<?php

class Admin_AdministratorController extends Zend_Controller_Action
{

	protected $_adminService = null;
	protected $_paymetnService = null;

	public function init()
	{
		if(!$this->_adminService){
			$this->_adminService = new Application_Service_Admin();
		}
		if(!$this->_paymetnService){
			$this->_paymetnService = new Application_Service_Payment();
		}
	}

	public function indexAction()
	{
		// action body
	}

	public function adminconsoleAction()
	{
		$auth = Zend_Auth::getInstance();
		if($auth->hasIdentity()){
			$this->_helper->layout()->setLayout('adminlayout');
			$storage = new Zend_Auth_Storage_Session();
			$loginProf = $storage->read();
			$loginProf['restownerId'] = "";
			$storage = new Zend_Auth_Storage_Session();
			$storage->write($loginProf);	
		}
		else{
			$this->_redirect('login','Auth','Ums');
		}
	}
	public function adminuserconsoleAction()
	{
		$auth = Zend_Auth::getInstance();
		if($auth->hasIdentity()){
			$this->_helper->layout()->setLayout('adminlayout');
		}
		else{
			$this->_redirect('login','Auth','Ums');
		}
	}

	public function managerestaurantAction()
	{
		$this->_helper->layout()->setLayout('adminlayout');
		$auth = Zend_Auth::getInstance();
		
		if($auth->hasIdentity()){
			$storage = new Zend_Auth_Storage_Session();
			$loginProf = $storage->read();
			$page = $this->_request->getParam('page');
			if (empty($page)){
				$page = 1;
			}
			$payForm = $this->_adminService->getRestaurantPaymentForm();
			$data = array();
			$request = $this->getRequest();
			$form = $this->_adminService->getManageRestForm();
			if($this->getRequest()->isPost()){
				$data = $this->getRequest()->getPost();
				$form->populate($data);
				$this->view->form = $form;
			}
			
			
			$resultSet = $this->_adminService->GetRestaurantSummary($data,$page,$loginProf);
			if($resultSet['status']){
				$s = $resultSet['restForm'];
				$this->view->resultSet = $s['rowset'];
				$this->view->restmatchcount = $s['restmatchcount'];
				$this->view->form = $this->_adminService->getManageRestForm();
				if($s['cityBd']){
						$form->resCity->addMultiOptions($s['cityBd']);
					}
			}else{
				$this->view->form = $resultSet['restForm'];
			}
			
			if($request->firstname){
					$this->view->firstname = $request->firstname;
				}
			if($request->lastname){
					$this->view->lastname = $request->lastname;
				}
			if($request->resid){
					$this->view->resid = $request->resid;
				}
			if($request->restname){
					$this->view->restname = $request->restname;
				}
			if($request->resRegion){
					$this->view->resRegion = $request->resRegion;
				}	
			if($request->resCity){
					$this->view->resCity = $request->resCity;
				}
			if($request->reststatus){
					$this->view->reststatus = $request->reststatus;
				}
			if($request->restappstatus){
					$this->view->restappstatus = $request->restappstatus;
				}
			if($request->comapny){
					$this->view->comapny = $request->comapny;
				}
				
			//$this->view->resultSet      = $resultSet['rowset'];
			$this->view->payForm = $payForm;
			
			
			if($request){
				$msg = $request->msg;
				$this->view->msg = $msg;
			}
		 }
		
		else{
			$this->_redirect('login','Auth','Ums');
		}
	}

	public function restaurantdetailsAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout()->setLayout('adminlayout');
				$request = $this->getRequest();
				$restDetails = $this->_adminService->GetRestaurantDetails($request);
				$restConflictDetails = $this->_adminService->GetRestaurantConflictDetails($restDetails);
				$this->view->restdetails = $restDetails;
				$this->view->restconflictdetails = $restConflictDetails;
	
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function updaterestappstatusAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				$operation = $request->operation;
				switch($operation){
					case 'Selected':
						if($request->resselection == 'SAME'){
							$params = $this->_adminService->UpdateRestAppStatus($request,$data);
							$listed = $this->_adminService->UpdateListedRestStatus($request);
						}else{
							$params = $this->_adminService->UpdateRestAppStatus($request,$data);
						}
						break;
					case 'NotSelected':
						if($request->resselection == 'SAME'){
							$params = $this->_adminService->UpdateRestAppStatus($request,$data);
							$listed = $this->_adminService->UpdateListedRestStatus($request);
						}else{
							$params = $this->_adminService->UpdateRestAppStatus($request,$data);
						}
						break;
					default :
						$params = $this->_adminService->UpdateRestAppStatus($request,$data);
						break;
				}
	
	
				$this->_helper->redirector('managerestaurant','Administrator','Admin',array('msg'=>$params));
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function updatereststatusAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				$params = $this->_adminService->UpdateRestStatus($request,$data);
				if($request->resttype == 'list'){
					$this->_helper->redirector('viewlistedrest','Administrator','Admin',array('msg'=>$params));
				}else{
					$this->_helper->redirector('managerestaurant','Administrator','Admin',array('msg'=>$params));
				}
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function adminrestaurantdetailsAction()
	{
		try{

			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$restDetails = $this->_adminService->GetRestaurantArrDetails($request);
			echo json_encode($restDetails);
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}

	}

	public function managerestypeAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$page = $this->_request->getParam('page');
				if (empty($page)){
					$page = 1;
				}
				$request = $this->getRequest();
				if($this->getRequest()->isPost()){
					$operation = $request->status;
					switch($operation){
						case 'EDIT' :
							$editDetails = $this->_adminService->EditResTypes($request);
							if($editDetails){
								break;
							}else{
								$this->view->editstatus = 't';
								$this->view->rtcode = $request->editcode;
								$this->view->rtdesc = $request->editdesc;
								break;
							}
						case 'DEL' 	:
							$delete = $this->_adminService->DeleteResTypes($request->restypeid);
							break;
						case 'ADD'	:
							$add = $this->_adminService->AddResTypes($request);
							if($add){
								break;
							}else{
								$this->view->addstatus = 't';
								$this->view->rtcode = $request->code;
								$this->view->rtdesc = $request->desc;
								break;
							}
					}
				}
				if($request->status == 'UPS'){
					$mapper = new Application_Model_RestaurantTypeDataMapper();
					$add = $mapper->UpdateStatus($request);
				}
				$resDetails = $this->_adminService->GetRestTypes($page);
				$this->view->addForm = $this->_adminService->getAddResTypeForm();
				$this->view->editForm = $this->_adminService->getEditResTypeForm();
				$this->view->resDetails = $resDetails;
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function managecountrysAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$page = $this->_request->getParam('page');
				if (empty($page)){
					$page = 1;
				}
				$request = $this->getRequest();
				if($this->getRequest()->isPost()){
					$operation = $request->status;
					switch($operation){
						case 'EDIT' :
							$editDetails = $this->_adminService->EditCountry($request);
							if($editDetails){
								break;
							}else{
								$this->view->addstatus = 'e';
								$this->view->countrycode = $request->editcode;
								$this->view->countrydesc = $request->editdesc;
								break;
							}
						case 'ADD'	:
							$add = $this->_adminService->AddCountry($request);
							if($add){
								break;
							}else{
								$this->view->addstatus = 'a';
								$this->view->countrycode = $request->code;
								$this->view->countrydesc = $request->desc;
								break;
							}
					}
				}
				if($request->status == 'UPS'){
					$mapper = new Application_Model_CountryDataMapper();
					$add = $mapper->UpdateStatus($request);
				}
				if($request->stateid){
					$regionist = $this->_adminService->GetRegionByStateId($request->stateid,$page);
					$this->view->state = $request->stateid;
					$this->view->regionbd = $regionist;
				}
	
				$this->view->stateBd = $stateBd;
				
				$countrys = $this->_adminService->getCountrys($page);
				$this->view->addForm = $this->_adminService->getAddCountryForm();
				$this->view->editForm = $this->_adminService->getEditCountryForm();
				$this->view->countrys = $countrys;
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}	
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function managestatesAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			$countryMapper = new Application_Model_CountryDataMapper();
			$countryBd = $countryMapper->fetchAll();
			if($auth->hasIdentity()){
				$page = $this->_request->getParam('page');
				if (empty($page)){
					$page = 1;
				}
				$request = $this->getRequest();
				if($this->getRequest()->isPost()){
					$operation = $request->status;
					switch($operation){
						case 'EDIT' :
							$editDetails = $this->_adminService->EditState($request);
							if($editDetails){
								break;
							}else{
								$this->view->addstatus = 'e';
								$this->view->statecode = $request->editcode;
								$this->view->statedesc = $request->editdesc;
								break;
							}
						case 'ADD'	:
							$add = $this->_adminService->AddState($request);
							if($add){
								break;
							}else{
								$this->view->addstatus = 'a';
								$this->view->statecode = $request->code;
								$this->view->statedesc = $request->desc;
								break;
							}
					}
				}
				if($request->status == 'UPS'){
					$mapper = new Application_Model_StateDataMapper();
					$add = $mapper->UpdateStatus($request);
				}
				
				$this->view->countryBd = $countryBd;
				if($request->countryid || $request->editcountryid){
					if($request->countryid){
						$countryid = $request->countryid;
					}else{
						$countryid = $request->editcountryid;
					}					
					$resDetails = $this->_adminService->GetStatesUsingCountryId($countryid,$page);
					$this->view->country = $countryid;
					$this->view->resDetails = $resDetails;
				}
				//$resDetails = $this->_adminService->GetStates($page);
				$this->view->addForm = $this->_adminService->getAddStateForm();
				$this->view->editForm = $this->_adminService->getEditStateForm();
				//$this->view->resDetails = $resDetails;
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function editrestypeAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$edit = $this->_adminService->EditResTypes($request);
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}

	}
	
	public function deleterestypeAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$delete = $this->_adminService->DeleteResTypes($request->restypeid);
			if($delete){
				$this->_helper->redirector('managerestype','Administrator','Admin');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function addrestypeAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$delete = $this->_adminService->DeleteResTypes($request->restypeid);
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function viewlistedrestAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$data = array();
				//$this->view->form = $this->_adminService->getListedRestForm();
				$form = $this->_adminService->getListedRestForm();
					if($this->getRequest()->isPost()){
						$data = $this->getRequest()->getPost();
						$form->populate($data);
						$this->view->form = $form;
								}
				$resultSet = $this->_adminService->ViewListedRestaurants($data);
			
		             if($resultSet['status'] ){
						//$s = $resultSet['ListedRest'];
						$this->view->resultSet = $resultSet['ListedRest'];
					    $this->view->form = $this->_adminService->getListedRestForm();
					    if($resultSet['Regions']!='')
					    $this->view->form->resRegion->addMultiOptions($resultSet['Regions']);
					    if($resultSet['Cities']!='')
					    $this->view->form->resCity->addMultiOptions($resultSet['Cities']);
					    if($resultSet['Nbds']!='')
					    $this->view->form->restNeighbour->addMultiOptions($resultSet['Nbds']);
						
					    //$this->view->form->resRegion->addMultiOptions($regionList);
					}else{
						$this->view->form = $resultSet['ListedRest'];
					}
				$this->view->listedrestaurants = $resultSet['ListedRest'];
				$request = $this->getRequest();
				if($request){
					$msg = $request->msg;
					$this->view->msg = $msg;
				}
			}else{
				$this->_helper->redirector('managerestype','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function addlistedrestAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$restService = new Application_Service_Restaurant();
				$form = $restService->getAddListedRestForm();
	
				if($this->getRequest()->isPost()){
					$msg = "";
					$results = array();
					$results = $restService->AddListedRestaurant($this->getRequest()->getPost());
					if(isset($results['RestStatus']) && $results['RestStatus'] == true){
						$msg = true;
						$this->view->msgstatus = $msg;
					}else if(isset($results['RestStatus']) && $results['RestStatus'] == false){
						$msg = false;
						$form = $results['form'];
						$this->view->msgstatus = $msg;
					}else {
						$form = $results['form'];
					}
				}
				$this->view->addRestform = $form;
			}else{
				$this->_helper->redirector('managerestype','Auth','Ums');
	
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}

	}
	
	public function managepricetypeAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$page = $this->_request->getParam('page');
				if (empty($page)){
					$page = 1;
				}
				$request = $this->getRequest();
				if($this->getRequest()->isPost()){
					$operation = $request->status;
					switch($operation){
						case 'EDIT' :
							$editDetails = $this->_adminService->EditPrice($request);
							if($editDetails){
								break;
							}else{
								$this->view->addstatus = 't';
								$this->view->rtcode = $request->editcode;
								$this->view->rtdesc = $request->editdesc;
								break;
							}
						case 'ADD'	:
							$add = $this->_adminService->AddPrice($request);
							if($add){
								break;
							}else{
								$this->view->addstatus = 't';
								$this->view->rtcode = $request->code;
								$this->view->rtdesc = $request->desc;
							}
					}
				}
				if($request->status == 'UPS'){
					$mapper = new Application_Model_PriceDataMapper();
					$add = $mapper->UpdateStatus($request);
				}
				$priceDetails = $this->_adminService->GetpriceTypes($page);
				$this->view->addForm = $this->_adminService->getAddPriceForm();
				$this->view->editForm = $this->_adminService->getEditPriceForm();
				$this->view->priceDetails = $priceDetails;
			}else{
				$this->_helper->redirector('login','Auth','Ums');
	
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}


	}
	
	public function manageneighborhoodAction()
	{
		try{

			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			$countryMapper = new Application_Model_CountryDataMapper();
			$countryBd = $countryMapper->fetchAll();
//			$state = new Application_Model_StateDataMapper();
//			$stateBd = $state->fetchAll();
//			$region = new Application_Model_RegionDataMapper();
//			$regionBd = $region->fetchAll();
			$bokService = new Application_Service_Booking();
			$cityBd		= $bokService->GetCityBaseData();
			if($auth->hasIdentity()){
				$page = $this->_request->getParam('page');
				if (empty($page)){
					$page = 1;
				}
				$request = $this->getRequest();
				if($this->getRequest()->isPost()){
					$operation = $request->status;
					switch($operation){
						case 'EDIT' :
							if(count($request->editdescrip) == 0){
								$this->view->editmsg = "Please Enter A Neighbourhood";
								$this->view->editneighid = $request->editneighid;
								break;
							}else{
							$editDetails = $this->_adminService->EditNeighborhood($request);
								if($editDetails){
									break;
								}else{
									$this->view->editstatus = 't';
									$this->view->editneighid = $request->editneighid;
									$this->view->editdesc = $request->editdescrip;
									break;
								}
							}
							
							
	//					case 'DEL' 	:
	//						$delete = $this->_adminService->DeleteNeighborhood($request->restypeid);
	//						break;
						case 'ADD'	:
							if($request->descrip == null){
								$this->view->msg = "Please Enter A Neighbourhood";
								break;
							}else{
								$add = $this->_adminService->AddNeighborhood($request);
								if($add){
									break;
								}else{
									$this->view->addstatus = 't';
									$this->view->desc = $request->descrip;
									break;
								}
							}
					}
				}if($request->update == "UPDATE"){
					$mapper = new Application_Model_NeighborhoodDataMapper();
					$update = $mapper->UpdateStatus($request);
				}
				$this->view->countryBd = $countryBd;
				if($request->countryid){
					$countryid = $request->countryid;
					$sateList = $this->_adminService->getStatesByCountryId($request);
					$this->view->country = $countryid;
					$this->view->stateBd = $sateList;
				}
				if($request->stateid){
					$stateid = $request->stateid;
					$reglist = $this->_adminService->getRegionsByStateId($request);
					$this->view->state = $request->stateid;
					$this->view->regionBd = $reglist->getRegionList();
				}
				if($request->regionid){
					$citylist = $this->_adminService->getCitysByRegionId($request);
					$this->view->region = $request->regionid;
					$this->view->cityBd = $citylist->getCityList();
				}
				if($request->cityid){
					$restService = new Application_Service_Restaurant();
					$neilist = $restService->GetNeighListByCityid($request->cityid,$page);
					$this->view->city = $request->cityid;
					$this->view->neighbd = $neilist;
				}
				
				//$this->view->cityBd = $cityBd;
	
				$this->view->addForm = $this->_adminService->getAddNeighborForm();
				$this->view->editForm = $this->_adminService->getEditNeighborForm();
	
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function editlistedrestAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout()->setLayout('adminlayout');
				if($this->getRequest()->isPost()){
					$request = $this->getRequest();
					$result = $this->_adminService->EditRestaurantDetails($this->getRequest()->getPost(),$request);
					$formArr = $this->_adminService->editRestaurantDeatails($request);
					$resultObj = $this->_adminService->viewRestaurantDetails($request);
					if($result['status']){
							
						$this->view->restdetails = $resultObj;
						$this->view->personalForm = $formArr['personalForm'];
						$this->view->addressForm = $formArr['addressForm'];
						$this->view->parkingForm = $formArr['parkingForm'];
						$this->view->restaurantimage = $formArr['restaurantimage'];
						$this->view->restaurantlogo = $formArr['restaurantlogo'];
					}else{
							
						if(isset($result['personalForm'])){
							$this->view->personalForm = $result['personalForm'];
							$this->view->popUpForm = 	'personalForm';
						}else{
							$this->view->personalForm = $formArr['personalForm'];
						}
						if(isset($result['addressForm'])){
							$this->view->addressForm = $result['addressForm'];
							$this->view->popUpForm = 	'addressForm';
						}else{
							$this->view->addressForm = $formArr['addressForm'];
						}
						if(isset($result['parkingForm'])){
							$this->view->parkingForm = $result['parkingForm'];
							$this->view->popUpForm = 	'parkingForm';
						}else{
							$this->view->parkingForm = $formArr['parkingForm'];
						}
						if(isset($result['restaurantimage'])){
							$this->view->restaurantimage = $result['restaurantimage'];
							$this->view->popUpForm = 	'restaurantimage';
						}else{
							$this->view->restaurantimage = $formArr['restaurantimage'];
						}
						if(isset($result['restaurantlogo'])){
							$this->view->restaurantlogo = $result['restaurantlogo'];
							$this->view->popUpForm = 	'restaurantlogo';
						}else{
							$this->view->restaurantlogo = $formArr['restaurantlogo'];
						}
						$this->view->restdetails = $resultObj;
					}
				}else{
					$request = $this->getRequest();
					$resultObj = $this->_adminService->viewRestaurantDetails($request);
					$formArr = $this->_adminService->editRestaurantDeatails($request);
					$this->view->restdetails = $resultObj;
					$this->view->personalForm = $formArr['personalForm'];
					$this->view->addressForm = $formArr['addressForm'];
					$this->view->parkingForm = $formArr['parkingForm'];
					$this->view->restaurantimage = $formArr['restaurantimage'];
					$this->view->restaurantlogo = $formArr['restaurantlogo'];
				}
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}

	}
	
	public function managecityAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			$countryMapper = new Application_Model_CountryDataMapper();
			$countryBd = $countryMapper->fetchAll();
//			$state = new Application_Model_StateDataMapper();
//			$stateBd = $state->fetchAll();
//			$region = new Application_Model_RegionDataMapper();
//			$regionBd = $region->fetchAll();
			if($auth->hasIdentity()){
				$page = $this->_request->getParam('page');
				if (empty($page)){
					$page = 1;
				}
				$request = $this->getRequest();
				if($this->getRequest()->isPost()){
					$operation = $request->status;
					switch($operation){
						case 'EDIT' :
							if($request->editcitycode == null || $request->editcitydesc == null){
								$this->view->editmsg = "Please Enter both City Code and Description";
								if($request->editcitycode){
									$this->view->editcitcode = $request->editcitycode;
								}
								if($request->editcitydesc){
									$this->view->editcitdesc = $request->editcitydesc;
								}
								break;
							}else{
								$editDetails = $this->_adminService->EditCity($request);
								if($editDetails){
									break;
								}else{
									$this->view->editstatus = 't';
									$this->view->editdesc = $request->editcitydesc;
									$this->view->editcityid = $request->editcityid;
									$this->view->editcode = $request->editcitycode;
									break;
								}
							}
	
	
							//					case 'DEL' 	:
							//						$delete = $this->_adminService->DeleteNeighborhood($request->restypeid);
							//						break;
						case 'ADD'	:
							if($request->citycode == null || $request->citydesc == null){
								$this->view->msg = "Please Enter both City Code and Description";
								if($request->citycode){
									$this->view->citycode = $request->citycode;
								}
								if($request->citydesc){
									$this->view->citydesc = $request->citydesc;
								}
								break;
							}else{
								$add = $this->_adminService->AddCity($request);
								if($add){
									break;
								}else{
									$this->view->addstatus = 't';
									$this->view->desc = $request->citydesc;
									$this->view->code = $request->citycode;
									break;
								}
							}
					}
				}
				if($request->update == "UPDATE"){
					$mapper = new Application_Model_CityDataMapper();
					$update = $mapper->UpdateStatus($request);
				}
				$this->view->countryBd = $countryBd;
				if($request->countryid){
					$countryid = $request->countryid;
					$sateList = $this->_adminService->getStatesByCountryId($request);
					$this->view->country = $countryid;
					$this->view->stateBd = $sateList;
				}
				if($request->stateid){
					$stateid = $request->stateid;
					$reglist = $this->_adminService->getRegionsByStateId($request);
					$this->view->state = $request->stateid;
					$this->view->regionBd = $reglist->getRegionList();
				}
				if($request->regionid){
					$neilist = $this->_adminService->GetCityByRegionId($request->regionid,$page);
					$this->view->region = $request->regionid;
					$this->view->citybd = $neilist;
				}
	
				$this->view->addForm = $this->_adminService->getAddCityForm();
				$this->view->editForm = $this->_adminService->getEditCityForm();
	
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function manageregionsAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			$countryMapper = new Application_Model_CountryDataMapper();
			$countryBd = $countryMapper->fetchAll();
//			$state = new Application_Model_StateDataMapper();
//			$stateBd = $state->fetchAll();
			if($auth->hasIdentity()){
				$page = $this->_request->getParam('page');
				if (empty($page)){
					$page = 1;
				}
				$request = $this->getRequest();
				if($this->getRequest()->isPost()){
					$operation = $request->status;
					switch($operation){
						case 'EDIT' :
							if($request->editregioncode == null || $request->editregiondesc == null){
								$this->view->editmsg = "Please Enter both Region Code and Description";
								if($request->editregioncode){
									$this->view->editregcode = $request->editregioncode;
								}
								if($request->editregiondesc){
									$this->view->editregdesc = $request->editregiondesc;
								}
								break;
							}else{
								$editDetails = $this->_adminService->EditRegion($request);
								if($editDetails){
									break;
								}else{
									$this->view->editstatus = 't';
									$this->view->editdesc = $request->editregiondesc;
									$this->view->editregionid = $request->editregionid;
									$this->view->editcode = $request->editregioncode;
									break;
								}
							}
	
	
							//					case 'DEL' 	:
							//						$delete = $this->_adminService->DeleteNeighborhood($request->restypeid);
							//						break;
						case 'ADD'	:
							if($request->regioncode == null || $request->regiondesc == null){
								$this->view->msg = "Please Enter both Region Code and Description";
								if($request->regioncode){
									$this->view->regioncode = $request->regioncode;
								}
								if($request->regiondesc){
									$this->view->regiondesc = $request->regiondesc;
								}
								break;
							}else{
								$add = $this->_adminService->AddRegion($request);
								if($add){
									break;
								}else{
									$this->view->addstatus = 't';
									$this->view->desc = $request->regiondesc;
									$this->view->code = $request->regioncode;
									break;
								}
							}
					}
				}
				if($request->update == "UPDATE"){
					$mapper = new Application_Model_RegionDataMapper();
					$update = $mapper->UpdateStatus($request);
				}
				if($request->countryid){
					$stateBd = $this->_adminService->getStatesByCountryId($request);
					$this->view->country = $request->countryid;
					$this->view->stateBd = $stateBd;
				}
				if($request->stateid){
					$regionist = $this->_adminService->GetRegionByStateId($request->stateid,$page);
					$this->view->state = $request->stateid;
					$this->view->regionbd = $regionist;
				}
					
				$this->view->countryBd = $countryBd;
	
				$this->view->addForm = $this->_adminService->getAddRegionForm();
				$this->view->editForm = $this->_adminService->getEditRegionForm();
	
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function managecontactusAction()
	{

		$this->_helper->layout()->setLayout('adminlayout');
		$auth = Zend_Auth::getInstance();
		
		if($auth->hasIdentity()){
         $data = array();
		$page = $this->_request->getParam('page');
			if (empty($page)){
				$page = 1;
			}
			$contform = $this->_adminService->getManageContactUsForm();
			if($this->getRequest()->isPost()){
				$data = $this->getRequest()->getPost();
				$contform->populate($data);
				$this->view->form = $contform;
			}
			$resultSet = $this->_adminService->GetAllContactUsDeatils($page,$data);
			//$resultSet = $this->_adminService->GetContactUsDeatils($data);
			if($resultSet['status']){
				$this->view->resultSet = $resultSet['personalForm'];
				$this->view->form = $contform;
				
			}else{
				$this->view->form = $resultSet['personalForm'];
			}
			$request = $this->getRequest();
    	     if($request->id){
					$this->view->id = $request->id;
				}
		     if($request->name){
					$this->view->name = $request->name;
				}
			 if(isset($request->status)){
				 if($request->status){
						$this->view->status = $request->status;
				  }else if(!$request->status && $request->status != ""){
				  		$this->view->status = $request->status;
				  }else {
				  	$this->view->status = $request->status;
				  }	

		 	 }else{
         	 	$this->view->status = 1;
		 	 }				
		  if($request->startdate){
					$this->view->startdate = $request->startdate;
				}

		     if($request->enddate){

					$this->view->enddate = $request->enddate;
				}
			if($request){
				$msg = $request->msg;
				$this->view->msg = $msg;
			}
		}else{
			$this->_helper->redirector('login','Auth','Ums');
		}

	}
	
	public function closecontactusAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$status = $this->_adminService->CloseContactUsDeatils($request);
				if($status){
					return $this->_helper->redirector('managecontactus');
				}
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getconusdeatilsajaxAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_adminService->GetContactUsDeatils($request);
			echo json_encode($result);
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function notificationcreationAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$Service = new Application_Service_Notification();
				$form = $Service->getNotificationCreationForm();
				if($this->getRequest()->isPost()){
					$result = $Service->NotificationCreation($this->getRequest()->getPost(),$request);
					if(isset($result['msgid'])){
						return $this->_helper->redirector('getrestaurantorcustomerdetails','Administrator','Admin',array('msgid'=>$result['msgid']));
					}
					if(isset($result['form'])){
						$this->view->form = $result['form'];
					}
				}else{
					$this->view->form = $form;
				}
				
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getrestaurantorcustomerdetailsAction()
	{
		try{
			$stateid 	= "";
			$userStatus = "";
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$Service = new Application_Service_Notification();
				$msgform = $Service->getNotificationCreationForm();
				$form = $Service->getRecipentFilterForm();
				$request = $this->getRequest();
				$result = $Service->getMessageDeatails($request);
				$this->view->message = $result;
				$this->view->msgid = $request->msgid;
				if($request->state){
					$stateid = $request->state;
					$resservice = new Application_Service_Restaurant();
					$regionBd  = $resservice->GetRegionByStateId_($stateid);
					$form->region->addMultiOptions($regionBd);
				}
				if($request->region){
					$regionid = $request->region;
					$resservice = new Application_Service_Restaurant();
					$cityBd  = $resservice->GetCityByRegionId_($regionid);
					$form->city->addMultiOptions($cityBd);
				}
				if($request->usertype){
					$userStatus = $request->usertype;
				}else{
					$userStatus = 'RES';
				}
				$campaignProp = new Application_Model_GetCampaignForPost();
				$campaignProp->setAudType($userStatus)
							 ->setIsAjaxCall(true);
				
				$campaign = $this->_adminService->GetCampaignDetails($campaignProp);
				$form->campaign->addMultiOptions($campaign);
				$this->view->form = $form;
				$this->view->msgform = $msgform;
				if($this->getRequest()->isPost()){
					$result = $Service->getrestaurantorcustomerdetailsbystateid($this->getRequest()->getPost(),$request);
					if(isset($result['form'])){
						$this->view->form = $result['form'];
					}else{
						if(isset($result['offset'])){
							$this->view->offset		   = $result['offset'];
						}
						$this->view->prev = $result['prev'];
						$this->view->next = $result['next'];
						$this->view->idcount = $result['count'];
						$this->view->result = $result;
					    $this->view->UnCheckedvals = $request->UnCheckedvals;
					}
				}
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function editnotificationmessageAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$msgid = $request->msgid;
				$Service = new Application_Service_Notification();
				if($this->getRequest()->isPost()){
					$result = $Service->UpdatemessageDeatils($this->getRequest()->getPost());
					if(isset($result['form'])){
						$this->view->msgform = $result['form'];
						$this->view->msgid = $request->msgid;
					}
					if(isset($result['status'])){
						return $this->_helper->redirector('getrestaurantorcustomerdetails','Administrator','Admin',array('msgid'=>$msgid));
					}
				}else{
					$msgform = $Service->getMessageFromDetails($request);
					$this->view->msgform = $msgform;
					$this->view->msgid = $request->msgid;
				}
				
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function sendnotificationAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$Service = new Application_Service_Notification();
				$request = $this->getRequest();
				$result = $Service->SendNotificationToUsers($request);
				$this->view->result = $result;
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function managenotificationsAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$Service = new Application_Service_Notification();
				$result = $Service->getAllNotifications();
				$this->view->result = $result;
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getmsgdetailsandsenttolistbymsgidAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$Service = new Application_Service_Notification();
				$result = $Service->GetMsgDetalisandSentListByMsgId($request);
				$this->view->message = $result['Message'];
				$this->view->title   = $result['title'];
				$this->view->msgid   = $request->msgid; 
				if(count($result) > 2){
					$this->view->list = $result['list'];
					if(isset($result['offset'])){
						$this->view->offset = $result['offset'];
					}
					$this->view->prev = $result['prev'];
					$this->view->next = $result['next'];
				}			
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function addsponsorAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				if($this->getRequest()->isPost()){
					$result = $this->_adminService->AddSponsor($this->getRequest()->getPost(),$request);
					if($result['status']){
						return $this->_helper->_redirector('addsponsorconfirmation','Administrator','Admin',array('status'=>'success','sponsor'=>$result['result']));
					}else{
						$this->view->sponsorForm = $result['addSponsor'];
					}
				}else{
					$form = $this->_adminService->getAddSponsorForm();
					$this->view->sponsorForm = $form;
				}
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function editsponsorAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				if($this->getRequest()->isPost()){
					$result = $this->_adminService->EditSponsor($this->getRequest()->getPost(),$request);
					if($result['status']){
						return $this->_helper->_redirector('managesponsors','Administrator','Admin');
					}else{
						$this->view->sponsorForm = $result['editSponsor'];
						$this->view->campSponsor = $request->campSponsor;
					}
				}else{
					if($request->campSponsor){
						$form = $this->_adminService->getSponsor($request);
						$this->view->campSponsor = $request->campSponsor;
					}else{
						$form = $this->_adminService->getEditSponsorForm();
					}
					$this->view->sponsorForm = $form;
				}
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function addpriceplanAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				if($this->getRequest()->isPost()){
					$result = $this->_adminService->AddPricePlan($this->getRequest()->getPost());
					if($result['status']){
						return $this->_helper->_redirector('addpriceplanconfirmation','Administrator','Admin',array('status'=>'success','priceplan'=>$result['result']));
					}else{
						if(trim($request->plantype) == "NOT" || trim($request->plantype) == "BOTH"){
							$this->view->formstatus = 'failure';
						}
						$this->view->priceForm = $result['addPricePlan'];
					}
				}else{
					$form = $this->_adminService->getAddPricePlanForm();
					$this->view->priceForm = $form;
				}
			}else{
				return $this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function addcampaignAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				if($this->getRequest()->isPost()){
					$result = $this->_adminService->AddCampaign($this->getRequest()->getPost());
					if($result['status']){
						return $this->_helper->_redirector('editcampaign','Administrator','Admin',array('campaignName'=>$result['result']));
					}else{
						$this->view->campaignForm = $result['addCampaign'];
					}
				}else{
					$form = $this->_adminService->getAddCampaignForm();
					$this->view->campaignForm = $form;
				}
			}else{
				return $this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function editcampaignAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				if($this->getRequest()->isPost()){
					$result = $this->_adminService->EditCampaign($this->getRequest()->getPost(),$request);
					if($result['status']){
						return $this->_helper->_redirector('editcampaign','Administrator','Admin',array('campaignName'=>$result['result']));
					}else{
						$camId = "";
						if($request->campaingName){
							$camId = $request->campaingName;
						}else if($request->campId){
							$camId = $request->campId;
						}
						$forms = $this->_adminService->getCampaign($camId);
						$this->view->stat = $result['status'];
						$this->view->formstat = $result['form'];
						if($result['form'] == 'campImage'){
							$this->view->imgForm =  $result['editCampaign'];
							$this->view->planForm = $forms['planForm'];
						$this->view->locationForm = $forms['locationForm'];		
						}else if($result['form'] == 'campPlan'){
							$this->view->planForm = $result['editCampaign'];
							$this->view->imgForm = $forms['descForm'];
							$this->view->locationForm = $forms['locationForm'];
						}else if($result['form'] == 'campLocation'){
							$this->view->locationForm =  $result['editCampaign'];
							$this->view->imgForm = $forms['descForm'];
							$this->view->planForm = $forms['planForm'];
						}
						$CampDetails = $this->_adminService->GetCampaignById($camId);
						$this->view->CampDetails = $CampDetails;
					}
				}else{
					$camId = "";
						
					if($request->campaignName){
						$camId = $request->campaignName;
						$CampDetails = $this->_adminService->GetCampaignById($camId);
						$this->view->CampDetails = $CampDetails;
						$forms = $this->_adminService->getCampaign($camId);
						$this->view->stat = true;
						$this->view->formstat = false;
						$this->view->imgForm = $forms['descForm'];
						$this->view->planForm = $forms['planForm'];
						$this->view->locationForm = $forms['locationForm'];
					}else if($request->campId){
						$camId = $request->campId;
						$CampDetails = $this->_adminService->GetCampaignById($camId);
						$this->view->CampDetails = $CampDetails;
						$forms = $this->_adminService->getCampaign($camId);
						$this->view->stat = true;
						$this->view->formstat = false;
						$this->view->imgForm = $forms['descForm'];
						$this->view->planForm = $forms['planForm'];
						$this->view->locationForm = $forms['locationForm'];
					}else{						
						$form = $this->_adminService->getEditCampaignForm();
						$this->view->campaignForm = $form;
					}
					
				}
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function addsponsorconfirmationAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				if($request->sponsor){
					$spoDetails = $this->_adminService->GetSponsorDetailsById($request->sponsor);
					$this->view->sponsor = $spoDetails;
				}
				$this->view->status = $request->status;
			}else{
				return $this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function addpriceplanconfirmationAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				if($request->priceplan){
					$spoDetails = $this->_adminService->GetPricePlanById($request->priceplan,false);
					$this->view->price = $spoDetails;
				}
				$this->view->status = $request->status;
			}else{
				return $this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function addcampaignconfirmationAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				if($request->campaign){
					$spoDetails = $this->_adminService->GetCampaignById($request->campaign);
					$this->view->campaign = $spoDetails;
				}
				$this->view->status = $request->status;
			}else{
				return $this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getpriceplanbyidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$result = $this->_adminService->GetPricePlanById($request->priceplan,true);
				echo json_encode($result);
			}else{
				return $this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getcampaigndetailsAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$cus = $request->type;
				$state = $request->state;
				$isAjaxCall = $request->status;
				$campProp = new Application_Model_GetCampaignForPost();
				$campProp->setAudType($cus)
						 ->setStateId($state)
						 ->setIsAjaxCall($isAjaxCall);
				
				$result = $this->_adminService->GetCampaignDetails($campProp);
				echo json_encode($result);
			}else{
				return $this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function managesponsorsAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$result = $this->_adminService->GetAllSponsors();
				$this->view->sponsors = $result; 
			}else{
				return $this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}	
	}

	public function managecampaignAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$result = $this->_adminService->GetAllSponsorships();
				$this->view->sponsors = $result; 
			}else{
				return $this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getcampaigndetailsbyidAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$result = $this->_adminService->GetCampaignDetailsBySponsorsId($request);
				$this->view->campaign = $result;
				$this->view->id = $request->id;
			}else{
				return $this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getcampaignsenttodetailsAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$result = $this->_adminService->GetCampaignSentToDetails($request);
				
				echo json_encode($result);
			}else{
				return $this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function editsponsorstatusAction()
	{
		try{
//			$this->_helper->layout->disableLayout();
//			$this->_helper->viewRenderer->setNoRender();
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$result = $this->_adminService->EditSponsorStatus($request);
				if($result){
					return $this->_helper->_redirector('managesponsors','Administrator','Admin');
				}
			}else{
				return $this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function editcampaignstatusAction()
	{
		try{
//			$this->_helper->layout->disableLayout();
//			$this->_helper->viewRenderer->setNoRender();
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$result = $this->_adminService->EditCampaignStatus($request);
				$subaction = $request->subaction;
				
				if($result){
					if(isset($request->id)){
						$id = $request->id;
						return $this->_helper->_redirector($subaction,'Administrator','Admin',array('id'=>$id));
					}else{
						return $this->_helper->_redirector($subaction,'Administrator','Admin');
					}
					
				}
			}else{
				return $this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function reservationreportadminAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
			    $bokService = new Application_Service_Booking();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->view->userStatus = $data['Usertype'];
				//$this->view->userPermissions = $data['Permissions'];
				$page = $this->_request->getParam('page');
				if (empty($page)){
					$page = 1;
				}
				$request = $this->getRequest();
				$result = $this->_adminService->ReservationReport($request,$page);
				
				$bokstatus = $bokService->getBookingStatusBd();

				/* Reteriving restaurant names */

				//$restService = new Application_Service_Restaurant();
				//$restNamesList = $restService->GetRestNameById($data['User_Id']);
				$x= $request->bokdatetype;
				
				if($request->reserveid){
					$this->view->reservid = $request->reserveid;
				}
				if($request->bokstartdate){
					$this->view->bokstartdate = $request->bokstartdate;
				}
				if($request->bokenddate){
					$this->view->bokenddate = $request->bokenddate;
				}
				if($request->bokstarttime){
					$this->view->bokstarttime = $request->bokstarttime;
				}
				if($request->bokendtime){
					$this->view->bokendtime = $request->bokendtime;
				}
				if($request->bookstatus){
					$bookingstatus = $request->bookstatus;
					$bokstsarr = array();
					foreach($bookingstatus as $types){
						$bokstsarr[] = $types;
					}
					$this->view->status = $bokstsarr;
				}
				if($request->bokdatetype){
					$this->view->datetype = $request->bokdatetype;
				}
				if($request->restaurantid){
					$this->view->restaurantid = $request->restaurantid;
				}
				if($request->date){
					$this->view->date = $request->date;
				}else{
					$this->view->date = date("m-d-Y");
				}
				
				if($request->filterfirstname != ""){
					$this->view->filtfrstName = $request->filterfirstname;
				}
				
				if($request->filterlastname != ""){
					$this->view->filtlstName = $request->filterlastname;
				}
				
				if($request->reportsorton){
					$this->view->reportsorton = $request->reportsorton;	
				}
				
				if($request->reportsortorder){
					$this->view->reportsortorder = $request->reportsortorder;
				}
				
				$form = $bokService->getMakeReservationForm();
				$this->view->MakeResForm   = $form;
				$this->view->rowSet 	   = $result['RowSet'];
				$this->view->counts        = $result['Count'];
				
				
				if($result['RestName']){
					$this->view->RestName = $result['RestName'];
				}
				
				$this->view->bokStatus = $bokstatus;
				
				
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function addsubscriptionplanAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				if($this->getRequest()->isPost()){
					$result = $this->_adminService->AddSubscriptionPlan($this->getRequest()->getPost(),$request,$data);
					if($result['status']){
						return $this->_helper->_redirector('managesubscriptionplan','Administrator','Admin',array('status'=>'addsubscription','subscription'=>$result['result']));
					}else{
						$this->view->paymentForm = $result['addSubscription'];
					}
				}else{
					$form = $this->_adminService->getAddSubscriptionPlanForm();
					$this->view->paymentForm = $form;
				}
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function managesubscriptionplanAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$page = $this->_request->getParam('page');
				if (empty($page)){
					$page = 1;
				}
				if($this->getRequest()->isPost()){
					$result = $this->_adminService->getSubscriptionPlansSearch($this->getRequest()->getPost(),$request,$page);
					$this->view->result = $result;
					if($request->titlesearch){
						$this->view->titlesearch = $request->titlesearch;
					}
					if($request->amountsearch){
						$this->view->amountsearch = $request->amountsearch;
					}
					if($request->durationsearch){
						$this->view->durationsearch = $request->durationsearch;
					}
				}else{
					if($request->status == 'editsubscription'){
						$this->view->subStatus = 'editsubscription';
					}
					if($request->status == 'addsubscription'){
						$this->view->subStatus = 'addsubscription';
					}
					if($request->PlanId){
						$form = $this->_adminService->EditSubscriptionPlanDetails($request);
						$this->view->PlanId = $request->PlanId;
						$this->view->paymentForm = $form;
					}else{
						$result = $this->_adminService->getSubscriptionPlans($page);
						$this->view->result = $result;
					}
					if($request->titlesearch){
						$this->view->titlesearch = $request->titlesearch;
					}
					if($request->amountsearch){
						$this->view->amountsearch = $request->amountsearch;
					}
					if($request->durationsearch){
						$this->view->durationsearch = $request->durationsearch;
					}
				}
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}	
	}
	
	public function subscriptiondetailsAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$page = $this->_request->getParam('page');
				if (empty($page)){
					$page = 1;
				}
				$request = $this->getRequest();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				if($this->getRequest()->isPost()){
					if(isset($request->plan)){
						$result = $this->_adminService->EditSubscriptionPlan($this->getRequest()->getPost(),$request,$data);
						if($result['status']){
							return $this->_helper->_redirector('managesubscriptionplan','Administrator','Admin',array('status'=>'editsubscription','subscription'=>$result['result']));
						}else{
							$this->view->paymentForm = $result['editSubscription'];
						}
					}else{
						$result = $this->_adminService->getRestaurantsbySubscpriotionIdSearch($this->getRequest()->getPost(),$request,$page);
						$this->view->result = $result;
						if($request->resnamesearch){
							$this->view->resnamesearch = $request->resnamesearch;
						}
						if($request->firstsearch){
							$this->view->firstsearch = $request->firstsearch;
						}
						if($request->lastsearch){
							$this->view->lastsearch = $request->lastsearch;
						}
						if($request->emailsearch){
							$this->view->emailsearch = $request->emailsearch;
						}
						if($request->datesearch){
							$this->view->datesearch = $request->datesearch;
						}
					}
				}else{
					if(isset($request->plan)){
						$this->view->PlanId = $request->plan;
						$form = $this->_adminService->EditSubscriptionPlanDetails($request);
						$this->view->paymentForm = $form;
					}else{
						$result = $this->_adminService->getRestaurantsbySubscpriotionId($request,$page);
						$this->view->result = $result;
					}
				}
				$this->view->plan = $request->PlanId;
				
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function editsubscriptionplanstautsAction()
	{
		try{
//			$this->_helper->layout->disableLayout();
//			$this->_helper->viewRenderer->setNoRender();
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$result = $this->_adminService->EditSubscriptionStatus($request);
								
				if($result){
					$id = $request->PlanId;
					return $this->_helper->_redirector('managesubscriptionplan','Administrator','Admin');
				}
			}else{
				return $this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
public function resttransactionreportAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			$this->_helper->layout()->setLayout('adminlayout');
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$page = $this->_request->getParam('page');
				if (empty($page)){
					$page = 1;
				}
				$request = $this->getRequest();
				if($this->getRequest()->isPost()){
					$result = $this->_paymetnService->GetAllTransactions($this->getRequest()->getPost(),$page);
					if($request->startdate){
						$this->view->startdate = $request->startdate;
					}
					if($request->starttime){
						$this->view->starttime = $request->starttime;
					}
					if($request->enddate){
						$this->view->enddate = $request->enddate;
					}
					if($request->endtime){
						$this->view->endtime = $request->endtime;
					}
					if($request->txnId){
						$this->view->txnId = $request->txnId;
					}
					if($request->invNumber){
						$this->view->invNumber = $request->invNumber;
					}
					if($request->resName){
						$this->view->resName = $request->resName;
					}
					if($request->resId){
						$this->view->resId = $request->resId;
					}
					if($request->restaurantid){
						$this->view->restaurantid = $request->restaurantid;
					}
				}else{
					$formValues = array();
					if($request->restaurantid){
						$formValues['resId'] = $request->restaurantid;
						$this->view->restaurantid = $request->restaurantid;
					}
					$result = $this->_paymetnService->GetAllTransactions($formValues,$page);
				}

				$this->view->txnList = $result;

				
				
				
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function manageservicetaxAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			$this->_helper->layout()->setLayout('adminlayout');
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				if($this->getRequest()->isPost()){
					$this->_adminService->editServiceTax($this->getRequest()->getPost());
				}				
				$result = $this->_adminService->retrieveServiceTax();
				$this->view->result = $result;		
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function managetransactionchargesAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			$this->_helper->layout()->setLayout('adminlayout');
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				if($this->getRequest()->isPost()){
					$this->_adminService->editTransactionCharges($this->getRequest()->getPost());
				}				
				$result = $this->_adminService->reterieveTransactionCharges();
				$this->view->result = $result;
			}else{
				$this->_redirect('login','Auth','Ums');
			}	
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function managesubrenewalsAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			$this->_helper->layout()->setLayout('adminlayout');
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				if($data['Usertype'] == 'ADM'){
					$request = $this->getRequest();
					$result = $this->_adminService->ManageSubscriptionRenewal($request);
				}
					
			}else{
				$this->_redirect('login','Auth','Ums');
			}	
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * function to retreive all restaurant owners and 
	 * edit password and email   
	 */
	public function managerestaurantownersAction()
	{
		$this->_helper->layout()->setLayout('adminlayout');
		$auth = Zend_Auth::getInstance();
		if($auth->hasIdentity()){
			$data = array();
			$page = $this->_request->getParam('page');
			if (empty($page)){
				$page = 1;
			}
			$form = $this->_adminService->getEditPasswordForm();
			$serform = $this->_adminService->getRestOwnerSearchForm();
			$request = $this->getRequest();
			if($this->getRequest()->isPost()){
				$data = $this->getRequest()->getPost();
				$serform->populate($data);
				$this->view->serform = $serform;
			}			
			$result = $this->_adminService->manageRestaurantOwners($data,$page);
			$this->view->result = $result;
			$this->view->form = $form;
			$regionBd	= array();
			$cityBd 	= array();
			if($request->state){
				$stateid 	= $request->state;
				$userService= new Application_Service_User();
				$regionBd  	= $userService->GetRegionByStateId($stateid);
			}
			if($request->region){
				$regionid 	= $request->region;
				$userService= new Application_Service_User();
				$cityBd  	= $userService->GetCityByRegionId($regionid);
			}
			if($regionBd){
				$serform->region->addMultiOptions($regionBd);
			}
			if($cityBd){
				$serform->city->addMultiOptions($cityBd);
			}
			$this->view->serform = $serform;
			if(isset($request->msg)){
				$msg = $request->msg;
				$this->view->msg = $msg;
			}
			if($request->firstname){
				$this->view->firstname = $request->firstname;
			}
			if($request->lastname){
				$this->view->lastname = $request->lastname;
			}
			if($request->userId){
				$this->view->userId = $request->userId;
			}
			if($request->email){
				$this->view->email = $request->email;
			}
			if($request->status){
				$this->view->status = $request->status;
			}
			if($request->state){
				$this->view->state = $request->state;
			}
			if($request->city){
				$this->view->city = $request->city;
			}
		}else{
			$this->_redirect('login','Auth','Ums');
		}
	}
	
	public function getrestaurantownerdetailsAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$result = $this->_adminService->getrestaurantownerdetails($request);
			$jsonObj = json_encode($result);
			echo $jsonObj;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function editrestaurantownerdetailsAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$resultset = $this->_adminService->EditRestaurantOwnerDetails($request);
			$this->_helper->redirector('managerestaurantowners','Administrator','Admin');
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function editsourceofrestaurantAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$resultset = $this->_adminService->EditSourceofRestaurant($request);
			$msg = $this->_adminService->UpdateRestaurantOwnerStatus($request);
			$this->_helper->redirector('managerestaurantowners','Administrator','Admin',array('msg'=>$msg));
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
/*	public function adminupdaterestaurantownerAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			if($this->getRequest()->isPost()){
			$result = $this->_adminService->adminupdaterestaurantowner($this->getRequest()->getPost());
			$msg = $this->_adminService->UpdateRestaurantOwnerStatus($request);
			$this->_helper->redirector('managerestaurantowners','Administrator','Admin',array('msg'=>$msg));
				}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	*/
	public function editrestaurantownerviewdetailsAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$resultset = $this->_adminService->EditRestaurantOwnerDetails($request);
			$this->_helper->redirector('viewallusers','Administrator','Admin');
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function updateownerstatusAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$msg = $this->_adminService->UpdateRestaurantOwnerStatus($request);
				$this->_helper->redirector('managerestaurantowners','Administrator','Admin',array('msg'=>$msg));
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function updateviewuserstatusAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$msg = $this->_adminService->UpdateRestaurantViewStatus($request);
				$this->_helper->redirector('viewallusers','Administrator','Admin',array('msg'=>$msg));
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
	
	}
	}
	/**
	 * Action to validate edit password from   
	 */
	public function passwordformvalidationajaxAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$form = $this->_adminService->getEditPasswordForm();
	        $form->isValid($this->_getAllParams());
	        $json = $form->getMessages();
	        if(empty($json)){
	        	echo json_encode('t');
	        }else{
	        	header('Content-type: application/json');
	        	echo json_encode($json);
	        }
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * Action to retreive all restaurants of restaurant owner   
	 */
	public function getrestaurantdatabyowneridajaxAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			
			$resultObj = $this->_adminService->GetRestaurantDataByOwnerId($request);
			$jsonObj = json_encode($resultObj);
			echo $jsonObj;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/* This Action is used for generating invoices before subscription renewal */
	public function manageinvoiceAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			$this->_helper->layout()->setLayout('adminlayout');
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				if($data['Usertype'] == 'ADM'){
					$request = $this->getRequest();
					$result = $this->_adminService->GenerateInvoicesForSubscriptionRenewal($request);
				}
			}else{
				$this->_redirect('login','Auth','Ums');
			 }	
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/* This Action is used for payment due notification before subscription renewal */
	public function manageduenotificationsAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			$this->_helper->layout()->setLayout('adminlayout');
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				if($data['Usertype'] == 'ADM'){
					$request = $this->getRequest();
					$result = $this->_adminService->ManagePaymentDueNotification($request);
				}
			}else{
				$this->_redirect('login','Auth','Ums');
			 }	
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	

	/**
	 * Action to retreive all customers   
	 */
	public function managecustomersAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			$this->_helper->layout()->setLayout('adminlayout');
			if($auth->hasIdentity()){
				$data = array();
				$page = $this->_request->getParam('page');
				if (empty($page)){
					$page = 1;
				}
				$form = $this->_adminService->getEditPasswordForm();
				$serform = $this->_adminService->getCustomerSearchForm();
				$request = $this->getRequest();
				if($this->getRequest()->isPost()){
					$data = $this->getRequest()->getPost();
					$serform->populate($data);
					$this->view->serform = $serform;
				}			
				$result = $this->_adminService->manageCustomers($data,$page);
				$this->view->result = $result;
				$this->view->form = $form;
				$regionBd	= array();
				$cityBd 	= array();
				if($request->state){
					$stateid 	= $request->state;
					$userService= new Application_Service_User();
					$regionBd  	= $userService->GetRegionByStateId($stateid);
				}
				if($request->region){
					$regionid 	= $request->region;
					$userService= new Application_Service_User();
					$cityBd  	= $userService->GetCityByRegionId($regionid);
				}
				if($regionBd){
					$serform->region->addMultiOptions($regionBd);
				}
				if($cityBd){
					$serform->city->addMultiOptions($cityBd);
				}
				$this->view->serform = $serform;
				if(isset($request->msg)){
					$msg = $request->msg;
					$this->view->msg = $msg;
				}
			}else{
				$this->_redirect('login','Auth','Ums');
			}	
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * Action to upadte customer status   
	 */
	public function updatecustomerstatusAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$msg = $this->_adminService->UpdateCustomerStatus($request);
				$this->_helper->redirector('managecustomers','Administrator','Admin',array('msg'=>$msg));
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * Action to edit customer email and password by admin   
	 */
	public function editcusemailandpasswordAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$resultset = $this->_adminService->EditCusEmailAndPassword($request);
			$this->_helper->redirector('managecustomers','Administrator','Admin');
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function specialtyperestAction()
	{
		try{
		
		    $this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$page = $this->_request->getParam('page');
				if (empty($page)){
					$page = 1;
				}
				$request = $this->getRequest();
				if($this->getRequest()->isPost()){
					$operation = $request->status;
					switch($operation){
						case 'EDIT' :
							$editSpcltype = $this->_adminService->EditSpecialType($request);
							if($editSpcltype){
								break;
							}else{
								$this->view->addstatus = 'e';
								$this->view->stcode = $request->spclcode;
								$this->view->stdesc = $request->spcldesc;
								break;
							}
						//case 'DEL' 	:
							//$delete = $this->_adminService->DeleteResTypes($request->restypeid);
							//break;
						case 'ADD'	:
							$addSpclType = $this->_adminService->AddSpecialTypes($request);
							if($addSpclType){
								break;
							}else{
								$this->view->addstatus = 'a';
								$this->view->stcode = $request->addcode;
								$this->view->stdesc = $request->adddesc;
								break;
							}
					}
				}
				if($request->status == 'UPS'){
					$mapper = new Application_Model_SpecialTypeDataMapper();
					$add = $mapper->UpdateStatus($request);
				}
				$resDetails = $this->_adminService->GetSpecialRestTypes($page);
				$this->view->addForm = $this->_adminService->getAddSpecialTypeForm();
				$this->view->editForm = $this->_adminService->getSpecialTypeForm();
				$this->view->resDetails = $resDetails;
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
			
	}
		
	public function specialcategoryAction()
	{
		try{
		
		    $this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$page = $this->_request->getParam('page');
				if (empty($page)){
					$page = 1;
				}
				$request = $this->getRequest();
				if($this->getRequest()->isPost()){
					$operation = $request->status;
					switch($operation){
						case 'EDIT' :
							$editCategory = $this->_adminService->EditSpecialCategory($request);
							if($editCategory){
								break;
							}else{
								$this->view->addstatus = 'e';
								$this->view->sccode = $request->editcode;
								$this->view->scdesc = $request->editdesc;
								break;
							}
						//case 'DEL' 	:
							//$delete = $this->_adminService->DeleteResTypes($request->restypeid);
							//break;
						case 'ADD'	:
							$addCategory = $this->_adminService->AddSpecialCategory($request);
							if($addCategory){
								break;
							}else{
								$this->view->addstatus = 'a';
								$this->view->sccode = $request->addcode;
								$this->view->scdesc = $request->adddesc;
								break;
							}
					}
				}
				if($request->status == 'UPS'){
					$mapper = new Application_Model_SpecialCategoryDataMapper();
					$add = $mapper->UpdateStatus($request);
				}
				$resDetails = $this->_adminService->GetSpecialCategory($page);
				$this->view->addForm = $this->_adminService->getAddSpecialCategoryForm();
				$this->view->editForm = $this->_adminService->getEditSpecialCategoryForm();
				$this->view->resDetails = $resDetails;
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
			
		}	
	public function specialnumberrestAction()
	{
		try{
		
		    $this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$page = $this->_request->getParam('page');
				if (empty($page)){
					$page = 1;
				}
				$request = $this->getRequest();
				if($this->getRequest()->isPost()){
					$operation = $request->status;
					switch($operation){
						case 'EDIT' :
							$editCount = $this->_adminService->EditSpecialNumberRest($request);
							if($editCount){
								break;
							}else{
								$this->view->addstatus = 'e';
								$this->view->ctcode = $request->editcode;
								$this->view->ctdesc = $request->editdesc;
								break;
							}
						//case 'DEL' 	:
							//$delete = $this->_adminService->DeleteResTypes($request->restypeid);
							//break;
						case 'ADD'	:
							$addCount = $this->_adminService->AddSpecialNumber($request);
							if($addCount){
								break;
							}else{
								$this->view->addstatus = 'a';
								$this->view->ctcode = $request->addcode;
								$this->view->ctdesc = $request->adddesc;
								break;
							}
					}
				}
				if($request->status == 'UPS'){
					$mapper = new Application_Model_SpecialCountTypeDataMapper();
					$add = $mapper->UpdateStatus($request);
				}
				$resDetails = $this->_adminService->GetSpecialNumber($page);
				$this->view->addForm = $this->_adminService->getAddSpecialNumberForm();
				$this->view->editForm = $this->_adminService->getEditSpecialNumberForm();
				$this->view->resDetails = $resDetails;
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
			
	}	
	public function specialdiscountmodeAction()
	{
		try{
		
		    $this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$page = $this->_request->getParam('page');
				if (empty($page)){
					$page = 1;
				}
				$request = $this->getRequest();
				if($this->getRequest()->isPost()){
					$operation = $request->status;
					switch($operation){
						case 'EDIT' :
							$editDiscount = $this->_adminService->EditDiscountMode($request);
							if($editDiscount){
								break;
							}else{
								$this->view->addstatus = 'e';
								$this->view->dmcode = $request->editcode;
								$this->view->dmdesc = $request->editdesc;
								break;
							}
						//case 'DEL' 	:
							//$delete = $this->_adminService->DeleteResTypes($request->restypeid);
							//break;
						//case 'ADD'	:
							//$addDiscount = $this->_adminService->AddDiscountMode($request);
							//if($addDiscount){
							//	break;
							//}else{
								//$this->view->addstatus = 'a';
								//$this->view->dmcode = $request->addcode;
								//$this->view->dmdesc = $request->adddesc;
								//break;
							//}
					}
				}
				if($request->status == 'UPS'){
					$mapper = new Application_Model_DiscountModeDataMapper();
					$add = $mapper->UpdateStatus($request);
				}
				$resDetails = $this->_adminService->GetDiscountMode($page);
				$this->view->addForm = $this->_adminService->getAddDiscountModeForm();
				$this->view->editForm = $this->_adminService->getEditDiscountModeForm();
				$this->view->resDetails = $resDetails;
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
			
	}
	public function viewallusersAction()
	{
		$this->_helper->layout()->setLayout('adminlayout');
		$auth = Zend_Auth::getInstance();
		if($auth->hasIdentity()){
			$data = array();
			$page = $this->_request->getParam('page');
			if (empty($page)){
				$page = 1;
			}
			$form = $this->_adminService->getEditPasswordForm();
			$serform = $this->_adminService->getViewAllUserSearchForm();
			$request = $this->getRequest();
			if($this->getRequest()->isPost()){
				$data = $this->getRequest()->getPost();
				$serform->populate($data);
				$this->view->serform = $serform;
			}			
			$result = $this->_adminService->viewAllUsers($data,$page);
			$this->view->result = $result;
			$this->view->form = $form;
			$regionBd	= array();
			$cityBd 	= array();
			if($request->state){
				$stateid 	= $request->state;
				$userService= new Application_Service_User();
				$regionBd  	= $userService->GetRegionByStateId($stateid);
			}
			if($request->region){
				$regionid 	= $request->region;
				$userService= new Application_Service_User();
				$cityBd  	= $userService->GetCityByRegionId($regionid);
			}
			if($regionBd){
				$serform->region->addMultiOptions($regionBd);
			}
			if($cityBd){
				$serform->city->addMultiOptions($cityBd);
			}
			$this->view->serform = $serform;
			if(isset($request->msg)){
				$msg = $request->msg;
				$this->view->msg = $msg;
			}
			if($request->firstname){
				$this->view->firstname = $request->firstname;
			}
			if($request->lastname){
				$this->view->lastname = $request->lastname;
			}
			if($request->userId){
				$this->view->userId = $request->userId;
			}
			if($request->email){
				$this->view->email = $request->email;
			}
			if($request->status){
				$this->view->status = $request->status;
			}
			if($request->state){
				$this->view->state = $request->state;
			}
			if($request->city){
				$this->view->city = $request->city;
			}
		}else{
			$this->_redirect('login','Auth','Ums');
		}
	}
				
	public function ureservadvertiseAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			if($auth->hasIdentity()){
				$form = $this->_adminService->getAddAdvertiseForm();
				
				$request = $this->getRequest();
				if($this->getRequest()->isPost()){
					$result = $this->_adminService->AddAdvertise($this->getRequest()->getPost(),$data);
					if(!$result['status']){
						$this->view->adform = $result['addAdvertise'];
					}else{
//						$this->view->adform = $form;
//						$this->view->adformStat = true;
						return $this->_helper->_redirector('manageureservadvertise','Administrator','Admin');
					}
				}else{
					$this->view->adform = $form;
				}
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function manageureservadvertiseAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$result = $this->_adminService->GetUreservAdvertiseForManage();
				$this->view->result = $result;
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function editadvertisestatusAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$result = $this->_adminService->EditAdStatus($request);
				$subaction = $request->subaction;
				
				if($result){
					if(isset($request->id)){
						$id = $request->id;
						return $this->_helper->_redirector($subaction,'Administrator','Admin',array('id'=>$id));
					}else{
						return $this->_helper->_redirector($subaction,'Administrator','Admin');
					}
					
				}
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function editadvertiseAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$this->view->ad = $request->ad;
				if($this->getRequest()->isPost()){
					$result = $this->_adminService->EditAdvertise($this->getRequest()->getPost(),$data,$request->ad);
					if(!$result['status']){
						$this->view->adform = $result['EditAdvertise'];
					}else{
						return $this->_helper->_redirector('manageureservadvertise','Administrator','Admin');
					}
				}else{
					$form = $this->_adminService->getEditAdvertise($request);
					$this->view->adform = $form;
				}
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * Action to increment advertise counts  
	 */
	public function advertisecountAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_adminService->advertiseCount($request);
			if($result){
				echo json_encode('t');
			}else{
				echo json_encode('f');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getadvertisetimerAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$auth = Zend_Auth::getInstance();
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			$resultset = array();
			if($auth->hasIdentity()){
				$result = $this->_adminService->getAdvertiseTimer($data);
				if($result){
					$resultset = array('at_id'=>$result->at_id,'timer'=>$result->at_timer);
				}else{
					$resultset = null;
				}
				echo json_encode($resultset);
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function updateadvertisetimerAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$auth = Zend_Auth::getInstance();
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			$request = $this->getRequest();
			if($auth->hasIdentity()){
				$result = $this->_adminService->updateAdvertiseTimer($this->getRequest(),$data);
				if($result){
					echo 't';
				}else{
					echo 'f';
				}
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function manageulistcategorybdAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				if($this->getRequest()->isPost()){
				$operation = $request->status;
					switch($operation){
						case 'EDIT' :
							$editDetails = $this->_adminService->Editcategory($request);
							if($editDetails){
								break;
							}else{
								$this->view->addstatus = 'e';
								$this->view->statecode = $request->editcode;
								$this->view->statedesc = $request->editdesc;
								break;
							}
						case 'ADD'	:
							$add = $this->_adminService->AddCategory($request);
							if($add){
								break;
							}else{
								$this->view->addstatus = 'a';
								$this->view->statecode = $request->code;
								$this->view->statedesc = $request->desc;
								break;
							}
					}
				}
				if($request->status == 'UPS'){
					$mapper = new Application_Model_UlistCategoryDataMapper();
					$add = $mapper->UpdateStatus($request);
				}
				$result = $this->_adminService->GetCategoryBd($request);
				$this->view->addForm = $this->_adminService->getAddUlistCategoryForm();
				$this->view->editForm = $this->_adminService->getEditUlistCategoryForm();
				$this->view->result = $result;
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function reportforadminAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$data = array();
				$request = $this->getRequest();
				$result = $this->_adminService->AdminReport($data, $request);
				
				/*$Contacts = "";
				$Arr = array();
				$Arr[] = 'Restaurant Id';
				$Arr[] = 'Restaurant Name';
				$Arr[] = 'Restaurant Owner';
				$Arr[] = 'Restaurant Created On';
				$Arr[] = 'Region';
				$Arr[] = 'City';
				$Arr[] = 'Status';
				$Arr[] = 'Payment profile setup status';
				$Arr[] = 'No of reservations';
				$Arr[] = 'No of covers';
				$Arr[] = 'Reserv';
				$Arr[] = 'Completed';
				$Arr[] = 'Seated';
				$Arr[] = 'Partially seated';
				$Arr[] = 'wipe Ready';
				$Arr[] = 'Cancelled';
				$Arr[] = 'Reschedule';
				$Arr[] = 'Dessert';
				$Arr[] = 'Check Ready';
				$Arr[] = 'Waiting List';
				$Arr[] = 'Blocked';
				$Arr[] = 'No-Show';
				$Arr[] = 'Waiting Status Change';
				$Arr[] = 'Web';
				$Arr[] = 'Walk-In';
				$Arr[] = 'FaceBook';
				
				$Contacts .= join(',',$Arr)."\n";
				if($result['restForm']){
					foreach($result['restForm'] as $key=>$value){
						$Arr = array();
						$Arr[] = $key;
						$Arr[] = $value['resname'];
						$Arr[] = $value['firstname'].' '.$value['lastname'];
						$Arr[] = date('Y-m-d',strtotime($value['createDate']));
						$Arr[] = $value['city'];
						$Arr[] = $value['region'];
						$Arr[] = $value['appstatus'];
						$Arr[] = $value['respaymentstatus'];
						$Arr[] =$value['res_payment_mode'];
						$Arr[] = $value['finalcount'];
						$Arr[] = $value['totalpax'];
						$Arr[] = $value['statcount']['10'];
						$Arr[] = $value['statcount']['5'];
						$Arr[] = $value['statcount']['3'];
						$Arr[] = $value['statcount']['8'];
						$Arr[] = $value['statcount']['22'];
						$Arr[] = $value['statcount']['4'];
						$Arr[] = $value['statcount']['9'];
						$Arr[] = $value['statcount']['7'];
						$Arr[] = $value['statcount']['6'];
						$Arr[] = $value['statcount']['11'];
						$Arr[] = $value['statcount']['12'];
						$Arr[] = $value['statcount']['14'];
						$Arr[] = $value['statcount']['15'];
						$Arr[] = $value['modecount']['1'];
						$Arr[] = $value['modecount']['2'];
						$Arr[] = $value['modecount']['6'];
						$Contacts .= join(',',$Arr)."\n";
					}
				}	*/			
				// Output the headers to download the file
				header("Content-type: application/x-msdownload");
				header("Content-Disposition: attachment; filename=AdminReport.csv");
				header("Pragma: no-cache");
				header("Expires: 0");
				
				echo $result;
				
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function adminreportAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$data = array();
				$form = $this->_adminService->getRestaurantSearchForm();
				if($this->getRequest()->isPost()){
					$result = $this->_adminService->AdminReport($this->getRequest()->getPost(),$request);
					if($result['status']){
						$this->view->result = $result['restForm'];
					}
					$data = $this->getRequest()->getPost();
					$cityBd=array();
					if($data['region']){
						$citymapper = new Application_Model_CityDataMapper();
						$cityObj = new Application_Model_City();
						$cityObj->setRegionId($data['region']);
						$city = $citymapper->getCityByRegionId($cityObj);
						$cityBd = $city->getCityList();						
					}
					$form->populate($data);
					$form->city->addMultiOptions($cityBd);
					$this->view->form = $form;
				}else{
					$result = $this->_adminService->AdminReport($data,$request);
					if($result['status']){
						$this->view->result = $result['restForm'];
					}
					$this->view->form = $form;
				}
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}	
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getenquirystatusbdAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$enquirystatus = new Application_Model_EnquiryStatusDataMapper();
			$enquries = $enquirystatus->fetchAll();
			$enquirystatusList[] = array('key'=>'','value'=>'Select Status');   	   
    		 foreach($enquries as $enquiry){
    			$enquirystatusList[] = array('key'=>$enquiry->getId(),'value'=>$enquiry->getDescription());
    	 	} 
			$jsonObj = json_encode($enquirystatusList);
			echo $jsonObj;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function editenquirylogAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				if($this->getRequest()->isPost()){
					$result = $this->_adminService->editEnquiryLog($this->getRequest()->getPost(),$data);
					if($result){
						return $this->_helper->_redirector('managecontactus','Administrator','Admin');
					}
				}
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getenquirylogAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$result = $this->_adminService->getEnquiryLog($request);
			$jsonObj = json_encode($result);
			echo $jsonObj;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function manualpaymentmanagementAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$result = $this->_adminService->manageManualPayment($request);
			$status=false;
			if($result)
			{
				$status=true;
				echo $status;
			}
			else
			{
				echo $status;
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function managesuggestionsAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			if($auth->hasIdentity()){
				$result = $this->_adminService->ManageSuggestions();
				$this->view->result = $result;
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function managecompanyAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				$page = $this->_request->getParam('page');
				if (empty($page)){
					$page = 1;
				}
				$request = $this->getRequest();
				if($this->getRequest()->isPost()){
					$operation = $request->status;
					switch($operation){
						case 'ADD'	:
							$result = $this->_adminService->AddCompany($this->getRequest()->getPost(), $data);
							if(isset($result['form']) && (!$result['status'])){
								$this->view->addForm = $result['form'];
								$this->view->addstatus = 't';
							}else{
								return $this->_helper->_redirector('managecompany','Administrator','Admin');
							}
							break;
						case 'EDIT'	:
							$result = $this->_adminService->UpdateCompany($this->getRequest()->getPost(), $data);
							if(isset($result['form']) && (!$result['status'])){
								$this->view->addForm = $result['form'];
								$this->view->editstatus = 't';
							}else{
								return $this->_helper->_redirector('managecompany','Administrator','Admin');
							}
							break;
					}
				}
				if($request->update == "UPDATE"){
					$mapper = new Admin_Model_CompanyDataMapper();
					$update = $mapper->UpdateStatus($request);
				}				
				$companys = $this->_adminService->GetCompanys($page);
				$this->view->companys = $companys;
				$this->view->addForm = $this->_adminService->getAddCompanyForm();
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getcompanydetailsbyidAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$result = $this->_adminService->getCompanyDetailsById($request);
			$jsonObj = json_encode($result);
			echo $jsonObj;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function checkcompanyexistAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$result = $this->_adminService->checkCompanyExist($request);
			$jsonObj = json_encode($result);
			echo $jsonObj;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function managerolesandpermissionsAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				$form = $this->_adminService->getAddAdminRoleForm();
				$editform = $this->_adminService->getEditAdminRoleForm();
				$page = $this->_request->getParam('page');
				if (empty($page)){
					$page = 1;
				}
				if($this->getRequest()->isPost()){
					$operation = $request->status;
					switch($operation){
						case 'ADD'	:
								$result = $this->_adminService->AddRoleToCompany($this->getRequest()->getPost(), $data);
								if($result['status']){
									break;
								}else if(isset($result['form'])){
									$this->view->addForm = $result['form'];
									$this->view->addstatus = 't';
									break;
								}
						case 'EDIT'	:
								$result = $this->_adminService->UpdateRoleByCompany($this->getRequest()->getPost(), $data);
								if($result['status']){
									break;
								}else if(isset($result['form'])){
									$this->view->addForm = $result['form'];
									$this->view->editstatus = 't';
									break;
								}
					}
				}
				$compNameList = $this->_adminService->getComapnyNameList($data);
				$form->company->addMultiOptions($compNameList);
				$editform->editcompany->addMultiOptions($compNameList);
				if($request->companyid){
					$roles = $this->_adminService->getRolesByCompanyId($request->companyid, $page);
					$this->view->roles = $roles;
					$form->setDefaults(array('company'=>$request->companyid));
				}
				$this->view->form = $form;
				$this->view->editform = $editform;
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function changerolestatusbyroleidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_adminService->changeRoleStatusByRoleId($request);
			return $this->_helper->redirector('managerolesandpermissions','Administrator','Admin',array('companyid'=>$request->companyid));
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getroledetailsbyroleandcompanyidAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$result = $this->_adminService->getRoleDetailsByRoleandCompanyid($request);
			$jsonObj = json_encode($result);
			echo $jsonObj;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function adminrolenamecheckAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$result = $this->_adminService->adminRoleNameCheck($request);
			if($result){
				echo "t";
			}else{
				echo "f";
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getrolesbycompanyAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$result = $this->_adminService->getRolesByCompany($request);
			$jsonObj = json_encode($result);
			echo $jsonObj;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getpermissionslistAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$result = $this->_adminService->getPermissionsList($request);
			if($result){
				echo json_encode($result);
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function managerestaurantusersAction()
	{
		$this->_helper->layout()->setLayout('adminlayout');
		$auth = Zend_Auth::getInstance();
		if($auth->hasIdentity()){
			$data = array();
			$page = $this->_request->getParam('page');
			if (empty($page)){
				$page = 1;
			}
			$form = $this->_adminService->getEditPasswordForm();
			$serform = $this->_adminService->getRestOwnerSearchForm();
			$request = $this->getRequest();
			if($this->getRequest()->isPost()){
				$data = $this->getRequest()->getPost();
				$serform->populate($data);
				$this->view->serform = $serform;
			}			
			$result = $this->_adminService->manageRestaurantUsers($data,$page);
			
			$this->view->result = $result;
			$this->view->form = $form;
			$regionBd	= array();
			$cityBd 	= array();
			if($request->state){
				$stateid 	= $request->state;
				$userService= new Application_Service_User();
				$regionBd  	= $userService->GetRegionByStateId($stateid);
			}
			if($request->region){
				$regionid 	= $request->region;
				$userService= new Application_Service_User();
				$cityBd  	= $userService->GetCityByRegionId($regionid);
			}
			if($regionBd){
				$serform->region->addMultiOptions($regionBd);
			}
			if($cityBd){
				$serform->city->addMultiOptions($cityBd);
			}
			$this->view->serform = $serform;
			if(isset($request->msg)){
				$msg = $request->msg;
				$this->view->msg = $msg;
			}
			if($request->firstname){
				$this->view->firstname = $request->firstname;
			}
			if($request->lastname){
				$this->view->lastname = $request->lastname;
			}
			if($request->userId){
				$this->view->userId = $request->userId;
			}
			if($request->email){
				$this->view->email = $request->email;
			}
			if($request->status){
				$this->view->status = $request->status;
			}
			if($request->state){
				$this->view->state = $request->state;
			}
			if($request->city){
				$this->view->city = $request->city;
			}
		}else{
			$this->_redirect('login','Auth','Ums');
		}
	}
	
	public function getrestaurantuserdetailsAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$result = $this->_adminService->getrestaurantuserdetails($request);
			$jsonObj = json_encode($result);
			echo $jsonObj;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function editrestaurantuserdetailsAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$resultset = $this->_adminService->EditRestaurantOwnerDetails($request);
			$this->_helper->redirector('managerestaurantusers','Administrator','Admin');
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function editsourceofuserAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$resultset = $this->_adminService->EditSourceofRestaurant($request);
			$msg = $this->_adminService->UpdateRestaurantUserStatus($request);
			$this->_helper->redirector('managerestaurantusers','Administrator','Admin',array('msg'=>$msg));
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function updateuserstatusAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$msg = $this->_adminService->UpdateRestaurantUserStatus($request);
				$this->_helper->redirector('managerestaurantusers','Administrator','Admin',array('msg'=>$msg));
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function editallemailandpasswordAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$resultset = $this->_adminService->EditCusEmailAndPassword($request);
			$this->_helper->redirector('viewallusers','Administrator','Admin');
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function addrestaurantownerbyadminuserAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			if($this->getRequest()->isPost()){
				$result = $this->_adminService->RegisterRestaurantOwnerByAdminUser($this->getRequest()->getPost());
				if($result['status']){
					return $this->_helper->redirector('managerestaurantowners','Administrator','Admin');
				}else if($result['form']){
					$this->view->form = $result['form'];
				}
			}else{
				$this->view->form = $this->_adminService->getAddRestaurantOwnerForm();
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function restaurantdetailsnewlocationAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$restDetails = $this->_adminService->GetRestaurantNewLocationDetails($request);
				echo json_encode($restDetails);
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	//Payment History Details
	public function getpaymenthistoryAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$payHistory = $this->_adminService->getPaymentHistory($request);
				echo json_encode($payHistory); 
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	//Update the description in Payment History 
	public function paydescriptionupdateAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$payDescUpdt = $this->_adminService->payDescriptionUpdate($request);
				$updateDescStatus=false;
				if($payDescUpdt)
				{
					$updateDescStatus=true;
					echo $updateDescStatus; 
				}
				else
				{
					echo $updateDescStatus; 
				}
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function adminrestreportAction()
	{
		try{
			$this->_helper->layout()->setLayout('adminlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$data = array();
				$form = $this->_adminService->getRewardsRestaurantSearchForm();
				if($this->getRequest()->isPost()){
					$result = $this->_adminService->GetRestReservations($this->getRequest()->getPost(),$request);
					if($result['status']){
						$this->view->result = $result['restForm'];
					}
					$data = $this->getRequest()->getPost();
					$cityBd=array();
					if($data['region']){
						$citymapper = new Application_Model_CityDataMapper();
						$cityObj = new Application_Model_City();
						$cityObj->setRegionId($data['region']);
						$city = $citymapper->getCityByRegionId($cityObj);
						$cityBd = $city->getCityList();						
					}
					$form->populate($data);
					$form->city->addMultiOptions($cityBd);
					$this->view->form = $form;
				}else{
					$result = $this->_adminService->GetRestReservations($data,$request);
					if($result['status']){
						$this->view->result = $result['restForm'];
					}
					$this->view->form = $form;
				}
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}	
//			$request = $this->getRequest();
//			$resid = $request->resid;
//			$list = $this->_adminService->GetRestReservations($request);
//			$this->view->result = $list;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function exportreservationsAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				$resid = $request->resid;
				$list = $this->_adminService->GetRestReservations($data,$request);
				$Contacts = "";
				$Arr = array();
				$Arr[] = 'Booking Id';
//				$Arr[] = 'Booking User';
				$Arr[] = 'Restaurant Name';
				$Arr[] = 'Name';
				$Arr[] = 'Party Size';
				$Arr[] = 'Timings';
				$Arr[] = 'Email';
				$Arr[] = 'Phone';
				$Arr[] = 'Table No';
				$Arr[] = 'Special Request';
				$Arr[] = 'Restaurant Note';
				$Arr[] = 'Reservation Mode';
				$Arr[] = 'Booking Status';
				
				$Contacts .= join(',',$Arr)."\n";
				if($list['restForm']){
					foreach($list['restForm'] as $value){
						$Arr = array();
						$Arr[] = $value['bokid'];
//						$Arr[] = $value['bokuserid'];
						$Arr[] = $value['resname'];
						$Arr[] = $value['bok_name'];
						$Arr[] = $value['bokparty_size'];
						$Arr[] = $value['bokbooking_timings'];
						$Arr[] = $value['bokemail'];
						$Arr[] = $value['bokphone'];
						$Arr[] = implode('-',$value['tableNoArr']);
						$Arr[] = $value['bokspecial_request'];
						$Arr[] = $value['bokrestaurant_note'];
						$Arr[] = $value['bokresmodedesc'];
						$Arr[] = $value['bokstatusdesc'];
						
						$Contacts .= join(',',$Arr)."\n";
					}
				}				
				// Output the headers to download the file
				header("Content-type: application/x-msdownload");
				header("Content-Disposition: attachment; filename=RestaurantReservations.csv");
				header("Pragma: no-cache");
				header("Expires: 0");
				echo $Contacts;					
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}		
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function nativeapplicencekeydetailsAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout()->setLayout('adminlayout');
				$request = $this->getRequest();
				$page = $this->_request->getParam('page');
				if (empty($page)){
					$page = 1;
				}
				$data = array();
				$request = $this->getRequest();
				if($this->getRequest()->isPost()){
					$data= $this->getRequest()->getPost();
					$this->view->restaurantid = $data['resid'];
					$this->view->resName = $data['resName'];
				}
				$result = $this->_adminService->getNativeAppLicenceKeyDetails($data,$page);
				$this->view->result = $result;
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function resetnativeapplicencekeyAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_adminService->resetNativeAppLicenceKey($request);								
			echo $result;	
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function restpaymentreportAction()
	{
		try
		{
			$auth = Zend_Auth::getInstance();
			$this->_helper->layout()->setLayout('adminlayout');
			
			if($auth->hasIdentity()){
				
				$page = $this->_request->getParam('page');
				if (empty($page)){
					$page = 1;
				}
				$request = $this->getRequest();
				if($this->getRequest()->isPost()){
					$result = $this->_adminService->GetRestPaymentReport($this->getRequest()->getPost());
					if($request->resName)
					{
						$this->view->resName = $request->resName;
					}					
					if($request->selectYear){
						$this->view->selYear = $request->selectYear;
					}else
					{
						$this->view->selYear = date('m-d-Y', strtotime("first day of january " . date('Y')))."/".date('m-d-Y', strtotime("last day of december " . date('Y')));
					}
				}else
				{
					$formValues = array();
					
					if($request->selectYear)
					{
						$formValues['selectYear'] = $request->selectYear;
					}
					else
					{
						$this->view->selYear = date('m-d-Y', strtotime("first day of january " . date('Y')))."/".date('m-d-Y', strtotime("last day of december " . date('Y')));
					}
										
					if($request->resName)
					{
						$formValues['resName'] = $request->resName;						
					}
					
					$result = $this->_adminService->GetRestPaymentReport($formValues);
				}
				 $page=$this->_getParam('page',1);
    			 $paginator = Zend_Paginator::factory($result);
    			 $paginator->setItemCountPerPage(20);
    			 $paginator->setCurrentPageNumber($page);
    			 $this->view->paginator=$paginator;
				
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getrestduepaymentAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();				
			$result = $this->_adminService->GetRestDuePaymentInfo($request);								
			echo json_encode($result);
				
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function chargerestAction()
	{
		try
		{	
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_adminService->ChargeRestaurant($request);
			if($result['status'] == 'true'){
				echo 't';
			}else
			{
				echo $result['msg'];
			}					
		}catch (Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function generatelicenceAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_adminService->GenerateLicenceKey();
		}catch (Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function getadvpaydatesAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$payService = new Application_Service_Payment();
			$result = $payService->GetAdvancePaymentInfo($request);
			echo json_encode($result);
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function advchargerestAction()
	{
		try
		{	
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_adminService->AdvChargeRestaurant($request);
			if($result['status'] == 'true'){
				echo 't';
				
			}else
			{
				echo $result['msg'];
			}					
		}catch (Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
}