<?php

class Admin_Form_AddCampaign extends Zend_Form
{

    public function init()
    {

    	$stateMapper  = new Application_Model_StateDataMapper();
    	$states = $stateMapper->fetchAll();
    	$stateList = array();  
    	$stateList[] = array('key'=>'','value'=>'Select All State');  	   
    	foreach($states as $state){
    		$stateList[] = array('key'=>$state->getId(),'value'=>$state->getDescription());
    	}
    	
    	$timeMapper  = new Application_Model_SponsorTimeSelectionDataMapper();
    	$times = $timeMapper->fetchAll();
    	$tiemList = array();  
    	$tiemList[] = array('key'=>'','value'=>'Select Time');  	   
    	foreach($times as $time){
    		$tiemList[] = array('key'=>$time->getCode(),'value'=>$time->getDescription());
    	}
    	
    	$sponsorMapper = new Admin_Model_SponsorDataMapper();
    	$sponsors = $sponsorMapper->GetSponsors();
    	$sponsorList = array();
    	$sponsorList[] = array('key'=>'','value'=>'Select Sponsor');
    	foreach($sponsors as $comp){
    		$sponsorList[] = array('key'=>$comp->spoid,'value'=>$comp->spocompany_name);
    	}
    	
    	$priceMapper = new Admin_Model_PricePlanDataMapper();
    	$pricePlans = $priceMapper->GetPricePlans();
    	$pricePlanList = array();
    	$pricePlanList[] = array('key'=>'','value'=>'Select Price Plan');
    	foreach($pricePlans as $price){
    		$pricePlanList[] = array('key'=>$price->sppid,'value'=>$price->sppplan_name);
    	}
    	
 	    $audMapper = new Application_Model_IntendedAudienceDataMapper();
    	$audience = $audMapper->fetchAll();
    	$audienceList = array();
    	foreach($audience as $aud){
    		$audienceList[] = array('key'=>trim($aud->getCode()),'value'=>"  ".  $aud->getDescription());
    	}
    	
    	$typeMapper = new Application_Model_SponsorTargetPagesDataMapper();
    	$types = $typeMapper->fetchAll();
    	$typeList = array();
    	//$typeList[] = array('key'=>'','value'=>'Select Type');
    	foreach($types as $type){
    		$typeList[] = array('key'=>trim($type->getCode()),'value'=>"  ". $type->getDescription());
    	}
    	
    	
    	$camcount = $this->createElement('hidden','camCount');
    	$camcount->removeDecorator('DtDdWrapper')
			  	 ->removeDecorator('Label')
			  	 ->removeDecorator('HtmlTag');
    	
    	$campaingSponsor = $this->createElement('select','campSponsor');
		$campaingSponsor->removeDecorator('Label')
        			    ->removeDecorator('HtmlTag')
        			    ->setAttrib('maxlength', '100')
        			    ->setAttrib('class','sel1')
        			    ->addMultiOptions($sponsorList)        			    
        			    ->setValue('')
        			    ->setRequired(true);
        			    
    	$compName = $this->createElement('text','campaignName');
    	$compName->removeDecorator('Label')
    		 	 ->removeDecorator('HtmlTag')
    			   ->setAttrib('maxlength', '100')
        		   ->setAttrib('class','inp1 required')
        		   ->addFilters(array('StringTrim'))
        		   ->addValidator('StringLength', false,array(0,100))
        		   ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter Campaign Name.'))))
        		   ->setValue('')
        		   ->setRequired(true);
        		  
		$billingAddress = $this->createElement('textarea','campaignDesc');
		$billingAddress->removeDecorator('Label')
		 				->removeDecorator('HtmlTag')
					  ->setValue('')              
                	  ->setAttrib('cols', '20')
			          ->setAttrib('rows', '3')
			          ->addFilters(array('StringTrim'))
			          ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Campaign Description.'))))
			          ->setRequired(true);
        
		$campStartDate = $this->createElement('text','campaignStartDate');
		$campStartDate->removeDecorator('Label')
					  ->removeDecorator('HtmlTag')
					  ->setAttrib('class','inp1 datepicker')
					  ->setAttrib('readonly','readonly')
					  ->addFilters(array('StringTrim'))
					  ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select StartDate'))))
					  ->setRequired(true);
					  
		$campEndDate = $this->createElement('text','campaignEndDate');
		$campEndDate->removeDecorator('Label')
					->removeDecorator('HtmlTag')
					->setAttrib('class','inp1 datepicker2')
					->setAttrib('readonly','readonly')
					->addFilters(array('StringTrim'))
					->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select EndDate.'))))
					->setRequired(true);

					
		$checkbox = $this->createElement('checkbox','campaignDashboard');
       	$checkbox->setLabel('Display on Dash Board')
			     ->removeDecorator('HtmlTag')
			     ->setUncheckedValue('false')
			     ->setCheckedValue('true')
			     ->addValidators(array(array('notEmpty', true, array('messages' => 'Please accept terms and condition.'))))
			     ->removeDecorator('DtDdWrapper')			       
			     ->setRequired(false);
                
		$campaignWebsite = $this->createElement('text', 'campaignWebsite');
        $campaignWebsite->removeDecorator('Label') 
                   		->removeDecorator('HtmlTag')               	
	        	        ->setAttrib('class','inp1')              
	                    ->setAttrib('maxlength', '255')
	                    ->addFilters(array('StringTrim'))
//	                    ->addValidator('regex', false, '/^[a-zA-Z0-9._-]+\.[a-zA-Z]{2,6}$/')
	                    //->addValidators(new Zend_Validate_Callback(array(Zend_Uri::check())))
	                    ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Link.'))))
	                    ->setValue('')              
	                    ->setRequired(false);
                	

//        $campaignImage = $this->createElement('file','campaignImage');
//		$campaignImage->removeDecorator('Label')
//		     		  ->removeDecorator('HtmlTag')
//				      ->setAttrib('class','inp1')			     
//				      ->setRequired(false)
//				      ->addValidator('FilesSize', false, array('min' => '1kB', 'max' => '200kB'))
//				      ->addValidator('Extension', false, 'jpg,png,gif,jpeg');
				      
				      
		$campaingPricePlan = $this->createElement('text','campPricePlan');
		$campaingPricePlan->removeDecorator('Label')
				 		  ->setAttrib('maxlength', '100')
    			 		  ->setAttrib('class','inp1 required')
        		 		  ->removeDecorator('HtmlTag')
        		 		  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter Plan Name.'))))
        		 		  ->addFilters(array('StringTrim'))
        		 		  ->setRequired(true);

        $noofemails = $this->createElement('text','noofemails');
		$noofemails->removeDecorator('Label')
				   ->setAttrib('maxlength', '10')
	    		   ->setAttrib('class','inp1 required')
	        	   ->removeDecorator('HtmlTag')
	        	   ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter your Restaurant Capacity.')),
      				 				array('StringLength', false,array(0,5))))
      				 ->addValidator('Digits',new Zend_Validate_Digits(),array('messages' => 'Please enter Numbers only'))
      				 ->setValue('')
	        	   ->addFilters(array('StringTrim'))
	        	   ->setRequired(false);
	        	   
        
	    $intendedAud = new Zend_Form_Element_Radio('campaignAudience');
		$intendedAud->removeDecorator('Label')
			   		->removeDecorator('HtmlTag')
			   		->setMultiOptions($audienceList)
			   		->setValue('CUS')
			   		->setSeparator(' ')
			   		->setRequired(true);

			   		
		$amount = $this->createElement('text','amount');
		$amount->removeDecorator('Label')
			   ->removeDecorator('HtmlTag')        			     
        	   ->setAttrib('class','inp1')
               ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter the Amount.'))))
               ->addFilters(array('StringTrim'))
               ->setRequired(false); 

        $camtime = $this->createElement('select','campaignTime');
        $camtime->removeDecorator('Label') 
         		  ->removeDecorator('HtmlTag')
         		  ->setAttrib('class','sel1 drpDown')
         		  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select Time.'))))       	   
               	  ->addMultiOptions($tiemList)
                  ->setRequired(true);
                  
        $state = $this->createElement('select','state');
        $state->removeDecorator('Label') 
         		  ->removeDecorator('HtmlTag')
         		  ->setAttrib('class','sel1 drpDown')
         		  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select State.'))))       	   
               	  ->addMultiOptions($stateList)
                  ->setRequired(false);
                  
        $region = $this->createElement('select','region');
        $region->removeDecorator('Label') 
         		  ->removeDecorator('HtmlTag')
         		  ->setAttrib('class','sel1 drpDown')
         		  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select Region.'))))       	   
               	  ->setRegisterInArrayValidator(false)
         		  ->setRequired(false);
         		  
        $campImage = $this->createElement('file','campImage');
		$campImage->removeDecorator('Label')
			      ->removeDecorator('HtmlTag')
			      ->setAttrib('class','inp1')			     
			      ->setRequired(false)
			      ->addValidator('FilesSize', false, array('min' => '1kB', 'max' => '100kB'))
			      ->addValidator('Extension', false, 'jpg,png,gif');
                  
        $city = $this->createElement('select', 'city');
        $city->removeDecorator('Label')
         		 ->removeDecorator('HtmlTag')
         		 ->setAttrib('class','sel1 drpDown')
         		 ->setRegisterInArrayValidator(false)
         		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select City.'))))       	     
                 ->setRequired(false);
	                    
	    $campaignTarget = new Zend_Form_Element_Radio('campaignTarget');
		$campaignTarget->removeDecorator('Label')
			   	 	   ->removeDecorator('HtmlTag')
 		   		 	   ->setMultiOptions($typeList)
			   	 	   ->setValue('MANU')
			   	 	   ->setSeparator(' ')
			   	 	   ->setRequired(true);
			   	                 
	   $edit = $this->createElement('button','Submit');
       $edit->removeDecorator('Label')
           ->removeDecorator('DtDdWrapper')
           ->setValue('Search')           		          		        		
           ->setAttrib('class','submitBtn')
           ->setIgnore(true);
    	
    	                   
		$this->addElements( array ($campaingSponsor,
								   $compName,
								   $camcount,
								   $billingAddress,
								   $campStartDate,
								   $campEndDate,
								   $campaignWebsite,
//								   $campaignImage,
								   $campaingPricePlan,
								   $campaignTarget,
								   $state,
								   $region,
								   $city,
								   $camtime,
								   $noofemails,
								   $intendedAud,
								   $amount,
								   $edit,
								   $checkbox,
								   $campImage
								   ));                           	        
    }
}
