<?php
class Admin_Form_AddCompany extends Zend_Form
{
    public function init()
    {
    	$countryMapper  = new Application_Model_CountryDataMapper();
        $countries = $countryMapper->fetchAll();
		$countryCodeNumberList = array(); 
        foreach($countries as $country){
    		if ($country->getcountry_id() != 2) {
				$countryCodeNumberList[] = array('key'=>$country->getcountry_id(),'value'=>$country->getCountry_codenumber());
    		} 
        }
        
 		$companyname = $this->createElement('text','companyname');
    	$companyname->removeDecorator('Label')
    			    ->setAttrib('class','inp1')
        		    ->removeDecorator('HtmlTag')
        		    ->setAttrib('maxlength', '50')
        		    ->addFilters(array('StringTrim'))
        		    ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter comapny name.'))))
        		    ->setRequired(true);
        		    
		$comdescription = $this->createElement('textarea', 'comdescription');
		$comdescription->removeDecorator('Label')
		               ->removeDecorator('HtmlTag')                	   
                	   ->setAttrib('maxlength', '5000')
                	   ->setAttrib('cols', '40')
			           ->setAttrib('rows', '4')
			           ->setAttrib('class','inp1')
              		   ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter comapny description.'))))
              		   ->setRequired(true);

        $phone = $this->createElement('text', 'phone');
        $phone->removeDecorator('Label')
         		  ->removeDecorator('HtmlTag')                  
                  ->setAttrib('class','inp1')
                  ->setAttrib('style','width:96px !important;')              
                  ->setAttrib('maxlength', '12')
                  ->addFilters(array('StringTrim'))
                  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter phone number.'))))
                  ->setRequired(true);  

		$email =  $this->createElement('text', 'email');
        $email->removeDecorator('Label')
        	  ->removeDecorator('HtmlTag')        			     
              ->setAttrib('maxlength', '255')
        	  ->setAttrib('class','inp1')
			  ->addFilters(array('StringTrim'))
			  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter email.'))))
			  ->setRequired(true);
			  
		$address = $this->createElement('text','address');
        $address->removeDecorator('Label')
        	    ->removeDecorator('HtmlTag')
        	    ->setAttrib('maxlength', '510')
        	    ->setAttrib('class','inp1')
        	   ->addFilters(array('StringTrim'))
        	   ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter comapny address.'))))
        	   ->setRequired(true);
        	   
       	$website = $this->createElement('text', 'website');
        $website->removeDecorator('Label')
        		->removeDecorator('HtmlTag')
        		->setAttrib('class','inp1')
        		->setAttrib('maxlength', '30')
        		->addValidators(array(array('StringLength', false,array(0,30))))
        		->setValue('')
                ->setRequired(false); 	   
		$logouturl = $this->createElement('text', 'logouturl');
        $logouturl->removeDecorator('Label')
        		->removeDecorator('HtmlTag')
        		->setAttrib('class','inp1')
        		->setAttrib('maxlength', '50')
        		->addValidators(array(array('StringLength', false,array(0,50))))
        		->addFilters(array('StringTrim'))
        	    ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter URL.'))))
        		->setValue('')
                ->setRequired(true);
        	   
       	$companyid = $this->createElement('hidden','companyid');
       	$companyid->removeDecorator('DtDdWrapper')
			  	 ->removeDecorator('Label')
			  	 ->removeDecorator('HtmlTag');
			  	
		$countryCodeNumber = $this->createElement('select','countryCodeNumber');
		$countryCodeNumber->removeDecorator('Label') 
         		  ->removeDecorator('HtmlTag')
         		  ->setAttrib('class','sel1 drpDown')
         		  ->setAttrib('style','width:60px !important;')
         		  ->setValue(1)         		  
         		  //->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select Country.'))))       	   
               	  ->addMultiOptions($countryCodeNumberList)
                  ->setRequired(false);
        	   
       	$this->addElements(array(
       						$companyname,
       						$comdescription,
       						$phone,
       						$email,
       						$address,
       						$website,
       						$logouturl,
       						$companyid,
       						$countryCodeNumber
       					));
    }
}