<?php

class Admin_Form_ViewListedRest extends Zend_Form
{

    public function init()
    {
    	
    	/* Populating State Base Data */
    	
    	$stateMapper  = new Application_Model_StateDataMapper();
    	$states = $stateMapper->fetchAll();
    	$stateList = array();  
    	$stateList[] = array('key'=>'','value'=>'Select State');  	   
    	foreach($states as $state){
    		$stateList[] = array('key'=>$state->getId(),'value'=>$state->getDescription());
    	} 
    	/* Populating City Base Data 
    	
    	$cityMapper = new Application_Model_CityDataMapper();
    	$cityResults   = $cityMapper->fetchAll();
    	$cityList = array();
    	$cityList[] = array('key'=>'0','value'=>'Select City');
    	foreach($cityResults as $result){
    		$cityList[] = array('key'=>$result->getId(),'value'=>$result->getDescription());
    	}*/
    	
    	/* Populating Restaurant Approval Status Bd  */
    	
    	$restStatusMapper = new Application_Model_RestaurantStatusDataMapper();
    	$restStatusRes = $restStatusMapper->fetchAll();
    	$restStatusLst = array();
    	$restStatusLst[] = array('key'=>'','value'=>'Select Status');
    	foreach($restStatusRes as $res){
    		$restStatusLst[] = array('key'=>$res->getId(),'value'=>$res->getDescription());
    	}
    	
    	$restName = $this->createElement('text','restname');
    	$restName->removeDecorator('Label')
    			 ->setAttrib('class','inp1')
        		 ->removeDecorator('HtmlTag')
        		 ->addFilters(array('StringTrim'))
        		 ->setValue('');
        		 
         $resState = $this->createElement('select','resState');
         $resState->removeDecorator('Label') 
         		  ->removeDecorator('HtmlTag')
         		  ->setAttrib('class','sel1 drpDown')
         		  ->addMultiOptions($stateList);
		    	     
         $resRegion = $this->createElement('select', 'resRegion');
         $resRegion->removeDecorator('Label')
         		 ->removeDecorator('HtmlTag')
         		 ->setAttrib('class','sel1 drpDown')
         		 ->setRegisterInArrayValidator(false)
         		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select Restaurant Region.'))))        	          
                 ;
         		  
         $resCity = $this->createElement('select', 'resCity');
         $resCity->removeDecorator('Label')
         		 ->removeDecorator('HtmlTag')
         		 ->setAttrib('class','sel1 drpDown')
         		 ->setRegisterInArrayValidator(false)
         		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select Restaurant City.'))))        	          
                ;
         		    
       	$resNeighbour = $this->createElement('select', 'restNeighbour');
        $resNeighbour->removeDecorator('Label')
         			  ->setAttrib('class','sel1 drpDown')
         		 	  ->removeDecorator('HtmlTag')
         		 	  ->setRegisterInArrayValidator(false)
         		 	  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select Restaurant Neighbourhood.'))))        	          
                 	;

		 $restStatus = $this->createElement('select','reststatus');
		 $restStatus->removeDecorator('Label')
         		    ->removeDecorator('HtmlTag')
         		    ->setAttrib('class','drpDown') 
         		    ->setAttrib('style','width:160px')      	     
        	        ->addMultiOptions($restStatusLst);
        	        		 		                  
		 $resSearch = $this->createElement('submit','search');
         $resSearch->removeDecorator('Label')
        		   ->removeDecorator('DtDdWrapper')
        		   ->setValue('Search')           		          		        		
        		   ->setAttrib('class','submitBtn')
                   ->setIgnore(true);
                   
		$this->addElements( array ($restName,
								   $resState,
								   $resRegion,
								   $resCity,
								   $resNeighbour,
								   $restStatus,
								   $resSearch));                           	        
    }


}

