<?php
class Admin_Model_Company
{
	private $_id;
	private $_companyname;
	private $_description;
	private $_email;
	private $_phone;
	private $_address;
	private $_website;
	private $_logouturl;
	private $_status;
	private $_createdby;
	private $_countrycode;
	
	public function __construct(array $options = null)
	{
		if(is_array($options)){
			$this->setOptions($options);
		}		
	}
	
	public function __set($name, $value)
	{
		$method = 'set' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Advertise Timer property');
		}
		$this->$method($value);
	}
	
	public function __get($name)
	{
		$method = 'get' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Advertise Timer property');
		}
		return $this->$method();
	}
	
	public function setOptions(array $options)
	{
		$methods = get_class_methods($this);
		foreach ($options as $key => $value) {
			$method = 'set' . ucfirst($key);
			if (in_array($method, $methods)) {
				$this->$method($value);
			}
		}
		return $this;
	}
	
	public function setId($id)
	{
		$this->_id = $id;
		return $this;
	}
	
	public function getId()
	{
		return $this->_id;
	}
	
	public function setCompanyname($companyname)
	{
		$this->_companyname = $companyname;
		return $this;
	}
	
	public function getCompanyname()
	{
		return $this->_companyname;
	}
	
	public function setDescription($description)
	{
		$this->_description = $description;
		return $this;
	}
	
	public function getDescription()
	{
		return $this->_description;
	}
	
	public function setEmail($email)
	{
		$this->_email = $email;
		return $this;
	}
	
	public function getEmail()
	{
		return $this->_email;
	}
	
	public function setPhone($phone)
	{
		$this->_phone = $phone;
		return $this;
	}
	
	public function getPhone()
	{
		return $this->_phone;
	}
	
	public function setAddress($address)
	{
		$this->_address = $address;
		return $this;
	}
	
	public function getAddress()
	{
		return $this->_address;
	}
	
	public function setWebsite($website)
	{
		$this->_website = $website;
		return $this;
	}
	
	public function getWebsite()
	{
		return $this->_website;
	}
	
	public function setLogoutUrl($logouturl)
	{
		$this->_logouturl = $logouturl;
		return $this;
	}
	
	public function getLogoutUrl()
	{
		return $this->_logouturl;
	}
	
	public function setCreatedby($createdby)
	{
		$this->_createdby = $createdby;
		return $this;
	}
	
	public function getCreatedby()
	{
		return $this->_createdby;
	}
	
	public function setStatus($status)
	{
		$this->_status = $status;
		return $this;
	}
	
	public function getStatus()
	{
		return $this->_status;
	}
	
	public function setCountrycode($countrycode)
	{
		$this->_countrycode = $countrycode;
		return $this;
	}
	
	public function getCountrycode()
	{
		return $this->_countrycode;
	}
}