<?php
class Admin_Model_PricePlan
{
	private $_planType;
	private $_planName;
	private $_noofemails;
	private $_audience;
	private $_amount;
	
	public function __construct(array $options = null)
	{
		if(is_array($options)){
			$this->setOptions($options);
		}		
	}
	
	public function __set($name, $value)
	{
		$method = 'set' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Price Plan property');
		}
		$this->$method($value);
	}
	
	public function __get($name)
	{
		$method = 'get' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Price Plan property');
		}
		return $this->$method();
	}
	
	public function setOptions(array $options)
	{
		$methods = get_class_methods($this);
		foreach ($options as $key => $value) {
			$method = 'set' . ucfirst($key);
			if (in_array($method, $methods)) {
				$this->$method($value);
			}
		}
		return $this;
	}
	
	public function setPlanName($name)
	{
		$this->_planName = $name;
		return $this;
	}
	
	public function getPlanName()
	{
		return $this->_planName;
	}
	
	public function setPlanType($type)
	{
		$this->_planType = $type;
		return $this;
	}
	
	public function getPlanType()
	{
		return $this->_planType;
	}
	
	public function setNoOfEmails($no)
	{
		$this->_noofemails = $no;
		return $this;
	}
	
	public function getNoOfEmails()
	{
		return $this->_noofemails;
	}
	
	public function setAudience($aud)
	{
		$this->_audience = $aud;
		return $this;
	}
	
	public function getAudience()
	{
		return $this->_audience;
	}
		
	public function setAmount($amount)
	{
		$this->_amount = $amount;
		return $this;
	}
	
	public function getAmount()
	{
		return $this->_amount;
	}
		
}