<?php
class Admin_Model_Sponsor
{
	private $_id;
	private $_companyName;
	private $_empName;
	private $_address;
	private $_phno;
	private $_email;
	private $_fax;
	
	public function __construct(array $options = null)
	{
		if(is_array($options)){
			$this->setOptions($options);
		}		
	}
	
	public function __set($name, $value)
	{
		$method = 'set' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Sponsor property');
		}
		$this->$method($value);
	}
	
	public function __get($name)
	{
		$method = 'get' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Sponsor property');
		}
		return $this->$method();
	}
	
	public function setOptions(array $options)
	{
		$methods = get_class_methods($this);
		foreach ($options as $key => $value) {
			$method = 'set' . ucfirst($key);
			if (in_array($method, $methods)) {
				$this->$method($value);
			}
		}
		return $this;
	}
	
	public function setId($id)
	{
		$this->_id = $id;
		return $this;
	}
	
	public function getId()
	{
		return $this->_id;
	}
	
	public function setCompanyName($name)
	{
		$this->_companyName = $name;
		return $this;
	}
	
	public function getCompanyName()
	{
		return $this->_companyName;
	}
	
	public function setEmpName($emp)
	{
		$this->_empName = $emp;
		return $this;
	}
	
	public function getEmpName()
	{
		return $this->_empName;
	}
	
	public function setAddress($address)
	{
		$this->_address = $address;
		return $this;
	}
	
	public function getAddress()
	{
		return $this->_address;
	}
	
	public function setPhNo($ph)
	{
		$this->_phno = $ph;
		return $this;
	}
	
	public function getPhNo()
	{
		return $this->_phno;
	}
		
	public function setEmail($email)
	{
		$this->_email = $email;
		return $this;
	}
	
	public function getEmail()
	{
		return $this->_email;
	}
	
	public function setFax($fax)
	{
		$this->_fax = $fax;
		return $this;
	}
	
	public function getFax()
	{
		return $this->_fax;
	}
	
}