<?php
class Admin_Model_SponsorCampaignEmailPostingDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Admin_Model_DbTable_SponsorCampaignEmailPosting');
		}
		return $this->_dbTable;
	}
	
	public function UpdateEmailCount($camId,$count)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$select = $this->getDbTable()->select();
			$select->from($this->getDbTable(),array('sep_remaining_count'))
				   ->where('sep_campaign_id = ?',$camId);
			$result = $this->getDbTable()->fetchRow($select);
			$set = array(
						'sep_remaining_count'=>	$result->sep_remaining_count + $count
				);
			$where = $db->quoteInto('sep_campaign_id = ?',$camId);
			$result = $this->getDbTable()->update($set,$where);
			return true;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
}