<?php
/**
*	Name			: RestaurantController.php
*	Author			: Snehal
*	Creation Date	: 09/30/2010
*	Path 			: application/modules/ManageRestaurant/controllers/RestaurantController.php
*	Description		: This is controller class for the Manage Restaurant module.
*					   	
*/
class ManageRestaurant_RestaurantController extends Zend_Controller_Action
{

	/**
	 * Instance variable of restaurant service
	 * @var object
	 */
	protected $_restaurantService = null;

	/**
     * Initialize the restaurant service instance.
     */
	public function init()
	{
		if(!$this->_restaurantService){
			$this->_restaurantService	= new Application_Service_Restaurant();
		}
	}

	/**
	 * Index Action
	 */
	public function indexAction()
	{
		// action body
	}

	/**
	 * action to add the restaurant
	 */
	public function addrestaurantAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				if($this->getRequest()->isPost()){
					$result = $this->_restaurantService->AddRestaurant($this->getRequest()->getPost());
					if($result){
						$this->view->resId = $result['resid'];
						$this->view->isSubmit_ = true;
						//return $this->_helper->redirector('restaurantschedule');
					}
				}
				$this->view->userStat = $data['Usertype'];
				$form = $this->_restaurantService->getAddRestaurantForm();
				$this->view->addRestform = $form;
					
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to manage the restaurant
	 */
	public function managerestaurantAction()
	{
		try{
			$this->_helper->layout()->setLayout('restaurantuserlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$page = $this->_request->getParam('page');
				if (empty($page)){
					$page = 1;
				}
				if($data['Usertype'] == "RSO" || $data['Usertype'] == "ADM" || $data['Usertype'] == "ADU"){
					$restaurantList = $this->_restaurantService->GetRestaurantsByOwnerId($data,$page);
				}else if($data['Usertype'] == "RSU"){
					$restaurantList = $this->_restaurantService->GetRestaurantsDetailsByOwnerResId($data,$page);
				}
				$this->view->restaurantList = $restaurantList;
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to edit the restaurant
	 */
	public function editrestaurantAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				
				$request = $this->getRequest();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				if($request->restaurantid){
					$resStat = $this->_restaurantService->AuthenticateRestByAuth($data,$request->restaurantid);
				}else{
					$resStat = false;
				}				
				$this->view->resStPhrase = $resStat;
				if($resStat){
					if($this->getRequest()->isPost()){						
						$formArr = $this->_restaurantService->editRestaurantDeatails($request);
						$result = $this->_restaurantService->EditRestaurantDetails($this->getRequest()->getPost(),$request);
						$resultObj = $this->_restaurantService->viewRestaurantDetails($request);
						if($result['status']){
	
							$this->view->restdetails = $resultObj;
							$this->view->personalForm = $formArr['personalForm'];
							$this->view->addressForm = $formArr['addressForm'];
							$this->view->parkingForm = $formArr['parkingForm'];
							$this->view->restaurantimage = $formArr['restaurantimage'];
							$this->view->restaurantlogo = $formArr['restaurantlogo'];
						}else{
	
							if(isset($result['personalForm'])){
								$this->view->personalForm = $result['personalForm'];
								$this->view->popUpForm = 	'personalForm';
							}else{
								$this->view->personalForm = $formArr['personalForm'];
							}
							if(isset($result['addressForm'])){
								$this->view->addressForm = $result['addressForm'];
								$this->view->popUpForm = 	'addressForm';
							}else{
								$this->view->addressForm = $formArr['addressForm'];
							}
							if(isset($result['parkingForm'])){
								$this->view->parkingForm = $result['parkingForm'];
								$this->view->popUpForm = 	'parkingForm';
							}else{
								$this->view->parkingForm = $formArr['parkingForm'];
							}
							if(isset($result['restaurantimage'])){
								$this->view->restaurantimage = $result['restaurantimage'];
								$this->view->popUpForm = 	'restaurantimage';
							}else{
								$this->view->restaurantimage = $formArr['restaurantimage'];
							}
							if(isset($result['restaurantlogo'])){
								$this->view->restaurantlogo = $result['restaurantlogo'];
								$this->view->popUpForm = 	'restaurantlogo';
							}else{
								$this->view->restaurantlogo = $formArr['restaurantlogo'];
							}
							$this->view->restdetails = $resultObj;
						}
					}else{
						$request = $this->getRequest();
						
						$resultObj = $this->_restaurantService->viewRestaurantDetails($request);
						$formArr = $this->_restaurantService->editRestaurantDeatails($request);
						$this->view->restdetails = $resultObj;
						$this->view->personalForm = $formArr['personalForm'];
						$this->view->addressForm = $formArr['addressForm'];
						$this->view->parkingForm = $formArr['parkingForm'];
						$this->view->restaurantimage = $formArr['restaurantimage'];
						$this->view->restaurantlogo = $formArr['restaurantlogo'];
					}
				}
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function editrestpersonaldetailsfromnativeappAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_restaurantService->EditRestPersonalDetailsFromNativeApp($request);
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}	

	public function editrestaddressdetailsfromnativeappAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_restaurantService->EditRestAddressDetailsFromNativeApp($request);
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function editrestparkingdetailsfromnativeappAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_restaurantService->EditRestParkingDetailsFromNativeApp($request);
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to delete the restaurant
	 */
	public function deleterestaurantAction()
	{
		// action body
	}

	/**
	 * action to edit the restaurant status
	 */
	public function editrestaurantstatusAction()
	{
		try{
			$this->_helper->layout()->setLayout('restaurantuserlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$this->_restaurantService->EditRestaurantStatus($request);
				return $this->_helper->redirector('managerestaurant');
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to add the restaurant schedule
	 */
	/* Restaurant Schedule Management  Actions Start */
	public function restaurantscheduleAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				
				if($request->restaurantid){
					$resStat = $this->_restaurantService->AuthenticateRestByAuth($data,$request->restaurantid);
					$schTypeResult = $this->_restaurantService->CheckRestaurantScheduleType($request);
					if($schTypeResult['settingType'] == 'UL'){
						return $this->_helper->redirector('restaurantulschedule','Restaurant','ManageRestaurant',array('restaurantid'=>$request->restaurantid));
					}else if($schTypeResult['settingType'] == 'SMC'){
						return $this->_helper->redirector('restaurantsmcschedule','Restaurant','ManageRestaurant',array('restaurantid'=>$request->restaurantid));
					}
					
					$result = $this->_restaurantService->managescheduleSetting($request);
				    $this->view->schedulestatus1 = $result->code;
					$setresult1=$this->_restaurantService->getschedulesetting();
					$this->view->schedulestatus=$setresult1;				
				}else{
					$resStat = true;
				}				
				$this->view->secureLoginStatus = $resStat;
				if($resStat){
					$this->_helper->layout()->setLayout('restaurantuserlayout');
				
					$operation = $request->operation;
					switch($operation){
						case 'create':
							$result = $this->_restaurantService->CreateSchedule($request);
							return $this->_helper->redirector('restaurantschedule','Restaurant','ManageRestaurant',array('isSubmit'=>true,'resIsset'=>false,'restaurantid'=>$request->restaurantid));
							break;
						case 'update':
							$result = $this->_restaurantService->UpdateSchedule($request);
							return $this->_helper->redirector('restaurantschedule','Restaurant','ManageRestaurant',array('isSubmit'=>true,'resIsset'=>true,'restaurantid'=>$request->restaurantid,'returnresult'=>$result,'weekday'=>$request->weekday));
							break;
						default :
							if($request->restaurantid){
								$result = $this->_restaurantService->GetRestaurantSchedule($request);
								$presentSchDay = $this->_restaurantService->GetRestaurantPresentDayScheudle($request);
								/*$AllSchDay = $this->_restaurantService->GetRestaurantAllEmptyDayScheudle($request);
								$this->view->AllSchDay = $AllSchDay['isset'];
								if(count($AllSchDay['notset']) == 7){
									return $this->_helper->redirector('addrestaurantschedule','Restaurant','ManageRestaurant',array('restaurantid'=>$request->restaurantid));
								}*/
								if($presentSchDay){
									$this->view->presentSchDay = 'true';
								}else{
									$this->view->presentSchDay = 'false';
								}
								$this->view->inventory    = $result['inventory'];
								if(isset($request->resIsset)){
									$this->view->resIsset	= $request->resIsset;
								}else{
									$this->view->resIsset	= $result['resIsset'];
								}
								if(isset($request->isSubmit)){
									$this->view->isSubmit	= $request->isSubmit;
								}else{
									$this->view->isSubmit	= false;
								}
								if($request->returnresult){
									$this->view->returnresult = $request->returnresult;
								}
	
								$this->view->schedule	  = $result['schedule'];
								$this->view->restaurantid = $request->restaurantid;
								$this->view->weekday	  =	$result['weekday'];		
							}
							break;
					}
					$this->view->restaurantid = $request->restaurantid;
					
					//			$resId = $request->RestaurantNameHide;
					//			if($resId > 0){
					//				$resstatus = $this->_restaurantService->GetRestStatusById($resId);
					//
					//				$this->view->resfloorStatus = $resstatus->getRestFloorPlanStatus();
					//				$this->view->resschStatus = $resstatus->getRestScheStatus();
					//
					//			}
	
					$result = $this->_restaurantService->RestaurantSchedule($data);
					$this->view->resform = $result['form'];
					$this->view->userStat = $data['Usertype'];
					if($request->isSubmit){
						$this->view->isSubmit = $request->isSubmit;
					}
					//			else{
					//				$resstatus = $this->_restaurantService->GetRestStatusById($resId);
					//
					//				$this->view->resfloorStatus = $resstatus->getRestFloorPlanStatus();
					//				$this->view->resschStatus = $resstatus->getRestScheStatus();
					//
					//			}
				}
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function restaurantulscheduleAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				
				if($request->restaurantid){
					$resStat = $this->_restaurantService->AuthenticateRestByAuth($data,$request->restaurantid);
					$schTypeResult = $this->_restaurantService->CheckRestaurantScheduleType($request);
					if($schTypeResult['settingType'] == 'SL'){
						return $this->_helper->redirector('restaurantschedule','Restaurant','ManageRestaurant',array('restaurantid'=>$request->restaurantid));
					}else if($schTypeResult['settingType'] == 'SMC'){
						return $this->_helper->redirector('restaurantsmcschedule','Restaurant','ManageRestaurant',array('restaurantid'=>$request->restaurantid));
					}
					//schedule action
					$result = $this->_restaurantService->managescheduleSetting($request);
				    $this->view->schedulestatus1 = $result->code;
					$setresult1=$this->_restaurantService->getschedulesetting();
					$this->view->schedulestatus=$setresult1;
				}else{
					$resStat = true;
				}				
				$this->view->secureLoginStatus = $resStat;
				if($resStat){
					$this->_helper->layout()->setLayout('restaurantuserlayout');
					$operation = $request->operation;
					switch($operation){
						case 'create':
							$result = $this->_restaurantService->CreateSchedule($request);
							return $this->_helper->redirector('restaurantulschedule','Restaurant','ManageRestaurant',array('isSubmit'=>true,'resIsset'=>false,'restaurantid'=>$request->restaurantid));
							break;
						case 'update':
							$result = $this->_restaurantService->UpdateSchedule($request);
							return $this->_helper->redirector('restaurantulschedule','Restaurant','ManageRestaurant',array('isSubmit'=>true,'resIsset'=>true,'restaurantid'=>$request->restaurantid,'returnresult'=>$result,'weekday'=>$request->weekday));
							break;
						default :
							if($request->restaurantid){
								$result = $this->_restaurantService->GetRestaurantULSchedule($request);
								$presentSchDay = $this->_restaurantService->GetRestaurantPresentDayULScheudle($request);
								$AllSchDay = $this->_restaurantService->GetRestaurantAllEmptyDayULScheudle($request);
								$this->view->AllSchDay = $AllSchDay['isset'];
								if(count($AllSchDay['notset']) == 7){
									return $this->_helper->redirector('addrestaurantulschedule','Restaurant','ManageRestaurant',array('restaurantid'=>$request->restaurantid));
								}
								if($presentSchDay){
									$this->view->presentSchDay = 'true';
								}else{
									$this->view->presentSchDay = 'false';
								}
//								$this->view->inventory    = $result['inventory'];
								if(isset($request->resIsset)){
									$this->view->resIsset	= $request->resIsset;
								}else{
									$this->view->resIsset	= $result['resIsset'];
								}
								if(isset($request->isSubmit)){
									$this->view->isSubmit	= $request->isSubmit;
								}else{
									$this->view->isSubmit	= false;
								}
								if($request->returnresult){
									$this->view->returnresult = $request->returnresult;
								}
	
								$this->view->schedule	  = $result['schedule'];
								$this->view->restaurantid = $request->restaurantid;
								$this->view->weekday	  =	$result['weekday'];		
							}
							break;
					}
					$this->view->restaurantid = $request->restaurantid;
					
					//			$resId = $request->RestaurantNameHide;
					//			if($resId > 0){
					//				$resstatus = $this->_restaurantService->GetRestStatusById($resId);
					//
					//				$this->view->resfloorStatus = $resstatus->getRestFloorPlanStatus();
					//				$this->view->resschStatus = $resstatus->getRestScheStatus();
					//
					//			}
	
					$result = $this->_restaurantService->RestaurantSchedule($data);
					$this->view->resform = $result['form'];
					$this->view->userStat = $data['Usertype'];
					if($request->isSubmit){
						$this->view->isSubmit = $request->isSubmit;
					}
					//			else{
					//				$resstatus = $this->_restaurantService->GetRestStatusById($resId);
					//
					//				$this->view->resfloorStatus = $resstatus->getRestFloorPlanStatus();
					//				$this->view->resschStatus = $resstatus->getRestScheStatus();
					//
					//			}
				}
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function restaurantsmcscheduleAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				
				if($request->restaurantid){
					$resStat = $this->_restaurantService->AuthenticateRestByAuth($data,$request->restaurantid);
					$schTypeResult = $this->_restaurantService->CheckRestaurantScheduleType($request);
					if($schTypeResult['settingType'] == 'SL'){
						return $this->_helper->redirector('restaurantschedule','Restaurant','ManageRestaurant',array('restaurantid'=>$request->restaurantid));
					}else if($schTypeResult['settingType'] == 'UL'){
						return $this->_helper->redirector('restaurantulschedule','Restaurant','ManageRestaurant',array('restaurantid'=>$request->restaurantid));
					}
					$result = $this->_restaurantService->managescheduleSetting($request);
				    $this->view->schedulestatus1 = $result->code;
					$setresult1=$this->_restaurantService->getschedulesetting();
					$this->view->schedulestatus=$setresult1;
						
					
				}else{
					$resStat = true;
				}				
				$this->view->secureLoginStatus = $resStat;
				if($resStat){
					$this->_helper->layout()->setLayout('restaurantuserlayout');
					$operation = $request->operation;
					switch($operation){
						case 'create':
							$result = $this->_restaurantService->CreateSchedule($request);
							return $this->_helper->redirector('restaurantsmcschedule','Restaurant','ManageRestaurant',array('isSubmit'=>true,'resIsset'=>false,'restaurantid'=>$request->restaurantid));
							break;
						case 'update':
							$result = $this->_restaurantService->UpdateSchedule($request);
							return $this->_helper->redirector('restaurantsmcschedule','Restaurant','ManageRestaurant',array('isSubmit'=>true,'resIsset'=>true,'restaurantid'=>$request->restaurantid,'returnresult'=>$result,'weekday'=>$request->weekday));
							break;
						default :
							if($request->restaurantid){
								$result = $this->_restaurantService->GetRestaurantSMCSchedule($request);
								$presentSchDay = $this->_restaurantService->GetRestaurantPresentDaySMCScheudle($request);
								$AllSchDay = $this->_restaurantService->GetRestaurantAllEmptyDaySMCScheudle($request);
								$this->view->AllSchDay = $AllSchDay['isset'];
								if(count($AllSchDay['notset']) == 7){
									return $this->_helper->redirector('addrestaurantsmcschedule','Restaurant','ManageRestaurant',array('restaurantid'=>$request->restaurantid));
								}
								if($presentSchDay){
									$this->view->presentSchDay = 'true';
								}else{
									$this->view->presentSchDay = 'false';
								}
//								$this->view->inventory    = $result['inventory'];
								if(isset($request->resIsset)){
									$this->view->resIsset	= $request->resIsset;
								}else{
									$this->view->resIsset	= $result['resIsset'];
								}
								if(isset($request->isSubmit)){
									$this->view->isSubmit	= $request->isSubmit;
								}else{
									$this->view->isSubmit	= false;
								}
								if($request->returnresult){
									$this->view->returnresult = $request->returnresult;
								}
	
								$this->view->schedule	  = $result['schedule'];
								$this->view->restaurantid = $request->restaurantid;
								$this->view->weekday	  =	$result['weekday'];		
							}
							break;
					}
					$this->view->restaurantid = $request->restaurantid;
					
					//			$resId = $request->RestaurantNameHide;
					//			if($resId > 0){
					//				$resstatus = $this->_restaurantService->GetRestStatusById($resId);
					//
					//				$this->view->resfloorStatus = $resstatus->getRestFloorPlanStatus();
					//				$this->view->resschStatus = $resstatus->getRestScheStatus();
					//
					//			}
	
					$result = $this->_restaurantService->RestaurantSchedule($data);
					$this->view->resform = $result['form'];
					$this->view->userStat = $data['Usertype'];
					if($request->isSubmit){
						$this->view->isSubmit = $request->isSubmit;
					}
					//			else{
					//				$resstatus = $this->_restaurantService->GetRestStatusById($resId);
					//
					//				$this->view->resfloorStatus = $resstatus->getRestFloorPlanStatus();
					//				$this->view->resschStatus = $resstatus->getRestScheStatus();
					//
					//			}
				}
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function restaurantscheduleajaxAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_restaurantService->GetRestaurantScheduleByAjax($request);
			if($result){
				echo json_encode($result);
			}else{
				echo json_encode('f');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function restaurantulscheduleajaxAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_restaurantService->GetRestaurantULScheduleByAjax($request);
			if($result){
				echo json_encode($result);
			}else{
				echo json_encode('f');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function restaurantsmcscheduleajaxAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_restaurantService->GetRestaurantSMCScheduleByAjax($request);
			if($result){
				echo json_encode($result);
			}else{
				echo json_encode('f');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function changerestaurantschedulepageAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_restaurantService->CheckRestaurantScheduleType($request);
			echo $result['settingType'];
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function restspecialscheduleAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				
				if($request->restaurantid){
					$resStat = $this->_restaurantService->AuthenticateRestByAuth($data,$request->restaurantid);
				}else{
					$resStat = true;
				}
				$this->view->secureLoginStatus = $resStat;
				if($resStat){
					$this->_helper->layout()->setLayout('restaurantuserlayout');
					if($request->isPost()){
						$formdata = $request->getPost();
						$result = $this->_restaurantService->CreateSpecialSchedule($formdata);
						if($result['status']){
							//$msg = $result['msg'];
							$this->_helper->redirector('managespecialschedule','Restaurant','ManageRestaurant');
						}else{
							$this->view->resform = $result['form'];
							$this->view->restaurantid = $formdata['RestaurantName'];
							$this->view->inventory = $result['inventory'];						
						}
					}else{
						if($request->restaurantid){					
							
							$result = $this->_restaurantService->GetRestSplScheduleInventory($request);
							$this->view->inventory    = $result['inventory'];
							
							if($request->returnresult){
								$this->view->returnresult = $request->returnresult;
							}
		
							//$this->view->schedule	  = $result['schedule'];
							$this->view->restaurantid = $request->restaurantid;	
						}	
	
						$result = $this->_restaurantService->RestaurantSpecialSchedule();
						$this->view->resform  = $result['form'];
						$this->view->userStat = $data['Usertype'];
					}
				}else{
					$result = $this->_restaurantService->RestaurantSpecialSchedule();
					$this->view->resform  = $result['form'];
					$this->view->userStat = $data['Usertype'];
				}
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function splscheduleformvalidationajaxAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$form = $this->_restaurantService->getRestSpecialScheduleForm();
	        $form->isValid($this->_getAllParams());
	        $json = $form->getMessages();
	        if(empty($json)){
	        	echo json_encode('t');
	        }else{
	        	header('Content-type: application/json');
	        	echo json_encode($json);
	        }
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function restsplschconfAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout()->setLayout('restaurantuserlayout');
			
			if($request){
				$this->view->msg = $request->msg;
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function managespecialscheduleAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$formdata = "";
				$form = new ManageRestaurant_Form_RestaurantSpecialSchedule();
				$request = $this->getRequest();
				$page = $this->_request->getParam('page');
				if (empty($page)){
					$page = 1;
				}
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				if($request->isPost()){
					$formdata = $this->getRequest()->getPost();
					$form->populate($formdata);
					$this->view->resform = $form;
				}
				$result = $this->_restaurantService->ManageSpecialSchedules($data, $formdata,$page);
				$this->view->result = $result;
				$this->view->resform = $form;
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function updatesplschedulestatusAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_restaurantService->UpdateSplScheduleStatus($request);
				if($result){
					echo 't';
				}else{
					echo 'f';
				}
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function checksplschedulebydateAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				if($request){
					$result = $this->_restaurantService->checkSplScheduleByDate($request);
					if($result){
						echo "t";
					}else{
						echo "f";
					}
				}
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getsplscheduledescriptionAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			if($this->getRequest()->isPost()){
				$request = $this->getRequest();
				$result = $this->_restaurantService->getSplScheduleDescription($request);
				if($result){
					echo json_encode($result);
				}else{
					echo "f";
				}
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getspecialschedulebyidAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				if($request->restaurantid){
					$resStat = $this->_restaurantService->AuthenticateRestByAuth($data,$request->restaurantid);
				}else{
					$resStat = false;
				}
				$this->view->secureLoginStatus = $resStat;
				if($resStat){
					$this->_helper->layout()->setLayout('restaurantuserlayout');
					if($request->isPost()){
						$formdata = $request->getPost();
						$result = $this->_restaurantService->UpdateSpecialSchedule($formdata);
						if($result){
							$this->view->msg = 'Schedule Updated Successfully';
						}
					}
					$resform = $this->_restaurantService->getSpecialSchedulesById($request, $data);
					$eventid = $resform['eventid'];
					$schresult = $this->_restaurantService->GetSpecialSchedule($request,$eventid);
					$this->view->resform 	= $resform['form'];
					$this->view->inventory  = $schresult['inventory'];
					$this->view->schedule	= $schresult['schedule'];
					$this->view->restaurantid = $request->restaurantid;
					$this->view->id = $request->id;
				}
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getsplschedulesbydateAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request	= $this->getRequest();				
				$result 	= $this->_restaurantService->getSpecialScheduleByDate($request);
		        echo json_encode($result);
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getsplscheduledatesAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request	= $this->getRequest();				
				$splDates 	= $this->_restaurantService->getSplScheduleDatesByResId($request);
			    echo json_encode($splDates);
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	/**
	 * action to add the restaurant schedule menu
	 */
	public function addrestaurantschedulemenuAction()
	{
		try{
			$request = $this->getRequest();
			if($request){
				$result = $this->_restaurantService->AddRestaurantScheduleMenu($request);
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				if($result){
					echo "t";
				}else{
					echo "f";
				}
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to create the schedule
	 */
	public function createscheduleAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$request = $this->getRequest();

				$result = $this->_restaurantService->CreateSchedule($request);

				return $this->_helper->redirector('restaurantschedule','Restaurant','ManageRestaurant',array('isSubmit'=>$result));
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to manage the schedule
	 */
	public function managescheduleAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				$result = $this->_restaurantService->ManageSchedule($data,$request);
				if($request->msg){
					$msg = $request->msg;
					if($msg){
						$this->view->msg = "Restaurant Schedule updated sucessfully.";
					}

				}
				$this->view->resultStr = $result['resultStr'];
				$this->view->resform = $result['resform'];

			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to update the schedule
	 */
	public function updatescheduleAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$request = $this->getRequest();
				$rest_id = $request->RestaurantNameHide;
				$result = $this->_restaurantService->UpdateSchedule($request);
				$this->_helper->redirector('manageschedule','Restaurant','ManageRestaurant',array('restaurant_id'=>$rest_id,'msg'=>true));
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to retreive the restaurant menu
	 */
	public function getrestmenuAction()
	{
		try{
			$request = $this->getRequest();
			$restMenuList = $this->_restaurantService->GetRestMenu($request);
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$menuArr = array();
			foreach($restMenuList as $value){
				$menuArr[] = array('key'=>$value->getrsmid(),'value'=> $value->getrsmmenu());
			}
			if($menuArr){
				echo json_encode($menuArr);

			}else{
				echo "f";
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to add the restaurants floor 
	 */
	public function restaurantfloorAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$diningid = "";
				$floorstatus = "";
				$form = $this->_restaurantService->getRestTableForm();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				if($request->resid){
					$resStat = $this->_restaurantService->AuthenticateRestByAuth($data,$request->resid);
				}else{
					$resStat = true;
				}
								
				$this->view->secureLoginStatus = $resStat;
				if($resStat){
					$restNameList = "";
					if($data['Usertype'] == "RSO" || $data['Usertype'] == "ADM" || $data['Usertype'] == "ADU"){
						$restNameList = $this->_restaurantService->GetRestNameById($data);
					}else if($data['Usertype'] == "RSU"){
						$restNameList = $this->_restaurantService->GetRestNameById($data);
					}				
					$this->_helper->layout()->setLayout('restaurantuserlayout');
					if($this->getRequest()->isPost()){
						$result = $this->_restaurantService->ManageRestFloorPlan($this->getRequest()->getPost());
						if($result['status']){
							$floorstatus = $this->_restaurantService->getFloorStatusByResid($result['restid']);
							if($floorstatus == true){
								$this->view->floorstatus = false;
							}else{
								$this->view->floorstatus = true;
							}
							$form = $result['form'];
							$form->RestaurantName->addMultiOptions($restNameList);
							$form->setDefaults(array('RestaurantName'=>$result['restid']));
							$this->view->form      = $form;
							$resultArr 			   = $result['floorPlan'];
							$this->view->resultStr = $resultArr['finalStr'];
							$this->view->floorSepStr = $result['floorSep'];
							$this->view->etnStr    = $resultArr['etnStr'];
							$this->view->resid     = $result['restid'];
							$this->view->msg       = 'Floor Plan Created Scuessfully.';
							$this->view->isSubmit  = $result['submitstatus'];
							$this->view->userStat  = $data['Usertype'];
							$this->view->diningarea= $result['diningArr'];
							$this->view->diningid  = $result['diningid'];
							$this->view->diningname= $result['diningname'];
						}else{
							$this->view->form = $result['form'];
						}
					}else{
	
						$form->RestaurantName->addMultiOptions($restNameList);
						$this->view->form = $form;
						$resId = 0;
						if($request->resid){
							$resId = $request->resid;
							$floorstatus = $this->_restaurantService->getFloorStatusByResid($resId);
							if($floorstatus == true){
								$this->view->floorstatus = false;	
							}else{
								$this->view->floorstatus = true;
							}
							$diningidArr = array();
							$Diningresult = $this->_restaurantService->getDinigAreasByRestIdfromFloor($resId);
							if($request->diningid){
									$diningid = $request->diningid;
								}else{
									foreach($Diningresult as $dining){
										$diningidArr[] = $dining->rdaid;
									}
									$diningid = $diningidArr[0];					
							} 
							$this->view->diningarea = $Diningresult;
							
							$resultArr   = $this->_restaurantService->getRestFloorPlan($resId,$diningid);
							$floorSepArr = $this->_restaurantService->getRestFloorSeprators($resId,$diningid);
							if($resultArr['finalStr']){
								$this->view->floorSt = true;
							}else{
								$this->view->floorSt = false;
							}
							$this->view->resultStr   = $resultArr['finalStr'];
							$this->view->floorSepStr = $floorSepArr;
							$this->view->etnStr = $resultArr['etnStr'];
							$this->view->resid = $resId;
							$this->view->diningid = $diningid;
							foreach($Diningresult as $dining)
							{
								if($dining->rdaid == $diningid){
									$this->view->diningname = $dining->rda_diningname;
									break;
								}
							}
						}else{
							$this->view->floorstatus = true;
						}
						//				if($resId > 0)
						//				{
						//				$resstatus = $this->_restaurantService->GetRestStatusById($resId);
						//
						//				$this->view->resfloorStatus = $resstatus->getRestFloorPlanStatus();
						//				$this->view->resschStatus = $resstatus->getRestScheStatus();
						//				}
						
					}
				}
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to add the restaurant deal
	 */
	public function restaurantdealAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$form = $this->_restaurantService->getRestaurantDealForm();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				if($this->getRequest()->isPost()){
					$result = $this->_restaurantService->ManageDeal($this->getRequest()->getPost());
					if($result){
						return $this->_helper->redirector('managedeal');
					}
				}else{
					$restNameList = $this->_restaurantService->GetRestNameById($data);
					$form->RestaurantName->addMultiOptions($restNameList);
					$this->view->form = $form;
				}
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to manage the restaurant deal
	 */
	public function managedealAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$result = $this->_restaurantService->RestaurantManageDeal($data);
				$this->view->result = $result;
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to edit the restaurant deal
	 */
	public function editrestaurantdealAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				if($this->getRequest()->isPost()){
					$result = $this->_restaurantService->EditRestaurantDeal($this->getRequest()->getPost());
					if($result){
						return $this->_helper->redirector('managedeal');
					}
				}else{
					$request = $this->getRequest();
					$form = $this->_restaurantService->GetRestaurantDealById($request,$data);
					$this->view->result = $form;
				}
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to delete the restaurants deal
	 */
	public function deleterestaurantdealAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$this->_restaurantService->deleteRestaurantDeal($request);
				return $this->_helper->redirector('managedeal');
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to add the restaurants special
	 */
	public function restaurantspecialAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$form = $this->_restaurantService->getRestaurantSpecialForm();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				if($this->getRequest()->isPost()){
					$result = $this->_restaurantService->ManageSpecial($this->getRequest()->getPost());
					if($result){
						return $this->_helper->redirector('managespecial');
					}
				}
				$restNameList = $this->_restaurantService->GetRestNameById($data);
				$form->RestaurantName->addMultiOptions($restNameList);
				$this->view->form = $form;
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to manage the restaurants special
	 */
	public function managespecialAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$result = $this->_restaurantService->RestaurantManageSpecial($data);
				$this->view->result = $result;
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to eidt the restaurants special
	 */
	public function editrestaurantspecialAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				if($this->getRequest()->isPost()){
					$result = $this->_restaurantService->EditRestaurantSpecial($this->getRequest()->getPost(),$request);
					$formArr = $this->_restaurantService->editRestaurantSpecialDetails($request,$data);
					$resultSpl = $this->_restaurantService->viewRestaurntSpecialById($request,$data);

					if($result['status']){
						$sp = $request->specialid;
						$this->view->result = $resultSpl;
						$this->view->editSplForm = $formArr['editSplForm'];
						$this->view->restSplImage = $formArr['restSplImage'];
						$this->view->restSplSch = $formArr['restSplSch'];
						$this->view->restaurantid = $request->restaurantid;
						$this->view->specialid = $request->specialid;
					}else{
						if(isset($result['editSplForm'])){
							$this->view->editSplForm = $result['editSplForm'];
							//$this->view->popUpForm = 	'editSplForm';
						}else{
							$this->view->editSplForm = $formArr['editSplForm'];
						}
						if(isset($result['restSplImage'])){
							$this->view->restSplImage = $result['restSplImage'];
							$this->view->popUpForm = 	'restSplImage';
						}else{
							$this->view->restSplImage = $formArr['restSplImage'];
						}
						if(isset($result['restSplSch'])){
							$this->view->restSplSch = $result['restSplSch'];
						}else{
							$this->view->restSplSch = $formArr['restSplSch'];
						}
						$this->view->result = $resultSpl;
					}
				}else{
					$resultSpl = $this->_restaurantService->viewRestaurntSpecialById($request,$data);
					$formArr = $this->_restaurantService->editRestaurantSpecialDetails($request,$data);
					$this->view->result = $resultSpl;
					$this->view->editSplForm = $formArr['editSplForm'];
					$this->view->restSplImage = $formArr['restSplImage'];
					$this->view->restSplSch = $formArr['restSplSch'];
					$this->view->restaurantid = $request->restaurantid;
					$this->view->specialid = $request->specialid;
				}
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to delete the restaurants special
	 */
	public function deleterestaurantspecialAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$this->_restaurantService->deleteRestaurantspl($request);
				return $this->_helper->redirector('managespecial');
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to add the restaurant hot table
	 */
	public function restauranthottableAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$form = $this->_restaurantService->getRestaurantHotTableForm();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				if($this->getRequest()->isPost()){
					$result = $this->_restaurantService->ManageHotTable($this->getRequest()->getPost());
					if($result){
						return $this->_helper->redirector('managehottable');
					}
				}
				$restNameList = $this->_restaurantService->GetRestNameById($data);
				$form->RestaurantName->addMultiOptions($restNameList);
				$this->view->form = $form;
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to manage the restaurant hot table
	 */
	public function managehottableAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$result = $this->_restaurantService->RestaurantManageHotTable($data);
				$this->view->result = $result;
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to edit the restaurant hot table
	 */
	public function editrestauranthottableAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				if($this->getRequest()->isPost()){
					$result = $this->_restaurantService->EditRestaurantHotTable($this->getRequest()->getPost());
					if($result['status']){
						return $this->_helper->redirector('managehottable');
					}else{
						$this->view->form = $result['form'];
					}

				}else{
					$request = $this->getRequest();
					$form = $this->_restaurantService->GetRestaurantHotTableById($request,$data);
					$this->view->form = $form;
				}
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to delete the restaurant hot table
	 */
	public function deletehottableAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$this->_restaurantService->deleteRestaurantHotTable($request);
				return $this->_helper->redirector('managehottable');
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to manage the restaurant contacts
	 */
	public function managecontactsAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$form = $this->_restaurantService->getAddUserContactForm();
				$searcform = $this->_restaurantService->getSearchUserContactForm();
				$excelform = $this->_restaurantService->getExcelImportForm();
				$storage = new Zend_Auth_Storage_Session();
				$page = $this->_request->getParam('page');
				if (empty($page)){
					$page = 1;
				}
				$data = $storage->read();
				$request = $this->getRequest();
				if($data['Usertype'] == "RSO" || $data['Usertype'] == "ADM" || $data['Usertype'] == "ADU"){
					$restNameList = $this->_restaurantService->GetRestNameById($data);
				}else if($data['Usertype'] == "RSU"){
					$restNameList = $this->_restaurantService->GetRestNameById($data);
				}
				$this->view->restType = $data['companyid'];
				if($this->getRequest()->isPost()){
					//$id = $request->formstatus;
					if($request->formstatus == 'search'){
						$result = $this->_restaurantService->searchUsercontact($this->getRequest()->getPost(),$data,$page,$restNameList);
						if($result){
							$this->view->result = $result['result'];
							$result['form']->restaurantName->addMultiOptions($restNameList);
							$this->view->searchform = $result['form'];
						}else{
							$searcform->restaurantName->addMultiOptions($restNameList);
							$this->view->searchform = $searcform;
						}
						$excelform->ExcelRestaurantName->addMultiOptions($restNameList);
						$this->view->excelform = $excelform;
						$form->RestaurantName->addMultiOptions($restNameList);
						$this->view->form = $form;
					}
					if($request->formstatus == 'addcontact'){
						$result = $this->_restaurantService->AddUserContact($this->getRequest()->getPost(),$data);
						if($result['status']){
							return $this->_helper->redirector('managecontacts');
						}else{
							$this->view->form = $result['usercontact'];
							$this->view->popUpForm = 'usercontact';
							$searcform->restaurantName->addMultiOptions($restNameList);
							$this->view->searchform = $searcform;
							$result = $this->_restaurantService->manageUsersContacts($data,$page);
							$this->view->result = $result;
							$excelform->ExcelRestaurantName->addMultiOptions($restNameList);
							$this->view->excelform = $excelform;
						}
					}
					if($request->formstatus == 'addexcel'){
						$result = $this->_restaurantService->getDetailsExcel($this->getRequest()->getPost(),$data);
						if($result){
							return $this->_helper->redirector('managecontacts');
						}
					}
				}else{
					$form->RestaurantName->addMultiOptions($restNameList);
					$this->view->form = $form;
					$searcform->restaurantName->addMultiOptions($restNameList);
					$this->view->searchform = $searcform;
					if(count($restNameList) >1){
						$result = $this->_restaurantService->manageUsersContacts($data,$page);
						if($result){
							$this->view->result = $result;
						}	
					 }
					$excelform->ExcelRestaurantName->addMultiOptions($restNameList);
					$this->view->excelform = $excelform;
				}
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to eidt the restaurant contacts
	 */
	public function editusercontactAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$form = $this->_restaurantService->getAddUserContactForm();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$userid = $data['User_Id'];
				if($this->getRequest()->isPost()){
					$result = $this->_restaurantService->EditUserContact($this->getRequest()->getPost(),$data);
					if($result['status']){
						return $this->_helper->redirector('managecontacts');
					}else{
						$this->view->form = $result['form'];
					}
				}else{
					$request = $this->getRequest();
					$form = $this->_restaurantService->GetUserContactById($request,$data);
					$this->view->form = $form;
				}
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to delete the restaurant contacts
	 */
	public function deleteusercontactAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$this->_restaurantService->deleteUserContact($request);
				return $this->_helper->redirector('managecontacts');
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to manage the restaurant groups
	 */
	public function managegroupsAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				
				$form = $this->_restaurantService->getAddGroupForm();
				$searcform = $this->_restaurantService->getSearchUserContactForm();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				if($request->restaurantid){
					$resStat = $this->_restaurantService->AuthenticateRestByAuth($data,$request->restaurantid);
				}else{
					$resStat = true;
				}
				$this->view->secureLoginStatus = $resStat;
				if($resStat){
					$this->_helper->layout()->setLayout('restaurantuserlayout');
					$userid = $data['User_Id'];
					
					if($this->getRequest()->isPost()){
						$result = $this->_restaurantService->AddGroup($this->getRequest()->getPost(),$data);
						if($result['status'])
						{
							return $this->_helper->redirector('managegroups');
						}else{
							if($data['Usertype'] == "RSO" || $data['Usertype'] == "ADM" || $data['Usertype'] == "ADU"){
								$restNameList = $this->_restaurantService->GetRestNameById($data);
							}else if($data['Usertype'] == "RSU"){
								$restNameList = $this->_restaurantService->GetRestNameById($data);
							}
							$this->view->restaurantNameList = $restNameList;
							$this->view->form = $result['groupfrom'];
							$this->view->popUpForm = 'groupfrom';
						}
					}else{
						if($data['Usertype'] == "RSO" || $data['Usertype'] == "ADM" || $data['Usertype'] == "ADU"){
							$restNameList = $this->_restaurantService->GetRestNameById($data);
						}else if($data['Usertype'] == "RSU"){
							$restNameList = $this->_restaurantService->GetRestNameById($data);
						}
						$this->view->restaurantNameList = $restNameList;
						$form->RestaurantName->addMultiOptions($restNameList);
						$this->view->form = $form;
						$searcform->restaurantName->addMultiOptions($restNameList);
						$this->view->searchform = $searcform;
						if($request->restaurantid){
							$restid = $request->restaurantid;
							$groupList = $this->_restaurantService->getRestaurantGroupsById($restid);
							$this->view->groupNameList = $groupList;
							$this->view->resturantid = $restid;
						}
					}
				}
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to edit the restaurant group
	 */
	public function editusergroupAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$form = $this->_restaurantService->getAddGroupForm();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$userid = $data['User_Id'];
				if($this->getRequest()->isPost()){
					$result = $this->_restaurantService->EditGroupDetails($this->getRequest()->getPost(),$data);
					if($result['status']){
						return $this->_helper->redirector('managegroups');
					}else{
						$this->view->form = $result['groupfrom'];
					}
				}else{
					$request = $this->getRequest();
					$form = $this->_restaurantService->GetUserGroupById($request,$data);
					$this->view->form = $form;
				}
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to delete the restaurant group
	 */
	public function deleteusergroupAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$this->_restaurantService->deleteUserGroup($request);
				return $this->_helper->redirector('managegroups');
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	// Commented to introduce Regions
	public function getcitysbystateidAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$resultObj = $this->_restaurantService->getCitysByStateId($request);
			$jsonObj = json_encode($resultObj->getCityList());
			echo $jsonObj;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	} 

	public function getcitiesbystateidandregionidAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$resultObj = $this->_restaurantService->GetCitiesByStateAndRegionId($request);
			$jsonObj = json_encode($resultObj);
			echo $jsonObj;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getstatesbyajaxAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$resultObj = $this->_restaurantService->getStatesInfo();
			$jsonObj = json_encode($resultObj);
			echo $jsonObj;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getregionsbystateidAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$resultObj = $this->_restaurantService->getRegionsByStateId($request);
			$jsonObj = json_encode($resultObj->getRegionList());
			echo $jsonObj;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getcitysbyregionidAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$resultObj = $this->_restaurantService->getCitysByRegionId($request);
			$jsonObj = json_encode($resultObj->getCityList());
			echo $jsonObj;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action retreive the neighbourhood basedata using city id
	 */
	public function getnghidbycityidAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$resultObj = $this->_restaurantService->getNghIdCidyId($request);
			$jsonObj = json_encode($resultObj->getNeighborhoodList());
			echo $jsonObj;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to manage the restaurant details
	 */
	public function restaurantdetailsAction()
	{
		try{
			$request = $this->getRequest();
			$resultObj = $this->_restaurantService->restaurantDetails($request);
			$this->view->restdetails = $resultObj;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to retreive the restaurant type using restaurant id using ajax call
	 */
	public function restauranttypebyrestidajaxAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$restid = $request->restaurantid;
			$result = $this->_restaurantService->getRestaurantTypeById($restid);
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to check the unique ness of the special
	 */
	public function specialuniquecheckAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$restaurantSpl = new ManageRestaurant_Model_RestaurantSpecial();
			$restaurantSpl->setSpecialtitle(trim($request->specialTitle));
			$restaurantSpl->setRestaurantid(trim($request->restaurantid));
			$result = $this->_restaurantService->CheckUnique($restaurantSpl);
			if($result){
				echo "t";
			}else{
				echo "f";
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to verify the existence of restaurant schedule
	 */
	public function restaurantscheduleissetAction()
	{
		try{
			$request = $this->getRequest();
			$result = $this->_restaurantService->RestaurantScheduleIsset($request);
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			if((int)$result){
				echo "t";
			}else{
				echo "f";

			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to retreive the restaurant tables by restaurant id using ajax-call
	 */
	public function restauranttablesbyrestidajaxAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$result = $this->_restaurantService->getRestaurantTablesById($request);
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to retreive the restaurant timings
	 */
	public function restauranttimingsAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_restaurantService->RestaurantTimings($request);

			if($result){
				echo json_encode($result);
			}else{
				echo json_encode("f");
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to retreive the restaurant timings for freeze
	 */
	public function getrestauranttimingsfreezeAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_restaurantService->GetRestaurantTimingsFreeze($request);

			if($result){
				echo json_encode($result);
			}else{
				echo "f";
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to retreive the reservations and timings
	 */
	public function getrestauranttimingsandreservationsAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$resid = $request->restaurantid;
			$date = $request->date;
			$datExp = explode('-',$date);
			$reDate = $datExp[2]."-".$datExp[0]."-".$datExp[1];
			$limit = $request->limit;
			$offset = $request->offset;
			$resultSet = array();
			$result = $this->_restaurantService->RestaurantTimings($request);
			if(empty($result)){
				echo json_encode("f");
			}else{
				$reservResult = $this->_restaurantService->RestaurantReservationsCount($resid,$reDate,$limit,$offset,$result);
				$res = $this->_restaurantService->GenerateChart($reservResult,$result,$resid,$reDate,$limit,$offset,10,"onClick");
				$resultSet['resName'] = $res;
				$resultSet['limit'] = $request->limit;
				$resultSet['offset'] = $request->offset;
				$resultSet['Total'] = count($result);
				if($resultSet){
					echo json_encode($resultSet);
				}else{
					echo json_encode("f");
				}
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to retreive the groups by restaurnant id using ajax-call
	 */
	public function getgroupsbyrestidajaxAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$restid = $request->restaurantid;
			$resultList = $this->_restaurantService->getRestaurantGroupsById($restid);

			echo json_encode($resultList);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to delete the schedule using ajax-call
	 */
	public function deletescheduleajaxAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_restaurantService->DeleteScheduleAjax($request);
			echo $result;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function deleteulscheduleajaxAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_restaurantService->DeleteULScheduleAjax($request);
			echo $result;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function deletesmcscheduleajaxAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_restaurantService->DeleteSMCScheduleAjax($request);
			echo $result;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	/**
	 * action to delete the inventory using ajax-call 
	 */
	public function deleteinventroyajaxAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_restaurantService->DeleteInventoryAjax($request);
			if($result){
				echo 1;
			}else{
				echo 0;
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to check the table staus
	 */
	public function checkboktablestatusAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_restaurantService->CheckBokStatus($request);
			if($result){
				echo "t";
			}else{
				echo "f";
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to check the inventory count using ajax-call 
	 */
	public function checkinventorycountajaxAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$count = $request->count;
			$result = $this->_restaurantService->CheckInventoryCountAjax($request);
			echo $result;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to check the group name 
	 */
	public function groupnamecheckAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();

			$result = $this->_restaurantService->CheckGroupName($request);
			if($result){
				echo "t";
			}else{
				echo "f";
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to check the unique-ness of the restaurant name 
	 */
	public function resnameuniquecheckAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();

			$result = $this->_restaurantService->CheckRestaurantName($request);
			if($result){
				echo "t";
			}else{
				echo "f";
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to retreive restaurant details for search using ajax-call 
	 */
	public function restaurantsearchajaxAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$text = $request->inputtext;
			$result = $this->_restaurantService->getRestaurantNamesSearch($text);
			$list = array();
			$finallist = null;
			foreach($result as $key=>$value){
				$list[] = array('res' => array("key"=>$key,"value"=>$value));
			}
			$resListArr = array('reslist'=>$list);
			$resJson = json_encode($resListArr);
			echo $resJson;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}

	}
	
	/**
	 * action to retreive restaurant details for search using ajax-call 
	 */
	public function restaurantsearchtimeanddateajaxAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$text = $request->inputtext;
			$result = $this->_restaurantService->getRestaurantNamesTimeSearch($text,$request);
			$list = array();
			$finallist = null;
			if(isset($result)){
				foreach($result as $key=>$value){
					$list[] = array('res' => array("key"=>$key,"value"=>$value));
				}
			}
			$resListArr = array('reslist'=>$list);
			$resJson = json_encode($resListArr);
			echo $resJson;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}

	}
	
	/**
	 * action to retreive restaurant details using restaurant id
	 */
	public function restaurantdetailsbyidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$resid = $request->restaurantid;
			if($request->restaurantid){
				$result = $this->_restaurantService->GetRestaurantDetailsArr($request);
				echo json_encode($result);

			}
			//$this->_helper->redirector('addrestaurant','Restaurant','ManageRestaurant',array('restaurantid' => $resid));
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}

	}

	/**
	 * action to manage overbooking password 
	 */
	public function overbookedpasswordAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$form = $this->_restaurantService->getOverBookedPasswordForm();
				if($this->getRequest()->isPost()){
					if($data['Usertype'] == 'ADM' || $data['Usertype'] == 'ADU'){
						$result = $this->_restaurantService->OverBookedPassword($this->getRequest()->getPost(),$data['restownerId']);
					}else{
						$result = $this->_restaurantService->OverBookedPassword($this->getRequest()->getPost(),$data['User_Id']);
					}
					if($result['status'] == true){
						$this->view->passwordmsg = $result['msg'];
					}
				}
				if($data['Usertype'] == "RSO" || $data['Usertype'] == 'ADM' || $data['Usertype'] == 'ADU'){
					$restNameList = $this->_restaurantService->GetRestNameById($data);
				}else if($data['Usertype'] == "RSU"){
					$restNameList = $this->_restaurantService->GetRestNameById($data);
				}
				$form->RestaurantName->addMultiOptions($restNameList);
				$this->view->form = $form;
					
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to manage the role permissions  
	 */
	public function managerolepermissionsAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				if($request->restaurantid){
					$resStat = $this->_restaurantService->AuthenticateRestByAuth($data,$request->restaurantid);
				}else{
					$resStat = true;
				}
				$this->view->secureLoginStatus = $resStat;
				if($resStat){
					$this->_helper->layout()->setLayout('restaurantuserlayout');
					$form = $this->_restaurantService->getRolePermissionsForm();
					$editform = $this->_restaurantService->getEditRolePermissionsForm();
					 
					$page = $this->_request->getParam('page');
					if (empty($page)){
						$page = 1;
					}
					if($this->getRequest()->isPost()){
						if($request->frmstatus == "ADD"){
							$resid = $request->restaurantid;
							$result = $this->_restaurantService->AddUserPermissons($this->getRequest()->getPost(),$data);
							if($result['status']){
								return $this->_helper->redirector('managerolepermissions','Restaurant','ManageRestaurant',array('restaurantid'=>$request->restaurantid));
							}else{
								$restNameList = $this->_restaurantService->GetRestNameById($data);
								$this->view->restaurantNameList = $restNameList;
								$this->view->form = $result['addrole'];
								$this->view->popUpForm = 'groupfrom';
							}
						}else if($request->frmstatus == "EDIT"){
							$result	= $this->_restaurantService->EditUserPermissions($this->getRequest()->getPost(),$data);
							if($result['status']){
								return $this->_helper->redirector('managerolepermissions','Restaurant','ManageRestaurant',array('restaurantid'=>$request->editRestaurantName));
							}else{
								$restNameList = $this->_restaurantService->GetRestNameById($data);
								$this->view->restaurantNameList = $restNameList;
								$this->view->editform = $result['addrole'];
								$this->view->editpopUpForm = 'groupfrom';
							}
						}
					}
					if($request->frmstatus == "DEL"){
						$resid = $request->restaurantid;
						$roleid = $request->roleid;
						$roles = $this->_restaurantService->deleteRolesByRoleId($resid,$roleid);
						return $this->_helper->redirector('managerolepermissions','Restaurant','ManageRestaurant',array('restaurantid'=>$request->restaurantid));
	
					}
					if($data['Usertype'] == "RSO" || $data['Usertype'] == "ADM" || $data['Usertype'] == "ADU"){
						$restNameList = $this->_restaurantService->GetRestNameById($data);
					}else if($data['Usertype'] == "RSU"){
						$restNameList = $this->_restaurantService->GetRestNameById($data);
					}
					$editform->editRestaurantName->addMultiOptions($restNameList);
					$form->RestaurantName->addMultiOptions($restNameList);
					if($request->restaurantid){
						$roles = $this->_restaurantService->getAllRolesByRestId($request->restaurantid, $page);
						$this->view->rolevalues = $roles;
						$form->setDefaults(array('RestaurantName'=>$request->restaurantid));
					}
					$this->view->resnamelist = $restNameList;
					$this->view->form = $form;
					$this->view->editform = $editform;
					$this->view->restaurantid = $request->restaurantid;
				}
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function permissionslistAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();			
			$result = $this->_restaurantService->getPermissionsList();
			if($result){
				echo json_encode($result);
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function changerolestatusAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_restaurantService->changeRoleStatus($request);
			return $this->_helper->redirector('managerolepermissions','Restaurant','ManageRestaurant',array('restaurantid'=>$request->restaurantid));
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}	
	}
	/**
	 * action to check the role names 
	 */
	public function rolenamecheckAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();

			$result = $this->_restaurantService->CheckRoleName($request);
			if($result){
				echo "t";
			}else{
				echo "f";
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to check the role asignments 
	 */
	public function checkroleasignAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$roles = $this->_restaurantService->CheckRoleAsignById($request);
			if($roles){
				echo 't';
			}else{
				echo 'f';
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to retreive roles by restaurant id
	 */
	public function getrolesbyresidajaxAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$resid = $request->restaurantid;
			$roles = $this->_restaurantService->getRolesByRestId($resid);
			if($roles){
				echo json_encode($roles);
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}

	}

	/**
	 * action to retreive role details by role id
	 */
	public function getrolesbyroleidajaxAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$roleid = $request->roleid;
			$roles = $this->_restaurantService->getRolesByRoleId($roleid);
			echo json_encode($roles);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to delete the role by roleid using ajax-call 
	 */
	public function deleterolesbyroleidajaxAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$form = $this->_restaurantService->getRolePermissionsForm();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$resid = $request->restaurantid;
				$roleid = $request->roleid;
				$roles = $this->_restaurantService->deleteRolesByRoleId($resid,$roleid);
				return $this->_helper->redirector('managerolepermissions','Restaurant','ManageRestaurant',array('frms'=>'Yes','resid'=>$request->restaurantid));
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to manage notification status
	 */
	public function notificationstatusAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$this->_restaurantService->ManageNotificationStatus($request);
				if($request->from){
					$this->_helper->redirector('managerestaurant','Restaurant','ManageRestaurant');
				}else{
					$this->_helper->redirector('restaurantconsole','User','Ums');
				}	
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function phonenotifystatusAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$this->_restaurantService->ManagePhoneNotifyStatus($request);
				$this->_helper->redirector('restaurantconsole','User','Ums');							
				
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to download the excel for restaurant contacts 
	 */
	public function downloadexcelAction()
	{
		$this->_helper->layout->disableLayout();
		$this->_helper->viewRenderer->setNoRender();
		$request = $this->getRequest();
		if($request){
			$file = 'excelcontacts/RestContacts.xls';
			$size = filesize($file);		
			if (file_exists($file))
			{
				header("Content-type: application/force-download");
				header("Content-Transfer-Encoding: Binary");
				header('Content-Length: '.$size);
				header("Content-disposition: attachment; filename=".basename($file));
				readfile($file);
	
			}			
		}
	}
	
	public function exportcontactsAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				$list = $this->_restaurantService->GetRestUsersContacts($data);
				$Contacts = "";
				$Arr = array();
				$Arr[] = 'First Name';
				$Arr[] = 'Last Name';
				$Arr[] = 'Gender';				
				$Arr[] = 'Email';				
				$Arr[] = 'Phone';
				$Arr[] = 'Address';
				$Arr[] = 'State';
				$Arr[] = 'City';
				$Arr[] = 'ZipCode';
				$Arr[] = 'Birthday';
				$Arr[] = 'Anniversary';
				$Arr[] = 'Opt-in Email';
				$Contacts .= join(',',$Arr)."\n";
				if($list){
					foreach($list as $value){
						$Arr = array();
						$Arr[] = $value->rgufirst_name;
						$Arr[] = $value->rgulast_name;
						$Arr[] = $value->rgugender;						
						$Arr[] = $value->rguemail;						
						$usphone = str_replace("-","",$value->rguphone);
						if(strlen($usphone) > 3){
							$usphone = substr_replace($usphone, '-', 3, 0);
							if(strlen($usphone) > 7){
								$usphone = substr_replace($usphone, '-', 7, 0);	
							}
						}
						$Arr[] = $usphone;
						$Arr[] = $value->rguaddress;
						$Arr[] = $value->state;
						$Arr[] = $value->city;
						$Arr[] = $value->rguzipcode;
						$Arr[] = $value->rgu_birthday;
						$Arr[] = $value->rgu_anniversary;
						if($value->rgu_optinemail){
							$Arr[] = 'True';
						}else{
							$Arr[] = 'False';
						}
						$Contacts .= join(',',$Arr)."\n";
					}
				}				
				// Output the headers to download the file
				header("Content-type: application/x-msdownload");
				header("Content-Disposition: attachment; filename=RestaurantContacts.csv");
				header("Pragma: no-cache");
				header("Expires: 0");
				echo $Contacts;					
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}		
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to retreive the open slots for reservations
	 */
	public function getopenslotsAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$resultSet = array();
			$result = $this->_restaurantService->getNoofTablesandPaxByTimes($request);
			
			if($result){
				echo json_encode($result);
			}else{
				echo json_encode("f");
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getreservedslotsAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$resultSet = array();
			$result = $this->_restaurantService->getReservedSlots($request);
			
			if($result){
				echo json_encode($result);
			}else{
				echo json_encode("f");
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getreservedslotspdfAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$resultSet = array();
			$result = $this->_restaurantService->getReservedSlotsPDFReport($request);
			$file = 'deskreport/'.$request->restaurantid.'.pdf';
			
			$size = filesize($file);		
			if (file_exists($file))
			{
				header("Content-type: application/force-download");
				header("Content-Transfer-Encoding: Binary");
				header('Content-Length: '.$size);
				header("Content-disposition: attachment; filename=".basename($file));
				readfile($file);
	
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	/**
	 * action to retreive the open slots for max count setting
	 */
	public function getopenslotsformaxcountAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$resultSet = array();
			$result = $this->_restaurantService->getOpenSlotsForMaxCountSetting($request);
			
			if($result){
				echo json_encode($result);
			}else{
				echo json_encode("f");
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getrestauranttimesearchmsgAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_restaurantService->getRestaurantTimeSearchMessage($request->resid);
			echo $result->resbooking_search_msg;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function managerestauranttimesearchmsgAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_restaurantService->ManageRestaurantTimeSearchMessage($request);
			echo $result;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getopenslotsfromweekviewAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$resultSet = array();
			$result = $this->_restaurantService->getOpenSlotsFromWeekView($request);
			
			if($result){
				echo json_encode($result);
			}else{
				echo json_encode("f");
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getopenslotsformaxcountfromweekviewAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$resultSet = array();
			$result = $this->_restaurantService->getOpenSlotsForMaxCountFromWeekView($request);
			
			if($result){
				echo json_encode($result);
			}else{
				echo json_encode("f");
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to retreive notifications using id
	 */
	public function getnotificationsbyidAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$notifications = $this->_restaurantService->getNotificationsByOwnerId($data);
				$this->view->notifications = $notifications;			
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to retreive notification details using id
	 */
	public function getnotificationdetailsbyidAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$request = $this->getRequest();
				$msgid = $request->msgid;
				$email_mapper = new Notification_Model_EmailMessageDataMapper();
				$msgid = $email_mapper->GetMsgIdByPhrase($msgid);
			
				$service = new Application_Service_Notification();
				$result = $service->GetTitleandMessageById($msgid);
				$this->view->title = $result['title'];	
				$this->view->message = $result['Message'];			
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to retreive restaurant timezone 
	 */
	public function getrestauranttimezoneAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$timezone = $this->_restaurantService->GetRestaurantTimeZone($request->resid);
			date_default_timezone_set($timezone);
			$selDate = $request->selDate;
			$selDateArr = explode('-',$selDate);
			$selDateSec = mktime(0,0,0,$selDateArr[0],$selDateArr[1],$selDateArr[2]);
			$todDate = date('m-d-Y');
			$todDateArr = explode('-',$todDate);
			$todDateSec = mktime(0,0,0,$todDateArr[0],$todDateArr[1],$todDateArr[2]);
			if($selDateSec == $todDateSec){
				$dateArr = explode("-",$selDate);
				$resTime = date('H:i:s');
				$resTimearr = explode(':',$resTime);
				$selTime = date("H:i:s",strtotime($request->selTime));
				$selTimeArr = explode(':',$selTime);
				$resTimeSec = mktime($resTimearr[0],$resTimearr[1],$resTimearr[2],$dateArr[0],$dateArr[1],$dateArr[2]);
				$selTimeSec = mktime($selTimeArr[0],$selTimeArr[1],$selTimeArr[2],$dateArr[0],$dateArr[1],$dateArr[2]);
				if($selTimeSec < $resTimeSec){
					echo 'f';
				}else{
					echo 't';
				}
			}else{
				echo 't';
			}
				
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to add the dining area
	 */
	public function adddiningareaAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_restaurantService->AddDiningArea($request);
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to manage dining area
	 */
	public function managediningareaAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$request = $this->getRequest();
				$result = $this->_restaurantService->GetAllDiningAreasByResId($request);
				$this->view->diningarea = $result;
				$this->view->resid = $request->resid;			
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to edit the dining area
	 */
	public function editdiningareaAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_restaurantService->EditDiningArea($request);
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to edit dining area status
	 */
	public function editdiningareastatusAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_restaurantService->EditDiningAreaStatus($request);
			if($result){
				return $this->_helper->redirector('restaurantfloor','Restaurant','ManageRestaurant',array('resid'=>$request->resid));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to add facebook page id for the restaurant
	 */
	public function addfacebookpageidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_restaurantService->AddFacebookPageId($request);
			if($result){
				if($request->from){
					return $this->_helper->redirector('managerestaurant','Administrator','Admin');
				}else{
					return $this->_helper->redirector('restaurantconsole','User','Ums');
				}
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to edit facebook page id for the restaurant
	 */
	public function editfacebookpageidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_restaurantService->EditFacebookPageId($request);
			if($result){
				if($request->from){
					return $this->_helper->redirector('managerestaurant','Administrator','Admin');
				}else{
					return $this->_helper->redirector('restaurantconsole','User','Ums');
				}
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to retreive facebook page id using restaurant id
	 */
	public function getfacebookpageidbyrestidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_restaurantService->GetFacebookPageIdByRestId($request);
			if($result){
				echo json_encode($result);
			}else{
				echo json_encode("f");
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to retreive restaurant information using facebook page id
	 */
	public function restaurantinfobyfbpageidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_restaurantService->GetRestaurantInfoByFBPageid($request);
			if($result){
				echo json_encode($result);
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to create message
	 */
	public function createmessageAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				if($data['Usertype'] == 'RSO'){
					if($this->getRequest()->isPost()){
						$result = $this->_restaurantService->createMessage($request,$data);
					}
					$result = $this->_restaurantService->getMessagesById($data);
					$this->view->message = $result;
				}else if($data['Usertype'] == 'RSU'){
					$Msgresult = $this->_restaurantService->getReceivedMessagesById($data);
					$this->view->message = $Msgresult;
				}
				$this->view->usertype = $data['Usertype'];
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to retreive message using id
	 */
	public function getmessagebyidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_restaurantService->getMessageDescriptionById($request);
			if($result){
				echo json_encode($result);
			}			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to create alert for the restaurant operators
	 */
	public function createalertAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				if($this->getRequest()->isPost()){
					$status = $this->_restaurantService->createAlert($this->getRequest()->getPost(),$data);
					If($status){
						if($request->date){
							$date = $request->date; 
						}else{
							$date = date("m-d-Y");
						}
						return $this->_helper->redirector('reservationdesk','Booking','Booking',array('restaurantid'=>$request->restaurantid,'date'=> $date));
					}
				}else{
					$restNameList = $this->_restaurantService->GetRestNameById($data);
					$this->view->restnames = $restNameList;
					$result = $this->_restaurantService->getRestaurantUserIdsByRestIds($data);
					$this->view->result = $result['result'];
					$this->view->resids = $result['resids'];
					$this->view->restid = $request->restaurantid;
				}
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to retreive alerts using date for the restaurant operators
	 */
	public function getalertsbydateAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_restaurantService->getAlertsByDate($request, $data);
				if($result){
					echo json_encode($result);
				}else{
					echo json_encode('f');
				}
			}else{
				$this->_redirect('login','Auth','Ums');
			}		
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to retreive all alerts for the user
	 */
	public function viewallalertsAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$request = $this->getRequest();
				$result = $this->_restaurantService->viewAllAlerts($request, $data);
				$this->view->result = $result;
			}else{
				$this->_redirect('login','Auth','Ums');
			}		
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to retreive alert details using id
	 */
	public function getalertdetailsbyidAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_restaurantService->getAlertDetailsById($request);
				if($result){
					echo json_encode($result);
				}else{
					echo json_encode('f');
				}
			}else{
				$this->_redirect('login','Auth','Ums');
			}		
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to update alert status using id 
	 */
	public function updatealertstatusidAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_restaurantService->updateAlertStatusId($request);
				if($result){
					echo json_encode('t');
				}else{
					echo json_encode('f');
				}
			}else{
				$this->_redirect('login','Auth','Ums');
			}		
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function changerestemailstatusajaxAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_restaurantService->changeresemailstatus($request);
				if($result){
					echo 't';
				}else{
					echo 'f';
				}
			}else{
				$this->_redirect('login','Auth','Ums');
			}		
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function deleteresemailajaxAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_restaurantService->deleteResEmail($request);
				if($result){
					echo 't';
				}else{
					echo 'f';
				}
			}else{
				$this->_redirect('login','Auth','Ums');
			}		
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function restsmsnotifynumberAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				if($request->type == 'sms'){
					$result = $this->_restaurantService->restSmsNotifyNumber($request);
				}else{
					$result = $this->_restaurantService->restPhoneNotifyNumber($request);
				}
				if($result){
					echo 't';
				}else{
					echo 'f';
				}
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getrestsmsnotifynumberajaxAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_restaurantService->getRestSmsNotifyNumber($request);
				if($result){
					echo json_encode($result);
				}else{
					echo json_encode('f');
				}
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	
	public function updatenotifydetailsajaxAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_restaurantService->UpdateNotifyDetails($request);
				if($result){
					echo 't';
				}else{
					echo 'f';
				}
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	
	public function updatephonenotifydetailsajaxAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_restaurantService->UpdatePhoneNotifyDetails($request);
				if($result){
					echo 't';
				}else{
					echo 'f';
				}
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function updatecusinfoAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_restaurantService->UpdateCusInfo($request);
				if($result){
					echo json_encode('t');
				}else{
					echo json_encode('f');
				}
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function deletefloorsepratorAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			if($request){
				$result = $this->_restaurantService->deleteFloorSeprator($request);
				if($result){
					echo json_encode('t');
				}else{
					echo json_encode('f');
				}
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getresdetailsbyresidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			if($request){
				$result = $this->_restaurantService->GetRestaurantDetailsByResId($request);
				if($result){
					echo json_encode($result);
				}else{
					echo json_encode("f");
					
				}
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function manageconstconatctsettingsAction()
	{
		try{
			
			$auth = Zend_Auth::getInstance();
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			$request = $this->getRequest();
			if($request->restaurantid){
				$resStat = $this->_restaurantService->AuthenticateRestByAuth($data,$request->restaurantid);
			}else{
				$resStat = false;
			}
			$this->view->secureLoginStatus = $resStat;
			if($resStat){
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				if($auth->hasIdentity()){
					$manageForm = $this->_restaurantService->getManageConstantContactForm();
					
					if($request->isPost()){
						$result = $this->_restaurantService->ManageConstantContactSettings($this->getRequest()->getPost(),$data);
						if($result['status']){
							$restResult = $result['result'];
							$this->view->result = $restResult['result'];
							$this->view->frmaction = $restResult['action'];
							$this->view->manageForm = $manageForm;						
						}else{
							$this->view->result = 'false';
							$this->view->manageForm = $result['form'];
						}
					}else{
						$this->view->manageForm = $manageForm;					
					}
					$settings = $this->_restaurantService->GetConstContactSettings($request);
					if($settings){
						$lookupuser = $this->_restaurantService->LookUpConstContactUser($request);
						if($lookupuser){
							$this->view->lookUpUser = "Y";
							$this->view->contactList = $this->_restaurantService->GetConstContactList($request);
						}else{
							$this->view->lookUpUser = "N";
						}
					}
				    
					$syncReport = $this->_restaurantService->GetContactSyncReport($request);
				    
					$this->view->settings = $settings;
					$this->view->syncReport = $syncReport;
					$this->view->restaurantid = $request->restaurantid;
				}else{
					$this->_redirect('login','Auth','Ums');
				}
			}
				
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function synccontactsAction()
	{
		$request = $this->getRequest();
		try{
		$this->_helper->layout->disableLayout();
		$this->_helper->viewRenderer->setNoRender();
			$auth = Zend_Auth::getInstance();	
			if($auth->hasIdentity()){				
								
				$this->_restaurantService->SyncContactsToConstContact($request);
				$this->_helper->redirector('manageconstconatctsettings','Restaurant', 'ManageRestaurant',array('restaurantid' => $request->restaurantid));
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
			$this->_helper->redirector('manageconstconatctsettings','Restaurant', 'ManageRestaurant',array('restaurantid' => $request->restaurantid));
		}		
	}
	
	public function verifyconstconatctaccountAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();				
			$result = $this->_restaurantService->VerifyConstContactAccount($request);
			if($result){
				$this->_helper->redirector('manageconstconatctsettings','Restaurant', 'ManageRestaurant',array('restaurantid' => $request->restaurantid));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function configureconstaontactAction()
	{
		try{
			
			$auth = Zend_Auth::getInstance();			
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				if($request->restaurantid){
					$resStat = $this->_restaurantService->AuthenticateRestByAuth($data,$request->restaurantid);
				}else{
					$resStat = false;
				}
				$this->view->secureLoginStatus = $resStat;
				if($resStat){
					$this->_helper->layout()->setLayout('restaurantuserlayout');
					$manageForm = $this->_restaurantService->getManageConstantContactForm();
					
					if($request->isPost()){
						$result = $this->_restaurantService->ManageConstantContactSettings($this->getRequest()->getPost(),$data);
						if($result['status']){						
							$this->_helper->redirector('constaontactconfirm','Restaurant', 'ManageRestaurant',array('restaurantid' => $request->restaurantid));							
						}else{						
							$this->view->manageForm = $result['form'];
						}
					}else{
						$this->view->manageForm = $manageForm;					
					}
					
					$this->view->restaurantid = $request->restaurantid;
				}
				
			}else{
				$this->_redirect('login','Auth','Ums');
			}
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function constaontactconfirmAction()
	{
		try{
			$this->_helper->layout()->setLayout('restaurantuserlayout');
			$auth = Zend_Auth::getInstance();	
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$this->view->restaurantid = $request->restaurantid;
			}else{
				$this->_redirect('login','Auth','Ums');
			}
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getsourcelistAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$resultObj = $this->_restaurantService->getSourcelist($request);
			$jsonObj = json_encode($resultObj);
			echo $jsonObj;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function managewidgetthemesAction()
	{
		try{
			
			$auth = Zend_Auth::getInstance();
			$request = $this->getRequest();		
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				if($request->restaurantid){
					$resStat = $this->_restaurantService->AuthenticateRestByAuth($data,$request->restaurantid);
				}else{
					$resStat = true;
				}
				$this->view->secureLoginStatus = $resStat;
				// getting company id based on restaurant owner id if usertype is ureserv admin
				$userType = $data['Usertype'];
				if($userType =='ADM' || $userType == 'ADU'){
					$restownerid = $data['restownerId'];
					$companyid = $this->_restaurantService->restaurantCompanyDetailsByUserId($restownerid);
			        $this->view->companyid = $companyid['rso_companyid'];
				} else {
					  $this->view->companyid = $data['companyid'];
				}
				
				if($resStat){
					$this->_helper->layout()->setLayout('restaurantuserlayout');
					$restNameList = "";
					if($data['Usertype'] == "RSO" || $data['Usertype'] == "ADM" || $data['Usertype'] == "ADU"){
						$restNameList = $this->_restaurantService->GetRestNameById($data);
					}else if($data['Usertype'] == "RSU"){
						$restNameList = $this->_restaurantService->GetRestNameById($data);
					}
					
					$this->view->restNames = $restNameList;
					if($request->restaurantid){
						$this->view->restaurantid = $request->restaurantid;
					}
				}
			}else{
				$this->_redirect('login','Auth','Ums');
			}	
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}		
	}
	
	public function getwidgetthemeAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			
			$theme = $this->_restaurantService->GetWidgetThemeByRestId($request);
			if($theme){
				echo json_encode($theme);
			}else{
				echo json_encode('f');
			}			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function savewidgetthemeAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$status = $this->_restaurantService->ManageWidgetTheme($request);
			if($status){
				echo json_encode('t');
			}else{
				echo json_encode('f');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}	
	}
 
	//restaurant setting Action
	public function settingsAction(){
		try{
			
			$auth = Zend_Auth::getInstance();
			$request = $this->getRequest();		
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				if($request->restaurantid)
				{
					$resStat = $this->_restaurantService->AuthenticateRestByAuth($data,$request->restaurantid);
				}else{
					$resStat = false;
				}
				$this->view->secureLoginStatus = $resStat;
				/**
			  *  retrieving companyid and usertype values from session *
			  *  */	
				$this->view->companyid = $data['companyid'];
				$this->view->usertype = $data['Usertype'];
				if($resStat){
					$this->_helper->layout()->setLayout('restaurantuserlayout');
					$result = $this->_restaurantService->getRestaurantMealType($request);
					$this->view->mealType = $result['mealType'];
					
					//schedule setting type base data
					$result1 = $this->_restaurantService->getschedulesetting();
					$this->view->schedulestatus = $result1;
					
					if(isset($result['mealCount'])){
						$this->view->mealCount = $result['mealCount'];
					}
					$this->view->restaurantid = $request->restaurantid;
					$this->view->returnAction = $request->returnAction;
				}
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){ 
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getmaxandminpartysizebyresidAction(){
		try{
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$auth = Zend_Auth::getInstance();
				$request = $this->getRequest();		
//				$resid = $request->restid;
				$result = $this->_restaurantService->getMaxandMinPartySize($request);
//				$resultset = array('min'=>$result->resminpax,'max'=>$result->resmaxpax);
				$jsonObj = json_encode($result);
				echo $jsonObj;				
			
		}catch (Exception $ex){ 
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function editpartysizeAction(){
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$auth = Zend_Auth::getInstance();
			$request = $this->getRequest();		
			if($request->isPost()){
				$result = $this->_restaurantService->editPartySize($request);
				if($result){
						$this->_helper->redirector('settings','Restaurant', 'ManageRestaurant',array('restaurantid' => $request->restid,'returnAction'=>$request->returnAction));	
				}		
			}
		}catch (Exception $ex){ 
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getdaypartysizeAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_restaurantService->getDayPartySize($request);
				if($result){
					echo json_encode($result);
				}else{
					echo json_encode('f');
				}
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function gettextripplekeysAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
//				echo json_encode($request);die();
				$result = $this->_restaurantService->getTextRippleKeys($request);
				if($result){
					echo json_encode($result[0]);
				}else{
					echo json_encode('f');
				}
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function updatetextrippleAction() {
	        try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_restaurantService->setTextRippleKeys($request);
				if($result){
					echo json_encode($result);
				}else{
					echo json_encode('f');
				}
	            }else{
                	    $this->_redirect('login','Auth','Ums');
        	    }
	        }catch (Exception $ex){
        	        throw new Exception($ex->getMessage()) ;
	        }
	}
	
	public function updatepartysizerangeajaxAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_restaurantService->updatePartySizeRange($request);
				if($result){
					echo 't';
				}else{
					echo 'f';
				}
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getspecialsettingAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_restaurantService->getSpecialSetting($request);
				if($result){
					echo json_encode($result->resspecialsetting);
				}else{
					echo json_encode('f');
				}
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function updatespecialsettingajaxAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_restaurantService->updateSpecialSetting($request);
				if($result){
					echo 't';
				}else{
					echo 'f';
				}
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getspecialsettingwidgetAction()
	{
		try{
				$storage = new Zend_Auth_Storage_Session();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_restaurantService->getSpecialSetting($request);
				if($result){
					echo json_encode($result->resspecialsetting);
				}else{
					echo json_encode('f');
				}
			}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getspecialrequestsettingAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_restaurantService->getSpecialRequestSetting($request);
				if($result){
					echo json_encode($result->resspecial_request);
				}else{
					echo json_encode('f');
				}
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function updatespecialrequestsettingajaxAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_restaurantService->updateSpecialRequestSetting($request);
				if($result){
					echo 't';
				}else{
					echo 'f';
				}
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getspecialrequestsettingwidgetAction()
	{
		try{
				$storage = new Zend_Auth_Storage_Session();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_restaurantService->getSpecialRequestSetting($request);
				if($result){
					echo json_encode($result->resspecial_request);
				}else{
					echo json_encode('f');
				}
			}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function viewfbpageidAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			$request = $this->getRequest();		
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->view->pageid = $request->pageid;
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){ 
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function confingfbpageidAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			$request = $this->getRequest();		
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				if($data['Usertype'] == "RSO"){
					$restNameList = $this->_restaurantService->GetRestNameById($data);
				}else if($data['Usertype'] == "RSU"){
					$restNameList = $this->_restaurantService->GetRestNameById($data);
				}
				if($request->restid){				
					$result = $this->_restaurantService->addfbpageidbyrestid($request);
					if($result){
						header( 'Location: http://www.facebook.com/'.$request->appid) ;
					}
				}
				$this->view->restNames = $restNameList;
				$this->view->pageid = $request->pageid;
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){ 
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function updatebookingoptionssettingajaxAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_restaurantService->updateBookingOptionsSetting($request);
				if($result){
					echo 't';
				}else{
					echo 'f';
				}
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function addnotifcationcontentAction()
	{
		try{
			$this->_helper->layout()->setLayout('restaurantuserlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();		
				if($request->isPost()){
					$notfsrvice = new Application_Service_Notification();
					$result = $notfsrvice->AddNotifcationContent($request,$data);
					if($result){
						$this->_helper->redirector('managenotificationcontent','Restaurant', 'ManageRestaurant',array('restaurantid' => $request->restaurantid));
					}
				}
				$this->view->restaurantid = $request->restaurantid;
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function managenotificationcontentAction()
	{
		try{
			$this->_helper->layout()->setLayout('restaurantuserlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();	
				
				$notfsrvice = new Application_Service_Notification();
				$result = $notfsrvice->getNotificationContentByResid($request);
				if($result){
					$this->view->result = $result;
					//$template = $notfsrvice->getEmailTemplatewithNotificationContent($request->restaurantid);
					//$this->view->template = $template;
					$resDataMapper = new ManageRestaurant_Model_RestaurantDataMapper();
					$restObj= new ManageRestaurant_Model_RestaurantById();
					$restObj->setRestaurantId($request->restaurantid);
					$resDetails = $resDataMapper->getRestaurantById($restObj);	
					$this->view->resDetails = $resDetails;
				}
				$this->view->restaurantid = $request->restaurantid;
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function changenotifcationcontentstatusAction()
	{
		try{
			$this->_helper->layout()->setLayout('restaurantuserlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();	
				
				$notfsrvice = new Application_Service_Notification();
				$result = $notfsrvice->ChangeNotificationContentStatus($request, $data);
				$this->_helper->redirector('managenotificationcontent','Restaurant', 'ManageRestaurant',array('restaurantid' => $request->restaurantid));
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function editnotifcationcontentAction()
	{
		try{
			$this->_helper->layout()->setLayout('restaurantuserlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				$notfsrvice = new Application_Service_Notification();		
				if($request->isPost()){
					$result = $notfsrvice->UpdateNotifcationContent($request,$data);
					if($result){
						$this->_helper->redirector('managenotificationcontent','Restaurant', 'ManageRestaurant',array('restaurantid' => $request->restaurantid));
					}
				}
				$result = $notfsrvice->getNotificationContentByResid($request);
				$this->view->result = $result;
				$this->view->restaurantid = $request->restaurantid;
				$this->view->id = $request->id;
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function checkstateAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$result = array();
			$statemapper = new Application_Model_StateDataMapper();
			
			if($request->setstate == 1){
				$stateid = $this->_restaurantService->addCantFindState($request);
				$result['stateid'] = $stateid;
			}else{
				if($request->statedescription){
					$result['description']	= $statemapper->verifyDesc($request->statedescription,0);
				}
				if($request->statecode){
					$result['code']			=  $statemapper->verifyCode($request->statecode,0);
				}
			}
			
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function checkregionAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$regionmapper = new Application_Model_RegionDataMapper();
			
			if($request->stateid){
				$regionid = $this->_restaurantService->addCantFindRegion($request);
				$result['regionid'] = $regionid;
			}else{
				if($request->regiondescription){
				$result['description']	= $regionmapper->verifyDesc($request->regiondescription,0);
				}
				if($request->regioncode){
				$result['code']			=  $regionmapper->verifyCode($request->regioncode,0);
				}
			}
			
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function addrestaurantscheduleAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				
				if($request->restaurantid){
					$resStat = $this->_restaurantService->AuthenticateRestByAuth($data,$request->restaurantid);
					$result = $this->_restaurantService->managescheduleSetting($request);
				    $this->view->schedulestatus1 = $result->code;
					$setresult1=$this->_restaurantService->getschedulesetting();
					$this->view->schedulestatus=$setresult1;			
				}else{
					$resStat = true;
				}
				
				$this->view->secureLoginStatus = $resStat;
				if($resStat){
					$this->_helper->layout()->setLayout('restaurantuserlayout');
					if($request->restaurantid){
						$result = $this->_restaurantService->GetRestaurantSchedule($request);
						$this->view->inventory    = $result['inventory'];
						$this->view->restaurantid = $request->restaurantid;
						$this->view->resIsset	= $result['resIsset'];
						if($this->getRequest()->isPost()){
							$result = $this->_restaurantService->AddRestaurantSchedule($this->getRequest()->getPost(),$data);
							if($result){
								$this->view->status = $result['status'];
								return $this->_helper->redirector('restaurantschedule','Restaurant','ManageRestaurant',array('restaurantid'=>$request->restaurantid));
							}else{
								$this->view->status = 'err';
							}
						}
						$AllSchDay = $this->_restaurantService->GetRestaurantAllEmptyDayScheudle($request);
						$this->view->AllSchDay = $AllSchDay['notset'];
						
					}
					$this->view->restaurantid = $request->restaurantid;
					
					$result = $this->_restaurantService->RestaurantSchedule($data);
					$this->view->resform = $result['form'];
					$this->view->userStat = $data['Usertype'];
				}
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function addrestaurantulscheduleAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				
				if($request->restaurantid){
					$resStat = $this->_restaurantService->AuthenticateRestByAuth($data,$request->restaurantid);
				}else{
					$resStat = true;
				}
				
				$this->view->secureLoginStatus = $resStat;
				if($resStat){
					$this->_helper->layout()->setLayout('restaurantuserlayout');
					if($request->restaurantid){
						$result = $this->_restaurantService->GetRestaurantULSchedule($request);
						$this->view->restaurantid = $request->restaurantid;
						$this->view->resIsset	= $result['resIsset'];
						if($this->getRequest()->isPost()){
							$result = $this->_restaurantService->AddRestaurantULSchedule($this->getRequest()->getPost(),$data);
							if($result){
								$this->view->status = $result['status'];
								return $this->_helper->redirector('restaurantulschedule','Restaurant','ManageRestaurant',array('restaurantid'=>$request->restaurantid));
							}else{
								$this->view->status = 'err';
							}
						}
						$AllSchDay = $this->_restaurantService->GetRestaurantAllEmptyDayULScheudle($request);
						$this->view->AllSchDay = $AllSchDay['notset'];
						//schedule settings
						$result2 = $this->_restaurantService->managescheduleSetting($request);
						$this->view->schedulestatus1 = $result2->code;
						$setresult1=$this->_restaurantService->getschedulesetting();
						$this->view->schedulestatus=$setresult1;
					}
					$this->view->restaurantid = $request->restaurantid;
					
					$result = $this->_restaurantService->RestaurantSchedule($data);
					$this->view->resform = $result['form'];
					$this->view->userStat = $data['Usertype'];
				}
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function addrestaurantsmcscheduleAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				
				if($request->restaurantid){
					$resStat = $this->_restaurantService->AuthenticateRestByAuth($data,$request->restaurantid);
				}else{
					$resStat = true;
				}
				
				$this->view->secureLoginStatus = $resStat;
				if($resStat){
					$this->_helper->layout()->setLayout('restaurantuserlayout');
					if($request->restaurantid){
						$result = $this->_restaurantService->GetRestaurantSMCSchedule($request);
						$this->view->restaurantid = $request->restaurantid;
						$this->view->resIsset	= $result['resIsset'];
						if($this->getRequest()->isPost()){
							$result = $this->_restaurantService->AddRestaurantSMCSchedule($this->getRequest()->getPost(),$data);
							if($result){
								$this->view->status = $result['status'];
								return $this->_helper->redirector('restaurantsmcschedule','Restaurant','ManageRestaurant',array('restaurantid'=>$request->restaurantid));
							}else{
								$this->view->status = 'err';
							}
						}
						$AllSchDay = $this->_restaurantService->GetRestaurantAllEmptyDaySMCScheudle($request);
						$this->view->AllSchDay = $AllSchDay['notset'];
						//schedule settings
						$result2 = $this->_restaurantService->managescheduleSetting($request);
						$this->view->schedulestatus1 = $result2->code;
						$setresult1=$this->_restaurantService->getschedulesetting();
						$this->view->schedulestatus=$setresult1;
						
					}
					$this->view->restaurantid = $request->restaurantid;
					
					$result = $this->_restaurantService->RestaurantSchedule($data);
					$this->view->resform = $result['form'];
					$this->view->userStat = $data['Usertype'];
				}
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function managerestaurantscheduleupdateAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$result = $this->_restaurantService->ManageRestaurantScheduleUpdate($this->getRequest()->getPost(),$data);
				return $this->_helper->redirector('restaurantschedule','Restaurant','ManageRestaurant',array('restaurantid'=>$request->selActionRes));
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function managerestaurantulscheduleupdateAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$result = $this->_restaurantService->ManageRestaurantULScheduleUpdate($this->getRequest()->getPost(),$data);
				return $this->_helper->redirector('restaurantulschedule','Restaurant','ManageRestaurant',array('restaurantid'=>$request->selActionRes));
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function managerestaurantsmcscheduleupdateAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$result = $this->_restaurantService->ManageRestaurantSMCScheduleUpdate($this->getRequest()->getPost(),$data);
				return $this->_helper->redirector('restaurantsmcschedule','Restaurant','ManageRestaurant',array('restaurantid'=>$request->selActionRes));
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function managerestaurantscheduleupdatecompAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$result = $this->_restaurantService->ManageRestaurantScheduleUpdateComp($this->getRequest()->getPost(),$data);
				return $this->_helper->redirector('restaurantschedule','Restaurant','ManageRestaurant',array('restaurantid'=>$request->selActionResComp));
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function managerestaurantulscheduleupdatecompAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$result = $this->_restaurantService->ManageRestaurantULScheduleUpdateComp($this->getRequest()->getPost(),$data);
				return $this->_helper->redirector('restaurantulschedule','Restaurant','ManageRestaurant',array('restaurantid'=>$request->selActionResComp));
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function managerestaurantsmcscheduleupdatecompAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$result = $this->_restaurantService->ManageRestaurantSMCScheduleUpdateComp($this->getRequest()->getPost(),$data);
				return $this->_helper->redirector('restaurantsmcschedule','Restaurant','ManageRestaurant',array('restaurantid'=>$request->selActionResComp));
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function checkcityAction()
	{
		try{
			$request = $this->getRequest();
			$result = array();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$citymapper = new Application_Model_CityDataMapper();
			
			if($request->regionid){
				$cityid = $this->_restaurantService->addCantFindCity($request);
				$result['cityid'] = $cityid;
			}else{
				if($request->citydescription){
				$result['description']	= $citymapper->verifyDesc($request->citydescription,0);
				}
				if($request->citycode){
				$result['code']			=  $citymapper->verifyCode($request->citycode,0);
				}
			}
			
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function checkrestaurantstateAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$result = array();
			$statemapper = new Application_Model_StateDataMapper();
			if($request->setstate == 1){
				$stateid = $this->_restaurantService->addCantFindRestaurantState($request);
				$result['stateid'] = $stateid;
			}else{
				if($request->statedescription){
					$result['description']	= $statemapper->verifyDesc($request->statedescription,0);
				}
				if($request->statecode){
					$result['code']			=  $statemapper->verifyCode($request->statecode,0);
				}
			}
			
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function checkrestaurantregionAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$regionmapper = new Application_Model_RegionDataMapper();
			
			if($request->stateid){
				$regionid = $this->_restaurantService->addCantFindRestaurantRegion($request);
				$result['regionid'] = $regionid;
			}else{
				if($request->regiondescription){
					$result['description']	= $regionmapper->verifyDesc($request->regiondescription,0);
				}
				if($request->regioncode){
					$result['code']			=  $regionmapper->verifyCode($request->regioncode,0);
				} 
			}
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function checkrestaurantcityAction()
	{
		try{
			$request = $this->getRequest();
			$result = array();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$citymapper = new Application_Model_CityDataMapper();
			if($request->regionid){
				$cityid = $this->_restaurantService->addCantFindRestaurantCity($request);
				$result['cityid'] = $cityid;
			}else {
				
				if($request->citydescription){
					$result['description']	= $citymapper->verifyDesc($request->citydescription,0);
				}
				if($request->citycode){
					$result['code']			=  $citymapper->verifyCode($request->citycode,0);
				}
			}
			
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function checkrestaurantneighbourAction()
	{
		try{
			$request = $this->getRequest();
			$result = array();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$neighmapper = new Application_Model_NeighborhoodDataMapper();
			
			if($request->cityid){
				$cityid = $this->_restaurantService->addCantFindRestaurantNeighbour($request);
				$result['neighbourid'] = $cityid;
			}else if($request->neighdescription){
				$result['description']	= $neighmapper->verifyDesc($request->neighdescription,0);
			}
			
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function addscheduleajaxAction()
	{
		try{
			$request = $this->getRequest();
			$result = array();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$result = $this->_restaurantService->AddScheduleAjax($request);
			if($result){
				echo $result;
			}else{
				echo 'f';
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function addmaxcountajaxAction()
	{
		try{
			$request = $this->getRequest();
			$result = array();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$result = $this->_restaurantService->AddMaxCountAjax($request);
			if($result){
				echo $result;
			}else{
				echo 'f';
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function addscheduleinventoryajaxAction()
	{
		try{
			$request = $this->getRequest();
			$result = array();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$result = $this->_restaurantService->AddScheduleInventoryAjax($request);
			if($result){
				echo json_encode($result);
			}else{
				echo 'f';
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function quickfloorplanAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$result = $this->_restaurantService->ManageQuickFloorPlan($request);
			if($result){
				echo 't';
			}else{
				echo 'f';
			}
				
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}

	public function getrestaurantresvtimesettingAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_restaurantService->getRestaurantResvTimeSetting($request->resid);
			if($result){
				echo json_encode($result);
			}else{
				echo json_encode("f");
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function saverestresvtimesettingsAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_restaurantService->saveRestaurantResvTimeSetting($request);
			if($result){
				echo json_encode($result);
			}else{
				echo json_encode("f");
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}	
	
		
	//Restaurant Schedule Setting action
	
	
	public function getschedulesettingAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_restaurantService->managescheduleSetting($request);
				if($result){
					if($result == 'SPL'){
						echo 'SL';
					}else{
						echo $result->code;
					}
				}else{
					echo 'f';
				}
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function updateschedulesettingajaxAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_restaurantService->updatescheduleSetting($request);
				if($result){
					echo 't';
				}else{
					echo 'f';
				}
			}else{
				$this->_redirect('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to edit  user  contact details by ajaxCall
	 */
	public function usercontactdetailsAction()
    {
    	try{
    		$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
    		if($this->getRequest()->isPost()){
    			$result = $this->_restaurantService->EditUserContactDetails($this->getRequest()->getPost());
    			$jsonObj = json_encode($result);
				echo $jsonObj;
    		}	
    	}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
    }

	 public function getstatesbycountryAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$resultObj = $this->_restaurantService->getStatesByCountryId($request);
			$jsonObj = json_encode($resultObj);
			echo $jsonObj;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	} 

	public function getcountrycodenumberbycountryidAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$result = $this->_restaurantService->getCountryCodeNumberbyCountryid($request);
			if($result){
				echo json_encode($result);
			}else{
				echo json_encode("f");
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getcountrycodenumbersAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$result = $this->_restaurantService->getCountryCodeNumbers($request);
			if($result){
				echo json_encode($result);
			}else{
				echo json_encode("f");
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

//* This action is for updating restaurant name from admin manage restaurant dashboard *// Faiz //	
	public function updaterestaurantnameAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$result = $this->_restaurantService->updaterestaurantname($request);
			if($result){
				echo json_encode($result);
			}else{
				echo json_encode("f");
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}	
}
