<?php
class ManageRestaurant_Form_AddUserContact extends Zend_Form
{

	public function init()
    {
		$this->setAttrib('enctype', 'multipart/form-data');
		
		$gengerList   = array(
    	 		array('key'=>'Male','value'=>'Male'),
    	 		array('key'=>'Female','value'=>'Female')    	 
    	 );
    	 
    	$countryMapper  = new Application_Model_CountryDataMapper();
        $countries = $countryMapper->fetchAll();
        $countryCodeNumberList = array(); 
        foreach($countries as $country){
    		if ($country->getcountry_id() != 2) {
				$countryCodeNumberList[] = array('key'=>$country->getcountry_id(),'value'=>$country->getCountry_codenumber());
    		} 
        } 
    	 
    	$stateMapper  = new Application_Model_StateDataMapper();
    	$states = $stateMapper->fetchAll();
    	$stateList = array();  
    	$stateList[] = array('key'=>'','value'=>'Select State');  	   
    	foreach($states as $state){
    		$stateList[] = array('key'=>$state->getId(),'value'=>$state->getDescription());
    	} 
    	 
    	$userid = $this->createElement('hidden','userid');
    	$id = $this->createElement('hidden','addcontact');
    	$id->removeDecorator('Label')
         		 ->removeDecorator('HtmlTag')
         		 ->setValue('addcontact');
         		    
    	
		$restNameCtl = $this->createElement('select','RestaurantName');
        $restNameCtl->removeDecorator('Label')
         		    ->removeDecorator('HtmlTag')
         		    ->setAttrib('class','sel1 drpDown')
         		    ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select RestaurantName.'))))
         		    ->setRegisterInArrayValidator(false)
         		    ->setRequired(true);
         		    
        $groupName = $this->createElement('select','GroupName');
        $groupName->removeDecorator('Label')
         		  ->removeDecorator('HtmlTag')
        		  ->setAttrib('class','sel1 drpDown')
         		  ->addValidators(array
        		 				(array('NotEmpty', true, array('messages' => 'Please select GroupName.'))))
         		  ->setRegisterInArrayValidator(false)
         		  ->setRequired(true);
         		  
       	$firstName =  $this->createElement('text', 'firstName');
        $firstName->removeDecorator('Label')
        		  ->removeDecorator('HtmlTag')        		
        		  ->setAttrib('maxlength', '30')
        		  ->setAttrib('class','inp1')
        		  ->addFilters(array('StringTrim'))
                  ->addValidators(array
                				(array('NotEmpty', true, array('messages' => 'Please enter your FirstName.')),
                					array('StringLength', false,array(0,30)),array('Alnum')))                					 
                  ->setValue('')
                  ->setRequired(true);
        
        $lastName = $this->createElement('text', 'lastName');
        $lastName->removeDecorator('Label')
        		 ->removeDecorator('HtmlTag')
        		 ->setAttrib('maxlength', '30')
        		 ->setAttrib('class','inp1')
        		 ->addFilters(array('StringTrim'))
        		 ->addValidators(array
                				(array('NotEmpty', true, array('messages' => 'Please enter your LastName.')),
                					array('StringLength', false,array(0,30)),array('Alnum')))
                 ->setValue('')
                 ->setRequired(true); 
                 
        $gender = $this->createElement('select','gender');
        $gender->removeDecorator('Label') 
        	   ->removeDecorator('HtmlTag')
        	   ->setAttrib('class', 'sel2')       		
               ->addMultiOptions($gengerList)
               ->setRequired(false);
        
        $email =  $this->createElement('text', 'emailAddress');
        $email->removeDecorator('Label')
        	  ->removeDecorator('HtmlTag')        			     
        	  ->setAttrib('maxlength', '50')
        	  ->setAttrib('class','inp1 email')
              ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter your Email Address.')),
                		 				array('StringLength', false,array(5,255))))
              ->addFilters(array('StringTrim'))
              ->addValidator('EmailAddress',false,array('messages'=>array(Zend_Validate_EmailAddress::INVALID =>'Please enter a valid Host Name')))
			 ->addErrorMessage('Pleaes Enter Valid Email Address')
              ->setRequired(false);
                      
        $phone = $this->createElement('text', 'phone');
        $phone->removeDecorator('Label')
        	  ->removeDecorator('HtmlTag')
              ->setAttrib('class','inp1 usformat')              
              ->setAttrib('maxlength', '12')
              ->setAttrib('style','width:96px !important;')
              ->addFilters(array('StringTrim'))
              ->addValidators(array
                   					(array('NotEmpty', true, array('messages' => 'Please enter Your Phone Number.'))
                   				 ))
              ->setValue('')              
              ->setRequired(false);
              
        /*$mobile = $this->createElement('text','mobile');
        $mobile->removeDecorator('Label')
        	  ->removeDecorator('HtmlTag')
              ->setAttrib('class','inp1')              
              ->setAttrib('maxlength', '15')
              ->addFilters(array('StringTrim'))
              ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter your Mobile Number.')),
              				array('StringLength', false,array(0,15,'messages' => array(
              				Zend_Validate_StringLength::TOO_SHORT =>'mobile should be minimum 10 charactors',
              				Zend_Validate_StringLength::TOO_LONG => 'mobile is too long(>15).'
              				))))) 
              ->setValue('')              
              ->setRequired(true);*/
              
        $state = $this->createElement('select','state');
        $state->removeDecorator('Label') 
         		  ->removeDecorator('HtmlTag')
         		  ->setAttrib('class','sel1 drpDown')
         		  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select State.'))))       	   
               	  ->addMultiOptions($stateList)
                  ->setRequired(false);

        $region = $this->createElement('select', 'region');
        $region->removeDecorator('Label')
         	 ->removeDecorator('HtmlTag')
         	 ->setAttrib('class','sel1 drpDown')
         	 ->setRegisterInArrayValidator(false)
         	 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select Region.'))))       	     
             ->setRequired(false);
             
        $city = $this->createElement('select', 'city');
        $city->removeDecorator('Label')
         	 ->removeDecorator('HtmlTag')
         	 ->setAttrib('class','sel1 drpDown')
         	 ->setRegisterInArrayValidator(false)
         	 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select City.'))))       	     
             ->setRequired(false);
             
        $neighbourhood = $this->createElement('select', 'neighbourhood');
        $neighbourhood->removeDecorator('Label')
         			  ->setAttrib('class','sel1 drpDown')
         		 	  ->removeDecorator('HtmlTag')
         		 	  ->setRegisterInArrayValidator(false)
         		 	  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select Neighbourhood.'))))        	          
                 	  ->setRequired(false);
              
        $zipCode = $this->createElement('text', 'zipCode');
        $zipCode->removeDecorator('Label')  
         		   ->removeDecorator('HtmlTag')      		       
        		   ->setAttrib('class','inp1')
        		   ->addFilters(array('StringTrim'))
        		   ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Zip Code.'))))    
                   ->addValidator('StringLength', false,array(1,10))
                   ->setValue('')
                   ->setAttrib('maxlength', '10')
                   ->setRequired(false);  
             
        $address =  $this->createElement('textarea', 'address');
        $address->removeDecorator('Label')
        		->removeDecorator('HtmlTag')
        		->setAttrib('maxlength', '200')
        		->setAttrib('cols', '40')
			    ->setAttrib('rows', '4')
			    ->setAttrib('class','inp1')
			    ->addFilters(array('StringTrim'))              
                ->setRequired(false);
                
      	$guestnotes = $this->createElement('textarea', 'guestnotes');
        $guestnotes->removeDecorator('Label')
        			   ->removeDecorator('HtmlTag')
        			   ->setAttrib('maxlength', '500')
        			   ->setAttrib('cols', '40')
        			   ->setAttrib('rows', '4')        			   
        			   ->setAttrib('class','inp1')
        			   ->setRequired(false)
        			   ->addFilters(array('StringTrim'));
		$birthday = $this->createElement('text','birthday');
    	$birthday->removeDecorator('HtmlTag')
    			 ->setAttrib('class','datepicker2')
    			 ->setAttrib('readonly','readonly')
    			 ->setAttrib('style','width:100px;')
    			 ->addFilters(array('StringTrim'))
    		     ->removeDecorator('Label')
    		     ->setRequired(false);
    		     
    	$anniversary = $this->createElement('text', 'anniversary');
        $anniversary->removeDecorator('Label')  
         		   ->removeDecorator('HtmlTag')      		       
        		   ->setAttrib('class','datepicker')
    			   ->setAttrib('readonly','readonly')
    			   ->setAttrib('style','width:100px;')
    			   ->addFilters(array('StringTrim'))
                   ->setRequired(false);
                   
        $optinemail = $this->createElement('checkbox','optinemail');
       	$optinemail->removeDecorator('Label')
			       ->removeDecorator('HtmlTag')
			       ->setAttrib('class','addcontact')
			       ->setRequired(false)
			       ->setChecked(false);
         
        $Submit = $this->createElement('submit','Update');
        $Submit->removeDecorator('Label')
        		   ->removeDecorator('DtDdWrapper')
        		   ->setValue('Submit')           		          		        		
        		   ->setAttrib('class','submitBtn')
                   ->setIgnore(false);
                   
        $countryCodeNumber = $this->createElement('select','countryCodeNumber');
		$countryCodeNumber->removeDecorator('Label') 
         		  ->removeDecorator('HtmlTag')
         		  ->setAttrib('class','sel1 drpDown')
         		  ->setAttrib('style','width:60px !important;')
         		  ->setValue(1)         		  
         		  //->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select Country.'))))       	   
               	  ->addMultiOptions($countryCodeNumberList)
                  ->setRequired(true); 
           
        $this->addElements( array ($userid,
        						   $id,
        						   $restNameCtl,
        						   $groupName,
        						   $firstName,
        						   $lastName,
        						   $gender,
        						   $email,
        						   $phone,
        						   $address,
        						   $state,
        						   $region,
        						   $city,
        						   $neighbourhood,
        						   $zipCode,
        						   $guestnotes,
        						   $birthday,
        						   $anniversary,
        						   $optinemail,
        						   $Submit,
        						   $countryCodeNumber
        				));
    }
}