<?php
class ManageRestaurant_Form_RestaurantHotTable extends Zend_Form
{
	public function init()
	{
		
		$HoursList = array(
    			array('key'=>'01','value'=>'01'),
    			array('key'=>'02','value'=>'02'),
    			array('key'=>'03','value'=>'03'),
    			array('key'=>'04','value'=>'04'),
    			array('key'=>'05','value'=>'05'),
    			array('key'=>'06','value'=>'06'),
    			array('key'=>'07','value'=>'07'),
    			array('key'=>'08','value'=>'08'),
    			array('key'=>'09','value'=>'09'),
    			array('key'=>'10','value'=>'10'),
    			array('key'=>'11','value'=>'11'),
    			array('key'=>'12','value'=>'12')    	
    	);
    	
    	$minutesList= array(
    			array('key'=>'00','value'=>'00'),
    			array('key'=>'05','value'=>'05'),
    			array('key'=>'10','value'=>'10'),
    			array('key'=>'15','value'=>'15'),
    			array('key'=>'20','value'=>'20'),
    			array('key'=>'25','value'=>'25'),
    			array('key'=>'30','value'=>'30'),
    			array('key'=>'35','value'=>'35'),
    			array('key'=>'40','value'=>'40'),
    			array('key'=>'45','value'=>'45'),
    			array('key'=>'50','value'=>'50'),
    			array('key'=>'55','value'=>'55')    	
    	);
    	
    	$meridiemList = array(
    			array('key'=>'AM','value'=>'AM'),
    			array('key'=>'PM','value'=>'PM')
    			);
		
    	$hottableId = $this->createElement('hidden','hottableId');
		
		$restNameCtl = $this->createElement('select','RestaurantName');
        $restNameCtl->removeDecorator('Label')
         		    ->removeDecorator('HtmlTag')
         		    ->setAttrib('class','sel1 drpDown')
         		    ->setRegisterInArrayValidator(false)
         		    ->setRequired(true);
         		    
        $nooftables = $this->createElement('select', 'nooftables');
        $nooftables->removeDecorator('Label')
         		   ->removeDecorator('HtmlTag')
         		   ->setAttrib('class','sel1 drpDown')
         		   ->setRegisterInArrayValidator(false)
         		   ->setRequired(true);
         		   
        $price = $this->createElement('text', 'price');
        $price->removeDecorator('Label')
         	  ->removeDecorator('HtmlTag')
         	  ->setAttrib('class','inp1')
         	  ->addFilters(array('StringTrim'))
    		  ->setValue('')
        	  ->setRequired(false);
        	  
        $hottableStartDate = $this->createElement('text','hottableStartDate');
		$hottableStartDate->removeDecorator('Label')
					  ->removeDecorator('HtmlTag')
					  ->setAttrib('class','inp1 datepicker')
					  ->addFilters(array('StringTrim'))
					  ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select StartDate'))))
					  ->setRequired(true);
					  
		$hottableEndDate = $this->createElement('text','hottableEndDate');
		$hottableEndDate->removeDecorator('Label')
					->removeDecorator('HtmlTag')
					->setAttrib('class','inp1 datepicker2')
					->addFilters(array('StringTrim'))
					->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select EndDate.'))))
					->setRequired(true);
					
		$hottableStartHoursTime = $this->createElement('select', 'hottableStartHoursTime');
		$hottableStartHoursTime->removeDecorator('Label')
					  	   ->removeDecorator('HtmlTag')
					  	   ->removeDecorator('DtDdWrapper')
					  	   ->addMultiOptions($HoursList)
					  	   ->setRequired(false);

		$hottableStartMinutesTime = $this->createElement('select', 'hottableStartMinutesTime');
		$hottableStartMinutesTime->removeDecorator('Label')
					  		 ->removeDecorator('HtmlTag')
					  		 ->removeDecorator('DtDdWrapper')
					  		 ->addMultiOptions($minutesList)
					  		 ->setRequired(false);
					 
		$hottableStartMeridiem = $this->createElement('select', 'hottableStartMeridiem');
		$hottableStartMeridiem->removeDecorator('Label')
					  	  ->removeDecorator('HtmlTag')
					  	  ->removeDecorator('DtDdWrapper')
					  	  ->addMultiOptions($meridiemList)
					  	  ->setRequired(false);
					  	  
		$hottableEndHoursTime = $this->createElement('select', 'hottableEndHoursTime');
		$hottableEndHoursTime->removeDecorator('Label')
					  	   ->removeDecorator('HtmlTag')
					  	   ->removeDecorator('DtDdWrapper')
					  	   ->addMultiOptions($HoursList)
					  	   ->setRequired(false);

		$hottableEndMinutesTime = $this->createElement('select', 'hottableEndMinutesTime');
		$hottableEndMinutesTime->removeDecorator('Label')
					  		 ->removeDecorator('HtmlTag')
					  		 ->removeDecorator('DtDdWrapper')
					  		 ->addMultiOptions($minutesList)
					  		 ->setRequired(false);
					 
		$hottableEndMeridiem = $this->createElement('select', 'hottableEndMeridiem');
		$hottableEndMeridiem->removeDecorator('Label')
					  	  ->removeDecorator('HtmlTag')
					  	  ->removeDecorator('DtDdWrapper')
					  	  ->addMultiOptions($meridiemList)
					  	  ->setRequired(false);
					
		$hottableRecurrence = $this->createElement('checkBox','hottableRecurrence');
		$hottableRecurrence->removeDecorator('Label')
			          ->removeDecorator('HtmlTag')
			          ->setAttrib('class','chk1 recChk')
			          ->setRequired(false)
			          ->setChecked(false);			  	

		$weeks = new Zend_Form_Element_MultiCheckbox('weeks', array(
						'multiOptions' => array(
							'01' => 'SUN',
							'02' => 'MON',
							'03' => 'TUE',
							'04' => 'WED',
							'05' => 'THU',
							'06' => 'FRI',
							'07' => 'SAT'
						 )
				));
		$weeks->removeDecorator('Label')
			   ->removeDecorator('HtmlTag',array('tag' => 'Br'))
			   ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select hottableDay'))))			  
			   ->setRequired(true);
			   
		$hottableDescription = $this->createElement('textArea', 'hottableDescription');
		$hottableDescription->removeDecorator('Label')
						->removeDecorator('HtmlTag')                	   
                	    ->setAttrib('maxlength', '10000')
                	    ->setValue('')              
                	    ->setAttrib('cols', '40')
			            ->setAttrib('rows', '4')
			            ->addFilters(array('StringTrim'))
			            ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter hottableTableDescription.')),
			           			array('StringLength', false,array(1,10000,'messages' => array(
              					Zend_Validate_StringLength::TOO_LONG => 'Description is too long(>10000).'
              				)))))
			            ->setRequired(false);
			            
		$hottableSubmit = $this->createElement('submit','Submit');
        $hottableSubmit->removeDecorator('Label')
        		   ->removeDecorator('DtDdWrapper')
        		   ->setValue('Submit')           		          		        		
        		   ->setAttrib('class','submitBtn')
                   ->setIgnore(true);

		$hottableReset = $this->createElement('reset','Reset');
        $hottableReset->removeDecorator('Label')        		 
        		  ->setValue('Reset')
        		  ->removeDecorator('DtDdWrapper')           	  	 
        	  	  ->setAttrib('class','submitBtn')
              	  ->setIgnore(true);
        
         $this->addElements( array ($hottableId,
         							$restNameCtl,
         							$nooftables,
         							$price,
         							$hottableStartDate,
         							$hottableEndDate,
         							$hottableStartHoursTime,
         							$hottableStartMinutesTime,
         							$hottableStartMeridiem,
         							$hottableEndHoursTime,
         							$hottableEndMinutesTime,
         							$hottableEndMeridiem,
         							$hottableRecurrence,
         							$weeks,
         							$hottableDescription,
         							$hottableSubmit,
         							$hottableReset
         					));
	}
}