<?php
class ManageRestaurant_Form_RestaurantSpecial extends Zend_Form
{
	public function init()
	{
		$specialsCountMapper = new Application_Model_SpecialCountTypeDataMapper();
    	$specialsCount = $specialsCountMapper->fetchAll();
    	$specialscountlist = array();
    	foreach($specialsCount as $specialcount){
    		$specialscountlist[] = array('key'=>$specialcount->getId(),'value'=>$specialcount->getDescription());
    	}
    				   			
	   	$specialsMapper  = new Application_Model_SpecialTypeDataMapper();
    	$specials = $specialsMapper->fetchAll();
    	$specialsList = array(); 
    	$specialsList[] = array('key'=>'','value'=>'Select special');   	   
    	foreach($specials as $special){
    		$specialsList[] = array('key'=>$special->getId(),'value'=>$special->getDescription());
    	}

		$specialsCatMapper  = new Application_Model_SpecialCategoryDataMapper();
    	$specialsCat = $specialsCatMapper->fetchAll();

    	$specialsCatList = array(); 
    	$specialsCatList[] = array('key'=>'','value'=>'Select special');   	   
    	foreach($specialsCat as $specialCat){
    		$specialsCatList[] = array('key'=>$specialCat->getId(),'value'=>$specialCat->getDescription());

    	}
    	 
		$splId = $this->createElement('hidden','specialid');
    	 
    	$restNameCtl = $this->createElement('select','RestaurantName');
        $restNameCtl->removeDecorator('Label')
         		    ->removeDecorator('HtmlTag')
         		    ->setAttrib('class','sel1 drpDown')
         		    ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select RestaurantName.'))))
         		    ->setRegisterInArrayValidator(false)
         		    ->setRequired(true);
         		    
        $specialType = $this->createElement('select','specialType');
        $specialType->removeDecorator('Label')
        	  		->removeDecorator('HtmlTag') 
        	  		->setAttrib('class', 'sel1')       	   
             		->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select SpecialType.'))))
        	  		->addMultiOptions($specialsList)
              		->setRequired(true);
              		
        $specialCatType = $this->createElement('select','specialCatType');
        $specialCatType->removeDecorator('Label')
	        	  		->removeDecorator('HtmlTag') 
	        	  		->setAttrib('class', 'sel1')       	   
	             		->addValidators(array
	        		 				  (array('NotEmpty', true, array('messages' => 'Please select Special Category Type.'))))
	        	  		->addMultiOptions($specialsCatList)
	              		->setRequired(true);
         		    
	    $specialCount = $this->createElement('select','specialCount');
        $specialCount->removeDecorator('Label')
        	  		->removeDecorator('HtmlTag') 
        	  		->setAttrib('class', 'sel1')       	   
             		->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select SpecialType.'))))
        	  		->addMultiOptions($specialscountlist)
              		->setRequired(true);
              		
        $NumOfDishes = $this->createElement('text','NumOfdishes');
        $NumOfDishes->removeDecorator('Label')
        			->removeDecorator('HtmlTag')
        			->setAttrib('class','inp1')
        			->addFilters(array('StringTrim'))
        			->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please Enter Number of Dishes'))))
        			->setRequired(true);
                 	
        $specialTitle = $this->createElement('text','specialTitle');
        $specialTitle->removeDecorator('Label')
    			  	 ->removeDecorator('HtmlTag')
    			  	 ->setAttrib('maxlength', '100')
    			  	 ->setAttrib('class','inp1')
    			  	 ->addFilters(array('StringTrim'))
    			  	 ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please Enter SpecialTitle'))))
    			  	 ->setValue('')
        		  	 ->setRequired(true);

       	$specialImage = $this->createElement('file','specialImage');
		$specialImage->removeDecorator('Label')
			     	 ->removeDecorator('HtmlTag')
			     	 ->setAttrib('class','inp1')			     
			     	 ->setRequired(false)
			     	 ->addValidator('FilesSize', false, array('min' => '1kB', 'max' => '100kB'))
			     	 ->addValidator('Extension', false, 'jpg,png,gif');
			      	 
		$foodType = $this->createElement('select', 'foodtype');
		$foodType->removeDecorator('Label')
				 ->removeDecorator('HtmlTag')
				 ->setAttrib('class','sel1 drpDown')
				 ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select FoodType.'))))
				 ->setRegisterInArrayValidator(false)
				 ->setRequired(true);
							 
		$regularPrice = $this->createElement('text','regularPrice');
        $regularPrice->removeDecorator('Label')
    			  	 ->removeDecorator('HtmlTag')
    			  	 ->setAttrib('class','inp1')
    			  	 ->addFilters(array('StringTrim'))
    			  	 ->setValue('')
        		  	 ->setRequired(false);
        		  	 
        $discountPercentage = $this->createElement('text','discountpecentage');
        $discountPercentage->removeDecorator('Label')
					  	   ->removeDecorator('HtmlTag')
					  	   ->removeDecorator('DtDdWrapper')

					  	   ->setRequired(false);
        		  	 
       	$priceWithDiscount = $this->createElement('text','priceWithDiscount');
        $priceWithDiscount->removeDecorator('Label')
    			  	 	  ->removeDecorator('HtmlTag')
    			  	   	  ->setAttrib('class','inp1')
    			  	   	  ->addFilters(array('StringTrim'))
    			  	 	  ->setValue('')
    			  	 	  ->setRequired(false);
        		  	 	  
       	$kidsEatFree = $this->createElement('checkBox','kidsEatFree');
       	$kidsEatFree->removeDecorator('Label')
			        ->removeDecorator('HtmlTag')
			        ->setAttrib('class','kids recChk')
			        ->setRequired(false)
			        ->setChecked(false);	

		$kidsSelection = new Zend_Form_Element_Radio('kidsSelection',array(
							'multiOptions' => array(
							'2 kids free with 1 paying adult' => '2 kids free with 1 paying adult',
							'all kids eat free under the age of 12' => 'all kids eat free under the age of 12'
						 )
					));
		$kidsSelection->removeDecorator('Label')
			   		  ->removeDecorator('HtmlTag',array('tag' => 'Br'))			  
			   		  ->setRequired(false);
        			
        $specialStartDate = $this->createElement('text','specialStartDate');
		$specialStartDate->removeDecorator('Label')
					  ->removeDecorator('HtmlTag')
					  ->setAttrib('class','inp1 datepicker')
					  ->addFilters(array('StringTrim'))
					  ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select StartDate'))))
					  ->setRequired(true);
					  
		$specialEndDate = $this->createElement('text','specialEndDate');
		$specialEndDate->removeDecorator('Label')
					->removeDecorator('HtmlTag')
					->setAttrib('class','inp1 datepicker2')
					->addFilters(array('StringTrim'))
					->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select EndDate.'))))
					->setRequired(true);
					
		$specialStartTime = $this->createElement('text','specialStartTime');
		$specialStartTime->removeDecorator('Label')
						 ->removeDecorator('HtmlTag')
						 ->setAttrib('class','timepicker1')
						 ->addFilters(array('StringTrim'))
						 ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select StartTime.'))))
						 ->setRequired(true);
						 
		$specialEndTime = $this->createElement('text','specialEndTime');
		$specialEndTime->removeDecorator('Label')
						 ->removeDecorator('HtmlTag')
						 ->setAttrib('class','timepicker1')
						 ->addFilters(array('StringTrim'))
						 ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select EndTime.'))))
						 ->setRequired(true);
					
		$specialRecurrence = $this->createElement('checkBox','specialRecurrence');
		$specialRecurrence->removeDecorator('Label')
			          ->removeDecorator('HtmlTag')
			          ->setAttrib('class','chk1 recChk')
			          ->setRequired(false)
			          ->setChecked(false);			  	

		$weeks = new Zend_Form_Element_MultiCheckbox('weeks', array(
						'multiOptions' => array(
							'01' => 'SUN',
							'02' => 'MON',
							'03' => 'TUE',
							'04' => 'WED',
							'05' => 'THU',
							'06' => 'FRI',
							'07' => 'SAT'
						 )
				));
		$weeks->removeDecorator('Label')
			   ->removeDecorator('HtmlTag',array('tag' => 'Br'))
			   ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select SpecialDay'))))			  
			   ->setRequired(false);
			          
		$specialDescription = $this->createElement('textArea', 'specialDescription');
		$specialDescription->removeDecorator('Label')
						->removeDecorator('HtmlTag')                	   
                	    ->setAttrib('maxlength', '10000')
                	    ->setValue('')              
                	    ->setAttrib('cols', '40')
			            ->setAttrib('rows', '4')
			            ->addFilters(array('StringTrim'))
			            ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter specialDescription.')),
			           			array('StringLength', false,array(1,10000,'messages' => array(
              					Zend_Validate_StringLength::TOO_LONG => 'Description is too long(>10000).'
              				)))))
			            ->setRequired(false);
			            
		$specialSubmit = $this->createElement('submit','Submit');
        $specialSubmit->removeDecorator('Label')
        		   ->removeDecorator('DtDdWrapper')
        		   ->setValue('Submit')           		          		        		
        		   ->setAttrib('class','submitBtn')
                   ->setIgnore(true);

		$specialReset = $this->createElement('reset','Reset');
        $specialReset->removeDecorator('Label')        		 
        		  ->setValue('Reset')
        		  ->removeDecorator('DtDdWrapper')           	  	 
        	  	  ->setAttrib('class','submitBtn')
              	  ->setIgnore(true);
					  	  
        $this->addElements( array ($splId,
        							$restNameCtl,
        							$specialType,
        							$NumOfDishes,
        							$specialTitle,
        							$specialImage,
        							$foodType,
        							$regularPrice,
        							$discountPercentage,
        							$priceWithDiscount,
        							$kidsEatFree,
        							$kidsSelection,
        							$specialStartDate,
        							$specialEndDate,
        							$specialStartTime,
        							$specialEndTime,
        							$specialRecurrence,
        							$weeks,
        							$specialCount,
        							$specialDescription,
        							$specialSubmit,
        							$specialReset,
        							$specialCatType
        				   ));
	}
}