<?php

class ManageRestaurant_Model_OverBookedPasswordDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}


	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('ManageRestaurant_Model_DbTable_OverBookedPassword');
		}
		return $this->_dbTable;
	}

	public function OverBookedPassword(ManageRestaurant_Model_OverBookedPassword $obj)
	{
		try{
			$status = false;
			$db = Zend_Db_Table::getDefaultAdapter();
			
			$length = 8;
			$characters = '0123456789abcdefghijklmnopqrstuvwxyz';
			$randomdata = "";
			for ($p = 0; $p < $length; $p++) {
				$randomdata .= $characters[mt_rand(0, strlen($characters))];
			}
			$passSha = sha1($obj->getPassword().$randomdata);
			$update = date('Y-m-d H:i:s');	
			$data = array(
			'ropfk_restaurant'	=>	$obj->getRestaurantId(),
			'roppassword'		=>	$passSha,
			'ropfk_userid'		=>	$obj->getUserid(),
			'roppassphrase'		=>	$randomdata
			);

			$result = $db->fetchOne("select count(ropid) from mt.restaurant_overbooked_password where ropfk_restaurant = ".$obj->getRestaurantId());
			if($result){
				$Where = $db->quoteInto('ropfk_restaurant = ?',$obj->getRestaurantId());
				$data['ropupdateddatetime'] =	$update;
				$rows_affected = $this->getDbTable()->update($data,$Where);
				if($rows_affected){
					$msg = "Password updated successfully.";
					$status = true;
				}else{
					$status = false;
				}
			}else{
				$data['ropcreateddatetime'] =	$update;
				$id = $this->getDbTable()->insert($data);
				if($id){
					$msg = "Password Saved successfully.";
					$status = true;
				}else{
					$status = false;
				}
			}
			return array('status'=>$status,'msg'=>$msg);
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function CheckPassword(ManageRestaurant_Model_OverBookedPassword $obj)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$passPhrase = $this->getUserPassPhrase($obj->getRestaurantId(),$obj->getUserid());
			if($passPhrase){
				$passwordHash = sha1($obj->getPassword().$passPhrase->roppassphrase);
				$result = $db->fetchOne("select count(ropid) from mt.restaurant_overbooked_password where roppassword = '". $passwordHash ."'and ropfk_restaurant = '". $obj->getRestaurantId() ."'and ropfk_userid = '".$obj->getUserid()."'");				
				if((int)$result)
				{
					$status = true;
				}else{
					$status = false;
				}
			}else{
				$status = false;
			}
			return $status;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getUserPassPhrase($rest,$user)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			
			$select->from(array('usr'=>'mt.restaurant_overbooked_password'),array('roppassphrase'))
				   ->where('ropfk_restaurant = ?',$rest)
				   ->where('ropfk_userid = ?',$user);
			$row = $table->fetchRow($select);
			return $row;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function updateAll()
	{
		try{
		$db = Zend_Db_Table::getDefaultAdapter();
			$result = $db->fetchAll(
				"SELECT ropid,roppassword,roppassphrase FROM mt.restaurant_overbooked_password "
				);
			foreach($result as $row){
				$id = $row['ropid'];
				if(strlen($row['roppassword']) < 30){
					$length = 8;
					$characters = '0123456789abcdefghijklmnopqrstuvwxyz';
					$randomdata = "";
					for ($p = 0; $p < $length; $p++) {
						$randomdata .= $characters[mt_rand(0, strlen($characters))];
					}
					$update = date('Y-m-d H:i:s');
					$passSha = sha1($row['roppassword'].$randomdata);
					$usertabledata = array('roppassword'        => $passSha,'roppassphrase' => $randomdata);
					$this->getDbTable()->update($usertabledata, array('ropid = ?' => $id));
				}
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

}