<?php
class ManageRestaurant_Model_RestWidgetThemeMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}


	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('ManageRestaurant_Model_DbTable_RestWidgetTheme');
		}
		return $this->_dbTable;
	}

	public function SaveRestWidgetTheme(ManageRestaurant_Model_RestWidgetTheme $RestWidgetTheme)
	{
		try{
			$table = $this->getDbTable();
			$data = array('rwtfk_restaurant' => $RestWidgetTheme->getrwtfk_restaurant(),
						  'rwt_theme_name'	 => $RestWidgetTheme->getrwt_theme_name(),
						  'rwt_theme_style'  => $RestWidgetTheme->getrwt_theme_style(),
						  'rwt_widget_type'	 => $RestWidgetTheme->getrwt_widget_type(),
						  'rwt_theme_css'    => $RestWidgetTheme->getrwt_theme_css(),
						  'rwt_created_by'   => $RestWidgetTheme->getrwt_created_by(),
						  'rwt_created_date' => $RestWidgetTheme->getrwt_created_date());
			$id = $table->insert($data);
			return $id;								
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function UpdateRestWidgetTheme(ManageRestaurant_Model_RestWidgetTheme $RestWidgetTheme)
	{
		try{
			$table = $this->getDbTable();
			$set = array('rwt_theme_name'	=> $RestWidgetTheme->getrwt_theme_name(),
						 'rwt_theme_style'  => $RestWidgetTheme->getrwt_theme_style(),
						 'rwt_widget_type'	=> $RestWidgetTheme->getrwt_widget_type(),
						 'rwt_theme_css'    => $RestWidgetTheme->getrwt_theme_css(),
						 'rwt_updated_by'   => $RestWidgetTheme->getrwt_updated_by(),
						 'rwt_updated_date' => $RestWidgetTheme->getrwt_updated_date());
			
			$where = array('rwtid = ?' 			  => $RestWidgetTheme->getrwtid(),
						   'rwtfk_restaurant = ?' => $RestWidgetTheme->getrwtfk_restaurant());
			$rows_affected = $table->update($set,$where);
			return $rows_affected;
			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function RetrieveWidgetThemeByRestId($restid)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('rwtid','rwtfk_restaurant','rwt_theme_name','rwt_theme_style','rwt_widget_type','rwt_theme_css','rwt_created_by','rwt_created_date'))
				   ->where('rwtfk_restaurant = ?',$restid);
			$result = array();				   
			$row = $table->fetchRow($select);
			if($row){
				$result['rwtid'] 			= $row->rwtid;
				$result['rwtfk_restaurant'] = $row->rwtfk_restaurant;
				$result['rwt_theme_name'] 	= $row->rwt_theme_name;
				$result['rwt_theme_style']	= $row->rwt_theme_style;
				$result['rwt_widget_type']	= $row->rwt_widget_type;
				$result['rwt_theme_css']	= $row->rwt_theme_css;
				$result['rwt_created_by'] 	= $row->rwt_created_by;
				$result['rwt_created_date'] = $row->rwt_created_date;					
			}
			return $result; 	
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
}