<?php

class ManageRestaurant_Model_RestaurantEmailsDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('ManageRestaurant_Model_DbTable_RestaurantEmails');
		}
		return $this->_dbTable;
	}
	
	public function GetRestaurantEmails($restaurantid)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			
			$select->from(array('resemail'=>'mt.restaurant_emails'),array('rese_id','rese_email','rese_status'))
				   ->join(array('resstatus'=>'mt.restaurant_status_bd'),'resemail.rese_email_status_id = resstatus.id',array('description'))
				   ->where('resemail.resefk_restaurantid = ?',$restaurantid)
				   ->where('resemail.rese_email_status_id IN(?)',array(1,2))
				   ->order('resemail.rese_id');
				   
			$result = $table->fetchAll($select);
			$resultArr = array();
			foreach($result as $value){
				$array = array(
					'email' =>	$value->rese_email,
					'id'	=>	$value->rese_id,
					'status'=>	$value->description
				);
				$resultArr[] = $array;
			}			
			return $resultArr;		
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function UpdateRestEmailById($restid, $resemail, $Id)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$result = 0;
			$count = 0;
			$status = "";
			$result = $db->fetchOne("select count(rese_id) from mt.restaurant_emails where resefk_restaurantid = '".$restid."'and rese_email ILIKE'%".$resemail."%' and rese_email_status_id IN(1,2)");
			if($result < 1){
				$count = $db->fetchOne("select count(resemail) from mt.restaurant where resid = '".$restid."'and resemail ILIKE '%".$resemail."%'");
				if($count < 1){
					$table = $this->getDbTable();
					$set   = array('rese_email'=>$resemail);
					$where = array('resefk_restaurantid = ?'=>$restid,
								   'rese_id = ?' => $Id);
					$status = $table->update($set,$where);
				}	
			}else if($result == 1){
				$resid = $db->fetchOne("select rese_id from mt.restaurant_emails where resefk_restaurantid = '".$restid."'and rese_email ILIKE'%".$resemail."%' and rese_email_status_id IN(1,2)");
				if($resid == $Id){
					$status = true;
				}
			}
			return 	$status;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function AddRestEmailById($restid, $resemail)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$result = 0;
			$count = 0;
			$id = "";
			$result = $db->fetchOne("select count(rese_email) from mt.restaurant_emails where resefk_restaurantid = '".$restid."'and rese_email ILIKE'%".$resemail."%'and rese_email_status_id IN(1,2)");
			if($result < 1){
				$count = $db->fetchOne("select count(resemail) from mt.restaurant where resid = '".$restid."'and resemail ILIKE '%".$resemail."%'");
				if($count < 1){
					$data = array('resefk_restaurantid'	=>	$restid,
								  'rese_email'			=>	$resemail,
								  'rese_status'			=>	true,
								  'rese_email_status_id'=>	1
							);
					$table = $this->getDbTable();
					$id = $table->insert($data);	
				}
			}
			if($id){
				return true;
			}else{
				return false;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function changeresemailstatus($id, $text)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$table = $this->getDbTable();
			if($text == "Activate"){
				$set   = array('rese_status'=> 'true',
								'rese_email_status_id'=> '1');
			}else if($text == "InActivate"){
				$set   = array('rese_status'=> 'false',
								'rese_email_status_id'=> '2');
			}
			$where = $db->quoteInto('rese_id = ?', $id);
			$status = $table->update($set,$where);
			return 	$status;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function deleteResEmail($id)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$table = $this->getDbTable();
			
			$set   = array('rese_status'=> 'false',
								'rese_email_status_id'=> '3');
			
			$where = $db->quoteInto('rese_id = ?', $id);
			$status = $table->update($set,$where);
			return 	$status;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function RestEmailDetails($restId)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('rese_id','resefk_restaurantid','rese_email','rese_status','rese_email_status_id'))
				   ->where('resefk_restaurantid = ?',$restId);	   
			$rows = $table->fetchAll($select);
			$resultArr = array();
			foreach($rows as $value){
				$array = array(
					'rese_id'						=> $value->rese_id,
					'resefk_restaurantid' 			=>	$value->resefk_restaurantid,
					'rese_email'					=>	$value->rese_email,
					'rese_status'					=>	$value->rese_status,
					'rese_email_status_id'			=>	$value->rese_email_status_id,
				);
				$resultArr[] = $array;
			}			
			return $resultArr;		
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function AddRestEmailByIdFromNativeApp($restid, $resemail)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$result = 0;
			$count = 0;
			$id = 0;
			$result = $db->fetchOne("select count(rese_email) from mt.restaurant_emails where resefk_restaurantid = '".$restid."'and rese_email ILIKE'%".$resemail."%'and rese_email_status_id IN(1,2)");
			if($result < 1){
				$count = $db->fetchOne("select count(resemail) from mt.restaurant where resid = '".$restid."'and resemail ILIKE '%".$resemail."%'");
				if($count < 1){
					$data = array('resefk_restaurantid'	=>	$restid,
								  'rese_email'			=>	$resemail,
								  'rese_status'			=>	true,
								  'rese_email_status_id'=>	1
							);
					$table = $this->getDbTable();
					$id = $table->insert($data);	
				}
			}
			return $id;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}

