<?php

class ManageRestaurant_Model_RestaurantFloorEntrance
{
	protected $_id;
	protected $_resid;
	protected $_entrancenumber;
	protected $_entrancetype;
	protected $_entrancecoordinates;
	protected $_entrancedimension;
	protected $_entranceposition;
	protected $_floornumber;
	protected $_entrancestatus;
	protected $_createdDate;
	protected $_createdBy;
	protected $_updatedDate;
	protected $_updatedBy;
	protected $_diningid;
	
	public function __construct(array $options = null)
	{
		if(is_array($options)){
			$this->setOptions($options);
		}		
	}
	
	public function __set($name, $value)
	{
		$method = 'set' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid RestaurantMenu property');
		}
		$this->$method($value);
	}
	
	public function __get($name)
	{
		$method = 'get' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid RestaurantMenu property');
		}
		return $this->$method();
	}
	
	public function setOptions(array $options)
	{
		$methods = get_class_methods($this);
		foreach ($options as $key => $value) {
			$method = 'set' . ucfirst($key);
			if (in_array($method, $methods)) {
				$this->$method($value);
			}
		}
		return $this;
	}
	public function setId($id)
	{
		$this->_id = (int)$id;
		return $this; 
	}
	
	public function getID()
	{
	    return	$this->_id;
	}
	public function setResId($resid)
	{
		$this->_resid = $resid;
		return $this; 
	}
	
	
	public function getResId()
	{
	    return	$this->_resid;
	}
	public function setEntranceNumber($entnumber)
	{
		$this->_entrancenumber = $entnumber;
		return $this; 
	}
	
	public function getEntranceNumber()
	{
	    return	$this->_entrancenumber;
	}
	
	public function setEntranceType($entrancetype)
	{
		$this->_entrancetype = $entrancetype;
		return $this; 
	}
	
	public function getEntranceType()
	{
	    return	$this->_entrancetype;
	}
	public function setEntranceCoor($entrancecoor)
	{
		$this->_entrancecoordinates = $entrancecoor;
		return $this; 
	}
	
	public function getEntranceCoor()
	{
	    return	$this->_entrancecoordinates;
	}
	public function setEntranceDimension($entrancedimension)
	{
		$this->_entrancedimension = $entrancedimension;
		return $this; 
	}
	
	public function getEntranceDimension()
	{
	    return	$this->_entrancedimension;
	}
	
	public function setFloorNumber($floornumber)
	{
		$this->_floornumber= $floornumber;
		return $this; 
	}
	public function setEntrancePosition($_entranceposition){
		$this->_entranceposition = $_entranceposition;
		return $this;		
	}
	public function getEntrancePosition(){
		return $this->_entranceposition;
	}
	
	public function getFloorNumber()
	{
	    return	$this->_floornumber;
	}
	public function setEntranceStatus($entrancestatus)
	{
		$this->_entrancestatus = $entrancestatus;
		return $this; 
	}
	
	public function getEntranceStatus()
	{
	    return	$this->_entrancestatus;
	}
	public function setCreatedDate($createddate)
	{
		$this->_createdDate= $createddate;
		return $this; 
	}
	
	public function getCreatedDate()
	{
	    return	$this->_createdDate;
	}
	public function setCreatedBy($createdby)
	{
		$this->_createdBy = $createdby;
		return $this; 
	}
	
	public function getCreatedBy()
	{
	    return	$this->_createdBy;
	}
	public function setUpdatedDate($updateddate)
	{
		$this->_updatedDate = $updateddate;
		return $this; 
	}
	
	public function getUpdatedDate()
	{
	    return	$this->_updatedDate;
	}
	public function setUpdatedBy($updatedby)
	{
		$this->_updatedby = $updatedby;
		return $this; 
	}
	
	public function getUpdatedBy()
	{
	    return	$this->_updatedby;
	}
	
	public function setDiningId($diningid)
	{
		$this->_diningid = $diningid;
		return $this;
	}

	public function getDiningId()
	{
		return	$this->_diningid;
	}
}

