<?php
class ManageRestaurant_Model_RestaurantGroupUsersDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
				
			$this->setDbTable('ManageRestaurant_Model_DbTable_RestaurantGroupUsers');
		}
		return $this->_dbTable;
	}

	public function addUserContact(ManageRestaurant_Model_RestaurantGroupUsers $user)
	{
			$db = Zend_Db_Table::getDefaultAdapter();
			$data = array(
						'rgufk_restaurant'		=>	$user->getRestaurantId(),
						'rgufk_rsgid'			=>	$user->getGroupId(),
						'rgufirst_name'			=>	$user->getFirstName(),
						'rgulast_name'			=>	$user->getLastName(),
						'rgugender'				=>	$user->getGender(),
						'rguaddress'			=>	$user->getAddress(),
						'rgustatus'				=>	$user->getStatus(),
						'rguzipcode'			=>	$user->getZipCode(),
						'rgrestaraunt_note'			=>	$user->getRgrestaraunt_note(),
						);
			if($user->getEmail()){
				$data['rguemail'] = $user->getEmail();
			}
			if($user->getPhone()){
				$data['rguphone'] = str_replace("-","",$user->getPhone());
			}
			if($user->getState()){
				$data['rgustate_id'] = $user->getState();
			}
			if($user->getRegion()){
				$data['rguregion_id'] = $user->getRegion();
			}
			if($user->getCity()){
				$data['rgucity_id'] = $user->getCity();
			}
			if($user->getNeighbourhood()){
				$data['rguneighbourhood_id'] = $user->getNeighbourhood();
			}
			if($user->getSplRequest()){
				$data['rguspecial_request'] = $user->getSplRequest();
			}
			if($user->getOccational_emails()){
				$data['rgu_occational_emails'] = $user->getOccational_emails();
			}
			if($user->getrgu_birthday()){
				$data['rgu_birthday'] = $user->getrgu_birthday();
			}
			if($user->getrgu_anniversary()){
				$data['rgu_anniversary'] = $user->getrgu_anniversary();
			}
			if($user->getrgu_optinemail()){
				$data['rgu_optinemail'] = $user->getrgu_optinemail();
			}
			if($user->getCountrycode()){
				$data['rgucountrycode'] = $user->getCountrycode();
			}
			if($user->getRgrestaraunt_note()){
				$data['rgrestaraunt_note'] = $user->getRgrestaraunt_note();
			}
			try{
				$whtShouldIUpdate = '';
				
				 
				if($user->getEmail() && $user->getPhone()){
					$result = $db->fetchOne("select count(rguid) from mt.restaurant_group_users where rgufk_restaurant = ".$user->getRestaurantId()." and rguphone = '".$user->getPhone()."'and rguemail ILIKE '%".$user->getEmail()."%'");
					if($result == 0)
					{
						$result =="";
						$result = $db->fetchOne("select count(rguid) from mt.restaurant_group_users where rgufk_restaurant = ".$user->getRestaurantId()." and rguphone = '".$user->getPhone()."'");
						if($result == 0){
							$result =="";
							$result = $db->fetchOne("select count(rguid) from mt.restaurant_group_users where rgufk_restaurant = ".$user->getRestaurantId()." and rguemail ILIKE '%".$user->getEmail()."%'");
							if($result == 0){
								$whtShouldIUpdate = 'Both';	
							}else{
								$whtShouldIUpdate = 'Phone';
							}
						}else{
							$whtShouldIUpdate = 'email';
						}
					}
				}else if($user->getPhone()){
					$result = $db->fetchOne("select count(rguid) from mt.restaurant_group_users where rgufk_restaurant = ".$user->getRestaurantId()." and rguphone = '".$user->getPhone()."'");
					if($result == 0)
					{
						$whtShouldIUpdate = 'Both';
					}
				}else if($user->getEmail()){
					$result = $db->fetchOne("select count(rguid) from mt.restaurant_group_users where rgufk_restaurant = ".$user->getRestaurantId()." and rguemail ILIKE '%".$user->getEmail()."%'");
					if($result == 0)
					{
						$whtShouldIUpdate = 'Both';
					}
				}else{
					if($user->getSplRequest() && !$user->getId()){
						$whtShouldIUpdate = 'Both';
					}
				}
				
				
				if($user->getFirstName() && $user->getLastName()){
					$result = $db->fetchOne("select count(rguid) from mt.restaurant_group_users where rgufk_restaurant = ".$user->getRestaurantId()." and rgufirst_name = '".$user->getFirstName()."' and rgulast_name = '".$user->getLastName()."'");
					if($result == 0)
					{
						$whtShouldIUpdate = 'Both';
					} else {
						$whtShouldIUpdate = 'guest_notes';
					}
				}
				
				if($whtShouldIUpdate == 'Both')
				{
					$this->getDbTable()->insert($data);
				}else if($whtShouldIUpdate == 'guest_notes'){
					if($user->getSplRequest()){
						$set = array('rguspecial_request' => $user->getSplRequest(),
									'rgrestaraunt_note'			  => $user->getRgrestaraunt_note()
									);
					}else{
						$set = array('rgrestaraunt_note'			  => $user->getRgrestaraunt_note());
					}
					$where = array('rgufk_restaurant = ?'		=>	$user->getRestaurantId(),
								   'rgufirst_name = ?'				=>	$user->getFirstName(),
								   'rgulast_name = ?'				=>	$user->getLastName(),
								    'rguemail = ?'				=>	$user->getEmail()	
							);
					//unset($set['rguspecial_request']);
					$rows_affected = $this->getDbTable()->update($set,$where);
					
				}else if($whtShouldIUpdate == 'email'){
					if($user->getSplRequest()){
						$set = array('rguspecial_request' => $user->getSplRequest(),
									'rguemail'			  => $user->getEmail()
									);
					}else{
						$set = array('rguemail'			  => $user->getEmail());
					}
					$where = array('rgufk_restaurant = ?'		=>	$user->getRestaurantId(),
								   'rguphone = ?'				=>	$user->getPhone()	
							);
					//unset($set['rguspecial_request']);
					$rows_affected = $this->getDbTable()->update($set,$where);
					
				}else if($whtShouldIUpdate == 'Phone'){
					if($user->getSplRequest()){
						$set = array('rguspecial_request' => $user->getSplRequest(),
									'rguphone'			  => $user->getPhone()
									);
					}else{
						$set = array('rguphone'			  => $user->getPhone());
					}
					$where = array('rgufk_restaurant = ?'		=>	$user->getRestaurantId(),
								   'rguemail = ?'				=>	$user->getEmail()	
							);
					//unset($set['rguspecial_request']);
					$rows_affected = $this->getDbTable()->update($set,$where);					
				}else{
					if($user->getSplRequest()){
						$set = array('rguspecial_request' => $user->getSplRequest());
						if($user->getId()){
							$where = array('rguid = ?' => $user->getId());
						}else if($user->getEmail() && $user->getPhone()){
							$where = array('rgufk_restaurant = ?'	=>	$user->getRestaurantId(),
									       'rguemail ILIKE (?)'		=>	'%'.$user->getEmail().'%',
									       'rguphone = ?'				=>	$user->getPhone()	
									);
						}else if($user->getPhone()){
							$where = array('rgufk_restaurant = ?'	=>	$user->getRestaurantId(),
									       'rguphone = ?'				=>	$user->getPhone()	
									);
						}else{
							$where = array('rgufk_restaurant = ?'	=>	$user->getRestaurantId(),
									       'rguemail ILIKE (?)'		=>	'%'.$user->getEmail().'%'
									);
						}
						//unset($set['rguspecial_request']);
						$rows_affected = $this->getDbTable()->update($set,$where);
					}
				}
				Uss_Logger_FileLogger::info(print_r($set,true));
				Uss_Logger_FileLogger::info('After Unset');
				unset($set['rguspecial_request']);
				Uss_Logger_FileLogger::info(print_r($set,true));
				$status = true;
				return $status;
			}catch(Exception $ex){
				$db->rollBack();
				throw new Exception($ex->getMessage()) ;
			}
	}
	
	public function addExcelUserContact($resId,$grpId,$excelContacts)
	{
			
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$db->beginTransaction();
			$table = $this->getDbTable();
			$query= $table->select();
			$query->setIntegrityCheck(false);
			$query->from(array('rgu' => 'mt.restaurant_group_users'),array('rguid','rgufk_restaurant','rgufirst_name','rgulast_name','rguemail','rguphone','rgufk_rsgid'))
					->join(array('rsg' => 'mt.restaurant_group'),'rsg.rsgid = rgu.rgufk_rsgid',array('rsggroup'))
					->where('rgu.rgustatus = ?',TRUE)
					->where('rgu.rgufk_restaurant =?',$resId);
					
			$result = $table->fetchAll($query);
					
			foreach($excelContacts as $contacts){
				$userdat = "";
				$status = true;
				foreach($contacts as $user){
					$userdat[] = $user;
				}
				
				if(strlen($userdat[4]) > 15){
					$userdat[4] ="";
				}
				if(strlen($userdat[9]) > 15){
					$userdat[9] ="";
				}
				$usnumber = $userdat[4];
				$usnumber = str_replace("-","",$usnumber);
				$usnumber = str_replace("(","",$usnumber);
				$usnumber = str_replace(")","",$usnumber);
			
				if(!is_numeric($userdat[6])) {
					$userdat[6] = null;
				}	
				if(!is_numeric($userdat[7])) {
					$userdat[7] = null;
				}
				$data = array(
					'rgufk_restaurant'		=>	$resId,
					'rgufk_rsgid'			=>	$grpId,
					'rgufirst_name'			=>	utf8_encode($userdat[0]),
					'rgulast_name'			=>	utf8_encode($userdat[1]),
					'rgugender'				=>	$userdat[2],
					'rguemail'				=>	utf8_encode($userdat[3]),
					'rguphone'				=>	utf8_encode($usnumber),
					'rguaddress'			=>	utf8_encode($userdat[5]),
					'rgustatus'				=>	1,
					'rgustate_id'			=>	$userdat[6],
				    'rgucity_id'			=>	$userdat[7],
					'rguzipcode'			=>	$userdat[8],
					'rgu_optinemail'		=>  $userdat[11],
					'rguspecial_request'	=>	utf8_encode($userdat[12]),
					);
					
				if($userdat[9] != ""){
					if (strpos($userdat[9],'/') !== false) {
						$data['rgu_birthday'] = str_replace('/','-',$userdat[9]);
					}else if (strpos($userdat[9],'-') !== false) {
						$data['rgu_birthday'] = $userdat[9];
					}
				}
				if($userdat[10]  != ""){
					if (strpos($userdat[10],'/') !== false) {
						$data['rgu_anniversary'] = str_replace('/','-',$userdat[10]);
					}
				}
					
				foreach($result as $contDetails){
					if($userdat[3] != ""){
						if($contDetails->rguemail == $userdat[3]){
							$status = false;
							break;
						}
					}
					if($userdat[4] != ""){
						if($contDetails->rguphone == $userdat[4]){
							$status = false;
							break;
						}
					}
				}
				if($status){
					$this->getDbTable()->insert($data);	
				}
			}
			$db->commit();
			$status = true;
		}catch(Exception $ex){
			$db->rollBack();
			throw new Exception($ex->getMessage()) ;
		}
		return $status;
	}

	public function getUsersContacts($restList,$offset)
	{
		try{
			$limit = 15;
			$table = $this->getDbTable();
			$query= $table->select();
			$query->setIntegrityCheck(false);

			$query->from(array('rgu' => 'mt.restaurant_group_users'),array('rguid','rgufk_restaurant','rgufirst_name','rgulast_name','rguemail','rguphone','rgufk_rsgid','rguaddress','rguzipcode','rgucountrycode'))
				  ->join(array('res' => 'mt.restaurant'),'res.resid = rgu.rgufk_restaurant',array('resrestaurant_name'))
				  ->join(array('rsg' => 'mt.restaurant_group'),'rsg.rsgid = rgu.rgufk_rsgid',array('rsggroup'))
				  ->joinLeft(array('sta'=>'mt.state_bd'),'sta.id = rgu.rgustate_id',array('id as stateid','description as state'))
				  ->joinLeft(array('reg'=>'mt.region_bd'),'reg.id = rgu.rguregion_id',array('id as regionid','description as region'))
				  ->joinLeft(array('cty'=>'mt.city_bd'),'cty.id = rgu.rgucity_id',array('id as cityid','description as city'))
				  ->joinLeft(array('neg'=>'mt.neighborhood_bd'),'neg.id = rgu.rguneighbourhood_id',array('id as neighbid','description as neighborhood'))
				  ->where('rgu.rgustatus = ?',TRUE);							
			$resIdArr = array();	
			foreach($restList as $item['key']){
				$restaurantList = $item['key'];
				if($restaurantList['key']){
					if($restaurantList['key'] != 0)
					{
						$resIdArr[] = $restaurantList['key'];
					}
				}
			}
			$query->where('rgu.rgufk_restaurant IN(?)',$resIdArr);
			$query->order('rgu.rguid DESC');
			//$Result = $table->fetchAll($query);
			$Result = "";
			if(count($resIdArr)>0){
			$Result = new Zend_Paginator(
				new Zend_Paginator_Adapter_DbTableSelect($query)
				);
				$Result->setItemCountPerPage($limit);
				$Result->setCurrentPageNumber($offset);
			}
			return $Result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function GetRestUsersContacts($restList)
	{
		try{
			$table = $this->getDbTable();
			$query= $table->select();
			$query->setIntegrityCheck(false);

			$query->from(array('rgu' => 'mt.restaurant_group_users'),array('rguid','rgufk_restaurant','rgufirst_name','rgulast_name','rguemail','rguphone','rgufk_rsgid','rgugender','rguzipcode','rguaddress','rgu_birthday','rgu_anniversary','rgu_optinemail'))
			->join(array('rsg' => 'mt.restaurant_group'),'rsg.rsgid = rgu.rgufk_rsgid',array('rsggroup'))
			->joinLeft(array('sta'=>'mt.state_bd'),'sta.id = rgu.rgustate_id',array('description as state'))
			->joinLeft(array('cty'=>'mt.city_bd'),'cty.id = rgu.rgucity_id',array('description as city'))
			->where('rgu.rgustatus = ?',TRUE);
			$resIdArr = array();	
			foreach($restList as $item['key']){
				$restaurantList = $item['key'];
				if($restaurantList['key']){
					if($restaurantList['key'] != 0)
					{
						$resIdArr[] = $restaurantList['key'];
					}
				}
			}
			$query->where('rgu.rgufk_restaurant IN(?)',$resIdArr);
			$query->order('rgu.rguid DESC');
			$Result = "";
			if(count($resIdArr)>0){
				$Result = $table->fetchAll($query);
			}
			return $Result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getUserContactById(ManageRestaurant_Model_RestaurantGroupUsers $id)
	{
		try{
			$table = $this->getDbTable();
			$query= $table->select();
			$query->setIntegrityCheck(false);

			$query->from(array('rgu' => 'mt.restaurant_group_users'),array('rgufk_restaurant','rgufk_rsgid','rgufirst_name','rgulast_name','rgugender','rguemail','rguphone','rguaddress','rgustate_id','rguregion_id','rgucity_id','rguzipcode','rguneighbourhood_id','rguspecial_request','rgu_birthday','rgu_anniversary','rgu_optinemail','rgucountrycode'))
			->join(array('rsg' => 'mt.restaurant_group'),'rsg.rsgid = rgu.rgufk_rsgid',array('rsggroup'))
			->where('rguid = ?',$id->getId());
				
			$Result = $table->fetchRow($query);
			$cityList = "";
			$regionList="";
			$neighborhoodList = ""; 
			if($Result){
				if($Result['rgustate_id'] != ''){
					$regionmapper = new Application_Model_RegionDataMapper();
					$regionObj = new Application_Model_Region();
					$regionObj->setStateId($Result['rgustate_id']);
					$region = $regionmapper->getRegionByStateId($regionObj);
					$regionList = $region->getRegionList();
						if($Result['rguregion_id'] != ''){
							$citymapper = new Application_Model_CityDataMapper();
							$cityObj = new Application_Model_City();
							$cityObj->setRegionId($Result['rguregion_id']);
							$city = $citymapper->getCityByRegionId($cityObj);
							$cityList = $city->getCityList();
						}
						if($Result['rgucity_id'] != ''){
							$neighborhoodmapper = new Application_Model_NeighborhoodDataMapper();
							$neighborhoodObj = new Application_Model_Neighborhood();
							$neighborhoodObj->setCityId($Result['rgucity_id']);
							$neighborhood = $neighborhoodmapper->getNghByCityId($neighborhoodObj);
							$neighborhoodList = $neighborhood->getNeighborhoodList();
						}
				}
			}

			$obj = new ManageRestaurant_Model_RestaurantGroupUsers();
			$obj->setRestaurantId($Result->rgufk_restaurant)
			->setGroupId($Result->rgufk_rsgid)
			->setGroupName($Result->rsggroup)
			->setFirstName($Result->rgufirst_name)
			->setLastName($Result->rgulast_name)
			->setGender($Result->rgugender)
			->setEmail($Result->rguemail)
			->setPhone($Result->rguphone)
			->setAddress($Result->rguaddress)
			->setCity($Result->rgucity_id)
			->setRegion($Result->rguregion_id)
			->setNeighbourhood($Result->rguneighbourhood_id)
			->setState($Result->rgustate_id)
			->setZipCode($Result->rguzipcode)
			->setSplRequest($Result->rguspecial_request)
			->setrgu_birthday($Result->rgu_birthday)
			->setrgu_anniversary($Result->rgu_anniversary)
			->setrgu_optinemail($Result->rgu_optinemail)
			->setCountrycode($Result->rgucountrycode);

			if($regionList){
				$obj->setRegionBd($regionList);
				if($cityList){
					$obj->setCityBd($cityList);
					if($neighborhoodList){
						$obj->setNeighbourhoodBd($neighborhoodList);	
					}
				}
			}
			return $obj;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function UpdateUserContact(ManageRestaurant_Model_RestaurantGroupUsers $user)
	{
		try{
			$status = false;
			$db = Zend_Db_Table::getDefaultAdapter();
			$set = array(
						'rgufk_restaurant'		=>	$user->getRestaurantId(),
						'rgufk_rsgid'			=>	$user->getGroupId(),
						'rgufirst_name'			=>	$user->getFirstName(),
						'rgulast_name'			=>	$user->getLastName(),
						'rgugender'				=>	$user->getGender(),
						'rguemail'				=>	$user->getEmail(),
						'rguphone'				=>	str_replace("-","",$user->getPhone()),
						'rguaddress'			=>	$user->getAddress(),
						'rguzipcode'			=>	$user->getZipCode(),
						);
			if($user->getCountrycode()){
				$set['rgucountrycode'] = $user->getCountrycode();
			}
			if($user->getState()){
				$set['rgustate_id'] = $user->getState();
			}
			if($user->getRegion()){
				$set['rguregion_id'] = $user->getRegion();
			}
			if($user->getCity()){
				$set['rgucity_id'] = $user->getCity();
			}
			if($user->getNeighbourhood()){
				$set['rguneighbourhood_id'] = $user->getNeighbourhood();
			}
			if($user->getSplRequest()){
				$set['rguspecial_request'] = $user->getSplRequest();
			}
			if($user->getrgu_birthday()){
				$set['rgu_birthday'] = $user->getrgu_birthday();
			}
			if($user->getrgu_anniversary()){
				$set['rgu_anniversary'] = $user->getrgu_anniversary();
			}
			if($user->getrgu_optinemail()){
				$set['rgu_optinemail'] = $user->getrgu_optinemail();
			}
			$where = $db->quoteInto('rguid = ?',$user->getId());
			$rows_affected = $this->getDbTable()->update($set,$where);
			if($rows_affected)
			{
				return true;
			}else{
				return false;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getUserContacts(ManageRestaurant_Model_RestaurantGroupUsers $groupusers,$offset,$restList)
	{
		try{
			$limit = 15;
			$query = $this->getDbTable()->select();
			$query->setIntegrityCheck(false);
			$query->from(array('rgu' => 'mt.restaurant_group_users'),array('rguid','rgufk_restaurant','rgufirst_name','rgulast_name','rguemail','rguphone','rgufk_rsgid','rguzipcode','rguaddress','rgucountrycode'))
				  ->join(array('res' => 'mt.restaurant'),'res.resid = rgu.rgufk_restaurant',array('resrestaurant_name'))
			  	  ->join(array('rsg' => 'mt.restaurant_group'),'rsg.rsgid = rgu.rgufk_rsgid',array('rsggroup'))
			  	  ->joinLeft(array('sta'=>'mt.state_bd'),'sta.id = rgu.rgustate_id',array('id as stateid','description as state'))
			  	  ->joinLeft(array('reg'=>'mt.region_bd'),'reg.id = rgu.rguregion_id',array('id as regionid','description as region'))
			   	  ->joinLeft(array('cty'=>'mt.city_bd'),'cty.id = rgu.rgucity_id',array('id as cityid','description as city'))
			  	  ->joinLeft(array('neg'=>'mt.neighborhood_bd'),'neg.id = rgu.rguneighbourhood_id',array('id as neighbid','description as neighborhood'));
			$resIdArr = array();
			if($groupusers->getRestaurantId()){
				$query->where('rgu.rgufk_restaurant = ?',$groupusers->getRestaurantId());
			}else{
				foreach($restList as $item['key']){
					$restaurantList = $item['key'];
					if($restaurantList['key']){
						if($restaurantList['key'] != 0)
						{
							$resIdArr[] = $restaurantList['key'];
						}
					}
				}
				$query->where('rgu.rgufk_restaurant IN(?)',$resIdArr);
			}
			if($groupusers->getGroupId()){
				$query->where('rgu.rgufk_rsgid = ?',$groupusers->getGroupId());
			}
			if($groupusers->getFirstName()){
				$query->where('rgu.rgufirst_name Ilike ?','%'.trim($groupusers->getFirstName()).'%');
			}
			if($groupusers->getLastName()){
				$query->where('rgu.rgulast_name Ilike ?','%'.trim($groupusers->getLastName().'%'));
			}
			if($groupusers->getEmail()){
				$query->where('rgu.rguemail Ilike ?','%'.trim($groupusers->getEmail().'%'));
			}
			if($groupusers->getPhone()){
				$query->where('rgu.rguphone Ilike ?','%'.trim($groupusers->getPhone().'%'));
			}
			if($groupusers->getSortOn() == 'email' && $groupusers->getSortOrder() == 'ASC'){
				$query->order(array('rgu.rguemail ASC'));
			}else if($groupusers->getSortOn() == 'email' && $groupusers->getSortOrder() == 'DESC'){
				$query->order(array('rgu.rguemail DESC'));
			}
			if($groupusers->getSortOn() == 'fname' && $groupusers->getSortOrder() == 'ASC'){
				$query->order(array('rgu.rgufirst_name ASC'));
			}else if($groupusers->getSortOn() == 'fname' && $groupusers->getSortOrder() == 'DESC'){
				$query->order(array('rgu.rgufirst_name DESC'));
			}
			if($groupusers->getSortOn() == 'lname' && $groupusers->getSortOrder() == 'ASC'){
				$query->order(array('rgu.rgulast_name ASC'));
			}else if($groupusers->getSortOn() == 'lname' && $groupusers->getSortOrder() == 'DESC'){
				$query->order(array('rgu.rgulast_name DESC'));
			}
			if($groupusers->getSortOrder()){
				$query->where('rgu.rgulast_name Ilike ?','%'.trim($groupusers->getLastName().'%'));
			}
			$query->where('rgu.rgustatus = ?',TRUE);
			$query->order('rgu.rguid DESC');
			$Result = "";
			if($groupusers->getRestaurantId()!='' || count($resIdArr)>0){
				$Result = new Zend_Paginator(
				new Zend_Paginator_Adapter_DbTableSelect($query)
				);
				$Result->setItemCountPerPage($limit);
				$Result->setCurrentPageNumber($offset);
			}
			return $Result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function CheckEmail(ManageRestaurant_Model_RestaurantGroupUsers $user)
	{
		try{
			
			$db = Zend_Db_Table::getDefaultAdapter();
			$result = $db->fetchOne("select count(rguid) from mt.restaurant_group_users where rgufk_restaurant = '". $user->getRestaurantId() ."'and rguemail = '". $user->getEmail() ."'");

			if((int)$result)
			{
				$status = true;
			}else{
				$status = false;
			}
			return $status;
			
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetCustomerNames($text, $restid,$lastname)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			$select->from($table,array('rguid','rgufirst_name','rgulast_name','rguphone','rguemail','rgrestaraunt_note'));
			$select->where('rgufk_restaurant = ?',$restid);
			if($lastname){
				$select->where('rgulast_name ILIKE(?)','%'.$lastname.'%');
				$select->where('rgufirst_name ILIKE(?)','%'.$text.'%');
			}else{
				$select->where('rgufirst_name ILIKE(?)','%'.$text.'%');
			}
			$result = $table->fetchAll($select);
			$list = null;
			foreach($result as $item){
				if(!empty($text)){
					if(stristr($item['rgufirst_name'],$text))
					{
						if($item['rguphone'] != ''){
							$phone = str_replace("-","",$item['rguphone']);
							$list[$item['rguid']] = $item['rgufirst_name']." ".$item['rgulast_name']." - ".$phone;
						}else if($item['rguemail'] != ''){
							if($data['companyid'] == 1){
								$list[$item['rguid']] = $item['rgufirst_name']." ".$item['rgulast_name']." - ".$item['rguemail'];
							}else{
								$list[$item['rguid']] = $item['rgufirst_name']." ".$item['rgulast_name']." - ";
							}
						}else{
							$list[$item['rguid']] = $item['rgufirst_name']." ".$item['rgulast_name']." - ";
						}
					}
				}else {
					if($item['rguphone'] != '' && $lastname != ''){
						$phone = str_replace("-","",$item['rguphone']);
						$list[$item['rguid']] = $item['rgufirst_name']." ".$item['rgulast_name']." - ".$phone;
					}else if($lastname != ''){
						$list[$item['rguid']] = $item['rgufirst_name']." ".$item['rgulast_name']." - ";
					}
				}
			}
			return $list;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function searchCusContactByName($text, $restid)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$s = "rgulast_name||' '||rgufirst_name";
			$select->from($table,array('rguid','rgufirst_name','rgulast_name','rguphone','rguemail'));
			$select->where('rgufk_restaurant = ?',$restid);
			$select->where($s.' ILIKE(?)','%'.$text.'%');
			$result = $table->fetchAll($select);
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			$list = null;
			foreach($result as $item){
				if(!empty($text)){
					$str = $item['rgulast_name'].' '.$item['rgufirst_name'];
					if(stristr($str,$text))
					{
						if($item['rguphone'] != ''){
							$list[$item['rguid']] = $item['rgufirst_name']." ".$item['rgulast_name']." - ".$item['rguphone'];
						}else if($item['rguemail'] != ''){
							if($data['companyid'] == 1){
								$list[$item['rguid']] = $item['rgufirst_name']." ".$item['rgulast_name']." - ".$item['rguemail'];
							}else{
								$list[$item['rguid']] = $item['rgufirst_name']." ".$item['rgulast_name']." - ";
							}
						}else{
							$list[$item['rguid']] = $item['rgufirst_name']." ".$item['rgulast_name']." - ";
						}
					}
				}else {
					if($item['rguphone'] != '' && $item['rgulast_name'] != ''){
						$list[$item['rguid']] = $item['rgufirst_name']." ".$item['rgulast_name']." - ".$item['rguphone'];
					}else if($item['rguemail'] != '' && $item['rgulast_name'] != ''){
						if($data['companyid'] == 1){
							$list[$item['rguid']] = $item['rgufirst_name']." ".$item['rgulast_name']." - ".$item['rguemail'];
						}else{
							$list[$item['rguid']] = $item['rgufirst_name']." ".$item['rgulast_name']." - ";
						}
					}else if($lastname != ''){
						$list[$item['rguid']] = $item['rgufirst_name']." ".$item['rgulast_name']." - ";
					}
				}
			}
			return $list;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetCustomerDetailsById($cusid)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			$select->from($table,array('rgufirst_name','rgulast_name','rguemail','rguphone','rguspecial_request','rgucountrycode','rgufk_restaurant'));
			$select->where('rguid = ?',$cusid);
			$result = $table->fetchRow($select);
			if($result->rgucountrycode){
				$countryMapper  = new Application_Model_CountryDataMapper();
				$countryid = $countryMapper->getCountryidbyCountryCodeNumber($result->rgucountrycode);
				$countrycode =  $countryid;
				$countrycodeNumber = $result->rgucountrycode;
			}
			else{
				$restMapper = new ManageRestaurant_Model_RestaurantDataMapper();
				$countrycodeArr = $restMapper->getRestaurantCountryCodeNumber($result->rgufk_restaurant);
				$countrycode = $countrycodeArr['countrycodeid']; 
				$countrycodeNumber = $countrycodeArr['countrycode'];
			}	
			$Obj = array(
				   	'firstName'	=>	$result->rgufirst_name,
				  	'lastName'	=>	$result->rgulast_name,
				  	'number'	=>	$result->rguphone,
					'splreq'	=>	$result->rguspecial_request,
					'id'		=>	$cusid,
					'countrycode' => $countrycode,
					'countrycodenumber' => $countrycodeNumber
				);
			if($data['companyid'] == 2){
				$Obj['email']	=	'';
			}else{
				if($result->rguemail){
					$Obj['email']	=	$result->rguemail;
				}else{
					$Obj['email']	=	'';
				}
			}
			
			
			return $Obj;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
		
	public function getRestCustomerDetails(ManageRestaurant_Model_RestaurantGroupUsers $userObj)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			$select->from(array('rgu' => 'mt.restaurant_group_users'),array('rguid','rguemail','rguphone','rguzipcode','rguaddress','rguspecial_request','rgucountrycode'))
				   ->join(array('rsg' => 'mt.restaurant_group'),'rsg.rsgid = rgu.rgufk_rsgid',array('rsggroup'))
				   ->joinLeft(array('sta'=>'mt.state_bd'),'sta.id = rgu.rgustate_id',array('description as state'))
				   ->joinLeft(array('reg'=>'mt.region_bd'),'reg.id = rgu.rguregion_id',array('description as region'))
				   ->joinLeft(array('cty'=>'mt.city_bd'),'cty.id = rgu.rgucity_id',array('description as city'))
				   ->joinLeft(array('neg'=>'mt.neighborhood_bd'),'neg.id = rgu.rguneighbourhood_id',array('description as neighborhood'))
				   ->where('rgu.rgufk_restaurant = ?',$userObj->getRestaurantId())
				   ->where('rgu.rgustatus = ?',TRUE);

			if($userObj->getEmail()){
				$select->where('rgu.rguemail ILIKE(?)','%'.$userObj->getEmail().'%');
			}
			if($userObj->getPhone()){
				$select->where('rgu.rguphone = ?',$userObj->getPhone());
			}				
			
			$email = "";
			$phone = "";
			$state = "";
			$region = "";
			$city = "";
			$negbor = "";
			$address = "";
			$zip = "";
			$splrqs = "";
			$countrycode = "";
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			if($userObj->getEmail() == "" && $userObj->getPhone() == ""){
				$email = $userObj->getEmail();
				$phone = $userObj->getPhone();
			}else{
				$result = $table->fetchRow($select);				
				if($result){
					if($result->state){
						$state = $result->state;
					}
					if($result->region){
						$region = $result->region;
					}
					if($result->city){
						$city = $result->city;
					}
					if($result->neighborhood){
						$negbor = $result->neighborhood;
					}
					if($result->rguaddress){
						$address = $result->rguaddress;
					}
					if($result->rguzipcode){
						$zip = $result->rguzipcode;
					}
					if($result->rguspecial_request){
						$splrqs = $result->rguspecial_request;
					}
					if($result->rguemail){
						if($data['companyid'] == 2){
							$email = '';
						}else{
							$email = $result->rguemail;
						}
					}
					if($result->rguphone){
						$phone = $result->rguphone;
					}
				}else{
					$email = $userObj->getEmail();
					$phone = $userObj->getPhone();
				} 
			}
			if($phone != ""){
				if($result->rgucountrycode != ""){
					$countrycode =  $result->rgucountrycode;
//				}else{
//					$restMapper = new ManageRestaurant_Model_RestaurantDataMapper();
//					$countrycodeArr = $restMapper->getRestaurantCountryCodeNumber($userObj->getRestaurantId());
//					$countrycode = $countrycodeArr['countrycode'];
				}
			}
			$Obj = array('firstname'=>	$userObj->getFirstName(),
					'lastname'		=>	$userObj->getLastName(),
				   	'Email'			=>	$email,
				  	'Phone'			=>	$phone,
				  	'State'			=>	$state,
					'Region'		=>	$region,
					'City'			=>	$city,
					'Neighborhood'	=>	$negbor,
					'Address'		=>	$address,
					'ZipCode'		=>	$zip,
					'GuestNotes'	=>	$splrqs,
					'countrycode'	=>	$countrycode
				);			
			return $Obj;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	

	public function UpdateUserGustNotes(ManageRestaurant_Model_RestaurantGroupUsers $userObj)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$status = false;
			if($userObj->getEmail() && $userObj->getPhone()){
				$result = $db->fetchOne("select rguid from mt.restaurant_group_users where rgufk_restaurant = ".$userObj->getRestaurantId()." and rguphone = '".$userObj->getPhone()."'and rguemail ILIKE '%".$userObj->getEmail()."%'");
			}else if($userObj->getPhone()){
				$result = $db->fetchOne("select rguid from mt.restaurant_group_users where rgufk_restaurant = ".$userObj->getRestaurantId()." and rguphone = '".$userObj->getPhone()."'");
			}else if($userObj->getEmail()){
				$result = $db->fetchOne("select rguid from mt.restaurant_group_users where rgufk_restaurant = ".$userObj->getRestaurantId()." and rguemail ILIKE '%".$userObj->getEmail()."%'");
			}
			if($result){
				$set = array('rguspecial_request' => $userObj->getSplRequest());
				$where = array('rguid = ?' => $result);
				$rows_affected = $this->getDbTable()->update($set,$where);
				if($rows_affected){
					$status = true;
				}		
			}			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function UpdateCusInfo(ManageRestaurant_Model_RestaurantGroupUsers $userObj)
	{
		try{
			$status = false;
			$db = Zend_Db_Table::getDefaultAdapter();
			if($userObj->getSplRequest()){
				$set = array('rgufirst_name'	=>	$userObj->getFirstName(),
						 'rgulast_name'	 		=>	$userObj->getLastName(),
						 'rguemail'				=>	$userObj->getEmail(),
						 'rguphone'				=>	$userObj->getPhone(),
						 'rguspecial_request'	=>	$userObj->getSplRequest()
						);
			}else{
				$set = array('rgufirst_name'	=>	$userObj->getFirstName(),
						 'rgulast_name'	 		=>	$userObj->getLastName(),
						 'rguemail'				=>	$userObj->getEmail(),
						 'rguphone'				=>	$userObj->getPhone()	
						);
			}
			$where = array('rguid = ?' => $userObj->getId());
			
			$rows_affected = $this->getDbTable()->update($set,$where);
			if($rows_affected){
				$status = true;
			}
			return $status;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function RetrieveRestContactsByRestId($restid)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('rguid','rgufirst_name','rgulast_name','rguemail'))
				   ->where('rgufk_restaurant = ?',$restid)
				   ->where('rguemail <> ?','')
				   ->where('rgustatus = ?',true);
				   
		   $rowset = $table->fetchAll($select);
		   return $rowset;	
		   			   
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getRestaurantContactsByRestid($restid)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('rguid','rgufk_restaurant','rgufk_rsgid','rgufirst_name','rgulast_name','rgugender','rguemail','rguphone','rguaddress','rgustatus','rgucreated_date','rguupdated_date','rgustate_id','rgucity_id','rguzipcode','rguneighbourhood_id','rguregion_id','rguspecial_request'))
				   ->where('rgufk_restaurant = ?',$restid)
				   ->where('rgu_sync_status IS NULL')
				   ->order(array('rguid'))
				   ->limit(500);
			$rowset = $table->fetchAll($select);
		   	$RestContacts = array();
			foreach($rowset as $key=>$value){
				$subArr = array();
				foreach($value as  $key1=>$value1){
					$subArr[$key1]= $value1;
				}
				$RestContacts[] = $subArr;
			}
			return $RestContacts;	   
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
/** Updating customer contact details by ajaxcall**/
	
	public function UpdateUserContactDetails(ManageRestaurant_Model_RestaurantGroupUsers $contactObj)
	{
		try{
			$status = false;
			$db = Zend_Db_Table::getDefaultAdapter();
			$set=array(
						'rgufirst_name'			=>	$contactObj->getFirstName(),
					    'rgulast_name'			=>	$contactObj->getLastName(),
						'rguemail'				=>	$contactObj->getEmail(),
					    'rguphone'				=>	$contactObj->getPhone(),
						'rguaddress'			=>  $contactObj->getAddress(),
						'rguzipcode'			=>  $contactObj->getZipCode(),
						
					  );
			if($contactObj->getState()){
				$set['rgustate_id'] = $contactObj->getState();
			}else{
				$set['rgustate_id'] = null;
			}
			if($contactObj->getRegion()){
				$set['rguregion_id'] = $contactObj->getRegion();
			}else{
				$set['rguregion_id'] = null;
			}
			if($contactObj->getCity()){
				$set['rgucity_id'] = $contactObj->getCity();
			}else{
				$set['rgucity_id'] = null;
			}
			if($contactObj->getNeighbourhood()){
				$set['rguneighbourhood_id'] = $contactObj->getNeighbourhood();
			}else{
				$set['rguneighbourhood_id'] = null;
			}
			$where = array('rguid = ?' => $contactObj->getId(),'rgufk_restaurant = ?' => $contactObj->getRestaurantId());
			
			$rows_affected = $this->getDbTable()->update($set,$where);
			if($rows_affected){
				$result = array();
				$table = $this->getDbTable();
				$select = $table->select();
				$select->setIntegrityCheck(false);
				$select->from($table,array('rguid','rgufk_restaurant','rgufk_rsgid','rgufirst_name','rgulast_name','rguemail','rguphone','rguaddress','rguzipcode'));
				$select->joinLeft(array('sta'=>'mt.state_bd'),'sta.id = rgustate_id',array('id as stateid','description as state'));
				$select->joinLeft(array('reg'=>'mt.region_bd'),'reg.id = rguregion_id',array('id as regionid','description as region'));
				$select->joinLeft(array('cty'=>'mt.city_bd'),'cty.id = rgucity_id',array('id as cityid','description as city'));
				$select->joinLeft(array('neg'=>'mt.neighborhood_bd'),'neg.id = rguneighbourhood_id',array('id as neighbid','description as neighborhood'));
				$select->where('rgufk_restaurant = ?',$contactObj->getRestaurantId());
			   	$select->where('rguid  = ?',$contactObj->getId());
				$rowset = $table->fetchRow($select);
				$stateid = $rowset->stateid;
				$regionid = $rowset->regionid;
				$cityid = $rowset->cityid;
				$neighbid = $rowset->neighbid;
				if($rowset->stateid == null){
					$rowset->state = '';
					$stateid = '';
				}
				if($rowset->regionid == null){
					$rowset->region = '';
					$regionid = '';
				}
				if($rowset->cityid == null){
					$rowset->city = '';
					$cityid = '';
				}
				if($rowset->neighbid == null){
					$rowset->neighborhood = '';
					$neighbid = '';
				}
				if($rowset)
				{
					$resultarr = array('firstName'			=> $rowset->rgufirst_name,
									   'lastName'			=> $rowset->rgulast_name,	
									   'Phone'				=> $rowset->rguphone,	
									   'Email'				=> $rowset->rguemail,	
								       'Address'			=> $rowset->rguaddress,	
								       'Zipcode'			=> $rowset->rguzipcode,	
							           'State'				=> $rowset->state,	
								       'Region'				=> $rowset->region,	
								       'City'				=> $rowset->city,	
							           'Neighbourhood'		=> $rowset->neighborhood,
							           'State_Id'			=> $stateid,
							           'Region_Id'			=> $regionid,
							           'City_Id'			=> $cityid,
							           'Neighbor_Id'		=> $neighbid
					);
	   	
				}
				$result = $resultarr;
			}
			return $result;
			}catch (Exception $ex){
				throw new Exception($ex->getMessage()) ;
			}
	}

	public function SaveNativeCustContacts($contactlist)
	{
		try
		{
			$db = Zend_Db_Table::getDefaultAdapter();
			$db->beginTransaction();
			$resultArray = array();

			$writer = new Zend_Log_Writer_Stream('/logs/app-import.txt');
			$logger = new Zend_Log($writer); 
			$logger->info(print_r($contactList,true));

			foreach($contactlist as $contact)
			{
				$user = new ManageRestaurant_Model_RestaurantGroupUsers();
						$user->setRestaurantId($contact->rgufk_restaurant)
							 ->setGroupId(3)
							 ->setFirstName($contact->rgufirst_name)
						     ->setLastName($contact->rgulast_name)
							 ->setEmail($contact->rguemail)
							 ->setPhone($contact->rguphone)
							 ->setSplRequest($contact->rguspecial_request)
							 ->setStatus(TRUE);
				
				$webid = $this->addUserContactToWeb($user);
				
				$resultArray[] = array('rguid' => $contact->rguid, 'rguwebid' => $webid);					
			}
			$db->commit();		    
			return $resultArray;
			
		}catch (Exception $ex){	
			$db->rollBack();			
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function addUserContactToWeb(ManageRestaurant_Model_RestaurantGroupUsers $user)
	{
			$db = Zend_Db_Table::getDefaultAdapter();
			$webid = 0;
			$data = array(
						'rgufk_restaurant'		=>	$user->getRestaurantId(),
						'rgufk_rsgid'			=>	$user->getGroupId(),
						'rgufirst_name'			=>	$user->getFirstName(),
						'rgulast_name'			=>	$user->getLastName(),
						'rgustatus'				=>	$user->getStatus(),	
						'rguspecial_request'	=> 	$user->getSplRequest(),					
						);
			if($user->getEmail()){
				$data['rguemail'] = $user->getEmail();
			}
			if($user->getPhone()){
				$data['rguphone'] = $user->getPhone();
			}
			
			try{
				$whtShouldIUpdate = '';
				
				if($user->getEmail() && $user->getPhone()){
					$result = $db->fetchOne("select count(rguid) from mt.restaurant_group_users where rgufk_restaurant = ".$user->getRestaurantId()." and rguphone = '".$user->getPhone()."'and rguemail ILIKE '%".$user->getEmail()."%'");
					if($result == 0)
					{
						$result =="";
						$result = $db->fetchOne("select count(rguid) from mt.restaurant_group_users where rgufk_restaurant = ".$user->getRestaurantId()." and rguphone = '".$user->getPhone()."'");
						if($result == 0){
							$result =="";
							$result = $db->fetchOne("select count(rguid) from mt.restaurant_group_users where rgufk_restaurant = ".$user->getRestaurantId()." and rguemail ILIKE '%".$user->getEmail()."%'");
							if($result == 0){
								$whtShouldIUpdate = 'Both';	
							}else{
								$whtShouldIUpdate = 'Phone';
							}
						}else{
							$whtShouldIUpdate = 'email';
						}
					}
				}else if($user->getPhone()){
					$result = $db->fetchOne("select count(rguid) from mt.restaurant_group_users where rgufk_restaurant = ".$user->getRestaurantId()." and rguphone = '".$user->getPhone()."'");
					if($result == 0)
					{
						$whtShouldIUpdate = 'Both';
					}
				}else if($user->getEmail()){
					$result = $db->fetchOne("select count(rguid) from mt.restaurant_group_users where rgufk_restaurant = ".$user->getRestaurantId()." and rguemail ILIKE '%".$user->getEmail()."%'");
					if($result == 0)
					{
						$whtShouldIUpdate = 'Both';
					}
				}else{
					if($user->getSplRequest() && !$user->getId()){
						$whtShouldIUpdate = 'Both';
					}
				}
				
				if($whtShouldIUpdate == 'Both')
				{
					$webid = $this->getDbTable()->insert($data);
					
				}else if($whtShouldIUpdate == 'email'){
					if($user->getSplRequest()){
						$set = array('rguspecial_request' => $user->getSplRequest(),
									'rguemail'			  => $user->getEmail()
									);
					}else{
						$set = array('rguemail'			  => $user->getEmail());
					}
					$where = array('rgufk_restaurant = ?'		=>	$user->getRestaurantId(),
								   'rguphone = ?'				=>	$user->getPhone()	
							);
					$rows_affected = $this->getDbTable()->update($set,$where);
					
					/* Select Updated Web Contact Id */
					if($rows_affected)
					{
						$webid = $db->fetchOne("select rguid from mt.restaurant_group_users where rgufk_restaurant = ".$user->getRestaurantId()." and rguphone = '".$user->getPhone()."'");
					}
					
				}else if($whtShouldIUpdate == 'Phone'){
					if($user->getSplRequest()){
						$set = array('rguspecial_request' => $user->getSplRequest(),
									'rguphone'			  => $user->getPhone()
									);
					}else{
						$set = array('rguphone'			  => $user->getPhone());
					}
					$where = array('rgufk_restaurant = ?'		=>	$user->getRestaurantId(),
								   'rguemail = ?'				=>	$user->getEmail()	
							);
					$rows_affected = $this->getDbTable()->update($set,$where);	
					
					/* Select Updated Web Contact Id */
					if($rows_affected)
					{
						$webid = $db->fetchOne("select rguid from mt.restaurant_group_users where rgufk_restaurant = ".$user->getRestaurantId()." and rguemail ILIKE '%".$user->getEmail()."%'");
					}					
				}else{
					if($user->getSplRequest()){
						
						$selectWebIdQuery = "";
						
						$set = array('rguspecial_request' => $user->getSplRequest());
						if($user->getId()){
							$where = array('rguid = ?' => $user->getId());							
						}else if($user->getEmail() && $user->getPhone()){
							$where = array('rgufk_restaurant = ?'	=>	$user->getRestaurantId(),
									       'rguemail ILIKE (?)'		=>	'%'.$user->getEmail().'%',
									       'rguphone = ?'				=>	$user->getPhone()	
									);
						 	$selectWebIdQuery = "select rguid from mt.restaurant_group_users where rgufk_restaurant = ".$user->getRestaurantId()." and rguphone = '".$user->getPhone()."' and rguemail ILIKE '%".$user->getEmail()."%'";
						 		
						}else if($user->getPhone()){
							$where = array('rgufk_restaurant = ?'	=>	$user->getRestaurantId(),
									       'rguphone = ?'				=>	$user->getPhone()	
									);
							$selectWebIdQuery = "select rguid from mt.restaurant_group_users where rgufk_restaurant = ".$user->getRestaurantId()." and rguphone = '".$user->getPhone()."'";
																
						}else{
							
							$where = array('rgufk_restaurant = ?'	=>	$user->getRestaurantId(),
									       'rguemail ILIKE (?)'		=>	'%'.$user->getEmail().'%'
										  );
									
						    $selectWebIdQuery = "select rguid from mt.restaurant_group_users where rgufk_restaurant = ".$user->getRestaurantId()." and rguemail ILIKE '%".$user->getEmail()."%'";
						}
												
						$rows_affected = $this->getDbTable()->update($set,$where);
						
						$webid = $db->fetchOne($selectWebIdQuery);
					}
				}
				
				if($webid == 0)
				{
					if($user->getEmail() && $user->getPhone()){
						$webid = $db->fetchOne("select rguid from mt.restaurant_group_users where rgufk_restaurant = ".$user->getRestaurantId()." and rguphone = '".$user->getPhone()."'and rguemail ILIKE '%".$user->getEmail()."%'");						
					}else if($user->getPhone()){
						$webid = $db->fetchOne("select rguid from mt.restaurant_group_users where rgufk_restaurant = ".$user->getRestaurantId()." and rguphone = '".$user->getPhone()."'");						
					}else if($user->getEmail()){
						$webid = $db->fetchOne("select rguid from mt.restaurant_group_users where rgufk_restaurant = ".$user->getRestaurantId()." and rguemail ILIKE '%".$user->getEmail()."%'");
					}
				}				
				return $webid;
			}catch(Exception $ex){	
				throw new Exception($ex->getMessage()) ;
			}
	}
	
	public function updateContactsSyncStatusFromNative($contactdetails)
	{
		try
		{
			$db = Zend_Db_Table::getDefaultAdapter();
			$table  = $this->getDbTable();
			$set = array('rgu_sync_status' => 'S');
			
			$where = $db->quoteInto('rguid IN(?)',$contactdetails);
			$row_affected = $table->update($set,$where);
			return $row_affected;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}
