<?php

class ManageRestaurant_Model_RestaurantMenuDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
				
			$this->setDbTable('ManageRestaurant_Model_DbTable_RestaurantMenu');
		}
		return $this->_dbTable;
	}

	public function getRestaurantsMenu(ManageRestaurant_Model_GetMenuByRestId $menurestbyid)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();

			$select->from($table,array('rsmid','rsmmenu'))
			->where('rsmfk_restaurant = ?',$menurestbyid->getRestaurantId())
			->orwhere('rsmmenu_type_id = ?',1)
			->where('rsmstatus = ?',true);
			$rowset = $table->fetchAll($select);
			$restaurantMenu = array();
			foreach($rowset as $row){
				$resMenu = new ManageRestaurant_Model_RestaurantMenu();
				$resMenu->setrsmid($row['rsmid'])
				->setrsmmenu($row['rsmmenu']);
				$restaurantMenu[] = $resMenu;
			}
			return $restaurantMenu;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function addRestaurantMenu(ManageRestaurant_Model_RestaurantMenu $resMenu)
	{
		try{
			$resMenuData = array(
	  		'rsmfk_restaurant' 	=> $resMenu->getrsmid(),
			'rsmmenu'           => trim($resMenu->getrsmmenu()),
		    'rsmmenu_type_id'   => 2,
			'rsmstatus'         => true,
			'rsmcreated_date'   => date('Y-m-d H:i:s'));  		
			 
			$resMenuId = $this->getDbTable()->insert($resMenuData);
			return $resMenuId;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function addRestaurantValidation(ManageRestaurant_Model_RestaurantMenu $resMenu)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$records = $db->fetchRow(
    						"select count('rsmid') as count from mt.restaurant_menu  where rsmmenu = :menu",
			array('menu' => $resMenu->getrsmmenu()));

			$menuFlag = $records['count'];


			return $menuFlag;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

}

