<?php
class ManageRestaurant_Model_RestaurantScheduleTableDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {

			$this->setDbTable('ManageRestaurant_Model_DbTable_RestaurantScheduleTable');
		}
		return $this->_dbTable;
	}
	
	public function createInventorys(array $resInventoryArr,$schid)
	{
		try{
			$table = $this->getDbTable();
			foreach($resInventoryArr as $resInventory){
				if($resInventory->getrstid()){
					$set 	= array(
					 	'rsttable_pax' 		  		 => $resInventory->getrsttable_pax(),
						'rstno_of_tables' 		     => $resInventory->getrstno_of_tables()
					);
					$where 	= array('rstid = ?' => $resInventory->getrstid());
					$rows_affected = $table->update($set,$where);
						
				}else{
						
					$resInventoryData = array(
				  		'rsttable_pax' 		  		 => $resInventory->getrsttable_pax(),
						'rstno_of_tables' 		     => $resInventory->getrstno_of_tables(),
						'rstfk_restaurant_schedule'  =>	$schid,
						'rststatus'					 => true
					);
					$id = $table->insert($resInventoryData);
						
				}

			}

		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}

	}
	
	public function deleteInventoryBySchId($schid)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$set = array('rststatus' => 0);
			$where = array('rstfk_restaurant_schedule = ?'=> $schid);
			$rows_affected = $this->getDbTable()->update($set,$where);
			return $rows_affected;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function checkInventoryById($inventoryid)
	{
		try{
			$bookStatusMapper = new Application_Model_BookingStatusDataMapper();
			$bookStatus = array('CAN','COM','RES','WAL');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
			$status = $bookStatusRes;
			foreach($status as $key=>$value){
				$statusId[] = $value->getId();
			}
			$bokmapper = new Booking_Model_BookingDataMapper();
			$table = $bokmapper->getDbTable();
			$select = $table->select();

			$select->from($table,array('bokid'))
			->where('bokfk_rest_sch_table = ?',(int)$inventoryid)
			->where("bokbooking_status_id NOT IN(?)",$statusId);
			$rowset = $table->fetchAll($select);
			if(count($rowset)){
				return 0;
			}
			else{
				$result = $this->deleteInventoryById($inventoryid);
				return 1;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function checkInventoryCount($inventoryid)
	{
		try{
			$bookStatusMapper = new Application_Model_BookingStatusDataMapper();
			$bookStatus = array('CAN','COM','RES','WAL');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
			$status = $bookStatusRes;
			foreach($status as $key=>$value){
				$statusId[] = $value->getId();
			}

			$bokmapper = new Booking_Model_BookingDataMapper();
			$table = $bokmapper->getDbTable();
			$select = $table->select();

			$select->from($table,array('bokid'))
			->where('bokfk_rest_sch_table = ?',(int)$inventoryid)
			->where("bokbooking_status_id NOT IN(?)",$statusId);
			$rowset = $table->fetchAll($select);
			$varcount = count($rowset);
			return $varcount-1;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getInventoryBySchId($schid)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$bookStatusMapper = new Application_Model_BookingStatusDataMapper();
			$bookStatus = array('CAN','COM','RES','WAL');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
			$status = $bookStatusRes;
			foreach($status as $key=>$value){
				$statusId[] = $value->getId();
			}

			$select->from($table,array('rstid'))
			->where('rstfk_restaurant_schedule = ?',(int)$schid);


			$rowset = $table->fetchAll($select);
			$inventoryArr = null;
			foreach($rowset as $inventory){
				$inventoryArr[] = $inventory->rstid;
			}

			$bokmapper = new Booking_Model_BookingDataMapper();
			$boktable = $bokmapper->getDbTable();
			$selectinventory = $boktable->select();
			$selectinventory->from($boktable,array('bokid'))
			->where('bokfk_rest_sch_table IN(?)',$inventoryArr)
			->where("bokbooking_status_id NOT IN(?)",$statusId);
			$result = $table->fetchAll($selectinventory);
			if(count($result)){
				return true;
			}else{
				return false;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function deleteInventoryById($inventoryid)
	{
		try{
			$set = array('rststatus' => 0);
			$where = array('rstid = ?' => (int)$inventoryid);
				
			$rows_affected = $this->getDbTable()->update($set,$where);
			return $rows_affected;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function GetInventoryCountsByRestId($restid,array $days,$schtype)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);	
			
			$select->from(array('schtbl'=>'mt.restaurant_schedule_table'),array('sum(rsttable_pax * rstno_of_tables) as invcount'))
				   ->join(array('sch'=>'mt.restaurant_schedule'),'schtbl.rstfk_restaurant_schedule = sch.rssid',array('rssday_of_week'))
				   ->join(array('meal'=>'mt.restaurant_meal_type'),'meal.rmt_restaurant =  sch.rssfk_restaurant',array('rmt_id'))
				   ->join(array('mealtyp'=>'mt.meal_type_bd'),'mealtyp.id = meal.rmt_meal_type',array('description as mealtype'))
				   ->where('sch.rssfk_restaurant = ?',$restid)
				   ->where('sch.rssday_of_week IN(?)',$days)
				   ->where('sch.rssscheduletype_id = ?',$schtype)
				   ->where('sch.rssstatus = ?',true)
				   ->where('schtbl.rststatus = ?',true)
				   ->where('sch.rssstart_time >= meal.rmt_start_time')
				   ->where('sch.rssstart_time <= meal.rmt_end_time')
				   ->where('meal.rmt_status = ?','Y')
				   ->group(array('meal.rmt_id','mealtyp.description','sch.rssday_of_week'))
				   ->order(array('sch.rssday_of_week','mealtyp.description'));
				   
			$rowset = $table->fetchAll($select);
			
			$inventoryCount = array();
			
			if(count($rowset)>0){
				$day = "";
				$prevDay = "";
				$mealCountArr = array();
				$count = 0;
				
				foreach($rowset as $row){
					$count++;
					if($day == ""){
						$day = $row->rssday_of_week;
						$prevDay = $day;
						$mealCountArr[$row->mealtype] = $row->invcount;
					}else{
						$day = $row->rssday_of_week;
						if($day == $prevDay){
							$mealCountArr[$row->mealtype] = $row->invcount;
						}else{
							$inventoryCount[$prevDay] = $mealCountArr;
							$mealCountArr = null;
							$day = $row->rssday_of_week;
							$prevDay = $day;
							$mealCountArr[$row->mealtype] = $row->invcount;							
						}
					}
				}

				$inventoryCount[$day] = $mealCountArr;
				
			}
	
			return $inventoryCount;
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getSumOfPartysizesByDay($restaurantid,$weekDayArr)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			$select->from(array('rst'=>'mt.restaurant_schedule_table'),array('SUM(rsttable_pax * rstno_of_tables) as totPax'))
					 ->join(array('rs'=>'mt.restaurant_schedule'),'rst.rstfk_restaurant_schedule = rs.rssid',array('rssday_of_week'))
					 ->join(array('meal'=>'mt.restaurant_meal_type'),'meal.rmt_restaurant =  rs.rssfk_restaurant',array('rmt_id'))
				     ->join(array('mealtyp'=>'mt.meal_type_bd'),'mealtyp.id = meal.rmt_meal_type',array('description as mealtype'))
					 ->where('rs.rssfk_restaurant = ?',$restaurantid)
					 ->where('rs.rssday_of_week IN(?)',$weekDayArr)
					 ->where('rs.rssscheduletype_id = ?',1)
					 ->where('rs.rssstatus = ?',true)
					 ->where('rst.rststatus = ?',true)
					 ->where('rs.rssstart_time >= meal.rmt_start_time')
				     ->where('rs.rssstart_time <= meal.rmt_end_time')
				     ->where('meal.rmt_status = ?','Y')
					 ->group(array('rs.rssday_of_week','meal.rmt_id','mealtyp.description'))
					 ->order(array('rs.rssday_of_week','mealtyp.description'));
					 
			$rowSet = $table->fetchAll($select);
			$resultArr = array();
			foreach($weekDayArr as $weekday){
				$resultArr[ucwords($weekday)] = 0;
			}
			if(count($rowSet) > 0){
				foreach($rowSet as $row){
					$resultArr[ucwords($row->rssday_of_week)] = $resultArr[ucwords($row->rssday_of_week)]+$row->totPax;
				}
			}
			return $resultArr;
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function createInventorysAjax(array $resInventoryArr,$schid)
	{
		try{
			$table = $this->getDbTable();
			$status = false;
			$result = array();
			foreach($resInventoryArr as $resInventory){
				if($resInventory->getrstid()){
					$set 	= array(
					 	'rsttable_pax' 		  		 => $resInventory->getrsttable_pax(),
						'rstno_of_tables' 		     => $resInventory->getrstno_of_tables()
					);
					$where 	= array('rstid = ?' => $resInventory->getrstid());
					$rows_affected = $table->update($set,$where);
					$result[$resInventory->getrsttable_pax()] = $resInventory->getrstid();
				}else{
						
					$resInventoryData = array(
				  		'rsttable_pax' 		  		 => $resInventory->getrsttable_pax(),
						'rstno_of_tables' 		     => $resInventory->getrstno_of_tables(),
						'rstfk_restaurant_schedule'  =>	$schid,
						'rststatus'					 => true
					);
					$id = $table->insert($resInventoryData);
					$result[$resInventory->getrsttable_pax()] = $id;	
				}
			}
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}

	}
}