<?php

class ManageRestaurant_Model_ScheduleCuisineDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('ManageRestaurant_Model_DbTable_ScheduleCuisine');
		}
		return $this->_dbTable;
	}

	public function save(ManageRestaurant_Model_ScheduleCuisine $cusinie)
	{
		try{
			$data = array(
			'rscfk_restaurant_schedule'    => $cusinie->getResScheduleId(),
			'rsccuisine_type_id'   => $cusinie->getResTypeId(),
			'rscstatus' =>	$cusinie->getStatus(),
			'resfk_restaurant_resid' => $cusinie->getResId()
				
			);
			$this->getDbTable()->insert($data);
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function getCuisine(ManageRestaurant_Model_ScheduleCuisine $cusinie)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array(
						'rsccuisine_type_id'
						))
						->where('rscfk_restaurant_schedule = ?',$cusinie->getResScheduleId());
						$resultset = $this->getDbTable()->fetchAll($select);
						$cStr = "";
						foreach($resultset as $value){
							$cStr .= $value->rsccuisine_type_id.",";
						}
						return $cStr;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function deleteCuisine(ManageRestaurant_Model_ScheduleCuisine $cuisine)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$where = $db->quoteInto('resfk_restaurant_resid = ?', $cuisine->getResId());

			$this->getDbTable()->delete($where);
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

}

