<?php
class Notification_Model_EmailMessage
{
	private $_id;
	private $_title;
	private $_description;
	private $_priority;
	private $_emailtype;
	private $_usertype;
	private $_stateid;
	private $_cityid;
	private $_sentby;
	private $_signature;
	private $_docpath;	
	private $_bokid;
	private $_emsg_msg_phrase;
	
	public function __construct(array $options = null)
	{
		if(is_array($options)){
			$this->setOptions($options);
		}		
	}
	
	public function __set($name, $value)
	{
		$method = 'set' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid City_BD property');
		}
		$this->$method($value);
	}
	
	public function __get($name)
	{
		$method = 'get' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid State_BD property');
		}
		return $this->$method();
	}
	
	public function setOptions(array $options)
	{
		$methods = get_class_methods($this);
		foreach ($options as $key => $value) {
			$method = 'set' . ucfirst($key);
			if (in_array($method, $methods)) {
				$this->$method($value);
			}
		}
		return $this;
	}
	
	
	public function setid($id)
	{
		$this->_id = $id;
		return $this;
	}
	
	public function getid()
	{
		return $this->_id;
	}
	
	public function setTitle($title)
	{
		$this->_title = $title;
		return $this;
	}
	
	public function getTitle()
	{
		return $this->_title;
	}
	
	public function setDescription($description)
	{
		$this->_description = $description;
		return $this;
	}
	
	public function getDescription()
	{
		return $this->_description;
	}
	
	public function setPriority($priority)
	{
		$this->_priority = $priority;
		return $this;
	}
	
	public function getPriority()
	{
		return $this->_priority;
	}
	
	public function setEmailtype($emailtype)
	{
		$this->_emailtype = $emailtype;
		return $this;
	}
	
	public function getEmailtype()
	{
		return $this->_emailtype;
	}
	
	public function setUsertype($usertype)
	{
		$this->_usertype = $usertype;
		return $this;
	}
	
	public function getUsertype()
	{
		return $this->_usertype;
	}
	
	public function setStateid($stateid)
	{
		$this->_stateid = $stateid;
		return $this;
	}
	
	public function getStateid()
	{
		return $this->_stateid;
	}
	
	public function setCityid($cityid)
	{
		$this->_cityid = $cityid;
		return $this;
	}
	
	public function getCityid()
	{
		return $this->_cityid;
	}
	
	public function setSentby($sentby)
	{
		$this->_sentby = $sentby;
		return $this;
	}
	
	public function getSentby()
	{
		return $this->_sentby;
	}
	
	public function setSignature($signature)
	{
		$this->_signature = $signature;
		return $this;
	}
	
	public function getSignature()
	{
		return $this->_signature;
	}
	
	public function setDocpath($docpath)
	{
		$this->_docpath = $docpath;
		return $this;
	}
	
	public function getDocpath()
	{
		return $this->_docpath;
	}
	
	public function setBokid($bokid)
	{
		$this->_bokid = $bokid;
		return $this;
	}
	
	public function getBokid()
	{
		return $this->_bokid;
	}
	
	public function setPhrase($emsg_msg_phrase)
	{
		$this->_emsg_msg_phrase = $emsg_msg_phrase;
		return $this;
	}
	
	public function getPhrase()
	{
		return $this->_emsg_msg_phrase;
	}
}