<?php
class Notification_Model_SmsMessage
{
	private $_id;
	private $_title;
	private $_description;
	private $_priority;
	private $_smstype;
	private $_usertype;
	private $_sentto;
	private $_senton;
	private $_sentby;
	private $_senttouser;
	private $_sentfromuser;	
	private $_bokid;
	private $_emsg_msg_phrase;
	private $_emsg_msg_reference;
	
	public function __construct(array $options = null)
	{
		if(is_array($options)){
			$this->setOptions($options);
		}		
	}
	
	public function __set($name, $value)
	{
		$method = 'set' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid City_BD property');
		}
		$this->$method($value);
	}
	
	public function __get($name)
	{
		$method = 'get' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid State_BD property');
		}
		return $this->$method();
	}
	
	public function setOptions(array $options)
	{
		$methods = get_class_methods($this);
		foreach ($options as $key => $value) {
			$method = 'set' . ucfirst($key);
			if (in_array($method, $methods)) {
				$this->$method($value);
			}
		}
		return $this;
	}
	
	
	public function setid($id)
	{
		$this->_id = $id;
		return $this;
	}
	
	public function getid()
	{
		return $this->_id;
	}
	
	public function setTitle($title)
	{
		$this->_title = $title;
		return $this;
	}
	
	public function getTitle()
	{
		return $this->_title;
	}
	
	public function setDescription($description)
	{
		$this->_description = $description;
		return $this;
	}
	
	public function getDescription()
	{
		return $this->_description;
	}
	
	public function setPriority($priority)
	{
		$this->_priority = $priority;
		return $this;
	}
	
	public function getPriority()
	{
		return $this->_priority;
	}
	
	public function setSmstype($smstype)
	{
		$this->_smstype = $smstype;
		return $this;
	}
	
	public function getSmstype()
	{
		return $this->_smstype;
	}
	
	public function setUsertype($usertype)
	{
		$this->_usertype = $usertype;
		return $this;
	}
	
	public function getUsertype()
	{
		return $this->_usertype;
	}
	
	public function setSentTo($sentto)
	{
		$this->_sentto = $sentto;
		return $this;
	}
	
	public function getSentTo()
	{
		return $this->_sentto;
	}
	
	public function setSentOn($SentOn)
	{
		$this->_senton = $SentOn;
		return $this;
	}
	
	public function getSentOn()
	{
		return $this->_senton;
	}
	
	public function setSentby($sentby)
	{
		$this->_sentby = $sentby;
		return $this;
	}
	
	public function getSentby()
	{
		return $this->_sentby;
	}
	
	public function setSentToUser($SentToUser)
	{
		$this->_senttouser = $SentToUser;
		return $this;
	}
	
	public function getSentToUser()
	{
		return $this->_senttouser;
	}
	
	public function setSentFromUser($SentFromUser)
	{
		$this->_sentfromuser = $SentFromUser;
		return $this;
	}
	
	public function getSentFromUser()
	{
		return $this->_sentfromuser;
	}
	
	public function setBokid($bokid)
	{
		$this->_bokid = $bokid;
		return $this;
	}
	
	public function getBokid()
	{
		return $this->_bokid;
	}
	
	public function setPhrase($emsg_msg_phrase)
	{
		$this->_emsg_msg_phrase = $emsg_msg_phrase;
		return $this;
	}
	
	public function getPhrase()
	{
		return $this->_emsg_msg_phrase;
	}
	
	public function setReference($_emsg_msg_reference)
	{
		$this->_emsg_msg_reference = $_emsg_msg_reference;
		return $this;
	}
	
	public function getReference()
	{
		return $this->_emsg_msg_reference;
	}
}