<?php
class Payments_Model_AuthnetCustomerProfileMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Payments_Model_DbTable_AuthnetCustomerProfile');
		}
		return $this->_dbTable;
	}
	
	public function GetAuthNetCustProfIdByUserId(Payments_Model_GetAuthNetCustProfId $object)
	{
		try
		{
			$profile_id  = "";
			$table  = $this->getDbTable();
			$select = $table->select();
			
			$select->from($table,array('ancpid','ancpcustomer_profile_id as ProfileId'))
			       ->where('ancpuser_id = ?',$object->getancpuser_id());
			
			$row = $table->fetchRow($select);
			
			return $row;
			 	
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}		
	}
	
	public function SaveAuthNetCusomerProfile(Payments_Model_AuthnetCustomerProfile $object)
	{
		try
		{
			$table = $this->getDbTable();
			$data = array('ancpprofile_description' => $object->getancpprofile_description(),
						  'ancpcustomer_profile_id' => $object->getancpcustomer_profile_id(),
						  'ancpuser_id' 			=> $object->getancpuser_id(),
						  'ancpcreated_date'		=> $object->getancpcreated_date(),
						  'ancpcreated_time'		=> $object->getancpcreated_time(),
						  'ancpstatus'				=> $object->getancpstatus(),
						  'ancpemail'				=> $object->getancpemail(),
						  'ancpstatus'				=> $object->getancpstatus());
			$result = $table->insert($data);
			return $result;
			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}	
}