<?php
class Payments_Model_SpecialInvoice
{
	private $_invid;
	private $_special_id;
	private $_invrestaurant_id;
	private $_customer_id;
	private $_booking_id;
	private $_invdescription;
	private $_invbilling_fromdate;
	private $_invbilling_todate;
	private $_invamount;
	private $_invtotamount;
	private $_invservice_tax;
	private $_invservice_taxtotal;
	private $_invtxncharges;
	private $_invstatus;
	private $_invgenerated_date;
	private $_invgenerated_time;
	private $_invcreated_by;
	private $_custprofid;
	private $_paymentprofid;
	
	public function __construct(array $options = null)
	{
		if(is_array($options)){
			$this->setOptions($options);
		}		
	}
	
	public function __set($name, $value)
	{
		$method = 'set' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Invoice Table property');
		}
		$this->$method($value);
	}
	
	public function __get($name)
	{
		$method = 'get' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Special Invoice property');
		}
		return $this->$method();
	}
	
	public function setOptions(array $options)
	{
		$methods = get_class_methods($this);
		foreach ($options as $key => $value) {
			$method = 'set' . ucfirst($key);
			if (in_array($method, $methods)) {
				$this->$method($value);
			}
		}
		return $this;
	}
	
	public function setinvid($invid)
	{
		$this->_invid = $invid;
		return $this;
	}
	
	public function getinvid()
	{
		return $this->_invid;
	}
	
	public function setinvrestaurant_id($invrestaurant_id)
	{
		$this->_invrestaurant_id = $invrestaurant_id;
		return $this;
	}
	
	public function getinvrestaurant_id()
	{
		return $this->_invrestaurant_id; 
	}
	
	public function setinvcustomer_id($invcus_id)
	{
		$this->_customer_id = $invcus_id;
		return $this;
	}
	
	public function getinvcustomer_id()
	{
		return $this->_customer_id; 
	}
	
	public function setinvbooking_id($invbok_id)
	{
		$this->_booking_id = $invbok_id;
		return $this;
	}
	
	public function getinvbooking_id()
	{
		return $this->_booking_id; 
	}
	
	public function setinvdescription($invdescription)
	{
		$this->_invdescription = $invdescription;
		return $this;
	}
	
	public function getinvdescription()
	{
		return $this->_invdescription;
	}
	
	public function setinvbilling_fromdate($invbilling_fromdate)
	{
		$this->_invbilling_fromdate = $invbilling_fromdate;
		return $this;
	}
	
	public function getinvbilling_fromdate()
	{
		return $this->_invbilling_fromdate;
	}
	
	public function setinvbilling_todate($invbilling_todate)
	{
		$this->_invbilling_todate = $invbilling_todate;
		return $this;
	}
	
	public function getinvbilling_todate()
	{
		return $this->_invbilling_todate;
	}
	
	public function setinvamount($invamount)
	{
		$this->_invamount = $invamount;
		return $this;
	}
	
	public function getinvamount()
	{
		return $this->_invamount;
	}
	
	public function setinvstatus($invstatus)
	{
		$this->_invstatus = $invstatus;
		return $this;
	}
	
	public function getinvstatus()
	{
		return $this->_invstatus;
	}
	
	public function setinvgenerated_date($invgenerated_date)
	{
		$this->_invgenerated_date= $invgenerated_date;
		return $this;
	}
	
	public function getinvgenerated_date()
	{
		return $this->_invgenerated_date;	
	}
	
	public function setinvgenerated_time($invgenerated_time)
	{
		$this->_invgenerated_time = $invgenerated_time;
		return $this;
	}
	
	public function getinvgenerated_time()
	{
		return $this->_invgenerated_time;
	}
	
	public function setinvcreated_by($invcreated_by)
	{
		$this->_invcreated_by = $invcreated_by;
		return $this;
	}
	
	public function getinvcreated_by()
	{
		return $this->_invcreated_by;
	}
	
	public function setcustprofid($custprofid)
	{
		$this->_custprofid = $custprofid;
		return $this;
	}
	
	public function getcustprofid()
	{
		return $this->_custprofid;
	}
	
	public function setpaymentprofid($paymentprofid)
	{
		$this->_paymentprofid = $paymentprofid;
		return $this;
	}
	
	public function getpaymentprofid()
	{
		return $this->_paymentprofid;
	}
	
	public function setinvtotamount($invtotamount)
	{
		$this->_invtotamount = $invtotamount;
		return $this;
	}
	
	public function getinvtotamount()
	{
		return $this->_invtotamount;
	}
	
	public function setinvservice_tax($invservice_tax)
	{
		$this->_invservice_tax = $invservice_tax;
		return $this;
	}
	
	public function getinvservice_tax()
	{
		return $this->_invservice_tax;
	}
	
	public function setinvtxncharges($invtxncharges)
	{
		$this->_invtxncharges = $invtxncharges;
		return $this;
	}
	
	public function getinvtxncharges()
	{
		return $this->_invtxncharges;
	}
	
	public function setinvservice_taxtotal($invservice_taxtotal)
	{
		$this->_invservice_taxtotal = $invservice_taxtotal;
		return $this;
	}
	
	public function getinvservice_taxtotal()
	{
		return $this->_invservice_taxtotal;
	}
	
	public function setinvspecial_id($invspl_id)
	{
		$this->_special_id = $invspl_id;
		return $this;
	}
	
	public function getinvspecial_id()
	{
		return $this->_special_id; 
	}
}