<?php
class Payments_Model_Transactions
{
	Private $_txnid;
	Private $_txnfk_restaurant;
	Private $_txntransaction_id;
	Private $_txninvoice_number;
	Private $_txnpayment_profile_id;
	Private $_txntransaction_amount;
	Private $_txntransaction_date;
	Private $_txntransaction_time;
	Private $_txndescription;
	Private $_txntransaction_type;
	Private $_txnstatus;
	
	public function __construct(array $options = null)
	{
		if(is_array($options)){
			$this->setOptions($options);
		}		
	}
	
	public function __set($name, $value)
	{
		$method = 'set' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Transaction property');
		}
		$this->$method($value);
	}
	
	public function __get($name)
	{
		$method = 'get' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Transaction property');
		}
		return $this->$method();
	}
	
	public function setOptions(array $options)
	{
		$methods = get_class_methods($this);
		foreach ($options as $key => $value) {
			$method = 'set' . ucfirst($key);
			if (in_array($method, $methods)) {
				$this->$method($value);
			}
		}
		return $this;
	}
	
	public function settxnid($txnid)
	{
		$this->_txnid = $txnid;
		return $this;
	}
	
	public function gettxnid()
	{
		return $this->_txnid;
	}
	
	public function settxntransaction_id($txntransaction_id)
	{
		$this->_txntransaction_id = $txntransaction_id;
		return $this;
	}
	
	public function gettxntransaction_id()
	{
		return $this->_txntransaction_id;
	}
	
	public function settxninvoice_number($txninvoice_number)
	{
		$this->_txninvoice_number = $txninvoice_number;
		return $this;
	}
	
	public function gettxninvoice_number()
	{
		return $this->_txninvoice_number;
	}
	
	public function settxnpayment_profile_id($txnpayment_profile_id)
	{
		$this->_txnpayment_profile_id = $txnpayment_profile_id;
		return $this;
	}
	
	public function gettxnpayment_profile_id()
	{
		return $this->_txnpayment_profile_id;
	}
	
	public function settxntransaction_amount($txntransaction_amount)
	{
		$this->_txntransaction_amount = $txntransaction_amount;
		return $this;
	}
	
	public function gettxntransaction_amount()
	{
		return $this->_txntransaction_amount;
	}
	
	public function settxntransaction_date($txntransaction_date)
	{
		$this->_txntransaction_date = $txntransaction_date;
		return $this;
	}
	
	public function gettxntransaction_date()
	{
		return $this->_txntransaction_date;
	}

	public function settxntransaction_time($txntransaction_time)
	{
		$this->_txntransaction_time = $txntransaction_time;
		return $this;
	}
	
	public function gettxntransaction_time()
	{
		return $this->_txntransaction_time;
	}

	public function settxndescription($txndescription)
	{
		$this->_txndescription = $txndescription;
		return $this;
	}
	
	public function gettxndescription()
	{
		return $this->_txndescription;
	}
	
	public function settxntransaction_type($txntransaction_type)
	{
		$this->_txntransaction_type = $txntransaction_type;
		return $this;
	}
	
	public function gettxntransaction_type()
	{
		return $this->_txntransaction_type;
	}
	
	public function settxnstatus($txnstatus)
	{
		$this->_txnstatus = $txnstatus;
		return $this;
	}
	
	public function gettxnstatus()
	{
		return $this->_txnstatus;
	}
	
	public function settxnfk_restaurant($txnfk_restaurant)
	{
		$this->_txnfk_restaurant = $txnfk_restaurant;
		return $this;
	}
	
	public function gettxnfk_restaurant()
	{
		return $this->_txnfk_restaurant;
	}
}