<?php
class Payments_Model_UListPostInvoiceMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Payments_Model_DbTable_UListPostInvoice');
		}
		return $this->_dbTable;
	}
	
	public function CreateUListPostInvoice(Payments_Model_UListPostInvoice $UListPostInvoice)
	{
		try{
			$data = array('ulpinv_post_id' 			=> $UListPostInvoice->getulpinv_post_id(),
						  'ulpinv_description' 		=> $UListPostInvoice->getulpinv_description(),
						  'ulpinv_billing_fromdate' => $UListPostInvoice->getulpinv_billing_fromdate(),
						  'ulpinv_billing_todate'	=> $UListPostInvoice->getulpinv_billing_todate(),
						  'ulpinv_amount'			=> $UListPostInvoice->getulpinv_amount(),
						  'ulpinv_status'			=> $UListPostInvoice->getulpinv_status(),
						  'ulpinv_generated_date'	=> $UListPostInvoice->getulpinv_generated_date(),
						  'ulpinv_generated_time'   => $UListPostInvoice->getulpinv_generated_time(),
						  'ulpinv_created_by'		=> $UListPostInvoice->getulpinv_created_by(),
						  'ulpinv_service_tax'		=> $UListPostInvoice->getulpinv_service_tax(),
						  'ulpinv_txn_charges'		=> $UListPostInvoice->getulpinv_txn_charges()
			);
			
			$table = $this->getDbTable();
			
			$id = $table->insert($data);
			
			return $id;
			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}	
	}
	
	public function UpdatePostInvoiceStatusById(Payments_Model_UListUpdatePostInvoiceStatusById $UListUpdatePostInvoiceStatusById)
	{
		try{
			$set = array('ulpinv_status' => $UListUpdatePostInvoiceStatusById->getulpinv_status());
			$where = array('ulpinv_id = ?' => $UListUpdatePostInvoiceStatusById->getulpinv_id(),
						   'ulpinv_post_id = ?' => $UListUpdatePostInvoiceStatusById->getulpinv_post_id());
			$table = $this->getDbTable();
			
			$rows_affected = $table->update($set,$where);
			
			return $rows_affected;
			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
}