<?php

class Bootstrap extends Zend_Application_Bootstrap_Bootstrap
{
	protected function _initAutoload()
	{
		$moduleLoader = new Zend_Application_Module_Autoloader(array(
		'namespace'=> '',
		'basePath' => APPLICATION_PATH)

		);
		$autoloader = Zend_Loader_Autoloader::getInstance();
		$autoloader->registerNamespace('Uss_');
		$autoloader->registerNamespace('LeaderSend_');
		$autoloader->registerNamespace('My_');
		return $moduleLoader;
	}

	protected function _initApploader()
	{
	  $appSession = new Zend_Session_Namespace('SMSData');	
	  //SETUP DINEDESK IDS WITH RDINE BITLYS
	  $data = array();
	  $data['236'] = 'http://bit.ly/2mHnjhh';

	  $zendauth = new Zend_Session_Namespace('Zend_Auth');
	  $zendauth->setExpirationSeconds(172800);

	  $appSession->smsdata = $data;
	}
	protected function _initDoctype()
	{
		$this->bootstrap('view');
		$view = $this->getResource('view');
		$view->doctype('XHTML1_STRICT');
		$storage = new Zend_Auth_Storage_Session();
		$data = $storage->read();
		$this->view->companyid = $data['companyid'];
                $namespace = new Zend_Session_Namespace();
                
                
		if($data['companyid'] == 6){
			$view->headLink()->appendStylesheet('/css/roundmenuStyle.css','screen');
			$view->headLink(array('rel' => 'SHORTCUT ICON',
						'href' => '/images/icons/rfavicon.ico'),
						'PREPEND');
			$view->headTitle('RoundMenu');
		}else if($data['companyid'] == 22){
			$view->headLink()->appendStylesheet('/css/hbcStyle.css','screen');
			$view->headLink(array('rel' => 'SHORTCUT ICON',
						'href' => '/images/icons/hbcfavicon.ico'),
						'PREPEND');
			$view->headTitle('HBC Solutions');
                }else if($data['companyid']==25){
                        $view->headLink()->appendStylesheet('/css/diningwithusstyle.css','screen');
			$view->headLink(array('rel' => 'SHORTCUT ICON',
						'href' => '/images/icons/dwu-fevicon.png'),
						'PREPEND');
			$view->headTitle('DiningWithUs');                    
                }
                else{
			$view->headLink()->appendStylesheet('/css/mtStyle.css','screen');
			$view->headLink(array('rel' => 'SHORTCUT ICON',
						'href' => '/images/favlogo.png'),
						'PREPEND');
			$view->headTitle('DINEDESK');
                        if($namespace->lang == 'el_GR'){
			$view->headLink()->appendStylesheet('/css/greektrans.css','screen');	
			}
		}
		$view->headLink()->appendStylesheet('/css/text.css','screen');
                $view->headLink()->appendStylesheet('/css/pace_barber.css','screen');
		$view->headLink()->appendStylesheet('/css/cssmenuhorizontal.css','screen');
		$view->headLink()->appendStylesheet('/theme/custom-theme-white/jquery.ui.all.css');
	
		$view->headScript()->appendFile('/js/jquery.js');
		$view->headScript()->appendFile('/js/inat.js');
                $view->headScript()->appendFile('/js/pace.min.js');
		$view->headScript()->appendFile('/js/jquery.corners.min.js');
		$view->headScript()->appendFile('/theme/ui/minified/jquery.ui.core.min.js');
		$view->headScript()->appendFile('/theme/ui/minified/jquery.ui.widget.min.js');
		$view->headScript()->appendFile('/theme/ui/minified/jquery.ui.autocomplete.min.js');
		$view->addHelperPath('Uss/Helper/', 'Uss_Helper');

	}

	protected function _initResourceLoader()
	{
		$this->_resourceLoader->addResourceType( 'service', 'services', 'Service' );

	}
	
	protected function _initSetTranslations()
	{
		$translate = new Zend_Translate(
					    array(
					        'adapter' => 'gettext',
					        'content' => APPLICATION_PATH . '/../library/Uss/Translate/Language',
					    	'locale'	=>	null,
					    	'scan' => Zend_Translate::LOCALE_FILENAME
					    )
					);
		$namespace = new Zend_Session_Namespace(); 
		
		$language = 'en';
		if($namespace->lang){
			if($namespace->lang == 'en_US'){
				$language = 'en';
				$namespace->lang = 'en_US';
			}
			if($namespace->lang == 'es_SP'){
				$language = 'es_SP';
			}
                        if($namespace->lang == 'el_GR'){
				$language = 'el_GR';
			}
		}else{
			$language = 'en';
			$namespace->lang = 'en_US';
			
		}
		$translate->setLocale($language);
		$view = $this->getResource('view');
		$view->translate = $translate;
		if($namespace->lang){
			$view->lang = $namespace->lang;
		}else{
			$view->lang = 'en_US';
			$namespace->lang = 'en_US';
		}
	}

	protected function _initLog()
	{
		if($this->hasPluginResource("log"))
		{
			$options = $this->getOption('resources');
	 
	        $partitionConfig = $this->getOption('log');
	        $logOptions = $options['log'];
	        $baseFilename = $logOptions['stream']['writerParams']['stream'];
	        if ($partitionConfig['partitionFrequency'] == 'daily')
	        {
			    $baseFilename = $partitionConfig['path'].'/';
			    $logFilename = $baseFilename.'application_'.date('dmY').'.log';
			    $logOptions['stream']['writerParams']['stream'] = $logFilename;
			    $logger = Zend_Log::factory($logOptions);
				Zend_Registry::set('log', $logger);
				return $logger;
	        }
	        else
	        {
					
						
					$r = $this->getPluginResource("log");
					$log = $r->getLog();
					Zend_Registry::set('log',$log);
	        }
    	}

	
	}


	protected function _initRouter()
	{
		$frontController = Zend_Controller_Front::getInstance();
		$router = $frontController->getRouter();

		/* Inat Bookking Url from third party site. */

		$reserve = new Zend_Controller_Router_Route('rest/:restaurantid',
							array('module'=> 'Reservation',
								  'controller' => 'Reservation',
								  'action'=> 'restaurantinfo',
								  'category'=>'SUB',
								  'type'=> 'weburl'));														  	
	  	$router->addRoute('rest', $reserve);
	  	$booking = new Zend_Controller_Router_Route('booking/:bookingid',
							array('module'=> 'Reservation',
								  'controller' => 'Reservation',
								  'action'=> 'webbookingdetails'));														  	
	  	$router->addRoute('Reservation', $booking);
	  	$waitBook = new Zend_Controller_Router_Route('waitbook/:bookingid',
	  			array('module'=> 'Reservation',
	  					'controller' => 'Reservation',
	  					'action'=> 'webbookingdetails',
	  					'category'=>'wait',
	  					'anchor'=>'#bookdetails'
	  			));
	  	$router->addRoute('WaitBook', $waitBook);
	  	$guest = new Zend_Controller_Router_Route('booking/:bookingid/guest/:guestid/status/:constat',
							array('module'=> 'Reservation',
								  'controller' => 'Reservation',
								  'action'=> 'webinvitedguestdetails'));														  	
	  	$router->addRoute('guest', $guest);
	  	$index = new Zend_Controller_Router_Route('switchview/:switchview',
							array('controller' => 'Index',
								  'action'=> 'index',
								  'category'=>'SUB',
								  'type'=> 'weburl'));														  	
	  	$router->addRoute('inde', $index);
	  	
	  	$index = new Zend_Controller_Router_Route('index',
							array('controller' => 'Index',
								  'action'=> 'index',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('index', $index);
	  	
	  	$indexza = new Zend_Controller_Router_Route('indexza',
							array('controller' => 'Index',
								  'action'=> 'indexza',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('indexza', $indexza);
	  	
	  	$indexmx = new Zend_Controller_Router_Route('indexmx',
							array('controller' => 'Index',
								  'action'=> 'indexmx',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('indexmx', $indexmx);
	  	
	  	$index = new Zend_Controller_Router_Route('contactus',
							array('controller' => 'Index',
								  'action'=> 'contactus',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('contactus', $index);
	  	
	  	$index = new Zend_Controller_Router_Route('howitworks',
							array('controller' => 'Index',
								  'action'=> 'howitworks',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('howitworks', $index);
	  	
	  	$index = new Zend_Controller_Router_Route('contactusza',
							array('controller' => 'Index',
								  'action'=> 'contactusza',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('contactusza', $index);
	  	
	  	$index = new Zend_Controller_Router_Route('contactusmx',
							array('controller' => 'Index',
								  'action'=> 'contactusmx',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('contactusmx', $index);
	  	
	  	$index = new Zend_Controller_Router_Route('features',
							array('controller' => 'Index',
								  'action'=> 'dinedeskfeatures',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('features', $index);
	  	
		$features_za = new Zend_Controller_Router_Route('featuresza',
							array('controller' => 'Index',
								  'action'=> 'dinedeskfeaturesza',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('featuresza', $features_za);
	  	
	  	$features_mx = new Zend_Controller_Router_Route('featuresmx',
							array('controller' => 'Index',
								  'action'=> 'dinedeskfeaturesmx',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('featuresmx', $features_mx);
	  	
	  	$index = new Zend_Controller_Router_Route('partners',
							array('controller' => 'Index',
								  'action'=> 'dinedeskpartners',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('partners', $index); 	
	  	
	  	$reserveonline = new Zend_Controller_Router_Route('reserveonline',
							array('controller' => 'Index',
								  'action'=> 'reserveonline',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('reserveonline', $reserveonline);
	  	
	  	$tablemanagement = new Zend_Controller_Router_Route('tablemanagement',
							array('controller' => 'Index',
								  'action'=> 'tablemanagement',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('tablemanagement', $tablemanagement);
	  	
	  	$tablemanagementza = new Zend_Controller_Router_Route('tablemanagementza',
							array('controller' => 'Index',
								  'action'=> 'tablemanagementza',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('tablemanagementza', $tablemanagementza);
	  	
	  	$tablemanagementmx = new Zend_Controller_Router_Route('tablemanagementmx',
							array('controller' => 'Index',
								  'action'=> 'tablemanagementmx',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('tablemanagementmx', $tablemanagement);
		
	  	$guestmanagementdemo = new Zend_Controller_Router_Route('guestmanagementdemo',
							array('controller' => 'Index',
								  'action'=> 'guestmanagementdemo',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('guestmanagementdemo', $guestmanagementdemo);
		
	  	$guestmanagementdemomx = new Zend_Controller_Router_Route('guestmanagementdemomx',
							array('controller' => 'Index',
								  'action'=> 'guestmanagementdemomx',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('guestmanagementdemomx', $guestmanagementdemo);
		
	  	$guestmanagementdemoza = new Zend_Controller_Router_Route('guestmanagementdemoza',
							array('controller' => 'Index',
								  'action'=> 'guestmanagementdemoza',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('guestmanagementdemoza', $guestmanagementdemo);
		
	  	$marketingdemo = new Zend_Controller_Router_Route('marketingdemo',
							array('controller' => 'Index',
								  'action'=> 'marketingdemo',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('marketingdemo', $marketingdemo);
		
	  	$marketingdemomx = new Zend_Controller_Router_Route('marketingdemomx',
							array('controller' => 'Index',
								  'action'=> 'marketingdemomx',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('marketingdemomx', $marketingdemomx);
		
	  	$marketingdemoza = new Zend_Controller_Router_Route('marketingdemoza',
							array('controller' => 'Index',
								  'action'=> 'marketingdemoza',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('marketingdemoza', $marketingdemoza);
		
	  	$index = new Zend_Controller_Router_Route('ourpartners',
							array('controller' => 'Index',
								  'action'=> 'ourpartners',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('ourpartners', $index);
	  	
	  	$ourpartners_za = new Zend_Controller_Router_Route('ourpartnersza',
							array('controller' => 'Index',
								  'action'=> 'ourpartnersza',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('ourpartnersza', $ourpartners_za);
	  	
	  	$partners_za = new Zend_Controller_Router_Route('partnersza',
							array('controller' => 'Index',
								  'action'=> 'dinedeskpartnersza',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('partnersza', $partners_za);
	  	
	  	$partners_mx = new Zend_Controller_Router_Route('partnersmx',
							array('controller' => 'Index',
								  'action'=> 'dinedeskpartnersmx',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('partnersmx', $partners_mx);
	  	
	  	$ourpartners_mx = new Zend_Controller_Router_Route('ourpartnersmx',
							array('controller' => 'Index',
								  'action'=> 'ourpartnersmx',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('ourpartnersmx', $ourpartners_mx);
	  	
	  	$index = new Zend_Controller_Router_Route('pricing',
							array('controller' => 'Index',
								  'action'=> 'pricing',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('pricing', $index);
	  	
	  	$pricing_za = new Zend_Controller_Router_Route('pricingza',
							array('controller' => 'Index',
								  'action'=> 'pricingza',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('pricingza', $pricing_za);
	  	
	  	$pricing_mx = new Zend_Controller_Router_Route('pricingmx',
							array('controller' => 'Index',
								  'action'=> 'pricingmx',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('pricingmx', $pricing_mx);
	  	
	  	$index = new Zend_Controller_Router_Route('requestfordemo',
							array('controller' => 'Index',
								  'action'=> 'requestfordemo',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('requestfordemo', $index);
	  	
                $index = new Zend_Controller_Router_Route('requestfordemotab',
							array('controller' => 'Index',
								  'action'=> 'requestfordemo',
								  'switchview'=>'browser',
								  'tabs'=>'tabs'));														  	
	  	$router->addRoute('requestfordemotab', $index);
		
  	  	$requestfordemo_za = new Zend_Controller_Router_Route('requestfordemoza',
							array('controller' => 'Index',
								  'action'=> 'requestfordemoza',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('requestfordemoza', $requestfordemo_za);
	  	
	  	$requestfordemo_mx = new Zend_Controller_Router_Route('requestfordemomx',
							array('controller' => 'Index',
								  'action'=> 'requestfordemomx',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('requestfordemomx', $requestfordemo_mx);
	  	
	  	$index = new Zend_Controller_Router_Route('aboutus',
							array('controller' => 'Index',
								  'action'=> 'aboutus',
								  'switchview'=>'browser'));
		$router->addRoute('aboutus', $index);

		$index = new Zend_Controller_Router_Route('aboutusmx',
							array('controller' => 'Index',
								  'action'=> 'aboutus',
								  'switchview'=>'browser'));
	  	$router->addRoute('aboutusmx', $index);
	  	
	  	$index = new Zend_Controller_Router_Route('newsandpress',
							array('controller' => 'Index',
								  'action'=> 'newsandpress',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('newsandpress', $index);
	  	$index = new Zend_Controller_Router_Route('faq',
							array('controller' => 'Index',
								  'action'=> 'faq',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('faq', $index);
	  	$index = new Zend_Controller_Router_Route('careers',
							array('controller' => 'Index',
								  'action'=> 'careers',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('careers', $index);
	  	$index = new Zend_Controller_Router_Route('privacypolicy',
							array('controller' => 'Index',
								  'action'=> 'privacypolicy',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('privacypolicy', $index);
	  	
	  	$privacypolicyza = new Zend_Controller_Router_Route('privacypolicyza',
							array('controller' => 'Index',
								  'action'=> 'privacypolicyza',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('privacypolicyza', $privacypolicyza);
	  	
	  	$privacypolicymx = new Zend_Controller_Router_Route('privacypolicymx',
							array('controller' => 'Index',
								  'action'=> 'privacypolicymx',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('privacypolicymx', $privacypolicymx);
	  	
	  	$index = new Zend_Controller_Router_Route('termsofservice',
							array('controller' => 'Index',
								  'action'=> 'termsofservice',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('termsofservice', $index);
		
		$index = new Zend_Controller_Router_Route('systemfeatures', array('controller' => 'Index', 'action'=> 'systemfeatures', 'switchview'=>'browser'));														  	
	  	$router->addRoute('systemfeatures', $index);
		
	  	$index = new Zend_Controller_Router_Route('cloudbasedsystem', array('controller' => 'Index', 'action'=> 'cloudbasedsystem', 'switchview'=>'browser'));														  	
	  	$router->addRoute('cloudbasedsystem', $index);
		
	  	$index = new Zend_Controller_Router_Route('reservationwidget', array('controller' => 'Index', 'action'=> 'reservationwidget', 'switchview'=>'browser'));														  	
	  	$router->addRoute('reservationwidget', $index);
		
	  	$index = new Zend_Controller_Router_Route('phonenotify', array('controller' => 'Index', 'action'=> 'phonenotify', 'switchview'=>'browser'));														  	
	  	$router->addRoute('phonenotify', $index);
		
	  	$index = new Zend_Controller_Router_Route('twowaywaitlist', array('controller' => 'Index', 'action'=> 'twowaywaitlist', 'switchview'=>'browser'));														  	
	  	$router->addRoute('twowaywaitlist', $index);
		
	  	$index = new Zend_Controller_Router_Route('reservationhover', array('controller' => 'Index', 'action'=> 'reservationhover', 'switchview'=>'browser'));														  	
	  	$router->addRoute('reservationhover', $index);
	  			
	  	$index = new Zend_Controller_Router_Route('mobileapps', array('controller' => 'Index', 'action'=> 'mobileapps', 'switchview'=>'browser'));														  	
	  	$router->addRoute('mobileapps', $index);
		
	  	$index = new Zend_Controller_Router_Route('onlinereservations', array('controller' => 'Index', 'action'=> 'onlinereservations', 'switchview'=>'browser'));														  	
	  	$router->addRoute('onlinereservations', $index);
		
	  	$index = new Zend_Controller_Router_Route('restauranttablemanagement', array('controller' => 'Index', 'action'=> 'restauranttablemanagement', 'switchview'=>'browser'));														  	
	  	$router->addRoute('restauranttablemanagement', $index);
		
	  	$index = new Zend_Controller_Router_Route('customerlist', array('controller' => 'Index', 'action'=> 'customerlist', 'switchview'=>'browser'));														  	
	  	$router->addRoute('customerlist', $index);
	  	
	  	$termsofserviceza = new Zend_Controller_Router_Route('termsofserviceza',
							array('controller' => 'Index',
								  'action'=> 'termsofserviceza',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('termsofserviceza', $termsofserviceza);
	  	
	  	$termsofservicemx = new Zend_Controller_Router_Route('termsofservicemx',
							array('controller' => 'Index',
								  'action'=> 'termsofservicemx',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('termsofservicemx', $termsofservicemx);
	  	
	  	$index = new Zend_Controller_Router_Route('marketing',
							array('controller' => 'Index',
								  'action'=> 'marketing',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('marketing', $index);
	  	
	  	$marketingza = new Zend_Controller_Router_Route('marketingza',
							array('controller' => 'Index',
								  'action'=> 'marketingza',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('marketingza', $marketingza);
	  	
	  	$marketingmx = new Zend_Controller_Router_Route('marketingmx',
							array('controller' => 'Index',
								  'action'=> 'marketingmx',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('marketingmx', $marketingmx);
	  	
	  	$index = new Zend_Controller_Router_Route('onlinereservation',
							array('controller' => 'Index',
								  'action'=> 'onlinereservation',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('onlinereservation', $index);
	  	
	  	$onlinereservationza = new Zend_Controller_Router_Route('onlinereservationza',
							array('controller' => 'Index',
								  'action'=> 'onlinereservationza',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('onlinereservationza', $onlinereservationza);
	  	
	  	$onlinereservationmx = new Zend_Controller_Router_Route('onlinereservationmx',
							array('controller' => 'Index',
								  'action'=> 'onlinereservationmx',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('onlinereservationmx', $onlinereservationmx);
	  	
	  	
	  	$index = new Zend_Controller_Router_Route('guestmanagement',
							array('controller' => 'Index',
								  'action'=> 'guestmanagement',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('guestmanagement', $index);
		$index = new Zend_Controller_Router_Route('themes',
							array('controller' => 'Index',
								  'action'=> 'themes',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('themes', $index);
	  	
	  	$guestmanagementza = new Zend_Controller_Router_Route('guestmanagementza',
							array('controller' => 'Index',
								  'action'=> 'guestmanagementza',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('guestmanagementza', $guestmanagementza);	  	
	  	
	  	$guestmanagementmx = new Zend_Controller_Router_Route('guestmanagementmx',
							array('controller' => 'Index',
								  'action'=> 'guestmanagementmx',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('guestmanagementmx', $guestmanagementmx);	
	  	
	  	$careers1 = new Zend_Controller_Router_Route('careers1',
							array('controller' => 'Index',
								  'action'=> 'careers1',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('careers1', $careers1);
	  	$careers2 = new Zend_Controller_Router_Route('careers2',
							array('controller' => 'Index',
								  'action'=> 'careers2',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('careers2', $careers2);
	  	$news1 = new Zend_Controller_Router_Route('news1',
							array('controller' => 'Index',
								  'action'=> 'news1',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('news1', $news1);
	  	$news2 = new Zend_Controller_Router_Route('news2',
							array('controller' => 'Index',
								  'action'=> 'news2',
								  'switchview'=>'browser'));														  	
	  	$router->addRoute('news2', $news2);
	  	
	  	$signin = new Zend_Controller_Router_Route('signin',array('module'=> 'User',
  																'controller' => 'Login',
  																'action'=> 'signin'));
  		$router->addRoute('login', $signin);
  		
  		$roundmenusignin = new Zend_Controller_Router_Route('roundmenusignin',array('module'=> 'User',
  																'controller' => 'Login',
  																'action'=> 'roundmenusignin'));
  		$router->addRoute('roundmenulogin', $roundmenusignin);
  		
  		$hbcsignin = new Zend_Controller_Router_Route('hbcsignin',array('module'=> 'User',
  																'controller' => 'Login',
  																'action'=> 'hbcsignin'));
  		$router->addRoute('hbclogin', $hbcsignin);
                
                $dwusignin = new Zend_Controller_Router_Route('dwusignin',array('module'=> 'User',
  																'controller' => 'Login',
  																'action'=> 'dwusignin'));
  		$router->addRoute('dwulogin', $dwusignin);
  		
  		$signinza = new Zend_Controller_Router_Route('signinza',array('module'=> 'User',
  																'controller' => 'Login',
  																'action'=> 'signinza'));
  		$router->addRoute('signinza', $signinza);
  		
  		$signinmx = new Zend_Controller_Router_Route('signinmx',array('module'=> 'User',
  																'controller' => 'Login',
  																'action'=> 'signinmx'));
  		$router->addRoute('signinmx', $signinmx);
  		
  		$signin = new Zend_Controller_Router_Route('signout',array('module'=> 'User',
  																'controller' => 'Login',
  																'action'=> 'signout'));
  		$router->addRoute('logout', $signin);
  		
		$signup = new Zend_Controller_Router_Route('register',array('module'=> 'User',
  																  'controller' => 'Client',
  																  'action'=> 'managerregistration'));
  		$router->addRoute('register', $signup);
  		
  		$signup = new Zend_Controller_Router_Route('wixregister',array('module'=> 'User',
  																  'controller' => 'Client',
  																  'action'=> 'managerwixregistration'));
  		$router->addRoute('wixregister', $signup);
  		
  		$rmsignup = new Zend_Controller_Router_Route('roundmenuregister',array('module'=> 'User',
  																  'controller' => 'Client',
  																  'action'=> 'roundmenuregister'));
  		$router->addRoute('roundmenuregister', $rmsignup);
  		
  		$hbcsignup = new Zend_Controller_Router_Route('hbcregister',array('module'=> 'User',
  																  'controller' => 'Client',
  																  'action'=> 'hbcregister'));
  		$router->addRoute('hbcregister', $hbcsignup);
  		
		$password = new Zend_Controller_Router_Route('password',array('module'=> 'User',
													                  'controller' => 'Login',
													  				  'action'=> 'password'));
 		$router->addRoute('password', $password);
 		
 		$cussignup = new Zend_Controller_Router_Route('GuestRegister',array('module'=> 'User',
  																  'controller' => 'Client',
  																  'action'=> 'guestsignup'));
  		$router->addRoute('Customer', $cussignup);
  		
  		$menu = new Zend_Controller_Router_Route('menu/:restaurantid',
  				array('module'=> 'FirmManagement',
  						'controller' => 'Firm',
  						'action'=> 'firmcuisines'));
  		$router->addRoute('Menu', $menu);
 		
 		$switchLang = new Zend_Controller_Router_Route('lang/:lang',
							array('controller' => 'Index',
								  'action'=> 'languageswitch',
								  'switchview'=>'browser'));
		$router->addRoute('switchLang', $switchLang);
	  	
	  	return $router;
	}
}

