<?php
class Application_Model_AdminPermissionsType
{
	protected $_id;
	protected $_code;
	protected $_description;
	protected $_status;
	protected $_detaileddescription;
	protected $_roleid;
	protected $_permission_type_id;
	
	public function __construct(array $options = null)
	{
		if(is_array($options)){
			$this->setOptions($options);
		}
	}

	public function __set($name, $value)
	{
		$method = 'set' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid RestaurantUserMenu_BD property');
		}
		$this->$method($value);
	}

	public function __get($name)
	{
		$method = 'get' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid RestaurantUserMenu_BD property');
		}
		return $this->$method();
	}

	public function setOptions(array $options)
	{
		$methods = get_class_methods($this);
		foreach ($options as $key => $value) {
			$method = 'set' . ucfirst($key);
			if (in_array($method, $methods)) {
				$this->$method($value);
			}
		}
		return $this;
	}

	public function setId($id)
	{
		$this->_id = $id;
		return $this;
	}
	
	public function getId()
	{
		return $this->_id;
	}
	
	public function setCode($code)
	{
		$this->_code = $code;
		return $this;
	}
	
	public function getCode()
	{
		return $this->_code;
	}
	
	public function setDescription($description)
	{
		$this->_description = $description;
		return $this;
	}
	
	public function getDescription()
	{
		return $this->_description;
	}
	
	public function setStatus($status)
	{
		$this->_status = $status;
		return $this;
	}
	
	public function getStatus()
	{
		return $this->_status;
	}
	
	public function setDetaileddescription($detaileddescription)
	{
		$this->_detaileddescription = $detaileddescription;
		return $this;
	}
	
	public function getDetaileddescription()
	{
		return $this->_detaileddescription;
	}
	
	public function setRoleId($roleid)
	{
		$this->_roleid = $roleid;
		return $this;
	}
	
	public function getRoleId()
	{
		return $this->_roleid;
	}
	
	public function setPermissionTypeId($permissiontypeid)
	{
		$this->_permission_type_id = $permissiontypeid;
		return $this;
	}
	
	public function getPermissionTypeId()
	{
		return $this->_permission_type_id;
	}

}