<?php
class Application_Model_AdminPermissionsTypeDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_AdminPermissionsType');
		}
		return $this->_dbTable;
	}
	
	public function fetchAll()
	{
		$cache = new Uss_Helper_CacheManager();
		$adminpermissions = array();
		if(!$adminpermissions = $cache->Fetch('ddadminperm')){
			$where = array('status = ?'=> true);
			$records = $this->getDbTable()->fetchAll($where);
						
			foreach($records as $record){
				$adminpermissions[] = new Application_Model_AdminPermissionsType(						
					$record->toArray());	
			}
			$cache->Save($adminpermissions,'ddadminperm');			
		}else{
			$adminpermissions = $cache->Fetch('ddadminperm');
		}
		
		$cache = null;
		return $adminpermissions;
	}
	
	public function getAdminMenuBD()
	{
		try{
			$cache = new Uss_Helper_CacheManager();
			$adminusermenu = array();
			if(!$adminusermenu = $cache->Fetch('ddadminusermenu_bd')){
				$where = array('status = ?'=> true);
				$records = $this->getDbTable()->fetchAll($where);
					
				foreach($records as $record){
					$adminusermenu[] = new Application_Model_AdminPermissionsType(
					$record->toArray());
				}
				$cache->Save($adminusermenu,'ddadminusermenu_bd');
			}else{
				$adminusermenu = $cache->Fetch('ddadminusermenu_bd');
			}
			$cache = null;
			return $adminusermenu;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}