<?php
class Application_Model_AdminRolePermissionMapDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_AdminRolePermissionMap');
		}
		return $this->_dbTable;
	}
	
	public function getAdminUserPermissionByRole($roleid)
	{
		$table = $this->getDbTable();
		$select = $table->select();
		$select->setIntegrityCheck(false);
		
		$select->from(array('rpm'=>'mt.admin_role_permission_map'),array('arpm_id'))
 			   ->join(array('per'=>'mt.admin_permissionstype_bd'),'per.id = rpm.arpm_permissiontype_id',array('code as permcode','description as permdesc'))
 			   ->where('rpm.arpm_roleid = ?',$roleid);
		 					
		$rowSet =  $table->fetchAll($select);
		$result = array();
		foreach($rowSet as $row){
			$adminusermenu = new Application_Model_PermissionsType();
			$adminusermenu->setCode($row->permcode);
			$adminusermenu->setDescription($row->permdesc);
			
			$result[] = $adminusermenu;
		}
		return $result;	
	}
	
	public function getPermissionList()
	{
		$table = $this->getDbTable();
		$select = $table->select();
		$select->setIntegrityCheck(false);
		
		$select->from(array('rpm'=>'mt.admin_role_permission_map'),array('arpm_id'))
 			   ->join(array('per'=>'mt.admin_permissionstype_bd'),'per.id = rpm.arpm_permissiontype_id',array('id','code as permcode','description as permdesc','detaileddescription'))
 			   ->join(array('role'=>'mt.role_bd'),'role.id = rpm.arpm_roleid',array('code as role'))
 			   ->where('role.code ILIKE ?', 'Manager')
 			   ->where('role.rolfk_typeid = ?', 1);
 			   
		 					
		$rowSet =  $table->fetchAll($select);
		$result = array();
		foreach($rowSet as $row){
			$adminusermenu = new Application_Model_AdminPermissionsType();
			$adminusermenu->setCode($row->permcode);
			$adminusermenu->setDescription($row->permdesc);
			$adminusermenu->setId($row->id);
			$adminusermenu->setDetaileddescription($row->detaileddescription);
			
			$result[] = $adminusermenu;
		}
		return $result;	
	}
	
}