<?php
/**
*	Name			: City.php
*	Author			: Zubair Ahmed
*	Creation Date	: 10/05/2010
*	Path 			: application/models/City.php
*	Description		: This is the Model class for the city basedata table.
*					   	
*/
class Application_Model_City
{
	/**
	 * 
	 * @var integer
	 */
	private $_id;
	
	/**
	 * 
	 * @var string
	 */
	private $_code;
	
	/**
	 * 
	 * @var string
	 */
	private $_description;
	
	/**
	 * 
	 * @var boolean
	 */
	private $_status;
	
	/**
	 * 
	 * @var integer
	 */
	private $_regionid;
	
	/**
	 * 
	 * @var arrray
	 */
	private $_cityList;
	
	private $_stateid;
	
	/**
     * Public constructor
     *
     * @param  array $options
     */
	public function __construct(array $options = null)
	{
		if(is_array($options)){
			$this->setOptions($options);
		}		
	}
	
	/**
	 * Writing data to properties
	 */
	public function __set($name, $value)
	{
		$method = 'set' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid City_BD property');
		}
		$this->$method($value);
	}
	
	/**
	 * Reading data from properties
	 */
	public function __get($name)
	{
		$method = 'get' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid State_BD property');
		}
		return $this->$method();
	}
	
	public function setOptions(array $options)
	{
		$methods = get_class_methods($this);
		foreach ($options as $key => $value) {
			$method = 'set' . ucfirst($key);
			if (in_array($method, $methods)) {
				$this->$method($value);
			}
		}
		return $this;
	}
	
	/**
     * @param integer $id
     * @return self
     */
	public function setId($id)
	{
		$this->_id = $id;
		return $this;
	}
	
	 /**
     * @return integer
     */
	public function getId()
	{
		return $this->_id;
	}
	
	/**
     * @param string $code
     * @return self
     */
	public function setCode($code)
	{
		$this->_code = $code;
		return $this;
	}
	
	/**
     * @return string
     */
	public function getCode()
	{
		return $this->_code;
	}
	
	/**
     * @param string $description
     * @return self
     */
	public function setDescription($description)
	{
		$this->_description = $description;
		return $this;
	}
	
	/**
     * @return string
     */
	public function getDescription()
	{
		return $this->_description;
	}
	
	/**
     * @param boolean $status
     * @return self
     */
	public function setStatus($status)
	{
		$this->_status = $status;
		return $this;
	}
	
	/**
     * @return boolean
     */
	public function getStatus()
	{
		return $this->_status;
	}
	
	public function setStateId($stateid)
	{
		$this->_stateid = $stateid;
		return $this;
	}
	
	public function getStateId()
	{
		return $this->_stateid;
	}
	
	/**
     * @param integer $stateid
     * @return self
     */
	public function setRegionId($regionid){
		$this->_regionid = $regionid;
		return $this;
	}
	public function getRegionId()
	{
		return $this->_regionid;
	}
	
	/**
     * @param array $cityList
     * @return self
     */
	public function setCityList($cityList){
		$this->_cityList = 	$cityList;
		return $this;
	}
	
	/**
     * @return array
     */
	public function getCityList(){
		return $this->_cityList;	
	}


}

