<?php
class Application_Model_CountryCodeDataMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			//$this->setDbTable('Application_Model_DbTable_State');
      $this->setDbTable('Application_Model_DbTable_CountryCode');
		}
		return $this->_dbTable;
	}
	
	public function fetchAll()
	{
		$cache = new Uss_Helper_CacheManager();
		$countrycode = array();
		if(!$countrycode = $cache->Fetch('countrycode')){
			$where = array('status = ?'=> true);
			$order = array('description');
			$records = $this->getDbTable()->fetchAll($where,$order);	
      //echo '<pre>'; print_r($records); exit;					
			foreach($records as $record){
				$countrycode[] = new Application_Model_State(						
					$record->toArray());	
			}
			$cache->Save($countrycode,'countrycode');			
		}else{
			$countrycode = $cache->Fetch('countrycode');
		}
		//echo '<pre>'; print_r($countrycode); exit;
		$cache = null;
		return $countrycode;
	}
 
   public function getCountryCode()
	{
		try{
			$select = $this->getDbTable()->select();
			$select->from('mt.countrycode_bd',array('id','code','description'))
					//->where('mt.timezone_bd.country_id = ?',$timezoneObj->getCountryId())	       
					->where('mt.countrycode_bd.status = ?',true)
					->order(array('mt.countrycode_bd.id'));	       
			$records = $this->getDbTable()->fetchAll($select);
      //$sql = $select->__toString();
      //echo "$sql\n";   exit;	
			$dataArr = array();
			//$dataArr[] = array("key"=>"","value"=>"Select TimeZone");
			foreach($records as $record){
				$dataArr[] = array("key"=>$record->description,"value"=>$record->code,"country"=>$record->id);
			}		
			return $dataArr;			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
 
}