<?php
class Application_Model_CurrencyDataMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_Currency');
		}
		return $this->_dbTable;
	}
	
	public function fetchAll()
	{
		$cache = new Uss_Helper_CacheManager();
		$currency = array();
		if(!$currency = $cache->Fetch('ddcurrency')){
			$where = array('status = ?'=> true);
			$order = array('id');
			$records = $this->getDbTable()->fetchAll($where,$order);
			
			foreach($records as $record){
				
				$currencyObj = new Application_Model_Currency();
				$currencyObj->setId($record->id);
				$currencyObj->setCode($record->code);
				$currencyObj->setDescription($record->description);
				$currencyObj->setStatus($record->status);
				
				$currency[] = $currencyObj;
				
			}
			$cache->Save($currency,'ddcurrency');
		}else{
			$currency = $cache->Fetch('ddcurrency');
		}

		$cache = null;
		return $currency;
	}
	
}