<?php
class Application_Model_CustomerSuggestRestaurant
{
	protected  $_csr_id;
	protected  $_csr_fk_userid;
	protected  $_csr_first_name;
	protected  $_csr_last_name;
	protected  $_csr_rest_name;
	protected  $_csr_rest_address;
	protected  $_csr_rest_city;
	protected  $_csr_rest_state;
	protected  $_csr_rest_zip;
	protected  $_csr_rest_email;
	protected  $_csr_rest_phone;
	protected  $_csr_rest_manager;
	
	public function __construct(array $options = null)
	{
		if(is_array($options)){
			$this->setOptions($options);
		}		
	}
	
	public function __set($name, $value)
	{
		$method = 'set' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Customer property');
		}
		$this->$method($value);
	}
	
	public function __get($name)
	{
		$method = 'get' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Customer property');
		}
		return $this->$method();
	}
	
	public function setOptions(array $options)
	{
		$methods = get_class_methods($this);
		foreach ($options as $key => $value) {
			$method = 'set' . ucfirst($key);
			if (in_array($method, $methods)) {
				$this->$method($value);
			}
		}
		return $this;
	}
	
	public function setId($id)
	{
		$this->_csr_id = $id;
		return $this;
	}
	
	public function getId()
	{
		return $this->_csr_id;	
	}
	
	public function setUserId($userid)
	{
		$this->_csr_fk_userid = $userid;
		return $this;
	}
	
	public function getUserId()
	{
		return $this->_csr_fk_userid;	
	}
	
	public function setFirstName($name)
	{
		$this->_csr_first_name = $name;
		return $this;
	}

	public function getFirstName()
	{
		return $this->_csr_first_name;
	}
	
	public function setLastName($LastName)
	{
		$this->_csr_last_name = $LastName;
		return $this;
	}

	public function getLastName()
	{
		return $this->_csr_last_name;
	}
	
	public function setRestName($RestName)
	{
		$this->_csr_rest_name = $RestName;
		return $this;
	}
	
	public function getRestName()
	{
		return $this->_csr_rest_name;
	}
	
	public function setRestCity($city)
	{
		$this->_csr_rest_city = $city;
		return $this;
	}
	
	public function getRestCity()
	{
		return $this->_csr_rest_city;
	}
	
	public function setRestState($state)
	{
		$this->_csr_rest_state = $state;
		return $this;
	}
	
	public function getRestState()
	{
		return $this->_csr_rest_state;
	}
	
	public function setRestAddress($address)
	{
		$this->_csr_rest_address = $address;
		return $this;
	}
	
	public function getRestAddress()
	{
		return $this->_csr_rest_address;
	}
	
	public function setRestZip($Zip)
	{
		$this->_csr_rest_zip = $Zip;
		return $this;
	}
	
	public function getRestZip()
	{
		return $this->_csr_rest_zip;
	}
	
	public function setRestEmail($Email)
	{
		$this->_csr_rest_email = $Email;
		return $this;
	}
	
	public function getRestEmail()
	{
		return $this->_csr_rest_email;
	}
	
	public function setRestPhone($Phone)
	{
		$this->_csr_rest_phone = $Phone;
		return $this;
	}
	
	public function getRestPhone()
	{
		return $this->_csr_rest_phone;
	}

	public function setRestManager($Manager)
	{
		$this->_csr_rest_manager = $Manager;
		return $this;
	}
	
	public function getRestManager()
	{
		return $this->_csr_rest_manager;
	}
}