<?php
class Application_Model_CustomerSuggestRestaurantMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_CustomerSuggestRestaurant');
		}
		return $this->_dbTable;
	}
	
	public function SuggestRestaurant(Application_Model_CustomerSuggestRestaurant $suggest)
	{
		try{
			$data = array(
//							'csr_id'			,
							'csr_fk_userid'			=>	$suggest->getUserId(),
							'csr_first_name'		=>	$suggest->getFirstName(),
							'csr_last_name'			=>	$suggest->getLastName(),
							'csr_rest_name'			=>	$suggest->getRestName(),
							'csr_rest_address'		=>	$suggest->getRestAddress(),
							'csr_rest_city'			=>	$suggest->getRestCity(),
							'csr_rest_state'		=>	$suggest->getRestState(),
							'csr_rest_zip'			=>	$suggest->getRestZip(),
							'csr_rest_email'		=>	$suggest->getRestEmail(),
							'csr_rest_phone'		=>	$suggest->getRestPhone(),
							'csr_rest_manager'		=>	$suggest->getRestManager()
			);
			$result = $this->getDbTable()->insert($data);
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getCustomerSuggestions()
	{
		try{
			$select = $this->getDbTable()->select();
			$select->from($this->getDbTable(),array('csr_id','csr_fk_userid','csr_first_name','csr_last_name','csr_rest_name','csr_rest_address','csr_rest_city','csr_rest_state','csr_rest_zip','csr_rest_email','csr_rest_phone','csr_rest_manager'));
			$result = $this->getDbTable()->fetchAll($select);
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}