<?php
/**
*	Name			: DiscountTypeDataMapper.php
*	Author			: Zubair Ahmed
*	Creation Date	: 10/05/2010
*	Path 			: application/models/DiscountTypeDataMapper.php
*	Description		: This is the DataMapper class for the discount type basedata table.
*					   	
*/
class Application_Model_DiscountTypeDataMapper
{
	/**
	 * Instance variable of discount type basedata table
	 * @var object
	 */
	protected $_dbTable;
	
	/**
     * @param instance of DbTable discountType $dbTable
     * @return self
     */
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	/**
     * @return instance of DbTable discountType
     */
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_DiscountType');
		}
		return $this->_dbTable;
	}
	
	/**
	 * Fetches all the discounttype basedata rows and saves in cache
	 */
	public function fetchAll()
	{
		$cache = new Uss_Helper_CacheManager();
		$distypes = array();
		if(!$distypes = $cache->Fetch('distypes')){
			$where = array('status = ?'=> true);
			$records = $this->getDbTable()->fetchAll($where);
						
			foreach($records as $record){
				$distypes[] = new Application_Model_State(						
					$record->toArray());	
			}
			$cache->Save($distypes,'distypes');			
		}else{
			$distypes = $cache->Fetch('distypes');
		}
		
		$cache = null;
		return $distypes;
	}

}
