<?php
/**
*	Name			: EmailTypeDataMapper.php
*	Author			: Zubair Ahmed
*	Creation Date	: 05/28/2011
*	Path 			: application/models/EmailTypeDataMapper.php
*	Description		: This is the DataMapper class for the email type basedata table.
*					   	
*/
class Application_Model_EmailTypeDataMapper
{
	/**
	 * Instance variable of emailtype basedata table
	 * @var object
	 */
	protected $_dbTable;
	
	/**
     * @param instance of DbTable emailtype $dbTable
     * @return self
     */
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	/**
     * @return instance of DbTable emailtype
     */
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_EmailType');
		}
		return $this->_dbTable;
	}
	
	/**
	 * Fetches all the emailtype basedata rows and saves in cache
	 */
	public function fetchAll()
	{
		$cache = new Uss_Helper_CacheManager();
		$emailtype = array();
		if(!$emailtype = $cache->Fetch('emailtype')){
			$where = array('status = ?'=> TRUE);
			$records = $this->getDbTable()->fetchAll($where);
						
			foreach($records as $record){
				$emailtype[] = new Application_Model_EmailType(						
					$record->toArray());	
			}
			$cache->Save($emailtype,'emailtype');			
		}else{
			$emailtype = $cache->Fetch('emailtype');
		}
		
		$cache = null;
		return $emailtype;
	}
	
	/**
	 *Get emailtype by code 
	 */
	public function GetEmailTypeByCode($code)
	{
		$emailTypeList = $this->fetchAll();
		foreach($emailTypeList as $key=>$value){
			if($value->getcode() == $code){
				return $value;	
			}			
		}		
	}
}