<?php
class Application_Model_FeedbackQuestionsTypeDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_FeedbackQuestionsType');
		}
		return $this->_dbTable;
	}
	
	public function fetchAll()
	{
		$cache = new Uss_Helper_CacheManager();
		$adminpermissions = array();
		if(!$adminpermissions = $cache->Fetch('ddfeedbackquestionstype')){
			$where = array('status = ?'=> true);
			$records = $this->getDbTable()->fetchAll($where);
						
			foreach($records as $record){
				$adminpermissions[] = new Application_Model_FeedbackQuestionsType(						
					$record->toArray());	
			}
			$cache->Save($adminpermissions,'ddfeedbackquestionstype');			
		}else{
			$adminpermissions = $cache->Fetch('ddfeedbackquestionstype');
		}
		
		$cache = null;
		return $adminpermissions;
	}
	
	public function GetQuestionTypeByCode(array $code)
	{
		$QuestionTypeList = $this->fetchAll();
		$arrayCount = count($code);
		$count = 0;
		$result = array();
		foreach($QuestionTypeList as $key=>$value){
			if(in_array($value->getcode(),$code)){
				$result[$value->getcode()] = $value; 
				$count++;
				if($count == $arrayCount){
					break;
				}				
			}			
		}

		return $result;
	}
	
}