<?php
/**
*	Name			: GetCampaignForPost.php
*	Author			: snehal
*	Creation Date	: 2/4/2011
*	Path 			: application/models/GetCampaignForPost.php
*	Description		: This is the Model class for the GetCampaignForPost table.
*					   	
*/
class Application_Model_GetCampaignForPost
{
	/**
	 * 
	 * @var integer
	 */
	protected $_stateid;
	
	/**
	 * 
	 * @var string
	 */
	protected $_aud;
	
	/**
	 * 
	 * @var boolean
	 */
	protected $_isajax;
	
	/**
	 * 
	 * @var integer
	 */
	protected $_regionId;
	
	/**
	 * 
	 * @var integer
	 */
	protected $_cityId;
	
	/**
	 * 
	 * @var integer
	 */
	protected $_camId;

	/**
     * Public constructor
     *
     * @param  array $options
     */
	public function __construct(array $options = null)
	{
		if(is_array($options)){
			$this->setOptions($options);
		}
	}

	/**
	 * Writing data to properties
	 */
	public function __set($name, $value)
	{
		$method = 'set' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Role_BD property');
		}
		$this->$method($value);
	}

	/**
	 * Reading data from properties
	 */
	public function __get($name)
	{
		$method = 'get' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid GetCampaignForPost property');
		}
		return $this->$method();
	}

	public function setOptions(array $options)
	{
		$methods = get_class_methods($this);
		foreach ($options as $key => $value) {
			$method = 'set' . ucfirst($key);
			if (in_array($method, $methods)) {
				$this->$method($value);
			}
		}
		return $this;
	}

	/**
     * @param integer $id
     * @return self
     */
	public function setStateId($id)
	{
		$this->_stateid = $id;
		return $this;
	}
	
 	/**
     * @return integer
     */
	public function getStateId()
	{
		return $this->_stateid;
	}
	
	/**
     * @param string $code
     * @return self
     */
	public function setAudType($code)
	{
		$this->_aud = $code;
		return $this;
	}
	
	/**
     * @return string
     */
	public function getAudType()
	{
		return $this->_aud;
	}
	
	/**
     * @param string $regionid
     * @return self
     */
	public function setRegionId($reg)
	{
		$this->_regionId = $reg;
		return $this;
	}
	
	/**
     * @return string
     */
	public function getRegionId()
	{
		return $this->_regionId;
	}
	
	/**
     * @param boolean $status
     * @return self
     */
	public function setIsAjaxCall($status)
	{
		$this->_isajax = $status;
		return $this;
	}
	
	/**
     * @return boolean
     */
	public function getIsAjaxCall()
	{
		return $this->_isajax;
	}

	/**
     * @param integer $cityId
     * @return self
     */
	public function setCityId($citId)
	{
		$this->_cityId = $citId;
		return $this;
	}

	/**
     * @return integer
     */
	public function getCityId()
	{
		return $this->_cityId;
	}

	/**
     * @param integer $camId
     * @return self
     */
	public function setCampId($citId)
	{
		$this->_camId = $citId;
		return $this;
	}

	/**
     * @return integer
     */
	public function getCampId()
	{
		return $this->_camId;
	}
	
}

