<?php
class Application_Model_InquiryFieldsDataMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_InquiryFields');
		}
		return $this->_dbTable;
	}
	
	public function fetchAll()
	{
		$cache = new Uss_Helper_CacheManager();
		$InquiryField = array();
		if(!$InquiryField = $cache->Fetch('inquiryfield')){
			$where = array('status = ?'=> true);
		//	$order = array('id');
			$records = $this->getDbTable()->fetchAll($where);
						
			foreach($records as $record){
				$InquiryField[] = new Application_Model_InquiryFields(						
					$record->toArray());	
			}
			$cache->Save($InquiryField,'inquiryfield');			
		}else{
			$InquiryField = $cache->Fetch('inquiryfield');
		}
		
		$cache = null;
		return $InquiryField;
	}
	
	public function getcols(){
		
	}
}