<?php
/**
*	Name			: IntendedAudienceDataMapper.php
*	Author			: Zubair Ahmed
*	Creation Date	: 05/28/2011
*	Path 			: application/models/IntendedAudienceDataMapper.php
*	Description		: This is the DataMapper class for the intended audience basedata table.
*					   	
*/
class Application_Model_IntendedAudienceDataMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_IntendedAudience');
		}
		return $this->_dbTable;
	}
	
	public function fetchAll()
	{
		$cache = new Uss_Helper_CacheManager();
		$bookstatus = array();
		if(!$bookstatus = $cache->Fetch('intendedaudience')){
			$where = array('status = ?'=> true);
			$order = array('id');
			$records = $this->getDbTable()->fetchAll($where,$order);
						
			foreach($records as $record){
				$bookstatus[] = new Application_Model_IntendedAudience(						
					$record->toArray());	
			}
			$cache->Save($bookstatus,'intendedaudience');			
		}else{
			$bookstatus = $cache->Fetch('intendedaudience');
		}
		
		$cache = null;
		return $bookstatus;
	}
	
	public function GetIntendedAudienceByCode(array $code)
	{
		$audList = $this->fetchAll();
		$arrayCount = count($code);
		$count = 0;
		$result = array();
		foreach($audList as $key=>$value){
			if(in_array($value->getcode(),$code)){
				$result[$value->getcode()] = $value; 
				$count++;
				if($count == $arrayCount){
					break;
				}				
			}			
		}

		return $result;
	}
}