<?php
/**
*	Name			: InvoiceStatusDataMapper.php
*	Author			: Zubair Ahmed
*	Creation Date	: 07/04/2011
*	Path 			: application/models/InvoiceStatusDataMapper.php
*	Description		: This is the DataMapper class for the invoice status basedata table.
*					   	
*/
class Application_Model_InvoiceStatusDataMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_InvoiceStatus');
		}
		return $this->_dbTable;
	}
	
	public function fetchAll()
	{
		$cache = new Uss_Helper_CacheManager();
		$invoicestatus = array();
		if(!$invoicestatus = $cache->Fetch('invoicestatus')){
			$where = array('status = ?'=> true);
			$records = $this->getDbTable()->fetchAll($where);
						
			foreach($records as $record){
				$invoicestatus[] = new Application_Model_InvoiceStatus(						
					$record->toArray());	
			}
			$cache->Save($invoicestatus,'invoicestatus');			
		}else{
			$invoicestatus = $cache->Fetch('invoicestatus');
		}
		
		$cache = null;
		return $invoicestatus;
	}

	public function getInvoiceStatusByCode($code){
		$invoiceStatusList = $this->fetchAll();
		foreach($invoiceStatusList as $key=>$value){
			if($value->getcode() == $code){
				return $value;	
			}			
		}
	}
}