<?php
/**
*	Name			: MealTypeDataMapper.php
*	Author			: Snehal
*	Creation Date	: 08/09/2010
*	Path 			: application/models/MealTypeDataMapper.php
*	Description		: This is the dataMapper class for the booking status basedata table.
*					   	
*/
class Application_Model_MealTypeDataMapper
{
	/**
	 * Instance variable of booking status basedata table
	 * @var object
	 */
	protected $_dbTable;
	
	/**
     * @param instance of DbTable BookingStatus $dbTable
     * @return self
     */
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	/**
     * @return instance of DbTable BookingStatus
     */
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_MealType');
		}
		return $this->_dbTable;
	}
	/**
	 * Fetches all the booking status basedata rows and saves in cache
	 */
	public function fetchAll()
	{
		$cache = new Uss_Helper_CacheManager();
		$bookstatus = array();
		if(!$bookstatus = $cache->Fetch('mealtype')){
			$where = array('status = ?'=> true);
			$records = $this->getDbTable()->fetchAll($where);
						
			foreach($records as $record){
				$bookstatus[] = new Application_Model_MealType(						
					$record->toArray());	
			}
			$cache->Save($bookstatus,'mealtype');			
		}else{
			$bookstatus = $cache->Fetch('mealtype');
		}
		
		$cache = null;
		return $bookstatus;
	}
	
	/**
	 *Get Booking status by Code 
	 */
	public function GetMealTypeByCode(array $code)
	{
		$bookstatusList = $this->fetchAll();
		$arrayCount = count($code);
		$count = 0;
		$result = array();
		foreach($bookstatusList as $key=>$value){
			if(in_array($value->getcode(),$code)){
				$result[$value->getcode()] = $value; 
				$count++;
				if($count == $arrayCount){
					break;
				}				
			}			
		}

		return $result;
	}
	
	/**
	 *Get Booking status by id 
	 */
	public function GetMealTypeById(array $id)
	{
		$bookstatusList = $this->fetchAll();
		$arrayCount = count($id);
		$count = 0;
		$result = array();
		foreach($bookstatusList as $key=>$value){
			if(in_array($value->getid(),$id)){
				$result[$value->getid()] = $value; 
				$count++;
				if($count == $arrayCount){
					break;
				}				
			}			
		}

		return $result;
	}
	
}