<?php
/**
*	Name			: Neighborhood.php
*	Author			: Zubair Ahmed
*	Creation Date	: 10/05/2010
*	Path 			: application/models/Neighborhood.php
*	Description		: This is the Model class for the neighborhood basedata table.
*					   	
*/
class Application_Model_Neighborhood
{

	/**
	 * 
	 * @var integer
	 */
	protected $_id;
	
	/**
	 * 
	 * @var string
	 */
	protected $_code;
	
	/**
	 * 
	 * @var string
	 */
	protected $_description;
	
	/**
	 * 
	 * @var boolean
	 */
	protected $_status;
	
	/**
	 * 
	 * @var integer
	 */
	protected $_cityid;
	
	/**
	 * 
	 * @var array
	 */
	protected $_neighborhoodlist;
	
	/**
     * Public constructor
     *
     * @param  array $options
     */
	public function __construct(array $options = null)
	{
		if(is_array($options)){
			$this->setOptions($options);
		}		
	}
	
	/**
	 * Writing data to properties
	 */
	public function __set($name, $value)
	{
		$method = 'set' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Neighbourhod Status Bd property');
		}
		$this->$method($value);
	}
	
	/**
	 * Reading data from properties
	 */
	public function __get($name)
	{
		$method = 'get' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Neighbourhod Status Bd property');
		}
		return $this->$method();
	}
	
	public function setOptions(array $options)
	{
		$methods = get_class_methods($this);
		foreach ($options as $key => $value) {
			$method = 'set' . ucfirst($key);
			if (in_array($method, $methods)) {
				$this->$method($value);
			}
		}
		return $this;
	}
	
	/**
     * @param integer $id
     * @return self
     */
	public function setId($id)
	{
		$this->_id = $id;
		return $this;
	}
	
	/**
     * @return integer
     */
	public function getId()
	{
		return $this->_id;
	}
	
	/**
     * @param string $code
     * @return self
     */
	public function setCode($code)
	{
		$this->_code = $code;
		return $this;
	}
	
	/**
     * @return string
     */
	public function getCode()
	{
		return $this->_code;
	}
	
	/**
     * @param string $description
     * @return self
     */
	public function setDescription($description)
	{
		$this->_description = $description;
		return $this;
	}
	
	/**
     * @return string
     */
	public function getDescription()
	{
		return $this->_description;
	}
	
	/**
     * @param boolean $status
     * @return self
     */
	public function setStatus($status)
	{
		$this->_status = $status;
		return $this;
	}
	
	/**
     * @return boolean
     */
	public function getStatus()
	{
		return $this->_status;
	}
	
	/**
     * @param integer $cityid
     * @return self
     */
	public function setCityId($cityid)
	{
		$this->_cityid = $cityid;
		return $this;
	}
	
	/**
     * @return integer
     */
	public function getCityId()
	{
		return $this->_cityid;
	}
	
	/**
     * @param array $neighborhoodlist
     * @return self
     */
	public function setNeighborhoodList($neighborhoodlist)
	{
		$this->_neighborhoodlist = $neighborhoodlist;
		return $this;
	}
	
	/**
     * @return array
     */
	public function getNeighborhoodList()
	{
		return $this->_neighborhoodlist;
	}
	
}


