<?php
/**
*	Name			: NotificationTypeDataMapper.php
*	Author			: kartheek
*	Creation Date	: 11/23/2010
*	Path 			: application/models/NotificationTypeDataMapper.php
*	Description		: This is the DataMapper class for the notification type basedata table.
*					   	
*/
class Application_Model_NotificationTypeDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_NotificationType');
		}
		return $this->_dbTable;
	}

	public function fetchAll()
	{
		$cache = new Uss_Helper_CacheManager();
		$notificationtype = array();
		if(!$notificationtype = $cache->Fetch('notificationtype')){
			$where = array('status = ?'=> true);
			$order = array('id');
			$records = $this->getDbTable()->fetchAll($where,$order);

			foreach($records as $record){
				$notificationtype[] = new Application_Model_ReservationType(
				$record->toArray());
			}
			$cache->Save($notificationtype,'notificationtype');
		}else{
			$notificationtype = $cache->Fetch('notificationtype');
		}

		$cache = null;
		return $notificationtype;
	}

	public function GetNotificationTypeByCode(array $code)
	{
		$notiftypeList = $this->fetchAll();
		$arrayCount = count($code);
		$count = 0;
		$result = array();
		foreach($notiftypeList as $key=>$value){
			if(in_array($value->getcode(),$code)){
				$result[$value->getcode()] = $value;
				$count++;
				if($count == $arrayCount){
					break;
				}
			}
		}

		return $result;
	}
}