<?php
/**
*	Name			: OriginDataMapper.php
*	Author			: kartheek
*	Creation Date	: 1/05/2011
*	Path 			: application/models/OriginDataMapper.php
*	Description		: This is the DataMapper class for the origin basedata table.
*					   	
*/
class Application_Model_OriginDataMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_Origin');
		}
		return $this->_dbTable;
	}
	
	public function fetchAll()
	{
		$cache = new Uss_Helper_CacheManager();
		$origins = array();
		if(!$origins = $cache->Fetch('restorigins')){
			$where = array('status = ?'=> true);
			$records = $this->getDbTable()->fetchAll($where);
						
			foreach($records as $record){
				$origins[] = new Application_Model_Origin(						
					$record->toArray());	
			}
			$cache->Save($origins,'restorigins');			
		}else{
			$origins = $cache->Fetch('restorigins');
		}
		
		$cache = null;
		return $origins;
	}	
}