<?php
/**
*	Name			: PermissionsTypeDataMapper.php
*	Author			: kartheek
*	Creation Date	: 2/04/2011
*	Path 			: application/models/PermissionsTypeDataMapper.php
*	Description		: This is the DataMapper class for the permissions type basedata table.
*					   	
*/
class Application_Model_PermissionsTypeDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_PermissionsType');
		}
		return $this->_dbTable;
	}

	public function fetchAll()
	{
		$cache = new Uss_Helper_CacheManager();
		$bookstatus = array();
		if(!$bookstatus = $cache->Fetch('perm')){
			$where = array('status = ?'=> true);
			$records = $this->getDbTable()->fetchAll($where);
						
			foreach($records as $record){
				$bookstatus[] = new Application_Model_PermissionsType(						
					$record->toArray());	
			}
			$cache->Save($bookstatus,'perm');			
		}else{
			$bookstatus = $cache->Fetch('perm');
		}
		
		$cache = null;
		return $bookstatus;
	}
	
	public function getRestUserMenuBD()
	{
		try{
			$cache = new Uss_Helper_CacheManager();
			$restusermenu = array();
			if(!$restusermenu = $cache->Fetch('restusermenu_bd')){
				$where = array('status = ?'=> true);
				$records = $this->getDbTable()->fetchAll($where);
					
				foreach($records as $record){
					$restusermenu[] = new Application_Model_PermissionsType(
					$record->toArray());
				}
				$cache->Save($restusermenu,'restusermenu_bd');
			}else{
				$restusermenu = $cache->Fetch('restusermenu_bd');
			}

			$cache = null;
			return $restusermenu;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetPermissionsByCode(array $code)
	{
		$bookstatusList = $this->fetchAll();
		$arrayCount = count($code);
		$count = 0;
		$result = array();
		foreach($bookstatusList as $key=>$value){
			if(in_array($value->getcode(),$code)){
				$result[$value->getcode()] = $value; 
				$count++;
				if($count == $arrayCount){
					break;
				}				
			}			
		}

		return $result;
	}

}

