<?php
/**
*	Name			: PriorityDataMapper.php
*	Author			: kartheek
*	Creation Date	: 5/28/2011
*	Path 			: application/models/PriorityDataMapper.php
*	Description		: This is the DataMapper class for the priority basedata table.
*					   	
*/
class Application_Model_PriorityDataMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_Priority');
		}
		return $this->_dbTable;
	}
	
	public function fetchAll()
	{
		$cache = new Uss_Helper_CacheManager();
		$priority = array();
		if(!$priority = $cache->Fetch('priority')){
			$where = array('status = ?'=> true);
			$records = $this->getDbTable()->fetchAll($where);
						
			foreach($records as $record){
				$priority[] = new Application_Model_Priority(						
					$record->toArray());	
			}
			$cache->Save($priority,'priority');			
		}else{
			$priority = $cache->Fetch('priority');
		}
		
		$cache = null;
		return $priority;
	}
	
	public function GetPriorityByCode($code)
	{
		$priorityTypeList = $this->fetchAll();
		foreach($priorityTypeList as $key=>$value){
			if($value->getcode() == $code){
				return $value;	
			}			
		}		
	}
	
}