<?php
/**
*	Name			: ProfileStatusDataMapper.php
*	Author			: kartheek
*	Creation Date	: 7/04/2011
*	Path 			: application/models/ProfileStatusDataMapper.php
*	Description		: This is the DataMapper class for the profile status basedata table.
*					   	
*/
class Application_Model_ProfileStatusDataMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_ProfileStatus');
		}
		return $this->_dbTable;
	}
	
	public function fetchAll()
	{
		$cache = new Uss_Helper_CacheManager();
		$profilestatus = array();
		if(!$profilestatus = $cache->Fetch('profilestatus')){
			$where = array('status = ?'=> true);
			$records = $this->getDbTable()->fetchAll($where);
						
			foreach($records as $record){
				$profilestatus[] = new Application_Model_ProfileStatus(						
					$record->toArray());	
			}
			$cache->Save($profilestatus,'profilestatus');			
		}else{
			$profilestatus = $cache->Fetch('profilestatus');
		}
		
		$cache = null;
		return $profilestatus;
	}

	public function getProfileStatusByCode($code){
		$profileStatusList = $this->fetchAll();
		foreach($profileStatusList as $key=>$value){
			if($value->getcode() == $code){
				return $value;	
			}			
		}
	}
}