<?php

class Application_Model_RegionCityMapDataMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_RegionCityMap');
		}
		return $this->_dbTable;
	}
	
	public function getCityByRegionId($id)
	{
		$select = $this->getDbTable()->select();
		$select->from($this->getDbTable(),array('region_id','city_id'))
				->where('region_id =?',$id)
				->where('status =?',true);
		$result = $this->getDbTable()->fetchAll($select);
		return $result;
	}
	
	public function UpdateStatus($id,$city)
	{
		$status = false;
		$db = Zend_Db_Table::getDefaultAdapter();
		$mapset = array('status' =>$id);
				$mapwhere = $db->quoteInto('city_id = ?',$city);
				$resultSet = $this->getDbTable()->update($mapset,$mapwhere);
				if($resultSet){
					$status = true;
				}
				return $status;
	}
	
	public function getRegionCityMapByIds($regionIds, $cityIds)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			
			$select->from($table,array('id','region_id','city_id','status'))
				   ->where('region_id IN (?)',$regionIds)
				   ->where('city_id IN (?)',$cityIds);	
			$resultset = $table->fetchAll($select);
			$resultArr  = array();
			foreach($resultset as $key=>$value){
				$subArr = array();
				foreach($value as  $key1=>$value1){
					$subArr[$key1]= $value1;
				}
				$resultArr[] = $subArr;
			}
			return $resultArr;	
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}	
	}


}

