<?php
/**
*	Name			: ReservationModeDataMapper.php
*	Author			: kartheek
*	Creation Date	: 10/10/2010
*	Path 			: application/models/ReservationModeDataMapper.php
*	Description		: This is the DataMapper class for the reservationmode basedata table.
*					   	
*/
class Application_Model_ReservationModeDataMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_ReservationMode');
		}
		return $this->_dbTable;
	}
	
	public function fetchAll()
	{
		$cache = new Uss_Helper_CacheManager();
		$reserveMode = array();
		if(!$reserveMode = $cache->Fetch('reservemode')){
			$where = array('status = ?'=> true);
			$records = $this->getDbTable()->fetchAll($where);
						
			foreach($records as $record){
				$reserveMode[] = new Application_Model_ReservationMode(						
					$record->toArray());	
			}
			$cache->Save($reserveMode,'reservemode');			
		}else{
			$reserveMode = $cache->Fetch('reservemode');
		}
		
		$cache = null;
		return $reserveMode;
	}
	public function GetReservationModeByCode(array $code)
	{
		$ReservationModeList = $this->fetchAll();
		$arrayCount = count($code);
		$count = 0;
		$result = array();
		foreach($ReservationModeList as $key=>$value){
			if(in_array($value->getcode(),$code)){
				$result[$value->getcode()] = $value; 
				$count++;
				if($count == $arrayCount){
					break;
				}				
			}			
		}

		return $result;
	}
	
	public function GetReservationModeByDesc($desc)
	{
		$ReservationModeList = $this->fetchAll();
		$count = 0;
		$result = array();
		foreach($ReservationModeList as $key=>$value){
			if($value->getDescription() == $desc){
				$result[$value->getDescription()] = $value;
				$count++;
					break;
			}
		}
	
		return $result;
	}

}
