<?php
/**
*	Name			: ReservationStatusDataMapper.php
*	Author			: Zubair Ahmed
*	Creation Date	: 08/09/2010
*	Path 			: application/models/ReservationStatusDataMapper.php
*	Description		: This is the dataMapper class for the booking status basedata table.
*					   	
*/
class Application_Model_ReservationStatusDataMapper
{
	/**
	 * Instance variable of booking status basedata table
	 * @var object
	 */
	protected $_dbTable;
	
	/**
     * @param instance of DbTable BookingStatus $dbTable
     * @return self
     */
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	/**
     * @return instance of DbTable BookingStatus
     */
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_ReservationStatus');
		}
		return $this->_dbTable;
	}
	/**
	 * Fetches all the booking status basedata rows and saves in cache
	 */
	public function fetchAll()
	{
		$cache = new Uss_Helper_CacheManager();
		$bookstatus = array();
		//if(!$bookstatus = $cache->Fetch('bookstatus')){
			$where = array('status = ?'=> true);
			$records = $this->getDbTable()->fetchAll($where);
						
			foreach($records as $record){
				$bookstatus[] = new Application_Model_ReservationStatus(						
					$record->toArray());	
			}
			$cache->Save($bookstatus,'bookstatus');	
    /*		
		}else{
			$bookstatus = $cache->Fetch('bookstatus');
		}
		*/
		$cache = null;
		return $bookstatus;
	}
	
	/**
	 *Get Booking status by Code 
	 */
	public function GetBookingStatusByCode(array $code)
	{
		$bookstatusList = $this->fetchAll();
		$arrayCount = count($code);
		$count = 0;
		$result = array();
		foreach($bookstatusList as $key=>$value){
			if(in_array($value->getcode(),$code)){
				$result[$value->getcode()] = $value; 
				$count++;
				if($count == $arrayCount){
					break;
				}				
			}			
		}
		//echo '<pre>'; print_r($result); exit;
		return $result;
	}
	
	/**
	 *Get Booking status by id 
	 */
	public function GetBookingStatusById(array $id)
	{
		$bookstatusList = $this->fetchAll();
		$arrayCount = count($id);
		$count = 0;
		$result = array();
		foreach($bookstatusList as $key=>$value){
			if(in_array($value->getid(),$id)){
				$result[$value->getid()] = $value; 
				$count++;
				if($count == $arrayCount){
					break;
				}				
			}			
		}

		return $result;
	}
	
}