<?php
/**
*	Name			: BookingTypeDataMapper.php
*	Author			: Zubair Ahmed
*	Creation Date	: 10/10/2010
*	Path 			: application/models/ReservationTypeDataMapper.php
*	Description		: This is the dataMapper class for the booking type basedata table.
*					   	
*/
class Application_Model_ReservationTypeDataMapper
{
	/**
	 * Instance variable of booking status basedata table
	 * @var object
	 */
	protected $_dbTable;
	
	/**
     * @param instance of DbTable BookingType $dbTable
     * @return self
     */
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	/**
     * @return instance of DbTable BookingType
     */
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_ReservationType');
		}
		return $this->_dbTable;
	}
	
	/**
	 * Fetches all the bookingtype basedata rows and saves in cache
	 */
	public function fetchAll()
	{
		$cache = new Uss_Helper_CacheManager();
		$booktype = array();
		if(!$booktype = $cache->Fetch('booktype')){
			$where = array('status = ?'=> true);
			$records = $this->getDbTable()->fetchAll($where);
						
			foreach($records as $record){
				$booktype[] = new Application_Model_ReservationType(						
					$record->toArray());	
			}
			$cache->Save($booktype,'booktype');			
		}else{
			$booktype = $cache->Fetch('booktype');
		}
		
		$cache = null;
		return $booktype;
	}
	
	/**
	 *Get Booking type by Code 
	 */
	public function GetBookingTypeByCode($code)
	{
		$bookTypeList = $this->fetchAll();
		foreach($bookTypeList as $key=>$value){
			if($value->getcode() == $code){
				return $value;	
			}			
		}		
	}
	
	public function GetBookingTypeById($id)
	{
		$bookTypeList = $this->fetchAll();
		foreach($bookTypeList as $key=>$value){
			if($value->getId() == $id){
				return $value;	
			}			
		}		
	}
}