<?php

class Application_Model_RestPaymentModeMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_RestPaymentMode');
		}
		return $this->_dbTable;
	}
	//Restaurant Offline Payment base data values 	
	public function GetPaymentMode()
	{
		$cache = new Uss_Helper_CacheManager();
		$paymentstatus = array();
		if(!$paymentstatus = $cache->Fetch('paymentstatus')){
			$where = array('status = ?'=> true);
			$records = $this->getDbTable()->fetchAll($where);
			foreach($records as $record){
				$paymentstatus[] = new Application_Model_RestPaymentMode($record->toArray());	
			}
			$cache->Save($paymentstatus,'paymentstatus');			
		}else{
			$paymentstatus = $cache->Fetch('paymentstatus');
		}
		$cache = null;
		return $paymentstatus;
	}
	 public function GetIdByCode($code)
	{
		$paymentList = $this->GetPaymentMode();
		$arrayCount = count($code);
		$count = 0;
		foreach($paymentList as $key=>$value){
			if($value->getCode() == $code){
				$result = $value; 
				$count++;
				if($count == $arrayCount){
					break;
				}				
			}				
		}
		return $result;
	}
	
	
}
?>
