<?php
/**
*	Name			: RestPaymentPlanStatusDataMapper.php
*	Author			: snehal
*	Creation Date	: 7/4/2011
*	Path 			: application/models/RestPaymentPlanStatusDataMapper.php
*	Description		: This is the DataMapper class for the restaurant paymentplan status basedata table.
*					   	
*/
class Application_Model_RestPaymentPlanStatusDataMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_RestPaymentPlanStatus');
		}
		return $this->_dbTable;
	}
	
	public function fetchAll()
	{
		$cache = new Uss_Helper_CacheManager();
		$restpymtplanstatus = array();
		if(!$restpymtplanstatus = $cache->Fetch('restpymtplanstatus')){
			$where = array('status = ?'=> true);
			$records = $this->getDbTable()->fetchAll($where);
						
			foreach($records as $record){
				$restpymtplanstatus[] = new Application_Model_Priority(						
					$record->toArray());	
			}
			$cache->Save($restpymtplanstatus,'restpymtplanstatus');			
		}else{
			$restpymtplanstatus = $cache->Fetch('restpymtplanstatus');
		}
		
		$cache = null;
		return $restpymtplanstatus;
	}
	
	public function getRestPaymentPlanStatusByCode($code)
	{
		$restPymtPlanStatusList = $this->fetchAll();
		foreach($restPymtPlanStatusList as $key=>$value){
			if($value->getcode() == $code){
				return $value;	
			}			
		}		
	}
	
}