<?php
/**
*	Name			: RestaurantApprovalStatusDataMapper.php
*	Author			: kartheek
*	Creation Date	: 09/30/2010
*	Path 			: application/models/RestaurantApprovalStatusDataMapper.php
*	Description		: This is the DataMapper class for the restaurant approval status basedata table.
*					   	
*/
class Application_Model_RestaurantApprovalStatusDataMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_RestaurantApprovalStatus');
		}
		return $this->_dbTable;
	}
	
	public function fetchAll()
	{
		$cache = new Uss_Helper_CacheManager();
		$restappstatus = array();
		if(!$restappstatus = $cache->Fetch('restappstatus')){
			$where = array('status = ?'=> true);
			$records = $this->getDbTable()->fetchAll($where);
						
			foreach($records as $record){
				$restappstatus[] = new Application_Model_RestaurantApprovalStatus(						
					$record->toArray());	
			}
			$cache->Save($restappstatus,'restappstatus');			
		}else{
			$restappstatus = $cache->Fetch('restappstatus');
		}
		
		$cache = null;
		return $restappstatus;
	}
	

}

