<?php
/**
*	Name			: RestaurantCategoryDataMapper.php
*	Author			: snehal
*	Creation Date	: 12/28/2010
*	Path 			: application/models/RestaurantCategoryDataMapper.php
*	Description		: This is the DataMapper class for the restaurant category basedata table.
*					   	
*/
class Application_Model_RestaurantCategoryDataMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_RestaurantCategory');
		}
		return $this->_dbTable;
	}
	
	public function fetchAll()
	{
		$cache = new Uss_Helper_CacheManager();
		$restcategory = array();
		if(!$restcategory = $cache->Fetch('restcategory')){
			$where = array('status = ?'=> true);
			$records = $this->getDbTable()->fetchAll($where);
						
			foreach($records as $record){
				$restcategory[] = new Application_Model_RestaurantCategory(						
					$record->toArray());	
			}
			$cache->Save($restcategory,'restcategory');			
		}else{
			$restcategory = $cache->Fetch('restcategory');
		}
		
		$cache = null;
		return $restcategory;
	}
	public function getIdByCode(Application_Model_RestaurantCategory $restCategory)
	{
		$restCategoryBd = $this->fetchAll();
		if($restCategoryBd){
			foreach($restCategoryBd as $item){
				if($item->getCode() == $restCategory->getCode()){
					return $item;
				} 
			}
		}
	}
	

}

