<?php
/**
*	Name			: RestaurantPaymentModeDataMapper.php
*	Author			: snehal
*	Creation Date	: 12/28/2010
*	Path 			: application/models/RestaurantPaymentModeDataMapper.php
*	Description		: This is the DataMapper class for the restaurant paymentmode basedata table.
*					   	
*/
class Application_Model_RestaurantPaymentModeDataMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_RestaurantPaymentMode');
		}
		return $this->_dbTable;
	}
	
	public function fetchAll()
	{
		$cache = new Uss_Helper_CacheManager();
		$restpayment = array();
		if(!$restpayment = $cache->Fetch('restpayment')){
			$where = array('status = ?'=> true);
			$records = $this->getDbTable()->fetchAll($where);
						
			foreach($records as $record){
				$restpayment[] = new Application_Model_RestaurantPaymentMode(						
					$record->toArray());	
			}
			$cache->Save($restpayment,'restpayment');			
		}else{
			$restpayment = $cache->Fetch('restpayment');
		}
		
		$cache = null;
		return $restpayment;
	}
	public function getPaymentModeById(Application_Model_RestaurantPaymentMode $payment)
	{
		$paymentBd = $this->fetchAll();
		if($paymentBd){
			foreach($paymentBd as $item){
				if($item->getId() == $payment->getId()){
					return $item;
				} 
			}
		}
	}
	

}

