<?php
/**
*	Name			: RestaurantStatusDataMapper.php
*	Author			: snehal
*	Creation Date	: 9/30/2010
*	Path 			: application/models/RestaurantStatusDataMapper.php
*	Description		: This is the DataMapper class for the restaurant status basedata table.
*					   	
*/
class Application_Model_RestaurantStatusDataMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_RestaurantStatus');
		}
		return $this->_dbTable;
	}
	
	public function fetchAll()
	{
		$cache = new Uss_Helper_CacheManager();
		$reststatus = array();
		if(!$reststatus = $cache->Fetch('reststatus')){
			$where = array('status = ?'=> true);
			$records = $this->getDbTable()->fetchAll($where);
						
			foreach($records as $record){
				$reststatus[] = new Application_Model_RestaurantStatus(						
					$record->toArray());	
			}
			$cache->Save($reststatus,'reststatus');			
		}else{
			$reststatus = $cache->Fetch('reststatus');
		}
		
		$cache = null;
		return $reststatus;
	}
	
	

}

