<?php
/**
*	Name			: Role.php
*	Author			: snehal
*	Creation Date	: 2/4/2011
*	Path 			: application/models/Role.php
*	Description		: This is the Model class for the role basedata table.
*					   	
*/
class Application_Model_Role
{
	/**
	 * 
	 * @var integer
	 */
	protected $_id;
	
	/**
	 * 
	 * @var string
	 */
	protected $_code;
	
	/**
	 * 
	 * @var string
	 */
	protected $_description;
	
	/**
	 * 
	 * @var boolean
	 */
	protected $_status;
	
	/**
	 * 
	 * @var integer
	 */
	protected $_statusRestaurantId;
	
	/**
	 * 
	 * @var integer
	 */
	protected $_permissionid;

	protected $_companyid;
	protected $_roletypeid;
	protected $_createdby;
	/**
     * Public constructor
     *
     * @param  array $options
     */
	public function __construct(array $options = null)
	{
		if(is_array($options)){
			$this->setOptions($options);
		}
	}

	/**
	 * Writing data to properties
	 */
	public function __set($name, $value)
	{
		$method = 'set' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Role_BD property');
		}
		$this->$method($value);
	}

	/**
	 * Reading data from properties
	 */
	public function __get($name)
	{
		$method = 'get' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Role_BD property');
		}
		return $this->$method();
	}

	public function setOptions(array $options)
	{
		$methods = get_class_methods($this);
		foreach ($options as $key => $value) {
			$method = 'set' . ucfirst($key);
			if (in_array($method, $methods)) {
				$this->$method($value);
			}
		}
		return $this;
	}

	/**
     * @param integer $id
     * @return self
     */
	public function setId($id)
	{
		$this->_id = $id;
		return $this;
	}
	
 	/**
     * @return integer
     */
	public function getId()
	{
		return $this->_id;
	}
	
	/**
     * @param string $code
     * @return self
     */
	public function setRoleCode($code)
	{
		$this->_code = $code;
		return $this;
	}
	
	/**
     * @return string
     */
	public function getRoleCode()
	{
		return $this->_code;
	}
	
	/**
     * @param string $description
     * @return self
     */
	public function setRoleDesc($description)
	{
		$this->_description = $description;
		return $this;
	}
	
	/**
     * @return string
     */
	public function getRoleDesc()
	{
		return $this->_description;
	}
	
	/**
     * @param boolean $status
     * @return self
     */
	public function setStatus($status)
	{
		$this->_status = $status;
		return $this;
	}
	
	/**
     * @return boolean
     */
	public function getStatus()
	{
		return $this->_status;
	}

	/**
     * @param integer $statusRestaurantId
     * @return self
     */
	public function setRestaurantId($statusRestaurantId)
	{
		$this->_statusRestaurantId = $statusRestaurantId;
		return $this;
	}

	/**
     * @return integer
     */
	public function getRestaurantId()
	{
		return $this->_statusRestaurantId;
	}
	
	/**
     * @param integer $permissionid
     * @return self
     */
	public function setPermissionId($permissionid)
	{
		$this->_permissionid = $permissionid;
		return $this; 
	}
	
	/**
     * @return integer
     */
	public function getPermissionId()
	{
	    return	$this->_permissionid;
	}
	
	public function setCompanyId($companyid)
	{
		$this->_companyid = $companyid;
		return $this; 
	}
	
	public function getCompanyId()
	{
	    return	$this->_companyid;
	}
	
	public function setRoleTypeId($roletypeid)
	{
		$this->_roletypeid = $roletypeid;
		return $this; 
	}
	
	public function getRoleTypeId()
	{
	    return	$this->_roletypeid;
	}
	
	public function setCreatedBy($createdby)
	{
		$this->_createdby = $createdby;
		return $this; 
	}
	
	public function getCreatedBy()
	{
	    return	$this->_createdby;
	}
}

