<?php
/**
*	Name			: RolePermissionMapDataMapper.php
*	Author			: snehal
*	Creation Date	: 2/4/2011
*	Path 			: application/models/RolePermissionMapDataMapper.php
*	Description		: This is the DataMapper class for the role permission map table.
*					   	
*/
class Application_Model_RolePermissionMapDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_RolePermissionMap');
		}
		return $this->_dbTable;
	}

	public function getPermissionByRole($roleid)
	{
	 $rolesPermMapTable = $this->getDbTable();
	 $rolesPermMapSelect = $rolesPermMapTable->select();

	 $rolesPermMapSelect->setIntegrityCheck(false);
	 	 	
	 $rolesPermMapSelect->from(array('rpm'=>'mt.role_permission_map'),array('rpmid'))
	 					->join(array('per'=>'mt.permissionstype_bd'),'per.id = rpm.rpm_permissiontype_id',array('code as permcode','description as permdesc'))
	 					->where('rpm.rpm_roleid = ?',$roleid);
	 					
		 					
	 $rowSet =  $rolesPermMapTable->fetchAll($rolesPermMapSelect);

	 return $rowSet;
		 					
	}
	
	public function GetRoleMaptabledataByRoleids($roleids)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('rpmid','rpm_roleid','rpm_permissiontype_id','rpmcreatedby','rpmcreateddatetime','rpmupdatedby','rpmupdateddatetime'))
				   ->where('rpm_roleid IN(?)',$roleids);
				   
			$resultset = $table->fetchAll($select);
			
			$resultArr  = array();
			foreach($resultset as $key=>$value){
				$subArr = array();
				foreach($value as  $key1=>$value1){
					if($key1 == 'rpmcreatedby' || $key1 == 'rpmupdatedby'){
						$subArr[$key1]= null;
					}else{
						$subArr[$key1]= $value1;
					}
				}
				$resultArr[] = $subArr;
			}
			return $resultArr;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

}

