<?php
/**
*	Name			: ScheduleRestaurantIntervalsDataMapper.php
*	Author			: snehal
*	Creation Date	: 11/06/2010
*	Path 			: application/models/ScheduleRestaurantIntervalsDataMapper.php
*	Description		: This is the DataMapper class for the restaurant schedule intervals basedata table.
*					   	
*/
class Application_Model_ScheduleRestaurantIntervalsDataMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_ScheduleRestaurantIntervals');
		}
		return $this->_dbTable;
	}
	
	public function fetchAll()
	{
		$cache = new Uss_Helper_CacheManager();
		$restype = array();
		if(!$restype = $cache->Fetch('schtimings_bd')){
			$where = array('status = ?'=> true);
			$records = $this->getDbTable()->fetchAll($where);
			
			foreach($records as $record){
				$restype[] = new Application_Model_ScheduleRestaurantIntervals(						
					$record->toArray());	
			}
			$cache->Save($restype,'schtimings_bd');			
		}else{
			$restype = $cache->Fetch('schtimings_bd');
		}
		
		$cache = null;
		return $restype;
	}
	public function getScheduleTimingsBD()
	{
		$result = $this->fetchAll();
		$schArr = array();
		foreach($result as $row){
			$schArr[] = array('key'=>$row->code,'value'=>$row->description); 	
			
		}
		return $schArr;
	}
}