<?php 
/**
*	Name			: ScheduleTypeDataMapper.php
*	Author			: Kartheek
*	Creation Date	: 09/08/2010
*	Path 			: application/models/ScheduleTypeDataMapper.php
*	Description		: This is the dataMapper class for the schedule type basedata table.
*					   	
*/
class Application_Model_ScheduleTypeDataMapper
{
	/**
	 * Instance variable of schedule type basedata table
	 * @var object
	 */
	protected $_dbTable;
	
	/**
     * @param instance of DbTable schedule type $dbTable
     * @return self
     */
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	/**
     * @return instance of DbTable schedule type
     */
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_ScheduleType');
		}
		return $this->_dbTable;
	}
	/**
	 * Fetches all the schedule type basedata rows and saves in cache
	 */
	public function fetchAll()
	{
		$cache = new Uss_Helper_CacheManager();
		$scheduletype = array();
		if(!$scheduletype = $cache->Fetch('scheduletype')){
			$where = array('status = ?'=> true);
			$records = $this->getDbTable()->fetchAll($where);
						
			foreach($records as $record){
				$scheduletype[] = new Application_Model_ScheduleType(						
					$record->toArray());	
			}
			$cache->Save($scheduletype,'scheduletype');			
		}else{
			$scheduletype = $cache->Fetch('scheduletype');
		}
		
		$cache = null;
		return $scheduletype;
	}
	
	/**
	 *Get schedule type by Code 
	 */
	public function GetScheduleTypeByCode($code)
	{
		$scheduletypeList = $this->fetchAll();
		foreach($scheduletypeList as $key=>$value){
			if($value->getcode() == $code){
				return $value;	
			}			
		}	
	}
		
}
