<?php
/**
*	Name			: ServiceTax.php
*	Author			: mahesh
*	Creation Date	: 7/02/2011
*	Path 			: application/models/ServiceTax.php
*	Description		: This is the Model class for the servicetax basedata table.
*					   	
*/
class Application_Model_ServiceTax
{
	/**
	 * 
	 * @var integer
	 */
	private $_id;
	
	/**
	 * 
	 * @var string
	 */
	private $_code;
	
	/**
	 * 
	 * @var string
	 */
	private $_description;
	
	/**
	 * 
	 * @var boolean
	 */
	private $_status;
	
	/**
	 * 
	 * @var double
	 */
	private $_tax;
	
	/**
	 * 
	 * @var integer
	 */
	private $_created_by;
	
	/**
	 * 
	 * @var date
	 */
	private $_created_date;
	
	/**
	 * 
	 * @var integer
	 */
	private $_updated_by;
	
	/**
	 * 
	 * @var date
	 */
	private $_updated_date;
	
	/**
     * Public constructor
     *
     * @param  array $options
     */
	public function __construct(array $options = null)
	{
		if(is_array($options)){
			$this->setOptions($options);
		}		
	}
	
	/**
	 * Writing data to properties
	 */
	public function __set($name, $value)
	{
		$method = 'set' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid ServiceTax property');
		}
		$this->$method($value);
	}
	
	/**
	 * Reading data from properties
	 */
	public function __get($name)
	{
		$method = 'get' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid ServiceTax property');
		}
		return $this->$method();
	}
	
	public function setOptions(array $options)
	{
		$methods = get_class_methods($this);
		foreach ($options as $key => $value) {
			$method = 'set' . ucfirst($key);
			if (in_array($method, $methods)) {
				$this->$method($value);
			}
		}
		return $this;
	}
	
	/**
     * @param integer $id
     * @return self
     */
	public function setid($id)
	{
		$this->_id = $id;
		return $this;
	}
	
	/**
     * @return integer
     */
	public function getid()
	{
		return $this->_id;
	}
	
	/**
     * @param string $code
     * @return self
     */
	public function setcode($code)
	{
		$this->_code = $code;
		return $this;
	}
	
	/**
     * @return string
     */
	public function getcode()
	{
		return $this->_code;
	}
	
	/**
     * @param string $description
     * @return self
     */
	public function setdescription($description)
	{
		$this->_description = $description;
		return $this;
	}
	
	/**
     * @return string
     */
	public function getdescription()
	{
		return $this->_description;
	}
		
	/**
     * @param boolean $status
     * @return self
     */
	public function setstatus($status)
	{
		$this->_status = $status;
		return $this;
	}
	
	/**
     * @return boolean
     */
	public function getstatus()
	{
		return $this->_status;
	}
	
	/**
     * @param double $tax
     * @return self
     */
	public function settax($tax)
	{
		$this->_tax = $tax;
		return $this;
	}
	
	/**
     * @return double
     */
	public function gettax()
	{
		return $this->_tax;
	}
	
	/**
     * @param integer $created_by
     * @return self
     */
	public function setcreated_by($created_by)
	{
		$this->_created_by = $created_by;
		return $this;
	}
	
	/**
     * @return integer
     */
	public function getcreated_by()
	{
		return $this->_created_by; 
	}
	
	/**
     * @param date $created_date
     * @return self
     */
	public function setcreated_date($created_date)
	{
		$this->_created_date = $created_date;
		return $this;
	}
	
	/**
     * @return date
     */	
	public function getcreated_date()
	{
		return $this->_created_date;
	}
	
	
	/**
     * @param integer $updated_by
     * @return self
     */
	public function setupdated_by($updated_by)
	{
		$this->_updated_by = $updated_by;
		return $this;
	}
	
	/**
     * @return integer
     */
	public function getupdated_by()
	{
		return $this->_updated_by;
	}
	
	/**
     * @param date $updated_date
     * @return self
     */
	public function setupdated_date($updated_date)
	{
		$this->_updated_date = $updated_date;
		return $this;
	}
	
	/**
     * @return date
     */	
	public function getupdated_date()
	{
		return $this->_updated_date;
	}
}