<?php
/**
*	Name			: ServiceTaxDataMapper.php
*	Author			: mahesh
*	Creation Date	: 7/02/2011
*	Path 			: application/models/ServiceTaxDataMapper.php
*	Description		: This is the DataMapper class for the servicetax basedata table.
*					   	
*/
class Application_Model_ServiceTaxMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_ServiceTax');
		}
		return $this->_dbTable;
	}
	
	public function RetrieveServiceTax()
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();
			
			$select->from($table,array('id','tax as servicetax','description as servicedesc'))
				   ->where('status = ?',true);
				   
			$rowSet = $table->fetchAll($select);

			return $rowSet;
			 
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
		
	}
	
	public function EditServiceTax(Application_Model_ServiceTax $taxobj)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$set = array(
					'tax' =>	$taxobj->gettax()	
				);
				
			$where = $db->quoteInto('id = ?',$taxobj->getid());
			$result = $this->getDbTable()->update($set,$where);
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}