<?php
/**
*	Name			: SmsTemplateDataMapper.php
*	Author			: mahesh
*	Creation Date	: 12/18/2010
*	Path 			: application/models/SmsTemplateDataMapper.php
*	Description		: This is the DataMapper class for the sms template basedata table.
*					   	
*/
class Application_Model_SmsTemplateDataMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_SmsTemplate');
		}
		return $this->_dbTable;
	}
	
	public function fetchAll()
	{
		$cache = new Uss_Helper_CacheManager();
		$smstemplates = array();
		if(!$smstemplates = $cache->Fetch('smstemplate')){
			$where = array('status = ?'=> true);
			$records = $this->getDbTable()->fetchAll($where);
						
			foreach($records as $record){
				$smsObj = new Application_Model_SmsTemplate();
				$smsObj->setId($record['id'])
					   ->setCode($record['code'])
					   ->setmsg_body($record['msg_body'])
					   ->setStatus($record['status']);	 
				$smstemplates[] = $smsObj;	
			}
			$cache->Save($smstemplates,'smstemplate');			
		}else{
			$smstemplates = $cache->Fetch('smstemplate');
		}
		$cache = null;
		return $smstemplates;
	}
	
	public function getSmsTempByCode($code)
	{
		$templates = $this->fetchAll();
		if($templates){
			foreach($templates as $template){
				if($template->code == $code){
					return $template;
				}
			}
		}
	}
}