<?php
/**
*	Name			: SocialMediaTypeDataMapper.php
*	Author			: kartheek
*	Creation Date	: 9/30/2010
*	Path 			: application/models/SocialMediaTypeDataMapper.php
*	Description		: This is the DataMapper class for the socialmedia type basedata table.
*					   	
*/
class Application_Model_SocialMediaTypeDataMapper
{

	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_SocialMediaType');
		}
		return $this->_dbTable;
	}
	
	public function fetchAll()
	{
		$cache = new Uss_Helper_CacheManager();
		$mediaType = array();
		if(!$mediaType = $cache->Fetch('mediatype')){
			    $where = array('status = ?'=> true);
			$records = $this->getDbTable()->fetchAll($where);
						
			foreach($records as $record){
				$mediaType[] = new Application_Model_SocialMediaType(						
					$record->toArray());	
			}
			$cache->Save($mediaType,'mediatype');			
		}else{
			$mediaType = $cache->Fetch('mediatype');
		}
		
		$cache = null;
		return $mediaType;
	}
	
	
}

