<?php
class Application_Model_SpecialPriceTypeDataMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_SpecialPriceType');
		}
		return $this->_dbTable;
	}
	
	public function fetchAll()
	{
		$cache = new Uss_Helper_CacheManager();
		$splpricetype = array();
		if(!$splpricetype = $cache->Fetch('specialpricetype')){
			$where = array('status = ?'=> true);
			$records = $this->getDbTable()->fetchAll($where);
						
			foreach($records as $record){
				$splpricetype[] = new Application_Model_Origin(						
					$record->toArray());	
			}
			$cache->Save($splpricetype,'specialpricetype');			
		}else{
			$splpricetype = $cache->Fetch('specialpricetype');
		}
		
		$cache = null;
		return $splpricetype;
	}	
}