<?php
class Application_Model_SpecialStatusDataMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_SpecialStatus');
		}
		return $this->_dbTable;
	}
	
	public function fetchAll()
	{
		$cache = new Uss_Helper_CacheManager();
		$specialstatus = array();
		if(!$specialstatus = $cache->Fetch('specialcode')){
			$where = array('status = ?'=> true);
	//		$order = array('id');
			$records = $this->getDbTable()->fetchAll($where);
						
			foreach($records as $record){
				$specialstatus[] = new Application_Model_SpecialStatus(						
					$record->toArray());	
			}
			$cache->Save($specialstatus,'specialcode');			
		}else{
			$specialstatus = $cache->Fetch('specialcode');
		}
		
		$cache = null;
		return $specialstatus;
	}
}