<?php
/**
*	Name			: SponsorTimeSelectionDataMapper.php
*	Author			: mahesh
*	Creation Date	: 5/28/2011
*	Path 			: application/models/SponsorTimeSelectionDataMapper.php
*	Description		: This is the DataMapper class for the sponsor timeselection basedata table.
*					   	
*/
class Application_Model_SponsorTimeSelectionDataMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_SponsorTimeSelection');
		}
		return $this->_dbTable;
	}
	
	public function fetchAll()
	{
		$cache = new Uss_Helper_CacheManager();
		$sponsortime = array();
		if(!$sponsortime = $cache->Fetch('sponsortimesel')){
			$where = array('status = ?'=> true);
			$order = array('id');
			$records = $this->getDbTable()->fetchAll($where,$order);
						
			foreach($records as $record){
				$sponsortime[] = new Application_Model_SponsorTimeSelection(						
					$record->toArray());	
			}
			$cache->Save($sponsortime,'sponsortimesel');			
		}else{
			$sponsortime = $cache->Fetch('sponsortimesel');
		}
		
		$cache = null;
		return $sponsortime;
	}
}