<?php
/**
*	Name			: State.php
*	Author			: mahesh 
*	Creation Date	: 9/30/2010
*	Path 			: application/models/State.php
*	Description		: This is the Model class for the state basedata table.
*					   	
*/
class Application_Model_State
{
	/**
	 * 
	 * @var integer
	 */
	protected $_id;
	
	/**
	 * 
	 * @var string
	 */
	protected $_code;
	
	/**
	 * 
	 * @var string
	 */
	protected $_description;
	
	/**
	 * 
	 * @var boolean
	 */
	protected $_status;
	
	protected $_currency_code;
	protected $_country_dial_code;
	protected $_country_flag;
	protected $_time_zone;
	/**
     * Public constructor
     *
     * @param  array $options
     */
	public function __construct(array $options = null)
	{
		if(is_array($options)){
			$this->setOptions($options);
		}		
	}
	
	/**
	 * Writing data to properties
	 */
	public function __set($name, $value)
	{
		$method = 'set' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid State_BD property');
		}
		$this->$method($value);
	}
	
	/**
	 * Reading data from properties
	 */
	public function __get($name)
	{
		$method = 'get' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid State_BD property');
		}
		return $this->$method();
	}
	
	public function setOptions(array $options)
	{
		$methods = get_class_methods($this);
		foreach ($options as $key => $value) {
			$method = 'set' . ucfirst($key);
			if (in_array($method, $methods)) {
				$this->$method($value);
			}
		}
		return $this;
	}
	
	/**
     * @param integer $id
     * @return self
     */
	public function setId($id)
	{
		$this->_id = $id;
		return $this;
	}
	
 	/**
     * @return integer
     */
	public function getId()
	{
		return $this->_id;
	}
	
	/**
     * @param string $code
     * @return self
     */
	public function setCode($code)
	{
		$this->_code = $code;
		return $this;
	}
	
	/**
     * @return string
     */
	public function getCode()
	{
		return $this->_code;
	}
	
	/**
     * @param string $description
     * @return self
     */
	public function setDescription($description)
	{
		$this->_description = $description;
		return $this;
	}
	
	/**
     * @return string
     */
	public function getDescription()
	{
		return $this->_description;
	}
	
	/**
     * @param boolean $status
     * @return self
     */
	public function setStatus($status)
	{
		$this->_status = $status;
		return $this;
	}
	
	/**
     * @return boolean
     */
	public function getStatus()
	{
		return $this->_status;
	}
	
	public function setCurrency_code($currency_code)
	{
		$this->_currency_code = $currency_code;
		return $this;
	}
	
	/**
     * @return boolean
     */
	public function getCurrency_code()
	{
		return $this->_currency_code;
	}
	
	public function setCountry_dial_code($country_dial_code)
	{
		$this->_country_dial_code = $country_dial_code;
		return $this;
	}
	
	/**
     * @return boolean
     */
	public function getCountry_dial_code()
	{
		return $this->_country_dial_code;
	}
	
	public function setCountry_flag($country_flag)
	{
		$this->_country_flag = $country_flag;
		return $this;
	}
	
	/**
     * @return boolean
     */
	public function getCountry_flag()
	{
		return $this->_country_flag;
	}
	
	public function setTimezone($timezone)
	{
		$this->_time_zone = $timezone;
		return $this;
	}
	
	/**
     * @return boolean
     */
	public function getTimezone()
	{
		return $this->_time_zone;
	}
}

