<?php
/**
*	Name			: StateCityMap.php
*	Author			: mahesh 
*	Creation Date	: 9/30/2010
*	Path 			: application/models/StateCityMap.php
*	Description		: This is the Model class for the state and city map basedata table.
*					   	
*/
class Application_Model_StateCityMap
{
	/**
	 * 
	 * @var integer
	 */
	protected $_id;
	
	/**
	 * 
	 * @var integer
	 */
	protected $_state_id;
	
	/**
	 * 
	 * @var integer
	 */
	protected $_city_id;
	
	/**
	 * 
	 * @var boolean
	 */
	protected $_status;
	
	/**
     * Public constructor
     *
     * @param  array $options
     */
	public function __construct(array $options = null)
	{
		if(is_array($options)){
			$this->setOptions($options);
		}		
	}
	
	/**
	 * Writing data to properties
	 */
	public function __set($name, $value)
	{
		$method = 'set' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid StateCityMap property');
		}
		$this->$method($value);
	}
	
	/**
	 * Reading data from properties
	 */
	public function __get($name)
	{
		$method = 'get' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid StateCityMap property');
		}
		return $this->$method();
	}
	
	public function setOptions(array $options)
	{
		$methods = get_class_methods($this);
		foreach ($options as $key => $value) {
			$method = 'set' . ucfirst($key);
			if (in_array($method, $methods)) {
				$this->$method($value);
			}
		}
		return $this;
	}
	
	/**
     * @param integer $id
     * @return self
     */
	public function setId($id)
	{
		$this->_id = $id;
		return $this;
	}
	
	/**
     * @return integer
     */
	public function getId()
	{
		return $this->_id;
	}
	
	/**
     * @param integer $state_id
     * @return self
     */
	public function setStateId($state_id)
	{
		$this->_state_id = $state_id;
		return $this;
	}
	
	/**
     * @return integer
     */
	public function getStateId()
	{
		return $this->_state_id;
	}
	
	/**
     * @param integer $city_id
     * @return self
     */
	public function setCityId($city_id)
	{
		$this->_city_id = $city_id;
		return $this;
	}
	
	/**
     * @return integer
     */
	public function getCityId()
	{
		return $this->_city_id;
	}
	
	/**
     * @param boolean $status
     * @return self
     */
	public function setStatus($status)
	{
		$this->_status = $status;
		return $this;
	}
	
	/**
     * @return boolean
     */
	public function getStatus()
	{
		return $this->_status;
	}

}

