<?php
/**
*	Name			: StateCityMapDataMapper.php
*	Author			: mahesh 
*	Creation Date	: 9/30/2010
*	Path 			: application/models/StateCityMapDataMapper.php
*	Description		: This is the DataMapper class for the state and city map basedata table.
*					   	
*/
class Application_Model_StateCityMapDataMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_StateCityMap');
		}
		return $this->_dbTable;
	}
	
	public function getCityByStateId($id)
	{
		$select = $this->getDbTable()->select();
		$select->from($this->getDbTable(),array('state_id','city_id'))
				->where('state_id =?',$id)
				->where('status =?',true);
		$result = $this->getDbTable()->fetchAll($select);
		return $result;
	}
	
	public function UpdateStatus($id,$city)
	{
		$status = false;
		$db = Zend_Db_Table::getDefaultAdapter();
		$mapset = array('status' =>$id);
				$mapwhere = $db->quoteInto('city_id = ?',$city);
				$resultSet = $this->getDbTable()->update($mapset,$mapwhere);
				if($resultSet){
					$status = true;
				}
				return $status;
	}
//	public function fetchAll()
//	{
//		$cache = new Uss_Helper_CacheManager();
//		$states = array();
//		if(!$states = $cache->Fetch('states')){
//			$where = array('status = ?'=> true);
//			$records = $this->getDbTable()->fetchAll($where);
//						
//			foreach($records as $record){
//				$states[] = new Application_Model_StateCityMap(						
//					$record->toArray());	
//			}
//			$cache->Save($states,'states');			
//		}else{
//			$states = $cache->Fetch('states');
//		}
//		
//		$cache = null;
//		return $states;
//	}

}

