<?php

class Application_Model_StateRegionMapDataMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_StateRegionMap');
		}
		return $this->_dbTable;
	}
	
	public function getRegionByStateId($id)
	{
		$select = $this->getDbTable()->select();
		$select->from($this->getDbTable(),array('state_id','region_id'))
				->where('state_id =?',$id)
				->where('status =?',true);
		$result = $this->getDbTable()->fetchAll($select);
		return $result;
	}
	
	public function UpdateStatus($id,$region)
	{
		$status = false;
		$db = Zend_Db_Table::getDefaultAdapter();
		$mapset = array('status' =>$id);
				$mapwhere = $db->quoteInto('region_id = ?',$region);
				$resultSet = $this->getDbTable()->update($mapset,$mapwhere);
				if($resultSet){
					$status = true;
				}
				return $status;
	}
	
	public function getStateRegionMapByIds($satateIds, $regionIds)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			
			$select->from($table,array('id','state_id','region_id','status'))
				   ->where('state_id IN (?)',$satateIds)
				   ->where('region_id IN (?)',$regionIds);	
			$resultset = $table->fetchAll($select);
			$resultArr  = array();
			foreach($resultset as $key=>$value){
				$subArr = array();
				foreach($value as  $key1=>$value1){
					$subArr[$key1]= $value1;
				}
				$resultArr[] = $subArr;
			}
			return $resultArr;	
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}	
	}


}

