<?php
/**
*	Name			: SubscriptionPlanStatusDataMapper.php
*	Author			: mahesh 
*	Creation Date	: 6/30/2011
*	Path 			: application/models/SubscriptionPlanStatusDataMapper.php
*	Description		: This is the DataMapper class for the subscription planstatus basedata table.
*					   	
*/
class Application_Model_SubscriptionPlanStatusDataMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_SubscriptionPlanStatus');
		}
		return $this->_dbTable;
	}
	
	public function fetchAll()
	{
		$cache = new Uss_Helper_CacheManager();
		$bookstatus = array();
		if(!$bookstatus = $cache->Fetch('subscriptionplanstatus')){
			$where = array('status = ?'=> true);
			$records = $this->getDbTable()->fetchAll($where);
						
			foreach($records as $record){
				$bookstatus[] = new Application_Model_SubscriptionPlanStatus(						
					$record->toArray());	
			}
			$cache->Save($bookstatus,'subscriptionplanstatus');			
		}else{
			$bookstatus = $cache->Fetch('subscriptionplanstatus');
		}
		
		$cache = null;
		return $bookstatus;
	}
	
	public function GetSubscriptionStatusByCode(array $code)
	{
		$subscriptionstatusList = $this->fetchAll();
		$arrayCount = count($code);
		$count = 0;
		$result = array();
		foreach($subscriptionstatusList as $key=>$value){
			if(in_array($value->getcode(),$code)){
				$result[$value->getcode()] = $value; 
				$count++;
				if($count == $arrayCount){
					break;
				}				
			}			
		}

		return $result;
	}
	
	public function GetSubscriptionStatusById(array $id)
	{
		$subscriptionstatusList = $this->fetchAll();
		$arrayCount = count($id);
		$count = 0;
		$result = array();
		foreach($subscriptionstatusList as $key=>$value){
			if(in_array($value->getid(),$id)){
				$result[$value->getid()] = $value; 
				$count++;
				if($count == $arrayCount){
					break;
				}				
			}			
		}

		return $result;
	}
	
}