<?php
/**
*	Name			: TimeZoneDataMapper.php
*	Author			: naresh 
*	Creation Date	: 10/8/2010
*	Path 			: application/models/TimeZoneDataMapper.php
*	Description		: This is the DataMapper class for the time zone basedata table.
*					   	
*/
class Application_Model_TimeZoneDataMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_TimeZone');
		}
		return $this->_dbTable;
	}
	
	public function fetchAll()
	{
		$cache = new Uss_Helper_CacheManager();
		$timezones = array();
		if(!$timezones = $cache->Fetch('timezones')){
			$where = array('status = ?'=> true);
			$records = $this->getDbTable()->fetchAll($where);
						
			foreach($records as $record){
				$timezones[] = new Application_Model_TimeZone(						
					$record->toArray());	
			}
			$cache->Save($timezones,'timezones');			
		}else{
			$timezones = $cache->Fetch('timezones');
		}
		
		$cache = null;
		return $timezones;
	}
	
	public function getTimeZonesByStateId(Application_Model_TimeZone $timezoneObj)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->from('mt.timezone_bd',array('id','code','description','country_id'))
					//->where('mt.timezone_bd.country_id = ?',$timezoneObj->getCountryId())	       
					->where('mt.timezone_bd.status = ?',true)
					->order(array('mt.timezone_bd.description'));	       
			$records = $this->getDbTable()->fetchAll($select);	
			$dataArr = array();
			$dataArr[] = array("key"=>"","value"=>"Select TimeZone");
			foreach($records as $record){
				$dataArr[] = array("key"=>$record->description,"value"=>$record->description);
			}		
			return $dataArr;			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function updateCountryIdByTimezoneId($countryid,$timezoneId)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$set =  array('country_id'	=> 	$countryid);
			$where = $db->quoteInto('id = ?',$timezoneId);
			$result = $this->getDbTable()->update($set,$where);
			return $result;
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}

