<?php
/**
*	Name			: TransactionChargesDataMapper.php
*	Author			: Zubair Ahmed 
*	Creation Date	: 7/2/2011
*	Path 			: application/models/TransactionChargesDataMapper.php
*	Description		: This is the DataMapper class for the transaction charges basedata table.
*					   	
*/
class Application_Model_TransactionChargesMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_TransactionCharges');
		}
		return $this->_dbTable;
	}
	
	public function ReterieveTransactionCharges()
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();
			
			$select->from($table,array('id','charge as txncharge','description as txnchargedesc'))
				   ->where('status = ?',true);
				   
			$rowSet = $table->fetchAll($select);
			return $rowSet;
			 
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function ReterieveTransactionChargeByCode($code)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();
			
			$select->from($table,array('id','charge as txncharge','description as txnchargedesc'))
				   ->where('status = ?',true)
				   ->where('code = ?',$code);
				   
			$rowSet = $table->fetchAll($select);

			return $rowSet;
			 
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function EditTransactionCharges(Application_Model_TransactionCharges $chargeobj)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$set = array(
					'charge' =>	$chargeobj->getcharge()	
				);
				
			$where = $db->quoteInto('id = ?',$chargeobj->getid());
			$result = $this->getDbTable()->update($set,$where);
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}