<?php
/**
*	Name			: TransactionStatusDataMapper.php
*	Author			: naresh 
*	Creation Date	: 7/4/2011
*	Path 			: application/models/TransactionStatusDataMapper.php
*	Description		: This is the DataMapper class for the transaction status basedata table.
*					   	
*/
class Application_Model_TransactionStatusDataMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_TransactionStatus');
		}
		return $this->_dbTable;
	}
	
	public function fetchAll()
	{
		$cache = new Uss_Helper_CacheManager();
		$transactionstatus = array();
		if(!$transactionstatus = $cache->Fetch('transactionstatus')){
			$where = array('status = ?'=> true);
			$records = $this->getDbTable()->fetchAll($where);
						
			foreach($records as $record){
				$transactionstatus[] = new Application_Model_TransactionStatus(						
					$record->toArray());	
			}
			$cache->Save($transactionstatus,'transactionstatus');			
		}else{
			$transactionstatus = $cache->Fetch('transactionstatus');
		}
		
		$cache = null;
		return $transactionstatus;
	}
	
	public function getTransactionStatusByCode($code){
		$txnStatusList = $this->fetchAll();
		foreach($txnStatusList as $key=>$value){
			if($value->getcode() == $code){
				return $value;	
			}			
		}
	}

}