<?php
/**
*	Name			: TransactionTypeDataMapper.php
*	Author			: mahesh 
*	Creation Date	: 7/4/2011
*	Path 			: application/models/TransactionTypeDataMapper.php
*	Description		: This is the DataMapper class for the transaction type basedata table.
*					   	
*/
class Application_Model_TransactionTypeDataMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_TransactionType');
		}
		return $this->_dbTable;
	}
	
	public function fetchAll()
	{
		$cache = new Uss_Helper_CacheManager();
		$transactiontype = array();
		if(!$transactiontype = $cache->Fetch('transactiontype')){
			$where = array('status = ?'=> true);
			$records = $this->getDbTable()->fetchAll($where);
						
			foreach($records as $record){
				$transactiontype[] = new Application_Model_TransactionType(						
					$record->toArray());	
			}
			$cache->Save($transactiontype,'transactiontype');			
		}else{
			$transactiontype = $cache->Fetch('transactiontype');
		}
		
		$cache = null;
		return $transactiontype;
	}
	
	public function getTransactionTypeByCode($code){
		$txnTypeList = $this->fetchAll();
		foreach($txnTypeList as $key=>$value){
			if($value->getcode() == $code){
				return $value;	
			}			
		}
	}

}