<?php
/**
*	Name			: UlistPrice
*	Author			: Sairam
*	Creation Date	: 7/02/2012
*	Path 			: application/models/UlistPrice
*	Description		: This is the Model class for the UlistPrice basedata table.
*					   	
*/
class Application_Model_UlistPrice
{
	
	/**
	 * 
	 * @var integer
	 */
	protected $_id;
	
	/**
	 * 
	 * @var integer
	 */
	protected $_userid;
	
	/**
	 * 
	 * @var money
	 */
	protected $_price;
	
	
	/**
	 * 
	 * @var date
	 */
	protected $_createdDate;
	
	/**
	 * 
	 * @var date
	 */
	protected $_updatedDate;
	
	/**
	 * 
	 * @var boolean
	 */
	
	protected $_status;
	
	/**
     * Public constructor
     *
     * @param  array $options
     */
	public function __construct(array $options = null)
	{
		if(is_array($options)){
			$this->setOptions($options);
		}		
	}
	
	/**
	 * Writing data to properties
	 */
	public function __set($name, $value)
	{
		$method = 'set' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid State_BD property');
		}
		$this->$method($value);
	}
	
	/**
	 * Reading data from properties
	 */
	public function __get($name)
	{
		$method = 'get' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid State_BD property');
		}
		return $this->$method();
	}
	
	public function setOptions(array $options)
	{
		$methods = get_class_methods($this);
		foreach ($options as $key => $value) {
			$method = 'set' . ucfirst($key);
			if (in_array($method, $methods)) {
				$this->$method($value);
			}
		}
		return $this;
	}
	
	/**
     * @param integer $id
     * @return self
     */
	public function setId($id)
	{
		$this->_id = $id;
		return $this;
	}
	
 	/**
     * @return integer
     */
	public function getId()
	{
		return $this->_id;
	}
	
	/**
     * @param string $userid
     * @return self
     */
	public function setUserId($userid)
	{
		$this->_userid = $userid;
		return $this;
	}
	
	/**
     * @return string
     */
	public function getUserId()
	{
		return $this->_userid;
	}
	
	/**
     * @param string $price
     * @return self
     */
	public function setPrice($price)
	{
		$this->_price = $price;
		return $this;
	}
	
	/**
     * @return string
     */
	public function getPrice()
	{
		return $this->_price;
	}
	
	
	/**
     * @param integer $createdDate
     * @return self
     */
	public function setCreatedDate($createdDate)
	{
		$this->_createdDate = $createdDate;
		return $this;
	}

	/**
     * @return date
     */
	public function getCreatedDate()
	{
		return $this->_createdDate;
	}
	
	/**
     * @param integer $createdDate
     * @return self
     */
	public function setUpdatedDate($updatedDate)
	{
		$this->_updatedDate = $updatedDate;
		return $this;
	}

	/**
     * @return date
     */
	public function getUpdatedDate()
	{
		return $this->_updatedDate;
	}
	
	
	/**
     * @param boolean $status
     * @return self
     */
	public function setStatus($status)
	{
		$this->_status = $status;
		return $this;
	}
	
	/**
     * @return boolean
     */
	public function getStatus()
	{
		return $this->_status;
	}
}

