<?php
/**
*	Name			: WaitingQuoteTimeDataMapper.php
*	Author			: snehal
*	Creation Date	: 06/08/2011
*	Path 			: application/models/WaitingQuoteTimeDataMapper.php
*	Description		: This is the dataMapper class for the booking status basedata table.
*					   	
*/
class Application_Model_WaitingQuoteTimeDataMapper
{
	/**
	 * Instance variable of booking status basedata table
	 * @var object
	 */
	protected $_dbTable;
	
	/**
     * @param instance of DbTable WaitingQuoteTimeDataMapper $dbTable
     * @return self
     */
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	/**
     * @return instance of DbTable BookingStatus
     */
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_WaitingQuoteTime');
		}
		return $this->_dbTable;
	}
	/**
	 * Fetches all the booking status basedata rows and saves in cache
	 */
	public function fetchAll()
	{
		$cache = new Uss_Helper_CacheManager();
		$waitingquote = array();
		if(!$waitingquote = $cache->Fetch('waitingquote')){
			$where = array('status = ?'=> true);
			$order = array('id');
			$records = $this->getDbTable()->fetchAll($where,$order);
						
			foreach($records as $record){
				$waitingquote[] = new Application_Model_WaitingQuoteTime(						
					$record->toArray());	
			}
			$cache->Save($waitingquote,'waitingquote');			
		}else{
			$waitingquote = $cache->Fetch('waitingquote');
		}
		
		$cache = null;
		return $waitingquote;
	}
	
	public function GetQuoteTimeByCode(array $code)
	{
		$QuoteTimeList = $this->fetchAll();
   //echo '<pre>'; print_r($QuoteTimeList); exit;
		$arrayCount = count($code);
		$count = 0;
		$result = array();
		foreach($QuoteTimeList as $key=>$value){
			if(in_array($value->getcode(),$code)){
				$result[$value->getcode()] = $value; 
				$count++;
				if($count == $arrayCount){
					break;
				}				
			}			
		}

		return $result;
	}
	
	public function getQuoteTimeById($id)
	{
		try{
			$QuoteTimeList = $this->fetchAll();
			foreach($QuoteTimeList as $key=>$value){
			if($value->getId() == $id){
				return $value;	
			}			
		}	
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}