<?php

class Application_Model_WeekRecurrDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_WeekRecurr');
		}
		return $this->_dbTable;
	}

	public function fetchAll()
	{
		$cache = new Uss_Helper_CacheManager();
		$weekrecurr = array();
		if(!$weekrecurr = $cache->Fetch('weekrecurr')){
			$where = array('status = ?'=> true);
			$order = array('description');
			$records = $this->getDbTable()->fetchAll($where,$order);
			
			foreach($records as $record){
				$weekrecurr[] = new Application_Model_WeekRecurr(
				$record->toArray());
			}
			$cache->Save($weekrecurr,'weekrecurr');
		}else{
			$weekrecurr = $cache->Fetch('weekrecurr');
		}

		$cache = null;
		return $weekrecurr;
	}
	
	
	public function getWeekDayIdByCode(Application_Model_WeekRecurr $week)
	{
		$WeekRecurr = array();
		$WeekRecurr = $this->fetchAll();
		foreach($WeekRecurr as $weekobj){
			if(strtolower($weekobj->getCode()) == strtolower($week->getcode())){
				return $weekobj;
			}
		}
	}
}



