<?php

class Admin_Form_AddSponsor extends Zend_Form
{

    public function init()
    {
    	
    	$compName = $this->createElement('text','companyName');
    	$compName->removeDecorator('Label')
    		 	 ->removeDecorator('HtmlTag')
    			   ->setAttrib('maxlength', '100')
        		   ->setAttrib('class','inp1 required')
        		   ->addFilters(array('StringTrim'))
        		   ->addValidator('StringLength', false,array(0,100))
        		   ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter Company Name.'))))
        		   ->setValue('')
        		   ->setRequired(true);
        		  
		$compContact = $this->createElement('text','contactPerson');
		$compContact->removeDecorator('Label')
				  ->setAttrib('maxlength', '100')
    			  ->setAttrib('class','inp1 required')
        		  ->removeDecorator('HtmlTag')
        		  ->addFilters(array('StringTrim'))
        		  ->setValue('')
        		  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Contact Person.'))))
        		  ->setRequired(true);
        		  
		$billingAddress = $this->createElement('textarea','billingAddress');
		$billingAddress->removeDecorator('Label')
		 				->removeDecorator('HtmlTag')
					  ->setAttrib('maxlength', '1000')
                	  ->setValue('')              
                	  ->setAttrib('cols', '20')
			          ->setAttrib('rows', '3')
			          ->addFilters(array('StringTrim'))
			          ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Billing Address.')),
			           			array('StringLength', false,array(1,1000,'messages' => array(
              					Zend_Validate_StringLength::TOO_LONG => 'Description is too long(>1000).'
              				)))))
			          ->setRequired(true);
        		  
		$phno = $this->createElement('text','phNo');
		$phno->removeDecorator('Label')
			 ->removeDecorator('HtmlTag')                  
             ->setAttrib('class','inp1')              
             ->setAttrib('maxlength', '15')
             ->addFilters(array('StringTrim'))
             ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Phone Number.'))))
             ->setValue('')              
             ->setRequired(true);

             
        $email = $this->createElement('text','sponsorEmail');
		$email->removeDecorator('Label')
			  ->removeDecorator('HtmlTag')        			     
        	  ->setAttrib('maxlength', '255')
        	  ->setAttrib('class','inp1')
              ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter your Email Address.')),
                		 				array('StringLength', false,array(5,255))))
              ->addValidator('EmailAddress',false,array('messages'=>array(Zend_Validate_EmailAddress::INVALID =>'Please enter a valid Host Name')))
			  ->addErrorMessage('Pleaes Enter Valid Email Address')
              ->addFilters(array('StringTrim'))
              ->setRequired(true); 
	        		  
	    $resFax = $this->createElement('text', 'sponsorFax');
        $resFax->removeDecorator('Label') 
         		->removeDecorator('HtmlTag')               
                ->setAttrib('class','inp1')              
                ->setAttrib('maxlength', '15')
                ->addFilters(array('StringTrim'))
                ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Fax Number.'))))
                ->setValue('')              
                ->setRequired(false);
    		  
    	
       $edit = $this->createElement('button','Submit');
       $edit->removeDecorator('Label')
        		   ->removeDecorator('DtDdWrapper')
        		   ->setValue('Search')           		          		        		
        		   ->setAttrib('class','submitBtn')
                   ->setIgnore(true);
    	
    	                   
		$this->addElements( array ($compName,
								   $compContact,
								   $billingAddress,
								   $phno,
								   $email,
								   $resFax,
								   $edit
								   ));                           	        
    }


}

