<?php

class Admin_Form_RewardsRestSearch extends Zend_Form
{

    public function init()
    {
    	/* populating rewards restaurant */
    	$resMapper = new ManageRestaurant_Model_RestaurantDataMapper();
    	$resResult = $resMapper->GetRewardsRestaurants();
    	$resArr = array();
    	$resArr[] = array('key'=>'All','value'=>'All Restaurants');
    	foreach($resResult as $val){
    		$resArr[] = array('key'=>$val->resid,'value'=>$val->resrestaurant_name);
    	}
    	
    	/* Populating State Base Data */
    	$regionMapper = new Application_Model_RegionDataMapper();
    	$regionResults   = $regionMapper->fetchAll();
    	$regionList = array();
    	$regionList[] = array('key'=>'','value'=>'Select Region');
    	foreach($regionResults as $result){
    		$regionList[] = array('key'=>$result->getId(),'value'=>$result->getDescription());
    	}
        
        $resName = $this->createElement('select','resname');
    	$resName->removeDecorator('Label')
    			  ->setAttrib('class','inp1 form')
    			  ->addMultiOptions($resArr)
        		  ->removeDecorator('HtmlTag')
        		  ->addFilters(array('StringTrim'))
        		  ->setValue('');
              
       	 $region = $this->createElement('select', 'region');
         $region->removeDecorator('Label')
         		 ->removeDecorator('HtmlTag') 
         		 ->setAttrib('class','sel1 form') 
         		 ->addMultiOptions($regionList)
         		 ->setRequired(false);
              
        $city = $this->createElement('select', 'city');
        $city->removeDecorator('Label')
        	 ->removeDecorator('HtmlTag') 
        	 ->setAttrib('class', 'sel1 form') 
        	 ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select City.'))))
        	 ->setRegisterInArrayValidator(false)
             ->setRequired(false);
             
        $startDate = $this->createElement('text','startDate');
		$startDate->removeDecorator('Label')
					  ->removeDecorator('HtmlTag')
					  ->setAttrib('class','inp1 datepicker form')
					  ->setAttrib('readonly','readonly')
					  ->addFilters(array('StringTrim'))
					  ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select StartDate'))))
					  ->setRequired(false);
					  
		$endDate = $this->createElement('text','endDate');
		$endDate->removeDecorator('Label')
					->removeDecorator('HtmlTag')
					->setAttrib('class','inp1 datepicker2 form')
					->setAttrib('readonly','readonly')
					->addFilters(array('StringTrim'))
					->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select EndDate.'))))
					->setRequired(false);
        	       
		 $Search = $this->createElement('submit','search');
         $Search->removeDecorator('Label')
        		   ->removeDecorator('DtDdWrapper')
        		   ->setValue('Search')           		          		        		
        		   ->setAttrib('class','submitBtn')
                   ->setIgnore(true);
                   
		$this->addElements( array ($resName,
		                           $region,
								   $city,
								   $startDate,
								   $endDate,
								   $Search));                           	        
    }
}