<?php
class Administrator_Form_AddCompany extends Zend_Form
{
    public function init()
    {
    	$this->setAttrib('enctype', 'multipart/form-data');
    	$companytypeMapper = new Administrator_Model_CompanyTypeMapper();
    	$companytypeList = $companytypeMapper->fetchAll();
    	
 		$companyname = $this->createElement('text','companyname');
    	$companyname->removeDecorator('Label')
    			    ->setAttrib('class','inp1')
        		    ->removeDecorator('HtmlTag')
        		    ->setAttrib('maxlength', '50')
        		    ->addFilters(array('StringTrim'))
        		    ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter company name.'))))
        		    ->setRequired(true);
        
        $priceperRest = $this->createElement('text', 'priceperrestaurant');
        $priceperRest->removeDecorator('Label')
                     ->setAttrib('class', 'inp1')
                     ->removeDecorator('HtmlTag')
                     ->setAttrib('maxlength', '50')
        		    ->addFilters(array('StringTrim'))
        		    ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter price.'))))
        		    ->setRequired(true);
        		    
		$comdescription = $this->createElement('textarea', 'comdescription');
		$comdescription->removeDecorator('Label')
		               ->removeDecorator('HtmlTag')                	   
                	   ->setAttrib('maxlength', '5000')
                	   ->setAttrib('cols', '40')
			           ->setAttrib('rows', '4')
			           ->setAttrib('class','inp1')
              		   ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter company description.'))))
              		   ->setRequired(false);

        $phone = $this->createElement('text', 'phone');
        $phone->removeDecorator('Label')
         		  ->removeDecorator('HtmlTag')                  
                  ->setAttrib('class','inp1')              
                  ->setAttrib('maxlength', '15')
                  ->addFilters(array('StringTrim'))
                  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter phone number.'))))
                  ->setRequired(true);  

		$email =  $this->createElement('text', 'email');
        $email->removeDecorator('Label')
        	  ->removeDecorator('HtmlTag')        			     
              ->setAttrib('maxlength', '255')
        	  ->setAttrib('class','inp1')
        	  ->addValidator('EmailAddress',false,array('messages'=>array(Zend_Validate_EmailAddress::INVALID =>'Please enter a valid Host Name')))
				 ->addErrorMessage('Pleaes Enter Valid Email Address')
                ->addFilters(array('StringTrim'))
			  ->setRequired(true);
			  
		$address = $this->createElement('textarea','address');
        $address->removeDecorator('Label')
        	    ->removeDecorator('HtmlTag')
        	    ->setAttrib('maxlength', '510')
        	    ->setAttrib('cols', '40')
			    ->setAttrib('rows', '4')
        	    ->setAttrib('class','inp1')
        	    ->addFilters(array('StringTrim'))
        	    ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter company address.'))))
        	    ->setRequired(true);
        	   
       	$website = $this->createElement('text', 'website');
        $website->removeDecorator('Label')
        		->removeDecorator('HtmlTag')
        		->setAttrib('class','inp1')
        		->setAttrib('maxlength', '30')
        		->addValidators(array(array('StringLength', false,array(0,30))))
        		->setValue('')
                ->setRequired(false); 

		$logouturl = $this->createElement('text', 'logouturl');
        $logouturl->removeDecorator('Label')
        		  ->removeDecorator('HtmlTag')
        		  ->setAttrib('class','inp1')
        		  ->setAttrib('maxlength', '200')
        		  ->addValidators(array(array('StringLength', false,array(0,200))))
        		  ->setValue('')
                  ->setRequired(false);
                                   
		$partnerurl = $this->createElement('text', 'partnerurl');
        $partnerurl->removeDecorator('Label')
        		  ->removeDecorator('HtmlTag')
        		  ->setAttrib('class','inp1')
        		  ->setAttrib('maxlength', '200')
        		  ->addValidators(array(array('StringLength', false,array(0,200))))
        		  ->setValue('')
                  ->setRequired(false);                  
        	   
       	$companyID = $this->createElement('hidden','companyID');
       	$companyID->removeDecorator('DtDdWrapper')
			  	 ->removeDecorator('Label')
			  	 ->removeDecorator('HtmlTag');

		$companyLogo = $this->createElement('file','companyLogo');
		$companyLogo->removeDecorator('Label')
				->removeDecorator('HtmlTag')
				->setAttrib('class','inp2 form') 
				->setAttrib('style', 'height:32px !important;padding:0;')				
			    ->setRequired(false)
			    ->setValue('')     
			    ->addValidator('FilesSize', false, array('min' => '1B', 'max' => '100kB'))
			    ->addValidator('Extension', false,array('jpg,png','messages' => 'Please select jpg or png images only'));

		$companytypes = $this->createElement('select','companytype');
		$companytypes->removeDecorator('Label')
        			    ->removeDecorator('HtmlTag')
        			    ->setAttrib('maxlength', '100')
						->setAttrib('placeholder', 'Company Type')
        			    ->setAttrib('class','inp2 form required') 
        			    ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select company type.')))) 
        			    ->addMultiOptions($companytypeList)        			    
        			    ->setValue('')
        			    ->setRequired(true);			    
			    			  	 
       $this->addElements(array(
       						$companyname,
       						$phone,
       						$email,
       						$address,
       						$website,
       						$companyID,
       						$logouturl,
       						$companyLogo,
       						$partnerurl,
       						$companytypes,
                            $priceperRest
       					));
    }
}