<?php

class Administrator_Form_AddPricePlan extends Zend_Form
{

    public function init()
    {
    	$this->setAttrib('enctype', 'multipart/form-data');

    	$audMapper = new Application_Model_IntendedAudienceDataMapper();
    	$audience = $audMapper->fetchAll();
    	$audienceList = array();
    	foreach($audience as $aud){
    		$audienceList[] = array('key'=>trim($aud->getCode()),'value'=>"  ".  $aud->getDescription());
    	}
    	
    	$typeMapper = new Application_Model_SponsorTargetPagesDataMapper();
    	$types = $typeMapper->fetchAll();
    	$typeList = array();
    	//$typeList[] = array('key'=>'','value'=>'Select Type');
    	foreach($types as $type){
    		$typeList[] = array('key'=>trim($type->getCode()),'value'=>"  ". $type->getDescription());
    	}
    	
    	$playtype = new Zend_Form_Element_Radio('plantype');
		$playtype->removeDecorator('Label')
			   	 ->removeDecorator('HtmlTag')
 		   		 ->setMultiOptions($typeList)
			   	 ->setValue('NOT')
			   	 ->setSeparator(' ')
			   	 ->setRequired(true);
			   		
//    	$playtype = $this->createElement('select','plantype');
//    	$playtype->removeDecorator('Label')
//    		 	 ->removeDecorator('HtmlTag')
//    			   ->setAttrib('class','inp1 required')
//        		   ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select Plan Type.'))))
//        		   ->addMultiOptions($typeList)
//        		   ->setRegisterInArrayValidator(false)
//        		   ->setRequired(true);
        		  
		$planName = $this->createElement('text','planName');
		$planName->removeDecorator('Label')
				 ->setAttrib('maxlength', '100')
    			 ->setAttrib('class','inp1 required')
        		 ->removeDecorator('HtmlTag')
        		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter Plan Name.'))))
        		 ->addFilters(array('StringTrim'))
        		 ->setRequired(true);
        		  
		$noofemails = $this->createElement('text','noofemails');
		$noofemails->removeDecorator('Label')
				   ->setAttrib('maxlength', '10')
	    		   ->setAttrib('class','inp1 required')
	        	   ->removeDecorator('HtmlTag')
	        	   ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter No of Emails.'))))
	        	   ->addFilters(array('StringTrim'))
	        	   ->setRequired(true);
        
	    $intendedAud = new Zend_Form_Element_Radio('intendedAud');
		$intendedAud->removeDecorator('Label')
			   		->removeDecorator('HtmlTag')
			   		->setMultiOptions($audienceList)
			   		->setValue('CUS')
			   		->setSeparator(' ')
			   		->setRequired(true);
			   		  	 
//		$intendedAud = $this->createElement('select','intendedAud');
//		$intendedAud->removeDecorator('Label')
//					->removeDecorator('HtmlTag')                  
//		            ->setAttrib('class','inp1')              
//		            ->addFilters(array('StringTrim'))
//		            ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Select Intended Audience.'))))
//		            ->addMultiOptions($audienceList)  
//		            ->setRegisterInArrayValidator(false)            
//		            ->setRequired(true);

             
        $amount = $this->createElement('text','amount');
		$amount->removeDecorator('Label')
			   ->removeDecorator('HtmlTag')        			     
        	   ->setAttrib('class','inp1')
               ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter the Amount.'))))
               ->addFilters(array('StringTrim'))
               ->setRequired(true); 
	        		  
       $edit = $this->createElement('button','Submit');
       $edit->removeDecorator('Label')
        		   ->removeDecorator('DtDdWrapper')
        		   ->setValue('Search')           		          		        		
        		   ->setAttrib('class','submitBtn')
                   ->setIgnore(true);
    	
    	                   
		$this->addElements( array ($playtype,
								   $planName,
								   $noofemails,
								   $intendedAud,
								   $amount,
								   $edit
								   ));                           	        
    }


}

