<?php

class Administrator_Form_AddRestaurantOwner extends Zend_Form
{

    public function init()
    {
    	$stateMapper  = new Application_Model_StateDataMapper();
        $states = $stateMapper->fetchAll();
        $stateList = array(); 
        $stateList[] = array('key'=>'','value'=>'Select Country');   	   
        foreach($states as $state){
    		$stateList[] = array('key'=>$state->getId(),'value'=>$state->getDescription());
        }
        $stateList[] = array('key'=>'noState','value'=>"Can't Find Your State");
        
        $passwordConfirm = new Uss_Validate_PasswordConfirmation();
    	$confirmEmail = new Uss_Validate_EMailConfirmation();
    	
    	$emailAddress =  $this->createElement('text', 'emailAddress');
        $emailAddress->removeDecorator('Label')
        			->removeDecorator('HtmlTag')        		
        			->setAttrib('class','inp1')
        			->setAttrib('maxlength', '40')
                	->addValidators(array($confirmEmail,
                						  array('NotEmpty', true, array('messages' => 'Please enter your EmailAddress.'))
                				))
                	->addValidator('EmailAddress',false,array('messages'=>array(Zend_Validate_EmailAddress::INVALID =>'Please enter a valid Host Name')))
					 ->addErrorMessage('Pleaes Enter Valid Email Address')
                	->addFilters(array('StringTrim'))
                	->setValue('')
                	->addFilter('StringToLower')
                	->setRequired(true);
                	
	   $confirmEmailAdd = $this->createElement('text', 'confirmEmailAddress');
       $confirmEmailAdd->removeDecorator('Label')
        			->removeDecorator('HtmlTag')        		
        			->setAttrib('class','inp1')
        			->setAttrib('maxlength', '40')
                	->addValidators(array($confirmEmail,
                						  array('NotEmpty', true, array('messages' => 'Please confirm your EmailAddress.'))
                				))              
                	->setValue('')
                	->addFilters(array('StringTrim'))
                	->addFilter('StringToLower')
                	->setRequired(true);                	
                
		$password =  $this->createElement('password','password');
        $password->removeDecorator('Label')
         		->removeDecorator('HtmlTag')        	
        		->setAttrib('class','inp1')
        		->setAttrib('maxlength', '20')
                ->addValidators(array($passwordConfirm,
                				 array('NotEmpty', true, array('messages' => 'Please enter your Password.')),
                				 array('StringLength', false, array(6, 20,'messages' => array(
                    		Zend_Validate_StringLength::TOO_SHORT => 'Your password is too short(>6).',
                    Zend_Validate_StringLength::TOO_LONG => 'Your password is too long(<20).'))
            		)))
                ->setRequired(true)
                ->setValue('');
        
        $confirmPassword =  $this->createElement('password','password_confirm');
        $confirmPassword->removeDecorator('Label')
        				->removeDecorator('HtmlTag')        				
        				->setAttrib('class','inp1')
        				->setAttrib('maxlength', '20')
                    	->addValidators(array($passwordConfirm,
                    					  array('NotEmpty', true, array('messages' => 'Please Confirm your password.'))
                    					))
                    	->setRequired(true)
                    	->setValue(''); 

		$firstName =  $this->createElement('text', 'firstName');
        $firstName->removeDecorator('Label')
        		->removeDecorator('HtmlTag')
        		->setAttrib('class','inp1')
        		->setAttrib('maxlength', '30')
        		->addFilters(array('StringTrim'))
                ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter FirstName.')),
                					  array('StringLength', false,array(0,30)),array('Alnum')))                					                 					 
                ->setValue('')
                ->setRequired(true);
        
        $lastName = $this->createElement('text', 'lastName');
        $lastName->removeDecorator('Label')
        		 ->removeDecorator('HtmlTag')
        		 ->setAttrib('maxlength', '30')
        		 ->addFilters(array('StringTrim'))
        		 ->addValidators(array(array('StringLength', false,array(0,30)),array('Alnum')))
        		 ->setAttrib('class','inp1')
        		 ->setValue('')
                 ->setRequired(false);                     	
                    	
        $phone = $this->createElement('text', 'phone');
        $phone->removeDecorator('Label')
        	  ->removeDecorator('HtmlTag')
              ->setAttrib('class','inp1')              
              ->setAttrib('maxlength', '15')
              ->addFilters(array('StringTrim'))
              ->addValidators(array
                   					(array('NotEmpty', true, array('messages' => 'Please enter Your Phone Number.'))
                   				 ))
              ->setValue('')              
              ->setRequired(true);
              
       $rastaurantname = $this->createElement('text', 'restaurantName'); 
       $rastaurantname ->removeDecorator('Label')
       					->removeDecorator('HtmlTag')
       					->setAttrib('class','inp1')
        			  	->setAttrib('maxlength', '225')
        			  	->addFilters(array('StringTrim'))
        			  	->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter RestaurantName.'))))
        			  	->setvalue('')
        			  	->setrequired(true);

        $region = $this->createElement('select','region');
        $region->removeDecorator('Label')
        	  ->removeDecorator('HtmlTag') 
        	  ->setAttrib('class', 'sel1')       	   
              ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select Region.'))))
        	  ->setRegisterInArrayValidator(false)
              ->setRequired(true);
              
        $state = $this->createElement('select','state');
        $state->removeDecorator('Label')
        	  ->removeDecorator('HtmlTag') 
        	  ->setAttrib('class', 'sel1')       	   
              ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select State.'))))
        	  ->addMultiOptions($stateList)
              ->setRequired(true);
        
        $city = $this->createElement('select', 'city');
        $city->removeDecorator('Label')
        	 ->removeDecorator('HtmlTag') 
        	 ->setAttrib('class', 'sel1') 
        	 ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select City.'))))
        	 ->setRegisterInArrayValidator(false)
             ->setRequired(true);
		
        $description = $this->createElement('textarea', 'description');
		$description->removeDecorator('Label')
		               ->removeDecorator('HtmlTag')                	   
                	   ->setAttrib('maxlength', '5000')
                	   ->setAttrib('cols', '40')
			           ->setAttrib('rows', '4')
			           ->setAttrib('class','inp1')              
                	   ->setValue('')              
                	   ->addValidators(array(array('StringLength', false,array(1,5000,'messages' => array(
              					Zend_Validate_StringLength::TOO_LONG => 'Description is too long(>5000).'
              				)))))
			           ->setRequired(false);
			           
		      
         $website = $this->createElement('text', 'website');
         $website->removeDecorator('Label')
        		 ->removeDecorator('HtmlTag')
        		 ->setAttrib('class','inp1')
        		 ->setAttrib('maxlength', '30')
        		 ->addValidators(array(array('StringLength', false,array(0,30))))
        		 ->setValue('')
                 ->setRequired(false); 
			           
        $register = $this->createElement('submit','register');
        $register->setLabel("Register")
        		 ->removeDecorator('DtDdWrapper')        		
        		 ->setAttrib('class','submitBtn')
                 ->setIgnore(true);
                 
        $reset = $this->createElement('reset','reset');
        $reset->removeDecorator('Label')
         	  ->removeDecorator('DtDdWrapper')
        	  ->setLabel("Reset")
        	  ->setAttrib('class','submitBtn')
              ->setIgnore(true);
        			 		  
        $this->addElements( array ($firstName,
        							$lastName,
	        						$emailAddress,
	        						$confirmEmailAdd,
	        						$password,
	        						$confirmPassword,
	        						$rastaurantname,
	        						$state,
	        						$city,
	        						$region,
	        						$description,
	                           	 	$phone,
	                           	 	$website,
	                           	 	$register,
	                            	$reset
                            	));
    }


}

