<?php

class Administrator_Form_AddState extends Zend_Form
{

    public function init()
    {
    	/* Populating City Base Data */
    	
    	$timeZoneMapper  = new Application_Model_TimeZoneDataMapper();
    	$timeZones = $timeZoneMapper->fetchAll();
    	$timeZoneList = array();
    	$timeZoneList[] = array('key'=>'','value'=>'Select TimeZone');    	   
    	foreach($timeZones as $timeZone){
    		$timeZoneList[] = array('key'=>$timeZone->getId(),'value'=>$timeZone->getDescription());
    	} 
    	
    	$code = $this->createElement('text','code');
    	$code->removeDecorator('Label')
    		 ->removeDecorator('HtmlTag')
    			   ->setAttrib('maxlength', '10')
        		   ->setAttrib('class','inp1 required addcode')
        		   ->addFilters(array('StringTrim'))
        		   ->addValidator('StringLength', false,array(0,30))
        		   ->setValue('')
        		   ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter country code.'))))
        		   ->setRequired(true);
        		  
		$desc = $this->createElement('text','desc');
		$desc->removeDecorator('Label')
				  ->setAttrib('maxlength', '200')
    			  ->setAttrib('class','inp1 required adddesc')
        		  ->removeDecorator('HtmlTag')
        		  ->addFilters(array('StringTrim'))
        		  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter country description.'))))
        		  ->setValue('');

        $currency = $this->createElement('text','currency');
		$currency->removeDecorator('Label')
				  ->setAttrib('maxlength', '15')
    			  ->setAttrib('class','inp1 required addcurrency')
        		  ->removeDecorator('HtmlTag')
        		  ->addFilters(array('StringTrim'))
        		  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter country currency.'))))
        		  ->setValue('');

        $dialcode = $this->createElement('text','dialcode');
		$dialcode->removeDecorator('Label')
				  ->setAttrib('maxlength', '4')
    			  ->setAttrib('class','inp1 required adddialcode')
    			  ->setAttrib('style','width:140px;')
        		  ->removeDecorator('HtmlTag')
        		  ->addFilters(array('StringTrim'))
        		  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter country phonecode.'))))
        		  ->setValue('');

		$countryflag = $this->createElement('file','countryflag');
		$countryflag->removeDecorator('Label')
				->removeDecorator('HtmlTag')
				->setAttrib('class','inp1 required addflag') 
			    ->addValidator('FilesSize', false, array('min' => '1kB', 'max' => '100kB'))
			    ->addValidator('Extension', false,array('jpg,png','messages' => 'Please select jpg or png images only'));        		  
        		  
		$Id = $this->createElement('hidden','stateid');
    	$Id->removeDecorator('HtmlTag')
    		  ->removeDecorator('Label');
    		  
    	
       $edit = $this->createElement('button','Submit');
       $edit->removeDecorator('Label')
        		   ->removeDecorator('DtDdWrapper')
        		   ->setValue('Search')           		          		        		
        		   ->setAttrib('class','submitBtn')
                   ->setIgnore(true);
    	
    	$timezne = $this->createElement('select','timezone');
        $timezne->removeDecorator('Label') 
         				->removeDecorator('HtmlTag') 
         				->setAttrib('class','inp1 required timezone') 
						->setAttrib('placeholder', 'TimeZone')
         				->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select TimeZone.'))))
               			->addMultiOptions($timeZoneList)
               			->setRequired(true);
               			                   
		$this->addElements( array ($code,
								   $desc,
								   $edit,
								   $currency,
								   $countryflag,
								   $dialcode,
								   $timezne,
								   $Id));                           	        
    }


}

