<?php

class Administrator_Form_CusBookingReport extends Zend_Form
{

    public function init()
    {
        
        /* Populating City Base Data */
    	$cityMapper = new Application_Model_CityDataMapper();
    	$cityResults   = $cityMapper->fetchAll();
    	$cityList = array();
    	$cityList[] = array('key'=>'','value'=>'Select City');
    	foreach($cityResults as $result){
    		$cityList[] = array('key'=>$result->getId(),'value'=>$result->getDescription());
    	}
        
        
        $resName = $this->createElement('text','resname');
    	$resName->removeDecorator('Label')
    			  ->setAttrib('class','inp1 form input_form')
    			  ->setAttrib('title','Restaurant Name')
    			  ->setAttrib('placeholder','Restaurant Name')
        		  ->removeDecorator('HtmlTag')
        		  ->addFilters(array('StringTrim'))
        		  ->setValue('');
        
        
         $city = $this->createElement('select', 'city');
         $city->removeDecorator('Label')
         		 ->removeDecorator('HtmlTag') 
         		 ->setAttrib('class','sel1 form input_form')
         		 ->setAttrib('title','City')
         		 ->addMultiOptions($cityList)
         		 ->setRequired(false);
              
        $bookId = $this->createElement('text','bookid');
    	$bookId->removeDecorator('Label')
    			  ->setAttrib('class','inp1 form input_form')
    			  ->setAttrib('title','Booking Id')
    			  ->setAttrib('placeholder','Booking Id')
        		  ->removeDecorator('HtmlTag')
        		  ->addValidator('Digits',new Zend_Validate_Digits(),array('messages' => 'Please enter valid booking id'))
        		  ->setValue('');
        
        $cusFirstName = $this->createElement('text','cusfirstname');
    	$cusFirstName->removeDecorator('Label')
    			  ->setAttrib('class','inp1 form input_form')
    			  ->setAttrib('title','First Name')
    			  ->setAttrib('placeholder','First Name')
        		  ->removeDecorator('HtmlTag')
        		  ->addFilters(array('StringTrim'))
        		  ->setValue('');
        
        $cusLastName = $this->createElement('text','cuslastname');
    	$cusLastName->removeDecorator('Label')
    			  ->setAttrib('class','inp1 form input_form')
    			  ->setAttrib('title','Last Name')
    			  ->setAttrib('placeholder','Last Name')
        		  ->removeDecorator('HtmlTag')
        		  ->addFilters(array('StringTrim'))
        		  ->setValue('');
             
        $startDate = $this->createElement('text','startDate');
		$startDate->removeDecorator('Label')
					  ->removeDecorator('HtmlTag')
					  ->setAttrib('class','inp1 datepicker form input_form')
					  ->setAttrib('title','Start Date')
					  ->setAttrib('placeholder','Start Date')
					  ->setAttrib('readonly','readonly')
					  ->addFilters(array('StringTrim'))
					  ->addValidators(array
        		                 (array('NotEmpty', true, array('messages' => 'Please select StartDate'))))
					  ->setRequired(false);
					  
		$endDate = $this->createElement('text','endDate');
		$endDate->removeDecorator('Label')
					->removeDecorator('HtmlTag')
					->setAttrib('class','inp1 datepicker2 form input_form')
					->setAttrib('title','End Date')
				    ->setAttrib('placeholder','End Date')
					->setAttrib('readonly','readonly')
					->addFilters(array('StringTrim'))
					->addValidators(array
        		(array('NotEmpty', true, array('messages' => 'Please select EndDate.'))))
					->setRequired(false);
        	       
		 $Search = $this->createElement('submit','search');
                 $Search->removeDecorator('Label')
        		   ->removeDecorator('DtDdWrapper')
        		   ->setValue('Search')           		          		        		
        		   ->setAttrib('class','submitBtn')
                           ->setIgnore(true);
                   
		$this->addElements( array ($resName, $city, $bookId, $cusFirstName, $cusLastName,
		                           
					$startDate,
					$endDate,
                                        $Search));                           	        
    }


}