<?php

class Administrator_Form_EditCampaign extends Zend_Form
{

    public function init()
    {
    	
    	$stateMapper  = new Application_Model_StateDataMapper();
    	$states = $stateMapper->fetchAll();
    	$stateList = array();  
    	$stateList[] = array('key'=>'','value'=>'Select State');  	   
    	foreach($states as $state){
    		$stateList[] = array('key'=>$state->getId(),'value'=>$state->getDescription());
    	}
    	$timeMapper  = new Application_Model_SponsorTimeSelectionDataMapper();
    	$times = $timeMapper->fetchAll();
    	$tiemList = array();  
    	$tiemList[] = array('key'=>'','value'=>'Select Time');  	   
    	foreach($times as $time){
    		$tiemList[] = array('key'=>$time->getCode(),'value'=>$time->getDescription());
    	}
    	$campMapper = new Administrator_Model_CampaignDataMapper();
    	$campaign = $campMapper->GetCampaignDetails();
    	$campaignList = array();
    	$campaignList[] = array('key'=>'','value'=>'Select Campaign');
    	foreach($campaign as $camp){
    		$campaignList[] = array('key'=>$camp->scid,'value'=>$camp->scad_name);
    	} 
    	
    $audMapper = new Application_Model_IntendedAudienceDataMapper();
    	$audience = $audMapper->fetchAll();
    	$audienceList = array();
    	foreach($audience as $aud){
    		$audienceList[] = array('key'=>trim($aud->getCode()),'value'=>"  ".  $aud->getDescription());
    	}
$typeMapper = new Application_Model_SponsorTargetPagesDataMapper();
    	$types = $typeMapper->fetchAll();
    	$typeList = array();
    	//$typeList[] = array('key'=>'','value'=>'Select Type');
    	foreach($types as $type){
    		$typeList[] = array('key'=>trim($type->getCode()),'value'=>"  ". $type->getDescription());
    	}
    	$camName = $this->createElement('hidden','campId');
    	$camName->removeDecorator('DtDdWrapper')
			  	->removeDecorator('Label')
			  	->removeDecorator('HtmlTag');
    	
		$price = $this->createElement('hidden','priceId');
    	$price->removeDecorator('DtDdWrapper')
			  	->removeDecorator('Label')
			  	->removeDecorator('HtmlTag');
			  	
    	$campaingSponsor = $this->createElement('text','campSponsor');
		$campaingSponsor->removeDecorator('Label')
        			    ->removeDecorator('HtmlTag')
        			    ->setAttrib('maxlength', '100')
        			    ->setAttrib('class','inp1 required')
        			    ->setAttrib('readonly','readonly')
        			    ->setAttrib('style','background:#B5B0B1')
	        		   	->addFilters(array('StringTrim'))
	        		   	->addValidator('StringLength', false,array(0,100))
	        		   	->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter Campaign Name.'))))
	        		   	->setValue('')
	        		   	->setRequired(false);
        			    
    	$compName = $this->createElement('text','campaignName');
    	$compName->removeDecorator('Label')
    		 	 ->removeDecorator('HtmlTag')
    			   ->setAttrib('maxlength', '100')
        		   ->setAttrib('class','sel1 required')
			   ->setAttrib('readonly','readonly')
        		   ->addFilters(array('StringTrim'))
//        		   ->addMultiOptions($campaignList)
//        		   ->addValidator('StringLength', false,array(0,100))
//        		   ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter Campaign Name.'))))
        		   ->setValue('')
        		   ->setRequired(true);
        		  
        $compstatus = $this->createElement('select','campaignStatus');
    	$compstatus->removeDecorator('Label')
    		 	   ->removeDecorator('HtmlTag')
    			   ->setAttrib('maxlength', '100')
        		   ->setAttrib('class','sel1 required')
        		   ->addFilters(array('StringTrim'))
        		   ->addMultiOptions(array(array('key'=>'1','value'=>'Active'),
        		   							array('key'=>'0','value'=>'InActive')))
        		   ->setValue('')
        		   ->setRequired(false);
        		   
		$billingAddress = $this->createElement('textarea','campaignDesc');
		$billingAddress->removeDecorator('Label')
		 				->removeDecorator('HtmlTag')
					  ->setValue('')              
                	  ->setAttrib('cols', '20')
			          ->setAttrib('rows', '3')
			          ->addFilters(array('StringTrim'))
			          ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Campaign Description.'))))
			          ->setRequired(true);
        
		$campStartDate = $this->createElement('text','campaignStartDate');
		$campStartDate->removeDecorator('Label')
					  ->removeDecorator('HtmlTag')
					  ->setAttrib('class','inp1 datepicker')
					  ->setAttrib('readonly','readonly')
					  ->addFilters(array('StringTrim'))
					  ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select StartDate'))))
					  ->setRequired(true);
					  
		$campEndDate = $this->createElement('text','campaignEndDate');
		$campEndDate->removeDecorator('Label')
					->removeDecorator('HtmlTag')
					->setAttrib('class','inp1 datepicker2')
					->setAttrib('readonly','readonly')
					->addFilters(array('StringTrim'))
					->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select EndDate.'))))
					->setRequired(true);
					
		$campaignWebsite = $this->createElement('text', 'campaignWebsite');
        $campaignWebsite->removeDecorator('Label') 
                   		->removeDecorator('HtmlTag')               	
	        	        ->setAttrib('class','inp1')              
	                    ->setAttrib('maxlength', '255')
	                    ->addFilters(array('StringTrim'))
//	                    ->addValidator('regex', false, '/^[a-zA-Z0-9._-]+\.[a-zA-Z]{2,6}$/')
	                    //->addValidators(new Zend_Validate_Callback(array(Zend_Uri::check())))
	                    ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Link.'))))
	                    ->setValue('')              
	                    ->setRequired(false);
                	

//        $campaignImage = $this->createElement('file','campaignImage');
//		$campaignImage->removeDecorator('Label')
//		     		  ->removeDecorator('HtmlTag')
//				      ->setAttrib('class','inp1')			     
//				      ->setRequired(false)
//				      ->addValidator('FilesSize', false, array('min' => '1kB', 'max' => '200kB'))
//				      ->addValidator('Extension', false, 'jpg,png,gif,jpeg');
				      
				      
		$campaingPricePlan = $this->createElement('text','campPricePlan');
		$campaingPricePlan->removeDecorator('Label')
        			    ->removeDecorator('HtmlTag')
        			    ->setAttrib('maxlength', '100')
        			    ->setAttrib('readonly','readonly')
        			    ->setAttrib('style','background:#B5B0B1');
        			    
//$noofemails = $this->createElement('text','noofemails');
//		$noofemails->removeDecorator('Label')
//				   ->setAttrib('maxlength', '10')
//	    		   ->setAttrib('class','inp1 required')
//	        	   ->removeDecorator('HtmlTag')
//	        	   ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter No of Emails.'))))
//	        	   ->addFilters(array('StringTrim'))
//	        	   ->setRequired(true);
		$intendedAud = new Zend_Form_Element_Radio('campaignAudience');
		$intendedAud->removeDecorator('Label')
			   		->removeDecorator('HtmlTag')
			   		->setMultiOptions($audienceList)
			   		->setValue('CUS')
			   		->setSeparator(' ')
			   		->setRequired(true);
		$amount = $this->createElement('text','amount');
		$amount->removeDecorator('Label')
			   ->removeDecorator('HtmlTag')        			     
        	   ->setAttrib('class','inp1')
               ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter the Amount.'))))
               ->addFilters(array('StringTrim'))
               ->setRequired(false); 
        $camtime = $this->createElement('select','campaignTime');
        $camtime->removeDecorator('Label') 
         		  ->removeDecorator('HtmlTag')
         		  ->setAttrib('class','sel1 drpDown')
         		  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select Time.'))))       	   
               	  ->addMultiOptions($tiemList)
                  ->setRequired(true);
				      
			     
       $state = $this->createElement('select','state');
        $state->removeDecorator('Label') 
         		  ->removeDecorator('HtmlTag')
         		  ->setAttrib('class','sel1 drpDown')
         		  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select State.'))))       	   
               	  ->addMultiOptions($stateList)
                  ->setRequired(false);
       
        $checkbox = $this->createElement('checkbox','campaignDashboard');
       	$checkbox->setLabel('Dash Board')
			     ->removeDecorator('HtmlTag')
			     ->setUncheckedValue('')
			     ->setAttrib('disabled','disabled')
			     ->setCheckedValue('Dash Board')
			     ->addValidators(array(array('notEmpty', true, array('messages' => 'Please accept terms and condition.'))))
			     ->removeDecorator('DtDdWrapper')			       
			     ->setRequired(false);
			     
        $region = $this->createElement('select','region');
        $region->removeDecorator('Label') 
         		  ->removeDecorator('HtmlTag')
         		  ->setAttrib('class','sel1 drpDown')
         		  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select Region.'))))       	   
               	  ->setRegisterInArrayValidator(false)
         		  ->setRequired(false);           
                  
                  
        $city = $this->createElement('select', 'city');
        $city->removeDecorator('Label')
         		 ->removeDecorator('HtmlTag')
         		 ->setAttrib('class','sel1 drpDown')
         		 ->setRegisterInArrayValidator(false)
         		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select City.'))))       	     
                 ->setRequired(false);

                 
       	$campaignAudience = $this->createElement('text', 'campaignAudience');
        $campaignAudience->removeDecorator('Label') 
                   		 ->removeDecorator('HtmlTag')               	
	        	         ->setAttrib('class','inp1')    
	        	         ->setAttrib('style','background:#B5B0B1')          
	                     ->setAttrib('readonly', 'readonly')
	                     ->addFilters(array('StringTrim'))
	                     ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Audience.'))))
	                     ->setValue('')              
	                     ->setRequired(false);
	                    
	   	$campaignImage = $this->createElement('file','campImage');
		$campaignImage->removeDecorator('Label')
			      	  ->removeDecorator('HtmlTag')
			     	  ->setAttrib('class','inp1')			     
			      	  ->setRequired(false)
			     	  ->addValidator('FilesSize', false, array('min' => '1kB', 'max' => '100kB'))
			   	      ->addValidator('Extension', false, 'jpg,png,gif');
			      
	    $campaignTarget = $this->createElement('text', 'campaignTarget');
        $campaignTarget->removeDecorator('Label') 
                   		->removeDecorator('HtmlTag')               	
	        	        ->setAttrib('class','inp1')              
	                    ->setAttrib('readonly', 'readonly')
	                    ->setAttrib('style','background:#B5B0B1')
	                    ->addFilters(array('StringTrim'))
	                    ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Target.'))))
	                    ->setValue('')              
	                    ->setRequired(false);
	                    
	                    
	   $edit = $this->createElement('button','Submit');
       $edit->removeDecorator('Label')
           ->removeDecorator('DtDdWrapper')
           ->setValue('Search')           		          		        		
           ->setAttrib('class','submitBtn')
           ->setIgnore(true);
    	
    	                   
		$this->addElements( array ($campaingSponsor,
								   $compName,
								   $price,
								   $billingAddress,
								   $campStartDate,
								   $campEndDate,
								   $campaignWebsite,
								   $campaignImage,
								   $compstatus,
								   $campaingPricePlan,
								   $campaignAudience,
								   $campaignTarget,
								   $state,
								   $region,
								   $city,
								   $amount,
								   $camtime,
								   $camName,
								   $checkbox,
								    $edit
								   ));                           	        
    }


}

