<?php

class Administrator_Form_EditSponsor extends Zend_Form
{

    public function init()
    {
    	$sponsorMapper = new Administrator_Model_SponsorDataMapper();
    	$sponsors = $sponsorMapper->GetSponsors();
    	$sponsorList = array();
    	$sponsorList[] = array('key'=>'','value'=>'Select Sponsor');
    	foreach($sponsors as $comp){
    		$sponsorList[] = array('key'=>$comp->spoid,'value'=>$comp->spocompany_name);
    	}
    	
		$compContact = $this->createElement('text','contactPerson');
		$compContact->removeDecorator('Label')
				  ->setAttrib('maxlength', '100')
    			  ->setAttrib('class','inp1 required')
        		  ->removeDecorator('HtmlTag')
        		  ->addFilters(array('StringTrim'))
        		  ->setValue('')
        		  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Contact Person.'))))
        		  ->setRequired(true);
        		  
		$billingAddress = $this->createElement('textarea','billingAddress');
		$billingAddress->removeDecorator('Label')
		 				->removeDecorator('HtmlTag')
					  ->setAttrib('maxlength', '1000')
                	  ->setValue('')              
                	  ->setAttrib('cols', '20')
			          ->setAttrib('rows', '3')
			          ->addFilters(array('StringTrim'))
			          ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Billing Address.')),
			           			array('StringLength', false,array(1,1000,'messages' => array(
              					Zend_Validate_StringLength::TOO_LONG => 'Description is too long(>1000).'
              				)))))
			          ->setRequired(true);
        		  
		$phno = $this->createElement('text','phNo');
		$phno->removeDecorator('Label')
			 ->removeDecorator('HtmlTag')                  
             ->setAttrib('class','inp1')              
             ->setAttrib('maxlength', '15')
             ->addFilters(array('StringTrim'))
             ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Phone Number.'))))
             ->setValue('')              
             ->setRequired(true);

             
        $email = $this->createElement('text','sponsorEmail');
		$email->removeDecorator('Label')
			  ->removeDecorator('HtmlTag')        			     
        	  ->setAttrib('maxlength', '255')
        	  ->setAttrib('class','inp1')
              ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter your Email Address.')),
                		 				array('StringLength', false,array(5,255))))
              ->addValidator('EmailAddress',false,array('messages'=>array(Zend_Validate_EmailAddress::INVALID =>'Please enter a valid Host Name')))
			 ->addErrorMessage('Pleaes Enter Valid Email Address')
              ->addFilters(array('StringTrim'))
              ->setRequired(true); 
	        		  
	    $resFax = $this->createElement('text', 'sponsorFax');
        $resFax->removeDecorator('Label') 
         		->removeDecorator('HtmlTag')               
                ->setAttrib('class','inp1')              
                ->setAttrib('maxlength', '15')
                ->addFilters(array('StringTrim'))
                ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Fax Number.'))))
                ->setValue('')              
                ->setRequired(false);
    	
        $spoid = $this->createElement('hidden','campSponsor');
		$spoid->removeDecorator('DtDdWrapper')
		  	  ->removeDecorator('Label')
			  ->removeDecorator('HtmlTag');               
                
    	$campaingSponsor = $this->createElement('text','campaignSponsor');
		$campaingSponsor->removeDecorator('Label')
        			    ->removeDecorator('HtmlTag')
        			    ->setAttrib('maxlength', '100')
        			    ->setAttrib('class','sel1')
        			    ->setAttrib('readonly','readonly')
//        			    ->addMultiOptions($sponsorList)        			    
        			    ->setValue('')
        			    ->setRequired(true);
        			    
        			    
       $edit = $this->createElement('button','Submit');
       $edit->removeDecorator('Label')
        		   ->removeDecorator('DtDdWrapper')
        		   ->setValue('Search')           		          		        		
        		   ->setAttrib('class','submitBtn')
                   ->setIgnore(true);
    	
    	                   
		$this->addElements( array (
								   $compContact,
								   $billingAddress,
								   $phno,
								   $email,
								   $resFax,
								   $spoid,
								   $campaingSponsor,
								   $edit
								   ));                           	        
    }


}

