<?php
class Administrator_Form_EditState extends Zend_Form
{

    public function init()
    {
    	/* Populating City Base Data */
    	$timeZoneMapper  = new Application_Model_TimeZoneDataMapper();
    	$timeZones = $timeZoneMapper->fetchAll();
    	$timeZoneList = array();
    	$timeZoneList[] = array('key'=>'','value'=>'Select TimeZone');    	   
    	foreach($timeZones as $timeZone){
    		$timeZoneList[] = array('key'=>$timeZone->getId(),'value'=>$timeZone->getDescription());
    	}
    	
    	
    	$code = $this->createElement('text','editcode');
    	$code->removeDecorator('Label')
    			  ->setAttrib('class','inp1 required editcode')
    			  ->setAttrib('maxlength', '10')
        		  ->removeDecorator('HtmlTag')
        		  ->addFilters(array('StringTrim'))
        		  ->setValue('');
        		  
		$desc = $this->createElement('text','editdesc');
		$desc->removeDecorator('Label')
    			  ->setAttrib('class','inp1 required editdesc')
    			  ->setAttrib('maxlength', '200')
        		  ->removeDecorator('HtmlTag')
        		  ->addFilters(array('StringTrim'))
        		  ->setValue('');
        		  
        $currency = $this->createElement('text','editcurrency');
		$currency->removeDecorator('Label')
				  ->setAttrib('maxlength', '15')
    			  ->setAttrib('class','inp1 required editcurrency')
        		  ->removeDecorator('HtmlTag')
        		  ->addFilters(array('StringTrim'))
        		  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter country currency.'))))
        		  ->setValue('');

        $dialcode = $this->createElement('text','editdialcode');
		$dialcode->removeDecorator('Label')
				  ->setAttrib('maxlength', '4')
    			  ->setAttrib('class','inp1 required editdialcode')
    			  ->setAttrib('style','width:140px;')
        		  ->removeDecorator('HtmlTag')
        		  ->addFilters(array('StringTrim'))
        		  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter country phonecode.'))))
        		  ->setValue('');

		$countryflag = $this->createElement('file','countryflag');
		$countryflag->removeDecorator('Label')
				->removeDecorator('HtmlTag')
				->setAttrib('class','inp1 splimage') 
			    ->addValidator('FilesSize', false, array('min' => '50B', 'max' => '100kB'))
			    ->addValidator('Extension', false,array('jpg,png','messages' => 'Please select jpg or png images only')); 
			    
		$timezne = $this->createElement('select','edittimezone');
        $timezne->removeDecorator('Label') 
         				->removeDecorator('HtmlTag') 
         				->setAttrib('class','inp1 required edittimezone') 
						->setAttrib('placeholder', 'TimeZone')
         				->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select TimeZone.'))))
               			->addMultiOptions($timeZoneList)
               			->setRequired(false);
			    		  
		$Id = $this->createElement('hidden','editstateid');
    	$Id->removeDecorator('HtmlTag')
    		  ->removeDecorator('Label');
    		  
    	
       $edit = $this->createElement('button','Update');
       $edit->removeDecorator('Label')
        		   ->removeDecorator('DtDdWrapper')
        		   ->setValue('Search')           		          		        		
        		   ->setAttrib('class','submitBtn')
                   ->setIgnore(true);
    	
    	                   
		$this->addElements( array ($code,
								   $desc,
								   $edit,
								   $currency,
								   $countryflag,
								   $dialcode,
								   $timezne,
								   $Id));                           	        
    }


}