<?php

class Administrator_Form_ManageRest extends Zend_Form
{

    public function init()
    {
    	$this->setAttrib('enctype', 'multipart/form-data');
    	/* Populating City Base Data */
    	
    	$regionMapper = new Application_Model_RegionDataMapper();
    	$regionResults   = $regionMapper->fetchAll();
    	$regionList = array();
    	$regionList[] = array('key'=>'','value'=>'Select State');
    	foreach($regionResults as $result){
    		$regionList[] = array('key'=>$result->getId(),'value'=>$result->getDescription());
    	}
    	
    	/* Populating Restaurant Approval Status Bd  */
    	
    	$restAppStaMapper = new Application_Model_RestaurantApprovalStatusDataMapper();
    	$restAppStaRes = $restAppStaMapper->fetchAll();
    	$restAppStaLst = array();
    	$restAppStaLst[] = array('key'=>'','value'=>'All');
    	foreach($restAppStaRes as $res){
    		$restAppStaLst[] = array('key'=>$res->getId(),'value'=>$res->getDescription());
    	}
    	
    	/* Populating Restaurant  Status Bd*/
  	    $restStaMapper = new Application_Model_RestaurantStatusDataMapper();
    	$restStaRes = $restStaMapper->fetchAll();
    	$restStaLst = array();
    	$restStaLst[] = array('key'=>'','value'=>'Select Status');
    	foreach($restStaRes as $rest){
    		$restStaLst[] = array('key'=>$rest->getId(),'value'=>$rest->getDescription());
    	}
    	
    	$companyList = array();
    	$companyMapper = new Administrator_Model_CompanyDataMapper();
    	$companyList = $companyMapper->getAllComapnyList();    	
    	
    	$firstName = $this->createElement('text','firstname');
    	$firstName->removeDecorator('Label')
    			  ->setAttrib('class','inp1 form input_form')
    			  ->setAttrib('placeholder','First Name')
    			  ->setAttrib('title','First Name')
        		  ->removeDecorator('HtmlTag')
        		  ->addFilters(array('StringTrim'))
        		  ->setValue('');
        		  
		$lastName = $this->createElement('text','lastname');
		$lastName->removeDecorator('Label')
    			  ->setAttrib('class','inp1 form input_form')
    			  ->setAttrib('placeholder','Last Name')
    			  ->setAttrib('title','Last Name')
        		  ->removeDecorator('HtmlTag')
        		  ->addFilters(array('StringTrim'))
        		  ->setValue('');	

        $restId = $this->createElement('text','restid');
    	$restId->removeDecorator('Label')
    			 ->setAttrib('class','inp1 form input_form')
    	  		 ->setAttrib('placeholder','Restaurant Id')
    	  		 ->setAttrib('title','Restaurant Id')
        		 ->removeDecorator('HtmlTag')
        		  ->setAttrib('maxlength', '6')
        		  ->addValidator('Digits',new Zend_Validate_Digits(),array('messages' => 'Please enter Numbers only'))
        		 ->setValue('');
    	
    	$restName = $this->createElement('text','restname');
    	$restName->removeDecorator('Label')
    			 ->setAttrib('class','inp1 form input_form')
    		  	 ->setAttrib('placeholder','Restaurant Name')
    		  	 ->setAttrib('title','Restaurant Name') 
        		 ->removeDecorator('HtmlTag')
        		 ->addFilters(array('StringTrim'))
        		 ->setValue('');

         $resRegion = $this->createElement('select', 'resRegion');
         $resRegion->removeDecorator('Label')
         		 ->removeDecorator('HtmlTag') 
         		 ->setAttrib('class','drpDown form input_form')
         		 ->setAttrib('placeholder','Select State') 
         		 ->setAttrib('title','State') 
         		 ->setAttrib('style','width:160px')     	     
        	     ->addMultiOptions($regionList);
        		 	
	 	$resCity = $this->createElement('select', 'resCity');
        $resCity->removeDecorator('Label')
         		 ->removeDecorator('HtmlTag') 
         		 ->setAttrib('class','drpDown input_form') 
         		 ->setAttrib('placeholder','Select City')
         		 ->setAttrib('title','City') 
         		 ->setAttrib('style','width:160px')
         		 ->setRegisterInArrayValidator(false);
             	     
        $restEmail = $this->createElement('text','email');
    	$restEmail->removeDecorator('Label')
    			 ->setAttrib('class','inp1 form input_form')
    			 ->setAttrib('placeholder','Email')
         		 ->setAttrib('title','Email') 
        		 ->removeDecorator('HtmlTag')
        		 ->addFilters(array('StringTrim'))
        		 ->setValue('');     
                 

		 $restStatus = $this->createElement('select','reststatus');
		 $restStatus->removeDecorator('Label')
         		    ->removeDecorator('HtmlTag')
         		    ->setAttrib('style','width:160px') 
         	     	->setAttrib('placeholder','Select Status')
         		 	->setAttrib('title','Status') 
         		    ->setAttrib('class','drpDown form input_form')       	     
        	        ->addMultiOptions($restStaLst);
        	        
         $restAppStatus = $this->createElement('select','restappstatus');
		 $restAppStatus->removeDecorator('Label')
         		    ->removeDecorator('HtmlTag')
         		    ->setAttrib('style','width:160px')
         		    ->setAttrib('placeholder','Select Approval Status')
         		 	->setAttrib('title','Approval Status')  
         		    ->setAttrib('class','drpDown form input_form')       	     
        	        ->addMultiOptions($restAppStaLst);
        	        
       	 $comapny = $this->createElement('select','comapny');
		 $comapny->removeDecorator('Label')
         	     ->removeDecorator('HtmlTag')
         	     ->setAttrib('style','width:160px')
         	     ->setAttrib('title','Company')  
         	     ->setAttrib('class','drpDown input_form')       	     
                 ->addMultiOptions($companyList);
        	        		 		                  
		 $resSearch = $this->createElement('submit','search');
         $resSearch->removeDecorator('Label')
        		   ->removeDecorator('DtDdWrapper')
        		   ->setValue('Search')           		          		        		
        		   ->setAttrib('class','submitBtn')
                   ->setIgnore(true);
                   
		$this->addElements( array ($restId,
								   $restName,
		                           $firstName,
								   $lastName,
								   $restEmail,
								   $resRegion,
								   $resCity,
								   $restStatus,
								   $restAppStatus,
								   $comapny,
								   $resSearch));                           	        
    }


}

