<?php
class Administrator_Model_Campaign
{
	private $_campType;
	private $_campName;
	private $_sponsor;
	private $_desc;
	private $_startDate;
	private $_endDate;
	private $_link;
	private $_image;
	private $_state;
	private $_region;
	private $_city;
	private $_status;
	private $_id;
	private $_priceid;
	private $_count;
	private $_planType;
	private $_planName;
	private $_noofemails;
	private $_audience;
	private $_amount;	
	private $_time;
	private $_dashStat;
	private $_formStat;
	private $_scWebCount;
	
	public function __construct(array $options = null)
	{
		if(is_array($options)){
			$this->setOptions($options);
		}		
	}
	
	public function __set($name, $value)
	{
		$method = 'set' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Price Plan property');
		}
		$this->$method($value);
	}
	
	public function __get($name)
	{
		$method = 'get' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Price Plan property');
		}
		return $this->$method();
	}
	
	public function setOptions(array $options)
	{
		$methods = get_class_methods($this);
		foreach ($options as $key => $value) {
			$method = 'set' . ucfirst($key);
			if (in_array($method, $methods)) {
				$this->$method($value);
			}
		}
		return $this;
	}
	
	public function setId($id)
	{
		$this->_id = $id;
		return $this;
	}
	
	public function getId()
	{
		return $this->_id;
	}
	
	public function setPriceId($id)
	{
		$this->_priceid = $id;
		return $this;
	}
	
	public function getPriceId()
	{
		return $this->_priceid;
	}
	
	public function setCampName($name)
	{
		$this->_campName = $name;
		return $this;
	}
	
	public function getCampName()
	{
		return $this->_campName;
	}
	
	public function setCampType($type)
	{
		$this->_campType = $type;
		return $this;
	}
	
	public function getCampType()
	{
		return $this->_campType;
	}
	
	public function setSponsor($sponsor)
	{
		$this->_sponsor = $sponsor;
		return $this;
	}
	
	public function getSponsor()
	{
		return $this->_sponsor;
	}
	
	public function setCampDesc($desc)
	{
		$this->_desc = $desc;
		return $this;
	}
	
	public function getCampDesc()
	{
		return $this->_desc;
	}
		
	public function setStartDate($startDate)
	{
		$this->_startDate = $startDate;
		return $this;
	}
	
	public function getStartDate()
	{
		return $this->_startDate;
	}

	public function setEndDate($endDate)
	{
		$this->_endDate = $endDate;
		return $this;
	}
	
	public function getEndDate()
	{
		return $this->_endDate;
	}
	
	public function setLink($link)
	{
		$this->_link = $link;
		return $this;
	}
	
	public function getLink()
	{
		return $this->_link;
	}
	
	public function setCampImage($img)
	{
		$this->_image = $img;
		return $this;
	}
	
	public function getCampImage()
	{
		return $this->_image;
	}
	
	public function setState($state)
	{
		$this->_state = $state;
		return $this;
	}
	
	public function getState()
	{
		return $this->_state;
	}
	
	public function setRegion($region)
	{
		$this->_region = $region;
		return $this;
	}
	
	public function getRegion()
	{
		return $this->_region;
	}
		
	public function getCity()
	{
		return $this->_city;
	}
	
	public function setCity($city)
	{
		$this->_city = $city;
		return $this;
	}
	
	public function setCount($count)
	{
		$this->_count = $count;
		return $this;
	}
	
	public function getCount()
	{
		return $this->_count;
	}
	
	public function setStatus($status)
	{
		$this->_status = $status;
		return $this;
	}
	
	public function getStatus()
	{
		return $this->_status;
	}
	
	public function setPlanName($name)
	{
		$this->_planName = $name;
		return $this;
	}
	
	public function getPlanName()
	{
		return $this->_planName;
	}
	
	public function setPlanType($type)
	{
		$this->_planType = $type;
		return $this;
	}
	
	public function getPlanType()
	{
		return $this->_planType;
	}
	
	public function setNoOfEmails($no)
	{
		$this->_noofemails = $no;
		return $this;
	}
	
	public function getNoOfEmails()
	{
		return $this->_noofemails;
	}
	
	public function setAudience($aud)
	{
		$this->_audience = $aud;
		return $this;
	}
	
	public function getAudience()
	{
		return $this->_audience;
	}
		
	public function setAmount($amount)
	{
		$this->_amount = $amount;
		return $this;
	}
	
	public function getAmount()
	{
		return $this->_amount;
	}

	public function setCampTime($time)
	{
		$this->_time = $time;
		return $this;
	}
	
	public function getCampTime()
	{
		return $this->_time;
	}
	
	public function setDashboardStatus($stat)
	{
		$this->_dashStat = $stat;
		return $this;
	}
	
	public function getDashboardStatus()
	{
		return $this->_dashStat;
	}
	
	public function setFormType($stat)
	{
		$this->_formStat = $stat;
		return $this;
	}
	
	public function getFormType()
	{
		return $this->_formStat;
	}
	public function setScWebLinkCount($Count)
	{
		$this->_scWebCount = $Count;
		return $this;
	}
	
	public function getScWebLinkCount()
	{
		return $this->_scWebCount;
	}
}