<?php
class Administrator_Model_CompanyTypeMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Administrator_Model_DbTable_CompanyType');
		}
		return $this->_dbTable;
	}
	
	public function fetchAll()
	{
		try{
			$companytypeArr = array();	
			$where = array('status = ?'=> true);
			$records = $this->getDbTable()->fetchAll($where);
			$companytypeArr[] = array('key'=>'','value'=>'Select Company Type'); 					
			foreach($records as $record){
				$companytypeArr[] = array('key'=>$record['id'],'value'=>$record['description']);	
			}
			return $companytypeArr;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}
