<?php
class Administrator_Model_EmailMarketLogDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Administrator_Model_DbTable_EmailMarketLog');
		}
		return $this->_dbTable;
	}
	
	public function EditEmailMarketLog(Administrator_Model_EmailMarketLog $emarketlog)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$table = $this->getDbTable();
			$data = array(
							'emls_assigned_to'		=>	$emarketlog->getAssignedTo(),
						  	'emls_log_description'	=>	$emarketlog->getLogDescription(),
						  	'emls_status_id'		=>	$emarketlog->getStatusId(),
							'emls_date'				=>	$emarketlog->getDate(),
							'emls_time'				=>	$emarketlog->getTime(),
							'emls_log_createdby'		=>	$emarketlog->getCreatedBy(),
							'emls_enquiry_id'			=>	$emarketlog->getEnquiryId()
			);
			if($emarketlog->getNextFollowUpDate() !='')
			{
				$data['emls_next_follow_up_date'] = $emarketlog->getNextFollowUpDate();
			}
			$row_insert = $table->insert($data);
			if($row_insert)
			{
				$templatemapper = new FirmManagement_Model_EmailMarketingTemplateDataMapper;
				$set 	= array('emt_emailstatus'	=>	$emarketlog->getStatusId());
				$where 	= array('emt_id = ?' => $emarketlog->getEnquiryId());
				$rows_affected = $templatemapper->getDbTable()->update($set,$where);
			}
			
			return $row_insert;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getEmailMarketLogById($enquiryid)
	{
		try{
			$resultSet = array();
			
			$table 	= $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			
			$select->from(array('elst'=>'mt.emailmarket_log_status'),array('emls_id','emls_assigned_to','emls_log_description','emls_status_id','emls_date','emls_time','emls_log_createdby','emls_next_follow_up_date','emls_enquiry_id'))
				   ->joinLeft(array('esbd'=>'mt.email_market_status_bd'),'esbd.id = elst.emls_status_id',array('description'))
				   ->where('emls_enquiry_id = ?',$enquiryid);
			$records = $table->fetchAll($select);
			foreach($records as $value)
			{
				$next_follow_up_date = $value->emls_next_follow_up_date;
				if($value->emls_next_follow_up_date == '')
				{
					$next_follow_up_date = '';
				}else{
					$next_follow_up_date = date("d M Y",strtotime($value->emls_next_follow_up_date));
				}
				$resultSet[] = array('emls_id' => $value->emls_id,'emls_enquiry_id' => $value->emls_enquiry_id,'emls_status' => $value->description,'emls_log_description' => $value->emls_log_description,'emls_log_createdby' => $value->emls_log_createdby,'emls_datetime' => date("d M Y",strtotime($value->emls_date)).' '.$value->emls_time,'emls_assigned_to' => $value->emls_assigned_to,'emls_next_follow_up_date' => $next_follow_up_date);
			}
			return $resultSet;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}