<?php
/**
*	Name			: EnquiryLogStatus.php
*	Author			: Sairam
*	Creation Date	: 28/03/2012
*	Path 			: application/models/EnquiryLogStatus.php
*	Description		: This is the Model class for the Enquiry Log Status basedata table.
*/

class Administrator_Model_EnquiryLogStatus
{
	/**
	 * 
	 * @var integer
	 */
	protected $_elsid;
	
	/**
	 * 
	 * @var string
	 */
	protected $_elslog_description;
	
	/**
	 * 
	 * @var integer
	 */
	protected $_elsassigned_to;
	
	/**
	 * 
	 * @var integer
	 */
	protected $_elsstatus_id;
	
	/**
     * 
     *
     * @var date
     */	

	protected $_elsdate;
	
	/**
     * 
     *
     * @var time
     */	

	protected $_elstime;
	
	/**
     * 
     *
     * @var integer
     */	
	
	protected $_elslog_createdby;
	
	/**
     * 
     *
     * @var date
     */	
	
	protected $_elsnext_follow_up_date;
	
	/**
	 * 
	 * @var integer
	 */
	protected $_elsenquiry_id;
	
	/**
     * Public constructor
     *
     * @param  array $options
     */	
	
	public function __construct(array $options = null)
	{
		if(is_array($options)){
			$this->setOptions($options);
		}		
	}
	
	/**
	 * Writing data to properties
	 */
	public function __set($name, $value)
	{
		$method = 'set' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Enquiry Log Status property');
		}
		$this->$method($value);
	}
	
	/**
	 * Reading data from properties
	 */
	public function __get($name)
	{
		$method = 'get' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Enquiry Log Status property');
		}
		return $this->$method();
	}
	
	public function setOptions(array $options)
	{
		$methods = get_class_methods($this);
		foreach ($options as $key => $value) {
			$method = 'set' . ucfirst($key);
			if (in_array($method, $methods)) {
				$this->$method($value);
			}
		}
		return $this;
	}
	
	/**
     * @param integer $elsid
     * @return self
     */
	public function setId($elsid)
	{
		$this->_elsid = $elsid;
		return $this;
	}
	
	 /**
     * @return integer
     */
	public function getId()
	{
		return $this->_elsid;
	}
	
	/**
     * @param string $elslog_description
     * @return self
     */
	public function setLogDescription($elslog_description)
	{
		$this->_elslog_description = $elslog_description;
		return $this;
	}
	
	/**
     * @return string
     */
	public function getLogDescription()
	{
		return $this->_elslog_description;
	}
	
	/**
     * @param string $elsassigned_to
     * @return self
     */
	public function setAssignedTo($elsassigned_to)
	{
		$this->_elsassigned_to = $elsassigned_to;
		return $this;
	}
	
	/**
     * @return string
     */
	public function getAssignedTo()
	{
		return $this->_elsassigned_to;
	}
	
	/**
     * @param boolean $elsstatus_id
     * @return self
     */
	public function setStatusId($elsstatus_id)
	{
		$this->_elsstatus_id = $elsstatus_id;
		return $this;
	}
	
	/**
     * @return boolean
     */
	public function getStatusId()
	{
		return $this->_elsstatus_id;
	}
	
	/**
     * @param date $elsdate
     * @return self
     */
	public function setDate($elsdate)
	{
		$this->_elsdate = $elsdate;
		return $this;
	}
	
	/**
     * @return date
     */
	public function getDate()
	{
		return $this->_elsdate;
	}
	
	/**
     * @param time $elstime
     * @return self
     */
	public function setTime($elstime)
	{
		$this->_elstime = $elstime;
		return $this;
	}
	
	/**
     * @return date
     */
	public function getTime()
	{
		return $this->_elstime;
	}
	
	/**
     * @param integer $elslog_createdby
     * @return self
     */
	public function setCreatedBy($elslog_createdby)
	{
		$this->_elslog_createdby = $elslog_createdby;
		return $this;
	}
	
	/**
     * @return integer
     */
	public function getCreatedBy()
	{
		return $this->_elslog_createdby;
	}
	
	/**
     * @param date $elsnext_follow_up_date
     * @return self
     */
	public function setNextFollowUpDate($elsnext_follow_up_date)
	{
		$this->_elsnext_follow_up_date = $elsnext_follow_up_date;
		return $this;
	}
	
	/**
     * @return date
     */
	public function getNextFollowUpDate()
	{
		return $this->_elsnext_follow_up_date;
	}
	
	
	/**
     * @param boolean $elsenquiry_id
     * @return self
     */
	public function setEnquiryId($elsenquiry_id)
	{
		$this->_elsenquiry_id = $elsenquiry_id;
		return $this;
	}
	
	/**
     * @return boolean
     */
	public function getEnquiryId()
	{
		return $this->_elsenquiry_id;
	}
}