<?php
class Administrator_Model_EnquiryLogStatusDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Administrator_Model_DbTable_EnquiryLogStatus');
		}
		return $this->_dbTable;
	}
	
	public function EditEnquiryLog(Administrator_Model_EnquiryLogStatus $enquirylog)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$table = $this->getDbTable();
			$data = array(
							'elsassigned_to'		=>	$enquirylog->getAssignedTo(),
						  	'elslog_description'	=>	$enquirylog->getLogDescription(),
						  	'elsstatus_id'			=>	$enquirylog->getStatusId(),
							'elsdate'				=>	$enquirylog->getDate(),
							'elstime'				=>	$enquirylog->getTime(),
							'elslog_createdby'		=>	$enquirylog->getCreatedBy(),
							'elsenquiry_id'			=>	$enquirylog->getEnquiryId()
			);
			if($enquirylog->getNextFollowUpDate() !='')
			{
				$data['elsnext_follow_up_date'] = $enquirylog->getNextFollowUpDate();
			}
			$row_insert = $table->insert($data);
			if($row_insert)
			{
				$contactmapper = new Communication_Model_ContactUsDataMapper();
				$set 	= array('enquiry_status_id'	=>	$enquirylog->getStatusId());
				$where 	= array('id = ?' => $enquirylog->getEnquiryId());
				$rows_affected = $contactmapper->getDbTable()->update($set,$where);
			}
			
			return $row_insert;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getEnquiryLogEnquiryId($enquiryid)
	{
		try{
			$resultSet = array();
			
			$table 	= $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			
			$select->from(array('elst'=>'mt.enquiry_log_status'),array('elsid','elsassigned_to','elslog_description','elsstatus_id','elsdate','elstime','elslog_createdby','elsnext_follow_up_date','elsenquiry_id'))
				   ->joinLeft(array('esbd'=>'mt.enquiry_status_bd'),'esbd.id = elst.elsstatus_id',array('description'))
				   ->where('elsenquiry_id = ?',$enquiryid);
			$records = $table->fetchAll($select);
			foreach($records as $value)
			{
				$next_follow_up_date = $value->elsnext_follow_up_date;
				if($value->elsnext_follow_up_date == '')
				{
					$next_follow_up_date = '';
				}else{
					$next_follow_up_date = date("d M Y",strtotime($value->elsnext_follow_up_date));
				}
				$resultSet[] = array('elsid' => $value->elsid,'elsenquiry_id' => $value->elsenquiry_id,'elsstatus' => $value->description,'elslog_description' => $value->elslog_description,'elslog_createdby' => $value->elslog_createdby,'elsdatetime' => date("d M Y",strtotime($value->elsdate)).' '.$value->elstime,'elsassigned_to' => $value->elsassigned_to,'elsnext_follow_up_date' => $next_follow_up_date);
			}
			return $resultSet;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}