<?php
class Administrator_Model_PricePlanDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Administrator_Model_DbTable_PricePlan');
		}
		return $this->_dbTable;
	}
	
	public function GetPricePlans()
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('sppid','sppplan_name'))
				   ->where('sppstatus = true')
				   ->where('sppdelete_status = false')
				   ->order(array('sppid'));
			$records = $table->fetchAll($select);
			return $records;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function AddPricePlan(Administrator_Model_PricePlan $pricePlan)
	{
		try{
			$data = array(
							'sppplan_name'			=>	$pricePlan->getPlanName(),
							'sppplan_type'			=>	$pricePlan->getPlanType(),	
							'sppintended_audience'	=>	$pricePlan->getAudience(),
							'sppamount'				=>	$pricePlan->getAmount(),
							'sppcreated_on'			=>	date('Y-m-d H:i:s'),
							'sppstatus'				=>	1,
							'sppdelete_status'		=>	0
			);
			if($pricePlan->getPlanType()){
				
			}
			$result = $this->getDbTable()->insert($data);
			if($pricePlan->getPlanType() == 'NOT' || $pricePlan->getPlanType() == 'BOTH'){
				$mapper = new Administrator_Model_SponsorCampaignEmailDataMapper();
				$table = $mapper->getDbTable();
				$Emaildata = array(
									'scetotal_email_count'	=>	$pricePlan->getNoOfEmails(),
									'sceemail_count'		=>	$pricePlan->getNoOfEmails(),
									'scefk_price_plan'		=>	$result
				);
				$emailResult = $table->insert($Emaildata);
			}
			if($result){
				return $result;
			}else{
				return false;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetPricePlanDetails($spoid,$isAjaxCall)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			$select->from(array('spp'=>'mt.sponsor_price_plan'),array('sppplan_name','sppplan_type','sppintended_audience','sppamount'))
				   ->join(array('aud'=>'mt.intended_audience_bd'),'aud.code = spp.sppintended_audience',array('description as Audience'))
				   ->join(array('note'=>'mt.sponsor_target_pages_bd'),'note.code = spp.sppplan_type',array('description as PlanType'))
				   ->join(array('sce'=>'mt.sponsor_campaign_email'),'sce.scefk_price_plan = spp.sppid',array('scetotal_email_count'))
				   ->where('spp.sppid = ?',$spoid);
			$result = $table->fetchRow($select);
			if($isAjaxCall){
				$resultSet = array();
				$resultSet = array(
									'planName'		=>	trim($result->sppplan_name),
									'planType'		=>	trim($result->PlanType),
									'planAudience'	=>	trim($result->Audience),
									'sppamount'		=>	trim($result->sppamount),
									'count'			=>	trim($result->scetotal_email_count)
				);
				return $resultSet;	
			}else{
				return $result;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}