<?php
class Administrator_Model_RestaurantActivityMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Administrator_Model_DbTable_RestaurantActivity');
		}
		return $this->_dbTable;
	}
	
	public function AddRestaurantActivity(Administrator_Model_RestaurantActivity $activity)
	{
            try{
                $db = Zend_Db_Table::getDefaultAdapter();
                $table = $this->getDbTable();
                $data = array(
                                'rar_fk_restaurant' =>  $activity->getrar_fk_restaurant(),
                                'rarstatus'         =>  $activity->getrarstatus(),
                                'raractivity_date'  =>  $activity->getraractivity_date(),
                                'rarupdated_by'     =>  $activity->getrarupdated_by(),
                                'rarupdated_at'     =>  $activity->getrarupdated_at()
                );
                $row_insert = $table->insert($data);
                return $row_insert;
            }catch (Exception $ex){
                    throw new Exception($ex->getMessage()) ;
            }
	}
	
	public function getEnquiryLogEnquiryId($enquiryid)
	{
		try{
			$resultSet = array();
			
			$table 	= $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			
			$select->from(array('elst'=>'mt.enquiry_log_status'),array('elsid','elsassigned_to','elslog_description','elsstatus_id','elsdate','elstime','elslog_createdby','elsnext_follow_up_date','elsenquiry_id'))
				   ->joinLeft(array('esbd'=>'mt.enquiry_status_bd'),'esbd.id = elst.elsstatus_id',array('description'))
				   ->where('elsenquiry_id = ?',$enquiryid);
			$records = $table->fetchAll($select);
			foreach($records as $value)
			{
				$next_follow_up_date = $value->elsnext_follow_up_date;
				if($value->elsnext_follow_up_date == '')
				{
					$next_follow_up_date = '';
				}else{
					$next_follow_up_date = date("d M Y",strtotime($value->elsnext_follow_up_date));
				}
				$resultSet[] = array('elsid' => $value->elsid,'elsenquiry_id' => $value->elsenquiry_id,'elsstatus' => $value->description,'elslog_description' => $value->elslog_description,'elslog_createdby' => $value->elslog_createdby,'elsdatetime' => date("d M Y",strtotime($value->elsdate)).' '.$value->elstime,'elsassigned_to' => $value->elsassigned_to,'elsnext_follow_up_date' => $next_follow_up_date);
			}
			return $resultSet;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}