<?php
class Administrator_Model_RestaurantManualPaymentDetailsMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Administrator_Model_DbTable_RestaurantManualPaymentDetails');
		}
		return $this->_dbTable;
	}
	
	public function ManageManualPayment(Administrator_Model_RestaurantManualPaymentDetails $manual)
	{
		try{

				$setarr = array('rmpd_payment_status'	=>	0);
				$where = array('rmpd_fk_restaurant = ?' => $manual->getResId());				
				$this->getDbTable()->update($setarr,$where);
				
				$data = array(
							'rmpd_fk_restaurant'			=>	$manual->getResId(),
							'rmpd_valid_from'				=>	$manual->getStart(),
							'rmpd_valid_to'					=>	$manual->getEnd(),
							'rmpd_payment_made_on'			=>	date('Y-m-d'),
							'rmpd_payment_description'		=>	$manual->getDesc(),
							'rmpd_payment_created_by'		=>	$manual->getCreatedby(),
							'rmpd_payment_created_on'		=>	date('Y-m-d h:i:a'),
							'rmpd_payment_status'			=>  true
					);
				$result = $this->getDbTable()->insert($data);
			if($result){
				$set = array('resstatus'=>1);
				$resMapper = new FirmManagement_Model_FirmDataMapper();
				$row_eff = $resMapper->getDbTable()->update($set,array('resid = ?'=>$manual->getResId()));
			}
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getManualPaymentDetailsforRestaurant($resid)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->from($this->getDbTable(),array('rmpd_valid_from','rmpd_valid_to','rmpd_payment_description'))
					->where('rmpd_fk_restaurant = ?',$resid)
					->where('rmpd_payment_status = ?',TRUE);
			$result = $this->getDbTable()->fetchRow($select);
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getPaymentDetails($resid)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->from($this->getDbTable(),array('rmpd_id','rmpd_valid_from','rmpd_valid_to','rmpd_payment_description','rmpd_payment_made_on','rmpd_payment_updated_on','rmpd_payment_status'))
					->where('rmpd_fk_restaurant = ?',$resid);
			$result = $this->getDbTable()->fetchAll($select);
			$entry=array();
			$entries=array();
			foreach($result as $row)
			{
				$entry['rmpd_id'] = $row['rmpd_id'];
				$entry['rmpd_valid_from'] = date('m-d-Y',strtotime($row['rmpd_valid_from']));
				$entry['rmpd_valid_to']=date('m-d-Y',strtotime($row['rmpd_valid_to']));
				$entry['rmpd_payment_description']=$row['rmpd_payment_description'];
				$entry['rmpd_payment_made_on']= date('m-d-Y',strtotime($row['rmpd_payment_made_on']));
				if($row['rmpd_payment_updated_on']){
					$entry['rmpd_payment_updated_on']=$row['rmpd_payment_updated_on'];
				}else{
					$entry['rmpd_payment_updated_on']= '-';
				}
				$entry['rmpd_payment_status']=$row['rmpd_payment_status'];
				$entries[]=$entry;
			}
			return $entries;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	//Update the description in Payment History
	public function updateDescription($rmpd,$desc)
	{
		try{
			 $set = array('rmpd_payment_description'=>	$desc);
			 $result = $this->getDbTable()->update($set,array('rmpd_id = ?'=> $rmpd));
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}