<?php
class Administrator_Model_SubscriptionPlansSearch
{
	private $_id;
	private $_resName;
	private $_firstName;
	private $_lastName;
	private $_email;
	private $_actDate;
	
public function __construct(array $options = null)
	{
		if(is_array($options)){
			$this->setOptions($options);
		}		
	}
	
	public function __set($name, $value)
	{
		$method = 'set' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Subscription property');
		}
		$this->$method($value);
	}
	
	public function __get($name)
	{
		$method = 'get' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Subscription property');
		}
		return $this->$method();
	}
	
	public function setOptions(array $options)
	{
		$methods = get_class_methods($this);
		foreach ($options as $key => $value) {
			$method = 'set' . ucfirst($key);
			if (in_array($method, $methods)) {
				$this->$method($value);
			}
		}
		return $this;
	}
	
	public function setId($id)
	{
		$this->_id = $id;
		return $this;
	}
	
	public function getId()
	{
		return $this->_id;
	}
	
	public function setresName($name)
	{
		$this->_resName = $name;
		return $this;
	}
	
	public function getresName()
	{
		return $this->_resName;
	}
	
	public function setfirstName($firname)
	{
		$this->_firstName = $firname;
		return $this;
	}
	
	public function getfirstName()
	{
		return $this->_firstName;
	}
	
	public function setlastName($lasname)
	{
		$this->_lastName = $lasname;
		return $this;
	}
	
	public function getlastName()
	{
		return $this->_lastName;
	}
	
	public function setEmail($email)
	{
		$this->_email = $email;
		return $this;
	}
	
	public function getEmail()
	{
		return $this->_email;
	}

	public function setActDate($date)
	{
		$this->_actDate = $date;
		return $this;
	}
	
	public function getActDate()
	{
		return $this->_actDate;
	}
}