<?php
class Android_AndroidController extends Zend_Controller_Action
{

	protected $_android = null;
	protected $_firmService = null;
	protected $_reservationService = null;
	
	public function init()
	{
		if(!$this->_android){
			$this->_android	= new Application_Service_Android();
		}
		
		if(!$this->_firmService){
			$this->_firmService	= new Application_Service_Firm();
		}
		
		if(!$this->_reservationService){
			$this->_reservationService	= new Application_Service_Reservation();
		}
	}
	
	public function checkandroidloginAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();

				$request = $this->getRequest();
				header('Content-type: application/json');
				
				$loginRes = $this->_android->CheckAndroidDetails($request);
				if(isset($loginRes['isFormValid'])){
					header('Content-type: application/json');	
					echo json_encode("Form Invalid");
				}else if(isset($loginRes['UserNotApproved'])){
					header('Content-type: application/json');	
					echo json_encode("UserNotApproved");
				}else if(isset($loginRes['UserInActive'])){
					header('Content-type: application/json');	
					echo json_encode("UserInActive");
				}else if($loginRes['Status']){
					header('Content-type: application/json');
					echo json_encode(array(
						'restauranttabledata'		=>	$loginRes['restaurantdata'],
						'access_token' => $loginRes['access_token']
									));
				}

		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function retrievefirmtimeslotsAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$reservService = new Application_Service_Reservation();
			$results = $reservService->getRestaurantTimings($request);
			$searchListArr = array();
			if(isset($results)){
				$index = 0;
				if($request->fromaction == 'reservation'){
					foreach($results as $listval){
						$searchListArr[$index] = $listval;
						$index++;
					}
				}else{
					if($results){
						foreach($results as $listval){
							if($listval['status'] == 'WAL'){
								continue;
							}else{
								$searchListArr[$index] = $listval;
								$index++;
							}
						}
					}
				}
			}
			header('Content-type: application/json');
			echo json_encode($searchListArr);
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function bookareservationandroidAction()
	{
		try{
			
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			header('Content-type: application/json');
			if($request){
				$formData = $request->getPost();
				$result = $this->_android->MakeReservationAndroid($formData);
				if($result['status']){
					echo json_encode(true);							
				}else{
					echo json_encode(false);
				}
			}else{
				echo json_encode(false);
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function makewalkinandroidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			header('Content-type: application/json');
			if($request){
				$formData = $request->getPost();
				$userid = $request->userid;
				$resService = new Application_Service_Reservation();
				$result = $resService->MakeWalkinReservation($request,$userid);
				if($result){
					echo json_encode(true);
				}else{
					echo json_encode(false);
				}				
			}else{
				echo json_encode(false);
			}
			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function makewaitingandroidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			header('Content-type: application/json');
			if($request){
				$formData = $request->getPost();
				$userid = $request->userid;
				$result = $this->_android->MakeWaitingReservationAndroid($formData,$userid);
				if($result['status']){
					echo json_encode(true);			
				}else{
					echo json_encode(false);
				}
			}else{
				echo json_encode(false);
			}		
					
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function pickfirmblockedintervelsandroidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->GetRestaurantTimingsFreeze($request);
			header('Content-type: application/json');
			if($result){
				echo json_encode(array('mealintervals' => $result));
			}else{
				echo "false";
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function blockscheduleandroidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			header('Content-type: application/json');
			$userid = $request->userid;
			$freezedDates = $this->_android->FreezeReservationAndroid($request,$userid);
			if($freezedDates){
				echo json_encode('true');
			}else{
				echo json_encode('false');
			}			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function reservationreportandroidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			header('Content-type: application/json');			
			if($request){
				$resService = new Application_Service_Reservation();
				$reservResult = $resService->getResvReportMobile($request);
				if($reservResult['rowset'] != null){
					echo json_encode($reservResult);
				}else{
					echo json_encode(false);
				}
			}
			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function customercontactsandroidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			header('Content-type: application/json');
			if($request){
				$restid = $request->restaurantid;				
				if($this->getRequest()->isPost()){
					$request = $this->getRequest()->getPost();
					$result = $this->_android->getCustomerContacts($restid);
				}else{
					$result = $this->_android->getCustomerContacts($restid);
				}
				if($result != null){
					$contacts = array();
					$contacts['contacts'] = $result;						
					echo json_encode($contacts);				
				}else{
					echo json_encode(false);
				}
			}
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function listofreservbyandroidAction()
	{
		try{			
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$resultArr = array(); 
			$resType = $request->restype;
			header('Content-type: application/json');
			if($request->restaurantid){
				$resService = new Application_Service_Reservation();
				$diningidArr = array();
					$diningAreaArr = array();
					$diningMapper = new FirmManagement_Model_FirmDiningAreaDataMapper();
					$Diningresult = $diningMapper->getDinigAreasByRestId($request->restaurantid);
					//				foreach($Diningresult as $dining){
					//					$diningidArr[] = $dining->rdaid;
					//				}
					//				$diningid = $diningidArr[0];
				$diningArr = array();
				foreach($Diningresult as $din){
					$diningArr[] = array('diningname' => $din->rda_diningname,
										 'diningid' => $din->rdaid);
				}
				$resultArr['diningareas'] = $diningArr;
				if(isset($resType))
				{
					
					switch($resType)
					{
						case 'all':
						$date = '';
						$timeZone = $this->_firmService->GetRestaurantTimeZone($request->restaurantid);
						date_default_timezone_set($timeZone);
						if(isset($request->date)){
							$date = $request->date;
						}else{
							$date = date('Y-m-d');
						}
						$getWaitingList = new Reservation_Model_GetWaitingList();
						$getWaitingList->setRestaurantId($request->restaurantid);
						$getWaitingList->setDate($date);
						$getWaitingList->setIsAjaxCall(true);
						/* Reteriving booking status id by code */
						$status = array();
						$bookStatus = array('WAL','READY','QUOTE','BAR','NEXT','CANCUS','BACK');
						$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
						$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
						$getWaitingList->setBookStatus($bookStatusRes);
						$waitnSortedArray = array();
						$bookMapper = new Reservation_Model_ReservationDataMapper();
						$unformatArray = array();
						$reservResult = $resService->getReservationsMobile($request);
						$waitingListRes = $bookMapper->getWaitingList($getWaitingList);
						$unformatArray = array_merge($reservResult['AttendingList'],$reservResult['CompletedList'],$waitingListRes);
						$createdTimes = array();
						$resultArr['AllList'] = $unformatArray;
						break;
						case 'reserv':
						$reservResult = $resService->getReservationsMobile($request);
						$resultArr['resvResult'] = $reservResult['AttendingList'];
						break;
						case 'completed':
						$reservResult = $resService->getReservationsMobile($request);
						$resultArr['compResult'] = $reservResult['CompletedList'];
						break;
					}
				}
				echo json_encode($resultArr);
			}
			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function waitlistandroidAction()
	{
		try{
			
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$resultArr = array(); 
			$date = '';
			header('Content-type: application/json');
			if($request->restaurantid){
				$timeZone = $this->_firmService->GetRestaurantTimeZone($request->restaurantid);
				date_default_timezone_set($timeZone);
				if(isset($request->date)){
					$date = $request->date;
				}else{
					$date = date('Y-m-d');
				}
			/* Reteriving Table layout start */

				$diningidArr = array();
				$diningAreaArr = array();
				$diningMapper = new FirmManagement_Model_FirmDiningAreaDataMapper();
				$Diningresult = $diningMapper->getDinigAreasByRestId($request->restaurantid);
//				foreach($Diningresult as $dining){
//					$diningidArr[] = $dining->rdaid;
//				}
//				$diningid = $diningidArr[0];
				$diningArr = array();
				foreach($Diningresult as $din){
					$diningArr[] = array('diningname' => $din->rda_diningname,
										 'diningid' => $din->rdaid);
				}
				$resultArr['diningareas'] = $diningArr;
			
			/* Reteriving Waiting list start */

				$getWaitingList = new Reservation_Model_GetWaitingList();
				$getWaitingList->setRestaurantId($request->restaurantid);
				$getWaitingList->setDate($date);
				$getWaitingList->setIsAjaxCall(true);
				/* Reteriving booking status id by code */
				$status = array();
	
				$bookStatus = array('WAL','READY','QUOTE','BAR','NEXT','CANCUS','BACK');
				$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
				$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
				$getWaitingList->setBookStatus($bookStatusRes);
				$waitnSortedArray = array();
				$bookMapper = new Reservation_Model_ReservationDataMapper();
				
				$waitingListRes = $bookMapper->getWaitingList($getWaitingList);
				$resultArr['WaitingList'] = $waitingListRes;
								
				echo json_encode($resultArr);
			}
			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function restmarketingandroidAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();			
			$restId = $request->restaurantid;
			$userid = $request->userid;
			header('Content-type: application/json');
		//	$countrycodeMap = new Reservation_Model_ReservationDataMapper();
		//	$countrycode = $countrycodeMap->getRestaurantLocByResId($restId);
			//if($countrycode->state == 'IND'){
			if(true){
				if($this->getRequest()->isPost()){
			       	$data = $this->getRequest()->getPost();	
			       	$userData = array();
			       	$userData['RestId'] = $restId;
			       	$userData['User_Id'] = $userid;
			       	//coma seperated ids
			       	$groupIds = $data['campGroupIds'];
			       	$data['campGroupId'] = explode(',',$groupIds);
					$status = $this->_firmService->sendSmsCampaignWithRdLabs($data,$userData);
					if($status){
						echo json_encode("congrats");
					}else{
						echo json_encode("false");
					}		       				       		
				}					
			}else{
				echo json_encode("nocountry");
			}				
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getleftmessagecountandroidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			header('Content-type: application/json');
			$resultArr = array();
			$restId = $request->restaurantid;
			if($request){				
				$leftmessageMapper = new FirmManagement_Model_SmsRestaurantCampCountDataMapper();
				$leftmessage = 	$leftmessageMapper->getLeftMessagesCountByResid($restId);	
				if($leftmessage){
					if($leftmessage != 'noaccess'){
						$resultArr['leftmessage'] = $leftmessage; 
					}
				}else{
					$resultArr['leftmessage'] = 0;
				}
				// FETCH ONLY PHONE NUMBER COUNT
				$countOfNumbers = $this->_firmService->getPoneNumbersCountByResid($restId);
				$resultArr['phonenumCount'] = intval($countOfNumbers);
				$resultArr['phonenum'] = 0;

				$campTypesArr = array();
				$campTypesArr[] = array('type_id'=>1,'title'=>'Send to all contacts');
				$campTypesArr[] = array('type_id'=>2,'title'=>'Send to specific groups');
				$resultArr['camp_types'] = $campTypesArr;
				$contactGroups = $this->_firmService->getContactGroupsByResId($restId);
				$resultArr['contact_groups'] = $contactGroups;
				echo json_encode($resultArr);
			}else{
				echo json_encode(false);
			}
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function managereservoperationsandroidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			header('Content-type: application/json');
			$auth = Zend_Auth::getInstance();
			$storage = new Zend_Auth_Storage_Session();
			$userid = $request->userid;
			if($auth->hasIdentity())
			{
				
				$userid = $request->userid;
				$userdata = $storage->read();
				if(!is_array($userdata))
				{
					$userdata = array();
				}
				$userdata['User_Id'] = $userid;
				$userdata['Type'] = 'Res';
				$storage->write($userdata);
			}
			else
			{
				$userid = $request->userid;
				$userdata = array();
				$userdata['User_Id'] = $userid;
				$userdata['Type'] = 'Res';
				$storage->write($userdata);
			}
			if($request){
				$status = '';				
				if($request->type == "guestarrived"){
					$status = $this->_reservationService->ManageCheckedInResv($request);
				}else if($request->type == "partiallyarrived"){
					$status = $this->_reservationService->ManagePartialArrivedResv($request);
				}else if($request->type == "allarrived"){
					$status = $this->_reservationService->ManageAllArrivedResv($request);
				}else if($request->type == "cominglate"){
					$status = $this->_reservationService->ManageRunningLateResv($request);
				}else if($request->type == "confirmreserv"){
					$status = $this->_reservationService->changeBokConfirmStatus($request);
				}else if($request->type == "clearstatus"){
					$status = $this->_reservationService->ClearReservationStatus($request);
				}else if($request->type == "completed"){
					$userid = $request->userid;
					$status = $this->_android->ChangeTableStatus($request,$userid);
				}else if($request->type == "cancel"){
					$status = $this->_reservationService->ChangeTableStatusToCan($request);
				}else if($request->type == "PREALLOC"){
					$userid = $request->userid;
					$status = $this->_android->PreAllocateSeat($request, $userid);
				}else if($request->type == "SEATED"){
					$userid = $request->userid;
					$status = $this->_android->AllocateSeat($request, $userid);
				}else if($request->type == "PARTSEATED"){
					$userid = $request->userid;
					$status = $this->_android->PartiallyAllocateSeat($request, $userid);
				}else if($request->type == "Ready"){
					$userid = $request->userid;
					$status = $this->_android->ChangeTableStatus($request, $userid);
				}else if($request->type == "CancleCom"){
					$status = $this->_reservationService->cancelCompletion($request);
				}else if($request->type == "changewait"){
					$result = $this->_reservationService->ChangeWaitingTime($request);
					if($result){
						$userid = $request->userid;
						$status = $this->_android->ChangeTableStatus($request, $userid);
					}else{
						echo json_encode(false);
					}
				}else if($request->type == "tableOp"){
					$userid = $request->userid;
					$status = $this->_android->ChangeTableStatus($request,$userid);
				}else if($request->type == "MOV"){
					$status = $this->_reservationService->MoveParty($request);
				}
				if($status){
					echo json_encode(true);
				}else{
					echo json_encode(false);
				}
			}else{
				echo json_encode(false);
			}
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function gettablesoffloorbydiningidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$resultStr = $this->_android->GetLayoutByDiningIdMobile($request);
			$resultarr = array();
			if($resultStr){
				$resultarr["diningtables"] = $resultStr;
				echo json_encode($resultarr);
			}else{
				echo json_encode(false);
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function retreivetimesforwaitingAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
		
			$request = $this->getRequest();
			$result = $this->_reservationService->GetWaitingTimes($request);
			if($result){
				echo json_encode(array("times"=>$result));
			}else{
				echo json_encode(false);
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function bookareservationuploadAction()
	{
		try{

			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest(); 
			header('Content-type: application/json');
			if($request){
			$data = file_get_contents('php://input');
			$formDatas = json_decode($data, true); 
			foreach($formDatas as $formData){ 
			$result = $this->_android->MakeReservationAndroid($formData); 
			} 
			if($result['status']){
			echo json_encode(true); 
			}else{
			echo json_encode(false);
			}
			}else{
			echo json_encode(false);
			}
		}
			catch(Exception $ex){
		throw new Exception($ex->getMessage()) ;
		}
	}
}
