<?php
class Communication_Form_CommunicationCreation extends Zend_Form
{

    public function init()
    { 	
    	
    	$mapper = new Application_Model_PriorityDataMapper();
    	$prioritys = $mapper->fetchAll();
   		$priorityList = array();  
    	$priorityList[] = array('key'=>'','value'=>'Select Priority');  	   
    	foreach($prioritys as $priority){
    		$priorityList[] = array('key'=>$priority->getCode(),'value'=>$priority->getDescription());
    	}
    	
    	$typemapper = new Application_Model_EmailTypeDataMapper();
    	$emailtypes = $typemapper->fetchAll();
   	 	$emailtypeList = array();  
    	$emailtypeList[] = array('key'=>'','value'=>'Select Type');  	   
    	foreach($emailtypes as $emailtype){
    		$emailtypeList[] = array('key'=>$emailtype->getCode(),'value'=>$emailtype->getDescription());
    	}
		
    	$id = $this->createElement('hidden','id');
    	$id->removeDecorator('HtmlTag')
    	   ->removeDecorator('Label');
    	
    	$Title = $this->createElement('text', 'Title');
      	$Title->removeDecorator('Label')
      	      ->removeDecorator('HtmlTag')
      	      ->setAttrib('maxlength', '100')
      	      ->setAttrib('class','inp1 required')
      	      ->addFilters(array('StringTrim'))
      	      ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter Title.')),
      	      				array('StringLength', false,array(1,100,'messages' => array(
              				Zend_Validate_StringLength::TOO_LONG => 'Title is too long(>100).'
              			)))))
      	      ->setValue('')
      	      ->setRequired(true);
		
  		$Description = $this->createElement('textarea', 'Description');
		$Description->removeDecorator('Label')
		            ->removeDecorator('HtmlTag')                	   
                	->setAttrib('cols', '40')
			        ->setAttrib('rows', '4')
			        ->setAttrib('class','inp1 required')              
                	->setValue('')              
                	->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Description.')),
			        		))
			        ->setRequired(true);
			        
		$emailPriority = $this->createElement('select','emailPriority');
        $emailPriority->removeDecorator('Label') 
         		  ->removeDecorator('HtmlTag')
         		  ->setAttrib('class','sel1 drpDown required')
         		  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select Priority.'))))       	   
               	  ->addMultiOptions($priorityList)
                  ->setRequired(true);
                  
        $emailtype = $this->createElement('select','emailtype');
        $emailtype->removeDecorator('Label') 
         		  ->removeDecorator('HtmlTag')
         		  ->setAttrib('class','sel1 drpDown required')
         		  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select EmailType.'))))       	   
               	  ->addMultiOptions($emailtypeList)
                  ->setRequired(true);

        $document = $this->createElement('file','document');
		$document->removeDecorator('Label')
			     ->removeDecorator('HtmlTag')
			     ->setAttrib('class','inp1')			     
			     ->setRequired(false)
			     ->addValidator('FilesSize', false, array('min' => '1kB', 'max' => '100kB'))
			     ->addValidator('Extension', false, 'docx,dot,dotx,doc,dotm,txt,rtf,pdf,ppt,pptx,pps,ppsx,xls,xlsx');
                  
        $signature = $this->createElement('textarea', 'signature');
		$signature->removeDecorator('Label')
		            ->removeDecorator('HtmlTag')                	   
                	->setAttrib('cols', '40')
			        ->setAttrib('rows', '4')
			        ->setAttrib('class','inp1 required')              
                	->setValue('Thanks,
                				DineDesk.')              
                	->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Description.')),
			        		))
			        ->setRequired(true);
			        
		
			        
		$this->addElements(array($Title,
								 $Description,
								 $emailPriority,
								 $emailtype,
								 $id,
								 $document,
								 $signature	 							
						));
    	
    }
}