<?php
class Communication_Model_BookingOtp
{
	private $_bok_otp_id;
	private $_bok_otp_val;
	private $_bok_otp_generated_date;
	private $_bok_otp_generated_time;
	private $_bok_otp_status;
	private $_bok_otp_expiry_time;
	
	public function __construct(array $options = null)
	{
		if(is_array($options)){
			$this->setOptions($options);
		}		
	}
	
	public function __set($name, $value)
	{
		$method = 'set' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid BookingOtp property');
		}
		$this->$method($value);
	}
	
	public function __get($name)
	{
		$method = 'get' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid BookingOtp property');
		}
		return $this->$method();
	}
	
	public function setOptions(array $options)
	{
		$methods = get_class_methods($this);
		foreach ($options as $key => $value) {
			$method = 'set' . ucfirst($key);
			if (in_array($method, $methods)) {
				$this->$method($value);
			}
		}
		return $this;
	}
	
	
	public function setbok_otp_id($bok_otp_id)
	{
		$this->_bok_otp_id = $bok_otp_id;
		return $this;
	}
	
	public function getbok_otp_id()
	{
		return $this->_bok_otp_id;
	}
	
	public function setbok_otp_val($bok_otp_val)
	{
		$this->_bok_otp_val = $bok_otp_val;
		return $this;
	}
	
	public function getbok_otp_val()
	{
		return $this->_bok_otp_val;
	}
	
	public function setbok_otp_generated_date($bok_otp_generated_date)
	{
		$this->_bok_otp_generated_date = $bok_otp_generated_date;
		return $this;
	}
	
	public function getbok_otp_generated_date()
	{
		return $this->_bok_otp_generated_date;
	}
	
	public function setbok_otp_generated_time($bok_otp_generated_time)
	{
		$this->_bok_otp_generated_time = $bok_otp_generated_time;
		return $this;
	}
	
	public function getbok_otp_generated_time()
	{
		return $this->_bok_otp_generated_time;
	}
	
	public function setbok_otp_expiry_time($bok_otp_expiry_time)
	{
		$this->_bok_otp_expiry_time = $bok_otp_expiry_time;
		return $this;
	}
	
	public function getbok_otp_expiry_time()
	{
		return $this->_bok_otp_expiry_time;
	}
	
	public function setbok_otp_status($bok_otp_status)
	{
		$this->_bok_otp_status = $bok_otp_status;
		return $this;
	}
	
	public function getbok_otp_status()
	{
		return $this->_bok_otp_status;
	}
}