<?php
class Communication_Model_BookingOtpMapper
{	
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Communication_Model_DbTable_BookingOtp');
		}
		return $this->_dbTable;
	}
	
	public function SaveOtpGeneration(Communication_Model_BookingOtp  $BookingOtp)
	{
		try{
			$data = array(
						'bok_otp_id'				=>	$BookingOtp->getbok_otp_id(),
					  	'bok_otp_val'				=>	$BookingOtp->getbok_otp_val(),
					  	'bok_otp_generated_date'	=>	$BookingOtp->getbok_otp_generated_date(),
					  	'bok_otp_generated_time'	=>	$BookingOtp->getbok_otp_generated_time(),
						'bok_otp_expiry_time'		=>	$BookingOtp->getbok_otp_expiry_time(),
					  	'bok_otp_status'			=>	$BookingOtp->getbok_otp_status()
					);
		
			$otpTable = $this->getDbTable();
			$otpid = $otpTable->insert($data);
			return $otpid;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function UpdateOtpDetails(Communication_Model_BookingOtp  $BookingOtp)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$table  = $this->getDbTable();
			$set = array(		
						'$BookingOtp->getbok_otp_status()'		=>	false
					);
			$where = $db->quoteInto('bok_otp_id = ?',$BookingOtp->getbok_otp_id());
			$table->update($set,$where);			
			return true;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function ValidateBookingOtp($otpid,$otptext)
	{
		try{
			$otpTable = $this->getDbTable();
			$select = $otpTable->select();
			$select->from($otpTable,array('bok_otp_id','bok_otp_val','bok_otp_generated_date','bok_otp_generated_time','bok_otp_status'))
					->where('bok_otp_id = ?',$otpid)
					->where('bok_otp_val = ?',$otptext)
					->where('bok_otp_generated_date = ?',date('Y-m-d'))
					->where('bok_otp_expiry_time >= ?',date('H:i:s'))
					->where('bok_otp_status = ?',true);
			$result = $otpTable->fetchRow($select);
			return $result;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}