<?php
class Communication_Model_CommunicationContent
{
	private $_id;
	private $_desc;
	private $_restid;
	private $_cretedby;
	private $_creteddate;
	private $_updatedby;
	private $_updateddate;
	private $_status;
	
	public function __construct(array $options = null)
	{
		if(is_array($options)){
			$this->setOptions($options);
		}		
	}
	
	public function __set($name, $value)
	{
		$method = 'set' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid City_BD property');
		}
		$this->$method($value);
	}
	
	public function __get($name)
	{
		$method = 'get' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid State_BD property');
		}
		return $this->$method();
	}
	
	public function setOptions(array $options)
	{
		$methods = get_class_methods($this);
		foreach ($options as $key => $value) {
			$method = 'set' . ucfirst($key);
			if (in_array($method, $methods)) {
				$this->$method($value);
			}
		}
		return $this;
	}
	
	public function setid($id)
	{
		$this->_id = $id;
		return $this;
	}
	
	public function getid()
	{
		return $this->_id;
	}
	
	public function setdesc($desc)
	{
		$this->_desc = $desc;
		return $this;
	}
	
	public function getdesc()
	{
		return $this->_desc;
	}
	
	public function setrestid($restid)
	{
		$this->_restid = $restid;
		return $this;
	}
	
	public function getrestid()
	{
		return $this->_restid;
	}
	
	public function setcretedby($cretedby)
	{
		$this->_cretedby = $cretedby;
		return $this;
	}
	
	public function getcretedby()
	{
		return $this->_cretedby;
	}
	
	public function setcreteddate($creteddate)
	{
		$this->_creteddate = $creteddate;
		return $this;
	}
	
	public function getcreteddate()
	{
		return $this->_creteddate;
	}
	
	public function setupdatedby($updatedby)
	{
		$this->_updatedby = $updatedby;
		return $this;
	}
	
	public function getupdatedby()
	{
		return $this->_updatedby;
	}
	
	public function setupdateddate($updateddate)
	{
		$this->_updateddate = $updateddate;
		return $this;
	}
	
	public function getupdateddate()
	{
		return $this->_updateddate;
	}
	
	public function setstatus($status)
	{
		$this->_status = $status;
		return $this;
	}
	
	public function getstatus()
	{
		return $this->_status;
	}	
}