<?php
class Communication_Model_CommunicationContentDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Communication_Model_DbTable_CommunicationContent');
		}
		return $this->_dbTable;
	}
	
	public function AddNotifcationContent(Communication_Model_CommunicationContent $obj)
	{
		try{
			$data = array(
						'ncfk_restaurant'	=> $obj->getrestid(),
						'ncdescription'		=> $obj->getdesc(),
						'nccreated_by'		=> $obj->getcretedby(),
						'nccreated_datetime'=> $obj->getcreteddate(),
						'ncstatus'			=> $obj->getstatus()
					);			
			
			$id = $this->getDbTable()->insert($data);
			if($id){
				return $id;
			}else{
				return false;
			}			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function UpdateNotifcationContent(Communication_Model_CommunicationContent $obj)
	{
		try{
			$status = '';
			$table = $this->getDbTable();
			$set = array(
						'ncdescription'		=> $obj->getdesc(),
						'ncupdated_by'		=> $obj->getupdatedby(),
						'ncupdated_datetime'=> $obj->getupdateddate()
					);			
			
			$where = array('ncid = ?'=> $obj->getid());
			$status = $table->update($set,$where);
			if($status){
				return $status;
			}else{
				return false;
			}				
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getNotificationContentByResid($resid, $id)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->from(array('mt.notifcation_content'),array('ncid','ncdescription','ncstatus'))
				   ->where('ncfk_restaurant = ?',$resid);
			if($id){
				$select->where('ncid = ?',$id);
			}
			
			$rowSet = $table->fetchRow($select);
			return $rowSet;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function ChangeNotificationContentStatus(Communication_Model_CommunicationContent $obj)
	{
		try{
			$status = '';
			$table = $this->getDbTable();
			$set = array('ncstatus'			=> $obj->getstatus(),
						'ncupdated_by'		=> $obj->getupdatedby(),
						'ncupdated_datetime'=> $obj->getupdateddate()
					);
			$where = array('ncid = ?'=> $obj->getid());
			$status = $table->update($set,$where);
			if($status){
				return $status;
			}else{
				return false;
			}	
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	
}