<?php
class Communication_Model_EmailRestRecipentsDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Communication_Model_DbTable_EmailRestRecipents');
		}
		return $this->_dbTable;
	}
	
	public function SaveUserEmails($request,$result,$campaignId)
	{
		$db = Zend_Db_Table::getDefaultAdapter();
		$Table		= $this->getDbTable();
		$msgid 		= $request->messageid;
		$stateid 	= $request->stateid;
		$cityid 	= $request->cityid;
		$usertype 	= $request->usrtype;
	
		$statemapper = new Application_Model_StateDataMapper();
		$statecitymapper = new Application_Model_StateCityMapDataMapper();
		$Emailstatemapper = new Communication_Model_EmailStateDataMapper();
		$Emailcitymapper = new Communication_Model_EmailCityDataMapper();
		try{
			$db->beginTransaction();
			if($stateid == "" && $cityid == ""){
				$states = $statemapper->fetchAll();
				foreach($states as $state){
					$resultset = $statecitymapper->getCityByStateId($state->getId());
					$statedata = array(
								'est_messageid'		=>	$msgid,
								'est_stateid' 		=>	$state->getId()
							);
					$id = $Emailstatemapper->getDbTable()->insert($statedata);
					foreach($resultset as $value){
						$citydata = array(
							'emc_emailstateid'	=> $id,
							'emc_cityid'		=> $value->city_id
						);
						$Emailcitymapper->getDbTable()->insert($citydata);
					}
				}
			}else if($stateid != "" &&$cityid == ""){
				$resultset = $statecitymapper->getCityByStateId($stateid);
				$statedata = array(
							'est_messageid'		=>	$msgid,
							'est_stateid' 		=>	$stateid
						);
				$id = $Emailstatemapper->getDbTable()->insert($statedata);
				foreach($resultset as $value){
					$citydata = array(
						'emc_emailstateid'	=> $id,
						'emc_cityid'		=> $value->city_id
					);
					$Emailcitymapper->getDbTable()->insert($citydata);
				}
			}else{
				$statedata = array(
								'est_messageid'		=>	$msgid,
								'est_stateid' 		=>	$stateid
							);
				$id = $Emailstatemapper->getDbTable()->insert($statedata);
				$citydata = array(
					'emc_emailstateid'	=> $id,
					'emc_cityid'		=> $cityid
				);
				$Emailcitymapper->getDbTable()->insert($citydata);
			}			
			$msgmapper = new Communication_Model_EmailMessageDataMapper();
			if($campaignId){
				$set = array('emsg_email_users' => $usertype,
							 'emsg_campaignid'	=>	$campaignId,
							 'emsg_notificationtype'=> 1		
							);
			}else{
				$set = array('emsg_email_users' => $usertype,
							 'emsg_notificationtype'=> 1
						);
			}				
				$where = array('emsg_id = ?'=>$msgid);
				$msgmapper->getDbTable()->update($set,$where);
			
			$emailIds = array();
			$primaryArr = $result['primary'];
			$secArr = $result['secondary'];
			foreach($primaryArr as $key=>$value){
				$emailIds[] = $value;
				$cusdata = array(
					'err_restid' 	=>	$key,
					'err_emailid'	=>	$value,
					'err_msgid'		=>  $msgid,
					'err_senton'	=>	date('Y-m-d')
				);
				$Table->insert($cusdata);
			}			
			foreach($secArr as $key=>$value){
				
				$res = '';
				$emailIds[] = $value;
				$val = explode('-',$key);
				$res = $val[0];
				
				$cusdata = array(
					'err_restid' 	=>	$res,
					'err_emailid'	=>	$value,
					'err_msgid'		=>  $msgid,
					'err_senton'	=>	date('Y-m-d')
				);
				$Table->insert($cusdata);
			}			
			$db->commit();
			return $emailIds;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function SaveRestMailDetails($msgid,$stateid,$cityid,$usertype,$campaignId,$email)
	{
		$db = Zend_Db_Table::getDefaultAdapter();
		$Table		= $this->getDbTable();
	
		$statemapper = new Application_Model_StateDataMapper();
		$statecitymapper = new Application_Model_StateCityMapDataMapper();
		$Emailstatemapper = new Communication_Model_EmailStateDataMapper();
		$Emailcitymapper = new Communication_Model_EmailCityDataMapper();
		try{
			$db->beginTransaction();
			if($stateid == "" && $cityid == ""){
				$states = $statemapper->fetchAll();
				foreach($states as $state){
					$resultset = $statecitymapper->getCityByStateId($state->getId());
					$statedata = array(
								'est_messageid'		=>	$msgid,
								'est_stateid' 		=>	$state->getId()
							);
					$id = $Emailstatemapper->getDbTable()->insert($statedata);
					foreach($resultset as $value){
						$citydata = array(
							'emc_emailstateid'	=> $id,
							'emc_cityid'		=> $value->city_id
						);
						$Emailcitymapper->getDbTable()->insert($citydata);
					}
				}
			}else if($stateid != "" &&$cityid == ""){
				$resultset = $statecitymapper->getCityByStateId($stateid);
				$statedata = array(
							'est_messageid'		=>	$msgid,
							'est_stateid' 		=>	$stateid
						);
				$id = $Emailstatemapper->getDbTable()->insert($statedata);
				foreach($resultset as $value){
					$citydata = array(
						'emc_emailstateid'	=> $id,
						'emc_cityid'		=> $value->city_id
					);
					$Emailcitymapper->getDbTable()->insert($citydata);
				}
			}else{
				$statedata = array(
								'est_messageid'		=>	$msgid,
								'est_stateid' 		=>	$stateid
							);
				$id = $Emailstatemapper->getDbTable()->insert($statedata);
				$citydata = array(
					'emc_emailstateid'	=> $id,
					'emc_cityid'		=> $cityid
				);
				$Emailcitymapper->getDbTable()->insert($citydata);
			}			
			$msgmapper = new Communication_Model_EmailMessageDataMapper();
			if($campaignId){
				$set = array('emsg_email_users' => $usertype,
							 'emsg_campaignid'	=>	$campaignId,
							 'emsg_notificationtype'=> 0		
							);
			}else{
				$set = array('emsg_email_users' => $usertype,
							 'emsg_notificationtype'=> 0
						);
			}				
				$where = array('emsg_id = ?'=>$msgid);
				$msgmapper->getDbTable()->update($set,$where);
			if(is_array($email) ){
				for($i = 0; $i < count($email); $i++){
					$cusdata = array(
					'err_emailid'	=>	$email[$i],
					'err_msgid'		=>  $msgid,
					'err_senton'	=>	date('Y-m-d')
					);
					$Table->insert($cusdata);
				}
			}else{
				$cusdata = array(
				'err_emailid'	=>	$email,
				'err_msgid'		=>  $msgid,
				'err_senton'	=>	date('Y-m-d')
				);
				$Table->insert($cusdata);
			}
			$db->commit();
			return true;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function SaveRestEmailandStatus($resid,$email,$msgid,$status)
	{
		try{
			$Table	= $this->getDbTable();
			$data = array(
					'err_restid' 		=>	$resid,
					'err_emailid'		=>	$email,
					'err_msgid'			=>  $msgid,
					'err_senton'		=> 	date("Y-m-d"),
					'err_emailstatus'	=>	$status
				);
			$id = $Table->insert($data);
			return $id;	
		}catch (Exception $ex){	
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	
	public function getNotificationsById($ids)
	{
		try{
			$Table	= $this->getDbTable();
			$select = $Table->select();
			$select->setIntegrityCheck(false);
			$select->from(array('err'=>'mt.email_restaurant_recipents'),array('err_senton'))
				   ->join(array('msg'=>'mt.email_message'),'msg.emsg_id = err.err_msgid',array('emsg_subject','emsg_msg_phrase'))
				   ->where('err.err_restid IN(?)',$ids);
			$result = $Table->fetchAll($select);
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getSentDetailsByMsgid($request)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$result = array();
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			
			$count = null;
			if($request->msgid){
				$count = $this->GetCountById($request->msgid);
			}
			if($count > 0){
					$offset = 0;
				$limit = 50;
			
				/* Reteriving the previous offset */
				if($request->offset && $request->offset != 0){
					$offset = $request->offset;
				}
				/* If next link or arrow is clicked this if condition is executed. */
				if($request->event == 'next'){
		
					if($count >= $offset + 50){
		
						$offset = $offset + 50;
		
						if($offset + 50 >= $count){
							$result['next'] = false;
						}else{
							$result['next'] = true;
						}
					}
					if($offset >= 50){
						$result['prev'] = true;
					}
		
				}/* if previous link is clicked this if condition is executed. */
				elseif($request->event == 'prev'){
		
					$offset = $offset - 50;
		
					if($offset == 0 || $offset < 50){
						$result['prev'] = false;
					}else{
						$result['prev'] = true;
					}
					if($count > $offset){
		
						$result['next'] = true;
					}
		
				}/* This else part is executed on first call of this function. */
				else{
					if($count > 50){
						/* if count is greater than 50 show the next link */
						$result['next'] = true;
						$result['prev'] = false;
					}else{
						/* if count is less than 50 then no links are shown. */
						$result['next'] = false;
						$result['prev'] = false;
					}
		
				}
				
				$result['offset'] = $offset;
				
				$select->from(array('err'=>'mt.email_restaurant_recipents'),array('err_emailid'))
					   ->join(array('emsg'=>'mt.email_message'),'emsg.emsg_id = err.err_msgid',array('emsg_email_users'))
					   ->where('err.err_msgid = ?',$request->msgid);
				
				$select->limit($limit,$offset);
				$resultSet = $table->fetchAll($select);
				$result['UsersList'] = $resultSet;
				return $result;
			}else{
				return false;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}	
	}
	
	public function GetCountById($msgid)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			
			$select->from(array('err'=>'mt.email_restaurant_recipents'),array('count(errid) as mailcount'))
				   ->join(array('emsg'=>'mt.email_message'),'emsg.emsg_id = err.err_msgid',array())
				   ->where('err.err_msgid = ?',$msgid);
		
			$resultSet = $table->fetchAll($select);
			foreach($resultSet as $row){
					$count = $row->mailcount;
			}
			return $count;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
		
	}
	
	public function UpdateEmailStatus($emailid,$msgid)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$table = $this->getDbTable();
			$set = array(	'err_emailstatus' => 'SENT',
							'err_senton'	  => date('y-m-d')	
						);
			$where = array('err_msgid = ?'=>$msgid,
				 			'err_emailid = ?'=>$emailid
									);
			$table->update($set,$where);
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}	
	}
	
	public function SaveRestMailDetailsForFeedback($msgid,$usertype,$campaignId,$email)
	{
		$db = Zend_Db_Table::getDefaultAdapter();
		$Table		= $this->getDbTable();
	
		try{
			$msgmapper = new Communication_Model_EmailMessageDataMapper();
			if($campaignId){
				$set = array('emsg_email_users' => $usertype,
							 'emsg_campaignid'	=>	$campaignId,
							 'emsg_notificationtype'=> 0		
							);
			}else{
				$set = array('emsg_email_users' => $usertype,
							 'emsg_notificationtype'=> 0
						);
			}				
				$where = array('emsg_id = ?'=>$msgid);
				$msgmapper->getDbTable()->update($set,$where);
			if(is_array($email) ){
				for($i = 0; $i < count($email); $i++){
					$cusdata = array(
					'err_emailid'	=>	$email[$i],
					'err_msgid'		=>  $msgid,
					'err_senton'	=>	date('Y-m-d')
					);
					$Table->insert($cusdata);
				}
			}else{
				$cusdata = array(
				'err_emailid'	=>	$email,
				'err_msgid'		=>  $msgid,
				'err_senton'	=>	date('Y-m-d')
				);
				$Table->insert($cusdata);
			}
			return true;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}