<?php
class Communication_Model_ReplyNumberHistory
{
	private $_rnh_id;
	private $_rnh_number;
	private $_rnh_msg;
	private $_rnh_sent_on;
	private $_rnh_circle;
	private $_rnh_service;
	private $_rnh_status;
	
	public function __construct(array $options = null)
	{
		if(is_array($options)){
			$this->setOptions($options);
		}		
	}
	
	public function __set($name, $value)
	{
		$method = 'set' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid BookingOtp property');
		}
		$this->$method($value);
	}
	
	public function __get($name)
	{
		$method = 'get' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid BookingOtp property');
		}
		return $this->$method();
	}
	
	public function setOptions(array $options)
	{
		$methods = get_class_methods($this);
		foreach ($options as $key => $value) {
			$method = 'set' . ucfirst($key);
			if (in_array($method, $methods)) {
				$this->$method($value);
			}
		}
		return $this;
	}
	
	
	public function setrnh_id($rnh_id)
	{
		$this->_rnh_id = $rnh_id;
		return $this;
	}
	
	public function getrnh_id()
	{
		return $this->_rnh_id;
	}
	
	public function setrnh_number($rnh_number)
	{
		$this->_rnh_number = $rnh_number;
		return $this;
	}
	
	public function getrnh_number()
	{
		return $this->_rnh_number;
	}
	
	public function setrnh_msg($rnh_msg)
	{
		$this->_rnh_msg = $rnh_msg;
		return $this;
	}
	
	public function getrnh_msg()
	{
		return $this->_rnh_msg;
	}
	
	public function setrnh_sent_on($rnh_sent_on)
	{
		$this->_rnh_sent_on = $rnh_sent_on;
		return $this;
	}
	
	public function getrnh_sent_on()
	{
		return $this->_rnh_sent_on;
	}
	
	public function setrnh_service($rnh_service)
	{
		$this->_rnh_service = $rnh_service;
		return $this;
	}
	
	public function getrnh_service()
	{
		return $this->_rnh_service;
	}
	
	public function setrnh_circle($rnh_circle)
	{
		$this->_rnh_circle = $rnh_circle;
		return $this;
	}
	
	public function getrnh_circle()
	{
		return $this->_rnh_circle;
	}
	
	public function setrnh_status($rnh_status)
	{
		$this->_rnh_status = $rnh_status;
		return $this;
	}
	
	public function getrnh_status()
	{
		return $this->_rnh_status;
	}
}