<?php
class Communication_Model_ReplyNumberHistoryMapper
{	
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Communication_Model_DbTable_ReplyNumberHistory');
		}
		return $this->_dbTable;
	}
	
	public function SaveReplyNumberHistory(Communication_Model_ReplyNumberHistory  $ReplyNumberHistory)
	{
		try{
			$data = array(
						'rnh_id'				=>	$ReplyNumberHistory->getrnh_id(),
						'rnh_number'			=>	$ReplyNumberHistory->getrnh_number(),
						'rnh_msg'				=>	$ReplyNumberHistory->getrnh_msg(),
						'rnh_sent_on'			=>	$ReplyNumberHistory->getrnh_sent_on(),
						'rnh_circle'			=>	$ReplyNumberHistory->getrnh_circle(),
						'rnh_service'			=>	$ReplyNumberHistory->getrnh_service(),
						'rnh_request_status'	=>	$ReplyNumberHistory->getrnh_status()
					);
		
			$replyTable = $this->getDbTable();
			$replyid = $replyTable->insert($data);
			return $replyid;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}