<?php
class DDApiService_ApiController extends Zend_Controller_Action
{	
	protected $_ApiService = null;	
	
	public function init()
	{
		$this->_helper->layout->disableLayout();
		$this->_helper->viewRenderer->setNoRender();
		$this->_ApiService = new Application_Service_ApiService();
		header('Content-type: application/json');
	}
	
	public function validateuserAction()
	{
		try
		{
			$request = $this->getRequest();			
			$loginRes = $this->_ApiService->ValidateLogin($request);
		
			 if($loginRes['Status']){
				
				echo json_encode(array(
					   'restaurantownertabledata'	=>	$loginRes['restaurantownertabledata'],
					   'usertabledata'				=>	$loginRes['usertabledata'],
					   'restauranttabledata'		=>	$loginRes['restaurantdata'],
					   'restaurantusersdata'		=>	$loginRes['restaurantusersdata'],					   
					   'roletabledata'				=>	$loginRes['roletabledata'],
					   'rolemaptabledata'			=>	$loginRes['rolemaptabledata'],
					   'statebasedata'				=>	$loginRes['statebasedata'],
					   'regionbasedata'				=>	$loginRes['regionbasedata'],
					   'stateregionmapdata'			=>	$loginRes['stateregionmapdata'],
					   'citybasedata'				=>	$loginRes['citybasedata'],
					   'regioncitymapdata'			=>	$loginRes['regioncitymapdata'],
					   'neighborhoodbasedata'		=>	$loginRes['neighborhoodbasedata'],
					   'restsuperuser'				=>  $loginRes['superuser'],					 
					));
			}else if($loginRes['Status'] == "error"){
				echo json_encode($loginRes["Msg"]);
			}
						
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	/* Retrieval Action For Tablet */
	
	public function restaurantmenuAction()
	{
		try
		{
			$request = $this->getRequest();	
			$result = $this->_ApiService->RetrieveRestMenu($request);
			echo json_encode($result);
			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}

	public function restauratfeedbackAction()
	{
		try
		{
			$request = $this->getRequest();	
			$result = $this->_ApiService->RetrieveFeedBackQuestionByRestId($request);
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function restwaitquotetimesAction()
	{
		try
		{
			$request = $this->getRequest();	
			$result = $this->_ApiService->RetrieveRestWaitQuoteTimesByResId($request);
			echo json_encode($result);
			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function syncrestcontactsAction()
	{
		try
		{
			$request = $this->getRequest();	
			$result = $this->_ApiService->GetRestContactGroupsByRestId($request);
			echo json_encode($result);	
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function syncfloorplanAction()
	{
		try
		{
			$request = $this->getRequest();	
			$result = $this->_ApiService->GetRestFloorPlan($request);
			echo json_encode($result);
			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function syncrestmealsettingsAction()
	{
		try
		{
			$request = $this->getRequest();	
			$result = $this->_ApiService->GetRestMealTypes($request);
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function syncschedulesAction()
	{
		try
		{
			$request = $this->getRequest();	
			$result = $this->_ApiService->GetRestSchedules($request);
			echo json_encode($result);			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function syncfreezedataAction()
	{
		try
		{
			$request = $this->getRequest();	
			$result = $this->_ApiService->GetFreezeData($request);
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function syncrestbookingsAction()
	{
		try
		{
			$request = $this->getRequest();	
			$result = $this->_ApiService->GetRestBookings($request);
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}	
	}
	
	public function syncrestusersAction()
	{
		try
		{
			$request = $this->getRequest();	
			$result = $this->_ApiService->GetRestaurantUsers($request);
			echo json_encode($result);
			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	/* Save Data From Tablet to Native Actions */
	
	public function savefeedbackAction()
	{
		try
		{
			$data = file_get_contents('php://input');		
			$result = $this->_ApiService->SaveCustomrFeedBack($data);
			echo json_encode($result);				
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function savewaitreservationAction()
	{
		try
		{
			$data = file_get_contents('php://input');
			$result = $this->_ApiService->SaveWatingReservtions($data);
			echo json_encode($result);
			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function savetabletnewbookingsAction()
	{
		try
		{
			$data = file_get_contents('php://input');
			$result = $this->_ApiService->SaveTabletBookingsToWeb($data);
			echo json_encode($result);
			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function savetabletchangestatusbookingsAction()
	{
		try
		{
			$data = file_get_contents('php://input');
			
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}

	/* DD Desktop App Actions */
	
	public function restaurantsynchronizationAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			//header('Content-type: application/json');
			$result = $this->_ApiService->RestaurantSynchronization($request);
			echo json_encode($result);
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function retrieveupdatedfloorplanfromwebAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();			
			$result = $this->_ApiService->retrieveUpdatedFloorPlanFromWeb($request);
			echo json_encode($result);
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function retrieveupdatedschedulesfromwebAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_ApiService->retrieveUpdatedSchedulesFromWeb($request);
			echo json_encode($result);
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function migratebookingsAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_ApiService->MigrateBookings($request);
			echo json_encode($result);
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function migratingchangestatusreservationstowebAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_ApiService->MigratingChangeStatusReservationsToWeb($request);
			if(empty($result))
			{
				echo 'false';
			}else{
				echo json_encode($result);
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function bookingwebsyncAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_ApiService->BookingWebSync($request);
			if($result){
				echo json_encode($result);
			}else{
				echo json_encode(array('result'=>'f'));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function retrievechangestatusreservationsfromwebAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_ApiService->syncBookingStatusChange($request);
			if(empty($result))
			{
				echo 'false';
			}else{
				echo json_encode($result);
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}	
	
	public function retrievewaitingreservationschatfromwebAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_ApiService->retrieveWaitingReservationsChatFromWeb($request);
			if(empty($result))
			{
				echo 'false';
			}else{
				echo json_encode($result);
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function migratecontactsAction()
	{
		try{
			
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();			
			$result = $this->_ApiService->MigrateCustContactsFromNativeToWeb($request);
			echo json_encode($result);
			
		}catch(Exception $ex){			
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getsuperuserbyowneridAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_ApiService->getAllRestSuperUsersByOwnerId($request);
			echo json_encode($result);
		}catch(Exception $ex){			
			throw new Exception($ex->getMessage()) ;
		}	
	}
	
	public function getserversbyrestidAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();			
			$result = $this->_ApiService->GetRestServersByRestId($request);
			echo json_encode($result);
		}catch(Exception $ex){			
			throw new Exception($ex->getMessage()) ;
		}	
	}
	
	public function migrateserversAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();		
			$result = $this->_ApiService->SaveNativeServersToWeb($request);
			echo json_encode($result);
		}
		catch(Exception $ex)
		{
			throw new Exception($ex->getMessage()) ;
		}	
	}
	
	
	public function migratechangeserversAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();			
			$result = $this->_ApiService->SaveChangeNativeServersToWeb($request);
			echo json_encode($result);
		}
		catch(Exception $ex)
		{
			throw new Exception($ex->getMessage());
		}	
	}
	
	public function retrievecontactsfromwebAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();			
			$result = $this->_ApiService->GetRestContactsListByRestId($request);
			echo json_encode($result);
		}
		catch(Exception $ex)
		{
			throw new Exception($ex->getMessage()) ;
		}	
	}

	public function retrieveupdatedschedulessettingfromwebAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_ApiService->retrieveUpdatedSchedulesSettingFromWeb($request);
			echo json_encode($result);
		}catch (Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function syncrestbookingsfortabletAction()
	{
		try
		{
			$request = $this->getRequest();	
			$result = $this->_ApiService->GetRestBookingsforTablet($request);
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}	
	}
	
	public function getsmscampaigndetailsbyresidAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();	
			$result = $this->_ApiService->GetSmsCampaignDetailsbyresId($request);
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}	
	}
	
	public function getreservationhistorybycusidAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();	
			$result = $this->_ApiService->getpastandfuturereservations($request);
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}	
	}
	
	public function savecontactsAction()
	{
		try
		{
			$data = file_get_contents('php://input');		
			$result = $this->_ApiService->SaveCustomrContacts($data);
			echo json_encode($result);				
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function feedbackreportfortabletAction()
	{
		try{		
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();	
			$request = $this->getRequest();		
			if($request->date){		
				$this->view->date = $request->date;
			}
			$result = $this->_ApiService->getFeedbackReportHistoryofRestaurant($request);
			echo json_encode($result);			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function quotetimesforipadAction()
	{
		try
		{
			$result = $this->_ApiService->RetrieveQuoteTimesBd();
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function getserversipadbyrestidAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_ApiService->GetRestServersForIpadByRestId($request);
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
		public function migrateserversipadAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$data = file_get_contents('php://input');		
			$result = $this->_ApiService->SaveNativeServersToWebFromIpad($data);
			echo json_encode($result);
		}
		catch(Exception $ex)
		{
			throw new Exception($ex->getMessage()) ;
		}	
	}
	
	
	public function migratechangeserversipadAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$data = file_get_contents('php://input');			
			$result = $this->_ApiService->SaveChangeNativeServersToWebFromIpad($data);
			echo json_encode($result);
		}
		catch(Exception $ex)
		{
			throw new Exception($ex->getMessage());
		}	
	}
	
	public function pickfirmblockedintervelsiosAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_ApiService->pickfirmblockedintervelsIpad($request);
			header('Content-type: application/json');
			if($result){
				echo json_encode($result);
			}else{
				echo "false";
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function syncrestquotetimesforipadAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$data = file_get_contents('php://input');		
			$result = $this->_ApiService->SaveQuoteTimesToWebFromIpad($data);
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}	
	}
	
	public function migratingchangestatusreservationstowebipadAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$data = file_get_contents('php://input');
			$result = $this->_ApiService->MigratingChangeStatusReservationsToWebfromipad($data);
			echo json_encode($result);
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getstatesforipadAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$result = $this->_ApiService->getStatesForIpad();
			echo json_encode($result);
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function savenewiosbookingsAction()
	{
		try
		{
			$data = file_get_contents('php://input');
			$result = $this->_ApiService->SavenewIosBookingsToWeb($data);
			echo json_encode($result['result']);
			$sreservice = new Application_Service_Reservation();
			$sreservice->sendIosEmails($result);
			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function validateuseriosAction()
	{
		try
		{
			$request = $this->getRequest();
      //echo '<pre>'; print_r($request); exit;
			$loginRes = $this->_ApiService->ValidateLoginForIos($request);
			
			if($loginRes['Status'] == "ok"){
				echo json_encode(array(
					   'restaurantownertabledata'	=>	$loginRes['restaurantownertabledata'],
					   'usertabledata'				=>	$loginRes['usertabledata'],
					   'restauranttabledata'		=>	$loginRes['restaurantdata'],
					   'restaurantusersdata'		=>	$loginRes['restaurantusersdata'],
					   'restsuperuser'				=>  $loginRes['superuser'],
					   'access_token'	=> $loginRes['access_token']   					 
					));
			}else if($loginRes['Status'] == "error"){
				echo json_encode($loginRes["Msg"]);
			}
						
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function restauratfeedbackiosAction()
	{
		try
		{
			$request = $this->getRequest();	
			$result = $this->_ApiService->RetrieveFeedBackQuestionByRestIdForIpad($request);
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function reservationreportsiosAction()
	{
		try
		{
			$request = $this->getRequest();	
			$result = $this->_ApiService->ReservationReportForIos($request);
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function getavailableslotsiosAction()
	{
		try
		{
			$request = $this->getRequest();	
			$result = $this->_ApiService->getavailableslotsipad($request);
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function getchangedserversforipadbyrestidAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_ApiService->GetChangedRestServersForIpadByRestId($request);
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getchangeduserdataiosAction()
	{
		try
		{
			
			$request = $this->getRequest();			
			$loginRes = $this->_ApiService->GetUpdatedUsersDataIos($request);
			
			echo json_encode(array(
					   'restaurantownertabledata'	=>	$loginRes['restaurantownertabledata'],
					   'usertabledata'				=>	$loginRes['usertabledata'],
					   'restauranttabledata'		=>	$loginRes['restaurantdata'],
					   'restaurantusersdata'		=>	$loginRes['restaurantusersdata'],
					   'restsuperuser'				=>  $loginRes['superuser']  					 
					));
						
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function syncchangedcontactsAction()
	{
		try
		{
			$request = $this->getRequest();	
			$result = $this->_ApiService->GetChangedRestContactsByRestId($request);
			echo json_encode($result);	
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function logipadexceptionAction()
	{
		try
		{
			$request = $this->getRequest();	
			$restaurantid = $request->restaurantid;
			$functionName = $request->function;
			$exReason = $request->exceptionreason;
			$exName = $request->exceptionname;
			Uss_Logger_FileLogger::info('Restaurant Id : '.$restaurantid . ' , Function Name : '.$functionName. ' , Exception Reason : ' .$exReason. ' Exception Name : ' . $exName);	
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function changedwaitquotetimesAction()
	{
		try
		{
			$request = $this->getRequest();	
			$result = $this->_ApiService->RetrieveChangedRestWaitQuoteTimesByResId($request);
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function savechangedcontactsAction()
	{
		try
		{
			$data = file_get_contents('php://input');		
			$result = $this->_ApiService->SaveChangedCustomrContacts($data);
			echo json_encode($result);				
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
    
    public function posordersyncAction()
    {
        try{
            $this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$data = file_get_contents('php://input');
			$result = $this->_ApiService->MigragePosOrders($data);
			echo json_encode($result);
        } catch (Exception $ex) {
            throw new Exception($ex->getMessage());
        }
    }
	/*Guest reports*/
	public function guestreportAction(){
		try{
			$request = $this->getRequest();
			$reservationService = new Application_Service_Reservation();
			$rest_result = $reservationService->GetReservationsForChitsAndDupes($request);
			echo json_encode($rest_result);
		}catch (Exception $ex){			
			throw new Exception($ex->getMessage()) ;
		}
	}
	/*Download Link*/
	public function getchitspdfAction(){
		try{
			$request = $this->getRequest();
			$reservationService = new Application_Service_Reservation();
			$pdf = $reservationService->zendpdf($request);
			$file = 'managerest/'.$request->restaurantid.'/chits/'.$request->restaurantid.'.pdf';
			$size = filesize($file);		
			if (file_exists($file))
			{
				header("Content-type: application/force-download");
				header("Content-Transfer-Encoding: Binary");
				header('Content-Length: '.$size);
				header("Content-disposition: attachment; filename=".basename($file));
				readfile($file);
	
			}
		}catch (Exception $ex){			
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * ADD SESSION ALERTS
	 */
	public function addalertsajaxAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$userid = $request->userid;
			if(isset($userid)){
				if($request->isPost())
				{
					$firmService = new Application_Service_Firm();
					$result = $firmService->addSessionAlerts($request,$userid);
					echo json_encode($result);
				}
			}
			else
			{
				echo json_encode(array('status'=>false,'err'=>'userid cannot be empty'));
			}

		}
		catch(Exception $ex)
		{
			throw new Exception($ex->getMessage());
			
		}
	}

	/**
	 * GET SESSION ALERTS IN JSON
	 */
	public function getsessionalertsAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$firmService = new Application_Service_Firm();
			$result = $firmService->getSessionAlerts($request);
			echo json_encode($result);

		}
		catch(Exception $ex)
		{
			throw new Exception($ex->getMessage());
			
		}
	}

	/**
	 * GET SEESION ALERTS COUNT
	 */
	
	public function getsessionalertscountAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$firmService = new Application_Service_Firm();
			$result = $firmService->getSessionAlertsCount($request);
			echo json_encode($result);

		}
		catch(Exception $ex)
		{
			throw new Exception($ex->getMessage());
			
		}
	}

	/**
	 * FEEDBACK REVIEWS API
	 */
	public function feedbackreviewsAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			if(isset($request->restaurantid)){
				$data = array();
				$reservationService = new Application_Service_Reservation();
				$result = $reservationService->getFeedbackReviewsHistoryofRestaurant($request,$data);

				echo json_encode(array('status'=>true,'result'=>$result));
			}else{
				echo json_encode(array('status'=>false,'err'=>'RestaurantId is required'));
			}
			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	/**
	* REVIEW REPLIES SUBMIT API
	**/
	public function feedbackreviewsreplyapiAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			//if($request->isPost())
			if(true)
			{
				$data = array();
				$data['User_Id'] = $request->User_Id;
				$cdMapper = new User_Model_ClientDataMapper();
				$typeBd = $cdMapper->getUsertype($request->User_Id);
				$data['Usertype'] = $typeBd->getCode();
				$reservationService = new Application_Service_Reservation();
				$result = $reservationService->FeedbackReviewsCommunication($request,$data);
				echo $result;
			}
			else
			{
				echo json_encode(array("message"=>"Invalid request type"));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * SAVE FEEDBACK
	 */
	public function savesinglecustomerfeedbackAction()
	{
   		try{
    		$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			//$request = file_get_contents('php://input');
			$request = $this->getRequest();		
			$result = $this->_ApiService->saveCustomerFeedbackFromIpad($request);
			if($result){
				echo json_encode('t');
			}else{
				echo json_encode('f');
			}
    	}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}    		
    }

    /**
	Delete a alert
	**/
	public function deletealertsapiAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();	
			$firmService = new Application_Service_Firm();
			$result = $firmService->deleteSessionAlert($request);
			echo json_encode($result);
		}
		catch(Exception $ex)
		{
			throw new Exception($ex->getMessage());	
		}
	}

	/**
	EDIT ALERT
	**/
	public function editalertsapiAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();	
			$firmService = new Application_Service_Firm();
			$result = $firmService->editSessionAlert($request);
			echo json_encode($result);
		}
		catch(Exception $ex)
		{
			throw new Exception($ex->getMessage());	
		}
	}

	/**
	GET MEAL TIMES FOR THE RESERVATION POPUP
	**/
	public function getrestimesapiAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$reservationService = new Application_Service_Reservation();
			$mealsData = $reservationService->getMealsByResidAPI($request->resid);
			echo json_encode($mealsData);
		}
		catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}

	}


	/**
	 * SEND REMINDER SMS API
	 */
	public function sendremindersmsapiAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$reservationService = new Application_Service_Reservation();
			$reservationService->sendReminderSMS($request->bokid,$request->userid);
			echo json_encode('true');
		}
		catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * SEND USS CONTACT FORM AS MAIL
	 */
	public function sendusscontactformemailAction()
	{
		try
		{
			header("Access-Control-Allow-Origin: http://unicornsoftwaresolutions.com");
			$this->_helper->layout->disableLayout();	
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			if($request->isPost())
			{
				$comService = new Application_Service_Communication();
				$comService->sendUssContactAsEmail($request);
			}
			else
			{
			echo "Invalid request";
			}

		}
		catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * SEND USS CONTACT FORM AS MAIL
	 */
	public function sendradiantsolsformemailAction()
	{
		try
		{
			header("Access-Control-Allow-Origin: http://unicornsoftwaresolutions.com");
			$this->_helper->layout->disableLayout();	
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			if($request->isPost())
			{
				$comService = new Application_Service_Communication();
				$comService->sendRadiantContactAsEmail($request);
			}
			else
			{
			echo "Invalid request";
			}

		}
		catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * GET RESTAURANT MEAL TYPES BY RESID
	 */
	public function getrestaurantmealtypesAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();	
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$resid = $request->resid;
			if(isset($resid))
			{
				$reservationService = new Application_Service_Reservation();
				$data = $reservationService->getRestaurantMealTypesByResidApi
				($resid);
				echo json_encode($data);
			}
		}
		catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * MIGRATE POS ORDERS TO SERVER
	 */
	public function migrateposorderipadAction()
	{
		try{
			$this->_helper->layout->disableLayout();	
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$oids = array();
			if($request->isPost())
			{
				$data = file_get_contents('php://input');
				$data = json_decode($data,true);
				$ordersArr = $data['orders'];
					$status = false;
					$message = '';
					if($ordersArr)
					{
						$orderService = new Application_Service_OrderManagement();
						$arr = $orderService->migrateOrdersFromIpad($ordersArr);
						if(count($arr)>0)
						{
							$status = true;
							$oids = $arr;
						}

					}
					else
					{
						$status = false;
						$message = 'Invalid Request Format';
					}
				}
			else
			{
				$status = false;
				$message = 'Invalid Request Type';
			}
			echo json_encode(array('status'=>$status,'message'=>$message,'response'=>$oids));
		}
		catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * FETCH ORDERS FOR A RESTAURANT
	 */
	public function fetchordersforrestaruantAction()
	{
		try {
			$this->_helper->layout->disableLayout();	
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$resid = $request->resid;
			if(!isset($resid))
			{
				echo json_encode(array('status'=>'false','error'=>'Restaruant Id Required'));
			}
			else
			{

				$orderService = new Application_Service_OrderManagement();
				$data = $orderService->fetchOrdersByResid($resid,$request->date);
				echo json_encode($data);
			}
		} catch (Exception $e) {
			throw new Exception($e->getMessage()) ;
		}
	}

	public function sampleorderjsonAction($value='')
	{
		try
		{
			$this->_helper->layout->disableLayout();	
			$this->_helper->viewRenderer->setNoRender();
			$response = array();
			$orders = array();
			$order_details = array();
			$modifiers = array();
			$tempMod = array();
			$tempMod['order_detail_id'] = 1;
			$tempMod['order_id'] = 1;
			$tempMod['modifier_id'] = 1;
			$tempMod['modifier_name'] = 'Cheese';
			$tempMod['modifier_price'] = 100;
			$tempMod['item_id'] = 10;
			$tempMod['mod_status'] = true;
			$modifiers[] = $tempMod;
			for($j=0;$j<2;$j++)
			{
				$temp = array();
				$temp['discount'] = 10;
				$temp['discount_amount'] = 100;
				$temp['item_base_price'] = 120;
				$temp['item_categoryid'] = 1;
				$temp['item_id'] = 1;
				$temp['item_name'] = 'bririyani';
				$temp['net_amount'] = 100;
				$temp['order_id_ref'] = 1;
				$temp['tax'] = 10;
				$temp['modifiers'] = $modifiers;
				$order_details[] = $temp;

			}
			for($i=0;$i<3;$i++)
			{
				$temp = array();
				$temp['booking_id'] = $i;
				$temp['customer_id'] = $i;
				$temp['discount'] = 10;
				$temp['discount_amount'] = 110;
				$temp['net_amount'] = 90;
				$temp['order_createdby'] = 1;
				$temp['order_status'] = true;
				$temp['order_created_date_time'] = '12-12-2016 16:00:00';
				$temp['order_updatedby'] = 1;
				$temp['order_updated_date_time'] = '12-12-2016 16:00:00';
				$temp['restaurant_id'] = 1;
				$temp['round_off_amount'] = 100;
				$temp['server_id'] = 1;
				$temp['server_name'] ='server';
				$temp['table_no'] = 1;
				$temp['tax'] = 20.4;
				$temp['order_details'] = $order_details;
				$orders[] = $temp;
 			}
 			$response['orders'] = $orders;
 			echo json_encode($response);
		}
		catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	* WEB HOOK FOR CM TELECOM
	**/
	public function webhookforcmAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();	
			$this->_helper->viewRenderer->setNoRender();
			Uss_Logger_FileLogger::info("cm request");
			Uss_Logger_FileLogger::info(json_encode($_POST));
			
		}
		catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}

	public function gettaxrulesforrestaurantAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();	
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$resid = $request->resid;
			$response = array();
			if($resid>0)
			{
				$data = $this->_ApiService->getTaxRulesByRestaurantIdWithColNames($resid);
				$response['status'] = true;
				$response['data'] = $data;
			}
			else
			{
				$response['status'] = false;
				$response['message'] = 'Invalid Restaurant Id';
			}
			echo json_encode($response);
			
		}
		catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}

	/**
	 * get timemslo
	 */
	public function gettimesAction()
	{
		try {
			$this->_helper->layout->disableLayout();	
			$this->_helper->viewRenderer->setNoRender();
			$url = "https://script.google.com/macros/s/AKfycbyd5AcbAnWi2Yn0xhFRbyzS4qMq1VucMVgVvhul5XqS9HkAyJY/exec?tz=Asia/Kolkata";
			$json = file_get_contents($url);
			$data = json_decode($json,true);
			if($data['status']=="ok")
			{
				$indianTimeStr = $data['fulldate'];
				$indianTimeStamp = strtotime($indianTimeStr);
				print_R(date('y-m-d H:i:s',$indianTimeStamp));
			}

		} catch (Exception $e) {
			
		}
	}
}
