<?php
/**
 * CONTROLLER WRITTEN TO HANDLE THE WEBHOOK AND API REQUESTS FROM THE RDLABS
 * Author : Sai
 * Date : 19-12-2016
 */
class DDApiService_RdlController extends Zend_Controller_Action
{	
	protected $_ApiService = null;	
	
	public function init()
	{
		$this->_helper->layout->disableLayout();
		$this->_helper->viewRenderer->setNoRender();
		$this->_ApiService = new Application_Service_ApiService();
		header('Content-type: application/json');
	}
	
	/**API TO FETCH RESTAURANT GUEST LIST PHONE BY RESID
	* REQUEST TYPE GET
	* PARAMETER RESID (MANDATORY)
	**/
	public function fetchcontactphonenumberAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$resid = $request->resid;
			if((!isset($resid)) || intval($resid)<=0)
			{
				echo json_encode(array('status'=>false,'error'=>'Resid not mentioned'));
			}
			else
			{ 
				$data = $this->_ApiService->getPhoneNumbersByResId($resid);
				//$data = array('phonestring'=>array('+918179482067','+918179482067'));
				echo json_encode($data);
			}
		}
		catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}

	}
	/**
	 * FETCH CONTACTS BY GROUP IDS
	 */
	
	public function fetchcontactphonenumberbygroupidAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$groupIds = $request->groupids;
			if((!isset($groupIds)))
			{
				echo json_encode(array('status'=>false,'error'=>'Resid not mentioned'));
			}
			else
			{ 
				$groupIdsArr = explode(',', $groupIds);
				if(count($groupIdsArr)>0)
				{
					$data = $this->_ApiService->getPhoneNumbersByGroupId($groupIdsArr);
					//$data = array('phonestring'=>array('+918179482067','+918179482067'));
					echo json_encode($data);
				}
				else {
					echo json_encode(array());
				}
				
			}
		}
		catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}

	}
	
}
