<?php
class Deals_Form_EditRestSpecialCost extends Zend_Form
{
	public function init()
	{
    	
    	$discountMapper = new Application_Model_DiscountModeDataMapper();
    	$discount = $discountMapper->fetchAll();
    	$discountModeArr = array();
    	foreach($discount as $disMode){
    		$discountModeArr[] = array('key'=>$disMode->getId(),'value'=>$disMode->getDescription());	
    	}
    	
		$specialPriceTypeMapper = new Application_Model_SpecialPriceTypeDataMapper();
    	$specialsPriceType = $specialPriceTypeMapper->fetchAll();
    	$specialpricetypelist = array();
    	foreach($specialsPriceType as $specialpricetype){
    		$specialpricetypelist[] = array('key'=>$specialpricetype->getId(),'value'=>$specialpricetype->getDescription());
    	}
    	
		$splId = $this->createElement('hidden','specialid');
		$splId->removeDecorator('DtDdWrapper')
			  ->removeDecorator('Label')
			  ->removeDecorator('HtmlTag');
    	$restId = $this->createElement('hidden','restaurantid');
    	$restId->removeDecorator('DtDdWrapper')
    			->removeDecorator('Label')
				->removeDecorator('HtmlTag');
		$spldetails = $this->createElement('hidden','splcost');
		$spldetails->setValue('splcost')
				   ->removeDecorator('DtDdWrapper')
    			   ->removeDecorator('Label')
				   ->removeDecorator('HtmlTag');

		$regularPrice = $this->createElement('text','editregularPrice');
        $regularPrice->removeDecorator('Label')
    			  	 ->removeDecorator('HtmlTag')
    			  	 ->setAttrib('class','inp1')
    			  	 ->setAttrib('maxlength', '5')
    			  	 ->addValidator('Float', true,array(null,'messages' => array(Zend_Validate_Float::NOT_FLOAT => 'The quantity should be a number.')))
    			  	 ->addFilters(array('StringTrim'))
    			  	 ->setValue('')
        		  	 ->setRequired(true);
        		  	 
        $discountPercentage = $this->createElement('text','editdiscountpecentage');
        $discountPercentage->removeDecorator('Label')
					  	   ->removeDecorator('HtmlTag')
					  	   ->setAttrib('maxlength', '5')
					  	   ->addValidator('Float', true,array(null,'messages' => array(Zend_Validate_Float::NOT_FLOAT => 'The quantity should be a number.')))
					  	   ->removeDecorator('DtDdWrapper')
					  	   ->setRequired(true);
					  	   
		$discountMode = $this->createElement('select','editdiscountmode');
        $discountMode->removeDecorator('Label')
        	  		->removeDecorator('HtmlTag') 
        	  		->setAttrib('class', 'sel4 form')       	   
             		->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select SpecialType.'))))
        	  		->addMultiOptions($discountModeArr)
              		->setRequired(true);
        		  	 
       	$priceWithDiscount = $this->createElement('text','editpriceWithDiscount');
        $priceWithDiscount->removeDecorator('Label')
    			  	 	  ->removeDecorator('HtmlTag')
    			  	   	  ->setAttrib('class','inp1')
    			  	   	  ->setAttrib('readonly','readonly')
    			  	   	  ->setAttrib('maxlength', '5')
    			  	   	  ->addValidator('Float', true,array(null,'messages' => array(Zend_Validate_Float::NOT_FLOAT => 'The quantity should be a number.')))
    			  	   	  ->addFilters(array('StringTrim'))
    			  	 	  ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select RestaurantName.'))))
        		 		  ->setRequired(true);
        		  	 	  
       $specialpriceType = $this->createElement('select','editspecialpriceType');
       $specialpriceType->removeDecorator('Label')
        	  		->removeDecorator('HtmlTag') 
        	  		->setAttrib('class', 'sel4 form')       	   
             		->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select SpecialPriceType.'))))
        	  		->addMultiOptions($specialpricetypelist)
              		->setRequired(true);
			            
		$specialSubmit = $this->createElement('submit','editSubmit');
        $specialSubmit->removeDecorator('Label')
        		   ->removeDecorator('DtDdWrapper')
        		   ->setValue('Submit')           		          		        		
        		   ->setAttrib('class','submitBtn')
                   ->setIgnore(true);

		$specialReset = $this->createElement('reset','editReset');
        $specialReset->removeDecorator('Label')        		 
        		  ->setValue('Reset')
        		  ->removeDecorator('DtDdWrapper')           	  	 
        	  	  ->setAttrib('class','submitBtn')
              	  ->setIgnore(true);
					  	  
        $this->addElements( array ($splId,
									$restId,
									$spldetails,
        							$regularPrice,
        							$discountMode,
        							$discountPercentage,
        							$priceWithDiscount,
        							$specialSubmit,
        							$specialReset,
        							$specialpriceType
        				   ));
	}
}