<?php
class Deals_Form_RestaurantSpecial extends Zend_Form
{
	public function init()
	{
		$specialsCountMapper = new Application_Model_SpecialCountTypeDataMapper();
    	$specialsCount = $specialsCountMapper->fetchAll();
    	$specialscountlist = array();
    	foreach($specialsCount as $specialcount){
    		$specialscountlist[] = array('key'=>$specialcount->getId(),'value'=>$specialcount->getDescription());
    	}
    				   			
	   	$specialsMapper  = new Application_Model_SpecialTypeDataMapper();
    	$specials = $specialsMapper->fetchAll();
    	$specialsList = array(); 
    	$specialsList[] = array('key'=>'','value'=>'Select Special Type');   	   
    	foreach($specials as $special){
    		$specialsList[] = array('key'=>$special->getId(),'value'=>$special->getDescription());
    	}

		$specialsCatMapper  = new Application_Model_SpecialCategoryDataMapper();
    	$specialsCat = $specialsCatMapper->fetchAll();

    	$specialsCatList = array(); 
    	$specialsCatList[] = array('key'=>'','value'=>'Select Special Category');   	   
    	foreach($specialsCat as $specialCat){
    		$specialsCatList[] = array('key'=>$specialCat->getId(),'value'=>$specialCat->getDescription());

    	}
    	
    	$discountMapper = new Application_Model_DiscountModeDataMapper();
    	$discount = $discountMapper->fetchAll();
    	$discountModeArr = array();
    	foreach($discount as $disMode){
    		$discountModeArr[] = array('key'=>$disMode->getId(),'value'=>$disMode->getDescription());	
    	}
    	
		$specialPriceTypeMapper = new Application_Model_SpecialPriceTypeDataMapper();
    	$specialsPriceType = $specialPriceTypeMapper->fetchAll();
    	$specialpricetypelist = array();
    	foreach($specialsPriceType as $specialpricetype){
    		$specialpricetypelist[] = array('key'=>$specialpricetype->getId(),'value'=>$specialpricetype->getDescription());
    	}
    	 
		$splId = $this->createElement('hidden','specialid');
		$splId->removeDecorator('HtmlTag')
    	       	    ->removeDecorator('Label');
    	 
    	$restNameCtl = $this->createElement('hidden','restaurantid');
        $restNameCtl->removeDecorator('Label')
         		    ->removeDecorator('HtmlTag');
         		    
        $specialType = $this->createElement('select','specialType');
        $specialType->removeDecorator('Label')
        	  		->removeDecorator('HtmlTag') 
        	  		->setAttrib('class', 'form sel1') 
        	  		->setValue('1')
        	  		->setAttrib('style','display:none;')
             		->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select SpecialType.'))))
        	  		->addMultiOptions($specialsList)
              		->setRequired(true);
              		
        $specialCatType = $this->createElement('select','specialCatType');
        $specialCatType->removeDecorator('Label')
	        	  		->removeDecorator('HtmlTag') 
	        	  		->setAttrib('class', 'form sel1')       	   
	             		->addValidators(array
	        		 				  (array('NotEmpty', true, array('messages' => 'Please select Special Category Type.'))))
	        	  		->addMultiOptions($specialsCatList)
	              		->setRequired(true);
         		    
	    $specialCount = $this->createElement('select','specialCount');
        $specialCount->removeDecorator('Label')
        	  		->removeDecorator('HtmlTag') 
        	  		->setAttrib('class', 'sel4 form')       	   
             		->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select SpecialType.'))))
        	  		->addMultiOptions($specialscountlist)
              		->setRequired(true);
              		
        $specialpriceType = $this->createElement('select','specialpriceType');
        $specialpriceType->removeDecorator('Label')
        	  		->removeDecorator('HtmlTag') 
        	  		->setAttrib('class', 'sel4 form')       	   
             		->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select SpecialPriceType.'))))
        	  		->addMultiOptions($specialpricetypelist)
              		->setRequired(true);
              		
        $NumOfDishes = $this->createElement('text','NumOfdishes');
        $NumOfDishes->removeDecorator('Label')
        			->removeDecorator('HtmlTag')
        			->setAttrib('maxlength', '5')
        			->setAttrib('class','form inp13')
        			->addFilters(array('StringTrim'))
        			->addValidator('Digits',new Zend_Validate_Digits(),array('messages' => 'Please enter Numbers only'))
        			->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please Enter Number of Dishes'))))
        			->setRequired(false);
                 	
        $specialTitle = $this->createElement('text','specialTitle');
        $specialTitle->removeDecorator('Label')
    			  	 ->removeDecorator('HtmlTag')
    			  	 ->setAttrib('maxlength', '100')
    			  	 ->setAttrib('class','form inp1')
    			  	 ->setAttrib('style','width:592px;')
    			  	 ->addFilters(array('StringTrim'))
    			  	 ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please Enter SpecialTitle'))))
    			  	 ->setValue('')
        		  	 ->setRequired(true);

       	$specialImage = $this->createElement('file','specialImage');
		$specialImage->removeDecorator('Label')
			     	 ->removeDecorator('HtmlTag')
			     	 ->setAttrib('class','inp1')			     
					 ->addValidator(new Zend_Validate_File_IsImage)
			    	 ->addValidator('Count', false,array('min' => 0, 'max' => 5))
					 ->setOptions(array('multiple' => 'multiple'))
			    	 ->setIsArray(true)
			     	 ->setRequired(false)
			     	 ->setAttrib('style','width:195px;')
			//     	 ->addValidator('FilesSize', false, array('min' => '1kB', 'max' => '250kB'))
			     	 ->addValidator('Extension', false, 'jpg,png,gif,jpeg');
			      	 
		$foodType = $this->createElement('select', 'foodtype');
		$foodType->removeDecorator('Label')
				 ->removeDecorator('HtmlTag')
				 ->setAttrib('class','form sel1 drpDown')
				 ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select FoodType.'))))
				 ->setRegisterInArrayValidator(false)
				 ->setRequired(false);
							 
		$regularPrice = $this->createElement('text','regularPrice');
        $regularPrice->removeDecorator('Label')
    			  	 ->removeDecorator('HtmlTag')
    			  	 ->setAttrib('maxlength', '5')
    			  	 ->setAttrib('class','form inp13')
    			  	 ->addValidator('Float', true,array(null,'messages' => array(Zend_Validate_Float::NOT_FLOAT => 'The quantity should be a number.')))
    			  	 ->addFilters(array('StringTrim'))
    			  	 ->setValue('')
        		  	 ->setRequired(true);
        		  	 
        $discountPercentage = $this->createElement('text','discountpecentage');
        $discountPercentage->removeDecorator('Label')
					  	   ->removeDecorator('HtmlTag')
					  	   ->setAttrib('maxlength', '5')
					  	   ->removeDecorator('DtDdWrapper')
					  	   ->addValidator('Float', true,array(null,'messages' => array(Zend_Validate_Float::NOT_FLOAT => 'The quantity should be a number.')))
						   ->setAttrib('class','form inp13')
					  	   ->setRequired(true);
					  	   
		$discountMode = $this->createElement('select','discountmode');
        $discountMode->removeDecorator('Label')
        	  		->removeDecorator('HtmlTag') 
        	  		->setAttrib('class', 'sel4 form')       	   
             		->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select SpecialType.'))))
        	  		->addMultiOptions($discountModeArr)
              		->setRequired(true);
              		
              		
		  		  	 
       	$priceWithDiscount = $this->createElement('text','priceWithDiscount');
        $priceWithDiscount->removeDecorator('Label')
    			  	 	  ->removeDecorator('HtmlTag')
    			  	   	  ->setAttrib('class','form inp13')
    			  	   	  ->setAttrib('maxlength', '5')
    			  	   	  ->addValidator('Float', true,array(null,'messages' => array(Zend_Validate_Float::NOT_FLOAT => 'The quantity should be a number.')))
    			  	   	  ->setAttrib('readonly','readonly')
    			  	   	  ->addFilters(array('StringTrim'))
    			  	 	  ->setRequired(true);
        		 		  
       	$kidsEatFree = $this->createElement('checkbox','kidsEatFree');
       	$kidsEatFree->removeDecorator('Label')
			        ->removeDecorator('HtmlTag')
			        ->setAttrib('class','kids recChk')
			        ->setRequired(false)
			        ->setChecked(false);	

		$kidsSelection = new Zend_Form_Element_Radio('kidsSelection',array(
							'multiOptions' => array(
							'2 kids free with 1 paying adult' => '2 kids free with 1 paying adult',
							'all kids eat free under the age of 12' => 'all kids eat free under the age of 12'
						 )
					));
		$kidsSelection->removeDecorator('Label')
			   		  ->removeDecorator('HtmlTag',array('tag' => 'Br'))	
			   		  ->setValue('2 kids free with 1 paying adult')	
			   		  ->setRequired(false);
        			
        $specialStartDate = $this->createElement('text','specialStartDate');
		$specialStartDate->removeDecorator('Label')
					  ->removeDecorator('HtmlTag')
					  ->setAttrib('class','form inp12 datepicker')
					  ->setAttrib('style','width:105px;')
					  ->setAttrib('readonly','readonly')
					  ->addFilters(array('StringTrim'))
					  ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select the  StartDate'))))
					  ->setRequired(true);
					  
		$specialEndDate = $this->createElement('text','specialEndDate');
		$specialEndDate->removeDecorator('Label')
					->removeDecorator('HtmlTag')
					->setAttrib('class','form inp12 datepicker2')
					->setAttrib('readonly','readonly')
					->setAttrib('style','width:105px;')
					->addFilters(array('StringTrim'))
					->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select the  EndDate.'))))
					->setRequired(true);
					
		$specialStartTime = $this->createElement('text','specialStartTime');
		$specialStartTime->removeDecorator('Label')
						 ->removeDecorator('HtmlTag')
						 ->setAttrib('class','form timepicker1 timepicker3')
						 ->addFilters(array('StringTrim'))
						 ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select StartTime.'))))
						 ->setRequired(true);
						 
		$specialEndTime = $this->createElement('text','specialEndTime');
		$specialEndTime->removeDecorator('Label')
						 ->removeDecorator('HtmlTag')
						 ->setAttrib('class','form timepicker1 timepicker3')
						 ->addFilters(array('StringTrim'))
						 ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select EndTime.'))))
						 ->setRequired(true);
					
		$specialRecurrence = $this->createElement('checkbox','specialRecurrence');
		$specialRecurrence->removeDecorator('Label')
				          ->removeDecorator('HtmlTag')
				          ->setAttrib('class','chk1 recChk')
				          ->setRequired(true);			  	

	     $Timelist = array(
    	 		array('key'=>'All Day','value'=>'All Day'),
    	 		array('key'=>'Selected Time Range','value'=>'Selected Time Range')
    	 );
    	 
		$specialTimeRecurrence = new Zend_Form_Element_Radio('specialTimeRecurrence');
		$specialTimeRecurrence ->removeDecorator('Label')
					   		   ->removeDecorator('HtmlTag')
					   		   ->setMultiOptions($Timelist)
					   		   ->setSeparator(' ')
					   		   ->setAttrib('style','margin-right:5px')
					   		   ->setValue('Selected Time Range')
					   		   ->setRequired(true);							      

		 $list = array(
    	 		array('key'=>'Single Day','value'=>'Single Day'),
    	 		array('key'=>'Multiple Days','value'=>'Multiple Days')
    	 );
    	 		          
		$specialDay = new Zend_Form_Element_Radio('specialDay');
		$specialDay->removeDecorator('Label')
			   		   ->removeDecorator('HtmlTag')
			   		   ->setMultiOptions($list)
			   		   ->setSeparator(' ')
			   		   ->setAttrib('style','margin-right:5px')
			   		   ->setValue('Multiple Days')
			   		   ->setRequired(true);
			   		   
		$canMakeResv = $this->createElement('checkbox','canmakeresv');
		$canMakeResv->removeDecorator('Label')
					          ->removeDecorator('HtmlTag')
					          ->setAttrib('class','chk1')
					          ->setRequired(false);
					          
		$canMakePayResv = $this->createElement('checkbox','canmakepayresv');
		$canMakePayResv->removeDecorator('Label')
					          ->removeDecorator('HtmlTag')
					          ->setAttrib('class','chk1')
					          ->setRequired(false);
			          
        $restcustype = $this->createElement('hidden','restcustype');
    	$restcustype->removeDecorator('HtmlTag')
    	       	    ->removeDecorator('Label');  

		$weeks = new Zend_Form_Element_MultiCheckbox('weeks', array(
						'multiOptions' => array(
							'01' => 'SUN',
							'02' => 'MON',
							'03' => 'TUE',
							'04' => 'WED',
							'05' => 'THU',
							'06' => 'FRI',
							'07' => 'SAT'
						 )
				));
		$weeks->removeDecorator('Label')
			   ->removeDecorator('HtmlTag',array('tag' => 'Br'))
			   ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select SpecialDay'))));
        //	   ->setRequired(true);
			          
		$specialDescription = $this->createElement('textarea', 'specialDescription');
		$specialDescription->removeDecorator('Label')
						->removeDecorator('HtmlTag')                	   
                	    ->setAttrib('maxlength', '300')
                	    ->setValue('')              
                	    ->setAttrib('cols', '60')
			            ->setAttrib('rows', '4')
			            ->addFilters(array('StringTrim'))
			            ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter specialDescription.')),
			           			array('StringLength', false,array(1,300,'messages' => array(
              					Zend_Validate_StringLength::TOO_LONG => 'Please Enter Description in less than 300 characters'
              				)))))
			            ->setRequired(false);
			            
		$specialSubmit = $this->createElement('submit','Submit');
        $specialSubmit->removeDecorator('Label')
        		   ->removeDecorator('DtDdWrapper')
        		   ->setValue('Submit')           		          		        		
        		   ->setAttrib('class','form submitBtn')
                   ->setIgnore(true);

		$specialReset = $this->createElement('reset','Reset');
        $specialReset->removeDecorator('Label')        		 
        		  ->setValue('Reset')
        		  ->removeDecorator('DtDdWrapper')           	  	 
        	  	  ->setAttrib('class','form submitBtn')
              	  ->setIgnore(true);
					  	  
        $this->addElements( array ($splId,
        							$restNameCtl,
        							$specialType,
        							$NumOfDishes,
        							$specialTitle,
        							$specialImage,
        							$foodType,
        							$regularPrice,
        							$discountPercentage,
        							$priceWithDiscount,
        							$kidsEatFree,
        							$kidsSelection,
        							$specialStartDate,
        							$specialEndDate,
        							$specialStartTime,
        							$specialEndTime,
        							$specialRecurrence,
        							$specialTimeRecurrence,
        							$specialDay,
        							$weeks,
        							$specialCount,
        							$specialDescription,
        							$specialSubmit,
        							$specialReset,
        							$specialCatType,
        							$discountMode,
        							$restcustype,
        							$canMakeResv,
        							$canMakePayResv,
        							$specialpriceType
        				   ));
	}
}