<?php
class Deals_Form_SearchSpecialForm extends Zend_Form
{
	public function init()
	{
		
		$restStaMapper = new Application_Model_RestaurantStatusDataMapper();
    	$restStaRes = $restStaMapper->fetchAll();
    	$restStaLst = array();
    	$restStaLst[] = array('key'=>'','value'=>'Select Status');
    	$restStaLst[] = array('key'=>'ell','value'=>'Ellapsed');
    	foreach($restStaRes as $rest){
    		$restStaLst[] = array('key'=>$rest->getId(),'value'=>$rest->getDescription());
    	}
    	
    	    	 
		$restNameCtl = $this->createElement('select','RestaurantName');
        $restNameCtl->removeDecorator('Label')
         		    ->removeDecorator('HtmlTag')
         		    ->setAttrib('class','sel1 drpDown')
         		    ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select RestaurantName.'))))
         		    ->setRegisterInArrayValidator(false)
         		    ->setRequired(true);
        			
        $specialStartDate = $this->createElement('text','searchStartDate');
		$specialStartDate->removeDecorator('Label')
					  ->removeDecorator('HtmlTag')
			   		  ->setAttrib('placeholder','Start Date')
					  ->setAttrib('title','Start Date')
					  ->setAttrib('class','inp4 datepicker input_form')
					  ->setAttrib('readonly','readonly')
					  ->addFilters(array('StringTrim'))
					  ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select StartDate'))))
					  ->setRequired(true);
					  
		$specialEndDate = $this->createElement('text','searchEndDate');
		$specialEndDate->removeDecorator('Label')
					->removeDecorator('HtmlTag')
					->setAttrib('placeholder','End Date')
					->setAttrib('title','End Date')
					->setAttrib('class','inp4 datepicker2 input_form')
					->setAttrib('readonly','readonly')
					->addFilters(array('StringTrim'))
					->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select EndDate.'))))
					->setRequired(true);
					
		$specialStartTime = $this->createElement('text','searchStartTime');
		$specialStartTime->removeDecorator('Label')
						 ->removeDecorator('HtmlTag')
						 ->setAttrib('placeholder','Start Time')
						 ->setAttrib('title','Start Time')
						 ->setAttrib('class','timepicker1 input_form')
						 ->addFilters(array('StringTrim'))
						 ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select StartTime.'))))
						 ->setRequired(true);
						 
		$specialEndTime = $this->createElement('text','searchEndTime');
		$specialEndTime->removeDecorator('Label')
						 ->removeDecorator('HtmlTag')
						 ->setAttrib('placeholder','End Time')
						 ->setAttrib('title','End Time')
						 ->setAttrib('class','timepicker1 input_form')
						 ->addFilters(array('StringTrim'))
						 ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select EndTime.'))))
						 ->setRequired(true);

		$restStatus = $this->createElement('select','splstatus');
		$restStatus->removeDecorator('Label')
         		    ->removeDecorator('HtmlTag')
         		    ->setAttrib('style','width:100%') 
         	     	->setAttrib('placeholder','Special Status')
         		    ->setAttrib('class','inp4 drpDown input_form')       	     
        	        ->addMultiOptions($restStaLst);
        	        
		$specialSubmit = $this->createElement('submit','Submit');
        $specialSubmit->removeDecorator('Label')
        		   ->removeDecorator('DtDdWrapper')
        		   ->setValue('Submit')           		          		        		
        		   ->setAttrib('class','submitBtn')
                   ->setIgnore(true);

		$specialReset = $this->createElement('reset','Reset');
        $specialReset->removeDecorator('Label')        		 
        		  ->setValue('Reset')
        		  ->removeDecorator('DtDdWrapper')           	  	 
        	  	  ->setAttrib('class','submitBtn')
              	  ->setIgnore(true);
					  	  
        $this->addElements( array (
        							$restNameCtl,
        							$specialStartDate,
        							$specialEndDate,
        							$specialStartTime,
        							$specialEndTime,
        							$specialSubmit,
        							$specialReset,
        							$restStatus
        				   ));
	}
}