<?php
class Deals_Model_RestaurantEmailBlastRequestDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}


	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Deals_Model_DbTable_RestaurantEmailBlastRequest');
		}
		return $this->_dbTable;
	}
	
	public function Save(array $dataObj)
	{
		$db = Zend_Db_Table::getDefaultAdapter();
		try{
			$db->beginTransaction(); 
			$status = false;
			foreach($dataObj as $dataVar){
				$data = array('rebr_fk_restaurant'	    		=> $dataVar->getEmailblastRestaurant(),
			                  'rebr_fk_deal'	    			=> $dataVar->getEmailblastDeal(),
				  			  'rebr_fk_contact'					=> $dataVar->getEmailblastContact(),
			  				  'rebr_fk_contact_invite_status'	=> $dataVar->getEmailblastInviteStatus(),
				  			  'rebr_email_status'				=> $dataVar->getEmailStatus(),
							  'rebr_templateid'				=> $dataVar->getTempId(),
			  				  'rebr_status'						=> $dataVar->getStatus());
							  
				$table = $this->getDbTable();
				$id    = $table->insert($data);
				$status = true;
			}
			$db->commit();
			return $status;			
		}catch (Exception $ex){
			$db->rollBack();
			throw new Exception($ex->getMessage()) ;
		}	
	}
	
}