<?php
class Deals_Model_RestaurantEmailBlastTemplateMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}


	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Deals_Model_DbTable_RestaurantEmailBlastTemplate');
		}
		return $this->_dbTable;
	}
	
	public function SaveTemplate(Deals_Model_RestaurantEmailBlastTemplate $dataObj)
	{
		$db = Zend_Db_Table::getDefaultAdapter();
		try{
			$db->beginTransaction(); 
			$status = false;
			$resServ = new Application_Service_Firm();
			$timeZone = $resServ->GetRestaurantTimeZone($dataObj->getEmailblastRestaurantId());
			date_default_timezone_set($timeZone);			
			$date = date('m-d-Y');
			$time = date('H:i:s');
			$data = array('rebt_fk_restaurant'	    		=> $dataObj->getEmailblastRestaurantId(),
		                  'rebt_fk_deal'	    			=> $dataObj->getEmailblastDealId(),
			  			  'rebt_template'					=> $dataObj->getEmailblastTemplate(),
		  				  'rebt_subject'					=> $dataObj->getEmailblastSubject(),
			  			  'rebt_createddatetime'			=> $date. ' ' .$time,				
					//	  'rebr_email_status'				=> $dataVar->getEmailStatus(),
		  			//	  'rebr_status'						=> $dataVar->getStatus());
						 ); 
			$table = $this->getDbTable();
			$id    = $table->insert($data);
			$status = $id;
			$db->commit();
			return $status;			
		}catch (Exception $ex){
			$db->rollBack();
			throw new Exception($ex->getMessage()) ;
		}	
	}
	
	public function getAllRestaurantEmailBlastDetails($offset)
	{
		try{
			$limit = 20;
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false); 
			
			$select->from(array('rebt'=>'mt.restaurant_email_blast_template'),array('rebt_tempid','rebt_fk_deal','rebt_subject','rebt_template','rebt_status'))
					->join(array('res'=>'mt.restaurant'),'res.resid = rebt.rebt_fk_restaurant',array('resrestaurant_name'))
					->join(array('rebr'=>'mt.restaurant_email_blast_request'),'rebr.rebr_templateid  = rebt.rebt_tempid',array())
					->joinRight(array('rgu'=>'mt.restaurant_group_users'),'rgu.rguid = rebr.rebr_fk_contact',array('array_agg(rguemail)as email'))
					 ->group(array('rebt_tempid','rebt_fk_deal','rebt_subject','rebt_template','rebt_status','resrestaurant_name'))
					->order('rebt_tempid DESC');			   
			$Result = "";
			$Result = new Zend_Paginator(
				new Zend_Paginator_Adapter_DbTableSelect($select)
				);
			$Result->setItemCountPerPage($limit);
			$Result->setCurrentPageNumber($offset);
			return $Result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}