<?php
class Deals_Model_RestaurantFBEventDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}


	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Deals_Model_DbTable_RestaurantFBEvent');
		}
		return $this->_dbTable;
	}
	
	public function SaveEvent(Deals_Model_RestaurantFBEvent $restFBSpl)
	{
		try{
			$status = false;
			$db = Zend_Db_Table::getDefaultAdapter();
			$model = new Deals_Model_RestaurantSpecialById();
			$model->setSpecialId($restFBSpl->getrfbe_fk_deal_id());
			$mapper = new Deals_Model_RestaurantSpecialDataMapper();
			$restSpl = $mapper->RetrieveSpecialDetailsBysplid($model);
			$data = array(
					'rfbe_event_fb_id'				=>	$restFBSpl->getrfbe_event_fb_id(),
					'rfbe_fk_deal_id'				=>	$restFBSpl->getrfbe_fk_deal_id(),
					'rfbe_start_date'				=>	$restSpl->getStartdate(),
					'rfbe_start_time'				=>	$restSpl->getStarttime(),
					'rfbe_end_date'					=>	$restSpl->getEnddate(),
					'rfbe_end_time'					=>	$restSpl->getEndtime(),
					'rfbe_created_fb_by'			=>	$restFBSpl->getrfbe_created_fb_by(),
					'rfbe_status'					=>	'T',
					'rfbe_created_fb_for'			=>	$restFBSpl->getrfbe_created_fb_for()
			);
			
			$spl_id = $this->getDbTable()->insert($data);
			$status = true;
			return $spl_id;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetFbEvent(Deals_Model_RestaurantFBEvent $restFBSpl)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->from($this->getDbTable(),array(
													'rfbe_event_fb_id',
													'rfbe_fk_deal_id',
													'rfbe_start_date',
													'rfbe_start_time',
													'rfbe_end_date',
													'rfbe_end_time',
													'rfbe_created_fb_by',
													'rfbe_status',
													'rfbe_created_fb_for'))
					->where('rfbe_fk_deal_id = ?',$restFBSpl->getrfbe_fk_deal_id())
					->where('rfbe_status = ?',true);
			$result = $this->getDbTable()->fetchRow($select);
			return $result;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}