<?php
class Deals_Model_RestaurantFbEventInviteeDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}


	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Deals_Model_DbTable_RestaurantFbEventInvitee');
		}
		return $this->_dbTable;
	}
	
	public function Save(array $dataObj)
	{
		$db = Zend_Db_Table::getDefaultAdapter();
		try{
			$db->beginTransaction(); 
			$status = false;
			foreach($dataObj as $dataVar){
				$data = array(
		                  'rfei_fk_event'	    	=> $dataVar->getEvent(),
		                  'rfei_fb_user'	    	=> $dataVar->getFbuser(),
		  				  'rfei_fb_invite_status'	=> $dataVar->getInvitestatus(),
			  			  'rfei_fb_status'			=> $dataVar->getStatus());
							  
				$table = $this->getDbTable();
				$id    = $table->insert($data);
				$status = true;
			}
			$db->commit();
			return $status;			
		}catch (Exception $ex){
			$db->rollBack();
			throw new Exception($ex->getMessage()) ;
		}	
	}
	
	public function SyncDealStatistics($eventArr,$eventid)
	{
		$db = Zend_Db_Table::getDefaultAdapter();
		try{
			$db->beginTransaction(); 
			$status = false;
			if($eventArr['invited']){
				foreach($eventArr['invited']->data as $key=>$invited){
					$select = $this->getDbTable()->select();
					$select->from($this->getDbTable(),array('rfei_id','rfei_fk_event','rfei_fb_user','rfei_fb_invite_status'))
							->where('rfei_fk_event = ?',$eventid)
							->where('rfei_fb_user = ?',$invited->id);
					$invitedrow = $this->getDbTable()->fetchRow($select);
					if($invitedrow){
						$data = array('rfei_fb_invite_status'=>$invited->rsvp_status);
						$where = array('rfei_fb_user = ?' => $invited->id,'rfei_fk_event = ?'=>$eventid);
						$rows_affected = $this->getDbTable()->update($data,$where);
					}else{
						$data = array(
					                  'rfei_fk_event'	    	=> $eventid,
					                  'rfei_fb_user'	    	=> $invited->id,
					  				  'rfei_fb_invite_status'	=> 'not_replied',
						  			  'rfei_fb_status'			=> 'T'
								);										  
						$table = $this->getDbTable();
						$id    = $table->insert($data);
					}
					$status = true;
				}				
			}			
			$db->commit();
			return $status;			
		}catch (Exception $ex){
			$db->rollBack();
			throw new Exception($ex->getMessage()) ;
		}	
	}
}