<?php
class Deals_Model_RestaurantSpecialCounterDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}


	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Deals_Model_DbTable_RestaurantSpecialCounter');
		}
		return $this->_dbTable;
	}
	
	public function IncrementSpecialCounter(Deals_Model_RestaurantSpecialCounter $counter)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$db = Zend_Db_Table::getDefaultAdapter();
			$select->from($table,array('rscid','rsc_spl_counter'))
					->where('rsc_fk_special_id = ?',$counter->getSpecialId())
					->where('rsc_fk_restaurant = ?',$counter->getRestaurantid());
			$rowset = $table->fetchRow($select);
			$result = '';
			if($rowset){
				$set = array('rsc_spl_counter'=>$rowset->rsc_spl_counter+1);
				$splWhere = $db->quoteInto('rscid = ?',$rowset->rscid);
				$result = $table->update($set,$splWhere);
			}else{
				$data = array(
							'rsc_spl_counter'		=>	1,
							'rsc_fk_special_id'		=>	$counter->getSpecialId(),
							'rsc_fk_restaurant'		=>	$counter->getRestaurantid()
				);
				$result = $table->insert($data);
			}
			return $result;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
}