<?php
class Deals_Model_RestaurantSpecialSearchCounterDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}


	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Deals_Model_DbTable_RestaurantSpecialSearchCounter');
		}
		return $this->_dbTable;
	}
	
	public function IncrementSpecialSearchCount(Deals_Model_RestaurantSpecialSearchCounter $obj)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$db = Zend_Db_Table::getDefaultAdapter();
			$select->from($table,array('rssc_id','rssc_count'))
					->where('rsscfk_restaurant = ?',$obj->getRestaurantid());
			$rowset = $table->fetchRow($select);
			$result = '';
			if($rowset){
				$set = array('rssc_count'=>$rowset->rssc_count+1);
				$splWhere = $db->quoteInto('rssc_id = ?',$rowset->rssc_id);
				$result = $table->update($set,$splWhere);
			}else{
				$data = array(
							'rssc_count'		=>	1,
							'rsscfk_restaurant'		=>	$obj->getRestaurantid()
				);
				$result = $table->insert($data);
			}
			return $result;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getsplsearchcountbyresid(Deals_Model_RestaurantSpecialSearchCounter $obj)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$db = Zend_Db_Table::getDefaultAdapter();
			$select->from($table,array('rssc_count'))
					->where('rsscfk_restaurant = ?',$obj->getRestaurantid());
			$rowset = $table->fetchRow($select);
			$result = '';
			if($rowset){
				$result = $rowset->rssc_count;
			}else{
				$result = 0;
			}
			return $result;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
}