<?php
class Deals_Model_SpecialTagLineMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Deals_Model_DbTable_SpecialTagLine');
		}
		return $this->_dbTable;
	}
	
	public function SaveSpecialTagLine(Deals_Model_SpecialTagLine $restSplTagLine)
	{
			$status = false;
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			$db = Zend_Db_Table::getDefaultAdapter();
			$data = array(
					//'spl_tag_id'				=>	$restSplTagLine->getId(),
					'spl_tag_restid'			=>	$restSplTagLine->getRestaurantid(),
					'spl_tag_createdby'			=>	$restSplTagLine->getCreatedby(),
					'spl_tag_createddate'		=>	date('Y-m-d H:i:s'),
					'spl_tag_updatedby'			=>	$restSplTagLine->getUpdatedby(),
					'spl_tag_updateddate'		=>	date('Y-m-d H:i:s'),
					
					'spl_tag_tagline'			=>	$restSplTagLine->getTagLine()
					
			);
			$data1 = array(
					

					'spl_tag_updatedby'			=>	$restSplTagLine->getUpdatedby(),
					'spl_tag_updateddate'		=>	date('Y-m-d H:i:s'),
					
					'spl_tag_tagline'			=>	$restSplTagLine->getTagLine()
					
			);
			try{
//				$select->from(array('mt.special_tagline'),'status')
//				->where('spl_tag_restid= ?', $restSplTagLine->getRestaurantid());
				//$result = $db->getAdapter()->fetchRow($select);
				//$db->beginTransaction();
//				if(!$result)

				//$spl_id = $this->getDbTable()->insert($data);
				$result = $db->fetchOne("select count(spl_tag_restid) from mt.special_tagline where spl_tag_restid = '". $restSplTagLine->getRestaurantid() ."' and spl_tag_status = 'True'");
				if($result)
				{
				$splWhere = $db->quoteInto('spl_tag_restid = ?',$restSplTagLine->getRestaurantid());
				$spl_id=$this->getDbTable()->update($data1,$splWhere);	
				$value= "updated";
				
				}
				else
				{
				$spl_id = $this->getDbTable()->insert($data);
				$value="inserted";
				
				}
				//$db->commit();
//				else 
//					$splWhere = $db->quoteInto('spl_tag_restid = ?',$restSplTagLine->getRestaurantid());
//				$this->getDbTable()->update($data1,$splWhere);					
				
				$status = true;
				if($spl_id)
				return $value;
				else 
				return false;
				
			}catch(Exception $ex){
				//$db->rollBack();
				throw new Exception($ex->getMessage()) ;
			}
	}
	
	
	public function getSpecialTagLineDetails($userid,$offset)
	{
		try{
			$limit = 8;
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			
			$select->from(array('sptag'=>'mt.special_tagline'),array('spl_tag_restid','spl_tag_createdby','spl_tag_tagline','spl_tag_createdby','spl_tag_createddate','spl_tag_updatedby','spl_tag_updateddate','spl_tag_status'))
				   ->join(array('rest'=>'mt.restaurant'),'rest.resid = sptag.spl_tag_restid',array('resrestaurant_name'))
				   ->join(array('restowner'=>'mt.restaurant_owner'),'restowner.rsofk_user = sptag.spl_tag_createdby',array('rsofirst_name as FName','rsolast_name as LName'))
			
			
					->where('spl_tag_createdby  = ?', $userid);
			$rowSet = $table->fetchAll($select);										
			//$result = $this->getAdapter()->fetchAll($select);
			return $rowSet;
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
		
	
	public function getSpecialTagLinebyResId($restid)
	{
		try{
			//$limit = 8;
			$mojo=$restid;
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			
			$select->from(array('sptag'=>'mt.special_tagline'),array('sptag.spl_tag_tagline'))
				   	->where('spl_tag_restid  = ?', $mojo);
			$rowSet = $table->fetchRow($select);										
			//$result = $this->getAdapter()->fetchAll($select);
			return $rowSet;
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
		
	

	

}