<?php
class  Phone_ReservationsController extends Zend_Controller_Action
{
	protected $_reservationService = null;
	protected $_restaurantService = null;

	public function init()
	{
		//$this->_helper->layout->setLayout('webapplayout');
		if(!$this->_reservationService){
			$this->_reservationService	= new Application_Service_Reservation();
		}

		if(!$this->_restaurantService){
			$this->_restaurantService = new Application_Service_Firm();
		}
	}

	public function indexAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){

			}else{
			 $this->_helper->redirector('mlogin','Authenticate','Phone');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function bookareservationAction()
	{
		try{
			$this->_helper->layout->setLayout('mobilelayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();	
				$request = $this->getRequest();
				if($request->restaurantid){
					$resStat = $this->_restaurantService->AuthenticateRestByAuth($data,$request->restaurantid);
				}else{
					$resStat = false;
				}
				if($resStat){
					$form = $this->_reservationService->getMakeResevMobileForm();
					if($request->isPost()){
						$formData = $request->getPost();
						$result = $this->_reservationService->MakeReservationMobile($formData);
						if($result['status']){
							if($formData['bookingStatus'] == 'RSD'){
								$this->_helper->redirector('listofreservations','Reservations','Phone',array('restaurantid'=>$formData['restaurantid'],'date'=>$formData['resDate']),'default',true);
							}else if($formData['bookingStatus'] == 'OVB'){
								$this->_helper->redirector('listofreservations','Reservations','Phone',array('restaurantid'=>$formData['restaurantid'],'date'=>$formData['resDate']),'default',true);
							}
								
						}else{
							$form = $result['form'];
							$this->view->MakeResForm = $form;
						}
					}else if($request->bookingid &&  $request->booktype == 'RES'){
						$results = $this->_reservationService->getBookingObjByBookingId($request);
						$form->populate($results);	
						$this->view->MakeResForm = $form;					
					}else{
						$this->view->MakeResForm = $form;
					}
					if($request->restaurantid){
						
						$CountryCodeMapper = new Application_Model_CountryCodeDataMapper();
				    	$CountryCode = $CountryCodeMapper->fetchAll();
				    	$CodeList = array();
				    	$CodeList[] = array('key'=>'','value'=>'Select Country Flag');
				    	foreach($CountryCode as $listcode){
				    		$CodeList[] = array('key'=>$listcode->getCountry_dial_code(),'value'=>$listcode->getCountry_flag());
				    	}
						    	
				    	$this->view->codelist = $CodeList;
						$restDataMapper = new FirmManagement_Model_FirmDataMapper();
						$countrycode = $restDataMapper->getCountrycodebyId($request->restaurantid);
						if($countrycode){
							if(!$request->bookingid){
								$formValues = array('countryCode' => $countrycode);
								$form->populate($formValues);
							}
							$this->view->countrycode = $countrycode;
						
						}
				    	
						$result = $this->_restaurantService->GetRestaurantNamesById($request->restaurantid);
						$this->view->restinfo = $result;
						$dateArray = $this->_reservationService->getDatesBetweenDateRange($request);
						$this->view->dateArray = $dateArray;
						$this->view->restaurantid = $request->restaurantid;
					}else{
				 		$this->_helper->redirector('mlogin','Authenticate','Phone');
					}
				}
				$this->view->secureLoginStatus = $resStat;	

			}else{
			 	$this->_helper->redirector('mlogin','Authenticate','Phone');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function makewalkinAction()
	{
		try{
			$this->_helper->layout->setLayout('mobilelayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();	
				$request = $this->getRequest();
				if($request->restaurantid){
					$resStat = $this->_restaurantService->AuthenticateRestByAuth($data,$request->restaurantid);
				}else{
					$resStat = false;
				}
				if($resStat){
					$form = $this->_reservationService->getMakeWalkinMobileForm();				
					$storage = new Zend_Auth_Storage_Session();
					$data = $storage->read();
					if($request->isPost()){
						$formData = $request->getPost();
						$result = $this->_reservationService->MakeWalkinReservation($request,$data['User_Id']);
						if($result){
							$this->_helper->redirector('listofreservations','Reservations','Phone',array('restaurantid'=>$request->restaurantid,'date'=>$formData['winDate']),'default',true);
						}
					}else{
						$this->view->MakewalkinForm = $form;
					}
					if($request->restaurantid){
				    	$CountryCodeMapper = new Application_Model_CountryCodeDataMapper();
				    	$CountryCode = $CountryCodeMapper->fetchAll();
				    	$CodeList = array();
				    	$CodeList[] = array('key'=>'','value'=>'Select Country Flag');
				    	foreach($CountryCode as $listcode){
				    		$CodeList[] = array('key'=>$listcode->getCountry_dial_code(),'value'=>$listcode->getCountry_flag());
				    	}
						    	
				    	$this->view->codelist = $CodeList;
						
						$restDataMapper = new FirmManagement_Model_FirmDataMapper();
						$countrycode = $restDataMapper->getCountrycodebyId($request->restaurantid);
						if($countrycode){
							$formValues = array('countryCode' => $countrycode);
							$this->view->countrycode = $countrycode;
							$form->populate($formValues);
						}
						$timezone = "";
						$mapper = new FirmManagement_Model_FirmDataMapper();
						$timezone = $mapper->GetRestaurantTimeZone($request->restaurantid);
						date_default_timezone_set($timezone); 
						
						$result = $this->_restaurantService->GetRestaurantNamesById($request->restaurantid);
						$this->view->restinfo = $result;
						$this->view->date = date("m-d-Y");
						$this->view->formDateVal = date("d M Y");
						$this->view->restaurantid = $request->restaurantid;
						$this->view->time = date("h:i A");
					}else{
						$this->_helper->redirector('mlogin','Authenticate','Phone');
					}
				}
				$this->view->secureLoginStatus = $resStat;	
			}else{
			 $this->_helper->redirector('mlogin','Authenticate','Phone');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function makewaitingAction()
	{
		try{
			$this->_helper->layout->setLayout('mobilelayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();	
				$request = $this->getRequest();
				if($request->restaurantid){
					$resStat = $this->_restaurantService->AuthenticateRestByAuth($data,$request->restaurantid);
				}else{
					$resStat = false;
				}
				if($resStat){
					$form = $this->_reservationService->getMakeWaitingMobileForm();
					$restid = $request->restaurantid;
					if($request->isPost()){
						$formData = $request->getPost();
						$result = $this->_reservationService->MakeWaitingReservationMobile($formData,$data['User_Id']);
						if($result['status'] == true){
								$this->_helper->redirector('waitlist','Reservations','Phone',array('restaurantid'=>$request->restaurantid,'date'=>$formData['waitresDate']),'default',true);			
						}else{
							$form = $result['form'];
							$this->view->MakeWaitingResForm = $form;
						}
					}else{
						$this->view->MakeWaitingResForm = $form;
					}
				
					$CountryCodeMapper = new Application_Model_CountryCodeDataMapper();
			    	$CountryCode = $CountryCodeMapper->fetchAll();
			    	$CodeList = array();
			    	$CodeList[] = array('key'=>'','value'=>'Select Country Flag');
			    	foreach($CountryCode as $listcode){
			    		$CodeList[] = array('key'=>$listcode->getCountry_dial_code(),'value'=>$listcode->getCountry_flag());
			    	}
					    	
			    	$this->view->codelist = $CodeList;		
					
					$restDataMapper = new FirmManagement_Model_FirmDataMapper();
					$countrycode = $restDataMapper->getCountrycodebyId($request->restaurantid);
					if($countrycode){
						$formValues = array('countryCode' => $countrycode);
						$this->view->countrycode = $countrycode;
						$form->populate($formValues);
					}
					$timezone = "";
					$mapper = new FirmManagement_Model_FirmDataMapper();
					$timezone = $mapper->GetRestaurantTimeZone($request->restaurantid);
					date_default_timezone_set($timezone); 
					$result = $this->_restaurantService->GetRestaurantNamesById($request->restaurantid);
					$this->view->restinfo = $result;
					$dateArray = $this->_reservationService->getDatesBetweenDateRange($request);
					$this->view->restaurantid = $request->restaurantid;
					$this->view->time = date("h:i A");
					$this->view->date = date("m-d-Y");					
				}
				$this->view->secureLoginStatus = $resStat;	
			}else{
			 $this->_helper->redirector('mlogin','Authenticate','Phone');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	
	public function waitlistAction()
	{
		try{
			$this->_helper->layout->setLayout('mobilelayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){				
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();	
				$request = $this->getRequest();
				if($request->restaurantid){
					$resStat = $this->_restaurantService->AuthenticateRestByAuth($data,$request->restaurantid);
				}else{
					$resStat = false;
				}
				if($resStat){
			//		$form = $this->_reservationService->getMakeWaitingMobileForm();
					$restid = $request->restaurantid;				
					/* Reteriving Waiting list start */	
						$diningidArr = array();
						$diningAreaArr = array();
						$diningMapper = new FirmManagement_Model_FirmDiningAreaDataMapper();
						$Diningresult = $diningMapper->getDinigAreasByRestId($restid);
						foreach($Diningresult as $dining){
							$diningidArr[] = $dining->rdaid;
						}
						$diningid = $diningidArr[0];
						
						$this->view->diningareas = $Diningresult;
					
						$getWaitingList = new Reservation_Model_GetWaitingList();
						$getWaitingList->setRestaurantId($restid);
						if($request->date){
							$getWaitingList->setDate($request->date);
						}else{
							$getWaitingList->setDate(date("m-d-Y"));
						}
						/* Reteriving booking status id by code */
						$status = array();
			
						$bookStatus = array('WAL','READY','QUOTE','BAR','NEXT','CANCUS','BACK');
						$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
						$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
						$getWaitingList->setBookStatus($bookStatusRes);
						$bookMapper = new Reservation_Model_ReservationDataMapper();
						$waitingListRes = $bookMapper->getWaitingList($getWaitingList);
						$result['WaitingList'] = $waitingListRes;
						
						
						if($request->date){
							$tSel = explode('-',$request->date);
							if($tSel[0] > 12){
								$this->view->date = date("Y-m-d",mktime(0,0,0,$tSel[1],$tSel[2],$tSel[0]));
								$this->view->formDateVal = date("d M Y",mktime(0,0,0,$tSel[1],$tSel[2],$tSel[0]));
							}else {
								$this->view->date = date("Y-m-d",mktime(0,0,0,$tSel[0],$tSel[1],$tSel[2]));
								$this->view->formDateVal = date("d M Y",mktime(0,0,0,$tSel[0],$tSel[1],$tSel[2]));
							}
						}else{
							$this->view->date = date("Y-m-d");
							$this->view->formDateVal = date("d M Y");
						}
						
						$this->view->restaurantid = $restid;
						$this->view->time = date("h:i A");
						$this->view->WaitingList   = $result['WaitingList'];
				}
				$this->view->secureLoginStatus = $resStat;					
			}else{
			 $this->_helper->redirector('mlogin','Authenticate','Phone');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function waitlistajaxAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$resultArr = array(); 
				$date = '';
				if($request->restaurantid){
					$timeZone = $this->_restaurantService->GetRestaurantTimeZone($request->restaurantid);
					date_default_timezone_set($timeZone);
					if(isset($request->date)){
						$date = $request->date;
					}else{
						$date = date('Y-m-d');
					}
				/* Reteriving Table layout start */

					$diningidArr = array();
					$diningAreaArr = array();
					$diningMapper = new FirmManagement_Model_FirmDiningAreaDataMapper();
					$Diningresult = $diningMapper->getDinigAreasByRestId($request->restaurantid);
					foreach($Diningresult as $dining){
						$diningidArr[] = $dining->rdaid;
					}
					$diningid = $diningidArr[0];
					$diningArr = array();
					foreach($Diningresult as $din){
						$diningArr[$din->rdaid] = $din->rda_diningname;
					}
					$resultArr['diningareas'] = json_encode($diningArr);
				
				/* Reteriving Waiting list start */

					$getWaitingList = new Reservation_Model_GetWaitingList();
					$getWaitingList->setRestaurantId($request->restaurantid);
					$getWaitingList->setDate($date);
					$getWaitingList->setIsAjaxCall(true);
					/* Reteriving booking status id by code */
					$status = array();
		
					$bookStatus = array('WAL','READY','QUOTE','BAR','NEXT','CANCUS','BACK');
					$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
					$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
					$getWaitingList->setBookStatus($bookStatusRes);
					$waitnSortedArray = array();
					$bookMapper = new Reservation_Model_ReservationDataMapper();
					if(isset($request->waitsorton)&& isset($request->waitsortorder) && $request->waitsorton != "" && $request->waitsortorder != ""){
						if($request->waitsorton == "booktime"){
							$getWaitingList->setSortOrder($request->waitsortorder);
							$waitingListRes = $bookMapper->getWaitingList($getWaitingList);
							$jsonwaitingList = json_encode($waitingListRes);
							$resultArr['WaitingList'] = $jsonwaitingList;
						}else{
							$waitingListRes = $bookMapper->getWaitingList($getWaitingList);
							$waitnSortedArray = $this->array_sort($waitingListRes,$request->waitsorton,$request->waitsortorder);
							$jsonattenList = json_encode($waitnSortedArray);
							$resultArr['WaitingList'] = $jsonattenList;
						}
					}else{
						$waitingListRes = $bookMapper->getWaitingList($getWaitingList);
						$jsonwaitingList = json_encode($waitingListRes);
						$resultArr['WaitingList'] = $jsonwaitingList;
					}
					
					echo json_encode($resultArr);
				}
			}else{
			 $this->_helper->redirector('mlogin','Authenticate','Phone');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function listofreservationsAction()
	{
		try{
			$this->_helper->layout->setLayout('mobilelayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){				
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();	
				$request = $this->getRequest();
				if($request->restaurantid){
					$resStat = $this->_restaurantService->AuthenticateRestByAuth($data,$request->restaurantid);
				}else{
					$resStat = false;
				}
				if($resStat){
					$menu = $this->_reservationService->getReservationMenu($request->restaurantid);
					$this->view->menu = $menu;
					$reservResult = $this->_reservationService->getReservationsMobile($request);
					$result = $this->_restaurantService->GetRestaurantNamesById($request->restaurantid);
					$this->view->resvResult = $reservResult['AttendingList'];
					$this->view->CompletedList = $reservResult['CompletedList'];
					$this->view->restinfo = $result;
					$dateArray = $this->_reservationService->getDatesBetweenDateRange($request);
					
					$diningidArr = array();
					$diningAreaArr = array();
					$diningMapper = new FirmManagement_Model_FirmDiningAreaDataMapper();
					$Diningresult = $diningMapper->getDinigAreasByRestId($request->restaurantid);
					foreach($Diningresult as $dining){
						$diningidArr[] = $dining->rdaid;
					}
					$diningid = $diningidArr[0];
					
					$this->view->diningareas = $Diningresult;
					
					$this->view->dateArray = $dateArray;
				//	$this->view->seldate = $request->date;
					if($request->date){
						$tSel = explode('-',$request->date);
						if($tSel[0] > 12){
							$this->view->seldate = date("Y-m-d",mktime(0,0,0,$tSel[1],$tSel[2],$tSel[0]));
							$this->view->formDateVal = date("d M Y-D",mktime(0,0,0,$tSel[1],$tSel[2],$tSel[0]));
						}else {
							$this->view->seldate = date("Y-m-d",mktime(0,0,0,$tSel[0],$tSel[1],$tSel[2]));
							$this->view->formDateVal = date("d M Y-D",mktime(0,0,0,$tSel[0],$tSel[1],$tSel[2]));
						}
					}else{
						$this->view->seldate = date("Y-m-d");
						$this->view->formDateVal = date("d M Y-D");
					}
					if($request->tab){
						$this->view->tab = $request->tab;
					}
				}
				$this->view->secureLoginStatus = $resStat;			
			}else{
			 $this->_helper->redirector('mlogin','Authenticate','Phone');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function listofreservbyajaxAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$resultArr = array(); 
				if($request->restaurantid){
//					$menu = $this->_reservationService->getReservationMenu($request->restaurantid);
//					$resultArr['menu'] = json_encode($menu);
					$reservResult = $this->_reservationService->getReservationsMobile($request);
					$result = $this->_restaurantService->GetRestaurantNamesById($request->restaurantid);
					$resultArr['resvResult'] = json_encode($reservResult['AttendingList']);
					$resultArr['compResult'] = json_encode($reservResult['CompletedList']);
//					$resultArr['restinfo'] = json_encode($result);
					$dateArray = $this->_reservationService->getDatesBetweenDateRange($request);
					
					$diningidArr = array();
					$diningAreaArr = array();
					$diningMapper = new FirmManagement_Model_FirmDiningAreaDataMapper();
					$Diningresult = $diningMapper->getDinigAreasByRestId($request->restaurantid);
					foreach($Diningresult as $dining){
						$diningidArr[] = $dining->rdaid;
					}
					$diningid = $diningidArr[0];
					$diningArr = array();
					foreach($Diningresult as $din){
						$diningArr[$din->rdaid] = $din->rda_diningname;
					}
					$resultArr['diningareas'] = json_encode($diningArr);
					
//					$resultArr['dateArray'] = json_encode($dateArray);
//					$resultArr['seldate'] = $request->date;
					echo json_encode($resultArr);
				}
			}else{
			 $this->_helper->redirector('mlogin','Authenticate','Phone');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	
	public function gettablesoffloorbydiningidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$resultStr = $this->_reservationService->GetLayoutByDiningIdMobile($request);
			echo json_encode($resultStr);
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function restauranttimingsAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_restaurantService->RestTimeMobMakeResv($request);

			if($result){
				echo json_encode($result);
			}else{
				echo "f";
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function retrievefirmtimeslotsAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$results = $this->_reservationService->getRestaurantTimings($request);
			$searchListArr = array();
			if(isset($results)){
				$index = 0;
				if($request->fromaction == 'reservation'){
					foreach($results as $listval){
						$searchListArr[$index] = $listval;
						$index++;
					}
				}else{
					if($results){
						foreach($results as $listval){
							if($listval['status'] == 'WAL'){
								continue;
							}else{
								$searchListArr[$index] = $listval;
								$index++;
							}
						}
					}
				}
			}
			echo json_encode($searchListArr);
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function reservationreportAction()
	{
		try{
			$this->_helper->layout->setLayout('mobilelayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();	
		        $request = $this->getRequest();
		        if($request->restaurantid){
					$resStat = $this->_restaurantService->AuthenticateRestByAuth($data,$request->restaurantid);
				}else{
					$resStat = false;
				}
				if($resStat){
					$reservResult = $this->_reservationService->getResvReportMobile($request);
					$result = $this->_restaurantService->GetRestaurantNamesById($request->restaurantid);
					$this->view->resvResult = $reservResult['rowset'];
					$this->view->todaydate  = $reservResult['todaydate'];
					$this->view->restinfo = $result;
					$dateArray = $this->_reservationService->getDatesBetweenDateRange($request);
					$this->view->dateArray = $dateArray;
					/* Reteriving booking status */
					$bokstatus = $this->_reservationService->getBookingStatusBd();
					$this->view->bookstatus = $bokstatus;
					if(isset($request->bokstartdate)){
						$this->view->todaydate = $request->bokstartdate;
					}

					if(isset($request->bokenddate)){
						$this->view->todate = $request->bokenddate;
					}

					if(isset($request->reservstatus)){
						$this->view->reservstatus = $request->reservstatus;
					}
				}
				$this->view->secureLoginStatus = $resStat;
			}else{
			 $this->_helper->redirector('mlogin','Authenticate','Phone');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function overflowbookAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				if($request->restaurantid){

					$reservResult = $this->_reservationService->getOverFlowBookMobile($request);
					$result = $this->_restaurantService->GetRestaurantNamesById($request->restaurantid);
					$this->view->resvResult = $reservResult;
					$this->view->restinfo = $result;
					$dateArray = $this->_reservationService->getDatesBetweenDateRange($request);
					$this->view->dateArray = $dateArray;
					$this->view->seldate = $request->date;
				}
			}else{
			 $this->_helper->redirector('mlogin','Authenticate','Phone');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getbookingreservationdatesAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				if($request->restaurantid){
					$dateArray = $this->_reservationService->getDatesBetweenDateRange($request);
					echo json_encode($dateArray);
				}
			}else{
			 $this->_helper->redirector('mlogin','Authenticate','Phone');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function resvformvalidationAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$form = $this->_reservationService->getMakeResevMobileForm();
			$params = $this->_getAllParams();
			if($params['noteType'] == 'both'){
				$form->number->setRequired(true);
				$form->email->setRequired(true);
			}else if($params['noteType'] == 'sms'){
				$form->number->setRequired(true);
				$form->email->setRequired(false);
			}else if($params['noteType'] == 'email'){
				$form->email->setRequired(true);
				$form->number->setRequired(false);
			}
			$form->isValid($this->_getAllParams());
			$json = $form->getMessages();
			if(empty($json)){
				echo json_encode('t');
			}else{
				header('Content-type: application/json');
				echo json_encode($json);
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function validatebookingdetailsformAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$form = $this->_reservationService->getBookingDetailsForm();
			$form->number->setRequired(true);
			$form->email->setRequired(true);
			$params = $this->_getAllParams();
			$form->isValid($this->_getAllParams());
			$json = $form->getMessages();
			if(empty($json)){
				echo json_encode('t');
			}else{
				header('Content-type: application/json');
				echo json_encode($json);
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function changestatusAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			if($request){
				$result = $this->_reservationService->ChangeReservationStatusToRead($request);
				if($result){
					echo json_encode('t');
				}else{
					echo json_encode('f');
				}
					
			}else{
				echo json_encode('f');
			}


		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function removereservationAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			if($request){
				$result = $this->_reservationService->ChangeTableStatusToCan($request);
				if($result['status']){
					echo json_encode('t');
				}else{
					echo json_encode('f');
				}
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function managefreezeAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){

				$request = $this->getRequest();
				$dateArray = $this->_reservationService->getDatesBetweenDateRange($request);
				$result    = $this->_restaurantService->GetRestaurantTimingsFreeze($request);
				$restinfo  = $this->_restaurantService->GetRestaurantNamesById($request->restaurantid);
				$frzDates  = $this->_reservationService->GetFreezedDates($request);
				$timeZone = $this->_restaurantService->GetRestaurantTimeZone($request->restaurantid);
				date_default_timezone_set($timeZone);
				foreach($frzDates as $key=>$value){
					$datSplit = explode('/',$value);
					$value = date('Y-m-d',mktime(0,0,0,$datSplit[0],$datSplit[1],$datSplit[2]));
					$frzDates[$key] = $value;
				}
					
				$this->view->restinfo   = $restinfo;
				$this->view->timesArray = $result;
				$this->view->dateArray  = $dateArray;
				$this->view->frzDates	= $frzDates;

				if(isset($request->date)){
					$datSplit = explode('-',$request->date);
					$date = date('Y-m-d',mktime(0,0,0,$datSplit[0],$datSplit[1],$datSplit[2]));
					$this->view->seldate   = $date;
				}

			}else{
			 $this->_helper->redirector('mlogin','Authenticate','Phone');
			}

		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function bookfreezeAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$timeZone = $this->_restaurantService->GetRestaurantTimeZone($request->restaurantid);
				date_default_timezone_set($timeZone);
				$freezedDates = $this->_reservationService->FreezeReservation($request,$data['User_Id']);
				$date = '';

				if($request->selectedDate){
					$datSplit = explode('-',$request->selectedDate);
					$date = date('m-d-Y',mktime(0,0,0,$datSplit[1],$datSplit[2],$datSplit[0]));
				}else{
					$date = date("m-d-Y");
				}
				if($freezedDates){
					$this->_helper->redirector('managefreeze','Reservations','Phone',array('restaurantid'=>$request->restaurantid,'date'=>$date),'default',true);
				}

			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function blockresvAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){

				$request   = $this->getRequest();
				$dateArray = $this->_reservationService->getDatesBetweenDateRange($request);
				$restinfo  = $this->_restaurantService->GetRestaurantNamesById($request->restaurantid);

				$this->view->restinfo   = $restinfo;
				$this->view->dateArray  = $dateArray;

				if(isset($request->date)){
					$this->view->seldate   = $request->date;
				}

			}else{
				$this->_helper->redirector('mlogin','Authenticate','Phone');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function modifystatusoftableAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$result = $this->_reservationService->ChangeTableStatus($request,$data);
				if($result['status']){
					echo json_encode('t');
				}else{
					echo json_encode('f');
				}
			}else{
				$this->_helper->redirector('mlogin','Authenticate','Phone');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}

	public function communicationsettingsAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				if($request->restaurantid){
					$result = $this->_restaurantService->GetRestaurantNamesById($request->restaurantid);
					$this->view->restinfo = $result;

					$primaryEmail = $this->_reservationService->GetRestaurantEmailById($request);
					$restEmails   = $this->_reservationService->GetRestaurantEmails($request);

					$this->view->primaryEmail = $primaryEmail;
					$this->view->restEmails   = $restEmails;

				}
			}else{
				$this->_helper->redirector('mlogin','Authenticate','Phone');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}

	public function notificationstatusAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			if($request){
				$status = $this->_restaurantService->ManageNotificationStatus($request);
				if($status){
					echo json_encode('t');
				}else{
					echo json_encode('f');
				}
			}

		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function phonesmsstatusAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_reservationService->updateNotificationStatus($request);
			if($result){
				echo 't';

			}else{
				echo 'f';
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getrestemailAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			if($request){

				$primaryEmail = $this->_reservationService->GetRestaurantEmailById($request);
				$restEmails   = $this->_reservationService->GetRestaurantEmails($request);

				$result = array();
				$result['primaryEmail'] = $primaryEmail;
				$result['restEmails']   = $restEmails;

				echo json_encode($result);
			}

		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getrestcontactnumberAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			if($request){
				$result = $this->_restaurantService->getRestSmsNotifyNumber($request);
				if($result){
					echo json_encode($result);
				}else{
					echo json_encode('f');
				}
			}

		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function updatenotifydetailsajaxAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_restaurantService->UpdateNotifyDetails($request);
			if($result){
				echo 't';
			}else{
				echo 'f';
			}

		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function restsmsnotifynumberAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_restaurantService->restSmsNotifyNumber($request);
			if($result){
				echo 't';
			}else{
				echo 'f';
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function managerestemailAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				if($request->restaurantid){
					$result = $this->_restaurantService->GetRestaurantNamesById($request->restaurantid);
					$this->view->restinfo = $result;

					$primaryEmail = $this->_reservationService->GetRestaurantEmailById($request);
					$restEmails   = $this->_reservationService->GetRestaurantEmails($request);

					$this->view->primaryEmail = $primaryEmail;
					$this->view->restEmails   = $restEmails;
					$this->view->emailcount   = count($restEmails);

				}
			}else{
				$this->_helper->redirector('mlogin','Authenticate','Phone');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function widgetindexAction()
	{

		try{
			$this->_helper->layout->disableLayout();
			$request = $this->getRequest();
			$restService = new Application_Service_Firm();

			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->view->userlogstat = 'true';
			}else{
				$this->view->userlogstat = 'false';
			}
			//$form = new Application_Form_Search();
			$searchList = array();
			$searchListArr = array();
			$postBool = false;
			$resid = '';
			if($request->where){
				$resid = $request->where;
			}else{
				$resid = $request->restid;
			}			
			if(isset($request->bokSrcComp)){
				$this->view->bokSrcComp = $request->bokSrcComp;
			}else{
				$this->view->bokSrcComp = 'INAT';
			}			
			/* Get Widget Theme Start */
			
			$theme = $restService->GetWidgetThemeByRestId($request);
			$this->view->theme = $theme;
			
			/* Get Widget Theme End */
			$timezone = "";
			$mapper = new FirmManagement_Model_FirmDataMapper();
			$timezone = $mapper->GetRestaurantTimeZone($resid);
			date_default_timezone_set($timezone);
			
			$specialserv = new Application_Service_Deals();
			/*code to retrive the tagline*/
			$splTag = '';
			$tagline = $specialserv->GetSpecialTagLineByResId($resid);
			if($tagline){
				$splTag=$tagline->spl_tag_tagline;
			}
			$this->view->tagLine=$splTag;
			//-------------------------------//
			
			/*special status by date*/
//			$splStat = $specialserv->getRestaurantSpecialByDate($request);
			$restDataMapper = new FirmManagement_Model_FirmDataMapper();
			$splstatus = $restDataMapper->GetSpecialSetting($resid);
			$splcheck = $splstatus->resspecialsetting;
			$this->view->splStat = 1;
			$this->view->splcheck = $splcheck;
			
			$widsettings = $restService->getRestaurantCustomizeWidgetByResid($resid);
			if($widsettings){
				$this->view->widsettings = $widsettings;
			}
			
			if($this->getRequest()->isPost()){
				$postBool = true;
				
					
				$maxPartyRes = "";
				$maxParty = "";
				$maxPartyAllowed = "Yes";
				$minParty = "";
				// BEGIN Getting Max and Min Party Sizes Day Wise//	
				$dateSplit = explode("-",$request->date);
				$weekday = date("D", mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]));	 
				
				$object = new FirmManagement_Model_FirmDayPartySettings();
				$object->setrdpsfk_restaurants($resid);	
				$mapper = new FirmManagement_Model_FirmDayPartySettingsMapper();
				$resultArray = $mapper->GetDayPartySize($object);
				$maxallowedsize = $resultArray['ressize'];
				$tempdata = $resultArray['times'];
				foreach($tempdata as $item)
				{
					$x=strtoupper($item['day']);
					$y=strtoupper($weekday);
					$z = strcmp ($x,$y);
					if(!$z){
						if($item['daystatus'])
						{
							$maxParty = $item['maxsize'];
							$minParty = $item['minsize'];
							
						}else{
							
							$maxParty = $maxallowedsize;
							$minParty = 1;
							
						}
						break;
					}else{
							
							$maxParty = $maxallowedsize;
							$minParty = 1;
							
						}
				}
				
				if(!$resultArray){
						$maxParty = $maxallowedsize;
						$minParty = 1;
				}
				if(($request->pax > $maxParty || $request->pax < $minParty)){
					$maxPartyAllowed = "No";	
				}
				// END Getting Max and Min Party Sizes Day Wise//	
				$searchList = $this->_reservationService->GetRestTimingsFromWidget($request, $resid);
				$index = 0;  
				if($searchList){
					foreach($searchList as $listval){
						if($listval['status'] == 'WAL'){
							continue;
						}else{
							$searchListArr[$index] = $listval;
							$index++;
						}
					}
				}else{
					$frezresult = $this->_reservationService->getFreezeTypeByDate($request);
					if($frezresult){

						$this->view->freezedesc = $frezresult['desc'];
					}else{
						$serv = new Application_Service_Firm();
						$msg = $serv->getRestaurantTimeSearchMessage($request->restid);
						$this->view->freezedesc = $msg->resbooking_search_msg;
					}
				}
				$dateSplit = explode("-",$request->date);
				$s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
				$weekdate = date("Y-m-d", $s);
				
				
				$this->view->searchlist = $searchListArr;
				$this->view->restid = $resid;
				$pax = $request->pax;
				$date = $request->date;
				$this->view->pax = $request->pax;
				$this->view->date = $request->date;
				$this->view->time = $request->time;
				$this->view->mealtype = $request->mealtype;
				$this->view->forDate = $weekdate;

				$resDataMapper = new FirmManagement_Model_FirmDataMapper();
				$restid = new FirmManagement_Model_FirmById();
				$restid->setRestaurantId($resid);
				$resDetails = $resDataMapper->getRestaurantById($restid);
								
				$this->view->resDetails = $resDetails;
				$this->view->resName = $resDetails->getRestaurantname();
				$this->view->resAddress = $resDetails->getRestaddress();
				$this->view->resPhone	= $resDetails->getRestphone();
				$this->view->restid = $resid;
				$this->view->postBool = $postBool;
				$this->view->maxPartyStatus = $maxPartyAllowed;
				$this->view->maxParty = $maxParty;
				$this->view->minParty = $minParty;
				$this->view->resCompanyid = $resDetails->getcompanyid();
				
				
			}else{
				$this->view->restid = $resid;
				$resDataMapper = new FirmManagement_Model_FirmDataMapper();
				$restid = new FirmManagement_Model_FirmById();
				$restid->setRestaurantId($resid);
				$resDetails = $resDataMapper->getRestaurantById($restid);
				
				$this->view->resDetails = $resDetails;
				$this->view->mealTypes = $this->_reservationService->getRestaurantMealTypes($request);
				$mapper = new FirmManagement_Model_FirmDataMapper();
				$owner = new FirmManagement_Model_OwnerByRestaurantId();
				$owner->setRestaurantId($resid);
				$resownername = $mapper->getOwnerByRestId($owner);
				$restList = '';
				if($resownername){
					$restNameByOwnObj = new FirmManagement_Model_FirmNamesByOwnerId();
					$restNameByOwnObj->setRestOwnerId($resownername->getRestUser());
					$restList   = $mapper->getRestaurantDataByOwnerId($restNameByOwnObj);
					$this->view->restList = $restList;
				}
				$this->view->postBool = $postBool;
				$this->view->resCompanyid = $resDetails->getcompanyid();
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function reservationcancelformobileAction()
	{
		try{
			$this->_helper->layout()->setLayout('mobileaddlayout');
			$request = $this->getRequest();
			$result = $this->_reservationService->CancelReservation($request);
			$campDetails = $this->_reservationService->CampaignManageForMobile($result->getbokfk_restaurant());
			if(count($campDetails)){
				$count = count($campDetails);
				if($count > 1){
					$this->view->campaign = $campDetails[rand(0,$count-1)];
				}else{
					$this->view->campaign = $campDetails[0];
				}
			}			
			$this->view->bookedData = $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function reservationcancelformobileconAction()
	{
		$msg = "";
		try{
			$this->_helper->layout()->setLayout('mobileaddlayout');
			$request = $this->getRequest();
			$result = $this->_reservationService->CancelReservationCon($request);
			$campDetails = $this->_reservationService->CampaignManageForMobile($request->restaurantid);
			if(count($campDetails)){
				$count = count($campDetails);
				if($count > 1){
					$this->view->campaign = $campDetails[rand(0,$count-1)];
				}else{
					$this->view->campaign = $campDetails[0];
				}
			}
			if($result['result']){
				$this->view->bookedData = $result['result'];
				$this->view->status = $result['status'];
			}else{
				$msg = true;
				$this->view->msg = $msg;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function  sendinvitationforguestmobileAction()
	{
		try{
			$this->_helper->layout()->setLayout('mobileaddlayout');
			$request = $this->getRequest();
			$bokid   = $request->bokid;
			$restId = $request->resid;
			$bokStat = $request->bokstat;
			$notstat = $request->notstat;
			$result = $this->_reservationService->GetBookingDetails($bokid);
			$campDetails = $this->_reservationService->CampaignManageForMobile($restId);
			if(count($campDetails)){
				$count = count($campDetails);
				if($count > 1){
					$this->view->campaign = $campDetails[rand(0,$count-1)];
				}else{
					$this->view->campaign = $campDetails[0];
				}
			}
			$this->view->bookedData = $result;
			$this->view->restaurantid = $restId;
			$this->view->bokStat = $bokStat;
			$this->view->bokid = $bokid;
			$this->view->notstat = $notstat;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function mailnotifymailAction()
	{
	try{
			$this->_helper->layout->disableLayout();		
			$request = $this->getRequest();	
			$notServ = new Application_Service_Communication();
			if($notServ->WidgetNotifyFriendsEmail($request)){
				return $this->_helper->redirector('inviteguestmobile','Reservations','Phone',array('bokid'=>$request->bokid,'resid'=>$request->resid,'notstat'=>1));
			}else{
				return $this->_helper->redirector('inviteguestmobile','Reservations','Phone',array('bokid'=>$request->bokid,'resid'=>$request->resid,'notstat'=>1));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function notifyconfirmationAction()
	{
		try{
			$request = $this->getRequest();	
			$this->_helper->layout()->setLayout('mobileaddlayout');
			//$this->view->sendername=$request->sendername;
			$notServ = new Application_Service_Communication();
			$this->view->bokid=$request->bokid;	
			$bokid   = $request->bokid;
			$constat=$request->constat;
			$result = $this->_reservationService->GetBookingDetails($bokid);
			$senderFname=$result->getbokfirst_name(); 
			$senderLname=$result->getboklast_name();
			$this->view->fname=$senderFname;
			$this->view->lname=$senderLname;
			$notServ->NotifyConfirmation($result,$request);
			}
		catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function campaignlinkcountAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			//$ScId = ($request->scid);
			$LinkData = new Administrator_Model_CampaignDataMapper();
        	$link = $LinkData->LinkCount($request->scid);	
        	if($link){
        		header("Location: $link");	
        	}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	public function reservationwidgetmobileAction()
	{
		try{
			$request = $this->getRequest();
			$resid = '';
			$postBool = false;
			if($request->where){
				$resid = $request->where;
			}else{
				$resid = $request->restid;
			}
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->view->userlogstat = 'true';
			}else{
				$this->view->userlogstat = 'false';
			}
			$timezone = "";
			$mapper = new FirmManagement_Model_FirmDataMapper();
			$timezone = $mapper->GetRestaurantTimeZone($resid);
			date_default_timezone_set($timezone);
			if($request->isPost()){
				$postBool = true;
				$maxPartyRes = "";
				$maxParty = "";
				$maxPartyAllowed = "Yes";
				$minParty = "";
				// BEGIN Getting Max and Min Party Sizes Day Wise//	
				$dateSplit = explode("-",$request->date);
				$weekday = date("D", mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]));	 
				
				$object = new FirmManagement_Model_FirmDayPartySettings();
				$object->setrdpsfk_restaurants($resid);	
				$mapper = new FirmManagement_Model_FirmDayPartySettingsMapper();
				$resultArray = $mapper->GetDayPartySize($object);
				$maxallowedsize = $resultArray['ressize'];
				$tempdata = $resultArray['times'];
				foreach($tempdata as $item)
				{
					$x=strtoupper($item['day']);
					$y=strtoupper($weekday);
					$z = strcmp ($x,$y);
					if(!$z){
						if($item['daystatus']){
							$maxParty = $item['maxsize'];
							$minParty = $item['minsize'];
						}else{							
							$maxParty = $maxallowedsize;
							$minParty = 1;							
						}
						break;
					}else{							
						$maxParty = $maxallowedsize;
						$minParty = 1;
					}
				}				
				if(!$resultArray){
					$maxParty = $maxallowedsize;
					$minParty = 1;
				}
				if(($request->pax > $maxParty || $request->pax < $minParty)){
					$maxPartyAllowed = "No";	
				}
				// END Getting Max and Min Party Sizes Day Wise//	
				//$searchList = $this->_reservationService->GetRestTimingsFromWidget($request);
				$searchList = $this->_reservationService->GetRestTimingsFromWidget($request, $resid);
				$index = 0;  
				if($searchList){
					foreach($searchList as $listval){
						if($listval['status'] == 'WAL'){
							continue;
						}else{
							$searchListArr[$index] = $listval;
							$index++;
						}
					}
				}else{
					$frezresult = $this->_reservationService->getFreezeTypeByDate($request);
					if($frezresult && $frezresult['type'] == 'All'){
						$frzdescMap = $this->_reservationService->getFreezeDesc($request);
						if($frzdescMap && $frzdescMap->rfdm_desc){
							$this->view->freezedesc = $frzdescMap->rfdm_desc;
						}else{
							$serv = new Application_Service_Firm();
							$msg = $serv->getRestaurantTimeSearchMessage($request->restid);
							$this->view->freezedesc = $msg->resbooking_search_msg;
						}
					}else{
						$serv = new Application_Service_Firm();
						$msg = $serv->getRestaurantTimeSearchMessage($request->restid);
						$this->view->freezedesc = $msg->resbooking_search_msg;
					}
				}
				$weekdate = $request->date;
					
				$payStat = 'false';
				$payType = '';
				if($payResult){
					$payType = $payResult['rpsnoshow_type'];
					$this->view->payType = $payType;
					$this->view->payAmt = $payResult['payamount'];
					if($request->pax >= $payResult['paypax']){		
						$payStat = 'true';
					}
				}
				$this->view->searchlist = $searchListArr;
				$this->view->restid = $resid;
				$this->view->pax = $request->pax;
				$this->view->date = $request->date;
				$this->view->time = $request->time;
				$this->view->paymentStatus = $payStat;

				$resDataMapper = new FirmManagement_Model_FirmDataMapper();
				$restid = new FirmManagement_Model_FirmById();
				$restid->setRestaurantId($resid);
				$resDetails = $resDataMapper->getRestaurantById($restid);
								
				$this->view->resDetails = $resDetails;
				$this->view->resName = $resDetails->getRestaurantname();
				$this->view->resAddress = $resDetails->getRestaddress();
				$this->view->resPhone	= $resDetails->getRestphone();
				$this->view->restid = $resid;
				$this->view->postBool = $postBool;
				$this->view->maxPartyStatus = $maxPartyAllowed;
				$this->view->maxParty = $maxParty;
				$this->view->minParty = $minParty;			
			}else{
				$this->view->restid = $resid;
				$mapper = new FirmManagement_Model_FirmDataMapper();
				$this->view->mealTypes = $this->_reservationService->getRestaurantMealTypes($request);
				$owner = new FirmManagement_Model_OwnerByRestaurantId();
				$owner->setRestaurantId($resid);
				$resownername = $mapper->getOwnerByRestId($owner);
				$restList = '';
				if($resownername){
					$restNameByOwnObj = new FirmManagement_Model_FirmNamesByOwnerId();
					$restNameByOwnObj->setRestOwnerId($resownername->getRestUser());
					$restList   = $mapper->getRestaurantDataByOwnerId($restNameByOwnObj);
					$this->view->restList = $restList;
				}
				$dateArray = $this->_reservationService->getDatesBetweenDateRangeforwidget($request);
				$this->view->dateArray = $dateArray;
				$this->view->postBool = $postBool;
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function bookingdetailsmobilewidgetAction()
	{
		try{
			$request = $this->getRequest();
			$stateId = "";
			$cityId = "";
			$regionId = "";
			
			$restid = $request->restaurantid;
			$mapper = new FirmManagement_Model_FirmDataMapper();
			$result = $mapper->GetSpecialRequestSetting($restid);
			$this->view->splreq = $result->resspecial_request;
			if($this->getRequest()->isPost()){
				if($result = $this->_reservationService->BookingDetails($this->getRequest()->getPost(),$stateId,$cityId,$regionId)){
					if($result){
						if(!$result['result']){
							$form = $this->_reservationService->getBookingDetailsForm();
							$payStat = 'false';
							if(!$request->specialid){
								$payService = new Application_Service_Renumeration();
								$dateSplit = explode("-",$request->resdate);
								$s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
								$weekdate = date("Y-m-d", $s);
								
								$payResult = $payService->GetRestaurantPaymentSettingsByResId($request->restaurantid,$weekdate);	
								$payStat = 'false';
								$payType = '';
								if($payResult){
									$payType = $payResult['rpsnoshow_type'];
									$this->view->payType = $payType; 
									$this->view->payAmt = $payResult['payamount'];
									if($request->respax >= $payResult['paypax']){		
										$payStat = 'true';
									}
								}
							}
							
							$request = $this->getRequest();
							$formData  = array('resId'=>(int)$request->restaurantid,
				                           'resName'=>$request->resname,
				                           'resAddress'=>$request->resaddress,
				                           'resDate'=>$request->resdate,
				                           'resTime'=>$request->restime,
				                           'pax'=>$request->respax,
										   'inventoryid'=>$request->inventoryid,
										   'paymentStatus'=>$payStat
				
							);
							
							$dateSplit = explode("-",$request->resdate);
							$s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
							$this->view->resdate = date('D d M Y',$s);
							$this->view->resname = $request->resname;
							$this->view->resaddress = $request->resaddress;
							$this->view->restime = $request->restime;
							$this->view->respax = $request->respax;
							$this->view->bookingstatus = $request->bookingstatus;
							$this->view->restaurantid = $request->restaurantid;
							$this->view->tablesize = $request->tablesize;
							$this->view->nooftables = $request->nooftables;
							$this->view->specialid  = $request->specialid;
							$this->view->booktype   = $request->booktype;
							$this->view->specialamt = $request->specialamt;
				
							$auth = Zend_Auth::getInstance();
							$data = array();
							if($auth->hasIdentity()){
								$storage = new Zend_Auth_Storage_Session();
								$data = $storage->read();
								$this->view->userdata = $data;
								$formData['firstName'] = $data['Firstname'];
								$formData['lastName'] = $data['LastName'];
								$formData['number'] = $data['Phone'];
								$formData['email'] = $data['Email'];
								$formData['userid'] = $data['User_Id'];
								//$formData['notificationType'] = ;
							}
							$form->populate($formData);
							$this->view->form = $form;
						}else{
							$paymentStatus = $request->paymentStatus;
							if($paymentStatus == 'true'){
								$this->view->cusprofId = $result['profileId'];
								$this->view->paymentprofId = $result['payment'];
								$this->view->bookingid = $result['result'];
								$this->view->userid = $result['userId'];
								$this->view->resid = $request->restaurantid;
							}else{
								$bookedData = $result['result'];
								$resid = $request->restaurantid;
								$this->_helper->redirector('confirmmobilewidgetbooking','Reservations','Phone',array('bokid'=>$bookedData,'resid'=>$resid,'bokstat'=>true));
							}
						}
					}
				}
			}else{
				$form = $this->_reservationService->getBookingDetailsForm();
				$weekdate = $request->resdate;
				$payStat = 'false';
							
				$request = $this->getRequest();
				$formData  = array('resId'=>(int)$request->restaurantid,
	                           'resName'=>$request->resname,
	                           'resAddress'=>$request->resaddress,
	                           'resDate'=>$request->resdate,
	                           'resTime'=>$request->restime,
	                           'pax'=>$request->respax,
							   'inventoryid'=>$request->inventoryid,
							   'paymentStatus'=>$payStat
	
				);
	
				$dateSplit = explode("-",$request->resdate);
				$s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
				$this->view->resdate = date('D d M Y',$s);
				$this->view->resname = $request->resname;
				$this->view->resaddress = $request->resaddress;
				$this->view->restime = $request->restime;
				$this->view->respax = $request->respax;
				$this->view->bookingstatus = $request->bookingstatus;
				$this->view->restaurantid = $request->restaurantid;
				$this->view->tablesize = $request->tablesize;
				$this->view->nooftables = $request->nooftables;
				$this->view->specialid  = $request->specialid;
				$this->view->booktype   = $request->booktype;
				$this->view->specialamt = $request->specialamt;
				
				$auth = Zend_Auth::getInstance();
				$data = array();
				if($auth->hasIdentity()){
					$storage = new Zend_Auth_Storage_Session();
					$data = $storage->read();
					$this->view->userdata = $data;
					$formData['firstName'] = $data['Firstname'];
					$formData['lastName'] = $data['LastName'];
					$formData['number'] = $data['Phone'];
					$formData['email'] = $data['Email'];
					$formData['userid'] = $data['User_Id'];
					//$formData['notificationType'] = ;
				}
				
				$form->populate($formData);
				$resservice = new Application_Service_Firm();
				$bokoptionstatus = $resservice->getBookingOptionsSetting($request->restaurantid);
				if($bokoptionstatus->resbookingoption_setting){
					$bookingoptions = $this->_reservationService->getBookingOptionsByresId($request);
					if(count($bookingoptions) > 1){
						$form->bokoptions->addMultiOptions($bookingoptions);
						$this->view->bokoptionsts   = true;
					}else{
						$this->view->bokoptionsts   = false;
					}							
				}else{
					$this->view->bokoptionsts   = false;
				}	
				$this->view->form = $form;
			}
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function confirmmobilewidgetbookingAction()
	{
		try{

			$request = $this->getRequest();
			if(isset($request->bokstat)){
				$this->view->bokStat = $request->bokstat;
			}else{
				$this->view->bokStat = '';
			}
			$restId = $request->resid;
			$bokid   = $request->bokid;
			$result = $this->_reservationService->GetBookingDetailsByPhraseId($bokid);
			$this->view->bookedData = $result;
			$this->view->restaurantid = $restId;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function notifyfriendswidgetmblAction()
	{
		try{
			$request = $this->getRequest();
			$bokid   = $request->bokid;
			$restId = $request->restid;
			$bokStat = $request->bokstat;
			$result = $this->_reservationService->GetBookingDetailsByPhraseId($bokid);
			$this->view->bookedData = $result;
			$this->view->restaurantid = $restId;
			$this->view->bokStat = $bokStat;
			$this->view->bokid = $bokid;
			$this->view->splname = $request->splname;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function widgetnotifymailmobileAction()
	{
		try{
			$notificationService = new Application_Service_Communication();		
			$request = $this->getRequest();	
			if($notificationService->WidgetNotifyFriendsEmail($request)){
				$this->view->isSubmit_ = true;
				return 	$this->_helper->redirector('confirmmobilewidgetbooking','Reservations','Phone',array('bokid'=>$request->bokid,'resid'=>$request->resid,'bokstat'=>$request->bokstat));
			}
			
			return $this->_helper->redirector('widgetindexmobile','Reservations','Phone',array('restid'=>$request->resid));
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function getrestwebsitebyrestidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$mapper = new FirmManagement_Model_FirmDataMapper();
			$restNameByOwnObj = new FirmManagement_Model_FirmNamesByOwnerId();
			$restNameByOwnObj->setRestId($request->restid);
			$result   = $mapper->getRestaurantDataByOwnerId($restNameByOwnObj);
			foreach($result as $row){
				if($row['reswebsite']){
					echo $row['reswebsite'];
				}else{
					echo 'f';
				}
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function widgetsplviewallAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$request = $this->getRequest();
			$searchList = array();
			$searchListArr = array();
			$postBool = false;
			$resid = '';
			if($request->where){
				$resid = $request->where;
			}else{
				$resid = $request->restid;
			}
			$restService = new Application_Service_Firm();

			/* Get Widget Theme Start */
			
			$theme = $restService->GetWidgetThemeByRestId($request);
			$this->view->theme = $theme;
			
			/* Get Widget Theme End */
			if($this->getRequest()->isPost()){
				$postBool = true;
				$resttimings = new Reservation_Model_GetRestaurantTimings();
				
				$resttimings->setDate($request->date);
				$resttimings->setRestId($resid);
				$resttimings->setTime($request->time);
				$resttimings->setpartysize($request->pax);
				$resttimings->setschtype('viewall');
				if($request->date){
					$dateSplit = explode("-",$request->date);
					$weekday = date("D", mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]));
					
					$weekRecurrObj    = new Application_Model_WeekRecurr();
					$weekRecurrMapper = new Application_Model_WeekRecurrDataMapper();
					$weekRecurrObj->setcode(strtolower($weekday));
					$weekRecurrRes = $weekRecurrMapper->getWeekDayIdByCode($weekRecurrObj);
					$resttimings->setDay(strtolower($weekday));																
					$resttimings->setWeekDayId($weekRecurrRes->getId());				
				}
				$page = '';
				if($request->page){
					$page = $request->page;
				}else{
					$page = 1;
				}
				$detailsMapper = new Reservation_Model_SearchListViewDataMapper();
				$searchList = $detailsMapper->getRestSplTimings($resttimings,$page);
				$index = 0; 
				$val = 0;
				$limit = '';
				$offset = '';
				if($searchList[0]){
					$offset = count($searchList[0]);
					if($theme && $theme['rwt_theme_style'] == 'H'){
						$limit = 2;
					}else{
						$limit = 4;
					}
					
					
					foreach($searchList[0] as $listval){
						$val++;
						
						if($listval->getTimesArray()){
							foreach($listval->getTimesArray() as $value){
								if($value['status'] == 'WAL'){
									continue;
								}else{
									$searchListArr[$index] = $value;
									$index++;
								} 
							}
							$listval->setTimesArray($searchListArr);
						}
						
					}
				}
				$dateSplit = explode("-",$request->date);
				$s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
				$weekdate = date("Y-m-d", $s);
				
				$this->view->searchlist = $searchList[0];
				$this->view->restid = $resid;
				$pax = $request->pax;
				$date = $request->date;
				$this->view->pax = $request->pax;
				$this->view->date = $request->date;
				$this->view->time = $request->time;
//				$this->view->paymentStatus = $payStat;
				$this->view->offset = $offset;
				$this->view->limit = $limit;
				$this->view->splFrom = $request->splFrom;
				$this->view->page = $page;

				$resDataMapper = new FirmManagement_Model_FirmDataMapper();
				$restid = new FirmManagement_Model_FirmById();
				$restid->setRestaurantId($resid);
				$resDetails = $resDataMapper->getRestaurantById($restid);
				$this->view->resDetails = $resDetails;
				$this->view->resName = $resDetails->getRestaurantname();
				$this->view->resAddress = $resDetails->getRestaddress();
                                $this->view->resCompanyid = $resDetails->getcompanyid();
				$this->view->restid = $resid;
				$this->view->postBool = $postBool;
			}else{
				$postBool = true;
				$resttimings = new Reservation_Model_GetRestaurantTimings();
				
				$resttimings->setDate(date('m-d-Y'));
				$resttimings->setRestId($resid);
				$resttimings->setTime(date('h:i A'));
				$resttimings->setpartysize(2);
				$resttimings->setschtype('viewall');
				if(date('m-d-Y')){
					$dateSplit = explode("-",date('m-d-Y'));
					$weekday = date("D", mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]));
					
					$weekRecurrObj    = new Application_Model_WeekRecurr();
					$weekRecurrMapper = new Application_Model_WeekRecurrDataMapper();
					$weekRecurrObj->setcode(strtolower($weekday));
					$weekRecurrRes = $weekRecurrMapper->getWeekDayIdByCode($weekRecurrObj);
					$resttimings->setDay(strtolower($weekday));																
					$resttimings->setWeekDayId($weekRecurrRes->getId());				
				}
				$page = '';
				if($request->page){
					$page = $request->page;
				}else{
					$page = 1;
				}
				$detailsMapper = new Reservation_Model_SearchListViewDataMapper();
				$searchList = $detailsMapper->getRestSplTimings($resttimings,$page);
				$index = 0; 
				$val = 0;
				$limit = '';
				$offset = '';
				if($searchList[0]){
					$offset = count($searchList[0]);
					if($theme && $theme['rwt_theme_style'] == 'H'){
						$limit = 2;
					}else{
						$limit = 10;
					}
					
					
					foreach($searchList[0] as $listval){
						$val++;
						
						if($listval->getTimesArray()){
							foreach($listval->getTimesArray() as $value){
								if($value['status'] == 'WAL'){
									continue;
								}else{
									$searchListArr[$index] = $value;
									$index++;
								} 
							}
							$listval->setTimesArray($searchListArr);
						}
						
					}
				}
				$dateSplit = explode("-",date('m-d-Y'));
				$s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
				$weekdate = date("Y-m-d", $s);
				
				$this->view->searchlist = $searchList[0];
				$this->view->restid = $resid;
				$pax = 2;
				$date = date('m-d-Y');
				$this->view->pax = 2;
				$this->view->date = date('m-d-Y');
				$this->view->time = date('h:i A');
				$this->view->offset = $offset;
				$this->view->limit = $limit;
				$this->view->splFrom = 'viewall';
				$this->view->page = $page;

				$resDataMapper = new FirmManagement_Model_FirmDataMapper();
				$restid = new FirmManagement_Model_FirmById();
				$restid->setRestaurantId($resid);
				$resDetails = $resDataMapper->getRestaurantById($restid);
				$this->view->resDetails = $resDetails;
				$this->view->resName = $resDetails->getRestaurantname();
				$this->view->resAddress = $resDetails->getRestaddress();
                                $this->view->resCompanyid = $resDetails->getcompanyid();
				$this->view->restid = $resid;
				$this->view->postBool = $postBool;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function dealsplbookingdetailswidgetAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$request = $this->getRequest();
			$searchList = array();
			$searchListArr = array();
			$postBool = false;
			$resid = '';
			$check = '';
			if($request->where){
				$resid = $request->where;
			}else{
				$resid = $request->restid;
			}
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->view->userlogstat = 'true';
			}else{
				$this->view->userlogstat = 'false';
			}
			$restService = new Application_Service_Firm();

			/* Get Widget Theme Start */
			
			$theme = $restService->GetWidgetThemeByRestId($request);
			$this->view->theme = $theme;
			
			/* Get Widget Theme End */
			if($this->getRequest()->isPost()){
				$postBool = true;
				$resttimings = new Reservation_Model_GetRestaurantTimings();
				$resttimings->setDate($request->date);
				$resttimings->setRestId($resid);
				$resttimings->setTime($request->time);
				$resttimings->setpartysize($request->pax);
				$resttimings->setSplId($request->splid);
				$resttimings->setschtype($request->splFrom);
				$resttimings->setschtype('viewall');
				if($request->date){
					$dateSplit = explode("-",$request->date);
					$weekday = date("D", mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]));
					
					$weekRecurrObj    = new Application_Model_WeekRecurr();
					$weekRecurrMapper = new Application_Model_WeekRecurrDataMapper();
					$weekRecurrObj->setcode(strtolower($weekday));
					$weekRecurrRes = $weekRecurrMapper->getWeekDayIdByCode($weekRecurrObj);
					$resttimings->setDay(strtolower($weekday));																
					$resttimings->setWeekDayId($weekRecurrRes->getId());				
				}
				$page = '';
				if($request->page){
					$page = $request->page;
				}else{
					$page = 1;
				}
				$specialMapper = new Application_Service_Deals();
				$specialCount = new Deals_Model_RestaurantSpecialCounter();
				$specialCount->setSpecialId($request->splid)
							 ->setRestaurantid($resid);
				$specialCounter = $specialMapper->SpecialCountIncrementer($specialCount);
				
				$detailsMapper = new Reservation_Model_SearchListViewDataMapper();
				$searchList = $detailsMapper->getRestSplTimings($resttimings,$page);
				$index = 0; 
				$val = 0;
				$offset = '';
				$limit = '';
				$statLtd = '';
				if($searchList[0]){
					$offset = count($searchList[0]);
					if($theme && $theme['rwt_theme_style'] == 'H'){
						$limit = 1;
					}else{
						$limit = 2;	
					}
				
					
					foreach($searchList[0] as $listval){
						$val++;
						
						if($listval->getTimesArray()){
							foreach($listval->getTimesArray() as $value){
								if($value['status'] == 'WAL'){
									continue;
								}else{
									$searchListArr[$index] = $value;
									$index++;
								} 
							}
							$statLtd = 'true';
							$listval->setTimesArray($searchListArr);
						}
						
					}
				}
				$dateSplit = explode("-",$request->date);
				$s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
				$weekdate = date("Y-m-d", $s);
				
				$this->view->searchlist = $searchList[0];
				if($statLtd){
					$this->view->check = $check;
				}else{
					$this->view->check = 'false';
				}
				$this->view->restid = $resid;
				$pax = $request->pax;
				$date = $request->date;
				$this->view->pax = $request->pax;
				$this->view->date = $request->date;
				$this->view->time = $request->time;
				$this->view->offset = $offset;
				$this->view->limit = $limit;
				$this->view->page = $page;
				$this->view->splFrom = $request->splFrom;
				$this->view->splid = $request->splid;

				$resDataMapper = new FirmManagement_Model_FirmDataMapper();
				$restid = new FirmManagement_Model_FirmById();
				$restid->setRestaurantId($resid);
				$resDetails = $resDataMapper->getRestaurantById($restid);
				$this->view->resDetails = $resDetails;
				$this->view->resName = $resDetails->getRestaurantname();
				$this->view->resAddress = $resDetails->getRestaddress();
				$this->view->restid = $resid;
				$this->view->postBool = $postBool;
			}else{
				$postBool = true;
				$resttimings = new Reservation_Model_GetRestaurantTimings();
				$todDate = date('m-d-Y');
				$todTime = date('h:i A');
				$resttimings->setDate($todDate);
				$resttimings->setRestId($resid);
				$resttimings->setTime(date('h:i A'));
				$resttimings->setpartysize(2);
				$resttimings->setSplId($request->splid);
				$resttimings->setschtype('viewall');
				$resttimings->setschtype('viewall');
				if($todDate){
					$dateSplit = explode("-",$todDate);
					$weekday = date("D", mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]));
					
					$weekRecurrObj    = new Application_Model_WeekRecurr();
					$weekRecurrMapper = new Application_Model_WeekRecurrDataMapper();
					$weekRecurrObj->setcode(strtolower($weekday));
					$weekRecurrRes = $weekRecurrMapper->getWeekDayIdByCode($weekRecurrObj);
					$resttimings->setDay(strtolower($weekday));																
					$resttimings->setWeekDayId($weekRecurrRes->getId());				
				}
				$page = '';
				if($request->page){
					$page = $request->page;
				}else{
					$page = 1;
				}
				$specialMapper = new Application_Service_Deals();
				$specialCount = new Deals_Model_RestaurantSpecialCounter();
				$specialCount->setSpecialId($request->splid)
							 ->setRestaurantid($resid);
				$specialCounter = $specialMapper->SpecialCountIncrementer($specialCount);
				
				$detailsMapper = new Reservation_Model_SearchListViewDataMapper();
				$searchList = $detailsMapper->getRestSplTimings($resttimings,$page);
				$index = 0; 
				$val = 0;
				$offset = '';
				$limit = '';
				$statLtd = '';
				if($searchList[0]){
					$offset = count($searchList[0]);
					if($theme && $theme['rwt_theme_style'] == 'H'){
						$limit = 1;
					}else{
						$limit = 2;	
					}
				
					
					foreach($searchList[0] as $listval){
						$val++;
						
						if($listval->getTimesArray()){
							foreach($listval->getTimesArray() as $value){
								if($value['status'] == 'WAL'){
									continue;
								}else{
									$searchListArr[$index] = $value;
									$index++;
								} 
							}
							$statLtd = 'true';
							$listval->setTimesArray($searchListArr);
						}
						
					}
				}
				$dateSplit = explode("-",$todDate);
				$s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
				$weekdate = date("Y-m-d", $s);
				
				$this->view->searchlist = $searchList[0];
				if($statLtd){
					$this->view->check = $check;
				}else{
					$this->view->check = 'false';
				}
				$this->view->restid = $resid;
				$pax = 2;
				$date = $todDate;
				$this->view->pax = 2;
				$this->view->date = $todDate;
				$this->view->time = $todTime;
				$this->view->offset = $offset;
				$this->view->limit = $limit;
				$this->view->page = $page;
				$this->view->splFrom = 'viewall';
				$this->view->splid = $request->splid;

				$resDataMapper = new FirmManagement_Model_FirmDataMapper();
				$restid = new FirmManagement_Model_FirmById();
				$restid->setRestaurantId($resid);
				$resDetails = $resDataMapper->getRestaurantById($restid);
				$this->view->resDetails = $resDetails;
				$this->view->resName = $resDetails->getRestaurantname();
				$this->view->resAddress = $resDetails->getRestaddress();
				$this->view->restid = $resid;
				$this->view->postBool = $postBool;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function widgetsplbookingpurchaserdetailsAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$request = $this->getRequest();
			$respl = $request->ressplName;
			$stateId = "";
			$cityId = "";
			$regionId = "";
			
			$restService = new Application_Service_Firm();
			/* Get Widget Theme Start */
			
			$theme = $restService->GetWidgetThemeByRestId($request);
			$this->view->theme = $theme;
			
			/* Get Widget Theme End */
			$restid = $request->restaurantid;
			$mapper = new FirmManagement_Model_FirmDataMapper();
			$result = $mapper->GetSpecialRequestSetting($restid);
			$this->view->splreq = $result->resspecial_request;
			
			$otpmapper = new FirmManagement_Model_FirmDataMapper();
			$otpResult = $otpmapper->GetOtpSettingStatus($restid);
			if($otpResult->resotp_setting){
				$this->view->otpresult = 'true';
			}else{
				$this->view->otpresult = 'false';
			}
			if($this->getRequest()->isPost() && $request->splFrom != 'widgetsplbooking'){
				if($result = $this->_reservationService->BookingDetails($this->getRequest()->getPost(),$stateId,$cityId,$regionId)){
					if($result){
						if(!$result['result']){
							$form = $this->_reservationService->getBookingDetailsForm();
							$payStat = 'false';
							if($request->specialid){	
								$dateSplit = explode("-",$request->resdate);
								$s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
								$weekdate = date("Y-m-d", $s);
								
								$splService = new Application_Service_Deals();	
								$splResult = $splService->GetWidgetSpecialDetailsById($request->restaurantid,$request->specialid,false);
								if($splResult->getCatTypeCode() == 'SP'){
									$payStat = 'true';
									$this->view->splTransactType = 'SPLPAID';
								}else if($splResult->getCatTypeCode() == 'CP'){
									$payStat = 'true';
									$this->view->splTransactType = 'SPLPAID';
								}
							}
							
							$request = $this->getRequest();
							$formData  = array('resId'=>(int)$request->restaurantid,
				                           'resName'=>$request->resname,
				                           'resAddress'=>$request->resaddress,
				                           'resDate'=>$request->resdate,
				                           'resTime'=>$request->restime,
				                           'pax'=>$request->respax,
										   'inventoryid'=>$request->inventoryid,
										   'paymentStatus'=>$payStat
				
							);
				
					
							$this->view->resdate = date('D d M Y',$s);
							$this->view->date = $weekdate;
							$this->view->resname = $request->resname;
							$this->view->resaddress = $request->resaddress;
							$this->view->restime = $request->restime;
							$this->view->respax = $request->respax;
							$this->view->bookingstatus = $request->bookingstatus;
							$this->view->restaurantid = $request->restaurantid;
							$this->view->tablesize = $request->tablesize;
							$this->view->nooftables = $request->nooftables;
							$this->view->specialid  = $request->specialid;
							$this->view->booktype   = $request->booktype;
							$this->view->specialamt = $request->specialamt;
							$this->view->ressplName = $request->ressplName;
							$this->view->splResult = $splResult;
							$auth = Zend_Auth::getInstance();
							$data = array();
							if($auth->hasIdentity()){
								$storage = new Zend_Auth_Storage_Session();
								$data = $storage->read();
								$this->view->userdata = $data;
								$formData['firstName'] = $data['Firstname'];
								$formData['lastName'] = $data['LastName'];
								$formData['number'] = $data['Phone'];
								$formData['email'] = $data['Email'];
								$formData['userid'] = $data['User_Id'];
							}

							$form->populate($formData);
							$this->view->form = $form;
						}else{
							$paymentStatus = $request->paymentStatus;
							if($request->specialid){	
								$dateSplit = explode("-",$request->resdate);
								$s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
								$weekdate = date("Y-m-d", $s);
								$splService = new Application_Service_Deals();	
								$splResult = $splService->GetWidgetSpecialDetailsById($request->restaurantid,$request->specialid,false);
								if($splResult->getCatTypeCode() == 'SP'){
									$payStat = 'true';
									$this->view->splTransactType = 'SPLPAID';
								}else if($splResult->getCatTypeCode() == 'CP'){
									$payStat = 'true';
									$this->view->splTransactType = 'SPLPAID';
								}
							}
							$bookedData = $result['result'];
								$resid = $request->restaurantid;
								$respl = $request->ressplName;
								$this->_helper->redirector('dealsplbookingconfirmwidget','Reservations','Phone',array('bokid'=>$bookedData,'resid'=>$resid,'ressplName'=>$request->ressplName,'bokstat'=>true));
							
						}
					}
				}
			}else{
				$form = $this->_reservationService->getBookingDetailsForm();
			
				$dateSplit = explode("-",$request->resdate);
				$s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
				$weekdate = date("Y-m-d", $s);
				$payStat = 'false';
				if($request->specialid){	
					$splService = new Application_Service_Deals();	
					$splResult = $splService->GetWidgetSpecialDetailsById($request->restaurantid ,$request->specialid,false);
					if($splResult->getCatTypeCode() == 'SP'){
						$payStat = 'true';
						$this->view->splTransactType = 'SPLPAID';
					}else if($splResult->getCatTypeCode() == 'CP'){
						$payStat = 'true';
						$this->view->splTransactType = 'SPLPAID';
					}
				}			
				$request = $this->getRequest();
				$formData  = array('resId'=>(int)$request->restaurantid,
	                           'resName'=>$request->resname,
	                           'resAddress'=>$request->resaddress,
	                           'resDate'=>$request->resdate,
	                           'resTime'=>$request->restime,
	                           'pax'=>$request->respax,
							   'inventoryid'=>$request->inventoryid,
							   'paymentStatus'=>'false'
	
				);
	
				$this->view->splResult = $splResult;
				$this->view->resdate = date('D d M Y',$s);
				$this->view->resname = $request->resname;
				$this->view->resaddress = $request->resaddress;
				$this->view->restime = $request->restime;
				$this->view->date = $weekdate;
				$this->view->respax = $request->respax;
				$this->view->bookingstatus = $request->bookingstatus;
				$this->view->restaurantid = $request->restaurantid;
				$this->view->tablesize = $request->tablesize;
				$this->view->nooftables = $request->nooftables;
				$this->view->specialid  = $request->specialid;
				$this->view->booktype   = $request->booktype;
				$this->view->specialamt = $request->specialamt;
				$this->view->ressplName = $request->ressplName;
				
				$auth = Zend_Auth::getInstance();
				$data = array();
				if($auth->hasIdentity()){
					$storage = new Zend_Auth_Storage_Session();
					$data = $storage->read();
					$this->view->userdata = $data;
					$formData['firstName'] = $data['Firstname'];
					$formData['lastName'] = $data['LastName'];
					$formData['number'] = $data['Phone'];
					$formData['email'] = $data['Email'];
					$formData['userid'] = $data['User_Id'];
				}	
				$form->populate($formData);
				$resservice = new Application_Service_Firm();
				$optionsetting = $resservice->getBookingOptionsSetting($request->restaurantid);
				if($optionsetting->resbookingoption_setting){
					$bookingoptions = $this->_reservationService->getBookingOptionsByresId($request);
					if(count($bookingoptions) > 1){
						$form->bokoptions->addMultiOptions($bookingoptions);
						$this->view->bokoptionsts   = true;
					}else{
						$this->view->bokoptionsts   = false;
					}							
				}else{
					$this->view->bokoptionsts   = false;
				}
				$this->view->form = $form;
			}
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function dealsplbookingconfirmwidgetAction()
	{
		try{
			$this->_helper->layout->disableLayout();

			$request = $this->getRequest();
			if(isset($request->bokstat)){
				$this->view->bokStat = $request->bokstat;
			}else{
				$this->view->bokStat = '';
			}
			$restId = $request->resid;
			$bokid   = $request->bokid;
			$result = $this->_reservationService->GetBookingDetailsByPhraseId($bokid);
			$this->view->bookedData = $result;
			$this->view->restaurantid = $restId;
			$this->view->ressplName = $request->ressplName;
			$restService = new Application_Service_Firm();
			/* Get Widget Theme Start */
			
			$theme = $restService->GetWidgetThemeByRestId($request);
			$this->view->theme = $theme;
			
			/* Get Widget Theme End */
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}

	}
	
/**	
	 * 	action to retreive the customer details by id 
	 */	
	public function customerdetailsbyidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			if($request->customerid){
				$result = $this->_restaurantService->GetCustomerDetailsArr($request);
				echo json_encode($result);

			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function customernamesajaxAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$text = trim($request->firstname);
			$lastname = $request->lastname;
			$restid = $request->restaurantid;
			$result = $this->_restaurantService->getCustomerNames($text,$restid,$lastname);
			$list = array();
			$cusListArr = null;
			if($result){

				foreach($result as $key=>$value){
					$list[] = array('rgu' => array("key"=>$key,"value"=>$value));
				}
			}
			if(count($list) > 0){
				$cusListArr = array('cuslist'=>$list);
				$cusJson = json_encode($cusListArr);
				echo $cusJson;
			}else{
				//$test = "f";
				$cusJson = json_encode("f");
				echo $cusJson;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function customercontactsAction()
	{
		try{
			$this->_helper->layout->setLayout('mobilelayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				if($request->restaurantid){
					$resStat = $this->_restaurantService->AuthenticateRestByAuth($data,$request->restaurantid);
				}else{
					$resStat = false;
				}
				if($resStat){
					$restid = $request->restaurantid;
					$page = $this->_request->getParam('page');
					$text = $this->_request->getParam('searchcontact');
					if (empty($page)){
						$page = 1;
					}
					if($this->getRequest()->isPost()){
						$request = $this->getRequest()->getPost();
						$result = $this->_restaurantService->getCustomerContacts($page,$restid,$text);
					}else{
						$result = $this->_restaurantService->getCustomerContacts($page,$restid,$text);
					}
					$this->view->text = $text;
					$this->view->resultSet = $result;
					$this->view->restaurantid = $restid;
				}
				$this->view->secureLoginStatus = $resStat;				
			}else{
				 $this->_helper->redirector('mlogin','Authenticate','Phone');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function customercontactdetailsAction()
	{
		try{
			$this->_helper->layout->setLayout('mobilelayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				if($request->restaurantid){
					$resStat = $this->_restaurantService->AuthenticateRestByAuth($data,$request->restaurantid);
				}else{
					$resStat = false;
				}
				if($resStat){
					if($request->customerid){
						$result = $this->_restaurantService->GetCustomerDetailsArr($request);
						$this->view->resultSet = $result;
						$this->view->restaurantid = $request->restaurantid;
					}
				}
				$this->view->secureLoginStatus = $resStat;				
			}else{
				 $this->_helper->redirector('mlogin','Authenticate','Phone');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function restfreezeAction()
	{
		try{
			$this->_helper->layout->setLayout('mobilelayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				 if($request->restaurantid){
					$resStat = $this->_restaurantService->AuthenticateRestByAuth($data,$request->restaurantid);
				}else{
					$resStat = false;
				}
				if($resStat){
					$restid = $request->restaurantid;
					$dateArray = $this->_reservationService->getDatesBetweenDateRange($request);
					$restinfo  = $this->_restaurantService->GetRestaurantNamesById($restid);
					$frzDates  = $this->_reservationService->GetFreezedDates($request);
					
					$MealTypeDataMapper = new FirmManagement_Model_FirmMealTypeDataMapper();
					$mealSettings = $MealTypeDataMapper->GetMealSettingsByRestId($restid);
					
					$timeZone = $this->_restaurantService->GetRestaurantTimeZone($restid);
					date_default_timezone_set($timeZone);
					foreach($frzDates as $key=>$value){
						$datSplit = explode('/',$value);
						$value = date('Y-m-d',mktime(0,0,0,$datSplit[0],$datSplit[1],$datSplit[2]));
						$frzDates[$key] = $value;
					}
						
					$this->view->restinfo   = $restinfo;
					$this->view->dateArray  = $dateArray;
					$this->view->frzDates	= $frzDates;
					$this->view->mealtypes  = $mealSettings;
	
					if(isset($request->date)){
						$datSplit = explode('-',$request->date);
						$date = date('Y-m-d',mktime(0,0,0,$datSplit[0],$datSplit[1],$datSplit[2]));
						$this->view->seldate   = $date;
					}else{
						$date = date('Y-m-d');
						$this->view->seldate   = $date;
					}
					
					$this->view->restaurantid = $restid;
				}
				$this->view->secureLoginStatus = $resStat;
			}else{
			 $this->_helper->redirector('mlogin','Authenticate','Phone');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function customernamesbyajaxAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$text = trim($request->firstname);
			$lastname = $request->lastname;
			$restid = $request->restaurantid;
			$result = $this->_restaurantService->getCustomerNames($text,$restid,$lastname);
			$list = array();
			$cusListArr = null;
			if($result){

				foreach($result as $key=>$value){
					$list[] = array('rgu' => array("key"=>$key,"value"=>$value));
				}
			}
			if(count($list) > 0){
				$cusListArr = array('cuslist'=>$list);
				$cusJson = json_encode($cusListArr);
				echo $cusJson;
			}else{
				//$test = "f";
				$cusJson = json_encode("f");
				echo $cusJson;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
    
    public function instantfeedbackAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$request = $this->getRequest();
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read(); 
			if(!isset($request->restaurantid)){
				$request->setParam('restaurantid',$data['RestId']);
			}
			if(isset($request->bookingid)){
				$result = $this->_reservationService->getCustomerDetailsByBookingId($request);
				$this->view->bookingResult = $result;
				$this->view->bookingid = $request->bookingid;
			}
			$CountryCodeMapper = new Application_Model_CountryCodeDataMapper();
			$CountryCode = $CountryCodeMapper->fetchAll();
			$CodeList = array();
			$CodeList[] = array('key'=>'','value'=>'Select Country Flag');
			foreach($CountryCode as $listcode){
				$CodeList[] = array('key'=>$listcode->getCountry_dial_code(),'value'=>$listcode->getCountry_flag());
			}
				
			$this->view->codelist = $CodeList;
			$restDataMapper = new FirmManagement_Model_FirmDataMapper();
			$countrycode = $restDataMapper->getCountrycodebyId($request->restaurantid);
			if($countrycode){
				$this->view->countrycode = $countrycode;
			}
			$result = $this->_reservationService->getFeedbackFormByRestaurantId($request);
			$this->view->feedbackForm = $result;
			$this->view->restaurantid = $request->restaurantid;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

}