<?php
/**
*	Name			: FirmController.php
*	Author			: Snehal
*	Creation Date	: 09/30/2010
*	Path 			: application/modules/FirmManagement/controllers/FirmController.php
*	Description		: This is controller class for the Manage Restaurant module.
*					   	
*/
class FirmManagement_FirmmarketingController extends Zend_Controller_Action
{

	/**
	 * Instance variable of restaurant service
	 * @var object
	 */
	protected $_firmService = null;

	/**
     * Initialize the restaurant service instance.
     */
	public function init()
	{
		if(!$this->_firmService){
			$this->_firmService	= new Application_Service_Firm();
		}
	}

	public function marketingwebviewAction()
	{
		$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout()->setLayout('marketing_webviews_layout');
				$request = $this->getRequest();
				$resid = $request->restaurantid;
				if(!isset($resid))
				{
					echo 'Invalid Request';die();
				}
				$data['RestId'] = $resid;
				$currentView = 'launchPage';
				$smsMaxLength = 160;
				//CHECK FOR RDINE LINK 
				$appNameSpace = new Zend_Session_Namespace('SMSData');
				$smsForRdineFlag = false;
				$rdineLinks = $appNameSpace->smsdata;
				if(array_key_exists($resid, $rdineLinks))
				{
					$smsForRdineFlag = true;
					$smsMaxLength -= strlen("BOOK ON ".$rdineLinks[$resid]);
				}
				$this->view->smsForRdineFlag = $smsForRdineFlag;
				$this->view->smsMaxLength = $smsMaxLength;

				$page = 1;
				if(isset($request->page))
				{
					$page = $request->page;
					$currentView = 'listPage';
				}


				if($request->isPost())
				{
			      
		       		$postData = $this->getRequest()->getPost();
		       		//INDIAN SMS GATEWAY ASUSUAL
		       		$status = $this->_firmService->sendSmsCampaignWithRdLabs($postData,$data);
		       		if($status == null)
		       		{
		       			$this->view->lowBalanceIndicator = true;

		       		}
		       		else {
		       			$currentView = 'listPage';
		       			$this->view->lowBalanceIndicator = false;	
		       		}
								
						
				}


				$smscampMapper = new FirmManagement_Model_SmsCampaignDataMapper();	
				$leftmessageMapper = new FirmManagement_Model_SmsRestaurantCampCountDataMapper();
				$leftmessage = 	$leftmessageMapper->getLeftMessagesCountByResid($resid);
				if($leftmessage == "noaccess")
				{
					echo '<h2>You dont have access to marketing contact Supprt team to gain access</h2>';
					die();
				}
				
				$this->view->leftMessages = $leftmessage;

				$this->view->urlResid = $resid;
				$contactGroups = $this->_firmService->getContactGroupsByResId($resid);

				$this->view->currentView = $currentView;
				$myCampaigns = $smscampMapper->GetSmsCampaignDetailsbyresId($data,$page);	
				$this->view->myCampaigns = $myCampaigns;
				$this->view->contactGroups = $contactGroups;
			}
			else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		
	}

	public function smscampdetailswebviewAction()
	{
		$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout()->setLayout('marketing_webviews_layout');
				$resid = $data['RestId'];
				$request = $this->getRequest();
				$campid = $request->smscampid;

				$this->view->campid = $campid;
				if(!isset($request->page))
				{
					$request->setParam('page',1);
				}

				if(!isset($campid))
				{
					echo 'Invalid Request';die();
				}

				$smscampMapper = new FirmManagement_Model_SmsCampaignDataMapper();
				$myCampaign = $smscampMapper->GetSmsCampaignDetailsbyId($campid,$resid);
				$this->view->resid = $resid;
				$this->view->myCampaign = $myCampaign;
				$campdetails = $this->_firmService->getSmsCampaignDetailsByCampid($request);
				$this->view->campDetails = $campdetails;
				$this->view->currentPage = $request->page;

			}
			else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
	}




}