<?php

class FirmManagement_Form_AddFirm extends Zend_Form
{

	public function init()
    {
    	 $this->setAttrib('enctype', 'multipart/form-data');
    	 
		 $list = array(
    	 		array('key'=>'Yes','value'=>' Yes'),
    	 		array('key'=>'No','value'=>' No')
    	 );
    	 
    	/* Populating Restaurant Type Base Data */
    	
    	$resTypeMapper  = new Application_Model_RestaurantTypeDataMapper();
    	$resTypes = $resTypeMapper->getRestauranttypeBD();
    	$resTypeList = array();
    	$resTypeList[] = array('key'=>'','value'=>'Select Restaurant Type');    	   
    	foreach($resTypes as $resType){
    		$resTypeList[] = array('key'=>$resType->getId(),'value'=>$resType->getDescription());
    	}   
    	
    	/* Populating State Base Data */
    	
    	$stateMapper  = new Application_Model_StateDataMapper();
    	$states = $stateMapper->fetchAll();
    	$stateList = array();  
    	$stateList[] = array('key'=>'','value'=>'Select Country');  	   
    	foreach($states as $state){
    		$stateList[] = array('key'=>$state->getId(),'value'=>$state->getDescription());
    	}  
    	$stateList[] = array('key'=>'find','value'=>"Can't Find Country");
    	
//    	$timezoneMapper = new Application_Model_TimeZoneDataMapper();
//    	$timezones = $timezoneMapper->fetchAll();
//    	$timezoneList = array();
//    	$timezoneList[] = array('key'=>'','value'=>'Select TimeZone');
//    	foreach($statetime as $timezone){
//    		$timezoneList[] = array('key'=>$timezone->id,'value'=>$timezone->description);
//    	}
    	
    	$paymentmodeMapper = new Application_Model_RestaurantPaymentModeDataMapper();
    	$paymentmodes = $paymentmodeMapper->fetchAll();
    	$paymentmodesList = array();
    	//$paymentmodesList[] = array('key'=>'','value'=>'Select Payment Mode');
    	foreach($paymentmodes as $paymentmode){
    		$paymentmodesList[] = array('key'=>$paymentmode->getId(),'value'=>$paymentmode->getDescription());
    	}
    	
    	$tagbdMapper = new FirmManagement_Model_FirmTagBdMapper();
    	$tagbds = $tagbdMapper->fetchAll();
    	$tagbdList = array();
    	foreach($tagbds as $tagbd){
    		$tagbdList[] = array('key'=>$tagbd->getId(),'value'=>$tagbd->getDescription());
    	}
    	
    	$priceMapper = new Application_Model_PriceDataMapper();
    	$prices = $priceMapper->fetchAll();
    	$priceList = array();
    	$priceList[] = array('key'=>'','value'=>'Select Price');
    	foreach($prices as $price){
    		$priceList[] = array('key'=>$price->getCode(),'value'=>$price->getCode());
    	}
    	
    	$CountryCodeMapper = new Application_Model_CountryCodeDataMapper();
    	$CountryCode = $CountryCodeMapper->fetchAll();
    	$CodeList = array();
    	$CodeList[] = array('key'=>'','value'=>'Select flag');
    	foreach($CountryCode as $listcode){
    		$CodeList[] = array('key'=>$listcode->getDescription(),'value'=>$listcode->getCode());
    	}
    	
    	//$diningStyleList[] = array('key'=>'','value'=>'Select Dining Style');
    	$diningStyleList = array(
    			array('key'=>'','value'=>'Select Dining Style'),
    			array('key'=>'Casual Elegant','value'=>'Casual Elegant'),
    			array('key'=>'Casual Dining','value'=>'Casual Dining'),
    			array('key'=>'Fine Dining','value'=>'Fine Dining'),
    			array('key'=>'Coffeehouse','value'=>'Coffeehouse'),
    			array('key'=>'Pizzeria','value'=>'Pizzeria'),
    			array('key'=>'Steakhouses','value'=>'Steakhouses'),
    			array('key'=>'Seafood Restaurants','value'=>'Seafood Restaurants')    	
    	);
    	
    	$paxList = array(
    			array('key'=>'0','value'=>'Select PartySize'),
    			array('key'=>'1','value'=>'1'),
    			array('key'=>'2','value'=>'2'),
    			array('key'=>'3','value'=>'3'),
    			array('key'=>'4','value'=>'4'),
    			array('key'=>'5','value'=>'5'),
    			array('key'=>'6','value'=>'6'),
    			array('key'=>'7','value'=>'7'),
    			array('key'=>'8','value'=>'8'),
    			array('key'=>'9','value'=>'9'),
    			array('key'=>'10','value'=>'10'),
    			array('key'=>'11','value'=>'11'),
    			array('key'=>'12','value'=>'12'),
    			array('key'=>'13','value'=>'13'),
    			array('key'=>'14','value'=>'14'),
    			array('key'=>'15','value'=>'15'),
    			array('key'=>'16','value'=>'16'),
    			array('key'=>'17','value'=>'17'),
    			array('key'=>'18','value'=>'18'),
    			array('key'=>'19','value'=>'19'),
    			array('key'=>'20','value'=>'20')    	
    	);
    	
    	/* Populating City Base Data */
    	
    	/*$cityMapper = new Application_Model_CityDataMapper();
    	$cityResults   = $cityMapper->fetchAll();
    	$cityList = array();
    	foreach($cityResults as $result){
    		$cityList[] = array('key'=>$result->getId(),'value'=>$result->getDescription());
    	}*/
    	
    	/* Populating Neighborhood Base Data */
    	
    	/*$neighborhodMapper  = new Application_Model_NeighborhoodDataMapper();
    	$neighborhodResults = $neighborhodMapper->fetchAll();
    	$neighborhodList    = array();
    	foreach($neighborhodResults as $result){
    		$neighborhodList[] = array('key'=>$result->getId(),'value'=>$result->getDescription());
    	}*/
    	
    	$restId = $this->createElement('hidden','restId');
    	$restId->removeDecorator('Label')
        	   ->removeDecorator('DtDdWrapper')
        	   ->removeDecorator('HtmlTag');
        	   
    	$restLatitude = $this->createElement('hidden','restLatitude');
    	$restLatitude->removeDecorator('Label')
        	   		 ->removeDecorator('DtDdWrapper');
        	   		 
    	$restLongitude = $this->createElement('hidden','restLongitude');
    	$restLongitude->removeDecorator('Label')
        	   		  ->removeDecorator('DtDdWrapper');
        	   		  
        $restaurantName = $this->createElement('text', 'restName');
        $restaurantName->removeDecorator('Label')
        			   ->removeDecorator('HtmlTag')
        			   ->setAttrib('maxlength', '255')
					   ->setAttrib('placeholder', 'Business Name')
        			   ->setAttrib('class','inp2 form required')  
        			   ->addFilters(array('StringTrim'))
        			   ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter your Restaurant Name.')),
        			   				array('StringLength', false,array(0,255))))
        			   ->setValue('')
        			   ->setRequired(true);
        			   
      	$restCapacity = $this->createElement('text', 'restCapacity');
      	$restCapacity->removeDecorator('Label')
      				 ->removeDecorator('HtmlTag')
      				 ->setAttrib('maxlength', '5')
					 ->setAttrib('placeholder', 'Restaurant Capacity')
      				  ->setAttrib('class','inp2 form required')  
      				 ->addFilters(array('StringTrim'))
      				 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter your Restaurant Capacity.')),
      				 				array('StringLength', false,array(0,5))))
      				 ->addValidator('Digits',new Zend_Validate_Digits(),array('messages' => 'Please enter Numbers only'))
      				 ->setValue('')
      				 ->setRequired(true);
        			   
		$restDiningStyle = $this->createElement('select','restDiningStyle');
		$restDiningStyle->removeDecorator('Label')
        			    ->removeDecorator('HtmlTag')
        			    ->setAttrib('maxlength', '100')
						->setAttrib('placeholder', 'Dining Style')
        			    ->setAttrib('class','inp2 form required')  
        			    ->addMultiOptions($diningStyleList)        			    
        			    ->setValue('')
        			    ->setRequired(false);

       	
        			   
		$resEmailAddress =  $this->createElement('text', 'emailAddress');
        $resEmailAddress ->removeDecorator('Label')
        				 ->removeDecorator('HtmlTag')        			     
        			     ->setAttrib('maxlength', '255')
						 ->setAttrib('placeholder', 'Email')
        				  ->setAttrib('class','inp2 form required')  
                		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter your Email Address.')),
                		 				array('StringLength', false,array(5,255))))
                		 ->addValidator('EmailAddress',false,array('messages'=>array(Zend_Validate_EmailAddress::INVALID =>'Please enter a valid Host Name')))
						 ->addErrorMessage('Pleaes Enter Valid Email Address')
                		 ->addFilters(array('StringTrim'))
               			 ->setRequired(true);  
		
	   /* $resYearFound =  $this->createElement('text', 'resYearFound');
        $resYearFound->removeDecorator('Label')
        			 ->removeDecorator('HtmlTag')        			 
        			 ->setAttrib('class','inp1')
        			 ->setAttrib('maxlength', '4')
                	 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter Year Found.')),
                	 				array('StringLength', false,array(4,4,'messages' => array(
              					Zend_Validate_StringLength::TOO_SHORT => "Year must be 4 digits"
              				)))))
                	 ->addValidator('Digits',new Zend_Validate_Digits(),array('messages' => 'Please enter Numbers only'))
					 ->addValidator(new Zend_Validate_Date(array("format" => 'yyyy')))
                     ->setValue('')
                	 ->setRequired(true);*/

        $maxpax = $this->createElement('select', 'maxpax');
        $maxpax->removeDecorator('Label') 
        		 ->removeDecorator('HtmlTag')
				 ->setAttrib('placeholder', 'Max Pax')
				 ->setAttrib('title', 'Maximum party size to accept from online')
        		 ->setAttrib('class','sel1 form')      		 
                 ->addMultiOptions($paxList)
                 ->setRequired(true);
                	 
         $restaurantType = $this->createElement('select','restype');
         $restaurantType->removeDecorator('Label') 
         				->removeDecorator('HtmlTag') 
         				->setAttrib('class','sel1 form') 
						->setAttrib('placeholder', 'Restaurant Type')
         				//->setAttrib('multiple', 'multiple')
         				->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select Restaurant Type.'))))
               			->addMultiOptions($resTypeList)
               			->setRegisterInArrayValidator(false)
               			->setRequired(true);
          //$restaurantType->size=5;
               			
          $resAddress = $this->createElement('text','resAddress');
          $resAddress->removeDecorator('Label')
        			 ->removeDecorator('HtmlTag')
        			 ->setAttrib('maxlength', '510')
					 ->setAttrib('placeholder', 'Address')
        			->setAttrib('class','inp2 form required')  
        			 ->addFilters(array('StringTrim'))
        			 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter your Restaurant Address.')),
			         					array('StringLength', false,array(1,510,'messages' => array(
              					Zend_Validate_StringLength::TOO_LONG => 'address is too long(>510).'
              				)))))        			               		 
               		 ->setValue('')	
        			 ->setRequired(true);
             
		 $resState = $this->createElement('select','resState');
         $resState->removeDecorator('Label') 
         		  ->removeDecorator('HtmlTag')
				  ->setAttrib('placeholder', 'State')
         		 ->setAttrib('class','inp2 form required')  
         		  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select State.'))))       	   
               	  ->addMultiOptions($stateList)
                  ->setRequired(true);
                  
         $resTimezone = $this->createElement('select','restimezone');
         $resTimezone->removeDecorator('Label')
	         		 ->removeDecorator('HtmlTag')
					 ->setAttrib('placeholder', 'Region')
	         		 ->setAttrib('class','sel1 drpDown')
	         		 ->setRegisterInArrayValidator(false)
	         		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select TimeZone.'))))       	     
	                 ->setRequired(true);
         
         $resPaymentMode = $this->createElement('multiCheckbox','resPayment');
         $resPaymentMode->removeDecorator('Label')
         			 ->removeDecorator('HtmlTag')
         			 ->setAttrib('class','sel1')
         			 ->setAttrib('style','height:20px;width:25px;!important')
         			 ->addMultiOptions($paymentmodesList)
         			 ->setRequired(false);
				 
         $resprice = $this->createElement('select','resprice');
         $resprice->removeDecorator('Label')
         		  ->removeDecorator('HtmlTag')
				  ->setAttrib('placeholder', 'Price')
         		  ->setAttrib('class','sel1 drpDown form')
         		  
         		  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Select Price Range.'))))
         		  ->addMultiOptions($priceList)
         		  ->setRequired(true);
         
         			 
         $resCity = $this->createElement('select', 'resCity');
         $resCity->removeDecorator('Label')
         		 ->removeDecorator('HtmlTag')
				 ->setAttrib('placeholder', 'City')
         		 ->setAttrib('class','sel1 drpDown form')
         		 ->setRegisterInArrayValidator(false)
         		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select City.'))))       	     
                 ->setRequired(true);
                 
         $resRegion = $this->createElement('select', 'resRegion');
         $resRegion->removeDecorator('Label')
         		 ->removeDecorator('HtmlTag')
				 ->setAttrib('placeholder', 'Region')
         		 ->setAttrib('class','sel1 drpDown')
         		 ->setRegisterInArrayValidator(false)
         		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select Region.'))))       	     
                 ->setRequired(true);
                 
        $cantfind = $this->createElement('hidden','cantfind');
		$cantfind->removeDecorator('HtmlTag')
    		  	 ->removeDecorator('Label');

		$cantfindcity = $this->createElement('text', 'cantfindcity');
        $cantfindcity->removeDecorator('Label')
        		 ->removeDecorator('HtmlTag')
        		 ->setAttrib('class','inp2 form')
        		 ->setAttrib('maxlength', '30')
        		 ->addValidators(array(array('StringLength', false,array(0,30))))
        		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter City.'))))
        		 ->setValue('')
                 ->setRequired(false); 
        
        $cantfindstate = $this->createElement('text', 'cantfindstate');
        $cantfindstate->removeDecorator('Label')
        		 ->removeDecorator('HtmlTag')
        		 ->setAttrib('class','inp2 form')
        		 ->setAttrib('maxlength', '30')
        		 ->addValidators(array(array('StringLength', false,array(0,30))))
        		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter State.'))))  
        		 ->setValue('')
                 ->setRequired(false); 
                 
        $cantfindregion = $this->createElement('text', 'cantfindregion');
        $cantfindregion->removeDecorator('Label')
        		 ->removeDecorator('HtmlTag')
        		 ->setAttrib('class','inp2 form')
        		 ->setAttrib('maxlength', '30')
        		 ->addValidators(array(array('StringLength', false,array(0,30))))
        		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter Region.'))))  
        		 ->setValue('')
                 ->setRequired(false); 
                 
        $cantfindneigh = $this->createElement('text', 'cantfindneigh');
        $cantfindneigh->removeDecorator('Label')
        		 ->removeDecorator('HtmlTag')
        		 ->setAttrib('class','inp2 form')
        		 ->setAttrib('maxlength', '30')
        		 ->addValidators(array(array('StringLength', false,array(0,30))))
        		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter Neighbour.'))))  
        		 ->setValue('')
                 ->setRequired(false); 
                          
         $resNeighbour = $this->createElement('select', 'resNeighbour');
         $resNeighbour->removeDecorator('Label')
         			  ->setAttrib('class','sel1 drpDown form')
					  ->setAttrib('style','width:81%;')
         		 	  ->removeDecorator('HtmlTag')
         		 	  ->setRegisterInArrayValidator(false)
         		 	  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select Restaurant Neighbourhood.'))))        	          
                 	  ->setRequired(true);
                 	  
         $resPostalCode = $this->createElement('text', 'postalCode');
         $resPostalCode->removeDecorator('Label')  
         			   ->removeDecorator('HtmlTag')      		       
        		       ->setAttrib('class','inp2 form required')  
        		       ->addFilters(array('StringTrim'))
        		       ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Postal Code.'))))    
                       ->addValidator('StringLength', false,array(1,10))
                       ->setValue('')
                       ->setAttrib('maxlength', '10')
                       ->setRequired(true);                                
                 
                       
        $rescountryCode = $this->createElement('select','rescountryCode');
		$rescountryCode->removeDecorator('Label')
        			    ->removeDecorator('HtmlTag')
        			    ->setAttrib('maxlength', '100')
        			    ->setAttrib('class','inp2 form required') 
        			    ->setAttrib('style','width:92px;')  
        			    ->addMultiOptions($CodeList)  
        			    ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select country code.'))))    
                        ->setValue('')
        			    ->setRequired(false);

         $countryCode = $this->createElement('text', 'countryCode');
         $countryCode->removeDecorator('Label')  
         			   ->removeDecorator('HtmlTag')      		       
        		       ->setAttrib('class','inp2 form required')  
        		       ->setAttrib('style','width:92px;')
        		       ->setAttrib('readonly','readonly')
        		       ->addFilters(array('StringTrim'))
        		       ->setAttrib('placeholder','Code')
        		       ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select country code.'))))    
                        ->setValue('')
                       ->setAttrib('maxlength', '5')
                       ->setRequired(true);  
        			       			    
         $resPhone = $this->createElement('text', 'resPhone');
         $resPhone->removeDecorator('Label')
         		  ->removeDecorator('HtmlTag')                  
                  ->setAttrib('class','inp2 form required')           
                  ->setAttrib('maxlength', '15')
                  ->setAttrib('style','width:70%')
                  ->addFilters(array('StringTrim'))
                  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Phone Number.'))))
                  ->addValidator('regex', false, array('pattern' =>'/^[0-9 ]+$/','messages' => 'Enter a valid Phone Number'))
                  ->setValue('')              
                  ->setRequired(true);

         $resFax = $this->createElement('text', 'resFax');
         $resFax->removeDecorator('Label') 
         		->removeDecorator('HtmlTag')               
                ->setAttrib('class','inp2 form required')               
                ->setAttrib('maxlength', '15')
                ->addFilters(array('StringTrim'))
                ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Fax Number.'))))
                ->setValue('')              
                ->setRequired(false);
         
         $resWebsite = $this->createElement('text', 'resWebsite');
         $resWebsite->removeDecorator('Label') 
                    ->removeDecorator('HtmlTag')               	
                	->setAttrib('class','inp2 form required')           
                	->setAttrib('maxlength', '255')
                	->addFilters(array('StringTrim'))
                	->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter WebSite.'))))
                	->setValue('')              
                	->setRequired(false);
                	
         $resManager = $this->createElement('text', 'resManager');
         $resManager->removeDecorator('Label') 
                    ->removeDecorator('HtmlTag')               	
                	->setAttrib('class','inp2 form required')            
                	->setAttrib('maxlength', '255')
                	->addFilters(array('StringTrim'))
                	->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Restaurant ManagerName.'))))
                	->setValue('')              
                	->setRequired(false);
                	
		$resDescription = $this->createElement('textarea', 'resDescription');
		$resDescription->removeDecorator('Label')
		               ->removeDecorator('HtmlTag')                	   
                	   ->setAttrib('maxlength', '5000')
                	   ->setAttrib('cols', '40')
			           ->setAttrib('rows', '4')
					   ->setAttrib('style', 'width:90%; height:162px;')
			           ->setAttrib('class','inp1')              
                	   ->setValue('')              
                	   ->setRequired(false);
                	   	
               	   
		$resImage = $this->createElement('file','resImage');
		$resImage->removeDecorator('Label')
			     ->removeDecorator('HtmlTag')
			     ->setAttrib('class','inp2 form required')  			     
			     ->setRequired(false)
	//		     ->addValidator('FilesSize', false, array('min' => '1kB', 'max' => '100kB'))
			     ->addValidator(new Zend_Validate_File_IsImage)
			     ->addValidator('Count', false,array('min' => 0, 'max' => 5))
			     ->setOptions(array('multiple' => 'multiple'))
			     ->setIsArray(true)
			     ->addValidator('Extension', false, 'jpg,png,gif');
			     
		$resLogo = $this->createElement('file','resLogo');
		$resLogo->removeDecorator('Label')
				->removeDecorator('HtmlTag')
				->setAttrib('class','inp2 form required') 
				//->setAttrib('style', 'height:32px !important;')				
			    ->setRequired(false)
			    ->addValidator('FilesSize', false, array('min' => '1kB', 'max' => '100kB'))
			    ->addValidator('Extension', false,array('jpg,png','messages' => 'Please select jpg or png images only'));
			     	
	    $restParking = $this->createElement('text','restParking');
	    $restParking->removeDecorator('Label')
			        ->removeDecorator('HtmlTag')
			        ->setAttrib('class','inp2 form required')  
			        ->addFilters(array('StringTrim'))			     
			        ->setRequired(false)
			        ->setAttrib('maxlength', '100');

		$restParkDetail = $this->createElement('text','restParkDetails');
		$restParkDetail->removeDecorator('Label')
			           ->removeDecorator('HtmlTag')			     
			           ->setRequired(false)
			           ->setAttrib('maxlength', '5000')
			           ->addFilters(array('StringTrim'))
			           ->addValidators(array(array('StringLength', false,array(1,5000,'messages' => array(
              					Zend_Validate_StringLength::TOO_LONG => 'ParkDetail is too long(>5000).')))))
			           ->setAttrib('class','inp2 form required');

		$restPrivateParty = new Zend_Form_Element_Radio('restPrivParty');
		$restPrivateParty->removeDecorator('Label')
			   		   ->removeDecorator('HtmlTag')
			   		   ->setMultiOptions($list)
			   		   ->setSeparator(' ')
			   		   ->setRequired(false);					           
			           				        
        $restPrivContact = $this->createElement('text','restPrivPartyContact');
		$restPrivContact->removeDecorator('Label')
			             ->removeDecorator('HtmlTag')
			             ->setRequired(false)
			           	 ->setAttrib('maxlength', '500')
			           	 ->addFilters(array('StringTrim'))
			           	 ->addValidators(array(array('StringLength', false,array(1,500,'messages' => array(
              					Zend_Validate_StringLength::TOO_LONG => 'PrivPartyContact is too long(>500).'
              				)))))
			           	->setAttrib('class','inp2 form required');	

		$restEntertainment = $this->createElement('text','restEntertainment');
		$restEntertainment->removeDecorator('Label')
			              ->removeDecorator('HtmlTag')
			              ->setRequired(false)
			           	  ->setAttrib('maxlength', '1000')
			           	  ->addFilters(array('StringTrim'))
			           	  ->addValidators(array(array('StringLength', false,array(1,1000,'messages' => array(
              					Zend_Validate_StringLength::TOO_LONG => 'Entertainment is too long(>1000).'
              				)))))
			           	  ->setAttrib('class','inp2 form required');
			           	  	
		$restAdditDetail = $this->createElement('text','restAdditDetails');
		$restAdditDetail->removeDecorator('Label')
			            ->removeDecorator('HtmlTag')
			            ->setRequired(false)
			            ->setAttrib('maxlength', '500')
			            ->addFilters(array('StringTrim'))
			            ->addValidators(array(array('StringLength', false,array(1,500,'messages' => array(
              					Zend_Validate_StringLength::TOO_LONG => 'AdditDetails is too long(>500).'
              				)))))
			            ->setAttrib('class','inp2 form required');
		/*$restSubResSys = new Zend_Form_Element_Checkbox('restSubResSys');
		$restSubResSys->removeDecorator('Label')
			          ->removeDecorator('HtmlTag')
			          ->setRequired(false)
			          ->setChecked(false);*/
			          
		$restTimings = $this->createElement('textarea', 'restTimings');
		$restTimings->removeDecorator('Label')
				    ->removeDecorator('HtmlTag')                	   
                    ->setAttrib('maxlength', '100')
                    ->setAttrib('cols', '20')
		            ->setAttrib('rows', '3')
					 ->setAttrib('placeholder','(EX:9:00AM-11:00AM BREAKFAST,1:00PM-4:00PM LUNCH)')
					->setAttrib('style','height:80px !important; font-size:11px; width:90%;')
		            ->addFilters(array('StringTrim'))              
                    ->setValue('')              
                    ->setRequired(false);
		            
		$restLandMark = $this->createElement('text','restLandMark');
		$restLandMark->removeDecorator('Label')
			        ->removeDecorator('HtmlTag')
			        ->setRequired(false)
			        ->setAttrib('maxlength', '255')
			        ->addFilters(array('StringTrim'))
			        ->addValidators(array(array('StringLength', false,array(1,255,'messages' => array(
              					Zend_Validate_StringLength::TOO_LONG => 'AdditDetails is too long(>255).'
              				)))))
			        ->setAttrib('class','inp2 form required');

		$restAvgMealPriceMax = $this->createElement('text','restAvgMealPriceMax');
		$restAvgMealPriceMax->removeDecorator('Label')
			        ->removeDecorator('HtmlTag')
			        ->setRequired(false)
			        ->addFilters(array('StringTrim'))
			        ->setAttrib('style','width:72px;')
			        ->setAttrib('class','inp2 form required');
			        
		$restAvgMealPriceMin = $this->createElement('text','restAvgMealPriceMin');
		$restAvgMealPriceMin->removeDecorator('Label')
			        ->removeDecorator('HtmlTag')
			        ->setRequired(false)
			        ->setAttrib('style','width:72px;')
			        ->addFilters(array('StringTrim'))
			        ->setAttrib('class','inp2 form required');
			        
		$DeliveryList   = array(
    	 		array('key'=>'Take Out','value'=>' Take Out '),
    	 		array('key'=>'Delivery','value'=>' Delivery '),
    	 		array('key'=>'Both','value'=>' Both '),
    	 		array('key'=>'none','value'=>' None')
    	 );

    	$restDelevery = new Zend_Form_Element_Radio('restDelevery');
		$restDelevery->removeDecorator('Label')
			   ->removeDecorator('HtmlTag')
			   ->setMultiOptions($DeliveryList)
			   ->setSeparator(' ')
			   ->setRequired(false);
                	
		$MealTypeList   = array(
    	 		array('key'=>'Veg','value'=>' Veg '),
    	 		array('key'=>'Non-Veg','value'=>' Non-Veg '),
    	 		array('key'=>'Both','value'=>' Both')
    	 );
    	 
    	$restMealType = new Zend_Form_Element_Radio('restMealType');
		$restMealType->removeDecorator('Label')
			   ->removeDecorator('HtmlTag')
			   ->setMultiOptions($MealTypeList)
			   ->setSeparator(' ')
			   ->setRequired(false);
    	 
    	$restTableReserv = new Zend_Form_Element_Radio('restTableReserv');
		$restTableReserv->removeDecorator('Label')
			   		   ->removeDecorator('HtmlTag')
			   		   ->setMultiOptions($list)
			   		   ->setSeparator(' ')
			   		   ->setRequired(false);
			   		   
		$restLunchBuffet = new Zend_Form_Element_Radio('restLunchBuffet');
		$restLunchBuffet->removeDecorator('Label')
			   		    ->removeDecorator('HtmlTag')
			   		    ->setMultiOptions($list)
			   		    ->setSeparator(' ')
			   		    ->setRequired(false);
			   		   
		$restDinnerBuffet = new Zend_Form_Element_Radio('restDinnerBuffet');
		$restDinnerBuffet->removeDecorator('Label')
			   		     ->removeDecorator('HtmlTag')
			   		     ->setMultiOptions($list)
			   		     ->setSeparator(' ')
			   		     ->setRequired(false);
			   		     
		$wifiList = array(
    	 		array('key'=>'Free','value'=>' Free'),
    	 		array('key'=>'Paid','value'=>' Paid'),
    	 		array('key'=>'Not Available','value'=>' Not Available')
    	 );

    	$restWifi = new Zend_Form_Element_Radio('restWifi');
		$restWifi->removeDecorator('Label')
			   ->removeDecorator('HtmlTag')
			   ->setMultiOptions($wifiList)
			   ->setSeparator(' ')
			   ->setRequired(false);
			   	 
		$restAlcohol = new Zend_Form_Element_Radio('restAlcohol');
		$restAlcohol->removeDecorator('Label')
			   		->removeDecorator('HtmlTag')
			   		->setMultiOptions($list)
			   		->setSeparator(' ')
			   		->setRequired(false);
			   		
		$SmokingList = array(
    	 		array('key'=>'Smoking','value'=>' Smoking'),
    	 		array('key'=>'Non-Smoking','value'=>' Non-Smoking'),
    	 		array('key'=>'Both','value'=>' Both')
    	 );
    	 
    	$restSmoke = new Zend_Form_Element_Radio('restSmoke');
		$restSmoke->removeDecorator('Label')
			   ->removeDecorator('HtmlTag')
			   ->setMultiOptions($SmokingList)
			   ->setSeparator(' ')
			   ->setRequired(false);
                  
        $restAC = new Zend_Form_Element_Radio('restAC');
		$restAC->removeDecorator('Label')
			   ->removeDecorator('HtmlTag')
			   ->setMultiOptions($list)
			   ->setSeparator(' ')
			   ->setRequired(false);
			   
		$restCatering = new Zend_Form_Element_Radio('restCatering');
		$restCatering->removeDecorator('Label')
			  	     ->removeDecorator('HtmlTag')
			         ->setMultiOptions($list)
			         ->setSeparator(' ')
			         ->setRequired(false);
			         
		$restKidsSection = new Zend_Form_Element_Radio('restKidsSection');
		$restKidsSection->removeDecorator('Label')
			  	        ->removeDecorator('HtmlTag')
			         	->setMultiOptions($list)
			         	->setSeparator(' ')
			         	->setRequired(false);
		
        $resttagbd = new Zend_Form_Element_Multiselect('resttagbd');
		$resttagbd->removeDecorator('Label')
			  	        ->removeDecorator('HtmlTag')
			         	->setMultiOptions($tagbdList)
			         	->setAttrib('class','resttag') 
			         	->setRequired(false);         
			   		  	 	
        $restnewtag = $this->createElement('text','restnewtag');
	    $restnewtag->removeDecorator('Label')
			        ->removeDecorator('HtmlTag')
			        ->addFilters(array('StringTrim'))			     
			        ->setRequired(false)
			        ->setAttrib('maxlength', '100');

        $tagId = $this->createElement('hidden','tagId');
    	$tagId->removeDecorator('Label')
        	   ->removeDecorator('DtDdWrapper')
        	   ->removeDecorator('HtmlTag');
        	   	   
		$imageCaptcha = new Zend_Captcha_Image();
        $imageCaptcha->setWidth(250)
        			 ->setWordlen(6)
        			 ->setHeight(80)
        			 ->setTimeout(900)
        			 ->setFontSize(32)
        			 ->setGcFreq(5)
        			 ->setFont('fonts/Scrawllege.ttf')
        			 ->setImgDir('images/captcha/')
        			 ->setImgUrl('/images/captcha/')
        			 ->setDotNoiseLevel(0)
        			 ->setLineNoiseLevel(0);
        			   
        $captcha = new Zend_Form_Element_Captcha('captcha',array('label' => 'Text you see above',
										         					'captcha' => $imageCaptcha 
										         			)); 
		$captcha->removeDecorator('DtDdWrapper')
				->removeDecorator('HtmlTag')
				->setAttrib('style','position:relative;margin-top:35px'); 
				            
		$resSubmit = $this->createElement('submit','Submit');
        $resSubmit->removeDecorator('Label')
        		  ->removeDecorator('DtDdWrapper')
        		  ->setValue('Submit')           		          		        		
        		  ->setAttrib('class','submitBtn')
                  ->setIgnore(true);

		$resReset = $this->createElement('reset','Reset');
        $resReset->removeDecorator('Label')        		 
        		 ->setValue('Reset')
        		 ->removeDecorator('DtDdWrapper')           	  	 
        	  	 ->setAttrib('class','submitBtn')
              	 ->setIgnore(true);						 
			              	 
		$this->addElements( array ($restId,
								   $restLatitude,
								   $restLongitude,
								   $restaurantName,
								   $restCapacity,
								   $restDiningStyle,
								   $resEmailAddress,
								   //$resYearFound,
								   $maxpax,
								   $restaurantType,
								   $resAddress,
								   $resState,
								   $resTimezone,
								   $resprice,
								   $resRegion,
								   $resCity,
								   $resNeighbour,
								   $resPostalCode,
								   $resPhone,
								   $resFax,
								   $resWebsite,
								   $resManager,
								   $resDescription,	
								   $resImage,
								   $resLogo,
								   $restParking,
								   $restParkDetail,
								   $restPrivateParty,
								   $restPrivContact,
								   $restEntertainment,
								   $restAdditDetail,
								   $resPaymentMode,
								   $restTimings,								   						   
								   $resSubmit,
								   $restLandMark,
								   $restAvgMealPriceMax,
								   $restAvgMealPriceMin,
								   $restDelevery,
								   $restMealType,
								   $resReset,
								   $restTableReserv,
								   $restLunchBuffet,
								   $cantfindstate,
	                           	   $cantfindregion,
					   			   $restDinnerBuffet,
								   $restWifi,
								   $restAlcohol,
								   $restSmoke,
								   $restAC,
	                           	   $cantfind,
	                           	   $cantfindcity,
	                           	   $cantfindneigh,		
					   			   $restCatering,
								   $restKidsSection,
								   $resReset,
								   $countryCode,
								   $resttagbd,
								   $restnewtag,
								   $tagId
								  ));	     		 
    }
}