<?php
class FirmManagement_Form_AddGroup extends Zend_Form
{

	public function init()
    {
		$this->setAttrib('enctype', 'multipart/form-data');
		
		$userid = $this->createElement('hidden','userid');
    	
		$restNameCtl = $this->createElement('select','RestaurantName');
        $restNameCtl->removeDecorator('Label')
         		    ->removeDecorator('HtmlTag')
         		    ->setAttrib('class','sel1 drpDown required')
         		    ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select RestaurantName.'))))
         		    ->setRegisterInArrayValidator(false)
         		    ->setRequired(true);
         		    
        $groupName =  $this->createElement('text', 'groupName');
        $groupName->removeDecorator('Label')
        		  ->removeDecorator('HtmlTag')        		
        		  ->setAttrib('maxlength', '30')
        		  ->setAttrib('class','inp1 required')
        		  ->addFilters(array('StringTrim'))
                  ->addValidators(array
                				(array('NotEmpty', true, array('messages' => 'Please enter your Group Name.')),
                					array('StringLength', false,array(0,30))))                					 
                  ->setValue('')
                  ->setRequired(true);
                  
        $groupDesc =  $this->createElement('textarea', 'groupDesc');
        $groupDesc->removeDecorator('Label')
        		  ->removeDecorator('HtmlTag')
        		  ->setAttrib('maxlength', '100')
        		  ->setAttrib('cols', '40')
			      ->setAttrib('rows', '4')
			      ->setAttrib('class','inp1 required')
			      ->addFilters(array('StringTrim'))              
                  ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please enter your Group Description.')),
        		 				  array('StringLength', false,array(1,100,'messages' => array(
              					Zend_Validate_StringLength::TOO_LONG => 'Description is too long(>100).'
              				)))))                
                  ->setValue('')
                  ->setRequired(true);
                  
        $Submit = $this->createElement('submit','Update');
        $Submit->removeDecorator('Label')
        		   ->removeDecorator('DtDdWrapper')
        		   ->setValue('Submit')           		          		        		
        		   ->setAttrib('class','submitBtn')
                   ->setIgnore(false);
                  
        $this->addElements( array ($userid,
        						   $restNameCtl,
        						   $groupName,
        						   $groupDesc,
        						   $Submit
        		 ));
    }
}