<?php
class FirmManagement_Form_AddRoundMenuFirm extends Zend_Form
{
	public function init()
    {
 		$this->setAttrib('enctype', 'multipart/form-data');

 		$resTypeMapper  = new Application_Model_RestaurantTypeDataMapper();
    	$resTypes = $resTypeMapper->getRestauranttypeBD();
    	$resTypeList = array();
    	$resTypeList[] = array('key'=>'','value'=>'Select Restaurant Type');    	   
    	foreach($resTypes as $resType){
    		$resTypeList[] = array('key'=>$resType->getId(),'value'=>$resType->getDescription());
    	}   
    	
    	$stateMapper  = new Application_Model_StateDataMapper();
    	$states = $stateMapper->fetchAll();
    	$stateList = array();  
    	$stateList[] = array('key'=>'','value'=>'Select Country');  	   
    	foreach($states as $state){
    		$stateList[] = array('key'=>$state->getId(),'value'=>$state->getDescription());
    	}  
    	$stateList[] = array('key'=>'find','value'=>"Can't Find Country");
    	
    	$paymentmodeMapper = new Application_Model_RestaurantPaymentModeDataMapper();
    	$paymentmodes = $paymentmodeMapper->fetchAll();
    	$paymentmodesList = array();
    	foreach($paymentmodes as $paymentmode){
    		$paymentmodesList[] = array('key'=>$paymentmode->getId(),'value'=>$paymentmode->getDescription());
    	}
    	
    	$priceMapper = new Application_Model_PriceDataMapper();
    	$prices = $priceMapper->fetchAll();
    	$priceList = array();
    	$priceList[] = array('key'=>'','value'=>'Select Price');
    	foreach($prices as $price){
    		$priceList[] = array('key'=>$price->getCode(),'value'=>$price->getCode());
    	}
    	
    	$diningStyleList = array(
    			array('key'=>'','value'=>'Select Dining Style'),
    			array('key'=>'Casual Elegant','value'=>'Casual Elegant'),
    			array('key'=>'Casual Dining','value'=>'Casual Dining'),
    			array('key'=>'Fine Dining','value'=>'Fine Dining'),
    			array('key'=>'Coffeehouse','value'=>'Coffeehouse'),
    			array('key'=>'Pizzeria','value'=>'Pizzeria'),
    			array('key'=>'Steakhouses','value'=>'Steakhouses'),
    			array('key'=>'Seafood Restaurants','value'=>'Seafood Restaurants')    	
    	);
    	
    	$paxList = array(
    			array('key'=>'0','value'=>'Select PartySize'),
    			array('key'=>'1','value'=>'1'),
    			array('key'=>'2','value'=>'2'),
    			array('key'=>'3','value'=>'3'),
    			array('key'=>'4','value'=>'4'),
    			array('key'=>'5','value'=>'5'),
    			array('key'=>'6','value'=>'6'),
    			array('key'=>'7','value'=>'7'),
    			array('key'=>'8','value'=>'8'),
    			array('key'=>'9','value'=>'9'),
    			array('key'=>'10','value'=>'10'),
    			array('key'=>'11','value'=>'11'),
    			array('key'=>'12','value'=>'12'),
    			array('key'=>'13','value'=>'13'),
    			array('key'=>'14','value'=>'14'),
    			array('key'=>'15','value'=>'15'),
    			array('key'=>'16','value'=>'16'),
    			array('key'=>'17','value'=>'17'),
    			array('key'=>'18','value'=>'18'),
    			array('key'=>'19','value'=>'19'),
    			array('key'=>'20','value'=>'20')    	
    	);
    	
    	$restId = $this->createElement('hidden','restId');
    	$restId->removeDecorator('Label')
        	   ->removeDecorator('DtDdWrapper')
        	   ->removeDecorator('HtmlTag');
        	   		  
        $restaurantName = $this->createElement('text', 'restName');
        $restaurantName->removeDecorator('Label')
        			   ->removeDecorator('HtmlTag')
        			   ->setAttrib('maxlength', '255')
					   ->setAttrib('placeholder', 'Business Name')
        			   ->setAttrib('class','inp2 form required')  
        			   ->addFilters(array('StringTrim'))
        			   ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter your Restaurant Name.')),
        			   				array('StringLength', false,array(0,255))))
        			   ->setValue('')
        			   ->setRequired(true);
        			   
      	$restCapacity = $this->createElement('text', 'restCapacity');
      	$restCapacity->removeDecorator('Label')
      				 ->removeDecorator('HtmlTag')
      				 ->setAttrib('maxlength', '5')
					 ->setAttrib('placeholder', 'Restaurant Capacity')
      				  ->setAttrib('class','inp2 form required')  
      				 ->addFilters(array('StringTrim'))
      				 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter your Restaurant Capacity.')),
      				 				array('StringLength', false,array(0,5))))
      				 ->addValidator('Digits',new Zend_Validate_Digits(),array('messages' => 'Please enter Numbers only'))
      				 ->setValue('')
      				 ->setRequired(true);
        			   
		$restDiningStyle = $this->createElement('select','restDiningStyle');
		$restDiningStyle->removeDecorator('Label')
        			    ->removeDecorator('HtmlTag')
        			    ->setAttrib('maxlength', '100')
						->setAttrib('placeholder', 'Dining Style')
        			    ->setAttrib('class','inp2 form required')  
        			    ->addMultiOptions($diningStyleList)        			    
        			    ->setValue('')
        			    ->setRequired(false);

        $maxpax = $this->createElement('select', 'maxpax');
        $maxpax->removeDecorator('Label') 
        		 ->removeDecorator('HtmlTag')
				 ->setAttrib('placeholder', 'Max Pax')
				 ->setAttrib('title', 'Maximum party size to accept from online')
        		 ->setAttrib('class','sel1 form')      		 
                 ->addMultiOptions($paxList)
                 ->setRequired(true);
                	 
         $restaurantType = $this->createElement('select','restype');
         $restaurantType->removeDecorator('Label') 
         				->removeDecorator('HtmlTag') 
         				->setAttrib('class','sel1 form') 
						->setAttrib('placeholder', 'Restaurant Type')
         				->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select Restaurant Type.'))))
               			->addMultiOptions($resTypeList)
               			->setRegisterInArrayValidator(false)
               			->setRequired(true);
             
		 $resState = $this->createElement('select','resState');
         $resState->removeDecorator('Label') 
         		  ->removeDecorator('HtmlTag')
				  ->setAttrib('placeholder', 'State')
         		 ->setAttrib('class','inp2 form required')  
         		  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select State.'))))       	   
               	  ->addMultiOptions($stateList)
                  ->setRequired(true);
                  
         $resTimezone = $this->createElement('select','restimezone');
         $resTimezone->removeDecorator('Label')
	         		 ->removeDecorator('HtmlTag')
					 ->setAttrib('placeholder', 'Region')
	         		 ->setAttrib('class','sel1 drpDown')
	         		 ->setRegisterInArrayValidator(false)
	         		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select TimeZone.'))))       	     
	                 ->setRequired(true);
         
         $resPaymentMode = $this->createElement('multiCheckbox','resPayment');
         $resPaymentMode->removeDecorator('Label')
         			 ->removeDecorator('HtmlTag')
         			 ->setAttrib('class','sel1')
         			 ->setAttrib('style','height:20px;width:25px;!important')
         			 ->addMultiOptions($paymentmodesList)
         			 ->setRequired(false);
				 
         $resprice = $this->createElement('select','resprice');
         $resprice->removeDecorator('Label')
         		  ->removeDecorator('HtmlTag')
				  ->setAttrib('placeholder', 'Price')
         		  ->setAttrib('class','sel1 drpDown form')
         		  
         		  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Select Price Range.'))))
         		  ->addMultiOptions($priceList)
         		  ->setRequired(true);
         
         			 
         $resCity = $this->createElement('select', 'resCity');
         $resCity->removeDecorator('Label')
         		 ->removeDecorator('HtmlTag')
				 ->setAttrib('placeholder', 'City')
         		 ->setAttrib('class','sel1 drpDown form')
         		 ->setRegisterInArrayValidator(false)
         		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select City.'))))       	     
                 ->setRequired(true);
                 
         $resRegion = $this->createElement('select', 'resRegion');
         $resRegion->removeDecorator('Label')
         		 ->removeDecorator('HtmlTag')
				 ->setAttrib('placeholder', 'Region')
         		 ->setAttrib('class','sel1 drpDown')
         		 ->setRegisterInArrayValidator(false)
         		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select Region.'))))       	     
                 ->setRequired(true);
                 
        $cantfind = $this->createElement('hidden','cantfind');
		$cantfind->removeDecorator('HtmlTag')
    		  	 ->removeDecorator('Label');

		$cantfindcity = $this->createElement('text', 'cantfindcity');
        $cantfindcity->removeDecorator('Label')
        		 ->removeDecorator('HtmlTag')
        		 ->setAttrib('class','inp2 form')
        		 ->setAttrib('maxlength', '30')
        		 ->addValidators(array(array('StringLength', false,array(0,30))))
        		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter City.'))))
        		 ->setValue('')
                 ->setRequired(false); 
        
        $cantfindstate = $this->createElement('text', 'cantfindstate');
        $cantfindstate->removeDecorator('Label')
        		 ->removeDecorator('HtmlTag')
        		 ->setAttrib('class','inp2 form')
        		 ->setAttrib('maxlength', '30')
        		 ->addValidators(array(array('StringLength', false,array(0,30))))
        		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter State.'))))  
        		 ->setValue('')
                 ->setRequired(false); 
                 
        $cantfindregion = $this->createElement('text', 'cantfindregion');
        $cantfindregion->removeDecorator('Label')
        		 ->removeDecorator('HtmlTag')
        		 ->setAttrib('class','inp2 form')
        		 ->setAttrib('maxlength', '30')
        		 ->addValidators(array(array('StringLength', false,array(0,30))))
        		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter Region.'))))  
        		 ->setValue('')
                 ->setRequired(false); 
                 
        $cantfindneigh = $this->createElement('text', 'cantfindneigh');
        $cantfindneigh->removeDecorator('Label')
        		 ->removeDecorator('HtmlTag')
        		 ->setAttrib('class','inp2 form')
        		 ->setAttrib('maxlength', '30')
        		 ->addValidators(array(array('StringLength', false,array(0,30))))
        		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter Neighbour.'))))  
        		 ->setValue('')
                 ->setRequired(false); 
                          
         $resNeighbour = $this->createElement('select', 'resNeighbour');
         $resNeighbour->removeDecorator('Label')
         			  ->setAttrib('class','sel1 drpDown form')
         		 	  ->removeDecorator('HtmlTag')
         		 	  ->setRegisterInArrayValidator(false)
         		 	  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select Restaurant Neighbourhood.'))))        	          
                 	  ->setRequired(true);
 		            
		$resSubmit = $this->createElement('submit','Submit');
        $resSubmit->removeDecorator('Label')
        		  ->removeDecorator('DtDdWrapper')
        		  ->setValue('Submit')           		          		        		
        		  ->setAttrib('class','submitBtn')
                  ->setIgnore(true);
         $countryCode = $this->createElement('hidden', 'countryCode');
         $countryCode->removeDecorator('Label')  
         			   ->removeDecorator('HtmlTag')      		       
        		       ->setAttrib('class','inp2 form required')  
        		       ->setAttrib('style','width:92px;')
        		       ->setAttrib('readonly','readonly')
        		       ->addFilters(array('StringTrim'))
        		       ->setAttrib('maxlength', '5');  

		$resReset = $this->createElement('reset','Reset');
        $resReset->removeDecorator('Label')        		 
        		 ->setValue('Reset')
        		 ->removeDecorator('DtDdWrapper')           	  	 
        	  	 ->setAttrib('class','submitBtn')
              	 ->setIgnore(true);						 
			              	 
		$this->addElements( array ($restId,
								   $restaurantName,
								   $restCapacity,
								   $restDiningStyle,
								   $maxpax,
								   $restaurantType,
								   $resState,
								   $resTimezone,
								   $resprice,
								   $resRegion,
								   $resCity,
								   $resNeighbour,								   						   
								   $resSubmit,
								   $resReset,
	                           	   $cantfind,
	                           	   $cantfindcity,
	                           	   $cantfindneigh,
	                           	   $countryCode
								  ));	
    }
}