<?php

class FirmManagement_Form_EditFirmAddressDetails extends Zend_Form
{

	public function init()
    {
    	 $this->setAttrib('enctype', 'multipart/form-data');
    	/* Populating State Base Data */
    	
    	$stateMapper  = new Application_Model_StateDataMapper();
    	$states = $stateMapper->fetchAll();
    	$stateList = array();  
    	$stateList[] = array('key'=>'','value'=>'Select Country');  	   
    	foreach($states as $state){
    		$stateList[] = array('key'=>$state->getId(),'value'=>$state->getDescription());
    	}  
    	
//    	$timezoneMapper = new Application_Model_TimeZoneDataMapper();
//    	$timezones = $timezoneMapper->fetchAll();
//    	$timezoneList = array();
//    	$timezoneList[] = array('key'=>'','value'=>'Select TimeZone');
//    	foreach($timezones as $timezone){
//    		$timezoneList[] = array('key'=>$timezone->getCode(),'value'=>$timezone->getDescription());
//    	}
    	
    	$CountryCodeMapper = new Application_Model_CountryCodeDataMapper();
    	$CountryCode = $CountryCodeMapper->fetchAll();
    	$CodeList = array();
    	$CodeList[] = array('key'=>'','value'=>'Select flag');
    	foreach($CountryCode as $listcode){
    		$CodeList[] = array('key'=>$listcode->getDescription(),'value'=>$listcode->getCode());
    	}
    	
    	$restId = $this->createElement('hidden','restaurantid');
    	$address = $this->createElement('hidden','address');
    	$address->setValue('address');
    	
    	$restLatitude = $this->createElement('hidden','restLatitude');
    	$restLatitude->removeDecorator('Label')
        			 ->removeDecorator('HtmlTag');
    	$restLongitude = $this->createElement('hidden','restLongitude');
    	$restLongitude->removeDecorator('Label')
        			  ->removeDecorator('HtmlTag');
    	
    	$resAddress = $this->createElement('text','resAddress');
        $resAddress->removeDecorator('Label')
        			 ->removeDecorator('HtmlTag')
        			 ->setAttrib('maxlength', '510')
        			 ->setAttrib('class','inp2')
        			 ->addFilters(array('StringTrim'))
        			 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter your Restaurant Address.')),
			         					array('StringLength', false,array(1,510,'messages' => array(
              					Zend_Validate_StringLength::TOO_LONG => 'address is too long(>510).'
              				)))))        			               		 
               		 ->setValue('')	
        			 ->setRequired(false);
    	
    	$resEmailAddress =  $this->createElement('text', 'emailAddress');
        $resEmailAddress ->removeDecorator('Label')
        				 ->removeDecorator('HtmlTag')        			     
        			     ->setAttrib('maxlength', '255')
        				 ->setAttrib('class','inp2')
                		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter your Email Address.')),
                		 				array('StringLength', false,array(5,255))))
                		 ->addValidator('EmailAddress',false,array('messages'=>array(Zend_Validate_EmailAddress::INVALID =>'Please enter a valid Host Name')))
						 ->addErrorMessage('Pleaes Enter Valid Email Address')
                		 ->addFilters(array('StringTrim'))
               			 ->setRequired(false);  
		
	         
		 $resState = $this->createElement('select','resState');
         $resState->removeDecorator('Label') 
         		  ->removeDecorator('HtmlTag')
         		  ->setAttrib('class','sel1 drpDown')
         		  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select Country.'))))       	   
               	  ->addMultiOptions($stateList)
                  ->setRequired(true);
                  
         $resTimezone = $this->createElement('select','restimezone');
       	 $resTimezone->removeDecorator('Label')
	         		 ->removeDecorator('HtmlTag')
	         		 ->setAttrib('class','sel1 drpDown')
	         		 ->setRegisterInArrayValidator(false)
	         		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select TimeZone.'))))       	     
	                 ->setRequired(true);
                  
         $resCity = $this->createElement('select', 'resCity');
         $resCity->removeDecorator('Label')
         		 ->removeDecorator('HtmlTag')
         		 ->setAttrib('class','sel1 drpDown')
         		 ->setRegisterInArrayValidator(false)
         		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select City.'))))       	     
                 ->setRequired(true);
         
         $resRegion = $this->createElement('select', 'resRegion');
         $resRegion->removeDecorator('Label')
         		 ->removeDecorator('HtmlTag')
         		 ->setAttrib('class','sel1 drpDown')
         		 ->setRegisterInArrayValidator(false)
         		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select State.'))))       	     
                 ->setRequired(true);
                          
         $resNeighbour = $this->createElement('select', 'resNeighbour');
         $resNeighbour->removeDecorator('Label')
         			  ->setAttrib('class','sel1 drpDown')
         		 	  ->removeDecorator('HtmlTag')
         		 	  ->setRegisterInArrayValidator(false)
         		 	  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select Neighbourhood.'))))        	          
                 	  ->setRequired(true);
                 	  
         $resPostalCode = $this->createElement('text', 'postalCode');
         $resPostalCode->removeDecorator('Label')  
         			   ->removeDecorator('HtmlTag')      		       
        		       ->setAttrib('class','inp2')
        		       ->addFilters(array('StringTrim'))
        		       ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Postal Code.'))))    
                       ->addValidator('StringLength', false,array(1,10))
                       ->setValue('')
                       ->setAttrib('maxlength', '10')
                       ->setRequired(true);                                

                       
        $rescountryCode = $this->createElement('select','rescountryCode');
		$rescountryCode->removeDecorator('Label')
        			    ->removeDecorator('HtmlTag')
        			    ->setAttrib('maxlength', '100')
        			    ->setAttrib('class','sel1 drpDown')    
        			    ->setAttrib('style','width:92px;')  
        			    ->addMultiOptions($CodeList)   
        			    ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select country code.'))))    
                        ->setValue('')
        			    ->setRequired(false);

         $rescodetext = $this->createElement('text', 'rescodetext');
         $rescodetext->removeDecorator('Label')  
         			   ->removeDecorator('HtmlTag')      		       
        		       ->setAttrib('class','inp2')
        		       ->setAttrib('style','width:92px;')
        		       ->setAttrib('readonly','readonly')
        		       ->addFilters(array('StringTrim'))
        		       ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select country code.'))))    
                       ->setValue('')
                       ->setAttrib('maxlength', '5')
                       ->setRequired(false); 
                       
         $resPhone = $this->createElement('text', 'resPhone');
         $resPhone->removeDecorator('Label')
         		  ->removeDecorator('HtmlTag')                  
                  ->setAttrib('class','inp2')              
                  ->setAttrib('maxlength', '10')
                  ->addFilters(array('StringTrim'))
                  ->setAttrib('style','width:70%;')
                  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Phone Number.'))))
                  ->addValidator('regex', false, array('pattern' =>'/^[0-9 ]+$/','messages' => 'Enter a valid Phone Number'))
                  ->setValue('')              
                  ->setRequired(false);

         $resFax = $this->createElement('text', 'resFax');
         $resFax->removeDecorator('Label') 
         		->removeDecorator('HtmlTag')               
                ->setAttrib('class','inp2')              
                ->setAttrib('maxlength', '15')
                ->addFilters(array('StringTrim'))
                ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Fax Number.'))))
                ->setValue('')              
                ->setRequired(false);
         
        $this->addElements( array ($restId,
								   $address,
								   $resAddress,
//								   $resEmailAddress,
								   $resState,
								   $resRegion,
								   $resTimezone,
								   $resCity,
								   $resNeighbour,
								   $resPostalCode,
//								   $resPhone,
//								   $resFax,
								   $restLatitude,
								   $restLongitude,
								   $rescodetext
								   )		
		
		);	 
         		 
    }

}

