<?php

class FirmManagement_Form_EditFirmParkingDetails extends Zend_Form
{

	public function init()
    {
//    	 $this->setAttrib('enctype', 'multipart/form-data');
   		$tagbdMapper = new FirmManagement_Model_FirmTagBdMapper();
    	$tagbds = $tagbdMapper->fetchAll();
    	$tagbdList = array();
    	foreach($tagbds as $tagbd){
    		$tagbdList[] = array('key'=>$tagbd->getId(),'value'=>$tagbd->getDescription());
    	}
    	
    	$restId = $this->createElement('hidden','restaurantid');
    	$parking = $this->createElement('hidden','parking');
    	$parking->setValue('parking');
        			     	
	    $restParking = $this->createElement('text','restParking');
	    $restParking->removeDecorator('Label')
			        ->removeDecorator('HtmlTag')
			        ->setAttrib('class','inp2')
			        ->addFilters(array('StringTrim'))			     
			        ->setRequired(false)
			        ->setAttrib('maxlength', '100');

		$restParkDetail = $this->createElement('text','restParkDetails');
		$restParkDetail->removeDecorator('Label')
			           ->removeDecorator('HtmlTag')			     
			           ->setRequired(false)
			           ->setAttrib('maxlength', '5000')
			           ->addFilters(array('StringTrim'))
			           ->addValidators(array(array('StringLength', false,array(1,5000,'messages' => array(
              					Zend_Validate_StringLength::TOO_LONG => 'ParkDetail is too long(>5000).'
              				)))))
			           ->setAttrib('class','inp2');

		$restPrivateParty = $this->createElement('text','restPrivParty');
		$restPrivateParty->removeDecorator('Label')
			             ->removeDecorator('HtmlTag')
			             ->setRequired(false)
			           	 ->setAttrib('maxlength', '(1000')
			           	 ->addFilters(array('StringTrim'))
			           	 ->addValidators(array(array('StringLength', false,array(1,1000,'messages' => array(
              					Zend_Validate_StringLength::TOO_LONG => 'PrivParty is too long(>1000).'
              				)))))
			           	 ->setAttrib('class','inp2');					           
			           				        
        $restPrivContact = $this->createElement('text','restPrivPartyContact');
		$restPrivContact->removeDecorator('Label')
			             ->removeDecorator('HtmlTag')
			             ->setRequired(false)
			           	 ->setAttrib('maxlength', '500')
			           	 ->addFilters(array('StringTrim'))
			           	 ->addValidators(array(array('StringLength', false,array(1,500,'messages' => array(
              					Zend_Validate_StringLength::TOO_LONG => 'PrivPartyContact is too long(>500).'
              				)))))
			           	->setAttrib('class','inp2');	

		$restEntertainment = $this->createElement('text','restEntertainment');
		$restEntertainment->removeDecorator('Label')
			              ->removeDecorator('HtmlTag')
			              ->setRequired(false)
			           	  ->setAttrib('maxlength', '1000')
			           	  ->addFilters(array('StringTrim'))
			           	  ->addValidators(array(array('StringLength', false,array(1,1000,'messages' => array(
              					Zend_Validate_StringLength::TOO_LONG => 'Entertainment is too long(>1000).'
              				)))))
			           	  ->setAttrib('class','inp2');
			           	  	
		$restAdditDetail = $this->createElement('text','restAdditDetails');
		$restAdditDetail->removeDecorator('Label')
			            ->removeDecorator('HtmlTag')
			            ->setRequired(false)
			            ->setAttrib('maxlength', '500')
			            ->addFilters(array('StringTrim'))
			            ->addValidators(array(array('StringLength', false,array(1,500,'messages' => array(
              					Zend_Validate_StringLength::TOO_LONG => 'AdditDetails is too long(>500).'
              				)))))
			            ->setAttrib('class','inp2');
		
		$restLandMark = $this->createElement('text','restLandMark');
		$restLandMark->removeDecorator('Label')
			        ->removeDecorator('HtmlTag')
			        ->setRequired(false)
			        ->setAttrib('maxlength', '255')
			        ->addFilters(array('StringTrim'))
			        ->addValidators(array(array('StringLength', false,array(1,255,'messages' => array(
              					Zend_Validate_StringLength::TOO_LONG => 'AdditDetails is too long(>255).'
              				)))))
			        ->setAttrib('class','inp2 form required');
			            	            
		$restAvgMealPriceMax = $this->createElement('text','restAvgMealPriceMax');
		$restAvgMealPriceMax->removeDecorator('Label')
			        ->removeDecorator('HtmlTag')
			        ->setRequired(false)
			        ->setAttrib('style','width:72px;')
			        ->addFilters(array('StringTrim'))
			        ->setAttrib('class','inp2 form required');
			            
		$restAvgMealPriceMin = $this->createElement('text','restAvgMealPriceMin');
		$restAvgMealPriceMin->removeDecorator('Label')
			        ->removeDecorator('HtmlTag')
			        ->setRequired(false)
			        ->setAttrib('style','width:72px;')
			        ->addFilters(array('StringTrim'))
			        ->setAttrib('class','inp2 form required');
			            
		$DeliveryList   = array(
    	 		array('key'=>'Take Out','value'=>' Take Out '),
    	 		array('key'=>'Delivery','value'=>' Delivery '),
    	 		array('key'=>'Both','value'=>' Both '),
    	 		array('key'=>'none','value'=>' None')
    	 );

    	$restDelevery = new Zend_Form_Element_Radio('restDelevery');
		$restDelevery->removeDecorator('Label')
			   ->removeDecorator('HtmlTag')
			   ->setMultiOptions($DeliveryList)
			   ->setSeparator(' ')
			   ->setRequired(false);
			        	            
		$MealTypeList   = array(
    	 		array('key'=>'Veg','value'=>' Veg '),
    	 		array('key'=>'Non-Veg','value'=>' Non-Veg '),
    	 		array('key'=>'Both','value'=>' Both')
    	 );
    	 
    	$restMealType = new Zend_Form_Element_Radio('restMealType');
		$restMealType->removeDecorator('Label')
			   ->removeDecorator('HtmlTag')
			   ->setMultiOptions($MealTypeList)
			   ->setSeparator(' ')
			   ->setRequired(false);
    	
			            
		$SmokingList = array(
    	 		array('key'=>'Smoking','value'=>' Smoking'),
    	 		array('key'=>'Non-Smoking','value'=>' Non-Smoking'),
    	 		array('key'=>'Both','value'=>' Both')
    	 );
    	 
    	$restSmoke = new Zend_Form_Element_Radio('restSmoke');
		$restSmoke->removeDecorator('Label')
			   ->removeDecorator('HtmlTag')
			   ->setMultiOptions($SmokingList)
			   ->setSeparator(' ')
			   ->setRequired(false);
        
	    $wifiList = array(
    	 		array('key'=>'Free','value'=>' Free'),
    	 		array('key'=>'Paid','value'=>' Paid'),
    	 		array('key'=>'Not Available','value'=>' Not Available')
    	 );

    	$restWifi = new Zend_Form_Element_Radio('restWifi');
		$restWifi->removeDecorator('Label')
			   ->removeDecorator('HtmlTag')
			   ->setMultiOptions($wifiList)
			   ->setSeparator(' ')
			   ->setRequired(false);
			   
	    $list = array(
    	 		array('key'=>'Yes','value'=>' Yes'),
    	 		array('key'=>'No','value'=>' No')
    	 );
    	 
		$restTableReserv = new Zend_Form_Element_Radio('restTableReserv');
		$restTableReserv->removeDecorator('Label')
			   		   ->removeDecorator('HtmlTag')
			   		   ->setMultiOptions($list)
			   		   ->setSeparator(' ')
			   		   ->setRequired(false);
			          
		$restLunchBuffet = new Zend_Form_Element_Radio('restLunchBuffet');
		$restLunchBuffet->removeDecorator('Label')
			   		    ->removeDecorator('HtmlTag')
			   		    ->setMultiOptions($list)
			   		    ->setSeparator(' ')
			   		    ->setRequired(false);
			   		   
		$restDinnerBuffet = new Zend_Form_Element_Radio('restDinnerBuffet');
		$restDinnerBuffet->removeDecorator('Label')
			   		     ->removeDecorator('HtmlTag')
			   		     ->setMultiOptions($list)
			   		     ->setSeparator(' ')
			   		     ->setRequired(false);
		
      $restAlcohol = new Zend_Form_Element_Radio('restAlcohol');
	  $restAlcohol->removeDecorator('Label')
			   		->removeDecorator('HtmlTag')
			   		->setMultiOptions($list)
			   		->setSeparator(' ')
			   		->setRequired(false);
		
	    $restAC = new Zend_Form_Element_Radio('restAC');
		$restAC->removeDecorator('Label')
			   ->removeDecorator('HtmlTag')
			   ->setMultiOptions($list)
			   ->setSeparator(' ')
			   ->setRequired(false);
			   
		$restCatering = new Zend_Form_Element_Radio('restCatering');
		$restCatering->removeDecorator('Label')
			  	     ->removeDecorator('HtmlTag')
			         ->setMultiOptions($list)
			         ->setSeparator(' ')
			         ->setRequired(false);
			         
		$restKidsSection = new Zend_Form_Element_Radio('restKidsSection');
		$restKidsSection->removeDecorator('Label')
			  	        ->removeDecorator('HtmlTag')
			         	->setMultiOptions($list)
			         	->setSeparator(' ')
			         	->setRequired(false);
		
		$tagId = $this->createElement('hidden','tagId');
    	$tagId->removeDecorator('Label')
	        	    ->removeDecorator('DtDdWrapper')
	        	    ->removeDecorator('HtmlTag');
        	   	         	
		$resttagbd = new Zend_Form_Element_Multiselect('resttagbd');
		$resttagbd->removeDecorator('Label')
			  	        ->removeDecorator('HtmlTag')
			         	->setMultiOptions($tagbdList)
			         	->setAttrib('class','resttag') 
			         	->setRequired(false);
			         		   		
		$this->addElements( array ($restId,
								   $parking,
								   $restParking,
								   $restParkDetail,
								   $restPrivateParty,
								   $restPrivContact,
								   $restEntertainment,
								   $restAdditDetail,
								   $restLandMark,
								   $restAvgMealPriceMax,
								   $restAvgMealPriceMin,
								   $restDelevery,
								   $restMealType,
								   $restSmoke,
								   $restWifi,
								   $restTableReserv,
								   $restLunchBuffet,
								   $restDinnerBuffet,
								   $restAlcohol,
								   $restAC,
								   $restCatering,
								   $restKidsSection,
								   $resttagbd,
								   $tagId
								   )		
		
		);	 
         		 
    }

}

