<?php

class FirmManagement_Form_EditFirmPersonalDetails extends Zend_Form
{

	public function init()
    {
    	 $this->setAttrib('enctype', 'multipart/form-data');
    	
    	$resTypeMapper  = new Application_Model_RestaurantTypeDataMapper();
    	$resTypes = $resTypeMapper->getRestauranttypeBD();
    	$resTypeList = array();
    	$resTypeList[] = array('key'=>'','value'=>'Select Restaurant Type');    	   
    	foreach($resTypes as $resType){
    		$resTypeList[] = array('key'=>$resType->getId(),'value'=>$resType->getDescription());
    	}   
    	
    	
    	$priceMapper = new Application_Model_PriceDataMapper();
    	$prices = $priceMapper->fetchAll();
    	$priceList = array();
    	$priceList[] = array('key'=>'','value'=>'Select Price');
    	foreach($prices as $price){
    		$priceList[] = array('key'=>$price->getCode(),'value'=>$price->getCode());
    	}
    	
    	$paymentmodeMapper = new Application_Model_RestaurantPaymentModeDataMapper();
    	$paymentmodes = $paymentmodeMapper->fetchAll();
    	$paymentmodesList = array();
    	//$paymentmodesList[] = array('key'=>'','value'=>'Select Payment Mode');
    	foreach($paymentmodes as $paymentmode){
    		$paymentmodesList[] = array('key'=>$paymentmode->getId(),'value'=>$paymentmode->getDescription());
    	}
    	
    	//$diningStyleList[] = array('key'=>'','value'=>'Select Dining Style');
    	$diningStyleList = array(
    			array('key'=>'','value'=>'Select Dining Style'),
    			array('key'=>'Casual Elegant','value'=>'Casual Elegant'),
    			array('key'=>'Casual Dining','value'=>'Casual Dining'),
    			array('key'=>'Fine Dining','value'=>'Fine Dining'),
    			array('key'=>'Coffeehouse','value'=>'Coffeehouse'),
    			array('key'=>'Pizzeria','value'=>'Pizzeria'),
    			array('key'=>'Steakhouses','value'=>'Steakhouses'),
    			array('key'=>'Seafood Restaurants','value'=>'Seafood Restaurants')    	
    	);
    	
    	$paxList = array(
    			array('key'=>'0','value'=>'Select PartySize'),
    			array('key'=>'1','value'=>'1'),
    			array('key'=>'2','value'=>'2'),
    			array('key'=>'3','value'=>'3'),
    			array('key'=>'4','value'=>'4'),
    			array('key'=>'5','value'=>'5'),
    			array('key'=>'6','value'=>'6'),
    			array('key'=>'7','value'=>'7'),
    			array('key'=>'8','value'=>'8'),
    			array('key'=>'9','value'=>'9'),
    			array('key'=>'10','value'=>'10'),
    			array('key'=>'11','value'=>'11'),
    			array('key'=>'12','value'=>'12'),
    			array('key'=>'13','value'=>'13'),
    			array('key'=>'14','value'=>'14'),
    			array('key'=>'15','value'=>'15'),
    			array('key'=>'16','value'=>'16'),
    			array('key'=>'17','value'=>'17'),
    			array('key'=>'18','value'=>'18'),
    			array('key'=>'19','value'=>'19'),
    			array('key'=>'20','value'=>'20')    	
    	);
    	
    	
    	$restId = $this->createElement('hidden','restaurantid');
    	$personal = $this->createElement('hidden','personal');
    	$personal->setValue('personal');
    	$upatetype = $this->createElement('hidden','updatetype');
    	
    	$restaurantName = $this->createElement('text', 'restName');
        $restaurantName->removeDecorator('Label')
        			   ->removeDecorator('HtmlTag')
        			   ->setAttrib('maxlength', '255')
        			   ->setAttrib('class','inp2')
        			   ->setAttrib('readonly','readonly')
        			   ->addFilters(array('StringTrim'))
        			   ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter your Restaurant Name.')),
        			   				array('StringLength', false,array(0,255))))
        	//	   ->setValue('')
        			   ->setRequired(true);
        			   
      	$restCapacity = $this->createElement('text', 'restCapacity');
      	$restCapacity->removeDecorator('Label')
      				 ->removeDecorator('HtmlTag')
      				 ->setAttrib('maxlength', '5')
      				 ->setAttrib('class','inp2 form')
      				 ->addFilters(array('StringTrim'))
      				 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter your Restaurant Capacity.')),
      				 				array('StringLength', false,array(0,5))))
      				 ->addValidator('Digits',new Zend_Validate_Digits(),array('messages' => 'Please enter Numbers only'))
      				 ->setValue('')
      				 ->setRequired(true);
        			   
		$restDiningStyle = $this->createElement('select','restDiningStyle');
		$restDiningStyle->removeDecorator('Label')
        			    ->removeDecorator('HtmlTag')
        			    ->setAttrib('maxlength', '100')
        			    ->setAttrib('class','sel1 form')
        			    ->addMultiOptions($diningStyleList)        			    
        			    ->setValue('')
        			    ->setRequired(false);		        			   
        			   
	   /* $resYearFound =  $this->createElement('text', 'resYearFound');
        $resYearFound->removeDecorator('Label')
        			 ->removeDecorator('HtmlTag')        			 
        			 ->setAttrib('class','inp1')
        			 ->setAttrib('maxlength', '4')
                	 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter Year Found.')),
                	 				array('StringLength', false,array(4,4,'messages' => array(
              					Zend_Validate_StringLength::TOO_SHORT => "Year must be 4 digits"
              				)))))
                	 ->addValidator('Digits',new Zend_Validate_Digits(),array('messages' => 'Please enter Numbers only'))
					 ->addValidator(new Zend_Validate_Date(array("format" => 'yyyy')))
                     ->setValue('')
                	 ->setRequired(true);*/
                	 
        $maxpax = $this->createElement('select', 'maxpax');
        $maxpax->removeDecorator('Label') 
        		 ->removeDecorator('HtmlTag')
        		 ->setAttrib('class','inp2')      		 
                 ->addMultiOptions($paxList)
                 ->setRequired(true);
                	 
         $restaurantType = $this->createElement('select','restype');
         $restaurantType->removeDecorator('Label') 
         				->removeDecorator('HtmlTag') 
         				->setAttrib('class','sel1') 
         				//->setAttrib('multiple', 'multiple')
         				->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select Restaurant Type.'))))
               			->addMultiOptions($resTypeList)
               			->setRegisterInArrayValidator(false)
               			->setRequired(true);
          //$restaurantType->size=5;
          
        $resPaymentMode = $this->createElement('multiCheckbox','resPayment');
        $resPaymentMode->removeDecorator('Label')
         			 ->removeDecorator('HtmlTag')
         			  ->setAttrib('class','sel1')
         			 ->setAttrib('style','height:20px;width:25px;!important')
         			 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select PaymentMode Type.'))))
         			 ->addMultiOptions($paymentmodesList)
         			 ->setRegisterInArrayValidator(false)
         			 ->setRequired(false)
         			 ->size=5;
               			
         $resprice = $this->createElement('select','resprice');
         $resprice->removeDecorator('Label')
         		  ->removeDecorator('HtmlTag')
         		  ->setAttrib('class','sel1 drpDown')
         		  
         		  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Select Price Range.'))))
         		  ->addMultiOptions($priceList)
         		  ->setRequired(true);
         
         			 
         $resWebsite = $this->createElement('text', 'resWebsite');
         $resWebsite->removeDecorator('Label') 
                    ->removeDecorator('HtmlTag')               	
                	->setAttrib('class','inp2')              
                	->setAttrib('maxlength', '255')
                	->addFilters(array('StringTrim'))
                	->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter WebSite.'))))
                	->setValue('')              
                	->setRequired(false);
                	
         $resManager = $this->createElement('text', 'resManager');
         $resManager->removeDecorator('Label') 
                    ->removeDecorator('HtmlTag')               	
                	->setAttrib('class','inp2')              
                	->setAttrib('maxlength', '255')
                	->addFilters(array('StringTrim'))
                	->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Restaurant ManagerName.'))))
                	->setValue('')              
                	->setRequired(false);
                	
		$resDescription = $this->createElement('textarea', 'resDescription');
		$resDescription->removeDecorator('Label')
		               ->removeDecorator('HtmlTag')                	   
                	   ->setAttrib('maxlength', '5000')
                	   ->setAttrib('cols', '40')
			           ->setAttrib('rows', '4')
			           ->setAttrib('class','inp1')
			           ->setAttrib('style', 'width:90%; height:162px;')
			           ->addFilters(array('StringTrim'))              
                	   ->setValue('')              
                	   ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Restaurant Description.')),
			           			array('StringLength', false,array(1,5000,'messages' => array(
              					Zend_Validate_StringLength::TOO_LONG => 'Description is too long(>5000).'
              				)))))
			           ->setRequired(false);
			           
		/*$restSubResSys = new Zend_Form_Element_Checkbox('restSubResSys');
		$restSubResSys->removeDecorator('Label')
			          ->removeDecorator('HtmlTag')
			          ->setRequired(false)
			          ->setChecked(false);*/
			          
		$restTimings = $this->createElement('textarea', 'restTimings');
		$restTimings->removeDecorator('Label')
				    ->removeDecorator('HtmlTag')                	   
                    ->setAttrib('maxlength', '100')
                    ->setAttrib('cols', '20')
		            ->setAttrib('rows', '3')
					 ->setAttrib('placeholder','(EX:9:00AM-11:00AM BREAKFAST,1:00PM-4:00PM LUNCH)')
					->setAttrib('style','height:80px !important; font-size:11px; width:90%;')
		            ->addFilters(array('StringTrim'))              
                    ->setValue('')              
                    ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Restaurant Description.')),
		           			array('StringLength', false,array(1,5000,'messages' => array(
              				Zend_Validate_StringLength::TOO_LONG => 'Description is too long(>5000).'
              			)))))
		            ->setRequired(false);


		$this->addElements( array ($restId,
								   $personal,
								   $upatetype,
								   $restaurantName,
								   $restCapacity,
								   $restDiningStyle,
								   //$resYearFound,
								   $maxpax,
								   $restaurantType,
								   $resprice,
								   $resWebsite,
								   $resManager,
								   $resDescription,
								   //$restSubResSys,
								   $restTimings,
								   $resPaymentMode
								   )		
		
		);	 
         		 
    }

}

