<?php

class FirmManagement_Form_EditFirmPersonalMoreDetails extends Zend_Form
{

	public function init()
    {
    	 $this->setAttrib('enctype', 'multipart/form-data');
    	
    	$paymentmodeMapper = new Application_Model_RestaurantPaymentModeDataMapper();
    	$paymentmodes = $paymentmodeMapper->fetchAll();
    	$paymentmodesList = array();
    	//$paymentmodesList[] = array('key'=>'','value'=>'Select Payment Mode');
    	foreach($paymentmodes as $paymentmode){
    		$paymentmodesList[] = array('key'=>$paymentmode->getId(),'value'=>$paymentmode->getDescription());
    	}
    	
    	$restId = $this->createElement('hidden','restaurantid');
    	$personal = $this->createElement('hidden','personalmore');
    	$personal->setValue('personalmore');
    	$upatetype = $this->createElement('hidden','updatetype');
    	
        $resPaymentMode = $this->createElement('multiCheckbox','resPayment');
        $resPaymentMode->removeDecorator('Label')
         			 ->removeDecorator('HtmlTag')
         			  ->setAttrib('class','sel1')
         			 ->setAttrib('style','height:20px;width:25px;!important')
         			 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select PaymentMode Type.'))))
         			 ->addMultiOptions($paymentmodesList)
         			 ->setRegisterInArrayValidator(false)
         			 ->setRequired(false)
         			 ->size=5;
               			
         
		$resDescription = $this->createElement('textarea', 'resDescription');
		$resDescription->removeDecorator('Label')
		               ->removeDecorator('HtmlTag')                	   
                	   ->setAttrib('maxlength', '5000')
                	   ->setAttrib('cols', '40')
			           ->setAttrib('rows', '4')
			           ->setAttrib('class','inp1')
			           ->setAttrib('style', 'width:90%; height:162px;')
			           ->addFilters(array('StringTrim'))              
                	   ->setValue('')              
                	   ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Restaurant Description.')),
			           			array('StringLength', false,array(1,5000,'messages' => array(
              					Zend_Validate_StringLength::TOO_LONG => 'Description is too long(>5000).'
              				)))))
			           ->setRequired(false);
		
		$restTimings = $this->createElement('textarea', 'restTimings');
		$restTimings->removeDecorator('Label')
				    ->removeDecorator('HtmlTag')                	   
                    ->setAttrib('maxlength', '100')
                    ->setAttrib('cols', '20')
		            ->setAttrib('rows', '3')
					 ->setAttrib('placeholder','(EX:9:00AM-11:00AM BREAKFAST,1:00PM-4:00PM LUNCH)')
					->setAttrib('style','height:80px !important; font-size:11px; width:90%;')
		            ->addFilters(array('StringTrim'))              
                    ->setValue('')              
                    ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Restaurant Description.')),
		           			array('StringLength', false,array(1,5000,'messages' => array(
              				Zend_Validate_StringLength::TOO_LONG => 'Description is too long(>5000).'
              			)))))
		            ->setRequired(false);


		$this->addElements( array ($restId,
								   $personal,
								   $upatetype,
								   $resDescription,
								   $restTimings,
								   $resPaymentMode
								   )		
		
		);	 
         		 
    }

}