<?php

class FirmManagement_Form_EditListFirmAddress extends Zend_Form
{

	public function init()
    {
    	 $this->setAttrib('enctype', 'multipart/form-data');
    	/* Populating State Base Data */
    	
    	$stateMapper  = new Application_Model_StateDataMapper();
    	$states = $stateMapper->fetchAll();
    	$stateList = array();  
    	$stateList[] = array('key'=>'','value'=>'Select State');  	   
    	foreach($states as $state){
    		$stateList[] = array('key'=>$state->getId(),'value'=>$state->getDescription());
    	}  
    	
    	$timezoneMapper = new Application_Model_TimeZoneDataMapper();
    	$timezones = $timezoneMapper->fetchAll();
    	$timezoneList = array();
    	$timezoneList[] = array('key'=>'','value'=>'Select TimeZone');
    	foreach($timezones as $timezone){
    		$timezoneList[] = array('key'=>$timezone->getCode(),'value'=>$timezone->getCode().$timezone->getDescription());
    	}
    	
    	$restId = $this->createElement('hidden','restaurantid');
    	$address = $this->createElement('hidden','address');
    	$address->setValue('address');
    	$reststatus = $this->createElement('hidden','reststatus');
    	$reststatus->setValue('list');
    	
    	$restLatitude = $this->createElement('hidden','restLatitude');
    	$restLatitude->removeDecorator('Label')
        			 ->removeDecorator('HtmlTag');
    	$restLongitude = $this->createElement('hidden','restLongitude');
    	$restLongitude->removeDecorator('Label')
        			  ->removeDecorator('HtmlTag');
    	
    	$resAddress = $this->createElement('text','resAddress');
        $resAddress->removeDecorator('Label')
        			 ->removeDecorator('HtmlTag')
        			 ->setAttrib('maxlength', '510')
        			 ->setAttrib('class','inp1')
        			 ->addFilters(array('StringTrim'))
        			 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter your Restaurant Address.')),
			         					array('StringLength', false,array(1,510,'messages' => array(
              					Zend_Validate_StringLength::TOO_LONG => 'address is too long(>510).'
              				)))))        			               		 
               		 ->setValue('')	
        			 ->setRequired(true);
    	
    	$resEmailAddress =  $this->createElement('text', 'emailAddress');
        $resEmailAddress ->removeDecorator('Label')
        				 ->removeDecorator('HtmlTag')        			     
        			     ->setAttrib('maxlength', '255')
        				 ->setAttrib('class','inp1')
                		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter your Email Address.')),
                		 				array('StringLength', false,array(5,255))))
                		 ->addValidator('EmailAddress',false,array('messages'=>array(Zend_Validate_EmailAddress::INVALID =>'Please enter a valid Host Name')))
						 ->addErrorMessage('Pleaes Enter Valid Email Address')
                		 ->addFilters(array('StringTrim'))
               			 ->setRequired(true);  
		
	         
		 $resState = $this->createElement('select','resState');
         $resState->removeDecorator('Label') 
         		  ->removeDecorator('HtmlTag')
         		  ->setAttrib('class','sel1 drpDown')
         		  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select State.'))))       	   
               	  ->addMultiOptions($stateList)
                  ->setRequired(true);   
		 
         $resRegion = $this->createElement('select','resRegion');
         $resRegion->removeDecorator('Label') 
         		  ->removeDecorator('HtmlTag')
         		  ->setAttrib('class','sel1 drpDown')
         		  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select Region.'))))       	   
               	  ->setRegisterInArrayValidator(false)
                  ->setRequired(true);
                  
         $resTimezone = $this->createElement('select','restimezone');
         $resTimezone->removeDecorator('Label')
         			 ->removeDecorator('HtmlTag')
         			 ->setAttrib('class','sel1 drpDown')
         			 
         			 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select Timezone.'))))
         			 ->addMultiOptions($timezoneList)
         			 ->setRequired(true);
                  
         $resCity = $this->createElement('select', 'resCity');
         $resCity->removeDecorator('Label')
         		 ->removeDecorator('HtmlTag')
         		 ->setAttrib('class','sel1 drpDown')
         		 ->setRegisterInArrayValidator(false)
         		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select City.'))))       	     
                 ->setRequired(true);
                          
         $resNeighbour = $this->createElement('select', 'resNeighbour');
         $resNeighbour->removeDecorator('Label')
         			  ->setAttrib('class','sel1 drpDown')
         		 	  ->removeDecorator('HtmlTag')
         		 	  ->setRegisterInArrayValidator(false)
         		 	  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select Restaurant Neighbourhood.'))))        	          
                 	  ->setRequired(true);
                 	  
         $resPostalCode = $this->createElement('text', 'postalCode');
         $resPostalCode->removeDecorator('Label')  
         			   ->removeDecorator('HtmlTag')      		       
        		       ->setAttrib('class','inp1')
        		       ->addFilters(array('StringTrim'))
        		       ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Postal Code.'))))    
                       ->addValidator('StringLength', false,array(1,10))
                       ->setValue('')
                       ->setAttrib('maxlength', '10')
                       ->setRequired(true);                                
                 
         $resPhone = $this->createElement('text', 'resPhone');
         $resPhone->removeDecorator('Label')
         		  ->removeDecorator('HtmlTag')                  
                  ->setAttrib('class','inp1')              
                  ->setAttrib('maxlength', '15')
                  ->addFilters(array('StringTrim'))
                  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Phone Number.'))))
                  ->setValue('')              
                  ->setRequired(true);

         $resFax = $this->createElement('text', 'resFax');
         $resFax->removeDecorator('Label') 
         		->removeDecorator('HtmlTag')               
                ->setAttrib('class','inp1')              
                ->setAttrib('maxlength', '15')
                ->addFilters(array('StringTrim'))
                ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Fax Number.'))))
                ->setValue('')              
                ->setRequired(false);
                
         $executiveChef = $this->createElement('text','executiveChef');
		$executiveChef->removeDecorator('Label')
			          ->removeDecorator('HtmlTag')
			          ->setRequired(false)
			          ->setAttrib('maxlength', '100')
			          ->addFilters(array('StringTrim'))
			          ->addValidators(array(array('StringLength', false,array(1,100,'messages' => array(
              			Zend_Validate_StringLength::TOO_LONG => 'AdditDetails is too long(>100).'
              			)))))
			          ->setAttrib('class','inp1');
              	 
        $dressCode = $this->createElement('text','derssCode');
		$dressCode->removeDecorator('Label')
		          ->removeDecorator('HtmlTag')
			      ->setRequired(false)
			      ->setAttrib('maxlength', '100')
			      ->addFilters(array('StringTrim'))
			      ->addValidators(array(array('StringLength', false,array(1,100,'messages' => array(
              		Zend_Validate_StringLength::TOO_LONG => 'Dress Code is too long(>100).'
              			)))))
			      ->setAttrib('class','inp1');
			      
		$walkin = new Zend_Form_Element_Checkbox('walkIn');
		$walkin->removeDecorator('Label')
			  ->removeDecorator('HtmlTag')
			  ->setRequired(false)
			  ->setChecked(false);
         
        $this->addElements( array ($restId,
								   $address,
								   $resAddress,
								   $resEmailAddress,
								   $resState,
								   $resRegion,
								   $resTimezone,
								   $resCity,
								   $resNeighbour,
								   $resPostalCode,
								   $resPhone,
								   $resFax,
								   $executiveChef,
								   $dressCode,
								   $walkin,
								   $reststatus,
								   $restLatitude,
								   $restLongitude
								   )		
		
		);	 
         		 
    }

}

