<?php

class FirmManagement_Form_EditListFirmParking extends Zend_Form
{

	public function init()
    {
    	 $this->setAttrib('enctype', 'multipart/form-data');
    	
    	$restId = $this->createElement('hidden','restaurantid');
    	$parking = $this->createElement('hidden','parking');
    	$parking->setValue('parking');
    	$reststatus = $this->createElement('hidden','reststatus');
    	$reststatus->setValue('list');
    	
    	$restParking = $this->createElement('text','restParking');
	    $restParking->removeDecorator('Label')
			        ->removeDecorator('HtmlTag')
			        ->setAttrib('class','inp1')
			        ->addFilters(array('StringTrim'))			     
			        ->setRequired(false)
			        ->setAttrib('maxlength', '100');

		$restParkDetail = $this->createElement('text','restParkDetails');
		$restParkDetail->removeDecorator('Label')
			           ->removeDecorator('HtmlTag')			     
			           ->setRequired(false)
			           ->setAttrib('maxlength', '5000')
			           ->addFilters(array('StringTrim'))
			           ->addValidators(array(array('StringLength', false,array(1,5000,'messages' => array(
              					Zend_Validate_StringLength::TOO_LONG => 'ParkDetail is too long(>5000).'
              				)))))
			           ->setAttrib('class','inp1');

		$restPrivateParty = $this->createElement('text','restPrivParty');
		$restPrivateParty->removeDecorator('Label')
			             ->removeDecorator('HtmlTag')
			             ->setRequired(false)
			           	 ->setAttrib('maxlength', '(1000')
			           	 ->addFilters(array('StringTrim'))
			           	 ->addValidators(array(array('StringLength', false,array(1,1000,'messages' => array(
              					Zend_Validate_StringLength::TOO_LONG => 'PrivParty is too long(>1000).'
              				)))))
			           	 ->setAttrib('class','inp1');					           
			           				        
        $restPrivContact = $this->createElement('text','restPrivPartyContact');
		$restPrivContact->removeDecorator('Label')
			             ->removeDecorator('HtmlTag')
			             ->setRequired(false)
			           	 ->setAttrib('maxlength', '500')
			           	 ->addFilters(array('StringTrim'))
			           	 ->addValidators(array(array('StringLength', false,array(1,500,'messages' => array(
              					Zend_Validate_StringLength::TOO_LONG => 'PrivPartyContact is too long(>500).'
              				)))))
			           	->setAttrib('class','inp1');	

		$restEntertainment = $this->createElement('text','restEntertainment');
		$restEntertainment->removeDecorator('Label')
			              ->removeDecorator('HtmlTag')
			              ->setRequired(false)
			           	  ->setAttrib('maxlength', '1000')
			           	  ->addFilters(array('StringTrim'))
			           	  ->addValidators(array(array('StringLength', false,array(1,1000,'messages' => array(
              					Zend_Validate_StringLength::TOO_LONG => 'Entertainment is too long(>1000).'
              				)))))
			           	  ->setAttrib('class','inp1');
			           	  	
		$restAdditDetail = $this->createElement('text','restAdditDetails');
		$restAdditDetail->removeDecorator('Label')
			            ->removeDecorator('HtmlTag')
			            ->setRequired(false)
			            ->setAttrib('maxlength', '500')
			            ->addFilters(array('StringTrim'))
			            ->addValidators(array(array('StringLength', false,array(1,500,'messages' => array(
              					Zend_Validate_StringLength::TOO_LONG => 'AdditDetails is too long(>500).'
              				)))))
			            ->setAttrib('class','inp1');
			            
		$publictransit = $this->createElement('text','publictransit');
		$publictransit->removeDecorator('Label')
			          ->removeDecorator('HtmlTag')
			          ->setRequired(false)
			          ->setAttrib('maxlength', '500')
			          ->addFilters(array('StringTrim'))
			          ->addValidators(array(array('StringLength', false,array(1,500,'messages' => array(
              			Zend_Validate_StringLength::TOO_LONG => 'Publictransit is too long(>500).'
              			)))))
			          ->setAttrib('class','inp1');	

        $spleventsandpromotions = $this->createElement('text','spleventsandpromotions');
		$spleventsandpromotions->removeDecorator('Label')
			          		   ->removeDecorator('HtmlTag')
			                   ->setRequired(false)
			                   ->setAttrib('maxlength', '500')
			                   ->addFilters(array('StringTrim'))
			         		   ->addValidators(array(array('StringLength', false,array(1,500,'messages' => array(
              			Zend_Validate_StringLength::TOO_LONG => 'Events and Promotions is too long(>500).'
              			)))))
			                   ->setAttrib('class','inp1');	
			                   
         $rescrossstreet = $this->createElement('text','crossstreet');
		 $rescrossstreet->removeDecorator('Label')
			          		   ->removeDecorator('HtmlTag')
			                   ->setRequired(false)
			                   ->setAttrib('maxlength', '100')
			                   ->addFilters(array('StringTrim'))
			         		   ->addValidators(array(array('StringLength', false,array(1,100,'messages' => array(
              			Zend_Validate_StringLength::TOO_LONG => 'Crossstreet is too long(>100).'
              			)))))
			                   ->setAttrib('class','inp1');
			                   
			                   
         $resmenu = $this->createElement('text','menu');
		 $resmenu->removeDecorator('Label')
			          		   ->removeDecorator('HtmlTag')
			                   ->setRequired(false)
			                   ->setAttrib('maxlength', '500')
			                   ->addFilters(array('StringTrim'))
			         		   ->addValidators(array(array('StringLength', false,array(1,500,'messages' => array(
              			Zend_Validate_StringLength::TOO_LONG => 'Menu is too long(>500).'
              			)))))
                   ->setAttrib('class','inp1');  
		
		$this->addElements( array ($restId,
								   $parking,
								   $restParking,
								   $restParkDetail,
								   $restPrivateParty,
								   $restPrivContact,
								   $restEntertainment,
								   $restAdditDetail,
								   $publictransit,
								   $spleventsandpromotions,
								   $rescrossstreet,
								   $resmenu,
								   $reststatus
								   )		
		
		);	 
         		 
    }

}

