<?php
class FirmManagement_Form_EditRoundMenuFirmAddressDetails extends Zend_Form
{

	public function init()
    {
    	$this->setAttrib('enctype', 'multipart/form-data');
    	
    	$stateMapper  = new Application_Model_StateDataMapper();
    	$states = $stateMapper->fetchAll();
    	$stateList = array();  
    	$stateList[] = array('key'=>'','value'=>'Select State');  	   
    	foreach($states as $state){
    		$stateList[] = array('key'=>$state->getId(),'value'=>$state->getDescription());
    	}  
    	
    	$restId = $this->createElement('hidden','restaurantid');
    	$address = $this->createElement('hidden','address');
    	$address->setValue('address');
    	
    	$resState = $this->createElement('select','resState');
        $resState->removeDecorator('Label') 
         		  ->removeDecorator('HtmlTag')
         		  ->setAttrib('class','sel1 drpDown')
         		  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select State.'))))       	   
               	  ->addMultiOptions($stateList)
                  ->setRequired(true);
                  
         $resTimezone = $this->createElement('select','restimezone');
       	 $resTimezone->removeDecorator('Label')
	         		 ->removeDecorator('HtmlTag')
	         		 ->setAttrib('class','sel1 drpDown')
	         		 ->setRegisterInArrayValidator(false)
	         		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select TimeZone.'))))       	     
	                 ->setRequired(true);
                  
         $resCity = $this->createElement('select', 'resCity');
         $resCity->removeDecorator('Label')
         		 ->removeDecorator('HtmlTag')
         		 ->setAttrib('class','sel1 drpDown')
         		 ->setRegisterInArrayValidator(false)
         		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select City.'))))       	     
                 ->setRequired(true);
         
         $resRegion = $this->createElement('select', 'resRegion');
         $resRegion->removeDecorator('Label')
         		 ->removeDecorator('HtmlTag')
         		 ->setAttrib('class','sel1 drpDown')
         		 ->setRegisterInArrayValidator(false)
         		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select Region.'))))       	     
                 ->setRequired(true);
                          
         $resNeighbour = $this->createElement('select', 'resNeighbour');
         $resNeighbour->removeDecorator('Label')
         			  ->setAttrib('class','sel1 drpDown')
         		 	  ->removeDecorator('HtmlTag')
         		 	  ->setRegisterInArrayValidator(false)
         		 	  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select Restaurant Neighbourhood.'))))        	          
                 	  ->setRequired(true);
                 	  
         $countryCode = $this->createElement('hidden', 'countryCode');
         $countryCode->removeDecorator('DtDdWrapper')
				  	 ->removeDecorator('Label')
				  	 ->removeDecorator('HtmlTag');
        		       
        $this->addElements( array ($restId,
								   $address,
								   $resState,
								   $resRegion,
								   $resTimezone,
								   $resCity,
								   $resNeighbour,
								   $countryCode
								   )		
		
		);	 
         		 
    }

}