<?php
class FirmManagement_Form_EditRoundMenuFirmPersonalDetails extends Zend_Form
{
	public function init()
    {
    	$this->setAttrib('enctype', 'multipart/form-data');
    	
    	$resTypeMapper  = new Application_Model_RestaurantTypeDataMapper();
    	$resTypes = $resTypeMapper->getRestauranttypeBD();
    	$resTypeList = array();
    	$resTypeList[] = array('key'=>'','value'=>'Select Restaurant Type');    	   
    	foreach($resTypes as $resType){
    		$resTypeList[] = array('key'=>$resType->getId(),'value'=>$resType->getDescription());
    	}   
    	
    	$priceMapper = new Application_Model_PriceDataMapper();
    	$prices = $priceMapper->fetchAll();
    	$priceList = array();
    	$priceList[] = array('key'=>'','value'=>'Select Price');
    	foreach($prices as $price){
    		$priceList[] = array('key'=>$price->getCode(),'value'=>$price->getCode());
    	}
    	
    	$diningStyleList = array(
    			array('key'=>'','value'=>'Select Dining Style'),
    			array('key'=>'Casual Elegant','value'=>'Casual Elegant'),
    			array('key'=>'Casual Dining','value'=>'Casual Dining'),
    			array('key'=>'Fine Dining','value'=>'Fine Dining'),
    			array('key'=>'Coffeehouse','value'=>'Coffeehouse'),
    			array('key'=>'Pizzeria','value'=>'Pizzeria'),
    			array('key'=>'Steakhouses','value'=>'Steakhouses'),
    			array('key'=>'Seafood Restaurants','value'=>'Seafood Restaurants')    	
    	);
    	
    	$paxList = array(
    			array('key'=>'0','value'=>'Select PartySize'),
    			array('key'=>'1','value'=>'1'),
    			array('key'=>'2','value'=>'2'),
    			array('key'=>'3','value'=>'3'),
    			array('key'=>'4','value'=>'4'),
    			array('key'=>'5','value'=>'5'),
    			array('key'=>'6','value'=>'6'),
    			array('key'=>'7','value'=>'7'),
    			array('key'=>'8','value'=>'8'),
    			array('key'=>'9','value'=>'9'),
    			array('key'=>'10','value'=>'10'),
    			array('key'=>'11','value'=>'11'),
    			array('key'=>'12','value'=>'12'),
    			array('key'=>'13','value'=>'13'),
    			array('key'=>'14','value'=>'14'),
    			array('key'=>'15','value'=>'15'),
    			array('key'=>'16','value'=>'16'),
    			array('key'=>'17','value'=>'17'),
    			array('key'=>'18','value'=>'18'),
    			array('key'=>'19','value'=>'19'),
    			array('key'=>'20','value'=>'20')    	
    	);
    	
    	
    	$restId = $this->createElement('hidden','restaurantid');
    	$personal = $this->createElement('hidden','personal');
    	$personal->setValue('personal');
    	$upatetype = $this->createElement('hidden','updatetype');
    	
    	$restaurantName = $this->createElement('text', 'restName');
        $restaurantName->removeDecorator('Label')
        			   ->removeDecorator('HtmlTag')
        			   ->setAttrib('maxlength', '255')
        			   ->setAttrib('class','inp2')
        			   ->setAttrib('readonly','readonly')
        			   ->addFilters(array('StringTrim'))
        			   ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter your Restaurant Name.')),
        			   				array('StringLength', false,array(0,255))))
        			   ->setRequired(true);
        			   
      	$restCapacity = $this->createElement('text', 'restCapacity');
      	$restCapacity->removeDecorator('Label')
      				 ->removeDecorator('HtmlTag')
      				 ->setAttrib('maxlength', '5')
      				 ->setAttrib('class','inp2 form')
      				 ->addFilters(array('StringTrim'))
      				 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter your Restaurant Capacity.')),
      				 				array('StringLength', false,array(0,5))))
      				 ->addValidator('Digits',new Zend_Validate_Digits(),array('messages' => 'Please enter Numbers only'))
      				 ->setValue('')
      				 ->setRequired(true);
        			   
		$restDiningStyle = $this->createElement('select','restDiningStyle');
		$restDiningStyle->removeDecorator('Label')
        			    ->removeDecorator('HtmlTag')
        			    ->setAttrib('maxlength', '100')
        			    ->setAttrib('class','sel1 form')
        			    ->addMultiOptions($diningStyleList)        			    
        			    ->setValue('')
        			    ->setRequired(true);		        			   
       
        $maxpax = $this->createElement('select', 'maxpax');
        $maxpax->removeDecorator('Label') 
        		 ->removeDecorator('HtmlTag')
        		 ->setAttrib('class','inp2')      		 
                 ->addMultiOptions($paxList)
                 ->setRequired(true);
                	 
         $restaurantType = $this->createElement('select','restype');
         $restaurantType->removeDecorator('Label') 
         				->removeDecorator('HtmlTag') 
         				->setAttrib('class','sel1') 
         				->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select Restaurant Type.'))))
               			->addMultiOptions($resTypeList)
               			->setRegisterInArrayValidator(false)
               			->setRequired(true);
          
         $resprice = $this->createElement('select','resprice');
         $resprice->removeDecorator('Label')
         		  ->removeDecorator('HtmlTag')
         		  ->setAttrib('class','sel1 drpDown')
         		  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Select Price Range.'))))
         		  ->addMultiOptions($priceList)
         		  ->setRequired(true);
         
         

		$this->addElements( array ($restId,
								   $personal,
								   $upatetype,
								   $restaurantName,
								   $restCapacity,
								   $restDiningStyle,
								   $maxpax,
								   $restaurantType,
								   $resprice
								   )		
		
		);	 
         		 
    }

}