<?php
class FirmManagement_Form_FirmDeal extends Zend_Form
{
	public function init()
	{
		$HoursList = array(
    			array('key'=>'01','value'=>'01'),
    			array('key'=>'02','value'=>'02'),
    			array('key'=>'03','value'=>'03'),
    			array('key'=>'04','value'=>'04'),
    			array('key'=>'05','value'=>'05'),
    			array('key'=>'06','value'=>'06'),
    			array('key'=>'07','value'=>'07'),
    			array('key'=>'08','value'=>'08'),
    			array('key'=>'09','value'=>'09'),
    			array('key'=>'10','value'=>'10'),
    			array('key'=>'11','value'=>'11'),
    			array('key'=>'12','value'=>'12')    	
    	);
    	
    	$minutesList= array(
    			array('key'=>'00','value'=>'00'),
    			array('key'=>'05','value'=>'05'),
    			array('key'=>'10','value'=>'10'),
    			array('key'=>'15','value'=>'15'),
    			array('key'=>'20','value'=>'20'),
    			array('key'=>'25','value'=>'25'),
    			array('key'=>'30','value'=>'30'),
    			array('key'=>'35','value'=>'35'),
    			array('key'=>'40','value'=>'40'),
    			array('key'=>'45','value'=>'45'),
    			array('key'=>'50','value'=>'50'),
    			array('key'=>'55','value'=>'55')    	
    	);
    	
    	$meridiemList = array(
    			array('key'=>'AM','value'=>'AM'),
    			array('key'=>'PM','value'=>'PM')
    			);
    			
    	$DealId = $this->createElement('hidden','dealId');
    			
		$restNameCtl = $this->createElement('select','RestaurantName');
        $restNameCtl->removeDecorator('Label')
         		    ->removeDecorator('HtmlTag')
         		    ->setAttrib('class','sel1 drpDown')
         		    ->setRegisterInArrayValidator(false)
         		    ->setRequired(true);
         		    
    	$dealTitle = $this->createElement('text','dealTitle');
    	$dealTitle->removeDecorator('Label')
    			  ->removeDecorator('HtmlTag')
    			  ->setAttrib('maxlength', '100')
    			  ->setAttrib('class','inp1')
    			  ->addFilters(array('StringTrim'))
    			  ->setValue('')
        		  ->setRequired(true);
        		  
       	$dealImage = $this->createElement('file','dealImage');
		$dealImage->removeDecorator('Label')
			      ->removeDecorator('HtmlTag')
			      ->setAttrib('class','inp1')			     
			      ->setRequired(false)
			      ->addValidator(new Zend_Validate_File_Size('1MB'))
			      ->addValidator(new Zend_Validate_File_IsImage)				 
			      ->addValidator('Extension', false, 'jpg,png,gif');
			      
		$foodType = $this->createElement('select', 'foodtype');
		$foodType->removeDecorator('Label')
				 ->removeDecorator('HtmlTag')
				 ->setAttrib('class','sel1 drpDown')
				 ->setRegisterInArrayValidator(false)
				 ->setRequired(false);
				 
		$dealStartDate = $this->createElement('text','dealStartDate');
		$dealStartDate->removeDecorator('Label')
					  ->removeDecorator('HtmlTag')
					  ->setAttrib('class','inp1 datepicker')
					  ->addFilters(array('StringTrim'))
					  ->setRequired(false);
					  
		$dealEndDate = $this->createElement('text','dealEndDate');
		$dealEndDate->removeDecorator('Label')
					->removeDecorator('HtmlTag')
					->setAttrib('class','inp1 datepicker')
					->addFilters(array('StringTrim'))
					->setRequired(false);
					
		$dealStartHoursTime = $this->createElement('select', 'dealStartHoursTime');
		$dealStartHoursTime->removeDecorator('Label')
					  	   ->removeDecorator('HtmlTag')
					  	   ->removeDecorator('DtDdWrapper')
					  	   ->addMultiOptions($HoursList)
					  	   ->setRequired(false);

		$dealStartMinutesTime = $this->createElement('select', 'dealStartMinutesTime');
		$dealStartMinutesTime->removeDecorator('Label')
					  		 ->removeDecorator('HtmlTag')
					  		 ->removeDecorator('DtDdWrapper')
					  		 ->addMultiOptions($minutesList)
					  		 ->setRequired(false);
					 
		$dealStartMeridiem = $this->createElement('select', 'dealStartMeridiem');
		$dealStartMeridiem->removeDecorator('Label')
					  	  ->removeDecorator('HtmlTag')
					  	  ->removeDecorator('DtDdWrapper')
					  	  ->addMultiOptions($meridiemList)
					  	  ->setRequired(false);
					  	  
		$dealEndHoursTime = $this->createElement('select', 'dealEndHoursTime');
		$dealEndHoursTime->removeDecorator('Label')
					  	   ->removeDecorator('HtmlTag')
					  	   ->removeDecorator('DtDdWrapper')
					  	   ->addMultiOptions($HoursList)
					  	   ->setRequired(false);

		$dealEndMinutesTime = $this->createElement('select', 'dealEndMinutesTime');
		$dealEndMinutesTime->removeDecorator('Label')
					  		 ->removeDecorator('HtmlTag')
					  		 ->removeDecorator('DtDdWrapper')
					  		 ->addMultiOptions($minutesList)
					  		 ->setRequired(false);
					 
		$dealEndMeridiem = $this->createElement('select', 'dealEndMeridiem');
		$dealEndMeridiem->removeDecorator('Label')
					  	  ->removeDecorator('HtmlTag')
					  	  ->removeDecorator('DtDdWrapper')
					  	  ->addMultiOptions($meridiemList)
					  	  ->setRequired(false);
					  
		$dealRecurrence = $this->createElement('checkBox','dealRecurrence');
		$dealRecurrence->removeDecorator('Label')
			          ->removeDecorator('HtmlTag')
			          ->setAttrib('class','chk1 recChk')
			          ->setRequired(false)
			          ->setChecked(false);			  	

		$weeks = new Zend_Form_Element_MultiCheckbox('weeks', array(
						'multiOptions' => array(
							'01' => 'SUN',
							'02' => 'MON',
							'03' => 'TUE',
							'04' => 'WED',
							'05' => 'THU',
							'06' => 'FRI',
							'07' => 'SAT'
						 )
				));
		$weeks->removeDecorator('Label')
			   ->removeDecorator('HtmlTag',array('tag' => 'Br'))			  
			   ->setRequired(false);
			          
		$dealDescription = $this->createElement('textArea', 'dealDescription');
		$dealDescription->removeDecorator('Label')
						->removeDecorator('HtmlTag')                	   
                	    ->setAttrib('maxlength', '10000')
                	    ->setValue('')              
                	    ->setAttrib('cols', '40')
			            ->setAttrib('rows', '4')
			            ->addFilters(array('StringTrim'))
			            ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter DealDescription.')),
			           			array('StringLength', false,array(1,10000,'messages' => array(
              					Zend_Validate_StringLength::TOO_LONG => 'Description is too long(>10000).'
              				)))))
			            ->setRequired(true);
			            
		$dealSubmit = $this->createElement('submit','Submit');
        $dealSubmit->removeDecorator('Label')
        		   ->removeDecorator('DtDdWrapper')
        		   ->setValue('Submit')           		          		        		
        		   ->setAttrib('class','submitBtn')
                   ->setIgnore(true);

		$dealReset = $this->createElement('reset','Reset');
        $dealReset->removeDecorator('Label')        		 
        		  ->setValue('Reset')
        		  ->removeDecorator('DtDdWrapper')           	  	 
        	  	  ->setAttrib('class','submitBtn')
              	  ->setIgnore(true);

        $this->addElements( array ($DealId,
        						   $restNameCtl,
        						   $dealTitle,
        						   $dealImage,
        						   $foodType,
        						   $dealStartDate,
        						   $dealEndDate,
        						   $dealStartHoursTime,
        						   $dealStartMinutesTime,
        						   $dealStartMeridiem,
        						   $dealEndHoursTime,
        						   $dealEndMinutesTime,
        						   $dealEndMeridiem,
        						   $dealRecurrence,
        						   $weeks,
        						   $dealDescription,
        						   $dealSubmit,
        						   $dealReset
        				  ));
	}
}