<?php
class FirmManagement_Form_ManageMailChimp extends Zend_Form
{

	public function init()
    {
		$this->setAttrib('enctype', 'multipart/form-data');
		
		$userid = $this->createElement('hidden','userid');
		$userid->removeDecorator('Label')
				->removeDecorator('DtDdWrapper')
        	  ->removeDecorator('HtmlTag');
        	  
        $restid = $this->createElement('hidden','restaurantid');
		$restid->removeDecorator('Label')
				->removeDecorator('DtDdWrapper')
        	  ->removeDecorator('HtmlTag');
    	
		$constName =  $this->createElement('text', 'mailChimpName');
        $constName->removeDecorator('Label')
        		  ->removeDecorator('HtmlTag')        		
        		  ->setAttrib('maxlength', '30')
        		  ->setAttrib('class','inp1 required')
        		  ->addFilters(array('StringTrim'))
                  ->addValidators(array
                				(array('NotEmpty', true, array('messages' => 'Please enter your Mail Chimp User Name.')),
                					array('StringLength', false,array(0,30))))                					 
                  ->setValue('')
                  ->setRequired(true);
                  
        $apikey =  $this->createElement('text', 'mailChimpApi');
        $apikey->removeDecorator('Label')
        	   ->removeDecorator('HtmlTag')        		
               ->setAttrib('maxlength', '36')
        	   ->setAttrib('class','inp1 required')
        	   ->addFilters(array('StringTrim'))
               ->addValidators(array
                				(array('NotEmpty', true, array('messages' => 'Please enter your Mail Chimp Api Key.')),
                					array('StringLength', false,array(0,36))))                					 
               ->setValue('')
               ->setRequired(true);
                  
        $Submit = $this->createElement('submit','Update');
        $Submit->removeDecorator('Label')
        		   ->removeDecorator('DtDdWrapper')
        		   ->setValue('Submit')           		          		        		
        		   ->setAttrib('class','submitBtn')
                   ->setIgnore(false);
                  
        $this->addElements( array ($userid,
        							$restid,
        						   $constName,
        						   $apikey,
        						   $Submit
        		 ));
    }
}