<?php
class FirmManagement_Form_SearchUserContact extends Zend_Form
{

	public function init()
    {
		$this->setAttrib('enctype', 'multipart/form-data');
		
		$userid = $this->createElement('hidden','userid');
    	$searchid = $this->createElement('hidden','searchid');
    	$searchid->removeDecorator('Label')
         		 ->removeDecorator('HtmlTag')
         		 ->setValue('search');
         		 
        $sorton = $this->createElement('hidden','contsorton');
        $sorton->removeDecorator('Label')
         	   ->removeDecorator('HtmlTag');
         	   
    	$sortorder = $this->createElement('hidden','contsortorder');
    	$sortorder->removeDecorator('Label')
         		  ->removeDecorator('HtmlTag');

        $upComingEventStatus = $this->createElement('hidden','upComingEventStatus');
    	$upComingEventStatus->removeDecorator('Label')
         		  			->removeDecorator('HtmlTag')
         		  			->setValue('false'); 
    	
		$restNameCtl = $this->createElement('select','restaurantName');
        $restNameCtl->removeDecorator('Label')
         		    ->removeDecorator('HtmlTag')
         		    ->setAttrib('class','sel1 drpDown')
         		    ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select RestaurantName.'))))
         		    ->setRegisterInArrayValidator(false)
         		    ->setRequired(false);
         		    
        $groupName = $this->createElement('select','restgroupname');
        $groupName->removeDecorator('Label')
         		  ->removeDecorator('HtmlTag')
        		  ->setAttrib('class','sel1 drpDown')
         		  ->addValidators(array
        		 				(array('NotEmpty', true, array('messages' => 'Please select GroupName.'))))
         		  ->setRegisterInArrayValidator(false)
         		  ->setRequired(false);
         		  
       	$firstName =  $this->createElement('text', 'firstName');
        $firstName->removeDecorator('Label')
        		  ->removeDecorator('HtmlTag')        		
        		  ->setAttrib('maxlength', '30')
        		  ->setAttrib('class','inp1')
        		  ->addFilters(array('StringTrim'))
                  ->addValidators(array
                				(array('NotEmpty', true, array('messages' => 'Please enter your First Name.')),
                					array('StringLength', false,array(0,30))))                					 
                  ->setValue('')
                  ->setRequired(false);
        
        $lastName = $this->createElement('text', 'lastName');
        $lastName->removeDecorator('Label')
        		 ->removeDecorator('HtmlTag')
        		 ->setAttrib('maxlength', '30')
        		 ->setAttrib('class','inp1')
        		 ->addFilters(array('StringTrim'))
        		 ->addValidators(array
        		 				  (array('StringLength', false,array(0,30)))
        		 				 )
                 ->setValue('')
                 ->setRequired(false); 
                 
        $emailId = $this->createElement('text', 'emailId');
        $emailId->removeDecorator('Label')
        		 ->removeDecorator('HtmlTag')
        		 ->setAttrib('maxlength', '30')
        		 ->setAttrib('class','inp1')
        		 ->addFilters(array('StringTrim'))
        		 ->addValidators(array
        		 				  (array('StringLength', false,array(0,30)))
        		 				 )
                 ->setValue('')
                 ->setRequired(false); 
                 
        $phoneNumber = $this->createElement('text', 'phoneNumber');
        $phoneNumber->removeDecorator('Label')
        		 ->removeDecorator('HtmlTag')
        		 ->setAttrib('maxlength', '15')
        		 ->setAttrib('class','inp1')
        		 ->addFilters(array('StringTrim'))
        		 ->addValidators(array
        		 				  (array('StringLength', false,array(0,15)))
        		 				 )
                 ->setValue('')
                 ->setRequired(false); 
                 
                   
        $search = $this->createElement('submit','Search');
        $search->removeDecorator('Label')
        		   ->removeDecorator('DtDdWrapper')
        		   ->setValue('Submit')           		          		        		
        		   ->setAttrib('class','submitBtn')
                   ->setIgnore(false);
                
        $this->addElements( array ($userid,
        						   $searchid,
        						   $restNameCtl,
        						   $groupName,
        						   $firstName,
        						   $lastName,
        						   $search,
        						   $sorton,
        						   $sortorder,
        						   $emailId,
        						   $phoneNumber,
        						   $upComingEventStatus
        				));
    }
}