<?php

class FirmManagement_Model_CampaignDetailsDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('FirmManagement_Model_DbTable_CampaignDetails');
		}
		return $this->_dbTable;
	}
	
	public function getSmsCampaignDetailsByCampId($campID,$offset)
	{
		try{
			$limit = 20;
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			$resultarr = array();
			$pageOffset = ($offset-1)*$limit;
			$select->from($table,array('campd_id','campd_phone','campd_sentstatus'))
				   ->join(array('mt.sms_campaigns'),'smscamp_id = campd_smsid',array('smscamp_title','smscamp_msg'))
				   ->where('smscamp_id = ?',$campID)
			->limit($limit,$pageOffset);
			$resultSet = $select->query()->fetchAll();
		  	if(count($resultSet) > 0){
		  		foreach($resultSet as $result){
		  			$resultarr[] = array('Id'       		=> $result['campd_id'],
		  								 'CampaignName' 	=> $result['smscamp_title'],
		  								 'Message'			=> $result['smscamp_msg'],
		  								 'Phone'			=> $result['campd_phone'],
		  								 'Status'			=> $result['campd_sentstatus']
										
					);
		  		}
		  	}
			return $resultarr;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
		}
}