<?php
class FirmManagement_Model_ContWidgetCustomizeDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('FirmManagement_Model_DbTable_ContWidgetCustomize');
		}
		return $this->_dbTable;
	}
           
// Faiz: This mapper function is to save the data of the color codes saved by the restaurant user or owner. //           
	public function SavecontWidget(FirmManagement_Model_ContCustomWidget $Details)
    {
        try{
        		$restId = $Details->getrestid();
	        	$select = $this->getDbTable()
	        					->select()
	            				->from('mt.cont_widget_customize',array('cwc_links_colors','cwc_alerts_colors','cwc_title_colors','cwc_bg_color','cwc_bg_image_url'))
	              				->where('cwc_restid = ?',$restId); 
	            $exec = $select->query();
				$result = $exec->fetchAll();
	           	$InsertData = array('cwc_links_colors' 	=> '#'.$Details ->getcolorlinks(),
					          'cwc_alerts_colors' 		=> '#'.$Details->getalertcolors(),
				              'cwc_title_colors' 		=> '#'.$Details->gettitlecolor(),
				              'cwc_bg_color'   			=> '#'.$Details->getbgcolor(),
				              'cwc_restid' 				=> $restId,    
	           				  'cwc_createdby'			=> $Details->getcreated_by(),
	           				  'cwc_create_date_time'		=> $Details->getcreated_date()
	           				  );   				
	           	$UpdateData = array('cwc_links_colors' 	=> '#'.$Details ->getcolorlinks(),
					          'cwc_alerts_colors' 		=> '#'.$Details->getalertcolors(),
				              'cwc_title_colors' 		=> '#'.$Details->gettitlecolor(),
				              'cwc_bg_color'   			=> '#'.$Details->getbgcolor(),
				              'cwc_bg_image_url' 		=> $Details->getbgimage(),    
	           				  'cwc_updatedby'			=> $Details->getupdated_by(),
	           				  'cwc_updated_date_time'	=> $Details->getupdated_date()
	           				  ); 
	           	$Insert = '';
	           	$Update = '';
	           	if ($result == NULL) {
		           	if($Details->getbgimage()){
		           		$InsertData['cwc_bg_image_url'] 		= $Details->getbgimage();
		           	}
		           	$Insert = $this->getDbTable()->insert($InsertData);
		         
	        	} 
	        	else {    	
	        		if($Details->getbgimage()){
		           		$UpdateData['cwc_bg_image_url'] 		= $Details->getbgimage();
		           	}
	        		$Update =  $this->getDbTable()->update($UpdateData, array('cwc_restid = ?' => $restId));      
	        	}
	        	if($Insert !='' || $Update != ''){
	        		return 't';
	        	}
	        	else
	        	{
	        		return 'f';
	        	}
	        }catch (Exception $ex){
				throw new Exception($ex->getMessage()) ;
		}
    }
//Faiz: This fucntion is to fetch the color codes saved by the owner or restaurant user.  Here we are fecthing the records  with the help of restaurant id. *//         
 	public function getContCustomizeWidgeteSetting($restid)
    {
           try{
           			$select = $this->getDbTable()
	        						->select()
	            					->from('mt.cont_widget_customize',array('cwc_links_colors','cwc_alerts_colors','cwc_title_colors','cwc_bg_color','cwc_bg_image_url'))
	              					->where('cwc_restid = ?',$restid); 
	            	$exec = $select->query();
					$result = $exec->fetchAll();
					if($result){
						return $result[0];
					}
           }catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
			}
    }
}