<?php
class FirmManagement_Model_FeedbackAnswersMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('FirmManagement_Model_DbTable_FeedbackAnswers');
		}
		return $this->_dbTable;
	}
	
	public function insertAnwsersByQuestionId($questionid,$anwserArry)
	{
		try{
			$storage = new Zend_Auth_Storage_Session();
			$userdata = $storage->read();
			$ans1 = array('fba_questionid'	=> $questionid,
						  'fba_answer'		=> $anwserArry[1],
						  'fba_status'		=> true,
						  'fba_createdby'		=> $userdata['User_Id'],
					  	  'fba_createddatetime'=> date('Y-m-d H:i:s')
						);
			$this->getDbTable()->insert($ans1);
			$ans2 = array('fba_questionid'	=> $questionid,
						  'fba_answer'		=> $anwserArry[2],
						  'fba_status'		=> true,
						  'fba_createdby'	=> $userdata['User_Id'],
					  	  'fba_createddatetime'=> date('Y-m-d H:i:s')
						);
			$this->getDbTable()->insert($ans2);
			$ans3 = array('fba_questionid'	=> $questionid,
						  'fba_answer'		=> $anwserArry[3],
						  'fba_status'		=> true,
						  'fba_createdby'	=> $userdata['User_Id'],
					  	  'fba_createddatetime'=> date('Y-m-d H:i:s')
						);
			$this->getDbTable()->insert($ans3);
			$ans4 = array('fba_questionid'	=> $questionid,
						  'fba_answer'		=> $anwserArry[4],
						  'fba_status'		=> true,
						  'fba_createdby'		=> $userdata['User_Id'],
					  	  'fba_createddatetime'=> date('Y-m-d H:i:s')
						);
			$this->getDbTable()->insert($ans4);
			$ans5 = array('fba_questionid'	=> $questionid,
						  'fba_answer'		=> $anwserArry[5],
						  'fba_status'		=> true,
						  'fba_createdby'		=> $userdata['User_Id'],
					  	  'fba_createddatetime'=> date('Y-m-d H:i:s')
						);
			$this->getDbTable()->insert($ans5);
//			$ans6 = array('fba_questionid'	=> $questionid,
//						  'fba_answer'		=> $anwserArry[6],
//						  'fba_status'		=> true,
//						  'fba_createdby'		=> $userdata['User_Id'],
//					  	  'fba_createddatetime'=> date('Y-m-d H:i:s')
//						);
//			$this->getDbTable()->insert($ans6);
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
public function GetFeedbackQuestAnsByQuestId($questid)
	{
		try
		{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('fba_id','fba_questionid','fba_answer','fba_status','fba_createdby','fba_createddatetime','fba_updatedby','fba_updateddatetime'))
				   ->where('fba_questionid IN(?)',$questid);
			$rowSet = $table->fetchAll($select);
			$answers = array();
			foreach($rowSet as $row){
				$answers[] = array('fba_id'			   => $row->fba_id,
								 'fba_questionid'	   => $row->fba_questionid,
								 'fba_answer'		   => $row->fba_answer,
								 'fba_status'		   => $row->fba_status,
								 'fba_createdby'	   => $row->fba_createdby,
								 'fba_createddatetime' => $row->fba_createddatetime,
								 'fba_updatedby'       => $row->fba_updatedby,
								 'fba_updateddatetime' => $row->fba_updateddatetime);
			}
			return $answers;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}
