<?php
class FirmManagement_Model_FeedbackCommunicationMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('FirmManagement_Model_DbTable_FeedbackCommunication');
		}
		return $this->_dbTable;
	}
	
	public function saveFeedbackReviewReply($reviewData)
	{
		try{
			$usertypeMapper = new Application_Model_UsertypeDataMapper();
			$userData = $usertypeMapper->GetUserTypeByCode(array($reviewData['replyBy']));
			$select = $this->getDbTable()->select();
			$data = array(
					'fbco_fk_feedback'			=>	$reviewData['replyCommId'],
					'fbco_feedback_desc'		=>	$reviewData['replyText'],
					'fbco_feedback_created'		=>	$reviewData['replyCreated'],
					'fbco_feedback_created_by'	=>	$userData[$reviewData['replyBy']]->getId()
// 					'fbco_feedback_created_by'	=>	$reviewData['replyBy']
			);
			if($reviewData['replyById']){
				$data['fbco_created_user'] = $reviewData['replyById'];
			}
			$result = $this->getDbTable()->insert($data);
			if($result){
				$commServ = new Application_Service_Communication();
				$communication = $commServ->FeedbackReviewsCommunication($data);
			}
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}