<?php
class FirmManagement_Model_FirmConstContactSettingMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('FirmManagement_Model_DbTable_FirmConstContactSetting');
		}
		return $this->_dbTable;
	}
	
	public function SaveConstContactSettings(FirmManagement_Model_FirmConstContactSetting $Settings)
	{
		try{
			
			$table = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('rccsid','rccsfk_restaurant','rccs_username','rccs_apikey','rccs_consumersecret','rccs_status'))
					->where('rccsfk_restaurant = ?',$Settings->getrccsfk_restaurant());
			$resultSet = $table->fetchRow($select);
			$id = '';
			$result = array();
			if($resultSet){
				$set = array(
							  'rccs_username' 		=> $Settings->getrccs_username(),
							  'rccs_apikey'	  		=> $Settings->getrccs_apikey(),
							  'rccs_consumersecret' => $Settings->getrccs_consumersecret(),
							  'rccs_status'			=> $Settings->getrccs_status(),
							  'rccs_updatedby'		=> $Settings->getrccs_updatedby(),
							  'rccs_updateddate'	=> $Settings->getrccs_updateddate()
				);
				$where = array('rccsfk_restaurant = ?'=>$Settings->getrccsfk_restaurant(),'rccsid = ?'=>$resultSet->rccsid);
				$id = $table->update($set,$where);
				$result = array('action'=>'update','result'=>$id);
			}else{
				$data = array('rccsfk_restaurant'   => $Settings->getrccsfk_restaurant(),
							  'rccs_username' 		=> $Settings->getrccs_username(),
							  'rccs_apikey'	  		=> $Settings->getrccs_apikey(),
							  'rccs_consumersecret' => $Settings->getrccs_consumersecret(),
							  'rccs_status'			=> $Settings->getrccs_status(),
							  'rccs_createdby'		=> $Settings->getrccs_createdby(),
							  'rccs_createddate'	=> $Settings->getrccs_createddate()
				);

				$id = $table->insert($data);
				$result = array('action'=>'add','result'=>$id);
			}
			return $result;
			
		}catch(Exception $ex){
    		throw new Exception($ex->getMessage()) ;
    	}
	}
	
	public function RetrieveConstContactSettingsByRestId(FirmManagement_Model_FirmConstContactSetting $Settings)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();

			$select->from($table,array('rccsid','rccsfk_restaurant','rccs_username','rccs_apikey','rccs_consumersecret','rccs_createddate'))
				   ->where('rccsfk_restaurant = ?',$Settings->getrccsfk_restaurant())
				   ->where('rccs_status = ?',$Settings->getrccs_status());
				   
		    $row = $table->fetchRow($select);
		    
		    return $row;
			
		}catch(Exception $ex){
    		throw new Exception($ex->getMessage()) ;
    	}
	}
}