<?php
class FirmManagement_Model_FirmConstContactSyncReportMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}


	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('FirmManagement_Model_DbTable_FirmConstContactSyncReport');
		}
		return $this->_dbTable;
	}
	
	public function SaveContactSyncInfo(FirmManagement_Model_FirmConstContactSyncReport $ContactSyncReport)
	{
		try{
			$table = $this->getDbTable();
			$data = array('rccsrfk_restaurant' 		  => $ContactSyncReport->getrccsrfk_restaurant(),
						  'rccsr_contacts_sync_date'  => $ContactSyncReport->getrccsr_contacts_sync_date(),
						  'rccsr_no_of_contacts_sync' => $ContactSyncReport->getrccsr_no_of_contacts_sync(),
						  'rccsr_createddate'		  => $ContactSyncReport->getrccsr_createddate(),
						  'rccsr_createdby'			  => $ContactSyncReport->getrccsr_createdby());
			$id = $table->insert($data);
			return $id;
			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function RetrieveContactSyncInfoByRestId(FirmManagement_Model_FirmConstContactSyncReport $ContactSyncReport)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('rccsrid','rccsrfk_restaurant','rccsr_contacts_sync_date','rccsr_no_of_contacts_sync','rccsr_createddate','rccsr_createdby'))
				   ->where('rccsrfk_restaurant = ?',$ContactSyncReport->getrccsrfk_restaurant());
		    $rowset = $table->fetchAll($select);
		    return $rowset;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
}