<?php

class FirmManagement_Model_FirmDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}


	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('FirmManagement_Model_DbTable_Firm');
		}
		return $this->_dbTable;
	}


	public function addRestaurant(FirmManagement_Model_Firm $restaurant)
	{
		$status = false;
		$db = Zend_Db_Table::getDefaultAdapter();
		$data = array(
					'resfk_user' 		 	 => $restaurant->getRestaurantaownerid(),
					'resrestaurant_name' 	 => $restaurant->getRestaurantname(),
					'restcapacity'			 => $restaurant->getRestCapacity(),
					'resimage'			 	 => $restaurant->getRestimage(),
					'resemail'			 	 => $restaurant->getRestemail(),
		//'resyear_founded'	 	 => $restaurant->getRestyrfound(),
					'resaddress'			 => $restaurant->getRestaddress(),
//					'rescity_id'			 => $restaurant->getRestCity(),
//		            'resregion_id'			 => $restaurant->getRestRegion(),
//					'resstate_id'			 => $restaurant->getReststateid(),
//					'resneighborhood_id'	 => $restaurant->getRestneighboorhood(),
					'reszipcode'			 => $restaurant->getRestzipcode(),
					'resphone'				 => str_replace("-","",$restaurant->getRestphone()),
					'resfax'				 => $restaurant->getRestfax(),
					'reswebsite'		 	 => $restaurant->getRestwebsite(),
					'resmanager_name'		 => $restaurant->getRestmanagername(),
					'resdescription'		 => $restaurant->getRestdesc(),
					'resimage'				 => $restaurant->getRestimage(),
					'reslogo'				 => $restaurant->getRestlogo(),
					'resstatus'			     => $restaurant->getReststatus(),
					'resapprovalstatus'		 => $restaurant->getRestverifiedstatus(),
					'resdiningstyle'		 => $restaurant->getRestDiningStyle(),
					'resadditionaldetails'   => $restaurant->getRestAdditDet(),
					'resparking'			 => $restaurant->getRestParking(),
					'resparkingdetails'      => $restaurant->getRestParkDetails(),
					'resprivateparty'        => $restaurant->getRestPrivParty(),
					'resprivatepartycontact' => $restaurant->getRestPrivPartyContact(),
					'resentertainment'  	 => $restaurant->getRestEntertainment(),
					'resreservation_system'  => $restaurant->getRestsubforreservation(),
					'restcreatedon'			 => $restaurant->getRestCreatedOn(),
					'restimezone'			 => $restaurant->getResttimezone(),
					'resprice'				 => $restaurant->getRestPrice(),
					'reslatitude'			 => $restaurant->getRestLatitude(),
					'reslongitude'			 => $restaurant->getRestLongitude(),
					'resgooglemapstatus'	 => $restaurant->getRestGoogleMapStatus(),
					'resgoogleimage'		 => $restaurant->getRestGoogleImage(),
					'resmaxpax'				 =>	$restaurant->getMaxpax(),
					'resrestaurant_timings'	 => $restaurant->getRestTimings(),
					'rescategory_id'		 => $restaurant->getRestCategory(),
					'reslisted_restaurant_id'=> $restaurant->getRestListedResId(),
					'reslandmark'			 =>	$restaurant->getreslandmark(),
					'resavg_mealprice_max'	 =>	$restaurant->getresavg_mealprice_max(),
					'resavg_mealprice_min'	 =>	$restaurant->getresavg_mealprice_min(),
					'rescreatedby'			 => $restaurant->getRestCreatedBy(),
					'res_delevery'			 =>	$restaurant->getres_delevery(),
					'reslunch_buffet'		 =>	$restaurant->getreslunch_buffet(),
					'resdinner_buffet'		 =>	$restaurant->getresdinner_buffet(),
					'res_wifi'				 =>	$restaurant->getres_wifi(),
					'res_alcohol'			 =>	$restaurant->getres_alcohol(),
					'res_companyid'			 => $restaurant->getcompanyid(),
					'res_smoking'			 =>	$restaurant->getres_smoking(),
					'res_ac'				 =>	$restaurant->getres_ac(),
					'res_catering'			 =>	$restaurant->getres_catering(),
					'res_kids_section'		 =>	$restaurant->getres_kids_section(),
					'res_party_allowed'		 => $restaurant->getres_party_allowed(),
					'res_meal_category'		 => $restaurant->getres_meal_category(),
					'res_countrycode'		 => $restaurant->getres_country_code(),
					'resfeedbacksmsnotf' 	 =>	1,
					'resfeedbacknotf'		 => 0		
		);

		try{
			$db->beginTransaction();

			$rest_id = $this->getDbTable()->insert($data);

			$resnewLocationMapper = new FirmManagement_Model_FirmNewLocationMapper();
			$resnewTable = $resnewLocationMapper->getDbTable();
			$resExistData = array();
			
			if($restaurant->getCantFind() == 1)
			{
					$resExistData['resstate_id']		=	$restaurant->getReststateid();
					$resExistData['resregion_id']		=	$restaurant->getRestRegion();
					$resExistData['rescity_id']			=	$restaurant->getRestCity();
					$restWhere = $db->quoteInto('resid = ?',$rest_id);
					$this->getDbTable()->update($resExistData,$restWhere);
					
					$resnewData['rnl_new_neighbour']	=	$restaurant->getCantFindNeighbour();
					$resnewData['rnl_fk_restaurant']	=	$rest_id;
					$resnewData['rnl_location_count']	=	$restaurant->getCantFind();
					$resnewData['rnl_status']			=	'T';
					$rowEff = $resnewTable->insert($resnewData);
					
				
			}else if($restaurant->getCantFind() == 2){
				
					$resExistData['resstate_id']		=	$restaurant->getReststateid();
					$resExistData['resregion_id']		=	$restaurant->getRestRegion();
					$restWhere = $db->quoteInto('resid = ?',$rest_id);
					$this->getDbTable()->update($resExistData,$restWhere);
					
					$resnewData['rnl_new_neighbour']	=	$restaurant->getCantFindNeighbour();
					$resnewData['rnl_new_city']			=	$restaurant->getCantFindCity();
					$resnewData['rnl_fk_restaurant']	=	$rest_id;
					$resnewData['rnl_location_count']	=	$restaurant->getCantFind();
					$resnewData['rnl_status']			=	'T';
					$rowEff = $resnewTable->insert($resnewData);
									
			}else if($restaurant->getCantFind() == 3){
				
					$resExistData['resstate_id']		=	$restaurant->getReststateid();
					$restWhere = $db->quoteInto('resid = ?',$rest_id);
					$this->getDbTable()->update($resExistData,$restWhere);
					
					$resnewData['rnl_new_neighbour']	=	$restaurant->getCantFindNeighbour();
					$resnewData['rnl_new_region']		=	$restaurant->getCantFindRegion();
					$resnewData['rnl_new_city']			=	$restaurant->getCantFindCity();
					$resnewData['rnl_fk_restaurant']	=	$rest_id;
					$resnewData['rnl_location_count']	=	$restaurant->getCantFind();
					$resnewData['rnl_status']			=	'T';
					$rowEff = $resnewTable->insert($resnewData);
									
			}else if($restaurant->getCantFind() == 4){
				
					$resnewData['rnl_new_state']		=	$restaurant->getCantFindState();
					$resnewData['rnl_new_region']		=	$restaurant->getCantFindRegion();
					$resnewData['rnl_new_city']			=	$restaurant->getCantFindCity();
					$resnewData['rnl_new_neighbour']	=	$restaurant->getCantFindNeighbour();
					$resnewData['rnl_fk_restaurant']	=	$rest_id;
					$resnewData['rnl_location_count']	=	$restaurant->getCantFind();
					$resnewData['rnl_status']			=	'T';
					$rowEff = $resnewTable->insert($resnewData);
									
			}else if($restaurant->getCantFind() == 0 || $restaurant->getCantFind() == ''){
					$resExistData['resstate_id']		=	$restaurant->getReststateid();
					$resExistData['rescity_id']			=	$restaurant->getRestCity();
					$resExistData['resregion_id']		=	$restaurant->getRestRegion();
					$resExistData['resneighborhood_id']	=	$restaurant->getRestneighboorhood();
					
					$restWhere = $db->quoteInto('resid = ?',$rest_id);
					$this->getDbTable()->update($resExistData,$restWhere);
			}
			
			$restaurantType = $restaurant->getResttypeid();
			$mapper = new FirmManagement_Model_FirmCuisineDataMapper();
			//foreach($restaurantType as $types){
			$cusisneData = array(
				'rcsfk_restaurant' 		  => $rest_id,
				'rscfk_restauranttype_id' => $restaurantType->getRestaurantTypeId()
			);

			$mapper->getDbTable()->insert($cusisneData);

			$paymentOptions = $restaurant->getRestPaymentMode();
			$paymentMapper = new FirmManagement_Model_FirmPaymentOptionsDataMapper();
			foreach($paymentOptions as $types){
				$payment = array(
						'rpofk_restaurant' 		  => $rest_id,
						'rpofk_restaurant_payment_type_id' => $types->getRestaurantPaymentTypeId()
				);
				$paymentMapper->getDbTable()->insert($payment);
			}
// Faiz //			
			$tagcount = 0;
			$tagOptions = $restaurant->gettag_id();
			$tagOptionsMapper = new FirmManagement_Model_FirmTagOptionsMapper();
			$tagcount = count($tagOptions);
			if($tagcount > 0){
				foreach($tagOptions as $types){
					$tag = array(
							'rtofk_restaurant' 		  => $rest_id,
							'rtofk_restaurant_tags_bd_id' => $types,
							'rtostatus'	=> 1
					);
					$tagOptionsMapper->getDbTable()->insert($tag);
				}
			}
			
			if($restaurant->getres_new_tag() != null){
				$tagMapper = new FirmManagement_Model_FirmTagBdMapper();
				$tagtable = $tagMapper->getDbTable();
				$tagselect = $tagtable->select();			
				$tagselect->from($tagtable,array('code','description'));		
				$tagresult = array();				
				$tagselect->order('id DESC');	
				$tagselect->limit(1);			
				$tagselect->where('status = ?',true);
				$resttag = $tagtable->fetchAll($tagselect);	
				foreach($resttag as $tagg){
					$tagresult = $tagg->code;
				}
	
				if($tagresult != null){
					if(is_numeric($tagresult) && is_int(0+$tagresult)){
						$code = $tagresult + 1;
					}else{
						$code = 1;
					}
					$newtag = array(
								'code' 		  => $code,
								'description' => $restaurant->getres_new_tag(),
								'status'      => "true"
						);
					$tagtable->insert($newtag);
				}
			}
			$diningMapper = new FirmManagement_Model_FirmDiningAreaDataMapper();
			$diningMapper->AddDiningArea($rest_id,'Dining area','DA');

			$db->commit();
			$status = true;
		}catch(Exception $ex){
			$db->rollBack();
			throw new Exception($ex->getMessage()) ;
		}
		$result = array('status'=>$status,'resid'=>$rest_id);
		return $result;
	}

	public function addRoundMenuRestaurant(FirmManagement_Model_Firm $restaurant)
	{
		$status = false;
		$db = Zend_Db_Table::getDefaultAdapter();
		$data = array(
					'resfk_user' 		 	 => $restaurant->getRestaurantaownerid(),
					'resrestaurant_name' 	 => $restaurant->getRestaurantname(),
					'restcapacity'			 => $restaurant->getRestCapacity(),
					'resstatus'			     => $restaurant->getReststatus(),
					'resapprovalstatus'		 => $restaurant->getRestverifiedstatus(),
					'resdiningstyle'		 => $restaurant->getRestDiningStyle(),
					'restcreatedon'			 => $restaurant->getRestCreatedOn(),
					'restimezone'			 => $restaurant->getResttimezone(),
					'resprice'				 => $restaurant->getRestPrice(),
					'rescategory_id'		 => $restaurant->getRestCategory(),
					'rescreatedby'			 => $restaurant->getRestCreatedBy(),
					'res_companyid'			 => $restaurant->getcompanyid(),
					'resmaxpax'				 =>	$restaurant->getMaxpax(),
					'res_countrycode'		 => $restaurant->getres_country_code(),
					
		);

		try{
			$db->beginTransaction();

			$rest_id = $this->getDbTable()->insert($data);

			$resnewLocationMapper = new FirmManagement_Model_FirmNewLocationMapper();
			$resnewTable = $resnewLocationMapper->getDbTable();
			$resExistData = array();
			
			if($restaurant->getCantFind() == 1)
			{
					$resExistData['resstate_id']		=	$restaurant->getReststateid();
					$resExistData['resregion_id']		=	$restaurant->getRestRegion();
					$resExistData['rescity_id']			=	$restaurant->getRestCity();
					$restWhere = $db->quoteInto('resid = ?',$rest_id);
					$this->getDbTable()->update($resExistData,$restWhere);
					
					$resnewData['rnl_new_neighbour']	=	$restaurant->getCantFindNeighbour();
					$resnewData['rnl_fk_restaurant']	=	$rest_id;
					$resnewData['rnl_location_count']	=	$restaurant->getCantFind();
					$resnewData['rnl_status']			=	'T';
					$rowEff = $resnewTable->insert($resnewData);
					
				
			}else if($restaurant->getCantFind() == 2){
				
					$resExistData['resstate_id']		=	$restaurant->getReststateid();
					$resExistData['resregion_id']		=	$restaurant->getRestRegion();
					$restWhere = $db->quoteInto('resid = ?',$rest_id);
					$this->getDbTable()->update($resExistData,$restWhere);
					
					$resnewData['rnl_new_neighbour']	=	$restaurant->getCantFindNeighbour();
					$resnewData['rnl_new_city']			=	$restaurant->getCantFindCity();
					$resnewData['rnl_fk_restaurant']	=	$rest_id;
					$resnewData['rnl_location_count']	=	$restaurant->getCantFind();
					$resnewData['rnl_status']			=	'T';
					$rowEff = $resnewTable->insert($resnewData);
									
			}else if($restaurant->getCantFind() == 3){
				
					$resExistData['resstate_id']		=	$restaurant->getReststateid();
					$restWhere = $db->quoteInto('resid = ?',$rest_id);
					$this->getDbTable()->update($resExistData,$restWhere);
					
					$resnewData['rnl_new_neighbour']	=	$restaurant->getCantFindNeighbour();
					$resnewData['rnl_new_region']		=	$restaurant->getCantFindRegion();
					$resnewData['rnl_new_city']			=	$restaurant->getCantFindCity();
					$resnewData['rnl_fk_restaurant']	=	$rest_id;
					$resnewData['rnl_location_count']	=	$restaurant->getCantFind();
					$resnewData['rnl_status']			=	'T';
					$rowEff = $resnewTable->insert($resnewData);
									
			}else if($restaurant->getCantFind() == 4){
				
					$resnewData['rnl_new_state']		=	$restaurant->getCantFindState();
					$resnewData['rnl_new_region']		=	$restaurant->getCantFindRegion();
					$resnewData['rnl_new_city']			=	$restaurant->getCantFindCity();
					$resnewData['rnl_new_neighbour']	=	$restaurant->getCantFindNeighbour();
					$resnewData['rnl_fk_restaurant']	=	$rest_id;
					$resnewData['rnl_location_count']	=	$restaurant->getCantFind();
					$resnewData['rnl_status']			=	'T';
					$rowEff = $resnewTable->insert($resnewData);
									
			}else if($restaurant->getCantFind() == 0 || $restaurant->getCantFind() == ''){
					$resExistData['resstate_id']		=	$restaurant->getReststateid();
					$resExistData['rescity_id']			=	$restaurant->getRestCity();
					$resExistData['resregion_id']		=	$restaurant->getRestRegion();
					$resExistData['resneighborhood_id']	=	$restaurant->getRestneighboorhood();
					
					$restWhere = $db->quoteInto('resid = ?',$rest_id);
					$this->getDbTable()->update($resExistData,$restWhere);
			}
			
			$restaurantType = $restaurant->getResttypeid();
			$mapper = new FirmManagement_Model_FirmCuisineDataMapper();
			//foreach($restaurantType as $types){
			$cusisneData = array(
				'rcsfk_restaurant' 		  => $rest_id,
				'rscfk_restauranttype_id' => $restaurantType->getRestaurantTypeId()
			);

			$mapper->getDbTable()->insert($cusisneData);

			$diningMapper = new FirmManagement_Model_FirmDiningAreaDataMapper();
			$diningMapper->AddDiningArea($rest_id,'Dining area','DA');

			$db->commit();
			$status = true;
		}catch(Exception $ex){
			$db->rollBack();
			throw new Exception($ex->getMessage()) ;
		}
		$result = array('status'=>$status,'resid'=>$rest_id);
		return $result;
	}

	public function addListedRestaurant(FirmManagement_Model_Firm $restaurant)
	{
		$status = false;
		$db = Zend_Db_Table::getDefaultAdapter();
		$data = array(
					'resfk_user' 		 	 => $restaurant->getRestaurantaownerid(),
					'resrestaurant_name' 	 => $restaurant->getRestaurantname(),
					'restcapacity'			 => $restaurant->getRestCapacity(),
					'resimage'			 	 => $restaurant->getRestimage(),
					'resemail'			 	 => $restaurant->getRestemail(),		
					'resaddress'			 => $restaurant->getRestaddress(),
					'rescity_id'			 => $restaurant->getRestCity(),
					'resregion_id'			 => $restaurant->getRestRegion(),
					'resstate_id'			 => $restaurant->getReststateid(),
					'resneighborhood_id'	 => $restaurant->getRestneighboorhood(),
					'reszipcode'			 => $restaurant->getRestzipcode(),
					'resphone'				 => $restaurant->getRestphone(),
					'resfax'				 => $restaurant->getRestfax(),
					'reswebsite'		 	 => $restaurant->getRestwebsite(),
					'resmanager_name'		 => $restaurant->getRestmanagername(),
					'resdescription'		 => $restaurant->getRestdesc(),
					'resimage'				 => $restaurant->getRestimage(),
					'reslogo'				 => $restaurant->getRestlogo(),
					'resstatus'			     => $restaurant->getReststatus(),
					'resapprovalstatus'		 => $restaurant->getRestverifiedstatus(),
					'resdiningstyle'		 => $restaurant->getRestDiningStyle(),
					'resadditionaldetails'   => $restaurant->getRestAdditDet(),
					'resparking'			 => $restaurant->getRestParking(),
					'resparkingdetails'      => $restaurant->getRestParkDetails(),
					'resprivateparty'        => $restaurant->getRestPrivParty(),
					'resprivatepartycontact' => $restaurant->getRestPrivPartyContact(),
					'resentertainment'  	 => $restaurant->getRestEntertainment(),
					'resreservation_system'  => $restaurant->getRestsubforreservation(),
					'restcreatedon'			 => $restaurant->getRestCreatedOn(),
					'restimezone'			 => $restaurant->getResttimezone(),
					'resprice'				 => $restaurant->getRestPrice(),
					'reslatitude'			 => $restaurant->getRestLatitude(),
					'reslongitude'			 => $restaurant->getRestLongitude(),
					'resgooglemapstatus'	 => $restaurant->getRestGoogleMapStatus(),
					'resgoogleimage'		 => $restaurant->getRestGoogleImage(),
					'resmaxpax'				 =>	$restaurant->getMaxpax(),
					'resrestaurant_timings'	 => $restaurant->getRestTimings(),
					'rescategory_id'		 => $restaurant->getRestCategory(),
					'reslisted_restaurant_id'=> $restaurant->getRestListedResId(),
					'reslandmark'			 =>	$restaurant->getreslandmark(),
					'resavg_mealprice_max'	 =>	$restaurant->getresavg_mealprice_max(),
					'resavg_mealprice_min'	 =>	$restaurant->getresavg_mealprice_min(),
					'rescreatedby'			 => $restaurant->getRestCreatedBy(),
					'res_delevery'			 =>	$restaurant->getres_delevery(),
					'reslunch_buffet'		 =>	$restaurant->getreslunch_buffet(),
					'resdinner_buffet'		 =>	$restaurant->getresdinner_buffet(),
					'res_wifi'				 =>	$restaurant->getres_wifi(),
					'res_alcohol'			 =>	$restaurant->getres_alcohol(),
					'res_companyid'			 => $restaurant->getcompanyid(),
					'res_smoking'			 =>	$restaurant->getres_smoking(),
					'res_ac'				 =>	$restaurant->getres_ac(),
					'res_catering'			 =>	$restaurant->getres_catering(),
					'res_kids_section'		 =>	$restaurant->getres_kids_section(),
					'res_party_allowed'		 => $restaurant->getres_party_allowed(),
					'res_meal_category'		 => $restaurant->getres_meal_category(),
					'res_countrycode'		 => $restaurant->getres_country_code(),
					'resfeedbacksmsnotf' 	 =>	true,
					'resfeedbacknotf'		 => false 		
		);

		try{

			$db->beginTransaction();
			/* Check the rest is already exist in system */
			$restTable = $this->getDbTable();
			$selectRest = $this->getDbTable()->select();
			$selectRest->from($restTable,array('COUNT(resid) as restcount'))
			->where('resrestaurant_name ILIKE ?','%'.trim($restaurant->getRestaurantname()).'%')
			->where('resneighborhood_id = ?',$restaurant->getRestneighboorhood());

			$rowSet = $restTable->fetchAll($selectRest);
			$count = 0;
			foreach($rowSet as $row){
				$count = $row->restcount;
			}


			if($count == 0){

				$rest_id = $this->getDbTable()->insert($data);

			$resnewLocationMapper = new FirmManagement_Model_FirmNewLocationMapper();
			$resnewTable = $resnewLocationMapper->getDbTable();
			$resExistData = array();
			
			if($restaurant->getCantFind() == 1)
			{
					$resExistData['resstate_id']		=	$restaurant->getReststateid();
					$resExistData['resregion_id']		=	$restaurant->getRestRegion();
					$resExistData['rescity_id']			=	$restaurant->getRestCity();
					$restWhere = $db->quoteInto('resid = ?',$rest_id);
					$this->getDbTable()->update($resExistData,$restWhere);
					
					$resnewData['rnl_new_neighbour']	=	$restaurant->getCantFindNeighbour();
					$resnewData['rnl_fk_restaurant']	=	$rest_id;
					$resnewData['rnl_location_count']	=	$restaurant->getCantFind();
					$resnewData['rnl_status']			=	'T';
					$rowEff = $resnewTable->insert($resnewData);
					
				
			}else if($restaurant->getCantFind() == 2){
				
					$resExistData['resstate_id']		=	$restaurant->getReststateid();
					$resExistData['resregion_id']		=	$restaurant->getRestRegion();
					$restWhere = $db->quoteInto('resid = ?',$rest_id);
					$this->getDbTable()->update($resExistData,$restWhere);
					
					$resnewData['rnl_new_neighbour']	=	$restaurant->getCantFindNeighbour();
					$resnewData['rnl_new_city']			=	$restaurant->getCantFindCity();
					$resnewData['rnl_fk_restaurant']	=	$rest_id;
					$resnewData['rnl_location_count']	=	$restaurant->getCantFind();
					$resnewData['rnl_status']			=	'T';
					$rowEff = $resnewTable->insert($resnewData);
									
			}else if($restaurant->getCantFind() == 3){
				
					$resExistData['resstate_id']		=	$restaurant->getReststateid();
					$restWhere = $db->quoteInto('resid = ?',$rest_id);
					$this->getDbTable()->update($resExistData,$restWhere);
					
					$resnewData['rnl_new_neighbour']	=	$restaurant->getCantFindNeighbour();
					$resnewData['rnl_new_region']		=	$restaurant->getCantFindRegion();
					$resnewData['rnl_new_city']			=	$restaurant->getCantFindCity();
					$resnewData['rnl_fk_restaurant']	=	$rest_id;
					$resnewData['rnl_location_count']	=	$restaurant->getCantFind();
					$resnewData['rnl_status']			=	'T';
					$rowEff = $resnewTable->insert($resnewData);
									
			}else if($restaurant->getCantFind() == 4){
				
					$resnewData['rnl_new_state']		=	$restaurant->getCantFindState();
					$resnewData['rnl_new_region']		=	$restaurant->getCantFindRegion();
					$resnewData['rnl_new_city']			=	$restaurant->getCantFindCity();
					$resnewData['rnl_new_neighbour']	=	$restaurant->getCantFindNeighbour();
					$resnewData['rnl_fk_restaurant']	=	$rest_id;
					$resnewData['rnl_location_count']	=	$restaurant->getCantFind();
					$resnewData['rnl_status']			=	'T';
					$rowEff = $resnewTable->insert($resnewData);
									
			}else if($restaurant->getCantFind() == 0 || $restaurant->getCantFind() == ''){
					$resExistData['resstate_id']		=	$restaurant->getReststateid();
					$resExistData['rescity_id']			=	$restaurant->getRestCity();
					$resExistData['resregion_id']		=	$restaurant->getRestRegion();
					$resExistData['resneighborhood_id']	=	$restaurant->getRestneighboorhood();
					
					$restWhere = $db->quoteInto('resid = ?',$rest_id);
					$this->getDbTable()->update($resExistData,$restWhere);
			}
			
				$restaurantType = $restaurant->getResttypeid();
				$mapper = new FirmManagement_Model_FirmCuisineDataMapper();

				$cusisneData = array(
				'rcsfk_restaurant' 		  => $rest_id,
				'rscfk_restauranttype_id' => $restaurantType->getRestaurantTypeId()
				);

				$mapper->getDbTable()->insert($cusisneData);

				$paymentOptions = $restaurant->getRestPaymentMode();
				$paymentMapper = new FirmManagement_Model_FirmPaymentOptionsDataMapper();
				foreach($paymentOptions as $types){
					$payment = array(
						'rpofk_restaurant' 		  => $rest_id,
						'rpofk_restaurant_payment_type_id' => $types->getRestaurantPaymentTypeId()
					);
					$paymentMapper->getDbTable()->insert($payment);
				}

			$tagcount = 0;
			$tagOptions = $restaurant->gettag_id();
			$tagOptionsMapper = new FirmManagement_Model_FirmTagOptionsMapper();
			$tagcount = count($tagOptions);
			if($tagcount > 0){
				foreach($tagOptions as $types){
					$tag = array(
							'rtofk_restaurant' 		  => $rest_id,
							'rtofk_restaurant_tags_bd_id' => $types,
							'rtostatus'	=> 1
					);
					$tagOptionsMapper->getDbTable()->insert($tag);
				}
			}
			
			if($restaurant->getres_new_tag() != null){
				$tagMapper = new FirmManagement_Model_FirmTagBdMapper();
				$tagtable = $tagMapper->getDbTable();
				$tagselect = $tagtable->select();			
				$tagselect->from($tagtable,array('code','description'));		
				$tagresult = array();				
				$tagselect->order('id DESC');	
				$tagselect->limit(1);			
				$tagselect->where('status = ?',true);
				$resttag = $tagtable->fetchAll($tagselect);	
				foreach($resttag as $tagg){
					$tagresult = $tagg->code;
				}
	
				if($tagresult != null){
					if(is_numeric($tagresult) && is_int(0+$tagresult)){
						$code = $tagresult + 1;
					}else{
						$code = 1;
					}
					$newtag = array(
								'code' 		  => $code,
								'description' => $restaurant->getres_new_tag(),
								'status'      => "true"
						);
					$tagtable->insert($newtag);
				}
			}
				$db->commit();

				$status = true;
			}else{
				$status = false;
			}
		}catch(Exception $ex){
			$db->rollBack();
			throw new Exception($ex->getMessage()) ;
		}
		return $status;
	}


	public function getRestaurantByOwnerId(FirmManagement_Model_FirmByOwnerId $byownerid,$offset)
	{
		try{
			$ownerId = $byownerid->getResOwnerId();
			$limit = 10;
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);

			$socialMediaMapper = new SocialMedia_Model_SocialMediaDataMapper();
			$socialMediaTable  = $socialMediaMapper->getDbTable();
			$socialMediaSelect = $socialMediaTable->select(); 
			$socialMediaSelect->from($socialMediaTable,array('rsm_pageid','rsm_restid'))
							->where('rsm_status = ?',true);
			
			$select->from(array('rest'=>'mt.restaurant'),array('resid','resaddress','resrestaurant_name','resimage','restcapacity','resreservation_system','resstatus','resschestatus','resfloorplanstatus','resnotification','respaymentstatus','resphonenotify','reszipcode','resphone','resemail','res_countrycode'))
				   ->join(array('reststs'=>'mt.restaurant_status_bd'),'reststs.id = rest.resstatus',array('code','description'))
				   ->joinLeft(array('cty'=>'mt.city_bd'),'rest.rescity_id = cty.id',array('code as citycode','description as city'))
				   ->joinLeft(array('ngbh'=>'mt.neighborhood_bd'),'rest.resneighborhood_id = ngbh.id',array('description as neighbor'))
				   ->join(array('app'=>'mt.restaurant_approval_status_bd'),'app.id = rest.resapprovalstatus',array('code as approvalcode','description as approvalstatus'))
				   ->joinLeft(array('rsm'=>$socialMediaSelect),'rsm.rsm_restid = rest.resid',array('rsm_pageid'))
				   ->where('rest.resfk_user = ?',$ownerId)
				   ->where('rest.resstatus != ?',3)
				   ->order(array('resrestaurant_name'));

			
			$resultSet = new Zend_Paginator(
			new Zend_Paginator_Adapter_DbTableSelect($select)
			);
			$resultSet->setItemCountPerPage($limit);
			$resultSet->setCurrentPageNumber($offset);

			return $resultSet;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getRestaurantDetailsByOwnerResId($resid,$userid,$offset)
	{
		try{
			$limit = 8;
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);

			$select->from(array('rest'=>'mt.restaurant'),array('resid','resrestaurant_name','restcapacity','resreservation_system','resstatus','resschestatus','resfloorplanstatus','resphonenotify','resnotification','respaymentstatus','resphonenotify'))
				   ->join(array('reststs'=>'mt.restaurant_status_bd'),'reststs.id = rest.resstatus',array('code','description'))
				   ->join(array('cty'=>'mt.city_bd'),'rest.rescity_id = cty.id',array('code as citycode','description as city'))
				   ->join(array('ngbh'=>'mt.neighborhood_bd'),'rest.resneighborhood_id = ngbh.id',array('description as neighbor'))
				   ->join(array('app'=>'mt.restaurant_approval_status_bd'),'app.id = rest.resapprovalstatus',array('code as approvalcode','description as approvalstatus'));
			
			$select->where("rest.resid = $resid OR rest.resfk_user = $userid");
			

			$resultSet = new Zend_Paginator(
			new Zend_Paginator_Adapter_DbTableSelect($select)
			);
			$resultSet->setItemCountPerPage($limit);
			$resultSet->setCurrentPageNumber($offset);
			return $resultSet;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getOwnerByRestId(FirmManagement_Model_OwnerByRestaurantId $byrestaurantid)
	{
		try{
			$restid = $byrestaurantid->getRestaurantId();
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);

			$select->from(array('rest'=>'mt.restaurant'),array('resfk_user','resid','resrestaurant_name'))
			->join(array('restowner'=>'mt.restaurant_owner'),'restowner.rsofk_user = rest.resfk_user',array('rsofirst_name','rsolast_name','rsophone'))
			->join(array('ownername'=>'mt.user'),'ownername.usrid = rest.resfk_user',array('usremail'))
			->where('rest.resid = ?',$restid);

			$resultSet = $table->fetchAll($select);

			$ownerList = '';
			foreach($resultSet as $result){
				$ownerObj = new FirmManagement_Model_Owner();

				$ownerObj->setRestUser($result->resfk_user)
				->setRestId($result->resid)
				->setOwnerFirstName($result->rsofirst_name)
				->setOwnerLastName($result->rsolast_name)
				->setOwnerEmail($result->usremail)
				->setRestaurantName($result->resrestaurant_name)
				->setOwnerPhone($result->rsophone);

				$ownerList = $ownerObj;
			}

			return $ownerList;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getRestaurantById(FirmManagement_Model_FirmById $restaurantbyid)
	{
		try{
			$resttable = $this->getDbTable();

			$cuisinemapper = new FirmManagement_Model_FirmCuisineDataMapper();

			$restcuisinetable = $cuisinemapper->getDbTable();
			$paymentmapper = new FirmManagement_Model_FirmPaymentOptionsDataMapper();
			$selectResttable = $paymentmapper->getDbTable();
			$selectRestPayment = $selectResttable->select();
			$selectRest = $resttable->select();

			$selectRestCuisine = $restcuisinetable->select();
			$selectRest->setIntegrityCheck(false);


			/* Reteriving Restaurant Details */
			$selectRest->from(array('rest'=>'mt.restaurant'),
			array('resid',
									   'resfk_user',
									   'resrestaurant_name',
								 	   'restcapacity',
									   'reslogo',
									   'resimage',
									   'resemail',
									   'res_no_of_floors',
									   'resaddress',
									   'rescity_id',
									   'resstate_id',
                     'resregion_id',
									   'resneighborhood_id',
									   'reszipcode',
									   'resphone',
									   'resfax',
									   'restimezone',
									   'resprice',	
									   'reswebsite',
									   'resmanager_name',
									   'resdescription',
									   'resdiningstyle',
									   'resadditionaldetails',
									   'resparking',
									   'resparkingdetails',
									   'resprivateparty',
									   'resprivatepartycontact',
									   'resentertainment',
									   'resreservation_system',
									   'resgoogleimage',
									   'reslatitude',
									   'reslongitude',
									   'resmaxpax',
									   'resrestaurant_timings',
										'resapprovalstatus',
										'rescategory_id',
										'reslisted_restaurant_id',
										'resexecutivechef',
										'resdresscode',
										'resacceptwalkin',
										'respublictransit',
										'resspleventsandpromotions',
										'rescrossstreet',
									        'resmenu',
										'resorigin_id',
										'resreserv',
										'rescampaign_status',
										'resbookingoption_setting',
										'resavg_mealprice_min',
										'resavg_mealprice_max',																
										'reslunch_buffet',
										'resdinner_buffet',
										'reslandmark',	
										'res_delevery',
										'res_wifi',
										'res_alcohol',
										'res_smoking',	
										'res_ac',
										'res_party_allowed',
										'res_catering',
										'res_kids_section',																												'resdiningstyle',
										'reslatitude',
										'reslongitude',
										'resreserv',
										'res_meal_category',
										'res_countrycode',
										'res_companyid',
                                                                                'resauto_confirm'
										))
										->joinLeft(array('neigh'=>'mt.neighborhood_bd'),'neigh.id = rest.resneighborhood_id',array('description as neighbor'))
										->joinLeft(array('city'=>'mt.city_bd'),'city.id = rest.rescity_id',array('description as city'))
										->joinLeft(array('region'=>'mt.region_bd'),'region.id = rest.resregion_id',array('description as region'))
										->joinLeft(array('state'=>'mt.state_bd'),'state.id = rest.resstate_id',array('description as state'))
										->join(array('restatus'=>'mt.restaurant_status_bd'),'restatus.id = rest.resstatus',array('code as rescode'))
										->join(array('apptatus'=>'mt.restaurant_approval_status_bd'),'apptatus.id = rest.resapprovalstatus',array('code as appcode'))
										//->join(array('orbd'=>'mt.restaurant_origin_bd'),'orbd.id = rest.resorigin_id',array('description as origin'))
										->where('rest.resid = ?',$restaurantbyid->getRestaurantId());
                    
										$restResult = $resttable->fetchRow($selectRest);
                    //echo '<pre>'; print_r($restResult); exit;
										$restObj    = new FirmManagement_Model_Firm();
										if($restResult){
											$regionList = array();
											$cityList = array();
											$neighborhoodList = array();
											if($restResult['resstate_id']){
												$regionmapper = new Application_Model_RegionDataMapper();
												$regionObj = new Application_Model_Region();
												$regionObj->setStateId($restResult['resstate_id']);
												$region = $regionmapper->getRegionByStateId($regionObj);
												$regionList = $region->getRegionList();
											}
											if($restResult['resregion_id']){
												$citymapper = new Application_Model_CityDataMapper();
												$cityObj = new Application_Model_City();
												$cityObj->setRegionId($restResult['resregion_id']);
												$city = $citymapper->getCityByRegionId($cityObj);
												$cityList = $city->getCityList();
											}
											if($restResult['rescity_id']){
												$neighborhoodmapper = new Application_Model_NeighborhoodDataMapper();
												$neighborhoodObj = new Application_Model_Neighborhood();
												$neighborhoodObj->setCityId($restResult['rescity_id']);
												$neighborhood = $neighborhoodmapper->getNghByCityId($neighborhoodObj);
												$neighborhoodList = $neighborhood->getNeighborhoodList();
											}



											$restObj->setId($restResult->resid)
											->setRestaurantownerid($restResult->resfk_user)
											->setRestaurantname($restResult->resrestaurant_name)
											->setRestCapacity($restResult->restcapacity)
											->setRestemail($restResult->resemail)
											->setRestlogo($restResult->reslogo)
											->setRestimage($restResult->resimage)
											//->setRestyrfound($restResult->resyear_founded)
											//	->setRestnoofflor($restResult->res_no_of_floors)
											->setRestaddress($restResult->resaddress)
											->setRestCity($restResult->rescity_id)
											->setRestRegion($restResult->resregion_id)
											->setReststateid($restResult->resstate_id)
											->setRestneighboorhood($restResult->resneighborhood_id)
											->setRestzipcode($restResult->reszipcode)
											->setRestphone($restResult->resphone)
											->setRestfax($restResult->resfax)
											->setResttimezone($restResult->restimezone)
											->setRestPrice($restResult->resprice)
											->setRestwebsite($restResult->reswebsite)
											->setRestmanagername($restResult->resmanager_name)
											->setRestdesc($restResult->resdescription)
											->setRestDiningStyle($restResult->resdiningstyle)
											->setRestAdditDet($restResult->resadditionaldetails)
											->setRestParking($restResult->resparking)
											->setRestParkDetails($restResult->resparkingdetails)
											->setRestPrivParty($restResult->resprivateparty)
											->setRestPrivPartyContact($restResult->resprivatepartycontact)
											->setRestEntertainment($restResult->resentertainment)
											->setRestsubforreservation($restResult->resreservation_system)
											->setCityBd($cityList)
											->setRegionBd($regionList)
											->setRestNeighborDesc($restResult->neighbor)
											->setRestCityDesc($restResult->city)
											->setRestRegionDesc($restResult->region)
											->setRestStateDesc($restResult->state)
											->setNeighborhodBd($neighborhoodList)
											->setRestGoogleImage($restResult->resgoogleimage)
											->setRestLatitude($restResult->reslatitude)
											->setRestLongtitude($restResult->reslongitude)
											->setMaxpax($restResult->resmaxpax)
											->setRestTimings($restResult->resrestaurant_timings)
											->setReststatus($restResult->rescode)
											->setRestsubforreservation('TRUE')
											->setRestAppStatusId($restResult->appcode)
											->setRestCategory($restResult->rescategory_id)
											->setRestListedResId($restResult->reslisted_restaurant_id)
											->setresexecutivechef($restResult->resexecutivechef)
											->setresdresscode($restResult->resdresscode)
											->setresacceptwalkin($restResult->resacceptwalkin)
											->setrespublictransit($restResult->respublictransit)
											->setresspleventsandpromotions($restResult->resspleventsandpromotions)
											->setrescrossstreet($restResult->rescrossstreet)
											->setresmenu($restResult->resmenu)
											->setResoriginId($restResult->resorigin_id)
											->setResReserv($restResult->resreserv)
											->setresbookingoption_setting($restResult->resbookingoption_setting)
											->setrescampaignstatus($restResult->rescampaign_status)
											->setresavg_mealprice_min($restResult->resavg_mealprice_min)
											->setresavg_mealprice_max($restResult->resavg_mealprice_max)
											->setreslunch_buffet($restResult->reslunch_buffet)
											->setresdinner_buffet($restResult->resdinner_buffet)
											->setreslandmark($restResult->reslandmark)
											->setres_delevery($restResult->res_delevery)
											->setres_wifi($restResult->res_wifi)
											->setres_alcohol($restResult->res_alcohol)
											->setres_smoking($restResult->res_smoking)
											->setres_ac($restResult->res_ac)
											->setres_party_allowed($restResult->res_party_allowed)
											->setres_catering($restResult->res_catering)
											->setres_kids_section($restResult->res_kids_section)
											->setres_meal_category($restResult->res_meal_category)
											->setresreserv($restResult->resreserv)
											->setcompanyid($restResult->res_companyid)
											->setres_country_code($restResult->res_countrycode)
                                                                                        ->setresauto_confirm($restResult->resauto_confirm);
                                                                                       
											//->setResorigin($restResult->origin);


											/* Reteriving Restaurant Cuisines */
											$selectRestCuisine->setIntegrityCheck(false);
											$selectRestCuisine->from(array('cuis'=>'mt.restaurant_cuisine'),array('rscid','rscfk_restauranttype_id'))
											->join(array('resttyp'=>'mt.restaurant_type_bd'),'resttyp.id = cuis.rscfk_restauranttype_id',array('code','description'))
											->where('cuis.rcsfk_restaurant = ?',$restaurantbyid->getRestaurantId());
											$cuisineResult = $restcuisinetable->fetchAll($selectRestCuisine);

											$restCuisines = array();

											foreach($cuisineResult as $cuisRes){
												$restCuisObj = new FirmManagement_Model_FirmCuisine();
												$restCuisObj->setId($cuisRes->rscid);
												$restCuisObj->setRestaurantTypeId($cuisRes->rscfk_restauranttype_id);
												$restCuisObj->setRestCuisineCode($cuisRes->code);
												$restCuisObj->setRestCuisineDesc($cuisRes->description);
												$restCuisines[] = $restCuisObj;
											}

											$selectRestPayment->setIntegrityCheck(false);
											$selectRestPayment->from(array('pay'=>'mt.restaurant_payment_options'),array('rpoid','rpofk_restaurant_payment_type_id'))
											->join(array('respay'=>'mt.reservation_paymentmode_bd'),'respay.id = pay.rpofk_restaurant_payment_type_id',array('code','description'))
											->where('pay.rpofk_restaurant = ?',(int)$restaurantbyid->getRestaurantId());
											$paymentResult = $selectResttable->fetchAll($selectRestPayment);
											$resPayments = array();
											foreach($paymentResult as $payRes){
												$restPayObj = new FirmManagement_Model_FirmPaymentOptions();
												$restPayObj->setId($payRes->rpoid);
												$restPayObj->setRestaurantPaymentTypeId($payRes->rpofk_restaurant_payment_type_id);
												$restPayObj->setRestPaymentCode($payRes->code);
												$restPayObj->setRestPaymentDesc($payRes->description);
												$resPayments[] = $restPayObj;
											}
											/* Setting restaurant types to Restaurant objects restauranttype id property. */
											$restObj->setResttypeid($restCuisines);
											$restObj->setRestPaymentMode($resPayments);
											//$restObj->setRestPaymentMode($resPayments);
											/* Reteriving Restaurant Schedules */
											/*$resSchmapper  = new FirmManagement_Model_FirmScheduleDataMapper();
											 $resScheList = $resSchmapper->getScheduleRes($restaurantbyid->getRestaurantId());
											 $restObj->setRestSchedule($resScheList);*/

											/* Reteriving Restaurant Menu */

											/*$menuMapper   = new FirmManagement_Model_FirmMenuDataMapper();
											 $menurestbyid = new FirmManagement_Model_GetMenuByRestId();
											 $menurestbyid->setRestaurantId($restaurantbyid->getRestaurantId());
											 $restMenu = $menuMapper->getRestaurantsMenu($menurestbyid);

											 $restObj->setRestMenu($restMenu);*/
											
// Faiz //											
											$tagmapper = new FirmManagement_Model_FirmPaymentOptionsDataMapper();
											$selectResttagg = $tagmapper->getDbTable();
											$selectRestTag = $selectResttagg->select();
											$selectRestTag->setIntegrityCheck(false);
											$selectRestTag->from(array('tag'=>'mt.restaurant_tag_options'),array('rtoid','rtofk_restaurant','rtofk_restaurant_tags_bd_id','rtostatus'))
															  ->join(array('bd'=>'mt.restaurant_tags_bd'),'tag.rtofk_restaurant_tags_bd_id = bd.id',array('code','description'))
															  ->where('tag.rtofk_restaurant = ?',(int)$restaurantbyid->getRestaurantId())
															  ->where('bd.status = ?',"True")
															  ->where('tag.rtostatus = ?',1);
											$tagResult = $selectResttagg->fetchAll($selectRestTag);
											$restags = array();
											if($tagResult){
												foreach($tagResult as $tagRes){	
													$restTagObj = new FirmManagement_Model_FirmTagBd();											
													$restTagObj->setrtofk_restaurant_tags_bd_id($tagRes->rtofk_restaurant_tags_bd_id);
													$restTagObj->setCode($tagRes->code);
													$restTagObj->setDescription($tagRes->description);
													$restags[] = $restTagObj;
												}
											}
											$restObj->settag_id($restags);
										}
										return $restObj;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getRestaurantWithNewLocationById(FirmManagement_Model_FirmById $restaurantbyid)
	{
		try{
			$resttable = $this->getDbTable();

			$cuisinemapper = new FirmManagement_Model_FirmCuisineDataMapper();

			$restcuisinetable = $cuisinemapper->getDbTable();
			$paymentmapper = new FirmManagement_Model_FirmPaymentOptionsDataMapper();
			$selectResttable = $paymentmapper->getDbTable();
			$selectRestPayment = $selectResttable->select();
			$selectRest = $resttable->select();

			$selectRestCuisine = $restcuisinetable->select();
			$selectRest->setIntegrityCheck(false);


			/* Reteriving Restaurant Details */
			$selectRest->from(array('rest'=>'mt.restaurant'),
			array('resid',
									   'resfk_user',
									   'resrestaurant_name',
								 	   'restcapacity',
									   'reslogo',
									   'resimage',
									   'resemail',
									   'res_no_of_floors',
									   'resaddress',
									   'rescity_id',
									   'resstate_id',
			                           'resregion_id',
									   'resneighborhood_id',
									   'reszipcode',
									   'resphone',
									   'resfax',
									   'restimezone',
									   'resprice',	
									   'reswebsite',
									   'resmanager_name',
									   'resdescription',
									   'resdiningstyle',
									   'resadditionaldetails',
									   'resparking',
									   'resparkingdetails',
									   'resprivateparty',
									   'resprivatepartycontact',
									   'resentertainment',
									   'resreservation_system',
									   'resgoogleimage',
									   'reslatitude',
									   'reslongitude',
									   'resmaxpax',
									   'resrestaurant_timings',
										'resapprovalstatus',
										'rescategory_id',
										'reslisted_restaurant_id',
										'resexecutivechef',
										'resdresscode',
										'resacceptwalkin',
										'respublictransit',
										'resspleventsandpromotions',
										'rescrossstreet',
									    'resmenu',
										'resorigin_id',
										'resreserv',
										'rescampaign_status',
										'resbookingoption_setting'
										))
										->joinLeft(array('neigh'=>'mt.neighborhood_bd'),'neigh.id = rest.resneighborhood_id',array('description as neighbor'))
										->joinLeft(array('city'=>'mt.city_bd'),'city.id = rest.rescity_id',array('description as city'))
										->joinLeft(array('loc'=>'mt.restaurant_new_location'),'rest.resid = loc.rnl_fk_restaurant',array('rnl_id','rnl_fk_restaurant','rnl_location_count','rnl_new_state','rnl_new_region','rnl_new_city','rnl_status','rnl_new_neighbour'))
										->joinLeft(array('region'=>'mt.region_bd'),'region.id = rest.resregion_id',array('description as region'))
										->joinLeft(array('state'=>'mt.state_bd'),'state.id = rest.resstate_id',array('description as state'))
										->join(array('restatus'=>'mt.restaurant_status_bd'),'restatus.id = rest.resstatus',array('code as rescode'))
										->join(array('apptatus'=>'mt.restaurant_approval_status_bd'),'apptatus.id = rest.resapprovalstatus',array('code as appcode'))
										//->join(array('orbd'=>'mt.restaurant_origin_bd'),'orbd.id = rest.resorigin_id',array('description as origin'))
										->where('rest.resid = ?',$restaurantbyid->getRestaurantId());



			$restResult = $resttable->fetchRow($selectRest);
			$restObj = array();
			if($restResult){
				$restObj = array(
							   	'restId'					=>		$restResult->resid,
							  	'restName'					=>		$restResult->resrestaurant_name,
							  	'restCapacity'				=>		$restResult->restcapacity,
								'restDiningStyle'			=>		$restResult->resdiningstyle,
							  	'maxpax'					=>		$restResult->resmaxpax,
							  	'resprice'					=>		$restResult->resprice,
							  	'resAddress'				=>		$restResult->resaddress,
							  	'resState'					=>		$restResult->resstate_id,
								'resRegion'					=>		$restResult->resregion_id,
								'resCity'					=>		$restResult->rescity_id,
							  	'postalCode'				=>		$restResult->reszipcode,
							  	'resPhone'					=>		$restResult->resphone,
							  	'resFax'					=>		$restResult->resfax,
							  	'restimezone'				=>		$restResult->restimezone,
						 	 	'emailAddress'				=>		$restResult->resemail,
							  	'resWebsite'				=>		$restResult->reswebsite,
							  	'resManager'				=>		$restResult->resmanager_name,
							  	'resDescription'			=>		$restResult->resdescription,
					  			'resImage'					=>		$restResult->resimage,
							  	'resLogo'					=>		$restResult->reslogo,
							  	'restParking'				=>		$restResult->resparking,
							  	'restParkDetails'			=>		$restResult->resparkingdetails,
							  	'restPrivParty'				=>		$restResult->resprivateparty,
						  		'restPrivPartyContact'		=>		$restResult->resprivatepartycontact,
							  	'restEntertainment'			=>		$restResult->resentertainment,
							  	'restAdditDetails'			=>		$restResult->resadditionaldetails,
						   		'restTimings'				=>		$restResult->resrestaurant_timings,
								'State'						=>		$restResult->state,
								'Region'					=>		$restResult->region,
								'City'						=>		$restResult->city,
								'Neighbour'					=>		$restResult->neighbor,
								'CantFindState'				=>		$restResult->rnl_new_state,
								'CantFindRegion'			=>		$restResult->rnl_new_region,
								'CantFindCity'				=>		$restResult->rnl_new_city,
								'CantFindNeighbour'			=>		$restResult->rnl_new_neighbour,
								'CantFind'					=>		$restResult->rnl_location_count,
				);
			}
			return $restObj;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetRestaurantEmailById($restaurantid)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->from(array('mt.restaurant'),array('resemail','resnotification','resphonenotify','ressmsnotify','resauto_confirm'))
					   ->where('resid = ?',$restaurantid);
					   	
			$restResult = $table->fetchRow($select);
			$result['email'] = $restResult->resemail;
			$result['emailstatus'] = $restResult->resnotification;
			$result['phonestatus'] = $restResult->resphonenotify;
			$result['smsstatus'] = $restResult->ressmsnotify;
			$result['autoconfirm'] = $restResult->resauto_confirm;
			if($result){
				return $result;
			}else{
				return false;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function updateRestaurantPersonalDetails(FirmManagement_Model_Firm $restaurant)
	{

		$status = false;
		$db = Zend_Db_Table::getDefaultAdapter();
		$set = array(
			//'resrestaurant_name' 	 => $restaurant->getRestaurantname(),
			'restcapacity'			 => $restaurant->getRestCapacity(),		
		//'resyear_founded'	 	 => $restaurant->getRestyrfound(),
			'reswebsite'			 => $restaurant->getRestwebsite(),
			//'resmanager_name'		 => $restaurant->getRestmanagername(),
			//'resdescription'		 => $restaurant->getRestdesc(),		
			'resdiningstyle'		 => $restaurant->getRestDiningStyle(),
			'resprice'				 => $restaurant->getRestPrice(),
		//'resreservation_system'  => $restaurant->getRestsubforreservation(),
			'resmaxpax'				 =>	$restaurant->getMaxpax(),
			//'resrestaurant_timings'  => $restaurant->getRestTimings(),
			'resorigin_id'			 => $restaurant->GetResoriginId(),
			'resreserv'				 =>	$restaurant->getResReserv(),
			'resupdateddatetime'	 => $restaurant->getRestUpdatedDate(),
			'resupdatedby'			 =>	$restaurant->getRestUpdatedBy()
		);
		
		if($restaurant->getRestaurantname())
		{
			$set['resrestaurant_name'] = $restaurant->getRestaurantname();
		}

		try{
			$db->beginTransaction();

			/* Update Restaurant */

			$restWhere = $db->quoteInto('resid = ?',$restaurant->getId());

			$this->getDbTable()->update($set,$restWhere);

			$restaurantType = $restaurant->getResttypeid();
			$mapper = new FirmManagement_Model_FirmCuisineDataMapper();

			/* Delete Restaurant types */

			$cuisineWhere = $db->quoteInto('rcsfk_restaurant = ?',$restaurant->getId());
			$rows_affected = $mapper->getDbTable()->delete($cuisineWhere);

			//foreach($restaurantType as $types){
			$cusisneData = array(
					'rcsfk_restaurant' 		  => $restaurant->getId(),
					'rscfk_restauranttype_id' => $restaurantType->getRestaurantTypeId()
			);

			$mapper->getDbTable()->insert($cusisneData);
			//}
//			$restpaymentType = $restaurant->getRestPaymentMode();
//			$paymentmapper = new FirmManagement_Model_FirmPaymentOptionsDataMapper();
//
//			$Where = $db->quoteInto('rpofk_restaurant = ?',$restaurant->getId());
//			$rows_affected = $paymentmapper->getDbTable()->delete($Where);
//
//			foreach($restpaymentType as $types){
//				$paymentData = array(
//					'rpofk_restaurant' 		  			=> $restaurant->getId(),
//					'rpofk_restaurant_payment_type_id' 	=> $types->getRestaurantPaymentTypeId()
//				);
//
//				$paymentmapper->getDbTable()->insert($paymentData);
//			}

			$db->commit();
			$status = true;
			return $status;
		}catch(Exception $ex){
			$db->rollBack();
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function updateRestaurantPersonalMoreDetails(FirmManagement_Model_Firm $restaurant)
	{

		$status = false;
		$db = Zend_Db_Table::getDefaultAdapter();
		$set = array(
			'resdescription'		 => $restaurant->getRestdesc(),		
			'resrestaurant_timings'  => $restaurant->getRestTimings(),
			'resupdateddatetime'	 => $restaurant->getRestUpdatedDate(),
			'resupdatedby'			 =>	$restaurant->getRestUpdatedBy()
		);
		try{
			$db->beginTransaction();

			/* Update Restaurant */

			$restWhere = $db->quoteInto('resid = ?',$restaurant->getId());

			$this->getDbTable()->update($set,$restWhere);

			$restpaymentType = $restaurant->getRestPaymentMode();
			$paymentmapper = new FirmManagement_Model_FirmPaymentOptionsDataMapper();

			$Where = $db->quoteInto('rpofk_restaurant = ?',$restaurant->getId());
			$rows_affected = $paymentmapper->getDbTable()->delete($Where);

			foreach($restpaymentType as $types){
				$paymentData = array(
					'rpofk_restaurant' 		  			=> $restaurant->getId(),
					'rpofk_restaurant_payment_type_id' 	=> $types->getRestaurantPaymentTypeId()
				);

				$paymentmapper->getDbTable()->insert($paymentData);
			}

			$db->commit();
			$status = true;
			return $status;
		}catch(Exception $ex){
			$db->rollBack();
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function updateRestaurantAddressDeatails(FirmManagement_Model_Firm $restaurant)
	{

		$status = false;
		$db = Zend_Db_Table::getDefaultAdapter();
		$set = array(
//		'resemail'			 	 => $restaurant->getRestemail(),
		'rescity_id'			 => $restaurant->getRestCity(),
		'resregion_id'			 => $restaurant->getRestRegion(),
		'resstate_id'			 => $restaurant->getReststateid(),
		'resneighborhood_id'	 => $restaurant->getRestneighboorhood(),
		'reszipcode'			 => $restaurant->getRestzipcode(),
//		'resphone'				 => str_replace("-","",$restaurant->getRestphone()),
//		'resfax'				 => $restaurant->getRestfax(),
		'restimezone'			 => $restaurant->getResttimezone(),
		'resgooglemapstatus'	 => $restaurant->getRestGoogleMapStatus(),
		'resgoogleimage'		 => $restaurant->getRestGoogleImage(),	
		'resaddress'			 => $restaurant->getRestaddress(),
		'resexecutivechef'		 => $restaurant->getresexecutivechef(),
		'resdresscode'			 => $restaurant->getresdresscode(),
		'resacceptwalkin'		 =>	$restaurant->getresacceptwalkin(),
		'reslatitude'			 => $restaurant->getRestLatitude(),
		'reslongitude'			 => $restaurant->getRestLongitude(),
		'resupdateddatetime'	 => $restaurant->getRestUpdatedDate(),
		'resupdatedby'			 =>	$restaurant->getRestUpdatedBy(),
//		'res_countrycode'        => $restaurant->getres_country_code()
		);

		try{
			$db->beginTransaction();

			/* Update Restaurant */

			$restWhere = $db->quoteInto('resid = ?',$restaurant->getId());

			$this->getDbTable()->update($set,$restWhere);

			$db->commit();
			$status = true;
			return $status;
		}catch(Exception $ex){
			$db->rollBack();
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function updateRoundMenuRestaurantAddressDeatails(FirmManagement_Model_Firm $restaurant)
	{

		$status = false;
		$db = Zend_Db_Table::getDefaultAdapter();
		$set = array(
		'rescity_id'			 => $restaurant->getRestCity(),
		'resregion_id'			 => $restaurant->getRestRegion(),
		'resstate_id'			 => $restaurant->getReststateid(),
		'resneighborhood_id'	 => $restaurant->getRestneighboorhood(),
		'restimezone'			 => $restaurant->getResttimezone(),
		'res_countrycode'        => $restaurant->getres_country_code(),
		'resupdateddatetime'	 => $restaurant->getRestUpdatedDate(),
		'resupdatedby'			 =>	$restaurant->getRestUpdatedBy(),
		);

		try{
			$db->beginTransaction();

			/* Update Restaurant */

			$restWhere = $db->quoteInto('resid = ?',$restaurant->getId());

			$this->getDbTable()->update($set,$restWhere);

			$db->commit();
			$status = true;
			return $status;
		}catch(Exception $ex){
			$db->rollBack();
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function updateRestaurantContactDeatails(FirmManagement_Model_Firm $restaurant)
	{

		$status = false;
		$db = Zend_Db_Table::getDefaultAdapter();
		$set = array(
		'resemail'			 	 => $restaurant->getRestemail(),
		'resphone'				 => str_replace("-","",$restaurant->getRestphone()),
		'resfax'				 => $restaurant->getRestfax(),
//		'restimezone'			 => $restaurant->getResttimezone(),
		'resupdateddatetime'	 => $restaurant->getRestUpdatedDate(),
		'resupdatedby'			 =>	$restaurant->getRestUpdatedBy(),
		'res_countrycode'        => $restaurant->getres_country_code(),
		'reswebsite'			 => $restaurant->getRestwebsite(),
		'resmanager_name'		 => $restaurant->getRestmanagername(),
		
		);

		try{
			$db->beginTransaction();

			/* Update Restaurant */

			$restWhere = $db->quoteInto('resid = ?',$restaurant->getId());

			$this->getDbTable()->update($set,$restWhere);

			$db->commit();
			$status = true;
			return $status;
		}catch(Exception $ex){
			$db->rollBack();
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function updateRestaurantParkingDeatails(FirmManagement_Model_Firm $restaurant)
	{
		$status = false;
		$db = Zend_Db_Table::getDefaultAdapter();
		$set = array(
		'resparking'			 => $restaurant->getRestParking(),
		'resparkingdetails'      => $restaurant->getRestParkDetails(),
		'resprivateparty'        => $restaurant->getRestPrivParty(),
		'resprivatepartycontact' => $restaurant->getRestPrivPartyContact(),
		'resentertainment'  	 => $restaurant->getRestEntertainment()	,
		'resadditionaldetails'	 => $restaurant->getRestAdditDet(),
		'respublictransit'		 =>	$restaurant->getrespublictransit(),
		'resspleventsandpromotions'=> $restaurant->getresspleventsandpromotions(),
		'rescrossstreet'		 => $restaurant->getrescrossstreet(),
		'resmenu'				 => $restaurant->getresmenu(),
		'reslandmark'			 	=> $restaurant->getreslandmark(),
		'resavg_mealprice_max'	 	=> $restaurant->getresavg_mealprice_max(),
		'resavg_mealprice_min'	 	=> $restaurant->getresavg_mealprice_min(),
		'res_delevery'	 			=> $restaurant->getres_delevery(),
		'res_meal_category'	 		=> $restaurant->getres_meal_category(),
		'res_smoking'	 			=> $restaurant->getres_smoking(),
		'res_wifi'	 				=> $restaurant->getres_wifi(),
		'reslunch_buffet'	 	    => $restaurant->getreslunch_buffet(),
		'resdinner_buffet'	 	    => $restaurant->getresdinner_buffet(),
		'res_alcohol'   	 	    => $restaurant->getres_alcohol(),
		'res_ac'	 	            => $restaurant->getres_ac(),
		'res_catering'	 	    	=> $restaurant->getres_catering(),
		'res_kids_section'	 	    => $restaurant->getres_kids_section(),
		'resupdateddatetime'	 	=> $restaurant->getRestUpdatedDate(),
		'resupdatedby'			 	=>	$restaurant->getRestUpdatedBy(),
		'resupdateddatetime'	 => $restaurant->getRestUpdatedDate(),
		'resupdatedby'			 =>	$restaurant->getRestUpdatedBy()
		);
// Faiz //		
		$tagset = array(
		'rtostatus' => 2,
		);
		try{
			$db->beginTransaction();

			/* Update Restaurant */

			$restWhere = $db->quoteInto('resid = ?',$restaurant->getId());

			$this->getDbTable()->update($set,$restWhere);
			$count = 0;
			$tagOptions = $restaurant->gettag_id();
			$tagOptionsMapper = new FirmManagement_Model_FirmTagOptionsMapper();
			
			$tagWhere = $db->quoteInto('rtofk_restaurant = ?',$restaurant->getId());
			$tagOptionsMapper->getDbTable()->update($tagset,$tagWhere);
			
			$count = count($tagOptions);
			if($count > 0){					
				foreach($tagOptions as $types){
					$tag = array(
							'rtofk_restaurant' 		  => $restaurant->getId(),
							'rtofk_restaurant_tags_bd_id' => $types,
							'rtostatus'	=> 1
					);
					$tagOptionsMapper->getDbTable()->insert($tag);
				}
			}
			$db->commit();
			$status = true;
			return $status;
		}catch(Exception $ex){
			$db->rollBack();
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function updateRestaurantImage(FirmManagement_Model_Firm $restaurant)
	{
		$status = false;
		$db = Zend_Db_Table::getDefaultAdapter();
		$set = array('resimage' 		  => $restaurant->getRestimage(),
					 'resupdateddatetime' => $restaurant->getRestUpdatedDate(),
					 'resupdatedby'		  =>	$restaurant->getRestUpdatedBy());
		try{
			$db->beginTransaction();

			/* Update Restaurant */

			$restWhere = $db->quoteInto('resid = ?',$restaurant->getId());

			$this->getDbTable()->update($set,$restWhere);
			$db->commit();
			$status = true;
			return $status;
		}catch(Exception $ex){
			$db->rollBack();
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function updateRestaurantLogo(FirmManagement_Model_Firm $restaurant)
	{
		$status = false;
		$db = Zend_Db_Table::getDefaultAdapter();
		$set = array('reslogo' 			  => $restaurant->getRestlogo(),
					 'resupdateddatetime' => $restaurant->getRestUpdatedDate(),
					 'resupdatedby'		  => $restaurant->getRestUpdatedBy());
		try{
			$db->beginTransaction();

			/* Update Restaurant */

			$restWhere = $db->quoteInto('resid = ?',$restaurant->getId());

			$this->getDbTable()->update($set,$restWhere);
			$db->commit();
			$status = true;
			return $status;
		}catch(Exception $ex){
			$db->rollBack();
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function Updateimglogo($restid,$imageRename,$logoRename)
	{
		$status = false;
		$db = Zend_Db_Table::getDefaultAdapter();
		$set = array('resimage'   => $imageRename,
		                  'reslogo' => $logoRename);
		try
		{
	        $db->beginTransaction(); 
		    $restWhere = array('resid = ?'=>$restid);
	        $this->getDbTable()->update($set,$restWhere);
			$db->commit();
			$status = true;
			return $status;
		} catch(Exception $ex){
			$db->rollBack();
			throw new Exception($ex->getMessage()) ;
		}
	}
//	public function UpdateImgLogo($restid,$imagepath,$logopath)
//	{
//		/* Update Restaurant img and logo*/
//		try{
//			$table = $this->getDbTable();
//		     $set = array('resimage'   => $imagepath,
//		                  'reslogo' => $logopath);
//            $restWhere = array('resid = ?'=>$restid);
//			$this->getDbTable()->update($set,$restWhere);
//			$status = true;
//			return $status;
//		}catch(Exception $ex){
//			throw new Exception($ex->getMessage()) ;
//		}
//		
//		              
//	}


	public function updateRestaurantStatus(FirmManagement_Model_UpdateRestaurantStatus $restaurantstatus)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$status = false;
			$restStatus = $this->getRestStatusByCode($restaurantstatus->getRestaurantStatus());
			$set = array('resstatus' => $restStatus->id,
						 'resupdateddatetime' => $restaurantstatus->getRestaurantUpdatedDate(),
						 'resupdatedby' => $restaurantstatus->getRestaurantUpdatedBy()
						);
			$where = $db->quoteInto('resid = ?',$restaurantstatus->getRestaurantId());

			$rows_affected = $this->getDbTable()->update($set,$where);

			if($rows_affected > 0){
				$status = true;
                                $actMapper = new Administrator_Model_RestaurantActivityMapper();
                                $activity = new Administrator_Model_RestaurantActivity();
                                $activity->setrarstatus($restStatus->id)
                                        ->setraractivity_date(date('Y-m'))
                                        ->setrar_fk_restaurant($restaurantstatus->getRestaurantId())
                                        ->setrarupdated_by($restaurantstatus->getRestaurantUpdatedBy())
                                        ->setrarupdated_at($restaurantstatus->getRestaurantUpdatedDate());
                                $actResult = $actMapper->AddRestaurantActivity($activity);
			}
			return $status;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function updateRestAppStatus(FirmManagement_Model_UpdateRestAppStatus $restappstatus)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$status = false;
			$appStatus = $this->getRestAppStatusByCode($restappstatus->getRestAppStatusCode());
			$set = array('resapprovalstatus' => $appStatus->id,
						 'resupdateddatetime' => $restappstatus->getRestAppUpdatedDate(),
						 'resupdatedby' => $restappstatus->getRestAppUpdatedBy()
						);
			$where = $db->quoteInto('resid = ?',$restappstatus->getRestId());
			$rows_affected = $this->getDbTable()->update($set,$where);

			if($rows_affected > 0){
				$status = true;
			}
			return $status;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getRestSummary(FirmManagement_Model_GetRestSummary $restSummary,$offset)
	{
		try{
			$limit = 20;
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);

			$socialMediaMapper = new SocialMedia_Model_SocialMediaDataMapper();
			$socialMediaTable  = $socialMediaMapper->getDbTable();
			$socialMediaSelect = $socialMediaTable->select(); 
			$socialMediaSelect->from($socialMediaTable,array('rsm_pageid','rsm_restid'))
							->where('rsm_status = ?',true);
			
			$select->from(array('rest'=>'mt.restaurant'),array('resid','resrestaurant_name','resmanager_name','resemail','restcreatedon','resreservation_system','resneighborhood_id','reslisted_restaurant_id','respaymentstatus','res_payment_mode'));
			$select->where('rest.rescategory_id = ?',2);
			$select->join(array('restown'=>'mt.restaurant_owner'),'rest.resfk_user = restown.rsofk_user',array('rsofirst_name','rsolast_name'));
			$select->join(array('usr'=>'mt.user'),'restown.rsofk_user = usr.usrid',array('usremail','usrid'));
			$select->join(array('sta'=>'mt.state_bd'),'rest.resstate_id = sta.id',array('description as state'));
			$select->joinLeft(array('cty'=>'mt.city_bd'),'rest.rescity_id = cty.id',array('description as city'));
			$select->joinLeft(array('loc'=>'mt.restaurant_new_location'),'rest.resid= loc.rnl_fk_restaurant',array('rnl_location_count'));
			$select->join(array('appsts'=>'mt.restaurant_approval_status_bd'),'rest.resapprovalstatus = appsts.id',array('code as appstatuscode','description as appstatus'));
			$select->join(array('rescat'=>'mt.restaurant_category_bd'),'rest.rescategory_id = rescat.id',array('code as rescatstatuscode','description as rescatstatus'));
			$select->join(array('reststs'=>'mt.restaurant_status_bd'),'reststs.id = rest.resstatus',array('code as reststatscode','description as reststatusdesc'));
			$select->joinLeft(array('nei'=>'mt.neighborhood_bd'),'rest.resneighborhood_id = nei.id',array('description as neighbour'));
			$select->joinLeft(array('rsm'=>$socialMediaSelect),'rsm.rsm_restid = rest.resid',array('rsm_pageid'));
			$select->join(array('cpm'=>'mt.company'),'rest.res_companyid = cpm.com_id',array('com_companyname as company','com_id as companyid'));
			/**SHOWCASE SMS CREDITS**/
			$select->joinLeft(array('smscount'=>'mt.sms_restaurant_campcount'),'rescamp_resid = resid',array('rescamp_totalsms','rescamp_usedsms'));
			if($restSummary->getRestId()){
				$select->where('rest.resid = ?',$restSummary->getRestId());
			}
			if($restSummary->getOwnerEmail()){
				$select->where('usr.usremail Ilike ?','%'.trim($restSummary->getOwnerEmail()).'%');	
			}
			if($restSummary->getRestName()){
				$select->where('rest.resrestaurant_name Ilike ?','%'.trim($restSummary->getRestName()).'%');
			}
			if($restSummary->getFirstName()){
				$select->where('restown.rsofirst_name Ilike  ?','%'.trim($restSummary->getFirstName()).'%');
			}
			if($restSummary->getLastName()){
				$select->where('restown.rsolast_name Ilike  ?','%'.trim($restSummary->getLastName()).'%');
			}
			if($restSummary->getRestRegion()){
				$select->where('rest.resregion_id = ?',$restSummary->getRestRegion());
			}
			if($restSummary->getRestCity()){
				$select->where('rest.rescity_id = ?',$restSummary->getRestCity());
			}
			if($restSummary->getRestAppStatus()){
				$select->where('rest.resapprovalstatus = ?',$restSummary->getRestAppStatus());
			}
			if($restSummary->getRestStatus()){
				$select->where('rest.resstatus = ?',$restSummary->getRestStatus());
			}else{
				$select->where('rest.resstatus NOT IN (?) ',array(3,2));
			}
			if($restSummary->getCompany()){
				$select->where('rest.res_companyid = ?',$restSummary->getCompany());
			}else{
				if($restSummary->getCompanyId() != 1){
					$select->where('rest.res_companyid = ?',$restSummary->getCompanyId());
				}
			}
			
			$select->order('rest.restcreatedon DESC');
			
			$rowset = new Zend_Paginator(
					  new Zend_Paginator_Adapter_DbTableSelect($select)
					);
			
			$rowset->setItemCountPerPage($limit);
		    $rowset->setCurrentPageNumber($offset);
			
			$restNameArray = array();
			$restNeighArray = array();
			
			foreach($rowset as $row){
				if($row->resneighborhood_id){
					$restNameArray[]   = $row->resrestaurant_name;
					$restNeighArray[]  = $row->resneighborhood_id;
				}
			} 
			
			/* Reteriving matching listed restaurants */
			$restMatchCount = array();
			if(count($restNameArray) > 0){
				$resselect = $table->select();
				$resselect->setIntegrityCheck(false);
				$resselect->from(array('rest'=>'mt.restaurant'),array('resrestaurant_name'));				
				$resselect->where('rest.rescategory_id = ?',1);
				$resselect->where('rest.resrestaurant_name IN(?)',$restNameArray);
				$resselect->where('rest.resneighborhood_id IN(?)',$restNeighArray);
				$resselect->where('rest.resstatus = ?',1);
				$restMatchCount = $table->fetchAll($resselect);
			}	
			$restNameMatchArray = array();
			foreach($restMatchCount as $restName){
				$restNameMatchArray[] = trim($restName->resrestaurant_name);
			}
			$resultSet = array();
			$cityBd=array();
			if($restSummary->getRestRegion()){
				$citymapper = new Application_Model_CityDataMapper();
				$cityObj = new Application_Model_City();
				$cityObj->setRegionId($restSummary->getRestRegion());
				$city = $citymapper->getCityByRegionId($cityObj);
				
				$cityBd = $city->getCityList();
				
			}
			
			$resultSet['rowset'] 		 = $rowset;
			$resultSet['restmatchcount'] = $restNameMatchArray;
			$resultSet['cityBd'] 		 = $cityBd;
			return $resultSet;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getConflictRestaurants($resname,$neighbor)
	{
		try{
			$table = $this->getDbTable();
			$resselect = $table->select();
			$resselect->setIntegrityCheck(false);
			$resselect->from(array('rest'=>'mt.restaurant'),array('resid','resrestaurant_name','resapprovalstatus'));
			$resselect->join(array('nei'=>'mt.neighborhood_bd'),'rest.resneighborhood_id = nei.id',array('description as neighbour'));
			$resselect->join(array('appsts'=>'mt.restaurant_approval_status_bd'),'rest.resapprovalstatus = appsts.id',array('code as appstatuscode','description as appstatus'));
			$resselect->join(array('reststs'=>'mt.restaurant_status_bd'),'reststs.id = rest.resstatus',array('code as reststatscode','description as reststatusdesc'));
			$resselect->where('rest.resrestaurant_name Ilike ?','%'.trim($resname).'%');
			$resselect->where('rest.rescategory_id = ?',1);
			$resselect->where('nei.description Ilike ?','%'.trim($neighbor).'%');
			$result = $table->fetchAll($resselect);
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getCityByCode($code)
	{
		try{
			$cityList = array();
			$cityBDMapper = new Application_Model_CityDataMapper();
			$cityList = $cityBDMapper->fetchAll();

			foreach($cityList as $city){
				if($code == $city->code){
					return $city;
				}
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getRestAppStatusByCode($code)
	{
		try{
			$statusList = array();
			$restAppStatusMapper = new Application_Model_RestaurantApprovalStatusDataMapper();
			$statusList = $restAppStatusMapper->fetchAll();

			foreach($statusList as $status){
				if($code == $status->code){
					return $status;
				}
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getRestStatusByCode($code)
	{
		try{
			$statusList = array();
			$restStatusMapper = new Application_Model_RestaurantStatusDataMapper();
			$statusList = $restStatusMapper->fetchAll();

			foreach($statusList as $status){
				if($code == $status->code){
					return $status;
				}
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getRestaurantNamesByOwnerId(FirmManagement_Model_FirmNamesByOwnerId $restaurantnames)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();

			$select->from($table,array('resid','resrestaurant_name',''));
			if($restaurantnames->getRestOwnerId()){
				$select->where('resfk_user = ?',$restaurantnames->getRestOwnerId());	
			}else if($restaurantnames->getRestId()){
				$select->where('resid = ?',$restaurantnames->getRestId());
			}
			
			$select->where('resstatus = ?',1);

			$resultset =  $table->fetchAll($select);
			$restNames = array();
			$restNames[] = array('key'=>'','value'=>'Select Restaurant');
			foreach($resultset as $result){
				$restNames[] = array('key'=>$result->resid,'value'=>$result->resrestaurant_name);
			}

			return $restNames;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function getRestaurantStatusById(FirmManagement_Model_FirmById $restaurantbyid)
	{
		try{
			$resttable = $this->getDbTable();
			$cuisinemapper = new FirmManagement_Model_FirmCuisineDataMapper();

			$restcuisinetable = $cuisinemapper->getDbTable();

			$selectRest = $resttable->select();

			$selectRestCuisine = $restcuisinetable->select();
			$selectRest->setIntegrityCheck(false);
			/* Reteriving Restaurant Details */
			$selectRest->from(array('rest'=>'mt.restaurant'),
			array('resid',
					   'resschestatus',
					   'resfloorplanstatus'
					   
					   ))
					   ->where('rest.resid = ?',$restaurantbyid->getRestaurantId());



					   $restResult = $resttable->fetchRow($selectRest);
					   $restObj    = new FirmManagement_Model_Firm();
					   if($restResult){


					   	$restObj->setId($restResult->resid)
					   	->setRestScheStatus($restResult->resschestatus)

					   	->setRestFloorPlanStatus($restResult->resfloorplanstatus);
					   }
					   return $restObj;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getFavorieRestaurantNames(FirmManagement_Model_getFevRestNames $restaurantnames, $userid, $offset)
	{
		/* Geeting User restaurant Id's */
		try{
			$limit = 10;
			$mapper = new User_Model_CustomerRestChoiceDataMapper();
	//		$restIdList = $mapper->getCustRestFavId($userid);

			$query = $this->getDbTable()->select();
			$query->setIntegrityCheck(false);
			$query->from(array('rest' => 'mt.restaurant'), array('resid','resrestaurant_name','resimage','resaddress','resdescription'));
			$query->join(array('state' => 'mt.state_bd'),'rest.resstate_id = state.id ',array('description as state'));
			$query->join(array('neigh' => 'mt.neighborhood_bd'),'rest.resneighborhood_id = neigh.id ',array('description as neighbor'));
			$query->join(array('cty'=>'mt.city_bd'),'rest.rescity_id = cty.id',array('description as city'));
            		$query->join(array('rgn'=>'mt.region_bd'),'rest.resregion_id = rgn.id',array('description as region'));
            
			if($restaurantnames->getRestName()){
				$query->where('rest.resrestaurant_name Ilike ?','%'.trim($restaurantnames->getRestName()).'%');
			}
			if($restaurantnames->getStateId()){
				$query->where ('rest.resstate_id = ?',$restaurantnames->getStateId());
			}
			if($restaurantnames->getRegionId()){
				$query->where ('rest.resregion_id = ?',$restaurantnames->getRegionId());
			}
			if($restaurantnames->getCityId() ){
				$query->where ('rest.rescity_id = ?',$restaurantnames->getCityId());
			}

			if($restaurantnames->getNeighborhoodId()){
				$query->where ('rest.resneighborhood_id = ?', $restaurantnames->getNeighborhoodId());
			}
			if($restaurantnames->getCuisineId()){
				$query->join(array('rsc' => 'mt.restaurant_cuisine'),'rsc.rcsfk_restaurant = rest.resid');
				$query->where ('rsc.rscfk_restauranttype_id = ?',$restaurantnames->getCuisineId());
			}
//			$query->joinLeft(array('crc' => $query1),'crc.crcrestaurant_id = rest.resid',array('crcstatus as status'));
			$query->joinLeft(array('crc' => new Zend_Db_Expr('(SELECT crcrestaurant_id,crcstatus as status FROM mt.customer_restaurant_choice WHERE  crcfk_user ='.$userid.')')), 'crc.crcrestaurant_id  = rest.resid');
			$query->where('rescategory_id = 2');
//			$query->where('crc.crcfk_user = ?',$userid); 
			$query->where('rest.resstatus = ?',1);
			$query->order('rest.resid ASC');
			$ans = $this->getDbTable()->fetchAll($query);
			$Result = new Zend_Paginator(
			new Zend_Paginator_Adapter_DbTableSelect($query)
			);
			$Result->setItemCountPerPage($limit);
			$Result->setCurrentPageNumber($offset);

			$restList = array();
			$status = false;
		
//			foreach($Result as $result){
//				$RestaurantObj= new FirmManagement_Model_Firm();
//				$rest_id = $result->resid;
//				
//			//	$status = $this->checkRestIds($restIdList,$rest_id);
//			//	if($status){
//					$cusStatus = $mapper->getCustStatusById($userid,$rest_id);
//					if($cusStatus){
//					$RestaurantObj->setId($rest_id)
//								  ->setStatus($cusStatus);
//					$restList[] = $RestaurantObj;
//				}
//			}
		//	$results = array("status"=>$restList,"paginator"=>$Result);
			$results = array("status"=>true,"paginator"=>$Result);

			return $results;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getRestaurantCountByOwnerId($userid)
	{
		try{
			$restTable = $this->getDbTable();
			$selectResCount = $restTable->select();
			$selectResCount->from($restTable,array('COUNT(resid) as restcount'))
			->where('resfk_user = ?',$userid);

			$countResults = $restTable->fetchAll($selectResCount);
			$count = 0;
			foreach($countResults as $restcount){
				$count = $restcount->restcount;
			}
			return $count;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function checkRestIds(array $restIdList,$rest_id)
	{
		try{
			foreach($restIdList as $restid){
				if($rest_id == $restid['key']){
					return true;
				}
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getCuisineTypeById($restid)
	{
		try{
			$cuisinemapper = new FirmManagement_Model_FirmCuisineDataMapper();

			$restcuisinetable = $cuisinemapper->getDbTable();
			$selectRestCuisine = $restcuisinetable->select();
			$selectRestCuisine->setIntegrityCheck(false);
			$selectRestCuisine->from(array('cuis'=>'mt.restaurant_cuisine'),array('rscid','rscfk_restauranttype_id'))
			->join(array('resttyp'=>'mt.restaurant_type_bd'),'resttyp.id = cuis.rscfk_restauranttype_id',array('id as restypeid','description'))
			->where('cuis.rcsfk_restaurant = ?',$restid);
			$cuisineResult = $restcuisinetable->fetchAll($selectRestCuisine);

			$restCuisines = array();


			$restCuisines[] = array('key'=>'','value'=>'Select Cuisine');
			foreach($cuisineResult as $result){
				$restCuisines[] = array('key'=>$result->restypeid,'value'=>$result->description);
			}

			return $restCuisines;

			/* Setting restaurant types to Restaurant objects restauranttype id property. */

			return $restCuisines;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function getRestaurantDataByOwnerId(FirmManagement_Model_FirmNamesByOwnerId $restaurantnames)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			$select->from(array('rest'=>'mt.restaurant'),array('resid','resrestaurant_name','resimage','reslogo','resaddress','respaymentstatus','reswebsite'));
			$select->joinLeft(array('state' => 'mt.state_bd'),'rest.resstate_id = state.id ',array('description as state'));
			$select->joinLeft(array('neigh' => 'mt.neighborhood_bd'),'rest.resneighborhood_id = neigh.id ',array('description as neighbor'));
			$select->joinLeft(array('cty'=>'mt.city_bd'),'rest.rescity_id = cty.id',array('description as city'));
            		$select->joinLeft(array('rgn'=>'mt.region_bd'),'rest.resregion_id = rgn.id',array('description as region'));
			if($restaurantnames->getRestOwnerId()){
			$select->where('resfk_user = ?',$restaurantnames->getRestOwnerId());
			}else if($restaurantnames->getRestId()){
				$select->where('resid = ?',$restaurantnames->getRestId());
			}
			$select->where('resstatus = ?',1)
					->order('resid');

			$resultset =  $table->fetchAll($select);
			$restNames = array();
			//$restNames[] = array('key'=>'','value'=>'Select Restaurant');
			foreach($resultset as $result){
				$restNames[] = array('resid'		=> $result->resid,
								 'resname'			=> $result->resrestaurant_name,
								 'resimage'			=> $result->resimage,
								 'reslogo'			=> $result->reslogo,
								 'resaddress'		=> $result->neighbor,
								 'respaymentstatus'	=> $result->respaymentstatus,
								 'reswebsite'		=> $result->reswebsite
							);
			}

			return $restNames;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function RestaurantScheduleIsset($restaurantid)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$resultStr = "";
			$select->from($table,array('resschestatus','resid'))
			->where('resid = ?',$restaurantid);
			$resultset = $table->fetchRow($select);
			$result = $resultset['resschestatus'];
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getRestaurantDetailsById($restId)
	{
		try{
			$resttable = $this->getDbTable();
			$selectRest = $resttable->select();
			$selectRest->from($resttable,array('resrestaurant_name','resaddress','res_countrycode','resphone','resemail','reslogo','resfk_user'))
			->where('resid = ?',$restId);

			$restResult = $resttable->fetchRow($selectRest);

			return $restResult;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function checkRestaurantName(FirmManagement_Model_Firm $restaurant)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$result = $db->fetchOne("select count(resrestaurant_name) from mt.restaurant where resrestaurant_name = '". $restaurant->getRestaurantname() ."'and resstatus = ".$restaurant->getStatus());

			if((int)$result)
			{
				$status = true;
			}else{
				$status = false;
			}
			return $status;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function getRestaurantNamesSearch($text)
	{
		try{
			$resttable = $this->getDbTable();
			$select = $resttable->select();
			$select->setIntegrityCheck(false);
			$select->from(array('res'=>'mt.restaurant'),array('resid','resrestaurant_name'));
			$select->where('res.rescategory_id = ?',1);
			$text = trim($text);
			$select->where('res.resrestaurant_name ILIKE ?','%'.$text.'%');
			$select->where('res.resstatus = ?',1);
			$select->where('res.resapprovalstatus = ?',1);
			$select->join(array('neigh'=>'mt.neighborhood_bd'),'neigh.id = res.resneighborhood_id',array('description as neighdesc'));
			$select->order(array('res.resrestaurant_name'));
			$result = $resttable->fetchAll($select);
			$list = null;
			foreach($result as $item){
				$list[$item['resid']] = $item['resrestaurant_name']." - ".$item['neighdesc'];
			}
			return $list;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getRestaurantNamesTimeSearch($text,$searchType,$cityId,$regionId,$neighborId,$stateId)
	{
		try{
			$resttable = $this->getDbTable();
			$select = $resttable->select();
			$select->setIntegrityCheck(false);
			$select->from(array('res'=>'mt.restaurant'),array('resid','resrestaurant_name'));
			if($searchType == 'subscribe'){
				$select->where('res.rescategory_id = ?',2);
			}
			if($regionId && $cityId && $stateId){
				$select->where('res.resstate_id = ?',$stateId);
				$select->where('res.resregion_id = ?',$regionId);
				$select->where('res.rescity_id = ?',$cityId);
			}
			$text = trim($text);
			if($neighborId){
				$select->where('res.resneighborhood_id = ?',$neighborId);
			}
			$select->where('res.resrestaurant_name ILIKE ?','%'.$text.'%');
			$select->where('res.resstatus = ?',1);
			$select->where('res.resapprovalstatus = ?',1);
			$select->join(array('neigh'=>'mt.neighborhood_bd'),'neigh.id = res.resneighborhood_id',array('description as neighdesc'));
			$select->order(array('res.resrestaurant_name'));
			$result = $resttable->fetchAll($select);
			$list = null;
			foreach($result as $item){
				$list[$item['resid']] = $item['resrestaurant_name']." - ".$item['neighdesc'];
			}
			return $list;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getRestaurantArrById(FirmManagement_Model_FirmById $restaurantbyid)
	{
		try{
			$resttable = $this->getDbTable();

			$cuisinemapper = new FirmManagement_Model_FirmCuisineDataMapper();

			$restcuisinetable = $cuisinemapper->getDbTable();
			$paymentmapper = new FirmManagement_Model_FirmPaymentOptionsDataMapper();
			$selectResttable = $paymentmapper->getDbTable();
			$selectRestPayment = $selectResttable->select();
			$selectRest = $resttable->select();

			$selectRestCuisine = $restcuisinetable->select();
			$selectRest->setIntegrityCheck(false);


			/* Reteriving Restaurant Details */
			$selectRest->from(array('rest'=>'mt.restaurant'),
			array('resid',
				   'resfk_user',
				   'resrestaurant_name',
			 	   'restcapacity',
				   'reslogo',
				   'resimage',
				   'resemail',
				   'res_no_of_floors',
				   'resaddress',
				   'rescity_id',
				   'resstate_id',
				   'resneighborhood_id',
				   'reszipcode',
				   'resphone',
				   'resfax',
				   'restimezone',
				   'resprice',	
				   'reswebsite',
				   'resmanager_name',
				   'resdescription',
				   'resdiningstyle',
				   'resadditionaldetails',
				   'resparking',
				   'resparkingdetails',
				   'resprivateparty',
				   'resprivatepartycontact',
				   'resentertainment',
				   'resreservation_system',
				   'resgoogleimage',
				   'reslatitude',
				   'reslongitude',
				   'resmaxpax',
				   'resrestaurant_timings' 		

				   ))
				   ->join(array('neigh'=>'mt.neighborhood_bd'),'neigh.id = rest.resneighborhood_id',array('description as neighbor'))
				   ->join(array('city'=>'mt.city_bd'),'city.id = rest.rescity_id',array('description as city'))
				   ->join(array('state'=>'mt.state_bd'),'state.id = rest.resstate_id',array('description as state'))
				   ->where('rest.resid = ?',$restaurantbyid->getRestaurantId());



				   $restResult = $resttable->fetchRow($selectRest);
				   $restObj    = new FirmManagement_Model_Firm();
				   if($restResult){
				   	$citymapper = new Application_Model_CityDataMapper();
				   	$cityObj = new Application_Model_City();
				   	$cityObj->setStateId($restResult['resstate_id']);
				   	$city = $citymapper->getCityByStateId($cityObj);
				   	$cityList = $city->getCityList();
				   	 
				   	$neighborhoodmapper = new Application_Model_NeighborhoodDataMapper();
				   	$neighborhoodObj = new Application_Model_Neighborhood();
				   	$neighborhoodObj->setCityId($restResult['rescity_id']);
				   	$neighborhood = $neighborhoodmapper->getNghByCityId($neighborhoodObj);
				   	$neighborhoodList = $neighborhood->getNeighborhoodList();
				   	 


				   	$restObj = array(
							   	'restId'					=>		$restResult->resid,
							  	'restName'					=>		$restResult->resrestaurant_name,
							  	'restCapacity'				=>		$restResult->restcapacity,
								'restDiningStyle'			=>		$restResult->resdiningstyle,
							  	'maxpax'					=>		$restResult->resmaxpax,
							  	'resprice'					=>		$restResult->resprice,
							  	'resAddress'				=>		$restResult->resaddress,
							  	'resState'					=>		$restResult->resstate_id,
							  	'postalCode'				=>		$restResult->reszipcode,
							  	'resPhone'					=>		$restResult->resphone,
							  	'resFax'					=>		$restResult->resfax,
							  	'restimezone'				=>		$restResult->restimezone,
						 	 	'emailAddress'				=>		$restResult->resemail,
							  	'resWebsite'				=>		$restResult->reswebsite,
							  	'resManager'				=>		$restResult->resmanager_name,
							  	'resDescription'			=>		$restResult->resdescription,
					  			'resImage'					=>		$restResult->resimage,
							  	'resLogo'					=>		$restResult->reslogo,
							  	'restParking'				=>		$restResult->resparking,
							  	'restParkDetails'			=>		$restResult->resparkingdetails,
							  	'restPrivParty'				=>		$restResult->resprivateparty,
						  		'restPrivPartyContact'		=>		$restResult->resprivatepartycontact,
							  	'restEntertainment'			=>		$restResult->resentertainment,
							  	'restAdditDetails'			=>		$restResult->resadditionaldetails,
						   		'restTimings'				=>		$restResult->resrestaurant_timings

				   	);
				   }

				   $selectRestCuisine->setIntegrityCheck(false);
				   $selectRestCuisine->from(array('cuis'=>'mt.restaurant_cuisine'),array('rscid','rscfk_restauranttype_id'))
				   ->join(array('resttyp'=>'mt.restaurant_type_bd'),'resttyp.id = cuis.rscfk_restauranttype_id',array('code','description'))
				   ->where('cuis.rcsfk_restaurant = ?',$restaurantbyid->getRestaurantId());
				   $cuisineResult = $restcuisinetable->fetchAll($selectRestCuisine);

				   $restCuisines = array();

				   foreach($cuisineResult as $cuisRes){
				   	$restCuisObj = new FirmManagement_Model_FirmCuisine();
				   	$restCuisObj->setId($cuisRes->rscid);
				   	$restCuisObj->setRestaurantTypeId($cuisRes->rscfk_restauranttype_id);
				   	$restCuisObj->setRestCuisineCode($cuisRes->code);
				   	$restCuisObj->setRestCuisineDesc($cuisRes->description);
				   	$restCuisines[] = $cuisRes->rscfk_restauranttype_id;
				   }

				   $selectRestPayment->setIntegrityCheck(false);
				   $selectRestPayment->from(array('pay'=>'mt.restaurant_payment_options'),array('rpoid','rpofk_restaurant_payment_type_id'))
				   ->join(array('respay'=>'mt.reservation_paymentmode_bd'),'respay.id = pay.rpofk_restaurant_payment_type_id',array('code','description'))
				   ->where('pay.rpofk_restaurant = ?',(int)$restaurantbyid->getRestaurantId());
				   $paymentResult = $selectResttable->fetchAll($selectRestPayment);
				   $resPayments = array();
				   foreach($paymentResult as $payRes){
				   		   				//$restPayObj = new FirmManagement_Model_FirmPaymentOptions();
				   		   				//$restPayObj->setId($payRes->rpoid);
				   		   				//$restPayObj->setRestaurantPaymentTypeId($payRes->rpofk_restaurant_payment_type_id);
				   		   				//$restPayObj->setRestPaymentCode($payRes->code);
				   		   				//$restPayObj->setRestPaymentDesc($payRes->description);
				   	$resPayments[] = $payRes->rpofk_restaurant_payment_type_id;
				   }


				   $finalResult = array();
				   $finalResult['citybd'] = $cityList;
				   $finalResult['neighbd'] = $neighborhoodList;
				   $finalResult['restdetails'] = $restObj;
				   $finalResult['cityid'] = $restResult->rescity_id;
				   $finalResult['neighid'] = $restResult->resneighborhood_id;
				   $finalResult['cusine'] = $restCuisines;
				   $finalResult['payment'] = $resPayments;
				   $finalResult['images'] = $restResult->reslogo." - ".$restResult->resimage;
				   return $finalResult;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function reteriveListedRest(FirmManagement_Model_GetListedRest $object)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();

			$select->setIntegrityCheck(false);

			$select->from(array('rest'=>'mt.restaurant'),array('resid','resrestaurant_name','resstatus'))
			->join(array('reststs'=>'mt.restaurant_status_bd'),'reststs.id = rest.resstatus',array('code','description'))
			->join(array('sbd'=>'mt.state_bd'),'sbd.id=rest.resstate_id',array('code as statecode','description as state'))
			->join(array('rbd'=>'mt.region_bd'),'rbd.id=rest.resregion_id',array('code as regioncode','description as region'))
			->join(array('cty'=>'mt.city_bd'),'rest.rescity_id = cty.id',array('code as citycode','description as city'))
			->join(array('ngbh'=>'mt.neighborhood_bd'),'rest.resneighborhood_id = ngbh.id',array('description as neighbor'))
			->join(array('app'=>'mt.restaurant_approval_status_bd'),'app.id = rest.resapprovalstatus',array('code as approvalcode','description as approvalstatus'))
			->join(array('cusine'=>'mt.restaurant_cuisine'),'cusine.rcsfk_restaurant = rest.resid',array('rscid'))
			->join(array('resttype'=>'mt.restaurant_type_bd'),'resttype.id = cusine.rscfk_restauranttype_id',array('description as resttype'))
			->join(array('price'=>'mt.price_bd'),'price.code = rest.resprice',array('description as price'))
			->where('rescategory_id = ?',1);

			if($object->getRestName()){
				$select->where('rest.resrestaurant_name Ilike ?','%'.trim($object->getRestName()).'%');
			}
			if($object->getState()){
				$select->where('rest.resstate_id = ?',$object->getState());
			}
			if($object->getRegion()){
				$select->where('rest.resregion_id = ?',$object->getRegion());
			}
			if($object->getCity()){
				$select->where('rest.rescity_id = ?',$object->getCity());
			}
			if($object->getRestStatus()){
				$select->where('rest.resstatus = ?',$object->getRestStatus());
			}
			if($object->getNeighbour()){
				$select->where('rest.resneighborhood_id = ?',$object->getNeighbour());
			}
			$select->order('rest.resrestaurant_name DESC');

			$rowSet = $table->fetchAll($select);

			return $rowSet;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getListedRestaurantById(FirmManagement_Model_FirmById $restaurantbyid)
	{
		try{
			$resttable = $this->getDbTable();

			$cuisinemapper = new FirmManagement_Model_FirmCuisineDataMapper();

			$restcuisinetable = $cuisinemapper->getDbTable();
			$paymentmapper = new FirmManagement_Model_FirmPaymentOptionsDataMapper();
			$selectResttable = $paymentmapper->getDbTable();
			$selectRestPayment = $selectResttable->select();
			$selectRest = $resttable->select();

			$selectRestCuisine = $restcuisinetable->select();
			$selectRest->setIntegrityCheck(false);


			/* Reteriving Restaurant Details */
			$selectRest->from(array('rest'=>'mt.restaurant'),
			array('resid',
				   'resfk_user',
				   'resrestaurant_name',
			 	   'restcapacity',
				   'reslogo',
				   'resimage',
				   'resemail',
				   'res_no_of_floors',
				   'resaddress',
				   'resstate_id',
				   'resregion_id',
				   'rescity_id',
				   'resneighborhood_id',
				   'reszipcode',
				   'resphone',
				   'resfax',
				   'restimezone',
				   'resprice',	
				   'reswebsite',
				   'resmanager_name',
				   'resdescription',
				   'resdiningstyle',
				   'resadditionaldetails',
				   'resparking',
				   'resparkingdetails',
				   'resprivateparty',
				   'resprivatepartycontact',
				   'resentertainment',
				   'resreservation_system',
				   'resgoogleimage',
				   'reslatitude',
				   'reslongitude',
				   'resmaxpax',
				   'resrestaurant_timings',

					'resapprovalstatus',
					'rescategory_id',
					'reslisted_restaurant_id',
					'resexecutivechef',
					'resdresscode',
					'resacceptwalkin',
					'respublictransit',
					'resspleventsandpromotions',
					'rescrossstreet',
				    'resmenu',
					'resorigin_id',
					'resreserv'
					))
					->join(array('neigh'=>'mt.neighborhood_bd'),'neigh.id = rest.resneighborhood_id',array('description as neighbor'))
					->join(array('city'=>'mt.city_bd'),'city.id = rest.rescity_id',array('description as city'))
					->join(array('st'=>'mt.state_bd'),'st.id = rest.resstate_id',array('description as state'))
					->join(array('region'=>'mt.region_bd'),'region.id = rest.resregion_id',array('description as region'))
					->join(array('restatus'=>'mt.restaurant_status_bd'),'restatus.id = rest.resstatus',array('code as rescode'))
					->join(array('apptatus'=>'mt.restaurant_approval_status_bd'),'apptatus.id = rest.resapprovalstatus',array('code as appcode'))
					->join(array('orbd'=>'mt.restaurant_origin_bd'),'orbd.id = rest.resorigin_id',array('description as origin'))
					->where('rest.resid = ?',$restaurantbyid->getRestaurantId());



					$restResult = $resttable->fetchRow($selectRest);
					$restObj    = new FirmManagement_Model_Firm();
					if($restResult){
						$statemapper = new Application_Model_StateDataMapper();
						$stateList=$statemapper->getStateIds();
											
						$regionmapper = new Application_Model_RegionDataMapper();
						$regionObj = new Application_Model_Region();
						$regionObj->setStateId($restResult['resstate_id']);
						$region = $regionmapper->getRegionByStateId($regionObj);
						$regionList = $region->getRegionList();
											
						$citymapper = new Application_Model_CityDataMapper();
						$cityObj = new Application_Model_City();
						$cityObj->setRegionId($restResult['resregion_id']);
						$city = $citymapper->getCityByRegionId($cityObj);
						$cityList = $city->getCityList();

						$neighborhoodmapper = new Application_Model_NeighborhoodDataMapper();
						$neighborhoodObj = new Application_Model_Neighborhood();
						$neighborhoodObj->setCityId($restResult['rescity_id']);
						$neighborhood = $neighborhoodmapper->getNghByCityId($neighborhoodObj);
						$neighborhoodList = $neighborhood->getNeighborhoodList();					
						/*$citymapper = new Application_Model_CityDataMapper();
						$cityObj = new Application_Model_City();
						$cityObj->setStateId($restResult['resstate_id']);
						$city = $citymapper->getCityByStateId($cityObj);
						$cityList = $city->getCityList();
							
						$neighborhoodmapper = new Application_Model_NeighborhoodDataMapper();
						$neighborhoodObj = new Application_Model_Neighborhood();
						$neighborhoodObj->setCityId($restResult['rescity_id']);
						$neighborhood = $neighborhoodmapper->getNghByCityId($neighborhoodObj);
						$neighborhoodList = $neighborhood->getNeighborhoodList();
						*/	

							
						$restObj->setId($restResult->resid)
						->setRestaurantownerid($restResult->resfk_user)
						->setRestaurantname($restResult->resrestaurant_name)
						->setRestCapacity($restResult->restcapacity)
						->setRestemail($restResult->resemail)
						->setRestlogo($restResult->reslogo)
						->setRestimage($restResult->resimage)
						//->setRestyrfound($restResult->resyear_founded)
						//	->setRestnoofflor($restResult->res_no_of_floors)
						->setRestaddress($restResult->resaddress)
						->setRestRegion($restResult->resregion_id)
						->setRestCity($restResult->rescity_id)
						->setReststateid($restResult->resstate_id)
						->setRestneighboorhood($restResult->resneighborhood_id)
						->setRestzipcode($restResult->reszipcode)
						->setRestphone($restResult->resphone)
						->setRestfax($restResult->resfax)
						->setResttimezone($restResult->restimezone)
						->setRestPrice($restResult->resprice)
						->setRestwebsite($restResult->reswebsite)
						->setRestmanagername($restResult->resmanager_name)
						->setRestdesc($restResult->resdescription)
						->setRestDiningStyle($restResult->resdiningstyle)
						->setRestAdditDet($restResult->resadditionaldetails)
						->setRestParking($restResult->resparking)
						->setRestParkDetails($restResult->resparkingdetails)
						->setRestPrivParty($restResult->resprivateparty)
						->setRestPrivPartyContact($restResult->resprivatepartycontact)
						->setRestEntertainment($restResult->resentertainment)
						//->setRestsubforreservation($restResult->resreservation_system)
						->setStateBd($stateList)
						->setCityBd($cityList)
						->setRegionBd($regionList)
						->setRestNeighborDesc($restResult->neighbor)
						->setRestRegionDesc($restResult->region)
						->setRestCityDesc($restResult->city)
						->setRestStateDesc($restResult->state)
						->setNeighborhodBd($neighborhoodList)
						->setRestGoogleImage($restResult->resgoogleimage)
						->setRestLatitude($restResult->reslatitude)
						->setRestLongtitude($restResult->reslongitude)
						->setMaxpax($restResult->resmaxpax)
						->setRestTimings($restResult->resrestaurant_timings)
						->setReststatus($restResult->rescode)
						->setRestsubforreservation('TRUE')
						->setRestAppStatusId($restResult->appcode)
						->setRestCategory($restResult->rescategory_id)
						->setRestListedResId($restResult->reslisted_restaurant_id)
						->setresexecutivechef($restResult->resexecutivechef)
						->setresdresscode($restResult->resdresscode)
						->setresacceptwalkin($restResult->resacceptwalkin)
						->setrespublictransit($restResult->respublictransit)
						->setresspleventsandpromotions($restResult->resspleventsandpromotions)
						->setrescrossstreet($restResult->rescrossstreet)
						->setresmenu($restResult->resmenu)
						->setResoriginId($restResult->resorigin_id)
						->setResorigin($restResult->origin)
						->setResReserv($restResult->resreserv);


						/* Reteriving Restaurant Cuisines */
						$selectRestCuisine->setIntegrityCheck(false);
						$selectRestCuisine->from(array('cuis'=>'mt.restaurant_cuisine'),array('rscid','rscfk_restauranttype_id'))
						->join(array('resttyp'=>'mt.restaurant_type_bd'),'resttyp.id = cuis.rscfk_restauranttype_id',array('code','description'))
						->where('cuis.rcsfk_restaurant = ?',$restaurantbyid->getRestaurantId());
						$cuisineResult = $restcuisinetable->fetchAll($selectRestCuisine);
							
						$restCuisines = array();

						foreach($cuisineResult as $cuisRes){
							$restCuisObj = new FirmManagement_Model_FirmCuisine();
							$restCuisObj->setId($cuisRes->rscid);
							$restCuisObj->setRestaurantTypeId($cuisRes->rscfk_restauranttype_id);
							$restCuisObj->setRestCuisineCode($cuisRes->code);
							$restCuisObj->setRestCuisineDesc($cuisRes->description);
							$restCuisines[] = $restCuisObj;
						}

						$selectRestPayment->setIntegrityCheck(false);
						$selectRestPayment->from(array('pay'=>'mt.restaurant_payment_options'),array('rpoid','rpofk_restaurant_payment_type_id'))
						->join(array('respay'=>'mt.reservation_paymentmode_bd'),'respay.id = pay.rpofk_restaurant_payment_type_id',array('code','description'))
						->where('pay.rpofk_restaurant = ?',(int)$restaurantbyid->getRestaurantId());
						$paymentResult = $selectResttable->fetchAll($selectRestPayment);
						$resPayments = array();
						foreach($paymentResult as $payRes){
							$restPayObj = new FirmManagement_Model_FirmPaymentOptions();
							$restPayObj->setId($payRes->rpoid);
							$restPayObj->setRestaurantPaymentTypeId($payRes->rpofk_restaurant_payment_type_id);
							$restPayObj->setRestPaymentCode($payRes->code);
							$restPayObj->setRestPaymentDesc($payRes->description);
							$resPayments[] = $restPayObj;
						}
						/* Setting restaurant types to Restaurant objects restauranttype id property. */
						$restObj->setResttypeid($restCuisines);
						$restObj->setRestPaymentMode($resPayments);
						//$restObj->setRestPaymentMode($resPayments);
						/* Reteriving Restaurant Schedules */
						/*$resSchmapper  = new FirmManagement_Model_FirmScheduleDataMapper();
						 $resScheList = $resSchmapper->getScheduleRes($restaurantbyid->getRestaurantId());
						 $restObj->setRestSchedule($resScheList);*/
							
						/* Reteriving Restaurant Menu */

						/*$menuMapper   = new FirmManagement_Model_FirmMenuDataMapper();
						 $menurestbyid = new FirmManagement_Model_GetMenuByRestId();
						 $menurestbyid->setRestaurantId($restaurantbyid->getRestaurantId());
						 $restMenu = $menuMapper->getRestaurantsMenu($menurestbyid);

						 $restObj->setRestMenu($restMenu);*/
//Faiz//						
						$tagmapper = new FirmManagement_Model_FirmPaymentOptionsDataMapper();
						$selectResttagg = $tagmapper->getDbTable();
						$selectRestTag = $selectResttagg->select();
						$selectRestTag->setIntegrityCheck(false);
						$selectRestTag->from(array('tag'=>'mt.restaurant_tag_options'),array('rtoid','rtofk_restaurant','rtofk_restaurant_tags_bd_id','rtostatus'))
										  ->join(array('bd'=>'mt.restaurant_tags_bd'),'tag.rtofk_restaurant_tags_bd_id = bd.id',array('code','description'))
										  ->where('tag.rtofk_restaurant = ?',(int)$restaurantbyid->getRestaurantId())
										  ->where('bd.status = ?',"True")
										  ->where('tag.rtostatus = ?',1);
						$tagResult = $selectResttagg->fetchAll($selectRestTag);
						$restags = array();
						if($tagResult){
							foreach($tagResult as $tagRes){	
								$restTagObj = new FirmManagement_Model_FirmTagBd();											
								$restTagObj->setrtofk_restaurant_tags_bd_id($tagRes->rtofk_restaurant_tags_bd_id);
								$restTagObj->setCode($tagRes->code);
								$restTagObj->setDescription($tagRes->description);
								$restags[] = $restTagObj;
							}
						}
						$restObj->settag_id($restags);
					}
					return $restObj;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function UpdateNotificationStatus(FirmManagement_Model_FirmNotificationStatus $object)	
	{
		try{
			$table = $this->getDbTable();
			$set   = array('resnotification'=>$object->getNotifStatus());
			$where = array('resid = ?'=>$object->getRestId());
			$status = $table->update($set,$where);
			return 	$status;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}		
	}
	
	public function UpdateAutoConfirmStatus(FirmManagement_Model_FirmNotificationStatus $object)	
	{
		try{
			$table = $this->getDbTable();
			$set   = array('resauto_confirm'=>$object->getNotifStatus());
			$where = array('resid = ?'=>$object->getRestId());
			$status = $table->update($set,$where);
			return 	$status;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}		
	}
	
	public function GetAutoConfirmStatus($restid)	
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$result = $db->fetchOne("select resauto_confirm from mt.restaurant where resid = ".$restid);
			return 	$result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}		
	}
	
	public function ManageRestNotifyStatus($resid, $status, $type)	
	{
		try{
			$table = $this->getDbTable();
			if($type == 'phone'){
				$set   = array('resphonenotify'=>$status);
			}else if($type == 'sms'){
				$set   = array('ressmsnotify'=>$status);
			}
			$where = array('resid = ?'=>$resid);
			$status = $table->update($set,$where);
			return 	$status;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}		
	}
	
	public function UpdatePhoneNotifyStatus(FirmManagement_Model_PhoneNotifyStatus $object)
	{
		try{
			$table = $this->getDbTable();
			$set   = array('resphonenotify'=>$object->getPhoneNotify());
			$where = array('resid = ?'=>$object->getRestId());
			$status = $table->update($set,$where);
			return 	$status;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function UpdateRestPrimaryEmail($restid, $resemail)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$result = 0;
			$status = "";
			$resultid = $db->fetchOne("select resid from mt.restaurant where resemail ILIKE '%".$resemail."%'");
			if($resultid == $restid){
				$status = true;
			}else{
				$result = $db->fetchOne("select count(rese_email) from mt.restaurant_emails where resefk_restaurantid = '".$restid."'and rese_email ILIKE'%".$resemail."%'and rese_email_status_id IN(1,2)  and feedback_email IS NULL");
				if($result < 1){
					$table = $this->getDbTable();
					$set   = array('resemail'=>$resemail);
					$where = $db->quoteInto('resid = ?',$restid);
					$status = $table->update($set,$where);
				}
			}
			return 	$status;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function GetRestaurantTimeZone($resid)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->setIntegrityCheck(false);
			$select->from($this->getDbTable(),array('restimezone'))
				   ->join('mt.timezone_bd','code = restimezone',array('description as TimeZone'))
				   ->where('resid = ?',$resid);
			$result = $this->getDbTable()->fetchRow($select);
			$timeZone = $result->TimeZone;
			return $timeZone;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getRestaurantDetailsBystateid($stateid,$regionid,$cityid,$request,$restname,$groupName,$Crestartdate,$Creenddate)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$table = $this->getDbTable();
			$select = $table->select(); 
			$select->setIntegrityCheck(false);
			
			$count = null;
			
			$countres = $this->GetUsersCountByStateId($stateid,$regionid,$cityid,$restname,$groupName,$Crestartdate,$Creenddate);
			$count = $countres['count'];
			$calcount = $countres['totalcount']; 
			$offset = 0;
			$limit = 50;
		
			/* Reteriving the previous offset */
			if($request->offset && $request->offset != 0){
				$offset = $request->offset;
			}
			/* If next link or arrow is clicked this if condition is executed. */
			if($request->event == 'next'){

				if($count >= $offset + 50){

					$offset = $offset + 50;

					if($offset + 50 >= $count){
						$result['next'] = false;
					}else{
						$result['next'] = true;
					}
				}
				if($offset >= 50){
					$result['prev'] = true;
				}

			}/* if previous link is clicked this if condition is executed. */
			elseif($request->event == 'prev'){

				$offset = $offset - 50;

				if($offset == 0 || $offset < 50){
					$result['prev'] = false;
				}else{
					$result['prev'] = true;
				}
				if($count > $offset){

					$result['next'] = true;
				}

			}/* This else part is executed on first call of this function. */
			else{
				if($count > 50){
					/* if count is greater than 50 show the next link */
					$result['next'] = true;
					$result['prev'] = false;
				}else{
					/* if count is less than 50 then no links are shown. */
					$result['next'] = false;
					$result['prev'] = false;
				}

			}
			
			$result['offset'] = $offset;
			$result['count'] = $calcount;
			
			$select->from(array('rest'=>'mt.restaurant'),array('resid','resemail','resrestaurant_name'));
			//$select->join(array('resemail'=>'mt.restaurant_emails'),'resemail.resefk_restaurantid = rest.resid',array('rese_id','rese_email'));
			$select->join(array('restown'=>'mt.restaurant_owner'),'restown.rsofk_user = rest.resfk_user',array('rsofirst_name','rsolast_name'));
			$select->join(array('sta'=>'mt.state_bd'),'rest.resstate_id = sta.id',array('code as statecode','description as state'));
			$select->join(array('cty'=>'mt.city_bd'),'rest.rescity_id = cty.id',array('code as citycode','description as city'));
			$select->join(array('ngbh'=>'mt.neighborhood_bd'),'rest.resneighborhood_id = ngbh.id',array('description as neighbor'));
			$select->where('rest.resemail != ?','');
            //$select->where('resemail.rese_status = ?',true);		
			if($stateid && $cityid && $regionid){
				$select->where('rest.resstate_id = ?',$stateid);
				$select->where('rest.resregion_id = ?',$regionid);
				$select->where('rest.rescity_id = ?',$cityid);
			}
			else if($stateid && $regionid){
				$select->where('rest.resstate_id = ?',$stateid);
				$select->where('rest.resregion_id = ?',$regionid);
			}
			else if($stateid){
				$select->where('rest.resstate_id = ?',$stateid);
			}
			if($restname != ""){
				$select->where('rest.resrestaurant_name Ilike ?','%'.trim($restname).'%');
			}
			if($groupName != ""){
				$select->where('restown.rsorestaurant_name Ilike ?','%'.trim($groupName).'%');
			}
			if($Crestartdate != "" && $Creenddate != ""){
				$select->where('rest.restcreatedon >= ?',$Crestartdate);
				$select->where('rest.restcreatedon <= ?',$Creenddate);
			}else if($Crestartdate != ""){
				$select->where('rest.restcreatedon = ?',$Crestartdate);
			}
			$select->where('rest.rescategory_id = ?',2);
			$select->where('rest.resstatus = ?',1);
			$select->order('rest.resid');
			$select->limit($limit,$offset);
			$resultSet = $table->fetchAll($select);
			$emailmapper = new FirmManagement_Model_FirmEmailsDataMapper();
			$secemailArr = array();
			foreach($resultSet as $row)
			{
				$emailselect = $emailmapper->getDbTable()->select();
				$emailselect->from(array('mt.restaurant_emails'),array('rese_email','resefk_restaurantid'));
				$emailselect->where('resefk_restaurantid = ?',$row->resid);
				$emailselect->where('rese_status = ?',true);
				$emailselect->where('feedback_email IS  NULL');
				$emailselect->order('rese_id');
				$emailset = $emailmapper->getDbTable()->fetchAll($emailselect);
				$val = "";
				foreach ($emailset as $email){
					if($email){
						$val .= ','.$email->rese_email;
					}
				}
				if($val){
					$secemailArr[$row->resid] = $row->resemail.$val;
				}
			}
			$emailListArr =array();
			$emailListArr['primay'] = $resultSet;
			$emailListArr['secondary'] = $secemailArr;			   
			$result['UsersList'] = $emailListArr;
			return 	$result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetUsersCountByStateId($stateid,$regionid,$cityid,$restname,$groupName,$Crestartdate,$Creenddate)
	{
		try{
			$count = 0;
			$emailcount = 0;
			$emailmapper = new FirmManagement_Model_FirmEmailsDataMapper();
			$restTable = $this->getDbTable();
			$select = $restTable->select();
			$select->setIntegrityCheck(false);
			$select->from(array('rest'=>'mt.restaurant'),array('count(resemail) as restcount','resid'));
			$select->join(array('restown'=>'mt.restaurant_owner'),'restown.rsofk_user = rest.resfk_user',array());
			$select->where('rest.resemail != ?','');
			if($stateid && $cityid && $regionid){
				$select->where('rest.resstate_id = ?',$stateid);
				$select->where('rest.resregion_id = ?',$regionid);
				$select->where('rest.rescity_id = ?',$cityid);
			}else if($stateid && $regionid){
				$select->where('rest.resstate_id = ?',$stateid);
				$select->where('rest.resregion_id = ?',$regionid);
			}
			else if($stateid){
				$select->where('rest.resstate_id = ?',$stateid);
			}
			if($restname != ""){
				$select->where('rest.resrestaurant_name Ilike ?','%'.trim($restname).'%');
			}
			if($groupName != ""){
				$select->where('restown.rsorestaurant_name Ilike ?','%'.trim($groupName).'%');
			}
			if($Crestartdate != "" && $Creenddate != ""){
				$select->where('rest.restcreatedon >= ?',$Crestartdate);
				$select->where('rest.restcreatedon <= ?',$Creenddate);
			}else if($Crestartdate != "" && $Creenddate == ""){
				$select->where('rest.restcreatedon = ?',$Crestartdate);
			}
			$select->where('rest.rescategory_id = ?',2);
			$select->where('rest.resstatus = ?',1);
			$select->group('rest.resid');
			$rowset = $restTable->fetchAll($select);
			foreach($rowset as $row){
				$count += $row->restcount;
				$emailselect = $emailmapper->getDbTable()->select();
				$emailselect->from(array('mt.restaurant_emails'),array('count(rese_email) as emailcount'));
				$emailselect->where('resefk_restaurantid = ?',$row->resid);
				$emailselect->where('rese_status = ?',true);
				$emailselect->where('feedback_email IS NULL');			
				$resultset = $emailmapper->getDbTable()->fetchAll($emailselect);
				foreach($resultset as $resultrow){
					$emailcount += $resultrow->emailcount;
				}
			}
			$finalcount = $count + $emailcount;
			$countArr = array('count'=>$count,'totalcount'=>$finalcount);	
			return $countArr;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function getRestaurantEmailIds($stateid,$cityid,$restIdsArr,$restname,$groupName,$Crestartdate,$Creenddate)
	{
		try{
			$primaryrestIds = array();
			$secrestIds = array();
			foreach($restIdsArr as $resVal){
				if(strpos($resVal, '-')){
					$val = explode('-',$resVal);
					if(in_array($val[0], $primaryrestIds)){
						if($val[1] != 1){
							$secrestIds[] = $resVal;		
						}	
						continue;
					}else{
						if($val[1] == 1){
							$primaryrestIds[] = $val[0];
						}else{
							$secrestIds[] = $resVal;		
						}	
					}
				}else{
					$primaryrestIds[] = $resVal;
				}
				
			}
			
			$emailmapper = new FirmManagement_Model_FirmEmailsDataMapper();
			$emailselect = $emailmapper->getDbTable()->select();
			$emailselect->setIntegrityCheck(false);
			$emailselect->from(array('resemail'=>'mt.restaurant_emails'),array('rese_email','resefk_restaurantid'));
			$emailselect->join(array('rest'=>'mt.restaurant'),'resemail.resefk_restaurantid = rest.resid',array());
			$emailselect->join(array('restown'=>'mt.restaurant_owner'),'restown.rsofk_user = rest.resfk_user',array());
			$emailselect->where('rest.resemail != ?','');
			$emailselect->where('feedback_email IS NULL');
			if($stateid && $cityid){
				$emailselect->where('rest.resstate_id = ?',$stateid);
				$emailselect->where('rest.rescity_id = ?',$cityid);
			}else if($stateid){
				$emailselect->where('rest.resstate_id = ?',$stateid);
			}
			if($groupName != ""){
				$emailselect->where('restown.rsorestaurant_name Ilike ?','%'.trim($groupName).'%');
			}
			if($restname != ""){
				$emailselect->where('rest.resrestaurant_name Ilike ?','%'.trim($restname).'%');
			}
			if($Crestartdate  != "" && $Creenddate  != ""){
				$emailselect->where('rest.restcreatedon >= ?',$Crestartdate);
				$emailselect->where('rest.restcreatedon <= ?',$Creenddate);
			}else if($Crestartdate  != ""){
				$emailselect->where('rest.restcreatedon = ?',$Crestartdate);
			}
			$emailselect->where('rest.rescategory_id = ?',2);
			$emailselect->where('rest.resstatus = ?',1);
			$emailselect->where('resemail.rese_status = ?',true);
			$emailselect->order('resemail.resefk_restaurantid');
//			$emailselect->group('resemail.rese_id');
			$emailset = $emailmapper->getDbTable()->fetchAll($emailselect);
			$secemailArr = array();
			$count = 2;
			$tempid = "";
			foreach($emailset as $emailval)
			{
				if(in_array($emailval->resefk_restaurantid.'-'.$count,$secrestIds)){
					$count++;
					continue;
				}else{
					if($tempid == ""){
						$tempid = $emailval->resefk_restaurantid;
						$secemailArr[$emailval->resefk_restaurantid.'-'.$count] = $emailval->rese_email;
						$count++;
					}else if($tempid == $emailval->resefk_restaurantid){
						$secemailArr[$emailval->resefk_restaurantid.'-'.$count] = $emailval->rese_email;
						$count++;
					}else{
						$count = 2;
						$tempid = $emailval->resefk_restaurantid;
						$secemailArr[$emailval->resefk_restaurantid.'-'.$count] = $emailval->rese_email;
						$count++;
					} 
				}										
			}
			
			
			$restTable = $this->getDbTable();
			$select = $restTable->select();
			$select->setIntegrityCheck(false);
			$select->from(array('rest'=>'mt.restaurant'),array('resid','resemail'));
			$select->join(array('restown'=>'mt.restaurant_owner'),'restown.rsofk_user = rest.resfk_user',array());
			$select->where('rest.resemail != ?','');
			if($stateid && $cityid){
				$select->where('rest.resstate_id = ?',$stateid);
				$select->where('rest.rescity_id = ?',$cityid);
			}else if($stateid){
				$select->where('rest.resstate_id = ?',$stateid);
			}
			if($groupName != ""){
				$select->where('restown.rsorestaurant_name Ilike ?','%'.trim($groupName).'%');
			}
			if($restname != ""){
				$select->where('rest.resrestaurant_name Ilike ?','%'.trim($restname).'%');
			}
			if($Crestartdate  != "" && $Creenddate  != ""){
				$select->where('rest.restcreatedon >= ?',$Crestartdate);
				$select->where('rest.restcreatedon <= ?',$Creenddate);
			}else if($Crestartdate  != ""){
				$select->where('rest.restcreatedon = ?',$Crestartdate);
			}
			$select->where('rest.rescategory_id = ?',2);
			$select->where('rest.resstatus = ?',1);
			if(count($primaryrestIds)){
				$select->where('rest.resid NOT IN(?)',$primaryrestIds);
			}
			$rowset = $restTable->fetchAll($select);
			$priemailArr = array();
			foreach($rowset as $row)
			{
					$priemailArr[$row->resid] = $row->resemail;
			}
			
			return array('primary'=>$priemailArr,'secondary'=>$secemailArr);
		}catch (Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function getRestaurantIdsByOwnerId(FirmManagement_Model_FirmByOwnerId $byownerid)
	{
		try{
			$ownerId = $byownerid->getResOwnerId();

			$table = $this->getDbTable();
			$select = $table->select();
			
			$select->from(array('rest'=>'mt.restaurant'),array('resid','resrestaurant_name'))
			->where('rest.resfk_user = ?',$ownerId)
			->order(array('resid'));

			$resultSet = $table->fetchAll($select);
			return $resultSet;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getApprovedRestaurantIdsByOwnerId(FirmManagement_Model_FirmByOwnerId $byownerid)
	{
		try{
			$ownerId = $byownerid->getResOwnerId();
      //echo $ownerId; exit;
			$table = $this->getDbTable();
			$select = $table->select();
			
			$select->from(array('rest'=>'mt.restaurant'),array('resid','resrestaurant_name'))
			->where('rest.resfk_user = ?',$ownerId)
			->where('rest.resapprovalstatus = ?',1)
			->order(array('resid'));

			$resultSet = $table->fetchAll($select);
			return $resultSet;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getRestaurantStateByResId($resid)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->from($this->getDbTable(),array('resid','resstate_id','rescity_id','resregion_id'))
				   ->where('resid = ?',$resid);
			$result = $this->getDbTable()->fetchRow($select);
			$stateId = $result->resstate_id;
			$cityId = $result->rescity_id;
			$regionId = $result->resregion_id;
			return array('state'=>$stateId,'city'=>$cityId,'region'=>$regionId);
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetPaymentStatusByRestaurantId($resid)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->from($this->getDbTable(),array('respaymentstatus'))
				   ->where('resid = ?',$resid);
			$result = $this->getDbTable()->fetchRow($select);
			return $result->respaymentstatus; 
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function retrievePhoneDetails($restaurantid)
	{
		try{
			
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('resphonenotify','ressmsnotify'))
				   ->where('resid = ?',$restaurantid);
				   
			$row = $table->fetchRow($select);
			
			$phonenotify = false;
			$smsnotify   = false;
			
			$phonenumber = "";
			$smsphonenumber = "";
			
			if($row){
				$phonenotify = $row->resphonenotify;
				$smsnotify   = $row->ressmsnotify;
			}
			
			$notifyTimesMapper = new FirmManagement_Model_FirmNotifyTimesMapper();
			$notifyTable = $notifyTimesMapper->getDbTable();
			$notifySelect = $notifyTable->select();
			
			$notifySelect->from($notifyTable,array('rntphone','rntnotify_from_time','rntnotify_to_time','rntnotify_type','rntcountrycode'))
						 ->where('rntstatus = ?',true)
						 ->where('rntnotify_type = ?','sms')
						 ->where('rntfk_restaurants = ?',$restaurantid);
				   
			$rowSet = $notifyTable->fetchAll($notifySelect);
			
			$result = array();
			
			$result['phonenotify'] = $phonenotify;
			$result['smsnotify']   = $smsnotify;
			$result['rowset'] 	   = $rowSet;
			
			return $result;
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetRestMaxPartyAllowed($restid)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('resmaxpax','resid'))
				   ->where('resid = ?',$restid);				   
			$row = $table->fetchRow($select);			
			return $row;
							   
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getFloorStatusByResid($resid){
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('resschestatus','resfloorplanstatus','ressettingstatus'))
				   ->where('resid = ?',$resid);
				   
			$result = $this->getDbTable()->fetchRow($select);

//			return $result->resfloorplanstatus;
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getMaxandMinPartySize($restid)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('resmaxpax','resminpax'))
				   ->where('resid = ?',$restid);				   
			$row = $table->fetchRow($select);			
			return $row;
							   
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function editPartySize($resid,$max)
	{
		$status = false;
		try{
			
			$set   = array('resmaxpax' 		  => $max);
			$where = array('resid = ?'=>$resid);
			$status = $this->getDbTable()->update($set,$where);

			return $status;
		}catch(Exception $ex){
			$db->rollBack();
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetSpecialSetting($restid)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('resspecialsetting'))
				   ->where('resid = ?',$restid);				   
			$row = $table->fetchRow($select);			
			return $row;
							   
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function UpdateSpecialSetting($restid,$specialsetting)
	{
		try{
			$table = $this->getDbTable();
			$set   = array('resspecialsetting'=>$specialsetting);
			$where = array('resid = ?'=>$restid);
			$status = $table->update($set,$where);
			return 	$status;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetSpecialRequestSetting($restid)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('resspecial_request'))
				   ->where('resid = ?',$restid);				   
			$row = $table->fetchRow($select);			
			return $row;
							   
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function GetOtpSettingStatus($restid)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('resotp_setting'))
				   ->where('resid = ?',$restid);				   
			$row = $table->fetchRow($select);			
			return $row;
							   
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function UpdateSpecialRequestSetting($restid,$resspecial_request)
	{
		try{
			$table = $this->getDbTable();
			$set   = array('resspecial_request'=>$resspecial_request);
			$where = array('resid = ?'=>$restid);
			$status = $table->update($set,$where);
			return 	$status;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function UpdateOtpSetting($restid,$resspecial_request)
	{
		try{
			$table = $this->getDbTable();
			$set   = array('resotp_setting'=>$resspecial_request);
			$where = array('resid = ?'=>$restid);
			$status = $table->update($set,$where);
			return 	$status;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	/**
         * Desc - Function to display restaurant reservation report,
         * Table mt.booking, mt.restaurant, mt.city_bd & mt.company have been joined to get result based on current day or previous day booking date
         * bitrix Id: #416
         * @param FirmManagement_Model_FirmSearch $restObj
         * @param type $request
         * @param type $page
         * @return object
         * @throws Exception
         */

        
        public function RestaurantReservationReport(FirmManagement_Model_FirmSearch $restObj, $request, $page=null)
        {
            try
            {                    
                        $limit =15;
                        $table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
                        $select->from(array('bok'=>'mt.booking'), array('bokid','bokemail','bokfirst_name','boklast_name','bokphone', 'bokbooking_date', 'bokparty_size', 'bokrestaurant_note'))
                                    ->join(array('rest'=>'mt.restaurant'),'bok.bokfk_restaurant=rest.resid' ,array('resrestaurant_name', 'rescity_id', 'res_companyid'))
                                    ->join(array('city'=>'mt.city_bd'),'city.id=rest.rescity_id',array('description'))
                                    ->join(array('com'=>'mt.company'), 'com.com_id=rest.res_companyid', array('com_companyname'))
                                    ->join(array('bokstatus'=>'mt.booking_status_bd'), 'bok.bokbooking_status_id=bokstatus.id', array('description as curbokstatus'))
                                    ->join(array('resmode'=>'mt.reservation_mode_bd'), 'resmode.id=bok.bokreservation_mode_id', array('description as reservationmode'))
                                    ->join(array('rgu'=>'mt.restaurant_group_users'), 'rgu.rguid=bok.bok_contactid', array('rguspecial_request'))				                                       
                                    ->order(array('bokid desc')); 
                       
                        if($restObj->getRestaurantname() || $restObj->getRestbokid() || $restObj->getCusfirstName() || $restObj->getCuslastName()|| $restObj->getStartDate() || $restObj->getEndDate())
                        {                          
                        if($restObj->getRestaurantname()){
				$select->where('rest.resrestaurant_name Ilike ?','%'.trim($restObj->getRestaurantname()).'%');
			}
                        if($restObj->getRestbokid()){
                            $select->where('bok.bokid = ?',$restObj->getRestbokid());                            
                        }
                        if($restObj->getCusfirstName()){
                            $select->where('bok.bokfirst_name Ilike ?','%'.trim($restObj->getCusfirstName()). '%');
                        }
                        if($restObj->getCuslastName()){
                            $select->where('bok.boklast_name Ilike ?','%'.trim($restObj->getCuslastName()). '%');                            
                        }

                        if($restObj->getStartDate() && $restObj->getEndDate()){                                                               
				$select->where('bok.bokbooking_date >= ?',$restObj->getStartDate());
				$select->where('bok.bokbooking_date <= ?',$restObj->getEndDate());                                  
			}                                                
//                        if($restObj->getRestCity()){
//				$select->where('city.id = ?',$restObj->getRestCity());                                
//			}  
                        }
                        else
                        {                                                      
                            $select->where('bok.bokbooking_date = ?', date("Y-m-d"));
                        }
                        $result = "";                        
                        if($page!=null)
                        {
			$result = new Zend_Paginator(
				new Zend_Paginator_Adapter_DbTableSelect($select));
				$result->setItemCountPerPage($limit);
				$result->setCurrentPageNumber($page);
                        }
                        else
                        {
                            $result = $table->fetchAll($select);
                        }                                
			return $result;            
            }
            catch(Exception $ex)
            {
                throw new Exception($ex->getMessage()) ;
            }                        
        }	
	public function AdminReport(FirmManagement_Model_FirmSearch $restObj,$resids)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			
			$bokMapper = new Reservation_Model_ReservationDataMapper();
			$bokTable = $bokMapper->getDbTable();
			$bokTableSelect = $bokTable->select(); 
			$bokTableSelect->from($bokTable,array('bokid','bokfk_restaurant','bokbooking_status_id','bokreservation_mode_id','bokparty_size','bokbooking_date'));
			
			$resownTableMapper = new User_Model_ManagerDataMapper();
			$resownTable       = $resownTableMapper->getDbTable();
			$resownTableSelect = $resownTable->select(); 
			$resownTableSelect->from($resownTable,array('rsofirst_name','rsolast_name','rsofk_user'));
			
			$regTableMapper = new Application_Model_RegionDataMapper();
			$regTable       = $regTableMapper->getDbTable();
			$regTableSelect = $regTable->select(); 
			$regTableSelect->from($regTable,array('id','code','description'))
						   ->where('status = ?',true);
						   
			$cityTableMapper = new Application_Model_CityDataMapper();
			$cityTable       = $cityTableMapper->getDbTable();
			$cityTableSelect = $cityTable->select(); 
			$cityTableSelect->from($cityTable,array('id','code','description'))
						   ->where('status = ?',true);
						   
			$resappTableMapper = new Application_Model_RestaurantApprovalStatusDataMapper();
			$resappTable       = $resappTableMapper->getDbTable();
			$resappTableSelect = $resappTable->select(); 
			$resappTableSelect->from($resappTable,array('id','code','description'));
			
			$select->from(array('rest'=>'mt.restaurant'),array('resid','resrestaurant_name','respaymentstatus','restcreatedon'))
				   ->joinLeft(array('bok'=>$bokTableSelect),'rest.resid = bok.bokfk_restaurant',array('count(bokid) as count','bokbooking_status_id as status','bokreservation_mode_id as modes','bokparty_size'))
				   ->joinLeft(array('resown'=>$resownTableSelect),'rest.resfk_user = resown.rsofk_user',array('rsofirst_name','rsolast_name'))
				   ->joinLeft(array('reg'=>$regTableSelect),'rest.resregion_id = reg.id',array('description as region'))
				   ->joinLeft(array('city'=>$cityTableSelect),'rest.rescity_id = city.id',array('description as city'))
				   ->joinLeft(array('resapp'=>$resappTableSelect),'rest.resapprovalstatus = resapp.id',array('description as appstatus'))
				   ->where('rest.resstatus != ?',3);
			if($restObj->getRestCategory()){
				$select->where('rest.rescategory_id = ?',$restObj->getRestCategory());
			}
			if($restObj->getRestaurantname()){
				$select->where('rest.resrestaurant_name Ilike ?','%'.trim($restObj->getRestaurantname()).'%');
			}
			if($restObj->getRestRegion()){
				$select->where('rest.resregion_id = ?',$restObj->getRestRegion());
			}
			if($restObj->getRestCity()){
				$select->where('rest.rescity_id = ?',$restObj->getRestCity());
			}
			if($restObj->getStartDate() && $restObj->getEndDate()){
				$select->where('bok.bokbooking_date >= ?',$restObj->getStartDate());
				$select->where('bok.bokbooking_date <= ?',$restObj->getEndDate());
			}	
			if($resids){
				$select->where('rest.resid IN(?)',$resids);
			}
			$storage = new Zend_Auth_Storage_Session();
			$loginProf = $storage->read();
			$select->where('rest.res_companyid = ?',$loginProf['companyid']);
			$select->group(array('bok.bokbooking_status_id','rest.resid','rest.rescategory_id','rest.resrestaurant_name','rest.respaymentstatus','rest.restcreatedon','resown.rsofirst_name','resown.rsolast_name','reg.description','city.description','resapp.description','bok.bokreservation_mode_id','bok.bokparty_size'))
				   ->order(array('rest.resid'));;
			$rowset = $table->fetchAll($select);
			$resArr = array();
			$statusArr = array();
			$modeArr = array();
			$payment = "";
			foreach($rowset as $row){
				if(array_key_exists($row->resid,$resArr)){
					$resArr[$row->resid]['finalcount'] = $resArr[$row->resid]['finalcount']+$row->count;
					$resArr[$row->resid]['totalpax'] = $resArr[$row->resid]['totalpax']+($row->count * $row->bokparty_size);
					$statusArr = $resArr[$row->resid]['statcount'];
					if(array_key_exists($row->status,$statusArr)){
						if($row->status == '15' || $row->status == '16' || $row->status == '17' || $row->status == '18' || $row->status == '19' || $row->status == '20'){
							$statusArr['15'] = $statusArr['15']+ $row->count;
						}else{
							$statusArr[$row->status] = $statusArr[$row->status]+ $row->count;
						}
					}else{
						if($row->status == '15' || $row->status == '16' || $row->status == '17' || $row->status == '18' || $row->status == '19' || $row->status == '20'){
							$statusArr['15'] = $statusArr['15']+ $row->count;
						}else{
							$statusArr[$row->status] = $row->count;
						}
					}
					$resArr[$row->resid]['statcount'] = $statusArr;
					$modeArr = $resArr[$row->resid]['modecount'];
					if(array_key_exists($row->modes,$modeArr)){
						 $modeArr[$row->modes] = $modeArr[$row->modes]+ $row->count;
					}else{
						$modeArr[$row->modes] = $row->count;
					}               
					$resArr[$row->resid]['modecount'] = $modeArr;
				}else{
					$statusArr = array('10'=>0,'5'=>0,'3'=>0,'8'=>0,'22'=>0,'4'=>0,'9'=>0,'7'=>0,'6'=>0,'11'=>0,'12'=>0,'14'=>0,'15'=>0);
					if($row->status){
						if($row->status == '15' || $row->status == '16' || $row->status == '17' || $row->status == '18' || $row->status == '19' || $row->status == '20'){
							$statusArr['15'] = $row->count;
						}else{
							$statusArr[$row->status] = $row->count;
						}
					}
					$modeArr = array('1'=>0,'2'=>0,'6'=>0);
					if($row->modes){
						$modeArr[$row->modes] = $row->count;
					} 
					if($row->respaymentstatus){
						$payment = 'Done';
					}else{
						$payment = 'Pending';
					}
					$resArr[$row->resid] = array('resname'=>$row->resrestaurant_name,'createDate'=>$row->restcreatedon,'firstname'=>$row->rsofirst_name,'lastname'=>$row->rsolast_name,'city'=>$row->city,'region'=>$row->region,'appstatus'=>$row->appstatus,'respaymentstatus'=>$payment,'statcount'=>$statusArr,'modecount'=>$modeArr,'finalcount'=>$row->count,'totalpax'=>($row->count * $row->bokparty_size));
				}
			}
			return $resArr;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function UpdateBookingOptionsSetting($restid,$optionsetting)
	{
		try{
			$table = $this->getDbTable();
			$set   = array('resbookingoption_setting'=>$optionsetting);
			$where = array('resid = ?'=>$restid);
			$status = $table->update($set,$where);
			return 	$status;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetBookingOptionsSetting($restid)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('resbookingoption_setting'))
				   ->where('resid = ?',$restid);				   
			$row = $table->fetchRow($select);			
			return $row;
							   
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getRestaurantTimeSearchMessage($restid)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('resbooking_search_msg'))
				   ->where('resid = ?',$restid);				   
			$row = $table->fetchRow($select);			
			return $row;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function FirmManagementTimeSearchMessage($restid,$msg)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();
			$set = array('resbooking_search_msg'	=>	$msg);
			$where = array('resid = ?'=>$restid);				   
			$row = $table->update($set,$where);			
			return $row;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function GetRestaurantTableDataByOwnerId($userid)
	{
		try{
			$resttable = $this->getDbTable();
			$selectRest = $resttable->select();
			$selectRest->setIntegrityCheck(false);

			$selectRest->from(array('rest'=>'mt.restaurant'),
								array('resid',
									  'resfk_user',
									  'resrestaurant_name',
								 	  'restcapacity',
									  'reslogo',
									  'resimage',
									  'resemail',
								      'resyear_founded',
									  'resprice',
									  'res_no_of_floors',
									  'resaddress',
									  'rescity_id',
									  'resstate_id',
									  'reslocation',
									  'resneighborhood_id',
									  'reszipcode',
									  'resphone',
									  'resfax',
									  'restimezone',
									  'reswebsite',
									  'resmanager_name',
									  'resdescription',
									  'resdiningstyle',
									  'resadditionaldetails',
									  'resparking',
									  'resparkingdetails',
									  'resprivateparty',
									  'resprivatepartycontact',
									  'resentertainment',
									  'resmaxpax',
									  'resreservation_system',
								      'resschestatus',
									  'resfloorplanstatus',
									  'resstatus',
									  'resapprovalstatus',
									  'reslatitude',
									  'reslongitude',
									  'resgooglemapstatus',
									  'resgoogleimage',
									  'resrestaurant_timings',
									  'restcreatedon',
									  'rescreatedby',
									  'rescreateddatetime',
									  'resupdatedby',
									  'resupdateddatetime',
									  'resexecutivechef',
									  'resdresscode',
									  'resacceptwalkin',
									  'respublictransit',
									  'resspleventsandpromotions',
									  'rescrossstreet',
									  'resmenu',
									  'rescategory_id',
									  'reslisted_restaurant_id',
									  'resorigin_id',
									  'resreserv',
									  'resnotification',
									  'respaymentstatus',
									  'resregion_id',
									  'resphonenotify',
									  'ressmsnotify',
									  'resminpax',
									  'resspecialsetting',
									  'rescampaign_status',
									  'resbookingoption_setting',
									  'resspecial_request',
										'resbooking_search_msg',
										'res_companyid',
										'res_sch_setting_id',
										'res_payment_mode',
										'reslandmark',
										'resavg_mealprice_max',
										'resavg_mealprice_min',
										'res_delevery',
										'reslunch_buffet',
										'resdinner_buffet',
										'res_wifi',
										'res_alcohol',
										'res_smoking',
										'res_ac',
										'res_party_allowed',
										'res_catering',
										'res_kids_section',
										'res_category',
										'res_meal_category',
										'resotp_setting',
										'resfacebook_id',
										'res_countrycode',
										'ressettingstatus',))
						->join(array('neigh'=>'mt.neighborhood_bd'),'neigh.id = rest.resneighborhood_id',array('description as neighbor'))
						->join(array('city'=>'mt.city_bd'),'city.id = rest.rescity_id',array('description as city'))
						->joinLeft(array('region'=>'mt.region_bd'),'region.id = rest.resregion_id',array('description as region'))
						->join(array('state'=>'mt.state_bd'),'state.id = rest.resstate_id',array('description as state'))
						->join(array('restatus'=>'mt.restaurant_status_bd'),'restatus.id = rest.resstatus',array('code as rescode'))
						->join(array('apptatus'=>'mt.restaurant_approval_status_bd'),'apptatus.id = rest.resapprovalstatus',array('code as appcode'))
						->joinLeft(array('time'=>'mt.timezone_bd'),'time.country_id = rest.resid',array('id','code','description','status','country_id'))
						->joinLeft(array('usr'=>'mt.restaurant_overbooked_password'),'ropfk_restaurant = resid',array('resroppassphrase'=>'roppassphrase', 'resroppassword'=>'roppassword'))
						->where('rest.resfk_user = ?',$userid)
						->where('rest.resapprovalstatus = ?', 1);
			
			$result = $resttable->fetchAll($selectRest);
			$mainArr = array();
			foreach($result as $key=>$value){
				$subArr = array();
				foreach($value as  $key1=>$value1){
					if($key1 == 'rescreatedby' || $key1 == 'resupdatedby'){
						$subArr[$key1]= null;
					}else{
						$subArr[$key1]= $value1;
					}
				}
				$mainArr[$subArr['resid']] = $subArr;
			}
			return $mainArr;					   
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetCuisineTableDataByRestaurantId($resids)
	{
		try{
			$resultArr = array();
			$cuisinemapper = new FirmManagement_Model_FirmCuisineDataMapper();
			$restcuisinetable = $cuisinemapper->getDbTable();
			$selectRestCuisine = $restcuisinetable->select();
			$selectRestCuisine->from(array('mt.restaurant_cuisine'),array('rscid','rcsfk_restaurant','rscfk_restauranttype_id'))
							  ->where('rcsfk_restaurant IN(?)',$resids)
							  ->order('rcsfk_restaurant DESC');
			$rowset = $restcuisinetable->fetchAll($selectRestCuisine);
			foreach($rowset as $row){
				$resultArr[$row->rcsfk_restaurant] = array('rscid'=>$row->rscid,'rcsfk_restaurant'=>$row->rcsfk_restaurant,'rscfk_restauranttype_id'=>$row->rscfk_restauranttype_id);
			}
			return $resultArr;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetPaymentOptionsTableDataByRestaurantId($resids)
	{
		try{
			$resultArr = array();
			$paymentoptionmapper = new FirmManagement_Model_FirmPaymentOptionsDataMapper;
			$paymentoptiontable = $paymentoptionmapper->getDbTable();
			$selectpaymentoption = $paymentoptiontable->select();
			$selectpaymentoption->from(array('mt.restaurant_payment_options'),array('rpoid','rpofk_restaurant','rpofk_restaurant_payment_type_id'))
							  ->where('rpofk_restaurant IN(?)',$resids)
							  ->order('rpofk_restaurant DESC');
			$rowset = $paymentoptiontable->fetchAll($selectpaymentoption);
			$prevresid = "";
			foreach($rowset as $row){
				if($prevresid == ""){
					$subArr = array();
					$prevresid = $row->rpofk_restaurant;
					$subArr[] = array('rpoid'=>$row->rpoid,'rpofk_restaurant'=>$row->rpofk_restaurant,'rpofk_restaurant_payment_type_id'=>$row->rpofk_restaurant_payment_type_id);
				}else if($prevresid == $row->rpofk_restaurant){
					$subArr[] = array('rpoid'=>$row->rpoid,'rpofk_restaurant'=>$row->rpofk_restaurant,'rpofk_restaurant_payment_type_id'=>$row->rpofk_restaurant_payment_type_id);
				}else{
					$resultArr[$prevresid] = $subArr;
					$prevresid = $row->rpofk_restaurant;
					$subArr = array();
					$subArr[] = array('rpoid'=>$row->rpoid,'rpofk_restaurant'=>$row->rpofk_restaurant,'rpofk_restaurant_payment_type_id'=>$row->rpofk_restaurant_payment_type_id);
				}
			}
			$resultArr[$prevresid] = $subArr;
			return $resultArr;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function RestEmailAddress($restId)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('resemail','resphonenotify','ressmsnotify','resnotification'))
				   ->where('resid = ?',$restId);	   
			$result = $table->fetchRow($select);
			$resultArr = array(
								'resemail' => $result['resemail'],
								'resnotification' => $result['resnotification'],	
								'resphonenotify' => $result['resphonenotify'],
								'ressmsnotify' => $result['ressmsnotify'],
								'resid'		   => $restId				
							);
			return $resultArr;		
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function getGeographicalInformationByrestIds($restIds)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('resstate_id','resregion_id','rescity_id','resneighborhood_id'))
				   ->where('resid IN (?)',$restIds);	   
			$rowset = $table->fetchAll($select);
			$resultArr = array();
			$stateArr = array();
			$regionArr = array();
			$cityArr = array();
			$neighArr = array();
			foreach($rowset as $row){
				if (!in_array($row->resstate_id,$stateArr)){
					$stateArr[] = $row->resstate_id;
				}
				if (!in_array($row->resregion_id,$regionArr)){
					$regionArr[] = $row->resregion_id;
				}
				if (!in_array($row->rescity_id,$cityArr)){
					$cityArr[] = $row->rescity_id;
				}
				if (!in_array($row->resneighborhood_id,$neighArr)){
					$neighArr[] = $row->resneighborhood_id;
				}
			}
			$resultArr = array(
							'stateIds' 		=> 	$stateArr,
							'regionIds'		=> 	$regionArr,
							'cityIds' 		=> 	$cityArr,
							'neighborIds' 	=> 	$neighArr
						);
			return $resultArr;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetRestIdByPhrase($phrase)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('resid'))
				   ->where('resphrase = ?',$phrase);	   
			$result = $table->fetchRow($select);
			return $result->resid;		
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetRestPhraseById($id)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('resphrase'))
				   ->where('resid = ?',$id);	   
			$result = $table->fetchRow($select);
			return $result->resphrase;		
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function AuthenticateRestByAuth(FirmManagement_Model_FirmNamesByOwnerId $restaurantnames,$data)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			$select->from($table,array('resid'));
			if($data['Usertype'] == 'RSO' || $data['Usertype'] == 'ADM' || $data['Usertype'] == 'ADU'){
				$select->where('resfk_user = ?',$restaurantnames->getRestOwnerId());	
			}else if($data['Usertype'] == 'RSU'){
				$select->join(array('mt.restaurant_user'), 'resid = rsufk_restaurant', array('rsuid'));
				$select->where('rsufk_user = ?',$restaurantnames->getRestOwnerId());
			}else if($data['Usertype'] == "SRU"){
				$select->join(array('mt.restaurant_user'), 'resid = rsufk_restaurant', array('rsuid'));
				$select->join(array('mt.restaurant_super_user'), 'rsu_rsu_fk_user = rsufk_user', array('rsu_rsuid'));
				
				$select->where('rsufk_user = ?',$restaurantnames->getRestOwnerId());
			}
			$select->where('resid = ?',$restaurantnames->getRestId());
			$select->where('resstatus = ?',1);

			$resultset =  $table->fetchRow($select);
			if($resultset){
				return $resultset->resid;
			}else{
				return false;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getRestaurntOwnerDetailsByAdmin(FirmManagement_Model_FirmByOwnerId $ownerDet)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->setIntegrityCheck(false);
			$select->from(array('rest'=>'mt.restaurant'),array('resfk_user','resid','resrestaurant_name'))
					->join(array('restowner'=>'mt.restaurant_owner'),'restowner.rsofk_user = rest.resfk_user',array('rsofirst_name','rsolast_name','rsophone'))
					->join(array('ownername'=>'mt.user'),'ownername.usrid = rest.resfk_user',array('usremail'))
					->where('rest.resfk_user = ?',$ownerDet->getResOwnerId());
			$resultSet = $this->getDbTable()->fetchRow($select);
			$ownerList = '';
//			foreach($resultSet as $result){
				$ownerObj = new FirmManagement_Model_Owner();

				$ownerObj->setRestUser($resultSet->resfk_user)
						->setRestId($resultSet->resid)
						->setOwnerFirstName($resultSet->rsofirst_name)
						->setOwnerLastName($resultSet->rsolast_name)
						->setOwnerEmail($resultSet->usremail)
						->setRestaurantName($resultSet->resrestaurant_name)
						->setOwnerPhone($resultSet->rsophone);

//				$ownerList = $ownerObj;
//			}
			return $ownerObj;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function updateGoogleImage(FirmManagement_Model_Firm $restaurant)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();
			$set = array('reslatitude'			 => $restaurant->getRestLatitude(),
						'reslongitude'			 => $restaurant->getRestLongitude(),
						'resgooglemapstatus'	 => $restaurant->getRestGoogleMapStatus(),
						'resgoogleimage'		 => $restaurant->getRestGoogleImage());
			$where = array('resid = ?'=>$restaurant->getId());				   
			$row = $table->update($set,$where);			
			return $row;			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getScheduleSettingTypeByresId($restid)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->setIntegrityCheck(false);
			$select->from(array('rest'=>'mt.restaurant'),array('res_sch_setting_id'))
					->join(array('schsetting'=>'mt.schedulesetting_bd'),'schsetting.id = rest.res_sch_setting_id',array('code','description'))
					->where('rest.resid = ?',$restid);
			$rowset = $this->getDbTable()->fetchRow($select);
			$resultArr = array();
			
			$resultArr['settingType'] = $rowset->code;
			$resultArr['settingId'] = $rowset->res_sch_setting_id;
			
			return $resultArr;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
		//retriving schedule settings 
	public function GetScheduleSettingByid($resid)
	{
		try
		{
			$select = $this->getDbTable()->select();
			$select->setIntegrityCheck(false);
			$select->from(array('rest'=>'mt.restaurant'),array('res_sch_setting_id'))
					->join(array('restsch'=>'mt.schedulesetting_bd'),'restsch.id = rest.res_sch_setting_id',array('code','description'))
					->where('rest.resid = ?',$resid);
			$resultSet = $this->getDbTable()->fetchRow($select);
			return $resultSet;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	//update schedule setting id by restaurant id in restaurant table
	public function UpdateScheduleSetting($resid,$scheduleid)
	{
		try{
			$table = $this->getDbTable();
			$set   = array('res_sch_setting_id'=>$scheduleid);
			$where = array('resid = ?'=>$resid);
			$status = $table->update($set,$where);
			return 	$status;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	//update payment mode id by restaurant id in restaurant table
	public function UpdatePaymentMode(Administrator_Model_RestaurantManualPaymentDetails $resid,$paymodeid)
	{
		try{
			$table = $this->getDbTable();
			$set   = array('res_payment_mode'=>$paymodeid);
			$where = array('resid = ?'=>$resid->getResId());
			$status = $table->update($set,$where);
			return 	$status;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetRestaurantOwnerEmailid($resid)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->setIntegrityCheck(false);
			$select->from(array('rest'=>'mt.restaurant'),array('resemail'))
					->where('rest.resid = ?',$resid);
			$resultSet = $this->getDbTable()->fetchRow($select);
			return $resultSet;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}	
	
	public function getOwnerCountrycodebyId($resid)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			$select->from($table,array())
				   ->join(array('mt.restaurant_owner'),'rsofk_user = resfk_user',array('rsocountrycode'))
				   ->where('resid = ?',$resid);				   
			$row = $table->fetchRow($select);			
			return $row->rsocountrycode;
							   
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function GetRestaurantfirstresid($resid)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();			
			$select->from($table,array('resid'))
				   ->where('resfk_user = ?',$resid) ;   
			$row = $table->fetchRow($select);
			$restid = $row->resid;
			return $restid;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getCountrycodebyId($resid)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			$select->from($table,array('res_countrycode'))
				   ->join(array('mt.restaurant_owner'),'rsofk_user = resfk_user',array('rsocountrycode'))
				   ->where('resid = ?',$resid);				   
			$row = $table->fetchRow($select);	
			if($row->res_countrycode){
				return $row->res_countrycode;
			}else{		
				return $row->rsocountrycode;
			}
							   
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	
	public function GetSettingStatusbyResid($resid)
	{
		try{
			$table = $this->getDbTable();			
			$select = $table->select();			
			$select->from($table,array('ressettingstatus'))
				   ->where('resid = ?',$resid) ;   
			$row = $table->fetchRow($select);
			if($row['ressettingstatus']){
				return false;
			}else{
				$set   = array('ressettingstatus'=>true);
				$where = array('resid = ?'=>$resid);
				$status = $table->update($set,$where);
				return 	true;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getImagePathById($resid)
	{
		try{
			$table = $this->getDbTable();
			$query= $table->select();
			$query->from(array('rsp'=>'mt.restaurant'),array('resimage'))
				  ->where('resid = ?',$resid);
		    $resultSet = $table->fetchRow($query);
		 //   $result = array('dbimpagepath'=> $resultSet);
		    return $resultSet; 
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	
	public function SmsBackgroundCall()
	{
		try{
			$table = $this->getDbTable();
			$query= $table->select();
			$query->from(array('mt.restaurant'),array('resid'))
				  ->where('resapprovalstatus = ?',1);
		    $resultSet = $table->fetchAll($query);   
		    $resSubscriptMapper = new FirmManagement_Model_SmsRestaurantSubscriptionDataMapper();
		    $resSubscript = $resSubscriptMapper->getDbTable();		    
			
		    $resCampCountMapper = new FirmManagement_Model_SmsRestaurantCampCountDataMapper();
		    $resCampCount = $resCampCountMapper->getDbTable();		   
		    
			foreach($resultSet as $row){
				$status = false;
				$result = null;
				$timeZone = $this->GetRestaurantTimeZone($row->resid);		
				date_default_timezone_set($timeZone);
				$date = date('M Y');	
				$select = $resSubscript->select();				
				$select->from($resSubscript,array('subcamp_resid'));		
				$select->where('subcamp_resid = ?',$row->resid);
				$select->where('subcamp_currentmonth  = ?',$date);
				$select->where('subcamp_credit_type  = ?','Free');
				
				$result = $resSubscript->fetchRow($select);	
				if(!$result){
					$data = array('subcamp_resid' 				=>	$row->resid,
								  'subcamp_createddatetime' 	=>	date("Y-m-d H:i:s"),
								  'subcamp_credit_type' 		=>	'Free',
								  'subcamp_totalcredits'		=>	1000,
								  'subcamp_currentmonth'		=>	$date
					);
					$status = $resSubscript->insert($data);	
				}
				if($status){
					$countselect = $resCampCount->select();	
					$countselect->from($resCampCount,array('rescamp_resid','rescamp_totalsms','rescamp_usedsms'));
					$countselect->where('rescamp_resid = ?',$row->resid);
					$camprow = $resCampCount->fetchRow($countselect);	
					if(!$camprow){
						$data = array('rescamp_resid' 				=>	$row->resid,
									  'rescamp_createddatetime' 	=>	date("Y-m-d H:i:s"),
									  'rescamp_totalsms'			=>	1000,
									  'rescamp_usedsms'				=>	0
						);
						$campstatus = $resCampCount->insert($data);	
					}else{
						$set = array('rescamp_updateddatetime' 	=>  date("Y-m-d H:i:s"),
									 'rescamp_totalsms'			=>	1000,
									 'rescamp_usedsms'			=>	0
						);
						$where = array('rescamp_resid = ?'=>$row->resid);
						$campupdatestatus = $resCampCount->update($set,$where);
						$subset = array('subcamp_usedcredits' 		=>	$camprow->rescamp_usedsms,
									  'subcamp_updateddatetime' 	=>	date("Y-m-d H:i:s")
						);
						$subwhere = array('subcamp_resid = ?'=>$row->resid,'subcamp_currentmonth = ?' =>date('M Y', strtotime(date('Y-m')." -1 month")));
						$campupdatestatus = $resSubscript->update($subset,$subwhere);
						
					}
				}				
			}
		    return true; 
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getRestaurantDetailsbyrestIdAPI($restId)
	{
		try{
			$resttable = $this->getDbTable();

			$cuisinemapper = new FirmManagement_Model_FirmCuisineDataMapper();

			$restcuisinetable = $cuisinemapper->getDbTable();
			$paymentmapper = new FirmManagement_Model_FirmPaymentOptionsDataMapper();
			$selectResttable = $paymentmapper->getDbTable();
			$selectRestPayment = $selectResttable->select();
			$selectRest = $resttable->select();

			$selectRestCuisine = $restcuisinetable->select();
			$selectRest->setIntegrityCheck(false);

			/* Reteriving Restaurant Details */
			$selectRest->from(array('rest'=>'mt.restaurant'),
								 array('resid as restaurantid',
									   'resrestaurant_name as restaurantname',
								 	   'restcapacity as capacity',
									   'reslogo as logo',
									   'resimage as image',
									   'resemail as email',
									   'resprice as price',
									   'resaddress as address',
									   'reszipcode as zipcode',
									   'resphone as phone',
									   'resfax as fax',
									   'restimezone as timezone',
									   'reswebsite as website',
									   'resmanager_name as managername',
									   'resdescription as description',
									   'resdiningstyle as diningstyle',
									   'resadditionaldetails as additionaldetails',
									   'resparking as parking',
									   'resparkingdetails as parkingdetails',
									   'resprivateparty as privateparty ',
									   'resprivatepartycontact as privatepartycontact',
									   'resentertainment as entertainment',
									   'resreservation_system as reservationsystem',
									   'resmaxpax as maxpartysize',
									   'resschestatus as schedulestatus',
									   'resfloorplanstatus as floorplanstatus',
									   'resgooglemapstatus as googleimagestatus',
									   'resgoogleimage as googleimage',
									   'reslatitude as latitude',
									   'reslongitude as longitude',
									   'resrestaurant_timings as timings',
									   'resexecutivechef as executivechef',
									   'resdresscode as dresscode',
									   'resacceptwalkin as acceptwalkin',
									   'respublictransit as publictransit',
									   'resspleventsandpromotions as spleventsandpromotions',
									   'rescrossstreet as crossstreet',
									   'resmenu as menu',
									   'resreserv as reserv',
								 	   'resphonenotify as phonenotify',
								 	   'ressmsnotify as smsnotify',
									   'resminpax as minpartysize'))
						->joinLeft(array('neigh'=>'mt.neighborhood_bd'),'neigh.id = rest.resneighborhood_id',array('description as neighborhood'))
						->joinLeft(array('city'=>'mt.city_bd'),'city.id = rest.rescity_id',array('description as city'))
						->joinLeft(array('region'=>'mt.region_bd'),'region.id = rest.resregion_id',array('description as region'))
						->joinLeft(array('state'=>'mt.state_bd'),'state.id = rest.resstate_id',array('description as state'))
						->join(array('restatus'=>'mt.restaurant_status_bd'),'restatus.id = rest.resstatus',array('description as restaurantstatus'))
						->join(array('apptatus'=>'mt.restaurant_approval_status_bd'),'apptatus.id = rest.resapprovalstatus',array('description as approvalstatus'))
					    ->joinLeft(array('orbd'=>'mt.restaurant_origin_bd'),'orbd.id = rest.resorigin_id',array('description as origin'))
					    ->joinLeft(array('paymode'=>'mt.payment_mode_bd'),'paymode.id = rest.res_payment_mode',array('description as paymentmode'))
					    ->join(array('cmp'=>'mt.company'),'cmp.com_id = rest.res_companyid',array('com_companyname as cpmpanyname'))
						->where('rest.resid = ?',$restId);
						
			$restResult = $resttable->fetchRow($selectRest);
			$finalArr = array();
			if($restResult){
				foreach($restResult as  $key=>$value){
					$finalArr[$key]= $value;
				}
				
				/* Reteriving Restaurant Cuisines */
				$selectRestCuisine->setIntegrityCheck(false);
				$selectRestCuisine->from(array('cuis'=>'mt.restaurant_cuisine'),array('rscid','rscfk_restauranttype_id'))
				->join(array('resttyp'=>'mt.restaurant_type_bd'),'resttyp.id = cuis.rscfk_restauranttype_id',array('code','description'))
				->where('cuis.rcsfk_restaurant = ?',$restId);
				$cuisineResult = $restcuisinetable->fetchAll($selectRestCuisine);
				$restCuisines = array();
				foreach($cuisineResult as $cuisRes){
					$restCuisines[] = $cuisRes->description;
				}
				$finalArr['cusine']= implode(',',$restCuisines);
				$selectRestPayment->setIntegrityCheck(false);
				$selectRestPayment->from(array('pay'=>'mt.restaurant_payment_options'),array('rpoid','rpofk_restaurant_payment_type_id'))
				->join(array('respay'=>'mt.reservation_paymentmode_bd'),'respay.id = pay.rpofk_restaurant_payment_type_id',array('code','description'))
				->where('pay.rpofk_restaurant = ?',$restId);
				$paymentResult = $selectResttable->fetchAll($selectRestPayment);
				$resPayments = array();
				foreach($paymentResult as $payRes){
					$resPayments[] = $payRes->description;
				}
				$finalArr['paymentoptions']= implode(',',$resPayments);
			}
			return $finalArr;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getcompanyIdbyResid($resid)
	{
		try{
			$table = $this->getDbTable();
			$query= $table->select();
			$query->from(array('rsp'=>'mt.restaurant'),array('res_companyid'))
				  ->where('resid = ?',$resid);
		    $resultSet = $table->fetchRow($query);
		    return $resultSet->res_companyid; 
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getcompanyIdbyBookingid($bokid)
	{
		try{
			$table = $this->getDbTable();
			$query = $table->select();
			$query->setIntegrityCheck(false);
			$query->from(array('res'=>'mt.restaurant'),array('res_companyid'))
				  ->join(array('bok'=>'mt.booking'),'bok.bokfk_restaurant = res.resid',array('bokfk_restaurant'))	
				  ->where('bokid = ?',$bokid);
		    $resultSet = $table->fetchRow($query);
		    if($resultSet){
		    	return $resultSet->res_companyid; 
		    }else{
		    	return $resultSet;
		    }
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function retrieveRestCountry($restid)
	{
		try
		{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			$select->from(array('res'=>'mt.restaurant'),array('resid','resstate_id'))
			       ->join(array('st'=>'mt.state_bd'),'st.id = res.resstate_id',array('code','description','currency_code'))
			       ->where('res.resid = ?',$restid);
			       
			$rowset = $table->fetchAll($select);

			$result = array();
			
			foreach($rowset as $row){
				$result['CountryId'] = $row->resstate_id;
				$result['CountryCode'] = $row->code;
				$result['CountryDesc'] = $row->description;
				$result['CountryCurrency'] = $row->currency_code;
			}
			
			return $result;
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function RetrieveFloorPlandAndScheduleStatus($restid)
	{
		try
		{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('resid','resschestatus','resfloorplanstatus'))
				   ->where('resid = ?',$restid);
			$row = $table->fetchRow($select);	
			return $row;   
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetRestaurantTableDataByOwnerIdAndroid($userid)
	{
		try{
			$resttable = $this->getDbTable();
			$selectRest = $resttable->select();
			$selectRest->setIntegrityCheck(false);

			$selectRest->from(array('rest'=>'mt.restaurant'),
								array('resid',
									  'resrestaurant_name',
									  'resimage',									  
									  'resaddress'
									  ))
						->joinLeft(array('mt.state_bd'),'id=resstate_id',array('country_dial_code'))
						->where('rest.resfk_user = ?',$userid)
						->where('rest.resstatus = ?', 1);
			
			$result = $resttable->fetchAll($selectRest);
			$mainArr = array();
			foreach($result as $res){
				$mainArr[] = array('resid' => $res->resid,
								   'resrestaurant_name' => $res->resrestaurant_name,
								   'resimage' => $res->resimage,					
								   'resdial_code'=>$res->country_dial_code,			  
								   'resaddress' => $res->resaddress,
								   'userid' => $userid);
			}
			return $mainArr;					   
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	

	public function GetRestaurantTableDataByRestaurantIdAndroid($resid,$userid)
	{
		try{
			$resttable = $this->getDbTable();
			$selectRest = $resttable->select();
			$selectRest->setIntegrityCheck(false);

			$selectRest->from(array('rest'=>'mt.restaurant'),
								array('resid',
									  'resrestaurant_name',
									  'resimage',									  
									  'resaddress',
									  'resfk_user'
									  ))
						->joinLeft(array('mt.state_bd'),'id=resstate_id',array('country_dial_code'))
						->where('rest.resid = ?',$resid)
						->where('rest.resstatus = ?', 1);
			
			$result = $resttable->fetchAll($selectRest);
			$mainArr = array();
			foreach($result as $res){
				$mainArr[] = array('resid' => $res->resid,
								   'resrestaurant_name' => $res->resrestaurant_name,
								   'resimage' => $res->resimage,					
								   'resdial_code'=>$res->country_dial_code,			  
								   'resaddress' => $res->resaddress,
								   'userid' => $userid);
			}
			return $mainArr;					   
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	


	public function RetrieveRestOwnerIdByRestId($restid)
	{
		try
		{
			$table = $this->getDbTable();
			$select = $table->select();
			
			$select->from($table,array('resfk_user'))
				   ->where('resid = ?' ,$restid);				   
		    $row = $table->fetchRow($select);
		    
		    $userid = $row->resfk_user;
		    
		    return $userid;
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getRestaurantListbyCompanyid($resFilter, $page = null)
	{
		try{
			$limit =12;
			$notifyTableMapper = new FirmManagement_Model_FirmNotifyTimesMapper(); 
			$notifyTableSelect = $notifyTableMapper->getDbTable()->select();
			$notifyTableSelect->from($notifyTableMapper->getDbTable(),array('rntfk_restaurants','array_agg(rntphone) as phoneNo'))
								   ->where('rntnotify_type = ?','sms')
								   ->group(array('rntfk_restaurants'));
				
			$table   =  $this->getDbTable();
			$select  =  $table->select();
			$select    ->setIntegrityCheck(false);
			$select    ->from(array('rest'=>'mt.restaurant'),array('resid','resrestaurant_name','resemail','resphone','resstatus','res_countrycode','res_companyid','resmanager_name'))
			 	   ->join(array('restown'=>'mt.restaurant_owner'),'restown.rsofk_user = rest.resfk_user',array('rsofirst_name','rsolast_name'))
			 	   ->joinLeft(array('region'=>'mt.region_bd'),'region.id = rest.resregion_id',array('description as region'))
				   ->join(array('state'=>'mt.state_bd'),'state.id = rest.resstate_id',array('description as state'))
				   ->joinLeft(array('city'=>'mt.city_bd'),'city.id = rest.rescity_id',array('description as city'))
				   ->join(array('tz'=>'mt.timezone_bd'),'tz.code = rest.restimezone',array('description as TimeZone'))
				   ->joinleft(array('rbd'=>'mt.restaurant_booking_discounts'),'rbd.rd_resid = rest.resid',array('rd_discount_msg','rd_discount_status'))
				   ->joinleft(array('rnt'=>$notifyTableSelect),'rnt.rntfk_restaurants = rest.resid',array('phoneNo'))
				   
				   ->order(array('resid DESC'));
			if($resFilter['CompanyId'] != 1){
				$select->where('res_companyid = ?',$resFilter['CompanyId']);
			}
   	        if(isset($resFilter['restname'])){
				$select->where('rest.resrestaurant_name Ilike ?','%'.trim($resFilter['restname']).'%');
			}
			if(isset($resFilter['restId'])){
				$select->where('rest.resid = ?',$resFilter['restId']);
			}			
			if(isset($resFilter['resCountry']) && $resFilter['resCountry'] != ''){
				$select->where('rest.resstate_id = ?',$resFilter['resCountry']);
			}			
			if(isset($resFilter['resState']) && $resFilter['resState'] != ''){
				$select->where('rest.resregion_id = ?',$resFilter['resState']);
			}
			if(isset($resFilter['resCity']) && $resFilter['resCity'] != ''){
				$select->where('rest.rescity_id = ?',$resFilter['resCity']);
			}
			$select->where('rest.resstatus NOT IN (?) ',array(3,2));
			$select->where('rest.resapprovalstatus NOT IN (?) ',array(3,2));
                        
                        $resultset = "";
                        if($page!=null){
                        $resultset = new Zend_Paginator(
				new Zend_Paginator_Adapter_DbTableSelect($select));
				$resultset->setItemCountPerPage($limit);
				$resultset->setCurrentPageNumber($page);
                        }
                        else
                        {
                            $resultset =  $table->fetchAll($select);
                            
                        }
                        
			return $resultset;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
        
	public function getRestaurantIdByRestaurantName($restname)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('resid'))
				   ->where('resrestaurant_name = ?' ,$restname);				   
		    $row = $table->fetchRow($select);
		    if($row){
		    	return $row->resid;
		    }else{
		    	return 0;
		    }		    
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function checkRestaurantIdValid($restaurantid)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$result = $db->fetchOne("select count(resid) from mt.restaurant where resid = ".$restaurantid);

			if((int)$result)
			{
				$status = true;
			}else{
				$status = false;
			}
			return $status;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}		

	public function getRestNewPostsByRestId($restaurantid)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			$select->from(array('rest'=>'mt.restaurant'),array(''))
				   ->join(array('bsp'=>'mt.business_social_posts'),'bsp.rsp_fk_business = rest.resid',array('rsp_description','rsp_post_created_at'))
				   ->where('bsp.rsp_fk_business = ?',$restaurantid)
				   ->where('rsp_type = ?', 'post')
				   ->order('bsp.rsp_id DESC');
			$result1 = $table->fetchAll($select); 
			  
			$select = $table->select();
			$select->setIntegrityCheck(false);
			$select->from(array('rest'=>'mt.restaurant'),array(''))
				   ->joinleft(array('scamp'=>'mt.sms_campaigns'),'scamp.smscamp_resid = rest.resid',array('smscamp_id','smscamp_title','smscamp_msg','smscamp_createddatetime'))
				   ->where('scamp.smscamp_resid = ?',$restaurantid)
				   ->order('scamp.smscamp_id DESC');
			$result2 = $table->fetchAll($select); 
			$resultSet = array('result1' => $result1,'result2' => $result2);
			return $resultSet; 	     
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function SaveReservationDiscount($request)
	 {
		try{
			$resid = $request->resid;
			$msg = $request->discountmsg;
			$status = $request->status;
			$timeZone = $this->GetRestaurantTimeZone($resid);		
			date_default_timezone_set($timeZone);
			$resDiscountMapper = new FirmManagement_Model_FirmReservationDiscountDataMapper();
		    $resDiscountTable = $resDiscountMapper->getDbTable();
			$select = $resDiscountTable->select();
			$select->from(array('rd'=>'mt.restaurant_booking_discounts'),array('rd_resid'))
					->where('rd.rd_resid = ?',$resid);
			$rowset = $resDiscountTable->fetchRow($select);
			if(!$rowset){
				$data = array('rd_resid' 					=>	$resid,
							  'rd_createddatetime' 			=>	date("Y-m-d H:i:s"),
							  'rd_discount_msg'				=>	$msg,
							  'rd_discount_status'			=>	$status
				);
				$discountstatus = $resDiscountTable->insert($data);	
				$discstatus = 'insert';
			}else{
				$set = array('rd_updateddatetime' 	=>  date("Y-m-d H:i:s"),
							 'rd_discount_msg'		=>	$msg,
						     'rd_discount_status'	=>	$status				
				);
				$where = array('rd_resid = ?'=> $resid);
				$discountstatus = $resDiscountTable->update($set,$where);
				$discstatus = 'update';
			}
			if($discstatus){
				return $discstatus;
			}else{
				return false;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function Getdiscountstatus($resid)
	{
		try{
			$resDiscountMapper = new FirmManagement_Model_FirmReservationDiscountDataMapper();
		    $resDiscountTable = $resDiscountMapper->getDbTable();
			$select = $resDiscountTable->select();
			$select->from(array('rd'=>'mt.restaurant_booking_discounts'),array('rd_resid','rd_discount_msg','rd_discount_status'))
					->where('rd.rd_resid = ?',$resid);
			$rowset = $resDiscountTable->fetchRow($select);
			if($rowset){
				$result = array();
				$result['status'] =	 $rowset->rd_discount_status;
				$result['msg'] 	  =	 $rowset->rd_discount_msg;
				return $result;						
			}else{
				return false;
			}			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getFeedbackEmailsOfRestaurant()
	{
		try{
			$feedbackEmailMapper = new FirmManagement_Model_FirmEmailsDataMapper();
			$feedbackEmailTable     = $feedbackEmailMapper->getDbTable();
			$feedbackEmailSelect = $feedbackEmailTable->select(); 
			$feedbackEmailSelect->setIntegrityCheck(false);
			$feedbackEmailSelect->from(array('mt.restaurant_emails'),array('resefk_restaurantid','array_agg(rese_email) as emails'))
							 	->where('rese_email_status_id = ?', 1)
							 	->where('feedback_email  = ?', 'feedback')
							 	->group('resefk_restaurantid');
							  
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			$select->from(array('rest' =>'mt.restaurant'),array('resid','resemail','resrestaurant_name'))
				   ->joinleft(array('restemail'=>$feedbackEmailSelect),'restemail.resefk_restaurantid = rest.resid',array('emails'))
				   ->where('rest.resstatus = ?',1)
                                    ->where('res_companyid = ?',1)
				   ->where('rest.resapprovalstatus = ?',1)
				   ->where('rest.resfeedbacknotf = ?', true)
				   ->order('rest.resid');  
			$rows = $table->fetchAll($select);
			$resultArr = array();
			foreach($rows as $value){
				$emailString = substr($value->emails, 1, -1);
				if($emailString){
					$emailAddresses = $value->resemail.','.substr($value->emails, 1, -1);
				}else{
					$emailAddresses = $value->resemail;
				}
				$EmailArr = explode(",",$emailAddresses);
		//		$restArr[$value->resid.'-'.$value->resrestaurant_name] = $EmailArr;
				$restArr[$value->resid] = $EmailArr;
				$resName[$value->resid] =  $value->resrestaurant_name;
			}
			$result = array('feedbackEmails'=>$restArr,'resName'=>$resName);
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetFeedbackEmailStatusById($restaurantid)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->from(array('mt.restaurant'),array('resemail','resfeedbacknotf','resfeedbacksmsnotf'))
					   ->where('resid = ?',$restaurantid);
					   	
			$restResult = $table->fetchRow($select);
			$result['email'] = $restResult->resemail;
			$result['resfeedbacknotf'] = $restResult->resfeedbacknotf;
			$result['resfeedbacksmsnotf'] = $restResult->resfeedbacksmsnotf;
			if($result){
				return $result;
			}else{
				return false;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function ManageRestFeedbackNotifyStatus($resid, $status, $type)	
	{
		try{
			$table = $this->getDbTable();
			if($type == 'sms'){
				$set   = array('resfeedbacksmsnotf'=>$status);
			}else if($type == 'email'){
				$set   = array('resfeedbacknotf'=>$status);
			}
			$where = array('resid = ?'=>$resid);
			$status = $table->update($set,$where);
			if($status){
				return $status;
			}else{
				return 	false;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}		
	}
	
	public function GetRestListByOwnerId($userid)
	{		
		try
		{			
			$table = $this->getDbTable();
			$select = $table->select();
			
			$select->from($table,array('resid'))
			       ->where('resfk_user = ?',$userid)
			       ->where('resstatus = ?',1)
			       ->where('resapprovalstatus = ?',1);
			       
			$rowSet =  $table->fetchAll($select);    
			$restIdList = array();
			if($rowSet)
			{
				foreach($rowSet as $row)
				{
					$restIdList[] = $row->resid;
				}				
			}			
			return $restIdList;
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}


	/**
	 * ADD SMS CREDITS TO SPECIFIC RESTAURANTS
	 */
	public function addSMSCreditsByResId($resid,$numberOfCredits)
	{
		try{
			$table = $this->getDbTable();
			$query= $table->select();
			$query->from(array('mt.restaurant'),array('resid'))
				->where('resid = ?',$resid)
				  ->where('resapprovalstatus = ?',1);
		    $resultSet = $table->fetchAll($query);   
		    $resSubscriptMapper = new FirmManagement_Model_SmsRestaurantSubscriptionDataMapper();
		    $resSubscript = $resSubscriptMapper->getDbTable();		    
			
		    $resCampCountMapper = new FirmManagement_Model_SmsRestaurantCampCountDataMapper();
		    $resCampCount = $resCampCountMapper->getDbTable();		   
		    
			foreach($resultSet as $row){
				$status = false;
				$result = null;
				$timeZone = $this->GetRestaurantTimeZone($row->resid);		
				date_default_timezone_set($timeZone);
				$date = date('M Y');	
				$select = $resSubscript->select();				
				$select->from($resSubscript,array('subcamp_resid'));		
				$select->where('subcamp_resid = ?',$row->resid);
				$select->where('subcamp_currentmonth  = ?',$date);
				$select->where('subcamp_credit_type  = ?','Free');
				//UPDATE IF THE ENTRY ALREADY EXITS FOR THE MONTH
				$where = array('subcamp_resid = ?'=>$row->resid,'subcamp_currentmonth = ?'=>$date,'subcamp_credit_type = ?'=>'Free');
				$toUpdateData = array('subcamp_totalcredits'=>$numberOfCredits);
				$updateResult = $resSubscript->update($toUpdateData,$where);
				if($updateResult==0)
				{
					$data = array('subcamp_resid' 				=>	$row->resid,
								  'subcamp_createddatetime' 	=>	date("Y-m-d H:i:s"),
								  'subcamp_credit_type' 		=>	'Free',
								  'subcamp_totalcredits'		=>	$numberOfCredits,
								  'subcamp_currentmonth'		=>	$date
					);
					$status = $resSubscript->insert($data);	
				}
				else
				{
					$status = $updateResult;	
				}
				
				
				if($status){
					$countselect = $resCampCount->select();	
					$countselect->from($resCampCount,array('rescamp_resid','rescamp_totalsms','rescamp_usedsms'));
					$countselect->where('rescamp_resid = ?',$row->resid);
					$camprow = $resCampCount->fetchRow($countselect);	
					if(!$camprow){
						$data = array('rescamp_resid' 				=>	$row->resid,
									  'rescamp_createddatetime' 	=>	date("Y-m-d H:i:s"),
									  'rescamp_totalsms'			=>	$numberOfCredits,
						);
						$campstatus = $resCampCount->insert($data);	
					}else{
						$set = array('rescamp_updateddatetime' 	=>  date("Y-m-d H:i:s"),
									 'rescamp_totalsms'			=>	$numberOfCredits,	
						);
						$where = array('rescamp_resid = ?'=>$row->resid);
						$campupdatestatus = $resCampCount->update($set,$where);
						$subset = array('subcamp_usedcredits' 		=>	$camprow->rescamp_usedsms,
									  'subcamp_updateddatetime' 	=>	date("Y-m-d H:i:s")
						);
						$subwhere = array('subcamp_resid = ?'=>$row->resid,'subcamp_currentmonth = ?' =>date('M Y', strtotime(date('Y-m')." -1 month")));
						$campupdatestatus = $resSubscript->update($subset,$subwhere);
						
					}
				}				
			}
		    return true; 
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
        public function paymentDueAlert($restaurantid){
            try{
                $restaurant = array();                      
                if(in_array($restaurantid, $restaurant)){
                  return false;  
                }else {
                  return true;  
                }                                                                                      
                }catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
        }
	
}
