<?php

class FirmManagement_Model_FirmFeedBackPhoneNumbersDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('FirmManagement_Model_DbTable_FirmFeedBackPhoneNumbers');
		}
		return $this->_dbTable;
	}
	
	public function GetFeedbackPhoneNumbersOfRes($request)
	{
		try{
			$restaurantid = $request->restaurantid;
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			
			$select->from(array('mt.feedback_phonenums'),array('fbp_id','fbp_phone','fbpcountrycode','fbp_status'))
				   ->join(array('mt.restaurant_status_bd'),'fbp_phone_status_id = id',array('description'))
				   ->where('fbpfk_restid = ?',$restaurantid)
				   ->where('fbp_phone_status_id IN(?)',array(1,2))
		   		   ->order('fbp_id');
				   
			$result = $table->fetchAll($select);
			$resultArr = array();
			foreach($result as $value){
				$array = array(
					'phone' 		=>	$value->fbp_phone,
					'id'			=>	$value->fbp_id,
					'status'		=>	$value->description,
					'countryCode'	=>	$value->fbpcountrycode,
				);
				$resultArr[] = $array;
			}			
			return $resultArr;		
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function AddFeedbackPhoneNum($restid, $phone,$countryCode)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$result = 0;
			$id = "";
			$result = $db->fetchOne("select count(fbp_phone) from mt.feedback_phonenums where fbpfk_restid = '".$restid."'and fbp_phone ILIKE'%".$phone."%'and fbpcountrycode = '+".trim($countryCode)."'and fbp_phone_status_id IN(1,2) ");
			if($result < 1){
				$data = array('fbpfk_restid'		=>	$restid,
							  'fbp_phone'			=>	$phone,
							  'fbp_status'			=>	true,
							  'fbp_phone_status_id'	=>	1,
							  'fbpcountrycode'		=>  '+'.trim($countryCode)
						);
				$table = $this->getDbTable();
				$id = $table->insert($data);	
			}
			if($id){
				return true;
			}else{
				return false;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function UpdateRestFeedbackPhoneNumById($restid, $phone, $id, $fbcountrycode)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$result = 0;
			$count = 0;
			$status = false;
			$result = $db->fetchOne("select count(fbp_phone),count(fbpcountrycode) from mt.feedback_phonenums where fbpfk_restid= '".$restid."'and fbp_phone ILIKE'%".$phone."%' and fbpcountrycode = '+".trim($fbcountrycode)."'and fbp_phone_status_id IN(1,2)");
			if($result < 1){
					$table = $this->getDbTable();
					$set   = array('fbp_phone'=>$phone, 'fbpcountrycode' => '+'.trim($fbcountrycode));
					$where = array('fbpfk_restid = ?'=>$restid,
								   'fbp_id = ?' => $id);
					$status = $table->update($set,$where);
			}else if($result == 1){
				$fbpId = $db->fetchOne("select fbp_id from mt.feedback_phonenums where fbpfk_restid = '".$restid."'and fbp_phone ILIKE'%".$phone."%' and fbpcountrycode = '".$fbcountrycode."' and fbp_phone_status_id IN(1,2)");
				if($fbpId == $id){
					$status = true;
				}
			}
			return 	$status;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
		
	public function ReterieveRestFeedbackphonenumbers($resid)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();			
			$select->from(array('mt.feedback_phonenums'),array('fbp_phone','fbpcountrycode'))
				   ->where('fbpfk_restid = ?',$resid)
				   ->where('fbp_phone_status_id =?', 1);
				   
		  $result = $table->fetchAll($select);
		  $resultArr = array();
		  foreach($result as $value){
			$array[] = $value->fbpcountrycode.''.$value->fbp_phone;
		  }	
		  $resultArr['phone'] = $array;	
		  return $resultArr;		
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function deleteResFeedbackPhone($id)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$table = $this->getDbTable();
			
			$set   = array('fbp_status'=> 'false',
						   'fbp_phone_status_id'=> '3');
			
			$where = $db->quoteInto('fbp_id = ?', $id);
			$status = $table->update($set,$where);
			return 	$status;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function changefeedbackphonestatus($id, $text)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$table = $this->getDbTable();
			if($text == "Activate"){
				$set   = array('fbp_status'=> 'true',
								'fbp_phone_status_id'=> '1');
			}else if($text == "InActivate"){
				$set   = array('fbp_status'=> 'false',
								'fbp_phone_status_id'=> '2');
			}
			$where = $db->quoteInto('fbp_id = ?', $id);
			$status = $table->update($set,$where);
			return 	$status;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}