<?php
class FirmManagement_Model_FirmFloorUpdateStatusMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}


	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('FirmManagement_Model_DbTable_FirmFloorUpdateStatus');
		}
		return $this->_dbTable;
	}
	
	public function changeRestFloorUpdatedStatusFlag($restid, $status, $userid)
	{
		try{
			$count = 0;
			$table = $this->getDbTable();
			$select = $table->select();

			$select->from($table,array('COUNT(rfuid) as count'))
			->where('rfufk_restaurant = ?',$restid);
			
			$rowset = $table->fetchRow($select);
			
			if($rowset)
			{
				$count = $rowset->count;
			}
			
			if($count > 0){
				$set = array(
					'rfu_updated_status' =>	$status,
					'rfuupdatedby'		 =>	$userid,	
					'rfuupdateddate' 	 =>	date('Y-m-d H:i:s')
				);
				$where = array(
						'rfufk_restaurant = ?'		=>	$restid,
					);
				$this->getDbTable()->update($set,$where);
			}else
			{
				$data = array(
					'rfufk_restaurant'		=>	$restid,
					'rfu_updated_status'	=>	$status,
					'rfucreatedby'			=>	$userid,	
					'rfucreateddate' 		=>	date('Y-m-d H:i:s')
				);

				$this->getDbTable()->insert($data);
			}
		
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getUpdatedFloorStatus($restid)
	{
		try{
			$status = false;
			$table = $this->getDbTable();
			$select = $table->select();

			$select->from($table,array('rfu_updated_status'))
			->where('rfufk_restaurant = ?',$restid);
			
			$rowset = $table->fetchRow($select);
			
			if($rowset)
			{
				$status = $rowset->rfu_updated_status;
			}
			return $status;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}