<?php
class FirmManagement_Model_FirmGroupUsersDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
				
			$this->setDbTable('FirmManagement_Model_DbTable_FirmGroupUsers');
		}
		return $this->_dbTable;
	}

	public function addUserContact(FirmManagement_Model_FirmGroupUsers $user)
	{
		try{
			$mapper = new FirmManagement_Model_FirmDataMapper();
			$timezone = $mapper->GetRestaurantTimeZone($user->getRestaurantId());
			date_default_timezone_set($timezone);
			//echo '<pre>'; echo "g-1";
			$db = Zend_Db_Table::getDefaultAdapter();
			$data = array(
						'rgufk_restaurant'		=>	$user->getRestaurantId(),
						'rgufk_rsgid'			=>	$user->getGroupId(),
						'rgufirst_name'			=>	$user->getFirstName(),
						'rgulast_name'			=>	$user->getLastName(),
						'rgugender'				=>	$user->getGender(),
						'rguaddress'			=>	$user->getAddress(),
						'rgustatus'				=>	$user->getStatus(),
						'rguzipcode'			=>	$user->getZipCode(),
						'rguallergies_dislikes'	=>	$user->getdislikes(),
						'rgudesignation'		=>	$user->getdesignation(),
						'rgucompany'			=>  $user->getcuscompany(),
						'rgucreated_date'		=> date('Y-m-d H:i:s'),
					);
			if($user->getEmail()){
				$data['rguemail'] = $user->getEmail();
			}
			if($user->getPhone()){
				$data['rguphone'] = str_replace("-","",$user->getPhone());
			}
			
			if($user->getcountry_code()){
				$data['rgucountrycode'] = $user->getcountry_code();
			}
			
			if($user->getsplstatusid()){
				$data['rgusplstatus_id'] = $user->getsplstatusid();
			}
			
			if($user->getState()){
				$data['rgustate_id'] = $user->getState();
			}
			if($user->getRegion()){
				$data['rguregion_id'] = $user->getRegion();
			}
			if($user->getCity()){
				$data['rgucity_id'] = $user->getCity();
			}
			if($user->getNeighbourhood()){
				$data['rguneighbourhood_id'] = $user->getNeighbourhood();
			}
			if($user->getSplRequest()!=md5('RES')){
                    if($user->getSplRequest()){
					$data['rguspecial_request'] = $user->getSplRequest();
				 }                         
            }
			if($user->getOccational_emails()){
				$data['rgu_occational_emails'] = $user->getOccational_emails();
			}
			if($user->getrgu_birthday()){
				$data['rgu_birthday'] = $user->getrgu_birthday();
			}
			if($user->getrgu_anniversary()){
				$data['rgu_anniversary'] = $user->getrgu_anniversary();
			}
			if($user->getrgu_optinemail()){
				$data['rgu_optinemail'] = $user->getrgu_optinemail();
			}
			//echo '<pre>'; echo "g-2";
			$whtShouldIUpdate = '';
			$result = '';
			$guestid = '';
			if($user->getId()){
				$guestid = $user->getId();
			}else{
				if($user->getEmail() && $user->getPhone() && $user->getFirstName() && $user->getLastName()){
					$result = $db->fetchRow("select rguid from mt.restaurant_group_users where rgufk_restaurant = ".$user->getRestaurantId()." and rgufirst_name = '". $user->getFirstName()."' and rgulast_name = '".$user->getLastName()."' and rguphone = '".$user->getPhone()."'and rguemail ILIKE '%".$user->getEmail()."%'");
					if($result)
					{
						$guestid = $result['rguid'];
					}else{
						$whtShouldIUpdate = 'Both';
					}
				}else if($user->getPhone()){
					$result = $db->fetchRow("select rguid from mt.restaurant_group_users where rgufk_restaurant = ".$user->getRestaurantId()." and rgufirst_name = '". $user->getFirstName()."' and rgulast_name = '".$user->getLastName()."' and rguphone = '".$user->getPhone()."'");
					if(!$result){
						$whtShouldIUpdate = 'Both';
					}else{
						$guestid = $result['rguid'];
					}
				}else if($user->getEmail()){
					$result = $db->fetchRow("select rguid from mt.restaurant_group_users where rgufk_restaurant = ".$user->getRestaurantId()." and rgufirst_name = '". $user->getFirstName()."' and rgulast_name = '".$user->getLastName()."' and rguemail ILIKE '%".$user->getEmail()."%'");
					if(!$result){
						$whtShouldIUpdate = 'Both';
					}else{
						$guestid = $result['rguid'];
					}
				}else if($user->getEmail() == '' && $user->getPhone() == ''){
					$whtShouldIUpdate = 'Both';
				}		
			}
			//echo '<pre>'; echo "g-3";
			//echo '<pre>'; echo $whtShouldIUpdate;
			//echo '<pre>'; echo $guestid;
			if($whtShouldIUpdate == 'Both')
			{
				//echo '<pre>'; echo "g-4";
				$guestid = $this->getDbTable()->insert($data);
				//echo '<pre>'; echo "g-5";
			}else if($guestid != '' ){
				if($user->getFirstName()){
					$set['rgufirst_name'] = $user->getFirstName();
				}
				if($user->getLastName()){
					$set['rgulast_name'] = $user->getLastName();
				}
				else{
					$set['rgulast_name'] = '';
				}
				if($user->getEmail()){
					$set['rguemail'] = $user->getEmail();
				}
				else{
					$set['rguemail'] = '';
				}
				if($user->getPhone()){
					$set['rguphone'] = str_replace("-","",$user->getPhone());
				}
				else{
					$set['rguphone'] ='';
				}
				if($user->getcountry_code()){
					$set['rgucountrycode'] = $user->getcountry_code();
				}
				if($user->getSplRequest()!=md5('RES')){
					if($user->getSplRequest()){
						$set['rguspecial_request'] = $user->getSplRequest();
					}
					else{
					  $set['rguspecial_request'] =''; 
					}  
				}				
				if($user->getAddress()){
					$set['rguaddress'] = $user->getAddress();
				}
				if($user->getStatus() != ''){
					$set['rgustatus'] = $user->getStatus();
				}
				if($user->getdislikes() != ''){
					$set['rguallergies_dislikes'] = $user->getdislikes();
				}
				if($user->getdesignation() != ''){
					$set['rgudesignation'] = $user->getdesignation();
				}
				if($user->getcuscompany() != ''){
					$set['rgucompany'] = $user->getcuscompany();
				}
				if($user->getsplstatusid() != ''){
					$set['rgusplstatus_id'] = $user->getsplstatusid();
				}
				$set['rguupdated_date'] = date('Y-m-d H:i:s');
				
				$where = array('rgufk_restaurant = ?' =>	$user->getRestaurantId(),
							   'rguid = ?'			  =>	$guestid);
				$rows_affected = $this->getDbTable()->update($set,$where);
			}
			return $guestid;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function addExcelUserContact($resId,$grpId,$excelContacts)
	{
			
		try{
			// $table = $this->getDbTable();
			// $query= $table->select();
			// $query->setIntegrityCheck(false);
			// $query->from(array('rgu' => 'mt.restaurant_group_users'),array('rguid','rgufk_restaurant','rgufirst_name','rgulast_name','rguemail','rguphone','rgufk_rsgid'))
			// 		->join(array('rsg' => 'mt.restaurant_group'),'rsg.rsgid = rgu.rgufk_rsgid',array('rsggroup'))
			// 		->where('rgu.rgustatus = ?',TRUE)
			// 		->where('rgu.rgufk_restaurant =?',$resId);
					
			// $result = $table->fetchAll($query);
			foreach($excelContacts as $contacts)
			{
				$db = Zend_Db_Table::getDefaultAdapter();
				$db->beginTransaction();
				$conditionArray = array();
				$conditionArray[] = "rgufk_restaurant = $resId";
				$userdat = "";
				$status = true;

				foreach($contacts as $user){
					$userdat[] = $user;
				}
				if(strlen($userdat[4]) > 15){
					$userdat[4] ="";
				}
				
				$usnumber = $userdat[4];
				$usnumber = str_replace("-","",$usnumber);
				$usnumber = str_replace("(","",$usnumber);
				$usnumber = str_replace(")","",$usnumber);
				
				
				$data = array(
					'rgufk_restaurant'		=>	$resId,
					'rgufk_rsgid'			=>	$grpId,
					'rgufirst_name'			=>	addslashes($userdat[0]),
					'rgulast_name'			=>	addslashes($userdat[1]),
					'rgugender'				=>	$userdat[2],
					'rguemail'				=>	addslashes($userdat[3]),
					'rguphone'				=>	addslashes($usnumber),
					'rguaddress'			=>	addslashes($userdat[5]),
					'rgustatus'				=>	1,
					'rgustate_id'			=>	$userdat[6],
				        'rgucity_id'			=>	$userdat[7],
					'rguzipcode'			=>	$userdat[8],
					'rgucompany'			=>	$userdat[9],
					'rgu_optinemail'		=>  $userdat[12]
					);	
				if($userdat[10] != ""){
					if (strpos($userdat[10],'/') !== false) {
						$data['rgu_birthday'] = str_replace('/','-',$userdat[10]);
					}else if (strpos($userdat[10],'-') !== false) {
						$data['rgu_birthday'] = $userdat[10];
					}
				}
				if($userdat[11]  != ""){
					if (strpos($userdat[11],'/') !== false) {
						$data['rgu_anniversary'] = str_replace('/','-',$userdat[11]);
					}
				}	
				if($userdat[3] != ""){
					$conditionArray[]= "rguemail= '".$userdat[3]."'";
					}
				if($userdat[4] != ""){
					$conditionArray[] = "rguphone = '".$userdat[4]."'";
					}
				if(count($conditionArray)>1)
				{
					$updateRows = $this->getDbTable()->update($data,$conditionArray);
					if($updateRows==0){
					$newId = $this->getDbTable()->insert($data);	
					}
				}
				else
				{
					$newId = $this->getDbTable()->insert($data);	
				}
				$db->commit();
				$status = true;
			}
				return true;	
			}catch(Exception $ex){
				$db->rollBack();
				throw new Exception($ex->getMessage()) ;
			}
			return $status;
	}
        
        public function getGuestCount(FirmManagement_Model_FirmGroupUsers $requestdata, $arraydata)
        {
            try{
                        $searchtext='';    
                        if(array_key_exists('searchtext', $arraydata)){
                            $searchtext = $arraydata['searchtext'];
                        }
                        
                        $table = $this->getDbTable();
			$query = $table->select();
			
                        $query->from(array('rgu' => 'mt.restaurant_group_users'),array('count(rguid) as guestcount'))		                        
			->where('rgu.rgustatus = ?',TRUE)
			->where('rgu.rgufk_restaurant = ?',$requestdata->getRestaurantId());
                        if($searchtext){
                                if(strpos($searchtext, " ") >0 ){
                                    $searchstr = explode(" ", $searchtext);                                    
                                    $query->where('rgu.rgufirst_name Ilike ?','%'.trim($searchstr[0].'%'));
                                    $query->where('rgu.rgulast_name Ilike ?','%'.trim($searchstr[1].'%'));
                                }else {
                            $query->where('(rgu.rgufirst_name Ilike ?','%'.trim($searchtext.'%'));
                            $query->orwhere('rgu.rgulast_name Ilike ?','%'.trim($searchtext.'%'));
                            $query->orwhere('rgu.rguphone Ilike ?',trim($searchtext.'%'));
                            $query->orwhere('rgu.rguemail Ilike ? )','%'.trim($searchtext.'%'));        
                                } 
                            }
                        if($requestdata->getsplstatusid()){
                            $query->where('rgu.rgusplstatus_id = ?',$requestdata->getsplstatusid());
                        }
                        if($requestdata->getrgu_birthday()){
                            $bsplit = explode('-',$requestdata->getrgu_birthday());
                            $query->where("(Extract(month from rgu_birthday)= '".$bsplit[0]."') AND (Extract(day from rgu_birthday)= '".$bsplit[1]."')");
                        }
                        if($requestdata->getrgu_anniversary()){
                            $asplit = explode('-',$requestdata->getrgu_anniversary());
                            $query->where("(Extract(month from rgu_anniversary)= '".$asplit[0]."') AND (Extract(day from rgu_anniversary)= '".$asplit[1]."')");
                        }
                        if($requestdata->getrgu_specialdays()){
                            $query->where('rgu.rgu_specialdays Ilike ?',trim($requestdata->getrgu_specialdays().'%'));
                        }
                        if($requestdata->getrgu_frqntdinner()){
                            $query->where('rgu.rgufrqntdinner = ?',$requestdata->getrgu_frqntdinner());
                        }
                        if($requestdata->getrgu_blacklist()){
                          $query->where('rgu.rgublacklist = ?',$requestdata->getrgu_blacklist());  
                        }
                        $fetchedrow = $table->fetchRow($query);
                        $result = $fetchedrow->guestcount;
                        return $result; 
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
            
        }
	public function getUsersContacts(FirmManagement_Model_FirmGroupUsers $model, $restList, $offset, $requestdata)
	{
		try{    
                        $lastid ='';
                        $searchtext ='';                        
                        $limit ='';                                                                        
                        if(array_key_exists('last_id', $requestdata)){
                           $lastid =  $requestdata['last_id'];
                        }
                        if(array_key_exists('searchtext', $requestdata)){
                            $searchtext = $requestdata['searchtext'];
                        }                        
                        if(array_key_exists('limit', $requestdata)){
                            $limit = $requestdata['limit'];
                        }
                        
			$table = $this->getDbTable();
			$query= $table->select();
			$query->setIntegrityCheck(false);

                        $query->from(array('rgu' => 'mt.restaurant_group_users'),array('rguid','rgufk_restaurant','rgufirst_name','rgulast_name','rguemail','rguphone','rgufk_rsgid','rgu_birthday', 'rgucountrycode'))		                        
			->where('rgu.rgustatus = ?',TRUE)
			->where('rgu.rgufk_restaurant = ?',$model->getRestaurantId());
                        						                        
			$Resultobj = array();
                        if($lastid || $searchtext || $model->getsplstatusid() || $model->getrgu_birthday() || $model->getrgu_anniversary() || $model->getrgu_specialdays() || $model->getrgu_frqntdinner() || $model->getrgu_blacklist())
                            {
                            if($searchtext){
                                if(strpos($searchtext, " ") >0 ){
                                    $searchstr = explode(" ", $searchtext);                                    
                                    $query->where('rgu.rgufirst_name Ilike ?','%'.trim($searchstr[0].'%'));
                                    $query->where('rgu.rgulast_name Ilike ?','%'.trim($searchstr[1].'%'));
                                }else {
                            $query->where('(rgu.rgufirst_name Ilike ?','%'.trim($searchtext.'%'));
                            $query->orwhere('rgu.rgulast_name Ilike ?','%'.trim($searchtext.'%'));
                            $query->orwhere('rgu.rguphone Ilike ?',trim($searchtext.'%'));
                            $query->orwhere('rgu.rguemail Ilike ? )','%'.trim($searchtext.'%'));        
                                } 
                            }   
                            if($model->getsplstatusid()){
                                $query->where('rgu.rgusplstatus_id = ?',$model->getsplstatusid());
                            }
                            if($model->getrgu_birthday()){
                                $bsplit = explode('-',$model->getrgu_birthday());
                                $query->where("(Extract(month from rgu_birthday)= '".$bsplit[0]."') AND (Extract(day from rgu_birthday)= '".$bsplit[1]."')");
                            }
                            if($model->getrgu_anniversary()){
                                $asplit = explode('-',$model->getrgu_anniversary());
                                $query->where("(Extract(month from rgu_anniversary)= '".$asplit[0]."') AND (Extract(day from rgu_anniversary)= '".$asplit[1]."')");
                            }
                            if($model->getrgu_specialdays()){
                                $query->where('rgu.rgu_specialdays Ilike ?',trim($model->getrgu_specialdays().'%'));
                            }
                            if($model->getrgu_frqntdinner()){
                                
                                $query->where('rgu.rgufrqntdinner = ?',$model->getrgu_frqntdinner());
                            }
                            if($model->getrgu_blacklist()){
                                $query->where('rgu.rgublacklist = ?',$model->getrgu_blacklist());
                            }                            
                            if($lastid){
                              $query->where('rgu.rguid < ? ', $lastid);  
                            }
                                                   
                        $query->order('rgu.rguid desc');                       
                        $query->limit($limit);                               			                                                
                        }
                        else {
                        $query->order('rgu.rguid desc');
                        $query->limit(25);			                        
                        }	
                        $resultset = $table->fetchAll($query); 
                        foreach($resultset as $row)
                            {                                                       
                            $Resultobj[] = array(
                                'rguid' => $row->rguid,                               
                                'rgufk_restaurant' => $row->rgufk_restaurant,                                
                                'rgu_birthday' => str_replace('null', '', $row->rgu_birthday),                                
                                'rgufirst_name' => strtolower($row->rgufirst_name),
                                'rgulast_name' => strtolower(str_replace('null', '', $row->rgulast_name)),
                                'rguemail' => str_replace('null', '', $row->rguemail),
				'rgucountrycode' => str_replace('null', '', $row->rgucountrycode),
                                'rguphone' => str_replace('null', '', $row->rguphone)                                                              
                            );                                                            
                        } 
                       return $Resultobj;                                                 
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getUpcomingCelebrationUsersContacts(FirmManagement_Model_FirmGroupUsers $groupusers,$offset,$request)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$limit = 15;
			$table = $this->getDbTable();
			$query= $table->select();
			$query->setIntegrityCheck(false);
			
			$query->from(array('rgu' => 'mt.restaurant_group_users'),array('rguid','rgufk_restaurant','rgufirst_name','rgulast_name','rguemail','rguphone','rgufk_rsgid','rguaddress','rguzipcode','rguallergies_dislikes','rgu_birthday','rgu_anniversary','rgusplstatus_id','rguspecial_request','rgucountrycode'))
				  ->joinLeft(array('sta'=>'mt.state_bd'),'sta.id = rgu.rgustate_id',array('id as stateid','description as state'))
				  ->joinLeft(array('reg'=>'mt.region_bd'),'reg.id = rgu.rguregion_id',array('id as regionid','description as region'))
				  ->joinLeft(array('cty'=>'mt.city_bd'),'cty.id = rgu.rgucity_id',array('id as cityid','description as city'))
				  ->joinLeft(array('neg'=>'mt.neighborhood_bd'),'neg.id = rgu.rguneighbourhood_id',array('id as neighbid','description as neighborhood'))
				  ->where("((Extract(month from rgu_birthday) >= Extract(month from CURRENT_DATE::DATE) 
					and Extract(month from rgu_birthday) <= Extract(month from CURRENT_DATE::DATE)+1)
					OR (Extract(month from rgu_anniversary) >= Extract(month from CURRENT_DATE::DATE) 
					and Extract(month from rgu_anniversary) <= Extract(month from CURRENT_DATE::DATE)+1))");
	
			if($groupusers->getFirstName()){
				$query->where('rgu.rgufirst_name Ilike ?','%'.trim($groupusers->getFirstName()).'%');
			}
			if($groupusers->getLastName()){
				$query->where('rgu.rgulast_name Ilike ?','%'.trim($groupusers->getLastName().'%'));
			}
			if($groupusers->getEmail()){
				$query->where('rgu.rguemail Ilike ?','%'.trim($groupusers->getEmail().'%'));
			}
			if($groupusers->getPhone()){
				$query->where('rgu.rguphone Ilike ?','%'.trim($groupusers->getPhone().'%'));
			}
			if($groupusers->getSortOn() == 'email' && $groupusers->getSortOrder() == 'ASC'){
				$query->order(array('rgu.rguemail ASC'));
			}else if($groupusers->getSortOn() == 'email' && $groupusers->getSortOrder() == 'DESC'){
				$query->order(array('rgu.rguemail DESC'));
			}
			if($groupusers->getSortOn() == 'fname' && $groupusers->getSortOrder() == 'ASC'){
				$query->order(array('rgu.rgufirst_name ASC'));
			}else if($groupusers->getSortOn() == 'fname' && $groupusers->getSortOrder() == 'DESC'){
				$query->order(array('rgu.rgufirst_name DESC'));
			}
			if($groupusers->getSortOn() == 'lname' && $groupusers->getSortOrder() == 'ASC'){
				$query->order(array('rgu.rgulast_name ASC'));
			}else if($groupusers->getSortOn() == 'lname' && $groupusers->getSortOrder() == 'DESC'){
				$query->order(array('rgu.rgulast_name DESC'));
			}
			if($groupusers->getSortOrder()){
				$query->where('rgu.rgulast_name Ilike ?','%'.trim($groupusers->getLastName().'%'));
			}	  
				  
			$query->where('rgufk_restaurant = ?',$request->restaurantid)
				  ->where('rgu.rgustatus = ?',TRUE)
			      ->order('rgu.rguid DESC');
			//$Result = $table->fetchAll($query);
			$Result = "";
			$Result = new Zend_Paginator(
			new Zend_Paginator_Adapter_DbTableSelect($query)
			);
			$Result->setItemCountPerPage($limit);
			$Result->setCurrentPageNumber($offset);
			
			return $Result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function GetRestUsersContacts($restList)
	{
		try{
			$table = $this->getDbTable();
			$query= $table->select();
			$query->setIntegrityCheck(false);

			$query->from(array('rgu' => 'mt.restaurant_group_users'),array('rguid','rgufk_restaurant','rgufirst_name','rgulast_name','rguemail','rguphone','rgufk_rsgid','rgugender','rguzipcode','rguaddress','rgu_birthday','rgu_anniversary','rgu_optinemail','rgucompany'))
			->join(array('rsg' => 'mt.restaurant_group'),'rsg.rsgid = rgu.rgufk_rsgid',array('rsggroup'))
			->joinLeft(array('sta'=>'mt.state_bd'),'sta.id = rgu.rgustate_id',array('description as state'))
			->joinLeft(array('cty'=>'mt.city_bd'),'cty.id = rgu.rgucity_id',array('description as city'))
			->where('rgu.rgustatus = ?',TRUE);
			$resIdArr = array();
			$query->where('rgu.rgufk_restaurant = ?',$restList);
			$query->order('rgu.rguid DESC');
			$Result = "";
			$Result = $table->fetchAll($query);
			return $Result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
        public function DownloadContactsbyAjax(FirmManagement_Model_FirmGroupUsers $dataobj, $searchtext)
	{
		try{
                        
                        $result = '';                                                                        
			$table = $this->getDbTable();
			$query= $table->select();  
                        $query->setIntegrityCheck(false);
			$query->from(array('rgu' => 'mt.restaurant_group_users'),array('rguid','rgufk_restaurant','rgufirst_name','rgulast_name','rguemail','rguphone','rgufk_rsgid','rgugender','rguzipcode','rguaddress','rgu_birthday','rgu_anniversary','rgu_optinemail','rgucompany','rgustate','rgucity'))			
                               ->join(array('rsg' => 'mt.restaurant_group'),'rsg.rsgid = rgu.rgufk_rsgid',array('rsggroup'))
			->joinLeft(array('sta'=>'mt.state_bd'),'sta.id = rgu.rgustate_id',array('description as state'))
			->joinLeft(array('cty'=>'mt.city_bd'),'cty.id = rgu.rgucity_id',array('description as city'))
			->where('rgu.rgustatus = ?',TRUE)
                        ->where('rgu.rgufk_restaurant = ?', $dataobj->getRestaurantId());						
			if($searchtext){
                                if(strpos($searchtext, " ") >0 ){
                                    $searchstr = explode(" ", $searchtext);                                    
                                    $query->where('rgu.rgufirst_name Ilike ?','%'.trim($searchstr[0].'%'));
                                    $query->where('rgu.rgulast_name Ilike ?','%'.trim($searchstr[1].'%'));
                                }else {
                            $query->where('(rgu.rgufirst_name Ilike ?','%'.trim($searchtext.'%'));
                            $query->orwhere('rgu.rgulast_name Ilike ?','%'.trim($searchtext.'%'));
                            $query->orwhere('rgu.rguphone Ilike ?',trim($searchtext.'%'));
                            $query->orwhere('rgu.rguemail Ilike ? )','%'.trim($searchtext.'%'));        
                                } 
                            }
                        
                        if($dataobj->getsplstatusid()){
                         $query->where('rgu.rgusplstatus_id = ?', $dataobj->getsplstatusid()); 
                        }
                        if($dataobj->getrgu_birthday()){
                         $bsplit = explode('-',$dataobj->getrgu_birthday());                                                                
                         $query->where("(Extract(month from rgu_birthday)= '".$bsplit[0]."') AND (Extract(day from rgu_birthday)= '".$bsplit[1]."')"); 
                        }
                        if($dataobj->getrgu_anniversary()){
                         $asplit = explode('-',$dataobj->getrgu_anniversary());                                                                                            	                                
                         $query->where("(Extract(month from rgu_anniversary)= '".$asplit[0]."') AND (Extract(day from rgu_anniversary)= '".$asplit[1]."')"); 
                        }
                        if($dataobj->getrgu_specialdays()){
                         $query->where('rgu.rgu_specialdays Ilike ?',trim($dataobj->getrgu_specialdays().'%'));
                        }
                        if($dataobj->getrgu_frqntdinner()){
                          $query->where('rgu.rgufrqntdinner = ?',$dataobj->getrgu_frqntdinner());  
                        }
                        if($dataobj->getrgu_blacklist()){
                          $query->where('rgu.rgublacklist = ?',$dataobj->getrgu_blacklist());
                        }                                                                         
			$query->order('rgu.rguid DESC');
			$result = $table->fetchAll($query);
                        
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getUserContactById(FirmManagement_Model_FirmGroupUsers $id)
	{
		try{
			$table = $this->getDbTable();
			$query= $table->select();
			$query->setIntegrityCheck(false);

			$query->from(array('rgu' => 'mt.restaurant_group_users'),array('rgufk_restaurant','rgufk_rsgid','rgufirst_name','rgulast_name','rgugender','rguemail','rguphone','rguaddress','rgustate_id','rguregion_id','rgucity_id','rguzipcode','rguneighbourhood_id','rguspecial_request','rgu_birthday','rgu_anniversary','rgu_optinemail'))
			->join(array('rsg' => 'mt.restaurant_group'),'rsg.rsgid = rgu.rgufk_rsgid',array('rsggroup'))
			->where('rguid = ?',$id->getId());
				
			$Result = $table->fetchRow($query);
			$cityList = "";
			$regionList="";
			$neighborhoodList = ""; 
			if($Result){
				if($Result['rgustate_id'] != ''){
					$regionmapper = new Application_Model_RegionDataMapper();
					$regionObj = new Application_Model_Region();
					$regionObj->setStateId($Result['rgustate_id']);
					$region = $regionmapper->getRegionByStateId($regionObj);
					$regionList = $region->getRegionList();
						if($Result['rguregion_id'] != ''){
							$citymapper = new Application_Model_CityDataMapper();
							$cityObj = new Application_Model_City();
							$cityObj->setRegionId($Result['rguregion_id']);
							$city = $citymapper->getCityByRegionId($cityObj);
							$cityList = $city->getCityList();
						}
						if($Result['rgucity_id'] != ''){
							$neighborhoodmapper = new Application_Model_NeighborhoodDataMapper();
							$neighborhoodObj = new Application_Model_Neighborhood();
							$neighborhoodObj->setCityId($Result['rgucity_id']);
							$neighborhood = $neighborhoodmapper->getNghByCityId($neighborhoodObj);
							$neighborhoodList = $neighborhood->getNeighborhoodList();
						}
				}
			}

			$obj = new FirmManagement_Model_FirmGroupUsers();
			$obj->setRestaurantId($Result->rgufk_restaurant)
			->setGroupId($Result->rgufk_rsgid)
			->setGroupName($Result->rsggroup)
			->setFirstName($Result->rgufirst_name)
			->setLastName($Result->rgulast_name)
			->setGender($Result->rgugender)
			->setEmail($Result->rguemail)
			->setPhone($Result->rguphone)
			->setAddress($Result->rguaddress)
			->setCity($Result->rgucity_id)
			->setRegion($Result->rguregion_id)
			->setNeighbourhood($Result->rguneighbourhood_id)
			->setState($Result->rgustate_id)
			->setZipCode($Result->rguzipcode)
			->setSplRequest($Result->rguspecial_request)
			->setrgu_birthday($Result->rgu_birthday)
			->setrgu_anniversary($Result->rgu_anniversary)
			->setrgu_optinemail($Result->rgu_optinemail);

			if($regionList){
				$obj->setRegionBd($regionList);
				if($cityList){
					$obj->setCityBd($cityList);
					if($neighborhoodList){
						$obj->setNeighbourhoodBd($neighborhoodList);	
					}
				}
			}
			return $obj;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function UpdateUserContact(FirmManagement_Model_FirmGroupUsers $user)
	{
		try{
			$status = false;
			$db = Zend_Db_Table::getDefaultAdapter();
			$set = array(
						'rgufk_restaurant'		=>	$user->getRestaurantId(),
						'rgufk_rsgid'			=>	$user->getGroupId(),
						'rgufirst_name'			=>	$user->getFirstName(),
						'rgulast_name'			=>	$user->getLastName(),
						'rgugender'				=>	$user->getGender(),
						'rguemail'				=>	$user->getEmail(),
						'rguphone'				=>	str_replace("-","",$user->getPhone()),
						'rguaddress'			=>	$user->getAddress(),
						'rguzipcode'			=>	$user->getZipCode(),
						);
			if($user->getState()){
				$set['rgustate_id'] = $user->getState();
			}
			if($user->getRegion()){
				$set['rguregion_id'] = $user->getRegion();
			}
			if($user->getCity()){
				$set['rgucity_id'] = $user->getCity();
			}
			if($user->getNeighbourhood()){
				$set['rguneighbourhood_id'] = $user->getNeighbourhood();
			}
			if($user->getSplRequest()){
				$set['rguspecial_request'] = $user->getSplRequest();
			}
			if($user->getrgu_birthday()){
				$set['rgu_birthday'] = $user->getrgu_birthday();
			}
			if($user->getrgu_anniversary()){
				$set['rgu_anniversary'] = $user->getrgu_anniversary();
			}
			if($user->getrgu_optinemail()){
				$set['rgu_optinemail'] = $user->getrgu_optinemail();
			}
			$where = $db->quoteInto('rguid = ?',$user->getId());
			$rows_affected = $this->getDbTable()->update($set,$where);
			if($rows_affected)
			{
				return true;
			}else{
				return false;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function deleteContact($contactid)
	{
		try{
			$status = false;
			$db = Zend_Db_Table::getDefaultAdapter();
			$set = array(
						'rgustatus'		=>	'false'
						);
			$where = $db->quoteInto('rguid = ?',$contactid);
			$rows_affected = $this->getDbTable()->update($set,$where);
			if($rows_affected)
			{
				return true;
			}else{
				return false;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getUserContacts(FirmManagement_Model_FirmGroupUsers $groupusers,$offset,$restList,$request)
	{
		try{
			$limit = 15;
			$query = $this->getDbTable()->select();
			$query->setIntegrityCheck(false);
			$query->from(array('rgu' => 'mt.restaurant_group_users'),array('rguid','rgufk_restaurant','rgufirst_name','rgulast_name','rguemail','rguphone','rgufk_rsgid','rguzipcode','rguspecial_request','rguaddress','rguallergies_dislikes','rgu_birthday','rgu_anniversary','rgusplstatus_id','rgucountrycode'))
					->join(array('res' => 'mt.restaurant'),'res.resid = rgu.rgufk_restaurant',array('resrestaurant_name'))
				  ->join(array('rsg' => 'mt.restaurant_group'),'rsg.rsgid = rgu.rgufk_rsgid',array('rsggroup'))
			  	  ->joinLeft(array('sta'=>'mt.state_bd'),'sta.id = rgu.rgustate_id',array('id as stateid','description as state'))
			  	  ->joinLeft(array('reg'=>'mt.region_bd'),'reg.id = rgu.rguregion_id',array('id as regionid','description as region'))
			   	  ->joinLeft(array('cty'=>'mt.city_bd'),'cty.id = rgu.rgucity_id',array('id as cityid','description as city'))
			  	  ->joinLeft(array('neg'=>'mt.neighborhood_bd'),'neg.id = rgu.rguneighbourhood_id',array('id as neighbid','description as neighborhood'));
			$resIdArr = array();
			if($groupusers->getRestaurantId()){
				$query->where('rgu.rgufk_restaurant = ?',$groupusers->getRestaurantId());
			}else{
//				foreach($restList as $item['key']){
//					$restaurantList = $item['key'];
//					if($restaurantList['key']){
//						if($restaurantList['key'] != 0)
//						{
//							$resIdArr[] = $restaurantList['key'];
//						}
//					}
//				}
				///$query->where('rgu.rgufk_restaurant IN(?)',$resIdArr);
			}
			if($groupusers->getGroupId()){
				$query->where('rgu.rgufk_rsgid = ?',$groupusers->getGroupId());
			}
			if($groupusers->getFirstName()){
				$query->where('rgu.rgufirst_name Ilike ?','%'.trim($groupusers->getFirstName()).'%');
			}
			if($groupusers->getLastName()){
				$query->where('rgu.rgulast_name Ilike ?','%'.trim($groupusers->getLastName().'%'));
			}
			if($groupusers->getEmail()){
				$query->where('rgu.rguemail Ilike ?','%'.trim($groupusers->getEmail().'%'));
			}
			if($groupusers->getPhone()){
				$query->where('rgu.rguphone Ilike ?','%'.trim($groupusers->getPhone().'%'));
			}
			if($groupusers->getSortOn() == 'email' && $groupusers->getSortOrder() == 'ASC'){
				$query->order(array('rgu.rguemail ASC'));
			}else if($groupusers->getSortOn() == 'email' && $groupusers->getSortOrder() == 'DESC'){
				$query->order(array('rgu.rguemail DESC'));
			}
			if($groupusers->getSortOn() == 'fname' && $groupusers->getSortOrder() == 'ASC'){
				$query->order(array('rgu.rgufirst_name ASC'));
			}else if($groupusers->getSortOn() == 'fname' && $groupusers->getSortOrder() == 'DESC'){
				$query->order(array('rgu.rgufirst_name DESC'));
			}
			if($groupusers->getSortOn() == 'lname' && $groupusers->getSortOrder() == 'ASC'){
				$query->order(array('rgu.rgulast_name ASC'));
			}else if($groupusers->getSortOn() == 'lname' && $groupusers->getSortOrder() == 'DESC'){
				$query->order(array('rgu.rgulast_name DESC'));
			}
			if($groupusers->getSortOrder()){
				$query->where('rgu.rgulast_name Ilike ?','%'.trim($groupusers->getLastName().'%'));
			}
			$query->where('rgu.rgustatus = ?',TRUE);
			$query->where('rgufk_restaurant = ?',$request->restaurantid);
			$query->order('rgu.rguid DESC');
			$Result = "";
//			if($groupusers->getRestaurantId()!='' || count($resIdArr)>0){
				$Result = new Zend_Paginator(
				new Zend_Paginator_Adapter_DbTableSelect($query)
				);
				$Result->setItemCountPerPage($limit);
				$Result->setCurrentPageNumber($offset);
//			}
			return $Result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function CheckEmail(FirmManagement_Model_FirmGroupUsers $user)
	{
		try{
			
			$db = Zend_Db_Table::getDefaultAdapter();
			$result = $db->fetchOne("select count(rguid) from mt.restaurant_group_users where rgufk_restaurant = '". $user->getRestaurantId() ."'and rguemail = '". $user->getEmail() ."'");

			if((int)$result)
			{
				$status = true;
			}else{
				$status = false;
			}
			return $status;
			
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetCustomerNames($text, $restid,$lastname)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('rguid','rgufirst_name','rgulast_name','rguphone','rguemail','rgucountrycode'));
			$select->where('rgufk_restaurant = ?',$restid);
			if($lastname){
				$select->where('rgulast_name ILIKE(?)','%'.$lastname.'%');
				$select->where('rgufirst_name ILIKE(?)','%'.$text.'%');
			}else{
				$select->where('rgufirst_name ILIKE(?)','%'.$text.'%');
			}
			$result = $table->fetchAll($select);
			$list = null;
			foreach($result as $item){
				if(!empty($text)){
						if(stristr($item['rgufirst_name'],$text))
						{
							if($item['rguphone'] != ''){
								$list[$item['rguid']] = $item['rgufirst_name']." ".$item['rgulast_name']." - ".$item['rgucountrycode'].$item['rguphone'];
							}else {
								$list[$item['rguid']] = $item['rgufirst_name']." ".$item['rgulast_name']." - ".$item['rguemail'];
							}
						}
					}else {
						if($item['rguphone'] != '' && $lastname != ''){
							$list[$item['rguid']] = $item['rgufirst_name']." ".$item['rgulast_name']." - ".$item['rgucountrycode'].$item['rguphone'];
						}else if($lastname != ''){
							$list[$item['rguid']] = $item['rgufirst_name']." ".$item['rgulast_name']." - ";
						}
					}
			}
			return $list;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function searchCusContactByName($text, $restid)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$s = "rgulast_name||' '||rgufirst_name";
			$select->from($table,array('rguid','rgufirst_name','rgulast_name','rguphone','rguemail'));
			$select->where('rgufk_restaurant = ?',$restid);
			$select->where($s.' ILIKE(?)','%'.$text.'%');
			$result = $table->fetchAll($select);
			$list = null;
			foreach($result as $item){
				if(!empty($text)){
					$str = $item['rgulast_name'].' '.$item['rgufirst_name'];
					if(stristr($str,$text))
					{
						if($item['rguphone'] != ''){
							$list[$item['rguid']] = $item['rgufirst_name']." ".$item['rgulast_name']." - ".$item['rguphone'];
						}else{
							$list[$item['rguid']] = $item['rgufirst_name']." ".$item['rgulast_name']." - ".$item['rguemail'];
						}
					}
				}else {
					if($item['rguphone'] != '' && $item['rgulast_name'] != ''){
						$list[$item['rguid']] = $item['rgufirst_name']." ".$item['rgulast_name']." - ".$item['rguphone'];
					}else if($item['rguemail'] != '' && $item['rgulast_name'] != ''){
						$list[$item['rguid']] = $item['rgufirst_name']." ".$item['rgulast_name']." - ".$item['rguemail'];
					}else if($lastname != ''){
						$list[$item['rguid']] = $item['rgufirst_name']." ".$item['rgulast_name']." - ";
					}
				}
			}
			return $list;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetCustomerDetailsById($cusid)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
//			$select->from(array('rgu' => 'mt.restaurant_group_users'),array('rgufirst_name','rgulast_name','rguemail','rguphone','rguspecial_request','rgu_birthday','rgu_anniversary','rguallergies_dislikes','rgusplstatus_id','rguaddress','rguregion_id','rgucity_id','rgustate_id','rguzipcode','rgucountrycode'))
//				   ->join(array('sta'=>'mt.state_bd'),'sta.id = rgu.rgustate_id',array('description as state'))
//				   ->joinLeft(array('reg'=>'mt.region_bd'),'reg.id = rgu.rguregion_id',array('description as region'))
//				   ->joinLeft(array('cty'=>'mt.city_bd'),'cty.id = rgu.rgucity_id',array('description as city'))
//				   ->where('rguid = ?',$cusid);
			$select->from(array('rgu' => 'mt.restaurant_group_users'),array('rgufirst_name','rgulast_name','rguemail','rguphone','rguspecial_request','rgu_birthday','rgu_anniversary','rguallergies_dislikes','rgusplstatus_id','rguaddress','rguregion_id','rgucity_id','rgustate_id','rguzipcode','rgufrqntdinner','rgublacklist','rgu_specialdays','rgucompany','rgudesignation','rgucountrycode','rgustate','rgucity','rgu_reservation_count','rgu_noshow_count','rgu_cancel_count','rgu_reschedule_count','rgu_total_count','rgu_web_count','rgu_walkin_count','rgu_facebook_count'))
			   ->joinLeft(array('spl' => 'mt.splstatus_bd'),'spl.id = rgu.rgusplstatus_id',array('description as spldesc'))
			   ->join(array('rsg' => 'mt.restaurant_group'),'rsg.rsgid = rgu.rgufk_rsgid',array('rsggroup'))
			   ->joinLeft(array('sta'=>'mt.state_bd'),'sta.id = rgu.rgustate_id',array('description as state'))
			   ->joinLeft(array('reg'=>'mt.region_bd'),'reg.id = rgu.rguregion_id',array('description as region'))
			   ->joinLeft(array('cty'=>'mt.city_bd'),'cty.id = rgu.rgucity_id',array('description as city'))
			   ->joinLeft(array('neg'=>'mt.neighborhood_bd'),'neg.id = rgu.rguneighbourhood_id',array('description as neighborhood'))
			   ->where('rguid = ?',$cusid);
			$result = $table->fetchRow($select);				
			$Obj = array(
				   	'firstName'	=>	$result->rgufirst_name,
				  	'lastName'	=>	$result->rgulast_name,
				  	'number'	=>	$result->rguphone,
					'email'		=>	$result->rguemail,
					'splreq'	=>	$result->rguspecial_request,
					'birthday'	=>	$result->rgu_birthday,
					'anniversary'=>	$result->rgu_anniversary,
					'dislikes'	=>	$result->rguallergies_dislikes,
					'id'		=>	$cusid,
					'splstatus' => $result->rgusplstatus_id,
					'spldesc'   => $result->spldesc,
					'address' => $result->rguaddress,
					'state' => $result->state,
					'city' => $result->city,
					'zipcode' => $result->rguzipcode,
					'frqntdinner' => $result->rgufrqntdinner,
					'blacklist' => $result->rgublacklist,
					'specialdays' => $result->rgu_specialdays,
					'compnyname' => $result->rgucompany,
					'md' => $result->rgudesignation,
					'countrycode'	=>  $result->rgucountrycode,
					'statetext' => $result->rgustate,
					'citytext' => $result->rgucity,
					'reservation_count' => $result->rgu_reservation_count,
					'noshow_count' 		=> $result->rgu_noshow_count,
					'cancel_count' 		=> $result->rgu_cancel_count,
					'reschedule_count' 	=> $result->rgu_reschedule_count,
					'total_count' 		=> $result->rgu_total_count,
					'web_count' 		=> $result->rgu_web_count,
					'walkin_count' 		=> $result->rgu_walkin_count,
					'facebook_count' 	=> $result->rgu_facebook_count
				);
				if($result->rgu_birthday){
					$tSel = explode('-',$result->rgu_birthday);
					if($tSel[0] > 12){
						$Obj['birthdayText'] = date("d M",mktime(0,0,0,$tSel[1],$tSel[2],$tSel[0]));					
					}else {
						$Obj['birthdayText'] = date("d M",mktime(0,0,0,$tSel[0],$tSel[1],$tSel[2]));
					}
				}
				if($result->rgu_anniversary){
					$tSel = explode('-',$result->rgu_anniversary);
					if($tSel[0] > 12){
						$Obj['anniversaryText'] = date("d M",mktime(0,0,0,$tSel[1],$tSel[2],$tSel[0]));					
					}else {
						$Obj['anniversaryText'] = date("d M",mktime(0,0,0,$tSel[0],$tSel[1],$tSel[2]));
					}
				}
				if($result->rgu_specialdays){
					$tSel = explode('-',$result->rgu_specialdays);
					if($tSel[0] > 12){
						$Obj['specialdaysText'] = date("d M",mktime(0,0,0,$tSel[1],$tSel[2],$tSel[0]));					
					}else {
						$Obj['specialdaysText'] = date("d M",mktime(0,0,0,$tSel[0],$tSel[1],$tSel[2]));
					}
				}
			
			
			return $Obj;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
		
	public function getRestCustomerDetails(FirmManagement_Model_FirmGroupUsers $userObj)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			$select->from(array('rgu' => 'mt.restaurant_group_users'),array('rguid','rguemail','rguphone','rguzipcode','rguaddress','rguspecial_request','rgucountrycode'))
				   ->join(array('rsg' => 'mt.restaurant_group'),'rsg.rsgid = rgu.rgufk_rsgid',array('rsggroup'))
				   ->joinLeft(array('sta'=>'mt.state_bd'),'sta.id = rgu.rgustate_id',array('description as state'))
				   ->joinLeft(array('reg'=>'mt.region_bd'),'reg.id = rgu.rguregion_id',array('description as region'))
				   ->joinLeft(array('cty'=>'mt.city_bd'),'cty.id = rgu.rgucity_id',array('description as city'))
				   ->joinLeft(array('neg'=>'mt.neighborhood_bd'),'neg.id = rgu.rguneighbourhood_id',array('description as neighborhood'))
				   ->where('rgu.rgufk_restaurant = ?',$userObj->getRestaurantId())
				   ->where('rgu.rgustatus = ?',TRUE);

			if($userObj->getEmail()){
				$select->where('rgu.rguemail ILIKE(?)','%'.$userObj->getEmail().'%');
			}
			if($userObj->getPhone()){
				$select->where('rgu.rguphone = ?',$userObj->getPhone());
			}				
			
			$email = "";
			$phone = "";
			$state = "";
			$region = "";
			$city = "";
			$negbor = "";
			$address = "";
			$zip = "";
			$splrqs = "";
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			if($userObj->getEmail() == "" && $userObj->getPhone() == ""){
				$email = $userObj->getEmail();
				$phone = $userObj->getPhone();
			}else{
				$result = $table->fetchRow($select);				
				if($result){
					if($result->state){
						$state = $result->state;
					}
					if($result->region){
						$region = $result->region;
					}
					if($result->city){
						$city = $result->city;
					}
					if($result->neighborhood){
						$negbor = $result->neighborhood;
					}
					if($result->rguaddress){
						$address = $result->rguaddress;
					}
					if($result->rguzipcode){
						$zip = $result->rguzipcode;
					}
					if($result->rguspecial_request){
						$splrqs = $result->rguspecial_request;
					}
					if($result->rguemail){
							$email = $result->rguemail;
					}
					if($result->rguphone){
						$phone = $result->rguphone;
					}
					if($result->rgucountrycode){
						$countrycode = $result->rgucountrycode;
					}
				}else{
					$email = $userObj->getEmail();
					$phone = $userObj->getPhone();
					$countrycode = $userObj->getcountry_code();
				} 
			}
			$Obj = array('firstname'=>	$userObj->getFirstName(),
					'lastname'		=>	$userObj->getLastName(),
				   	'Email'			=>	$email,
					'Countrycode'	=>	$countrycode,
				  	'Phone'			=>	$phone,
				  	'State'			=>	$state,
					'Region'		=>	$region,
					'City'			=>	$city,
					'Neighborhood'	=>	$negbor,
					'Address'		=>	$address,
					'ZipCode'		=>	$zip,
					'GuestNotes'=>	$splrqs		
				);			
			return $Obj;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	

	public function UpdateUserGustNotes(FirmManagement_Model_FirmGroupUsers $userObj)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$status = false;
			if($userObj->getEmail() && $userObj->getPhone()){
				$result = $db->fetchOne("select rguid from mt.restaurant_group_users where rgufk_restaurant = ".$userObj->getRestaurantId()." and rguphone = '".$userObj->getPhone()."'and rguemail ILIKE '%".$userObj->getEmail()."%'");
			}else if($userObj->getPhone()){
				$result = $db->fetchOne("select rguid from mt.restaurant_group_users where rgufk_restaurant = ".$userObj->getRestaurantId()." and rguphone = '".$userObj->getPhone()."'");
			}else if($userObj->getEmail()){
				$result = $db->fetchOne("select rguid from mt.restaurant_group_users where rgufk_restaurant = ".$userObj->getRestaurantId()." and rguemail ILIKE '%".$userObj->getEmail()."%'");
			}
			if($result){
				$set = array('rguspecial_request' => $userObj->getSplRequest());
				$where = array('rguid = ?' => $result);
				$rows_affected = $this->getDbTable()->update($set,$where);
				if($rows_affected){
					$status = true;
				}		
			}			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function UpdateCusInfo(FirmManagement_Model_FirmGroupUsers $userObj)
	{
		try{
			$status = false;
			$db = Zend_Db_Table::getDefaultAdapter();
			if($userObj->getSplRequest()){
				$set = array('rgufirst_name'	=>	$userObj->getFirstName(),
						 'rgulast_name'	 		=>	$userObj->getLastName(),
						 'rguemail'				=>	$userObj->getEmail(),
						 'rguphone'				=>	str_replace("-","",$userObj->getPhone()),
						 'rguspecial_request'	=>	$userObj->getSplRequest()
						);
			}else{
				$set = array('rgufirst_name'	=>	$userObj->getFirstName(),
						 'rgulast_name'	 		=>	$userObj->getLastName(),
						 'rguemail'				=>	$userObj->getEmail(),
						 'rguphone'				=>	str_replace("-","",$userObj->getPhone())
						);
			}
			$where = array('rguid = ?' => $userObj->getId());
			
			$rows_affected = $this->getDbTable()->update($set,$where);
			if($rows_affected){
				$status = true;
			}
			return $status;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function RetrieveRestContactsByRestId($restid)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('rguid','rgufirst_name','rgulast_name','rguemail'))
				   ->where('rgufk_restaurant = ?',$restid)
				   ->where('rguemail <> ?','')
				   ->where('rgustatus = ?',true);
				   
		   $rowset = $table->fetchAll($select);
		   return $rowset;	
		   			   
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getRestaurantContactsByRestid($restid)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('rguid','rgufk_restaurant','rgufk_rsgid','rgufirst_name','rgulast_name','rgugender','rguemail','rguphone','rguaddress','rgustatus','rgucreated_date','rguupdated_date','rgustate_id','rgucity_id','rguzipcode','rguneighbourhood_id','rguregion_id','rguspecial_request'))
				   ->where('rgufk_restaurant = ?',$restid)
				    ->limit(2000);
			$rowset = $table->fetchAll($select);
		   	$RestContacts = array();
			foreach($rowset as $key=>$value){
				$subArr = array();
				foreach($value as  $key1=>$value1){
					$subArr[$key1]= $value1;
				}
				$RestContacts[] = $subArr;
			}
			return $RestContacts;	   
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
/** Updating customer contact details by ajaxcall**/
	
	public function UpdateUserContactDetails(FirmManagement_Model_FirmGroupUsers $contactObj)
	{
		try{
			$status = false;
			$db = Zend_Db_Table::getDefaultAdapter();
			$set=array(
						'rgufirst_name'			=>	$contactObj->getFirstName(),
					    'rgulast_name'			=>	$contactObj->getLastName(),
						'rguemail'				=>	$contactObj->getEmail(),
					    'rguphone'				=>	str_replace("-","",$contactObj->getPhone()),
						'rguaddress'			=>  $contactObj->getAddress(),
						'rguzipcode'			=>  $contactObj->getZipCode(),
						'rgucountrycode'     	=>	$contactObj->getcountry_code()
						
					  );
			if($contactObj->getState()){
				$set['rgustate_id'] = $contactObj->getState();
			}else{
				$set['rgustate_id'] = null;
			}
			if($contactObj->getRegion()){
				$set['rguregion_id'] = $contactObj->getRegion();
			}else{
				$set['rguregion_id'] = null;
			}
			if($contactObj->getCity()){
				$set['rgucity_id'] = $contactObj->getCity();
			}else{
				$set['rgucity_id'] = null;
			}
			if($contactObj->getNeighbourhood()){
				$set['rguneighbourhood_id'] = $contactObj->getNeighbourhood();
			}else{
				$set['rguneighbourhood_id'] = null;
			}
			$where = array('rguid = ?' => $contactObj->getId(),'rgufk_restaurant = ?' => $contactObj->getRestaurantId());
			
			$rows_affected = $this->getDbTable()->update($set,$where);
			if($rows_affected){
				$result = array();
				$table = $this->getDbTable();
				$select = $table->select();
				$select->setIntegrityCheck(false);
				$select->from($table,array('rguid','rgufk_restaurant','rgufk_rsgid','rgufirst_name','rgulast_name','rguemail','rguphone','rguaddress','rguzipcode','rgucountrycode'));
				$select->joinLeft(array('sta'=>'mt.state_bd'),'sta.id = rgustate_id',array('id as stateid','description as state'));
				$select->joinLeft(array('reg'=>'mt.region_bd'),'reg.id = rguregion_id',array('id as regionid','description as region'));
				$select->joinLeft(array('cty'=>'mt.city_bd'),'cty.id = rgucity_id',array('id as cityid','description as city'));
				$select->joinLeft(array('neg'=>'mt.neighborhood_bd'),'neg.id = rguneighbourhood_id',array('id as neighbid','description as neighborhood'));
				$select->where('rgufk_restaurant = ?',$contactObj->getRestaurantId());
			   	$select->where('rguid  = ?',$contactObj->getId());
				$rowset = $table->fetchRow($select);
				$stateid = $rowset->stateid;
				$regionid = $rowset->regionid;
				$cityid = $rowset->cityid;
				$neighbid = $rowset->neighbid;
				if($rowset->stateid == null){
					$rowset->state = '';
					$stateid = '';
				}
				if($rowset->regionid == null){
					$rowset->region = '';
					$regionid = '';
				}
				if($rowset->cityid == null){
					$rowset->city = '';
					$cityid = '';
				}
				if($rowset->neighbid == null){
					$rowset->neighborhood = '';
					$neighbid = '';
				}
				if($rowset)
				{
					$resultarr = array('firstName'			=> $rowset->rgufirst_name,
									   'lastName'			=> $rowset->rgulast_name,	
									   'Phone'				=> $rowset->rguphone,	
									   'CountryCode'		=> $rowset->rgucountrycode,
									   'Email'				=> $rowset->rguemail,	
								       'Address'			=> $rowset->rguaddress,	
								       'Zipcode'			=> $rowset->rguzipcode,	
							           'State'				=> $rowset->state,	
								       'Region'				=> $rowset->region,	
								       'City'				=> $rowset->city,	
							           'Neighbourhood'		=> $rowset->neighborhood,
							           'State_Id'			=> $stateid,
							           'Region_Id'			=> $regionid,
							           'City_Id'			=> $cityid,
							           'Neighbor_Id'		=> $neighbid
					);
	   	
				}
				$result = $resultarr;
			}
			return $result;
			}catch (Exception $ex){
				throw new Exception($ex->getMessage()) ;
			}
	}
	
	public function GetRestaurantUsersContacts($restList,$request)
	{
		try{
			$table = $this->getDbTable();
			$query= $table->select();
			$query->setIntegrityCheck(false);
			$resultarr = array();
			
			$socialMediaMapper = new Deals_Model_RestaurantEmailBlastRequestDataMapper();
			$socialMediaTable  = $socialMediaMapper->getDbTable();
			$socialMediaSelect = $socialMediaTable->select(); 
			$socialMediaSelect->from($socialMediaTable,array('rebr_fk_contact','rebr_fk_contact_invite_status'));
			if(isset($request->specialid)){
				$socialMediaSelect->where('rebr_fk_deal = ?',$request->specialid);
			}	
							
			$query->from($table,array('rguid','rgufk_restaurant','rgufk_rsgid','rgufirst_name','rgulast_name','rguemail','rguphone','rguaddress','rguzipcode'));
			$query->joinLeft(array($socialMediaSelect),'rebr_fk_contact = rguid',array('rebr_fk_contact_invite_status as inviteStat'));
			$query->joinLeft(array('sta'=>'mt.state_bd'),'sta.id = rgustate_id',array('id as stateid','description as state'));
			$query->joinLeft(array('reg'=>'mt.region_bd'),'reg.id = rguregion_id',array('id as regionid','description as region'));
			$query->joinLeft(array('cty'=>'mt.city_bd'),'cty.id = rgucity_id',array('id as cityid','description as city'));
			$query->joinLeft(array('neg'=>'mt.neighborhood_bd'),'neg.id = rguneighbourhood_id',array('id as neighbid','description as neighborhood'))
				   ->where('rguemail <> ?','')
				   ->where('rgustatus = ?',true);
			   
		   $resIdArr = array();	
			foreach($restList as $item['key']){
				$restaurantList = $item['key'];
				if($restaurantList['key']){
					if($restaurantList['key'] != 0)
					{
						$resIdArr[] = $restaurantList['key'];
					}
				}
			}
			$query->where('rgufk_restaurant IN(?)',$resIdArr);
			$query->order('rguid DESC');
			$Result = "";
			if(count($resIdArr)>0){
				$Result = $table->fetchAll($query);
				foreach($Result as $rowset){
					$stateid = $rowset->stateid;
					$regionid = $rowset->regionid;
					$cityid = $rowset->cityid;
					$neighbid = $rowset->neighbid;
					if($rowset->stateid == null){
						$rowset->state = '';
						$stateid = '';
					}
					if($rowset->regionid == null){
						$rowset->region = '';
						$regionid = '';
					}
					if($rowset->cityid == null){
						$rowset->city = '';
						$cityid = '';
					}
					if($rowset->neighbid == null){
						$rowset->neighborhood = '';
						$neighbid = '';
					}
					$resultarr[] = array('rguid'			=> $rowset->rguid,
										'inviteStat'		=> $rowset->inviteStat,
										'firstName'			=> $rowset->rgufirst_name,
									   'lastName'			=> $rowset->rgulast_name,	
									   'Phone'				=> $rowset->rguphone,	
									   'Email'				=> $rowset->rguemail,	
								       'Address'			=> $rowset->rguaddress,	
								       'Zipcode'			=> $rowset->rguzipcode,	
							           'State'				=> $rowset->state,	
								       'Region'				=> $rowset->region,	
								       'City'				=> $rowset->city,	
							           'Neighbourhood'		=> $rowset->neighborhood,
							           'State_Id'			=> $stateid,
							           'Region_Id'			=> $regionid,
							           'City_Id'			=> $cityid,
							           'Neighbor_Id'		=> $neighbid
					);
				}
			}
			return $resultarr;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function searchCusContactByPhone($text,$phone,$email,$restid)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$s = "CONCAT(rgulast_name, rgufirst_name)";
			$textname = trim($text);
			$select->from($table,array('rguid','rgufirst_name','rgulast_name','rguphone','rguemail','rguspecial_request','rgufrqntdinner','rgublacklist','rgu_specialdays','rgu_birthday','rgu_anniversary','rgu_reservation_count','rgu_noshow_count','rgu_cancel_count','rgu_reschedule_count','rgu_total_count','rgu_web_count','rgu_walkin_count','rgu_facebook_count'));
			$select->where('rgufk_restaurant = ?',$restid);
			if ($textname && $textname != 'null') {
				$select->where($s.' ILIKE(?)','%'.$textname.'%');				
			}
			if ($phone && $phone != 'null') {
				$select->where('rguphone ILIKE(?)','%'.$phone.'%');	
			}
			if ($email && $email != 'null') {
				$select->where('rguemail'.' ILIKE(?)','%'.$email.'%');	
			}
			$rowset = $table->fetchAll($select);
			$result = array();
			$i = 0;
			if(count($rowset) <= 0){
				$table = $this->getDbTable();
				$select = $table->select();
				$select->from($table,array('rguid','rgufirst_name','rgulast_name','rguphone','rguemail','rguspecial_request','rgufrqntdinner','rgublacklist','rgu_specialdays','rgu_birthday','rgu_anniversary','rgu_reservation_count','rgu_noshow_count','rgu_cancel_count','rgu_reschedule_count','rgu_total_count','rgu_web_count','rgu_walkin_count','rgu_facebook_count'));
				$select->where('rgufk_restaurant = ?',$restid);
				if ($textname && $textname != 'null') {
					$select->where($s.' ILIKE(?)','%'.$textname.'%');				
				}
				if ($phone && $phone != 'null') {
					$select->where('rguphone ILIKE(?)','%'.$phone.'%');	
				}
				if ($email && $email != 'null') {
					$select->where('rguemail'.' ILIKE(?)','%'.$email.'%');	
				}
				$rowset = $table->fetchAll($select);
			}
			foreach($rowset as $row){
				$result[$i] = array('firstName'			=> $row->rgufirst_name,
								   'rguid'				=> $row->rguid,	
								   'Phone'				=> $row->rguphone,	
								   'Email'				=> $row->rguemail);
				if($row->rgulast_name){
					$result[$i]['lastName'] = $row->rgulast_name;
				}else{
					$result[$i]['lastName'] = '';
				}
				if($row->rgu_total_count){
					$result[$i]['Total'] = $row->rgu_total_count;
				}else{
					$result[$i]['Total'] = 0;
				}
				if($row->rgu_reservation_count){
					$result[$i]['Reserved'] = $row->rgu_reservation_count;
				}else{
					$result[$i]['Reserved'] = 0;
				}
				if($row->rgu_reschedule_count){
					$result[$i]['Reschedule'] = $row->rgu_reschedule_count;
				}else{
					$result[$i]['Reschedule'] = 0;
				}
				if($row->rgu_cancel_count){
					$result[$i]['Cancel'] = $row->rgu_cancel_count;
				}else{
					$result[$i]['Cancel'] = 0;
				}
				if($row->rgu_noshow_count){
					$result[$i]['Noshow'] = $row->rgu_noshow_count;
				}else{
					$result[$i]['Noshow'] = 0;
				}
			if($row->rgufrqntdinner){
					$result[$i]['Frqntdinner'] = $row->rgufrqntdinner;
				}
				if($row->rgublacklist){
					$result[$i]['Blacklist'] = $row->rgublacklist;
				}
				
				if($row->rgu_specialdays){
					$tSel = explode('-',$row->rgu_specialdays);
					if($tSel[0] > 12){
						$result[$i]['SplDay'] = date("d M",mktime(0,0,0,$tSel[1],$tSel[2],$tSel[0]));					
					}else {
						$result[$i]['SplDay'] = date("d M",mktime(0,0,0,$tSel[0],$tSel[1],$tSel[2]));
					}
				}
				if($row->rgu_birthday){
					$tSel = explode('-',$row->rgu_birthday);
					if($tSel[0] > 12){
						$result[$i]['Birthday'] = date("d M",mktime(0,0,0,$tSel[1],$tSel[2],$tSel[0]));					
					}else {
						$result[$i]['Birthday'] = date("d M",mktime(0,0,0,$tSel[0],$tSel[1],$tSel[2]));
					}
				}
				if($row->rgu_anniversary){
					$tSel = explode('-',$row->rgu_anniversary);
					if($tSel[0] > 12){
						$result[$i]['Anniversary'] = date("d M",mktime(0,0,0,$tSel[1],$tSel[2],$tSel[0]));					
					}else {
						$result[$i]['Anniversary'] = date("d M",mktime(0,0,0,$tSel[0],$tSel[1],$tSel[2]));
					}
				}
				if($row->rguspecial_request){
					$result[$i]['Notes'] = $row->rguspecial_request;
				}
					$i ++;
			}	
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function searchCusContactByGroupId($contactid,$restid)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$s = "CONCAT(rgulast_name, rgufirst_name)";
//			$textname = trim($text);
			$select->from($table,array('rguid','rgufirst_name','rgulast_name','rguphone','rguemail','rgu_reservation_count','rgu_noshow_count','rgu_cancel_count','rgu_reschedule_count','rgu_total_count','rgu_web_count','rgu_walkin_count','rgu_facebook_count'));
			$select->where('rgufk_restaurant = ?',$restid);
			$select->where('rguid =? ',$contactid);
			$rowset = $table->fetchAll($select);
			$result = array();
			$i = 0;
			foreach($rowset as $row){
				$result[$i] = array('firstName'			=> $row->rgufirst_name,
								   'rguid'				=> $row->rguid,	
								   'Phone'				=> $row->rguphone,	
								   'Email'				=> $row->rguemail);
				if($row->rgulast_name){
					$result[$i]['lastName'] = $row->rgulast_name;
				}else{
					$result[$i]['lastName'] = '';
				}
				if($row->rgu_total_count){
					$result[$i]['Total'] = $row->rgu_total_count;
				}else{
					$result[$i]['Total'] = 0;
				}
				if($row->rgu_reservation_count){
					$result[$i]['Reserved'] = $row->rgu_reservation_count;
				}else{
					$result[$i]['Reserved'] = 0;
				}
				if($row->rgu_reschedule_count){
					$result[$i]['Reschedule'] = $row->rgu_reschedule_count;
				}else{
					$result[$i]['Reschedule'] = 0;
				}
				if($row->rgu_cancel_count){
					$result[$i]['Cancel'] = $row->rgu_cancel_count;
				}else{
					$result[$i]['Cancel'] = 0;
				}
				if($row->rgu_noshow_count){
					$result[$i]['Noshow'] = $row->rgu_noshow_count;
				}else{
					$result[$i]['Noshow'] = 0;
				}
					$i ++;
			}	
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getReservationReportByStatus($custid,$restid,$startDate,$endDate)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$s = "rgulast_name||' '||rgufirst_name";
			$select->from($table,array('rguid','rgufirst_name','rgulast_name','rguphone','rguemail'));
			$select->where('rgufk_restaurant = ?',$restid);
			$select->where('rguid = ?',$custid);
			$rowset = $table->fetchAll($select);
			$result = array();
			$i = 0;
			foreach($rowset as $row){
				$text = $row->rgulast_name.' '.$row->rgufirst_name;
				$phone = $row->rguphone;
				$email = $row->rguemail;
				if($row->rguid == $custid){
					$mapper = new Reservation_Model_ReservationDataMapper();
					$tablee = $mapper->getDbTable();
					$selectResCount = $tablee->select();
					$sa = "boklast_name||' '||bokfirst_name";
					$statusArr = array(10,4,14,9);
					
					$dateSplit = explode(' ',$startDate);
					$smonth = date('m',strtotime($dateSplit[1]));
					$startdate = date("Y-m-d", mktime(0,0,0,$smonth,$dateSplit[0],$dateSplit[2]));
					$dateSplit = explode(' ',$endDate);
					$emonth = date('m',strtotime($dateSplit[1]));
					$enddate = date("Y-m-d", mktime(0,0,0,$emonth,$dateSplit[0],$dateSplit[2]));
					
					$selectResCount->from($tablee,array('COUNT(bokid) as bokcount','bokbooking_status_id as status'));
					$selectResCount->where('bokbooking_date >= ?',$startdate);
					$selectResCount->where('bokbooking_date <= ?',$enddate);
					$selectResCount->where('bokfk_restaurant = ?',$restid);
					$selectResCount->where('bokbooking_status_id IN (?)',$statusArr );
					$text = $row->rgulast_name.' '.$row->rgufirst_name;
					$selectResCount->where('bok_contactid = ?',$custid);	
//					$phone = $row->rguphone;
//					$email = $row->rguemail;
//					if ($phone && $email) {
//						$selectResCount->where("bokphone = '$phone' OR bokemail ILIKE('%$email%')");	
//					}else if ($phone) {
//						$selectResCount->where('bokphone = ?',$phone);	
//					}else if ($email) {
//						$selectResCount->where('bokemail'.' ILIKE(?)','%'.$email.'%');	
//					}
					$selectResCount->group('bokbooking_status_id');
					$selectResCount->order('bokbooking_status_id');
					$countResults = $tablee->fetchAll($selectResCount);
					
					$selectResCount = $tablee->select();
					$selectResCount->from($tablee,array('COUNT(bokid) as bokcount'));
					$selectResCount->where('bokfk_restaurant = ?',$restid);
//					$selectResCount->where('bokbooking_date >= ?',date("Y-m-d", strtotime($startDate)));
//					$selectResCount->where('bokbooking_date <= ?',date("Y-m-d", strtotime($endDate)));
					$selectResCount->where('bokbooking_date >= ?',$startdate);
					$selectResCount->where('bokbooking_date <= ?',$enddate);

					$text = $row->rgulast_name.' '.$row->rgufirst_name;
					$selectResCount->where('bok_contactid = ?',$custid);
//					$phone = $row->rguphone;
//					$email = $row->rguemail;
//					if ($phone && $email) {
//						$selectResCount->where("bokphone = '$phone' OR bokemail ILIKE('%$email%')");	
//					}else if ($phone) {
//						$selectResCount->where('bokphone = ?',$phone);	
//					}else if ($email) {
//						$selectResCount->where('bokemail'.' ILIKE(?)','%'.$email.'%');	
//					}
					$restcount = $tablee->fetchRow($selectResCount);
						
					$result  =  array( 'firstName'			=> $row->rgufirst_name,
									   'lastName'			=> $row->rgulast_name,	
									   'rguid'				=> $row->rguid,	
									   'Phone'				=> $row->rguphone,	
									   'Email'				=> $row->rguemail,	
									   'Total'				=> $restcount->bokcount
					);
					foreach($countResults as $row){
						if($row->status == 4){
							$result['Cancel'] = $row->bokcount; 
							$result['Reschedule'] = 0; 
							$result['Reserved'] = 0; 
							$result['Noshow'] = 0; 
						}else if($row->status == 9){
							$result['Reschedule'] = $row->bokcount; 
							$result['Reserved'] = 0; 
							$result['Noshow'] = 0;
						}else if($row->status == 10){
							$result['Reserved'] = $row->bokcount; 
							$result['Noshow'] = 0;
						}else if($row->status == 14){
							$result['Noshow'] = $row->bokcount; 
						}
					}
					if(!isset($result['Cancel'])){
						$result['Cancel'] = 0; 
					}
					if(!isset($result['Reschedule'])){
						$result['Reschedule'] = 0; 
					}
					if(!isset($result['Reserved'])){
						$result['Reserved'] = 0; 
					}
					if(!isset($result['Noshow'])){
						$result['Noshow'] = 0; 
					}
					break;
				}
			}
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function UpdateCustomerDetailsById($request)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->from(array('rgu' => 'mt.restaurant_group_users'),array('rgufk_restaurant'))
			   ->where('rguid = ?',$request->customerid);
			$result = $table->fetchRow($select);
			$restaurantid = $result->rgufk_restaurant;
			
			$mapper = new FirmManagement_Model_FirmDataMapper();
			$timezone = $mapper->GetRestaurantTimeZone($restaurantid);
			date_default_timezone_set($timezone);
			
			$status = false;
			$db = Zend_Db_Table::getDefaultAdapter();
			
			if($request->firstname) {
				$set = array(
				'rgufirst_name'			=>	$request->firstname,
				'rguemail'				=>	$request->email,
				'rguphone'				=>	str_replace("-","",$request->phone),
				'rgudesignation'		=>	$request->desig,
				'rgucompany'			=>	$request->company,
				'rguaddress'			=>	$request->address,
				'rgustate'				=>	$request->state,
				'rgucity'				=>	$request->city,
				'rguzipcode'			=>	$request->zipcode,
				'rgucountrycode'		=>	$request->countrycode,
				);			
			}
			
			if($request->lastname){
				$set['rgulast_name'] =	$request->lastname;					
			}
			
			if($request->guest) {
				$set = array(
				'rguspecial_request'	=>	$request->guest,
				);
			}if($request->dislikes) {
				$set = array(
				'rguallergies_dislikes'	=>	$request->dislikes,
				);
			}if($request->splstat) {
				$set = array(
				'rgusplstatus_id'	=>	$request->splstat,
				);
			}if($request->frqntdin) {
				$set = array(
				'rgufrqntdinner'	=>	$request->frqntdin
				);		
			}if($request->blcklst) {
				$set = array(
				'rgublacklist'	=>	$request->blcklst,
				);		
			}
//					if($request->annivrsy || $request->specialdys || $request->brthday) {
//						$set = array(
//						'rgu_anniversary'	=>	$request->annivrsy,
//						'rgu_specialdays'	=>	$request->specialdys,
//						'rgu_birthday'		=>	$request->brthday
//						);	
//					}
					
			if($request->annivrsy){
				$set['rgu_anniversary'] = $request->annivrsy;
			}					
			if($request->specialdys) {
				$set['rgu_specialdays'] = $request->specialdys;
			}
			if($request->brthday) {
				$set['rgu_birthday'] = $request->brthday;		
			}
			$set['rguupdated_date'] = date('Y-m-d H:i:s');
					
			$where = $db->quoteInto('rguid = ?',$request->customerid);
			$rows_affected = $this->getDbTable()->update($set,$where);
			if($rows_affected)
			{
				return true;
			}else{
				return false;
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

        public function UpdateContactDetailsById($request)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->from(array('rgu' => 'mt.restaurant_group_users'),array('rgufk_restaurant'))
			   ->where('rguid = ?',$request->customerid);
			$result = $table->fetchRow($select);
			$restaurantid = $result->rgufk_restaurant;
			
			$mapper = new FirmManagement_Model_FirmDataMapper();
			$timezone = $mapper->GetRestaurantTimeZone($restaurantid);
			date_default_timezone_set($timezone);
						
			$db = Zend_Db_Table::getDefaultAdapter();
			
			if($request->firstname) {
				$set = array(
				'rgufirst_name'			=>	$request->firstname,
                                'rgulast_name'                  =>      $request->lastname,   
				'rguemail'				=>	$request->email,
				'rguphone'				=>	str_replace("-","",$request->phone),                                    
				'rguaddress'			=>	$request->address,
                                'rgudesignation'		=>	$request->desig,
				'rgucompany'			=>	$request->company,				
				'rgustate'				=>	$request->state,
				'rgucity'				=>	$request->city,
				'rguzipcode'			=>	$request->zipcode,    
                                'rgucountrycode'		=>	$request->countrycode, 
                                'rguspecial_request'		=>	$request->guest,     
				'rguallergies_dislikes'         => $request->dislikes,                                 
                                'rguupdated_date'              => date('Y-m-d H:i:s'),
				);			
			}
                        
                        if(!$request->annivrsy){
				$set['rgu_anniversary'] = null;
                        }else {
                            $set['rgu_anniversary'] = $request->annivrsy;
                        }					
			if(!$request->specialdys) {
				$set['rgu_specialdays'] = null;
                        }else {
                            $set['rgu_specialdays'] = $request->specialdys;
                        }
			if(!$request->brthday) {
				$set['rgu_birthday'] = null;		
                        }else {
                            $set['rgu_birthday'] = $request->brthday;		
                        }  
                        if($request->splstat) {
				$set = array(
				'rgusplstatus_id'	=>	$request->splstat,
				);
			}
                        if($request->frqntdin) {
				$set = array(
				'rgufrqntdinner'	=>	$request->frqntdin
				);		
			}if($request->blcklst) {
				$set = array(
				'rgublacklist'	=>	$request->blcklst,
				);		
			}
                        
			$where = $db->quoteInto('rguid = ?',$request->customerid);
			$rows_affected = $this->getDbTable()->update($set,$where);
			if($rows_affected)
			{
				return true;
			}else{
				return false;
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetCustomerDetailsbybookingdata($request)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			$select->from(array('rgu' => 'mt.restaurant_group_users'),array('rgufirst_name','rgulast_name','rguemail','rguphone','rguspecial_request','rguallergies_dislikes','rgusplstatus_id','rguaddress','rgufrqntdinner','rgublacklist','rgucompany','rgudesignation','rgu_total_count','rgu_noshow_count','rgu_walkin_count','rgu_reservation_count','rgu_cancel_count'));
			$select->joinLeft(array('spl' => 'mt.splstatus_bd'),'spl.id = rgu.rgusplstatus_id',array('description as spldesc'));

			if($request->phone && $request->email) {
				$select->where("rguphone = '$request->phone' OR rguemail = '$request->email'");	
			}else if ($request->phone) {
				$select->where('rguphone = ?',$request->phone);	
			}else if ($request->email) {
				$select->where('rguemail= ?',$request->email);	
			}
			$select->where('rgufk_restaurant= ?',$request->restaurantid);			
			$rowset = $table->fetchRow($select);
			$resultarr = array();
				if($rowset){
				$resultarr = array('address'			=> $rowset->rguaddress,	
							       'allergies_dislikes'	=> $rowset->rguallergies_dislikes,
						           'frqntdinner'		=> $rowset->rgufrqntdinner,
						           'blacklist'			=> $rowset->rgublacklist,
						           'company'			=> $rowset->rgucompany,
						           'designation'		=> $rowset->rgudesignation,
								   'spldesc'			=> $rowset->spldesc,
							       'guestnote'			=> $rowset->rguspecial_request,
							       'totalcount'			=> $rowset->rgu_total_count,
								   'reservationcount'   => $rowset->rgu_reservation_count,
								   'noshowcount'		=> $rowset->rgu_noshow_count,
								   'cancelcount'		=> $rowset->rgu_cancel_count,
								   'walkincount'		=> $rowset->rgu_walkin_count
				
				);
			}
			return $resultarr;		
			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function updateGuestReservationCount($guestid, $status, $rsv_modeid)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$table = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('rgu_reservation_count','rgu_total_count','rgu_noshow_count','rgu_cancel_count','rgu_reschedule_count','rgu_web_count','rgu_walkin_count','rgu_facebook_count'))
			       ->where('rguid = ?',$guestid);
			$rowset = $table->fetchRow($select);
			if($rowset){
				if($status == 'RSD'){
					$reservationCount = $rowset->rgu_reservation_count+1;
					$totalCount = $rowset->rgu_total_count+1;
					$set = array('rgu_reservation_count' => $reservationCount,
								 'rgu_total_count' => $totalCount);
					if($rsv_modeid == 1){
						$webCount = $rowset->rgu_web_count+1;
						$set['rgu_web_count'] = $webCount;
					}else if($rsv_modeid == 2){
						$walkinCount = $rowset->rgu_walkin_count+1;
						$set['rgu_walkin_count'] = $walkinCount;
					}else if($rsv_modeid == 6){
						$facebookCount = $rowset->rgu_facebook_count+1;
						$set['rgu_facebook_count'] = $facebookCount;
					}
				}else if($status == 'NOS'){
					$reservationCount = $rowset->rgu_reservation_count-1;
					$noshowCount = $rowset->rgu_noshow_count+1;
					$set = array('rgu_reservation_count' => $reservationCount,
								 'rgu_noshow_count' => $noshowCount);
				}else if($status == 'CAN'){
					$reservationCount = $rowset->rgu_reservation_count-1;
					$cancelCount = $rowset->rgu_cancel_count+1;
					$set = array('rgu_reservation_count' => $reservationCount,
								 'rgu_cancel_count' => $cancelCount);
				}else if($status == 'SHOW'){
					$reservationCount = $rowset->rgu_reservation_count+1;
					$noshowCount = $rowset->rgu_noshow_count-1;
					$set = array('rgu_reservation_count' => $reservationCount,
								 'rgu_noshow_count' => $noshowCount);
				}		
				$where = $db->quoteInto('rguid = ?',$guestid);
				$rows_affected = $this->getDbTable()->update($set,$where);
			}			     
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getphonenumbersByresId($resid)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$table = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('rguphone'))
			       ->where('rgufk_restaurant = ?',$resid)
			       ->where('rguphone IS NOT NULL')
			       ->where('rguphone <> ?', '')
			       ->where('rgustatus = ?',true)
			       ->group('rguphone');
			$rowset = $table->fetchAll($select);
			if(count($rowset) > 0){
				 foreach($rowset as $result){
				 	$phonearrray[] = $result->rguphone;	 
 				} 
 				 $phonestring = implode(',',$phonearrray);
 				 $resultSet = array('phonestring'=> $phonestring, 'countNumbers'=> count($phonearrray));
 
				return $resultSet;
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getGuestDetailsByIdsArr($guestArr)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			
			$select->from($table,array('rguid','rgufirst_name','rgulast_name','rguemail','rguphone'))
				   ->where('rguid IN (?)',$guestArr );		
			
			$resultSet = $table->fetchAll($select);
			
			return $resultSet;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getCustomerDetailsByBookingId($bookingid)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			
//			$select->from(array('rgu' => 'mt.restaurant_group_users'),array('rguid','rgufirst_name','rgulast_name','rguemail','rguphone','rguspecial_request','rgu_birthday','rgu_anniversary','rguallergies_dislikes','rgusplstatus_id','rguaddress','rguregion_id','rgucity_id','rgustate_id','rguzipcode','rgufrqntdinner','rgublacklist','rgu_specialdays','rgucompany','rgudesignation','rgucountrycode','rgustate','rgucity','rgu_reservation_count','rgu_noshow_count','rgu_cancel_count','rgu_reschedule_count','rgu_total_count','rgu_web_count','rgu_walkin_count','rgu_facebook_count'))
//			   	   ->join(array('book' => 'mt.booking'),'rgu.rguid = book.bok_contactid',array('bokbooking_date','bokbooking_timings','bokparty_size','bokreservation_mode_id','bokbooking_type_id','bokrestaurant_note'))
//			   	   ->joinLeft(array('spl' => 'mt.splstatus_bd'),'spl.id = rgu.rgusplstatus_id',array('description as spldesc'))
//			   	   ->where('book.bokid = ?',$bookingid);
                        
                        $select->from(array('rgu' => 'mt.restaurant_group_users'),array('rguid','rguspecial_request','rgu_birthday','rgu_anniversary','rguallergies_dislikes','rgusplstatus_id','rguaddress','rguregion_id','rgucity_id','rgustate_id','rguzipcode','rgufrqntdinner','rgublacklist','rgu_specialdays','rgucompany','rgudesignation','rgucountrycode','rgustate','rgucity','rgu_reservation_count','rgu_noshow_count','rgu_cancel_count','rgu_reschedule_count','rgu_total_count','rgu_web_count','rgu_walkin_count','rgu_facebook_count'))
			   	   ->join(array('book' => 'mt.booking'),'rgu.rguid = book.bok_contactid',array('bokfirst_name','boklast_name','bokemail','bokphone','bokbooking_date','bokbooking_timings','bokparty_size','bokreservation_mode_id','bokbooking_type_id','bokrestaurant_note'))
			   	   ->joinLeft(array('spl' => 'mt.splstatus_bd'),'spl.id = rgu.rgusplstatus_id',array('description as spldesc'))
			   	   ->where('book.bokid = ?',$bookingid);
                                   
			$result = $table->fetchRow($select);
			if($result){				
				$Obj = array(
//				   	'firstName'	=>	$result->rgufirst_name,
//				  	'lastName'	=>	$result->rgulast_name,
//				  	'number'	=>	$result->rguphone,
//					'email'		=>	$result->rguemail,
                                    
                                        'firstName'	=>	$result->bokfirst_name,
				  	'lastName'	=>	$result->boklast_name,
				  	'number'	=>	$result->bokphone,
					'email'		=>	$result->bokemail,
                                    
                                    
					'splreq'	=>	$result->rguspecial_request,
					'restNotes' 	=>  $result->bokrestaurant_note,
					'birthday'	=>	$result->rgu_birthday,
					'anniversary'=>	$result->rgu_anniversary,
					'dislikes'	=>	$result->rguallergies_dislikes,
					'id'		=>	$result->rguid,
					'splstatus' => $result->rgusplstatus_id,
					'spldesc'   => $result->spldesc,
					'address' => $result->rguaddress,
					'zipcode' => $result->rguzipcode,
					'frqntdinner' => $result->rgufrqntdinner,
					'blacklist' => $result->rgublacklist,
					'specialdays' => $result->rgu_specialdays,
					'compnyname' => $result->rgucompany,
					'md' => $result->rgudesignation,
					'countrycode'	=>  $result->rgucountrycode,
					'statetext' => $result->rgustate,
					'citytext' => $result->rgucity,
					'reservation_count' => $result->rgu_reservation_count,
					'noshow_count' 		=> $result->rgu_noshow_count,
					'cancel_count' 		=> $result->rgu_cancel_count,
					'reschedule_count' 	=> $result->rgu_reschedule_count,
					'total_count' 		=> $result->rgu_total_count,
					'web_count' 		=> $result->rgu_web_count,
					'walkin_count' 		=> $result->rgu_walkin_count,
					'facebook_count' 	=> $result->rgu_facebook_count,
					'bookingtime' 		=> date("h:i A",strtotime($result->bokbooking_timings)),
					'partysize'			=> $result->bokparty_size,
					'boktypeid'			=> $result->bokbooking_type_id
				);
				if($result->bokbooking_date){
					$date = explode('-',$result->bokbooking_date);
					$Obj['bookingdate'] = date("d M Y",mktime(0,0,0,$date[1],$date[2],$date[0]));	
				}
				if($result->rgu_birthday){
					$tSel = explode('-',$result->rgu_birthday);
					if($tSel[0] > 12){
						$Obj['birthdayText'] = date("d M",mktime(0,0,0,$tSel[1],$tSel[2],$tSel[0]));					
					}else {
						$Obj['birthdayText'] = date("d M",mktime(0,0,0,$tSel[0],$tSel[1],$tSel[2]));
					}
				}
				if($result->rgu_anniversary){
					$tSel = explode('-',$result->rgu_anniversary);
					if($tSel[0] > 12){
						$Obj['anniversaryText'] = date("d M",mktime(0,0,0,$tSel[1],$tSel[2],$tSel[0]));					
					}else {
						$Obj['anniversaryText'] = date("d M",mktime(0,0,0,$tSel[0],$tSel[1],$tSel[2]));
					}
				}
				if($result->rgu_specialdays){
					$tSel = explode('-',$result->rgu_specialdays);
					if($tSel[0] > 12){
						$Obj['specialdaysText'] = date("d M",mktime(0,0,0,$tSel[1],$tSel[2],$tSel[0]));					
					}else {
						$Obj['specialdaysText'] = date("d M",mktime(0,0,0,$tSel[0],$tSel[1],$tSel[2]));
					}
				}
			}else{
				$mapper = new Reservation_Model_ReservationDataMapper();
				$boktable = $mapper->getDbTable();
				$select = $boktable->select();
				$select->from($boktable,array('bokfirst_name','boklast_name','bokphone','bokemail','bokbooking_date','bokbooking_timings','bokparty_size','bokreservation_mode_id','bokbooking_type_id','bokrestaurant_note','bokcountrycode'))
			   	       ->where('bokid = ?',$bookingid);
				$result = $boktable->fetchRow($select);
				$Obj = array('firstName'=>	$result->bokfirst_name,
					  	'lastName'		=>	$result->boklast_name,
					  	'number'		=>	$result->bokphone,
						'email'			=>	$result->bokemail,
						'bookingtime' 	=> date("h:i A",strtotime($result->bokbooking_timings)),
						'partysize'		=> $result->bokparty_size,
						'boktypeid'		=> $result->bokbooking_type_id,
						'countrycode'   =>  $result->bokcountrycode,
						'restNotes' 	=>  $result->bokrestaurant_note);
				if($result->bokbooking_date){
					$date = explode('-',$result->bokbooking_date);
					$Obj['bookingdate'] = date("d M Y",mktime(0,0,0,$date[1],$date[2],$date[0]));	
				}
			}
			return $Obj;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getCustomerContactsById($offset,$restid,$text)
	{
		try{
			$limit = 10;
			$s = "rgulast_name||' '||rgufirst_name";
			$db = Zend_Db_Table::getDefaultAdapter();
			$table = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('rgufirst_name','rgulast_name','rguemail','rguphone','rguid'));
			$select->where('rgufk_restaurant= ?',$restid);
			$select->where('rgustatus = ?',true);		
			if($text){   
		   		$select->where($s.' ILIKE(?)','%'.$text.'%');
			}
		    $select->order('rguid DESC');
		    $Result = "";
			$Result = new Zend_Paginator(
			new Zend_Paginator_Adapter_DbTableSelect($select)
			);
			$Result->setPageRange(1);
			$Result->setItemCountPerPage($limit);
			$Result->setCurrentPageNumber($offset);
		
			return $Result;
		 }catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getRestaurantContactsByRestidforTablet($restid,$offset)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('rguid','rgufk_restaurant','rgufk_rsgid','rgufirst_name','rgulast_name','rgugender','rguemail','rguphone','rguaddress','rgustatus','rgucreated_date','rguupdated_date','rgustate_id','rgucity_id','rguzipcode','rguneighbourhood_id','rguregion_id','rguspecial_request','rgu_birthday','rgu_anniversary','rgu_optinemail','rgu_occational_emails','rgucountrycode','rgucity','rgustate','rgucompany','rgudesignation','rgufrqntdinner','rgublacklist','rguallergies_dislikes','rgusplstatus_id','rgu_specialdays','rgu_reservation_count','rgu_noshow_count','rgu_cancel_count','rgu_reschedule_count','rgu_total_count','rgu_web_count','rgu_walkin_count','rgu_facebook_count'))
				   ->where('rgufk_restaurant = ?',$restid)				   
				   ->limit(1000,($offset-1));
			$rowset = $table->fetchAll($select);
		   	$result = array();
			$RestContacts = array();
		   	
		   	if(count($rowset) > 0)
		   	{
		   		$result["status"] = true;
		   		foreach($rowset as $key=>$value){
					$subArr = array();
					foreach($value as  $key1=>$value1){
						$subArr[$key1]= $value1;
					}
					$RestContacts[] = $subArr;
				}
				$result["conatcts"] = $RestContacts;
		   	}else
		   	{
		   		$result["status"] = false;
		   	}
			
			return $result;	   
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function SaveNativeCustContacts($contactlist)
	{
		try
		{
			$db = Zend_Db_Table::getDefaultAdapter();
			$db->beginTransaction();
			$resultArray = array();
			
			foreach($contactlist as $contact)
			{
				$user = new FirmManagement_Model_FirmGroupUsers();
						$user->setRestaurantId($contact->rgufk_restaurant)
							 ->setGroupId(3)
							 ->setFirstName($contact->rgufirst_name)
						     ->setLastName($contact->rgulast_name)
							 ->setEmail($contact->rguemail)
							 ->setPhone($contact->rguphone)
							 ->setSplRequest($contact->rguspecial_request)
							 ->setStatus(TRUE);
				
				$webid = $this->addUserContactToWeb($user);
				
				$resultArray[] = array('rguid' => $contact->rguid, 'rguwebid' => $webid);					
			}
			$db->commit();		    
			return $resultArray;
			
		}catch (Exception $ex){	
			$db->rollBack();
			Uss_Logger_FileLogger::info($ex->getMessage());			
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function addUserContactToWeb(FirmManagement_Model_FirmGroupUsers $user)
	{
			$db = Zend_Db_Table::getDefaultAdapter();
			$webid = 0;
			$data = array(
						'rgufk_restaurant'		=>	$user->getRestaurantId(),
						'rgufk_rsgid'			=>	$user->getGroupId(),
						'rgufirst_name'			=>	$user->getFirstName(),
						'rgulast_name'			=>	$user->getLastName(),
						'rgustatus'				=>	$user->getStatus(),	
						'rguspecial_request'	=> 	$user->getSplRequest(),					
						);
			if($user->getEmail()){
				$data['rguemail'] = $user->getEmail();
			}
			if($user->getPhone()){
				$data['rguphone'] = $user->getPhone();
			}
			
			try{
				$whtShouldIUpdate = '';
				
				if($user->getEmail() && $user->getPhone()){
					$result = $db->fetchOne("select count(rguid) from mt.restaurant_group_users where rgufk_restaurant = ".$user->getRestaurantId()." and rguphone = '".$user->getPhone()."'and rguemail ILIKE '%".$user->getEmail()."%'");
					if($result == 0)
					{
						$result =="";
						$result = $db->fetchOne("select count(rguid) from mt.restaurant_group_users where rgufk_restaurant = ".$user->getRestaurantId()." and rguphone = '".$user->getPhone()."'");
						if($result == 0){
							$result =="";
							$result = $db->fetchOne("select count(rguid) from mt.restaurant_group_users where rgufk_restaurant = ".$user->getRestaurantId()." and rguemail ILIKE '%".$user->getEmail()."%'");
							if($result == 0){
								$whtShouldIUpdate = 'Both';	
							}else{
								$whtShouldIUpdate = 'Phone';
							}
						}else{
							$whtShouldIUpdate = 'email';
						}
					}
				}else if($user->getPhone()){
					$result = $db->fetchOne("select count(rguid) from mt.restaurant_group_users where rgufk_restaurant = ".$user->getRestaurantId()." and rguphone = '".$user->getPhone()."'");
					if($result == 0)
					{
						$whtShouldIUpdate = 'Both';
					}
				}else if($user->getEmail()){
					$result = $db->fetchOne("select count(rguid) from mt.restaurant_group_users where rgufk_restaurant = ".$user->getRestaurantId()." and rguemail ILIKE '%".$user->getEmail()."%'");
					if($result == 0)
					{
						$whtShouldIUpdate = 'Both';
					}
				}else{
					if($user->getSplRequest() && !$user->getId()){
						$whtShouldIUpdate = 'Both';
					}
				}
				
				if($whtShouldIUpdate == 'Both')
				{
					$webid = $this->getDbTable()->insert($data);
					
				}else if($whtShouldIUpdate == 'email'){
					if($user->getSplRequest()){
						$set = array('rguspecial_request' => $user->getSplRequest(),
									'rguemail'			  => $user->getEmail()
									);
					}else{
						$set = array('rguemail'			  => $user->getEmail());
					}
					$where = array('rgufk_restaurant = ?'		=>	$user->getRestaurantId(),
								   'rguphone = ?'				=>	$user->getPhone()	
							);
					$rows_affected = $this->getDbTable()->update($set,$where);
					
					/* Select Updated Web Contact Id */
					if($rows_affected)
					{
						$webid = $db->fetchOne("select rguid from mt.restaurant_group_users where rgufk_restaurant = ".$user->getRestaurantId()." and rguphone = '".$user->getPhone()."'");
					}
					
				}else if($whtShouldIUpdate == 'Phone'){
					if($user->getSplRequest()){
						$set = array('rguspecial_request' => $user->getSplRequest(),
									'rguphone'			  => $user->getPhone()
									);
					}else{
						$set = array('rguphone'			  => $user->getPhone());
					}
					$where = array('rgufk_restaurant = ?'		=>	$user->getRestaurantId(),
								   'rguemail = ?'				=>	$user->getEmail()	
							);
					$rows_affected = $this->getDbTable()->update($set,$where);	
					
					/* Select Updated Web Contact Id */
					if($rows_affected)
					{
						$webid = $db->fetchOne("select rguid from mt.restaurant_group_users where rgufk_restaurant = ".$user->getRestaurantId()." and rguemail ILIKE '%".$user->getEmail()."%'");
					}					
				}else{
					if($user->getSplRequest()){
						
						$selectWebIdQuery = "";
						
						$set = array('rguspecial_request' => $user->getSplRequest());
						if($user->getId()){
							$where = array('rguid = ?' => $user->getId());							
						}else if($user->getEmail() && $user->getPhone()){
							$where = array('rgufk_restaurant = ?'	=>	$user->getRestaurantId(),
									       'rguemail ILIKE (?)'		=>	'%'.$user->getEmail().'%',
									       'rguphone = ?'				=>	$user->getPhone()	
									);
						 	$selectWebIdQuery = "select rguid from mt.restaurant_group_users where rgufk_restaurant = ".$user->getRestaurantId()." and rguphone = '".$user->getPhone()."' and rguemail ILIKE '%".$user->getEmail()."%'";
						 		
						}else if($user->getPhone()){
							$where = array('rgufk_restaurant = ?'	=>	$user->getRestaurantId(),
									       'rguphone = ?'				=>	$user->getPhone()	
									);
							$selectWebIdQuery = "select rguid from mt.restaurant_group_users where rgufk_restaurant = ".$user->getRestaurantId()." and rguphone = '".$user->getPhone()."'";
																
						}else{
							
							$where = array('rgufk_restaurant = ?'	=>	$user->getRestaurantId(),
									       'rguemail ILIKE (?)'		=>	'%'.$user->getEmail().'%'
										  );
									
						    $selectWebIdQuery = "select rguid from mt.restaurant_group_users where rgufk_restaurant = ".$user->getRestaurantId()." and rguemail ILIKE '%".$user->getEmail()."%'";
						}
												
						$rows_affected = $this->getDbTable()->update($set,$where);
						
						$webid = $db->fetchOne($selectWebIdQuery);
					}
				}
				
				if($webid == 0)
				{
					if($user->getEmail() && $user->getPhone()){
						$webid = $db->fetchOne("select rguid from mt.restaurant_group_users where rgufk_restaurant = ".$user->getRestaurantId()." and rguphone = '".$user->getPhone()."'and rguemail ILIKE '%".$user->getEmail()."%'");						
					}else if($user->getPhone()){
						$webid = $db->fetchOne("select rguid from mt.restaurant_group_users where rgufk_restaurant = ".$user->getRestaurantId()." and rguphone = '".$user->getPhone()."'");						
					}else if($user->getEmail()){
						$webid = $db->fetchOne("select rguid from mt.restaurant_group_users where rgufk_restaurant = ".$user->getRestaurantId()." and rguemail ILIKE '%".$user->getEmail()."%'");
					}
				}				
				return $webid;
			}catch(Exception $ex){	
				Uss_Logger_FileLogger::info($ex->getMessage());
				throw new Exception($ex->getMessage()) ;
			}
		}
		
	public function getRestaurantContactsForSyncByRestid($restid)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('rguid','rgufk_restaurant','rgufk_rsgid','rgufirst_name','rgulast_name','rgugender','rguemail','rguphone','rguaddress','rgustatus','rgucreated_date','rguupdated_date','rgustate_id','rgucity_id','rguzipcode','rguneighbourhood_id','rguregion_id','rguspecial_request'))
				   ->where('rgufk_restaurant = ?',$restid);
				   
			$rowset = $table->fetchAll($select);
		   	$RestContacts = array();
			foreach($rowset as $key=>$value){
				$subArr = array();
				foreach($value as  $key1=>$value1){
					$subArr[$key1]= $value1;
				}
				$RestContacts[] = $subArr;
			}
			return $RestContacts;	   
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function SaveIpadContacts($contacts)
	{
		try
		{
			$db = Zend_Db_Table::getDefaultAdapter();
			
			$resultArray = array();
			$rguidArr = array();	
			/* Save Contact details */			
			foreach($contacts as $request)			
			{			
				if($request->rgufirst_name) {
					$set = array(
						'rgufirst_name'			=>	$request->rgufirst_name,
						'rguemail'				=>	$request->rguemail,
						'rguphone'				=>	str_replace("-","",$request->rguphone),
						'rgudesignation'		=>	$request->rgudesignation,
						'rgucompany'			=>	$request->rgucompany,
						'rguaddress'			=>	$request->rguaddress,
						'rgustate'				=>	$request->rgustate,
						'rgucity'				=>	$request->rgucity,
						'rguzipcode'			=>	$request->rguzipcode,
						'rgucountrycode'		=>	$request->rgucountrycode,
					);			
				}
					
				if($request->rgulast_name){
					$set['rgulast_name'] =	$request->rgulast_name;					
				}
				
				if($request->rguspecial_request){
					$set['rguspecial_request'] =	$request->rguspecial_request;					
				}
				
				if($request->rguallergies_dislikes){
					$set['rguallergies_dislikes'] =	$request->rguallergies_dislikes;					
				}
				
				if($request->rgusplstatus_id){
					$set['rgusplstatus_id'] =	$request->rgusplstatus_id;					
				}
				
				if($request->rgufrqntdinner){
					$set['rgufrqntdinner'] =	$request->rgufrqntdinner;					
				}
				
				if($request->rgublacklist){
					$set['rgublacklist'] =	$request->rgublacklist;					
				}
				
				if($request->rgu_anniversary){
					$set['rgu_anniversary'] = $request->rgu_anniversary;
				}					
				if($request->rgu_specialdays) {
					$set['rgu_specialdays'] = $request->rgu_specialdays;
				}
				if($request->rgu_birthday) {
					$set['rgu_birthday'] = $request->rgu_birthday;		
				}
				
				$where = $db->quoteInto('rguid = ?',$request->rguid);
				$rows_affected = $this->getDbTable()->update($set,$where);
				
				$rguidArr[] = array("rguid" => $request->rguid);
				$resultArray['rguid'] = $rguidArr;
				$resultArray["status"] = true;
			}			
			return $resultArray;
			
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());			
			$result["status"] = false;
			return $result;
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getChangedRestaurantContactsByRestidforIpad($restid)
	{
		try{
			$restaurantService = new Application_Service_Firm();
			$timeZone = $restaurantService->GetRestaurantTimeZone($restid);			
			date_default_timezone_set($timeZone);
			
			$date = date('Y-m-d');
			
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('rguid','rgufk_restaurant','rgufk_rsgid','rgufirst_name','rgulast_name','rgugender','rguemail','rguphone','rguaddress','rgustatus','rgucreated_date','rguupdated_date','rgustate_id','rgucity_id','rguzipcode','rguneighbourhood_id','rguregion_id','rguspecial_request','rgu_birthday','rgu_anniversary','rgu_optinemail','rgu_occational_emails','rgucountrycode','rgucity','rgustate','rgucompany','rgudesignation','rgufrqntdinner','rgublacklist','rguallergies_dislikes','rgusplstatus_id','rgu_specialdays','rgu_reservation_count','rgu_noshow_count','rgu_cancel_count','rgu_reschedule_count','rgu_total_count','rgu_web_count','rgu_walkin_count','rgu_facebook_count'))
				   ->where('rgufk_restaurant = ?',$restid)
				   ->where("rguupdated_date::text LIKE (?) OR rgucreated_date::text LIKE (?)",'%'.$date.'%');			   
			$rowset = $table->fetchAll($select);
		   	$result = array();
			$RestContacts = array();
		   	
		   	if(count($rowset) > 0)
		   	{
		   		$result["status"] = true;
		   		foreach($rowset as $key=>$value){
					$subArr = array();
					foreach($value as  $key1=>$value1){
						$subArr[$key1]= $value1;
					}
					$RestContacts[] = $subArr;
				}
				$result["conatcts"] = $RestContacts;
		   	}else
		   	{
		   		$result["status"] = false;
		   	}
			
			return $result;	   
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function SaveTabletContacts($contacts)
	{
		try
		{
			$db = Zend_Db_Table::getDefaultAdapter();
			
			$contactsArr = $contacts->contacts;						
			$result = array();			
			/* Save Contact details */			
			foreach($contactsArr as $request)			
			{			
				if($request->rgufirst_name) {
					$set = array(
						'rgufirst_name'			=>	$request->rgufirst_name,
						'rguemail'				=>	$request->rguemail,
						'rguphone'				=>	str_replace("-","",$request->rguphone),
						'rgudesignation'		=>	$request->rgudesignation,
						'rgucompany'			=>	$request->rgucompany,
						'rguaddress'			=>	$request->rguaddress,
						'rgustate'				=>	$request->rgustate,
						'rgucity'				=>	$request->rgucity,
						'rguzipcode'			=>	$request->rguzipcode,
						'rgucountrycode'		=>	$request->rgucountrycode,
					);			
				}
					
				if($request->rgulast_name){
					$set['rgulast_name'] =	$request->rgulast_name;					
				}
				
				if($request->rguspecial_request){
					$set['rguspecial_request'] =	$request->rguspecial_request;					
				}
				
				if($request->rguallergies_dislikes){
					$set['rguallergies_dislikes'] =	$request->rguallergies_dislikes;					
				}
				
				if($request->rgusplstatus_id){
					$set['rgusplstatus_id'] =	$request->rgusplstatus_id;					
				}
				
				if($request->rgufrqntdinner){
					$set['rgufrqntdinner'] =	$request->rgufrqntdinner;					
				}
				
				if($request->rgublacklist){
					$set['rgublacklist'] =	$request->rgublacklist;					
				}
				
				if($request->rgu_anniversary){
					$set['rgu_anniversary'] = $request->rgu_anniversary;
				}					
				if($request->rgu_specialdays) {
					$set['rgu_specialdays'] = $request->rgu_specialdays;
				}
				if($request->rgu_birthday) {
					$set['rgu_birthday'] = $request->rgu_birthday;		
				}
				
				$where = $db->quoteInto('rguid = ?',$request->rguid);
				$rows_affected = $this->getDbTable()->update($set,$where);
			}
			
			$result["status"] = true;
			return $result;
			
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());			
			$result["status"] = false;
			return $result;
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * GET CUSTOMER PHONE NUMBERS BY RESID FOR RDLABS API
	 */
	public function getCustomerContactNUmbersByResId($resid)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$table = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('rguphone','rgucountrycode'))
					->joinLeft(array('mt.restaurant'),'rgufk_restaurant = resid',array('resstate_id'))
					->joinLeft(array('mt.state_bd'),'id = resstate_id',array('country_dial_code'))
			       ->where('rgufk_restaurant = ?',$resid)
			       ->where('rguphone IS NOT NULL')
			       ->where('rguphone <> ?', '')
			       ->where('rgustatus = ?',true)
			       ->setIntegrityCheck(false);
			$rowset = $table->fetchAll($select);
			$phonearrray = array();
			if(count($rowset) > 0){
				 foreach($rowset as $result){
				 	$phoneNumber = $result->rguphone;
				 	$phoneNumber = preg_replace('/\s+/', '', $phoneNumber);
				 	if(strlen($phoneNumber)<=10)
				 	{
				 		if(strlen($result->rgucountrycode)>0)
				 		{
				 			$phoneNumber = $result->rgucountrycode."".$phoneNumber;
				 		}
				 		else
				 		{
				 			$phoneNumber = $result->country_dial_code."".$phoneNumber;	
				 		}
				 	} 
				 	$phonearrray[] = $phoneNumber;	
 				} 

 				
 				 $resultSet = array('phonestring'=> $phonearrray, 'countNumbers'=> count($phonearrray));
 
				return $resultSet;
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getCustomerContactNUmbersCountByResId($resid)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$table = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('count(rguphone)'))
			       ->where('rgufk_restaurant = ?',$resid)
			       ->where('rguphone IS NOT NULL')
			       ->where('rguphone <> ?', '')
			       ->where('rgustatus = ?',true)
			       ->setIntegrityCheck(false);
			$rowset = $select->query()->fetchAll();
			return $rowset[0]['count'];
			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
		
	}
}
