<?php
class FirmManagement_Model_FirmMailChimpSettingMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('FirmManagement_Model_DbTable_FirmMailChimpSetting');
		}
		return $this->_dbTable;
	}
	
	public function SaveMailChimpSettings(FirmManagement_Model_FirmMailChimpSetting $Settings)
	{
		try{
			
			$table = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('rmcsid','rmcsfk_restaurant','rmcs_username','rmcs_apikey','rmcs_status'))
					->where('rmcsfk_restaurant = ?',$Settings->getrmcsfk_restaurant());
			$resultSet = $table->fetchRow($select);
			$id = '';
			$result = array();
			if($resultSet){
				$set = array(
							  'rmcs_username' 		=> $Settings->getrmcs_username(),
							  'rmcs_apikey'	  		=> $Settings->getrmcs_apikey(),
							  'rmcs_status'			=> $Settings->getrmcs_status(),
							  'rmcs_updatedby'		=> $Settings->getrmcs_updatedby(),
							  'rmcs_updateddate'	=> $Settings->getrmcs_updateddate()
				);
				$where = array('rmcsfk_restaurant = ?'=>$Settings->getrmcsfk_restaurant(),'rmcsid = ?'=>$resultSet->rmcsid);
				$id = $table->update($set,$where);
				$result = array('action'=>'update','result'=>$id);
			}else{
				$data = array('rmcsfk_restaurant'   => $Settings->getrmcsfk_restaurant(),
							  'rmcs_username' 		=> $Settings->getrmcs_username(),
							  'rmcs_apikey'	  		=> $Settings->getrmcs_apikey(),
							  'rmcs_status'			=> $Settings->getrmcs_status(),
							  'rmcs_createdby'		=> $Settings->getrmcs_createdby(),
							  'rmcs_createddate'	=> $Settings->getrmcs_createddate()
				);

				$id = $table->insert($data);
				$result = array('action'=>'add','result'=>$id);
			}
			return $result;
			
		}catch(Exception $ex){
    		throw new Exception($ex->getMessage()) ;
    	}
	}
	
	public function RetrieveMailChimpSettingsByRestId(FirmManagement_Model_FirmMailChimpSetting $Settings)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();

			$select->from($table,array('rmcsid','rmcsfk_restaurant','rmcs_username','rmcs_apikey','rmcs_createddate'))
				   ->where('rmcsfk_restaurant = ?',$Settings->getrmcsfk_restaurant())
				   ->where('rmcs_status = ?',$Settings->getrmcs_status());
				   
		    $row = $table->fetchRow($select);
		    
		    return $row;
			
		}catch(Exception $ex){
    		throw new Exception($ex->getMessage()) ;
    	}
	}
}