<?php
class FirmManagement_Model_FirmMailChimpSyncReportMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}


	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('FirmManagement_Model_DbTable_FirmMailChimpSyncReport');
		}
		return $this->_dbTable;
	}
	
	public function SaveContactSyncInfo(FirmManagement_Model_FirmMailChimpSyncReport $ContactSyncReport)
	{
		try{
			$table = $this->getDbTable();
			$data = array('rmcsrfk_restaurant' 		  => $ContactSyncReport->getrmcsrfk_restaurant(),
						  'rmcsr_contacts_sync_date'  => $ContactSyncReport->getrmcsr_contacts_sync_date(),
						  'rmcsr_no_of_contacts_sync' => $ContactSyncReport->getrmcsr_no_of_contacts_sync(),
						  'rmcsr_createddate'		  => $ContactSyncReport->getrmcsr_createddate(),
						  'rmcsr_createdby'			  => $ContactSyncReport->getrmcsr_createdby());
			$id = $table->insert($data);
			return $id;
			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function RetrieveContactSyncInfoByRestId(FirmManagement_Model_FirmMailChimpSyncReport $ContactSyncReport)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('rmcsrid','rmcsrfk_restaurant','rmcsr_contacts_sync_date','rmcsr_no_of_contacts_sync','rmcsr_createddate','rmcsr_createdby'))
				   ->where('rmcsrfk_restaurant = ?',$ContactSyncReport->getrmcsrfk_restaurant());
		    $rowset = $table->fetchAll($select);
		    return $rowset;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
}