<?php
class FirmManagement_Model_FirmMenuCustomizeDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('FirmManagement_Model_DbTable_FirmMenuCustomize');
		}
		return $this->_dbTable;
	}
	
	public function SaveMenuTheme(FirmManagement_Model_custommenu $Details)
    {
        try{
        	$table  = $this->getDbTable();
			$select = $table->select();
			
        	$select->from($table,array('COUNT(rmc_header_colors) as count'))
	               ->where('rmc_restaurantid = ?',$Details ->getrestid());
	        $count = 0;
			$result = $table->fetchAll($select);
        	foreach($result as $restcount){
				$count = $restcount->count;
			}
			
	        $InsertData = array('rmc_header_colors' 	=> '#'.$Details ->gettitlecolor(),
					          'rmc_category_colors' 	=> '#'.$Details->getcategorycolor(),
				              'rmc_itemname_colors' 	=> '#'.$Details->getitemnamecolor(),
	        				  'rmc_itemname_colors' 	=> '#'.$Details->getitemdesccolor(),
				              'rmc_bg_color'   			=> '#'.$Details->getbgcolor(),
				              'rmc_restaurantid' 		=> $Details ->getrestid(),    
	           				  'rmc_createdby'			=> $Details->getcreated_by(),
	           				  'rmc_create_date_time'	=> $Details->getcreated_date()
	           				  );   				
	        $UpdateData = array('rmc_header_colors' 	=> '#'.$Details ->gettitlecolor(),
					          'rmc_category_colors' 	=> '#'.$Details->getcategorycolor(),
				              'rmc_itemname_colors' 	=> '#'.$Details->getitemnamecolor(),
				              'rmc_itemdesc_colors' 	=> '#'.$Details->getitemdesccolor(),
				              'rmc_bg_color'   			=> '#'.$Details->getbgcolor(),
				              'rmc_bg_image_url' 		=> $Details->getbgimage(),    
	           				  'rmc_updatedby'			=> $Details->getupdated_by(),
	           				  'rmc_updated_date_time'	=> $Details->getupdated_date()
	           				  ); 
           	$Insert = '';
           	$Update = '';
           	if ($count == 0) {
	           	if($Details->getbgimage()){
	           		$InsertData['rmc_bg_image_url'] 		= $Details->getbgimage();
	           	}
	           	$Insert = $this->getDbTable()->insert($InsertData);
	         
        	}else {
        		if($Details->getbgimage()){
	           		$UpdateData['rmc_bg_image_url'] 		= $Details->getbgimage();
	           	}
        		$Update =  $this->getDbTable()->update($UpdateData, array('rmc_restaurantid = ?' => $Details ->getrestid()));      
        	}
        	if($Insert !='' || $Update != ''){
        		return 't';
        	}else{
        		return 'f';
        	}
        }catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getRestaurantMenuTheme($restaurantId)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();
			
        	$select->from($table,array('rmc_header_colors','rmc_category_colors','rmc_itemname_colors','rmc_itemdesc_colors','rmc_bg_color','rmc_bg_image_url'))
	               ->where('rmc_restaurantid = ?',$restaurantId);
	              
	        $result = $table->fetchRow($select);
	        $resultArr = array();
	        if($result){
		        foreach($result as $key=>$value){
		        	$resultArr[$key] = $value;
		        }
	        }
	        return $resultArr;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}