<?php

class FirmManagement_Model_FirmScheduleDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {

			$this->setDbTable('FirmManagement_Model_DbTable_FirmSchedule');
		}
		return $this->_dbTable;
	}

	public function createScheduleRes(array $resScheduleArr)
	{
		$db = Zend_Db_Table::getDefaultAdapter();
		try{
			$db->beginTransaction();
			$restId = null;
			$thistable = $this->getDbTable();
			foreach($resScheduleArr as $resSchedule){
				$restId = $resSchedule->getrssfk_restaurant();


				$select = $thistable->select();
				$select->from($thistable,array('count(rssid) as rescount'))
						->where('rssfk_restaurant = ?',$resSchedule->getrssfk_restaurant())
						->where('rssday_of_week = ?',$resSchedule->getrssday_of_week())
						->where('rssstart_time = ?',$resSchedule->getrssstart_time())
						->where('rssscheduletype_id = 1')
						->where('rssstatus = ?','T');
				$resultset = $thistable->fetchRow($select);
				$result = (int)$resultset['rescount'];
				if($result > 0){
					$db->rollback();
					$failedTime = array('day'=>$resSchedule->getrssday_of_week(),
									'time'=>$resSchedule->getrssstart_time());
					return $failedTime;
				}
				$resScheduleData = array(
					  		'rssfk_restaurant' 		  	 => $resSchedule->getrssfk_restaurant(),
							'rssday_of_week' 		     => $resSchedule->getrssday_of_week(),
							'rssstart_time'    			 =>	$resSchedule->getrssstart_time(),
							//'rssend_time' 				 =>	$resSchedule->getrssend_time(),
							'rsscreated_date' 			 => $resSchedule->getrsscreated_date(),
							'rss_createdby'				 => $resSchedule->getrss_createdby(),
							'rssscheduletype_id'		 => $resSchedule->getrssscheduletype_id(),
							'rssstatus'					 => true
				);
				$schid = $thistable->insert($resScheduleData);
				$mapper = new FirmManagement_Model_FirmScheduleTableDataMapper();
				$mapper->createInventorys($resSchedule->getinventory(),$schid);
			}
			if($restId){
				$restmapper = new FirmManagement_Model_FirmDataMapper();
				$table = $restmapper->getDbTable();
				$set   = array('resschestatus'=>true);
				$where = array('resid = ?' => $restId);
				$rows_affected = $table->update($set,$where);
			}
				
			$db->commit();
			return true;
		}catch(Exception $ex){
			$db->rollBack();
			throw new Exception($ex->getMessage()) ;
			return false;
		}
	}
	
	public function createSMCScheduleRes(array $resScheduleArr ,$schSetting)
	{
		$db = Zend_Db_Table::getDefaultAdapter();
		try{
			$db->beginTransaction();
			$restId = null;
			$schtypeMapper = new Application_Model_ScheduleTypeDataMapper();
			$status = $schSetting;
			$schTypeRes = $schtypeMapper->GetScheduleTypeByCode($status);
			$thistable = $this->getDbTable();
			foreach($resScheduleArr as $resSchedule){
				$restId = $resSchedule->getrssfk_restaurant();
				$select = $thistable->select();
				$select->from($thistable,array('count(rssid) as rescount'))
				->where('rssfk_restaurant = ?',$resSchedule->getrssfk_restaurant())
				->where('rssday_of_week = ?',$resSchedule->getrssday_of_week())
				->where('rssstart_time = ?',$resSchedule->getrssstart_time())
				->where('rssscheduletype_id = ?',$schTypeRes->getId())
				->where('rssstatus = ?','T');
				$resultset = $thistable->fetchRow($select);
				$result = (int)$resultset['rescount'];
				if($result > 0){
					$db->rollback();
					$failedTime = array('day'=>$resSchedule->getrssday_of_week(),
									'time'=>$resSchedule->getrssstart_time());
					return $failedTime;
				}
				$resScheduleData = array(
					  		'rssfk_restaurant' 		  	 => $resSchedule->getrssfk_restaurant(),
							'rssday_of_week' 		     => $resSchedule->getrssday_of_week(),
							'rssstart_time'    			 =>	$resSchedule->getrssstart_time(),
							//'rssend_time' 				 =>	$resSchedule->getrssend_time(),
							'rsscreated_date' 			 => $resSchedule->getrsscreated_date(),
							'rss_createdby'				 => $resSchedule->getrss_createdby(),
							'rssscheduletype_id'		 => $schTypeRes->getId(),
							'rss_max_count'				 => $resSchedule->getrss_max_count(),
							'rssstatus'					 => true
				);
				$schid = $thistable->insert($resScheduleData);

			}
			if($restId){
				$restmapper = new FirmManagement_Model_FirmDataMapper();
				$table = $restmapper->getDbTable();
				$set   = array('resschestatus'=>true);
				$where = array('resid = ?' => $restId);
				$rows_affected = $table->update($set,$where);
			}
				
			$db->commit();
			return true;
		}catch(Exception $ex){
			$db->rollBack();
			throw new Exception($ex->getMessage()) ;
			return false;
		}
	}
	
	public function createSpecialSchdule(array $object)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$db->beginTransaction();
			
			$splSchDetailObj = $object['SplSchDetail'];
			
			$splSchMapperObj = new FirmManagement_Model_FirmSpecialScheduleMapper();
			$rsesid = $splSchMapperObj->SaveSpecialScheduleDetails($splSchDetailObj);
			
			$restId = null;
			$thistable = $this->getDbTable();
			$resScheduleArr = array();
			$resScheduleArr = $object['resScheduleArr'];
			
			foreach($resScheduleArr as $resSchedule){
				
				$restId = $resSchedule->getrssfk_restaurant();
				
				/*$select = $thistable->select();
				$select->from($thistable,array('count(rssid) as rescount'))
					   ->where('rssfk_restaurant = ?',$resSchedule->getrssfk_restaurant())
					   ->where('rssday_of_week = ?',$resSchedule->getrssday_of_week())
					   ->where('rssstart_time = ?',$resSchedule->getrssstart_time());
				$resultset = $thistable->fetchRow($select);
				$result = (int)$resultset['rescount'];
				
				if($result > 0){
					$db->rollback();
					$failedTime = array('day'=>$resSchedule->getrssday_of_week(),
									    'time'=>$resSchedule->getrssstart_time());
					return $failedTime;
				}*/
				
				$resScheduleData = array(
		  			'rssfk_restaurant' 		  	   => $resSchedule->getrssfk_restaurant(),
					'rssday_of_week' 		       => $resSchedule->getrssday_of_week(),
					'rssstart_time'    			   => $resSchedule->getrssstart_time(),				
					'rsscreated_date' 			   => $resSchedule->getrsscreated_date(),
					'rssstatus'					   => true,
					'rssscheduletype_id'		   => $resSchedule->getrssscheduletype_id(),
					'rssfk_special_event_schedule' => $rsesid
				);
									
				$schid  = $thistable->insert($resScheduleData);
				$mapper = new FirmManagement_Model_FirmScheduleTableDataMapper();
				$mapper->createInventorys($resSchedule->getinventory(),$schid);
			}
			
			
			$db->commit();
			return true;
		}catch(Exception $ex){
			$db->rollBack();
			throw new Exception($ex->getMessage()) ;
			return false;
		}		
	}

	public function getScheduleRes($resId, $weekday)
	{
		try{
			$schtypeMapper = new Application_Model_ScheduleTypeDataMapper();
			$status = 'DRS';
			$schTypeRes = $schtypeMapper->GetScheduleTypeByCode($status);
			
			$table = $this->getDbTable();
			$select = $table->select();
			//$selectRestCuisine->setIntegrityCheck(false);
			$resultStr = "";
			$select->from($table,array('rssid','rssday_of_week','rssstart_time'))
				   ->where('rssfk_restaurant = ?',$resId)
				   ->where('rssscheduletype_id = ?',$schTypeRes->getId())
				   ->where('rssday_of_week = ?',$weekday)
				   ->where('rssstatus = ?',true)
				   ->order(array('rssstart_time'));
			$resultset = $this->getDbTable()->fetchAll($select);
			$schList = array();
			foreach($resultset as $value){
				$time = explode(":",$value->rssstart_time);
				$s = mktime($time[0],$time[1],0,0,0,0);// to convert time format of 12:30 PM PRASAD
				$stime = date("h:i A",$s);
		 	   	//$time = explode(":",$value->rssend_time);
		 	   	//$s = mktime($time[0],$time[1],0,0,0,0);// to convert time format of 12:30 PM
		 	   	//$etime =  date("h:i A",$s);
		 	   		
		 	   	$selectInven = $table->select();
		 	   	$selectInven->setIntegrityCheck(false);
		 	   	$selectInven->from(array('rst'=>'mt.restaurant_schedule_table'),array('rstid','rstno_of_tables','rsttable_pax'))
		 	   			    ->where('rststatus = ?',true)
		 	   			    ->where('rstfk_restaurant_schedule = ?',$value->rssid)
		 	   				->order(array('rstid'));
		 	   	$resultsetInven = $this->getDbTable()->fetchAll($selectInven);
		 	   	$schInven = array();
		 	   	foreach($resultsetInven as $valueInven){
		 	   		$schInvenArr = array(
								'inventoryid' => $valueInven->rstid,
								'tablepax' 	  => $valueInven->rsttable_pax,
								'tablesize'	  => $valueInven->rstno_of_tables);
					 	   		$schInven[$valueInven->rsttable_pax] = $schInvenArr;					 	   			
				}
				for($i = 1; $i <= 20; $i++){
					if(!array_key_exists($i,$schInven)){
						$schInvenArr = array('inventoryid' => 0,
											'tablepax' 	  => $i,
											'tablesize'	  => 0);
					 	   		$schInven[$i] = $schInvenArr;
					}	
				}
				$schRowArr = array(
						'schid'		=>  $value->rssid,
						'day' 		=>	$value->rssday_of_week,
						'starttime' =>	$stime,
							 	   	//'endtime'	=>	$etime,
						'inventory'	=>	$schInven);
				$schList[] = $schRowArr;
			}
			return $schList;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getSMCScheduleRes($resId, $weekday)
	{
		try{
			$resMapper = new FirmManagement_Model_FirmDataMapper();
			$schSetting = $resMapper->getScheduleSettingTypeByresId($resId);
			$schtypeMapper = new Application_Model_ScheduleTypeDataMapper();
			$status = $schSetting['settingType'];
			$schTypeRes = $schtypeMapper->GetScheduleTypeByCode($status);
			
			$table = $this->getDbTable();
			$select = $table->select();
			//$selectRestCuisine->setIntegrityCheck(false);
			$resultStr = "";
			$select->from($table,array('rssid','rssday_of_week','rssstart_time','rss_max_count'))
			 	   ->where('rssfk_restaurant = ?',$resId)
			 	   ->where('rssscheduletype_id = ?',$schTypeRes->getId())
			 	   ->where('rssday_of_week = ?',$weekday)
			 	   ->where('rssstatus = ?',true)
			 	   ->order(array('rssstart_time'));
	 	   	$resultset = $this->getDbTable()->fetchAll($select);
	 	   	$schList = array();
	 	   	foreach($resultset as $value){
		 	   	$time = explode(":",$value->rssstart_time);
		 	   	$s = mktime($time[0],$time[1],0,0,0,0);// to convert time format of 12:30 PM PRASAD
		 	   	$stime = date("h:i A",$s);
		 	   	$schRowArr = array(
									'schid'		=>  $value->rssid,
									'day' 		=>	$value->rssday_of_week,
									'starttime' =>	$stime,
		 	   						'maxcount'  =>	$value->rss_max_count
					 	   	);
		 	   	$schList[] = $schRowArr;
	 	   }
	 	   return $schList;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getScheduleStatusOfDay($resId, $weekday, $schsetting)
	{
		try{
			$schtypeMapper = new Application_Model_ScheduleTypeDataMapper();
			if($schsetting == 'UL' || $schsetting == 'SMC'){
				$status = $schsetting;
			}else{
				$status = 'DRS';
			}
			$schTypeRes = $schtypeMapper->GetScheduleTypeByCode($status);
			
			$table = $this->getDbTable();
			$select = $table->select();
			$resultStr = "";
			$select->from($table,array('COUNT(rssid) as count'))
				   ->where('rssfk_restaurant = ?',$resId)
				   ->where('rssscheduletype_id = ?',$schTypeRes->getId())
				   ->where('rssday_of_week = ?',$weekday)
				   ->where('rssstatus = ?',true);
			$resultset = $this->getDbTable()->fetchAll($select);
			$count = 0;
			foreach($resultset as $value){
				$count = $value->count;
			}
			return $count;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getSpecialScheduleRes($resId,$eventid)
	{
		try{
			$schtypeMapper = new Application_Model_ScheduleTypeDataMapper();
			$status = 'SES';
			$schTypeRes = $schtypeMapper->GetScheduleTypeByCode($status);
			
			$table = $this->getDbTable();
			$select = $table->select();
			//$selectRestCuisine->setIntegrityCheck(false);
			$resultStr = "";
			$select->from($table,array('rssid',
						   'rssday_of_week', 
					 	   'rssstart_time'
					 	   ))
					 	   ->where('rssfk_restaurant = ?',$resId)
					 	   ->where('rssscheduletype_id = ?',$schTypeRes->getId())
					 	   ->where('rssfk_special_event_schedule = ?',$eventid)
					 	   ->where('rssstatus = ?',true)
					 	   ->order(array('rssstart_time'));
					 	   $resultset = $this->getDbTable()->fetchAll($select);
					 	   $schList = array();
					 	   foreach($resultset as $value){
					 	   	$time = explode(":",$value->rssstart_time);
					 	   	$s = mktime($time[0],$time[1],0,0,0,0);// to convert time format of 12:30 PM PRASAD
					 	   	$stime = date("h:i A",$s);
					 	   	//$time = explode(":",$value->rssend_time);
					 	   	//$s = mktime($time[0],$time[1],0,0,0,0);// to convert time format of 12:30 PM
					 	   	//$etime =  date("h:i A",$s);
					 	   		
					 	   	$selectInven = $table->select();
					 	   	$selectInven->setIntegrityCheck(false);
					 	   	$selectInven->from(array('rst'=>'mt.restaurant_schedule_table'),array('rstid','rstno_of_tables','rsttable_pax'))
					 	   	->where('rststatus = ?',true)
					 	   	->where('rstfk_restaurant_schedule = ?',$value->rssid)
					 	   	->order(array('rstid'));
					 	   	$resultsetInven = $this->getDbTable()->fetchAll($selectInven);
					 	   	$schInven = array();
					 	   	foreach($resultsetInven as $valueInven){
					 	   		$schInvenArr = array(
					'inventoryid' => $valueInven->rstid,
					'tablepax' 	  => $valueInven->rsttable_pax,
					'tablesize'	  => $valueInven->rstno_of_tables
					 	   		);
					 	   		$schInven[] = $schInvenArr;
					 	   			
					 	   	}
					 	   	$schRowArr = array(
				'schid'		=>  $value->rssid,
				'day' 		=>	$value->rssday_of_week,
				'starttime' =>	$stime,
					 	   	//'endtime'	=>	$etime,
				'inventory'	=>	$schInven
					 	   	);
					 	   	$schList[] = $schRowArr;
					 	   }
					 	   return $schList;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function updateScheduleRes(array $resScheduleArr)
	{
			$db = Zend_Db_Table::getDefaultAdapter();
			try{
				$db->beginTransaction();
				$restId = null;
				$table = $this->getDbTable();
				foreach($resScheduleArr as $resSchedule){
					$restId = $resSchedule->getrssfk_restaurant();

					$schid = $resSchedule->getrssid();
					if($resSchedule->getrssid()){
						$set 	= array(
					 	'rssfk_restaurant' 		  	 => $resSchedule->getrssfk_restaurant(),
						'rssday_of_week' 		     => $resSchedule->getrssday_of_week(),
						'rssstart_time'    			 =>	$resSchedule->getrssstart_time(),
						//'rssend_time' 				 =>	$resSchedule->getrssend_time(),
						'rssupdated_date' 			 => $resSchedule->getrsscreated_date(),
						'rss_updatedby'				 => $resSchedule->getrss_createdby(),
						'rssscheduletype_id'		 => $resSchedule->getrssscheduletype_id()
						);
						$where 	= array('rssid = ?' => $resSchedule->getrssid());
						$rows_affected = $table->update($set,$where);
							
					}else{
							
						$select = $table->select();
						$select->from($table,array('count(rssid) as rescount'))
						->where('rssfk_restaurant = ?',$resSchedule->getrssfk_restaurant())
						->where('rssday_of_week = ?',$resSchedule->getrssday_of_week())
						->where('rssstart_time = ?',$resSchedule->getrssstart_time())
						->where('rssscheduletype_id = ?',$resSchedule->getrssscheduletype_id())
						->where('rssstatus = ?',true);
						$resultset = $table->fetchRow($select);
						$result = (int)$resultset['rescount'];
						if($result > 0){
							$db->rollBack();
							$failedTime = array('day'=>$resSchedule->getrssday_of_week(),
										'time'=>$resSchedule->getrssstart_time());
							return $failedTime;
						}
						$resScheduleData = array(
				  		'rssfk_restaurant' 		  	 => $resSchedule->getrssfk_restaurant(),
						'rssday_of_week' 		     => $resSchedule->getrssday_of_week(),
						'rssstart_time'    			 =>	$resSchedule->getrssstart_time(),
						//'rssend_time' 				 =>	$resSchedule->getrssend_time(),
						'rsscreated_date' 			 => $resSchedule->getrsscreated_date(),
						'rss_createdby'				 => $resSchedule->getrss_createdby(),
						'rssscheduletype_id'		 => $resSchedule->getrssscheduletype_id(),
						'rssstatus'					 => true
						);
						$schid = $table->insert($resScheduleData);

					}


					$mapper = new FirmManagement_Model_FirmScheduleTableDataMapper();
					$mapper->createInventorys($resSchedule->getinventory(),$schid);
				}
				/*if($restId){
				 $restmapper = new FirmManagement_Model_FirmDataMapper();
				 $table = $restmapper->getDbTable();
				 $set   = array('resschestatus'=>true);
				 $where = array('resid = ?' => $restId);
				 $rows_affected = $table->update($set,$where);
				 }*/
					
				$db->commit();
				return true;
			}catch(Exception $ex){
				$db->rollBack();
				throw new Exception($ex->getMessage()) ;
				return false;
			}
		//return $resMenuId;
	}
	
	public function updateScheduleResFromManage(array $resScheduleArr)
	{
			try{
				$restId = null;
				$table = $this->getDbTable();
				$mapper = new FirmManagement_Model_FirmScheduleTableDataMapper();
				foreach($resScheduleArr as $resSchedule){
					$restId = $resSchedule->getrssfk_restaurant();

					$schid = $resSchedule->getrssid();
					if($resSchedule->getrssid()){
						$set 	= array(
					 	'rssfk_restaurant' 		  	 => $resSchedule->getrssfk_restaurant(),
						'rssday_of_week' 		     => $resSchedule->getrssday_of_week(),
						'rssstart_time'    			 =>	$resSchedule->getrssstart_time(),
						//'rssend_time' 				 =>	$resSchedule->getrssend_time(),
						'rssupdated_date' 			 => $resSchedule->getrsscreated_date(),
						'rss_updatedby'				 => $resSchedule->getrss_createdby(),
						'rssscheduletype_id'		 => $resSchedule->getrssscheduletype_id()
						);
						$where 	= array('rssid = ?' => $resSchedule->getrssid());
						$rows_affected = $table->update($set,$where);
							
					}else{
							
						$select = $table->select();
						$select->from($table,array('rssid'))
						->where('rssfk_restaurant = ?',$resSchedule->getrssfk_restaurant())
						->where('rssday_of_week = ?',$resSchedule->getrssday_of_week())
						->where('rssstart_time = ?',$resSchedule->getrssstart_time())
						->where('rssscheduletype_id = ?',$resSchedule->getrssscheduletype_id())
						->where('rssstatus = ?',true);
						$resultset = $table->fetchRow($select);
						$result = $resultset['rssid'];
						if($result > 0){
							//  inactivating schedule tables of schedules
							$setTab = array('rststatus' => 0);
							$whereTab = array('rstfk_restaurant_schedule = ?'=> $result);
							$rows_affected = $mapper->getDbTable()->update($setTab,$whereTab);
							// inactivating schedules
							$set = array('rssstatus' => 0);
							$where = array('rssfk_restaurant = ?' => $resSchedule->getrssfk_restaurant(),'rssid = ?' => $result);								
							$effected_row = $this->getDbTable()->update($set,$where);
							
//							$set 	= array(
//						 	'rssfk_restaurant' 		  	 => $resSchedule->getrssfk_restaurant(),
//							'rssday_of_week' 		     => $resSchedule->getrssday_of_week(),
//							'rssstart_time'    			 =>	$resSchedule->getrssstart_time(),
//							//'rssend_time' 				 =>	$resSchedule->getrssend_time(),
//							'rssupdated_date' 			 => $resSchedule->getrsscreated_date(),
//							'rssscheduletype_id'		 => $resSchedule->getrssscheduletype_id()
//							);
//							$where 	= array('rssid = ?' => $resSchedule->getrssid());
//							$rows_affected = $table->update($set,$where);

//							$mapper = new FirmManagement_Model_FirmScheduleTableDataMapper();
//							$mapper->createInventorys($resSchedule->getinventory(),$schid);
//							continue;
						}
						$resScheduleData = array(
				  		'rssfk_restaurant' 		  	 => $resSchedule->getrssfk_restaurant(),
						'rssday_of_week' 		     => $resSchedule->getrssday_of_week(),
						'rssstart_time'    			 =>	$resSchedule->getrssstart_time(),
						//'rssend_time' 				 =>	$resSchedule->getrssend_time(),
						'rsscreated_date' 			 => $resSchedule->getrsscreated_date(),
						'rss_createdby'				 => $resSchedule->getrss_createdby(),
						'rssscheduletype_id'		 => $resSchedule->getrssscheduletype_id(),
						'rssstatus'					 => true
						);
						$schid = $table->insert($resScheduleData);

					}
					$mapper->createInventorys($resSchedule->getinventory(),$schid);
				}
				/*if($restId){
				 $restmapper = new FirmManagement_Model_FirmDataMapper();
				 $table = $restmapper->getDbTable();
				 $set   = array('resschestatus'=>true);
				 $where = array('resid = ?' => $restId);
				 $rows_affected = $table->update($set,$where);
				 }*/
					
				return true;
			}catch(Exception $ex){
				throw new Exception($ex->getMessage()) ;
				return false;
			}
		//return $resMenuId;
	}
	
	public function updateSMCScheduleResFromManage(array $resScheduleArr)
	{
			try{
				$restId = null;
				$table = $this->getDbTable();
				$mapper = new FirmManagement_Model_FirmScheduleTableDataMapper();
				foreach($resScheduleArr as $resSchedule){
					$restId = $resSchedule->getrssfk_restaurant();

					$schid = $resSchedule->getrssid();
					if($resSchedule->getrssid()){
						$set 	= array(
						 	'rssfk_restaurant' 		  	 => $resSchedule->getrssfk_restaurant(),
							'rssday_of_week' 		     => $resSchedule->getrssday_of_week(),
							'rssstart_time'    			 =>	$resSchedule->getrssstart_time(),
							'rssupdated_date' 			 => $resSchedule->getrsscreated_date(),
							'rss_updatedby'				 => $resSchedule->getrss_createdby(),
							'rssscheduletype_id'		 => $resSchedule->getrssscheduletype_id()							
						);
						if($resSchedule->getrss_max_count()){
							$set['rss_max_count'] = $resSchedule->getrss_max_count();
						}
						$where 	= array('rssid = ?' => $resSchedule->getrssid());
						$rows_affected = $table->update($set,$where);
							
					}else{
							
						$select = $table->select();
						$select->from($table,array('rssid'))
								->where('rssfk_restaurant = ?',$resSchedule->getrssfk_restaurant())
								->where('rssday_of_week = ?',$resSchedule->getrssday_of_week())
								->where('rssstart_time = ?',$resSchedule->getrssstart_time())
								->where('rssscheduletype_id = ?',$resSchedule->getrssscheduletype_id())
								->where('rssstatus = ?',true);
						$resultset = $table->fetchRow($select);
						$result = $resultset['rssid'];
						if($result > 0){
							// inactivating schedules
							$set = array('rssstatus' => 0);
							$where = array('rssfk_restaurant = ?' => $resSchedule->getrssfk_restaurant(),'rssid = ?' => $result);								
							$effected_row = $this->getDbTable()->update($set,$where);
							
						}
						$resScheduleData = array(
					  		'rssfk_restaurant' 		  	 => $resSchedule->getrssfk_restaurant(),
							'rssday_of_week' 		     => $resSchedule->getrssday_of_week(),
							'rssstart_time'    			 =>	$resSchedule->getrssstart_time(),
							//'rssend_time' 				 =>	$resSchedule->getrssend_time(),
							'rsscreated_date' 			 => $resSchedule->getrsscreated_date(),
							'rss_createdby'				 => $resSchedule->getrss_createdby(),
							'rssscheduletype_id'		 => $resSchedule->getrssscheduletype_id(),
							'rssstatus'					 => true
						);
						if($resSchedule->getrss_max_count()){
							$resScheduleData['rss_max_count'] = $resSchedule->getrss_max_count();
						}
						$schid = $table->insert($resScheduleData);

					}
				}
				return true;
			}catch(Exception $ex){
				throw new Exception($ex->getMessage()) ;
				return false;
			}
		//return $resMenuId;
	}

	public function updateSpecialScheduleRes(array $resScheduleArr)
	{
		$db = Zend_Db_Table::getDefaultAdapter();
		try{
			$db->beginTransaction();
			$restId = null;
			$table = $this->getDbTable();
			foreach($resScheduleArr as $resSchedule){
				$restId = $resSchedule->getrssfk_restaurant();

				$schid = $resSchedule->getrssid();
				if($resSchedule->getrssid()){
					$set 	= array(
				 	'rssfk_restaurant' 		  	   => $resSchedule->getrssfk_restaurant(),
					'rssday_of_week' 		       => $resSchedule->getrssday_of_week(),
					'rssstart_time'    			   => $resSchedule->getrssstart_time(),
					'rssupdated_date' 			   => $resSchedule->getrsscreated_date(),
					'rssscheduletype_id'		   => $resSchedule->getrssscheduletype_id(),
					'rssfk_special_event_schedule' => $resSchedule->getrssfk_special_event_schedule()
					);
					$where 	= array('rssid = ?' => $resSchedule->getrssid());
					$rows_affected = $table->update($set,$where);
						
				}else{
						
					$select = $table->select();
					$select->from($table,array('count(rssid) as rescount'))
					->where('rssfk_restaurant = ?',$resSchedule->getrssfk_restaurant())
					->where('rssday_of_week = ?',$resSchedule->getrssday_of_week())
					->where('rssstart_time = ?',$resSchedule->getrssstart_time())
					->where('rssscheduletype_id = ?',$resSchedule->getrssscheduletype_id())
					->where('rssfk_special_event_schedule = ?',$resSchedule->getrssfk_special_event_schedule())
					->where('rssstatus = ?',true);
					$resultset = $table->fetchRow($select);
					$result = (int)$resultset['rescount'];
					if($result > 0){
						$db->rollBack();
						$failedTime = array('day'=>$resSchedule->getrssday_of_week(),
									'time'=>$resSchedule->getrssstart_time());
						return $failedTime;
					}
					$resScheduleData = array(
			  		'rssfk_restaurant' 		  	   => $resSchedule->getrssfk_restaurant(),
					'rssday_of_week' 		       => $resSchedule->getrssday_of_week(),
					'rssstart_time'    			   =>	$resSchedule->getrssstart_time(),
					'rssscheduletype_id'		   => $resSchedule->getrssscheduletype_id(),
					'rssfk_special_event_schedule' => $resSchedule->getrssfk_special_event_schedule(),
					'rsscreated_date' 			   => $resSchedule->getrsscreated_date(),
					'rssstatus'					   => true
					);
					$schid = $table->insert($resScheduleData);

				}


				$mapper = new FirmManagement_Model_FirmScheduleTableDataMapper();
				$mapper->createInventorys($resSchedule->getinventory(),$schid);
			}
			/*if($restId){
			 $restmapper = new FirmManagement_Model_FirmDataMapper();
			 $table = $restmapper->getDbTable();
			 $set   = array('resschestatus'=>true);
			 $where = array('resid = ?' => $restId);
			 $rows_affected = $table->update($set,$where);
			 }*/
				
			$db->commit();
			return true;
		}catch(Exception $ex){
			$db->rollBack();
			throw new Exception($ex->getMessage()) ;
			return false;
		}
	}
	
	public function deleteScheduleRes(FirmManagement_Model_FirmSchedule  $resSch)
	{
		$db = Zend_Db_Table::getDefaultAdapter();
		try{
			$db->beginTransaction();

			$mapper = new FirmManagement_Model_FirmScheduleTableDataMapper();
			$mapper->deleteInventoryBySchId($resSch->getrssid());
			$set = array('rssstatus' => 0);
			$where = array('rssfk_restaurant = ?' => $resSch->getrssfk_restaurant(),'rssid = ?' => $resSch->getrssid());
				
			$effected_row = $this->getDbTable()->update($set,$where);
			
			$updatestatMapper = new FirmManagement_Model_FirmScheduleUpdateStatusMapper();
			$updatestatMapper->changeRestScheduleUpdatedStatusFlag($resSch->getrssfk_restaurant(), true);
			
			$db->commit();
			return true;
		}catch(Exception $ex){
			$db->rollBack();
			throw new Exception($ex->getMessage()) ;
			return false;
		}
	}
	
	public function deleteSMCScheduleRes(FirmManagement_Model_FirmSchedule  $resSch)
	{
		$db = Zend_Db_Table::getDefaultAdapter();
		try{
			$db->beginTransaction();

			$mapper = new FirmManagement_Model_FirmScheduleTableDataMapper();
			$mapper->deleteInventoryBySchId($resSch->getrssid());
			$set = array('rssstatus' => 0);
			$where = array('rssfk_restaurant = ?' => $resSch->getrssfk_restaurant(),'rssid = ?' => $resSch->getrssid());
				
			$effected_row = $this->getDbTable()->update($set,$where);
			
			$updatestatMapper = new FirmManagement_Model_FirmScheduleUpdateStatusMapper();
			$updatestatMapper->changeRestScheduleUpdatedStatusFlag($resSch->getrssfk_restaurant(), true);
			
			$db->commit();
			return true;
		}catch(Exception $ex){
			$db->rollBack();
			throw new Exception($ex->getMessage()) ;
			return false;
		}
	}

	public function RestaurantScheduleCount($restaurantid)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$resultStr = "";
			$select->from($table,array('count(rssid) as rescount'))
			->where('rssfk_restaurant = ?',$restaurantid)
			->where('rssstatus = ?',true);
			$resultset = $table->fetchRow($select);
			$result = $resultset['rescount'];
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function RestaurantScheduleTimings(FirmManagement_Model_FirmSchedule $schObj)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			
			/* get restaurant Schedule setting type */
			$resDataMapper = new FirmManagement_Model_FirmDataMapper();
			$seetingArr = $resDataMapper->getScheduleSettingTypeByresId($schObj->getrssfk_restaurant());
			$settingType = $seetingArr['settingType'];
			
			/* Check Whether the selected date contains any special schedule */
			$restSpecialSchObject = new FirmManagement_Model_FirmSpecialSchedule();
			$restSpecialSchObject->setrsesfk_restaurant($schObj->getrssfk_restaurant());
			$restSpecialSchObject->setrseseventdate($schObj->getdate());
			
			$restSplSchMapperObj = new FirmManagement_Model_FirmSpecialScheduleMapper();			
			$splSchRow = $restSplSchMapperObj->CheckSpecialScheduleAvilable($restSpecialSchObject);
			$resultStr = "";
			$select->from($table,array('rssid','rssstart_time'))
				   ->where('rssfk_restaurant = ?',$schObj->getrssfk_restaurant())
				   ->where('rssday_of_week = ?',$schObj->getrssday_of_week())
				   ->where('rssstatus = ?',true);
				   
			if($splSchRow){
				$select->where('rssscheduletype_id = ?',2);
				$select->where('rssfk_special_event_schedule = ?',$splSchRow->rsesid);	
			}else{
				if($settingType == 'UL'){
					$select->where('rssscheduletype_id = ?',3);
				}else if($settingType == 'SMC'){
					$select->where('rssscheduletype_id = ?',4);
				}else{
					$select->where('rssscheduletype_id = ?',1);
				}
			}
				   
			$select->order(array('rssstart_time'));

			$resultset = $table->fetchAll($select);
			$timeArr = array();
			foreach($resultset as $row){
					
				$time = explode(":",$row->rssstart_time);
				$s = mktime($time[0],$time[1],$time[2],0,0,0);
				$startTime =  date("h:i A",$s);
				//$time = explode(":",$row->rssend_time);
				//$s = mktime($time[0],$time[1],$time[2],0,0,0);
				//$endTime =  date("h:i A",$s);
					
				$time = array(  'st'=> $startTime,
				//'et'=> $endTime,
							'schid'=> $row->rssid);	
				$timeArr[] = $time;
			}
			return $timeArr;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function RestaurantScheduleTimingsFreeze(FirmManagement_Model_FirmSchedule $schObj,$date)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$resultStr = "";
			
			/* Check Whether the selected date contains any special schedule */
			$restSpecialSchObject = new FirmManagement_Model_FirmSpecialSchedule();
			$restSpecialSchObject->setrsesfk_restaurant($schObj->getrssfk_restaurant());
			$restSpecialSchObject->setrseseventdate($date);
			
			$restSplSchMapperObj = new FirmManagement_Model_FirmSpecialScheduleMapper();			
			$splSchRow = $restSplSchMapperObj->CheckSpecialScheduleAvilable($restSpecialSchObject);	
			
			$restMapperObj = new FirmManagement_Model_FirmDataMapper();
			$restSchSettingObj = $restMapperObj->getScheduleSettingTypeByresId($schObj->getrssfk_restaurant());
			
			$select->from($table,array('rssid','rssstart_time'))
				   ->where('rssfk_restaurant = ?',$schObj->getrssfk_restaurant())
				   ->where('rssday_of_week = ?',$schObj->getrssday_of_week());
			
			if($schObj->getrssstart_time() && $schObj->getrssend_time()){   
				$select->where('rssstart_time >= ?',$schObj->getrssstart_time());
				$select->where('rssstart_time <= ?',$schObj->getrssend_time());
			}
			$select->where('rssstatus = ?',true);
			if($splSchRow){
				$select->where('rssscheduletype_id = ?',2);
				$select->where('rssfk_special_event_schedule = ?',$splSchRow->rsesid);	
			}else{
				if($restSchSettingObj['settingType'] == 'UL'){
					$select->where('rssscheduletype_id = ?',3);
				}else if($restSchSettingObj['settingType'] == 'SMC'){
					$select->where('rssscheduletype_id = ?',4);
				}else if($restSchSettingObj['settingType'] == 'SL'){
					$select->where('rssscheduletype_id = ?',1);
				}else{
					$select->where('rssscheduletype_id = ?',1);
				}				
			}			
			$select->order(array('rssstart_time'));

			$resultset = $table->fetchAll($select);
			$timeArr = array();
			$frzmapper = new Reservation_Model_RestaurantFreezeDataMapper();
			$frzDates = $frzmapper->GetFreezedDates($schObj->getrssfk_restaurant());
			$dateSearch = array_search($date,$frzDates);
			$dateVarType = gettype($dateSearch);
			if($dateVarType == 'integer'){
				$frzmapper = new Reservation_Model_RestaurantFreezeDataMapper();
				$mappertable = $frzmapper->getDbTable();
				$mapperSelect = $mappertable->select();
				$mapperSelect->from($mappertable,array('frzfreezedate','frzid','frztype','frzdesc'))
							 ->where('frzfk_restaurant = ?',$schObj->getrssfk_restaurant())
							 ->where('frzfreezedate = ?',$date);
				if($restSchSettingObj['settingType'] == 'UL'){
					$mapperSelect->where('frz_restsch_setting_id = ?',2);
				}else if($restSchSettingObj['settingType'] == 'SMC'){
					$mapperSelect->where('frz_restsch_setting_id = ?',3);
				}else if($restSchSettingObj['settingType'] == 'SL'){
					$mapperSelect->where('frz_restsch_setting_id = ?',1);
				}else{
					$mapperSelect->where('frz_restsch_setting_id = ?',1);
				}	
				$mapperResult = $mappertable->fetchRow($mapperSelect);
				if(trim($mapperResult->frztype) == 'All'){
					foreach($resultset as $row){
						$time = explode(":",$row->rssstart_time);
						$s = mktime($time[0],$time[1],$time[2],0,0,0);
						$startTime =  date("h:i A",$s);
						$timeArr[$row->rssid] = array($startTime=>'frz');
					}
				}else{
					$mapper = new Reservation_Model_RestaurantFreezeTimeMapDataMapper();
					$frzTable = $mapper->getDbTable();
					$frzSelect = $frzTable->select();
					$frzSelect->setIntegrityCheck(false);
					$frzSelect->from(array('rft'=>'mt.restaurant_freeze_time_map'),array('rftmfrz_time'))
							  ->join(array('frz'=>'mt.restaurant_freeze'),'frz.frzid = rft.rftm_frzid',array('frzfreezedate','frztype'))
							  ->where('rftm_frzresid = ?',$schObj->getrssfk_restaurant())
							  ->where('frzfreezedate = ?',$date);
					if($restSchSettingObj['settingType'] == 'UL'){
						$frzSelect->where('frz_restsch_setting_id = ?',2);
					}else if($restSchSettingObj['settingType'] == 'SMC'){
						$frzSelect->where('frz_restsch_setting_id = ?',3);
					}else if($restSchSettingObj['settingType'] == 'SL'){
						$frzSelect->where('frz_restsch_setting_id = ?',1);
					}else{
						$frzSelect->where('frz_restsch_setting_id = ?',1);
					}	
					$frzResult = $frzTable->fetchAll($frzSelect);
					$frzIds = array();
					foreach($frzResult as $frz){
						$frzIds[] = $frz->rftmfrz_time;
					}		  
							  
					foreach($resultset as $row){
						$time = explode(":",$row->rssstart_time);
						$s = mktime($time[0],$time[1],$time[2],0,0,0);
						$startTime =  date("h:i A",$s);
						$search = array_search($row->rssid,$frzIds);
						$varType = gettype($search);
						if($varType == 'integer'){
							$timeArr[$row->rssid] = array($startTime=>'frz');
						}else{
							$timeArr[$row->rssid] = array($startTime=>'unfrz');
						}
					}
				}
				if($mapperResult->frzdesc){
					$timeArr['desc'] = $mapperResult->frzdesc;
				}else{
					$timeArr['desc'] = "This restaurant is not accepting reservations for today! please try another day.";
				}		
			}else{
				foreach($resultset as $row){					
					$time = explode(":",$row->rssstart_time);
					$s = mktime($time[0],$time[1],$time[2],0,0,0);
					$startTime =  date("h:i A",$s);
					$timeArr[$row->rssid] = array($startTime=>'unfrz');
				}
				if(isset($mapperResult->frzdesc)){
					$timeArr['desc'] = $mapperResult->frzdesc;
				}else{
					$timeArr['desc'] = "This restaurant is not accepting reservations for today! please try another day.";
				}
			}			
			return $timeArr;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getNoofTablesandPaxByTimes(FirmManagement_Model_FirmSchedule $schObj,$bookStatusForOpenSlots,$bookStatusForReservedSlots)
	{
		try{
			$statusIdsForOpenSlots = array();
			$status = $bookStatusForOpenSlots;
			foreach($status as $key=>$value){
				$statusIdsForOpenSlots[] = $value->getId();
			}
			$statusIdForReservedSlots = array();
			$statusForReservedSlots = $bookStatusForReservedSlots;
			foreach($statusForReservedSlots as $key=>$value){
				$statusIdForReservedSlots[] = $value->getId();
			}
			$mealType = "";
			$mealMapper = new FirmManagement_Model_FirmMealTypeDataMapper();
			$mealTyperes = $mealMapper->GetRestaurantMealSettingsByRestId($schObj->getrssfk_restaurant(),$schObj->getmealtype());
			$StartTime = array();
			$EndTime = array();	
			foreach($mealTyperes as $key=>$value){
				$StartTime[] = $value->rmt_start_time;
				$EndTime[] = $value->rmt_end_time;
			}
			
			if(count($StartTime) == 0){
				return false;
			}
			
			/* Reterieve Schedules and inventory start */
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
				
			$restSpecialSchObject = new FirmManagement_Model_FirmSpecialSchedule();
			$restSpecialSchObject->setrsesfk_restaurant($schObj->getrssfk_restaurant());
			$restSpecialSchObject->setrseseventdate($schObj->getdate());
			
			$restSplSchMapperObj = new FirmManagement_Model_FirmSpecialScheduleMapper();			
			$splSchRow = $restSplSchMapperObj->CheckSpecialScheduleAvilable($restSpecialSchObject);	
			$resultStr = "";
				
			$frzmapper = new Reservation_Model_RestaurantFreezeDataMapper();
		    $frzSelect = $frzmapper->getDbTable()->select();
		    $frzSelect->setIntegrityCheck(false);
		    $frzSelect->from(array('frzmap'=>'mt.restaurant_freeze_time_map'),array('rftmid','rftmfrz_time'))
		   			 ->join(array('frz'=>'mt.restaurant_freeze'),'frz.frzid = frzmap.rftm_frzid',array('frzid','frzfreezedate'))
		   			 ->where('frz.frzfreezedate = ?',$schObj->getdate())
		   			 ->where('frz.frzstatus = ?',true)
		   			 ->where('frzfk_restaurant = ?',$schObj->getrssfk_restaurant())
		   			 ->where('frzmap.rftmfrz_status = ?',true);

			$schTime = '';
			for($i = 0;$i < count($StartTime); $i++){
				if($i == 0){
					$schTime= "(ressch.rssstart_time >= '$StartTime[$i]' and ressch.rssstart_time <= '$EndTime[$i]')";
				}else{
					$schTime.=  " or (ressch.rssstart_time >= '$StartTime[$i]' and  ressch.rssstart_time <= '$EndTime[$i]')";
				}
			}
			$select->from(array('ressch'=>'mt.restaurant_schedule'),array('rssid','rssstart_time'))
				   ->join(array('schtab'=>'mt.restaurant_schedule_table'),'ressch.rssid = schtab.rstfk_restaurant_schedule',array('rstid','rsttable_pax','rstno_of_tables'))
				   ->joinLeft(array('frzsel'=>$frzSelect),'ressch.rssid = frzsel.rftmfrz_time')
				   ->where('ressch.rssfk_restaurant = ?',$schObj->getrssfk_restaurant())
				   ->where('ressch.rssday_of_week = ?',$schObj->getrssday_of_week())
				   ->where("($schTime)")
				   ->where('ressch.rssstatus = ?',true)
				   ->where('schtab.rststatus = ?',true);
			if($splSchRow){
				$select->where('ressch.rssscheduletype_id = ?',2);
				$select->where('ressch.rssfk_special_event_schedule = ?',$splSchRow->rsesid);	
			}else{
				$select->where('ressch.rssscheduletype_id = ?',1);
			}
				
			$select->order(array('ressch.rssstart_time','schtab.rsttable_pax'));
	
			$schRowSet = $table->fetchAll($select);
			$prevtime = "";
			$inveArr = array();
			$timeArr = array();
	
			foreach($schRowSet as $schRow){
				if($prevtime == ""){
					$prevtime  = $schRow->rssstart_time;
					$inveArr[] = $schRow->rstid;
					$timeArr[] = $schRow->rssstart_time;		
				}else{
					if($prevtime == $schRow->rssstart_time){
						$inveArr[] = $schRow->rstid;						
					}else{
						$prevtime  = $schRow->rssstart_time;
						$inveArr[] = $schRow->rstid;
						$timeArr[] = $schRow->rssstart_time;
					}
				} 	
			}
				
			if(empty($inveArr) || empty($timeArr)){
				return false;
			}else{							
				/* Reteriev Reservation's count */
				$mapperbok  = new Reservation_Model_ReservationDataMapper();
				$boktable   = $mapperbok->getDbTable();
				
				$bokSelect1 =  $boktable->select();
				$bokSelect1->from(array('book'=>'mt.booking'),array('bokfk_rest_sch_table as inventory','COUNT(bokfk_rest_sch_table) as idcount'))
				   		  ->where('book.bokfk_restaurant = ?',$schObj->getrssfk_restaurant())
				   		  ->where('book.bokbooking_date = ?',$schObj->getdate())
				   		  ->where('book.bokbooked_status NOT IN(?)',array('11','13'))
				   		  ->where('book.bokbooking_timings IN(?)',$timeArr)		  
				   		  ->where('book.bokfk_rest_sch_table IN (?)',$inveArr)
				   		  ->where('book.bokbooking_status_id IN(?)',$statusIdsForOpenSlots)
				   		  ->group(array('bokfk_rest_sch_table'));
				 
				$resvRowSet1 = $boktable->fetchAll($bokSelect1);
				
				$bokSelect2 =  $boktable->select();
				$bokSelect2->setIntegrityCheck(false);
				$bokSelect2->from(array('bokacc'=>'mt.booking_accumulative_inventory'),array('bai_inventory as inventory','COUNT(bai_inventory) as idcount'))
						  ->join(array('book'=>'mt.booking'),'book.bokid = bokacc.bai_fk_booking',array())
						  ->where('book.bokfk_restaurant = ?',$schObj->getrssfk_restaurant())
				   		  ->where('book.bokbooking_date = ?',$schObj->getdate())
				   		  ->where('book.bokbooked_status NOT IN(?)',array('11','13'))
				   		  ->where('book.bokbooking_timings IN(?)',$timeArr)
				   		  ->where('bokacc.bai_inventory IN (?)',$inveArr)
				   		  ->where('book.bokbooking_status_id IN(?)',$statusIdsForOpenSlots)
				   		  ->group(array('bai_inventory'));
				   		  
				$resvRowSet2 = $boktable->fetchAll($bokSelect2);
				   
				$resvCount = array();
				foreach($resvRowSet1 as $resvRow){
					if(array_key_exists($resvRow->inventory,$resvCount)){
						$resvCount[$resvRow->inventory] = $resvCount[$resvRow->inventory]+$resvRow->idcount;
					}else{
						$resvCount[$resvRow->inventory] = $resvRow->idcount;
					}
				}

				foreach($resvRowSet2 as $resvRow){
					if(array_key_exists($resvRow->inventory,$resvCount)){
						$resvCount[$resvRow->inventory] = $resvCount[$resvRow->inventory]+$resvRow->idcount;
					}else{
						$resvCount[$resvRow->inventory] = $resvRow->idcount;
					}
				}					
				/* Final Data Creation */
				$count = 0;
				$time  = "";
				$schid = "";
				$tempInvenArr = array();
				$finalArray   = array();
				foreach($schRowSet as $schRow){
					if($time == ""){
						$time = $schRow->rssstart_time;
						$timesplit = explode(":",$time);
						$s = mktime($timesplit[0],$timesplit[1],$timesplit[2],0,0,0);
						$startTime =  date("h:i A",$s);
					   	$schid = $schRow->rssid;
					   	$frzid = $schRow->rftmid;
						if(array_key_exists($schRow->rstid,$resvCount)){
					   	 	$count = $schRow->rstno_of_tables-$resvCount[$schRow->rstid];
					   	 	$tempInvenArr[$schRow->rsttable_pax] = $count;
					   	}else{
					   		$tempInvenArr[$schRow->rsttable_pax] = $schRow->rstno_of_tables;
					   	}			   	
					}else{
						$timesplit = explode(":",$schRow->rssstart_time);
						$s = mktime($timesplit[0],$timesplit[1],$timesplit[2],0,0,0);
						$nextstartTime =  date("h:i A",$s);
						if($startTime == $nextstartTime){
							if(array_key_exists($schRow->rstid,$resvCount)){
						   	 	$count = $schRow->rstno_of_tables-$resvCount[$schRow->rstid];
						   	 	if(array_key_exists($schRow->rsttable_pax,$tempInvenArr)){
						   	 		$tempInvenArr[$schRow->rsttable_pax] = $tempCountsplit[$schRow->rsttable_pax]+$count;
						   	 	}else{
						   	 		$tempInvenArr[$schRow->rsttable_pax] = $count;
						   	 	}
						   	}else{
						   		if(array_key_exists($schRow->rsttable_pax,$tempInvenArr)){
						   			$tempInvenArr[$schRow->rsttable_pax] = $tempInvenArr[$schRow->rsttable_pax]+$schRow->rstno_of_tables;
						   		}else{
						   	 		$tempInvenArr[$schRow->rsttable_pax] = $schRow->rstno_of_tables;
						   		}
						   	}
						}else{
							$finalInvenArray = array();
							for($i = 1; $i <= 10; $i++){
								if(array_key_exists($i,$tempInvenArr)){
									$finalInvenArray[$i] = $tempInvenArr[$i];
								}else{
									$finalInvenArray[$i] = 0;
								}
							}
							$finalArray[$startTime]=array('schid'=>$schid.'-'.$frzid,'opensoltval'=>$finalInvenArray);
							unset($tempInvenArr);
							$tempInvenArr = array(); 
							$time = $schRow->rssstart_time;
							$timesplit = explode(":",$time);
							$s = mktime($timesplit[0],$timesplit[1],$timesplit[2],0,0,0);
							$startTime =  date("h:i A",$s);
							$schid = $schRow->rssid;
							$frzid = $schRow->rftmid;
							if(array_key_exists($schRow->rstid,$resvCount)){
						   	 	$count = $schRow->rstno_of_tables-$resvCount[$schRow->rstid];
						   	 	if(array_key_exists($schRow->rsttable_pax,$tempInvenArr)){
						   	 		$tempInvenArr[$schRow->rsttable_pax] = $tempCountsplit[$schRow->rsttable_pax]+$count;
						   	 	}else{
						   	 		$tempInvenArr[$schRow->rsttable_pax] = $count;
						   	 	}
						   	}else{
						   		if(array_key_exists($schRow->rsttable_pax,$tempInvenArr)){
						   			$tempInvenArr[$schRow->rsttable_pax] = $tempInvenArr[$schRow->rsttable_pax]+$schRow->rstno_of_tables;
						   		}else{
						   	 		$tempInvenArr[$schRow->rsttable_pax] = $schRow->rstno_of_tables;
						   		}
						   	}
						}
					}
				}
				$finalInvenArray = array();
				for($i = 1; $i <= 10; $i++){
					if(array_key_exists($i,$tempInvenArr)){
						$finalInvenArray[$i] = $tempInvenArr[$i];
					}else{
						$finalInvenArray[$i] = 0;
					}
					$paxArray[] = $i;
				}
				$timesplit = explode(":",$time);
				$s = mktime($timesplit[0],$timesplit[1],$timesplit[2],0,0,0);
				$startTime =  date("h:i A",$s);
				$finalArray[$startTime]=array('schid'=>$schid.'-'.$frzid,'opensoltval'=>$finalInvenArray);
				
				/* Reteriev Reservation's count */		
				$bokmapper  = new Reservation_Model_ReservationDataMapper();
				$boktable   = $bokmapper->getDbTable();
				$bokSelect =  $boktable->select();			
	
				$bokSelect->from(array('book'=>'mt.booking'),array('bokbooking_timings','bokparty_size','COUNT(bokparty_size) as idcount'))
				   		  ->where('book.bokfk_restaurant = ?',$schObj->getrssfk_restaurant())
				   		  ->where('book.bokbooking_date = ?',$schObj->getdate())
				   		  ->where('book.bokbooking_status_id IN(?)',$statusIdForReservedSlots)
				   		  ->group(array('bokparty_size','bokbooking_timings'))
				   		  ->order('bokbooking_timings');
				$bokcountRowSet = $boktable->fetchAll($bokSelect);
				$prevtime = "";
				$paxArr = array();
				$bokcountArr = array();
				foreach($bokcountRowSet as $bokcountrow){
					if($prevtime == ""){
						$prevtime = $bokcountrow->bokbooking_timings;
						if($bokcountrow->bokparty_size > 20){
							$paxArr[21] = $bokcountrow->idcount.'-'.$bokcountrow->bokparty_size;
						}else{
							$paxArr[$bokcountrow->bokparty_size] = $bokcountrow->idcount;
						}
					}else if($prevtime == $bokcountrow->bokbooking_timings){
						if($bokcountrow->bokparty_size > 20){
							if(array_key_exists(21, $paxArr)){
								$countArr = explode("-", $paxArr[21]);
								$idcount = $countArr[0]+$bokcountrow->idcount;
								$paxcount = $countArr[1]+$bokcountrow->bokparty_size;
								$paxArr[21] = $idcount.'-'.$paxcount;
							}else{
								$paxArr[21] = $bokcountrow->idcount.'-'.$bokcountrow->bokparty_size;
							}
						}else{
							$paxArr[$bokcountrow->bokparty_size] = $bokcountrow->idcount;
						}
					}else{
						$bokcountArr[$prevtime] = $paxArr;
						unset($paxArr); 
	 					$prevtime = $bokcountrow->bokbooking_timings;
						if($bokcountrow->bokparty_size > 20){
							$paxArr[21] = $bokcountrow->idcount.'-'.$bokcountrow->bokparty_size;
						}else{
							$paxArr[$bokcountrow->bokparty_size] = $bokcountrow->idcount;
						}
					}
				}
				if(count($paxArr) > 0){
					$bokcountArr[$prevtime] = $paxArr;
				}
				$finalbookArr = array();
				$tempbookcountArr = array();
				$totalCount = 0;
				$cellCount = 0;
				if(count($bokcountArr) > 0){
					foreach($bokcountArr as $timekey=>$paxvalue){
						$temptime = "";
						$temptime = $timekey;
						if(array_key_exists($temptime, $finalbookArr)){
							foreach($paxvalue as $pax=>$count){
								$tempbookcountArr = $finalbookArr[$temptime];
								if(array_key_exists($pax, $tempbookcountArr)){
									if($pax == 21){
										$newcountArr = explode("-", $count);
										$oldcountArr = explode("-", $tempbookcountArr[$pax]);
										$cellCount = $oldcountArr[0]+$newcountArr[0];
										$totalCount = $oldcountArr[1]+$newcountArr[1];
										$tempbookcountArr[$pax] = $cellCount.'-'.$totalCount;
									}else{
										$tempbookcountArr[$pax] = $tempbookcountArr[$pax]+$count;
									}
								}else{
									$tempbookcountArr[$pax] = $count;
								}
							}
							$finalbookArr[$temptime] = $tempbookcountArr;
						}else{
							$finalbookArr[$temptime] = $paxvalue;
						}					
					}
				}
				$reservedSlotsResultArr = array();
			  	foreach($timeArr as $time){
			  		if(array_key_exists($time, $finalbookArr)){
			  			$totalcount = 0;
			  			$timesplit = explode(":",$time);
						$s = mktime($timesplit[0],$timesplit[1],$timesplit[2],0,0,0);
						$startTime =  date("h:i A",$s);
			  			ksort($finalbookArr[$time],SORT_NUMERIC);
			  			foreach($finalbookArr[$time] as $key=>$value){
			  				if($key == 21){
			  					$val = explode("-",$value);
			  					$totalcount = $totalcount+ $val[1];
			  				}else{
			  					$totalcount = $totalcount+ $key*$value;
			  				}
			  			}
			  			$reservedSlotsResultArr[$startTime] = $finalbookArr[$time];
			  		}else{
			  			$timesplit = explode(":",$time);
						$s = mktime($timesplit[0],$timesplit[1],$timesplit[2],0,0,0);
						$startTime =  date("h:i A",$s);
			  			$reservedSlotsResultArr[$startTime] = array();
			  		}
			  	}
			  	$resultArr = array();
			  	$tempFinalArray = array();
			  	$resultArr['maxtableno'] = $paxArray;
			  	foreach($reservedSlotsResultArr as $key=>$value){
			  		for($i = 1; $i <= 10; $i++){
						if(array_key_exists($i,$value)){
							$finalReservedArray[$i] = $value[$i];
							$finalInvenArray[$i] = 0;
						}else{
							$finalReservedArray[$i] = 0;
							$finalInvenArray[$i] = 0;
						}
					}
			  		if(!array_key_exists($key, $finalArray)){
			  			$tempFinalArray[$key] = array('schid'=>'','opensoltval'=>$finalInvenArray);
			  		}else{
			  			$tempFinalArray[$key] = $finalArray[$key]; 
			  		}	  		
					$tempFinalArray[$key]['reservedsoltval'] = $finalReservedArray;
			  	}			  				
				$resultArr['mainarr'] = $tempFinalArray; 
				return $resultArr;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getReservedSlots(FirmManagement_Model_FirmSchedule $schObj,$resid,$date,$bookStatusRes,$mealType)
	{
		try{
			$statusId = array();
			$status = $bookStatusRes;
			foreach($status as $key=>$value){
				$statusId[] = $value->getId();
			}											
			/* Reteriev Reservation's count */		
			$bokmapper  = new Reservation_Model_ReservationDataMapper();
			$boktable   = $bokmapper->getDbTable();
			$bokSelect =  $boktable->select();			

			$bokSelect->from(array('book'=>'mt.booking'),array('bokbooking_timings','bokparty_size','COUNT(bokparty_size) as idcount'))
			   		  ->where('book.bokfk_restaurant = ?',$resid)
			   		  ->where('book.bokbooking_date = ?',$date)
			   		  ->where('book.bokbooking_status_id IN(?)',$statusId)
			   		  ->group(array('bokparty_size','bokbooking_timings'))
			   		  ->order('bokbooking_timings');
			$bokcountRowSet = $boktable->fetchAll($bokSelect);
			  
			$prevtime = "";
			$paxArr = array();
			$bokcountArr = array();
			foreach($bokcountRowSet as $bokcountrow){
				if($prevtime == ""){
					$prevtime = $bokcountrow->bokbooking_timings;
					if($bokcountrow->bokparty_size > 20){
						$paxArr[21] = $bokcountrow->idcount.'-'.$bokcountrow->bokparty_size;
					}else{
						$paxArr[$bokcountrow->bokparty_size] = $bokcountrow->idcount;
					}
				}else if($prevtime == $bokcountrow->bokbooking_timings){
					if($bokcountrow->bokparty_size > 20){
						if(array_key_exists(21, $paxArr)){
							$countArr = explode("-", $paxArr[21]);
							$idcount = $countArr[0]+$bokcountrow->idcount;
							$paxcount = $countArr[1]+$bokcountrow->bokparty_size;
							$paxArr[21] = $idcount.'-'.$paxcount;
						}else{
							$paxArr[21] = $bokcountrow->idcount.'-'.$bokcountrow->bokparty_size;
						}
					}else{
						$paxArr[$bokcountrow->bokparty_size] = $bokcountrow->idcount;
					}
				}else{
					$bokcountArr[$prevtime] = $paxArr;
					unset($paxArr); 
 					$prevtime = $bokcountrow->bokbooking_timings;
					if($bokcountrow->bokparty_size > 20){
						$paxArr[21] = $bokcountrow->idcount.'-'.$bokcountrow->bokparty_size;
					}else{
						$paxArr[$bokcountrow->bokparty_size] = $bokcountrow->idcount;
					}
				}
			}
			if(count($paxArr) > 0){
				$bokcountArr[$prevtime] = $paxArr;
			}
			$finalbookArr = array();
			$tempbookcountArr = array();
			$totalCount = 0;
			$cellCount = 0;
			if(count($bokcountArr) > 0){
				foreach($bokcountArr as $timekey=>$paxvalue){
					$temptime = "";
					$splittimeArr = explode(':',$timekey);
					if($splittimeArr[1] >= 0 && $splittimeArr[1] <= 59){
						$temptime = $splittimeArr[0].':00:00';
						if(array_key_exists($temptime, $finalbookArr)){
							foreach($paxvalue as $pax=>$count){
								$tempbookcountArr = $finalbookArr[$temptime];
								if(array_key_exists($pax, $tempbookcountArr)){
									if($pax == 21){
										$newcountArr = explode("-", $count);
										$oldcountArr = explode("-", $tempbookcountArr[$pax]);
										$cellCount = $oldcountArr[0]+$newcountArr[0];
										$totalCount = $oldcountArr[1]+$newcountArr[1];
										$tempbookcountArr[$pax] = $cellCount.'-'.$totalCount;
									}else{
										$tempbookcountArr[$pax] = $tempbookcountArr[$pax]+$count;
									}
								}else{
									$tempbookcountArr[$pax] = $count;
								}
							}
							$finalbookArr[$temptime] = $tempbookcountArr;
						}else{
							$finalbookArr[$temptime] = $paxvalue;
						}					
					}
				}
			}
			$timezone = "";
			$mapper = new FirmManagement_Model_FirmDataMapper();
			$timezone = $mapper->GetRestaurantTimeZone($resid);
			date_default_timezone_set($timezone);
			
			$today = date('Y-m-d');
			$seldate = explode("-",$date);
			$selstr = strtotime(date('Y-m-d',mktime(0,0,0,$seldate[0],$seldate[1],$seldate[2])));
			if($selstr > strtotime($today)){
				$comptime = '00:00:00';
			}else{
				$comptime = date('H:i:s');
			}

			$mealMapper = new FirmManagement_Model_FirmMealTypeDataMapper();
			$mealTyperes = $mealMapper->GetRestaurantMealSettingsByRestId($resid,$mealType);
			$times = array();
			foreach($mealTyperes as $key=>$value){
				$sttimesplit = 	explode(":",$value->rmt_start_time);
				if($sttimesplit[1] >= 00 && $sttimesplit[1] < 60){
					$start_time =  strtotime($sttimesplit[0].':00:00');	
				}	
				$edtimesplit = 	explode(":",$value->rmt_end_time);
				if($edtimesplit[1] >= 00 && $edtimesplit[1] < 60){
					$end_time =  strtotime($edtimesplit[0].':00:00');	
				}
				$nexttime = $sttimesplit[0];
			   	while ($start_time < $end_time) { 
			       $times[] = date('H:i:s', $start_time);
			       $nexttime = $nexttime+1;
			       $start_time =  strtotime($nexttime.':00:00'); 
			    } 
			  	$times[] = date('H:i:s', $start_time);
			}
			array_multisort($times, SORT_ASC);
		  	$resultArr = array();
		  	foreach($times as $time){
		  		if(array_key_exists($time, $finalbookArr)){
		  			$totalcount = 0;
		  			if(strtotime($comptime) < strtotime($time)){
			  			$timesplit = explode(":",$time);
						$s = mktime($timesplit[0],$timesplit[1],$timesplit[2],0,0,0);
						$startTime =  date("h:i A",$s);
			  			ksort($finalbookArr[$time],SORT_NUMERIC);
			  			foreach($finalbookArr[$time] as $key=>$value){
			  				if($key == 21){
			  					$val = explode("-",$value);
			  					$totalcount = $totalcount+ $val[1];
			  				}else{
			  					$totalcount = $totalcount+ $key*$value;
			  				}
			  			}
			  			$resultArr[$startTime.'-op-'.$totalcount] = $finalbookArr[$time];	
		  			}else{
		  				$timesplit = explode(":",$time);
						$s = mktime($timesplit[0],$timesplit[1],$timesplit[2],0,0,0);
						$startTime =  date("h:i A",$s);
			  			ksort($finalbookArr[$time],SORT_NUMERIC);
		  				foreach($finalbookArr[$time] as $key=>$value){
		  					if($key == 21){
			  					$val = explode("-",$value);
			  					$totalcount = $totalcount+ $val[1];
			  				}else{
			  					$totalcount = $totalcount+ $key*$value;
			  				}
			  			}
			  			$resultArr[$startTime.'-bk-'.$totalcount] = $finalbookArr[$time];
		  			}
		  		}else{
		  			if(strtotime($comptime) < strtotime($time)){
			  			$timesplit = explode(":",$time);
						$s = mktime($timesplit[0],$timesplit[1],$timesplit[2],0,0,0);
						$startTime =  date("h:i A",$s);
			  			$resultArr[$startTime.'-op-0'] = array();
		  			}else{
		  				$timesplit = explode(":",$time);
						$s = mktime($timesplit[0],$timesplit[1],$timesplit[2],0,0,0);
						$startTime =  date("h:i A",$s);
			  			$resultArr[$startTime.'-bk-0'] = array();
		  			}
		  		}
		  	}
			return $resultArr;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getOpenSlotsForMaxCountSetting(FirmManagement_Model_FirmSchedule $schObj,$resid,$date,$bookStatusRes)
	{
		try{
			$statusId = array();
			$status = $bookStatusRes;
			foreach($status as $key=>$value){
				$statusId[] = $value->getId();
			}
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);	

			/* Check special schedule avalible for given date. */
			$restSpecialSchObject = new FirmManagement_Model_FirmSpecialSchedule();
			$restSpecialSchObject->setrsesfk_restaurant($schObj->getrssfk_restaurant());
			$restSpecialSchObject->setrseseventdate($date);			
			$restSplSchMapperObj = new FirmManagement_Model_FirmSpecialScheduleMapper();			
			$splSchRow = $restSplSchMapperObj->CheckSpecialScheduleAvilable($restSpecialSchObject);	
			
			$frzmapper = new Reservation_Model_RestaurantFreezeDataMapper();
		    $frzSelect = $frzmapper->getDbTable()->select();
		    $frzSelect->setIntegrityCheck(false);
		    $frzSelect->from(array('frzmap'=>'mt.restaurant_freeze_time_map'),array('rftmid','rftmfrz_time'))
		   			 ->join(array('frz'=>'mt.restaurant_freeze'),'frz.frzid = frzmap.rftm_frzid',array('frzid','frzfreezedate'))
		   			 ->where('frz.frzfreezedate = ?',$date)
		   			 ->where('frz.frzstatus = ?',true)
		   			 ->where('frzfk_restaurant = ?',$resid)
		   			 ->where('frzmap.rftmfrz_status = ?',true)
		   			 ->where('frz.frz_restsch_setting_id = ?',$schObj->getrssscheduletype_id());
						   
			$select->from(array('ressch'=>'mt.restaurant_schedule'),array('rssid','rssstart_time','rss_max_count'))
				   ->joinLeft(array('frzsel'=>$frzSelect),'ressch.rssid = frzsel.rftmfrz_time')
				   ->where('ressch.rssfk_restaurant = ?',$schObj->getrssfk_restaurant())
				   ->where('ressch.rssday_of_week = ?',$schObj->getrssday_of_week())
				   ->where('ressch.rssstatus = ?',true);
			if($splSchRow){
				$select->where('ressch.rssscheduletype_id = ?',2);
				$select->where('ressch.rssfk_special_event_schedule = ?',$splSchRow->rsesid);	
			}else{
				$select->where('ressch.rssscheduletype_id = ?',$schObj->getrssscheduletype_id());
			}			
			$select->order(array('ressch.rssstart_time'));

			$schRowSet = $table->fetchAll($select);
			$timeArr = array();
			foreach($schRowSet as $schRow){
				$timeArr[] = $schRow->rssstart_time;	
			}
			$finalArr = array();
			if($timeArr){
				$bokmapper  = new Reservation_Model_ReservationDataMapper();
				$boktable   = $bokmapper->getDbTable();
				$bokSelect =  $boktable->select();			
	
				$bokSelect->from(array('book'=>'mt.booking'),array('bokbooking_timings','bokparty_size','COUNT(bokparty_size) as idcount'))
				   		  ->where('book.bokfk_restaurant = ?',$resid)
				   		  ->where('book.bokbooking_date = ?',$date)
				   		  ->where('book.bokbooked_status NOT IN(?)',array('11','13'))
				   		  ->where('book.bokbooking_timings IN(?)',$timeArr)		  
				   		  ->where('book.bokbooking_status_id IN(?)',$statusId)
				   		 // changin to quicl fix hayden's slot issue ->where('book.bok_restsch_setting_id = 3')
				   		  ->group(array('bokparty_size','bokbooking_timings'))
				   		  ->order('bokbooking_timings');
				$bokcountRowSet = $boktable->fetchAll($bokSelect);
				
				$prevtime = "";
				$paxArr = array();
				$bokcountArr = array();
                $i = 0;
				foreach($bokcountRowSet as $bokcountrow){
					if($prevtime == ""){
						$prevtime = $bokcountrow->bokbooking_timings;
						if($bokcountrow->bokparty_size > 15){
							$paxArr[16] = $bokcountrow->idcount.'-'.$bokcountrow->bokparty_size;
						}else{
							$paxArr[$bokcountrow->bokparty_size] = $bokcountrow->idcount;
						}
					}else if($prevtime == $bokcountrow->bokbooking_timings){
						if($bokcountrow->bokparty_size > 15){
							if(array_key_exists(16, $paxArr)){
								$countArr = explode("-", $paxArr[16]);
								$idcount = $countArr[0]+$bokcountrow->idcount;
								$paxcount = $countArr[1]+$bokcountrow->bokparty_size;
								$paxArr[16] = $idcount.'-'.$paxcount;
							}else{
								$paxArr[16] = $bokcountrow->idcount.'-'.$bokcountrow->bokparty_size;
							}
						}else{
							$paxArr[$bokcountrow->bokparty_size] = $bokcountrow->idcount;
						}
					}else{
						$bokcountArr[$prevtime] = $paxArr;
						unset($paxArr); 
	 					$prevtime = $bokcountrow->bokbooking_timings;
						if($bokcountrow->bokparty_size > 15){
							$paxArr[16] = $bokcountrow->idcount.'-'.$bokcountrow->bokparty_size;
						}else{
							$paxArr[$bokcountrow->bokparty_size] = $bokcountrow->idcount;
						}
					}
				}
				$bokcountArr[$prevtime] = $paxArr;
				
				foreach($schRowSet as $schRow){
					$totalCount = 0;
					$tempArr = array();
					if(array_key_exists($schRow->rssstart_time,$bokcountArr)){
						$tempArr[] = $bokcountArr[$schRow->rssstart_time];
						foreach($bokcountArr[$schRow->rssstart_time] as $key=>$value){
							if($key == 16){
								$countArr = explode("-", $value);
								$totalCount += $countArr[1];
							}else{
								$totalCount += $key*$value;
							}
						}	
					}
					$time = explode(":",$schRow->rssstart_time);
					$s = mktime($time[0],$time[1],$time[2],0,0,0);
					$startTime =  date("h:i A",$s);
					$finalArr[$startTime.'-'.$schRow->rftmid] = array('maxCount' => $schRow->rss_max_count,'totalcount'=>$totalCount,'paxCountArr'=>$tempArr);
				}
			}
			return $finalArr;			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getOpenSlotsFromWeekView(FirmManagement_Model_FirmSchedule $schObj,$resid,$date,$bookStatusRes,$stime,$etime)
	{
		try{
			$statusId = array();
			$status = $bookStatusRes;
			foreach($status as $key=>$value){
				$statusId[] = $value->getId();
			}
			$max = 0;
			$resttablemapper = new FirmManagement_Model_FirmTableDataMapper();
			$resttable = $resttablemapper->getDbTable();
			$tableselect = $resttable->select();
			$tableselect->from($resttable,'rsttable_pax')
						->where('rstfk_restaurant = ?',$resid)
						->where('rsttable_status = ?', true)						
						->order('rsttable_pax');
			$paxArray = array();

			$paxRowSet = $resttable->fetchAll($tableselect);
			foreach($paxRowSet as $paxRow){
				$paxArray[] = $paxRow->rsttable_pax;
			}
			if(empty($paxArray)){
				return false;
			}else{
				/* Reterieve Schedules and inventory start */
				$table = $this->getDbTable();
				$select = $table->select();
				$select->setIntegrityCheck(false);
				/* Check Whether the selected date contains any special schedule */
			
				$restSpecialSchObject = new FirmManagement_Model_FirmSpecialSchedule();
				$restSpecialSchObject->setrsesfk_restaurant($schObj->getrssfk_restaurant());
				$restSpecialSchObject->setrseseventdate($date);
				
				$restSplSchMapperObj = new FirmManagement_Model_FirmSpecialScheduleMapper();			
				$splSchRow = $restSplSchMapperObj->CheckSpecialScheduleAvilable($restSpecialSchObject);	
				$resultStr = "";
				$select->from(array('ressch'=>'mt.restaurant_schedule'),array('rssid','rssstart_time'))
					   ->join(array('schtab'=>'mt.restaurant_schedule_table'),'ressch.rssid = schtab.rstfk_restaurant_schedule',array('rstid','rsttable_pax','rstno_of_tables'))
					   ->where('ressch.rssfk_restaurant = ?',$schObj->getrssfk_restaurant())
					   ->where('ressch.rssday_of_week = ?',$schObj->getrssday_of_week())
					   ->where('ressch.rssstart_time >= ?',$stime)
					   ->where('ressch.rssstart_time <= ?',$etime)
					   ->where('ressch.rssstatus = ?',true)
					   ->where('schtab.rststatus = ?',true);
				if($splSchRow){
					$select->where('ressch.rssscheduletype_id = ?',2);
					$select->where('ressch.rssfk_special_event_schedule = ?',$splSchRow->rsesid);	
				}else{
					$select->where('ressch.rssscheduletype_id = ?',1);
				}
				
				$select->order(array('ressch.rssstart_time','schtab.rsttable_pax'));
	
				$schRowSet = $table->fetchAll($select);
				$prevtime = "";
				$inveArr = array();
				$timeArr = array();
	
				foreach($schRowSet as $schRow){
					if($prevtime == ""){
						$prevtime  = $schRow->rssstart_time;
						$inveArr[] = $schRow->rstid;
						$timeArr[] = $schRow->rssstart_time;		
					}else{
						if($prevtime == $schRow->rssstart_time){
							$inveArr[] = $schRow->rstid;						
						}else{
							$prevtime  = $schRow->rssstart_time;
							$inveArr[] = $schRow->rstid;
							$timeArr[] = $schRow->rssstart_time;
						}
					} 	
				}
				
				if(empty($inveArr) || empty($timeArr)){
					return false;
				}else{
								
					/* Reteriev Reservation's count */
		
					$mapperbok  = new Reservation_Model_ReservationDataMapper();
					$boktable   = $mapperbok->getDbTable();
					
					$bokSelect1 =  $boktable->select();
					$bokSelect1->from(array('book'=>'mt.booking'),array('bokfk_rest_sch_table as inventory','COUNT(bokfk_rest_sch_table) as idcount'))
					   		  ->where('book.bokfk_restaurant = ?',$resid)
					   		  ->where('book.bokbooking_date = ?',$date)
					   		  ->where('book.bokbooked_status NOT IN(?)',array('11','13'))
					   		  ->where('book.bokbooking_timings IN(?)',$timeArr)		  
					   		  ->where('book.bokfk_rest_sch_table IN (?)',$inveArr)
					   		  ->where('book.bokbooking_status_id IN(?)',$statusId)
					   		  ->group(array('bokfk_rest_sch_table'));
					 
					$resvRowSet1 = $boktable->fetchAll($bokSelect1);
					
					$bokSelect2 =  $boktable->select();
					$bokSelect2->setIntegrityCheck(false);
					$bokSelect2->from(array('bokacc'=>'mt.booking_accumulative_inventory'),array('bai_inventory as inventory','COUNT(bai_inventory) as idcount'))
							  ->join(array('book'=>'mt.booking'),'book.bokid = bokacc.bai_fk_booking',array())
							  ->where('book.bokfk_restaurant = ?',$resid)
					   		  ->where('book.bokbooking_date = ?',$date)
					   		  ->where('book.bokbooked_status NOT IN(?)',array('11','13'))
					   		  ->where('book.bokbooking_timings IN(?)',$timeArr)
					   		  ->where('bokacc.bai_inventory IN (?)',$inveArr)
					   		  ->where('book.bokbooking_status_id IN(?)',$statusId)
					   		  ->group(array('bai_inventory'));
					   		  
					$resvRowSet2 = $boktable->fetchAll($bokSelect2);
					   
					$resvCount = array();
					foreach($resvRowSet1 as $resvRow){
						if(array_key_exists($resvRow->inventory,$resvCount)){
							$resvCount[$resvRow->inventory] = $resvCount[$resvRow->inventory]+$resvRow->idcount;
						}else{
							$resvCount[$resvRow->inventory] = $resvRow->idcount;
						}
					}

					foreach($resvRowSet2 as $resvRow){
						if(array_key_exists($resvRow->inventory,$resvCount)){
							$resvCount[$resvRow->inventory] = $resvCount[$resvRow->inventory]+$resvRow->idcount;
						}else{
							$resvCount[$resvRow->inventory] = $resvRow->idcount;
						}
					}	
		
					/* Final Data Creation */
					$count = 0;
					$time  = "";
					$schid = "";
					$tempInvenArr = array();
					$finalArray   = array();
					foreach($schRowSet as $schRow){
						if($time == ""){
						   $time = $schRow->rssstart_time;
						   $schid = $schRow->rssid;
						   if(count($resvCount)>0){
						   	 if(array_key_exists($schRow->rstid,$resvCount)){
						   	 	$count = $schRow->rstno_of_tables-$resvCount[$schRow->rstid];
						   	 	$tempInvenArr[$schRow->rsttable_pax] = $count."_".$schRow->rstid;
						   	 }else{
						   	 	$tempInvenArr[$schRow->rsttable_pax] = $schRow->rstno_of_tables."_".$schRow->rstid;
						   	 }
						   }else{
						   	 $tempInvenArr[$schRow->rsttable_pax] = $schRow->rstno_of_tables."_".$schRow->rstid;
						   }			   	
						}else{
							if($time == $schRow->rssstart_time){
								if(count($resvCount)>0){
								   	 if(array_key_exists($schRow->rstid,$resvCount)){
								   	 	$count = $schRow->rstno_of_tables-$resvCount[$schRow->rstid];
								   	 	$tempInvenArr[$schRow->rsttable_pax] = $count."_".$schRow->rstid;
								   	 }else{
								   	 	$tempInvenArr[$schRow->rsttable_pax] = $schRow->rstno_of_tables."_".$schRow->rstid;
								   	 }
							   }else{
							   	 $tempInvenArr[$schRow->rsttable_pax] = $schRow->rstno_of_tables."_".$schRow->rstid;
							   }
							}else{
								$finalInvenArray = array();
								foreach($paxArray as $pax){
									if(array_key_exists($pax,$tempInvenArr)){
										$finalInvenArray[$pax] = $tempInvenArr[$pax];
									}else{
										$finalInvenArray[$pax] = "NA";
									}
								}
								$time = explode(":",$time);
								$s = mktime($time[0],$time[1],$time[2],0,0,0);
								$startTime =  date("h:i A",$s);
								
								$finalArray[$startTime]=array('schid'=>$schid,'opensoltval'=>$finalInvenArray);
								unset($tempInvenArr); 
								$time = $schRow->rssstart_time;
								$schid = $schRow->rssid;
						   		if(count($resvCount)>0){
								   	 if(array_key_exists($schRow->rstid,$resvCount)){
								   	 	$count = $schRow->rstno_of_tables-$resvCount[$schRow->rstid];
								   	 	$tempInvenArr[$schRow->rsttable_pax] = $count."_".$schRow->rstid;
								   	 }else{
								   	 	$tempInvenArr[$schRow->rsttable_pax] = $schRow->rstno_of_tables."_".$schRow->rstid;
								   	 }
						   		}else{	
						   	 		$tempInvenArr[$schRow->rsttable_pax] = $schRow->rstno_of_tables."_".$schRow->rstid;
						   		}
							}
						}
					}
					$finalInvenArray = array();
					foreach($paxArray as $pax){
						if(array_key_exists($pax,$tempInvenArr)){
							$finalInvenArray[$pax] = $tempInvenArr[$pax];
						}else{
							$finalInvenArray[$pax] = "NA";
						}
					}
					$time = explode(":",$time);
					$s = mktime($time[0],$time[1],$time[2],0,0,0);
					$startTime =  date("h:i A",$s);
					$finalArray[$startTime]=array('schid'=>$schid,'opensoltval'=>$finalInvenArray);
								
				$resultArr = array();
				$paxArray = array_unique($paxArray);
				$paxArray = array_values($paxArray);
				
				$resultArr['maxtableno'] = $paxArray;
				$resultArr['mainarr'] = $finalArray; 
				return $resultArr;
			}
		}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}	
	}
	
	public function getOpenSlotsForMaxCountFromWeekView(FirmManagement_Model_FirmSchedule $schObj,$resid,$date,$bookStatusRes,$stime,$etime)
	{
		try{
			$statusId = array();
			$status = $bookStatusRes;
			foreach($status as $key=>$value){
				$statusId[] = $value->getId();
			}
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);	

			/* Check special schedule avalible for given date. */
			$restSpecialSchObject = new FirmManagement_Model_FirmSpecialSchedule();
			$restSpecialSchObject->setrsesfk_restaurant($schObj->getrssfk_restaurant());
			$restSpecialSchObject->setrseseventdate($date);			
			$restSplSchMapperObj = new FirmManagement_Model_FirmSpecialScheduleMapper();			
			$splSchRow = $restSplSchMapperObj->CheckSpecialScheduleAvilable($restSpecialSchObject);	
			
			$frzmapper = new Reservation_Model_RestaurantFreezeDataMapper();
		    $frzSelect = $frzmapper->getDbTable()->select();
		    $frzSelect->setIntegrityCheck(false);
		    $frzSelect->from(array('frzmap'=>'mt.restaurant_freeze_time_map'),array('rftmid','rftmfrz_time'))
		   			 ->join(array('frz'=>'mt.restaurant_freeze'),'frz.frzid = frzmap.rftm_frzid',array('frzid','frzfreezedate'))
		   			 ->where('frz.frzfreezedate = ?',$date)
		   			 ->where('frz.frzstatus = ?',true)
		   			 ->where('frzfk_restaurant = ?',$resid)
		   			 ->where('frzmap.rftmfrz_status = ?',true)
		   			 ->where('frz.frz_restsch_setting_id = ?',$schObj->getrssscheduletype_id());
						   
			$select->from(array('ressch'=>'mt.restaurant_schedule'),array('rssid','rssstart_time','rss_max_count'))
				   ->joinLeft(array('frzsel'=>$frzSelect),'ressch.rssid = frzsel.rftmfrz_time')
				   ->where('ressch.rssfk_restaurant = ?',$schObj->getrssfk_restaurant())
				   ->where('ressch.rssday_of_week = ?',$schObj->getrssday_of_week())
				   ->where('ressch.rssstart_time >= ?',$stime)
				   ->where('ressch.rssstart_time <= ?',$etime)
				   ->where('ressch.rssstatus = ?',true);
			if($splSchRow){
				$select->where('ressch.rssscheduletype_id = ?',2);
				$select->where('ressch.rssfk_special_event_schedule = ?',$splSchRow->rsesid);	
			}else{
				$select->where('ressch.rssscheduletype_id = ?',$schObj->getrssscheduletype_id());
			}			
			$select->order(array('ressch.rssstart_time'));

			$schRowSet = $table->fetchAll($select);
			$timeArr = array();
			foreach($schRowSet as $schRow){
				$timeArr[] = $schRow->rssstart_time;	
			}
			
			$bokmapper  = new Reservation_Model_ReservationDataMapper();
			$boktable   = $bokmapper->getDbTable();
			$bokSelect =  $boktable->select();			

			$bokSelect->from(array('book'=>'mt.booking'),array('bokbooking_timings','bokparty_size','COUNT(bokparty_size) as idcount'))
			   		  ->where('book.bokfk_restaurant = ?',$resid)
			   		  ->where('book.bokbooking_date = ?',$date)
			   		  ->where('book.bokbooked_status NOT IN(?)',array('11','13'))
			   		  ->where('book.bokbooking_timings IN(?)',$timeArr)		  
			   		  ->where('book.bokbooking_status_id IN(?)',$statusId)
			   		  ->where('book.bok_restsch_setting_id = ?',$schObj->getrssscheduletype_id())
			   		  ->group(array('bokparty_size','bokbooking_timings'))
			   		  ->order('bokbooking_timings');
			$bokcountRowSet = $boktable->fetchAll($bokSelect);
			
			$prevtime = "";
			$paxArr = array();
			$bokcountArr = array();
			foreach($bokcountRowSet as $bokcountrow){
				if($prevtime == ""){
					$prevtime = $bokcountrow->bokbooking_timings;
					if($bokcountrow->bokparty_size > 15){
						$paxArr[16] = $bokcountrow->idcount.'-'.$bokcountrow->bokparty_size;
					}else{
						$paxArr[$bokcountrow->bokparty_size] = $bokcountrow->idcount;
					}
				}else if($prevtime == $bokcountrow->bokbooking_timings){
					if($bokcountrow->bokparty_size > 15){
						if(array_key_exists(16, $paxArr)){
							$countArr = explode("-", $paxArr[16]);
							$idcount = $countArr[0]+$bokcountrow->idcount;
							$paxcount = $countArr[1]+$bokcountrow->bokparty_size;
							$paxArr[16] = $idcount.'-'.$paxcount;
						}else{
							$paxArr[16] = $bokcountrow->idcount.'-'.$bokcountrow->bokparty_size;
						}
					}else{
						$paxArr[$bokcountrow->bokparty_size] = $bokcountrow->idcount;
					}
				}else{
					$bokcountArr[$prevtime] = $paxArr;
					unset($paxArr); 
 					$prevtime = $bokcountrow->bokbooking_timings;
					if($bokcountrow->bokparty_size > 15){
						$paxArr[16] = $bokcountrow->idcount.'-'.$bokcountrow->bokparty_size;
					}else{
						$paxArr[$bokcountrow->bokparty_size] = $bokcountrow->idcount;
					}
				}
			}
			$bokcountArr[$prevtime] = $paxArr;
			
			$finalArr = array();
			foreach($schRowSet as $schRow){
				$totalCount = 0;
				$tempArr = array();
				if(array_key_exists($schRow->rssstart_time,$bokcountArr)){
					$tempArr[] = $bokcountArr[$schRow->rssstart_time];
					foreach($bokcountArr[$schRow->rssstart_time] as $key=>$value){
						if($key == 16){
							$countArr = explode("-", $value);
							$totalCount += $countArr[1];
						}else{
							$totalCount += $key*$value;
						}
					}	
				}
				$time = explode(":",$schRow->rssstart_time);
				$s = mktime($time[0],$time[1],$time[2],0,0,0);
				$startTime =  date("h:i A",$s);
				$finalArr[$startTime.'-'.$schRow->rftmid] = array('maxCount' => $schRow->rss_max_count,'totalcount'=>$totalCount,'paxCountArr'=>$tempArr);
			}
			return $finalArr;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}	
	}
	
	
	public function ReterieveScheduleTimes(FirmManagement_Model_FirmSchedule $schObj)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$resultStr = "";
			/* Check Whether the selected date contains any special schedule */
			
			$restSpecialSchObject = new FirmManagement_Model_FirmSpecialSchedule();
			$restSpecialSchObject->setrsesfk_restaurant($schObj->getrssfk_restaurant());
			$restSpecialSchObject->setrseseventdate($schObj->getdate());
			
			$restSplSchMapperObj = new FirmManagement_Model_FirmSpecialScheduleMapper();			
			$splSchRow = $restSplSchMapperObj->CheckSpecialScheduleAvilable($restSpecialSchObject);
			$select->from($table,array('rssid','rssstart_time'))
				   ->where('rssfk_restaurant = ?',$schObj->getrssfk_restaurant())
				   ->where('rssday_of_week = ?',$schObj->getrssday_of_week())
				   ->where('rssstatus = ?',true);
			if($splSchRow){
				$select->where('rssscheduletype_id = ?',2);
				$select->where('rssfk_special_event_schedule = ?',$splSchRow->rsesid);	
			}else{
				$select->where('rssscheduletype_id = ?',1);
			}
				   
		    $select->order(array('rssstart_time'));

			$resultset = $table->fetchAll($select);
			$timeArr = array();
			foreach($resultset as $row){
					
				$time = explode(":",$row->rssstart_time);
				$s = mktime($time[0],$time[1],$time[2],0,0,0);
				$startTime =  date("h:i A",$s);								
	
				$timeArr[$startTime] = $row->rssid;
			}
			return $timeArr;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	

	public function getSchdsOfRestByRstIdDate($restId,$weekday)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->from($this->getDbTable(),array('rssid','rssstart_time'))
			->where('rssfk_restaurant = ?',(int)$restId)
			->where('rssday_of_week = ?',strtolower($weekday))
			->where('rssstatus = ?',true);
			$resultSet =  $this->getDbTable()->fetchAll($select);
			$timeArr = array();
			foreach ($resultSet as $row){
				$timeArr[] = array('rssid'=>$row->rssid,'starttime'=>$row->rssstart_time);
			}
			return $timeArr;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function ReterieveSchedules(FirmManagement_Model_GetSchedulesByRestId $object)
	{
		try{
			$schTable = $this->getDbTable();
			$schTableSelect = $schTable->select();
			$schTableSelect->setIntegrityCheck(false);
			$resultArray = array();

			/* Get day of week from given date */
				
			$schTableSelect->from(array('sch' => 'mt.restaurant_schedule'),array('rssid','rssfk_restaurant','rssstart_time'))
			->where('sch.rssfk_restaurant = ?',$object->getRestId())
			->where('sch.rssday_of_week = ?',$object->getDayOfWeek())
			->join(array('schtab' => 'mt.restaurant_schedule_table'),'schtab.rstfk_restaurant_schedule = sch.rssid',array('rstid','rsttable_pax','rstno_of_tables'))
			->where('sch.rssstatus = ?',true)
			->where('schtab.rststatus = ?',true)
			->where('sch.rssid IN(?)',$object->getSchId());
			
			if($object->getOrder() == 'DESC'){
				$schTableSelect->order(array('sch.rssstart_time DESC','schtab.rsttable_pax DESC'));	
			}else if($object->getOrder() == 'ASC'){
				$schTableSelect->order(array('sch.rssstart_time ASC','schtab.rsttable_pax ASC'));
			}else{
				$schTableSelect->order(array('sch.rssstart_time','schtab.rsttable_pax'));
			}
			
			$row_set = $schTable->fetchAll($schTableSelect);

			$schid = null;
			$schtime = null;

			$inventoryid = null;
			$tablesize = null;
			$nooftables = null;

			foreach($row_set as $row){
				$schid   	 = $row->rssid;
				$schtime 	 = date("g:i A", strtotime($row->rssstart_time));
				$inventoryid = $row->rstid;
				$tablesize   = $row->rsttable_pax;
				$nooftables  = $row->rstno_of_tables;
				for($i=0;$i<$nooftables;$i++){
					$resultArray[]= array('schid'   	 => $schid,
									  'schtime' 	 => $schtime,
									  'inventoryid'  => $inventoryid,
									  'tablesize'    => $tablesize,
									  'nooftables'   => $nooftables,
									  'bookid'		 => '',
									  'username'     => '',
									  'partysize'    => '',
									  'resvnote'     => '',
									  'restnote'     => '',
									  'tableno'      => '',
									  'booktypecode' => '',
									  'booktypedesc' => '',
									  'resvmodcode'  => '',
									  'resvmoddesc'  => '',
									  'bokstscode'   => '',
									  'bokstsdesc'   => '',
									  'flag'         => false); 
				}
			}

			return $resultArray;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function ReterieveSchedulesForBlock($schid,$pax)
	{
		try{
			$schTable = $this->getDbTable();
			$schTableSelect = $schTable->select();
			$schTableSelect->setIntegrityCheck(false);
			$resultArray = array();


			/* Get day of week from given date */
				
			$schTableSelect->from(array('sch' => 'mt.restaurant_schedule'),array('rssid','rssfk_restaurant','rssstart_time'))
			->where('sch.rssid = ?',$schid)
			->join(array('schtab' => 'mt.restaurant_schedule_table'),'schtab.rstfk_restaurant_schedule = sch.rssid',array('rstid','rsttable_pax','rstno_of_tables'))
			->where('sch.rssstatus = ?',true)
			->where('schtab.rststatus = ?',true)
			->where('schtab.rsttable_pax = ?',$pax)
			->order(array('sch.rssstart_time','schtab.rsttable_pax'));
			$row_set = $schTable->fetchRow($schTableSelect);

			$schid = null;
			$schtime = null;

			$inventoryid = null;
			$tablesize = null;
			$nooftables = null;


			$schid   	 = $row_set->rssid;
			$schtime 	 = date("g:i A", strtotime($row_set->rssstart_time));
			$inventoryid = $row_set->rstid;
			$tablesize   = $row_set->rsttable_pax;
			$nooftables  = $row_set->rstno_of_tables;
				
			$resultArray = array('schid'   	 => $schid,
									  'schtime' 	 => $schtime,
									  'inventoryid'  => $inventoryid,
									  'tablesize'    => $tablesize,
									  'nooftables'   => $nooftables); 



			return $resultArray;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	

	public function GetSumOfPartySizes($timings,$resid,$day,$limit,$offset,$lim)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$mapper = new FirmManagement_Model_FirmScheduleTableDataMapper();
			$schTable = $mapper->getDbTable();
			$TotalValues = array();
			if($timings){
				$Timings = array_slice($timings,$offset,$lim);
				$schIdArr = array();
				$TimeArr = array();
				foreach($Timings as $tim){
					$schIdArr[] = $tim['schid'];
					$TimeArr[$tim['schid']] = $tim['st'];
				}
				$selTable = $schTable->select();
				$selTable->setIntegrityCheck(false);
				$selTable->from(array('rst'=>'mt.restaurant_schedule_table'),array('rstfk_restaurant_schedule','SUM(rsttable_pax * rstno_of_tables) as totPax'))
						 ->where('rst.rstfk_restaurant_schedule IN(?) ',$schIdArr)
						 ->where('rst.rststatus = ?',true)
						 ->join(array('rs'=>'mt.restaurant_schedule'),'rs.rssid = rst.rstfk_restaurant_schedule',array('rssstart_time'))
						 ->group(array('rst.rstfk_restaurant_schedule','rs.rssstart_time'))
						 ->order(array('rs.rssstart_time'));
				$rowSet = $db->fetchAll($selTable);
				
				if(count($rowSet) > 0){
					foreach($rowSet as $row){
						$time = $TimeArr[$row['rstfk_restaurant_schedule']];					
						$TotalValues[$time] = $row['totPax'];	
					}
				}
			}
			return $TotalValues;
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetRestaurantSchedulesByRestaurantid($restaurantid)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$resultStr = "";
			$select->from($table,array('rssid',
									   'rssfk_restaurant',
									   'rssday_of_week', 
					 	   			   'rssstart_time',
									   'rssend_time',
									   'rsscreated_date',
									   'rssupdated_date',
									   'rssstatus',
									   'rssscheduletype_id',
									   'rssfk_special_event_schedule',
									   'rss_createdby',
									   'rss_updatedby',
									   'rss_max_count'
					 	   ))
				  ->where('rssfk_restaurant = ?',$restaurantid)
				  ->where('rssstatus = ?',true)
				  ->order(array('rssstart_time'));
			 	   
				  $resultset = $this->getDbTable()->fetchAll($select);
			 	  $schList = array();
			 	  foreach($resultset as $value){
			 	  	$selectInven = $table->select();
			 	   	$selectInven->setIntegrityCheck(false);
			 	   	$selectInven->from(array('rst'=>'mt.restaurant_schedule_table'),array('rstid','rstfk_restaurant_schedule','rsttable_pax','rstno_of_tables','rststatus'))
			 	   			    ->where('rststatus = ?',true)
			 	   				->where('rstfk_restaurant_schedule = ?',$value->rssid)
			 	   				->order(array('rstid'));
			 	   	$resultsetInven = $this->getDbTable()->fetchAll($selectInven);
			 	   	$schInven = array();
			 	   	foreach($resultsetInven as $valueInven){
			 	   		$schInvenArr = array(
										'rstid'						=> $valueInven->rstid,
			 	   						'rstfk_restaurant_schedule'	=> $valueInven->rstfk_restaurant_schedule,
										'rsttable_pax' 	  			=> $valueInven->rsttable_pax,
										'rstno_of_tables'	  		=> $valueInven->rstno_of_tables,
			 	   						'rststatus'	  				=> $valueInven->rststatus
			 	   						);
			 	   		$schInven[] = $schInvenArr;
			 	   			
					}
					$schRowArr = array(
									'rssid'					=>  $value->rssid,
									'rssfk_restaurant'		=> $value->rssfk_restaurant,
									'rssday_of_week' 		=>	$value->rssday_of_week,
									'rssstart_time' 		=>	$value->rssstart_time,
									'rsscreated_date'		=>	$value->rsscreated_date,
									'rssupdated_date' 		=>	$value->rssupdated_date,
									'rssstatus' 			=>	$value->rssstatus,
									'rssscheduletype_id'	=>	$value->rssscheduletype_id,
									'rssfk_special_event_schedule' =>	$value->rssfk_special_event_schedule,
									'restaurant_schedule_table'	=>	$schInven,
									'rss_createdby'         => $value->rss_createdby,
									'rss_updatedby'			=> $value->rss_updatedby,
									'rss_max_count'			=> $value->rss_max_count
									);
					$schList[] = $schRowArr;
				}
			return $schList;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function FirmManagementScheduleUpdate($resid,$actType,$actStat,$actDay,$actPerformedOn,$selDayArr,$schJson)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$db->beginTransaction();
			$schIdArr = array();
			$schTimesArr = array();
			
			$storage = new Zend_Auth_Storage_Session();
			$UserData = $storage->read();
			
			if($actType == 'DEL'){
				$schedules = $this->getScheduleRes($resid,$actDay);
				$tabMapper = new FirmManagement_Model_FirmScheduleTableDataMapper();
				if($actStat == 'All'){
					foreach($schedules as $row){
						$schIdArr[] = $row['schid'];
					}
					if($schIdArr){
						//  inactivating schedule tables of schedules
						$setTab = array('rststatus' => 0);
						$whereTab = array('rstfk_restaurant_schedule IN (?)'=> $schIdArr);
						$rows_affected = $tabMapper->getDbTable()->update($setTab,$whereTab);
						// inactivating schedules
						$set = array('rssstatus' => 0);
						$where = array('rssfk_restaurant = ?' => $resid,'rssid IN (?)' => $schIdArr);								
						$effected_row = $this->getDbTable()->update($set,$where);
					}
					foreach($selDayArr as $key=>$value){
						$schedules = $this->getScheduleRes($resid,$value);
						unset($schIdArr);
						foreach($schedules as $row){
							$schIdArr[] = $row['schid'];
						}
						if($schIdArr){
							//  inactivating schedule tables of schedules
							$setTab = array('rststatus' => 0);
							$whereTab = array('rstfk_restaurant_schedule IN (?)'=> $schIdArr);
							$rows_affected = $tabMapper->getDbTable()->update($setTab,$whereTab);
							// inactivating schedules
							$set = array('rssstatus' => 0);
							$where = array('rssfk_restaurant = ?' => $resid,'rssid IN (?)' => $schIdArr);								
							$effected_row = $this->getDbTable()->update($set,$where);
						}
					}
				}else if($actStat == 'Sel'){
					$selectedTimes = array();
					$selec = explode(',',$actPerformedOn);
					foreach($selec as $sel){
						$selVa = explode('_',$sel);
						$selectedTimes[$selVa[0]] = $selVa[2];
					}
					foreach($schedules as $row){
						if(in_array($row['schid'],$selectedTimes)){
							$stat = array_search($row['schid'],$selectedTimes);
							$schIdArr[] = $selectedTimes[$stat];
							$schTimesArr[$row['schid']] = $row['starttime'];
						}
					}
					if($schIdArr){
						//  inactivating schedule tables of schedules
						$setTab = array('rststatus' => 0);
						$whereTab = array('rstfk_restaurant_schedule IN (?)'=> $schIdArr);
						$rows_affected = $tabMapper->getDbTable()->update($setTab,$whereTab);
						// inactivating schedules
						$set = array('rssstatus' => 0);
						$where = array('rssfk_restaurant = ?' => $resid,'rssid IN (?)' => $schIdArr);								
						$effected_row = $this->getDbTable()->update($set,$where);
					}
					foreach($selDayArr as $key=>$value){
						if($value != $actDay){
							$schedules = $this->getScheduleRes($resid,$value);
							unset($schIdArr);
							foreach($schedules as $row){
								if(in_array($row['starttime'],$schTimesArr)){
									$stat = array_search($row['starttime'],$schTimesArr);
									$schIdArr[] = $row['schid'];
								}
							}
							if($schIdArr){
								//  inactivating schedule tables of schedules
								$setTab = array('rststatus' => 0);
								$whereTab = array('rstfk_restaurant_schedule IN (?)'=> $schIdArr);
								$rows_affected = $tabMapper->getDbTable()->update($setTab,$whereTab);
								// inactivating schedules
								$set = array('rssstatus' => 0);
								$where = array('rssfk_restaurant = ?' => $resid,'rssid IN (?)' => $schIdArr);								
								$effected_row = $this->getDbTable()->update($set,$where);
							}
						}
					}
				}
			}else if($actType == 'COPY'){
				
				$resSch = json_decode($schJson);
				$resScheduleArr = array();
				foreach ($resSch as $row) {
					$resSchObj = new FirmManagement_Model_FirmSchedule();
					$resSchObj->setrssid((int)$row->schid);
					$resSchObj->setrssfk_restaurant($resid);
					$resSchObj->setrssday_of_week($row->day);
					$resSchObj->setrssstart_time($row->starttime);
					$resSchObj->setrsscreated_date(date('Y-m-d H:i:s'));
					$resSchObj->setrss_createdby($UserData['User_Id']);
					$resSchObj->setrssscheduletype_id(1);
					$inventory = str_replace("'", "\"", $row->inventory);
					$inventory = json_decode($inventory);
					$resSchInventoryArr = array();
					foreach($inventory as $invRow){
						$resSchInventory = new FirmManagement_Model_FirmScheduleTable();
						$resSchInventory->setrstid((int)$invRow->inventoryid);
						$resSchInventory->setrsttable_pax($invRow->tablepax);
						$resSchInventory->setrstno_of_tables($invRow->tablecount);
						array_push($resSchInventoryArr, $resSchInventory);
					}
					$resSchObj->setinventory($resSchInventoryArr);
					array_push($resScheduleArr, $resSchObj);
				}
				$resultSch = $this->updateScheduleResFromManage($resScheduleArr);
				if($resultSch === true){
					$actDaySchedulesArr = array();
					$schedules = $this->getScheduleRes($resid,$actDay);
					$tabMapper = new FirmManagement_Model_FirmScheduleTableDataMapper();
//					foreach($schedules as $row){
//						$resSchObj = new FirmManagement_Model_FirmSchedule();
//						$resSchObj->setrssid((int)$row['schid']);
//						$resSchObj->setrssfk_restaurant($resid);
//						$resSchObj->setrssday_of_week($row['day']);
//						$resSchObj->setrssstart_time($row['starttime']);
//						$resSchObj->setrsscreated_date(date('Y-m-d H:i:s'));
//						$resSchObj->setrssscheduletype_id(1);
//						$inventory = str_replace("'", "\"", $row['inventory']);
//						$inventory = json_decode($inventory);
//						$resSchInventoryArr = array();
//						foreach($inventory as $invRow){
//							$resSchInventory = new FirmManagement_Model_FirmScheduleTable();
//							$resSchInventory->setrstid((int)$invRow['inventoryid']);
//							$resSchInventory->setrsttable_pax($invRow['tablepax']);
//							$resSchInventory->setrstno_of_tables($invRow['tablesize']);
//							array_push($resSchInventoryArr, $resSchInventory);
//						}
//						$resSchObj->setinventory($resSchInventoryArr);
//						$actDaySchedulesArr[$row['starttime']] = $resSchObj;
////						array_push($actDaySchedulesArr, $resSchObj);
//					}
					if($actStat == 'All'){
						unset($resScheduleArr);
						$resScheduleArr = array();
						foreach($selDayArr as $key=>$value){
							if($value != $actDay){
								foreach ($resSch as $row) {
									$resSchObj = new FirmManagement_Model_FirmSchedule();
//									$resSchObj->setrssid((int)$row->schid);
									$resSchObj->setrssfk_restaurant($resid);
									$resSchObj->setrssday_of_week($value);
									$resSchObj->setrssstart_time($row->starttime);
									$resSchObj->setrsscreated_date(date('Y-m-d H:i:s'));
									$resSchObj->setrss_createdby($UserData['User_Id']);
									$resSchObj->setrssscheduletype_id(1);
									$inventory = str_replace("'", "\"", $row->inventory);
									$inventory = json_decode($inventory);
									$resSchInventoryArr = array();
									foreach($inventory as $invRow){
										$resSchInventory = new FirmManagement_Model_FirmScheduleTable();
//										$resSchInventory->setrstid((int)$invRow->inventoryid);
										$resSchInventory->setrsttable_pax($invRow->tablepax);
										$resSchInventory->setrstno_of_tables($invRow->tablecount);
										array_push($resSchInventoryArr, $resSchInventory);
									}
									$resSchObj->setinventory($resSchInventoryArr);
									array_push($resScheduleArr, $resSchObj);
								}
							}
						}
						$resultSch = $this->updateScheduleResFromManage($resScheduleArr);
					}else if($actStat == 'Sel'){
						$selectedTimes = array();
						$selec = explode(',',$actPerformedOn);
						foreach($selec as $sel){
							$selVa = explode('_',$sel);
							$selectedTimes[] = $selVa[0];
						}
						unset($resScheduleArr);
						$resScheduleArr = array();
						foreach($selDayArr as $key=>$value){
							if($value != $actDay){
								foreach ($resSch as $row) {
									if(in_array($row->starttime,$selectedTimes)){
										$stat = array_search($row->starttime,$selectedTimes);
									
										$resSchObj = new FirmManagement_Model_FirmSchedule();
	//									$resSchObj->setrssid((int)$row->schid);
										$resSchObj->setrssfk_restaurant($resid);
										$resSchObj->setrssday_of_week($value);
										$resSchObj->setrssstart_time($row->starttime);
										$resSchObj->setrsscreated_date(date('Y-m-d H:i:s'));
										$resSchObj->setrss_createdby($UserData['User_Id']);
										$resSchObj->setrssscheduletype_id(1);
										$inventory = str_replace("'", "\"", $row->inventory);
										$inventory = json_decode($inventory);
										$resSchInventoryArr = array();
										foreach($inventory as $invRow){
											$resSchInventory = new FirmManagement_Model_FirmScheduleTable();
	//										$resSchInventory->setrstid((int)$invRow->inventoryid);
											$resSchInventory->setrsttable_pax($invRow->tablepax);
											$resSchInventory->setrstno_of_tables($invRow->tablecount);
											array_push($resSchInventoryArr, $resSchInventory);
										}
										$resSchObj->setinventory($resSchInventoryArr);
										array_push($resScheduleArr, $resSchObj);
									}
								}
							}
						}
						$resultSch = $this->updateScheduleResFromManage($resScheduleArr);
					}
				}
			}
			$updatestatMapper = new FirmManagement_Model_FirmScheduleUpdateStatusMapper();
			$updatestatMapper->changeRestScheduleUpdatedStatusFlag($resid, true);
			$db->commit();
		}catch (Exception $ex){
			$db->rollBack();
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function FirmManagementSMCScheduleUpdate($resid,$actType,$actStat,$actDay,$actPerformedOn,$selDayArr,$schJson)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$db->beginTransaction();
			$schIdArr = array();
			$schTimesArr = array();
			
			$storage = new Zend_Auth_Storage_Session();
			$UserData = $storage->read();
			$resMapper = new FirmManagement_Model_FirmDataMapper();
			$schSetting = $resMapper->getScheduleSettingTypeByresId($resid);
			$schtypeMapper = new Application_Model_ScheduleTypeDataMapper();
			$status = $schSetting['settingType'];
			$schTypeRes = $schtypeMapper->GetScheduleTypeByCode($status);
			
			if($actType == 'DEL'){
				$schedules = $this->getSMCScheduleRes($resid,$actDay);
				$tabMapper = new FirmManagement_Model_FirmScheduleTableDataMapper();
				if($actStat == 'All'){
					foreach($schedules as $row){
						$schIdArr[] = $row['schid'];
					}
					if($schIdArr){
						// inactivating schedules
						$set = array('rssstatus' => 0);
						$where = array('rssfk_restaurant = ?' => $resid,'rssid IN (?)' => $schIdArr);								
						$effected_row = $this->getDbTable()->update($set,$where);
					}
					foreach($selDayArr as $key=>$value){
						$schedules = $this->getSMCScheduleRes($resid,$value);
						unset($schIdArr);
						foreach($schedules as $row){
							$schIdArr[] = $row['schid'];
						}
						if($schIdArr){
							// inactivating schedules
							$set = array('rssstatus' => 0);
							$where = array('rssfk_restaurant = ?' => $resid,'rssid IN (?)' => $schIdArr);								
							$effected_row = $this->getDbTable()->update($set,$where);
						}
					}
				}else if($actStat == 'Sel'){
					$selectedTimes = array();
					$selec = explode(',',$actPerformedOn);
					foreach($selec as $sel){
						$selVa = explode('_',$sel);
						$selectedTimes[$selVa[0]] = $selVa[2];
					}
					foreach($schedules as $row){
						if(in_array($row['schid'],$selectedTimes)){
							$stat = array_search($row['schid'],$selectedTimes);
							$schIdArr[] = $selectedTimes[$stat];
							$schTimesArr[$row['schid']] = $row['starttime'];
						}
					}
					if($schIdArr){
						// inactivating schedules
						$set = array('rssstatus' => 0);
						$where = array('rssfk_restaurant = ?' => $resid,'rssid IN (?)' => $schIdArr);								
						$effected_row = $this->getDbTable()->update($set,$where);
					}
					foreach($selDayArr as $key=>$value){
						if($value != $actDay){
							$schedules = $this->getSMCScheduleRes($resid,$value);
							unset($schIdArr);
							foreach($schedules as $row){
								if(in_array($row['starttime'],$schTimesArr)){
									$stat = array_search($row['starttime'],$schTimesArr);
									$schIdArr[] = $row['schid'];
								}
							}
							if($schIdArr){
								// inactivating schedules
								$set = array('rssstatus' => 0);
								$where = array('rssfk_restaurant = ?' => $resid,'rssid IN (?)' => $schIdArr);								
								$effected_row = $this->getDbTable()->update($set,$where);
							}
						}
					}
				}
			}else if($actType == 'COPY'){
				
				$resSch = json_decode($schJson);
				$resScheduleArr = array();
				foreach ($resSch as $row) {
					$resSchObj = new FirmManagement_Model_FirmSchedule();
					$resSchObj->setrssid((int)$row->schid);
					$resSchObj->setrssfk_restaurant($resid);
					$resSchObj->setrssday_of_week($row->day);
					$resSchObj->setrssstart_time($row->starttime);
					$resSchObj->setrss_max_count($row->maxcount);
					$resSchObj->setrsscreated_date(date('Y-m-d H:i:s'));
					$resSchObj->setrss_createdby($UserData['User_Id']);
					$resSchObj->setrssscheduletype_id($schTypeRes->getId());
					array_push($resScheduleArr, $resSchObj);
				}
				$resultSch = $this->updateSMCScheduleResFromManage($resScheduleArr);
				if($resultSch === true){
					$actDaySchedulesArr = array();
					$schedules = $this->getSMCScheduleRes($resid,$actDay);
					$tabMapper = new FirmManagement_Model_FirmScheduleTableDataMapper();
					if($actStat == 'All'){
						unset($resScheduleArr);
						$resScheduleArr = array();
						foreach($selDayArr as $key=>$value){
							if($value != $actDay){
								foreach ($resSch as $row) {
									$resSchObj = new FirmManagement_Model_FirmSchedule();
//									$resSchObj->setrssid((int)$row->schid);
									$resSchObj->setrssfk_restaurant($resid);
									$resSchObj->setrssday_of_week($value);
									$resSchObj->setrssstart_time($row->starttime);
									$resSchObj->setrss_max_count($row->maxcount);
									$resSchObj->setrsscreated_date(date('Y-m-d H:i:s'));
									$resSchObj->setrss_createdby($UserData['User_Id']);
									$resSchObj->setrssscheduletype_id($schTypeRes->getId());
									$inventory = str_replace("'", "\"", $row->inventory);
									
									array_push($resScheduleArr, $resSchObj);
								}
							}
						}
						$resultSch = $this->updateSMCScheduleResFromManage($resScheduleArr);
					}else if($actStat == 'Sel'){
						$selectedTimes = array();
						$selec = explode(',',$actPerformedOn);
						foreach($selec as $sel){
							$selVa = explode('_',$sel);
							$selectedTimes[] = $selVa[0];
						}
						unset($resScheduleArr);
						$resScheduleArr = array();
						foreach($selDayArr as $key=>$value){
							if($value != $actDay){
								foreach ($resSch as $row) {
									if(in_array($row->starttime,$selectedTimes)){
										$stat = array_search($row->starttime,$selectedTimes);
									
										$resSchObj = new FirmManagement_Model_FirmSchedule();
	//									$resSchObj->setrssid((int)$row->schid);
										$resSchObj->setrssfk_restaurant($resid);
										$resSchObj->setrssday_of_week($value);
										$resSchObj->setrssstart_time($row->starttime);
										$resSchObj->setrss_max_count($row->maxcount);
										$resSchObj->setrsscreated_date(date('Y-m-d H:i:s'));
										$resSchObj->setrss_createdby($UserData['User_Id']);
										$resSchObj->setrssscheduletype_id($schTypeRes->getId());
										
										array_push($resScheduleArr, $resSchObj);
									}
								}
							}
						}
						$resultSch = $this->updateSMCScheduleResFromManage($resScheduleArr);
					}
				}
			}
			$updatestatMapper = new FirmManagement_Model_FirmScheduleUpdateStatusMapper();
			$updatestatMapper->changeRestScheduleUpdatedStatusFlag($resid, true);
			$db->commit();
		}catch (Exception $ex){
			$db->rollBack();
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function FirmManagementScheduleUpdateComp($resid,$actType,$actStat,$actDay,$actPerformedOn)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$db->beginTransaction();
			$schIdArr = array();
			$schTimesArr = array();
			$storage = new Zend_Auth_Storage_Session();
			$UserData = $storage->read();			
			if($actType == 'COPY'){
				$actDaySchedulesArr = array();
				$schedules = $this->getScheduleRes($resid,$actDay);
				$tabMapper = new FirmManagement_Model_FirmScheduleTableDataMapper();
				if($actStat == 'All'){
					unset($resScheduleArr);
					$resScheduleArr = array();
						foreach ($schedules as $row) {
							$resSchObj = new FirmManagement_Model_FirmSchedule();
							$resSchObj->setrssfk_restaurant($resid);
							$resSchObj->setrssday_of_week($actPerformedOn);
							$resSchObj->setrssstart_time($row['starttime']);
							$resSchObj->setrsscreated_date(date('Y-m-d H:i:s'));
							$resSchObj->setrss_createdby($UserData['User_Id']);
							$resSchObj->setrssscheduletype_id(1);
							$inventory = str_replace("'", "\"", $row['inventory']);
//							$inventory = json_decode($inventory);
							$resSchInventoryArr = array();
							foreach($inventory as $invRow){
								$resSchInventory = new FirmManagement_Model_FirmScheduleTable();
								$resSchInventory->setrsttable_pax($invRow['tablepax']);
								$resSchInventory->setrstno_of_tables($invRow['tablesize']);
								array_push($resSchInventoryArr, $resSchInventory);
							}
							$resSchObj->setinventory($resSchInventoryArr);
							array_push($resScheduleArr, $resSchObj);
						}
						
					$resultSch = $this->updateScheduleResFromManage($resScheduleArr);
				}
				$updatestatMapper = new FirmManagement_Model_FirmScheduleUpdateStatusMapper();
				$updatestatMapper->changeRestScheduleUpdatedStatusFlag($resid, true);
			}
			$db->commit();
		}catch (Exception $ex){
			$db->rollBack();
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function FirmManagementSMCScheduleUpdateComp($resid,$actType,$actStat,$actDay,$actPerformedOn,$schSetting)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$db->beginTransaction();
			$schIdArr = array();
			$schTimesArr = array();
			$storage = new Zend_Auth_Storage_Session();
			$UserData = $storage->read();
			$resMapper = new FirmManagement_Model_FirmDataMapper();
			$schSetting = $resMapper->getScheduleSettingTypeByresId($resid);
			$schtypeMapper = new Application_Model_ScheduleTypeDataMapper();
			$status = $schSetting['settingType'];
			$schTypeRes = $schtypeMapper->GetScheduleTypeByCode($status);			
			if($actType == 'COPY'){
				$actDaySchedulesArr = array();
				$schedules = $this->getSMCScheduleRes($resid,$actDay);				
				$tabMapper = new FirmManagement_Model_FirmScheduleTableDataMapper();
				if($actStat == 'All'){
					unset($resScheduleArr);
					$resScheduleArr = array();
						foreach ($schedules as $row) {
							$resSchObj = new FirmManagement_Model_FirmSchedule();
							$resSchObj->setrssfk_restaurant($resid);
							$resSchObj->setrssday_of_week($actPerformedOn);
							$resSchObj->setrssstart_time($row['starttime']);
							$resSchObj->setrsscreated_date(date('Y-m-d H:i:s'));
							$resSchObj->setrss_max_count($row['maxcount']);
							$resSchObj->setrss_createdby($UserData['User_Id']);
							$resSchObj->setrssscheduletype_id($schTypeRes->getId());
							array_push($resScheduleArr, $resSchObj);
						}
						
					$resultSch = $this->updateSMCScheduleResFromManage($resScheduleArr);
				}
				$updatestatMapper = new FirmManagement_Model_FirmScheduleUpdateStatusMapper();
				$updatestatMapper->changeRestScheduleUpdatedStatusFlag($resid, true);
			}
			$db->commit();
		}catch (Exception $ex){
			$db->rollBack();
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function AddScheduleAjax($resid,$schTime,$day_of_week,$sch,$schtype)
	{
		try{
			$storage = new Zend_Auth_Storage_Session();
			$UserData = $storage->read();
			$schtypeMapper = new Application_Model_ScheduleTypeDataMapper();
			$schTypeRes = $schtypeMapper->GetScheduleTypeByCode($schtype);
			$timezone = "";
			$thistable = $this->getDbTable();
			$mapper = new FirmManagement_Model_FirmDataMapper();
			$timezone = $mapper->GetRestaurantTimeZone($resid);
			date_default_timezone_set($timezone);
			$date = date('Y-m-d');
			$select = $thistable->select();
			$select->from($thistable,array('rssid'))
					->where('rssfk_restaurant = ?',$resid)
					->where('rssday_of_week = ?',$day_of_week)
					->where('rssstart_time = ?',$schTime)
					->where('rssscheduletype_id = ?',$schTypeRes->getId())
					->where('rssstatus = ?','T');
			$resultset = $thistable->fetchRow($select);
			$result = (int)$resultset['rssid'];
			if($sch){
				$set 	= array(
			 	'rssfk_restaurant' 		  	 => $resid,
				'rssday_of_week' 		     => $day_of_week,
				'rssstart_time'    			 =>	$schTime,
				//'rssend_time' 				 =>	$resSchedule->getrssend_time(),
				'rssupdated_date' 			 => date('Y-m-d H:i:s'),
				
				'rssscheduletype_id'		 => $schTypeRes->getId()
				);
				$where 	= array('rssid = ?' => $sch);
				$rows_affected = $thistable->update($set,$where);
				$updatestatMapper = new FirmManagement_Model_FirmScheduleUpdateStatusMapper();
				$updatestatMapper->changeRestScheduleUpdatedStatusFlag($resid, true);
				return $sch;	
			}
			if($result > 0 ){
				$mapper = new FirmManagement_Model_FirmScheduleTableDataMapper();
				//  inactivating schedule tables of schedules
//				$setTab = array('rststatus' => 0);
//				$whereTab = array('rstfk_restaurant_schedule = ?'=> $result);
//				$rows_affected = $mapper->getDbTable()->update($setTab,$whereTab);
				// inactivating schedules
				$set = array('rssstart_time' => $schTime);
				$where = array('rssfk_restaurant = ?' => $resid,'rssid = ?' => $result);								
				$effected_row = $this->getDbTable()->update($set,$where);
				$updatestatMapper = new FirmManagement_Model_FirmScheduleUpdateStatusMapper();
				$updatestatMapper->changeRestScheduleUpdatedStatusFlag($resid, true);
				return $result;
			}else{
				$resScheduleData = array(
				  		'rssfk_restaurant' 		  	 => $resid,
						'rssday_of_week' 		     => $day_of_week,
						'rssstart_time'    			 =>	$schTime,
						//'rssend_time' 				 =>	$resSchedule->getrssend_time(),
						'rsscreated_date' 			 => date('Y-m-d H:i:s'),
						'rss_updatedby'				 => $UserData['User_Id'],
						'rssscheduletype_id'		 => $schTypeRes->getId(),
						'rssstatus'					 => true
						);
				$schid = $thistable->insert($resScheduleData);
				$updatestatMapper = new FirmManagement_Model_FirmScheduleUpdateStatusMapper();
				$updatestatMapper->changeRestScheduleUpdatedStatusFlag($resid, true);				
				return $schid;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function AddMaxCountAjax($resid,$maxCount,$day_of_week,$sch,$schtype)
	{
		try{
			$storage = new Zend_Auth_Storage_Session();
			$UserData = $storage->read();
			$schtypeMapper = new Application_Model_ScheduleTypeDataMapper();
			$schTypeRes = $schtypeMapper->GetScheduleTypeByCode($schtype);
			$timezone = "";
			$thistable = $this->getDbTable();
			$mapper = new FirmManagement_Model_FirmDataMapper();
			$timezone = $mapper->GetRestaurantTimeZone($resid);
			date_default_timezone_set($timezone);
			$date = date('Y-m-d');
			
			if($sch > 0 ){
				$mapper = new FirmManagement_Model_FirmScheduleTableDataMapper();
				$set = array('rss_max_count' => $maxCount,
							'rssupdated_date' => date('Y-m-d H:i:s'),
							'rss_updatedby' => $UserData['User_Id']);
				$where = array('rssfk_restaurant = ?' => $resid,'rssid = ?' => $sch);								
				$effected_row = $this->getDbTable()->update($set,$where);
				$updatestatMapper = new FirmManagement_Model_FirmScheduleUpdateStatusMapper();
				$updatestatMapper->changeRestScheduleUpdatedStatusFlag($resid, true);
				return $sch;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getRestIdByschid($schid)
	{
		try{
			$schTable = $this->getDbTable();
			$schTableSelect = $schTable->select();
				
			$schTableSelect->from($schTable,array('rssfk_restaurant'))
						   ->where('rssid = ?',$schid);
						   
			$row_set = $schTable->fetchRow($schTableSelect);
						   
			return $row_set->rssfk_restaurant;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetUpdatedRestaurantSchedulesByRestaurantid($restaurantid)
	{
		try{
			
			$table = $this->getDbTable();
			$select = $table->select();
			$resultStr = "";
			$select->from($table,array('rssid',
									   'rssfk_restaurant',
									   'rssday_of_week', 
					 	   			   'rssstart_time',
									   'rssend_time',
									   'rsscreated_date',
									   'rssupdated_date',
									   'rssstatus',
									   'rssscheduletype_id',
									   'rssfk_special_event_schedule',
									   'rss_max_count'
					 	   ))
				  ->where('rssfk_restaurant = ?',$restaurantid)
				  //->where('rsssync_status = ?','C')
				  ->order(array('rssstart_time'));
			 	   
				  $resultset = $this->getDbTable()->fetchAll($select);
			 	  $schList = array();
			 	  foreach($resultset as $value){	
			 	  	$schInven = array();		 	  	
			 	  	if($value->rssscheduletype_id == 1 ||  $value->rssscheduletype_id == 2){
			 	  		
				 	  	$selectInven = $table->select();
				 	   	$selectInven->setIntegrityCheck(false);
				 	   	$selectInven->from(array('rst'=>'mt.restaurant_schedule_table'),array('rstid','rstfk_restaurant_schedule','rsttable_pax','rstno_of_tables','rststatus'))
				 	   			    ->where('rststatus = ?',true)
				 	   				->where('rstfk_restaurant_schedule = ?',$value->rssid)
				 	   				->order(array('rstid'));
				 	   	$resultsetInven = $this->getDbTable()->fetchAll($selectInven);
				 	   	foreach($resultsetInven as $valueInven){
				 	   		$schInvenArr = array(
											'rstid'						=> $valueInven->rstid,
				 	   						'rstfk_restaurant_schedule'	=> $valueInven->rstfk_restaurant_schedule,
											'rsttable_pax' 	  			=> $valueInven->rsttable_pax,
											'rstno_of_tables'	  		=> $valueInven->rstno_of_tables,
				 	   						'rststatus'	  				=> $valueInven->rststatus
				 	   						);
				 	   		$schInven[] = $schInvenArr;
				 	   			
						}
			 	  	}
			 	  	
					$schRowArr = array(
									'rssid'					=>  $value->rssid,
									'rssfk_restaurant'		=> $value->rssfk_restaurant,
									'rssday_of_week' 		=>	$value->rssday_of_week,
									'rssstart_time' 		=>	$value->rssstart_time,
									'rsscreated_date'		=>	$value->rsscreated_date,
									'rssupdated_date' 		=>	$value->rssupdated_date,
									'rssstatus' 			=>	$value->rssstatus,
									'rssscheduletype_id'	=>	$value->rssscheduletype_id,
									'rssfk_special_event_schedule' =>	$value->rssfk_special_event_schedule,
									'rss_max_count'			=>	$value->rss_max_count,
									'restaurant_schedule_table'	=>	$schInven
								    );
					$schList[] = $schRowArr;
				}
			return $schList;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

}