<?php

class FirmManagement_Model_FirmTableDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {

			$this->setDbTable('FirmManagement_Model_DbTable_FirmTable');
		}
		return $this->_dbTable;
	}

	public function saveRestaurantTable(array $resFloorArr,array $resFloorEtnArr,array $resFloorSepArr,$resid,$diningid)
	{
			$db = Zend_Db_Table::getDefaultAdapter();
			try{
				$db->beginTransaction();
				$submitstatus = 1;
				//$where = $db->quoteInto('rstfk_restaurant = ?', $resid);
				//$this->getDbTable()->delete($where);
				$tbaleId = '';
				$entranceid = '';
				$sepratorid = '';
				if($resFloorArr){
					$table = $this->getDbTable();
					foreach($resFloorArr as $resFloor){
						
						$tableStatusFromUI = (int)$resFloor->getTableStatusFromUI();

						if($tableStatusFromUI > 0){
							$set 	= array(
					 			'rsttable_number' 		=> $resFloor->getTableNumber(),
					  			'rsttable_pax' 			=> $resFloor->getTablePax(),
					  			'rsttable_coordinates' 	=> $resFloor->getTableCoor(),
					  			'rstfloor_number' 		=> $resFloor->getFloorNumber(),
					  			'rsttable_status' 		=> $resFloor->getTableStatus(),
					  			'rstupdateddatetime' 	=> $resFloor->getCreatedDate(),
								'rstupdatedby'			=> $resFloor->getCreatedBy(),				  
					  			'rsttable_type' 		=> $resFloor->getTableType(),
					  			'rsttable_dimensions' 	=> $resFloor->getTableDimension(),
								'rstdiningid'			=> $resFloor->getDiningId(),
								'rsttable_size'			=> $resFloor->getrsttable_size(),
								'rsttable_angle'		=> $resFloor->getrsttable_angle()						
							);
							$where 	= array('rstid = ?' => $resFloor->getTableId(),'rstfk_restaurant = ?'=> $resid);
							$rows_affected = $table->update($set,$where);
							$submitstatus = 0;
						}else if($tableStatusFromUI === 0){
							$resFloorData = array(
				  	    		'rstfk_restaurant' 		=> $resid,
					 			'rsttable_number' 		=> $resFloor->getTableNumber(),
					  			'rsttable_pax' 			=> $resFloor->getTablePax(),
					  			'rsttable_coordinates' 	=> $resFloor->getTableCoor(),
					  			'rstfloor_number' 		=> $resFloor->getFloorNumber(),
					  			'rsttable_status' 		=> $resFloor->getTableStatus(),
					  			'rstcreateddatetime' 	=> $resFloor->getCreatedDate(),
								'rstcreatedby'			=> $resFloor->getCreatedBy(),				  
					  			'rsttable_type' 		=> $resFloor->getTableType(),
					  			'rsttable_dimensions' 	=> $resFloor->getTableDimension(),
								'rstdiningid'			=> $resFloor->getDiningId(),
								'rsttable_size'			=> $resFloor->getrsttable_size(),
								'rsttable_angle'		=> $resFloor->getrsttable_angle()										
							);
							$tbaleId = $table->insert($resFloorData);
						}else if($tableStatusFromUI === -1){
							$set = array(
								'rsttable_status' => 'FALSE'
							);
							$where 	= array('rstid = ?' => $resFloor->getTableId(),'rstfk_restaurant = ?'=> $resid);
							$table->update($set,$where);
							$submitstatus = 0;
						}

					}
					$this->clearFloorPlan($resid);
				}
				if($resFloorEtnArr){
					$mapper = new FirmManagement_Model_FirmFloorEntranceDataMapper();
					$entranceid = $mapper->saveRestaurantFloorEntrance($resFloorEtnArr,$resid,$diningid);
				}
				
				if($resFloorSepArr){
					$restFloorSepMapper = new FirmManagement_Model_FirmFloorSepratorMapper();
					$sepratorid = $restFloorSepMapper->saveRestFloorSeprators($resFloorSepArr);
				}
				
				if($resid){
					$restmapper = new FirmManagement_Model_FirmDataMapper();
					$table = $restmapper->getDbTable();
					$set   = array('resfloorplanstatus'=>true);
					$where = array('resid = ?' => $resid);
					$rows_affected = $table->update($set,$where);
				}

				$db->commit();
				$result = array(
					'restablestatus'	=> true,
					'submitstatus'		=> $submitstatus,
					'tableid'			=> $tbaleId,
					'entranceid'		=> $entranceid,
					'sepratorid'			=> $sepratorid	
				);
				return $result;
			}catch(Exception $ex){
				$db->rollBack();
				throw new Exception($ex->getMessage()) ;
			}
	}
	
	public function getRestaurantTable(FirmManagement_Model_FirmTable $tableObj)
	{
		try{
			$resultset = null;
			$resId = $tableObj->getResId();
			$diningid = $tableObj->getDiningId();
			
			$table = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array(
					'rstid',
					'rsttable_number',
					'rsttable_type',
					'rsttable_pax',
					'rsttable_coordinates',
					'rsttable_dimensions',
					'rsttable_size', 
					'rsttable_angle'
					))
					->where('rstfk_restaurant = ?',$resId)
					->where('rstdiningid = ?',$diningid)
					->where('rsttable_type <> ?','p')
					->where('rsttable_status = ?','TRUE');
					$resultset = $this->getDbTable()->fetchAll($select);
			
			$tableArr = array();
			$finalArr = array();
			foreach($resultset as $value){
				$table = array(
							 'tableid' 	   => $value['rstid'],
							 'number' 	   => $value['rsttable_number'],
							 'type' 	   => $value['rsttable_type'],
							 'pax' 		   => $value['rsttable_pax'],
							 'coordinates' => $value['rsttable_coordinates'],
							 'dimensions'  => $value['rsttable_dimensions'],
							 'size'		   => $value['rsttable_size'],
							 'tableangle'  => $value['rsttable_angle']
				);
				$tableArr[] = $table;
			}

			$finalArr['finalStr'] = $tableArr;

			$mapper = new FirmManagement_Model_FirmFloorEntranceDataMapper();
			$etnObj = new FirmManagement_Model_FirmFloorEntrance();
			$etnObj->setResId($resId);
			$etnObj->setDiningId($diningid);
			$etnStr = $mapper->getRestaurantFloorEntrance($etnObj);
			$finalArr['etnStr'] =  $etnStr;
			$cache = null;
			return $finalArr;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getRestaurantTableCountById($restid)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$qry = "select count(rstfk_restaurant) from mt.restaurant_tables where rstfk_restaurant =".$restid;
			$result = $db->fetchOne($qry);
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function clearFloorPlan($restid)
	{
		try{
			if($restid){
				$resultset = null;
				$status = null;

				$cache = new Uss_Helper_CacheManager();
				if($cache->Check($restid)){
					$status = $cache->Clear($restid);
					return $status;
				}
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getRestaurantInventory(FirmManagement_Model_GetRestInventoryById $inventory)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();

			$select->from($table,array('rsttable_pax','count(rstid) as tablecount'))
			->where('rstfk_restaurant = ?',$inventory->getRestaurantId())
			->group('rsttable_pax')
			->order('rsttable_pax')
			->where('rsttable_status = ?','TRUE');

			$rowset = $table->fetchAll($select);

			return $rowset;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetRestaurantTablesByRestaurantid($restaurantid)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('rstid',
									   'rstfk_restaurant',
									   'rsttable_number',
									   'rsttable_pax',
									   'rsttable_coordinates',
									   'rstfloor_number',
									   'rsttable_status',
									   'rstcreatedby',
									   'rstcreateddatetime',
									   'rstupdatedby',
									   'rstupdateddatetime',
								       'rsttable_type',
									   'rsttable_dimensions',
									   'rstdiningid',									   
									   'rsttable_size', 
									   'rsttable_angle'
						))
						->where('rstfk_restaurant = ?',$restaurantid)
						->where('rsttable_status = ?','TRUE');;
			$resultset = $this->getDbTable()->fetchAll($select);
			$tableArr= array();
			foreach($resultset as $key=>$value){
				$subArr = array();
				foreach($value as  $key1=>$value1){
					if($key1 == 'rstcreatedby' || $key1 == 'rstupdatedby'){
						$subArr[$key1]= null;
					}else{
						$subArr[$key1]= $value1;
					}
				}
				$tableArr[] = $subArr;
			}
			return $tableArr;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function saveRestaurantQuickFloorPlan(array $resFloorArr,$rest_id,$dining)
	{
			$db = Zend_Db_Table::getDefaultAdapter();
			try{
				$db->beginTransaction();
				$submitstatus = 1;
				//$where = $db->quoteInto('rstfk_restaurant = ?', $resid);
				//$this->getDbTable()->delete($where);

				if($resFloorArr){
					$table = $this->getDbTable();
					$resServ = new Application_Service_Firm();
					$timezone = $resServ->GetRestaurantTimeZone($rest_id);
					date_default_timezone_set($timezone);
					$mainStart = 1;
					foreach($resFloorArr as $resFloor){
						$prefix = '';
						if($resFloor->getTableStart() && $resFloor->getTableEnd()){
							$start = $resFloor->getTableStart();
							$end = $resFloor->getTableEnd();
						}else{
							$prefix = 'Q';
							$start = $mainStart;
						}
						foreach($resFloor->getTableInventory() as $inventory){
							for($i = 0;$i < $inventory->getTableCount();$i++){
								$resFloorData = array(
					  	    		'rstfk_restaurant' 		=> $rest_id,
						 			'rsttable_number' 		=> $prefix.$start,
						  			'rsttable_pax' 			=> $resFloor->getTablePax(),
						  			'rsttable_coordinates' 	=> $inventory->getTable_Co_Ordinates(),
						  			'rstfloor_number' 		=> 1,
						  			'rsttable_status' 		=> 'T',
						  			'rstcreateddatetime' 	=> date('Y-m-d H:i:s'),				  
						  			'rsttable_type' 		=> $inventory->getTableSize(),
						  			'rsttable_dimensions' 	=> $inventory->getTableDimensions(),
									'rstdiningid'			=> $dining,
									'rsttable_size'			=> $resFloor->getTableType(),
//									'rsttable_angle'		=> $resFloor->getrsttable_angle()										
								);
								$table->insert($resFloorData);
								$start++;								
							}
							if(!($resFloor->getTableStart() && $resFloor->getTableEnd())){
								$mainStart = $start;
							}
						}
						
						
					}
					$this->clearFloorPlan($rest_id);
				}
//				$mapper = new FirmManagement_Model_FirmFloorEntranceDataMapper();
//				$mapper->saveRestaurantFloorEntrance($resFloorEtnArr,$resid,$diningid);
//
//				if($resFloorSepArr){
//					$restFloorSepMapper = new FirmManagement_Model_FirmFloorSepratorMapper();
//					$restFloorSepMapper->saveRestFloorSeprators($resFloorSepArr);
//				}
//				
//				if($resid){
//					$restmapper = new FirmManagement_Model_FirmDataMapper();
//					$table = $restmapper->getDbTable();
//					$set   = array('resfloorplanstatus'=>true);
//					$where = array('resid = ?' => $resid);
//					$rows_affected = $table->update($set,$where);
//				}

				$db->commit();
				$result = array('restablestatus'=>true,'submitstatus'=>$submitstatus);
				return true;
			}catch(Exception $ex){
				$db->rollBack();
				return false;
				throw new Exception($ex->getMessage()) ;
			}
	}
	
	public function GetRestaurantTablesByRestaurantidForTablet($restaurantid)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('rstid',
									   'rstfk_restaurant',
									   'rsttable_number',
									   'rsttable_pax',
									   'rsttable_coordinates',
									   'rstfloor_number',
									   'rsttable_status',
									   'rstcreatedby',
									   'rstcreateddatetime',
									   'rstupdatedby',
									   'rstupdateddatetime',
								       'rsttable_type',
									   'rsttable_dimensions',
									   'rstdiningid',									   
									   'rsttable_size', 
									   'rsttable_angle'
						))
						->where('rstfk_restaurant = ?',$restaurantid);
			$resultset = $this->getDbTable()->fetchAll($select);
			$tableArr= array();
			foreach($resultset as $key=>$value){
				$subArr = array();
				foreach($value as  $key1=>$value1){
					if($key1 == 'rstcreatedby' || $key1 == 'rstupdatedby'){
						$subArr[$key1]= null;
					}else{
						$subArr[$key1]= $value1;
					}
				}
				$tableArr[] = $subArr;
			}
			return $tableArr;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetUpdatedRestaurantTablesByRestaurantid($restaurantid)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('rstid',
									   'rstfk_restaurant',
									   'rsttable_number',
									   'rsttable_pax',
									   'rsttable_coordinates',
									   'rstfloor_number',
									   'rsttable_status',
									   'rstcreatedby',
									   'rstcreateddatetime',
									   'rstupdatedby',
									   'rstupdateddatetime',
								       'rsttable_type',
									   'rsttable_dimensions',
									   'rstdiningid',									   
									   'rsttable_size', 
									   'rsttable_angle'
						))
						->where('rstfk_restaurant = ?',$restaurantid);
						//->where('rstsync_status = ?','C');
			$resultset = $this->getDbTable()->fetchAll($select);
			$tableArr= array();
			foreach($resultset as $key=>$value){
				$subArr = array();
				foreach($value as  $key1=>$value1){
					if($key1 == 'rstcreatedby' || $key1 == 'rstupdatedby'){
						$subArr[$key1]= null;
					}else{
						$subArr[$key1]= $value1;
					}
				}
				$tableArr[] = $subArr;
			}
			return $tableArr;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

}

