<?php

class FirmManagement_Model_FirmTagBdMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('FirmManagement_Model_DbTable_FirmTagBd');
		}
		return $this->_dbTable;
	}
	
	public function fetchAll()
	{
		try{
			$resttag = array();	
			$where = array('status = ?'=> true);
			$records = $this->getDbTable()->fetchAll($where);					
			foreach($records as $record){
				$resttag[] = new FirmManagement_Model_FirmTagBd(						
					$record->toArray());	
			}
			return $resttag;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
    			
	public function CheckTag($request)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();			
			$select->from($table,array('code','description'));		
			$result = array();	
			if($request->tagname){				
				if (trim($request->tagname) != 'null') {
					$select->where('description'.' ILIKE(?)','%'.trim($request->tagname).'%');				
				}
				$select->where('status = ?',true);
				$resultset = $table->fetchAll($select);
				foreach($resultset as $row){
					$result = array('Description' => $row->description);
				}				
			}		    
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}