<?php
class FirmManagement_Model_FirmWidgetCustomizeDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('FirmManagement_Model_DbTable_FirmWidgetCustomize');
		}
		return $this->_dbTable;
	}
	
	public function SaveWidget(FirmManagement_Model_customwidget $Details)
        {
        	try{
        		$restId = $Details ->getrestid();
	        	$select = $this->getDbTable()
	        					->select()
	            				->from('mt.widget_customize',array('wc_links_colors','wc_alerts_colors','wc_title_colors','wc_bg_color','wc_bg_image_url'))
	              				->where('wc_restid = ?',$restId); 
	            $exec = $select->query();
				$result = $exec->fetchAll();
	           	$InsertData = array('wc_links_colors' 	=> '#'.$Details ->getcolorlinks(),
					          'wc_alerts_colors' 		=> '#'.$Details->getalertcolors(),
				              'wc_title_colors' 		=> '#'.$Details->gettitlecolor(),
				              'wc_bg_color'   			=> '#'.$Details->getbgcolor(),
				              'wc_restid' 				=> $restId,    
	           				  'wc_createdby'			=> $Details->getcreated_by(),
	           				  'wc_create_date_time'		=> $Details->getcreated_date()
	           				  );   				
	           	$UpdateData = array('wc_links_colors' 	=> '#'.$Details ->getcolorlinks(),
					          'wc_alerts_colors' 		=> '#'.$Details->getalertcolors(),
				              'wc_title_colors' 		=> '#'.$Details->gettitlecolor(),
				              'wc_bg_color'   			=> '#'.$Details->getbgcolor(),
				    //          'wc_bg_image_url' 		=> $Details->getbgimage(),    
	           				  'wc_updatedby'			=> $Details->getupdated_by(),
	           				  'wc_updated_date_time'	=> $Details->getupdated_date()
	           				  ); 
	           	$Insert = '';
	           	$Update = '';
	           	if ($result == NULL) {
		           	if($Details->getbgimage()){
		           		$InsertData['wc_bg_image_url'] 		= $Details->getbgimage();
		           	}
		           	$Insert = $this->getDbTable()->insert($InsertData);
		         
	        	} 
	        	else {    	
	        		if($Details->getbgimage()){
		           		$UpdateData['wc_bg_image_url'] 		= $Details->getbgimage();
		           	}
	        		$Update =  $this->getDbTable()->update($UpdateData, array('wc_restid = ?' => $restId));      
	        	}
	        	if($Insert !='' || $Update != ''){
	        		return 't';
	        	}
	        	else
	        	{
	        		return 'f';
	        	}
	        }catch (Exception $ex){
				throw new Exception($ex->getMessage()) ;
			}
           }
           
           public function getRestCustomizeWidgeteSetting($restid)
           {
           		try{
           			$select = $this->getDbTable()
	        						->select()
	            					->from('mt.widget_customize',array('wc_links_colors','wc_alerts_colors','wc_title_colors','wc_bg_color','wc_bg_image_url'))
	              					->where('wc_restid = ?',$restid); 
	            	$exec = $select->query();
					$result = $exec->fetchAll();
					if($result){
						return $result[0];
					}
           }catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
           }
           
	 public function getwidgetbackgroundimgbyresid($restid)
     {
         try{
           $selectTable = $this->getDbTable();
       	   $select = $selectTable->select();
           $select->from('mt.widget_customize',array('wc_bg_image_url'))
          		    ->where('wc_restid = ?',$restid); 
     	   $result = $selectTable->fetchRow($select);
		   $image = $result->wc_bg_image_url;
		   if($result){
	           $UpdateData['wc_bg_image_url'] 	= '';        
	           $Update =  $this->getDbTable()->update($UpdateData, array('wc_restid = ?' => $restid));      
			   return $image;
		   }
        }catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
     }
}