<?php
class FirmManagement_Model_MenuItemsDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('FirmManagement_Model_DbTable_MenuItems');
		}
		return $this->_dbTable;
	}
	
	public function AddMenuItems($category_id, $request)
	{
		try{
			$itemNames = $request->itemname; 
			$itemDesc = $request->itemdesc;
	    	$itemPrice = $request->itemprice;
	    	$itemType = $request->type;
            $itemColor = $request->itemcolor;
	    	
	    	$storage = new Zend_Auth_Storage_Session();
			$userdata = $storage->read();
			
			for($i = 0; $i < count($itemNames); $i++ )
			{
				$data = array(
		    		'mifk_categoryid'	=>	$category_id,
		    		'mi_name'			=>	$itemNames[$i],
		    		'mi_description'	=>	$itemDesc[$i],
					'mi_price'			=>	$itemPrice[$i],
					'mi_status'			=>	true,
		    		'mi_createdby'		=>	$userdata['User_Id'],
		    		'mi_createddatetime'=>	date('Y-m-d H:i:s')
		    	);
		    	if($itemType[$i]){
		    		$data['mi_type'] = $itemType[$i]; 
		    	}
                if($itemColor[$i]){
                    $data['mi_itemcolor'] = $itemColor[$i];
                }
		    	$this->getDbTable()->insert($data);
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	//Add item
        public function AddMenuItem($request)
	{
		try{			    	                	    	
	    	$storage = new Zend_Auth_Storage_Session();
		$userdata = $storage->read();
                $addonMapper = new FirmManagement_Model_MenuItemsAddonDataMapper(); 
                $tagsDb = new FirmManagement_Model_DbTable_MenuItemTags();
                $restaurantid =     $request->restaurantid;  
                $itemtag = $request->itemtag;                
                $moditemNames = $request->moditemname; 
		$moditemDesc = $request->moditemdesc;
	    	$moditemPrice = $request->moditemprice;
	    	$moditemType = $request->moditemtype;
                $modfier_id = array();
                
                                                                
			$data = array(
		    		'mifk_categoryid'	=>	$request->categoryid,
		    		'mi_name'		=>      $request->itemname,
		    		'mi_description'	=>	$request->itemdesc,
				'mi_price'		=>	$request->itemprice,
                                'mi_itemcolor'		=>	$request->itemcolor,                            
				'mi_status'			=>	true,
		    		'mi_createdby'		=>	$userdata['User_Id'],
		    		'mi_createddatetime'=>	date('Y-m-d H:i:s')
		    	);
                        if($request->itemtype){
                            $data['mi_type'] = $request->itemtype;
                        }
                        if(count($moditemNames)>0){
                            $data['mi_modifier_status'] = true;
                        }
                        $itemid = $this->getDbTable()->insert($data);
                        if($itemid){
                            
                            if($itemtag!=null){
                                $tagText = $itemtag;
                                preg_match_all("/(#\w+)/", $tagText, $tags);
                                $this->updateMenuItemTags($itemid, $tags[0]);
                            }
                            
                            for($i = 0; $i < count($moditemNames); $i++ )
                                {
                               if(count($moditemNames)>0){
                                   $data = array(
                                       'mia_fk_restaurant'	=>	$restaurantid,
                                       'mia_fk_item'       =>  $itemid,
                                       'mia_name'			=>	$moditemNames[$i],
                                       'mia_description'	=>	$moditemDesc[$i],					
                                       'mia_status'		=>	true,
                                       'mia_createdby'		=>	$userdata['User_Id'],
                                       'mia_createddatetime'=>	date('Y-m-d H:i:s')
                                   );
                                   if(array_key_exists($i, $moditemType)){
                                       $data['mia_type'] = $moditemType[$i]; 
                                   }
                                   if(array_key_exists($i, $moditemPrice)){
                                       $data['mia_price'] = $moditemPrice[$i];
                                       $data['mia_pricetype'] = true;
                                   }
                                   $addonMapper = new FirmManagement_Model_MenuItemsAddonDataMapper();                
                                   $modfier_id[] = $addonMapper->getDbTable()->insert($data);
                               }
                           }
                           
                         
                        }                       
                $arrayset = array('itemid'=>$itemid, 'modiferid' =>$modfier_id); 
                
                return $arrayset; 
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
        
        public function EditMenuItem($request)
	{
		$db = Zend_Db_Table::getDefaultAdapter();		
                $storage = new Zend_Auth_Storage_Session();
		$userdata = $storage->read();
                
                $tagsDb = new FirmManagement_Model_DbTable_MenuItemTags();
                $itemid = $request->itemid;
                $itemtag = $request->itemtag;
                $globalitemtag = $request->globalitemtag;
                $itemtaghash = md5($itemtag);
                $taghashbeforedit = md5($globalitemtag);
                $restaurantid =     $request->restaurantid;  
                $modfier_id = array();
                
                $moditemId = $request->moditemid;                
                $moditemNames = $request->moditemname; 
		$moditemDesc = $request->moditemdesc;
		$moditemPrice = $request->moditemprice;
		$moditemType = $request->moditemtype;
                
                
                
        	$data = array(		    		
                            'mi_name'		=>      $request->itemname,
                            'mi_description'	=>	$request->itemdesc,
                            'mi_price'		=>	$request->itemprice,
                            'mi_itemcolor'		=>	$request->itemcolor,                            				
                            'mi_createdby'		=>	$userdata['User_Id'],
                            'mi_createddatetime'=>	date('Y-m-d H:i:s')
                       );    
                
                if($request->itemtype){
                    $data['mi_type'] = $request->itemtype;
                    }
                if(count($moditemNames)>0){
                            $data['mi_modifier_status'] = true;
                        }    
		try{
						
                        $where = $db->quoteInto('miid = ?',$itemid);
			$row_affected = $this->getDbTable()->update($data, $where);
                        
                        
                            if($itemtaghash!=$taghashbeforedit){
                                $tagText = $itemtag;
                                preg_match_all("/(#\w+)/", $tagText, $tags);
                                $this->updateMenuItemTags($itemid, $tags[0]);
                            } 
                            
                        
                        
                        for($i = 0; $i < count($moditemNames); $i++ )
                            {
                                if($moditemId && $moditemId[$i] && array_key_exists($i, $moditemId)){
                                    $data = array(
                                        'mia_name'			=>$moditemNames[$i],
                                        'mia_description'	=>	$moditemDesc[$i],					
                                        'mia_status'		=>	true,
                                        'mia_createdby'		=>	$userdata['User_Id'],
                                        'mia_createddatetime'=>	date('Y-m-d H:i:s')
                                    );
                                    if($moditemType && array_key_exists($i, $moditemType)){
                                        $data['mia_type'] = $moditemType[$i]; 
                                    }
                                    if($moditemPrice && array_key_exists($i, $moditemPrice)){
                                        $data['mia_price'] = $moditemPrice[$i];
                                        $data['mia_pricetype'] = true;
                                    }
                                    $where = array('mia_fk_item = ?' => $request->itemid,'mia_id = ?'=>$moditemId[$i]);
                                    $addonMapper = new FirmManagement_Model_MenuItemsAddonDataMapper();                
                                    $addonMapper->getDbTable()->update($data,$where);
                                }else{
                                    $data = array(
                                        'mia_fk_restaurant'	=>	$request->restaurantid,
                                        'mia_fk_item'       =>  $request->itemid,
                                        'mia_name'			=>	$moditemNames[$i],
                                        'mia_description'	=>	$moditemDesc[$i],					
                                        'mia_status'		=>	true,
                                        'mia_createdby'		=>	$userdata['User_Id'],
                                        'mia_createddatetime'=>	date('Y-m-d H:i:s')
                                    );
                                    if(array_key_exists($i, $moditemType)){
                                        $data['mia_type'] = $moditemType[$i]; 
                                    }
                                    if(array_key_exists($i, $moditemPrice)){
                                        $data['mia_price'] = $moditemPrice[$i];
                                        $data['mia_pricetype'] = true;
                                    }
                                    $addonMapper = new FirmManagement_Model_MenuItemsAddonDataMapper();                
                                    $modfier_id[] = $addonMapper->getDbTable()->insert($data);
                                }
                            }
                                                                                                                                                                                                                        
			$arrayset = array('itemid'=>$itemid, 'modiferid' =>$modfier_id); 
                        return $arrayset;                            			
		}catch(Exception $ex){
			$db->rollBack();
			throw new Exception($ex->getMessage()) ;
		}
	}
        
	public function GetMenuItems($categoryid)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			$itemTagSelect = '(SELECT(array (SELECT mit_tag_title  FROM mt.menu_item_tags where mit_fk_itemid = mi.miid))) AS itemTags';
            $modMapper = new FirmManagement_Model_MenuItemsAddonDataMapper();
            $modSelect = $modMapper->getDbTable()->select();
            $modSelect->setIntegrityCheck(false);
            $modSelect->from(array('mod'=>'mt.menu_items_addon'),array('mia_id','mia_fk_restaurant','mia_fk_item','mia_name','mia_description','mia_type','mia_price','mia_status','mia_colorcode','mia_pricetype'))
                    ->joinLeft(array('mtbdmod'=>'mt.menu_typebd'),'mtbdmod.id = mod.mia_type',array('description as moditemtype'))
                    ->where('mia_status = ?',TRUE)
                    ->order('mia_id');
            
			$select->from(array('mi'=>'mt.menu_items'),array('miid','mi_name','mi_description','mi_price','mi_status','mi_itemcolor','mi_modifier_status',$itemTagSelect))
				   ->joinLeft(array('mtbd'=>'mt.menu_typebd'),'mtbd.id = mi.mi_type',array('description as itemtype'))
                    ->joinLeft(array('mod'=>$modSelect),'mod.mia_fk_item = mi.miid',array('array_agg(mia_id) as modid','mia_fk_restaurant','mia_fk_item','array_agg(mia_name) as modname','array_agg(mia_description) as moddesc','array_agg(mia_type) as modtype','array_agg(mia_price) as modprice','array_agg(mia_status) as modstatus','array_agg(mia_colorcode) as modcolor','array_agg(mia_pricetype) as modpricetype'))
                    ->where('mifk_categoryid = ?',$categoryid)
                    ->where('mi_status = ?',true)
                    ->group(array('miid','mtbd.description','mod.mia_fk_restaurant','mod.mia_fk_item'))
				   ->order(array('miid ASC'));
			
			$rowSet = $table->fetchAll($select);
			$menuItems = array();
			foreach($rowSet as $row){
                
                $modidArr= str_getcsv(trim($row->modid, '{}'));
				$modnameArr= str_getcsv(trim($row->modname, '{}'));
				$moddescArr= str_getcsv(trim($row->moddesc, '{}'));
                $modpriceArr= str_getcsv(trim($row->modprice, '{}'));
				$modtypeArr= str_getcsv(trim($row->modtype, '{}'));
				$modstatusArr= str_getcsv(trim($row->modstatus, '{}'));
                
				$menuItems[] = array(
						'itemid'        =>	$row->miid,
						'itemname'      =>	$row->mi_name,
						'itemdesc'      =>	$row->mi_description,
						'itemprice'     =>	$row->mi_price,
						'itemtype'      =>	$row->itemtype,
						'itemstatus'    =>	$row->mi_status,
                        'itemcolor'     =>  $row->mi_itemcolor,
                        'modstatus'    =>  $row->mi_modifier_status,
                        'moditemid'     =>	$modidArr,
						'moditemname'	=>	$modnameArr,
						'moditemdesc'	=>	$moddescArr,
						'moditemprice'	=>	$modpriceArr,
						'moditemtype'	=>	$modtypeArr,
						'moditemstatus' =>	$modstatusArr,
                        'moditemcolor'  =>  $row->modcolor,
                        'itemTags'		=> 	$this->postgresArrayToPhp($row->itemTags)
					);
			}
			return $menuItems;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function postgresArrayToPhp($postgresArray)
	{
		try
		{
			$data = str_replace(array("\r\n", "\r", "\n"), "", trim($postgresArray,'{}'));
			$result = array();
			if(strlen($data)>0)
			{
				if (strpos($data, '"') === 0) {
			    $data = '[' . $data . ']';
			    $result = json_decode($data);
				} else {
				    $result = explode(',', $data);

				}
			}
			return $result;
		}
		catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function EditMenuItems($request)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$itemNames = $request->itemname; 
			$itemDesc = $request->itemdesc;
	    	$itemPrice = $request->itemprice;
	    	$itemType = $request->type;
	    	$itemIds = $request->itemid;
	    	
	    	$storage = new Zend_Auth_Storage_Session();
			$userdata = $storage->read();
			
			for($i = 0; $i < count($itemNames); $i++ )
			{
				if($itemIds[$i] != "")
				{
					$set = array(
			    		'mi_name'			=>	$itemNames[$i],
			    		'mi_description'	=>	$itemDesc[$i],
						'mi_price'			=>	$itemPrice[$i],
						'mi_type'			=>	$itemType[$i],
			    		'mi_updatedby'		=>	$userdata['User_Id'],
			    		'mi_updateddatetime'=>	date('Y-m-d H:i:s')
			    	);
			    	$where = $db->quoteInto('miid = ?',$itemIds[$i]);
					$row_affected = $this->getDbTable()->update($set,$where);
				}else{
					$data = array(
		    		'mifk_categoryid'	=>	$request->categoryid,
		    		'mi_name'			=>	$itemNames[$i],
		    		'mi_description'	=>	$itemDesc[$i],
					'mi_price'			=>	$itemPrice[$i],
					'mi_type'			=>	$itemType[$i],
		    		'mi_status'			=>	true,
		    		'mi_createdby'		=>	$userdata['User_Id'],
		    		'mi_createddatetime'=>	date('Y-m-d H:i:s')
		    	);
		    	
		    	$this->getDbTable()->insert($data);
				}
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getMenuItemsByCategoryId($categoryid)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();
			
			$select->from($table,array('miid','mi_name','mi_description','mi_price','mi_status','mi_type','mi_itemcolor'))
				   ->where('mifk_categoryid = ?',$categoryid)
				   ->where('mi_status = ?',true)
				   ->order(array('miid ASC'));
			
			$rowSet = $table->fetchAll($select);
			$menuItems = array();
			foreach($rowSet as $row){
				$menuItems[] = array(
						'itemid'	=>	$row->miid,
						'itemname'	=>	$row->mi_name,
						'itemdesc'	=>	$row->mi_description,
						'itemprice'	=>	$row->mi_price,
						'itemtype'	=>	$row->mi_type,
						'itemstatus'=>	$row->mi_status,
                        'itemcolor' =>  $row->mi_itemcolor
					);
			}
			return $menuItems;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getRestaurantMenuItemsByCategoryId($categoryid)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();
			
			$select->from($table,array('miid','mi_name','mi_description','mi_price','mi_status','mi_type','mi_itemcolor'))
				   ->where('mifk_categoryid = ?',$categoryid)
				   ->where('mi_status = ?',true)
				   ->order(array('miid ASC'));
			
			$rowSet = $table->fetchAll($select);
			$menuItems = array();
			foreach($rowSet as $row){
				$menuItems[] = array(
						'itemid'	=>	$row->miid,
						'itemname'	=>	$row->mi_name,
						'itemdesc'	=>	$row->mi_description,
						'itemprice'	=>	$row->mi_price,
						'itemtype'	=>	$row->mi_type,
						'itemstatus'=>	$row->mi_status,
                        'itemcolor' =>  $row->mi_itemcolor
					);
			}
			return $menuItems;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function changeMenuItemStatus($itemid, $status)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			
			$set = array('mi_status' => $status);
			
			$where = $db->quoteInto('miid = ?',$itemid);
			$row_affected = $this->getDbTable()->update($set,$where);
			return $row_affected;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function updateItem($request)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$storage = new Zend_Auth_Storage_Session();
			$userdata = $storage->read();
			
                        $moditemId = $request->moditemid; 
                        $moditemNames = $request->moditemname; 
			$moditemDesc = $request->moditemdesc;
                	$moditemPrice = $request->moditemprice;
                        $moditemType = $request->moditemtype;
            
			$set = array('mi_name'			=>	$request->itemname,
			    		'mi_description'	=>	$request->itemdesc,
						'mi_price'			=>	$request->itemprice,
						//mi_type'			=>	$request->itemtype,
			    		'mi_updatedby'		=>	$userdata['User_Id'],
			    		'mi_updateddatetime'=>	date('Y-m-d H:i:s'));
			if($request->itemtype){
	    		$set['mi_type'] = $request->itemtype;
	    	}
            if($request->itemcolorcode){
                $set['mi_itemcolor'] =  $request->itemcolorcode;
            }
            if($moditemId){
                $set['mi_modifier_status'] =  'true';
            }
			
	    	$where = $db->quoteInto('miid = ?',$request->itemid);
			$row_affected = $this->getDbTable()->update($set,$where);
            
            for($i = 0; $i < count($moditemNames); $i++ )
            {
                if($moditemId && $moditemId[$i] && array_key_exists($i, $moditemId)){
                    $data = array(
                        'mia_name'			=>	$moditemNames[$i],
                        'mia_description'	=>	$moditemDesc[$i],					
                        'mia_status'		=>	true,
                        'mia_createdby'		=>	$userdata['User_Id'],
                        'mia_createddatetime'=>	date('Y-m-d H:i:s')
                    );
                    if($moditemType && array_key_exists($i, $moditemType)){
                        $data['mia_type'] = $moditemType[$i]; 
                    }
                    if($moditemPrice && array_key_exists($i, $moditemPrice)){
                        $data['mia_price'] = $moditemPrice[$i];
                        $data['mia_pricetype'] = true;
                    }
                    $where = array('mia_fk_item = ?' => $request->itemid,'mia_id = ?'=>$moditemId[$i]);
                    $addonMapper = new FirmManagement_Model_MenuItemsAddonDataMapper();                
                    $addonMapper->getDbTable()->update($data,$where);
                }else{
                    $data = array(
                        'mia_fk_restaurant'	=>	$request->restaurantid,
                        'mia_fk_item'       =>  $request->itemid,
                        'mia_name'			=>	$moditemNames[$i],
                        'mia_description'	=>	$moditemDesc[$i],					
                        'mia_status'		=>	true,
                        'mia_createdby'		=>	$userdata['User_Id'],
                        'mia_createddatetime'=>	date('Y-m-d H:i:s')
                    );
                    if(array_key_exists($i, $moditemType)){
                        $data['mia_type'] = $moditemType[$i]; 
                    }
                    if(array_key_exists($i, $moditemPrice)){
                        $data['mia_price'] = $moditemPrice[$i];
                        $data['mia_pricetype'] = true;
                    }
                    $addonMapper = new FirmManagement_Model_MenuItemsAddonDataMapper();                
                    $modUpd[] = $addonMapper->getDbTable()->insert($data);
                }
            }
            
			return $row_affected;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}	
	
	public function addItemByCategoryid($request)
	{
		try{
			$storage = new Zend_Auth_Storage_Session();
			$userdata = $storage->read();
			$db = Zend_Db_Table::getDefaultAdapter();
			$db->beginTransaction();
            
            $moditemNames = $request->moditemname; 
			$moditemDesc = $request->moditemdesc;
	    	$moditemPrice = $request->moditemprice;
	    	$moditemType = $request->moditemtype;
//            $itemColor = $request->itemcolor;
            
			$data = array(
		    		'mifk_categoryid'	=>	$request->categoryid,
		    		'mi_name'			=>	$request->itemname,
		    		'mi_description'	=>	$request->itemdesc,
					'mi_price'			=>	$request->itemprice,
					'mi_status'			=>	true,
		    		'mi_createdby'		=>	$userdata['User_Id'],
		    		'mi_createddatetime'=>	date('Y-m-d H:i:s')
		    	);
            if(count($moditemNames)){
                $data['mi_modifier_status'] = 'true';
            }
            if($request->itemtype){
                $data['mi_type'] = $request->itemtype;
            }
            if($request->itemcolorcode){
                $set['mi_itemcolor'] =  $request->itemcolorcode;
            }
		    	
		   	$id = $this->getDbTable()->insert($data);
            $modUpd = array();
			for($i = 0; $i < count($moditemNames); $i++ )
			{
				$data = array(
		    		'mia_fk_restaurant'	=>	$request->restaurantid,
                    'mia_fk_item'       =>  $id,
		    		'mia_name'			=>	$moditemNames[$i],
		    		'mia_description'	=>	$moditemDesc[$i],					
					'mia_status'		=>	true,
		    		'mia_createdby'		=>	$userdata['User_Id'],
		    		'mia_createddatetime'=>	date('Y-m-d H:i:s')
		    	);
		    	if($moditemType && array_key_exists($i, $moditemType)){
		    		$data['mia_type'] = $moditemType[$i]; 
		    	}
                if($moditemPrice && array_key_exists($i, $moditemPrice)){
                    $data['mia_price'] = $moditemPrice[$i];
                    $data['mia_pricetype'] = true;
                }
                $addonMapper = new FirmManagement_Model_MenuItemsAddonDataMapper();                
		    	$modUpd[] = $addonMapper->getDbTable()->insert($data);
			}
            $db->commit();
		   	return array('item'=>$id,'modifier'=>$modUpd);
		}catch(Exception $ex){
            $db->rollBack();
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function updateItemSequence($request)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$itemIds = $request->itemidarr; 
			$rowIndexs = $request->rowindexarr;
	    	
			for($i = 0; $i < count($itemIds); $i++ )
			{
				$set = array('mi_ordersequence'	=>	$rowIndexs[$i]);		    	
		    	$where = $db->quoteInto('miid = ?',$itemIds[$i]);
				$row_affected = $this->getDbTable()->update($set,$where);
			}
			return true;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * [updateMenuItemTags updates the tags of the menu item]
	 * @param  [type] $itemId [itemid]
	 * @param  array  $tags   [includes an array of tags to be added]
	 * @return [boolean]         [Nothing significant]
	 */
	public function updateMenuItemTags($itemId,array $tags)
	{
		try{
			
				$tagsDb = new FirmManagement_Model_DbTable_MenuItemTags();
				$where = 'mit_fk_itemid = '.$itemId;
				$tagsDb->delete($where);
				foreach ($tags as $key => $tag) {
					$tagrr = array('mit_fk_itemid'=>$itemId,'mit_tag_title'=>$tag);
					$tagsDb->insert($tagrr);
				}
			
			

		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
		
	}
}