<?php

class FirmManagement_Model_PosOderAddonMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('FirmManagement_Model_DbTable_PosOrderAddons');
		}
		return $this->_dbTable;
	}
	
	public function getModifiersByOrderDetailId($orderDetailId)
	{
		try
		{
			$db = $this->getDbTable();
			$select = $db->select()
						->from(array('mt.pos_order_addons'))
						->where('poa_status = ?',true)
						->where('poa_id = ?',$orderDetailId)
						->setIntegrityCheck(false);
			$data = $select->query()->fetchAll();
			$response = array();
			if(count($data)>0)
			{
				foreach ($data as $key => $row) {
					$temp["order_detail_id"] = $row['poa_orderdetial_fk_id'];
					$temp["order_id"] = $row['poa_order_fk_id'];
					$temp["moi_id"] = $row['poa_modifier_fk_id'];
					$temp["mia_name"] = $row['poa_modifier_name'];
					$temp["mia_price"] = $row['poa_modifier_price'];
					$temp["item_id"] = $row['poa_item_fk_id'];
					$temp["mod_status"] = $row['poa_status'];
					$temp['mod_hash_identifier'] = md5(json_encode($temp));
					$response[] = $temp;
				}
			}
			return $response;
		}
		catch (Exception $e) {
			throw new Exception($e->getMessage());
			
		}
	}
	
}