<?php

class FirmManagement_Model_PosOrderDetailsMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('FirmManagement_Model_DbTable_PosOrderdetails');
		}
		return $this->_dbTable;
	}
	
	public function getOrderDetailsByOderId($orderid)
	{
		try
		{
			$db = $this->getDbTable();
			$select = $db->select()
						->from(array('mt.pos_restaurant_order_details'))
						->joinLeft(array('mt.menu_items'),'prod_item_fk_id = miid',array('mi_name'))
						->where('prod_status = true')
						->where('prod_id = ?',$orderid)
						->setIntegrityCheck(false);
			$main = array();
			$data = $select->query()->fetchAll();
			$modMapper = new FirmManagement_Model_PosOderAddonMapper();
			$FirmManagement_Model_DbTable_PosOrderdetails = array();
			if(count($data)>0)
			{
				foreach ($data as $key => $row) {
					$response = array();
					$response['order_detail_id'] = $row['prod_id'];
					$response["discount"] = $row['prod_discount'];
					$response["discountamt"] = $row['prod_discountamt'];
					$response["item_base_price"] = $row['prod_item_base_price'];
					$response["item_categoryid"] = $row['prod_item_categoryid'];
					$response["item_id"] = $row['prod_item_fk_id'];
					$response["item_name"] = $row['mi_name'];
					$response["netamt"] = $row['prod_netamt'];
					$response["order_id_ref"] = $row['prod_order_fk_id'];
					$response['tax']= $row['prod_tax'];
					$modArr = $modMapper->getModifiersByOrderDetailId($row['prod_id']);
					$response['modifiers'] = $modArr;
					$response['od_hash_identifier'] = md5(json_encode($response));
					$main[] = $response;
				}
			}
			return $main;
		}
		catch (Exception $e) {
			throw new Exception($e->getMessage());
			
		}
	}
}