<?php

class FirmManagement_Model_PosTaxListMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('FirmManagement_Model_DbTable_PosTaxList');
		}
		return $this->_dbTable;
	}
	
    public function getAllTaxes($restid = 0)
	{
		try{
			$limit = 15;
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
            $resmapper = new FirmManagement_Model_FirmDataMapper();
            $resSelect = $resmapper->getDbTable()->select();
            $resSelect->from($resmapper->getDbTable(),array('resid','resrestaurant_name'))
                        ->where('resid = ?',$restid);
			$select->from(array('rol'=>'mt.pos_tax_bd'),array('id','code','description','tax','pt_fk_restaurant','status','pt_type'))
				   ->joinLeft(array('res'=>$resSelect),'res.resid = rol.pt_fk_restaurant',array('resrestaurant_name'))
				   ->order(array('rol.id'));	
            
			$result = $table->fetchAll($select);

			return $result;
			//return $roleList;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
    
    public function updateTaxTr($request)
    {
        try{
            $id = $request->taxid;
            $code = $request->code;
            $desc = $request->desc;
            $tax = $request->tax;
            $storage = new Zend_Auth_Storage_Session();
            $data = $storage->read();
            if($id){
                if(isset($request->act)){
                    if($request->act == 'enable'){
                        $set = array('status'=>'true');
                    }else{
                        $set = array('status'=>'false');
                    }
                }else{
                    $set = array(
                        'pt_fk_restaurant'	=>	$request->restaurantid,
                        'code'				=>	$code,
                        'description'		=>	$desc,
                        'tax'				=>	$tax
                    );
                }
                $set['pt_updatedby'] = $data['User_Id'];
                $set['pt_updatedon'] = date('Y-m-d h:i:s');
                $where = array('id = ?'=>$id);
                $role_id = $this->getDbTable()->update($set,$where);
            }else{
                 $set = array(
                    'pt_fk_restaurant'	=>	$request->restaurantid,
                    'code'				=>	$code,
                    'description'		=>	$desc,
                    'tax'				=>	$tax,
                    'status'            =>  'false',
                    'pt_type'           =>  'Custom',
                    'pt_fk_createdby'   =>  $data['User_Id'],
                    'pt_createdon'      =>  date('Y-m-d h:i:s')
                );
                $role_id = $this->getDbTable()->insert($set);
            }
            return $role_id;
        } catch (Exception $ex) {
            throw new Exception($ex->getMessage()) ;
        }
    }

        public function AddTax($category_id, $request)
	{
		try{
			$itemNames = $request->itemname; 
			$itemDesc = $request->itemdesc;
	    	$itemPrice = $request->itemprice;
	    	$itemType = $request->type;
            $itemColor = $request->itemcolor;
	    	
	    	$storage = new Zend_Auth_Storage_Session();
			$userdata = $storage->read();
			
			for($i = 0; $i < count($itemNames); $i++ )
			{
				$data = array(
		    		'mifk_categoryid'	=>	$category_id,
		    		'mi_name'			=>	$itemNames[$i],
		    		'mi_description'	=>	$itemDesc[$i],
					'mi_price'			=>	$itemPrice[$i],
					'mi_status'			=>	true,
		    		'mi_createdby'		=>	$userdata['User_Id'],
		    		'mi_createddatetime'=>	date('Y-m-d H:i:s')
		    	);
		    	if($itemType[$i]){
		    		$data['mi_type'] = $itemType[$i]; 
		    	}
                if($itemColor[$i]){
                    $data['mi_itemcolor'] = $itemColor[$i];
                }
		    	$this->getDbTable()->insert($data);
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}