<?php

class FirmManagement_Model_RestaurantCustomerGroupsDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('FirmManagement_Model_DbTable_RestaurantCustomerGroups');
		}
		return $this->_dbTable;
	}

   public function getUserGroupsByRestaurnatId($resId)
   {
   	try {
   		$db = $this->getDbTable();
   		$select = $db->select()
   					->from(array('mt.restaurant_customers_groups'))
   					->where('rcg_fk_restaurant_id = ?',$resId)
   					->where('rcg_status = ?',true);
   		$data = $select->query()->fetchAll();
   		return $data;
   	} catch (Exception $ex) {
   		throw new Exception($ex->getMessage());
   	}
   }

   public function getCustomerContactNUmbersByGroupIds($groupIds)
	{
		try{
			$db = $this->getDbTable();
			$groupSelect = $db->select();
			$groupSelect = $groupSelect->from(array('mt.restaurant_customers_groups_map'),array('rcgcm_fk_user_id'))
									->joinLeft(array('mt.restaurant_customers_groups'),'rcg_id = rcgcm_fk_group_id',array())
									->where('rcg_id IN (?)',$groupIds)
									->setIntegrityCheck(false);
			$groupUserIdsRaw = $groupSelect->query()->fetchAll();
			$groupUserIds = array();
			foreach ($groupUserIdsRaw as $row) {
				$groupUserIds[] = $row['rcgcm_fk_user_id'];
			}

			$firmGroupUsersMapper = new FirmManagement_Model_FirmGroupUsersDataMapper();

			$table = $firmGroupUsersMapper->getDbTable();
			$select = $table->select();
			$select->from($table,array('rguphone','rgucountrycode'))
					->joinLeft(array('mt.restaurant'),'rgufk_restaurant = resid',array('resstate_id'))
					->joinLeft(array('mt.state_bd'),'id = resstate_id',array('country_dial_code'))
			       ->where('rguid IN (?) ',$groupUserIds)
			       ->where('rguphone IS NOT NULL')
			       ->where('rguphone <> ?', '')
			       ->where('rgustatus = ?',true)
			       ->setIntegrityCheck(false);
			$rowset = $table->fetchAll($select);
			$phonearrray = array();
			if(count($rowset) > 0){
				 foreach($rowset as $result){
				 	$phoneNumber = $result->rguphone;
				 	$phoneNumber = preg_replace('/\s+/', '', $phoneNumber);
				 	if(strlen($phoneNumber)<=10)
				 	{
				 		if(strlen($result->rgucountrycode)>0)
				 		{
				 			$phoneNumber = $result->rgucountrycode."".$phoneNumber;
				 		}
				 		else
				 		{
				 			$phoneNumber = $result->country_dial_code."".$phoneNumber;	
				 		}
				 	} 
				 	$phonearrray[] = $phoneNumber;	
 				} 

 				
 				 $resultSet = array('phonestring'=> $phonearrray, 'countNumbers'=> count($phonearrray));
 
				return $resultSet;
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}