<?php
class FirmManagement_Model_RestaurantSessionAlertsMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('FirmManagement_Model_DbTable_RestaurantSessionAlerts');
		}
		return $this->_dbTable;
	}
	
	public function getSessionAlerts($conditionArray = null)
	{
		try
		{
			$db = $this->getDbTable();
			$select = $db->select();
			$select->from($db);
			if($conditionArray!=null)
			{
				if(is_array($conditionArray))
				{
					if(count($conditionArray)>0)
					{
						foreach($conditionArray as $key => $condition)
						{
							$select->where($key,$condition);
						}
					}
				}
			}
			$select->order('rsa_id DESC');
			$result = $select->query()->fetchAll();
			return $result;
		}
		catch(Exception $ex)
		{
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function addNewAlert($data)
	{
		try
		{
			if(count($data)>0)
			{
				$data['rsa_createdon'] = date("Y-m-d H:i:s");
				$data['rsa_info'] = htmlspecialchars($data['rsa_info']);
				$data['rsa_createdfor'] = htmlspecialchars($data['rsa_createdfor']);
				$db = $this->getDbTable();
				$id = $db->insert($data);
				return $id;
			}
			else
			{
				return false;
			}
		}
		catch(Exception $ex)
		{
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getAlertsCount($resid,$date)
	{
		try
		{
			$db = $this->getDbTable();
			$select = $db->select($db,array('alert_count'=>'COUNT(*)'));
			$select->where('rsa_assignedon = ?',$date);
			$select->where('rsa_resfkid = ?',$resid);
			$data = $select->query()->fetchAll();
			return $data;

		}
		catch(Exception $ex)
		{
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function deleteSessionAlertById($id)
	{
		try
		{
			$db = $this->getDbTable();
			$respose = $db->delete('rsa_id = '.$id);
			return $respose;

		}
		catch(Exception $ex)
		{
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function editSessionAlertById($data,$id)
	{
		try
		{
			$db = $this->getDbTable();
			$response = $db->update($data,'rsa_id = '.$id);
			return $response;

		}
		catch(Exception $ex)
		{
			throw new Exception($ex->getMessage()) ;
		}
	}
}