<?php

class FirmManagement_Model_SmsCampaignDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('FirmManagement_Model_DbTable_SmsCampaign');
		}
		return $this->_dbTable;
	}
	
	public function SaveSmsCampaign($title,$msg,$userdata,$camptype = null,$groupids = null)
	{
		try{
			$date = date("Y-m-d");
			$time = date("H:i:s");
			$data = array(
			'smscamp_title'   	 		=> 	$title,
			'smscamp_msg'  	   			=> 	$msg,
			'smscamp_resid'   			=> 	$userdata['RestId'],
			'smscamp_createdby' 		=>	$userdata['User_Id'],
			'smscamp_createddatetime'	=>  $date." ".$time
				
			);
			if($camptype !=null)
			{
				$data['smscamp_type'] = $camptype;
			}
			

			$result = $this->getDbTable()->insert($data);
			
			if($result){
				if($camptype ==2)
			{
				if($groupids!=null)
				{
					if(count($groupids)>0)
					{
						$smsCampGroupsMapTable = new FirmManagement_Model_DbTable_SmsCapaignsUserGroupsMap();
						foreach ($groupids as $group) {
							$temp = array();
							$temp['scugm_fk_camp_id'] = $result;
							$temp['scugm_fk_group_id'] = $group;
							$smsCampGroupsMapTable->insert($temp);
	 					}
					}
				}
			}
				return $result;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function SaveMobileSmsCampaign($title,$msg,$resid,$userid)
	{
		try{
			$date = date("Y-m-d");
			$time = date("H:i:s");
			$data = array(
			'smscamp_title'   	 		=> 	$title,
			'smscamp_msg'  	   			=> 	$msg,
			'smscamp_resid'   			=> 	$resid,
			'smscamp_createdby' 		=>	$userid,
			'smscamp_createddatetime'	=>  $date." ".$time
				
			);
			$result = $this->getDbTable()->insert($data);
			if($result){
				return $result;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetSmsCampaignDetailsbyresId($data,$offset)
	{
		try{
			$limit = 10;
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			$select->from($table,array('smscamp_id','smscamp_title','smscamp_createddatetime','smscamp_msg'))
				   ->join(array('mt.sms_campaign_details'),'campd_smsid = smscamp_id',array('count(campd_id) as totalcount'))
				   ->where('smscamp_resid = ?',$data['RestId'])
				   ->where('campd_phone <> ?', '')
				   ->order('smscamp_id DESC')
				   ->group('smscamp_id');	
		   $Result = "";
			$Result = new Zend_Paginator(
				new Zend_Paginator_Adapter_DbTableSelect($select)
				);
			$Result->setItemCountPerPage($limit);
			$Result->setCurrentPageNumber($offset);
			return $Result;
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetSmsCampaignDetailsbyId($id,$resid)
	{
		try{
			$limit = 5;
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			$select->from($table,array('smscamp_id','smscamp_title','smscamp_createddatetime','smscamp_msg'))
					->join(array('mt.sms_campaign_details'),'campd_smsid = smscamp_id',array('count(campd_id) as totalcount'))
				   ->where('smscamp_resid = ?',$resid)
				   ->where('smscamp_id = ?',$id)
				   ->setIntegrityCheck(false)
				    ->group('smscamp_id');	
		   	$Result = $this->getDbTable()->fetchRow($select);
			return $Result;
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetSmsCampaignDetailsbyresIdforTablet($restaurantid)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			$select->from($table,array('smscamp_id','smscamp_title','smscamp_createddatetime','smscamp_msg'))
				   ->join(array('mt.sms_campaign_details'),'campd_smsid = smscamp_id',array('count(campd_id) as totalcount'))
				   ->where('smscamp_resid = ?',$restaurantid)
				   ->where('campd_phone <> ?', '')
				   ->order('smscamp_id DESC')
				   ->group('smscamp_id');	
		  	$resultset = $table->fetchAll($select);	
		  	$smstablesArr = array();
			foreach($resultset as $key=>$value){
				$subArray = array();
				foreach($value as  $key1=>$value1){
					$subArray[$key1]= $value1;
				}
				$smstablesArr[] = $subArray;
			}
			return $smstablesArr;
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}