<?php

class FirmManagement_Model_SmsRestaurantCampCountDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}


	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('FirmManagement_Model_DbTable_SmsRestaurantCampaignCount');
		}
		return $this->_dbTable;
	}

	public function getLeftMessagesCountByResid($resid)
	{
		try{
			$table = $this->getDbTable();
			$query= $table->select();
			$query->from($table,array('rescamp_totalsms','rescamp_usedsms'))
				  ->where('rescamp_resid = ?',$resid);
		    $resultSet = $table->fetchRow($query);
		    if($resultSet){
		   	 $remaincount = $resultSet->rescamp_totalsms - $resultSet->rescamp_usedsms;
		   	  return $remaincount;
		    }else{
		    	return 'noaccess';
		    }
		   
		    
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
}