<?php
class FirmManagement_Model_SmsRestaurantRequestCreditsDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
				
			$this->setDbTable('FirmManagement_Model_DbTable_SmsRestaurantRequestCredits');
		}
		return $this->_dbTable;
	}
	
	public function SendRequestForCredits($request,$data)
	{
		try{
			$date = date('M Y');	
	  		$data = array('reqcre_resid' 	  	  		=> $request->resid,
					  	  'reqcre_totalcredits'         => $request->totalcredits,
			  	 		  'reqcre_totalamount'          => $request->totalamt,
	  					  'reqcre_restqueries'      	=> $request->comments,
					      'reqcre_month'       			=> $date,
				  	      'reqcre_createddatetime'  	=> date("Y-m-d H:i:s"),	
	  					  'reqcre_createdby'			=> $data['User_Id']
	  					 );
	        $table  = $this->getDbTable();
	        $result = $table->insert($data);
	        if($result){
	       		return $result;	
	        }else{
	        	return false;
	        }
		}catch(Exception $ex){			
			throw new Exception($ex->getMessage()) ;
		}		  
	}
	
	public function GetAllRestaurantCreditDetails($offset,$data)
	{
		try{
			$limit = 10;
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			$select->from($table,array('reqcre_id','reqcre_resid','reqcre_totalcredits','reqcre_totalamount','reqcre_month','reqcre_createddatetime','reqcre_status','reqcre_restqueries','reqcre_comments'))
				   ->join(array('mt.restaurant'),'resid = reqcre_resid',array('resrestaurant_name'))
				   ->order('reqcre_id DESC');	
		   	$Result = "";
			$Result = new Zend_Paginator(
				new Zend_Paginator_Adapter_DbTableSelect($select)
				);
			$Result->setItemCountPerPage($limit);
			$Result->setCurrentPageNumber($offset);
			return $Result;
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function SaveSmsCreditStatus($request)
	{
		try{
			$timemapper = new FirmManagement_Model_FirmDataMapper();
			$timeZone = $timemapper->GetRestaurantTimeZone($request->resid);		
			date_default_timezone_set($timeZone);
			$table = $this->getDbTable();		
			$set = array('reqcre_comments'			=> 	$request->status,
	    				 'reqcre_updateddatetime'  	=>  date("Y-m-d H:i:s"),
						 'reqcre_updatedby'			=> 	1					 
				);
			$where = array('reqcre_id = ?'=> $request->reqid);
			$status = $table->update($set,$where);
			return $status;		
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}