<?php

/**
* Created By : Sai
* Date : 30-Jan-2017
* Purpose : Handles model class for taxation rule
* 
*/
class  FirmManagement_Model_TaxationRule 
{
	protected $_trId;
	protected $_trTittle;
	protected $_trPercent;
	protected $_trType;
	protected $_trRestaurantId;
	protected $_trStatus;
	protected $_trCreatedOn;
	protected $_trCreatedBy;
	protected $_trUpdatedOn;
	protected $_trUpdatedBy;
	protected $_trIgnoreToTotal;
	protected $_trAlreadyIncluded;
	protected $_trTags;
    protected $_ruleTags;

	public function setOptions(array $options)
    {
        $methods = get_class_methods($this);
        foreach ($options as $key => $value) {
            $method = 'set' . ucfirst($key);
            if (in_array($method, $methods)) {
                $this->$method($value);
            }
        }
        return $this;
    }

    /**
     * Gets the value of _trId.
     *
     * @return mixed
     */
    public function getTrId()
    {
        return $this->_trId;
    }

    /**
     * Sets the value of _trId.
     *
     * @param mixed $_trId the tr id
     *
     * @return self
     */
    public function setTrId($trId)
    {
        $this->_trId = $trId;

        return $this;
    }

    /**
     * Gets the value of _trTittle.
     *
     * @return mixed
     */
    public function getTrTittle()
    {
        return $this->_trTittle;
    }

    /**
     * Sets the value of _trTittle.
     *
     * @param mixed $_trTittle the tr tittle
     *
     * @return self
     */
    public function setTrTittle($trTittle)
    {
        $this->_trTittle = $trTittle;

        return $this;
    }

    /**
     * Gets the value of _trPercent.
     *
     * @return mixed
     */
    public function getTrPercent()
    {
        return $this->_trPercent;
    }

    /**
     * Sets the value of _trPercent.
     *
     * @param mixed $_trPercent the tr percent
     *
     * @return self
     */
    public function setTrPercent($trPercent)
    {
        $this->_trPercent = $trPercent;

        return $this;
    }

    /**
     * Gets the value of _trType.
     *
     * @return mixed
     */
    public function getTrType()
    {
        return $this->_trType;
    }

    /**
     * Sets the value of _trType.
     *
     * @param mixed $_trType the tr type
     *
     * @return self
     */
    public function setTrType($trType)
    {
        $this->_trType = $trType;

        return $this;
    }

    /**
     * Gets the value of _trRestaurantId.
     *
     * @return mixed
     */
    public function getTrRestaurantId()
    {
        return $this->_trRestaurantId;
    }

    /**
     * Sets the value of _trRestaurantId.
     *
     * @param mixed $_trRestaurantId the tr restaurant id
     *
     * @return self
     */
    public function setTrRestaurantId($trRestaurantId)
    {
        $this->_trRestaurantId = $trRestaurantId;

        return $this;
    }

    /**
     * Gets the value of _trStatus.
     *
     * @return mixed
     */
    public function getTrStatus()
    {
        return $this->_trStatus;
    }

    /**
     * Sets the value of _trStatus.
     *
     * @param mixed $_trStatus the tr status
     *
     * @return self
     */
    public function setTrStatus($trStatus)
    {
        $this->_trStatus = $trStatus;

        return $this;
    }

    /**
     * Gets the value of _trTags.
     *
     * @return mixed
     */
    public function getTrTags()
    {
        return $this->_trTags;
    }

    /**
     * Sets the value of _trTags.
     *
     * @param mixed $_trTags the tr tags
     *
     * @return self
     */
    public function setTrTags(array $trTags)
    {
        $this->_trTags = $trTags;

        return $this;
    }

    /**
     * Gets the value of _trCreatedOn.
     *
     * @return mixed
     */
    public function getTrCreatedOn()
    {
        return $this->_trCreatedOn;
    }

    /**
     * Sets the value of _trCreatedOn.
     *
     * @param mixed $_trCreatedOn the tr created on
     *
     * @return self
     */
    public function setTrCreatedOn($trCreatedOn)
    {
        $this->_trCreatedOn = $trCreatedOn;

        return $this;
    }

    /**
     * Gets the value of _trCreatedBy.
     *
     * @return mixed
     */
    public function getTrCreatedBy()
    {
        return $this->_trCreatedBy;
    }

    /**
     * Sets the value of _trCreatedBy.
     *
     * @param mixed $_trCreatedBy the tr created by
     *
     * @return self
     */
    public function setTrCreatedBy($trCreatedBy)
    {
        $this->_trCreatedBy = $trCreatedBy;

        return $this;
    }

    /**
     * Gets the value of _trUpdatedOn.
     *
     * @return mixed
     */
    public function getTrUpdatedOn()
    {
        return $this->_trUpdatedOn;
    }

    /**
     * Sets the value of _trUpdatedOn.
     *
     * @param mixed $_trUpdatedOn the tr updated on
     *
     * @return self
     */
    public function setTrUpdatedOn($trUpdatedOn)
    {
        $this->_trUpdatedOn = $trUpdatedOn;

        return $this;
    }

    /**
     * Gets the value of _trUpdatedBy.
     *
     * @return mixed
     */
    public function getTrUpdatedBy()
    {
        return $this->_trUpdatedBy;
    }

    /**
     * Sets the value of _trUpdatedBy.
     *
     * @param mixed $_trUpdatedBy the tr updated by
     *
     * @return self
     */
    public function setTrUpdatedBy($trUpdatedBy)
    {
        $this->_trUpdatedBy = $trUpdatedBy;

        return $this;
    }

    /**
     * Gets the value of _trIgnoreToTotal.
     *
     * @return mixed
     */
    public function getTrIgnoreToTotal()
    {
        return $this->_trIgnoreToTotal;
    }

    /**
     * Sets the value of _trIgnoreToTotal.
     *
     * @param mixed $_trIgnoreToTotal the tr ignore to total
     *
     * @return self
     */
    public function setTrIgnoreToTotal($trIgnoreToTotal)
    {
        $this->_trIgnoreToTotal = $trIgnoreToTotal;

        return $this;
    }

    /**
     * Gets the value of _trAlreadyIncluded.
     *
     * @return mixed
     */
    public function getTrAlreadyIncluded()
    {
        return $this->_trAlreadyIncluded;
    }

    /**
     * Sets the value of _trAlreadyIncluded.
     *
     * @param mixed $_trAlreadyIncluded the tr already included
     *
     * @return self
     */
    public function setTrAlreadyIncluded($trAlreadyIncluded)
    {
        $this->_trAlreadyIncluded = $trAlreadyIncluded;

        return $this;
    }

     /**
     * Gets the value of _trRuleTags.
     *
     * @return mixed
     */
    public function getRuleTags()
    {
        return $this->_ruleTags;
    }

    /**
     * Sets the value of _trRuleTags.
     *
     * @param mixed $_trRuleTags the tr already included
     *
     * @return self
     */
    public function setRuleTags($RuleTags)
    {
        $this->_ruleTags = $RuleTags;

        return $this;
    }
}