<?php
class ManageRenumeration_RenumerationController extends Zend_Controller_Action
{
	protected $_remunerationService = null;
	protected $_adminService = null;
	protected $_paymentService = null;
	
	public function init()
	{
		if(!$this->_remunerationService){
			$this->_remunerationService	= new Application_Service_Renumeration();
		}
		if(!$this->_adminService){
			$this->_adminService = new Application_Service_Admin();
		}
		if(!$this->_paymentService){
			$this->_paymentService = new Application_Service_Payment();
		}
	}
	
	public function restmembershipAction()
	{
		try
		{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->view->currentPageName = 'managepayments';
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout()->setLayout('global_settings_layout');
				$request = $this->getRequest();			
				
				if(isset($request->restaurantid)){
					$restId = $request->restaurantid;
				}else{
					$restId = $data['RestId'];
					$request->setParam('restaurantid',$restId);
				}
        
				$this->view->companyId = $data['companyid'];
				/* Get Membership plans */
				$memshipplan = $this->_remunerationService->GetRenumerationPlans($request);
				
				$this->view->membership = $memshipplan['Membership'];
				$this->view->currencycode = $memshipplan['CurrencyCode'];
				/* Get Currency List */
				$currencyList = $this->_remunerationService->GetCurrencyList();
				$this->view->curencyList = $currencyList;
				$this->view->restaurantid = $request->restaurantid;
				$this->view->customerId = 'DD-CUSTOMER-'.$request->restaurantid;
        
				/* Check Plan exist */
				$planExist = $this->_remunerationService->CheckPlanExists($request);
				if($planExist["status"] == "Y")
				{
					$this->view->exist_planid = $planExist["rmpmpayment_plan_id"];
				}else{
					$this->view->exist_planid = "";
				}
				
				/* -- Ureserv -> Authorize.net -- */
				if($data['Usertype'] == "RSO"){
					//$form = $this->_paymentService->getSearchPaymentProfileForm();
					//$this->view->form = $form;
					$result = $this->_paymentService->Manage_Rest_AuthNet_Subscription($request);
           //echo '<pre>'; print_r($result); exit;
					$this->view->customerProfileId = $result['CustProfId'];
					if($this->getRequest()->isPost()){
						/*
						$formData = $this->getRequest()->getPost();
						$searchResult = $this->_paymentService->searchPaymentProfiles($formData);
						$this->view->paymentProfiles = $searchResult;
						$this->view->formData = $formData;
						*/
					}else {
						$this->view->paymentProfiles   = $result['PaymentProfiles'];	
					}
					$this->view->authNetPaymentInfo = $result['CC_AC_Details'];
					$this->view->userbreach = false;
           
				}else if($data['Usertype'] == "RSU"){
					$this->view->userbreach = true;
				}else if($data['Usertype'] == "ADM" || $data['Usertype'] == "ADU"){
					//$form = $this->_paymentService->getSearchPaymentProfileForm();
					//$this->view->form = $form;
					$result = $this->_paymentService->Manage_Rest_AuthNet_Subscription($request);
					//echo '<pre>'; print_r($result); exit;
					$this->view->customerProfileId = $result['CustProfId'];
					if($this->getRequest()->isPost()){
						/*
						$formData = $this->getRequest()->getPost();
						$searchResult = $this->_paymentService->searchPaymentProfiles($formData);
						$this->view->paymentProfiles = $searchResult;
						$this->view->formData = $formData;
						*/
					}else {
						$this->view->paymentProfiles   = $result['PaymentProfiles'];	
					}
					$this->view->authNetPaymentInfo = $result['CC_AC_Details'];
					$this->view->userbreach = false;
				}
				/* ------------------------------ */
				
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'signin',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
        
        public function partnermembershipAction()
	{
		try
		{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout()->setLayout('adminlayout');
				$request = $this->getRequest();			
				
				if(isset($request->restaurantid)){
					$restId = $request->restaurantid;
				}else{
					$restId = $data['RestId'];
					$request->setParam('restaurantid',$restId);
				}
				
                                $result = $this->_remunerationService->partnerPlanGeneration($request,$data);
                                $this->view->restDet = $result;
					
				
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'signin',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}

	public function managerestmemshipAction()
	{
		try
		{
			
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$status = $this->_remunerationService->AddmemberShip($request);
				if($status){
					$this->_helper->redirector('paymentterms','Renumeration', 'ManageRenumeration',array('restaurantid' => $request->restaurantid,'planid'=>$request->planid,'currency'=>$request->currency));
				}	
				
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'signin',true));
			}			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function paymenttermsAction()
	{
		try
		{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
                                $this->view->currentPageName = 'managepayments';
				$this->_helper->layout()->setLayout('global_settings_layout');
				$request = $this->getRequest();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();						
				$result = $this->_remunerationService->GetPaymentTermsDetails($request,$data);
				$this->view->result = $result;
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'signin',true));
			}	
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
        
        public function partnerpaymenttermsAction()
	{
		try
		{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout()->setLayout('adminlayout');
				$request = $this->getRequest();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();						
				$result = $this->_remunerationService->GetPartnerPaymentTermsDetails($request,$data);
				$this->view->result = $result;
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'signin',true));
			}	
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
    public function handletwocheckpassbackAction()
	{
		try
		{
			$request = $this->getRequest();
            if(isset($request->companyid)){
                $this->_helper->layout()->setLayout('adminlayout');
                $result = $this->_remunerationService->PartnerHandle2CheckPassback($request);
                $this->view->result = $result;
            }else if(isset($request->restaurantid)){
                $this->_helper->layout()->setLayout('restaurantuserlayout');
                $result = $this->_remunerationService->Handle2CheckPassback($request);
                $this->view->result = $result;
            }
			
			
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
    
	public function twocheckpassbackAction()
	{
		try
		{
			$request = $this->getRequest();
			$this->_helper->layout()->setLayout('restaurantuserlayout');			
		    $result = $this->_remunerationService->Handle2CheckPassback($request);
		    $this->view->result = $result;
			
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function authorizenetpassbackAction(){
		try{
			$this->_helper->layout->disableLayout();
			$data = $_POST;
			$result = $this->_remunerationService->HandleAuthorizeNextPassback($data);
			$this->view->paymentData = $data;

		}
		catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
        
        public function partnertwocheckpassbackAction()
	{
		try
		{
			$request = $this->getRequest();
            $this->_helper->layout()->setLayout('adminlayout');
		    $result = $this->_remunerationService->PartnerHandle2CheckPassback($request);
            $this->view->result = $result;
			
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getmemshipplanbyidAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
		    $result = $this->_remunerationService->GetSubscriptionPlanById($request);
			echo json_encode($result);
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function managepaymentsAction()
	{
		try
		{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->view->currentPageName = 'managepayments';
				$request = $this->getRequest();
				$result = $this->_remunerationService->ManagePayments($request);
				$url = "";
				if($result['Status'] == 'Y'){
					$this->_helper->layout()->setLayout('global_settings_layout');					
					$this->view->result = $result;
					$this->view->paymentHistory  = $this->_remunerationService->GetTwoCheckNotificationByRestId($request);
					
				}else if($result['Status'] == 'N'){
					$this->_helper->layout->disableLayout();
					$this->_helper->viewRenderer->setNoRender();
				
					if($result['Plan'] == 'Y'){
						$this->_helper->redirector('restmembership','Renumeration','ManageRenumeration',array('restaurantid'=>$request->restaurantid,'planid'=>$result['PlanId']));
						
					}else if ($result['Plan'] == 'N'){
						$this->_helper->redirector('restmembership','Renumeration','ManageRenumeration',array('restaurantid'=>$request->restaurantid));
					}
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'signin',true));
			}
				
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
    
    public function partnerpaymenthistoryAction()
    {
        try{
            $this->_helper->layout->disableLayout();
            $this->_helper->viewRenderer->setNoRender();
            $request = $this->getRequest();
            $paymentHistory  = $this->_remunerationService->GetCompanyTwoCheckNotificationByComId($request);
            echo json_encode($paymentHistory);
        } catch (Exception $ex) {
            throw new Exception($ex->getMessage()) ;
        }
    }
    public function managepartnerpaymentsAction()
	{
		try
		{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
        $this->_helper->layout()->setLayout('adminlayout');
        $this->view->paymentHistory  = $this->_remunerationService->GetCompanyTwoCheckNotificationByComId($request,$data);
        $paymentresult = $this->_remunerationService->partnerPlanGeneration($request,$data);
        $this->view->paymentresult = $paymentresult;
				
				$page = $this->_request->getParam('page');
				if (empty($page)){
					$page = 1;
				}
				//$request = $this->getRequest();
				if($this->getRequest()->isPost()){
					$result = $this->_adminService->GetRestPaymentReport($this->getRequest()->getPost());
					if($request->resName)
					{
						$this->view->resName = $request->resName;
					}					
					if($request->selectYear){
						$this->view->selYear = $request->selectYear;
					}else
					{
						$this->view->selYear = date('m-d-Y', strtotime("first day of january " . date('Y')))."/".date('m-d-Y', strtotime("last day of december " . date('Y')));
					}
				}else
				{
					$formValues = array();
					
					if($request->selectYear)
					{
						$formValues['selectYear'] = $request->selectYear;
					}
					else
					{
						$this->view->selYear = date('m-d-Y', strtotime("first day of january " . date('Y')))."/".date('m-d-Y', strtotime("last day of december " . date('Y')));
					}
										
					if($request->resName)
					{
						$formValues['resName'] = $request->resName;						
					}
					
					$result = $this->_adminService->GetRestPaymentReport($formValues);
					//echo '<pre>'; print_r($result); exit;
				}
				 $page = $this->_getParam('page',1);
    			 $paginator = Zend_Paginator::factory($result);
    			 $paginator->setItemCountPerPage(20);
    			 $paginator->setCurrentPageNumber($page);
    			 $this->view->paginator = $paginator;
					
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'signin',true));
			}
				
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function renumerationinfoAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_remunerationService->GetRenumerationDetailsByRestaurantId($request);
						
			if($result){
				echo json_encode($result);
			}else{
				return json_encode('f');
			}
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function stopreccuringAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_remunerationService->StopLineItemReccuring($request);
			echo json_encode($result);
			
		}
		catch(Exception $ex)
		{
			throw $ex;
		}
	}
	
	public function insAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();			
			$request = $this->getRequest();			
			$result = $this->_remunerationService->SaveTwoCheckNotifications($request);			
		}
		catch(Exception $ex)
		{
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw $ex;
		}
	}

	public function twocheckhistoryAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();			
			$request = $this->getRequest();	
			$result = $this->_remunerationService->GetTwoCheckNotificationByOrderId($request);
			echo json_encode($result);		
		}catch(Exception $ex)
		{
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw $ex;
		}
	}
        
        public function partnerplangenerationAction()
        {
            try{
                $this->_helper->layout->disableLayout();
                $this->_helper->viewRenderer->setNoRender();			
                $request = $this->getRequest();	
                $storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();	
                $result = $this->_remunerationService->monthlyPartnerPlanGeneration($request,$data);
                echo json_encode($result);
            }catch (Exception $ex) {

            }
        }
	
}