<?php
class ManageRenumeration_Model_CompanySubscriptionRenewalMapper
{
    protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('ManageRenumeration_Model_DbTable_CompanySubscriptionRenewal');
		}
		return $this->_dbTable;
	}	
    
    public function SaveSubscriptionRenewal($renewalArr)
	{
		try
		{
			$table = $this->getDbTable();
            foreach($renewalArr as $renewal){
                $select = $table->select();
                $select->from($table,array('csrid','csrcompany_id','csrbilling_date','csrbilling_duedate','csramount','csrrestaurant_count','csramount_per_restaurant','csrbilling_fromdate','csrbilling_todate','csrstatus'))
                        ->where("date_part('month',csrbilling_date) = ?",date('n',strtotime($renewal->getcsrbilling_date())))
                        ->where('csrcompany_id = ?',$renewal->getcsrcompany_id());
                $result = $table->fetchRow($select);
                if(!$result){
                    $data = array('csrcompany_id'               => $renewal->getcsrcompany_id(),
                                  'csrbilling_date'             => $renewal->getcsrbilling_date(),
                                  'csrbilling_duedate'          => $renewal->getcsrbilling_duedate(),
                                  'csramount'                   => $renewal->getcsramount(),
                                  'csrrestaurant_count'         => $renewal->getcsrrestaurant_count(),
                                  'csramount_per_restaurant' 	=> $renewal->getcsramount_per_restaurant(),
                                  'csrbilling_fromdate'         => $renewal->getcsrbilling_fromdate(),
                                  'csrbilling_todate'           => $renewal->getcsrbilling_todate(),
                                  'csrstatus'                   => $renewal->getcsrstatus());

                    $id = $table->insert($data);
                    $data['csrid'] = $id;
                    $compMapper = new Administrator_Model_CompanyDataMapper();
                    $compDet = $compMapper->getCompanyDetailsById($renewal->getcsrcompany_id());
                    $renumService = new Application_Service_Renumeration();
                    $renumService->GenerateCompanuInvoicePdf($data,$compDet);
    //                $commMapper = new Application_Service_Communication();
    //                $commMapper->sendCompanyInvoice($data,$compDet);
                }
            }
//			return $id;
			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
    
    public function getSubscriptionRenewalById(ManageRenumeration_Model_CompanySubscriptionRenewal $subscr)
    {
        try{
            $table = $this->getDbTable();
            $select = $table->select();
            $select->from($table,array('csrid','csrcompany_id','csrbilling_date','csrbilling_duedate','csramount','csrrestaurant_count','csramount_per_restaurant','csrbilling_fromdate','csrbilling_todate','csrstatus'))
                    ->where('csrid = ?',$subscr->getcsrid());
            $result = $table->fetchRow($select);
            return $result;
        } catch (Exception $ex) {
            throw new Exception($ex->getMessage()) ;
        }
    }
    
    public function updateSubscriptionStatus(ManageRenumeration_Model_CompanySubscriptionRenewal $renewal)
    {
        try{
            $table = $this->getDbTable();
			
			$set = array('csrstatus' => $renewal->getcsrstatus());			
			$where = array('csrid = ?' => $renewal->getcsrid());
			$row_affected = $table->update($set,$where);	
					
			return $row_affected;
        } catch (Exception $ex) {
            throw new Exception($ex->getMessage()) ;
        }
    }
}