<?php
class ManageRenumeration_Model_CompanyTwoCheckoutNotificationMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('ManageRenumeration_Model_DbTable_CompanyTwoCheckoutNotification');
		}
		return $this->_dbTable;
	}
	
	public function SaveTwoCheckNotification(ManageRenumeration_Model_CompanyTwoCheckoutNotification $TwoCheckoutNotification)
	{
		try
		{
			$table = $this->getDbTable();

			$select = $table->select();
			$select->setIntegrityCheck(false);
			
			$select->from(array('his'=>'mt.twocheck_company_payment_history'),array('tcomph_id','tcomph_message_id','tcomph_message_type','tcomph_message_description','tcomph_timestamp','tcomph_sale_id','tcomph_vendor_id','tcomph_sale_date_placed','tcomph_invoice_id','tcomph_recurring','tcomph_payment_type','tcomph_invoice_status','tcomph_invoice_list_amount','tcomph_invoice_usd_amount','tcomph_invoice_cust_amount'))
				   ->where('his.tcomph_sale_id = ?',$TwoCheckoutNotification->gettcomph_sale_id());
				   
			$rowSet = $table->fetchRow($select);
            
            if($rowSet){
                return false;
            }else{
                $data = array(
                        'tcomph_message_id' 		=> $TwoCheckoutNotification->gettcomph_message_id(),
//                        'tcomph_message_type' 		=> $TwoCheckoutNotification->gettcomph_message_type(),
//                        'tcomph_message_description'  => $TwoCheckoutNotification->gettcomph_message_description(),
                        'tcomph_timestamp' 			=> $TwoCheckoutNotification->gettcomph_timestamp(),
                        'tcomph_sale_id'              => $TwoCheckoutNotification->gettcomph_sale_id(),
                        'tcomph_vendor_id' 			=> $TwoCheckoutNotification->gettcomph_vendor_id(),
                        'tcomph_sale_date_placed'     => $TwoCheckoutNotification->gettcomph_sale_date_placed(),
                        'tcomph_invoice_id'           => $TwoCheckoutNotification->gettcomph_invoice_id(),
                        'tcomph_recurring' 			=> $TwoCheckoutNotification->gettcomph_recurring(),
                        'tcomph_payment_type' 		=> $TwoCheckoutNotification->gettcomph_payment_type(),
                        'tcomph_invoice_status'       => $TwoCheckoutNotification->gettcomph_invoice_status(),
                        'tcomph_invoice_list_amount'  => $TwoCheckoutNotification->gettcomph_invoice_list_amount(),
                        'tcomph_invoice_usd_amount'   => $TwoCheckoutNotification->gettcomph_invoice_usd_amount(),
                        'tcomph_invoice_cust_amount'  => $TwoCheckoutNotification->gettcomph_invoice_cust_amount(),
//                        'tcomph_vendor_order_id'      => $TwoCheckoutNotification->gettcomph_vendor_order_id()
                        );
			
                $id = $table->insert($data);
                return $id;
            }
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function RetrieveTwoCheckNotificationByOrderId(ManageRenumeration_Model_TwoCheckoutSubscription $TwoCheckoutSubscription)
	{
		try
		{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			
			$select->from(array('his'=>'mt.twocheck_company_payment_history'),array('tcomph_id','tcomph_message_id','tcomph_message_type','tcomph_message_description','tcomph_timestamp','tcomph_sale_id','tcomph_vendor_id','tcomph_sale_date_placed','tcomph_invoice_id','tcomph_recurring','tcomph_payment_type','tcomph_invoice_status','tcomph_invoice_list_amount','tcomph_invoice_usd_amount','tcomph_invoice_cust_amount'))
				   ->join(array('sub'=>'mt.twocheckout_subscription'),'sub.tcoms_order_id = his.tcomph_sale_id',array('tcoms_order_id','tcoms_fk_company'))
				   ->join(array('res'=>'mt.company'),'res.com_id = sub.tcoms_fk_company',array('com_id','com_companyname'))
				   ->where('his.tcomph_sale_id = ?',$TwoCheckoutSubscription->gettcoms_order_id())
                    ->order('tcomph_timestamp DESC');
				   
			$rowSet = $table->fetchAll($select);

			$result = array();
			
			foreach($rowSet as $row)
			{
				$result[] = array('tcomph_id' 		  		 => $row->tcomph_id,
								  'tcomph_message_id'   		 => $row->tcomph_message_id,
								  'tcomph_message_type' 		 => $row->tcomph_message_type,
								  'tcomph_message_description' => $row->tcomph_message_description,
								  'tcomph_timestamp'			 => $row->tcomph_timestamp,
								  'tcomph_sale_id'			 => $row->tcomph_sale_id,
								  'tcomph_vendor_id'			 => $row->tcomph_vendor_id,
								  'tcomph_sale_date_placed'	 => $row->tcomph_sale_date_placed,
								  'tcomph_vendor_id'			 => $row->tcomph_vendor_id,
								  'tcomph_sale_date_placed'    => $row->tcomph_sale_date_placed,
								  'tcomph_invoice_id'			 => $row->tcomph_invoice_id,
								  'tcomph_vendor_id'			 => $row->tcomph_vendor_id,
								  'tcomph_recurring'		     => $row->tcomph_recurring,
								  'tcomph_payment_type'		 => $row->tcomph_payment_type,
								  'tcomph_invoice_status'		 => $row->tcomph_invoice_status,
								  'tcomph_invoice_list_amount' => $row->tcomph_invoice_list_amount,
								  'companyname'       => $row->com_companyname);
			}
			
			return $result;
			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function RetrieveTwoCheckNotificationByComId(ManageRenumeration_Model_CompanyTwoCheckoutSubscription $TwoCheckoutSubscription)
	{
		try
		{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			
			$select->from(array('his'=>'mt.twocheck_company_payment_history'),array('tcomph_id','tcomph_message_id','tcomph_message_type','tcomph_message_description','tcomph_timestamp','tcomph_sale_id','tcomph_vendor_id','tcomph_sale_date_placed','tcomph_invoice_id','tcomph_recurring','tcomph_payment_type','tcomph_invoice_status','tcomph_invoice_list_amount','tcomph_invoice_usd_amount','tcomph_invoice_cust_amount'))
				   ->join(array('sub'=>'mt.twocheckout_company_subscription'),'sub.tcoms_order_id = his.tcomph_sale_id',array('tcoms_order_id','tcoms_fk_company'))
				   ->join(array('res'=>'mt.company'),'res.com_id = sub.tcoms_fk_company',array('com_id','com_companyname'))
				   ->where('sub.tcoms_fk_company = ?',$TwoCheckoutSubscription->gettcoms_fk_company())
                    ->order('tcomph_timestamp DESC');
				   
			$rowSet = $table->fetchAll($select);

			$result = array();
			
			foreach($rowSet as $row)
			{
				$result[] = array('tcomph_id' 		  		 => $row->tcomph_id,
								  'tcomph_message_id'   		 => $row->tcomph_message_id,
								  'tcomph_message_type' 		 => $row->tcomph_message_type,
								  'tcomph_message_description' => $row->tcomph_message_description,
								  'tcomph_timestamp'			 => $row->tcomph_timestamp,
								  'tcomph_sale_id'			 => $row->tcomph_sale_id,
								  'tcomph_vendor_id'			 => $row->tcomph_vendor_id,
								  'tcomph_sale_date_placed'    => $row->tcomph_sale_date_placed,
								  'tcomph_invoice_id'			 => $row->tcomph_invoice_id,
								  'tcomph_vendor_id'			 => $row->tcomph_vendor_id,
								  'tcomph_recurring'		     => $row->tcomph_recurring,
								  'tcomph_payment_type'		 => $row->tcomph_payment_type,
								  'tcomph_invoice_status'		 => $row->tcomph_invoice_status,
								  'tcomph_invoice_list_amount' => $row->tcomph_invoice_list_amount,
								  'companyname'       => $row->com_companyname);
			}
			
			return $result;
			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
    
    public function RetrieveTwoCheckNotificationByAdmin(ManageRenumeration_Model_CompanyTwoCheckoutSubscription $TwoCheckoutSubscription)
	{
		try
		{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			
			$select->from(array('his'=>'mt.twocheck_company_payment_history'),array('tcomph_id','tcomph_message_id','tcomph_message_type','tcomph_message_description','tcomph_timestamp','tcomph_sale_id','tcomph_vendor_id','tcomph_sale_date_placed','tcomph_invoice_id','tcomph_recurring','tcomph_payment_type','tcomph_invoice_status','tcomph_invoice_list_amount','tcomph_invoice_usd_amount','tcomph_invoice_cust_amount'))
				   ->join(array('sub'=>'mt.twocheckout_company_subscription'),'sub.tcoms_order_id = his.tcomph_sale_id',array('tcoms_order_id','tcoms_fk_company'))
				   ->join(array('res'=>'mt.company'),'res.com_id = sub.tcoms_fk_company',array('com_id','com_companyname'))
                    ->joinLeft(array('csr'=>'mt.company_subscription_renewal'),'csr.csrid = his.tcomph_message_id',array('csrbilling_date','csrbilling_duedate','csramount','csrrestaurant_count','csramount_per_restaurant','csrbilling_fromdate','csrbilling_todate'))
                    ->order('tcomph_timestamp DESC');
				   
			$rowSet = $table->fetchAll($select);

			$result = array();
			
			foreach($rowSet as $row)
			{
				$result[] = array('tcomph_id'                       => $row->tcomph_id,
								  'tcomph_message_id'               => $row->tcomph_message_id,
								  'tcomph_message_type'             => $row->tcomph_message_type,
								  'tcomph_message_description'      => $row->tcomph_message_description,
								  'tcomph_timestamp'                => $row->tcomph_timestamp,
								  'tcomph_sale_id'                  => $row->tcomph_sale_id,
								  'tcomph_vendor_id'                => $row->tcomph_vendor_id,
								  'tcomph_sale_date_placed'         => $row->tcomph_sale_date_placed,
								  'tcomph_invoice_id'               => $row->tcomph_invoice_id,
								  'tcomph_recurring'                => $row->tcomph_recurring,
								  'tcomph_payment_type'             => $row->tcomph_payment_type,
								  'tcomph_invoice_status'           => $row->tcomph_invoice_status,
								  'tcomph_invoice_list_amount'      => $row->tcomph_invoice_list_amount,
                                  'billingdate'                     =>$row->csrbilling_date,
                                  'duedate'                         =>$row->csrbilling_duedate,
                                  'amount'                          =>$row->csramount,
                                  'fromdate'                        =>$row->csrbilling_fromdate,
                                  'todate'                          =>$row->csrbilling_todate,
								  'companyname'                     => $row->com_companyname);
			}
			return $result;
			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}