<?php
class ManageRenumeration_Model_RenumerationPlanMapMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('ManageRenumeration_Model_DbTable_RenumerationPlanMap');
		}
		return $this->_dbTable;
	}
	
	public function AddMembeshipPlan(ManageRenumeration_Model_RenumerationPlanMap $membershipPlanMap)
	{
		try
		{
			$table = $this->getDbTable();
			
			$data = array('rmpmpayment_plan_id'      => $membershipPlanMap->getrmpmpayment_plan_id(),
						  'rmpmrestaurant_id'        => $membershipPlanMap->getrmpmrestaurant_id(),
						  'rmpmplan_activation_date' => $membershipPlanMap->getrmpmplan_activation_date(),
						  'rmpmstatus'				 => $membershipPlanMap->getrmpmstatus(),
						  'rmpm_currency'            => $membershipPlanMap->getrmpm_currency(),						  
						  'rmpmplan_activation_time' => $membershipPlanMap->getrmpmplan_activation_time());
			
			if($membershipPlanMap->getrmpmid()){
				$where = array("rmpmid = ?"=>$membershipPlanMap->getrmpmid());
				$id = $table->update($data,$where);
			}else{
				$id = $table->insert($data);	
			}
			return $id;
			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function CheckMembership(ManageRenumeration_Model_RenumerationPlanMap $membershipPlanMap)
	{
		try
		{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array("rmpmid","rmpmpayment_plan_id"))
			       ->where('rmpmrestaurant_id = ?',$membershipPlanMap->getrmpmrestaurant_id());
			       
			$rowset = $table->fetchAll($select);
			$result = array();
			if(count($rowset)){
				$result['status'] = "Y";
				foreach($rowset as $row){					
					$result['rmpmid'] = $row->rmpmid;
					$result['rmpmpayment_plan_id'] = $row->rmpmpayment_plan_id;	
				}
			}else{
				$result['status'] = "N";
			}
						
			return $result;
			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function UpdatePlanActivationDate(ManageRenumeration_Model_RenumerationPlanMap $membershipPlanMap)
	{
		try
		{
			$table = $this->getDbTable();
			
			$set = array('rmpmplan_activation_date' => $membershipPlanMap->getrmpmplan_activation_date());
			
			$where = array('rmpmpayment_plan_id = ?' => $membershipPlanMap->getrmpmpayment_plan_id(),
					  	   'rmpmrestaurant_id   = ?'   => $membershipPlanMap->getrmpmrestaurant_id());
			
			$rows_affected = $table->update($set,$where);
			
			return $rows_affected;						  	 
			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
}