<?php
class ManageRenumeration_Model_RenumerationPlansMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('ManageRenumeration_Model_DbTable_RenumerationPlans');
		}
		return $this->_dbTable;
	}
	
	public function RetrieveSubscriptionPlans(ManageRenumeration_Model_RenumerationPlans $SubscriptionPlans)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();			
			$select->from($table,array('spid','spplan_title','spplan_description','spamount','spplan_duration','spplan_status','sp_2coid','sp_product_id'));
				   
				   
			/*if($SubscriptionPlans->getspid())
			{
				$select->where('spid =?',$SubscriptionPlans->getspid());
			}else
			{
				$select->where('spplan_status = ?',$SubscriptionPlans->getspplan_status());
				$select->order(array('spid'));
			}*/
			
				$select->where('spplan_status = ?',$SubscriptionPlans->getspplan_status());
				$select->order(array('spid'));
			
				$select->where('sp_country_code = ?',$SubscriptionPlans->getsp_country_code());
				   
			$rowset = $table->fetchAll($select);
			$result = array();
			foreach($rowset as $row)
			{
				$result[] = array('spid'				 => $row->spid,
								  'spplan_title' 		 => $row->spplan_title,
								  'spplan_description'   => $row->spplan_description,
								  'spamount'			 => $row->spamount,
								  'spplan_duration'	     => $row->spplan_duration,
								  'sp_2coid'			 => $row->sp_2coid,
								  'sp_product_id'		 => $row->sp_product_id);
			}
			
			return $result;
				   
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
		
	}
	
	public function RetrieveSubscriptionPlansById(ManageRenumeration_Model_RenumerationPlans $SubscriptionPlans)
	{
		try{
			
			$table  = $this->getDbTable();
			$select = $table->select();			
			$select->from($table,array('spid','spplan_title','spplan_description','spamount','spplan_duration','spplan_status','sp_2coid','sp_product_id'));
			$select->where('spid =?',$SubscriptionPlans->getspid());
				   
			$rowset = $table->fetchAll($select);
			$result = array();
			foreach($rowset as $row)
			{
				if($row->spid > 4)
				{
					$spplan_description = str_replace("$","INR",$row->spplan_description);
				}else
				{
					$spplan_description = $row->spplan_description;
				}
				$result[] = array('spid'				 => $row->spid,
								  'spplan_title' 		 => $row->spplan_title,	
								  'spplan_description'   => $row->spplan_description,							  
								  'spamount'			 => $row->spamount,
								  'spplan_duration'	     => $row->spplan_duration,
								  'sp_2coid'			 => $row->sp_2coid,
								  'sp_product_id'		 => $row->sp_product_id);
			}
			
			return $result;
				   
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
		
	}
}