<?php
class ManageRenumeration_Model_TwoCheckoutNotificationMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('ManageRenumeration_Model_DbTable_TwoCheckoutNotification');
		}
		return $this->_dbTable;
	}
	
	public function SaveTwoCheckNotification(ManageRenumeration_Model_TwoCheckoutNotification $TwoCheckoutNotification)
	{
		try
		{
			$table = $this->getDbTable();

			$data = array('tcph_message_id' 		 => $TwoCheckoutNotification->gettcph_message_id(),
						  'tcph_message_type' 		 => $TwoCheckoutNotification->gettcph_message_type(),
						  'tcph_message_description' => $TwoCheckoutNotification->gettcph_message_description(),
						  'tcph_timestamp' 			 => $TwoCheckoutNotification->gettcph_timestamp(),
						  'tcph_sale_id' 			 => $TwoCheckoutNotification->gettcph_sale_id(),
						  'tcph_vendor_id' 			 => $TwoCheckoutNotification->gettcph_vendor_id(),
						  'tcph_sale_date_placed'    => $TwoCheckoutNotification->gettcph_sale_date_placed(),
						  'tcph_invoice_id' 		 => $TwoCheckoutNotification->gettcph_invoice_id(),
						  'tcph_recurring' 			 => $TwoCheckoutNotification->gettcph_recurring(),
						  'tcph_payment_type' 		 => $TwoCheckoutNotification->gettcph_payment_type(),
						  'tcph_invoice_status' 	 => $TwoCheckoutNotification->gettcph_invoice_status(),
						  'tcph_invoice_list_amount' => $TwoCheckoutNotification->gettcph_invoice_list_amount(),
						  'tcph_invoice_usd_amount'  => $TwoCheckoutNotification->gettcph_invoice_usd_amount(),
						  'tcph_invoice_cust_amount' => $TwoCheckoutNotification->gettcph_invoice_cust_amount(),
						  'tcph_vendor_order_id'	 => $TwoCheckoutNotification->gettcph_vendor_order_id());
			
			$id = $table->insert($data);			
			return $id;
			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function RetrieveTwoCheckNotificationByOrderId(ManageRenumeration_Model_TwoCheckoutSubscription $TwoCheckoutSubscription)
	{
		try
		{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			
			$select->from(array('his'=>'mt.twocheck_payment_history'),array('tcph_id','tcph_message_id','tcph_message_type','tcph_message_description','tcph_timestamp','tcph_sale_id','tcph_vendor_id','tcph_sale_date_placed','tcph_invoice_id','tcph_recurring','tcph_payment_type','tcph_invoice_status','tcph_invoice_list_amount','tcph_invoice_usd_amount','tcph_invoice_cust_amount'))
				   ->join(array('sub'=>'mt.twocheckout_subscription'),'sub.tcos_order_id = his.tcph_sale_id',array('tcos_order_id','tcos_fk_restaurant'))
				   ->join(array('res'=>'mt.restaurant'),'res.resid = sub.tcos_fk_restaurant',array('resid','resrestaurant_name'))
				   ->where('his.tcph_sale_id = ?',$TwoCheckoutSubscription->gettcos_order_id());
				   
			$rowSet = $table->fetchAll($select);

			$result = array();
			
			foreach($rowSet as $row)
			{
				$result[] = array('tcph_id' 		  		 => $row->tcph_id,
								  'tcph_message_id'   		 => $row->tcph_message_id,
								  'tcph_message_type' 		 => $row->tcph_message_type,
								  'tcph_message_description' => $row->tcph_message_description,
								  'tcph_timestamp'			 => $row->tcph_timestamp,
								  'tcph_sale_id'			 => $row->tcph_sale_id,
								  'tcph_vendor_id'			 => $row->tcph_vendor_id,
								  'tcph_sale_date_placed'	 => $row->tcph_sale_date_placed,
								  'tcph_vendor_id'			 => $row->tcph_vendor_id,
								  'tcph_sale_date_placed'    => $row->tcph_sale_date_placed,
								  'tcph_invoice_id'			 => $row->tcph_invoice_id,
								  'tcph_vendor_id'			 => $row->tcph_vendor_id,
								  'tcph_recurring'		     => $row->tcph_recurring,
								  'tcph_payment_type'		 => $row->tcph_payment_type,
								  'tcph_invoice_status'		 => $row->tcph_invoice_status,
								  'tcph_invoice_list_amount' => $row->tcph_invoice_list_amount,
								  'resrestaurant_name'       => $row->resrestaurant_name);
			}
			
			return $result;
			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function RetrieveTwoCheckNotificationByRestId(ManageRenumeration_Model_TwoCheckoutSubscription $TwoCheckoutSubscription)
	{
		try
		{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			
			$select->from(array('his'=>'mt.twocheck_payment_history'),array('tcph_id','tcph_message_id','tcph_message_type','tcph_message_description','tcph_timestamp','tcph_sale_id','tcph_vendor_id','tcph_sale_date_placed','tcph_invoice_id','tcph_recurring','tcph_payment_type','tcph_invoice_status','tcph_invoice_list_amount','tcph_invoice_usd_amount','tcph_invoice_cust_amount'))
				   ->join(array('sub'=>'mt.twocheckout_subscription'),'sub.tcos_order_id = his.tcph_sale_id',array('tcos_order_id','tcos_fk_restaurant'))
				   ->join(array('res'=>'mt.restaurant'),'res.resid = sub.tcos_fk_restaurant',array('resid','resrestaurant_name'))
				   ->where('sub.tcos_fk_restaurant = ?',$TwoCheckoutSubscription->gettcos_fk_restaurant());
				   
			$rowSet = $table->fetchAll($select);

			$result = array();
			
			foreach($rowSet as $row)
			{
				$result[] = array('tcph_id' 		  		 => $row->tcph_id,
								  'tcph_message_id'   		 => $row->tcph_message_id,
								  'tcph_message_type' 		 => $row->tcph_message_type,
								  'tcph_message_description' => $row->tcph_message_description,
								  'tcph_timestamp'			 => $row->tcph_timestamp,
								  'tcph_sale_id'			 => $row->tcph_sale_id,
								  'tcph_vendor_id'			 => $row->tcph_vendor_id,
								  'tcph_sale_date_placed'	 => $row->tcph_sale_date_placed,
								  'tcph_vendor_id'			 => $row->tcph_vendor_id,
								  'tcph_sale_date_placed'    => $row->tcph_sale_date_placed,
								  'tcph_invoice_id'			 => $row->tcph_invoice_id,
								  'tcph_vendor_id'			 => $row->tcph_vendor_id,
								  'tcph_recurring'		     => $row->tcph_recurring,
								  'tcph_payment_type'		 => $row->tcph_payment_type,
								  'tcph_invoice_status'		 => $row->tcph_invoice_status,
								  'tcph_invoice_list_amount' => $row->tcph_invoice_list_amount,
								  'resrestaurant_name'       => $row->resrestaurant_name);
			}
			
			return $result;
			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}