<?php

class ManageRestaurant_Form_AddRestauranat extends Zend_Form
{

	public function init()
    {
    	 $this->setAttrib('enctype', 'multipart/form-data');

    	 
    	/* Populating Restaurant Type Base Data */
    	
    	$resTypeMapper  = new Application_Model_RestaurantTypeDataMapper();
    	$resTypes = $resTypeMapper->getRestauranttypeBD();
    	$resTypeList = array();
    	$resTypeList[] = array('key'=>'','value'=>'Select Restaurant Type');    	   
    	foreach($resTypes as $resType){
    		$resTypeList[] = array('key'=>$resType->getId(),'value'=>$resType->getDescription());
    	}   
    	
    	/* Populating Country Base Data */
    	
    	$countryMapper  = new Application_Model_CountryDataMapper();
        $countries = $countryMapper->fetchAll();
        $countryList = array();
        $countryCodeNumberList = array(); 
        $countryList[] = array('key'=>'','value'=>'Select Country'); 
        foreach($countries as $country){
    		$countryList[] = array('key'=>$country->getcountry_id(),'value'=>$country->getcountry_description());
    		if ($country->getcountry_id() != 2) {
				$countryCodeNumberList[] = array('key'=>$country->getcountry_id(),'value'=>$country->getCountry_codenumber());
    		} 
        }  
    	
    	$timezoneMapper = new Application_Model_TimeZoneDataMapper();
    	$timezones = $timezoneMapper->fetchAll();
    	$timezoneList = array();
    	$timezoneList[] = array('key'=>'','value'=>'Select TimeZone');
    	foreach($timezones as $timezone){
    		$timezoneList[] = array('key'=>$timezone->getCode(),'value'=>$timezone->getCode().$timezone->getDescription());
    	}
    	
    	$paymentmodeMapper = new Application_Model_RestaurantPaymentModeDataMapper();
    	$paymentmodes = $paymentmodeMapper->fetchAll();
    	$paymentmodesList = array();
    	//$paymentmodesList[] = array('key'=>'','value'=>'Select Payment Mode');
    	foreach($paymentmodes as $paymentmode){
    		$paymentmodesList[] = array('key'=>$paymentmode->getId(),'value'=>$paymentmode->getDescription());
    	}
    	
    	$priceMapper = new Application_Model_PriceDataMapper();
    	$prices = $priceMapper->fetchAll();
    	$priceList = array();
    	$priceList[] = array('key'=>'','value'=>'Select Price');
    	foreach($prices as $price){
    		$priceList[] = array('key'=>$price->getCode(),'value'=>$price->getCode());
    	}
    	//$diningStyleList[] = array('key'=>'','value'=>'Select Dining Style');
    	$diningStyleList = array(
    			array('key'=>'','value'=>'Select Dining Style'),
    			array('key'=>'Casual Elegant','value'=>'Casual Elegant'),
    			array('key'=>'Casual Dining','value'=>'Casual Dining'),
    			array('key'=>'Fine Dining','value'=>'Fine Dining'),
    			array('key'=>'Coffeehouse','value'=>'Coffeehouse'),
    			array('key'=>'Pizzeria','value'=>'Pizzeria'),
    			array('key'=>'Steakhouses','value'=>'Steakhouses'),
    			array('key'=>'Seafood Restaurants','value'=>'Seafood Restaurants')    	
    	);
    	
    	$paxList = array(
    			array('key'=>'0','value'=>'Select PartySize'),
    			array('key'=>'1','value'=>'1'),
    			array('key'=>'2','value'=>'2'),
    			array('key'=>'3','value'=>'3'),
    			array('key'=>'4','value'=>'4'),
    			array('key'=>'5','value'=>'5'),
    			array('key'=>'6','value'=>'6'),
    			array('key'=>'7','value'=>'7'),
    			array('key'=>'8','value'=>'8'),
    			array('key'=>'9','value'=>'9'),
    			array('key'=>'10','value'=>'10'),
    			array('key'=>'11','value'=>'11'),
    			array('key'=>'12','value'=>'12'),
    			array('key'=>'13','value'=>'13'),
    			array('key'=>'14','value'=>'14'),
    			array('key'=>'15','value'=>'15'),
    			array('key'=>'16','value'=>'16'),
    			array('key'=>'17','value'=>'17'),
    			array('key'=>'18','value'=>'18'),
    			array('key'=>'19','value'=>'19'),
    			array('key'=>'20','value'=>'20')    	
    	);
    	
    	/* Populating City Base Data */
    	
    	/*$cityMapper = new Application_Model_CityDataMapper();
    	$cityResults   = $cityMapper->fetchAll();
    	$cityList = array();
    	foreach($cityResults as $result){
    		$cityList[] = array('key'=>$result->getId(),'value'=>$result->getDescription());
    	}*/
    	
    	/* Populating Neighborhood Base Data */
    	
    	/*$neighborhodMapper  = new Application_Model_NeighborhoodDataMapper();
    	$neighborhodResults = $neighborhodMapper->fetchAll();
    	$neighborhodList    = array();
    	foreach($neighborhodResults as $result){
    		$neighborhodList[] = array('key'=>$result->getId(),'value'=>$result->getDescription());
    	}*/
    	
    	$restId = $this->createElement('hidden','restId');
    	$restId->removeDecorator('Label')
        	   ->removeDecorator('DtDdWrapper')
        	   ->removeDecorator('HtmlTag');
        	   
    	$restLatitude = $this->createElement('hidden','restLatitude');
    	$restLatitude->removeDecorator('Label')
        	   		 ->removeDecorator('DtDdWrapper');
        	   		 
    	$restLongitude = $this->createElement('hidden','restLongitude');
    	$restLongitude->removeDecorator('Label')
        	   		  ->removeDecorator('DtDdWrapper');
        	   		  
        $restaurantName = $this->createElement('text', 'restName');
        $restaurantName->removeDecorator('Label')
        			   ->removeDecorator('HtmlTag')
        			   ->setAttrib('maxlength', '255')
        			   ->setAttrib('class','inp1')
        			   ->addFilters(array('StringTrim'))
        			   ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter your Restaurant Name.')),
        			   				array('StringLength', false,array(0,255))))
        			   ->setValue('')
        			   ->setRequired(true);
        			   
      	$restCapacity = $this->createElement('text', 'restCapacity');
      	$restCapacity->removeDecorator('Label')
      				 ->removeDecorator('HtmlTag')
      				 ->setAttrib('maxlength', '5')
      				 ->setAttrib('class','inp1')
      				 ->addFilters(array('StringTrim'))
      				 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter your Restaurant Capacity.')),
      				 				array('StringLength', false,array(0,5))))
      				 ->addValidator('Digits',new Zend_Validate_Digits(),array('messages' => 'Please enter Numbers only'))
      				 ->setValue('')
      				 ->setRequired(true);
        			   
		$restDiningStyle = $this->createElement('select','restDiningStyle');
		$restDiningStyle->removeDecorator('Label')
        			    ->removeDecorator('HtmlTag')
        			    ->setAttrib('maxlength', '100')
        			    ->setAttrib('class','sel1')
        			    ->addMultiOptions($diningStyleList)        			    
        			    ->setValue('')
        			    ->setRequired(false);

       	
        			   
		$resEmailAddress =  $this->createElement('text', 'emailAddress');
        $resEmailAddress ->removeDecorator('Label')
        				 ->removeDecorator('HtmlTag')        			     
        			     ->setAttrib('maxlength', '255')
        				 ->setAttrib('class','inp1')
                		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter your Email Address.')),
                		 				array('StringLength', false,array(5,255))))
                		 ->addValidator('EmailAddress',false,array('messages'=>array(Zend_Validate_EmailAddress::INVALID =>'Please enter a valid Host Name')))
						 ->addErrorMessage('Pleaes Enter Valid Email Address')
                		 ->addFilters(array('StringTrim'))
               			 ->setRequired(true);  
		
	   /* $resYearFound =  $this->createElement('text', 'resYearFound');
        $resYearFound->removeDecorator('Label')
        			 ->removeDecorator('HtmlTag')        			 
        			 ->setAttrib('class','inp1')
        			 ->setAttrib('maxlength', '4')
                	 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter Year Found.')),
                	 				array('StringLength', false,array(4,4,'messages' => array(
              					Zend_Validate_StringLength::TOO_SHORT => "Year must be 4 digits"
              				)))))
                	 ->addValidator('Digits',new Zend_Validate_Digits(),array('messages' => 'Please enter Numbers only'))
					 ->addValidator(new Zend_Validate_Date(array("format" => 'yyyy')))
                     ->setValue('')
                	 ->setRequired(true);*/

        $maxpax = $this->createElement('select', 'maxpax');
        $maxpax->removeDecorator('Label') 
        		 ->removeDecorator('HtmlTag')
        		 ->setAttrib('class','sel1')      		 
                 ->addMultiOptions($paxList)
                 ->setRequired(false);
                	 
         $restaurantType = $this->createElement('select','restype');
         $restaurantType->removeDecorator('Label') 
         				->removeDecorator('HtmlTag') 
         				->setAttrib('class','sel1') 
         				//->setAttrib('multiple', 'multiple')
         				->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select Restaurant Type.'))))
               			->addMultiOptions($resTypeList)
               			->setRegisterInArrayValidator(false)
               			->setRequired(true);
          //$restaurantType->size=5;
               			
          $resAddress = $this->createElement('text','resAddress');
          $resAddress->removeDecorator('Label')
        			 ->removeDecorator('HtmlTag')
        			 ->setAttrib('maxlength', '510')
        			 ->setAttrib('class','inp1')
        			 ->addFilters(array('StringTrim'))
        			 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter your Restaurant Address.')),
			         					array('StringLength', false,array(1,510,'messages' => array(
              					Zend_Validate_StringLength::TOO_LONG => 'address is too long(>510).'
              				)))))        			               		 
               		 ->setValue('')	
        			 ->setRequired(true);
            $resCountry = $this->createElement('select','resCountry');
			$resCountry->removeDecorator('Label') 
         		  ->removeDecorator('HtmlTag')
         		  ->setAttrib('class','sel1 drpDown')
         		  
         		  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select Country.'))))       	   
               	  ->addMultiOptions($countryList)
                  ->setRequired(true); 
				  
		 $resState = $this->createElement('select','resState');
         $resState->removeDecorator('Label') 
         		  ->removeDecorator('HtmlTag')
         		  ->setAttrib('class','sel1 drpDown')
         		  
         		  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select State.'))))       	   
               	 
				  ->setRegisterInArrayValidator(false)
                  ->setRequired(true);
                  
         $resTimezone = $this->createElement('select','restimezone');
         $resTimezone->removeDecorator('Label')
         			 ->removeDecorator('HtmlTag')
         			 ->setAttrib('class','sel1 drpDown')
         			 
         			 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select Timezone.'))))
         			 ->addMultiOptions($timezoneList)
         			 ->setRequired(true);
         
         $resPaymentMode = $this->createElement('select','resPayment');
         $resPaymentMode->removeDecorator('Label')
         			 ->removeDecorator('HtmlTag')
         			 ->setAttrib('class','sel1')
         			 ->setAttrib('multiple', 'multiple')
         			 
         			 ->addMultiOptions($paymentmodesList)
         			 ->setRegisterInArrayValidator(false)
         			 ->setRequired(true)
         			 ->size=5;
         			 
         $resprice = $this->createElement('select','resprice');
         $resprice->removeDecorator('Label')
         		  ->removeDecorator('HtmlTag')
         		  ->setAttrib('class','sel1 drpDown')
         		  
         		  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Select Price Range.'))))
         		  ->addMultiOptions($priceList)
         		  ->setRequired(true);
         
         			 
         $resCity = $this->createElement('select', 'resCity');
         $resCity->removeDecorator('Label')
         		 ->removeDecorator('HtmlTag')
         		 ->setAttrib('class','sel1 drpDown')
         		 ->setRegisterInArrayValidator(false)
         		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select City.'))))       	     
                 ->setRequired(true);
                 
         $resRegion = $this->createElement('select', 'resRegion');
         $resRegion->removeDecorator('Label')
         		 ->removeDecorator('HtmlTag')
         		 ->setAttrib('class','sel1 drpDown')
         		 ->setRegisterInArrayValidator(false)
         		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select Region.'))))       	     
                 ->setRequired(true);
                 
        $cantfind = $this->createElement('hidden','cantfind');
		$cantfind->removeDecorator('HtmlTag')
    		  	 ->removeDecorator('Label');

		$cantfindcity = $this->createElement('text', 'cantfindcity');
        $cantfindcity->removeDecorator('Label')
        		 ->removeDecorator('HtmlTag')
        		 ->setAttrib('class','inp1')
        		 ->setAttrib('maxlength', '30')
        		 ->addValidators(array(array('StringLength', false,array(0,30))))
        		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter City.'))))
        		 ->setValue('')
                 ->setRequired(false); 
        
        $cantfindstate = $this->createElement('text', 'cantfindstate');
        $cantfindstate->removeDecorator('Label')
        		 ->removeDecorator('HtmlTag')
        		 ->setAttrib('class','inp1')
        		 ->setAttrib('maxlength', '30')
        		 ->addValidators(array(array('StringLength', false,array(0,30))))
        		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter State.'))))  
        		 ->setValue('')
                 ->setRequired(false); 
                 
        $cantfindregion = $this->createElement('text', 'cantfindregion');
        $cantfindregion->removeDecorator('Label')
        		 ->removeDecorator('HtmlTag')
        		 ->setAttrib('class','inp1')
        		 ->setAttrib('maxlength', '30')
        		 ->addValidators(array(array('StringLength', false,array(0,30))))
        		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter Region.'))))  
        		 ->setValue('')
                 ->setRequired(false); 
                 
       /* $cantfindneigh = $this->createElement('text', 'cantfindneigh');
        $cantfindneigh->removeDecorator('Label')
        		 ->removeDecorator('HtmlTag')
        		 ->setAttrib('class','inp1')
        		 ->setAttrib('maxlength', '30')
        		 ->addValidators(array(array('StringLength', false,array(0,30))))
        		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter Neighbour.'))))  
        		 ->setValue('')
                 ->setRequired(false); */
                          
       /*  $resNeighbour = $this->createElement('select', 'resNeighbour');
         $resNeighbour->removeDecorator('Label')
         			  ->setAttrib('class','sel1 drpDown')
         		 	  ->removeDecorator('HtmlTag')
         		 	  ->setRegisterInArrayValidator(false)
         		 	  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select Restaurant Neighbourhood.'))))        	          
                 	  ->setRequired(true);*/
                 	  
         $resPostalCode = $this->createElement('text', 'postalCode');
         $resPostalCode->removeDecorator('Label')  
         			   ->removeDecorator('HtmlTag')      		       
        		       ->setAttrib('class','inp1')
        		       ->addFilters(array('StringTrim'))
        		       ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Postal Code.'))))    
                       ->addValidator('StringLength', false,array(1,10))
                       ->setValue('')
                       ->setAttrib('maxlength', '10')
                       ->setRequired(true);                                
                 
         $resPhone = $this->createElement('text', 'resPhone');
         $resPhone->removeDecorator('Label')
         		  ->removeDecorator('HtmlTag')                  
                  ->setAttrib('class','inp1 usformat')
                  ->setAttrib('style','width:108px !important;')              
                  ->setAttrib('maxlength', '15')
                  ->addFilters(array('StringTrim'))
                  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Phone Number.'))))
                  ->setValue('')              
                  ->setRequired(true);

         $resFax = $this->createElement('text', 'resFax');
         $resFax->removeDecorator('Label') 
         		->removeDecorator('HtmlTag')               
                ->setAttrib('class','inp1')              
                ->setAttrib('maxlength', '15')
                ->addFilters(array('StringTrim'))
                ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Fax Number.'))))
                ->setValue('')              
                ->setRequired(false);
         
         $resWebsite = $this->createElement('text', 'resWebsite');
         $resWebsite->removeDecorator('Label') 
                    ->removeDecorator('HtmlTag')               	
                	->setAttrib('class','inp1')              
                	->setAttrib('maxlength', '255')
                	->addFilters(array('StringTrim'))
                	->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter WebSite.'))))
                	->setValue('')              
                	->setRequired(false);
                	
         $resManager = $this->createElement('text', 'resManager');
         $resManager->removeDecorator('Label') 
                    ->removeDecorator('HtmlTag')               	
                	->setAttrib('class','inp1')              
                	->setAttrib('maxlength', '255')
                	->addFilters(array('StringTrim'))
                	->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Restaurant ManagerName.'))))
                	->setValue('')              
                	->setRequired(false);
                	
		$resDescription = $this->createElement('textarea', 'resDescription');
		$resDescription->removeDecorator('Label')
		               ->removeDecorator('HtmlTag')                	   
                	   ->setAttrib('maxlength', '5000')
                	   ->setAttrib('cols', '40')
			           ->setAttrib('rows', '4')
			           ->setAttrib('class','inp1')              
                	   ->setValue('')              
                	   ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Restaurant Description.')),
			           			array('StringLength', false,array(1,5000,'messages' => array(
              					Zend_Validate_StringLength::TOO_LONG => 'Description is too long(>5000).'
              				)))))
			           ->setRequired(true);
                	   	
               	   
		$resImage = $this->createElement('file','resImage');
		$resImage->removeDecorator('Label')
			     ->removeDecorator('HtmlTag')
			     ->setAttrib('class','inp1')			     
			     ->setRequired(false)
			     ->addValidator('FilesSize', false, array('min' => '1kB', 'max' => '100kB'))
			     ->addValidator('Extension', false, 'jpg,png,gif');
			     
		$resLogo = $this->createElement('file','resLogo');
		$resLogo->removeDecorator('Label')
				->removeDecorator('HtmlTag')
				->setAttrib('class','inp1')			     
			    ->setRequired(false)
			    ->addValidator('FilesSize', false, array('min' => '1kB', 'max' => '100kB'))
			    ->addValidator('Extension', false,array('jpg,png','messages' => 'Please select jpg or png images only'));
			     	
	    $restParking = $this->createElement('text','restParking');
	    $restParking->removeDecorator('Label')
			        ->removeDecorator('HtmlTag')
			        ->setAttrib('class','inp1')
			        ->addFilters(array('StringTrim'))			     
			        ->setRequired(false)
			        ->setAttrib('maxlength', '100');

		$restParkDetail = $this->createElement('text','restParkDetails');
		$restParkDetail->removeDecorator('Label')
			           ->removeDecorator('HtmlTag')			     
			           ->setRequired(false)
			           ->setAttrib('maxlength', '5000')
			           ->addFilters(array('StringTrim'))
			           ->addValidators(array(array('StringLength', false,array(1,5000,'messages' => array(
              					Zend_Validate_StringLength::TOO_LONG => 'ParkDetail is too long(>5000).'
              				)))))
			           ->setAttrib('class','inp1');

		$restPrivateParty = $this->createElement('text','restPrivParty');
		$restPrivateParty->removeDecorator('Label')
			             ->removeDecorator('HtmlTag')
			             ->setRequired(false)
			           	 ->setAttrib('maxlength', '(1000')
			           	 ->addFilters(array('StringTrim'))
			           	 ->addValidators(array(array('StringLength', false,array(1,1000,'messages' => array(
              					Zend_Validate_StringLength::TOO_LONG => 'PrivParty is too long(>1000).'
              				)))))
			           	 ->setAttrib('class','inp1');					           
			           				        
        $restPrivContact = $this->createElement('text','restPrivPartyContact');
		$restPrivContact->removeDecorator('Label')
			             ->removeDecorator('HtmlTag')
			             ->setRequired(false)
			           	 ->setAttrib('maxlength', '500')
			           	 ->addFilters(array('StringTrim'))
			           	 ->addValidators(array(array('StringLength', false,array(1,500,'messages' => array(
              					Zend_Validate_StringLength::TOO_LONG => 'PrivPartyContact is too long(>500).'
              				)))))
			           	->setAttrib('class','inp1');	

		$restEntertainment = $this->createElement('text','restEntertainment');
		$restEntertainment->removeDecorator('Label')
			              ->removeDecorator('HtmlTag')
			              ->setRequired(false)
			           	  ->setAttrib('maxlength', '1000')
			           	  ->addFilters(array('StringTrim'))
			           	  ->addValidators(array(array('StringLength', false,array(1,1000,'messages' => array(
              					Zend_Validate_StringLength::TOO_LONG => 'Entertainment is too long(>1000).'
              				)))))
			           	  ->setAttrib('class','inp1');
			           	  	
		$restAdditDetail = $this->createElement('text','restAdditDetails');
		$restAdditDetail->removeDecorator('Label')
			            ->removeDecorator('HtmlTag')
			            ->setRequired(false)
			            ->setAttrib('maxlength', '500')
			            ->addFilters(array('StringTrim'))
			            ->addValidators(array(array('StringLength', false,array(1,500,'messages' => array(
              					Zend_Validate_StringLength::TOO_LONG => 'AdditDetails is too long(>500).'
              				)))))
			            ->setAttrib('class','inp1');
		/*$restSubResSys = new Zend_Form_Element_Checkbox('restSubResSys');
		$restSubResSys->removeDecorator('Label')
			          ->removeDecorator('HtmlTag')
			          ->setRequired(false)
			          ->setChecked(false);*/
			          
		$restTimings = $this->createElement('textarea', 'restTimings');
		$restTimings->removeDecorator('Label')
				    ->removeDecorator('HtmlTag')                	   
                    ->setAttrib('maxlength', '200')
                    ->setAttrib('cols', '40')
		            ->setAttrib('rows', '3')
		            ->setAttrib('class','sel1')
		            ->addFilters(array('StringTrim'))              
                    ->setValue('')              
                    ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Restaurant Description.')),
		           			array('StringLength', false,array(1,5000,'messages' => array(
              				Zend_Validate_StringLength::TOO_LONG => 'Description is too long(>5000).'
              			)))))
		            ->setRequired(false);
			          					            			           	  		           	 

		$imageCaptcha = new Zend_Captcha_Image();
        $imageCaptcha->setWidth(250)
        			 ->setWordlen(6)
        			 ->setHeight(80)
        			 ->setTimeout(900)
        			 ->setFontSize(32)
        			 ->setGcFreq(5)
        			 ->setFont('fonts/Scrawllege.ttf')
        			 ->setImgDir('images/captcha/')
        			 ->setImgUrl('/images/captcha/')
        			 ->setDotNoiseLevel(0)
        			 ->setLineNoiseLevel(0);
        			   
        $captcha = new Zend_Form_Element_Captcha('captcha',array(
										         					'label' => 'Text you see above',
										         					'captcha' => $imageCaptcha 
										         			)); 
		$captcha->removeDecorator('DtDdWrapper')
				->removeDecorator('HtmlTag')
				->setAttrib('style','position:relative;margin-top:35px'); 
				            
		$resSubmit = $this->createElement('submit','Submit');
        $resSubmit->removeDecorator('Label')
        		  ->removeDecorator('DtDdWrapper')
        		  ->setValue('Submit')           		          		        		
        		  ->setAttrib('class','submitBtn')
                  ->setIgnore(true);

		$resReset = $this->createElement('reset','Reset');
        $resReset->removeDecorator('Label')        		 
        		 ->setValue('Reset')
        		 ->removeDecorator('DtDdWrapper')           	  	 
        	  	 ->setAttrib('class','submitBtn')
              	 ->setIgnore(true);		

        $countryCodeNumber = $this->createElement('select','countryCodeNumber');
		$countryCodeNumber->removeDecorator('Label') 
         		  ->removeDecorator('HtmlTag')
         		  ->setAttrib('class','sel1 drpDown')
         		  ->setAttrib('style','width:50px !important;')
         		  ->setValue(1)         		  
         		  //->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select Country.'))))       	   
               	  ->addMultiOptions($countryCodeNumberList)
                  ->setRequired(true); 
				 
		$this->addElements( array ($restId,
								   $restLatitude,
								   $restLongitude,
								   $restaurantName,
								   $restCapacity,
								   $restDiningStyle,
								   $resEmailAddress,
								   //$resYearFound,
								   $maxpax,
								   $restaurantType,
								   $resAddress,
								   $resCountry,
								   $resState,
								   $resTimezone,
								   $resprice,
								   $resRegion,
								   $resCity,								   
								   $resPostalCode,
								   $resPhone,
								   $resFax,
								   $resWebsite,
								   $resManager,
								   $resDescription,	
								   $resImage,
								   $resLogo,
								   $restParking,
								   $restParkDetail,
								   $restPrivateParty,
								   $restPrivContact,
								   $restEntertainment,
								   $restAdditDetail,
								   $resPaymentMode,
								   $restTimings,								   						   
								   $resSubmit,
								   $resReset,
								   $cantfindstate,
	                           	   $cantfindregion,
	                           	   $cantfind,
	                           	   $cantfindcity,	                           	  
	                           	   $countryCodeNumber		
								  )			
		);	     		 
    }
}

