<?php
class ManageRestaurant_Form_OverBookedPassword extends Zend_Form
{

	public function init()
    {
    	$passwordConfirm = new Uss_Validate_PasswordConfirmation();
    	
    	$restNameCtl = $this->createElement('select','RestaurantName');
        $restNameCtl->removeDecorator('Label')
         		    ->removeDecorator('HtmlTag')
         		    ->setAttrib('class','sel1 drpDown')
         		    ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select RestaurantName.'))))
         		    ->setRegisterInArrayValidator(false)
         		    ->setRequired(true);
         		    
         $password =  $this->createElement('password','password');
         $password->removeDecorator('Label')
         		->removeDecorator('HtmlTag')
        		->setAttrib('maxlength', '20')
        		->setAttrib('class','inp1')
                ->addValidators(array($passwordConfirm,
                			array('NotEmpty', true, array('messages' => 'Please enter your Password.')),
                			array('StringLength', false, array(6, 20,'messages' => array(
                    Zend_Validate_StringLength::TOO_SHORT => 'Your password is too short(>6).',
                    Zend_Validate_StringLength::TOO_LONG => 'Your password is too long(<20).'))
            		)))
                ->setRequired(true)
                ->setValue('')                
                ->setIgnore(false);
        
        $confirmPassword =  $this->createElement('password','password_confirm');
        $confirmPassword->removeDecorator('Label')
        			->removeDecorator('HtmlTag')
        			->setAttrib('maxlength', '20')
        			->setAttrib('class','inp1')
                    ->addValidators(array($passwordConfirm,
                    				  array('NotEmpty', true, array('messages' => 'Please enter confirm Password.')),
                					 
                				 ))
                    ->setRequired(true)
                    ->setValue('')
                    ->setIgnore(false); 
                    
        $status = $this->createElement('hidden','status');                    	
        $status->removeDecorator('HtmlTag');
           	
        $Submit = $this->createElement('submit','Submit');
        $Submit->setLabel("Submit") 
        		->removeDecorator('DtDdWrapper')       		
        		->setAttrib('class','submitBtn')
                ->setIgnore(true);
                
         $this->addElements( array (
        					$restNameCtl,
        					$password,
                            $confirmPassword,
                            $status,
                            $Submit));
    }
}