<?php
class ManageRestaurant_Model_RestNotifyTimesMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}


	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('ManageRestaurant_Model_DbTable_RestNotifyTimes');
		}
		return $this->_dbTable;
	}
	
	public function AddrestSmsNotifyNumber(ManageRestaurant_Model_RestNotifyTimes $object)
	{
		try{
			
			$data = array('rntfk_restaurants'	=>	$object->getrntfk_restaurants(),
						  'rntphone'			=>	$object->getrntphone(),
						  'rntnotify_from_time'	=>	$object->getrntnotify_from_time(),
						  'rntnotify_to_time'	=>	$object->getrntnotify_to_time(),
						  'rntnotify_type'		=>	$object->getrntnotify_type(),
						  'rntstatus'			=>  $object->getrntstatus(),
						  'rntcountrycode'		=>  $object->getCountrycode()	
					);
					
			$id = $this->getDbTable()->insert($data);
			if($id){
				return true;
			}else{
				return false;
			}
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function AddrestSmsNotifyNumberFromNativeApp(ManageRestaurant_Model_RestNotifyTimes $object)
	{
		try{
			$id = 0; 
			$data = array('rntfk_restaurants'	=>	$object->getrntfk_restaurants(),
						  'rntphone'			=>	$object->getrntphone(),
						  'rntnotify_from_time'	=>	$object->getrntnotify_from_time(),
						  'rntnotify_to_time'	=>	$object->getrntnotify_to_time(),
						  'rntnotify_type'		=>	$object->getrntnotify_type(),
						  'rntstatus'			=>  $object->getrntstatus()	 	
					);
					
			$id = $this->getDbTable()->insert($data);
			return $id;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function restPhoneNotifyNumber(array $PhoneNotifydayArr)
	{
		$db = Zend_Db_Table::getDefaultAdapter();
		try{
			$db->beginTransaction();
			if($PhoneNotifydayArr){
				foreach($PhoneNotifydayArr as $day){
					if($day->getrntid()){
						if($day->getrntstatus()){
							$set = array('rntphone' 	=>	$day->getrntphone(),
								 'rntcountrycode'		=>	$day->getCountrycode(), 
								 'rntnotify_from_time'	=>	$day->getrntnotify_from_time(),
								 'rntnotify_to_time'	=>	$day->getrntnotify_to_time(),
								 'rntstatus' 			=>	$day->getrntstatus()
							);
						}else{
							$set = array('rntphone' 	=>	$day->getrntphone(),
								 'rntcountrycode'		=>	$day->getCountrycode(),
								 'rntnotify_from_time'	=>	$day->getrntnotify_from_time(),
								 'rntnotify_to_time'	=>	$day->getrntnotify_to_time(),
								 'rntstatus' 			=>	'false'
							);
						}						
						$where = array('rntid = ?'=>$day->getrntid());
							
						$id = $this->getDbTable()->update($set,$where);
					}else{
						$data = array('rntfk_restaurants'	=>	$day->getrntfk_restaurants(),
						  'rntphone'			=>	$day->getrntphone(),
						  'rntcountrycode'		=>	$day->getCountrycode(),
						  'rntnotify_from_time'	=>	$day->getrntnotify_from_time(),
						  'rntnotify_to_time'	=>	$day->getrntnotify_to_time(),
						  'rntnotify_type'		=>	$day->getrntnotify_type(),
						  'rntstatus'			=>  $day->getrntstatus(),
						  'rntnotify_week_day'	=>	$day->getrntnotify_week_day()	
						);
						$id = $this->getDbTable()->insert($data);
					}
				}
			}
			$db->commit();
			if($id){
				return true;
			}else{
				return false;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getRestSmsNotifyNumber(ManageRestaurant_Model_RestNotifyTimes $object)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('rntid','rntphone','rntnotify_from_time','rntnotify_to_time','rntcountrycode'));
			$select->where('rntfk_restaurants = ?',$object->getrntfk_restaurants());
			$select->where('rntnotify_type = ?',$object->getrntnotify_type());
			$select->where('rntstatus = ?',true);
			
			$rowSet = $table->fetchRow($select);
			$resultArr = array();
			if($rowSet){
				$startTime = explode(':',$rowSet->rntnotify_from_time);
				if($startTime[0] >=12){
					if((int)$startTime[0] != 12){
						(int)$startTime[0] -= 12;
					}
					$startTime[2] = 'PM';
					$finalstartTime = $startTime[0].':'.$startTime[1].' '.$startTime[2];
				}else{
					$startTime[2] = 'AM';
					if((int)$startTime[0] == 0){
						$startTime[0] = 12;
					}
					$finalstartTime = $startTime[0].':'.$startTime[1].' '.$startTime[2];
				}
				
				$endTime = explode(':',$rowSet->rntnotify_to_time);
				if($endTime[0] >=12){
					if((int)$endTime[0] != 12){
						(int)$endTime[0] -= 12;
					}
					$endTime[2] = 'PM';
					$finalendTime = $endTime[0].':'.$endTime[1].' '.$endTime[2];
				}else{
					$endTime[2] = 'AM';
					if((int)$endTime[0] == 0){
						$endTime[0] = 12;
					}
					$finalendTime = $endTime[0].':'.$endTime[1].' '.$endTime[2];
				}
				
				$resultArr['Id'] = $rowSet->rntid;
				$resultArr['phone'] = $rowSet->rntphone;
				$resultArr['from'] = $finalstartTime;
				$resultArr['to'] = $finalendTime;
				if($rowSet->rntcountrycode){
					$resultArr['phonecode'] = $rowSet->rntcountrycode;
				}else{
					$resultArr['phonecode'] = '';
				}
			}
			return $resultArr;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getRestPhoneNotifyNumber(ManageRestaurant_Model_RestNotifyTimes $object)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('rntid','rntphone','rntnotify_from_time','rntnotify_to_time','rntnotify_week_day','rntstatus','rntcountrycode'));
			$select->where('rntfk_restaurants = ?',$object->getrntfk_restaurants());
			$select->where('rntnotify_type = ?',$object->getrntnotify_type());
			//$select->where('rntstatus = ?',true);
			
			$resultSet = $table->fetchAll($select);
			$tempArr = array();
			$resultArr = array();
			$finalArr =  array();
			$dayArr = array();
			
			foreach($resultSet as $row){
				$startTime = explode(':',$row->rntnotify_from_time);
				if($startTime[0] >=12){
					if((int)$startTime[0] != 12){
						(int)$startTime[0] -= 12;
					}
					$startTime[2] = 'PM';
					$finalstartTime = $startTime[0].':'.$startTime[1].' '.$startTime[2];
				}else{
					$startTime[2] = 'AM';
					if((int)$startTime[0] == 0){
						$startTime[0] = 12;
					}
					$finalstartTime = $startTime[0].':'.$startTime[1].' '.$startTime[2];
				}
				
				$endTime = explode(':',$row->rntnotify_to_time);
				if($endTime[0] >=12){
					if((int)$endTime[0] != 12){
						(int)$endTime[0] -= 12;
					}
					$endTime[2] = 'PM';
					$finalendTime = $endTime[0].':'.$endTime[1].' '.$endTime[2];
				}else{
					$endTime[2] = 'AM';
					if((int)$endTime[0] == 0){
						$endTime[0] = 12;
					}
					$finalendTime = $endTime[0].':'.$endTime[1].' '.$endTime[2];
				}
				
				$tempArr['Id'] = $row->rntid;
				$resultArr['phone'] = $row->rntphone;
				$tempArr['from'] = $finalstartTime;
				$tempArr['to'] = $finalendTime;
				$tempArr['day'] = $row->rntnotify_week_day;
				$tempArr['daystatus'] = $row->rntstatus;
				$dayArr[$row->rntnotify_week_day] = $tempArr;
				if($row->rntcountrycode){
					$countryMapper  = new Application_Model_CountryDataMapper();
					$countryCodeNumber = $countryMapper->getCountryidbyCountryCodeNumber($row->rntcountrycode);
					$resultArr['phonecode'] = $countryCodeNumber;
				}else{
					$resultArr['phonecode'] = '';
				}
			}
			if($dayArr){
				$weekdayArr = array('mon','tue','wed','thu','fri','sat','sun');
				for($i= 0; $i<7;$i++){
					if(isset($dayArr[$weekdayArr[$i]])){
						$finalArr[$weekdayArr[$i]] =$dayArr[$weekdayArr[$i]];
					}else{					
						$finalArr[$weekdayArr[$i]] =array('Id'=>"",'from'=>"",'to'=>"",'day'=>"");
					}
				}
				$resultArr['times'] = $finalArr;
			}
			return $resultArr;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function UpdateNotifyDetails(ManageRestaurant_Model_RestNotifyTimes $object)
	{
		try{
			$table = $this->getDbTable();
			$set = array('rntphone' 			=>	$object->getrntphone(),
						 'rntnotify_from_time'	=>	$object->getrntnotify_from_time(),
						 'rntnotify_to_time'	=>	$object->getrntnotify_to_time(),
						 'rntcountrycode'		=>	$object->getCountrycode()
					);
			$where = array('rntid = ?'=>$object->getrntid());		
			$status = $table->update($set,$where);
			return 	$status;		
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function retrievePhoneNotifyNumber(ManageRestaurant_Model_RestNotifyTimes $object)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('rntid','rntphone','rntnotify_from_time','rntnotify_to_time'))
				   ->where('rntnotify_type = ?','phone')
				   ->where('rntnotify_week_day = ?',$object->getrntnotify_week_day())
				   ->where('rntfk_restaurants= ?',$object->getrntfk_restaurants())
				   ->where('rntstatus = ?',true);
				   
			$row = $table->fetchRow($select);
			
			return $row;
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function RestSMSDetails($restId)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('rntid','rntfk_restaurants','rntphone','rntnotify_from_time','rntnotify_to_time','rntnotify_type','rntstatus','rntnotify_week_day'))
				   ->where('rntfk_restaurants = ?',$restId);   
			$rows = $table->fetchAll($select);
			$resultArr = array();
			foreach($rows as $value){
				$array = array(
					'rntid'							=> $value->rntid,
					'rntfk_restaurants' 			=>	$value->rntfk_restaurants,
					'rntphone'						=>	$value->rntphone,
					'rntnotify_from_time'			=>	$value->rntnotify_from_time,
					'rntnotify_to_time'				=>	$value->rntnotify_to_time,
					'rntnotify_type'				=>	$value->rntnotify_type,
					'rntstatus'						=>	$value->rntstatus,
					'rntnotify_week_day'			=>	$value->rntnotify_week_day,
				);
				$resultArr[] = $array;
			}			
			return $resultArr;		
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}