<?php

class ManageRestaurant_Model_RestaurantFloorEntranceDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {

			$this->setDbTable('ManageRestaurant_Model_DbTable_RestaurantFloorEntrance');
		}
		return $this->_dbTable;
	}
	public function saveRestaurantFloorEntrance(array $resFloorEtnArr,$resid,$diningid)
	{

		try{

			$db = Zend_Db_Table::getDefaultAdapter();
			$where = array('rfefk_restaurant = ?' => $resid,
						   'rfediningid  = ?' => $diningid
						 );
			$this->getDbTable()->delete($where);

			if($resFloorEtnArr){
				foreach($resFloorEtnArr as $resFloorEtn){
					$resFloorEtnData = array(
			  	    'rfefk_restaurant' 			=> 	$resid,
				 	'rfeentrance_number' 		=> 	$resFloorEtn->getEntranceNumber(),
				  	'rfeentrance_position' 		=> 	$resFloorEtn->getEntrancePosition(),
				  	'rfeentrance_coordinates' 	=>	$resFloorEtn->getEntranceCoor(),
				  	'rfefloor_number' 			=> 	$resFloorEtn->getFloorNumber(),
				  	'rfestatus' 				=> 	$resFloorEtn->getEntranceStatus(),
					'rfecreatedby'				=>  $resFloorEtn->getCreatedBy(),
				  	'rfecreateddatetime' 		=> 	$resFloorEtn->getCreatedDate(),				  
				  	'rfeentrance_type' 			=> 	$resFloorEtn->getEntranceType(),
				  	'rfeentrance_dimensions' 	=> 	$resFloorEtn->getEntranceDimension(),
					'rfediningid'				=>	$resFloorEtn->getDiningId(),
					'rfesync_status'			=>	'C'
					);

					$this->getDbTable()->insert($resFloorEtnData);
				}

				$this->clearFloorEntrance($resid);
			}
			return true;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getRestaurantFloorEntrance(ManageRestaurant_Model_RestaurantFloorEntrance  $etnObj)
	{
		try{
			$resId = $etnObj->getResId();
			$diningId = $etnObj->getDiningId();
			//$cache = new Uss_Helper_CacheManager();
			$resultset = null;
			//$key = $resId.'ent';

			//if(!$resultset = $cache->Fetch($key)){
				$table = $this->getDbTable();
				$select = $table->select();
				$select->from($table,array(
						'rfeentrance_number',
						'rfeentrance_type',
						'rfeentrance_position',
						'rfeentrance_coordinates',
						'rfeentrance_dimensions'
						))
						->where('rfefk_restaurant = ?',$resId)
						->where('rfediningid = ?',$diningId);
						$resultset = $this->getDbTable()->fetchAll($select);
			/*			if($resultset){
							$cache->Save($resultset,$key);
						}
							
			}else{
				$resultset = $cache->Fetch($key);
			}*/

			$tableArr = array();
			foreach($resultset as $value){

				$number = $value['rfeentrance_number'];
				$type  = $value['rfeentrance_type'];
				$position = $value['rfeentrance_position'];
				$coordinates = $value['rfeentrance_coordinates'];
				$dimensions = $value['rfeentrance_dimensions'];

				array_push($tableArr,array('number' 	 => $number,
				 				       'type'    	 => $type,
					 				   'position'	 => $position,
					 				   'coordinates' => $coordinates,
					 				   'dimensions'  => $dimensions));			

			}
			//$cache = null;
			return $tableArr;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function clearFloorEntrance($restid)
	{
		try{
			$key = $restid.'ent';
			$status = null;
			$cache = new Uss_Helper_CacheManager();
			if($cache->Check($key)){
				$status = $cache->Clear($key);
				return $status;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetRestaurantFloorEntranceByRestaurantid($restaurantid)
	{
		try{			
			$table = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('rfeid',
									   'rfefk_restaurant',
									   'rfeentrance_coordinates',
									   'rfestatus',
									   'rfecreatedby',
									   'rfecreateddatetime',
									   'rfeupdatedby',
									   'rfeupdateddatetime',
									   'rfeentrance_dimensions',
									   'rfeentrance_position',
									   'rfeentrance_type',
									   'rfeentrance_number',
									   'rfefloor_number',
									   'rfediningid'))
				   ->where('rfefk_restaurant = ?',$restaurantid)
				   ->where('rfestatus = ?','TRUE');
			$resultset = $this->getDbTable()->fetchAll($select);
			$entranceArr= array();
			foreach($resultset as $key=>$value){
				$subArr = array();
				foreach($value as  $key1=>$value1){
					if($key1 == 'rfecreatedby' || $key1 == 'rfeupdatedby'){
						$subArr[$key1]= null;
					}else{
						$subArr[$key1]= $value1;
					}
				}
				$entranceArr[] = $subArr;
			}
			return $entranceArr;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetUpdatedRestaurantFloorEntranceByRestaurantid($restaurantid)
	{
		try{			
			$table = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('rfeid',
									   'rfefk_restaurant',
									   'rfeentrance_coordinates',
									   'rfestatus',
									   'rfecreatedby',
									   'rfecreateddatetime',
									   'rfeupdatedby',
									   'rfeupdateddatetime',
									   'rfeentrance_dimensions',
									   'rfeentrance_position',
									   'rfeentrance_type',
									   'rfeentrance_number',
									   'rfefloor_number',
									   'rfediningid'))
				   ->where('rfefk_restaurant = ?',$restaurantid)
				   ->where('rfesync_status = ?','C');
			$resultset = $this->getDbTable()->fetchAll($select);
			$entranceArr= array();
			foreach($resultset as $key=>$value){
				$subArr = array();
				foreach($value as  $key1=>$value1){
					if($key1 == 'rfecreatedby' || $key1 == 'rfeupdatedby'){
						$subArr[$key1]= null;
					}else{
						$subArr[$key1]= $value1;
					}
				}
				$entranceArr[] = $subArr;
			}
			return $entranceArr;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function UpdateRestaurantFloorEntranceSyncStatusFromNative($restaurantid)
	{
		try{
			$set = array('rfesync_status'  => 'S');			
			$where 	= array('rfefk_restaurant = ?'=> $restaurantid,'rfesync_status = ?'=>'C');
			
			$this->getDbTable()->update($set,$where);
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

}

