<?php

class ManageRestaurant_Model_RestaurantGroup
{

      protected $_id;
      protected $_grouptypeid;
      protected $_restaurantid;
      protected $_restaurantgroup;
      protected $_groupdesc;
      protected $_createddate;
      protected $_updatedate;
      protected $_status;
      
	public function __construct(array $options = null)
	{
		if(is_array($options)){
			$this->setOptions($options);
		}		
	}
	
	public function __set($name, $value)
	{
		$method = 'set' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid RestaurantMenu property');
		}
		$this->$method($value);
	}
	
	public function __get($name)
	{
		$method = 'get' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid RestaurantMenu property');
		}
		return $this->$method();
	}
	
	public function setOptions(array $options)
	{
		$methods = get_class_methods($this);
		foreach ($options as $key => $value) {
			$method = 'set' . ucfirst($key);
			if (in_array($method, $methods)) {
				$this->$method($value);
			}
		}
		return $this;
	}
	
	public function setId($id)
	{
		$this->_id = (int)$id;
		return $this; 
	}
	
	public function getId()
	{
	    return	$this->_id;
	}
	
	public function setGroupTypeId($grouptypeid)
	{
		$this->_grouptypeid = $grouptypeid;
		return $this; 
	}
	
	public function getGroupTypeId()
	{
	    return	$this->_grouptypeid;
	}
	
	public function setRestaurantId($restaurantid)
	{
		$this->_restaurantid = (int)$restaurantid;
		return $this; 
	}
	
	public function getRestaurantId()
	{
	    return	$this->_restaurantid;
	}
	
	public function setRestaurantGroup($restaurantgroup)
	{
		$this->_restaurantgroup = $restaurantgroup;
		return $this; 
	}
	
	public function getRestaurantGroup()
	{
	    return	$this->_restaurantgroup;
	}
	
	public function setGroupDesc($groupdesc)
	{
		$this->_groupdesc = $groupdesc;
		return $this; 
	}
	
	public function getGroupDesc()
	{
	    return	$this->_groupdesc;
	}
	
	public function setCreatedDate($createddate)
	{
		$this->_createddate = $createddate;
		return $this; 
	}
	
	public function getCreatedDate()
	{
	    return	$this->_createddate;
	}
	
	public function setUpdateDate($updatedate)
	{
		$this->_updatedate = $updatedate;
		return $this; 
	}
	
	public function getUpdateDate()
	{
	    return	$this->_updatedate;
	}
	
	public function setStatus($status)
	{
		$this->_status = $status;
		return $this; 
	}
	
	public function getStatus()
	{
	    return	$this->_status;
	}
	
}

