<?php
class ManageRestaurant_Model_RestaurantInternalMessagingDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
				
			$this->setDbTable('ManageRestaurant_Model_DbTable_RestaurantInternalMessaging');
		}
		return $this->_dbTable;
	}
	
	public function createMessage(ManageRestaurant_Model_RestaurantByOwnerId $ownerIdObj,$suject, $message, $restIdsArr)
	{
		$status = false;
		$db = Zend_Db_Table::getDefaultAdapter();
		$data = array(
				'rim_userid'	=>	$ownerIdObj->getResOwnerId(),
				'rim_subject'	=>	$suject,
				'rim_message'	=>	$message,
				'rim_status'	=>	true,
				'rim_createdon'	=>	date('Y-m-d H:i:s')
			);
				
		try{
			$db->beginTransaction();
			
			$msgid = $this->getDbTable()->insert($data);
			
			$restuserMapper = new Ums_Model_RestaurantUserDataMapper();
			$UserIds = $restuserMapper->getRestaurantUserIdsByRestIds($restIdsArr);
			
			foreach($UserIds as $userid){
				$data = array(
					'rimr_messageid'	=> $msgid,
					'rimr_userid'		=> $userid->rsufk_user,
					'rimr_status'		=> true
				);
				
				$recipentsMapper = new ManageRestaurant_Model_RestaurantInternalMessagingRecipentsDataMapper();
				$recipentsMapper->getDbTable()->insert($data);
			}
			$db->commit();
			$status = true;
			return $status;
		}catch (Exception $ex){
			$db->rollBack();
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getMessagesById($Id)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			
			$select->from($table,array('rimid','rim_message','rim_subject'))
				   ->where('rim_userid = ?',$Id)
				   ->order('rimid DESC');
			$result = $table->fetchAll($select);
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getMessageDescriptionById($msgid)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			
			$select->from($table,array('rim_message'))
				   ->where('rimid = ?',$msgid);
			$result = $table->fetchRow($select);
			$resultArr = array();
			$resultArr['result'] = $result->rim_message;
			return $resultArr;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}