<?php
class ManageRestaurant_Model_RestaurantInternalMessagingRecipentsDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
				
			$this->setDbTable('ManageRestaurant_Model_DbTable_RestaurantInternalMessagingRecipents');
		}
		return $this->_dbTable;
	}
	
	public function getMessagesById($Id)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			$select->from(array('rm'=>'mt.restaurant_internalmessage_recipents'),array('rimrid','rimr_messageid'))
				   ->join(array('rim'=>'mt.restaurant_internalmessages'),'rm.rimr_messageid = rim.rimid',array('rimid','rim_message','rim_subject'))
				   ->where('rm.rimr_userid = ?',$Id)
				   ->order('rim.rimid DESC');
			$result = $table->fetchAll($select);
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}