<?php

class ManageRestaurant_Model_RestaurantMealTypeDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}


	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('ManageRestaurant_Model_DbTable_RestaurantMealType');
		}
		return $this->_dbTable;
	}
	
	public function AddRestaurantMealType(ManageRestaurant_Model_RestaurantMealType $meal)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->setIntegrityCheck(false);
			$select->from(array('meal'=>'mt.restaurant_meal_type'),array('rmt_id','rmt_start_time','rmt_end_time'))
					->join(array('type'=>'mt.meal_type_bd'),'meal.rmt_meal_type = type.id',array('id as mealid','code as meal','description as mealtype'))
					->where('meal.rmt_restaurant = ?',$meal->getResId())
					->where('meal.rmt_start_time <= ?',$meal->getStartTime())
					->where('meal.rmt_end_time >= ?',$meal->getEndTime())
					->where('meal.rmt_status = ?','Y');
			$row = $this->getDbTable()->fetchRow($select);
			if(!$row){
				$db = Zend_Db_Table::getDefaultAdapter();
				$rowSet = $db->fetchOne("select count(rmt_id) from mt.restaurant_meal_type where rmt_restaurant = '". $meal->getResId() ."'and rmt_meal_type = '". $meal->getMealType()."'");
				if(!$rowSet){
					$data = array(
									'rmt_restaurant'		=>	$meal->getResId(),
									'rmt_meal_type'			=>	$meal->getMealType(),
									'rmt_start_time'		=>	$meal->getStartTime(),
									'rmt_end_time'			=>	$meal->getEndTime(),
									'rmt_status'			=>	'Y'
					);
					$result = $this->getDbTable()->insert($data);
					$resultSet = $this->GetRestaurantMealTypes($meal);
					return $resultSet;
				}else{
					return false;
				}
			}else{
				return false;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function EditRestaurantMealType(ManageRestaurant_Model_RestaurantMealType $meal)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->setIntegrityCheck(false);
			$select->from(array('meal'=>'mt.restaurant_meal_type'),array('rmt_id','rmt_start_time','rmt_end_time'))
					->join(array('type'=>'mt.meal_type_bd'),'meal.rmt_meal_type = type.id',array('id as mealid','code as meal','description as mealtype'))
					->where('meal.rmt_restaurant = ?',$meal->getResId())
					->where('meal.rmt_id <> ?', $meal->getMealType())
					->where('meal.rmt_start_time <= ?',$meal->getStartTime())
					->where('meal.rmt_end_time >= ?',$meal->getEndTime())
					->where('meal.rmt_status = ?','Y');
			$row = $this->getDbTable()->fetchRow($select);
			if(!$row){
				$set = array(
								'rmt_start_time'		=>	$meal->getStartTime(),
								'rmt_end_time'			=>	$meal->getEndTime()
				);
				$where = array('rmt_restaurant = ?' => $meal->getResId(),
								'rmt_id = ?' => $meal->getMealType()
				);
				$result = $this->getDbTable()->update($set,$where);
				$resultSet = $this->GetRestaurantMealTypes($meal);
				return $resultSet;
			}else{
				return false;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function UpdateMealStattus(ManageRestaurant_Model_RestaurantMealType $meal)
	{
		try{
			$set = array(
							'rmt_status'	=>	$meal->getStatus()
			);
			$where = array('rmt_restaurant = ?' => $meal->getResId(),
							'rmt_id = ?' => $meal->getId()
			);
			$result = $this->getDbTable()->update($set,$where);
			$resultSet = $this->GetRestaurantMealTypes($meal);
			return $resultSet;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetRestaurantMealTypes(ManageRestaurant_Model_RestaurantMealType $meal)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->setIntegrityCheck(false);
			$select->from(array('meal'=>'mt.restaurant_meal_type'),array('rmt_id','rmt_start_time','rmt_end_time','rmt_status'))
				   ->join(array('type'=>'mt.meal_type_bd'),'meal.rmt_meal_type = type.id',array('code as meal','description as mealtype'))
				   ->where('meal.rmt_restaurant = ?',$meal->getResId())
				   //->where('meal.rmt_status = ?','Y')
				   ->order('meal.rmt_start_time');
			$resultSet = $this->getDbTable()->fetchAll($select);
			$result = array();
			foreach($resultSet as $row){
				$start = date("h:i A",strtotime($row->rmt_start_time));
				$end = date("h:i A",strtotime($row->rmt_end_time));
				$data = array('id'			=>	$row->rmt_id,
							  'meal'		=>	$row->meal,
							  'desc'		=>	$row->mealtype,
							  'starttime'	=>	$start,
							  'endtime'		=>	$end,
							  'status'		=>	$row->rmt_status);
				$result[$row->rmt_id] = $data;
			}
			$result['count'] = count($result);
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetRestaurantMealByTime(ManageRestaurant_Model_RestaurantMealType $meal)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->setIntegrityCheck(false);
			$select->from(array('meal'=>'mt.restaurant_meal_type'),array('rmt_id','rmt_start_time','rmt_end_time'))
					->join(array('type'=>'mt.meal_type_bd'),'meal.rmt_meal_type = type.id',array('id as mealid','code as meal','description as mealtype'))
					->where('meal.rmt_restaurant = ?',$meal->getResId())
					->where('meal.rmt_start_time <= ?',$meal->getTime())
					->where('meal.rmt_end_time >= ?',$meal->getTime())
					->where('meal.rmt_status = ?','Y');
			$resultSet = $this->getDbTable()->fetchRow($select);
			$result = array();
			
			return $resultSet;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetRestaurantMealByType(ManageRestaurant_Model_RestaurantMealType $meal)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->setIntegrityCheck(false);
			$select->from(array('meal'=>'mt.restaurant_meal_type'),array('rmt_id','rmt_start_time','rmt_end_time'))
					->join(array('type'=>'mt.meal_type_bd'),'meal.rmt_meal_type = type.id',array('id as mealid','code as meal','description as mealtype'))
					->where('meal.rmt_restaurant = ?',$meal->getResId())
					->where('type.code = ?',$meal->getMealType())
					->where('meal.rmt_status = ?','Y');
			$resultSet = $this->getDbTable()->fetchRow($select);
			$result = array();
			
			return $resultSet;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetMealSettingsByRestId($restid)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			
			$select->from(array('meal'=>'mt.restaurant_meal_type'),array('rmt_id','rmt_restaurant','rmt_meal_type','rmt_start_time','rmt_end_time','rmt_status'))
			       ->join(array('typ'=>'mt.meal_type_bd'),'typ.id = meal.rmt_meal_type',array('code as mealcode','description as mealdesc'))
			       ->where('rmt_restaurant = ?',$restid)
			       ->where('rmt_status = ?',true);
			       
			$rowset = $table->fetchAll($select);
			$mealSettingsArr = array();
			
			/* Break Fast */			
			foreach($rowset as $row){
				if($row->mealcode == "BRE"){
					$mealSettingsArr[] = $row->mealdesc;
				}
			}
						
			/* Lunch */			
			foreach($rowset as $row){
				if($row->mealcode == "LUN"){
					$mealSettingsArr[] = $row->mealdesc;
				}
			}
			
			/* Brunch */			
			foreach($rowset as $row){
				if($row->mealcode == "BRU"){
					$mealSettingsArr[] = $row->mealdesc;
				}
			}
			
			/* Dinner */			
			foreach($rowset as $row){
				if($row->mealcode == "DIN"){
					$mealSettingsArr[] = $row->mealdesc;
				}
			}
			
			return $mealSettingsArr;	
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetMealSettingsWebServiceByRestId($restid)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			$mealSettingsArr = array();
			$select->from(array('meal'=>'mt.restaurant_meal_type'),array('rmt_id','rmt_restaurant','rmt_meal_type','rmt_start_time','rmt_end_time','rmt_status'))
			       ->join(array('typ'=>'mt.meal_type_bd'),'typ.id = meal.rmt_meal_type',array('code as mealcode','description as mealdesc'))
			       ->where('rmt_restaurant = ?',$restid);
			       
			$rowset = $table->fetchAll($select);
			foreach($rowset as $row){
				$val = array();
				$val = array(	'rmt_id'			=>	$row->rmt_id,
								'rmt_restaurant'	=>	$row->rmt_restaurant,
								'rmt_meal_type'		=>	$row->rmt_meal_type,
								'rmt_start_time'	=>	$row->rmt_start_time,
								'rmt_end_time'		=>	$row->rmt_end_time,
								'rmt_status'		=>	$row->rmt_status
				);
				$mealSettingsArr[] = $val;
			}
			return $mealSettingsArr;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetRestaurantMealSettingsByRestId($resid,$mealType)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->setIntegrityCheck(false);
			$select->from(array('meal'=>'mt.restaurant_meal_type'),array('rmt_start_time','rmt_end_time'))
					->join(array('type'=>'mt.meal_type_bd'),'meal.rmt_meal_type = type.id',array('id as mealid','code as meal','description as mealtype'))
					->where('meal.rmt_restaurant = ?',$resid)
					->where('meal.rmt_status = ?','Y');
			if($mealType != 'ALL' && $mealType != ''){
				$select->where('type.code = ?',$mealType);
			}
			$resultSet = $this->getDbTable()->fetchAll($select);
			return $resultSet;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}