<?php
class ManageRestaurant_Model_RestaurantReservationsTimeSettingDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}


	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('ManageRestaurant_Model_DbTable_RestaurantReservationsTimeSetting');
		}
		return $this->_dbTable;
	}
	
	public function saveRestaurantResvTimeSetting($resid, $time, $chkstatus)
	{
		try{
			$status = '';
			$table  = $this->getDbTable();
			$data = array(
					'rrts_restaurantid'	=>	$resid,
					'rrts_time'			=>	$time,
					'rrts_status'		=>	$chkstatus
				);
			$db = Zend_Db_Table::getDefaultAdapter();
			$result = $db->fetchOne("select count(rrts_id) from mt.restaurant_reservations_time_setting where rrts_restaurantid = ".$resid);
			if((int)$result)
			{
				$where = array('rrts_restaurantid = ?'=>$resid);
				$status = $table->update($data,$where);				
			}else{
				$status = $table->insert($data);
			}				
			return $status;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getRestaurantResvTimeSetting($restid)
	{
		try{
			$result = array();
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('rrts_time','rrts_status'))
				   ->where('rrts_restaurantid = ?',$restid);				   
			$row = $table->fetchRow($select);

			if($row){
				$result['status'] = $row->rrts_status;
				$result['time'] = $row->rrts_time;
			}
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
}