<?php
class ManageRestaurant_Model_RestaurantSocialMediaDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}


	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('ManageRestaurant_Model_DbTable_RestaurantSocialMedia');
		}
		return $this->_dbTable;
	}
	
	public function AddFacebookPageId($restid,$appid){
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			
			$status = false; 
			$table = $this->getDbTable();
			
			$where = array('rsm_restid = ?' => $restid);
			$table->delete($where);
			
			$data = array(
				'rsm_restid'	=>	$restid,
				'rsm_pageid'	=>	$appid,
				'rsm_status'	=>	true
			);
			
			$id = $this->getDbTable()->insert($data);
			if($id){
				$status = true;
			}
			return $status;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function EditFacebookPageId($restid, $appid)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$status = false; 
			
			$set = array('rsm_pageid'=>	$appid);
			$where = $db->quoteInto('rsm_restid = ?',$restid);
			
			$id = $this->getDbTable()->update($set,$where);
			if($id){
				$status = true;
			}
			return $status;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetFacebookPageIdByRestId($restid)
	{
		try{
			$pageid = "";
			$table = $this->getDbTable();
			$select = $table->select();
			
			$select->from($table,array('rsm_pageid','rsmid'))
				   ->where('rsm_restid = ?',$restid);
			
			$resultset = $table->fetchAll($select);
			foreach ($resultset as $fbpageid){
				$pageid = $fbpageid->rsm_pageid;
			}
			return $pageid;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetRestaurantInfoByFBPageid($pageid)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			
			$select->from(array('rsm'=>'mt.restaurant_socialmedia'),array('rsm_restid'))
				   ->join(array('rst'=>'mt.restaurant'),'rst.resid = rsm.rsm_restid',array('resrestaurant_name','resphone','resaddress'))
				   ->where('rsm.rsm_pageid = ?',$pageid);
			
			$resultset = $table->fetchRow($select);
			$resulArr = array();
			if($resultset){
				$resulArr['restaurantid'] = $resultset->rsm_restid;
				$resulArr['restaurantname'] = $resultset->resrestaurant_name;
				$resulArr['restaurantphone'] = $resultset->resphone;
				$resulArr['restaurantaddress'] = $resultset->resaddress; 
			}
			return $resulArr;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
}