<?php
class Notification_Form_RecipentFilter extends Zend_Form
{
    public function init()
    {    	
    	$stateMapper  = new Application_Model_StateDataMapper();
    	$states = $stateMapper->fetchAll();
    	$stateList = array();  
    	$stateList[] = array('key'=>'','value'=>'Select All States');  	   
    	foreach($states as $state){
    		$stateList[] = array('key'=>$state->getId(),'value'=>$state->getDescription());
    	}
    	
    	$audMapper = new Application_Model_IntendedAudienceDataMapper();
    	$audience = $audMapper->fetchAll();
    	$audienceList = array();
    	foreach($audience as $aud){
    		$audienceList[] = array('key'=>trim($aud->getCode()),'value'=>"  ".  $aud->getDescription());
    	}
    	
    	$stateid = $this->createElement('hidden','stateid');
    	$stateid->removeDecorator('HtmlTag')
    		  		 ->removeDecorator('Label');
    		  		 
    	$regionid = $this->createElement('hidden','regionid');
    	$regionid->removeDecorator('HtmlTag')
    		  		 ->removeDecorator('Label');
    		  		 
    	$cityid = $this->createElement('hidden','cityid');
    	$cityid->removeDecorator('HtmlTag')
    		  		 ->removeDecorator('Label');
    		  		 
    	$usertype = new Zend_Form_Element_Radio('usertype');
		$usertype->removeDecorator('Label')
			   		  	 ->removeDecorator('HtmlTag')
			   		  	 ->setMultiOptions($audienceList)
			   		  	 ->setValue('RES')
			   		  	 ->setSeparator(' ')
			   		  	 ->setRequired(false);
                  
        $state = $this->createElement('select','state');
        $state->removeDecorator('Label') 
         		  ->removeDecorator('HtmlTag')
         		  ->setAttrib('class','sel1 drpDown')
         		  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select State.'))))       	   
               	  ->addMultiOptions($stateList)
               	  ->setAttrib('style','width:130px')
                  ->setRequired(false);
                  
        $campaign = $this->createElement('select','campaign');
        $campaign->removeDecorator('Label') 
         		 ->removeDecorator('HtmlTag')
         		 ->setAttrib('class','sel1 drpDown')
         		 ->setAttrib('style','width:130px')
         		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select Campaign.'))))       	   
               	 ->setRequired(false);

        $region = $this->createElement('select', 'region');
        $region->removeDecorator('Label')
         		 ->removeDecorator('HtmlTag')
         		 ->setAttrib('class','sel1 drpDown')
         		 ->setAttrib('style','width:130px')
         		 ->setRegisterInArrayValidator(false)
         		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select Region.'))))       	     
                 ->setRequired(false);      	 
                  
        $city = $this->createElement('select', 'city');
        $city->removeDecorator('Label')
         		 ->removeDecorator('HtmlTag')
         		 ->setAttrib('class','sel1 drpDown')
         		 ->setAttrib('style','width:130px')
         		 ->setRegisterInArrayValidator(false)
         		 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select City.'))))       	     
                 ->setRequired(false);
                 
        $restgroupname = $this->createElement('text', 'restgroupname');
      	$restgroupname->removeDecorator('Label')
      	         	  ->removeDecorator('HtmlTag')
      	         	  ->setAttrib('class','inp1')
      	         	  ->setAttrib('style','width:130px')
      	         	  ->addFilters(array('StringTrim'))
      	         	  ->setValue('')
      	        	  ->setRequired(false);
      	        	  
      	$restname = $this->createElement('text', 'restname');
      	$restname->removeDecorator('Label')
      	         	  ->removeDecorator('HtmlTag')
      	         	  ->setAttrib('class','inp1')
      	         	  ->setAttrib('style','width:130px')
      	         	  ->addFilters(array('StringTrim'))
      	         	  ->setValue('')
      	        	  ->setRequired(false);
      	      
      	$CreatedDate = $this->createElement('text','CreatedDate');
    	$CreatedDate->removeDecorator('HtmlTag')
    			    ->setAttrib('class','datepicker')
    			    ->setAttrib('readonly','readonly')
    			    ->setAttrib('style','width:130px')
    			    ->addFilters(array('StringTrim'))
    		        ->removeDecorator('Label');
    		        
    	$EndDate = $this->createElement('text','EndDate');
    	$EndDate->removeDecorator('HtmlTag')
    		     ->setAttrib('class','datepicker2')
    		     ->setAttrib('readonly','readonly')
    		     ->setAttrib('style','width:130px')
    		     ->addFilters(array('StringTrim'))
    	         ->removeDecorator('Label');
			        
		$this->addElements(array($usertype,
								 $state,
								 $region,
								 $city,
								 $stateid,
								 $regionid,
								 $cityid,
								 $campaign,
								 $restgroupname,
								 $CreatedDate,
								 $EndDate,
								 $restname	 							
						));
    }
}