<?php
class Payments_PaymentController extends Zend_Controller_Action
{
	protected $_paymentService = null;
	 
	public function init()
	{
		if(!$this->_paymentService){
			$this->_paymentService = new Application_Service_Payment();
		}	
	}
	
	public function indexAction()
	{
		
	}
	
	public function restpaymentsubscriptionAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				$resServ = new Application_Service_Restaurant();
				if($request->restaurantid){
					$resStat = $resServ->AuthenticateRestByAuth($data,$request->restaurantid);
				}else{
					$resStat = false;
				}
				
				$this->view->secureLoginStatus = $resStat;
				if($resStat){
					$this->_helper->layout()->setLayout('restaurantuserlayout');				
					
					$planId = $this->_paymentService->getPaymentPlan($request->restaurantid);
					if($planId){
						$this->_helper->redirector('paymentterms','Payment', 'Payments',array('restaurantid' => $request->restaurantid,'planid'=>$planId));				
					} else {
						$planId = "";
						$result = $this->_paymentService->Manage_Rest_AuthNet_Subscription($request);
						$subscriptionPlans = $this->_paymentService->GetSubscriptionPlans($planId,false);
						$this->view->restaurantId = $request->restaurantid;
						$this->view->customerProfileId  = $result['CustProfId']; 
						$this->view->paymentProfiles    = $result['PaymentProfiles'];
						$this->view->authNetPaymentInfo = $result['CC_AC_Details'];	
						$this->view->subscriptionPlans  = $subscriptionPlans;
					}
				}
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}		
	}
	
	public function getsubscriptionplanajaxAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$planId = $request->PlanId;
				$subscriptionPlan = $this->_paymentService->GetSubscriptionPlans($planId,true);
				echo json_encode($subscriptionPlan);
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function managerestpaymentprofileAction()
	{
		try {
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$restNameList = "";
				$restaurantService = new Application_Service_Restaurant();
				if($data['Usertype'] == "RSO"){
					$restNameList = $restaurantService->GetRestNameById($data);
				}else if($data['Usertype'] == "RSU"){
					$restNameList = $restaurantService->GetRestNameById($data);
				}
				$this->_helper->layout()->setLayout('restaurantuserlayout');				
				
				$request = $this->getRequest();
				
				$result = $this->_paymentService->Manage_Rest_AuthNet_Subscription($request);
				$this->view->restaurantId = $request->restaurantid;
				$this->view->restNameList = $restNameList;
				$this->view->customerProfileId  = $result['CustProfId']; 
				$this->view->paymentProfiles    = $result['PaymentProfiles'];
				$this->view->authNetPaymentInfo = $result['CC_AC_Details'];
				
				if(isset($request->popupStatus)){
					$this->view->popupStatus = 1;
				}
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}						
		} catch (Exception $ex) {
			throw new Exception($ex->getMessage());
		}
	}
	
	public function getauthnettokenAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$token = $this->_paymentService->Get_AuthNet_HostedProfPage_Token($request);
				echo json_encode($token);
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}		
	}
	
	public function getauthnettokencustomerAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$token = $this->_paymentService->Get_AuthNet_HostedProfPage_Token($request);
			echo json_encode($token);
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}		
	}
	
	public function addrestpaymentmapAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$status = $this->_paymentService->Add_PaymentProfile_And_SubscriptionPlan_ToRestaurant($request);
				if($status){
					$this->_helper->redirector('paymentterms','Payment', 'Payments',array('restaurantid' => $request->restaurantid,'planid'=>$request->planid));
				}	
				
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}		
	}
	
	public function managepaymentprofileAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout()->setLayout('restaurantuserlayout');				
				$request = $this->getRequest();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				if($data['Usertype'] == "RSO"){
					$form = $this->_paymentService->getSearchPaymentProfileForm();
					$this->view->form = $form;
					$result = $this->_paymentService->Manage_Rest_AuthNet_Subscription($request);
					$this->view->customerProfileId = $result['CustProfId'];
					if($this->getRequest()->isPost()){
						$formData = $this->getRequest()->getPost();
						$searchResult = $this->_paymentService->searchPaymentProfiles($formData);
						$this->view->paymentProfiles = $searchResult;
						$this->view->formData = $formData;
					}else {
						$this->view->paymentProfiles   = $result['PaymentProfiles'];	
					}
					$this->view->authNetPaymentInfo = $result['CC_AC_Details'];
					$this->view->userbreach = false;
				}else if($data['Usertype'] == "RSU"){
					$this->view->userbreach = true;
				}else if($data['Usertype'] == "ADM" || $data['Usertype'] == "ADU"){
					$form = $this->_paymentService->getSearchPaymentProfileForm();
					$this->view->form = $form;
					$result = $this->_paymentService->Manage_Rest_AuthNet_Subscription($request);
					$this->view->customerProfileId = $result['CustProfId'];
					if($this->getRequest()->isPost()){
						$formData = $this->getRequest()->getPost();
						$searchResult = $this->_paymentService->searchPaymentProfiles($formData);
						$this->view->paymentProfiles = $searchResult;
						$this->view->formData = $formData;
					}else {
						$this->view->paymentProfiles   = $result['PaymentProfiles'];	
					}
					$this->view->authNetPaymentInfo = $result['CC_AC_Details'];
					$this->view->userbreach = false;
				}
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function viewtransactionsAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$page = $this->_request->getParam('page');
				if (empty($page)){
					$page = 1;
				}
				$this->_helper->layout()->setLayout('restaurantuserlayout');				
				$request = $this->getRequest();
				$form = $this->_paymentService->getSearchTransactionForm();
				$this->view->form = $form;
				$customerProfileID = $this->_paymentService->getCustomerProfileID();
				$paymentProfileIDs = $this->_paymentService->getPaymentProfileIDs($customerProfileID);
				$form->paymentProfileId->addMultiOptions($paymentProfileIDs);
				if($this->getRequest()->isPost()){
					$formData = $this->getRequest()->getPost();
					$this->view->formData = $formData;
					$this->view->paymentProfileId = $formData['paymentProfileId'];
					$txnList = $this->_paymentService->getTransactions($customerProfileID, $formData,$page);
					$this->view->txnList = $txnList;
				} else {
					$this->view->paymentProfileId = $request->paymentProfileId;
					$data['paymentProfileId'] = $request->paymentProfileId;
					$txnList = $this->_paymentService->getTransactions($customerProfileID, $data,$page);
					$this->view->txnList = $txnList;			
				}			
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getrestpaymentprofilemapAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$restNames = $this->_paymentService->getRestPaymentProfileMap($request);
				
				$jsonObj = json_encode($restNames);
				echo $jsonObj;
				
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}	
	}
	
	public function paymenttermsAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			$restaurantid = "";
			$invoiceid	  = "";
			$planId		  = "";
			if($auth->hasIdentity()){
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$request = $this->getRequest();
				if($request->isPost()){
					$formData = $this->getRequest()->getPost();
					$result = $this->_paymentService->RestSubscribtionTransaction($formData);
					if($result['status']){
						$this->_helper->redirector('paymentconfirm','Payment', 'Payments',array('restaurantid' => $formData['restaurantid'],'amount'=>$result['amount']));
					}else{
						$this->view->paymentForm  = $result['form'];
						$this->view->restaurantid = $formData['restaurantid'];
						$invoiceid = $formData['invoiceNum']; 
						$restaurantid = $formData['restaurantid']; 
					}
				}else{
					$restaurantid = $request->restaurantid;
					$this->view->restaurantid = $request->restaurantid;
					if($request->invoiceid){
						$invoiceid = $request->invoiceid;	
					}
					
					$this->view->invoiceid   = $invoiceid; 
					$this->view->paymentForm = $this->_paymentService->getPaymentTermsForm();
					
				}
				if($request->planid){
					$PlanDet = $this->_paymentService->GetSubscriptionPlans($request->planid,true);
					$this->view->PlanDet = $PlanDet;	
				}else{
					$planId = $this->_paymentService->GetPlanIdByRestId($request);
				}
				
				
				$this->view->dueAmount = $this->_paymentService->GetDueAmount($restaurantid);				
				$this->view->planid = $planId;
				
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){

			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function paymentconfirmAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage   = new Zend_Auth_Storage_Session();
				$request = $this->getRequest();
		    	$data 	   = $storage->read();
		    	$ownerName = $data['Firstname']." ".$data['LastName'];
		    	$this->view->ownerName = $ownerName;
		    	$this->view->amount = $request->amount;
		    	$this->view->restaurantid = $request->restaurantid;
				$this->_helper->layout()->setLayout('restaurantuserlayout');
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function manageinvoiceAction()
	{
		try{
			$auth = Zend_Auth::getInstance();			
			if($auth->hasIdentity()){
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$formData = array();
				$request = $this->getRequest();
				if($request->isPost()){
					$formData = $this->getRequest()->getPost();
				}
				$result = $this->_paymentService->ManageInvoice($formData);
				$this->view->invoiceResults = $result['rowset'];
				$form = $this->_paymentService->getManageInvoiceForm();
				
				if($result['form']){
					$form->populate($result['form']);	
				} 
				$this->view->manageInvoiceForm = $form;
					
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}		
	} 
	
	public function updaterestpaymentprofAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$auth = Zend_Auth::getInstance();			
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$status  = $this->_paymentService->updatePaymentProfile($request);
				if($status)
				{
					echo 't';
				}else{
					echo 'f';
				}				
				//$this->_helper->redirector('restaurantconsole','User', 'Ums',array('updatestatus'=>$status));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function managepaymentsettingsAction()
	{
		try{
			$auth = Zend_Auth::getInstance();			
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$request = $this->getRequest();
				
				
				$restService = new Application_Service_Restaurant();
				if($this->getRequest()->isPost()){
					
					$result = $this->_paymentService->ManagePaymentSettings($this->getRequest()->getPost(),$data,$request);
					if($result['formStatus'] != 'error'){
						
						$this->view->formStatus = $result['formStatus'];
						
					
						if($data['Usertype'] == "RSO" || $data['Usertype'] == "ADM" || $data['Usertype'] == "ADU"){
							$restNameList = $restService->GetRestNameById($data);
						}else if($data['Usertype'] == "RSU"){
							$restNameList = $restService->GetRestNameById($data);
						}
						$form = $this->_paymentService->getManagePaymentSettingsForm();
						$editform = $this->_paymentService->getEditPaymentSettingsForm();
						$form->restaurantName->addMultiOptions($restNameList);
						$this->view->form = $form;
						$this->view->editform = $editform;
						$this->view->actionForm = $request->formStat;
					}else{
						$operation = $request->formStat;
						switch($operation){
							case 'ADD':
								$editform = $this->_paymentService->getEditPaymentSettingsForm();
								$this->view->formStatus = $result['formStatus'];
								$this->view->form = $result['result'];
								$this->view->dateStatus = $request->settingDate;
								$this->view->editform = $editform;
								$this->view->actionForm = $request->formStat;
							break;
							case 'EDIT':
								if($data['Usertype'] == "RSO" || $data['Usertype'] == "ADM" || $data['Usertype'] == "ADU"){
									$restNameList = $restService->GetRestNameById($data);
								}else if($data['Usertype'] == "RSU"){
									$restNameList = $restService->GetRestNameById($data);
								}
								$form = $this->_paymentService->getManagePaymentSettingsForm();
								$form->restaurantName->addMultiOptions($restNameList);
								$this->view->formStatus = $result['formStatus'];
								$this->view->dateStatus = $request->editsettingDate;
								$this->view->editform = $result['result'];
								$this->view->form = $form;
								$this->view->actionForm = $request->formStat;
							break;
						}
						
					}
				}else{
					$form = $this->_paymentService->getManagePaymentSettingsForm();
					$editform = $this->_paymentService->getEditPaymentSettingsForm();
					
					if($data['Usertype'] == "RSO" || $data['Usertype'] == "ADM" || $data['Usertype'] == "ADU"){
						$restNameList = $restService->GetRestNameById($data);
					}else if($data['Usertype'] == "RSU"){
						$restNameList = $restService->GetRestNameById($data);
					}
					$form->restaurantName->addMultiOptions($restNameList);
					$this->view->formStatus = false;
					$this->view->actionForm = false;
					$this->view->form = $form;
					$this->view->editform = $editform;
				}
				$paymentsettingDetails = $this->_paymentService->GetPaymentSettings($data);
				$this->view->paymentDetails = $paymentsettingDetails;
									
			}else{
				$this->_helper->redirector('login','Auth','Ums');
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function editpaymentsettingstatusAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$auth = Zend_Auth::getInstance();			
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$status  = $this->_paymentService->updatePaymentSettingStatus($request);
				if($status){
					$this->_helper->redirector('managepaymentsettings','Payment', 'Payments');
				}				
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function managecustomerprofileonreservationAction()
	{
		//Uss_Logger_FileLogger::info('Step 0');
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$auth = Zend_Auth::getInstance();			
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$customer = new Ums_Model_Customer();
				$customer->setUserid($request->userid);		
				//Uss_Logger_FileLogger::info('Step 1');
				$userMapper = new Ums_Model_UserDataMapper();
				$userDet = $userMapper->getCustomerNameandEmailByUserId($request->userid);
				$customer->setEmail($userDet->usremail);
				//Uss_Logger_FileLogger::info('Step 2');	
				if($request->curDate){
					$date = $request->curDate;
				}else{
					$date = date('m-d-Y');
				}
				$mapper = new Booking_Model_BookingDataMapper();
				$bokid = $mapper->GetBookingIdByBookPhrase($request->bokid);
				$resid = $request->restaurantid;
				$status  = $this->_paymentService->Manage_Customer_Registration_On_Reservation($customer);
				$from = 'restaurant';
				$bookingStatus = $this->_paymentService->ManagePaidReservations($bokid,$resid,$status,$from);
				$paymentId = array();
				$paymentProfResult = $status['PaymentProfiles'];
		   		if($paymentProfResult){
		   			foreach($paymentProfResult as $row){
		   				$paymentId[] = $row->anppid;
		   			}
		   		}
				if($paymentId){
					return $this->_helper->redirector($request->blkreturnAction,'Booking','Booking',array('restaurantid' => $resid,'date'=> $date,'bokstat'=>true));
				}else{
					return $this->_helper->redirector($request->blkreturnAction,'Booking','Booking',array('restaurantid' => $resid,'date'=> $date,'bokstat'=>'err'));
				}				
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}		
	}	
	
	public function managecustomerprofileoncustomerreservationAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$auth = Zend_Auth::getInstance();			
			$request = $this->getRequest();
			$customer = new Ums_Model_Customer();
			$customer->setUserid($request->userid);		

			$userMapper = new Ums_Model_UserDataMapper();
			$userDet = $userMapper->getCustomerNameandEmailByUserId($request->userid);
			$customer->setEmail($userDet->usremail);
			
			if($request->curDate){
				$date = $request->curDate;
			}else{
				$date = date('m-d-Y');
			}
			$bokid = $request->bokid; 
			$mapper = new Booking_Model_BookingDataMapper();
			$bokid = $mapper->GetBookingIdByBookPhrase($request->bokid);
			$resid = $request->restaurantid;
			$status  = $this->_paymentService->Manage_Customer_Registration_On_Reservation($customer);
			$from = 'customer';
			$bookingStatus = $this->_paymentService->ManagePaidReservations($bokid,$resid,$status,$from);
			$paymentId = array();
			$paymentProfResult = $status['PaymentProfiles'];
	   		if($paymentProfResult){
	   			foreach($paymentProfResult as $row){
	   				$paymentId[] = $row->anppid;
	   			}
	   		}
			if($paymentId){
				if($request->blkreturnAction == 'bookingconfirmation'){						
					return $this->_helper->redirector($request->blkreturnAction,'Booking','Booking',array('bokid'=>$request->bokid,'bokstat'=>true));
				}else{
					return $this->_helper->redirector($request->blkreturnAction,'Booking','Booking',array('bokid'=>$request->bokid,'resid' => $resid,'bokstat'=>true));
				}
			}else{
				if($request->blkreturnAction == 'bookingconfirmation'){						
					return $this->_helper->redirector($request->blkreturnAction,'Booking','Booking',array('bokid'=>$request->bokid,'bokstat'=>'err'));
				}else{
					return $this->_helper->redirector($request->blkreturnAction,'Booking','Booking',array('bokid'=>$request->bokid,'resid' => $resid,'bokstat'=>'err'));
				}
			}				
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}		
	}

	public function spltrasactiononcustomerreservationAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$auth = Zend_Auth::getInstance();			
			$request = $this->getRequest();
			$customer = new Ums_Model_Customer();
			$customer->setUserid($request->userid);		

			$userMapper = new Ums_Model_UserDataMapper();
			$userDet = $userMapper->getCustomerNameandEmailByUserId($request->userid);
			$customer->setEmail($userDet->usremail);
			
			if($request->curDate){
				$date = $request->curDate;
			}else{
				$date = date('m-d-Y');
			}
			$mapper = new Booking_Model_BookingDataMapper();
			$bokid = $mapper->GetBookingIdByBookPhrase($request->bokid);
			$resid = $request->restaurantid;
			$status  = $this->_paymentService->Manage_Customer_Registration_On_Reservation($customer);
			$from = 'customer';
			$bookingStatus = $this->_paymentService->ManageSplPaidReservations($bokid,$resid,$request->specialid,$status,$from);
			$paymentId = array();
			$paymentProfResult = $status['PaymentProfiles'];
	   		if($paymentProfResult){
	   			foreach($paymentProfResult as $row){
	   				$paymentId[] = $row->anppid;
	   			}
	   		}
	   		
	   		
	   		if($paymentId){
	   			
	   		}
	   		
			if($paymentId){
				if($request->blkreturnAction == 'bookingconfirmation'){						
					return $this->_helper->redirector($request->blkreturnAction,'Booking','Booking',array('bokid'=>$request->bokid,'bokstat'=>true));
				}else{
					return $this->_helper->redirector($request->blkreturnAction,'Booking','Booking',array('bokid'=>$request->bokid,'resid' => $resid,'bokstat'=>true));
				}
			}else{
				if($request->blkreturnAction == 'bookingconfirmation'){						
					return $this->_helper->redirector($request->blkreturnAction,'Booking','Booking',array('bokid'=>$request->bokid,'bokstat'=>'err'));
				}else{
					return $this->_helper->redirector($request->blkreturnAction,'Booking','Booking',array('bokid'=>$request->bokid,'resid' => $resid,'bokstat'=>'err'));
				}
			}				
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}		
	}
	
	public function getpaymentstatusbyspecialAction()
	{
		try{
//			$auth = Zend_Auth::getInstance();
//			if($auth->hasIdentity()){
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$splid = $request->specialid;
				$resid = $request->restaurantid;
				
				$payStat = 'false';
				$splService = new Application_Service_Specials();	
				$splResult = $splService->GetSpecialDetailsById($request,false);
				if($splResult->getCatTypeCode() == 'SP'){
					$payStat = 'SP';
				}else if($splResult->getCatTypeCode() == 'CP'){
					$dateSplit = explode("-",$request->resdate);
					$s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
					$weekdate = date("Y-m-d", $s);
					$payResult = $this->_paymentService->GetRestaurantPaymentSettingsByResId($request->restaurantid,$weekdate);	
					$payType = '';
					if($payResult){
						$payType = $payResult['rpsnoshow_type'];
						$this->view->payType = $payType;
						$this->view->paydesc = $payResult['rpsdesc'];
						$this->view->payAmt = $payResult['payamount'];
						if($request->respax >= $payResult['paypax']){		
							$payStat = 'CP';
						}
					}
				}
				echo $payStat;
//			}else{
//				$this->_redirect('login','Auth','Ums');
//			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function managepayprofbyadminAction()
	{
		try{

			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();			
			$request = $this->getRequest();			
			$result = $this->_paymentService->Manage_Rest_AuthNet_Subscription_Admin($request);
			if($result)
			{
				echo json_encode($result);
			}else
			{
				echo json_encode('f');
			}			
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function inactivatepaymentprofAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$auth = Zend_Auth::getInstance();			
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$status  = $this->_paymentService->InActivatePaymentProfile($request);
				if($status)
				{
					echo 't';
				}else{
					echo 'f';
				}
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
}
