<?php
class Payments_Form_EditPaymentSettings extends Zend_Form
{

	public function init()
    {
		$this->setAttrib('enctype', 'multipart/form-data');
		
		$notificationList = array();
    	$notificationList[] = array('key'=>'DEF','value'=> 'All Days');
    	$notificationList[] = array('key'=>'SPL','value'=> 'Specific Day');
    	$notificationList[] = array('key'=>'RANGE','value'=> 'Date Range');
    	
		$userid = $this->createElement('hidden','userid');
    	$userid->removeDecorator('Label')
        	   ->removeDecorator('DtDdWrapper')
        	   ->removeDecorator('HtmlTag');
        	   
        $payid = $this->createElement('hidden','payid');
    	$payid->removeDecorator('Label')
        	   ->removeDecorator('DtDdWrapper')
        	   ->removeDecorator('HtmlTag');
        	   
        $resid = $this->createElement('hidden','resid');
    	$resid->removeDecorator('Label')
        	   ->removeDecorator('DtDdWrapper')
        	   ->removeDecorator('HtmlTag');
    	
		$restNameCtl = $this->createElement('text','editrestaurantName');
        $restNameCtl->removeDecorator('Label')
         		    ->removeDecorator('HtmlTag')
         		    ->setAttrib('class','inp1 required')
         		    ->setAttrib('readonly','readonly')
         		    ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select Restaurant Name.'))))
         		    ->setRequired(true);
         		    
        $setName = $this->createElement('text', 'editsettingName');
        $setName->removeDecorator('Label')
        			   ->removeDecorator('HtmlTag')
        			   ->setAttrib('maxlength', '30')
        			   ->setAttrib('class','inp1 required')
        			   ->addFilters(array('StringTrim'))        			   
        			   ->setValue('')
        			   ->setRequired(false); 		    

        $notificationType = $this->createElement('text', 'editsettingType');
		$notificationType->removeDecorator('Label')
			   		  	 ->removeDecorator('HtmlTag')
						 ->setAttrib('maxlength', '30')
						 ->setAttrib('readonly','readonly')
        			   	 ->setAttrib('class','inp1 required')
        			   	 ->addFilters(array('StringTrim'))  
			   		  	 ->setRequired(true);

		$noshowType = $this->createElement('text', 'editnoshowType');
		$noshowType->removeDecorator('Label')
			   		->removeDecorator('HtmlTag')
					->setAttrib('maxlength', '30')
					->setAttrib('readonly','readonly')
        			->setAttrib('class','inp1 required')
        			->addFilters(array('StringTrim'))  
			   		->setRequired(true);
			   		  	 
        $resDate = $this->createElement('text','editsettingDate');
    	$resDate->removeDecorator('HtmlTag')
    			 ->setAttrib('class','datepicker1 resDatePicker')
    			 ->setAttrib('readonly','readonly')
    			 ->addFilters(array('StringTrim'))
    			 ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select Date.'))))
    		     ->removeDecorator('Label'); 

    	$resDate1 = $this->createElement('text','editsettingDateEnd');
    	$resDate1->removeDecorator('HtmlTag')
    			 ->setAttrib('class','datepicker2 resDatePicker')
    			 ->setAttrib('readonly','readonly')
    			 ->addFilters(array('StringTrim'))
    			 ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select Date.'))))
    		     ->removeDecorator('Label'); 
         		  
       	$firstName =  $this->createElement('text', 'editamount');
        $firstName->removeDecorator('Label')
        		  ->removeDecorator('HtmlTag')        		
        		  ->setAttrib('class','inp1 required')
        		  ->addFilters(array('StringTrim'))
                  ->setAttrib('maxlength', '6')
        		  ->addValidator(new Zend_Validate_Float())
        		  ->addValidator('GreaterThan',new Zend_Validate_GreaterThan(0),array('min' => 0,'messages'=>'Please enter values greater than 0'))
        		  ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please enter Amount.'))))
        		  ->setValue('')
                  ->setRequired(true);
        
        $lastName = $this->createElement('text', 'editpartysize');
        $lastName->removeDecorator('Label')
        		 ->removeDecorator('HtmlTag')
        		 ->setAttrib('class','inp1 required')
        		 ->addFilters(array('StringTrim'))
        		 ->setAttrib('maxlength', '6')
        		  ->addValidator('Digits',new Zend_Validate_Digits(),array('messages' => 'Please enter Numbers only'))
        		  ->addValidator('GreaterThan',new Zend_Validate_GreaterThan(0),array('min' => 0,'messages'=>'Please enter values greater than 0'))
        		  ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please enter Party Size.'))))
        		 ->setValue('')
                 ->setRequired(true);

        $editpaymentdesc = $this->createElement('textarea', 'editpaymentdesc');
        $editpaymentdesc->removeDecorator('Label')
        			   ->removeDecorator('HtmlTag')
        			   ->setAttrib('maxlength', '120')
        			   ->setAttrib('rows', '4')
        			   ->setAttrib('style', 'width:230px;')
        			   ->addFilters(array('StringTrim'));
                 
                      
        $this->addElements( array ($userid,
        						   $payid,
        						   $resid,
        						   $restNameCtl,
        						   $firstName,
        						   $lastName,
        						   $setName,
        						   $resDate,
        						   $resDate1,
        						   $notificationType,
        						   $noshowType,
        						   $editpaymentdesc
        				));
    }
}