<?php
class Payments_Form_ManagePaymentSettings extends Zend_Form
{

	public function init()
    {
		$this->setAttrib('enctype', 'multipart/form-data');
		
   	 	$notificationList = array();
    	$notificationList[] = array('key'=>'DEF','value'=> 'All Days');
    	$notificationList[] = array('key'=>'SPL','value'=> 'Specific Day');
    	$notificationList[] = array('key'=>'RANGE','value'=> 'Date Range');
    	
    	$TypeList = array();
    	$TypeList[] = array('key'=>'PAX','value'=> 'Per Seat');
    	$TypeList[] = array('key'=>'RESERV','value'=> 'Per Party');
    	
		$userid = $this->createElement('hidden','userid');
    	
		$restNameCtl = $this->createElement('select','restaurantName');
        $restNameCtl->removeDecorator('Label')
         		    ->removeDecorator('HtmlTag')
         		    ->setAttrib('class','sel1 drpDown')
         		    ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please select Restaurant Name.'))))
         		    ->setRegisterInArrayValidator(false)
         		    ->setRequired(true);
         		    
        $setName = $this->createElement('text', 'settingName');
        $setName->removeDecorator('Label')
        			   ->removeDecorator('HtmlTag')
        			   ->setAttrib('maxlength', '30')
        			   ->setAttrib('class','inp1 required')
        			   ->addFilters(array('StringTrim'))        			   
        			   ->setValue('')
        			   ->setRequired(true); 		    

        $resDate = $this->createElement('text','settingDate');
    	$resDate->removeDecorator('HtmlTag')
    			 ->setAttrib('class','datepicker resDatePicker')
    			 ->setAttrib('readonly','readonly')
    			 ->addFilters(array('StringTrim'))
    		     ->removeDecorator('Label');
    		     
    	$resDate1 = $this->createElement('text','settingDateEnd');
    	$resDate1->removeDecorator('HtmlTag')
    			 ->setAttrib('class','datepicker2 resDatePicker')
    			 ->setAttrib('readonly','readonly')
    			 ->addFilters(array('StringTrim'))
    		     ->removeDecorator('Label');
    		     
       	$amount =  $this->createElement('text', 'amount');
        $amount->removeDecorator('Label')
        		  ->removeDecorator('HtmlTag')        		
        		  ->setAttrib('class','inp1')
        		  ->addFilters(array('StringTrim'))
                  ->setAttrib('maxlength', '6')
                  ->addValidator('GreaterThan',new Zend_Validate_GreaterThan(0),array('min' => 0,'messages'=>'Please enter values greater than 0'))
                  ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please enter Amount.'))))
        		  ->addValidator(new Zend_Validate_Float(),array('messages' => 'Please enter integer or float'))        		  
        		  ->setValue('')
                  ->setRequired(true);
        
        $notificationType = $this->createElement('select','settingType');
		$notificationType->removeDecorator('Label')
			   		  	 ->removeDecorator('HtmlTag')
			   		  	 ->setMultiOptions($notificationList)
			   		  	 ->setValue('sms')
			   		  	 ->setSeparator(' ')
			   		  	 ->setRequired(false);
			   		  	 
      	$noshowType = $this->createElement('select','noshowType');
		$noshowType->removeDecorator('Label')
					->removeDecorator('HtmlTag')
			   		->setMultiOptions($TypeList)
			   		->setValue('sms')
			   		->setSeparator(' ')
			   		->setRequired(false);
			   		  	 
        $partySize = $this->createElement('text', 'partysize');
        $partySize->removeDecorator('Label')
        		 ->removeDecorator('HtmlTag')
        		 ->setAttrib('class','inp1')
        		 ->addFilters(array('StringTrim'))
        		 ->setAttrib('maxlength', '6')
        		  ->addValidator('Digits',new Zend_Validate_Digits(),array('messages' => 'Please enter Numbers only'))
        		  ->addValidator('GreaterThan',new Zend_Validate_GreaterThan(0),array('min' => 0,'messages'=>'Please enter values greater than 0'))
        		  ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please enter Party Size.'))))
        		 ->setValue('')
                 ->setRequired(true);
                 
        $paymentdesc = $this->createElement('textarea', 'paymentdesc');
        $paymentdesc->removeDecorator('Label')
        			   ->removeDecorator('HtmlTag')
        			   ->setAttrib('maxlength', '120')
        			   ->setAttrib('rows', '4')
        			   ->setAttrib('style', 'width:230px;')
        			   ->addFilters(array('StringTrim'));
                 
                      
        $this->addElements( array ($userid,
        						   $restNameCtl,
        						   $setName,
        						   $amount,
        						   $resDate,
        						   $resDate1,
        						   $partySize,
        						   $notificationType,
        						   $noshowType,
        						   $paymentdesc
        				));
    }
}