<?php
class Payments_Model_RestaurantPaymentPlanMapMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Payments_Model_DbTable_RestaurantPaymentPlanMap');
		}
		return $this->_dbTable;
	}
	
	public function SaveSubscriptionPlanOfRestaurant(Payments_Model_RestaurantPaymentPlanMap $object)
	{
		try {
			$status = false;
			$db = Zend_Db_Table::getDefaultAdapter();
			$table = $this->getDbTable();
			$data = array('rppmpayment_plan_id'	=> $object->getrppmpayment_plan_id(),
						  'rppmrestaurant_id' => $object->getrppmrestaurant_id(),
						  'rppmplan_activation_date' => $object->getrppmplan_activation_date(),
						  'rppmplan_enddate' => $object->getrppmplan_enddate(),
						  'rppmstatus' => $object->getrppmstatus()
			);
			$rowid = $table->insert($data);
			if($rowid)
				$status = true;
			return $status;
		}catch (Exception $ex) {
			throw new Exception($ex->getMessage());
		}
	}

	public function getPaymentPlan($resId){
		try {
			$planId = false;
			$table  = $this->getDbTable();
			$select = $table->select();

			$select->from(array('rpplanm' => 'mt.restaurant_payment_plan_map'), array('rppmpayment_plan_id as planid'))
					->join(array('rauthppm' => 'mt.rest_authnet_payment_profile_map'), 'rauthppm.rappmrestaurant_id = rpplanm.rppmrestaurant_id', array())
					->join(array('authpp' => 'mt.authnet_payment_profile'), 'authpp.anppid = rauthppm.rappmpayment_profile_id', array())
					->where('authpp.anppstatus = 1')
					->where('rpplanm.rppmrestaurant_id = ?',$resId);
			$rowSet = $table->fetchAll($select);
			if($rowSet){
				foreach ($rowSet as $row){
					$planId = $row->planid;
				}
			}
			return $planId;
		}catch (Exception $ex) {
			throw new Exception($ex->getMessage());
		}	
	}
}