<?php
class Payments_Model_SubscriptionPaidMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Payments_Model_DbTable_SubscriptionPaid');
		}
		return $this->_dbTable;
	}
	
	public function saveSubscriptionPaidDetails(Payments_Model_SubscriptionPaid $subscriptionPaidObject)
	{
		try{
			$data = array('subprestaurant_id'    => $subscriptionPaidObject->getsubprestaurant_id(),
						  'subpbilling_date'     => $subscriptionPaidObject->getsubpbilling_date(),
						  'subpamount'		     => $subscriptionPaidObject->getsubpamount(),
						  'subpplan_id'		  	 => $subscriptionPaidObject->getsubpplan_id(),
						  'subpbilling_fromdate' => $subscriptionPaidObject->getsubpbilling_fromdate(),
						  'subpbilling_todate'	 => $subscriptionPaidObject->getsubpbilling_todate(),
					      'subptransaction_id'	 => $subscriptionPaidObject->getsubptransaction_id(),
						  'subp_status'			 => $subscriptionPaidObject->getsubp_status()
						  );
						  
		  	$table  = $this->getDbTable();
		  	$subpid = $table->insert($data);
		  	
		  	return $subpid;
		  	
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}