<?php
class Payments_Model_UListPostTransactionsMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Payments_Model_DbTable_UListPostTransactions');
		}
		return $this->_dbTable;
	}
	
	public function saveTransactionDetails(array $objectArray)
	{
		try{
			
			$db = Zend_Db_Table::getDefaultAdapter();
			$db->beginTransaction();
			$status = false;
			
			$UListPostTransactions = $objectArray['txnObject'];		
			
			$data = array('ulptxn_post_id' 		      => $UListPostTransactions->getulptxn_post_id(),
						  'ulptxn_transaction_id'     => $UListPostTransactions->getulptxn_transaction_id(),
						  'ulptxn_invoice_number' 	  => $UListPostTransactions->getulptxn_invoice_number(),
						  'ulptxn_payment_profile_id' => $UListPostTransactions->getulptxn_payment_profile_id(),
						  'ulptxn_transaction_amount' => $UListPostTransactions->getulptxn_transaction_amount(),
						  'ulptxn_transaction_date'	  => $UListPostTransactions->getulptxn_transaction_date(),
						  'ulptxn_transaction_time'	  => $UListPostTransactions->getulptxn_transaction_time(),
						  'ulptxn_description'		  => $UListPostTransactions->getulptxn_description(),
						  'ulptxn_transaction_type'   => $UListPostTransactions->getulptxn_transaction_type(),
						  'ulptxn_status'             => $UListPostTransactions->getulptxn_status());
			
			/* Save txn details */
			
			$table = $this->getDbTable();			
			$txnid = $table->insert($data);
			
			/* Update Invoice status from unpaid to paid */
			$UListUpdatePostInvoiceStatusById = $objectArray['updateInveStatusObj'];
			$UListPostInvoiceMapper = new Payments_Model_UListPostInvoiceMapper();
			$invoice_rows_affected = $UListPostInvoiceMapper->UpdatePostInvoiceStatusById($UListUpdatePostInvoiceStatusById);
			
			/* Update Post Status */
			
			 $UlistPostDataMapper = new UList_Model_UlistPostDataMapper();
			 $post_rows_affected = $UlistPostDataMapper->updatePostPaymentStatusByPostId($UListPostTransactions->getulptxn_post_id());	
			 	
			 $db->commit();
			
			$status = true;
			return $status;
			
		}catch(Exception $ex){
			$db->rollBack();
			throw new Exception($ex->getMessage());
		}
	}
	
}