<?php
class Phone_Form_ContactUs extends Zend_Form{
	
	public function init()
    {
    	$contact = array();
    	
    	$contact[] = array('key'=>'email','value'=>' Email');
    	$contact[] = array('key'=>'phone','value'=>' Phone');
    	
		$this->setAttrib('enctype', 'multipart/form-data');
		
        $contactName = $this->createElement('text', 'contactName');
        $contactName->removeDecorator('Label')
        			->removeDecorator('HtmlTag')
        			->setAttrib('maxlength', '100')
        			->setAttrib('class','input w90 required')
					->setAttrib('placeholder','Contact Name')
        			->addFilters(array('StringTrim'))
        	  		->addValidators(array(array('NotEmpty', true, array('messages' => ' *Required fields'))))         			   
        			->setValue('')
        			->setRequired(true);  

         $phone = $this->createElement('text', 'phone');
         $phone->removeDecorator('Label')
         		  ->removeDecorator('HtmlTag')                  
                  ->setAttrib('class','input w90')
				  ->setAttrib('placeholder','Phone')             
                  ->setAttrib('maxlength', '15')
                  ->addFilters(array('StringTrim'))
                  ->addValidators(array(array('NotEmpty', true, array('messages' => ' *Required fields'))))
                  ->setValue('')              
                  ->setRequired(false);                       
                       
        $emailAddress =  $this->createElement('text', 'emailAddress');
        $emailAddress->removeDecorator('Label')
        			 ->removeDecorator('HtmlTag')        			     
        			 ->setAttrib('maxlength', '40')
        			 ->setAttrib('class','input w90')
				  ->setAttrib('placeholder','Email')
                	 ->addValidators(array(array('NotEmpty', true, array('messages' => ' *Required fields')),
                	 				array('StringLength', false,array(5,40))))
                	 ->addValidator('EmailAddress')    
                	 ->addFilters(array('StringTrim'))
               		 ->setRequired(true);

        
        $comments = $this->createElement('textarea', 'comments');
        $comments->removeDecorator('Label')
        			   ->removeDecorator('HtmlTag')
        			   ->setAttrib('maxlength', '1000')
        			   ->setAttrib('rows', '3')
        			   ->setAttrib('cols', '25')
        			   ->setAttrib('class','input w90 textarea')
        			   ->addFilters(array('StringTrim'))
        			   ->addValidators(array(array('NotEmpty', true, array('messages' => ' *Required fields'))))
        			   ->setRequired(true);         		

       
        $contactType = new Zend_Form_Element_Radio('contactType');
		$contactType->removeDecorator('Label')
			   		 	 ->removeDecorator('HtmlTag')
			   		  	 ->setMultiOptions($contact)
			   		  	 ->setValue('email')
			   		  	 ->setSeparator('&nbsp;&nbsp;&nbsp;')
			   		  	 ->setRequired(false);        		
		
        $submit = $this->createElement('button','submit');
        $submit->removeDecorator('Label')
        		  ->removeDecorator('DtDdWrapper')
        		  ->setValue('Submit')           		          		        		
        		  ->setAttrib('class','submitBtn')
                  ->setIgnore(true);
                  
		$type = $this->createElement('hidden','type');
    	$type->removeDecorator('HtmlTag')
    		  		 ->removeDecorator('Label');                  
		                	
          $this->addElements( array ($contactName,
          							 $phone,
          							 $emailAddress,
          							 $comments,
          							 $contactType,
          							 $type,
          							 $submit));
        	  
    }

}