<?php
class Reservation_Form_AddCustomerContact extends Zend_Form
{

	public function init()
    {
		$this->setAttrib('enctype', 'multipart/form-data');
    	 
		$gengerList   = array(
    	 		array('key'=>'Male','value'=>'Male'),
    	 		array('key'=>'Female','value'=>'Female')    	 
    	 );
    	 
    	$stateMapper  = new Application_Model_StateDataMapper();
    	$states = $stateMapper->fetchAll();
    	$stateList = array();  
    	$stateList[] = array('key'=>'','value'=>'Select State');  	   
    	foreach($states as $state){
    		$stateList[] = array('key'=>$state->getId(),'value'=>$state->getDescription());
    	} 
    	 
    	$userid = $this->createElement('hidden','userid');
    	$id = $this->createElement('hidden','addcontact');
    	$id->removeDecorator('Label')
         		 ->removeDecorator('HtmlTag')
         		 ->setValue('addcontact');
         		    
    	
		$restNameCtl = $this->createElement('hidden','RestaurantName');
        $restNameCtl->removeDecorator('Label')
         		    ->removeDecorator('HtmlTag');
         		    
        $groupName = $this->createElement('hidden','GroupName');
        $groupName->removeDecorator('Label')
         		  ->removeDecorator('HtmlTag');
         		  
       	$firstName =  $this->createElement('text', 'confName');
        $firstName->removeDecorator('Label')
        		  ->removeDecorator('HtmlTag')        		
        		  ->setAttrib('maxlength', '30')
        		  ->setAttrib('class','inp1 required')
        		  ->addFilters(array('StringTrim'))
                  ->addValidators(array
                				(array('NotEmpty', true, array('messages' => 'Please enter your First Name.')),
                					array('StringLength', false,array(0,30)),array('Alnum')))                					 
                  ->setValue('')
                  ->setRequired(true);
        
        $lastName = $this->createElement('text', 'conlName');
        $lastName->removeDecorator('Label')
        		 ->removeDecorator('HtmlTag')
        		 ->setAttrib('maxlength', '30')
        		 ->setAttrib('class','inp1')
        		 ->addFilters(array('StringTrim'))
        		 ->addValidators(array
        		 				  (array('StringLength', false,array(0,30)),array('Alnum')
        		 				 ))
                 ->setValue('')
                 ->setRequired(false); 
                 
        $gender = $this->createElement('select','gender');
        $gender->removeDecorator('Label') 
        	   ->removeDecorator('HtmlTag')
        	   ->setAttrib('class', 'sel2')       		
               ->addMultiOptions($gengerList)
               ->setRequired(false);
        
        $email =  $this->createElement('text', 'emailAddress');
        $email->removeDecorator('Label')
        	  ->removeDecorator('HtmlTag')        			     
        	  ->setAttrib('maxlength', '50')
        	  ->setAttrib('class','inp1 email required')
              ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter your Email Address.')),
                		 				array('StringLength', false,array(5,255))))
              ->addValidator('EmailAddress')    
              ->addFilters(array('StringTrim'))
              ->setRequired(true);
                      
        $phone = $this->createElement('text', 'phone');
        $phone->removeDecorator('Label')
        	  ->removeDecorator('HtmlTag')
              ->setAttrib('class','inp1 required')              
              ->setAttrib('maxlength', '15')
              ->addFilters(array('StringTrim'))
              ->addValidators(array
                   					(array('NotEmpty', true, array('messages' => 'Please enter Your Phone Number.'))
                   				 ))
              ->setValue('')              
              ->setRequired(true);
              
       /* $mobile = $this->createElement('text','mobile');
        $mobile->removeDecorator('Label')
        	  ->removeDecorator('HtmlTag')
              ->setAttrib('class','inp1')              
              ->setAttrib('maxlength', '15')
              ->addFilters(array('StringTrim'))
              ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter your Mobile Number.')),
              				array('StringLength', false,array(0,15,'messages' => array(
              				Zend_Validate_StringLength::TOO_SHORT =>'mobile should be minimum 10 charactors',
              				Zend_Validate_StringLength::TOO_LONG => 'mobile is too long(>15).'
              				))))) 
              ->setValue('')              
              ->setRequired(true);*/
              
        $state = $this->createElement('select','state');
        $state->removeDecorator('Label') 
         		  ->removeDecorator('HtmlTag')
         		  ->setAttrib('class','sel1 drpDown required')
         		  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select State.'))))       	   
               	  ->addMultiOptions($stateList)
                  ->setRequired(true);
                  
        $city = $this->createElement('select', 'city');
        $city->removeDecorator('Label')
         	 ->removeDecorator('HtmlTag')
         	 ->setAttrib('class','sel1 drpDown required')
         	 ->setRegisterInArrayValidator(false)
         	 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select City.'))))       	     
             ->setRequired(true);
             
        $neighbourhood = $this->createElement('select', 'neighbourhood');
        $neighbourhood->removeDecorator('Label')
         			  ->setAttrib('class','sel1 drpDown required')
         		 	  ->removeDecorator('HtmlTag')
         		 	  ->setRegisterInArrayValidator(false)
         		 	  ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select Neighbourhood.'))))        	          
                 	  ->setRequired(true);
              
        $zipCode = $this->createElement('text', 'zipCode');
        $zipCode->removeDecorator('Label')  
         		   ->removeDecorator('HtmlTag')      		       
        		   ->setAttrib('class','inp1 required')
        		   ->addFilters(array('StringTrim'))
        		   ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Enter Postal Code.'))))    
                   ->addValidator('StringLength', false,array(1,10))
                   ->setValue('')
                   ->setAttrib('maxlength', '10')
                   ->setRequired(true);  
             
        $address =  $this->createElement('textarea', 'address');
        $address->removeDecorator('Label')
        		->removeDecorator('HtmlTag')
        		->setAttrib('maxlength', '200')
        		->setAttrib('cols', '40')
			    ->setAttrib('rows', '4')
			    ->setAttrib('class','inp1 required')
			    ->addFilters(array('StringTrim'))              
                ->addValidators(array
        		 				  (array('NotEmpty', true, array('messages' => 'Please enter your Address.'))))                
                ->setValue('')
                ->setRequired(true);
         
        $Submit = $this->createElement('submit','Update');
        $Submit->removeDecorator('Label')
        		   ->removeDecorator('DtDdWrapper')
        		   ->setValue('Submit')           		          		        		
        		   ->setAttrib('class','submitBtn')
                   ->setIgnore(false);
           
        $this->addElements( array ($userid,
        						   $id,
        						   $restNameCtl,
        						   $groupName,
        						   $firstName,
        						   $lastName,
        						   $gender,
        						   $email,
        						   $phone,
        						   $address,
        						   $state,
        						   $city,
        						   $neighbourhood,
        						   $zipCode,
        						   $Submit
        				));
    }
}