<?php

class Reservation_Form_ReservationDetails extends Zend_Form
{

    public function init()
    {
    	
    	$notificationTypeMapper = new Application_Model_NotificationTypeDataMapper();
    	$result = $notificationTypeMapper->fetchAll();
    	$notificationList = array();
    	$notificationList[] = array('key'=>'','value'=>'Select notification Type');
    	foreach($result  as $value){
    		$notificationList[] = array('key'=>$value->getCode(),'value'=>$value->getDescription());
    	}
    	
    	$resId = $this->createElement('hidden','resId');
    	$resId->removeDecorator('HtmlTag')
    		  ->removeDecorator('Label');
    	
    	
    	$resName = $this->createElement('hidden','resName');
    	$resName->removeDecorator('HtmlTag') 
    		    ->removeDecorator('Label');
    	
    	$resAddress = $this->createElement('hidden','resAddress');
    	$resAddress->removeDecorator('HtmlTag')
    			    ->removeDecorator('Label');
    			    
    	$bokSrcComp = $this->createElement('hidden','bokSrcComp');
    	$bokSrcComp->removeDecorator('HtmlTag')
    			    ->removeDecorator('Label');
    			    
    	$resphone = $this->createElement('hidden','resphone');
    	$resphone->removeDecorator('HtmlTag')
    			    ->removeDecorator('Label');
    	
    	$resDate = $this->createElement('hidden','resDate');
    	$resDate->removeDecorator('HtmlTag')
    		     ->removeDecorator('Label');
    	
    	$resTime = $this->createElement('hidden','resTime');
    	$resTime->removeDecorator('HtmlTag')
    	         ->removeDecorator('Label');
    	         
    	$reservationfrom = $this->createElement('hidden','reservationfrom');
    	$reservationfrom->removeDecorator('HtmlTag')
    	         ->removeDecorator('Label');
    	
    	$pax = $this->createElement('hidden','pax');
    	$pax->removeDecorator('HtmlTag')
    	     ->removeDecorator('Label');
    	
    	$userid = $this->createElement('hidden','userid');
    	$userid->removeDecorator('HtmlTag')
    	       ->removeDecorator('Label');
    	$restPax = $this->createElement('hidden','tablesize');
    	$restPax->removeDecorator('HtmlTag')
    	        ->removeDecorator('Label');
    	
        $nooftables = $this->createElement('hidden','nooftables');
    	$nooftables->removeDecorator('HtmlTag')
    	       	   ->removeDecorator('Label');
    	$inventoryid = $this->createElement('hidden','inventoryid');
    	$inventoryid->removeDecorator('HtmlTag')
    	       	    ->removeDecorator('Label');       	   
    	$bookingStatus = $this->createElement('hidden','bookingStatus');
    	$bookingStatus->setValue('RSD');
    	$bookingStatus->removeDecorator('HtmlTag')
    				  ->removeDecorator('Label');
    	
	$specialId = $this->createElement('hidden','specialid');    	
    	$specialId->removeDecorator('HtmlTag') 
    		      ->removeDecorator('Label');
    	
    	$bookType = $this->createElement('hidden','booktype');    	
    	$bookType->removeDecorator('HtmlTag') 
    		     ->removeDecorator('Label');
    	
    	$specialAmt = $this->createElement('hidden','specialamt');    	
    	$specialAmt->removeDecorator('HtmlTag') 
    		       ->removeDecorator('Label');
    		       
    	$cuscontactid = $this->createElement('hidden','cuscontactid');
    	$cuscontactid->removeDecorator('HtmlTag')
    		  		 ->removeDecorator('Label')
    		  		 ->setValue('');
		       
    	$paymentStat = $this->createElement('hidden','paymentStatus');
    	$paymentStat->removeDecorator('Label')
			        ->removeDecorator('HtmlTag');
			        
    	$numberList = array(
    		array('key'=>'mobile','value' => 'Mobile'),
    		array('key'=>'phone','value' => 'Phone')
    	);
        $firstName = $this->createElement('text', 'firstName');
        $firstName->removeDecorator('Label')
        			   ->removeDecorator('HtmlTag')
        			   ->setAttrib('maxlength', '30')
        			   ->setAttrib('class','inp1 required username')
					   ->setAttrib('placeholder', 'First Name')
        			   ->addFilters(array('StringTrim'))
        			   ->addValidator('StringLength', false,array(0,30))
        			   ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter FirstName.'))))
        			   ->setValue('')
        			   ->setRequired(true);
        $lastName = $this->createElement('text', 'lastName');
        $lastName->removeDecorator('Label')
        			   ->removeDecorator('HtmlTag')
        			   ->setAttrib('maxlength', '30')
        			   ->setAttrib('class','inp1 required username')
					   ->setAttrib('placeholder', 'Last Name')
        			   ->addFilters(array('StringTrim'))
        			   ->addValidator('StringLength', false,array(0,30))
        			    ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter LastName.'))))
        			   ->setValue('')
        			   ->setRequired(true);
        			   
        			   
        $countryCode = $this->createElement('text', 'countryCode');
        $countryCode->removeDecorator('Label')  
         			   ->removeDecorator('HtmlTag')      		       
        		       ->setAttrib('class','countrycode inp1')
        		       ->setAttrib('style','width:52px;')
        		       ->setAttrib('readonly','readonly')
        		       ->setAttrib('placeholder', 'Code')
        		       ->setAttrib('title', 'Country Code')
        		       ->addFilters(array('StringTrim'))
        		       ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select country code.'))))
        		       ->setValue('')
                       ->setAttrib('maxlength', '5');
                       
        $number = $this->createElement('text', 'number');
        $number->removeDecorator('Label')
        			   ->removeDecorator('HtmlTag')
        			   ->setAttrib('maxlength', '15')
        			   ->setAttrib('class','inp1 phnum webphone')
					   ->setAttrib('placeholder', 'Number')
        			   ->addFilters(array('StringTrim'))
        			   ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter Phone Number.'))))
        			   ->addValidator('regex', false, array('pattern' =>'/^[0-9 ]+$/','messages' => 'Enter a valid Phone Number'))
        			   ->addValidator('StringLength', false,array(0,15));
        $email = $this->createElement('text', 'email');
        $email->removeDecorator('Label')
        			   ->removeDecorator('HtmlTag')
        			   ->setAttrib('maxlength', '40')
        			   ->setAttrib('class','inp1 required webemail ignore')
					   ->setAttrib('placeholder', 'Email')
        			   ->addValidator('StringLength', false,array(0,40))
        			   ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter Email Address.'))))
        			   ->addValidator('EmailAddress',false,array('messages'=>array(Zend_Validate_EmailAddress::INVALID =>'Please enter a valid Host Name')))
					 ->addErrorMessage('Pleaes Enter Valid Email Address')
        			   ->addFilters(array('StringTrim'))
        			   ->setValue('');
       	/*$notificationType = $this->createElement('select', 'notificationType');
        $notificationType->removeDecorator('HtmlTag')
    	     ->removeDecorator('Label')
    	     ->setAttrib('class', 'required')
			 ->addMultiOptions($notificationList)
			 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Select Notification Type.')))) 
			 ->setRequired(true);*/
        $dinerRequest = $this->createElement('textarea', 'dinerRequest');
        $dinerRequest->removeDecorator('Label')
        			   ->removeDecorator('HtmlTag')
        			   ->setAttrib('maxlength', '1000')
					   ->setAttrib('placeholder', 'Special Request')
        			   ->setAttrib('rows', '5')
        			   ->setAttrib('cols', '50')
        			   ->addFilters(array('StringTrim'))        			   
        			    ->addValidators(array(array('StringLength', false,array(1,1000,'messages' => array(
              					Zend_Validate_StringLength::TOO_LONG => 'special request is too long(>1000).'
              				))))) 
        			   ->setValue('')
        			   ->setRequired(false);
        			   
        $bokoptions = $this->createElement('select','bokoptions');
    	$bokoptions->removeDecorator('HtmlTag')
    	     ->removeDecorator('Label')
    	     ->setRegisterInArrayValidator(false)
    	     ->setAttrib('class', 'sel1 inp1 form');
    	     
    	$boksecoptions = $this->createElement('select','boksecoptions');
    	$boksecoptions->removeDecorator('HtmlTag')
    	     ->removeDecorator('Label')
    	     ->setRegisterInArrayValidator(false)
    	     ->setAttrib('class', 'sel1 inp1 form');
               			
        $resSubmit = $this->createElement('submit','Submit');
        $resSubmit->removeDecorator('Label')
        		  ->removeDecorator('DtDdWrapper')
        		  ->setValue('Submit')           		          		        		
        		  ->setAttrib('class','submitBtn')
                  ->setIgnore(true);

		$resReset = $this->createElement('reset','Reset');
        $resReset->removeDecorator('Label')        		 
        		 ->setValue('Reset')
        		 ->removeDecorator('DtDdWrapper')           	  	 
        	  	 ->setAttrib('class','submitBtn')
              	 ->setIgnore(true);
        
        			   
						 
				 
		$this->addElements( array ($firstName,
									$lastName,
									$number,
									$nooftables,
									$email,
									//$notificationType,
									$dinerRequest,									
									$resId,
							    	$resName,
							    	$resAddress,
									$bokSrcComp,
							    	$resphone,
							    	$resDate,
							    	$resTime,
							    	$pax,
							    	$bookingStatus,
							    	$resSubmit,
							    	$resReset,
							    	$userid,
							    	$restPax,
							    	$inventoryid,
							    	$cuscontactid,
									$specialId,
							    	$bookType,
							    	$specialAmt,
							    	$paymentStat,
							    	$reservationfrom,
							    	$bokoptions,
							    	$boksecoptions,
							    	$countryCode
								  )		
		
		);	 
    }


}

