<?php

class Reservation_Form_WalkInReserv extends Zend_Form
{

    public function init()
    {
    	$passwordConfirm = new Uss_Validate_PasswordConfirmation();
    	
    	$paxList   = array();
    	$paxList[] = array('key'=>'Select Party Size','value'=>'Select Party Size');
    	$paxList[] = array('key'=>'1','value'=>'1 person');    	
    	for($i = 2;$i<=200;$i++){
    		$paxList[] = array('key'=>$i,'value'=>$i.' persons');
   	 	}
		
    	$notificationTypeMapper = new Application_Model_NotificationTypeDataMapper();
    	$result = $notificationTypeMapper->fetchAll();
    	$notificationList = array();
    	foreach($result  as $value){
    		$notificationList[] = array('key'=>$value->getCode(),'value'=> " ". $value->getDescription());
    	}
    	
    	$resId = $this->createElement('hidden','restaurantid');
    	$resId->removeDecorator('HtmlTag')
    		  ->removeDecorator('Label');
    	
    	$winpax = $this->createElement('select','winpax');
    	$winpax->removeDecorator('HtmlTag')
    	     ->removeDecorator('Label')
    	     ->setAttrib('class', 'sel2')
    	     ->setAttrib('title', 'Party Size')
			 ->addMultiOptions($paxList);
		
    	$winfirstName = $this->createElement('text', 'winfirstName');
        $winfirstName->removeDecorator('Label')
        			   ->removeDecorator('HtmlTag')
        			   ->setAttrib('maxlength', '30')
        			   ->setAttrib('class','inp1')
        			   ->setAttrib('title','First Name')
				   ->setAttrib('placeholder','First Name')
        			   ->addFilters(array('StringTrim'))        			   
        			   ->setValue('')
        			   ->setRequired(false);
        $winlastName = $this->createElement('text', 'winlastName');
        $winlastName->removeDecorator('Label')
        			   ->removeDecorator('HtmlTag')
        			   ->setAttrib('maxlength', '30')
        			   ->setAttrib('title','Last Name')
				   ->setAttrib('placeholder','Last Name')
        			   ->addFilters(array('StringTrim'))
        			   ->setAttrib('class','inp1');
        $winnotificationType = new Zend_Form_Element_Radio('winnotificationType');
		$winnotificationType->removeDecorator('Label')
			   		  	 ->removeDecorator('HtmlTag')
			   		  	 ->setMultiOptions($notificationList)
			   		  	 ->setValue('sms')
			   		  	 ->setSeparator(' ')
			   		  	 ->setAttrib('title','NotificationType')
			   		  	 ->setRequired(false);
			   		  	 
   	  	 $countryCode = $this->createElement('text', 'countryCode');
         $countryCode->removeDecorator('Label')  
         			   ->removeDecorator('HtmlTag')      		       
        		       ->setAttrib('class','inp1 countrycode')
        		       ->setAttrib('readonly','readonly')
					   ->setAttrib('style','float:left; width:60px;')
        	//	       ->setAttrib('placeholder', ' Code')
        		       ->setAttrib('title', 'Country Code')
        		       ->addFilters(array('StringTrim'))
        		       ->setValue('')
                       ->setAttrib('maxlength', '5');
			   		  	 
		$winnumber = $this->createElement('text', 'winnumber');
        $winnumber->removeDecorator('Label')
        			   ->removeDecorator('HtmlTag')
        			   ->setAttrib('maxlength', '15')
        			   ->setAttrib('title','Phone Number')
					   ->setAttrib('placeholder','Phone Number')
        			   ->addFilters(array('StringTrim'))
					   ->setAttrib('style','width:80% !important;')
        			   ->setAttrib('class','inp1 phnum');
        			   
        $winemail = $this->createElement('text', 'winemail');
        $winemail->removeDecorator('Label')
        			   ->removeDecorator('HtmlTag')
        			   ->setAttrib('maxlength', '40')
        			   ->setAttrib('title','Email')
				   ->setAttrib('placeholder','Email')
        			   ->addFilters(array('StringTrim'))
        			   ->setAttrib('class','inp1 email');
        
       $windinerRequest = $this->createElement('textarea', 'windinerRequest');
       $windinerRequest->removeDecorator('Label')
        			   ->removeDecorator('HtmlTag')
        			   ->setAttrib('maxlength', '200')
        			   ->setAttrib('rows', '3')
        			   ->setAttrib('cols', '25')
        			   ->setAttrib('title','Booking Note')
				   ->setAttrib('placeholder','Booking Note')
        			//   ->setAttrib('style','width:200px;height:25px')
        			   ->addFilters(array('StringTrim'));
        $wincontactInfo = $this->createElement('textarea', 'wincontactInfo');
        $wincontactInfo->removeDecorator('Label')
        			   ->removeDecorator('HtmlTag')
        			   ->setAttrib('maxlength', '500')
        			   ->setAttrib('rows', '3')
        			   ->setAttrib('cols', '25')
        			   ->setAttrib('title','Guest Notes')
        			   ->addFilters(array('StringTrim'));
               			
        $winSubmit = $this->createElement('submit','winSubmit');
        $winSubmit->removeDecorator('Label')
        		  ->removeDecorator('DtDdWrapper')
        		  ->setValue('Submit')           		          		        		
        		  ->setAttrib('class','submitBtn')
                  ->setIgnore(true);

		$winReset = $this->createElement('reset','winReset');
        $winReset->removeDecorator('Label')        		 
        		 ->setValue('Reset')
        		 ->removeDecorator('DtDdWrapper')           	  	 
        	  	 ->setAttrib('class','submitBtn')
              	 ->setIgnore(true);
              	 
        $diningid = $this->createElement('hidden','windiningid');
    	$diningid->removeDecorator('HtmlTag')
    			  ->removeDecorator('Label');
    
    	$tableno = $this->createElement('hidden','wintableno');
    	$tableno->removeDecorator('HtmlTag')
    			  ->removeDecorator('Label');
    			 
    	$tableid = $this->createElement('hidden','wintableid');
    	$tableid->removeDecorator('HtmlTag')
    			  ->removeDecorator('Label');
    	
    	$winDate = $this->createElement('hidden','winDate');
    	$winDate->removeDecorator('HtmlTag')
    			  ->removeDecorator('Label');

        $winTime = $this->createElement('text','winTime');
        $winTime->removeDecorator('HtmlTag')
                  ->removeDecorator('Label')
                  ->setAttrib('class','winselTimeSpan');
    	       	    
    	$this->addElements( array ($winfirstName,
									$winlastName,
									$winnumber,
									$winemail,									
									$resId,
							    	$winDate,
							    	$winpax,
							    	$winSubmit,
							    	$winReset,
							    	$wincontactInfo,
							    	$windinerRequest,
							    	$winnotificationType,
							    	$diningid,
							    	$tableno,
							    	$tableid,
							    	$countryCode,
                                    				$winTime,
								  )		
		
		);	 
    }


}
?>