<?php

class Reservation_Form_WidgetBookingDetails extends Zend_Form
{

    public function init()
    {
    	
    	$notificationTypeMapper = new Application_Model_NotificationTypeDataMapper();
    	$result = $notificationTypeMapper->fetchAll();
    	$notificationList = array();
    	$notificationList[] = array('key'=>'','value'=>'Select notification Type');
    	foreach($result  as $value){
    		$notificationList[] = array('key'=>$value->getCode(),'value'=>$value->getDescription());
    	}
    	
    	$resId = $this->createElement('hidden','resId');
    	$resId->removeDecorator('HtmlTag')
    		  ->removeDecorator('Label');
    		  
    	$paymentStat = $this->createElement('hidden','paymentStatus');
    	$paymentStat->removeDecorator('Label')
			        ->removeDecorator('HtmlTag');
    	
    	$resName = $this->createElement('hidden','resName');
    	$resName->removeDecorator('HtmlTag') 
    		    ->removeDecorator('Label');
    	
    	$resAddress = $this->createElement('hidden','resAddress');
    	$resAddress->removeDecorator('HtmlTag')
    			    ->removeDecorator('Label');
    	
    	$resDate = $this->createElement('hidden','resDate');
    	$resDate->removeDecorator('HtmlTag')
    		     ->removeDecorator('Label');
    	
    	$resTime = $this->createElement('hidden','resTime');
    	$resTime->removeDecorator('HtmlTag')
    	         ->removeDecorator('Label');
    	
    	$pax = $this->createElement('hidden','pax');
    	$pax->removeDecorator('HtmlTag')
    	     ->removeDecorator('Label');
    	
    	$userid = $this->createElement('hidden','userid');
    	$userid->removeDecorator('HtmlTag')
    	       ->removeDecorator('Label');
    	$restPax = $this->createElement('hidden','tablesize');
    	$restPax->removeDecorator('HtmlTag')
    	        ->removeDecorator('Label');
    	
        $nooftables = $this->createElement('hidden','nooftables');
    	$nooftables->removeDecorator('HtmlTag')
    	       	   ->removeDecorator('Label');
    	       	   
    	$specialId = $this->createElement('hidden','specialid');    	
    	$specialId->removeDecorator('HtmlTag') 
    		      ->removeDecorator('Label');
    	
    	$bookType = $this->createElement('hidden','booktype');    	
    	$bookType->removeDecorator('HtmlTag') 
    		     ->removeDecorator('Label');
    	
    	$specialAmt = $this->createElement('hidden','specialamt');    	
    	$specialAmt->removeDecorator('HtmlTag') 
    		       ->removeDecorator('Label');
    	       	   
    	$bookingStatus = $this->createElement('hidden','bookingStatus');
    	$bookingStatus->setValue('RSD');
    	$bookingStatus->removeDecorator('HtmlTag');
    	
    	$numberList = array(
    		array('key'=>'mobile','value' => 'Mobile'),
    		array('key'=>'phone','value' => 'Phone')
    	);
        $firstName = $this->createElement('text', 'firstName');
        $firstName->removeDecorator('Label')
        			   ->removeDecorator('HtmlTag')
        			   ->setAttrib('maxlength', '50')
        			   ->setAttrib('class','inp1')
        			   ->addValidator('StringLength', false,array(0,50))
        			   ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter First Name.'))))
        			   ->setValue('')
        			   ->setRequired(true);
        $lastName = $this->createElement('text', 'lastName');
        $lastName->removeDecorator('Label')
        			   ->removeDecorator('HtmlTag')
        			   ->setAttrib('maxlength', '50')
        			   ->setAttrib('class','inp1')
        			   ->addValidator('StringLength', false,array(0,50))
        			   ->setValue('')
        			   ->setRequired(false);
        $number = $this->createElement('text', 'number');
        $number->removeDecorator('Label')
        			   ->removeDecorator('HtmlTag')
        			   ->setAttrib('maxlength', '50')
        			   ->setAttrib('class','inp1')
        			   ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter Phone Number.'))))
        			   ->addValidator('StringLength', false,array(0,50))
        			   ->setRequired(true);
        $email = $this->createElement('text', 'email');
        $email->removeDecorator('Label')
        			   ->removeDecorator('HtmlTag')
        			   ->setAttrib('maxlength', '50')
        			   ->setAttrib('class','inp1')
        			   ->addValidator('StringLength', false,array(0,50))
        			   ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please enter Email Address.'))))
        			   ->addValidator('EmailAddress')
        			   ->setValue('')
        			   ->setRequired(true);
       	$notificationType = $this->createElement('select', 'notificationType');
        $notificationType->removeDecorator('HtmlTag')
    	     ->removeDecorator('Label')
    	     ->setAttrib('class', 'required')
			 ->addMultiOptions($notificationList)
			 ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please Select Notification Type.')))) 
			 ->setRequired(true);
        $dinerRequest = $this->createElement('text', 'dinerRequest');
        $dinerRequest->removeDecorator('Label')
        			   ->removeDecorator('HtmlTag')
        			   ->setAttrib('maxlength', '500')        			   
        			   ->addValidator('StringLength', false,array(0,500))
        			   ->setValue('')
        			   ->setRequired(false);
               			
         $resSubmit = $this->createElement('submit','Submit');
        $resSubmit->removeDecorator('Label')
        		  ->removeDecorator('DtDdWrapper')
        		  ->setValue('Submit')           		          		        		
        		  ->setAttrib('class','submitBtn')
                  ->setIgnore(true);

		$resReset = $this->createElement('reset','Reset');
        $resReset->removeDecorator('Label')        		 
        		 ->setValue('Reset')
        		 ->removeDecorator('DtDdWrapper')           	  	 
        	  	 ->setAttrib('class','submitBtn')
              	 ->setIgnore(true);
        
        			   
						 
				 
		$this->addElements( array ($firstName,
									$lastName,
									$number,
									$nooftables,
									$email,
									$notificationType,
									$dinerRequest,									
									$resId,
							    	$resName,
							    	$resAddress,
							    	$resDate,
							    	$resTime,
							    	$pax,
							    	$bookingStatus,
							    	$resSubmit,
							    	$specialId,
							    	$bookType,
							    	$specialAmt,
							    	$resReset,
							    	$userid,
							    	$restPax,
							    	$paymentStat
								  )		
		
		);	 
    }


}

