<?php
/**
*	Name			: BlockTable.php
*	Author			: snehal
*	Creation Date	: 1/13/2011
*	Path 			: application/modules/Reservation/models/BlockTable.php
*	Description		: This is the Model class for blocking a table.
*					   	
*/
class Reservation_Model_BlockTable
{
	/**
	 * 
	 * @var integer
	 */
	private $_restid;
	
	/**
	 * 
	 * @var integer
	 */
	private $_tableid;
	
	/**
	 * 
	 * @var boolean
	 */
	private $_status;
	
	/**
	 * 
	 * @var integer
	 */
	private $_tablestatusid;
	
	/**
	 * 
	 * @var integer
	 */
	private $_tablepax;
	
	/**
     * Public constructor
     *
     * @param  array $options
     */
	public function __construct(array $options = null)
	{
		if(is_array($options)){
			$this->setOptions($options);
		}		
	}
	
	/**
	 * Writing data to properties
	 */
	public function __set($name, $value)
	{
		$method = 'set' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Booking property');
		}
		$this->$method($value);
	}
	
	/**
	 * Reading data from properties
	 */
	public function __get($name)
	{
		$method = 'get' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Booking property');
		}
		return $this->$method();
	}
	
	/**
     * @param integer $restid
     * @return self
     */
	public function setRestId($restid)
	{
		$this->_restid = $restid;
		return $this;
	}
	
	 /**
     * @return integer
     */
	public function getRestId()
	{
		return $this->_restid;
	} 
	
	/**
     * @param integer $tableid
     * @return self
     */
	public function setTableId($tableid)
	{
		$this->_tableid = $tableid;
		return $this;
	}
	
	 /**
     * @return integer
     */
	public function getTableId()
	{
		return $this->_tableid;
	}
	
	/**
     * @param boolean $status
     * @return self
     */
	public function setStatus($status)
	{
		$this->_status = $status;
		return $this;
	}
	
	/**
     * @return boolean
     */
	public function getStatus()
	{
		return $this->_status;
	}
	
	/**
     * @param integer $tablestatusid
     * @return self
     */
	public function setTableStatusId($tablestatusid)
	{
		$this->_tablestatusid = $tablestatusid;
		return $this;	
	}
	
	/**
     * @return integer
     */
	public function getTableStatusId()
	{
		return $this->_tablestatusid;
	}
	
	/**
     * @param integer $tablepax
     * @return self
     */
	public function setTablePax($tablepax)
	{
		$this->_tablepax = $tablepax;
		return $this;	
	}
	
	/**
     * @return integer
     */
	public function getTablePax()
	{
		return $this->_tablepax;
	}
}