<?php
/**
*	Name			: BlockTableDataMapper.php
*	Author			: snehal
*	Creation Date	: 1/13/2011
*	Path 			: application/modules/Reservation/models/BlockTableDataMapper.php
*	Description		: This is the datamapper class for blocking a table.
*					   	
*/
class Reservation_Model_BlockTableDataMapper
{
	/**
	 * Instance variable of blocking a table
	 * @var object
	 */
	protected $_dbTable;

	/**
     * @param instance of DbTable restaurant_table_status $dbTable
     * @return self
     */
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	/**
     * @return instance of DbTable restaurant_table_status
     */
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Reservation_Model_DbTable_BlockTable');
		}
		return $this->_dbTable;
	}

	/**
	 * @param instance of blocktable
	 * function to blocking a table 
	 */
	public function BlockTable(Reservation_Model_BlockTable $tableObj)
	{
		try{
			$table = $this->getDbTable();
			$data = array('rtsfk_restaurantid' => $tableObj->getRestId(),
					  'rtsfk_tableid' 	   => $tableObj->getTableId(),
					  'rtsfk_statusid' 	   => $tableObj->getStatus());

			$tableid = $table->insert($data);
			if($tableid){
				return $tableid;
			}else {
				return false;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * @param instance of blocktable
	 * function to Unblock a table 
	 */
	public function UnBlockTable(Reservation_Model_BlockTable $tableObj)
	{
		try{
			$table = 'mt.restaurant_table_status';
			$db = Zend_Db_Table::getDefaultAdapter();

			$where = $db->quoteInto(array(
									'rtsfk_restaurantid  = ?'=> $tableObj->getRestId(),
									'rtsfk_tableid = ?' => $tableObj->getTableId()));


			$effectedRow = $db->delete($table,$where);
			if($effectedRow){
				return true;
			}else {
				return false;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}
