<?php
/**
*	Name			: BookingLog.php
*	Author			: snehal
*	Creation Date	: 1/13/2011
*	Path 			: application/modules/Reservation/models/BlockTable.php
*	Description		: This is the Model class for blocking a table.
*					   	
*/
class Reservation_Model_BookingLog
{
	/**
	 * 
	 * @var integer
	 */
	private $_bok_log_id;
	
	/**
	 * 
	 * @var integer
	 */
	private $_bok_log_fk_booking;
	
	/**
	 * 
	 * @var boolean
	 */
	private $_bok_log_booked_type;
	
	/**
	 * 
	 * @var integer
	 */
	private $_bok_log_bok_status;
	
	/**
	 * 
	 * @var integer
	 */
	private $_bok_log_book_message;
	
	/**
	 *
	 * @var integer
	 */
	private $_bok_log_updated_by;
	
	/**
	 *
	 * @var integer
	 */
	private $_bok_log_updated_at;
	
	private $_bok_log_update_done_by;
	/**
     * Public constructor
     *
     * @param  array $options
     */
	public function __construct(array $options = null)
	{
		if(is_array($options)){
			$this->setOptions($options);
		}		
	}
	
	/**
	 * Writing data to properties
	 */
	public function __set($name, $value)
	{
		$method = 'set' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Booking property');
		}
		$this->$method($value);
	}
	
	/**
	 * Reading data from properties
	 */
	public function __get($name)
	{
		$method = 'get' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Booking property');
		}
		return $this->$method();
	}
	
	/**
     * @param integer $bok_log_id
     * @return self
     */
	public function setbok_log_id($bok_log_id)
	{
		$this->_bok_log_id = $bok_log_id;
		return $this;
	}
	
	 /**
     * @return integer
     */
	public function getbok_log_id()
	{
		return $this->_bok_log_id;
	} 
	
	/**
     * @param integer $bok_log_fk_booking
     * @return self
     */
	public function setbok_log_fk_booking($bok_log_fk_booking)
	{
		$this->_bok_log_fk_booking = $bok_log_fk_booking;
		return $this;
	}
	
	 /**
     * @return integer
     */
	public function getbok_log_fk_booking()
	{
		return $this->_bok_log_fk_booking;
	}
	
	/**
     * @param boolean $bok_log_booked_type
     * @return self
     */
	public function setbok_log_booked_type($bok_log_booked_type)
	{
		$this->_bok_log_booked_type = $bok_log_booked_type;
		return $this;
	}
	
	/**
     * @return boolean
     */
	public function getbok_log_booked_type()
	{
		return $this->_bok_log_booked_type;
	}
	
	/**
     * @param integer $bok_log_bok_status
     * @return self
     */
	public function setbok_log_bok_status($bok_log_bok_status)
	{
		$this->_bok_log_bok_status = $bok_log_bok_status;
		return $this;	
	}
	
	/**
     * @return integer
     */
	public function getbok_log_bok_status()
	{
		return $this->_bok_log_bok_status;
	}
	
	/**
     * @param integer $bok_log_book_message
     * @return self
     */
	public function setbok_log_book_message($bok_log_book_message)
	{
		$this->_bok_log_book_message = $bok_log_book_message;
		return $this;	
	}
	
	/**
     * @return integer
     */
	public function getbok_log_book_message()
	{
		return $this->_bok_log_book_message;
	}
	
	/**
	 * @param integer $bok_log_updated_by
	 * @return self
	 */
	public function setbok_log_updated_by($bok_log_updated_by)
	{
		$this->_bok_log_updated_by = $bok_log_updated_by;
		return $this;
	}
	
	/**
	 * @return integer
	 */
	public function getbok_log_updated_by()
	{
		return $this->_bok_log_updated_by;
	}
	
	/**
	 * @param integer $bok_log_updated_at
	 * @return self
	 */
	public function setbok_log_updated_at($bok_log_updated_at)
	{
		$this->_bok_log_updated_at = $bok_log_updated_at;
		return $this;
	}
	
	/**
	 * @return integer
	 */
	public function getbok_log_updated_at()
	{
		return $this->_bok_log_updated_at;
	}
	
	/**
	 * @param integer $bok_log_update_done_by
	 * @return self
	 */
	public function setbok_log_update_done_by($bok_log_update_done_by)
	{
		$this->_bok_log_update_done_by = $bok_log_update_done_by;
		return $this;
	}
	
	/**
	 * @return integer
	 */
	public function getbok_log_update_done_by()
	{
		return $this->_bok_log_update_done_by;
	}
}