<?php
/**
*	Name			: BookingLogMapper.php
*	Author			: snehal
*	Creation Date	: 1/13/2011
*	Path 			: application/modules/Reservation/models/BlockTableDataMapper.php
*	Description		: This is the datamapper class for blocking a table.
*					   	
*/
class Reservation_Model_BookingLogMapper
{
	/**
	 * Instance variable of blocking a table
	 * @var object
	 */
	protected $_dbTable;

	/**
     * @param instance of DbTable restaurant_table_status $dbTable
     * @return self
     */
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	/**
     * @return instance of DbTable restaurant_table_status
     */
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Reservation_Model_DbTable_BookingLog');
		}
		return $this->_dbTable;
	}

	public function updateBookingLog(Reservation_Model_BookingLog $bokLog)
	{
		try{
			
			$data = array(
							'bok_log_fk_booking'	=>	$bokLog->getbok_log_fk_booking(),
							'bok_log_booked_type'	=>	$bokLog->getbok_log_booked_type(),
							'bok_log_bok_status'	=>	$bokLog->getbok_log_bok_status(),
							'bok_log_book_message'	=>	$bokLog->getbok_log_book_message(),
							'bok_log_updated_by'	=>	$bokLog->getbok_log_updated_by(),
							'bok_log_updated_at'	=>	$bokLog->getbok_log_updated_at()
					);
			if($bokLog->getbok_log_updated_by()){
				$userMapper = new User_Model_ClientDataMapper();
				$userDet = $userMapper->getUsertypeidByUserId($bokLog->getbok_log_updated_by());
				if($userDet['Type']){
					$data['bok_log_update_done_by'] = $userDet['Type'];
				}
			}else{
				$auth = Zend_Auth::getInstance();
				if($auth->hasIdentity()){
					$storage = new Zend_Auth_Storage_Session();
					$userdata = $storage->read();
					$userid = $userdata['User_Id'];
					$userMapper = new User_Model_ClientDataMapper();
					$userDet = $userMapper->getUsertypeidByUserId($userid);
					if($userDet['Type']){
						$data['bok_log_update_done_by'] = $userDet['Type'];
					}if($bokLog->getbok_log_update_done_by()){
						$data['bok_log_update_done_by'] = $bokLog->getbok_log_update_done_by();
					}else{
						$data['bok_log_update_done_by'] = 'CUS';
					}
				}else{
					$data['bok_log_update_done_by'] = 'CUS';
				}
			}
			$result = $this->getDbTable()->insert($data);
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getBookingLog($bokid)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->setIntegrityCheck(false);
			$select->from(array('log'=>'mt.booking_log'),array('bok_log_id','bok_log_fk_booking','bok_log_booked_type','bok_log_bok_status','bok_log_book_message','bok_log_updated_by','bok_log_updated_at','bok_log_update_done_by'))
					->join(array('bok'=>'mt.booking'),'bok.bokid = log.bok_log_fk_booking',array('bokid'))
					->joinleft(array('typ'=>'mt.booking_status_bd'),'log.bok_log_booked_type = typ.id',array('code as bookedCode','description as bookedDesc'))
					->joinleft(array('type'=>'mt.booking_status_bd'),'log.bok_log_bok_status = type.id',array('code as currCode','description as currDesc'))
					->where('bok_log_fk_booking = ?',$bokid)
					->order('bok_log_updated_at');
			$resultSet = $this->getDbTable()->fetchAll($select);
			$resultArr = array();
			foreach($resultSet as $result){
				$bokType = array(
								'bok_log_id'			=>	$result->bok_log_id,
								'bok_log_fk_booking'	=>	$result->bok_log_fk_booking,
								'bok_log_booked_type'	=>	$result->bok_log_booked_type,
								'bok_log_bok_status'	=>	$result->bok_log_bok_status,
								'bok_log_book_message'	=>	$result->bok_log_book_message,
								'bok_log_updated_at'	=>	date('d M Y h:i:a',strtotime($result->bok_log_updated_at)),
								'bok_log_updated_by'	=>	$result->bok_log_updated_by,
								'bok_log_update_done_by'=>	$result->bok_log_update_done_by
				);
				$resultArr[] = $bokType;
			}
			return $resultArr;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}
