<?php

class Reservation_Model_MultiTime
{
	private $_id;
	private $_time;
	private $_interval;
	private $_starttime;
	private $_endtime;
	private $_resid;
	private $_date;
	private $_timebookingstatus;
	private $_noofseats;
	private $_bookingcount;
	private $_isajaxcall;
	
	public function __construct(array $options = null)
	{
		if(is_array($options)){
			$this->setOptions($options);
		}		
	}
	
	public function __set($name, $value)
	{
		$method = 'set' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Customer property');
		}
		$this->$method($value);
	}
	
	public function __get($name)
	{
		$method = 'get' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Customer property');
		}
		return $this->$method();
	}
	
	public function setOptions(array $options)
	{
		$methods = get_class_methods($this);
		foreach ($options as $key => $value) {
			$method = 'set' . ucfirst($key);
			if (in_array($method, $methods)) {
				$this->$method($value);
			}
		}
		return $this;
	}
	
	public function setId($id)
	{
		$this->_id = $id;
		return $this;
	}
	
	public function getId()
	{
		return $this->_id;
	}
	
	public function setTime($time)
	{
		$this->_time = $time;
		return $this;
	}
	
	public function getTime()
	{
		return $this->_time;
	}	
	
	public function setInterval($interval)
	{
		$this->_interval = $interval;
		return $this;
	}
	
	public function getInterval()
	{
		return $this->_interval;
	}
	
	public function setStartTime($starttime)
	{
		$this->_starttime = $starttime;
		return $this;
	}
	
	public function getStartTime()
	{
		return $this->_starttime;
	}
	
	public function setEndTime($endtime)
	{
		$this->_endtime = $endtime;
		return $this;
	}
	
	public function getEndTime()
	{
		return $this->_endtime;
	}
	
	public function setResId($resid)
	{
		$this->_resid = $resid;
		return $this;
	}
		
	public function getResId()
	{
		return $this->_resid;
	}
	
	public function setDate($date)
	{
		$this->_date = $date;
		return $this;
	}	
	
	public function getDate()
	{
		return $this->_date;
	}
	
	public function setBookingCountStatus($timebookingcount)
	{
		$this->_timebookingstatus = $timebookingcount;
		return $this;
	}	
	
	public function getBookingCountStatus()
	{
		return $this->_timebookingstatus;
	}
	
	public function setNoOfSeats($noofseats)
	{
		$this->_noofseats = $noofseats;
		return $this;
	}
	
	public function getNoOfSeats()
	{
		return $this->_noofseats;
	}	
	
	public function setBookingCount($bookingcount)
	{
		$this->_bookingcount = $bookingcount;
		return $this;
	}
	
	public function getBookingCount()
	{
		return $this->_bookingcount;
	}	
	
	public function setIsAjaxCall($isajaxcall)
	{
		$this->_isajaxcall = $isajaxcall;
		return $this;
	}
	
	public function getIsAjaxCall()
	{
		return $this->_isajaxcall;
	}

}

