<?php

class Reservation_Model_MultiTimeDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Reservation_Model_DbTable_ReservationCount');
		}
		return $this->_dbTable;
	}

	public function multitime(Reservation_Model_MultiTime  $timeObj)
	{
		try{
			$timeA= explode(" ",$timeObj->getTime());
			$a = $timeA[1];
			$timeFir =  $timeA[0];
			$timeHM = explode(":",$timeFir);
			$h = (int)$timeHM[0];
			if($timeA[1] == "PM" &&  $h != 12){
				$h += 12;
			}
			if($timeA[1] == "AM" &&  $h == 12){
				$h = 0;
			}
			$inter = explode(":",$timeObj->getInterval());
			$interH = intval($inter[0]);
			$interM = intval($inter[1]);

			$gap = ($interH*60)+$interM;
			$m = $timeHM[1]-($gap*2);
			$multiTime = array();

			$getStratTime = date("h:i A",strtotime($timeObj->getStartTime()));
			$stimeA= explode(" ",$getStratTime);
			$sa = $stimeA[1];
			$stimeFir =  $stimeA[0];
			$stimeHM = explode(":",$stimeFir);
			$sh = (int)$stimeHM[0];
			if($stimeA[1] == "PM"  &&  $sh != 12){
				$sh += 12;
			}
			if($stimeA[1] == "AM" &&  $sh == 12){
				$sh = 0;
			}

			$getEndTime = date("h:i A",strtotime($timeObj->getEndTime()));
			$etimeA= explode(" ",$getEndTime);
			$ea = $etimeA[1];
			$etimeFir =  $etimeA[0];
			$etimeHM = explode(":",$etimeFir);
			$eh = (int)$etimeHM[0];
			if($etimeA[1] == "PM"  &&  $eh != 12){
				$eh += 12;
			}
			if($etimeA[1] == "AM" &&  $eh == 12){
				$eh = 0;
			}


			$st = mktime($sh,$stimeHM[1],0,0,0,0);
			$e = mktime($eh,$etimeHM[1],0,0,0,0);


			for($i=0;$i<=4;$i++){

				$s = mktime($h,$m,0,0,0,0);
				$finalTime =  date("h:i A",$s);

				if($st <= $s  && $s <=  $e){

					$table = $this->getDbTable();
					$select = $table->select();
					$select->from($table,array('btcbooking_count'))
					->where('btcfkres_id = ?',$timeObj->getResId())
					->where('btcbooking_date = ?',$timeObj->getDate())
					->where('btcbooking_timings = ?',$finalTime);
						
					$row = $table->fetchRow($select);
					$bookingCount = (int)$row['btcbooking_count'];
					if($timeObj->getIsAjaxCall()){

						$status = null;
						$seatsFlag  = (int)$timeObj->getNoOfSeats();


						if($bookingCount >= $seatsFlag){
							$status = 'WAL';
						}else{
							$status = 'RSD';
						}

						$multiTime[] = array('resvtime'   => $finalTime,
										 'bookcount'  => $bookingCount,
										 'resvstatus' => $status);

					}else{


						$multitimeObj = new Reservation_Model_MultiTime();
						$multitimeObj->setTime($finalTime);

						$seatsFlag  = (int)$timeObj->getNoOfSeats();

						$multitimeObj->setBookingCount($bookingCount);
						if($bookingCount >= $seatsFlag){
							$multitimeObj->setBookingCountStatus('WAL');
						}else{
							$multitimeObj->setBookingCountStatus('RSD');
						}

						$multiTime[] = $multitimeObj;
					}
				}
				$m += $gap;
			}
			return $multiTime;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

}

