<?php
class Reservation_Model_ReservationAccumulativeInventoryMapper
{
	
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Reservation_Model_DbTable_ReservationAccumulativeInventory');
		}
		return $this->_dbTable;
	}
	
	public function GetBookingAccumulativeInventorysByBookingIds($bokingIds)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('baiid','bai_fk_booking','bai_inventory','bai_status'))
				   ->where('bai_fk_booking IN(?)',$bokingIds);
			$resultset = $this->getDbTable()->fetchAll($select);
			$InventorysArr = array();
			foreach($resultset as $key=>$value){
				$subArr = array();
				foreach($value as  $key1=>$value1){
					$subArr[$key1]= $value1;
				}
				$InventorysArr[] = $subArr;
			}
			return $InventorysArr;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}