<?php
class Reservation_Model_ReservationFBEventDataMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Reservation_Model_DbTable_ReservationFBEvent');
		}
		return $this->_dbTable;
	}
	
	public function saveBookingFbEvent(Reservation_Model_ReservationFBEvent $BookingFBEvent)
	{
		try
		{
			$table = $this->getDbTable();
			
			$data = array('bfe_fb_profile_id' => $BookingFBEvent->getbfe_fb_profile_id(),
						  'bfe_fb_eventid'	  => $BookingFBEvent->getbfe_fb_eventid(),
					      'bfe_fk_booking'	  => $BookingFBEvent->getbfe_fk_booking());
			
			$result = $table->insert($data);
			
			return $result;
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getBookFbEvent(Reservation_Model_ReservationFBEvent $BookingFBEvent)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->from($this->getDbTable(),array('bfe_id','bfe_fb_profile_id','bfe_fb_eventid'))
					->where('bfe_fk_booking = ?',$BookingFBEvent->getbfe_fk_booking());
			$result = $this->getDbTable()->fetchRow($select);
			return $result;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function RetrieveReservationFbEvents($booking_id_array)
	{
		try
		{
			$select = $this->getDbTable()->select();
			$select->from($this->getDbTable(),array('bfe_id','bfe_fb_profile_id','bfe_fb_eventid','bfe_fk_booking'))
					->where('bfe_fk_booking IN(?)',$booking_id_array);
			$rowset = $this->getDbTable()->fetchAll($select);
			
			$result 	  = array();
			$fbevents 	  = array();
			$fbevents_ids = array();			
			if(count($rowset) > 0)
			{
				$result["status"] = true;
				foreach($rowset as $row)
				{
					$fbevents[] = array('bfe_id'=>$row->bfe_id,'bfe_fb_profile_id'=>$row->bfe_fb_profile_id,'bfe_fb_eventid'=>$row->bfe_fb_eventid,'bfe_fk_booking'=>$row->bfe_fk_booking);
					$fbevents_ids[] = $row->bfe_fb_eventid;
				}
				
				$result["fb_events"] = $fbevents;
				$result["fb_event_ids"] = $fbevents_ids;
			}else{
				$result["status"] = false;
			}		
			return $result;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
}