<?php
class Reservation_Model_ReservationFBInviteDataMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Reservation_Model_DbTable_ReservationFBInvite');
		}
		return $this->_dbTable;
	}
	
	public function SaveBookingFbInvites(array $dataObj)
	{
		$db = Zend_Db_Table::getDefaultAdapter();
		try{
			$db->beginTransaction(); 
			$status = false;
			$table = $this->getDbTable();
			foreach($dataObj as $dataVar){
				$data = array(
		                  'bfi_fk_event'	    => $dataVar->getbfi_fk_event(),
		                  'bfi_fb_user'	    	=> $dataVar->getbfi_fb_user(),
		  				  'bfi_fb_invite_status'=> $dataVar->getbfi_fb_invite_status(),
			  			  'bfi_fb_status'		=> $dataVar->getbfi_fb_status());
				
				$id    = $table->insert($data);
			}
			$status = true;
			$db->commit();
			return $status;			
		}catch (Exception $ex){
			$db->rollBack();
			throw new Exception($ex->getMessage()) ;
		}	
	}
	
	public function RetrieveFbEventInvites($event_id_array)
	{
		try
		{
			$table 	= $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('bfi_id','bfi_fk_event','bfi_fb_user','bfi_fb_invite_status','bfi_fb_status'))
				   ->where("bfi_fk_event IN(?)",$event_id_array);
			$rowset = $table->fetchAll();	
			$result = array();   
			foreach($rowset as $row)
			{
				$result[] = array('bfi_id'=>$row->bfi_id,'bfi_fk_event'=>$row->bfi_fk_event,'bfi_fb_user'=>$row->bfi_fb_user,'bfi_fb_invite_status'=>$row->bfi_fb_invite_status,'bfi_fb_status'=>$row->bfi_fb_status);
			}
			return $result;
		}catch (Exception $ex){
			$db->rollBack();
			throw new Exception($ex->getMessage()) ;
		}
	}
}