<?php
class Reservation_Model_ReservationNotifyMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Reservation_Model_DbTable_ReservationNotify');
		}
		return $this->_dbTable;
	}
	
	public function SaveBookingNotifyInfo(Reservation_Model_ReservationNotify $BookingNotify)
	{
		try{
			$table = $this->getDbTable();
			$data = array('bknfk_booking'	   => $BookingNotify->getbknfk_booking(),
						  'bkn_booking_date'   => $BookingNotify->getbkn_booking_date(),
						  'bkn_reminderstatus' => "FALSE");				
								
			$id = $table->insert($data);				
			return $id;
				
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function UpdateReminderStatus(Reservation_Model_ReservationNotify $BookingNotify)
	{
		try{
			$table = $this->getDbTable();
				$set = array('bkn_reminderstatus' => $BookingNotify->getbkn_reminderstatus());
				$where = array('bknid = ?' => $BookingNotify->getbknid());			
			$rows_affected = $table->update($set,$where);
			return $rows_affected;	
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}		
	}
	
	public function RetrieveReminderBookingInfo(Reservation_Model_ReminderBookings $ReminderBookings)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);

			$select->from(array('bkn'=>'mt.booking_notify'),array('bknid'))
				   ->join(array('bok'=>'mt.booking'),'bkn.bknfk_booking = bok.bokid',array('bokid','bokfk_restaurant','bokfirst_name','boklast_name','bokparty_size','bokbooking_timings','bokspecial_request','bokemail','bokphone','bokbooking_date','bokbooking_status_id','boknotification_type','bokbooking_type_id'))
				   ->join(array('boksts'=>'mt.booking_status_bd'),'boksts.id = bok.bokbooking_status_id',array('code as bookstatus'))
				   ->join(array('boktyp'=>'mt.booking_type_bd'),'boktyp.id = bok.bokbooking_type_id',array('code as booktype'))
				   ->join(array('res'=>'mt.restaurant'),'bok.bokfk_restaurant = res.resid',array('resid','resrestaurant_name','resaddress','reszipcode','resphone','resfax','resemail','rescity_id','resstate_id','resneighborhood_id','resregion_id'))
				   ->join(array('cty'=>'mt.city_bd'),'cty.id = res.rescity_id',array('code as citycode','description as citydesc'))
				   ->join(array('neigh'=>'mt.neighborhood_bd'),'neigh.id = res.resneighborhood_id',array('description as nieghbor'))
				   ->where('bkn.bkn_booking_date = ?',$ReminderBookings->getbookingdate())
				   ->where('boksts.code IN(?)',$ReminderBookings->getbookstatus())
				   ->where('bok.bokbooking_timings >= ?',$ReminderBookings->getbookfromtime())
				   ->where('bok.bokbooking_timings <= ?',$ReminderBookings->getbooktotime())
				   ->where('bkn.bkn_reminderstatus = FALSE');				   
				   
			$rowSet = $table->fetchAll($select);
			
			return $rowSet;	   
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}