<?php
/**
*	Name			: ReservationOptions.php
*	Author			: Sairam
*	Creation Date	: 02/04/2012
*	Path 			: application/modules/Reservation/models/ReservationOptions.php
*	Description		: This is the Model class for the booking Booking Options table.
*					   	
*/
class Reservation_Model_ReservationOptions
{
	
	/**
	 * 
	 * @var integer
	 */
	protected $_boptid;
	/**
	 * 
	 * @var boolean
	 */
	protected $_boptresid;
	protected $_bokcompanyid;
	/**
	 * 
	 * @var integer
	 */
	protected $_boptcreatedbyId;
	
	
	/**
	 * 
	 * @var integer
	 */
	protected $_boptupdatedbyId;
	
	/**
	 * 
	 * @var date
	 */
	protected $_boptcreatedDateTime;
	
	/**
	 * 
	 * @var date
	 */
	protected $_boptupdatedDateTime;
	
	
	/**
	 * 
	 * @var date
	 */
	protected $_boptdescription;
	
	
	/**
	 * 
	 * @var integer
	 */
	private   $_boptstatus; 
	private   $_boptcode;
	private	  $_bopttype;
	/**
     * Public constructor
     *
     * @param  array $options
     */	
	public function __construct(array $options = null)
	{
		if(is_array($options)){
			$this->setOptions($options);
		}		
	}
	
	/**
	 * Writing data to properties
	 */	
	public function __set($name, $value)
	{
		$method = 'set' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Reservation Options property');
		}
		$this->$method($value);
	}
	
	/**
	 * Reading data from properties
	 */
	public function __get($name)
	{
		$method = 'get' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Reservation Options property');
		}
		return $this->$method();
	}
	
	public function setOptions(array $options)
	{
		$methods = get_class_methods($this);
		foreach ($options as $key => $value) {
			$method = 'set' . ucfirst($key);
			if (in_array($method, $methods)) {
				$this->$method($value);
			}
		}
		return $this;
	}

	/**
     * @param string $boptid
     * @return self
     */
	public function setId($boptid)
	{
		$this->_boptid = $boptid;
		return $this;	
	}
	
	/**
     * @return string
     */
	public function getId()
	{
		return $this->_boptid;	
	}
	
		
	/**
     * @param string $boptcreatedbyId
     * @return self
     */
	public function setCreatedbyId($boptcreatedbyId)
	{
		$this->_boptcreatedbyId = $boptcreatedbyId;
		return $this;
	}
	
	/**
     * @return integer
     */
	public function getCreatedbyId()
	{
		return $this->_boptcreatedbyId;
	}
	

	/**
     * @param string $boptupdatedbyId
     * @return self
     */
	public function setUpdatedbyId($boptupdatedbyId)
	{
		$this->_boptupdatedbyId = $boptupdatedbyId;
		return $this;
	}
	
	/**
     * @return integer
     */
	public function getUpdatedbyId()
	{
		return $this->_boptupdatedbyId;
	}
	
	/**
     * @param integer $boptdescription
     * @return self
     */
	public function setDescription($boptdescription)
	{
		$this->_boptdescription = $boptdescription;
		return $this;
	}

	/**
     * @return date
     */
	public function getDescription()
	{
		return $this->_boptdescription;
	}
	
	/**
     * @param integer $boptcreatedDateTime
     * @return self
     */
	public function setCreatedDateTime($boptcreatedDateTime)
	{
		$this->_boptcreatedDateTime = $boptcreatedDateTime;
		return $this;
	}

	/**
     * @return date
     */
	public function getCreatedDateTime()
	{
		return $this->_boptcreatedDateTime;
	}
	
	/**
     * @param integer $boptupdatedDateTime
     * @return self
     */
	public function setUpdatedDateTime($boptupdatedDateTime)
	{
		$this->_boptupdatedDateTime = $boptupdatedDateTime;
		return $this;
	}

	/**
     * @return date
     */
	public function getUpdatedDateTime()
	{
		return $this->_boptupdatedDateTime;
	}
	
	
	/**
     * @param integer $boptstatus
     * @return self
     */
	public function setStatus($boptstatus)
	{
		$this->_boptstatus = $boptstatus;
		return $this;	
	}
	
	/**
     * @return boolean
     */
	public function getStatus()
	{
		return $this->_boptstatus;
	}
	
	/**
     * @param integer $boptresid
     * @return self
     */
	public function setResid($boptresid)
	{
		$this->_boptresid = $boptresid;
		return $this;	
	}
	
	/**
     * @return boolean
     */
	public function getResid()
	{
		return $this->_boptresid;
	}
	
         public function setCompanyid($companyid)
	{
		$this->_bokcompanyid = $companyid;
		return $this;	
	}
	
	public function getCompanyid()
	{
		return $this->_bokcompanyid;
	}
        
	public function setCode($boptcode)
	{
		$this->_boptcode = $boptcode;
		return $this;	
	}
	
	public function getCode()
	{
		return $this->_boptcode;
	}
	
	public function setType($bopttype)
	{
		$this->_bopttype = $bopttype;
		return $this;	
	}
	
	public function getType()
	{
		return $this->_bopttype;
	}
	
}