<?php
/**
*	Name			: ReservationOptionsMap.php
*	Author			: sairam
*	Creation Date	: 02/04/2012
*	Path 			: application/modules/Reservation/models/ReservationOptionsMap.php
*	Description		: This is the Model class for the booking Reservation Options table.
*/
class Reservation_Model_ReservationOptionsMap
{
	
	/**
	 * 
	 * @var integer
	 */
	protected $_bopmid;
	/**
	 * 
	 * @var integer
	 */
	protected $_bopmbokid;
	
	/**
	 * 
	 * @var integer
	 */
	protected $_bopmbok_optionsid;
	
	/**
     * Public constructor
     *
     * @param  array $options
     */	
	public function __construct(array $options = null)
	{
		if(is_array($options)){
			$this->setOptions($options);
		}		
	}
	
	/**
	 * Writing data to properties
	 */	
	public function __set($name, $value)
	{
		$method = 'set' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Reservation Options Map property');
		}
		$this->$method($value);
	}
	
	/**
	 * Reading data from properties
	 */
	public function __get($name)
	{
		$method = 'get' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Reservation Options Map property');
		}
		return $this->$method();
	}
	
	public function setOptions(array $options)
	{
		$methods = get_class_methods($this);
		foreach ($options as $key => $value) {
			$method = 'set' . ucfirst($key);
			if (in_array($method, $methods)) {
				$this->$method($value);
			}
		}
		return $this;
	}
	
	/**
     * @param string $bopmid
     * @return self
     */
	public function setId($bopmid)
	{
		$this->_bopmid = $bopmid;
		return $this;	
	}
	
	/**
     * @return string
     */
	public function getId()
	{
		return $this->_bopmid;	
	}
	
		
	/**
     * @param string $bopmbok_optionsid
     * @return self
     */
	public function setBookOptionsId($bopmbok_optionsid)
	{
		$this->_bopmbok_optionsid = $bopmbok_optionsid;
		return $this;
	}
	
	/**
     * @return integer
     */
	public function getBookOptionsId()
	{
		return $this->_bopmbok_optionsid;
	}
	
	/**
     * @param integer $bopmbokid
     * @return self
     */
	public function setBookId($bopmbokid)
	{
		$this->_bopmbokid = $bopmbokid;
		return $this;	
	}
	
	/**
     * @return boolean
     */
	public function getBookId()
	{
		return $this->_bopmbokid;
	}
}