<?php
/**
*	Name			: ReservationOptionsMapDataMapper.php
*	Author			: Sairam
*	Creation Date	: 02/04/2012
*	Path 			: application/modules/Reservation/models/ReservationOptionsMapDataMapper.php
*	Description		: This is the Model class for the booking ReservationOptionsMapDataMapper table.
*					   	
*/
class Reservation_Model_ReservationOptionsMapDataMapper
{
	/**
	 * Instance variable of booking_options_map a table
	 * @var object
	 */
	protected $_dbTable;

	/**
     * @param instance of DbTable booking_options_map $dbTable
     * @return self
     */
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	/**
     * @return instance of DbTable Reservation_options_map
     */
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Reservation_Model_DbTable_ReservationOptionsMap');
		}
		return $this->_dbTable;
	}
	
	public function saveBookingOptions($bookid, $bokoption)
	{
		try{				
			$data= array(
				'bopmbokid'			=>	$bookid,
				'bopmbok_optionsid'	=>	$bokoption					
			);	
				
			$user_id = $this->getDbTable()->insert($data);		
			return $user_id;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}	
	}
	
	public function GetBookingOptionsByBookingIds($bookids)
	{
		try{				
			$table = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('bopmid','bopmbokid','bopmbok_optionsid'))
				   ->where('bopmbokid IN(?)',$bookids);
			$resultset = $this->getDbTable()->fetchAll($select);
			$bokoptionsArr = array();
			foreach($resultset as $key=>$value){
				$subArr = array();
				foreach($value as  $key1=>$value1){
					$subArr[$key1]= $value1;
				}
				$bokoptionsArr[] = $subArr;
			}
			return $bokoptionsArr;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}	
	}
}