<?php
class Reservation_Model_ReservationSeatedTimeMapper
{
	/**
	 * Instance variable of the booking table
	 * @var object
	 */
	protected $_dbTable;

	/**
     * @param instance of DbTable booking $dbTable
     * @return self
     */
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	/**
     * @return instance of DbTable booking
     */
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Reservation_Model_DbTable_ReservationSeatedTime');
		}
		return $this->_dbTable;
	}
	
	public function QuoteSeatedTime(Reservation_Model_ReservationSeatedTime $seatTime)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->form($this->getDbTable(),array('bst_duration','bst_start_time'))
					->where('bst_bokid = ?',$seatTime->getBokId());
					
			$resultSet = $this->getDbTable()->fetchRow($select);
			if($resultSet->bst_duration){
				$set = array('bst_end_time = ?',$seatTime->getEndTime());
				$where = array('bst_bokid = ?'=>$seatTime->getBokId());
				$result = $this->getDbTable()->update($set,$where);
			}else{
				$data = array(
							'bst_bokid'			=>	$seatTime->getBokId(), 		
							'bst_start_time'	=>	$seatTime->getStartTimeId(),
							'bst_status'		=>	$seatTime->getStatus()		
				);
				$result = $this->getDbTable()->insert($data);
			}
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getQuotedSeatTime($bokid)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->form($this->getDbTable(),array('bst_duration'))
					->where('bst_bokid = ?',$bokid);
					
			$result = $this->getDbTable()->fetchRow($select);
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}