<?php
class Reservation_Model_ReservationSpecialDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Reservation_Model_DbTable_ReservationSpecial');
		}
		return $this->_dbTable;
	}
	
	public function OrderSpecial(Reservation_Model_ReservationSpecial $object)
	{
		try{
			$data = array('bksfk_restaurant' 	  => $object->getbksfk_restaurant(),
					  	  'bksspecial_id'         => $object->getbksspecial_id(),
					  	  'bksfk_user'            => $object->getbksfk_user(),
		        	      'bksordered_date'       => $object->getbksordered_date(),
				  	      'bksordered_time'  	  => $object->getbksordered_time(),
					      'bksorder_made_on_date' => $object->getbksorder_made_on_date(),
					      'bksorder_made_on_time' => $object->getbksorder_made_on_time(),
					      'bksamount'			  => $object->getbksamount(),
					      'bksorder_status'       => $object->getbksorder_status(),
					      'bkscreatedby'  		  => $object->getbkscreatedby(),
				          'bkscreateddatetime'    => $object->getbkscreateddatetime()
					     );
	        $table  = $this->getDbTable();
	        $result = $table->insert($data);
	        return $result;	
		}catch(Exception $ex){			
			throw new Exception($ex->getMessage()) ;
		}		  
	}
	
	public function getCustBookingHistory(Reservation_Model_ReservationSpecial $splObj,$offset)
	{
		try{
			$limit = 5;
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);

			$select->from(array('bookspl'=>'mt.booking_special'),array('bksfk_booking','bksspecial_id','bksno_of_specials'))
					->join(array('book'=>'mt.booking'),'book.bokid = bookspl.bksfk_booking',array('bokid','bokfirst_name','boklast_name','bokemail','bokparty_size','bokphone','bokbooking_date','bokbooking_timings','bokbooking_status_id','bokbooking_made_on','bokbooking_made_time'))
					->join(array('spl'=>'mt.restaurant_special'),'spl.rspid = bookspl.bksspecial_id',array('rspid',
																   										   'rspfk_restaurant',
																   										   'rspno_of_dishes',
																   										   'rspspecial_title',
																   										   'rspregular_price',
																										   'rspspecial_image',
																										   'rspdiscount_percentage_point',
																										   'rspprice_with_discount',
																										   'rspkids_eat_free',
																										   'rspstart_date',
																										   'rspend_date',
																										   'rspstart_time',
																										   'rspend_time',
																										   'rspdescription',
																										   'rspfood_type',
																										   'rspspecial_type',
																										   'rsprecurencestatus',
																										   'rspstatus',
																										   'rspkidsstatus',
																										   'rspcategory',
																										   'rsptype_of_occurance',
																										   'rspdiscount_mode'))
					->join(array('rest'=>'mt.restaurant'),'rest.resid = spl.rspfk_restaurant',array('resrestaurant_name','resaddress','resphone'))
					->join(array('bokbd'=>'mt.booking_status_bd'),'bokbd.id = book.bokbooking_status_id',array('description as bookingStatus'))
					->join(array('discmod'=>'mt.discount_mode_bd'),'discmod.id = spl.rspdiscount_mode',array('description as discMode'))
					->join(array('spb'=>'mt.special_type_bd'),'spb.id = spl.rspspecial_type',array('description as special'))
					->join(array('spcat'=>'mt.special_category_bd'),'spcat.id = spl.rspcategory',array('description as splCategory'))
					->join(array('splcnt'=>'mt.special_count_type_bd'),'splcnt.id = spl.rsptype_of_occurance',array('description as splCount'))
					->where('book.bokuserid = ?',$splObj->getbkscreatedby());
			$resultSet = $table->fetchAll($select);
//			$resultSet = new Zend_Paginator(
//			new Zend_Paginator_Adapter_DbTableSelect($select)
//			);
//			$resultSet->setItemCountPerPage($limit);
//			$resultSet->setCurrentPageNumber($offset);
			foreach($resultSet as $row){
				if($row->rsprecurencestatus){
					$reoccMapper = new Deals_Model_RestaurantSpecialRecurenceDataMapper();
					$reTable = $reoccMapper->getDbTable();
					$reoccSelect = $reTable->select();
					$reoccSelect->setIntegrityCheck(false);
					$reoccSelect->from(array('rsr'=>'mt.restaurant_special_reccurence'),array('rsrid','rsrday_of_week'))
								->join(array('wrb'=>'mt.weekly_recurence_bd'),'wrb.id = rsr.rsrday_of_week',array('description as day'))
								->where('rsr.rsrfk_restaurant_special = ? ',$row->rspid);
					$rowResult = $reTable->fetchAll($reoccSelect);
				}else{
					$rowResult = "";
				}
				if(strlen($row->rspdescription) > 200){
					$description = substr($row->rspdescription, 0, 200)." ...";
				}else{
					$description = $row->rspdescription;
				}
				$splObj = new Deals_Model_RestaurantSpecial();
				$splObj->setId($row->rspid)
					   ->setRestaurantname($row->resrestaurant_name)
						->setAddress($row->resaddress)
						->setRestaurantid($row->rspfk_restaurant)
						->setNoofdishes($row->rspno_of_dishes)
						->setSpecialtypename($row->special)
						->setSpecialtypeid($row->rspspecial_type)
						->setSpecialtitle($row->rspspecial_title)
						->setSpecialimage($row->rspspecial_image)
						->setStartdate($row->rspstart_date)
						->setEnddate($row->rspend_date)
						->setStarttime($row->rspstart_time)
						->setEndtime($row->rspend_time)
						->setDescription($description)
						->setSpecialrecurence($row->rsprecurencestatus)
						->setKidsinfo($row->rspkids_eat_free)
						->setKidsstatus($row->rspkidsstatus)
						->setSpecialCount($row->rsptype_of_occurance)
						->setSpecialCategoryType($row->rspcategory)
						->setSpecialCategoryTypeName($row->splCategory)
						->setSpecialCountName($row->splCount)
						->setDiscountMode($row->discMode)
						->setRegprice($row->rspregular_price)
						->setDispercentage($row->rspdiscount_percentage_point)
						->setPricewithdiscount($row->rspprice_with_discount)
						->setStatus($row->rspstatus)
						->setPhone($row->resphone)
						->setSplDate($row->bokbooking_date)
						->setSplTime($row->bokbooking_timings)
						->setNoOfSpl($row->bksno_of_specials);
				$splWeek = array();
				if($rowResult){
					foreach($rowResult as $value){
						$splRecurenceObj = new Deals_Model_RestaurantSpecialRecurence();
						$splRecurenceObj->setWeekId($value->rsrday_of_week);
						$splRecurenceObj->setWeekDesc($value->day);
						$splWeek[] = $splRecurenceObj;
					}
				}
				$splObj->setWeekids($splWeek);
				$resDet[$row->bokid] = $splObj;
			}
			return $resDet;
			
		}catch(Exception $ex){			
			throw new Exception($ex->getMessage()) ;
		}	
	}
	
	public function getCusSplBookingHistoryBysplid(Reservation_Model_ReservationSpecial $splObj)
	{
		try{
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			
			$select->from(array('bookspl'=>'mt.booking_special'),array('bksfk_booking','bksspecial_id','bksno_of_specials','bksamount'))
					->join(array('book'=>'mt.booking'),'book.bokid = bookspl.bksfk_booking',array('bokid','bokfirst_name','boklast_name','bokemail','bokparty_size','bokphone','bokbooking_date','bokbooking_timings','bokbooking_status_id','bokbooking_made_on','bokbooking_made_time'))
					->join(array('spltrn'=>'mt.special_transactions'),'spltrn.spltxnfk_booking_id = book.bokid',array('spltxntransaction_amount'))
					->join(array('boksts'=>'mt.booking_status_bd'),'boksts.id = book.bokbooking_status_id',array('description as bokstatus'))
					->where('bookspl.bksspecial_id = ?',$splObj->getbksid());
			
			$resultSet = $table->fetchAll($select);
			$resDet = array();
			foreach($resultSet as $row){
				$splObj = new Deals_Model_RestaurantSpecial();
				$splObj->setSplbokname($row->bokfirst_name.' '.$row->bokfirst_name)
						->setSplbokemail($row->bokemail)
						->setSplbokphone($row->bokphone)
						->setSplbokid($row->bokid)
						->setSplDate($row->bokbooking_date)
						->setSplTime($row->bokbooking_timings)
						->setSplmadedate($row->bokbooking_made_on)
						->setSplmadetime($row->bokbooking_made_time)
						->setSplbokamount($row->spltxntransaction_amount)
						->setSplsplbokpax($row->bokparty_size)
						->setSplbokstatus($row->bokstatus);
				$resDet[$row->bokid] = $splObj;
			}
			return $resDet;
		}catch(Exception $ex){			
			throw new Exception($ex->getMessage()) ;
		}
	}
}