<?php
/**
*	Name			: ReservationTableMapper.php
*	Author			: snehal
*	Creation Date	: 4/19/2011
*	Path 			: application/modules/Reservation/models/ReservationTableMapper.php
*	Description		: This is the datamapper class for bookingtables table.
*					   	
*/
class Reservation_Model_ReservationTableMapper
{
	/**
	 * Instance variable of bookingtables table
	 * @var object
	 */
	protected $_dbTable;

	/**
     * @param instance of DbTable bookingtables $dbTable
     * @return self
     */
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	/**
     * @return instance of DbTable bookingtables
     */
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Reservation_Model_DbTable_ReservationTables');
		}
		return $this->_dbTable;
	}
	
	public function retrieveSeatedInventory(Reservation_Model_GetSeatedInventoryByDate $getSeatInv)
	{
		try
		{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			
			$select->from(array('bt'=>'mt.booking_tables'),array('bktbtableid'))
			       ->join(array('bok'=>'mt.booking'),'bt.bktbfk_booking = bok.bokid',array('bokparty_size'))
			       ->join(array('rst'=>'mt.restaurant_tables'),'rst.rstid = bt.bktbtableid',array('rsttable_pax','rsttable_number'))
			       ->where('bok.bokfk_restaurant = ?',$getSeatInv->getrestid())
			       ->where('bok.bokbooking_date = ?',$getSeatInv->getdate())
			       ->where('bok.bokbooking_status_id != ?',5)
			       ->where('bt.status = ?',true);

			 $result = array();      
			
			 $rowset = $table->fetchAll($select);
			 
			 if(count($rowset) > 0)
			 {
			 	foreach($rowset as $row)
			 	{
			 		
//			 		if(array_key_exists($row->bktbtableid,$result))
//					{
//						$sum = $result[$row->bktbtableid];
//			 			$result[$row->bktbtableid] = $sum + $row->bokparty_size;
//					}else{
						$result[$row->bktbtableid] =  $row->bokparty_size;
//					}
			 	}
			 }
			 
			 return $result;
			
		}
		catch (Exception $ex)
		{	
			throw new Exception($ex->getMessage());
		}
	}

}