<?php

class Reservation_Model_RestScheduleSettingMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Reservation_Model_DbTable_RestScheduleSetting');
		}
		return $this->_dbTable;
	}
	//schedule setting base data values 	
	public function GetScheduleSetting()
	{
		$cache = new Uss_Helper_CacheManager();
		$schedulestatus = array();
		if(!$schedulestatus = $cache->Fetch('schedulestatus')){
			$where = array('status = ?'=> true);
			$records = $this->getDbTable()->fetchAll($where);
						
			foreach($records as $record){
				$schedulestatus[] = new Reservation_Model_RestScheduleSetting($record->toArray());	
			}
			$cache->Save($schedulestatus,'schedulestatus');			
		}else{
			$schedulestatus = $cache->Fetch('schedulestatus');
		}
		$cache = null;
		return $schedulestatus;
	}
	//retriving the schedule setting base data value by code
	public function GetScheduleSettingByCode($code)
	{
		$scheduleSettingList = $this->GetScheduleSetting();
		$arrayCount = count($code);
		$count = 0;
		foreach($scheduleSettingList as $key=>$value)
		{
			if($value->getcode() == $code)
			{
				$result = $value; 
				$count++;
				if($count == $arrayCount)
				{
					break;
				}				
			}				
		}
	 return $result;
	}
}
?>
