<?php
/**
*	Name			: BlockTable.php
*	Author			: snehal
*	Creation Date	: 1/13/2011
*	Path 			: application/modules/Reservation/models/BlockTable.php
*	Description		: This is the Model class for blocking a table.
*					   	
*/
class Reservation_Model_RestaurantCustomMenu
{
	/**
	 * 
	 * @var integer
	 */
	private $_restid;
	
	/**
	 * 
	 * @var integer
	 */
	private $_id;
	
	/**
	 * 
	 * @var boolean
	 */
	private $_status;
	
	/**
	 * 
	 * @var integer
	 */
	private $_menuType;
	
	/**
	 * 
	 * @var integer
	 */
	private $_menuDesc;
	private $_menuCode;
	
	/**
     * Public constructor
     *
     * @param  array $options
     */
	public function __construct(array $options = null)
	{
		if(is_array($options)){
			$this->setOptions($options);
		}		
	}
	
	/**
	 * Writing data to properties
	 */
	public function __set($name, $value)
	{
		$method = 'set' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Reservation property');
		}
		$this->$method($value);
	}
	
	/**
	 * Reading data from properties
	 */
	public function __get($name)
	{
		$method = 'get' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Reservation property');
		}
		return $this->$method();
	}
	
	/**
     * @param integer $restid
     * @return self
     */
	public function setRestId($restid)
	{
		$this->_restid = $restid;
		return $this;
	}
	
	 /**
     * @return integer
     */
	public function getRestId()
	{
		return $this->_restid;
	} 
	
	/**
     * @param integer $tableid
     * @return self
     */
	public function setId($tableid)
	{
		$this->_id = $tableid;
		return $this;
	}
	
	 /**
     * @return integer
     */
	public function getId()
	{
		return $this->_id;
	}
	
	/**
     * @param boolean $status
     * @return self
     */
	public function setStatus($status)
	{
		$this->_status = $status;
		return $this;
	}
	
	/**
     * @return boolean
     */
	public function getStatus()
	{
		return $this->_status;
	}
	
	/**
     * @param integer $tablestatusid
     * @return self
     */
	public function setMenuType($MenuType)
	{
		$this->_menuType = $MenuType;
		return $this;	
	}
	
	/**
     * @return integer
     */
	public function getMenuType()
	{
		return $this->_menuType;
	}
	
	/**
     * @param integer $tablepax
     * @return self
     */
	public function setMenuDesc($MenuDesc)
	{
		$this->_menuDesc = $MenuDesc;
		return $this;	
	}
	
	/**
     * @return integer
     */
	public function getMenuDesc()
	{
		return $this->_menuDesc;
	}
	
	public function setMenuCode($MenuCode)
	{
		$this->_menuCode = $MenuCode;
		return $this;	
	}
	
	/**
     * @return integer
     */
	public function getMenuCode()
	{
		return $this->_menuCode;
	}
}