<?php
/**
*	Name			: BlockTableDataMapper.php
*	Author			: snehal
*	Creation Date	: 1/13/2011
*	Path 			: application/modules/Reservation/models/BlockTableDataMapper.php
*	Description		: This is the datamapper class for blocking a table.
*					   	
*/
class Reservation_Model_RestaurantCustomMenuMapper
{
	/**
	 * Instance variable of blocking a table
	 * @var object
	 */
	protected $_dbTable;

	/**
     * @param instance of DbTable restaurant_table_status $dbTable
     * @return self
     */
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	/**
     * @return instance of DbTable restaurant_table_status
     */
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Reservation_Model_DbTable_RestaurantCustomMenu');
		}
		return $this->_dbTable;
	}
	
	public function ManageCustomMenu(Reservation_Model_RestaurantCustomMenu $custom)
	{
		try{
			$select = $this->getDbTable()->select();
			$table = $this->getDbTable();
			$select->from($table,array('rcm_id','rcm_fk_restaurant','rcm_code','rcm_desc','rcm_status','rcm_menu_type'))
					->where('rcm_fk_restaurant = ?', $custom->getRestId())
					->where('rcm_code = ?',$custom->getMenuCode())
					->where('rcm_menu_type = ?',$custom->getMenuType());
//					->where('rcm_status = ?','T');
			$resultSet = $this->getDbTable()->fetchRow($select);
			$result = array();
			if($resultSet){
				$set = array('rcm_desc'	=>	$custom->getMenuDesc());
				if(!$resultSet->rcm_status){
					$set['rcm_status'] = 'T';
				}				
				$where = array('rcm_id = ?'	=>	$resultSet->rcm_id);
				$result['result'] = $this->getDbTable()->update($set,$where);
		//		$result['status'] = 'update';
				if($result){
					$result['status'] = $custom->getMenuDesc();
				}
			}else{
				$data = array(	'rcm_menu_type'		=>	$custom->getMenuType(),
								'rcm_fk_restaurant'	=>	$custom->getRestId(),
								'rcm_code'			=>	$custom->getMenuCode(),
								'rcm_desc'			=>	$custom->getMenuDesc(),
								'rcm_status'		=>	$custom->getStatus(),
							);
				$result['result'] = $this->getDbTable()->insert($data);
		//		$result['status'] = 'add';
				if($result){
					$result['status'] = $custom->getMenuDesc();
				}
			}
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetCustomMenu(Reservation_Model_RestaurantCustomMenu $custom,$stat)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->setIntegrityCheck(false);
			$select->from($this->getDbTable(),array('rcm_id','rcm_fk_restaurant','rcm_code','rcm_desc','rcm_status','rcm_menu_type'))
					->where('rcm_fk_restaurant = ?', $custom->getRestId());
			if($stat == 'get'){
				$select->where('rcm_status = ?','T');
			}
			$resultSet = $this->getDbTable()->fetchAll($select);
			$result = array();
			foreach($resultSet as $row){
				if($row){
					$status = 'Inactive';
					if($row->rcm_status){
						$status = 'Active';
					}
					$result[$row->rcm_code] = array(
													'id'		=>	$row->rcm_id,
													'desc'		=>	$row->rcm_desc,
													'menuType'	=>	$row->rcm_menu_type,
													'status'	=>	$status
					);
//					$reservMenuArr[$row->rcm_code] = $row->rcm_desc.'_'.$row->rcm_id;
				}
			}
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function ChangeCustomMenuStatus(Reservation_Model_RestaurantCustomMenu $custom)
	{
		try{
			$select = $this->getDbTable()->select();
			$table = $this->getDbTable();
			$select->from($table,array('rcm_id','rcm_fk_restaurant','rcm_code','rcm_desc','rcm_status','rcm_menu_type'))
					->where('rcm_fk_restaurant = ?', $custom->getRestId())
					->where('rcm_code = ?',$custom->getMenuCode())
					->where('rcm_menu_type = ?',$custom->getMenuType());
//					->where('rcm_status = ?','T');
			$resultSet = $this->getDbTable()->fetchRow($select);
			$result = array();
			if($resultSet){
				$set = array();
				if(!$resultSet->rcm_status){
					$set['rcm_status'] = 'T';
					$result['status'] = 'T';
				}else{
					$set['rcm_status'] = 'F';
					$result['status'] = 'F';
				}
				$where = array('rcm_id = ?'	=>	$resultSet->rcm_id);
				$result['result'] = $this->getDbTable()->update($set,$where);
	//			$result['status'] = 'update';
			}
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}