<?php
/**
*	Name			: RestaurantFreezeDataMapper.php
*	Author			: snehal
*	Creation Date	: 10/27/2010
*	Path 			: application/modules/Reservation/models/RestaurantFreezeDataMapper.php
*	Description		: This is the datamapper class for restaurant freeze table.
*					   	
*/
class Reservation_Model_RestaurantFreezeDataMapper
{
	/**
	 * Instance variable of restaurant freeze table
	 * @var object
	 */
	protected $_dbTable;

	/**
     * @param instance of DbTable restaurant freeze $dbTable
     * @return self
     */
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	/**
     * @return instance of DbTable restaurant freeze
     */
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Reservation_Model_DbTable_RestaurantFreeze');
		}
		return $this->_dbTable;
	}

	/**
	 * @param instance of freeze and freezetimes
	 * function to freeze the all the slots or selected slots for the restaurant
	 */
	public function FreezeReservation(Reservation_Model_RestaurantFreeze $freeze,Reservation_Model_RestaurantFreezeTimeMap $frzTime)
	{
		try{	
			$selectedTimesArray = array();
			$status = false;
			$db = Zend_Db_Table::getDefaultAdapter();
				$storage = new Zend_Auth_Storage_Session();
				$storeddata = $storage->read();
				if(!is_array($storeddata['User_Id']))
				{
					$storeddata['User_Id'] = $freeze->getfrzfreezeddby();
				}
				$db->beginTransaction();
				$table = $this->getDbTable();
				$selectedTimesArray = explode(",",$frzTime->getfrzfreezedtime());
				/* Freeze type for whole day*/
				$restMapperObj = new FirmManagement_Model_FirmDataMapper();
				$restSchSettingObj = $restMapperObj->getScheduleSettingTypeByresId($freeze->getfrzfk_restaurant());
				
				if($freeze->getfrztype() == 'All'){
					$select = $table->select();
					$select->from($table,array('frzid','frzfreezedate','frztype'))
					->where('frzfreezedate = ?',$freeze->getfrzfreezeddate())
					->where('frzfk_restaurant = ?',$freeze->getfrzfk_restaurant());
					if($restSchSettingObj['settingId'] && ($restSchSettingObj['settingType'] != 'SAC')){
						$select->where('frz_restsch_setting_id =?',$restSchSettingObj['settingId']);
					}else{
						$select->where('frz_restsch_setting_id =?',1);
					}
					$row = $table->fetchRow($select);
					
					/* if Freeze does not exists for the day*/
					
					if(!$row){
						$data = array('frzfk_restaurant' => $freeze->getfrzfk_restaurant(),
						      'frzstatus' 		=> $freeze->getfrzstatus(),
							  'frzfreezedate' 	=> $freeze->getfrzfreezeddate(),
							  'frzfreezeddby'	=> $freeze->getfrzfreezeddby(),
							  'frztype'			=> $freeze->getfrztype(),
							  'frzdesc'			=> $freeze->getfrzdesc(),
							  'frzcreatedby'	=> $storeddata['User_Id'],
							  'frzcreateddatetime'=>date('Y-m-d H:i:s')
						);
						if($restSchSettingObj['settingType'] == 'UL'){
							$data['frz_restsch_setting_id'] = $restSchSettingObj['settingId'];
						}else if($restSchSettingObj['settingType'] == 'SMC'){
							$data['frz_restsch_setting_id'] = $restSchSettingObj['settingId'];
						}else if($restSchSettingObj['settingType'] == 'SL'){
							$data['frz_restsch_setting_id'] = $restSchSettingObj['settingId'];
						}else{
							$data['frz_restsch_setting_id'] = 1;
						}
						if($freeze->getfrzdesc()){
							$data['frzdesc'] = $freeze->getfrzdesc();
						}
						$frzid = $table->insert($data);//insert new freeze 
						
						$mapper = new Reservation_Model_RestaurantFreezeTimeMapDataMapper();
						$frzTable = $mapper->getDbTable();
						$frzSelect = $frzTable->select();
						$frzSelect->from($frzTable,array('rftmfrz_time','rftmid'))
								  ->where('rftm_frzid = ?',$frzid)
								  ->where('rftm_frzresid = ?',$freeze->getfrzfk_restaurant());
						$rowSet = $frzTable->fetchAll($frzSelect);
						$freezedTimesArray = array();
						foreach($rowSet as $timings){
							$freezedTimesArray[$timings->rftmid] = $timings->rftmfrz_time;
						}
						$frzTime->setfrzid($frzid);
						
						for($j = 0;$j < count($selectedTimesArray)-1;$j++){
							$timesArray = explode('-',$selectedTimesArray[$j]);
							$search = array_search($timesArray[0],$freezedTimesArray);
							$varType = gettype($search);
							if(!$search){
								$timedata = array(
											'rftm_frzid'			=>	$frzTime->getfrzid(),
											'rftm_frzresid'			=>	$frzTime->getfrzfk_restaurant(),
											'rftmfrz_time'			=>	$timesArray[0],
											'rftmfrz_status'		=>	$frzTime->getfrzstatus(),
											'rtfmcreatedby'			=>	$storeddata['User_Id'],
											'rtfmcreateddatetime'	=>	date('Y-m-d H:i:s')
								);
								$frzmapid = $frzTable->insert($timedata);
							}//if time is not freezed then freeze the time
						}
					}else{/* If freeze already exitst for the day*/
						$frzid = $row->frzid;
						/* if the existing freeze type is all or for the complete day then unfreeze the complete day*/
						if(trim($row->frztype) == 'All'){
							$mapper = new Reservation_Model_RestaurantFreezeTimeMapDataMapper();
							$frzTable = $mapper->getDbTable();
							
							$frzwhere = array(
								'rftm_frzid = ?'			=>	$frzid
							);
							$frzTable->delete($frzwhere);
							
							$where = array('frzfk_restaurant = ?' => $freeze->getfrzfk_restaurant(),
							   				'frzid = ?'=>$frzid);
							$table->delete($where);
						}else{
							/* if the existing freeze type is Slot then update it to all and freeze all the slots*/
							
							$set = array('frztype'=>$freeze->getfrztype(),
										 'frzdesc'=> $freeze->getfrzdesc(),
										 'frzupdatedby'	=> $storeddata['User_Id'],
							  		 	 'frzupdateddatetime'=>date('Y-m-d H:i:s'));
							if($freeze->getfrzdesc()){
								$set['frzdesc'] = $freeze->getfrzdesc();
							}
							
							$where = array('frzid = ?'=>$row->frzid);
							$table->update($set,$where);
							
							$mapper = new Reservation_Model_RestaurantFreezeTimeMapDataMapper();
							$frzTable = $mapper->getDbTable();
							$frzSelect = $frzTable->select();
							$frzSelect->from($frzTable,array('rftmfrz_time','rftmid'))
									  ->where('rftm_frzid = ?',$frzid)
									  ->where('rftm_frzresid = ?',$freeze->getfrzfk_restaurant());
							$rowSet = $frzTable->fetchAll($frzSelect);
							$freezedTimesArray = array();
							foreach($rowSet as $timings){
								$freezedTimesArray[$timings->rftmid] = $timings->rftmfrz_time;
							}
		//					if(!count($freezedTimesArray)){
		//						$whereFail = array('frzid = ?'=>$frzid);
		//						$table->delete($whereFail);
		//					}
							$frzTime->setfrzid($frzid);
							
							for($j = 0;$j < count($selectedTimesArray)-1;$j++){
								$timesArray = explode('-',$selectedTimesArray[$j]);
								$search = array_search($timesArray[0],$freezedTimesArray);
								$varType = gettype($search);
								if(!$search){
									$timedata = array(
												'rftm_frzid'			=>	$frzTime->getfrzid(),
												'rftm_frzresid'			=>	$frzTime->getfrzfk_restaurant(),
												'rftmfrz_time'			=>	$timesArray[0],
												'rftmfrz_status'		=>	$frzTime->getfrzstatus(),
												'rtfmcreatedby'			=>	$storeddata['User_Id'],
												'rtfmcreateddatetime'	=>	date('Y-m-d H:i:s')
									);
									$frzmapid = $frzTable->insert($timedata);
								}
							}
						}
					}
					
				}else{
					/* Freeze type for Slots */
					
					$select = $table->select();
					$select->from($table,array('frzid','frzfreezedate'))
					->where('frzfreezedate = ?',$freeze->getfrzfreezeddate())
					->where('frzfk_restaurant = ?',$freeze->getfrzfk_restaurant());
					if($restSchSettingObj['settingId'] && ($restSchSettingObj['settingType'] != 'SAC')){
						$select->where('frz_restsch_setting_id =?',$restSchSettingObj['settingId']);
					}else{
						$select->where('frz_restsch_setting_id =?',1);
					}
					$row = $table->fetchRow($select);
					
					/* if the freeze does not exists for the day */
					
					if(!$row){
						$data = array('frzfk_restaurant' => $freeze->getfrzfk_restaurant(),
						      'frzstatus' 		=> $freeze->getfrzstatus(),
							  'frzdesc'			=> $freeze->getfrzdesc(),
							  'frzfreezedate' 	=> $freeze->getfrzfreezeddate(),
							  'frzfreezeddby' 	=> $freeze->getfrzfreezeddby(),
							  'frztype'			=> $freeze->getfrztype(),
							  'frzcreatedby'	=> $storeddata['User_Id'],
							  'frzcreateddatetime'=>date('Y-m-d H:i:s'));
						if($freeze->getfrzdesc()){
							$data['frzdesc'] = $freeze->getfrzdesc();
						}
						if($restSchSettingObj['settingType'] == 'UL'){
							$data['frz_restsch_setting_id'] = $restSchSettingObj['settingId'];
						}else if($restSchSettingObj['settingType'] == 'SMC'){
							$data['frz_restsch_setting_id'] = $restSchSettingObj['settingId'];
						}else if($restSchSettingObj['settingType'] == 'SL'){
							$data['frz_restsch_setting_id'] = $restSchSettingObj['settingId'];
						}else{
							$data['frz_restsch_setting_id'] = 1;
						}
						$frzid = $table->insert($data);
					}else{
						/* if the freeze exists for the day */
						
						$set = array('frztype'=>$freeze->getfrztype(),
								  	 'frzdesc'=> $freeze->getfrzdesc(),
									 'frzupdatedby'	=> $storeddata['User_Id'],
							  		 'frzupdateddatetime'=>date('Y-m-d H:i:s'));
						if($freeze->getfrzdesc()){
							$set['frzdesc'] = $freeze->getfrzdesc();
						}
						$where = array('frzid = ?'=>$row->frzid);
						$table->update($set,$where);
						$frzid = $row->frzid;
					}
					
					
					$mapper = new Reservation_Model_RestaurantFreezeTimeMapDataMapper();
					$frzTable = $mapper->getDbTable();
					$frzSelect = $frzTable->select();
					$frzSelect->from($frzTable,array('rftmfrz_time','rftmid'))
							  ->where('rftm_frzid = ?',$frzid)
							  ->where('rftm_frzresid = ?',$freeze->getfrzfk_restaurant());
					$rowSet = $frzTable->fetchAll($frzSelect);
					$freezedTimesArray = array();
					foreach($rowSet as $timings){
						$freezedTimesArray[$timings->rftmid] = $timings->rftmfrz_time;
					}
//					if(!count($freezedTimesArray)){
//						$whereFail = array('frzid = ?'=>$frzid);
//						$table->delete($whereFail);
//					}
					$frzTime->setfrzid($frzid);
					
					for($j = 0;$j < count($selectedTimesArray)-1;$j++){
						$timesArray = explode('-',$selectedTimesArray[$j]);
						$search = array_search($timesArray[0],$freezedTimesArray);
						$varType = gettype($search);
						/* if the selected slot is already exists then unfreeze it */
						
						if($varType == 'integer'){
							$frzwhere = array(
								'rftmid = ?'=>$search
							);
							if($freeze->getfrzselAllStatus() == 'unfreezeAll'){
								$frzTable->delete($frzwhere);
							}
							unset($freezedTimesArray[$search]);
						}else{
							/* if the selected slot does not exists then freeze it */
							
							$timedata = array(
										'rftm_frzid'			=>	$frzTime->getfrzid(),
										'rftm_frzresid'			=>	$frzTime->getfrzfk_restaurant(),
										'rftmfrz_time'			=>	$timesArray[0],
										'rftmfrz_status'		=>	$frzTime->getfrzstatus(),
										'rtfmcreatedby'			=>	$storeddata['User_Id'],
										'rtfmcreateddatetime'	=>	date('Y-m-d H:i:s')
							);
							$frzmapid = $frzTable->insert($timedata);
							$freezedTimesArray[$frzmapid] = $timesArray[0];
						}
					}
					if(!count($freezedTimesArray)){
						
						/* if the freezed times are empty then unfreeze the complete day from freeze table*/
						
						$delwhere = array('frzfk_restaurant = ?' => $freeze->getfrzfk_restaurant(),
							   				'frzid = ?'=>$frzid);
							$table->delete($delwhere);
					}
				}	
				
				
				$db->commit();
				$status = true;
			}catch(Exception $ex){
				$db->rollBack();
				throw new Exception($ex->getMessage()) ;
			}
			return $status;
	}

	/**
	 * @param restaurantid and freezeddates
	 * function to Unfreeze the restaurant
	 */
	public function UnFreeze($restid,$freezedates)
	{
			$unfreezedatesArr = array();
			$status = false;
			$db = Zend_Db_Table::getDefaultAdapter();
			try{
				$db->beginTransaction();
				$table = $this->getDbTable();
				$unfreezedatesArr = explode("-",$freezedates);
				for($i = 0;$i < count($unfreezedatesArr)-1;$i++){
					$where = array('frzfk_restaurant = ?' => (int)$restid,
							   'frzid = ?'=>(int)$unfreezedatesArr[$i]);
					$table->delete($where);
				}
				$db->commit();
				$status = true;
			}

			catch(Exception $ex){
				$db->rollBack();
				throw new Exception($ex->getMessage()) ;
			}
			return $status;
	}

	/**
	 * @param restaurantid 
	 * function to get all freezed dates of the restaurant
	 */
	public function GetFreezedDates($resid)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$restMapperObj = new FirmManagement_Model_FirmDataMapper();
			$restSchSettingObj = $restMapperObj->getScheduleSettingTypeByresId($resid);
			$select->from($table,array('frzid','frzfreezedate','frztype'))
			->where('frzfk_restaurant = ?',$resid);
			if($restSchSettingObj['settingType'] != 'SAC'){
				$select->where('frz_restsch_setting_id = ?',$restSchSettingObj['settingId']);
			}else{
				$select->where('frz_restsch_setting_id = ?',1);
			}
			$rowset = $table->fetchAll($select);
			$freezetime = array();
			foreach($rowset as $times){
				$mapper = new Reservation_Model_RestaurantFreezeTimeMapDataMapper();
				$frzTable = $mapper->getDbTable();
				$frzSelect = $frzTable->select();
				$frzSelect->from($frzTable,array('count(rftmid) as Count'))
						  ->where('rftm_frzid = ?',$times->frzid);
				$rowSet = $frzTable->fetchAll($frzSelect);
				foreach($rowSet as $row){
					$count = $row->Count;
				}
				if(!$count && $times['frztype'] == 'Slot'){
					$where = array('frzid = ?'=>$times['frzid']);
					$table->delete($where);
					continue;
				}
				
				$freezetime[$times['frzid']] = $times['frzfreezedate'];
			}
			return $freezetime;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetFreezedDatesByMonthRange($resid,$stDate,$endDate)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$restMapperObj = new FirmManagement_Model_FirmDataMapper();
			$restSchSettingObj = $restMapperObj->getScheduleSettingTypeByresId($resid);
			$select->from($table,array('frzid','frzfreezedate','frztype'))
			->where('frzfk_restaurant = ?',$resid)
			->where('frzfreezedate >= ?',$stDate)
			->where('frzfreezedate <= ?',$endDate);
			if($restSchSettingObj['settingType'] != 'SAC'){
				$select->where('frz_restsch_setting_id = ?',$restSchSettingObj['settingId']);
			}else{
				$select->where('frz_restsch_setting_id = ?',1);
			}
			$rowset = $table->fetchAll($select);
			$freezetime = array();
			foreach($rowset as $times){
				$mapper = new Reservation_Model_RestaurantFreezeTimeMapDataMapper();
				$frzTable = $mapper->getDbTable();
				$frzSelect = $frzTable->select();
				$frzSelect->from($frzTable,array('count(rftmid) as Count'))
						  ->where('rftm_frzid = ?',$times->frzid);
				$rowSet = $frzTable->fetchAll($frzSelect);
				foreach($rowSet as $row){
					$count = $row->Count;
				}
				if(!$count && $times['frztype'] == 'Slot'){
					$where = array('frzid = ?'=>$times['frzid']);
					$table->delete($where);
					continue;
				}
				
				$freezetime[$times['frzid']] = $times['frzfreezedate'];
			}
			return $freezetime;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetFreezeDatesByRestaurantd($restaurantid, $date)
	{
		try{
			$finalArr = array();
			$table = $this->getDbTable();
			$select = $table->select();
			$restMapperObj = new FirmManagement_Model_FirmDataMapper();
			$restSchSettingObj = $restMapperObj->getScheduleSettingTypeByresId($restaurantid);
			$select->from($table,array('frzid','frzfk_restaurant','frzfreezedate','frzfreezeddby','frzstatus','frztype','frzcreatedby','frzcreateddatetime','frzupdatedby','frzupdateddatetime','frzdesc'))
			->where('frzfk_restaurant = ?',$restaurantid)
			->where('frzfreezedate >= ?',$date);
			if($restSchSettingObj['settingType'] != 'SAC'){
				$select->where('frz_restsch_setting_id = ?',$restSchSettingObj['settingId']);
			}else{
				$select->where('frz_restsch_setting_id = ?',1);
			}
			$freezetabledata = $table->fetchAll($select);
			$freezeArr = array();
			$freezeIds = array();
			foreach($freezetabledata as $key=>$value){
				$subArr = array();
				$freezeIds[] = $value->frzid;
				foreach($value as  $key1=>$value1){
					if($key1 == 'frzcreatedby' || $key1 == 'frzupdatedby'){
						$subArr[$key1]= null;
					}else{
						$subArr[$key1]= $value1;
					}
				}
				$freezeArr[] = $subArr;
			}
			$freezemapArr = array();
			$key = "";
			$value = "";
			$key1 = "";
			$value1 = "";
			if($freezeArr){
				$mapper = new Reservation_Model_RestaurantFreezeTimeMapDataMapper();
				$frzmapTable = $mapper->getDbTable();
				$frzSelect = $frzmapTable->select();
				$frzSelect->from($frzmapTable,array('rftmid','rftm_frzid','rftm_frzresid','rftmfrz_status','rftmfrz_time','rtfmcreatedby','rtfmcreateddatetime','rtfmupdatedby','rtfmupdateddatetime'))
						  ->where('rftm_frzid IN(?)',$freezeIds);
				$freezemaptabledata = $frzmapTable->fetchAll($frzSelect);
				foreach($freezemaptabledata as $key=>$value){
					$subArr = array();
					foreach($value as  $key1=>$value1){
						if($key1 == 'rtfmcreatedby' || $key1 == 'rtfmupdatedby'){
							$subArr[$key1]= null;
						}else{
							$subArr[$key1]= $value1;
						}
					}
					$freezemapArr[] = $subArr;
				}
			}
			
			$finalArr = array('freezetabledata' 	=> $freezeArr,
							  'freezemaptabledata'	=> $freezemapArr);
			return $finalArr;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param instance of freeze status
	 * function to get all freezestatuses 
	 */
	public function GetFreezeStatus(Reservation_Model_GetFreezeStatus $freezestatus)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$restMapperObj = new FirmManagement_Model_FirmDataMapper();
			$restSchSettingObj = $restMapperObj->getScheduleSettingTypeByresId($freezestatus->getRestId());
			$select->from($table,array('frzstatus'))
			->where('frzfk_restaurant = ?',$freezestatus->getRestId())
			->where('frzfreezedate = ?',$freezestatus->getFreezeDate());
			if($restSchSettingObj['settingType'] != 'SAC'){
				$select->where('frz_restsch_setting_id = ?',$restSchSettingObj['settingId']);
			}else{
				$select->where('frz_restsch_setting_id = ?',1);
			}
			$row = $table->fetchRow($select);
			if($row){
				if($row->frzstatus){
					return true;
				}else{
					return false;
				}
			}else{
				return false;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getFreezeTypeByDate($resid, $date)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$restMapperObj = new FirmManagement_Model_FirmDataMapper();
			$restSchSettingObj = $restMapperObj->getScheduleSettingTypeByresId($resid);
			$select->from($table,array('frzdesc','frztype'))
			->where('frzfk_restaurant = ?',$resid)
			->where('frzfreezedate = ?',$date);
			if($restSchSettingObj['settingType'] != 'SAC'){
				$select->where('frz_restsch_setting_id = ?',$restSchSettingObj['settingId']);
			}else{
				$select->where('frz_restsch_setting_id = ?',1);
			}
			$row = $table->fetchRow($select);
			$result = array();
			if($row){
				$result['type'] = $row->frztype;
				$result['desc'] = $row->frzdesc;
			}
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function ManageFreezeFromNative($resid,$selDate,$selTimings,$userid,$frztypeAction,$desc,$descStat)
	{
		try{
			$frzTime = new Reservation_Model_RestaurantFreezeTimeMap();
			$db = Zend_Db_Table::getDefaultAdapter();
			$storage = new Zend_Auth_Storage_Session();
			$storeddata = $storage->read();
			$db->beginTransaction();
			$table = $this->getDbTable();
			$select = $table->select();
			$selectedTimes = array();
			$frzMapIdsArr = array();
			foreach($selTimings as $selT){
				$selectedTimes[] = $selT->rssid;
			}
			if($frztypeAction == "All"){
				
				
				$select->from($table,array('frzid','frzfreezedate','frztype'))
						->where('frzfreezedate = ?',$selDate)
						->where('frzstatus = true')
						->where('frzfk_restaurant = ?',$resid);
				$row = $table->fetchRow($select);
				if(!$row){
					$data = array('frzfk_restaurant' => $resid,
						      'frzstatus' 		=> true,
							  'frzfreezedate' 	=> $selDate,
							  'frzfreezeddby'	=> $userid,
							  'frztype'			=> $frztypeAction,
							  //'frzdesc'			=> $freeze->getfrzdesc(),
							  'frzcreatedby'	=> $userid,
							  'frzcreateddatetime'=>date('Y-m-d H:i:s')
						);
						if($descStat){
							$data['frzdesc'] = $desc;
						}
						$frzid = $table->insert($data);//insert new freeze 
						
						$mapper = new Reservation_Model_RestaurantFreezeTimeMapDataMapper();
						$frzTable = $mapper->getDbTable();
						$frzSelect = $frzTable->select();
						$frzSelect->from($frzTable,array('rftmfrz_time','rftmid'))
								  ->where('rftm_frzid = ?',$frzid)
								  ->where('rftm_frzresid = ?',$resid);
						$rowSet = $frzTable->fetchAll($frzSelect);
						
						$freezedTimesArray = array();
						foreach($rowSet as $timings){
							$freezedTimesArray[$timings->rftmid] = $timings->rftmfrz_time;
						}
						$frzTime->setfrzid($frzid);
						
						for($j = 0;$j < count($selectedTimes);$j++){
							$search = array_search ($selectedTimes[$j],$freezedTimesArray);
							$varType = gettype($search);
							if(!$search){
								$timedata = array(
											'rftm_frzid'			=>	$frzTime->getfrzid(),
											'rftm_frzresid'			=>	$resid,
											'rftmfrz_time'			=>	$selectedTimes[$j],
											'rftmfrz_status'		=>	'T',
											'rtfmcreatedby'			=>	$userid,
											'rtfmcreateddatetime'	=>	date('Y-m-d H:i:s')
								);
								$frzmapid = $frzTable->insert($timedata);
								$frzMapIdsArr[$selectedTimes[$j]] = $frzmapid;
							}//if time is not freezed then freeze the time
						}
				}else{
				/* If freeze already exitst for the day*/
					$frzid = $row->frzid;
					/* if the existing freeze type is all or for the complete day then unfreeze the complete day*/
					if(trim($row->frztype) == 'All'){
						$mapper = new Reservation_Model_RestaurantFreezeTimeMapDataMapper();
						$frzTable = $mapper->getDbTable();
						
						$frzwhere = array(
										'rftm_frzid = ?'			=>	$frzid
						);
						$frzTable->delete($frzwhere);
						
						$where = array('frzfk_restaurant = ?' => $resid,
						   				'frzid = ?'=>$frzid);
						$table->delete($where);
					}else{
						/* if the existing freeze type is Slot then update it to all and freeze all the slots*/
						
						$set = array('frztype'=>$frztypeAction,
									 //'frzdesc'=> $freeze->getfrzdesc(),
									 'frzupdatedby'	=> $userid,
						  		 	 'frzupdateddatetime'=>date('Y-m-d H:i:s'));
						if($descStat){
							$set['frzdesc'] = $desc;
						}
						$where = array('frzid = ?'=>$row->frzid);
						$table->update($set,$where);
						
						$mapper = new Reservation_Model_RestaurantFreezeTimeMapDataMapper();
						$frzTable = $mapper->getDbTable();
						$frzSelect = $frzTable->select();
						$frzSelect->from($frzTable,array('rftmfrz_time','rftmid'))
								  ->where('rftm_frzid = ?',$frzid)
								  ->where('rftm_frzresid = ?',$resid);
						$rowSet = $frzTable->fetchAll($frzSelect);
						$freezedTimesArray = array();
						foreach($rowSet as $timings){
							$freezedTimesArray[$timings->rftmid] = $timings->rftmfrz_time;
						}
	//					if(!count($freezedTimesArray)){
	//						$whereFail = array('frzid = ?'=>$frzid);
	//						$table->delete($whereFail);
	//					}
						$frzTime->setfrzid($frzid);
						
						for($j = 0;$j < count($selectedTimes);$j++){
							$search = array_search ($selectedTimes[$j],$freezedTimesArray);
							$varType = gettype($search);
							if(!$search){
								$timedata = array(
											'rftm_frzid'			=>	$frzTime->getfrzid(),
											'rftm_frzresid'			=>	$resid,
											'rftmfrz_time'			=>	$selectedTimes[$j],
											'rftmfrz_status'		=>	'T',
											'rtfmcreatedby'			=>	$userid,
											'rtfmcreateddatetime'	=>	date('Y-m-d H:i:s')
								);
								$frzmapid = $frzTable->insert($timedata);
								$frzMapIdsArr[$selectedTimes[$j]] = $frzmapid;
							}
						}
					}					
				}
			}else if($frztypeAction == "Slot"){
			/* Freeze type for Slots */
					
				$select = $table->select();
				$select->from($table,array('frzid','frzfreezedate'))
				->where('frzfreezedate = ?',$selDate)
				->where('frzfk_restaurant = ?',$resid);
				$row = $table->fetchRow($select);
				
				/* if the freeze does not exists for the day */
				
				if(!$row){
					$data = array('frzfk_restaurant' => $resid,
					      'frzstatus' 		=> 'T',
						  //'frzdesc'			=> $freeze->getfrzdesc(),
						  'frzfreezedate' 	=> $selDate,
						  'frzfreezeddby' 	=> $userid,
						  'frztype'			=> $frztypeAction,
						  'frzcreatedby'	=> $userid,
						  'frzcreateddatetime'=>date('Y-m-d H:i:s'));
					if($descStat){
						$data['frzdesc'] = $desc;
					}
					$frzid = $table->insert($data);
				}else{
					/* if the freeze exists for the day */
					
					$set = array('frztype'=>$frztypeAction,
							  	 //'frzdesc'=> $freeze->getfrzdesc(),
								 'frzupdatedby'	=> $userid,
						  		 'frzupdateddatetime'=>date('Y-m-d H:i:s'));
					if($descStat){
						$set['frzdesc'] = $desc;
					}
					$where = array('frzid = ?'=>$row->frzid);
					$table->update($set,$where);
					$frzid = $row->frzid;
				}
				
				
				$mapper = new Reservation_Model_RestaurantFreezeTimeMapDataMapper();
				$frzTable = $mapper->getDbTable();
				$frzSelect = $frzTable->select();
				$frzSelect->from($frzTable,array('rftmfrz_time','rftmid'))
						  ->where('rftm_frzid = ?',$frzid)
						  ->where('rftm_frzresid = ?',$resid);
				$rowSet = $frzTable->fetchAll($frzSelect);
				$freezedTimesArray = array();
				foreach($rowSet as $timings){
					$freezedTimesArray[$timings->rftmid] = $timings->rftmfrz_time;
				}
//					if(!count($freezedTimesArray)){
//						$whereFail = array('frzid = ?'=>$frzid);
//						$table->delete($whereFail);
//					}
				$frzTime->setfrzid($frzid);
				
				for($j = 0;$j < count($selectedTimes);$j++){
					$search = array_search($selectedTimes[$j],$freezedTimesArray);
					$varType = gettype($search);
					
					/* if the selected slot is already exists then unfreeze it */
					
					if($search){
						$frzwhere = array(
									'rftmid = ?'=>$search
						);
						$frzTable->delete($frzwhere);
						unset($freezedTimesArray[$search]);
					}else{
						
						/* if the selected slot does not exists then freeze it */
						
						$timedata = array(
									'rftm_frzid'			=>	$frzTime->getfrzid(),
									'rftm_frzresid'			=>	$resid,
									'rftmfrz_time'			=>	$selectedTimes[$j],
									'rftmfrz_status'		=>	'T',
									'rtfmcreatedby'			=>	$userid,
									'rtfmcreateddatetime'	=>	date('Y-m-d H:i:s')
						);
						$frzmapid = $frzTable->insert($timedata);
						$freezedTimesArray[$frzmapid] = $selectedTimes[$j];
						$frzMapIdsArr[$selectedTimes[$j]] = $frzmapid;
					}
				}
				if(!count($freezedTimesArray)){
					
					/* if the freezed times are empty then unfreeze the complete day from freeze table*/
					
					$delwhere = array('frzfk_restaurant = ?' => $resid,
						   				'frzid = ?'=>$frzid);
						$table->delete($delwhere);
				}
			}
			$db->commit();
			if(count($frzMapIdsArr) > 0){
			$finalArr = array(
							'frzid'		=>	$frzid,
							'frzMapArr'	=>	$frzMapIdsArr
						);
			}else
			{
				$finalArr = array(
							'frzid'		=>	$frzid,
							'frzMapArr'	=>	""
						);
			}
			return $finalArr;
		}catch(Exception $ex){
			$db->rollBack();
			throw new Exception($ex->getMessage()) ;
		}
		return $status;
	}
	
	public function getFreezeStatusForMealTypeByDateAndRestId($restaurantid, $date)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$restMapperObj = new FirmManagement_Model_FirmDataMapper();
			$restSchSettingObj = $restMapperObj->getScheduleSettingTypeByresId($restaurantid);
			$select->from($table,array('frzid','frztype'))
			->where('frzfk_restaurant = ?',$restaurantid)
			->where('frzfreezedate = ?',$date);
			if($restSchSettingObj['settingType'] != 'SAC'){
				$select->where('frz_restsch_setting_id = ?',$restSchSettingObj['settingId']);
			}else{
				$select->where('frz_restsch_setting_id = ?',1);
			}
			$row = $table->fetchRow($select);
			$result = array();
			$rowset = array();
			$weekday =  date('D', strtotime($date)); 
			if($row){
				if($row->frztype = "Slot"){
					$result['type'] = $row->frztype;
					$MealTypeDataMapper = new FirmManagement_Model_FirmMealTypeDataMapper();
					$MealTypes = $MealTypeDataMapper->GetRestaurantMealSettingsByRestId($restaurantid, "");
					foreach($MealTypes as $mealType){
						$count = 0;
						$mapper = new Reservation_Model_RestaurantFreezeTimeMapDataMapper();
						$frzmapTable = $mapper->getDbTable();
						$frzSelect = $frzmapTable->select();
						$frzSelect->setIntegrityCheck(false);
						$frzSelect->from($frzmapTable,array('COUNT(rftm_frzid) as count'))
								  ->join(array('mt.restaurant_schedule'),'rssid = rftmfrz_time',array(''))
								  ->where('rssstart_time >= ?',$mealType->rmt_start_time)
								  ->where('rssstart_time <= ?',$mealType->rmt_end_time)
								  ->where('rftm_frzid = ?',$row->frzid)
								  ->group(array('rftm_frzid'));
						$freezemaptabledata = $frzmapTable->fetchAll($frzSelect);
						
						$Schedulemapper = new Reservation_Model_SearchListViewDataMapper();
						$SchedulemapTable = $Schedulemapper->getDbTable();
						$ScheduleSelect = $SchedulemapTable->select();
						$ScheduleSelect->setIntegrityCheck(false);
						$ScheduleSelect->from($SchedulemapTable,array('COUNT(rssstart_time) as countt'))
//									   ->join(array('mt.restaurant_meal_type'),'rmt_restaurant = rssfk_restaurant',array(''))
									   ->where('rssstart_time >= ?',$mealType->rmt_start_time)
								  	   ->where('rssstart_time <= ?',$mealType->rmt_end_time)
								  	   ->where('rssfk_restaurant = ?',$restaurantid)
								  	   ->where('rssday_of_week = ?',strtolower($weekday))
									   ->where('rssstatus = ?', true);
						if($restSchSettingObj['settingId'] == 3){
							$ScheduleSelect->where('rssscheduletype_id = ?', 4);
						}else if($restSchSettingObj['settingId'] == 2){
							$ScheduleSelect->where('rssscheduletype_id = ?', 3);
						}else{
							$ScheduleSelect->where('rssscheduletype_id = ?', 1);
						}
//							$ScheduleSelect->where('rmt_meal_type = ?', $mealType->mealid);
								//	   ->group(array('rssstart_time'));
						$Scheduletabledata = $SchedulemapTable->fetchAll($ScheduleSelect);

						
						foreach($freezemaptabledata as $maprow){
							$count = $maprow->count;
						}
						if($count > 0){
							$result[$mealType->mealtype] = 'true';
						} 
						
						foreach($Scheduletabledata as $datarow){
							$schedulecount = $datarow->countt;
						}
						
						if($count == $schedulecount){
							$rowset[$mealType->mealtype] = 'true';
						}else{
							$rowset[$mealType->mealtype] = 'false';
						}
					}
					$result['count'] = $rowset;					
				}else if($row->frztype = 'All'){
					$result['type'] = $row->frztype;
				}
				
		//		$result['count'] = $rowset;
			}
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}