<?php
/**
*	Name			: RestaurantFreezeTimeMapDataMapper.php
*	Author			: Mahesh
*	Creation Date	: 6/7/2011
*	Path 			: application/modules/Reservation/models/RestaurantFreezeTimeMapDataMapper.php
*	Description		: This is the datamapper class for restaurant freeze timemap table.
*					   	
*/
class Reservation_Model_RestaurantFreezeDescMapDataMapper
{
	/**
	 * Instance variable of restaurant freeze timemap table
	 * @var object
	 */
	protected $_dbTable;

	/**
     * @param instance of DbTable restaurant freeze timemap $dbTable
     * @return self
     */
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	/**
     * @return instance of DbTable restaurant freeze timemap
     */
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Reservation_Model_DbTable_RestaurantFreezeDescMap');
		}
		return $this->_dbTable;
	}
	
	public function ManageFreezeDesc(Reservation_Model_RestaurantFreezeDescMap $desc)
	{
		try{
			$rowUpdate= "";
			$select = $this->getDbTable()->select();
			$select->from($this->getDbTable(),array('rfdm_id','rfdm_restaurant','rfdm_desc','rfdm_status'))
					->where('rfdm_restaurant = ?',$desc->getfrzfk_restaurant());
			$row = $this->getDbTable()->fetchRow($select);
			if($row){
				$set = array('rfdm_desc'=>$desc->getDesc());
				$rowUpdate = $this->getDbTable()->update($set,array('rfdm_restaurant = ?'=>$desc->getfrzfk_restaurant()));
			}else{
				$data = array('rfdm_restaurant'		=>	$desc->getfrzfk_restaurant(),
							  'rfdm_desc'			=>	$desc->getDesc(),
							  'rfdm_status'			=>	'T');
				$rowUpdate = $this->getDbTable()->insert($data);
			}
			return $rowUpdate;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getFreezeDesc($resid)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->from($this->getDbTable(),array('rfdm_id','rfdm_restaurant','rfdm_desc','rfdm_status'))
					->where('rfdm_restaurant = ?',$resid);
			$row = $this->getDbTable()->fetchRow($select);
			return $row;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}