<?php
class Reservation_Model_RestaurantSubscriptionFailAttemptsMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Reservation_Model_DbTable_RestaurantSubscriptionFailAttempts');
		}
		return $this->_dbTable;
	}
	
	public function ManageRestPaymentAttempts($resid,$data)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->from($this->getDbTable(),array('rfsa_attempts as attempts'))
					->where('rfsa_fk_resid = ?',$resid);
			$result = $this->getDbTable()->fetchRow($select);
			
			if($result == null){
				return 'none';
			}else if($result->attempts >= 5){
				
				$timezone = "";
				$mapper = new FirmManagement_Model_FirmDataMapper();
				$timezone = $mapper->GetRestaurantTimeZone($resid);
				date_default_timezone_set($timezone);
				$date = date('Y-m-d');
				$manualMapper = new Administrator_Model_RestaurantManualPaymentDetailsMapper();
				$manualPay = $manualMapper->getManualPaymentDetailsforRestaurant($resid);
				if($manualPay){
					if(strtotime($manualPay->rmpd_valid_from) <= strtotime($date) && strtotime($manualPay->rmpd_valid_to) >= strtotime($date)){
						$set = array('rfsa_attempts'=>0,
								'rfsa_last_login'=>$data['LastLoginDate']);
						$row_eff = $this->getDbTable()->update($set,array('rfsa_fk_resid = ?'=>$resid));
						return 'success';
					}
				}
				
				$set = array('resstatus'=>2);
				$resMapper = new FirmManagement_Model_FirmDataMapper();
				$row_eff = $resMapper->getDbTable()->update($set,array('resid = ?'=>$resid));
				return 'overflow';
			}else{
				$set = array('rfsa_attempts'=>$result->attempts+1,
								'rfsa_last_login'=>$data['LastLoginDate']);
				$row_eff = $this->getDbTable()->update($set,array('rfsa_fk_resid = ?'=>$resid));
				return $row_eff;  
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetRestPaymentAttempts($resid,$data)
	{
		try{
			$resMapper = new FirmManagement_Model_FirmDataMapper();
			$resSelect = $resMapper->getDbTable()->select();
			$resSelect->from($resMapper->getDbTable(),array('respaymentstatus','resid'))
						->where('resid = ?',$resid)
						->where('respaymentstatus = ?','F');
			$resResult = $resMapper->getDbTable()->fetchRow($resSelect);
			if($resResult){
				$timezone = "";
				$mapper = new FirmManagement_Model_FirmDataMapper();
				$timezone = $mapper->GetRestaurantTimeZone($resid);
				date_default_timezone_set($timezone);
				$date = date('Y-m-d');
				$manualMapper = new Administrator_Model_RestaurantManualPaymentDetailsMapper();
				$manualPay = $manualMapper->getManualPaymentDetailsforRestaurant($resid);
				if($manualPay){
					if(strtotime($manualPay->rmpd_valid_from) <= strtotime($date) && strtotime($manualPay->rmpd_valid_to) >= strtotime($date)){
						$set = array('rfsa_attempts'=>0,
								'rfsa_last_login'=>$data['LastLoginDate']);
						$row_eff = $this->getDbTable()->update($set,array('rfsa_fk_resid = ?'=>$resid));
						return 'success';
					}
				}
				$select = $this->getDbTable()->select();
				$select->from($this->getDbTable(),array('rfsa_attempts as attempts','rfsa_last_login'))
						->where('rfsa_fk_resid = ?',$resid);
				$result = $this->getDbTable()->fetchRow($select);
				if($result == null){
					$dataArr = array('rfsa_fk_resid'=>$resid,'rfsa_attempts'=>0,'rfsa_last_login'=>$data['LastLoginDate']);
					$result = $this->getDbTable()->insert($dataArr);
					return 5;
				}else if(strtotime($data['LastLoginDate']) == strtotime($result->rfsa_last_login)){ 
					return 'success';
				}else{
					return 5-$result->attempts;
				}
			}else{
				return 'success';
			}
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}