<?php

class Reservation_Model_SearchListView
{
	private $_id;
	private $_resid;
	private $_restownerid; 
	private $_restaurantname; 
    private $_restimage;   
    private $_restdesc;
    private $_starttime;
    private $_endtime;
    private $_time;
    private $_date;
    private $_day;
    private $_weekday_id;
    private $_pax;
    private $_interval;
    private $_address;
    private $_region;
    private $_city;
    private $_state;
    private $_neighbor;
    private $_parking;
    private $_cuisine;
	private $_price;
    private $_limit;
    private $_offset;
    private $_latitude;
    private $_longitude;
	private $_neighborhood;
	private $_noofseats;
	private $_prev;
	private $_next;
	private $_event;
	private $_reslandmark;
	private $_resavg_mealprice_max;
	private $_resavg_mealprice_min;
	private $_res_delevery;
	private $_reslunch_buffet;
	private $_resdinner_buffet;
	private $_res_wifi;
	private $_res_alcohol;
	private $_res_smoking;
	private $_res_ac;
	private $_res_party_allowed;
	private $_res_catering;
	private $_res_kids_section;
	private $_res_category;
	private $_searchCriteria;
	//private $_offset;
	    
    public function __construct(array $options = null)
	{
		if(is_array($options)){
			$this->setOptions($options);
		}		
	}
	
	public function __set($name, $value)
	{
		$method = 'set' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Restaurant property');
		}
		$this->$method($value);
	}
	
	public function __get($name)
	{
		$method = 'get' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Restaurant property');
		}
		return $this->$method();
	}
	
	public function setOptions(array $options)
	{
		$methods = get_class_methods($this);
		foreach ($options as $key => $value) {
			$method = 'set' . ucfirst($key);
			if (in_array($method, $methods)) {
				$this->$method($value);
			}
		}
		return $this;
	}
	public function setId($id)
	{
		$this->_id = $id;
		return $this;
	}
	
	public function getId()
	{
		return $this->_id;
	}
	public function setResId($resid)
	{
		$this->_resid = $resid;
		return $this;
	}
	
	public function getResId()
	{
		return $this->_resid;
	}
	
	public function setRestaurantname($restaurantname)
	{
	  $this->_restaurantname = $restaurantname;
	  return $this; 
	}
	
	public function getRestaurantname()
	{
	   return $this->_restaurantname;
	}
	
	
    public function setResimage($restimage)
    {
    	$this->_restimage = $restimage;
    	return $this;
    }
    
    public function getResimage()
    {
    	return $this->_restimage;
    }
	public function setResDesc($resdesc)
    {
    	$this->_restdesc = $resdesc;
    	return $this;
    }
    
    public function getResDesc()
    {
    	return $this->_restdesc;
    }
    
	public function setStartTime($startTime)
    {
    	$this->_starttime = $startTime;
    	return $this;
    }
    
    public function getStartTime()
    {
    	return $this->_starttime;
    }
	public function setEndTime($endTime)
    {
    	$this->_endtime = $endTime;
    	return $this;
    }
    
    public function getEndTime()
    {
    	return $this->_endtime;
    }
	public function setTime($time)
    {
    	$this->_time = $time;
    	return $this;
    }
    
    public function getTime()
    {
    	return $this->_time;
    }
	public function setDate($date)
    {
    	$this->_date = $date;
    	return $this;
    }
    
    public function getDate()
    {
    	return $this->_date;
    }
	public function setDay($day)
    {
    	$this->_day = $day;
    	return $this;
    }
    
    public function getDay()
    {
    	return $this->_day;
    }
	public function setPax($pax)
    {
    	$this->_pax = $pax;
    	return $this;
    }
    
    public function getPax()
    {
    	return $this->_pax;
    }
	public function setInterval($interval){
		$this->_interval = $interval;
    	return $this;
	}    
	public function getInterval(){
		return $this->_interval;
	}
	public function setAddress($address){
		$this->_address = $address;
    	return $this;
	}    
	public function getAddress(){
		return $this->_address;	
	}
	
	public function setRegion($region)
	{
		$this->_region = $region;
		return $this;
	}
	
	public function getRegion()
	{
		return $this->_region;
	}
	
	public function setCity($city)
	{
		$this->_city = $city;
		return $this;
	}
	
	public function getCity()
	{
		return $this->_city;
	}
	
	public function setState($state)
	{
		$this->_state = $state;
		return $this;
	}
	
	public function getState()
	{
		return $this->_state;
	}
	
	public function setNeighbor($neighbor)
	{
		$this->_neighbor = $neighbor;
		return $this;
	}
	
	public function getNeighbor()
	{
		return $this->_neighbor;
	}
	
	public function setCuisine($cuisine)
	{
		$this->_cuisine = $cuisine;
		return $this;
	}
	
	public function getCuisine()
	{
		return $this->_cuisine;
	}
	public function setLimit($limit)
	{
		$this->_limit = $limit;
		return $this;
	}
	
	public function getLimit()
	{
		return $this->_limit;
	}
	public function setOffset($offset)
	{
		$this->_offset = $offset;
		return $this;
	}
	
	public function getOffset()
	{
		return $this->_offset;
	}
	public function setLatitude($latitude)
	{
		$this->_latitude = $latitude;
		return $this;
	}
	
	public function getLatitude()
	{
		return $this->_latitude;
	}
	public function setLongitude($longitude)
	{
		$this->_longitude = $longitude;
		return $this;
	}
	
	public function getLongitude()
	{
		return $this->_longitude;
	}
	public function setParking($parking)
	{
		$this->_parking = $parking;
		return $this;
	}
	
	public function getParking()
	{
		return $this->_parking;
	}
	public function setPrice($price)
	{
		$this->_price = $price;
		return $this;
	}
	
	public function getPrice()
	{
		return $this->_price;
	}
	public function setNeighborhood($neighborhood)
	{
		$this->_neighborhood = $neighborhood;
		return $this;
	}
	
	public function getNeighborhood()
	{
		return $this->_neighborhood;
	}
	public function setNoOfSeats($noofseats)
	{
		$this->_noofseats = $noofseats;
		return $this;
	}
	
	public function getNoOfSeats()
	{
		return $this->_noofseats;
	}
	
	public function setevent($event){
		$this->_event = $event;
		return $this;
	}
	
	public function getevent()
	{
		return $this->_event;
	}
	
	public function setprev($prev)
	{
		$this->_prev = $prev;
		return $this; 
	}
	
	public function getprev()
	{
		return $this->_prev;
	}
	
	public function setnext($next)
	{
		$this->_next = $next;
		return $this;
	}
	
	public function getnext()
	{
		return $this->_next;
	}
	
	public function setreslandmark($_reslandmark)
	{
		$this->_reslandmark = $_reslandmark;
		return $this;
	}
	
	public function getreslandmark()
	{
		return $this->_reslandmark;
	}
	
	public function setresavg_mealprice_max($_resavg_mealprice_max)
	{
		$this->_resavg_mealprice_max = $_resavg_mealprice_max;
		return $this;
	}
	
	public function getresavg_mealprice_max()
	{
		return $this->_resavg_mealprice_max;
	}
	
	public function setresavg_mealprice_min($_resavg_mealprice_min)
	{
		$this->_resavg_mealprice_min = $_resavg_mealprice_min;
		return $this;
	}
	
	public function getresavg_mealprice_min()
	{
		return $this->_resavg_mealprice_min;
	}
	
	public function setres_delevery($_res_delevery)
	{
		$this->_res_delevery = $_res_delevery;
		return $this;
	}
	
	public function getres_delevery()
	{
		return $this->_res_delevery;
	}
	
	public function setreslunch_buffet($_reslunch_buffet)
	{
		$this->_reslunch_buffet = $_reslunch_buffet;
		return $this;
	}
	
	public function getreslunch_buffet()
	{
		return $this->_reslunch_buffet;
	}
	
	public function setresdinner_buffet($_resdinner_buffet)
	{
		$this->_resdinner_buffet = $_resdinner_buffet;
		return $this;
	}
	
	public function getresdinner_buffet()
	{
		return $this->_resdinner_buffet;
	}
	
	public function setres_wifi($_res_wifi)
	{
		$this->_res_wifi = $_res_wifi;
		return $this;
	}
	
	public function getres_wifi()
	{
		return $this->_res_wifi;
	}
	
	public function setres_alcohol($_res_alcohol)
	{
		$this->_res_alcohol = $_res_alcohol;
		return $this;
	}
	
	public function getres_alcohol()
	{
		return $this->_res_alcohol;
	}
	
	public function setres_smoking($_res_smoking)
	{
		$this->_res_smoking = $_res_smoking;
		return $this;
	}
	
	public function getres_smoking()
	{
		return $this->_res_smoking;
	}
	
	public function setres_ac($_res_ac)
	{
		$this->_res_ac = $_res_ac;
		return $this;
	}
	
	public function getres_ac()
	{
		return $this->_res_ac;
	}
	
	public function setres_party_allowed($_res_party_allowed)
	{
		$this->_res_party_allowed = $_res_party_allowed;
		return $this;
	}
	
	public function getres_party_allowed()
	{
		return $this->_res_party_allowed;
	}
	
	public function setres_catering($_res_catering)
	{
		$this->_res_catering = $_res_catering;
		return $this;
	}
	
	public function getres_catering()
	{
		return $this->_res_catering;
	}
	
	public function setres_kids_section($_res_kids_section)
	{
		$this->_res_kids_section = $_res_kids_section;
		return $this;
	}
	
	public function getres_kids_section()
	{
		return $this->_res_kids_section;
	}
	
	public function setSearchCriteria($search)

	{
		$this->_searchCriteria= $search;

		return $this;
	}
	
	public function getSearchCriteria()
	{
		return $this->_searchCriteria;
	}
	public function setWeekDayId($weekday_id)
	{
		$this->_weekday_id = $weekday_id;
		return $this;
	}
	
	public function getWeekDayId()
	{
		return $this->_weekday_id;
	}
}

