<?php
class Reservation_Model_WixWidgetDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Reservation_Model_DbTable_WixWidget');
		}
		return $this->_dbTable;
	}
	
	public function saveWixWidgetDetails($restaurantid, $compid)
	{
		try{
			$table = $this->getDbTable();
			$timezone = "";
			$mapper = new FirmManagement_Model_FirmDataMapper();
			$timezone = $mapper->GetRestaurantTimeZone($restaurantid);
			date_default_timezone_set($timezone);
			
			$data = array(
						'wwr_restaurantid'		=>	$restaurantid,
						'wwr_componentid'		=>	$compid,
						'wwr_create_date_time'	=>	date('Y-m-d h:i:s')		
					);
			$row_insert = $table->insert($data);
			return $row_insert;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}	
	
	public function deleteWixWidgetDetails($compid)
	{
		try{
			$table = $this->getDbTable();
			
			$where = array('wwr_componentid = ?'=>$compid);
			$status = $this->getDbTable()->delete($where);
			return $status;			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}	
	
	public function getRestaurntidByCompId($compid)
	{
		try{
			if($compid == ''){
				return 0;
			}else{
				$table = $this->getDbTable();
				$select = $table->select();
				
				$select->from($table,array('wwr_restaurantid'))
						->where('wwr_componentid= ?',$compid);
				$result = $table->fetchRow($select);
				if($result){
					return $result->wwr_restaurantid;
				}else{			
					return 0;
				}	
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
}