<?php

class Server_Model_ServerStatusbdMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Server_Model_DbTable_ServerStatusbd');
		}
		return $this->_dbTable;
	}
	
	public function fetchAll()
	{
		$cache = new Uss_Helper_CacheManager();
		$servstatus = array();
		if(!$restcategory = $cache->Fetch('serverstatus')){
			$where = array('status = ?'=> true);
			$records = $this->getDbTable()->fetchAll($where);
						
			foreach($records as $record){
				$servstatus[] = new Server_Model_ServerStatus(						
					$record->toArray());	
			}
			$cache->Save($servstatus,'serverstatus');			
		}else{
			$servstatus = $cache->Fetch('serverstatus');
		}
		
		$cache = null;
		return $servstatus;
	}
	
	public function getIdByCode($servstatus)
	{
		$servstatusBd = $this->fetchAll();
		if($servstatusBd){
			foreach($servstatusBd as $item){
				if($item->getCode() == $servstatus){
					return $item;
				} 
			}
		}
	}
}

