<?php

class Server_Model_ServerTableMapDataMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Server_Model_DbTable_ServertableMap');
		}
		return $this->_dbTable;
	}
	
	public function savetabledetails(Server_Model_ServerTableMap $secSerObj)
	{
		try{
			$table = $this->getDbTable();			    
		    $count = 0;		     	
		    $tableIdArr = array();
		    $serverIds = array();
		    $tableid = "";		    
		    $tableno = "";		    
		    $diningid = "";		    
		    $tableIdArr = $secSerObj->getstm_tableid();		    		    
		    $count = count($tableIdArr);
		    $result = "";		    
		    if($count > 0){		    			    	
		    	foreach($tableIdArr as $tablesarr){
		    		$tab = explode('_', $tablesarr);
		    		
		    		$tableid = $tab[0];
		    		$diningid = $tab[1];
		    		$tableno = $tab[2];
		    		
		    		$select = $table->select();
		    		$select->from($table,array('stm_fk_serv'))
				   		   ->where('stm_diningid = ?',$diningid)
				   		   ->where('stm_tableid = ?',$tableid)
				   		   ->where('stm_status = ?',true);
		    		$rowset = $table->fetchRow($select);
		    		
		    		if($rowset){
		    			if (!in_array($rowset->stm_fk_serv, $serverIds)) {
		    				$serverIds[] = $rowset->stm_fk_serv;
		    			}
		    			$status = "false";		
						$set = array('stm_status' => $status);			
						$where = array('stm_fk_serv = ?' => $rowset->stm_fk_serv,
									   'stm_tableid = ?' => $tableid);			
						$res = $table->update($set,$where);
		    		}
		    		
	    			$data = array('stm_fk_serv'  	=> $secSerObj->getstm_fk_ser(),
		    					  'stm_status'		=> $secSerObj->getstm_staus(),
		    					  'stm_diningid'	=> $diningid,
		    					  'stm_tableno'		=> $tableno,
		    					  'stm_tableid' 	=> $tableid ); 
	    			$result = $table->insert($data);		    		
		    	}     		
		    }		    
			return $result;			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function retrieveSecTableForHighlight($restid)
	{
		try
		{
			$table  = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);		
			$select->from(array('stm'=>'mt.server_table_map'),array('stm_tableid','stm_fk_serv'))
			       ->join(array('sec'=>'mt.servers'),'stm.stm_fk_serv = sec.serv_id',array('serv_colorcode'))
				   ->where('sec.serv_resid = ?',$restid)
				   ->where('sec.serv_status = ?',1)
				   ->where('stm.stm_status = ?',true);
				   
			$resultset = $table->fetchAll($select);	
			$result = array();
			foreach($resultset as $row)
			{
				$result[$row->stm_tableid."_".$row->stm_fk_serv] = $row->serv_colorcode;
			}
			return $result;	
				
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function gettablesofserverbyid($serverid)
	{
		try
		{
		  $table  = $this->getDbTable();
		  $select = $table->select();
		  $select->from(array('stm'=>'mt.server_table_map'),array('stm_tableid','stm_tableno','stm_diningid'))
				   ->where('stm.stm_fk_serv = ?',$serverid)
				   ->where('stm.stm_status = ?',true);
				   
		  $resultset = $table->fetchAll($select);	
		  $result = array();
		  foreach($resultset as $row)
		  {
			$result[] = array('Table Id' => $row->stm_tableid.'_'.$row->stm_diningid,
							  'Table no' => $row->stm_tableno);
		  }
		  return $result;			  
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}	
	}
	
	public function assigntablesforserver(Server_Model_ServerTableMap $SertabObj)
	{
		try
		{
		  $db = Zend_Db_Table::getDefaultAdapter();
		  $db->beginTransaction();	
		  $table  = $this->getDbTable();	     	
		  $tablecount = 0;		     	
		  $servercount = 0;		     	
	      $tableIdArr = array();
	      $serverIds = array();
	      $tableid = "";		    		    		    
		  $tableno = "";
		  $serverId = "";
			
			
		  	$tableIdArr = $SertabObj->getstm_tableid();
		  	$tablecount = count($tableIdArr);		    
			    if($tablecount > 0){		    			    	
			    	foreach($tableIdArr as $tablesarr){
			    		$tab = explode('_', $tablesarr);			    		
			    		$tableid = $tab[0];
			    		$tableno = $tab[1];
			    		$serverId = $tab[2];
			    		
			    		$sertab = $this->getDbTable();
						$set = array('stm_status' => "false");
						$where = $db->quoteInto('stm_fk_serv = ?',$serverId);
						$ser_id = $sertab->update($set,$where);
						
			    		$select = $table->select();
			    		$select->from($table,array('stm_fk_serv'))
					   		   ->where('stm_diningid = ?',$SertabObj->getstm_diningid())
					   		   ->where('stm_tableid = ?',$tableid)
					   		   ->where('stm_status = ?',true);
			    		$rowset = $table->fetchRow($select);
		    		
			    		if($rowset){
			    			if (!in_array($rowset->stm_fk_serv, $serverIds)) {
			    				$serverIds[] = $rowset->stm_fk_serv;
			    			}
			    			$status = "false";		
							$set = array('stm_status' => $status);			
							$where = array('stm_fk_serv = ?' => $rowset->stm_fk_serv,
										   'stm_tableid = ?' => $tableid);			
							$res = $table->update($set,$where);
			    		}
			    	}
			    }
    		    		    	    
			    if($tablecount > 0){		    			    	
			    	foreach($tableIdArr as $tablesarr){
			    		$tab = explode('_', $tablesarr);			    		
			    		$tableid = $tab[0];
			    		$tableno = $tab[1];
			    		$serverId = $tab[2];
			    		
		    			$data = array('stm_fk_serv'  	=> $serverId,
			    					  'stm_status'		=> $SertabObj->getstm_staus(),
			    					  'stm_diningid'	=> $SertabObj->getstm_diningid(),
			    					  'stm_tableno'		=> $tableno,
			    					  'stm_tableid' 	=> $tableid );
		    			$result = $table->insert($data);		    		
			    	}     		
			    }
			    $db->commit();			    		   		
	   	 	
		  return $result;
		  			  
		}catch (Exception $ex){
			$db->rollBack();
			throw new Exception($ex->getMessage()) ;
		}	
	}
	
	public function getServerIdByTableIds($tableids,$diningid)
	{
		try{
			$table  = $this->getDbTable();
		  	$select = $table->select();
		  	$select->from(array('mt.server_table_map'),array('stm_fk_serv'))
				   ->where('stm_tableid IN(?)',$tableids)
				   ->where('stm_diningid = ?',$diningid)
				   ->where('stm_status = ?',true);
				   
		 	$rowset = $table->fetchRow($select);	
		  	$serverid = '';
		  	if($rowset){
				$serverid = $rowset->stm_fk_serv;
		  	}
		 	return $serverid;	
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
}