<?php
class SocialMedia_Form_SocialMediaPost extends Zend_Form
{

	public function init()
    {
    	$resTypeList = array();
    	$resTypeList[] = array('key'=>'post','value'=>'Post Now');    	   
    	$resTypeList[] = array('key'=>'sch','value'=>'Schedule Post'); 
    	
    	$this->setAttrib('enctype', 'multipart/form-data');
    	
    	$restId = $this->createElement('hidden','restaurantid');
    	
    	
    	$postImg = $this->createElement('file','postImg');
		$postImg->removeDecorator('Label')
			     ->removeDecorator('HtmlTag')
			     ->setAttrib('class','inp1')			     
			     ->setRequired(false)
			     ->addValidator('FilesSize', false, array('min' => '1kB', 'max' => '5MB'))
			     ->addValidator('Extension', false, 'jpg,jpeg,png,gif');
		
		$restNameCtl = $this->createElement('select','postRestaurant');
        $restNameCtl->removeDecorator('Label')
         		    ->removeDecorator('HtmlTag')
         		    ->setAttrib('class','inp1')
         		    ->setRegisterInArrayValidator(false);  
         		    
       	$typeCtl = $this->createElement('select','postType');
        $typeCtl->removeDecorator('Label')
         	    ->removeDecorator('HtmlTag')
         	    ->setAttrib('class','sel1')
         	    ->addMultiOptions($resTypeList)
         	    ->setRegisterInArrayValidator(false);  
         	    
        $resDate = $this->createElement('text','postDate');
    	$resDate->removeDecorator('HtmlTag')
    			 ->setAttrib('class','datepicker2')
    			 ->setAttrib('readonly','readonly')
    			 ->setAttrib('style','width:130px;')
    			 ->setAttrib('placeholder', 'Date')
    			 ->setAttrib('title', 'Date')
    			 ->addFilters(array('StringTrim'))
    		     ->removeDecorator('Label');
    	
    	$resTime = $this->createElement('text','postTime');
    	$resTime->removeDecorator('HtmlTag')
    			 ->setAttrib('class','timepicker1')
    			 ->setAttrib('style','width:120px')
    			 ->setAttrib('placeholder', 'Time')
    			 ->setAttrib('title', 'Time')
    			 ->addFilters(array('StringTrim'))
    			 ->removeDecorator('Label');
		
		$postTitle = $this->createElement('text', 'postTo');
        $postTitle->removeDecorator('Label')
        			   ->removeDecorator('HtmlTag')
        			   ->setAttrib('maxlength', '255')
        			   ->setAttrib('style','width:400px')
        			   ->setAttrib('class','inp1 required')  
					   ->setAttrib('placeholder','Select Accounts')
        			   ->addFilters(array('StringTrim'))
        			   ->addValidators(array(array('NotEmpty', true, array('messages' => 'Please select accounts for your post.'))))
        			   ->setValue('')
        			   ->setRequired(true);
		
		$postDesc = $this->createElement('textarea', 'postDesc');
        $postDesc->removeDecorator('Label')
        			   ->removeDecorator('HtmlTag')
        			   ->setAttrib('rows', '5')
        			   ->setAttrib('cols', '60')
        			   ->setAttrib('class','inp1 required')  
        			   ->setAttrib('placeholder', 'Description for your post ...')
        			   ->setAttrib('title', 'Reservation Notes')
        			   ->setAttrib('style','width:100%')
        			   ->addFilters(array('StringTrim'));
		
		$fbCheck = new Zend_Form_Element_Checkbox('fbCheck');
		$fbCheck->removeDecorator('Label')
			          ->removeDecorator('HtmlTag')
			          ->setRequired(false)
			          ->setChecked(false);
					  
		$twiCheck = new Zend_Form_Element_Checkbox('twiCheck');
		$twiCheck->removeDecorator('Label')
			          ->removeDecorator('HtmlTag')
			          ->setRequired(false)
			          ->setChecked(false);
					  
		$gooCheck = new Zend_Form_Element_Checkbox('gooCheck');
		$gooCheck->removeDecorator('Label')
			          ->removeDecorator('HtmlTag')
			          ->setRequired(false)
			          ->setChecked(false);
					   
		$this->addElements( array ($restId,
								   $postImg,
								   $postTitle,
								   $postDesc,
								   $fbCheck,
								   $restNameCtl,
								   $gooCheck,
								   $typeCtl,
								   $resDate,
							    	$resTime,
								   $twiCheck
								   ));
	}
}	