<?php
class SocialMedia_Model_FBPostsDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}


	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('SocialMedia_Model_DbTable_FBPosts');
		}
		return $this->_dbTable;
	}
	
	public function SavePosts(SocialMedia_Model_FBPosts $restFBSpl)
	{
		try{
			$status = false;
			$db = Zend_Db_Table::getDefaultAdapter();
			$data = array(
					'rfbp_post_fb_id'				=>	$restFBSpl->getrfbp_post_fb_id(),
					'rfbp_post_id'					=>	$restFBSpl->getrfbp_post_id(),
					'rfbp_fk_business'			=>	$restFBSpl->getrfbp_fk_business(),
					'rfbp_post_date'				=>	$restFBSpl->getrfbp_post_date(),
					'rfbp_post_time'				=>	$restFBSpl->getrfbp_post_time(),
					'rfbp_created_fb_by'			=>	$restFBSpl->getrfbp_created_fb_by(),
					'rfbp_status'					=>	'T',
					'rfbp_created_fb_for'			=>	$restFBSpl->getrfbp_created_fb_for(),
					'rfbp_sent_status'				=>	$restFBSpl->getrfbp_sent_status()
			);
			
			$spl_id = $this->getDbTable()->insert($data);
			$status = true;
			return $spl_id;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetFbPosts(SocialMedia_Model_FBPosts $restFBSpl)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->from($this->getDbTable(),array(
													'rfbp_post_fb_id',
													'rfbp_post_id',
													'rfbp_fk_business',
													'rfbp_post_date',
													'rfbp_post_time',
													'rfbp_created_fb_by',
													'rfbp_status',
													'rfbp_created_fb_for',
													'rfbp_sent_status'))
					->where('rfbp_fk_business = ?',$restFBSpl->getrfbp_fk_business())
//					->where('rfbp_created_fb_by = ?',$restFBSpl->getrfbp_created_fb_by())
					->where('rfbp_status = ?',true)
					->order('rfbp_id DESC');
			$result = $this->getDbTable()->fetchAll($select);
			return $result;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}