<?php
class SocialMedia_Model_FBProfileMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}


	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('SocialMedia_Model_DbTable_FBProfile');
		}
		return $this->_dbTable;
	}
	
	public function SaveProfile(SocialMedia_Model_FBProfile $restFBSpl)
	{
		try{
			$status = false;
			$db = Zend_Db_Table::getDefaultAdapter();
			
			$select = $this->getDbTable()->select();
			$select->from($this->getDbTable(),array(
													'bfbp_id',
													'bfbp_fk_profile',
													'bfbp_user_id',
													'bfbp_user_access_token',
													'bfbp_user_name',
													'bfbp_user_page',
													'bfbp_status',
													'bfbp_created',
													'bfbp_updated'))
					->where('bfbp_user_id = ?',$restFBSpl->getbfbp_user_id())
					->where('bfbp_fk_profile = ?',$restFBSpl->getbfbp_fk_profile());
			$result = $this->getDbTable()->fetchRow($select);
			
			$data = array();
			$data['bfbp_fk_profile'] = $restFBSpl->getbfbp_fk_profile();
			$data['bfbp_user_access_token'] = $restFBSpl->getbfbp_user_access_token();
			$data['bfbp_user_name'] = $restFBSpl->getbfbp_user_name();
			$data['bfbp_user_page'] = $restFBSpl->getbfbp_user_page();
			$data['bfbp_status'] = $restFBSpl->getbfbp_status();
			$data['bfbp_user_id'] = $restFBSpl->getbfbp_user_id();
			if($result->bfbp_user_id){
				$data['bfbp_updated'] = date('Y-m-d H:i:s');
				$where = array('bfbp_user_id = ?' => $restFBSpl->getbfbp_user_id());
				$rows_affected = $this->getDbTable()->update($data,$where);
				return $result->bfbp_id;
			}else{
				$data['bfbp_created'] = date('Y-m-d H:i:s');
				$spl_id = $this->getDbTable()->insert($data);
				$status = true;
				return $spl_id;
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetProfile(SocialMedia_Model_FBProfile $restFBSpl)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->setIntegrityCheck(false);
			$select->from($this->getDbTable(),array(
													'bfbp_id',
													'bfbp_fk_profile',
													'bfbp_user_id',
													'bfbp_user_access_token',
													'bfbp_user_name',
													'bfbp_user_page',
													'bfbp_status'))
					->join(array('pag'=>'mt.business_fb_profile_pages'),'bfbpp_profile_id = bfbp_id',array(
													'bfbpp_id',
													'bfbpp_profile_id',
													'bfbpp_page_id',
													'bfbpp_page_name',
													'bfbpp_page_category',
													'bfbpp_page_access',
													'bfbpp_page_roles',
													'bfbpp_page_status'))
					->where('bfbp_fk_profile = ?',$restFBSpl->getbfbp_fk_profile())
					->order('bfbp_id DESC');
			if($restFBSpl->getbfbp_user_id()){
				$select->where('bfbp_user_id = ?',$restFBSpl->getbfbp_user_id());
			}
			if($restFBSpl->getId()){
				$select->where('bfbp_id = ?',$restFBSpl->getId());
				$result = $this->getDbTable()->fetchRow($select);
			}else{
				$result = $this->getDbTable()->fetchAll($select);
			}
			
			return $result;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

}