<?php
class SocialMedia_Model_FBProfilePageMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}


	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('SocialMedia_Model_DbTable_FBProfilePage');
		}
		return $this->_dbTable;
	}
	
	public function SaveProfilePage($modelArr)
	{
		try{
			$status = false;
			$db = Zend_Db_Table::getDefaultAdapter();
			foreach($modelArr as $restFBSpl){
				$select = $this->getDbTable()->select();
				$select->from($this->getDbTable(),array(
														'bfbpp_id',
														'bfbpp_profile_id',
														'bfbpp_page_id',
														'bfbpp_page_name',
														'bfbpp_page_category',
														'bfbpp_page_access',
														'bfbpp_page_roles',
														'bfbpp_page_status',
														'bfbpp_page_created',
														'bfbpp_page_updated'))
						->where('bfbpp_page_id = ?',$restFBSpl->getbfbpp_page_id())
						->where('bfbpp_profile_id = ?',$restFBSpl->getbfbpp_profile_id());
				$result = $this->getDbTable()->fetchRow($select);
				
				$data = array();
				$data['bfbpp_profile_id'] = $restFBSpl->getbfbpp_profile_id();
				$data['bfbpp_page_name'] = $restFBSpl->getbfbpp_page_name();
				$data['bfbpp_page_category'] = $restFBSpl->getbfbpp_page_category();
				$data['bfbpp_page_access'] = $restFBSpl->getbfbpp_page_access();
				$data['bfbpp_page_roles'] = $restFBSpl->getbfbpp_page_roles();
				
				$data['bfbpp_page_id'] = $restFBSpl->getbfbpp_page_id();
				if($result->bfbpp_page_id){
					$data['bfbpp_page_updated'] = date('Y-m-d H:i:s');
					$where = array('bfbpp_page_id = ?' => $restFBSpl->getbfbpp_page_id());
					$rows_affected = $this->getDbTable()->update($data,$where);
				}else{
					$data['bfbpp_page_created'] = date('Y-m-d H:i:s');
					$spl_id = $this->getDbTable()->insert($data);
					$status = true;
				}
			}
			return true;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetProfilePage(SocialMedia_Model_FBProfilePage $restFBSpl)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->setIntegrityCheck(false);
			$select->from($this->getDbTable(),array(
													'bfbpp_id',
													'bfbpp_profile_id',
													'bfbpp_page_id',
													'bfbpp_page_name',
													'bfbpp_page_category',
													'bfbpp_page_access',
													'bfbpp_page_roles',
													'bfbpp_page_status'))
					->where('bfbpp_profile_id = ?',$restFBSpl->getbfbpp_profile_id())
					->order('bfbpp_id DESC');
			if($restFBSpl->getbfbpp_page_id()){
				$select->where('bfbpp_page_id = ?',$restFBSpl->getbfbpp_page_id());
			}
			$result = $this->getDbTable()->fetchAll($select);
			return $result;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetProfilePageByIds(SocialMedia_Model_FBProfilePage $restFBSpl)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->setIntegrityCheck(false);
			$select->from($this->getDbTable(),array(
													'bfbpp_id',
													'bfbpp_profile_id',
													'bfbpp_page_id',
													'bfbpp_page_name',
													'bfbpp_page_category',
													'bfbpp_page_access',
													'bfbpp_page_roles',
													'bfbpp_page_status'))
					->join(array('pag'=>'mt.business_fb_profile'),'bfbpp_profile_id = bfbp_id',array('bfbp_id','bfbp_fk_profile','bfbp_user_id','bfbp_user_access_token','bfbp_user_name','bfbp_user_page','bfbp_status'))
					->where('bfbpp_id IN (?)',$restFBSpl->getId())
					->where('bfbpp_profile_id IN (?)',$restFBSpl->getbfbpp_profile_id())
					->order('bfbpp_id DESC');
			$result = $this->getDbTable()->fetchAll($select);
			return $result;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function UpdateProfilePage(SocialMedia_Model_FBProfilePage $restFBSpl,$restid)
	{
		try{
			$data = array();
			$data['bfbpp_page_status'] = $restFBSpl->getbfbpp_page_status();
			$data['bfbpp_page_updated'] = date('Y-m-d H:i:s');
			$where = array('bfbpp_id = ?' => $restFBSpl->getId());
			if($restFBSpl->getbfbpp_page_status() == 'D'){
				$rows_affected = $this->getDbTable()->delete($where);
//				$mapper = new SocialMedia_Model_SocialProfileMapper();
//				$data = array();
//				$data['rsp_fb_status'] = 'false';
//				$where = array('rsp_fk_business = ?',$restid);
//				$rows_affected = $mapper->getDbTable()->update($data,$where);
			}else{
				$rows_affected = $this->getDbTable()->update($data,$where);
			}
			return $rows_affected;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

}