<?php
class SocialMedia_Model_GOOPostsMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}


	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('SocialMedia_Model_DbTable_GOOPosts');
		}
		return $this->_dbTable;
	}
	
	public function SavePosts(SocialMedia_Model_GOOPosts $restGOOSpl)
	{
		try{
			$status = false;
			$db = Zend_Db_Table::getDefaultAdapter();
			$data = array(
					'rgop_post_goo_id'				=>	$restGOOSpl->getrgop_post_goo_id(),
					'rgop_post_id'					=>	$restGOOSpl->getrgop_post_id(),
					'rgop_fk_business'				=>	$restGOOSpl->getrgop_fk_business(),
					'rgop_post_date'				=>	$restGOOSpl->getrgop_post_date(),
					'rgop_post_time'				=>	$restGOOSpl->getrgop_post_time(),
					'rgop_created_fb_by'			=>	$restGOOSpl->getrgop_created_fb_by(),
					'rgop_status'					=>	'T',
					'rgop_created_fb_for'			=>	$restGOOSpl->getrgop_created_fb_for(),
					'rgop_sent_status'				=>	$restGOOSpl->getrgop_sent_status()
			);
			
			$spl_id = $this->getDbTable()->insert($data);
			$status = true;
			return $spl_id;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetGOOPosts(SocialMedia_Model_GOOPosts $restGOOSpl)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->from($this->getDbTable(),array(
													'rgop_post_goo_id',
													'rgop_post_id',
													'rgop_fk_business',
													'rgop_post_date',
													'rgop_post_time',
													'rgop_created_fb_by',
													'rgop_status',
													'rgop_created_fb_for',
													'rgop_sent_status'))
					->where('rgop_fk_business = ?',$restGOOSpl->getrgop_fk_business())
//					->where('rgop_created_fb_by = ?',$restGOOSpl->getrgop_created_fb_by())
					->where('rgop_status = ?',true)
					->order('rgop_id DESC');
			$result = $this->getDbTable()->fetchAll($select);
			return $result;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}