<?php
class SocialMedia_Model_GOOProfileMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}


	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('SocialMedia_Model_DbTable_GOOProfile');
		}
		return $this->_dbTable;
	}
	
	public function SaveProfile(SocialMedia_Model_GOOProfile $restGOOSpl)
	{
		try{
			$status = false;
			$db = Zend_Db_Table::getDefaultAdapter();
			
			$select = $this->getDbTable()->select();
			$select->from($this->getDbTable(),array(
													'bgop_id',
													'bgop_fk_profile',
													'bgop_user_id',
													'bgop_user_access_token',
													'bgop_user_refresh_token',
													'bgop_user_expires_in',
													'bgop_user_token_type',
													'bgop_id_token',
													'bgop_created_token',
													'bgop_user_name',
													'bgop_status',
													'bgop_created',
													'bgop_updated'))
					->where('bgop_user_id = ?',$restGOOSpl->getbgop_user_id())
					->where('bgop_fk_profile = ?',$restGOOSpl->getbgop_fk_profile());
			$result = $this->getDbTable()->fetchRow($select);
			
			$data = array();
			$data['bgop_fk_profile'] = $restGOOSpl->getbgop_fk_profile();
			$data['bgop_user_access_token'] = $restGOOSpl->getbgop_user_access_token();
			$data['bgop_user_refresh_token'] = $restGOOSpl->getbgop_user_refresh_token();
			$data['bgop_user_expires_in'] = $restGOOSpl->getbgop_user_expires_in();
			$data['bgop_user_token_type'] = $restGOOSpl->getbgop_user_token_type();
			$data['bgop_user_name'] = $restGOOSpl->getbgop_user_name();
			$data['bgop_id_token'] = $restGOOSpl->getbgop_id_token();
			$data['bgop_created_token'] = $restGOOSpl->getbgop_created_token();
			$data['bgop_status'] = $restGOOSpl->getbgop_status();
			$data['bgop_user_id'] = $restGOOSpl->getbgop_user_id();
			if($result){
				$data['bgop_updated'] = date('Y-m-d H:i:s');
				$where = array('bgop_user_id = ?' => $restGOOSpl->getbgop_user_id(),'bgop_fk_profile = ?'=>$restGOOSpl->getbgop_fk_profile());
				$rows_affected = $this->getDbTable()->update($data,$where);
				return $rows_affected;
			}else{
				$data['bgop_created'] = date('Y-m-d H:i:s');
				$spl_id = $this->getDbTable()->insert($data);
				$status = true;
				return $spl_id;
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetProfile(SocialMedia_Model_GOOProfile $restGOOSpl)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->from($this->getDbTable(),array(
													'bgop_id',
													'bgop_fk_profile',
													'bgop_user_id',
													'bgop_user_access_token',
													'bgop_user_refresh_token',
													'bgop_user_expires_in',
													'bgop_id_token',
													'bgop_created_token',
													'bgop_user_token_type',
													'bgop_user_name',
													'bgop_status'))
					->where('bgop_fk_profile = ?',$restGOOSpl->getbgop_fk_profile())
					->order('bgop_id DESC');
			if($restGOOSpl->getId()){
				$select->where('bgop_id = ?',$restGOOSpl->getId());
			}
			$result = $this->getDbTable()->fetchAll($select);
			return $result;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function UpdateProfileGOO(SocialMedia_Model_GOOProfile $restGOOSpl,$restid)
	{
		try{
			$data = array();
			$data['bgop_status'] = $restGOOSpl->getbgop_status();
			$data['bgop_updated'] = date('Y-m-d H:i:s');
			$where = array('bgop_id = ?' => $restGOOSpl->getId());
			if($restGOOSpl->getbgop_status() == 'D'){
				$rows_affected = $this->getDbTable()->delete($where);
//				$mapper = new SocialMedia_Model_SocialProfileMapper();
//				$data = array();
//				$data['rsp_goog_status'] = 'false';
//				$where = array('rsp_fk_business = ?',$restid);
//				$rows_affected = $mapper->getDbTable()->update($data,$where);
			}else{
				$rows_affected = $this->getDbTable()->update($data,$where);
			}
			return $rows_affected;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetProfileByIds(SocialMedia_Model_GOOProfile $restGOOSpl)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->setIntegrityCheck(false);
			$select->from($this->getDbTable(),array(
													'bgop_id',
													'bgop_fk_profile',
													'bgop_user_id',
													'bgop_user_access_token',
													'bgop_user_refresh_token',
													'bgop_user_expires_in',
													'bgop_user_token_type',
													'bgop_id_token',
													'bgop_created_token',
													'bgop_user_name',
													'bgop_status'))
					->where('bgop_id IN (?)',$restGOOSpl->getId())
					->order('bgop_id DESC');
			$result = $this->getDbTable()->fetchAll($select);
			return $result;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

}