<?php
class SocialMedia_Model_LINKPostsMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}


	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('SocialMedia_Model_DbTable_LINKPosts');
		}
		return $this->_dbTable;
	}
	
	public function SavePosts(SocialMedia_Model_LINKPosts $restLINKSpl)
	{
		try{
			$status = false;
			$db = Zend_Db_Table::getDefaultAdapter();
			$data = array(
					'rinp_post_in_id'				=>	$restLINKSpl->getrinp_post_in_id(),
					'rinp_post_id'					=>	$restLINKSpl->getrinp_post_id(),
					'rinp_fk_business'				=>	$restLINKSpl->getrinp_fk_business(),
					'rinp_post_date'				=>	$restLINKSpl->getrinp_post_date(),
					'rinp_post_time'				=>	$restLINKSpl->getrinp_post_time(),
					'rinp_created_by'				=>	$restLINKSpl->getrinp_created_fb_by(),
					'rinp_status'					=>	'T',
					'rinp_created_for'				=>	$restLINKSpl->getrinp_created_fb_for(),
					'rinp_sent_status'				=>	$restLINKSpl->getrinp_sent_status()
			);
			
			$spl_id = $this->getDbTable()->insert($data);
			$status = true;
			return $spl_id;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetLINKPosts(SocialMedia_Model_LINKPosts $restLINKSpl)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->from($this->getDbTable(),array(
													'rinp_post_in_id',
													'rinp_post_id',
													'rinp_fk_business',
													'rinp_post_date',
													'rinp_post_time',
													'rinp_created_by',
													'rinp_status',
													'rinp_created_for',
													'rinp_sent_status'))
					->where('rinp_fk_business = ?',$restLINKSpl->getrinp_fk_business())
					->where('rinp_status = ?',true)
					->order('rinp_id DESC');
			$result = $this->getDbTable()->fetchAll($select);
			return $result;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}