<?php
class SocialMedia_Model_LINKProfileMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}


	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('SocialMedia_Model_DbTable_LINKProfile');
		}
		return $this->_dbTable;
	}
	
	public function SaveProfile(SocialMedia_Model_LINKProfile $restLINKSpl)
	{
		try{
			$status = false;
			$db = Zend_Db_Table::getDefaultAdapter();
			
			$select = $this->getDbTable()->select();
			$select->from($this->getDbTable(),array(
                                                'binp_id',
                                                'binp_fk_profile',
                                                'binp_user_id',
                                                'binp_user_access_token',
                                                'binp_user_refresh_token',
                                                'binp_user_expires_in',
                                                'binp_user_token_type',
                                                'binp_id_token',
                                                'binp_created_token',
                                                'binp_user_name',
                                                'binp_status',
                                                'binp_created',
                                                'binp_updated',
                                                'binp_user_access_token_secret'))
					->where('binp_user_id = ?',$restLINKSpl->getbinp_user_id())
					->where('binp_fk_profile = ?',$restLINKSpl->getbinp_fk_profile());
			$result = $this->getDbTable()->fetchRow($select);
			
			$data = array();
			$data['binp_fk_profile'] = $restLINKSpl->getbinp_fk_profile();
			$data['binp_user_access_token'] = $restLINKSpl->getbinp_user_access_token();
			$data['binp_user_refresh_token'] = $restLINKSpl->getbinp_user_refresh_token();
			$data['binp_user_expires_in'] = $restLINKSpl->getbinp_user_expires_in();
			$data['binp_user_token_type'] = $restLINKSpl->getbinp_user_token_type();
			$data['binp_user_name'] = $restLINKSpl->getbinp_user_name();
			$data['binp_id_token'] = $restLINKSpl->getbinp_id_token();
			$data['binp_created_token'] = $restLINKSpl->getbinp_created_token();
			$data['binp_status'] = $restLINKSpl->getbinp_status();
			$data['binp_user_id'] = $restLINKSpl->getbinp_user_id();
			$data['binp_user_access_token_secret'] = $restLINKSpl->getbinp_user_access_token_secret();
			if($result->binp_user_id){
				$data['binp_updated'] = date('Y-m-d H:i:s');
				$where = array('binp_user_id = ?' => $restLINKSpl->getbinp_user_id(),'binp_fk_profile = ?'=>$restLINKSpl->getbinp_fk_profile());
				$rows_affected = $this->getDbTable()->update($data,$where);
				return $result->binp_id;
			}else{
				$data['binp_created'] = date('Y-m-d H:i:s');
				$spl_id = $this->getDbTable()->insert($data);
				$status = true;
				return $spl_id;
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetProfile(SocialMedia_Model_LINKProfile $restLINKSpl)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->from($this->getDbTable(),array(
													'binp_id',
													'binp_fk_profile',
													'binp_user_id',
													'binp_user_access_token',
													'binp_user_refresh_token',
													'binp_user_expires_in',
													'binp_id_token',
													'binp_created_token',
													'binp_user_token_type',
													'binp_user_name',
													'binp_status',
													'binp_user_access_token_secret'))
					->where('binp_fk_profile = ?',$restLINKSpl->getbinp_fk_profile())
					->order('binp_id DESC');
			if($restLINKSpl->getId()){
				$select->where('binp_id = ?',$restLINKSpl->getId());
			}
			$result = $this->getDbTable()->fetchAll($select);
			return $result;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function UpdateProfileLINK(SocialMedia_Model_LINKProfile $restLINKSpl,$restid)
	{
		try{
			$data = array();
			$data['binp_status'] = $restLINKSpl->getbinp_status();
			$data['binp_updated'] = date('Y-m-d H:i:s');
			$where = array('binp_id = ?' => $restLINKSpl->getId());
			if($restLINKSpl->getbinp_status() == 'D'){
				$rows_affected = $this->getDbTable()->delete($where);
//				$mapper = new SocialMedia_Model_SocialProfileMapper();
//				$data = array();
//				$data['rsp_in_status'] = 'false';
//				$where = array('rsp_fk_business = ?',$restid);
//				$rows_affected = $mapper->getDbTable()->update($data,$where);
			}else{
				$rows_affected = $this->getDbTable()->update($data,$where);
			}
			return $rows_affected;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetProfileByIds(SocialMedia_Model_LINKProfile $restLINKSpl)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->setIntegrityCheck(false);
			$select->from($this->getDbTable(),array(
													'binp_id',
													'binp_fk_profile',
													'binp_user_id',
													'binp_user_access_token',
													'binp_user_refresh_token',
													'binp_user_expires_in',
													'binp_user_token_type',
													'binp_id_token',
													'binp_created_token',
													'binp_user_name',
													'binp_status',
													'binp_user_access_token_secret'))
					->where('binp_id IN (?)',$restLINKSpl->getId())
					->order('binp_id DESC');
			$result = $this->getDbTable()->fetchAll($select);
			return $result;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

}