<?php
class SocialMedia_Model_LINKProfilePageMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}


	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('SocialMedia_Model_DbTable_LINKProfilePage');
		}
		return $this->_dbTable;
	}
	
	public function SaveProfilePage($modelArr)
	{
		try{
			$status = false;
			$db = Zend_Db_Table::getDefaultAdapter();
			foreach($modelArr as $restLINKSpl){
                            
				$select = $this->getDbTable()->select();
				$select->from($this->getDbTable(),array(
														'binpp_id',
														'binpp_profile_id',
														'binpp_page_id',
														'binpp_page_name',
														'binpp_page_category',
														'binpp_page_access',
														'binpp_page_roles',
														'binpp_page_status',
														'binpp_page_created',
														'binpp_page_updated'))
						->where('binpp_page_id = ?',(string)$restLINKSpl->getbinpp_page_id())
						->where('binpp_profile_id = ?',$restLINKSpl->getbinpp_profile_id());
                              $result = $this->getDbTable()->fetchRow($select);
				 
				$data = array();
				$data['binpp_profile_id'] = $restLINKSpl->getbinpp_profile_id();
				$data['binpp_page_name'] = $restLINKSpl->getbinpp_page_name();
				$data['binpp_page_category'] = $restLINKSpl->getbinpp_page_category();
				$data['binpp_page_access'] = $restLINKSpl->getbinpp_page_access();
				$data['binpp_page_roles'] = $restLINKSpl->getbinpp_page_roles();
				
				$data['binpp_page_id'] = (string)$restLINKSpl->getbinpp_page_id();
                                if($result->binpp_page_id){
                                    	$data['binpp_page_updated'] = date('Y-m-d H:i:s');
					$where = array('binpp_page_id = ?' => (string)$restLINKSpl->getbinpp_page_id());
                                        $rows_affected = $this->getDbTable()->update($data,$where);
				}else{
                                    
					$data['binpp_page_created'] = date('Y-m-d H:i:s');
					$spl_id = $this->getDbTable()->insert($data);
					$status = true;
				}
			}
			return true;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetProfilePage(SocialMedia_Model_LINKProfilePage $restLINKSpl)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->setIntegrityCheck(false);
			$select->from($this->getDbTable(),array(
													'binpp_id',
													'binpp_profile_id',
													'binpp_page_id',
													'binpp_page_name',
													'binpp_page_category',
													'binpp_page_access',
													'binpp_page_roles',
													'binpp_page_status'))
					->where('binpp_profile_id = ?',$restLINKSpl->getbinpp_profile_id())
					->order('binpp_id DESC');
			if($restLINKSpl->getbinpp_page_id()){
				$select->where('binpp_page_id = ?',$restLINKSpl->getbinpp_page_id());
			}
			$result = $this->getDbTable()->fetchAll($select);
			return $result;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetProfilePageByIds(SocialMedia_Model_LINKProfilePage $restLINKSpl)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->setIntegrityCheck(false);
			$select->from($this->getDbTable(),array(
													'binpp_id',
													'binpp_profile_id',
													'binpp_page_id',
													'binpp_page_name',
													'binpp_page_category',
													'binpp_page_access',
													'binpp_page_roles',
													'binpp_page_status'))
					->join(array('pag'=>'mt.business_link_profile'),'binpp_profile_id = binp_id',array('binp_id','binp_fk_profile','binp_user_id','binp_user_access_token','binp_user_name','binp_status'))
					->where('binpp_id IN (?)',$restLINKSpl->getId())
					->where('binpp_profile_id IN (?)',$restLINKSpl->getbinpp_profile_id())
					->order('binpp_id DESC');
			$result = $this->getDbTable()->fetchAll($select);
			return $result;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function UpdateProfilePage(SocialMedia_Model_LINKProfilePage $restLINKSpl,$restid)
	{
		try{
			$data = array();
			$data['binpp_page_status'] = $restLINKSpl->getbinpp_page_status();
			$data['binpp_page_updated'] = date('Y-m-d H:i:s');
			$where = array('binpp_id = ?' => $restLINKSpl->getId());
			if($restLINKSpl->getbinpp_page_status() == 'D'){
				$rows_affected = $this->getDbTable()->delete($where);
//				$mapper = new SocialMedia_Model_SocialProfileMapper();
//				$data = array();
//				$data['rsp_in_status'] = 'false';
//				$where = array('rsp_fk_business = ?',$restid);
//				$rows_affected = $mapper->getDbTable()->update($data,$where);
			}else{
				$rows_affected = $this->getDbTable()->update($data,$where);
			}
			return $rows_affected;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

}