<?php
class SocialMedia_Model_SocialProfileMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}


	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('SocialMedia_Model_DbTable_SocialProfile');
		}
		return $this->_dbTable;
	}
	
	public function SaveProfile(SocialMedia_Model_SocialProfile $restFBSpl)
	{
		try{
			$status = false;
			$db = Zend_Db_Table::getDefaultAdapter();
			
			$select = $this->getDbTable()->select();
			$select->from($this->getDbTable(),array(
													'rsp_id',
													'rsp_fb_status',
													'rsp_fk_business',
													'rsp_twi_status',
													'rsp_goog_status',
													'rsp_in_status',
													'rsp_insta_status'))
					->where('rsp_fk_business = ?',$restFBSpl->getrsp_fk_business());
			$result = $this->getDbTable()->fetchRow($select);
			if($result){
				$data = array();
				if($restFBSpl->getrsp_fb_status()){
					$data['rsp_fb_status'] = 'true';
				}else{
					if($result->rsp_fb_status){
						$data['rsp_fb_status'] = 'true';
					}else{
						$data['rsp_fb_status'] = 'false';
					}
				}
				if($restFBSpl->getrsp_twi_status()){
					$data['rsp_twi_status'] = 'true';
				}else{
					if($result->rsp_twi_status){
						$data['rsp_twi_status'] = 'true';
					}else{
						$data['rsp_twi_status'] = 'false';
					}
				}
				if($restFBSpl->getrsp_goog_status()){
					$data['rsp_goog_status'] = 'true';
				}else{
					if($result->rsp_goog_status){
						$data['rsp_goog_status'] = 'true';
					}else{
						$data['rsp_goog_status'] = 'false';
					}
				}
				if($restFBSpl->getrsp_in_status()){
					$data['rsp_in_status'] = 'true';
				}else{
					if($result->rsp_in_status){
						$data['rsp_in_status'] = 'true';
					}else{
						$data['rsp_in_status'] = 'false';
					}
				}
				if($restFBSpl->getrsp_insta_status()){
					$data['rsp_insta_status'] = 'true';
				}else{
					if($result->rsp_insta_status){
						$data['rsp_insta_status'] = 'true';
					}else{
						$data['rsp_insta_status'] = 'false';
					}
				}
				$data['rsp_fk_business'] = $restFBSpl->getrsp_fk_business();
				$where = array('rsp_fk_business = ?' => $restFBSpl->getrsp_fk_business());
				$rows_affected = $this->getDbTable()->update($data,$where);
				return $rows_affected;
			}else{
				$data = array();
				if($restFBSpl->getrsp_fb_status()){
					$data['rsp_fb_status'] = 'true';
				}else{
					$data['rsp_fb_status'] = 'false';
				}
				if($restFBSpl->getrsp_twi_status()){
					$data['rsp_twi_status'] = 'true';
				}else{
					$data['rsp_twi_status'] = 'false';
				}
				if($restFBSpl->getrsp_goog_status()){
					$data['rsp_goog_status'] = 'true';
				}else{
					$data['rsp_goog_status'] = 'false';
				}
				if($restFBSpl->getrsp_in_status()){
					$data['rsp_in_status'] = 'true';
				}else{
					$data['rsp_in_status'] = 'false';
				}
				if($restFBSpl->getrsp_insta_status()){
					$data['rsp_insta_status'] = 'true';
				}else{
					$data['rsp_insta_status'] = 'false';
				}
				$data['rsp_fk_business'] = $restFBSpl->getrsp_fk_business();
				$spl_id = $this->getDbTable()->insert($data);
				$status = true;
				return $spl_id;
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetProfile(SocialMedia_Model_SocialProfile $restFBSpl)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->setIntegrityCheck(false);
			$select->from($this->getDbTable(),array(
													'rsp_id',
													'rsp_fb_status',
													'rsp_fk_business',
													'rsp_twi_status',
													'rsp_goog_status',
													'rsp_in_status',
													'rsp_insta_status'))
					->where('rsp_fk_business = ?',$restFBSpl->getrsp_fk_business())
					->order('rsp_id DESC');
			if($restFBSpl->getId()){
				$select->where('rsp_id = ?',$restFBSpl->getId());
			}
			$result = $this->getDbTable()->fetchRow($select);
			return $result;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

}