<?php
class SocialMedia_Model_TWIPostsMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}


	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('SocialMedia_Model_DbTable_TWIPosts');
		}
		return $this->_dbTable;
	}
	
	public function SavePosts(SocialMedia_Model_TWIPosts $restTWISpl)
	{
		try{
			$status = false;
			$db = Zend_Db_Table::getDefaultAdapter();
			$data = array(
					'rtwp_post_twi_id'				=>	$restTWISpl->getrtwp_post_twi_id(),
					'rtwp_post_id'					=>	$restTWISpl->getrtwp_post_id(),
					'rtwp_fk_business'			=>	$restTWISpl->getrtwp_fk_business(),
					'rtwp_post_date'				=>	$restTWISpl->getrtwp_post_date(),
					'rtwp_post_time'				=>	$restTWISpl->getrtwp_post_time(),
					'rtwp_created_fb_by'			=>	$restTWISpl->getrtwp_created_fb_by(),
					'rtwp_status'					=>	'T',
					'rtwp_created_fb_for'			=>	$restTWISpl->getrtwp_created_fb_for(),
					'rtwp_sent_status'				=>	$restTWISpl->getrtwp_sent_status()
			);
			
			$spl_id = $this->getDbTable()->insert($data);
			$status = true;
			return $spl_id;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetTWIPosts(SocialMedia_Model_TWIPosts $restTWISpl)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->from($this->getDbTable(),array(
													'rtwp_post_twi_id',
													'rtwp_post_id',
													'rtwp_fk_business',
													'rtwp_post_date',
													'rtwp_post_time',
													'rtwp_created_fb_by',
													'rtwp_status',
													'rtwp_created_fb_for',
													'rtwp_sent_status'))
					->where('rtwp_fk_business = ?',$restTWISpl->getrtwp_fk_business())
//					->where('rtwp_created_fb_by = ?',$restTWISpl->getrtwp_created_fb_by())
					->where('rtwp_status = ?',true)
					->order('rtwp_id DESC');
			$result = $this->getDbTable()->fetchAll($select);
			return $result;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}