<?php
class SocialMedia_Model_TWIProfileMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}


	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('SocialMedia_Model_DbTable_TWIProfile');
		}
		return $this->_dbTable;
	}
	
	public function SaveProfile(SocialMedia_Model_TWIProfile $restTWISpl)
	{
		try{
			$status = false;
			$db = Zend_Db_Table::getDefaultAdapter();
			
			$select = $this->getDbTable()->select();
			$select->from($this->getDbTable(),array(
													'btwp_id',
													'btwp_fk_profile',
													'btwp_user_id',
													'btwp_user_access_token',
													'btwp_user_access_token_secret',
													'btwp_user_name',
													'btwp_status',
													'btwp_created',
													'btwp_updated'))
					->where('btwp_user_id = ?',$restTWISpl->getbtwp_user_id())
					->where('btwp_fk_profile = ?',$restTWISpl->getbtwp_fk_profile());
			$result = $this->getDbTable()->fetchRow($select);
			$data = array();
			$data['btwp_fk_profile'] = $restTWISpl->getbtwp_fk_profile();
			$data['btwp_user_access_token'] = $restTWISpl->getbtwp_user_access_token();
			$data['btwp_user_access_token_secret'] = $restTWISpl->getbtwp_user_access_token_secret();
			$data['btwp_user_name'] = $restTWISpl->getbtwp_user_name();
			$data['btwp_status'] = $restTWISpl->getbtwp_status();
			$data['btwp_user_id'] = $restTWISpl->getbtwp_user_id();
			if($result->btwp_user_id){
				$data['btwp_updated'] = date('Y-m-d H:i:s');
				$where = array('btwp_user_id = ?' => (string)$restTWISpl->getbtwp_user_id());
				$rows_affected = $this->getDbTable()->update($data,$where);
				return $rows_affected;
			}else{
				$data['btwp_created'] = date('Y-m-d H:i:s');
				$spl_id = $this->getDbTable()->insert($data);
				$status = true;
				return $spl_id;
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetProfile(SocialMedia_Model_TWIProfile $restTWISpl)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->from($this->getDbTable(),array(
													'btwp_id',
													'btwp_fk_profile',
													'btwp_user_id',
													'btwp_user_access_token',
													'btwp_user_access_token_secret',
													'btwp_user_name',
													'btwp_status'))
					->where('btwp_fk_profile = ?',$restTWISpl->getbtwp_fk_profile())
					->order('btwp_id DESC');
			if($restTWISpl->getId()){
				$select->where('btwp_id = ?',$restTWISpl->getId());
			}
			$result = $this->getDbTable()->fetchAll($select);
			return $result;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function UpdateProfileTWI(SocialMedia_Model_TWIProfile $restTWISpl,$restid)
	{
		try{
			$data = array();
			$data['btwp_status'] = $restTWISpl->getbtwp_status();
			$data['btwp_updated'] = date('Y-m-d H:i:s');
			$where = array('btwp_id = ?' => $restTWISpl->getId());
			if($restTWISpl->getbtwp_status() == 'D'){
				$rows_affected = $this->getDbTable()->delete($where);
//				$mapper = new SocialMedia_Model_SocialProfileMapper();
//				$data = array();
//				$data['rsp_twi_status'] = 'false';
//				$where = array('rsp_fk_business = ?',$restid);
//				$rows_affected = $mapper->getDbTable()->update($data,$where);
			}else{
				$rows_affected = $this->getDbTable()->update($data,$where);
			}
			return $rows_affected;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetProfileByIds(SocialMedia_Model_TWIProfile $restTWISpl)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->setIntegrityCheck(false);
			$select->from($this->getDbTable(),array(
													'btwp_id',
													'btwp_fk_profile',
													'btwp_user_id',
													'btwp_user_access_token',
													'btwp_user_access_token_secret',
													'btwp_user_name',
													'btwp_status'))
					->where('btwp_id IN (?)',$restTWISpl->getId())
					->order('btwp_id DESC');
			$result = $this->getDbTable()->fetchAll($select);
			return $result;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

}