<?php
/**
*	Name			: UserController.php
*	Author			: Kartheek
*	Creation Date	: 09/30/2010
*	Path 			: application/modules/Reservation/controllers/UserController.php
*	Description		: This is controller class for the UserManagementSystem module.
*					   	
*/
class User_ClientController extends Zend_Controller_Action
{

	protected $_userService = null;

	/**
     * Initialize the User service instance.
     */
	public function init()
	{
		if(!$this->_userService){
			$this->_userService	= new Application_Service_Client();
		}
	}

	public function indexAction()
	{
		// action body
	}
	/**
	 * action for customer registration
	 */
	public function guestsignupAction()
	{
		try{
			$this->_helper->layout()->setLayout('dinedesk');
			if($this->getRequest()->isPost()){
				if($this->_userService->RegisterCustomer($this->getRequest()->getPost())){
					return $this->_helper->redirector('signinupapproval','Client','User',array('usertype' => 'CUS'));
				}
			}
			
			$CountryCodeMapper = new Application_Model_CountryCodeDataMapper();
	    	$CountryCode = $CountryCodeMapper->fetchAll();
	    	$CodeList = array();
	    	$CodeList[] = array('key'=>'','value'=>'Select Country Flag');
	    	foreach($CountryCode as $listcode){
	    		$CodeList[] = array('key'=>$listcode->getCountry_dial_code(),'value'=>$listcode->getCountry_flag());
	    	}
		    	
	    	$this->view->codelist = $CodeList;
	    	
			$this->view->form = $this->_userService->getCustomerForm();
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function signinupapprovalAction()
	{
		try{
			$this->_helper->layout()->setLayout('dinedesk');
			$request = $this->getRequest();
			
			if($request->usertype){
				$this->view->usertype = $request->usertype;	
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * display the customer account details and booking history
	 */
	public function guestacctandbookinghistoryAction()
	{
		try{
			$this->_helper->layout()->setLayout('customerlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$page = $this->_request->getParam('page');
				if (empty($page)){
					$page = 1;
				}
				/* Reteriving Account Information */
				$this->view->accountinfo = $this->_userService->GetAccountInfo($data);
				$bookingService = new Application_Service_Reservation();
				$bookingList = $bookingService->GetCusBookingsByOwnerId($data,$page);
				$this->view->bookHistRes = $bookingList;
				$request = $this->getRequest();
				if(isset($request->actstat)){
					$this->view->actstat = $request->actstat;
				}
			}
			else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action for cancel the reservation from customer
	 */
	public function deletereservationfromguestAction()
	{
		try{
			$this->_helper->layout->disableLayout();
//			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$auth = Zend_Auth::getInstance();
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			
			$bokservice = new Application_Service_Reservation();
			$result = $bokservice->CancelCusResv($request,$data);
			if($result){				
			//	return $this->_helper->redirector('guestacctandbookinghistory');
				return $this->_helper->redirector('customerhistory','Reservation','Reservation');
			}else{
				return $this->_helper->redirector('customerhistory','Reservation','Reservation',array('actstat'=>'f'));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function deletehistoryofguestreservationAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$auth = Zend_Auth::getInstance();
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			
			$bokservice = new Application_Service_Reservation();
			$result = $bokservice->CancelCusResv($request,$data);
			if($result){				
				return $this->_helper->redirector('customerhistory','Reservation','Reservation');
			}else{
				return $this->_helper->redirector('customerhistory','Reservation','Reservation',array('actstat'=>'f'));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * after successful login of restaurantowner display the account details and restaurnts 
	 */
	public function acctandfirmdetailsofmanagerAction()
	{
		try{
			$this->_helper->layout()->setLayout('restaurantuserlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				$this->view->userid = $data['User_Id'];
				//echo '<pre>'; print_r($storage); exit;
				if($data['Usertype'] == "ADM" || $data['Usertype'] == "ADU"){
					if($request->userid){
						$mapper = new FirmManagement_Model_FirmDataMapper();
//						$resid = $mapper->GetRestaurantfirstresid($request->userid);
						$data['restownerId'] = $request->userid;
						$data['RestId'] = $request->resid;
						$restaurantService = new Application_Service_Firm();
						$restNameList = $restaurantService->GetRestNameById($data);
						$data['restList'] = $restNameList;
						$storage = new Zend_Auth_Storage_Session();
						$storage->write($data);
						
						$rsoMapper = new User_Model_ManagerDataMapper();
						$table 	   = $rsoMapper->getDbTable();
						$select    = $table->select();
						$select->from($table,array('rsofk_salution','rsofirst_name','rsolast_name','rsophone','rsostateid','rsocityid','rsoregionid','rso_companyid','presid','defaultview'))
							   ->where('rsofk_user = ?',$request->userid) ;   
						$row = $table->fetchRow($select);
						
						if($request->resid){
							if($row->defaultview == 'floor'){
								$this->_helper->redirector('floorplan','Reservation','Reservation',array('selTab'=>0,'restaurantid'=>$request->resid));
					 		}else{
					 			$this->_helper->redirector('calendar','Reservation','Reservation',array('selTab'=>0,'restaurantid'=>$request->resid));
					 		}
						}
					}	
				}
				$page = $this->_request->getParam('page');
				if (empty($page)){
					$page = 1;
				}
				if($request->campaign){
					$stateId = '';
					$stateId = $data['State_Id'];
					$adminService = new Application_Service_Administrator();
					$campProp = new Application_Model_GetCampaignForPost();
					$campProp->setAudType('RES')
							 ->setStateId($stateId)
							 ->setIsAjaxCall(false);
					$campDetails = $adminService->GetCampaignDetailsLogin($campProp);
					if($campDetails){
						if(count($campDetails) > 1){
						$campaign = $campDetails[rand(0,count($campDetails)-1)];
						}else{
							$campaign = $campDetails[0];
						}
						$this->view->campaign = $campaign;
						$this->view->campName = $campaign->getCampName();
						$this->view->campDesc = $campaign->getCampDesc();
						$this->view->campSponsor = $campaign->getSponsor();
					}
				}
				//echo '<pre>'; print_r($data); exit;
				/* Reteriving Account Information */
				$this->view->accountinfo = $this->_userService->GetAccountInfo($data);

				/* Reteriving Restaurants list */
				$restaurantService = new Application_Service_Firm();
				$restaurantList = $restaurantService->GetRestaurantsByOwnerId($data,$page);
				
				$this->view->restaurantList = $restaurantList;
				/* Reteriving restaurant */
					$restNameList = $restaurantService->GetRestNameById($data);
				
				foreach($restNameList as $resNameVal){
					$NameList[$resNameVal['key']] = $resNameVal['value'];
					$this->view->RestaurantName = $NameList;
				}
				$count = $this->_userService->GetRestaurantCount($data);
				$this->view->restcount = $count;
				
			}
			else{
				$this->_redirect(array('module'=>'User','controller'=>'Login','action'=>'signin'));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * after successful login of restaurantuser display the account information and restaurnts assigned to him 
	 */
	public function firmpatrondetailsAction()
	{
		$this->_helper->layout()->setLayout('restaurantuserlayout');
		$auth = Zend_Auth::getInstance();
		if($auth->hasIdentity()){
			$request = $this->getRequest();
			if($request->campaign){
				$stateId = '';
				$campaign = '';
				$adminService = new Application_Service_Administrator();
				$campProp = new Application_Model_GetCampaignForPost();
				$campProp->setAudType('RES')
						 ->setStateId($stateId)
						 ->setIsAjaxCall(false);
				$campDetails = $adminService->GetCampaignDetails($campProp);
				if($campDetails){
					if(count($campDetails) > 1){
						$campaign = $campDetails[rand(0,count($campDetails)-1)];
					}else{
						$campaign = $campDetails[0];
					}
					$this->view->campaign = $campaign;
					$this->view->campName = $campaign->getCampName();
					$this->view->campDesc = $campaign->getCampDesc();
					$this->view->campSponsor = $campaign->getSponsor();
				}
			}
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			$this->view->accountinfo = $this->_userService->GetAccountInfo($data);
		}
		else{
			$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
		}
	}

	/**
	 * action for restaurant operator registration
	 */
	public function managerregistrationAction()
	{
		try{
			$this->_helper->layout()->setLayout('dinedesk');
			if($this->getRequest()->isPost()){
				$result = $this->_userService->RegisterRestaurantOwner($this->getRequest()->getPost());
				if($result['status']){
					return $this->_helper->redirector('signinupapproval','Client','User',array('usertype' => 'OWN'));
				}else if($result['form']){
					$this->view->form = $result['form'];
				}
			}
			$this->view->form = $this->_userService->getRestaurantOwnerForm();
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function managerwixregistrationAction()
	{
		try{
			$this->_helper->layout()->setLayout('wixlayout');
			if($this->getRequest()->isPost()){
				$result = $this->_userService->RegisterRestaurantOwner($this->getRequest()->getPost(),'WIX');
				if($result['status']){
					$userMapper = new User_Model_ClientDataMapper();
					$loginProfile = $userMapper->getLoginProfile($result['result']);
					$storage = new Zend_Auth_Storage_Session();
					$data = $storage->read();
					$namespace = new Zend_Session_Namespace(); 
					$loginProfile['lang'] = $namespace->lang;
					$storage->write($loginProfile);
					$this->_redirect($this->view->url(array('module'=>'FirmManagement','controller'=>'Firm', 'action'=>'addfirm','src'=>'wix'),'default',true));
				}else if($result['form']){
					$this->view->form = $result['form'];
				}
			}
			$this->view->form = $this->_userService->getRestaurantOwnerForm();
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function firmmanagerregistrationAction()
	{
		try{
			$request = $this->getRequest();
			if($this->getRequest()->isPost()){
				$result = $this->_userService->RegisterRestaurantOwner($this->getRequest()->getPost());
				if($result['status']){
					return $this->_helper->redirector('regconfirmation','User','User',array('usertype' => 'OWN'));
				}else if($result['form']){
					$this->view->form = $result['form'];
				}
			}
			$this->view->form = $this->_userService->getRestaurantOwnerForm();
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action for restaurant user registration
	 */
	public function patronregistrationAction()
	{
		try{
			$this->_helper->layout()->setLayout('restaurantuserlayout');
			$auth = Zend_Auth::getInstance();
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			if($auth->hasIdentity()){
				$CountryCodeMapper = new Application_Model_CountryCodeDataMapper();
		    	$CountryCode = $CountryCodeMapper->fetchAll();
		    	$CodeList = array();
		    	$CodeList[] = array('key'=>'','value'=>'Select Country Flag');
		    	foreach($CountryCode as $listcode){
		    		$CodeList[] = array('key'=>$listcode->getCountry_dial_code(),'value'=>$listcode->getCountry_flag());
		    	}

		    	$this->view->codelist = $CodeList;
			
				if($this->getRequest()->isPost()){
					$result = $this->_userService->RegisterRestaurantUser($this->getRequest()->getPost(),$data);
					if($result['status']){
						return $this->_helper->redirector('managepatron');
					}else{
						$this->view->form = $result['form'];
					}
				}else{
					$restownerId = new User_Model_ManagerDataMapper();
					$countrycode = $restownerId->getOwnerCountrycodebyId($data['User_Id']);
					if($countrycode){
						$form = $this->_userService->getRestaurantUserFrom();
						$formValues = array('countryCode' => $countrycode->getres_country_code());
						$form->populate($formValues);					
					}
				}
				
				$form = $this->_userService->GetRestaurantNames($data);
				$this->view->form = $form;
			}
			else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function patronregistrationfrmnativeappAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_userService->RegisterRestaurantUserFromNativeApp($request);
			echo json_encode($result);
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * function for edit customer details
	 */
	public function changedetailsofguestAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout()->setLayout('customerlayout');
				if($this->getRequest()->isPost()){
					$result = $this->_userService->EditCustomerProfile($this->getRequest()->getPost());
					if($result['status']){
						$this->view->successmsg = "Profile Updated Successfully";
						$this->view->form = $result['form'];
					}else{
						$this->view->form = $result['form'];
					}

				}else{
					$form = $this->_userService->GetCustomerProfileById($data);
					$this->view->form = $form;
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * function for edit restaurant owner details
	 */
	public function changefirmmanagerrecordAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
                                $this->view->currentPageName = 'changefirmmanagerrecord';
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout()->setLayout('global_settings_layout');
				$this->view->userid = $data['User_Id'];
				$restaurantService = new Application_Service_Firm();
				$restNameList = $restaurantService->GetRestNameById($data);
				foreach($restNameList as $resNameVal){
					$NameList[$resNameVal['key']] = $resNameVal['value'];
					$this->view->RestaurantName = $NameList;
				}
				
				$CountryCodeMapper = new Application_Model_CountryCodeDataMapper();
   	    $CountryCode = $CountryCodeMapper->fetchAll();
        $countrycodenew = $CountryCodeMapper->getCountryCode();
		    	$CodeList = array();
		    	$CodeList[] = array('key'=>'','value'=>'Select Country Flag');
			    /*
		    	foreach($CountryCode as $listcode){
		    		$CodeList[] = array('key'=>$listcode->getCountry_dial_code(),'value'=>$listcode->getCountry_flag());
		    	}*/
          foreach($countrycodenew as $listcode){
             $CodeList[] = array('key'=>$listcode['key'],'value'=>$listcode['value']);
		    	}	
		    	$this->view->codelist = $CodeList;
				
				if($this->getRequest()->isPost()){
					$result = $this->_userService->EditRestOwnProfile($this->getRequest()->getPost());
					if($result['status']){
						//return $this->_helper->redirector('regconfirmation');
						$this->view->successmsg = "Profile Updated Successfully";
						$this->view->form = $result['form'];
					}else{
						$this->view->form = $result['form'];
					}
				}else{
					$form = $this->_userService->GetRestOwnProfileById($data);
					$this->view->form = $form;
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * function for edit restaurantuser details
	 */
	public function changepatronrecordAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				
				$CountryCodeMapper = new Application_Model_CountryCodeDataMapper();
		    	$CountryCode = $CountryCodeMapper->fetchAll();
		    	$CodeList = array();
		    	$CodeList[] = array('key'=>'','value'=>'Select Country Flag');
		    	foreach($CountryCode as $listcode){
		    		$CodeList[] = array('key'=>$listcode->getCountry_dial_code(),'value'=>$listcode->getCountry_flag());
		    	}
			    	
		    	$this->view->codelist = $CodeList;
		    	
				if($this->getRequest()->isPost()){
					$result = $this->_userService->EditUser($this->getRequest()->getPost(),$data);
					if($result['status']){
						return $this->_helper->redirector('managepatron');
					}else{
						$this->view->form = $result['form'];
					}
				}else{
					$request = $this->getRequest();
					$form = $this->_userService->GetRestuserProfileById($request,$data);
					$this->view->form = $form;
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function changepatronfrmnativeappAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_userService->EditRestaurantUserFromNativeApp($request);
			echo json_encode($result);
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function editpatronpositionfrmnativeappAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_userService->changeRestUserStatusFromNativeApp($request);
			if($result)
			{
				echo json_encode('true');
			}else
			{
				echo json_encode('false');
			}
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * function for manage restaurantusers of each restaurant
	 */
	public function managepatronAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$page = $this->_request->getParam('page');
				if (empty($page)){
					$page = 1;
				}
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$form = $this->_userService->getSearchRestaurantUserForm($data);
				if($data['Usertype'] == "ADM" || $data['Usertype'] == "ADU"){
					$userid = $data['restownerId'];
				}else{
					$userid = $data['User_Id'];
				}
				$this->view->userid = $data['User_Id'];
				$restaurantService = new Application_Service_Firm();
				$restNameList = $restaurantService->GetRestNameById($data);
				foreach($restNameList as $resNameVal){
					$NameList[$resNameVal['key']] = $resNameVal['value'];
					$this->view->RestaurantName = $NameList;
				}
				$formData = array();
				if($this->getRequest()->isPost()){
					$formData = $this->getRequest()->getPost();
					$userlist = $this->_userService->GetRestusersById($formData,$userid,$page);
				}else{
					if($data['Usertype'] == "RSO" || $data['Usertype'] == "ADM" || $data['Usertype'] == "ADU"){
						$userlist = $this->_userService->GetRestusersById($formData,$userid,$page);
					}else if($data['Usertype'] == "RSU" || $data['Usertype'] == "SRU"){
						$formData['RestaurantName'] = $data['RestId'];
						$userlist = $this->_userService->GetRestusersById($formData,$userid,$page);
					}
				}
				$this->view->result = $userlist;
				$this->view->form = $form;
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function modifypatronstatusAction()
	{
		$this->_helper->layout->disableLayout();
		$this->_helper->viewRenderer->setNoRender();
		$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				$result = $this->_userService->changeRestUserStatus($request);
				//return $this->_helper->redirector('managepatron','Client','User');		
				return $this->_helper->redirector('userlevelaccessmanagement','Firm','FirmManagement',array('restaurantid'=>$data['RestId']));	
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}	
		}

	/*public function deleterestuserAction()
	 {
		$auth = Zend_Auth::getInstance();
		if($auth->hasIdentity()){
		$request = $this->getRequest();
		$this->_userService->delRestUser(2,$request);
		return $this->_helper->redirector('managerestuser');
		}else{
		$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
		}
		}*/

	/**
	 * function for change the password of users 
	 */
	public function userpasswordresetAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
                                $this->view->currentPageName = 'userpasswordreset';
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				switch($data['Usertype']){
					case 'CUS' : $this->_helper->layout()->setLayout('customerlayout');
					break;
					case 'RSO' : $this->_helper->layout()->setLayout('global_settings_layout');
					break;
					case 'RSU' : $this->_helper->layout()->setLayout('global_settings_layout');
					break;
					case 'SRU' : $this->_helper->layout()->setLayout('global_settings_layout');
					break;
					case 'ADM' : $this->_helper->layout()->setLayout('adminlayout');
					break;
					case 'ADU' : $this->_helper->layout()->setLayout('adminlayout');
					break;
				}
				$this->view->userid = $data['User_Id'];
				$restaurantService = new Application_Service_Firm();
				$restNameList = $restaurantService->GetRestNameById($data);
				foreach($restNameList as $resNameVal){
					$NameList[$resNameVal['key']] = $resNameVal['value'];
					$this->view->RestaurantName = $NameList;
				}
				$form = $this->_userService->getChangePasswordForm($data);
				if($this->getRequest()->isPost()){
					$result = $this->_userService->changePassword($this->getRequest()->getPost());
					if($result){
						$this->view->passwordmsg = $result['msg'];
					}
				}
				$this->view->form = $form;
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * function for add customers different socialmedia accounts 
	 */
	public function guestpersonalaccountAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$page = $this->_request->getParam('page');
				if (empty($page)){
					$page = 1;
				}
				$this->_helper->layout()->setLayout('customerlayout');
				$form = $this->_userService->getSocialMediaTypeForm($data);
				if($this->getRequest()->isPost()){
					$result = $this->_userService->socialMedia($this->getRequest()->getPost());
					if($result['success']){
						$this->view->msg = 'User Id saved successfully.';
					}else if($result['exist']){
						$this->view->msg = 'User Id already exists.';
					}
				}
				$socialProfObj = $this->_userService->cusSocialProfile($data,$page);
				$this->view->socialProfObj = $socialProfObj;
				$this->view->form = $form;
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * function for edit customers different socialmedia details 
	 */
	public function updateguestpersonalaccountAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$userid = $data['User_Id'];
				if($this->getRequest()->isPost()){
					$status = $this->_userService->EditSocialProfile($this->getRequest(),$userid);
					$this->_helper->layout->disableLayout();
					$this->_helper->viewRenderer->setNoRender();
					if($status){
						echo "t";
					}else{
						echo "f";
					}
				}else{
					$request = $this->getRequest();
					$form = $this->_userService->getSocialprofileById($request);
					$this->view->form = $form;
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * function for delete customers different socialmedia details 
	 */
	public function removeguestpersonalaccountAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$this->_helper->layout()->setLayout('customerlayout');
				$this->_userService->delSocilaProfile('FALSE',$request);
				return $this->_helper->redirector('socialprofile');
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * function for get customer favorite restaurants. 
	 */
	public function guestfavoriterestaurantsAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$pageview = $this->_request->getParam('pageview');
				if (empty($pageview)){
					$pageview = 1;
				}
				$page = $this->_request->getParam('page');
				if (empty($page)){
					$page = 1;
				}
				$request = $this->getRequest();
//				if($this->getRequest()->isPost()){
//					$result = $this->_userService->getFevRestIds($request,$data);
//				}
				$this->_helper->layout()->setLayout('customerlayout');
				if($request->favoriterestautant){
					$restList = $this->_userService->CusFevRestaurants($data,$pageview);
					$this->view->result = $restList;
					$resultSet = $this->_userService->GetRestaurantInfoByCusId($data,$page);
					$this->view->results = $resultSet;
				}else if($request->visitedrestaurant){
					$resultSet = $this->_userService->GetRestaurantInfoByCusId($data,$page);
					$resultvisite = 'visited';
					$this->view->resultvisit = $resultvisite;
					$this->view->results = $resultSet;
					$restList = $this->_userService->CusFevRestaurants($data,$pageview);
					$this->view->result = $restList;
				}
				else{
					$restList = $this->_userService->CusFevRestaurants($data,$pageview);
					$this->view->result = $restList;
					$resultSet = $this->_userService->GetRestaurantInfoByCusId($data,$page);
				}
				$this->view->results = $resultSet;

			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	/**
	 * function for add the restaurant to favoritelist. 
	 */
	public function createlistoffavoritefirmsAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$page = $this->_request->getParam('page');
				if (empty($page)){
					$page = 1;
				}
				$request = $this->getRequest();
				$this->_helper->layout()->setLayout('customerlayout');
				$restService = new Application_Service_Firm();
				
				$form = $this->_userService->getSearcgFevRestaurant($data);
				$formdata = array();
				if($this->getRequest()->isPost()){
					$formdata = $this->getRequest()->getPost();
						if(isset($formdata['state'])&& $formdata['state']!='')
						{
						$regionMapper = new Application_Model_RegionDataMapper();
						$regionObj = new Application_Model_Region();
				        $regionObj->setStateId($formdata['state']);
						$regionBd = $restService->getRegionsByStateId($regionObj);
						$regionList=array();
						$regionList=$regionBd->getRegionList();
						$form->region->addMultiOptions($regionList);
						$this->view->state=$formdata['state'];
						}
						if(isset($formdata['region'])&& $formdata['region']!='')
						{
						$cityMapper = new Application_Model_CityDataMapper();
						$cityObj = new Application_Model_City();
						$cityObj->setRegionId($formdata['region']);
						$cityBd		= $restService->getCitysByRegionId($cityObj);
						$cityList=$cityBd->getCityList();	
						$form->city->addMultiOptions($cityList);
						$this->view->region=$formdata['region'];
						}
					
						if(isset($formdata['city']) && $formdata['city']!='')
						{
						$nghMapper = new Application_Model_NeighborhoodDataMapper();
						$nghObj = new Application_Model_Neighborhood();
						$nghObj->setCityId($formdata['city']);
						$neighborBd = $restService->getNghIdCidyId($nghObj);
						$neighborhoodlist=$neighborBd->getNeighborhoodList();
						$form->neighborhood->addMultiOptions($neighborhoodlist);
						$this->view->city=$formdata['city'];
					
						}
						if(isset($formdata['neighborhood'])&& $formdata['neighborhood']!='0')
						$this->view->neighborhood=$formdata['neighborhood'];
						if($formdata['restName']!='')
						$this->view->restName=$formdata['restName'];
						$form->populate($formdata);
						$this->view->form =  $form;
					}
				$userid = $data['User_Id'];
				$restList = $this->_userService->GetRestaurants($formdata,$userid,$page);
					if($restList['status']){
						$this->view->results = $restList['restForm'];
						$this->view->form = $form;
						$this->view->pagenator = $restList['paginator'];
					}else{
						$this->view->form = $form;
					}
					
				//$this->view->pagenator = $restList['paginator'];
				//$this->view->form = $form;
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * display all the restaurantusers for the search  
	 */
	public function patronslistforsearchAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				$this->_helper->layout()->setLayout('restaurantuserlayout');
					
				if($this->getRequest()->isPost()){
					$restList = $this->_userService->getRestaurantUsers($this->getRequest()->getPost(),$userid);
				}
				$this->view->form = $form;
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * function for check whether email already exists
	 */
	public function searchforemailexistAction()
	{
		try{
			if($this->getRequest()->isPost()){
				$emailObj = new User_Model_Signin();
				if($_REQUEST['email']){
					$emailObj->setEmailAddress(strtolower(trim($_REQUEST['email'])));
				}
				$result = $this->_userService->CheckEmailAvaliable($emailObj);
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				if($result){
					echo "t";
				}else{
					echo "f";
				}
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function searchforsocialemailexistAction()
	{
		try{
			if($this->getRequest()->isPost()){
				$emailObj = new User_Model_signin();
				if($_REQUEST['email']){
					$emailObj->setEmailAddress(strtolower(trim($_REQUEST['email'])));
				}
				$result = $this->_userService->CheckEmailAvaliable($emailObj);
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				if($result){
					echo "t";
				}else{
					echo "f";
				}
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * function to check email id in the system
	 */
	public function findemailidfordisrememberpasswordAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			if($this->getRequest()->isPost()){
				$request = $this->getRequest();
				$result = $this->_userService->emailCheck($request);
				if($result){
					echo json_encode($result);
				}else{
					echo json_encode('f');
				}
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
		
	/**
	 * function for send auto genarated password to user
	 */
	public function disrememberpasswordAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			if($this->getRequest()->isPost()){
				$request = $this->getRequest();
				$result = $this->_userService->sendPassword($request);
				if($result){
					echo "t";
				}else{
					echo "f";
				}
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * function for sending verifyCode to genarate password to user
	 */
	public function postcodefordisrememberpasswordAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			if($this->getRequest()->isPost()){
				$request = $this->getRequest();
				$result = $this->_userService->sendPasswordbyajax($request);
				if($result){
					echo $result;
				}else{
					echo "f";
				}
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function disrememberpaswrdforsocialwidgetAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			if($this->getRequest()->isPost()){
				$request = $this->getRequest();
				$result = $this->_userService->sendPassword($request);
				if($result){
					echo "t";
				}else{
					echo "f";
				}
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * function for get all notifications recived by user
	 */
	public function receivecommunicationsbyguestidAction()
	{
		$auth = Zend_Auth::getInstance();
		if($auth->hasIdentity()){
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			$this->_helper->layout()->setLayout('customerlayout');
			$notifications = $this->_userService->getNotificationsByUserId($data);
			$this->view->notifications = $notifications;			
		}else{
			$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
		}
	}
	
	/**
	 * action to retreive the notification details 
	 */
	public function retrievecommunicationdetailsbyguestidAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout()->setLayout('customerlayout');
				$request = $this->getRequest();
				$msgid = $request->msgid;
				$service = new Application_Service_Communication();
				$result = $service->GetTitleandMessageById($msgid);
				$this->view->title = $result['title'];	
				$this->view->message = $result['Message'];
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/*	public function customermychoiceAction()
	 {
		$auth = Zend_Auth::getInstance();
		if($auth->hasIdentity()){
		$storage = new Zend_Auth_Storage_Session();
		$data = $storage->read();
		$this->_helper->layout()->setLayout('customerlayout');
		}else{
		$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
		}
		}*/

	public function tutorialsAction()
    {
//   		$this->_helper->layout()->setLayout('restaurantuserlayout');
    }

	public function retrievemanagerinfobyidAction()
    {
   	 try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			if($this->getRequest()->isPost()){
				$request = $this->getRequest();
				$result = $this->_userService->getOwnerDescriptionbyId($request);
				if($result){
					echo json_encode($result);
				}else{
					echo "f";
				}
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
    }
    
	public function createadminpatronAction()
	{
		$this->_helper->layout()->setLayout('adminlayout');
		$auth = Zend_Auth::getInstance();
		if($auth->hasIdentity()){
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			$form = $this->_userService->getAddAdminUserForm();
			if($this->getRequest()->isPost()){
				if($this->_userService->addAdminUser($this->getRequest()->getPost(), $data)){
					return $this->_helper->redirector('maintainadminpatrons','Client','User');
				}
			}
			$this->view->form = $form;
		}else{
			$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
		}
	}
	
	public function maintainadminpatronsAction()
	{
		$this->_helper->layout()->setLayout('adminlayout');
		$auth = Zend_Auth::getInstance();
		if($auth->hasIdentity()){
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			$form = $this->_userService->getAddAdminUserForm();
			$editform = $this->_userService->getEditAdminUserForm();
			$request = $this->getRequest();
			$adminService = new Application_Service_Administrator();
			if($this->getRequest()->isPost()){
				$operation = $request->status;
				if($request->companyid){ 
					switch($operation){
						case 'ADD'	:
								$result = $adminService->AddRoleToCompany($this->getRequest()->getPost(), $data);
								if($result['status']){
									break;
								}else if(isset($result['form'])){
									break;
								}
						case 'EDIT'	:
								$result = $adminService->UpdateRoleByCompany($this->getRequest()->getPost(), $data);
								if($result['status']){
									break;
								}else if(isset($result['form'])){
									break;
								}
					}
				}else if($request->status == 'EDITCOMPANY'){
					$formresult = $adminService->UpdateCompany($this->getRequest()->getPost(), $data);					
				}else{
					switch($operation){
						case 'ADD'	:
							$result = $this->_userService->addAdminUser($this->getRequest()->getPost(), $data);
							if(isset($result['form']) && (!$result['status'])){
								$this->view->addForm = $result['form'];
								$this->view->addstatus = 't';
							}
							break;
						case 'EDIT'	:
							$result = $this->_userService->EditAdminUserProfile($this->getRequest()->getPost(), $data);
							if(isset($result['form']) && (!$result['status'])){
								$this->view->editform = $result['form'];
								$this->view->editstatus = 't';
							}
							break;
					}
				}
			}
			$result = $this->_userService->manageAdminUsers($data);
			$this->view->result = $result;
			$this->view->form = $form;
			$this->view->editform = $editform;
			
			//*** Roles code Start  ***//
			$adminService = new Application_Service_Administrator();
			$roleform = $adminService->getAddAdminRoleForm();
			$editroleform = $adminService->getEditAdminRoleForm();
			$page = $this->_request->getParam('page');
			if (empty($page)){
				$page = 1;
			}
			$compNameList = $adminService->getComapnyNameList($data);
			$menumapper = new Application_Model_AdminPermissionsTypeDataMapper();
			$menu = $menumapper->getAdminMenuBD();
			$restUserMenuList = array();
			foreach($menu as $menulist){
				if($menulist->getCode() != "MR" && $menulist->getCode() != 'PS' && $menulist->getCode() != 'MPAY' && $menulist->getCode() != "BV"){
					$restUserMenuList[] = array('key'=>$menulist->getId(),'value'=>$menulist->getDescription());
				}
			}
			$roleform->permisstionType->addMultiOptions($restUserMenuList);
			$roleform->companyName->addMultiOptions($compNameList);
			$editroleform->editcompanyName->addMultiOptions($compNameList);
			if($request->companyid){
				$roles = $adminService->getRolesByCompanyId($request->companyid, $page);
				$this->view->roles = $roles;
				$roleform->setDefaults(array('companyName'=>$request->companyid));
			}
			$this->view->roleform = $roleform;
			$this->view->editroleform = $editroleform;
			 /*** End roles code 
			
			 Edit Company code start ***/
			if($request->update == "UPDATE"){
				$mapper = new Administrator_Model_CompanyDataMapper();
				$update = $mapper->UpdateStatus($request);
				$this->view->pageview = 't';
			}	
			if($request->pageview){			
				$companys = $adminService->GetCompanys($request->pageview);
				$this->view->pageview = $request->pageview;
			}else{
				$page = 1;
				$companys = $adminService->GetCompanys($page);
			}
			$this->view->companys = $companys;
			if(isset($formresult['form']) && (!$formresult['status'])){
				$this->view->editForm = $formresult['form'];
				$this->view->editcompanystatus = 't';
			}else{
					$this->view->editForm = $adminService->getAddCompanyForm();
			}
				/*** End of company code  ***/
		}else{
			$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
		}
	}
	
	public function updateadminpatronAction()
	{
		$this->_helper->layout()->setLayout('adminlayout');
		$auth = Zend_Auth::getInstance();
		if($auth->hasIdentity()){
			$request = $this->getRequest();
			if($this->getRequest()->isPost()){
				$result = $this->_userService->EditAdminUserProfile($this->getRequest()->getPost(),$request);
				if($result['status']){
					return $this->_helper->redirector('maintainadminpatrons','Client','User');
				}else{
					$this->view->id = $request->id;
					$this->view->form = $result['form'];
				}
			}else{
				$form = $this->_userService->getAdminUserDetailsById($request);
				$this->view->form = $form;
				$this->view->id = $request->id;
			}
		}else{
			$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
		}
	}
	
	public function retrieveadminpatroninfobyidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			if($this->getRequest()->isPost()){
				$request = $this->getRequest();
				$result = $this->_userService->getAdminUserDetailsById($request);
				$jsonObj = json_encode($result);
				echo $jsonObj;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function editadminpatronstatusAction()
	{
		$this->_helper->layout()->setLayout('adminlayout');
		$auth = Zend_Auth::getInstance();
		if($auth->hasIdentity()){
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			$request = $this->getRequest();
			$result = $this->_userService->adminUserStatusChange($request);
			return $this->_helper->redirector('maintainadminpatrons','Client','User');
		}else{
			$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
		}
	}
	
	/**
	 * function for manage restaurant users initials of each restaurant
	 */
	public function maintainpatroncodesAction()
	{
	try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$page = $this->_request->getParam('page');
				if (empty($page)){
					$page = 1;
				}
				$this->_helper->layout()->setLayout('restaurantuserlayout');
//				$form = $this->_userService->getRestaurantUserInitialsForm($data);
				$userid = $data['User_Id'];
				$formData = array();
				if($this->getRequest()->isPost()){
					$result = $this->_userService->updateuserinitial($this->getRequest()->getPost(),$data);
					if($result['status']){
						return $this->_helper->redirector('manageinitials');
					}else{
						$this->view->form = $result['form'];
					}
				}else{
					$form = $this->_userService->getRestaurantUserInitialsForm($data);
					$this->view->form = $form;
				}
				
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function retrievefirmpatronsbyfirmidAction()
    {
   	 	try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			if($this->getRequest()->isPost()){
				$request = $this->getRequest();
				$result = $this->_userService->getrestusersbyrestid($request);
				$jsonObj = json_encode($result);
				echo $jsonObj;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
    }
    
	public function retrievepatroncodesbypatronidAction()
    {
   	 try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			if($this->getRequest()->isPost()){
				$request = $this->getRequest();
				$result = $this->_userService->getinitialbyuserid($request);
				$jsonObj = json_encode($result);
				echo $jsonObj;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
    }
    
	public function checkpatroncodeAction()
    {
   	 try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			if($this->getRequest()->isPost()){
				$request = $this->getRequest();
				$users = $this->_userService->initialcheck($request);
				$jsonObj = json_encode($users);
				echo $jsonObj;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
    }
    
    public function editpatroncodesAction()
    {
     try{
    		$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_userService->changepatron($request);
				if($result)
				{
					$status = 't';
				}else{
					$status = 'f';
				}
				echo $status;
			
       	}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
    }

    public function specifybestfirmbyajaxAction()
    {
     try{
     		$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
			}
    		$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			if($this->getRequest()->isPost()){
				$request = $this->getRequest();
				$result = $this->_userService->AddFavouriteRest($request,$data);
				if($result)
				{
					$status = 't';
				}else{
					$status = 'f';
				}
				echo $status;
			}
       	}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
    }

	public function signinfromwidgetAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			
			
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity() && isset($data['User_Id'])){
				if(isset($request->code)){
					echo "<script type=\"text/javascript\">";
    				echo "window.opener.location.href = '".$loginProfile['widgetlink']."';window.close(); </script>";
				}else{
					echo 'auth';
				}
			}else if(isset($request->error_reason) && isset($request->error)){
				$auth->clearIdentity();
				echo "<script type=\"text/javascript\">";
    			echo "window.close(); </script>";
			}else{
				$storage = new Zend_Auth_Storage_Session('fblogin');
				$data = $storage->read();
				$auth = Zend_Auth::getInstance();
				/* facebook*/
				include('facebook/src/facebook.php');	
				$app_id	= '174154322766851';
				$app_secret	= '1b3d72b533301ed3332c344db134c94d';	
				$domain = 'www.dinedesk.com';
				if($_SERVER['SERVER_NAME'] == 'hbcsolutions.net' || $_SERVER['SERVER_NAME'] == 'www.hbcsolutions.net'){
					$app_id	= '948525858546744';
					$app_secret	= '2b32439c9e2074a64ee77c5f549cf34a';
					$domain = 'www.hbcsolutions.net';
				}

				//$app_id = "457400417677841";
			   	//$app_secret = "d9db9df7d728a68d107548de0b8a2a06";
			   	$my_url = "http://".$_SERVER["HTTP_HOST"]."/User/Client/signinfromwidget";

			 	
			   	$loginProfile = $data;
			   	if(isset($request->widgetlink)){
			   		$loginProfile['widgetlink'] = $request->widgetlink;
			   	}
			   	$facebook = new Facebook(array(
				    'appId'  => $app_id,
				    'secret' => $app_secret,
				));
				$code = $request->code;
				
			   	if(empty($code)) {
			    	$loginProfile['state'] = md5(uniqid(rand(), TRUE)); // CSRF protection
			     	$dialog_url = "https://www.facebook.com/dialog/oauth?display=popup&domain=".$domain."&locale=en_US&client_id=" 
							       . $app_id . "&redirect_uri=" . urlencode($my_url) . "&scope=email&state="
							       . $loginProfile['state'];
			
			     	
			//     	echo '<a href="'.$dialog_url.'" onclick="window.open (this.href, "child", "height=400,width=300"); return false">Click to log out</a>';
					$storage->write($loginProfile); 
					echo $dialog_url; 
			   	}
			   	if($loginProfile['state'] && ($loginProfile['state'] === $request->state)) {
			    	$token_url = "https://graph.facebook.com/oauth/access_token?"
						       . "client_id=" . $app_id . "&redirect_uri=" . urlencode($my_url)
						       . "&client_secret=" . $app_secret . "&code=" . $code."&scope=email";
			
					try{
				     	$response = file_get_contents($token_url);
				     	$params = null;
				     	parse_str($response, $params);
				
				     	$loginProfile['access_token'] = $params['access_token'];
				
				     	$graph_url = "https://graph.facebook.com/me?access_token=" 
				       				. $params['access_token'];

				       	$user = $facebook->api('/me?fields=id,gender,email',array('access_token'=>$params['access_token']));
						$object = (object) $user;
					    //$user = json_decode(file_get_contents($graph_url));
					    $emailObj = new User_Model_Signin();
						$emailObj->setEmailAddress(strtolower(trim($object->email)));
						$result = $this->_userService->manageLoginProfileWidget($object,$loginProfile);
						if($result['Status']){
							$auth->clearIdentity();
							$auth = Zend_Auth::getInstance();
							$storage = new Zend_Auth_Storage_Session();
							$storage->write($result['loginprofile']);
							echo "<script type=\"text/javascript\">";
	    					echo "window.opener.location.href = '".$loginProfile['widgetlink']."';window.close(); </script>";
						}else{
							$auth->clearIdentity();
							echo "<script type=\"text/javascript\">";
	    					echo "window.close(); </script>";
						}
					}catch(Exception $e){
						unset($loginProfile['access_token']);
						$storage->write($loginProfile);
					}
			   	}
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function signinfromwidgetfbAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			
			
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity() && isset($data['User_Id'])){
				if(isset($request->code)){
					echo "<script type=\"text/javascript\">";
    				echo "window.top.location = '".$loginProfile['widgetlink']."'; </script>";
				}else{
					echo 'auth';
				}
			}else if(isset($request->error_reason) && isset($request->error)){
				$auth->clearIdentity();
				echo "<script type=\"text/javascript\">";
    			echo " </script>";
			}else{
				$storage = new Zend_Auth_Storage_Session('fblogin');
				$data = $storage->read();
				$auth = Zend_Auth::getInstance();
				/* facebook*/
				include('facebook/src/facebook.php');	
				$app_id	= '174154322766851';
				$app_secret	= '1b3d72b533301ed3332c344db134c94d';	
				$domain = 'www.dinedesk.com';
				if($_SERVER['SERVER_NAME'] == 'hbcsolutions.net' || $_SERVER['SERVER_NAME'] == 'www.hbcsolutions.net'){
					$app_id	= '948525858546744';
					$app_secret	= '2b32439c9e2074a64ee77c5f549cf34a';
					$domain = 'www.hbcsolutions.net';
				}

				//$app_id = "457400417677841";
			   	//$app_secret = "d9db9df7d728a68d107548de0b8a2a06";
			   	$my_url = "http://".$_SERVER["HTTP_HOST"]."/User/Client/signinfromwidgetfb";

			 	
			   	$loginProfile = $data;
			   	if(isset($request->widgetlink)){
			   		$loginProfile['widgetlink'] = $request->widgetlink;
			   	}
			   	$facebook = new Facebook(array(
				    'appId'  => $app_id,
				    'secret' => $app_secret,
				));
				$code = $request->code;
				
			   	if(empty($code)) {
			    	$loginProfile['state'] = md5(uniqid(rand(), TRUE)); // CSRF protection
			     	$dialog_url = "https://www.facebook.com/dialog/oauth?display=popup&domain=".$domain."&locale=en_US&client_id=" 
							       . $app_id . "&redirect_uri=" . urlencode($my_url) . "&scope=email&state="
							       . $loginProfile['state'];
			
			     	
			//     	echo '<a href="'.$dialog_url.'" onclick="window.open (this.href, "child", "height=400,width=300"); return false">Click to log out</a>';
					$storage->write($loginProfile); 
					//echo $dialog_url; 
					echo "<script type=\"text/javascript\">";
					echo "window.top.location = '$dialog_url';</script>";
			   	}
			   	if($loginProfile['state'] && ($loginProfile['state'] === $request->state)) {
			    	$token_url = "https://graph.facebook.com/oauth/access_token?"
						       . "client_id=" . $app_id . "&redirect_uri=" . urlencode($my_url)
						       . "&client_secret=" . $app_secret . "&code=" . $code."&scope=email";
			
					try{
				     	$response = file_get_contents($token_url);
				     	$params = null;
				     	parse_str($response, $params);
				
				     	$loginProfile['access_token'] = $params['access_token'];
				
				     	$graph_url = "https://graph.facebook.com/me?access_token=" 
				       				. $params['access_token'];

				       	$user = $facebook->api('/me?fields=id,gender,email',array('access_token'=>$params['access_token']));
						$object = (object) $user;
					    //$user = json_decode(file_get_contents($graph_url));
					    $emailObj = new User_Model_Signin();
						$emailObj->setEmailAddress(strtolower(trim($object->email)));
						$result = $this->_userService->manageLoginProfileWidget($object,$loginProfile);
						if($result['Status']){
							$auth->clearIdentity();
							$auth = Zend_Auth::getInstance();
							$storage = new Zend_Auth_Storage_Session();
							$storage->write($result['loginprofile']);
							echo "<script type=\"text/javascript\">";
	    					echo "window.top.location = '".$loginProfile['widgetlink']."'; </script>";
						}else{
							$auth->clearIdentity();
						}
					}catch(Exception $e){
						unset($loginProfile['access_token']);
						$storage->write($loginProfile);
					}
			   	}
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function signinfrommobileversionAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity() && isset($data['User_Id'])){
				if(isset($request->code)){
					echo "<script type=\"text/javascript\">";
					if($data['Usertype'] == 'CUS'){
    					echo "window.location.href = '/index.php/Phone/Customer/customerdashboard';window.close(); </script>";
					}else{
						echo "window.location.href = '/index.php/Phone/Restaurant/restaurantlist';window.close(); </script>";
					}
				}else{
					if($data['Usertype'] == 'CUS'){
						echo 'CUS';
					}else{
						echo 'auth';
					}
				}
			}else if(isset($request->error_reason) && isset($request->error)){
				$auth->clearIdentity();
				echo "<script type=\"text/javascript\">";
    			echo "window.close(); </script>";
			}else{
				$storage = new Zend_Auth_Storage_Session('fblogin');
				$data = $storage->read();
				$auth = Zend_Auth::getInstance();
				/* facebook*/
				include('facebook/src/facebook.php');	
			 	$app_id = "457400417677841";
			   	$app_secret = "d9db9df7d728a68d107548de0b8a2a06";
			   	$my_url = "http://www.dinedesk.com/User/Client/signinfrommobileversion";
			   	
			   	$loginProfile = $data;

			   	$facebook = new Facebook(array(
				    'appId'  => '457400417677841',
				    'secret' => 'd9db9df7d728a68d107548de0b8a2a06',
				));
				$code = $request->code;
				
			   	if(empty($code)) {
			    	$loginProfile['state'] = md5(uniqid(rand(), TRUE)); // CSRF protection
			     	$dialog_url = "https://www.facebook.com/dialog/oauth?display=popup&domain=www.dinedesk.com&locale=en_US&client_id=" 
							       . $app_id . "&redirect_uri=" . urlencode($my_url) . "&scope=email&state="
							       . $loginProfile['state'];
			
			     	
					$storage->write($loginProfile); 
					echo $dialog_url; 
			   	}
			   	if($loginProfile['state'] && ($loginProfile['state'] === $request->state)) {
			    	$token_url = "https://graph.facebook.com/oauth/access_token?"
						       . "client_id=" . $app_id . "&redirect_uri=" . urlencode($my_url)
						       . "&client_secret=" . $app_secret . "&code=" . $code."&scope=email";
			
					try{
				     	$response = file_get_contents($token_url);
				     	$params = null;
				     	parse_str($response, $params);
				
				     	$loginProfile['access_token'] = $params['access_token'];
				
				     	$graph_url = "https://graph.facebook.com/me?access_token=" 
				       				. $params['access_token'];
				
					    $user = json_decode(file_get_contents($graph_url));
					    $emailObj = new User_Model_Signin();
						$emailObj->setEmailAddress(strtolower(trim($user->email)));
						$result = $this->_userService->manageLoginProfileWidget($user,$loginProfile);
						if($result['Status']){
							$auth->clearIdentity();
							$auth = Zend_Auth::getInstance();
							$storage = new Zend_Auth_Storage_Session();
							$storage->write($result['loginprofile']);
							echo "<script type=\"text/javascript\">";
							if($result['Usertype']  == "ADU" || $result['Usertype']  == "RSO" || $result['Usertype']  == "RSU"  ){ 
								$loginProfile['widgetlink'] = "/index.php/Phone/Restaurant/restaurantlist";
							}else if($result['Usertype']  == "CUS" ){
								$loginProfile['widgetlink'] = "/index.php/Phone/Customer/customerdashboard";
							}
							echo "window.location.href = '".$loginProfile['widgetlink']."';window.close(); </script>";
						}else{
							$auth->clearIdentity();
							echo "<script type=\"text/javascript\">";
	    					echo "window.close(); </script>";
						}
					}catch(Exception $e){
						unset($loginProfile['access_token']);
						$storage->write($loginProfile);
					}
			   	}
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function widgetlogoutAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$auth = Zend_Auth::getInstance();
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			if($auth->hasIdentity()){
			 	$app_id = "457400417677841";
			   	$app_secret = "d9db9df7d728a68d107548de0b8a2a06";
			   	$my_url = "http://www.dinedesk.com/User/Client/signoutfromwidget";
			
			   	$token = $data["access_token"];
			   	if($token) {
			     	$graph_url = "https://graph.facebook.com/me/permissions?method=delete&access_token=" 
			       				. $token;
		
			       	try{
				     	$result = json_decode(file_get_contents($graph_url));
				     	if($result) {
							$auth->clearIdentity();
					        echo("User is now logged out.");
				     	}
			       	}catch(Exception $e){
						unset($data['access_token']);
						$storage->write($data);
					}
			   	} else {
			     	echo("User already logged out.");
			   	}
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}	
	
	public function reservationwidgetusermangementAction()
	{
		try{
			$this->_helper->layout->disableLayout();

			$auth = Zend_Auth::getInstance();
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			$request = $this->getRequest();
			if($auth->hasIdentity()){
				$this->view->userLogStat = 'true';
			}else{
				$this->view->userLogStat = 'false';
			}
			if(isset($request->bokSrcComp)){
				$this->view->bokSrcComp = $request->bokSrcComp;
			}else{
				$this->view->bokSrcComp = 'INAT';
			}
			$this->view->restaurantid = $request->restaurantid;
			
			$this->view->widgetlink = $request->widgetlink;
			
			$dateSplit = explode("-",$request->resdate);
			$s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
			$weekdate = date("D d M Y", $s);
			
			$this->view->resname = $request->resname;
			$this->view->restime = $request->restime;
			$this->view->resdate = $request->resdate;
			$this->view->weekdate = $weekdate;
			$this->view->respax = $request->respax;
			$this->view->inventoryid = $request->inventoryid;
			$this->view->tablesize = $request->tablesize;
			$this->view->nooftables = $request->nooftables;
			$this->view->bookingstatus = $request->bookingstatus;
			$this->view->resaddress = $request->resaddress;
			$this->view->resCompanyid = $request->rescompanyid;
			$this->view->mealtype = $request->mealtype;
			
			/* Get Widget Theme Start */
			$restService = new Application_Service_Firm();
			$theme = $restService->GetWidgetThemeByRestId($request);
			$this->view->theme = $theme;
			
			/* Get Widget Theme End */
			
			$restId = $request->restaurantid;
			$restService = new Application_Service_Firm();
			$widsettings = $restService->getRestaurantCustomizeWidgetByResid($restId);
			if($widsettings){
				$this->view->widsettings = $widsettings;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function wixwidgetusermangementAction()
	{
		try{
			$this->_helper->layout->disableLayout();

			$auth = Zend_Auth::getInstance();
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			$request = $this->getRequest();
			if($auth->hasIdentity()){
				$this->view->userLogStat = 'true';
			}else{
				$this->view->userLogStat = 'false';
			}
			$this->view->deviceType = $request->deviceType;
			$this->view->restaurantid = $request->restaurantid;
			
			$this->view->widgetlink = $request->widgetlink;
			
			$dateSplit = explode("-",$request->resdate);
			$s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
			$weekdate = date("D d M Y", $s);
			
			$this->view->resname = $request->resname;
			$this->view->restime = $request->restime;
			$this->view->resdate = $request->resdate;
			$this->view->weekdate = $weekdate;
			$this->view->respax = $request->respax;
			$this->view->inventoryid = $request->inventoryid;
			$this->view->tablesize = $request->tablesize;
			$this->view->nooftables = $request->nooftables;
			$this->view->bookingstatus = $request->bookingstatus;
			$this->view->resaddress = $request->resaddress;
			$this->view->rescompanyid = $request->rescompanyid;
			$this->view->mealtype = $request->mealtype;
			$this->view->wixtitleColor = $request->wixtitleColor;
			$this->view->wixwidimage = $request->wixwidimage;
			$this->view->wixfontColor = $request->wixfontColor;
			$this->view->wixwidBtn = $request->wixwidBtn;
			/* Get Widget Theme Start */
			$restService = new Application_Service_Firm();
			$theme = $restService->GetWidgetThemeByRestId($request);
			$this->view->theme = $theme;
			
			/* Get Widget Theme End */
			
			$restId = $request->restaurantid;
			$restService = new Application_Service_Firm();
			$widsettings = $restService->getRestaurantCustomizeWidgetByResid($restId);
			if($widsettings){
				$this->view->widsettings = $widsettings;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function reservationwidgetpatronsigningupAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_userService->widgetUserRegistration($request);
			if($result){
				echo 't';
			}else{
				echo 'f';
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function signinfromsocialwidgetAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			
			
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity() && isset($data['User_Id'])){
				if(isset($request->code)){
					echo "<script type=\"text/javascript\">";
    				echo "window.opener.location.href = '".$loginProfile['widgetlink']."';window.close(); </script>";
				}else{
					echo 'auth';
				}
			}else if(isset($request->error_reason) && isset($request->error)){
				$auth->clearIdentity();
				echo "<script type=\"text/javascript\">";
    			echo "window.close(); </script>";
			}else{
				$storage = new Zend_Auth_Storage_Session('fblogin');
				$data = $storage->read();
				$auth = Zend_Auth::getInstance();
				/* facebook*/
				include('facebook/src/facebook.php');	
			 	$app_id = "457400417677841";
			   	$app_secret = "d9db9df7d728a68d107548de0b8a2a06";
			   	$my_url = "http://www.dinedesk.com/User/Client/signinfromsocialwidget";
			   	
			   	$loginProfile = $data;
			   	if(isset($request->widgetlink)){
			   		$loginProfile['widgetlink'] = $request->widgetlink;
			   	}
			   	$facebook = new Facebook(array(
				    'appId'  => '457400417677841',
				    'secret' => 'd9db9df7d728a68d107548de0b8a2a06',
				));
				$code = $request->code;
				
			   	if(empty($code)) {
			    	$loginProfile['state'] = md5(uniqid(rand(), TRUE)); // CSRF protection
			     	$dialog_url = "https://www.facebook.com/dialog/oauth?display=popup&domain=www.dinedesk.com&locale=en_US&client_id=" 
							       . $app_id . "&redirect_uri=" . urlencode($my_url) . "&scope=email&state="
							       . $loginProfile['state'];
			
			     	
			//     	echo '<a href="'.$dialog_url.'" onclick="window.open (this.href, "child", "height=400,width=300"); return false">Click to log out</a>';
					$storage->write($loginProfile); 
					echo $dialog_url;
			   	}
			   	if($loginProfile['state'] && ($loginProfile['state'] === $request->state)) {
			    	$token_url = "https://graph.facebook.com/oauth/access_token?"
						       . "client_id=" . $app_id . "&redirect_uri=" . urlencode($my_url)
						       . "&client_secret=" . $app_secret . "&code=" . $code."&scope=email";
			
					try{
				     	$response = file_get_contents($token_url);
				     	$params = null;
				     	parse_str($response, $params);
				
				     	$loginProfile['access_token'] = $params['access_token'];
				
				     	$graph_url = "https://graph.facebook.com/me?access_token=" 
				       				. $params['access_token'];
				
					    $user = json_decode(file_get_contents($graph_url));
					    $emailObj = new User_Model_Signin();
						$emailObj->setEmailAddress(strtolower(trim($user->email)));
						$result = $this->_userService->manageLoginProfileWidget($user,$loginProfile);
						if($result['Status']){
							$auth->clearIdentity();
							$auth = Zend_Auth::getInstance();
							$storage = new Zend_Auth_Storage_Session();
							$storage->write($result['loginprofile']);
							echo "<script type=\"text/javascript\">";
	    					echo "window.opener.location.href = '".$loginProfile['widgetlink']."';window.close(); </script>";
						}else{
							$auth->clearIdentity();
							echo "<script type=\"text/javascript\">";
	    					echo "window.close(); </script>";
						}
					}catch(Exception $e){
						unset($loginProfile['access_token']);
						$storage->write($loginProfile);
					}
			   	}
			}
			if($request){
				
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function singoutfromsocalwidgetAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$auth = Zend_Auth::getInstance();
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			if($auth->hasIdentity()){
			 	$app_id = "457400417677841";
			   	$app_secret = "d9db9df7d728a68d107548de0b8a2a06";
			   	$my_url = "http://www.dinedesk.com/User/Client/singoutfromsocalwidget";
			
			   	$token = $data["access_token"];
			   	if($token) {
			     	$graph_url = "https://graph.facebook.com/me/permissions?method=delete&access_token=" 
			       				. $token;
			
			        try{
			     	$result = json_decode(file_get_contents($graph_url));
			     	if($result) {
						$auth->clearIdentity();
				        echo("User is now logged out.");
			     	}
			        }catch(Exception $e){
						unset($data['access_token']);
						$storage->write($data);
					}
			   	} else {
			     	echo("User already logged out.");
			   	}
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}	
	
	public function socialreservationwidgetusermangementAction()
	{
		try{
			$this->_helper->layout->disableLayout();

			$auth = Zend_Auth::getInstance();
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			$request = $this->getRequest();
			if($auth->hasIdentity()){
				$this->view->userLogStat = 'true';
			}else{
				$this->view->userLogStat = 'false';
			}
			$this->view->restaurantid = $request->restaurantid;
			
			$this->view->widgetlink = $request->widgetlink;
			
			$dateSplit = explode("-",$request->resdate);
			$s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
			$weekdate = date("D d M Y", $s);
			
			$this->view->resname = $request->resname;
			$this->view->restime = $request->restime;
			$this->view->resdate = $request->resdate;
			$this->view->weekdate = $weekdate;
			$this->view->respax = $request->respax;
			$this->view->inventoryid = $request->inventoryid;
			$this->view->tablesize = $request->tablesize;
			$this->view->nooftables = $request->nooftables;
			$this->view->bookingstatus = $request->bookingstatus;
			$this->view->resaddress = $request->resaddress;
			$this->view->mealtype = $request->mealtype;
                        $this->view->resCompanyid = $request->rescompanyid;
					
			/* Get Widget Theme Start */
			$restService = new Application_Service_Firm();
			$theme = $restService->GetWidgetThemeByRestId($request);
			$this->view->theme = $theme;
			
			/* Get Widget Theme End */
			
			$restId = $request->restaurantid;
			$restService = new Application_Service_Firm();
			$widsettings = $restService->getRestaurantCustomizeWidgetByResid($restId);
			if($widsettings){
				$this->view->widsettings = $widsettings;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function socialwidgetusersingingupAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_userService->widgetUserRegistration($request);
			if($result){
				echo 't';
			}else{
				echo 'f';
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function dealwidgetusermangementAction()
	{
		try{
			$this->_helper->layout->disableLayout();

			$auth = Zend_Auth::getInstance();
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			$request = $this->getRequest();
			if($auth->hasIdentity()){
				$this->view->userLogStat = 'true';
			}else{
				$this->view->userLogStat = 'false';
			}
			$this->view->restaurantid = $request->restaurantid;
			
			$this->view->widgetlink = $request->widgetlink;
			
			/* Get Widget Theme Start */
			$restService = new Application_Service_Firm();
			$theme = $restService->GetWidgetThemeByRestId($request);
			$this->view->theme = $theme;
			
			/* Get Widget Theme End */
			
			$restId = $request->restaurantid;
			$restService = new Application_Service_Firm();
			$widsettings = $restService->getRestaurantCustomizeWidgetByResid($restId);
			if($widsettings){
				$this->view->widsettings = $widsettings;
			}			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function socialdealwidgetusermangementAction()
	{
		try{
			$this->_helper->layout->disableLayout();

			$auth = Zend_Auth::getInstance();
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			$request = $this->getRequest();
			if($auth->hasIdentity()){
				$this->view->userLogStat = 'true';
			}else{
				$this->view->userLogStat = 'false';
			}
			$this->view->restaurantid = $request->restaurantid;
			
			$this->view->widgetlink = $request->widgetlink;
			
			/* Get Widget Theme Start */
			$restService = new Application_Service_Firm();
			$theme = $restService->GetWidgetThemeByRestId($request);
			$this->view->theme = $theme;
			
			/* Get Widget Theme End */
			
			$restId = $request->restaurantid;
			$restService = new Application_Service_Firm();
			$widsettings = $restService->getRestaurantCustomizeWidgetByResid($restId);
			if($widsettings){
				$this->view->widsettings = $widsettings;
			}			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function reachusAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$notificationService	= new Application_Service_Communication();
			$restService = new Application_Service_Firm();
			$request = $this->getRequest();	
//* The below code fetchs the data for contact us widget. The data contains all the color codes. From  here we are calling to a function in restaurant.php *// 				
			$widsettings = $restService->getContCustomizeWidgetByResid($request->restid);
			if($widsettings){
				$this->view->widsettings = $widsettings;
			}	
//* Contact us widget code ends here. *//
			
			$resname = $restService->GetRestaurantNamesById($request->restid); //* Restaurant name by id *//
			
			if($this->getRequest()->isPost()){	
				$restid = $request->restid;							
    			$result = $notificationService->AddContactUsForRest($this->getRequest()->getPost(),$restid);
    			if($result['status']){
    				$params = '<span style="font-size:25px;"> Hi </span>'.$result['status'].',
    						   <br><br>	
    						   Your enquiry has been delivered
							   to the restaurant. We will 
    						   review and get back to you 
    						   shortly.
    						   <br><br>
    						   <span style="font-size:25px;"> Thank you </span>,
    						   <br>
    						   '.$resname['restName'].'.';
    				$this->view->contactsuccessform = $params;
    				$this->view->restid = $restid;
    			}else{
    				$this->view->contactform = $result['form'];
    			}
    		}else{
    			$this->view->contactform = $notificationService->getContactUsToRestForm();			
    		$CountryCodeMapper = new Application_Model_CountryCodeDataMapper();
	    	$CountryCode = $CountryCodeMapper->fetchAll();
	    	$CodeList = array();
	    	$CodeList[] = array('key'=>'','value'=>'Select Country Flag');
	    	foreach($CountryCode as $listcode){
	    		$CodeList[] = array('key'=>$listcode->getCountry_dial_code(),'value'=>$listcode->getCountry_flag());
	    	}
	    	
	    	$this->view->codelist = $CodeList;
	    	
		$codemapper = new FirmManagement_Model_FirmDataMapper();
		$countrycode = $codemapper->getOwnerCountrycodebyId($request->restid);
		$form = $notificationService->getContactUsToRestForm();
		if($countrycode){
			$form = $notificationService->getContactUsToRestForm();
			$formData['countryCode'] =  $countrycode;
		}
		$form->populate($this->getRequest()->getPost());			
		} 
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function roundmenuregisterAction()
	{
		try{
			$this->_helper->layout->disableLayout();
//			$CountryCodeMapper = new Application_Model_CountryCodeDataMapper();
//	    	$CountryCode = $CountryCodeMapper->fetchAll();
//	    	$CodeList = array();
//	    	$CodeList[] = array('key'=>'','value'=>'Select Country Flag');
//	    	foreach($CountryCode as $listcode){
//	    		$CodeList[] = array('key'=>$listcode->getCountry_dial_code(),'value'=>$listcode->getCountry_flag());
//	    	}
//		    	
//	    	$this->view->codelist = $CodeList;
			if($this->getRequest()->isPost()){
				$result = $this->_userService->RegisterRestaurantOwner($this->getRequest()->getPost());
				if($result['status']){
					return $this->_helper->redirector('signinupapproval','Client','User',array('usertype' => 'OWN'));
				}else if($result['form']){
					$this->view->form = $result['form'];
				}
			}
			$this->view->form = $this->_userService->getRestaurantOwnerForm();
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function hbcregisterAction()
	{
		try{
			$this->_helper->layout->disableLayout();
//			$CountryCodeMapper = new Application_Model_CountryCodeDataMapper();
//	    	$CountryCode = $CountryCodeMapper->fetchAll();
//	    	$CodeList = array();
//	    	$CodeList[] = array('key'=>'','value'=>'Select Country Flag');
//	    	foreach($CountryCode as $listcode){
//	    		$CodeList[] = array('key'=>$listcode->getCountry_dial_code(),'value'=>$listcode->getCountry_flag());
//	    	}
//		    	
//	    	$this->view->codelist = $CodeList;
			if($this->getRequest()->isPost()){
				$result = $this->_userService->RegisterRestaurantOwner($this->getRequest()->getPost());
				if($result['status']){
					return $this->_helper->redirector('signinupapproval','Client','User',array('usertype' => 'OWN'));
				}else if($result['form']){
					$this->view->form = $result['form'];
				}
			}
			$this->view->form = $this->_userService->getRestaurantOwnerForm();
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}