<?php

class User_Model_GuestDataMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('User_Model_DbTable_Customer');
		}
		return $this->_dbTable;
	}
	
	public function save(User_Model_Guest $customer)
	{
		
			$db = Zend_Db_Table::getDefaultAdapter();
			$userMapper = new User_Model_ClientDataMapper();
			
			try{
				$db->beginTransaction();
				
				$userId = $userMapper->save($customer);
				
				$customer->setUserid($userId);
				
				$data = array(
		  		'cusfk_user' 		=> $customer->getUserid(),
				'cussalution'   	=> $customer->getSalution(),
		  		'cusfirst_name' 	=> $customer->getFirstname(),
		  		'cuslast_name'  	=> $customer->getLastname(),
//		  		'cusgender'			=> $customer->getGender(),
		  		'cusaddress'		=> $customer->getAddress(),
//				'cusregion_id'		=> $customer->getRegionid(),
//		  		'cuscity_id'		=> $customer->getCityid(),
//				'cusneighborhood_id'=> $customer->getNeighborhoodid(),
//		  		'cusstate_id'   	=> $customer->getStateid(),
		  		'cuszipcode'		=> $customer->getZipcode(),
//		  		'custimezone'   	=> $customer->getTimezone(),
		  		'cusphone'      	=> $customer->getPhonenumber(),
				'cuscountrycode'	=> $customer->getcountryCode(), 		
		 		 );
		 		 
		 		$customer_id = $this->getDbTable()->insert($data);	
		 				
				$db->commit();
				
				return $customer_id;
				
			}catch(Exception $ex){
				
				$db->rollBack();
				throw new Exception($ex->getMessage()) ;	
			}		
	}
	
	public function widgetsave(User_Model_Guest $customer)
	{
		
			$db = Zend_Db_Table::getDefaultAdapter();
			$userMapper = new User_Model_ClientDataMapper();
			
			try{
				$db->beginTransaction();
				
				$userId = $userMapper->save($customer);
				
				$customer->setUserid($userId);
				
				$data = array(
		  		'cusfk_user' 		=> $customer->getUserid(),
		  		'cusfirst_name' 	=> $customer->getFirstname(),
		  		'cuslast_name'  	=> $customer->getLastname(),
		  		'cusphone'      	=> $customer->getPhonenumber()	  		
		 		 );
		 		 
		 		$customer_id = $this->getDbTable()->insert($data);	
		 				
				$db->commit();
				
				return $customer_id;
				
			}catch(Exception $ex){
				
				$db->rollBack();
				throw new Exception($ex->getMessage()) ;	
			}		
	}
	
	public function saveCustomerDetailsOnReservation(User_Model_Guest $customer)
	{
		
			$db = Zend_Db_Table::getDefaultAdapter();
			$userMapper = new User_Model_ClientDataMapper();
			
			try{
				$db->beginTransaction();
				
				$userId = $userMapper->save($customer);
				
				$customer->setUserid($userId);
				
				$data = array(
		  		'cusfk_user' 		=> $customer->getUserid(),
				'cusfirst_name' 	=> $customer->getFirstname(),
		  		'cuslast_name'  	=> $customer->getLastname(),
		  		'cusphone'      	=> $customer->getPhonenumber()	  		
		 		 );
		 		 
		 		$customer_id = $this->getDbTable()->insert($data);	
		 				
				$db->commit();
				
				return $customer_id;
				
			}catch(Exception $ex){
				
				$db->rollBack();
				throw new Exception($ex->getMessage()) ;	
			}		
	}
	
	public function getCustomerProfileById(User_Model_CustomerProfileById $userid)
	{
		try{
			$query = $this->getDbTable()->select();
			$query->setIntegrityCheck(false);
			$query->from(array('cus' => 'mt.customer'), array('cussalution', 'cusfirst_name', 'cuslast_name','cusphone', 'cusmobile', 'cusaddress', 'cuszipcode'));
			$query->join(array('usr' => 'mt.user'), 'cus.cusfk_user = usr.usrid', array('usremail'));
			$query->where('cus.cusfk_user = ?',$userid->getUserId());
			
			$Result = $this->getDbTable()->fetchRow($query);
			
//			$regionmapper = new Application_Model_RegionDataMapper();
////			$regionObj = new Application_Model_Region();
////			$regionObj->setStateId($Result['cusstate_id']);
//			$region = $regionmapper->getRegionByStateId();
//			$regionList = $region->getRegionList();
//			
//			$citymapper = new Application_Model_CityDataMapper();
//			$cityObj = new Application_Model_City();
//			$cityObj->setRegionId($Result['cusregion_id']);
//			$city = $citymapper->getCityByRegionId($cityObj);
//			$cityList = $city->getCityList();
//			
//			$neighborhoodmapper = new Application_Model_NeighborhoodDataMapper();
//			$neighborhoodObj = new Application_Model_Neighborhood();
//			$neighborhoodObj->setCityId($Result['cuscity_id']);
//			$neighborhood = $neighborhoodmapper->getNghByCityId($neighborhoodObj);
//			$neighborhoodList = $neighborhood->getNeighborhoodList();
			
			$CusProfileObj = new User_Model_Guest();
			$CusProfileObj->setEmail($Result->usremail)
						  ->setSalution($Result->cussalution)
						  ->setFirstname($Result->cusfirst_name)
						  ->setLastname($Result->cuslast_name)
//						  ->setGender($Result->cusgender)
						  ->setAddress($Result->cusaddress)
//						  ->setRegionid($Result->cusregion_id)
//						  ->setCityid($Result->cuscity_id)
//						  ->setNeighborhoodid($Result->cusneighborhood_id)
						  ->setPhonenumber($Result->cusphone)
						  ->setMobilenumber($Result->cusmobile)
//						  ->setStateid($Result->cusstate_id)
						  ->setZipcode($Result->cuszipcode);
//						  ->setFavoritefood($Result->cusfavorite_type_of_food)
//						  ->setFavoritemusic($Result->cusfavorite_type_of_music)
//						  ->setRegionBd($regionList)
//						  ->setCityBd($cityList)
//						  ->setNeighborhodBd($neighborhoodList)
//						  ->setTimeZone($Result->custimezone);
	
			return $CusProfileObj;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}		
	}
	
	
	public function update(User_Model_Guest $customer)
	{
		
			$status = false;
			$db = Zend_Db_Table::getDefaultAdapter();		
			$userMapper = new User_Model_ClientDataMapper();
			
			try{
				$db->beginTransaction();
				$set = array('cussalution'				 => $customer->getSalution(),
							 'cusfirst_name'			 => $customer->getFirstname(),
							 'cuslast_name' 			 => $customer->getLastname(),
//							 'cusgender'				 =>	$customer->getGender(),
							 'cusaddress' 				 => $customer->getAddress(),
//							 'cuscity_id' 				 => $customer->getCityid(),
//							 'cusneighborhood_id'		 =>	$customer->getNeighborhoodid(),
//							 'cusstate_id' 				 => $customer->getStateid(),
							 'cuszipcode' 				 => $customer->getZipcode(),
							 'cusphone' 				 => $customer->getPhonenumber(),
							 'cusmobile' 				 => $customer->getMobilenumber(),
							 'cusfavorite_type_of_food'  => $customer->getFavoritefood(),
							 'cusfavorite_type_of_music' => $customer->getFavoritemusic()
					);
				$where = array('cusfk_user = ?' => $customer->getId());	
				$rows_affected = $this->getDbTable()->update($set,$where);
				$db->commit();
				$status = true;
				return $status;
			}catch(Exception $ex){
				$db->rollBack();
				throw new Exception($ex->getMessage()) ;	
			}
	}
	
	public function userMediaProfile(User_Model_SocilProfileById $socialprofile,$offset)
	{
		try{
			$limit = 5;
			$query= $this->getDbTable()->select();
			$query->setIntegrityCheck(false);
			
			$query->from(array('csp' => 'mt.customer_social_profile'),array('cspid', 'cspsocial_media_userid','cspcreatedon','cspsocial_media_type_id'))			  
				  ->join(array('spb' => 'mt.socialmediatype_bd'),'csp.cspsocial_media_type_id = spb.id',array('description'))
				  ->where('csp.cspcustomerid = ?',$socialprofile->getUserId())
				  ->where('csp.cspstatus = ?','TRUE')
				  ->order('csp.cspid DESC');
	        			  
			//$rowset = $this->getDbTable()->fetchAll($query);
			$Result = new Zend_Paginator(
				new Zend_Paginator_Adapter_DbTableSelect($query)
			);
			$Result->setItemCountPerPage($limit);
			$Result->setCurrentPageNumber($offset);
			
		/*	$socialProfList = array();
			foreach($rowset as $row){
				$socialProfObj = new User_Model_SocialProfile();			
				$socialProfObj->setId($row->cspid);
				$socialProfObj->setEmailid($row->cspsocial_media_userid);
				$socialProfObj->setDescription($row->description);
				$socialProfObj->setCreatedon($row->cspcreatedon);
				$socialProfObj->setMediatype($row->cspsocial_media_type_id);
				$socialProfList[] = $socialProfObj; 	
			}*/
			return $Result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function socialMediaProfileById(User_Model_UpdateSocialProById $cspid)
	{
		try{
			$query= $this->getDbTable()->select();
			$query->setIntegrityCheck(false);
			
			$query->from(array('csp' => 'mt.customer_social_profile'),array('cspsocial_media_userid', 'cspsocial_media_type_id'))
				  ->join(array('spb' => 'mt.socialmediatype_bd'),'csp.cspsocial_media_type_id = spb.id',array('description','status'))
				  ->where('csp.cspid = ?',$cspid->getId());
			$resultset = $this->getDbTable()->fetchRow($query);
			$resultObj = new User_Model_SocialProfile();
			$resultObj->setEmailid($resultset->cspsocial_media_userid)
					  ->setStatus($resultset->description);
					  
			return $resultObj;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}	
	}
	
	public function getRestaurantDetailsBystateid($stateid,$regionid,$cityid,$request)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$table = $this->getDbTable();
			$cusselect = $table->select();
			$cusselect->setIntegrityCheck(false);
			
			$count = null;
			$count = $this->GetUsersCountById($stateid,$regionid,$cityid);
			$offset = 0;
			$limit = 50;
		
			/* Reteriving the previous offset */
			if($request->offset && $request->offset != 0){
				$offset = $request->offset;
			}
			/* If next link or arrow is clicked this if condition is executed. */
			if($request->event == 'next'){

				if($count >= $offset + 50){

					$offset = $offset + 50;

					if($offset + 50 >= $count){
						$result['next'] = false;
					}else{
						$result['next'] = true;
					}
				}
				if($offset >= 50){
					$result['prev'] = true;
				}

			}/* if previous link is clicked this if condition is executed. */
			elseif($request->event == 'prev'){

				$offset = $offset - 50;

				if($offset == 0 || $offset < 50){
					$result['prev'] = false;
				}else{
					$result['prev'] = true;
				}
				if($count > $offset){

					$result['next'] = true;
				}

			}/* This else part is executed on first call of this function. */
			else{
				if($count > 50){
					/* if count is greater than 50 show the next link */
					$result['next'] = true;
					$result['prev'] = false;
				}else{
					/* if count is less than 50 then no links are shown. */
					$result['next'] = false;
					$result['prev'] = false;
				}

			}
			
			$result['offset'] = $offset;
			$result['count'] = $count;
			
			$cusselect->from(array('cus'=>'mt.customer'),array('cusfirst_name','cuslast_name'))
					  ->join(array('usr'=>'mt.user'),'usr.usrid = cus.cusfk_user',array('usrid','usremail'))
					   ->join(array('rgn'=>'mt.region_bd'),'cus.cusregion_id = rgn.id',array('code as regioncode','description as region'))
					  ->join(array('cty'=>'mt.city_bd'),'cus.cuscity_id = cty.id',array('code as citycode','description as city'))
					  ->join(array('ngbh'=>'mt.neighborhood_bd'),'cus.cusneighborhood_id = ngbh.id',array('description as neighbor'));
			if($stateid && $cityid && $regionid){
				$cusselect->where('cus.cusstate_id = ?',$stateid);
				$cusselect->where('cus.cusregion_id = ?',$regionid);
				$cusselect->where('cus.cuscity_id = ?',$cityid);
			}
			else if($stateid && $regionid){
				$cusselect->where('cus.cusstate_id = ?',$stateid);
				$cusselect->where('cus.cusregion_id = ?',$regionid);
			}
			else if($stateid){
				$cusselect->where('cus.cusstate_id = ?',$stateid);
			}
			$cusselect->limit($limit,$offset);
			$resultSet = $table->fetchAll($cusselect);
			$result['UsersList'] = $resultSet;
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetUsersCountById($stateid,$cityid)
	{
		try{
			$count = 0;
			$table = $this->getDbTable();
			$cusselect = $table->select();
			$cusselect->setIntegrityCheck(false);
			$cusselect->from(array('cus'=>'mt.customer'),array())
					  ->join(array('usr'=>'mt.user'),'usr.usrid = cus.cusfk_user',array('count(usremail) as usercount'));
			if($stateid && $cityid){
				$cusselect->where('cus.cusstate_id = ?',$stateid);
				$cusselect->where('cus.cuscity_id = ?',$cityid);
			}else if($stateid){
				$cusselect->where('cus.cusstate_id = ?',$stateid);
			}
			$resultSet = $table->fetchAll($cusselect);

			foreach($resultSet as $row){
				$count = $row->usercount;
			}

			return $count;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getUserEmailIds($stateid,$cityid,$idsArr)
	{
		try{
			$table = $this->getDbTable();
			$cusselect = $table->select();
			$cusselect->setIntegrityCheck(false);
			$cusselect->from(array('cus'=>'mt.customer'),array())
					  ->join(array('usr'=>'mt.user'),'usr.usrid = cus.cusfk_user',array('usremail','usrid'));
			if($stateid && $cityid){
				$cusselect->where('cus.cusstate_id = ?',$stateid);
				$cusselect->where('cus.cuscity_id = ?',$cityid);
			}else if($stateid){
				$cusselect->where('cus.cusstate_id = ?',$stateid);
			}
			if(count($idsArr)){
				$cusselect->where('usr.usrid NOT IN(?)',$idsArr);
			}
			$resultSet = $table->fetchAll($cusselect);
			return $resultSet;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}

