<?php

class User_Model_ManagerDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
		$this->setDbTable('User_Model_DbTable_Manager');
		}
		return $this->_dbTable;
	}

	public function save(User_Model_Manager $restaurantowner,$source = 'DD')
	{
			$db = Zend_Db_Table::getDefaultAdapter();
			$userMapper = new User_Model_ClientDataMapper();
			
			try{
				$db->beginTransaction();
				
				$userId = $userMapper->save($restaurantowner);
				
				$restaurantowner->setUserid($userId);
			
				$data = array(
					'rsofirst_name'    		=> 	$restaurantowner->getFirstName(),
					'rsolast_name'			=>  $restaurantowner->getLastName(),
					'rsofk_user' 			=>	$restaurantowner->getUserid(),
					//'rsophone' 				=> 	$restaurantowner->getPhonenumber(),
					'rsorestaurant_name'	=> 	$restaurantowner->getRestaurantname(),
//					'rsostateid'			=>	$restaurantowner->getStateid(),
//					'rsocityid'				=>	$restaurantowner->getCityid(),
//					'rsoregionid'			=>	$restaurantowner->getRegionid(),
					'rsodescription'		=>	$restaurantowner->getDescription(),
					'rsowebsite'			=>	$restaurantowner->getWebsite(),
//					'rsoyourstate'			=>	$restaurantowner->getCantFindState(),
//					'rsoyourregion'			=>	$restaurantowner->getCantFindRegion(),
//					'rsoyourcity'			=>	$restaurantowner->getCantFindCity(),
					'rsocantfind'			=> 	$restaurantowner->getCantFind(),
					//'rsocountrycode'		=>  $restaurantowner->getCountryCode(),
					'rsocountry'			=>  $restaurantowner->getcountry(),
					'rsocity'				=>  $restaurantowner->getcity(),
					'rsozipcode'            =>  $restaurantowner->getzipCode(),
				);
				if($restaurantowner->getPhonenumber()){
					$data['rsophone'] = $restaurantowner->getPhonenumber();  	
				}
				if($restaurantowner->getCountryCode()){
					$data['rsocountrycode'] = $restaurantowner->getCountryCode();  	
				}
				if($restaurantowner->getDateofbirth()){
					$data['rsodob'] = $restaurantowner->getDateofbirth();  	
				}
				if($restaurantowner->getCantFind() == 1)
				{
						$data['rsostateid']			=	$restaurantowner->getStateid();
						$data['rsoregionid']		=	$restaurantowner->getRegionid();
						$data['rsoyourcity']		=	$restaurantowner->getCantFindCity();
						
					
				
				}else if($restaurantowner->getCantFind() == 2){
					
						$data['rsostateid']			=	$restaurantowner->getStateid();
						$data['rsoyourregion']		=	$restaurantowner->getCantFindRegion();
						$data['rsoyourcity']		=	$restaurantowner->getCantFindCity();
										
				}else if($restaurantowner->getCantFind() == 3){
					
						$data['rsoyourstate']		=	$restaurantowner->getCantFindState();
						$data['rsoyourregion']		=	$restaurantowner->getCantFindRegion();
						$data['rsoyourcity']		=	$restaurantowner->getCantFindCity();
										
				}else if($restaurantowner->getCantFind() == 0 || $restaurantowner->getCantFind() == ''){
						$data['rsostateid']			=	$restaurantowner->getStateid();
						$data['rsocityid']			=	$restaurantowner->getCityid();
						$data['rsoregionid']		=	$restaurantowner->getRegionid();
				}
		
				if($restaurantowner->getSourceid()){
					$data['rsosourceid'] = $restaurantowner->getSourceid();
					if($restaurantowner->getSourcedescription()){
					$data['rsosourcedescription'] = $restaurantowner->getSourcedescription();
					}
				}
				if($restaurantowner->getCompanyid()){
					$data['rso_companyid'] = $restaurantowner->getCompanyid();
				}
				$res_own_id = $this->getDbTable()->insert($data);
				$db->commit();
				if($source == 'DD'){
					return $userId;	
				}else{
					$query = $this->getDbTable()->select();
					$query->setIntegrityCheck(false);
					$query->from(array('usr' => 'mt.user'),array('usrid','usremail','usrpassword','usrusertype_id','usrrole_id','usrregistered_date','usrlastlogged_in_ip','usrlast_login_date','usruser_status_id','usrcreatedby','usrcreateddatetime','usrupdatedby','usrupdateddatetime','usrpassphrase','usripaddress'))
							->where('usrid = ?',$userId);
					return $this->getDbTable()->fetchRow($query);
				}
			}catch(Exception $ex){
				
				$db->rollBack();	
				throw new Exception($ex->getMessage()) ;
			}
	}

	public function getRestOwnProfileById(User_Model_ResOwnProfileById $userid)
	{
		try{
			$query= $this->getDbTable()->select();
			$query->setIntegrityCheck(false);
			$query->from(array('rso' => 'mt.restaurant_owner'), array('rsorestaurant_name','rsofirst_name','rsolast_name','rsophone','rsostateid','rsocityid','rsodescription','rsoregionid','rsocountrycode','rsotechfirst_name','rsobilfirst_name','rsobillast_name','rsotechlast_name','rsotechphone','rsobilphone','rsotechemail','rsobilemail','rsotechcountrycode','rsobilcountrycode'));
			$query->where('rso.rsofk_user = ?',$userid->getUserId());
			
			$Result = $this->getDbTable()->fetchRow($query);
			$cityList 	= array();
			$regionList = array();
			if($Result['rsostateid']){
				$regionmapper = new Application_Model_RegionDataMapper();
				$regionObj = new Application_Model_Region();
				$regionObj->setStateId($Result['rsostateid']);
				$region = $regionmapper->getRegionByStateId($regionObj);
				$regionList = $region->getRegionList();
			}
			
			if($Result['rsoregionid']){
				$citymapper = new Application_Model_CityDataMapper();
				$cityObj = new Application_Model_City();
				$cityObj->setRegionId($Result['rsoregionid']);
				$city = $citymapper->getCityByRegionId($cityObj);
				$cityList = $city->getCityList();
			}
			
			$RestOwnProfileObj = new User_Model_Manager();
	
			$RestOwnProfileObj->setRestaurantname($Result->rsorestaurant_name)
							  ->setPhonenumber($Result->rsophone)
							  ->setFristName($Result->rsofirst_name)
							  ->setLastName($Result->rsolast_name)
							  ->setDescription($Result->rsodescription)
							  ->setStateid($Result->rsostateid)
							  ->setCityid($Result->rsocityid)
							  ->setCityBd($cityList)
							  ->setRegionid($Result->rsoregionid)
							  ->setCountryCode($Result->rsocountrycode)
							  ->setRegionBd($regionList)
							  ->setTechfirstName($Result->rsotechfirst_name)
							  ->setTechemail($Result->rsotechemail)
							  ->setTechlastname($Result->rsotechlast_name)
							  ->setTechphone($Result->rsotechphone)
							  ->setTechcountrycode($Result->rsotechcountrycode)
							  ->setBilfirstName($Result->rsobilfirst_name)
							  ->setbilemail($Result->rsobilemail)
							  ->setBillastname($Result->rsobillast_name)
							  ->setBilphone($Result->rsobilphone)
							  ->setBilcountrycode($Result->rsobilcountrycode);

			return $RestOwnProfileObj;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}	
	}
	
	public function update(User_Model_Manager $restOwn)
	{

			$status = false;
			try{			
				$set = array(
					'rsofirst_name'		=>	$restOwn->getFirstName(),
					'rsolast_name'		=>	$restOwn->getLastName(),
					'rsorestaurant_name'=> 	$restOwn->getRestaurantname(),
					'rsophone' 			=> 	$restOwn->getPhonenumber(),
					'rsostateid'		=>	$restOwn->getStateid(),
					'rsoregionid'		=>	$restOwn->getRegionid(),
					'rsocityid'			=>	$restOwn->getCityid(),
					'rsodescription'	=>	$restOwn->getDescription(),
					'rsocountrycode'	=>	$restOwn->getCountryCode(),
					'rsotechfirst_name'	=>	$restOwn->getTechfirstName(),
					'rsobilfirst_name'	=>	$restOwn->getBilfirstName(),
					'rsobillast_name'	=>	$restOwn->getBillastname(),
					'rsotechlast_name'	=>	$restOwn->getTechlastname(),
					'rsotechphone'		=>	$restOwn->getTechphone(),
					'rsobilphone'		=>	$restOwn->getBilphone(),
					'rsotechemail'		=>	$restOwn->getTechemail(),
					'rsobilemail'		=>	$restOwn->getBilemail(),
					'rsotechcountrycode'=>	$restOwn->getTechcountrycode(),
					'rsobilcountrycode'	=>	$restOwn->getBilcountrycode(),
					);
				
				$where = array('rsofk_user = ?' => $restOwn->getId());
				$rows_affected = $this->getDbTable()->update($set,$where);
				
				$status = true;
				return $status;
				
			}catch(Exception $ex){
				throw new Exception($ex->getMessage()) ;		
			}
		
	}
	
	public function getOwnerDescriptionbyId($id)
	{
		try{
			$table  =$this->getDbTable();
			$select = $table->select();
			$select->from($table,array('rsodescription'))
				   ->where('rsofk_user = ?',$id);
		    $row = $table->fetchRow($select);
		    $result = array('desc' => $row->rsodescription);
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function EditSourceofRestaurant(User_Model_Manager $obj)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$status = false;
			if($obj->getSourceid())
			{
				$set = array('rsosourceid' 	=> $obj->getSourceid(),
							 'rsosourcedescription' 	=> $obj->getSourcedescription()
							);
				$where = $db->quoteInto('rsofk_user = ?',$obj->getId());
				$rows_affected = $this->getDbTable()->update($set,$where);
			}
			else{
				$set = array('rsosourceid' 	=> null,
						 'rsosourcedescription' 	=> null
						);
				$where = $db->quoteInto('rsofk_user = ?',$obj->getId());
				$rows_affected = $this->getDbTable()->update($set,$where);
			}

			if($rows_affected > 0){
				$status = true;
			}
			return $status;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getOwnerDetailsByResId($resid)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->setIntegrityCheck(false);
			$select->from($this->getDbTable(),array('rsoid','rsofirst_name','rsolast_name'))
					->join(array('usr' => 'mt.user'), 'rsofk_user = usr.usrid', array('usrid','usremail','usrregistered_date'))
					->join(array('rest' => 'mt.restaurant'),'usr.usrid = rest.resfk_user',array('resid','resrestaurant_name'))
					->join(array('usrtyp'=>'mt.userstatus_bd'),'usrtyp.id = usr.usruser_status_id',array('code','description'))
					->where('rest.resid = ?',$resid);
			$result = $this->getDbTable()->fetchRow($select);
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getrestaurantownerdetailsbyUserid($userid)
	{
		try{
				$table  = $this->getDbTable();
				$select = $table->select();
				$select->setIntegrityCheck(false);
				$select->from(array('rso' => 'mt.restaurant_owner'), array('rsofk_user','rsorestaurant_name as restaurant_name','rsofirst_name as first_name','rsolast_name as last_name','rsophone as phone','rsodescription as owndescription','rsosourceid as sourceid','rsosourcedescription as sourcedescription','rsowebsite as website','rsostateid as stateid','rsocityid as cityid','rsoregionid as regionid','rsocantfind','rsoyourstate','rsoyourregion','rsoyourcity'))
						->joinLeft(array('srbd'=>'mt.source_of_restaurant_bd'),'srbd.id=rso.rsosourceid',array('srbd.description as description'))
						->joinLeft(array('usr'=>'mt.user'),'usr.usrid=rso.rsofk_user',array('usremail as email','usrpassword as password'))
						->joinLeft(array('st'=>'mt.state_bd'),'st.id=rso.rsostateid',array('st.description as statename'))
						->joinLeft(array('cty'=>'mt.city_bd'),'cty.id=rso.rsocityid',array('cty.description as cityname'))
						->joinLeft(array('rgn'=>'mt.region_bd'),'rgn.id=rso.rsoregionid',array('rgn.description as regionname'))
						->where('rso.rsofk_user = ?',$userid);
				
				$records = $table->fetchAll($select);
				$resowner	=	array();
				$RestPrf	=	array();
				
				foreach($records as $value)
				{
					$id = $value->sourceid;
					$description=$value->sourcedescription;
					$emailaddress=$value->email;
					$password=$value->password;
					$result=array('First Name'=>$value->first_name,'Last Name'=>$value->last_name,'Restaurant Name / Group Name'=>$value->restaurant_name,'Email Address'=>$value->email,'Phone'=>$value->phone,'State'=>$value->statename,'Region'=>$value->regionname,'City'=>$value->cityname,'Description'=>$value->owndescription,'Website'=>$value->website,'id'=>$id,'description'=>$description,'NewState'=>$value->rsoyourstate,'NewRegion'=>$value->rsoyourregion,'NewCity'=>$value->rsoyourcity,'cantfind'=>$value->rsocantfind,'stateid'=>$value->stateid,'regionid'=>$value->regionid,'cityid'=>$value->cityid);
					if($value->website==null){
					$result['Website']='';
					}
					
				}
			
						
				$sourceofrestaurantMapper  = new Application_Model_SourceofRestaurantDataMapper();
			    $sources = $sourceofrestaurantMapper->fetchAll();
			    $sourceList[] = array('key'=>'','value'=>'Select Source');   	   
			    foreach($sources as $source){
			    $sourceList[] = array('key'=>$source->getId(),'value'=>$source->getDescription());
				}
				
				if($id==null)
				$RestPrf=array('resowner'=>$result,'sourcelist'=>$sourceList);
				else
				$RestPrf=array('resowner'=>$result,'sourcelist'=>$sourceList,'id'=>$id,'description'=>$description,);
								
			return $RestPrf;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}	
	}
	
	public function getGeographicalInformationByUserId($userid)
	{
		try{
			$table  =$this->getDbTable();
			$select = $table->select();
			$select->from($table,array('rsostateid','rsoregionid','rsocityid'))
				   ->where('rsofk_user = ?',$userid);
		    $row = $table->fetchRow($select);
		    $result = array(
		    			'stateid' 	=> $row->rsostateid,
		    			'regionid' 	=> $row->rsoregionid,
		    			'cityid' 	=> $row->rsocityid,
		    		);
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
    //Fetch Company id by restaurant userid in restaurant_owner table
    public function getCompanyByUserId($userid)
	{
	    try
		{
			$select = $this->getDbTable()->select();
			$select->from(array('resto'=>'mt.restaurant_owner'),array('rso_companyid'))
					->where('resto.rsofk_user = ?',$userid);
			$resultSet = $this->getDbTable()->fetchRow($select);
			return $resultSet;
		 }catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		 }
	 }
	 public function addPresid($restaurant,$ownerid)
	 {
				try{
			$db = Zend_Db_Table::getDefaultAdapter();
					
//			$db->beginTransaction();
			/* Check the rest is already exist in system */
			$restTable = $this->getDbTable();
			$selectRest = $this->getDbTable()->select();
			$selectRest->from($restTable,array('COUNT(presid) as restcount'))
			->where('rsoid = ?',$ownerid);
//			->where('resneighborhood_id = ?',$restaurant->getRestneighboorhood());
			$rowSet = $restTable->fetchAll($selectRest);
			$count = 0;
			foreach($rowSet as $row){
				$count = $row->restcount;
			}
			if($count == 0){

				$set = array('presid'  => $restaurant
						);
				$where = $db->quoteInto('rsofk_user = ?',$ownerid);
				$rows_affected = $this->getDbTable()->update($set,$where);			
				}

//				$db->commit();	
				}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		 }			
	
	 }
	 
	 public function updatePresid($restaurant,$ownerid)
	 {
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
					
			$set = array('presid'  => $restaurant
					);
			$where = $db->quoteInto('rsofk_user = ?',$ownerid);
			$rows_affected = $this->getDbTable()->update($set,$where);

			$mapper = new User_Model_PatronDataMapper();
			$set = array('rsup_resid'  => $restaurant,
						'rsufk_restaurant'=> $restaurant
					);
			$where = $db->quoteInto('rsufk_user = ?',$ownerid);
			$rows_affected = $mapper->getDbTable()->update($set,$where);
				

//				$db->commit();	
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}			
	
	 }
	 
	public function UpdateUserLoggedInDate($userid)
	{
		$mapper = new User_Model_ClientDataMapper();
		$date  = date('Y-m-d H:i:s');
		$set   = array('usrlast_login_date'=>$date);
		$where = array('usrid = ?'=>$userid);		
		$rows_affected = $mapper->getDbTable()->update($set,$where);
		
		if($rows_affected){
			return true;
		}else{
			return false;
		}
	}
	
	public function getOwnerCountrycodebyId($id)
	{
		try{
			$table  =$this->getDbTable();
			$select = $table->select();
			$select->from($table,array('rsocountrycode'))
				   ->where('rsofk_user = ?',$id);
		    $row = $table->fetchRow($select);
		    $restObj = new FirmManagement_Model_Firm();
		    $restObj->setres_country_code($row->rsocountrycode); 
			return $restObj;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function UpdateDefaultViewSetting($request,$userid,$usertype)
	{
		try{
			$result = '';
			if($usertype == 'RSO'){
				$table = $this->getDbTable();
				$set   = array('defaultview'=>$request->viewscreen);
				$where = array('rsofk_user = ?'=>$userid);
				$result = $table->update($set,$where);
			}else if($usertype == 'RSU' || $usertype == 'SRU'){
				 $rsuMapper = new User_Model_PatronDataMapper();
				 $table  = $rsuMapper->getDbTable();
				 $set  = array('rsudefaultview'=>$request->viewscreen);
				 $where = array('rsufk_user = ?'=>$userid);
				 $result = $table->update($set,$where);
			}
			return $result;
		}catch (Exception $ex){
				throw new Exception($ex->getMessage()) ;
			}
		}
	
	public function GetDefaultViewStatus($userid,$usertype)
	{
		try{
			$result = '';
			if($usertype == 'RSO'){
				$table  =$this->getDbTable();
				$select = $table->select();
				$select->from($table,array('defaultview'))
					   ->where('rsofk_user = ?',$userid);
			    $row = $table->fetchRow($select);
			    $result = $row->defaultview;
			}else if($usertype == 'RSU' || $usertype == 'SRU'){
				 $rsuMapper = new User_Model_PatronDataMapper();
				 $table     = $rsuMapper->getDbTable();
				 $select    = $table->select();
				 $select->from(array('rsu'=>'mt.restaurant_user'),array('rsudefaultview'))						 		
				 		->where('rsu.rsufk_user = ?', $userid);
				 $row = $table->fetchRow($select); 	
				 $result = $row->rsudefaultview;
			}
		   return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function fetchAll()
	{
		try{
			$ownerNames = array();	
			$table     = $this->getDbTable();
			$select    = $table->select();
			
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			$companyid = $data['companyid'];
				
			$select->where('rso_companyid = ?', $companyid);
			$owners = $this->getDbTable()->fetchAll($select);
						
			$ownerNames[] = array('key'=>'','value'=>'Select Owner');				
			foreach($owners as $own){
				$ownerNames[] = array('key'=>$own->rsofk_user,'value'=>$own->rsofirst_name.' '.$own->rsolast_name);
			}
			return $ownerNames;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetRestOwnerDetalsByRestUserId($user_id)
	{
		try
		{
			$table 	   = $this->getDbTable();
			$select    = $table->select();
			
			$select->from($table,array('rsoid',
									   'rsofk_salution',
									   'rsofk_user',
									   'rsofirst_name',
									   'rsolast_name',
									   'rsorestaurant_name',
									   'rsophone',
									   'rsocreatedby',
									   'rsocreateddatetime',
									   'rsoupdatedby',
								       'rsoupdateddatetime',
									   'rsostateid',
									   'rsocityid',
									   'rsodescription',
									   'rsoregionid',
									   'rsosourceid',
									   'rsosourcedescription',
									   'rsowebsite',
									   'rsocantfind',
									   'rsoyourstate',
									   'rsoyourregion',
									   'rsoyourcity',
									   'presid','rso_companyid','rsodob','rsocountrycode','rsocountry','rsocity','rsozipcode','defaultview',
									   'rsotechfirst_name','rsobilfirst_name','rsobillast_name','rsotechlast_name',
									   'rsotechphone','rsobilphone','rsotechemail','rsobilemail','rsotechcountrycode','rsobilcountrycode'))
			
				   ->where('rsofk_user = ?',$user_id) ; 
					     
				$row = $table->fetchRow($select);
				$result = array(); 
				foreach ($row as $key=>$value){
					if($key == 'rsocreatedby' || $key == 'rsoupdatedby'){
						$result[$key] = null;
					}else{
						$result[$key] = $value;
					}
				}
				
				return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}

