<?php

class User_Model_Patron extends User_Model_Client
{
	protected $_address;	
	protected $_firstname;
	protected $_lastname;
	protected $_mobilenumber;
	protected $_phonenumber;
	protected $_userinitial;
	protected $_salution;
	protected $_userid;	
	protected $_restaurantid;
	protected $_id;
	protected $_restid;
	protected $_registereddate;
	protected $_emailAddress;
	protected $_restaurantName;
	protected $_status;
	protected $_code;
	protected $_description;
	private $_designation;
	private $_restuserrole;
	protected $_gender;
	protected $_restuserroleId;
	protected $_countrycode;	
	protected $_restusertype;
	protected $_restaurantIds;
	
	public function __construct(array $options = null)
	{
		if(is_array($options)){
			$this->setOptions($options);
		}		
	}
	
	public function __set($name, $value)
	{
		$method = 'set' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Customer property');
		}
		$this->$method($value);
	}
	
	public function __get($name)
	{
		$method = 'get' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Customer property');
		}
		return $this->$method();
	}
	
	public function setOptions(array $options)
	{
		$methods = get_class_methods($this);
		foreach ($options as $key => $value) {
			$method = 'set' . ucfirst($key);
			if (in_array($method, $methods)) {
				$this->$method($value);
			}
		}
		return $this;
	}
	
	public function setAddress($address)
	{
		$this->_address = (string)$address;
		return $this;	
	}
	
	public function getAddress()
	{
		return $this->_address;	
	}
	
	public function setFirstname($firstname)
	{
		$this->_firstname = (string)$firstname;
		return $this;
	}	
	
	public function getFirstname()
	{
		return $this->_firstname;
	}
	
		public function setLastname($lastname)
	{
		$this->_lastname = (string)$lastname;
		return $this;
	}
	
	public function getLastname()
	{
		return $this->_lastname;
	}
	
	public function setMobilenumber($mobilenumber)
	{
		$this->_mobilenumber = (string)$mobilenumber;
		return $this;
	}

	public function getMobilenumber()
	{
		return $this->_mobilenumber;
	}
	
	public function setPhonenumber($phonenumber)
	{
		$this->_phonenumber = (string)$phonenumber;
		return $this;
	}
	
	public function getPhonenumber()
	{
		return $this->_phonenumber;
	}
	
	public function setSalution($salution)
	{
		$this->_salution = $salution;
		return $this;
	}
	
	public function getSalution()
	{
		return $this->_salution;
	}
	
		public function setUserid($userid)
	{
		$this->_userid = (int)$userid;
		return $this;
	}
	
	public function getUserid()
	{
		return $this->_userid;
	}
	
	public function setId($id)
	{
		$this->_id = (int)$id;
		return $this;
	}
	
	public function getId()
	{
		return $this->_id;
	}
	
	public function setRestId($restid)
	{
		$this->_restid = (int)$restid;
		return $this;
	}
	
	public function getRestId()
	{
		return $this->_restid;
	}
	
	public function setRegistereddate($registereddate)
	{
		$this->_registereddate = $registereddate;
		return $this;
	}
	
	public function getRegistereddate()
	{
		return $this->_registereddate;
	}
	
	public function setRestaurantid($restaurantid)
	{
		$this->_restaurantid = $restaurantid;
		return $this;
	}
	
	public function getRestaurantid()
	{
		return $this->_restaurantid;
	}
	
	public function setEmailAddress($emailAddress)
	{
		$this->_emailAddress = 	$emailAddress;
		return $this;
	}
	
	public function getEmailAddress()
	{
		return $this->_emailAddress;
	}
	
	public function setRestaurantName($restaurantName)
	{
		$this->_restaurantName = $restaurantName;
		return $this;
	}
	
	public function getRestaurantName()
	{
		return $this->_restaurantName;
	} 
	
	public function setStatus($status)
	{
		$this->_status = $status;
		return $this;
	}
	
	public function getStatus()
	{
		return $this->_status;
	}
	
	public function setCode($code)
	{
		$this->_code = $code;
		return $this;
	}
	
	public function getCode()
	{
		return $this->_code;
	}
	
	public function setDescription($description)
	{
		$this->_description = $description;
		return $this;
	}
	
	public function getDescription()
	{
		return $this->_description;
	}
	
	public function setDesignation($designation)
	{
		$this->_designation = $designation;
		return $this;
	}
	
	public function getDesignation()
	{
		return $this->_designation;
	}
	
	public function setRestUserRole($restuserrole)
	{
		$this->_restuserrole = $restuserrole;
		return $this;
	}
	
	public function getRestUserRole()
	{
		return $this->_restuserrole;
	}
	
	public function setRestUserRoleId($restuserroleId)
	{
		$this->_restuserroleId = $restuserroleId;
		return $this;
	}
	
	public function getRestUserRoleId()
	{
		return $this->_restuserroleId;
	}
	
	public function setGender($gender)
	{
		$this->_gender = $gender;
		return $this;
	}
	
	public function getGender()
	{
		return $this->_gender;
	}
	
	public function setUserInitial($userinitial)
	{
		$this->_userinitial = $userinitial;
		return $this;
	}
	
	public function getUserInitial()
	{
		return $this->_userinitial;
	}
	
	public function setCountryCode($countrycode)
	{
		$this->_countrycode = $countrycode;
		return $this;
	}
	
	public function getCountryCode()
	{
		return $this->_countrycode;
	}
	
	public function setUserType($UserType)
	{
		$this->_restusertype = $UserType;
		return $this;
	}
	
	public function getUserType()
	{
		return $this->_restusertype;
	}
	
	public function setRestaurantIds($restaurantIds)
	{
		$this->_restaurantIds = $restaurantIds;
		return $this;
	}
	
	public function getRestaurantIds()
	{
		return $this->_restaurantIds;
	}
}

