<?php

class User_Model_PatronCodes extends User_Model_Client
{
	protected $_id;	
	protected $_userid;
	protected $_restaurantid;
	protected $_initial;
	protected $_status;
	
	public function __construct(array $options = null)
	{
		if(is_array($options)){
			$this->setOptions($options);
		}		
	}
	
	public function __set($name, $value)
	{
		$method = 'set' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Customer property');
		}
		$this->$method($value);
	}
	
	public function __get($name)
	{
		$method = 'get' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Customer property');
		}
		return $this->$method();
	}
	
	public function setOptions(array $options)
	{
		$methods = get_class_methods($this);
		foreach ($options as $key => $value) {
			$method = 'set' . ucfirst($key);
			if (in_array($method, $methods)) {
				$this->$method($value);
			}
		}
		return $this;
	}
	
	public function setUserid($userid)
	{
		$this->_userid = (int)$userid;
		return $this;
	}
	
	public function getUserid()
	{
		return $this->_userid;
	}
	
	public function setId($id)
	{
		$this->_id = (int)$id;
		return $this;
	}
	
	public function getId()
	{
		return $this->_id;
	}
	
	public function setRestaurantid($restaurantid)
	{
		$this->_restaurantid = (int)$restaurantid;
		return $this;
	}
	
	public function getRestaurantid()
	{
		return $this->_restaurantid;
	}
	
	public function setStatus($status)
	{
		$this->_status = $status;
		return $this;
	}
	
	public function getStatus()
	{
		return $this->_status;
	}
	
	public function setInitial($ini)
	{
		$this->_initial = $ini;
		return $this;
	}
	
	public function getInitial()
	{
		return $this->_initial;
	}
}

