<?php

class User_Model_PatronCodesDataMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('User_Model_DbTable_RestaurantUserInitials');
		}
		return $this->_dbTable;
	}
	
	public function update(User_Model_PatronCodes $userinitial)
	{
//			$status = false;
//			$db = Zend_Db_Table::getDefaultAdapter();		
//			
			try{
//				$db->beginTransaction();
				$set = array(
					'rsui_initial' 		=> 	$userinitial->getInitial()					
				);
				
				$where = array('rsui_fk_user = ?' => $userinitial->getUserid());
				$rows_affected = $this->getDbTable()->update($set,$where);
//				$db->commit();
//				$status = true;
//				return $status;
//				
			}catch(Exception $ex){
				$db->rollBack();
				throw new Exception($ex->getMessage()) ;
			}
	}
	
	public function getinitialbyuserId($userid)
	{
	try{	
			$table  = $this->getDbTable();
			$query= $table->select();
			$query->setIntegrityCheck(false);
			
			$query->from(array('usrintl' => 'mt.restaurant_user_initials'), array('rsui_fk_restaurant','rsui_initial'));
			$query->where('usrintl.rsui_fk_user = ?',$userid);
			$records = $table->fetchAll($query);
			$initialList = array();
			foreach($records as $value){
				$initialList[] = array("key"=>$value->rsui_fk_restaurant,"value"=>$value->rsui_initial);
			}
			
			  return $initialList;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function initialCheck($resid)
	{
	try{	
			$table  = $this->getDbTable();
			$query= $table->select();
			$query->setIntegrityCheck(false);
			
			$query->from(array('usrintl' => 'mt.restaurant_user_initials'), array('rsui_fk_user','rsui_initial'));
			$query->where('usrintl.rsui_fk_restaurant  = ?',$resid);
			$records = $table->fetchAll($query);
			$userList = array();
			foreach($records as $value){
				$userList[] = array("key"=>$value->rsui_fk_user,"value"=>$value->rsui_initial);
			}
			
			  return $userList;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function changePatron($userinitial,$bookingid)
	{
		$db = Zend_Db_Table::getDefaultAdapter();		
		try{
				$db->beginTransaction();
				$obj = new Reservation_Model_ReservationDataMapper();
				
				$restid = $obj->getRestIdByBookId($bookingid);
			
				$timezone = "";
				$mapper = new FirmManagement_Model_FirmDataMapper();
				$timezone = $mapper->GetRestaurantTimeZone($restid);
				date_default_timezone_set($timezone);
				
				$tab = $obj->getDbTable();
				$set = array(
					'bokbooking_user_initials' 	=> 	$userinitial,
					'bokcreatedby'				=>	'',
					'bokupdated_date'			=> date('Y-m-d'),
					'bokupdateddatetime'		=> date("H:i",time()),
					'boksync_status'			=> 'C'					
				);
				
				$where = array('bokid = ?' => $bookingid);
				$rows_affected = $tab->update($set,$where);
				$db->commit();
				$status = 't';
				return $rows_affected;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetUserIntialsByRestaurantId($restids)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			
			$select->from($table,array('rsui_id','rsui_fk_user','rsui_fk_restaurant','rsui_initial','rsui_status'))
				   ->where('rsui_fk_restaurant IN (?)',$restids);
				   
			$resultset = $this->getDbTable()->fetchAll($select);
			$InitialsResult= array();
			foreach($resultset as $key=>$value){
				$subArr = array();
				foreach($value as  $key1=>$value1){
					$subArr[$key1]= $value1;
				}
				$InitialsResult[] = $subArr;
			}
			return $InitialsResult;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
}