<?php

class User_Model_PatronDataMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('User_Model_DbTable_Patron');
		}
		return $this->_dbTable;
	}
	
	public function save(User_Model_Patron $resaturantuser)
	{
	
			$db = Zend_Db_Table::getDefaultAdapter();
			$userMapper = new User_Model_ClientDataMapper();
			
			try{
				$db->beginTransaction();
				
				$userId = $userMapper->save($resaturantuser);
				$storage = new Zend_Auth_Storage_Session();
				$userdata = $storage->read();
				$restArr = $resaturantuser->getRestaurantid();
				if($resaturantuser->getUserType() == 'SRU'){
					$resid = $restArr[0];
				}else{
					$resid = $userdata['RestId'];
				}
				$resaturantuser->setRestaurantid($resid);
				$resaturantuser->setUserid($userId);
				
				$data = array(
						'rsufk_user' 		=> $resaturantuser->getUserid(),
						'rsufk_restaurant' 	=> $resid,
						'rsusalution' 		=> $resaturantuser->getSalution(),
						'rsufirst_name' 	=> $resaturantuser->getFirstname(),
						'rsulast_name' 		=> $resaturantuser->getLastname(),
						'rsugender'			=> $resaturantuser->getGender(),
						'rsudesignation'	=> $resaturantuser->getDesignation(),
						'rsuaddress' 		=> $resaturantuser->getAddress(),
						'rsuphone' 			=> $resaturantuser->getPhonenumber(),
						'rsumobile' 		=> $resaturantuser->getMobilenumber(), 
						'rsucountrycode'	=> $resaturantuser->getcountryCode(),
					);
				$res_user_id = $this->getDbTable()->insert($data);
				if($resaturantuser->getUserType() == 'SRU'){
					$restUserArr = array();
					foreach($restArr as $id){
						$restSuser = new User_Model_RestSuperUser();
						$restSuser->setUser($resaturantuser->getUserid())
								  ->setRestaurant($id)
								  ->setCreateddtime(date("Y-m-d H:i:s"));
						$restUserArr[] = $restSuser; 
					}
					$resid = $id;
					$superUserMapper = new User_Model_RestSuperUserDataMapper();
					$restRes = $superUserMapper->save($restUserArr);
				}
				$db->commit();
				if($res_user_id)
				{
					$db->beginTransaction();
					$mapper = new User_Model_PatronCodesDataMapper();
					$table = $mapper->getDbTable();
					$select = $table->select();
					$select->from(array('usrintl' => 'mt.restaurant_user_initials'),array('rsui_initial'));
					$select->where('usrintl.rsui_fk_restaurant=?',$resaturantuser->getRestaurantid());
					$records = $table->fetchAll($select);
					$UserInitial = array();
					if($records){
						$i=0;
						foreach($records as $value){
							++$i;
							$UserInitial[$i] = $value->rsui_initial;
						}
					}
					$num=count($UserInitial);
					$check=$num+1; //one for new user//
					while(true){
							if(array_search($check,$UserInitial))
							{
								$check++;
							}else{
								break;
							}			
					}
					$initial = array(
						'rsui_fk_user' 		=> $resaturantuser->getUserid(),
						'rsui_fk_restaurant' 	=> $resaturantuser->getRestaurantid(),
						'rsui_initial' 		=> $check,
						'rsui_status' 	=> 'TRUE'
						);
					$res_user_initial = $table->insert($initial);
					$db->commit();
				}
				return $res_user_id;	
			}catch(Exception $ex){
				
				$db->rollBack();
				throw new Exception($ex->getMessage()) ;	
			}
		
	}
	
	public function RegisterRestaurantUserFromNativeApp(User_Model_Patron $resaturantuser)
	{
	
			$db = Zend_Db_Table::getDefaultAdapter();
			$userMapper = new User_Model_ClientDataMapper();
			
			try{
				$db->beginTransaction();
				
				$userId = $userMapper->save($resaturantuser);
				
				$resaturantuser->setUserid($userId);
				
				$data = array(
						'rsufk_user' 		=> $resaturantuser->getUserid(),
						'rsufk_restaurant' 	=> $resaturantuser->getRestaurantid(),
						'rsusalution' 		=> $resaturantuser->getSalution(),
						'rsufirst_name' 	=> $resaturantuser->getFirstname(),
						'rsulast_name' 		=> $resaturantuser->getLastname(),
						'rsugender'			=> $resaturantuser->getGender(),
						'rsudesignation'	=> $resaturantuser->getDesignation(),
						'rsuaddress' 		=> $resaturantuser->getAddress(),
						'rsuphone' 			=> $resaturantuser->getPhonenumber(),
						'rsumobile' 		=> $resaturantuser->getMobilenumber() 
					);
				$res_user_id = $this->getDbTable()->insert($data);
				$db->commit();
				if($res_user_id)
				{
					$db->beginTransaction();
					$mapper = new User_Model_PatronCodesDataMapper();
					$table = $mapper->getDbTable();
					$select = $table->select();
					$select->from(array('usrintl' => 'mt.restaurant_user_initials'),array('rsui_initial'));
					$select->where('usrintl.rsui_fk_restaurant=?',$resaturantuser->getRestaurantid());
					$records = $table->fetchAll($select);
					$UserInitial = array();
					if($records){
						$i=0;
						foreach($records as $value){
							++$i;
							$UserInitial[$i] = $value->rsui_initial;
						}
					}
					$num=count($UserInitial);
					$check=$num+1; //one for new user//
					while(true){
							if(array_search($check,$UserInitial))
							{
								$check++;
							}else{
								break;
							}			
					}
					$initial = array(
						'rsui_fk_user' 		=> $resaturantuser->getUserid(),
						'rsui_fk_restaurant' 	=> $resaturantuser->getRestaurantid(),
						'rsui_initial' 		=> $check,
						'rsui_status' 	=> 'TRUE'
						);
					$res_user_initial = $table->insert($initial);
					$db->commit();
				}
				$resultArr = array();
				
				$resultArr["usrid"] = $userId;
				$resultArr["rsuid"] = $res_user_id;
				$resultArr["rsui_initial"] = $check;
				$resultArr["rsui_id"] = $res_user_initial;
				return $resultArr;	
			}catch(Exception $ex){
				
				$db->rollBack();
				throw new Exception($ex->getMessage()) ;	
			}
		
	}
	
	public function getRestusersById(User_Model_SearchRestaurantUsers $restaurantUsers,$offset)
	{
		try{	
			$limit = 10;
			$query= $this->getDbTable()->select();
			$query->setIntegrityCheck(false);
			
			$query->from(array('resusr' => 'mt.restaurant_user'), array('rsuid','rsufirst_name','rsulast_name'));
			$query->join(array('usr' => 'mt.user'), 'resusr.rsufk_user = usr.usrid', array('usrid','usremail','usrregistered_date'));
			$query->join(array('rest' => 'mt.restaurant'),'resusr.rsufk_restaurant = rest.resid',array('resid','resrestaurant_name'));
			$query->join(array('usrtyp'=>'mt.userstatus_bd'),'usrtyp.id = usr.usruser_status_id',array('code','description'));
			$query->joinLeft(array('usrinit'=>'mt.restaurant_user_initials'),'usrinit.rsui_fk_user = usr.usrid',array('rsui_initial'));
			$query->where('rest.resfk_user = ?',$restaurantUsers->getUserId());
			if($restaurantUsers->getEmail()){
				$query->where('usr.usremail Ilike ?','%'.trim($restaurantUsers->getEmail()).'%');
			}
			if($restaurantUsers->getUserName()){
				$query->where('resusr.rsufirst_name Ilike ?','%'.trim($restaurantUsers->getUserName()).'%');
			}
//			if($restaurantUsers->getUserId()){
//				$query->where('rest.resfk_user = ?', $restaurantUsers->getUserId());
//			}
			if($restaurantUsers->getStatusId()){
				$query->where('usr.usruser_status_id = ?',$restaurantUsers->getStatusId());
			}
			if($restaurantUsers->getRestaurantId()){
				$query->where('resusr.rsufk_restaurant = ?',$restaurantUsers->getRestaurantId());
			}
			$query->where('rest.resstatus = ?',1);
			
			//$Result = $this->getDbTable()->fetchAll($query);
			$Result = new Zend_Paginator(
				new Zend_Paginator_Adapter_DbTableSelect($query)
			);
			$Result->setItemCountPerPage($limit);
			$Result->setCurrentPageNumber($offset);
			
			  return $Result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getRestuserProById(User_Model_RestUserProById $userid)
	{
		try{
			$query = $this->getDbTable()->select();
			$query->setIntegrityCheck(false);
	
			$query->from(array('resusr' => 'mt.restaurant_user'), array('rsuid','rsufirst_name','rsusalution','rsulast_name','rsugender','rsuaddress','rsuphone','rsumobile','rsudesignation','rsurole','rsucountrycode'));
			$query->join(array('usr' => 'mt.user'), 'resusr.rsufk_user = usr.usrid', array('usremail','usruser_status_id','usrusertype_id'));
			$query->join(array('rol'=>'mt.role_bd'),'usr.usrrole_id = rol.id',array('id as roleid','code as rolename','description as roledesc'));
			$query->join(array('rest' => 'mt.restaurant'),'resusr.rsufk_restaurant=rest.resid',array('resid','resrestaurant_name'));
			$query->joinLeft(array('usrinit'=>'mt.restaurant_user_initials'),'usrinit.rsui_fk_user = usr.usrid',array('rsui_initial'));
			if($userid->getUserTypeId() == 6){
				$query->join(array('rsu' => 'mt.restaurant_super_user'),'rsu.rsu_rsu_fk_user=resusr.rsufk_user',array('array_agg(rsu_rsu_restaurant) as restIds'));
				$query->where('resusr.rsufk_user = ?',$userid->getUserId());
				$query->where('rsu.rsu_rsu_status = ?',true);
				$query->group(array('rsui_initial','roleid','rolename','roledesc','resid','resrestaurant_name','usremail','usruser_status_id','usrusertype_id','rsuid','rsufirst_name','rsusalution','rsulast_name','rsugender','rsuaddress','rsuphone','rsumobile','rsudesignation','rsurole','rsucountrycode'));
			}else{
				$query->where('resusr.rsufk_user = ?',$userid->getUserId());
			}
			
			$Result = $this->getDbTable()->fetchRow($query);
			if($userid->getUserTypeId() == 6){
				$restIds = substr($Result->restIds, 1, -1);
			}else{
				$restIds = '';
			}
			$restUserProObj= new User_Model_Patron();
			$restUserProObj->setId($Result->rsuid)
						   ->setRestId($Result->resid)
						   ->setFirstname($Result->rsufirst_name)
						   ->setLastname($Result->rsulast_name)
						   ->setGender($Result->rsugender)
						   ->setSalution($Result->rsusalution)
						   ->setAddress($Result->rsuaddress)
						   ->setPhonenumber($Result->rsuphone)
						   ->setCountryCode($Result->rsucountrycode)
						   ->setMobilenumber($Result->rsumobile)
						   ->setEmail($Result->usremail)
						   ->setRestaurantName($Result->resrestaurant_name)
						   ->setRestUserRole($Result->rolename)
						   ->setRestUserRoleId($Result->roleid)
						   ->setDesignation($Result->rsudesignation)
						   ->setUserstatisid($Result->usruser_status_id)
						   ->setUserType($Result->usrusertype_id)
						   ->setRestaurantIds($restIds)
						   ->setUserInitial($Result->rsui_initial);
	
			return $restUserProObj;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function update(User_Model_Patron $restuser)
	{
			$status = false;
			$db = Zend_Db_Table::getDefaultAdapter();		
			$userMapper = new User_Model_ClientDataMapper();
			$userinitial = new User_Model_PatronCodes();
			$userinitial->setUserid($restuser->getId());
			$userinitial->setInitial($restuser->getUserInitial());
			$mapper = new User_Model_PatronCodesDataMapper();
			$restArr = $restuser->getRestaurantName();
			try{
				$db->beginTransaction();
				
				$userMapper->update($restuser);
				$mapper->update($userinitial);
				
				if($restuser->getUserType() == 'SRU'){
					$resid = $restArr[0];
				}else{
					$resid = $restuser->getRestaurantid();
				}
				
				
				$set = array(
					'rsusalution' 		=> 	$restuser->getSalution(),
					'rsufirst_name'		=>	$restuser->getFirstname(),
					'rsulast_name'		=>	$restuser->getLastname(),
					'rsugender'			=>	$restuser->getGender(),
					'rsuaddress'		=>	$restuser->getAddress(),
					'rsuphone'			=>	$restuser->getPhonenumber(),
					'rsumobile'			=>	$restuser->getMobilenumber(),
					'rsudesignation'	=>	$restuser->getDesignation(),
					'rsurole'			=>	$restuser->getRestUserRole(),
			//		'rsufk_restaurant'	=>  $restuser->getRestaurantName(),
					'rsufk_restaurant'	=>  $resid,
					'rsup_resid'		=>	$resid,
					'rsucountrycode'	=>  $restuser->getCountryCode()					
				);
				
				$where = array('rsufk_user = ?' => $restuser->getId());
				$rows_affected = $this->getDbTable()->update($set,$where);
				
				if($restuser->getUserType() == 'SRU'){
					$restUserArr = array();
					foreach($restArr as $id){
						$restSuser = new User_Model_RestSuperUser();
						$restSuser->setUser($restuser->getId())
								  ->setRestaurant($id)
								  ->setUpdatedby($restuser->getUserid())
								  ->setCreateddtime(date("Y-m-d H:i:s"));
						$restUserArr[] = $restSuser; 
					}
					$resid = $id;
					$superUserMapper = new User_Model_RestSuperUserDataMapper();
					$restRes = $superUserMapper->update($restUserArr);
				}else if($restuser->getUserType() == 'RSU'){
					$superUserMapper = new User_Model_RestSuperUserDataMapper();
					$where = array('rsu_rsu_fk_user = ?'=>$restuser->getId());	
					$status = $superUserMapper->getDbTable()->delete($where);	
				}
				
				$db->commit();
				$status = true;
				return $status;
				
			}catch(Exception $ex){
				$db->rollBack();
				throw new Exception($ex->getMessage()) ;
			}
	}
	
	public function getRestaurantOwnersAndUsersByRestId($resid)
	{
		try{
			$query = $this->getDbTable()->select();
			$query->setIntegrityCheck(false);
			$query->from(array('resusr' => 'mt.restaurant_user'), array('rsuid','rsufirst_name','rsulast_name'));
			$query->join(array('usr' => 'mt.user'), 'resusr.rsufk_user = usr.usrid', array('usrid','usremail','usrregistered_date'));
			$query->join(array('rest' => 'mt.restaurant'),'resusr.rsufk_restaurant = rest.resid',array('resid','resrestaurant_name'));
			$query->join(array('usrtyp'=>'mt.userstatus_bd'),'usrtyp.id = usr.usruser_status_id',array('code','description'));
			$query->where('resusr.rsufk_restaurant = ?',$resid);
			$query->where('usr.usruser_status_id = ?',1);
			
			$UserResult = $this->getDbTable()->fetchAll($query);
			
			$mapper = new User_Model_ManagerDataMapper();
			$OwnerResult = $mapper->getOwnerDetailsByResId($resid);
			$UserDetailsArr = array();
			$UserDetailsArr[] = array('key'=>$OwnerResult->usrid,'value'=>$OwnerResult->rsofirst_name.' '.$OwnerResult->rsolast_name);
			if($UserResult){
				foreach($UserResult as $user){
					$UserDetailsArr[] = array('key'=>$user->usrid,'value'=>$user->rsufirst_name.' '.$user->rsulast_name);
				}
			}
			return $UserDetailsArr;
		}catch(Exception $ex){
			$db->rollBack();
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getRestaurantUserIdsByRestIds($restIdsArr)
	{
		try{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			
			$select->from(array('resusr' => 'mt.restaurant_user'), array('rsufirst_name','rsulast_name','rsufk_user','rsufk_restaurant'))
				   ->join(array('rst'=>'mt.restaurant'),'rst.resid = resusr.rsufk_restaurant',array('resrestaurant_name'))
				   ->join(array('usr'=>'mt.user'),'usr.usrid = resusr.rsufk_user',array('usrrole_id'))
				   ->join(array('rol'=>'mt.role_bd'),'rol.id = usr.usrrole_id',array('description as rsurole'))
				   ->where('resusr.rsufk_restaurant IN(?)',$restIdsArr)
				   ->where('usr.usruser_status_id = ?',1);
			$result = $table->fetchAll($select);
			
			return $result;
		}catch(Exception $ex){
				throw new Exception($ex->getMessage()) ;
			}
	}
	
	public function getrestusersbyrestId($request)
	{
		$resid = $request->resid;
		$bookingid = $request->bookingid;
		try{
			$query = $this->getDbTable()->select();
			$query->setIntegrityCheck(false);
			$query->from(array('resusr' => 'mt.restaurant_user'), array('rsuid','rsufirst_name','rsulast_name'));
			$query->join(array('usr' => 'mt.user'), 'resusr.rsufk_user = usr.usrid', array('usrid','usremail','usrregistered_date'));
			$query->join(array('rest' => 'mt.restaurant'),'resusr.rsufk_restaurant = rest.resid',array('resid','resrestaurant_name'));
			$query->join(array('usrtyp'=>'mt.userstatus_bd'),'usrtyp.id = usr.usruser_status_id',array('code','description'));
			$query->where('resusr.rsufk_restaurant = ?',$resid);
			$query->where('usr.usruser_status_id = ?',1);
			$UserResult = $this->getDbTable()->fetchAll($query);
			
			$mapper = new User_Model_ManagerDataMapper();
			$OwnerResult = $mapper->getOwnerDetailsByResId($resid);
			$UserDetailsArr[] = array('key'=>$OwnerResult->usrid,'value'=>$OwnerResult->rsofirst_name.' '.$OwnerResult->rsolast_name);
			if($UserResult){
				foreach($UserResult as $user){
					$UserDetailsArr[] = array('key'=>$user->usrid,'value'=>$user->rsufirst_name.' '.$user->rsulast_name);
				}
			}
			if($bookingid)
			{
			
			$obj = new Reservation_Model_ReservationDataMapper();
			$tab = $obj->getDbTable();
			$select = $tab->select();
			$select->from(array('bok' => 'mt.booking'), array('bokbooking_user_initials'));
			$select->where('bok.bokid = ?',$bookingid);
			$initials = $tab->fetchAll($select);
			
			foreach($initials as $initial){
					$UserDetailsArr['id'] = $initial->bokbooking_user_initials;
				}
			}
						
			return $UserDetailsArr;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetRestaurantUsersByRestaurantid($restids)
	{
		try{
			$select = $this->getDbTable()->select();
			$select->setIntegrityCheck(false);
			$select->from(array('resusr' => 'mt.restaurant_user'), array('rsuid','rsufk_user','rsufk_restaurant','rsusalution','rsufirst_name','rsulast_name','rsugender','rsuaddress','rsucreate_date','rsuupdated_date','rsuphone','rsumobile','rsudesignation','rsurole','rsucreatedby','rsucreateddatetime','rsuupdatedby','rsuupdateddatetime','rsup_resid','rsucountrycode','rsudefaultview'));
			$select->join(array('usr' => 'mt.user'), 'resusr.rsufk_user = usr.usrid', array('usrid','usremail','usrpassword','usrusertype_id','usrrole_id','usrregistered_date','usrlastlogged_in_ip','usrlast_login_date','usruser_status_id','usrcreatedby','usrcreateddatetime','usrupdatedby','usrupdateddatetime','usrpassphrase'));
			$select->where('resusr.rsufk_restaurant IN (?)',$restids);
			$resultset = $this->getDbTable()->fetchAll($select);
      //echo '<pre>'; print_r($resultset); exit;
			$UserResult= array();
			foreach($resultset as $key=>$value){
				$subArr = array();
				foreach($value as  $key1=>$value1){
					if($key1 == 'rsucreatedby' || $key1 == 'rsuupdatedby' || $key1 == 'usrcreatedby' || $key1 == 'usrupdatedby'){
						$subArr[$key1]= null;
					}else{
						$subArr[$key1]= $value1;
					}
				}
				$UserResult[] = $subArr;
			}
			return $UserResult;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getrestaurantuserdetailsbyUserid($userid)
	{
		try{
				$table  = $this->getDbTable();
				$select = $table->select();
				$select->setIntegrityCheck(false);
				$select->from(array('rsu' => 'mt.restaurant_user'), array('rsufk_user','rsufirst_name as first_name','rsulast_name as last_name','rsuphone as phone','rsuaddress as address','rsudesignation as designation','rsurole as role'))
					//	->joinLeft(array('srbd'=>'mt.source_of_restaurant_bd'),'srbd.id=rso.rsosourceid',array('srbd.description as description'))
						->join(array('usr'=>'mt.user'),'usr.usrid=rsu.rsufk_user',array('usremail as email'))
					//	->joinLeft(array('st'=>'mt.state_bd'),'st.id=rso.rsostateid',array('st.description as statename'))
					//	->joinLeft(array('cty'=>'mt.city_bd'),'cty.id=rso.rsocityid',array('cty.description as cityname'))
					//	->joinLeft(array('rgn'=>'mt.region_bd'),'rgn.id=rso.rsoregionid',array('rgn.description as regionname'))
						->join(array('res'=>'mt.restaurant'),'res.resid = rsu.rsufk_restaurant',array('resrestaurant_name as restaurant_name','resaddress as restaurantadd'))
						->where('rsu.rsufk_user = ?',$userid);
				
				$records = $table->fetchAll($select);
				$resowner	=	array();
				$RestPrf	=	array();
				
				foreach($records as $value)
				{
					//$id = $value->sourceid;
					//$description=$value->sourcedescription;
					$emailaddress=$value->email;
					
					if($value->role == null){
						$value->role = "";
					}
					$result=array('First Name'=>$value->first_name,'Last Name'=>$value->last_name,'Restaurant Name / Group Name'=>$value->restaurant_name,'Restaurant Address'=>$value->restaurantadd,'Email Address'=>$value->email,'Phone'=>$value->phone,'Designation'=>$value->designation,'Role'=>$value->role,'Address'=>$value->address);
					//if($value->website==null){
					//$result['Website']='';
					//}
					
				}
			
						
//				$sourceofrestaurantMapper  = new Application_Model_SourceofRestaurantDataMapper();
//			    $sources = $sourceofrestaurantMapper->fetchAll();
//			    $sourceList[] = array('key'=>'','value'=>'Select Source');   	   
//			    foreach($sources as $source){
//			    $sourceList[] = array('key'=>$source->getId(),'value'=>$source->getDescription());
//				}
				
	//			if($id==null)
				$RestPrf=array('resowner'=>$result);
//				else
//				$RestPrf=array('resowner'=>$result,'sourcelist'=>$sourceList,'id'=>$id,'description'=>$description,);
								
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}	
	}
	
	public function RetrieveRestIdByUserId($rest_user_id)
	{
		try
		{
			$table  = $this->getDbTable();
			$select = $table->select();
			
			$select->from($table,array('rsufk_restaurant'))
			       ->where('rsufk_user = ?',$rest_user_id);
			       
			$row = $table->fetchRow($select); 
			
			$restid = $row->rsufk_restaurant;
			
			return $restid;
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}	
	}
}