<?php
class User_Model_RestSuperUser
{
	private $_id;
	private $_userid;
	private $_restaurant;
	private $_createdby;
	private $_createdtime;
	private $_updatedby;
	private $_updatedtime;
	
	public function __construct(array $options = null)
	{
		if(is_array($options)){
			$this->setOptions($options);
		}		
	}
	
	public function __set($name, $value)
	{
		$method = 'set' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Price Plan property');
		}
		$this->$method($value);
	}
	
	public function __get($name)
	{
		$method = 'get' . $name;
		if (('mapper' == $name) || !method_exists($this, $method)) {
			throw new Exception('Invalid Price Plan property');
		}
		return $this->$method();
	}
	
	public function setOptions(array $options)
	{
		$methods = get_class_methods($this);
		foreach ($options as $key => $value) {
			$method = 'set' . ucfirst($key);
			if (in_array($method, $methods)) {
				$this->$method($value);
			}
		}
		return $this;
	}
	
	public function setId($id)
	{
		$this->_id = $id;
		return $this;
	}
	
	public function getId()
	{
		return $this->_id;
	}
	
	public function setUser($user)
	{
		$this->_userid = $user;
		return $this;
	}
	
	public function getUser()
	{
		return $this->_userid;
	}

	public function setRestaurant($id)
	{
		$this->_restaurant = (int)$id;
		return $this;
	}
	
	public function getRestaurant()
	{
			return $this->_restaurant;
	}
	
	public function setCreatedby($lastlogin)
	{
		$this->_createdby = $lastlogin;
		return $this;
	}
	
	public function getCreatedby()
	{
		return $this->_createdby;
	}
	
	public function setCreateddtime($lastloginip)
	{
		$this->_createdtime = (string)$lastloginip;
		return $this;
	}
	
	public function getCreatedtime()
	{
		return $this->_createdtime;
	}
	
	public function setUpdatedby($password)
	{
		$this->_updatedby = (string)$password;
		return $this;
	}
	
	public function getUpdatedby()
	{
		return $this->_updatedby;
	}
	
	public function setUpdatedtime($registereddate)
	{
		$this->_updatedtime = $registereddate;
		return $this;
	}
	
	public function getUpdatedtime()
	{
		return $this->_updatedtime;
	}
}