<?php

class User_Model_RestSuperUserDataMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}	
	
	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('User_Model_DbTable_RestSuperUser');
		}
		return $this->_dbTable;
	}
		
	public function save($userArr)
	{
		try{				
			foreach($userArr as $userDet){
				$user= array(
							'rsu_rsu_fk_user'		=>$userDet->getUser(),
							'rsu_rsu_restaurant'	=>$userDet->getRestaurant(),
							'rsu_rsu_created_by'	=>$userDet->getCreatedby(),
							'rsu_rsu_createdtime'	=>$userDet->getCreatedtime(),
							'rsu_rsu_status'		=> true		
				);						
				$user_id = $this->getDbTable()->insert($user);	
			}	
			return $user_id;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}		
	}
	
	public function retrievesuperuserrestaurants($superuser_id)
	{
		try
		{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('rsu_rsuid','rsu_rsu_fk_user','rsu_rsu_restaurant','rsu_rsu_created_by','rsu_rsu_createdtime','rsu_rsu_createdtime','rsu_rsu_updatedtime','rsu_rsu_status'))
				   ->where('rsu_rsu_status = ?',true)
				   ->where('rsu_rsu_fk_user IN (?)',$superuser_id);
			$rowset = $table->fetchAll($select);
			$result = array();
			foreach($rowset as $key=>$value)
			{
				$subArr = array();
				foreach($value as  $key1=>$value1){
						$subArr[$key1]= $value1;
				}
				$result[] = $subArr;
			}  
			return $result;  
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function update($userArr)
	{
		try{
			$user_id = true;
			$userid = $userArr[0]->getUser();
			$table = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('rsu_rsuid','rsu_rsu_fk_user','rsu_rsu_restaurant','rsu_rsu_status'))
			       ->where('rsu_rsu_fk_user IN (?)',$userid);
			$rowset = $table->fetchAll($select);
			$residArr = array();
			$residArray	=	array();
			if(count($rowset) > 0){
				foreach($rowset as $row){
					$residArr[$row->rsu_rsu_restaurant] = $row->rsu_rsu_status;
				}
			}
			foreach($userArr as $userDet){
				if (array_key_exists($userDet->getRestaurant(), $residArr)) {
					$residArray[] = $userDet->getRestaurant();
					$resStatus = $residArr[$userDet->getRestaurant()];
					if(!$resStatus){
						$set = array('rsu_rsu_status' 	=> 	true,
								'rsu_rsu_updated_by'	=>	$userDet->getUpdatedby(),
								'rsu_rsu_updatedtime'	=>	date("Y-m-d H:i:s"),
						);
						$where = array('rsu_rsu_fk_user = ?'   => $userDet->getUser());
						$status = $this->getDbTable()->update($set,$where);	
					}					
				}else{
					$user = array(
						'rsu_rsu_status' 		=> 	true,
						'rsu_rsu_fk_user'		=>	$userDet->getUser(),
						'rsu_rsu_restaurant'	=>	$userDet->getRestaurant(),
						'rsu_rsu_created_by'	=>	$userDet->getUpdatedby(),
						'rsu_rsu_createdtime'	=>	date("Y-m-d H:i:s")		
					);						
					$user_id = $this->getDbTable()->insert($user);
				}				
			}
			if(count($rowset) > 0){
				foreach($rowset as $row){
					if(!in_array($row->rsu_rsu_restaurant, $residArray)){
						$set = array('rsu_rsu_status' 		=> 	0,
									'rsu_rsu_updated_by'	=>	$userArr[0]->getUpdatedby(),
									'rsu_rsu_updatedtime'	=>	date("Y-m-d H:i:s"),
								);
					$where = array('rsu_rsu_fk_user = ?'   	 => $userid,
								   'rsu_rsu_restaurant = ?'  => $row->rsu_rsu_restaurant);
						$status = $this->getDbTable()->update($set,$where);	
					}
				}	
			}			
			return $user_id;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}		
	}
		
	public function retrieveallspueruserbyrestid($restidlist)
	{
		try
		{
			$table = $this->getDbTable();
			$select = $table->select();
			$select->from($table,array('rsu_rsuid','rsu_rsu_fk_user','rsu_rsu_restaurant','rsu_rsu_created_by','rsu_rsu_createdtime','rsu_rsu_updated_by','rsu_rsu_updatedtime','rsu_rsu_status'))
			       ->where('rsu_rsu_restaurant IN (?)',$restidlist)
			       ->order('rsu_rsuid');
			$rowset = $table->fetchAll($select);
			$result = array();
			foreach($rowset as $key=>$value)
			{
				$subArr = array();

				foreach($value as  $key1=>$value1){
						$subArr[$key1]= $value1;
				}
				$result[] = $subArr;
			}  
			return $result;  
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
}