<?php
class Application_Service_Android
{
	
	public function CheckAndroidDetails($request)
	{
		try{
			$requestedValues = array();
			$finalArr = array();
			
			$requestedValues['emailAddress']= $request->email;
			$requestedValues['password']	= $request->password;
			
		
			$userService = new Application_Service_Client();
			$resultArr = $userService->CheckLoginDetails($requestedValues);
			if($resultArr['Status']){
				$usertabledata = $resultArr['userdata'];
				
				$userMapper = new User_Model_ClientDataMapper();
				$userType = $userMapper->getUsertype($usertabledata->usrusertype_id);
				$user_id = "";	
				$userRestId = null;
				switch ($userType->getcode()) {
					case 'RSU':
							
					$rsuMapper = new User_Model_PatronDataMapper();
					$rsutable 	   = $rsuMapper->getDbTable();
					$rsuselect    = $rsutable->select();
					$rsuselect->from($rsutable,array('rsufk_restaurant',))
						   ->where('rsufk_user = ?',$usertabledata->usrid) ;   
					$row = $rsutable->fetchRow($rsuselect);
					$restid = $row['rsufk_restaurant'];
					$userRestId = $restid;
					$restMapper = new FirmManagement_Model_FirmDataMapper();
					$resttable 	   = $restMapper->getDbTable();
					$restselect    = $resttable->select();
					$restselect->from($resttable,array('resfk_user'))
						   ->where('resid = ?',$restid) ;   
					$restresult = $resttable->fetchRow($restselect);
					$user_id = $restresult['resfk_user'];
				
					break;
					case 'SRU':
					$rsuMapper = new User_Model_PatronDataMapper();
					$rsutable 	   = $rsuMapper->getDbTable();
					$rsuselect    = $rsutable->select();
					$rsuselect->from($rsutable,array('rsufk_restaurant',))
						   ->where('rsufk_user = ?',$usertabledata->usrid) ;   
					$row = $rsutable->fetchRow($rsuselect);
					$restid = $row['rsufk_restaurant'];
					
					$restMapper = new FirmManagement_Model_FirmDataMapper();
					$resttable 	   = $restMapper->getDbTable();
					$restselect    = $resttable->select();
					$restselect->from($resttable,array('resfk_user'))
						   ->where('resid = ?',$restid) ;   
					$restresult = $resttable->fetchRow($restselect);
					
					$user_id = $restresult['resfk_user'];
					break;
					default:
						$user_id = $usertabledata->usrid;
					break;
				}			
	
				$FirmMapper = new FirmManagement_Model_FirmDataMapper();
				$restauranttabledata = array();
				if($userType->getcode() == "RSU")
				{
					$restauranttabledata = $FirmMapper->GetRestaurantTableDataByRestaurantIdAndroid($userRestId,$user_id);

				}
				else {
					$restauranttabledata = $FirmMapper->GetRestaurantTableDataByOwnerIdAndroid($user_id);
				}
				
				$finalArr['Status'] = true;
				$finalArr['restaurantdata']	= $restauranttabledata;
				$clientService = new Application_Service_Client();
				$finalArr['access_token'] = $clientService->generateUserTokenWithUserId($user_id);		
				return $finalArr;
			}else{
				return $resultArr;
			}
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function MakeReservationAndroid(array $data)
	{
		try{
			if($data){
				$formData = $data;
				$bookTypeMapper = new Application_Model_ReservationTypeDataMapper();
				$bookType = $bookTypeMapper->GetBookingTypeByCode('NOR');

				$statusCode = array();

				if($data['bookingStatus'] && $data['rescheduleStatus']){
					$statusCode[] = $data['bookingStatus'];
					$statusCode[] = $data['rescheduleStatus'];
				}else if($data['bookingStatus']){
					$statusCode[] = $data['bookingStatus'];
				}

				$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
				$bookStatus 	  = $bookStatusMapper->GetBookingStatusByCode($statusCode);
				$bookStatusObj 	  = $bookStatus[$data['bookingStatus']];
				$resStatusObj = null;
				if(isset($bookStatus[$data['rescheduleStatus']])){
					$resStatusObj = $bookStatus[$data['rescheduleStatus']];
				}
				

				$resModeMapper = new Application_Model_ReservationModeDataMapper();
				$rescode = $formData['origin'];
				$resModeStatus 	  = $resModeMapper->GetReservationModeByCode(array($rescode));
				$resModeObj 	  = $resModeStatus[$rescode];

				$mapper = new Reservation_Model_ReservationDataMapper();
				$dinerDetails = new Reservation_Model_Reservation();

				$dinerDetails->setbokfk_restaurant($formData['restaurantid']);
				$dinerDetails->setbokbooking_date($formData['resDate']);
				$time = '';
				if($data['bookingStatus'] == 'RSD'){
					$dinerDetails->setbokbooking_timings($formData['seltime']);
					$time = $formData['seltime'];
				}else if($data['bookingStatus'] == 'OVB'){
					$dinerDetails->setbokbooking_timings($formData['resTime']);
					$time = $formData['resTime'];
				}

				if($data['bookingStatus'] && $data['rescheduleStatus']){
					$dinerDetails->setbokbooking_status_id($bookStatusObj->getId());
					$dinerDetails->setbokbooking_status_code($bookStatusObj->getCode());
					$dinerDetails->setbokbooking_status($bookStatusObj->getId());
				}else{
					$dinerDetails->setbokbooking_status_id($bookStatusObj->getId());
					$dinerDetails->setbokbooking_status_code($bookStatusObj->getCode());
					$dinerDetails->setbokbooking_status($bookStatusObj->getId());
				}
				$dinerDetails->setbokparty_size($formData['pax']);
				$dinerDetails->setbokfirst_name($formData['firstName']);
				$dinerDetails->setboklast_name($formData['lastName']);
				$dinerDetails->setbokphone($formData['number']);
				$dinerDetails->setbokemail($formData['email']);
				$dinerDetails->setbokcountry_code($formData['countryCode']);
				$dinerDetails->setbokrestaurant_note($formData['dinerRequest']);

				$resServ = new Application_Service_Firm();
				$timeZone = $resServ->GetRestaurantTimeZone($formData['restaurantid']);
				date_default_timezone_set($timeZone);

				$dinerDetails->setbokbooking_made_on(date('Y-m-d H:i:s'));
				$dinerDetails->setBookingMadeTime(date("H:i",time()));
				$userid = "";
				
				$bookPhrase = uniqid ();
				$dinerDetails->setbokbookingphrase($bookPhrase);

				$dinerDetails->setbokuserid($userid);
				$dinerDetails->setbokspecial_request($formData['contactInfo']);
				$dinerDetails->setbokbooking_type_id($bookType->getId());
				$dinerDetails->setbokreservation_mode_id($resModeObj->getId());
				$dinerDetails->setTableSize($formData['tableSize']);
				$dinerDetails->setNoOfTables($formData['noOfTables']);
				$dinerDetails->setInventoryId($formData['inventoryid']);
				$dinerDetails->setNotificationType($formData['notificationType']);
				$dinerDetails->setbokid($formData['bookingid']);
				$dinerDetails->setbokuserid($formData['userid']);
				if($formData['bokoptions']){
					$dinerDetails->setbokoptions($formData['bokoptions']);
				}
				
				$resDataMapper = new FirmManagement_Model_FirmDataMapper();
				$seetingArr = $resDataMapper->getScheduleSettingTypeByresId($formData['restaurantid']);
				$dinerDetails->setbok_restsch_setting_id($seetingArr['settingId']);
				$dinerDetails->setbok_restsch_setting_type($seetingArr['settingType']);
				
				if($formData['rescheduleStatus']){
					$dinerDetails->setRescheduleCode($formData['rescheduleStatus']);
				}
				if($resStatusObj){
					$dinerDetails->setRessch_Status_Id($resStatusObj->getId());
				}
				
				$result = $mapper->saveMakeReservationDetails($dinerDetails,'reserv',$formData);

				$dinerDetails->setbokid($result);
				$mailmapper = new Application_Service_Communication();
				$restService = new Application_Service_Firm();
				$restResult = $restService->GetRestaurantDetailsById($formData['restaurantid']);
				$resDataMapper = new FirmManagement_Model_FirmDataMapper();
				$restObj= new FirmManagement_Model_FirmById();
				$restObj->setRestaurantId($formData['restaurantid']);
				$resDetails = $resDataMapper->getRestaurantById($restObj);
				$mailObj = new Communication_Model_Mail();
				if($formData['email']){
					if(isset($data['rescheduleStatus']) && $data['rescheduleStatus']== 'RES'){
						$mailObj->setMsgCode('ReSchedule');
					}else{
						$mailObj->setMsgCode('BookConf');
					}
					if($stateId == ""){
						$reservice = new Application_Service_Reservation();
						$stateCity = $reservice->getRestaurantStateByResId($formData['restaurantid']);
						$stateId = $stateCity['state'];
						$cityId = $stateCity['city'];
						$regionId = $stateCity['region'];
					}
					$userType = 'CUS';
					$adminService = new Application_Service_Administrator();
					$campProp = new Application_Model_GetCampaignForPost();
					$campProp->setAudType($userType)
					->setStateId($stateId)
					->setCityId($cityId)
					->setRegionId($regionId)
					->setIsAjaxCall(false);
					$campDetails = array();
					if(!$resDetails->getrescampaignstatus() === false){
						$campDetails = $adminService->GetCampaignDetails($campProp);
					}

					$name = $formData['firstName'].' '.$formData['lastName'];
					$dat = array('UserName' => $name,
							  'SenTo'    => $formData['email'],
							  'phone'	 => $formData['number'],
							  'RestName' => $restResult->resrestaurant_name,
							  'ResDate'  => $formData['resDate'],
					//		  'Time'     => $boktime,
							  'Time'     => $time,
							  'Size'     => $formData['pax'],
							  'Address'	 => $restResult->resaddress,
							  'resphone' => $resDetails->getRestphone(),
							  'resemail' =>	$resDetails->getRestemail(),
							  'rescity'	 =>	$resDetails->getRestCityDesc(),
							  'resnbh'	 =>	$resDetails->getRestNeighborDesc(),
							  'reszipcode'	=>	$resDetails->getRestzipcode(),
							  'Status'	 => $result['bokstatus'], 
							  'Bokid'	 =>	$result,
							  'State_Id' =>	$stateId,
							  'City_Id'	 =>	$cityId,
							  'UserType' =>	$userType,
							  'BookNotf' =>  false,
					);
					if(count($campDetails)){
						$count = count($campDetails);
						if($count > 1){
							$campaign = $campDetails[rand(0,$count-1)];
						}else{
							$campaign = $campDetails[0];
						}
						$notfService = new Application_Service_Communication();
						$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
						$dat['campaignName'] = trim($campaign->getSponsor());
						$dat['campaignDesc'] =	trim($campaign->getCampDesc());
						$dat['campaignImg'] =	trim($campaign->getCampImage());
						$dat['campId']	= $campaign->getId();
					}
					if($mailObj->getMsgCode() == 'ReSchedule'){
						$dat['splstatus']	= false;
					}
					
					$mailObj->setData($dat);
					$mailStatus = $mailmapper->SendMail($mailObj);
				}else if($formData['number']){
					$smsObj = new Communication_Model_Sms();
					if(isset($data['rescheduleStatus']) && $data['rescheduleStatus']== 'RES'){

						$smsObj->setMsgCode('ReSchedule');
					}else{
						$smsObj->setMsgCode('BookConf');
					}

					$dat = array(
					 'to'			=>	trim($formData['number']),
					 'countrycode'	=> $formData['countryCode'],
					 'bokid'		=> $result,
					 'RestName' 	=> $restResult->resrestaurant_name,
					 'ResDate'  	=> $formData['resDate'],
					 'Time'     	=> $time,
				//	 'Time'     	=> $boktime,
					 'Size'     	=> $formData['pax'],
					 'CustomerName' => $formData['firstName'].' '.$formData['lastName']
					//'Address'	 => $restResult->resaddress,
					);
					$smsObj->setData($dat);
					$mailStatus = $mailmapper->SendSms($smsObj);
				}
				if($result){
					$resultarray['status']= true;
				}
				return $resultarray;
				
			}else{
				$resultarray['status'] = false;
				return $resultarray;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function MakeWaitingReservationAndroid(array $data,$userid)
	{
		try{
			if($data){
				
				$formData = $data;
			
				$bookTypeMapper = new Application_Model_ReservationTypeDataMapper();
				$bookType = $bookTypeMapper->GetBookingTypeByCode('NOR');
	
				$statusCode = array();
				if($data['waitbookingStatus'] && $data['waitrescheduleStatus']){
					$statusCode[] = $data['waitbookingStatus'];
					$statusCode[] = $data['waitrescheduleStatus'];
				}else{
					$statusCode[] = $data['waitbookingStatus'];
				}
				$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
				$bookStatus 	  = $bookStatusMapper->GetBookingStatusByCode($statusCode);
				$bookStatusObj 	  = $bookStatus[$data['waitbookingStatus']];
				$resStatusObj = null;
				if(isset($bookStatus[$data['waitrescheduleStatus']])){
					$resStatusObj = $bookStatus[$data['waitrescheduleStatus']];
				}
	
				$resModeMapper = new Application_Model_ReservationModeDataMapper();
				$rescode = $formData['waitorigin'];
				$resModeStatus 	  = $resModeMapper->GetReservationModeByCode(array($rescode));
				$resModeObj 	  = $resModeStatus[$rescode];
	
				$waitingquoteMapper = new Application_Model_WaitingQuoteTimeDataMapper();
				$quotecode = $formData['quotedTime'];
				$quoteStatus 	  = $waitingquoteMapper->GetQuoteTimeByCode(array($quotecode));
				$quoteObj 	  = $quoteStatus[$quotecode];
	
				$mapper = new Reservation_Model_ReservationDataMapper();
				$dinerDetails = new Reservation_Model_Reservation();
	
				$dinerDetails->setbokfk_restaurant($formData['restaurantid']);
					
				$dinerDetails->setbokparty_size($formData['waitpax']);
				$dinerDetails->setbokbooking_status_id($bookStatusObj->getId());
				$dinerDetails->setbokbooking_status_code($bookStatusObj->getCode());
				$dinerDetails->setbokbooking_status($bookStatusObj->getId());
				$dinerDetails->setbokfirst_name($formData['waitfirstName']);
				$dinerDetails->setboklast_name($formData['waitlastName']);
				$dinerDetails->setbokphone($formData['waitnumber']);
				$dinerDetails->setbokcountry_code($formData['countryCode']);
				if($formData['waitnumber']){
					$dinerDetails->setNotificationType('sms');
				}
				//$dinerDetails->setbokemail($formData['waitemail']);
				//$dinerDetails->setbokemail('');
				$dinerDetails->setbokrestaurant_note($formData['waitdinerRequest']);
				$dinerDetails->setQuotedTime($quoteObj->getId());
	
				$resServ = new Application_Service_Firm();
				$timeZone = $resServ->GetRestaurantTimeZone($formData['restaurantid']);
				date_default_timezone_set($timeZone);
	
				$dinerDetails->setbokbooking_made_on(date('Y-m-d H:i:s'));
				$dinerDetails->setBookingMadeTime(date("H:i",time()));
				$dinerDetails->setbokbooking_date($formData['waitresDate']);
				$dinerDetails->setbokbooking_timings(date('g:i A'));
				//$dinerDetails->setbokbooking_timings($formData['waitresTime']);
				$bookPhrase = uniqid ();
				$dinerDetails->setbokbookingphrase($bookPhrase);
			
				$dinerDetails->setbokuserid($userid);
				$dinerDetails->setbokspecial_request($formData['waitcontactInfo']);
				$dinerDetails->setbokbooking_type_id($bookType->getId());
				$dinerDetails->setbokreservation_mode_id($resModeObj->getId());
				$dinerDetails->setTableSize($formData['waittableSize']);
				$dinerDetails->setNoOfTables($formData['waitnoOfTables']);
				$dinerDetails->setInventoryId($formData['waitinventoryid']);
				//$dinerDetails->setNotificationType($formData['waitnotificationType']);
				
				$dinerDetails->setbokid($formData['bookingid']);
	
	
				if($formData['waitrescheduleStatus']){
					$dinerDetails->setRescheduleCode($formData['waitrescheduleStatus']);
	
				}
				if($resStatusObj){
					$dinerDetails->setRessch_Status_Id($resStatusObj->getId());
				}
				$result = $mapper->saveMakeReservationDetails($dinerDetails,'waiting',$formData);
	
				$dinerDetails->setbokid($result);
				$mailmapper = new Application_Service_Communication();
				$restService = new Application_Service_Firm();
				$restResult = $restService->GetRestaurantDetailsById($formData['restaurantid']);
	
				if($formData['waitnumber'] != ""){
					$name = $formData['waitfirstName'].' '.$formData['waitlastName'];
					$custMsg = '';
					$custMsg = 'Hi '.$name.', we have put your reservation in waiting, please wait for '.$quoteObj->getDescription().'. '.$restResult->resrestaurant_name;
					$smsObj = new Communication_Model_Sms();
					$smsObj->setMsgCode('WaitingReserv');
					$data = array(
									'to'			=> trim($formData['waitnumber']),
									'countrycode'	=> $formData['countryCode'],
									'RestName' 		=> $restResult->resrestaurant_name,
									'UserName'		=> $name,
									'Quote'			=> $quoteObj->getDescription(),
									'BookId'		=> $result
					);
					$smsObj->setData($data);
					$mailStatus = $mailmapper->SendSms($smsObj);
				}
				if($result){
						$resultarray['status']= true;
				}
				return $resultarray;
			}else{
				$resultarray['status'] = false;
				return $resultarray;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function FreezeReservationAndroid($request,$userid)
	{
		try{
			if($request && $userid){
				$restid = $request->restaurantid;
				$freeze = new Reservation_Model_RestaurantFreeze();
				$freeze->setfrzfk_restaurant($restid);
				$date = $request->date;
				if($request->status == 'freeze'){
					$freeze->setfrzstatus('TRUE');
				}

				$freeze->setfrzselAllStatus($request->selAllStatus);
				$freeze->setfrzfreezeddate($request->selectedDate);
				$freeze->setfrztype($request->selectedStatus);
				$freeze->setfrzdesc($request->freezedesc);
				$frzTime = new Reservation_Model_RestaurantFreezeTimeMap();
				$frzTime->setfrzfk_restaurant($restid);
				$frzTime->setfrzfreezedtime($request->selectedTimes);
				$frzTime->setfrzstatus(true);
				$freeze->setfrzfreezeddby($userid);
				$mapper = new Reservation_Model_RestaurantFreezeDataMapper();
				$status = $mapper->FreezeReservation($freeze,$frzTime);
				return $status;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getCustomerContacts($restid)
	{
		try{
			$mapper = new FirmManagement_Model_FirmGroupUsersDataMapper();
			$limit = 2500;
			$db = Zend_Db_Table::getDefaultAdapter();
			$table = $mapper->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			$select->from(array('rgu' => 'mt.restaurant_group_users'),array('rguid','rgufk_restaurant','rgufk_rsgid','rgufirst_name','rgulast_name','rgugender','rguemail','rguphone','rguaddress','rgustatus','rgucreated_date','rguupdated_date','rgustate_id','rgucity_id','rguzipcode','rguneighbourhood_id','rguregion_id','rguspecial_request','rgu_birthday','rgu_anniversary','rgu_optinemail','rgu_occational_emails','rgucountrycode', 'rgucity','rgustate','rgucompany','rgudesignation','rgufrqntdinner','rgublacklist','rguallergies_dislikes','rgusplstatus_id','rgu_specialdays','rgu_reservation_count','rgu_noshow_count','rgu_cancel_count','rgu_reschedule_count','rgu_total_count','rgu_web_count','rgu_walkin_count','rgu_facebook_count'))
				   ->joinLeft(array('spl' => 'mt.splstatus_bd'),'spl.id = rgu.rgusplstatus_id',array('description as spldesc'))
				   ->where('rgufk_restaurant = ?',$restid)
				   ->where('rgustatus = ?',true)
				   ->order('rguid DESC');
		    $Result = "";
			$Result = new Zend_Paginator(
			new Zend_Paginator_Adapter_DbTableSelect($select)
			);
			$Result->setItemCountPerPage($limit);
			$resArr = array();
			foreach($Result as $row){
				$resArr[] = array('rguid' => $row->rguid,
								  'rgufirst_name' => $row->rgufirst_name,
								  'rgulast_name'  => $row->rgulast_name,
								  'rguemail' => $row->rguemail,
								  'rguphone' => $row->rguphone,
								  'rgustatus' => $row->rgustatus,								  
								  'rguspecial_request' => $row->rguspecial_request,								  
								  'rgucountrycode' => $row->rgucountrycode,								  
								  'rguallergies_dislikes' => $row->rguallergies_dislikes,
								  'rgu_specialdays' => $row->rgu_specialdays,
								  'rgu_reservation_count' => $row->rgu_reservation_count,
								  'rgu_noshow_count' => $row->rgu_noshow_count,
								  'rgu_cancel_count' => $row->rgu_cancel_count,
								  'rgu_reschedule_count' => $row->rgu_reschedule_count,
								  'rgu_total_count' => $row->rgu_total_count,
								  'rgu_walkin_count' => $row->rgu_walkin_count,
								  'spldesc'   => $row->spldesc,
									);
				}
				return $resArr;
			
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function sendSmsToCustomerNumFromMobileMode($request,$resid,$userid)
	{
		try{
			if($request){
				$resMapper = new FirmManagement_Model_FirmDataMapper();
				$restDetails = $resMapper->getRestaurantDetailsById($resid);
				$service = new Application_Service_Communication();
				$body = $request['msgbody'];
				$smstitle = $request['smstitle'];
				$splitarray = explode(',',$request['phoneNums']);
				$chunk = array_chunk($splitarray,100);
				$smsMapper = new FirmManagement_Model_SmsCampaignDataMapper();
				$smscampid = $smsMapper->SaveMobileSmsCampaign($smstitle,$body,$resid,$userid);
						
				$i=0;
				$count = count($splitarray);
				if($i < $count){
					foreach($chunk as $phonearray){
						$mobilenumbersArr = array();
						$messageArray = array();				
						foreach($phonearray as $mobile){	
							if(strlen($mobile) >= 10 ){				
								$msgMapper = new Communication_Model_SmsMessageMapper();
								$priorMapper = new Application_Model_PriorityDataMapper();
								$prior = $priorMapper->GetPriorityByCode('H');
								$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
								$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
								$message = new Communication_Model_SmsMessage();
								$msgPhrase = uniqid ();
								$message->setPhrase($msgPhrase)
										->setDescription($body)
										->setPriority($prior->getcode())
										->setSmstype($emailType->getcode())
										->setSentToUser('CUS')
										->setSentTo($mobile)
										->setSentFromUser('ADMIN')
										->setSentby($restDetails->resrestaurant_name)
										->setUsertype($userid)
										->setid($resid)
										->setTitle($smstitle);
							   $msgid = $msgMapper->SaveMessageDetails($message);
							   $messageArray[] = $message;
							   $mobilenumbersArr[]=	$mobile;
							}
						}	
						if($mobilenumbersArr){	
							$mobilenumbers = implode(',',$mobilenumbersArr);	
						    $mailStatus = $service->SendBulkMessage($body,$mobilenumbers);
							
							$stat = substr($mailStatus,7,1);
							$bufferstring = substr(strstr($mailStatus, ','),1);
							if($stat == 0){
								$bufferarray = explode(',',$bufferstring);
								$msgMapper->UpdateBulkMessageDetails($messageArray,$bufferarray,$smscampid);
							}else{
								$msgMapper->UpdateBulkMessageDetails($messageArray,$bufferstring,$smscampid);
							}	
						}else{
							return false;
						}
					}	
					
				$i++;
				}
	
			}
			return $smscampid;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function ChangeTableStatus($request, $userid)
	{
		try{
			$changeTableStatusObj  = new Reservation_Model_AllocateSeat();
			
			$changeTableStatusObj->setUserId($userid);

			/* Reteriving Reservation Status Id By Code */
			$bokStatusCode = null;
			$bokStatusCode = $request->bookingstatus;
			$bookMapper = new Reservation_Model_ReservationDataMapper();
			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			if($bokStatusCode){
				$bookStatus 	  = $bookStatusMapper->GetBookingStatusByCode(array($bokStatusCode));
				$bookStatusObj 	  = $bookStatus[$bokStatusCode];
			}else{
				$bookPrevStatus = $bookMapper->getBookingPrevStatus($request->bookingid);
				$bookStatus 	  = $bookStatusMapper->GetBookingStatusById(array(trim($bookPrevStatus)));
				$bookStatusObj 	  = $bookStatus[$bookPrevStatus];
			}
			$restaurantid = $request->restaurantid;
			$changeTableStatusObj->setRestId($restaurantid);
			/* get booking id with phraseid */
//			$phraseId = $bookMapper->GetBookingIdByBookPhrase($request->bookingid);
			
			$changeTableStatusObj->setBookId($request->bookingid);
			$changeTableStatusObj->setBookStatus($bookStatusObj->getId());
			$changeTableStatusObj->setBookStatusCode($bookStatusObj->getCode());
			
			$book = new Reservation_Model_Reservation();
			$book->setbokid($request->bookingid);
//			$book->setbokbookingphrase($request->bookingid);
			$bokDetails = $bookMapper->getBookingDetails($book);
			if($bokDetails->getbokcontactid()){
				$changeTableStatusObj->setContactid($bokDetails->getbokcontactid());
			}
			$neme = $book->getresrestaurant_name();
			if($request->bookingstatus == 'NOS' && $book->getbokemail()){
				if($request->reservtransaction == 'true'){
					$payServ = new Application_Service_Renumeration();
					$customer = new ManageRenumeration_Model_CreateInvoiceByCustId();
					$customer->setRestId($restaurantid)
					->setCustId($bokDetails->getbokuserid())
					->setBookingId($phraseId);
					$CustomerInvoice = $payServ->GenerateCustomerInvoice($customer);
					$CustomerInvoice->setpaymentprofid($request->payprof);
					$CustTransaction = $payServ->CustomerReservationTransaction($CustomerInvoice);
					if($CustTransaction['status']){
						$bookStatus 	  = $bookMapper->ChangeTableStatus($changeTableStatusObj);
					}else{
						$bookStatus 	  = false;
					}
				}else{
					$bookStatus 	  = $bookMapper->ChangeTableStatus($changeTableStatusObj);
				}
			}else{
				$bookStatus 	  = $bookMapper->ChangeTableStatus($changeTableStatusObj);
			}
			if($request->bokaction == 'SHOW' && $bokDetails->getbokcontactid()){
				$groupUsersDataMapper = new FirmManagement_Model_FirmGroupUsersDataMapper();
				$groupUsersDataMapper->updateGuestReservationCount($bokDetails->getbokcontactid(), 'SHOW','');
			}
			if($bookStatus){
				$result = array('status'=>true,'restaurant_id'=>$restaurantid);
				$resMapper = new FirmManagement_Model_FirmDataMapper();
				$rest = new FirmManagement_Model_FirmById();
				$rest->setRestaurantId($restaurantid);
				$resDetails = $resMapper->getRestaurantById($rest);
					
				if($request->bookingstatus == 'NOS' && $book->getbokemail()){
					$stateId = "";
					$cityId = "";
					$regionId = "";
					if($stateId == ""){
						$stateCity = $this->getRestaurantStateByResId($restaurantid);
						$stateId = $stateCity['state'];
						$cityId = $stateCity['city'];
						$regionId = $stateCity['region'];

					}
					$userType = 'CUS';
					$adminService = new Application_Service_Administrator();
					$campProp = new Application_Model_GetCampaignForPost();
					$campProp->setAudType($userType)
					->setStateId($stateId)
					->setCityId($cityId)
					->setRegionId($regionId)
					->setIsAjaxCall(false);
					$campDetails = array();
					$resMapper = new FirmManagement_Model_FirmDataMapper();
					$rest = new FirmManagement_Model_FirmById();
					$rest->setRestaurantId($restaurantid);
					$resDetails = $resMapper->getRestaurantById($rest);
					if(!$resDetails->getrescampaignstatus() === false){
						$campDetails = $adminService->GetCampaignDetails($campProp);
					}
					$mailmapper = new Application_Service_Communication();
					
					$mailObj = new Communication_Model_Mail();
					$mailObj->setMsgCode('No-Show');
					$name = $book->getbokfirst_name().' '.$book->getboklast_name();
					$data = array('UserName' => $name,
								  'Bokid'				=> $request->bookingid,
								  'SenTo'    			=> $book->getbokemail(),
								  'RestName' 			=> $book->getresrestaurant_name(),
								  'ResDate'  			=> $book->getbokbooking_date(),
								  'Time'     			=> $book->getbokbooking_timings(),
							  	  'Size'     			=> $book->getbokparty_size(),
								  'Address'	 			=> $book->getresaddress(),
								  'Status'	 			=> $book->getbokbooking_status_desc(),
								  'State_Id' 			=>	$stateId,
								  'City_Id'	 			=>	$cityId,
								  'UserType' 			=>	$userType,
								  'ResManager'			=>	$resDetails->getRestmanagername(),
								  'ResEmail'			=>	$resDetails->getRestemail()
					);
					if(count($campDetails)){
						$count = count($campDetails);
						if($count > 1){
							$campaign = $campDetails[rand(0,$count-1)];
						}else{
							$campaign = $campDetails[0];
						}
						$notfService = new Application_Service_Communication();
						$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
						$data['campaignName'] = trim($campaign->getSponsor());
						$data['campaignDesc'] =	trim($campaign->getCampDesc());
						$data['campaignImg'] =	trim($campaign->getCampImage());
						$data['campId']	= $campaign->getId();
					}
					if($request->noshowmailsend == 'yes'){
						$mailObj->setData($data);
						$mailStatus = $mailmapper->SendMail($mailObj);
					}
				}else if(isset($request->bokaction) && $request->bokaction == 'SHOW'){
					$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
					$bookStatus = array('NOS');
					$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
					$noshow = new Reservation_Model_GetNoShowList();
					$noshow->setBookStatus($bookStatusRes);
					$noshow->setRestaurantId($restaurantid);
					$noshow->setDate($request->selDate);
					$noshow->setIsAjaxCall(true);
					$noshowcount = $bookMapper->GetNoShowReservation($noshow);
					$result['count'] = count($noshowcount);
				}else if($request->bookingstatus == 'COM'){
					$resowner = $data['Firstname'].' '.$data['LastName'];
					$name = $book->getbokfirst_name().' '.$book->getboklast_name();
					$data = array('UserName' 			=>  $name,
								  'Bokid'				=> 	$request->bookingid,
								  'SenTo'    			=> 	$book->getbokemail(),
								  'to'					=> 	$book->getbokphone(),
								  'countrycode'			=>  $book->getbokcountry_code(),
								  'RestName' 			=> 	$book->getresrestaurant_name(),
								  'ResDate'  			=> 	$book->getbokbooking_date(),
								  'UserType' 			=>	'CUS',
								  'ResManager'			=>	$resDetails->getRestmanagername(),
								  'ResEmail'			=>	$resDetails->getRestemail(),
								  'ResOwner'			=>	$resowner,
								  'ResId'				=>	$restaurantid
					);
					$notifmapper = new Application_Service_Communication();
											
					if($book->getbokemail()){
						$mailObj = new Communication_Model_Mail();
						$mailObj->setMsgCode('ThankMsg');
						$mailObj->setData($data);	
						$mailStatus = $notifmapper->SendMail($mailObj);
					}
					if($book->getbokphone()){	
						$smsObj = new Communication_Model_Sms();
						$smsObj->setMsgCode('ThankMsg');					
						$smsObj->setData($data);									
						$smsStatus = $notifmapper->SendSms($smsObj);
					}				
				}
				return $result;
			}else{
				$result = array('status'=>false);
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetLayoutByDiningIdMobile($request)
	{
		try{
			$resid = $request->restaurantid;
			$diningid = $request->diningid;

			$date = null;
			if(isset($request->date)){
				$date = $request->date;
			}else{
				$date = date('m-d-Y');
			}

			$mapper = new FirmManagement_Model_FirmTableDataMapper();
			$tableObj = new FirmManagement_Model_FirmTable();
			$tableObj->setResId($resid);
			$tableObj->setDiningId($diningid);
			$resultStr = $mapper->getRestaurantTable($tableObj);

			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			$bookMapper = new Reservation_Model_ReservationDataMapper();

			$getTableStatusObj = new Reservation_Model_GetTableStatus();
			$getTableStatusObj->setRestaurantId($resid);
			$getTableStatusObj->setDate($date);

			$bookStatus = array('ALC','DES','BOK','PTS','CRD');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$getTableStatusObj->setBookStatus($bookStatusRes);

			$tableStatus = $bookMapper->getTableStatus($getTableStatusObj);
			$tablesArrFinal = array();
			foreach($resultStr['finalStr'] as $row){
				if($row['number'] != 'PH'){
					$tablesArrFinal[] = $row;
				}
			}
			$tableArr = array();
			
			ksort($tablesArrFinal);  
			return $tablesArrFinal;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function PreAllocateSeat($request, $userid)
	{

		try{
			$diningid = $request->prediningid;
			$preallocSeatObj 	  = new Reservation_Model_AllocateSeat();

			$preallocSeatObj->setUserId($userid);
			
			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			$restaurantid = $request->restaurantid;

			$tableid = array();
			$tableno = array();

			$tableidString = "";
			$tablenoString = "";

			$tableidString = $request->pretableid;
			$tablenoString = $request->pretableno;

			if($tableidString){
				$tableid = explode(',',$tableidString);
			}

			if($tablenoString){
				$tableno = explode(',',$tablenoString);
			}

			$preallocSeatObj->setBookId($request->bookingid)
			->setRestId($restaurantid)
			->setBookTableId($tableid)
			->setBookTableNo($tableno)
			->setDiningId($diningid);

			$bookMapper = new Reservation_Model_ReservationDataMapper();
			$status = $bookMapper->preallocateSeat($preallocSeatObj);

			if($status){
				$result = array('status'=>true);
				return $result;
			}else{

				$result = array('status'=>false);
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function AllocateSeat($request, $userid)
	{
		try{
			$diningid = $request->diningid;
			$allocSeatObj 	  = new Reservation_Model_AllocateSeat();
			
			$allocSeatObj->setUserId($userid);
			
			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			$bookStatus 	  = $bookStatusMapper->GetBookingStatusByCode(array('BOK'));
			$bookStatusObj 	  = $bookStatus['BOK'];
			$restaurantid = $request->restaurantid;

			$tableid = array();
			$tableno = array();

			$tableidString = "";
			$tablenoString = "";

			$tableidString = $request->tableid;
			$tablenoString = $request->tableno;

			if($tableidString){
				$tableid = explode(',',$tableidString);
			}

			if($tablenoString){
				$tableno = explode(',',$tablenoString);
			}

			$allocSeatObj->setBookId($request->bookingid)
			->setRestId($restaurantid)
			->setBookTableId($tableid)
			->setBookTableNo($tableno)
			->setBookStatus($bookStatusObj->getId())
			->setDiningId($diningid);

			$bookMapper = new Reservation_Model_ReservationDataMapper();
			$status = $bookMapper->allocateSeat($allocSeatObj);
			$status = true;
			if($status){
				$result = array('status'=>true,
		 					'restaurant_id'=>$restaurantid);
				return $result;
			}else{
				$result = array('status'=>false);
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function PartiallyAllocateSeat($request,$userid)
	{
		try{
			$diningid = $request->diningid;
			$allocSeatObj 	  = new Reservation_Model_AllocateSeat();
			
			$allocSeatObj->setUserId($userid);
			
			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			$bookStatus 	  = $bookStatusMapper->GetBookingStatusByCode(array('PTS'));
			$bookStatusObj 	  = $bookStatus['PTS'];
			$restaurantid = $request->restaurantid;

			$tableid = array();
			$tableno = array();

			$tableidString = "";
			$tablenoString = "";

			$tableidString = $request->tableid;
			$tablenoString = $request->tableno;

			if($tableidString){
				$tableid = explode(',',$tableidString);
			}

			if($tablenoString){
				$tableno = explode(',',$tablenoString);
			}

			$allocSeatObj->setBookId($request->bookingid)
			->setRestId($restaurantid)
			->setBookTableId($tableid)
			->setBookTableNo($tableno)
			->setBookStatus($bookStatusObj->getId())
			->setDiningId($diningid);

			$bookMapper = new Reservation_Model_ReservationDataMapper();
			$status = $bookMapper->allocateSeat($allocSeatObj);
			$status = true;
			if($status){
				$result = array('status'=>true,
		 					'restaurant_id'=>$restaurantid);
				return $result;
			}else{
				$result = array('status'=>false);
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function CheckLoginDetailsTablet($request)
	{
		try{
			$requestedValues = array();
			$finalArr = array();
			
			$requestedValues['emailAddress']= $request->email;
			$requestedValues['password']	= $request->password;
						
			$userService = new Application_Service_Client();
			$resultArr = $userService->CheckLoginDetails($requestedValues);
			if($resultArr['Status']){
				$usertabledata = $resultArr['userdata'];
				
				$userMapper = new User_Model_ClientDataMapper();
				$userType = $userMapper->getUsertype($usertabledata->usrusertype_id);
			
				$user_id = "";				
				if($userType->getcode() == "RSU")
				{	
					$rsuMapper = new User_Model_PatronDataMapper();
					$rsutable 	   = $rsuMapper->getDbTable();
					$rsuselect    = $rsutable->select();
					$rsuselect->from($rsutable,array('rsufk_restaurant',))
						   ->where('rsufk_user = ?',$usertabledata->usrid) ;   
					$row = $rsutable->fetchRow($rsuselect);
					$restid = $row['rsufk_restaurant'];
					
					$restMapper = new FirmManagement_Model_FirmDataMapper();
					$resttable 	   = $restMapper->getDbTable();
					$restselect    = $resttable->select();
					$restselect->from($resttable,array('resfk_user'))
						   ->where('resid = ?',$restid) ;   
					$restresult = $resttable->fetchRow($restselect);
					
					$user_id = $restresult['resfk_user'];
					
					$userMapper = new User_Model_ClientDataMapper();
					$usertable 	   = $userMapper->getDbTable();
					$userselect    = $usertable->select();
					$userselect->from($usertable,array('usrid','usremail','usrpassword','usrusertype_id','usrrole_id','usrregistered_date','usrlastlogged_in_ip','usrlast_login_date','usruser_status_id','usrcreatedby','usrcreateddatetime','usrupdatedby','usrupdateddatetime','usrpassphrase'))
						   ->where('usrid = ?',$user_id) ;   
					$row = $usertable->fetchRow($userselect);
					foreach ($row as $key=>$value){
						$ownusertabledata[$key] = $value;
					}
					$ownusertabledata->usrcreatedby = null;
					$ownusertabledata->usrupdatedby = null;
					if($ownusertabledata->usrlast_login_date == null){
						$ownusertabledata->usrlast_login_date = $ownusertabledata->usrregistered_date;
					}
					
					$finalArr['usertabledata']			= $ownusertabledata;
				}else
				{
					$user_id = $usertabledata->usrid;
					$usertabledata->usrcreatedby = null;
					$usertabledata->usrupdatedby = null;
					if($usertabledata->usrlast_login_date == null){
						$usertabledata->usrlast_login_date = $usertabledata->usrregistered_date;
					}
					
					$finalArr['usertabledata']	= $usertabledata;
				}
				
				$rsoMapper = new User_Model_ManagerDataMapper();
				$table 	   = $rsoMapper->getDbTable();
				$select    = $table->select();
				$select->from($table,array('rsoid',
										   'rsofk_salution',
										   'rsofk_user',
										   'rsofirst_name',
										   'rsolast_name',
										   'rsorestaurant_name',
										   'rsophone',
										   'rsocreatedby',
										   'rsocreateddatetime',
										   'rsoupdatedby',
									       'rsoupdateddatetime',
										   'rsostateid',
										   'rsocityid',
										   'rsodescription',
										   'rsoregionid',
										   'rsosourceid',
										   'rsosourcedescription',
										   'rsowebsite',
										   'rsocantfind',
										   'rsoyourstate',
										   'rsoyourregion',
										   'rsoyourcity',
										   'presid','rso_companyid','rsodob','rsocountrycode','rsocountry','rsocity','rsozipcode','defaultview',
										   'rsotechfirst_name','rsobilfirst_name','rsobillast_name','rsotechlast_name',
										   'rsotechphone','rsobilphone','rsotechemail','rsobilemail','rsotechcountrycode','rsobilcountrycode'))
				
					   ->where('rsofk_user = ?',$user_id) ;   
				$row = $table->fetchRow($select);
				foreach ($row as $key=>$value){
					if($key == 'rsocreatedby' || $key == 'rsoupdatedby'){
						$restaurantownertabledata[$key] = null;
					}else{
						$restaurantownertabledata[$key] = $value;
					}
				}
		
				$resService = new Application_Service_Firm();
				$resIdsArr = array();
				
				$OwnIdObj = new FirmManagement_Model_FirmByOwnerId();
				$OwnIdObj->setResOwnerId($user_id);
				
				$mapper = new FirmManagement_Model_FirmDataMapper();
				$restIdsList = $mapper->getApprovedRestaurantIdsByOwnerId($OwnIdObj);
				
				foreach($restIdsList as $resid){
					$resIdsArr[] = $resid->resid;
				}
				
				$GeographicalResultbyUserid = $rsoMapper->getGeographicalInformationByUserId($user_id);
				$restMapper = new FirmManagement_Model_FirmDataMapper();
				$GeographicalResultByRestId = $restMapper->getGeographicalInformationByrestIds($resIdsArr);
				
				$satateids = array();
				if($GeographicalResultbyUserid['stateid'] != null){
					$satateids[] = $GeographicalResultbyUserid['stateid'];
				}
				foreach($GeographicalResultByRestId['stateIds'] as $satateid){
					if (!in_array($satateid,$satateids)){
						$satateids[] = $satateid;
					}
				}
				
				$stateMapper = new Application_Model_StateDataMapper();
				$statebasedata = $stateMapper->getStatesByStateIds($satateids);
				
				$regionids = array();
				if($GeographicalResultbyUserid['regionid'] != null){
					$regionids[] = $GeographicalResultbyUserid['regionid'];
				}
				foreach($GeographicalResultByRestId['regionIds'] as $regionid){
					if (!in_array($regionid,$regionids)){
						$regionids[] = $regionid;
					}
				}
				$bookService = new Application_Service_Reservation();
//				$floorplan = $resService->SynchronizationOfFloorPlanByRestaurantid($resIdsArr);
//				$reservations = $bookService->SynchronizationOfReservationsByRestaurantid($resIdsArr);
				
				$regionMapper = new Application_Model_RegionDataMapper();
				$regionbasedata = $regionMapper->getRegionsByregionIds($regionids);
				
				$stateregionMapper = new Application_Model_StateRegionMapDataMapper();
				$stateregionmapdata = $stateregionMapper->getStateRegionMapByIds($satateids, $regionids);
				
				$cityids = array();
				if($GeographicalResultbyUserid['cityid'] != null){
					$cityids[] = $GeographicalResultbyUserid['cityid'];
				}
				foreach($GeographicalResultByRestId['cityIds'] as $cityid){
					if (!in_array($cityid,$cityids)){
						$cityids[] = $cityid;
					}
				}
				
				$cityMapper = new Application_Model_CityDataMapper();
				$citybasedata = $cityMapper->getCitysBycityIds($cityids);
				
				$regioncityMapper = new Application_Model_RegionCityMapDataMapper();
				$regioncitymapdata = $regioncityMapper->getRegionCityMapByIds($regionids, $cityids);
				
				$neighborids = array();
				foreach($GeographicalResultByRestId['neighborIds'] as $neighborid){
					$neighborids[] = $neighborid;
				}
				
				$neighborhoodMapper = new Application_Model_NeighborhoodDataMapper();
				$neighborhoodbasedata = $neighborhoodMapper->getNeighborhoodsByneighborhoodIds($neighborids);
				
				$cuisineArr = $resService->GetCuisineTableDataByRestaurantId($resIdsArr);
				$paymentOptionsArr = $resService->GetPaymentOptionsTableDataByRestaurantId($resIdsArr);
				//$restaurantcount = $resService->GetRestaurantCountByOwnerId($user_id);
				$restauranttabledata = $resService->GetRestaurantTableDataByOwnerId($user_id);
//				foreach($resIdsArr as $resid){
//					$restauranttabledata[$resid]['cusinetabledata']	 = $cuisineArr[$resid];
//					$restauranttabledata[$resid]['paymenttabledata'] = $paymentOptionsArr[$resid];
//				}
				
				$resultRestUsers = $resService->SynchronizationOfRestaurantUsersByRestaurantid($resIdsArr);
										
				$finalArr['Status'] = true;
				$finalArr['restaurantownertabledata'] 	= $restaurantownertabledata;
				$finalArr['restaurantdata']				= $restauranttabledata;
				$finalArr['restaurantusersdata']		= $resultRestUsers["restaurantusersdata"];
				$finalArr['Initialsdata']				= $resultRestUsers["Initialsdata"];
				$finalArr['roletabledata']				= $resultRestUsers["roletabledata"];
				$finalArr['rolemaptabledata']			= $resultRestUsers["rolemaptabledata"];
				$finalArr['statebasedata'] 				= $statebasedata;
				$finalArr['regionbasedata'] 			= $regionbasedata;
				$finalArr['stateregionmapdata'] 		= $stateregionmapdata;
				$finalArr['citybasedata'] 				= $citybasedata;
				$finalArr['regioncitymapdata'] 			= $regioncitymapdata;
				$finalArr['neighborhoodbasedata'] 		= $neighborhoodbasedata;
//				$finalArr['floorplan'] 					= $floorplan;
//				$finalArr['reservations'] 				= $reservations;
				return $finalArr;
			}else{
				return $resultArr;
			}
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
}
