<?php
/**
*	Name			: User.php
*	Author			: Kartheek
*	Creation Date	: 9/30/2010
*	Path 			: application/services/User.php
*	Description		: This is the service class for the usermanagementsystem module.
*					   	
*/
class Application_Service_Client
{
	/**
	 * Instance variable of the form
	 * @var array
	 */
	protected $_form = array();
	
	/**
     * @param instance of zend form
     */
	public function setCustomerForm(Zend_Form $form)
	{
		$this->_form['Customer'] = $form;
	}

	/**
     * @return instance of form
     */
	public function getCustomerForm()
	{
		if(empty($this->_form['Customer'])) {
			$this->setCustomerForm(new User_Form_Guest());
		}
		return $this->_form['Customer'];
	}

	/**
     * @param instance of zend form
     */
	public function setEditCustomerProfileForm(Zend_Form $form)
	{
		$this->_form['EditCustomerProfile'] = $form;
	}

	/**
     * @return instance of form
     */
	public function getEditCustomerProfileForm()
	{
		if(empty($this->_form['EditCustomerProfile'])){
			$this->setEditCustomerProfileForm(new User_Form_EditCustomerProfile());
		}
		return $this->_form['EditCustomerProfile'];
	}

	/**
     * @param instance of zend form
     */
	public function setRestaurantOwnerForm(Zend_Form $form)
	{
		$this->_form['RestaurantOwner'] = $form;
	}

	/**
     * @return instance of form
     */
	public function getRestaurantOwnerForm()
	{
		if(empty($this->_form['RestaurantOwner'])) {
			$this->setRestaurantOwnerForm(new User_Form_Manager());
		}
		return $this->_form['RestaurantOwner'];
	}

	/**
     * @param instance of zend form
     */
	public function setChangePasswordForm(Zend_Form $form)
	{
		$this->_form['ChangePassword'] = $form;
	}

	/**
     * @return instance of form
     */
	public function getChangePasswordForm($data)
	{
		if(empty($this->_form['ChangePassword'])) {
			$changePwdform = new User_Form_ChangePassword();
			$formvalue = array('userid'=>$data['User_Id']);
			$changePwdform->populate($formvalue);
			$this->setChangePasswordForm($changePwdform);
		}
		return $this->_form['ChangePassword'];
	}
	
	public function setUserPasswordChangeForm(Zend_Form $form)
	{
		$this->_form['UserPasswordChange'] = $form;
	}

	/**
     * @return instance of form
     */
	public function getUserPasswordChangeForm()
	{
		if(empty($this->_form['UserPasswordChange'])) {
			$this->setUserPasswordChangeForm(new User_Form_UserPasswordChange());
		}
		return $this->_form['UserPasswordChange'];
	}
	
	/**
     * @param instance of zend form
     */
	public function setSocialMediaTypeForm(Zend_Form $form)
	{
		$this->_form['SocialMediaType'] = $form;
	}

	/**
     * @return instance of form
     */
	public function getSocialMediaTypeForm($data)
	{
		if(empty($this->_form['SocialMediaType'])){
			$socialmediatype = new User_Form_SocialMediaType();
			$formvalue = array('userid'=>$data['User_Id']);
			$socialmediatype->populate($formvalue);
			$this->setSocialMediaTypeForm($socialmediatype);
		}
		return $this->_form['SocialMediaType'];
	}

	/**
     * @param instance of zend form
     */
	public function setEditRestOwnProfile(Zend_Form $form)
	{
		return $this->_form['EditRestOwnProfile'] = $form;
	}

	/**
     * @return instance of form
     */
	public function getEditRestOwnProfile()
	{
		if(empty($this->_form['EditRestOwnProfile'])){
			$this->setEditRestOwnProfile(new User_Form_EditRestOwnFrom());
		}
		return $this->_form['EditRestOwnProfile'];
	}

	/**
     * @param instance of zend form
     */
	public function setRestaurantUserFrom(Zend_Form $form)
	{
		$this->_form['RestaurantUser'] = $form;
	}

	/**
     * @return instance of form
     */
	public function getRestaurantUserFrom()
	{
		if(empty($this->_form['RestaurantUser'])) {
			$this->setRestaurantUserFrom(new User_Form_Patron());
		}
		return $this->_form['RestaurantUser'];
	}

	/**
     * @param instance of zend form
     */
	public function setEditRestUserProfileForm(Zend_Form $form)
	{
		$this->_form['EditRestUserProfile'] = $form;
	}

	/**
     * @return instance of form
     */
	public function getEditRestUserProfileForm()
	{
		if(empty($this->_form['EditRestUserProfile'])){
			$this->setEditRestUserProfileForm(new User_Form_EditRestUserProfileFrom());
		}
		return $this->_form['EditRestUserProfile'];
	}

	/**
     * @param instance of zend form
     */
	public function setEditSocialProfileForm(Zend_Form $form)
	{
		$this->_form['EditSocialProfile'] = $form;
	}

	/**
     * @return instance of form
     */
	public function getEditSocialProfileForm()
	{
		if(empty($this->_form['EditSocialProfile'])){
			$this->setEditSocialProfileForm(new User_Form_EditSocialProfile());
		}
		return $this->_form['EditSocialProfile'];
	}
	
	public function setEditAdminUserForm(Zend_Form $form)
	{
		$this->_form['EditAdminUser'] = $form;
	}

	public function getEditAdminUserForm()
	{
		if(empty($this->_form['EditAdminUser'])) {
			$this->setEditAdminUserForm(new User_Form_EditAdminPatron());
		}
		return $this->_form['EditAdminUser'];
	}
	
	public function setAddAdminUserForm(Zend_Form $form)
	{
		$this->_form['AddAdminUser'] = $form;
	}

	public function getAddAdminUserForm()
	{
		if(empty($this->_form['AddAdminUser'])) {
			$this->setAddAdminUserForm(new User_Form_AddAdminPatron());
		}
		return $this->_form['AddAdminUser'];
	}

	/**
     * @param instance of zend form
     */
	public function setSearcgFevRestaurant(Zend_Form $form)
	{
		$this->_form['SearcgFevRestaurant'] = $form;
	}

	/**
     * @return instance of form
     */
	public function getSearcgFevRestaurant($data)
	{
		if(empty($this->_form['SearcgFevRestaurant'])){
			$searchFevRestForm = new User_Form_SearchFevRestaurant();
			$formvalue = array('userid'=>$data['User_Id']);
			$searchFevRestForm->populate($formvalue);
			$this->setSearcgFevRestaurant($searchFevRestForm);
		}
		return $this->_form['SearcgFevRestaurant'];
	}
	
	public function setSearchRestaurantUserForm(Zend_Form $form)
	{
		$this->_form['SearchRestaurantUser'] = $form;
	}

	
	public function getSearchRestaurantUserForm($data)
	{
		if(empty($this->_form['SearchRestaurantUser'])){
			$searchResUser = new User_Form_SearchRestaurantUser();
			$userid = $data['User_Id'];
				
			$mapper = new FirmManagement_Model_FirmDataMapper();
			$restObj = new FirmManagement_Model_FirmNamesByOwnerId();
			if($data['Usertype'] == "RSO"){
				$restObj->setRestOwnerId($userid);
			}else if($data['Usertype'] == "RSU" || $data['Usertype'] == "SRU"){
				$restObj->setRestId($data['RestId']);
			}else if($data['Usertype'] == "ADM" || $data['Usertype'] == "ADU"){
				$restObj->setRestOwnerId($data['restownerId']);		
			}
			$results = $mapper->getRestaurantNamesByOwnerId($restObj);
			$searchResUser->RestaurantName->addMultiOptions($results);
			$this->setSearchRestaurantUserForm($searchResUser);
		}
		return $this->_form['SearchRestaurantUser'];
	}

	/**
     * @param instance of zend form
     */
	public function setLoginForm(Zend_Form $form)
	{
		$this->_form['Login'] = $form;
	}
	
	/**
     * @return instance of form
     */
	public function getLoginForm()
	{
		if(empty($this->_form['Login'])) {
			$this->setLoginForm(new User_Form_Signin());
		}
		return $this->_form['Login'];
	}
	

	/**
	 * registration of customer
	 * 
     * @param customer registration form data
     * @return status of registration completed or not
     */	
	public function RegisterCustomer(array $data)
	{
		try{
			$form = $this->getCustomerForm();
			$stateid = null;
			$regionid = null;
			$cityid  = null;
			$regionBd  = array();
			$cityBd  = array();
			$ngbhBd = array();
           	$restService = new Application_Service_Firm();
//			if($data['state']){
//				$stateid = $data['state'];
//				$regionBd  = $restService->GetRegionByStateId_($stateid);
//			}
//			if($data['region']){
//				$regionid = $data['region'];
//				$cityBd  = $restService->GetCityByRegionId_($regionid);
//			}
//
//			if(isset($data['city'])){
//				$cityid = $data['city'];
//				$ngbhBd = $restService->GetNeighborhodByCityId_($cityid);
//			}
			
           if($data['phone'] != ''){
           		$form->countryCode->setRequired(true);
           	}
           	
			if($form->isValid($data)){

				$formData = $form->getValues();
				$date = new Zend_Date();
				$customer = new User_Model_Guest();
				$customer->setEmail(strtolower($formData['emailAddress']))
				->setPassword($formData['password'])
				->setUsertypeid(2)
				->setRole(4)
				->setRegistereddate(date('Y-m-d H:i:s'))
				->setUserstatisid(1)
				->setSalution($formData['salution'])
				->setFirstname($formData['firstName'])
				->setLastname($formData['lastName'])
//				->setGender($formData['gender'])
				->setAddress($formData['address'])
//				->setCityid($formData['city'])
//				->setRegionid($formData['region'])
//				->setStateid($formData['state'])
//				->setNeighborhoodid($formData['neighborhood'])
//				->setTimezone($formData['timezone'])
				->setPhonenumber($formData['phone'])
				->setcountryCode($formData['countryCode'])
				->setZipcode($formData['postalCode']);

				$mapper = new User_Model_GuestDataMapper();
				$customer_id = $mapper->save($customer);

				if($customer_id){
					/* For E-Mail*/
					$mailmapper = new Application_Service_Communication();
					$mailObj = new Communication_Model_Mail();
					$mailObj->setMsgCode('Customer_Confirmation');
					$name = $formData['firstName'].' '.$formData['lastName'];
					$data = array('UserName' => $name,
								  'SenTo'    => $customer->getEmail());
					$mailObj->setData($data);
					$mailStatus = $mailmapper->SendMail($mailObj);
					/*For SMS*/
					/*if(isset($formData['phone'])){
						$smsObj = new Communication_Model_Sms();
						$smsObj->setMsgCode('Customer_Confirmation');
						$data = array(
						 	'to'	=>	trim($formData['phone'])
						 );
						 $smsObj->setData($data);
						 $mailStatus = $mailmapper->SendSms($smsObj);
					}*/
					return true;
				}else{
					return false;
				}
			}else{
				$formData = $form->getValues();
				$form->populate($data);
				if($regionBd){
					$form->region->addMultiOptions($regionBd);
				}
				if($cityBd){
					$form->city->addMultiOptions($cityBd);
				}
				if($ngbhBd){
					$form->neighborhood->addMultiOptions($ngbhBd);
				}
			}
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function RegisterCustomerOnReservation($formData)
	{
		try{
			$customer = new User_Model_Guest();
			
			$usermapper = new User_Model_ClientDataMapper();
			$userStat = $usermapper->checkEmailOnReservation($formData['email']);
			if($userStat['status']){
				$length = 8;
				$characters = '0123456789abcdefghijklmnopqrstuvwxyz';
				$randomdata = "";
				for ($p = 0; $p < $length; $p++) {
					$randomdata .= $characters[mt_rand(0, strlen($characters)-1)];
				}
				$customer->setEmail(strtolower($formData['email']))
						->setPassword($randomdata)
						->setUsertypeid(2)
						->setRole(4)
						->setRegistereddate(date('Y-m-d H:i:s'))
						->setUserstatisid(1)
						->setFirstname($formData['firstName'])
						->setLastname($formData['lastName'])
						->setPhonenumber($formData['number']);
	
				$mapper = new User_Model_GuestDataMapper();
				$customer_id = $mapper->save($customer);
				if($customer_id){
					$userStat = $usermapper->checkEmailOnReservation(strtolower($formData['email']));
					/* For E-Mail*/
					$mailmapper = new Application_Service_Communication();
					$mailObj = new Communication_Model_Mail();
					$mailObj->setMsgCode('Customer_Reg_OnReservation');
					$name = $formData['firstName'].' '.$formData['lastName'];
					$data = array('UserName' => $name,
								  'SenTo'    => $customer->getEmail(),
								  'password' => $randomdata);
					$mailObj->setData($data);
					$mailStatus = $mailmapper->SendMail($mailObj);
					/*For SMS*/
					/*if(isset($formData['phone'])){
						$smsObj = new Communication_Model_Sms();
						$smsObj->setMsgCode('Customer_Confirmation');
						$data = array(
						 	'to'	=>	trim($formData['phone'])
						 );
						 $smsObj->setData($data);
						 $mailStatus = $mailmapper->SendSms($smsObj);
					}*/
					return $userStat['userId'];
				}
			}else{
//				$userDetails =  
				return $userStat['userId'];
			}
			
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * get customer information
	 * 
     * @param $data array contains login user information
     * @return the customer information
     */	
	public function GetCustomerProfileById($data)
	{
		try{
			$userid = $data['User_Id'];
			$cusProfileByIdObj= new User_Model_CustomerProfileById();
			$cusProfileByIdObj->setUserId($userid);

			$mapper= new User_Model_GuestDataMapper();
			$cusProfileResult = $mapper->getCustomerProfileById($cusProfileByIdObj);

			$formValues = array('userid'    =>  $userid,
							'emailAddress'	=>  $cusProfileResult->getEmail(),
	                        'salution'		=>	$cusProfileResult->getSalution(),
	                        'firstName'		=>	$cusProfileResult->getFirstname(),
	                        'lastName'		=>	$cusProfileResult->getLastname(),
//							'gender'		=>	$cusProfileResult->getGender(),
	                        'phone'			=>	$cusProfileResult->getPhonenumber(),
	                        'mobile'		=>	$cusProfileResult->getMobilenumber(),
	                        'address'		=>	$cusProfileResult->getAddress(),
	                        'postalCode'	=>	$cusProfileResult->getZipcode(),
	                        'favoritefood'	=>	$cusProfileResult->getFavoritefood(),
	                        'favoritemusic'	=>	$cusProfileResult->getFavoritemusic(),
//							'state'			=>	$cusProfileResult->getStateid(),
//							'timezone'		=>	$cusProfileResult->getTimezone()
			);

			$cusform = $this->getEditCustomerProfileForm();
//            $cusform->region->addMultiOptions($cusProfileResult->getRegionBd());
//			$cusform->city->addMultiOptions($cusProfileResult->getCityBd());
//			$cusform->neighborhood->addMultiOptions($cusProfileResult->getNeighborhodBd());
				
			$cusform->populate($formValues);

//			$cusform->setDefaults(array(
//				'state' 		=> $cusProfileResult->getStateid(),
//			    'region' 		=> $cusProfileResult->getregionid(),
//				'city'			=> $cusProfileResult->getCityid(),
//				'neighborhood'	=> $cusProfileResult->getNeighborhoodid(),
//
//			));
			return $cusform;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * Edit and Update customer information
	 * 
     * @param $data array contains login user information
     * @return status and form
     */		
	public function EditCustomerProfile(array $data)
	{
		try{
			$form = $this->getEditCustomerProfileForm();
			$stateid = null;
			$regionid = null;
			$cityid  = null;
			$cityBd  = array();
			$cityBd  = array();
			$ngbhBd = array();
            $restService = new Application_Service_Firm();
            	
//			if($data['state']){
//				$stateid = $data['state'];
//				$regionBd  = $restService->GetRegionByStateId_($stateid);
//			}
//			if($data['region']){
//				$regionid = $data['region'];
//				$cityBd  = $restService->GetCityByRegionId_($regionid);
//			}
//
//			if(isset($data['city'])){
//				$cityid = $data['city'];
//				$ngbhBd = $restService->GetNeighborhodByCityId_($cityid);
//			}

			if($form->isValid($data)){

				$formData = $form->getValues();
				$customer = new User_Model_Guest();

				$customer->setId((int)$form->getValue('userid'));
				$customer->setEmail(strtolower($formData['emailAddress']));
				$customer->setSalution($formData['salution']);
				$customer->setFirstname($formData['firstName']);
				$customer->setLastname($formData['lastName']);
//				$customer->setGender($formData['gender']);
				$customer->setPhonenumber($formData['phone']);
//				$customer->setMobilenumber($formData['mobile']);
				$customer->setAddress($formData['address']);
//				$customer->setRegionid($formData['region']);
//				$customer->setCityid($formData['city']);
//				$customer->setNeighborhoodid($formData['neighborhood']);
//				$customer->setStateid($formData['state']);
				$customer->setZipcode($formData['postalCode']);
//				$customer->setTimezone($formData['timezone']);
				$customer->setFavoritefood($formData['favoritefood']);
				$customer->setFavoritemusic($formData['favoritemusic']);

				$mapper = new User_Model_GuestDataMapper();
				$status = $mapper->update($customer);
				if($status){
					$form->populate($data);
//					if($regionBd)
//					{		
//						$form->region->addMultiOptions($regionBd);
//					}
//					if($cityBd){
//							
//						$form->city->addMultiOptions($cityBd);
//					}
//					if($ngbhBd){
//						$form->neighborhood->addMultiOptions($ngbhBd);
//					}
						
					$result = array('status'=>true,'form'=>$form);
					return $result;
				}
			}else{
				$formData = $form->getValues();
				$form->populate($data);
//				if($regionBd){
//							
//						$form->region->addMultiOptions($regionBd);
//					}
				if($cityBd){

					$form->city->addMultiOptions($cityBd);
				}
				if($ngbhBd){
					$form->neighborhood->addMultiOptions($ngbhBd);
				}

				$result = array('status'=>false,'form'=>$form);
				return $result;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	

	/* Edit Admin user profile*/
	
	public function EditAdminUserProfile(array $data,$request)
	{
		try{
			$form = $this->getEditAdminUserForm();
			if($data['editcompany']){
				$roleObj = new Application_Model_Role();
				$roleObj->setCompanyId($data['editcompany']);
				$roleObj->setStatus('TRUE');
           	
				$mapper = new Application_Model_RoleDataMapper();
				$RolesList = $mapper->getRolesByCompany($roleObj);
           	}
			
			if($form->isValid($data)){

				$formData = $form->getValues();
				$adminuser = new User_Model_AdminPatron();
				
				$adminuser->setUserId($data['id']);			  					  
				$adminuser->setadu_firstname($data['editfirstName']);
				$adminuser->setadu_lastname($data['editlastName']);
				$adminuser->setadu_company_id($data['editcompany']);
				
				if($data['editcompany'] == 1){
					$adminuser->setRole(1);
				}else{
					$adminuser->setRole($data['editadminUserRole']);
				}
								
				$mapper = new User_Model_AdminPatronDataMapper();
				$status = $mapper->update($adminuser);				
				if($status){					
					$result = array('status'=>true);
					return $result;
				}
			}else{
				$formData = $form->getValues();
				$form->populate($data);
				if($RolesList){
					$form->editadminUserRole->addMultiOptions($RolesList);
				}
				
				$result = array('status'=>false,'form'=>$form);
				return $result;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	

	/**
	 * change the password of user account
	 * 
     * @param $data array contains login user information.
     */	
	public function changePassword(array $data)
	{
		try{
			$form = $this->getChangePasswordForm($data);

			if($form->isValid($data)){
				$userid = $form->getValue('userid');
				$formData = $form->getValues();
				$userPwdByIdObj= new User_Model_UserPwdById();
				$userPwdByIdObj->setUserId($userid);

				$user = new User_Model_Client();
				$user->setPassword($formData['password'])
				->setOldpassword($formData['oldpassword']);

				$mapper = new User_Model_ClientDataMapper();
				$resultset = $mapper->updatePassword($user,$userPwdByIdObj);

				if($resultset == true){
					$msg = "Password updated successfully.";
					$result = array('status'=>true,'msg'=>$msg);
				}else if($resultset == false){
					$msg = "In Valid password supplied.";
					$result = array('status'=>true,'msg'=>$msg);
				}
				return $result;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function changeUserPassword(array $data)
	{
		try{
			$form = $this->getUserPasswordChangeForm();
			$result = array();
			if($form->isValid($data)){
				$userid = $form->getValue('userid');
		//		$userid = $data['userid'];
				$formData = $form->getValues();
				$userPwdByIdObj= new User_Model_UserPwdById();
				$userPwdByIdObj->setUserId($userid);

				$user = new User_Model_Client();
				$user->setPassPhrase($formData['passphrase'])
					 ->setPassword($formData['password']);

				$mapper = new User_Model_ClientDataMapper();
				$resultset = $mapper->updatePassword($user,$userPwdByIdObj);

				if($resultset == true){
					$msg = "Password updated successfully.";
					$result = array('status'=>true,'msg'=>$msg);
				}else if($resultset == false){
					$msg = "In Valid Verification Code.";
					$result = array('status'=>false,'msg'=>$msg,'userid'=>$userid);
				}
				return $result;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * registration of Restaurant Owner
	 * 
     * @param owner registration form data
     * @return status of registration completed or not
     */
	public function RegisterRestaurantOwner(array $data,$source = 'DD')
	{
		try{
			$form = $this->getRestaurantOwnerForm();
			$stateid = null;
			$regionid = null;
			$cityid  = null;
                        $regorigin = null;
			$regionBd  = array();
			$cityBd  = array();
			$ngbhBd = array();
			$restService = new Application_Service_Firm();
						
			if($form->isValid($data)){
				$storage = new Zend_Auth_Storage_Session();
				$userdata = $storage->read();
				
				$formData = $form->getValues();

				$restaurantowner= new User_Model_Manager();

				$restaurantowner->setFristName($formData['firstName'])
				->setLastName($formData['lastName'])
				->setEmail(strtolower($formData['emailAddress']))
				->setPassword($formData['password'])
				->setUsertypeid(3)
				->setRole(2)
				->setRegistereddate(date('Y-m-d H:i:s'))				
				->setRestaurantname($formData['restaurantName'])
				->setPhonenumber($formData['phone'])
				->setCountryCode($formData['countryCode'])	
				->setcountry($formData['resownercountry'])
				->setcity($formData['resownercity'])
				->setzipCode($formData['resownerzipcode'])
				->setSourceid($formData['source'])
				->setWebsite($formData['website'])
				->setSourcedescription($formData['sourcedescription'])
				->setDescription($formData['description'])
				->setDateofbirth($formData['dateofbirth']);
				
				if($userdata['Usertype'] == "ADM" || $userdata['Usertype'] == "ADU" || $source == 'WIX'){
					$restaurantowner->setUserstatisid(1);
                                        $regorigin = 'Admin Console';
				}else{                                    
					$restaurantowner->setUserstatisid(3);
                                        $regorigin = 'Main Registration Page';
				}
				
				if(isset($userdata['companyid'])){
					$restaurantowner->setCompanyid($userdata['companyid']);
				}else{
					$restaurantowner->setCompanyid(1);
				}

				$mapper = new User_Model_ManagerDataMapper();
				$res_own_id = $mapper->save($restaurantowner,$source);
//				return  $res_own_id;
				if($res_own_id){
					$mailmapper = new Application_Service_Communication();
					/* for E-mail*/
					$mailObjToUser = new Communication_Model_Mail();
					$mailObjToUser->setMsgCode('ResOwnConf');
					$name 		= $formData['firstName'].' '.$formData['lastName'];		
					$data = array('name'=> $name,
								  'restname'=> $formData['restaurantName'],
								  'phone'	=> $formData['countryCode'].$formData['phone'],
								  'email'	=> strtolower($formData['emailAddress']),
								 // 'state'	=> $state,
								 // 'city'	=> $city,
								 // 'userid'	=> $formData['userid'],
								  //'approval'=> $approval,
                                  'uId'         => $res_own_id,
								  //'disapproval'=>$disapproval,
								  //'state'	=> $formData['resownercountry'],
								  //'city'	=> $formData['resownercity'],
								  'desc'	=> $formData['description'],
								  'SenTo'	=> strtolower($formData['emailAddress']))
					;
					$mailObjToUser->setData($data);
					$mailStatus = $mailmapper->SendMail($mailObjToUser);
					$mailObjToAdmin = new Communication_Model_Mail();
					/**SEND ADMIN A MAIL**/
					$mailObjToAdmin->setMsgCode('New Registration email');
					$name 		= $formData['firstName'].' '.$formData['lastName'];
					$data = array('name'=> $name,
								  'restname'=> $formData['restaurantName'],
								  'phone'	=> $formData['countryCode'].$formData['phone'],
								  'email'	=> strtolower($formData['emailAddress']),
								  'state'	=> $state,
								  'city'	=> $city,
								  'userid'	=> $formData['userid'],
								  'approval'=> $approval,
                            					  'uId'         => $res_own_id,
								  'disapproval'=>$disapproval,
								  'state'	=> $formData['resownercountry'],
								  'city'	=> $formData['resownercity'],
								  'desc'	=> $formData['description'],
                                                                  'origin'      => $regorigin
                                                        );
					$mailObjToAdmin->setData($data);
					$mailStatus = $mailmapper->SendMail($mailObjToAdmin);
				
					$result = array('status'=>true,'userid'=>$res_own_id);
					if($source == 'DD'){
						return $result;
					}else{
						return array('status'=>true,'result'=>$res_own_id);
					}
				}
			}else{
				$formData = $form->getValues();
				$form->populate($data);
				$result = array('status'=>false,'form'=>$form);
				return $result;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * get restaurant owner profile information
	 * 
     * @param $data array contains login user information
     * @return  restaurantowner details
     */	
	public function GetRestOwnProfileById($data)
	{
		try{
			if($data['Usertype'] == "ADM" || $data['Usertype'] == "ADU"){
				$userid = $data['restownerId'];
			}else{
				$userid = $data['User_Id'];
			}
			$resOwnProByIdObj = new User_Model_ResOwnProfileById();
			$resOwnProByIdObj->setUserId($userid);

			$mapper = new User_Model_ManagerDataMapper();
			$resOwnprofile = $mapper->getRestOwnProfileById($resOwnProByIdObj);
			
			$formValues = array('userid' =>$userid,
    					'firstName'			=> $resOwnprofile->getFirstName(),
						'lastName'			=> $resOwnprofile->getLastName(),
						'restaurantName' 	=> $resOwnprofile->getRestaurantname(),
                        'phone' 			=> $resOwnprofile->getPhonenumber(),
						'state'				=> $resOwnprofile->getStateid(),
						'region'			=> $resOwnprofile->getRegionid(),
						'city'				=> $resOwnprofile->getCityid(),
						'description'		=> $resOwnprofile->getDescription(),
						'rescodetext'		=> $resOwnprofile->getCountryCode(),
						'techfirstName'		=> $resOwnprofile->getTechfirstName(),
						'bilfirstName'		=> $resOwnprofile->getBilfirstName(),
						'techlastName'		=> $resOwnprofile->getTechlastname(),
						'billastName'		=> $resOwnprofile->getBillastname(),
						'techrescodetext'	=> $resOwnprofile->getTechcountrycode(),
						'bilrescodetext'	=> $resOwnprofile->getBilcountrycode(),
						'techphone'			=> $resOwnprofile->getTechphone(),
						'bilphone'			=> $resOwnprofile->getBilphone(),
						'bilemail'			=> $resOwnprofile->getBilemail(),
						'techemail'			=> $resOwnprofile->getTechemail()
						);
		
			$restform = $this->getEditRestOwnProfile();
			if($resOwnprofile->getCityBd()){
				$restform->city->addMultiOptions($resOwnprofile->getCityBd());
				$restform->region->addMultiOptions($resOwnprofile->getRegionBd());
				$restform->setDefaults(array(
					'state' => $resOwnprofile->getStateid(),
					'region'=> $resOwnprofile->getRegionid(),
					'city'	=> $resOwnprofile->getCityid()				
				));
			}
			$restform->populate($formValues);
			
			return $restform;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * Edit and Update restaurantowner information
	 * 
     * @param $data array contains login user information
     * @return status and form
     */

	public function EditRestOwnProfile(array $data)
	{
		try{
			$form = $this->getEditRestOwnProfile();
			$stateid = null;
			$regionid= null;
			$regionBd= array();
			$cityBd  = array();

			if($data['state']){
				$stateid = $data['state'];
				$regionBd  = $this->GetRegionByStateId($stateid);
			}
			if($data['region']){
				$regionid = $data['region'];
				$cityBd   = $this->GetCityByRegionId($regionid);
			}
			
			if($form->isValid($data)){
				$formData = $form->getValues();

				$restOwn = new User_Model_Manager();
				$restOwn->setId((int)$form->getValue('userid'));
				$restOwn->setFristName(trim($formData['firstName']));
				$restOwn->setLastName(trim($formData['lastName']));
				$restOwn->setRestaurantname(trim($formData['restaurantName']));
				$restOwn->setPhonenumber(trim($formData['phone']));
				$restOwn->setStateid($formData['state']);
				$restOwn->setRegionid($formData['region']);
				$restOwn->setCityid($formData['city']);
				$restOwn->setDescription($formData['description']);
				$restOwn->setCountryCode($formData['rescodetext']);
				$restOwn->setTechfirstName($formData['techfirstName']);
				$restOwn->setTechlastname($formData['techlastName']);
				$restOwn->setTechemail($formData['techemail']);
				$restOwn->setTechphone($formData['techphone']);
				$restOwn->setTechcountrycode($formData['bilrescodetext']);
				$restOwn->setBilfirstName($formData['bilfirstName']);
				$restOwn->setBillastname($formData['billastName']);
				$restOwn->setbilemail($formData['bilemail']);
				$restOwn->setBilphone($formData['bilphone']);
				$restOwn->setBilcountrycode($formData['bilrescodetext']);

				$mapper = new User_Model_ManagerDataMapper();
				$status = $mapper->update($restOwn);
				if($status){
					$form->populate($data);
					if($regionBd){
						$form->region->addMultiOptions($regionBd);
					}
					if($cityBd){
						$form->city->addMultiOptions($cityBd);
					}
					$result = array('status'=>true,'form'=>$form);
				}
				return $result;
			}else{
				$formData = $form->getValues();
				$form->populate($data);
				if($regionBd){
					$form->region->addMultiOptions($regionBd);
				}
				if($cityBd){
					$form->city->addMultiOptions($cityBd);
				}
				$result = array('status'=>false,'form'=>$form);
				return $result;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * registration of RestaurantUser
	 * 
     * @param Restaurantuser registration form data and suserdata
     * @return status of registration completed or not
     */	
	public function RegisterRestaurantUser(array $data,$userData)
	{
		try{
			$form = $this->getRestaurantUserFrom();
//			if($data['phone']){
//				$form->countryCode->setRequired(true);
//			}else{
//				$form->countryCode->setValue('');
//			}
			if($form->isValid($data)){
				$formData = $form->getValues();
				/*  retreiving user type */
				$userType[] = 'RSU';
				$userMapper = new Application_Model_UsertypeDataMapper();
				$userList = $userMapper->GetUserTypeByCode($userType);
				$userTypeList = $userList['RSU'];
				/*  retreiving user type */

				$restaurantuser = new User_Model_Patron();
				$restaurantuser->setEmail(strtolower($formData['emailAddress']))
				->setPassword($formData['password'])
				->setUsertypeid($userTypeList->getId())
				->setRole($formData['restUserRoles'])
				->setRegistereddate(date('Y-m-d H:i:s'))
				->setUserstatisid(1)
				->setRestaurantid($formData['RestaurantName'])
				->setSalution($formData['salution'])
				->setFirstname($formData['firstName'])
				->setLastname($formData['lastName'])
				->setGender($formData['gender'])
				->setAddress($formData['address'])
				->setcountryCode($formData['countryCode'])
				->setPhonenumber($formData['phone'])
				->setMobilenumber($formData['mobile'])
				->setDesignation($formData['designation']);

				$mapper = new User_Model_PatronDataMapper();
				$res_user_id = $mapper->save($restaurantuser);
				if($res_user_id){
					$result = array('status'=>true,'form'=>$form);
					return $result;
				}else{
					return false;
				}
			}else{
				$formData = $form->getValues();
				$resServ = new Application_Service_Firm();
				if($formData['RestaurantName'] && $formData['restUserRoles']){
					$resid = $formData['RestaurantName'];
					$roles = $resServ->getRolesByRestId($resid);
					$roleList = "";
					if($roles){
						foreach($roles as $role){
							$roleList[] = array('key'=>$role['roleid'],'value'=>$role['rolecode']);
						}
					}else{
						$rolesbyRol = $resServ->getRolesByRoleId($formData['restUserRoles']);
						$roleList[] = array('key'=>$rolesbyRol['roleid'],'value'=>$rolesbyRol['roleCode']);
					}
					$resNameList = $resServ->GetRestNameById($userData);
					$form->RestaurantName->addMultiOptions($resNameList);
					$form->restUserRoles->addMultiOptions($roleList);
					$form->setDefaults(array(
						'RestaurantName'		=>	$resid,
						'restUserRoles'		=>	$formData['restUserRoles']
						));
				}else{
					$resNameList = $resServ->GetRestNameById($userData);
					$form->RestaurantName->addMultiOptions($resNameList);
				}
				$form->populate($formData);
				
				
				$result = array('status'=>false,'form'=>$form);
				return $result;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function RegisterRestaurantUserFromNativeApp($request)
	{
		try{
			if($request->restuserdetails)
			{
				$restuserdetails = json_decode($request->restuserdetails);
				
				$emailObj = new User_Model_Signin();
				$emailObj->setEmailAddress(strtolower(trim($restuserdetails->usremail)));
				$result = $this->CheckEmailAvaliable($emailObj);
				if($result){
					return 'false';
				}else{
					/*  retreiving user type */
					$userType[] = 'RSU';
					$userMapper = new Application_Model_UsertypeDataMapper();
					$userList = $userMapper->GetUserTypeByCode($userType);
					$userTypeList = $userList['RSU'];
					/*  retreiving user type */
	
					$restaurantuser = new User_Model_Patron();
					$restaurantuser->setEmail(strtolower($restuserdetails->usremail))
					->setPassword($restuserdetails->usrpassword)
					->setUsertypeid($userTypeList->getId())
					->setRole($restuserdetails->usrrole_id)
					->setRegistereddate(date('Y-m-d H:i:s'))
					->setUserstatisid($restuserdetails->usruser_status_id)
					->setRestaurantid($restuserdetails->rsufk_restaurant)
					->setSalution($restuserdetails->rsusalution)
					->setFirstname($restuserdetails->rsufirst_name)
					->setLastname($restuserdetails->rsulast_name)
					->setGender($restuserdetails->rsugender)
					->setAddress($restuserdetails->rsuaddress)
					->setPhonenumber($restuserdetails->rsuphone)
					->setMobilenumber($restuserdetails->rsumobile)
					->setDesignation($restuserdetails->rsudesignation);
					
					$mapper = new User_Model_PatronDataMapper();
					$resultArr = $mapper->RegisterRestaurantUserFromNativeApp($restaurantuser);
					return $resultArr;
				}
			}
			else{
				return 'false';
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	/**
	 * get restaurantusers
	 * 
     * @param $data array contains login user information and $userid
     * @return  restaurantuser List
     */	
	public function GetRestusersById(array $data,$userid,$offset)
	{
		try{
			$restUserProById = new User_Model_RestUserProById();
			$restUserProById->setUserId($userid);
			$restaurantUsers = new User_Model_SearchRestaurantUsers();
			if($data){
				if(isset($data['RestaurantName']) != NULL)
				{
					$restaurantUsers->setRestaurantId($data['RestaurantName']);
				}
				if(isset($data['username']) != NULL )
				{
					$restaurantUsers->setUserName($data['username']);
				}
				if(isset($data['emailAddress']) != NULL){
					$restaurantUsers->setEmail($data['emailAddress']);
				}
				if(isset($data['status']) != '0')
				{
					$restaurantUsers->setStatusId($data['status']);
				}
			}
			$restaurantUsers->setUserId($userid);
			$mapper = new User_Model_PatronDataMapper();
			$RestUserslist= $mapper->getRestusersById($restaurantUsers,$offset);

			return $RestUserslist;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * get restaurantuser profile information
	 * 
     * @param $data array contains login user information
     * @return  restaurantuser details
     */	
	public function GetRestuserProfileById($request,$data)
	{
		try{
			$userid = $request->userid;
			$restUserProById = new User_Model_RestUserProById();
			$restUserProById->setUserId($userid);

			$mapper = new User_Model_PatronDataMapper();
			$RestUserProfile= $mapper->getRestuserProById($restUserProById);
			$resServ = new Application_Service_Firm();
			$resid = $RestUserProfile->getRestId();
			$roles = $resServ->getRolesByRestId($resid);
			$roleList = "";
			if($roles){
				foreach($roles as $role){
					$roleList[] = array('key'=>$role['roleid'],'value'=>$role['rolecode']);
				}
			}else{
				$rolesbyRol = $resServ->getRolesByRoleId($RestUserProfile->getRestUserRoleId());
				$roleList[] = array('key'=>$rolesbyRol['roleid'],'value'=>$rolesbyRol['roleCode']);
			}
				
				
			$formValues = array(
	    			'userid' 		 		=> $userid,
	    			'salution'		 		=>	$RestUserProfile->getSalution(),
	    			'phone'					=>	$RestUserProfile->getPhonenumber(),
	    			'mobile'		 		=>	$RestUserProfile->getMobilenumber(),
	    			'address'		 		=>	$RestUserProfile->getAddress(),
	    			'firstName' 	 		=>	$RestUserProfile->getFirstname(),
	    			'lastName'	     		=>	$RestUserProfile->getLastname(),
					'gender'		 		=>	$RestUserProfile->getGender(),
					'designation'	 		=>	$RestUserProfile->getDesignation(),
					'role'			 		=>	$RestUserProfile->getRestUserRole(),
	    			'EditRestaurantName'	=>	$RestUserProfile->getRestaurantName(),
	    			'emailAddress'	 		=>	$RestUserProfile->getEmail(),
					'initial'	 	 		=>	$RestUserProfile->getUserInitial(),
					'status'		 		=>	$RestUserProfile->getUserStatusid(),
					'countryCode'	 		=>	$RestUserProfile->getCountryCode()
			);
			$resNameList = $resServ->GetRestNameById($data);
			$restuserform = $this->getEditRestUserProfileForm();
			$restuserform->RestaurantRole->addMultiOptions($roleList);
			$restuserform->EditRestaurantName->addMultiOptions($resNameList);
			$restuserform->populate($formValues);
			$restuserform->setDefaults(array(
				'EditRestaurantName'		=>	$resid,
				'RestaurantRole'		=>	$RestUserProfile->getRestUserRoleId()
			));
			return $restuserform;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function editUserDetailsByRole(array $data,$userData,$request)
	{
		try{
			$form = $this->getEditRestUserProfileForm();
			if($data['EditrestUsersType'] == 'RSU'){
				$form->EditRestaurantName->setRequired(false);
			}
			if($form->isValid($data)){
				$formData = $form->getValues();
				$restuser = new User_Model_Patron();

				$userType[] = $formData['EditrestUsersType'];
				$userMapper = new Application_Model_UsertypeDataMapper();
				$userList = $userMapper->GetUserTypeByCode($userType);
				$userTypeList = $userList[$formData['EditrestUsersType']];
				
				$restuser->setId($request->userid);
				$restuser->setEmail(strtolower($formData['emailAddress']));
				$restuser->setRestaurantName($formData['EditRestaurantName']);
				$restuser->setSalution($formData['salution']);
				$restuser->setUserstatisid($formData['status']);
				$restuser->setFirstname($formData['firstName']);
				$restuser->setLastname($formData['lastName']);
				$restuser->setGender($formData['gender']);
//				$restuser->setPhonenumber($formData['phone']);
//				$restuser->setCountryCode($formData['countryCode']);
				$restuser->setMobilenumber($formData['mobile']);
				$restuser->setAddress($formData['address']);
				$restuser->setDesignation($formData['designation']);
				$restuser->setRestUserRole($formData['RestaurantRole']);
				$restuser->setRestUserRoleId($formData['RestaurantRole']);
				$restuser->setUserType($formData['EditrestUsersType']);
				$restuser->setUsertypeid($userTypeList->getId());
				$restuser->setRestaurantid($userData['RestId']);
				$restuser->setUserid($userData['User_Id']);
//				$restuser->setUserInitial($formData['initial']);
				if($formData['password']){
					$restuser->setPassword($formData['password']);
				}		

				$mapper = new User_Model_PatronDataMapper();
				$status = $mapper->update($restuser);
				if($status){
					$result = array('status'=>$userTypeList->getId(),'form'=>$form);
				}
				return $result;
			}else{
				return false;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function addRestUserByRole(array $data,$userData,$request)
	{
		try{
			$form = $this->getRestaurantUserFrom();
			if($data['restUsersType'] == 'RSU'){
				$form->restUsersType->setRequired(false);
				$form->RestaurantNameSel->setRequired(false);
			}
			if($form->isValid($data)){
				$formData = $form->getValues();
				/*  retreiving user type */
				$userType[] = $formData['restUsersType'];
				$userMapper = new Application_Model_UsertypeDataMapper();
				$userList = $userMapper->GetUserTypeByCode($userType);
				$userTypeList = $userList[$formData['restUsersType']];
				/*  retreiving user type */
        
				$restaurantuser = new User_Model_Patron();
				$restaurantuser->setEmail(strtolower($formData['emailAddress']))
				->setPassword($formData['password'])
				->setUsertypeid($userTypeList->getId())
				->setRole($formData['restUserRoles'])
				->setRegistereddate(date('Y-m-d H:i:s'))
				->setUserstatisid(1)
				->setRestaurantid($formData['RestaurantNameSel'])
				->setSalution($formData['salution'])
				->setFirstname($formData['firstName'])
				->setLastname($formData['lastName'])
				->setGender($formData['gender'])
				->setAddress($formData['address'])
//				->setcountryCode($formData['countryCode'])
//				->setPhonenumber($formData['phone'])
				->setMobilenumber($formData['mobile'])
				->setDesignation($formData['designation'])
				->setUserType($formData['restUsersType']);
        
				$mapper = new User_Model_PatronDataMapper();
				$res_user_id = $mapper->save($restaurantuser);
				if($res_user_id){
					$result = array('status'=>true,'form'=>$form);
					return $result;
				}else{
					return false;
				}
			}else{
				return false;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * Edit and Update restaurantuser information
	 * 
     * @param $data array contains login user information and userdata
     * @return status and form
     */

	public function EditUser(array $data,$userData)
	{
		try{
			$form = $this->getEditRestUserProfileForm();
			
			if($form->isValid($data)){
				$formData = $form->getValues();
				$restuser = new User_Model_Patron();

				$restuser->setId((int)$form->getValue('userid'));
				$restuser->setEmail(strtolower($formData['emailAddress']));
				$restuser->setRestaurantName($formData['EditRestaurantName']);
				$restuser->setSalution($formData['salution']);
				$restuser->setUserstatisid($formData['status']);
				$restuser->setFirstname($formData['firstName']);
				$restuser->setLastname($formData['lastName']);
				$restuser->setGender($formData['gender']);
				$restuser->setPhonenumber($formData['phone']);
				$restuser->setCountryCode($formData['countryCode']);
				$restuser->setMobilenumber($formData['mobile']);
				$restuser->setAddress($formData['address']);
				$restuser->setDesignation($formData['designation']);
				$restuser->setRestUserRole($formData['role']);
				$restuser->setRestUserRoleId($formData['RestaurantRole']);
				$restuser->setUserInitial($formData['initial']);
				if($formData['password']){
					$restuser->setPassword($formData['password']);
				}		

				$mapper = new User_Model_PatronDataMapper();
				$status = $mapper->update($restuser);
				if($status){
					$result = array('status'=>true,'form'=>$form);
				}
				return $result;
			}else{
				$formData = $form->getValues();
				$resServ = new Application_Service_Firm();
				if($formData['EditRestaurantName'] && $formData['RestaurantRole']){
					$resid = $formData['EditRestaurantName'];
					$roles = $resServ->getRolesByRestId($resid);
					$roleList = "";
					if($roles){
						foreach($roles as $role){
							$roleList[] = array('key'=>$role['roleid'],'value'=>$role['rolecode']);
						}
					}else{
						$rolesbyRol = $resServ->getRolesByRoleId($formData['RestaurantRole']);
						$roleList[] = array('key'=>$rolesbyRol['roleid'],'value'=>$rolesbyRol['roleCode']);
					}
					$resNameList = $resServ->GetRestNameById($userData);
					$form->RestaurantRole->addMultiOptions($roleList);
					$form->EditRestaurantName->addMultiOptions($resNameList);
					$form->setDefaults(array(
						'EditRestaurantName'		=>	$resid,
						'RestaurantRole'		=>	$formData['RestaurantRole']
						));
				}else{
					$resNameList = $resServ->GetRestNameById($userData);
					$form->EditRestaurantName->addMultiOptions($resNameList);
				}
				$form->populate($formData);
				
				
				$result = array('status'=>false,'form'=>$form);
				return $result;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function EditRestaurantUserFromNativeApp($request)
	{
		try{
			if($request->restuserdetails)
			{
				$restuserdetails = json_decode($request->restuserdetails);
				
				$restuser = new User_Model_Patron();
				$restuser->setEmail(strtolower($restuserdetails->usremail))
				->setPassword($restuserdetails->usrpassword)
				->setRestUserRoleId($restuserdetails->usrrole_id)
				->setRegistereddate(date('Y-m-d H:i:s'))
				->setUserstatisid($restuserdetails->usruser_status_id)
				->setRestaurantid($restuserdetails->rsufk_restaurant)
				->setRestaurantName($restuserdetails->rsufk_restaurant)
				->setSalution($restuserdetails->rsusalution)
				->setFirstname($restuserdetails->rsufirst_name)
				->setLastname($restuserdetails->rsulast_name)
				->setGender($restuserdetails->rsugender)
				->setAddress($restuserdetails->rsuaddress)
				->setPhonenumber($restuserdetails->rsuphone)
				->setMobilenumber($restuserdetails->rsumobile)
				->setDesignation($restuserdetails->rsudesignation)
				->setId($restuserdetails->usrid)
				->setUserInitial($restuserdetails->rsui_initial);
				
				$mapper = new User_Model_PatronDataMapper();
				$status = $mapper->update($restuser);
				if($status)
				{
					return 'true';
				}else
				{
				return 'false';
				}
			}
			else{
				return 'false';
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function changeRestUserStatus($request)
	{
		$userid = $request->userid;
		$code = $request->status;
		$mapper = new User_Model_ClientDataMapper();
		$result = $mapper->UpdateCustomerStatus($userid, $code);
		return $result;
	}
	
	public function changeRestUserStatusFromNativeApp($request)
	{		
		if($request->restuserdetails)
		{
			$restuserdetails = json_decode($request->restuserdetails);
		
			$userid = $restuserdetails->userid;
			$code = $restuserdetails->status;
			
			$mapper = new User_Model_ClientDataMapper();
			$result = $mapper->UpdateCustomerStatus($userid, $code);
			return $result;
		}
	}

	/*public function delRestUser($userstatus,$request)
	 {
		$userid = $request->userid;
		$mapper = new User_Model_ClientDataMapper();
		$data = array('usruser_status_id'=>$userstatus);
		$mapper->getDbTable()->update($data,array('usrid = ?'=>$userid));

		}*/

	/**
	 * @param  $data array contains login user information
	 * retreive all restaurant names by give data
	 */
	public function GetRestaurantNames($data)
	{
		try{
			$restService = new Application_Service_Firm();
			$result = $restService->getRestaurantNamesByOwnerId($data);
			$form = $this->getRestaurantUserFrom();
			$form->RestaurantName->addMultiOptions($result);
			return $form;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param  $data array contains login user information
	 * save socialmedia details to the customer 
	 */
	public function socialMedia(array $data)
	{
		try{
			$form = $this->getSocialMediaTypeForm($data);
			if($form->isValid($data)){
				$userid = $form->getValue('userid');
				$formData = $form->getValues();

				$socialmedia = new User_Model_SocialProfile();

				$socialmedia->setCustomerid($userid)
				->setEmailid($formData['emailAddress'])
				->setMediatype($formData['socialmedia'])
				->setCreatedon(date('Y-m-d H:i:s'))
				->setUserstatisid(1);
				$mapper = new User_Model_SocialProfileMapper();
				$status = $mapper->save($socialmedia);
				if($status){
					$result['success'] = true;
				}else{
					$result['exist'] = true;
				}
				return $result;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param  $data array contains login user information and offset
	 * retreive socialmedia profiles of customer
	 */
	public function cusSocialProfile($data,$offset)
	{
		try{
			$userid = $data['User_Id'];
			$socialProByIdObj= new User_Model_SocilProfileById();
			$socialProByIdObj->setUserId($userid);

			$mapper = new User_Model_GuestDataMapper();
			$socialProfObj = $mapper->userMediaProfile($socialProByIdObj,$offset);
			return $socialProfObj;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param  $data conatins socialmedia id
	 * retreive socialmedia deatils by id
	 */
	public function getSocialprofileById($data)
	{
		try{
			$cspid = $data->cspid;
			$cspByIdObj = new User_Model_UpdateSocialProById();
			$cspByIdObj->setId($cspid);

			$mapper = new User_Model_GuestDataMapper();
			$result = $mapper->socialMediaProfileById($cspByIdObj);
			$formValues = array(
						'cspid'		   => $cspid,	
						'emailAddress' => $result->getEmailid(),
						'socialmedia'  => $result->getStatus()
			);

			$resultform = $this->getEditSocialProfileForm();
			$resultform->populate($formValues);
			return $resultform;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param $request object and userid
	 * edit and update the socialmedia id of the customer
	 */
	public function EditSocialProfile($request,$userid)
	{
		try{
			$form = $this->getEditSocialProfileForm();

			$formData = $form->getValues();

			$usersocailpro = new User_Model_SocialProfile();
			$usersocailpro->setCustomerid($userid);
			$usersocailpro->setId($request->profid);
			$usersocailpro->setEmailid(strtolower($request->email));
			$usersocailpro->setMediatype($request->proftypeid);
			$mapper = new User_Model_SocialProfileMapper();
			$status = $mapper->update($usersocailpro);
			if($status){
				return true;
			}else{
				return false;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param $request object and status of customersocialmedia
	 * delete socialmedia id of the customer
	 */
	public function delSocilaProfile($cspstatus, $request)
	{
		try{
			$cspid = $request->cspid;
			$mapper = new User_Model_SocialProfileMapper();
			$data = array('cspstatus'=>$cspstatus);
			$mapper->getDbTable()->update($data,array('cspid = ?'=>$cspid));
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param $data , userid and offset 
	 * retreive restaurants by userid 
	 */
	public function GetRestaurants(array $data, $userid, $offset)
	{
		try{
			$form = $this->getSearcgFevRestaurant($data);
			$restService = new Application_Service_Firm();
			$restList = $restService->geRestaurantNamesByData($data, $userid, $offset);
			return $restList;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * @param $request object and $data
	 * retreive customer favorite restaurantIds
	 */
	public function getFevRestIds($request, array $data)
	{
		try{
			$form = $this->getSearcgFevRestaurant($data);
			if($form->isValid($data)){
				$userid = $data['User_Id'];
				$Obj= new User_Model_FevRestById();
				$Obj->setUserId($userid);

				if($request->favorite){
					$cusList = array();
					foreach($request->favorite as 	$value){
						$restids = new User_Model_CustomerRestChoice();
						$restids->setRestId($value);
						$cusList[] = $restids;
					}

					$mapper = new User_Model_CustomerRestChoiceDataMapper();
					$status = $mapper->save($cusList,$Obj);
					return $status;
				}
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param $data and pageid
	 * retreive customer favorite restaurants
	 */
	public function CusFevRestaurants($data,$page)
	{
		try{
			$userid = $data['User_Id'];
			$Obj= new User_Model_FevRestById();
			$Obj->setUserId($userid);

			$mapper = new User_Model_CustomerRestChoiceDataMapper();
			$list  = $mapper->CusFevRestauarants($Obj,$page);
			return $list;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param $data and pageid
	 * retreive customer favorite restaurants
	 */
	public function GetRestaurantInfoByCusId($data,$page)
	{
		try{
			$userid = $data['User_Id'];
			$email = $data['Email'];
			$phone = $data['Phone'];
			$Obj= new User_Model_FevRestById();
			$Obj->setUserId($userid);

			$mapper = new Reservation_Model_ReservationDataMapper();
			$list  = $mapper->GetRestInfoByCusId($Obj,$page,$email,$phone);
			return $list;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param $data and userid
	 * retreive restaurant users
	 */
	public function getRestaurantUsers(array $data,$userId)
	{
		try{
			$form = $this->getSearchRestaurantUserForm($data);
			$mapper =  new User_Model_PatronDataMapper();
			$restaurantUsers = new User_Model_SearchRestaurantUsers();
			if($data['username'] != NULL )
			{
				$restaurantUsers->setUserName($data['username']);
			}
			if($data[emailAddress] != NULL){
				$restaurantUsers->setEmail($data['emailAddress']);
			}
			$mapper->getRestaurantUsersBySearch($restaurantUsers,$userId);
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getRestaurantOwnersAndUsersByRestId($resid)
	{
		try{
			$mapper =  new User_Model_PatronDataMapper();
			$userDetails = $mapper->getRestaurantOwnersAndUsersByRestId($resid);
			return $userDetails;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	

	/**
	 * @param array
	 * function to login the users
	 */
	public function Login(array $data)
	{
		try{
			$form = new User_Form_Signin();
			if($form->isValid($data)){

				$formValues = $form->getValues();
				$loginRes = $this->_process($formValues);
				return $loginRes;

			}else{
				$form->populate($data);
				return $loginRes = array('Status'=>false,'Form'=>$form,'isFormValid'=>false);
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function LoginFromSearch(User_Model_Signin $login)
	{
		try{
			if($login){
				$loginvalues = array('emailAddress'=> $login->getEmailAddress(),
								 	 'password'	   => $login->getPassword());

				$loginRes = $this->_process($loginvalues);
				if($loginRes['Status']){
					return $loginRes;
				}else{
					return $loginRes = array('Status'=>false);
				}
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param instance of login
	 * function to check whether email id exists or not
	 */
	public function CheckEmailAvaliable(User_Model_Signin $obj)
	{
		try{
			$mapper = new User_Model_ClientDataMapper();
			$status = $mapper->getEmailStatus($obj);
			return $status;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * function to logout the users
	 */
	public function Logout()
	{
		try{
			$auth = Zend_Auth::getInstance();
			$auth->clearIdentity();
			return true;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param values
	 * function to check whether emailaddress and password valid or not
	 * if it is valid user enters to his/her account
	 */
	protected function _process($values,$authFlag = false)
	{
		$adapter = $this->_getAuthAdapter();
		$userMapper = new User_Model_ClientDataMapper();
		$passPhrase = $userMapper->getUserPassPhrase($values['emailAddress']);
		if($passPhrase){
			$passwordHash = '';
			if($authFlag==true)
			{
				$passwordHash = $values['password'];
			}
			else
			{
				$passwordHash = sha1($values['password'].$passPhrase->usrpassphrase);
			}
			$email = strtolower($values['emailAddress']);
			$adapter->setIdentity(trim($email))
			->setCredential($passwordHash);
			$auth = Zend_Auth::getInstance();
			try{
				$select = $adapter->getDbSelect();
				$select->where('usruser_status_id = 1');
				$result = $auth->authenticate($adapter);
			}
			catch(Zend_Exception $ex){ 
				$this->view->errorMsg = $ex->getMessage() . "<br>";
				Uss_Logger_FileLogger::info($ex->getMessage());
				throw new Exception($ex->getMessage()) ;
			}
	
			if($result->isValid()){
				$data = $adapter->getResultRowObject();
	
				$loginProfile = $userMapper->getLoginProfile($data);
				
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$namespace = new Zend_Session_Namespace(); 
				$loginProfile['lang'] = $namespace->lang;
				$storage->write($loginProfile);	
	
				$userType = $loginProfile['Usertype'];
				if(($userType == "ADU" || $userType == "RSO" || $userType == "RSU" || $userType == "SRU")  && $loginProfile['companyid'] != 1){
					$companyMapper = new Administrator_Model_CompanyDataMapper();
					$status = $companyMapper->getComapnyStatusById($loginProfile['companyid']);
					if($status == true){
						$loginRes = array('Status'=> true,'Usertype'=>$userType,'loginprofile'=>$loginProfile);
					}else{
						$auth->clearIdentity();
						return $loginRes = array('Status'=>false,'CompanyInActive'=>true);
					}
				}else{				
					$loginRes = array('Status'=> true,'Usertype'=>$userType,'loginprofile'=>$loginProfile);
				}
				$LoginAttemptMapper = new User_Model_LoginAttemptsDataMapper();
				$LoginAttemptMapper->UpdateLoginAttempts($data['Email']);
				return $loginRes;
			}else{
				$userMapper = new User_Model_ClientDataMapper();
				$userstatus = $userMapper->getUserStatusByEmail($values['emailAddress']);
				if($userstatus['userstatusid'] == 3){
					return $loginRes = array('Status'=>false,'UserNotApproved'=>true);
				}else if($userstatus['userstatusid'] == 2){
					return $loginRes = array('Status'=>false,'UserInActive'=>true);
				}else{
					return $loginRes = array('Status'=>false,'isFormValid'=>true);
				}
			}
		}else{
			return $loginRes = array('Status'=>false,'isFormValid'=>true);
		}
		
	}

	public function _getAuthAdapter()
	{
		$users = new User_Model_DbTable_Client();
		$authAdapter = new Zend_Auth_Adapter_DbTable($users->getAdapter());
		$authAdapter->setTableName('mt.user');
		$authAdapter->setIdentityColumn('usremail')
		->setCredentialColumn('usrpassword');
		return $authAdapter;
	}
	
	public function CheckLoginDetails($values)
	{
		$adapter = $this->_getAuthAdapter();
		$userMapper = new User_Model_ClientDataMapper();
		$passPhrase = $userMapper->getUserPassPhrase($values['emailAddress']);
		if($passPhrase){
			$passwordHash = sha1($values['password'].$passPhrase->usrpassphrase);
			$email = strtolower($values['emailAddress']);
			$adapter->setIdentity(trim($email))
			->setCredential($passwordHash);
			$auth = Zend_Auth::getInstance();
			try{
				$select = $adapter->getDbSelect();
				$select->where('usruser_status_id = 1');
			//$select->where('usrusertype_id = 3');
				$result = $auth->authenticate($adapter);
			}
			catch(Zend_Exception $ex){
				$this->view->errorMsg = $ex->getMessage() . "<br>";
				Uss_Logger_FileLogger::info($ex->getMessage());
				throw new Exception($ex->getMessage()) ;
			}
      
			if($result->isValid()){
				$data = $adapter->getResultRowObject();
        //echo '<pre>'; print_r($data); exit;
				return $loginRes = array('Status'=>true,'userdata'=>$data);
			}else{
				
				$userstatus = $userMapper->getUserStatusByEmail($values['emailAddress']);
				if($userstatus['userstatusid'] == 3){
					return $loginRes = array('Status'=>false,'UserNotApproved'=>true);
				}else if($userstatus['userstatusid'] == 2){
					return $loginRes = array('Status'=>false,'UserInActive'=>true);
				}else{
					return $loginRes = array('Status'=>false,'isFormValid'=>true);
				}
			}
		}
	}
	
	public function getRestaurantDetailsByUserData($data)
	{
		try{
			$resArr = array();
			$userMapper = new User_Model_ClientDataMapper();
			$user_id       = $data->usrid;
			$usertype_Id   = $data->usrusertype_id;
			$userType = $userMapper->getUsertype($usertype_Id);
			if($userType->code == 'RSO'){
				$byownerid = new FirmManagement_Model_FirmByOwnerId();
				$byownerid->setResOwnerId($user_id);
				
				$rsoMapper = new FirmManagement_Model_FirmDataMapper();
				$resultSet = $rsoMapper->getApprovedRestaurantIdsByOwnerId($byownerid);
				foreach($resultSet as $resid){
					$resArr[$resid->resid] = $resid->resrestaurant_name;
				}
			}
			return $resArr;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function GetRegionByStateId($stateId)
	{
		try{
			if($stateId){
				$region = new Application_Model_Region();
				$region->setStateId($stateId);
				$regionBdMapper = new Application_Model_RegionDataMapper();
				$regionBd       = $regionBdMapper->getRegionByStateId($region);
				return $regionBd->getRegionList();
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetCityByRegionId($regionId)
	{
		try{
			if($regionId){
				$city = new Application_Model_City();
				$city->setRegionId($regionId);
				$cityBdMapper = new Application_Model_CityDataMapper();
				$cityBd       = $cityBdMapper->getCityByRegionId($city);
				return $cityBd->getCityList();
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	/**
	 * @param stateid
	 * retreives all citys by stateid from basedata
	 */
	public function GetCityByStateId($stateId)
	{
		try{
			if($stateId){
				$city = new Application_Model_City();
				$city->setStateId($stateId);
				$cityBdMapper = new Application_Model_CityDataMapper();
				$cityBd       = $cityBdMapper->getCityByStateId($city);
				return $cityBd->getCityList();
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param cityid
	 * retreives all neighborhoods by cityid from basedata
	 */
	public function GetNeighborhodByCityId($cityid)
	{
		try{
			if($cityid){
				$neighborhood = new Application_Model_Neighborhood();
				$neighborhood->setCityId($cityid);
				$nghBdMapper = new Application_Model_NeighborhoodDataMapper();
				$nghBd       = $nghBdMapper->getNghByCityId($neighborhood);
				return $nghBd->getNeighborhoodList();
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param $data
	 * function to retreive the account information of user 
	 */
	public function GetAccountInfo($data)
	{
		try{
			//echo '<pre>'; print_r($data); exit;
			$accountinfo = null;
			if($data){
				if($data['Usertype']== 'CUS'){
					$accountinfo = array('Usertype'		  =>'Customer',
										 'SignUpDate'     => $data['SignUpdate'],
										 'LastLoginDate'  => $data['LastLoginDate']);

				}else if($data['Usertype']== 'RSO'){
					$accountinfo = array('Usertype'		  =>'Restaurant Owner',
										 'SignUpDate'     => $data['SignUpdate'],
										 'LastLoginDate'  => $data['LastLoginDate']);
						
				}else if($data['Usertype']== 'RSU'){
					$accountinfo = array('Usertype'		  =>'Restaurant User',
										 'SignUpDate'     => $data['SignUpdate'],
										 'LastLoginDate'  => $data['LastLoginDate']);		
				}else if($data['Usertype']== 'SRU'){
					$accountinfo = array('Usertype'		  =>'Restaurant Super User',
										 'SignUpDate'     => $data['SignUpdate'],
										 'LastLoginDate'  => $data['LastLoginDate']);		
				}else if($data['Usertype']== 'ADM'){
					$accountinfo = array('Usertype'		  =>'Administrator',
										 'SignUpDate'     => $data['SignUpdate'],
										 'LastLoginDate'  => $data['LastLoginDate']);				
				}

				return $accountinfo;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param $data
	 * function to retreive restaurantcount by ownerid
	 */
	public function GetRestaurantCount($data)
	{
		try{
			if($data['Usertype'] == "ADM" || $data['Usertype'] == "ADU"){
				$userid = $data['restownerId'];
			}else{
				$userid = $data['User_Id'];
			}			
			$restService = new Application_Service_Firm();
			$count = 0;
			$count = $restService->GetRestaurantCountByOwnerId($userid);
			return $count;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * @param $request
	 * function to check the emailid in database
	 */
	public function emailCheck($request)
	{
		try{
			$email = $request->email;
			if($this->emailCheack($email)){
				$mapper = new User_Model_ClientDataMapper;
				$userdetails = $mapper->getUsertypeidByemail($email);
				if($userdetails){
					return $userdetails;
			}else{
				return false;
			}
		}else{
			return false;
		}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	
	/**
	 * @param $request
	 * function to send the auto genarated password to given useremail 
	 */
	public function sendPassword($request)
	{
		try{
			$email = $request->email;
			if($this->emailCheack($email)){
				$length = 8;
				$characters = '0123456789abcdefghijklmnopqrstuvwxyz';
				$randomdata = "";
				for ($p = 0; $p < $length; $p++) {
					$randomdata .= $characters[mt_rand(0, strlen($characters))];
				}

				$mapper = new User_Model_ClientDataMapper;
				$userdetails = $mapper->getUsertypeidByemail($email,$randomdata);
				if($userdetails){
					$mailmapper = new Application_Service_Communication();
					$mailObj = new Communication_Model_Mail();
					$mailObj->setMsgCode('ForgotPwd');
					$name = $userdetails['Firstname'].' '.$userdetails['LastName'];
					$data = array('UserName' => $name,
								  'password' => $randomdata,
								  'SenTo'    => $email);
					$mailObj->setData($data);
					$mailStatus = $mailmapper->SendMail($mailObj);
					if($mailStatus){
						$userid = $userdetails['User_Id'];
						$mapper->UpdateForgotPwd($userid,$randomdata);
					}
				}
				return true;
			}else{
				return false;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * @param $request
	 * function to send the auto genarated password by ajax call to given useremail 
	 */
	public function sendPasswordbyajax($request)
	{
		try{
			$email = $request->email;
			if($email){
				$length = 8;
				$characters = '0123456789abcdefghijklmnopqrstuvwxyz';
				$randomdata = "";
				for ($p = 0; $p < $length; $p++) {
					$randomdata .= $characters[mt_rand(0, strlen($characters))];
				}

				$mapper = new User_Model_ClientDataMapper;
				$mailmapper = new Application_Service_Communication();
				$mailObj = new Communication_Model_Mail();
				$mailObj->setMsgCode('ForgotPwd');
				$name = $request->firstname . '' .$request->lastName;
				$data = array('UserName' => $name,
							  'password' => $randomdata,
							  'SenTo'    => $email);
				$mailObj->setData($data);
				$mailStatus = $mailmapper->SendMail($mailObj);
				if($mailStatus){
					$userid = $request->userid;
					$mapper->UpdateForgotPwd($userid,$randomdata);
				}
				return true;
			}else{
				return false;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param $email
	 * function to check whether given useremail valid or not 
	 */
	public function emailCheack($email)
	{
		try{
			$mapper = new User_Model_ClientDataMapper;
			$status = $mapper->emailValidCheck($email);
			return $status;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * @param $data
	 * function to retreive the notifications of login user 
	 */
	public function getNotificationsByUserId($data)
	{
		try{
			$userid = $data['User_Id'];
			
			$service = new Communication_Model_EmailCusRecipentsDataMapper();
			$result = $service->getNotificationsByUserId($userid);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function manageRestaurantOwners($data,$page)
	{
		try{
			$obj = new User_Model_RestOwnSearch();
			$adminService = new Application_Service_Administrator();
			$form = $adminService->getRestOwnerSearchForm();
			if($form->isValid($data)){
				if($data)
				{
					$formData = $form->getValues();
					if($formData['userId'])
					{
						$obj->setId($formData['userId']);
					}
					if($formData['email']){
						$obj->setEmail($formData['email']);
					}
					if($formData['status']){
						$obj->setStatusId($formData['status']);
					}
					if($formData['firstname']){
						$obj->setFirstname($formData['firstname']);
					}
					if($formData['lastname']){
						$obj->setLastname($formData['lastname']);
					}
					if($formData['state']){
						$obj->setStateid($formData['state']);
					}	
					if($formData['region']){
						$obj->setRegionid($formData['region']);
					}
					if($formData['city']){
						$obj->setCityid($formData['city']);
					}
					if($formData['resname']){
						$obj->setResName($formData['resname']);
					}
					if($formData['company']){
						$obj->setCompany($formData['company']);
					}
				}
				$userMapper = new User_Model_ClientDataMapper();
				$result = $userMapper->manageRestaurantOwners($obj,$page);
				return $result;
			}
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function viewAllUsers($data,$page)
	{
		try{
			$obj = new User_Model_RestOwnSearch();
			$adminService = new Application_Service_Administrator();
			$form = $adminService->getViewAllUserSearchForm();
			if($form->isValid($data)){
				if($data)
				{
					$formData = $form->getValues();
					if($formData['userId'])
					{
						$obj->setId($formData['userId']);
					}
					if($formData['email']){
						$obj->setEmail($formData['email']);
					}
					if($formData['status']){
						$obj->setStatusId($formData['status']);
					}
					if($formData['firstname']){
						$obj->setFirstname($formData['firstname']);
					}
					if($formData['lastname']){
						$obj->setLastname($formData['lastname']);
					}
					if($formData['state']){
						$obj->setStateid($formData['state']);
					}	
					if($formData['region']){
						$obj->setRegionid($formData['region']);
					}
					if($formData['city']){
						$obj->setCityid($formData['city']);
					}				
				}
				$userMapper = new User_Model_ClientDataMapper();
				$result = $userMapper->viewAllUsers($obj,$page);
				return $result;
			}
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function UpdateRestaurantOwnerStatus($request)
	{
		try{
			if($request->userid)
			{
				$userid = $request->userid;
			}else{
				$userid = $request->uid;
			}
			$code = $request->status;
			$userMapper = new User_Model_ClientDataMapper();
			$status = $userMapper->UpdateRestaurantOwnerStatus($userid, $code);

			if(isset($request->appstatus)){
				$result = $userMapper->getNameandEmailByUserId($userid);
				
				$mailmapper = new Application_Service_Communication();
				$mailObj = new Communication_Model_Mail();
				$name	= $result['rsofirst_name'].' '.$result['rsolast_name']; 
				$email	= $result['usremail']; 
				$mailObj->setMsgCode('Registration Approved');
				
				$data = array('UserName' => $name,
						  'SenTo'    => $email);
				$mailObj->setData($data);
				$mailmapper->SendMail($mailObj);
			}
			return $status;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function EditRestaurantOwnerDetails($request)
	{
		try{
			$obj = new User_Model_Client();
			if($request->emailAddress){
				$email 		= strtolower($request->emailAddress);
				$obj->setEmail($email);
				$userid 	= $request->id;
				$obj->setId($userid);
			}
			if($request->password){
				$password 	= $request->password;
				$obj->setPassword($password);
				$userid 	= $request->userid;
				$obj->setId($userid);
			}			
			$userMapper = new User_Model_ClientDataMapper();
			$status = $userMapper->EditRestaurantOwnerDetails($obj);
			return $status;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * display the entire customer list.
	 */
	public function manageCustomers($data,$page)
	{
		try{
			$obj = new User_Model_Guest();
			$adminService = new Application_Service_Administrator();
			$form = $adminService->getRestOwnerSearchForm();
			if($form->isValid($data)){
				if($data)
				{
					$formData = $form->getValues();
					if($formData['userId'])
					{
						$obj->setId($formData['userId']);
					}
					if($formData['email']){
						$obj->setEmail($formData['email']);
					}
					if($formData['status']){
						$obj->setStatusId($formData['status']);
					}
					if($formData['firstname']){
						$obj->setFirstname($formData['firstname']);
					}
					if($formData['lastname']){
						$obj->setLastname($formData['lastname']);
					}
					if($formData['state']){
						$obj->setStateid($formData['state']);
					}	
					if($formData['city']){
						$obj->setCityid($formData['city']);
					}				
				}
				$userMapper = new User_Model_ClientDataMapper();
				$result = $userMapper->manageCustomers($obj,$page);
				return $result;
			}
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * Update the customer status
	 */
	public function UpdateCustomerStatus($request)
	{
		try{
			$userid = $request->userid;
			$code = $request->status;
			$userMapper = new User_Model_ClientDataMapper();
			$status = $userMapper->UpdateCustomerStatus($userid, $code);
			return $status;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	
	/**
	 * Update the customer email and password by admin
	 */
	public function EditCusEmailAndPassword($request)
	{
		try{
			$obj = new User_Model_Client();
			if($request->emailAddress){
				$email 		= $request->emailAddress;
				$obj->setEmail($email);
				$userid 	= $request->id;
				$obj->setId($userid);
			}
			if($request->password){
				$password 	= $request->password;
				$obj->setPassword($password);
				$userid 	= $request->userid;
				$obj->setId($userid);
			}			
			$userMapper = new User_Model_ClientDataMapper();
			$status = $userMapper->EditCusEmailAndPassword($obj);
			return $status;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * get description of owner by id
	 */
	public function getOwnerDescriptionbyId($request)
	{
		try{
			$id = $request->id;
			$mapper = new User_Model_ManagerDataMapper();
			$desc = $mapper->getOwnerDescriptionbyId($id);
			return $desc;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function addAdminUser(array $data , $userdata)
	{
		try{
			$form = $this->getAddAdminUserForm();
			$RolesList = array();
           	$restService = new Application_Service_Firm();
			
           	if($data['company']){
				$roleObj = new Application_Model_Role();
				$roleObj->setCompanyId($data['company']);
				$roleObj->setStatus('TRUE');
           	
				$mapper = new Application_Model_RoleDataMapper();
				$RolesList = $mapper->getRolesByCompany($roleObj);
           	}
           	
			if($form->isValid($data)){
			/*  retreiving user type */
				$userType[] = 'ADU';
				$userMapper = new Application_Model_UsertypeDataMapper();
				$userList = $userMapper->GetUserTypeByCode($userType);
				$userTypeList = $userList['ADU'];
				/*  retreiving user type */
				
				$adminuser = new User_Model_AdminPatron();
				$adminuser->setEmail(strtolower($data['emailAddress']))
						  ->setPassword($data['password'])
						  ->setUsertypeid($userTypeList->getId())
						  ->setRegistereddate(date('Y-m-d H:i:s'))
						  ->setUserstatisid(1);				
				$adminuser->setadu_firstname($data['firstName']);
				$adminuser->setadu_lastname($data['lastName']);
				$adminuser->setadu_company_id($data['company']);
				$adminuser->setadu_status(true);
				
				if($data['company'] == 1){
					$adminuser->setRole(1);
				}else{
					$adminuser->setRole($data['adminUserRole']);
				}
				
				$mapper = new User_Model_AdminPatronDataMapper();
				$result = $mapper->AddAdminUser($adminuser);
				return $result;
			}else{
				$formData = $form->getValues();
				$form->populate($data);
				if($RolesList){
					$form->adminUserRole->addMultiOptions($RolesList);
				}
				$result = array('status'=>false,'form'=>$form);
				return $result;
			}			
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function manageAdminUsers($data)
	{
		try{
			$mapper = new User_Model_AdminPatronDataMapper();
			$result = $mapper->ManageAdminUsers($data);
			return $result; 
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function adminUserStatusChange($request)
	{
		try{
			$id = $request->id;
			$code = $request->status;
			
			$mapper = new User_Model_ClientDataMapper();
			$result = $mapper->UpdateCustomerStatus($id, $code);
			return $result; 
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getAdminUserDetailsById($request)
	{
		try{
			$userid = $request->id;
				
			$mapper = new User_Model_AdminPatronDataMapper();
			$result = $mapper->getAdminUserDetailsById($userid);
			
			$formValues = array(
	                        'firstName'		=> $result->getadu_firstname(),
	                        'lastName'		=> $result->getadu_lastname(),
							'company'		=> $result->getadu_company_id(),
							'adminUserRole'	=> $result->getRole()
			);
			
			return $formValues;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function setRestaurantUserInitialsForm(Zend_Form $form)
	{
		$this->_form['RestaurantUserInitials'] = $form;
	}
	
	public function getRestaurantUserInitialsForm($data)
	{
		if(empty($this->_form['RestaurantUserInitials'])){
			$searchResUser = new User_Form_PatronCodes();
			$userid = $data['User_Id'];
				
			$mapper = new FirmManagement_Model_FirmDataMapper();
			$restObj = new FirmManagement_Model_FirmNamesByOwnerId();
			if($data['Usertype'] == "RSO"){
				$restObj->setRestOwnerId($userid);
			}else if($data['Usertype'] == "RSU" || $data['Usertype'] == "SRU"){
				$restObj->setRestId($data['RestId']);
			}
			$results = $mapper->getRestaurantNamesByOwnerId($restObj);
			$searchResUser->RestaurantName->addMultiOptions($results);
			$this->setRestaurantUserInitialsForm($searchResUser);
		}
		return $this->_form['RestaurantUserInitials'];
	}
	
	/**
	 * get description of restaurant users by restaurnat owner id
	 */
	public function getrestusersbyrestid($request)
	{
		try{
			$resid = $request->resid;
			$mapper = new User_Model_PatronDataMapper();
			$result = $mapper->getrestusersbyrestId($request);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * get initial of restaurant users by user id
	 */
	public function getinitialbyuserid($request)
	{
		try{
			$userid = $request->userid;
			$mapper = new User_Model_PatronCodesDataMapper();
			$initial = $mapper->getinitialbyuserId($userid);
			return $initial;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * get initial of restaurant users by user id
	 */
	public function initialcheck($request)
	{
		try{
			$resid = $request->resid;
			$mapper = new User_Model_PatronCodesDataMapper();
			$users = $mapper->initialCheck($resid);
			return $users;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/* Update Restaurant User Initial*/
	
	public function updateuserinitial($request,$data)
	{
		try{
			$form = new User_Form_PatronCodes();
			$userid = $data['User_Id'];
				
			$mapper = new FirmManagement_Model_FirmDataMapper();
			$restObj = new FirmManagement_Model_FirmNamesByOwnerId();
			$restObj->setRestOwnerId($userid);
			$results = $mapper->getRestaurantNamesByOwnerId($restObj);
			$form->RestaurantName->addMultiOptions($results);
			if($form->isValid($request)){

				$formData = $form->getValues();
				$userinitial = new User_Form_PatronCodes();
				
				$userinitial->setUserid($formData[UserName]);
				$userinitial->setInitial($formData[initial]);
				$mapper = new User_Form_PatronCodesDataMapper();
				$status = $mapper->update($userinitial);
				
				if($status){					
					$result = array('status'=>true);
					return $result;
				}
			}else{
				
				$formData = $form->getValues();
				$mapper = new User_Model_PatronDataMapper();
				$users = $mapper->getrestusersbyrestId($formData['RestaurantName']);
				$form->UserName->addMultiOptions($users);
				$form->setDefaults(array(
				'RestaurantName'=>	$formData['RestaurantName'],
				'UserName'		=>	$formData['UserName'],
				'initial'		=>$formData['initial']));
				}
				$result = array('status'=>false,'form'=>$form);
				return $result;
			
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function changepatron($request)
	{
			$userinitial = $request->user_list;
			$bookingid = $request->bookingid;
			$mapper = new User_Model_PatronCodesDataMapper();
			$status = $mapper->changepatron($userinitial,$bookingid);
			return $status;
	}
	
	public function GetRestOwnProfileByUserId($userid)
	{
		try{
			$userDataMapper = new User_Model_ClientDataMapper();
			$data = $userDataMapper->getRestOwnDetails($userid);
			return $data;
			
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function updateAll()
	{
		try{
			$userMapper = new User_Model_ClientDataMapper();
			$result = $userMapper->updateAllPhrase();	
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function manageRestaurantUsers($data,$page)
	{
		try{
			$obj = new User_Model_RestOwnSearch();
			$adminService = new Application_Service_Administrator();
			$form = $adminService->getRestOwnerSearchForm();
			if($form->isValid($data)){
				if($data)
				{
					$formData = $form->getValues();
					if($formData['userId'])
					{
						$obj->setId($formData['userId']);
					}
					if($formData['email']){
						$obj->setEmail($formData['email']);
					}
					if($formData['status']){
						$obj->setStatusId($formData['status']);
					}
					if($formData['firstname']){
						$obj->setFirstname($formData['firstname']);
					}
					if($formData['lastname']){
						$obj->setLastname($formData['lastname']);
					}
					if($formData['state']){
						$obj->setStateid($formData['state']);
					}	
					if($formData['region']){
						$obj->setRegionid($formData['region']);
					}
					if($formData['city']){
						$obj->setCityid($formData['city']);
					}
					if($formData['resname']){
						$obj->setResName($formData['resname']);
					}
				}
				$userMapper = new User_Model_ClientDataMapper();
				$result = $userMapper->manageRestaurantUsers($obj,$page);
			
				return $result;
			}
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function UpdateRestaurantUserStatus($request)
	{
		try{
			if($request->userid)
			{
				$userid = $request->userid;
			}else{
				$userid = $request->uid;
			}
			$code = $request->status;
			$userMapper = new User_Model_ClientDataMapper();
			$status = $userMapper->UpdateRestaurantOwnerStatus($userid, $code);
			return $status;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function GetRestInfoByCusId($data)
	{
		try{
//			$restid = $request->restid;
			$userid = $data['User_Id'];
			$mapper = new Reservation_Model_ReservationDataMapper();
			$result = $mapper->RestInfoByCusId($userid);
			return $result;
		}catch(Exception $ex){	
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	
	public function AddFavouriteRest($request,$data)
	{
		try{
//			$restid = $request->restid;
			$userid = $data['User_Id'];
			$restid = $request->restid;
			$status = $request->status;
			$mapper = new User_Model_CustomerRestChoiceDataMapper();
			$result = $mapper->AddFavouriteRest($userid,$restid,$status);
			return $result;
		}catch(Exception $ex){	
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function manageLoginProfileWidget($user,$userLoginProf)
	{
		try{		
			
			$userMapper = new User_Model_ClientDataMapper();

			$loginProfile = $userMapper->manageLoginProfileWidget($user);
//			$loginProfile[] = $userLoginProf; 
//			$storage = new Zend_Auth_Storage_Session();
//			$storage->write($loginProfile);	

			$userType = $loginProfile['Usertype'];
			if(($userType == "ADU" || $userType == "RSO" || $userType == "RSU" || $userType == "RSU")  && $loginProfile['companyid'] != 1){
				$companyMapper = new Administrator_Model_CompanyDataMapper();
				$status = $companyMapper->getComapnyStatusById($loginProfile['companyid']);
				if($status == true){
					$loginRes = array('Status'=> true,'Usertype'=>$userType,'loginprofile'=>$loginProfile);
				}else{
					$auth->clearIdentity();
					return $loginRes = array('Status'=>false,'CompanyInActive'=>true);
				}
			}else{				
				$loginRes = array('Status'=> true,'Usertype'=>$userType,'loginprofile'=>$loginProfile);
			}
			$LoginAttemptMapper = new User_Model_LoginAttemptsDataMapper();
			$LoginAttemptMapper->UpdateLoginAttempts($user->email);
			return $loginRes;
			
		}catch(Exception $ex){	
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function widgetUserRegistration($request)
	{
		try{
			$customer = new User_Model_Guest();
			$name = explode(' ',$request->username);
			$customer->setEmail(strtolower($request->webemail))
					->setPassword($request->webpassword)
					->setUsertypeid(2)
					->setRole(4)
					->setRegistereddate(date('Y-m-d H:i:s'))
					->setUserstatisid(1)
					->setFirstname($name[0])
					->setPhonenumber($request->webphone);
					
			if(isset($name[1])){
				$customer->setLastname($name[1]);
			}

			$mapper = new User_Model_GuestDataMapper();
			$customer_id = $mapper->widgetsave($customer);
			$values = array('emailAddress'=>$request->webemail,'password'=>$request->webpassword);
			$createLoginProf = $this->_process($values);
			if($customer_id){
				/* For E-Mail*/
				$mailmapper = new Application_Service_Communication();
				$mailObj = new Communication_Model_Mail();
				$mailObj->setMsgCode('Customer_Confirmation');
//				$name = $request->firstName.' '.$request->lastName;
				$data = array('UserName' => $request->username,
							  'SenTo'    => $customer->getEmail());
				$mailObj->setData($data);
				$mailStatus = $mailmapper->SendMail($mailObj);
				/*For SMS*/
				/*if(isset($request['phone'])){
					$smsObj = new Communication_Model_Sms();
					$smsObj->setMsgCode('Customer_Confirmation');
					$data = array(
					 	'to'	=>	trim($request['phone'])
					 );
					 $smsObj->setData($data);
					 $mailStatus = $mailmapper->SendSms($smsObj);
				}*/
				return true;
			}else{
				return false;
			}
		}catch(Exception $ex){	
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function validateLoginDetailsAPI($request)
	{
		try{
			$adapter = $this->_getAuthAdapter();
			$userMapper = new User_Model_ClientDataMapper();
			$passPhrase = $userMapper->getUserPassPhrase($request->email);
			if($passPhrase){
				$passwordHash = sha1($request->password.$passPhrase->usrpassphrase);
				$email = strtolower($request->email);
				$adapter->setIdentity(trim($email))
					    ->setCredential($passwordHash);
				$auth = Zend_Auth::getInstance();
				try{
					$select = $adapter->getDbSelect();
					$select->where('usruser_status_id = 1');
					$result = $auth->authenticate($adapter);
				}
				catch(Zend_Exception $ex){
					$this->view->errorMsg = $ex->getMessage() . "<br>";
					Uss_Logger_FileLogger::info($ex->getMessage());
					throw new Exception($ex->getMessage()) ;
				}
	
				if($result->isValid()){
					$data = $adapter->getResultRowObject();		
					$loginProfile = $userMapper->getLoginProfile($data);
					$storage = new Zend_Auth_Storage_Session();
					$storage->write($loginProfile);
					$userType = $loginProfile['Usertype'];					
					if(($userType == "ADU" || $userType == "RSO" || $userType == "RSU" || $userType == "SRU")  && $loginProfile['companyid'] != 1){
						$companyMapper = new Administrator_Model_CompanyDataMapper();
						$status = $companyMapper->getComapnyStatusById($loginProfile['companyid']);
						if($status == true){
							$loginRes = array('Status'=> true,'Usertype'=>$userType,'loginprofile'=>$loginProfile);
						}else{
							$auth->clearIdentity();
							return $loginRes = array('Status'=>false,'CompanyInActive'=>true);
						}
					}else{				
						$loginRes = array('Status'=> true,'Usertype'=>$userType,'loginprofile'=>$loginProfile);
					}
					return $loginRes;
				}else{
					$userMapper = new User_Model_ClientDataMapper();
					$userstatus = $userMapper->getUserStatusByEmail($email);
					if($userstatus['userstatusid'] == 3){
						return $loginRes = array('Status'=>false,'UserNotApproved'=>true);
					}else if($userstatus['userstatusid'] == 2){
						return $loginRes = array('Status'=>false,'UserInActive'=>true);
					}else{
						return $loginRes = array('Status'=>false,'isFormValid'=>true);
					}
				}
			}else{
				return $loginRes = array('Status'=>false,'isFormValid'=>true);
			}
		}catch(Exception $ex){	
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetRestOwnerUserTableDetails($userid)
	{
		try
		{
			$clientDataMapper = new User_Model_ClientDataMapper();
			$result = $clientDataMapper->RetrieveRestOwnerdetails($userid);
			return $result;
		}catch(Exception $ex){	
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetRestIdByRestUserId($rest_user_id)
	{
		try
		{
			$patronDataMapper = new User_Model_PatronDataMapper();
			$restid = $patronDataMapper->RetrieveRestIdByUserId($rest_user_id);
			return $restid;
			
		}catch(Exception $ex){	
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetRestOwnerDetails($userid)
	{
		try
		{
		 $managerDataMapper = new User_Model_ManagerDataMapper();
		 $result = $managerDataMapper->GetRestOwnerDetalsByRestUserId($userid);
		 return $result;
		}catch(Exception $ex){	
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * Generate User Token with userid
	 */
	public function generateUserTokenWithUserId($userid)
	{
		try
		{
			$characters = '0123456789';
		    $charactersLength = strlen($characters);
		    $randomString = '';
		    $length = 9;
		    for ($i = 0; $i < $length; $i++) {
		        $randomString .= $characters[rand(0, $charactersLength - 1)];
		    }
		    $completeString = $randomString.''.$userid;
		    $hashedToken = base64_encode($completeString);
		    return $hashedToken;

		}catch(Exception $ex){	
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	/**
	 * DECODE userid from  User Token  
	 */
	public function decodeUserToken($token)
	{
		try
		{
			$unHashedToken = base64_decode($token);
			$randonLength = 9;
			$userid = substr($unHashedToken,$randonLength);
			$userid = intval($userid);
			return $userid;

		}catch(Exception $ex){	
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	/**
	 * Authenticate user with user token
	 */
	public function authenticateUserWithToken($token)
	{
		try
		{
			$userid = $this->decodeUserToken($token);
			if($userid>0)
			{
				$userDetails = array();
				$userMapper = new User_Model_ClientDataMapper();
				$user = $userMapper->getUserCredentailsByUserId($userid);
				$userDetails['emailAddress'] = $user->usremail;
				$userDetails['password'] = $user->usrpassword;
				$loginDetails = $this->_process($userDetails,true);
				return $loginDetails['Status'];
			}
			else
			{
				// INVALID TOKEN
				return false;
			}
			

		}catch(Exception $ex){	
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}


	
}