<?php
class Application_Service_Notification
{
	protected $_form = array();
	public function setContactUsForm(Zend_Form $form)
	{
		$this->_form['ContactUs'] = $form;
	}

	public function getContactUsForm()
	{
		if(empty($this->_form['ContactUs'])) {
			$this->setContactUsForm(new Notification_Form_ContactUs());
		}
		return $this->_form['ContactUs'];
	}
	
	public function setNotificationCreationForm(Zend_Form $form)
	{
		$this->_form['NotificationCreation'] = $form;
	}
	
	public function getNotificationCreationForm()
	{
		if(empty($this->_form['NotificationCreation'])) {
			$this->setNotificationCreationForm(new Notification_Form_NotificationCreation());
		}
		return $this->_form['NotificationCreation'];
	}
	
	public function setRecipentFilterForm(Zend_Form $form)
	{
		$this->_form['RecipentFilter'] = $form;
	}
	
	public function getRecipentFilterForm()
	{
		if(empty($this->_form['RecipentFilter'])) {
			$this->setRecipentFilterForm(new Notification_Form_RecipentFilter());
		}
		return $this->_form['RecipentFilter'];
	}
	
	public function GetSponsorCampaigns($aud)
	{
		$service = new Application_Service_Admin();
		$campProp = new Application_Model_GetCampaignForPost();
		$campProp->setAudType($aud)
				 ->setStateId(1);
		$sponsorDetails = $service->GetCampaignDetails($campProp);
		return $sponsorDetails;
	}
	
	public function UpdateCampaignEmailCount($camId,$count)
	{
		$service = new Application_Service_Admin();
		$service->UpdateCampaignEmailCount($camId,$count);
		return true;
	}
	public  function SendMail(Notification_Model_Mail $mailobj)
	{
		try{
			$fromaddress = 'info@dinedesk.com';
			$fromname = 'DineDesk';
			
			/*	Case Restaurant Owner Registration Confirmation	*/
			if($mailobj){
				Zend_Mail::setDefaultTransport( new Zend_Mail_Transport_Postmark('37c5685c-d02f-4581-b6f8-c922a7bee942' ));
				$mail = new Zend_Mail();
				switch($mailobj->getMsgCode()){
					case 'ResOwnConf':
						$template = $this->GetMessageTemplate($mailobj);
						if($template){
							$data    = $mailobj->getData();
							$name    = $data['UserName'];
							$subject = $template->msg_subject;
							$body    = $template->msg_body;							
							$body    = str_replace("%firstname%",$name,$body);
							$body 	 = str_replace("ï¿½",'',$body);
							$receiverslist = $data['SenTo'];
							
							$mail->setFrom($fromaddress, $fromname);
						    $mail->setReplyTo($fromaddress,$fromname);
						    $mail->addTo( $receiverslist,$name);
						    $mail->setSubject($subject);
						    $mail->setBodyHtml($body);
						    $mail->send();
						}	
						break;
						
					case 'New Registration email' :
						$template = $this->GetMessageTemplate($mailobj);
						if($template){
							$data    = $mailobj->getData();
							$name 	 		= $data['name'];
							$restname		= $data['restname'];
							$city			= $data['city'];
							$state			= $data['state'];
							$phone			= $data['phone'];
							$email 			= $data['email'];	
							
							$subject 		= $template->msg_subject;
							$body    		= $template->msg_body;							
							$body 	 		= str_replace("%restowner%",$name,$body);
							$body 	 		= str_replace("%restname%",$restname,$body);
							$body 	 		= str_replace("%city%",$city,$body);
							$body 	 		= str_replace("%state%",$state,$body);
							$body 	 		= str_replace("%phone%",$phone,$body);
							$body 	 		= str_replace("%email%",$email,$body);
							$body 	 		= str_replace("ï¿½",'',$body);
							
							$receiverslist 	= 'vgarrett@ureserv.com';
							
							$mail->setFrom($fromaddress, $fromname);
						    $mail->setReplyTo($fromaddress,$fromname);
						    $mail->addTo( $receiverslist,$name);
						    $mail->setSubject($subject);
						    $mail->setBodyHtml($body);
						    $mail->send();
						}
						break;
						
					case 'Registration Approved' :
							$template = $this->GetMessageTemplate($mailobj);
							if($template){
								$data    = $mailobj->getData();
								$name    = $data['UserName'];
								$subject = $template->msg_subject;
								$body    = $template->msg_body;							
								$body    = str_replace("%restowner%",$name,$body);
								$body 	 = str_replace("ï¿½",'',$body);
								$receiverslist = $data['SenTo'];
								
								$mail->setFrom($fromaddress, $fromname);
							    $mail->setReplyTo($fromaddress,$fromname);
							    $mail->addTo( $receiverslist,$name);
							    $mail->setSubject($subject);
							    $mail->setBodyHtml($body);
							    $mail->send();
							}	
						
						break;
						
					case 'Customer_Confirmation' :
						$template = $this->GetMessageTemplate($mailobj);
						
						if($template){
							$data    = $mailobj->getData();
							$name    = $data['UserName'];
							$subject = $template->msg_subject;
							$body    = $template->msg_body;							
							$body    = str_replace("%firstname%",$name,$body);
							$body 	 = str_replace("ï¿½",'',$body);
							$receiverslist = $data['SenTo'];
							
							$mail->setFrom($fromaddress, $fromname);
						    $mail->setReplyTo($fromaddress,$fromname);
						    $mail->addTo( $receiverslist,$name);
						    $mail->setSubject($subject);
						    $mail->setBodyHtml($body);
						    $mail->send();
						}
						break;
						
					case 'Customer_Reg_OnReservation':
						$template = $this->GetMessageTemplate($mailobj);
						
						if($template){
							$data    = $mailobj->getData();
							$name    = $data['UserName'];
							$pwd 	 = $data['password'];
							$subject = $template->msg_subject;
							$body    = $template->msg_body;							
							$body    = str_replace("%firstname%",$name,$body);
							$body	 = str_replace('%pwd%',$pwd,$body);
							$body 	 = str_replace("ï¿½",'',$body);
							$receiverslist = $data['SenTo'];
							
							$mail->setFrom($fromaddress, $fromname);
						    $mail->setReplyTo($fromaddress,$fromname);
						    $mail->addTo( $receiverslist,$name);
						    $mail->setSubject($subject);
						    $mail->setBodyHtml($body);
						    $mail->send();
						}
						break;
						
					case "BookReminder" :
//						$template = $this->GetMessageTemplate($mailobj);

						$templateBdMapper = new Application_Model_EmailtemplateDataMapper();
						$resDetails = new Booking_Model_BookingDataMapper;
                                                $resid = $resDetails->getRestIdByBookId($data['Bokid']);
						//getting book reminder subject by code
						$templateSubject = $templateBdMapper->getEmailTempByCode('BookReminder');
						$template = $templateBdMapper->getEmailTempByCode('Email_Message');
						switch($resid) {
							case 2474:
								$template = $templateBdMapper->getEmailTempByCode('BookReminderEMC');
								break;
							case 2500:
								$template = $templateBdMapper->getEmailTempByCode('BookReminderPavilion');
								break;

							case 2516:
								$template = $templateBdMapper->getEmailTempByCode('BookReminderRooster');
								break;
							case 2522:
                                                        case 2526:
                                                        case 2527:
								$template = $templateBdMapper->getEmailTempByCode('BookReminderCrownePlaza');
                                                                break;
						}						
						if($template){
							$data     = $mailobj->getData();
							$campId = "";

							$name     = $data['UserName'];
							$phone    = $data['Phone'];
							$email    = $data['Email'];
							$restname = $data['RestName'];
							$resdate  = $data['ResDate'];
							$time     = $data['Time'];
							$size     = $data['Size'];
//							$address  = $data['Address'];
//							$resphone = $data['resphone'];
//							$status	  = $data['Status'];
							$bokid    = $data['Bokid'];
							$state	  = $data['State_Id'];
							$city	  = $data['City_Id'];
//							$resemail = $data['resemail'];
//							$reszipcode = $data['reszipcode'];
//							$rescity  = $data['rescity'];
//							$resnbh   = $data['resnbh'];
							
//							$spldiv = '<div style="background: #f1ede8;box-shadow: 5px 5px 30px #808080;-moz-box-shadow: 5px 5px 30px #808080;-khtml-box-shadow: 5px 5px 30px #808080;-webkit-box-shadow: 5px 5px 30px #808080;border:3px solid #643513; padding:8px; font-size:12px;"><div style="color:#F79646; font-weight:bold; text-align:center;">%splname%</div><br /><div style="color:#4f6228; font-weight:bold;">Special Id: %splid%</div><br /><br /><div style="color:#000048;">%spldesc%</div></div><br /><br />';
//							if($data['splstatus']){
//								$splid		= $data['splid']; 
//								$splname 	= $data['splname'];
//								$spldesc	= $data['spldesc'];
////								$splorgprice= $data['splorgprice'];
////								$spldiscount= $data['spldiscount'];
////								$splprice	= $data['splprice'];
//							}
							
							$userType = $data['UserType'];
//							$div = '<td width="45%" valign="top" align="left">%img%</br><div>%desc%</div></td>';
//							$imgDiv = '<div><img src="http://www.ureserv.com%img%" width="150" height="150"/></div>';
							if(isset($data['campId'])){
								$campId  	= $data['campId'];
								$campname 	= $data['campaignName'];
								$desc  		= $data['campaignDesc'];
								$img 	  	= $data['campaignImg'];
//								$desc  		= str_replace('src="','src="http://www.ureserv.com',$desc);
								$display  	= 'block';
							}

						    //storing book reminder subject in a variable
							$subject = $templateSubject->msg_subject;
							$body    = $template->msg_body;
							
							$body    = str_replace("%firstname%",$name,$body);
							$body    = str_replace("%phone%",$phone,$body);
							$body    = str_replace("%email%",$email,$body);
							$body    = str_replace("%restname%",$restname,$body);
							$body    = str_replace("%date%",$resdate,$body);
							$body    = str_replace("%time%",$time,$body);
							$body    = str_replace("%size%",$size,$body);
//							$body	 = str_replace("%address%",$address,$body);
//							$body	 = str_replace("%resphone%",$resphone,$body);
//							$body	 = str_replace("%bokid%",$bokid,$body);
//							$body	 = str_replace("%resnbh%",$resnbh,$body);
//							$body	 = str_replace("%rescity%",$rescity,$body);
//							$body	 = str_replace("%resemail%",$resemail,$body);
//							$body	 = str_replace("%reszipcode%",$reszipcode,$body);							
							
							$body 	 = str_replace("ï¿½",'',$body);
//							if(isset($data['campId'])){
//								$body    = str_replace("none",$display,$body);
//								$body    = str_replace("%desc%",$desc,$body);
//								if($data['campaignImg']){
//									$imgDiv 	= str_replace("%img%",$img,$imgDiv);
//									$body    	= str_replace("%img%",$imgDiv,$body);
//								}else{
//									$body    = str_replace($imgDiv,'',$body);
//								}
//								$body    = str_replace("%campName%",$campname,$body);
//							}else{
//								$body    = str_replace($div,'',$body);
//								$body    = str_replace("%campName%",'UReserv',$body);
//							}
//							if($data['splstatus']){
//								$body	= str_replace("%splname%",$splname,$body);
//								$body	= str_replace("%splid%",$splid,$body);
////								$body	= str_replace("%orgprice%",$splorgprice,$body);
////								$body	= str_replace("%discount%",$spldiscount,$body);
////								$body	= str_replace("%price%",$splprice,$body);
//								$body	= str_replace("%spldesc%",$spldesc,$body);
//							}else{
//								$body	= str_replace($spldiv,'',$body);
//							}
							
							$receiverslist = $data['SenTo'];
						    
							$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
							$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
							$priorMapper = new Application_Model_PriorityDataMapper();
							$prior = $priorMapper->GetPriorityByCode('H');
							$msgMapper = new Notification_Model_EmailMessageDataMapper();
							$message = new Notification_Model_EmailMessage();
							$msgPhrase = uniqid ();
							$message->setBokid($bokid)
									->setPhrase($msgPhrase)
									->setTitle($mailobj->getMsgCode())
									->setDescription($body)
									->setPriority($prior->getcode())
									->setEmailtype($emailType->getcode())
									->setUsertype($userType)
									->setSentby('adminstrator@ureserv.com');
							$msgid = $msgMapper->SaveMessageDetails($message);
							$src = "http://www.ureserv.com/Notification/Notification/emailnotification/msgid/".$msgPhrase;
							$body	 = str_replace("%bookingsrc%",$src,$body);
							if($userType == 'CUS'){
								$cusMapper = new Notification_Model_EmailCusRecipentsDataMapper();
								$cusResult = $cusMapper->SaveCustMailDetails($msgid,$state,$city,$userType,$campId,$receiverslist);
							}
						    $mail->setFrom($fromaddress, $fromname);
						    $mail->setReplyTo($fromaddress,$fromname);
						    $mail->addTo( $receiverslist,$name);
						    $mail->setSubject($subject);
						    $mail->setBodyHtml($body);
						    $mailSentStatus = $mail->send();
						    return $mailSentStatus;
						}						
						break;	
						
						case 'BookConf' :
						case 'BookConfUber' :
            case 'BookConfTempAd' :
//						$template = $this->GetMessageTemplate($mailobj);
						$templateBdMapper = new Application_Model_EmailtemplateDataMapper();
						//getting book confirmation subject by code
						$templateSubject = $templateBdMapper->getEmailTempByCode('BookConf');
						$data     = $mailobj->getData();
						/**
						 * 
						 * To fetch Restaurant ID by Book ID
						 */
						$resDetails = new Booking_Model_BookingDataMapper;
						$resid = $resDetails->getRestIdByBookId($data['Bokid']);				
						$Service = new Application_Service_Restaurant;
						$CompanyDetails = $Service->restaurantCompanyDetails($resid);
						$CompanyId = $CompanyDetails->res_companyid;
						$templateBdMapper = new Application_Model_EmailtemplateDataMapper();
						$UserAgent = new Uss_Plugin_Context;
						$MobileView = $UserAgent->ismobile();
						if($resid == 3){
							$template = $templateBdMapper->getEmailTempByCode('BookConfTempAd2');
						} else if($resid == 1739){
							$template = $templateBdMapper->getEmailTempByCode('BookConfTempAdTasca'); 	
						} else if($CompanyId == 6 ){
							$fromaddress = 'reservations@makanluar.com';
							$fromname = 'MakanLuar Reservation';
							$template = $templateBdMapper->getEmailTempByCode('BookConfMakanLuar');
						//	if($resid == 2414){
						//	$template = $templateBdMapper->getEmailTempByCode('BookConfBlancoParMandif');
						//	}
						}else if($CompanyId == 1){
							$template = $templateBdMapper->getEmailTempByCode('BookConf');
							$template = $templateBdMapper->getEmailTempByCode('BookConfTempAd2');
						}
						else{
							$template = $templateBdMapper->getEmailTempByCode('Email_Message');
							$template = $templateBdMapper->getEmailTempByCode('BookConfTempAd2');
						}
						switch($resid) {
							case 2195:
							case 2196:
							case 2197:
							case 2198:
							case 2199:
							case 2575:
							case 2576:
								$template = $templateBdMapper->getEmailTempByCode('BookConfMooring');
								break;
							case 2474:
								$template = $templateBdMapper->getEmailTempByCode('BookConfEMC');
								break;
							case 2500:
								$template = $templateBdMapper->getEmailTempByCode('BookConfPavilion');
								break;

							case 2516:
								$template = $templateBdMapper->getEmailTempByCode('BookConfRoyalRooster');
								break;
							case 2522:
							case 2526:
							case 2527:
								$template = $templateBdMapper->getEmailTempByCode('BookConfCrownePlaza');
								break;
						}
						if($template){
//							$data     = $mailobj->getData();
							$campId = "";
							
							
							$name     = $data['UserName'];
							$restname = $data['RestName'];
							$resdate  = $data['ResDate'];
							$time     = $data['Time'];
							$size     = $data['Size'];
							$bokid    = $data['Bokid'];
							$state	  = $data['State_Id'];
							$city	  = $data['City_Id'];
							$phone    = $data['Phone'];
							$email    = $data['Email'];
							if(empty($email)) {
								$email = $data['email'];
							}
							if(empty($phone)) {
								$phone = $data['phone'];
							}
														
//							$spldiv = '<div style="background: #f1ede8;box-shadow: 5px 5px 30px #808080;-moz-box-shadow: 5px 5px 30px #808080;-khtml-box-shadow: 5px 5px 30px #808080;-webkit-box-shadow: 5px 5px 30px #808080;border:3px solid #643513; padding:8px; font-size:12px;"><div style="color:#F79646; font-weight:bold; text-align:center;">%splname%</div><br /><div style="color:#4f6228; font-weight:bold;">Special Id: %splid%</div><br /><br /><div style="color:#000048;">%spldesc%</div></div><br /><br />';
//							if($data['splstatus']){
//								$splid		= $data['splid']; 
//								$splname 	= $data['splname'];
//								$spldesc	= $data['spldesc'];
////								$splorgprice= $data['splorgprice'];
////								$spldiscount= $data['spldiscount'];
////								$splprice	= $data['splprice'];
//							}
							
							$userType = $data['UserType'];
//							$div = '<td width="45%" valign="top" align="left">%img%</br><div>%desc%</div></td>';
//							$imgDiv = '<div><img src="http://www.ureserv.com%img%" width="150" height="150"/></div>';
							if(isset($data['campId'])){
								$campId  	= $data['campId'];
								$campname 	= $data['campaignName'];
								$desc  		= $data['campaignDesc'];
								$img 	  	= $data['campaignImg'];
//								$desc  		= str_replace('src="','src="http://www.ureserv.com',$desc);
								$display  	= 'block';
							}
							
//							$notifcontdiv = '<div class="notificationcontent">%notifcont%</div><br/>';
//							if($data['notifcontstatus']){
//								$notifcont = $data['notifcont'];
//								$notifcont  = str_replace('src="','src="http://www.ureserv.com',$notifcont); 
//							}
						    //storing book confirmation subject in a variable
							$subject = $templateSubject->msg_subject;
							$body    = $template->msg_body;
							
							$body    = str_replace("%firstname%",trim($name),$body);
							$body    = str_replace("%restname%",trim($restname),$body);
							if($CompanyId == 6 || $CompanyId == 1 || $CompanyId == 2){
								
								$bookingmapper = new Booking_Model_BookingDataMapper();
								$phraseId = $bookingmapper->GetBookingPhraseByBookid($bokid);
								$address  = $data['Address'];
								$resphone = $data['resphone'];
								$status	  = $data['Status'];
								$resemail = $data['resemail'];
								$reszipcode = $data['reszipcode'];
								$rescity  = $data['rescity'];
								$resnbh   = $data['resnbh'];
								$booknotes= $data['BookNotes'];
								
								$body	 = str_replace("%bokid%",$phraseId,$body);
								$body	 = str_replace("%bookingid%",$bokid,$body);

								/* $body    = str_replace("%date%",trim($resdate),$body); */

								/* Convert Date to string */ 
								
								/* Set time zone */
								
								$resServ = new Application_Service_Restaurant();
								$timeZone = $resServ->GetRestaurantTimeZone($resid);
								date_default_timezone_set($timeZone);
								
								$indodate = trim($resdate);

								$indodatesplit = explode("-",$indodate); 
								$indoStringDate = date("F j, Y", mktime(0,0,0,$indodatesplit[0],$indodatesplit[1],$indodatesplit[2]));								
								$body    = str_replace("%date%",$indoStringDate,$body);

								$body    = str_replace("%time%",trim($time),$body);
								$body    = str_replace("%size%",trim($size),$body);
								$body	 = str_replace("%address%",$address,$body);
								$body	 = str_replace("%resphone%",$resphone,$body);
								$body	 = str_replace("%resnbh%",$resnbh,$body);
								$body	 = str_replace("%rescity%",$rescity,$body);
								$body	 = str_replace("%resemail%",$resemail,$body);
								$body	 = str_replace("%reszipcode%",$reszipcode,$body);
								$body    = str_replace("%resid%",$resid,$body);							
								$body    = str_replace("%phone%",$phone,$body);
								$body    = str_replace("%email%",$email,$body);
								$body    = str_replace("%specialrequest%",$booknotes,$body);
								$body    = str_replace("%submitdate%",date("F j, Y"),$body);
							}
							
							$body 	 = str_replace("ï¿½",'',$body);
//							if(isset($data['campId'])){
//								$body    = str_replace("none",$display,$body);
//								$body    = str_replace("%desc%",$desc,$body);
//								if($data['campaignImg']){
//									$imgDiv 	= str_replace("%img%",$img,$imgDiv);
//									$body    	= str_replace("%img%",$imgDiv,$body);
//								}else{
//									$body    = str_replace($imgDiv,'',$body);
//								}
//								$body    = str_replace("%campName%",$campname,$body);
//							}else{
//								$body    = str_replace($div,'',$body);
//								$body    = str_replace("%campName%",'UReserv',$body);
//							}
//							if($data['splstatus']){
//								$body	= str_replace("%splname%",$splname,$body);
//								$body	= str_replace("%splid%",$splid,$body);
////								$body	= str_replace("%orgprice%",$splorgprice,$body);
////								$body	= str_replace("%discount%",$spldiscount,$body);
////								$body	= str_replace("%price%",$splprice,$body);
//								$body	= str_replace("%spldesc%",$spldesc,$body);
//							}else{
//								$body	= str_replace($spldiv,'',$body);
//							}
//							
//							if($data['notifcontstatus']){
//								$body	= str_replace("%notifcont%",$notifcont,$body);
//							}else{
//								$body	= str_replace($notifcontdiv,'',$body);
//							}
							
							$receiverslist = $data['SenTo'];
						    
							$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
							$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
							$priorMapper = new Application_Model_PriorityDataMapper();
							$prior = $priorMapper->GetPriorityByCode('H');
							$msgMapper = new Notification_Model_EmailMessageDataMapper();
							$message = new Notification_Model_EmailMessage();
							$msgPhrase = uniqid ();
							/**
							 * 
							 * To save message details with respect to URESERV or Reward restaurants 
							 */
							if($CompanyId == 2){
								$message->setBokid($bokid)
										->setPhrase($msgPhrase)
										->setTitle($mailTemplate)
										->setDescription($body)
										->setPriority($prior->getcode())
										->setEmailtype($emailType->getcode())
										->setUsertype($userType)
										->setSentby('adminstrator@ureserv.com');
							}else{
								$message->setBokid($bokid)
										->setPhrase($msgPhrase)
										->setTitle($mailobj->getMsgCode())
										->setDescription($body)
										->setPriority($prior->getcode())
										->setEmailtype($emailType->getcode())
										->setUsertype($userType)
										->setSentby('adminstrator@ureserv.com');	
							}
							$msgid = $msgMapper->SaveMessageDetails($message);
							$src = "http://www.ureserv.com/Notification/Notification/emailnotification/msgid/".$msgPhrase;
							$body	 = str_replace("%bookingsrc%",$src,$body);
							if($userType == 'CUS'){
								$cusMapper = new Notification_Model_EmailCusRecipentsDataMapper();
								$cusResult = $cusMapper->SaveCustMailDetails($msgid,$state,$city,$userType,$campId,$receiverslist);
							}
						    $mail->setFrom($fromaddress, $fromname);
						    $mail->setReplyTo($fromaddress,$fromname);
						    $mail->addTo( $receiverslist,$name);
						    $mail->setSubject($subject);
						    $mail->setBodyHtml($body);
						    $status = $mail->send();
						}						
						break;	
						
						case 'BookNotf' :
								
//							$template = $this->GetMessageTemplate($mailobj);
							$templateBdMapper = new Application_Model_EmailtemplateDataMapper();
							//getting book notification subject by code
							$templateSubject = $templateBdMapper->getEmailTempByCode('BookNotf');
//							$template = $templateBdMapper->getEmailTempByCode('Email_Message');
							$data     = $mailobj->getData();
							/**
							 * 
							 * To fetch Restaurant ID by Book ID
							 */
							$resDetails = new Booking_Model_BookingDataMapper;
							$resid = $resDetails->getRestIdByBookId($data['Bookid']);
							$Service = new Application_Service_Restaurant;
							$CompanyDetails = $Service->restaurantCompanyDetails($resid);
							$CompanyId = $CompanyDetails->res_companyid;
							$UserAgent = new Uss_Plugin_Context;
							$MobileView = $UserAgent->ismobile();
							$templateBdMapper = new Application_Model_EmailtemplateDataMapper();
							if($CompanyId ==2){
								$mailTemplate= "BookNotfRN";
								$fromaddress = 'reservations@rewardsnetwork.com';
								$fromname = 'Rewards Network';
								if($MobileView['is_mobile'] == 1){
									$mailTemplate .= "Mobile";
									$browserMode = 'm';
								}
								$template = $templateBdMapper->getEmailTempByCode($mailTemplate);
							}else if($CompanyId == 6 ){
								$fromaddress = 'reservations@makanluar.com';
								$fromname = 'MakanLuar Reservation';
								$template = $templateBdMapper->getEmailTempByCode('BookNotfMakanLuar');
							}else if($CompanyId == 1 ){
								$template = $templateBdMapper->getEmailTempByCode('BookNotf');	
							}else{
								$template = $templateBdMapper->getEmailTempByCode('Email_Message');	
							}
							switch($resid) {
        	                                                case 2195:
	                                                        case 2196:
                	                                        case 2197:
                        	                                case 2198:
                                	                        case 2199:
								case 2575:
								case 2576:
                                        	                        $template = $templateBdMapper->getEmailTempByCode('BookConfMooring');
                                                	                break;
	                                                        case 2474:
        	                                                        $template = $templateBdMapper->getEmailTempByCode('BookConfEMC');
                	                                                break;
                        	                                case 2500:
                                	                                $template = $templateBdMapper->getEmailTempByCode('BookConfPavilion');
                                        	                        break;

                                                	        case 2516:
                                                        	        // $template = $templateBdMapper->getEmailTempByCode('BookConfRoyalRooster');
                                	                              	break;
								case 2522:
        	                                                case 2526:
	                                                        case 2527:
                	                                                $template = $templateBdMapper->getEmailTempByCode('BookNotfCrownePlaza');
                        	                                        break;

	                                                }

							if($template){
//								$data     = $mailobj->getData();
								$campId = "";
								$receiverslist = $data['SenTo'];
								if(count($receiverslist) > 1){
									$ToArr =  $receiverslist;
								}else{
									$ToArr = $receiverslist[0];
								}
								
								$name     = $data['UserName'];
								$restname = $data['RestName'];
								$resdate  = $data['ResDate'];
								$time     = $data['Time'];
								$size     = $data['Size'];
//								$address  = $data['Address'];
								$bookid	  = $data['Bookid'];
								$state	  = $data['State_Id'];
								$city	  = $data['City_Id'];
								$userType = $data['UserType'];
//								$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div>%img%</br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
//								$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.ureserv.com%img%" width="150" height="150"/>';
//								$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div><div><a class="linkopacity" target="newwindow">%img%</a></div></br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
//								$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.ureserv.com%img%" width="150" height="150"/>';
								
								if(isset($data['campId'])){
									$campId   = $data['campId'];
									$campname 	= $data['campaignName'];
									$desc  = $data['campaignDesc'];
									$img = $data['campaignImg'];
									$desc  = str_replace('src="','src="http://www.ureserv.com',$desc);
									$display  = 'block';
								}
							   	//storing book notification subject in a variable
								if($CompanyId == 6 ){
									$subject = 'Reservation Confirmation';
								}else{
									$subject = $templateSubject->msg_subject;
								}								
								
								$body    = $template->msg_body;
								
								$body    = str_replace("%custname%",trim($name),$body);
								$body    = str_replace("%firstname%",$restname,$body);
								$body    = str_replace("%restname%",trim($restname),$body);
								if($CompanyId == 6 || $CompanyId == 1){
									$email    = $data['email'];
									$phone    = $data['phone'];
									$note     = $data['Note'];
									
									/* $body    = str_replace("%date%",trim($resdate),$body); */

									/* Convert Date to string */ 
									
									/* Set time zone */
								
									$resServ = new Application_Service_Restaurant();
									$timeZone = $resServ->GetRestaurantTimeZone($resid);
									date_default_timezone_set($timeZone);
								
									$indodate = trim($resdate);

									$indodatesplit = explode("-",$indodate); 
									$indoStringDate = date("F j, Y", mktime(0,0,0,$indodatesplit[0],$indodatesplit[1],$indodatesplit[2]));								
									$body    = str_replace("%date%",$indoStringDate,$body);

									$body    = str_replace("%time%",trim($time),$body);
									$body    = str_replace("%size%",trim($size),$body);
	//								$body	 = str_replace("%address%",$address,$body);
									$body	 = str_replace("%bookid%",$bookid,$body);
									$body	 = str_replace("%email%",$email,$body);
									$body	 = str_replace("%phone%",$phone,$body);
									$body	 = str_replace("%note%",$note,$body);
									$body    = str_replace("%submitdate%",date("F j, Y"),$body);
								}
								
								$body 	 = str_replace("ï¿½",'',$body);
//								
//								if(isset($data['campId'])){
//									$body    = str_replace("none",$display,$body);
//									$body    = str_replace("%desc%",$desc,$body);
//									if($data['campaignImg']){
//										$imgDiv 	= str_replace("%img%",$img,$imgDiv);
//										$body    	= str_replace("%img%",$imgDiv,$body);								
//									}else{
//										$body    = str_replace("%img%",'',$body);
//									}
//									$body    = str_replace("%campName%",$campname,$body);
//								}else{
//									$body    = str_replace($div,'',$body);
//								}
								$receiverslist = $data['SenTo'];
							    
								$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
								$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
								$priorMapper = new Application_Model_PriorityDataMapper();
								$prior = $priorMapper->GetPriorityByCode('H');
								$msgMapper = new Notification_Model_EmailMessageDataMapper();
								$message = new Notification_Model_EmailMessage();
								$msgPhrase = uniqid ();
								/**
								 * 
								 * To save message details with respect to URESERV or Reward restaurants 
								 */
								if($CompanyId==2){
									$message->setBokid($bookid)
										->setPhrase($msgPhrase)
										->setTitle($mailTemplate)
										->setDescription($body)
										->setPriority($prior->getcode())
										->setEmailtype($emailType->getcode())
										->setUsertype($userType)
										->setSentby('adminstrator@ureserv.com');
								}else{
									$message->setBokid($bookid)
										->setPhrase($msgPhrase)
										->setTitle($mailobj->getMsgCode())
										->setDescription($body)
										->setPriority($prior->getcode())
										->setEmailtype($emailType->getcode())
										->setUsertype($userType)
										->setSentby('adminstrator@ureserv.com');
								}
								$msgid = $msgMapper->SaveMessageDetails($message);
								$src = "http://www.ureserv.com/Notification/Notification/emailnotification/msgid/".$msgPhrase;
								$body	 = str_replace("%bookingsrc%",$src,$body);
								if($userType == 'RES'){
									$cusMapper = new Notification_Model_EmailRestRecipentsDataMapper();
									$cusResult = $cusMapper->SaveRestMailDetails($msgid,$state,$city,$userType,$campId,$receiverslist);
								}
								$mail->setFrom($fromaddress, $fromname);
							    $mail->setReplyTo($fromaddress,$fromname);
							    //$mail->addTo( $receiverslist,$name);
							    $mail->addBcc($ToArr);
							    $mail->setSubject($subject);
							    $mail->setBodyHtml($body);
							    $mail->send();
							}
						
						break;
					case 'BookRescheduleNotf' :
								
//							$template = $this->GetMessageTemplate($mailobj);
							$templateBdMapper = new Application_Model_EmailtemplateDataMapper();
							//getting book notification subject by code
							$templateSubject = $templateBdMapper->getEmailTempByCode('BookNotf');
//							$template = $templateBdMapper->getEmailTempByCode('Email_Message');
							$data     = $mailobj->getData();
							/**
							 * 
							 * To fetch Restaurant ID by Book ID
							 */
							$resDetails = new Booking_Model_BookingDataMapper;
							$resid = $resDetails->getRestIdByBookId($data['Bookid']);
							$Service = new Application_Service_Restaurant;
							$CompanyDetails = $Service->restaurantCompanyDetails($resid);
							$CompanyId = $CompanyDetails->res_companyid;
							$UserAgent = new Uss_Plugin_Context;
							$MobileView = $UserAgent->ismobile();
							$templateBdMapper = new Application_Model_EmailtemplateDataMapper();
							if($CompanyId ==2){
								$mailTemplate= "BookNotfRN";
								$fromaddress = 'reservations@rewardsnetwork.com';
								$fromname = 'Rewards Network';
								if($MobileView['is_mobile'] == 1){
									$mailTemplate .= "Mobile";
									$browserMode = 'm';
								}
								$template = $templateBdMapper->getEmailTempByCode($mailTemplate);
							}else if($CompanyId == 6 ){
								$fromaddress = 'reservations@makanluar.com';
								$fromname = 'MakanLuar Reschedule';
								$template = $templateBdMapper->getEmailTempByCode('BookNotfRescheduleMakanLuar');
							}else if($CompanyId == 1 ){
								$template = $templateBdMapper->getEmailTempByCode('BookNotf');	
							}else{
								$template = $templateBdMapper->getEmailTempByCode('Email_Message');	
							}
							if($template){
//								$data     = $mailobj->getData();
								$campId = "";
								$receiverslist = $data['SenTo'];
								if(count($receiverslist) > 1){
									$ToArr =  $receiverslist;
								}else{
									$ToArr = $receiverslist[0];
								}
								
								$name     = $data['UserName'];
								$restname = $data['RestName'];
								$resdate  = $data['ResDate'];
								$time     = $data['Time'];
								$size     = $data['Size'];
//								$address  = $data['Address'];
								$bookid	  = $data['Bookid'];
								$state	  = $data['State_Id'];
								$city	  = $data['City_Id'];
								$userType = $data['UserType'];
//								$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div>%img%</br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
//								$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.ureserv.com%img%" width="150" height="150"/>';
//								$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div><div><a class="linkopacity" target="newwindow">%img%</a></div></br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
//								$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.ureserv.com%img%" width="150" height="150"/>';
								
								if(isset($data['campId'])){
									$campId   = $data['campId'];
									$campname 	= $data['campaignName'];
									$desc  = $data['campaignDesc'];
									$img = $data['campaignImg'];
									$desc  = str_replace('src="','src="http://www.ureserv.com',$desc);
									$display  = 'block';
								}
							   	//storing book notification subject in a variable
								if($CompanyId == 6 ){
									$subject = 'Reservation Confirmation';
								}else{
									$subject = $templateSubject->msg_subject;
								}								
								
								$body    = $template->msg_body;
								
								$body    = str_replace("%custname%",trim($name),$body);
								$body    = str_replace("%firstname%",$restname,$body);
								$body    = str_replace("%restname%",trim($restname),$body);
								if($CompanyId == 6 || $CompanyId == 1){
									$email    = $data['Email'];
									$phone    = $data['Phone'];
									$note     = $data['Note'];
									
									/* $body    = str_replace("%date%",trim($resdate),$body); */

									/* Convert Date to string */ 
									
									/* Set time zone */
								
									$resServ = new Application_Service_Restaurant();
									$timeZone = $resServ->GetRestaurantTimeZone($resid);
									date_default_timezone_set($timeZone);
								
									$indodate = trim($resdate);

									$indodatesplit = explode("-",$indodate); 
									$indoStringDate = date("F j, Y", mktime(0,0,0,$indodatesplit[0],$indodatesplit[1],$indodatesplit[2]));								
									$body    = str_replace("%date%",$indoStringDate,$body);

									$body    = str_replace("%time%",trim($time),$body);
									$body    = str_replace("%size%",trim($size),$body);
	//								$body	 = str_replace("%address%",$address,$body);
									$body	 = str_replace("%bookid%",$bookid,$body);
									$body	 = str_replace("%email%",$email,$body);
									$body	 = str_replace("%phone%",$phone,$body);
									$body	 = str_replace("%note%",$note,$body);
								}
								
								$body 	 = str_replace("Ã¯Â¿Â½",'',$body);
//								
//								if(isset($data['campId'])){
//									$body    = str_replace("none",$display,$body);
//									$body    = str_replace("%desc%",$desc,$body);
//									if($data['campaignImg']){
//										$imgDiv 	= str_replace("%img%",$img,$imgDiv);
//										$body    	= str_replace("%img%",$imgDiv,$body);								
//									}else{
//										$body    = str_replace("%img%",'',$body);
//									}
//									$body    = str_replace("%campName%",$campname,$body);
//								}else{
//									$body    = str_replace($div,'',$body);
//								}
								$receiverslist = $data['SenTo'];
							    
								$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
								$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
								$priorMapper = new Application_Model_PriorityDataMapper();
								$prior = $priorMapper->GetPriorityByCode('H');
								$msgMapper = new Notification_Model_EmailMessageDataMapper();
								$message = new Notification_Model_EmailMessage();
								$msgPhrase = uniqid ();
								/**
								 * 
								 * To save message details with respect to URESERV or Reward restaurants 
								 */
								if($CompanyId==2){
									$message->setBokid($bookid)
										->setPhrase($msgPhrase)
										->setTitle($mailTemplate)
										->setDescription($body)
										->setPriority($prior->getcode())
										->setEmailtype($emailType->getcode())
										->setUsertype($userType)
										->setSentby('adminstrator@ureserv.com');
								}else{
									$message->setBokid($bookid)
										->setPhrase($msgPhrase)
										->setTitle($mailobj->getMsgCode())
										->setDescription($body)
										->setPriority($prior->getcode())
										->setEmailtype($emailType->getcode())
										->setUsertype($userType)
										->setSentby('adminstrator@ureserv.com');
								}
								$msgid = $msgMapper->SaveMessageDetails($message);
								$src = "http://www.ureserv.com/Notification/Notification/emailnotification/msgid/".$msgPhrase;
								$body	 = str_replace("%bookingsrc%",$src,$body);
								if($userType == 'RES'){
									$cusMapper = new Notification_Model_EmailRestRecipentsDataMapper();
									$cusResult = $cusMapper->SaveRestMailDetails($msgid,$state,$city,$userType,$campId,$receiverslist);
								}
								$mail->setFrom($fromaddress, $fromname);
							    $mail->setReplyTo($fromaddress,$fromname);
							    //$mail->addTo( $receiverslist,$name);
							    $mail->addBcc($ToArr);
							    $mail->setSubject($subject);
							    $mail->setBodyHtml($body);
							    $mail->send();
							}
						
						break;
	
					case 'BookNotCan' :
								
//							$template = $this->GetMessageTemplate($mailobj);
							$templateBdMapper = new Application_Model_EmailtemplateDataMapper();
							//getting book notification cancellation subject by code
							$templateSubject = $templateBdMapper->getEmailTempByCode('BookNotCan');
//							$template = $templateBdMapper->getEmailTempByCode('Email_Message');
							$data     = $mailobj->getData();
							/**
							 * 
							 * To fetch Restaurant ID by Book ID
							 */
							$resDetails = new Booking_Model_BookingDataMapper;
							$resid = $resDetails->getRestIdByBookId($data['Bookid']);
							$Service = new Application_Service_Restaurant;
							$CompanyDetails = $Service->restaurantCompanyDetails($resid);
							$CompanyId = $CompanyDetails->res_companyid;
							$UserAgent = new Uss_Plugin_Context;
							$MobileView = $UserAgent->ismobile();
							$templateBdMapper = new Application_Model_EmailtemplateDataMapper();
							if($CompanyId ==2){
								$mailTemplate= "BookNotCanRN";
								$fromaddress = 'reservations@rewardsnetwork.com';
								$fromname = 'Rewards Network';
								if($MobileView['is_mobile'] == 1){
									$mailTemplate .= "Mobile";
									$browserMode = 'm';
								}
								$template = $templateBdMapper->getEmailTempByCode($mailTemplate);
							}else if($CompanyId == 6 ){
								$fromaddress = 'reservations@makanluar.com';
								$fromname = 'MakanLuar Reservation';
								$template = $templateBdMapper->getEmailTempByCode('BookNotCanMakanLuar');
							}else if($CompanyId == 1){
								$template = $templateBdMapper->getEmailTempByCode('BookNotCan');
							}else{
								$template = $templateBdMapper->getEmailTempByCode('Email_Message');
							}
							if($template){
//								$data     = $mailobj->getData();
								$campId = '';

								$receiverslist = $data['SenTo'];
								if(count($receiverslist) > 1){
									$ToArr =  $receiverslist;
								}else{
									$ToArr = $receiverslist[0];
								}
								
								$name     = $data['UserName'];
								$restname = $data['RestName'];
								$resdate  = $data['ResDate'];
								$time     = $data['Time'];
								$size     = $data['Size'];
//								$address  = $data['Address'];
								$bookid	  = $data['Bookid'];
								$state	  = $data['State_Id'];
								$city	  = $data['City_Id'];
								$userType = $data['UserType'];
//								$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div>%img%</br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
//								$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.ureserv.com%img%" width="150" height="150"/>';
//								$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div><div><a class="linkopacity" target="newwindow">%img%</a></div></br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
//								$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.ureserv.com%img%" width="150" height="150"/>';
								
								if(isset($data['campId'])){
									$campId   = $data['campId'];
									$campname 	= $data['campaignName'];
									$desc  = $data['campaignDesc'];
									$img = $data['campaignImg'];
									$desc  = str_replace('src="','src="http://www.ureserv.com',$desc);
									$display  = 'block';
								}
								//storing booknotification cancellation subject in a variable
								$subject = $templateSubject->msg_subject;
								$body    = $template->msg_body;
								
								$body    = str_replace("%firstname%",trim($restname),$body);
								$body    = str_replace("%custname%",trim($name),$body);
								$body    = str_replace("%restname%",trim($restname),$body);

								if($CompanyId == 6 ||  $CompanyId == 1){
								/* Convert Date to string */ 
							
									/* Set time zone */
								
									$resServ = new Application_Service_Restaurant();
									$timeZone = $resServ->GetRestaurantTimeZone($resid);
									date_default_timezone_set($timeZone);
									
									$indodate = trim($resdate);

									$indodatesplit = explode("-",$indodate); 
									$indoStringDate = date("F j, Y", mktime(0,0,0,$indodatesplit[1],$indodatesplit[2],$indodatesplit[0]));								
									$body    = str_replace("%date%",$indoStringDate,$body);
								
								}else{
									$body    = str_replace("%date%",$resdate,$body);
								}

								$body    = str_replace("%time%",trim($time),$body);
								$body    = str_replace("%size%",trim($size),$body);
//								$body	 = str_replace("%address%",$address,$body);
								if($CompanyId == 6 || $CompanyId == 1){
									$email  = $data['email'];
									$phone  = $data['phone'];
									
									$body	 = str_replace("%bookid%",$bookid,$body);
									$body	 = str_replace("%email%",$email,$body);
									$body	 = str_replace("%phone%",$phone,$body);
								}
								$body 	 = str_replace("ï¿½",'',$body);
								
//								if(isset($data['campId'])){
//									$body    = str_replace("none",$display,$body);
//									$body    = str_replace("%desc%",$desc,$body);
//									if($data['campaignImg']){
//										$imgDiv 	= str_replace("%img%",$img,$imgDiv);
//										$body    	= str_replace("%img%",$imgDiv,$body);								
//									}else{
//										$body    = str_replace("%img%",'',$body);
//									}
//									$body    = str_replace("%campName%",$campname,$body);
//								}else{
//									$body    = str_replace($div,'',$body);
//								}
								$receiverslist = $data['SenTo'];
							    
								$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
								$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
								$priorMapper = new Application_Model_PriorityDataMapper();
								$prior = $priorMapper->GetPriorityByCode('H');
								$msgMapper = new Notification_Model_EmailMessageDataMapper();
								$message = new Notification_Model_EmailMessage();
								$msgPhrase = uniqid ();
								/**
								 * 
								 * To save message details with respect to URESERV or Reward restaurants 
								 */
								if($CompanyId ==2){
									$message->setBokid($bookid)
											->setPhrase($msgPhrase)
											->setTitle($mailTemplate)
											->setDescription($body)
											->setPriority($prior->getcode())
											->setEmailtype($emailType->getcode())
											->setUsertype($userType)
											->setSentby('adminstrator@ureserv.com');
								}else{
									$message->setBokid($bookid)
											->setPhrase($msgPhrase)
											->setTitle($mailobj->getMsgCode())
											->setDescription($body)
											->setPriority($prior->getcode())
											->setEmailtype($emailType->getcode())
											->setUsertype($userType)
											->setSentby('adminstrator@ureserv.com');
								}
								$msgid = $msgMapper->SaveMessageDetails($message);
								$src = "http://www.ureserv.com/Notification/Notification/emailnotification/msgid/".$msgPhrase;
								$body	 = str_replace("%bookingsrc%",$src,$body);
								if($userType == 'RES'){
									$cusMapper = new Notification_Model_EmailRestRecipentsDataMapper();
									$cusResult = $cusMapper->SaveRestMailDetails($msgid,$state,$city,$userType,$campId,$receiverslist);
								}
								$mail->setFrom($fromaddress, $fromname);
							    $mail->setReplyTo($fromaddress,$fromname);
							    //$mail->addTo( $receiverslist,$name);
							    $mail->addBcc($ToArr);
							    $mail->setSubject($subject);
							    $mail->setBodyHtml($body);
							    $mail->send();
							}
						
						break;	
						
					case 'Success_Confirmation' :
						$template = $this->GetMessageTemplate($mailobj);
						
						if($template){
							$data    = $mailobj->getData();
							$name    = $data['UserName'];
							$resname = $data['resname'];
							$subject = $template->msg_subject;
							$body    = $template->msg_body;							
							$body    = str_replace("%firstname%",$name,$body);
							$body	 = str_replace("%Restaurant Name%",$resname,$body);
							$body 	 = str_replace("ï¿½",'',$body);
							$receiverslist = $data['SenTo'];
							
							$mail->setFrom($fromaddress, $fromname);
						    $mail->setReplyTo($fromaddress,$fromname);
						    $mail->addTo( $receiverslist,$name);
						    $mail->setSubject($subject);
						    $mail->setBodyHtml($body);
						    $mail->send();
						}
						break;
						
					case 'Restaurant_approved' :
						$template = $this->GetMessageTemplate($mailobj);
						
						if($template){
							$campId = '';
							$data    = $mailobj->getData();
							$name    = $data['UserName'];
							$resname = $data['resname'];
							$state	  = $data['State_Id'];
							$city	  = $data['City_Id'];
							$userType = $data['UserType'];
							$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div>%img%</br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
							$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.ureserv.com%img%" width="150" height="150"/>';
//							$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div><div><a class="linkopacity" target="newwindow">%img%</a></div></br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
//							$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.ureserv.com%img%" width="150" height="150"/>';
							
							if(isset($data['campId'])){
								$campId   = $data['campId'];
								$campname 	= $data['campaignName'];
								$desc  = $data['campaignDesc'];
								$img = $data['campaignImg'];
								$desc  = str_replace('src="','src="http://www.ureserv.com',$desc);
								$display  = 'block';
							}
							
							$subject = $template->msg_subject;
							$body    = $template->msg_body;							
							$body    = str_replace("%firstname%",$name,$body);
							$body	 = str_replace("%Restaurant Name%",$resname,$body);
							$body 	 = str_replace("ï¿½",'',$body);
							
							if(isset($data['campId'])){
								$body    = str_replace("none",$display,$body);
								$body    = str_replace("%desc%",$desc,$body);
								if($data['campaignImg']){
									$imgDiv 	= str_replace("%img%",$img,$imgDiv);
									$body    	= str_replace("%img%",$imgDiv,$body);								
									}else{
										$body    = str_replace("%img%",'',$body);
								}
								$body    = str_replace("%campName%",$campname,$body);
							}else{
								$body    = str_replace($div,'',$body);
							}
							$receiverslist = $data['SenTo'];
						    
							$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
							$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
							$priorMapper = new Application_Model_PriorityDataMapper();
							$prior = $priorMapper->GetPriorityByCode('H');
							$msgMapper = new Notification_Model_EmailMessageDataMapper();
							$message = new Notification_Model_EmailMessage();
							$message->setTitle($mailobj->getMsgCode())
									->setDescription($body)
									->setPriority($prior->getcode())
									->setEmailtype($emailType->getcode())
									->setUsertype($userType)
									->setSentby('adminstrator@ureserv.com');
							$msgid = $msgMapper->SaveMessageDetails($message);
//							if($userType == 'RES'){
//								$cusMapper = new Notification_Model_EmailRestRecipentsDataMapper();
//								$cusResult = $cusMapper->SaveRestMailDetails($msgid,$state,$city,$userType,$campId,$receiverslist);
//							}
							
							$mail->setFrom($fromaddress, $fromname);
							$mail->setReplyTo($fromaddress,$fromname);
							$mail->addTo( $receiverslist,$name);
						    $mail->setSubject($subject);
						    $mail->setBodyHtml($body);
						    $mail->send();
						}
						break;
						
					case 'WalBookConf' :
						$template = $this->GetMessageTemplate($mailobj);
						$campId = '';
						$data     = $mailobj->getData();
						
						$name     = $data['UserName'];
						$restname = $data['RestName'];
						$resdate  = $data['ResDate'];
						$time     = $data['Time'];
						$size     = $data['Size'];
						$address  = $data['Address'];
						$resphone = $data['resphone'];
						$status	  = $data['Status'];
						$state	  = $data['State_Id'];
						$city	  = $data['City_Id'];
						$userType = $data['UserType'];
						$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div>%img%</br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
						$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.ureserv.com%img%" width="150" height="150"/>';
							
//						$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div><div><a class="linkopacity" target="newwindow">%img%</a></div></br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
//						$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.ureserv.com%img%" width="150" height="150"/>';
						
						if(isset($data['campId'])){
							$campId   = $data['campId'];
							$campname 	= $data['campaignName'];
							$desc  = $data['campaignDesc'];
							$img  = $data['campaignImg'];
							$desc  = str_replace('src="','src="http://www.ureserv.com',$desc);
							$display  = 'block';
						}
						$receiverslist = $data['SenTo'];
						
						$subject = $template->msg_subject;
						$body    = $template->msg_body;
						
						$body    = str_replace("%firstname%",$name,$body);
						$body    = str_replace("%restname%",$restname,$body);
						$body    = str_replace("%date%",$resdate,$body);
						$body    = str_replace("%time%",$time,$body);
						$body    = str_replace("%size%",$size,$body);
						$body	 = str_replace("%address%",$address,$body);
						$body	 = str_replace("%resphone%",$resphone,$body);
						$body 	 = str_replace("ï¿½",'',$body);
						
						if(isset($data['campId'])){
							$body    = str_replace("none",$display,$body);
							$body    = str_replace("%desc%",$desc,$body);
							if($data['campaignImg']){
								$imgDiv 	= str_replace("%img%",$img,$imgDiv);
								$body    	= str_replace("%img%",$imgDiv,$body);								
							}else{
								$body    = str_replace("%img%",'',$body);
							}
							$body    = str_replace("%campName%",$campname,$body);
						}else{
								$body    = str_replace($div,'',$body);
							}
						$receiverslist = $data['SenTo'];
					    
						$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
						$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
						$priorMapper = new Application_Model_PriorityDataMapper();
						$prior = $priorMapper->GetPriorityByCode('H');
						$msgMapper = new Notification_Model_EmailMessageDataMapper();
						$message = new Notification_Model_EmailMessage();
						$message->setTitle($mailobj->getMsgCode())
								->setDescription($body)
								->setPriority($prior->getcode())
								->setEmailtype($emailType->getcode())
								->setUsertype($userType)
								->setSentby('adminstrator@ureserv.com');
						$msgid = $msgMapper->SaveMessageDetails($message);
						if($userType == 'CUS'){
							$cusMapper = new Notification_Model_EmailCusRecipentsDataMapper();
							$cusResult = $cusMapper->SaveCustMailDetails($msgid,$state,$city,$userType,$campId,$receiverslist);
						}
						$mail->setFrom($fromaddress, $fromname);
					    $mail->setReplyTo($fromaddress,$fromname);
					    $mail->addTo( $receiverslist,$name);
					    $mail->setSubject($subject);
					    $mail->setBodyHtml($body);
					    $mail->send();
						break;
						
					case 'WaltoRsdBookConf' :
						$template = $this->GetMessageTemplate($mailobj);
						
						$data     = $mailobj->getData();
						
						$name     = $data['UserName'];
						$restname = $data['RestName'];
						$resdate  = $data['ResDate'];
						$time     = $data['Time'];
						$size     = $data['Size'];
						$address  = $data['Address'];
						$status	  = $data['Status'];
						
						$subject = $template->msg_subject;
						$body    = $template->msg_body;
						
						$body    = str_replace("%firstname%",$name,$body);
						$body    = str_replace("%restname%",$restname,$body);
						$body    = str_replace("%date%",$resdate,$body);
						$body    = str_replace("%time%",$time,$body);
						$body    = str_replace("%size%",$size,$body);
						$body	 = str_replace("%address%",$address,$body);
						$body 	 = str_replace("ï¿½",'',$body);
						$receiverslist = $data['SenTo'];
						$mail->setFrom($fromaddress, $fromname);
					    $mail->setReplyTo($fromaddress,$fromname);
					    $mail->addTo( $receiverslist,$name);
					    $mail->setSubject($subject);
					    $mail->setBodyHtml($body);
					    $mail->send();	
						break;	
					case 'Restaurant_Creation_Conf' :
						$template = $this->GetMessageTemplate($mailobj);
						
						if($template){
							$data    = $mailobj->getData();
							$name    = $data['UserName'];
							$resname = $data['resname'];
							$subject = $template->msg_subject;
							$body    = $template->msg_body;							
							$body    = str_replace("%firstname%",$name,$body);
							$body	 = str_replace("%Restaurant Name%",$resname,$body);
							$body 	 = str_replace("ï¿½",'',$body);
							$receiverslist = $data['SenTo'];
							
							$mail->setFrom($fromaddress, $fromname);
						    $mail->setReplyTo($fromaddress,$fromname);
						    $mail->addTo( $receiverslist,$name);
						    $mail->setSubject($subject);
						    $mail->setBodyHtml($body);
						    $mail->send();
						  	
						}
						
						break;
						
					case 'Invoice' :
						$template = $this->GetMessageTemplate($mailobj);
						
						if($template){
							$data    	= $mailobj->getData();
							$name    	= $data['UserName'];
							$subject 	= $data['subject'];
							$body    	= $template->msg_body;							
							$body    	= str_replace("%firstname%",$name,$body);
							$body 	 	= str_replace("ï¿½",'',$body);
							$receiverslist = $data['SenTo'];
							
							$mail->setFrom($fromaddress, $fromname);
						    $mail->setReplyTo($fromaddress,$fromname);
						    $mail->addTo( $receiverslist,$name);
						    $mail->setSubject($subject);
						    $mail->setBodyHtml($body);
						    
						    $fileContents = file_get_contents($data['path']);
							$at = $mail->createAttachment($fileContents);
							$at->type = Zend_Mime::TYPE_OCTETSTREAM;
							$at->disposition = Zend_Mime::DISPOSITION_INLINE;
							$at->encoding = Zend_Mime::ENCODING_BASE64;
							$at->filename = 'invoice- '.date('Y-m-d').'.pdf';
							
						    $mail->send();
						}
						break;
						
					case 'PostInvoice' :
						
						$template = $this->GetMessageTemplate($mailobj);
						
						if($template){
							$data    	= $mailobj->getData();
							$name    	= $data['UserName'];
							$subject 	= $data['subject'];
							$body    	= $template->msg_body;							
							$body    	= str_replace("%firstname%",$name,$body);
							$body 	 	= str_replace("ï¿½",'',$body);
							$receiverslist = $data['SenTo'];
							
							$mail->setFrom($fromaddress, $fromname);
						    $mail->setReplyTo($fromaddress,$fromname);
						    $mail->addTo( $receiverslist,$name);
						    $mail->setSubject($subject);
						    $mail->setBodyHtml($body);
						    
						    $fileContents = file_get_contents($data['path']);
							$at = $mail->createAttachment($fileContents);
							$at->type = Zend_Mime::TYPE_OCTETSTREAM;
							$at->disposition = Zend_Mime::DISPOSITION_INLINE;
							$at->encoding = Zend_Mime::ENCODING_BASE64;
							$at->filename = 'invoice- '.date('Y-m-d').'.pdf';
							
						    $mail->send();
						}
						break;						
					case 'Reservation_Invoice' :
						$template = $this->GetMessageTemplate($mailobj);
						
						if($template){
							$data    	= $mailobj->getData();
							$name    	= $data['UserName'];
							$subject 	= $data['subject'];
							$body    	= $template->msg_body;							
							$body    	= str_replace("%firstname%",$name,$body);
							$body 	 	= str_replace("ï¿½",'',$body);
							$receiverslist = $data['SenTo'];
							
							$mail->setFrom($fromaddress, $fromname);
						    $mail->setReplyTo($fromaddress,$fromname);
						    $mail->addTo( $receiverslist,$name);
						    $mail->setSubject($subject);
						    $mail->setBodyHtml($body);
						    
						    $fileContents = file_get_contents($data['path']);
							$at = $mail->createAttachment($fileContents);
							$at->type = Zend_Mime::TYPE_OCTETSTREAM;
							$at->disposition = Zend_Mime::DISPOSITION_INLINE;
							$at->encoding = Zend_Mime::ENCODING_BASE64;
							$at->filename = 'reservation_invoice- '.date('Y-m-d').'.pdf';
							
						    $mail->send();
						}
						break;	
					case 'Special_Booking_Conf':
						$template = $this->GetMessageTemplate($mailobj);
						if($template){
							$data     = $mailobj->getData();
							$campId = "";

							$name     = $data['UserName'];
							$restname = $data['RestName'];
							$resdate  = $data['ResDate'];
							$time     = $data['Time'];
							$size     = $data['Size'];
							$address  = $data['Address'];
							$resphone = $data['resphone'];
							$status	  = $data['Status'];
							$bokid    = $data['Bokid'];
							$state	  = $data['State_Id'];
							$city	  = $data['City_Id'];
							$resemail = $data['resemail'];
							$reszipcode = $data['reszipcode'];
							$rescity  = $data['rescity'];
							$resnbh   = $data['resnbh'];
							
							$spldiv = '<div style="background: #f1ede8;box-shadow: 5px 5px 30px #808080;-moz-box-shadow: 5px 5px 30px #808080;-khtml-box-shadow: 5px 5px 30px #808080;-webkit-box-shadow: 5px 5px 30px #808080;border:3px solid #643513; padding:8px; font-size:12px;"><div style="color:#F79646; font-weight:bold; text-align:center;">%splname%</div><br /><div style="color:#4f6228; font-weight:bold;">Special Id: %splid%</div><br /><br /><div style="color:#000048;">%spldesc%</div></div><br /><br />';
							if($data['splstatus']){
								$splid		= $data['splid']; 
								$splname 	= $data['splname'];
								$spldesc	= $data['spldesc'];
//								$splorgprice= $data['splorgprice'];
//								$spldiscount= $data['spldiscount'];
//								$splprice	= $data['splprice'];
							}
							
							$userType = $data['UserType'];
							$div = '<td width="45%" valign="top" align="left">%img%</br><div>%desc%</div></td>';
							$imgDiv = '<div><img src="http://www.ureserv.com%img%" width="150" height="150"/></div>';
							if(isset($data['campId'])){
								$campId  	= $data['campId'];
								$campname 	= $data['campaignName'];
								$desc  		= $data['campaignDesc'];
								$img 	  	= $data['campaignImg'];
								$desc  		= str_replace('src="','src="http://www.ureserv.com',$desc);
								$display  	= 'block';
							}

							
							$subject = $template->msg_subject;
							$body    = $template->msg_body;
							
							$body    = str_replace("%firstname%",$name,$body);
							$body    = str_replace("%restname%",$restname,$body);
							$body    = str_replace("%date%",$resdate,$body);
							$body    = str_replace("%time%",$time,$body);
							$body    = str_replace("%size%",$size,$body);
							$body	 = str_replace("%address%",$address,$body);
							$body	 = str_replace("%resphone%",$resphone,$body);
							$body	 = str_replace("%bokid%",$bokid,$body);
							$body	 = str_replace("%resnbh%",$resnbh,$body);
							$body	 = str_replace("%rescity%",$rescity,$body);
							$body	 = str_replace("%resemail%",$resemail,$body);
							$body	 = str_replace("%reszipcode%",$reszipcode,$body);							
							
							$body 	 = str_replace("ï¿½",'',$body);
							if(isset($data['campId'])){
								$body    = str_replace("none",$display,$body);
								$body    = str_replace("%desc%",$desc,$body);
								if($data['campaignImg']){
									$imgDiv 	= str_replace("%img%",$img,$imgDiv);
									$body    	= str_replace("%img%",$imgDiv,$body);
								}else{
									$body    = str_replace($imgDiv,'',$body);
								}
								$body    = str_replace("%campName%",$campname,$body);
							}else{
								$body    = str_replace($div,'',$body);
								$body    = str_replace("%campName%",'UReserv',$body);
							}
							if($data['splstatus']){
								$body	= str_replace("%splname%",$splname,$body);
								$body	= str_replace("%splid%",$splid,$body);
//								$body	= str_replace("%orgprice%",$splorgprice,$body);
//								$body	= str_replace("%discount%",$spldiscount,$body);
//								$body	= str_replace("%price%",$splprice,$body);
								$body	= str_replace("%spldesc%",$spldesc,$body);
							}else{
								$body	= str_replace($spldiv,'',$body);
							}
							
							$receiverslist = $data['SenTo'];
						    
							$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
							$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
							$priorMapper = new Application_Model_PriorityDataMapper();
							$prior = $priorMapper->GetPriorityByCode('H');
							$msgMapper = new Notification_Model_EmailMessageDataMapper();
							$message = new Notification_Model_EmailMessage();
							$message->setTitle($mailobj->getMsgCode())
									->setDescription($body)
									->setPriority($prior->getcode())
									->setEmailtype($emailType->getcode())
									->setUsertype($userType)
									->setSentby('adminstrator@ureserv.com');
							$msgid = $msgMapper->SaveMessageDetails($message);
							if($userType == 'CUS'){
								$cusMapper = new Notification_Model_EmailCusRecipentsDataMapper();
								$cusResult = $cusMapper->SaveCustMailDetails($msgid,$state,$city,$userType,$campId,$receiverslist);
							}
						    $mail->setFrom($fromaddress, $fromname);
						    $mail->setReplyTo($fromaddress,$fromname);
						    $mail->addTo( $receiverslist,$name);
						    $mail->setSubject($subject);
						    $mail->setBodyHtml($body);
						     $fileContents = file_get_contents($data['path']);
							$at = $mail->createAttachment($fileContents);
							$at->type = Zend_Mime::TYPE_OCTETSTREAM;
							$at->disposition = Zend_Mime::DISPOSITION_INLINE;
							$at->encoding = Zend_Mime::ENCODING_BASE64;
							$at->filename = 'reservation_invoice- '.date('Y-m-d').'.pdf';
						    $status = $mail->send();
						}
					break;
					case 'Declined trnsaction' :
						
						$template = $this->GetMessageTemplate($mailobj);
						
						if($template){
							$data    	= $mailobj->getData();
							$name    	= $data['UserName'];
							$subject = $template->msg_subject;
							$body    = $template->msg_body;							
							$body    	= str_replace("%firstname%",$name,$body);
							$body 	 	= str_replace("ï¿½",'',$body);
							$receiverslist = $data['SenTo'];
							
							$mail->setFrom($fromaddress, $fromname);
						    $mail->setReplyTo($fromaddress,$fromname);
						    $mail->addTo( $receiverslist,$name);
						    $mail->setSubject($subject);
						    $mail->setBodyHtml($body);
						    $mail->send();
						}
						
						break;
						
					case 'Restaurant_Floor_Remainder' :
						$template = $this->GetMessageTemplate($mailobj);
						
						if($template){
							$data    = $mailobj->getData();
							$name    = $data['UserName'];
							$resname = $data['resname'];
							$subject = $template->msg_subject;
							$body    = $template->msg_body;							
							$body    = str_replace("%firstname%",$name,$body);
							$body	 = str_replace("%Restaurant Name%",$resname,$body);
							$body 	 = str_replace("ï¿½",'',$body);
							$receiverslist = $data['SenTo'];
							
							$mail->setFrom($fromaddress, $fromname);
						    $mail->setReplyTo($fromaddress,$fromname);
						    $mail->addTo( $receiverslist,$name);
						    $mail->setSubject($subject);
						    $mail->setBodyHtml($body);
						    $mail->send();
						}
						
						
						break;
					case 'Restaurant_Schedule_Remainder' :
						$template = $this->GetMessageTemplate($mailobj);
						
						if($template){
							$data    = $mailobj->getData();
							$name    = $data['UserName'];
							$resname = $data['resname'];
							$subject = $template->msg_subject;
							$body    = $template->msg_body;							
							$body    = str_replace("%firstname%",$name,$body);
							$body	 = str_replace("%Restaurant Name%",$resname,$body);
							$body 	 = str_replace("ï¿½",'',$body);
							$receiverslist = $data['SenTo'];
							
							$mail->setFrom($fromaddress, $fromname);
						    $mail->setReplyTo($fromaddress,$fromname);
						    $mail->addTo( $receiverslist,$name);
						    $mail->setSubject($subject);
						    $mail->setBodyHtml($body);
						    $mail->send();
						}
						break;
						
					case 'ForgotPwd' :
						$template = $this->GetMessageTemplate($mailobj);
						
						if($template){
							
							$data    = $mailobj->getData();
							$name    = $data['UserName'];
							$password = $data['password'];
							$subject = $template->msg_subject;
							$body    = $template->msg_body;							
							$body    = str_replace("%firstname%",$name,$body);
							$body	 = str_replace("%PassWord%",$password,$body);
							$body 	 = str_replace("ï¿½",'',$body);
							$receiverslist = $data['SenTo'];
							
							$mail->setFrom($fromaddress, $fromname);
						    $mail->setReplyTo($fromaddress,$fromname);
						    $mail->addTo( $receiverslist,$name);
						    $mail->setSubject($subject);
						    $mail->setBodyHtml($body);
						    $mail->send();
						}
						$status = 'success';
						return $status;
						break;
					case 'RNForgotPwd' :
						$template = $this->GetMessageTemplate($mailobj);
						
						if($template){
							
							$data    = $mailobj->getData();
							$name    = $data['UserName'];
							$password = $data['password'];
							$subject = $template->msg_subject;
							$body    = $template->msg_body;							
							$body    = str_replace("%firstname%",$name,$body);
							$body	 = str_replace("%PassWord%",$password,$body);
							$body 	 = str_replace("ï¿½",'',$body);
							$receiverslist = $data['SenTo'];
							$fromaddress = 'reservations@rewardsnetwork.com';
							$fromname = 'Rewards Network';
							$mail->setFrom($fromaddress, $fromname);
						    $mail->setReplyTo($fromaddress,$fromname);
						    $mail->addTo( $receiverslist,$name);
						    $mail->setSubject($subject);
						    $mail->setBodyHtml($body);
						    $mail->send();
						}
						$status = 'success';
						return $status;
						break;
	
					case 'Cancel' :
//						$template = $this->GetMessageTemplate($mailobj);
						$templateBdMapper = new Application_Model_EmailtemplateDataMapper();
						//getting book cancellation subject by code
						$templateSubject = $templateBdMapper->getEmailTempByCode('Cancel');
						$data     = $mailobj->getData();
						/**
						 * 
						 * To fetch Restaurant ID by Book ID
						 */
						$resDetails = new Booking_Model_BookingDataMapper;
						$resid = $resDetails->getRestIdByBookId($data['BookId']);
						$Service = new Application_Service_Restaurant;
						$CompanyDetails = $Service->restaurantCompanyDetails($resid);
						$CompanyId = $CompanyDetails->res_companyid;
						$templateBdMapper = new Application_Model_EmailtemplateDataMapper();
						/**
						 * 
						 * To pick template with respect to URESERV or Reward restaurants 
						 */
						$UserAgent = new Uss_Plugin_Context;
						$MobileView = $UserAgent->ismobile();
						if($CompanyId ==2){
							$mailTemplate= "CancelRN";
							$fromaddress = 'reservations@rewardsnetwork.com';
							$fromname = 'Rewards Network';
							if($MobileView['is_mobile'] == 1){
								$mailTemplate .= "Mobile";
								$browserMode = 'm';
							}
							$template = $templateBdMapper->getEmailTempByCode($mailTemplate);	
						}else if($CompanyId == 6 ){
							$fromaddress = 'reservations@makanluar.com';
							$fromname = 'MakanLuar Reservation';
							$template = $templateBdMapper->getEmailTempByCode('CancelMakanLuar');
						}else if($CompanyId == 1 ){
							$template = $templateBdMapper->getEmailTempByCode('Cancel');
						}else{
							$template = $templateBdMapper->getEmailTempByCode('Email_Message');
						}
						switch($resid) {
                                                        case 2522:
							case 2526:
                                                        case 2527:
                                                        	$template = $templateBdMapper->getEmailTempByCode('CancelCrownePlaza');
                                                                break;
                                                }

//						$template = $templateBdMapper->getEmailTempByCode('Email_Message');
						$campId = '';
//						$data     = $mailobj->getData();
						$splitbookdate = explode('-',$data['ResDate']);
						$name     = $data['UserName'];
						$restname = $data['RestName'];
						$resdate  = date('m-d-Y',mktime(0,0,0,$splitbookdate[1],$splitbookdate[2],$splitbookdate[0]));;
						$time     = $data['Time'];
						$size     = $data['Size'];
						$address  = $data['Address'];
//						$status	  = $data['Status'];
						$state	  = $data['State_Id'];
						$city	  = $data['City_Id'];
						$resphone = $data['resphone'];
						$userType = $data['UserType'];
						$bokid    = $data['BookId'];
//						$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div>%img%</br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
//						$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.ureserv.com%img%" width="150" height="150"/>';
//						
////						$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div><div><a class="linkopacity" target="newwindow">%img%</a></div></br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
////						$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.ureserv.com%img%" width="150" height="150"/>';
						
						if(isset($data['campId'])){
							$campId   = $data['campId'];
							$campname 	= $data['campaignName'];
							$desc  = $data['campaignDesc'];
							$img  = $data['campaignImg'];
//							$desc  = str_replace('src="','src="http://www.ureserv.com',$desc);
							$display  = 'block';
						}
						//storing cancellation subject in a variable
						$subject = $templateSubject->msg_subject;
						$body    = $template->msg_body;
						
						$body    = str_replace("%firstname%",trim($name),$body);
						$body    = str_replace("%restname%",trim($restname),$body);
						if($CompanyId == 6 || $CompanyId == 1){
						/* Convert Date to string */ 
					
							/* Set time zone */
								
							$resServ = new Application_Service_Restaurant();
							$timeZone = $resServ->GetRestaurantTimeZone($resid);
							date_default_timezone_set($timeZone);
								
							$indodate = trim($resdate);

							$indodatesplit = explode("-",$indodate); 
							$indoStringDate = date("F j, Y", mktime(0,0,0,$indodatesplit[0],$indodatesplit[1],$indodatesplit[2]));								
							$body    = str_replace("%date%",$indoStringDate,$body);
						
						}else{
							$body    = str_replace("%date%",$resdate,$body);
						}						$body    = str_replace("%time%",trim($time),$body);
						$body    = str_replace("%size%",trim($size),$body);
						if($CompanyId == 6 || $CompanyId == 1){
							$body	 = str_replace("%address%",$address,$body);
							$body = str_replace("%phone%",$resphone,$body);
						}
						$body 	 = str_replace("ï¿½",'',$body);
						$receiverslist = $data['SenTo'];
						
//						if(isset($data['campId'])){
//							$body    = str_replace("none",$display,$body);
//							$body    = str_replace("%desc%",$desc,$body);
//							if($data['campaignImg']){
//								$imgDiv 	= str_replace("%img%",$img,$imgDiv);
//								$body    	= str_replace("%img%",$imgDiv,$body);								
//							}else{
//								$body    = str_replace("%img%",'',$body);
//							}
//							$body    = str_replace("%campName%",$campname,$body);
//						}else{
//								$body    = str_replace($div,'',$body);
//							}
						
						$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
						$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
						$priorMapper = new Application_Model_PriorityDataMapper();
						$prior = $priorMapper->GetPriorityByCode('H');
						$msgMapper = new Notification_Model_EmailMessageDataMapper();
						$message = new Notification_Model_EmailMessage();
						$msgPhrase = uniqid ();
						/**
						 * 
						 * To save message details with respect to URESERV or Reward restaurants 
						 */
						if($CompanyId==2){
							$message->setBokid($bokid)
								->setPhrase($msgPhrase)
								->setTitle($mailTemplate)
								->setDescription($body)
								->setPriority($prior->getcode())
								->setEmailtype($emailType->getcode())
								->setUsertype($userType)
								->setSentby('adminstrator@ureserv.com');
						}else{
							$message->setBokid($bokid)
								->setPhrase($msgPhrase)
								->setTitle($mailobj->getMsgCode())
								->setDescription($body)
								->setPriority($prior->getcode())
								->setEmailtype($emailType->getcode())
								->setUsertype($userType)
								->setSentby('adminstrator@ureserv.com');
						}
						$msgid = $msgMapper->SaveMessageDetails($message);
						$src = "http://www.ureserv.com/Notification/Notification/emailnotification/msgid/".$msgPhrase;
						$body	 = str_replace("%bookingsrc%",$src,$body);
						if($userType == 'CUS'){
							$cusMapper = new Notification_Model_EmailCusRecipentsDataMapper();
							$cusResult = $cusMapper->SaveCustMailDetails($msgid,$state,$city,$userType,$campId,$receiverslist);
						}
						
						$mail->setFrom($fromaddress, $fromname);
					    $mail->setReplyTo($fromaddress,$fromname);
					    $mail->addTo( $receiverslist,$name);
					    $mail->setSubject($subject);
					    $mail->setBodyHtml($body);
					    $mail->send();
					    
						break;
						
					case 'ReSchedule' :
//						$template = $this->GetMessageTemplate($mailobj);
						$templateBdMapper = new Application_Model_EmailtemplateDataMapper();
						//getting ReSchedule subject by code
						$templateSubject = $templateBdMapper->getEmailTempByCode('ReSchedule');
//						$template = $templateBdMapper->getEmailTempByCode('Email_Message');
						$data     = $mailobj->getData();
						/**
						 * 
						 * To fetch Restaurant ID by Book ID
						 */
						$resDetails = new Booking_Model_BookingDataMapper;
						$resid = $resDetails->getRestIdByBookId($data['Bokid']);	
						$Service = new Application_Service_Restaurant;
						$CompanyDetails = $Service->restaurantCompanyDetails($resid);
						$CompanyId = $CompanyDetails->res_companyid;
						$UserAgent = new Uss_Plugin_Context;
						$MobileView = $UserAgent->ismobile();
						$templateBdMapper = new Application_Model_EmailtemplateDataMapper();
						/**
						 * 
						 * To pick Template details with respect to URESERV or Reward restaurants 
						 */
						if($CompanyId ==2){
							//Rewards Company
							$mailTemplate= "ReScheduleRN";
							$fromaddress = 'reservations@rewardsnetwork.com';
							$fromname = 'Rewards Network';
							if($MobileView['is_mobile'] == 1){
								$mailTemplate .= "Mobile";
								$browserMode = 'm';
							}
							$template = $templateBdMapper->getEmailTempByCode($mailTemplate);
						}else if($CompanyId == 6 ){
							$fromaddress = 'reservations@makanluar.com';
							$fromname = 'MakanLuar Reservation';
							$template = $templateBdMapper->getEmailTempByCode('ReScheduleMakanLuar');
						}else if($CompanyId == 1 ){
							$template = $templateBdMapper->getEmailTempByCode('ReSchedule');
						}else{
							//URESERV
							$template = $templateBdMapper->getEmailTempByCode('Email_Message');
						}
						switch($resid) {
							case 2474:
								$template = $templateBdMapper->getEmailTempByCode('BookRescheduleEMC');
								break;
							case 2500:
								$template = $templateBdMapper->getEmailTempByCode('BookReschedulePavilion');
								break;

							case 2516:
								$template = $templateBdMapper->getEmailTempByCode('Reservation ReScheduled');
								break;
							case 2522:
							case 2526:
							case 2527:
								$template = $templateBdMapper->getEmailTempByCode('BookRescheduleCrownePlaza');
								break;
						}
						if($template){
//							$data     = $mailobj->getData();
							$campId = "";

							$name     = $data['UserName'];
							$restname = $data['RestName'];
							$phone    = $data['Phone'];
							$email    = $data['Email'];
							$resdate  = $data['ResDate'];
							$time     = $data['Time'];
							$size     = $data['Size'];
							$bokid    = $data['Bokid'];
							$state	  = $data['State_Id'];
							$city	  = $data['City_Id'];
							
//							$spldiv = '<div style="background: #f1ede8;box-shadow: 5px 5px 30px #808080;-moz-box-shadow: 5px 5px 30px #808080;-khtml-box-shadow: 5px 5px 30px #808080;-webkit-box-shadow: 5px 5px 30px #808080;border:3px solid #643513; padding:8px; font-size:12px;"><div style="color:#F79646; font-weight:bold; text-align:center;">%splname%</div><br /><div style="color:#4f6228; font-weight:bold;">Special Id: %splid%</div><br /><br /><div style="color:#000048;">%spldesc%</div></div><br /><br />';
//							if($data['splstatus']){
//								$splid		= $data['splid']; 
//								$splname 	= $data['splname'];
//								$spldesc	= $data['spldesc'];
////								$splorgprice= $data['splorgprice'];
////								$spldiscount= $data['spldiscount'];
////								$splprice	= $data['splprice'];
//							}
							
							$userType = $data['UserType'];
//							$div = '<td width="45%" valign="top" align="left">%img%</br><div>%desc%</div></td>';
//							$imgDiv = '<div><img src="http://www.ureserv.com%img%" width="150" height="150"/></div>';
							if(isset($data['campId'])){
								$campId  	= $data['campId'];
								$campname 	= $data['campaignName'];
								$desc  		= $data['campaignDesc'];
								$img 	  	= $data['campaignImg'];
//								$desc  		= str_replace('src="','src="http://www.ureserv.com',$desc);
								$display  	= 'block';
							}

							//storing ReSchedule subject in a variable
							$subject = $templateSubject->msg_subject;
							$body    = $template->msg_body;
							
							$body    = str_replace("%firstname%",trim($name),$body);
							$body    = str_replace("%restname%",trim($restname),$body);

							if($CompanyId == 6 ||  $CompanyId == 1){
								/* Convert Date to string */

								/* Set time zone */
								
								$resServ = new Application_Service_Restaurant();
								$timeZone = $resServ->GetRestaurantTimeZone($resid);
								date_default_timezone_set($timeZone);
							
								$indodate = trim($resdate);

								$indodatesplit = explode("-",$indodate); 
								$indoStringDate = date("F j, Y", mktime(0,0,0,$indodatesplit[0],$indodatesplit[1],$indodatesplit[2]));								
								$body    = str_replace("%date%",$indoStringDate,$body);
								
							}else{
								$body    = str_replace("%date%",$resdate,$body);
							}

							$body    = str_replace("%time%",trim($time),$body);
							$body    = str_replace("%size%",trim($size),$body);
							$body    = str_replace("%phone%",$phone,$body);
							$body    = str_replace("%email%",$email,$body);
							if($CompanyId == 6 || $CompanyId == 1){
								$address  = $data['Address'];
								$resphone = $data['resphone'];
								$status	  = $data['Status'];
								$resemail = $data['resemail'];
								$reszipcode = $data['reszipcode'];
								$rescity  = $data['rescity'];
								$resnbh   = $data['resnbh'];
								
								$bookingmapper = new Booking_Model_BookingDataMapper();
								$phraseId = $bookingmapper->GetBookingPhraseByBookid($bokid);
								$body	 = str_replace("%address%",$address,$body);
								$body	 = str_replace("%resphone%",$resphone,$body);
								$body	 = str_replace("%resnbh%",$resnbh,$body);
								$body	 = str_replace("%rescity%",$rescity,$body);
								$body	 = str_replace("%resemail%",$resemail,$body);
								$body	 = str_replace("%reszipcode%",$reszipcode,$body);
								$body	 = str_replace("%bokid%",$phraseId,$body);
								$body	 = str_replace("%bookingid%",$bokid,$body);
								$body    = str_replace("%resid%",$resid,$body);								
							}
							$body 	 = str_replace("ï¿½",'',$body);
//							if(isset($data['campId'])){
//								$body    = str_replace("none",$display,$body);
//								$body    = str_replace("%desc%",$desc,$body);
//								if($data['campaignImg']){
//									$imgDiv 	= str_replace("%img%",$img,$imgDiv);
//									$body    	= str_replace("%img%",$imgDiv,$body);
//								}else{
//									$body    = str_replace($imgDiv,'',$body);
//								}
//								$body    = str_replace("%campName%",$campname,$body);
//							}else{
//								$body    = str_replace($div,'',$body);
//								$body    = str_replace("%campName%",'UReserv',$body);
//							}
//							if($data['splstatus']){
//								$body	= str_replace("%splname%",$splname,$body);
//								$body	= str_replace("%splid%",$splid,$body);
////								$body	= str_replace("%orgprice%",$splorgprice,$body);
////								$body	= str_replace("%discount%",$spldiscount,$body);
////								$body	= str_replace("%price%",$splprice,$body);
//								$body	= str_replace("%spldesc%",$spldesc,$body);
//							}else{
//								$body	= str_replace($spldiv,'',$body);
//							}
							
							$receiverslist = $data['SenTo'];
						    
							$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
							$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
							$priorMapper = new Application_Model_PriorityDataMapper();
							$prior = $priorMapper->GetPriorityByCode('H');
							$msgMapper = new Notification_Model_EmailMessageDataMapper();
							$message = new Notification_Model_EmailMessage();
							$msgPhrase = uniqid ();
							/**
							 * 
							 * To save message details with respect to URESERV or Reward restaurants 
							 */
							if($CompanyId==2){
								$message->setBokid($bokid)
										->setPhrase($msgPhrase)
										->setTitle($mailTemplate)
										->setDescription($body)
										->setPriority($prior->getcode())
										->setEmailtype($emailType->getcode())
										->setUsertype($userType)
										->setSentby('adminstrator@ureserv.com');	
							}else{
								$message->setBokid($bokid)
										->setPhrase($msgPhrase)
										->setTitle($mailobj->getMsgCode())
										->setDescription($body)
										->setPriority($prior->getcode())
										->setEmailtype($emailType->getcode())
										->setUsertype($userType)
										->setSentby('adminstrator@ureserv.com');
							}
							$msgid = $msgMapper->SaveMessageDetails($message);
							$src = "http://www.ureserv.com/Notification/Notification/emailnotification/msgid/".$msgPhrase;
							$body	 = str_replace("%bookingsrc%",$src,$body);
							if($userType == 'CUS'){
								$cusMapper = new Notification_Model_EmailCusRecipentsDataMapper();
								$cusResult = $cusMapper->SaveCustMailDetails($msgid,$state,$city,$userType,$campId,$receiverslist);
							}
						    $mail->setFrom($fromaddress, $fromname);
						    $mail->setReplyTo($fromaddress,$fromname);
						    $mail->addTo( $receiverslist,$name);
						    $mail->setSubject($subject);
						    $mail->setBodyHtml($body);
						    $mail->send();
						}
						break;						
									/*	Case Enquiry/Contact Us Email Notification	*/
						case 'EnquiryNot' :
								
							$template = $this->GetMessageTemplate($mailobj);
							if($template){
								$data     = $mailobj->getData();
								
								$receiverslist = array();
								$receiverslist[] = 'vgarrett@ureserv.com';
								$receiverslist[] = 'jcaron@ureserv.com';
								$receiverslist[] = 'info@ureserv.com';								
								
								$name     = $data['Name'];
								$city  = $data['City'];
								$state     = $data['State'];
								$country     = $data['Country'];
								$phone     = $data['Phone'];
								$email  = $data['Email'];
								$comments  = $data['Comments'];
								$subject = $template->msg_subject;
								$body    = $template->msg_body;
								$body    = str_replace("%name%",$name,$body);
								$body    = str_replace("%city%",$city,$body);
								$body    = str_replace("%state%",$state,$body);

								$body    = str_replace("%country%",$country,$body);

								$body    = str_replace("%phone%",$phone,$body);

								$body    = str_replace("%email%",$email,$body);

								$body    = str_replace("%comments%",$comments,$body);
								$body 	 = str_replace("ï¿½",'',$body);

								$mail->setFrom($fromaddress, $fromname);							    
							    $mail->addTo($receiverslist);
							    //$mail->addBcc("ureservinc@gmail.com");
							    $mail->setSubject($subject);
							    $mail->setBodyHtml($body);
							    $mail->send();
							}
						
						break;
						
					case 'Notification' :
						$template = $this->GetMessageTemplate($mailobj);
						
						$data	= $mailobj->getData();
						
						$title 		= $data['subject'];
						$message	= $data['body'];
						$signature 	= $data['signature'];
						$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div>%img%</br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
						$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.ureserv.com%img%" width="150" height="150"/>';
						
	//					$image  = $data['campaignImage'];
	//					$link   = $data['campaignLink'];
						if(isset($data['campaignName']) && isset($data['campaignDesc'])){
							
							$name 	= $data['campaignName'];
							$desc  = $data['campaignDesc'];
							$img  = $data['campaignImg'];
							$desc  = str_replace('src="','src="http://www.ureserv.com',$desc);
							$display  = 'block';
						}
						
						
						$body	= $template->msg_body;
						
						$receiverslist = $data['SenTo'];
						if(count($receiverslist) > 1){
							$ToArr =  $receiverslist;
						}else{
							$ToArr = $receiverslist[0];
						}
						
						if(isset($data['campaignName']) && isset($data['campaignDesc'])){
							$body	= str_replace("none",$display,$body); 
							$body    = str_replace("%desc%",$desc,$body);
							if($data['campaignImg']){
								$imgDiv 	= str_replace("%img%",$img,$imgDiv);
								$body    	= str_replace("%img%",$imgDiv,$body);								
							}else{
								$body    = str_replace("%img%",'',$body);
							}
							$body    = str_replace("%campName%",$name,$body);	
						}else{
							$body    = str_replace($div,'',$body);
						}
						$body    = str_replace("%body%",$message,$body);
						$signature = str_replace(",",',<br/>',$signature);
						$body    = str_replace("%signature%",$signature,$body);
						
	//					$body    = str_replace("%link%",$link,$body);
	//					$body    = str_replace("%image%",$image,$body);
		
						$mail->setFrom($fromaddress, $fromname);
						$mail->setReplyTo($fromaddress,$fromname);
						 $mail->addBcc($ToArr);
						$mail->setSubject($title);
						$mail->setBodyHtml($body);
						$mail->send();
					
					break;
					case 'No-Show' :
//						$template = $this->GetMessageTemplate($mailobj);
						$templateBdMapper = new Application_Model_EmailtemplateDataMapper();
						//getting No-Show subject by code
						$templateSubject = $templateBdMapper->getEmailTempByCode('No-Show');
						$template = $templateBdMapper->getEmailTempByCode('Email_Message');
						$campId = '';
						$data     = $mailobj->getData();
						
						$name     = $data['UserName'];
//						$restname = $data['RestName'];
//						$resdate  = $data['ResDate'];
//						$time     = $data['Time'];
//						$size     = $data['Size'];
//						$address  = $data['Address'];
//						$status	  = $data['Status'];
						$bokid    = $data['Bokid'];
						$state	  = $data['State_Id'];
						$city	  = $data['City_Id'];
						$userType = $data['UserType'];
//						$resManager = $data['ResManager'];
						$resEmail = $data['ResEmail'];
//						$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div>%img%</br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
//						$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.ureserv.com%img%" width="150" height="150"/>';
						
////						$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div><div><a class="linkopacity" target="newwindow">%img%</a></div></br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
////						$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.ureserv.com%img%" width="150" height="150"/>';
						
						if(isset($data['campId'])){
							$campId   = $data['campId'];
							$campname 	= $data['campaignName'];
							$desc  = $data['campaignDesc'];
							$img  = $data['campaignImg'];
//							$desc  = str_replace('src="','src="http://www.ureserv.com',$desc);
							$display  = 'block';
						}
					   //storing No-Show subject in a variable
						$subject = $templateSubject->msg_subject;
						$body    = $template->msg_body;
						
						$body    = str_replace("%firstname%",$name,$body);
//						$body    = str_replace("%restname%",$restname,$body);
//						$body    = str_replace("%date%",$resdate,$body);
//						$body    = str_replace("%time%",$time,$body);
//						$body    = str_replace("%size%",$size,$body);
//						$body    = str_replace("%manager%",$resManager,$body);
//						$body	 = str_replace("%address%",$address,$body);
//						$body	 = str_replace("%resemail%",$resEmail,$body);
						$body 	 = str_replace("ï¿½",'',$body);
						$receiverslist = $data['SenTo'];
						
//						if(isset($data['campId'])){
//							$body    = str_replace("none",$display,$body);
//							$body    = str_replace("%desc%",$desc,$body);
//							if($data['campaignImg']){
//								$imgDiv 	= str_replace("%img%",$img,$imgDiv);
//								$body    	= str_replace("%img%",$imgDiv,$body);								
//							}else{
//								$body    = str_replace("%img%",'',$body);
//							}
//							$body    = str_replace("%campName%",$campname,$body);
//						}else{
//								$body    = str_replace($div,'',$body);
//							}
						
						$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
						$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
						$priorMapper = new Application_Model_PriorityDataMapper();
						$prior = $priorMapper->GetPriorityByCode('H');
						$msgMapper = new Notification_Model_EmailMessageDataMapper();
						$message = new Notification_Model_EmailMessage();
						$msgPhrase = uniqid ();
						$message->setBokid($bokid)
								->setPhrase($msgPhrase)
								->setTitle($mailobj->getMsgCode())
								->setDescription($body)
								->setPriority($prior->getcode())
								->setEmailtype($emailType->getcode())
								->setUsertype($userType)
								->setSentby('adminstrator@ureserv.com');
						$msgid = $msgMapper->SaveMessageDetails($message);
						$src = "http://www.ureserv.com/Notification/Notification/emailnotification/msgid/".$msgPhrase;
						$body	 = str_replace("%bookingsrc%",$src,$body);
						if($userType == 'CUS'){
							$cusMapper = new Notification_Model_EmailCusRecipentsDataMapper();
							$cusResult = $cusMapper->SaveCustMailDetails($msgid,$state,$city,$userType,$campId,$receiverslist);
						}
						
						$mail->setFrom($fromaddress, $fromname);
					    $mail->setReplyTo($resEmail,$fromname);
					    $mail->addTo( $receiverslist,$name);
					    $mail->setSubject($subject);
					    $mail->setBodyHtml($body);
					    $mail->send();
					    
						break;
						
					case 'Sub-Rnw':
						
						$template = $this->GetMessageTemplate($mailobj);					
						
						$data     = $mailobj->getData();
						$subject  = $template->msg_subject;
						$body     = $template->msg_body;
						
						$name   = $data['UserName'];
						$date   = $data['Date'];
						$amount = $data['Amount'];
						$email  = $data['SenTo'];
						
						$strdate = date('d-M-Y',strtotime($date));
						
						$body = str_replace("%firstname%",$name,$body);
						$body = str_replace("%date%",$strdate,$body);
						$body = str_replace("%amount%",$amount,$body);						
						
						$mail->setFrom('admin@ureserv.com', $fromname);
						$mail->addTo($email,$name);
						$mail->setSubject($subject);
					    $mail->setBodyHtml($body);
					    $mail->send();
												
						break;
					case 'WaitCustomMsg' :
						$template = $this->GetMessageTemplate($mailobj);
						$campId = '';
						$data     = $mailobj->getData();
						
						$name     	= $data['CustName'];
						$restname 	= $data['RestName'];
						$Message	= $data['Message'];
						$bokid		= $data['Bokid'];
						$SenTo		= $data['SenTo'];
						$userType   = $data['usertype'];
						$state	  = $data['State_Id'];
						$city	  = $data['City_Id'];
						
						$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div>%img%</br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
						$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.ureserv.com%img%" width="150" height="150"/>';
						
//						$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div><div><a class="linkopacity" target="newwindow">%img%</a></div></br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
//						$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.ureserv.com%img%" width="150" height="150"/>';
						
						if(isset($data['campId'])){
							$campId   = $data['campId'];
							$campname 	= $data['campaignName'];
							$desc  = $data['campaignDesc'];
							$img  = $data['campaignImg'];
							$desc  = str_replace('src="','src="http://www.ureserv.com',$desc);
							$display  = 'block';
						}
						
						$subject = $template->msg_subject;
						$body    = $template->msg_body;
						
						$body    = str_replace("%custname%",$name,$body);
						$body    = str_replace("%msg%",$Message,$body);
						$body    = str_replace("%bokid%",$bokid,$body);
						$body 	 = str_replace("ï¿½",'',$body);
						$receiverslist = $data['SenTo'];
						
						if(isset($data['campId'])){
							$body    = str_replace("none",$display,$body);
							$body    = str_replace("%desc%",$desc,$body);
							if($data['campaignImg']){
								$imgDiv 	= str_replace("%img%",$img,$imgDiv);
								$body    	= str_replace("%img%",$imgDiv,$body);								
							}else{
								$body    = str_replace("%img%",'',$body);
							}
							$body    = str_replace("%campName%",$campname,$body);
						}else{
								$body    = str_replace($div,'',$body);
								$body    = str_replace("%campName%",'UReserv',$body);
							}
						
						$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
						$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
						$priorMapper = new Application_Model_PriorityDataMapper();
						$prior = $priorMapper->GetPriorityByCode('H');
						$msgMapper = new Notification_Model_EmailMessageDataMapper();
						$message = new Notification_Model_EmailMessage();
						$message->setTitle($mailobj->getMsgCode())
								->setDescription($body)
								->setPriority($prior->getcode())
								->setEmailtype($emailType->getcode())
								->setUsertype($userType)
								->setSentby('adminstrator@ureserv.com');
						$msgid = $msgMapper->SaveMessageDetails($message);
						if($userType == 'CUS'){
							$cusMapper = new Notification_Model_EmailCusRecipentsDataMapper();
							$cusResult = $cusMapper->SaveCustMailDetails($msgid,$state,$city,$userType,$campId,$receiverslist);
						}
						
						$mail->setFrom($fromaddress, $fromname);
					    $mail->setReplyTo($data['resEmail'],$fromname);
					    $mail->addTo( $receiverslist,$name);
					    $mail->setSubject($subject);
					    $mail->setBodyHtml($body);
					    $stat = $mail->send();
					    if($stat){
					    	return true;
					    }
						break;
					case 'WaitReservReady' :
						$template = $this->GetMessageTemplate($mailobj);
						$campId = '';
						$data     = $mailobj->getData();
						
						$name     	= $data['CustName'];
						$restname 	= $data['RestName'];
						$Message	= $data['Message'];
						$SenTo		= $data['SenTo'];
						$userType   = $data['usertype'];
						$bokid		= $data['Bokid'];
						$state	  = $data['State_Id'];
						$city	  = $data['City_Id'];
						
						$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div>%img%</br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
						$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.ureserv.com%img%" width="150" height="150"/>';
						
//						$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div><div><a class="linkopacity" target="newwindow">%img%</a></div></br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
//						$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.ureserv.com%img%" width="150" height="150"/>';
						
						if(isset($data['campId'])){
							$campId   = $data['campId'];
							$campname 	= $data['campaignName'];
							$desc  = $data['campaignDesc'];
							$img  = $data['campaignImg'];
							$desc  = str_replace('src="','src="http://www.ureserv.com',$desc);
							$display  = 'block';
						}
						
						$subject = $template->msg_subject;
						$body    = $template->msg_body;
						
						$body    = str_replace("%custname%",$name,$body);
						$body    = str_replace("%bokid%",$bokid,$body);
						$body    = str_replace("%resname%",$restname,$body);
						$body 	 = str_replace("ï¿½",'',$body);
						$receiverslist = $data['SenTo'];
						
						if(isset($data['campId'])){
							$body    = str_replace("none",$display,$body);
							$body    = str_replace("%desc%",$desc,$body);
							if($data['campaignImg']){
								$imgDiv 	= str_replace("%img%",$img,$imgDiv);
								$body    	= str_replace("%img%",$imgDiv,$body);								
							}else{
								$body    = str_replace("%img%",'',$body);
							}
							$body    = str_replace("%campName%",$campname,$body);
						}else{
								$body    = str_replace($div,'',$body);
								$body    = str_replace("%campName%",'UReserv',$body);
							}
						
						$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
						$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
						$priorMapper = new Application_Model_PriorityDataMapper();
						$prior = $priorMapper->GetPriorityByCode('H');
						$msgMapper = new Notification_Model_EmailMessageDataMapper();
						$message = new Notification_Model_EmailMessage();
						$message->setTitle($mailobj->getMsgCode())
								->setDescription($body)
								->setPriority($prior->getcode())
								->setEmailtype($emailType->getcode())
								->setUsertype($userType)
								->setSentby('adminstrator@ureserv.com');
						$msgid = $msgMapper->SaveMessageDetails($message);
						if($userType == 'CUS'){
							$cusMapper = new Notification_Model_EmailCusRecipentsDataMapper();
							$cusResult = $cusMapper->SaveCustMailDetails($msgid,$state,$city,$userType,$campId,$receiverslist);
						}
						
						$mail->setFrom($fromaddress, $fromname);
					    $mail->setReplyTo($data['resEmail'],$fromname);
					    $mail->addTo( $receiverslist,$name);
					    $mail->setSubject($subject);
					    $mail->setBodyHtml($body);
					    $stat = $mail->send();
						if($stat){
					    	return true;
					    }
						break;
					case 'WaitReserv' :
						$template = $this->GetMessageTemplate($mailobj);
						$campId = '';
						$data     = $mailobj->getData();
						
						$name     	= $data['UserName'];
						$restname 	= $data['RestName'].',';
						$restaddr	= $data['Address'];
						$SenTo		= $data['SenTo'];
						$userType   = $data['UserType'];
						$quote		= $data['QuoteTime'];
						$bokid		= $data['Bokid'];
						$dateTime   = $data['ResDate'].' '.$data['Time'];
						$state	  = $data['State_Id'];
						$city	  = $data['City_Id'];
						
						$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div>%img%</br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
						$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.ureserv.com%img%" width="150" height="150"/>';
						
//						$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div><div><a class="linkopacity" target="newwindow">%img%</a></div></br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
//						$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.ureserv.com%img%" width="150" height="150"/>';
						
						if(isset($data['campId'])){
							$campId   = $data['campId'];
							$campname 	= $data['campaignName'];
							$desc  = $data['campaignDesc'];
							$img  = $data['campaignImg'];
							$desc  = str_replace('src="','src="http://www.ureserv.com',$desc);
							$display  = 'block';
						}
						
						$subject = $template->msg_subject;
						$body    = $template->msg_body;
						
						$body    = str_replace("%custname%",$name,$body);
						$body    = str_replace("%quotetime%",$quote,$body);
						$body    = str_replace("%restname%",$restname,$body);
						$body    = str_replace("%bokid%",$bokid,$body);
						$body    = str_replace("%datetime%",$dateTime,$body);
						$body    = str_replace("%resaddress%",$restaddr,$body);
						$body 	 = str_replace("ï¿½",'',$body);
						$receiverslist = $data['SenTo'];
						
						if(isset($data['campId'])){
							$body    = str_replace("none",$display,$body);
							$body    = str_replace("%desc%",$desc,$body);
							if($data['campaignImg']){
								$imgDiv 	= str_replace("%img%",$img,$imgDiv);
								$body    	= str_replace("%img%",$imgDiv,$body);								
							}else{
								$body    = str_replace("%img%",'',$body);
							}
							$body    = str_replace("%campName%",$campname,$body);
						}else{
								$body    = str_replace($div,'',$body);
								$body    = str_replace("%campName%",'UReserv',$body);
							}
						
						$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
						$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
						$priorMapper = new Application_Model_PriorityDataMapper();
						$prior = $priorMapper->GetPriorityByCode('H');
						$msgMapper = new Notification_Model_EmailMessageDataMapper();
						$message = new Notification_Model_EmailMessage();
						$message->setTitle($mailobj->getMsgCode())
								->setDescription($body)
								->setPriority($prior->getcode())
								->setEmailtype($emailType->getcode())
								->setUsertype($userType)
								->setSentby('adminstrator@ureserv.com');
						$msgid = $msgMapper->SaveMessageDetails($message);
						if($userType == 'CUS'){
							$cusMapper = new Notification_Model_EmailCusRecipentsDataMapper();
							$cusResult = $cusMapper->SaveCustMailDetails($msgid,$state,$city,$userType,$campId,$receiverslist);
						}
						
						$mail->setFrom($fromaddress, $fromname);
					    $mail->setReplyTo($data['ResEmail'],$fromname);
					    $mail->addTo( $receiverslist,$name);
					    $mail->setSubject($subject);
					    $mail->setBodyHtml($body);
					    $stat = $mail->send();
						if($stat){
					    	return true;
					    }
						break;
					case 'notifyfriends' :
//						$template = $this->GetMessageTemplate($mailobj);
						$templateBdMapper = new Application_Model_EmailtemplateDataMapper();
						//getting notifyfriends subject by code
						$templateSubject = $templateBdMapper->getEmailTempByCode('notifyfriends');
						$data     = $mailobj->getData();
						$resDetails = new Booking_Model_BookingDataMapper;
						$resid = $resDetails->getRestIdByBookId($data['Bokid']);				
						$Service = new Application_Service_Restaurant;
						$CompanyDetails = $Service->restaurantCompanyDetails($resid);
						$CompanyId = $CompanyDetails->res_companyid;
//						$templateBdMapper = new Application_Model_EmailtemplateDataMapper();
						$UserAgent = new Uss_Plugin_Context;
						$MobileView = $UserAgent->ismobile();
						if($CompanyId ==2){
							$mailTemplate = "rnnotifyfriends";
							$fromaddress = 'reservations@rewardsnetwork.com';
							$fromname = 'Rewards Network';
							if($MobileView['is_mobile'] == 1){
//								$mailTemplate .= "Mobile";
//								$browserMode = 'm';
							}
							$template = $templateBdMapper->getEmailTempByCode($mailTemplate);
						}else if($CompanyId == 6 ){
							$fromaddress = 'reservations@makanluar.com';
							$fromname = 'MakanLuar Reservation';
							$template = $templateBdMapper->getEmailTempByCode('notifyfriendsMakanLuar');
						}else if($CompanyId == 1 ){
							$template = $templateBdMapper->getEmailTempByCode('notifyfriends');
						}else{
							$template = $templateBdMapper->getEmailTempByCode('Email_Message');
						}
						$resdate = '';
						if($template){	
							$mapper = new Booking_Model_BookingDataMapper();
							/* get phrase id with booking */
							$phraseId = $mapper->GetBookingPhraseByBookid($data['Bokid']);
							$obj = new Application_Service_Booking;
							$bookResult = $obj->GetBookingDetails($data['Bokid']);		
							$splitbookdate = explode('-',$bookResult->getbokbooking_date());
							$resdate  = date('m-d-Y',mktime(0,0,0,$splitbookdate[1],$splitbookdate[2],$splitbookdate[0]));				
							$campId = "";
							$name     = $data['UserName'];
							$restname = $data['RestName'];
//							$resdate  = $data['ResDate'];
							$time     = $bookResult->getbokbooking_timings();
							$size     = $bookResult->getbokparty_size();
							$address  = $data['Address'];
							$resphone = $data['Phone'];
							$bokid    = $data['Bokid'];
							//$city	  = $data['City'];
							$resemail = $data['RestEmail'];
							$reszipcode = $data['Zipcode'];
							$rescity  = $data['City'];
							$resnbh   = $data['RestNbh'];
							
							$spldiv = '<div style="background: #f1ede8;box-shadow: 5px 5px 30px #808080;-moz-box-shadow: 5px 5px 30px #808080;-khtml-box-shadow: 5px 5px 30px #808080;-webkit-box-shadow: 5px 5px 30px #808080;border:3px solid #643513; padding:8px; font-size:12px;"><div style="color:#F79646; font-weight:bold; text-align:center;">%splname%</div><br /><div style="color:#4f6228; font-weight:bold;">Special Id: %splid%</div><br /><br /><div style="color:#000048;">%spldesc%</div></div><br /><br />';
							if($data['splstatus']){
								$splid		= $data['splid']; 
								$splname 	= $data['splname'];
								$spldesc	= $data['spldesc'];
							}
							$hiDiv = '<tr><td colspan="2"><p style="color:#505050 ; font-family:Verdana, Arial, Helvetica, sans-serif;">Dear %firstname%,</p></td></tr><tr><td colspan="2">You have recieved this email from UReserv to notify of your reservation.</td></tr>';
							$newHiDiv = '<tr><td colspan="2"><p style="color:#505050 ; font-family:Verdana, Arial, Helvetica, sans-serif;">Hi,</p></td></tr><tr><td colspan="2">You have been invited to a reservation by %firstname%.</td></tr>';
							$userType = $data['UserType'];
//							$div = '<td width="45%" valign="top" align="left">%img%</br><div>%desc%</div></td>';
//							$imgDiv = '<div><img src="http://www.ureserv.com%img%" width="150" height="150"/></div>';
							if(isset($data['campId'])){
								$campId  	= $data['campId'];
								$campname 	= $data['campaignName'];
								$desc  		= $data['campaignDesc'];
								$img 	  	= $data['campaignImg'];
//								$desc  		= str_replace('src="','src="http://www.ureserv.com',$desc);
								$display  	= 'block';
							}
							//storing notifyfriends subject in a variable
							$subject = $templateSubject->msg_subject;
							$body    = $template->msg_body;
							$body    = str_replace($hiDiv,$newHiDiv,$body);
							$body    = str_replace("%firstname%",$name,$body);
							$body    = str_replace("email-card.png",'email-card-notify.png',$body);

							$body    = str_replace("%restname%",$restname,$body);

							if($CompanyId == 6 || $CompanyId == 1){
							/* Convert Date to string */ 
							
							/* Set time zone */
								
							$resServ = new Application_Service_Restaurant();
							$timeZone = $resServ->GetRestaurantTimeZone($resid);
							date_default_timezone_set($timeZone);	
								
							$indodate = trim($resdate);

							$indodatesplit = explode("-",$indodate); 
							$indoStringDate = date("F j, Y", mktime(0,0,0,$indodatesplit[0],$indodatesplit[1],$indodatesplit[2]));								
							$body    = str_replace("%date%",$indoStringDate,$body);
								
							}else{
							$body    = str_replace("%date%",$resdate,$body);
							}
	
							$body    = str_replace("%time%",$time,$body);
							$body    = str_replace("%size%",$size,$body);
							$body	 = str_replace("%address%",$address,$body);
							$body	 = str_replace("%resphone%",$resphone,$body);
							$body	 = str_replace("%bokid%",$bookResult->getbokbookingphrase(),$body);
							$body	 = str_replace("%bookingid%",$bokid,$body);
							$body	 = str_replace("%resnbh%",$resnbh,$body);
							$body	 = str_replace("%rescity%",$rescity,$body);
							$body	 = str_replace("%resemail%",$resemail,$body);
							$body	 = str_replace("%reszipcode%",$reszipcode,$body);
							$body	 = str_replace("%senderemail%",$data['SendTo'],$body);							
							
							$body 	 = str_replace("ï¿½",'',$body);
							if(isset($data['campId'])){
								$body    = str_replace("none",$display,$body);
								$body    = str_replace("%desc%",$desc,$body);
								if($data['campaignImg']){
									$imgDiv 	= str_replace("%img%",$img,$imgDiv);
									$body    	= str_replace("%img%",$imgDiv,$body);
								}else{
									$body    = str_replace($imgDiv,'',$body);
								}
								$body    = str_replace("%campName%",$campname,$body);
							}else{
								$body    = str_replace($div,'',$body);
								$body    = str_replace("%campName%",'UReserv',$body);
							}
							if($data['splstatus']){
								$body	= str_replace("%splname%",$splname,$body);
								$body	= str_replace("%splid%",$splid,$body);
								$body	= str_replace("%spldesc%",$spldesc,$body);
							}else{
								$body	= str_replace($spldiv,'',$body);
							}
							
							/*code to explode string*/
							$noNewLine=explode("\n",$data['SendTo']);
							foreach($noNewLine as $key=>$value){
							//Now we are Looking for comma operator , if they have specified in field
								$arrEmail = explode(",",$value);
							}				
						    /*code to explode string*/
							$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
							$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
							$priorMapper = new Application_Model_PriorityDataMapper();
							$prior = $priorMapper->GetPriorityByCode('H');
							$msgMapper = new Notification_Model_EmailMessageDataMapper();
							$message = new Notification_Model_EmailMessage();
							$msgPhrase = uniqid ();
							$message->setBokid($bokid)
										->setPhrase($msgPhrase)
										->setDescription($body)
										->setPriority($prior->getcode())
										->setEmailtype($emailType->getcode())
										->setUsertype($userType)
										->setSentby('adminstrator@ureserv.com');
							if($CompanyId == 2){
								$message->setTitle($mailTemplate);
							}else{
								$message->setTitle($mailobj->getMsgCode());
							}
							$msgid = $msgMapper->SaveMessageDetails($message);
							
							if($userType == 'CUS'){
								$cusMapper = new Notification_Model_EmailCusRecipentsDataMapper();
								$cusResult = $cusMapper->SaveCustMailDetails($msgid,$state,$city,$userType,$campId,$receiverslist);
							}
							$tempbody = "";
							foreach($arrEmail as $key1=>$value1){
								$tempbody = $body;
								//Here i am checking whether the user has entered any Null values
									if(trim($value1)!=''){
										$src = "http://www.ureserv.com/Notification/Notification/emailnotification/msgid/".$msgPhrase;
										$src .= '/senderemail/'.$value1;
										$tempbody	 = str_replace("%bookingsrc%",$src,$tempbody);
//										$tempbody = str_replace("%senderemail%",$value1,$tempbody);
										$mail = new Zend_Mail();
										$mail->setFrom($fromaddress, $fromname);
										$mail->setReplyTo($fromaddress,$fromname);
										$mail->setSubject($subject);
										$mail->setBodyHtml($tempbody);
										$mail->addTo( $value1,$value1);								   
									    $st = $mail->send();
									}
								}
						}						
						break;	
					
				}
			}
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			return true;
		}
	}
	
	public function PhoneNotify(Notification_Model_Mail $mailobj)
	{
		if($mailobj){
			$phoneNotifyHelper = new Uss_Helper_PhoneNotifyHelper();
			$data = $mailobj->getData();
			$message   = "";
			$firstname = "";
			$lastname  = "";
			
			$template = "~\ActOnDigitPress(false)~ 
						 ~\ClearDTMF()~ 
						 ~\SetVar(Attempt|1)~
						 This is you reserve, you received a reservation for today.
						 ~\Label(TopMenu)~ 
						 ~\AssignDTMF(1|ReservationConfirm)~
						 ~\ActOnDigitPress(true)~ 
						 Press 1, for your reservation. 
						 ~\WaitForDTMF(10)~ 
						 ~\IncreaseVariable(Attempt|1)~ 
						 ~\GotoIf(Attempt|1|TopMenu)~ 
						 ~\GotoIf(Attempt|4|AttemptEnd)~ 
						 ~\Label(RepeatMenu)~ 
						 Please choose from the following options. 
						 ~\Goto(TopMenu)~ 
						 ~\Label(AttemptEnd)~ 
						 ~\EndCall()~ 
						 ~\Label(ReservationConfirm)~ 
						 %message%						 
						 ~\Label(MenuRepeat)~ 
						 ~\AssignDTMF(2|Start)~										 
						 ~\AssignDTMF(3|HangUp)~ 
						 ~\ActOnDigitPress(true)~ 
						 To repeat the message, press 2.						
						 To end the call, press 3. 
						 ~\WaitForDTMF(10)~ 
						 ~\IncreaseVariable(Attempt|1)~ 
						 ~\GotoIf(Attempt|1|TopMenu)~ 
						 ~\GotoIf(Attempt|4|AttemptEnd)~ 
						 ~\Label(RepeatMenu)~ 
						 Please choose from the following options. 
						 ~\Goto(MenuRepeat)~ 
						 ~\Label(AttemptEnd)~ 
						 ~\EndCall()~ 
						 ~\Label(HangUp)~ 
						 ~\EndCall()~";
			
			switch($mailobj->getMsgCode()){
				case 'BookNotf' :
									
					/* Add breaks to first name */	
					$cusfirstname = $data['Firstname'];
					$firstNamelength = strlen($cusfirstname);
					
					for($i=0; $i < $firstNamelength; $i++){
						$firstname .= $cusfirstname[$i]."<break />";
					}		
					
					/* Add breaks to last name */	
					$cuslastname = $data['Lastname'];
					$lastNamelength = strlen($cuslastname);
					
					for($i=0; $i < $lastNamelength; $i++){
						$lastname .= $cuslastname[$i]."<break />";
					}
					$reservPhone = '';
					$phone = '';
					$cusPhone = $data['ResvPhone'];
					if($data['ResvPhone']){
						for($i = 0;$i < strlen($cusPhone); $i++){
							$phone .= $cusPhone[$i]."<break />";
						}
						$reservPhone = "Phone number <break />".$phone ."<break />";
					}
					if($data['Note']){
						$message = "the reservation time is <break />". $data['ResvTime'] ."<break /> Party Size <break />". $data['Pax'] ."<break /> Last Name <break />".$cuslastname." <break />". $lastname ."<break /><break /> First Name <break />".$cusfirstname ."<break />". $firstname ."<break /><break />".$reservPhone ." Special Request <break />". $data['Note'];
					}else{
						$message = "the reservation time is <break />". $data['ResvTime'] ."<break /> Party Size <break />". $data['Pax'] ."<break /> Last Name <break />".$cuslastname." <break />". $lastname ."<break /><break /> First Name <break />".$cusfirstname ."<break />". $firstname ."<break /><break />".$reservPhone ;
					}
					$template = str_replace('%message%',$message,$template);
					
					$result = $phoneNotifyHelper->phone_notify_queueCall($data['PhoneNumber'],$template,'');
					break;
					
				case 'CancelNotf' :			
									
					/* Add breaks to first name */	
					$cusfirstname = $data['Firstname'];
					$firstNamelength = strlen($cusfirstname);
					
					for($i=0; $i < $firstNamelength; $i++){
						$firstname .= $cusfirstname[$i]."<break />";
					}		
					
					/* Add breaks to last name */	
					$cuslastname = $data['Lastname'];
					$lastNamelength = strlen($cuslastname);
					
					for($i=0; $i < $lastNamelength; $i++){
						$lastname .= $cuslastname[$i]."<break />";
					}
					
					$message = 'You just received a cancellation of a reservation for your restaurant for <break />'.$cuslastname.' <break />'. $lastname .'<break /><break />'.$cusfirstname .'<break />'. $firstname .'<break /><break /> for a party of <break />'. $data['Pax'] .'<break /> at <break />'. $data['ResvTime'] .'<break /> on <say-as format="ymd" interpret-as="date">'. $data['ResvDate'] .'</say-as>';					
					$template = str_replace('%message%',$message,$template);	
									
					$result = $phoneNotifyHelper->phone_notify_queueCall($data['PhoneNumber'],$template,'');
					
					break;
					
			}
		}	
	}
	
	public function SendSms(Notification_Model_Sms $smsobj)
	{
		try{
		if($smsobj){			
			switch($smsobj->getMsgCode()){
				case 'BookConf' :
					$template = $this->GetSmstemplate($smsobj);
					if($template){
						$data = $smsobj->getData();
						$mobile	  = str_replace("-","",$data['to']);
						$bokid 	  = $data['bokid'];
						$restname = $data['RestName'];
						$resdate  = $data['ResDate'];
						$time     = $data['Time'];
						$size     = $data['Size'];
						$name     = $data['CustomerName'];
						//$address  = $data['Address'];
						$body=	$template->msg_body;
						$body    = str_replace("%bokid%",$bokid,$body);
						$body    = str_replace("%ResturantName%",$restname,$body);
						$body    = str_replace("%date%",$resdate,$body);
						$body    = str_replace("%time%",$time,$body);
						$body    = str_replace("%size%",$size,$body);
						
						/* Sms Message Saving Start */
						$msgMapper = new Notification_Model_SmsMessageMapper();
						$priorMapper = new Application_Model_PriorityDataMapper();
						$prior = $priorMapper->GetPriorityByCode('H');
						$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
						$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
						$message = new Notification_Model_SmsMessage();
						$msgPhrase = uniqid ();
						$message->setBokid($bokid)
									->setPhrase($msgPhrase)
									->setDescription($body)
									->setPriority($prior->getcode())
									->setSmstype($emailType->getcode())
									->setSentToUser('CUS')
									->setSentTo($name)
									->setSentFromUser('ADMIN')
									->setSentby($restname)
									->setTitle($smsobj->getMsgCode());
						
						$msgid = $msgMapper->SaveMessageDetails($message);
						/* Sms Message Saving End */
							
						$this->SendMessage($body,$mobile);
					}
					break;					
				case 'BookNotf' :
					$template = $this->GetSmstemplate($smsobj);
					if($template){
						$data = $smsobj->getData();
						$mobile	  = str_replace("-","",$data['to']);
						$bokid 	  = $data['bokid'];
						$restname = $data['RestName'];
						$resdate  = $data['ResDate'];
						$time     = $data['Time'];
						$size     = $data['Size'];
						$name     = $data['CustomerName'];
						//$address  = $data['Address'];
						$body=	$template->msg_body;
						$body    = str_replace("%bokid%",$bokid,$body);
						$body    = str_replace("%restname%",$restname,$body);
						$body    = str_replace("%date%",$resdate,$body);
						$body    = str_replace("%time%",$time,$body);
						$body    = str_replace("%size%",$size,$body);
						$body    = str_replace("%custname%",$name,$body);
						
						/* Sms Message Saving Start */
						$msgMapper = new Notification_Model_SmsMessageMapper();
						$priorMapper = new Application_Model_PriorityDataMapper();
						$prior = $priorMapper->GetPriorityByCode('H');
						$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
						$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
						$message = new Notification_Model_SmsMessage();
						$msgPhrase = uniqid ();
						$message->setBokid($bokid)
									->setPhrase($msgPhrase)
									->setDescription($body)
									->setPriority($prior->getcode())
									->setSmstype($emailType->getcode())
									->setSentToUser('RES')
									->setSentTo($name)
									->setSentFromUser('ADMIN')
									->setSentby($restname)
									->setTitle($smsobj->getMsgCode());
						
						$msgid = $msgMapper->SaveMessageDetails($message);
						/* Sms Message Saving End */
						
						$this->SendMessage($body,$mobile);
					}
					break;
					
				case 'CanNotf' :
					$template = $this->GetSmstemplate($smsobj);
					if($template){
						$data = $smsobj->getData();
						$mobile	  = str_replace("-","",$data['to']);
						$bokid 	  = $data['bokid'];
						$restname = $data['RestName'];
						$resdate  = $data['ResDate'];
						$time     = $data['Time'];
						$size     = $data['Size'];
						$name     = $data['CustomerName'];
						
						$body	 =	$template->msg_body;
						$body    = str_replace("%bokid%",$bokid,$body);
						$body    = str_replace("%restname%",$restname,$body);
						$body    = str_replace("%date%",$resdate,$body);
						$body    = str_replace("%time%",$time,$body);
						$body    = str_replace("%size%",$size,$body);
						$body    = str_replace("%custname%",$name,$body);
						
						/* Sms Message Saving Start */
						$msgMapper = new Notification_Model_SmsMessageMapper();
						$priorMapper = new Application_Model_PriorityDataMapper();
						$prior = $priorMapper->GetPriorityByCode('H');
						$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
						$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
						$message = new Notification_Model_SmsMessage();
						$msgPhrase = uniqid ();
						$message->setBokid($bokid)
									->setPhrase($msgPhrase)
									->setDescription($body)
									->setPriority($prior->getcode())
									->setSmstype($emailType->getcode())
									->setSentToUser('RES')
									->setSentTo($name)
									->setSentFromUser('ADMIN')
									->setSentby($restname)
									->setTitle($smsobj->getMsgCode());
						
						$msgid = $msgMapper->SaveMessageDetails($message);
						/* Sms Message Saving End */
						
						$this->SendMessage($body,$mobile);
					}
					break;
				case 'ReSchedule' :
					$template = $this->GetSmstemplate($smsobj);
					if($template){
						$data = $smsobj->getData();
						$mobile	  = str_replace("-","",$data['to']);
						$bokid 	  = $data['bokid'];
						$restname = $data['RestName'];
						$resdate  = $data['ResDate'];
						$time     = $data['Time'];
						$size     = $data['Size'];
						$name     = $data['CustomerName'];
						//$address  = $data['Address'];
						$body=	$template->msg_body;
						$body    = str_replace("%bokid%",$bokid,$body);
						$body    = str_replace("%ResturantName%",$restname,$body);
						$body    = str_replace("%date%",$resdate,$body);
						$body    = str_replace("%time%",$time,$body);
						$body    = str_replace("%size%",$size,$body);
						
						/* Sms Message Saving Start */
						$msgMapper = new Notification_Model_SmsMessageMapper();
						$priorMapper = new Application_Model_PriorityDataMapper();
						$prior = $priorMapper->GetPriorityByCode('H');
						$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
						$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
						$message = new Notification_Model_SmsMessage();
						$msgPhrase = uniqid ();
						$message->setBokid($bokid)
									->setPhrase($msgPhrase)
									->setDescription($body)
									->setPriority($prior->getcode())
									->setSmstype($emailType->getcode())
									->setSentToUser('CUS')
									->setSentTo($name)
									->setSentFromUser('ADMIN')
									->setSentby($restname)
									->setTitle($smsobj->getMsgCode());
						
						$msgid = $msgMapper->SaveMessageDetails($message);
						/* Sms Message Saving End */
						
						$this->SendMessage($body,$mobile);
					}					
					break;					
				case 'Cancel' :
					$template = $this->GetSmstemplate($smsobj);
					if($template){
						$data = $smsobj->getData();
						$mobile	  = str_replace("-","",$data['to']);
						$bokid 	  = $data['bokid'];
						$restname = $data['RestName'];
						$resdate  = $data['ResDate'];
						$time     = $data['Time'];
						$size     = $data['Size'];
						$name     = $data['CustomerName'];
						$body=	$template->msg_body;
						$body    = str_replace("%RestaurantName%",$restname,$body);
						$body    = str_replace("%date%",$resdate,$body);
						$body    = str_replace("%time%",$time,$body);
						$body    = str_replace("%size%",$size,$body); 
						
						/* Sms Message Saving Start */
						$msgMapper = new Notification_Model_SmsMessageMapper();
						$priorMapper = new Application_Model_PriorityDataMapper();
						$prior = $priorMapper->GetPriorityByCode('H');
						$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
						$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
						$message = new Notification_Model_SmsMessage();
						$msgPhrase = uniqid ();
						$message->setBokid($bokid)
									->setPhrase($msgPhrase)
									->setDescription($body)
									->setPriority($prior->getcode())
									->setSmstype($emailType->getcode())
									->setSentToUser('CUS')
									->setSentTo($name)
									->setSentFromUser('ADMIN')
									->setSentby($restname)
									->setTitle($smsobj->getMsgCode());
						
						$msgid = $msgMapper->SaveMessageDetails($message);
						/* Sms Message Saving End */
						
						$this->SendMessage($body,$mobile);
					}					
					break;
				case 'WaitingReserv' :
					$template = $this->GetSmstemplate($smsobj);
					if($template){
						$data = $smsobj->getData();
						$bokid 	  = $data['BookId'];
						$mobile	  = str_replace("-","",$data['to']);
						$countryCode = str_replace("+","",$data['CountryCode']);
						$user = $data['UserName'];
						$quote = $data['Quote'];
						$restname = $data['RestName'];
						
						$body=	$template->msg_body;
						
						$body    = str_replace("%custname%",$user,$body);
						$body    = str_replace("%waittime%",$quote,$body);
						$body    = str_replace("%restname%",$restname,$body);
						if($bokid != 0){
							$bokserv = new Application_Service_Booking();
							$bookDet = $bokserv->GetBookingDetails($bokid);
							$resServ = new Application_Service_Restaurant();
							$timeZone = $resServ->GetRestaurantTimeZone($bookDet->getbokfk_restaurant());
							date_default_timezone_set($timeZone);
							
							/* Sms Message Saving Start */
							$msgMapper = new Notification_Model_SmsMessageMapper();
							$priorMapper = new Application_Model_PriorityDataMapper();
							$prior = $priorMapper->GetPriorityByCode('H');
							$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
							$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
							$message = new Notification_Model_SmsMessage();
							$msgPhrase = uniqid ();
							$message->setBokid($bokid)
										->setPhrase($msgPhrase)
										->setDescription($body)
										->setPriority($prior->getcode())
										->setSmstype($emailType->getcode())
										->setSentToUser('CUS')
										->setSentTo($user)
										->setSentFromUser('ADMIN')
										->setSentby($restname)
										->setTitle($smsobj->getMsgCode());
							
							$msgid = $msgMapper->SaveMessageDetails($message);
							/* Sms Message Saving End */
						}
						$smsdata = array('PhoneNumber' => $mobile,
										 'Message'	   => $body,
										 'ReferenceID' => $msgPhrase,
										 'CountryCode' => $countryCode);
						
						$advanceSms = New Uss_Helper_SmsNotifyHelper();
						$mailStatus = $advanceSms->AdvancedSMSSend($smsdata);
						
						//$mailStatus = $this->SendMessage($body,$mobile);
					}
					return $mailStatus;
					break;
				case 'WaitingCustMsg' :
					$template = $this->GetSmstemplate($smsobj);
					if($template){
						$data = $smsobj->getData();
						$mobile	  = str_replace("-","",$data['to']);
						$countryCode = str_replace("+","",$data['CountryCode']);
						$bokid 	  = $data['BookId'];
						$restname = $data['RestName'];
						
						$user = $data['UserName'];
						$message = $data['custMsg'];
						
						$body=	$template->msg_body;
						
						$body    = str_replace("%custname%",$user,$body);
						$body    = str_replace("%msg%",$message,$body);
						$body    = str_replace("%resname%",$restname,$body);
						
						/* Sms Message Saving Start */
						$bokserv = new Application_Service_Booking();
						$bookDet = $bokserv->GetBookingDetails($bokid);
						$resServ = new Application_Service_Restaurant();
						$timeZone = $resServ->GetRestaurantTimeZone($bookDet->getbokfk_restaurant());
						date_default_timezone_set($timeZone);
							
						$msgMapper = new Notification_Model_SmsMessageMapper();
						$priorMapper = new Application_Model_PriorityDataMapper();
						$prior = $priorMapper->GetPriorityByCode('H');
						$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
						$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
						$message = new Notification_Model_SmsMessage();
						$msgPhrase = uniqid ();
						$message->setBokid($bokid)
									->setPhrase($msgPhrase)
									->setDescription($body)
									->setPriority($prior->getcode())
									->setSmstype($emailType->getcode())
									->setSentToUser('CUS')
									->setSentTo($user)
									->setSentFromUser('RES')
									->setSentby($restname)
									->setTitle($smsobj->getMsgCode());
						
						$msgid = $msgMapper->SaveMessageDetails($message);
						/* Sms Message Saving End */
						
						$smsdata = array('PhoneNumber' => $mobile,
										 'Message'	   => $body,
										 'ReferenceID' =>$msgPhrase,
										 'CountryCode' => $countryCode);
						$advanceSms = New Uss_Helper_SmsNotifyHelper();
						$mailStatus = $advanceSms->AdvancedSMSSend($smsdata);
						
						//$mailStatus = $this->SendMessage($body,$mobile);
					}
					return $mailStatus;
					break;
				case 'WaitingReady' :
					$template = $this->GetSmstemplate($smsobj);
					if($template){
						$data = $smsobj->getData();
						$mobile	  = str_replace("-","",$data['to']);
						$countryCode = str_replace("+","",$data['CountryCode']);
						$bokid 	  = $data['BookId'];
						$restname = $data['RestName'];
						
						$user = $data['UserName'];
						
						$body=	$template->msg_body;
						
						$body    = str_replace("%cusname%",$user,$body);
						$body    = str_replace("%resname%",$restname,$body);
						
						/* Sms Message Saving Start */
						$bokserv = new Application_Service_Booking();
						$bookDet = $bokserv->GetBookingDetails($bokid);
						$resServ = new Application_Service_Restaurant();
						$timeZone = $resServ->GetRestaurantTimeZone($bookDet->getbokfk_restaurant());
						date_default_timezone_set($timeZone);
						
						$msgMapper = new Notification_Model_SmsMessageMapper();
						$priorMapper = new Application_Model_PriorityDataMapper();
						$prior = $priorMapper->GetPriorityByCode('H');
						$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
						$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
						$message = new Notification_Model_SmsMessage();
						$msgPhrase = uniqid ();
						$message->setBokid($bokid)
									->setPhrase($msgPhrase)
									->setDescription($body)
									->setPriority($prior->getcode())
									->setSmstype($emailType->getcode())
									->setSentby($restname)
									->setSentToUser('CUS')
									->setSentTo($user)
									->setSentFromUser('ADMIN')
									->setTitle($smsobj->getMsgCode());
						
						$msgid = $msgMapper->SaveMessageDetails($message);
						/* Sms Message Saving End */
						
						$smsdata = array('PhoneNumber' => $mobile,
										 'Message'	   => $body,
										 'ReferenceID' => $msgPhrase,
										 'CountryCode' => $countryCode);
						$advanceSms = New Uss_Helper_SmsNotifyHelper();
						$mailStatus = $advanceSms->AdvancedSMSSend($smsdata);
						
						//$mailStatus = $this->SendMessage($body,$mobile);
					}
					return $mailStatus;
					break;
				case 'WaitingQuoteChange' :
					$data = $smsobj->getData();
					$mobile	  = str_replace("-","",$data['to']);
					$countryCode = str_replace("+","",$data['CountryCode']);
					$bokid 	  = $data['BookId'];
					$restname = $data['RestName'];
					$user = $data['UserName'];
					$Quote = $data['Quote'];
					
					if($bokid != 0){
						/* Sms Message Saving Start */
						$bokserv = new Application_Service_Booking();
						$bookDet = $bokserv->GetBookingDetails($bokid);
						$resServ = new Application_Service_Restaurant();
						$timeZone = $resServ->GetRestaurantTimeZone($bookDet->getbokfk_restaurant());
						date_default_timezone_set($timeZone);
						
						$msgMapper = new Notification_Model_SmsMessageMapper();
						$priorMapper = new Application_Model_PriorityDataMapper();
						$prior = $priorMapper->GetPriorityByCode('H');
						$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
						$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
						$message = new Notification_Model_SmsMessage();
						$msgPhrase = uniqid ();
						$message->setBokid($bokid)
									->setPhrase($msgPhrase)
									->setDescription($Quote)
									->setPriority($prior->getcode())
									->setSmstype($emailType->getcode())
									->setSentby($restname)
									->setSentToUser('CUS')
									->setSentTo($user)
									->setSentFromUser('ADMIN')
									->setTitle($smsobj->getMsgCode());
						
						$msgid = $msgMapper->SaveMessageDetails($message);
						/* Sms Message Saving End */
					}
						
					$smsdata = array('PhoneNumber' => $mobile,
									 'Message'	   => $Quote,
									 'ReferenceID' => $msgPhrase,
									 'CountryCode' => $countryCode);
					$advanceSms = New Uss_Helper_SmsNotifyHelper();
					$mailStatus = $advanceSms->AdvancedSMSSend($smsdata);
					break;
				}
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public  function GetMessageTemplate(Notification_Model_Mail $mailobj)
	{
		$templateBdMapper = new Application_Model_EmailtemplateDataMapper();
		$template = $templateBdMapper->getEmailTempByCode($mailobj->getMsgCode());
		return $template;
	}
   public function setManageContactUsForm(Zend_Form $form)
	{
		$this->_form['ManageCont'] = $form;		
	}
    public function getManageContactUsForm()
	{
		if(empty($this->_form['ManageCont'])) {
			$this->setManageContactUsForm(new Admin_Form_ManageCont());
		}
		return $this->_form['ManageCont'];
	}
	
	public function GetSmstemplate(Notification_Model_Sms $smsObj)
	{
		$templateBdMapper = new Application_Model_SmsTemplateDataMapper();
		$template = $templateBdMapper->getSmsTempByCode($smsObj->getMsgCode());
		return $template;
	}
	
	public function SendMessage($body,$mobile)
	{
		try{
			$client = new SoapClient('http://sms2.cdyne.com/sms.svc?wsdl');
 			// Specify required info to send a text message
			$param = array(
				'PhoneNumber'	=> '1+'.$mobile,
				'LicenseKey' 	=> '98fea7e4-8685-45e3-b070-fee683f4cd62',
				'Message' 		=> $body
			);
			// Send the text message
			$result = $client->SimpleSMSsend($param);
			
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			return true;
		}
	}
	
	public function AddContact($data)
	{
		try{
			$form = $this->getContactUsForm();
			$result = array();
			$recaptcha = new \ReCaptcha\ReCaptcha(Zend_Registry::get('recaptchaSecret'));
                        $resp = $recaptcha->verify($_POST['g-recaptcha-response'], $_SERVER['REMOTE_ADDR']);
			if($form->isValid($data) && $resp->isSuccess()){
				$formData = $form->getValues();

				if(isset($_SERVER['HTTP_X_FORWARDED_FOR']) && $_SERVER['HTTP_X_FORWARDED_FOR'] != '') {
				    $ip_address = $_SERVER['HTTP_X_FORWARDED_FOR'];
				} else {
	    				$ip_address = $_SERVER['REMOTE_ADDR'];
				}	
				$mapper = new Notification_Model_ContactUsDataMapper();
				$contactObj = new Notification_Model_ContactUs();
					
				$contactObj->setcontactname($formData['contactName']);
				$contactObj->setaddress($formData['address']);
				$contactObj->setcity($formData['city']);
				$contactObj->setstate($formData['state']);
				$contactObj->setcountry($formData['country']);
				$contactObj->setzip($formData['postalCode']);
				$contactObj->setphone($formData['phone']);
				$contactObj->setemail($formData['emailAddress']);
				$contactObj->setfax($formData['fax']);
				$contactObj->setwebsite($formData['website']);
				$contactObj->setmoreinformation($formData['moreinfo']);
				$contactObj->setcomments($formData['comments']);
				$contactObj->setcontactby($formData['contactType']);
				$contactObj->setpostedon(date('Y-m-d')); 
				$contactObj->setcontacttype($formData['type']);
				$status = $mapper->CreateContact($contactObj);
					
				if($status){
					$result['status'] = $status; 
					$result['form']	  = $form;	
				}

				//return $result;
				$mailmapper = new Application_Service_Notification();
				//if($formData['notificationType'] == 'email'){
				if($result['status']){
					$mailObj = new Notification_Model_Mail();
					$mailObj->setMsgCode('EnquiryNot');
						$name = $formData['contactName'];
						$data = array('Name' => $name,
						  'City'    => $formData['city'],
						  'State' => $formData['state'],
						  'Country'  => $formData['country'],
						  'Phone'     => $formData['phone'],
						  'Email'     => $formData['emailAddress'],
						  'Comments'     => $formData['comments']);
						  //'Status'	 => $formData['bookingStatus']);
						$mailObj->setData($data);
						$mailStatus = $mailmapper->SendMail($mailObj);

				}
				return $result;
			} else {
			$formData = $form->getValues();
		 	$form->populate($formData);
		 	$result['status'] = false;
		 	$result['form'] = $form;
		 	return $result;
			}	
		} catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
    public function GetAllContactUsDeatils(array $formData,$page)
	{
		 try{

		 $contSummObj = new Notification_Model_ContactUs();
		 	$form = $this->getManageContactUsForm();
		 	$result = array();
			if($form->isValid($formData)){
				 if($formData){
						if($formData['id'])

						{
							$contSummObj->setId($formData['id']);
						}


						if($formData['name']){
							$contSummObj->setcontactname($formData['name']);
						}

						if($formData['status']){
							$contSummObj->setStatus($formData['status']);
						}
//						else if($formData['status'] != ""){
//							$contSummObj->setStatus($formData['status']);
//						}
						//else if($formData['status'] == ""){
						//$contSummObj->setStatus(TRUE);
						//}
						if($formData['startdate']){
							$contSummObj->setStartDate($formData['startdate']);
						}
				        if($formData['enddate']){
							$contSummObj->setEndDate($formData['enddate']);
						}
				    	
					}
		 	$mapper = new Notification_Model_ContactUsDataMapper();
		 	$resultset = $mapper->getAllCotactUsdeatils($page,$contSummObj);
		 	$result = array('status'=>true,'personalForm'=>$resultset);
		 	return $result;  

		 	}else{

			 	$Data = $form->getValues();
				$form->populate($Data);
				$result = array('status'=>false,'personalForm'=>$form);
				return $result;
			 }
		 }
				catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function CloseContactUsDeatils($id)
	{
		try{
		 	
		 	$mapper = new Notification_Model_ContactUsDataMapper();
		 	$status = $mapper->CloseContactUsDeatils($id);
		 	return $status;  
		 
		 }catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetContactUsInfo($request)
	{
		try{
			if($request->contactid){
				$mapper = new Notification_Model_ContactUsDataMapper();
				$row    = $mapper->ReterieveContactInfo($request->contactid);
				return $row;	
			}
			 
			
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetContactUsDeatils($id)
	{
		try{
		 	$mapper = new Notification_Model_ContactUsDataMapper();
		 	$resultset = $mapper->GetContactUsDeatils($id);
		 	return $resultset;  
		 }catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function NotificationCreation(array $data,$request)
	{
		try{
			$uploadpath = "doc/";
			$docpath = "";
			$form = $this->getNotificationCreationForm();
			$result = array();
			if($form->isValid($data)){
				$documentadapter = $form->document->getTransferAdapter();
				$docName = null;
				if($documentadapter){
					$fileInfo = $documentadapter->getFileInfo();
					if($fileInfo['document']){
						$info = $fileInfo['document'];
						$docName = $info['name'];
						if($info['name']){
							$fileName =$docName;
							$documentadapter->addFilter('Rename', array('target'=>$uploadpath.$fileName, 'overwrite'=>true));
							if($documentadapter->receive($info['name'])){
								$docpath = '/'.$uploadpath.$fileName;
							}
						}
					}
				}
				$formData = $form->getValues();
				$message = new Notification_Model_EmailMessage();
				$message->setTitle($formData['Title'])
						->setDescription($formData['Description'])
						->setPriority($formData['emailPriority'])
						->setEmailtype($formData['emailtype'])
						->setSentby('adminstrator@ureserv.com')
						->setSignature($formData['signature'])
						->setDocpath($docpath);
						
				$mapper = new Notification_Model_EmailMessageDataMapper();
				$msgid = $mapper->SaveMessageDetails($message);
				$result['msgid'] = $msgid; 
				return $result;
			}else{
				$formData = $form->getValues();
				$form->populate($data);
				$result['form'] = $form;
				return $result;
			}	
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getrestaurantorcustomerdetailsbystateid(array $data,$request)
	{
		try{
			$form = $this->getRecipentFilterForm();
			if($form->isValid($data)){
				$formData = $form->getValues();
				$stateid = $formData['state'];
				$regionid = $formData['region'];
				$cityid = $formData['city'];
				$usertype = $formData['usertype'];	
				$resultArr = array();
				if($usertype == 'RES'){
					$restname = $formData['restname'];
					$groupName = $formData['restgroupname'];
					$Crestartdate = $formData['CreatedDate'];
					$Creenddate = $formData['EndDate'];
					$mapper = new ManageRestaurant_Model_RestaurantDataMapper();
					$result = $mapper->getRestaurantDetailsBystateid($stateid,$regionid,$cityid,$request,$restname,$groupName,$Crestartdate,$Creenddate);
					$resultArr['list'] = $result['UsersList'];
					$resultArr['prev'] = $result['prev'];
					$resultArr['next'] = $result['next'];
					$resultArr['count'] = $result['count'];
					if(isset($result['offset'])){
						$resultArr['offset'] = $result['offset'];
					}
					$resultArr['type'] = 'RES';
					$resultArr['msgid'] = $request->msgid;
				}else if($usertype == 'CUS'){
					$cusmapper = new Ums_Model_CustomerDataMapper();
					$result = $cusmapper->getRestaurantDetailsBystateid($stateid,$regionid,$cityid,$request);
					$resultArr['list'] = $result['UsersList'];
					$resultArr['prev'] = $result['prev'];
					$resultArr['next'] = $result['next'];
					$resultArr['count'] = $result['count'];
					if(isset($result['offset'])){
						$resultArr['offset'] = $result['offset'];
					}
					$resultArr['type'] = 'CUS';
					$resultArr['msgid'] = $request->msgid;
				}
			return $resultArr;	
			}else{
				$formData = $form->getValues();
				$form->populate($data);
				$resultArr['form'] = $form; 
				return $resultArr;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function SendNotificationToUsers($request)
	{
		try{
			$idsArr	= array();
			$campaignDetails = array();
			if($request->UserIds != ''){
				$idsArr = explode(",",$request->UserIds);
			}
			$stateid 	= $request->stateid;
			$cityid 	= $request->cityid;
			$regionid   = $request->regionid;
			$usertype 	= $request->usrtype;
			$campaignId = $request->campaignId;
			$userType = $request->usrtype;
			if($campaignId){
				$adminService = new Application_Service_Admin();
				$campProp = new Application_Model_GetCampaignForPost();
				$campProp->setAudType($userType)
						 ->setStateId($stateid)
						 ->setCityId($cityid)
						 ->setRegionId($regionid)
						 ->setIsAjaxCall(false)
						 ->setCampId($campaignId);
						 
				$campDetails = $adminService->GetCampaignDetails($campProp);
				$campaignDetails = array();
				$count = count($campDetails);
				if(!$campaignId){
					if($count > 1){
						$campaignDetails = $campDetails[rand(0,$count-1)];
						$campaignId = $campaignDetails->getId();
					}else if($campDetails){
						$campaignDetails = $campDetails[0];
						$campaignId = $campaignDetails->getId();
					}
				}else{
					$campaignDetails = $campDetails[0];
				}
			}
			if($usertype == 'RES'){
				$restName = $request->restName;
				$groupName = $request->groupname;
				$Crestartdate = $request->crestartDate;
				$Creenddate = $request->creendDate;
				$mapper = new ManageRestaurant_Model_RestaurantDataMapper();
				$result = $mapper->getRestaurantEmailIds($stateid,$cityid,$idsArr,$restName,$groupName,$Crestartdate,$Creenddate);
				$resmapper = new Notification_Model_EmailRestRecipentsDataMapper();
				$emailids = $resmapper->SaveUserEmails($request,$result,$campaignId);
			}else if($usertype == 'CUS'){
				$cusmapper = new Ums_Model_CustomerDataMapper();
				$result = $cusmapper->getUserEmailIds($stateid,$cityid,$idsArr);
				$cusmapper = new Notification_Model_EmailCusRecipentsDataMapper();
				$emailids = $cusmapper->SaveUserEmails($request,$result,$campaignId);
			}
			if($emailids){

				if($campaignDetails){
					$emailCount = count($emailids);
					$count = $this->UpdateCampaignEmailCount($campaignId,$emailCount);
				}

				$msgid = $request->messageid;
				$msgmapper = new Notification_Model_EmailMessageDataMapper();
				$msgresult = $msgmapper->GetTitleandMessageById($msgid);
				$mailObj = new Notification_Model_Mail();
				$mailObj->setMsgCode('Notification');
				if($campaignDetails){
					$data = array(
								'SenTo'    			=> 	$emailids,
				  			  	'subject'	 		=> 	$msgresult['emsg_subject'],
							  	'body'	 			=> 	$msgresult['emsg_body'],
								'signature'			=>	$msgresult['emsg_signature'],
							  	'campaignName'		=> 	trim($campaignDetails->getSponsor()),
								'campaignDesc'		=>	trim($campaignDetails->getCampDesc()),
								'campaignImg'		=>	trim($campaignDetails->getCampImage())
					);
				}else{
					$data = array(
								'SenTo'    			=> 	$emailids,
				  			  	'subject'	 		=> 	$msgresult['emsg_subject'],
							  	'body'	 			=> 	$msgresult['emsg_body'],
								'signature'			=>	$msgresult['emsg_signature']
					);
				}
				
				$mailObj->setData($data);
				$mailStatus = $this->SendMail($mailObj);
			}
			return $result;						
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getMessageDeatails($request)
	{
		try{
			$msgid = $request->msgid;
			$mapper = new Notification_Model_EmailMessageDataMapper();
			$result = $mapper->GetMessageDetailsById($msgid);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getMessageFromDetails($request)
	{
		try{
			$msgform = $this->getNotificationCreationForm();
			$msgid = $request->msgid;
			$mapper = new Notification_Model_EmailMessageDataMapper();
			$result = $mapper->GetMessageDetailsById($msgid);
			$formValues = array(
					'Title'			=>	$result->emsg_subject,
					'Description'	=> 	$result->emsg_body,
					'emailPriority'	=>	$result->emsg_priority,
					'emailtype'		=>	$result->emsg_emailtype,
					'id'			=>	$msgid
			);
			$msgform->populate($formValues);
			return $msgform;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function UpdatemessageDeatils(array $data)
	{
		try{
			$result = array();
			$form = $this->getNotificationCreationForm();
			if($form->isValid($data)){
				$formData = $form->getValues();
				$message = new Notification_Model_EmailMessage();
				$message->setTitle($formData['Title'])
						->setDescription($formData['Description'])
						->setPriority($formData['emailPriority'])
						->setEmailtype($formData['emailtype'])
						->setid($formData['id'])
						->setSignature($formData['signature']);
						
				$mapper = new Notification_Model_EmailMessageDataMapper();
				$status = $mapper->UpdatemessageDeatils($message);
				$result['status'] = $status;
			}else{
				$formData = $form->getValues();
				$form->populate($formData);
				$result['form'] = $form;
			}
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getEmailIds(array $data)
	{
		try{
			$form = $this->getRecipentFilterForm();
			if($form->isValid($data)){
				$formData = $form->getValues();
				$stateid = $formData['state'];
				$cityid = $formData['city'];
				$usertype = $formData['usertype'];
				
				$mapper = new Notification_Model_EmailMessageDataMapper();
				$result = $mapper->GetEmailIdsById($stateid,$cityid,$usertype);
				return $result;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getAllNotifications()
	{
		try{
			$mapper = new Notification_Model_EmailMessageDataMapper();
			$result = $mapper->getAllNotifications();
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetMsgDetalisandSentListByMsgId($request)
	{
		try{
			$resultArr = array();
			$campDetails = "";
			$state = "";
			$msgid = $request->msgid;
			$mapper = new Notification_Model_EmailMessageDataMapper();
			$msgresult = $mapper->GetMessageDetailsById($msgid);
			$cmpmapper = new Admin_Model_CampaignDataMapper();
			if($msgresult['emsg_campaignid'] != ""){
				$campDetails = $cmpmapper->GetCampaignDetailsById($msgresult['emsg_campaignid']);
			}
			$mailObj = new Notification_Model_Mail();
			$mailObj->setMsgCode('Notification');
			$template = $this->GetMessageTemplate($mailObj);
			if($campDetails){
				$title			= $msgresult['emsg_subject'];
			  	$message		= $msgresult['emsg_body'];
			  	$signature  = $msgresult['emsg_signature'];
			  	$campaignName	= trim($campDetails['spocompany_name']);
				$campaignDesc	= trim($campDetails['scimage']).'</br>'.trim($campDetails['scdesc']);
				
			}else{
				$title		= $msgresult['emsg_subject'];
			  	$message	= $msgresult['emsg_body'];
			  	$signature  = $msgresult['emsg_signature'];
			}
			if(isset($campaignName) && isset($campaignName)){
					$name 	= $campaignName;
					$desc  = $campaignDesc;
					$desc  = str_replace('src="','src="http://www.ureserv.com',$desc);
					$display  = 'block';
			}
			$body	= $template->msg_body;
			
			if(isset($campaignName) && isset($campaignName)){
				$body    = str_replace("none",$display,$body);
				$body    = str_replace("%desc%",$desc,$body);
				$body    = str_replace("%campName%",$name,$body);	
			}
			$body    = str_replace("%body%",$message,$body);
			$signature = str_replace(",",',<br/>',$signature);
			$body    = str_replace("%signature%",$signature,$body);
		
			
			if($msgresult['emsg_email_users'] == 'RES'){
				$resmapper = new Notification_Model_EmailRestRecipentsDataMapper();
				$result = $resmapper->getSentDetailsByMsgid($request);
			}else if($msgresult['emsg_email_users'] == 'CUS'){
				$cusmapper = new Notification_Model_EmailCusRecipentsDataMapper();
				$result = $cusmapper->getSentDetailsByMsgid($request);
			}
			$resultArr['title']   = $title;
			$resultArr['Message'] = $body;
			
			if(isset($result)){
				$resultArr['list'] = $result['UsersList'];
				$resultArr['prev'] = $result['prev'];
				$resultArr['next'] = $result['next'];
				if(isset($result['offset'])){
					$resultArr['offset'] = $result['offset'];
				}
				$resultArr['msgid'] = $request->msgid;
			}
			return $resultArr;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetTitleandMessageById($msgid)
	{
		try{
			$campDetails = "";
			$mapper = new Notification_Model_EmailMessageDataMapper();
			$msgresult = $mapper->GetMessageDetailsById($msgid);
			$cmpmapper = new Admin_Model_CampaignDataMapper();
			if($msgresult['emsg_campaignid'] != ""){
				$campDetails = $cmpmapper->GetCampaignDetailsById($msgresult['emsg_campaignid']);
			}
			$mailObj = new Notification_Model_Mail();
			$mailObj->setMsgCode('Notification');
			$template = $this->GetMessageTemplate($mailObj);
			if($campDetails){
				$title			= $msgresult['emsg_subject'];
			  	$message		= $msgresult['emsg_body'];
			  	$signature  = $msgresult['emsg_signature'];
			  	$campaignName	= trim($campDetails['spocompany_name']);
				$campaignDesc	= trim($campDetails['scdesc']);
			}else{
				$title		= $msgresult['emsg_subject'];
			  	$message	= $msgresult['emsg_body'];
			  	$signature  = $msgresult['emsg_signature'];
			}
			if(isset($campaignName) && isset($campaignName)){
					$name 	= $campaignName;
					$desc  = $campaignDesc;
					$desc  = str_replace('src="','src="http://www.ureserv.com',$desc);
					$display  = 'block';
			}
			$body	= $template->msg_body;
			
			if(isset($campaignName) && isset($campaignName)){
				$body    = str_replace("none",$display,$body);
				$body    = str_replace("%desc%",$desc,$body);
				$body    = str_replace("%campName%",$name,$body);	
			}
			$body    = str_replace("%body%",$message,$body);
			$signature = str_replace(",",',<br/>',$signature);
			$body    = str_replace("%signature%",$signature,$body);
			$resultArr = array();
			$resultArr['title']   = $title;
			$resultArr['Message'] = $body;
			return $resultArr;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function ChangeBokStatusByResponse($request)
	{
		try{
			$bokservice = new Application_Service_Booking();
			$bokservice->ChangeBokStatusByResponse($request);
			
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	

	public  function WidgetNotifyFriendsEmail($request)//Moiz
	{
		try{
				$fromaddressNotify = 'info@ureserv.com';
				$fromnameNotify = 'UReserv';
				$mailmapper = new Application_Service_Notification();
				$mailObj = new Notification_Model_Mail();
				$mailObj->setMsgCode('notifyfriends');
				
				$resDataMapper = new ManageRestaurant_Model_RestaurantDataMapper();
				$restid = new ManageRestaurant_Model_RestaurantById();
				$restid->setRestaurantId($request->resid);
				$resDetails = $resDataMapper->getRestaurantById($restid);
				
				$bokidNew=$request->bokid;
				$bookServ = new Application_Service_Booking();
				$bookResult = $bookServ->GetBookingDetailsByPhraseId($bokidNew);
				
				$bookid = $request->bokid;
				$mapper = new Booking_Model_BookingDataMapper();
				/* get booing id with phraseid */
				$phraseId = $mapper->GetBookingIdByBookPhrase($bookid);
				
				$restname = $resDetails->getRestaurantname();
				$restaddr = $resDetails->getRestaddress();
				$restphone = $resDetails->getRestphone();
				$restcity = $resDetails->getRestCityDesc();
				$restzipcode = $resDetails->getRestzipcode();
				$restemail = $resDetails->getRestemail();
				$restneighbour = $resDetails->getRestNeighborDesc();
				$stateId=$resDetails->getReststateid();
				$isAjaxCall = true;
				$mapper = new Specials_Model_RestaurantSpecialDataMapper();
				if(($request->splname)){
					$resultdata = $mapper->getRestaurantSplByBookingId($bokidNew,$isAjaxCall);
					$splstatus=$resultdata['Status'];
					$splname=$resultdata['Special Name'];
					$splid=$resultdata['Id'];
					$spldesc=$resultdata['Desc'];
				}else{
					$splstatus='';
					$splname='';
					$splid='';
					$spldesc='';
				}
				
				if($stateId == ""){
					$stateCity = $this->getRestaurantStateByResId($request->resid);
					$stateId = $stateCity['state'];
					$cityId = $stateCity['city'];
					$regionId = $stateCity['region'];
				}else{
					$cityId = $resDetails->getRestCity();
					$regionId = $resDetails->getRestRegion();
				}
				$userType = 'CUS';
				$adminService = new Application_Service_Admin();
				$campProp = new Application_Model_GetCampaignForPost();
				$campProp->setAudType($userType)
				->setStateId($stateId)
				->setCityId($cityId)
				->setRegionId($regionId)
				->setIsAjaxCall(false);
				$campDetails = $adminService->GetCampaignDetails($campProp);
				
				if(count($campDetails)){
					$count = count($campDetails);
					if($count > 1){
						$campaign = $campDetails[rand(0,$count-1)];
					}else{
						$campaign = $campDetails[0];
					}
					$notfService = new Application_Service_Notification();
					$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
					$campaignName = trim($campaign->getSponsor());
					$campaignDesc =	trim($campaign->getCampDesc());
					$campaignImg =	trim($campaign->getCampImage());
					$campId= $campaign->getId();
				}else{
					$campaignName = "";
					$campaignDesc = "";
					$campaignImg = "";
					$campId = "";
				}
					$data = array('UserName' =>$bookResult->getbokfirst_name().' '.$bookResult->getboklast_name(),
								  'SendTo'    =>$request->to,
								  'RestName' => $restname,
								  'RestNbh'  => $restneighbour,
								  'ResDate'  => $request->date,
								  'Time'     => $request->time,
								  'Size'     => $request->partysize,
								  'Address'	 => $restaddr,
								  'Bokid'	 =>	$phraseId,
								  'City'	 =>	$restcity,
								  'Phone'	 => $restphone,
								  'Zipcode'	 => $restzipcode,
								  'RestEmail'=> $restemail,
								  'splname'	 =>	$splname,
								  'splstatus'=> $splstatus,
								  'spldesc'  => $spldesc,
								  'splid'	 => $splid,
								  'campaignName'=>$campaignName,
								  'campaignDesc'=>$campaignDesc,
								  'campaignImg'=>$campaignImg,
								  'campId'=>$campId,
								  'UserType'=>$userType
								  
					);
					$mailObj->setData($data);
					$mailStatus = $mailmapper->SendMail($mailObj);
						    
			}catch(Exception $ex){
				Uss_Logger_FileLogger::info($ex->getMessage());
				return true;
			}
	}
	public  function NotifyConfirmation(Booking_Model_Booking $bookObj,$request)//Moiz
	{
		try{
			$confirmationstatus = $request->constat;
			$fromaddressNotify = 'info@ureserv.com';
			$fromnameNotify = $request->senderemail;
				
			Zend_Mail::setDefaultTransport( new Zend_Mail_Transport_Postmark('37c5685c-d02f-4581-b6f8-c922a7bee942' ));
			$mail = new Zend_Mail();
			$email=$bookObj->getbokemail();	
			$subjectFriend='Acknowledgement';
			if($confirmationstatus==0){
				$mailbodyFriend='<div style="border:1px solid #F79646; padding:5px; line-height:32px;">Hi '.$bookObj->getbokfirst_name().' '.$bookObj->getboklast_name().',<br/>your guest '.$request->senderemail.' can not attend your reservation.</div>';
			}else{
				$mailbodyFriend='<div style="border:1px solid #F79646; padding:5px; line-height:32px;">Hi '.$bookObj->getbokfirst_name().' '.$bookObj->getboklast_name().',<br/>your guest '.$request->senderemail.' can attend your reservation.</div>';
			}
			
			$mail->setFrom($fromaddressNotify, $fromnameNotify);
			$mail->setReplyTo($fromaddressNotify,$fromnameNotify);
			$mail->setSubject($subjectFriend);
			$mail->setBodyHtml($mailbodyFriend);
			$mail->addTo($email,$email);								   
		    $mail->send();
			
			}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			return true;
		}
	}
	
	public function AddContactFromDemo($formData)
	{
		try{
			if(isset($_SERVER['HTTP_X_FORWARDED_FOR']) && $_SERVER['HTTP_X_FORWARDED_FOR'] != '') {
			 	$ip_address = $_SERVER['HTTP_X_FORWARDED_FOR'];
			} else {
    				$ip_address = $_SERVER['REMOTE_ADDR'];
			}
			$recaptcha = new \ReCaptcha\ReCaptcha(Zend_Registry::get('recaptchaSecret'));
                        $resp = $recaptcha->verify($_POST['g-recaptcha-response'], $_SERVER['REMOTE_ADDR']);
			if($resp->isSuccess()) {
				$result = array();
				$mapper = new Notification_Model_ContactUsDataMapper();
				$contactObj = new Notification_Model_ContactUs();
				$firstName=$formData['firstName'];
				$lastName=$formData['lastName'];
				$name=$firstName.$lastName;
				$contactObj->setcontactname($name);
				$contactObj->setaddress('');
				$contactObj->setcity($formData['city']);
				$contactObj->setstate($formData['state']);
				$contactObj->setcountry('');
				$contactObj->setzip($formData['zipcode']);
				$contactObj->setphone($formData['phoneNumber']);
				$contactObj->setemail($formData['emailAddress']);
				$contactObj->setfax('');
				$contactObj->setwebsite('');
				$contactObj->setmoreinformation('F');
				$contactObj->setcomments($formData['comments']);
				$contactObj->setcontactby($formData['contactType']);
				$contactObj->setpostedon(date('Y-m-d')); 
				$contactObj->setcontacttype('demo');
				$status = $mapper->CreateContact($contactObj);
				
				$mailmapper = new Application_Service_Notification();
				if($formData['contactType'] == 'email'){
					if($status){
						$mailObj = new Notification_Model_Mail();
						$mailObj->setMsgCode('EnquiryNot');
							$data = array('Name' => $name,
							  'City'    => $formData['city'],
							  'State' => $formData['state'],
							  'Country'  => '',
							  'Phone'     => $formData['phoneNumber'],
							  'Email'     => $formData['emailAddress'],
							  'Comments'     => $formData['comments']);
							  //'Status'	 => $formData['bookingStatus']);
						$mailObj->setData($data);
						$mailStatus = $mailmapper->SendMail($mailObj);
					}	
				}
				return $status;
			} else {
				return false;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function MessageDisplayDetails($request)
	{
		try{
			$msgid = $request->msgid;
			$sender = '';
			if(isset($request->senderemail)){
				$sender = $request->senderemail;
			}
			$email_mapper = new Notification_Model_EmailMessageDataMapper();
			$msgid = $email_mapper->GetMsgIdByPhrase($msgid);
			if($msgid){
				$emailMessage = $email_mapper->GetMessageDetailsById($msgid);
				if($emailMessage && $emailMessage->emsg_fk_bokid){
					if($emailMessage->emsg_email_users == 'RES'){
						$bookServ = new Application_Service_Booking();
						$bookResult = $bookServ->MessageDisplayDetailsForRestOwner($emailMessage,$sender);
					}
					else{					
						$bookServ = new Application_Service_Booking();
						$bookResult = $bookServ->MessageDisplayDetails($emailMessage,$sender);
					}
					return array('result'=>$bookResult['body'],'msg'=>$bookResult['msg'],'user'=>$emailMessage->emsg_email_users);
				}else{
					return false;
				}
			}else{
				return false;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function SuggestRestaurant($data)
	{
		try{
			$suggest = new Application_Model_CustomerSuggestRestaurant();
			$suggest->setUserId($data['user'])
					->setLastName($data['lastName'])
					->setFirstName($data['firstName'])
					->setRestName($data['restName'])
					->setRestManager($data['restManager'])
					->setRestAddress($data['restAddr'])
					->setRestCity($data['restCity'])
					->setRestState($data['restState'])
					->setRestEmail($data['restEmail'])
					->setRestPhone($data['restPhone'])
					->setRestZip($data['restZipcode']);
			$mapper = new Application_Model_CustomerSuggestRestaurantMapper();
			$result = $mapper->SuggestRestaurant($suggest);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	public  function rnNotifyConfirmation(Booking_Model_Booking $bookObj,$request)//Moiz
	{
		try{
			$confirmationstatus = $request->constat;
			$fromaddressNotify = 'reservations@rewardsnetwork.com';
			$fromnameNotify = $request->senderemail;
				
			Zend_Mail::setDefaultTransport( new Zend_Mail_Transport_Postmark('37c5685c-d02f-4581-b6f8-c922a7bee942' ));
			$mail = new Zend_Mail();
			$email=$bookObj->getbokemail();	
			$subjectFriend='Acknowledgement';
			if($confirmationstatus==0){
				$mailbodyFriend  = '<table width="640" border="0" cellspacing="0" cellpadding="0" align="center" bgcolor="#ffffff">
						  <tbody><tr>
						    <td width="20" height="20" bgcolor="#899639"></td>
						    <td width="600" bgcolor="#899639"></td>
						    <td width="20" height="20" bgcolor="#899639"></td>
						  </tr>
						  <tr>
						    <td height="20" bgcolor="#899639"></td>
						    <td width="600" align="left" valign="top"></td>
						    <td height="20" bgcolor="#899639"></td>
						  </tr>
						  <tr>
						    <td height="20" bgcolor="#899639"></td>
						    <td align="left" valign="top"><a href="http://www.rewardsnetwork.com/" target="_blank" style="display:block"><img style="padding:20px; display:block" src="http://www.ureserv.com/images/RN_images/r_w_logo.png" alt="RN Reservations" width="303" border="0" height="47"></a></td>
						    <td height="20" bgcolor="#899639"></td>
						  </tr>
						  <tr>
						    <td height="28" bgcolor="#899639"></td>
						    <td align="left" valign="top"></td>
						    <td height="28" bgcolor="#899639"></td>
						  </tr>
						  <tr>
						    <td height="20" bgcolor="#899639"></td>
						    <td align="left" valign="top">
								<table width="100%" border="0" cellspacing="0" cellpadding="0">
								  <tbody><tr>
									<td width="20" height="20"></td>
								    <td align="left" valign="top"><span style="font-family: Arial, Helvetica, sans-serif; font-weight: bold; font-size: 18px;">Dear '.$bookObj->getbokfirst_name().' '.$bookObj->getboklast_name().',</span></td>
								    <td width="20" height="20"></td>
								  </tr>
								  <tr>
								    <td height="12"></td>
								    <td align="left" valign="top"></td>
								    <td height="12"></td>
							      </tr>
								  <tr>
								    <td height="20"></td>
								    <td align="left" valign="top"><span style="font-family: Arial, Helvetica, sans-serif; font-weight: bold; font-size: 18px;">Your guest '.$request->senderemail.' can not attend your reservation.</span></td>
								    <td height="20"></td>
							      </tr>
								  <tr>
								    <td height="28"></td>
								    <td align="left" valign="top"></td>
								    <td height="28"></td>
							      </tr>
								  <tr>
								    <td height="20"></td>
								    <td align="left" valign="top"></td>
								    <td height="20"></td>
							      </tr>
								</tbody></table>
							</td>
						    <td height="20" bgcolor="#899639"></td>
						  </tr>
						  <tr>
						    <td height="20" bgcolor="#899639"></td>
						    <td align="left" valign="top"><table width="100%" border="0" cellspacing="0" cellpadding="0">
						      <tbody><tr>
							  	<td width="20"></td>
						        <td width="50"><a href="http://www.bbb.org/chicago/business-reviews/fulfillment-services/rewards-network-in-chicago-il-23000504#bbblogo" style="display:block;" target="_blank"><img style="display:block;" src="http://www.ureserv.com/images/RN_images/bbb_image.png" width="50" height="65"></a></td>
						        <td align="center" valign="bottom">
										<table width="250" border="0" cellspacing="0" cellpadding="0" align="center">
										  <tbody><tr>
											<td colspan="8" align="center"><span style="font-family:Arial, Helvetica, sans-serif; font-size:14px;">Visit us on <a href="http://www.ureserv.com" target="_blank">www.ureserv.com</a></span></td>
										  </tr>
										  <tr><td colspan="8" align="center" height="6"></td></tr>
										   <tr>
											<td align="right"><span style="font-family:Arial, Helvetica, sans-serif; font-size:14px;">Follow us on </span></td>
											<td><a href="http://www.facebook.com/ureserv" target="_blank"><img src="http://www.ureserv.com/images/ureservimages/ufacebook.png"></a></td>
											<td width="4"></td>
											<td><a href="http://twitter.com/#!/ureserv" target="_blank"><img src="http://www.ureserv.com/images/ureservimages/utwitter.png"></a></td>
											<td width="4"></td>
											<td><a href="http://twitter.com/#!/ureserv" target="_blank"><img src="http://www.ureserv.com/images/ureservimages/uink.png"></a></td>
											<td width="4"></td>
											<td><a href="http://www.youtube.com/ureserv" target="_blank"><img src="http://www.ureserv.com/images/ureservimages/youtube.png"></a></td>
									  </tr>
									</tbody></table>
								</td>
						        <td width="125" align="right" valign="bottom"><a href="http://www.ureserv.com" target="_blank"><img style="display:block;" src="http://www.ureserv.com/images/RN_images/footer_logo.png" alt="Powered by UReserv" width="125" height="60"></a></td>
								<td width="20" align="right" valign="bottom"></td>
						      </tr>
						    </tbody></table>
							</td>
						    <td bgcolor="#899639"></td>
						  </tr>
						  <tr>
						    <td height="20" bgcolor="#899639"></td>
						    <td align="left" valign="top"></td>
						    <td height="20" bgcolor="#899639"></td>
						  </tr>
						 <tr>
						    <td width="20" height="20" bgcolor="#899639"></td>
						    <td width="600" bgcolor="#899639"></td>
						    <td width="20" height="20" bgcolor="#899639"></td>
						  </tr>
						</tbody></table>';
			}else{
				$mailbodyFriend  = '<table width="640" border="0" cellspacing="0" cellpadding="0" align="center" bgcolor="#ffffff">
				  <tbody><tr>
				    <td width="20" height="20" bgcolor="#899639"></td>
				    <td width="600" bgcolor="#899639"></td>
				    <td width="20" height="20" bgcolor="#899639"></td>
				  </tr>
				  <tr>
				    <td height="20" bgcolor="#899639"></td>
				    <td width="600" align="left" valign="top"></td>
				    <td height="20" bgcolor="#899639"></td>
				  </tr>
				  <tr>
				    <td height="20" bgcolor="#899639"></td>
				    <td align="left" valign="top"><a href="http://www.rewardsnetwork.com/" target="_blank" style="display:block"><img style="padding:20px; display:block" src="http://www.ureserv.com/images/RN_images/r_w_logo.png" alt="RN Reservations" width="303" border="0" height="47"></a></td>
				    <td height="20" bgcolor="#899639"></td>
				  </tr>
				  <tr>
				    <td height="28" bgcolor="#899639"></td>
				    <td align="left" valign="top"></td>
				    <td height="28" bgcolor="#899639"></td>
				  </tr>
				  <tr>
				    <td height="20" bgcolor="#899639"></td>
				    <td align="left" valign="top">
						<table width="100%" border="0" cellspacing="0" cellpadding="0">
						  <tbody><tr>
							<td width="20" height="20"></td>
						    <td align="left" valign="top"><span style="font-family: Arial, Helvetica, sans-serif; font-weight: bold; font-size: 18px;">Dear '.$bookObj->getbokfirst_name().' '.$bookObj->getboklast_name().',</span></td>
						    <td width="20" height="20"></td>
						  </tr>
						  <tr>
						    <td height="12"></td>
						    <td align="left" valign="top"></td>
						    <td height="12"></td>
					      </tr>
						  <tr>
						    <td height="20"></td>
						    <td align="left" valign="top"><span style="font-family: Arial, Helvetica, sans-serif; font-weight: bold; font-size: 18px;">Your guest '.$request->senderemail.' can attend your reservation.</span></td>
						    <td height="20"></td>
					      </tr>
						  <tr>
						    <td height="28"></td>
						    <td align="left" valign="top"></td>
						    <td height="28"></td>
					      </tr>
						  <tr>
						    <td height="20"></td>
						    <td align="left" valign="top"></td>
						    <td height="20"></td>
					      </tr>
						</tbody></table>
					</td>
				    <td height="20" bgcolor="#899639"></td>
				  </tr>
				  <tr>
				    <td height="20" bgcolor="#899639"></td>
				    <td align="left" valign="top"><table width="100%" border="0" cellspacing="0" cellpadding="0">
				      <tbody><tr>
					  	<td width="20"></td>
				        <td width="50"><a href="http://www.bbb.org/chicago/business-reviews/fulfillment-services/rewards-network-in-chicago-il-23000504#bbblogo" style="display:block;" target="_blank"><img style="display:block;" src="http://www.ureserv.com/images/RN_images/bbb_image.png" width="50" height="65"></a></td>
				        <td align="center" valign="bottom">
								<table width="250" border="0" cellspacing="0" cellpadding="0" align="center">
								  <tbody><tr>
									<td colspan="8" align="center"><span style="font-family:Arial, Helvetica, sans-serif; font-size:14px;">Visit us on <a href="http://www.ureserv.com" target="_blank">www.ureserv.com</a></span></td>
								  </tr>
								  <tr><td colspan="8" align="center" height="6"></td></tr>
								   <tr>
									<td align="right"><span style="font-family:Arial, Helvetica, sans-serif; font-size:14px;">Follow us on </span></td>
									<td><a href="http://www.facebook.com/ureserv" target="_blank"><img src="http://www.ureserv.com/images/ureservimages/ufacebook.png"></a></td>
									<td width="4"></td>
									<td><a href="http://twitter.com/#!/ureserv" target="_blank"><img src="http://www.ureserv.com/images/ureservimages/utwitter.png"></a></td>
									<td width="4"></td>
									<td><a href="http://twitter.com/#!/ureserv" target="_blank"><img src="http://www.ureserv.com/images/ureservimages/uink.png"></a></td>
									<td width="4"></td>
									<td><a href="http://www.youtube.com/ureserv" target="_blank"><img src="http://www.ureserv.com/images/ureservimages/youtube.png"></a></td>
							  </tr>
							</tbody></table>
						</td>
				        <td width="125" align="right" valign="bottom"><a href="http://www.ureserv.com" target="_blank"><img style="display:block;" src="http://www.ureserv.com/images/RN_images/footer_logo.png" alt="Powered by UReserv" width="125" height="60"></a></td>
						<td width="20" align="right" valign="bottom"></td>
				      </tr>
				    </tbody></table>
					</td>
				    <td bgcolor="#899639"></td>
				  </tr>
				  <tr>
				    <td height="20" bgcolor="#899639"></td>
				    <td align="left" valign="top"></td>
				    <td height="20" bgcolor="#899639"></td>
				  </tr>
				 <tr>
				    <td width="20" height="20" bgcolor="#899639"></td>
				    <td width="600" bgcolor="#899639"></td>
				    <td width="20" height="20" bgcolor="#899639"></td>
				  </tr>
				</tbody></table>';
			}
			
			$mail->setFrom($fromaddressNotify, $fromnameNotify);
			$mail->setReplyTo($fromaddressNotify,$fromnameNotify);
			$mail->setSubject($subjectFriend);
			$mail->setBodyHtml($mailbodyFriend);
			$mail->addTo($email,$email);								   
		    $mail->send();
			
			}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			return true;
		}
	}
}
