<?php
/**
*	Name			: OderManagment.php
*	Author			: Sai
*	Creation Date	: 12/12/2016
*	Path 			: application/services/OrderManagement.php
*	Description		: This is the service class for the Odering module from POS.
*					   	
*/
class Application_Service_OrderManagement
{
	public function migrateOrdersFromIpad(array $orders)
	{
		try {
			$orderMapper = new FirmManagement_Model_PosRestaurantOrdersMapper();
			$response = $orderMapper->migratePosOrderFromIpad($orders);
			return $response;

		} catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	/**
	 * FETCH ALL ORDERS AND ITS DETAILS BY RESTAURANT ID
	 */
	public function fetchOrdersByResid($resid,$date = null)
	{
		try {
			$orderMapper = new FirmManagement_Model_PosRestaurantOrdersMapper();
			
			$where = array('pro_restaurant_fk_id = ?'=>$resid);
			if($date!=null)
			{
				$where['pro_ordercreateddatetime::date = ?'] = $date;
			}
			$response = $orderMapper->fetchOrdersForIpad($where);
			return $response;

		} catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * FETCH ALL ORDERS AND ITS DETAILS BY RESTAURANT ID
	 */
	public function fetchOrdersByBookingId($bokid)
	{
		try {
			$orderMapper = new FirmManagement_Model_PosRestaurantOrdersMapper();
			$where = array('pro_booking_fk_id = ?'=>$bokid);
			$response = $orderMapper->fetchOrdersForIpad($where);
			return $response;

		} catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
}