<?php
class Application_Service_Partner
{
	public function APIAccess($request)
	{
		try{
			
			$licensekey = $request->key;
			// Check License Key valid or not
			$companyMapper = new Administrator_Model_CompanyDataMapper();
			$licenseStatus = $companyMapper->checkLicenseKey($licensekey);	
			
			$restmapper = new FirmManagement_Model_FirmDataMapper();
			// Gets CompanyId of restaurant with restaurantid //
			$companyid = "";
			if(isset($request->restaurantid)){
				$companyid = $restmapper->getcompanyIdbyResid($request->restaurantid);
			}else if(isset($request->bookingid)){
				$companyid = $restmapper->getcompanyIdbyBookingid($request->bookingid);
			}
			$resModeMapper = new Application_Model_ReservationModeDataMapper();
			$resModeStatus 	  = $resModeMapper->GetReservationModeByDesc($licenseStatus['comapnyName']);
			$resModeObj = '';
			if(array_key_exists($licenseStatus['comapnyName'],$resModeStatus)){
				$resModeObj 	  = $resModeStatus[$licenseStatus['comapnyName']];
			}
			$finalArr = array();
			$parCompanyId = '';
			if($resModeObj){
				$parCompanyId = 8; // Etable Asia's company id
				$request->setParam('bokSrcComp',$resModeObj->getCode());
			}
							
			if(count($licenseStatus) > 0)
			{				
				if($licenseStatus['comapnyId'] == $companyid || $parCompanyId == $companyid)
				{
					if($licenseStatus['comapnyStatus']){
						// if license key valid
						$apiname = $request->apiname;
						switch($apiname){
							
							/* Authenticate Login */
							case 'AL'		 : 	$finalArr = $this->validateLoginDetails($request,$licenseStatus['comapnyId']);														
															break;															
							/* Get Meal Types */																					
							case 'GMT' 		 :	$finalArr = $this->getMealTypesAPI($request);												
															break;														
							/* Get Availability */														
							case 'GA'		 :	$finalArr = $this->getAvailabilityAPI($request);
															break;
							/* Make Reservation */																				
							case 'MR'		 : 	$finalArr = $this->makeReservationAPI($request);
															break;
							/* Confirm Reservation */									
							case 'RC'		 :	$finalArr = $this->confirmReservationAPI($request);
															break;
							/* Cancel Reservation */								
							case 'CR'		 :	$finalArr = $this->cancelReservationAPI($request);
															break;
							/* Restaurant Info */									
							case 'RI'		 :	$finalArr = $this->getRestaurantInfoAPI($request);
															break;
							/* Get Waitlist Partysize and Times */														
							case 'WLPST' 	 : 	$finalArr = $this->getWaitListPartysizesAndWaitTimesAPI($request);
															break; 
							/* Get Waiting Time for Partysize */									
							case 'WLTFPS' 	 : 	$finalArr = $this->getWaitingTimeForPartysizeAPI($request);
															break;
							/* Make Waitlist Reservation */														
							case 'MWLR'	 	 : 	$finalArr = $this->makeWaitListReservationAPI($request);
															break;
							/* Cancel Waitlist Reservation */									
							case 'CWLR'	 	 :	$finalArr = $this->cancelWaitListReservationAPI($request);
															break;														
							/* Get Reservation Info */														
							case 'GRI' 	 	 :	$finalArr = $this->getReservationInfoAPI($request);
															break; 
							/* Update Reservation */																				
							case 'UR' 	 	 :  $finalArr = $this->updatereservationdetailsAPI($request);
															break;
						}
					}else{
						// if licence key status is inactive
						$finalArr['message'] = 'Company License key status is Inactive.';
					}
				}else{
					// if license key not Exists 
					$finalArr['message'] = 'Restaurant Cannot be Accessed with this License Key';
				}
			}else{
				// if restaurant doesnt exists in the company
				$finalArr['message'] = 'License key Not exisits';
			}				
			return $finalArr;
		
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getAvailabilityAPI($request)
	{
	   try
	   {
			$bookingService = new Application_Service_Reservation();
			$slotsArr = $bookingService->GetRestTimingsForPartnerRest($request);
			
			$finalArr = array();
			
			if($slotsArr){
				
				$tempArr = array();
				
				foreach($slotsArr as $slot){
					if($slot['status'] == 'WAL'){
						continue;
					}else{
						$tempArr[] = $slot['time'];
					} 
				}
				if(count($tempArr) > 0){
					$finalArr['status'] = 'Y';
					$finalArr['slots'] = $tempArr;
				}
			}else{
				$request->setParams(array('restid'=>$request->restaurantid));
				$frezresult = $bookingService->getFreezeTypeByDate($request);
				if($frezresult && $frezresult['type'] == 'All'){
					$frzdescMap = $bookingService->getFreezeDesc($request);
					if($frzdescMap && $frzdescMap->rfdm_desc){
						$finalArr['status'] = 'N';
						$finalArr['message'] = $frzdescMap->rfdm_desc;
					}else{
						$serv = new Application_Service_Firm();
						$msg = $serv->getRestaurantTimeSearchMessage($request->restaurantid);
						if($msg->resbooking_search_msg){
							$finalArr['status'] = 'N';
							$finalArr['message'] = $msg->resbooking_search_msg;
						}else{
							$finalArr['status'] = 'N';
							$finalArr['message'] = "The date you are looking for is not available. Please select another time";
						}
					}
				}else{
					$serv = new Application_Service_Firm();
					$msg = $serv->getRestaurantTimeSearchMessage($request->restaurantid);
					if($msg->resbooking_search_msg){
						$finalArr['status'] = 'N';
						$finalArr['message'] = $msg->resbooking_search_msg;
					}else{
						$finalArr['status'] = 'N';
						$finalArr['message'] = "The time you are looking for is not available. Please select another time";
					}
				}
			}
						
			return $finalArr;		
				
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getMealTypesAPI($request)
	{
		try
		{
			$bookService = new Application_Service_Reservation();			
			$mealTypArr = $bookService->getPartnerRestMealTypes($request);
			
			$finalArr = array();
			
			if(count($mealTypArr) > 0)
			{
				$finalArr["status"] = "Y";
				$finalArr["mealtypes"] = $mealTypArr['mealtype'];
                                $finalArr["data"] = $mealTypArr['data'];
			}
			else
			{
				$finalArr["status"] = "N";
				$finalArr["message"] = "This restaurant dosen't have any meal type settings.";
			}
			
			return $finalArr;
									
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage());
		}
	}

	public function makeReservationAPI($request)
	{
		try
		{
			$bookingService = new Application_Service_Reservation();
			$slotsArr = $bookingService->GetRestTimingsForPartnerRest($request);
			$finalArr = array();
			if($slotsArr){
				$temparr = array();
				foreach($slotsArr as $slot){
					if($request->time == $slot['time']){
						$temparr = $slot;
						break;
					}	
				}
				if($temparr){
					$bookingService = new Application_Service_Reservation();
					$result = $bookingService->BookingDetailsAPI($request,$temparr);
					$finalArr['status'] = 'Y';
					$finalArr['message'] = $result['bookingid'];
				}else{
					$finalArr['status'] = 'N';
					$finalArr['message'] = 'Invalid time';
				}
			}else{
				$request->setParams(array('restid'=>$request->restaurantid));
				$frezresult = $bookingService->getFreezeTypeByDate($request);
				if($frezresult && $frezresult['type'] == 'All'){
					$frzdescMap = $bookingService->getFreezeDesc($request);
					if($frzdescMap && $frzdescMap->rfdm_desc){
						$finalArr['status'] = 'N';
						$finalArr['message'] = $frzdescMap->rfdm_desc;
					}else{
						$serv = new Application_Service_Firm();
						$msg = $serv->getRestaurantTimeSearchMessage($request->restaurantid);
						if($msg->resbooking_search_msg){
							$finalArr['status'] = 'N';
							$finalArr['message'] = $msg->resbooking_search_msg;
						}else{
							$finalArr['status'] = 'N';
							$finalArr['message'] = "The time you are looking for is not available. Please select another time";
						}
					}
				}else{
					$serv = new Application_Service_Firm();
					$msg = $serv->getRestaurantTimeSearchMessage($request->restaurantid);
					if($msg->resbooking_search_msg){
						$finalArr['status'] = 'N';
						$finalArr['message'] = $msg->resbooking_search_msg;
					}else{
						$finalArr['status'] = 'N';
						$finalArr['message'] = "The time you are looking for is not available. Please select another time";
					}
				}
			}
			return $finalArr;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage());
		}
	}

	public function confirmReservationAPI($request)
	{
		try{
			
			$mapper = new Reservation_Model_ReservationDataMapper();
			$dinerDetails = new Reservation_Model_Reservation();
			$dinerDetails->setbokid($request->bookingid);
			$result = $mapper->getBookingDetails($dinerDetails);
			$resultArr = array();
			if($result){
				$resultArr['restaurantname'] = $result->getresrestaurant_name();
				$resultArr['restaurantaddress'] = $result->getresaddress();
				$resultArr['restaurantcity'] = $result->getResCity();
				$resultArr['zipcode'] = $result->getResZipcode();
				$resultArr['fname'] = $result->getbokfirst_name();
				$resultArr['lname'] = $result->getboklast_name();
				$resultArr['partysize'] = $result->getbokparty_size();
				$resultArr['date'] = $result->getbokbooking_date();
				$resultArr['time'] = $result->getbokbooking_timings();
				$resultArr['bookingid'] = $result->getbokid();
			}			
			return $resultArr;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function cancelReservationAPI($request)
	{
		try{
			$bookingService = new Application_Service_Reservation();
			$resultArr = $bookingService->CancelReservationAPI($request);
			$finalArr = array();
			if($resultArr['status']){
				$finalArr['status'] = 'Y';
				$finalArr['message'] = "Your reservation has been cancelled and an email message has been sent";
			}else{
				$finalArr['status'] = 'N';
				$finalArr['message'] = "Your reservation can't be cancelled";
			}
			return $finalArr;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getRestaurantInfoAPI($request)
	{
		try{
			$mapper = new FirmManagement_Model_FirmDataMapper();
			$finalArr = $mapper->getRestaurantDetailsbyrestIdAPI($request->restaurantid);
			return $finalArr;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getWaitListPartysizesAndWaitTimesAPI($request)
	{
		try{
			$quoteSettingsDataMapper = new Reservation_Model_RestaurantQuoteSettingsDataMapper();
			$result = $quoteSettingsDataMapper->GetQuoteTimings($request->restaurantid);
			$finalArr= array();
			$tempArr = array();
			if($result['status']){
				$finalArr['status'] = 'Y';
				foreach($result['settings'] as $setting){
					$tempArr[$setting->rwqs_startpax.'-'.$setting->rwqs_endpax] = $setting->timedesc;
				}
				$finalArr['settings'] = $tempArr;
			}else{
				$finalArr['status'] = 'Y';
				$tempArr['Allpartys'] = "30 Minutes";
				$finalArr['settings'] = $tempArr;
			}
			return $finalArr;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getWaitingTimeForPartysizeAPI($request)
	{
		try{
			$restaurantid = $request->restaurantid;
			$pax = $request->pax;
			$quoteSettingsDataMapper = new Reservation_Model_RestaurantQuoteSettingsDataMapper();
			$result = $quoteSettingsDataMapper->CheckQuoteTimeSettingsAPI($restaurantid,$pax);
			$finalArr= array();
			if($result['status']){
				$finalArr['status'] = 'Y';
				$finalArr['waitingtime'] = $result['waiting_time'].' Minutes';
			}else{
				$finalArr['status'] = 'N';
				$finalArr['message'] = 'Please choose another party size';
			}
			return $finalArr;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function makeWaitListReservationAPI($request)
	{
		try{
			$result = '';
			$restaurantid = $request->restaurantid;
			$pax = $request->pax;
			$fname = $request->fname;
			$lname = $request->lname;
			
			$quoteSettingsDataMapper = new Reservation_Model_RestaurantQuoteSettingsDataMapper();
			$waitTime = $quoteSettingsDataMapper->CheckQuoteTimeSettingsAPI($restaurantid,$pax);
			if($waitTime['status']){
				$waitingquoteMapper = new Application_Model_WaitingQuoteTimeDataMapper();
				//$quotecode = explode(' ',$waitTime['waiting_time']);
				$quoteStatus 	  = $waitingquoteMapper->GetQuoteTimeByCode(array($waitTime['waiting_time']));
				$quoteObj 	  = $quoteStatus[$waitTime['waiting_time']];
				
				$bookTypeMapper = new Application_Model_ReservationTypeDataMapper();
				$bookType = $bookTypeMapper->GetBookingTypeByCode('NOR');
	
				$statusCode = array();
				$statusCode[] = 'WAL';
				$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
				$bookStatus 	  = $bookStatusMapper->GetBookingStatusByCode($statusCode);
				$bookStatusObj 	  = $bookStatus['WAL'];
				
				$resModeMapper = new Application_Model_ReservationModeDataMapper();
				$rescode = 'INAT';
				$resModeStatus 	  = $resModeMapper->GetReservationModeByCode(array($rescode));
				$resModeObj 	  = $resModeStatus[$rescode];
	
				$mapper = new Reservation_Model_ReservationDataMapper();
				$dinerDetails = new Reservation_Model_Reservation();
	
				$dinerDetails->setbokfk_restaurant($restaurantid);
					
				$dinerDetails->setbokparty_size($pax);
				$dinerDetails->setbokbooking_status_id($bookStatusObj->getId());
				$dinerDetails->setbokbooking_status_code($bookStatusObj->getCode());
				$dinerDetails->setbokbooking_status($bookStatusObj->getId());
				$dinerDetails->setbokfirst_name($fname);
				$dinerDetails->setboklast_name($lname);
				if($request->phone){
					$dinerDetails->setbokphone($request->phone);
					$dinerDetails->setNotificationType('sms');
				}
				$dinerDetails->setbokemail('');
				$dinerDetails->setQuotedTime($quoteObj->getId());
				
				$resServ = new Application_Service_Firm();
				$timeZone = $resServ->GetRestaurantTimeZone($restaurantid);
				date_default_timezone_set($timeZone);
	
				$dinerDetails->setbokbooking_made_on(date('Y-m-d H:i:s'));
				$dinerDetails->setBookingMadeTime(date("H:i",time()));
				$dinerDetails->setbokbooking_date(date('Y-m-d'));
				$dinerDetails->setbokbooking_timings(date('g:i A'));
	
				$bookPhrase = uniqid ();
				$dinerDetails->setbokbookingphrase($bookPhrase);
				$dinerDetails->setbokbooking_type_id($bookType->getId());
				$dinerDetails->setbokreservation_mode_id($resModeObj->getId());
				
				$result = $mapper->saveMakeReservationDetails($dinerDetails,'waiting');
	
				$dinerDetails->setbokid($result);
				$mailmapper = new Application_Service_Communication();
				$restService = new Application_Service_Firm();
				$restResult = $restService->GetRestaurantDetailsById($restaurantid);
				if($request->phone != ''){
					$name = $fname.' '.$lname;
					$custMsg = '';
					$custMsg = 'Hi '.$name.', we have put your reservation in waiting, please wait for '.$quoteObj->getDescription().'. '.$restResult->resrestaurant_name;
					$smsObj = new Communication_Model_Sms();
					$smsObj->setMsgCode('WaitingReserv');
					$data = array(
									'to'			=>	trim($request->phone),
									'RestName' 		=> $restResult->resrestaurant_name,
									'UserName'		=> $name,
									'Quote'			=> $quoteObj->getDescription(),
									'BookId'		=> $result
					);
					$smsObj->setData($data);
					$mailStatus = $mailmapper->SendSms($smsObj);
					if($result)
					{
						$formData['restaurantid'] = $restaurantid;
						$formData['waitfirstName'] = $fname;
						$formData['waitlastName'] = $lname;
						$formData['waitnumber'] = $request->phone;
						$restservice = new Application_Service_Firm();
						$restservice->AddWaitingCustomerContact($formData);
					}
				}	
			}
			$resultarray = array();				
			if($result){
				$resultarray['status'] = 'Y';
				$resultarray['bookingid'] = $result;
			}else{
				$resultarray['status'] = 'N';
			}	
			return $resultarray;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function cancelWaitListReservationAPI($request)
	{
		try{
			$bookingService = new Application_Service_Reservation();
			$resultArr = $bookingService->CancelWaitListReservationAPI($request);
			$finalArr = array();
			if($resultArr['status']){
				$finalArr['status'] = 'Y';
				$finalArr['message'] = "Your reservation has been cancelled";
			}else{
				$finalArr['status'] = 'N';
				$finalArr['message'] = "Your reservation can't be cancelled";
			}
			return $finalArr;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getReservationInfoAPI($request)
	{
		try{
			$bookingService = new Application_Service_Reservation();
			$slotsArr = $bookingService->GetRestReservations('',$request);
			if($slotsArr['restForm']){
				$finalArr['status'] = 'Y';
				$finalArr['count'] = count($slotsArr['restForm']);
				$finalArr['details'] = $slotsArr['restForm'];
			}else{
				$finalArr['status'] = 'N';
				$finalArr['message'] = 'There are no reservations for the selected date';
			}
			return $finalArr;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function updatereservationdetailsAPI($request)
	{
		try{
			
			$bookingService = new Application_Service_Reservation();
			$slotsArr = $bookingService->getRestaurantTimings($request);
			$finalArr = array();
			if($slotsArr){
				$temparr = array();
				foreach($slotsArr as $slot){
					if($request->time == $slot['time']){
						$temparr = $slot;
						break;
					}	
				}
				if($temparr){
					$bookingService = new Application_Service_Reservation();
					
					$result = $bookingService->UpdateReservationDetailsAPI($request,$temparr);
					if($result != false){
						$finalArr['status'] = 'Y';
						$finalArr['message'] = $result['bookingid'];
					}else{
						$finalArr['status'] = 'N';
					}					
				}else{
					$finalArr['status'] = 'N';
					$finalArr['message'] = 'Invalid time';
				}
			}else{
				$frezresult = $bookingService->getFreezeTypeByDate($request);
				if($frezresult && $frezresult['type'] == 'All'){
					$frzdescMap = $bookingService->getFreezeDesc($request);
					if($frzdescMap && $frzdescMap->rfdm_desc){
						$finalArr['status'] = 'N';
						$finalArr['message'] = $frzdescMap->rfdm_desc;
					}else{
						$serv = new Application_Service_Firm();
						$msg = $serv->getRestaurantTimeSearchMessage($request->restaurantid);
						if($msg->resbooking_search_msg){
							$finalArr['status'] = 'N';
							$finalArr['message'] = $msg->resbooking_search_msg;
						}else{
							$finalArr['status'] = 'N';
							$finalArr['message'] = "The time you are looking for is not available. Please select another time";
						}
					}
				}else{
					$serv = new Application_Service_Firm();
					$msg = $serv->getRestaurantTimeSearchMessage($request->restaurantid);
					if($msg->resbooking_search_msg){
						$finalArr['status'] = 'N';
						$finalArr['message'] = $msg->resbooking_search_msg;
					}else{
						$finalArr['status'] = 'N';
						$finalArr['message'] = "The time you are looking for is not available. Please select another time";
					}
				}
			}
			return $finalArr;
		
		}
		catch (Exception $ex){		
	
			throw new Exception($ex->getMessage()) ;
		}
	}
}