<?php
class Application_Service_Renumeration
{
	public function GetRenumerationPlans($request)
	{
		try
		{
			$restaurantid = $request->restaurantid;
			$RenumerationPlans = new ManageRenumeration_Model_RenumerationPlans();
			$RenumerationPlans->setspplan_status(TRUE);
			if($request->planid)
			{
				$RenumerationPlans->setspid($request->planid);	
			}
			
			/* Get Country by Restaurant Id */
			$restcountry = $this->GetRestaurantCountry($restaurantid);
			$RenumerationPlansMapper = new ManageRenumeration_Model_RenumerationPlansMapper();
			$result = array();
			$RenumerationPlans->setsp_country_code('USA');
			
			$membershipPlans = $RenumerationPlansMapper->RetrieveSubscriptionPlans($RenumerationPlans);
			$result['Membership'] = $membershipPlans;
			$result['CurrencyCode'] = 'USA';
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetCurrencyList()
	{
		try
		{
			$currDataMapper = new Application_Model_CurrencyDataMapper();			
			$currencyList = $currDataMapper->fetchAll(); 			
			return $currencyList;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function AddmemberShip($request)
	{
		try
		{
			$MembershipPlanMap = new ManageRenumeration_Model_RenumerationPlanMap();
			$MembershipPlanMap->setrmpmpayment_plan_id($request->planid);
			$MembershipPlanMap->setrmpmrestaurant_id($request->restaurantid);
			$MembershipPlanMap->setrmpmstatus(1);
			$activationDate = date('Y-m-d');
			$activationTime = date('h:i:s');
			$MembershipPlanMap->setrmpmplan_activation_date($activationDate);
			$MembershipPlanMap->setrmpmplan_activation_time($activationTime);
			$MembershipPlanMap->setrmpm_currency($request->currency);
			
			$MembershipPlanMapper = new ManageRenumeration_Model_RenumerationPlanMapMapper();
			
			/* Check Plan exists */
			$planResult = $MembershipPlanMapper->CheckMembership($MembershipPlanMap);
			if($planResult["status"] == "Y"){
				$MembershipPlanMap->setrmpmid($planResult["rmpmid"]);
			}
			
			$result = $MembershipPlanMapper->AddMembeshipPlan($MembershipPlanMap);
			
			if($result)
			{
			 	return true;
			}else{
				return false;
			}
			
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function CheckPlanExists($request)
	{
		try
		{
			$MembershipPlanMap = new ManageRenumeration_Model_RenumerationPlanMap();
			$MembershipPlanMap->setrmpmrestaurant_id($request->restaurantid);
			$MembershipPlanMapper = new ManageRenumeration_Model_RenumerationPlanMapMapper();
			$result = $MembershipPlanMapper->CheckMembership($MembershipPlanMap);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetPaymentTermsDetails($request,$data)
	{
		try
		{
			/* Get Membership plans */
			$memshipplan = $this->GetSubscriptionPlanById($request);

			$result = array();
			
			foreach($memshipplan as $memship)
			{
				$result['PlanId']    		= $memship['spid'];
				$result['PlanTitle'] 		= $memship['spplan_title'];
				$result['PlanDesc']  		= $memship['spplan_description'];
				$amount = str_replace('$','',$memship['spamount']);
				$amount = str_replace(',','',$amount);
				$result['PlanAmount']    	= str_replace('$','',$memship['spamount']);
				$result['PayAmount']		= $amount; 
				$result['PlanDuration']     = $memship['spplan_duration'];
				$result['sp_2coid']  		= $memship['sp_2coid'];
				$result['sp_product_id']    = $memship['sp_product_id'];	
			}
				$result['restaurantid']     = $request->restaurantid;
				$result['Currency']         = $request->currency;
				$result['User_Id']          = $data['User_Id'];
				$result['Firstname']        = $data['Firstname'];
				$result['LastName']         = $data['LastName'];
				$result['Recurrence']		= $memship['spplan_duration'].' Month';
				
				/*switch($result['PlanId'])
				{
					case '1' : 	$result['Recurrence'] = "1 Month"; break;				
					case '2' : 	$result['Recurrence'] = "3 Month"; break;
					case '3' : 	$result['Recurrence'] = "6 Month"; break;
					case '4' : 	$result['Recurrence'] = "1 Year"; break;
					case '5' : 	$result['Recurrence'] = "1 Month"; break;				
					case '6' : 	$result['Recurrence'] = "3 Month"; break;
					case '7' : 	$result['Recurrence'] = "6 Month"; break;
					case '8' : 	$result['Recurrence'] = "1 Year"; break;
				};*/
				
				/* Get Address */
				
				$restaurantid = $request->restaurantid;
				$resByIdObj = new FirmManagement_Model_FirmById();
				$resByIdObj->setRestaurantId($restaurantid);
				$mapper = new FirmManagement_Model_FirmDataMapper();
				$restResult = $mapper->getRestaurantById($resByIdObj);
				$result['Country'] = $restResult->getRestStateDesc();
				$result['State']   = $restResult->getRestRegionDesc();
				$result['City']    = $restResult->getRestCityDesc();
				$result['Address'] = $restResult->getRestaddress();
				$result['Email']   = $restResult->getRestemail();
				$result['Phone']   = $restResult->getRestphone();
				$result['Zip']     = $restResult->getRestzipcode();
				return $result;			
				
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
    
    public function GetPartnerPaymentTermsDetails($request,$data)
	{
		try
		{
			/* Get Membership plans */
			$memshipplan = $this->partnerPlanGeneration($request,$data);

			$result = array();
			$result = $memshipplan[0];
			
				$result['companyid']     = $data['companyid'];
				$result['Currency']         = 'INR';
				$result['User_Id']          = $data['User_Id'];
				$result['Firstname']        = $data['Firstname'];
				$result['LastName']         = $data['LastName'];
				
				
				
				
				/* Get Address */
				
				$mapper = new Administrator_Model_CompanyDataMapper();
				$restResult = $mapper->getCompanyDetailsById($data['companyid']);
				$result['Address'] = $restResult['com_address'];
				$result['Email']   = $restResult['com_email'];
				$result['Phone']   = $restResult['com_phone'];
				return $result;			
				
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function HandleAuthorizeNextPassback($data){
		try{
			$TwoCheckoutSubscription = new ManageRenumeration_Model_TwoCheckoutSubscription();
			$TwoCheckoutSubscription->settcos_order_id($data['x_trans_id']);
			$credit_card_processed = 'N';
			if($data['x_response_code'] == 1){
				// TRANSACTION SUCCESSFULL
				$credit_card_processed = 'Y';
			}
			else{
				// TRANSACTION FAILED
				$credit_card_processed = 'N';
			}
			$TwoCheckoutSubscription->settcos_credit_card_processed($credit_card_processed);
			$TwoCheckoutSubscription->settcos_status(TRUE);
			$TwoCheckoutSubscription->settcos_created_date(date('Y-m-d'));
			$planId = 1;
			if($data['x_amount'] > 129){
				$planId = 2;
			}
			$TwoCheckoutSubscription->settcos_created_by($data['x_cust_id']);
			$restId = str_replace('DD-CUSTOMER-', '', $data['x_cust_id']);
			$TwoCheckoutSubscription->settcos_fk_restaurant($restId);
		    $TwoCheckoutSubscription->setplan_id($planId);
			$TwoCheckoutSubscription->settcos_twocheck_status($data['x_MD5_Hash']);
			$TwoCheckoutSubscriptionMapper = new ManageRenumeration_Model_TwoCheckoutSubscriptionMapper();
		    	$status = $TwoCheckoutSubscriptionMapper->SaveTwoCheckSubscriptionDetails($TwoCheckoutSubscription);
		    	// SAVE PAYMENT HISTORY
		    $TwoCheckoutNotification = new ManageRenumeration_Model_TwoCheckoutNotification();
			$TwoCheckoutNotification->settcph_message_id($request->message_id);
			$TwoCheckoutNotification->settcph_message_type("");
			$TwoCheckoutNotification->settcph_message_description($data['x_response_reason_text']);
			$TwoCheckoutNotification->settcph_timestamp(date('Y-m-d'));
			$TwoCheckoutNotification->settcph_sale_id($data['x_trans_id']);
			$TwoCheckoutNotification->settcph_vendor_id("AUTHORIZE.NET");
			$TwoCheckoutNotification->settcph_sale_date_placed(date('Y-m-d'));
			$TwoCheckoutNotification->settcph_invoice_id($data['x_trans_id']);
			$TwoCheckoutNotification->settcph_recurring(false);
			$TwoCheckoutNotification->settcph_payment_type($data['x_method']);
			$TwoCheckoutNotification->settcph_invoice_status($data['x_response_code']);
			$TwoCheckoutNotification->settcph_invoice_list_amount($data['x_amount']);
			$TwoCheckoutNotification->settcph_invoice_usd_amount(0);
			$TwoCheckoutNotification->settcph_invoice_cust_amount($data['x_amount']);
			$TwoCheckoutNotification->settcph_vendor_order_id($data['x_MD5_Hash']);
			$TwoCheckoutNotificationMapper = new ManageRenumeration_Model_TwoCheckoutNotificationMapper();
			$result = $TwoCheckoutNotificationMapper->SaveTwoCheckNotification($TwoCheckoutNotification);
		    	return  $status;
		}
		catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}

	}

	public function Handle2CheckPassback($request)
	{
		try
		{
			$hashSecretWord = 'MWNlODhkNGUtNzgwNC00YmQ4LWI5M2EtMzIzMTQ1NTUzZjA0'; 			
		    $hashSid = 102611374; 		  	    
		    $hashOrder = $request->order_number; 		    
		    $credit_card_processed = $request->credit_card_processed;		    
		    $restd_id = $request->restaurantid; 
		    $plan_id = $request->planid;		    
			$total = $request->total;			
		    $StringToHash = strtoupper(md5($hashSecretWord . $hashSid . $hashOrder . $total));
		// $StringToHash = strtoupper(md5($hashSecretWord . $hashSid . 1 . $total));
				Uss_Logger_FileLogger::info($StringToHash.'-- '.$_REQUEST['key']);
		    if ($StringToHash != $_REQUEST['key']) {
				Uss_Logger_FileLogger::info("key failure");
		    	$result['status'] = 'N';
		    } else {
		    			    	
		    	/* Save Subscription Details and Update Payment Status */
		    	$TwoCheckoutSubscription = new ManageRenumeration_Model_TwoCheckoutSubscription();
		    	$TwoCheckoutSubscription->settcos_order_id($hashOrder);
		    	$TwoCheckoutSubscription->settcos_fk_restaurant($restd_id);
		    	$TwoCheckoutSubscription->setplan_id($plan_id);
		    	$TwoCheckoutSubscription->settcos_credit_card_processed($credit_card_processed);
		    	$TwoCheckoutSubscription->settcos_status(TRUE);
		    	$TwoCheckoutSubscription->settcos_created_date(date('Y-m-d'));
		    	Uss_Logger_FileLogger::info($hashOrder.','.$credit_card_processed);
		    	$TwoCheckoutSubscriptionMapper = new ManageRenumeration_Model_TwoCheckoutSubscriptionMapper();
		    	$status = $TwoCheckoutSubscriptionMapper->SaveTwoCheckSubscriptionDetails($TwoCheckoutSubscription);
		    	
		    	$result['status'] = 'Y';
		    	
		    }
		    $result['restaurantid'] = $restd_id;
		    $result['planid'] = $plan_id;
		    $result['credit_card_processed'] = $credit_card_processed;
		    $result['total'] = $total;
		    $result['order_id'] = $hashOrder;
		    
		    /* Get Status */
		    $result['url_to_send_status'] = $this->GetFloorPlanAndScheduleStatus($restd_id);
		    
		    return $result;
			
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
        public function PartnerHandle2CheckPassback($request)
	{
		try
		{
			$hashSecretWord = 'MWNlODhkNGUtNzgwNC00YmQ4LWI5M2EtMzIzMTQ1NTUzZjA0'; 			
		    $hashSid = 102611374; 		  	    
		    $hashOrder = $request->order_number; 		    
		    $credit_card_processed = $request->credit_card_processed;		    
		    $restd_id = $request->companyid; 
		    $plan_id = $request->planid;		    
			$total = $request->total;			
		    $StringToHash = strtoupper(md5($hashSecretWord . $hashSid . $hashOrder . $total));
//            echo $StringToHash.'  '.$_REQUEST['key'];die();
		    if ($StringToHash != $_REQUEST['key']) {
		    	$result['status'] = 'N';
		    } else {
		    			    	
                $twoCheckHelper = new Uss_Helper_TwoCheckOutHelper();
                
                $result = $twoCheckHelper->DetailSale(array('sale_id'=>$hashOrder,'invoice_id'=>$request->invoice_id));
                $decodeResult = json_decode($result);
                
		    	/* Save Subscription Details and Update Payment Status */
		    	$TwoCheckoutSubscription = new ManageRenumeration_Model_CompanyTwoCheckoutSubscription();
		    	$TwoCheckoutSubscription->settcoms_order_id($hashOrder);
		    	$TwoCheckoutSubscription->settcoms_fk_company($restd_id);
		    	$TwoCheckoutSubscription->settcoms_credit_card_processed($credit_card_processed);
		    	$TwoCheckoutSubscription->settcoms_status(TRUE);
		    	$TwoCheckoutSubscription->settcoms_created_date(date('Y-m-d'));
                $TwoCheckoutSubscription->settcoms_twocheck_status($invoiceDet[0]->status);
		    	
		    	$TwoCheckoutSubscriptionMapper = new ManageRenumeration_Model_CompanyTwoCheckoutSubscriptionMapper();
		    	$status = $TwoCheckoutSubscriptionMapper->SaveTwoCheckSubscriptionDetails($TwoCheckoutSubscription);
                
                if($decodeResult->response_code == 'OK'){
                    $saleDet = $decodeResult->sale;
                    $invoiceDet = $decodeResult->sale->invoices;
                    $TwoCheckoutNotification = new ManageRenumeration_Model_CompanyTwoCheckoutNotification();
                    $TwoCheckoutNotification->settcomph_message_id($plan_id);
    //                $TwoCheckoutNotification->settcomph_message_type($request->message_type);
    //                $TwoCheckoutNotification->settcomph_message_description($request->message_description);
                    $TwoCheckoutNotification->settcomph_timestamp($invoiceDet[0]->timestamp);
                    $TwoCheckoutNotification->settcomph_sale_id($saleDet->sale_id);
                    $TwoCheckoutNotification->settcomph_vendor_id($invoiceDet[0]->vendor_id);
                    $TwoCheckoutNotification->settcomph_sale_date_placed($invoiceDet[0]->date_placed);
                    $TwoCheckoutNotification->settcomph_invoice_id($saleDet->invoice_id);
                    $TwoCheckoutNotification->settcomph_recurring($invoiceDet[0]->recurring);
                    $TwoCheckoutNotification->settcomph_payment_type($saleDet->customer->pay_method->method);
                    $TwoCheckoutNotification->settcomph_invoice_status($invoiceDet[0]->status);
                    $TwoCheckoutNotification->settcomph_invoice_list_amount($invoiceDet[0]->vendor_total);
                    $TwoCheckoutNotification->settcomph_invoice_usd_amount($invoiceDet[0]->usd_total);
                    $TwoCheckoutNotification->settcomph_invoice_cust_amount($invoiceDet[0]->lineitems[0]->billing->customer_amount);
    //                $TwoCheckoutNotification->settcomph_vendor_order_id($decodeResult->vendor_order_id);
                    $TwoCheckoutNotificationMapper = new ManageRenumeration_Model_CompanyTwoCheckoutNotificationMapper();
                    $result = $TwoCheckoutNotificationMapper->SaveTwoCheckNotification($TwoCheckoutNotification);  
                    
                    $subscrRenewal = new ManageRenumeration_Model_CompanySubscriptionRenewal();
                    $subscrRenewal->setcsrid($plan_id);
                    $subscrRenewal->setcsrstatus(30);
                    $subscrRenewalMapper = new ManageRenumeration_Model_CompanySubscriptionRenewalMapper();
                    $subscrRenewalMapper->updateSubscriptionStatus($subscrRenewal);
                    $subRenResult = $subscrRenewalMapper->getSubscriptionRenewalById($subscrRenewal);
                    $subscrPaid = new ManageRenumeration_Model_CompanySubscriptionPaid();
                    $subscrPaid->setcsubpcompany_id($subRenResult->csrcompany_id)
                                ->setcsubptransaction_id($subRenResult->csrrestaurant_count)
                                ->setcsubpamount($subRenResult->csramount)
                                ->setcsubpamount_per_restaurant($subRenResult->csramount_per_restaurant)
                                ->setcsubpbilled_restaurants($subRenResult->csrrestaurant_count)
                                ->setcsubpbilling_date($subRenResult->csrbilling_date)
                                ->setcsubpbilling_fromdate($subRenResult->csrbilling_fromdate)
                                ->setcsubpbilling_todate($subRenResult->csrbilling_todate)
                                ->setcsubp_status($subRenResult->csrstatus);
    //                $subscrPaidMapper = new ManageRenumeration_Model_CompanySubscriptionPaidMapper();
    //                $subscrPaidResult = $subscrPaidMapper->saveSubscrPaid($subscrPaid);
                }      
		    	$result['status'] = 'Y';
		    }
		    $result['companyid'] = $restd_id;
		    $result['planid'] = $plan_id;
		    $result['credit_card_processed'] = $credit_card_processed;
		    $result['total'] = $total;
		    $result['order_id'] = $hashOrder;
		    
		    /* Get Status */
		    $result['url_to_send_status'] = 'Dashboard';
		    
		    return $result;
			
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
        
	public function GetRestaurantCountry($restid)
	{
		try
		{
			$restDataMapper = new FirmManagement_Model_FirmDataMapper();
			$result = $restDataMapper->retrieveRestCountry($restid);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function GetSubscriptionPlanById($request)
	{
		try
		{
			$SubscriptionPlans = new ManageRenumeration_Model_RenumerationPlans();
			$SubscriptionPlans->setspid($request->planid);	
			$SubscriptionPlansMapper = new ManageRenumeration_Model_RenumerationPlansMapper();
			$membershipPlans = $SubscriptionPlansMapper->RetrieveSubscriptionPlansById($SubscriptionPlans);
			return $membershipPlans;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function ManagePayments($request)
	{
		try
		{
			
			$restaurantid = $request->restaurantid;
			/* Check Subscription Exist */
			$TwoCheckoutSubscription = new ManageRenumeration_Model_TwoCheckoutSubscription(); 
			$TwoCheckoutSubscription->settcos_fk_restaurant($restaurantid);
			$TwoCheckoutSubscription->settcos_status(TRUE);
			$TwoCheckoutSubscriptionMapper = new ManageRenumeration_Model_TwoCheckoutSubscriptionMapper();
			$subscription = $TwoCheckoutSubscriptionMapper->RetrieveSubscriptionDetails($TwoCheckoutSubscription);
			
			$result = array();
			
			if($subscription)
			{
				$result['Status'] = 'Y';
				$result['Order_Id'] = $subscription['order_id'];
				
			}else{
				$result['Status'] = 'N';
			}
			
			$planResult = $this->CheckPlanExists($request);
			
			if($planResult['status'] == 'Y'){
				$result['Plan'] = 'Y';
				$planid = $planResult['rmpmpayment_plan_id'];
				/* Get Plan Details */
				
				$SubscriptionPlans = new ManageRenumeration_Model_RenumerationPlans();
				$SubscriptionPlans->setspid($planid);	
				$SubscriptionPlansMapper = new ManageRenumeration_Model_RenumerationPlansMapper();
				$membershipPlans = $SubscriptionPlansMapper->RetrieveSubscriptionPlansById($SubscriptionPlans);
				
				foreach($membershipPlans as $plan){
					
					$result['PlanId']	     = $plan['spid'];
					$result['Plan_Title']    = $plan['spplan_title'];
					$result['Plan_Desc']     = $plan['spplan_description'];
					$result['Plan_Amount']   = $plan['spamount'];
					$result['Plan_Duration'] = $plan['spplan_duration'];								 				
				}
				
			}else if ($planResult['status'] == 'N'){
				$result['Plan'] = 'N';
			}
			
			return $result;
			
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage());
		}
	}
    
    public function ManagePartnersPayments($request)
	{
		try
		{
			
			$restaurantid = $request->companyid;
			/* Check Subscription Exist */
			$TwoCheckoutSubscription = new ManageRenumeration_Model_CompanyTwoCheckoutSubscription(); 
			$TwoCheckoutSubscription->settcoms_fk_company($restaurantid);
			$TwoCheckoutSubscription->settcoms_status(TRUE);
			$TwoCheckoutSubscriptionMapper = new ManageRenumeration_Model_CompanyTwoCheckoutSubscriptionMapper();
			$subscription = $TwoCheckoutSubscriptionMapper->RetrieveSubscriptionDetails($TwoCheckoutSubscription);
			
			$result = array();
			
			if($subscription)
			{
				$result['Status'] = 'Y';
				$result['Order_Id'] = $subscription['order_id'];
				
			}else{
				$result['Status'] = 'N';
			}
			
//			$planResult = $this->CheckPlanExists($request);
			
//			if($planResult['status'] == 'Y'){
//				$result['Plan'] = 'Y';
//				$planid = $planResult['rmpmpayment_plan_id'];
				/* Get Plan Details */
				
				$SubscriptionPlans = new ManageRenumeration_Model_CompanySubscriptionRenewal();
				$SubscriptionPlans->setcsrid($planid);	
				$SubscriptionPlansMapper = new ManageRenumeration_Model_RenumerationPlansMapper();
				$membershipPlans = $SubscriptionPlansMapper->RetrieveSubscriptionPlansById($SubscriptionPlans);
				
				foreach($membershipPlans as $plan){
					
					$result['PlanId']	     = $plan['spid'];
					$result['Plan_Title']    = $plan['spplan_title'];
					$result['Plan_Desc']     = $plan['spplan_description'];
					$result['Plan_Amount']   = $plan['spamount'];
					$result['Plan_Duration'] = $plan['spplan_duration'];								 				
				}
				
//			}else if ($planResult['status'] == 'N'){
//				$result['Plan'] = 'N';
//			}
			
			return $result;
			
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage());
		}
	}

	public function GetRenumerationDetailsByRestaurantId($request)
	{
		try
		{
			$restid = $request->restaurantid;
			$CheckoutSubscriptionMapper = new ManageRenumeration_Model_TwoCheckoutSubscriptionMapper();
			$result = $CheckoutSubscriptionMapper->RetrieveRenumerationDetailsByRestId($restid);			
			return $result;
			
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage());
		}
	}

	public function StopLineItemReccuring($request)
	{
		try
		{
			$order_id = $request->sale_id;
			$twoCheckHelper = new Uss_Helper_TwoCheckOutHelper();
			$result = $twoCheckHelper->StopLineItemReccuring($order_id);
			$decodeResult = json_decode($result);
			
			if($decodeResult && $decodeResult->response_code == 'OK')
			{
				/* Save Subscription Details and Update Payment Status */
		    	$TwoCheckoutSubscription = new ManageRenumeration_Model_TwoCheckoutSubscription();
		    	$TwoCheckoutSubscription->settcos_order_id($order_id);		    	
		    	$TwoCheckoutSubscription->settcos_status(0);
		    	$TwoCheckoutSubscription->settcos_twocheck_status('Reccuring Stop');
		    	$TwoCheckoutSubscription->settcos_updated_date(date('Y-m-d'));
		    	
		    	$TwoCheckoutSubscriptionMapper = new ManageRenumeration_Model_TwoCheckoutSubscriptionMapper();
		    	$status = $TwoCheckoutSubscriptionMapper->UpdateTwoCheckSubscriptionStatus($TwoCheckoutSubscription);
		    	
		    	if($status)
		    	{
		    		return 't';
		    	}else{
		    		return 'f';
		    	}
			}
			
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage());
		}
	}
	
	public function SaveTwoCheckNotifications($request)
	{
		try
		{
			$TwoCheckoutNotification = new ManageRenumeration_Model_TwoCheckoutNotification();
			$TwoCheckoutNotification->settcph_message_id($request->message_id);
			$TwoCheckoutNotification->settcph_message_type($request->message_type);
			$TwoCheckoutNotification->settcph_message_description($request->message_description);
			$TwoCheckoutNotification->settcph_timestamp($request->timestamp);
			$TwoCheckoutNotification->settcph_sale_id($request->sale_id);
			$TwoCheckoutNotification->settcph_vendor_id($request->vendor_id);
			$TwoCheckoutNotification->settcph_sale_date_placed($request->sale_date_placed);
			$TwoCheckoutNotification->settcph_invoice_id($request->invoice_id);
			$TwoCheckoutNotification->settcph_recurring($request->recurring);
			$TwoCheckoutNotification->settcph_payment_type($request->payment_type);
			$TwoCheckoutNotification->settcph_invoice_status($request->invoice_status);
			$TwoCheckoutNotification->settcph_invoice_list_amount($request->invoice_list_amount);
			$TwoCheckoutNotification->settcph_invoice_usd_amount($request->invoice_usd_amount);
			$TwoCheckoutNotification->settcph_invoice_cust_amount($request->invoice_cust_amount);
			$TwoCheckoutNotification->settcph_vendor_order_id($request->vendor_order_id);
			$TwoCheckoutNotificationMapper = new ManageRenumeration_Model_TwoCheckoutNotificationMapper();
			$result = $TwoCheckoutNotificationMapper->SaveTwoCheckNotification($TwoCheckoutNotification);
			return $result;
			
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage());
		}
	}

	public function GetTwoCheckNotificationByOrderId($request)
	{
		try
		{
			$order_id = $request->sale_id;
			$TwoCheckoutSubscription = new ManageRenumeration_Model_TwoCheckoutSubscription();
			$TwoCheckoutSubscription->settcos_order_id($order_id);
			$TwoCheckoutNotificationMapper = new ManageRenumeration_Model_TwoCheckoutNotificationMapper();
			$result = $TwoCheckoutNotificationMapper->RetrieveTwoCheckNotificationByOrderId($TwoCheckoutSubscription);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage());
		}
	}
	
	public function GetTwoCheckNotificationByRestId($request)
	{
		try
		{
			$restid = $request->restaurantid;			
			$TwoCheckoutSubscription = new ManageRenumeration_Model_TwoCheckoutSubscription();
			$TwoCheckoutSubscription->settcos_fk_restaurant($restid);
			$TwoCheckoutNotificationMapper = new ManageRenumeration_Model_TwoCheckoutNotificationMapper();
			$result = $TwoCheckoutNotificationMapper->RetrieveTwoCheckNotificationByRestId($TwoCheckoutSubscription);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage());
		}
	}
    
    public function GetCompanyTwoCheckNotificationByComId($request,$userdata)
	{
		try
		{
            $TwoCheckoutSubscription = new ManageRenumeration_Model_CompanyTwoCheckoutSubscription();
            $TwoCheckoutNotificationMapper = new ManageRenumeration_Model_CompanyTwoCheckoutNotificationMapper();
            if(isset($request->companyid)){
                $TwoCheckoutSubscription->settcoms_fk_company($request->companyid);
                $result = $TwoCheckoutNotificationMapper->RetrieveTwoCheckNotificationByComId($TwoCheckoutSubscription);
            }else if($userdata['Usertype'] == 'ADU'){
               $TwoCheckoutSubscription->settcoms_fk_company($userdata['companyid']);
               $result = $TwoCheckoutNotificationMapper->RetrieveTwoCheckNotificationByComId($TwoCheckoutSubscription);
            }else{
                $result = $TwoCheckoutNotificationMapper->RetrieveTwoCheckNotificationByAdmin($TwoCheckoutSubscription);
            }		
			
			
            
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage());
		}
	}

	public function GetFloorPlanAndScheduleStatus($restid)
	{
		try
		{
			$FirmDataMapper = new FirmManagement_Model_FirmDataMapper();
			$result = $FirmDataMapper->RetrieveFloorPlandAndScheduleStatus($restid);
			$status = "";
			if($result)
			{
				if($result->resfloorplanstatus == 't' && $result->resschestatus == 't')
				{
					$status = "Dashboard";
				}else if($result->resfloorplanstatus != "t"){
					$status = "FloorPlan";
				}else if($result->resschestatus != 't'){
					$status = "Schedule";
				}
			}
			
			return $status;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage());
		}
	}
        
    public function partnerPlanGeneration($request,$userData)
    {
        try{
            $firmService = new Application_Service_Administrator();
            $result = $firmService->getPartnerRestaurants($request,$userData);
            return $result;
        } catch (Exception $ex) {
            Uss_Logger_FileLogger::info($ex->getMessage());
            throw new Exception($ex->getMessage());
        }
    }
    
    public function monthlyPartnerPlanGeneration($request,$userData)
    {
        try{
            $firmService = new Application_Service_Administrator();
            $result = $firmService->getMonthlyPartnerRestaurants($request,$userData);
            return $result;
        } catch (Exception $ex) {
            Uss_Logger_FileLogger::info($ex->getMessage());
            throw new Exception($ex->getMessage());
        }
    }
    
    public function GenerateCompanuInvoicePdf($billData, $companyDet)
    {
        try{
            $path = 'companypdf/'.$billData['csrcompany_id'];
			
			if(!file_exists($path)){
				mkdir($path,0777);
			}
			$invoiceDirPath = $path.'/invoice';
			if(!file_exists($invoiceDirPath)){
				mkdir($invoiceDirPath,0777);
			}
			
			$invoiceFilePath = $invoiceDirPath.'/'.$billData['csrid'].'.pdf';
            if(!file_exists($invoiceFilePath)){
                $pdf = new My_Pdf_Document($invoiceFilePath, '.');
				$page = $pdf->createPage();
	
				$font = Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_HELVETICA);
				
				$page->setFont($font, 8);
				$page->setLineColor(new Zend_Pdf_Color_Rgb(0,100,0));
				$page->drawLine(-10, 15, ($page->getWidth()-0), 15);
				$imageurl = "../public/images/logo.png";
				
				$image = Zend_Pdf_Image::imageWithPath($imageurl);
				
				// write image to page
				$page->drawImage($image,-10,-30,120, 40);
                $invoiceCreationDate = date('d M y',strtotime($billData['csrbilling_date']));
				$page->drawText('INVOICE', 500, 0);
				
				$page->drawText('DineDesk Hospitality Pvt Ltd',15,45);
				$page->setFont($font, 6);
				$page->drawText('Making life easier! ',15,55);
				/*Print Address*/
			    $page->drawText('SoftSol Building, Plot No.4,',15,65);
				$page->drawText('B-Wing Software Units Layout,',15,75);
				$page->drawText('Hitech City, Hyderabad, Telangana 500081,',15,85);		
				$page->drawText('EMail: admin@dinedesk.com',15,95);
				
				$invoiceNo  = "INVOICE#  ".$billData['csrid'];
				$invoiceDate  = "DATE  ".date('d M y',strtotime($billData['csrbilling_date']));
	
				/* Print Invoice No and date on right hand side */
				$page->drawText($invoiceNo,450,45);
				$page->drawText($invoiceDate,450,55);
				
				/* Print Billing info */
				
				$page->setFont($font, 8);
				
				$page->drawText('TO',15,120);
				
				$page->setFont($font, 6);
				
				
				$name = $companyDet['com_companyname'];
				$page->drawText($name,20,130);
				
				$address = $companyDet['com_address'].",";
				$page->drawText($address,20,140);
				
				$city_state = $companyDet['com_email']." - ".$companyDet['com_phone'].",";
				$page->drawText($city_state,20,150);
				
				$country_zip = $companyDet['com_website'].".";			
				$page->drawText($country_zip,20,160);
				
				
				/* Print Invoice details */
				
				$invoiceFrom = 'Invoice From: '.date('d M y',strtotime($billData['csrbilling_fromdate']));
				$page->drawText($invoiceFrom,400,130);
				
				$invoiceTo = 'Invoice To: '.date('d M y',strtotime($billData['csrbilling_todate']));
				$page->drawText($invoiceTo,400,140);
				
				//$duedate = 'Due Date:';
				//$page->drawText($duedate,400,150);
								
				$restId = 'Restaurant ID: '.$billData['csrcompany_id'];
				$page->drawText($restId,400,150);
				
				$restName = 'Partner Name: '.$companyDet['com_companyname'];
				$page->drawText($restName,400,160);
	
				$planType = "Plan type: Monthly Subscription";
				$page->drawText($planType,400,170);
				
				/* Create table for printing  invoice desc and amount */
				
				$table = new My_Pdf_Table(6);
				/* Adding table header */
				$headrow  = new My_Pdf_Table_Row();
				$headcols = array();
						
				$sNo  = new My_Pdf_Table_Column();
				$sNo->setText("SNO",'center','middle');
				$sNo->setWidth(30);
				$sNo->setHeight(100);
				$headcols[] = $sNo;
					
				$itemTitle = new My_Pdf_Table_Column();
				$itemTitle->setText("ITEM TITLE",'center','middle');
				$itemTitle->setWidth(100);
				$headcols[] = $itemTitle;
	
				$description  = new My_Pdf_Table_Column();
				$description->setText("NO OF RESTAURANTS",'center','middle');
				$description->setWidth(100);
				$headcols[] = $description;
					
				$price  = new My_Pdf_Table_Column();
				$price->setText("PRICE PER RESTAURANT",'center','middle');
				$price->setWidth(100);
				$headcols[] = $price;
	
				$deductions  = new My_Pdf_Table_Column();
				$deductions->setText("DEDUCTIONS",'center','middle');
				$deductions->setWidth(80);
				$headcols[] = $deductions;
					
				$lineTotal  = new My_Pdf_Table_Column();
				$lineTotal->setText("LINE TOTAL",'center','middle');
				$lineTotal->setWidth(80);
				$headcols[] = $lineTotal;
				
				$headrow->setColumns($headcols);
				$headrow->setFont($font, 8);
				$headrow->setBorder(My_Pdf::TOP, new Zend_Pdf_Style());
				$headrow->setBorder(My_Pdf::BOTTOM, new Zend_Pdf_Style());
				$headrow->setBorder(My_Pdf::LEFT, new Zend_Pdf_Style());
				$headrow->setBorder(My_Pdf::RIGHT, new Zend_Pdf_Style());
				$headrow->setCellPaddings(array(8,8,8,8));
				$table->addRow($headrow);
				
				/* Add Table rows */
				
				$row  = new My_Pdf_Table_Row();
				$cols = array();			
				
				$sNoCol = new My_Pdf_Table_Column();
				$sNoCol->setText('1','center','middle');
				$sNoCol->setWidth(30);
				$sNoCol->setHeight(600);
				$cols[] = $sNoCol;
				
				$itemTitleCol = new My_Pdf_Table_Column();				
				$itemTitleCol->setText(date('d M y',strtotime($billData['csrbilling_fromdate'])),'center','middle');
				$itemTitleCol->setWidth(100);			
				$cols[] = $itemTitleCol;
                
				$descCol = new My_Pdf_Table_Column();
				$descCol->setText($billData['csrrestaurant_count'],'center','middle');
				$descCol->setWidth(100);			
				$cols[] = $descCol;
				
				$priceCol = new My_Pdf_Table_Column();
				$priceCol->setText('$'.$billData['csramount_per_restaurant'],'center','middle');
				$priceCol->setWidth(100);			
				$cols[] = $priceCol;
				
				$deductionCol = new My_Pdf_Table_Column();
				$deductionCol->setText('$0','center','middle');
				$deductionCol->setWidth(80);			
				$cols[] = $deductionCol;
				
				$lineTotalCol = new My_Pdf_Table_Column();
				$lineTotalCol->setText('$'.$billData['csramount'],'center','middle');
				$lineTotalCol->setWidth(80);			
				$cols[] = $lineTotalCol;
				
				$row->setColumns($cols);
			    $row->setFont($font, 8);
				$row->setBorder(My_Pdf::TOP, new Zend_Pdf_Style());
				$row->setBorder(My_Pdf::BOTTOM, new Zend_Pdf_Style());
				$row->setBorder(My_Pdf::LEFT, new Zend_Pdf_Style());
				$row->setBorder(My_Pdf::RIGHT, new Zend_Pdf_Style());
				$row->setCellPaddings(array(8,8,8,8));
				$table->addRow($row);				
	
				/* Print total row */
				$totCols = array();
				
				$sNoColTot = new My_Pdf_Table_Column();
				$sNoColTot->setText('','center','middle');
				$sNoColTot->setWidth(30);
				$sNoColTot->setHeight(600);
				$totCols[] = $sNoColTot;
				
				$itemTitleTotCol = new My_Pdf_Table_Column();				
				$itemTitleTotCol->setText('','center','middle');
				$itemTitleTotCol->setWidth(100);			
				$totCols[] = $itemTitleTotCol;
				
				$descTotCol = new My_Pdf_Table_Column();
				$descTotCol->setText('TOTAL','right','middle');
				$descTotCol->setWidth(170);			
				$totCols[] = $descTotCol;
				
				$priceTotCol = new My_Pdf_Table_Column();
				$priceTotCol->setText('','center','middle');
				$priceTotCol->setWidth(70);			
				$totCols[] = $priceTotCol;
				
				$deductionTotCol = new My_Pdf_Table_Column();
				$deductionTotCol->setText('$0','center','middle');
				$deductionTotCol->setWidth(80);			
				$totCols[] = $deductionTotCol;
				
				$lineTotalCol1 = new My_Pdf_Table_Column();
				$lineTotalCol1->setText('$'.$billData['csramount'],'center','middle');
				$lineTotalCol1->setWidth(80);			
				$totCols[] = $lineTotalCol1;
				
				$totRow  = new My_Pdf_Table_Row();
				$totRow->setColumns($totCols);			
				$totRow->setFont($font, 8);
				$totRow->setCellPaddings(array(8,8,8,8));
				$table->addRow($totRow);	
				
				/* Add Service Tax row */
				
				$serviceTaxCols = array();
				
				$sNoColTax = new My_Pdf_Table_Column();
				$sNoColTax->setText('','center','middle');
				$sNoColTax->setWidth(30);
				$sNoColTax->setHeight(600);
				$serviceTaxCols[] = $sNoColTax;
				
				$itemTitleTaxCol = new My_Pdf_Table_Column();				
				$itemTitleTaxCol->setText('','center','middle');
				$itemTitleTaxCol->setWidth(100);			
				$serviceTaxCols[] = $itemTitleTaxCol;
				
				$descTaxCol = new My_Pdf_Table_Column();
				$descTaxCol->setText('SERVICE TAX(%)','right','middle');
				$descTaxCol->setWidth(170);			
				$serviceTaxCols[] = $descTaxCol;
				
				$priceTaxCol = new My_Pdf_Table_Column();
				$priceTaxCol->setText('','center','middle');
				$priceTaxCol->setWidth(70);			
				$serviceTaxCols[] = $priceTaxCol;
				
				$deductionTaxCol = new My_Pdf_Table_Column();
				$deductionTaxCol->setText('','center','middle');
				$deductionTaxCol->setWidth(80);			
				$serviceTaxCols[] = $deductionTaxCol;
				
				$lineTotalTaxCol = new My_Pdf_Table_Column();
				$lineTotalTaxCol->setText('0%','center','middle');
				$lineTotalTaxCol->setWidth(80);	
						
				$serviceTaxCols[] = $lineTotalTaxCol;
				
				
				$servTaxRow  = new My_Pdf_Table_Row();
				$servTaxRow->setColumns($serviceTaxCols);
				$servTaxRow->setFont($font, 8);
				$servTaxRow->setCellPaddings(array(8,8,8,8));
				$table->addRow($servTaxRow);	
				
				
					/* Add Service Tax Toatal row */
				
				$serviceTaxTotCols = array();
				
				$sNoColTaxTot = new My_Pdf_Table_Column();
				$sNoColTaxTot->setText('','center','middle');
				$sNoColTaxTot->setWidth(30);
				$sNoColTaxTot->setHeight(600);
				$serviceTaxTotCols[] = $sNoColTaxTot;
				
				$itemTitleTaxTotCol = new My_Pdf_Table_Column();				
				$itemTitleTaxTotCol->setText('','center','middle');
				$itemTitleTaxTotCol->setWidth(100);			
				$serviceTaxTotCols[] = $itemTitleTaxTotCol;
				
				$descTaxTotCol = new My_Pdf_Table_Column();
				$descTaxTotCol->setText('SERVICE TAX TOTAL','right','middle');
				$descTaxTotCol->setWidth(170);			
				$serviceTaxTotCols[] = $descTaxTotCol;
				
				$priceTaxTotCol = new My_Pdf_Table_Column();
				$priceTaxTotCol->setText('','center','middle');
				$priceTaxTotCol->setWidth(70);			
				$serviceTaxTotCols[] = $priceTaxTotCol;
				
				$deductionTaxTotCol = new My_Pdf_Table_Column();
				$deductionTaxTotCol->setText('','center','middle');
				$deductionTaxTotCol->setWidth(80);			
				$serviceTaxTotCols[] = $deductionTaxTotCol;
				
				$lineTotalTaxTotCol = new My_Pdf_Table_Column();
				$lineTotalTaxTotCol->setText('$0','center','middle');
				$lineTotalTaxTotCol->setWidth(80);						
				$serviceTaxTotCols[] = $lineTotalTaxTotCol;
				
				
				$servTaxTotRow  = new My_Pdf_Table_Row();
				$servTaxTotRow->setColumns($serviceTaxTotCols);
				$servTaxTotRow->setFont($font, 8);
				$servTaxTotRow->setCellPaddings(array(8,8,8,8));
				$table->addRow($servTaxTotRow);
				
				/* Handling Charges row */
				
				
				$handlingChargesCols = array();
				
				$sNoColCharge = new My_Pdf_Table_Column();
				$sNoColCharge->setText('','center','middle');
				$sNoColCharge->setWidth(30);
				$sNoColCharge->setHeight(600);
				$handlingChargesCols[] = $sNoColCharge;
				
				$itemTitleChargeCol = new My_Pdf_Table_Column();				
				$itemTitleChargeCol->setText('','center','middle');
				$itemTitleChargeCol->setWidth(100);			
				$handlingChargesCols[] = $itemTitleChargeCol;
				
				$descChargeCol = new My_Pdf_Table_Column();
				$descChargeCol->setText('TRANSACTION FEE','right','middle');
				$descChargeCol->setWidth(170);			
				$handlingChargesCols[] = $descChargeCol;
				
				$priceChargeCol = new My_Pdf_Table_Column();
				$priceChargeCol->setText('','center','middle');
				$priceChargeCol->setWidth(70);			
				$handlingChargesCols[] = $priceChargeCol;
				
				$deductionChargeCol = new My_Pdf_Table_Column();
				$deductionChargeCol->setText('','center','middle');
				$deductionChargeCol->setWidth(80);			
				$handlingChargesCols[] = $deductionChargeCol;
				
				$lineTotalChargeCol = new My_Pdf_Table_Column();
				$lineTotalChargeCol->setText('0%','center','middle');
				$lineTotalChargeCol->setWidth(80);						
				$handlingChargesCols[] = $lineTotalChargeCol;
				
				
				$txnChargeRow  = new My_Pdf_Table_Row();
				$txnChargeRow->setColumns($handlingChargesCols);
				$txnChargeRow->setFont($font, 8);
				$txnChargeRow->setCellPaddings(array(8,8,8,8));
				$table->addRow($txnChargeRow);
				
				
				/* Add Net Payable row */
										
				$netPayCols = array();
				
				$sNoColNetPay = new My_Pdf_Table_Column();
				$sNoColNetPay->setText('','center','middle');
				$sNoColNetPay->setWidth(30);
				$sNoColNetPay->setHeight(600);
				$netPayCols[] = $sNoColNetPay;
				
				$itemTitleTNetPay = new My_Pdf_Table_Column();				
				$itemTitleTNetPay->setText('','center','middle');
				$itemTitleTNetPay->setWidth(100);			
				$netPayCols[] = $itemTitleTNetPay;
				
				$descTaxNetPay = new My_Pdf_Table_Column();
				$descTaxNetPay->setText('NET PAYABLE TOTAL','right','middle');
				$descTaxNetPay->setWidth(170);			
				$netPayCols[] = $descTaxNetPay;
				
				$priceNetPay = new My_Pdf_Table_Column();
				$priceNetPay->setText('','center','middle');
				$priceNetPay->setWidth(70);			
				$netPayCols[] = $priceNetPay;
				
				$deductionNetPayCol = new My_Pdf_Table_Column();
				$deductionNetPayCol->setText('','center','middle');
				$deductionNetPayCol->setWidth(80);			
				$netPayCols[] = $deductionNetPayCol;
				
				$lineTotalNetPayCol = new My_Pdf_Table_Column();
				$lineTotalNetPayCol->setText('$'.$billData['csramount'],'center','middle');
				$lineTotalNetPayCol->setWidth(80);						
				$netPayCols[] = $lineTotalNetPayCol;
				
				
				$netPayRow  = new My_Pdf_Table_Row();
				$netPayRow->setColumns($netPayCols);
				$netPayRow->setFont($font, 8);
				$netPayRow->setCellPaddings(array(8,8,8,8));
				$table->addRow($netPayRow);
				
				
				
				$page->addTable($table, 10, 200);
				$pdf->addPage($page);
				$pdf->save();
            }
        } catch (Exception $ex) {
            Uss_Logger_FileLogger::info($ex->getMessage());
            throw new Exception($ex->getMessage());
        }
    }
    
    public function GenerateRestaurantInvoicePdf($billData, $companyDet)
    {
        try{
            $path = 'restaurantpdf/'.$billData['RestId'];
			
			if(!file_exists($path)){
				mkdir($path,0777);
			}
			$invoiceDirPath = $path.'/invoice';
			if(!file_exists($invoiceDirPath)){
				mkdir($invoiceDirPath,0777);
			}
			
			$invoiceFilePath = $invoiceDirPath.'/'.$billData['csrid'].'.pdf';
            if(!file_exists($invoiceFilePath)){
                $pdf = new My_Pdf_Document($invoiceFilePath, '.');
				$page = $pdf->createPage();
	
				$font = Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_HELVETICA);
				
				$page->setFont($font, 8);
				$page->setLineColor(new Zend_Pdf_Color_Rgb(0,100,0));
				$page->drawLine(-10, 15, ($page->getWidth()-0), 15);
				$imageurl = "../public/images/logo.png";
				
				$image = Zend_Pdf_Image::imageWithPath($imageurl);
				
				// write image to page
				$page->drawImage($image,-10,-30,120, 40);
                $invoiceCreationDate = date('d M y',strtotime($billData['csrbilling_date']));
				$page->drawText('INVOICE', 500, 0);
				
				$page->drawText('DineDesk Hospitality Pvt Ltd',15,45);
				$page->setFont($font, 6);
				$page->drawText('Making life easier! ',15,55);
				/*Print Address*/
			    $page->drawText('SoftSol Building, Plot No.4,',15,65);
				$page->drawText('B-Wing Software Units Layout,',15,75);
				$page->drawText('Hitech City, Hyderabad, Telangana 500081,',15,85);		
				$page->drawText('EMail: admin@dinedesk.com',15,95);
				
				$invoiceNo  = "INVOICE#  ".$billData['csrid'];
				$invoiceDate  = "DATE  ".date('d M y',strtotime($billData['csrbilling_date']));
	
				/* Print Invoice No and date on right hand side */
				$page->drawText($invoiceNo,450,45);
				$page->drawText($invoiceDate,450,55);
				
				/* Print Billing info */
				
				$page->setFont($font, 8);
				
				$page->drawText('TO',15,120);
				
				$page->setFont($font, 6);
				
				
				$name = $companyDet['com_companyname'];
				$page->drawText($name,20,130);
				
				$address = $companyDet['com_address'].",";
				$page->drawText($address,20,140);
				
				$city_state = $companyDet['com_email']." - ".$companyDet['com_phone'].",";
				$page->drawText($city_state,20,150);
				
				$country_zip = $companyDet['com_website'].".";			
				$page->drawText($country_zip,20,160);
				
				
				/* Print Invoice details */
				
				$invoiceFrom = 'Invoice From: '.date('d M y',strtotime($billData['csrbilling_fromdate']));
				$page->drawText($invoiceFrom,400,130);
				
				$invoiceTo = 'Invoice To: '.date('d M y',strtotime($billData['csrbilling_todate']));
				$page->drawText($invoiceTo,400,140);
				
				//$duedate = 'Due Date:';
				//$page->drawText($duedate,400,150);
								
				$restId = 'Restaurant ID: '.$billData['csrcompany_id'];
				$page->drawText($restId,400,150);
				
				$restName = 'Partner Name: '.$companyDet['com_companyname'];
				$page->drawText($restName,400,160);
	
				$planType = "Plan type: Monthly Subscription";
				$page->drawText($planType,400,170);
				
				/* Create table for printing  invoice desc and amount */
				
				$table = new My_Pdf_Table(6);
				/* Adding table header */
				$headrow  = new My_Pdf_Table_Row();
				$headcols = array();
						
				$sNo  = new My_Pdf_Table_Column();
				$sNo->setText("SNO",'center','middle');
				$sNo->setWidth(30);
				$sNo->setHeight(100);
				$headcols[] = $sNo;
					
				$itemTitle = new My_Pdf_Table_Column();
				$itemTitle->setText("ITEM TITLE",'center','middle');
				$itemTitle->setWidth(100);
				$headcols[] = $itemTitle;
	
				$description  = new My_Pdf_Table_Column();
				$description->setText("NO OF RESTAURANTS",'center','middle');
				$description->setWidth(100);
				$headcols[] = $description;
					
				$price  = new My_Pdf_Table_Column();
				$price->setText("PRICE PER RESTAURANT",'center','middle');
				$price->setWidth(100);
				$headcols[] = $price;
	
				$deductions  = new My_Pdf_Table_Column();
				$deductions->setText("DEDUCTIONS",'center','middle');
				$deductions->setWidth(80);
				$headcols[] = $deductions;
					
				$lineTotal  = new My_Pdf_Table_Column();
				$lineTotal->setText("LINE TOTAL",'center','middle');
				$lineTotal->setWidth(80);
				$headcols[] = $lineTotal;
				
				$headrow->setColumns($headcols);
				$headrow->setFont($font, 8);
				$headrow->setBorder(My_Pdf::TOP, new Zend_Pdf_Style());
				$headrow->setBorder(My_Pdf::BOTTOM, new Zend_Pdf_Style());
				$headrow->setBorder(My_Pdf::LEFT, new Zend_Pdf_Style());
				$headrow->setBorder(My_Pdf::RIGHT, new Zend_Pdf_Style());
				$headrow->setCellPaddings(array(8,8,8,8));
				$table->addRow($headrow);
				
				/* Add Table rows */
				
				$row  = new My_Pdf_Table_Row();
				$cols = array();			
				
				$sNoCol = new My_Pdf_Table_Column();
				$sNoCol->setText('1','center','middle');
				$sNoCol->setWidth(30);
				$sNoCol->setHeight(600);
				$cols[] = $sNoCol;
				
				$itemTitleCol = new My_Pdf_Table_Column();				
				$itemTitleCol->setText(date('d M y',strtotime($billData['csrbilling_fromdate'])),'center','middle');
				$itemTitleCol->setWidth(100);			
				$cols[] = $itemTitleCol;
                
				$descCol = new My_Pdf_Table_Column();
				$descCol->setText($billData['csrrestaurant_count'],'center','middle');
				$descCol->setWidth(100);			
				$cols[] = $descCol;
				
				$priceCol = new My_Pdf_Table_Column();
				$priceCol->setText('$'.$billData['csramount_per_restaurant'],'center','middle');
				$priceCol->setWidth(100);			
				$cols[] = $priceCol;
				
				$deductionCol = new My_Pdf_Table_Column();
				$deductionCol->setText('$0','center','middle');
				$deductionCol->setWidth(80);			
				$cols[] = $deductionCol;
				
				$lineTotalCol = new My_Pdf_Table_Column();
				$lineTotalCol->setText('$'.$billData['csramount'],'center','middle');
				$lineTotalCol->setWidth(80);			
				$cols[] = $lineTotalCol;
				
				$row->setColumns($cols);
			    $row->setFont($font, 8);
				$row->setBorder(My_Pdf::TOP, new Zend_Pdf_Style());
				$row->setBorder(My_Pdf::BOTTOM, new Zend_Pdf_Style());
				$row->setBorder(My_Pdf::LEFT, new Zend_Pdf_Style());
				$row->setBorder(My_Pdf::RIGHT, new Zend_Pdf_Style());
				$row->setCellPaddings(array(8,8,8,8));
				$table->addRow($row);				
	
				/* Print total row */
				$totCols = array();
				
				$sNoColTot = new My_Pdf_Table_Column();
				$sNoColTot->setText('','center','middle');
				$sNoColTot->setWidth(30);
				$sNoColTot->setHeight(600);
				$totCols[] = $sNoColTot;
				
				$itemTitleTotCol = new My_Pdf_Table_Column();				
				$itemTitleTotCol->setText('','center','middle');
				$itemTitleTotCol->setWidth(100);			
				$totCols[] = $itemTitleTotCol;
				
				$descTotCol = new My_Pdf_Table_Column();
				$descTotCol->setText('TOTAL','right','middle');
				$descTotCol->setWidth(170);			
				$totCols[] = $descTotCol;
				
				$priceTotCol = new My_Pdf_Table_Column();
				$priceTotCol->setText('','center','middle');
				$priceTotCol->setWidth(70);			
				$totCols[] = $priceTotCol;
				
				$deductionTotCol = new My_Pdf_Table_Column();
				$deductionTotCol->setText('$0','center','middle');
				$deductionTotCol->setWidth(80);			
				$totCols[] = $deductionTotCol;
				
				$lineTotalCol1 = new My_Pdf_Table_Column();
				$lineTotalCol1->setText('$'.$billData['csramount'],'center','middle');
				$lineTotalCol1->setWidth(80);			
				$totCols[] = $lineTotalCol1;
				
				$totRow  = new My_Pdf_Table_Row();
				$totRow->setColumns($totCols);			
				$totRow->setFont($font, 8);
				$totRow->setCellPaddings(array(8,8,8,8));
				$table->addRow($totRow);	
				
				/* Add Service Tax row */
				
				$serviceTaxCols = array();
				
				$sNoColTax = new My_Pdf_Table_Column();
				$sNoColTax->setText('','center','middle');
				$sNoColTax->setWidth(30);
				$sNoColTax->setHeight(600);
				$serviceTaxCols[] = $sNoColTax;
				
				$itemTitleTaxCol = new My_Pdf_Table_Column();				
				$itemTitleTaxCol->setText('','center','middle');
				$itemTitleTaxCol->setWidth(100);			
				$serviceTaxCols[] = $itemTitleTaxCol;
				
				$descTaxCol = new My_Pdf_Table_Column();
				$descTaxCol->setText('SERVICE TAX(%)','right','middle');
				$descTaxCol->setWidth(170);			
				$serviceTaxCols[] = $descTaxCol;
				
				$priceTaxCol = new My_Pdf_Table_Column();
				$priceTaxCol->setText('','center','middle');
				$priceTaxCol->setWidth(70);			
				$serviceTaxCols[] = $priceTaxCol;
				
				$deductionTaxCol = new My_Pdf_Table_Column();
				$deductionTaxCol->setText('','center','middle');
				$deductionTaxCol->setWidth(80);			
				$serviceTaxCols[] = $deductionTaxCol;
				
				$lineTotalTaxCol = new My_Pdf_Table_Column();
				$lineTotalTaxCol->setText('0%','center','middle');
				$lineTotalTaxCol->setWidth(80);	
						
				$serviceTaxCols[] = $lineTotalTaxCol;
				
				
				$servTaxRow  = new My_Pdf_Table_Row();
				$servTaxRow->setColumns($serviceTaxCols);
				$servTaxRow->setFont($font, 8);
				$servTaxRow->setCellPaddings(array(8,8,8,8));
				$table->addRow($servTaxRow);	
				
				
					/* Add Service Tax Toatal row */
				
				$serviceTaxTotCols = array();
				
				$sNoColTaxTot = new My_Pdf_Table_Column();
				$sNoColTaxTot->setText('','center','middle');
				$sNoColTaxTot->setWidth(30);
				$sNoColTaxTot->setHeight(600);
				$serviceTaxTotCols[] = $sNoColTaxTot;
				
				$itemTitleTaxTotCol = new My_Pdf_Table_Column();				
				$itemTitleTaxTotCol->setText('','center','middle');
				$itemTitleTaxTotCol->setWidth(100);			
				$serviceTaxTotCols[] = $itemTitleTaxTotCol;
				
				$descTaxTotCol = new My_Pdf_Table_Column();
				$descTaxTotCol->setText('SERVICE TAX TOTAL','right','middle');
				$descTaxTotCol->setWidth(170);			
				$serviceTaxTotCols[] = $descTaxTotCol;
				
				$priceTaxTotCol = new My_Pdf_Table_Column();
				$priceTaxTotCol->setText('','center','middle');
				$priceTaxTotCol->setWidth(70);			
				$serviceTaxTotCols[] = $priceTaxTotCol;
				
				$deductionTaxTotCol = new My_Pdf_Table_Column();
				$deductionTaxTotCol->setText('','center','middle');
				$deductionTaxTotCol->setWidth(80);			
				$serviceTaxTotCols[] = $deductionTaxTotCol;
				
				$lineTotalTaxTotCol = new My_Pdf_Table_Column();
				$lineTotalTaxTotCol->setText('$0','center','middle');
				$lineTotalTaxTotCol->setWidth(80);						
				$serviceTaxTotCols[] = $lineTotalTaxTotCol;
				
				
				$servTaxTotRow  = new My_Pdf_Table_Row();
				$servTaxTotRow->setColumns($serviceTaxTotCols);
				$servTaxTotRow->setFont($font, 8);
				$servTaxTotRow->setCellPaddings(array(8,8,8,8));
				$table->addRow($servTaxTotRow);
				
				/* Handling Charges row */
				
				
				$handlingChargesCols = array();
				
				$sNoColCharge = new My_Pdf_Table_Column();
				$sNoColCharge->setText('','center','middle');
				$sNoColCharge->setWidth(30);
				$sNoColCharge->setHeight(600);
				$handlingChargesCols[] = $sNoColCharge;
				
				$itemTitleChargeCol = new My_Pdf_Table_Column();				
				$itemTitleChargeCol->setText('','center','middle');
				$itemTitleChargeCol->setWidth(100);			
				$handlingChargesCols[] = $itemTitleChargeCol;
				
				$descChargeCol = new My_Pdf_Table_Column();
				$descChargeCol->setText('TRANSACTION FEE','right','middle');
				$descChargeCol->setWidth(170);			
				$handlingChargesCols[] = $descChargeCol;
				
				$priceChargeCol = new My_Pdf_Table_Column();
				$priceChargeCol->setText('','center','middle');
				$priceChargeCol->setWidth(70);			
				$handlingChargesCols[] = $priceChargeCol;
				
				$deductionChargeCol = new My_Pdf_Table_Column();
				$deductionChargeCol->setText('','center','middle');
				$deductionChargeCol->setWidth(80);			
				$handlingChargesCols[] = $deductionChargeCol;
				
				$lineTotalChargeCol = new My_Pdf_Table_Column();
				$lineTotalChargeCol->setText('0%','center','middle');
				$lineTotalChargeCol->setWidth(80);						
				$handlingChargesCols[] = $lineTotalChargeCol;
				
				
				$txnChargeRow  = new My_Pdf_Table_Row();
				$txnChargeRow->setColumns($handlingChargesCols);
				$txnChargeRow->setFont($font, 8);
				$txnChargeRow->setCellPaddings(array(8,8,8,8));
				$table->addRow($txnChargeRow);
				
				
				/* Add Net Payable row */
										
				$netPayCols = array();
				
				$sNoColNetPay = new My_Pdf_Table_Column();
				$sNoColNetPay->setText('','center','middle');
				$sNoColNetPay->setWidth(30);
				$sNoColNetPay->setHeight(600);
				$netPayCols[] = $sNoColNetPay;
				
				$itemTitleTNetPay = new My_Pdf_Table_Column();				
				$itemTitleTNetPay->setText('','center','middle');
				$itemTitleTNetPay->setWidth(100);			
				$netPayCols[] = $itemTitleTNetPay;
				
				$descTaxNetPay = new My_Pdf_Table_Column();
				$descTaxNetPay->setText('NET PAYABLE TOTAL','right','middle');
				$descTaxNetPay->setWidth(170);			
				$netPayCols[] = $descTaxNetPay;
				
				$priceNetPay = new My_Pdf_Table_Column();
				$priceNetPay->setText('','center','middle');
				$priceNetPay->setWidth(70);			
				$netPayCols[] = $priceNetPay;
				
				$deductionNetPayCol = new My_Pdf_Table_Column();
				$deductionNetPayCol->setText('','center','middle');
				$deductionNetPayCol->setWidth(80);			
				$netPayCols[] = $deductionNetPayCol;
				
				$lineTotalNetPayCol = new My_Pdf_Table_Column();
				$lineTotalNetPayCol->setText('$'.$billData['csramount'],'center','middle');
				$lineTotalNetPayCol->setWidth(80);						
				$netPayCols[] = $lineTotalNetPayCol;
				
				
				$netPayRow  = new My_Pdf_Table_Row();
				$netPayRow->setColumns($netPayCols);
				$netPayRow->setFont($font, 8);
				$netPayRow->setCellPaddings(array(8,8,8,8));
				$table->addRow($netPayRow);
				
				
				
				$page->addTable($table, 10, 200);
				$pdf->addPage($page);
				$pdf->save();
            }
        } catch (Exception $ex) {
            Uss_Logger_FileLogger::info($ex->getMessage());
            throw new Exception($ex->getMessage());
        }
    }
}
