<?php

class Application_Service_Serverservice
{
	
	protected $_form = array();
	
	public function updateorinsertServerDetails($request)
	{
		try{
			$restaurantService = new Application_Service_Firm();
			$timeZone = $restaurantService->GetRestaurantTimeZone($request->restaurantid);			
			date_default_timezone_set($timeZone);
			$storage = new Zend_Auth_Storage_Session();
			$userdata = $storage->read();
			
			$tableid = array();
			$tableidString = "";

			$tableidString = $request->servtableid;

			if($tableidString){
				$tableid = explode(',',$tableidString);
			}
			
			$server = new Server_Model_Server();
			$server->setser_name($request->servername);
			$server->setserid($request->serverid);
			$server->setser_colorcode($request->servercolor);
			$server->setTableid($tableid);
      // Pratik chnages - 22-09-2020 ///////////
			$server->setserupdateddate(date('H:i:s',time()));
      $server->setsernewupdateddate(date('Y-m-d'));
      //////////////////////////////////////////////
			$server->setserupdatedtime(date('H:i:s',time()));
			$server->setserupdatedby($userdata['User_Id']);
			$server->setsercreateddateandtime(date('Y-m-d H:i:s'));
			$server->setsercreatedby($userdata['User_Id']);
			$server->setser_resid($request->restaurantid);
			
			$serverDataMapper = new Server_Model_ServerDataMapper();
			$result = $serverDataMapper->updateorInsertServerDetails($server);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getalltables($request)
	{
		try{
			$restaurantid = $request->restaurantid;
			$diningid = $request->diningid;
			$serverDataMapper = new Server_Model_ServerDataMapper();
			$result = $serverDataMapper->getallTables($restaurantid,$diningid);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getServersByRestId($restid,$date)
	{
		try
		{
			$serverDataMapper = new Server_Model_ServerDataMapper();
			$result = $serverDataMapper->retrieveServersByRestId($restid,$date);
			return $result;			
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getSecTablesForHighlight($restid)
	{
		try
		{
			$secTableMapDataMapper = new Server_Model_ServerTableMapDataMapper();
			$result = $secTableMapDataMapper->retrieveSecTableForHighlight($restid);			
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function gettablesofserverbyid($request)
	{
		try
		{
			$serverid = $request->serverid;
			$serTableMapDataMapper = new Server_Model_ServerTableMapDataMapper();
			$result = $serTableMapDataMapper->gettablesofserverbyid($serverid);			
			return $result;	
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}	
	}
	
	public function assigntablesforserver($request)
	{
		try
		{
			$tableid = array();
			$tableidarr = "";
			$serveridarr = "";

			$tableidsarr = $request->tableids;
			$serveridarr = $request->serverids;
			
			if($tableidsarr){
				$tableid = explode(',',$tableidsarr);
			}
			
			$serTabObj = new Server_Model_ServerTableMap();
			$serTabObj->setStm_staus(true)
					  ->setstm_diningid($request->diningid)
					  ->setstm_tableid($tableid);
			$serTableMapDataMapper = new Server_Model_ServerTableMapDataMapper();
			$result = $serTableMapDataMapper->assigntablesforserver($serTabObj);			
			return $result;	
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}	
	}
	
	public function clearalltablesofservers($resid)
	{
		try
		{
			$serDataMapper = new Server_Model_ServerDataMapper();
			$result = $serDataMapper->clearalltablesofservers($resid);			
			return $result;	
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}	
	}
	
	public function ActivateorDeactServer($request)
	{
		try
		{
			$serverid = $request->serverid;
			$stat = $request->status;
			$restaurantid = $request->restaurantid;
			$status = $request->status;
			
			$ServerStatusMapper = new Server_Model_ServerStatusbdMapper();
			$ServerStatusRes = $ServerStatusMapper->getIdByCode($status);
			
			$serDataMapper = new Server_Model_ServerDataMapper();
			$result = $serDataMapper->ActivateorDeactServer($serverid,$ServerStatusRes->getId(),$restaurantid);
      //echo '<pre>'; print_r($ServerStatusRes); exit;
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getServersByRestaurantid($request)
	{
		try{
			$restaurantid = $request->restaurantid;
			
			$serDataMapper = new Server_Model_ServerDataMapper();
			$result = $serDataMapper->getServersByRestaurantid($restaurantid);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
}	