<?php
class Application_Service_SocialMedia
{
	/**
	 * Instance variable of the form
	 * @var array
	 */
	protected $_form = array();
	
	/**
     * @param instance of zend form
     */
	public function setSocialMediaPostForm(Zend_Form $form)
	{
		$this->_form['PostSocialMedia'] = $form;
	}
	/**
     * @return instance of form
     */
	public function getSocialMediaPostForm()
	{
		if(empty($this->_form['PostSocialMedia'])){
			$this->setSocialMediaPostForm(new SocialMedia_Form_SocialMediaPost());
		}
		return $this->_form['PostSocialMedia'];
	}
	
	public function saveSocialMedia($request,$post,$user,$postid)
	{
		try{
			$model = new SocialMedia_Model_FBPosts();
			$restServ = new Application_Service_Firm();
			$timeZone = $restServ->GetRestaurantTimeZone($request->postRestaurant);
			date_default_timezone_set($timeZone);
			$model->setrfbp_post_fb_id($post)
					->setrfbp_post_id($postid)
					->setrfbp_fk_business($request->postRestaurant)
					->setrfbp_created_fb_by($user->bfbp_id)
					->setrfbp_post_date(date('Y-m-d'))
					->setrfbp_post_time(date('H:i:s'))
					->setrfbp_status('T');
					
			if($request->postType == 'sch'){
				$model->setrfbp_sent_status(101)
						->setrfbp_post_date($request->postDate)
						->setrfbp_post_time(date('H:i:s',strtotime($request->postTime)));
			}else{
				$model->setrfbp_post_date(date('Y-m-d'))
						->setrfbp_post_time(date('H:i:s'))
						->setrfbp_sent_status(100);
			}
			if(isset($user->bfbpp_id)){
				$model->setrfbp_created_fb_for($user->bfbpp_id);
			}
			$mapper = new SocialMedia_Model_FBPostsDataMapper();
			$result = $mapper->SavePosts($model);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getSocialMediaPosts($request)
	{
		try{
			$model = new SocialMedia_Model_FBPosts();
			$model->setrfbp_fk_business($request->postRestaurant)
					->setrfbp_created_fb_by($request->user)
					->setrfbp_status('T');
			$mapper = new SocialMedia_Model_FBPostsDataMapper();
			$result = $mapper->GetFbPosts($model);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function saveSocialMediaTwi($request,$post,$user,$postid)
	{
		try{
			$model = new SocialMedia_Model_TWIPosts();
			$restServ = new Application_Service_Firm();
			$timeZone = $restServ->GetRestaurantTimeZone($request->postRestaurant);
			date_default_timezone_set($timeZone);
			$model->setrtwp_post_twi_id($post)
					->setrtwp_post_id($postid)
					->setrtwp_fk_business($request->postRestaurant)
					->setrtwp_created_fb_by($user->btwp_id)
					->setrtwp_status('T')
					->setrtwp_created_fb_for($user->btwp_id);
			if($request->postType == 'sch'){
				$model->setrtwp_sent_status(101)
						->setrtwp_post_date($request->postDate)
						->setrtwp_post_time(date('H:i:s',strtotime($request->postTime)));
			}else{
				$model->setrtwp_post_date(date('Y-m-d'))
						->setrtwp_post_time(date('H:i:s'))
						->setrtwp_sent_status(100);
			}
			$mapper = new SocialMedia_Model_TWIPostsMapper();
			$result = $mapper->SavePosts($model);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getSocialMediaPostsTwi($request)
	{
		try{
			$model = new SocialMedia_Model_TWIPosts();
			$model->setrtwp_fk_business($request->postRestaurant)
					->setrtwp_created_fb_by($request->user)
					->setrtwp_status('T');
			$mapper = new SocialMedia_Model_TWIPostsMapper();
			$result = $mapper->GetTWIPosts($model);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function saveSocialMediaLink($request,$post,$user,$postid)
	{
		try{
			$model = new SocialMedia_Model_LINKPosts();
			$restServ = new Application_Service_Firm();
			$timeZone = $restServ->GetRestaurantTimeZone($request->postRestaurant);
			date_default_timezone_set($timeZone);
			$model->setrinp_post_in_id($post)
					->setrinp_post_id($postid)
					->setrinp_fk_business($request->postRestaurant)
					->setrinp_created_fb_by($user->binp_id)
					->setrinp_status('T')
					->setrinp_created_fb_for($user->binp_id);
			if($request->postType == 'sch'){
				$model->setrinp_sent_status(101)
						->setrinp_post_date($request->postDate)
						->setrinp_post_time(date('H:i:s',strtotime($request->postTime)));
			}else{
				$model->setrinp_post_date(date('Y-m-d'))
						->setrinp_post_time(date('H:i:s'))
						->setrinp_sent_status(100);
			}
			$mapper = new SocialMedia_Model_LINKPostsMapper();
			$result = $mapper->SavePosts($model);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getSocialMediaPostsLink($request)
	{
		try{
			$model = new SocialMedia_Model_LINKPosts();
			$model->setrinp_fk_business($request->postRestaurant)
					->setrinp_created_fb_by($request->user)
					->setrinp_status('T');
			$mapper = new SocialMedia_Model_LINKPostsMapper();
			$result = $mapper->GetLINKPosts($model);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function saveSocialPosts($request,$user,$file = '')
	{
		try{
			$model = new SocialMedia_Model_SocialPosts();
			$restServ = new Application_Service_Firm();
			$timeZone = $restServ->GetRestaurantTimeZone($request->postRestaurant);
			date_default_timezone_set($timeZone);
			
			$model->setrsp_image($file)
					->setrsp_type($request->postType)
					->setrsp_description($request->postDesc)
					->setrsp_fk_business($request->postRestaurant)
					->setrsp_post_created_by($user)
					->setrsp_post_created_at(date('Y-m-d')." ".date('h:i:s'))
					->setrsp_status('T');
			$mapper = new SocialMedia_Model_SocialPostsMapper();
			$result = $mapper->SavePosts($model);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getSocialPosts($request)
	{
		try{
			$model = new SocialMedia_Model_SocialPosts();
			if(isset($request->post)){
				$model->setId($request->post);
			}
			$model->setrsp_fk_business($request->postRestaurant)
					->setrsp_post_created_by($request->user)
					->setrsp_status('T');
			$perPage = $request->perPage;
			$offSet = $request->offSet;
			$mapper = new SocialMedia_Model_SocialPostsMapper();
			$result = $mapper->GetFbPosts($model,$perPage,$offSet);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getSchSocialPosts($request)
	{
		try{
			$model = new SocialMedia_Model_SocialPosts();
			if(isset($request->post)){
				$model->setId($request->post);
			}
			$model->setrsp_fk_business($request->postRestaurant)
					->setrsp_post_created_by($request->user)
					->setrsp_status('T');
			$mapper = new SocialMedia_Model_SocialPostsMapper();
			$result = $mapper->GetSchPosts($model);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function saveSocialProfile($fbOpr,$restid)
	{
		try{
			$model = new SocialMedia_Model_SocialProfile();
			$restServ = new Application_Service_Firm();
			$timeZone = $restServ->GetRestaurantTimeZone($restid);
			date_default_timezone_set($timeZone);
			if($fbOpr == 'FB'){
				$model->setrsp_fb_status('T');
			}else if($fbOpr == 'TWI'){
				$model->setrsp_twi_status('T');
			}else if($fbOpr == 'GOO'){
				$model->setrsp_goog_status('T');
			}else if($fbOpr == 'IN'){
				$model->setrsp_in_status('T');
			}
			$model->setrsp_fk_business($restid);
			$mapper = new SocialMedia_Model_SocialProfileMapper();
			$result = $mapper->SaveProfile($model);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getSocialProfile($request)
	{
		try{
			$model = new SocialMedia_Model_SocialProfile();
			$model->setrsp_fk_business($request->postRestaurant);
			$mapper = new SocialMedia_Model_SocialProfileMapper();
			$result = $mapper->GetProfile($model);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function saveFBSocialProfile($access,$userObj,$request)
	{
		try{
			$model = new SocialMedia_Model_FBProfile();
			$restServ = new Application_Service_Firm();
			$timeZone = $restServ->GetRestaurantTimeZone($request->postRestaurant);
			date_default_timezone_set($timeZone);
			$socialProf = $this->getSocialProfile($request);
			$model->setbfbp_fk_profile($socialProf->rsp_id)
					->setbfbp_user_id($userObj['id'])
					->setbfbp_user_access_token($access)
					->setbfbp_user_name($userObj['name'])
					->setbfbp_user_page('me')
					->setbfbp_status('T');
			$mapper = new SocialMedia_Model_FBProfileMapper();
			$result = $mapper->SaveProfile($model);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getFBSocialProfile($request)
	{
		try{
			$model = new SocialMedia_Model_FBProfile();
			$model->setbfbp_fk_profile($request->profile);
			if($request->fbuserid){
				$model->setbfbp_user_id($request->fbuserid);
			}
			if($request->fbUser){
				$model->setId($request->fbUser);
			}
			$mapper = new SocialMedia_Model_FBProfileMapper();
			$result = $mapper->GetProfile($model);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function saveFBPageSocialProfile($pageList,$userObj,$request,$wallStat = false)
	{
		try{
			$restServ = new Application_Service_Firm();
			$timeZone = $restServ->GetRestaurantTimeZone($request->postRestaurant);
			date_default_timezone_set($timeZone);
			$modelArr = array();
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			$model = new SocialMedia_Model_FBProfilePage();
			$model->setbfbpp_profile_id($userObj)
				  ->setbfbpp_page_id('wall')
				  ->setbfbpp_page_name('wall')
				  ->setbfbpp_page_access($data['access_token'])
				  ->setbfbpp_page_category('wall')
				  ->setbfbpp_page_roles('wall')
				  ->setbfbpp_page_status('F');
			$modelArr[] = $model;
			foreach($pageList['data'] as $page){
				$model = new SocialMedia_Model_FBProfilePage();
				$model->setbfbpp_profile_id($userObj)
					  ->setbfbpp_page_id($page['id'])
					  ->setbfbpp_page_name($page['name'])
					  ->setbfbpp_page_access($page['access_token'])
					  ->setbfbpp_page_category($page['category'])
					  ->setbfbpp_page_roles(implode(",", $page['perms']))
					  ->setbfbpp_page_status('F');
				$modelArr[] = $model;
			}
			$mapper = new SocialMedia_Model_FBProfilePageMapper();
			$result = $mapper->SaveProfilePage($modelArr);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getFBPageSocialProfile($user)
	{
		try{
			$model = new SocialMedia_Model_FBProfilePage();
			$model->setbfbpp_profile_id($user);
			$mapper = new SocialMedia_Model_FBProfilePageMapper();
			$result = $mapper->GetProfilePage($model);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getFBPageSocialProfileByIds($user)
	{
		try{
			$userDet = explode(',',$user);
			$userProf = array();
			$userProfId = array();
			foreach($userDet as $userD){
				if($userD){
					$userSplit = explode('_',$userD);
					$userProf[] = $userSplit[1];
					$userProfId[] = $userSplit[0];
				}
			}
			$model = new SocialMedia_Model_FBProfilePage();
			$model->setId($userProf);
			$model->setbfbpp_profile_id($userProfId);
			$mapper = new SocialMedia_Model_FBProfilePageMapper();
			$result = $mapper->GetProfilePageByIds($model);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getTWISocialProfileByIds($user)
	{
		try{
			$userDet = explode(',',$user);
			$userProf = array();
			$userProfId = array();
			foreach($userDet as $userD){
				if($userD){
					$userSplit = explode('_',$userD);
					$userProf[] = $userSplit[1];
					$userProfId[] = $userSplit[0];
				}
			}
			$model = new SocialMedia_Model_TWIProfile();
			$model->setId($userProf);
			$mapper = new SocialMedia_Model_TWIProfileMapper();
			$result = $mapper->GetProfileByIds($model);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getGOOSocialProfileByIds($user)
	{
		try{
			$userDet = explode(',',$user);
			$userProf = array();
			$userProfId = array();
			foreach($userDet as $userD){
				if($userD){
					$userSplit = explode('_',$userD);
					$userProf[] = $userSplit[1];
					$userProfId[] = $userSplit[0];
				}
			}
			$model = new SocialMedia_Model_GOOProfile();
			$model->setId($userProf);
			$mapper = new SocialMedia_Model_GOOProfileMapper();
			$result = $mapper->GetProfileByIds($model);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getLINKSocialProfileByIds($user)
	{
		try{
			$userDet = explode(',',$user);
			$userProf = array();
			$userProfId = array();
			foreach($userDet as $userD){
				if($userD){
					$userSplit = explode('_',$userD);
					$userProf[] = $userSplit[1];
					$userProfId[] = $userSplit[0];
				}
			}
			$model = new SocialMedia_Model_LINKProfile();
			$model->setId($userProf);
			$mapper = new SocialMedia_Model_LINKProfileMapper();
			$result = $mapper->GetProfileByIds($model);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
        
        public function saveLINKPageSocialProfile($compObj,$userObj,$request,$wallStat = false)
	{
		try{

			
                    $restServ = new Application_Service_Firm();
			$timeZone = $restServ->GetRestaurantTimeZone($request->postRestaurant);
			date_default_timezone_set($timeZone);
			$modelArr = array();
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			$model = new SocialMedia_Model_LINKProfilePage();
			$model->setbinpp_profile_id($userObj)
				  ->setbinpp_page_id('profile')
				  ->setbinpp_page_name('profile')
				  ->setbinpp_page_access($data['access_token_linkedin'])
				  ->setbinpp_page_category('profile')
				  ->setbinpp_page_roles('profile')
				  ->setbinpp_page_status('F');
			$modelArr[] = $model;
			if($compObj->_total>0)
			{
				$pageList = $compObj->values;
					foreach($pageList as $key=>$page){                            
					$model = new SocialMedia_Model_LINKProfilePage();
					$model->setbinpp_profile_id($userObj)
						  ->setbinpp_page_id($page->id)
						  ->setbinpp_page_name($page->name)
						  ->setbinpp_page_access($data['access_token_linkedin'])
						  ->setbinpp_page_category('company')
						  ->setbinpp_page_roles('')
						  ->setbinpp_page_status('F');
					$modelArr[] = $model;
				}
			}
			$mapper = new SocialMedia_Model_LINKProfilePageMapper();
			$result = $mapper->SaveProfilePage($modelArr);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getLINKPageSocialProfile($user)
	{
		try{
			$model = new SocialMedia_Model_LINKProfilePage();
			$model->setbinpp_profile_id($user);
			$mapper = new SocialMedia_Model_LINKProfilePageMapper();
			$result = $mapper->GetProfilePage($model);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getLINKPageSocialProfileByIds($user)
	{
		try{
			$userDet = explode(',',$user);
			$userProf = array();
			$userProfId = array();
			foreach($userDet as $userD){
				if($userD){
					$userSplit = explode('_',$userD);
					$userProf[] = $userSplit[1];
					$userProfId[] = $userSplit[0];
				}
			}
			$model = new SocialMedia_Model_LINKProfilePage();
			$model->setId($userProf);
			$model->setbinpp_profile_id($userProfId);
			$mapper = new SocialMedia_Model_LINKProfilePageMapper();
			$result = $mapper->GetProfilePageByIds($model);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getSocialProfileByIds($user)
	{
		try{
			$userDet = explode(',',$user);
			$twiProf ='';
			$gooProf ='';
			$fbProf = '';
			$linkProf = '';
			$ProfResult = array();
			foreach($userDet as $userD){
				$userSplit = explode('_',$userD);
				if($userSplit[0] == 'FB'){
					$fbProf .= $userSplit[1].'_'.$userSplit[2].',';
				}else if($userSplit[0] == 'TWI'){
					$twiProf .= $userSplit[1].'_'.$userSplit[2].',';
				}else if($userSplit[0] == 'GOO'){
					$gooProf .= $userSplit[1].'_'.$userSplit[2].',';
				}else if($userSplit[0] == 'LINK'){
					$linkProf .= $userSplit[1].'_'.$userSplit[2].',';
				}
			}
			if($twiProf){
				$ProfResult['TWI'] = $this->getTWISocialProfileByIds($twiProf);
			}
			if($gooProf){
				$ProfResult['GOO'] = $this->getGOOSocialProfileByIds($gooProf);
			}
			if($fbProf){
				$ProfResult['FB'] = $this->getFBPageSocialProfileByIds($fbProf);
			}
			if($linkProf){
				$ProfResult['LINK'] = $this->getLINKPageSocialProfileByIds($linkProf);
			}
			return $ProfResult;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getSocialProfileByIdsForSms($user)
	{
		try{
			$twiProf ='';
			$gooProf ='';
			$fbProf = '';
			$inProf = '';
			$ProfResult = array();
			foreach($user as $userD){
				$userSplit = explode('_',$userD);
				if($userSplit[0] == 'FB'){
					$fbProf .= $userSplit[1].'_'.$userSplit[2].',';
				}else if($userSplit[0] == 'TWI'){
					$twiProf .= $userSplit[1].'_'.$userSplit[2].',';
				}else if($userSplit[0] == 'GOO'){
					$gooProf .= $userSplit[1].'_'.$userSplit[2].',';
				}else if($userSplit[0] == 'IN'){
					$inProf .= $userSplit[1].'_'.$userSplit[2].',';
				}
			}
			if($twiProf){
				$ProfResult['TWI'] = $this->getTWISocialProfileByIds($twiProf);
			}
			if($gooProf){
				$ProfResult['GOO'] = $this->getGOOSocialProfileByIds($gooProf);
			}
			if($fbProf){
				$ProfResult['FB'] = $this->getFBPageSocialProfileByIds($fbProf);
			}
			if($inProf){
				$ProfResult['IN'] = $this->getLINKSocialProfileByIds($inProf);
			}
			return $ProfResult;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function saveTWISocialProfile($aAccessToken,$userObj,$request)
	{
		try{
			$model = new SocialMedia_Model_TWIProfile();
			$restServ = new Application_Service_Firm();
			$timeZone = $restServ->GetRestaurantTimeZone($request->postRestaurant);
			date_default_timezone_set($timeZone);
			$socialProf = $this->getSocialProfile($request);
			$model->setbtwp_fk_profile($socialProf->rsp_id)
					->setbtwp_user_id($aAccessToken['user_id'])
					->setbtwp_user_access_token($aAccessToken['oauth_token'])
					->setbtwp_user_access_token_secret($aAccessToken['oauth_token_secret'])
					->setbtwp_user_name($aAccessToken['screen_name'])
					->setbtwp_status('F');
			$mapper = new SocialMedia_Model_TWIProfileMapper();
			$result = $mapper->SaveProfile($model);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getTWISocialProfile($request)
	{
		try{
			$model = new SocialMedia_Model_TWIProfile();
			$model->setbtwp_fk_profile($request->profile);
			$mapper = new SocialMedia_Model_TWIProfileMapper();
			$result = $mapper->GetProfile($model);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function saveGOOSocialProfile($aAccessToken,$userObj,$request)
	{
		try{
			$model = new SocialMedia_Model_GOOProfile();
			$restServ = new Application_Service_Firm();
			$timeZone = $restServ->GetRestaurantTimeZone($request->postRestaurant);
			date_default_timezone_set($timeZone);
			$socialProf = $this->getSocialProfile($request);
			$model->setbgop_fk_profile($socialProf->rsp_id)
					->setbgop_user_id($userObj['id'])
					->setbgop_user_access_token($aAccessToken->access_token)
					->setbgop_user_refresh_token($aAccessToken->refresh_token)
					->setbgop_user_token_type($aAccessToken->token_type)
					->setbgop_user_expires_in($aAccessToken->expires_in)
					->setbgop_id_token($aAccessToken->id_token)
					->setbgop_created_token($aAccessToken->created)
					->setbgop_user_name($userObj['displayName'])
					->setbgop_status('F');
			$mapper = new SocialMedia_Model_GOOProfileMapper();
			$result = $mapper->SaveProfile($model);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getGOOSocialProfile($request)
	{
		try{
			$model = new SocialMedia_Model_GOOProfile();
			$model->setbgop_fk_profile($request->profile);
			$mapper = new SocialMedia_Model_GOOProfileMapper();
			$result = $mapper->GetProfile($model);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function saveLINKSocialProfile($oauthAccessToken,$userObj,$request)
	{
		try{
			$model = new SocialMedia_Model_LINKProfile();
			$restServ = new Application_Service_Firm();
			$timeZone = $restServ->GetRestaurantTimeZone($request->postRestaurant);
			date_default_timezone_set($timeZone);
			$socialProf = $this->getSocialProfile($request);
			$model->setbinp_fk_profile($socialProf->rsp_id)
					->setbinp_user_id($userObj->id)
					->setbinp_user_access_token($oauthAccessToken['access_token_linkedin'])
					->setbinp_user_refresh_token($oauthAccessToken['access_token_linkedin'])
					->setbinp_user_access_token_secret($oauthAccessToken['access_token_linkedin'])
					->setbinp_user_token_type('')
					->setbinp_user_expires_in($oauthAccessToken['expires_at'])
					->setbinp_id_token('')
					->setbinp_created_token('')
					->setbinp_user_name($userObj->firstName.' '.$userObj->lastName)
					->setbinp_status('F');
			$mapper = new SocialMedia_Model_LINKProfileMapper();
			$result = $mapper->SaveProfile($model);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getLINKSocialProfile($request)
	{
		try{
			$model = new SocialMedia_Model_LINKProfile();
			$model->setbinp_fk_profile($request->profile);
			$mapper = new SocialMedia_Model_LINKProfileMapper();
			$result = $mapper->GetProfile($model);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getSocialPostsByNetwork($request)
	{
		try{
			$model = new SocialMedia_Model_SocialPosts();
			$perPage = null;
			$offSet = null;
			if(isset($request->post)){
				$model->setId($request->post);
			}
			if(isset($request->perPage))
			{
				$perPage = $request->perPage;
				$offSet = $request->offSet;
			}
			$model->setrsp_fk_business($request->postRestaurant)
					->setrsp_post_created_by($request->user)
					->setrsp_status('T');
			$mapper = new SocialMedia_Model_SocialPostsMapper();
			$result = $mapper->GetFbPostsByNetwork($model,$perPage,$offSet);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getSchSocialPostsByNetwork($request)
	{
		try{
			$model = new SocialMedia_Model_SocialPosts();
			if(isset($request->post)){
				$model->setId($request->post);
			}
			$model->setrsp_fk_business($request->postRestaurant)
					->setrsp_post_created_by($request->user)
					->setrsp_status('T');
			$mapper = new SocialMedia_Model_SocialPostsMapper();
			$result = $mapper->GetSchPostsByNetwork($model);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function updateFBPageStatus($request,$restid)
	{
		try{
			$model = new SocialMedia_Model_FBProfilePage();
			$pageDet = explode('_',$request->pageid);
			$model->setId($pageDet[2]);
			if($request->act == 'enable'){
				$model->setbfbpp_page_status('T');
			}else if($request->act == 'disable'){
				$model->setbfbpp_page_status('F');
			}else if($request->act == 'delete'){
				$model->setbfbpp_page_status('D');
			}
			$mapper = new SocialMedia_Model_FBProfilePageMapper();
			$result = $mapper->UpdateProfilePage($model,$restid);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function updateTWIAccStatus($request,$restid)
	{
		try{
			$model = new SocialMedia_Model_TWIProfile();
			$pageDet = explode('_',$request->pageid);
			$model->setId($pageDet[2]);
			if($request->act == 'enable'){
				$model->setbtwp_status('T');
			}else if($request->act == 'disable'){
				$model->setbtwp_status('F');
			}else if($request->act == 'delete'){
				$model->setbtwp_status('D');
			}
			$mapper = new SocialMedia_Model_TWIProfileMapper();
			$result = $mapper->UpdateProfileTWI($model,$restid);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function updateGOOAccStatus($request,$restid)
	{
		try{
			$model = new SocialMedia_Model_GOOProfile();
			$pageDet = explode('_',$request->pageid);
			$model->setId($pageDet[2]);
			if($request->act == 'enable'){
				$model->setbgop_status('T');
			}else if($request->act == 'disable'){
				$model->setbgop_status('F');
			}else if($request->act == 'delete'){
				$model->setbgop_status('D');
			}
			$mapper = new SocialMedia_Model_GOOProfileMapper();
			$result = $mapper->UpdateProfileGOO($model,$restid);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function updateLINKAccStatus($request,$restid)
	{
		try{
			$model = new SocialMedia_Model_LINKProfilePage();
			$pageDet = explode('_',$request->pageid);
			$model->setId($pageDet[2]);
			if($request->act == 'enable'){
				$model->setbinpp_page_status('T');
			}else if($request->act == 'disable'){
				$model->setbinpp_page_status('F');
			}else if($request->act == 'delete'){
				$model->setbinpp_page_status('D');
			}
			$mapper = new SocialMedia_Model_LINKProfilePageMapper();
			$result = $mapper->UpdateProfilePage($model,$restid);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
}