<?php
/**
*	Name			: FirmController.php
*	Author			: Snehal
*	Creation Date	: 09/30/2010
*	Path 			: application/modules/FirmManagement/controllers/FirmController.php
*	Description		: This is controller class for the Manage Restaurant module.
*					   	
*/
class FirmManagement_FirmController extends Zend_Controller_Action
{

	/**
	 * Instance variable of restaurant service
	 * @var object
	 */
	protected $_firmService = null;

	/**
     * Initialize the restaurant service instance.
     */
	public function init()
	{
		if(!$this->_firmService){
			$this->_firmService	= new Application_Service_Firm();
		}
	}

	/**
	 * Index Action
	 */
	public function indexAction()
	{
		// action body
	}

	/**
	 * action to add the restaurant
	 */
	public function addfirmAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->view->currentPageName = 'addfirm';
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout()->setLayout('global_settings_layout');
        //echo '<pre>'; print_r($data); exit;
				if($this->getRequest()->isPost()){
					$result = $this->_firmService->AddRestaurant($this->getRequest()->getPost());
					if($result){
						$this->view->resId = $result['resid'];
						$this->view->isSubmit_ = true;
						$this->view->companyid = $data['companyid'];
					}
				}else{
					$restownerId = new User_Model_ManagerDataMapper();
					if($data['User_Id'] != 1){
						$countrycode = $restownerId->getOwnerCountrycodebyId($data['User_Id']);
					}else{
						$countrycode = $restownerId->getOwnerCountrycodebyId($data['restownerId']);
					}
					if($countrycode){
						$form = $this->_firmService->getAddRestaurantForm();
						$formValues = array('countryCode' => $countrycode->getres_country_code());
						$form->populate($formValues);					
					}
				}
				$CountryCodeMapper = new Application_Model_CountryCodeDataMapper();
		    	$CountryCode = $CountryCodeMapper->fetchAll();
           $countrycodenew = $CountryCodeMapper->getCountryCode();
           //echo '<pre>'; print_r($countrycodenew); exit;
		    	$CodeList = array();
		    	$CodeList[] = array('key'=>'','value'=>'Select Country Flag','country'=>'');
         /*
		    	foreach($CountryCode as $listcode){
		    		$CodeList[] = array('key'=>$listcode->getCountry_dial_code(),'value'=>$listcode->getCountry_flag(),'country'=>$listcode->getId());
		    	}*/
           foreach($countrycodenew as $listcode){
             $CodeList[] = array('key'=>$listcode['key'],'value'=>$listcode['value'],'country'=>$listcode['country']);
		    	}
			    //echo '<pre>'; print_r($CodeList); exit;
		    	$this->view->codelist = $CodeList;
				$this->view->userStat = $data['Usertype'];
				$form = $this->_firmService->getAddRestaurantForm();
				$this->view->addRestform = $form;	
        $this->view->RestId = $data['RestId'];
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function addroundmenufirmAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				if($this->getRequest()->isPost()){
					$result = $this->_firmService->AddRoundMenuRestaurant($this->getRequest()->getPost());
					if($result){
						$this->view->resId = $result['resid'];
						$this->view->isSubmit_ = true;
					}
				}
				$this->view->userStat = $data['Usertype'];
				$form = $this->_firmService->getAddRoundMenuRestaurantForm();
				$this->view->addRestform = $form;	
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to manage the restaurant
	 */
	public function managefirmAction()
	{
		try{
			$this->_helper->layout()->setLayout('restaurantuserlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$page = $this->_request->getParam('page');
				if (empty($page)){
					$page = 1;
				}
				if($data['Usertype'] == "RSO" || $data['Usertype'] == "ADM" || $data['Usertype'] == "ADU"){
					$restaurantList = $this->_firmService->GetRestaurantsByOwnerId($data,$page);
				}else if($data['Usertype'] == "RSU" || $data['Usertype'] == "SRU"){
					$restaurantList = $this->_firmService->GetRestaurantsDetailsByOwnerResId($data,$page);
				}
				$this->view->restaurantList = $restaurantList;
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to edit the restaurant
	 */
	public function editfirmAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->view->currentPageName = 'editfirm';
				$request = $this->getRequest();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				
				$this->_helper->layout()->setLayout('global_settings_layout');
				if($request->restaurantid){
					$resStat = $this->_firmService->AuthenticateRestByAuth($data,$request->restaurantid);
				}else{
					$resStat = false;
				}		
				$CountryCodeMapper = new Application_Model_CountryCodeDataMapper();
		    	$CountryCode = $CountryCodeMapper->fetchAll();
       $countrycodenew = $CountryCodeMapper->getCountryCode();
		    	$CodeList = array();
		    	$CodeList[] = array('key'=>'','value'=>'Select Country Flag');
		    	 /*
		    	foreach($CountryCode as $listcode){
		    		$CodeList[] = array('key'=>$listcode->getCountry_dial_code(),'value'=>$listcode->getCountry_flag(),'country'=>$listcode->getId());
		    	}*/
          foreach($countrycodenew as $listcode){
             $CodeList[] = array('key'=>$listcode['key'],'value'=>$listcode['value'],'country'=>$listcode['country']);
		    	}
		    	$this->view->codelist = $CodeList;
				
				$this->view->restaurantid = $request->restaurantid;
				$this->view->resStPhrase = $resStat;
				if($resStat){
					if($this->getRequest()->isPost()){						
						$formArr = $this->_firmService->editRestaurantDeatails($request);
						$result = $this->_firmService->EditRestaurantDetails($this->getRequest()->getPost(),$request);
						$resultObj = $this->_firmService->viewRestaurantDetails($request);
						if($result['status']){
							$this->view->restdetails = $resultObj;
							$this->view->personalForm = $formArr['personalForm'];
							$this->view->personalmoreForm = $formArr['personalmoreForm'];
							$this->view->addressForm = $formArr['addressForm'];
							$this->view->parkingForm = $formArr['parkingForm'];
							$this->view->contactForm = $formArr['contactForm'];
							$this->view->restaurantimage = $formArr['restaurantimage'];
							$this->view->restaurantlogo = $formArr['restaurantlogo'];
						}else{
	
							if(isset($result['personalForm'])){
								$this->view->personalForm = $result['personalForm'];
								$this->view->popUpForm = 	'personalForm';
							}else{
								$this->view->personalForm = $formArr['personalForm'];
							}
							if(isset($result['personalmoreForm'])){
								$this->view->personalmoreForm = $result['personalmoreForm'];
								$this->view->popUpForm = 	'personalmoreForm';
							}else{
								$this->view->personalmoreForm = $formArr['personalmoreForm'];
							}
							if(isset($result['addressForm'])){
								$this->view->addressForm = $result['addressForm'];
								$this->view->popUpForm = 	'addressForm';
							}else{
								$this->view->addressForm = $formArr['addressForm'];
							}
							if(isset($result['parkingForm'])){
								$this->view->parkingForm = $result['parkingForm'];
								$this->view->popUpForm = 	'parkingForm';
							}else{
								$this->view->parkingForm = $formArr['parkingForm'];
							}
							if(isset($result['restaurantimage'])){
								$this->view->restaurantimage = $result['restaurantimage'];
								$this->view->popUpForm = 	'restaurantimage';
							}else{
								$this->view->restaurantimage = $formArr['restaurantimage'];
							}
							if(isset($result['restaurantlogo'])){
								$this->view->restaurantlogo = $result['restaurantlogo'];
								$this->view->popUpForm = 	'restaurantlogo';
							}else{
								$this->view->restaurantlogo = $formArr['restaurantlogo'];
							}
							
							if(isset($result['contactForm'])){
								$this->view->contactForm = $result['contactForm'];
								$this->view->popUpForm = 	'contactForm';
							}else{
								$this->view->contactForm = $formArr['contactForm'];
							}
							$this->view->restdetails = $resultObj;
						}
					}else{
						$request = $this->getRequest();
						
						$resultObj = $this->_firmService->viewRestaurantDetails($request);
						$formArr = $this->_firmService->editRestaurantDeatails($request);
						$this->view->restdetails = $resultObj;
						$this->view->personalForm = $formArr['personalForm'];
						$this->view->personalmoreForm = $formArr['personalmoreForm'];
						$this->view->addressForm = $formArr['addressForm'];
						$this->view->parkingForm = $formArr['parkingForm'];
						$this->view->restaurantimage = $formArr['restaurantimage'];
						$this->view->restaurantlogo = $formArr['restaurantlogo'];
						$this->view->contactForm = $formArr['contactForm'];	
					}
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	/**
	 * action to edit the restaurant status
	 */
	public function editfirmstatusAction()
	{
		try{
			$this->_helper->layout()->setLayout('restaurantuserlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$this->_firmService->EditRestaurantStatus($request);
				return $this->_helper->redirector('managefirm');
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function editroundmenufirmAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){				
				$request = $this->getRequest();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				if($request->restaurantid){
					$resStat = $this->_firmService->AuthenticateRestByAuth($data,$request->restaurantid);
				}else{
					$resStat = false;
				}
				$this->view->restaurantid = $request->restaurantid;
				$this->view->resStPhrase = $resStat;
				if($resStat){
					if($this->getRequest()->isPost()){						
						$formArr = $this->_firmService->editRoundMenuRestaurantDeatails($request);
						$result = $this->_firmService->EditRoundMenuRestaurantDetails($this->getRequest()->getPost(),$request);
						$resultObj = $this->_firmService->viewRestaurantDetails($request);
						if($result['status']){
							$this->view->restdetails = $resultObj;
							$this->view->personalForm = $formArr['personalForm'];
							$this->view->addressForm = $formArr['addressForm'];
						}else{
							if(isset($result['personalForm'])){
								$this->view->personalForm = $result['personalForm'];
								$this->view->popUpForm = 	'personalForm';
							}else{
								$this->view->personalForm = $formArr['personalForm'];
							}
							if(isset($result['addressForm'])){
								$this->view->addressForm = $result['addressForm'];
								$this->view->popUpForm = 	'addressForm';
							}else{
								$this->view->addressForm = $formArr['addressForm'];
							}
							$this->view->restdetails = $resultObj;
						}
					}else{
						$request = $this->getRequest();
						
						$resultObj = $this->_firmService->viewRestaurantDetails($request);
						$formArr = $this->_firmService->editRoundMenuRestaurantDeatails($request);
						$this->view->restdetails = $resultObj;
						$this->view->personalForm = $formArr['personalForm'];
						$this->view->addressForm = $formArr['addressForm'];	
					}
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to add the restaurant schedule
	 */
	/* Restaurant Schedule Management  Actions Start */
	public function displayinvAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
         $this->view->currentPageName = 'displayinv';
				$request = $this->getRequest();
				
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				if(isset($request->restaurantid)){
					$restId = $request->restaurantid;
				}else{
					$restId = $data['RestId'];
					$request->setParam('restaurantid',$restId);
				}
        
				if($restId){
					$resStat = $this->_firmService->AuthenticateRestByAuth($data,$restId);
					$schTypeResult = $this->_firmService->CheckRestaurantScheduleType($request);
					if($schTypeResult['settingType'] == 'SMC' || $schTypeResult['settingType'] == 'UL'){
						return $this->_helper->redirector('totalcount','Firm','FirmManagement',array('restaurantid'=>$request->restaurantid));
					}
					$this->view->scheduletype = $schTypeResult['settingType'];
				}else{
					$resStat = true;
				}
				$this->view->secureLoginStatus = $resStat;
        
				$floorstatus = $this->_firmService->getFloorStatusByResid($restId);
				
				if($floorstatus->ressettingstatus == false){
					$this->view->settingspage = true;
				}
				if($resStat){
					$this->_helper->layout()->setLayout('global_settings_layout');
					$operation = $request->operation;
					switch($operation){
						case 'create':
							$result = $this->_firmService->CreateSchedule($request);
							return $this->_helper->redirector('displayinv','Firm','FirmManagement',array('isSubmit'=>true,'resIsset'=>false,'restaurantid'=>$request->restaurantid));
							break;
						case 'update':
							$result = $this->_firmService->UpdateSchedule($request);
							return $this->_helper->redirector('displayinv','Firm','FirmManagement',array('isSubmit'=>true,'resIsset'=>true,'restaurantid'=>$request->restaurantid,'returnresult'=>$result,'weekday'=>$request->weekday));
							break;
						default :
							if($restId){
								$result = $this->_firmService->GetRestaurantSchedule($request);
								$AllSchDay = $this->_firmService->getRestaurantEachDayScheudleStatus($request);
								$this->view->AllSchDay = $AllSchDay['isset'];
								if(count($AllSchDay['notset']) == 7){
									return $this->_helper->redirector('addfirminventory','Firm','FirmManagement',array('restaurantid'=>$request->restaurantid,'from'=>'SL'));
								}
								$this->view->presentSchDay = $result['presentDayScheudle'];
								$this->view->schedule	  = $result['schedule'];
								$this->view->weekday	  =	$result['weekday'];
								if(isset($request->resIsset)){
									$this->view->resIsset	= $request->resIsset;
								}else{
									$this->view->resIsset	= $result['resIsset'];
								}
                                                                $this->view->inventory = $result['inventory'];	
								if(isset($request->isSubmit)){
									$this->view->isSubmit	= $request->isSubmit;
								}else{
									$this->view->isSubmit	= false;
								}
								if($request->returnresult){
									$this->view->returnresult = $request->returnresult;
								}
								$this->view->restaurantid = $restId;		
							}
							break;
					}
					$this->view->restaurantid = $restId;
					$this->view->userStat = $data['Usertype'];
					if($request->isSubmit){
						$this->view->isSubmit = $request->isSubmit;
					}
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	
	public function totalcountAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
                                $this->view->currentPageName = 'displayinv';
				$request = $this->getRequest();				
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				if(isset($request->restaurantid)){
					$restId = $request->restaurantid;
				}else{
					$restId = $data['RestId'];
					$request->setParam('restaurantid',$restId);
				}
				if($restId){
					$resStat = $this->_firmService->AuthenticateRestByAuth($data,$restId);
					$schTypeResult = $this->_firmService->CheckRestaurantScheduleType($request);
					if($schTypeResult['settingType'] == 'SL' || $schTypeResult['settingType'] == 'SAC'){
						return $this->_helper->redirector('displayinv','Firm','FirmManagement',array('restaurantid'=>$request->restaurantid));
					}
					$this->view->scheduletype = $schTypeResult['settingType'];
				}else{
					$resStat = true;
				}	
							
				$this->view->secureLoginStatus = $resStat;
				
				$floorstatus = $this->_firmService->getFloorStatusByResid($restId);							
				if($floorstatus->ressettingstatus == false){
					$this->view->settingspage = true;
				}
				
				if($resStat){
					$this->_helper->layout()->setLayout('global_settings_layout');
					$operation = $request->operation;
					switch($operation){
						case 'create':
							$result = $this->_firmService->CreateSchedule($request);
							return $this->_helper->redirector('totalcount','Firm','FirmManagement',array('isSubmit'=>true,'resIsset'=>false,'restaurantid'=>$request->restaurantid));
							break;
						case 'update':
							$result = $this->_firmService->UpdateSchedule($request);
							return $this->_helper->redirector('totalcount','Firm','FirmManagement',array('isSubmit'=>true,'resIsset'=>true,'restaurantid'=>$request->restaurantid,'returnresult'=>$result,'weekday'=>$request->weekday));
							break;
						default :
							if($restId){
								$result = $this->_firmService->GetRestaurantSMCSchedule($request, $schTypeResult['settingType']);
								$AllSchDay = $this->_firmService->getRestaurantEachDayScheudleStatus($request);
								$this->view->AllSchDay = $AllSchDay['isset'];
								if(count($AllSchDay['notset']) == 7){
									return $this->_helper->redirector('addfirminventory','Firm','FirmManagement',array('restaurantid'=>$request->restaurantid,'from'=>'SMC'));
								}
								$this->view->presentSchDay = $result['presentDayScheudle'];
								$this->view->schedule	  = $result['schedule'];
								$this->view->weekday	  =	$result['weekday'];
								if(isset($request->resIsset)){
									$this->view->resIsset	= $request->resIsset;
								}else{
									$this->view->resIsset	= $result['resIsset'];
								}
								if(isset($request->isSubmit)){
									$this->view->isSubmit	= $request->isSubmit;
								}else{
									$this->view->isSubmit	= false;
								}
								if($request->returnresult){
									$this->view->returnresult = $request->returnresult;
								}
								$this->view->restaurantid = $restId;	
							}
							break;
					}
					$this->view->restaurantid = $restId;
					$this->view->userStat = $data['Usertype'];
					if($request->isSubmit){
						$this->view->isSubmit = $request->isSubmit;
					}
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getfirminvpostAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->GetRestaurantScheduleByAjax($request);
			if($result){
				echo json_encode($result);
			}else{
				echo json_encode('f');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function totalcountpostAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->GetRestaurantSMCScheduleByAjax($request);
			if($result){
				echo json_encode($result);
			}else{
				echo json_encode('f');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function updaterestaurantinvAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->CheckRestaurantScheduleType($request);
			echo $result['settingType'];
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function holidayinvAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
                            $this->view->currentPageName = 'holidayinv';
				$request = $this->getRequest();
				
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				
				if($request->restaurantid){
					$resStat = $this->_firmService->AuthenticateRestByAuth($data,$request->restaurantid);
				}else{
					$resStat = true;
				}
				$this->view->secureLoginStatus = $resStat;
				if($resStat){
					$this->_helper->layout()->setLayout('global_settings_layout');
					if($request->isPost()){
						$formdata = $request->getPost();
						$result = $this->_firmService->CreateSpecialSchedule($formdata);
						if($result['status']){
							//$msg = $result['msg'];
							$this->_helper->redirector('manageholidayinv','Firm','FirmManagement');
						}else{
							$this->view->resform = $result['form'];
							$this->view->restaurantid = $formdata['RestaurantName'];
							$this->view->inventory = $result['inventory'];						
						}
					}else{
						if($request->restaurantid){					
							
							$result = $this->_firmService->GetRestSplScheduleInventory($request);
							$this->view->inventory    = $result['inventory'];
							
							if($request->returnresult){
								$this->view->returnresult = $request->returnresult;
							}
		
							//$this->view->schedule	  = $result['schedule'];
							$this->view->restaurantid = $request->restaurantid;	
						}	
	
						$result = $this->_firmService->RestaurantSpecialSchedule();
						$this->view->resform  = $result['form'];
						$this->view->userStat = $data['Usertype'];
					}
				}else{
					$result = $this->_firmService->RestaurantSpecialSchedule();
					$this->view->resform  = $result['form'];
					$this->view->userStat = $data['Usertype'];
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function holidayinvformvalidationAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$form = $this->_firmService->getRestSpecialScheduleForm();
	        $form->isValid($this->_getAllParams());
	        $json = $form->getMessages();
	        if(empty($json)){
	        	echo json_encode('t');
	        }else{
	        	header('Content-type: application/json');
	        	echo json_encode($json);
	        }
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function manageholidayinvAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
                            $this->view->currentPageName = 'manageholidayinv';
				$formdata = "";
				$form = new FirmManagement_Form_FirmSpecialSchedule();
				$request = $this->getRequest();
				$page = $this->_request->getParam('page');
				if (empty($page)){
					$page = 1;
				}
				$this->_helper->layout()->setLayout('global_settings_layout');
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				if($request->isPost()){
					$formdata = $this->getRequest()->getPost();
					$form->populate($formdata);
					$this->view->resform = $form;
				}
				$result = $this->_firmService->ManageSpecialSchedules($data, $formdata,$page);
				$this->view->result = $result;
				$this->view->resform = $form;
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function changeholidayinvstatusAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_firmService->UpdateSplScheduleStatus($request);
				if($result){
					echo 't';
				}else{
					echo 'f';
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function inquiryholidayinvbydateAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				if($request){
					$result = $this->_firmService->checkSplScheduleByDate($request);
					if($result){
						echo "t";
					}else{
						echo "f";
					}
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function pullholidayinvdescriptionAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			if($this->getRequest()->isPost()){
				$request = $this->getRequest();
				$result = $this->_firmService->getSplScheduleDescription($request);
				if($result){
					echo json_encode($result);
				}else{
					echo "f";
				}
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function holidayinvbyinventoryidAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				if($request->restaurantid){
					$resStat = $this->_firmService->AuthenticateRestByAuth($data,$request->restaurantid);
				}else{
					$resStat = false;
				}
				$this->view->secureLoginStatus = $resStat;
				if($resStat){
					$this->_helper->layout()->setLayout('restaurantuserlayout');
					if($request->isPost()){
						$formdata = $request->getPost();
						$result = $this->_firmService->UpdateSpecialSchedule($formdata);
						if($result){
							$this->view->msg = 'Schedule Updated Successfully';
						}
					}
					$resform = $this->_firmService->getSpecialSchedulesById($request, $data);
					$eventid = $resform['eventid'];
					$schresult = $this->_firmService->GetSpecialSchedule($request,$eventid);
					$this->view->resform 	= $resform['form'];
					$this->view->inventory  = $schresult['inventory'];
					$this->view->schedule	= $schresult['schedule'];
					$this->view->restaurantid = $request->restaurantid;
					$this->view->id = $request->id;
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function pickholidayinvbyperiodAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request	= $this->getRequest();				
				$result 	= $this->_firmService->getSpecialScheduleByDate($request);
		        echo json_encode($result);
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function pickholidayinvdatesAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request	= $this->getRequest();				
				$splDates 	= $this->_firmService->getSplScheduleDatesByResId($request);
			    echo json_encode($splDates);
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	/**
	 * action to add the restaurant schedule menu
	 */
	public function addfirminvmenuAction()
	{
		try{
			$request = $this->getRequest();
			if($request){
				$result = $this->_firmService->AddRestaurantScheduleMenu($request);
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				if($result){
					echo "t";
				}else{
					echo "f";
				}
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to create the schedule
	 */
	public function createinvAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$request = $this->getRequest();

				$result = $this->_firmService->CreateSchedule($request);

				return $this->_helper->redirector('displayinv','Firm','FirmManagement',array('isSubmit'=>$result));
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to manage the schedule
	 */
	public function manageinvAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				$result = $this->_firmService->ManageSchedule($data,$request);
				if($request->msg){
					$msg = $request->msg;
					if($msg){
						$this->view->msg = "Restaurant Schedule updated sucessfully.";
					}

				}
				$this->view->resultStr = $result['resultStr'];
				$this->view->resform = $result['resform'];

			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to update the schedule
	 */
	public function updateinvAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$request = $this->getRequest();
				$rest_id = $request->RestaurantNameHide;
				$result = $this->_firmService->UpdateSchedule($request);
				$this->_helper->redirector('manageinv','Firm','FirmManagement',array('restaurant_id'=>$rest_id,'msg'=>true));
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to retreive the restaurant menu
	 */
	public function pickfirmmenuAction()
	{
		try{
			$request = $this->getRequest();
			$restMenuList = $this->_firmService->GetRestMenu($request);
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$menuArr = array();
			foreach($restMenuList as $value){
				$menuArr[] = array('key'=>$value->getrsmid(),'value'=> $value->getrsmmenu());
			}
			if($menuArr){
				echo json_encode($menuArr);

			}else{
				echo "f";
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to add the restaurants floor 
	 */
	public function reservationareaAction()
	{
		try{
			$this->_helper->layout()->setLayout('global_settings_layout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
                            $this->view->currentPageName = 'reservationarea';
				$diningid = "";
				$floorstatus = "";
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				if(isset($request->resid)){
					$restId = $request->resid;
				}else{
					$restId = $data['RestId'];
					$request->setParam('resid',$restId);
				}
				if($restId){
					$resStat = $this->_firmService->AuthenticateRestByAuth($data,$restId);
				}else{
					$resStat = true;
				}								
				$this->view->secureLoginStatus = $resStat;
				if($resStat){
					$floorstatus = $this->_firmService->getFloorStatusByResid($restId);
					if($floorstatus->resfloorplanstatus == true){
						$this->view->floorstatus = false;						
					}else{
						$this->view->floorstatus = true;
					}
					if($floorstatus->resschestatus == true){
						$this->view->schedulestatus = false;	
					}else{
						$this->view->schedulestatus = true;	
					}
					$Diningresult = $this->_firmService->getDinigAreasByRestIdfromFloor($restId);
					if($request->diningid){
						$diningid = $request->diningid;
						foreach($Diningresult as $dining)
						{
							if($dining->rdaid == $diningid){
								$diningname = $dining->rda_diningname;
								break;
							}
						}
					}else{
						foreach($Diningresult as $dining){
							$diningid = $dining->rdaid;
							$diningname = $dining->rda_diningname;
							break;	
						}					
					} 
					$this->view->diningarea = $Diningresult;
					$this->view->diningid = $diningid;
					$this->view->diningname = $diningname;
					$resultArr   = $this->_firmService->getRestFloorPlan($restId,$diningid);
					$floorSepArr = $this->_firmService->getRestFloorSeprators($restId,$diningid);
					$this->view->resultStr   = $resultArr['finalStr'];
					$this->view->floorSepStr = $floorSepArr;
					$this->view->etnStr = $resultArr['etnStr'];
					$this->view->userStat  = $data['Usertype'];
					$this->view->resid = $restId;
					$this->view->urlResid = $restId;
					$this->view->companyid = $data['companyid'];
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function savereservationareaAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();			
			$status = $this->_firmService->saveFloorPlanAjax($request);
			if($status){
				echo json_encode($status);
			}else{
				echo json_encode('f');
			}			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	/**
	 * action to add the restaurants special
	 */
	public function firmdealAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$form = $this->_firmService->getRestaurantSpecialForm();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				if($this->getRequest()->isPost()){
					$result = $this->_firmService->ManageSpecial($this->getRequest()->getPost());
					if($result){
						return $this->_helper->redirector('managedeal');
					}
				}
				$restNameList = $this->_firmService->GetRestNameById($data);
				$form->RestaurantName->addMultiOptions($restNameList);
				$this->view->form = $form;
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to manage the restaurants special
	 */
	public function managedealAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$result = $this->_firmService->RestaurantManageSpecial($data);
				$this->view->result = $result;
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to eidt the restaurants special
	 */
	public function editfirmdealAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				if($this->getRequest()->isPost()){
					$result = $this->_firmService->EditRestaurantSpecial($this->getRequest()->getPost(),$request);
					$formArr = $this->_firmService->editRestaurantSpecialDetails($request,$data);
					$resultSpl = $this->_firmService->viewRestaurntSpecialById($request,$data);

					if($result['status']){
						$sp = $request->specialid;
						$this->view->result = $resultSpl;
						$this->view->editSplForm = $formArr['editSplForm'];
						$this->view->restSplImage = $formArr['restSplImage'];
						$this->view->restSplSch = $formArr['restSplSch'];
						$this->view->restaurantid = $request->restaurantid;
						$this->view->specialid = $request->specialid;
					}else{
						if(isset($result['editSplForm'])){
							$this->view->editSplForm = $result['editSplForm'];
							//$this->view->popUpForm = 	'editSplForm';
						}else{
							$this->view->editSplForm = $formArr['editSplForm'];
						}
						if(isset($result['restSplImage'])){
							$this->view->restSplImage = $result['restSplImage'];
							$this->view->popUpForm = 	'restSplImage';
						}else{
							$this->view->restSplImage = $formArr['restSplImage'];
						}
						if(isset($result['restSplSch'])){
							$this->view->restSplSch = $result['restSplSch'];
						}else{
							$this->view->restSplSch = $formArr['restSplSch'];
						}
						$this->view->result = $resultSpl;
					}
				}else{
					$resultSpl = $this->_firmService->viewRestaurntSpecialById($request,$data);
					$formArr = $this->_firmService->editRestaurantSpecialDetails($request,$data);
					$this->view->result = $resultSpl;
					$this->view->editSplForm = $formArr['editSplForm'];
					$this->view->restSplImage = $formArr['restSplImage'];
					$this->view->restSplSch = $formArr['restSplSch'];
					$this->view->restaurantid = $request->restaurantid;
					$this->view->specialid = $request->specialid;
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to delete the restaurants special
	 */
	public function removefirmdealAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$this->_firmService->deleteRestaurantspl($request);
				return $this->_helper->redirector('managedeal');
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	/**
	 * action to manage the restaurant contacts
	 */
        public function getusercontactsbyajaxAction()
        {
            try{
                        $offset ='';
                        $storage = new Zend_Auth_Storage_Session();
                        $data = $storage->read();
                        $auth = Zend_Auth::getInstance();
                        if($auth->hasIdentity()){
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();                        
                        $resultObj = $this->_firmService->manageUsersContacts($data, $offset, $request);  
                        echo $jsonObj = json_encode($resultObj);		        
                        }
                        else {
                          $this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));  
                        }
                        
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
        }
        public function downloadcontactsbyajaxAction(){
            try{
                $auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();				
				$request = $this->getRequest();
				$Contacts='';
                                $Contacts .= 'First Name,';
				$Contacts .= 'Last Name,';
				$Contacts .= 'Gender,';
				$Contacts .= 'Email,';
				$Contacts .= 'Phone,';
				$Contacts .= 'Address,';
				$Contacts .= 'State,';
				$Contacts .= 'City,';
                                $Contacts .= 'ZipCode,';
                                $Contacts .= 'Company,';
                                $Contacts .= 'Birthday,';
                                $Contacts .= 'Anniversary,';
                                $Contacts .= 'Opt-in Email';                                
                                $Contacts .="\n";
                                
                                $result = $this->_firmService->DownloadContactsbyAjax($request);
                                if($result){
                                   foreach($result as $row){
                                    
                                    $Contacts.='"'.$row->rgufirst_name.'",';
                                    $Contacts.='"'.$row->rgulast_name.'",'; 
                                    $Contacts.='"'.$row->rgugender.'",';
                                    $Contacts.='"'.$row->rguemail.'",';
                                    $Contacts.='"'.$row->rguphone.'",';
                                    $Contacts.='"'.$row->rguaddress.'",';
                                    $Contacts.='"'.$row->rgustate.'",';
                                    $Contacts.='"'.$row->rgucity.'",';
                                    $Contacts.='"'.$row->rguzipcode.'",';
                                    $Contacts.='"'.$row->rgucompany.'",';
                                    $Contacts.='"'.$row->rgu_birthday.'",';
                                    $Contacts.='"'.$row->rgu_anniversary.'",';
                                    $Contacts.='"'.$row->rgu_optinemail.'"';                                    
                                    $Contacts.="\n";
                                    
                                    } 
                                }                                                                																				
				header("Content-type: application/x-msdownload");
				header("Content-Disposition: attachment; filename=Contacts.csv");
				header("Pragma: no-cache");
				header("Expires: 0");
				echo $Contacts;					
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}                                
                 }catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
        }
        
         public function changecondetailsbyidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			if($request->customerid){
				$result = $this->_firmService->updateContactDetails($request);
				echo json_encode($result);

			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
        public function manageguestlistAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$form = $this->_firmService->getAddUserContactForm();
				$searchform = $this->_firmService->getFilterUserContactForm();
				$excelform = $this->_firmService->getExcelImportForm();
				$storage = new Zend_Auth_Storage_Session();
				$page = $this->_request->getParam('page');
//				if (empty($page)){
//					$page = 1;
//				}
				$data = $storage->read();
				$request = $this->getRequest();
				$this->view->restaurantid = $request->restaurantid;
				if($data['Usertype'] == "RSO" || $data['Usertype'] == "ADM" || $data['Usertype'] == "ADU"){
					$restNameList = $this->_firmService->GetRestNameById($data);
				}else if($data['Usertype'] == "RSU"){
					$restNameList = $this->_firmService->GetRestNameById($data);
				}else if($data['Usertype'] == "SRU"){
					$restNameList = $data['restList'];
				}
				$bookService = new Application_Service_Reservation();
				$makereservform = $bookService->getMakeReservationForm();
				$this->view->MakeResForm   = $makereservform;
				$restDataMapper = new FirmManagement_Model_FirmDataMapper();
				$countrycode = $restDataMapper->getCountrycodebyId($request->restaurantid);
				if($countrycode){
					$formValues = array('countryCode' => $countrycode);
					$this->view->countrycode = $countrycode;
					$makereservform->populate($formValues);
				}
				
				$CountryCodeMapper = new Application_Model_CountryCodeDataMapper();
		    	$CountryCode = $CountryCodeMapper->fetchAll();
		    	$CodeList = array();
		    	$CodeList[] = array('key'=>'','value'=>'Select Country Flag');
		    	foreach($CountryCode as $listcode){
		    		$CodeList[] = array('key'=>$listcode->getCountry_dial_code(),'value'=>$listcode->getCountry_flag());
		    	}
		    	$this->view->codelist = $CodeList;
				
				$SpecialStatusMapper = new Application_Model_SpecialStatusDataMapper();
		    	$SpecialStatus = $SpecialStatusMapper->fetchAll();
		    	$splstatusList = array();
		    	$splstatusList[] = array('key'=>'','value'=>'Select Status');
		    	foreach($SpecialStatus as $spllist){
		    		$splstatusList[] = array('key'=>$spllist->getId(),'value'=>$spllist->getDescription());
		    	}
		    	$this->view->splstatusList = $splstatusList;
                            $filteredrec=true;
				if($this->getRequest()->isPost()){                                    
					if($request->formstatus == 'search'){
						$result = $this->_firmService->filterUsercontact($this->getRequest()->getPost(),$data,$request);
						if($result){
                                                        if($result['result']){
                                                        $this->view->result = $result['result'];
                                                        }else{
                                                           $searchform->formbirthday->setValue(''); 
                                                           $searchform->formanniversary->setValue('');
                                                           $searchform->formsepcialday->setValue('');
                                                        }							
                                                        $this->view->resultcount = $result['guestcount'];
                                                        $this->view->filterrecord = $filteredrec;
							
						}
						
						$this->view->excelform = $excelform;					
                                                $searchform->formspecialstatus->addMultiOptions($splstatusList);
                                                $this->view->searchform = $searchform;
						$this->view->form = $form;
					}
					if($request->formstatus == 'addcontact'){
						$result = $this->_firmService->AddUserContact($this->getRequest()->getPost(),$data);
						if($result['status']){
							return $this->_helper->redirector('manageguestlist','Firm','FirmManagement',array('restaurantid'=>$request->restaurantid));
						}else{
							$this->view->form = $result['usercontact'];
							$this->view->popUpForm = 'usercontact';
							$searchform->formspecialstatus->addMultiOptions($splstatusList);
							$this->view->searchform = $searchform;
							$result = $this->_firmService->manageUsersContacts($data,$page,$request);
							$this->view->result = $result;
							$excelform->ExcelRestaurantName->addMultiOptions($restNameList);
							$this->view->excelform = $excelform;
						}
					}
					if($request->formstatus == 'addexcel'){
						$result = $this->_firmService->getDetailsExcel($this->getRequest()->getPost(),$data);
						if($result){
							return $this->_helper->redirector('manageguestlist','Firm','FirmManagement',array('restaurantid'=>$request->restaurantid));
						}
					}
				}else{
					$restDataMapper = new FirmManagement_Model_FirmDataMapper();
					$countrycode = $restDataMapper->getCountrycodebyId($request->restaurantid);
					if($countrycode){
						$formValues = array('countryCode' => $countrycode);
						$form->populate($formValues);					
					}
					
					$form->RestaurantName->addMultiOptions($restNameList);
					$this->view->form = $form;
					$searchform->formspecialstatus->addMultiOptions($splstatusList);
					$this->view->searchform = $searchform;
					if(count($restNameList) >1){
						$result = $this->_firmService->manageUsersContacts($data,$page,$request);
						if($result){                                                    
							$this->view->result = $result['result'];
                                                        $this->view->resultcount = $result['guestcount'];
						}	
					}
					$excelform->ExcelRestaurantName->addMultiOptions($restNameList);
					$this->view->excelform = $excelform;
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to eidt the restaurant contacts
	 */
	public function updateguestlistAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$form = $this->_firmService->getAddUserContactForm();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$userid = $data['User_Id'];
				if($this->getRequest()->isPost()){
					$result = $this->_firmService->EditUserContact($this->getRequest()->getPost(),$data);
					if($result['status']){
						return $this->_helper->redirector('manageguestlist');
					}else{
						$this->view->form = $result['form'];
					}
				}else{
					$request = $this->getRequest();
					$form = $this->_firmService->GetUserContactById($request,$data);
					$this->view->form = $form;
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to delete the restaurant contacts
	 */
	public function removeguestlistAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$this->_firmService->deleteUserContact($request);
				return $this->_helper->redirector('manageguestlist');
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to manage the restaurant groups
	 */
	public function guesttypemanagementAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				
				$form = $this->_firmService->getAddGroupForm();
				$searcform = $this->_firmService->getSearchUserContactForm();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				if($request->restaurantid){
					$resStat = $this->_firmService->AuthenticateRestByAuth($data,$request->restaurantid);
				}else{
					$resStat = true;
				}
				$this->view->secureLoginStatus = $resStat;
				if($resStat){
					$this->_helper->layout()->setLayout('restaurantuserlayout');
					$userid = $data['User_Id'];
					
					if($this->getRequest()->isPost()){
						$result = $this->_firmService->AddGroup($this->getRequest()->getPost(),$data);
						if($result['status'])
						{
							return $this->_helper->redirector('guesttypemanagement','Firm','FirmManagement',array('restaurantid'=>$request->restaurantid));
						}else{
							if($data['Usertype'] == "RSO" || $data['Usertype'] == "ADM" || $data['Usertype'] == "ADU"){
								$restNameList = $this->_firmService->GetRestNameById($data);
							}else if($data['Usertype'] == "RSU"){
								$restNameList = $this->_firmService->GetRestNameById($data);
							}else if($data['Usertype'] == "SRU"){
								$restNameList = $data['restList'];
							}
							$this->view->restaurantNameList = $restNameList;
							$this->view->form = $result['groupfrom'];
							$this->view->popUpForm = 'groupfrom';
						}
					}else{
						if($data['Usertype'] == "RSO" || $data['Usertype'] == "ADM" || $data['Usertype'] == "ADU"){
							$restNameList = $this->_firmService->GetRestNameById($data);
						}else if($data['Usertype'] == "RSU"){
							$restNameList = $this->_firmService->GetRestNameById($data);
						}else if($data['Usertype'] == "SRU"){
							$restNameList = $data['restList'];
						}
						$this->view->restaurantNameList = $restNameList;
						$form->RestaurantName->addMultiOptions($restNameList);
						$this->view->form = $form;
						$searcform->restaurantName->addMultiOptions($restNameList);
						$this->view->searchform = $searcform;
						if($request->restaurantid){
							$restid = $request->restaurantid;
							$groupList = $this->_firmService->getRestaurantGroupsById($restid);
							$this->view->groupNameList = $groupList;
							$this->view->restaurantid = $restid;
						}
					}
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to edit the restaurant group
	 */
	public function editguesttypeAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$form = $this->_firmService->getAddGroupForm();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				$userid = $data['User_Id'];
				if($this->getRequest()->isPost()){
					$result = $this->_firmService->EditGroupDetails($this->getRequest()->getPost(),$data);
					if($result['status']){
						return $this->_helper->redirector('guesttypemanagement','Firm','FirmManagement',array('restaurantid'=>$request->restaurantid));
					}else{
						$this->view->form = $result['groupfrom'];
					}
				}else{
					$request = $this->getRequest();
					$form = $this->_firmService->GetUserGroupById($request,$data);
					$this->view->form = $form;
				}
				$this->view->restaurantid = $request->restaurantid;
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to delete the restaurant group
	 */
	public function deleteguesttypeAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$this->_firmService->deleteUserGroup($request);
				return $this->_helper->redirector('guesttypemanagement','Firm','FirmManagement',array('restaurantid'=>$request->restaurantid));
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	// Commented to introduce Regions
	public function pickcitysbycountryidAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$resultObj = $this->_firmService->getCitysByStateId($request);
			$jsonObj = json_encode($resultObj->getCityList());
			echo $jsonObj;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	} 

	public function pickcitiesbycountryidandstateidAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$resultObj = $this->_firmService->GetCitiesByStateAndRegionId($request);
			$jsonObj = json_encode($resultObj);
			echo $jsonObj;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function pickcountrysbyajaxAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$resultObj = $this->_firmService->getStatesInfo();
			$jsonObj = json_encode($resultObj);
			echo $jsonObj;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function pickstatesbycountryidAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$resultObj = $this->_firmService->getRegionsByStateId($request);
			$jsonObj = json_encode($resultObj->getRegionList());
			echo $jsonObj;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function pickcitybystateidAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$resultObj = $this->_firmService->getCitysByRegionId($request);
			$jsonObj = json_encode($resultObj->getCityList());
			echo $jsonObj;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action retreive the neighbourhood basedata using city id
	 */
	public function picklocalityidbycityidAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$resultObj = $this->_firmService->getNghIdCidyId($request);
			$jsonObj = json_encode($resultObj->getNeighborhoodList());
			echo $jsonObj;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to manage the restaurant details
	 */
	public function firmdetailsAction()
	{
		try{
			$request = $this->getRequest();
			$resultObj = $this->_firmService->restaurantDetails($request);
			$this->view->restdetails = $resultObj;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to retreive the restaurant type using restaurant id using ajax call
	 */
	public function firmtypebyfirmidAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$restid = $request->restaurantid;
			$result = $this->_firmService->getRestaurantTypeById($restid);
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to check the unique ness of the special
	 */
	public function checkdealexistAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$restaurantSpl = new FirmManagement_Model_FirmSpecial();
			$restaurantSpl->setSpecialtitle(trim($request->specialTitle));
			$restaurantSpl->setRestaurantid(trim($request->restaurantid));
			$result = $this->_firmService->CheckUnique($restaurantSpl);
			if($result){
				echo "t";
			}else{
				echo "f";
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	/**
	 * action to retreive the restaurant timings
	 */
	public function firmmakeupAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->RestaurantTimings($request);

			if($result){
				echo json_encode($result);
			}else{
				echo json_encode("f");
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to retreive the restaurant timings for freeze
	 */
	public function pickfirmblockedintervelsAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->GetRestaurantTimingsFreeze($request);

			if($result){
				echo json_encode($result);
			}else{
				echo json_encode("f");
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to retreive the reservations and timings
	 */
	public function pickfirmslotsandbookingsAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$reservResult = $this->_firmService->RestaurantReservationsCount($request);
			if($reservResult){
				$tempArr = $reservResult;
				$timeArr = array();
				foreach($tempArr as $key=>$value){							
					$time = explode(":",$key);
					//if($time[0] >= 9){
						$s = mktime($time[0],0,0,0,0,0);
						$startTime =  date("h:i A",$s);
						if($timeArr){
							if(array_key_exists($startTime,$timeArr)){
								$timeArr[$startTime] = $timeArr[$startTime]+$value;
							}else{
								$timeArr[$startTime] = $value;
							}
						}else{
							$timeArr[$startTime] = $value;
						}	
					//}
				}
				$x = json_encode($timeArr);
				echo json_encode($timeArr);
			}else{
				echo json_encode("f");
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to retreive the groups by restaurnant id using ajax-call
	 */
	public function pickguesttypebyfirmidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$restid = $request->restaurantid;
			$resultList = $this->_firmService->getRestaurantGroupsById($restid);

			echo json_encode($resultList);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to delete the schedule using ajax-call
	 */
	public function removeinvpostAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->DeleteScheduleAjax($request);
			echo $result;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function removetotalcountpostAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->DeleteSMCScheduleAjax($request);
			echo $result;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	/**
	 * action to delete the inventory using ajax-call 
	 */
	public function removeinventroypostAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->DeleteInventoryAjax($request);
			if($result){
				echo 1;
			}else{
				echo 0;
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to check the table staus
	 */
	public function verifytablestatusAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->CheckBokStatus($request);
			if($result){
				echo "t";
			}else{
				echo "f";
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to check the inventory count using ajax-call 
	 */
	public function verifyinventorycountpostAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$count = $request->count;
			$result = $this->_firmService->CheckInventoryCountAjax($request);
			echo $result;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to check the group name 
	 */
	public function verifyguesttypeexistAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();

			$result = $this->_firmService->CheckGroupName($request);
			if($result){
				echo "t";
			}else{
				echo "f";
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to check the unique-ness of the restaurant name 
	 */
	public function verifyfirmnameexsitAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();

			$result = $this->_firmService->CheckRestaurantName($request);
			if($result){
				echo "t";
			}else{
				echo "f";
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	/**
	 * action to retreive restaurant details for search using ajax-call 
	 */
	public function findfirmtimeandperiodbyajaxAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$text = $request->inputtext;
			$result = $this->_firmService->getRestaurantNamesTimeSearch($text,$request);
			$list = array();
			$finallist = null;
			if(isset($result)){
				foreach($result as $key=>$value){
					$list[] = array('res' => array("key"=>$key,"value"=>$value));
				}
			}
			$resListArr = array('reslist'=>$list);
			$resJson = json_encode($resListArr);
			echo $resJson;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}

	}
	
	/**
	 * action to retreive restaurant details using restaurant id
	 */
	public function firmdetailsbyidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$resid = $request->restaurantid;
			if($request->restaurantid){
				$result = $this->_firmService->GetRestaurantDetailsArr($request);
				echo json_encode($result);

			}
			//$this->_helper->redirector('addfirm','Firm','FirmManagement',array('restaurantid' => $resid));
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}

	}

	/**
	 * action to manage overbooking password 
	 */
	public function reservationauthpasswordAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$request = $this->getRequest();
				$data = $storage->read();
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$form = $this->_firmService->getOverBookedPasswordForm();
				if($this->getRequest()->isPost()){
					if($data['Usertype'] == 'ADM' || $data['Usertype'] == 'ADU'){
						$result = $this->_firmService->OverBookedPassword($this->getRequest()->getPost(),$data['restownerId']);
					}else{
						$result = $this->_firmService->OverBookedPassword($this->getRequest()->getPost(),$data['User_Id']);
					}
					if($result['status'] == true){
						$this->view->passwordmsg = $result['msg'];
					}
				}
				if($data['Usertype'] == "RSO" || $data['Usertype'] == 'ADM' || $data['Usertype'] == 'ADU'){
					$restNameList = $this->_firmService->GetRestNameById($data);
				}else if($data['Usertype'] == "RSU"){
					$restNameList = $this->_firmService->GetRestNameById($data);
				}else if($data['Usertype'] == "SRU"){
					$restNameList = $data['restList'];
				}
				$form->RestaurantName->addMultiOptions($restNameList);
				$this->view->form = $form;
				$this->view->restaurantid = $request->restaurantid;
					
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to manage the role permissions  
	 */
	public function userlevelaccessmanagementAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
      
			if($auth->hasIdentity()){
         $this->view->currentPageName = 'userlevelaccessmanagement';
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
        
				if($request->restaurantid){
					$resStat = $this->_firmService->AuthenticateRestByAuth($data,$request->restaurantid);
				}else{
					$resStat = true;
				}
				$this->view->secureLoginStatus = $resStat;
				
				$CountryCodeMapper = new Application_Model_CountryCodeDataMapper();
   	    $CountryCode = $CountryCodeMapper->fetchAll();
        
		    	$CodeList = array();
		    	$CodeList[] = array('key'=>'','value'=>'Select Country Flag');
		    	foreach($CountryCode as $listcode){
		    		$CodeList[] = array('key'=>$listcode->getCountry_dial_code(),'value'=>$listcode->getCountry_flag());
		    	}
			    	
		    	$this->view->codelist = $CodeList;
				if($resStat){
					$this->_helper->layout()->setLayout('global_settings_layout');
					$form = $this->_firmService->getRolePermissionsForm();
					$editform = $this->_firmService->getEditRolePermissionsForm();
					 
					$page = $this->_request->getParam('page');
					if (empty($page)){
						$page = 1;
					}
					if($this->getRequest()->isPost()){
						if($request->frmstatus == "ADD"){
							$resid = $request->restaurantid;
							$result = $this->_firmService->AddUserPermissons($this->getRequest()->getPost(),$data);
							if($result['status']){
								return $this->_helper->redirector('userlevelaccessmanagement','Firm','FirmManagement',array('restaurantid'=>$request->restaurantid));
							}else{
								$restNameList = $this->_firmService->GetRestNameById($data);
								$this->view->restaurantNameList = $restNameList;
								$this->view->form = $result['addrole'];
								$this->view->popUpForm = 'groupfrom';
							}
						}else if($request->frmstatus == "EDIT"){
							$result	= $this->_firmService->EditUserPermissions($this->getRequest()->getPost(),$data);
							if($result['status']){
								return $this->_helper->redirector('userlevelaccessmanagement','Firm','FirmManagement',array('restaurantid'=>$request->editRestaurantName));
							}else{
								$restNameList = $this->_firmService->GetRestNameById($data);
								$this->view->restaurantNameList = $restNameList;
								$this->view->editform = $result['addrole'];
								$this->view->editpopUpForm = 'groupfrom';
							}
						}
					}
					if($request->frmstatus == "DEL"){
						$resid = $request->restaurantid;
						$roleid = $request->roleid;
						$roles = $this->_firmService->deleteRolesByRoleId($resid,$roleid);
						return $this->_helper->redirector('userlevelaccessmanagement','Firm','FirmManagement',array('restaurantid'=>$request->restaurantid));
	
					}
					if($data['Usertype'] == "RSO" || $data['Usertype'] == "ADM" || $data['Usertype'] == "ADU"){
						$restNameList = $this->_firmService->GetRestNameById($data);
            
					}else if($data['Usertype'] == "RSU"){
						$restNameList = $this->_firmService->GetRestNameById($data);
					}else if($data['Usertype'] == "SRU"){
						$restNameList = $data['restList'];
					}
					$editform->editRestaurantName->addMultiOptions($restNameList);
					$form->RestaurantName->addMultiOptions($restNameList);
					if($request->restaurantid){
						$roles = $this->_firmService->getAllRolesByRestId($request->restaurantid, $page);
						$this->view->rolevalues = $roles;
						$form->setDefaults(array('RestaurantName'=>$request->restaurantid));
					}
					$this->view->resUsersList = $this->_firmService->getUsersByResId($request->restaurantid);
           
					$userServ = new Application_Service_Client();
					$restUserform = $userServ->getEditRestUserProfileForm();
					$roles = $this->_firmService->getRolesByRestId($request->restaurantid);
           
					$roleList = array();
					if($roles){
						foreach($roles as $role){
							$roleList[] = array('key'=>$role['roleid'],'value'=>$role['rolecode']);
						}
					}
           
					$restUserform->EditRestaurantName->addMultiOptions($restNameList);
					$restUserform->RestaurantRole->addMultiOptions($roleList);
					$this->view->restUserform = $restUserform;
					$restDataMapper = new FirmManagement_Model_FirmDataMapper();
					$countrycode = $restDataMapper->getCountrycodebyId($request->restaurantid);
					$addrestUserform = $userServ->getRestaurantUserFrom();
					if($countrycode){
						$formValues = array('countryCode' => $countrycode);
						$addrestUserform->populate($formValues);						
						$this->view->countryCode = $countrycode;
					}
					$addrestUserform->RestaurantNameSel->addMultiOptions($restNameList);
					$addrestUserform->setDefaults(array('RestaurantName'=>$request->restaurantid));
					$this->view->addrestUserform = $addrestUserform;
					
					$this->view->resnamelist = $restNameList;
					$this->view->form = $form;
					$this->view->editform = $editform;
					$this->view->restaurantid = $request->restaurantid;
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function retreiveuserinfobyaccessidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();	
			$request = $this->getRequest();
			$RestUserProfile= $this->_firmService->getUserDetailsByRole($request);
			echo json_encode($RestUserProfile);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function updateuserinfobyaccessidAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();	
				$userServ = new Application_Service_Client();
				$result = $userServ->editUserDetailsByRole($this->getRequest()->getPost(),$data,$request);
				if($result){
					echo 't';
				}else{
					echo 'f';
				}
				
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}	
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function adduserinfobyaccessidAction()
	{ 
		try{
			$auth = Zend_Auth::getInstance();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();	
				$userServ = new Application_Service_Client();
        
				$result = $userServ->addRestUserByRole($this->getRequest()->getPost(),$data,$request);
        //echo '<pre>'; print_r($result); exit;
				if($result){
					echo 't';
				}else{
					echo 'f';
				}
				
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage());
		}
	}
	
	public function userlevelaccesslistAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();			
			$result = $this->_firmService->getPermissionsList();
			if($result){
				echo json_encode($result);
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function modifyaccessstatusAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->changeRoleStatus($request);
			return $this->_helper->redirector('userlevelaccessmanagement','Firm','FirmManagement',array('restaurantid'=>$request->restaurantid));
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}	
	}
	/**
	 * action to check the role names 
	 */
	public function verifyaccesssnameexistAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();

			$result = $this->_firmService->CheckRoleName($request);
			if($result){
				echo "t";
			}else{
				echo "f";
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to check the role asignments 
	 */
	public function authenticateaccessnameAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$roles = $this->_firmService->CheckRoleAsignById($request);
			if($roles){
				echo 't';
			}else{
				echo 'f';
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * action to retreive roles by restaurant id
	 */
	public function retreiveaccesslistbyfirmidpostAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$resid = $request->restaurantid;
			$roles = $this->_firmService->getRolesByRestId($resid);
			if($roles){
				echo json_encode($roles);
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}

	}

	/**
	 * action to retreive role details by role id
	 */
	public function retreiveaccesslistbyaccessnameidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$roleid = $request->roleid;
			$roles = $this->_firmService->getRolesByRoleId($roleid);
			echo json_encode($roles);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	/**
	 * action to manage notification status
	 */
	public function communicationstateAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$this->_firmService->ManageNotificationStatus($request);
				if($request->from){
					$this->_helper->redirector('managefirm','Firm','FirmManagement');
				}else{
					$this->_helper->redirector('acctandfirmdetailsofmanager','Client','User');
				}	
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	/**
	 * action to download the excel for restaurant contacts 
	 */
	public function guestlisttemplateAction()
	{
		$this->_helper->layout->disableLayout();
		$this->_helper->viewRenderer->setNoRender();
		$request = $this->getRequest();
		if($request){
			$file = 'excelcontacts/RestContacts.xls';
			$size = filesize($file);		
			if (file_exists($file))
			{
				header("Content-type: application/force-download");
				header("Content-Transfer-Encoding: Binary");
				header('Content-Length: '.$size);
				header("Content-disposition: attachment; filename=".basename($file));
				readfile($file);
	
			}			
		}
	}
	
	public function exportguestlistAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				$list = $this->_firmService->GetRestUsersContacts($data);
				$Contacts = "";
				$Arr = array();
				$Arr[] = 'First Name';
				$Arr[] = 'Last Name';
				$Arr[] = 'Gender';
				$Arr[] = 'Email';
				$Arr[] = 'Phone';
				$Arr[] = 'Address';
				$Arr[] = 'State';
				$Arr[] = 'City';
				$Arr[] = 'ZipCode';
				$Arr[] = 'Company';
				$Arr[] = 'Birthday';
				$Arr[] = 'Anniversary';
				$Arr[] = 'Opt-in Email';
				$Contacts .= join(',',$Arr)."\n";
				if($list){
					foreach($list as $value){
						$Arr = array();
						$Arr[] = $value->rgufirst_name;
						$Arr[] = $value->rgulast_name;
						$Arr[] = $value->rgugender;
						$Arr[] = $value->rguemail;
						$Arr[] = $value->rguphone;
						$Arr[] = $value->rguaddress;
						$Arr[] = $value->state;
						$Arr[] = $value->city;
						$Arr[] = $value->rguzipcode;
						$Arr[] = $value->rgucompany;
						$Arr[] = $value->rgu_birthday;
						$Arr[] = $value->rgu_anniversary;
						if($value->rgu_optinemail){
							$Arr[] = 'True';
						}else{
							$Arr[] = 'False';
						}
						$Contacts .= join(',',$Arr)."\n";
					}
				}				
				// Output the headers to download the file
				header("Content-type: application/x-msdownload");
				header("Content-Disposition: attachment; filename=RestaurantContacts.csv");
				header("Pragma: no-cache");
				header("Expires: 0");
				echo $Contacts;					
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}		
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to retreive the open slots for reservations
	 */
	public function pickvacantslotsAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$resultSet = array();
			$result = $this->_firmService->getNoofTablesandPaxByTimes($request);
			
			if($result){
				echo json_encode($result);
			}else{
				echo json_encode("f");
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function pickbookedslotsAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$resultSet = array();
			$result = $this->_firmService->getReservedSlots($request);
			
			if($result){
				echo json_encode($result);
			}else{
				echo json_encode("f");
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to retreive the open slots for max count setting
	 */
	public function pickvacantslotsformaxcountAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$resultSet = array();
			$result = $this->_firmService->getOpenSlotsForMaxCountSetting($request);
			
			if($result){
				echo json_encode($result);
			}else{
				echo json_encode("f");
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function retreiveinventorysearchmessageAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->getRestaurantTimeSearchMessage($request->resid);
			echo $result->resbooking_search_msg;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function managefirmtimesearchmsgAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->FirmManagementTimeSearchMessage($request);
			echo $result;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function vacantslotsformaximumcountfrmweeksightAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$resultSet = array();
			$result = $this->_firmService->getOpenSlotsForMaxCountFromWeekView($request);
			
			if($result){
				echo json_encode($result);
			}else{
				echo json_encode("f");
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to retreive notifications using id
	 */
	public function retreivecommunicationsbyidAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$notifications = $this->_firmService->getNotificationsByOwnerId($data);
				$this->view->notifications = $notifications;			
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to retreive notification details using id
	 */
	public function retreivecommunicationinfobyidAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$request = $this->getRequest();
				$msgid = $request->msgid;
				$email_mapper = new Communication_Model_EmailMessageDataMapper();
				$msgid = $email_mapper->GetMsgIdByPhrase($msgid);
			
				$service = new Application_Service_Communication();
				$result = $service->GetTitleandMessageById($msgid);
				$this->view->title = $result['title'];	
				$this->view->message = $result['Message'];			
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to retreive restaurant timezone 
	 */
	public function pickfirmtimebeltAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$timezone = $this->_firmService->GetRestaurantTimeZone($request->resid);
			date_default_timezone_set($timezone);
			$selDate = $request->selDate;
			$selDateArr = explode('-',$selDate);
			$selDateSec = mktime(0,0,0,$selDateArr[0],$selDateArr[1],$selDateArr[2]);
			$todDate = date('m-d-Y');
			$todDateArr = explode('-',$todDate);
			$todDateSec = mktime(0,0,0,$todDateArr[0],$todDateArr[1],$todDateArr[2]);
			if($selDateSec == $todDateSec){
				$dateArr = explode("-",$selDate);
				$resTime = date('H:i:s');
				$resTimearr = explode(':',$resTime);
				$selTime = date("H:i:s",strtotime($request->selTime));
				$selTimeArr = explode(':',$selTime);
				$resTimeSec = mktime($resTimearr[0],$resTimearr[1],$resTimearr[2],$dateArr[0],$dateArr[1],$dateArr[2]);
				$selTimeSec = mktime($selTimeArr[0],$selTimeArr[1],$selTimeArr[2],$dateArr[0],$dateArr[1],$dateArr[2]);
				if($selTimeSec < $resTimeSec){
					echo 'f';
				}else{
					echo 't';
				}
			}else{
				echo 't';
			}
				
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function pickfirmtimebeltsocialwidgetAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$timezone = $this->_firmService->GetRestaurantTimeZone($request->resid);
			date_default_timezone_set($timezone);
			$selDate = $request->selDate;
			$selDateArr = explode('-',$selDate);
			$selDateSec = mktime(0,0,0,$selDateArr[0],$selDateArr[1],$selDateArr[2]);
			$todDate = date('m-d-Y');
			$todDateArr = explode('-',$todDate);
			$todDateSec = mktime(0,0,0,$todDateArr[0],$todDateArr[1],$todDateArr[2]);
			if($selDateSec == $todDateSec){
				$dateArr = explode("-",$selDate);
				$resTime = date('H:i:s');
				$resTimearr = explode(':',$resTime);
				$selTime = date("H:i:s",strtotime($request->selTime));
				$selTimeArr = explode(':',$selTime);
				$resTimeSec = mktime($resTimearr[0],$resTimearr[1],$resTimearr[2],$dateArr[0],$dateArr[1],$dateArr[2]);
				$selTimeSec = mktime($selTimeArr[0],$selTimeArr[1],$selTimeArr[2],$dateArr[0],$dateArr[1],$dateArr[2]);
				if($selTimeSec < $resTimeSec){
					echo 'f';
				}else{
					echo 't';
				}
			}else{
				echo 't';
			}
				
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to add the dining area
	 */
	public function addfloorareaAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->AddDiningArea($request);
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	/**
	 * action to edit the dining area
	 */
	public function updatefloorareaAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->EditDiningArea($request);
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to edit dining area status
	 */
	public function updatefloorareastatusAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->EditDiningAreaStatus($request);
			if($result){
				return $this->_helper->redirector('reservationarea','Firm','FirmManagement',array('resid'=>$request->resid));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to add facebook page id for the restaurant
	 */
	public function addsocialidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->AddFacebookPageId($request);
			if($result){
				if($request->from){
					return $this->_helper->redirector('managefirm','Administrator','Admin');
				}else{
					return $this->_helper->redirector('pluginthemesmanagement','Firm','FirmManagement',array('restaurantid'=>$request->restid));
				}
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to edit facebook page id for the restaurant
	 */
	public function updatesocialidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->EditFacebookPageId($request);
			if($result){
				if($request->from){
					return $this->_helper->redirector('managefirm','Administrator','Admin');
				}else{
					return $this->_helper->redirector('pluginthemesmanagement','Firm','FirmManagement',array('restaurantid'=>$request->restid));
				}
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to retreive facebook page id using restaurant id
	 */
	public function retreivesocialidbyfirmidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->GetFacebookPageIdByRestId($request);
			if($result){
				echo json_encode($result);
			}else{
				echo json_encode("f");
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to retreive restaurant information using facebook page id
	 */
	public function firmdetailsbysocialidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->GetRestaurantInfoByFBPageid($request);
			if($result){
				echo json_encode($result);
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function adddealsocialidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->AddFacebookDealPageId($request);
			if($result){
				if($request->from){
					return $this->_helper->redirector('managefirm','Administrator','Admin');
				}else{
					return $this->_helper->redirector('pluginthemesmanagement','Firm','FirmManagement',array('restaurantid'=>$request->restid));
				}
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to edit facebook page id for the restaurant
	 */
	public function updatedealsocialidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->EditFacebookDealPageId($request);
			if($result){
				if($request->from){
					return $this->_helper->redirector('managefirm','Administrator','Admin');
				}else{
					return $this->_helper->redirector('pluginthemesmanagement','Firm','FirmManagement',array('restaurantid'=>$request->restid));
				}
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to retreive facebook page id using restaurant id
	 */
	public function retreivedealsocialidbyfirmidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->GetFacebookDealPageIdByRestId($request);
			if($result){
				echo json_encode($result);
			}else{
				echo json_encode("f");
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to retreive restaurant information using facebook page id
	 */
	public function firmdetailsbydealsocialidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->GetRestaurantInfoByFBDealPageid($request);
			if($result){
				echo json_encode($result);
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function addmenusocialidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->AddFacebookMenuPageId($request);
			if($result){
				if($request->from){
					return $this->_helper->redirector('managefirm','Administrator','Admin');
				}else{
					return $this->_helper->redirector('pluginthemesmanagement','Firm','FirmManagement',array('restaurantid'=>$request->restid));
				}
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to edit facebook page id for the restaurant
	 */
	public function updatemenusocialidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->EditFacebookMenuPageId($request);
			if($result){
				if($request->from){
					return $this->_helper->redirector('managefirm','Administrator','Admin');
				}else{
					return $this->_helper->redirector('pluginthemesmanagement','Firm','FirmManagement',array('restaurantid'=>$request->restid));
				}
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to retreive facebook page id using restaurant id
	 */
	public function retreivemenusocialidbyfirmidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->GetFacebookMenuPageIdByRestId($request);
			if($result){
				echo json_encode($result);
			}else{
				echo json_encode("f");
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to retreive restaurant information using facebook page id
	 */
	public function firmdetailsbymenusocialidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->GetRestaurantInfoByFBMenuPageid($request);
			if($result){
				echo json_encode($result);
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function addreservationsocialidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->AddFacebookBookingPageId($request);
			if($result){
				if($request->from){
					return $this->_helper->redirector('managefirm','Administrator','Admin');
				}else{
					return $this->_helper->redirector('pluginthemesmanagement','Firm','FirmManagement',array('restaurantid'=>$request->restid));
				}
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to edit facebook page id for the restaurant
	 */
	public function updatereservationsocialidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->EditFacebookBookingPageId($request);
			if($result){
				if($request->from){
					return $this->_helper->redirector('managefirm','Administrator','Admin');
				}else{
					return $this->_helper->redirector('pluginthemesmanagement','Firm','FirmManagement',array('restaurantid'=>$request->restid));
				}
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to retreive facebook page id using restaurant id
	 */
	public function retreivereservationsocialidbyfirmidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->GetFacebookBookingPageIdByRestId($request);
			if($result){
				echo json_encode($result);
			}else{
				echo json_encode("f");
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to retreive restaurant information using facebook page id
	 */
	public function firmdetailsbyreservationsocialidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->GetRestaurantInfoByFBBookingPageid($request);
			if($result){
				echo json_encode($result);
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	/**
	 * action to create message
	 */
	public function createmessageAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				if($data['Usertype'] == 'RSO'){
					if($this->getRequest()->isPost()){
						$result = $this->_firmService->createMessage($request,$data);
					}
					$result = $this->_firmService->getMessagesById($data);
					$this->view->message = $result;
				}else if($data['Usertype'] == 'RSU' || $data['Usertype'] == 'SRU'){
					$Msgresult = $this->_firmService->getReceivedMessagesById($data);
					$this->view->message = $Msgresult;
				}
				$this->view->usertype = $data['Usertype'];
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * action to retreive message using id
	 */
	public function getmessagebyidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->getMessageDescriptionById($request);
			if($result){
				echo json_encode($result);
			}			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function modifyfirmemailmodebyajaxAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_firmService->changeresemailstatus($request);
				if($result){
					echo 't';
				}else{
					echo 'f';
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}		
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function removefirmemailbyajaxAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_firmService->deleteResEmail($request);
				if($result){
					echo 't';
				}else{
					echo 'f';
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}		
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function firmsmscommunicatenumerAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				if($request->type == 'sms'){
					$result = $this->_firmService->restSmsNotifyNumber($request);
				}else{
					$result = $this->_firmService->restPhoneNotifyNumber($request);
				}
				if($result){
					echo 't';
				}else{
					echo 'f';
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function retrievefirmsmscommunicatenumbyajaxAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_firmService->getRestSmsNotifyNumber($request);
				if($result){
					echo json_encode($result);
				}else{
					echo json_encode('f');
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	
	public function editcommunicateinfobyajaxAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_firmService->UpdateNotifyDetails($request);
				if($result){
					echo 't';
				}else{
					echo 'f';
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	
	public function editmobilecommunicateinfobyajaxAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_firmService->UpdatePhoneNotifyDetails($request);
				if($result){
					echo json_encode($result);
				}else{
					echo 'f';
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function editcustomerinfoAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_firmService->UpdateCusInfo($request);
				if($result){
					echo json_encode('t');
				}else{
					echo json_encode('f');
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function removediningwallAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			if($request){
				$result = $this->_firmService->deleteFloorSeprator($request);
				if($result){
					echo json_encode('t');
				}else{
					echo json_encode('f');
				}
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function retrievefirmdetailsbyfirmidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			if($request){
				$result = $this->_firmService->GetRestaurantDetailsByResId($request);
				if($result){
					echo json_encode($result);
				}else{
					echo json_encode("f");
					
				}
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getfbfirminfobyfirmidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			if($request){
				$result = $this->_firmService->GetRestaurantDetailsByResId($request);
				if($result){
					echo json_encode($result);
				}else{
					echo json_encode("f");
					
				}
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function pluginthemesmanagementAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			$request = $this->getRequest();		
			if($auth->hasIdentity()){
                            $this->view->currentPageName = 'pluginthemesmanagement';
				$referer = $_SERVER['SERVER_NAME'];                                
				$this->view->referer = $referer;
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				if($request->restaurantid){
					$resStat = $this->_firmService->AuthenticateRestByAuth($data,$request->restaurantid);
				}else{
					$resStat = true;
				}
				$this->view->secureLoginStatus = $resStat;
				$this->view->returnAction = $request->returnAction;
				if($resStat){
					$this->_helper->layout()->setLayout('global_settings_layout');
					$restNameList = "";
					if($data['Usertype'] == "RSO" || $data['Usertype'] == "ADM" || $data['Usertype'] == "ADU"){
						$restNameList = $this->_firmService->GetRestNameById($data);
					}else if($data['Usertype'] == "RSU"){
						$restNameList = $this->_firmService->GetRestNameById($data);
					}else if($data['Usertype'] == "SRU"){
						$restNameList = $data['restList'];
					}
					
					$this->view->restNames = $restNameList;
					if($request->restaurantid){
						$this->view->restaurantid = $request->restaurantid;
					}
					// Cutomize Widget settings
					if($request->isPost()){
						$status = $this->_firmService->ManageCustomizeWidget($_POST,$_FILES);
						if($status =='t'){
							echo "<script>alert(\"Successfully Updated Widget setting. \") </script>" ;
						}
						else{
							echo "<script>alert(\"Widget setting unsuccessful. \") </script>" ;
						}
					}
					
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}	
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}		
	}
	
	public function retreivepluginthemeAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			
			$theme = $this->_firmService->GetWidgetThemeByRestId($request);
			if($theme){
				echo json_encode($theme);
			}else{
				echo json_encode('f');
			}			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function savepluginthemeAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$status = $this->_firmService->ManageWidgetTheme($request);
			if($status){
				echo json_encode('t');
			}else{
				echo json_encode('f');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}	
	}
 
	public function workareamanagementAction()
	{
		try{			
			$auth = Zend_Auth::getInstance();
			$request = $this->getRequest();		
			if($auth->hasIdentity()){
                               // $this->view->currentPageName = 'workareamanagement';
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				if($data['Usertype'] == 'RSU'){
				$permission = $data['Permissions'];
				$permm = false;
					foreach($permission as $value){
						if ($value->permcode == 'GM') {
							$permm = true;	
							break;
						}
					}
					if(!$permm){
						$this->view->nopermm = 'nopermm';
					}
				}
				if($data['DefaultView'] == 'floor'){
					$this->view->floorview = 'floor';
				}else{
					$this->view->floorview = 'calendar';
				}
				
				if($request->restaurantid)
				{
					$resStat = $this->_firmService->AuthenticateRestByAuth($data,$request->restaurantid);
				}else{
					$resStat = false;
				}
				$bookService = new Application_Service_Reservation();
				$quoteSettings = $bookService->reteriveWaitingreservationQuoteTimes($request);
				$this->view->quoteSettings = $quoteSettings;
				$form = $bookService->getQuoteTimeSettingsForm();
				$this->view->quoteform = $form;
				if($request->stepsimg)
				{		
					if($request->restaurantid){
						$resSetStat = $this->_firmService->GetSettingStatusbyResid($request->restaurantid);
					}else{
						$resSetStat = $this->_firmService->GetSettingStatusbyResid($data['RestId']);
					}
					if($resSetStat == true){
							$this->view->stepsimg = $request->stepsimg;
					}
				}
				$CountryCodeMapper = new Application_Model_CountryCodeDataMapper();
		    	$CountryCode = $CountryCodeMapper->fetchAll();
		    	$CodeList = array();
		    	$CodeList[] = array('key'=>'','value'=>'Select Country Flag');
		    	foreach($CountryCode as $listcode){
		    		$CodeList[] = array('key'=>$listcode->getCountry_dial_code(),'value'=>$listcode->getCountry_flag());
		    	}
		    	$this->view->codelist = $CodeList;
				$this->view->secureLoginStatus = $resStat;
				if($resStat){
					$this->_helper->layout()->setLayout('global_settings_layout');
					$result = $this->_firmService->getRestaurantMealType($request);
					$this->view->mealType = $result['mealType'];
					
					//schedule setting type base data
					$result1 = $this->_firmService->getschedulesetting();
					$this->view->schedulestatus = $result1;
					
					if(isset($result['mealCount'])){
						$this->view->mealCount = $result['mealCount'];
					}
					$this->view->restaurantid = $request->restaurantid;
					$this->view->returnAction = $request->returnAction;
					if($request->popup){					
						$this->view->popup = $request->popup;
                                                $this->view->currentPageName = $request->popup;
					}
					
				// retrieving data for table status option 	
					$bookService = new Application_Service_Reservation();
					$menu = $bookService->getReservationMenu($request->restaurantid,'edit');
					$this->view->menu = $menu;
				// end of retrieving data for table status option 	

				// Retrieving data for booking option 	
					$optionsetting = $this->_firmService->getBookingOptionsSetting($request->restaurantid);
					$this->view->optionsetting = $optionsetting->resbookingoption_setting;
					$this->view->restaurantid = $request->restaurantid;
					
					$optionList =$bookService->getBookingOptionsListByRestid($request->restaurantid);
					$this->view->optionList = $optionList;
					if($request->addstatus == 'a' || $request->addstatus == 'e'){
						$this->view->addstatus = $request->addstatus;
						$this->view->codestatus = $request->codestatus;
						$this->view->descstatus = $request->descstatus;
						$this->view->description = $request->description;
						$this->view->addcode = $request->addcode;
						$this->view->addtype = $request->addtype;
						$this->view->bokoptionid = $request->bokoptionid;
					}
				//  End of Retrieving data for booking option 
					$this->view->companyid = $data['companyid'];
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){ 
			throw new Exception($ex->getMessage()) ;
		}
	}
    
    public function posworkareamanagementAction()
	{
		try{			
			$auth = Zend_Auth::getInstance();
			$request = $this->getRequest();		
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				if($data['Usertype'] == 'RSU'){
                    $permission = $data['Permissions'];
                    $permm = false;
					foreach($permission as $value){
						if ($value->permcode == 'GM') {
							$permm = true;	
							break;
						}
					}
					if(!$permm){
						$this->view->nopermm = 'nopermm';
					}
				}
				if($request->restaurantid)
				{
					$resStat = $this->_firmService->AuthenticateRestByAuth($data,$request->restaurantid);
                    $this->view->secureLoginStatus = $resStat;
				}else{
					$resStat = false;
                    $this->view->secureLoginStatus = $resStat;
				}
				$taxResult = $this->_firmService->RetreiveFirmTaxList($request);
                $this->view->taxResult = $taxResult;
				//  End of Retrieving data for booking option 
					$this->view->companyid = $data['companyid'];
                    $this->view->restaurantid = $request->restaurantid;
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){ 
			throw new Exception($ex->getMessage()) ;
		}
	}
    
    public function updatetaxtrAction()
    {
        try{
            $this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$auth = Zend_Auth::getInstance();
			$request = $this->getRequest();		
			$result = $this->_firmService->updateTaxTr($request);
			$jsonObj = json_encode($result);
			echo $jsonObj;				
        } catch (Exception $ex) {
            throw new Exception($ex->getMessage()) ;
        }
    }
	
	public function pickmaxandminpartysizebyfirmidAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$auth = Zend_Auth::getInstance();
			$request = $this->getRequest();		
			$result = $this->_firmService->getMaxandMinPartySize($request);
			$jsonObj = json_encode($result);
			echo $jsonObj;				
		}catch (Exception $ex){ 
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function updateallowedpaxAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$auth = Zend_Auth::getInstance();
			$request = $this->getRequest();		
			if($request->isPost()){
				$result = $this->_firmService->editPartySize($request);
				if($result){
						$this->_helper->redirector('workareamanagement','Firm', 'FirmManagement',array('restaurantid' => $request->restid,'returnAction'=>$request->returnAction));	
				}		
			}
		}catch (Exception $ex){ 
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function retreivedayallowedpaxAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_firmService->getDayPartySize($request);
				if($result){
					echo json_encode($result);
				}else{
					echo json_encode('f');
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function changeallowedpaxrangeAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_firmService->updatePartySizeRange($request);
				if($result){
					echo 't';
				}else{
					echo 'f';
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function retreivedealworkmanagementAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_firmService->getSpecialSetting($request);
				if($result){
					echo json_encode($result->resspecialsetting);
				}else{
					echo json_encode('f');
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function changedealworkmanagementAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_firmService->updateSpecialSetting($request);
				if($result){
					echo 't';
				}else{
					echo 'f';
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function retreivedealworkmanagementpluginAction()
	{
		try{
				$storage = new Zend_Auth_Storage_Session();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_firmService->getSpecialSetting($request);
				if($result){
					echo json_encode($result->resspecialsetting);
				}else{
					echo json_encode('f');
				}
			}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function retreivedealrequestworkmanagementAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_firmService->getSpecialRequestSetting($request);
				if($result){
					echo json_encode($result->resspecial_request);
				}else{
					echo json_encode('f');
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function changedealrequestworkmanagementAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_firmService->updateSpecialRequestSetting($request);
				if($result){
					echo 't';
				}else{
					echo 'f';
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function updateotpsettingstatusAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_firmService->updateOtpSetting($request);
				if($result){
					echo 't';
				}else{
					echo 'f';
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function retreivedealrequestworkmanagementpluginAction()
	{
		try{
				$storage = new Zend_Auth_Storage_Session();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_firmService->getSpecialRequestSetting($request);
				if($result){
					echo json_encode($result->resspecial_request);
				}else{
					echo json_encode('f');
				}
			}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function getotpsettingstatusAction()
	{
		try{
				$storage = new Zend_Auth_Storage_Session();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_firmService->getOtpSettingStatus($request);
				if($result){
					echo json_encode($result->resotp_setting);
				}else{
					echo json_encode('f');
				}
			}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function showsocialidAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			$request = $this->getRequest();		
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->view->pageid = $request->pageid;
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){ 
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function setupsocialidAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			$request = $this->getRequest();		
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				if($data['Usertype'] == "RSO"){
					$restNameList = $this->_firmService->GetRestNameById($data);
				}else if($data['Usertype'] == "RSU"){
					$restNameList = $this->_firmService->GetRestNameById($data);
				}else if($data['Usertype'] == "SRU"){
					$restNameList = $data['restList'];
				}
				if($request->restid){				
					$result = $this->_firmService->addfbpageidbyrestid($request);
					if($result){
						header( 'Location: http://www.facebook.com/'.$request->appid) ;
					}
				}
				$this->view->restNames = $restNameList;
				$this->view->pageid = $request->pageid;
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){ 
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function showdealsocialidAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			$request = $this->getRequest();		
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->view->pageid = $request->pageid;
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){ 
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function setupdealsocialidAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			$request = $this->getRequest();		
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				if($data['Usertype'] == "RSO"){
					$restNameList = $this->_firmService->GetRestNameById($data);
				}else if($data['Usertype'] == "RSU"){
					$restNameList = $this->_firmService->GetRestNameById($data);
				}else if($data['Usertype'] == "SRU"){
					$restNameList = $data['restList'];
				}
				if($request->restid){				
					$result = $this->_firmService->addfbdealpageidbyrestid($request);
					if($result){
						header( 'Location: http://www.facebook.com/'.$request->appid) ;
					}
				}
				$this->view->restNames = $restNameList;
				$this->view->pageid = $request->pageid;
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){ 
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function showmenusocialidAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			$request = $this->getRequest();		
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->view->pageid = $request->pageid;
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){ 
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function setupmenusocialidAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			$request = $this->getRequest();		
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				if($data['Usertype'] == "RSO"){
					$restNameList = $this->_firmService->GetRestNameById($data);
				}else if($data['Usertype'] == "RSU"){
					$restNameList = $this->_firmService->GetRestNameById($data);
				}else if($data['Usertype'] == "SRU"){
					$restNameList = $data['restList'];
				}
				if($request->restid){				
					$result = $this->_firmService->addfbmenupageidbyrestid($request);
					if($result){
						header( 'Location: http://www.facebook.com/'.$request->appid) ;
					}
				}
				$this->view->restNames = $restNameList;
				$this->view->pageid = $request->pageid;
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){ 
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function showbookingsocialidAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			$request = $this->getRequest();		
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->view->pageid = $request->pageid;
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){ 
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function setupbookingsocialidAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			$request = $this->getRequest();		
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				if($data['Usertype'] == "RSO"){
					$restNameList = $this->_firmService->GetRestNameById($data);
				}else if($data['Usertype'] == "RSU"){
					$restNameList = $this->_firmService->GetRestNameById($data);
				}else if($data['Usertype'] == "SRU"){
					$restNameList = $data['restList'];
				}
				if($request->restid){				
					$result = $this->_firmService->addfbbookingpageidbyrestid($request);
					if($result){
						header( 'Location: http://www.facebook.com/'.$request->appid) ;
					}
				}
				$this->view->restNames = $restNameList;
				$this->view->pageid = $request->pageid;
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){ 
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function editreservationoptionsettingsbyajaxAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_firmService->updateBookingOptionsSetting($request);
				if($result){
					echo 't';
				}else{
					echo 'f';
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function addcommunicationdataAction()
	{
		try{
			$this->_helper->layout()->setLayout('restaurantuserlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();		
				if($request->isPost()){
					$notfsrvice = new Application_Service_Communication();
					$result = $notfsrvice->AddNotifcationContent($request,$data);
					if($result){
						$this->_helper->redirector('communicationdatamanagement','Firm', 'FirmManagement',array('restaurantid' => $request->restaurantid));
					}
				}
				$this->view->restaurantid = $request->restaurantid;
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function communicationdatamanagementAction()
	{
		try{
			$this->_helper->layout()->setLayout('restaurantuserlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();	
				
				$notfsrvice = new Application_Service_Communication();
				$result = $notfsrvice->getNotificationContentByResid($request);
				if($result){
					$this->view->result = $result;
					//$template = $notfsrvice->getEmailTemplatewithNotificationContent($request->restaurantid);
					//$this->view->template = $template;
					$resDataMapper = new FirmManagement_Model_FirmDataMapper();
					$restObj= new FirmManagement_Model_FirmById();
					$restObj->setRestaurantId($request->restaurantid);
					$resDetails = $resDataMapper->getRestaurantById($restObj);	
					$this->view->resDetails = $resDetails;
				}
				$this->view->restaurantid = $request->restaurantid;
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function updatecommunicationdatastatAction()
	{
		try{
			$this->_helper->layout()->setLayout('restaurantuserlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();	
				
				$notfsrvice = new Application_Service_Communication();
				$result = $notfsrvice->ChangeNotificationContentStatus($request, $data);
				$this->_helper->redirector('communicationdatamanagement','Firm', 'FirmManagement',array('restaurantid' => $request->restaurantid));
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function updatecommunicationdataAction()
	{
		try{
			$this->_helper->layout()->setLayout('restaurantuserlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				$notfsrvice = new Application_Service_Communication();		
				if($request->isPost()){
					$result = $notfsrvice->UpdateNotifcationContent($request,$data);
					if($result){
						$this->_helper->redirector('communicationdatamanagement','Firm', 'FirmManagement',array('restaurantid' => $request->restaurantid));
					}
				}
				$result = $notfsrvice->getNotificationContentByResid($request);
				$this->view->result = $result;
				$this->view->restaurantid = $request->restaurantid;
				$this->view->id = $request->id;
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function verifycountryexistAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$result = array();
			$statemapper = new Application_Model_StateDataMapper();
			
			if($request->setstate == 1){
				$stateid = $this->_firmService->addCantFindState($request);
				$result['stateid'] = $stateid;
			}else{
				if($request->statedescription){
					$result['description']	= $statemapper->verifyDesc($request->statedescription,0);
				}
				if($request->statecode){
					$result['code']			=  $statemapper->verifyCode($request->statecode,0);
				}
			}
			
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function verifystateexistAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$regionmapper = new Application_Model_RegionDataMapper();
			
			if($request->stateid){
				$regionid = $this->_firmService->addCantFindRegion($request);
				$result['regionid'] = $regionid;
			}else{
				if($request->regiondescription){
				$result['description']	= $regionmapper->verifyDesc($request->regiondescription,0);
				}
				if($request->regioncode){
				$result['code']			=  $regionmapper->verifyCode($request->regioncode,0);
				}
			}
			
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function addfirminventoryAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				if(isset($request->restaurantid)){
					$restId = $request->restaurantid;
				}else{
					$restId = $data['RestId'];
					$request->setParam('restaurantid',$restId);
				}
				if($restId){
					$resStat = $this->_firmService->AuthenticateRestByAuth($data,$restId);
				}else{
					$resStat = true;
				}				
				$this->view->secureLoginStatus = $resStat;
				
				if($resStat){
					$this->_helper->layout()->setLayout('restaurantuserlayout');
					if($restId){
                                                $result = $this->_firmService->GetRestaurantSchedule($request);
						$this->view->inventory    = $result['inventory'];
						$this->view->resIsset	= $result['resIsset'];
                                                
						
						if($this->getRequest()->isPost()){
							if($request->where == 'sl'){
								$result = $this->_firmService->AddRestaurantSchedule($this->getRequest()->getPost(),$data);
								if($result){
									$this->view->status = $result['status'];
									return $this->_helper->redirector('workareamanagement','Firm','FirmManagement',array('restaurantid'=>$request->restaurantid,'returnAction'=>'reservationdesk'));
								}else{
									$this->view->status = 'err';
								}
							}else{
								$result = $this->_firmService->AddRestaurantSMCSchedule($this->getRequest()->getPost(),$data);
								if($result){
									$this->view->status = $result['status'];
									return $this->_helper->redirector('workareamanagement','Firm','FirmManagement',array('restaurantid'=>$request->restaurantid,'returnAction'=>'reservationdesk'));
								}else{
									$this->view->status = 'err';
								}
							}
						}
						$restMealList = $this->_firmService->getMealTypeCountByRestaurantId($restId,'set');
						$this->view->restMealCount = $restMealList['count'];
						$AllSchDay = $this->_firmService->getRestaurantEachDayScheudleStatus($request);
						$this->view->AllSchDay = $AllSchDay['notset'];
						$schTypeResult = $this->_firmService->CheckRestaurantScheduleType($request);					
						$this->view->scheduletype = $schTypeResult['settingType'];
						$this->view->restaurantid = $restId;
						if($request->from){
							$this->view->from = $request->from;
						}			
					}
					$this->view->userStat = $data['Usertype'];
					$this->view->companyid = $data['companyid'];
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function addfirmtotalcountinventoryAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				
				if($request->restaurantid){
					$resStat = $this->_firmService->AuthenticateRestByAuth($data,$request->restaurantid);
				}else{
					$resStat = true;
				}
				
				$this->view->secureLoginStatus = $resStat;
				if($resStat){
					$this->_helper->layout()->setLayout('restaurantuserlayout');
					if($request->restaurantid){
						$result = $this->_firmService->GetRestaurantSMCSchedule($request);
						$this->view->restaurantid = $request->restaurantid;
						$this->view->resIsset	= $result['resIsset'];
						if($this->getRequest()->isPost()){
							$result = $this->_firmService->AddRestaurantSMCSchedule($this->getRequest()->getPost(),$data);
							if($result){
								$this->view->status = $result['status'];
								return $this->_helper->redirector('totalcount','Firm','FirmManagement',array('restaurantid'=>$request->restaurantid));
							}else{
								$this->view->status = 'err';
							}
						}
						$AllSchDay = $this->_firmService->GetRestaurantAllEmptyDaySMCScheudle($request);
						$this->view->AllSchDay = $AllSchDay['notset'];
						//schedule settings
						$result2 = $this->_firmService->managescheduleSetting($request);
						$this->view->schedulestatus1 = $result2->code;
						$setresult1=$this->_firmService->getschedulesetting();
						$this->view->schedulestatus=$setresult1;
						
					}
					$this->view->restaurantid = $request->restaurantid;
					
					$result = $this->_firmService->RestaurantSchedule($data);
					$this->view->resform = $result['form'];
					$this->view->userStat = $data['Usertype'];
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function managefirminventoryAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$result = $this->_firmService->FirmManagementScheduleUpdate($this->getRequest()->getPost(),$data);
				return $this->_helper->redirector('displayinv','Firm','FirmManagement',array('restaurantid'=>$request->selActionRes));
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function managefirmtotalcountinventoryAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$result = $this->_firmService->FirmManagementSMCScheduleUpdate($this->getRequest()->getPost(),$data);
				return $this->_helper->redirector('totalcount','Firm','FirmManagement',array('restaurantid'=>$request->selActionRes));
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function managefirminventorycompAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$result = $this->_firmService->FirmManagementScheduleUpdateComp($this->getRequest()->getPost(),$data);
				return $this->_helper->redirector('displayinv','Firm','FirmManagement',array('restaurantid'=>$request->selActionResComp));
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function managefirmtotalcountinventorycompAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$result = $this->_firmService->FirmManagementSMCScheduleUpdateComp($this->getRequest()->getPost(),$data);
				return $this->_helper->redirector('totalcount','Firm','FirmManagement',array('restaurantid'=>$request->selActionResComp));
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function verifycityexistAction()
	{
		try{
			$request = $this->getRequest();
			$result = array();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$citymapper = new Application_Model_CityDataMapper();
			
			if($request->regionid){
				$cityid = $this->_firmService->addCantFindCity($request);
				$result['cityid'] = $cityid;
			}else{
				if($request->citydescription){
				$result['description']	= $citymapper->verifyDesc($request->citydescription,0);
				}
				if($request->citycode){
				$result['code']			=  $citymapper->verifyCode($request->citycode,0);
				}
			}
			
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function verifyfirmcountryAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$result = array();
			$statemapper = new Application_Model_StateDataMapper();
			if($request->setstate == 1){
				$stateid = $this->_firmService->addCantFindRestaurantState($request);
				$result['stateid'] = $stateid;
			}else{
				if($request->statedescription){
					$result['description']	= $statemapper->verifyDesc($request->statedescription,0);
				}
				if($request->statecode){
					$result['code']			=  $statemapper->verifyCode($request->statecode,0);
				}
			}
			
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function verifyfirmstateAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$regionmapper = new Application_Model_RegionDataMapper();
			
			if($request->stateid){
				$regionid = $this->_firmService->addCantFindRestaurantRegion($request);
				$result['regionid'] = $regionid;
			}else{
				if($request->regiondescription){
					$result['description']	= $regionmapper->verifyDesc($request->regiondescription,0);
				}
				if($request->regioncode){
					$result['code']			=  $regionmapper->verifyCode($request->regioncode,0);
				} 
			}
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function verifyfirmcityAction()
	{
		try{
			$request = $this->getRequest();
			$result = array();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$citymapper = new Application_Model_CityDataMapper();
			if($request->regionid){
				$cityid = $this->_firmService->addCantFindRestaurantCity($request);
				$result['cityid'] = $cityid;
			}else {
				
				if($request->citydescription){
					$result['description']	= $citymapper->verifyDesc($request->citydescription,0);
				}
				if($request->citycode){
					$result['code']			=  $citymapper->verifyCode($request->citycode,0);
				}
			}
			
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function verifyfirmlocalityAction()
	{
		try{
			$request = $this->getRequest();
			$result = array();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$neighmapper = new Application_Model_NeighborhoodDataMapper();
			
			if($request->cityid){
				$cityid = $this->_firmService->addCantFindRestaurantNeighbour($request);
				$result['neighbourid'] = $cityid;
			}else if($request->neighdescription){
				$result['description']	= $neighmapper->verifyDesc($request->neighdescription,0);
			}
			
			echo json_encode($result);
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function addinventorypostAction()
	{
		try{
			$request = $this->getRequest();
			$result = array();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$result = $this->_firmService->AddScheduleAjax($request);
			if($result){
				echo $result;
			}else{
				echo 'f';
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function addscheduleinventoryajaxAction()
	{
		try{
			$request = $this->getRequest();
			$result = array();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$result = $this->_firmService->AddScheduleInventoryAjax($request);
			if($result){
				echo json_encode($result);
			}else{
				echo 'f';
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function retreivefirmreservationtimeworkmanagementAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->getRestaurantResvTimeSetting($request->resid);
			if($result){
				echo json_encode($result);
			}else{
				echo json_encode("f");
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function savefirmreservationtimeworkmanagementAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->saveRestaurantResvTimeSetting($request);
			if($result){
				echo json_encode($result);
			}else{
				echo json_encode("f");
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}	
	
	public function retreivefirminvtypeAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_firmService->managescheduleSetting($request);
				if($result){
					if($result == 'SPL'){
						echo 'SL';
					}else{
						echo $result->code;
					}
				}else{
					echo 'f';
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function updateinvajaxAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_firmService->updatescheduleSetting($request);
				if($result){
					echo 't';
				}else{
					echo 'f';
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function retreivefirmcustomizepluginAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			
			$settings = $this->_firmService->getRestaurantCustomizeWidget($request);
			if($settings){
				echo json_encode($settings);
			}else{
				echo json_encode('f');
			}			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function updateguestlistinfoAction()
    {
    	try{
    		$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
    		if($this->getRequest()->isPost()){
    			$result = $this->_firmService->EditUserContactDetails($this->getRequest()->getPost());
    			$jsonObj = json_encode($result);
				echo $jsonObj;
    		}	
    	}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
    }
    
	public function menucategoryanditemsAction()
    {
    	try{                
                $auth = Zend_Auth::getInstance();
                
                if($auth->hasIdentity())
                {
    		$this->_helper->layout()->setLayout('menu_layout');
    		$request = $this->getRequest();                
    		$result = $this->_firmService->getMenuCatedorysAndMenuItems($request);
    		$this->view->result = $result;
    		$this->view->restaurantid = $request->restaurantid;
                $restid = $request->restaurantid;
                $csvform =$this->_firmService->getMenuImportForm();
                $this->view->menuimportform = $csvform;
                
    		if($request->menuid){
    			$this->view->menuid = $request->menuid;
    		}else{
    			if(count($result) > 0){
    				$this->view->menuid = $result[0]['menuid'];
    			}
    		}
                $errorval='';
                $errorval = $this->_request->getParam('errorlink');
                $this->view->errorvar =$errorval;                                            
                if($request->formstatus == 'addcsvfile') {
                $result = $this->_firmService->uploadMenuCsv($this->getRequest()->getPost(), $restid);                                               
						if(is_array($result)){                                                                                                                                                            
                                                     return $this->_helper->redirector('menucategoryanditems','Firm','FirmManagement',array('restaurantid'=>$request->restaurantid, 'errorlink'=>'erroroccur'));                                                     							
                                                }  else {
                                                    return $this->_helper->redirector('menucategoryanditems','Firm','FirmManagement',array('restaurantid'=>$request->restaurantid, 'menuid'=>$result));                                                     							
                                                }                                             
                }
                                                
           }else {
               $this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
           }
                
    	}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
    }
    // function to download errorlists which occur during csvuploading.
         public function downloadmenuerrorAction()
                {
             
             try{
                $this->_helper->layout->disableLayout();
    		$this->_helper->viewRenderer->setNoRender();
                $errorDetails = $this->_firmService->downloadMenuErrorlist();
                if($errorDetails)
                {                    
                    foreach ($errorDetails as $value)
                        {
                            foreach($value as $valuee)
                            {
                            echo $valuee.",";
                            }
                            echo "\n";
                        }                                                    
                        header("Content-type: application/x-msdownload");
                        header("Content-Disposition: attachment; filename=errorlist.csv");
                        header("Pragma: no-cache");
                        header("Expires: 0");
                }               
                     }
                        catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}                    
                }
                //Function to download csv template for menu uploading
    public function downloadmenutemplateAction()
            {
        try{
            
                 $auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){   
                    $this->_helper->layout->disableLayout();
    		    $this->_helper->viewRenderer->setNoRender();
                    $csvstring =''; 
                    $csvstring.='menu_category,';
                    $csvstring.='menu_item,';
                    $csvstring.='Veg (1) AND Non Veg(2),';
                    $csvstring.='description,';
                    $csvstring.='price';                                                           
                        echo $csvstring;
                        header("Content-type: application/x-msdownload");
                        header("Content-Disposition: attachment; filename=menu.csv");
                        header("Pragma: no-cache");
                        header("Expires: 0");
                        }else {
                          $this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));  
                        }                              
                     }
                        catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}  
        
    }            
    
    public function addmenuheaderAction()
	{
    	try{
    		$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
    		$request = $this->getRequest();
    		$result = $this->_firmService->addMenuHeader($request);
    		if($result){
	    		echo json_encode($result);
			}else{
				echo json_encode('f');
			}	
    	}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
    }
    
	public function setmobilemenuviewtypeAction()
	{
    	try{
    		$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
    		$request = $this->getRequest();
    		$result = $this->_firmService->setMobileMenuViewType($request);
    		if($result){
	    		echo json_encode('t');
			}else{
				echo json_encode('f');
			}	
    	}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
    }
    
    public function getmenuheaderAction()
	{
    	try{
    		$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
    		$request = $this->getRequest();
    		$result = $this->_firmService->getMenuHeader($request);
    		if(count($result > 0)){
	    		echo json_encode($result);
			}else{
				echo json_encode('f');
			}	
    	}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
    }
    
	public function changemenustatusAction()
    {
    	try{
    		$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			
			$request = $this->getRequest();
	    	$result = $this->_firmService->changeMenuStatus($request);
			if(	$result){
				echo json_encode($result);
			}else{
				echo json_encode('f');
			}
    	}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;	
	}	
    }
    
    public function addmenucategoryandmenuitemsAction()
    {
    	try{
                        $auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
	    		$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
	    		$request = $this->getRequest();
	    		$result = $this->_firmService->AddMenuCatedoryAndItems($request);
	    		if($result)
	    		{
	    			echo $result;
	    		}else{
	    			echo 'f';
	    		}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
    	}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
    }
    
    //Add Menu Category
    public function addmenucategoryAction()
    {
                try{
                        $auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
	    		$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
	    		$request = $this->getRequest();
	    		$result = $this->_firmService->AddMenuCatedory($request);
	    		if($result){	    		
	    			echo $result;
	    		}else{
	    			echo 'f';
	    		}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
    	}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
    }
    //Add Menu Category
    //Edit Menu Category
    public function editmenucategoryAction()
    {
                try{
                        $auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
	    		$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
	    		$request = $this->getRequest();
	    		$result = $this->_firmService->EditMenuCatedory($request);
	    		if($result){	    		
	    			echo $result;
	    		}else{
	    			echo 'f';
	    		}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
    	}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
    }
    //Edit Menu Category
    public function addmenuitemAction()
    {
                try{
                        $auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
	    		$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
	    		$request = $this->getRequest();
	    		$result = $this->_firmService->AddMenuItem($request);
	    		if($result){	    		
	    			echo json_encode($result);
	    		}else{
	    			echo 'f';
	    		}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
    	}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
    }
    
    public function editmenuitemAction()
    {
                try{
                        $auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
	    		$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
	    		$request = $this->getRequest();
	    		$result = $this->_firmService->EditMenuItem($request);
	    		if($result){	    		
	    			echo json_encode($result);
	    		}else{
	    			echo 'f';
	    		}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
    	}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
    }
    
    
    
    public function getmenucategorysandmenuitemsAction()
    {
    	try{
    		$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			
			$request = $this->getRequest();
	    	$result = $this->_firmService->getMenuCatedorysAndMenuItems($request);
			if(	$result){
				echo json_encode($result);
			}else{
				echo json_encode('f');
			}	
    	}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
    }
    
    public function getmenucategorysandmenuitemsbymenuidAction()
    {
    	try{
    		$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			
			$request = $this->getRequest();
	    	$result = $this->_firmService->getMenuCatedorysAndMenuItemsByMenuId($request);
			if(	$result){
				echo json_encode($result);
			}else{
				echo json_encode('f');
			}	
    	}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
    }
    
    public function editmenucategoryandmenuitemsAction()
    {
    	try{
    		$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
	    		$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
	    		$request = $this->getRequest();
	    		$result = $this->_firmService->EditMenuCatedoryAndItems($request);
	    		if($result)
	    		{
	    			echo 't';
	    		}else{
	    			echo 'f';
	    		}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
    	}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
    }
    
    public function getmenuitemsbycategoryidAction()
    {
    	try{
    		$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			
			$request = $this->getRequest();
	    	$result = $this->_firmService->getMenuItemsByCategoryId($request);
			if(	$result){
				echo json_encode($result);
			}else{
				echo json_encode('f');
			}
    	}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
    }

	public function changemenucategorystatusAction()
    {
    	try{
    		$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			
			$request = $this->getRequest();
	    	$result = $this->_firmService->changeMenuCategoryStatus($request);
			if(	$result){
				echo json_encode($result);
			}else{
				echo json_encode('f');
			}
    	}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
    }
    
	public function updatecategoryAction()
    {
    	try{
    		$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			
			$request = $this->getRequest();
	    	$result = $this->_firmService->updateCategory($request);
			if(	$result){
				echo json_encode($result);
			}else{
				echo json_encode('f');
			}
    	}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
    }
    
	public function updateitemAction()
    {
    	try{
    		$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			
			$request = $this->getRequest();
	    	$result = $this->_firmService->updateItem($request);
			if($result){
				echo json_encode($result);
			}else{
				echo json_encode('f');
			}
    	}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
    }
    
    public function updateitemmodAction()
    {
    	try{
    		$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			
			$request = $this->getRequest();
	    	$result = $this->_firmService->updateItemMod($request);
			if($result){
				echo json_encode($result);
			}else{
				echo json_encode('f');
			}
    	}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
    }
    
	public function additembycategoryidAction()
    {
    	try{
    		$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			
			$request = $this->getRequest();
	    	$result = $this->_firmService->addItemByCategoryid($request);
			if($result){
				echo json_encode($result);
			}else{
				echo json_encode('f');
			}
    	}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
    }
    
    public function updateitemsequenceAction()
    {
    	try{
    		$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			
			$request = $this->getRequest();
	    	$result = $this->_firmService->updateItemSequence($request);
			if($result){
				echo json_encode($result);
			}else{
				echo json_encode('f');
			}
    	}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
    }
    
    public function firmcuisinesAction()
    {
    	try{
    		
    		$this->_helper->layout->disableLayout();
			
			$request = $this->getRequest();
	    	$result = $this->_firmService->restaurantMenus($request);
	    	$this->view->restaurantid = $request->restaurantid;
			$this->view->result = $result['categorys'];
			$this->view->theme = $result['menuTheme'];
    	}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
    }
    
    public function socialfirmcuisinesAction()
    {
    	try{
    		
    		$this->_helper->layout->disableLayout();
			
			$request = $this->getRequest();
	    	$result = $this->_firmService->restaurantMenus($request);
	    	$this->view->restaurantid = $request->restaurantid;
			$this->view->result = $result['categorys'];
			$this->view->theme = $result['menuTheme'];
    	}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
    }
    
    public function fbwidgetrestaurantmenusAction()
    {
    	try{
    		
    		$this->_helper->layout->disableLayout();
			
			$request = $this->getRequest();
	    	$result = $this->_firmService->restaurantMenus($request);
			$this->view->result = $result['categorys'];
			$this->view->theme = $result['menuTheme'];
    	}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
    }
    
	public function managemenuthemesAction()
	{
		try{			
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			
			$auth = Zend_Auth::getInstance();
			$request = $this->getRequest();		
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				if($request->isPost()){
					$status = $this->_firmService->CustomizeMenuThemes($_POST,$_FILES);
					if($status =='t'){
						echo 't';
					}else{
						echo 'f';
					}
				}	
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}	
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}		
	}
	
	public function getrestaurantcustomizemenuAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();	
			$settings = $this->_firmService->getRestaurantMenuTheme($request);
			if($settings){
				echo json_encode($settings);
			}else{
				echo json_encode('f');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function changemenuitemstatusAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();	
			$settings = $this->_firmService->changeMenuItemStatus($request);
			if($settings){
				echo json_encode('t');
			}else{
				echo json_encode('f');
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function manageinquiriesAction()
	{
		try{
			$this->_helper->layout()->setLayout('restaurantuserlayout');
			$form = $this->_firmService->getRestManageInquiryForm();
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){				
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();	
		        $request = $this->getRequest();
				if($data['Usertype'] == "RSO" || $data['Usertype'] == "ADM" || $data['Usertype'] == "ADU"){
					$restNameList = $this->_firmService->GetRestNameById($data);
				}else if($data['Usertype'] == "RSU"){
					$restNameList = $this->_firmService->GetRestNameById($data);
				}else if($data['Usertype'] == "SRU"){
					$restNameList = $data['restList'];
				}
				
// Faiz: The Below  code is to update the color code for the contact us widget. We are calling this from  manage inquiries. From here we are calling to function in restaurant service *//														
				if($_POST['linkcolor']){
				$status = $this->_firmService->ManageContactusWidget($_POST,$_FILES);
				if($status =='t'){
					echo "<script>alert(\"Successfully Updated Contact Us Widget setting. \") </script>" ;
				}
				else{
					echo "<script>alert(\"Widget setting unsuccessful. \") </script>" ;
				}
				}
				
//* Contact widget ends *//	

				$page = $this->_request->getParam('page');
				if (empty($page)){
					$page = 1;
				}					
				if(($request->restaurantid)){
					$restid = $request->restaurantid;
					$restId = $form->RestaurantId->setValue($restid);
					$resultSet = $this->_firmService->GetContactUsDeatilsByRestId($page,$restid);
					if($resultSet['status']){
						$this->view->resultSet = $resultSet['personalForm'];
						$form->RestaurantName->addMultiOptions($restNameList);
						$form->setDefaults(array('RestaurantName'=>$restid));
						$this->view->restID =  $restId;
						$this->view->form = $form;				
					}else{
						$form->RestaurantName->addMultiOptions($restNameList);
						$this->view->restID =  $restId;
						$this->view->form = $form;
					}
				}else{
					$form->RestaurantName->addMultiOptions($restNameList);
					$restId = $form->RestaurantId->setValue('');
					$this->view->restID =  $restId;
					$this->view->form = $form;
				}		
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
  		}
	}
	
	public function getenquirystatusbdAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$enquirystatus = new Application_Model_EnquiryStatusDataMapper();
			$enquries = $enquirystatus->fetchAll();
			$enquirystatusList[] = array('key'=>'','value'=>'Select Status');   	   
    		foreach($enquries as $enquiry){
    			$enquirystatusList[] = array('key'=>$enquiry->getId(),'value'=>$enquiry->getDescription());
    	 	} 
			$jsonObj = json_encode($enquirystatusList);
			echo $jsonObj;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function editenquirylogAction()
	{
		try{
			$this->_helper->layout()->setLayout('restaurantuserlayout');
			$auth = Zend_Auth::getInstance();
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				if($this->getRequest()->isPost()){
					$result = $this->_firmService->editEnquiryLog($this->getRequest()->getPost(),$data);
					if($result){
						return $this->_helper->_redirector('manageinquiries','Firm','FirmManagement',array('restaurantid'=>$request->restaurantid));
					}
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getenquirylogAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$result = $this->_firmService->getEnquiryLog($request);
			$jsonObj = json_encode($result);
			echo $jsonObj;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getconusdeatilsajaxAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->GetContactUsDeatils($request);
			echo json_encode($result);
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	
	public function closerestcontactusAction()
	{
		try{
			$this->_helper->layout()->setLayout('restaurantuserlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$status = $this->_firmService->CloseContactUsDeatils($request);
				if($status){
					return $this->_helper->redirector('manageinquiries','Firm','FirmManagement',array('restaurantid'=>$request->restaurantid));
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function pickreservelistplotAction()
		{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$total = $request->total;
			$cancel = $request->cancel;
			$noshow = $request->noshow;
			$resultSet = array();
				$res = $this->_firmService->GeneratersvChart($request);
				$resultSet['resName'] = $res;
				if($resultSet){
					echo json_encode($resultSet);
				}else{
					echo json_encode("f");
				}
//			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function retrievereservelistplotbydateAction()
		{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$total = $request->total;
			$cancel = $request->cancel;
			$noshow = $request->noshow;
			$resultSet = array();
				$resultSet = $this->_firmService->getReservationReportByStatus($request);
			//	$resultSet['resName'] = $res;
				if($resultSet){
					echo json_encode($resultSet);
				}else{
					echo json_encode("f");
				}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	

	public function freemobilewebsiteAction()
    {
    	try{
			$this->_helper->layout()->setLayout('restaurantuserlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();	
		     
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
    }
    
	public function updatepresidAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			if($auth->hasIdentity()){			
				$request = $this->getRequest();
				$restNameList = $this->_firmService->updatepresid($request);
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				if ($data['Usertype'] == "ADM" || $data['Usertype'] == "RSO" ) {
					$session = array();	
					$userMapper = new User_Model_ManagerDataMapper;
					$session = $data;
					$session['RestId'] = $request->presid;
					$storage->write($session);
				} else {
					$session = array();	
					$userMapper = new User_Model_ManagerDataMapper;
					$session = $data;
					$session['RestId'] = $request->presid;
					$storage->write($session);				
				}
				return $restNameList;	
			}else{
			$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function getfloordiningdatabyajaxAction()
	{
		try{
			$request = $this->getRequest();
			$resId = $request->resid;
			$diningid = $request->diningid;
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			if($request){
				$resultSet  = $this->_firmService->getstatusbydiningId($resId,$diningid);
				$resultArr   = $this->_firmService->getRestFloorPlan($resId,$diningid);
				$floorSepArr = $this->_firmService->getRestFloorSeprators($resId,$diningid);
			}
			if($resultArr){
					echo json_encode(array('layout' => $resultArr['finalStr'], 'entrance' => $resultArr['etnStr'],'seperator' => $floorSepArr,'statusdetails' => $resultSet));
			}		
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
/**
	 * action to edit dining area status by ajax
	 */
	public function updatefloorareastatuspostAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->EditDiningAreaStatus($request);
			if($result){
				echo json_encode($result);
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
// Faiz: The Below Action is to fetch the color codes data. We are calling this from Manageinquiries.phtml in the form of ajax. From  this action we are calling to a function present in restaurant service.//

	public function getcontcustomizewidgetAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			
			$settings = $this->_firmService->getContCustomizeWidgetByResid($request->restaurantid);
			if($settings){
				echo json_encode($settings);
			}else{
				echo json_encode('f');
			}			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function updatedefaultviewsettingAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				$userid = $data['User_Id'];
				$usertype = $data['Usertype'];
				$result = $this->_firmService->Updatedefaultviewsetting($request,$userid,$usertype);
				if($result){
					echo json_encode($result);
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getdefaultviewstatusAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();				
				$userid = $data['User_Id'];
				$usertype = $data['Usertype'];
				$result = $this->_firmService->Getdefaultviewstatus($userid,$usertype);						
				if($result){
					echo json_encode($result);
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function deletewidgetbackgroundimageAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			
			$settings = $this->_firmService->deletewidgetbackgroundbyresid($request->restaurantid);
			if($settings){
				echo json_encode($settings);
			}else{
				echo json_encode('f');
			}			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function menuexportpdfAction(){
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$pdf = $this->_firmService->menuzendpdf($request);
			$file = 'managerest/'.$request->restaurantid.'/menu/'.$request->restaurantid.'.pdf';
			
			$size = filesize($file);		
			if (file_exists($file))
			{
				header("Content-type: application/force-download");
				header("Content-Transfer-Encoding: Binary");
				header('Content-Length: '.$size);
				header("Content-disposition: attachment; filename=".basename($file));
				readfile($file);
	
			}
		}catch (Exception $ex){			
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function socialmenuexportpdfAction(){
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$pdf = $this->_firmService->menuzendpdf($request);
			$file = 'managerest/'.$request->restaurantid.'/menu/'.$request->restaurantid.'.pdf';
			
			$size = filesize($file);		
			if (file_exists($file))
			{
				header("Content-type: application/force-download");
				header("Content-Transfer-Encoding: Binary");
				header('Content-Length: '.$size);
				header("Content-disposition: attachment; filename=".basename($file));
				readfile($file);
	
			}
		}catch (Exception $ex){			
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function sendbulksmsAction()
	{
		try{
			$this->_helper->layout()->setLayout('restaurantuserlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){				
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();	
		        $request = $this->getRequest();
				$page = $this->_request->getParam('page');
				if (empty($page)){
					$page = 1;
				}else{
					$this->view->tabview = true;
			    }
			    $pageview = 1;
				if(isset($request->restaurantid)){
					$restId = $request->restaurantid;
				}else{
					$restId = $data['RestId'];
				}
				//CHECK FOR RDINE LINK 
				$appNameSpace = new Zend_Session_Namespace('SMSData');
				$smsForRdineFlag = false;
				$rdineLinks = $appNameSpace->smsdata;

				//GET GROUPS DATA
				$contactGroups = $this->_firmService->getContactGroupsByResId($restId);
				
				$this->view->contactGroups = $contactGroups;


				$smsMaxLength = 160;
				if(array_key_exists($restId, $rdineLinks))
				{
					$smsForRdineFlag = true;
					$smsMaxLength -= strlen("BOOK ON ".$rdineLinks[$restId]);
				}
				$this->view->smsForRdineFlag = $smsForRdineFlag;
				$this->view->smsMaxLength = $smsMaxLength;


			    $timeZone = $this->_firmService->GetRestaurantTimeZone($restId);
				date_default_timezone_set($timeZone);
				$countrycodeMap = new Reservation_Model_ReservationDataMapper();
				$countrycode = $countrycodeMap->getRestaurantLocByResId($restId);
				$this->view->lowBalanceIndicator = false;
				//if(($countrycode->state == 'IND')){		
				if(true){			    
					$smscampMapper = new FirmManagement_Model_SmsCampaignDataMapper();														
			        if($this->getRequest()->isPost()){
				        if($request->pageview){
							$pageview = $this->_request->getParam('pageview');
							if (empty($pageview)){
								$pageview = 1;
							}else{
								$this->view->tab2view = true;
						    }
						}else{
				       		$request = $this->getRequest()->getPost();
				       		//INDIAN SMS GATEWAY ASUSUAL
				       		$status = $this->_firmService->sendSmsCampaignWithRdLabs($request,$data);
				       		if($status == null)
				       		{
				       			$this->view->lowBalanceIndicator = true;

				       		}
				       		else {
				       			$this->view->lowBalanceIndicator = false;
				       			if($status && $request['sendsocial']){
								return $this->_helper->redirector('managesocialmedia','Social','SocialMedia',array('smscampid'=>$status));
								}else if($status){
									$this->view->tabview = true;
								}	
				       		}
								
						}
			    	}
					
					$result = $this->_firmService->getphonenumbersbyresId($restId);
					$result['phonestring'] = implode(',', $result['phonestring']);
					$resultSet = $smscampMapper->GetSmsCampaignDetailsbyresId($data,$page);	
					$accountMapper = new FirmManagement_Model_SmsRestaurantSubscriptionDataMapper();
					$accountSet = $accountMapper->GetRestCreditsAccountDetails($data,$pageview);		
					$leftmessageMapper = new FirmManagement_Model_SmsRestaurantCampCountDataMapper();
					$leftmessage = 	$leftmessageMapper->getLeftMessagesCountByResid($restId);	
					if($leftmessage){
						if($leftmessage != 'noaccess'){
							$this->view->leftmessage = $leftmessage;
						}
					}else{
						$this->view->leftmessage = '0';
					}
					$this->view->restaurantid = $restId;
					//$this->view->phonenum = $result['phonestring'];
					$this->view->phonenumCount = $result['countNumbers'];
					$this->view->resultSet = $resultSet;
					$this->view->accountSet = $accountSet;
				}else{
					$this->view->notIndia = $countrycode->state;
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}	
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getsmscampaigndetailsbycampidAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			
			$campdetails = $this->_firmService->getSmsCampaignDetailsByCampid($request);
			if($campdetails){
				echo json_encode($campdetails);
			}else{
				echo json_encode('f');
			}			
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function checktagAction(){
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->CheckTag($request);
			if($result){
				echo json_encode($result);
			}else{
				echo json_encode('f');
			}
		}catch (Exception $ex){			
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function smsbackgroundupdationAction(){
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->Smsbackgroundcall();
			if($result){
				return $this->_helper->redirector('smscreditsreport','Administrator','Administrator',array('msg'=>true));
			}else{
				return $this->_helper->redirector('smscreditsreport','Administrator','Administrator',array('msg'=>false));
			}
		}catch (Exception $ex){			
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	
	public function sendrequestforcreditsAction(){
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();	
				$request = $this->getRequest();
				$result = $this->_firmService->SendRequestForCredits($request,$data);
				if($result){
					echo json_encode($result);
				}else{
					echo json_encode('f');
				}
			}
		}catch (Exception $ex){			
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function retreivetimezonesbycountryidAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$resultObj = $this->_firmService->getTimezonesbystateId($request);
			$jsonObj = json_encode($resultObj);
			echo $jsonObj;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	/**
	 * Constant Contacts
	 * Enter description here...
	 * @return unknown_type
	 */
	public function constcontactsettingsAction()
	{
		try{
			
			$auth = Zend_Auth::getInstance();
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			$request = $this->getRequest();
			if($request->restaurantid){
				$resStat = $this->_firmService->AuthenticateRestByAuth($data,$request->restaurantid);
			}else{
				$resStat = false;
			}
			$this->view->secureLoginStatus = $resStat;
			if($resStat){
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				if($auth->hasIdentity()){
					$manageForm = $this->_firmService->getManageConstantContactForm();
					
					if($request->isPost()){
						$result = $this->_firmService->ManageConstantContactSettings($this->getRequest()->getPost(),$data);
						if($result['status']){
							$restResult = $result['result'];
							$this->view->result = $restResult['result'];
							$this->view->frmaction = $restResult['action'];
							$this->view->manageForm = $manageForm;						
						}else{
							$this->view->result = 'false';
							$this->view->manageForm = $result['form'];
						}
					}else{
						$this->view->manageForm = $manageForm;					
					}
					$settings = $this->_firmService->GetConstContactSettings($request);
					if($settings){
						$lookupuser = $this->_firmService->LookUpConstContactUser($request);
						if($lookupuser){
							$this->view->lookUpUser = "Y";
							$this->view->contactList = $this->_firmService->GetConstContactList($request);
						}else{
							$this->view->lookUpUser = "N";
						}
					}
				    
					$syncReport = $this->_firmService->GetContactSyncReport($request);
				    
					$this->view->settings = $settings;
					$this->view->syncReport = $syncReport;
					$this->view->restaurantid = $request->restaurantid;
				}else{
					$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
				}
			}
				
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function synccontactsAction()
	{
		$request = $this->getRequest();
		try{
		$this->_helper->layout->disableLayout();
		$this->_helper->viewRenderer->setNoRender();
			$auth = Zend_Auth::getInstance();	
			if($auth->hasIdentity()){				
								
				$this->_firmService->SyncContactsToConstContact($request);
				$this->_helper->redirector('constcontactsettings','Firm','FirmManagement',array('restaurantid' => $request->restaurantid));
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
			$this->_helper->redirector('constcontactsettings','Firm','FirmManagement',array('restaurantid' => $request->restaurantid));
		}		
	}
	
	public function verifyconstconatctaccountAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();				
			$result = $this->_firmService->VerifyConstContactAccount($request);
			if($result){
				$this->_helper->redirector('constcontactsettings','Firm','FirmManagement',array('restaurantid' => $request->restaurantid));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function configureconstcontactAction()
	{
		try{
			
			$auth = Zend_Auth::getInstance();			
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				if($request->restaurantid){
					$resStat = $this->_firmService->AuthenticateRestByAuth($data,$request->restaurantid);
				}else{
					$resStat = false;
				}
				$this->view->secureLoginStatus = $resStat;
				if($resStat){
					$this->_helper->layout()->setLayout('restaurantuserlayout');
					$manageForm = $this->_firmService->getManageConstantContactForm();
					
					if($request->isPost()){
						$result = $this->_firmService->ManageConstantContactSettings($this->getRequest()->getPost(),$data);
						if($result['status']){						
							$this->_helper->redirector('constcontactconfirm','Firm','FirmManagement',array('restaurantid' => $request->restaurantid));							
						}else{						
							$this->view->manageForm = $result['form'];
						}
					}else{
						$this->view->manageForm = $manageForm;					
					}
					
					$this->view->restaurantid = $request->restaurantid;
				}
				
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function constcontactconfirmAction()
	{
		try{
			$this->_helper->layout()->setLayout('restaurantuserlayout');
			$auth = Zend_Auth::getInstance();	
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$this->view->restaurantid = $request->restaurantid;
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * Mail Chimp
	 * Enter description here...
	 * @return unknown_type
	 */
	public function mailchimpsettingsAction()
	{
		try{
			
			$auth = Zend_Auth::getInstance();
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			$request = $this->getRequest();
			if($request->restaurantid){
				$resStat = $this->_firmService->AuthenticateRestByAuth($data,$request->restaurantid);
			}else{
				$resStat = false;
			}
			$this->view->secureLoginStatus = $resStat;
			if($resStat){
				$this->_helper->layout()->setLayout('restaurantuserlayout');
				if($auth->hasIdentity()){
					$manageForm = $this->_firmService->getManageMailChimpForm();
					
					if($request->isPost()){
						$result = $this->_firmService->ManageMailChimpSettings($this->getRequest()->getPost(),$data);
						if($result['status']){
							$restResult = $result['result'];
							$this->view->result = $restResult['result'];
							$this->view->frmaction = $restResult['action'];
							$this->view->manageForm = $manageForm;						
						}else{
							$this->view->result = 'false';
							$this->view->manageForm = $result['form'];
						}
					}else{
						$this->view->manageForm = $manageForm;					
					}
					$settings = $this->_firmService->GetMailChimpSettings($request);
					if($settings->rmcs_apikey){
						$lookupuser = $this->_firmService->LookUpMailChimpUser($request);
						if($lookupuser){
							$this->view->lookUpUser = "Y";
							$this->view->contactList = $this->_firmService->GetMailChimpList($request);
						}else{
							$this->view->lookUpUser = "N";
						}
					}
				    
					$syncReport = $this->_firmService->GetMailChimpSyncReport($request);
				    
					$this->view->settings = $settings;
					$this->view->syncReport = $syncReport;
					$this->view->restaurantid = $request->restaurantid;
				}else{
					$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
				}
			}
				
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function synccontactsmailchimpAction()
	{
		$request = $this->getRequest();
		try{
		$this->_helper->layout->disableLayout();
		$this->_helper->viewRenderer->setNoRender();
			$auth = Zend_Auth::getInstance();	
			if($auth->hasIdentity()){				
								
				$this->_firmService->SyncContactsToMailChimp($request);
				$this->_helper->redirector('mailchimpsettings','Firm','FirmManagement',array('restaurantid' => $request->restaurantid));
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
			$this->_helper->redirector('mailchimpsettings','Firm','FirmManagement',array('restaurantid' => $request->restaurantid));
		}		
	}
	
	public function verifymailchimpaccountAction()
	{
		try{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();				
			$result = $this->_firmService->VerifyMailChimpAccount($request);
			if($result){
				$this->_helper->redirector('mailchimpsettings','Firm','FirmManagement',array('restaurantid' => $request->restaurantid));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function configuremailchimpAction()
	{
		try{
			
			$auth = Zend_Auth::getInstance();			
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				if($request->restaurantid){
					$resStat = $this->_firmService->AuthenticateRestByAuth($data,$request->restaurantid);
				}else{
					$resStat = false;
				}
				$this->view->secureLoginStatus = $resStat;
				if($resStat){
					$this->_helper->layout()->setLayout('restaurantuserlayout');
					$manageForm = $this->_firmService->getManageMailChimpForm();
					
					if($request->isPost()){
						$result = $this->_firmService->ManageMailChimpSettings($this->getRequest()->getPost(),$data);
						if($result['status']){						
							$this->_helper->redirector('mailchimpconfirm','Firm','FirmManagement',array('restaurantid' => $request->restaurantid));							
						}else{						
							$this->view->manageForm = $result['form'];
						}
					}else{
						$this->view->manageForm = $manageForm;					
					}
					
					$this->view->restaurantid = $request->restaurantid;
				}
				
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function mailchimpconfirmAction()
	{
		try{
			$this->_helper->layout()->setLayout('restaurantuserlayout');
			$auth = Zend_Auth::getInstance();	
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$this->view->restaurantid = $request->restaurantid;
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
			
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function feedbacksettingsAction()
	{
		try{
			$this->_helper->layout()->setLayout('global_settings_layout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
                            $this->view->currentPageName = 'feedbacksettings';
				$request = $this->getRequest();
				$questionsList = $this->_firmService->feedbackSettingsByRestaurantId($request);
				//$activecount = $this->_firmService->checkFeedbackQuestionsActiveCountByrestId($request);
				$ddfeedbackquestionstype = new Application_Model_FeedbackQuestionsTypeDataMapper();
				$this->view->feedbackquestionstype = $ddfeedbackquestionstype->fetchAll(); 
				$this->view->list = $questionsList;
				$this->view->restaurantid = $request->restaurantid;
				//$this->view->activecount = $activecount;
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function changefeedbackquestionstatusAction()
    {
    	try{
    		$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			
			$request = $this->getRequest();
	    	$result = $this->_firmService->changeFeedbackQuestionStatus($request);
			if(	$result){
				echo json_encode($result);
			}else{
				echo json_encode('f');
			}
    	}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
    }
    
    public function getfeedbackqueandansbyidAction()
    {
    	try{
    		$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			
			$request = $this->getRequest();
	    	$result = $this->_firmService->getFeedbackQuestionAndAnswerById($request);
			if(	$result){
				echo json_encode($result);
			}else{
				echo json_encode('f');
			}
    	}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
    }
    
	public function updatefeedbackquestionandanswerbyidAction()
    {
    	try{
    		$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			
			$request = $this->getRequest();
	    	$result = $this->_firmService->updateFeedbackQuestionAndAnswerById($request);
			if(	$result){
				echo json_encode('t');
			}else{
				echo json_encode('f');
			}
    	}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
    }
    
    public function addfeedbackquestionandanswerAction()
    {
   		try{
    		$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			
			$request = $this->getRequest();
	    	$result = $this->_firmService->addFeedbackQuestionAndAnswer($request);
			if($result){
				echo json_encode('t');
			}else{
				echo json_encode('f');
			}
    	}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}    		
    }
    
    public function customerfeedbackfrommailAction()
    {
    	try{
    		$this->_helper->layout()->setLayout('mtlogin');
    		$request = $this->getRequest();
	    	$result = $this->_firmService->getFeedbackformByrestId($request);
	    	if($result['status']){
		    	$this->view->feedbackdetails = $result['feedbackdetails'];
		    	$this->view->restdetails = $result['details'];
		    	$this->view->status = true;
	    	}else{
	    		$this->view->restdetails = $result['details'];
	    		$this->view->status = false;
	    	}
	    	$this->view->restaurantid = $result['details']['restaurantid'];
	    	$this->view->bookingid = $request->bookingid;
    	}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		} 
    }
	
	
	public function savecustomerfeedbackAction()
    {
   		try{
    		$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			
			$request = $this->getRequest();
	    	$result = $this->_firmService->saveCustomerFeedback($request);
			if($result){
				echo json_encode('t');
			}else{
				echo json_encode('f');
			}
    	}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}    		
    }
    
	public function saverestaurantpasswordbyajaxAction()
    {
   		try{
    		$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();		
				$request = $this->getRequest();
				if($request->isPost()){
					if($data['Usertype'] == 'ADM' || $data['Usertype'] == 'ADU'){
						$result = $this->_firmService->RestaurantPassword($this->getRequest()->getPost(),$data['restownerId']);
					}else{
						$result = $this->_firmService->RestaurantPassword($this->getRequest()->getPost(),$data['User_Id']);
					}
					if($result){
						echo json_encode('t');
					}else{
						echo json_encode('f');
					}
				}
			}
    	}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}    		
    }
    
    public function getrestaurantidbyrestnameAction()
    {
    	try{
    		$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
    		$result = $this->_firmService->getRestaurantIdByRestaurantName($request);
			if($result != 0){
				echo json_encode($result);
			}else{
				echo json_encode('f');
			}
    	}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
    }
    
    public function checkrestaurantidvalidAction()
    {
    	try{
    		$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
    		$result = $this->_firmService->checkRestaurantIdValid($request);
			if($result){
				echo json_encode('t');
			}else{
				echo json_encode('f');
			}
    	}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
    }
    
	public function savefirmreservationdiscountAction()
	{
		try{
			$request = $this->getRequest();
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$resultObj = $this->_firmService->savereservationdiscount($request);
			if($resultObj){
				$jsonObj = json_encode($resultObj);
			}else{
				$jsonObj = json_encode('f');
			}
			echo $jsonObj;
		}catch(Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function removefirmfeedbackphonebyajaxAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_firmService->deleteResFeedbackPhone($request);
				if($result){
					echo 't';
				}else{
					echo 'f';
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}		
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function changestatusoffeedbackphoneAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_firmService->changefeedbackphonestatus($request);
				if($result){
					echo 't';
				}else{
					echo 'f';
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}		
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function deletecontactAction()
	{
		try{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$this->_helper->layout->disableLayout();
				$this->_helper->viewRenderer->setNoRender();
				$request = $this->getRequest();
				$result = $this->_firmService->deleteContact($request);
				if($result){
					echo 't';
				}else{
					echo 'f';
				}
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}		
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function createemailmarketingtemplateAction()
	{
		try{
			$this->_helper->layout()->setLayout('restaurantuserlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$request = $this->getRequest();
				if($request->restaurantid){
					$resStat = $this->_firmService->AuthenticateRestByAuth($data,$request->restaurantid);
				}else{
					$resStat = false;
				}
				$this->view->secureLoginStatus = $resStat;
				if($resStat){
					if($request->msg){
						$this->view->msg = "Your Email Marketing request has been sent successfully. Our staff will get back to you through email or phone.";
					}
					
					$this->view->restaurantid = $request->restaurantid;
					$Service = new Application_Service_Firm();
					$form = $Service->getEmailMarketingCreationForm();
					if($this->getRequest()->isPost()){
						$result = $Service->EmailTemplateCreation($this->getRequest()->getPost(),$request,$data);
						if(isset($result['msgid'])){
							return $this->_helper->redirector('createemailmarketingtemplate','Firm','FirmManagement',array('restaurantid' => $request->restaurantid,'msg'=>true));
						}
						if(isset($result['form'])){
							$this->view->form = $result['form'];
						}
					}else{
						$this->view->form = $form;
					}
				}
				
			}else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function emailmarketrecordsAction()
	{
		try{
			$this->_helper->layout()->setLayout('restaurantuserlayout');
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
	        	$page = $this->_request->getParam('page');
				 if (empty($page)){
					$page = 1;
				 }
				 $storage = new Zend_Auth_Storage_Session();
				 $sesdata = $storage->read();
				 $request = $this->getRequest();
				 $restid = $request->restaurantid;  
				 if($restid){
				 	 $resStat = $this->_firmService->AuthenticateRestByAuth($sesdata,$restid);
				 }else{
				 	 $resStat = false;
				 }
				 $this->view->secureAccess = $resStat;
				 if($resStat){			 	
				 	 $adminService = new Application_Service_Administrator();	
				     $form = $adminService->getEmailMarketSearchForm();
					 $data = array();
					 if($this->getRequest()->isPost()){
						$data = $this->getRequest()->getPost();
						$form->populate($data);
						$this->view->form = $form;
						$this->view->startDate = $data['DP-startDate'];
						$this->view->endDate = $data['DP-endDate'];
					 }else{
					 	$this->view->form = $form;
					 }
					 $resultSet = $this->_firmService->GetEmailMarketRecordsByRestId($page,$data,$restid);
					 $this->view->resultSet = $resultSet;
					 $this->view->restaurantid = $restid;
				}
			}else{
					$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}	
	
	/**
	 * ADD SESSION ALERTS
	 */
	public function addalertsajaxAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$auth = Zend_Auth::getInstance();
			$request = $this->getRequest();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				if($request->isPost())
				{
					$result = $this->_firmService->addSessionAlerts($request,$data['User_Id']);
					echo json_encode($result);
				}
			}
			else
			{
				echo json_encode(array('status'=>false,'err'=>'Please Check the Login'));
			}

		}
		catch(Exception $ex)
		{
			throw new Exception($ex->getMessage());
			
		}
	}

	/**
	 * GET SESSION ALERTS IN JSON
	 */
	public function getsessionalertsAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$auth = Zend_Auth::getInstance();
			$request = $this->getRequest();
			$result = $this->_firmService->getSessionAlerts($request);
			echo json_encode($result);

		}
		catch(Exception $ex)
		{
			throw new Exception($ex->getMessage());
			
		}
	}

	/**
	 * GET SEESION ALERTS COUNT
	 */
	
	public function getsessionalertscountAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$auth = Zend_Auth::getInstance();
			$request = $this->getRequest();
      
			$result = $this->_firmService->getSessionAlertsCount($request);
			echo json_encode($result);

		}
		catch(Exception $ex)
		{
			throw new Exception($ex->getMessage());
			
		}
	}

	/**
	 * UPDATE MAX COUNT AJAX
	 */
	public function updatemaxcountajaxAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();
			$result = $this->_firmService->AddMaxCountAjax($request);
			echo json_encode($result);
		}
		catch(Exception $ex)
		{
			throw new Exception($ex->getMessage());	
		}
	}

	/**
	Delete a alert
	**/
	public function deletealertsajaxAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();	
			$result = $this->_firmService->deleteSessionAlert($request);
			echo json_encode($result);
		}
		catch(Exception $ex)
		{
			throw new Exception($ex->getMessage());	
		}
	}

	/**
	EDIT ALERT
	**/
	public function editalertsajaxAction()
	{
		try
		{
			$this->_helper->layout->disableLayout();
			$this->_helper->viewRenderer->setNoRender();
			$request = $this->getRequest();	
			$result = $this->_firmService->editSessionAlert($request);
			echo json_encode($result);
		}
		catch(Exception $ex)
		{
			throw new Exception($ex->getMessage());	
		}
	}

	/**
	 * SETTINGS HOME PAGE
	 */
	public function settingshomeAction()
	{
		try
		{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$storage = new Zend_Auth_Storage_Session();
				$request = $this->getRequest();
				$resid = $request->restaurantid;
				$userdata = $storage->read();
				$userdata['RestId'] = $resid;
				$storage->write($userdata);
				$this->view->urlResid = $resid;
				$this->_helper->layout()->setLayout('global_settings_layout');

			}
			else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}
		catch(Exception $ex)
		{
			throw new Exception($ex->getMessage());	
		}
	}

	/**
	 * [taxationsettingsAction description]
	 * @return [type] [description]
	 */
	public function taxationsettingsAction()
	{
		try
		{
			$auth = Zend_Auth::getInstance();
			if($auth->hasIdentity()){
				$request = $this->getRequest();
				$resid = $request->restaurantid;
				$this->view->urlResid = $resid;
				$this->_helper->layout()->setLayout('global_settings_layout');
				$apiService = new Application_Service_ApiService();
				$data = $apiService->getTaxRulesByRestaurantId($resid);
				$this->view->data = $data;
				$this->view->currentPageName = 'taxationsettings';
			}
			else{
				$this->_redirect($this->view->url(array('module'=>'User','controller'=>'Login', 'action'=>'signin'),'login',true));
			}
		}
		catch(Exception $ex)
		{
			throw new Exception($ex->getMessage());	
		}
	}

	public function updatetaxruleAction()
	{
		$this->_helper->layout->disableLayout();
		$this->_helper->viewRenderer->setNoRender();
		$request = $this->getRequest();
		$storage = new Zend_Auth_Storage_Session();
		$user = $storage->read();
		$userid = $user['User_Id'];
		if($request->isPost())
		{
			$response = $this->_firmService->updateTaxRule($request->getPost(),$userid);
			if($response>0)
			{
				echo json_encode(array('status'=>true));
			}
		}
		else
		{
			echo json_encode(array('status'=>false,'message'=>'Inalid request type'));
		}
	}

	public function addtaxruleAction()
	{
		$this->_helper->layout->disableLayout();
		$this->_helper->viewRenderer->setNoRender();
		$request = $this->getRequest();
		$storage = new Zend_Auth_Storage_Session();
		$user = $storage->read();
		$userid = $user['User_Id'];
		if($request->isPost())
		{
			$response = $this->_firmService->addTaxRule($request->getPost(),$userid);
			if($response>0)
			{
				echo json_encode(array('status'=>true));
			}
		}
		else
		{
			echo json_encode(array('status'=>false,'message'=>'Inalid request type'));
		}
	}
        public function paymentduealertAction()
        {
            try{
                $this->_helper->layout->disableLayout();
		$this->_helper->viewRenderer->setNoRender();
		$request = $this->getRequest();
		$storage = new Zend_Auth_Storage_Session();
		$data = $storage->read();
		$restaurantid = $data['RestId'];
                $result = $this->_firmService->paymentDueAlert($restaurantid);
                if($result){
                echo json_encode(array('status'=>'t', 'msg'=>'Paid'));    
                }else{
                echo json_encode(array('status'=>'f', 'msg'=>'Not Paid'));    
                }
                
            }catch(Exception $ex)
		{
			throw new Exception($ex->getMessage());	
		}
            
        }
}
