<?php

class Reservation_Model_SearchListViewDataMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('FirmManagement_Model_DbTable_FirmSchedule');
		}
		return $this->_dbTable;
	}

	public function getSearchList(Reservation_Model_SearchListView  $searchList)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$endTime = $searchList->getTime();
			$time = explode(" ",$endTime);
			$timeHM = explode(":",$time[0]);
			if($time[1] ==  "PM"){
				if((int)$timeHM[0] != 12){
					(int)$timeHM[0] += 12;
				}
			}//if the time is PM than adding 12 to hours
			if($time[1] ==  "AM" && (int)$timeHM[0] == 12){

				(int)$timeHM[0] = 0;

			}
			$timezone = "";
			if($searchList->getResId()){
				$mapper = new FirmManagement_Model_FirmDataMapper();
				$timezone = $mapper->GetRestaurantTimeZone($searchList->getResId());
				date_default_timezone_set($timezone);
			}
			
			$todayDateSplit = explode("-",$searchList->getDate());
			$todayDateSplit[1] = $todayDateSplit[1];
			$todayDateArray = array($todayDateSplit[0],$todayDateSplit[1],$todayDateSplit[2]);
			$today = implode("-",$todayDateArray);

			$userTimeSec = mktime($timeHM[0],$timeHM[1],0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
			$userTime = date("h:i A",$userTimeSec);

			$todayTimeSec = mktime(21,0,0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
			$todayTime = date("h:i A",$todayTimeSec);

			$endTimeSec = mktime($timeHM[0]+3,(int)$timeHM[1],0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
			$endTime =  date("h:i A",$endTimeSec);

			$datesplit = explode("-",$searchList->getDate());
			$datesplit[1] = $datesplit[1]+1;
			$datearray = array($datesplit[0],$datesplit[1],$datesplit[2]);
			$tomorrow = implode("-",$datearray);//next days date
			$tomorrowTimeSec = mktime(00,(int)00,0,$datesplit[1],$datesplit[0],$datesplit[2]);
			$tomorrowTime = date("h:i A",$tomorrowTimeSec);//12:00AM
			if($userTimeSec >= $todayTimeSec && $endTimeSec <= $tomorrowTimeSec){
				$endTimeSec = mktime(23,(int)59,0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
				$endTime =  date("h:i A",$endTimeSec);
			}
			$todayThreeTimeSec = mktime(3,0,0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
			$todayThreeTime = date("h:i A",$todayThreeTimeSec);

			$todayLastTimeSec = mktime(00,(int)00,0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
			$todayLastTime = date("h:i A",$todayLastTimeSec);

			$startTimeSec = mktime($timeHM[0]-3,(int)$timeHM[1],0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
			$startTime =  date("h:i A",$startTimeSec);
			if($userTimeSec <= $todayThreeTimeSec && $startTimeSec <= $todayLastTimeSec){
				$startTimeSec = mktime(0,(int)0,0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
				$startTime =  date("h:i A",$startTimeSec);
			}
			
			/* Retrieve the special schedule dates */
			
			$restSplSchMapperObj = new FirmManagement_Model_FirmSpecialScheduleMapper();
			$restSplSchTable  = $restSplSchMapperObj->getDbTable();
			$restSplSchSelect = $restSplSchTable->select();
			$restSplSchSelect->from($restSplSchTable,array('rsesid','rsesfk_restaurant'))
							 ->where('rsesstatus = ?',true)
							 ->where('rseseventdate = ?',$searchList->getDate());
							 
			$restSplSchRowset = $restSplSchTable->fetchAll($restSplSchSelect);
			$restSplSchArray = array();

			foreach($restSplSchRowset as $restSplSchRow){
				$restSplSchArray[$restSplSchRow->rsesfk_restaurant]	= $restSplSchRow->rsesid; 
			}

			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);

			$select->from(array('sch'=>'mt.restaurant_schedule'),array('sch.rssid','sch.rssfk_restaurant','sch.rssstart_time','sch.rssday_of_week','rssfk_special_event_schedule'));
			$select->where('sch.rssstart_time >= ?' , $startTime);
			$select->where('sch.rssstart_time <= ?' , $endTime);
			$select->where('sch.rssday_of_week = ?', trim($searchList->getDay()));
			$select->where('sch.rssstatus = ?',true);					
			$select->join(array('res'=>'mt.restaurant'),'res.resid = sch.rssfk_restaurant',array('res.resid','resrestaurant_name','resdescription','resimage','resaddress','reslatitude','reslongitude','resprice'));
			$select->where('res.resstatus = ?',1);
			$select->where('res.resapprovalstatus = ?',1);
			//$select->where('res.resstate_id = ?',$searchList->getState());
			//$select->where('res.resregion_id = ?',$searchList->getRegion());
			$select->where('res.rescity_id = ?',$searchList->getCity());
			$select->join(array('rst'=>'mt.restaurant_schedule_table'),'sch.rssid = rst.rstfk_restaurant_schedule',array('rstid as invetory_id','rst.rstno_of_tables','rst.rsttable_pax'));
			$select->where('rst.rststatus = ?',true);
			$tablePax = $searchList->getPax();
			if($tablePax == 1 || $tablePax == 19){
				$select->where("rst.rsttable_pax = $tablePax OR rst.rsttable_pax = $tablePax + 1");
			}else if($tablePax >= 2 && $tablePax < 19){
				$select->where("rst.rsttable_pax = $tablePax OR rst.rsttable_pax = $tablePax + 1 OR rst.rsttable_pax = $tablePax + 2 ");

			}else if($tablePax == 20){
				$select->where("rst.rsttable_pax = $tablePax");
			}else if($tablePax > 20){
				$select->where("rst.rsttable_pax = $tablePax OR rst.rsttable_pax = $tablePax + 1 OR rst.rsttable_pax = $tablePax + 2 ");
			}
			if($searchList->getResId()){
				$select->where('res.resid = ?',$searchList->getResId());
			}
			if($searchList->getRestaurantname()){
				$select->where('res.resrestaurant_name ILIKE(?)','%'.$searchList->getRestaurantname().'%');
			}	
			if($searchList->getPrice()){
				$select->where('res.resprice = ?',$searchList->getPrice());
			}
			if($searchList->getNeighbor()){
				$select->where('res.resneighborhood_id = ?',$searchList->getNeighbor());
			}
			if($searchList->getCuisine()){
				$select->join(array('rsc'=>'mt.restaurant_cuisine'),'res.resid = rsc.rcsfk_restaurant');
				$select->where('rsc.rscfk_restauranttype_id = ?',$searchList->getCuisine());
			}
			$select->join(array('nei'=>'mt.neighborhood_bd'),'nei.id = res.resneighborhood_id',array('description as neighbor'));
			$select->order(array('res.resid','sch.rssstart_time'));
			$rowset = $table->fetchAll($select);

			$resultSet = array();

			$restaurantDet 	= array();
			$time_pax   	= array();
			$resStartTime	= null;
			$restid 		= null;
			$restname 		= null;
			$restdesc		= null;
			$restaddress 	= null;
			$restimage 		= null;
			$restlatitude 	= null;
			$restlongitude 	= null;
			$neighbor 		= null;
			$price 			= null;
			$table_count 	= null;
			$invetory_id    = null;
			$pax 			= null;
			$rssid 			= null;
			$status			= null;
			$newpax			= null;
			$newstatus		= null;
			$newinvetory_id = null;
			$newtable_count = null;
			$SqlResult 	    = false;
			$result 		= array();

			//Sorting of the Sql Result with required Pax and Status

			foreach($rowset as $row){
				if(count($restSplSchArray) && array_key_exists($row->rssfk_restaurant,$restSplSchArray)){
					if($restSplSchArray[$row->rssfk_restaurant] == $row->rssfk_special_event_schedule){
						if($restid == null && $resStartTime == null && $pax == null){
							$restid 	   = $row->rssfk_restaurant;
							$restname 	   = $row->resrestaurant_name;
							$restdesc	   = $row->resdescription;
							$restaddress   = $row->resaddress;
							$restimage 	   = $row->resimage;
							$restlatitude  = $row->reslatitude;
							$restlongitude = $row->reslongitude;
							$neighbor 	   = $row->neighbor;
							$price 		   = $row->resprice;
							$resStartTime  = $row->rssstart_time;
							$invetory_id   = $row->invetory_id;
							$pax    	   = $row->rsttable_pax;
							$table_count   = $row->rstno_of_tables;
							$rssid         = $row->rssid;
							$date          = $searchList->getDate();
							$status = $this->timeBookingStatus($restid,$date,$resStartTime,$pax,$table_count,$rssid);
		
						}//Initial initialization of the values
						else if($restid == $row->rssfk_restaurant && $resStartTime == $row->rssstart_time && $pax < $row->rsttable_pax && $status == 'RSD'){
							continue;
						}//If Old Pax is lessthan New Pax and Status is RSD
						else if($restid == $row->rssfk_restaurant && $resStartTime == $row->rssstart_time && $pax < $row->rsttable_pax && $status == 'WAL'){
							$newpax = $row->rsttable_pax;
							$newtable_count = $row->rstno_of_tables;
							$newstatus = $this->timeBookingStatus($restid,$date,$resStartTime,$newpax,$newtable_count,$rssid);
							$newinvetory_id = $row->invetory_id;
		
							if($newstatus == 'WAL'){
								continue;
							}else{
								$pax = $newpax;
								$status = $newstatus;
								$invetory_id = $newinvetory_id;
								$table_count = $newtable_count;
							}
						}//If Old Pax is lessthan New Pax and Status is WAL
						else if($restid == $row->rssfk_restaurant && $resStartTime == $row->rssstart_time && $pax > $row->rsttable_pax  && $status == 'RSD'){
							$newpax = $row->rsttable_pax;
							$newtable_count = $row->rstno_of_tables;
							$newstatus = $this->timeBookingStatus($restid,$date,$resStartTime,$newpax,$newtable_count,$rssid);
							$newinvetory_id = $row->invetory_id;
		
							if($newstatus == 'WAL'){
								continue;
							}else{
								$pax = $newpax;
								$status = $newstatus;
								$invetory_id = $newinvetory_id;
								$table_count = $newtable_count;
							}
						}//If Old Pax is Greaterthan NewPax and Status is RSD
						else if($restid == $row->rssfk_restaurant && $resStartTime == $row->rssstart_time && $pax > $row->rsttable_pax  && $status == 'WAL'){
							$newpax = $row->rsttable_pax;
							$newtable_count = $row->rstno_of_tables;
							$newstatus = $this->timeBookingStatus($restid,$date,$resStartTime,$newpax,$newtable_count,$rssid);
							$newinvetory_id = $row->invetory_id;
		
							$pax = $newpax;
							$status = $newstatus;
							$invetory_id = $newinvetory_id;
							$table_count = $newtable_count;
						}//If OldPax is Greaterthan NewPax and Status is WAL
						else if($restid == $row->rssfk_restaurant && $resStartTime != $row->rssstart_time){
								
							$time_pax[]   = array('Time' => $resStartTime,'Pax'=>$pax,'Status'=>$status,'No_of_Tables' => $table_count,'Schedule_id' => $rssid,'Inventory_Id' => $invetory_id);
							$rssid 		  = $row->rssid;
							$resStartTime = $row->rssstart_time;
							$invetory_id  = $row->invetory_id;
							$pax 		  = $row->rsttable_pax;
							$table_count  = $row->rstno_of_tables;
							$status = $this->timeBookingStatus($restid,$date,$resStartTime,$pax,$table_count,$rssid);
								
						}//On Change of StartTime
						else if($restid != $row->rssfk_restaurant){
		
							$time_pax[] = array('Time' => $resStartTime,'Pax'=>$pax,'Status'=>$status,'No_of_Tables' => $table_count,'Schedule_id' => $rssid,'Inventory_Id' => $invetory_id);
							$restaurantDet[$restid] = array('Time_Pax'=>$time_pax);
							$result[] = array('RestId'	     	  => $restid,
										  'RestName'     	  => $restname,
										  'RestDesc'		  => $restdesc,
										  'RestAddress'  	  => $restaddress,
										  'RestImage'    	  => $restimage,
										  'RestLatitude'      => $restlatitude,
										  'RestLongitude'	  => $restlongitude,
										  'RestNeighbor'	  =>$neighbor,
										  'RestPrice'		  => $price,
										  'RestaurantDetails' =>$restaurantDet
							);
		
							$time_pax 	   = null;
							$rssid 		   = $row->rssid;
							$restid 	   = $row->rssfk_restaurant;
							$restname 	   = $row->resrestaurant_name;
							$restdesc	   = $row->resdescription;
							$restaddress   = $row->resaddress;
							$restimage 	   = $row->resimage;
							$restlatitude  = $row->reslatitude;
							$restlongitude = $row->reslongitude;
							$neighbor 	   = $row->neighbor;
							$price 		   = $row->resprice;
							$resStartTime  = $row->rssstart_time;
							$invetory_id   = $row->invetory_id;
							$pax 		   = $row->rsttable_pax;
							$table_count   = $row->rstno_of_tables;
							$status = $this->timeBookingStatus($restid,$date,$resStartTime,$pax,$table_count,$rssid);
						}//On Change of Restaurant Id
						$SqlResult = true;
					}
					
				}else{
					if($restid == null && $resStartTime == null && $pax == null){
						$restid 	   = $row->rssfk_restaurant;
						$restname 	   = $row->resrestaurant_name;
						$restdesc	   = $row->resdescription;
						$restaddress   = $row->resaddress;
						$restimage 	   = $row->resimage;
						$restlatitude  = $row->reslatitude;
						$restlongitude = $row->reslongitude;
						$neighbor 	   = $row->neighbor;
						$price 		   = $row->resprice;
						$resStartTime  = $row->rssstart_time;
						$invetory_id   = $row->invetory_id;
						$pax    	   = $row->rsttable_pax;
						$table_count   = $row->rstno_of_tables;
						$rssid         = $row->rssid;
						$date          = $searchList->getDate();
						$status = $this->timeBookingStatus($restid,$date,$resStartTime,$pax,$table_count,$rssid);
	
					}//Initial initialization of the values
					else if($restid == $row->rssfk_restaurant && $resStartTime == $row->rssstart_time && $pax < $row->rsttable_pax && $status == 'RSD'){
						continue;
					}//If Old Pax is lessthan New Pax and Status is RSD
					else if($restid == $row->rssfk_restaurant && $resStartTime == $row->rssstart_time && $pax < $row->rsttable_pax && $status == 'WAL'){
						$newpax = $row->rsttable_pax;
						$newtable_count = $row->rstno_of_tables;
						$newstatus = $this->timeBookingStatus($restid,$date,$resStartTime,$newpax,$newtable_count,$rssid);
						$newinvetory_id = $row->invetory_id;
	
						if($newstatus == 'WAL'){
							continue;
						}else{
							$pax = $newpax;
							$status = $newstatus;
							$invetory_id = $newinvetory_id;
							$table_count = $newtable_count;
						}
					}//If Old Pax is lessthan New Pax and Status is WAL
					else if($restid == $row->rssfk_restaurant && $resStartTime == $row->rssstart_time && $pax > $row->rsttable_pax  && $status == 'RSD'){
						$newpax = $row->rsttable_pax;
						$newtable_count = $row->rstno_of_tables;
						$newstatus = $this->timeBookingStatus($restid,$date,$resStartTime,$newpax,$newtable_count,$rssid);
						$newinvetory_id = $row->invetory_id;
	
						if($newstatus == 'WAL'){
							continue;
						}else{
							$pax = $newpax;
							$status = $newstatus;
							$invetory_id = $newinvetory_id;
							$table_count = $newtable_count;
						}
					}//If Old Pax is Greaterthan NewPax and Status is RSD
					else if($restid == $row->rssfk_restaurant && $resStartTime == $row->rssstart_time && $pax > $row->rsttable_pax  && $status == 'WAL'){
						$newpax = $row->rsttable_pax;
						$newtable_count = $row->rstno_of_tables;
						$newstatus = $this->timeBookingStatus($restid,$date,$resStartTime,$newpax,$newtable_count,$rssid);
						$newinvetory_id = $row->invetory_id;
	
						$pax = $newpax;
						$status = $newstatus;
						$invetory_id = $newinvetory_id;
						$table_count = $newtable_count;
					}//If OldPax is Greaterthan NewPax and Status is WAL
					else if($restid == $row->rssfk_restaurant && $resStartTime != $row->rssstart_time){
							
						$time_pax[]   = array('Time' => $resStartTime,'Pax'=>$pax,'Status'=>$status,'No_of_Tables' => $table_count,'Schedule_id' => $rssid,'Inventory_Id' => $invetory_id);
						$rssid 		  = $row->rssid;
						$resStartTime = $row->rssstart_time;
						$invetory_id  = $row->invetory_id;
						$pax 		  = $row->rsttable_pax;
						$table_count  = $row->rstno_of_tables;
						$status = $this->timeBookingStatus($restid,$date,$resStartTime,$pax,$table_count,$rssid);
							
					}//On Change of StartTime
					else if($restid != $row->rssfk_restaurant){
	
						$time_pax[] = array('Time' => $resStartTime,'Pax'=>$pax,'Status'=>$status,'No_of_Tables' => $table_count,'Schedule_id' => $rssid,'Inventory_Id' => $invetory_id);
						$restaurantDet[$restid] = array('Time_Pax'=>$time_pax);
						$result[] = array('RestId'	     	  => $restid,
									  'RestName'     	  => $restname,
									  'RestDesc'		  => $restdesc,
									  'RestAddress'  	  => $restaddress,
									  'RestImage'    	  => $restimage,
									  'RestLatitude'      => $restlatitude,
									  'RestLongitude'	  => $restlongitude,
									  'RestNeighbor'	  =>$neighbor,
									  'RestPrice'		  => $price,
									  'RestaurantDetails' =>$restaurantDet
						);
	
						$time_pax 	   = null;
						$rssid 		   = $row->rssid;
						$restid 	   = $row->rssfk_restaurant;
						$restname 	   = $row->resrestaurant_name;
						$restdesc	   = $row->resdescription;
						$restaddress   = $row->resaddress;
						$restimage 	   = $row->resimage;
						$restlatitude  = $row->reslatitude;
						$restlongitude = $row->reslongitude;
						$neighbor 	   = $row->neighbor;
						$price 		   = $row->resprice;
						$resStartTime  = $row->rssstart_time;
						$invetory_id   = $row->invetory_id;
						$pax 		   = $row->rsttable_pax;
						$table_count   = $row->rstno_of_tables;
						$status = $this->timeBookingStatus($restid,$date,$resStartTime,$pax,$table_count,$rssid);
					}//On Change of Restaurant Id
					$SqlResult = true;
				}
			}
			if($SqlResult){
				$status = $this->timeBookingStatus($restid,$date,$resStartTime,$pax,$table_count,$rssid);
				$time_pax[] = array('Time' => $resStartTime,'Pax'=>$pax,'Status'=>$status,'No_of_Tables' => $table_count,'Schedule_id' => $rssid,'Inventory_Id' => $invetory_id);
				$restaurantDet[$restid] = array('Time_Pax'=>$time_pax);
				$result[] = array('RestId'	     	  => $restid,
						 	  'RestName'     	  => $restname,
						  	  'RestAddress'  	  => $restaddress,
							  'RestDesc'		  => $restdesc,	
						  	  'RestImage'    	  => $restimage,
						  	  'RestLatitude'      => $restlatitude,
						  	  'RestLongitude'	  => $restlongitude,
						  	  'RestNeighbor'	  => $neighbor,
						      'RestPrice'   	  => $price,
						  	  'RestaurantDetails' => $restaurantDet
				);

				$searchListDetails = array();
				$sourceIndex = 0;
				if($restid){
					//Sorting each Restaurant
					foreach($result as $resdetails)
					{
						$timein	 = $searchList->getTime();
						$frzDate = explode("-",$searchList->getDate());

						$s = mktime(0,0,0,$frzDate[0],$frzDate[1],$frzDate[2]);
						$frzDate = date('Y-m-d',$s);
						$frzSql = "select frzfk_restaurant from mt.restaurant_freeze frz
					   			where frzfreezedate ='".$frzDate."'";
						$frzIdSet = $db->fetchAll($frzSql);

						$frzArr = array();
						foreach($frzIdSet as $frzResId){
							$frzArr[] = $frzResId['frzfk_restaurant'];
						}
						$countFrzArr = count($frzArr);

						if($countFrzArr){
							$residd = $resdetails['RestId'];
							$key = array_search($residd, $frzArr);
							if($key === 0){
								$key = 1;
							}
							if($key){
								continue;
							}

						}

						$restaurantDetails = $resdetails['RestaurantDetails'];
						$reataurantId = $restaurantDetails[$resdetails['RestId']];
						$timepax = $reataurantId['Time_Pax'];
						$timearray = null;

						$timeresult = null;
						$index = 0;
						$pax = null;
						$schtime = null;
						$timesarray = null;
						$startingtimes = null;
						$endingtimes = null;
						sort($timepax);

						foreach($timepax as $times){
							$timesarray[] = $times['Time'];
						}//Array of all the Sorted Times

						sort($timesarray);
						$validData  = false;
						$timeSearch = false;
						foreach($timepax as $times){
							$timeHM = explode(":",$times['Time']);
							$sk = mktime($timeHM[0],(int)$timeHM[1],0,0,0,0);
							$time = date("h:i A",$sk);
								
							$timesp = explode(" ",$searchList->getTime());
								
							$timesplit = explode(":",$timesp[0]);
							if((int)$timesplit[0] < 10){
								$timesplit[0] = '0'.(int)$timesplit[0];
							}
							if($timesp[1] ==  "PM"){
								if((int)$timesplit[0] != 12){
									(int)$timesplit[0] += 12;
								}
							}
							if($timesp[1] ==  "AM" && (int)$timesplit[0] == 12){

								(int)$timesplit[0] = '00';

							}
							$actime = array($timesplit[0],$timesplit[1],'00');
								
							$actualtime = implode(":",$actime);//Actual Searched Time
							$inarrayvalue = in_array($actualtime,$timesarray);//checks for the actual time in the arrays and returns true if found
							if($inarrayvalue){
								$timeSearch = array_search($actualtime,$timesarray);
								$sourceIndex = $timeSearch;
								$validData = true;//indicates that the actual time is found in the times array
							}//Checks for the Actual time in the times array for getting the Index value of the actual time
							else if($actualtime > $times['Time']){
								$startingtimes[] = $times['Time'];
								$validData = false;//indicates that the actual time is not found in the times array
							}//if the actual time is not available in the times array then form the starting times array
							else{
								$endingtimes[] = $times['Time'];
								$validData = false;//indicates that the actual time is not found in the times array
							}//if the actual time is not available in the times array then form the ending times array
						}

						if($validData){
							foreach($timepax as $times){
								if($times['Status'] == 'WAL'){
									continue;
								}else{
									$timeresult[$index] = array('Time' => $times['Time'],'Status'=>$times['Status'],'Pax'=>$times['Pax'],'No_of_Tables' => $times['No_of_Tables'],'Schedule_id' => $times['Schedule_id'],'Inventory_Id' => $times['Inventory_Id']);
									$index++;
								}
							}//for each times array generate the timepax with the times status and pax etc
						}//if the actual time is found in the times array
						$timekeys = null;
						$actualtimeIndex = null;
						$timeresultarray = null;
						if(!$validData){
							if($startingtimes){
								$timekeys = array_keys($startingtimes);//generates all the keys of the array
							}//if starting times array exists when actual time is not found in the times array
							if($timekeys){
								$actualtimeIndex = end($timekeys);
							}//if timekeys exists
							if($actualtimeIndex == 0 || $actualtimeIndex == 1){
								$i = 0;
							}else{
								$i = $actualtimeIndex-2;
							}
							for($i;$i<=$actualtimeIndex;$i++){
								$timeresultarray[] =$startingtimes[$i];
							}if($endingtimes){
								if(count($endingtimes) == 1){
									$timeresultarray[] = $endingtimes[0];
								}else {
									$timeresultarray[] = $endingtimes[0];
									$timeresultarray[] = $endingtimes[1];
								}

							}
						}//if the actual time is not found in the times array
						$searcharray = null;
						if(!$validData){
							foreach($timepax as $values){
								if($values['Status'] == 'WAL'){
									continue;
								}else{
									if(in_array($values['Time'],$timeresultarray)){
										$searchPax = $searchList->getPax();
										$searcharray = array('Time'=>$values['Time'],'Pax'=>$searchPax);
										if(in_array($searcharray,$values)){
											$timeresult[] = array('Time' => $values['Time'],'Status'=>$values['Status'],'Pax'=>$values['Pax'],'No_of_Tables' => $values['No_of_Tables'],'Schedule_id' => $values['Schedule_id'],'Inventory_Id' => $values['Inventory_Id']);

										}
									}
									if(in_array($values['Time'],$timeresultarray)){
										$timeresult[] = array('Time' => $values['Time'],'Status'=>$values['Status'],'Pax'=>$values['Pax'],'No_of_Tables' => $values['No_of_Tables'],'Schedule_id' => $values['Schedule_id'],'Inventory_Id' => $values['Inventory_Id']);
									}
								}
							}
						}//if actual time is not found in the times array
						$timeres = null;
						$finaltimekey = null;
						if($validData){
							if(count($timeresult) > 4){
								$timekeys = array_keys($timeresult);
								$finaltimekey = end($timekeys);
								if($sourceIndex < 2 && $sourceIndex >= 0){
									$i = 0;
									for($i ;$i<=$sourceIndex+2;$i++){
										@$timeres[] = @$timeresult[$i];
									}
								}//if the sourceindex is in between 0 and 2
								else if($sourceIndex == $finaltimekey){
									for($i = $sourceIndex-2;$i<=$sourceIndex;$i++){
										@$timeres[] = @$timeresult[@$i];
									}
								}//if sourceindex is equal to the final value of the array
								else if($sourceIndex == $finaltimekey-1){
									for($i = $sourceIndex-2;$i<=$sourceIndex+1;$i++){
										@$timeres[] = @$timeresult[@$i];
									}
								}
								else if($sourceIndex == $finaltimekey-2){
									for($i = $sourceIndex-2;$i<=$sourceIndex+2;$i++){
										@$timeres[] = @$timeresult[@$i];
									}
								}
								else{
									for($i = $sourceIndex-2;$i<=$sourceIndex+2;$i++){
										@$timeres[] = @$timeresult[@$i];
									}
								}
							}else{
								$timeres = $timeresult;
							}
						}//If resultant timepax is greater than 5
						else{
							$timeres = $timeresult;
						}//if the resultant times is less than 5
						$finalTimeList = null;
						$finalTimeValue = null;
						$finalTimeList = $timeres;
						if($finalTimeList){
							sort($finalTimeList);
							$timeIndex = 0;//key of the finaltimelist
							foreach($finalTimeList as $List){
								if(!$List['Time'] == null){
									$timeValue = explode(":",$List['Time']);
									if($timeValue[0] >=12){
										if((int)$timeValue[0] != 12){
											$timeValue[0] -= 12;
										}
										$timeValue[2] = 'PM';
										if($timeValue[0] >= 10 || $timeValue[0] == 12){
											$finalTimeValue = $timeValue[0].':'.$timeValue[1].' '.$timeValue[2];
										}else{
											$finalTimeValue = '0'.$timeValue[0].':'.$timeValue[1].' '.$timeValue[2];
										}
										
									}else{
										$timeValue[2] = 'AM';
										if((int)$timeValue[0] == 0){
											$timeValue[0] = 12;
										}
										$finalTimeValue = $timeValue[0].':'.$timeValue[1].' '.$timeValue[2];
									}

									$List['Time'] = $finalTimeValue;
									$finalTimeList[$timeIndex] = $List;
									$timeIndex++;
								}//if time value exists in the list then the 24hours format of the time is converted and replaced into 12 hours format
							}

							$resdesc = $this->shorten_string($resdetails['RestDesc'],25);

							$resultObj = new Reservation_Model_SearchListView();
							$resultObj->setRestaurantname($resdetails['RestName'])
							->setResDesc($resdesc)
							->setResId($resdetails['RestId'])
							->setTime($finalTimeList)
							->setAddress(trim($resdetails['RestAddress']))
							->setResimage($resdetails['RestImage'])
							->setLatitude($resdetails['RestLatitude'])
							->setLongitude($resdetails['RestLongitude'])
							->setNeighborhood($resdetails['RestNeighbor'])
							->setPrice($resdetails['RestPrice']);
							$searchListDetails[] = $resultObj;//the resultant array of the restaurant details and the times with their pax size and status
						}// for each restaurant adding the time details

					}//If Restaurant Id exists
					return $searchListDetails;
				}
			}//If Sql Result is True
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getRestaurantSplList(Reservation_Model_SearchListView  $searchList)
	{
		try{
			$RestSearchReults = array();
			
			$RestSearchReults = $this->getSearchList($searchList);
			$restMapper = new Deals_Model_RestaurantSpecialDataMapper();
			$restTable = $restMapper->getDbTable();
			$restSelect = $restTable->select();
			$restSelect->setIntegrityCheck(false);
			$restSelect->from(array('respl'=>'mt.restaurant_special'),array('rspid',
																			'rspfk_restaurant',
																			'rspspecial_type',
																			'rspno_of_dishes', 
																			'rspspecial_title',
																			'rspspecial_image',
																			'rspfood_type',
																			'rspregular_price',
																			'rspdiscount_percentage_point',																
																			'rspprice_with_discount',
																			'rspkids_eat_free',
																			'rspstart_date',
																			'rspend_date',
																			'rspstart_time',
																			'rspend_time',
																			'rspdescription',
																			'rsprecurencestatus',
																			'rspkidsstatus',
																			'rspstatus',
																			'rspcategory',
																			'rsptype_of_occurance',
																			'rspdiscount_mode'));
			
			$restSelect->join(array('res'=>'mt.restaurant'),'res.resid = respl.rspfk_restaurant',array('resid','resrestaurant_name','resaddress','resphone'));
			$restSelect->join(array('spb'=>'mt.special_type_bd'),'spb.id = respl.rspspecial_type',array('description as special'));
			$restSelect->join(array('cty'=>'mt.city_bd'),'cty.id = res.rescity_id',array('code as citycode','description as citydesc'));
			$restSelect->join(array('neigh'=>'mt.neighborhood_bd'),'neigh.id = res.resneighborhood_id',array('description as neighdesc'));
			$restSelect->join(array('cat'=>'mt.special_category_bd'),'cat.id = respl.rspcategory',array('code as catcode','description as splCategory'));
			$restSelect->joinLeft(array('splcnt'=>'mt.special_count_type_bd'),'splcnt.id = respl.rsptype_of_occurance',array('description as splCount'));
			$restSelect->joinLeft(array('discmod'=>'mt.discount_mode_bd'),'discmod.id = respl.rspdiscount_mode',array('code as discModeCode' ,'description as discMode'));
			$restSelect->joinLeft(array('disctyp'=>'mt.discount_type_bd'),'disctyp.id = respl.rsptype_of_occurance',array('code as discTypeCode' ,'description as discTypeDisc'));
			
			$restSelect->where('respl.rspstatus = ?',true);
			$restSelect->where('respl.rspdeletestatus = ?',true);
			$restSelect->where('res.resapprovalstatus = ?',1);
			$restSelect->where('res.resstatus = ?',1);
			$restSelect->where('res.rescity_id = ?',$searchList->getCity());

			if($searchList->getPrice()){
				$restSelect->where('res.resprice = ?',$searchList->getPrice());
			}

			if($searchList->getNeighbor()){
				$restSelect->where('res.resneighborhood_id = ?',$searchList->getNeighbor());
			}

			if($searchList->getCuisine()){
				$restSelect->join(array('cusine'=>'mt.restaurant_cuisine'),'cusine.rcsfk_restaurant = res.resid',array('rscid'));
				$restSelect->where('cusine.rscfk_restauranttype_id = ?',$searchList->getCuisine());
			}
			if($searchList->getDate() && $searchList->getTime()){
				
				$restSelect->where('respl.rspstart_date <= ?',$searchList->getDate());
				$restSelect->where('respl.rspend_date >= ?',$searchList->getDate());
				$restSelect->where('respl.rspstart_time <= ?',$searchList->getTime());
				$restSelect->where('respl.rspend_time >= ?',$searchList->getTime());				
				
				$restSelect->join(array('recurr'=>'mt.restaurant_special_reccurence'),'recurr.rsrfk_restaurant_special = respl.rspid',array());
				$restSelect->where('recurr.rsrday_of_week = ?',$searchList->getWeekDayId());
				
			}else if($searchList->getDate()){
				$restSelect->where('respl.rspstart_date <= ?',$searchList->getDate());
				$restSelect->where('respl.rspend_date <= ?',$searchList->getDate());
				
				$restSelect->join(array('recurr'=>'mt.restaurant_special_reccurence'),'recurr.rsrfk_restaurant_special = respl.rspid',array());
				$restSelect->where('recurr.rsrday_of_week = ?',$searchList->getWeekDayId());
			}			

			$restSelect->order(array('respl.rspspecial_title'));

			$rowSet = $restTable->fetchAll($restSelect);
			$resDet = array();
			$resIdArr = array();
			
			foreach($rowSet as $row){
				if($row->rsprecurencestatus){
					$reoccMapper = new Deals_Model_RestaurantSpecialRecurenceDataMapper();
					$reTable = $reoccMapper->getDbTable();
					$reoccSelect = $reTable->select();
					$reoccSelect->setIntegrityCheck(false);
					$reoccSelect->from(array('rsr'=>'mt.restaurant_special_reccurence'),array('rsrid','rsrday_of_week'))
								->join(array('wrb'=>'mt.weekly_recurence_bd'),'wrb.id = rsr.rsrday_of_week',array('description as day'))
								->where('rsr.rsrfk_restaurant_special = ? ',$row->rspid);
					$rowResult = $reTable->fetchAll($reoccSelect);
				}else{
					$rowResult = "";
				}
				if(strlen($row->rspdescription) > 200){
					$description = substr($row->rspdescription, 0, 200)." ...";
				}else{
					$description = $row->rspdescription;
				}
				$splObj = new Deals_Model_RestaurantSpecial();
				$splObj->setRestaurantname($row->resrestaurant_name)
					   ->setId($row->rspid)
					   ->setRestaurantid($row->resid)
				       ->setAddress($row->resaddress)
					   ->setRestaurantid($row->rspfk_restaurant)
					   ->setNoofdishes($row->rspno_of_dishes)
					   ->setSpecialtypename($row->special)
				       ->setSpecialtypeid($row->rspspecial_type)
					   ->setSpecialtitle($row->rspspecial_title)
					   ->setSpecialimage($row->rspspecial_image)
					   ->setStartdate($row->rspstart_date)
					   ->setEnddate($row->rspend_date)
					   ->setStarttime($row->rspstart_time)
					   ->setEndtime($row->rspend_time)
					   ->setDescription($description)
					   ->setSpecialrecurence($row->rsprecurencestatus)
					   ->setKidsinfo($row->rspkids_eat_free)
					   ->setKidsstatus($row->rspkidsstatus)
					   ->setSpecialCount($row->rsptype_of_occurance)
					   ->setSpecialCategoryType($row->rspcategory)
					   ->setSpecialCategoryTypeName($row->splCategory)
					   ->setCatTypeCode($row->catcode)
					   ->setSpecialCountName($row->splCount)
					   ->setDiscountMode($row->discMode)
					   ->setRegprice($row->rspregular_price)
					   ->setDispercentage($row->rspdiscount_percentage_point)
					   ->setPricewithdiscount($row->rspprice_with_discount)
					   ->setStatus($row->rspstatus)
					   ->setCity($row->citydesc)
					   ->setNeighbour($row->neighdesc)
					   ->setPhone($row->resphone);
				$splWeek = array();
				if($rowResult){
					foreach($rowResult as $value){
						$splRecurenceObj = new Deals_Model_RestaurantSpecialRecurence();
						$splRecurenceObj->setWeekId($value->rsrday_of_week);
						$splRecurenceObj->setWeekDesc($value->day);
						$splWeek[] = $splRecurenceObj;
					}
				}
				$splObj->setWeekids($splWeek);
				$resDet[$row->rspid] = $splObj;
			}
			$ResvTimesArr = array();
			$finalResult = array();
			if(count($resDet) > 0 && count($RestSearchReults) > 0){
				/* Seprate time from Reservation Search results */
				foreach($RestSearchReults as $res){
					$ResvTimesArr[$res->getResId()] = $res->getTime(); 		
				}
				
				/* Compare search times falls under special defined time */
				
				foreach($resDet as $key => $value){
					$splObject = "";
					$splObject = $value;
					if(array_key_exists($splObject->getRestaurantid(),$ResvTimesArr) && ($splObject->getCatTypeCode() == 'CP' || $splObject->getCatTypeCode() == 'SP')){
						$times = $ResvTimesArr[$splObject->getRestaurantid()];
						
						$starttime     = $splObj->getStarttime();							
						$convstarttime = strtotime($starttime); 
						$endtime       = $splObj->getEndtime();
						$convendtime   = strtotime($endtime);
						$timesArr = array();
						foreach($times as $time){
							$convTime = "";
							$convTime = strtotime($time['Time']);
							if($convTime >= $convstarttime && $convTime <= $convendtime)
							{
								if($time['Status'] != 'WAL'){
									$timesArr[] = array('Time'     	   => $time['Time'],
												    	'Status'       => $time['Status'],
														'Pax'		   => $time['Pax'],
														'No_of_Tables' => $time['No_of_Tables'],
														'Schedule_id'  => $time['Schedule_id'],
														'Inventory_Id' => $time['Inventory_Id']);	
								}								
										
							}else{
								continue;
							}
						}

						if(count($timesArr) > 0){
							$splObject->setTimesArray($timesArr);
							$finalResult[$splObject->getId()] = $splObject;
						}
						  
					}else if($splObject->getCatTypeCode() == 'INF'){
						$finalResult[$splObject->getId()] = $splObject;
					}else if($splObject->getCatTypeCode() == 'PE'){
						$finalResult[$splObject->getId()] = $splObject;
					}
				}
				
			}

			$result['searchList'] = $finalResult;			
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getRestaurantList(Reservation_Model_SearchListView  $searchList,$request)
	{
		try{
			$restMapper = new FirmManagement_Model_FirmDataMapper();
			$restTable = $restMapper->getDbTable();
			$restSelect = $restTable->select();
			$restSelect->setIntegrityCheck(false);

			/* Reteriving the Resturants count */
			$count = null;
			if(!$searchList->getResId()){
				$count = $this->SearchRestaurantsCount($searchList);
			}
			$offset = 0;
			$limit = 9;

			/* Reteriving the previous offset */
			if($searchList->getOffset() && $searchList->getOffset() != 0){
				$offset = $searchList->getOffset();
			}
			/* If next link or arrow is clicked this if condition is executed. */
			if($searchList->getevent() == 'next'){

				if($count >= $offset + 9){

					$offset = $offset + 9;

					if($offset + 9 >= $count){
						$result['next'] = false;
					}else{
						$result['next'] = true;
					}
				}
				if($offset >= 9){
					$result['prev'] = true;
				}

			}/* if previous link is clicked this if condition is executed. */
			elseif($searchList->getevent() == 'prev'){

				$offset = $offset - 9;

				if($offset == 0 || $offset < 9){
					$result['prev'] = false;
				}else{
					$result['prev'] = true;
				}
				if($count > $offset){

					$result['next'] = true;
				}

			}/* This else part is executed on first call of this function. */
			else{
				if($request->prev ||  $request->next){
					if($request->prev && $request->next){
						$result['next'] = true;
						$result['prev'] = true;
					}else if($request->prev){
						$result['next'] = false;
						$result['prev'] = true;
					}else if($request->next){
						$result['next'] = true;
						$result['prev'] = false;
					}else{
						$result['next'] = false;
						$result['prev'] = false;
					}
				}else{
					if($count > 9){
						/* if count is greater than 9 show the next link */
						$result['next'] = true;
						$result['prev'] = false;
					}else{
						/* if count is less than 9 then no links are shown. */
						$result['next'] = false;
						$result['prev'] = false;
					}
				}
			}
				
			/* the offset value is stored and send to phtml page and
			 * upon next or previous action the increment or
			 * decrement of offset is done on this value */
			$result['offset'] = $offset;

			$restSelect->from(array('res'=>'mt.restaurant'),array('resid',
																'resrestaurant_name',
																'resprice',
																'resimage',
																'resemail',
																'resaddress',																
																'reszipcode',
																'resphone',
																'resdescription',
																'resavg_mealprice_min',
																'resavg_mealprice_max',																
																'reslunch_buffet',
																'resdinner_buffet',
																'reslandmark',	
																'res_delevery',
																'res_wifi',
																'res_alcohol',
																'res_smoking',	
																'res_ac',
																'res_party_allowed',
																'res_catering',
																'res_kids_section',																												'resdiningstyle',
																'reslatitude',
																'reslongitude',
																'resreserv'));
//			$restSelect->join(array('rgn'=>'mt.region_bd'),'rgn.id = res.resregion_id',array('code as regioncode','description as regiondesc'));
			$restSelect->join(array('cty'=>'mt.city_bd'),'cty.id = res.rescity_id',array('code as citycode','description as citydesc'));
			$restSelect->join(array('neigh'=>'mt.neighborhood_bd'),'neigh.id = res.resneighborhood_id',array('description as neighdesc'));
			$restSelect->join(array('cat'=>'mt.restaurant_category_bd'),'cat.id = res.rescategory_id',array('code as catcode','description as catdesc'));
			$restSelect->where('res.resapprovalstatus = ?',1);
			$restSelect->where('res.resstatus = ?',1);
			//$restSelect->where('res.resstate_id = ?',$searchList->getState());
			//$restSelect->where('res.resregion_id = ?',$searchList->getRegion());
			$restSelect->where('res.rescity_id = ?',$searchList->getCity());
			
			if($searchList->getResId()){
				$restSelect->where('res.resid = ?',$searchList->getResId());
			}
			if($searchList->getRestaurantname()){
				$restSelect->where('res.resrestaurant_name ILIKE(?)','%'.$searchList->getRestaurantname().'%');
			}
			if($searchList->getPrice()){
				$restSelect->where('res.resprice = ?',$searchList->getPrice());
			}

			if($searchList->getNeighbor()){
				$restSelect->where('res.resneighborhood_id = ?',$searchList->getNeighbor());
			}

			if($searchList->getCuisine()){
				$restSelect->join(array('cusine'=>'mt.restaurant_cuisine'),'cusine.rcsfk_restaurant = res.resid',array('rscid'));
				$restSelect->where('cusine.rscfk_restauranttype_id = ?',$searchList->getCuisine());
			}
			$restSelect->limit($limit,$offset);
			$restSelect->order(array('res.resrestaurant_name'));

			$rowSet = $restTable->fetchAll($restSelect);

			$result['searchList'] = $rowSet;

			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}

	}

	public function timeBookingStatus($resId,$date,$resTime,$resPax,$noofTables,$rssid)
	{
		try{
			$bookMapper = new Reservation_Model_ReservationCountDataMapper();

			$bookTable = $bookMapper->getDbTable();
			$bookSelect = $bookTable->select();
			$bookSelect->from(array('btc'=>'mt.booking_time_count'),array('btc.btcbooking_count','btc.boktablesize'))
					   ->where('btc.btcfkres_id = ?',$resId)
					   ->where('btc.btcbooking_date = ?',$date)
					   ->where('btc.btcbooking_timings = ?',$resTime)
					   ->where('btc.boktablesize = ?',$resPax)
					   ->where('btc.btcfk_restaurant_schedule = ?',$rssid);

			$booking = $bookTable->fetchRow($bookSelect);

			$bookingCount = (int)$booking['btcbooking_count'];//number of bookings for the time with pax
			$status = null;
			$seatsFlag  = $noofTables;//number of tables for the pax at the time
			if($bookingCount){
				if($bookingCount >= $seatsFlag){
					$status = 'WAL';
				}//if the booking count is greater than the number of tables
				else{
					$status = 'RSD';
				}
			}else{
				$status = 'RSD';
			}
			return $status;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function recursiveArraySearch($haystack, $needle, $index = null)
	{
		try{
			$aIt     = new RecursiveArrayIterator($haystack);
			$it    = new RecursiveIteratorIterator($aIt);

			while($it->valid())
			{
				if (((isset($index) AND ($it->key() == $index)) OR (!isset($index))) AND ($it->current() == $needle)) {
					return $aIt->key();
				}

				$it->next();
			}

			return false;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}//search over a nested array for the value and returns the key of that value

	public function GetRestTimings(Reservation_Model_GetRestaurantTimings $timings)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);

			$endTime = $timings->getTime();
			$time = explode(" ",$endTime);
			$timeHM = explode(":",$time[0]);
			if($time[1] ==  "PM"){
				if((int)$timeHM[0] != 12){
					(int)$timeHM[0] += 12;
				}
			}//if the time is PM then adding 12 to the hour
			if($time[1] ==  "AM" && (int)$timeHM[0] == 12){

				(int)$timeHM[0] = 0;

			}
			$timezone = "";
			$mapper = new FirmManagement_Model_FirmDataMapper();
			$timezone = $mapper->GetRestaurantTimeZone($timings->getRestId());
			date_default_timezone_set($timezone);
			
			
			$currentUserTime = date("h:i A");
			/* new code for checking the userdate and selected date(17-11-2012) */
			$currentUserDate = date('d-m-Y');
			$currentUserDateStr = strtotime($currentUserDate);
			$todayDateSplit = explode("-",$timings->getDate());
			$s = mktime(0,0,0,$todayDateSplit[0],$todayDateSplit[1],$todayDateSplit[2]);
			$seDate = date('Y-m-d',$s);
			$selUserDateStr = strtotime($seDate);
			/* old code for checking the userdate and selected date(17-11-2012) */
			/*
			$currentUserDate = date('m-d-Y');
			$currentUserDateStr = strtotime($currentUserDate);
			$selUserDateStr = strtotime($timings->getDate());
			*/
			$userTimeConflict = false;
			if($currentUserDateStr == $selUserDateStr && $timings->getResType() == 'web'){
				$mk = mktime(date("h"),date('i'),date('s'),date('m'),date('d'),date('Y'));
				$currentUserTimestr = strtotime($currentUserTime);
				$selUserTimestr = strtotime($timings->getTime());
				if($selUserTimestr > $currentUserTimestr){
					$differenceTimeStr = $selUserTimestr - $currentUserTimestr;
					$differenceTimeMin = floor((($differenceTimeStr)/60)/60);
					if($differenceTimeMin > 3){
						$userStartTime = $timings->getTime();
						$userTimeConflict = false;
					}else if($differenceTimeMin <= 3){
						$reservTimeMapper = new FirmManagement_Model_FirmReservationsTimeSettingDataMapper();
						$timeSettArr = $reservTimeMapper->getRestaurantResvTimeSetting($timings->getRestId()); 
						if($timeSettArr['status']){
							$userStartTime = date('h:i A',strtotime($currentUserTime)+($timeSettArr['time']*60));
							$userTimeConflict = true;
						}else{
							$userStartTime = date('h:i A',strtotime($currentUserTime));
							$userTimeConflict = true;
						}
					}else{
						return false;
					}
				}else{
					return false;
				}
			}
			
			
			$todayDateSplit = explode("-",$timings->getDate());
			$todayDateSplit[1] = $todayDateSplit[1];
			$todayDateArray = array($todayDateSplit[0],$todayDateSplit[1],$todayDateSplit[2]);
			$today = implode("-",$todayDateArray);

			$userTimeSec = mktime($timeHM[0],$timeHM[1],0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
			$userTime = date("h:i A",$userTimeSec);

			$todayTimeSec = mktime(21,0,0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
			$todayTime = date("h:i A",$todayTimeSec);

			$endTimeSec = mktime($timeHM[0]+3,(int)$timeHM[1],0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
			$endTime =  date("h:i A",$endTimeSec);

			$datesplit = explode("-",$timings->getDate());
			/* Date change to d-m-Y format */
			$dateExpArr = array($datesplit[1],$datesplit[0],$datesplit[2]);
			$date = implode("-",$dateExpArr);

			$datesplit[1] = $datesplit[1]+1;
			$datearray = array($datesplit[0],$datesplit[1],$datesplit[2]);
			$tomorrow = implode("-",$datearray);//next days date
			$tomorrowTimeSec = mktime(00,(int)00,0,$datesplit[1],$datesplit[0],$datesplit[2]);
			$tomorrowTime = date("h:i A",$tomorrowTimeSec);//12:00AM
			if($userTimeSec >= $todayTimeSec && $endTimeSec <= $tomorrowTimeSec){
				$endTimeSec = mktime(23,(int)59,0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
				$endTime =  date("h:i A",$endTimeSec);
			}
			$todayThreeTimeSec = mktime(3,0,0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
			$todayThreeTime = date("h:i A",$todayThreeTimeSec);

			$todayLastTimeSec = mktime(00,(int)00,0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
			$todayLastTime = date("h:i A",$todayLastTimeSec);

			if($userTimeConflict){
				$startTime =  $userStartTime;
			}else{
				$startTimeSec = mktime($timeHM[0]-3,(int)$timeHM[1],0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
				$startTime =  date("h:i A",$startTimeSec);
				if($userTimeSec <= $todayThreeTimeSec && $startTimeSec <= $todayLastTimeSec){
					$startTimeSec = mktime(0,(int)0,0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
					$startTime =  date("h:i A",$startTimeSec);
				}
			}

			$dateSplit = explode("-",$timings->getDate());
			$weekday = date("D", mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]));
			
			/* Check Whether the selected date contains any special schedule */
			
			$restSpecialSchObject = new FirmManagement_Model_FirmSpecialSchedule();
			$restSpecialSchObject->setrsesfk_restaurant($timings->getRestId());
			$restSpecialSchObject->setrseseventdate($timings->getDate());

			$restSplSchMapperObj = new FirmManagement_Model_FirmSpecialScheduleMapper();
			
			$splSchRow = $restSplSchMapperObj->CheckSpecialScheduleAvilable($restSpecialSchObject);
			
			
			$select->from(array('sch'=>'mt.restaurant_schedule'),array('rssid','rssstart_time','rssfk_restaurant'))
				   ->where('sch.rssfk_restaurant = ?',$timings->getRestId())
				   ->where('sch.rssstart_time >= ?',$startTime)
				   ->where('sch.rssstart_time <= ?',$endTime)
				   ->where('sch.rssday_of_week = ?',strtolower($weekday))
				   ->where('sch.rssstatus = ?',true);

			if($splSchRow){
				$select->where('sch.rssscheduletype_id = ?',2);
				$select->where('sch.rssfk_special_event_schedule = ?',$splSchRow->rsesid);	
			}else{
				$select->where('sch.rssscheduletype_id = ?',1);
			}	   
				   
			$select->join(array('res'=>'mt.restaurant'),'res.resid = sch.rssfk_restaurant',array('res.resid'));
			$select->where('res.resstatus = ?',1);
			$select->where('res.resapprovalstatus = ?',1);
			$select->join(array('rst'=>'mt.restaurant_schedule_table'),'rst.rstfk_restaurant_schedule = sch.rssid',array('rstid as invetory_id','rsttable_pax','rstno_of_tables'));
			$select->where('rst.rststatus = ?',true);

			$tablePax = $timings->getpartysize();
			if($tablePax == 1 || $tablePax == 19){
				$select->where("rst.rsttable_pax = $tablePax OR rst.rsttable_pax = $tablePax + 1");
			}else if($tablePax >= 2 && $tablePax < 19){
				$select->where("rst.rsttable_pax = $tablePax OR rst.rsttable_pax = $tablePax + 1 OR rst.rsttable_pax = $tablePax + 2 ");

			}else if($tablePax >= 20){
				$select->where("rst.rsttable_pax = $tablePax");
			}
			$select->order(array('sch.rssfk_restaurant','sch.rssstart_time'));
			$rowSet = $table->fetchAll($select);
			$rowcount = count($rowSet);
			if($rowcount >0){
				$restid = $timings->getRestId();
				$Presenttime = null;
				$endtime = null;
				$inventory_id = null;
				$table_pax = null;
				$tablecount = null;
				$status = null;
				$rssid = null;
				$restTimePax = array();
				$uniqueResult = array();
				$newpax = null;
				$newtablecount = null;
				$newstatus = null;
				$newinventory_id = null;
				//Sorting of the Sql Result with required Pax and Status
				foreach($rowSet as $row){
					if($Presenttime == null && $table_pax == null){
						$Presenttime = $row->rssstart_time;
						$rssid = $row->rssid;
						$inventory_id = $row->invetory_id;
						$table_pax = $row->rsttable_pax;
						$tablecount = $row->rstno_of_tables;
						$status = $this->timeBookingStatus($restid,$timings->getDate(),$Presenttime,$table_pax,$tablecount,$rssid);
					}//Initial initialization of the values
					else if($Presenttime == $row->rssstart_time && $table_pax <= $row->rsttable_pax && $status == 'RSD'){
						continue;
					}//If Old Pax is lessthan New Pax and Status is RSD
					else if($Presenttime == $row->rssstart_time && $table_pax <= $row->rsttable_pax && $status == 'WAL'){
						$newpax = $row->rsttable_pax;
						$newtablecount = $row->rstno_of_tables;
						$newstatus = $this->timeBookingStatus($restid,$timings->getDate(),$Presenttime,$newpax,$newtablecount,$rssid);
						$newinventory_id = $row->invetory_id;
						if($newstatus == 'WAL'){
							continue;
						}else{
							$table_pax = $newpax;
							$status = $newstatus;
							$rssid = $row->rssid;
							$inventory_id = $newinventory_id;
							$tablecount = $newtablecount;
						}
					}//If Old Pax is lessthan New Pax and Status is WAL
					else if($Presenttime == $row->rssstart_time && $table_pax > $row->rsttable_pax && $status == 'RSD'){
						$newpax = $row->rsttable_pax;
						$newtablecount = $row->rstno_of_tables;
						$newstatus = $this->timeBookingStatus($restid,$timings->getDate(),$Presenttime,$newpax,$newtablecount,$rssid);
						$newinventory_id = $row->invetory_id;
						if($newstatus == 'WAL'){
							continue;
						}else{
							$table_pax = $newpax;
							$status = $newstatus;
							$rssid = $row->rssid;
							$inventory_id = $newinventory_id;
							$tablecount = $newtablecount;
						}
					}//If Old Pax is Greaterthan NewPax and Status is RSD
					else if($Presenttime == $row->rssstart_time && $table_pax > $row->rsttable_pax && $status == 'WAL'){
						$table_pax = $row->rsttable_pax;
						$tablecount = $row->rstno_of_tables;
						$rssid = $row->rssid;
						$inventory_id = $row->invetory_id;
						$status  = $this->timeBookingStatus($restid,$timings->getDate(),$Presenttime,$table_pax,$tablecount,$rssid);
					}//If Old Pax is Greaterthan NewPax and Status is WAL
					else if($Presenttime != $row->rssstart_time){
						$restTimePax[] = array('RestId'=>$restid,'time'=>$Presenttime,'pax'=>$table_pax,'nooftables'=>$tablecount,'status'=>$status,'Inventory_Id'=>$inventory_id);
						$Presenttime   = $row->rssstart_time;
						$inventory_id  = $row->invetory_id;
						$rssid = $row->rssid;
						$table_pax     = $row->rsttable_pax;
						$tablecount    = $row->rstno_of_tables;
						$status 	   = $this->timeBookingStatus($restid,$timings->getDate(),$Presenttime,$table_pax,$tablecount,$rssid);
					}//If present time is changed


				}
				$restTimePax[] = array('RestId'=>$restid,'time'=>$Presenttime,'pax'=>$table_pax,'nooftables'=>$tablecount,'status'=>$status,'Inventory_Id'=>$inventory_id);
				$sourceIndex = 0;
				$timeresult = null;
				$index = 0;
				$pax = null;
				$schtime = null;
				$timesarray = null;
				$startingtimes = null;
				$endingtimes = null;
				sort($restTimePax);
				foreach($restTimePax as $times){
					$timesarray[] = $times['time'];
				}//array of all the times
				sort($timesarray);
				$validData  = false;
				$timeSearch = false;
				foreach($restTimePax as $times){
						
					$timeHM = explode(":",$times['time']);
					$sk = mktime($timeHM[0],(int)$timeHM[1],0,0,0,0);
					$time = date("h:i A",$sk);

					$timesp = explode(" ",$timings->getTime());

					$timesplit = explode(":",$timesp[0]);
					//					$count = sizeof($timesplit[0]);
					if((int)$timesplit[0] < 10){
						$timesplit[0] = '0'.(int)$timesplit[0];
					}
					if($timesp[1] ==  "PM"){
						if((int)$timesplit[0] != 12){
							(int)$timesplit[0] += 12;
						}
					}
					if($timesp[1] ==  "AM" && (int)$timesplit[0] == 12){

						(int)$timesplit[0] = '00';

					}
					$actime = array($timesplit[0],$timesplit[1],'00');

					$actualtime = implode(":",$actime);
					$inarrayvalue = in_array($actualtime,$timesarray);
					if($inarrayvalue){
						$timeSearch = array_search($actualtime,$timesarray);
						$sourceIndex = $timeSearch;
						$validData = true;//indicates that the actual time is found in the times array
					}//Checks for the Actual time in the times array for getting the Index value of the actual time
					else if($actualtime > $times['time']){
						$startingtimes[] = $times['time'];
						$validData = false;//indicates that the actual time is not found in the times array
					}//if the actual time is not available in the times array then form the starting times array
					else{
						$endingtimes[] = $times['time'];
						$validData = false;//indicates that the actual time is not found in the times array
					}//if the actual time is not available in the times array then form the ending times array
				}

				if($validData){
					foreach($restTimePax as $times){

						$timeresult[$index] = array('time' => $times['time'],'status'=>$times['status'],'pax'=>$times['pax'],'nooftables' => $times['nooftables'],'inventory_id'=>$times['Inventory_Id']);
						$index++;
					}
				}//if the actual time is found in the times array
				$timekeys = null;
				$actualtimeIndex = null;
				$timeresultarray = null;
				if(!$validData){
					if($startingtimes){
						$timekeys = array_keys($startingtimes);//generates all the keys of the array
					}//if starting times array exists when actual time is not found in the times array
					if($timekeys){
						$actualtimeIndex = end($timekeys);
					}//if timekeys exists
					if($actualtimeIndex == 0 || $actualtimeIndex == 1){
						$i = 0;
					}else{
						$i = $actualtimeIndex-2;
					}
					for($i;$i<=$actualtimeIndex;$i++){
						$timeresultarray[] =$startingtimes[$i];
					}if($endingtimes){
						if(count($endingtimes) == 1){
							$timeresultarray[] = $endingtimes[0];
						}else {
							$timeresultarray[] = $endingtimes[0];
							$timeresultarray[] = $endingtimes[1];
						}


					}
				}//if the actual time is not found in the times array
				$searcharray = null;
				if(!$validData){
					foreach($restTimePax as $values){
						if(in_array($values['time'],$timeresultarray)){
							$searchPax = (int)$timings->getpartysize();
							$searcharray = array('time'=>$values['time'],'pax'=>$searchPax);
							if(in_array($searcharray,$values)){
								$timeresult[] = array('time' => $values['time'],'status'=>$values['status'],'pax'=>$values['pax'],'nooftables' => $values['nooftables'],'inventory_id'=>$values['Inventory_Id']);

							}
						}
						if(in_array($values['time'],$timeresultarray)){
							$timeresult[] = array('time' => $values['time'],'status'=>$values['status'],'pax'=>$values['pax'],'nooftables' => $values['nooftables'],'inventory_id'=>$values['Inventory_Id']);
						}
					}
				}//if the actual time is not found in the times array
				$timeres = null;
				$finaltimekey = null;
				if($validData){
					if(count($timeresult) > 4){
						$timekeys = array_keys($timeresult);
						$finaltimekey = end($timekeys);
						if($sourceIndex < 2 && $sourceIndex >= 0){
							$i = 0;
							for($i ;$i<=$sourceIndex+2;$i++){
								@$timeres[] = @$timeresult[$i];
							}
						}//if the sourceindex is in between 0 and 2
						else if($sourceIndex == $finaltimekey){
							for($i = $sourceIndex-2;$i<=$sourceIndex;$i++){
								@$timeres[] = @$timeresult[@$i];
							}
						}//if sourceindex is equal to the final value of the array
						else if($sourceIndex == $finaltimekey-1){
							for($i = $sourceIndex-2;$i<=$sourceIndex+1;$i++){
								@$timeres[] = @$timeresult[@$i];
							}
						}
						else if($sourceIndex == $finaltimekey-2){
							for($i = $sourceIndex-2;$i<=$sourceIndex+2;$i++){
								@$timeres[] = @$timeresult[@$i];
							}
						}
						else{
							for($i = $sourceIndex-2;$i<=$sourceIndex+2;$i++){
								@$timeres[] = @$timeresult[@$i];
							}
						}
					}else{
						$timeres = $timeresult;
					}
				}//if the count of timeresult is greater than 4
				else{
					$timeres = $timeresult;
				}
				$finalArray = array();
				$finalTimeValue = null;
				$timeIndex = 0;
				/* Get Rest Timezone */
				$timezone = "";
				$mapper = new FirmManagement_Model_FirmDataMapper();
				$timezone = $mapper->GetRestaurantTimeZone($timings->getRestId());
				date_default_timezone_set($timezone);
				$todayDate = date('d-m-Y');				
				if(strtotime($todayDate) == strtotime($date)){
					/* Remove all the past times */
					$timesArray = array();
					$timesArray = $timeres;
				
					$currentTime = date('H:i');				
					$dateTime = $date." ".$currentTime;				
					$convCurrTime = strtotime($dateTime);
				
					if(count($timesArray) > 0){
						foreach($timesArray as $times){
							$restTime = $date." ".$times['time'];
							$convRestTime = strtotime($restTime);
							if($convRestTime > $convCurrTime){
								$finalArray[] = $times;
							}
						}	
					}	
				}else{
					$finalArray = $timeres;	
				}
				if($finalArray){
					foreach($finalArray as $value){
						$timeValue = explode(':',$value['time']);
						if($timeValue[0] >=12){
							if((int)$timeValue[0] != 12){
								(int)$timeValue[0] -= 12;
							}
							$timeValue[2] = 'PM';
							if($timeValue[0] >= 10 || $timeValue[0] == 12){
								$finalTimeValue = $timeValue[0].':'.$timeValue[1].' '.$timeValue[2];
							}else{
								$finalTimeValue = '0'.$timeValue[0].':'.$timeValue[1].' '.$timeValue[2];
							}
						}else{
							$timeValue[2] = 'AM';
							if((int)$timeValue[0] == 0){
								$timeValue[0] = 12;
							}
							$finalTimeValue = $timeValue[0].':'.$timeValue[1].' '.$timeValue[2];
						}
						$value['time'] = $finalTimeValue;
						$finalArray[$timeIndex] = $value;
						$timeIndex++;
					}
				}
				$finalizedArray = "";
				foreach($finalArray as $times){
					$tabMapper = new FirmManagement_Model_FirmScheduleTableDataMapper();
					$tabTable = $tabMapper->getDbTable();
					$tabSelect = $tabTable->select();
					$tabSelect->from($tabTable,array('rstfk_restaurant_schedule'))
							  ->where('rstid = ?',$times['inventory_id']);
					$tabResult = $tabTable->fetchRow($tabSelect);		  
					$selSchId = $tabResult->rstfk_restaurant_schedule;
							  
					$frzDate = explode("-",$timings->getDate());
					if($frzDate[0] > 100){
						$frzDate = $timings->getDate();
					}else{
						$s = mktime(0,0,0,$frzDate[0],$frzDate[1],$frzDate[2]);
						$frzDate = date('Y-m-d',$s);
					}					
					$frzSql = "select frzid,frztype from mt.restaurant_freeze frz
					   			where frzfreezedate ='".$frzDate."' and frzfk_restaurant =".$restid." and frz_restsch_setting_id IN (1,2)";;
					$frzIdSet = $db->fetchRow($frzSql);
					
					$frzid = $frzIdSet['frzid'];
					$frztype =$frzIdSet['frztype'];
					if($frzid){
						if(trim($frztype) == 'All'){
							break;
						}else{
							$frztimemapper = new Reservation_Model_RestaurantFreezeTimeMapDataMapper();
							$frztimeTable = $frztimemapper->getDbTable();
							$frztimeSelect = $frztimeTable->select();
							$frztimeSelect->from($frztimeTable,array('rftmfrz_time'))
										  ->where('rftm_frzid = ?',$frzid)
										  ->where('rftm_frzresid = ?',$restid);
										  
							$frztimeResult = $frztimeTable->fetchAll($frztimeSelect);
							$schids = array();
							foreach($frztimeResult as $frzt){
								$schids[] = $frzt->rftmfrz_time;
							}
							$arrSearch = array_search($selSchId, $schids);
							if($arrSearch === 0){
								$arrSearch = 1;
							}
							if($arrSearch){
								continue;	
							}
							$finalizedArray[] = $times;	
						}		
					}else{
						$finalizedArray[] = $times;	
					}
				}
				return $finalizedArray;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetRestTimingsByMealType(Reservation_Model_GetRestaurantTimings $timings)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);

			$timezone = "";
			$mapper = new FirmManagement_Model_FirmDataMapper();
			$timezone = $mapper->GetRestaurantTimeZone($timings->getRestId());
			date_default_timezone_set($timezone);
			
			
			$currentUserTime = date("h:i A");
			/* new code for checking the userdate and selected date(17-11-2012) */
			$currentUserDate = date('d-m-Y');
			$currentUserDateStr = strtotime($currentUserDate);
			$todayDateSplit = explode("-",$timings->getDate());
			$s = mktime(0,0,0,$todayDateSplit[0],$todayDateSplit[1],$todayDateSplit[2]);
			$seDate = date('Y-m-d',$s);
			$selUserDateStr = strtotime($seDate);
			/* old code for checking the userdate and selected date(17-11-2012) */
			/*
			$currentUserDate = date('m-d-Y');
			$currentUserDateStr = strtotime($currentUserDate);
			$selUserDateStr = strtotime($timings->getDate());
			*/
			$datesplit = explode("-",$timings->getDate());
			/* Date change to d-m-Y format */
			$dateExpArr = array($datesplit[1],$datesplit[0],$datesplit[2]);
			$date = implode("-",$dateExpArr);
			
			$mealMapper = new FirmManagement_Model_FirmMealTypeDataMapper();
			$meal = new FirmManagement_Model_FirmMealType();
			if($timings->getMealType() != ""){
				$meal->setMealType($timings->getMealType())
					 ->setResId($timings->getRestId());
				$selMealType = $mealMapper->GetRestaurantAllMealType($meal);
			}else{
				$meal->setMealType("")
				 ->setResId($timings->getRestId());
				$selMealType = $mealMapper->GetRestaurantAllMealType($meal);
			}
			if($selMealType){			
				$startTime = array();
				$endTime = array();	
				$userTimeConflict = false;
				foreach($selMealType as $selMeal){
					if($selMeal->rmt_start_time){
						if($currentUserDate == $timings->getDate() && $timings->getResType() == 'web'){
							$mk = mktime(date("h"),date('i'),date('s'),date('m'),date('d'),date('Y'));
							$currentUserTimestr = strtotime($currentUserTime);
							$selUserTimestr = strtotime($selMeal->rmt_start_time);
							if($timings->getRestId() != 6){
								if($selUserTimestr > $currentUserTimestr){
									$differenceTimeStr = $selUserTimestr - $currentUserTimestr;
									$differenceTimeMin = floor((($differenceTimeStr)/60)/60);
									if($differenceTimeMin > 3){
										$userStartTime = $selMeal->rmt_start_time;
										$userTimeConflict = false;
									}else if($differenceTimeMin <= 3){
										$reservTimeMapper = new FirmManagement_Model_FirmReservationsTimeSettingDataMapper();
										$timeSettArr = $reservTimeMapper->getRestaurantResvTimeSetting($timings->getRestId()); 
										if($timeSettArr['status']){
											$userStartTime = date('h:i A',strtotime($currentUserTime)+($timeSettArr['time']*60));
											$userTimeConflict = true;
										}else{
											$userStartTime = date('h:i A',strtotime($currentUserTime));
										}
									}else{
										$userStartTime = date('h:i A',strtotime($currentUserTime));
										$userTimeConflict = true;
									}
								}else{
									$reservTimeMapper = new FirmManagement_Model_FirmReservationsTimeSettingDataMapper();
									$timeSettArr = $reservTimeMapper->getRestaurantResvTimeSetting($timings->getRestId()); 
									if($timeSettArr['status']){
										$userStartTime = date('h:i A',strtotime($currentUserTime)+($timeSettArr['time']*60));
										$userTimeConflict = true;
									}else{
										$userStartTime = date('h:i A',strtotime($currentUserTime));
									}
								}
							}else{
								$selUserEndTimestr = strtotime($selMeal->rmt_end_time);
								if($selUserTimestr < $currentUserTimestr && $currentUserTimestr < $selUserEndTimestr){
									return false;
								}else if($selUserTimestr > $currentUserTimestr){
									$differenceTimeStr = $selUserTimestr - $currentUserTimestr;
									$differenceTimeMin = floor((($differenceTimeStr)/60)/60);
									if($differenceTimeMin > 3){
										$userStartTime = $selMeal->rmt_start_time;
										$userTimeConflict = false;
									}else if($differenceTimeMin <= 3){
										$reservTimeMapper = new FirmManagement_Model_FirmReservationsTimeSettingDataMapper();
										$timeSettArr = $reservTimeMapper->getRestaurantResvTimeSetting($timings->getRestId()); 
										if($timeSettArr['status']){
											$userStartTime = date('h:i A',strtotime($currentUserTime)+($timeSettArr['time']*60));
											$userTimeConflict = true;
										}else{
											$userStartTime = date('h:i A',strtotime($currentUserTime));
											$userTimeConflict = true;
										}
									}else{
										$userStartTime = date('h:i A',strtotime($currentUserTime));
										$userTimeConflict = true;
									}
								}else{
									return false;
								}
							}
						
						}
					}else{
						return false;
					}
					if($userTimeConflict){
						$startTime[] =  $userStartTime;
					}else{
						$startTime[] = $selMeal->rmt_start_time;
					}			
					$endTime[] = $selMeal->rmt_end_time;
					
				}	
			}
			if(count($startTime) == 0){
				return false;
			}
			$dateSplit = explode("-",$timings->getDate());
			$weekday = date("D", mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]));
			
			/* Check Whether the selected date contains any special schedule */
			
			$restSpecialSchObject = new FirmManagement_Model_FirmSpecialSchedule();
			$restSpecialSchObject->setrsesfk_restaurant($timings->getRestId());
			$restSpecialSchObject->setrseseventdate($timings->getDate());

			$restSplSchMapperObj = new FirmManagement_Model_FirmSpecialScheduleMapper();
			
			$splSchRow = $restSplSchMapperObj->CheckSpecialScheduleAvilable($restSpecialSchObject);
			
			
			$select->from(array('sch'=>'mt.restaurant_schedule'),array('rssid','rssstart_time','rssfk_restaurant'));
			$select->where('sch.rssfk_restaurant = ?',$timings->getRestId());
			//	   ->where('sch.rssstart_time >= ?',$startTime)
			
			$val = '';
			for($i = 0;$i < count($startTime); $i++){
				if($i == 0){
					$val.= "(sch.rssstart_time >= '$startTime[$i]' and  sch.rssstart_time <= '$endTime[$i]')";
				}else{
					$val.=  " or (sch.rssstart_time >= '$startTime[$i]' and  sch.rssstart_time <= '$endTime[$i]')";
				}
			}
			$select->where("($val)");
		//	   ->where('sch.rssstart_time <= ?',$endTime)
			$select->where('sch.rssday_of_week = ?',strtolower($weekday));
			$select->where('sch.rssstatus = ?',true);

			if($splSchRow){
				$select->where('sch.rssscheduletype_id = ?',2);
				$select->where('sch.rssfk_special_event_schedule = ?',$splSchRow->rsesid);	
			}else{
				$select->where('sch.rssscheduletype_id = ?',1);
			}	   
				   
			$select->join(array('res'=>'mt.restaurant'),'res.resid = sch.rssfk_restaurant',array('res.resid'));
			$select->where('res.resstatus = ?',1);
			$select->where('res.resapprovalstatus = ?',1);
			$select->join(array('rst'=>'mt.restaurant_schedule_table'),'rst.rstfk_restaurant_schedule = sch.rssid',array('rstid as invetory_id','rsttable_pax','rstno_of_tables'));
			$select->where('rst.rststatus = ?',true);

			$tablePax = $timings->getpartysize();
			if($tablePax == 1 || $tablePax == 19){
				$select->where("rst.rsttable_pax = $tablePax OR rst.rsttable_pax = $tablePax + 1");
			}else if($tablePax >= 2 && $tablePax < 19){
				$select->where("rst.rsttable_pax = $tablePax OR rst.rsttable_pax = $tablePax + 1 OR rst.rsttable_pax = $tablePax + 2 ");

			}else if($tablePax >= 20){
				$select->where("rst.rsttable_pax = $tablePax");
			}
			$select->order(array('sch.rssfk_restaurant','sch.rssstart_time'));
			$rowSet = $table->fetchAll($select);
			$rowcount = count($rowSet);
			if($rowcount >0){
				$restid = $timings->getRestId();
				$Presenttime = null;
				$endtime = null;
				$inventory_id = null;
				$table_pax = null;
				$tablecount = null;
				$status = null;
				$rssid = null;
				$restTimePax = array();
				$uniqueResult = array();
				$newpax = null;
				$newtablecount = null;
				$newstatus = null;
				$newinventory_id = null;
				//Sorting of the Sql Result with required Pax and Status
				foreach($rowSet as $row){
					if($Presenttime == null && $table_pax == null){
						$Presenttime = $row->rssstart_time;
						$rssid = $row->rssid;
						$inventory_id = $row->invetory_id;
						$table_pax = $row->rsttable_pax;
						$tablecount = $row->rstno_of_tables;
						$status = $this->timeBookingStatus($restid,$timings->getDate(),$Presenttime,$table_pax,$tablecount,$rssid);
					}//Initial initialization of the values
					else if($Presenttime == $row->rssstart_time && $table_pax <= $row->rsttable_pax && $status == 'RSD'){
						continue;
					}//If Old Pax is lessthan New Pax and Status is RSD
					else if($Presenttime == $row->rssstart_time && $table_pax <= $row->rsttable_pax && $status == 'WAL'){
						$newpax = $row->rsttable_pax;
						$newtablecount = $row->rstno_of_tables;
						$newstatus = $this->timeBookingStatus($restid,$timings->getDate(),$Presenttime,$newpax,$newtablecount,$rssid);
						$newinventory_id = $row->invetory_id;
						if($newstatus == 'WAL'){
							continue;
						}else{
							$table_pax = $newpax;
							$status = $newstatus;
							$rssid = $row->rssid;
							$inventory_id = $newinventory_id;
							$tablecount = $newtablecount;
						}
					}//If Old Pax is lessthan New Pax and Status is WAL
					else if($Presenttime == $row->rssstart_time && $table_pax > $row->rsttable_pax && $status == 'RSD'){
						$newpax = $row->rsttable_pax;
						$newtablecount = $row->rstno_of_tables;
						$newstatus = $this->timeBookingStatus($restid,$timings->getDate(),$Presenttime,$newpax,$newtablecount,$rssid);
						$newinventory_id = $row->invetory_id;
						if($newstatus == 'WAL'){
							continue;
						}else{
							$table_pax = $newpax;
							$status = $newstatus;
							$rssid = $row->rssid;
							$inventory_id = $newinventory_id;
							$tablecount = $newtablecount;
						}
					}//If Old Pax is Greaterthan NewPax and Status is RSD
					else if($Presenttime == $row->rssstart_time && $table_pax > $row->rsttable_pax && $status == 'WAL'){
						$table_pax = $row->rsttable_pax;
						$tablecount = $row->rstno_of_tables;
						$rssid = $row->rssid;
						$inventory_id = $row->invetory_id;
						$status  = $this->timeBookingStatus($restid,$timings->getDate(),$Presenttime,$table_pax,$tablecount,$rssid);
					}//If Old Pax is Greaterthan NewPax and Status is WAL
					else if($Presenttime != $row->rssstart_time){
						$restTimePax[] = array('RestId'=>$restid,'time'=>$Presenttime,'pax'=>$table_pax,'nooftables'=>$tablecount,'status'=>$status,'Inventory_Id'=>$inventory_id);
						$Presenttime   = $row->rssstart_time;
						$inventory_id  = $row->invetory_id;
						$rssid = $row->rssid;
						$table_pax     = $row->rsttable_pax;
						$tablecount    = $row->rstno_of_tables;
						$status 	   = $this->timeBookingStatus($restid,$timings->getDate(),$Presenttime,$table_pax,$tablecount,$rssid);
					}//If present time is changed


				}
				$restTimePax[] = array('RestId'=>$restid,'time'=>$Presenttime,'pax'=>$table_pax,'nooftables'=>$tablecount,'status'=>$status,'Inventory_Id'=>$inventory_id);
				$sourceIndex = 0;
				$timeresult = null;
				$index = 0;
				$pax = null;
				$schtime = null;
				$timesarray = null;
				$startingtimes = null;
				$endingtimes = null;
				sort($restTimePax);
				foreach($restTimePax as $times){
					$timesarray[] = $times['time'];
				}//array of all the times
				sort($timesarray);
				$validData  = false;
				$timeSearch = false;
				foreach($restTimePax as $times){
						
					$timeHM = explode(":",$times['time']);
					$sk = mktime($timeHM[0],(int)$timeHM[1],0,0,0,0);
					$time = date("h:i A",$sk);

					$timesp = explode(" ",date("h:i A",strtotime($selMeal->rmt_start_time)));

					$timesplit = explode(":",$timesp[0]);
					//					$count = sizeof($timesplit[0]);
					if((int)$timesplit[0] < 10){
						$timesplit[0] = '0'.(int)$timesplit[0];
					}
					if($timesp[1] ==  "PM"){
						if((int)$timesplit[0] != 12){
							(int)$timesplit[0] += 12;
						}
					}
					if($timesp[1] ==  "AM" && (int)$timesplit[0] == 12){

						(int)$timesplit[0] = '00';

					}
					$actime = array($timesplit[0],$timesplit[1],'00');

					$actualtime = implode(":",$actime);
					$inarrayvalue = in_array($actualtime,$timesarray);
					if($inarrayvalue){
						$timeSearch = array_search($actualtime,$timesarray);
						$sourceIndex = $timeSearch;
						$validData = true;//indicates that the actual time is found in the times array
					}//Checks for the Actual time in the times array for getting the Index value of the actual time
					else if($actualtime > $times['time']){
						$startingtimes[] = $times['time'];
						$validData = false;//indicates that the actual time is not found in the times array
					}//if the actual time is not available in the times array then form the starting times array
					else{
						$endingtimes[] = $times['time'];
						$validData = false;//indicates that the actual time is not found in the times array
					}//if the actual time is not available in the times array then form the ending times array
				}

				if($validData){
					foreach($restTimePax as $times){

						$timeresult[$index] = array('time' => $times['time'],'status'=>$times['status'],'pax'=>$times['pax'],'nooftables' => $times['nooftables'],'inventory_id'=>$times['Inventory_Id']);
						$index++;
					}
				}//if the actual time is found in the times array
				$timekeys = null;
				$actualtimeIndex = null;
				$timeresultarray = null;
				if(!$validData){
					if($startingtimes){
						$timekeys = array_keys($startingtimes);//generates all the keys of the array
					}//if starting times array exists when actual time is not found in the times array
					if($endingtimes){
						$timekeys = array_keys($endingtimes);//generates all the keys of the array
					}
					if($timekeys){
						$actualtimeIndex = end($timekeys);
					}//if timekeys exists
					if($actualtimeIndex == 0 || $actualtimeIndex == 1){
						$i = 0;
					}else{
						$i = 0;
					}
					for($i;$i<=$actualtimeIndex;$i++){
						if($startingtimes){
							$timeresultarray[] =$startingtimes[$i];
						}else if($endingtimes){
							$timeresultarray[] =$endingtimes[$i];
						}
					}
				}//if the actual time is not found in the times array
				$searcharray = null;
				if(!$validData){
					foreach($restTimePax as $values){
						if(in_array($values['time'],$timeresultarray)){
							$searchPax = (int)$timings->getpartysize();
							$searcharray = array('time'=>$values['time'],'pax'=>$searchPax);
							if(in_array($searcharray,$values)){
								$timeresult[] = array('time' => $values['time'],'status'=>$values['status'],'pax'=>$values['pax'],'nooftables' => $values['nooftables'],'inventory_id'=>$values['Inventory_Id']);

							}
						}
						if(in_array($values['time'],$timeresultarray)){
							$timeresult[] = array('time' => $values['time'],'status'=>$values['status'],'pax'=>$values['pax'],'nooftables' => $values['nooftables'],'inventory_id'=>$values['Inventory_Id']);
						}
					}
				}//if the actual time is not found in the times array
				$timeres = null;
				$finaltimekey = null;
				$timeres = $timeresult;
				$finalArray = array();
				$finalTimeValue = null;
				$timeIndex = 0;
				/* Get Rest Timezone */
				$timezone = "";
				$mapper = new FirmManagement_Model_FirmDataMapper();
				$timezone = $mapper->GetRestaurantTimeZone($timings->getRestId());
				date_default_timezone_set($timezone);
				$todayDate = date('d-m-Y');				
				if(strtotime($todayDate) == strtotime($date)){
					/* Remove all the past times */
					$timesArray = array();
					$timesArray = $timeres;
				
					$currentTime = date('H:i');				
					$dateTime = $date." ".$currentTime;				
					$convCurrTime = strtotime($dateTime);
				
					if(count($timesArray) > 0){
						foreach($timesArray as $times){
							$restTime = $date." ".$times['time'];
							$convRestTime = strtotime($restTime);
							if($convRestTime > $convCurrTime){
								$finalArray[] = $times;
							}
						}	
					}	
				}else{
					$finalArray = $timeres;	
				}
				if($finalArray){
					foreach($finalArray as $value){
						$timeValue = explode(':',$value['time']);
						if($timeValue[0] >=12){
							if((int)$timeValue[0] != 12){
								(int)$timeValue[0] -= 12;
							}
							$timeValue[2] = 'PM';
							if($timeValue[0] >= 10 || $timeValue[0] == 12){
								$finalTimeValue = $timeValue[0].':'.$timeValue[1].' '.$timeValue[2];
							}else{
								$finalTimeValue = '0'.$timeValue[0].':'.$timeValue[1].' '.$timeValue[2];
							}
						}else{
							$timeValue[2] = 'AM';
							if((int)$timeValue[0] == 0){
								$timeValue[0] = 12;
							}
							$finalTimeValue = $timeValue[0].':'.$timeValue[1].' '.$timeValue[2];
						}
						$value['time'] = $finalTimeValue;
						$finalArray[$timeIndex] = $value;
						$timeIndex++;
					}
				}
				$finalizedArray = "";
				foreach($finalArray as $times){
					$tabMapper = new FirmManagement_Model_FirmScheduleTableDataMapper();
					$tabTable = $tabMapper->getDbTable();
					$tabSelect = $tabTable->select();
					$tabSelect->from($tabTable,array('rstfk_restaurant_schedule'))
							  ->where('rstid = ?',$times['inventory_id']);
					$tabResult = $tabTable->fetchRow($tabSelect);		  
					$selSchId = $tabResult->rstfk_restaurant_schedule;
							  
					$frzDate = explode("-",$timings->getDate());
	
					$s = mktime(0,0,0,$frzDate[0],$frzDate[1],$frzDate[2]);
					$frzDate = date('Y-m-d',$s);
					$frzSql = "select frzid,frztype from mt.restaurant_freeze frz
					   			where frzfreezedate ='".$frzDate."' and frzfk_restaurant =".$restid." and frz_restsch_setting_id IN (1,2)";;
					$frzIdSet = $db->fetchRow($frzSql);
					
					$frzid = $frzIdSet['frzid'];
					$frztype =$frzIdSet['frztype'];
					if($frzid){
						if(trim($frztype) == 'All'){
							break;
						}else{
							$frztimemapper = new Reservation_Model_RestaurantFreezeTimeMapDataMapper();
							$frztimeTable = $frztimemapper->getDbTable();
							$frztimeSelect = $frztimeTable->select();
							$frztimeSelect->from($frztimeTable,array('rftmfrz_time'))
										  ->where('rftm_frzid = ?',$frzid)
										  ->where('rftm_frzresid = ?',$restid);
										  
							$frztimeResult = $frztimeTable->fetchAll($frztimeSelect);
							$schids = array();
							foreach($frztimeResult as $frzt){
								$schids[] = $frzt->rftmfrz_time;
							}
							$arrSearch = array_search($selSchId, $schids);
							if($arrSearch === 0){
								$arrSearch = 1;
							}
							if($arrSearch){
								continue;	
							}
							$finalizedArray[] = $times;	
						}		
					}else{
						$finalizedArray[] = $times;	
					}
				}
				return $finalizedArray;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetRestTimingsForAccumulative(Reservation_Model_GetRestaurantTimings $timings)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);

			$endTime = $timings->getTime();
			$time = explode(" ",$endTime);
			$timeHM = explode(":",$time[0]);
			if($time[1] ==  "PM"){
				if((int)$timeHM[0] != 12){
					(int)$timeHM[0] += 12;
				}
			}//if the time is PM then adding 12 to the hour
			if($time[1] ==  "AM" && (int)$timeHM[0] == 12){

				(int)$timeHM[0] = 0;

			}
			$timezone = "";
			$mapper = new FirmManagement_Model_FirmDataMapper();
			$timezone = $mapper->GetRestaurantTimeZone($timings->getRestId());
			date_default_timezone_set($timezone);
			
			
			$currentUserTime = date("h:i A");
			$currentUserDate = date('m-d-Y');
			$currentUserDateStr = strtotime($currentUserDate);
			$selUserDateStr = strtotime($timings->getDate());
			$userTimeConflict = false;
			if($currentUserDateStr == $selUserDateStr && $timings->getResType() == 'web'){
				$mk = mktime(date("h"),date('i'),date('s'),date('m'),date('d'),date('Y'));
				$currentUserTimestr = strtotime($currentUserTime);
				$selUserTimestr = strtotime($timings->getTime());
				if($selUserTimestr > $currentUserTimestr){
					$differenceTimeStr = $selUserTimestr - $currentUserTimestr;
					$differenceTimeMin = floor((($differenceTimeStr)/60)/60);
					if($differenceTimeMin > 3){
						$userStartTime = $timings->getTime();
						$userTimeConflict = false;
					}else if($differenceTimeMin <= 3){
						$reservTimeMapper = new FirmManagement_Model_FirmReservationsTimeSettingDataMapper();
						$timeSettArr = $reservTimeMapper->getRestaurantResvTimeSetting($timings->getRestId()); 
						if($timeSettArr['status']){
							$userStartTime = date('h:i A',strtotime($currentUserTime)+($timeSettArr['time']*60));
							$userTimeConflict = true;
						}else{
							$userStartTime = date('h:i A',strtotime($currentUserTime));
							$userTimeConflict = true;
						}
					}else{
						return false;
					}
				}else{
					return false;
				}
			}
			
			
			$todayDateSplit = explode("-",$timings->getDate());
			$todayDateSplit[1] = $todayDateSplit[1];
			$todayDateArray = array($todayDateSplit[0],$todayDateSplit[1],$todayDateSplit[2]);
			$today = implode("-",$todayDateArray);

			$userTimeSec = mktime($timeHM[0],$timeHM[1],0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
			$userTime = date("h:i A",$userTimeSec);

			$todayTimeSec = mktime(21,0,0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
			$todayTime = date("h:i A",$todayTimeSec);

			$endTimeSec = mktime($timeHM[0]+3,(int)$timeHM[1],0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
			$endTime =  date("h:i A",$endTimeSec);

			$datesplit = explode("-",$timings->getDate());
			/* Date change to d-m-Y format */
			$dateExpArr = array($datesplit[1],$datesplit[0],$datesplit[2]);
			$date = implode("-",$dateExpArr);

			$datesplit[1] = $datesplit[1]+1;
			$datearray = array($datesplit[0],$datesplit[1],$datesplit[2]);
			$tomorrow = implode("-",$datearray);//next days date
			$tomorrowTimeSec = mktime(00,(int)00,0,$datesplit[1],$datesplit[0],$datesplit[2]);
			$tomorrowTime = date("h:i A",$tomorrowTimeSec);//12:00AM
			if($userTimeSec >= $todayTimeSec && $endTimeSec <= $tomorrowTimeSec){
				$endTimeSec = mktime(23,(int)59,0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
				$endTime =  date("h:i A",$endTimeSec);
			}
			$todayThreeTimeSec = mktime(3,0,0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
			$todayThreeTime = date("h:i A",$todayThreeTimeSec);

			$todayLastTimeSec = mktime(00,(int)00,0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
			$todayLastTime = date("h:i A",$todayLastTimeSec);

			if($userTimeConflict){
				$startTime =  $userStartTime;
			}else{
				$startTimeSec = mktime($timeHM[0]-3,(int)$timeHM[1],0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
				$startTime =  date("h:i A",$startTimeSec);
				if($userTimeSec <= $todayThreeTimeSec && $startTimeSec <= $todayLastTimeSec){
					$startTimeSec = mktime(0,(int)0,0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
					$startTime =  date("h:i A",$startTimeSec);
				}
			}

			$dateSplit = explode("-",$timings->getDate());
			$weekday = date("D", mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]));
			
			/* Check Whether the selected date contains any special schedule */
			
			$restSpecialSchObject = new FirmManagement_Model_FirmSpecialSchedule();
			$restSpecialSchObject->setrsesfk_restaurant($timings->getRestId());
			$restSpecialSchObject->setrseseventdate($timings->getDate());

			$restSplSchMapperObj = new FirmManagement_Model_FirmSpecialScheduleMapper();
			
			$splSchRow = $restSplSchMapperObj->CheckSpecialScheduleAvilable($restSpecialSchObject);
			
			$bookMapper = new Reservation_Model_ReservationDataMapper();
			$bookSel = $bookMapper->getDbTable()->select();
			$bookSel->setIntegrityCheck(false);
			$bookSel->from(array('bok'=>'mt.booking'),array('count(bokid) as bookcount'));
			$splitbookdate   = explode('-',$timings->getDate());
			$bookingdate   = date('Y-m-d',mktime(0,0,0,$splitbookdate[0],$splitbookdate[1],$splitbookdate[2]));
			$bookSel->joinLeft(array('acc'=>'mt.booking_accumulative_inventory'),'bok.bokid = acc.bai_fk_booking',array(''));				
			$bookSel->join(array('rsttab'=>'mt.restaurant_schedule_table'),'bok.bokfk_rest_sch_table = rsttab.rstid or acc.bai_inventory = rsttab.rstid',array('rsttab.rstid as bok_rstid','rsttab.rsttable_pax as bok_pax'));
			
			$bookSel->where('bok.bokbooking_made_on = ?',$bookingdate);
			$bookSel->where('bok.bokfk_restaurant = ?',$timings->getRestId());
			$bookSel->group(array('rsttab.rstid','rsttab.rsttable_pax'));
			
			$select->from(array('sch'=>'mt.restaurant_schedule'),array('rssid','rssstart_time','rssfk_restaurant'))
				   ->where('sch.rssfk_restaurant = ?',$timings->getRestId())
				   ->where('sch.rssstart_time >= ?',$startTime)
				   ->where('sch.rssstart_time <= ?',$endTime)
				   ->where('sch.rssday_of_week = ?',strtolower($weekday))
				   ->where('sch.rssstatus = ?',true);

			if($splSchRow){
				$select->where('sch.rssscheduletype_id = ?',2);
				$select->where('sch.rssfk_special_event_schedule = ?',$splSchRow->rsesid);	
			}else{
				$select->where('sch.rssscheduletype_id = ?',1);
			}	   
				   
			$select->join(array('res'=>'mt.restaurant'),'res.resid = sch.rssfk_restaurant',array('res.resid'));
			$select->where('res.resstatus = ?',1);
			$select->where('res.resapprovalstatus = ?',1);
			$schTabMapper = new FirmManagement_Model_FirmScheduleTableDataMapper();
			$schTabSelect = $schTabMapper->getDbTable()->select();
			$schTabSelect->from(array('rstTab'=>'mt.restaurant_schedule_table'),array('rstid','rsttable_pax','rstno_of_tables','rstfk_restaurant_schedule','rststatus'));
			$schTabSelect->order(array('rsttable_pax'));
			$select->join(array('rst'=>$schTabSelect),'rst.rstfk_restaurant_schedule = sch.rssid',array('array_agg(rst.rstid) as invetory_id','array_agg(rst.rsttable_pax) as rsttable_pax','array_agg(rst.rstno_of_tables) as rstno_of_tables'));
			$select->where('rst.rststatus = ?',true);
			$select->joinLeft(array('book'=>$bookSel),'book.bok_rstid = rst.rstid',array('array_agg(coalesce(book.bookcount,0)) as booktotal'));

			$tablePax = $timings->getpartysize();
			$tablePaxArr = array();
			if($tablePax == 1 || $tablePax == 19){
				for($i = 1;$i <= $tablePax+1;$i++){
					$tablePaxArr[] = $i;
				}
			}else if($tablePax >= 2 && $tablePax < 19){
				for($i = 1;$i <= $tablePax+3;$i++){
					$tablePaxArr[] = $i;
				}
			}else if($tablePax >= 20){
				$tablePaxArr[] = $tablePax;
			}
			$select->where("rst.rsttable_pax IN (?)", $tablePaxArr);
			$select->group(array('sch.rssid','sch.rssstart_time','sch.rssfk_restaurant','res.resid'));
//			$select->group(array('rssid','rssstart_time','rssfk_restaurant','res.resid','rstid','rsttable_pax','rstno_of_tables','bokSel.bok_rstid'));
			$select->order(array('sch.rssstart_time'));
			$rowSet = $table->fetchAll($select);
			$rowcount = count($rowSet);
			if($rowcount >0){
				$restid = $timings->getRestId();
				$Presenttime = null;
				$endtime = null;
				$inventory_id = null;
				$table_pax = null;
				$tablecount = null;
				$status = null;
				$rssid = null;
				$restTimePax = array();
				$uniqueResult = array();
				$newpax = null;
				$newtablecount = null;
				$newstatus = null;
				$newinventory_id = null;
				$book_invent_countArr = array();
				$book_invent_count = 0;
				$selParty = $timings->getpartysize();
				$selPartyRange = array();
				for($i = $selParty;$i <= $selParty+3;$i++){
					$selPartyRange[] = $i;
				}
				$availablePaxArr = array();
				$inventory_idArr = array();
				$table_paxArr = array();
				$tablecountArr = array();
				$whileSelStatus = false;
				
				//Sorting of the Sql Result with required Pax and Status
				foreach($rowSet as $row){
					$Presenttime = $row->rssstart_time;
					$rssid = $row->rssid;
					$book_invent_countArr = explode(',',substr($row->booktotal,1,-1));
					$inventory_idArr = explode(',',substr($row->invetory_id,1,-1));
					$table_paxArr = explode(',',substr($row->rsttable_pax,1,-1));
					$tablecountArr = explode(',',substr($row->rstno_of_tables,1,-1));
					
					$frzDate = explode("-",$timings->getDate());
	
					$s = mktime(0,0,0,$frzDate[0],$frzDate[1],$frzDate[2]);
					$frzDate = date('Y-m-d',$s);
					$frzSql = "select frzid,frztype from mt.restaurant_freeze frz
					   			where frzfreezedate ='".$frzDate."' and frzfk_restaurant =".$restid." and frz_restsch_setting_id IN (1,2)";
					$frzIdSet = $db->fetchRow($frzSql);
					
					$frzid = $frzIdSet['frzid'];
					$frztype =$frzIdSet['frztype'];
					if($frzid){
						if(trim($frztype) == 'All'){
							break;
						}else{
							$frztimemapper = new Reservation_Model_RestaurantFreezeTimeMapDataMapper();
							$frztimeTable = $frztimemapper->getDbTable();
							$frztimeSelect = $frztimeTable->select();
							$frztimeSelect->from($frztimeTable,array('rftmfrz_time'))
										  ->where('rftm_frzid = ?',$frzid)
										  ->where('rftm_frzresid = ?',$restid)
										  ->where('rftmfrz_time = ?',$rssid);
										  
							$frztimeResult = $frztimeTable->fetchRow($frztimeSelect);
							$schids = array();
//							foreach($frztimeResult as $frzt){
//								$schids[] = $frzt->rftmfrz_time;
//							}
							if($frztimeResult){
								continue;
							}else{
								$accumulativeStatus = false;
								$slotOccurrenceStatus = false;
								$remainingCount = 0;
								$searchIndexStat = in_array($selParty,$table_paxArr);
								$searchIndex = array_search($selParty,$table_paxArr);
								$tempSel = $selParty;
								
								if($searchIndexStat && ($tablecountArr[$searchIndex] - $book_invent_countArr[$searchIndex] >= 0)){
									$inventory_id = $inventory_idArr[$searchIndex];
									$table_pax = $table_paxArr[$searchIndex];
									$tablecount = $tablecountArr[$searchIndex];
									$book_invent_count = $book_invent_countArr[$searchIndex];
									$status = $this->timeBookingStatus($restid,$timings->getDate(),$Presenttime,$table_pax,$tablecount,$rssid);
									if($status == 'RSD'){
										if($tablecount > $book_invent_count){
											$remainingCount = $tablecount - $book_invent_count;
										}else{
											$remainingCount = 0;
										}		
									}									
									if($status == 'RSD' && $remainingCount >= 0){
										$restTimePax[] = array('RestId'=>$restid,'time'=>$Presenttime,'pax'=>$table_pax,'nooftables'=>$tablecount,'status'=>$status,'Inventory_Id'=>$inventory_id,'bookCount'=>$book_invent_count,'accumulateStatus'=>false);
										continue;
									}
								}else{
									$whileSelStatus = false;
									while($tempSel <= $selParty+3){
										$tempSel++;
										$searchIndexStat = in_array($tempSel,$table_paxArr);
										$searchIndex = array_search($tempSel,$table_paxArr);
										if($searchIndexStat && ($tablecountArr[$searchIndex] - $book_invent_countArr[$searchIndex] >= 0)){
											$inventory_id = $inventory_idArr[$searchIndex];
											$table_pax = $table_paxArr[$searchIndex];
											$tablecount = $tablecountArr[$searchIndex];
											$book_invent_count = $book_invent_countArr[$searchIndex];
											$status = $this->timeBookingStatus($restid,$timings->getDate(),$Presenttime,$table_pax,$tablecount,$rssid);
											if($status == 'RSD'){
												if($tablecount > $book_invent_count){
													$remainingCount = $tablecount - $book_invent_count;
												}else{
													$remainingCount = 0;
												}					
											}						
											if($status == 'RSD' && $remainingCount >= 0){
												$restTimePax[] = array('RestId'=>$restid,'time'=>$Presenttime,'pax'=>$table_pax,'nooftables'=>$tablecount,'status'=>$status,'Inventory_Id'=>$inventory_id,'bookCount'=>$book_invent_count,'accumulateStatus'=>false);
												$whileSelStatus = true;
												break;
											}
										}
									}
									if($whileSelStatus){
										continue;
									}
								}
								$leastPartySizesArr = array_diff($table_paxArr,$selPartyRange);
								$leastPartyCount = count($leastPartySizesArr);
								$accumulativeSlotsPickedArr = array();
								$recentAccumulativePaxPicked = array();
								$remainingAccumulativePaxToPick = 0;
								$remainingPaxCount = $leastPartyCount-1;
								$remainingAccumulativePaxToPick = $selParty;
								if($remainingPaxCount >= 0){
									$highest_table_pax = $table_paxArr[$remainingPaxCount];
								}
								$sch_no_loops = 0;
								$whileSelStatus = false;
								$selPaxCountAccRecuceArr = $tablecountArr;
								while($remainingAccumulativePaxToPick > 0){
									if($remainingPaxCount >= 0){
										$inventory_id = $inventory_idArr[$remainingPaxCount];
										$table_pax = $table_paxArr[$remainingPaxCount];
										$tablecount = $tablecountArr[$remainingPaxCount];
										$book_invent_count = $book_invent_countArr[$remainingPaxCount];
										if($selParty > $table_pax){
											$status = $this->timeBookingStatus($restid,$timings->getDate(),$Presenttime,$table_pax,$tablecount,$rssid);
											if($status == 'RSD'){
												if($tablecount > $book_invent_count){
													$remainingCount = $tablecount - $book_invent_count;
												}else{
													$remainingCount = 0;
												}					
											}						
											if($status == 'RSD' && $remainingCount >= 0){
												$sch_no_loops++;
												$selPaxCountAccRecuceArr[$remainingPaxCount] = $selPaxCountAccRecuceArr[$remainingPaxCount] - 1;
												$accumulativeSlotsPickedArr[] = array('pax'=>$table_pax,'nooftables'=>$tablecount,'Inventory_Id'=>$inventory_id,'bookCount'=>$book_invent_count);
												$recentAccumulativePaxPicked[] = $table_pax;
												$remainingAccumulativePaxToPick = $remainingAccumulativePaxToPick - $table_pax;
											}
											if($table_pax < $remainingAccumulativePaxToPick){
												if(($selPaxCountAccRecuceArr[$remainingPaxCount] - $book_invent_countArr[$remainingPaxCount] > 0) && $status == 'RSD'){
													continue;
												}
											}
											$searchIndexStat = in_array($remainingAccumulativePaxToPick,$table_paxArr);
											$searchIndex = array_search($remainingAccumulativePaxToPick,$table_paxArr);
											if($searchIndexStat && ($selPaxCountAccRecuceArr[$searchIndex] - $book_invent_countArr[$searchIndex] > 0)){
												$inventory_id = $inventory_idArr[$searchIndex];
												$table_pax = $table_paxArr[$searchIndex];
												$tablecount = $tablecountArr[$searchIndex];
												$book_invent_count = $book_invent_countArr[$searchIndex];
												$status = $this->timeBookingStatus($restid,$timings->getDate(),$Presenttime,$table_pax,$tablecount,$rssid);
												if($status == 'RSD'){
													if($tablecount > $book_invent_count){
														$remainingCount = $tablecount - $book_invent_count;
													}else{
														$remainingCount = 0;
													}					
												}						
												if($status == 'RSD' && $remainingCount >= 0){
													$selPaxCountAccRecuceArr[$searchIndex] = $selPaxCountAccRecuceArr[$searchIndex] - 1;
													$accumulativeSlotsPickedArr[] = array('pax'=>$table_pax,'nooftables'=>$tablecount,'Inventory_Id'=>$inventory_id,'bookCount'=>$book_invent_count);
													$recentAccumulativePaxPicked[] = $table_pax;
													$remainingAccumulativePaxToPick = $remainingAccumulativePaxToPick - $table_pax;
												}
											}else{
												$tempSel = $remainingAccumulativePaxToPick;
												if($highest_table_pax >= $tempSel+3){
													$whileSelStatus = false;
													while($tempSel <= $remainingAccumulativePaxToPick+3){
														$tempSel++;
														$searchIndexStat = in_array($tempSel,$table_paxArr);
														$searchIndex = array_search($tempSel,$table_paxArr);
														if($searchIndexStat && ($selPaxCountAccRecuceArr[$searchIndex] - $book_invent_countArr[$searchIndex] > 0)){
															$inventory_id = $inventory_idArr[$searchIndex];
															$table_pax = $table_paxArr[$searchIndex];
															$tablecount = $tablecountArr[$searchIndex];
															$book_invent_count = $book_invent_countArr[$searchIndex];
															$status = $this->timeBookingStatus($restid,$timings->getDate(),$Presenttime,$table_pax,$tablecount,$rssid);
															if($status == 'RSD'){
																if($tablecount > $book_invent_count){
																	$remainingCount = $tablecount - $book_invent_count;
																}else{
																	$remainingCount = 0;
																}		
															}									
															if($status == 'RSD' && $remainingCount >= 0){
																$selPaxCountAccRecuceArr[$searchIndex] = $selPaxCountAccRecuceArr[$searchIndex] - 1;
																$accumulativeSlotsPickedArr[] = array('pax'=>$table_pax,'nooftables'=>$tablecount,'Inventory_Id'=>$inventory_id,'bookCount'=>$book_invent_count);
																$recentAccumulativePaxPicked[] = $table_pax;
																$remainingAccumulativePaxToPick = $remainingAccumulativePaxToPick - $table_pax;
																$whileSelStatus = true;
																break;
															}
														}
													}
												}
												if($whileSelStatus){
													$remainingPaxCount--;
													continue;
												}
											}
										}
										$remainingPaxCount--;
									}else{
										$accumulativeSlotsPickedArr = array();
										break;
									}
								}
								if($remainingAccumulativePaxToPick <= 0){
									$restTimePax[] = array('RestId'=>$restid,'time'=>$Presenttime,'status'=>$status,'accumulateStatus'=>true,'accumulateResult'=>$accumulativeSlotsPickedArr);
								}
								continue;
							}										
						}		
					}else{
						$accumulativeStatus = false;
						$slotOccurrenceStatus = false;
						$remainingCount = 0;
						$searchIndexStat = in_array($selParty,$table_paxArr);
						$searchIndex = array_search($selParty,$table_paxArr);
						$tempSel = $selParty;
						
						if($searchIndexStat && ($tablecountArr[$searchIndex] - $book_invent_countArr[$searchIndex] >= 0)){
							$inventory_id = $inventory_idArr[$searchIndex];
							$table_pax = $table_paxArr[$searchIndex];
							$tablecount = $tablecountArr[$searchIndex];
							$book_invent_count = $book_invent_countArr[$searchIndex];
							$status = $this->timeBookingStatus($restid,$timings->getDate(),$Presenttime,$table_pax,$tablecount,$rssid);
							if($status == 'RSD'){
								if($tablecount > $book_invent_count){
									$remainingCount = $tablecount - $book_invent_count;
								}else{
									$remainingCount = 0;
								}				
							}							
							if($status == 'RSD' && $remainingCount >= 0){
								$restTimePax[] = array('RestId'=>$restid,'time'=>$Presenttime,'pax'=>$table_pax,'nooftables'=>$tablecount,'status'=>$status,'Inventory_Id'=>$inventory_id,'bookCount'=>$book_invent_count,'accumulateStatus'=>false);
								continue;
							}
						}else{
							$whileSelStatus = false;
							while($tempSel <= $selParty+3){
								$tempSel++;
								$searchIndexStat = in_array($tempSel,$table_paxArr);
								$searchIndex = array_search($tempSel,$table_paxArr);
								if($searchIndexStat && ($tablecountArr[$searchIndex] - $book_invent_countArr[$searchIndex] >= 0)){
									$inventory_id = $inventory_idArr[$searchIndex];
									$table_pax = $table_paxArr[$searchIndex];
									$tablecount = $tablecountArr[$searchIndex];
									$book_invent_count = $book_invent_countArr[$searchIndex];
									$status = $this->timeBookingStatus($restid,$timings->getDate(),$Presenttime,$table_pax,$tablecount,$rssid);
									if($status == 'RSD'){
										if($tablecount > $book_invent_count){
											$remainingCount = $tablecount - $book_invent_count;
										}else{
											$remainingCount = 0;
										}		
									}									
									if($status == 'RSD' && $remainingCount >= 0){
										$restTimePax[] = array('RestId'=>$restid,'time'=>$Presenttime,'pax'=>$table_pax,'nooftables'=>$tablecount,'status'=>$status,'Inventory_Id'=>$inventory_id,'bookCount'=>$book_invent_count,'accumulateStatus'=>false);
										$whileSelStatus = true;
										break;
									}
								}
							}
							if($whileSelStatus){
								continue;
							}
						}
						$leastPartySizesArr = array_diff($table_paxArr,$selPartyRange);
						$leastPartyCount = count($leastPartySizesArr);
						$accumulativeSlotsPickedArr = array();
						$recentAccumulativePaxPicked = array();
						$remainingAccumulativePaxToPick = 0;
						$remainingPaxCount = $leastPartyCount-1;
						$remainingAccumulativePaxToPick = $selParty;
						if($remainingPaxCount >= 0){
							$highest_table_pax = $table_paxArr[$remainingPaxCount];
						}
						$sch_no_loops = 0;
						$whileSelStatus = false;
						$selPaxCountAccRecuceArr = $tablecountArr;
						while($remainingAccumulativePaxToPick > 0){
							if($remainingPaxCount >= 0){
								$inventory_id = $inventory_idArr[$remainingPaxCount];
								$table_pax = $table_paxArr[$remainingPaxCount];
								$tablecount = $tablecountArr[$remainingPaxCount];
								$book_invent_count = $book_invent_countArr[$remainingPaxCount];
								if($selParty > $table_pax){
									$status = $this->timeBookingStatus($restid,$timings->getDate(),$Presenttime,$table_pax,$tablecount,$rssid);
									if($status == 'RSD'){
										if($tablecount > $book_invent_count){
											$remainingCount = $tablecount - $book_invent_count;
										}else{
											$remainingCount = 0;
										}					
									}						
									if($status == 'RSD' && $remainingCount >= 0){
										$sch_no_loops++;
										$selPaxCountAccRecuceArr[$remainingPaxCount] = $selPaxCountAccRecuceArr[$remainingPaxCount] - 1;
										$accumulativeSlotsPickedArr[] = array('pax'=>$table_pax,'nooftables'=>$tablecount,'Inventory_Id'=>$inventory_id,'bookCount'=>$book_invent_count);
										$recentAccumulativePaxPicked[] = $table_pax;
										$remainingAccumulativePaxToPick = $remainingAccumulativePaxToPick - $table_pax;
									}
									if($table_pax < $remainingAccumulativePaxToPick){
										if(($selPaxCountAccRecuceArr[$remainingPaxCount] - $book_invent_countArr[$remainingPaxCount] > 0) && $status == 'RSD'){
											continue;
										}
									}
									$searchIndexStat = in_array($remainingAccumulativePaxToPick,$table_paxArr);
									$searchIndex = array_search($remainingAccumulativePaxToPick,$table_paxArr);
									if($searchIndexStat && ($selPaxCountAccRecuceArr[$searchIndex] - $book_invent_countArr[$searchIndex] >= 0)){
										$inventory_id = $inventory_idArr[$searchIndex];
										$table_pax = $table_paxArr[$searchIndex];
										$tablecount = $tablecountArr[$searchIndex];
										$book_invent_count = $book_invent_countArr[$searchIndex];
										$status = $this->timeBookingStatus($restid,$timings->getDate(),$Presenttime,$table_pax,$tablecount,$rssid);
										if($status == 'RSD'){
											if($tablecount > $book_invent_count){
												$remainingCount = $tablecount - $book_invent_count;
											}else{
												$remainingCount = 0;
											}					
										}						
										if($status == 'RSD' && $remainingCount >= 0){
											$selPaxCountAccRecuceArr[$searchIndex] = $selPaxCountAccRecuceArr[$searchIndex] - 1;
											$accumulativeSlotsPickedArr[] = array('pax'=>$table_pax,'nooftables'=>$tablecount,'Inventory_Id'=>$inventory_id,'bookCount'=>$book_invent_count);
											$recentAccumulativePaxPicked[] = $table_pax;
											$remainingAccumulativePaxToPick = $remainingAccumulativePaxToPick - $table_pax;
										}
									}else{
										$tempSel = $remainingAccumulativePaxToPick;
										if($highest_table_pax >= $tempSel+3){ 
											$whileSelStatus = false;
											while($tempSel <= $remainingAccumulativePaxToPick+3){
												$tempSel++;
												$searchIndexStat = in_array($tempSel,$table_paxArr);
												$searchIndex = array_search($tempSel,$table_paxArr);
												$x =$selPaxCountAccRecuceArr[$searchIndex] - $book_invent_countArr[$searchIndex];
												if($searchIndexStat && ($selPaxCountAccRecuceArr[$searchIndex] - $book_invent_countArr[$searchIndex] > 0)){
													$inventory_id = $inventory_idArr[$searchIndex];
													$table_pax = $table_paxArr[$searchIndex];
													$tablecount = $tablecountArr[$searchIndex];
													$book_invent_count = $book_invent_countArr[$searchIndex];
													$status = $this->timeBookingStatus($restid,$timings->getDate(),$Presenttime,$table_pax,$tablecount,$rssid);
													if($status == 'RSD'){
														if($tablecount > $book_invent_count){
															$remainingCount = $tablecount - $book_invent_count;
														}else{
															$remainingCount = 0;
														}	
													}										
													if($status == 'RSD' && $remainingCount >= 0){
														$selPaxCountAccRecuceArr[$searchIndex] = $selPaxCountAccRecuceArr[$searchIndex] - 1;
														$accumulativeSlotsPickedArr[] = array('pax'=>$table_pax,'nooftables'=>$tablecount,'Inventory_Id'=>$inventory_id,'bookCount'=>$book_invent_count);
														$recentAccumulativePaxPicked[] = $table_pax;
														$remainingAccumulativePaxToPick = $remainingAccumulativePaxToPick - $table_pax;
														$whileSelStatus = true;
														break;
													}
												}
											}
										}
										if($whileSelStatus){
											$remainingPaxCount--;
											continue;
										}
									}
								}
								$remainingPaxCount--;
							}else{
								$accumulativeSlotsPickedArr = array();
								break;
							}
						}
						if($remainingAccumulativePaxToPick <= 0){
							$restTimePax[] = array('RestId'=>$restid,'time'=>$Presenttime,'status'=>$status,'accumulateStatus'=>true,'accumulateResult'=>$accumulativeSlotsPickedArr);
						}
						continue;
					}
				}
				$sourceIndex = 0;
				$timeresult = null;
				$index = 0;
				$pax = null;
				$schtime = null;
				$timesarray = null;
				$startingtimes = null;
				$endingtimes = null;
				sort($restTimePax);
				foreach($restTimePax as $times){
					$timesarray[] = $times['time'];
				}//array of all the times
				if($timesarray){
					sort($timesarray);
				}
				$validData  = false;
				$timeSearch = false;
				foreach($restTimePax as $times){
						
					$timeHM = explode(":",$times['time']);
					$sk = mktime($timeHM[0],(int)$timeHM[1],0,0,0,0);
					$time = date("h:i A",$sk);

					$timesp = explode(" ",$timings->getTime());

					$timesplit = explode(":",$timesp[0]);
					//					$count = sizeof($timesplit[0]);
					if((int)$timesplit[0] < 10){
						$timesplit[0] = '0'.(int)$timesplit[0];
					}
					if($timesp[1] ==  "PM"){
						if((int)$timesplit[0] != 12){
							(int)$timesplit[0] += 12;
						}
					}
					if($timesp[1] ==  "AM" && (int)$timesplit[0] == 12){

						(int)$timesplit[0] = '00';

					}
					$actime = array($timesplit[0],$timesplit[1],'00');

					$actualtime = implode(":",$actime);
					$inarrayvalue = in_array($actualtime,$timesarray);
					if($inarrayvalue){
						$timeSearch = array_search($actualtime,$timesarray);
						$sourceIndex = $timeSearch;
						$validData = true;//indicates that the actual time is found in the times array
					}//Checks for the Actual time in the times array for getting the Index value of the actual time
					else if($actualtime > $times['time']){
						$startingtimes[] = $times['time'];
						$validData = false;//indicates that the actual time is not found in the times array
					}//if the actual time is not available in the times array then form the starting times array
					else{
						$endingtimes[] = $times['time'];
						$validData = false;//indicates that the actual time is not found in the times array
					}//if the actual time is not available in the times array then form the ending times array
				}

				if($validData){
					foreach($restTimePax as $times){
						if($times['accumulateStatus']){
							$paxStr = '';
							$notStr = '';
							$invStr = '';
							foreach($times['accumulateResult'] as $accumulate){
								if($paxStr && $notStr && $invStr){
									$paxStr .= ','.$accumulate['pax'];
									$notStr .= ','.$accumulate['nooftables'];
									$invStr .= ','.$accumulate['Inventory_Id'];
								}else{
									$paxStr = $accumulate['pax'];
									$notStr = $accumulate['nooftables'];
									$invStr = $accumulate['Inventory_Id'];
								}
							}
							$timeresult[$index] = array('time' => $times['time'],'status'=>$times['status'],'accumulateStatus'=>true,'pax'=>$paxStr,'nooftables' => $notStr,'inventory_id'=>$invStr);
						}else{
							$timeresult[$index] = array('time' => $times['time'],'status'=>$times['status'],'pax'=>$times['pax'],'nooftables' => $times['nooftables'],'inventory_id'=>$times['Inventory_Id'],'accumulateStatus'=>false);
						}
						$index++;
					}
				}//if the actual time is found in the times array
				$timekeys = null;
				$actualtimeIndex = null;
				$timeresultarray = null;
				if(!$validData){
					if($startingtimes){
						$timekeys = array_keys($startingtimes);//generates all the keys of the array
					}//if starting times array exists when actual time is not found in the times array
					if($timekeys){
						$actualtimeIndex = end($timekeys);
					}//if timekeys exists
					if($actualtimeIndex == 0 || $actualtimeIndex == 1){
						$i = 0;
					}else{
						$i = $actualtimeIndex-2;
					}
					for($i;$i<=$actualtimeIndex;$i++){
						$timeresultarray[] =$startingtimes[$i];
					}if($endingtimes){
						if(count($endingtimes) == 1){
							$timeresultarray[] = $endingtimes[0];
						}else {
							$timeresultarray[] = $endingtimes[0];
							$timeresultarray[] = $endingtimes[1];
						}


					}
				}//if the actual time is not found in the times array
				$searcharray = null;
				if(!$validData){
					foreach($restTimePax as $values){
						if(in_array($values['time'],$timeresultarray)){
							$searchPax = (int)$timings->getpartysize();
							$searcharray = array('time'=>$values['time'],'pax'=>$searchPax);
							if(in_array($searcharray,$values)){
								if($values['accumulateStatus']){
									$paxStr = '';
									$notStr = '';
									$invStr = '';
									foreach($values['accumulateResult'] as $accumulate){
										if($paxStr && $notStr && $invStr){
											$paxStr .= ','.$accumulate['pax'];
											$notStr .= ','.$accumulate['nooftables'];
											$invStr .= ','.$accumulate['Inventory_Id'];
										}else{
											$paxStr = $accumulate['pax'];
											$notStr = $accumulate['nooftables'];
											$invStr = $accumulate['Inventory_Id'];
										}
									}
									$timeresult[$index] = array('time' => $values['time'],'status'=>$values['status'],'accumulateStatus'=>true,'pax'=>$paxStr,'nooftables' => $notStr,'inventory_id'=>$invStr);
									$index++;
								}else{
									$timeresult[] = array('time' => $values['time'],'status'=>$values['status'],'pax'=>$values['pax'],'nooftables' => $values['nooftables'],'inventory_id'=>$values['Inventory_Id'],'accumulateStatus'=>false);
								}
							}else{
								if($values['accumulateStatus']){
									$paxStr = '';
									$notStr = '';
									$invStr = '';
									foreach($values['accumulateResult'] as $accumulate){
										if($paxStr && $notStr && $invStr){
											$paxStr .= ','.$accumulate['pax'];
											$notStr .= ','.$accumulate['nooftables'];
											$invStr .= ','.$accumulate['Inventory_Id'];
										}else{
											$paxStr = $accumulate['pax'];
											$notStr = $accumulate['nooftables'];
											$invStr = $accumulate['Inventory_Id'];
										}
									}
									$timeresult[$index] = array('time' => $values['time'],'status'=>$values['status'],'accumulateStatus'=>true,'pax'=>$paxStr,'nooftables' => $notStr,'inventory_id'=>$invStr);
									$index++;
								}else{
									$timeresult[] = array('time' => $values['time'],'status'=>$values['status'],'pax'=>$values['pax'],'nooftables' => $values['nooftables'],'inventory_id'=>$values['Inventory_Id'],'accumulateStatus'=>false);
								}
							}
						}
						
					}
				}//if the actual time is not found in the times array
				$timeres = null;
				$finaltimekey = null;
				if($validData){
					if(count($timeresult) > 4){
						$timekeys = array_keys($timeresult);
						$finaltimekey = end($timekeys);
						if($sourceIndex < 2 && $sourceIndex >= 0){
							$i = 0;
							for($i ;$i<=$sourceIndex+2;$i++){
								@$timeres[] = @$timeresult[$i];
							}
						}//if the sourceindex is in between 0 and 2
						else if($sourceIndex == $finaltimekey){
							for($i = $sourceIndex-2;$i<=$sourceIndex;$i++){
								@$timeres[] = @$timeresult[@$i];
							}
						}//if sourceindex is equal to the final value of the array
						else if($sourceIndex == $finaltimekey-1){
							for($i = $sourceIndex-2;$i<=$sourceIndex+1;$i++){
								@$timeres[] = @$timeresult[@$i];
							}
						}
						else if($sourceIndex == $finaltimekey-2){
							for($i = $sourceIndex-2;$i<=$sourceIndex+2;$i++){
								@$timeres[] = @$timeresult[@$i];
							}
						}
						else{
							for($i = $sourceIndex-2;$i<=$sourceIndex+2;$i++){
								@$timeres[] = @$timeresult[@$i];
							}
						}
					}else{
						$timeres = $timeresult;
					}
				}//if the count of timeresult is greater than 4
				else{
					$timeres = $timeresult;
				}
				$finalArray = array();
				$finalTimeValue = null;
				$timeIndex = 0;
				/* Get Rest Timezone */
				$timezone = "";
				$mapper = new FirmManagement_Model_FirmDataMapper();
				$timezone = $mapper->GetRestaurantTimeZone($timings->getRestId());
				date_default_timezone_set($timezone);
				$todayDate = date('d-m-Y');				
				if(strtotime($todayDate) == strtotime($date)){
					/* Remove all the past times */
					$timesArray = array();
					$timesArray = $timeres;
				
					$currentTime = date('H:i');				
					$dateTime = $date." ".$currentTime;				
					$convCurrTime = strtotime($dateTime);
				
					if(count($timesArray) > 0){
						foreach($timesArray as $times){
							$restTime = $date." ".$times['time'];
							$convRestTime = strtotime($restTime);
							if($convRestTime > $convCurrTime){
								$finalArray[] = $times;
							}
						}	
					}	
				}else{
					$finalArray = $timeres;	
				}
				if($finalArray){
					foreach($finalArray as $value){
						$timeValue = explode(':',$value['time']);
						if($timeValue[0] >=12){
							if((int)$timeValue[0] != 12){
								(int)$timeValue[0] -= 12;
							}
							$timeValue[2] = 'PM';
							if($timeValue[0] >= 10 || $timeValue[0] == 12){
								$finalTimeValue = $timeValue[0].':'.$timeValue[1].' '.$timeValue[2];
							}else{
								$finalTimeValue = '0'.$timeValue[0].':'.$timeValue[1].' '.$timeValue[2];
							}
						}else{
							$timeValue[2] = 'AM';
							if((int)$timeValue[0] == 0){
								$timeValue[0] = 12;
							}
							$finalTimeValue = $timeValue[0].':'.$timeValue[1].' '.$timeValue[2];
						}
						$value['time'] = $finalTimeValue;
						$finalArray[$timeIndex] = $value;
						$timeIndex++;
					}
				}
				
				return $finalArray;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetRestTimingsForAccumulativeByMealType(Reservation_Model_GetRestaurantTimings $timings)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);

			$timezone = "";
			$mapper = new FirmManagement_Model_FirmDataMapper();
			$timezone = $mapper->GetRestaurantTimeZone($timings->getRestId());
			date_default_timezone_set($timezone);
			
			$mealMapper = new FirmManagement_Model_FirmMealTypeDataMapper();
			$meal = new FirmManagement_Model_FirmMealType();
			if($timings->getMealType() != ""){
			$meal->setMealType($timings->getMealType())
				 ->setResId($timings->getRestId());
				$selMealType = $mealMapper->GetRestaurantAllMealType($meal);
			}else{
				$meal->setMealType("")
				 ->setResId($timings->getRestId());
				$selMealType = $mealMapper->GetRestaurantAllMealType($meal);
			}
			
			
			$currentUserTime = date("h:i A");
			$currentUserDate = date('m-d-Y');
			$currentUserDateStr = strtotime($currentUserDate);
			$selUserDateStr = strtotime($timings->getDate());
			
			if($selMealType){			
				$startTime = array();
				$endTime = array();	
				$userTimeConflict = false;
				foreach($selMealType as $selMeal){
					$userTimeConflict = false;
					if($currentUserDate == $timings->getDate() && $timings->getResType() == 'web'){
						$mk = mktime(date("h"),date('i'),date('s'),date('m'),date('d'),date('Y'));
						$currentUserTimestr = strtotime($currentUserTime);
						$selUserTimestr = strtotime($selMeal->rmt_start_time);
						if($timings->getRestId() != 6){
							if($selUserTimestr > $currentUserTimestr){
								$differenceTimeStr = $selUserTimestr - $currentUserTimestr;
								$differenceTimeMin = floor((($differenceTimeStr)/60)/60);
								if($differenceTimeMin > 3){
									$userStartTime = $selMeal->rmt_start_time;
									$userTimeConflict = false;
								}else if($differenceTimeMin <= 3){
									$reservTimeMapper = new FirmManagement_Model_FirmReservationsTimeSettingDataMapper();
									$timeSettArr = $reservTimeMapper->getRestaurantResvTimeSetting($timings->getRestId()); 
									if($timeSettArr['status']){
										$userStartTime = date('h:i A',strtotime($currentUserTime)+($timeSettArr['time']*60));
										$userTimeConflict = true;
									}else{
										$userStartTime = date('h:i A',strtotime($currentUserTime));
									}
								}else{
									$userStartTime = date('h:i A',strtotime($currentUserTime));
									$userTimeConflict = true;
								}
							}else{
								$reservTimeMapper = new FirmManagement_Model_FirmReservationsTimeSettingDataMapper();
								$timeSettArr = $reservTimeMapper->getRestaurantResvTimeSetting($timings->getRestId()); 
								if($timeSettArr['status']){
									$userStartTime = date('h:i A',strtotime($currentUserTime)+($timeSettArr['time']*60));
									$userTimeConflict = true;
								}else{
									$userStartTime = date('h:i A',strtotime($currentUserTime));
								}
								$userTimeConflict = true;
							}
						}else{
							$selUserEndTimestr = strtotime($selMeal->rmt_end_time);
							if($selUserTimestr < $currentUserTimestr && $currentUserTimestr < $selUserEndTimestr){
								return false;
							}else if($selUserTimestr > $currentUserTimestr){
								$differenceTimeStr = $selUserTimestr - $currentUserTimestr;
								$differenceTimeMin = floor((($differenceTimeStr)/60)/60);
								if($differenceTimeMin > 3){
									$userStartTime = $selMeal->rmt_start_time;
									$userTimeConflict = false;
								}else if($differenceTimeMin <= 3){
									$reservTimeMapper = new FirmManagement_Model_FirmReservationsTimeSettingDataMapper();
									$timeSettArr = $reservTimeMapper->getRestaurantResvTimeSetting($timings->getRestId()); 
									if($timeSettArr['status']){
										$userStartTime = date('h:i A',strtotime($currentUserTime)+($timeSettArr['time']*60));
										$userTimeConflict = true;
									}else{
										$userStartTime = date('h:i A',strtotime($currentUserTime));
									}
								}else{
										$userStartTime = date('h:i A',strtotime($currentUserTime));
										$userTimeConflict = true;
								}
							}else{
								return false;
							}
						}
					}
					
					if($userTimeConflict){
						$startTime[] =  $userStartTime;
					}else{
						$startTime[] = $selMeal->rmt_start_time;
					}
					$endTime[] = $selMeal->rmt_end_time;
				}
			}

			if(count($startTime) == 0){
				return false;
			}
			
			$dateSplit = explode("-",$timings->getDate());
			$weekday = date("D", mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]));
			
			/* Check Whether the selected date contains any special schedule */
			
			$datesplit = explode("-",$timings->getDate());
			/* Date change to d-m-Y format */
			$dateExpArr = array($datesplit[1],$datesplit[0],$datesplit[2]);
			$date = implode("-",$dateExpArr);
			
			$restSpecialSchObject = new FirmManagement_Model_FirmSpecialSchedule();
			$restSpecialSchObject->setrsesfk_restaurant($timings->getRestId());
			$restSpecialSchObject->setrseseventdate($timings->getDate());

			$restSplSchMapperObj = new FirmManagement_Model_FirmSpecialScheduleMapper();
			
			$splSchRow = $restSplSchMapperObj->CheckSpecialScheduleAvilable($restSpecialSchObject);
			
			$bookMapper = new Reservation_Model_ReservationDataMapper();
			$bookSel = $bookMapper->getDbTable()->select();
			$bookSel->setIntegrityCheck(false);
			$bookSel->from(array('bok'=>'mt.booking'),array('count(bokid) as bookcount'));
			$splitbookdate   = explode('-',$timings->getDate());
			$bookingdate   = date('Y-m-d',mktime(0,0,0,$splitbookdate[0],$splitbookdate[1],$splitbookdate[2]));
			$bookSel->joinLeft(array('acc'=>'mt.booking_accumulative_inventory'),'bok.bokid = acc.bai_fk_booking',array(''));				
			$bookSel->join(array('rsttab'=>'mt.restaurant_schedule_table'),'bok.bokfk_rest_sch_table = rsttab.rstid or acc.bai_inventory = rsttab.rstid',array('rsttab.rstid as bok_rstid','rsttab.rsttable_pax as bok_pax'));
			
			$bookSel->where('bok.bokbooking_made_on = ?',$bookingdate);
			$bookSel->where('bok.bokfk_restaurant = ?',$timings->getRestId());
			$bookSel->group(array('rsttab.rstid','rsttab.rsttable_pax'));
			
			$val = '';
			for($i = 0;$i < count($startTime); $i++){
				if($i == 0){
					$val.= "(sch.rssstart_time >= '$startTime[$i]' and  sch.rssstart_time <= '$endTime[$i]')";
				}else{
					$val.=  " or (sch.rssstart_time >= '$startTime[$i]' and  sch.rssstart_time <= '$endTime[$i]')";
				}
			}
			
			$select->from(array('sch'=>'mt.restaurant_schedule'),array('rssid','rssstart_time','rssfk_restaurant'))
				   ->where('sch.rssfk_restaurant = ?',$timings->getRestId())
				   ->where("($val)")
//				   ->where('sch.rssstart_time >= ?',$startTime)
//				   ->where('sch.rssstart_time <= ?',$endTime)
				   ->where('sch.rssday_of_week = ?',strtolower($weekday))
				   ->where('sch.rssstatus = ?',true);

			if($splSchRow){
				$select->where('sch.rssscheduletype_id = ?',2);
				$select->where('sch.rssfk_special_event_schedule = ?',$splSchRow->rsesid);	
			}else{
				$select->where('sch.rssscheduletype_id = ?',1);
			}	   
				   
			$select->join(array('res'=>'mt.restaurant'),'res.resid = sch.rssfk_restaurant',array('res.resid'));
			$select->where('res.resstatus = ?',1);
			$select->where('res.resapprovalstatus = ?',1);
			$schTabMapper = new FirmManagement_Model_FirmScheduleTableDataMapper();
			$schTabSelect = $schTabMapper->getDbTable()->select();
			$schTabSelect->from(array('rstTab'=>'mt.restaurant_schedule_table'),array('rstid','rsttable_pax','rstno_of_tables','rstfk_restaurant_schedule','rststatus'));
			$schTabSelect->order(array('rsttable_pax'));
			$select->join(array('rst'=>$schTabSelect),'rst.rstfk_restaurant_schedule = sch.rssid',array('array_agg(rst.rstid) as invetory_id','array_agg(rst.rsttable_pax) as rsttable_pax','array_agg(rst.rstno_of_tables) as rstno_of_tables'));
			$select->where('rst.rststatus = ?',true);
			$select->joinLeft(array('book'=>$bookSel),'book.bok_rstid = rst.rstid',array('array_agg(coalesce(book.bookcount,0)) as booktotal'));

			$tablePax = $timings->getpartysize();
			$tablePaxArr = array();
			if($tablePax == 1 || $tablePax == 19){
				for($i = 1;$i <= $tablePax+1;$i++){
					$tablePaxArr[] = $i;
				}
			}else if($tablePax >= 2 && $tablePax < 19){
				for($i = 1;$i <= $tablePax+3;$i++){
					$tablePaxArr[] = $i;
				}
			}else if($tablePax >= 20){
				$tablePaxArr[] = $tablePax;
			}
			$select->where("rst.rsttable_pax IN (?)", $tablePaxArr);
			$select->group(array('sch.rssid','sch.rssstart_time','sch.rssfk_restaurant','res.resid'));
//			$select->group(array('rssid','rssstart_time','rssfk_restaurant','res.resid','rstid','rsttable_pax','rstno_of_tables','bokSel.bok_rstid'));
			$select->order(array('sch.rssstart_time'));
			$rowSet = $table->fetchAll($select);
			$rowcount = count($rowSet);
			if($rowcount >0){
				$restid = $timings->getRestId();
				$Presenttime = null;
				$endtime = null;
				$inventory_id = null;
				$table_pax = null;
				$tablecount = null;
				$status = null;
				$rssid = null;
				$restTimePax = array();
				$uniqueResult = array();
				$newpax = null;
				$newtablecount = null;
				$newstatus = null;
				$newinventory_id = null;
				$book_invent_countArr = array();
				$book_invent_count = 0;
				$selParty = $timings->getpartysize();
				$selPartyRange = array();
				for($i = $selParty;$i <= $selParty+3;$i++){
					$selPartyRange[] = $i;
				}
				$availablePaxArr = array();
				$inventory_idArr = array();
				$table_paxArr = array();
				$tablecountArr = array();
				$whileSelStatus = false;
				
				//Sorting of the Sql Result with required Pax and Status
				foreach($rowSet as $row){
					$Presenttime = $row->rssstart_time;
					$rssid = $row->rssid;
					$book_invent_countArr = explode(',',substr($row->booktotal,1,-1));
					$inventory_idArr = explode(',',substr($row->invetory_id,1,-1));
					$table_paxArr = explode(',',substr($row->rsttable_pax,1,-1));
					$tablecountArr = explode(',',substr($row->rstno_of_tables,1,-1));
					
					$frzDate = explode("-",$timings->getDate());
	
					$s = mktime(0,0,0,$frzDate[0],$frzDate[1],$frzDate[2]);
					$frzDate = date('Y-m-d',$s);
					$frzSql = "select frzid,frztype from mt.restaurant_freeze frz
					   			where frzfreezedate ='".$frzDate."' and frzfk_restaurant =".$restid." and frz_restsch_setting_id IN (1,2)";
					$frzIdSet = $db->fetchRow($frzSql);
					
					$frzid = $frzIdSet['frzid'];
					$frztype =$frzIdSet['frztype'];
					if($frzid){
						if(trim($frztype) == 'All'){
							break;
						}else{
							$frztimemapper = new Reservation_Model_RestaurantFreezeTimeMapDataMapper();
							$frztimeTable = $frztimemapper->getDbTable();
							$frztimeSelect = $frztimeTable->select();
							$frztimeSelect->from($frztimeTable,array('rftmfrz_time'))
										  ->where('rftm_frzid = ?',$frzid)
										  ->where('rftm_frzresid = ?',$restid)
										  ->where('rftmfrz_time = ?',$rssid);
										  
							$frztimeResult = $frztimeTable->fetchRow($frztimeSelect);
							$schids = array();
//							foreach($frztimeResult as $frzt){
//								$schids[] = $frzt->rftmfrz_time;
//							}
							if($frztimeResult){
								continue;
							}else{
								$accumulativeStatus = false;
								$slotOccurrenceStatus = false;
								$remainingCount = 0;
								$searchIndexStat = in_array($selParty,$table_paxArr);
								$searchIndex = array_search($selParty,$table_paxArr);
								$tempSel = $selParty;
								
								if($searchIndexStat && ($tablecountArr[$searchIndex] - $book_invent_countArr[$searchIndex] >= 0)){
									$inventory_id = $inventory_idArr[$searchIndex];
									$table_pax = $table_paxArr[$searchIndex];
									$tablecount = $tablecountArr[$searchIndex];
									$book_invent_count = $book_invent_countArr[$searchIndex];
									$status = $this->timeBookingStatus($restid,$timings->getDate(),$Presenttime,$table_pax,$tablecount,$rssid);
									if($status == 'RSD'){
										if($tablecount > $book_invent_count){
											$remainingCount = $tablecount - $book_invent_count;
										}else{
											$remainingCount = 0;
										}		
									}									
									if($status == 'RSD' && $remainingCount >= 0){
										$restTimePax[] = array('RestId'=>$restid,'time'=>$Presenttime,'pax'=>$table_pax,'nooftables'=>$tablecount,'status'=>$status,'Inventory_Id'=>$inventory_id,'bookCount'=>$book_invent_count,'accumulateStatus'=>false);
										continue;
									}
								}else{
									$whileSelStatus = false;
									while($tempSel <= $selParty+3){
										$tempSel++;
										$searchIndexStat = in_array($tempSel,$table_paxArr);
										$searchIndex = array_search($tempSel,$table_paxArr);
										if($searchIndexStat && ($tablecountArr[$searchIndex] - $book_invent_countArr[$searchIndex] >= 0)){
											$inventory_id = $inventory_idArr[$searchIndex];
											$table_pax = $table_paxArr[$searchIndex];
											$tablecount = $tablecountArr[$searchIndex];
											$book_invent_count = $book_invent_countArr[$searchIndex];
											$status = $this->timeBookingStatus($restid,$timings->getDate(),$Presenttime,$table_pax,$tablecount,$rssid);
											if($status == 'RSD'){
												if($tablecount > $book_invent_count){
													$remainingCount = $tablecount - $book_invent_count;
												}else{
													$remainingCount = 0;
												}					
											}						
											if($status == 'RSD' && $remainingCount >= 0){
												$restTimePax[] = array('RestId'=>$restid,'time'=>$Presenttime,'pax'=>$table_pax,'nooftables'=>$tablecount,'status'=>$status,'Inventory_Id'=>$inventory_id,'bookCount'=>$book_invent_count,'accumulateStatus'=>false);
												$whileSelStatus = true;
												break;
											}
										}
									}
									if($whileSelStatus){
										continue;
									}
								}
								$leastPartySizesArr = array_diff($table_paxArr,$selPartyRange);
								$leastPartyCount = count($leastPartySizesArr);
								$accumulativeSlotsPickedArr = array();
								$recentAccumulativePaxPicked = array();
								$remainingAccumulativePaxToPick = 0;
								$remainingPaxCount = $leastPartyCount-1;
								$remainingAccumulativePaxToPick = $selParty;
								if($remainingPaxCount >= 0){
									$highest_table_pax = $table_paxArr[$remainingPaxCount];
								}
								$sch_no_loops = 0;
								$whileSelStatus = false;
								$selPaxCountAccRecuceArr = $tablecountArr;
								while($remainingAccumulativePaxToPick > 0){
									if($remainingPaxCount >= 0){
										$inventory_id = $inventory_idArr[$remainingPaxCount];
										$table_pax = $table_paxArr[$remainingPaxCount];
										$tablecount = $tablecountArr[$remainingPaxCount];
										$book_invent_count = $book_invent_countArr[$remainingPaxCount];
										if($selParty > $table_pax){
											$status = $this->timeBookingStatus($restid,$timings->getDate(),$Presenttime,$table_pax,$tablecount,$rssid);
											if($status == 'RSD'){
												if($tablecount > $book_invent_count){
													$remainingCount = $tablecount - $book_invent_count;
												}else{
													$remainingCount = 0;
												}					
											}						
											if($status == 'RSD' && $remainingCount >= 0){
												$sch_no_loops++;
												$selPaxCountAccRecuceArr[$remainingPaxCount] = $selPaxCountAccRecuceArr[$remainingPaxCount] - 1;
												$accumulativeSlotsPickedArr[] = array('pax'=>$table_pax,'nooftables'=>$tablecount,'Inventory_Id'=>$inventory_id,'bookCount'=>$book_invent_count);
												$recentAccumulativePaxPicked[] = $table_pax;
												$remainingAccumulativePaxToPick = $remainingAccumulativePaxToPick - $table_pax;
											}
											if($table_pax < $remainingAccumulativePaxToPick){
												if(($selPaxCountAccRecuceArr[$remainingPaxCount] - $book_invent_countArr[$remainingPaxCount] > 0) && $status == 'RSD'){
													continue;
												}
											}
											$searchIndexStat = in_array($remainingAccumulativePaxToPick,$table_paxArr);
											$searchIndex = array_search($remainingAccumulativePaxToPick,$table_paxArr);
											if($searchIndexStat && ($selPaxCountAccRecuceArr[$searchIndex] - $book_invent_countArr[$searchIndex] > 0)){
												$inventory_id = $inventory_idArr[$searchIndex];
												$table_pax = $table_paxArr[$searchIndex];
												$tablecount = $tablecountArr[$searchIndex];
												$book_invent_count = $book_invent_countArr[$searchIndex];
												$status = $this->timeBookingStatus($restid,$timings->getDate(),$Presenttime,$table_pax,$tablecount,$rssid);
												if($status == 'RSD'){
													if($tablecount > $book_invent_count){
														$remainingCount = $tablecount - $book_invent_count;
													}else{
														$remainingCount = 0;
													}					
												}						
												if($status == 'RSD' && $remainingCount >= 0){
													$selPaxCountAccRecuceArr[$searchIndex] = $selPaxCountAccRecuceArr[$searchIndex] - 1;
													$accumulativeSlotsPickedArr[] = array('pax'=>$table_pax,'nooftables'=>$tablecount,'Inventory_Id'=>$inventory_id,'bookCount'=>$book_invent_count);
													$recentAccumulativePaxPicked[] = $table_pax;
													$remainingAccumulativePaxToPick = $remainingAccumulativePaxToPick - $table_pax;
												}
											}else{
												$tempSel = $remainingAccumulativePaxToPick;
												if($highest_table_pax >= $tempSel+3){
													$whileSelStatus = false;
													while($tempSel <= $remainingAccumulativePaxToPick+3){
														$tempSel++;
														$searchIndexStat = in_array($tempSel,$table_paxArr);
														$searchIndex = array_search($tempSel,$table_paxArr);
														if($searchIndexStat && ($selPaxCountAccRecuceArr[$searchIndex] - $book_invent_countArr[$searchIndex] > 0)){
															$inventory_id = $inventory_idArr[$searchIndex];
															$table_pax = $table_paxArr[$searchIndex];
															$tablecount = $tablecountArr[$searchIndex];
															$book_invent_count = $book_invent_countArr[$searchIndex];
															$status = $this->timeBookingStatus($restid,$timings->getDate(),$Presenttime,$table_pax,$tablecount,$rssid);
															if($status == 'RSD'){
																if($tablecount > $book_invent_count){
																	$remainingCount = $tablecount - $book_invent_count;
																}else{
																	$remainingCount = 0;
																}		
															}									
															if($status == 'RSD' && $remainingCount >= 0){
																$selPaxCountAccRecuceArr[$searchIndex] = $selPaxCountAccRecuceArr[$searchIndex] - 1;
																$accumulativeSlotsPickedArr[] = array('pax'=>$table_pax,'nooftables'=>$tablecount,'Inventory_Id'=>$inventory_id,'bookCount'=>$book_invent_count);
																$recentAccumulativePaxPicked[] = $table_pax;
																$remainingAccumulativePaxToPick = $remainingAccumulativePaxToPick - $table_pax;
																$whileSelStatus = true;
																break;
															}
														}
													}
												}
												if($whileSelStatus){
													$remainingPaxCount--;
													continue;
												}
											}
										}
										$remainingPaxCount--;
									}else{
										$accumulativeSlotsPickedArr = array();
										break;
									}
								}
								if($remainingAccumulativePaxToPick <= 0){
									$restTimePax[] = array('RestId'=>$restid,'time'=>$Presenttime,'status'=>$status,'accumulateStatus'=>true,'accumulateResult'=>$accumulativeSlotsPickedArr);
								}
								continue;
							}										
						}		
					}else{
						$accumulativeStatus = false;
						$slotOccurrenceStatus = false;
						$remainingCount = 0;
						$searchIndexStat = in_array($selParty,$table_paxArr);
						$searchIndex = array_search($selParty,$table_paxArr);
						$tempSel = $selParty;
						
						if($searchIndexStat && ($tablecountArr[$searchIndex] - $book_invent_countArr[$searchIndex] >= 0)){
							$inventory_id = $inventory_idArr[$searchIndex];
							$table_pax = $table_paxArr[$searchIndex];
							$tablecount = $tablecountArr[$searchIndex];
							$book_invent_count = $book_invent_countArr[$searchIndex];
							$status = $this->timeBookingStatus($restid,$timings->getDate(),$Presenttime,$table_pax,$tablecount,$rssid);
							if($status == 'RSD'){
								if($tablecount > $book_invent_count){
									$remainingCount = $tablecount - $book_invent_count;
								}else{
									$remainingCount = 0;
								}				
							}							
							if($status == 'RSD' && $remainingCount >= 0){
								$restTimePax[] = array('RestId'=>$restid,'time'=>$Presenttime,'pax'=>$table_pax,'nooftables'=>$tablecount,'status'=>$status,'Inventory_Id'=>$inventory_id,'bookCount'=>$book_invent_count,'accumulateStatus'=>false);
								continue;
							}
						}else{
							$whileSelStatus = false;
							while($tempSel <= $selParty+3){
								$tempSel++;
								$searchIndexStat = in_array($tempSel,$table_paxArr);
								$searchIndex = array_search($tempSel,$table_paxArr);
								if($searchIndexStat && ($tablecountArr[$searchIndex] - $book_invent_countArr[$searchIndex] >= 0)){
									$inventory_id = $inventory_idArr[$searchIndex];
									$table_pax = $table_paxArr[$searchIndex];
									$tablecount = $tablecountArr[$searchIndex];
									$book_invent_count = $book_invent_countArr[$searchIndex];
									$status = $this->timeBookingStatus($restid,$timings->getDate(),$Presenttime,$table_pax,$tablecount,$rssid);
									if($status == 'RSD'){
										if($tablecount > $book_invent_count){
											$remainingCount = $tablecount - $book_invent_count;
										}else{
											$remainingCount = 0;
										}		
									}									
									if($status == 'RSD' && $remainingCount >= 0){
										$restTimePax[] = array('RestId'=>$restid,'time'=>$Presenttime,'pax'=>$table_pax,'nooftables'=>$tablecount,'status'=>$status,'Inventory_Id'=>$inventory_id,'bookCount'=>$book_invent_count,'accumulateStatus'=>false);
										$whileSelStatus = true;
										break;
									}
								}
							}
							if($whileSelStatus){
								continue;
							}
						}
						$leastPartySizesArr = array_diff($table_paxArr,$selPartyRange);
						$leastPartyCount = count($leastPartySizesArr);
						$accumulativeSlotsPickedArr = array();
						$recentAccumulativePaxPicked = array();
						$remainingAccumulativePaxToPick = 0;
						$remainingPaxCount = $leastPartyCount-1;
						$remainingAccumulativePaxToPick = $selParty;
						if($remainingPaxCount >= 0){
							$highest_table_pax = $table_paxArr[$remainingPaxCount];
						}
						$sch_no_loops = 0;
						$whileSelStatus = false;
						$selPaxCountAccRecuceArr = $tablecountArr;
						while($remainingAccumulativePaxToPick > 0){
							if($remainingPaxCount >= 0){
								$inventory_id = $inventory_idArr[$remainingPaxCount];
								$table_pax = $table_paxArr[$remainingPaxCount];
								$tablecount = $tablecountArr[$remainingPaxCount];
								$book_invent_count = $book_invent_countArr[$remainingPaxCount];
								if($selParty > $table_pax){
									$status = $this->timeBookingStatus($restid,$timings->getDate(),$Presenttime,$table_pax,$tablecount,$rssid);
									if($status == 'RSD'){
										if($tablecount > $book_invent_count){
											$remainingCount = $tablecount - $book_invent_count;
										}else{
											$remainingCount = 0;
										}					
									}						
									if($status == 'RSD' && $remainingCount >= 0){
										$sch_no_loops++;
										$selPaxCountAccRecuceArr[$remainingPaxCount] = $selPaxCountAccRecuceArr[$remainingPaxCount] - 1;
										$accumulativeSlotsPickedArr[] = array('pax'=>$table_pax,'nooftables'=>$tablecount,'Inventory_Id'=>$inventory_id,'bookCount'=>$book_invent_count);
										$recentAccumulativePaxPicked[] = $table_pax;
										$remainingAccumulativePaxToPick = $remainingAccumulativePaxToPick - $table_pax;
									}
									if($table_pax < $remainingAccumulativePaxToPick){
										if(($selPaxCountAccRecuceArr[$remainingPaxCount] - $book_invent_countArr[$remainingPaxCount] > 0) && $status == 'RSD'){
											continue;
										}
									}
									$searchIndexStat = in_array($remainingAccumulativePaxToPick,$table_paxArr);
									$searchIndex = array_search($remainingAccumulativePaxToPick,$table_paxArr);
									if($searchIndexStat && ($selPaxCountAccRecuceArr[$searchIndex] - $book_invent_countArr[$searchIndex] >= 0)){
										$inventory_id = $inventory_idArr[$searchIndex];
										$table_pax = $table_paxArr[$searchIndex];
										$tablecount = $tablecountArr[$searchIndex];
										$book_invent_count = $book_invent_countArr[$searchIndex];
										$status = $this->timeBookingStatus($restid,$timings->getDate(),$Presenttime,$table_pax,$tablecount,$rssid);
										if($status == 'RSD'){
											if($tablecount > $book_invent_count){
												$remainingCount = $tablecount - $book_invent_count;
											}else{
												$remainingCount = 0;
											}					
										}						
										if($status == 'RSD' && $remainingCount >= 0){
											$selPaxCountAccRecuceArr[$searchIndex] = $selPaxCountAccRecuceArr[$searchIndex] - 1;
											$accumulativeSlotsPickedArr[] = array('pax'=>$table_pax,'nooftables'=>$tablecount,'Inventory_Id'=>$inventory_id,'bookCount'=>$book_invent_count);
											$recentAccumulativePaxPicked[] = $table_pax;
											$remainingAccumulativePaxToPick = $remainingAccumulativePaxToPick - $table_pax;
										}
									}else{
										$tempSel = $remainingAccumulativePaxToPick;
										if($highest_table_pax >= $tempSel+3){ 
											$whileSelStatus = false;
											while($tempSel <= $remainingAccumulativePaxToPick+3){
												$tempSel++;
												$searchIndexStat = in_array($tempSel,$table_paxArr);
												$searchIndex = array_search($tempSel,$table_paxArr);
												$x =$selPaxCountAccRecuceArr[$searchIndex] - $book_invent_countArr[$searchIndex];
												if($searchIndexStat && ($selPaxCountAccRecuceArr[$searchIndex] - $book_invent_countArr[$searchIndex] > 0)){
													$inventory_id = $inventory_idArr[$searchIndex];
													$table_pax = $table_paxArr[$searchIndex];
													$tablecount = $tablecountArr[$searchIndex];
													$book_invent_count = $book_invent_countArr[$searchIndex];
													$status = $this->timeBookingStatus($restid,$timings->getDate(),$Presenttime,$table_pax,$tablecount,$rssid);
													if($status == 'RSD'){
														if($tablecount > $book_invent_count){
															$remainingCount = $tablecount - $book_invent_count;
														}else{
															$remainingCount = 0;
														}	
													}										
													if($status == 'RSD' && $remainingCount >= 0){
														$selPaxCountAccRecuceArr[$searchIndex] = $selPaxCountAccRecuceArr[$searchIndex] - 1;
														$accumulativeSlotsPickedArr[] = array('pax'=>$table_pax,'nooftables'=>$tablecount,'Inventory_Id'=>$inventory_id,'bookCount'=>$book_invent_count);
														$recentAccumulativePaxPicked[] = $table_pax;
														$remainingAccumulativePaxToPick = $remainingAccumulativePaxToPick - $table_pax;
														$whileSelStatus = true;
														break;
													}
												}
											}
										}
										if($whileSelStatus){
											$remainingPaxCount--;
											continue;
										}
									}
								}
								$remainingPaxCount--;
							}else{
								$accumulativeSlotsPickedArr = array();
								break;
							}
						}
						if($remainingAccumulativePaxToPick <= 0){
							$restTimePax[] = array('RestId'=>$restid,'time'=>$Presenttime,'status'=>$status,'accumulateStatus'=>true,'accumulateResult'=>$accumulativeSlotsPickedArr);
						}
						continue;
					}
				}
				$sourceIndex = 0;
				$timeresult = null;
				$index = 0;
				$pax = null;
				$schtime = null;
				$timesarray = null;
				$startingtimes = null;
				$endingtimes = null;
				sort($restTimePax);
				foreach($restTimePax as $times){
					$timesarray[] = $times['time'];
				}//array of all the times
				if($timesarray){
					sort($timesarray);
				}
				$validData  = false;
				$timeSearch = false;
				foreach($restTimePax as $times){
						
					$timeHM = explode(":",$times['time']);
					$sk = mktime($timeHM[0],(int)$timeHM[1],0,0,0,0);
					$time = date("h:i A",$sk);

					$timesp = explode(" ",date("h:i A",strtotime($selMeal->rmt_start_time)));

					$timesplit = explode(":",$timesp[0]);
					//					$count = sizeof($timesplit[0]);
					if((int)$timesplit[0] < 10){
						$timesplit[0] = '0'.(int)$timesplit[0];
					}
					if($timesp[1] ==  "PM"){
						if((int)$timesplit[0] != 12){
							(int)$timesplit[0] += 12;
						}
					}
					if($timesp[1] ==  "AM" && (int)$timesplit[0] == 12){

						(int)$timesplit[0] = '00';

					}
					$actime = array($timesplit[0],$timesplit[1],'00');

					$actualtime = implode(":",$actime);
					$inarrayvalue = in_array($actualtime,$timesarray);
					if($inarrayvalue){
						$timeSearch = array_search($actualtime,$timesarray);
						$sourceIndex = $timeSearch;
						$validData = true;//indicates that the actual time is found in the times array
					}//Checks for the Actual time in the times array for getting the Index value of the actual time
					else if($actualtime > $times['time']){
						$startingtimes[] = $times['time'];
						$validData = false;//indicates that the actual time is not found in the times array
					}//if the actual time is not available in the times array then form the starting times array
					else{
						$endingtimes[] = $times['time'];
						$validData = false;//indicates that the actual time is not found in the times array
					}//if the actual time is not available in the times array then form the ending times array
				}

				if($validData){
					foreach($restTimePax as $times){
						if($times['accumulateStatus']){
							$paxStr = '';
							$notStr = '';
							$invStr = '';
							foreach($times['accumulateResult'] as $accumulate){
								if($paxStr && $notStr && $invStr){
									$paxStr .= ','.$accumulate['pax'];
									$notStr .= ','.$accumulate['nooftables'];
									$invStr .= ','.$accumulate['Inventory_Id'];
								}else{
									$paxStr = $accumulate['pax'];
									$notStr = $accumulate['nooftables'];
									$invStr = $accumulate['Inventory_Id'];
								}
							}
							$timeresult[$index] = array('time' => $times['time'],'status'=>$times['status'],'accumulateStatus'=>true,'pax'=>$paxStr,'nooftables' => $notStr,'inventory_id'=>$invStr);
						}else{
							$timeresult[$index] = array('time' => $times['time'],'status'=>$times['status'],'pax'=>$times['pax'],'nooftables' => $times['nooftables'],'inventory_id'=>$times['Inventory_Id'],'accumulateStatus'=>false);
						}
						$index++;
					}
				}//if the actual time is found in the times array
				$timekeys = null;
				$actualtimeIndex = null;
				$timeresultarray = null;
				if(!$validData){
					if($startingtimes){
						$timekeys = array_keys($startingtimes);//generates all the keys of the array
					}//if starting times array exists when actual time is not found in the times array
					if($endingtimes){
						$timekeys = array_keys($endingtimes);//generates all the keys of the array
					}
					
					if($timekeys){
						$actualtimeIndex = end($timekeys);
					}//if timekeys exists
					if($actualtimeIndex == 0 || $actualtimeIndex == 1){
						$i = 0;
					}else{
						$i = 0;
					}
					for($i;$i<=$actualtimeIndex;$i++){
						if($startingtimes){
							$timeresultarray[] =$startingtimes[$i];
						}else if($endingtimes){
							$timeresultarray[] =$endingtimes[$i];
						}						
					}
				}//if the actual time is not found in the times array
				$searcharray = null;
				if(!$validData){
					foreach($restTimePax as $values){
						if(in_array($values['time'],$timeresultarray)){
							$searchPax = (int)$timings->getpartysize();
							$searcharray = array('time'=>$values['time'],'pax'=>$searchPax);
							if(in_array($searcharray,$values)){
								if($values['accumulateStatus']){
									$paxStr = '';
									$notStr = '';
									$invStr = '';
									foreach($values['accumulateResult'] as $accumulate){
										if($paxStr && $notStr && $invStr){
											$paxStr .= ','.$accumulate['pax'];
											$notStr .= ','.$accumulate['nooftables'];
											$invStr .= ','.$accumulate['Inventory_Id'];
										}else{
											$paxStr = $accumulate['pax'];
											$notStr = $accumulate['nooftables'];
											$invStr = $accumulate['Inventory_Id'];
										}
									}
									$timeresult[$index] = array('time' => $values['time'],'status'=>$values['status'],'accumulateStatus'=>true,'pax'=>$paxStr,'nooftables' => $notStr,'inventory_id'=>$invStr);
									$index++;
								}else{
									$timeresult[] = array('time' => $values['time'],'status'=>$values['status'],'pax'=>$values['pax'],'nooftables' => $values['nooftables'],'inventory_id'=>$values['Inventory_Id'],'accumulateStatus'=>false);
								}
							}else{
								if($values['accumulateStatus']){
									$paxStr = '';
									$notStr = '';
									$invStr = '';
									foreach($values['accumulateResult'] as $accumulate){
										if($paxStr && $notStr && $invStr){
											$paxStr .= ','.$accumulate['pax'];
											$notStr .= ','.$accumulate['nooftables'];
											$invStr .= ','.$accumulate['Inventory_Id'];
										}else{
											$paxStr = $accumulate['pax'];
											$notStr = $accumulate['nooftables'];
											$invStr = $accumulate['Inventory_Id'];
										}
									}
									$timeresult[$index] = array('time' => $values['time'],'status'=>$values['status'],'accumulateStatus'=>true,'pax'=>$paxStr,'nooftables' => $notStr,'inventory_id'=>$invStr);
									$index++;
								}else{
									$timeresult[] = array('time' => $values['time'],'status'=>$values['status'],'pax'=>$values['pax'],'nooftables' => $values['nooftables'],'inventory_id'=>$values['Inventory_Id'],'accumulateStatus'=>false);
								}
							}
						}
						
					}
				}//if the actual time is not found in the times array
				$timeres = null;
				$finaltimekey = null;
				$timeres = $timeresult;
				$finalArray = array();
				$finalTimeValue = null;
				$timeIndex = 0;
				/* Get Rest Timezone */
				$timezone = "";
				$mapper = new FirmManagement_Model_FirmDataMapper();
				$timezone = $mapper->GetRestaurantTimeZone($timings->getRestId());
				date_default_timezone_set($timezone);
				$todayDate = date('d-m-Y');				
				if(strtotime($todayDate) == strtotime($date)){
					/* Remove all the past times */
					$timesArray = array();
					$timesArray = $timeres;
				
					$currentTime = date('H:i');				
					$dateTime = $date." ".$currentTime;				
					$convCurrTime = strtotime($dateTime);
				
					if(count($timesArray) > 0){
						foreach($timesArray as $times){
							$restTime = $date." ".$times['time'];
							$convRestTime = strtotime($restTime);
							if($convRestTime > $convCurrTime){
								$finalArray[] = $times;
							}
						}	
					}	
				}else{
					$finalArray = $timeres;	
				}
				if($finalArray){
					foreach($finalArray as $value){
						$timeValue = explode(':',$value['time']);
						if($timeValue[0] >=12){
							if((int)$timeValue[0] != 12){
								(int)$timeValue[0] -= 12;
							}
							$timeValue[2] = 'PM';
							if($timeValue[0] >= 10 || $timeValue[0] == 12){
								$finalTimeValue = $timeValue[0].':'.$timeValue[1].' '.$timeValue[2];
							}else{
								$finalTimeValue = '0'.$timeValue[0].':'.$timeValue[1].' '.$timeValue[2];
							}
						}else{
							$timeValue[2] = 'AM';
							if((int)$timeValue[0] == 0){
								$timeValue[0] = 12;
							}
							$finalTimeValue = $timeValue[0].':'.$timeValue[1].' '.$timeValue[2];
						}
						$value['time'] = $finalTimeValue;
						$finalArray[$timeIndex] = $value;
						$timeIndex++;
					}
				}
				
				return $finalArray;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/* retrive times for unlimited seetings  */
	public function GetRestTimingsForUnlimited(Reservation_Model_GetRestaurantTimings $timings)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			
			$endTime = $timings->getTime();
			$time = explode(" ",$endTime);
			$timeHM = explode(":",$time[0]);
			if($time[1] ==  "PM"){
				if((int)$timeHM[0] != 12){
					(int)$timeHM[0] += 12;
				}
			}//if the time is PM then adding 12 to the hour
			if($time[1] ==  "AM" && (int)$timeHM[0] == 12){
				(int)$timeHM[0] = 0;
			}
			/* set timezone as a restaurant timezone */
			$timezone = "";
			$mapper = new FirmManagement_Model_FirmDataMapper();
			$timezone = $mapper->GetRestaurantTimeZone($timings->getRestId());
			date_default_timezone_set($timezone);
			
			$currentUserTime = date("h:i A");
			
			/* new code for checking the userdate and selected date(17-11-2012) */
			$currentUserDate = date('d-m-Y');
			$currentUserDateStr = strtotime($currentUserDate);
			$todayDateSplit = explode("-",$timings->getDate());
			$s = mktime(0,0,0,$todayDateSplit[0],$todayDateSplit[1],$todayDateSplit[2]);
			$seDate = date('Y-m-d',$s);
			$selUserDateStr = strtotime($seDate);
			/* old code for checking the userdate and selected date(17-11-2012) */
			
			$currentUserDate = date('m-d-Y');
			$currentUserDateStr = strtotime($currentUserDate);
			$selUserDateStr = strtotime($timings->getDate());
			$userTimeConflict = false;
			if($currentUserDateStr == $selUserDateStr && $timings->getResType() == 'web'){
				$mk = mktime(date("h"),date('i'),date('s'),date('m'),date('d'),date('Y'));
				$currentUserTimestr = strtotime($currentUserTime);
				$selUserTimestr = strtotime($timings->getTime());
				if($selUserTimestr > $currentUserTimestr){
					$differenceTimeStr = $selUserTimestr - $currentUserTimestr;
					$differenceTimeMin = floor((($differenceTimeStr)/60)/60);
					if($differenceTimeMin > 3){
						$userStartTime = $timings->getTime();
						$userTimeConflict = false;
					}else if($differenceTimeMin <= 3){
						$reservTimeMapper = new FirmManagement_Model_FirmReservationsTimeSettingDataMapper();
						$timeSettArr = $reservTimeMapper->getRestaurantResvTimeSetting($timings->getRestId()); 
						if($timeSettArr['status']){
							$userStartTime = date('h:i A',strtotime($currentUserTime)+($timeSettArr['time']*60));
							$userTimeConflict = true;
						}else{
							$userStartTime = date('h:i A',strtotime($currentUserTime));
							$userTimeConflict = true;
						}
					}else{
						return false;
					}
				}else{
					return false;
				}
			}
			
			$todayDateSplit = explode("-",$timings->getDate());
			$todayDateSplit[1] = $todayDateSplit[1];
			$todayDateArray = array($todayDateSplit[0],$todayDateSplit[1],$todayDateSplit[2]);
			$today = implode("-",$todayDateArray);

			$userTimeSec = mktime($timeHM[0],$timeHM[1],0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
			$userTime = date("h:i A",$userTimeSec);

			$todayTimeSec = mktime(21,0,0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
			$todayTime = date("h:i A",$todayTimeSec);

			$endTimeSec = mktime($timeHM[0]+3,(int)$timeHM[1],0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
			$endTime =  date("h:i A",$endTimeSec);

			$datesplit = explode("-",$timings->getDate());
			/* Date change to d-m-Y format */
			$datesplit = explode("-",$timings->getDate());
			$dateExpArr = array($datesplit[1],$datesplit[0],$datesplit[2]);
			$date = implode("-",$dateExpArr);

			$datesplit[1] = $datesplit[1]+1;
			$datearray = array($datesplit[0],$datesplit[1],$datesplit[2]);
			$tomorrow = implode("-",$datearray);//next days date
			$tomorrowTimeSec = mktime(00,(int)00,0,$datesplit[1],$datesplit[0],$datesplit[2]);
			$tomorrowTime = date("h:i A",$tomorrowTimeSec);//12:00AM
			if($userTimeSec >= $todayTimeSec && $endTimeSec <= $tomorrowTimeSec){
				$endTimeSec = mktime(23,(int)59,0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
				$endTime =  date("h:i A",$endTimeSec);
			}
			$todayThreeTimeSec = mktime(3,0,0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
			$todayThreeTime = date("h:i A",$todayThreeTimeSec);

			$todayLastTimeSec = mktime(00,(int)00,0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
			$todayLastTime = date("h:i A",$todayLastTimeSec);

			if($userTimeConflict){
				$startTime =  $userStartTime;
			}else{
				$startTimeSec = mktime($timeHM[0]-3,(int)$timeHM[1],0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
				$startTime =  date("h:i A",$startTimeSec);
				if($userTimeSec <= $todayThreeTimeSec && $startTimeSec <= $todayLastTimeSec){
					$startTimeSec = mktime(0,(int)0,0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
					$startTime =  date("h:i A",$startTimeSec);
				}
			}

			$dateSplit = explode("-",$timings->getDate());
			$weekday = date("D", mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]));
			
			/* get avaliable times */
			$select->from(array('sch'=>'mt.restaurant_schedule'),array('rssid','rssstart_time','rssfk_restaurant'))
				   ->where('sch.rssfk_restaurant = ?',$timings->getRestId())
				   ->where('sch.rssstart_time >= ?',$startTime)
				   ->where('sch.rssstart_time <= ?',$endTime)
				   ->where('sch.rssday_of_week = ?',strtolower($weekday))
				   ->where('sch.rssstatus = ?',true)
				   ->where('sch.rssscheduletype_id = ?',3)
				   ->join(array('res'=>'mt.restaurant'),'res.resid = sch.rssfk_restaurant',array('res.resid'))
				   ->where('res.resstatus = ?',1)
				   ->where('res.resapprovalstatus = ?',1)
				   ->order(array('sch.rssfk_restaurant','sch.rssstart_time'));
				   
			$rowSet = $table->fetchAll($select);
			$rowcount = count($rowSet);
			
			$restid = $timings->getRestId();
			$inventory_id = '';
			$table_pax = (int)$timings->getpartysize();
			$tablecount = '';
			$restTimePax = '';
			foreach($rowSet as $row){									
				$selSchId = $row->rssid;					
				$frzDate = explode("-",$timings->getDate());
				$s = mktime(0,0,0,$frzDate[0],$frzDate[1],$frzDate[2]);
				
				/* check freeze times */
				$frzDate = date('Y-m-d',$s);
				$frzSql = "select frzid,frztype from mt.restaurant_freeze frz
				   			where frzfreezedate ='".$frzDate."' and frzfk_restaurant =".$restid." and frz_restsch_setting_id = 4";
				$frzIdSet = $db->fetchRow($frzSql);
				
				$frzid = $frzIdSet['frzid'];
				$frztype =$frzIdSet['frztype'];
				if($frzid){
					if(trim($frztype) == 'All'){
						break;
					}else{
						$frztimemapper = new Reservation_Model_RestaurantFreezeTimeMapDataMapper();
						$frztimeTable = $frztimemapper->getDbTable();
						$frztimeSelect = $frztimeTable->select();
						$frztimeSelect->from($frztimeTable,array('rftmfrz_time'))
									  ->where('rftm_frzid = ?',$frzid)
									  ->where('rftm_frzresid = ?',$restid);									  
						$frztimeResult = $frztimeTable->fetchAll($frztimeSelect);
						$schids = array();
						foreach($frztimeResult as $frzt){
							$schids[] = $frzt->rftmfrz_time;
						}
						$arrSearch = array_search($selSchId, $schids);
						if($arrSearch === 0){
							$arrSearch = 1;
						}
						if($arrSearch){
							continue;	
						}
						$restTimePax[] = array('RestId'=>$restid,'time'=>$row->rssstart_time,'pax'=>$table_pax,'nooftables'=>$tablecount,'status'=>'RSD','Inventory_Id'=>$inventory_id);
					}		
				}else{
					$restTimePax[] = array('RestId'=>$restid,'time'=>$row->rssstart_time,'pax'=>$table_pax,'nooftables'=>$tablecount,'status'=>'RSD','Inventory_Id'=>$inventory_id);	
				}
			}
			$finalizedArray = array();
			if($restTimePax){
				$sourceIndex = 0;
				$timeresult = null;
				$index = 0;
				$pax = null;
				$schtime = null;
				$timesarray = null;
				$startingtimes = null;
				$endingtimes = null;
				sort($restTimePax);
				foreach($restTimePax as $times){
					$timesarray[] = $times['time'];
				}//array of all the times
				sort($timesarray);
				$validData  = false;
				$timeSearch = false;
				foreach($restTimePax as $times){
						
					$timeHM = explode(":",$times['time']);
					$sk = mktime($timeHM[0],(int)$timeHM[1],0,0,0,0);
					$time = date("h:i A",$sk);
					$timesp = explode(" ",$timings->getTime());
					$timesplit = explode(":",$timesp[0]);
					//					$count = sizeof($timesplit[0]);
					if((int)$timesplit[0] < 10){
						$timesplit[0] = '0'.(int)$timesplit[0];
					}
					if($timesp[1] ==  "PM"){
						if((int)$timesplit[0] != 12){
							(int)$timesplit[0] += 12;
						}
					}
					if($timesp[1] ==  "AM" && (int)$timesplit[0] == 12){
						(int)$timesplit[0] = '00';
					}
					$actime = array($timesplit[0],$timesplit[1],'00');

					$actualtime = implode(":",$actime);
					$inarrayvalue = in_array($actualtime,$timesarray);
					if($inarrayvalue){
						$timeSearch = array_search($actualtime,$timesarray);
						$sourceIndex = $timeSearch;
						$validData = true;//indicates that the actual time is found in the times array
					}//Checks for the Actual time in the times array for getting the Index value of the actual time
					else if($actualtime > $times['time']){
						$startingtimes[] = $times['time'];
						$validData = false;//indicates that the actual time is not found in the times array
					}//if the actual time is not available in the times array then form the starting times array
					else{
						$endingtimes[] = $times['time'];
						$validData = false;//indicates that the actual time is not found in the times array
					}//if the actual time is not available in the times array then form the ending times array
				}

				if($validData){
					foreach($restTimePax as $times){
						$timeresult[$index] = array('time' => $times['time'],'status'=>$times['status'],'pax'=>$times['pax'],'nooftables' => $times['nooftables'],'inventory_id'=>$times['Inventory_Id']);
						$index++;
					}
				}//if the actual time is found in the times array
				$timekeys = null;
				$actualtimeIndex = null;
				$timeresultarray = null;
				if(!$validData){
					if($startingtimes){
						$timekeys = array_keys($startingtimes);//generates all the keys of the array
					}//if starting times array exists when actual time is not found in the times array
					if($timekeys){
						$actualtimeIndex = end($timekeys);
					}//if timekeys exists
					if($actualtimeIndex == 0 || $actualtimeIndex == 1){
						$i = 0;
					}else{
						$i = $actualtimeIndex-2;
					}
					for($i;$i<=$actualtimeIndex;$i++){
						$timeresultarray[] =$startingtimes[$i];
					}if($endingtimes){
						if(count($endingtimes) == 1){
							$timeresultarray[] = $endingtimes[0];
						}else {
							$timeresultarray[] = $endingtimes[0];
							$timeresultarray[] = $endingtimes[1];
						}


					}
				}//if the actual time is not found in the times array
				$searcharray = null;
				if(!$validData){
					foreach($restTimePax as $values){
						if(in_array($values['time'],$timeresultarray)){
							$searchPax = (int)$timings->getpartysize();
							$searcharray = array('time'=>$values['time'],'pax'=>$searchPax);
							if(in_array($searcharray,$values)){
								$timeresult[] = array('time' => $values['time'],'status'=>$values['status'],'pax'=>$values['pax'],'nooftables' => $values['nooftables'],'inventory_id'=>$values['Inventory_Id']);
							}
						}
						if(in_array($values['time'],$timeresultarray)){
							$timeresult[] = array('time' => $values['time'],'status'=>$values['status'],'pax'=>$values['pax'],'nooftables' => $values['nooftables'],'inventory_id'=>$values['Inventory_Id']);
						}
					}
				}//if the actual time is not found in the times array
				$timeres = null;
				$finaltimekey = null;
				if($validData){
					if(count($timeresult) > 4){
						$timekeys = array_keys($timeresult);
						$finaltimekey = end($timekeys);
						if($sourceIndex < 2 && $sourceIndex >= 0){
							$i = 0;
							for($i ;$i<=$sourceIndex+2;$i++){
								@$timeres[] = @$timeresult[$i];
							}
						}//if the sourceindex is in between 0 and 2
						else if($sourceIndex == $finaltimekey){
							for($i = $sourceIndex-2;$i<=$sourceIndex;$i++){
								@$timeres[] = @$timeresult[@$i];
							}
						}//if sourceindex is equal to the final value of the array
						else if($sourceIndex == $finaltimekey-1){
							for($i = $sourceIndex-2;$i<=$sourceIndex+1;$i++){
								@$timeres[] = @$timeresult[@$i];
							}
						}
						else if($sourceIndex == $finaltimekey-2){
							for($i = $sourceIndex-2;$i<=$sourceIndex+2;$i++){
								@$timeres[] = @$timeresult[@$i];
							}
						}
						else{
							for($i = $sourceIndex-2;$i<=$sourceIndex+2;$i++){
								@$timeres[] = @$timeresult[@$i];
							}
						}
					}else{
						$timeres = $timeresult;
					}
				}//if the count of timeresult is greater than 4
				else{
					$timeres = $timeresult;
				}
				$finalArray = array();
				$finalTimeValue = null;
				$timeIndex = 0;
				/* Get Rest Timezone */
				date_default_timezone_set($timezone);
				$todayDate = date('d-m-Y');				
				if(strtotime($todayDate) == strtotime($date)){
					/* Remove all the past times */
					$timesArray = array();
					$timesArray = $timeres;
				
					$currentTime = date('H:i');				
					$dateTime = $date." ".$currentTime;				
					$convCurrTime = strtotime($dateTime);
				
					if(count($timesArray) > 0){
						foreach($timesArray as $times){
							$restTime = $date." ".$times['time'];
							$convRestTime = strtotime($restTime);
							if($convRestTime > $convCurrTime){
								$finalArray[] = $times;
							}
						}	
					}	
				}else{
					$finalArray = $timeres;	
				}
				if($finalArray){
					foreach($finalArray as $value){
						$timeValue = explode(':',$value['time']);
						if($timeValue[0] >=12){
							if((int)$timeValue[0] != 12){
								(int)$timeValue[0] -= 12;
							}
							$timeValue[2] = 'PM';
							if($timeValue[0] >= 10 || $timeValue[0] == 12){
								$finalTimeValue = $timeValue[0].':'.$timeValue[1].' '.$timeValue[2];
							}else{
								$finalTimeValue = '0'.$timeValue[0].':'.$timeValue[1].' '.$timeValue[2];
							}
						}else{
							$timeValue[2] = 'AM';
							if((int)$timeValue[0] == 0){
								$timeValue[0] = 12;
							}
							$finalTimeValue = $timeValue[0].':'.$timeValue[1].' '.$timeValue[2];
						}
						$value['time'] = $finalTimeValue;
						$finalArray[$timeIndex] = $value;
						$timeIndex++;
					}
				}				
				foreach($finalArray as $times){
						$finalizedArray[] = $times;	
				}	
			}
			return $finalizedArray;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetRestTimingsForUnlimitedByMealType(Reservation_Model_GetRestaurantTimings $timings)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);

			$timezone = "";
			$mapper = new FirmManagement_Model_FirmDataMapper();
			$timezone = $mapper->GetRestaurantTimeZone($timings->getRestId());
			date_default_timezone_set($timezone);
			
			$currentUserTime = date("h:i A");
			
			/* new code for checking the userdate and selected date(17-11-2012) */
			$currentUserDate = date('Y-m-d');
			$currentUserDateStr = strtotime($currentUserDate);
			$todayDateSplit = explode("-",$timings->getDate());
			$s = mktime(0,0,0,$todayDateSplit[0],$todayDateSplit[1],$todayDateSplit[2]);
			$seDate = date('Y-m-d',$s);
			$selUserDateStr = strtotime($seDate);
			/* old code for checking the userdate and selected date(17-11-2012) */
			
			$mealMapper = new FirmManagement_Model_FirmMealTypeDataMapper();
			$meal = new FirmManagement_Model_FirmMealType();
			
			$meal = new FirmManagement_Model_FirmMealType();
			if($timings->getMealType() != ""){
				$meal->setMealType($timings->getMealType())
					 ->setResId($timings->getRestId());
				$selMealType = $mealMapper->GetRestaurantAllMealType($meal);
			}else{
				$meal->setMealType("")
				 ->setResId($timings->getRestId());
				$selMealType = $mealMapper->GetRestaurantAllMealType($meal);
			}
			
			if($selMealType){			
				$startTime = array();
				$endTime = array();	
				$userTimeConflict = false;
				foreach($selMealType as $selMeal){
					$userTimeConflict = false;
					if($currentUserDate == $timings->getDate() && $timings->getResType() == 'web'){
						$mk = mktime(date("h"),date('i'),date('s'),date('m'),date('d'),date('Y'));
						$currentUserTimestr = strtotime($currentUserTime);
						$selUserTimestr = strtotime($selMeal->rmt_start_time);
						if($timings->getRestId() != 6){
							if($selUserTimestr > $currentUserTimestr){
								$differenceTimeStr = $selUserTimestr - $currentUserTimestr;
								$differenceTimeMin = floor((($differenceTimeStr)/60)/60);
								if($differenceTimeMin > 3){
									$userStartTime = $selMeal->rmt_start_time;
									$userTimeConflict = false;
								}else if($differenceTimeMin <= 3){
									$reservTimeMapper = new FirmManagement_Model_FirmReservationsTimeSettingDataMapper();
									$timeSettArr = $reservTimeMapper->getRestaurantResvTimeSetting($timings->getRestId()); 
									if($timeSettArr['status']){
										$userStartTime = date('h:i A',strtotime($currentUserTime)+($timeSettArr['time']*60));
										$userTimeConflict = true;
									}else{
										$userStartTime = date('h:i A',strtotime($currentUserTime));
									}
								}else{
									$userStartTime = date('h:i A',strtotime($currentUserTime));
									$userTimeConflict = true;
								}
							}else{
									$reservTimeMapper = new FirmManagement_Model_FirmReservationsTimeSettingDataMapper();
									$timeSettArr = $reservTimeMapper->getRestaurantResvTimeSetting($timings->getRestId()); 
									if($timeSettArr['status']){
										$userStartTime = date('h:i A',strtotime($currentUserTime)+($timeSettArr['time']*60));
										$userTimeConflict = true;
									}else{
										$userStartTime = date('h:i A',strtotime($currentUserTime));
									}
							}
						}else{
							$selUserEndTimestr = strtotime($selMeal->rmt_end_time);
							if($selUserTimestr < $currentUserTimestr && $currentUserTimestr < $selUserEndTimestr){
								return false;
							}else if($selUserTimestr > $currentUserTimestr){
								$differenceTimeStr = $selUserTimestr - $currentUserTimestr;
								$differenceTimeMin = floor((($differenceTimeStr)/60)/60);
								if($differenceTimeMin > 3){
									$userStartTime = $selMeal->rmt_start_time;
									$userTimeConflict = false;
								}else if($differenceTimeMin <= 3){
									$reservTimeMapper = new FirmManagement_Model_FirmReservationsTimeSettingDataMapper();
									$timeSettArr = $reservTimeMapper->getRestaurantResvTimeSetting($timings->getRestId()); 
									if($timeSettArr['status']){
										$userStartTime = date('H:i:s',strtotime($currentUserTime)+($timeSettArr['time']*60));
										$userTimeConflict = true;
									}else{
										$userStartTime = date('H:i:s',strtotime($currentUserTime));
										$userTimeConflict = true;
									}
								}else{
									$userStartTime = date('H:i:s',strtotime($currentUserTime));
									$userTimeConflict = true;
								}
							}else{
								return false;
							}
						}
					}
					
					if($userTimeConflict){
						$startTime[] =  $userStartTime;
					}else{
						$startTime[] = $selMeal->rmt_start_time;
					}			
					$endTime[] = $selMeal->rmt_end_time;	
				}
			}		

			if(count($startTime) == 0){
				return false;
			}
			
			$dateSplit = explode("-",$timings->getDate());
			$weekday = date("D", mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]));
			
			$datesplit = explode("-",$timings->getDate());
			/* Date change to d-m-Y format */
			$dateExpArr = array($datesplit[1],$datesplit[0],$datesplit[2]);
			$date = implode("-",$dateExpArr);
			/* get avaliable times */
			
			$val = '';
			for($i = 0;$i < count($startTime); $i++){
				if($i == 0){
					$val.= "(sch.rssstart_time >= '$startTime[$i]' and  sch.rssstart_time <= '$endTime[$i]')";
				}else{
					$val.=  " or (sch.rssstart_time >= '$startTime[$i]' and  sch.rssstart_time <= '$endTime[$i]')";
				}
			}
			$select->from(array('sch'=>'mt.restaurant_schedule'),array('rssid','rssstart_time','rssfk_restaurant'))
				   ->where('sch.rssfk_restaurant = ?',$timings->getRestId())
				   ->where("($val)")   				
				//   ->where('sch.rssstart_time >= ?',$startTime)
				//   ->where('sch.rssstart_time <= ?',$endTime)
				   ->where('sch.rssday_of_week = ?',strtolower($weekday))
				   ->where('sch.rssstatus = ?',true)
				   ->where('sch.rssscheduletype_id = ?',3)
				   ->join(array('res'=>'mt.restaurant'),'res.resid = sch.rssfk_restaurant',array('res.resid'))
				   ->where('res.resstatus = ?',1)
				   ->where('res.resapprovalstatus = ?',1)
				   ->order(array('sch.rssfk_restaurant','sch.rssstart_time'));
				   
			$rowSet = $table->fetchAll($select);
			$rowcount = count($rowSet);
			
			$restid = $timings->getRestId();
			$inventory_id = '';
			$table_pax = (int)$timings->getpartysize();
			$tablecount = '';
			$restTimePax = '';
			foreach($rowSet as $row){									
				$selSchId = $row->rssid;					
				$frzDate = explode("-",$timings->getDate());
				$s = mktime(0,0,0,$frzDate[0],$frzDate[1],$frzDate[2]);
				
				/* check freeze times */
				$frzDate = date('Y-m-d',$s);
				$frzSql = "select frzid,frztype from mt.restaurant_freeze frz
				   			where frzfreezedate ='".$frzDate."' and frzfk_restaurant =".$restid." and frz_restsch_setting_id = 4";
				$frzIdSet = $db->fetchRow($frzSql);
				
				$frzid = $frzIdSet['frzid'];
				$frztype =$frzIdSet['frztype'];
				if($frzid){
					if(trim($frztype) == 'All'){
						break;
					}else{
						$frztimemapper = new Reservation_Model_RestaurantFreezeTimeMapDataMapper();
						$frztimeTable = $frztimemapper->getDbTable();
						$frztimeSelect = $frztimeTable->select();
						$frztimeSelect->from($frztimeTable,array('rftmfrz_time'))
									  ->where('rftm_frzid = ?',$frzid)
									  ->where('rftm_frzresid = ?',$restid);									  
						$frztimeResult = $frztimeTable->fetchAll($frztimeSelect);
						$schids = array();
						foreach($frztimeResult as $frzt){
							$schids[] = $frzt->rftmfrz_time;
						}
						$arrSearch = array_search($selSchId, $schids);
						if($arrSearch === 0){
							$arrSearch = 1;
						}
						if($arrSearch){
							continue;	
						}
						$restTimePax[] = array('RestId'=>$restid,'time'=>$row->rssstart_time,'pax'=>$table_pax,'nooftables'=>$tablecount,'status'=>'RSD','Inventory_Id'=>$inventory_id);
					}		
				}else{
					$restTimePax[] = array('RestId'=>$restid,'time'=>$row->rssstart_time,'pax'=>$table_pax,'nooftables'=>$tablecount,'status'=>'RSD','Inventory_Id'=>$inventory_id);	
				}
			}
			$finalizedArray = array();
			if($restTimePax){
				$sourceIndex = 0;
				$timeresult = null;
				$index = 0;
				$pax = null;
				$schtime = null;
				$timesarray = null;
				$startingtimes = null;
				$endingtimes = null;
				sort($restTimePax);
				foreach($restTimePax as $times){
					$timesarray[] = $times['time'];
				}//array of all the times
				sort($timesarray);
				$validData  = false;
				$timeSearch = false;
				foreach($restTimePax as $times){
						
					$timeHM = explode(":",$times['time']);
					$sk = mktime($timeHM[0],(int)$timeHM[1],0,0,0,0);
					$time = date("h:i A",$sk);

					$timesp = explode(" ",date("h:i A",strtotime($selMeal->rmt_start_time)));

					$timesplit = explode(":",$timesp[0]);
					//					$count = sizeof($timesplit[0]);
					if((int)$timesplit[0] < 10){
						$timesplit[0] = '0'.(int)$timesplit[0];
					}
					if($timesp[1] ==  "PM"){
						if((int)$timesplit[0] != 12){
							(int)$timesplit[0] += 12;
						}
					}
					if($timesp[1] ==  "AM" && (int)$timesplit[0] == 12){
						(int)$timesplit[0] = '00';
					}
					$actime = array($timesplit[0],$timesplit[1],'00');

					$actualtime = implode(":",$actime);
					$inarrayvalue = in_array($actualtime,$timesarray);
					if($inarrayvalue){
						$timeSearch = array_search($actualtime,$timesarray);
						$sourceIndex = $timeSearch;
						$validData = true;//indicates that the actual time is found in the times array
					}//Checks for the Actual time in the times array for getting the Index value of the actual time
					else if($actualtime > $times['time']){
						$startingtimes[] = $times['time'];
						$validData = false;//indicates that the actual time is not found in the times array
					}//if the actual time is not available in the times array then form the starting times array
					else{
						$endingtimes[] = $times['time'];
						$validData = false;//indicates that the actual time is not found in the times array
					}//if the actual time is not available in the times array then form the ending times array
				}

				if($validData){
					foreach($restTimePax as $times){
						$timeresult[$index] = array('time' => $times['time'],'status'=>$times['status'],'pax'=>$times['pax'],'nooftables' => $times['nooftables'],'inventory_id'=>$times['Inventory_Id']);
						$index++;
					}
				}//if the actual time is found in the times array
				$timekeys = null;
				$actualtimeIndex = null;
				$timeresultarray = null;
				if(!$validData){
					if($startingtimes){
						$timekeys = array_keys($startingtimes);//generates all the keys of the array
					}//if starting times array exists when actual time is not found in the times array
					if($endingtimes){
						$timekeys = array_keys($endingtimes);//generates all the keys of the array
					}
					if($timekeys){
						$actualtimeIndex = end($timekeys);
					}//if timekeys exists
					if($actualtimeIndex == 0 || $actualtimeIndex == 1){
						$i = 0;
					}else{
						$i = 0;
					}
					for($i;$i<=$actualtimeIndex;$i++){
						if($startingtimes){
							$timeresultarray[] =$startingtimes[$i];
						}else if($endingtimes){
							$timeresultarray[] =$endingtimes[$i];
						}
					}
				}//if the actual time is not found in the times array
				$searcharray = null;
				if(!$validData){
					foreach($restTimePax as $values){
						if(in_array($values['time'],$timeresultarray)){
							$searchPax = (int)$timings->getpartysize();
							$searcharray = array('time'=>$values['time'],'pax'=>$searchPax);
							if(in_array($searcharray,$values)){
								$timeresult[] = array('time' => $values['time'],'status'=>$values['status'],'pax'=>$values['pax'],'nooftables' => $values['nooftables'],'inventory_id'=>$values['Inventory_Id']);
							}
						}
						if(in_array($values['time'],$timeresultarray)){
							$timeresult[] = array('time' => $values['time'],'status'=>$values['status'],'pax'=>$values['pax'],'nooftables' => $values['nooftables'],'inventory_id'=>$values['Inventory_Id']);
						}
					}
				}//if the actual time is not found in the times array
				$timeres = null;
				$finaltimekey = null;
				$timeres = $timeresult;
				$finalArray = array();
				$finalTimeValue = null;
				$timeIndex = 0;
				/* Get Rest Timezone */
				date_default_timezone_set($timezone);
				$todayDate = date('d-m-Y');				
				if(strtotime($todayDate) == strtotime($date)){
					/* Remove all the past times */
					$timesArray = array();
					$timesArray = $timeres;
				
					$currentTime = date('H:i');				
					$dateTime = $date." ".$currentTime;				
					$convCurrTime = strtotime($dateTime);
				
					if(count($timesArray) > 0){
						foreach($timesArray as $times){
							$restTime = $date." ".$times['time'];
							$convRestTime = strtotime($restTime);
							if($convRestTime > $convCurrTime){
								$finalArray[] = $times;
							}
						}	
					}	
				}else{
					$finalArray = $timeres;	
				}
				if($finalArray){
					foreach($finalArray as $value){
						$timeValue = explode(':',$value['time']);
						if($timeValue[0] >=12){
							if((int)$timeValue[0] != 12){
								(int)$timeValue[0] -= 12;
							}
							$timeValue[2] = 'PM';
							if($timeValue[0] >= 10 || $timeValue[0] == 12){
								$finalTimeValue = $timeValue[0].':'.$timeValue[1].' '.$timeValue[2];
							}else{
								$finalTimeValue = '0'.$timeValue[0].':'.$timeValue[1].' '.$timeValue[2];
							}
						}else{
							$timeValue[2] = 'AM';
							if((int)$timeValue[0] == 0){
								$timeValue[0] = 12;
							}
							$finalTimeValue = $timeValue[0].':'.$timeValue[1].' '.$timeValue[2];
						}
						$value['time'] = $finalTimeValue;
						$finalArray[$timeIndex] = $value;
						$timeIndex++;
					}
				}				
				foreach($finalArray as $times){
						$finalizedArray[] = $times;	
				}	
			}
			return $finalizedArray;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/* retrive times for max count seetings */
	public function GetRestTimingsForMaxCount(Reservation_Model_GetRestaurantTimings $timings)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);
			
			$endTime = $timings->getTime();
			$time = explode(" ",$endTime);
			$timeHM = explode(":",$time[0]);
			if($time[1] ==  "PM"){
				if((int)$timeHM[0] != 12){
					(int)$timeHM[0] += 12;
				}
			}//if the time is PM then adding 12 to the hour
			if($time[1] ==  "AM" && (int)$timeHM[0] == 12){
				(int)$timeHM[0] = 0;
			}
			
			/* set timezone as a restaurant timezone */
			$timezone = "";
			$mapper = new FirmManagement_Model_FirmDataMapper();
			$timezone = $mapper->GetRestaurantTimeZone($timings->getRestId());
			date_default_timezone_set($timezone);
			
			$currentUserTime = date("h:i A");
			
			/* new code for checking the userdate and selected date(17-11-2012) */
			$currentUserDate = date('d-m-Y');
			$currentUserDateStr = strtotime($currentUserDate);
			$todayDateSplit = explode("-",$timings->getDate());
			$s = mktime(0,0,0,$todayDateSplit[0],$todayDateSplit[1],$todayDateSplit[2]);
			$seDate = date('Y-m-d',$s);
			$selUserDateStr = strtotime($seDate);
			/* old code for checking the userdate and selected date(17-11-2012) */
			/*
			$currentUserDate = date('m-d-Y');
			$currentUserDateStr = strtotime($currentUserDate);
			$selUserDateStr = strtotime($timings->getDate());
			*/
			
			$userTimeConflict = false;
			if($currentUserDateStr == $selUserDateStr && $timings->getResType() == 'web'){
				$mk = mktime(date("h"),date('i'),date('s'),date('m'),date('d'),date('Y'));
				$currentUserTimestr = strtotime($currentUserTime);
				$selUserTimestr = strtotime($timings->getTime());
				if($selUserTimestr > $currentUserTimestr){
					$differenceTimeStr = $selUserTimestr - $currentUserTimestr;
					$differenceTimeMin = floor((($differenceTimeStr)/60)/60);
					if($differenceTimeMin > 3){
						$userStartTime = $timings->getTime();
						$userTimeConflict = false;
					}else if($differenceTimeMin <= 3){
						$reservTimeMapper = new FirmManagement_Model_FirmReservationsTimeSettingDataMapper();
						$timeSettArr = $reservTimeMapper->getRestaurantResvTimeSetting($timings->getRestId()); 
						if(isset($timeSettArr['status'])){
							$userStartTime = date('h:i A',strtotime($currentUserTime)+($timeSettArr['time']*60));
							$userTimeConflict = true;
						}else{
							$userStartTime = date('h:i A',strtotime($currentUserTime));
							$userTimeConflict = true;
						}
					}else{
						return false;
					}
				}else{
					return false;
				}
			}
			
			$todayDateSplit = explode("-",$timings->getDate());
			$todayDateSplit[1] = $todayDateSplit[1];
			$todayDateArray = array($todayDateSplit[0],$todayDateSplit[1],$todayDateSplit[2]);
			$today = implode("-",$todayDateArray);

			$userTimeSec = mktime($timeHM[0],$timeHM[1],0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
			$userTime = date("h:i A",$userTimeSec);

			$todayTimeSec = mktime(21,0,0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
			$todayTime = date("h:i A",$todayTimeSec);

			$endTimeSec = mktime($timeHM[0]+3,(int)$timeHM[1],0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
			$endTime =  date("h:i A",$endTimeSec);

			$datesplit = explode("-",$timings->getDate());
			/* Date change to d-m-Y format */
			$dateExpArr = array($datesplit[1],$datesplit[0],$datesplit[2]);
			$date = implode("-",$dateExpArr);

			$datesplit[1] = $datesplit[1]+1;
			$datearray = array($datesplit[0],$datesplit[1],$datesplit[2]);
			$tomorrow = implode("-",$datearray);//next days date
			$tomorrowTimeSec = mktime(00,(int)00,0,$datesplit[1],$datesplit[0],$datesplit[2]);
			$tomorrowTime = date("h:i A",$tomorrowTimeSec);//12:00AM
			if($userTimeSec >= $todayTimeSec && $endTimeSec <= $tomorrowTimeSec){
				$endTimeSec = mktime(23,(int)59,0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
				$endTime =  date("h:i A",$endTimeSec);
			}
			$todayThreeTimeSec = mktime(3,0,0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
			$todayThreeTime = date("h:i A",$todayThreeTimeSec);

			$todayLastTimeSec = mktime(00,(int)00,0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
			$todayLastTime = date("h:i A",$todayLastTimeSec);

			if($userTimeConflict){
				$startTime =  $userStartTime;
			}else{
				$startTimeSec = mktime($timeHM[0]-3,(int)$timeHM[1],0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
				$startTime =  date("h:i A",$startTimeSec);
				if($userTimeSec <= $todayThreeTimeSec && $startTimeSec <= $todayLastTimeSec){
					$startTimeSec = mktime(0,(int)0,0,$todayDateSplit[1],$todayDateSplit[0],$todayDateSplit[2]);
					$startTime =  date("h:i A",$startTimeSec);
				}
			}

			$dateSplit = explode("-",$timings->getDate());
			$weekday = date("D", mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]));
			
			/* get  times and maxcount */
			$select->from(array('sch'=>'mt.restaurant_schedule'),array('rssid','rssstart_time','rssfk_restaurant','rss_max_count'))
				   ->where('sch.rssfk_restaurant = ?',$timings->getRestId())
				   ->where('sch.rssstart_time >= ?',$startTime)
				   ->where('sch.rssstart_time <= ?',$endTime)
				   ->where('sch.rssday_of_week = ?',strtolower($weekday))
				   ->where('sch.rssstatus = ?',true)
				   ->where('sch.rssscheduletype_id = ?',4)
				   ->join(array('res'=>'mt.restaurant'),'res.resid = sch.rssfk_restaurant',array('res.resid'))
				   ->where('res.resstatus = ?',1)
			 	   ->where('res.resapprovalstatus = ?',1)
			       ->order(array('sch.rssfk_restaurant','sch.rssstart_time'));
			
      //$sql = $select->__toString();
      //echo '<pre>'; print_r($sql); exit;

			$rowSet = $table->fetchAll($select);
			
			$restid = $timings->getRestId();
			$inventory_id = '';
			$table_pax = (int)$timings->getpartysize();
			$tablecount = '';
			$restTimePax = '';
      
			foreach($rowSet as $row){									
				$selSchId = $row->rssid;
        
				/* check freeze times */
				$frzDate = explode("-",$timings->getDate());
				$s = mktime(0,0,0,$frzDate[0],$frzDate[1],$frzDate[2]);
				
				$frzDate = date('Y-m-d',$s);
				$frzSql = "select frzid,frztype from mt.restaurant_freeze frz
				   			where frzfreezedate ='".$frzDate."' and frzfk_restaurant =".$restid." and frz_restsch_setting_id = 3";
				$frzIdSet = $db->fetchRow($frzSql);
				
				$frzid = $frzIdSet['frzid'];
				$frztype =$frzIdSet['frztype'];
        
				if($frzid){
					if(trim($frztype) == 'All'){
						break;
					}else{
						$frztimemapper = new Reservation_Model_RestaurantFreezeTimeMapDataMapper();
						$frztimeTable = $frztimemapper->getDbTable();
						$frztimeSelect = $frztimeTable->select();
						$frztimeSelect->from($frztimeTable,array('rftmfrz_time'))
									  ->where('rftm_frzid = ?',$frzid)
									  ->where('rftm_frzresid = ?',$restid);
									  
						$frztimeResult = $frztimeTable->fetchAll($frztimeSelect);
						$schids = array();
						foreach($frztimeResult as $frzt){
							$schids[] = $frzt->rftmfrz_time;
						}
						$arrSearch = array_search($selSchId, $schids);
						if($arrSearch === 0){
							$arrSearch = 1;
						}
						if($arrSearch){
							continue;	
						}						
						/* get booking count for search date and time */
						$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
						$bookStatus = array('RSD','OVB','ALC','DES','BOK','PTS','CRD','COM','WRD');
						$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
						$bokMapper = new Reservation_Model_ReservationDataMapper();
						$bokCount = $bokMapper->getBookingCountByDateAndTime($restid, date('Y-m-d',$s), $row->rssstart_time, $bookStatusRes);
						$maxCount = $row->rss_max_count;
						$availablecount = $maxCount-$bokCount;						
						if($availablecount >= $table_pax){
							$restTimePax[] = array('RestId'=>$restid,'time'=>$row->rssstart_time,'pax'=>$table_pax,'nooftables'=>$tablecount,'status'=>'RSD','Inventory_Id'=>$inventory_id);
						}
					}
				}else{
					/* get booking count for search date and time */
					$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
					$bookStatus = array('RSD','OVB','ALC','DES','BOK','PTS','CRD','COM','WRD');
					$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);					
					$bokMapper = new Reservation_Model_ReservationDataMapper();
					$bokCount = $bokMapper->getBookingCountByDateAndTime($restid, date('Y-m-d',$s), $row->rssstart_time, $bookStatusRes);
					$maxCount = $row->rss_max_count;
					$availablecount = $maxCount-$bokCount;
					if($availablecount >= $table_pax){
						$restTimePax[] = array('RestId'=>$restid,'time'=>$row->rssstart_time,'pax'=>$table_pax,'nooftables'=>$tablecount,'status'=>'RSD','Inventory_Id'=>$inventory_id);
					}	
				}
			}
      
			$finalizedArray = array();
			if($restTimePax){
				$sourceIndex = 0;
				$timeresult = null;
				$index = 0;
				$pax = null;
				$schtime = null;
				$timesarray = null;
				$startingtimes = null;
				$endingtimes = null;
				sort($restTimePax);
				foreach($restTimePax as $times){
					$timesarray[] = $times['time'];
				}//array of all the times
				sort($timesarray);
				$validData  = false;
				$timeSearch = false;
				foreach($restTimePax as $times){
						
					$timeHM = explode(":",$times['time']);
					$sk = mktime($timeHM[0],(int)$timeHM[1],0,0,0,0);
					$time = date("h:i A",$sk);

					$timesp = explode(" ",$timings->getTime());

					$timesplit = explode(":",$timesp[0]);
					//					$count = sizeof($timesplit[0]);
					if((int)$timesplit[0] < 10){
						$timesplit[0] = '0'.(int)$timesplit[0];
					}
					if($timesp[1] ==  "PM"){
						if((int)$timesplit[0] != 12){
							(int)$timesplit[0] += 12;
						}
					}
					if($timesp[1] ==  "AM" && (int)$timesplit[0] == 12){

						(int)$timesplit[0] = '00';

					}
					$actime = array($timesplit[0],$timesplit[1],'00');

					$actualtime = implode(":",$actime);
					$inarrayvalue = in_array($actualtime,$timesarray);
					if($inarrayvalue){
						$timeSearch = array_search($actualtime,$timesarray);
						$sourceIndex = $timeSearch;
						$validData = true;//indicates that the actual time is found in the times array
					}//Checks for the Actual time in the times array for getting the Index value of the actual time
					else if($actualtime > $times['time']){
						$startingtimes[] = $times['time'];
						$validData = false;//indicates that the actual time is not found in the times array
					}//if the actual time is not available in the times array then form the starting times array
					else{
						$endingtimes[] = $times['time'];
						$validData = false;//indicates that the actual time is not found in the times array
					}//if the actual time is not available in the times array then form the ending times array
				}
        
				if($validData){
					foreach($restTimePax as $times){
						$timeresult[$index] = array('time' => $times['time'],'status'=>$times['status'],'pax'=>$times['pax'],'nooftables' => $times['nooftables'],'inventory_id'=>$times['Inventory_Id']);
						$index++;
					}
				}//if the actual time is found in the times array
				$timekeys = null;
				$actualtimeIndex = null;
				$timeresultarray = null;
				if(!$validData){
					if($startingtimes){
						$timekeys = array_keys($startingtimes);//generates all the keys of the array
					}//if starting times array exists when actual time is not found in the times array
					if($timekeys){
						$actualtimeIndex = end($timekeys);
					}//if timekeys exists
					if($actualtimeIndex == 0 || $actualtimeIndex == 1){
						$i = 0;
					}else{
						$i = $actualtimeIndex-2;
					}
					for($i;$i<=$actualtimeIndex;$i++){
						$timeresultarray[] =$startingtimes[$i];
					}if($endingtimes){
						if(count($endingtimes) == 1){
							$timeresultarray[] = $endingtimes[0];
						}else {
							$timeresultarray[] = $endingtimes[0];
							$timeresultarray[] = $endingtimes[1];
						}

					}
				}//if the actual time is not found in the times array
				$searcharray = null;
				if(!$validData){
					foreach($restTimePax as $values){
						if(in_array($values['time'],$timeresultarray)){
							$searchPax = (int)$timings->getpartysize();
							$searcharray = array('time'=>$values['time'],'pax'=>$searchPax);
							if(in_array($searcharray,$values)){
								$timeresult[] = array('time' => $values['time'],'status'=>$values['status'],'pax'=>$values['pax'],'nooftables' => $values['nooftables'],'inventory_id'=>$values['Inventory_Id']);
							}
						}
						if(in_array($values['time'],$timeresultarray)){
							$timeresult[] = array('time' => $values['time'],'status'=>$values['status'],'pax'=>$values['pax'],'nooftables' => $values['nooftables'],'inventory_id'=>$values['Inventory_Id']);
						}
					}
				}//if the actual time is not found in the times array
        
				$timeres = null;
				$finaltimekey = null;
				if($validData){
					if(count($timeresult) > 4){
						$timekeys = array_keys($timeresult);
						$finaltimekey = end($timekeys);
						if($sourceIndex < 2 && $sourceIndex >= 0){
							$i = 0;
							for($i ;$i<=$sourceIndex+2;$i++){
								@$timeres[] = @$timeresult[$i];
							}
						}//if the sourceindex is in between 0 and 2
						else if($sourceIndex == $finaltimekey){
							for($i = $sourceIndex-2;$i<=$sourceIndex;$i++){
								@$timeres[] = @$timeresult[@$i];
							}
						}//if sourceindex is equal to the final value of the array
						else if($sourceIndex == $finaltimekey-1){
							for($i = $sourceIndex-2;$i<=$sourceIndex+1;$i++){
								@$timeres[] = @$timeresult[@$i];
							}
						}
						else if($sourceIndex == $finaltimekey-2){
							for($i = $sourceIndex-2;$i<=$sourceIndex+2;$i++){
								@$timeres[] = @$timeresult[@$i];
							}
						}
						else{
							for($i = $sourceIndex-2;$i<=$sourceIndex+2;$i++){
								@$timeres[] = @$timeresult[@$i];
							}
						}
					}else{
						$timeres = $timeresult;
					}
				}//if the count of timeresult is greater than 4
				else{
					$timeres = $timeresult;
				}
        
				$finalArray = array();
				$finalTimeValue = null;
				$timeIndex = 0;
				/* Get Rest Timezone */
				date_default_timezone_set($timezone);
				$todayDate = date('d-m-Y');				
				if(strtotime($todayDate) == strtotime($date)){
					/* Remove all the past times */
					$timesArray = array();
					$timesArray = $timeres;
				
					$currentTime = date('H:i');				
					$dateTime = $date." ".$currentTime;				
					$convCurrTime = strtotime($dateTime);
				
					if(count($timesArray) > 0){
						foreach($timesArray as $times){
							$restTime = $date." ".$times['time'];
							$convRestTime = strtotime($restTime);
							if($convRestTime > $convCurrTime){
								$finalArray[] = $times;
							}
						}	
					}	
				}else{
					$finalArray = $timeres;	
				}
        
				if($finalArray){
					/* forming final time array like AM OR PM  */
					foreach($finalArray as $value){
						$timeValue = explode(':',$value['time']);
						if($timeValue[0] >=12){
							if((int)$timeValue[0] != 12){
								(int)$timeValue[0] -= 12;
							}
							$timeValue[2] = 'PM';
							if($timeValue[0] >= 10 || $timeValue[0] == 12){
								$finalTimeValue = $timeValue[0].':'.$timeValue[1].' '.$timeValue[2];
							}else{
								$finalTimeValue = '0'.$timeValue[0].':'.$timeValue[1].' '.$timeValue[2];
							}
						}else{
							$timeValue[2] = 'AM';
							if((int)$timeValue[0] == 0){
								$timeValue[0] = 12;
							}
							$finalTimeValue = $timeValue[0].':'.$timeValue[1].' '.$timeValue[2];
						}
						$value['time'] = $finalTimeValue;
						$finalArray[$timeIndex] = $value;
						$timeIndex++;
					}
				}
        
				foreach($finalArray as $times){
						$finalizedArray[] = $times;	
				}	
			}
      
			return $finalizedArray;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetRestTimingsForMaxCountByMealType(Reservation_Model_GetRestaurantTimings $timings)
	{
		try{
			$db = Zend_Db_Table::getDefaultAdapter();
			$table = $this->getDbTable();
			$select = $table->select();
			$select->setIntegrityCheck(false);

			$timezone = "";
			$mapper = new FirmManagement_Model_FirmDataMapper();
			$timezone = $mapper->GetRestaurantTimeZone($timings->getRestId());
			date_default_timezone_set($timezone);
			
			$currentUserTime = date("h:i A");
			
			/* new code for checking the userdate and selected date(17-11-2012) */
			$currentUserDate = date('Y-m-d');
			$currentUserDateStr = strtotime($currentUserDate);
			$todayDateSplit = explode("-",$timings->getDate());
			$s = mktime(0,0,0,$todayDateSplit[0],$todayDateSplit[1],$todayDateSplit[2]);
			$seDate = date('Y-m-d',$s);
			$selUserDateStr = strtotime($seDate);
			$datesplit = explode("-",$timings->getDate());
			/* Date change to d-m-Y format */
			$dateExpArr = array($datesplit[1],$datesplit[0],$datesplit[2]);
			$date = implode("-",$dateExpArr);
			/* old code for checking the userdate and selected date(17-11-2012) */
			/*
			$currentUserDate = date('m-d-Y');
			$currentUserDateStr = strtotime($currentUserDate);
			$selUserDateStr = strtotime($timings->getDate());
			*/
			$mealMapper = new FirmManagement_Model_FirmMealTypeDataMapper();
			$meal = new FirmManagement_Model_FirmMealType();
			if($timings->getMealType() != ""){
			$meal->setMealType($timings->getMealType())
				 ->setResId($timings->getRestId());
				$selMealType = $mealMapper->GetRestaurantAllMealType($meal);
			}else{
				$meal->setMealType("")
				 ->setResId($timings->getRestId());
				$selMealType = $mealMapper->GetRestaurantAllMealType($meal);
			}
			if($selMealType){			
				$startTime = array();
				$endTime = array();	
				$userTimeConflict = false;
				foreach($selMealType as $selMeal){
					$userTimeConflict = false;
					if($currentUserDate == $timings->getDate() && $timings->getResType() == 'web'){
						$mk = mktime(date("h"),date('i'),date('s'),date('m'),date('d'),date('Y'));
						$currentUserTimestr = strtotime($currentUserTime);
						$selUserTimestr = strtotime($selMeal->rmt_start_time);
						if($timings->getRestId() != 6){
							if($selUserTimestr > $currentUserTimestr){
								$differenceTimeStr = $selUserTimestr - $currentUserTimestr;
								$differenceTimeMin = floor((($differenceTimeStr)/60)/60);
								if($differenceTimeMin > 3){
									$userStartTime = $selMeal->rmt_start_time;
									$userTimeConflict = false;
								}else if($differenceTimeMin <= 3){
									$reservTimeMapper = new FirmManagement_Model_FirmReservationsTimeSettingDataMapper();
									$timeSettArr = $reservTimeMapper->getRestaurantResvTimeSetting($timings->getRestId()); 
									if($timeSettArr['status']){
										$userStartTime = date('h:i A',strtotime($currentUserTime)+($timeSettArr['time']*60));
										$userTimeConflict = true;
									}else{
										$userStartTime = date('h:i A',strtotime($currentUserTime));
									}
								}else{
									$userStartTime = date('h:i A',strtotime($currentUserTime));
									$userTimeConflict = true;
								}
							}else{
								$reservTimeMapper = new FirmManagement_Model_FirmReservationsTimeSettingDataMapper();
								$timeSettArr = $reservTimeMapper->getRestaurantResvTimeSetting($timings->getRestId()); 
								if($timeSettArr['status']){
									$userStartTime = date('h:i A',strtotime($currentUserTime)+($timeSettArr['time']*60));
									$userTimeConflict = true;
								}else{
									$userStartTime = date('h:i A',strtotime($currentUserTime));
								}
							}
						}else{
							$selUserEndTimestr = strtotime($selMeal->rmt_end_time);
							if($selUserTimestr < $currentUserTimestr && $currentUserTimestr < $selUserEndTimestr){
								return false;
							}else if($selUserTimestr > $currentUserTimestr){
								$differenceTimeStr = $selUserTimestr - $currentUserTimestr;
								$differenceTimeMin = floor((($differenceTimeStr)/60)/60);
								if($differenceTimeMin > 3){
									$userStartTime = $selMeal->rmt_start_time;
									$userTimeConflict = false;
								}else if($differenceTimeMin <= 3){
									$reservTimeMapper = new FirmManagement_Model_FirmReservationsTimeSettingDataMapper();
									$timeSettArr = $reservTimeMapper->getRestaurantResvTimeSetting($timings->getRestId()); 
									if(isset($timeSettArr['status'])){
										$userStartTime = date('H:i:s',strtotime($currentUserTime)+($timeSettArr['time']*60));
										$userTimeConflict = true;
									}else{
										$userStartTime = date('H:i:s',strtotime($currentUserTime));
										$userTimeConflict = true;
									}
								}else{
									$userStartTime = date('H:i:s',strtotime($currentUserTime));
									$userTimeConflict = true;
								}
							}else{
								return false;
							}
						}
					}
					
					if($userTimeConflict){
						$startTime[] =  $userStartTime;
					}else{
						$startTime[] = $selMeal->rmt_start_time;
					}			
					$endTime[] = $selMeal->rmt_end_time;	
				}
			}		
			
			if(count($startTime) == 0){
				return false;
			}

			$dateSplit = explode("-",$timings->getDate());
			$weekday = date("D", mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]));
			
			$datesplit = explode("-",$timings->getDate());
			/* Date change to d-m-Y format */
			$dateExpArr = array($datesplit[1],$datesplit[0],$datesplit[2]);
			$date = implode("-",$dateExpArr);
			/* get  times and maxcount */
			
			$val = '';
			for($i = 0;$i < count($startTime); $i++){
				if($i == 0){
					$val.= "(sch.rssstart_time >= '$startTime[$i]' and  sch.rssstart_time <= '$endTime[$i]')";
				}else{
					$val.=  " or (sch.rssstart_time >= '$startTime[$i]' and  sch.rssstart_time <= '$endTime[$i]')";
				}
			}
			
			$select->from(array('sch'=>'mt.restaurant_schedule'),array('rssid','rssstart_time','rssfk_restaurant','rss_max_count'))
				   ->where('sch.rssfk_restaurant = ?',$timings->getRestId())
				   ->where("($val)")
//				   ->where('sch.rssstart_time >= ?',$startTime)
//				   ->where('sch.rssstart_time <= ?',$endTime)
				   ->where('sch.rssday_of_week = ?',strtolower($weekday))
				   ->where('sch.rssstatus = ?',true)
				   ->where('sch.rssscheduletype_id = ?',4)
				   ->join(array('res'=>'mt.restaurant'),'res.resid = sch.rssfk_restaurant',array('res.resid'))
				   ->where('res.resstatus = ?',1)
			 	   ->where('res.resapprovalstatus = ?',1)
			       ->order(array('sch.rssfk_restaurant','sch.rssstart_time'));
			
			$rowSet = $table->fetchAll($select);
			
			$restid = $timings->getRestId();
			$inventory_id = '';
			$table_pax = (int)$timings->getpartysize();
			$tablecount = '';
			$restTimePax = '';
			foreach($rowSet as $row){									
				$selSchId = $row->rssid;

				/* check freeze times */
				$frzDate = explode("-",$timings->getDate());
				$s = mktime(0,0,0,$frzDate[0],$frzDate[1],$frzDate[2]);
				
				$frzDate = date('Y-m-d',$s);
				$frzSql = "select frzid,frztype from mt.restaurant_freeze frz
				   			where frzfreezedate ='".$frzDate."' and frzfk_restaurant =".$restid." and frz_restsch_setting_id = 3";
				$frzIdSet = $db->fetchRow($frzSql);
				
				$frzid = $frzIdSet['frzid'];
				$frztype =$frzIdSet['frztype'];
				if($frzid){
					if(trim($frztype) == 'All'){
						break;
					}else{
						$frztimemapper = new Reservation_Model_RestaurantFreezeTimeMapDataMapper();
						$frztimeTable = $frztimemapper->getDbTable();
						$frztimeSelect = $frztimeTable->select();
						$frztimeSelect->from($frztimeTable,array('rftmfrz_time'))
									  ->where('rftm_frzid = ?',$frzid)
									  ->where('rftm_frzresid = ?',$restid);
									  
						$frztimeResult = $frztimeTable->fetchAll($frztimeSelect);
						$schids = array();
						foreach($frztimeResult as $frzt){
							$schids[] = $frzt->rftmfrz_time;
						}
						$arrSearch = array_search($selSchId, $schids);
						if($arrSearch === 0){
							$arrSearch = 1;
						}
						if($arrSearch){
							continue;	
						}						
						/* get booking count for search date and time */
						$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
						$bookStatus = array('RSD','OVB','ALC','DES','BOK','PTS','CRD','COM','WRD');
						$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
						$bokMapper = new Reservation_Model_ReservationDataMapper();
						$bokCount = $bokMapper->getBookingCountByDateAndTime($restid, date('Y-m-d',$s), $row->rssstart_time, $bookStatusRes);
						$maxCount = $row->rss_max_count;
						$availablecount = $maxCount-$bokCount;						
						if($availablecount >= $table_pax){
							$restTimePax[] = array('RestId'=>$restid,'time'=>$row->rssstart_time,'pax'=>$table_pax,'nooftables'=>$tablecount,'status'=>'RSD','Inventory_Id'=>$inventory_id);
						}
					}
				}else{
					/* get booking count for search date and time */
					$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
					$bookStatus = array('RSD','OVB','ALC','DES','BOK','PTS','CRD','COM','WRD');
					$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);					
					$bokMapper = new Reservation_Model_ReservationDataMapper();
					$bokCount = $bokMapper->getBookingCountByDateAndTime($restid, date('Y-m-d',$s), $row->rssstart_time, $bookStatusRes);
					$maxCount = $row->rss_max_count;
					$availablecount = $maxCount-$bokCount;
					if($availablecount >= $table_pax){
						$restTimePax[] = array('RestId'=>$restid,'time'=>$row->rssstart_time,'pax'=>$table_pax,'nooftables'=>$tablecount,'status'=>'RSD','Inventory_Id'=>$inventory_id);
					}	
				}
			}
			$finalizedArray = array();
			if($restTimePax){
				$sourceIndex = 0;
				$timeresult = null;
				$index = 0;
				$pax = null;
				$schtime = null;
				$timesarray = null;
				$startingtimes = null;
				$endingtimes = null;
				sort($restTimePax);
				foreach($restTimePax as $times){
					$timesarray[] = $times['time'];
				}//array of all the times
				sort($timesarray);
				$validData  = false;
				$timeSearch = false;
				foreach($restTimePax as $times){
						
					$timeHM = explode(":",$times['time']);
					$sk = mktime($timeHM[0],(int)$timeHM[1],0,0,0,0);
					$time = date("h:i A",$sk);

					$timesp = explode(" ",date("h:i A",strtotime($selMeal->rmt_start_time)));

					$timesplit = explode(":",$timesp[0]);
					//					$count = sizeof($timesplit[0]);
					if((int)$timesplit[0] < 10){
						$timesplit[0] = '0'.(int)$timesplit[0];
					}
					if($timesp[1] ==  "PM"){
						if((int)$timesplit[0] != 12){
							(int)$timesplit[0] += 12;
						}
					}
					if($timesp[1] ==  "AM" && (int)$timesplit[0] == 12){

						(int)$timesplit[0] = '00';

					}
					$actime = array($timesplit[0],$timesplit[1],'00');

					$actualtime = implode(":",$actime);
					$inarrayvalue = in_array($actualtime,$timesarray);
					if($inarrayvalue){
						$timeSearch = array_search($actualtime,$timesarray);
						$sourceIndex = $timeSearch;
						$validData = true;//indicates that the actual time is found in the times array
					}//Checks for the Actual time in the times array for getting the Index value of the actual time
					else if($actualtime > $times['time']){
						$startingtimes[] = $times['time'];
						$validData = false;//indicates that the actual time is not found in the times array
					}//if the actual time is not available in the times array then form the starting times array
					else{
						$endingtimes[] = $times['time'];
						$validData = false;//indicates that the actual time is not found in the times array
					}//if the actual time is not available in the times array then form the ending times array
				}

				if($validData){
					foreach($restTimePax as $times){
						$timeresult[$index] = array('time' => $times['time'],'status'=>$times['status'],'pax'=>$times['pax'],'nooftables' => $times['nooftables'],'inventory_id'=>$times['Inventory_Id']);
						$index++;
					}
				}//if the actual time is found in the times array
				$timekeys = null;
				$actualtimeIndex = null;
				$timeresultarray = null;
				if(!$validData){
					if($startingtimes){
						$timekeys = array_keys($startingtimes);//generates all the keys of the array
					}//if starting times array exists when actual time is not found in the times array
					if($endingtimes){
						$timekeys = array_keys($endingtimes);//generates all the keys of the array
					}
					if($timekeys){
						$actualtimeIndex = end($timekeys);
					}//if timekeys exists
					if($actualtimeIndex == 0 || $actualtimeIndex == 1){
						$i = 0;
					}else{
						$i = 0;
					}
					for($i;$i<=$actualtimeIndex;$i++){
						if($startingtimes){
							$timeresultarray[] =$startingtimes[$i];
						}else if($endingtimes){
							$timeresultarray[] =$endingtimes[$i];
						}
					}
				}//if the actual time is not found in the times array
				$searcharray = null;
				if(!$validData){
					foreach($restTimePax as $values){
						if(in_array($values['time'],$timeresultarray)){
							$searchPax = (int)$timings->getpartysize();
							$searcharray = array('time'=>$values['time'],'pax'=>$searchPax);
							if(in_array($searcharray,$values)){
								$timeresult[] = array('time' => $values['time'],'status'=>$values['status'],'pax'=>$values['pax'],'nooftables' => $values['nooftables'],'inventory_id'=>$values['Inventory_Id']);
							}
						}
						if(in_array($values['time'],$timeresultarray)){
							$timeresult[] = array('time' => $values['time'],'status'=>$values['status'],'pax'=>$values['pax'],'nooftables' => $values['nooftables'],'inventory_id'=>$values['Inventory_Id']);
						}
					}
				}//if the actual time is not found in the times array
				$timeres = null;
				$finaltimekey = null;
				$timeres = $timeresult;
				$finalArray = array();
				$finalTimeValue = null;
				$timeIndex = 0;
				/* Get Rest Timezone */
				date_default_timezone_set($timezone);
				$todayDate = date('Y-m-d');				
				if(strtotime($todayDate) == strtotime($date)){
					/* Remove all the past times */
					$timesArray = array();
					$timesArray = $timeres;
				
					$currentTime = date('H:i');				
					$dateTime = $date." ".$currentTime;				
					$convCurrTime = strtotime($dateTime);
				
					if(count($timesArray) > 0){
						foreach($timesArray as $times){
							$restTime = $date." ".$times['time'];
							$convRestTime = strtotime($restTime);
							if($convRestTime > $convCurrTime){
								$finalArray[] = $times;
							}
						}	
					}	
				}else{
					$finalArray = $timeres;	
				}
				if($finalArray){
					/* forming final time array like AM OR PM  */
					foreach($finalArray as $value){
						$timeValue = explode(':',$value['time']);
						if($timeValue[0] >=12){
							if((int)$timeValue[0] != 12){
								(int)$timeValue[0] -= 12;
							}
							$timeValue[2] = 'PM';
							if($timeValue[0] >= 10 || $timeValue[0] == 12){
								$finalTimeValue = $timeValue[0].':'.$timeValue[1].' '.$timeValue[2];
							}else{
								$finalTimeValue = '0'.$timeValue[0].':'.$timeValue[1].' '.$timeValue[2];
							}
						}else{
							$timeValue[2] = 'AM';
							if((int)$timeValue[0] == 0){
								$timeValue[0] = 12;
							}
							$finalTimeValue = $timeValue[0].':'.$timeValue[1].' '.$timeValue[2];
						}
						$value['time'] = $finalTimeValue;
						$finalArray[$timeIndex] = $value;
						$timeIndex++;
					}
				}				
				foreach($finalArray as $times){
						$finalizedArray[] = $times;	
				}	
			}
			return $finalizedArray;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getRestSplTimings(Reservation_Model_GetRestaurantTimings $searchList,$page)
	{
		try{
			$RestSearchReults = array();
			/* set timezone as a restaurnt timezone */
			$timezone = "";
			$mapper = new FirmManagement_Model_FirmDataMapper();
			$timezone = $mapper->GetRestaurantTimeZone($searchList->getRestId());
			date_default_timezone_set($timezone);
			
			/* get restaurant schedule setting  */
			$resDataMapper = new FirmManagement_Model_FirmDataMapper();
			$seetingArr = $resDataMapper->getScheduleSettingTypeByresId($searchList->getRestId());
			$settingType = $seetingArr['settingType'];			
			if($settingType == 'SL'){
				$RestSearchReults = $this->GetRestTimings($searchList);
			}else if($settingType == 'UL'){
				$RestSearchReults = $this->GetRestTimingsForUnlimited($searchList);
			}else if($settingType == 'SMC'){
				$RestSearchReults = $this->GetRestTimingsForMaxCount($searchList);
			}else if($settingType == 'SAC'){
				$RestSearchReults = $this->GetRestTimingsForAccumulative($searchList);
			}
			
			$dateSplit = explode("-",$searchList->getDate());
			$weekday = date("D", mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]));
			
			$restMapper = new Deals_Model_RestaurantSpecialDataMapper();
			$restTable = $restMapper->getDbTable();
			$restSelect = $restTable->select();
			$restSelect->setIntegrityCheck(false);
			$restSelect->from(array('respl'=>'mt.restaurant_special'),array('rspid',
																			'rspfk_restaurant',
																			'rspspecial_type',
																			'rspno_of_dishes', 
																			'rspspecial_title',
																			'rspspecial_image',
																			'rspfood_type',
																			'rspregular_price',
																			'rspdiscount_percentage_point',																
																			'rspprice_with_discount',
																			'rspkids_eat_free',
																			'rspstart_date',
																			'rspend_date',
																			'rspstart_time',
																			'rspend_time',
																			'rspdescription',
																			'rsprecurencestatus',
																			'rspkidsstatus',
																			'rspstatus',
																			'rspcategory',
																			'rsptype_of_occurance',
																			'rspdiscount_mode'));
			
			$restSelect->join(array('res'=>'mt.restaurant'),'res.resid = respl.rspfk_restaurant',array('resid','resrestaurant_name','resaddress','resphone','reslogo','resimage','resdescription','resfacebook_id'));
			$restSelect->join(array('spb'=>'mt.special_type_bd'),'spb.id = respl.rspspecial_type',array('description as special'));
			$restSelect->join(array('cty'=>'mt.city_bd'),'cty.id = res.rescity_id',array('code as citycode','description as citydesc'));
			$restSelect->join(array('st'=>'mt.state_bd'),'st.id = res.resstate_id',array('code as countrycode','description as countrydesc','currency_code'));
			$restSelect->join(array('neigh'=>'mt.neighborhood_bd'),'neigh.id = res.resneighborhood_id',array('description as neighdesc'));
			$restSelect->join(array('cat'=>'mt.special_category_bd'),'cat.id = respl.rspcategory',array('code as catcode','description as splCategory'));
			$restSelect->joinLeft(array('splcnt'=>'mt.special_count_type_bd'),'splcnt.id = respl.rsptype_of_occurance',array('description as splCount'));
			$restSelect->joinLeft(array('splpt'=>'mt.special_price_type_bd'),'splpt.id = respl.rsppricetype',array('description as splprice'));
			$restSelect->joinLeft(array('discmod'=>'mt.discount_mode_bd'),'discmod.id = respl.rspdiscount_mode',array('code as discModeCode' ,'description as discMode'));
			$restSelect->joinLeft(array('disctyp'=>'mt.discount_type_bd'),'disctyp.id = respl.rsptype_of_occurance',array('code as discTypeCode' ,'description as discTypeDisc'));
			$restSelect->where('res.resid = ?',$searchList->getRestId());
			if($searchList->getSplId()){
				$restSelect->where('respl.rspid = ?',$searchList->getSplId());
			}
			$restSelect->where('respl.rspstatus = ?',true);
			$restSelect->where('respl.rspdeletestatus = ?',true);
			$restSelect->where('res.resapprovalstatus = ?',1);
			$restSelect->where('res.resstatus = ?',1);
			if($searchList->getDate() && $searchList->getschtype() == 'viewall'){
//				$restSelect->where('respl.rspstart_date <= ?',$searchList->getDate());
				$restSelect->where('respl.rspend_date >= ?',$searchList->getDate());
							
//				$restSelect->joinLeft(array('recurr'=>'mt.restaurant_special_reccurence'),'recurr.rsrfk_restaurant_special = respl.rspid',array());
//				$restSelect->where('recurr.rsrday_of_week = ?',$searchList->getWeekDayId());
			}else if($searchList->getDate() && $searchList->getTime()){
				
				$restSelect->where('respl.rspstart_date <= ?',$searchList->getDate());
				$restSelect->where('respl.rspend_date >= ?',$searchList->getDate());
				$restSelect->where('respl.rspstart_time <= ?',$searchList->getTime());
				$restSelect->where('respl.rspend_time >= ?',$searchList->getTime());				
				
//				$restSelect->joinLeft(array('recurr'=>'mt.restaurant_special_reccurence'),'recurr.rsrfk_restaurant_special = respl.rspid',array(''));
//				$restSelect->where('recurr.rsrday_of_week = ?',$searchList->getWeekDayId());
				
			}else if($searchList->getDate()){
				$restSelect->where('respl.rspstart_date <= ?',$searchList->getDate());
				$restSelect->where('respl.rspend_date <= ?',$searchList->getDate());
				
//				$restSelect->joinLeft(array('recurr'=>'mt.restaurant_special_reccurence'),'recurr.rsrfk_restaurant_special = respl.rspid',array());
//				$restSelect->where('recurr.rsrday_of_week = ?',$searchList->getWeekDayId());
			}

			$restSelect->order(array('respl.rspspecial_title'));
//			$restSelect->limit('4');
			$rowSet = $restTable->fetchAll($restSelect);
			$resDet = array();
			$resIdArr = array();
			
			foreach($rowSet as $row){
				if($row->rsprecurencestatus){
					$reoccMapper = new Deals_Model_RestaurantSpecialRecurenceDataMapper();
					$reTable = $reoccMapper->getDbTable();
					$reoccSelect = $reTable->select();
					$reoccSelect->setIntegrityCheck(false);
					$reoccSelect->from(array('rsr'=>'mt.restaurant_special_reccurence'),array('rsrid','rsrday_of_week'))
								->join(array('wrb'=>'mt.weekly_recurence_bd'),'wrb.id = rsr.rsrday_of_week',array('description as day','code as dayCode'))
								->where('rsr.rsrfk_restaurant_special = ? ',$row->rspid);
					$rowResult = $reTable->fetchAll($reoccSelect);
					
				}else{
					$rowResult = "";
				}
				$descSplit = explode(' ',$row->rspdescription);
				if(count($descSplit) > 40){
					$description = implode(' ',array_slice($descSplit,0, 40));
				}else{
					$description = $row->rspdescription;
				}
				
				if(strlen($row->resdescription) > 200){
					$resdescription = substr($row->resdescription, 0, 200)." ...";
				}else{
					$resdescription = $row->resdescription;
				}
				$splObj = new Deals_Model_RestaurantSpecial();
				$splObj->setRestaurantname($row->resrestaurant_name)
					   ->setRestaurantdesc($resdescription)
					   ->setId($row->rspid)
					   ->setRestaurantid($row->resid)
				       ->setAddress($row->resaddress)
					   ->setRestaurantid($row->rspfk_restaurant)
					   ->setNoofdishes($row->rspno_of_dishes)
					   ->setSpecialtypename($row->special)
				       ->setSpecialtypeid($row->rspspecial_type)
					   ->setSpecialtitle($row->rspspecial_title)
					   ->setSpecialimage(explode(',', $row->rspspecial_image))
					   ->setSpecialLogo($row->reslogo)
					   ->setStartdate($row->rspstart_date)
					   ->setEnddate($row->rspend_date)
					   ->setStarttime($row->rspstart_time)
					   ->setEndtime($row->rspend_time)
					   ->setDescription($description)
					   ->setSpecialrecurence($row->rsprecurencestatus)
					   ->setKidsinfo($row->rspkids_eat_free)
					   ->setKidsstatus($row->rspkidsstatus)
					   ->setSpecialCount($row->rsptype_of_occurance)
					   ->setSpecialCategoryType($row->rspcategory)
					   ->setSpecialCategoryTypeName($row->splCategory)
					   ->setCatTypeCode($row->catcode)
					   ->setSpecialCountName($row->splCount)
					   ->setDiscountMode($row->discMode)
					   ->setDistypename($row->discTypeDisc)
					   ->setSpecialpricetype($row->splprice)
					   ->setRegprice(str_replace('$','',$row->rspregular_price))
					   ->setDispercentage($row->rspdiscount_percentage_point)
					   ->setPricewithdiscount(str_replace('$','',$row->rspprice_with_discount))
					   ->setStatus($row->rspstatus)
					   ->setCity($row->citydesc)
					   ->setNeighbour($row->neighdesc)
					   ->setPhone($row->resphone)
					   ->setResfacebook_id($row->resfacebook_id)
					   ->setRescurrency($row->currency_code)
					   ->setCountry($row->countrydesc)
					   ->setRestaurantgoogleimage($row->resimage);
				$splWeek = array();
				if($rowResult){
					$weekStat = false;
					foreach($rowResult as $value){
						if(strtolower($weekday) == strtolower($value->dayCode)){
							$weekStat = true;
						}
						$splRecurenceObj = new Deals_Model_RestaurantSpecialRecurence();
						$splRecurenceObj->setWeekId($value->rsrday_of_week);
						$splRecurenceObj->setWeekDesc($value->day);
						$splWeek[] = $splRecurenceObj;
					}
//					if(!$weekStat){
//						continue;
//					}
				}
				$splObj->setWeekids($splWeek);
				$resDet[$row->rspid] = $splObj;
			}
			$ResvTimesArr = array();
			$finalResult = array();
			$rowSplIdSet = 1;
			$check = false;
			
			if($searchList->getSplId())
				{
					$restaurantMapper = new Deals_Model_RestaurantSpecialDataMapper();
					$restaurantTable = $restaurantMapper->getDbTable();
					$restaurantSelect = $restaurantTable->select();
					$restaurantSelect->setIntegrityCheck(false);
					$restaurantSelect->from(array('respl'=>'mt.restaurant_special'),array('rspid',
																					'rspstart_date',
																					'rspend_date',
																					'rspstart_time',
																					'rspend_time'));
					
					$restaurantSelect->where('respl.rspfk_restaurant = ?',$searchList->getRestId());
					if($searchList->getSplId()){
						$restaurantSelect->where('respl.rspid = ?',$searchList->getSplId());
					}
					$restaurantSelect->where('respl.rspstatus = ?',true);
					$restaurantSelect->where('respl.rspdeletestatus = ?',true);
					$restaurantSelect->where('respl.rspstart_date <= ?',$searchList->getDate());
					$restaurantSelect->where('respl.rspend_date >= ?',$searchList->getDate());
					$restaurantSelect->where('respl.rspstart_time <= ?',$searchList->getTime());
					$restaurantSelect->where('respl.rspend_time >= ?',$searchList->getTime());
//					$restaurantSelect->order(array('respl.rspspecial_title'));
					$rowSplIdSet = $restaurantTable->fetchRow($restaurantSelect);
				}
			
			
			if(count($resDet) > 0 && count($RestSearchReults) > 0){
				/* Seprate time from Reservation Search results */
				
				
				/* Compare search times falls under special defined time */
				
				foreach($resDet as $key => $value){
					$splObject = "";
					$splObject = $value;
					if($splObject->getCatTypeCode() == 'CP' || $splObject->getCatTypeCode() == 'SP'){
						if($rowSplIdSet){
	//						if($searchList->getschtype() != 'viewall'){
								if($RestSearchReults){
									$times = $RestSearchReults;
									
									$starttime     = $splObject->getStarttime();							
									$convstarttime = strtotime($starttime); 
									$endtime       = $splObject->getEndtime();
									$convendtime   = strtotime($endtime);
									$timesArr = array();
									foreach($times as $time){
										$convTime = "";
										$convTime = strtotime($time['time']);
										if($convTime >= $convstarttime && $convTime <= $convendtime)
										{
											if($time['status'] != 'WAL'){
												$timesArr[] = array('time'     	   => $time['time'],
															    	'status'       => $time['status'],
																	'pax'		   => $time['pax'],
																	'nooftables' => $time['nooftables'],
																	'inventory_id' => $time['inventory_id']);	
											}
										}else{
											continue;
										}
									}
			
									if(count($timesArr) > 0 || $searchList->getschtype() == 'viewall'){
										$splObject->setTimesArray($timesArr);
										$finalResult[$splObject->getId()] = $splObject;
									}
								}else{
									$finalResult[$splObject->getId()] = $splObject;
								}
	//						}else{
	//							if(count($RestSearchReults) > 0){
	//								$times = $RestSearchReults;
	//								$splObject->setTimesArray($times);
	//							}
	//							$finalResult[$splObject->getId()] = $splObject;
	//						}
						}else{
							$splObject->setTimesArray(null);
							$finalResult[$splObject->getId()] = $splObject;
							$check = true;
						}
					}else if($splObject->getCatTypeCode() == 'INF'){
						$finalResult[$splObject->getId()] = $splObject;
					}else if($splObject->getCatTypeCode() == 'PE'){
						$finalResult[$splObject->getId()] = $splObject;
					}
				}
			}else{
				foreach($resDet as $key => $value){
					$splObject = "";
					$splObject = $value;
					if($splObject->getCatTypeCode() == 'CP' || $splObject->getCatTypeCode() == 'SP'){
						if($rowSplIdSet){
	//						if($searchList->getschtype() != 'viewall'){
								if($RestSearchReults){
									$times = $RestSearchReults;
									
									$starttime     = $splObject->getStarttime();							
									$convstarttime = strtotime($starttime); 
									$endtime       = $splObject->getEndtime();
									$convendtime   = strtotime($endtime);
									$timesArr = array();
									foreach($times as $time){
										$convTime = "";
										$convTime = strtotime($time['time']);
										if($convTime >= $convstarttime && $convTime <= $convendtime)
										{
											if($time['status'] != 'WAL'){
												$timesArr[] = array('time'     	   => $time['time'],
															    	'status'       => $time['status'],
																	'pax'		   => $time['pax'],
																	'nooftables' => $time['nooftables'],
																	'inventory_id' => $time['inventory_id']);	
											}
										}else{
											continue;
										}
									}
			
									if(count($timesArr) > 0 || $searchList->getschtype() == 'viewall'){
										$splObject->setTimesArray($timesArr);
										$finalResult[$splObject->getId()] = $splObject;
									}
								}else{
									$finalResult[$splObject->getId()] = $splObject;
								}
	//						}else{
	//							if(count($RestSearchReults) > 0){
	//								$times = $RestSearchReults;
	//								$splObject->setTimesArray($times);
	//							}
	//							$finalResult[$splObject->getId()] = $splObject;
	//						}
						}else{
							$splObject->setTimesArray(null);
							$finalResult[$splObject->getId()] = $splObject;
							$check = true;
						}
					}else if($splObject->getCatTypeCode() == 'INF'){
						$finalResult[$splObject->getId()] = $splObject;
					}else if($splObject->getCatTypeCode() == 'PE'){
						$finalResult[$splObject->getId()] = $splObject;
					}
				}
				
			}
			$result[0] = $finalResult;
			$result[1] = $check;
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getRestSplTimingsAjax(Reservation_Model_GetRestaurantTimings $searchList,$page)
	{
		try{
			$limit = 2;
			$RestSearchReults = array();
			/* set timezone as a restaurnt timezone */
			$timezone = "";
			$mapper = new FirmManagement_Model_FirmDataMapper();
			$timezone = $mapper->GetRestaurantTimeZone($searchList->getRestId());
			date_default_timezone_set($timezone);
			
			$dateSplit = explode("-",$searchList->getDate());
			$weekday = date("D", mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]));
			
			$restMapper = new Deals_Model_RestaurantSpecialDataMapper();
			$restTable = $restMapper->getDbTable();
			$restSelect = $restTable->select();
			$restSelect->setIntegrityCheck(false);
			$restSelect->from(array('respl'=>'mt.restaurant_special'),array('rspid',
																			'rspfk_restaurant',
																			'rspspecial_type',
																			'rspno_of_dishes', 
																			'rspspecial_title',
																			'rspspecial_image',
																			'rspfood_type',
																			'rspregular_price',
																			'rspdiscount_percentage_point',																
																			'rspprice_with_discount',
																			'rspkids_eat_free',
																			'rspstart_date',
																			'rspend_date',
																			'rspstart_time',
																			'rspend_time',
																			'rspdescription',
																			'rsprecurencestatus',
																			'rspkidsstatus',
																			'rspstatus',
																			'rspcategory',
																			'rsptype_of_occurance',
																			'rspdiscount_mode'));
			
			$restSelect->join(array('res'=>'mt.restaurant'),'res.resid = respl.rspfk_restaurant',array('resid','resrestaurant_name','resaddress','resphone','reslogo','resdescription','resfacebook_id'));
			$restSelect->join(array('spb'=>'mt.special_type_bd'),'spb.id = respl.rspspecial_type',array('description as special'));
			$restSelect->join(array('cty'=>'mt.city_bd'),'cty.id = res.rescity_id',array('code as citycode','description as citydesc'));
			$restSelect->join(array('st'=>'mt.state_bd'),'st.id = res.resstate_id',array('code as countrycode','description as countrydesc','currency_code'));
			$restSelect->join(array('neigh'=>'mt.neighborhood_bd'),'neigh.id = res.resneighborhood_id',array('description as neighdesc'));
			$restSelect->join(array('cat'=>'mt.special_category_bd'),'cat.id = respl.rspcategory',array('code as catcode','description as splCategory'));
			$restSelect->joinLeft(array('splcnt'=>'mt.special_count_type_bd'),'splcnt.id = respl.rsptype_of_occurance',array('description as splCount'));
			$restSelect->joinLeft(array('splpt'=>'mt.special_price_type_bd'),'splpt.id = respl.rsppricetype',array('description as splprice'));
			$restSelect->joinLeft(array('discmod'=>'mt.discount_mode_bd'),'discmod.id = respl.rspdiscount_mode',array('code as discModeCode' ,'description as discMode'));
			$restSelect->joinLeft(array('disctyp'=>'mt.discount_type_bd'),'disctyp.id = respl.rsptype_of_occurance',array('code as discTypeCode' ,'description as discTypeDisc'));
			$restSelect->where('res.resid = ?',$searchList->getRestId());
			if($searchList->getSplId()){
				$restSelect->where('respl.rspid = ?',$searchList->getSplId());
			}
			$restSelect->where('respl.rspstatus = ?',true);
			$restSelect->where('respl.rspdeletestatus = ?',true);
			$restSelect->where('res.resapprovalstatus = ?',1);
			$restSelect->where('res.resstatus = ?',1);
			if($searchList->getDate() && $searchList->getschtype() == 'viewall'){
//				$restSelect->where('respl.rspstart_date <= ?',$searchList->getDate());
//				$restSelect->where('respl.rspend_date >= ?',$searchList->getDate());
							
//				$restSelect->joinLeft(array('recurr'=>'mt.restaurant_special_reccurence'),'recurr.rsrfk_restaurant_special = respl.rspid',array());
//				$restSelect->where('recurr.rsrday_of_week = ?',$searchList->getWeekDayId());
			}else if($searchList->getDate() && $searchList->getTime()){
				
				$restSelect->where('respl.rspstart_date <= ?',$searchList->getDate());
				$restSelect->where('respl.rspend_date >= ?',$searchList->getDate());
				$restSelect->where('respl.rspstart_time <= ?',$searchList->getTime());
				$restSelect->where('respl.rspend_time >= ?',$searchList->getTime());				
				
//				$restSelect->joinLeft(array('recurr'=>'mt.restaurant_special_reccurence'),'recurr.rsrfk_restaurant_special = respl.rspid',array(''));
//				$restSelect->where('recurr.rsrday_of_week = ?',$searchList->getWeekDayId());
				
			}else if($searchList->getDate()){
				$restSelect->where('respl.rspstart_date <= ?',$searchList->getDate());
				$restSelect->where('respl.rspend_date <= ?',$searchList->getDate());
				
//				$restSelect->joinLeft(array('recurr'=>'mt.restaurant_special_reccurence'),'recurr.rsrfk_restaurant_special = respl.rspid',array());
//				$restSelect->where('recurr.rsrday_of_week = ?',$searchList->getWeekDayId());
			}

			$restSelect->order(array('respl.rspspecial_title'));
			$restSelect->limit($limit,$page*$limit);
			$rowSet = $restTable->fetchAll($restSelect);
			$resDet = array();
			$resIdArr = array();
			
			foreach($rowSet as $row){
				if($row->rsprecurencestatus){
					$reoccMapper = new Deals_Model_RestaurantSpecialRecurenceDataMapper();
					$reTable = $reoccMapper->getDbTable();
					$reoccSelect = $reTable->select();
					$reoccSelect->setIntegrityCheck(false);
					$reoccSelect->from(array('rsr'=>'mt.restaurant_special_reccurence'),array('rsrid','rsrday_of_week'))
								->join(array('wrb'=>'mt.weekly_recurence_bd'),'wrb.id = rsr.rsrday_of_week',array('description as day','code as dayCode'))
								->where('rsr.rsrfk_restaurant_special = ? ',$row->rspid);
					$rowResult = $reTable->fetchAll($reoccSelect);
					
				}else{
					$rowResult = "";
				}
				$descSplit = explode(' ',$row->rspdescription);
				if(count($descSplit) > 40){
					$description = implode(' ',array_slice($descSplit,0, 40));
				}else{
					$description = $row->rspdescription;
				}
				
				if(strlen($row->resdescription) > 200){
					$resdescription = substr($row->resdescription, 0, 200)." ...";
				}else{
					$resdescription = $row->resdescription;
				}
				$splObj = array();
				$splObj = array('Restaurantname'			=>	$row->resrestaurant_name,
					   			'Restaurantdesc'			=>	$resdescription,
					   			'Id'						=>	$row->rspid,
							   	'Restaurantid'				=>	$row->resid,
						       	'Address'					=>	$row->resaddress,
							   	'Restaurantid'				=>	$row->rspfk_restaurant,
							   	'Noofdishes'				=>	$row->rspno_of_dishes,
							   	'Specialtypename'			=>	$row->special,
						       	'Specialtypeid'				=>	$row->rspspecial_type,
							   	'Specialtitle'				=>	$row->rspspecial_title,
							   	'Specialimage'				=>	$row->rspspecial_image,
							   	'SpecialLogo'				=>	$row->reslogo,
							   	'Startdate'					=>	date("m/d/Y",strtotime($row->rspstart_date)),
							   	'Enddate'					=>	date("m/d/Y",strtotime($row->rspend_date)),
							   	'Starttime'					=>	$row->rspstart_time,
							   	'Endtime'					=>	$row->rspend_time,
							   	'Description'				=>	$description,
							   	'Specialrecurence'			=>	$row->rsprecurencestatus,
							   	'Kidsinfo'					=>	$row->rspkids_eat_free,
							   	'Kidsstatus'				=>	$row->rspkidsstatus,
							   	'SpecialCount'				=>	$row->rsptype_of_occurance,
							   	'SpecialCategoryType'		=>	$row->rspcategory,
							   	'SpecialCategoryTypeName'	=>	$row->splCategory,
							   	'CatTypeCode'				=>	$row->catcode,
							   	'SpecialCountName'			=>	$row->splCount,
							   	'DiscountMode'				=>	$row->discMode,
							   	'Distypename'				=>	$row->discTypeDisc,
							   	'Specialpricetype'			=>	$row->splprice,
							   	'Regprice'					=>	str_replace('$','',$row->rspregular_price),
							   	'Dispercentage'				=>	$row->rspdiscount_percentage_point,
							   	'Pricewithdiscount'			=>	str_replace('$','',$row->rspprice_with_discount),
							   	'Status'					=>	$row->rspstatus,
							   	'City'						=>	$row->citydesc,
							   	'Neighbour'					=>	$row->neighdesc,
							   	'Phone'						=>	$row->resphone,
								'ResFb'						=>	$row->resfacebook_id,
								'ResCurrency'				=>	$row->currency_code,
								'ResCountry'				=>	$row->countrydesc
				);
				$splWeek = array();
				if($rowResult){
					$weekStat = false;
					foreach($rowResult as $value){
						if(strtolower($weekday) == strtolower($value->dayCode)){
							$weekStat = true;
						}
						$splRecurenceObj = new Deals_Model_RestaurantSpecialRecurence();
						$splRecurenceObj->setWeekId($value->rsrday_of_week);
						$splRecurenceObj->setWeekDesc($value->day);
						$splWeek[] = $splRecurenceObj;
					}
					if(!$weekStat){
						continue;
					}
				}
				$splObj['Weekids']=$splWeek;
				$resDet[$row->rspid] = $splObj;
			}
			$ResvTimesArr = array();
			$finalResult = array();
			$rowSplIdSet = 1;
			$check = false;
			
			foreach($resDet as $key => $value){
				$splObject = "";
				$splObject = $value;
				$finalResult[$splObject['Id']] = $splObject;				
			}
			$result[0] = $finalResult;
			$result[1] = $check;
			return $result;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function shorten_string($string, $wordsreturned)
	{
		try{
			$retval = $string;
			$array = explode(" ", $string);
			if (count($array) <= $wordsreturned){
				$retval = $string;
			}else{
				array_splice($array, $wordsreturned);
				$retval = implode(" ", $array)." ...";
				return $retval;
			}
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function SearchRestaurantsCount(Reservation_Model_SearchListView  $searchList)
	{
		try{
			$count = 0;
			$restMapper = new FirmManagement_Model_FirmDataMapper();
			$restTable = $restMapper->getDbTable();
			$restSelect = $restTable->select();
			$restSelect->setIntegrityCheck(false);

			$restSelect->from(array('res'=>'mt.restaurant'),array('count(res.resid) as search_count'))
			->where('res.resapprovalstatus = ?',1)
			->where('res.resstatus = ?',1)
			//->where('res.resregion_id = ?',$searchList->getRegion())
			->where('res.rescity_id = ?',$searchList->getCity());

			if($searchList->getResId()){
				$restSelect->where('res.resid = ?',$searchList->getResId());
			}
			if($searchList->getRestaurantname()){
				$restSelect->where('res.resrestaurant_name ILIKE(?)','%'.$searchList->getRestaurantname().'%');
			}
			
			if($searchList->getPrice()){
				$restSelect->where('res.resprice = ?',$searchList->getPrice());
			}

			if($searchList->getNeighbor()){
				$restSelect->where('res.resneighborhood_id = ?',$searchList->getNeighbor());
			}

			if($searchList->getCuisine()){
				$restSelect->join(array('cusine'=>'mt.restaurant_cuisine'),'cusine.rcsfk_restaurant = res.resid',array());
				$restSelect->where('cusine.rscfk_restauranttype_id = ?',$searchList->getCuisine());
				//$restSelect->group(array("cusine.rscid"));
			}

			$rowset = $restTable->fetchAll($restSelect);
			foreach($rowset as $row){
				$count = $row->search_count;
			}
			
			return $count;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function RestTimingsByPax(Reservation_Model_GetRestaurantTimings $timings,$status)
	{
		try{
			//		$mapper = new FirmManagement_Model_FirmScheduleTableDataMapper();
			//		$blkTimes = $mapper->getBlockedTables($timings);
			switch($status){
				case "BKD":

					/* Check Whether the selected date contains any special schedule */
			
					$restSpecialSchObject = new FirmManagement_Model_FirmSpecialSchedule();
					$restSpecialSchObject->setrsesfk_restaurant($timings->getRestId());
					$restSpecialSchObject->setrseseventdate($timings->getDate());

					$restSplSchMapperObj = new FirmManagement_Model_FirmSpecialScheduleMapper();
			
					$splSchRow = $restSplSchMapperObj->CheckSpecialScheduleAvilable($restSpecialSchObject);
					
					/* Get Rest Timezone */
					$timezone = "";
					$mapper = new FirmManagement_Model_FirmDataMapper();
					$timezone = $mapper->GetRestaurantTimeZone($timings->getRestId());
					date_default_timezone_set($timezone);
					
					$dateSplit = explode("-",$timings->getDate());
					$weekday = date("D", mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]));
					$table = $this->getDbTable();
					$select = $table->select();
					$select->setIntegrityCheck(false);
					$select->from(array('sch'=>'mt.restaurant_schedule'),array('rssid','rssstart_time','rssday_of_week'));
					$select->where('sch.rssfk_restaurant = ?',(int)$timings->getRestId());
					$select->where('sch.rssday_of_week = ?',strtolower($weekday));
					$select->where('sch.rssstatus = ?',true);
					
					if($splSchRow){
						$select->where('sch.rssscheduletype_id = ?',2);
						$select->where('sch.rssfk_special_event_schedule = ?',$splSchRow->rsesid);	
					}else{
						$select->where('sch.rssscheduletype_id = ?',1);
					}
					
					$select->join(array('rst'=>'mt.restaurant_schedule_table'),'sch.rssid = rst.rstfk_restaurant_schedule',array('rstid','rsttable_pax','rstno_of_tables'));
					$select->where('rst.rsttable_pax = ?',(int)$timings->getpartysize());
					$select->where('rst.rststatus = ?',true);
					$select->order(array('sch.rssstart_time'));
					$result = $table->fetchAll($select);
					$resDetails = array();
					$finalList = array();
					$rssid = "";
					$resid = $timings->getRestId();
					$start_time = null;
					$pax = null;
					$nooftables = null;
					$date = $timings->getDate();
					foreach($result as $value){
						$start_time = $value->rssstart_time;
						$rssid = $value->rssid;
						$pax = $value->rsttable_pax;
						$nooftables = $value->rstno_of_tables;
						$tableStatus = $this->timeBookingStatus($resid,$date,$start_time,$pax,$nooftables,$rssid);
						if($tableStatus == "RSD" ){
							$resDetails = array(
								'rssid'				=> $value->rssid,
								'start_time'		=> date("g:i a",strtotime($start_time)),								
								'rsttable_pax'		=> $pax,
								'rstid'				=> $value->rstid);
							$finalList[] = $resDetails;
						}
					}
					break;
				case "UNBKD":
					$dateSplit = explode("-",$timings->getDate());
					$weekday = date("D", mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]));
					$table = $this->getDbTable();
					$select = $table->select();
					$select->setIntegrityCheck(false);
					
					$status = array();
					$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
					$status = array('BKD');
					$statusId = array();
					$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($status);
					foreach($bookStatusRes as $key=>$value){
						$statusId[] = $value->getId();
					}
			
					$bookTableMapper = new Reservation_Model_ReservationTableMapper();
					$bookTable       = $bookTableMapper->getDbTable();
					$bookTableSelect = $bookTable->select(); 
					$bookTableSelect->from($bookTable,array('bktbfk_booking','bktbtableid','bktbtable_no_assigned','bktb_join_table_no','bkt_dining_id'))
									->where('status = ?',true);
									
									
					$diningAreaMapper = new FirmManagement_Model_FirmDiningAreaDataMapper();
					$diningTable = $diningAreaMapper->getDbTable();
					$diningTableSelect = $diningTable->select();
					$diningTableSelect->from($diningTable,array('rdaid','rda_diningname','rda_diningdisplyname'))
									  ->where('rda_restid = ?',$timings->getRestId())
									  ->where('rda_status = ?',true);
							  
					$select->from(array('bok'=>'mt.booking'),array('bokid','bokfk_restaurant','bokuserid','bokfirst_name','boklast_name','bokparty_size','bokbooking_timings','bokspecial_request','bokrestaurant_note','bokbooking_status_id','bokresv_confirm_status'))
						   ->joinLeft(array('bktb'=>$bookTableSelect),'bktb.bktbfk_booking = bok.bokid',array('bktbtableid','bktbtable_no_assigned','bkt_dining_id'))
						   ->joinLeft(array('rda'=>$diningTableSelect),'rda.rdaid = bktb.bkt_dining_id',array('rda_diningdisplyname'))
						   ->join(array('boktyp'=>'mt.booking_type_bd'),'boktyp.id = bokbooking_type_id',array('code as boktypcode','description as boktypdesc'))
						   ->join(array('resmode'=>'mt.reservation_mode_bd'),'resmode.id = bok.bokreservation_mode_id',array('code as bokresmodecode','description as bokresmodedesc'))
						   ->join(array('boksts'=>'mt.booking_status_bd'),'bok.bokbooking_status_id = boksts.id',array('code as bokstatuscode'))
						   ->joinLeft(array('rst'=>'mt.restaurant_schedule_table'),'rst.rstid = bokfk_rest_sch_table',array('rstid'))
						   ->joinLeft(array('rss'=>'mt.restaurant_schedule'),'rss.rssid = rst.rstfk_restaurant_schedule',array('rss.rssid'))
						   ->where('bok.bokfk_restaurant = ?',$timings->getRestId())
						   ->where('bok.bokbooking_date = ?',$timings->getDate())
					  	 //->where('bok.bokbooking_status_id = ?',$inqueuelst->getBookStatus())
						   ->where('bok.bokbooking_status_id IN(?)',$statusId)
						   ->where('bktb.bktbtableid = ?',$timings->getTableId());
				   
				   $finalList = array();
					$rowset = $table->fetchAll($select);
					$prevBokidArr		= array();			
					$bokid 				= "";	
					$previd				= "";
					$firstname			= "";
					$lastname 			= "";					
					$bokuserid 			= "";
					$bokfk_restaurant 	= "";						
					$customername 		= "";							
					$name_on_resvnote   = ""; 					
					$bokparty_size 		= "";
					$bokbooking_timings = "";
					$bokspecial_request = "";
					$boktypcode 		= "";
					$boktypdesc 		= "";
					$bokresmodecode 	= "";
					$bokrestaurant_note = "";
					$bokstatusid		= "";
					$bokstatuscode      = "";
					$boktablenumber 	= "";
					$boktablenumArr     = array();
					$dinigid 			= "";
					$resvconfirmstatus  = "";
					
					foreach($rowset as $row)
					{
						if($previd == ""){
							
							$bokid 				= $row->bokid;
							$previd				= $row->bokid;											
							$bokuserid 			= $row->bokuserid;
							$bokfk_restaurant 	= $row->bokfk_restaurant;						
							$customername 		= $row->bokfirst_name." ".$row->boklast_name;							
							$name_on_resvnote   = $row->bokfirst_name." ".$row->boklast_name; 					
							$bokparty_size 		= $row->bokparty_size;
							$bokbooking_timings = $row->bokbooking_timings;
							$bokspecial_request = $row->bokspecial_request;
							$boktypcode 		= $row->boktypcode;
							$boktypdesc 		= $row->boktypdesc;
							$bokresmodecode 	= $row->bokresmodecode;
							$bokrestaurant_note = $row->bokrestaurant_note;
							$bokstatusid		= $row->bokbooking_status_id;
							$bokstatuscode      = $row->bokstatuscode;
							$boktablenumber 	= $row->bktbtable_no_assigned;
							$boktablenumArr[]	= $row->bktbtable_no_assigned;
							$dinigid			= $row->rda_diningdisplyname;
							$resvconfirmstatus  = $row->bokresv_confirm_status;
							$prevBokidArr[]		= $bokid;
							
						}else{
							$bokid = $row->bokid;
							if(in_array($bokid,$prevBokidArr)){
								$boktablenumArr[]	= $row->bktbtable_no_assigned;
							}else{
								array_push($finalList, array('bokid'	   => $previd,
												 	 'bokuserid' 		   => $bokuserid,
												 	 'bokfk_restaurant'    => $bokfk_restaurant,
												 	 'bokfirst_name' 	   => $customername,
												 	 'boknameonresvnote'   => $name_on_resvnote,											 
												 	 'bokparty_size' 	   => $bokparty_size,
												 	 'bokbooking_timings'  => date("h:i A",strtotime($bokbooking_timings)),
												 	 'bokspecial_request'  => $bokspecial_request,
												 	 'boktypcode' 		   => $boktypcode,
												 	 'boktypdesc' 		   => $boktypdesc,
												 	 'bokresmodecode' 	   => $bokresmodecode,
												 	 'boktablenumber'	   => $boktablenumber,
												 	 'bokrestaurant_note'  => $bokrestaurant_note,
												 	 'bokbooking_status_id'=> $bokstatusid,
												 	 'bokstatuscode'       => $bokstatuscode,
													 'boktablenumArr'	   => $boktablenumArr,
													 'diningid'			   => $dinigid,
													 'resvconfirmstatus'   => $resvconfirmstatus));
								
								$previd             = $bokid;
								$boktablenumArr     = null;	
								$lastname 			= "";					
								$bokuserid 			= $row->bokuserid;
								$bokfk_restaurant 	= $row->bokfk_restaurant;						
								$customername 		= $row->bokfirst_name." ".$row->boklast_name;							
								$name_on_resvnote   = $row->bokfirst_name." ".$row->boklast_name; 					
								$bokparty_size 		= $row->bokparty_size;
								$bokbooking_timings = $row->bokbooking_timings;
								$bokspecial_request = $row->bokspecial_request;
								$boktypcode 		= $row->boktypcode;
								$boktypdesc 		= $row->boktypdesc;
								$bokresmodecode 	= $row->bokresmodecode;
								$bokrestaurant_note = $row->bokrestaurant_note;
								$bokstatusid		= $row->bokbooking_status_id;
								$bokstatuscode      = $row->bokstatuscode;
								$boktablenumber 	= $row->bktbtable_no_assigned;
								$boktablenumArr[]	= $row->bktbtable_no_assigned;
								$dinigid			= $row->rda_diningdisplyname;
								$resvconfirmstatus  = $row->bokresv_confirm_status;
								$prevBokidArr[]		= $bokid;
								
							}	
						}					
					}
					$date = "";
					if($bokbooking_timings){
						$date = date("h:i A",strtotime($bokbooking_timings));
					}
					array_push($finalList, array('bokid'	   => $bokid,
									 	 'bokuserid' 		   => $bokuserid,
									 	 'bokfk_restaurant'    => $bokfk_restaurant,
									 	 'bokfirst_name' 	   => $customername,
									 	 'boknameonresvnote'   => $name_on_resvnote,											 
									 	 'bokparty_size' 	   => $bokparty_size,
									 	 'bokbooking_timings'  => $date,
									 	 'bokspecial_request'  => $bokspecial_request,
									 	 'boktypcode' 		   => $boktypcode,
									 	 'boktypdesc' 		   => $boktypdesc,
									 	 'bokresmodecode' 	   => $bokresmodecode,
									 	 'boktablenumber'	   => $boktablenumber,
									 	 'bokrestaurant_note'  => $bokrestaurant_note,
									 	 'bokbooking_status_id'=> $bokstatusid,
									 	 'bokstatuscode'       => $bokstatuscode,
										 'boktablenumArr'	   => $boktablenumArr,
										 'diningid'			  => $dinigid,
										 'resvconfirmstatus'   => $resvconfirmstatus));
					
				break;
			}
			return $finalList;
		}catch (Exception $ex){
			throw new Exception($ex->getMessage()) ;
		}
	}

}