<?php
class Application_Service_Communication
{
	protected $_form = array();
	public function setContactUsForm(Zend_Form $form)
	{
		$this->_form['ContactUs'] = $form;
	}

	public function getContactUsForm()
	{
		if(empty($this->_form['ContactUs'])) {
			$this->setContactUsForm(new Communication_Form_ContactUs());
		}
		return $this->_form['ContactUs'];
	}
	
	public function setContactUsMobileForm(Zend_Form $form)
	{
		$this->_form['ContactUsMobile'] = $form;
	}

	public function getContactUsMobileForm()
	{
		if(empty($this->_form['ContactUsMobile'])) {
			$this->setContactUsMobileForm(new Phone_Form_ContactUs());
		}
		return $this->_form['ContactUsMobile'];
	}
	
	public function setContactUsToRestForm(Zend_Form $form)
	{
		$this->_form['ContactUsToRest'] = $form;
	}

	public function getContactUsToRestForm()
	{
		if(empty($this->_form['ContactUsToRest'])) {
			$this->setContactUsToRestForm(new Communication_Form_ContactUsToRest());
		}
		return $this->_form['ContactUsToRest'];
	}
	
	public function setNotificationCreationForm(Zend_Form $form)
	{
		$this->_form['NotificationCreation'] = $form;
	}
	
	public function getNotificationCreationForm()
	{
		if(empty($this->_form['NotificationCreation'])) {
			$this->setNotificationCreationForm(new Communication_Form_CommunicationCreation());
		}
		return $this->_form['NotificationCreation'];
	}
	
	public function setRecipentFilterForm(Zend_Form $form)
	{
		$this->_form['RecipentFilter'] = $form;
	}
	
	public function getRecipentFilterForm()
	{
		if(empty($this->_form['RecipentFilter'])) {
			$this->setRecipentFilterForm(new Communication_Form_RecipentFilter());
		}
		return $this->_form['RecipentFilter'];
	}
	
	public function GetSponsorCampaigns($aud)
	{
		$service = new Application_Service_Administrator();
		$campProp = new Application_Model_GetCampaignForPost();
		$campProp->setAudType($aud)
				 ->setStateId(1);
		$sponsorDetails = $service->GetCampaignDetails($campProp);
		return $sponsorDetails;
	}
	
	public function UpdateCampaignEmailCount($camId,$count)
	{
		$service = new Application_Service_Administrator();
		$service->UpdateCampaignEmailCount($camId,$count);
		return true;
	}
	public  function SendMail(Communication_Model_Mail $mailobj)
	{
		try{
			$storage = new Zend_Auth_Storage_Session();
			$userData = $storage->read(); 
			$hungryHubResIds = array(209,210,211);
			if(($userData['companyid'] != 6 )&& ($userData['companyid'] != 23)&&(!in_array($userData['RestId'],$hungryHubResIds))){
			/* postmark settings*/
			$fromaddress = 'admin@dinedesk.com';
			$replyfromaddress = 'support@dinedesk.com';
			$fromname = 'DineDesk';
			$replyfromname = 'DineDesk Support';
			$language = "en";
			$namespace = new Zend_Session_Namespace(); 
			if($namespace->lang && $namespace->lang == "es_SP"){
				$language = "sp";
			}
			
			/*	Case Restaurant Owner Registration Confirmation	*/
			if($mailobj){
				Zend_Mail::setDefaultTransport( new Zend_Mail_Transport_Postmark('7c73f7f1-c2e6-4bbd-aa4b-fc1dadcb7da8' ));
				$mail = new Zend_Mail();
				$LeaderSendApi  = new LeaderSend_Inc_Leadersend();
				switch($mailobj->getMsgCode()){
					case 'ResOwnConf':
						
						if($language == "sp")
						{
							$mailobj->setMsgCode("ResOwnConf_Sp");
							$template = $this->GetMessageTemplate($mailobj);
						}else{
							$template = $this->GetMessageTemplate($mailobj);
						}
						
						if($template){
							$data    = $mailobj->getData();
							$name    = $data['UserName'];
							$subject = $template->msg_subject;
							$body    = $template->msg_body;							
							$body    = str_replace("%firstname%",$name,$body);
							$body 	 = str_replace("�",'',$body);
							$receiverslist = $data['SenTo'];
						
							
							$request = array(
										'subject' => $template->msg_subject,
										'from'    => array( // required. A sender’s information
															'name'  => 'DineDesk',
															'email' => $fromaddress
													),
										'signing_domain'=>'dinedesk.com',
										'to' => array(
													array(
														'name' => $name,
														'email' => $receiverslist)
												),
										'html'       => $body, // email's HTML content
										'auto_plain' => true, // automatically generate a text part for the messages of HTML part
										'merge_vars' => array( // define merge variables for each recipient
											'kotturs@gmail.com' => array(
												array(
													'name'  => 'FNAME',
													'value' => 'Alex'
												),
												array(
													'name'  => 'LNAME',
													'value' => 'Doubt'
												)
											)
										)
									);
							$retval = $LeaderSendApi->messagesSend($request);
								
							if($LeaderSendApi->errorMessage){
							    $mail->setFrom($fromaddress, $fromname);
							    $mail->setReplyTo($fromaddress,$fromname);
							    $mail->addTo( $receiverslist,$name);
							    $mail->setSubject($subject);
							    $mail->setBodyHtml($body);
							    $mail->send();
							}							
						}	
						break;
						
					case 'New Registration email' :
						$bokMapper = new Reservation_Model_ReservationDataMapper();
						$data    = $mailobj->getData();
						//$resLoc = $bokMapper->getRestaurantLocByBookingId($data['BookId']);
						$domain = "dinedesk.com";
						if(/*$resLoc->res_companyid == 22*/false){
							$mailobj->setMsgCode("New Registration emailHBC");
							$template = $this->GetMessageTemplate($mailobj);
							$domain = "hbcsolutions.net";
							$fromname  = 'HBC Solutions';
							$fromaddress = 'info@hbcsolutions.net';
						}else{
							$template = $this->GetMessageTemplate($mailobj);
							$domain = "dinedesk.com";
						}
						if($template){
							$data    = $mailobj->getData();
							$name 	 		= $data['name'];
							$restname		= $data['restname'];
							$city			= $data['city'];
							$state			= $data['state'];
							$phone			= $data['phone'];
							$email 			= $data['email'];
                                                        $origin 		= $data['origin'];
							
							$subject 		= $template->msg_subject;
							$body    		= $template->msg_body;							
							$body 	 		= str_replace("%restowner%",$name,$body);
							$body 	 		= str_replace("%restname%",$restname,$body);
							$body 	 		= str_replace("%city%",$city,$body);
							$body 	 		= str_replace("%state%",$state,$body);
							$body 	 		= str_replace("%phone%",$phone,$body);
							$body 	 		= str_replace("%email%",$email,$body);
                                                        $body 	 		= str_replace("%origin%",$origin,$body);
                                                        $url = $_SERVER["HTTP_HOST"]."/Administrator/Administrator/updatesrcoffirm/source_list/1/sourcedescription//id//userid//uid/".$data['uId']."/status/ACT/appstatus/approved";
                                                        $ip = $_SERVER["REMOTE_ADDR"];
                                                        $body 	 		= str_replace("%ip%",$ip,$body);
							$body 	 		= str_replace("%approve%",$url,$body);
							$body 	 		= str_replace("�",'',$body);
							
						//	$receiverslist 	= 'admin@dinedesk.com';
						
							
							$request = array(
										'subject' => $template->msg_subject,
										'from'    => array( // required. A sender’s information
															'name'  => $fromname,
															'email' => $fromaddress
													),
										'signing_domain'=>$domain,
										'to' => array(
													array(
														'name' => "admin@dinedesk",
														'email' => 'admin@dinedesk.com'),
														array(
														'name' => "sales@dinedesk",
														'email' => 'sales@dinedesk.com')
												),
										'html'       => $body, // email's HTML content
										'auto_plain' => true // automatically generate a text part for the messages of HTML part
									);
							$retval = $LeaderSendApi->messagesSend($request);
							if($LeaderSendApi->errorMessage){
								$mail->setFrom($fromaddress, $fromname);
							    $mail->setReplyTo($fromaddress,$fromname);
							    $mail->addTo( $receiverslist,$name);
							    $mail->setSubject($subject);
							    $mail->setBodyHtml($body);
							    $mail->send();
							}
						}
						break;
						
					case 'Registration Approved' :
							$template = $this->GetMessageTemplate($mailobj);
							if($template){
								$data    = $mailobj->getData();
								$name    = $data['UserName'];
								$subject = $template->msg_subject;
								$body    = $template->msg_body;	
								$email   = $data['SenTo'];						
								$body    = str_replace("%restowner%",$name,$body);
								$body    = str_replace("%email%",$email,$body);
								$body 	 = str_replace("�",'',$body);
								$receiverslist = $data['SenTo'];
								
								
								$request = array(
											'subject' => $template->msg_subject,
											'from'    => array( // required. A sender’s information
																'name'  => 'DineDesk',
																'email' => $fromaddress
														),
											'signing_domain'=>'dinedesk.com',
											'to' => array(
														array(
															'name' => $name,
															'email' => $receiverslist)
													),
											'html'       => $body, // email's HTML content
											'auto_plain' => true // automatically generate a text part for the messages of HTML part
										);
								$retval = $LeaderSendApi->messagesSend($request);
								if($LeaderSendApi->errorMessage){
									$mail->setFrom($fromaddress, $fromname);
								    $mail->setReplyTo($fromaddress,$fromname);
								    $mail->addTo( $receiverslist,$name);
								    $mail->setSubject($subject);
								    $mail->setBodyHtml($body);
								    $mail->send();
								}
							}	
						
						break;
						
					case 'Customer_Confirmation' :
						$domain = "dinedesk.com";
						if($_SERVER['SERVER_NAME'] == 'hbcsolutions.net' || $_SERVER['SERVER_NAME'] == 'www.hbcsolutions.net'){
							$mailobj->setMsgCode("Customer_ConfirmationHBC");
							$template = $this->GetMessageTemplate($mailobj);
							$domain = "hbcsolutions.net";
							$fromname  = 'HBC Solutions';
							$fromaddress = 'info@hbcsolutions.net';
						}else{
							$template = $this->GetMessageTemplate($mailobj);	
						}
						
						
						if($template){
							$data    = $mailobj->getData();
							$name    = $data['UserName'];
							$subject = $template->msg_subject;
							$body    = $template->msg_body;							
							$body    = str_replace("%firstname%",$name,$body);
							if(isset($data['pass'])){
								$txt = 'Your login details are <br><b> Email Id : </b>' .$data['SenTo']. '<br> <b>Password : </b>' .$data['pass']. '<br><br>s You can login with above mentioned details or use your facebook account to access these features.';
								$body    = str_replace("%usrpassword%",$txt,$body);
							}else{								
								$txt = 'You can login with your registered email or facebook account to access these features.';
								$body    = str_replace("%usrpassword%",$txt,$body);
							}
//							if(isset($data['pass'])){
//								$txt = 'You have successfully registerd with Dinedesk, and your password is '.$data['pass'];
//								$body    = str_replace("%usrpassword%",$txt,$body);
//							}else{
//								$body    = str_replace("%usrpassword%",'',$body);
//							}
							$body 	 = str_replace("�",'',$body);
							$receiverslist = $data['SenTo'];
							
							$request = array(
										'subject' => $subject,
										'from'    => array( // required. A sender’s information
															'name'  => $fromname,
															'email' => $fromaddress
													),
										'signing_domain'=>$domain,
										'to' => array(
													array(
														'name' => $name,
														'email' => $receiverslist)
												),
										'html'       => $body, // email's HTML content
										'auto_plain' => true // automatically generate a text part for the messages of HTML part
									);
							$retval = $LeaderSendApi->messagesSend($request);
							if($LeaderSendApi->errorMessage){
								$mail->setFrom($fromaddress, $fromname);
							  	$mail->setReplyTo($fromaddress,$fromname);
							    $mail->addTo( $receiverslist,$name);
							    $mail->setSubject($subject);
							    $mail->setBodyHtml($body);
							    $mail->send();
							}
						}
						break;
						
					case 'Customer_Reg_OnReservation':
						$template = $this->GetMessageTemplate($mailobj);
						
						if($template){
							$data    = $mailobj->getData();
							$name    = $data['UserName'];
							$pwd 	 = $data['password'];
							$subject = $template->msg_subject;
							$body    = $template->msg_body;							
							$body    = str_replace("%firstname%",$name,$body);
							$body	 = str_replace('%pwd%',$pwd,$body);
							$body 	 = str_replace("�",'',$body);
							$receiverslist = $data['SenTo'];
							
							$request = array(
										'subject' => $subject,
										'from'    => array( // required. A sender’s information
															'name'  => 'DineDesk',
															'email' => $fromaddress
													),
										'signing_domain'=>'dinedesk.com',
										'to' => array(
													array(
														'name' => $name,
														'email' => $receiverslist)
												),
										'html'       => $body, // email's HTML content
										'auto_plain' => true // automatically generate a text part for the messages of HTML part
									);
							$retval = $LeaderSendApi->messagesSend($request);
							if($LeaderSendApi->errorMessage){
								$mail->setFrom($fromaddress, $fromname);
							    $mail->setReplyTo($fromaddress,$fromname);
							    $mail->addTo( $receiverslist,$name);
							    $mail->setSubject($subject);
							    $mail->setBodyHtml($body);
							    $mail->send();
							}
						}
						break;
						
					case "BookReminder" :
						if($language == "sp")
						{
							$mailobj->setMsgCode("BookReminder_Sp");
							$template = $this->GetMessageTemplate($mailobj);
						}else{
							$template = $this->GetMessageTemplate($mailobj);
						}
						if($template){
							$data     = $mailobj->getData();
							$campId = "";

							$name     = $data['UserName'];
							$restname = $data['RestName'];
							$resdate  = $data['ResDate'];
							$time     = $data['Time'];
							$size     = $data['Size'];
							$address  = $data['Address'];
							$resphone = $data['resphone'];
							$status	  = $data['Status'];
							$bokid    = $data['Bokid'];
							$bokphrase = '';
							$bokMap = new Reservation_Model_ReservationDataMapper();
							$bokphrase = $bokMap->GetBookingPhraseByBookid($bokid);
							$resid = $bokMap->getRestIdByBookId($bokid);
							$state	  = $data['State_Id'];
							$city	  = $data['City_Id'];
							$resemail = $data['resemail'];
							$reszipcode = $data['reszipcode'];
							$rescity  = $data['rescity'];
							$resnbh   = $data['resnbh'];
							
//							$spldiv = '<div style="background: #f1ede8;box-shadow: 5px 5px 30px #808080;-moz-box-shadow: 5px 5px 30px #808080;-khtml-box-shadow: 5px 5px 30px #808080;-webkit-box-shadow: 5px 5px 30px #808080;border:3px solid #643513; padding:8px; font-size:12px;"><div style="color:#F79646; font-weight:bold; text-align:center;">%splname%</div><br /><div style="color:#4f6228; font-weight:bold;">Special Id: %splid%</div><br /><br /><div style="color:#000048;">%spldesc%</div></div><br /><br />';
							$spldiv = '<div class="box-shadow"><div style="color:#F79646; font-weight:bold; text-align:center;">%splname%</div><br /><div style="color:#4f6228; font-weight:bold;">Special Id: %splid%</div><br /><br /><div style="color:#000048;">%spldesc%</div></div><br /><br />';
							if($data['splstatus']){
								$splid		= $data['splid']; 
								$splname 	= $data['splname'];
								$spldesc	= $data['spldesc'];
//								$splorgprice= $data['splorgprice'];
//								$spldiscount= $data['spldiscount'];
//								$splprice	= $data['splprice'];
							}
							
							$userType = $data['UserType'];
							$div = '<td width="44%" valign="top" align="left">%img%</br><div>%desc%</div></td>';
							$imgDiv = '<div><img src="http://www.dinedesk.com%img%" width="150" height="150"/></div>';
							if(isset($data['campId'])){
								$campId  	= $data['campId'];
								$campname 	= $data['campaignName'];
								$desc  		= $data['campaignDesc'];
								$img 	  	= $data['campaignImg'];
								$desc  		= str_replace('src="','src="http://www.dinedesk.com',$desc);
								$display  	= 'block';
							}

							
							$subject = $template->msg_subject;
							$body    = $template->msg_body;
							
							$body    = str_replace("%firstname%",$name,$body);
							$body    = str_replace("%restname%",$restname,$body);
							$body    = str_replace("%date%",$resdate,$body);
							$body    = str_replace("%time%",$time,$body);
							$body    = str_replace("%size%",$size,$body);
							$body	 = str_replace("%address%",$address,$body);
							$body	 = str_replace("http://www.dinedesk.com","http://www.dinedesk.com",$body);
							$body	 = str_replace("%resphone%",$resphone,$body);
							$body	 = str_replace("%bokid%",$bokphrase,$body);
							$body    = str_replace("%resid%",$resid,$body);
							$body	 = str_replace("%bookingid%",$bokid,$body);
							$body	 = str_replace("%resnbh%",$resnbh,$body);
							$body	 = str_replace("%rescity%",$rescity,$body);
							$body	 = str_replace("%resemail%",$resemail,$body);
							$body	 = str_replace("%reszipcode%",$reszipcode,$body);							
							
							$body 	 = str_replace("�",'',$body);
							if(isset($data['campId'])){
								$body    = str_replace("none",$display,$body);
								$body    = str_replace("%desc%",$desc,$body);
								if($data['campaignImg']){
									$imgDiv 	= str_replace("%img%",$img,$imgDiv);
									$body    	= str_replace("%img%",$imgDiv,$body);
								}else{
									$body    = str_replace($imgDiv,'',$body);
								}
								$body    = str_replace("%campName%",$campname,$body);
							}else{
								$body    = str_replace($div,'',$body);
								$body    = str_replace("%campName%",'DineDesk',$body);
							}
							if($data['splstatus']){
								$body	= str_replace("%splname%",$splname,$body);
								$body	= str_replace("%splid%",$splid,$body);
//								$body	= str_replace("%orgprice%",$splorgprice,$body);
//								$body	= str_replace("%discount%",$spldiscount,$body);
//								$body	= str_replace("%price%",$splprice,$body);
								$body	= str_replace("%spldesc%",$spldesc,$body);
							}else{
								$body	= str_replace($spldiv,'',$body);
							}
							
							$receiverslist = $data['SenTo'];
						    
							$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
							$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
							$priorMapper = new Application_Model_PriorityDataMapper();
							$prior = $priorMapper->GetPriorityByCode('H');
							$msgMapper = new Communication_Model_EmailMessageDataMapper();
							$message = new Communication_Model_EmailMessage();
							$msgPhrase = uniqid ();
							$message->setBokid($bokid)
									->setPhrase($msgPhrase)
									->setTitle($mailobj->getMsgCode())
									->setDescription($body)
									->setPriority($prior->getcode())
									->setEmailtype($emailType->getcode())
									->setUsertype($userType)
									->setSentby('admin@dinedesk.com');
							$msgid = $msgMapper->SaveMessageDetails($message);
							$src = "http://www.dinedesk.com/Communication/Communication/emailcommunication/msgid/".$msgPhrase;
							$body	 = str_replace("%bookingsrc%",$src,$body);
							if($userType == 'CUS'){
								$cusMapper = new Communication_Model_EmailCusRecipentsDataMapper();
								$cusResult = $cusMapper->SaveCustMailDetails($msgid,$state,$city,$userType,$campId,$receiverslist);
							}
							
							
							$ema =array(
														'name' => $name,
														'email' => $receiverslist);
							$ema = array_merge($ema);
							$request = array(
										'subject' => $subject,
										'from'    => array( // required. A sender’s information
															'name'  => 'DineDesk',
															'email' => $fromaddress
													),
										'signing_domain'=>'dinedesk.com',
										'to' => array(
													array(
														'name' => $name,
														'email' => $receiverslist)
												),
										'html'       => $body, // email's HTML content
										'auto_plain' => true // automatically generate a text part for the messages of HTML part
									);
							$retval = $LeaderSendApi->messagesSend($request);
							if($LeaderSendApi->errorMessage){
							    $mail->setFrom($fromaddress, $fromname);
							    $mail->setReplyTo($fromaddress,$fromname);
							    $mail->addTo( $receiverslist,$name);
							    $mail->setSubject($subject);
							    $mail->setBodyHtml($body);
							    $mailSentStatus = $mail->send();
							    return $mailSentStatus;
							}
						}						
						break;	
						
						case 'BookConf' :
						$data     = $mailobj->getData();                                                   
						$bokMapper = new Reservation_Model_ReservationDataMapper();
						$resLoc = $bokMapper->getRestaurantLocByBookingId($data['Bokid']);
						if($resLoc->res_companyid == 22){
							$mailobj->setMsgCode('BookConfHBC');
								$template = $this->GetMessageTemplate($mailobj);
								if($template){
									
									$campId = "";
		
									$name     = $data['UserName'];
									$restname = $data['RestName'];
									$dateSplit = explode("-",$data['ResDate']);
									$s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
						//			$resdate  = date('l, j F Y',$s);
									$resdate  = date('l, d F',$s);
									$time     = $data['Time'];
									$size     = $data['Size'];
									$address  = $data['Address'];
									$cusphone = $data['phone'];
									$note     = $data['Note'];
									$status	  = $data['Status'];
									$bokid    = $data['Bokid'];
									$bokphrase = '';
									$bokMap = new Reservation_Model_ReservationDataMapper();
									$bokphrase = $bokMap->GetBookingPhraseByBookid($bokid);
									$book = new Reservation_Model_Reservation();
									$book->setbokid($bokid);
									$bookdetails = $bokMap->getBookingDetails($book);
									$rescountrycode = $bookdetails->getResCountrycode();							
									$resid = $bookdetails->getbokfk_restaurant();	
									$partnerresid = $bookdetails->getres_company_resid();
									$resphone = $rescountrycode.$data['resphone'];
									$state	  = $data['State_Id'];
									$city	  = $data['City_Id'];
									$resemail = $data['resemail'];
									$reszipcode = $data['reszipcode'];
									$rescity  = $data['rescity'];
									$resnbh   = $data['resnbh'];
									$userType = $data['UserType'];
									$cuisine = $data['cuisine'];
									$subject = $template->msg_subject."-".$data['RestName'];
									$body    = $template->msg_body;
									
									$body    = str_replace("%firstname%",$name,$body);
									$body    = str_replace("%restname%",$restname,$body);
									$body    = str_replace("%date%",$resdate,$body);
									$body    = str_replace("%time%",$time,$body);
									$body    = str_replace("%size%",$size,$body);
									$body	 = str_replace("%address%",$address,$body);
									$body	 = str_replace("%cuisine%",$cuisine,$body);
									$body	 = str_replace("%resphone%",$resphone,$body);
									$body	 = str_replace("http://www.dinedesk.com","http://www.dinedesk.com",$body);
									$body	 = str_replace("%bokid%",$bokphrase,$body);
									$body    = str_replace("%partnerresid%",$partnerresid,$body);
									$body	 = str_replace("%bookingid%",$bokid,$body);
									$body	 = str_replace("%resnbh%",$resnbh,$body);
									$body	 = str_replace("%rescity%",$rescity,$body);
									$body	 = str_replace("%resemail%",$resemail,$body);
									$body	 = str_replace("%reszipcode%",$reszipcode,$body);	
									$body	 = str_replace("%email%",$data['SenTo'],$body);		
									$body	 = str_replace("%phone%",$cusphone,$body);
									$body	 = str_replace("%note%",$note,$body);													
									
									$body 	 = str_replace("ï¿½",'',$body);
									$receiverslist = $data['SenTo'];
								    
									$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
									$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
									$priorMapper = new Application_Model_PriorityDataMapper();
									$prior = $priorMapper->GetPriorityByCode('H');
									$msgMapper = new Communication_Model_EmailMessageDataMapper();
									$message = new Communication_Model_EmailMessage();
									$msgPhrase = uniqid ();
									$message->setBokid($bokid)
											->setPhrase($msgPhrase)
											->setTitle($mailobj->getMsgCode())
											->setDescription($body)
											->setPriority($prior->getcode())
											->setEmailtype($emailType->getcode())
											->setUsertype($userType)
											->setSentby('admin@dinedesk.com');
									$msgid = $msgMapper->SaveMessageDetails($message);
									$src = "http://www.dinedesk.com/Communication/Communication/emailcommunication/msgid/".$msgPhrase;
									$body	 = str_replace("%bookingsrc%",$src,$body);
									if($userType == 'CUS'){
										$cusMapper = new Communication_Model_EmailCusRecipentsDataMapper();
										$cusResult = $cusMapper->SaveCustMailDetails($msgid,$state,$city,$userType,$campId,$receiverslist);
									}
									$ReceiversEmails = array();
									if($data['BookNotf']){
										$userType = 'RES';
										$ReceiversEmails = $data['RestEmails'];
										$msgPhrase = uniqid ();
										$message->setPhrase($msgPhrase)
												->setUsertype($userType);
										$msgid = $msgMapper->SaveMessageDetails($message);
										$src = "http://www.dinedesk.com/Communication/Communication/emailcommunication/msgid/".$msgPhrase;
										$body	 = str_replace("%bookingsrc%",$src,$body);
										if($userType == 'RES'){
											$cusMapper = new Communication_Model_EmailRestRecipentsDataMapper();
											$cusResult = $cusMapper->SaveRestMailDetails($msgid,$state,$city,$userType,$campId,$ReceiversEmails);
										}	
									}
									$ReceiversEmails[] = $receiverslist; 
									$fromname  = 'HBC Solutions';
									$fromaddress = 'info@hbcsolutions.net';
									$signing_domain ='hbcsolutions.net';
									$request = array(
												'subject' => $template->msg_subject,
												'from'    => array( // required. A sender’s information
																	'name'  => $fromname,
																	'email' => $fromaddress
															),
												'signing_domain'=>$signing_domain,
												'to' 			=> $ReceiversEmails,
												'html'    		=> $body, // email's HTML content
												'auto_plain' 	=> true
											);
									$retval = $LeaderSendApi->messagesSend($request);	
									
									if($LeaderSendApi->errorMessage || $retval[0]['status'] != 'sent'){
									    $mail->setFrom($fromaddress, $fromname);
									    $mail->setReplyTo($replyfromaddress,$replyfromname);
									    $mail->addTo( $ReceiversEmails,$name);
									    $mail->setSubject($subject);
									    $mail->setBodyHtml($body);
									    $status = $mail->send();
									}	
									
								}
                                                }else if($resLoc->res_companyid ==25){
                                                    $mailobj->setMsgCode('BookConfDWU');
								$template = $this->GetMessageTemplate($mailobj);
								if($template){
									
									$campId = "";
		
									$name     = $data['UserName'];
									$restname = $data['RestName'];
                                                                        $restemails = $data['RestEmails']; 
                                                                        $restemailstr='';
                                                                        foreach($restemails as $resemail){
                                                                            $restemailstr .=$resemail.',';
                                                                        }
                                                                       
//									$dateSplit = explode("-",$data['ResDate']);
//									$s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
//						//			$resdate  = date('l, j F Y',$s);
//									$resdate  = date('l, d F',$s);
                                                                        $dateSplit = explode("-",$data['ResDate']);
								        if(strlen($dateSplit[0]) > 2){
									$s = mktime(0,0,0,$dateSplit[1],$dateSplit[2],$dateSplit[0]);
									$resdate  = date('d M Y',$s);
								        }else{
									$s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
									$resdate  = date('d M Y',$s);
								        }
									$time     = $data['Time'];
									$size     = $data['Size'];
									$address  = $data['Address'];
									$cusphone = $data['phone'];
									$note     = $data['Note'];
									$status	  = $data['Status'];
									$bokid    = $data['Bokid'];
									$bokphrase = '';
									$bokMap = new Reservation_Model_ReservationDataMapper();
									$bokphrase = $bokMap->GetBookingPhraseByBookid($bokid);
									$book = new Reservation_Model_Reservation();
									$book->setbokid($bokid);
									$bookdetails = $bokMap->getBookingDetails($book);
									$rescountrycode = $bookdetails->getResCountrycode();							
									$resid = $bookdetails->getbokfk_restaurant();	
									$partnerresid = $bookdetails->getres_company_resid();
									$resphone = $rescountrycode.$data['resphone'];
									$state	  = $data['State_Id'];
									$city	  = $data['City_Id'];
									$resemail = $data['resemail'];
									$reszipcode = $data['reszipcode'];
									$rescity  = $data['rescity'];
									$resnbh   = $data['resnbh'];
									$userType = $data['UserType'];
									$cuisine = $data['cuisine'];
									$subject = $template->msg_subject."-".$data['RestName'];
									$body    = $template->msg_body;
									
									$body    = str_replace("%firstname%",$name,$body);
									$body    = str_replace("%restname%",$restname,$body);
									$body    = str_replace("%date%",$resdate,$body);
									$body    = str_replace("%time%",$time,$body);
									$body    = str_replace("%size%",$size,$body);
									$body	 = str_replace("%address%",$address,$body);
									$body	 = str_replace("%cuisine%",$cuisine,$body);
									$body	 = str_replace("%resphone%",$resphone,$body);
									$body	 = str_replace("http://www.dinedesk.com","http://www.dinedesk.com",$body);
									$body	 = str_replace("%bokid%",$bokphrase,$body);
									$body    = str_replace("%partnerresid%",$partnerresid,$body);
									$body	 = str_replace("%bookingid%",$bokid,$body);
									$body	 = str_replace("%resnbh%",$resnbh,$body);
									$body	 = str_replace("%rescity%",$rescity,$body);
									$body	 = str_replace("%resemail%",$resemail,$body);
									$body	 = str_replace("%reszipcode%",$reszipcode,$body);	
									$body	 = str_replace("%email%",$data['SenTo'],$body);		
									$body	 = str_replace("%phone%",$cusphone,$body);
									$body	 = str_replace("%note%",$note,$body);													
									
									$body 	 = str_replace("ï¿½",'',$body);
									$receiverslist = $data['SenTo'];
								    
									$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
									$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
									$priorMapper = new Application_Model_PriorityDataMapper();
									$prior = $priorMapper->GetPriorityByCode('H');
									$msgMapper = new Communication_Model_EmailMessageDataMapper();
									$message = new Communication_Model_EmailMessage();
									$msgPhrase = uniqid ();
									$message->setBokid($bokid)
											->setPhrase($msgPhrase)
											->setTitle($mailobj->getMsgCode())
											->setDescription($body)
											->setPriority($prior->getcode())
											->setEmailtype($emailType->getcode())
											->setUsertype($userType)
											->setSentby('admin@dinedesk.com');
									$msgid = $msgMapper->SaveMessageDetails($message);
									$src = "http://www.dinedesk.com/Communication/Communication/emailcommunication/msgid/".$msgPhrase;
									$body	 = str_replace("%bookingsrc%",$src,$body);
									if($userType == 'CUS'){
										$cusMapper = new Communication_Model_EmailCusRecipentsDataMapper();
										$cusResult = $cusMapper->SaveCustMailDetails($msgid,$state,$city,$userType,$campId,$receiverslist);
									}
									$ReceiversEmails = array();
									if($data['BookNotf']){
										$userType = 'RES';
										$ReceiversEmails = $data['RestEmails'];
										$msgPhrase = uniqid ();
										$message->setPhrase($msgPhrase)
												->setUsertype($userType);
										$msgid = $msgMapper->SaveMessageDetails($message);
										$src = "http://www.dinedesk.com/Communication/Communication/emailcommunication/msgid/".$msgPhrase;
										$body	 = str_replace("%bookingsrc%",$src,$body);
										if($userType == 'RES'){
											$cusMapper = new Communication_Model_EmailRestRecipentsDataMapper();
											$cusResult = $cusMapper->SaveRestMailDetails($msgid,$state,$city,$userType,$campId,$ReceiversEmails);
										}	
									}
									$ReceiversEmails[] = $receiverslist; 
									$fromname  = 'DiningWithUs';
									$fromaddress = 'admin@diningwithus.com';
									$signing_domain ='diningwithus.com';
									$request = array(
												'subject' => $template->msg_subject,
												'from'    => array( // required. A sender’s information
																	'name'  => $fromname,
																	'email' => $fromaddress
															),
												'signing_domain'=>$signing_domain,
												'to' 			=> $ReceiversEmails,
												'html'    		=> $body, // email's HTML content
												'auto_plain' 	=> true,
                                                                                                'headers' => array(
                                                                                                    'reply-to' => $restemailstr,
                                                                                                ),
											);
									$retval = $LeaderSendApi->messagesSend($request);	
									
									if($LeaderSendApi->errorMessage || $retval[0]['status'] != 'sent'){
										$mail->setFrom($fromaddress, $fromname);
									    $mail->setReplyTo($replyfromaddress,$replyfromname);
									    $mail->addTo( $ReceiversEmails,$name);
									    $mail->setSubject($subject);
									    $mail->setBodyHtml($body);
									    $status = $mail->send();
									}	
									
								}
                                                }
                                                else if($resLoc->res_companyid == 6){
							if($data['rmnotf'] == 'true'){
								$mailobj->setMsgCode('BookConfRM');
								$template = $this->GetMessageTemplate($mailobj);
								if($template){
									
									$campId = "";
		
									$name     = $data['UserName'];
									$restname = $data['RestName'];
									$dateSplit = explode("-",$data['ResDate']);
									$s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
						//			$resdate  = date('l, j F Y',$s);
									$resdate  = date('l, d F',$s);
									$time     = $data['Time'];
									$size     = $data['Size'];
									$address  = $data['Address'];
									$cusphone = $data['phone'];
									$note     = $data['Note'];
									$status	  = $data['Status'];
									$bokid    = $data['Bokid'];
									$bokphrase = '';
									$bokMap = new Reservation_Model_ReservationDataMapper();
									$bokphrase = $bokMap->GetBookingPhraseByBookid($bokid);
									$book = new Reservation_Model_Reservation();
									$book->setbokid($bokid);
									$bookdetails = $bokMap->getBookingDetails($book);
									$rescountrycode = $bookdetails->getResCountrycode();							
									$resid = $bookdetails->getbokfk_restaurant();	
									$partnerresid = $bookdetails->getres_company_resid();
									$resphone = $rescountrycode.$data['resphone'];
									$state	  = $data['State_Id'];
									$city	  = $data['City_Id'];
									$resemail = $data['resemail'];
									$reszipcode = $data['reszipcode'];
									$rescity  = $data['rescity'];
									$resnbh   = $data['resnbh'];
									$userType = $data['UserType'];
									$cuisine = $data['cuisine'];
									$subject = $template->msg_subject."-".$data['RestName'];
									$body    = $template->msg_body;
									
									$body    = str_replace("%firstname%",$name,$body);
									$body    = str_replace("%restname%",$restname,$body);
									$body    = str_replace("%date%",$resdate,$body);
									$body    = str_replace("%time%",$time,$body);
									$body    = str_replace("%size%",$size,$body);
									$body	 = str_replace("%address%",$address,$body);
									$body	 = str_replace("%cuisine%",$cuisine,$body);
									$body	 = str_replace("%resphone%",$resphone,$body);
									$body	 = str_replace("http://www.dinedesk.com","http://www.dinedesk.com",$body);
									$body	 = str_replace("%bokid%",$bokphrase,$body);
									$body    = str_replace("%partnerresid%",$partnerresid,$body);
									$body	 = str_replace("%bookingid%",$bokid,$body);
									$body	 = str_replace("%resnbh%",$resnbh,$body);
									$body	 = str_replace("%rescity%",$rescity,$body);
									$body	 = str_replace("%resemail%",$resemail,$body);
									$body	 = str_replace("%reszipcode%",$reszipcode,$body);	
									$body	 = str_replace("%email%",$data['SenTo'],$body);		
									$body	 = str_replace("%phone%",$cusphone,$body);
									$body	 = str_replace("%note%",$note,$body);													
									
									$body 	 = str_replace("ï¿½",'',$body);
									$receiverslist = $data['SenTo'];
								    
									$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
									$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
									$priorMapper = new Application_Model_PriorityDataMapper();
									$prior = $priorMapper->GetPriorityByCode('H');
									$msgMapper = new Communication_Model_EmailMessageDataMapper();
									$message = new Communication_Model_EmailMessage();
									$msgPhrase = uniqid ();
									$message->setBokid($bokid)
											->setPhrase($msgPhrase)
											->setTitle($mailobj->getMsgCode())
											->setDescription($body)
											->setPriority($prior->getcode())
											->setEmailtype($emailType->getcode())
											->setUsertype($userType)
											->setSentby('admin@dinedesk.com');
									$msgid = $msgMapper->SaveMessageDetails($message);
									$src = "http://www.dinedesk.com/Communication/Communication/emailcommunication/msgid/".$msgPhrase;
									$body	 = str_replace("%bookingsrc%",$src,$body);
									if($userType == 'CUS'){
										$cusMapper = new Communication_Model_EmailCusRecipentsDataMapper();
										$cusResult = $cusMapper->SaveCustMailDetails($msgid,$state,$city,$userType,$campId,$receiverslist);
									}
									$ReceiversEmails = array();
									if($data['BookNotf']){
										$userType = 'RES';
										$ReceiversEmails = $data['RestEmails'];
										$msgPhrase = uniqid ();
										$message->setPhrase($msgPhrase)
												->setUsertype($userType);
										$msgid = $msgMapper->SaveMessageDetails($message);
										$src = "http://www.dinedesk.com/Communication/Communication/emailcommunication/msgid/".$msgPhrase;
										$body	 = str_replace("%bookingsrc%",$src,$body);
										if($userType == 'RES'){
											$cusMapper = new Communication_Model_EmailRestRecipentsDataMapper();
											$cusResult = $cusMapper->SaveRestMailDetails($msgid,$state,$city,$userType,$campId,$ReceiversEmails);
										}	
									}
									$ReceiversEmails[] = $receiverslist; 
									$request = array(
												'subject' => $template->msg_subject,
												'from'    => array( // required. A sender’s information
																	'name'  => 'DineDesk',
																	'email' => $fromaddress
															),
												'signing_domain'=>'dinedesk.com',
												'to' 			=> $ReceiversEmails,
												'html'    		=> $body, // email's HTML content
												'auto_plain' 	=> true
											);
									$retval = $LeaderSendApi->messagesSend($request);	
									
									if($LeaderSendApi->errorMessage || $retval[0]['status'] != 'sent'){
										$mail->setFrom($fromaddress, $fromname);
									    $mail->setReplyTo($replyfromaddress,$replyfromname);
									    $mail->addTo( $ReceiversEmails,$name);
									    $mail->setSubject($subject);
									    $mail->setBodyHtml($body);
									    $status = $mail->send();
									}	
									
								}
							}  
						}else {
							if($language == "sp"){
								$mailobj->setMsgCode('BookConf_Sp');
								$template = $this->GetMessageTemplate($mailobj);
							}else{
								$template = $this->GetMessageTemplate($mailobj);
							}
							if($template){
								
								$campId = "";
	
								$name     = $data['UserName'];
								$restname = $data['RestName'];
                                                                $restemails = $data['RestEmails']; 
                                                                $restemailstr='';
                                                                foreach($restemails as $resemail){
                                                                $restemailstr .=$resemail.',';
                                                                }
								$dateSplit = explode("-",$data['ResDate']);
								if(strlen($dateSplit[0]) > 2){
									$s = mktime(0,0,0,$dateSplit[1],$dateSplit[2],$dateSplit[0]);
									$resdate  = date('d M Y',$s);
								}else{
									$s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
									$resdate  = date('d M Y',$s);
								}
								$time     = $data['Time'];
								$size     = $data['Size'];
								$address  = $data['Address'];
								$cusphone = $data['phone'];
								$note     = $data['Note'];
								$status	  = $data['Status'];
								$bokid    = $data['Bokid'];
								$bokphrase = '';
								$bokMap = new Reservation_Model_ReservationDataMapper();
								$bokphrase = $bokMap->GetBookingPhraseByBookid($bokid);
								$book = new Reservation_Model_Reservation();
								$book->setbokid($bokid);
								$bookdetails = $bokMap->getBookingDetails($book);
								$rescountrycode = $bookdetails->getResCountrycode();							
								$resid = $bookdetails->getbokfk_restaurant();	
								
								if(isset($resid)){
									$row = $bokMap->GetRestaurantLogo($resid);
									if($row->reslogo){
										$logo = str_replace(" ","%20",$row->reslogo);
										$RestLogo = '<img src="http://www.dinedesk.com'.$logo.'" border="0"  height="60" align="left" />';
									}else{
										$RestLogo = '<img src="http://www.dinedesk.com/images/dinedesk-logo.png"  border="0" height="60"  align="left" usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2" />';
									}
								}else{
										$RestLogo = '<img src="http://www.dinedesk.com/images/dinedesk-logo.png"  border="0" height="60"  align="left" usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2" />';
								}
								if($data['DiscountMsg']){
									$DiscountMsg = '<tr>
														<td style="font-family:Helvetica,Arial,sans-serif;font-size:16px;line-height:23px;font-weight:bold;color:#00a651;padding-bottom:10px">Avail</td>
													</tr>
													<tr>
														<td align="left">
															<table cellpadding="0" cellspacing="0" border="0" width="450">
																	<tbody><tr>
																		<td align="left" style="font-family:Helvetica,Arial,sans-serif;font-size:12px;font-weight:bold;line-height:14px;color:#000;">'.$data['DiscountMsg'].'</td>
																	</tr>
																</tbody>
															</table>
														</td>
													</tr>
													<tr>
														<td align="left">
															<table cellpadding="0" cellspacing="0" border="0" width="450">
																	<tbody><tr>
																		<td height="20" align="left" style="font-size:0;line-height:0"><img src="http://www.dinedesk.com/images/email/spacer.gif" width="1" height="20" border="0" style="display:block" ></td>
																	</tr>
																	<tr>
																		<td height="1" bgcolor="#ececec" align="left" style="font-size:0;line-height:0"><img src="http://www.dinedesk.com/images/email/spacer.gif" width="1" height="1" border="0" style="display:block" ></td>
																	</tr>
																	<tr>
																		<td height="20" align="left" style="font-size:0;line-height:0"><img src="http://www.dinedesk.com/images/email/spacer.gif" width="1" height="20" border="0" style="display:block" ></td>
																	</tr>
																</tbody>
															</table>
														</td>
													</tr>';
								}else{
									$DiscountMsg = '';
								}
								$resphone = $rescountrycode.$data['resphone'];
								$state	  = $data['State_Id'];
								$city	  = $data['City_Id'];
								$resemail = $data['resemail'];
								$reszipcode = $data['reszipcode'];
								$rescity  = $data['rescity'];
								$resnbh   = $data['resnbh'];
								
	//							$spldiv = '<div style="background: #f1ede8;box-shadow: 5px 5px 30px #808080;-moz-box-shadow: 5px 5px 30px #808080;-khtml-box-shadow: 5px 5px 30px #808080;-webkit-box-shadow: 5px 5px 30px #808080;border:3px solid #643513; padding:8px; font-size:12px;"><div style="color:#F79646; font-weight:bold; text-align:center;">%splname%</div><br /><div style="color:#4f6228; font-weight:bold;">Special Id: %splid%</div><br /><br /><div style="color:#000048;">%spldesc%</div></div><br /><br />';
								$spldiv = '<div class="box-shadow"><div style="color:#F79646; font-weight:bold; text-align:center;">%splname%</div><br /><div style="color:#4f6228; font-weight:bold;">Special Id: %splid%</div><br /><br /><div style="color:#000048;">%spldesc%</div></div><br /><br />';
	//							if($data['splstatus']){
	//								$splid		= $data['splid']; 
	//								$splname 	= $data['splname'];
	//								$spldesc	= $data['spldesc'];
	////								$splorgprice= $data['splorgprice'];
	////								$spldiscount= $data['spldiscount'];
	////								$splprice	= $data['splprice'];
	//							}
								
								$userType = $data['UserType'];
								$div = '<td width="44%" valign="top" align="left">%img%</br><div>%desc%</div></td>';
										
								$imgDiv = '<div><img src="http://www.dinedesk.com%img%" width="150" height="150"/></div>';
								if(isset($data['campId'])){
									$campId  	= $data['campId'];
									$campname 	= $data['campaignName'];
									$desc  		= $data['campaignDesc'];
									$img 	  	= $data['campaignImg'];
									$desc  		= str_replace('src="','src="http://www.dinedesk.com',$desc);
									$display  	= 'block';
								}
								
								$notifcontdiv = '<div class="notificationcontent">%notifcont%</div><br/>';
	//							if($data['notifcontstatus']){
	//								$notifcont = $data['notifcont'];
	//								$notifcont  = str_replace('src="','src="http://www.dinedesk.com',$notifcont); 
	//							}
								
								$subject = $template->msg_subject."-".$data['RestName'];
								$body    = $template->msg_body;
								
								$body    = str_replace("%firstname%",$name,$body);
								$body    = str_replace("%restname%",$restname,$body);
								$body    = str_replace("%date%",$resdate,$body);
								$body    = str_replace("%time%",$time,$body);
								$body    = str_replace("%size%",$size,$body);
								$body	 = str_replace("%address%",$address,$body);
								$body	 = str_replace("%resphone%",$resphone,$body);
								$body	 = str_replace("http://www.dinedesk.com","http://www.dinedesk.com",$body);
								$body	 = str_replace("%bokid%",$bokphrase,$body);
								$body    = str_replace("%resid%",$resid,$body);
								$body	 = str_replace("%bookingid%",$bokid,$body);
								$body	 = str_replace("%resnbh%",$resnbh,$body);
								$body	 = str_replace("%rescity%",$rescity,$body);
								$body	 = str_replace("%resemail%",$resemail,$body);
								$body	 = str_replace("%reszipcode%",$reszipcode,$body);	
								$body	 = str_replace("%reslogo%",$RestLogo,$body);
								$body	 = str_replace("%discountmsg%",$DiscountMsg,$body);	
								$body	 = str_replace("%email%",$data['SenTo'],$body);		
								$body	 = str_replace("%phone%",$cusphone,$body);
								$body	 = str_replace("%note%",$note,$body);													
								
								$body 	 = str_replace("�",'',$body);
								if(isset($data['campId'])){
									$body    = str_replace("none",$display,$body);
									$body    = str_replace("%desc%",$desc,$body);
									if($data['campaignImg']){
										$imgDiv 	= str_replace("%img%",$img,$imgDiv);
										$body    	= str_replace("%img%",$imgDiv,$body);
									}else{
										$body    = str_replace($imgDiv,'',$body);
									}
									$body    = str_replace("%campName%",$campname,$body);
								}else{
									$body    = str_replace($div,'',$body);
									$body    = str_replace("%campName%",'DineDesk',$body);
								}
	//							if($data['splstatus']){
	//								$body	= str_replace("%splname%",$splname,$body);
	//								$body	= str_replace("%splid%",$splid,$body);
	////								$body	= str_replace("%orgprice%",$splorgprice,$body);
	////								$body	= str_replace("%discount%",$spldiscount,$body);
	////								$body	= str_replace("%price%",$splprice,$body);
	//								$body	= str_replace("%spldesc%",$spldesc,$body);
	//							}else{
									$body	= str_replace($spldiv,'',$body); 
	//							}
								
	//							if($data['notifcontstatus']){
	//								$body	= str_replace("%notifcont%",$notifcont,$body);
	//							}else{
									$body	= str_replace($notifcontdiv,'',$body);
	//							} 
								
								$receiverslist = $data['SenTo'];
							    
								$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
								$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
								$priorMapper = new Application_Model_PriorityDataMapper();
								$prior = $priorMapper->GetPriorityByCode('H');
								$msgMapper = new Communication_Model_EmailMessageDataMapper();
								$message = new Communication_Model_EmailMessage();
								$msgPhrase = uniqid ();
								$message->setBokid($bokid)
										->setPhrase($msgPhrase)
										->setTitle($mailobj->getMsgCode())
										->setDescription($body)
										->setPriority($prior->getcode())
										->setEmailtype($emailType->getcode())
										->setUsertype($userType)
										->setSentby('admin@dinedesk.com');
								$msgid = $msgMapper->SaveMessageDetails($message);
								$src = "http://www.dinedesk.com/Communication/Communication/emailcommunication/msgid/".$msgPhrase;
								$body	 = str_replace("%bookingsrc%",$src,$body);
								if($userType == 'CUS'){
									$cusMapper = new Communication_Model_EmailCusRecipentsDataMapper();
									$cusResult = $cusMapper->SaveCustMailDetails($msgid,$state,$city,$userType,$campId,$receiverslist);
								}
								$ReceiversEmails = array();
								if($data['BookNotf']){
									$userType = 'RES';
									$ReceiversEmails = $data['RestEmails'];
									$msgPhrase = uniqid ();
									$message->setPhrase($msgPhrase)
											->setUsertype($userType);
									$msgid = $msgMapper->SaveMessageDetails($message);
									$src = "http://www.dinedesk.com/Communication/Communication/emailcommunication/msgid/".$msgPhrase;
									$body	 = str_replace("%bookingsrc%",$src,$body);
									if($userType == 'RES'){
										$cusMapper = new Communication_Model_EmailRestRecipentsDataMapper();
										$cusResult = $cusMapper->SaveRestMailDetails($msgid,$state,$city,$userType,$campId,$ReceiversEmails);
									}	
								}
								
								
								$ReceiversEmails[] = $receiverslist; 
								$request = array(
											'subject' => $template->msg_subject,
											'from'    => array( // required. A sender’s information
																'name'  => 'DineDesk',
																'email' => $fromaddress
														),
											'signing_domain'=>'dinedesk.com',
											'to' 			=> $ReceiversEmails,
											'html'    		=> $body, // email's HTML content
											'auto_plain' 	=> true,
                                                                                        'headers' => array(
                                                                                                    'reply-to' => $restemailstr,
                                                                                        ),
										);
								
								$retval = $LeaderSendApi->messagesSend($request);
								if($retval){
									foreach($retval as $value){
										if($LeaderSendApi->errorMessage || $value['status'] != 'sent'){
											$mail->setFrom($fromaddress, $fromname);
											$mail->setReplyTo($replyfromaddress,$replyfromname);
											$mail->addTo( $value['email'] ,$name);
											$mail->setSubject($subject);
											$mail->setBodyHtml($body);
											$status = $mail->send();
										}
									}
								}
							}
						}						
						break;
                                                
                                                case 'BookRecvd' :
						$data     = $mailobj->getData();                                                       
						$bokMapper = new Reservation_Model_ReservationDataMapper();
						$resLoc = $bokMapper->getRestaurantLocByBookingId($data['Bokid']);
						 if($resLoc->res_companyid ==25){
                                                    $mailobj->setMsgCode('BookRecvdDWU');
								$template = $this->GetMessageTemplate($mailobj);
								if($template){									
									$campId = "";		
									$name     = $data['UserName'];
									$restname = $data['RestName'];
                                                                        $restemails = $data['RestEmails']; 
                                                                        $restemailstr='';
                                                                        foreach($restemails as $resemail){
                                                                            $restemailstr .=$resemail.',';
                                                                        }
                                                                        $dateSplit = explode("-",$data['ResDate']);
								        if(strlen($dateSplit[0]) > 2){
									$s = mktime(0,0,0,$dateSplit[1],$dateSplit[2],$dateSplit[0]);
									$resdate  = date('d M Y',$s);
								        }else{
									$s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
									$resdate  = date('d M Y',$s);
								        }
									$time     = $data['Time'];
									$size     = $data['Size'];
									$address  = $data['Address'];
									$cusphone = $data['phone'];
									$note     = $data['Note'];
									$status	  = $data['Status'];
									$bokid    = $data['Bokid'];
									$bokphrase = '';
									$bokMap = new Reservation_Model_ReservationDataMapper();
									$bokphrase = $bokMap->GetBookingPhraseByBookid($bokid);
									$book = new Reservation_Model_Reservation();
									$book->setbokid($bokid);
									$bookdetails = $bokMap->getBookingDetails($book);
									$rescountrycode = $bookdetails->getResCountrycode();							
									$resid = $bookdetails->getbokfk_restaurant();	
									$partnerresid = $bookdetails->getres_company_resid();
									$resphone = $rescountrycode.$data['resphone'];
									$state	  = $data['State_Id'];
									$city	  = $data['City_Id'];
									$resemail = $data['resemail'];
									$reszipcode = $data['reszipcode'];
									$rescity  = $data['rescity'];
									$resnbh   = $data['resnbh'];
									$userType = $data['UserType'];
									$cuisine = $data['cuisine'];
									$subject = $template->msg_subject."-".$data['RestName'];
									$body    = $template->msg_body;
									
									$body    = str_replace("%firstname%",$name,$body);
									$body    = str_replace("%restname%",$restname,$body);
									$body    = str_replace("%date%",$resdate,$body);
									$body    = str_replace("%time%",$time,$body);
									$body    = str_replace("%size%",$size,$body);
									$body	 = str_replace("%address%",$address,$body);
									$body	 = str_replace("%cuisine%",$cuisine,$body);
									$body	 = str_replace("%resphone%",$resphone,$body);
									$body	 = str_replace("http://www.dinedesk.com","http://www.dinedesk.com",$body);
									$body	 = str_replace("%bokid%",$bokphrase,$body);
									$body    = str_replace("%partnerresid%",$partnerresid,$body);
									$body	 = str_replace("%bookingid%",$bokid,$body);
									$body	 = str_replace("%resnbh%",$resnbh,$body);
									$body	 = str_replace("%rescity%",$rescity,$body);
									$body	 = str_replace("%resemail%",$resemail,$body);
									$body	 = str_replace("%reszipcode%",$reszipcode,$body);	
									$body	 = str_replace("%email%",$data['SenTo'],$body);		
									$body	 = str_replace("%phone%",$cusphone,$body);
									$body	 = str_replace("%note%",$note,$body);													
									
									$body 	 = str_replace("ï¿½",'',$body);
									$receiverslist = $data['SenTo'];
								    
									$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
									$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
									$priorMapper = new Application_Model_PriorityDataMapper();
									$prior = $priorMapper->GetPriorityByCode('H');
									$msgMapper = new Communication_Model_EmailMessageDataMapper();
									$message = new Communication_Model_EmailMessage();
									$msgPhrase = uniqid ();
									$message->setBokid($bokid)
											->setPhrase($msgPhrase)
											->setTitle($mailobj->getMsgCode())
											->setDescription($body)
											->setPriority($prior->getcode())
											->setEmailtype($emailType->getcode())
											->setUsertype($userType)
											->setSentby('admin@dinedesk.com');
									$msgid = $msgMapper->SaveMessageDetails($message);
									$src = "http://www.dinedesk.com/Communication/Communication/emailcommunication/msgid/".$msgPhrase;
									$body	 = str_replace("%bookingsrc%",$src,$body);
									if($userType == 'CUS'){
										$cusMapper = new Communication_Model_EmailCusRecipentsDataMapper();
										$cusResult = $cusMapper->SaveCustMailDetails($msgid,$state,$city,$userType,$campId,$receiverslist);
									}
									$ReceiversEmails = array();
									if($data['BookNotf']){
										$userType = 'RES';
										$ReceiversEmails = $data['RestEmails'];
										$msgPhrase = uniqid ();
										$message->setPhrase($msgPhrase)
												->setUsertype($userType);
										$msgid = $msgMapper->SaveMessageDetails($message);
										$src = "http://www.dinedesk.com/Communication/Communication/emailcommunication/msgid/".$msgPhrase;
										$body	 = str_replace("%bookingsrc%",$src,$body);
										if($userType == 'RES'){
											$cusMapper = new Communication_Model_EmailRestRecipentsDataMapper();
											$cusResult = $cusMapper->SaveRestMailDetails($msgid,$state,$city,$userType,$campId,$ReceiversEmails);
										}	
									}
									$ReceiversEmails[] = $receiverslist; 
									$fromname  = 'DiningWithUs';
									$fromaddress = 'admin@diningwithus.com';
									$signing_domain ='diningwithus.com';
									$request = array(
												'subject' => $template->msg_subject,
												'from'    => array( // required. A sender’s information
																	'name'  => $fromname,
																	'email' => $fromaddress
															),
												'signing_domain'=>$signing_domain,
												'to' 			=> $ReceiversEmails,
												'html'    		=> $body, // email's HTML content
												'auto_plain' 	=> true,
                                                                                                'headers' => array(
                                                                                                    'reply-to' => $restemailstr,
                                                                                                ),
											);
									$retval = $LeaderSendApi->messagesSend($request);	
									
									if($LeaderSendApi->errorMessage || $retval[0]['status'] != 'sent'){
										$mail->setFrom($fromaddress, $fromname);
									    $mail->setReplyTo($replyfromaddress,$replyfromname);
									    $mail->addTo( $ReceiversEmails,$name);
									    $mail->setSubject($subject);
									    $mail->setBodyHtml($body);
									    $status = $mail->send();
									}	
									
								}
                                                }
                                                else {
                                                        //Booking Received email for dinedesk customer							
							$template = $this->GetMessageTemplate($mailobj);							
							if($template){								
								$campId = "";
								$name     = $data['UserName'];
								$restname = $data['RestName'];
                                                                $restemails = $data['RestEmails']; 
                                                                $restemailstr='';
                                                                foreach($restemails as $resemail){
                                                                $restemailstr .=$resemail.',';
                                                                }
								$dateSplit = explode("-",$data['ResDate']);
								if(strlen($dateSplit[0]) > 2){
									$s = mktime(0,0,0,$dateSplit[1],$dateSplit[2],$dateSplit[0]);
									$resdate  = date('d M Y',$s);
								}else{
									$s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
									$resdate  = date('d M Y',$s);
								}
								$time     = $data['Time'];
								$size     = $data['Size'];
								$address  = $data['Address'];
								$cusphone = $data['phone'];
								$note     = $data['Note'];
								$status	  = $data['Status'];
								$bokid    = $data['Bokid'];
								$bokphrase = '';
								$bokMap = new Reservation_Model_ReservationDataMapper();
								$bokphrase = $bokMap->GetBookingPhraseByBookid($bokid);
								$book = new Reservation_Model_Reservation();
								$book->setbokid($bokid);
								$bookdetails = $bokMap->getBookingDetails($book);
								$rescountrycode = $bookdetails->getResCountrycode();							
								$resid = $bookdetails->getbokfk_restaurant();	
								
								if(isset($resid)){
									$row = $bokMap->GetRestaurantLogo($resid);
									if($row->reslogo){
										$logo = str_replace(" ","%20",$row->reslogo);
										$RestLogo = '<img src="http://www.dinedesk.com'.$logo.'" border="0"  height="60" align="left" />';
									}else{
										$RestLogo = '<img src="http://www.dinedesk.com/images/dinedesk-logo.png"  border="0" height="60"  align="left" usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2" />';
									}
								}else{
										$RestLogo = '<img src="http://www.dinedesk.com/images/dinedesk-logo.png"  border="0" height="60"  align="left" usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2" />';
								}
								if($data['DiscountMsg']){
									$DiscountMsg = '<tr>
														<td style="font-family:Helvetica,Arial,sans-serif;font-size:16px;line-height:23px;font-weight:bold;color:#00a651;padding-bottom:10px">Avail</td>
													</tr>
													<tr>
														<td align="left">
															<table cellpadding="0" cellspacing="0" border="0" width="450">
																	<tbody><tr>
																		<td align="left" style="font-family:Helvetica,Arial,sans-serif;font-size:12px;font-weight:bold;line-height:14px;color:#000;">'.$data['DiscountMsg'].'</td>
																	</tr>
																</tbody>
															</table>
														</td>
													</tr>
													<tr>
														<td align="left">
															<table cellpadding="0" cellspacing="0" border="0" width="450">
																	<tbody><tr>
																		<td height="20" align="left" style="font-size:0;line-height:0"><img src="http://www.dinedesk.com/images/email/spacer.gif" width="1" height="20" border="0" style="display:block" ></td>
																	</tr>
																	<tr>
																		<td height="1" bgcolor="#ececec" align="left" style="font-size:0;line-height:0"><img src="http://www.dinedesk.com/images/email/spacer.gif" width="1" height="1" border="0" style="display:block" ></td>
																	</tr>
																	<tr>
																		<td height="20" align="left" style="font-size:0;line-height:0"><img src="http://www.dinedesk.com/images/email/spacer.gif" width="1" height="20" border="0" style="display:block" ></td>
																	</tr>
																</tbody>
															</table>
														</td>
													</tr>';
								}else{
									$DiscountMsg = '';
								}
								$resphone = $rescountrycode.$data['resphone'];
								$state	  = $data['State_Id'];
								$city	  = $data['City_Id'];
								$resemail = $data['resemail'];
								$reszipcode = $data['reszipcode'];
								$rescity  = $data['rescity'];
								$resnbh   = $data['resnbh'];									
								$spldiv = '<div class="box-shadow"><div style="color:#F79646; font-weight:bold; text-align:center;">%splname%</div><br /><div style="color:#4f6228; font-weight:bold;">Special Id: %splid%</div><br /><br /><div style="color:#000048;">%spldesc%</div></div><br /><br />';									
								$userType = $data['UserType'];
								$div = '<td width="44%" valign="top" align="left">%img%</br><div>%desc%</div></td>';
										
								$imgDiv = '<div><img src="http://www.dinedesk.com%img%" width="150" height="150"/></div>';
								if(isset($data['campId'])){
									$campId  	= $data['campId'];
									$campname 	= $data['campaignName'];
									$desc  		= $data['campaignDesc'];
									$img 	  	= $data['campaignImg'];
									$desc  		= str_replace('src="','src="http://www.dinedesk.com',$desc);
									$display  	= 'block';
								}
								
								$notifcontdiv = '<div class="notificationcontent">%notifcont%</div><br/>';
								
								$subject = $template->msg_subject."-".$data['RestName'];
								$body    = $template->msg_body;
								
								$body    = str_replace("%firstname%",$name,$body);
								$body    = str_replace("%restname%",$restname,$body);
								$body    = str_replace("%date%",$resdate,$body);
								$body    = str_replace("%time%",$time,$body);
								$body    = str_replace("%size%",$size,$body);
								$body	 = str_replace("%address%",$address,$body);
								$body	 = str_replace("%resphone%",$resphone,$body);
								$body	 = str_replace("http://www.dinedesk.com","http://www.dinedesk.com",$body);
								$body	 = str_replace("%bokid%",$bokphrase,$body);
								$body    = str_replace("%resid%",$resid,$body);
								$body	 = str_replace("%bookingid%",$bokid,$body);
								$body	 = str_replace("%resnbh%",$resnbh,$body);
								$body	 = str_replace("%rescity%",$rescity,$body);
								$body	 = str_replace("%resemail%",$resemail,$body);
								$body	 = str_replace("%reszipcode%",$reszipcode,$body);	
								$body	 = str_replace("%reslogo%",$RestLogo,$body);
								$body	 = str_replace("%discountmsg%",$DiscountMsg,$body);	
								$body	 = str_replace("%email%",$data['SenTo'],$body);		
								$body	 = str_replace("%phone%",$cusphone,$body);
								$body	 = str_replace("%note%",$note,$body);													
								
								$body 	 = str_replace("�",'',$body);
								if(isset($data['campId'])){
									$body    = str_replace("none",$display,$body);
									$body    = str_replace("%desc%",$desc,$body);
									if($data['campaignImg']){
										$imgDiv 	= str_replace("%img%",$img,$imgDiv);
										$body    	= str_replace("%img%",$imgDiv,$body);
									}else{
										$body    = str_replace($imgDiv,'',$body);
									}
									$body    = str_replace("%campName%",$campname,$body);
								}else{
									$body    = str_replace($div,'',$body);
									$body    = str_replace("%campName%",'DineDesk',$body);
								}	
									$body	= str_replace($spldiv,'',$body); 
									$body	= str_replace($notifcontdiv,'',$body);
									
								$receiverslist = $data['SenTo'];
							    
								$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
								$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
								$priorMapper = new Application_Model_PriorityDataMapper();
								$prior = $priorMapper->GetPriorityByCode('H');
								$msgMapper = new Communication_Model_EmailMessageDataMapper();
								$message = new Communication_Model_EmailMessage();
								$msgPhrase = uniqid ();
								$message->setBokid($bokid)
										->setPhrase($msgPhrase)
										->setTitle($mailobj->getMsgCode())
										->setDescription($body)
										->setPriority($prior->getcode())
										->setEmailtype($emailType->getcode())
										->setUsertype($userType)
										->setSentby('admin@dinedesk.com');
								$msgid = $msgMapper->SaveMessageDetails($message);
								$src = "http://www.dinedesk.com/Communication/Communication/emailcommunication/msgid/".$msgPhrase;
								$body	 = str_replace("%bookingsrc%",$src,$body);
								if($userType == 'CUS'){
									$cusMapper = new Communication_Model_EmailCusRecipentsDataMapper();
									$cusResult = $cusMapper->SaveCustMailDetails($msgid,$state,$city,$userType,$campId,$receiverslist);
								}
								$ReceiversEmails = array();
								if($data['BookNotf']){
									$userType = 'RES';
									$ReceiversEmails = $data['RestEmails'];
									$msgPhrase = uniqid ();
									$message->setPhrase($msgPhrase)
											->setUsertype($userType);
									$msgid = $msgMapper->SaveMessageDetails($message);
									$src = "http://www.dinedesk.com/Communication/Communication/emailcommunication/msgid/".$msgPhrase;
									$body	 = str_replace("%bookingsrc%",$src,$body);
									if($userType == 'RES'){
										$cusMapper = new Communication_Model_EmailRestRecipentsDataMapper();
										$cusResult = $cusMapper->SaveRestMailDetails($msgid,$state,$city,$userType,$campId,$ReceiversEmails);
									}	
								}
								
								
								$ReceiversEmails[] = $receiverslist; 
								$request = array(
											'subject' => $template->msg_subject,
											'from'    => array( // required. A sender’s information
																'name'  => 'DineDesk',
																'email' => $fromaddress
														),
											'signing_domain'=>'dinedesk.com',
											'to' 			=> $ReceiversEmails,
											'html'    		=> $body, // email's HTML content
											'auto_plain' 	=> true,
                                                                                        'headers' => array(
                                                                                                    'reply-to' => $restemailstr,
                                                                                                ),
										);
								
								$retval = $LeaderSendApi->messagesSend($request);
								if($retval){
									foreach($retval as $value){
										if($LeaderSendApi->errorMessage || $value['status'] != 'sent'){
											$mail->setFrom($fromaddress, $fromname);
											$mail->setReplyTo($replyfromaddress,$replyfromname);
											$mail->addTo( $value['email'] ,$name);
											$mail->setSubject($subject);
											$mail->setBodyHtml($body);
											$status = $mail->send();
										}
									}
								}
							}
						}						
						break;
						
						case 'BookNotf' :
								
							if($language == "sp")
							{
								$mailobj->setMsgCode("BookNotf_Sp");
								$template = $this->GetMessageTemplate($mailobj);
							}else{
								$template = $this->GetMessageTemplate($mailobj);
							}
							
							if($template){
								$data     = $mailobj->getData();
								$bokMapper = new Reservation_Model_ReservationDataMapper();
								$resLoc = $bokMapper->getRestaurantLocByBookingId($data['Bookid']);
								if($resLoc->res_companyid == 22){
									$campId = "";
									$mailobj->setMsgCode("BookNotfHBC");
									$template = $this->GetMessageTemplate($mailobj);
									$receiverslist = $data['SenTo'];
									if(count($receiverslist) > 1){
										$ToArr =  $receiverslist;
									}else{
										$ToArr = $receiverslist[0];
									}
									
									$name     = $data['UserName'];
									$restname = $data['RestName'];
									$dateSplit = explode("-",$data['ResDate']);
									if(strlen($dateSplit[0]) > 2){
										$s = mktime(0,0,0,$dateSplit[1],$dateSplit[2],$dateSplit[0]);
										$resdate  = date('d M Y',$s);
									}else{
										$s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
										$resdate  = date('d M Y',$s);
									}
// 									$s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
// 									$resdate  = date('d M Y',$s);
									$time     = $data['Time'];
									$size     = $data['Size'];
									$address  = $data['Address'];
									$bookid	  = $data['Bookid'];
									$email    = $data['email'];
									$phone    = $data['phone'];
									$note     = $data['Note'];
									$state	  = $data['State_Id'];
									$city	  = $data['City_Id'];
									$userType = $data['UserType'];
									$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div>%img%</br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
									$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.dinedesk.com%img%" width="150" height="150"/>';
	//								$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div><div><a class="linkopacity" target="newwindow">%img%</a></div></br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
	//								$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.dinedesk.com%img%" width="150" height="150"/>';
									
									if(isset($data['campId'])){
										$campId   = $data['campId'];
										$campname 	= $data['campaignName'];
										$desc  = $data['campaignDesc'];
										$img = $data['campaignImg'];
										$desc  = str_replace('src="','src="http://www.dinedesk.com',$desc);
										$display  = 'block';
									}
								
									$bokMap = new Reservation_Model_ReservationDataMapper();
									$book = new Reservation_Model_Reservation();
									$book->setbokid($bookid);
									$bookdetails = $bokMap->getBookingDetails($book);
									$countrycode = $bookdetails->getbokcountry_code();
									$resid = $bookdetails->getbokfk_restaurant();
					//				$resid = $bokMap->getRestIdByBookId($bookid);
																	
									if(isset($resid)){
										$row = $bokMap->GetRestaurantLogo($resid);
										if($row->reslogo){
											$logo = str_replace(" ","%20",$row->reslogo);
											$RestLogo = '<img src="http://www.dinedesk.com'.$logo.'" border="0"  height="60" align="left" />';
										}else{
											$RestLogo = '<img src="http://www.dinedesk.com/images/dinedesk-logo.png"  border="0" height="60"  align="left" usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2" />';
										}
									}else{
										$RestLogo = '<img src="http://www.dinedesk.com/images/dinedesk-logo.png"  border="0" height="60" align="left" usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2" />';
									}
									
// 									if(isset($resid)){
// 										$row = $bokMap->GetRestaurantLogo($resid);
// 										if($row->reslogo){
// 											$logo = str_replace(" ","%20",$row->reslogo);
// 											$RestLogo = '<tr><td colspan="7" bgcolor="#e5e4de" height="12"></td></tr>
// 														 <tr>
// 														 	<td bgcolor="#e5e4de"></td>
// 														 	<td colspan="5" bgcolor="#FDF5E6" >
// 														 		<img src="http://www.dinedesk.com'.$logo.'"  border="0"  height="60" style="position:relative;left:12;"/>
// 														 	</td>
// 														 	<td bgcolor="#e5e4de"></td>
// 														 </tr>';
// 										}else{
// 											$RestLogo = '<tr><td colspan="7"><img src="http://www.dinedesk.com/images/dinedesk-logo.png"  border="0" height="60" usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2"></td></tr>';
// 										}
// 									}else{
// 											$RestLogo = '<tr><td colspan="7"><img src="http://www.dinedesk.com/images/dinedesk-logo.png"  border="0" height="60" usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2"></td></tr>';
// 									}
									
									$subject = $template->msg_subject;
									$body    = $template->msg_body;
									
									$body    = str_replace("%custname%",$name,$body);
									$body    = str_replace("%restname%",$restname,$body);
									$body    = str_replace("%date%",$resdate,$body);
									$body    = str_replace("%time%",$time,$body);
									$body    = str_replace("%size%",$size,$body);
									$body	 = str_replace("%address%",$address,$body);
									$body	 = str_replace("%bookid%",$bookid,$body);
									$body	 = str_replace("%email%",$email,$body);
									$body	 = str_replace("%phone%",$countrycode.$phone,$body);
									$body	 = str_replace("%note%",$note,$body);
									$body	 = str_replace("%reslogo%",$RestLogo,$body);
									
									$body 	 = str_replace("?",'',$body);
									$resService = new Application_Service_Reservation();
									$autoConf = $resService->GetAutoConfirmStatusByResid($bookdetails->getbokfk_restaurant());
									if(!$autoConf){
										$confUrl = 'http://hbcsolutions.net/Reservation/Reservation/updatereservationconfirmstatus/bokconfirmstatus/resvconfirm/src/mail/bookid/'.$bookid;
										$rejectUrl = 'http://hbcsolutions.net/Reservation/Reservation/updatereservationconfirmstatus/bokconfirmstatus/deny/src/mail/bookid/'.$bookid;
										$autoconfHtml = '<tr><td align="left" style="padding:10px;"><table cellpadding="0" cellspacing="1" border="0" width="90%">';
										$autoconfHtml .= '<tr><td align="left" bgcolor="#D6D1CC" style="padding:10px;">';
										$autoconfHtml .= '<a style="color:#db3743; text-decoration:none; font-weight:bold; font-size:12px;font-family:Helvetica,Arial,sans-serif;" href="'.$confUrl.'" target="newwindow" ><img src="http://www.hbcsolutions.net/images/icons/attending.gif" width="20" style="margin-right:5px;"/>Confirm Booking</a></td>';
										$autoconfHtml .= '<td></td><td align="left" bgcolor="#D6D1CC" style="padding:10px;">';
										$autoconfHtml .= '<a style="color:#db3743; text-decoration:none; font-weight:bold; font-size:12px;font-family:Helvetica,Arial,sans-serif;" href="'.$rejectUrl.'" target="newwindow" ><img src="http://www.hbcsolutions.net/images/icons/declined.gif" width="20" style="margin-right:5px;"/>Reject Booking</a>';
										$autoconfHtml .= '</td></tr></table></td></tr>';
										$body	 = str_replace("%autoconfirm%",$autoconfHtml,$body);
									}else{
										$body	 = str_replace("%autoconfirm%",'',$body);
									}
									
									
									if(isset($data['campId'])){
										$body    = str_replace("none",$display,$body);
										$body    = str_replace("%desc%",$desc,$body);
										if($data['campaignImg']){
											$imgDiv 	= str_replace("%img%",$img,$imgDiv);
											$body    	= str_replace("%img%",$imgDiv,$body);								
										}else{
											$body    = str_replace("%img%",'',$body);
										}
										$body    = str_replace("%campName%",$campname,$body);
									}else{
										$body    = str_replace($div,'',$body);
									}
									$receiverslist = $data['SenTo'];
								    
									$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
									$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
									$priorMapper = new Application_Model_PriorityDataMapper();
									$prior = $priorMapper->GetPriorityByCode('H');
									$msgMapper = new Communication_Model_EmailMessageDataMapper();
									$message = new Communication_Model_EmailMessage();
									$msgPhrase = uniqid ();
									$message->setBokid($bookid)
											->setPhrase($msgPhrase)
											->setTitle($mailobj->getMsgCode())
											->setDescription($body)
											->setPriority($prior->getcode())
											->setEmailtype($emailType->getcode())
											->setUsertype($userType)
											->setSentby('admin@dinedesk.com');
									$msgid = $msgMapper->SaveMessageDetails($message);
									$src = "http://www.dinedesk.com/Communication/Communication/emailcommunication/msgid/".$msgPhrase;
									$body	 = str_replace("%bookingsrc%",$src,$body);
									if($userType == 'RES'){
										$cusMapper = new Communication_Model_EmailRestRecipentsDataMapper();
										$cusResult = $cusMapper->SaveRestMailDetails($msgid,$state,$city,$userType,$campId,$receiverslist);
									}
									
									$fromname  = 'HBC Solutions';
									$fromaddress = 'info@hbcsolutions.net';
									$signing_domain ='hbcsolutions.net';
									$request = array(
												'subject' => $subject,
												'from'    => array( // required. A sender’s information
																	'name'  => $fromname,
																	'email' => $fromaddress
															),
												'signing_domain'=>$signing_domain,
												'to' => $receiverslist,
												'html'       => $body, // email's HTML content
												'auto_plain' => true // automatically generate a text part for the messages of HTML part
											);
									$retval = $LeaderSendApi->messagesSend($request);
									if($LeaderSendApi->errorMessage){
										$mail->setFrom($fromaddress, $fromname);
									    $mail->setReplyTo($fromaddress,$fromname);
									    $mail->addTo( $receiverslist,$name);
									    $mail->addBcc($ToArr);
									    $mail->setSubject($subject);
									    $mail->setBodyHtml($body);
									    $mail->send();
									}
                                                                }else if($resLoc->res_companyid == 25){
                                                                    				$campId = "";
									$mailobj->setMsgCode("BookNotfDWU");
									$template = $this->GetMessageTemplate($mailobj);
									$receiverslist = $data['SenTo'];
									if(count($receiverslist) > 1){
										$ToArr =  $receiverslist;
									}else{
										$ToArr = $receiverslist[0];
									}
									
									$name     = $data['UserName'];
									$restname = $data['RestName'];
									$dateSplit = explode("-",$data['ResDate']);
									if(strlen($dateSplit[0]) > 2){
										$s = mktime(0,0,0,$dateSplit[1],$dateSplit[2],$dateSplit[0]);
										$resdate  = date('d M Y',$s);
									}else{
										$s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
										$resdate  = date('d M Y',$s);
									}
// 									$s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
// 									$resdate  = date('d M Y',$s);
									$time     = $data['Time'];
									$size     = $data['Size'];
									$address  = $data['Address'];
									$bookid	  = $data['Bookid'];
									$email    = $data['email'];
									$phone    = $data['phone'];
									$note     = $data['Note'];
									$state	  = $data['State_Id'];
									$city	  = $data['City_Id'];
									$userType = $data['UserType'];
									$origin   = $data['Origin'];
									$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div>%img%</br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
									$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.dinedesk.com%img%" width="150" height="150"/>';
	//								$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div><div><a class="linkopacity" target="newwindow">%img%</a></div></br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
	//								$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.dinedesk.com%img%" width="150" height="150"/>';
									
									if(isset($data['campId'])){
										$campId   = $data['campId'];
										$campname 	= $data['campaignName'];
										$desc  = $data['campaignDesc'];
										$img = $data['campaignImg'];
										$desc  = str_replace('src="','src="http://www.dinedesk.com',$desc);
										$display  = 'block';
									}
								
									$bokMap = new Reservation_Model_ReservationDataMapper();
									$book = new Reservation_Model_Reservation();
									$book->setbokid($bookid);
									$bookdetails = $bokMap->getBookingDetails($book);
									$countrycode = $bookdetails->getbokcountry_code();
									$resid = $bookdetails->getbokfk_restaurant();
					//				$resid = $bokMap->getRestIdByBookId($bookid);
																	
									if(isset($resid)){
										$row = $bokMap->GetRestaurantLogo($resid);
										if($row->reslogo){
											$logo = str_replace(" ","%20",$row->reslogo);
											$RestLogo = '<img src="http://www.dinedesk.com'.$logo.'" border="0"  height="60" align="left" />';
										}else{
											$RestLogo = '<img src="http://www.dinedesk.com/images/dinedesk-logo.png"  border="0" height="60"  align="left" usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2" />';
										}
									}else{
										$RestLogo = '<img src="http://www.dinedesk.com/images/dinedesk-logo.png"  border="0" height="60" align="left" usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2" />';
									}
									
// 									if(isset($resid)){
// 										$row = $bokMap->GetRestaurantLogo($resid);
// 										if($row->reslogo){
// 											$logo = str_replace(" ","%20",$row->reslogo);
// 											$RestLogo = '<tr><td colspan="7" bgcolor="#e5e4de" height="12"></td></tr>
// 														 <tr>
// 														 	<td bgcolor="#e5e4de"></td>
// 														 	<td colspan="5" bgcolor="#FDF5E6" >
// 														 		<img src="http://www.dinedesk.com'.$logo.'"  border="0"  height="60" style="position:relative;left:12;"/>
// 														 	</td>
// 														 	<td bgcolor="#e5e4de"></td>
// 														 </tr>';
// 										}else{
// 											$RestLogo = '<tr><td colspan="7"><img src="http://www.dinedesk.com/images/dinedesk-logo.png"  border="0" height="60" usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2"></td></tr>';
// 										}
// 									}else{
// 											$RestLogo = '<tr><td colspan="7"><img src="http://www.dinedesk.com/images/dinedesk-logo.png"  border="0" height="60" usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2"></td></tr>';
// 									}
									
									$subject = $template->msg_subject;
									$body    = $template->msg_body;
									
									$body    = str_replace("%custname%",$name,$body);
									$body    = str_replace("%restname%",$restname,$body);
									$body    = str_replace("%date%",$resdate,$body);
									$body    = str_replace("%time%",$time,$body);
									$body    = str_replace("%size%",$size,$body);
									$body	 = str_replace("%address%",$address,$body);
									$body	 = str_replace("%bookid%",$bookid,$body);
									$body	 = str_replace("%email%",$email,$body);
									$body	 = str_replace("%phone%",$countrycode.$phone,$body);
									$body	 = str_replace("%note%",$note,$body);
                                                                        $body	 = str_replace("%origin%",$origin,$body);
									$body	 = str_replace("%reslogo%",$RestLogo,$body);
									
									$body 	 = str_replace("?",'',$body);
									$resService = new Application_Service_Reservation();
									$autoConf = $resService->GetAutoConfirmStatusByResid($bookdetails->getbokfk_restaurant());
									if(!$autoConf){
										$confUrl = 'http://www.dinedesk.com/Reservation/Reservation/updatereservationconfirmstatus/bokconfirmstatus/resvconfirm/src/mail/bookid/'.$bookid;
										$rejectUrl = 'http://www.dinedesk.com/Reservation/Reservation/updatereservationconfirmstatus/bokconfirmstatus/deny/src/mail/bookid/'.$bookid;
										$autoconfHtml = '<tr><td align="left" style="padding:10px;"><table cellpadding="0" cellspacing="1" border="0" width="90%">';
										$autoconfHtml .= '<tr><td align="left" bgcolor="#D6D1CC" style="padding:10px;">';
										$autoconfHtml .= '<a style="color:#db3743; text-decoration:none; font-weight:bold; font-size:12px;font-family:Helvetica,Arial,sans-serif;" href="'.$confUrl.'" target="newwindow" ><img src="http://app.diningwithus.net/images/icons/attending.gif" width="20" style="margin-right:5px;"/>Confirm Booking</a></td>';
										$autoconfHtml .= '<td></td><td align="left" bgcolor="#D6D1CC" style="padding:10px;">';
										$autoconfHtml .= '<a style="color:#db3743; text-decoration:none; font-weight:bold; font-size:12px;font-family:Helvetica,Arial,sans-serif;" href="'.$rejectUrl.'" target="newwindow" ><img src="http://app.diningwithus.net/images/icons/declined.gif" width="20" style="margin-right:5px;"/>Reject Booking</a>';
										$autoconfHtml .= '</td></tr></table></td></tr>';
										$body	 = str_replace("%autoconfirm%",$autoconfHtml,$body);
									}else{
										$body	 = str_replace("%autoconfirm%",'',$body);
									}
									
									
									if(isset($data['campId'])){
										$body    = str_replace("none",$display,$body);
										$body    = str_replace("%desc%",$desc,$body);
										if($data['campaignImg']){
											$imgDiv 	= str_replace("%img%",$img,$imgDiv);
											$body    	= str_replace("%img%",$imgDiv,$body);								
										}else{
											$body    = str_replace("%img%",'',$body);
										}
										$body    = str_replace("%campName%",$campname,$body);
									}else{
										$body    = str_replace($div,'',$body);
									}
									$receiverslist = $data['SenTo'];
								    
									$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
									$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
									$priorMapper = new Application_Model_PriorityDataMapper();
									$prior = $priorMapper->GetPriorityByCode('H');
									$msgMapper = new Communication_Model_EmailMessageDataMapper();
									$message = new Communication_Model_EmailMessage();
									$msgPhrase = uniqid ();
									$message->setBokid($bookid)
											->setPhrase($msgPhrase)
											->setTitle($mailobj->getMsgCode())
											->setDescription($body)
											->setPriority($prior->getcode())
											->setEmailtype($emailType->getcode())
											->setUsertype($userType)
											->setSentby('admin@dinedesk.com');
									$msgid = $msgMapper->SaveMessageDetails($message);
									$src = "http://www.dinedesk.com/Communication/Communication/emailcommunication/msgid/".$msgPhrase;
									$body	 = str_replace("%bookingsrc%",$src,$body);
									if($userType == 'RES'){
										$cusMapper = new Communication_Model_EmailRestRecipentsDataMapper();
										$cusResult = $cusMapper->SaveRestMailDetails($msgid,$state,$city,$userType,$campId,$receiverslist);
									}
									
									$fromname  = 'DiningWithUs';
									$fromaddress = 'admin@diningwithus.com';
									$signing_domain ='diningwithus.com';
									$request = array(
												'subject' => $subject,
												'from'    => array( // required. A sender’s information
																	'name'  => $fromname,
																	'email' => $fromaddress
															),
												'signing_domain'=>$signing_domain,
												'to' => $receiverslist,
												'html'       => $body, // email's HTML content
												'auto_plain' => true // automatically generate a text part for the messages of HTML part
											);
									$retval = $LeaderSendApi->messagesSend($request);
									if($LeaderSendApi->errorMessage){
										$mail->setFrom($fromaddress, $fromname);
									    $mail->setReplyTo($fromaddress,$fromname);
									    $mail->addTo( $receiverslist,$name);
									    $mail->addBcc($ToArr);
									    $mail->setSubject($subject);
									    $mail->setBodyHtml($body);
									    $mail->send();
									}
                                                                }
                                                                else if($resLoc->res_companyid != 6){
									$campId = "";
									$receiverslist = $data['SenTo'];
									if(count($receiverslist) > 1){
										$ToArr =  $receiverslist;
									}else{
										$ToArr = $receiverslist[0];
									}
									
									$name     = $data['UserName'];
									$restname = $data['RestName'];
									$dateSplit = explode("-",$data['ResDate']);
									if(strlen($dateSplit[0]) > 2){
										$s = mktime(0,0,0,$dateSplit[1],$dateSplit[2],$dateSplit[0]);
										$resdate  = date('d M Y',$s);
									}else{
										$s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
										$resdate  = date('d M Y',$s);
									}
// 									$s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
// 									$resdate  = date('d M Y',$s);
									$time     = $data['Time'];
									$size     = $data['Size'];
									$address  = $data['Address'];
									$bookid	  = $data['Bookid'];
									$email    = $data['email'];
									$phone    = $data['phone'];
									$note     = $data['Note'];
                                                                        $origin   = $data['Origin'];
									$state	  = $data['State_Id'];
									$city	  = $data['City_Id'];
									$userType = $data['UserType'];
									$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div>%img%</br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
									$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.dinedesk.com%img%" width="150" height="150"/>';
	//								$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div><div><a class="linkopacity" target="newwindow">%img%</a></div></br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
	//								$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.dinedesk.com%img%" width="150" height="150"/>';
									
									if(isset($data['campId'])){
										$campId   = $data['campId'];
										$campname 	= $data['campaignName'];
										$desc  = $data['campaignDesc'];
										$img = $data['campaignImg'];
										$desc  = str_replace('src="','src="http://www.dinedesk.com',$desc);
										$display  = 'block';
									}
								
									$bokMap = new Reservation_Model_ReservationDataMapper();
									$book = new Reservation_Model_Reservation();
									$book->setbokid($bookid);
									$bookdetails = $bokMap->getBookingDetails($book);
									$countrycode = $bookdetails->getbokcountry_code();
									$resid = $bookdetails->getbokfk_restaurant();
					//				$resid = $bokMap->getRestIdByBookId($bookid);
																	
									if(isset($resid)){
										$row = $bokMap->GetRestaurantLogo($resid);
										if($row->reslogo){
											$logo = str_replace(" ","%20",$row->reslogo);
											$RestLogo = '<img src="http://www.dinedesk.com'.$logo.'" border="0"  height="60" align="left" />';
										}else{
											$RestLogo = '<img src="http://www.dinedesk.com/images/dinedesk-logo.png"  border="0" height="60"  align="left" usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2" />';
										}
									}else{
										$RestLogo = '<img src="http://www.dinedesk.com/images/dinedesk-logo.png"  border="0" height="60" align="left" usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2" />';
									}
									
// 									if(isset($resid)){
// 										$row = $bokMap->GetRestaurantLogo($resid);
// 										if($row->reslogo){
// 											$logo = str_replace(" ","%20",$row->reslogo);
// 											$RestLogo = '<tr><td colspan="7" bgcolor="#e5e4de" height="12"></td></tr>
// 														 <tr>
// 														 	<td bgcolor="#e5e4de"></td>
// 														 	<td colspan="5" bgcolor="#FDF5E6" >
// 														 		<img src="http://www.dinedesk.com'.$logo.'"  border="0"  height="60" style="position:relative;left:12;"/>
// 														 	</td>
// 														 	<td bgcolor="#e5e4de"></td>
// 														 </tr>';
// 										}else{
// 											$RestLogo = '<tr><td colspan="7"><img src="http://www.dinedesk.com/images/dinedesk-logo.png"  border="0" height="60" usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2"></td></tr>';
// 										}
// 									}else{
// 											$RestLogo = '<tr><td colspan="7"><img src="http://www.dinedesk.com/images/dinedesk-logo.png"  border="0" height="60" usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2"></td></tr>';
// 									}
									
									$subject = $template->msg_subject;
									$body    = $template->msg_body;
									
									$body    = str_replace("%custname%",$name,$body);
									$body    = str_replace("%restname%",$restname,$body);
									$body    = str_replace("%date%",$resdate,$body);
									$body    = str_replace("%time%",$time,$body);
									$body    = str_replace("%size%",$size,$body);
									$body	 = str_replace("%address%",$address,$body);
									$body	 = str_replace("%bookid%",$bookid,$body);
									$body	 = str_replace("%email%",$email,$body);
									$body	 = str_replace("%phone%",$countrycode.$phone,$body);
									$body	 = str_replace("%note%",$note,$body);
                                                                        $body	 = str_replace("%origin%",$origin,$body);
									$body	 = str_replace("%reslogo%",$RestLogo,$body);
									
									$resService = new Application_Service_Reservation();
									$autoConf = $resService->GetAutoConfirmStatusByResid($bookdetails->getbokfk_restaurant());
									if(!$autoConf){
										$confUrl = 'http://www.dinedesk.com/Reservation/Reservation/updatereservationconfirmstatus/bokconfirmstatus/resvconfirm/src/mail/bookid/'.$bookid;
										$rejectUrl = 'http://www.dinedesk.com/Reservation/Reservation/updatereservationconfirmstatus/bokconfirmstatus/deny/src/mail/bookid/'.$bookid;
										$autoconfHtml = '<tr><td align="left" style="padding:10px;"><table cellpadding="0" cellspacing="1" border="0" width="90%">';
										$autoconfHtml .= '<tr><td align="left" bgcolor="#D6D1CC" style="padding:10px;">';
										$autoconfHtml .= '<a style="color:#db3743; text-decoration:none; font-weight:bold; font-size:12px;font-family:Helvetica,Arial,sans-serif;" href="'.$confUrl.'" target="newwindow" ><img src="http://www.hbcsolutions.net/images/icons/attending.gif" width="20" style="margin-right:5px;"/>Confirm Booking</a></td>';
										$autoconfHtml .= '<td></td><td align="left" bgcolor="#D6D1CC" style="padding:10px;">';
										$autoconfHtml .= '<a style="color:#db3743; text-decoration:none; font-weight:bold; font-size:12px;font-family:Helvetica,Arial,sans-serif;" href="'.$rejectUrl.'" target="newwindow" ><img src="http://www.hbcsolutions.net/images/icons/declined.gif" width="20" style="margin-right:5px;"/>Reject Booking</a>';
										$autoconfHtml .= '</td></tr></table></td></tr>';
										$body	 = str_replace("%autoconfirm%",$autoconfHtml,$body);
									}else{
										$body	 = str_replace("%autoconfirm%",'',$body);
									}
									
									$body 	 = str_replace("?",'',$body);
									
									if(isset($data['campId'])){
										$body    = str_replace("none",$display,$body);
										$body    = str_replace("%desc%",$desc,$body);
										if($data['campaignImg']){
											$imgDiv 	= str_replace("%img%",$img,$imgDiv);
											$body    	= str_replace("%img%",$imgDiv,$body);								
										}else{
											$body    = str_replace("%img%",'',$body);
										}
										$body    = str_replace("%campName%",$campname,$body);
									}else{
										$body    = str_replace($div,'',$body);
									}
									$receiverslist = $data['SenTo'];
								    
									$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
									$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
									$priorMapper = new Application_Model_PriorityDataMapper();
									$prior = $priorMapper->GetPriorityByCode('H');
									$msgMapper = new Communication_Model_EmailMessageDataMapper();
									$message = new Communication_Model_EmailMessage();
									$msgPhrase = uniqid ();
									$message->setBokid($bookid)
											->setPhrase($msgPhrase)
											->setTitle($mailobj->getMsgCode())
											->setDescription($body)
											->setPriority($prior->getcode())
											->setEmailtype($emailType->getcode())
											->setUsertype($userType)
											->setSentby('admin@dinedesk.com');
									$msgid = $msgMapper->SaveMessageDetails($message);
									$src = "http://www.dinedesk.com/Communication/Communication/emailcommunication/msgid/".$msgPhrase;
									$body	 = str_replace("%bookingsrc%",$src,$body);
									if($userType == 'RES'){
										$cusMapper = new Communication_Model_EmailRestRecipentsDataMapper();
										$cusResult = $cusMapper->SaveRestMailDetails($msgid,$state,$city,$userType,$campId,$receiverslist);
									}
									
									
									$request = array(
												'subject' => $subject,
												'from'    => array( // required. A sender’s information
																	'name'  => 'DineDesk',
																	'email' => $fromaddress
															),
												'signing_domain'=>'dinedesk.com',
												'to' => $receiverslist,
												'html'       => $body, // email's HTML content
												'auto_plain' => true // automatically generate a text part for the messages of HTML part
											);
									$retval = $LeaderSendApi->messagesSend($request);
									if($LeaderSendApi->errorMessage){
										$mail->setFrom($fromaddress, $fromname);
									    $mail->setReplyTo($fromaddress,$fromname);
									    $mail->addTo( $receiverslist,$name);
									    $mail->addBcc($ToArr);
									    $mail->setSubject($subject);
									    $mail->setBodyHtml($body);
									    $mail->send();
									}
								}
							}
						
						break;
	
					case 'BookNotCan' :
								
							if($language == "sp")
							{
								$mailobj->setMsgCode("BookNotCan_Sp");
								$template = $this->GetMessageTemplate($mailobj);
							}else{
								$template = $this->GetMessageTemplate($mailobj);
							}
							if($template){
								$data     = $mailobj->getData();
								$bokMapper = new Reservation_Model_ReservationDataMapper();
								$resLoc = $bokMapper->getRestaurantLocByBookingId($data['Bookid']);
								if($resLoc->res_companyid != 6 ){
									$campId = '';
	
									$receiverslist = $data['SenTo'];
									if(count($receiverslist) > 1){
										$ToArr =  $receiverslist;
									}else{
										$ToArr = $receiverslist[0];
									}
									
									$name     = $data['UserName'];
									$restname = $data['RestName'];
									$dateSplit = explode("-",$data['ResDate']);
									$s = mktime(0,0,0,$dateSplit[1],$dateSplit[2],$dateSplit[0]);
									$resdate  = date('d M Y',$s);
									$time     = $data['Time'];
									$size     = $data['Size'];
									$address  = $data['Address'];
									$bookid	  = $data['Bookid'];
									$email  = $data['email'];
									$phone  = $data['phone'];
									$state	  = $data['State_Id'];
									$city	  = $data['City_Id'];
									$userType = $data['UserType'];
									$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div>%img%</br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
									$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.dinedesk.com%img%" width="150" height="150"/>';
	//								$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div><div><a class="linkopacity" target="newwindow">%img%</a></div></br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
	//								$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.dinedesk.com%img%" width="150" height="150"/>';
									
									if(isset($data['campId'])){
										$campId   = $data['campId'];
										$campname 	= $data['campaignName'];
										$desc  = $data['campaignDesc'];
										$img = $data['campaignImg'];
										$desc  = str_replace('src="','src="http://www.dinedesk.com',$desc);
										$display  = 'block';
									}
									
									$bokMap = new Reservation_Model_ReservationDataMapper();
									$book = new Reservation_Model_Reservation();
									$book->setbokid($bookid);
									$bookdetails = $bokMap->getBookingDetails($book);
									$countrycode = $bookdetails->getbokcountry_code();
									$resid = $bookdetails->getbokfk_restaurant();							
									if(isset($resid)){
										$row = $bokMap->GetRestaurantLogo($resid);
										if($row->reslogo){
											$logo = str_replace(" ","%20",$row->reslogo);
											$RestLogo = '<tr><td colspan="7" bgcolor="#e5e4de" height="12"></td></tr>
														 <tr>
														 	<td bgcolor="#e5e4de"></td>
														 	<td colspan="5" bgcolor="#FDF5E6" >
														 		<img src="http://www.dinedesk.com'.$logo.'" border="0"  height="60" style="position:relative;left:12;"/>
														 	</td>
														 	<td bgcolor="#e5e4de"></td>
														 </tr>';
										}else{
											$RestLogo = '<tr><td colspan="7"><img src="http://www.dinedesk.com/images/dinedesk-logo.png"  border="0" height="60"  usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2"></td></tr>';
										}
									}else{
										$RestLogo = '<tr><td colspan="7"><img src="http://www.dinedesk.com/images/dinedesk-logo.png"  border="0" height="60"  usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2"></td></tr>';
									}
									$subject = $template->msg_subject;
									$body    = $template->msg_body;
									
									$body    = str_replace("%firstname%",$restname,$body);
									$body    = str_replace("%custname%",$name,$body);
									$body    = str_replace("%restname%",$restname,$body);
									$body    = str_replace("%date%",$resdate,$body);
									$body    = str_replace("%time%",$time,$body);
									$body    = str_replace("%size%",$size,$body);
									$body	 = str_replace("%address%",$address,$body);
									$body	 = str_replace("%bookingid%",$bookid,$body);
									$body	 = str_replace("%email%",$email,$body);
									$body	 = str_replace("%phone%",$countrycode.$phone,$body);
									$body	 = str_replace("%reslogo%",$RestLogo,$body);
									
									$body 	 = str_replace("�",'',$body);
									
									if(isset($data['campId'])){
										$body    = str_replace("none",$display,$body);
										$body    = str_replace("%desc%",$desc,$body);
										if($data['campaignImg']){
											$imgDiv 	= str_replace("%img%",$img,$imgDiv);
											$body    	= str_replace("%img%",$imgDiv,$body);								
										}else{
											$body    = str_replace("%img%",'',$body);
										}
										$body    = str_replace("%campName%",$campname,$body);
									}else{
										$body    = str_replace($div,'',$body);
									}
									$receiverslist = $data['SenTo'];
								    
									$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
									$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
									$priorMapper = new Application_Model_PriorityDataMapper();
									$prior = $priorMapper->GetPriorityByCode('H');
									$msgMapper = new Communication_Model_EmailMessageDataMapper();
									$message = new Communication_Model_EmailMessage();
									$msgPhrase = uniqid ();
									$message->setBokid($bookid)
											->setPhrase($msgPhrase)
											->setTitle($mailobj->getMsgCode())
											->setDescription($body)
											->setPriority($prior->getcode())
											->setEmailtype($emailType->getcode())
											->setUsertype($userType)
											->setSentby('admin@dinedesk.com');
									$msgid = $msgMapper->SaveMessageDetails($message);
									$src = "http://www.dinedesk.com/Communication/Communication/emailcommunication/msgid/".$msgPhrase;
									$body	 = str_replace("%bookingsrc%",$src,$body);
									if($userType == 'RES'){
										$cusMapper = new Communication_Model_EmailRestRecipentsDataMapper();
										$cusResult = $cusMapper->SaveRestMailDetails($msgid,$state,$city,$userType,$campId,$receiverslist);
									}
									
									$request = array(
												'subject' => $subject,
												'from'    => array( // required. A sender’s information
																	'name'  => 'DineDesk',
																	'email' => $fromaddress
															),
												'signing_domain'=>'dinedesk.com',
												'to' => $receiverslist,
												'html'       => $body, // email's HTML content
												'auto_plain' => true // automatically generate a text part for the messages of HTML part
											);
									$retval = $LeaderSendApi->messagesSend($request);
									if($LeaderSendApi->errorMessage){
										$mail->setFrom($fromaddress, $fromname);
									    $mail->setReplyTo($fromaddress,$fromname);
									    $mail->addTo( $receiverslist,$name);
									    $mail->setSubject($subject);
									    $mail->setBodyHtml($body);
									    $mail->send();
									}
								}
							}
						
						break;	
						
					case 'Success_Confirmation' :
						$template = $this->GetMessageTemplate($mailobj);
						
						if($template){
							$data    = $mailobj->getData();
							$name    = $data['UserName'];
							$resname = $data['resname'];
							$subject = $template->msg_subject;
							$body    = $template->msg_body;							
							$body    = str_replace("%firstname%",$name,$body);
							$body	 = str_replace("%Restaurant Name%",$resname,$body);
							$body 	 = str_replace("�",'',$body);
							$receiverslist = $data['SenTo'];
							
							
							$request = array(
										'subject' => $subject,
										'from'    => array( // required. A sender’s information
															'name'  => 'DineDesk',
															'email' => $fromaddress
													),
										'signing_domain'=>'dinedesk.com',
										'to' => array(
													array(
														'name' => $name,
														'email' => $receiverslist)
												),
										'html'       => $body, // email's HTML content
										'auto_plain' => true
									);
							$retval = $LeaderSendApi->messagesSend($request);
							if($LeaderSendApi->errorMessage){
								$mail->setFrom($fromaddress, $fromname);
							    $mail->setReplyTo($fromaddress,$fromname);
							    $mail->addTo( $receiverslist,$name);
							    $mail->setSubject($subject);
							    $mail->setBodyHtml($body);
							    $mail->send();
							}
						}
						break;
						
					case 'Restaurant_approved' :
						$template = $this->GetMessageTemplate($mailobj);
						
						if($template){
							$campId = '';
							$data    = $mailobj->getData();
							$name    = $data['UserName'];
							$resname = $data['resname'];
							$state	  = $data['State_Id'];
							$city	  = $data['City_Id'];
							$userType = $data['UserType'];
							$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div>%img%</br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
							$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.dinedesk.com%img%" width="150" height="150"/>';
//							$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div><div><a class="linkopacity" target="newwindow">%img%</a></div></br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
//							$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.dinedesk.com%img%" width="150" height="150"/>';
							
							if(isset($data['campId'])){
								$campId   = $data['campId'];
								$campname 	= $data['campaignName'];
								$desc  = $data['campaignDesc'];
								$img = $data['campaignImg'];
								$desc  = str_replace('src="','src="http://www.dinedesk.com',$desc);
								$display  = 'block';
							}
							
							$subject = $template->msg_subject;
							$body    = $template->msg_body;							
							$body    = str_replace("%firstname%",$name,$body);
							$body	 = str_replace("%Restaurant Name%",$resname,$body);
							$body 	 = str_replace("�",'',$body);
							
							if(isset($data['campId'])){
								$body    = str_replace("none",$display,$body);
								$body    = str_replace("%desc%",$desc,$body);
								if($data['campaignImg']){
									$imgDiv 	= str_replace("%img%",$img,$imgDiv);
									$body    	= str_replace("%img%",$imgDiv,$body);								
									}else{
										$body    = str_replace("%img%",'',$body);
								}
								$body    = str_replace("%campName%",$campname,$body);
							}else{
								$body    = str_replace($div,'',$body);
							}
							$receiverslist = $data['SenTo'];
						    
							$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
							$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
							$priorMapper = new Application_Model_PriorityDataMapper();
							$prior = $priorMapper->GetPriorityByCode('H');
							$msgMapper = new Communication_Model_EmailMessageDataMapper();
							$message = new Communication_Model_EmailMessage();
							$message->setTitle($mailobj->getMsgCode())
									->setDescription($body)
									->setPriority($prior->getcode())
									->setEmailtype($emailType->getcode())
									->setUsertype($userType)
									->setSentby('admin@dinedesk.com');
							$msgid = $msgMapper->SaveMessageDetails($message);
							if($userType == 'RES'){
								$cusMapper = new Communication_Model_EmailRestRecipentsDataMapper();
								$cusResult = $cusMapper->SaveRestMailDetails($msgid,$state,$city,$userType,$campId,$receiverslist);
							}
							
							$request = array(
										'subject' => $subject,
										'from'    => array( // required. A sender’s information
															'name'  => 'DineDesk',
															'email' => $fromaddress
													),
										'signing_domain'=>'dinedesk.com',
										'to' => array(
													array(
														'name' => $name,
														'email' => $receiverslist)
												),
										'html'       => $body, // email's HTML content
										'auto_plain' => true // automatically generate a text part for the messages of HTML part
									);
							$retval = $LeaderSendApi->messagesSend($request);
							if($LeaderSendApi->errorMessage){
								$mail->setFrom($fromaddress, $fromname);
							    $mail->setReplyTo($fromaddress,$fromname);
							    $mail->addTo( $receiverslist,$name);
							    $mail->setSubject($subject);
							    $mail->setBodyHtml($body);
							    $mail->send();
							}
						}
						break;
						
					case 'WalBookConf' :
						$template = $this->GetMessageTemplate($mailobj);
						$campId = '';
						$data     = $mailobj->getData();
						$bokMapper = new Reservation_Model_ReservationDataMapper();
						$resLoc = $bokMapper->getRestaurantLocByBookingId($data['Bokid']);
						if($resLoc->res_companyid != 6 ){
							$name     = $data['UserName'];
							$restname = $data['RestName'];
							$dateSplit = explode("-",$data['ResDate']);
							$s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
							$resdate  = date('d M Y',$s);
							$time     = $data['Time'];
							$size     = $data['Size'];
							$address  = $data['Address'];
							$resphone = $data['resphone'];
							$status	  = $data['Status'];
							$state	  = $data['State_Id'];
							$city	  = $data['City_Id'];
							$userType = $data['UserType'];
							$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div>%img%</br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
							$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.dinedesk.com%img%" width="150" height="150"/>';
								
	//						$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div><div><a class="linkopacity" target="newwindow">%img%</a></div></br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
	//						$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.dinedesk.com%img%" width="150" height="150"/>';
							
							if(isset($data['campId'])){
								$campId   = $data['campId'];
								$campname 	= $data['campaignName'];
								$desc  = $data['campaignDesc'];
								$img  = $data['campaignImg'];
								$desc  = str_replace('src="','src="http://www.dinedesk.com',$desc);
								$display  = 'block';
							}
							$receiverslist = $data['SenTo'];
							
							$subject = $template->msg_subject;
							$body    = $template->msg_body;
							
							$body    = str_replace("%firstname%",$name,$body);
							$body    = str_replace("%restname%",$restname,$body);
							$body    = str_replace("%date%",$resdate,$body);
							$body    = str_replace("%time%",$time,$body);
							$body    = str_replace("%size%",$size,$body);
							$body	 = str_replace("%address%",$address,$body);
							$body	 = str_replace("%resphone%",$resphone,$body);
							$body 	 = str_replace("�",'',$body);
							
							if(isset($data['campId'])){
								$body    = str_replace("none",$display,$body);
								$body    = str_replace("%desc%",$desc,$body);
								if($data['campaignImg']){
									$imgDiv 	= str_replace("%img%",$img,$imgDiv);
									$body    	= str_replace("%img%",$imgDiv,$body);								
								}else{
									$body    = str_replace("%img%",'',$body);
								}
								$body    = str_replace("%campName%",$campname,$body);
							}else{
									$body    = str_replace($div,'',$body);
								}
							$receiverslist = $data['SenTo'];
						    
							$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
							$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
							$priorMapper = new Application_Model_PriorityDataMapper();
							$prior = $priorMapper->GetPriorityByCode('H');
							$msgMapper = new Communication_Model_EmailMessageDataMapper();
							$message = new Communication_Model_EmailMessage();
							$message->setTitle($mailobj->getMsgCode())
									->setDescription($body)
									->setPriority($prior->getcode())
									->setEmailtype($emailType->getcode())
									->setUsertype($userType)
									->setSentby('admin@dinedesk.com');
							$msgid = $msgMapper->SaveMessageDetails($message);
							if($userType == 'CUS'){
								$cusMapper = new Communication_Model_EmailCusRecipentsDataMapper();
								$cusResult = $cusMapper->SaveCustMailDetails($msgid,$state,$city,$userType,$campId,$receiverslist);
							}
							
							$request = array(
										'subject' => $subject,
										'from'    => array( // required. A sender’s information
															'name'  => 'DineDesk',
															'email' => $fromaddress
													),
										'signing_domain'=>'dinedesk.com',
										'to' => array(
													array(
														'name' => $name,
														'email' => $receiverslist)
												),
										'html'       => $body, // email's HTML content
										'auto_plain' => true // automatically generate a text part for the messages of HTML part
									);
							$retval = $LeaderSendApi->messagesSend($request);
							if($LeaderSendApi->errorMessage){
								$mail->setFrom($fromaddress, $fromname);
							    $mail->setReplyTo($fromaddress,$fromname);
							    $mail->addTo( $receiverslist,$name);
							    $mail->setSubject($subject);
							    $mail->setBodyHtml($body);
							    $mail->send();
							}
						}
						break;
						
					case 'WaltoRsdBookConf' :
						$template = $this->GetMessageTemplate($mailobj);
						
						$data     = $mailobj->getData();
						$bokMapper = new Reservation_Model_ReservationDataMapper();
						$resLoc = $bokMapper->getRestaurantLocByBookingId($data['Bookid']);
						if($resLoc->res_companyid != 6 ){
							$name     = $data['UserName'];
							$restname = $data['RestName'];
							$dateSplit = explode("-",$data['ResDate']);
							$s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
							$resdate  = date('d M Y',$s);
							$time     = $data['Time'];
							$size     = $data['Size'];
							$address  = $data['Address'];
							$status	  = $data['Status'];
							
							$subject = $template->msg_subject;
							$body    = $template->msg_body;
							
							$body    = str_replace("%firstname%",$name,$body);
							$body    = str_replace("%restname%",$restname,$body);
							$body    = str_replace("%date%",$resdate,$body);
							$body    = str_replace("%time%",$time,$body);
							$body    = str_replace("%size%",$size,$body);
							$body	 = str_replace("%address%",$address,$body);
							$body 	 = str_replace("�",'',$body);
							$receiverslist = $data['SenTo'];
							
							$request = array(
										'subject' => $subject,
										'from'    => array( // required. A sender’s information
															'name'  => 'DineDesk',
															'email' => $fromaddress
													),
										'signing_domain'=>'dinedesk.com',
										'to' => array(
													array(
														'name' => $name,
														'email' => $receiverslist)
												),
										'html'       => $body, // email's HTML content
										'auto_plain' => true // automatically generate a text part for the messages of HTML part
									);
							$retval = $LeaderSendApi->messagesSend($request);
							if($LeaderSendApi->errorMessage){
								$mail->setFrom($fromaddress, $fromname);
							    $mail->setReplyTo($fromaddress,$fromname);
							    $mail->addTo( $receiverslist,$name);
							    $mail->setSubject($subject);
							    $mail->setBodyHtml($body);
		//					    $mail->send();	
							}
						}
						break;	
					case 'Restaurant_Creation_Conf' :
						$template = $this->GetMessageTemplate($mailobj);
						
						if($template){
							$data    = $mailobj->getData();
							$name    = $data['UserName'];
							$resname = $data['resname'];
							$subject = $template->msg_subject;
							$body    = $template->msg_body;							
							$body    = str_replace("%firstname%",$name,$body);
							$body	 = str_replace("%Restaurant Name%",$resname,$body);
							$body 	 = str_replace("�",'',$body);
							$receiverslist = $data['SenTo'];
							
							
							$request = array(
										'subject' => $subject,
										'from'    => array( // required. A sender’s information
															'name'  => 'DineDesk',
															'email' => $fromaddress
													),
										'signing_domain'=>'dinedesk.com',
										'to' => array(
													array(
														'name' => $name,
														'email' => $receiverslist)
												),
										'html'       => $body, // email's HTML content
										'auto_plain' => true // automatically generate a text part for the messages of HTML part
									);
							$retval = $LeaderSendApi->messagesSend($request);
							if($LeaderSendApi->errorMessage){							
								$mail->setFrom($fromaddress, $fromname);
							    $mail->setReplyTo($fromaddress,$fromname);
							    $mail->addTo( $receiverslist,$name);
							    $mail->setSubject($subject);
							    $mail->setBodyHtml($body);
							    $mail->send();
							}						  	
						}
						
						break;
						
					case 'Invoice' :
						
						if($language == "sp")
						{
							$mailobj->setMsgCode("Invoice_Sp");
							$template = $this->GetMessageTemplate($mailobj);
						}else{
							$template = $this->GetMessageTemplate($mailobj);
						}
						
						if($template){
							$data    	= $mailobj->getData();
							$name    	= $data['UserName'];
							$subject 	= $data['subject'];
							$body    	= $template->msg_body;							
							$body    	= str_replace("%firstname%",$name,$body);
							$body 	 	= str_replace("�",'',$body);
							$receiverslist = $data['SenTo'];
							
							
							$mail->setFrom($fromaddress, $fromname);
						    $mail->setReplyTo($fromaddress,$fromname);
						    $mail->addTo( $receiverslist,$name);
						    $mail->setSubject($subject);
						    $mail->setBodyHtml($body);
						    
						    $fileContents = file_get_contents($data['path']);
							$at = $mail->createAttachment($fileContents);
							$at->type = Zend_Mime::TYPE_OCTETSTREAM;
							$at->disposition = Zend_Mime::DISPOSITION_INLINE;
							$at->encoding = Zend_Mime::ENCODING_BASE64;
							$at->filename = 'invoice- '.date('Y-m-d').'.pdf';
							
//						    $mail->send();
						}
						break;
						
					case 'PostInvoice' :
						
						$template = $this->GetMessageTemplate($mailobj);
						
						if($template){
							$data    	= $mailobj->getData();
							$name    	= $data['UserName'];
							$subject 	= $data['subject'];
							$body    	= $template->msg_body;							
							$body    	= str_replace("%firstname%",$name,$body);
							$body 	 	= str_replace("�",'',$body);
							$receiverslist = $data['SenTo'];
							
								
							$mail->setFrom($fromaddress, $fromname);
						    $mail->setReplyTo($fromaddress,$fromname);
						    $mail->addTo( $receiverslist,$name);
						    $mail->setSubject($subject);
						    $mail->setBodyHtml($body);
						    
						    $fileContents = file_get_contents($data['path']);
							$at = $mail->createAttachment($fileContents);
							$at->type = Zend_Mime::TYPE_OCTETSTREAM;
							$at->disposition = Zend_Mime::DISPOSITION_INLINE;
							$at->encoding = Zend_Mime::ENCODING_BASE64;
							$at->filename = 'invoice- '.date('Y-m-d').'.pdf';
							
//						    $mail->send();
						}
						break;						
					case 'Reservation_Invoice' :
						$template = $this->GetMessageTemplate($mailobj);
						
						if($template){
							$data    	= $mailobj->getData();
							$name    	= $data['UserName'];
							$subject 	= $data['subject'];
							$body    	= $template->msg_body;							
							$body    	= str_replace("%firstname%",$name,$body);
							$body 	 	= str_replace("�",'',$body);
							$receiverslist = $data['SenTo'];
							
							
							$mail->setFrom($fromaddress, $fromname);
						    $mail->setReplyTo($fromaddress,$fromname);
						    $mail->addTo( $receiverslist,$name);
						    $mail->setSubject($subject);
						    $mail->setBodyHtml($body);
						    
						    $fileContents = file_get_contents($data['path']);
							$at = $mail->createAttachment($fileContents);
							$at->type = Zend_Mime::TYPE_OCTETSTREAM;
							$at->disposition = Zend_Mime::DISPOSITION_INLINE;
							$at->encoding = Zend_Mime::ENCODING_BASE64;
							$at->filename = 'reservation_invoice- '.date('Y-m-d').'.pdf';
							
//						    $mail->send();
						}
						break;	
					case 'Special_Booking_Conf':
						$template = $this->GetMessageTemplate($mailobj);
						if($template){
							$data     = $mailobj->getData();
							$campId = "";
							$bokMapper = new Reservation_Model_ReservationDataMapper();
							$resLoc = $bokMapper->getRestaurantLocByBookingId($data['Bokid']);
							if($resLoc->res_companyid != 6 ){
								$name     = $data['UserName'];
								$restname = $data['RestName'];
								$dateSplit = explode("-",$data['ResDate']);
								$s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
								$resdate  = date('d M Y',$s);
								$time     = $data['Time'];
								$size     = $data['Size'];
								$address  = $data['Address'];
								$resphone = $data['resphone'];
								$status	  = $data['Status'];
								$bokid    = $data['Bokid'];
								$bokphrase = '';
								$bokMap = new Reservation_Model_ReservationDataMapper();
								$bokphrase = $bokMap->GetBookingPhraseByBookid($bokid);
								$resid = $bokMap->getRestIdByBookId($bokid);
								$state	  = $data['State_Id'];
								$city	  = $data['City_Id'];
								$resemail = $data['resemail'];
								$reszipcode = $data['reszipcode'];
								$rescity  = $data['rescity'];
								$resnbh   = $data['resnbh'];
								
	//							$spldiv = '<div style="background: #f1ede8;box-shadow: 5px 5px 30px #808080;-moz-box-shadow: 5px 5px 30px #808080;-khtml-box-shadow: 5px 5px 30px #808080;-webkit-box-shadow: 5px 5px 30px #808080;border:3px solid #643513; padding:8px; font-size:12px;"><div style="color:#F79646; font-weight:bold; text-align:center;">%splname%</div><br /><div style="color:#4f6228; font-weight:bold;">Special Id: %splid%</div><br /><br /><div style="color:#000048;">%spldesc%</div></div><br /><br />';
								$spldiv = '<div class="box-shadow"><div style="color:#F79646; font-weight:bold; text-align:center;">%splname%</div><br /><div style="color:#4f6228; font-weight:bold;">Special Id: %splid%</div><br /><br /><div style="color:#000048;">%spldesc%</div></div><br /><br />';
								if($data['splstatus']){
									$splid		= $data['splid']; 
									$splname 	= $data['splname'];
									$spldesc	= $data['spldesc'];
	//								$splorgprice= $data['splorgprice'];
	//								$spldiscount= $data['spldiscount'];
	//								$splprice	= $data['splprice'];
								}
								
								$userType = $data['UserType'];
								$div = '<td width="44%" valign="top" align="left">%img%</br><div>%desc%</div></td>';
								$imgDiv = '<div><img src="http://www.dinedesk.com%img%" width="150" height="150"/></div>';
								if(isset($data['campId'])){
									$campId  	= $data['campId'];
									$campname 	= $data['campaignName'];
									$desc  		= $data['campaignDesc'];
									$img 	  	= $data['campaignImg'];
									$desc  		= str_replace('src="','src="http://www.dinedesk.com',$desc);
									$display  	= 'block';
								}
	
						
								$subject = $template->msg_subject;
								$body    = $template->msg_body;
								
								$body    = str_replace("%firstname%",$name,$body);
								$body    = str_replace("%restname%",$restname,$body);
								$body    = str_replace("%date%",$resdate,$body);
								$body    = str_replace("%time%",$time,$body);
								$body    = str_replace("%size%",$size,$body);
								$body	 = str_replace("%address%",$address,$body);
								$body	 = str_replace("%resphone%",$resphone,$body);
								$body	 = str_replace("%bokid%",$bokphrase,$body);
								$body	 = str_replace("http://www.dinedesk.com","http://www.dinedesk.com",$body);
								$body    = str_replace("%resid%",$resid,$body);
								$body	 = str_replace("%bookingid%",$bokid,$body);
								$body	 = str_replace("%resnbh%",$resnbh,$body);
								$body	 = str_replace("%rescity%",$rescity,$body);
								$body	 = str_replace("%resemail%",$resemail,$body);
								$body	 = str_replace("%reszipcode%",$reszipcode,$body);							
								
								$body 	 = str_replace("�",'',$body);
								if(isset($data['campId'])){
									$body    = str_replace("none",$display,$body);
									$body    = str_replace("%desc%",$desc,$body);
									if($data['campaignImg']){
										$imgDiv 	= str_replace("%img%",$img,$imgDiv);
										$body    	= str_replace("%img%",$imgDiv,$body);
									}else{
										$body    = str_replace($imgDiv,'',$body);
									}
									$body    = str_replace("%campName%",$campname,$body);
								}else{
									$body    = str_replace($div,'',$body);
									$body    = str_replace("%campName%",'DineDesk',$body);
								}
								if($data['splstatus']){
									$body	= str_replace("%splname%",$splname,$body);
									$body	= str_replace("%splid%",$splid,$body);
	//								$body	= str_replace("%orgprice%",$splorgprice,$body);
	//								$body	= str_replace("%discount%",$spldiscount,$body);
	//								$body	= str_replace("%price%",$splprice,$body);
									$body	= str_replace("%spldesc%",$spldesc,$body);
								}else{
									$body	= str_replace($spldiv,'',$body);
								}
								
								$receiverslist = $data['SenTo'];
							    
								$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
								$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
								$priorMapper = new Application_Model_PriorityDataMapper();
								$prior = $priorMapper->GetPriorityByCode('H');
								$msgMapper = new Communication_Model_EmailMessageDataMapper();
								$message = new Communication_Model_EmailMessage();
								$message->setTitle($mailobj->getMsgCode())
										->setDescription($body)
										->setPriority($prior->getcode())
										->setEmailtype($emailType->getcode())
										->setUsertype($userType)
										->setSentby('admin@dinedesk.com');
								$msgid = $msgMapper->SaveMessageDetails($message);
								if($userType == 'CUS'){
									$cusMapper = new Communication_Model_EmailCusRecipentsDataMapper();
									$cusResult = $cusMapper->SaveCustMailDetails($msgid,$state,$city,$userType,$campId,$receiverslist);
								}
							    
								$mail->setFrom($fromaddress, $fromname);
							    $mail->setReplyTo($fromaddress,$fromname);
							    $mail->addTo( $receiverslist,$name);
							    $mail->setSubject($subject);
							    $mail->setBodyHtml($body);
							     $fileContents = file_get_contents($data['path']);
								$at = $mail->createAttachment($fileContents);
								$at->type = Zend_Mime::TYPE_OCTETSTREAM;
								$at->disposition = Zend_Mime::DISPOSITION_INLINE;
								$at->encoding = Zend_Mime::ENCODING_BASE64;
								$at->filename = 'reservation_invoice- '.date('Y-m-d').'.pdf';
	//						    $status = $mail->send();
							}
						}
					break;
					case 'Declined trnsaction' :
						
						$template = $this->GetMessageTemplate($mailobj);
						
						if($template){
							$data    	= $mailobj->getData();
							$name    	= $data['UserName'];
							$subject = $template->msg_subject;
							$body    = $template->msg_body;							
							$body    	= str_replace("%firstname%",$name,$body);
							$body 	 	= str_replace("�",'',$body);
							$receiverslist = $data['SenTo'];
							
							
							$mail->setFrom($fromaddress, $fromname);
						    $mail->setReplyTo($fromaddress,$fromname);
						    $mail->addTo( $receiverslist,$name);
						    $mail->setSubject($subject);
						    $mail->setBodyHtml($body);
						    $mail->send();
						}
						
						break;
						
					case 'Restaurant_Floor_Remainder' :
						$template = $this->GetMessageTemplate($mailobj);
						
						if($template){
							$data    = $mailobj->getData();
							$name    = $data['UserName'];
							$resname = $data['resname'];
							$subject = $template->msg_subject;
							$body    = $template->msg_body;							
							$body    = str_replace("%firstname%",$name,$body);
							$body	 = str_replace("%Restaurant Name%",$resname,$body);
							$body 	 = str_replace("�",'',$body);
							$receiverslist = $data['SenTo'];
							
							
							$mail->setFrom($fromaddress, $fromname);
						    $mail->setReplyTo($fromaddress,$fromname);
						    $mail->addTo( $receiverslist,$name);
						    $mail->setSubject($subject);
						    $mail->setBodyHtml($body);
					    	$mail->send();
						}
						
						
						break;
					case 'Restaurant_Schedule_Remainder' :
						$template = $this->GetMessageTemplate($mailobj);
						
						if($template){
							$data    = $mailobj->getData();
							$name    = $data['UserName'];
							$resname = $data['resname'];
							$subject = $template->msg_subject;
							$body    = $template->msg_body;							
							$body    = str_replace("%firstname%",$name,$body);
							$body	 = str_replace("%Restaurant Name%",$resname,$body);
							$body 	 = str_replace("�",'',$body);
							$receiverslist = $data['SenTo'];
							
							
							$mail->setFrom($fromaddress, $fromname);
						    $mail->setReplyTo($fromaddress,$fromname);
						    $mail->addTo( $receiverslist,$name);
						    $mail->setSubject($subject);
						    $mail->setBodyHtml($body);
						    $mail->send();
						}
						break;
						
					case 'ForgotPwd' :
						
						$domain = "dinedesk.com";
						if($_SERVER['SERVER_NAME'] == 'hbcsolutions.net' || $_SERVER['SERVER_NAME'] == 'www.hbcsolutions.net'){
							Uss_Logger_FileLogger::info('fprgotpwdhbc');
							$mailobj->setMsgCode("ForgotPwdHBC");
							$template = $this->GetMessageTemplate($mailobj);
							$domain = "hbcsolutions.net";
							$fromname  = 'HBC Solutions';
							$fromaddress = 'info@hbcsolutions.net';
						}else if($language == "sp")
						{
							$mailobj->setMsgCode("ForgotPwd_Sp");
							$template = $this->GetMessageTemplate($mailobj);
						}else{
							$template = $this->GetMessageTemplate($mailobj);
						}
						
						if($template){
							
							$data    = $mailobj->getData();
							$name    = $data['UserName'];
							$password = $data['password'];
							$subject = $template->msg_subject;
							$body    = $template->msg_body;							
							$body    = str_replace("%firstname%",$name,$body);
							$body	 = str_replace("%PassWord%",$password,$body);
							$body 	 = str_replace("�",'',$body);
							$receiverslist = $data['SenTo'];
							
							
							$request = array(
										'subject' => $subject,
										'from'    => array( // required. A sender’s information
															'name'  => $fromname,
															'email' => $fromaddress
													),
										'signing_domain'=>$domain,
										'to' => array(
													array(
														'name' => $name,
														'email' => $receiverslist)
												),
										'html'       => $body, // email's HTML content
										'auto_plain' => true // automatically generate a text part for the messages of HTML part
									);
							$retval = $LeaderSendApi->messagesSend($request);
							if($LeaderSendApi->errorMessage){
								$mail->setFrom($fromaddress, $fromname);
							    $mail->setReplyTo($fromaddress,$fromname);
							    $mail->addTo( $receiverslist,$name);
							    $mail->setSubject($subject);
							    $mail->setBodyHtml($body);
							    $mail->send();
							}
						}
						$status = 'success';
						return $status;
						break;
	
					case 'Cancel' :
						$data     = $mailobj->getData();
						$bokMapper = new Reservation_Model_ReservationDataMapper();
						$resLoc = $bokMapper->getRestaurantLocByBookingId($data['BookId']);
						$domain = "dinedesk.com";
						if($resLoc->res_companyid == 22){
							$mailobj->setMsgCode("CancelHBC");
							$template = $this->GetMessageTemplate($mailobj);
							$fromname  = 'HBC Solutions';
							$fromaddress = 'info@hbcsolutions.net';
							$signing_domain ='hbcsolutions.net';
                                                }else if($resLoc->res_companyid == 25){
                                                        $mailobj->setMsgCode("CancelDWU");
							$template = $this->GetMessageTemplate($mailobj);
							$fromname  = 'DiningWithUs';
							$fromaddress = 'admin@diningwithus.com';
							$signing_domain ='diningwithus.com';
                                                }
                                                else if($language == "sp")
						{
							$mailobj->setMsgCode("Cancel_Sp");
							$template = $this->GetMessageTemplate($mailobj);
						}else{
							$template = $this->GetMessageTemplate($mailobj);
						}
						$campId = '';
						
						$bokMapper = new Reservation_Model_ReservationDataMapper();
						if($resLoc->res_companyid != 6 ){
							$splitbookdate = explode('-',$data['ResDate']);
							$name     = $data['UserName'];
							$restname = $data['RestName'];
							$resdate  = date('d M Y',mktime(0,0,0,$splitbookdate[1],$splitbookdate[2],$splitbookdate[0]));;
							$time     = $data['Time'];
							$size     = $data['Size'];
							$address  = $data['Address'];
							$status	  = $data['Status'];
							$state	  = $data['State_Id'];
							$city	  = $data['City_Id'];
							$resphone = $data['resphone'];
							$userType = $data['UserType'];
							$bokid    = $data['BookId'];
							$resemail = $data['resemail'];
							$cusphone = $data['phone'];
							$bokphrase = '';
							$bokMap = new Reservation_Model_ReservationDataMapper();
							$bokphrase = $bokMap->GetBookingPhraseByBookid($bokid);
							$book = new Reservation_Model_Reservation();
							$book->setbokid($bokid);
							$bookdetails = $bokMap->getBookingDetails($book);
							$rescountrycode = $bookdetails->getResCountrycode();							
							$resid = $bookdetails->getbokfk_restaurant();							
							if(isset($resid)){
								$row = $bokMap->GetRestaurantLogo($resid);
								if($row->reslogo){
									$logo = str_replace(" ","%20",$row->reslogo);
									$RestLogo = '<img src="http://www.dinedesk.com'.$logo.'" border="0"  height="60" align="left" style="position:relative;left:12;"/>';
								}else{
									if($resLoc->res_companyid == 22){
										$RestLogo = '<img src="http://www.dinedesk.com/images/hbc-logo.png"  border="0" align="left" height="60"  usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2">';
									}else{
										$RestLogo = '<img src="http://www.dinedesk.com/images/dinedesk-logo.png"  border="0" align="left" height="60"  usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2">';
									}
                                                                        if($resLoc->res_companyid == 25){
										$RestLogo = '<img src="http://www.dinedesk.com/images/diningwithuslogo.png"  border="0" align="left" height="60"  usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2">';
									}else{
										$RestLogo = '<img src="http://www.dinedesk.com/images/dinedesk-logo.png"  border="0" align="left" height="60"  usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2">';
									}
								}
							}else{
								if($resLoc->res_companyid == 22){
									$RestLogo = '<img src="http://www.dinedesk.com/images/hbc-logo.png"  border="0" height="60" align="left" usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2">';
								}else{
									$RestLogo = '<img src="http://www.dinedesk.com/images/dinedesk-logo.png"  border="0" height="60" align="left" usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2">';
								}
                                                                if($resLoc->res_companyid == 25){
									$RestLogo = '<img src="http://www.dinedesk.com/images/diningwithuslogo.png"  border="0" height="60" align="left" usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2">';
								}else{
									$RestLogo = '<img src="http://www.dinedesk.com/images/dinedesk-logo.png"  border="0" height="60" align="left" usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2">';
								}
							}
							$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" style="background: #dddddd;border:5px solid #ccc;box-shadow: 3px 3px 1px #eeeeee;-moz-box-shadow: 6px 7px 1px #eeeeee;-webkit-box-shadow: 3px 3px 1px #eeeeee;-khtml-box-shadow: 3px 3px 1px #eeeeee;border-radius:6px;-moz-border-radius:6px;-khtml-border-radius:6px;-webkit-border-radius:6px;padding:5px;displaylock;font-family:Arial, Helvetica, sans-serif;width:auto;"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div>%img%</br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
							$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.dinedesk.com%img%" width="150" height="150"/>';
							
	//						$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div><div><a class="linkopacity" target="newwindow">%img%</a></div></br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
	//						$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.dinedesk.com%img%" width="150" height="150"/>';
							
							if(isset($data['campId'])){
								$campId   = $data['campId'];
								$campname 	= $data['campaignName'];
								$desc  = $data['campaignDesc'];
								$img  = $data['campaignImg'];
								$desc  = str_replace('src="','src="http://www.dinedesk.com',$desc);
								$display  = 'block';
							}
							
							$subject = $template->msg_subject."-".$data['RestName'];
							$body    = $template->msg_body;
							
							$body    = str_replace("%firstname%",$name,$body);
							$body    = str_replace("%restname%",$restname,$body);
							$body    = str_replace("%date%",$resdate,$body);
							$body    = str_replace("%time%",$time,$body);
							$body    = str_replace("%size%",$size,$body);
							$body	 = str_replace("%address%",$address,$body);
							$body	 = str_replace("%bookingid%",$bokid,$body);
							$resemail = $data['resemail'];
							$body = str_replace("%resemail%",$resemail,$body);
							$body = str_replace("%resphone%",$rescountrycode.$resphone,$body);
							$body = str_replace("%reslogo%",$RestLogo,$body);
							$body = str_replace("%phone%",$cusphone,$body);
							$body = str_replace("%email%",$data['SenTo'],$body);
							$body 	 = str_replace("�",'',$body);
							$receiverslist = $data['SenTo'];
							
							if(isset($data['campId'])){
								$body    = str_replace("none",$display,$body);
								$body    = str_replace("%desc%",$desc,$body);
								if($data['campaignImg']){
									$imgDiv 	= str_replace("%img%",$img,$imgDiv);
									$body    	= str_replace("%img%",$imgDiv,$body);								
								}else{
									$body    = str_replace("%img%",'',$body);
								}
								$body    = str_replace("%campName%",$campname,$body);
							}else{
									$body    = str_replace($div,'',$body);
								}
							
							$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
							$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
							$priorMapper = new Application_Model_PriorityDataMapper();
							$prior = $priorMapper->GetPriorityByCode('H');
							$msgMapper = new Communication_Model_EmailMessageDataMapper();
							$message = new Communication_Model_EmailMessage();
							$msgPhrase = uniqid ();
							$message->setBokid($bokid)
									->setPhrase($msgPhrase)
									->setTitle($mailobj->getMsgCode())
									->setDescription($body)
									->setPriority($prior->getcode())
									->setEmailtype($emailType->getcode())
									->setUsertype($userType)
									->setSentby('admin@dinedesk.com');
							$msgid = $msgMapper->SaveMessageDetails($message);
							$src = "http://www.dinedesk.com/Communication/Communication/emailcommunication/msgid/".$msgPhrase;
							$body	 = str_replace("%bookingsrc%",$src,$body);
							if($userType == 'CUS'){
								$cusMapper = new Communication_Model_EmailCusRecipentsDataMapper();
								$cusResult = $cusMapper->SaveCustMailDetails($msgid,$state,$city,$userType,$campId,$receiverslist);
							}
							$ReceiversEmails = array();
							if($data['BookNotCan']){
								$ReceiversEmails = $data['RestEmails'];
								$userType = 'RES';
								$msgPhrase = uniqid ();
								$message->setPhrase($msgPhrase)
										->setUsertype($userType);
								$msgid = $msgMapper->SaveMessageDetails($message);
								$src = "http://www.dinedesk.com/Communication/Communication/emailcommunication/msgid/".$msgPhrase;
								$body	 = str_replace("%bookingsrc%",$src,$body);
								if($userType == 'RES'){
									$cusMapper = new Communication_Model_EmailRestRecipentsDataMapper();
									$cusResult = $cusMapper->SaveRestMailDetails($msgid,$state,$city,$userType,$campId,$ReceiversEmails);
								}
							}
							
							
							$ReceiversEmails[] = $receiverslist;
							$request = array(
										'subject' => $subject,
										'from'    => array( // required. A sender’s information
															'name'  => $fromname,
															'email' => $fromaddress
													),
										'signing_domain'=>$signing_domain,
										'to' 		 => $ReceiversEmails,
										'html'       => $body, // email's HTML content
										'auto_plain' => true // automatically generate a text part for the messages of HTML part
									);
							$retval = $LeaderSendApi->messagesSend($request);
							if($LeaderSendApi->errorMessage){
								$mail->setFrom($fromaddress, $fromname);
							    $mail->setReplyTo($replyfromaddress,$replyfromname);
							    $mail->addTo( $ReceiversEmails,$name);
							    $mail->setSubject($subject);
							    $mail->setBodyHtml($body);
							    $mail->send();
							}
						}
					    
						break;
						
					case 'ReSchedule' :
						$data     = $mailobj->getData();
						$bokMapper = new Reservation_Model_ReservationDataMapper();
						$resLoc = $bokMapper->getRestaurantLocByBookingId($data['Bokid']);
						if($resLoc->res_companyid == 22){
							$mailobj->setMsgCode('ReScheduleHBC');
							$template = $this->GetMessageTemplate($mailobj);
							$fromname  = 'HBC Solutions';
							$fromaddress = 'info@hbcsolutions.net';
							$signing_domain ='hbcsolutions.net';
                                                }else if($resLoc->res_companyid == 25){
                                                        $mailobj->setMsgCode('ReScheduleDWU');
							$template = $this->GetMessageTemplate($mailobj);
							$fromname  = 'DiningWithUs';
							$fromaddress = 'admin@diningwithus.com';
							$signing_domain ='diningwithus.com';                                                    
                                                }
                                                else if($language == "sp")
						{
							$mailobj->setMsgCode('ReSchedule_Sp');
							$template = $this->GetMessageTemplate($mailobj);
							$fromname  = 'DineDesk';
							$fromaddress = 'admin@dinedesk.com';
							$signing_domain ='dinedesk.com';
						}else{
							$template = $this->GetMessageTemplate($mailobj);
							$fromname  = 'DineDesk';
							$fromaddress = 'admin@dinedesk.com';
							$signing_domain ='dinedesk.com';
						}
						if($template){
							
							$campId = "";
							
							if($resLoc->res_companyid != 6){
								$name     = $data['UserName'];
								$restname = $data['RestName'];
								$dateSplit = explode("-",$data['ResDate']);
								$s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
								$resdate  = date('d M Y',$s);
								$time     = $data['Time'];
								$size     = $data['Size'];
								$address  = $data['Address'];
								$resphone = $data['resphone'];
								$status	  = $data['Status'];
								$bokid    = $data['Bokid'];
								$cusPhone = $data['phone'];
                                                                $restemails = $data['RestEmails']; 
                                                                $restemailstr='';
                                                                foreach($restemails as $resemail){
                                                                            $restemailstr .=$resemail.',';
                                                                 }
								
								$bokphrase = '';
								$bokMap = new Reservation_Model_ReservationDataMapper();
								$bokphrase = $bokMap->GetBookingPhraseByBookid($bokid);
								$book = new Reservation_Model_Reservation();
								$book->setbokid($bokid);
								$bookdetails = $bokMap->getBookingDetails($book);
								$rescountrycode = $bookdetails->getResCountrycode();							
								$resid = $bookdetails->getbokfk_restaurant();							
								if(isset($resid)){
									$row = $bokMap->GetRestaurantLogo($resid);
									if($row->reslogo){
										$logo = str_replace(" ","%20",$row->reslogo);
										$RestLogo = '<img src="http://www.dinedesk.com'.$logo.'" border="0"  height="60" align="left" style="position:relative;left:12;"/>';
									}else{
										$RestLogo = '<img src="http://www.dinedesk.com/images/dinedesk-logo.png"  border="0" align="left" height="60"  usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2" >';
									}
								}else{
										$RestLogo = '<img src="http://www.dinedesk.com/images/dinedesk-logo.png"  border="0" align="left" height="60" usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2">';
								}
								if($resLoc->res_companyid == 22){
									$RestLogo = '<img src="http://www.dinedesk.com/images/hbc-logo.png"  border="0" align="left" height="60" usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2">';
								}
                                                                if($resLoc->res_companyid == 25){
                                                                    $RestLogo = '<img src="http://www.dinedesk.com/images/diningwithuslogo.png"  border="0" align="left" height="60" usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2">';
                                                                    
                                                                }
								$state	  = $data['State_Id'];
								$city	  = $data['City_Id'];
								$resemail = $data['resemail'];
								$reszipcode = $data['reszipcode'];
								$rescity  = $data['rescity'];
								$resnbh   = $data['resnbh'];
								
	//							$spldiv = '<div style="background: #f1ede8;box-shadow: 5px 5px 30px #808080;-moz-box-shadow: 5px 5px 30px #808080;-khtml-box-shadow: 5px 5px 30px #808080;-webkit-box-shadow: 5px 5px 30px #808080;border:3px solid #643513; padding:8px; font-size:12px;"><div style="color:#F79646; font-weight:bold; text-align:center;">%splname%</div><br /><div style="color:#4f6228; font-weight:bold;">Special Id: %splid%</div><br /><br /><div style="color:#000048;">%spldesc%</div></div><br /><br />';
								$spldiv = '<div class="box-shadow"><div style="color:#F79646; font-weight:bold; text-align:center;">%splname%</div><br /><div style="color:#4f6228; font-weight:bold;">Special Id: %splid%</div><br /><br /><div style="color:#000048;">%spldesc%</div></div><br /><br />';
	//							if($data['splstatus']){
	//								$splid		= $data['splid']; 
	//								$splname 	= $data['splname'];
	//								$spldesc	= $data['spldesc'];
	////								$splorgprice= $data['splorgprice'];
	////								$spldiscount= $data['spldiscount'];
	////								$splprice	= $data['splprice'];
	//							}
								
								$userType = $data['UserType'];
								$div = '<td width="44%" valign="top" align="left">%img%</br><div>%desc%</div></td>';
								$imgDiv = '<div><img src="http://www.dinedesk.com%img%" width="150" height="150"/></div>';
								if(isset($data['campId'])){
									$campId  	= $data['campId'];
									$campname 	= $data['campaignName'];
									$desc  		= $data['campaignDesc'];
									$img 	  	= $data['campaignImg'];
									$desc  		= str_replace('src="','src="http://www.dinedesk.com',$desc);
									$display  	= 'block';
								}
	
								
								$subject = $template->msg_subject."-".$data['RestName'];
								$body    = $template->msg_body;
								
								$body    = str_replace("%firstname%",$name,$body);
								$body    = str_replace("%restname%",$restname,$body);
								$body    = str_replace("%date%",$resdate,$body);
								$body    = str_replace("%time%",$time,$body);
								$body    = str_replace("%size%",$size,$body);
								$body	 = str_replace("%address%",$address,$body);
								$body	 = str_replace("%resphone%",$rescountrycode.$resphone,$body);
								$body	 = str_replace("%bokid%",$bokphrase,$body);
								$body	 = str_replace("http://www.dinedesk.com","http://www.dinedesk.com",$body);
								$body    = str_replace("%resid%",$resid,$body);
								$body	 = str_replace("%bookingid%",$bokid,$body);
								$body	 = str_replace("%resnbh%",$resnbh,$body);
								$body	 = str_replace("%rescity%",$rescity,$body);
								$body	 = str_replace("%resemail%",$resemail,$body);
								$body	 = str_replace("%reszipcode%",$reszipcode,$body);
								$body	 = str_replace("%reslogo%",$RestLogo,$body);
								$body	 = str_replace("%phone%",$cusPhone,$body);
								$body	 = str_replace("%email%",$data['SenTo'],$body);								
								
								$body 	 = str_replace("�",'',$body);
								if(isset($data['campId'])){
									$body    = str_replace("none",$display,$body);
									$body    = str_replace("%desc%",$desc,$body);
									if($data['campaignImg']){
										$imgDiv 	= str_replace("%img%",$img,$imgDiv);
										$body    	= str_replace("%img%",$imgDiv,$body);
									}else{
										$body    = str_replace($imgDiv,'',$body);
									}
									$body    = str_replace("%campName%",$campname,$body);
								}else{
									$body    = str_replace($div,'',$body);
									$body    = str_replace("%campName%",'DineDesk',$body);
								}
	//							if($data['splstatus']){
	//								$body	= str_replace("%splname%",$splname,$body);
	//								$body	= str_replace("%splid%",$splid,$body);
	////								$body	= str_replace("%orgprice%",$splorgprice,$body);
	////								$body	= str_replace("%discount%",$spldiscount,$body);
	////								$body	= str_replace("%price%",$splprice,$body);
	//								$body	= str_replace("%spldesc%",$spldesc,$body);
	//							}else{
									$body	= str_replace($spldiv,'',$body);
	//							}
								
								$receiverslist = $data['SenTo'];
							    
								$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
								$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
								$priorMapper = new Application_Model_PriorityDataMapper();
								$prior = $priorMapper->GetPriorityByCode('H');
								$msgMapper = new Communication_Model_EmailMessageDataMapper();
								$message = new Communication_Model_EmailMessage();
								$msgPhrase = uniqid ();
								$message->setBokid($bokid)
										->setPhrase($msgPhrase)
										->setTitle($mailobj->getMsgCode())
										->setDescription($body)
										->setPriority($prior->getcode())
										->setEmailtype($emailType->getcode())
										->setUsertype($userType)
										->setSentby('admin@dinedesk.com');
								$msgid = $msgMapper->SaveMessageDetails($message);
								$src = "http://www.dinedesk.com/Communication/Communication/emailcommunication/msgid/".$msgPhrase;
								$body	 = str_replace("%bookingsrc%",$src,$body);
								if($userType == 'CUS'){
									$cusMapper = new Communication_Model_EmailCusRecipentsDataMapper();
									$cusResult = $cusMapper->SaveCustMailDetails($msgid,$state,$city,$userType,$campId,$receiverslist);
								}
								/* Save Restaurant owner info */
								$ReceiversEmails = array();
								if($data['BookNotf']){ 
									$userType = 'RES';
									$ReceiversEmails = $data['RestEmails'];
									$msgPhrase = uniqid ();
									$message->setPhrase($msgPhrase)
											->setUsertype($userType);
									$msgid = $msgMapper->SaveMessageDetails($message);
									$src = "http://www.dinedesk.com/Communication/Communication/emailcommunication/msgid/".$msgPhrase;
									$body	 = str_replace("%bookingsrc%",$src,$body);
									if($userType == 'RES'){
										$cusMapper = new Communication_Model_EmailRestRecipentsDataMapper();
										$cusResult = $cusMapper->SaveRestMailDetails($msgid,$state,$city,$userType,$campId,$ReceiversEmails);
									}
								}
								$ReceiversEmails[]  = 	$receiverslist;
								
								$request = array(
										'subject' => $subject,
										'from'    => array( // required. A sender’s information
															'name'  => $fromname,
															'email' => $fromaddress
													),
										'signing_domain'=>$signing_domain,
										'to' 			=> $ReceiversEmails,
										'html'       	=> $body, // email's HTML content
										'auto_plain' 	=> true, // automatically generate a text part for the messages of HTML part
                                                                                'headers' => array(
                                                                                                    'reply-to' => $restemailstr,
                                                                                                ),
									);
								$retval = $LeaderSendApi->messagesSend($request);
								if($LeaderSendApi->errorMessage){
									$mail->setFrom($fromaddress, $fromname);
								    $mail->setReplyTo($replyfromaddress,$replyfromname);
								    $mail->addTo($ReceiversEmails,$name);
								    $mail->setSubject($subject);
								    $mail->setBodyHtml($body);
								    $mail->send();
								}
							}
						}
						break;
						
									/*	Case Enquiry/Contact Us Email Notification	*/
						case 'EnquiryNot' :
								
							$template = $this->GetMessageTemplate($mailobj);
							if($template){
								$data     = $mailobj->getData();
								
								if(isset($data['restid'])){
									$bokMap = new Reservation_Model_ReservationDataMapper();
									$row = $bokMap->GetRestaurantLogo($data['restid']);
									if($row->reslogo){
										$logo = str_replace(" ","%20",$row->reslogo);
										$RestLogo = '<tr><td colspan="7" bgcolor="#e5e4de" height="12"></td></tr>
													 <tr>
													 	<td bgcolor="#e5e4de"></td>
													 	<td colspan="5" bgcolor="#FDF5E6" >
													 		<img src="http://www.dinedesk.com'.$logo.'" border="0"  height="60" style="position:relative;left:12;"/>
													 	</td>
													 	<td bgcolor="#e5e4de"></td>
													 </tr>';
									}else{
										$RestLogo = '<tr><td colspan="7"><img src="http://www.dinedesk.com/images/dinedesk-logo.png"  border="0" height="60"  usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2"></td></tr>';
									}
								}else{
										$RestLogo = '<tr><td colspan="7"><img src="http://www.dinedesk.com/images/dinedesk-logo.png"  border="0" height="60"  usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2"></td></tr>';
								}
								$name     = $data['Name'];
								$city  = $data['City'];
								$state     = $data['State'];
								$country     = $data['Country'];
								$phone     = $data['Phone'];
								$email  = $data['Email'];
								$comments  = $data['Comments'];
								$campId = '';
								$userType = "RES";
								$subject = $template->msg_subject;
								$body    = $template->msg_body;
								$body    = str_replace("%name%",$name,$body);
								$body    = str_replace("%city%",$city,$body);
								$body    = str_replace("%state%",$state,$body);

								$body    = str_replace("%country%",$country,$body);

								$body    = str_replace("%phone%",$phone,$body);

								$body    = str_replace("%email%",$email,$body);

								$body    = str_replace("%comments%",$comments,$body);
								$body 	 = str_replace("�",'',$body);
								$body    = str_replace("%reslogo%",$RestLogo,$body);
								
								if(isset($data['SendTo'])){						
									$receiverslist = $data['SendTo'];									
									$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
									$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
									$priorMapper = new Application_Model_PriorityDataMapper();
									$prior = $priorMapper->GetPriorityByCode('H');
									$msgMapper = new Communication_Model_EmailMessageDataMapper();
									$message = new Communication_Model_EmailMessage();
									$msgPhrase = uniqid ();
									$message->setPhrase($msgPhrase)
											->setTitle($mailobj->getMsgCode())
											->setDescription($body)
											->setPriority($prior->getcode())
											->setEmailtype($emailType->getcode())
											->setUsertype($userType)
											->setSentby('admin@dinedesk.com');
									$msgid = $msgMapper->SaveMessageDetails($message);
									if($userType == 'RES'){
										$cusMapper = new Communication_Model_EmailRestRecipentsDataMapper();
										$cusResult = $cusMapper->SaveRestMailDetails($msgid,$state,$city,$userType,$campId,$receiverslist);
									}
								}else{
									$receiverslist = array();
									
									$domain = $_SERVER["SERVER_NAME"];
									if ($domain == "www.dinedesk.co.za" || $domain == "dinedesk.co.za")
									{
										$receiverslist[] = array('email'=>'feedback@dinedesk.co.za','email'=>$name);
									}else
									{
										$receiverslist[] = array('email'=>'admin@dinedesk.com','name'=>'admin@dinedesk.com');
										$receiverslist[] = array('email'=>'sales@dinedesk.com','name'=>'sales@dinedesk.com');
									}
								}
								
								$request = array(
										'subject' => $subject,
										'from'    => array( // required. A sender’s information
															'name'  => 'DineDesk',
															'email' => $fromaddress
													),
										'signing_domain'=>'dinedesk.com',
										'to' => $receiverslist,
										'html'       => $body, // email's HTML content
										'auto_plain' => true // automatically generate a text part for the messages of HTML part
									);
								$retval = $LeaderSendApi->messagesSend($request);
								if($LeaderSendApi->errorMessage || $retval[0]['status'] != 'sent'){
									$mail->setFrom($fromaddress, $fromname);
								    $mail->setReplyTo($fromaddress,$fromname);
								    $mail->addTo( $receiverslist,$name);
								    $mail->setSubject($subject);
								    $mail->setBodyHtml($body);
								    $mail->send();
								}
							}
						
						break;
						
					case 'Notification' :
						$template = $this->GetMessageTemplate($mailobj);
						
						$data	= $mailobj->getData();
						
						$title 		= $data['subject'];
						$message	= $data['body'];
						$signature 	= $data['signature'];
						$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div>%img%</br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
						$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.dinedesk.com%img%" width="150" height="150"/>';
						
	//					$image  = $data['campaignImage'];
	//					$link   = $data['campaignLink'];
						if(isset($data['campaignName']) && isset($data['campaignDesc'])){
							
							$name 	= $data['campaignName'];
							$desc  = $data['campaignDesc'];
							$img  = $data['campaignImg'];
							$desc  = str_replace('src="','src="http://www.dinedesk.com',$desc);
							$display  = 'block';
						}
						
						
						$body	= $template->msg_body;
						
						$receiverslist = $data['SenTo'];
						if(count($receiverslist) > 1){
							$ToArr =  $receiverslist;
						}else{
							$ToArr = $receiverslist[0];
						}
						
						if(isset($data['campaignName']) && isset($data['campaignDesc'])){
							$body	= str_replace("none",$display,$body); 
							$body    = str_replace("%desc%",$desc,$body);
							if($data['campaignImg']){
								$imgDiv 	= str_replace("%img%",$img,$imgDiv);
								$body    	= str_replace("%img%",$imgDiv,$body);								
							}else{
								$body    = str_replace("%img%",'',$body);
							}
							$body    = str_replace("%campName%",$name,$body);	
						}else{
							$body    = str_replace($div,'',$body);
						}
						$body    = str_replace("%body%",$message,$body);
						$signature = str_replace(",",',<br/>',$signature);
						$body    = str_replace("%signature%",$signature,$body);
						
	//					$body    = str_replace("%link%",$link,$body);
	//					$body    = str_replace("%image%",$image,$body);
		
						
						$request = array(
								'subject' => $subject,
								'from'    => array( // required. A sender’s information
													'name'  => 'DineDesk',
													'email' => $fromaddress
											),
								'signing_domain'=>'dinedesk.com',
								'to' => array(
											array(
												'name' => $name,
												'email' => $receiverslist)
										),
								'html'       => $body, // email's HTML content
								'auto_plain' => true // automatically generate a text part for the messages of HTML part
							);
						$retval = $LeaderSendApi->messagesSend($request);
						if($LeaderSendApi->errorMessage){
							$mail->setFrom($fromaddress, $fromname);
						    $mail->setReplyTo($fromaddress,$fromname);
						    $mail->addTo( $receiverslist,$name);
						    $mail->setSubject($subject);
						    $mail->setBodyHtml($body);
							$mail->send();
						}
					
					break;
					case 'No-Show' :
						
						if($language == "sp")
						{
							$mailobj->setMsgCode("No-Show_Sp");
							$template = $this->GetMessageTemplate($mailobj);
						}else{
							$template = $this->GetMessageTemplate($mailobj);
						}
						
						$campId = '';
						$data     = $mailobj->getData();
						$bokMapper = new Reservation_Model_ReservationDataMapper();
						$resLoc = $bokMapper->getRestaurantLocByBookingId($data['Bokid']);
						if($resLoc->res_companyid != 6){
							$name     = $data['UserName'];
							$restname = $data['RestName'];
							$dateSplit = explode("-",$data['ResDate']);
							$s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
							$resdate  = date('d M Y',strtotime($data['ResDate']));
							$time     = $data['Time'];
							$size     = $data['Size'];
							$address  = $data['Address'];
							$status	  = $data['Status'];
							$bokid    = $data['Bokid'];
							$state	  = $data['State_Id'];
							$city	  = $data['City_Id'];
							$userType = $data['UserType'];
							$resManager = $data['ResManager'];
							$resEmail = $data['ResEmail'];
							$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div>%img%</br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
							$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.dinedesk.com%img%" width="150" height="150"/>';
							
	//						$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div><div><a class="linkopacity" target="newwindow">%img%</a></div></br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
	//						$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.dinedesk.com%img%" width="150" height="150"/>';
							
							if(isset($data['campId'])){
								$campId   = $data['campId'];
								$campname 	= $data['campaignName'];
								$desc  = $data['campaignDesc'];
								$img  = $data['campaignImg'];
								$desc  = str_replace('src="','src="http://www.dinedesk.com',$desc);
								$display  = 'block';
							}
							
								$bokMap = new Reservation_Model_ReservationDataMapper();
								$resid = $bokMap->getRestIdByBookId($bokid);
								
								$row = $bokMap->GetRestaurantLogo($resid);
								if($row->reslogo){
									$logo = str_replace(" ","%20",$row->reslogo);
									$RestLogo = '<tr><td colspan="7" bgcolor="#e5e4de" height="12"></td></tr>
												 <tr>
												 	<td bgcolor="#e5e4de"></td>
												 	<td colspan="5" bgcolor="#FDF5E6" >
												 		<img src="http://www.dinedesk.com'.$logo.'" border="0"  height="60" style="position:relative;left:12;"/>
												 	</td>
												 	<td bgcolor="#e5e4de"></td>
												 </tr>';
								}else{
									$RestLogo = '<tr><td colspan="7"><img src="http://www.dinedesk.com/images/dinedesk-logo.png"  border="0" height="60"  usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2"></td></tr>';
								}
							
							$subject = $template->msg_subject;
							$body    = $template->msg_body;
							
							$body    = str_replace("%firstname%",$name,$body);
							$body    = str_replace("%restname%",$restname,$body);
							$body    = str_replace("%date%",$resdate,$body);
							$body    = str_replace("%time%",$time,$body);
							$body    = str_replace("%size%",$size,$body);
							$body    = str_replace("%manager%",$resManager,$body);
							$body	 = str_replace("%address%",$address,$body);
							$body	 = str_replace("%resemail%",$resEmail,$body);
							$body	 = str_replace("%reslogo%",$RestLogo,$body);
							$body 	 = str_replace("�",'',$body);
							$receiverslist = $data['SenTo'];
							
							if(isset($data['campId'])){
								$body    = str_replace("none",$display,$body);
								$body    = str_replace("%desc%",$desc,$body);
								if($data['campaignImg']){
									$imgDiv 	= str_replace("%img%",$img,$imgDiv);
									$body    	= str_replace("%img%",$imgDiv,$body);								
								}else{
									$body    = str_replace("%img%",'',$body);
								}
								$body    = str_replace("%campName%",$campname,$body);
							}else{
									$body    = str_replace($div,'',$body);
								}
							
							$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
							$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
							$priorMapper = new Application_Model_PriorityDataMapper();
							$prior = $priorMapper->GetPriorityByCode('H');
							$msgMapper = new Communication_Model_EmailMessageDataMapper();
							$message = new Communication_Model_EmailMessage();
							$msgPhrase = uniqid ();
							$message->setBokid($bokid)
									->setPhrase($msgPhrase)
									->setTitle($mailobj->getMsgCode())
									->setDescription($body)
									->setPriority($prior->getcode())
									->setEmailtype($emailType->getcode())
									->setUsertype($userType)
									->setSentby('admin@dinedesk.com');
							$msgid = $msgMapper->SaveMessageDetails($message);
							$src = "http://www.dinedesk.com/Communication/Communication/emailcommunication/msgid/".$msgPhrase;
							$body	 = str_replace("%bookingsrc%",$src,$body);
							if($userType == 'CUS'){
								$cusMapper = new Communication_Model_EmailCusRecipentsDataMapper();
								$cusResult = $cusMapper->SaveCustMailDetails($msgid,$state,$city,$userType,$campId,$receiverslist);
							}
							
							
							$request = array(
										'subject' => $subject,
										'from'    => array( // required. A sender’s information
															'name'  => 'DineDesk',
															'email' => $fromaddress
													),
										'signing_domain'=>'dinedesk.com',
										'to' => array(
													array(
														'name' => $name,
														'email' => $receiverslist)
												),
										'html'       => $body, // email's HTML content
										'auto_plain' => true // automatically generate a text part for the messages of HTML part
									);
							$retval = $LeaderSendApi->messagesSend($request);
							if($LeaderSendApi->errorMessage){						
								$mail->setFrom($fromaddress, $fromname);
							    $mail->setReplyTo($fromaddress,$fromname);
							    $mail->addTo( $receiverslist,$name);
							    $mail->setSubject($subject);
							    $mail->setBodyHtml($body);
							    $mail->send();
							}
						}
					    
						break;
						
					case 'Sub-Rnw':
						
						$template = $this->GetMessageTemplate($mailobj);					
						
						$data     = $mailobj->getData();
						$subject  = $template->msg_subject;
						$body     = $template->msg_body;
						
						$name   = $data['UserName'];
						$date   = $data['Date'];
						$amount = $data['Amount'];
						$email  = $data['SenTo'];
						
						$strdate = date('d-M-Y',strtotime($date));
						
						$body = str_replace("%firstname%",$name,$body);
						$body = str_replace("%date%",$strdate,$body);
						$body = str_replace("%amount%",$amount,$body);						
						
						
						$request = array(
								'subject' => $subject,
								'from'    => array( // required. A sender’s information
													'name'  => 'DineDesk',
													'email' => $fromaddress
											),
								'signing_domain'=>'dinedesk.com',
								'to' => array(
											array(
												'name' => $name,
												'email' => $data['SenTo'])
										),
								'html'       => $body, // email's HTML content
								'auto_plain' => true // automatically generate a text part for the messages of HTML part
							);
						$retval = $LeaderSendApi->messagesSend($request);
						if($LeaderSendApi->errorMessage){
							$mail->setFrom($fromaddress, $fromname);
						    $mail->setReplyTo($fromaddress,$fromname);
						    $mail->addTo( $data['SenTo'],$name);
						    $mail->setSubject($subject);
						    $mail->setBodyHtml($body);
						    $mail->send();
						}
												
						break;
					case 'WaitCustomMsg' :
						
						if($language == "sp")
						{
							$mailobj->setMsgCode("WaitCustomMsg_Sp");
							$template = $this->GetMessageTemplate($mailobj);
						}else{
							$template = $this->GetMessageTemplate($mailobj);
						}
						
						$campId = '';
						$data     = $mailobj->getData();
						$bokMapper = new Reservation_Model_ReservationDataMapper();
						$resLoc = $bokMapper->getRestaurantLocByBookingId($data['Bokid']);
						if($resLoc->res_companyid != 6 ){
							$name     	= $data['CustName'];
							$restname 	= $data['RestName'];
							$Message	= $data['Message'];
							$bokid		= $data['Bokid'];
							$bokphrase = '';
							$bokMap = new Reservation_Model_ReservationDataMapper();
							$bokphrase = $bokMap->GetBookingPhraseByBookid($bokid);
							$resid = $bokMap->getRestIdByBookId($bokid);
							$SenTo		= $data['SenTo'];
							$userType   = $data['usertype'];
							$state	  = $data['State_Id'];
							$city	  = $data['City_Id'];
							
							$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div>%img%</br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
							$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.dinedesk.com%img%" width="150" height="150"/>';
							
	//						$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div><div><a class="linkopacity" target="newwindow">%img%</a></div></br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
	//						$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.dinedesk.com%img%" width="150" height="150"/>';
							
							if(isset($data['campId'])){
								$campId   = $data['campId'];
								$campname 	= $data['campaignName'];
								$desc  = $data['campaignDesc'];
								$img  = $data['campaignImg'];
								$desc  = str_replace('src="','src="http://www.dinedesk.com',$desc);
								$display  = 'block';
							}
							
							$subject = $template->msg_subject;
							$body    = $template->msg_body;
							
							$body    = str_replace("%custname%",$name,$body);
							$body    = str_replace("%msg%",$Message,$body);
							$body    = str_replace("%bokid%",$bokphrase,$body);
							$body	 = str_replace("http://www.dinedesk.com","http://www.dinedesk.com",$body);
							$body    = str_replace("%resid%",$resid,$body);
							$body	 = str_replace("%bookingid%",$bokid,$body);
							$body 	 = str_replace("�",'',$body);
							$receiverslist = $data['SenTo'];
							
							if(isset($data['campId'])){
								$body    = str_replace("none",$display,$body);
								$body    = str_replace("%desc%",$desc,$body);
								if($data['campaignImg']){
									$imgDiv 	= str_replace("%img%",$img,$imgDiv);
									$body    	= str_replace("%img%",$imgDiv,$body);								
								}else{
									$body    = str_replace("%img%",'',$body);
								}
								$body    = str_replace("%campName%",$campname,$body);
							}else{
									$body    = str_replace($div,'',$body);
									$body    = str_replace("%campName%",'DineDesk',$body);
								}
							
							$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
							$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
							$priorMapper = new Application_Model_PriorityDataMapper();
							$prior = $priorMapper->GetPriorityByCode('H');
							$msgMapper = new Communication_Model_EmailMessageDataMapper();
							$message = new Communication_Model_EmailMessage();
							$message->setTitle($mailobj->getMsgCode())
									->setDescription($body)
									->setPriority($prior->getcode())
									->setEmailtype($emailType->getcode())
									->setUsertype($userType)
									->setSentby('admin@dinedesk.com');
							$msgid = $msgMapper->SaveMessageDetails($message);
							if($userType == 'CUS'){
								$cusMapper = new Communication_Model_EmailCusRecipentsDataMapper();
								$cusResult = $cusMapper->SaveCustMailDetails($msgid,$state,$city,$userType,$campId,$receiverslist);
							}
							
							
							$request = array(
									'subject' => $subject,
									'from'    => array( // required. A sender’s information
														'name'  => 'DineDesk',
														'email' => $fromaddress
												),
									'signing_domain'=>'dinedesk.com',
									'to' => array(
												array(
													'name' => $name,
													'email' => $receiverslist)
											),
									'html'       => $body, // email's HTML content
									'auto_plain' => true // automatically generate a text part for the messages of HTML part
								);
							$retval = $LeaderSendApi->messagesSend($request);
							if($LeaderSendApi->errorMessage){
								$mail->setFrom($fromaddress, $fromname);
							    $mail->setReplyTo($fromaddress,$fromname);
							    $mail->addTo( $receiverslist,$name);
							    $mail->setSubject($subject);
							    $mail->setBodyHtml($body);
							    $stat = $mail->send();
							    if($stat){
							    	return true;
							    }
							}
						}
						break;
					case 'WaitReservReady' :
						
						if($language == "sp")
						{
							$mailobj->setMsgCode("WaitReservReady_Sp");
							$template = $this->GetMessageTemplate($mailobj);
						}else{
							$template = $this->GetMessageTemplate($mailobj);
						}
						
						$campId = '';
						$data     = $mailobj->getData();
						$bokMapper = new Reservation_Model_ReservationDataMapper();
						$resLoc = $bokMapper->getRestaurantLocByBookingId($data['Bokid']);
						if($resLoc->res_companyid != 6 ){
							$name     	= $data['CustName'];
							$restname 	= $data['RestName'];
							$Message	= $data['Message'];
							$SenTo		= $data['SenTo'];
							$userType   = $data['usertype'];
							$bokid		= $data['Bokid'];
							$bokphrase = '';
							$bokMap = new Reservation_Model_ReservationDataMapper();
							$bokphrase = $bokMap->GetBookingPhraseByBookid($bokid);
							$resid = $bokMap->getRestIdByBookId($bokid);
							$state	  = $data['State_Id'];
							$city	  = $data['City_Id'];
							
							$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div>%img%</br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
							$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.dinedesk.com%img%" width="150" height="150"/>';
							
	//						$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div><div><a class="linkopacity" target="newwindow">%img%</a></div></br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
	//						$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.dinedesk.com%img%" width="150" height="150"/>';
							
							if(isset($data['campId'])){
								$campId   = $data['campId'];
								$campname 	= $data['campaignName'];
								$desc  = $data['campaignDesc'];
								$img  = $data['campaignImg'];
								$desc  = str_replace('src="','src="http://www.dinedesk.com',$desc);
								$display  = 'block';
							}
							
							$subject = $template->msg_subject;
							$body    = $template->msg_body;
							
							$body    = str_replace("%custname%",$name,$body);
							$body    = str_replace("%bokid%",$bokphrase,$body);
							$body	 = str_replace("http://www.dinedesk.com","http://www.dinedesk.com",$body);
							$body    = str_replace("%resid%",$resid,$body);
							$body	 = str_replace("%bookingid%",$bokid,$body);
							$body    = str_replace("%resname%",$restname,$body);
							$body 	 = str_replace("�",'',$body);
							$receiverslist = $data['SenTo'];
							
							if(isset($data['campId'])){
								$body    = str_replace("none",$display,$body);
								$body    = str_replace("%desc%",$desc,$body);
								if($data['campaignImg']){
									$imgDiv 	= str_replace("%img%",$img,$imgDiv);
									$body    	= str_replace("%img%",$imgDiv,$body);								
								}else{
									$body    = str_replace("%img%",'',$body);
								}
								$body    = str_replace("%campName%",$campname,$body);
							}else{
									$body    = str_replace($div,'',$body);
									$body    = str_replace("%campName%",'DineDesk',$body);
								}
							
							$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
							$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
							$priorMapper = new Application_Model_PriorityDataMapper();
							$prior = $priorMapper->GetPriorityByCode('H');
							$msgMapper = new Communication_Model_EmailMessageDataMapper();
							$message = new Communication_Model_EmailMessage();
							$message->setTitle($mailobj->getMsgCode())
									->setDescription($body)
									->setPriority($prior->getcode())
									->setEmailtype($emailType->getcode())
									->setUsertype($userType)
									->setSentby('admin@dinedesk.com');
							$msgid = $msgMapper->SaveMessageDetails($message);
							if($userType == 'CUS'){
								$cusMapper = new Communication_Model_EmailCusRecipentsDataMapper();
								$cusResult = $cusMapper->SaveCustMailDetails($msgid,$state,$city,$userType,$campId,$receiverslist);
							}
							
							
							$request = array(
									'subject' => $subject,
									'from'    => array( // required. A sender’s information
														'name'  => 'DineDesk',
														'email' => $fromaddress
												),
									'signing_domain'=>'dinedesk.com',
									'to' => array(
												array(
													'name' => $name,
													'email' => $receiverslist)
											),
									'html'       => $body, // email's HTML content
									'auto_plain' => true // automatically generate a text part for the messages of HTML part
								);
							$retval = $LeaderSendApi->messagesSend($request);
							if($LeaderSendApi->errorMessage){
								$mail->setFrom($fromaddress, $fromname);
							    $mail->setReplyTo($fromaddress,$fromname);
							    $mail->addTo( $receiverslist,$name);
							    $mail->setSubject($subject);
							    $mail->setBodyHtml($body);
							    $stat = $mail->send();
								if($stat){
							    	return true;
							    }
							}
						}
						break;
					case 'WaitReserv' :
						
						if($language == "sp")
						{
							$mailobj->setMsgCode("WaitReserv_Sp");
							$template = $this->GetMessageTemplate($mailobj);
						}else{
							$template = $this->GetMessageTemplate($mailobj);
						}
						
						$campId = '';
						$data     = $mailobj->getData();
						$bokMapper = new Reservation_Model_ReservationDataMapper();
						$resLoc = $bokMapper->getRestaurantLocByBookingId($data['Bokid']);
						if($resLoc->res_companyid != 6 ){
							$name     	= $data['UserName'];
							$restname 	= $data['RestName'].',';
							$restaddr	= $data['Address'];
							$SenTo		= $data['SenTo'];
							$userType   = $data['UserType'];
							$quote		= $data['QuoteTime'];
							$bokid		= $data['Bokid'];
							$bokphrase = '';
							$bokMap = new Reservation_Model_ReservationDataMapper();
							$bokphrase = $bokMap->GetBookingPhraseByBookid($bokid);
							$resid = $bokMap->getRestIdByBookId($bokid);
							$dateTime   = $data['ResDate'].' '.$data['Time'];
							$state	  = $data['State_Id'];
							$city	  = $data['City_Id'];
							
							$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div>%img%</br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
							$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.dinedesk.com%img%" width="150" height="150"/>';
							
	//						$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div><div><a class="linkopacity" target="newwindow">%img%</a></div></br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
	//						$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.dinedesk.com%img%" width="150" height="150"/>';
							
							if(isset($data['campId'])){
								$campId   = $data['campId'];
								$campname 	= $data['campaignName'];
								$desc  = $data['campaignDesc'];
								$img  = $data['campaignImg'];
								$desc  = str_replace('src="','src="http://www.dinedesk.com',$desc);
								$display  = 'block';
							}
							
							$subject = $template->msg_subject;
							$body    = $template->msg_body;
							
							$body    = str_replace("%custname%",$name,$body);
							$body    = str_replace("%quotetime%",$quote,$body);
							$body    = str_replace("%restname%",$restname,$body);
							$body    = str_replace("%bokid%",$bokphrase,$body);
							$body	 = str_replace("http://www.dinedesk.com","http://www.dinedesk.com",$body);
							$body    = str_replace("%resid%",$resid,$body);
							$body	 = str_replace("%bookingid%",$bokid,$body);
							$body    = str_replace("%datetime%",$dateTime,$body);
							$body    = str_replace("%resaddress%",$restaddr,$body);
							$body 	 = str_replace("�",'',$body);
							$receiverslist = $data['SenTo'];
							
							if(isset($data['campId'])){
								$body    = str_replace("none",$display,$body);
								$body    = str_replace("%desc%",$desc,$body);
								if($data['campaignImg']){
									$imgDiv 	= str_replace("%img%",$img,$imgDiv);
									$body    	= str_replace("%img%",$imgDiv,$body);								
								}else{
									$body    = str_replace("%img%",'',$body);
								}
								$body    = str_replace("%campName%",$campname,$body);
							}else{
									$body    = str_replace($div,'',$body);
									$body    = str_replace("%campName%",'DineDesk',$body);
								}
							
							$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
							$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
							$priorMapper = new Application_Model_PriorityDataMapper();
							$prior = $priorMapper->GetPriorityByCode('H');
							$msgMapper = new Communication_Model_EmailMessageDataMapper();
							$message = new Communication_Model_EmailMessage();
							$message->setTitle($mailobj->getMsgCode())
									->setDescription($body)
									->setPriority($prior->getcode())
									->setEmailtype($emailType->getcode())
									->setUsertype($userType)
									->setSentby('admin@dinedesk.com');
							$msgid = $msgMapper->SaveMessageDetails($message);
							if($userType == 'CUS'){
								$cusMapper = new Communication_Model_EmailCusRecipentsDataMapper();
								$cusResult = $cusMapper->SaveCustMailDetails($msgid,$state,$city,$userType,$campId,$receiverslist);
							}
							
							
							$request = array(
									'subject' => $subject,
									'from'    => array( // required. A sender’s information
														'name'  => 'DineDesk',
														'email' => $fromaddress
												),
									'signing_domain'=>'dinedesk.com',
									'to' => array(
												array(
													'name' => $name,
													'email' => $receiverslist)
											),
									'html'       => $body, // email's HTML content
									'auto_plain' => true // automatically generate a text part for the messages of HTML part
								);
							$retval = $LeaderSendApi->messagesSend($request);
							if($LeaderSendApi->errorMessage){
								$mail->setFrom($fromaddress, $fromname);
							    $mail->setReplyTo($fromaddress,$fromname);
							    $mail->addTo( $receiverslist,$name);
							    $mail->setSubject($subject);
							    $mail->setBodyHtml($body);
							    $stat = $mail->send();
								if($stat){
							    	return true;
							    }
							}
						}
						break;
					case 'notifyfriends' :
						$data     = $mailobj->getData();
						$bokMapper = new Reservation_Model_ReservationDataMapper();
						$resLoc = $bokMapper->getRestaurantLocByBookingId($data['Bokid']);
						$fromname  = 'DineDesk';
						$fromaddress = 'admin@dinedesk.com';
						$signing_domain ='dinedesk.com';
						if($resLoc->res_companyid == 22){
							$mailobj->setMsgCode("notifyfriendsHBC");
							$template = $this->GetMessageTemplate($mailobj);
							$fromname  = 'HBC Solutions';
							$fromaddress = 'info@hbcsolutions.net';
							$signing_domain ='hbcsolutions.net';
                                                }else if($resLoc->res_companyid == 25){
                                                        $mailobj->setMsgCode("notifyfriendsDWU");
							$template = $this->GetMessageTemplate($mailobj);
							$fromname  = 'DiningWithUs';
							$fromaddress = 'admin@diningwithus.com';
							$signing_domain ='diningwithus.com';
                                                }
                                                
                                                else if($language == "sp")
						{
							$mailobj->setMsgCode("notifyfriends_Sp");
							$template = $this->GetMessageTemplate($mailobj);
						}else{
							$template = $this->GetMessageTemplate($mailobj);
						}
						
						if($template){							
							
							$bokMapper = new Reservation_Model_ReservationDataMapper();
							
							if($resLoc->res_companyid != 6 ){
								$campId = "";
								$name     = $data['UserName'];
								$restname = $data['RestName'];
								$resdate  = $data['ResDate'];
								$time     = $data['Time'];
								$size     = $data['Size'];
								$address  = $data['Address'];
								$resphone = $data['Phone'];
								$bokid    = $data['Bokid'];
								$bokphrase = '';
								$bokMap = new Reservation_Model_ReservationDataMapper();
								$bokphrase = $bokMap->GetBookingPhraseByBookid($bokid);
								$book = new Reservation_Model_Reservation();
								$book->setbokid($bokid);
								$bookdetails = $bokMap->getBookingDetails($book);
								$rescountrycode = $bookdetails->getResCountrycode();						
								$resid = $bookdetails->getbokfk_restaurant();	
								$senderemail = $bookdetails->getbokemail();			
								if(isset($resid)){							
									$row = $bokMap->GetRestaurantLogo($resid);
									if($row->reslogo){
										$logo = str_replace(" ","%20",$row->reslogo);
										$RestLogo = '<tr><td colspan="7" bgcolor="#e5e4de" height="12"></td></tr>
													 <tr>
													 	<td bgcolor="#e5e4de"></td>
													 	<td colspan="5" bgcolor="#FDF5E6" >
													 		<img src="http://www.dinedesk.com'.$logo.'" border="0"  height="60" />
													 	</td>
													 	<td bgcolor="#e5e4de"></td>
													 </tr>';
									}else{
										$RestLogo = '<tr><td colspan="7"><img src="http://www.dinedesk.com/images/dinedesk-logo.png"  border="0" height="60"  usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2" /></td></tr>';
									}
								}else{
										$RestLogo = '<tr><td colspan="7"><img src="http://www.dinedesk.com/images/dinedesk-logo.png"  border="0" height="60"  usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2" /></td></tr>';
								}
								$city	  = $data['City'];
								$resemail = $data['RestEmail'];
								$reszipcode = $data['Zipcode'];
								$rescity  = $data['City'];
								$resnbh   = $data['RestNbh'];
								
								$spldiv = '<div style="background: #f1ede8;box-shadow: 5px 5px 30px #808080;-moz-box-shadow: 5px 5px 30px #808080;-khtml-box-shadow: 5px 5px 30px #808080;-webkit-box-shadow: 5px 5px 30px #808080;border:3px solid #643513; padding:8px; font-size:12px;"><div style="color:#F79646; font-weight:bold; text-align:center;">%splname%</div><br /><div style="color:#4f6228; font-weight:bold;">Special Id: %splid%</div><br /><br /><div style="color:#000048;">%spldesc%</div></div><br /><br />';
								if($data['splstatus']){
									$splid		= $data['splid']; 
									$splname 	= $data['splname'];
									$spldesc	= $data['spldesc'];
								}
								$hiDiv = '<tr><td colspan="2"><p style="color:#505050 ; font-family:Verdana, Arial, Helvetica, sans-serif;">Dear %firstname%,</p></td></tr><tr><td colspan="2">You have recieved this email from DineDesk to notify of your reservation.</td></tr>';
								$newHiDiv = '<tr><td colspan="2"><p style="color:#505050 ; font-family:Verdana, Arial, Helvetica, sans-serif;">Hi,</p></td></tr><tr><td colspan="2">You have been invited to a reservation by %firstname%.</td></tr>';
								$userType = $data['UserType'];
								$div = '<td width="45%" valign="top" align="left">%img%</br><div>%desc%</div></td>';
								$imgDiv = '<div><img src="http://www.dinedesk.com%img%" width="150" height="150"/></div>';
								if(isset($data['campId'])){
									$campId  	= $data['campId'];
									$campname 	= $data['campaignName'];
									$desc  		= $data['campaignDesc'];
									$img 	  	= $data['campaignImg'];
									$desc  		= str_replace('src="','src="http://www.dinedesk.com',$desc);
									$display  	= 'block';
								}
								$subject = $template->msg_subject;
								$body    = $template->msg_body;
								$body    = str_replace($hiDiv,$newHiDiv,$body);
								$body    = str_replace("%firstname%",$name,$body);
								$body    = str_replace("email-card.png",'email-card-notify.png',$body);
								$body    = str_replace("%restname%",$restname,$body);
								$body    = str_replace("%date%",$resdate,$body);
								$body    = str_replace("%time%",$time,$body);
								$body    = str_replace("%size%",$size,$body);
								$body	 = str_replace("%address%",$address,$body);
								$body	 = str_replace("%phone%",$rescountrycode.$resphone,$body);
								$body	 = str_replace("%bokid%",$bokphrase,$body);
								$body	 = str_replace("http://www.dinedesk.com","http://www.dinedesk.com",$body);
								$body    = str_replace("%resid%",$resid,$body);
								$body	 = str_replace("%bookingid%",$bokid,$body);
								$body	 = str_replace("%resnbh%",$resnbh,$body);
								$body	 = str_replace("%rescity%",$rescity,$body);
								$body	 = str_replace("%email%",$resemail,$body);
								$body	 = str_replace("%senderemail%",$senderemail,$body);
								$body	 = str_replace("%reszipcode%",$reszipcode,$body);
								$body	 = str_replace("%reslogo%",$RestLogo,$body);							
								
								$body 	 = str_replace("�",'',$body);
								if(isset($data['campId'])){
									$body    = str_replace("none",$display,$body);
									$body    = str_replace("%desc%",$desc,$body);
									if($data['campaignImg']){
										$imgDiv 	= str_replace("%img%",$img,$imgDiv);
										$body    	= str_replace("%img%",$imgDiv,$body);
									}else{
										$body    = str_replace($imgDiv,'',$body);
									}
									$body    = str_replace("%campName%",$campname,$body);
								}else{
									$body    = str_replace($div,'',$body);
									$body    = str_replace("%campName%",'DineDesk',$body);
								}
								if($data['splstatus']){
									$body	= str_replace("%splname%",$splname,$body);
									$body	= str_replace("%splid%",$splid,$body);
									$body	= str_replace("%spldesc%",$spldesc,$body);
								}else{
									$body	= str_replace($spldiv,'',$body);
								}
								
								/*code to explode string*/
	//							$noNewLine=explode("\n",$data['SendTo']);
	//							foreach($noNewLine as $key=>$value){
	//							//Now we are Looking for comma operator , if they have specified in field
									$arrEmail = $data['SendTo'];
	//							}				
							    /*code to explode string*/
								$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
								$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
								$priorMapper = new Application_Model_PriorityDataMapper();
								$prior = $priorMapper->GetPriorityByCode('H');
								$msgMapper = new Communication_Model_EmailMessageDataMapper();
								$message = new Communication_Model_EmailMessage();
								$msgPhrase = uniqid ();
								$message->setBokid($bokid)
										->setPhrase($msgPhrase)
										->setTitle($mailobj->getMsgCode())
										->setDescription($body)
										->setPriority($prior->getcode())
										->setEmailtype($emailType->getcode())
										->setUsertype($userType)
										->setSentby('admin@dinedesk.com');
								$msgid = $msgMapper->SaveMessageDetails($message);
								
								if($userType == 'CUS'){
									$cusMapper = new Communication_Model_EmailCusRecipentsDataMapper();
									$cusResult = $cusMapper->SaveCustMailDetails($msgid,$state,$city,$userType,$campId,$receiverslist);
								}
								foreach($arrEmail as $key1=>$value1){
									$tempbody = "";
									$tempbody = $body;
									//Here i am checking whether the user has entered any Null values
									if(trim($value1)!=''){
										$tempbody = str_replace("%guestid%",$key1,$tempbody);

										$request = array(
											'subject' => $subject,
											'from'    => array( // required. A sender’s information
																'name'  => $fromname,
																'email' => $fromaddress
														),
											'signing_domain'=>$signing_domain,
											'to' => array(
														array(
															'name' => $value1,
															'email' => $value1)
													),
											'html'       => $tempbody, // email's HTML content
											'auto_plain' => true // automatically generate a text part for the messages of HTML part
										);
										$retval = $LeaderSendApi->messagesSend($request);
										if($LeaderSendApi->errorMessage){
											$mail = new Zend_Mail();
											$mail->setFrom($fromaddress, $fromname);
											$mail->setReplyTo($fromaddress,$fromname);
											$mail->setSubject($subject);
											$mail->setBodyHtml($tempbody);
											$mail->addTo( $value1,$value1);	
										    $stat = $mail->send();
											if($stat){
										    	return true;
										    }
										}
									}
								}
							}	
						}					
						break;	
					case 'BookingOTP' :
						if($language == "sp")
						{
							$mailobj->setMsgCode("BookingOTP_Sp");
							$template = $this->GetMessageTemplate($mailobj);
						}else{
							$template = $this->GetMessageTemplate($mailobj);
						}
						if($template){							
							$data     = $mailobj->getData();
							$bokMapper = new Reservation_Model_ReservationDataMapper();
							$resLoc = $bokMapper->getRestaurantLocByResId($data['ResId']);
							if($resLoc->res_companyid == 22){
								$mailobj->setMsgCode("BookingOTPHBC");
								$template = $this->GetMessageTemplate($mailobj);
								$bokMapper = new Reservation_Model_ReservationDataMapper();
								
								$row = $bokMapper->GetRestaurantLogo($data['ResId']);
								if($row->reslogo){
							//		$imageLogo=urlencode($row->reslogo);
							//		$enlogo = urlencode($imageLogo);
							//		$delogo = urldecode($enlogo);
									$logo = str_replace(" ","%20",$row->reslogo);
									$RestLogo = '<tr><td colspan="7" bgcolor="#e5e4de" height="12"></td></tr>
												 <tr>
												 	<td bgcolor="#e5e4de"></td>
												 	<td colspan="5" bgcolor="#FDF5E6" >
												 		<img src="http://www.dinedesk.com'.$logo.'" border="0"  height="60" />
												 	</td>
												 	<td bgcolor="#e5e4de"></td>
												 </tr>';
								}else{
									$RestLogo = '<tr><td colspan="7"><img src="http://www.dinedesk.com/images/dinedesk-logo.png"  border="0" height="60"  usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2" /></td></tr>';
								}
								
								$campId = "";
								$subject = $template->msg_subject;
								$body    = $template->msg_body;
								
								$body    = str_replace("%firstname%",$data['CustomerName'],$body);
								$body    = str_replace("%restName%",$resLoc->resrestaurant_name,$body);
								$body    = str_replace("%otp%",$data['OtpVal'],$body);
								$body    = str_replace("%reslogo%",$RestLogo,$body);
								$body 	 = str_replace("?",'',$body);
								$userType = 'CUS';
								$receiverslist = $data['to'];
								
								$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
								$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
								$priorMapper = new Application_Model_PriorityDataMapper();
								$prior = $priorMapper->GetPriorityByCode('H');
								$msgMapper = new Communication_Model_EmailMessageDataMapper();
								$message = new Communication_Model_EmailMessage();
								$msgPhrase = uniqid ();
								$message->setPhrase($msgPhrase)
										->setTitle($mailobj->getMsgCode())
										->setDescription($body)
										->setPriority($prior->getcode())
										->setEmailtype($emailType->getcode())
										->setUsertype($userType)
										->setSentby('admin@dinedesk.com');
								$msgid = $msgMapper->SaveMessageDetails($message);
								if($userType == 'CUS'){
									$cusMapper = new Communication_Model_EmailCusRecipentsDataMapper();
									$cusResult = $cusMapper->SaveCustMailDetails($msgid,$resLoc->resstate_id,$resLoc->rescity_id,$userType,$campId,$receiverslist);
								}
								
								$fromname  = 'HBC Solutions';
								$fromaddress = 'info@hbcsolutions.net';
								$signing_domain ='hbcsolutions.net';
								$request = array(
									'subject' => $subject,
									'from'    => array( // required. A sender’s information
														'name'  => $fromname,
														'email' => $fromaddress
												),
									'signing_domain'=>$signing_domain,
									'to' => array(
												array(
													'name' => $name,
													'email' => $receiverslist)
											),
									'html'       => $body, // email's HTML content
									'auto_plain' => true // automatically generate a text part for the messages of HTML part
								);
								$retval = $LeaderSendApi->messagesSend($request);
								if($LeaderSendApi->errorMessage){
									$mail->setFrom($fromaddress, $fromname);
								    $mail->setReplyTo($fromaddress,$fromname);
								    $mail->addTo( $receiverslist,$data['CustomerName']);
								    $mail->setSubject($subject);
								    $mail->setBodyHtml($body);
								    $stat = $mail->send();
									if($stat){
								    	return true;
								    }
								}
								
							}else if($resLoc->res_companyid != 6){
								$bokMapper = new Reservation_Model_ReservationDataMapper();
								
								$row = $bokMapper->GetRestaurantLogo($data['ResId']);
								if($row->reslogo){
							//		$imageLogo=urlencode($row->reslogo);
							//		$enlogo = urlencode($imageLogo);
							//		$delogo = urldecode($enlogo);
									$logo = str_replace(" ","%20",$row->reslogo);
									$RestLogo = '<tr><td colspan="7" bgcolor="#e5e4de" height="12"></td></tr>
												 <tr>
												 	<td bgcolor="#e5e4de"></td>
												 	<td colspan="5" bgcolor="#FDF5E6" >
												 		<img src="http://www.dinedesk.com'.$logo.'" border="0"  height="60" />
												 	</td>
												 	<td bgcolor="#e5e4de"></td>
												 </tr>';
								}else{
									$RestLogo = '<tr><td colspan="7"><img src="http://www.dinedesk.com/images/dinedesk-logo.png"  border="0" height="60" usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2" /></td></tr>';
								}
								
								$campId = "";
								$subject = $template->msg_subject;
								$body    = $template->msg_body;
								
								$body    = str_replace("%firstname%",$data['CustomerName'],$body);
								$body    = str_replace("%restName%",$resLoc->resrestaurant_name,$body);
								$body    = str_replace("%otp%",$data['OtpVal'],$body);
								$body    = str_replace("%reslogo%",$RestLogo,$body);
								$body 	 = str_replace("?",'',$body);
								$userType = 'CUS';
								$receiverslist = $data['to'];
								
								$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
								$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
								$priorMapper = new Application_Model_PriorityDataMapper();
								$prior = $priorMapper->GetPriorityByCode('H');
								$msgMapper = new Communication_Model_EmailMessageDataMapper();
								$message = new Communication_Model_EmailMessage();
								$msgPhrase = uniqid ();
								$message->setPhrase($msgPhrase)
										->setTitle($mailobj->getMsgCode())
										->setDescription($body)
										->setPriority($prior->getcode())
										->setEmailtype($emailType->getcode())
										->setUsertype($userType)
										->setSentby('admin@dinedesk.com');
								$msgid = $msgMapper->SaveMessageDetails($message);
								if($userType == 'CUS'){
									$cusMapper = new Communication_Model_EmailCusRecipentsDataMapper();
									$cusResult = $cusMapper->SaveCustMailDetails($msgid,$resLoc->resstate_id,$resLoc->rescity_id,$userType,$campId,$receiverslist);
								}
								
								
								$mail->setFrom($fromaddress, $fromname);
							    $mail->setReplyTo($fromaddress,$fromname);
							    $mail->addTo( $receiverslist,$data['CustomerName']);
							    $mail->setSubject($subject);
							    $mail->setBodyHtml($body);
							    $mail->send();
								}
						}
						break;
					case 'ThankMsg' :
							$template = $this->GetMessageTemplate($mailobj);
							if($template){							
								$data     = $mailobj->getData();
								$bokMapper = new Reservation_Model_ReservationDataMapper();
								$resLoc = $bokMapper->getRestaurantLocByBookingId($data['Bokid']);
								if($resLoc->res_companyid != 6){
									$name = $data['UserName'];
									$bookid = $data['Bokid'];
									$userType = $data['UserType'];
									if($data['ResManager']){
										$resmanager = $data['ResManager'];
									}else{
										$resmanager = $data['ResOwner'];
									}
									$book = new Reservation_Model_Reservation();
									$book->setbokid($bookid);
									$bokMap = new Reservation_Model_ReservationDataMapper();
									$bookdetails = $bokMap->getBookingDetails($book);
										
									$row = $bokMap->GetRestaurantLogo($bookdetails->getbokfk_restaurant());
									if($row->reslogo){
										$logo = str_replace(" ","%20",$row->reslogo);
										$RestLogo = '<tr><td colspan="7" bgcolor="#e5e4de" height="12"></td></tr>
													 <tr>
													 	<td bgcolor="#e5e4de"></td>
													 	<td colspan="5" bgcolor="#FDF5E6" >
													 		<img src="http://www.dinedesk.com'.$logo.'" border="0"  height="60" style="position:relative;left:12;"/>
													 	</td>
													 	<td bgcolor="#e5e4de"></td>
													 </tr>';
									}else{
										$RestLogo = '<tr><td colspan="7"><img src="http://www.dinedesk.com/images/dinedesk-logo.png"  border="0" height="60"  usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2"></td></tr>';
									}
									
                                                                        include_once('Bitly.php');
                                                                        $url = "https://api-ssl.bit.ly/v3/shorten?access_token=51b00ed7df02a27be6d963de3ddbab78ec93a0cb&longUrl=".urlencode('http://www.dinedesk.com/Reservation/Reservation/instantfeedback/restaurantid/'.$data['ResId'].'/bookingid/'.$data['Bokid']);
                                                                        $url .= "&domain=bit.ly";
                                                                        $url .= "&x_login=dinedesk&x_apiKey=R_8d998f9995ad4c20b62750f2a364002d";

                                                                        $ch = curl_init($url);
                                                                        curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
                                                                        curl_setopt( $ch, CURLOPT_SSL_VERIFYPEER, false);
                                                                        $output = curl_exec($ch);
                                                                        $output = json_decode($output);
                                                                        curl_close($ch);
                                                                        if (isset($output->{'data'}->{'hash'})) {
                                                                                $result['url'] = $output->{'data'}->{'url'};
                                                                                $result['hash'] = $output->{'data'}->{'hash'};
                                                                                $result['global_hash'] = $output->{'data'}->{'global_hash'};
                                                                                $result['long_url'] = $output->{'data'}->{'long_url'};
                                                                                $result['new_hash'] = $output->{'data'}->{'new_hash'};
                                                                        }
                                                                        $result['status_code'] = $output->status_code;
                                                                        
                                                                        
                                                                        
									$subject = $template->msg_subject;
									$body    = $template->msg_body;
                                                                        
									if($result['status_code'] == 200){
                                                                        $body    = str_replace("%feedbacklink%",$result['url'],$body);
                                                                        }
									$body    = str_replace("%CusName%",$name,$body);
									$body    = str_replace("%restname%",$bookdetails->getresrestaurant_name(),$body);
									$body    = str_replace("%date%",$bookdetails->getbokbooking_date(),$body);
									$body    = str_replace("%manager%",$resmanager,$body);
									$body	 = str_replace("%address%",$bookdetails->getresaddress(),$body);
									$body	 = str_replace("%resemail%",$data['ResEmail'],$body);
									$body	 = str_replace("%reslogo%",$RestLogo,$body);
									$body 	 = str_replace("�",'',$body);
									$receiverslist = $data['SenTo'];
									
									$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
									$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
									$priorMapper = new Application_Model_PriorityDataMapper();
									$prior = $priorMapper->GetPriorityByCode('H');
									$msgMapper = new Communication_Model_EmailMessageDataMapper();
									$message = new Communication_Model_EmailMessage();
									$msgPhrase = uniqid ();
									$message->setPhrase($msgPhrase)
											->setBokid($bookid)
											->setTitle($mailobj->getMsgCode())
											->setDescription($body)
											->setPriority($prior->getcode())
											->setEmailtype($emailType->getcode())
											->setUsertype($userType)
											->setSentby('admin@dinedesk.com');
									$msgid = $msgMapper->SaveMessageDetails($message);
									$campId = '';
									$resLoc = $bokMap->getRestaurantLocByResId($bookdetails->getbokfk_restaurant());
									if($userType == 'CUS'){
										$cusMapper = new Communication_Model_EmailCusRecipentsDataMapper();
										$cusResult = $cusMapper->SaveCustMailDetails($msgid,$resLoc->resstate_id,$resLoc->rescity_id,$userType,$campId,$receiverslist);
									}
									
									
									$request = array(
										'subject' => $subject,
										'from'    => array( // required. A sender’s information
														'name'  => 'DineDesk',
														'email' => $fromaddress
												),
										'signing_domain'=>'dinedesk.com',
										'to' => array(
												array(
													'name' => $data['UserName'],
													'email' => $receiverslist)
											),
										'html'       => $body, // email's HTML content
										'auto_plain' => true // automatically generate a text part for the messages of HTML part
									);
									$retval = $LeaderSendApi->messagesSend($request);
									if($LeaderSendApi->errorMessage){
										$mail->setFrom($fromaddress, $fromname);
								    	$mail->setReplyTo($fromaddress,$fromname);
								    	$mail->addTo( $receiverslist,$data['UserName']);
								    	$mail->setSubject($subject);
								    	$mail->setBodyHtml($body);
								    	$mail->send();
									}
								}
							}
							break;
					case 'ThankMsgDWU' :
							$template = $this->GetMessageTemplate($mailobj);                                                        
							if($template){							
								$data     = $mailobj->getData();
								$bokMapper = new Reservation_Model_ReservationDataMapper();
								$resLoc = $bokMapper->getRestaurantLocByBookingId($data['Bokid']);
								if($resLoc->res_companyid != 6){
									$name = $data['UserName'];
									$bookid = $data['Bokid'];
									$userType = $data['UserType'];
									if($data['ResManager']){
										$resmanager = $data['ResManager'];
									}else{
										$resmanager = $data['ResOwner'];
									}
									$book = new Reservation_Model_Reservation();
									$book->setbokid($bookid);
									$bokMap = new Reservation_Model_ReservationDataMapper();
									$bookdetails = $bokMap->getBookingDetails($book);
										
									$row = $bokMap->GetRestaurantLogo($bookdetails->getbokfk_restaurant());
									if($row->reslogo){
										$logo = str_replace(" ","%20",$row->reslogo);
										$RestLogo = '<tr><td colspan="7" bgcolor="#e5e4de" height="12"></td></tr>
													 <tr>
													 	<td bgcolor="#e5e4de"></td>
													 	<td colspan="5" bgcolor="#FDF5E6" >
													 		<img src="http://www.dinedesk.com'.$logo.'" border="0"  height="60" style="position:relative;left:12;"/>
													 	</td>
													 	<td bgcolor="#e5e4de"></td>
													 </tr>';
									}else{
										$RestLogo = '<tr><td colspan="7"><img src="http://www.dinedesk.com/images/dinedesk-logo.png"  border="0" height="60"  usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2"></td></tr>';
									}
									
                                                                        include_once('Bitly.php');
                                                                        $url = "https://api-ssl.bit.ly/v3/shorten?access_token=51b00ed7df02a27be6d963de3ddbab78ec93a0cb&longUrl=".urlencode('http://www.dinedesk.com/Reservation/Reservation/instantfeedback/restaurantid/'.$data['ResId'].'/bookingid/'.$data['Bokid']);
                                                                        $url .= "&domain=bit.ly";
                                                                        $url .= "&x_login=dinedesk&x_apiKey=R_8d998f9995ad4c20b62750f2a364002d";

                                                                        $ch = curl_init($url);
                                                                        curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
                                                                        curl_setopt( $ch, CURLOPT_SSL_VERIFYPEER, false);
                                                                        $output = curl_exec($ch);
                                                                        $output = json_decode($output);
                                                                        curl_close($ch);
                                                                        if (isset($output->{'data'}->{'hash'})) {
                                                                                $result['url'] = $output->{'data'}->{'url'};
                                                                                $result['hash'] = $output->{'data'}->{'hash'};
                                                                                $result['global_hash'] = $output->{'data'}->{'global_hash'};
                                                                                $result['long_url'] = $output->{'data'}->{'long_url'};
                                                                                $result['new_hash'] = $output->{'data'}->{'new_hash'};
                                                                        }
                                                                        $result['status_code'] = $output->status_code;
                                                                        
                                                                        
                                                                        
									$subject = $template->msg_subject;
									$body    = $template->msg_body;
                                                                        
									if($result['status_code'] == 200){
                                                                        $body    = str_replace("%feedbacklink%",$result['url'],$body);
                                                                        }
									$body    = str_replace("%CusName%",$name,$body);
									$body    = str_replace("%restname%",$bookdetails->getresrestaurant_name(),$body);
									$body    = str_replace("%date%",$bookdetails->getbokbooking_date(),$body);
									$body    = str_replace("%manager%",$resmanager,$body);
									$body	 = str_replace("%address%",$bookdetails->getresaddress(),$body);
									$body	 = str_replace("%resemail%",$data['ResEmail'],$body);
									$body	 = str_replace("%reslogo%",$RestLogo,$body);
									$body 	 = str_replace("�",'',$body);
									$receiverslist = $data['SenTo'];
									
									$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
									$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
									$priorMapper = new Application_Model_PriorityDataMapper();
									$prior = $priorMapper->GetPriorityByCode('H');
									$msgMapper = new Communication_Model_EmailMessageDataMapper();
									$message = new Communication_Model_EmailMessage();
									$msgPhrase = uniqid ();
									$message->setPhrase($msgPhrase)
											->setBokid($bookid)
											->setTitle($mailobj->getMsgCode())
											->setDescription($body)
											->setPriority($prior->getcode())
											->setEmailtype($emailType->getcode())
											->setUsertype($userType)
											->setSentby('admin@dinedesk.com');
									$msgid = $msgMapper->SaveMessageDetails($message);
									$campId = '';
									$resLoc = $bokMap->getRestaurantLocByResId($bookdetails->getbokfk_restaurant());
									if($userType == 'CUS'){
										$cusMapper = new Communication_Model_EmailCusRecipentsDataMapper();
										$cusResult = $cusMapper->SaveCustMailDetails($msgid,$resLoc->resstate_id,$resLoc->rescity_id,$userType,$campId,$receiverslist);
									}
									
									
									$request = array(
										'subject' => $subject,
										'from'    => array( // required. A sender’s information
														'name'  => 'DiningWithUs',
														'email' => 'admin@diningwithus.com'
												),
										'signing_domain'=>'diningwithus.com',
										'to' => array(
												array(
													'name' => $data['UserName'],
													'email' => $receiverslist)
											),
										'html'       => $body, // email's HTML content
										'auto_plain' => true // automatically generate a text part for the messages of HTML part
									);
									$retval = $LeaderSendApi->messagesSend($request);
									if($LeaderSendApi->errorMessage){
										$mail->setFrom($fromaddress, $fromname);
								    	$mail->setReplyTo($fromaddress,$fromname);
								    	$mail->addTo( $receiverslist,$data['UserName']);
								    	$mail->setSubject($subject);
								    	$mail->setBodyHtml($body);
								    	$mail->send();
									}
								}
							}
							break;
						case 'ReqCredits' :
							
							if($language == "sp")
							{
								$mailobj->setMsgCode("ReqCredits_Sp");
								$template = $this->GetMessageTemplate($mailobj);
							}else{
								$template = $this->GetMessageTemplate($mailobj);
							}
							
							if($template){							
								$data     = $mailobj->getData();
								$resname = $data['RestName'];
								$userId = $data['UserId'];
								$credits = $data['Credits'];
								$amount = $data['Amount'].'/-';
								$query	=  $data['Query'];
								$resphone = $data['ResPhone'];
								$resemail = $data['ResEmail'];
								$resowner = $data['ResOwner'];
								$reslogo = $data['ResLogo'];
								$resaddress = $data['ResAddress'];
								
								if($reslogo){
									$logo = str_replace(" ","%20",$reslogo);
									$RestLogo = '<tr><td colspan="7" bgcolor="#e5e4de" height="12"></td></tr>
												 <tr>
												 	<td bgcolor="#e5e4de"></td>
												 	<td colspan="5" bgcolor="#FDF5E6" >
												 		<img src="http://www.dinedesk.com'.$logo.'" border="0"  height="60" style="position:relative;left:12;"/>
												 	</td>
												 	<td bgcolor="#e5e4de"></td>
												 </tr>';
								}else{
									$RestLogo = '<tr><td colspan="7"><img src="http://www.dinedesk.com/images/dinedesk-logo.png"  border="0" height="60"  usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2"></td></tr>';
								}
								
								$subject = $template->msg_subject;
								$body    = $template->msg_body;
								
								$body    = str_replace("%name%",$resowner,$body);
								$body    = str_replace("%restname%",$resname,$body);
								$body	 = str_replace("%resaddress%",$resaddress,$body);
								$body	 = str_replace("%email%",$resemail,$body);
								$body	 = str_replace("%phone%",$resphone,$body);
								$body	 = str_replace("%reslogo%",$RestLogo,$body);
								$body	 = str_replace("%credits%",$credits,$body);
								$body	 = str_replace("%amount%",$amount,$body);
								$body	 = str_replace("%comments%",$query,$body);
								$body 	 = str_replace("�",'',$body);
								$receiverslist = $data['SenTo'];
								
								
									$request = array(
										'subject' => $subject,
										'from'    => array( // required. A sender’s information
														'name'  => 'DineDesk',
														'email' => $fromaddress
												),
										'signing_domain'=>'dinedesk.com',
										'to' => array(
												array(
													'name' => 'Admin',
													'email' => $receiverslist)
											),
										'html'       => $body, // email's HTML content
										'auto_plain' => true // automatically generate a text part for the messages of HTML part
									);
								$retval = $LeaderSendApi->messagesSend($request);
								if($LeaderSendApi->errorMessage){
									$mail->setFrom($fromaddress, $fromname);
						    		$mail->setReplyTo($fromaddress,$fromname);
						    		$mail->addTo( $receiverslist,'Admin');
						    		$mail->setSubject($subject);
						    		$mail->setBodyHtml($body);
						    		$mail->send();
								}
							}
							break;
				}
			}
			}
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			return true;
		}
	}
	
	public function SendNegativeFeedNotification($negFeedArr)
	{
		try{
			$storage = new Zend_Auth_Storage_Session();
			$userData = $storage->read(); 
			if($userData['companyid'] != 6){
				$mapper = new Reservation_Model_ReservationDataMapper();
				$restInfo = $mapper->ReterieveRestFeedbackemails($negFeedArr['custDet']->getRestaurantId());
				if($restInfo){
					if($restInfo['Emailstatus']){
						/* postmark settings*/
						$fromaddress = 'admin@dinedesk.com';
						$replyfromaddress = 'support@dinedesk.com';
						$fromname = 'DineDesk';
						$replyfromname = 'DineDesk Support';
						
						$language = "en";
						$namespace = new Zend_Session_Namespace(); 
						if($namespace->lang && $namespace->lang == "es_SP"){
							$language = "sp";
						}
						$htmlStr = '';
						$count = 0;
						$feedMap = new FirmManagement_Model_FeedbackQuestionsMapper();
						$quesSelect = $feedMap->getDbTable()->select();	
						$quesSelect->setIntegrityCheck(false);	
						$quesSelect->from(array('mt.feedback_questions'),array('fbq_question'))
								->where('fbq_id IN (?)',$negFeedArr['negFeedQuesArr']);
						$quesResult = $feedMap->getDbTable()->fetchAll($quesSelect);
						$queResArr = array();
						foreach($quesResult as $querow){
							$queResArr[] = $querow->fbq_question;
						}
						$ansSelect = $feedMap->getDbTable()->select();	
						$ansSelect->setIntegrityCheck(false);	
						$ansSelect->from(array('mt.feedback_answers'),array('fba_answer'))
								->where('fba_id IN (?)',$negFeedArr['negFeedAnsArr']);
						$ansResult = $feedMap->getDbTable()->fetchAll($ansSelect);
						$ansResArr = array();
						foreach($ansResult as $ansrow){
							$ansResArr[] = $ansrow->fba_answer;
						}
						$mailobj = new Communication_Model_Mail(); 
						Zend_Mail::setDefaultTransport( new Zend_Mail_Transport_Postmark('7c73f7f1-c2e6-4bbd-aa4b-fc1dadcb7da8' ));
						$mail = new Zend_Mail();
						$mailobj->setMsgCode("NegFeedBack");
						$template = $this->GetMessageTemplate($mailobj);
						$resServ = new Application_Service_Firm();
						$restDet = $resServ->GetRestaurantDetailsById($negFeedArr['custDet']->getRestaurantId());
		//				$mapper = new Reservation_Model_ReservationDataMapper();
		//				$restInfo = $mapper->ReterieveRestFeedbackemails($negFeedArr['custDet']->getRestaurantId());
						if($template){
							$custDet = $negFeedArr['custDet'];
							$name    = $custDet->getFirstName().' '.$custDet->getLastName();
							$phone = $custDet->getPhone();
							$email = $custDet->getEmail();
							$commentArr = $negFeedArr['comments'];
							$restname = $restDet->resrestaurant_name;
							$subject = $template->msg_subject;
							$body    = $template->msg_body;				
							$htmlStr .= '<tr><td colspan="4"><table width="100%" class="report_table">';
							for($i=0;$i<count($queResArr);$i++){
								$htmlStr .= '<tr><td><p>Q : &nbsp;&nbsp;'.$queResArr[$i].'</p></td></tr><tr><td class="answerTd"><p>A : &nbsp;&nbsp;'.$ansResArr[$i].'</p></td></tr>';
							}
							$htmlStr .= '</table></td></tr>';
							$resid = $negFeedArr['custDet']->getRestaurantId();
							if(isset($resid)){
								$row = $mapper->GetRestaurantLogo($negFeedArr['custDet']->getRestaurantId());
								if($row->reslogo){
									$logo = str_replace(" ","%20",$row->reslogo);
									$RestLogo = '<tr><td colspan="7"><img src="http://www.dinedesk.com'.$logo.'"  border="0" height="60" usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2" /></td></tr>';
								}else{
									$RestLogo = '<tr><td colspan="7"><img src="http://www.dinedesk.com/images/dinedesk-logo.png"  border="0" height="60"  usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2" /></td></tr>';
								}
							}else{
									$RestLogo = '<tr><td colspan="7"><img src="http://www.dinedesk.com/images/dinedesk-logo.png"  border="0" height="60"  usemap="#13e1cd4929ae2521_13dec7e4497b1541_Map2" /></td></tr>';
							}
							$body    = str_replace("%reslogo%",$RestLogo,$body);
							$body    = str_replace("%restname%",$restname,$body);
							$body    = str_replace("%custname%",$name,$body);
							$body    = str_replace("%phone%",$phone,$body);
							$body    = str_replace("%email%",$email,$body);
							$body    = str_replace("%comment%",$commentArr['fbcc_comment'],$body);
							$body    = str_replace("%rating%",$commentArr['fbcc_rating'],$body);
							$body    = str_replace("%commentid%",$negFeedArr['commentId'],$body);
							$body    = str_replace("%review%",$htmlStr,$body);
							$body 	 = str_replace("�",'',$body);
							$receiverslist = $restInfo['emails'];
							$userType ="RES";
							$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
							$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
							$priorMapper = new Application_Model_PriorityDataMapper();
							$prior = $priorMapper->GetPriorityByCode('H');
							$msgMapper = new Communication_Model_EmailMessageDataMapper();
							$message = new Communication_Model_EmailMessage();
							$msgPhrase = uniqid ();
							$message->setPhrase($msgPhrase)
									->setTitle($mailobj->getMsgCode())
									->setDescription($body)
									->setPriority($prior->getcode())
									->setEmailtype($emailType->getcode())
									->setUsertype($userType)
									->setSentby('admin@dinedesk.com');
							$msgid = $msgMapper->SaveMessageDetails($message);
							
							$src = "http://www.dinedesk.com/Communication/Communication/emailcommunication/msgid/".$msgPhrase;
							$body	 = str_replace("%bookingsrc%",$src,$body);
							if($userType == 'RES'){
								$ResMapper = new Communication_Model_EmailRestRecipentsDataMapper();
								$ResResult = $ResMapper->SaveRestMailDetailsForFeedback($msgid,$userType,$campId="",$receiverslist);
							}
							
							$mail->setFrom($fromaddress, $fromname);
						    $mail->setReplyTo($fromaddress,$fromname);
						    $mail->addTo( $receiverslist,$name);
						    $mail->setSubject($subject);
						    $mail->setBodyHtml($body);
						    $mail->send();
						}
					}
					if($restInfo['SmsStatus']){
						$FeedbackPhonemapper = new FirmManagement_Model_FirmFeedBackPhoneNumbersDataMapper();
						$phoneInfo = $FeedbackPhonemapper->ReterieveRestFeedbackphonenumbers($negFeedArr['custDet']->getRestaurantId());
						$commentArr = $negFeedArr['comments'];
						if($phoneInfo['phone']){
							$smsbody = 'Hi, A guest has provided his/her dining experience at your restaurant '.$restname.'.Feedback : '.$commentArr['fbcc_comment'].'. Rating : '.$commentArr['fbcc_rating'];
						/* Sms Message Saving Start */
						$custDet = $negFeedArr['custDet'];
						$name    = $custDet->getFirstName().' '.$custDet->getLastName();
						$phone = $custDet->getPhone();
						$email = $custDet->getEmail();
						$priorMapper = new Application_Model_PriorityDataMapper();
						$prior = $priorMapper->GetPriorityByCode('H');
						$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
						$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
							foreach($phoneInfo['phone'] as $mobile){
								if(strlen($mobile) >= 10){	
									$msgMapper = new Communication_Model_SmsMessageMapper();
									$message = new Communication_Model_SmsMessage();
									$msgPhrase = uniqid ();
									$message->setPhrase($msgPhrase)
											->setDescription($smsbody)
											->setPriority($prior->getcode())
											->setSmstype($emailType->getcode())
											->setSentToUser('RES')
											->setSentTo($mobile)
											->setSentFromUser('ADMIN')
											->setSentby($restname)
											->setTitle("Cancel");
								
									$msgid = $msgMapper->SaveMessageDetails($message);
									$mobilenumbersArr[]= $mobile;
									$messageArray[] = $message;
								}
							}
						/* Sms Message Saving End */
						
							if($mobilenumbersArr){
								//$mobilenumbers = implode(',',$mobilenumbersArr);	
								$mailStatus = $this->sendFeedBackSMS($smsbody,$mobilenumbersArr);

								// $stat = substr($mailStatus,7,1);
								// $bufferstring = substr(strstr($mailStatus, ','),1);
								// if($stat == 0){
								// 	$bufferarray = explode(',',$bufferstring);
								// 	$msgMapper->UpdateArrMessageDetails($messageArray,$bufferarray);
								// }else{
								// 	$message->setTransId($bufferstring);
								// 	$msgMapper->UpdateArrMessageDetails($messageArray,$bufferstring);
								// }	
							}
						}
					}
				}				
			}
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			return true;
		}
	}
	
	public function PhoneNotify(Communication_Model_Mail $mailobj)
	{
		if($mailobj){
			$phoneNotifyHelper = new Uss_Helper_PhoneNotifyHelper();
			$data = $mailobj->getData();
			$message   = "";
			$firstname = "";
			$lastname  = "";
			
			$template = "~\ActOnDigitPress(false)~ 
						 ~\ClearDTMF()~ 
						 ~\SetVar(Attempt|1)~
						 This is you reserve, you received a reservation for today.
						 ~\Label(TopMenu)~ 
						 ~\AssignDTMF(1|ReservationConfirm)~
						 ~\ActOnDigitPress(true)~ 
						 Press 1, for your reservation. 
						 ~\WaitForDTMF(10)~ 
						 ~\IncreaseVariable(Attempt|1)~ 
						 ~\GotoIf(Attempt|1|TopMenu)~ 
						 ~\GotoIf(Attempt|4|AttemptEnd)~ 
						 ~\Label(RepeatMenu)~ 
						 Please choose from the following options. 
						 ~\Goto(TopMenu)~ 
						 ~\Label(AttemptEnd)~ 
						 ~\EndCall()~ 
						 ~\Label(ReservationConfirm)~ 
						 %message%						 
						 ~\Label(MenuRepeat)~ 
						 ~\AssignDTMF(2|Start)~										 
						 ~\AssignDTMF(3|HangUp)~ 
						 ~\ActOnDigitPress(true)~ 
						 To repeat the message, press 2.						
						 To end the call, press 3. 
						 ~\WaitForDTMF(10)~ 
						 ~\IncreaseVariable(Attempt|1)~ 
						 ~\GotoIf(Attempt|1|TopMenu)~ 
						 ~\GotoIf(Attempt|4|AttemptEnd)~ 
						 ~\Label(RepeatMenu)~ 
						 Please choose from the following options. 
						 ~\Goto(MenuRepeat)~ 
						 ~\Label(AttemptEnd)~ 
						 ~\EndCall()~ 
						 ~\Label(HangUp)~ 
						 ~\EndCall()~";
			
			switch($mailobj->getMsgCode()){
				case 'BookNotf' :
									
					/* Add breaks to first name */	
					$cusfirstname = $data['Firstname'];
					$firstNamelength = strlen($cusfirstname);
					
					for($i=0; $i < $firstNamelength; $i++){
						$firstname .= $cusfirstname[$i]."<break />";
					}		
					
					/* Add breaks to last name */	
					$cuslastname = $data['Lastname'];
					$lastNamelength = strlen($cuslastname);
					
					for($i=0; $i < $lastNamelength; $i++){
						$lastname .= $cuslastname[$i]."<break />";
					}
					$reservPhone = '';
					$phone = '';
					$cusPhone = $data['ResvPhone'];
					if($data['ResvPhone']){
						for($i = 0;$i < strlen($cusPhone); $i++){
							$phone .= $cusPhone[$i]."<break />";
						}
						$reservPhone = "Phone number <break />".$phone ."<break />";
					}
					if($data['Note']){
						$message = "the reservation time is <break />". $data['ResvTime'] ."<break /> Party Size <break />". $data['Pax'] ."<break /> Last Name <break />".$cuslastname." <break />". $lastname ."<break /><break /> First Name <break />".$cusfirstname ."<break />". $firstname ."<break /><break />".$reservPhone ." Special Request <break />". $data['Note'];
					}else{
						$message = "the reservation time is <break />". $data['ResvTime'] ."<break /> Party Size <break />". $data['Pax'] ."<break /> Last Name <break />".$cuslastname." <break />". $lastname ."<break /><break /> First Name <break />".$cusfirstname ."<break />". $firstname ."<break /><break />".$reservPhone ;
					}
					$template = str_replace('%message%',$message,$template);
					
					$result = $phoneNotifyHelper->phone_notify_queueCall($data['PhoneNumber'],$template,'');
					break;
					
				case 'CancelNotf' :			
									
					/* Add breaks to first name */	
					$cusfirstname = $data['Firstname'];
					$firstNamelength = strlen($cusfirstname);
					
					for($i=0; $i < $firstNamelength; $i++){
						$firstname .= $cusfirstname[$i]."<break />";
					}		
					
					/* Add breaks to last name */	
					$cuslastname = $data['Lastname'];
					$lastNamelength = strlen($cuslastname);
					
					for($i=0; $i < $lastNamelength; $i++){
						$lastname .= $cuslastname[$i]."<break />";
					}
					
					$message = 'You just received a cancellation of a reservation for your restaurant for <break />'.$cuslastname.' <break />'. $lastname .'<break /><break />'.$cusfirstname .'<break />'. $firstname .'<break /><break /> for a party of <break />'. $data['Pax'] .'<break /> at <break />'. $data['ResvTime'] .'<break /> on <say-as format="ymd" interpret-as="date">'. $data['ResvDate'] .'</say-as>';					
					$template = str_replace('%message%',$message,$template);	
									
					$result = $phoneNotifyHelper->phone_notify_queueCall($data['PhoneNumber'],$template,'');
					
					break;
					
			}
		}	
	}
	
	public function SendSms(Communication_Model_Sms $smsobj)
	{
		try{
			$storage = new Zend_Auth_Storage_Session();
			$userData = $storage->read();
			$hungryHubResIds = array(209,210,211);
			if(($userData['companyid'] != 6 )&&(!in_array($userData['RestId'],$hungryHubResIds))){ 
				if($smsobj){	
        	
					switch($smsobj->getMsgCode()){
						case 'BookConf' :
							$template = $this->GetSmstemplate($smsobj);
							if($template && (!strstr($mobile,'9840797797') && !strstr($mobile,'9551982272'))){
								$data = $smsobj->getData();
								$mobile	  = str_replace("-","",$data['to']);
								$bokid 	  = $data['bokid'];
								$bokMapper = new Reservation_Model_ReservationDataMapper();
								$resLoc = $bokMapper->getRestaurantLocByBookingId($bokid);
								$restname = $data['RestName'];
                                $dateSplit = explode("-",$data['ResDate']);
                                if($dateSplit[0] > 12){
                                    $s = mktime(0,0,0,$dateSplit[1],$dateSplit[2],$dateSplit[0]);
                                }else{
                                    $s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
                                }
						//			$resdate  = date('l, j F Y',$s);
									$resdate  = date('l, d F',$s);
								$time     = $data['Time'];
								$size     = $data['Size'];
								$name     = $data['CustomerName'];
								$objUs = "";	 
								//$address  = $data['Address'];
								$body=	$template->msg_body;
								$body    = str_replace("%bokid%",'Booking Id '.$bokid,$body);
								$body    = str_replace("%ResturantName%",$restname,$body);
								$body    = str_replace("%date%",$resdate,$body);
								$body    = str_replace("%time%",$time,$body);
								$body    = str_replace("%size%",$size,$body);

								if($userData['RestId'] == 257)
								{
									// CUSTOM TEXT FOR BARBEQUE PRIDE
									$body .= " Max Hold 15min";
								}
								
								/* Sms Message Saving Start */
								$msgMapper = new Communication_Model_SmsMessageMapper();
								$priorMapper = new Application_Model_PriorityDataMapper();
								$prior = $priorMapper->GetPriorityByCode('H');
								$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
								$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
								$message = new Communication_Model_SmsMessage();
								$msgPhrase = uniqid ();
								$message->setBokid($bokid)
											->setPhrase($msgPhrase)
											->setDescription($body)
											->setPriority($prior->getcode())
											->setSmstype($emailType->getcode())
											->setSentToUser('CUS')
											->setSentTo($name)
											->setSentFromUser('ADMIN')
											->setSentby($restname)
											->setTitle($smsobj->getMsgCode());
								
								$msgid = $msgMapper->SaveMessageDetails($message);
								/* Sms Message Saving End */
								$mailStatus = $this->SendMessage($body,$mobile,$resLoc,$data['countrycode']);
								if($data['countrycode'] == '+91'){
									$message->setTransId(substr(strstr($mailStatus, ','),1));
									$msgMapper->UpdateMessageDetails($message);	
								}else if($resLoc->res_companyid == 1){
									$objUs = json_decode($mailStatus,true);
									if($objUs['messages'][0]['status'] == 0){
										$message->setTransId($objUs['messages'][0]['message-id']);
										$msgMapper->UpdateMessageDetails($message);	
									}else{
										$message->setTransId($objUs['messages'][0]['error-text']);
										$msgMapper->UpdateMessageDetails($message);	
									}
								}
							}
							break;
         case 'BookRecvd' :
							$template = $this->GetSmstemplate($smsobj);
							if($template && (!strstr($mobile,'9840797797') && !strstr($mobile,'9551982272'))){
								$data = $smsobj->getData();
								$mobile	  = str_replace("-","",$data['to']);
								$bokid 	  = $data['bokid'];
								$bokMapper = new Reservation_Model_ReservationDataMapper();
								$resLoc = $bokMapper->getRestaurantLocByBookingId($bokid);
								$restname = $data['RestName'];
                                $dateSplit = explode("-",$data['ResDate']);
                                if($dateSplit[0] > 12){
                                    $s = mktime(0,0,0,$dateSplit[1],$dateSplit[2],$dateSplit[0]);
                                }else{
                                    $s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
                                }
						//			$resdate  = date('l, j F Y',$s);
									$resdate  = date('l, d F',$s);
								$time     = $data['Time'];
								$size     = $data['Size'];
								$name     = $data['CustomerName'];
								$objUs = "";	 
								//$address  = $data['Address'];
								$body=	$template->msg_body;
								$body    = str_replace("%bokid%",'Booking Id '.$bokid,$body);
								$body    = str_replace("%ResturantName%",$restname,$body);
								$body    = str_replace("%date%",$resdate,$body);
								$body    = str_replace("%time%",$time,$body);
								$body    = str_replace("%size%",$size,$body);
								
								/* Sms Message Saving Start */
								$msgMapper = new Communication_Model_SmsMessageMapper();
								$priorMapper = new Application_Model_PriorityDataMapper();
								$prior = $priorMapper->GetPriorityByCode('H');
								$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
								$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
								$message = new Communication_Model_SmsMessage();
								$msgPhrase = uniqid ();
								$message->setBokid($bokid)
											->setPhrase($msgPhrase)
											->setDescription($body)
											->setPriority($prior->getcode())
											->setSmstype($emailType->getcode())
											->setSentToUser('CUS')
											->setSentTo($name)
											->setSentFromUser('ADMIN')
											->setSentby($restname)
											->setTitle($smsobj->getMsgCode());
								
								$msgid = $msgMapper->SaveMessageDetails($message);
								/* Sms Message Saving End */
								$mailStatus = $this->SendMessage($body,$mobile,$resLoc,$data['countrycode']);
								if($data['countrycode'] == '+91'){
									$message->setTransId(substr(strstr($mailStatus, ','),1));
									$msgMapper->UpdateMessageDetails($message);	
								}else if($resLoc->res_companyid == 1){
									$objUs = json_decode($mailStatus,true);
									if($objUs['messages'][0]['status'] == 0){
										$message->setTransId($objUs['messages'][0]['message-id']);
										$msgMapper->UpdateMessageDetails($message);	
									}else{
										$message->setTransId($objUs['messages'][0]['error-text']);
										$msgMapper->UpdateMessageDetails($message);	
									}
								}
							}
							break; 
                                                        
						case 'BookNotf' :
							$template = $this->GetSmstemplate($smsobj);
							if($template){
								$data = $smsobj->getData();
								$mobile	  = str_replace("-","",$data['to']);
								$bokid 	  = $data['bokid'];
								$bokMapper = new Reservation_Model_ReservationDataMapper();
								$resLoc = $bokMapper->getRestaurantLocByBookingId($bokid);
								$restname = $data['RestName'];
								$dateSplit = explode("-",$data['ResDate']);
                                if($dateSplit[0] > 12){
                                    $s = mktime(0,0,0,$dateSplit[1],$dateSplit[2],$dateSplit[0]);
                                }else{
                                    $s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
                                }
						//			$resdate  = date('l, j F Y',$s);
									$resdate  = date('l, d F',$s);
								$time     = $data['Time'];
								$size     = $data['Size'];
								$name     = $data['CustomerName'];
								$objUs = "";	
								
								//$address  = $data['Address'];
								$body=	$template->msg_body;
								$body    = str_replace("%bokid%",$bokid,$body);
								$body    = str_replace("%restname%",$restname,$body);
								$body    = str_replace("%date%",$resdate,$body);
								$body    = str_replace("%time%",$time,$body);
								$body    = str_replace("%size%",$size,$body);
								$body    = str_replace("%custname%",$name,$body);
								
								/* Sms Message Saving Start */
								$msgMapper = new Communication_Model_SmsMessageMapper();
								$priorMapper = new Application_Model_PriorityDataMapper();
								$prior = $priorMapper->GetPriorityByCode('H');
								$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
								$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
								$message = new Communication_Model_SmsMessage();
								$msgPhrase = uniqid ();
								$message->setBokid($bokid)
											->setPhrase($msgPhrase)
											->setDescription($body)
											->setPriority($prior->getcode())
											->setSmstype($emailType->getcode())
											->setSentToUser('RES')
											->setSentTo($name)
											->setSentFromUser('ADMIN')
											->setSentby($restname)
											->setTitle($smsobj->getMsgCode());
								
								$msgid = $msgMapper->SaveMessageDetails($message);
								$countrycode = "";
								if($data['countrycode']){
									$countrycode = $data['countrycode'];
								}else{
									$countrycode = $resLoc->country_dial_code;
								}
								/* Sms Message Saving End */
								$mailStatus = $this->SendMessage($body,$mobile,$resLoc,$countrycode);
								if($data['countrycode'] == '+91'){
									$message->setTransId(substr(strstr($mailStatus, ','),1));
									$msgMapper->UpdateMessageDetails($message);	
								}else if($resLoc->res_companyid == 1){
									$objUs = json_decode($mailStatus,true);
									if($objUs['messages'][0]['status'] == 0){
										$message->setTransId($objUs['messages'][0]['message-id']);
										$msgMapper->UpdateMessageDetails($message);	
									}else{
										$message->setTransId($objUs['messages'][0]['error-text']);
										$msgMapper->UpdateMessageDetails($message);	
									}
								}
							}
							break;
							
						case 'CanNotf' :
							$template = $this->GetSmstemplate($smsobj);
							if($template){
								$data = $smsobj->getData();
								$mobile	  = str_replace("-","",$data['to']);
								$bokid 	  = $data['bokid'];
								$bokMapper = new Reservation_Model_ReservationDataMapper();
								$resLoc = $bokMapper->getRestaurantLocByBookingId($bokid);
								$restname = $data['RestName'];
								$dateSplit = explode("-",$data['ResDate']);
								if($dateSplit[0] > 12){
                                    $s = mktime(0,0,0,$dateSplit[1],$dateSplit[2],$dateSplit[0]);
                                }else{
                                    $s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
                                }
						//			$resdate  = date('l, j F Y',$s);
									$resdate  = date('l, d F',$s);
								$time     = $data['Time'];
								$size     = $data['Size'];
								$name     = $data['CustomerName'];
								$objUs = "";	
								
								$body	 =	$template->msg_body;
								$body    = str_replace("%bokid%",$bokid,$body);
								$body    = str_replace("%restname%",$restname,$body);
								$body    = str_replace("%date%",$resdate,$body);
								$body    = str_replace("%time%",$time,$body);
								$body    = str_replace("%size%",$size,$body);
								$body    = str_replace("%custname%",$name,$body);
								
								/* Sms Message Saving Start */
								$msgMapper = new Communication_Model_SmsMessageMapper();
								$priorMapper = new Application_Model_PriorityDataMapper();
								$prior = $priorMapper->GetPriorityByCode('H');
								$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
								$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
								$message = new Communication_Model_SmsMessage();
								$msgPhrase = uniqid ();
								$message->setBokid($bokid)
											->setPhrase($msgPhrase)
											->setDescription($body)
											->setPriority($prior->getcode())
											->setSmstype($emailType->getcode())
											->setSentToUser('RES')
											->setSentTo($name)
											->setSentFromUser('ADMIN')
											->setSentby($restname)
											->setTitle($smsobj->getMsgCode());
								
								$msgid = $msgMapper->SaveMessageDetails($message);
								/* Sms Message Saving End */
								$mailStatus = $this->SendMessage($body,$mobile,$resLoc,$data['countrycode']);
								if($data['countrycode'] == '+91'){
									$message->setTransId(substr(strstr($mailStatus, ','),1));
									$msgMapper->UpdateMessageDetails($message);	
								}else if($resLoc->res_companyid == 1){
									$objUs = json_decode($mailStatus,true);
									if($objUs['messages'][0]['status'] == 0){
										$message->setTransId($objUs['messages'][0]['message-id']);
										$msgMapper->UpdateMessageDetails($message);	
									}else{
										$message->setTransId($objUs['messages'][0]['error-text']);
										$msgMapper->UpdateMessageDetails($message);	
									}
								}
							}
							break;
						case 'ReSchedule' :
							$template = $this->GetSmstemplate($smsobj);
							if($template){
								$data = $smsobj->getData();
								$mobile	  = str_replace("-","",$data['to']);
								$bokid 	  = $data['bokid'];
								$bokMapper = new Reservation_Model_ReservationDataMapper();
								$resLoc = $bokMapper->getRestaurantLocByBookingId($bokid);
								$restname = $data['RestName'];
								$dateSplit = explode("-",$data['ResDate']);
								if($dateSplit[0] > 12){
                                    $s = mktime(0,0,0,$dateSplit[1],$dateSplit[2],$dateSplit[0]);
                                }else{
                                    $s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
                                }
						//			$resdate  = date('l, j F Y',$s);
									$resdate  = date('l, d F',$s);
								$time     = $data['Time'];
								$size     = $data['Size'];
								$name     = $data['CustomerName'];
								//$address  = $data['Address'];
								$body=	$template->msg_body;
								$body    = str_replace("%bokid%",$bokid,$body);
								$body    = str_replace("%ResturantName%",$restname,$body);
								$body    = str_replace("%date%",$resdate,$body);
								$body    = str_replace("%time%",$time,$body);
								$body    = str_replace("%size%",$size,$body);
								$objUs = "";	
								
								/* Sms Message Saving Start */
								$msgMapper = new Communication_Model_SmsMessageMapper();
								$priorMapper = new Application_Model_PriorityDataMapper();
								$prior = $priorMapper->GetPriorityByCode('H');
								$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
								$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
								$message = new Communication_Model_SmsMessage();
								$msgPhrase = uniqid ();
								$message->setBokid($bokid)
											->setPhrase($msgPhrase)
											->setDescription($body)
											->setPriority($prior->getcode())
											->setSmstype($emailType->getcode())
											->setSentToUser('CUS')
											->setSentTo($name)
											->setSentFromUser('ADMIN')
											->setSentby($restname)
											->setTitle($smsobj->getMsgCode());
								
								$msgid = $msgMapper->SaveMessageDetails($message);
								/* Sms Message Saving End */
								$mailStatus = $this->SendMessage($body,$mobile,$resLoc,$data['countrycode']);
								if($data['countrycode'] == '+91'){
									$message->setTransId(substr(strstr($mailStatus, ','),1));
									$msgMapper->UpdateMessageDetails($message);	
								}else if($resLoc->res_companyid == 1){
									$objUs = json_decode($mailStatus,true);
									if($objUs['messages'][0]['status'] == 0){
										$message->setTransId($objUs['messages'][0]['message-id']);
										$msgMapper->UpdateMessageDetails($message);	
									}else{
										$message->setTransId($objUs['messages'][0]['error-text']);
										$msgMapper->UpdateMessageDetails($message);	
									}
								}
							}					
							break;					
						case 'Cancel' :
							$template = $this->GetSmstemplate($smsobj);
							if($template){
								$data = $smsobj->getData();
								$mobile	  = str_replace("-","",$data['to']);
								$bokid 	  = $data['bokid'];
								$bokMapper = new Reservation_Model_ReservationDataMapper();
								$resLoc = $bokMapper->getRestaurantLocByBookingId($bokid);
								$restname = $data['RestName'];
								$dateSplit = explode("-",$data['ResDate']);
								if($dateSplit[0] > 12){
                                    $s = mktime(0,0,0,$dateSplit[1],$dateSplit[2],$dateSplit[0]);
                                }else{
                                    $s = mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]);
                                }
						//			$resdate  = date('l, j F Y',$s);
									$resdate  = date('l, d F',$s);
								$time     = $data['Time'];
								$size     = $data['Size'];
								$name     = $data['CustomerName'];
								$body=	$template->msg_body;
								$body    = str_replace("%RestaurantName%",$restname,$body);
								$body    = str_replace("%date%",$resdate,$body);
								$body    = str_replace("%time%",$time,$body);
								$body    = str_replace("%size%",$size,$body); 
								$objUs = "";	
								
								/* Sms Message Saving Start */
								$msgMapper = new Communication_Model_SmsMessageMapper();
								$priorMapper = new Application_Model_PriorityDataMapper();
								$prior = $priorMapper->GetPriorityByCode('H');
								$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
								$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
								$message = new Communication_Model_SmsMessage();
								$msgPhrase = uniqid ();
								$message->setBokid($bokid)
											->setPhrase($msgPhrase)
											->setDescription($body)
											->setPriority($prior->getcode())
											->setSmstype($emailType->getcode())
											->setSentToUser('CUS')
											->setSentTo($name)
											->setSentFromUser('ADMIN')
											->setSentby($restname)
											->setTitle($smsobj->getMsgCode());
								
								$msgid = $msgMapper->SaveMessageDetails($message);
								/* Sms Message Saving End */
								$mailStatus = $this->SendMessage($body,$mobile,$resLoc,$data['countrycode']);
								if($data['countrycode'] == '+91'){
									$message->setTransId(substr(strstr($mailStatus, ','),1));
									$msgMapper->UpdateMessageDetails($message);	
								}else if($resLoc->res_companyid == 1){
									$objUs = json_decode($mailStatus,true);
									if($objUs['messages'][0]['status'] == 0){
										$message->setTransId($objUs['messages'][0]['message-id']);
										$msgMapper->UpdateMessageDetails($message);	
									}else{
										$message->setTransId($objUs['messages'][0]['error-text']);
										$msgMapper->UpdateMessageDetails($message);	
									}
								}
							}					
							break;
						case 'BookOtp' :
							$template = $this->GetSmstemplate($smsobj);
							if($template){
								$data = $smsobj->getData();
								$mobile	  = str_replace("-","",$data['to']);
								$bokMapper = new Reservation_Model_ReservationDataMapper();
								$resLoc = $bokMapper->getRestaurantLocByResId($data['ResId']);
								$restname = $resLoc->resrestaurant_name;
								$name     = $data['CustomerName'];
								$body=	$template->msg_body;
								$body    = str_replace("%otp%",$data['OtpVal'],$body); 
								$objUs = "";	
								
								/* Sms Message Saving Start */
								$msgMapper = new Communication_Model_SmsMessageMapper();
								$priorMapper = new Application_Model_PriorityDataMapper();
								$prior = $priorMapper->GetPriorityByCode('H');
								$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
								$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
								$message = new Communication_Model_SmsMessage();
								$msgPhrase = uniqid ();
		//							$message->setBokid($bokid)
								$message->setPhrase($msgPhrase)
											->setDescription($body)
											->setPriority($prior->getcode())
											->setSmstype($emailType->getcode())
											->setSentToUser('CUS')
											->setSentTo($name)
											->setSentFromUser('ADMIN')
											->setSentby($restname)
											->setTitle($smsobj->getMsgCode());
								
								$msgid = $msgMapper->SaveMessageDetails($message);
								if($data['countrycode'] == ''){
									if($resLoc->state == 'IND'){
										$data['countrycode'] = '+91';
									}
								}
								/* Sms Message Saving End */
								$mailStatus = $this->SendMessage($body,$mobile,$resLoc,$data['countrycode']);
								if($data['countrycode'] == '+91'){
									$message->setTransId(substr(strstr($mailStatus, ','),1));
									$msgMapper->UpdateMessageDetails($message);	
								}else if($resLoc->res_companyid == 1){
									$objUs = json_decode($mailStatus,true);
									if($objUs['messages'][0]['status'] == 0){
										$message->setTransId($objUs['messages'][0]['message-id']);
										$msgMapper->UpdateMessageDetails($message);	
									}else{
										$message->setTransId($objUs['messages'][0]['error-text']);
										$msgMapper->UpdateMessageDetails($message);	
									}
								}
							}					
							break;
						case 'WaitingReserv' :
							$template = $this->GetSmstemplate($smsobj);
							if($template){
								$data = $smsobj->getData();
								$bokid 	  = $data['BookId'];
								$bokMapper = new Reservation_Model_ReservationDataMapper();
								$resLoc = $bokMapper->getRestaurantLocByBookingId($bokid);
								$resServ = new Application_Service_Firm();
								$timeZone = $resServ->GetRestaurantTimeZone($resLoc->resid);
								date_default_timezone_set($timeZone);
								$mobile	  = str_replace("-","",$data['to']);
								$user = $data['UserName'];
								$quote = $data['Quote'];
								$restname = $data['RestName'];
								$objUs = "";	
								$body=	$template->msg_body;
								
								$body    = str_replace("%custname%",$user,$body);
								if($resLoc->resid == 110){
									$body    = str_replace("%waittime%",'or grab a drink at the bar while we find a table for you ',$body);
								}else{
									if($quote){
										$body    = str_replace("%waittime%",'for '.$quote,$body);
									}else{
										$body    = str_replace("%waittime%",' ',$body);
									}
								}
								
								/* short url generation code start*/
								
								/* get phrase id with booking */
								$phraseId = $bokMapper->GetBookingPhraseByBookid($bokid);
								include_once('Bitly.php');
								$url = "https://api-ssl.bit.ly/v3/shorten?access_token=51b00ed7df02a27be6d963de3ddbab78ec93a0cb&longUrl=".urlencode('http://www.dinedesk.com/waitbook/'.$phraseId);
								$url .= "&domain=bit.ly";
								$url .= "&x_login=dinedesk&x_apiKey=R_8d998f9995ad4c20b62750f2a364002d";
								
								$ch = curl_init($url);
								curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
								curl_setopt( $ch, CURLOPT_SSL_VERIFYPEER, false);
								$output = curl_exec($ch);
								$output = json_decode($output);
								curl_close($ch);
								if (isset($output->{'data'}->{'hash'})) {
									$result['url'] = $output->{'data'}->{'url'};
									$result['hash'] = $output->{'data'}->{'hash'};
									$result['global_hash'] = $output->{'data'}->{'global_hash'};
									$result['long_url'] = $output->{'data'}->{'long_url'};
									$result['new_hash'] = $output->{'data'}->{'new_hash'};
								}
								$result['status_code'] = $output->status_code;
								if($result['status_code'] == 200){
									$body    = str_replace("%restname%",$restname.' Access reservation '.$result['url'],$body);
								}else{
									$body    = str_replace("%restname%",$restname,$body);
								}
								
								/* short url generation code end */
								
								/* Sms Message Saving Start */
								$msgMapper = new Communication_Model_SmsMessageMapper();
								$priorMapper = new Application_Model_PriorityDataMapper();
								$prior = $priorMapper->GetPriorityByCode('H');
								$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
								$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
								$message = new Communication_Model_SmsMessage();
								$msgPhrase = uniqid ();
								$message->setBokid($bokid)
											->setPhrase($msgPhrase)
											->setDescription($body)
											->setPriority($prior->getcode())
											->setSmstype($emailType->getcode())
											->setSentToUser('CUS')
											->setSentTo($user)
											->setSentFromUser('ADMIN')
											->setSentby($restname)
											->setTitle($smsobj->getMsgCode());
								
								$msgid = $msgMapper->SaveMessageDetails($message);
								/* Sms Message Saving End */
								
								$smsdata = array('PhoneNumber' => $mobile,
												 'Message'	   => $body,
												 'ReferenceID' => $msgPhrase);
								
								$advanceSms = New Uss_Helper_SmsNotifyHelper();
								$mailStatus = $this->SendMessage($body,$mobile,$resLoc,$data['countrycode']);
								if($data['countrycode'] == '+91'){
									$message->setTransId(substr(strstr($mailStatus, ','),1));
									$msgMapper->UpdateMessageDetails($message);	
								}else if($resLoc->res_companyid == 1){
									$objUs = json_decode($mailStatus,true);
									if($objUs['messages'][0]['status'] == 0){
										$message->setTransId($objUs['messages'][0]['message-id']);
										$msgMapper->UpdateMessageDetails($message);	
									}else{
										$message->setTransId($objUs['messages'][0]['error-text']);
										$msgMapper->UpdateMessageDetails($message);	
									}
								}
							} 
							return $mailStatus;
							break;
						case 'WaitingCustMsg' :
							$template = $this->GetSmstemplate($smsobj);
							if($template){
								$data = $smsobj->getData();
								$mobile	  = str_replace("-","",$data['to']);
								$bokid 	  = $data['BookId'];
								$restname = $data['RestName'];
								$bokMapper = new Reservation_Model_ReservationDataMapper();
								$resLoc = $bokMapper->getRestaurantLocByBookingId($bokid);
								$resServ = new Application_Service_Firm();
								$timeZone = $resServ->GetRestaurantTimeZone($resLoc->resid);
								date_default_timezone_set($timeZone);
								$user = $data['UserName'];
								$message = $data['custMsg'];
								$objUs = "";	
								$body=	$template->msg_body;
								
								$body    = str_replace("%custname%",$user,$body);
								$body    = str_replace("%msg%",$message,$body);
								
								if($data['Sender'] == 'RES'){
									/* short url generation code start*/
									
									/* get phrase id with booking */
									$phraseId = $bokMapper->GetBookingPhraseByBookid($bokid);
									include_once('Bitly.php');
									$url = "https://api-ssl.bit.ly/v3/shorten?access_token=51b00ed7df02a27be6d963de3ddbab78ec93a0cb&longUrl=".urlencode('http://www.dinedesk.com/waitbook/'.$phraseId);
									$url .= "&domain=bit.ly";
									$url .= "&x_login=dinedesk&x_apiKey=R_8d998f9995ad4c20b62750f2a364002d";
									
									$ch = curl_init($url);
									curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
									curl_setopt( $ch, CURLOPT_SSL_VERIFYPEER, false);
									$output = curl_exec($ch);
									$output = json_decode($output);
									curl_close($ch);
									if (isset($output->{'data'}->{'hash'})) {
										$result['url'] = $output->{'data'}->{'url'};
										$result['hash'] = $output->{'data'}->{'hash'};
										$result['global_hash'] = $output->{'data'}->{'global_hash'};
										$result['long_url'] = $output->{'data'}->{'long_url'};
										$result['new_hash'] = $output->{'data'}->{'new_hash'};
									}
									$result['status_code'] = $output->status_code;
									if($result['status_code'] == 200){
										$body    = str_replace("%resname%",$restname.' Access reservation '.$result['url'],$body);
									}else{
										$body    = str_replace("%resname%",$restname,$body);
									}
									
									/* short url generation code end */
								}else{
									$body    = str_replace("%resname%",$restname,$body);
								}
								/* Sms Message Saving Start */
								$msgMapper = new Communication_Model_SmsMessageMapper();
								$priorMapper = new Application_Model_PriorityDataMapper();
								$prior = $priorMapper->GetPriorityByCode('H');
								$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
								$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
								$message = new Communication_Model_SmsMessage();
								$msgPhrase = uniqid ();
								$message->setBokid($bokid)
											->setPhrase($msgPhrase)
											->setDescription($body)
											->setPriority($prior->getcode())
											->setSmstype($emailType->getcode())
											->setSentToUser('CUS')
											->setSentTo($user)
											->setSentFromUser('RES')
											->setSentby($restname)
											->setTitle($smsobj->getMsgCode());
								
								$msgid = $msgMapper->SaveMessageDetails($message);
								/* Sms Message Saving End */
								
								$smsdata = array('PhoneNumber' => $mobile,
												 'Message'	   => substr($body,0,160),
												 'ReferenceID' =>$msgPhrase);
								$advanceSms = New Uss_Helper_SmsNotifyHelper();
//								$mailStatus = $this->SendMessage($body,$mobile,$resLoc,$data['countrycode']);
								$mailStatus = $this->SendBulkMessage(substr($body,0,160),$mobile);
								if($data['countrycode'] == '+91'){
									$message->setTransId(substr(strstr($mailStatus, ','),1));
									$msgMapper->UpdateMessageDetails($message);	
								}else if($resLoc->res_companyid == 1){
									$objUs = json_decode($mailStatus,true);
									if($objUs['messages'][0]['status'] == 0){
										$message->setTransId($objUs['messages'][0]['message-id']);
										$msgMapper->UpdateMessageDetails($message);	
									}else{
										$message->setTransId($objUs['messages'][0]['error-text']);
										$msgMapper->UpdateMessageDetails($message);	
									}
								}
							}
							return $mailStatus;
							break;
						case 'WaitingReady' :
							$template = $this->GetSmstemplate($smsobj);
							if($template){
								$data = $smsobj->getData();
								$mobile	  = str_replace("-","",$data['to']);
								$bokid 	  = $data['BookId'];
								$bokMapper = new Reservation_Model_ReservationDataMapper();
								$resLoc = $bokMapper->getRestaurantLocByBookingId($bokid);
								$resServ = new Application_Service_Firm();
								$timeZone = $resServ->GetRestaurantTimeZone($resLoc->resid);
								date_default_timezone_set($timeZone);
								$restname = $data['RestName'];
								
								$user = $data['UserName'];
								
								/* short url generation code start*/
								/* get phrase id with booking */
								$phraseId = $bokMapper->GetBookingPhraseByBookid($bokid);
								include_once('Bitly.php');
								
// 								$results = bitly_v3_shorten('http://www.dinedesk.com/waitbook/'.$phraseId, '51b00ed7df02a27be6d963de3ddbab78ec93a0cb', 'bit.ly');
								
								$url = "https://api-ssl.bit.ly/v3/shorten?access_token=51b00ed7df02a27be6d963de3ddbab78ec93a0cb&longUrl=".urlencode('http://www.dinedesk.com/waitbook/'.$phraseId);
								$url .= "&domain=bit.ly";
								$url .= "&x_login=dinedesk&x_apiKey=R_8d998f9995ad4c20b62750f2a364002d";
								
								$ch = curl_init($url);								
								curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
								curl_setopt( $ch, CURLOPT_SSL_VERIFYPEER, false);								
								$output = curl_exec($ch);
								$output = json_decode($output);
								curl_close($ch);
								if (isset($output->{'data'}->{'hash'})) {
									$result['url'] = $output->{'data'}->{'url'};
									$result['hash'] = $output->{'data'}->{'hash'};
									$result['global_hash'] = $output->{'data'}->{'global_hash'};
									$result['long_url'] = $output->{'data'}->{'long_url'};
									$result['new_hash'] = $output->{'data'}->{'new_hash'};
								}
								$result['status_code'] = $output->status_code;
								
// 								$bitly = new Zend_Service_ShortUrl_BitLy('dinedesk','R_8d998f9995ad4c20b62750f2a364002d');
								
								// Shorten a URL:
// 								$short = $bitly->shorten('http://www.dinedesk.com/waitbook/'.$phraseId); // http://bit.ly/15Oe0
								
								// 								// Inflate or unshorten a short URL:
								// 								$long  = $bitly->unshorten('http://bit.ly/15Oe0');
								
								$body=	$template->msg_body;
								
								$body    = str_replace("%cusname%",$user,$body);
								if($result['status_code'] == 200){
									$body    = str_replace("%custurl%",' Access reservation '.$result['url'],$body);
								}else{
									$body    = str_replace("%custurl%",' ',$body);
								}
								
								/* short url generation code end*/
								
								$objUs = "";	
								/* Sms Message Saving Start */
								$msgMapper = new Communication_Model_SmsMessageMapper();
								$priorMapper = new Application_Model_PriorityDataMapper();
								$prior = $priorMapper->GetPriorityByCode('H');
								$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
								$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
								$message = new Communication_Model_SmsMessage();
								$msgPhrase = uniqid ();
								$message->setBokid($bokid)
											->setPhrase($msgPhrase)
											->setDescription($body)
											->setPriority($prior->getcode())
											->setSmstype($emailType->getcode())
											->setSentby($restname)
											->setSentToUser('CUS')
											->setSentTo($user)
											->setSentFromUser('ADMIN')
											->setTitle($smsobj->getMsgCode());
								
								$msgid = $msgMapper->SaveMessageDetails($message);
								/* Sms Message Saving End */
								
								$smsdata = array('PhoneNumber' => $mobile,
												 'Message'	   => $body,
												 'ReferenceID' => $msgPhrase);
								$advanceSms = New Uss_Helper_SmsNotifyHelper();
								$mailStatus = $this->SendMessage($body,$mobile,$resLoc,$data['countrycode']);
								if($data['countrycode'] == '+91'){
									$message->setTransId(substr(strstr($mailStatus, ','),1));
									$msgMapper->UpdateMessageDetails($message);	
								}else if($resLoc->res_companyid == 1){
									$objUs = json_decode($mailStatus,true);
									if($objUs['messages'][0]['status'] == 0){
										$message->setTransId($objUs['messages'][0]['message-id']);
										$msgMapper->UpdateMessageDetails($message);	
									}else{
										$message->setTransId($objUs['messages'][0]['error-text']);
										$msgMapper->UpdateMessageDetails($message);	
									}
								}
							}
							return $mailStatus;
							break;
						case 'WaitingQuoteChange' :
							$template = $this->GetSmstemplate($smsobj);
							if($template){
								$data = $smsobj->getData();
								$mobile	  = str_replace("-","",$data['to']);
								
								$bokid 	  = $data['BookId'];
								$bokMapper = new Reservation_Model_ReservationDataMapper();
								$resLoc = $bokMapper->getRestaurantLocByBookingId($bokid);
								$resServ = new Application_Service_Firm();
								$timeZone = $resServ->GetRestaurantTimeZone($resLoc->resid);
								date_default_timezone_set($timeZone);
								$restname = $data['RestName'];
								$user = $data['UserName'];
								$Quote = $data['Quote'];
								$body=	$template->msg_body;
								
								$body    = str_replace("%cusname%",$user.',',$body);
								
								/* short url generation code start*/
								
								/* get phrase id with booking */
								$phraseId = $bokMapper->GetBookingPhraseByBookid($bokid);
								include_once('Bitly.php');
								$url = "https://api-ssl.bit.ly/v3/shorten?access_token=51b00ed7df02a27be6d963de3ddbab78ec93a0cb&longUrl=".urlencode('http://www.dinedesk.com/waitbook/'.$phraseId);
								$url .= "&domain=bit.ly";
								$url .= "&x_login=dinedesk&x_apiKey=R_8d998f9995ad4c20b62750f2a364002d";
								
								$ch = curl_init($url);
								curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
								curl_setopt( $ch, CURLOPT_SSL_VERIFYPEER, false);
								$output = curl_exec($ch);
								$output = json_decode($output);
								curl_close($ch);
								if (isset($output->{'data'}->{'hash'})) {
									$result['url'] = $output->{'data'}->{'url'};
									$result['hash'] = $output->{'data'}->{'hash'};
									$result['global_hash'] = $output->{'data'}->{'global_hash'};
									$result['long_url'] = $output->{'data'}->{'long_url'};
									$result['new_hash'] = $output->{'data'}->{'new_hash'};
								}
								$result['status_code'] = $output->status_code;
								if($result['status_code'] == 200){
									if($Quote){
										$body    = str_replace("%time%",'for '.$Quote.' -'.$restname.' Access reservation '.$result['url'],$body);
									}else{
										$body    = str_replace("%time%",' -'.$restname.' Access reservation '.$result['url'],$body);
									}
								}else{
									if($Quote){
										$body    = str_replace("%time%",'for '.$Quote.' -'.$restname,$body);
									}else{
										$body    = str_replace("%time%",' -'.$restname,$body);
									}
								}
								
								/* short url generation code end */
								
								$objUs = "";		
								/* Sms Message Saving Start */
									$msgMapper = new Communication_Model_SmsMessageMapper();
									$priorMapper = new Application_Model_PriorityDataMapper();
									$prior = $priorMapper->GetPriorityByCode('H');
									$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
									$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
									$message = new Communication_Model_SmsMessage();
									$msgPhrase = uniqid ();
									$message->setBokid($bokid)
												->setPhrase($msgPhrase)
												->setDescription($body)
												->setPriority($prior->getcode())
												->setSmstype($emailType->getcode())
												->setSentby($restname)
												->setSentToUser('CUS')
												->setSentTo($user)
												->setSentFromUser('ADMIN')
												->setTitle($smsobj->getMsgCode());
									
									$msgid = $msgMapper->SaveMessageDetails($message);
									/* Sms Message Saving End */
									
								$smsdata = array('PhoneNumber' => $mobile,
												 'Message'	   => $Quote,
												 'ReferenceID' => $msgPhrase);
								$advanceSms = New Uss_Helper_SmsNotifyHelper();
								$mailStatus = $this->SendMessage($body,$mobile,$resLoc,$data['countrycode']);
								if($data['countrycode'] == '+91'){
									$message->setTransId(substr(strstr($mailStatus, ','),1));
									$msgMapper->UpdateMessageDetails($message);	
								}else if($resLoc->res_companyid == 1){
									$objUs = json_decode($mailStatus,true);
									if($objUs['messages'][0]['status'] == 0){
										$message->setTransId($objUs['messages'][0]['message-id']);
										$msgMapper->UpdateMessageDetails($message);	
									}else{
										$message->setTransId($objUs['messages'][0]['error-text']);
										$msgMapper->UpdateMessageDetails($message);	
									}
								}
							}
							break;
						case 'ThankMsg' :
                                                        
							$template = $this->GetSmstemplate($smsobj);
                            $bokMapper = new Reservation_Model_ReservationDataMapper();
                            $data = $smsobj->getData();
                            $resLoc = $bokMapper->getRestaurantLocByResId($data['ResId']);
							if($template ){
								
								$mobile	  = str_replace("-","",$data['to']);
								$name     = $data['UserName'];
								$restname = $data['RestName'];
								$body =	$template->msg_body;
								$body = str_replace("%custname%",$name,$body); 
								$body = str_replace("%restname%",$restname,$body); 
								$objUs = "";					
								
								$msgMapper = new Communication_Model_SmsMessageMapper();
								$priorMapper = new Application_Model_PriorityDataMapper();
								$prior = $priorMapper->GetPriorityByCode('H');
								$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
								$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
								$message = new Communication_Model_SmsMessage();
                                
                                include_once('Bitly.php');
								$url = "https://api-ssl.bit.ly/v3/shorten?access_token=51b00ed7df02a27be6d963de3ddbab78ec93a0cb&longUrl=".urlencode('http://www.dinedesk.com/Phone/Reservations/instantfeedback/restaurantid/'.$data['ResId'].'/bookingid/'.$data['Bokid']);
								$url .= "&domain=bit.ly";
								$url .= "&x_login=dinedesk&x_apiKey=R_8d998f9995ad4c20b62750f2a364002d";
								
								$ch = curl_init($url);
								curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
								curl_setopt( $ch, CURLOPT_SSL_VERIFYPEER, false);
								$output = curl_exec($ch);
								$output = json_decode($output);
								curl_close($ch);
								if (isset($output->{'data'}->{'hash'})) {
									$result['url'] = $output->{'data'}->{'url'};
									$result['hash'] = $output->{'data'}->{'hash'};
									$result['global_hash'] = $output->{'data'}->{'global_hash'};
									$result['long_url'] = $output->{'data'}->{'long_url'};
									$result['new_hash'] = $output->{'data'}->{'new_hash'};
								}
								$result['status_code'] = $output->status_code;
								if($result['status_code'] == 200){
                                    $body = str_replace("%bitly%",$result['url'],$body);
								}                               
                                
								$msgPhrase = uniqid ();
								$message->setBokid($data['Bokid'])
											->setPhrase($msgPhrase)
											->setDescription($body)
											->setPriority($prior->getcode())
											->setSmstype($emailType->getcode())
											->setSentby($restname)
											->setSentToUser('CUS')
											->setSentTo($name)
											->setSentFromUser('ADMIN')
											->setTitle($smsobj->getMsgCode());
								
								$msgid = $msgMapper->SaveMessageDetails($message);							
								$mailStatus = $this->SendMessage($body,$mobile,$resLoc,$data['countrycode']);
//                                $mailStatus = $this->SendBulkMessage($body,$mobile);
								if($data['countrycode'] == '+91'){
									$message->setTransId(substr(strstr($mailStatus, ','),1));
									$msgMapper->UpdateMessageDetails($message);	
								}else if($resLoc->res_companyid == 1){
									$objUs = json_decode($mailStatus,true);
									if($objUs['messages'][0]['status'] == 0){
										$message->setTransId($objUs['messages'][0]['message-id']);
										$msgMapper->UpdateMessageDetails($message);	
									}else{
										$message->setTransId($objUs['messages'][0]['error-text']);
										$msgMapper->UpdateMessageDetails($message);	
									}
								}
							}
							break;
						case 'DiscountNotf' :
							$data = $smsobj->getData();
								$mobile	  = str_replace("-","",$data['to']);
								$bokid 	  = $data['bokid'];
								$restname = $data['RestName'];
								$resCountrycode = $data['RestCountryCode'];
								$bokMapper = new Reservation_Model_ReservationDataMapper();
								$resLoc = $bokMapper->getRestaurantLocByBookingId($bokid);
								$resServ = new Application_Service_Firm();
								$timeZone = $resServ->GetRestaurantTimeZone($resLoc->resid);
								date_default_timezone_set($timeZone);
								$user = $data['CustomerName'];
								$body = 'Hi '.$user.', ' .$data['discountMsg'].' at '.$restname;
								$objUs = "";	
								
								/* Sms Message Saving Start */
								$msgMapper = new Communication_Model_SmsMessageMapper();
								$priorMapper = new Application_Model_PriorityDataMapper();
								$prior = $priorMapper->GetPriorityByCode('H');
								$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
								$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
								$message = new Communication_Model_SmsMessage();
								$msgPhrase = uniqid ();
								$message->setBokid($bokid)
											->setPhrase($msgPhrase)
											->setDescription($body)
											->setPriority($prior->getcode())
											->setSmstype($emailType->getcode())
											->setSentToUser('CUS')
											->setSentTo($user)
											->setSentFromUser('ADMIN')
											->setSentby($restname)
											->setTitle($smsobj->getMsgCode());
								
								$msgid = $msgMapper->SaveMessageDetails($message);
								/* Sms Message Saving End */
								
								$mailStatus = $this->SendBulkMessage($body,$mobile);
								if($data['countrycode'] == '+91' || $resCountrycode == '+91'){
									$message->setTransId(substr(strstr($mailStatus, ','),1));
									$msgMapper->UpdateMessageDetails($message);	
								}
							break;
						}

					}
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public  function GetMessageTemplate(Communication_Model_Mail $mailobj)
	{
		$templateBdMapper = new Application_Model_EmailtemplateDataMapper();
		$template = $templateBdMapper->getEmailTempByCode($mailobj->getMsgCode());
		return $template;
	}
   public function setManageContactUsForm(Zend_Form $form)
	{
		$this->_form['ManageCont'] = $form;		
	}
    public function getManageContactUsForm()
	{
		if(empty($this->_form['ManageCont'])) {
			$this->setManageContactUsForm(new Administrator_Form_ManageCont());
		}
		return $this->_form['ManageCont'];
	}
	
	
	/**
     * @param instance of zend form
     */
	public function setRestManageInquiryForm(Zend_Form $form)
	{
		$this->_form['ManageInquiry'] = $form;
	}
	/**
     * @return instance of form
     */
	public function getRestManageInquiryForm()
	{
		if(empty($this->_form['ManageInquiry'])){
			$this->setRestManageInquiryForm(new FirmManagement_Form_ManageInquiry());
		}
		return $this->_form['ManageInquiry'];
	}
	
	
	public function GetSmstemplate(Communication_Model_Sms $smsObj)
	{
		$templateBdMapper = new Application_Model_SmsTemplateDataMapper();
		$template = $templateBdMapper->getSmsTempByCode($smsObj->getMsgCode());
		return $template;
	}
	
	public function SendMessage($body,$mobile,$resResult,$countryCode)
	{
		try{
			
			$user="info@dinedesk.com:641612";
			$receipientno=$mobile; 
			$senderID="DINDSK"; 
			$msgtxt=$body; 
			if($countryCode == '+91'){
				// $ch = curl_init();
				// curl_setopt($ch,CURLOPT_URL,  "http://api.mVaayoo.com/mvaayooapi/MessageCompose");
				// curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
				// curl_setopt($ch, CURLOPT_POST, 1);
				// curl_setopt($ch, CURLOPT_POSTFIELDS, "user=$user&senderID=$senderID&receipientno=$receipientno&msgtxt=$msgtxt");
				// $buffer = curl_exec($ch);
				// curl_close($ch);
				// if(empty ($buffer))
				// {
				// 	Uss_Logger_FileLogger::info('msg to '.$receipientno.'with text '.$msgtxt.' is not sent');
				// 	return false;
				// }else{
				// 	return $buffer;
				// } 
				$receipientno = $countryCode.$receipientno;
				$this->sendMessagCMTelecom($receipientno,$msgtxt);
				return true;
			}else if($resResult->res_companyid == 1 || $resResult->res_companyid == 8 || $resResult->res_companyid == 23 || $resResult->res_companyid == 24 || $resResult->res_companyid == 25){
				//25 COMPANYID IS FOR DWU - DININGWITHUS
				$receipientno = $countryCode.$receipientno;
				$this->sendMessagCMTelecom($receipientno,$msgtxt);
				return true;
			}
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			return true;
		}
	}
	/**
	 * SEND MESSAGE THROUGH CMTELECOM
	 */
	public function sendMessagCMTelecom($to,$message,$resid = null)
	{
		try
		{
			$contactsArr = array();
			$to = str_replace("+", "", $to);
			$to = "00".$to;
			$contactsArr[] = $to;
			 $xml = $this->buildMessageXml($contactsArr, $message,$resid);
                $ch = curl_init();
                curl_setopt_array($ch, array(
                  CURLOPT_URL            => 'https://cq9gwk0xv3.execute-api.us-east-1.amazonaws.com/dev/sendcmsms',//'https://sgw01.cm.nl/gateway.ashx',
                  CURLOPT_HTTPHEADER     => array('Content-Type: application/xml'),
                  CURLOPT_POST           => true,
                  CURLOPT_POSTFIELDS     => $xml,
                  CURLOPT_RETURNTRANSFER => true,
                  CONNECTION_TIMEOUT    => 1,
		CURLOPT_SSLVERSION => 6,
                )
              );
                $response = curl_exec($ch);
print_r($response);die();
                curl_close($ch);
		}
		catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			return true;
		}

	}

	/**
	 * BUILD XML FOR SENDING MESSAGE VIA CM TELECOM
	 */
	public function buildMessageXml($recipient, $message,$resid) {
		try
		{

	      $xml = new SimpleXMLElement('<MESSAGES/>');

	      $authentication = $xml->addChild('AUTHENTICATION');
	      $authentication->addChild('PRODUCTTOKEN', '772EE4EA-7EE3-403D-B396-496835FB8711');

	      $msg = $xml->addChild('MSG');
	      $msg->addChild('FROM', 'Dinedesk');
	      $msg->addChild('MINIMUMNUMBEROFMESSAGEPARTS','1');
	      $msg->addChild('MAXIMUMNUMBEROFMESSAGEPARTS','8');
	      foreach ($recipient as $key => $num) {
	         $msg->addChild('TO', $num);
	      }
	     
	      $msg->addChild('BODY', $message);
	      $msg->addChild('CUSTOMGROUPING', $resid);
	      return $xml->asXML();
    
		}
		catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			return true;
		}
	}

	public function SendBulkMessage($body,$mobile)
	{
		try{
			
			$ch = curl_init();
			$user="sales@dinedesk.com:cooldd@641";
			$receipientno=$mobile; 
			$senderID="TEST SMS"; 
			$msgtxt=urlencode($body); 
			curl_setopt($ch,CURLOPT_URL,  "http://api.mVaayoo.com/mvaayooapi/MessageCompose");
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_POST, 1);
			curl_setopt($ch, CURLOPT_POSTFIELDS, "user=$user&senderID=$senderID&receipientno=$receipientno&msgtxt=$msgtxt");
			$buffer = curl_exec($ch);
			curl_close($ch);
			if(empty ($buffer))
			{
				Uss_Logger_FileLogger::info('msg to '.$receipientno.'with text '.$msgtxt.' is not sent');
				return false;
			}else{			
				return $buffer;
			} 
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			return true;
		}
	}
	/**
	* SEND BULK SMS WITH RD LABS
	**/
	public function SendBulkMessageWithRDL($body,$resid,$smstitle,$campType = null,$groupIds)
	{
		try{
			
			$ch = curl_init();
			$appNameSpace = new Zend_Session_Namespace('SMSData');
			$rdineLinks = $appNameSpace->smsdata;
			if(array_key_exists($resid, $rdineLinks))
			{
				$body.="\nBOOK ON ".$rdineLinks[$resid];
			}
			$msgtxt=urlencode($body); 
			$serverName = $_SERVER['HTTP_HOST'];
			curl_setopt($ch,CURLOPT_URL,  "http://".$serverName."/rdl/sendbulksms.php");
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_TIMEOUT, 1);
			curl_setopt($ch, CURLOPT_POST, 1);
			curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/x-www-form-urlencoded'));
			$paramString = "resid=$resid&message=$msgtxt&camp_title=$smstitle&camptype=$campType";
			if($campType == 2)
			{
				// CAMP SEND TO GROUP OF PEOPLE
				$paramString.='&groupids='.implode(',', $groupIds);
			}

			curl_setopt($ch, CURLOPT_POSTFIELDS,$paramString );
			$buffer = curl_exec($ch);
			curl_close($ch);
			return true;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			return true;
		}
	}

	public function AddContact($data)
{
		try{
			$form = $this->getContactUsForm();
			$result = array();
//			if($data['contactType'] == 'email'){
//				$form->emailAddress->setRequired(true);
//				$form->phone->setRequired(false);
//			}else if($data['contactType'] == 'phone'){
//				$form->phone->setRequired(true);
//				$form->contactType->setValue('phone');
//				$form->emailAddress->setRequired(false);
//			}
			if($form->isValid($data)){
				$formData = $form->getValues();
				$mapper = new Communication_Model_ContactUsDataMapper();
				$contactObj = new Communication_Model_ContactUs();
				
				$domain = $_SERVER["SERVER_NAME"];
				if ($domain == "www.dinedesk.com" || $domain == "dinedesk.com")
				{
					$contactObj->setCompanyId(1);
				}else if ($domain == "www.dinedesk.co.za" || $domain == "dinedesk.co.za"){
					$contactObj->setCompanyId(2);
				}else{
					$contactObj->setCompanyId(1);
				}
				$contactObj->setcontactname($formData['contactName']);
				$contactObj->setaddress($formData['address']);
				$contactObj->setcity($formData['cityName']);
                        //        $contactObj->setcity($formData['city']);
                        //        $contactObj->setcountry($formData['state']);
			//	$contactObj->setstate($formData['state']);
				$contactObj->setcountry($formData['countryName']);
				$contactObj->setzip($formData['postalCode']);
				$contactObj->setphone($formData['phone']);
				$contactObj->setemail($formData['emailAddress']);
				$contactObj->setfax($formData['fax']);
				$contactObj->setwebsite($formData['website']);
				$contactObj->setmoreinformation($formData['moreinfo']);
				$contactObj->setcomments($formData['comments']);
				$contactObj->setcontactby($formData['contactType']);
				$contactObj->setpostedon(date('Y-m-d')); 
				$contactObj->setcontacttype($formData['type']);
				$status = $mapper->CreateContact($contactObj);
				
				if($status){
					$result['status'] = $status; 
					$result['form']	  = $form;	
				}

			//return $result;
				
			$mailmapper = new Application_Service_Communication();
				//if($formData['notificationType'] == 'email'){
				if($result['status']){
					$mailObj = new Communication_Model_Mail();
					$mailObj->setMsgCode('EnquiryNot');
						$name = $formData['contactName'];
						$data = array('Name' => $name,
						  'City'    => $formData['cityName'],
						  'State' => $formData['state'],
						  'Country'  => $formData['countryName'],
						  'Phone'     => $formData['phone'],
						  'Email'     => $formData['emailAddress'],
						  'Comments'     => $formData['comments']);
						  //'Status'	 => $formData['bookingStatus']);
						$mailObj->setData($data);
						$mailStatus = $mailmapper->SendMail($mailObj);

					}
				return $result;

			}else{
			$formData = $form->getValues();
		 	$form->populate($formData);
		 	$result['status'] = false;
		 	$result['form'] = $form;
		 	return $result;
			}	
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function AddContactUsForRest($data,$restid)
	{
		try{
			$form = $this->getContactUsToRestForm();
			$result = array();
			if($data['contactType'] == 'email'){
				$form->emailAddress->setRequired(true);
				$form->phone->setRequired(false);
			}else if($data['contactType'] == 'phone'){
				$form->phone->setRequired(true);
				$form->emailAddress->setRequired(false);
			}
			if($form->isValid($data)){
				$formData = $form->getValues();
				$mapper = new Communication_Model_ContactUsDataMapper();
				$contactObj = new Communication_Model_ContactUs();
				
				$contactObj->setcontactname($formData['contactName']);
				$contactObj->setaddress($formData['address']);
				$contactObj->setcity($formData['city']);
				$contactObj->setstate($formData['state']);
				$contactObj->setcountry($formData['country']);
				$contactObj->setzip($formData['postalCode']);
				$contactObj->setphone($formData['phone']);
				$contactObj->setemail($formData['emailAddress']);
				$contactObj->setfax($formData['fax']);
				$contactObj->setwebsite($formData['website']);
				$contactObj->setmoreinformation($formData['moreinfo']);
				$contactObj->setcomments($formData['comments']);
				$contactObj->setcontactby($formData['contactType']);
				$contactObj->setpostedon(date('Y-m-d')); 
				$contactObj->setcontacttype($formData['type']);
				$contactObj->setHelpInfo($formData['helpcomments']);
				$contactObj->setRestId($restid);
				$contactObj->setCountryCode($formData['countryCode']);
				$status = $mapper->CreateContact($contactObj);
				
				if($status){
					$result['status'] = $formData['contactName'];
					$result['form']	  = $form;	
				}

			//return $result;
			// get restowneremailid //
			if(isset($restid)){
				$mapper = new FirmManagement_Model_FirmDataMapper();
				$ownerEmailid = $mapper->GetRestaurantOwnerEmailid($restid);				
			}	
			$mailmapper = new Application_Service_Communication();
				//if($formData['notificationType'] == 'email'){
				if($result['status']){
					$mailObj = new Communication_Model_Mail();
					$mailObj->setMsgCode('EnquiryNot');
						$name = $formData['contactName'];
						$data = array('Name' => $name,
						  'City'    => $formData['city'],
						  'State' => $formData['state'],
						  'Country'  => $formData['country'],
						  'Phone'    => $formData['countryCode'].$formData['phone'],
						  'Email'    => $formData['emailAddress'],
						  'Comments' => $formData['comments'],
						  'SendTo'   => $ownerEmailid['resemail'],	
						  'restid'	 =>	$restid);	
						$mailObj->setData($data);
						$mailStatus = $mailmapper->SendMail($mailObj);

					}
				return $result;

			}else{
			$formData = $form->getValues();
		 	$form->populate($formData);
		 	$result['status'] = false;
		 	$result['form'] = $form;
		 	return $result;
			}	
		}catch (Exception $ex){


			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function AddContactMobile($data)
	{
		try{
			$form = $this->getContactUsMobileForm();
			$result = array();
			if($data['contactType'] == 'email'){
				$form->emailAddress->setRequired(true);
				$form->phone->setRequired(false);
			}else if($data['contactType'] == 'phone'){
				$form->phone->setRequired(true);
				$form->contactType->setValue('phone');
				$form->emailAddress->setRequired(false);
			}
			if($form->isValid($data)){
				$formData = $form->getValues();
				$mapper = new Communication_Model_ContactUsDataMapper();
				$contactObj = new Communication_Model_ContactUs();
				
				$domain = $_SERVER["SERVER_NAME"];
				if ($domain == "www.dinedesk.com" || $domain == "dinedesk.com")
				{
					$contactObj->setCompanyId(1);
				}else if ($domain == "www.dinedesk.co.za" || $domain == "dinedesk.co.za"){
					$contactObj->setCompanyId(2);
				}
				$contactObj->setcontactname($formData['contactName']);
//				$contactObj->setaddress($formData['address']);
//				$contactObj->setcity($formData['city']);
//				$contactObj->setstate($formData['state']);
//				$contactObj->setcountry($formData['country']);
//				$contactObj->setzip($formData['postalCode']);
				$contactObj->setphone($formData['phone']);
				$contactObj->setemail($formData['emailAddress']);
//				$contactObj->setfax($formData['fax']);
//				$contactObj->setwebsite($formData['website']);
//				$contactObj->setmoreinformation($formData['moreinfo']);
				$contactObj->setcomments($formData['comments']);
				$contactObj->setcontactby($formData['contactType']);
				$contactObj->setpostedon(date('Y-m-d')); 
				$contactObj->setcontacttype($formData['type']);
				$status = $mapper->CreateContact($contactObj);
				
				if($status){
					$result['status'] = $status; 
					$result['form']	  = $form;	
				}

			//return $result;
				
			$mailmapper = new Application_Service_Communication();
				//if($formData['notificationType'] == 'email'){
				if($result['status']){
					$mailObj = new Communication_Model_Mail();
					$mailObj->setMsgCode('EnquiryNot');
						$name = $formData['contactName'];
						$data = array('Name' => $name,
						  'City'    => $formData['city'],
						  'State' => $formData['state'],
						  'Country'  => $formData['country'],
						  'Phone'     => $formData['phone'],
						  'Email'     => $formData['emailAddress'],
						  'Comments'     => $formData['comments']);
						  //'Status'	 => $formData['bookingStatus']);
						$mailObj->setData($data);
						$mailStatus = $mailmapper->SendMail($mailObj);

					}
				return $result;

			}else{
			$formData = $form->getValues();
		 	$form->populate($formData);
		 	$result['status'] = false;
		 	$result['form'] = $form;
		 	return $result;
			}	
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
    public function GetAllContactUsDeatils(array $formData,$page,$userdata)
	{
		 try{

		 	$contSummObj = new Communication_Model_ContactUs();
		 	$form = $this->getManageContactUsForm();
		 	$result = array();
			if($form->isValid($formData)){
				 if($formData){
					if($formData['id'])

					{
						$contSummObj->setId($formData['id']);
					}


					if($formData['name']){
						$contSummObj->setcontactname($formData['name']);
					}

					if($formData['status']){
						$contSummObj->setStatus($formData['status']);
					}
//						else if($formData['status'] != ""){
//							$contSummObj->setStatus($formData['status']);
//						}
						//else if($formData['status'] == ""){
						//$contSummObj->setStatus(TRUE);
						//}
					if($formData['startdate']){
						$contSummObj->setStartDate($formData['DP-startdate']);
					}
			        if($formData['enddate']){
						$contSummObj->setEndDate($formData['DP-enddate']);
					}
				    	
				}
				if($userdata['companyid']){
					$contSummObj->setCompanyId($userdata['companyid']);
				}
			 	$mapper = new Communication_Model_ContactUsDataMapper();
			 	$resultset = $mapper->getAllCotactUsdeatils($page,$contSummObj);
			 	$result = array('status'=>true,'personalForm'=>$resultset);
			 	return $result;  

		 	}else{
			 	$Data = $form->getValues();
				$form->populate($Data);
				$result = array('status'=>false,'personalForm'=>$form);
				return $result;
			 }
		 }catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function CloseContactUsDeatils($id)
	{
		try{
		 	
		 	$mapper = new Communication_Model_ContactUsDataMapper();
		 	$status = $mapper->CloseContactUsDeatils($id);
		 	return $status;  
		 
		 }catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetContactUsInfo($request)
	{
		try{
			if($request->contactid){
				$mapper = new Communication_Model_ContactUsDataMapper();
				$row    = $mapper->ReterieveContactInfo($request->contactid);
				return $row;	
			}
			 
			
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetContactUsDeatils($id)
	{
		try{
		 	$mapper = new Communication_Model_ContactUsDataMapper();
		 	$resultset = $mapper->GetContactUsDeatils($id);
		 	return $resultset;  
		 }catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetContactUsDeatilsForOwner($id,$restid)
	{
		try{
		 	$mapper = new Communication_Model_ContactUsDataMapper();
		 	$resultset = $mapper->GetContactUsDeatilsForOwner($id,$restid);
		 	return $resultset;  
		 }catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function NotificationCreation(array $data,$request)
	{
		try{
			$uploadpath = "doc/";
			$docpath = "";
			$form = $this->getNotificationCreationForm();
			$result = array();
			if($form->isValid($data)){
				$documentadapter = $form->document->getTransferAdapter();
				$docName = null;
				if($documentadapter){
					$fileInfo = $documentadapter->getFileInfo();
					if($fileInfo['document']){
						$info = $fileInfo['document'];
						$docName = $info['name'];
						if($info['name']){
							$fileName =$docName;
							$documentadapter->addFilter('Rename', array('target'=>$uploadpath.$fileName, 'overwrite'=>true));
							if($documentadapter->receive($info['name'])){
								$docpath = '/'.$uploadpath.$fileName;
							}
						}
					}
				}
				$formData = $form->getValues();
				$message = new Communication_Model_EmailMessage();
				$message->setTitle($formData['Title'])
						->setDescription($formData['Description'])
						->setPriority($formData['emailPriority'])
						->setEmailtype($formData['emailtype'])
						->setSentby('admin@dinedesk.com')
						->setSignature($formData['signature'])
						->setDocpath($docpath);
						
				$mapper = new Communication_Model_EmailMessageDataMapper();
				$msgid = $mapper->SaveMessageDetails($message);
				$result['msgid'] = $msgid; 
				return $result;
			}else{
				$formData = $form->getValues();
				$form->populate($data);
				$result['form'] = $form;
				return $result;
			}	
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getrestaurantorcustomerdetailsbystateid(array $data,$request)
	{
		try{
			$form = $this->getRecipentFilterForm();
			if($form->isValid($data)){
				$formData = $form->getValues();
				$stateid = $formData['state'];
				$regionid = $formData['region'];
				$cityid = $formData['city'];
				$usertype = $formData['usertype'];	
				$resultArr = array();
				if($usertype == 'RES'){
					$restname = $formData['restname'];
					$groupName = $formData['restgroupname'];
					$Crestartdate = $data['DP-CreatedDate'];
					$Creenddate = $data['DP-EndDate'];
					$mapper = new FirmManagement_Model_FirmDataMapper();
					$result = $mapper->getRestaurantDetailsBystateid($stateid,$regionid,$cityid,$request,$restname,$groupName,$Crestartdate,$Creenddate);
					$resultArr['list'] = $result['UsersList'];
					$resultArr['prev'] = $result['prev'];
					$resultArr['next'] = $result['next'];
					$resultArr['count'] = $result['count'];
					if(isset($result['offset'])){
						$resultArr['offset'] = $result['offset'];
					}
					$resultArr['type'] = 'RES';
					$resultArr['msgid'] = $request->msgid;
				}else if($usertype == 'CUS'){
					$cusmapper = new User_Model_GuestDataMapper();
					$result = $cusmapper->getRestaurantDetailsBystateid($stateid,$regionid,$cityid,$request);
					$resultArr['list'] = $result['UsersList'];
					$resultArr['prev'] = $result['prev'];
					$resultArr['next'] = $result['next'];
					$resultArr['count'] = $result['count'];
					if(isset($result['offset'])){
						$resultArr['offset'] = $result['offset'];
					}
					$resultArr['type'] = 'CUS';
					$resultArr['msgid'] = $request->msgid;
				}
			return $resultArr;	
			}else{
				$formData = $form->getValues();
				$form->populate($data);
				$resultArr['form'] = $form; 
				return $resultArr;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function SendNotificationToUsers($request)
	{
		try{
			$idsArr	= array();
			$campaignDetails = array();
			if($request->UserIds != ''){
				$idsArr = explode(",",$request->UserIds);
			}
			$stateid 	= $request->stateid;
			$cityid 	= $request->cityid;
			$regionid   = $request->regionid;
			$usertype 	= $request->usrtype;
			$campaignId = $request->campaignId;
			$userType = $request->usrtype;
			if($campaignId){
				$adminService = new Application_Service_Administrator();
				$campProp = new Application_Model_GetCampaignForPost();
				$campProp->setAudType($userType)
						 ->setStateId($stateid)
						 ->setCityId($cityid)
						 ->setRegionId($regionid)
						 ->setIsAjaxCall(false)
						 ->setCampId($campaignId);
						 
				$campDetails = $adminService->GetCampaignDetails($campProp);
				$campaignDetails = array();
				$count = count($campDetails);
				if(!$campaignId){
					if($count > 1){
						$campaignDetails = $campDetails[rand(0,$count-1)];
						$campaignId = $campaignDetails->getId();
					}else if($campDetails){
						$campaignDetails = $campDetails[0];
						$campaignId = $campaignDetails->getId();
					}
				}else{
					$campaignDetails = $campDetails[0];
				}
			}
			if($usertype == 'RES'){
				$restName = $request->restName;
				$groupName = $request->groupname;
				$Crestartdate = $request->crestartDate;
				$Creenddate = $request->creendDate;
				$mapper = new FirmManagement_Model_FirmDataMapper();
				$result = $mapper->getRestaurantEmailIds($stateid,$cityid,$idsArr,$restName,$groupName,$Crestartdate,$Creenddate);
				$resmapper = new Communication_Model_EmailRestRecipentsDataMapper();
				$emailids = $resmapper->SaveUserEmails($request,$result,$campaignId);
			}else if($usertype == 'CUS'){
				$cusmapper = new User_Model_GuestDataMapper();
				$result = $cusmapper->getUserEmailIds($stateid,$cityid,$idsArr);
				$cusmapper = new Communication_Model_EmailCusRecipentsDataMapper();
				$emailids = $cusmapper->SaveUserEmails($request,$result,$campaignId);
			}
			if($emailids){

				if($campaignDetails){
					$emailCount = count($emailids);
					$count = $this->UpdateCampaignEmailCount($campaignId,$emailCount);
				}

				$msgid = $request->messageid;
				$msgmapper = new Communication_Model_EmailMessageDataMapper();
				$msgresult = $msgmapper->GetTitleandMessageById($msgid);
				$mailObj = new Communication_Model_Mail();
				$mailObj->setMsgCode('Notification');
				if($campaignDetails){
					$data = array(
								'SenTo'    			=> 	$emailids,
				  			  	'subject'	 		=> 	$msgresult['emsg_subject'],
							  	'body'	 			=> 	$msgresult['emsg_body'],
								'signature'			=>	$msgresult['emsg_signature'],
							  	'campaignName'		=> 	trim($campaignDetails->getSponsor()),
								'campaignDesc'		=>	trim($campaignDetails->getCampDesc()),
								'campaignImg'		=>	trim($campaignDetails->getCampImage())
					);
				}else{
					$data = array(
								'SenTo'    			=> 	$emailids,
				  			  	'subject'	 		=> 	$msgresult['emsg_subject'],
							  	'body'	 			=> 	$msgresult['emsg_body'],
								'signature'			=>	$msgresult['emsg_signature']
					);
				}
				
				$mailObj->setData($data);
//				$mailStatus = $this->SendMail($mailObj);
			}
			return $result;						
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getMessageDeatails($request)
	{
		try{
			$msgid = $request->msgid;
			$mapper = new Communication_Model_EmailMessageDataMapper();
			$result = $mapper->GetMessageDetailsById($msgid);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getMessageFromDetails($request)
	{
		try{
			$msgform = $this->getNotificationCreationForm();
			$msgid = $request->msgid;
			$mapper = new Communication_Model_EmailMessageDataMapper();
			$result = $mapper->GetMessageDetailsById($msgid);
			$formValues = array(
					'Title'			=>	$result->emsg_subject,
					'Description'	=> 	$result->emsg_body,
					'emailPriority'	=>	$result->emsg_priority,
					'emailtype'		=>	$result->emsg_emailtype,
					'id'			=>	$msgid
			);
			$msgform->populate($formValues);
			return $msgform;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function UpdatemessageDeatils(array $data)
	{
		try{
			$result = array();
			$form = $this->getNotificationCreationForm();
			if($form->isValid($data)){
				$formData = $form->getValues();
				$message = new Communication_Model_EmailMessage();
				$message->setTitle($formData['Title'])
						->setDescription($formData['Description'])
						->setPriority($formData['emailPriority'])
						->setEmailtype($formData['emailtype'])
						->setid($formData['id'])
						->setSignature($formData['signature']);
						
				$mapper = new Communication_Model_EmailMessageDataMapper();
				$status = $mapper->UpdatemessageDeatils($message);
				$result['status'] = $status;
			}else{
				$formData = $form->getValues();
				$form->populate($formData);
				$result['form'] = $form;
			}
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getEmailIds(array $data)
	{
		try{
			$form = $this->getRecipentFilterForm();
			if($form->isValid($data)){
				$formData = $form->getValues();
				$stateid = $formData['state'];
				$cityid = $formData['city'];
				$usertype = $formData['usertype'];
				
				$mapper = new Communication_Model_EmailMessageDataMapper();
				$result = $mapper->GetEmailIdsById($stateid,$cityid,$usertype);
				return $result;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getAllNotifications()
	{
		try{
			$mapper = new Communication_Model_EmailMessageDataMapper();
			$result = $mapper->getAllNotifications();
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetMsgDetalisandSentListByMsgId($request)
	{
		try{
			$resultArr = array();
			$campDetails = "";
			$state = "";
			$msgid = $request->msgid;
			$mapper = new Communication_Model_EmailMessageDataMapper();
			$msgresult = $mapper->GetMessageDetailsById($msgid);
			$cmpmapper = new Administrator_Model_CampaignDataMapper();
			if($msgresult['emsg_campaignid'] != ""){
				$campDetails = $cmpmapper->GetCampaignDetailsById($msgresult['emsg_campaignid']);
			}
			$mailObj = new Communication_Model_Mail();
			$mailObj->setMsgCode('Notification');
			$template = $this->GetMessageTemplate($mailObj);
			if($campDetails){
				$title			= $msgresult['emsg_subject'];
			  	$message		= $msgresult['emsg_body'];
			  	$signature  = $msgresult['emsg_signature'];
			  	$campaignName	= trim($campDetails['spocompany_name']);
				$campaignDesc	= trim($campDetails['scimage']).'</br>'.trim($campDetails['scdesc']);
				
			}else{
				$title		= $msgresult['emsg_subject'];
			  	$message	= $msgresult['emsg_body'];
			  	$signature  = $msgresult['emsg_signature'];
			}
			if(isset($campaignName) && isset($campaignName)){
					$name 	= $campaignName;
					$desc  = $campaignDesc;
					$desc  = str_replace('src="','src="http://www.dinedesk.com',$desc);
					$display  = 'block';
			}
			$body	= $template->msg_body;
			
			if(isset($campaignName) && isset($campaignName)){
				$body    = str_replace("none",$display,$body);
				$body    = str_replace("%desc%",$desc,$body);
				$body    = str_replace("%campName%",$name,$body);	
			}
			$body    = str_replace("%body%",$message,$body);
			$signature = str_replace(",",',<br/>',$signature);
			$body    = str_replace("%signature%",$signature,$body);
		
			
			if($msgresult['emsg_email_users'] == 'RES'){
				$resmapper = new Communication_Model_EmailRestRecipentsDataMapper();
				$result = $resmapper->getSentDetailsByMsgid($request);
			}else if($msgresult['emsg_email_users'] == 'CUS'){
				$cusmapper = new Communication_Model_EmailCusRecipentsDataMapper();
				$result = $cusmapper->getSentDetailsByMsgid($request);
			}
			$resultArr['title']   = $title;
			$resultArr['Message'] = $body;
			
			if(isset($result)){
				$resultArr['list'] = $result['UsersList'];
				$resultArr['prev'] = $result['prev'];
				$resultArr['next'] = $result['next'];
				if(isset($result['offset'])){
					$resultArr['offset'] = $result['offset'];
				}
				$resultArr['msgid'] = $request->msgid;
			}
			return $resultArr;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetTitleandMessageById($msgid)
	{
		try{
			$campDetails = "";
			$mapper = new Communication_Model_EmailMessageDataMapper();
			$msgresult = $mapper->GetMessageDetailsById($msgid);
			$cmpmapper = new Administrator_Model_CampaignDataMapper();
			if($msgresult['emsg_campaignid'] != ""){
				$campDetails = $cmpmapper->GetCampaignDetailsById($msgresult['emsg_campaignid']);
			}
			$mailObj = new Communication_Model_Mail();
			$mailObj->setMsgCode('Notification');
			$template = $this->GetMessageTemplate($mailObj);
			if($campDetails){
				$title			= $msgresult['emsg_subject'];
			  	$message		= $msgresult['emsg_body'];
			  	$signature  = $msgresult['emsg_signature'];
			  	$campaignName	= trim($campDetails['spocompany_name']);
				$campaignDesc	= trim($campDetails['scdesc']);
			}else{
				$title		= $msgresult['emsg_subject'];
			  	$message	= $msgresult['emsg_body'];
			  	$signature  = $msgresult['emsg_signature'];
			}
			if(isset($campaignName) && isset($campaignName)){
					$name 	= $campaignName;
					$desc  = $campaignDesc;
					$desc  = str_replace('src="','src="http://www.dinedesk.com',$desc);
					$display  = 'block';
			}
			$body	= $template->msg_body;
			
			if(isset($campaignName) && isset($campaignName)){
				$body    = str_replace("none",$display,$body);
				$body    = str_replace("%desc%",$desc,$body);
				$body    = str_replace("%campName%",$name,$body);	
			}
			$body    = str_replace("%body%",$message,$body);
			$signature = str_replace(",",',<br/>',$signature);
			$body    = str_replace("%signature%",$signature,$body);
			$resultArr = array();
			$resultArr['title']   = $title;
			$resultArr['Message'] = $body;
			return $resultArr;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function ChangeBokStatusByResponse($request)
	{
		try{
			$bokservice = new Application_Service_Reservation();
			$bokservice->ChangeBokStatusByResponse($request);
			
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function NotifyFriendsByEmail($request)
	{
		try{
			$firstname = $request->firstname; 
			$lastname = $request->lastname;
	    	$email = $request->email;
	    	$guestId = array();
	    	$emailArr = array();
	    	$setIds =  array();
 			for($i = 0; $i < count($firstname); $i++ )
			{
				$user = new FirmManagement_Model_FirmGroupUsers();
				$user->setRestaurantId($request->restaurantid)
					 ->setGroupId(3)
					 ->setFirstName($firstname[$i])
					 ->setLastName($lastname[$i])
					 ->setEmail($email[$i])			
					 ->setStatus(TRUE);
					 
				$mapper = new FirmManagement_Model_FirmGroupUsersDataMapper();
				$guestid= $mapper->addUserContact($user);
				$guestId[]  = $guestid;
				if(count($emailArr) <= 5){
					$emailArr[$guestid] = $email[$i];
					$setIds[] = $guestid;
				}
			}
			
			$request->setParam('resid',$request->restaurantid);
			$request->setParam('to',$emailArr);
			$this->WidgetNotifyFriendsEmail($request);
			
			$mapper = new Reservation_Model_ReservationInvitedGuestDataMapper();
			$status = $mapper->saveBookingInvitedGuests($request,$guestId,$setIds);
			return $status; 			
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public  function WidgetNotifyFriendsEmail($request)//Moiz
	{
		try{
				$fromaddressNotify = 'admin@dinedesk.com';
				$fromnameNotify = 'DineDesk';
				$mailmapper = new Application_Service_Communication();
				$mailObj = new Communication_Model_Mail();
				$mailObj->setMsgCode('notifyfriends');
				
				$resDataMapper = new FirmManagement_Model_FirmDataMapper();
				$restid = new FirmManagement_Model_FirmById();
				$restid->setRestaurantId($request->resid);
				$resDetails = $resDataMapper->getRestaurantById($restid);
				
				$bokidNew=$request->bokid;
				$bookServ = new Application_Service_Reservation();
				
				$bookResult = $bookServ->GetBookingDetailsByPhraseId($bokidNew);

				$bookid = $request->bokid;
				$mapper = new Reservation_Model_ReservationDataMapper();
				/* get booing id with phraseid */
				$phraseId = $mapper->GetBookingIdByBookPhrase($bookid);
				
				$restname = $resDetails->getRestaurantname();
				$restaddr = $resDetails->getRestaddress();
				$restphone = $resDetails->getRestphone();
				$restcity = $resDetails->getRestCityDesc();
				$restzipcode = $resDetails->getRestzipcode();
				$restemail = $resDetails->getRestemail();
				$restneighbour = $resDetails->getRestNeighborDesc();
				$stateId=$resDetails->getReststateid();
				$isAjaxCall = true;
				$mapper = new Deals_Model_RestaurantSpecialDataMapper();
				if(($request->splname)){
					$resultdata = $mapper->getRestaurantSplByBookingId($bokidNew,$isAjaxCall);
					$splstatus=$resultdata['Status'];
					$splname=$resultdata['Special Name'];
					$splid=$resultdata['Id'];
					$spldesc=$resultdata['Desc'];
				}else{
					$splstatus='';
					$splname='';
					$splid='';
					$spldesc='';
				}
				
				if($stateId == ""){
					$stateCity = $this->getRestaurantStateByResId($request->resid);
					$stateId = $stateCity['state'];
					$cityId = $stateCity['city'];
					$regionId = $stateCity['region'];
				}
				$userType = 'CUS';
				$adminService = new Application_Service_Administrator();
				$campProp = new Application_Model_GetCampaignForPost();
				$campProp->setAudType($userType)
				->setStateId($stateId)
				->setCityId($cityId)
				->setRegionId($regionId)
				->setIsAjaxCall(false);
				$campDetails = $adminService->GetCampaignDetails($campProp);
				
				if(count($campDetails)){
					$count = count($campDetails);
					if($count > 1){
						$campaign = $campDetails[rand(0,$count-1)];
					}else{
						$campaign = $campDetails[0];
					}
					$notfService = new Application_Service_Communication();
					$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
					$campaignName = trim($campaign->getSponsor());
					$campaignDesc =	trim($campaign->getCampDesc());
					$campaignImg =	trim($campaign->getCampImage());
					$campId= $campaign->getId();
					}
					$data = array('UserName' =>$bookResult->getbokfirst_name().' '.$bookResult->getboklast_name(),
								  'SendTo'    =>$request->to,
								  'RestName' => $restname,
								  'RestNbh'  => $restneighbour,
								  'ResDate'  => $request->date,
								  'Time'     => $request->time,
								  'Size'     => $request->partysize,
								  'Address'	 => $restaddr,
								  'Bokid'	 =>	$phraseId,
								  'City'	 =>	$restcity,
								  'Phone'	 => $restphone,
								  'Zipcode'	 => $restzipcode,
								  'RestEmail'=> $restemail,
								  'splname'	 =>	$splname,
								  'splstatus'=> $splstatus,
								  'spldesc'  => $spldesc,
								  'splid'	 => $splid,
								  'campaignName'=>$campaignName,
								  'campaignDesc'=>$campaignDesc,
								  'campaignImg'=>$campaignImg,
								  'campId'=>$campId
								  
					);
					$mailObj->setData($data);
					$mailStatus = $mailmapper->SendMail($mailObj);
						    
			}catch(Exception $ex){
				Uss_Logger_FileLogger::info($ex->getMessage());
				return true;
			}
	}
	
	public  function WixWidgetNotifyFriendsEmail($request)
	{
		try{
				$fromaddressNotify = 'admin@dinedesk.com';
				$fromnameNotify = 'DineDesk';
				$mailmapper = new Application_Service_Communication();
				$mailObj = new Communication_Model_Mail();
				$mailObj->setMsgCode('notifyfriends');
				
				$resDataMapper = new FirmManagement_Model_FirmDataMapper();
				$restid = new FirmManagement_Model_FirmById();
				$restid->setRestaurantId($request->resid);
				$resDetails = $resDataMapper->getRestaurantById($restid);
				
				$bokidNew=$request->bokid;
				$bookServ = new Application_Service_Reservation();
				
				$bookResult = $bookServ->GetBookingDetailsByPhraseId($bokidNew);

				$bookid = $request->bokid;
				$mapper = new Reservation_Model_ReservationDataMapper();
				/* get booing id with phraseid */
				$phraseId = $mapper->GetBookingIdByBookPhrase($bookid);
				
				$restname = $resDetails->getRestaurantname();
				$restaddr = $resDetails->getRestaddress();
				$restphone = $resDetails->getRestphone();
				$restcity = $resDetails->getRestCityDesc();
				$restzipcode = $resDetails->getRestzipcode();
				$restemail = $resDetails->getRestemail();
				$restneighbour = $resDetails->getRestNeighborDesc();
				$stateId=$resDetails->getReststateid();
				$isAjaxCall = true;
				$mapper = new Deals_Model_RestaurantSpecialDataMapper();
				if(($request->splname)){
					$resultdata = $mapper->getRestaurantSplByBookingId($bokidNew,$isAjaxCall);
					$splstatus=$resultdata['Status'];
					$splname=$resultdata['Special Name'];
					$splid=$resultdata['Id'];
					$spldesc=$resultdata['Desc'];
				}else{
					$splstatus='';
					$splname='';
					$splid='';
					$spldesc='';
				}
				
				if($stateId == ""){
					$stateCity = $this->getRestaurantStateByResId($request->resid);
					$stateId = $stateCity['state'];
					$cityId = $stateCity['city'];
					$regionId = $stateCity['region'];
				}
				$userType = 'CUS';
				$adminService = new Application_Service_Administrator();
				$campProp = new Application_Model_GetCampaignForPost();
				$campProp->setAudType($userType)
				->setStateId($stateId)
				->setCityId($cityId)
				->setRegionId($regionId)
				->setIsAjaxCall(false);
				$campDetails = $adminService->GetCampaignDetails($campProp);
				
				if(count($campDetails)){
					$count = count($campDetails);
					if($count > 1){
						$campaign = $campDetails[rand(0,$count-1)];
					}else{
						$campaign = $campDetails[0];
					}
					$notfService = new Application_Service_Communication();
					$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
					$campaignName = trim($campaign->getSponsor());
					$campaignDesc =	trim($campaign->getCampDesc());
					$campaignImg =	trim($campaign->getCampImage());
					$campId= $campaign->getId();
					}
					$data = array('UserName' =>$bookResult->getbokfirst_name().' '.$bookResult->getboklast_name(),
								  'SendTo'    =>explode(",",$request->to),
								  'RestName' => $restname,
								  'RestNbh'  => $restneighbour,
								  'ResDate'  => $request->date,
								  'Time'     => $request->time,
								  'Size'     => $request->partysize,
								  'Address'	 => $restaddr,
								  'Bokid'	 =>	$phraseId,
								  'City'	 =>	$restcity,
								  'Phone'	 => $restphone,
								  'Zipcode'	 => $restzipcode,
								  'RestEmail'=> $restemail,
								  'splname'	 =>	$splname,
								  'splstatus'=> $splstatus,
								  'spldesc'  => $spldesc,
								  'splid'	 => $splid,
								  'campaignName'=>$campaignName,
								  'campaignDesc'=>$campaignDesc,
								  'campaignImg'=>$campaignImg,
								  'campId'=>$campId
								  
					);
					$mailObj->setData($data);
					$mailStatus = $mailmapper->SendMail($mailObj);
						    
			}catch(Exception $ex){
				Uss_Logger_FileLogger::info($ex->getMessage());
				return true;
			}
	}
	
	public  function NotifyConfirmation(Reservation_Model_Reservation $bookObj,$request)//Moiz
	{
		try{
			$confirmationstatus = $request->constat;
			$fromaddressNotify = 'admin@dinedesk.com';
			$fromnameNotify = $request->senderemail;
				
			Zend_Mail::setDefaultTransport( new Zend_Mail_Transport_Postmark('37c5685c-d02f-4581-b6f8-c922a7bee942' ));
			$mail = new Zend_Mail();
			$email=$bookObj->getbokemail();	
			$subjectFriend='Acknowledgement';
			if($confirmationstatus==0){
				$mailbodyFriend='<div style="border:1px solid #F79646; padding:5px; line-height:32px;">Hi '.$bookObj->getbokfirst_name().' '.$bookObj->getboklast_name().',<br/>your guest '.$request->senderemail.' can not attend your reservation.</div>';
			}else{
				$mailbodyFriend='<div style="border:1px solid #F79646; padding:5px; line-height:32px;">Hi '.$bookObj->getbokfirst_name().' '.$bookObj->getboklast_name().',<br/>your guest '.$request->senderemail.' can attend your reservation.</div>';
			}
			
			$mail->setFrom($fromaddressNotify, $fromnameNotify);
			$mail->setReplyTo($fromaddressNotify,$fromnameNotify);
			$mail->setSubject($subjectFriend);
			$mail->setBodyHtml($mailbodyFriend);
			$mail->addTo($email,$email);								   
//		    $mail->send();
			
			}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			return true;
		}
	}
	
	public function AddContactFromDemo($formData)
	{
		try{
				$result = array();
				$mapper = new Communication_Model_ContactUsDataMapper();
				$contactObj = new Communication_Model_ContactUs();
				$firstName=$formData['firstName'];
//				$lastName=$formData['lastName'];
				$name=$firstName;
				$contactObj->setcontactname($name);
				$contactObj->setaddress($formData['address']);
				$contactObj->setRestname($formData['rest_name']);
//				$contactObj->setaddress('');
				$contactObj->setcity($formData['city']);
				$contactObj->setstate($formData['state']);
				$contactObj->setcountry('');
//				$contactObj->setzip($formData['zipcode']);
				$contactObj->setphone($formData['phoneNumber']);
				$contactObj->setCountryCode($formData['countryCode']);
				$contactObj->setemail($formData['emailAddress']);
				$contactObj->setfax('');
				$contactObj->setwebsite('');
				$contactObj->setmoreinformation('F');
				$contactObj->setcomments($formData['comments']);
				$contactObj->setcontactby($formData['contactType']);
				$contactObj->setpostedon(date('Y-m-d')); 
				$contactObj->setcontacttype('demo');
				
				$status = $mapper->CreateContact($contactObj);

				
			$mailmapper = new Application_Service_Communication();
			if($formData['contactType'] == 'email'){
				if($status){
					$mailObj = new Communication_Model_Mail();
					$mailObj->setMsgCode('EnquiryNot');
						$data = array('Name' => $name,
						  'City'    => $formData['city'],
						  'State' => $formData['state'],
						  'Country'  => '',
						  'Phone'     => $formData['countryCode'].$formData['phoneNumber'],
						  'Email'     => $formData['emailAddress'],
						  'Comments'     => $formData['comments']);
						  //'Status'	 => $formData['bookingStatus']);
						$mailObj->setData($data);
//						$mailStatus = $mailmapper->SendMail($mailObj);
					}	
				}
				return $status;

		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function AddNotifcationContent($request,$data)
	{
		try{
			$notfcon = new Communication_Model_NotifcationContent();
			$notfcon->setrestid($request->restaurantid);
			$notfcon->setdesc($request->Description);
			$notfcon->setcretedby($data['User_Id']);
			$notfcon->setcreteddate(date('Y-m-d H:i:s'));
			$notfcon->setstatus(true);
			$mapper = new Communication_Model_CommunicationContentDataMapper();
			$result = $mapper->AddNotifcationContent($notfcon);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getNotificationContentByResid($request)
	{
		try{
			$id = '';
			if($request->id){
				$id	= $request->id;
			}
			$resid 	= $request->restaurantid;
			$mapper = new Communication_Model_CommunicationContentDataMapper();
			$result = $mapper->getNotificationContentByResid($resid, $id);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function UpdateNotifcationContent($request,$data)
	{
		try{
			$notfcon = new Communication_Model_NotifcationContent();
			$notfcon->setid($request->id);
			$notfcon->setrestid($request->restaurantid);
			$notfcon->setdesc($request->Description);
			$notfcon->setupdatedby($data['User_Id']);
			$notfcon->setupdateddate(date('Y-m-d H:i:s'));
			$mapper = new Communication_Model_CommunicationContentDataMapper();
			$result = $mapper->UpdateNotifcationContent($notfcon);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function ChangeNotificationContentStatus($request, $data)
	{
		try{
			$notfcon = new Communication_Model_NotifcationContent();
			$notfcon->setid($request->id);
			$notfcon->setrestid($request->restaurantid);
			if($request->status == 't'){
				$notfcon->setstatus(1);
			}else if($request->status == 'f'){
				$notfcon->setstatus(0);
			}
			$notfcon->setupdatedby($data['User_Id']);
			$notfcon->setupdateddate(date('Y-m-d H:i:s'));
			$mapper = new Communication_Model_CommunicationContentDataMapper();
			$result = $mapper->ChangeNotificationContentStatus($notfcon);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getNotificationContentStatusByResid($resid)
	{
		try{
			$id = "";
			$mapper = new Communication_Model_CommunicationContentDataMapper();
			$result = $mapper->getNotificationContentByResid($resid, $id);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function MessageDisplayDetails($request)
	{
		try{
			$msgid = $request->msgid;
			
			$sender = '';
			if(isset($request->senderemail)){
				$sender = $request->senderemail;
			}
			$email_mapper = new Communication_Model_EmailMessageDataMapper();
			$msgid = $email_mapper->GetMsgIdByPhrase($msgid);
			if($msgid){
				$emailMessage = $email_mapper->GetMessageDetailsById($msgid);
				if($emailMessage && $emailMessage->emsg_fk_bokid){
					if($emailMessage->emsg_email_users == 'RES'){
						$bookServ = new Application_Service_Reservation();
						$bookResult = $bookServ->MessageDisplayDetailsForRestOwner($emailMessage,$sender);
					}
					else{					
						$bookServ = new Application_Service_Reservation();
						$bookResult = $bookServ->MessageDisplayDetails($emailMessage,$sender);
					}
					return $bookResult;
				}else{
					return false;
				}
			}else{
				return false;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function SuggestRestaurant($data)
	{
		try{
			$suggest = new Application_Model_CustomerSuggestRestaurant();
			$suggest->setUserId($data['user'])
					->setLastName($data['lastName'])
					->setFirstName($data['firstName'])
					->setRestName($data['restName'])
					->setRestManager($data['restManager'])
					->setRestAddress($data['restAddr'])
					->setRestCity($data['restCity'])
					->setRestState($data['restState'])
					->setRestEmail($data['restEmail'])
					->setRestPhone($data['restPhone'])
					->setRestZip($data['restZipcode']);
			$mapper = new Application_Model_CustomerSuggestRestaurantMapper();
			$result = $mapper->SuggestRestaurant($suggest);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GenerateOtp($request)
	{
		try{
			$resServ = new Application_Service_Firm();
			$timeZone = $resServ->GetRestaurantTimeZone($request->restaurantid);
			date_default_timezone_set($timeZone);
			if($request->otptext){
				$mapper = new Communication_Model_BookingOtpMapper();
				$result = $mapper->ValidateBookingOtp($request->otpid,$request->otptext);
				if($result){
					return array('otpstat'=>'true');
				}else{
					return array('otpstat'=>'false');
				}
			}else{
				$otpVal = mt_rand(100000, 999999);
				if($request->notType == 'sms'){
					$smsObj = new Communication_Model_Sms();
					$smsObj->setMsgCode('BookOtp');
					$data = array('to' 		 	 => $request->notCont,
								  'countrycode'	 => $request->countrycode,
								  'OtpVal'		 => $otpVal,
								  'ResId'	 	 => $request->restaurantid,
								  'CustomerName' => $request->firstName.' '.$request->lastName);

					$smsObj->setData($data);
					$mailStatus = $this->SendSms($smsObj);
				}else if($request->notType == 'email'){
					$mailObj = new Communication_Model_Mail();
					$mailObj->setMsgCode('BookingOTP');
					$data = array('to' 		 	 => $request->notCont,
								  'OtpVal'		 => $otpVal,
								  'ResId'	 	 => $request->restaurantid,
								  'CustomerName' => $request->firstName.' '.$request->lastName);

					$mailObj->setData($data);
					$mailStatus = $this->SendMail($mailObj);
				}
				$otp = new Communication_Model_BookingOtp();
				$otp->setbok_otp_val($otpVal)
					->setbok_otp_generated_time(date('H:i:s'))
					->setbok_otp_generated_date(date('Y-m-d'))
					->setbok_otp_expiry_time(date('H:i:s', strtotime("+3 min")))
					->setbok_otp_status('T');
				$mapper = new Communication_Model_BookingOtpMapper();
				$result = $mapper->SaveOtpGeneration($otp);
				return array('otpid'=>$result,'otp'=>$otp->getbok_otp_val(),'otpstart'=>$otp->getbok_otp_generated_time(),'otpexp'=>$otp->getbok_otp_expiry_time());
			}
			
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function FeedbackReviewsCommunication($feedData)
	{
		try{
			$feedQueMapper = new FirmManagement_Model_FeedbackQuestionsMapper();
			$feedRevData = $feedQueMapper->GetFeedbackReviewsById($feedData['fbco_fk_feedback']);
			$htmlString = '';
			foreach($feedRevData as $result){
				$splitdate = explode(' ',$result['created']);
				$tSel = explode('-',$splitdate[0]);
				if($tSel[0] > 12){
					$formatDate = date("d M Y",mktime(0,0,0,$tSel[1],$tSel[2],$tSel[0]));
				}else {
					$formatDate = date("d M Y",mktime(0,0,0,$tSel[0],$tSel[1],$tSel[2]));
				}
				$time = explode(':',$splitdate[1]);
				if($time[0] >=12){
					if((int)$time[0] != 12){
						(int)$time[0] -= 12;
					}
					$time[2] = 'PM';
					$TimeFormat = $time[0].':'.$time[1].' '.$time[2];
				}else{
					$time[2] = 'AM';
					$TimeFormat = $time[0].':'.$time[1].' '.$time[2];
				}
				if($result['email']){	
					$htmlString .= '<table cellpadding="0" cellspacing="0" border="0" width="100%">        			
										<tr>
											<td align="center" width="100%">
												<table cellpadding="0" cellspacing="0" border="0" width="100%">
													
													<tr>
														<td><img src="http://www.dinedesk.com/images/dinedesk-logo.png" border="0" height="60" align="left">
													</td></tr><tr>
														<td bgcolor="#a6ce39" style="font-size:0;line-height:0" width="100%" height="17"></td>
													</tr>
													<tr>
														<td align="left">
															<table cellpadding="0" cellspacing="0" border="0" width="450">
																	<tbody><tr>
																		<td height="10" align="left" style="font-size:0;line-height:0"><img src="http://www.dinedesk.com/images/email/spacer.gif" width="1" height="10" border="0" style="display:block"></td>
																	</tr>
																	<tr>
																		<td height="1"  align="left" style="font-size:0;line-height:0"><img src="http://www.dinedesk.com/images/email/spacer.gif" width="1" height="1" border="0" style="display:block"></td>
																	</tr>
																	<tr>
																		<td height="10" align="left" style="font-size:0;line-height:0"><img src="http://www.dinedesk.com/images/email/spacer.gif" width="1" height="10" border="0" style="display:block"></td>
																	</tr>
																</tbody>
															</table>
														</td>
													</tr>
													<tr>
														<td bgcolor="#ffffff">
															<table cellpadding="0" cellspacing="0" border="0" width="100%">
																<tr>
																	<td width="6"><img src="http://www.dinedesk.com/images/email/spacer.gif" width="6" height="1" border="0" style="display:block"></td>
																	<td>';
					$htmlString .= '<table cellpadding="0" cellspacing="0" border="0" width="100%">
										<tr>
											<td bgcolor="#D6D1CC" align="center">
												<table cellpadding="0" cellspacing="0" border="0" width="100%">
													<tr>
														<td style="height:10px"></td>
														<td style="height:10px"></td>
														<td style="height:10px"></td>
													</tr>
													<tr>
														<td style="width:10px;"></td>
														<td>
															<table cellpadding="0" cellspacing="0" border="0" width="100%">
																<tr>
																	<td style="width:66px"><img src="http://www.dinedesk.com/images/author.png" style="height:60px; width:60px;" /></td>
																	<td>
																		<span style="font-family:Helvetica,Arial,sans-serif;font-size:16px;line-height:24px;font-weight:bold;color:#000">'.$result['fname'].' '.$result['lname'].'</span><br />
																		<span style="font-family:Helvetica,Arial,sans-serif;font-size:12px;line-height:24px;font-weight:normal;color:#000">'.$result['phone'].',&nbsp;'.$result['email'].'</span><br />																		
																	</td>
																	<td style="width:66px; text-align:center;">
																		<span style="font-family:Helvetica,Arial,sans-serif;font-size:16px;line-height:24px;font-weight:bold;color:#fff; padding:10px 14px; background:#CB202D">'.$result['rating'].'.0'.'</span>
																	</td>
																</tr>
															</table>
														</td>
														<td style="width:10px;"></td>
													</tr>
													<tr>
														<td style="height:10px"></td>
														<td style="height:10px"></td>
														<td style="height:10px"></td>
													</tr>
												</table>
											</td>
										</tr>
										<tr>
											<td style="font-family:Helvetica,Arial,sans-serif;font-size:12px;line-height:24px;font-weight:normal;color:#000; padding:6px 0;">'.$formatDate.' '.$TimeFormat.'</td>
										</tr>
										<tr>
											<td style="font-family:Helvetica,Arial,sans-serif;font-size:14px;line-height:20px;font-weight:normal;color:#838383; padding:6px 0;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; '.$result['comment'].'</td>
										</tr>
										<tr>
											<td style="padding:6px 0;">
												<table class="report_table">';
				
							
							
					for($count = 0;$count< count($result['idArr']);$count++){
						if(isset($result['quesArr'][$count]) && isset($result['ansArr'][$count])){
							$htmlString .= '<tr>
												<td style="font-family:Helvetica,Arial,sans-serif;font-size:14px;line-height:24px;font-weight:bold;color:#000">Q : '.$result['quesArr'][$count].'</td>
											</tr>
											<tr>
												<td style="font-family:Helvetica,Arial,sans-serif;font-size:14px;line-height:24px;font-weight:bold;color:#838383">A : '.$result['ansArr'][$count].'</td>
											</tr>';
						}
					}
					$htmlString .= '</table>
											</td>
										</tr>';
					foreach($result['feedCommResult'] as $feedCommResult){
						$htmlString .= '<tr>
											<td>
												<table>
													<tr>
														<td style="width:20px;">
														
														</td>
														<td>
															<table cellpadding="0" cellspacing="0" border="0" width="100%">
																<tr>
																	<td style="height:10px"></td>
																	<td style="height:10px"></td>
																	<td style="height:10px"></td>
																</tr>
																<tr>
																	<td style="width:10px;"></td>
																	<td>
																		<table cellpadding="0" cellspacing="0" border="0" width="100%">
																			<tbody><tr>
																				<td style="width:66px"><img src="http://www.dinedesk.com/images/author.png" style="height:60px; width:60px;"></td>
																				<td>';
						if($feedCommResult['code'] == 'CUS'){
							$htmlString .= '<span style="font-family:Helvetica,Arial,sans-serif;font-size:16px;line-height:24px;font-weight:bold;color:#000">'.$result['fname'].' '.$result['lname'].'</span><br>';
							$htmlString .= '<span style="font-family:Helvetica,Arial,sans-serif;font-size:12px;line-height:16px;font-weight:normal;color:#000">'.$feedCommResult['fbco_feedback_created'].'</span><br>';
						}else{
							$htmlString .= '<span style="font-family:Helvetica,Arial,sans-serif;font-size:16px;line-height:24px;font-weight:bold;color:#000">'.$result['restaurant_name'].'</span><br>';
							$htmlString .= '<span style="font-family:Helvetica,Arial,sans-serif;font-size:12px;line-height:16px;font-weight:normal;color:#000">'.$feedCommResult['fbco_feedback_created'].'</span><br>';
						}
						$htmlString .= '
														
																																						
																					<span style="font-family:Helvetica,Arial,sans-serif;font-size:12px;line-height:16px;font-weight:normal;color:#000">'.$feedCommResult['fbco_feedback_desc'].'</span><br>																		
																				</td>
																			</tr>
																		</tbody></table>
																	</td>
																	<td style="width:10px;"></td>
																</tr>
																<tr>
																	<td style="height:10px"></td>
																	<td style="height:10px"></td>
																	<td style="height:10px"></td>
																</tr>
															</table>
														</td>
													</tr>
												</table>
											</td>
										</tr>';
						
					}
													
					$htmlString .= '<tr>
											<td>';
					if($feedCommResult['code'] == 'CUS'){
						$htmlString .= '<a href="http://www.dinedesk.com/Reservation/Reservation/feedbackreviewscomm/commentId/'.$result['commentid'].'/replyBy/RES" >Reply</a>';
					}else{
						$htmlString .= '<a href="http://www.dinedesk.com/Reservation/Reservation/feedbackreviewscomm/commentId/'.$result['commentid'].'/replyBy/CUS" >Reply</a>';
					}
					$htmlString .= '</td>
										</tr>
										<tr>
											<td height="20" align="left" style="font-size:0;line-height:0"><img src="http://www.dinedesk.com/images/email/spacer.gif" width="1" height="20" border="0" style="display:block"></td>
										</tr>
									</table>
								</td>
								<td width="6"><img src="http://www.dinedesk.com/images/email/spacer.gif" width="6" height="1" border="0" style="display:block"></td>
							</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td bgcolor="#D6D1CC" align="center">
						<table cellpadding="0" cellspacing="0" border="0" width="100%">
							
							<tr>
								<td bgcolor="#D6D1CC" align="center">
									<table cellpadding="0" cellspacing="0" border="0" width="100%">
										
										<tr>
											<td height="20" align="left" style="font-size:0;line-height:0"><img src="http://www.dinedesk.com/images/email/spacer.gif" width="1" height="20" border="0" style="display:block"></td>
										</tr>
										<tr>
											<td align="center">
												<table cellpadding="0" cellspacing="0" border="0">
													
													<tr>
														<td align="left" style="font-family:Helvetica,Arial,sans-serif;font-size:10px"><a href="http://www.facebook.com/DineDesk" style="color:#ffffff;text-decoration:none" target="_blank"><img src="https://ci5.googleusercontent.com/proxy/REe6mfHnDzOBAFAYRuhQpXj0gKINRF_upuaPKahM0Nm0xdtIRfAT7XrVUnqNHKG3O-GCqGj4dOsdTBenGsSfnGhY=s0-d-e1-ft#http://www.dinedesk.com/images/facebook1.png" width="29" height="29" alt="facebook" border="0" style="display:block"></a></td>
														<td width="10" align="left" style="font-size:0;line-height:0"><img src="http://www.dinedesk.com/images/email/spacer.gif" width="10" height="1" border="0" style="display:block"></td>
														<td align="left" style="font-family:Helvetica,Arial,sans-serif;font-size:10px"><a href="http://twitter.com/#!/dinedesk" style="color:#ffffff;text-decoration:none" target="_blank"><img src="https://ci6.googleusercontent.com/proxy/6qfzhIpIUD4roznOL68Fgkeojntw-VzgrWK8pNrI0xz618zzvD39hzPyCvVcCNu3CkHk9sQbbzOh5aD1zL-p5aQ=s0-d-e1-ft#http://www.dinedesk.com/images/twitter1.png" width="29" height="29" alt="twitter" border="0" style="display:block"></a></td>
														<td width="10" align="left" style="font-size:0;line-height:0"><img src="http://www.dinedesk.com/images/email/spacer.gif" width="10" height="1" border="0" style="display:block"></td>
														<td align="left" style="font-family:Helvetica,Arial,sans-serif;font-size:10px"><a href="http://linkedin.com/dinedesk" style="color:#ffffff;text-decoration:none" target="_blank"><img src="https://ci6.googleusercontent.com/proxy/6yTfnRRnRyLCaTzNcDOF8yc7OnBr_b2kyGgexwqyxHLvXsbXHb6RAyx2_k9kEVWrGXk7ycz6iyjpat7dLn_VN947=s0-d-e1-ft#http://www.dinedesk.com/images/linkedin1.png" width="29" height="29" alt="Google Plus" border="0" style="display:block"></a></td>
													</tr>
													
												</table>
											</td>
										</tr>
										<tr>
											<td height="20" align="left" style="font-size:0;line-height:0"><img src="http://www.dinedesk.com/images/email/spacer.gif" width="1" height="20" border="0" style="display:block"></td>
										</tr>
										
									</table>
								</td>
							</tr>
							
						</table>
					</td>
				</tr>
				
			</table>
		</td>
	</tr>
	
</table>';
				 
					 if($htmlString){
					 	if($feedCommResult['code'] == 'CUS'){
					 		$receipent = $result['resemail'];
					 		$from = $result['email'];
					 		$fromName = $result['fname'].' '.$result['lname'];
					 		$receipentName = $result['restaurant_name'];
					 	}else{
					 		$receipent = $result['email'];
					 		$from = $result['resemail'];
					 		$receipentName = $result['fname'].' '.$result['lname'];
					 		$fromName = $result['restaurant_name'];
					 	}
					 	
					 	$request = array(
					 			'subject' => 'Feedback Review',
					 			'from'    => array( // required. A sender’s information
					 					'name'  => 'DineDesk',
					 					'email' => 'support@dinedesk.com'
					 			),
					 			'signing_domain'=>'dinedesk.com',
					 			'to' => array(
					 					array(
					 							'name' => 'test',
					 							'email' => $receipent)
					 			),
					 			'html'       => $htmlString, // email's HTML content
					 			'auto_plain' => true, // automatically generate a text part for the messages of HTML part
					 			'merge_vars' => array( // define merge variables for each recipient
					 					'kotturs@gmail.com' => array(
					 							array(
					 									'name'  => 'FNAME',
					 									'value' => 'Alex'
					 							),
					 							array(
					 									'name'  => 'LNAME',
					 									'value' => 'Doubt'
					 							)
					 					)
					 			)
					 	);
					 	$LeaderSendApi  = new LeaderSend_Inc_Leadersend();
					 	$retval = $LeaderSendApi->messagesSend($request);
					 	
// 					 	Zend_Mail::setDefaultTransport( new Zend_Mail_Transport_Postmark('7c73f7f1-c2e6-4bbd-aa4b-fc1dadcb7da8' ));
// 					 	$mail = new Zend_Mail();
// 					 	$mail->setFrom($from, $fromName);
// 					 	$mail->setReplyTo($from,$fromName);
// 					 	$mail->addTo( $receipent,$receipentName);
// 					 	$mail->setSubject('descrk');
// 					 	$mail->setBodyHtml('test');
// 					 	$mail->send();
					 	return true;
					 }else{
					 	return false;
					 }
				}else{
					$reverseFeedCommResult = '';
					foreach($result['feedCommResult'] as $feedCommResult){
						$reverseFeedCommResult = $feedCommResult;
					}
					$htmlString = '';
					$mobile = '';
					if($feedCommResult['code'] == 'CUS'){
						$htmlString .= $result['fname'].' '.$result['lname'].' says ';
						$htmlString .= $feedCommResult['fbco_feedback_desc'].' for your response on feedback';
						$mobile = $result['phone'];
					}
					$mailStatus = $this->SendBulkMessage($htmlString,$mobile);
				}
			}		
								
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getrestFeedbackEmails()
	{
		$restService = new FirmManagement_Model_FirmDataMapper();
		$emailresult = $restService->getFeedbackEmailsOfRestaurant();
		$keys = array_keys($emailresult['feedbackEmails']);
		$fromaddress = 'admin@dinedesk.com';
		$replyfromaddress = 'support@dinedesk.com';
		$fromname = 'DineDesk';
		$replyfromname = 'DineDesk Support';
		$resid  = "";
		$ResidArr = array();
		foreach($keys as $key){
// 			if($key == 78){
				$resid = $key;
				$RestaurantName = $emailresult['resName'][$resid];
				$resServ = new Application_Service_Firm();
				$timeZone = $resServ->GetRestaurantTimeZone($resid);
				date_default_timezone_set($timeZone);
				$from = date('Y-m-d 00:00:00',strtotime(date('m/d/Y', strtotime("-1 days"))));
				$fromDate = date('d M Y',strtotime(date('m/d/Y', strtotime("-1 days"))));
	//			$to = date('Y-m-d 00:00:00',strtotime(date('m/d/Y', strtotime("-1 days"))));
				$to = date('Y-m-d').' 00:00:00';
				$mapper = new FirmManagement_Model_FeedbackQuestionsMapper();
				$resultSet = $mapper->GetFeedbackReviewsHistoryofRestaurant($resid,$from,$to);
				if(count($resultSet) > 0 ){
					$userProcessedArr = array();
					$msgbodyArr = array();
					$htmlString = '<table cellpadding="0" cellspacing="0" border="0" width="100%">
											<tr>
												<td align="center" width="100%">
													<table cellpadding="0" cellspacing="0" border="0" width="100%">
					
														<tr>
															<td><img src="http://www.dinedesk.com/ddstyles/images/DineDesk_logo.png" border="0" height="60" align="left">
														</td></tr><tr>
															<td bgcolor="#a6ce39" style="font-size:0;line-height:0" width="100%" height="17"></td>
														</tr>
														<tr>
															<td align="left">
																<table cellpadding="0" cellspacing="0" border="0" width="450">
																		<tbody><tr>
																			<td height="10" align="left" style="font-size:0;line-height:0"><img src="http://www.dinedesk.com/images/email/spacer.gif" width="1" height="10" border="0" style="display:block"></td>
																		</tr>
																		<tr>
																			<td height="1"  align="left" style="font-size:0;line-height:0"><img src="http://www.dinedesk.com/images/email/spacer.gif" width="1" height="1" border="0" style="display:block"></td>
																		</tr>
																		<tr>
																			<td height="10" align="left" style="font-size:0;line-height:0"><img src="http://www.dinedesk.com/images/email/spacer.gif" width="1" height="10" border="0" style="display:block"></td>
																		</tr>
																	</tbody>
																</table>
															</td>
														</tr>';
					foreach($resultSet as $result){
						if(in_array($result['guest'],$userProcessedArr)){
							continue; 
						}
						$userProcessedArr[] = $result['guest'];
						$msgbody = '<table class="table2" width="100%">';
						$splitdate = explode(' ',$result['created']);
						$tSel = explode('-',$splitdate[0]);
						if($tSel[0] > 12){
							$formatDate = date("d M Y",mktime(0,0,0,$tSel[1],$tSel[2],$tSel[0]));
						}else {
							$formatDate = date("d M Y",mktime(0,0,0,$tSel[0],$tSel[1],$tSel[2]));
						}
						$time = explode(':',$splitdate[1]);
				    	if($time[0] >=12){
							if((int)$time[0] != 12){
								(int)$time[0] -= 12;
							}
							$time[2] = 'PM';
							$TimeFormat = $time[0].':'.$time[1].' '.$time[2];
						}else{
							$time[2] = 'AM';
							$TimeFormat = $time[0].':'.$time[1].' '.$time[2];
						}
// 						$userProcessedArr[$result['fname'].' '.$result['lname'].$result['phone'].',&nbsp;'.$result['email']];
						
						$htmlString .= '				<tr>
															<td bgcolor="#ffffff">
																<table cellpadding="0" cellspacing="0" border="0" width="100%">
																	<tr>
																		<td width="6"><img src="http://www.dinedesk.com/images/email/spacer.gif" width="6" height="1" border="0" style="display:block"></td>
																		<td>
						<table cellpadding="0" cellspacing="0" border="0" width="100%">
											<tr>
												<td bgcolor="#D6D1CC" align="center">
													<table cellpadding="0" cellspacing="0" border="0" width="100%">
														<tr>
															<td style="height:10px"></td>
															<td style="height:10px"></td>
															<td style="height:10px"></td>
														</tr>
														<tr>
															<td style="width:10px;"></td>
															<td>
																<table cellpadding="0" cellspacing="0" border="0" width="100%">
																	<tr>
																		<td style="width:66px"><img src="http://www.dinedesk.com/images/author.png" style="height:60px; width:60px;" /></td>
																		<td>
																			<span style="font-family:Helvetica,Arial,sans-serif;font-size:16px;line-height:24px;font-weight:bold;color:#000">'.$result['fname'].' '.$result['lname'].'</span><br />
																			<span style="font-family:Helvetica,Arial,sans-serif;font-size:12px;line-height:24px;font-weight:normal;color:#000">'.$result['phone'].',&nbsp;'.$result['email'].'</span><br />
																		</td>
																		<td style="width:66px; text-align:center;">
																			<span style="font-family:Helvetica,Arial,sans-serif;font-size:16px;line-height:24px;font-weight:bold;color:#fff; padding:10px 14px; background:#CB202D">'.$result['rating'].'.0'.'</span>
																		</td>
																	</tr>
																</table>
															</td>
															<td style="width:10px;"></td>
														</tr>
														<tr>
															<td style="height:10px"></td>
															<td style="height:10px"></td>
															<td style="height:10px"></td>
														</tr>
													</table>
												</td>
											</tr>
											<tr>
												<td style="font-family:Helvetica,Arial,sans-serif;font-size:12px;line-height:24px;font-weight:normal;color:#000; padding:6px 0;">'.$formatDate.' '.$TimeFormat.'</td>
											</tr>
											<tr>
												<td style="font-family:Helvetica,Arial,sans-serif;font-size:14px;line-height:20px;font-weight:normal;color:#838383; padding:6px 0;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; '.$result['comment'].'</td>
											</tr>
											<tr>
												<td style="padding:6px 0;">
													<table class="report_table">';
						
							
							
						for($count = 0;$count< count($result['idArr']);$count++){
							if(isset($result['quesArr'][$count]) && isset($result['ansArr'][$count])){
								$htmlString .= '<tr>
												<td style="font-family:Helvetica,Arial,sans-serif;font-size:14px;line-height:24px;font-weight:bold;color:#000">Q : '.$result['quesArr'][$count].'</td>
											</tr>
											<tr>
												<td style="font-family:Helvetica,Arial,sans-serif;font-size:14px;line-height:24px;font-weight:bold;color:#838383">A : '.$result['ansArr'][$count].'</td>
											</tr>';
							}						
						}
						$htmlString .= '</table>
												</td>
											</tr>';
						foreach($result['feedCommResult'] as $feedCommResult){
							$htmlString .= '<tr>
												<td>
													<table>
														<tr>
															<td style="width:20px;">
						
															</td>
															<td>
																<table cellpadding="0" cellspacing="0" border="0" width="100%">
																	<tr>
																		<td style="height:10px"></td>
																		<td style="height:10px"></td>
																		<td style="height:10px"></td>
																	</tr>
																	<tr>
																		<td style="width:10px;"></td>
																		<td>
																			<table cellpadding="0" cellspacing="0" border="0" width="100%">
																				<tbody><tr>
																					<td style="width:66px"><img src="http://www.dinedesk.com/images/author.png" style="height:60px; width:60px;"></td>
																					<td>';
							if($feedCommResult['code'] == 'CUS'){
								$htmlString .= '<span style="font-family:Helvetica,Arial,sans-serif;font-size:16px;line-height:24px;font-weight:bold;color:#000">'.$result['fname'].' '.$result['lname'].'</span><br>';
								$htmlString .= '<span style="font-family:Helvetica,Arial,sans-serif;font-size:12px;line-height:16px;font-weight:normal;color:#000">'.$feedCommResult['fbco_feedback_created'].'</span><br>';
							}else{
								$htmlString .= '<span style="font-family:Helvetica,Arial,sans-serif;font-size:16px;line-height:24px;font-weight:bold;color:#000">'.$result['restaurant_name'].'</span><br>';
								$htmlString .= '<span style="font-family:Helvetica,Arial,sans-serif;font-size:12px;line-height:16px;font-weight:normal;color:#000">'.$feedCommResult['fbco_feedback_created'].'</span><br>';
							}
							$htmlString .= '
						
						
																						<span style="font-family:Helvetica,Arial,sans-serif;font-size:12px;line-height:16px;font-weight:normal;color:#000">'.$feedCommResult['fbco_feedback_desc'].'</span><br>
																					</td>
																				</tr>
																			</tbody></table>
																		</td>
																		<td style="width:10px;"></td>
																	</tr>
																	<tr>
																		<td style="height:10px"></td>
																		<td style="height:10px"></td>
																		<td style="height:10px"></td>
																	</tr>
																</table>
															</td>
														</tr>
													</table>
												</td>
											</tr>';
						
						}
							
						$htmlString .= '<tr>
												<td>';
						$htmlString .= '<a href="http://www.dinedesk.com/Reservation/Reservation/feedbackreviewscomm/commentId/'.$result['commentid'].'/replyBy/RES" >Reply</a>';
						$htmlString .= '</td>
											</tr>
											<tr>
												<td height="20" align="left" style="font-size:0;line-height:0"><img src="http://www.dinedesk.com/images/email/spacer.gif" width="1" height="20" border="0" style="display:block"></td>
											</tr>
										</table>
														</td>
														<td width="6"><img src="http://www.dinedesk.com/images/email/spacer.gif" width="6" height="1" border="0" style="display:block"></td>
													</tr>
												</table>
											</td>
										</tr>';
					}
						$htmlString .= '<tr>
											<td bgcolor="#D6D1CC" align="center">
												<table cellpadding="0" cellspacing="0" border="0" width="100%">
										
													<tr>
														<td bgcolor="#D6D1CC" align="center">
															<table cellpadding="0" cellspacing="0" border="0" width="100%">
											
																<tr>
																	<td height="20" align="left" style="font-size:0;line-height:0"><img src="http://www.dinedesk.com/images/email/spacer.gif" width="1" height="20" border="0" style="display:block"></td>
																</tr>
																<tr>
																	<td align="center">
																		<table cellpadding="0" cellspacing="0" border="0">
													
																			<tr>
																				<td align="left" style="font-family:Helvetica,Arial,sans-serif;font-size:10px"><a href="http://www.facebook.com/DineDesk" style="color:#ffffff;text-decoration:none" target="_blank"><img src="https://ci5.googleusercontent.com/proxy/REe6mfHnDzOBAFAYRuhQpXj0gKINRF_upuaPKahM0Nm0xdtIRfAT7XrVUnqNHKG3O-GCqGj4dOsdTBenGsSfnGhY=s0-d-e1-ft#http://www.dinedesk.com/images/facebook1.png" width="29" height="29" alt="facebook" border="0" style="display:block"></a></td>
																				<td width="10" align="left" style="font-size:0;line-height:0"><img src="http://www.dinedesk.com/images/email/spacer.gif" width="10" height="1" border="0" style="display:block"></td>
																				<td align="left" style="font-family:Helvetica,Arial,sans-serif;font-size:10px"><a href="http://twitter.com/#!/dinedesk" style="color:#ffffff;text-decoration:none" target="_blank"><img src="https://ci6.googleusercontent.com/proxy/6qfzhIpIUD4roznOL68Fgkeojntw-VzgrWK8pNrI0xz618zzvD39hzPyCvVcCNu3CkHk9sQbbzOh5aD1zL-p5aQ=s0-d-e1-ft#http://www.dinedesk.com/images/twitter1.png" width="29" height="29" alt="twitter" border="0" style="display:block"></a></td>
																				<td width="10" align="left" style="font-size:0;line-height:0"><img src="http://www.dinedesk.com/images/email/spacer.gif" width="10" height="1" border="0" style="display:block"></td>
																				<td align="left" style="font-family:Helvetica,Arial,sans-serif;font-size:10px"><a href="http://linkedin.com/dinedesk" style="color:#ffffff;text-decoration:none" target="_blank"><img src="https://ci6.googleusercontent.com/proxy/6yTfnRRnRyLCaTzNcDOF8yc7OnBr_b2kyGgexwqyxHLvXsbXHb6RAyx2_k9kEVWrGXk7ycz6iyjpat7dLn_VN947=s0-d-e1-ft#http://www.dinedesk.com/images/linkedin1.png" width="29" height="29" alt="Google Plus" border="0" style="display:block"></a></td>
																			</tr>
													
																		</table>
																	</td>
																</tr>
																<tr>
																	<td height="20" align="left" style="font-size:0;line-height:0"><img src="http://www.dinedesk.com/images/email/spacer.gif" width="1" height="20" border="0" style="display:block"></td>
																</tr>
											
															</table>
														</td>
													</tr>
										
												</table>
											</td>
										</tr>
											
									</table>
								</td>
							</tr>
											
						</table>';
						
						
						$msgbodyArr[] = $htmlString;
					
					$htmlString = implode('',$msgbodyArr);
				}else{
					$htmlString = '<table cellpadding="0" cellspacing="0" border="0" width="100%">
											<tr>
												<td align="center" width="100%">
													<table cellpadding="0" cellspacing="0" border="0" width="100%">
					
														<tr>
															<td><img src="http://www.dinedesk.com/images/dinedesk-logo.png" border="0" height="60" align="left">
														</td></tr><tr>
															<td bgcolor="#a6ce39" style="font-size:0;line-height:0" width="100%" height="17"></td>
														</tr>
														<tr>
															<td align="left">
																<table cellpadding="0" cellspacing="0" border="0" width="450">
																		<tbody><tr>
																			<td height="10" align="left" style="font-size:0;line-height:0"><img src="http://www.dinedesk.com/images/email/spacer.gif" width="1" height="10" border="0" style="display:block"></td>
																		</tr>
																		<tr>
																			<td height="1"  align="left" style="font-size:0;line-height:0"><img src="http://www.dinedesk.com/images/email/spacer.gif" width="1" height="1" border="0" style="display:block"></td>
																		</tr>
																		<tr>
																			<td height="10" align="left" style="font-size:0;line-height:0"><img src="http://www.dinedesk.com/images/email/spacer.gif" width="1" height="10" border="0" style="display:block"></td>
																		</tr>
																	</tbody>
																</table>
															</td>
														</tr>';
					$htmlString .= '<p>There are no feedbacks for '.$RestaurantName.' on '.$fromDate.'.</p>';
					$htmlString .= '<tr>
										<td>
											<table width="100%" cellpadding="0" cellspacing="0">
												<tr>
													<th colspan="3">
														<h2><span style="text-align:center;font-size: 18px; line-height: 29px; font-family: Arial,sans-serif; color: #7aa318; margin: 18px 0; font-weight: 300;">Faster. Smarter. Easier.</span><span  style="color: #545d64; font-size: 14px; line-height: 18px; font-family:Arial,sans-serif;margin:0;font-weight: 400;"> way of guest feedbacks</span> </h2>
													</th>
												</tr>
												<tr>
													<td width="49%"><img src="http://www.dinedesk.com/ddstyles/images/iphone-ipad-android.jpg" style="width:100%;" title="Online Restaurant Reservations Dinedesk" alt="Online Restaurant Reservations Dinedesk"></td>
													<td width="2%"></td>
													<td width="49%">
														<table>
															<tr>
																<td><p style="color: #545d64; font-size: 14px; line-height: 18px; font-family:Arial,sans-serif;margin:10px 0;font-weight: 400;">STILL USING PAPER BASED FEEDBACK FORM? AUTOMATE NOW!</p></td>
															</tr>
															<tr>
																<td><h2 style="font-size: 24px;line-height: 28px;font-family:Arial,sans-serif;color: #7aa318;margin-bottom: 18px;font-weight: 300;">Powerful Reporting, Intelligent Insights and Instant Alerts</h2></td>
															</tr>
															<tr>
																<td><p style="color: #545d64; font-size: 14px; line-height: 18px; font-family:Arial,sans-serif;margin:0 0 20px 0;font-weight: 400;">Now your customers can provide feedback using tablets. Please download the dinedesk software on your tablet.</p></td>
															</tr>
															<tr>
																<td>
																	<a href="https://play.google.com/store/apps/details?id=com.tablet.dinedesk&hl=en" target="_blank"><img src="http://www.dinedesk.com/ddstyles/images/google-play.png" style="height:30px; margin-bottom:20px;" /></a>
																	<a href="http://appstore.com/dinedesk" target="_blank"><img src="http://www.dinedesk.com/ddstyles/images/apple-store.png" style="height:30px; margin-bottom:20px;" /></a>
																</td>
															</tr>
														</table>
													</td>
												</tr>
											</table>
										</td>
									  </tr>';
					$htmlString .= '<tr>
											<td bgcolor="#D6D1CC" align="center">
												<table cellpadding="0" cellspacing="0" border="0" width="100%">
						
													<tr>
														<td bgcolor="#D6D1CC" align="center">
															<table cellpadding="0" cellspacing="0" border="0" width="100%">
					
																<tr>
																	<td height="20" align="left" style="font-size:0;line-height:0"><img src="http://www.dinedesk.com/images/email/spacer.gif" width="1" height="20" border="0" style="display:block"></td>
																</tr>
																<tr>
																	<td align="center">
																		<table cellpadding="0" cellspacing="0" border="0">
					
																			<tr>
																				<td align="left" style="font-family:Helvetica,Arial,sans-serif;font-size:10px"><a href="http://www.facebook.com/DineDesk" style="color:#ffffff;text-decoration:none" target="_blank"><img src="https://ci5.googleusercontent.com/proxy/REe6mfHnDzOBAFAYRuhQpXj0gKINRF_upuaPKahM0Nm0xdtIRfAT7XrVUnqNHKG3O-GCqGj4dOsdTBenGsSfnGhY=s0-d-e1-ft#http://www.dinedesk.com/images/facebook1.png" width="29" height="29" alt="facebook" border="0" style="display:block"></a></td>
																				<td width="10" align="left" style="font-size:0;line-height:0"><img src="http://www.dinedesk.com/images/email/spacer.gif" width="10" height="1" border="0" style="display:block"></td>
																				<td align="left" style="font-family:Helvetica,Arial,sans-serif;font-size:10px"><a href="http://twitter.com/#!/dinedesk" style="color:#ffffff;text-decoration:none" target="_blank"><img src="https://ci6.googleusercontent.com/proxy/6qfzhIpIUD4roznOL68Fgkeojntw-VzgrWK8pNrI0xz618zzvD39hzPyCvVcCNu3CkHk9sQbbzOh5aD1zL-p5aQ=s0-d-e1-ft#http://www.dinedesk.com/images/twitter1.png" width="29" height="29" alt="twitter" border="0" style="display:block"></a></td>
																				<td width="10" align="left" style="font-size:0;line-height:0"><img src="http://www.dinedesk.com/images/email/spacer.gif" width="10" height="1" border="0" style="display:block"></td>
																				<td align="left" style="font-family:Helvetica,Arial,sans-serif;font-size:10px"><a href="http://linkedin.com/dinedesk" style="color:#ffffff;text-decoration:none" target="_blank"><img src="https://ci6.googleusercontent.com/proxy/6yTfnRRnRyLCaTzNcDOF8yc7OnBr_b2kyGgexwqyxHLvXsbXHb6RAyx2_k9kEVWrGXk7ycz6iyjpat7dLn_VN947=s0-d-e1-ft#http://www.dinedesk.com/images/linkedin1.png" width="29" height="29" alt="Google Plus" border="0" style="display:block"></a></td>
																			</tr>
					
																		</table>
																	</td>
																</tr>
																<tr>
																	<td height="20" align="left" style="font-size:0;line-height:0"><img src="http://www.dinedesk.com/images/email/spacer.gif" width="1" height="20" border="0" style="display:block"></td>
																</tr>
					
															</table>
														</td>
													</tr>
						
												</table>
											</td>
										</tr>
					
									</table>
								</td>
							</tr>
					
						</table>';
				}
				
				$language = "en";
				$namespace = new Zend_Session_Namespace(); 
				if($namespace->lang && $namespace->lang == "es_SP"){
					$language = "sp";
				}
				$mailobj = new Communication_Model_Mail(); 
				Zend_Mail::setDefaultTransport( new Zend_Mail_Transport_Postmark('7c73f7f1-c2e6-4bbd-aa4b-fc1dadcb7da8' ));
				$mail = new Zend_Mail();	
				$mailobj->setMsgCode("FeedbackDayReport");
				$template = $this->GetMessageTemplate($mailobj);
				$resServ = new Application_Service_Firm();
				$mapper = new Reservation_Model_ReservationDataMapper();
				if($template){
					try{
						$subject = $template->msg_subject.' '.$fromDate.' - '.$RestaurantName ;
						$body    = $template->msg_body;				
						$body    = $htmlString;
					$receiverslist = $emailresult['feedbackEmails'][$key];
						$userType ="RES";
						$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
						$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
						$priorMapper = new Application_Model_PriorityDataMapper();
						$prior = $priorMapper->GetPriorityByCode('H');
						$msgMapper = new Communication_Model_EmailMessageDataMapper();
						$message = new Communication_Model_EmailMessage();
						$msgPhrase = uniqid ();
						$message->setPhrase($msgPhrase)
								->setTitle($mailobj->getMsgCode())
								->setDescription($body)
								->setPriority($prior->getcode())
								->setEmailtype($emailType->getcode())
								->setUsertype($userType)
								->setSentby('admin@dinedesk.com');
						$msgid = $msgMapper->SaveMessageDetails($message);
						
						if($userType == 'RES'){
							$ResMapper = new Communication_Model_EmailRestRecipentsDataMapper();
							$ResResult = $ResMapper->SaveRestMailDetails($msgid,$stateid="",$cityid="",$userType,$campId="",$receiverslist);
						}
					
						$mail->setFrom($fromaddress, $fromname);
						$mail->setReplyTo($fromaddress,$fromname);
						$mail->addTo( $receiverslist,$RestaurantName);
						$mail->setSubject($subject);
						$mail->setBodyHtml($body);
						$mail->send();
					}catch (Exception $ex){
						$ResidArr[] = $resid;
						Uss_Logger_FileLogger::info($ex->getMessage().$resid);
					}
				}					
// 			}
		}
		/** Day view feedback Acknowledgement  email to admin **/
		if(count($ResidArr) > 0){
			$Ids = implode(',',$ResidArr);
			$idmsg = 'Except for restaurant id '.$Ids;			
		}else{
			$idmsg = '';
		}
		$body = '<html>
				<head>
				</head>
				<body>
				<table>
				<tr>
					<td>
						<img title="DineDesk-logo" alt="DineDesk-logo" src="http://www.dinedesk.com/images/dinedesk-logo.png"/>
					</td>		
				</tr>
				</br>
				<tr>
					<td><h4>Hello Customer Relation Team,</h4></td>
				</tr>
				<tr>
					<td>
					<p>
						The day view feedback report have been sent to all the approved restaurants. '.$idmsg.'
					</p>
					</td>	
				</tr>
				<tr><td>Thanks,<br /><b>DineDesk Helpdesk</b></td></tr>
				</table>
				</body>
				</html>';
		$mailobj = new Communication_Model_Mail(); 
		Zend_Mail::setDefaultTransport( new Zend_Mail_Transport_Postmark('7c73f7f1-c2e6-4bbd-aa4b-fc1dadcb7da8' ));
		$mail = new Zend_Mail();
		$mail->setFrom($fromaddress,$fromname);
		$mail->setReplyTo($fromaddress,$fromname);
		$mail->addTo('support@dinedesk.com','DineDesk Support');
		$mail->setSubject('Day view feedback report information '.$fromDate);
		$mail->setBodyHtml($body);
		$mail->send();
		return true;
	}
	
	public function CheckReservationNotStatus($bokid)
	{
		try{
			$reservServ = new Application_Service_Reservation();
			$bokResult = $reservServ->GetBookingDetailsByPhraseId($bokid);
      //echo '<pre>'; print_r($bokResult); exit;
      $msgStat='';
			if($bokResult->getbokemail() != ''){
				$msgMapper = new Communication_Model_EmailMessageDataMapper();
				$msgStat = $msgMapper->CheckEmailMsgStatusByBokid($bokResult->getbokid());
			}else if($bokResult->getbokphone() != ''){
				$msgMapper = new Communication_Model_SmsMessageMapper();
				$msgStat = $msgMapper->CheckSmsMsgStatusByBokid($bokResult->getbokid());
			}		
			return $msgStat;	
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function CheckReservationNotStatusByBokid($bokid)
	{
		try{
			$reservServ = new Application_Service_Reservation();
			$bokResult = $reservServ->GetBookingDetails($bokid);
      $msgStat='';
			if($bokResult->getbokemail() != ''){
				$msgMapper = new Communication_Model_EmailMessageDataMapper();
				$msgStat = $msgMapper->CheckEmailMsgStatusByBokid($bokResult->getbokid());
			}else if($bokResult->getbokphone() != ''){
				$msgMapper = new Communication_Model_SmsMessageMapper();
				$msgStat = $msgMapper->CheckSmsMsgStatusByBokid($bokResult->getbokid());
			}		
			return $msgStat;	
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	/**
	Send reminderSms
	**/
	public function sendReminderSMS(Communication_Model_Sms $smsobj)
	{
		try
		{
			$template = $this->GetSmstemplate($smsobj);
			if($template){
				$data = $smsobj->getData();
				$mobile	  = str_replace("-","",$data['to']);
				$bokid 	  = $data['bokid'];
				$bokMapper = new Reservation_Model_ReservationDataMapper();
				$resLoc = $bokMapper->getRestaurantLocByBookingId($bokid);
				$restname = $data['RestName'];
				$resdate  = $data['ResDate'];
				$time     = $data['Time'];
				$size     = $data['Size'];
				$name     = $data['CustomerName'];
				$objUs = "";	
				
				//$address  = $data['Address'];
				$body=	$template->msg_body;
				$body    = str_replace("%bokid%",$bokid,$body);
				$body    = str_replace("%ResturantName%",$restname,$body);
				$body    = str_replace("%date%",$resdate,$body);
				$body    = str_replace("%time%",$time,$body);
				$body    = str_replace("%size%",$size,$body);
				$body    = str_replace("%custname%",$name,$body);
				$body    = str_replace("%waittime%",'1',$body);
				$body    = str_replace("%restname%",$restname,$body);
				/* Sms Message Saving Start */
				$msgMapper = new Communication_Model_SmsMessageMapper();
				$priorMapper = new Application_Model_PriorityDataMapper();
				$prior = $priorMapper->GetPriorityByCode('H');
				$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
				$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
				$message = new Communication_Model_SmsMessage();
				$msgPhrase = uniqid ();
				$message->setBokid($bokid)
							->setPhrase($msgPhrase)
							->setDescription($body)
							->setPriority($prior->getcode())
							->setSmstype($emailType->getcode())
							->setSentToUser('RES')
							->setSentTo($name)
							->setSentFromUser('ADMIN')
							->setSentby($restname)
							->setTitle($smsobj->getMsgCode());
				
				$msgid = $msgMapper->SaveMessageDetails($message);
				$countrycode = "";
				if($data['countrycode']){
					$countrycode = $data['countrycode'];
				}else{
					$countrycode = $resLoc->country_dial_code;
				}
				/* Sms Message Saving End */
				$mailStatus = $this->SendMessage($body,$mobile,$resLoc,$countrycode);
				if($data['countrycode'] == '+91'){
					$message->setTransId(substr(strstr($mailStatus, ','),1));
					$msgMapper->UpdateMessageDetails($message);	
				}else if($resLoc->res_companyid == 1){
					$objUs = json_decode($mailStatus,true);
					if($objUs['messages'][0]['status'] == 0){
						$message->setTransId($objUs['messages'][0]['message-id']);
						$msgMapper->UpdateMessageDetails($message);	
					}else{
						$message->setTransId($objUs['messages'][0]['error-text']);
						$msgMapper->UpdateMessageDetails($message);	
					}
				}
				return $mailStatus;
			}
		}
		catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * Send Uss contact form as email
	 */
	public function sendUssContactAsEmail($request)
	{
		try
		{
			$mail = new Zend_Mail();
			$LeaderSendApi  = new LeaderSend_Inc_Leadersend();
			$bokMapper = new Reservation_Model_ReservationDataMapper();
			$data    = $request->getPost();
			$msgCode = 'USSCONTACTFORM';
			$fromaddress = 'admin@dinedesk.com';
			$fromname = 'Unicorn Software Solutions';
			$domain = "dinedesk.com";
			$data = $request->getPost();
			$name 	 		= $data['name'];
			$company		= $data['company'];
			$city			= $data['city'];
			$country		= $data['country'];
			$phone			= $data['phone'];
			$email 			= $data['email'];	
			$message 		= $data['message'];
			$subject 		= "Unicorn Software Solutions Enquiry Request";
			$body = '<table width="100%" cellpadding="0" cellspacing="0" border="0" bgcolor="#f4f2f1">
					<tbody>
						<tr>     
							<td align="center">
								<table cellpadding="0" cellspacing="0" border="0" width="552">
									<tbody>
										<tr>
										<td align="center" width="552">
										   <table cellpadding="0" cellspacing="0" border="0">
											<tbody>
												<tr>
													<td><img src="http://unicornsoftwaresolutions.com/img/logo.png" border="0"></td>
												</tr>
												<tr>
												 <td bgcolor="#ffffff" style="font-size:0;line-height:0" width="552" height="17"></td>
												</tr>
												<tr>
												 <td bgcolor="#ffffff">
												  <table cellpadding="0" cellspacing="0" border="0" width="100%">
												   <tbody>
												   <tr>
												   <td width="2%"></td>
													<td align="left">
														<table cellpadding="0" cellspacing="0" border="0" width="450">
														 <tbody>
														  <tr>
														   <td colspan="2" style="font-family:Helvetica,Arial,sans-serif;font-size:18px;line-height:120%;font-weight:bold;color:#4c443f;padding-top:40px;padding-bottom:20px">Unicorn Software Solutions Enquiry</td>
														  </tr>
														  <tr>
														   <td style="font-family:Helvetica,Arial,sans-serif;font-size:16px;line-height:120%;font-weight:bold;color:#4c443f;padding-top:10px;padding-bottom:20px">Name</td><td style="font-family:Helvetica,Arial,sans-serif;font-size:16px;line-height:120%;font-weight:bold;color:#4c443f;padding-top:10px;padding-bottom:20px"> %name%</td>
														   </tr>
														   <tr>
														   <td style="font-family:Helvetica,Arial,sans-serif;font-size:16px;line-height:120%;font-weight:bold;color:#4c443f;padding-top:10px;padding-bottom:20px">Company</td><td style="font-family:Helvetica,Arial,sans-serif;font-size:16px;line-height:120%;font-weight:bold;color:#4c443f;padding-top:10px;padding-bottom:20px"> %company%</td>
														   </tr>
														   <tr>
														   <td style="font-family:Helvetica,Arial,sans-serif;font-size:16px;line-height:120%;font-weight:bold;color:#4c443f;padding-top:10px;padding-bottom:20px">Email</td><td style="font-family:Helvetica,Arial,sans-serif;font-size:16px;line-height:120%;font-weight:bold;color:#4c443f;padding-top:10px;padding-bottom:20px"> %email%</td></tr>
														   <tr>
														   <td style="font-family:Helvetica,Arial,sans-serif;font-size:16px;line-height:120%;font-weight:bold;color:#4c443f;padding-top:10px;padding-bottom:20px">Phone</td><td style="font-family:Helvetica,Arial,sans-serif;font-size:16px;line-height:120%;font-weight:bold;color:#4c443f;padding-top:10px;padding-bottom:20px"> %phone%</td></tr>
														   <tr>
														   <td style="font-family:Helvetica,Arial,sans-serif;font-size:16px;line-height:120%;font-weight:bold;color:#4c443f;padding-top:10px;padding-bottom:20px">City</td><td style="font-family:Helvetica,Arial,sans-serif;font-size:16px;line-height:120%;font-weight:bold;color:#4c443f;padding-top:10px;padding-bottom:20px"> %city%</td></tr>
														   <tr>
														   <td style="font-family:Helvetica,Arial,sans-serif;font-size:16px;line-height:120%;font-weight:bold;color:#4c443f;padding-top:10px;padding-bottom:20px">Country</td><td style="font-family:Helvetica,Arial,sans-serif;font-size:16px;line-height:120%;font-weight:bold;color:#4c443f;padding-top:10px;padding-bottom:20px"> %country%</td></tr>
														   <tr>
														   <td style="font-family:Helvetica,Arial,sans-serif;font-size:16px;line-height:120%;font-weight:bold;color:#4c443f;padding-top:10px;padding-bottom:20px">Message</td><td style="font-family:Helvetica,Arial,sans-serif;font-size:16px;line-height:120%;font-weight:bold;color:#4c443f;padding-top:10px;padding-bottom:20px"> %message%</td>
														  </tr>
														 </tbody>
														</table>
													   </td>
													    <td width="2%"></td>
													  </tr>
													 </tbody>
													</table>
												  </td>
												 </tr>
												</tbody>
												</table>
											</td>
										</tr>
									</tbody>
								</table>
							</td>
						</tr>
					</tbody>
				</table>';									
			$body 	 		= str_replace("%name%",$name,$body);
			$body 	 		= str_replace("%company%",$company,$body);
			$body 	 		= str_replace("%country%",$country,$body);
			$body 	 		= str_replace("%city%",$city,$body);
			$body 	 		= str_replace("%message%",$message,$body);
			$body 	 		= str_replace("%phone%",$phone,$body);
			$body 	 		= str_replace("%email%",$email,$body);
			$request = array(
						'subject' => $subject ,
						'from'    => array( // required. A sender’s information
											'name'  => $fromname,
											'email' => $fromaddress
									),
						'signing_domain'=>$domain,
						'to' => array(
									array(
										'name' => "Dinedesk",
										'email' => 'info@unicornsoftwaresolutions.com'),
									array(
										'name' => "Dinedesk",
										'email' => 'ahmed@dinedesk.com')
								),
						'html'       => $body, // email's HTML content
						'auto_plain' => true // automatically generate a text part for the messages of HTML part
					);
			$retval = $LeaderSendApi->messagesSend($request);
			if($LeaderSendApi->errorMessage){
				$mail->setFrom($fromaddress, $fromname);
			    $mail->setReplyTo($fromaddress,$fromname);
			    $mail->addTo( $receiverslist,$name);
			    $mail->setSubject($subject);
			    $mail->setBodyHtml($body);
			    $mail->send();
			}
						
		}
		catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}


	/**
	 * SEND FEEDBACK SMS
	 *
	 */
	public function sendFeedBackSMS($body,$numbers)
	{
		 
		try{
				if(count($numbers)>0)
				{
					foreach ($numbers as $key => $receipientno) {
					$receipientno = $receipientno;
					$this->sendMessagCMTelecom($receipientno,$body);
					}
				}
				return true;
			
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			return true;
		}
	
	}

	/**
	 * Send Radiant contact form as email
	 */
	public function sendRadiantContactAsEmail($request)
	{
		try
		{
			$mail = new Zend_Mail();
			$LeaderSendApi  = new LeaderSend_Inc_Leadersend();
			$bokMapper = new Reservation_Model_ReservationDataMapper();
			$data    = $request->getPost();
			$msgCode = 'USSCONTACTFORM';
			$fromaddress = 'admin@dinedesk.com';
			$fromname = 'Unicorn Software Solutions';
			$domain = "dinedesk.com";
			$data = $request->getPost();
			$name 	 		= $data['name'];
			$company		= $data['company'];
			$city			= $data['city'];
			$country		= $data['country'];
			$phone			= $data['phone'];
			$email 			= $data['email'];	
			$message 		= $data['message'];
			$subject 		= "Radiant Solutions Enquiry Request";
			$body = '<table width="100%" cellpadding="0" cellspacing="0" border="0" bgcolor="#f4f2f1">
					<tbody>
						<tr>     
							<td align="center">
								<table cellpadding="0" cellspacing="0" border="0" width="552">
									<tbody>
										<tr>
										<td align="center" width="552">
										   <table cellpadding="0" cellspacing="0" border="0">
											<tbody>
												<tr>
													<td><img src="http://radiantsols.com/img/logo.png" border="0"></td>
												</tr>
												<tr>
												 <td bgcolor="#ffffff" style="font-size:0;line-height:0" width="552" height="17"></td>
												</tr>
												<tr>
												 <td bgcolor="#ffffff">
												  <table cellpadding="0" cellspacing="0" border="0" width="100%">
												   <tbody>
												   <tr>
												   <td width="2%"></td>
													<td align="left">
														<table cellpadding="0" cellspacing="0" border="0" width="450">
														 <tbody>
														  <tr>
														   <td colspan="2" style="font-family:Helvetica,Arial,sans-serif;font-size:18px;line-height:120%;font-weight:bold;color:#4c443f;padding-top:40px;padding-bottom:20px">Radiant Sols Enquiry</td>
														  </tr>
														  <tr>
														   <td style="font-family:Helvetica,Arial,sans-serif;font-size:16px;line-height:120%;font-weight:bold;color:#4c443f;padding-top:10px;padding-bottom:20px">Name</td><td style="font-family:Helvetica,Arial,sans-serif;font-size:16px;line-height:120%;font-weight:bold;color:#4c443f;padding-top:10px;padding-bottom:20px"> %name%</td>
														   </tr>
														   <tr>
														   <td style="font-family:Helvetica,Arial,sans-serif;font-size:16px;line-height:120%;font-weight:bold;color:#4c443f;padding-top:10px;padding-bottom:20px">Company</td><td style="font-family:Helvetica,Arial,sans-serif;font-size:16px;line-height:120%;font-weight:bold;color:#4c443f;padding-top:10px;padding-bottom:20px"> %company%</td>
														   </tr>
														   <tr>
														   <td style="font-family:Helvetica,Arial,sans-serif;font-size:16px;line-height:120%;font-weight:bold;color:#4c443f;padding-top:10px;padding-bottom:20px">Email</td><td style="font-family:Helvetica,Arial,sans-serif;font-size:16px;line-height:120%;font-weight:bold;color:#4c443f;padding-top:10px;padding-bottom:20px"> %email%</td></tr>
														   <tr>
														   <td style="font-family:Helvetica,Arial,sans-serif;font-size:16px;line-height:120%;font-weight:bold;color:#4c443f;padding-top:10px;padding-bottom:20px">Phone</td><td style="font-family:Helvetica,Arial,sans-serif;font-size:16px;line-height:120%;font-weight:bold;color:#4c443f;padding-top:10px;padding-bottom:20px"> %phone%</td></tr>
														   <tr>
														   <td style="font-family:Helvetica,Arial,sans-serif;font-size:16px;line-height:120%;font-weight:bold;color:#4c443f;padding-top:10px;padding-bottom:20px">City</td><td style="font-family:Helvetica,Arial,sans-serif;font-size:16px;line-height:120%;font-weight:bold;color:#4c443f;padding-top:10px;padding-bottom:20px"> %city%</td></tr>
														   <tr>
														   <td style="font-family:Helvetica,Arial,sans-serif;font-size:16px;line-height:120%;font-weight:bold;color:#4c443f;padding-top:10px;padding-bottom:20px">Country</td><td style="font-family:Helvetica,Arial,sans-serif;font-size:16px;line-height:120%;font-weight:bold;color:#4c443f;padding-top:10px;padding-bottom:20px"> %country%</td></tr>
														   <tr>
														   <td style="font-family:Helvetica,Arial,sans-serif;font-size:16px;line-height:120%;font-weight:bold;color:#4c443f;padding-top:10px;padding-bottom:20px">Message</td><td style="font-family:Helvetica,Arial,sans-serif;font-size:16px;line-height:120%;font-weight:bold;color:#4c443f;padding-top:10px;padding-bottom:20px"> %message%</td>
														  </tr>
														 </tbody>
														</table>
													   </td>
													    <td width="2%"></td>
													  </tr>
													 </tbody>
													</table>
												  </td>
												 </tr>
												</tbody>
												</table>
											</td>
										</tr>
									</tbody>
								</table>
							</td>
						</tr>
					</tbody>
				</table>';									
			$body 	 		= str_replace("%name%",$name,$body);
			$body 	 		= str_replace("%company%",$company,$body);
			$body 	 		= str_replace("%country%",$country,$body);
			$body 	 		= str_replace("%city%",$city,$body);
			$body 	 		= str_replace("%message%",$message,$body);
			$body 	 		= str_replace("%phone%",$phone,$body);
			$body 	 		= str_replace("%email%",$email,$body);
			$request = array(
						'subject' => $subject ,
						'from'    => array( // required. A sender’s information
											'name'  => $fromname,
											'email' => $fromaddress
									),
						'signing_domain'=>$domain,
						'to' => array(
									array(
										'name' => "Dinedesk",
										'email' => 'info@radiantsols.com'),
									array(
										'name' => "Dinedesk",
										'email' => 'azmath@dinedesk.com')
								),
						'html'       => $body, // email's HTML content
						'auto_plain' => true // automatically generate a text part for the messages of HTML part
					);
			$retval = $LeaderSendApi->messagesSend($request);
			if($LeaderSendApi->errorMessage){
				$mail->setFrom($fromaddress, $fromname);
			    $mail->setReplyTo($fromaddress,$fromname);
			    $mail->addTo( $receiverslist,$name);
			    $mail->setSubject($subject);
			    $mail->setBodyHtml($body);
			    $mail->send();
			}
						
		}
		catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
}
