<?php
class Application_Service_Payment
{
	protected $_form = array();
	
	public function setSearchTransactionForm(Zend_Form $form)
	{
		$this->_form['SearchTransaction'] = $form;
	}	
	
	public function getSearchTransactionForm(){
		if(empty($this->_form['SearchTransaction'])){
			$searchTransaction = new Payments_Form_SearchTransaction();
			$this->setSearchTransactionForm($searchTransaction);
		}
		return $this->_form['SearchTransaction'];
	}
	
	public function setPaymentTermsForm(Zend_Form $form)
	{
		$this->_form['PaymentTerms'] = $form;
	}
	
	public function getPaymentTermsForm()
	{
		if(empty($this->_form['PaymentTerms'])){
			$paymentTermsFrom = new Payments_Form_PaymentTerms();
			$this->setPaymentTermsForm($paymentTermsFrom);
		}
		return $this->_form['PaymentTerms'];
	}
	
	public function setSearchPaymentProfileForm(Zend_Form $form)
	{
		$this->_form['SearchPaymentProfile'] = $form;
	}	
	
	public function getSearchPaymentProfileForm()
	{
		if(empty($this->_form['SearchPaymentProfile'])){
			$searchPymtPrfile = new Payments_Form_SearchPaymentProfile();
			$this->setSearchPaymentProfileForm($searchPymtPrfile);
		}
		return $this->_form['SearchPaymentProfile'];
	}
	
	public function setManageInvoiceForm(Zend_Form $form)
	{
		$this->_form['ManageInvoice'] = $form;
	}	
	
	public function getManageInvoiceForm()
	{
		if(empty($this->_form['ManageInvoice'])){
			$manageInvoice = new Payments_Form_ManageInvoice();
			$this->setManageInvoiceForm($manageInvoice);
		}
		return $this->_form['ManageInvoice'];
	}
	
	public function setManagePaymentSettingsForm(Zend_Form $form)
	{
		$this->_form['ManagePaymentSettings'] = $form;
	}	
	
	public function getManagePaymentSettingsForm()
	{
		if(empty($this->_form['ManagePaymentSettings'])){
			$ManagePaymentSettings = new Payments_Form_ManagePaymentSettings();
			$this->setManagePaymentSettingsForm($ManagePaymentSettings);
		}
		return $this->_form['ManagePaymentSettings'];
	}
	
	public function setEditPaymentSettingsForm(Zend_Form $form)
	{
		$this->_form['EditPaymentSettings'] = $form;
	}	
	
	public function getEditPaymentSettingsForm()
	{
		if(empty($this->_form['EditPaymentSettings'])){
			$EditPaymentSettings = new Payments_Form_EditPaymentSettings();
			$this->setEditPaymentSettingsForm($EditPaymentSettings);
		}
		return $this->_form['EditPaymentSettings'];
	}
	
	public function Manage_Rest_AuthNet_Subscription($request)
	{
		try{
			$mapper  	   = new Payments_Model_AuthnetCustomerProfileMapper();
			$paymentMapper = new Payments_Model_AuthnetPaymentProfileMapper();
			$authHelperObj = new Uss_Helper_AuthNetHelper();
			
			$storage = new Zend_Auth_Storage_Session();
		    $data 	 = $storage->read();
		    
		    $authNet_Cust_ProfId = "";
		    $ancpid				 = "";
		    $result 		   = array();
		    $userId 			 = '';
		    $fName				 = '';
		    $lName				 = '';
		    $email				 = '';
		    if($data['Usertype'] == "ADM" || $data['Usertype'] == "ADU"){
		    	$resServ = new Application_Service_Restaurant();
		    	$userDetails = $resServ->CheckRestaurantOwnerStatusByAdmin($data);
		    	$userId = $userDetails->getRestUser();
			    $fName = $userDetails->getOwnerFirstName();
			    $lName = $userDetails->getOwnerLastName();
			    $email = $userDetails->getOwnerEmail();
		    }else{
		    	$userId = $data['User_Id'];
			    $fName = $data['Firstname'];
			    $lName = $data['LastName'];
			    $email = $data['Email'];
		    }
		    
		    /* Check Whether Rest Owner has Authorized.Net Customer Profile */	    
		    $getAuthNetCustProfObj = new Payments_Model_GetAuthNetCustProfId();
		    $getAuthNetCustProfObj->setancpuser_id($userId);
		    
		    $profileStatusMapper = new Application_Model_ProfileStatusDataMapper();
			$prfActStatusObj = $profileStatusMapper->getProfileStatusByCode('ACT');
			$prfInaStatusObj = $profileStatusMapper->getProfileStatusByCode('INA');
		    
      $row = $mapper->GetAuthNetCustProfIdByUserId($getAuthNetCustProfObj);
			
		    if($row){
		    	$ancpid				 = $row->ancpid;
		    	$authNet_Cust_ProfId = $row->ProfileId;	
		    }
		    /* If no Profiles are found create a new Authorized.Net Customer profile */
		    if(!$authNet_Cust_ProfId){
				/* Create Auth Net Customer Profile */
	
				  $custProfObj = new Payments_Model_AuthnetCustomerProfile();
				  $custProfObj->setancpuser_id($userId)
	                     ->setancpprofile_description($fName." ".$lName)
	                     ->setancpemail($email);
	
	         
				  $authNet_Cust_ProfId = $authHelperObj->CreateCustomerProfileRequest($custProfObj);
				  if($authNet_Cust_ProfId){
  					/* Save Authorized.Net Customer Profile */
  
  					date_default_timezone_set('EST5EDT'); 
  					$date = date('Y-m-d');
  					$time = date('h:i:s');
  			 	
  					$custProfObj->setancpcustomer_profile_id($authNet_Cust_ProfId);
  					$custProfObj->setancpcreated_date($date);
  					$custProfObj->setancpcreated_time($time);
  					$custProfObj->setancpstatus($prfActStatusObj->getId());
  					$ancpid = $mapper->SaveAuthNetCusomerProfile($custProfObj);	     	
				  }	      	
		    }
			$result['CustProfId'] = $authNet_Cust_ProfId;
			
			/* Check The Customer has payment profiles created */
			
			$paymentProfObj = new Payments_Model_GetAuthNetPaymentProfId();
			$paymentProfObj->setancpcustomer_profile_id($authNet_Cust_ProfId)
						   ->setancpstatus($prfActStatusObj->getId())
						   ->setanppstatus($prfActStatusObj->getId());
		   	 
			$resultSet = $paymentMapper->GetAuthNetPaymentProfIdByCustProfId($paymentProfObj);
			
			$custProfReq = array();
			$paymentProfileId = array();
			$paymentProfileType = array();
			$custProfReq = $authHelperObj->GetCustomerProfileRequest($authNet_Cust_ProfId);
			
			foreach($custProfReq as $key => $value){
				$paymentProfileId[] = $key;
				$paymentProfileType[$key] = $value['paymentType'];
			}
			
			$paymentIdObj = new Payments_Model_AuthnetPaymentProfile();
			date_default_timezone_set('EST5EDT');
		 	$date = date('Y-m-d');
		 	$time = date('h:i:s');
			$paymentIdObj->setanppcustomer_profile_id($ancpid);
			$paymentIdObj->setanppcreated_date($date);
			$paymentIdObj->setanppcreated_time($time);
			$paymentIdObj->setanpppayment_type($paymentProfileType);
			$paymentIdObj->setanppstatus($prfActStatusObj->getId());
			
			if(!count($resultSet) > 0){
				//echo '<pre>'; print_r($custProfReq); exit;
				if(count($paymentProfileId) > 0){/* Save Payment Profile Id's*/
					
					$paymentIdObj->setanpppayment_profile_id($paymentProfileId);	
					$status = $paymentMapper->SavePaymentProfiles($paymentIdObj);					
					if($status){
						$resultSet = $paymentMapper->GetAuthNetPaymentProfIdByCustProfId($paymentProfObj);
					}
				}			
			}else if(count($resultSet) > 0 && count($paymentProfileId) > 0){
				
				/*Check Whether id's are new payment profile id's*/				
				$profileIdArray		   = array();
				$ureservSavedProfIdArr = array();
						
				
				foreach($resultSet as $results){
					$ureservSavedProfIdArr[] = $results->anpppayment_profile_id; 
				}				
				
				$profileIdArray['ureservSavedProfId'] = $ureservSavedProfIdArr;
				$profileIdArray['authNetProfId'] 	  = $paymentProfileId;
				$comparedArrs = array();				
				$comparedArrs = $this->ComparePaymentProfileIds($profileIdArray);

				if(count($comparedArrs) > 0 && count($comparedArrs['authNetNewProfId']) > 0){
					$paymentIdObj->setanpppayment_profile_id($comparedArrs['authNetNewProfId']);	
					$status = $paymentMapper->SavePaymentProfiles($paymentIdObj);					
					if($status){
						$resultSet = $paymentMapper->GetAuthNetPaymentProfIdByCustProfId($paymentProfObj);
					}
				}
				
				if(count($comparedArrs) > 0 && count($comparedArrs['authNetDeletedProfId']) > 0){
					$deletepaymentProfObj = new Payments_Model_DeletePaymentProfile();
					$deletepaymentProfObj->setPayemntProfId($comparedArrs['authNetDeletedProfId']);
					$deletepaymentProfObj->setStatus($prfInaStatusObj->getId());					
					$paymentMapper->DeletePaymentProfiles($deletepaymentProfObj);
					$resultSet = $paymentMapper->GetAuthNetPaymentProfIdByCustProfId($paymentProfObj);					
				}			
				
			}else if(count($resultSet) > 0 && count($paymentProfileId) == 0){
				
				$profileIdArray		   = array();
				$ureservSavedProfIdArr = array();
						
				
				foreach($resultSet as $results){
					$ureservSavedProfIdArr[] = $results->anpppayment_profile_id; 
				}				
				
				$profileIdArray['ureservSavedProfId'] = $ureservSavedProfIdArr;
				$profileIdArray['authNetProfId'] 	  = $paymentProfileId;
				$comparedArrs = array();				
				$comparedArrs = $this->ComparePaymentProfileIds($profileIdArray);
					
				$deletepaymentProfObj = new Payments_Model_DeletePaymentProfile();
				$deletepaymentProfObj->setPayemntProfId($comparedArrs['authNetDeletedProfId']);
				$deletepaymentProfObj->setStatus($prfInaStatusObj->getId());				
				$paymentMapper->DeletePaymentProfiles($deletepaymentProfObj);
				$resultSet = $paymentMapper->GetAuthNetPaymentProfIdByCustProfId($paymentProfObj);
			}
			
			$result['PaymentProfiles'] = $resultSet;
			$result['CC_AC_Details']   = $custProfReq;
				
		    return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage());
		} 
	}

	public function Get_AuthNet_HostedProfPage_Token($request)
	{
		try{
			if($request->customerProfileId){
				$authHelperObj = new Uss_Helper_AuthNetHelper();
				$communicatorUrl = '';  // This is hardcoded. Need to update in future.
				$token = $authHelperObj->getHostedProfilePageRequest($request->customerProfileId, $communicatorUrl);
				return $token;
			}
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}	
	}

	public function Add_PaymentProfile_And_SubscriptionPlan_ToRestaurant($request)
	{	
		try{
			$profileStatusMapper = new Application_Model_ProfileStatusDataMapper();
			$prfActStatusObj = $profileStatusMapper->getProfileStatusByCode('ACT');
			$restPaymentPlanStatusMapper = new Application_Model_RestPaymentPlanStatusDataMapper();
			$rppmActStatusObj = $restPaymentPlanStatusMapper->getRestPaymentPlanStatusByCode('ACT');
			
			$restPaymentMapMapper = new Payments_Model_RestAuthnetPaymentProfileMapMapper();
		
			$restPaymentMapObj = new Payments_Model_RestAuthnetPaymentProfileMap();
			$restPaymentMapObj->setrappmrestaurant_id($request->restaurantid)
							  ->setrappmpayment_profile_id($request->paymentprofid)
							  ->setrappmstatus($prfActStatusObj->getId());
			
			$resServ = new Application_Service_Restaurant();
			$timeZone = $resServ->GetRestaurantTimeZone($request->restaurantid);
			date_default_timezone_set($timeZone);				  
			$activationDate = date('Y-m-d');
			$activationTime = date('h:i:s');
			
			$restPlanObj = new Payments_Model_RestaurantPaymentPlanMap();
			$restPlanObj->setrppmpayment_plan_id($request->planid) 
						->setrppmrestaurant_id($request->restaurantid)
						->setrppmplan_activation_date($activationDate)
						->setrppmplan_activation_time($activationTime)
						->setrppmstatus($rppmActStatusObj->getId());
							  
			$status = $restPaymentMapMapper->SavePaymentProfileAndSubscriptionPlanOfRestaurant($restPaymentMapObj, $restPlanObj);

			//$tranByRestIdObj = new Payments_Model_SubscribtionTransactionByRestId();
			//$tranByRestIdObj->setRestId($request->restaurentid);
			//$this->RestSubscribtionTransaction($tranByRestIdObj);
			
			return $status;
	
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}			
	}	
	
	public function ComparePaymentProfileIds($profileIdArray)
	{
		try{
			
			$ureservSavedProfIdArr 	  = array();
			$authNetProfIdArr	   	  = array();
			$authNetNewProfIdArr	  = array();
			$authNetDeletedProfIdArr  = array();		
			
			$ureservSavedProfIdArr = $profileIdArray['ureservSavedProfId'];
			$authNetProfIdArr	   = $profileIdArray['authNetProfId'];
			
			/* Compare arrays to get new payment profile id's */		
			$authNetNewProfIdArr = array_diff($authNetProfIdArr,$ureservSavedProfIdArr);
			
			/* Compare arrays to get deleted payment profile id's */
			
			$authNetDeletedProfIdArr = array_diff($ureservSavedProfIdArr,$authNetProfIdArr);
			
			$result = array();
			$result['authNetNewProfId']     = $authNetNewProfIdArr;
			$result['authNetDeletedProfId'] = $authNetDeletedProfIdArr;
				
			return $result;						
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}	
	}
	
	public function RestSubscribtionTransaction(array $data)
	{
		try{
			$result = array();			
			$form = $this->getPaymentTermsForm();
			if($form->isValid($data)){
				$customerProfileId = "";
				$paymentProfileId  = "";
				$anppid			   = "";
				$invoiceid 		   = "";
				$invoiceObj		   = "";
					
				$restid    = $data['restaurantid'];			
				$invoiceid = $data['invoiceid'];
				
				if($invoiceid){
					$invDetailsByIdObject = new Payments_Model_GetInvoiceDetailsById();
					$invDetailsByIdObject->setInvoiceId($invoiceid)
										 ->setInvoiceStatus(2);
				 	$invMapperObject = new Payments_Model_InvoiceMapper();
				 	$row = $invMapperObject->RetrieveInvoiceById($invDetailsByIdObject);
					
				 	if($row){
				 		$totalAmount 	 = "";
				 		$serviceTaxTotal = "";
				 		
				 		$totalAmount = round(($row->invamount + (($row->invtxncharges * $row->invamount)/100) + (($row->invservice_tax * $row->invamount)/100)),2);
				 		$serviceTaxTotal = round(($row->invamount + (($row->invservice_tax * $row->invamount)/100)),2);
				 		
				 		$invoiceObj = new Payments_Model_Invoice();
				 		$invoiceObj->setinvid($row->invid)
				 				   ->setinvrestaurant_id($row->invrestaurant_id)
				 				   ->setinvdescription($row->invdescription)				 		
				 				   ->setinvbilling_fromdate($row->invbilling_fromdate)
				 				   ->setinvbilling_todate($row->invbilling_todate)
				 				   ->setinvamount($row->invamount)
				 				   ->setinvtotamount($totalAmount)
				 				   ->setinvstatus($row->invstatus)
				 				   ->setinvgenerated_date($row->invgenerated_date)
				 				   ->setinvgenerated_time($row->invgenerated_time)
				 				   ->setinvcreated_by($row->invcreated_by)
				 				   ->setinvservice_tax($row->invservice_tax)
				 				   ->setinvtxncharges($row->invtxncharges);
				 	}
					 	
				}else{
					$createInvoiceObj = new Payments_Model_CreateInvoiceByRestId();
					$createInvoiceObj->setRestId($restid);			
					$invoiceObj = $this->GenerateInvoice($createInvoiceObj);	
				}
				
				
				$profileStatusMapper = new Application_Model_ProfileStatusDataMapper();
				$prfActStatusObj = $profileStatusMapper->getProfileStatusByCode('ACT');
				$restPaymentPlanStatusMapper = new Application_Model_RestPaymentPlanStatusDataMapper();
				$rppmActStatusObj = $restPaymentPlanStatusMapper->getRestPaymentPlanStatusByCode('ACT');
				$txnTypeMapper = new Application_Model_TransactionTypeDataMapper();
				$debitTxn = $txnTypeMapper->getTransactionTypeByCode('DR');
				$txnStatusMapper = new Application_Model_TransactionStatusDataMapper();
				$successfulTxn = $txnStatusMapper->getTransactionStatusByCode('I00001');
				$subplanStatusMapper = new Application_Model_SubscriptionPlanStatusDataMapper();
				$subPlanStatus = $subplanStatusMapper->GetSubscriptionStatusByCode(array('ACT'));
				$actSubPlanStatus = $subPlanStatus['ACT'];
				$invoiceStatusMapper = new Application_Model_InvoiceStatusDataMapper();
				$paidinvStatus = $invoiceStatusMapper->getInvoiceStatusByCode('PD');
				
				/* Reterieve Customer and Payment profile Id's */
				
				$profileByRestIdObj = new Payments_Model_GetPaymentProfileByRestId();
				$profileByRestIdObj->setrappmrestaurant_id($restid)
								   ->setrappmstatus($prfActStatusObj->getId())
								   ->setanppstatus($prfActStatusObj->getId())
								   ->setancpstatus($prfActStatusObj->getId());
			   	
				$authNetProfMapper = new Payments_Model_AuthnetPaymentProfileMapper();
				$rowSet = $authNetProfMapper->GetPaymentProfileByRestId($profileByRestIdObj);
				
				foreach($rowSet as $row){
					$anppid			   = $row->anppid;
					$customerProfileId = $row->ancpcustomer_profile_id;
					$paymentProfileId  = $row->anpppayment_profile_id;
					
				}
				/* Initiate Transaction */
				if($invoiceObj && $invoiceObj instanceof Payments_Model_Invoice)
				{
					$authCapTransObj = new Payments_Model_AuthCaptureTransaction();
					$authCapTransObj->setCustProfId($customerProfileId)
									->setCustPaymentProfId($paymentProfileId)
									->setAmount($invoiceObj->getinvtotamount())
									->setInvoice($invoiceObj->getinvid())
									->setRecurringBilling(false);
					$authNetHelperObj = new Uss_Helper_AuthNetHelper();
					$response = $authNetHelperObj->CreateAuthCaptureTransaction($authCapTransObj);
					
					if($response['transcode'] == 'I00001'){
						
						$objectArray = array();
						
						$resServ = new Application_Service_Restaurant();
						$timeZone = $resServ->GetRestaurantTimeZone($restid);
						date_default_timezone_set($timeZone);
		 				$currentDate = date('Y-m-d');
		 				$currentTime = date('h:i');
		 				
		 				/* Prepare Transaction details object. */
		 				
						$transactionObject = new Payments_Model_Transactions();
						$transactionObject->settxnfk_restaurant($restid)
										  ->settxntransaction_id($response['transid'])
										  ->settxninvoice_number($invoiceObj->getinvid())
										  ->settxnpayment_profile_id($anppid)
										  ->settxntransaction_amount($invoiceObj->getinvtotamount())
										  ->settxntransaction_date($currentDate)
										  ->settxntransaction_time($currentTime)
										  ->settxndescription($invoiceObj->getinvdescription())
										  ->settxntransaction_type($debitTxn->getId())
										  ->settxnstatus($successfulTxn->getId());
										  
						$objectArray['txnObject'] = $transactionObject; 

						/* Reterive Plan Detiails */
						$planDetailsObj = new Payments_Model_SubscriptionPlanDetailsByRestId();
						$planDetailsObj->setrppmrestaurant_id($restid);
						$planDetailsObj->setspplan_status($actSubPlanStatus->getId());
						$planDetailsObj->setrppmstatus($rppmActStatusObj->getId());
						$planMapperObj = new Payments_Model_SubscriptionPlansMapper();
			
					    $rowSet = $planMapperObj->GetSubscriptionPlanDetailsByRestId($planDetailsObj);
					   
					    
					   $planId       = "";
					   $planDuration = "";
					   $subscriptionAmount = "";
					   
					   foreach($rowSet as $row){
					   	 $planId	         = $row->spid;
					   	 $planDuration       = $row->spplan_duration;
					   	 $subscriptionAmount = $row->spamount;
					   }
	
						/* Prepare Subscription Paid details object  */
						
						$subscriptionPaidObject = new Payments_Model_SubscriptionPaid();
						$subscriptionPaidObject->setsubprestaurant_id($restid)										   
											   ->setsubpbilling_date($currentDate)
											   ->setsubpamount($invoiceObj->getinvamount())
											   ->setsubpplan_id($planId)
											   ->setsubpbilling_fromdate($invoiceObj->getinvbilling_fromdate())
											   ->setsubpbilling_todate($invoiceObj->getinvbilling_todate())
											   ->setsubp_status($actSubPlanStatus->getId());
											   
						$objectArray['subPaidObj'] = $subscriptionPaidObject; 										   
											   
					   /* Prepare Subscription Renewal details object */ 										   
					   /* Calculate next billing date and amount */
	                   
					   
					   
				      /* $daysObject = new Payments_Model_CalculateDays();
				       $daysObject->setRestId($restid)
			 		     		  ->setPlanDuration($planDuration)
			 		    		  ->setFromDate($invoiceObj->getinvbilling_todate())
			 		   	 		  ->setAmount($subscriptionAmount);
	 	     
			 	 	   $result = array();			 		    						  
			 	 	   $result = $this->CalculateInvoiceAndAmount($daysObject);	
						*/
						
			 	 	   $billTodate   = trim($invoiceObj->getinvbilling_todate());
			 	 	   $explodedDate = explode('-',$billTodate);
			 	 	   
			 	 	   $Year  = $explodedDate[0];
			 	 	   $Month = $explodedDate[1];
			 	 	     
			 	 	   $newRenewalFromDate = "";
			 	 	   $newRenewalToDate   = "";			 	 	   	   
			 	 	   
			 	 	   $newRenewalFromDate = date('Y-m-d',mktime(0,0,0,$Month,15,$Year));
			 	 	   $newRenewalToDate   = date('Y-m-d',mktime(0,0,0,$Month + $planDuration,14,$Year));
			 	 	   
					   $subscriptionRenewalObject = new Payments_Model_SubscriptionRenewal();
					   $renewStatus = $txnStatusMapper->getTransactionStatusByCode('RNW');
					   $subscriptionRenewalObject->setsrrestaurant_id($restid)	
					   							 ->setsrbilling_date($newRenewalFromDate)
					   							 ->setsramount($subscriptionAmount)
					   							 ->setsrplan_id($planId)
					   							 ->setsrbilling_fromdate($newRenewalFromDate)
					   							 ->setsrbilling_todate($newRenewalToDate)
					   							 ->setsrstatus($renewStatus->getId());
	
					 $objectArray['subRenewalObj'] = $subscriptionRenewalObject; 
	
					  /* Prepare Update Invoice object */
					  
					 $updateInvoiceStatusByIdObject  = new Payments_Model_UpdateInvoiceStatusById();
					 $updateInvoiceStatusByIdObject->setinvid($invoiceObj->getinvid())
					 							   ->setinvrestaurant_id($restid)
					 							   ->setinvstatus($paidinvStatus->getId());
	
					 $objectArray['updateInveStatusObj'] = $updateInvoiceStatusByIdObject; 				 				 							   
					  
	   				 $transMapperObject = new Payments_Model_TransactionsMapper();
	   				 $status = $transMapperObject->saveTransactionDetails($objectArray);
	
	   				 /* Generate Invoice Pdf */
	   				 
	   				 $invoiceObj->setcustprofid($customerProfileId);
	   				 $invoiceObj->setpaymentprofid($paymentProfileId);
	   				 
	   				 $pdfStatus = $this->GenerateInvoicePdf($invoiceObj);
	   				 
					if($status){
	   				 	$storage = new Zend_Auth_Storage_Session();
						$user = $storage->read();
						$resservice = new Application_Service_Restaurant();
						$restaurantName = $resservice->GetRestaurantNamesById($restid);
	
						$mailmapper = new Application_Service_Notification();
						$mailObj = new Notification_Model_Mail();
						$mailObj->setMsgCode('Restaurant_Creation_Conf');
						$name = $user['Firstname'].' '.$user['LastName'];
						$maildata = array('UserName' => $name,
								  'SenTo'    => $user['Email'],
								  'resname'	 => $restaurantName['restName']);
						$mailObj->setData($maildata);
						$mailStatus = $mailmapper->SendMail($mailObj);
						
						$InNumber = $invoiceObj->getinvid();
						$mailObj = new Notification_Model_Mail();
						$subject = 'Invoice-'.$InNumber.', Date:'.$currentDate;
						$path = 'managerest/'.$restid.'/invoice/'.$invoiceObj->getinvid().'.pdf';
					    $mailObj->setMsgCode('Invoice');
						$maildata = array('UserName' => $name,
								  'subject'  =>	$subject,
								  'path'	 =>	$path,
								  'SenTo'    => $user['Email']);
						$mailObj->setData($maildata);
					    
					    $mailStatus = $mailmapper->SendMail($mailObj);
						
						$result['status'] = true;
						$form->populate($data);
						$result['form']   = $form;
						$result['amount'] = $invoiceObj->getinvtotamount();
						
	   				 }else{
	   				 	$form->populate($data);
						$result['form']   = $form;
						$result['status'] = false;
	   				 }						
					}else{
						//Declined trnsaction
					
						$storage = new Zend_Auth_Storage_Session();
						$user = $storage->read();						
		
						$mailmapper = new Application_Service_Notification();
						$mailObj = new Notification_Model_Mail();
						$mailObj->setMsgCode('Declined trnsaction');
						$name = $user['Firstname'].' '.$user['LastName'];
						$maildata = array('UserName' => $name,
								  'SenTo'    => $user['Email']);
						$mailObj->setData($maildata);
						$mailStatus = $mailmapper->SendMail($mailObj);
						
						$form->populate($data);
						$result['form']   = $form;
						$result['status'] = false;
					}					
				}else{
					$form->populate($data);
					$result['form']   = $form;
					$result['status'] = false;
				}
			}else{
				$form->populate($data);
				$result['form']   = $form;
				$result['status'] = false;
			}
			
			return $result;
			
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}		
	}
	
	public function GenerateInvoice(Payments_Model_CreateInvoiceByRestId $object)
	{
		try{

		$subplanStatusMapper = new Application_Model_SubscriptionPlanStatusDataMapper();
		$subPlanStatus = $subplanStatusMapper->GetSubscriptionStatusByCode(array('ACT'));
		$actSubPlanStatus = $subPlanStatus['ACT'];
		$restPaymentPlanStatusMapper = new Application_Model_RestPaymentPlanStatusDataMapper();
		$rppmActStatusObj = $restPaymentPlanStatusMapper->getRestPaymentPlanStatusByCode('ACT');
		$invStatusMapper = new Application_Model_InvoiceStatusDataMapper();
		$unpaidinvStatus = $invStatusMapper->getInvoiceStatusByCode('UPD');
				
		/* Caluculate Amount and Invoice data on Pro rata basis */
		/* Reterive Plan Detiails */
		$planDetailsObj = new Payments_Model_SubscriptionPlanDetailsByRestId();
		$planDetailsObj->setrppmrestaurant_id($object->getRestId());
		$planDetailsObj->setspplan_status($actSubPlanStatus->getId());
		$planDetailsObj->setrppmstatus($rppmActStatusObj->getId());
		$planMapperObj = new Payments_Model_SubscriptionPlansMapper();
		
		$rowSet = $planMapperObj->GetSubscriptionPlanDetailsByRestId($planDetailsObj);
		
		$resServ = new Application_Service_Restaurant();
		$timeZone = $resServ->GetRestaurantTimeZone($object->getRestId());
		date_default_timezone_set($timeZone);
	 	$currentDate = date('Y-m-d');

	 	$invoiceId 			  = "";
		$subscriptionAmount   = "";
		$planDuration		  = "";		
		$PlanActivationDate   = "";
		$PlanDesc			  = "";
		$subscriptionfromDate = "";
		$subscriptiontoDate   = "";
		$no_Of_Days			  = "";		
	    $invoiceObj = new Payments_Model_Invoice();
		 
		if($rowSet){
		  foreach($rowSet as $row){
		  	 $subscriptionAmount = $row->spamount;
			 $planDuration		 = $row->spplan_duration;
		  	 $subscriptionAmount = $row->spamount;
			 $PlanActivationDate = $row->rppmplan_activation_date;
			 $PlanDesc			 = $row->spplan_description;			  	 				  	  	
		  }

		 	 $daysObject = new Payments_Model_CalculateDays();
			 $daysObject->setRestId($object->getRestId())
		 		    	->setPlanDuration($planDuration)
		 		    	->setFromDate($PlanActivationDate)
		 		   	 	->setAmount($subscriptionAmount);
 	     
		 	 $result = array();			 		    						  
		 	 $result = $this->CalculateInvoiceAndAmount($daysObject);
		  		
		 	 $invoiceGenDate = "";
		 	 $invoiceGenTime = "";
		 	 
		 	 $invoiceGenDate = date('Y-m-d');
		 	 $invoiceGenTime = date('h:i');	 	
		 	 
		 	 $invoiceObj->setinvrestaurant_id($object->getRestId())		 	
		 	 			->setinvdescription($PlanDesc)
		 	 			->setinvbilling_fromdate($PlanActivationDate)
		 	 			->setinvbilling_todate($result['toDate'])	
		 	 			->setinvamount($result['amount'])
		 	 			->setinvtotamount($result['totamount'])
		 	 			->setinvservice_tax($result['serviceTax'])
		 	 			->setinvservice_taxtotal($result['serviceTaxTotal'])
		 	 			->setinvtxncharges($result['txnCharge'])
		 	 			->setinvgenerated_date($invoiceGenDate)
		 	 			->setinvgenerated_time($invoiceGenTime)		 	 			
		 	 			->setinvstatus($unpaidinvStatus->getId());
		 	 
		 	 $invoiceMapper = new Payments_Model_InvoiceMapper();
		 	 $row = $invoiceMapper->CheckInvoiceGenerated($invoiceObj);
		 	 
		 	 if(!$row){
		 	 	$invoiceId = $invoiceMapper->CreateInvoice($invoiceObj);
		 	 	$invoiceObj->setinvid($invoiceId);		 	 	
		 	 }else{
		 	 	$invoiceObj->setinvid($row->invid);
		 	 }		 	 
		 }
		 return $invoiceObj;		
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
 	}	

    public function CalculateInvoiceAndAmount(Payments_Model_CalculateDays $daysObject)
    {
	  	try{
	  		$no_Of_Days = 0;
	  		$Month = "";
	  		$Year  = "";
	  		$resServ = new Application_Service_Restaurant();
			$timeZone = $resServ->GetRestaurantTimeZone($daysObject->getRestId());
			date_default_timezone_set($timeZone);
	  		$planDuration = "";
	  		$toDate = "";
	  		$result = array();
	  		$actualAmount = 0;
	  		$calculatedAmount = 0;	  		
	  		$is_CurrMonth_15 = false;
	  		
	  		$planDuration = $daysObject->getPlanDuration();  		
	  		$fromDate = $daysObject->getFromDate();
	  		$dateSplit = explode('-',$fromDate);
	  		$Year  = $dateSplit[0];
	  		$Month = $dateSplit[1];
	  		 
	  		$currMonth_1st_Day = date('Y-m-d',mktime(0,0,0,$Month,1,$Year));
	  		$currMonth_14_Day  = date('Y-m-d',mktime(0,0,0,$Month,14,$Year));
	  		$currMonth_15_Day  = date('Y-m-d',mktime(0,0,0,$Month,15,$Year));
	  		$NextMonth_1st_Day = date('Y-m-d',mktime(0,0,0,$Month+1,1,$Year));
	  		 
	  		/* For time being the peorata calculation is commented */
	  		/* If from date is greater than 15th of month get days up to plan duration selected by restaurants */  		
	  		/* if(strtotime($fromDate) >= strtotime($currMonth_15_Day) && strtotime($fromDate) < strtotime($NextMonth_1st_Day)){
	  			
	  			$no_Of_Days = (strtotime(date('Y-m-d',mktime(0,0,0,$Month + $planDuration,15,$Year))) - (strtotime($fromDate)))/(60*60*24);
	  			$toDate = date('Y-m-d',mktime(0,0,0,$Month + $planDuration,15,$Year));
	  			 
	  		/* If from date is lesser than 15th of month get days up to plan duration selected by restaurants */ 	
	  		/* }else if(strtotime($fromDate) < strtotime($currMonth_15_Day) && strtotime($fromDate) >= strtotime($currMonth_1st_Day)){
	  			
	  			$no_Of_Days = (((strtotime($currMonth_15_Day) - (strtotime($fromDate)))) +(strtotime(date('Y-m-d',mktime(0,0,0,$Month + $planDuration,15,$Year))) - strtotime($currMonth_15_Day))) / (60*60*24);
	  			$toDate = date('Y-m-d',mktime(0,0,0,$Month + $planDuration,15,$Year));
	  		}*/
	  		
	  		/* The No of days should be calculated from date rest add to 15 of current month or next month */
	  		/* If from date is greater than 15th of month get days up to plan duration selected by restaurants */
	  		if(strtotime($fromDate) == strtotime($currMonth_15_Day)){
	  			$is_CurrMonth_15 = true;
	  			$toDate = date('Y-m-d',mktime(0,0,0,$Month + $planDuration,14,$Year));
	  			
	  		}else if(strtotime($fromDate) > strtotime($currMonth_15_Day)){	  			
	  			$no_Of_Days = (strtotime(date('Y-m-d',mktime(0,0,0,$Month + 1,15,$Year))) - (strtotime($fromDate)))/(60*60*24);
	  			$toDate = date('Y-m-d',mktime(0,0,0,$Month + 1,14,$Year));
	  			 
	  		 /* If from date is lesser than 15th of month get days up to plan duration selected by restaurants */ 	
	  		}else if(strtotime($fromDate) < strtotime($currMonth_15_Day) && strtotime($fromDate) == strtotime($currMonth_14_Day)){
	  			$no_Of_Days = 1;
	  			$toDate     = $currMonth_14_Day;
	  				  			
	  		}else if(strtotime($fromDate) < strtotime($currMonth_15_Day)){
	  			$no_Of_Days = (strtotime($currMonth_15_Day) - (strtotime($fromDate))) / (60*60*24);
	  			$toDate = $currMonth_14_Day;
	  		}
	  		
	  		/* Reterieve Service Tax and Tranasaction Charges */
	  		$serviceTax = 0;
	  		$serviceTaxResult = $this->getServiceTax();
	  		if($serviceTaxResult){
	  			foreach($serviceTaxResult as $taxResult){
	  				$serviceTax = $taxResult->servicetax;		
	  			}	
	  		}
	  		
  	  		/* Reterieve Customer and Payment profile Id's */
			$restid = $daysObject->getRestId();	
			$profileByRestIdObj = new Payments_Model_GetPaymentProfileByRestId();
			$profileByRestIdObj->setrappmrestaurant_id($restid)
							   ->setrappmstatus(1)
							   ->setanppstatus(1)
							   ->setancpstatus(1);
		   	
			$authNetProfMapper = new Payments_Model_AuthnetPaymentProfileMapper();
			$rowSet = $authNetProfMapper->GetPaymentProfileByRestId($profileByRestIdObj);
			
			foreach($rowSet as $row){
				$anppid			   = $row->anppid;
				$customerProfileId = $row->ancpcustomer_profile_id;
				$paymentProfileId  = $row->anpppayment_profile_id;
				$profiletype	   = $row->anpppayment_type;
				
			}
	  		
	  		$txnCharges = 0;
	  		$code = "";
	  		if($profiletype == 'CC'){
	  			$code = 'SUB_CC';	
	  		}else if($profiletype == 'EC'){
	  			$code = 'SUB_EC';
	  		}
	  		$txnChargesResult = $this->getTransactionCharges($code);
	  		
	  		if($txnChargesResult){
	  			foreach($txnChargesResult as $txnCharge){
	  				$txnCharges = $txnCharge->txncharge;
	  			}
	  		}
	  		
	  		/* Calculate Invoice Amount */
			
	  		$actualAmount = str_replace('$','',$daysObject->getAmount());
	  		if($is_CurrMonth_15){
	  			$calculatedAmount = trim($actualAmount);
	  		}else{
	  			$calculatedAmount = (trim($actualAmount)/(30 * $planDuration)) * $no_Of_Days;	
	  		}	  		
	  		
	  		$totalAmount = "";
	  		$calServTax = 0;
	  		if($serviceTax){
	  			$calServTax = ($serviceTax * $calculatedAmount) / 100;
	  		}
	  		$calTxnCharge = 0;
	  		if($txnCharges){
	  			$calTxnCharge = ($txnCharges * $calculatedAmount) / 100;	
	  		}
	  		$serviceTaxTotal =  round(($calculatedAmount + $calServTax),2);
	  		$totalAmount = round(($calculatedAmount + $calServTax + $calTxnCharge),2);	  		
	  		
	  		$result['fromDate']   	   = $fromDate;
	  		$result['toDate']     	   = $toDate;
	  		$result['amount']     	   = round($calculatedAmount,2);
	  		$result['totamount']  	   = $totalAmount; 
	  		$result['txnCharge']  	   = $txnCharges;
	  		$result['serviceTax'] 	   = $serviceTax;
	  		$result['serviceTaxTotal'] = $serviceTaxTotal;
	  		
			return $result;
	  		
	  		
	  	}catch(Exception $ex){
				Uss_Logger_FileLogger::info($ex->getMessage());
				throw new Exception($ex->getMessage()) ;
		}
  }
  
	public function searchPaymentProfiles(array $data)
	{
		try{
			$profileStatusMapper = new Application_Model_ProfileStatusDataMapper();
			$prfActStatusObj = $profileStatusMapper->getProfileStatusByCode('ACT');
			
			$searchData = new Payments_Model_SearchPaymentProfile();
			if (isset($data['customerProfileId']) != NULL && $data['customerProfileId'] != '') {
				$searchData->setsrchcustomer_profile_id($data['customerProfileId']);
			}
			if (isset($data['paymentProfileId']) != NULL && $data['paymentProfileId'] != '') {
				$searchData->setsrchpayment_profile_id($data['paymentProfileId']);
			}
			if (isset($data['profilecreatedstartdate']) != NULL && $data['profilecreatedstartdate'] != '') {
				$searchData->setsrchstart_date($data['profilecreatedstartdate']);
			}
			if (isset($data['profilecreatedstarttime']) != NULL && $data['profilecreatedstarttime'] != '') {
				$searchData->setsrchstart_time($data['profilecreatedstarttime']);
			}
			if (isset($data['profilecreatedenddate']) != NULL && $data['profilecreatedenddate'] != '') {
				$searchData->setsrchend_date($data['profilecreatedenddate']);
			}
			if (isset($data['profilecreatedendtime']) != NULL && $data['profilecreatedendtime'] != '') {
				$searchData->setsrchend_time($data['profilecreatedendtime']);
			}						
			$searchData->setancpstatus($prfActStatusObj->getId());
			$searchData->setanppstatus($prfActStatusObj->getId());
			$mapper = new Payments_Model_AuthnetPaymentProfileMapper();
			$searchResult = $mapper->searchPaymentProfiles($searchData);
			return $searchResult;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getCustomerProfileID()
	{
		try {
			
			$profileStatusMapper = new Application_Model_ProfileStatusDataMapper();
			$prfActStatusObj = $profileStatusMapper->getProfileStatusByCode('ACT');
			
			$mapper = new Payments_Model_AuthnetCustomerProfileMapper();
			$storage = new Zend_Auth_Storage_Session();
		    $data 	 = $storage->read();
		    
		    $authNet_Cust_ProfId = "";
		    $ancpid				 = "";
		    
		    /* Check Whether Rest Owner has Authorized.Net Customer Profile */	    
		    $getAuthNetCustProfObj = new Payments_Model_GetAuthNetCustProfId();
		    $getAuthNetCustProfObj->setancpuser_id($data['User_Id']);
		    
	        $row = $mapper->GetAuthNetCustProfIdByUserId($getAuthNetCustProfObj);
		    if($row){
		    	$ancpid				 = $row->ancpid;
		    	$authNet_Cust_ProfId = $row->ProfileId;	
		    }
		    /* If no Profiles are found create a new Authorized.Net Customer profile */
		    if(!$authNet_Cust_ProfId){
	        /* Create Auth Net Customer Profile */
	
	         $custProfObj = new Payments_Model_AuthnetCustomerProfile();
	         $custProfObj->setancpuser_id($data['User_Id'])
	                     ->setancpprofile_description($data['Firstname']." ".$data['LastName'])
	                     ->setancpemail($data['Email']);
	
	         
		     $authNet_Cust_ProfId = $authHelperObj->CreateCustomerProfileRequest($custProfObj);
		     if($authNet_Cust_ProfId){
		     	/* Save Authorized.Net Customer Profile */
		     	date_default_timezone_set('EST5EDT');
			 	$date = date('Y-m-d');
			 	$time = date('h:i:s');
			 	
			 	$custProfObj->setancpcustomer_profile_id($authNet_Cust_ProfId);
			 	$custProfObj->setancpcreated_date($date);
			 	$custProfObj->setancpcreated_time($time);
			 	$custProfObj->setancpstatus($prfActStatusObj->getId());
				$ancpid = $mapper->SaveAuthNetCusomerProfile($custProfObj);	     	
		     	
		      }	      	
		    }
			return $authNet_Cust_ProfId;			
		} catch (Exception $ex) {
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage());
		}
	}
	
	public function getPaymentProfileIDs($customerProfileId)
	{
		try {
			$paymentMapper = new Payments_Model_AuthnetPaymentProfileMapper();
			$paymentProfileIDs = $paymentMapper->getPaymentProfileIDs($customerProfileId);
			return $paymentProfileIDs;			
		} catch (Exception $ex) {
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage());
		}
	}
	
	public function getRestPaymentProfileMap($request)
	{
		try{
			if($request->paymentProfileId){
				$paymentProfileId = $request->paymentProfileId; 
				$mapper = new Payments_Model_RestAuthnetPaymentProfileMapMapper();
				$restNames = $mapper->getRestPaymentProfileMap($paymentProfileId);
				return $restNames;
			}
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}		
	}
	
	public function getTransactions($customerProfileID, $data,$offset)
	{
		try {
				$srchTxns = new Payments_Model_SearchTransaction();
				$srchTxns->setcustomerprofileid($customerProfileID);	
				if(isset($data['paymentProfileId']) != NULL && $data['paymentProfileId'] != ''){
					$srchTxns->setpaymentprofileid($data['paymentProfileId']);
				}
				if(isset($data['invNumber']) != NULL && $data['invNumber'] != ''){
					$srchTxns->setinvnumber($data['invNumber']);
				}
				if(isset($data['txnId']) != NULL && $data['txnId'] != ''){
					$srchTxns->settxnid($data['txnId']);
				}
				if(isset($data['startdate']) != NULL && $data['startdate'] != ''){
					$srchTxns->setstartdate($data['startdate']);
				}
				if(isset($data['starttime']) != NULL && $data['starttime'] != ''){
					$srchTxns->setstarttime($data['starttime']);
				}
				if(isset($data['enddate']) != NULL && $data['enddate'] != ''){
					$srchTxns->setenddate($data['enddate']);
				}
				if(isset($data['endtime']) != NULL && $data['endtime'] != ''){
					$srchTxns->setendtime($data['endtime']);
				}								
				$mapper = new Payments_Model_TransactionsMapper();
				
				$txnList = $mapper->getTransactions($srchTxns,$offset);
				
				return $txnList;
			
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getAllTransactions($data,$offset){
		try {
				$srchTxns = new Payments_Model_SearchTransaction();
				if(isset($data['paymentProfileId']) != NULL && $data['paymentProfileId'] != ''){
					$srchTxns->setpaymentprofileid($data['paymentProfileId']);
				}
				if(isset($data['invNumber']) != NULL && $data['invNumber'] != ''){
					$srchTxns->setinvnumber($data['invNumber']);
				}
				if(isset($data['txnId']) != NULL && $data['txnId'] != ''){
					$srchTxns->settxnid($data['txnId']);
				}
				if(isset($data['startdate']) != NULL && $data['startdate'] != ''){
					$srchTxns->setstartdate($data['startdate']);
				}
				if(isset($data['starttime']) != NULL && $data['starttime'] != ''){
					$srchTxns->setstarttime($data['starttime']);
				}
				if(isset($data['enddate']) != NULL && $data['enddate'] != ''){
					$srchTxns->setenddate($data['enddate']);
				}
				if(isset($data['endtime']) != NULL && $data['endtime'] != ''){
					$srchTxns->setendtime($data['endtime']);
				}
				if(isset($data['resName']) != NULL && $data['resName'] != ''){
					$srchTxns->setresName($data['resName']);
				}
				if(isset($data['resId']) != NULL && $data['resId'] != ''){
					$srchTxns->setresId($data['resId']);
				}								
				$mapper = new Payments_Model_TransactionsMapper();
				
				$txnList = $mapper->getTransactions($srchTxns,$offset);
				
				return $txnList;
			
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}	

	public function GenerateInvoicePdf(Payments_Model_Invoice $invoiceObject)
	{
		try{
			/* Reterieve Billing info  */
			$authHelperObj = new Uss_Helper_AuthNetHelper();
			$custProfReq = $authHelperObj->GetCustomerPaymentProfileRequest($invoiceObject->getcustprofid(),$invoiceObject->getpaymentprofid());
			$path = 'managerest/'.$invoiceObject->getinvrestaurant_id();
			
			/* Get Rest Name by rest id. */
			
			$restid = $invoiceObject->getinvrestaurant_id();
			$resservice = new Application_Service_Restaurant();
			$restaurantName = $resservice->GetRestaurantNamesById($restid);
			
			if(!file_exists($path)){
				mkdir($path,0777);
			}
			$invoiceDirPath = $path.'/invoice';
			if(!file_exists($invoiceDirPath)){
				mkdir($invoiceDirPath,0777);
			}
			
			$invoiceFilePath = $invoiceDirPath.'/'.$invoiceObject->getinvid().'.pdf';
			if(!file_exists($invoiceFilePath)){
				$pdf = new My_Pdf_Document($invoiceFilePath, '.');
				$page = $pdf->createPage();
	
				$font = Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_HELVETICA);
				
				$page->setFont($font, 8);
				$page->setLineColor(new Zend_Pdf_Color_Rgb(0,100,0));
				$page->drawLine(-10, 15, ($page->getWidth()-0), 15);
				$imageurl = "../public/images/logo.png";
				
				$image = Zend_Pdf_Image::imageWithPath($imageurl);
				
				// write image to page
				$page->drawImage($image,-10,-30,80, 40);			
				
				$invoiceCreationDate = $invoiceObject->getinvgenerated_date();
				$page->drawText('INVOICE', 500, 0);
				
				$page->drawText('UReserv Inc',15,45);
				$page->setFont($font, 6);
				$page->drawText('life just got easier ',15,55);
				
				/*Print Address*/
			    $page->drawText('464 Common Street,',15,65);
				$page->drawText('Suite 253,',15,75);
				$page->drawText('Belmont, MA 02478,',15,85);		
				$page->drawText('EMail: admin@ureserv.com',15,95);
				
				$invoiceNo  = "INVOICE#  ".$invoiceObject->getinvid();
				$invoiceDate  = "DATE  ".$invoiceObject->getinvgenerated_date();
	
				/* Print Invoice No and date on right hand side */
				$page->drawText($invoiceNo,450,45);
				$page->drawText($invoiceDate,450,55);
				
				/* Print Billing info */
				
				$page->setFont($font, 8);
				
				$page->drawText('TO',15,120);
				
				$page->setFont($font, 6);
				
				$paymentProfInfo = $custProfReq[$invoiceObject->getpaymentprofid()];
				
				$name = $paymentProfInfo['firstName']. " " .$paymentProfInfo['lastName'];
				$page->drawText($name,20,130);
				
				$address = $paymentProfInfo['address'].",";
				$page->drawText($address,20,140);
				
				$city_state = $paymentProfInfo['city']." - ".$paymentProfInfo['state'].",";
				$page->drawText($city_state,20,150);
				
				$country_zip = $paymentProfInfo['country']." - ".$paymentProfInfo['zip'].".";			
				$page->drawText($country_zip,20,160);
				
				
				/* Print Invoice details */
				
				$invoiceFrom = 'Invoice From: '.$invoiceObject->getinvbilling_fromdate();
				$page->drawText($invoiceFrom,400,130);
				
				$invoiceTo = 'Invoice To: '.$invoiceObject->getinvbilling_todate();
				$page->drawText($invoiceTo,400,140);
				
				//$duedate = 'Due Date:';
				//$page->drawText($duedate,400,150);
								
				$restId = 'Restaurant ID: '.$invoiceObject->getinvrestaurant_id();
				$page->drawText($restId,400,150);
				
				$restName = 'Restaurant Name: '.$restaurantName['restName'];
				$page->drawText($restName,400,160);
	
				$planType = "Plan type: Monthly Subscription";
				$page->drawText($planType,400,170);
				
				/* Create table for printing  invoice desc and amount */
				
				$table = new My_Pdf_Table(6);
				/* Adding table header */
				$headrow  = new My_Pdf_Table_Row();
				$headcols = array();
						
				$sNo  = new My_Pdf_Table_Column();
				$sNo->setText("SNO",'center','middle');
				$sNo->setWidth(30);
				$sNo->setHeight(100);
				$headcols[] = $sNo;
					
				$itemTitle = new My_Pdf_Table_Column();
				$itemTitle->setText("ITEM TITLE",'center','middle');
				$itemTitle->setWidth(100);
				$headcols[] = $itemTitle;
	
				$description  = new My_Pdf_Table_Column();
				$description->setText("DESCRPTION",'center','middle');
				$description->setWidth(170);
				$headcols[] = $description;
					
				$price  = new My_Pdf_Table_Column();
				$price->setText("PRICE",'center','middle');
				$price->setWidth(70);
				$headcols[] = $price;
	
				$deductions  = new My_Pdf_Table_Column();
				$deductions->setText("DEDUCTIONS",'center','middle');
				$deductions->setWidth(80);
				$headcols[] = $deductions;
					
				$lineTotal  = new My_Pdf_Table_Column();
				$lineTotal->setText("LINE TOTAL",'center','middle');
				$lineTotal->setWidth(80);
				$headcols[] = $lineTotal;
				
				$headrow->setColumns($headcols);
				$headrow->setFont($font, 8);
				$headrow->setBorder(My_Pdf::TOP, new Zend_Pdf_Style());
				$headrow->setBorder(My_Pdf::BOTTOM, new Zend_Pdf_Style());
				$headrow->setBorder(My_Pdf::LEFT, new Zend_Pdf_Style());
				$headrow->setBorder(My_Pdf::RIGHT, new Zend_Pdf_Style());
				$headrow->setCellPaddings(array(8,8,8,8));
				$table->addRow($headrow);
				
				/* Add Table rows */
				
				$row  = new My_Pdf_Table_Row();
				$cols = array();			
				
				$sNoCol = new My_Pdf_Table_Column();
				$sNoCol->setText('1','center','middle');
				$sNoCol->setWidth(30);
				$sNoCol->setHeight(600);
				$cols[] = $sNoCol;
				
				$itemTitleCol = new My_Pdf_Table_Column();				
				$itemTitleCol->setText($invoiceObject->getinvbilling_fromdate(),'center','middle');
				$itemTitleCol->setWidth(100);			
				$cols[] = $itemTitleCol;
				
				
				$invoiceDetails = 'Subcription for bill from '. $invoiceObject->getinvbilling_fromdate() .' to '. $invoiceObject->getinvbilling_todate();
				$descCol = new My_Pdf_Table_Column();
				$descCol->setText($invoiceDetails,'center','middle');
				$descCol->setWidth(170);			
				$cols[] = $descCol;
				
				$priceCol = new My_Pdf_Table_Column();
				$priceCol->setText('$'.$invoiceObject->getinvamount(),'center','middle');
				$priceCol->setWidth(70);			
				$cols[] = $priceCol;
				
				$deductionCol = new My_Pdf_Table_Column();
				$deductionCol->setText('$0','center','middle');
				$deductionCol->setWidth(80);			
				$cols[] = $deductionCol;
				
				$lineTotalCol = new My_Pdf_Table_Column();
				$lineTotalCol->setText('$'.$invoiceObject->getinvamount(),'center','middle');
				$lineTotalCol->setWidth(80);			
				$cols[] = $lineTotalCol;
				
				$row->setColumns($cols);
			    $row->setFont($font, 8);
				$row->setBorder(My_Pdf::TOP, new Zend_Pdf_Style());
				$row->setBorder(My_Pdf::BOTTOM, new Zend_Pdf_Style());
				$row->setBorder(My_Pdf::LEFT, new Zend_Pdf_Style());
				$row->setBorder(My_Pdf::RIGHT, new Zend_Pdf_Style());
				$row->setCellPaddings(array(8,8,8,8));
				$table->addRow($row);				
	
				/* Print total row */
				$totCols = array();
				
				$sNoColTot = new My_Pdf_Table_Column();
				$sNoColTot->setText('','center','middle');
				$sNoColTot->setWidth(30);
				$sNoColTot->setHeight(600);
				$totCols[] = $sNoColTot;
				
				$itemTitleTotCol = new My_Pdf_Table_Column();				
				$itemTitleTotCol->setText('','center','middle');
				$itemTitleTotCol->setWidth(100);			
				$totCols[] = $itemTitleTotCol;
				
				$descTotCol = new My_Pdf_Table_Column();
				$descTotCol->setText('TOTAL','right','middle');
				$descTotCol->setWidth(170);			
				$totCols[] = $descTotCol;
				
				$priceTotCol = new My_Pdf_Table_Column();
				$priceTotCol->setText('','center','middle');
				$priceTotCol->setWidth(70);			
				$totCols[] = $priceTotCol;
				
				$deductionTotCol = new My_Pdf_Table_Column();
				$deductionTotCol->setText('$0','center','middle');
				$deductionTotCol->setWidth(80);			
				$totCols[] = $deductionTotCol;
				
				$lineTotalCol1 = new My_Pdf_Table_Column();
				$lineTotalCol1->setText('$'.$invoiceObject->getinvamount(),'center','middle');
				$lineTotalCol1->setWidth(80);			
				$totCols[] = $lineTotalCol1;
				
				$totRow  = new My_Pdf_Table_Row();
				$totRow->setColumns($totCols);			
				$totRow->setFont($font, 8);
				$totRow->setCellPaddings(array(8,8,8,8));
				$table->addRow($totRow);	
				
				/* Add Service Tax row */
				
				$serviceTaxCols = array();
				
				$sNoColTax = new My_Pdf_Table_Column();
				$sNoColTax->setText('','center','middle');
				$sNoColTax->setWidth(30);
				$sNoColTax->setHeight(600);
				$serviceTaxCols[] = $sNoColTax;
				
				$itemTitleTaxCol = new My_Pdf_Table_Column();				
				$itemTitleTaxCol->setText('','center','middle');
				$itemTitleTaxCol->setWidth(100);			
				$serviceTaxCols[] = $itemTitleTaxCol;
				
				$descTaxCol = new My_Pdf_Table_Column();
				$descTaxCol->setText('SERVICE TAX(%)','right','middle');
				$descTaxCol->setWidth(170);			
				$serviceTaxCols[] = $descTaxCol;
				
				$priceTaxCol = new My_Pdf_Table_Column();
				$priceTaxCol->setText('','center','middle');
				$priceTaxCol->setWidth(70);			
				$serviceTaxCols[] = $priceTaxCol;
				
				$deductionTaxCol = new My_Pdf_Table_Column();
				$deductionTaxCol->setText('','center','middle');
				$deductionTaxCol->setWidth(80);			
				$serviceTaxCols[] = $deductionTaxCol;
				
				$lineTotalTaxCol = new My_Pdf_Table_Column();
				$lineTotalTaxCol->setText($invoiceObject->getinvservice_tax().'%','center','middle');
				$lineTotalTaxCol->setWidth(80);	
						
				$serviceTaxCols[] = $lineTotalTaxCol;
				
				
				$servTaxRow  = new My_Pdf_Table_Row();
				$servTaxRow->setColumns($serviceTaxCols);
				$servTaxRow->setFont($font, 8);
				$servTaxRow->setCellPaddings(array(8,8,8,8));
				$table->addRow($servTaxRow);	
				
				
					/* Add Service Tax Toatal row */
				
				$serviceTaxTotCols = array();
				
				$sNoColTaxTot = new My_Pdf_Table_Column();
				$sNoColTaxTot->setText('','center','middle');
				$sNoColTaxTot->setWidth(30);
				$sNoColTaxTot->setHeight(600);
				$serviceTaxTotCols[] = $sNoColTaxTot;
				
				$itemTitleTaxTotCol = new My_Pdf_Table_Column();				
				$itemTitleTaxTotCol->setText('','center','middle');
				$itemTitleTaxTotCol->setWidth(100);			
				$serviceTaxTotCols[] = $itemTitleTaxTotCol;
				
				$descTaxTotCol = new My_Pdf_Table_Column();
				$descTaxTotCol->setText('SERVICE TAX TOTAL','right','middle');
				$descTaxTotCol->setWidth(170);			
				$serviceTaxTotCols[] = $descTaxTotCol;
				
				$priceTaxTotCol = new My_Pdf_Table_Column();
				$priceTaxTotCol->setText('','center','middle');
				$priceTaxTotCol->setWidth(70);			
				$serviceTaxTotCols[] = $priceTaxTotCol;
				
				$deductionTaxTotCol = new My_Pdf_Table_Column();
				$deductionTaxTotCol->setText('','center','middle');
				$deductionTaxTotCol->setWidth(80);			
				$serviceTaxTotCols[] = $deductionTaxTotCol;
				
				$lineTotalTaxTotCol = new My_Pdf_Table_Column();
				$lineTotalTaxTotCol->setText('$'.$invoiceObject->getinvservice_taxtotal(),'center','middle');
				$lineTotalTaxTotCol->setWidth(80);						
				$serviceTaxTotCols[] = $lineTotalTaxTotCol;
				
				
				$servTaxTotRow  = new My_Pdf_Table_Row();
				$servTaxTotRow->setColumns($serviceTaxTotCols);
				$servTaxTotRow->setFont($font, 8);
				$servTaxTotRow->setCellPaddings(array(8,8,8,8));
				$table->addRow($servTaxTotRow);
				
				/* Handling Charges row */
				
				
				$handlingChargesCols = array();
				
				$sNoColCharge = new My_Pdf_Table_Column();
				$sNoColCharge->setText('','center','middle');
				$sNoColCharge->setWidth(30);
				$sNoColCharge->setHeight(600);
				$handlingChargesCols[] = $sNoColCharge;
				
				$itemTitleChargeCol = new My_Pdf_Table_Column();				
				$itemTitleChargeCol->setText('','center','middle');
				$itemTitleChargeCol->setWidth(100);			
				$handlingChargesCols[] = $itemTitleChargeCol;
				
				$descChargeCol = new My_Pdf_Table_Column();
				$descChargeCol->setText('TRANSACTION FEE','right','middle');
				$descChargeCol->setWidth(170);			
				$handlingChargesCols[] = $descChargeCol;
				
				$priceChargeCol = new My_Pdf_Table_Column();
				$priceChargeCol->setText('','center','middle');
				$priceChargeCol->setWidth(70);			
				$handlingChargesCols[] = $priceChargeCol;
				
				$deductionChargeCol = new My_Pdf_Table_Column();
				$deductionChargeCol->setText('','center','middle');
				$deductionChargeCol->setWidth(80);			
				$handlingChargesCols[] = $deductionChargeCol;
				
				$lineTotalChargeCol = new My_Pdf_Table_Column();
				$lineTotalChargeCol->setText($invoiceObject->getinvtxncharges().'%','center','middle');
				$lineTotalChargeCol->setWidth(80);						
				$handlingChargesCols[] = $lineTotalChargeCol;				
				
				$txnChargeRow  = new My_Pdf_Table_Row();
				$txnChargeRow->setColumns($handlingChargesCols);
				$txnChargeRow->setFont($font, 8);
				$txnChargeRow->setCellPaddings(array(8,8,8,8));
				$table->addRow($txnChargeRow);				
				
				/* Add Discount Row if exist */
				
				if($invoiceObject->getinv_discount())
				{
					$discountCols = array();
					
					$sNoColDiscount = new My_Pdf_Table_Column();
					$sNoColDiscount->setText('','center','middle');
					$sNoColDiscount->setWidth(30);
					$sNoColDiscount->setHeight(600);
					$discountCols[] = $sNoColDiscount;
					
					$itemTitleTDiscount = new My_Pdf_Table_Column();				
					$itemTitleTDiscount->setText('','center','middle');
					$itemTitleTDiscount->setWidth(100);			
					$discountCols[] = $itemTitleTDiscount;
					
					$descTaxDiscount = new My_Pdf_Table_Column();
					$descTaxDiscount->setText('DISCOUNT','right','middle');
					$descTaxDiscount->setWidth(170);			
					$discountCols[] = $descTaxDiscount;
					
					$priceDiscount = new My_Pdf_Table_Column();
					$priceDiscount->setText('','center','middle');
					$priceDiscount->setWidth(70);			
					$discountCols[] = $priceDiscount;
					
					$deductionDiscount = new My_Pdf_Table_Column();
					$deductionDiscount->setText('','center','middle');
					$deductionDiscount->setWidth(80);			
					$discountCols[] = $deductionDiscount;
					
					$lineTotalDiscount = new My_Pdf_Table_Column();
					$lineTotalDiscount->setText($invoiceObject->getinv_discount().'%','center','middle');
					$lineTotalDiscount->setWidth(80);						
					$discountCols[] = $lineTotalDiscount;
					
					
					$discountPayRow  = new My_Pdf_Table_Row();
					$discountPayRow->setColumns($discountCols);
					$discountPayRow->setFont($font, 8);
					$discountPayRow->setCellPaddings(array(8,8,8,8));
					$table->addRow($discountPayRow);
				}
				
				/* Add Net Payable row */
										
				$netPayCols = array();
				
				$sNoColNetPay = new My_Pdf_Table_Column();
				$sNoColNetPay->setText('','center','middle');
				$sNoColNetPay->setWidth(30);
				$sNoColNetPay->setHeight(600);
				$netPayCols[] = $sNoColNetPay;
				
				$itemTitleTNetPay = new My_Pdf_Table_Column();				
				$itemTitleTNetPay->setText('','center','middle');
				$itemTitleTNetPay->setWidth(100);			
				$netPayCols[] = $itemTitleTNetPay;
				
				$descTaxNetPay = new My_Pdf_Table_Column();
				$descTaxNetPay->setText('NET PAYABLE TOTAL','right','middle');
				$descTaxNetPay->setWidth(170);			
				$netPayCols[] = $descTaxNetPay;
				
				$priceNetPay = new My_Pdf_Table_Column();
				$priceNetPay->setText('','center','middle');
				$priceNetPay->setWidth(70);			
				$netPayCols[] = $priceNetPay;
				
				$deductionNetPayCol = new My_Pdf_Table_Column();
				$deductionNetPayCol->setText('','center','middle');
				$deductionNetPayCol->setWidth(80);			
				$netPayCols[] = $deductionNetPayCol;
				
				$lineTotalNetPayCol = new My_Pdf_Table_Column();
				$lineTotalNetPayCol->setText('$'.$invoiceObject->getinvtotamount(),'center','middle');
				$lineTotalNetPayCol->setWidth(80);						
				$netPayCols[] = $lineTotalNetPayCol;
				
				
				$netPayRow  = new My_Pdf_Table_Row();
				$netPayRow->setColumns($netPayCols);
				$netPayRow->setFont($font, 8);
				$netPayRow->setCellPaddings(array(8,8,8,8));
				$table->addRow($netPayRow);
				
				
				
				$page->addTable($table, 10, 200);
				$pdf->addPage($page);
				$pdf->save();
				
			}
						
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}	
	}
	
	public function GetDueAmount($restaurantid)
	{
		try{
		$restPaymentPlanStatusMapper = new Application_Model_RestPaymentPlanStatusDataMapper();
		$rppmActStatusObj = $restPaymentPlanStatusMapper->getRestPaymentPlanStatusByCode('ACT');
		$spplanStatusMapper = new Application_Model_SubscriptionPlanStatusDataMapper();
		$subplanStatusMapper = new Application_Model_SubscriptionPlanStatusDataMapper();
		$subPlanStatus = $subplanStatusMapper->GetSubscriptionStatusByCode(array('ACT'));
		$actSubPlanStatus = $subPlanStatus['ACT'];
			
			/* Reterive Plan Detiails */
		$planDetailsObj = new Payments_Model_SubscriptionPlanDetailsByRestId();
		$planDetailsObj->setrppmrestaurant_id($restaurantid);
		$planDetailsObj->setspplan_status($actSubPlanStatus->getId());
		$planDetailsObj->setrppmstatus($rppmActStatusObj->getId());
		$planMapperObj = new Payments_Model_SubscriptionPlansMapper();
		
		$rowSet = $planMapperObj->GetSubscriptionPlanDetailsByRestId($planDetailsObj);
		
		$resServ = new Application_Service_Restaurant();
		$timeZone = $resServ->GetRestaurantTimeZone($restaurantid);
		date_default_timezone_set($timeZone);
	 	$currentDate = date('Y-m-d');

	 	
		$subscriptionAmount   = "";
		$planDuration		  = "";		
		$PlanActivationDate   = "";
		$PlanDesc			  = "";
		 
		if($rowSet){
		  foreach($rowSet as $row){
		  	 $subscriptionAmount = $row->spamount;		  	
			 $planDuration		 = $row->spplan_duration;		  	 
			 $PlanActivationDate = $row->rppmplan_activation_date;
			 $PlanDesc			 = $row->spplan_description;			  	 				  	  	
		  }

	 	 $daysObject = new Payments_Model_CalculateDays();
		 $daysObject->setRestId($restaurantid)
	 		    	->setPlanDuration($planDuration)
	 		    	->setFromDate($PlanActivationDate)
	 		   	 	->setAmount($subscriptionAmount);
      
	 		 		    						  
	 	 $result = $this->CalculateInvoiceAndAmount($daysObject);
		}
		return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function GetSubscriptionPlans($planId = 0,$isAjaxCall)
	{
		try{
			$mapper = new Payments_Model_SubscriptionPlansMapper();
			$rowSet = $mapper->ReterieveSubscriptionPlans($planId,$isAjaxCall);
			return $rowSet;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getPaymentPlan($restId)
	{
		try {
			$mapper = new Payments_Model_RestaurantPaymentPlanMapMapper();
			$planId = $mapper->getPaymentPlan($restId);
			return $planId;	
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getServiceTax()
	{
		try{			
			$servceTaxMapper = new Application_Model_ServiceTaxMapper();
			$rowSet = $servceTaxMapper->RetrieveServiceTax();
			
			return $rowSet;				
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getTransactionCharges($code)
	{
		try{
			$txnChargMapper = new Application_Model_TransactionChargesMapper();
			$rowSet = $txnChargMapper->ReterieveTransactionChargeByCode($code);
			
			return $rowSet; 	
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}		
	}
	
	public function ManageInvoice(array $formdata)
	{
		try{
		 	$storage   = new Zend_Auth_Storage_Session();
			$data 	   = $storage->read();
		 	$userType = "";
		 	$result   = array();
		 
		 	$userType = $data['Usertype'];
		 	if($userType == 'RSO' || $userType == 'ADM' || $userType == 'ADU'){
		 	   if($userType == 'RSO'){
		 	   	$userid = $data['User_Id'];	
		 	   }else{
		 	    $userid = $data['restownerId'];
		 	   }
		 	   $manageInvoiceObject = new Payments_Model_ManageInvoice();
		 	   $manageInvoiceObject->setUserId($userid);			   
		 	   $invoiceMapper = new Payments_Model_InvoiceMapper();
		 	   if($formdata){
		 	   	if(isset($formdata['invoiceNum'])){
		 	   		$manageInvoiceObject->setinvoicenum($formdata['invoiceNum']);
		 	   	}
		 	   	
		 	   if(isset($formdata['startdate'])){
		 	   		$manageInvoiceObject->setinvoicefromdate($formdata['startdate']);
		 	   	}
		 	   	
		 	   	if(isset($formdata['enddate'])){
		 	   		$manageInvoiceObject->setinvoicetodate($formdata['enddate']);
		 	   	}
		 	   	
		 	   if(isset($formdata['invoiceStatus'])){
		 	   		$manageInvoiceObject->setinvoicestatus($formdata['invoiceStatus']);
		 	   	}
		 	   	
		 	   }		   
			   $result['rowset'] = $invoiceMapper->RetrieveInvoices($manageInvoiceObject);			   	   				   		 	   	   		
		 	}
			   $result['form'] = $formdata;
			   	
		 	return $result;
		 	 
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetPlanIdByRestId($request)
	{
		try{
			$planid = "";
			$mapper = new Payments_Model_RestaurantPaymentPlanMapMapper();
			$planid = $mapper->getPaymentPlan($request->restaurantid);
			
			return $planid;
			
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * This first is used for transaction initiation for restaurant renewal  
	 */
	public function ManageSubscriptionRenewal($request)
	{
		try{
			if($request){
				$status = false;
				$billingDate = 	$request->billingdate;
				
				/* Base Data objets */
				$profileStatusMapper = new Application_Model_ProfileStatusDataMapper();
				$prfActStatusObj = $profileStatusMapper->getProfileStatusByCode('ACT');
				$restPaymentPlanStatusMapper = new Application_Model_RestPaymentPlanStatusDataMapper();
				$rppmActStatusObj = $restPaymentPlanStatusMapper->getRestPaymentPlanStatusByCode('ACT');
				$txnTypeMapper = new Application_Model_TransactionTypeDataMapper();
				$debitTxn = $txnTypeMapper->getTransactionTypeByCode('DR');
				$txnStatusMapper = new Application_Model_TransactionStatusDataMapper();
				$successfulTxn = $txnStatusMapper->getTransactionStatusByCode('I00001');				
				$renewalStatus = $txnStatusMapper->getTransactionStatusByCode('RNW');
				
				$subplanStatusMapper = new Application_Model_SubscriptionPlanStatusDataMapper();
				$subPlanStatus = $subplanStatusMapper->GetSubscriptionStatusByCode(array('ACT'));
				$actSubPlanStatus = $subPlanStatus['ACT'];
				$invoiceStatusMapper = new Application_Model_InvoiceStatusDataMapper();
				$paidinvStatus = $invoiceStatusMapper->getInvoiceStatusByCode('PD');
				
				/* Get Subscription Renewal records */
				
				$getSubRenwDetailsObject = new Payments_Model_GetSubscriptionRenewalDetails();
				$getSubRenwDetailsObject->setsrbilling_fromdate($billingDate);
				$getSubRenwDetailsObject->setsrstatus($renewalStatus->getId());
				$getSubRenwDetailsObject->setrappmstatus($prfActStatusObj->getId());
				$getSubRenwDetailsObject->setanppstatus($prfActStatusObj->getId());
				$getSubRenwDetailsObject->setancpstatus($prfActStatusObj->getId());				
				
				$renewalMapperObject = new Payments_Model_SubscriptionRenewalMapper();
				$rowSet = $renewalMapperObject->RetrieveSubscriptionRenewalDetails($getSubRenwDetailsObject);
				
				/* Retrieve service tax */
				
				$serviceTax = 0;
		  		$serviceTaxResult = $this->getServiceTax();
		  		if($serviceTaxResult){
		  			foreach($serviceTaxResult as $taxResult){
		  				$serviceTax = $taxResult->servicetax;		
		  			}	
		  		}
				
				/* Retrieve transaction fee */							
				$transactionFee = 0;		  		
		  		$txnChargesResult = $this->getTransactionCharges('SUB_EC');
		  		
		  		if($txnChargesResult){
		  			foreach($txnChargesResult as $txnCharge){
		  				$transactionFee = $txnCharge->txncharge;
		  			}
		  		}
		  						
				if(count($rowSet) > 0){	
					
					$timeZone = 'EST5EDT';	
					date_default_timezone_set($timeZone);
					
					/* Mail object for sending email */					
					$mailmapper = new Application_Service_Notification();
										
					foreach($rowSet as $row){
						/* Initiate Transaction Process */					
						/* Create Invoice and Pdf */
						$anppid			   = "";
						$customerProfileId = "";
						$paymentProfileId  = "";
						$srid			   = "";
						$username		   = "";
						$useremail		   = "";
						$renewalPlanId     = "";
						/* info for sending email */
						$username  = $row->ancpprofile_description;
						$useremail = $row->ancpemail;
						
						$anppid			   = $row->anppid;
						$customerProfileId = $row->ancpcustomer_profile_id;
						$paymentProfileId  = $row->anpppayment_profile_id;
						$renewalPlanId     = $row->srplan_id;
						
						$invStatusMapper = new Application_Model_InvoiceStatusDataMapper();
						$unpaidinvStatus = $invStatusMapper->getInvoiceStatusByCode('UPD');
						
						$invoiceObj = new Payments_Model_Invoice();
									
						$invoiceGenDate = date('Y-m-d');
			 	 		$invoiceGenTime = date('h:i');
			 	 		
						$amount 	 = str_replace('$','',$row->sramount);
			 	 		$totalAmount = "";
			 	 		$serviceTaxTotal = "";
			 	 		
			 	 		$totalAmount 	 = round($amount + (($amount * $serviceTax)/100)+(($amount * $transactionFee)/100),2);
			 	 		$serviceTaxTotal = round($amount + (($amount * $serviceTax)/100),2);
			 	 		
			 	 		$restid = "";
			 	 		$restid = $row->srrestaurant_id;
			 	 		$srid   = $row->srid;
			 	 		
					 	$invoiceObj->setinvrestaurant_id($restid)		 	
					 	 		   ->setinvdescription($row->spplan_description)
					 	 		   ->setinvbilling_fromdate($row->srbilling_fromdate)
					 	 		   ->setinvbilling_todate($row->srbilling_todate)	
					 	 		   ->setinvamount(trim($amount))
					 	 		   ->setinvtotamount($totalAmount)
					 	 		   ->setinvservice_tax($serviceTax)
					 	 		   ->setinvservice_taxtotal($serviceTaxTotal)
					 	 		   ->setinvtxncharges($transactionFee)
					 	 		   ->setinvgenerated_date($invoiceGenDate)
					 	 		   ->setinvgenerated_time($invoiceGenTime)		 	 			
					 	 		   ->setinvstatus($unpaidinvStatus->getId());
					 	 		   
		 	 		     $invoiceMapper = new Payments_Model_InvoiceMapper();		 	 		    
					 	 $row = $invoiceMapper->CheckInvoiceGenerated($invoiceObj);
					 	 		 	 
					 	 if(!$row){
					 	 	$invoiceId = $invoiceMapper->CreateInvoice($invoiceObj);
					 	 	$invoiceObj->setinvid($invoiceId);		 	 	
					 	 }else{
					 	 	$invoiceObj->setinvid($row->invid);
					 	 }		 	 		    

		 	 		    /* Generate Invoice Pdf */		 	 		    
		 	 		    $invoiceObj->setcustprofid($customerProfileId);
	   				 	$invoiceObj->setpaymentprofid($paymentProfileId);
	   				 
	   				 	$pdfStatus = $this->GenerateInvoicePdf($invoiceObj);
		 	 		    
		 	 		    /* Initiate transaction */	   				 	
    			
						$authCapTransObj = new Payments_Model_AuthCaptureTransaction();
						$authCapTransObj->setCustProfId($customerProfileId)
										->setCustPaymentProfId($paymentProfileId)
										->setAmount($invoiceObj->getinvtotamount())
										->setInvoice($invoiceObj->getinvid())
										->setRecurringBilling(false);
						$authNetHelperObj = new Uss_Helper_AuthNetHelper();
						$response = $authNetHelperObj->CreateAuthCaptureTransaction($authCapTransObj);
						
						if($response['transcode'] == 'I00001'){
							
							$objectArray = array();
						
							$resServ = new Application_Service_Restaurant();
							$timeZone = $resServ->GetRestaurantTimeZone($restid);
							date_default_timezone_set($timeZone);
			 				$currentDate = date('Y-m-d');
			 				$currentTime = date('h:i');
							
							/* Prepare Transaction details object. */
			 				
							$transactionObject = new Payments_Model_Transactions();
							$transactionObject->settxnfk_restaurant($restid)
											  ->settxntransaction_id($response['transid'])
											  ->settxninvoice_number($invoiceObj->getinvid())
											  ->settxnpayment_profile_id($anppid)
											  ->settxntransaction_amount($invoiceObj->getinvtotamount())
											  ->settxntransaction_date($currentDate)
											  ->settxntransaction_time($currentTime)
											  ->settxndescription($invoiceObj->getinvdescription())
											  ->settxntransaction_type($debitTxn->getId())
											  ->settxnstatus($successfulTxn->getId());
											  
							$objectArray['txnObject'] = $transactionObject; 				  
		
							/* Prepare Subscription Paid details object  */
							
							$subscriptionPaidObject = new Payments_Model_SubscriptionPaid();
							$subscriptionPaidObject->setsubprestaurant_id($restid)										   
												   ->setsubpbilling_date($currentDate)
												   ->setsubpamount($invoiceObj->getinvamount())
												   ->setsubpplan_id($renewalPlanId)
												   ->setsubpbilling_fromdate($invoiceObj->getinvbilling_fromdate())
												   ->setsubpbilling_todate($invoiceObj->getinvbilling_todate())
												   ->setsubp_status($actSubPlanStatus->getId());
												   
							$objectArray['subPaidObj'] = $subscriptionPaidObject; 										   
												   
						   /* Prepare Subscription Renewal details object */ 										   
						   /* Calculate next billing date and amount */
		                   
						   /* Reterive Plan Detiails */
							$planDetailsObj = new Payments_Model_SubscriptionPlanDetailsByRestId();
							$planDetailsObj->setrppmrestaurant_id($restid);
							$planDetailsObj->setspplan_status($actSubPlanStatus->getId());
							$planDetailsObj->setrppmstatus($rppmActStatusObj->getId());
							$planMapperObj = new Payments_Model_SubscriptionPlansMapper();
				
						    $planRowSet = $planMapperObj->GetSubscriptionPlanDetailsByRestId($planDetailsObj);
		
						    $planId       = "";
						    $planDuration = ""; 
						    $subscriptionAmount = "";
						   
						    foreach($planRowSet as $planRow){
						      $planId 	          = $planRow->spid;
						   	  $planDuration       = $planRow->spplan_duration;
						   	  $subscriptionAmount = $planRow->spamount;
						    }
						   
					       /*$daysObject = new Payments_Model_CalculateDays();
					       $daysObject->setRestId($restid)
				 		     		  ->setPlanDuration($planDuration)
				 		    		  ->setFromDate($invoiceObj->getinvbilling_todate())
				 		   	 		  ->setAmount($subscriptionAmount);
		 	     
				 	 	   $result = array();			 		    						  
				 	 	   $result = $this->CalculateInvoiceAndAmount($daysObject);	
				 	 	   */
				 	 	   
				 	 	   $renewalFromDate = "";
						   $renewalToDate   = "";

						   $explodeCurrDate = explode('-',$invoiceObj->getinvbilling_todate());
						   $Year  = $explodeCurrDate[0];
						   $Month = $explodeCurrDate[1];
						   
						   $renewalFromDate = date('Y-m-d',mktime(0,0,0,$Month,15,$Year));
						   $renewalToDate = date('Y-m-d',mktime(0,0,0,$Month + $planDuration,14,$Year));
						   
						   $subscriptionRenewalObject = new Payments_Model_SubscriptionRenewal();
						   $renewStatus = $txnStatusMapper->getTransactionStatusByCode('RNW');
						   $subscriptionRenewalObject->setsrrestaurant_id($restid)	
						   							 ->setsrbilling_date($renewalFromDate)
						   							 ->setsramount($subscriptionAmount)
						   							 ->setsrplan_id($planId)
						   							 ->setsrbilling_fromdate($renewalFromDate)
						   							 ->setsrbilling_todate($renewalToDate)
						   							 ->setsrstatus($renewStatus->getId());
		
						 $objectArray['subRenewalObj'] = $subscriptionRenewalObject; 
		
						  /* Prepare Update Invoice object */
						  
						 $updateInvoiceStatusByIdObject  = new Payments_Model_UpdateInvoiceStatusById();
						 $updateInvoiceStatusByIdObject->setinvid($invoiceObj->getinvid())
						 							   ->setinvrestaurant_id($restid)
						 							   ->setinvstatus($paidinvStatus->getId());
		
						 $objectArray['updateInveStatusObj'] = $updateInvoiceStatusByIdObject; 				 				 							   

						 /* Prepare Update Sub Renewal Status object */
						 
						 $updateSubRenewalStatusObject = new Payments_Model_UpdateSubRenewalStatus();
						 $updateSubRenewalStatusObject->setsrid($srid);
						 $updateSubRenewalStatusObject->setsrstatus($successfulTxn->getId());
						 
						 $objectArray['updateSubRenewalStatusObj'] = $updateSubRenewalStatusObject;
						 
		   				 $transMapperObject = new Payments_Model_TransactionsMapper();
		   				 $status = $transMapperObject->saveTransactionDetails($objectArray);	

		   				 $InNumber = $invoiceObj->getinvid();
						 $mailObj = new Notification_Model_Mail();
						 $subject = 'Invoice-'.$InNumber.', Date:'.$currentDate;
						 $path = 'managerest/'.$restid.'/invoice/'.$invoiceObj->getinvid().'.pdf';
					     
						 $mailObj->setMsgCode('Invoice');
					     
						 $maildata = array('UserName' => $username,
								  		   'subject'  => $subject,
								  		   'path'	  => $path,
								  		   'SenTo'    => $useremail);
						$mailObj->setData($maildata);
					    
					    $mailStatus = $mailmapper->SendMail($mailObj); 				 
		   				 
						
						}else{							
							$resservice = new Application_Service_Restaurant();
							$restaurantName = $resservice->GetRestaurantNamesById($restid);
			
							
							$mailObj = new Notification_Model_Mail();
							$mailObj->setMsgCode('Declined trnsaction');
							
							$maildata = array('UserName' => $username,
									  		  'SenTo'    => $useremail);
							
							$mailObj->setData($maildata);
							$mailStatus = $mailmapper->SendMail($mailObj);
						}
									
					}												
				}
				return $status;
			}
				
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function GenerateInvoiceByInvoiceId($invoice_id) {
		try{
			$rowSet = '';

			/* Retrieve service tax */
                        $serviceTax = 0;
                        $serviceTaxResult = $this->getServiceTax();
                        if($serviceTaxResult){
 	                       foreach($serviceTaxResult as $taxResult){
        	                       $serviceTax = $taxResult->servicetax;
                               }
                        }

                        /* Retrieve transaction fee */
                        $transactionFee = 0;
                        $txnChargesResult = $this->getTransactionCharges('SUB_EC');
                        if($txnChargesResult){
                               foreach($txnChargesResult as $txnCharge){
                                       $transactionFee = $txnCharge->txncharge;
                               }
                        }

			if($rowSet) {
				foreach($rowSet as $row) {
					$invoiceObj = new Payments_Model_Invoice();
					$invoiceGenDate = date('Y-m-d');
                                        $invoiceGenTime = date('h:i');
                                        $amount          = str_replace('$','',$row->sramount);
                                        $totalAmount = "";
                                        $serviceTaxTotal = "";
                                        $totalAmount     = round($amount + (($amount * $serviceTax)/100)+(($amount * $transactionFee)/100),2);
                                        $serviceTaxTotal = round($amount + (($amount * $serviceTax)/100),2);

                                        $restid = "";
					$restid = $row->srrestaurant_id;
					$srid   = $row->srid;

                                        $invoiceObj->setinvrestaurant_id($restid)
                                                   ->setinvdescription($row->spplan_description)
                                                   ->setinvbilling_fromdate($row->srbilling_fromdate)
                                                   ->setinvbilling_todate($row->srbilling_todate)
                                                   ->setinvamount(trim($amount))
                                                   ->setinvtotamount($totalAmount)
                                                   ->setinvservice_tax($serviceTax)
                                                   ->setinvservice_taxtotal($serviceTaxTotal)
                                                   ->setinvtxncharges($transactionFee)
                                                   ->setinvgenerated_date($invoiceGenDate)
                                                   ->setinvgenerated_time($invoiceGenTime)
                                                   ->setinvstatus($unpaidinvStatus->getId());

                                         $invoiceMapper = new Payments_Model_InvoiceMapper();
                                         $row = $invoiceMapper->CheckInvoiceGenerated($invoiceObj);

                                         if(!$row){
                                         	$invoiceId = $invoiceMapper->CreateInvoice($invoiceObj);
                                                $invoiceObj->setinvid($invoiceId);
                                         }else{
                                                $invoiceObj->setinvid($row->invid);
                                         }
				}
			}

		} catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage());
		}
	}
	
	public function GenerateInvoicesForSubscriptionRenewal($request)
	{
		try{
			if($request){
				$status = false;
				$billingDate = 	$request->billingdate;
				
			    /* Base Data objets */
				$profileStatusMapper = new Application_Model_ProfileStatusDataMapper();
				$prfActStatusObj = $profileStatusMapper->getProfileStatusByCode('ACT');
				
				$restPaymentPlanStatusMapper = new Application_Model_RestPaymentPlanStatusDataMapper();
				$rppmActStatusObj = $restPaymentPlanStatusMapper->getRestPaymentPlanStatusByCode('ACT');
				
				$txnStatusMapper = new Application_Model_TransactionStatusDataMapper();							
				$renewalStatus = $txnStatusMapper->getTransactionStatusByCode('RNW');
								
				/* Get Subscription Renewal records */
				
				$getSubRenwDetailsObject = new Payments_Model_GetSubscriptionRenewalDetails();
				$getSubRenwDetailsObject->setsrbilling_fromdate($billingDate);
				$getSubRenwDetailsObject->setsrstatus($renewalStatus->getId());
				$getSubRenwDetailsObject->setrappmstatus($prfActStatusObj->getId());
				$getSubRenwDetailsObject->setanppstatus($prfActStatusObj->getId());
				$getSubRenwDetailsObject->setancpstatus($prfActStatusObj->getId());				
				
				$renewalMapperObject = new Payments_Model_SubscriptionRenewalMapper();
				$rowSet = $renewalMapperObject->RetrieveSubscriptionRenewalDetails($getSubRenwDetailsObject);
				
				/* Retrieve service tax */
				
				$serviceTax = 0;
		  		$serviceTaxResult = $this->getServiceTax();
		  		if($serviceTaxResult){
		  			foreach($serviceTaxResult as $taxResult){
		  				$serviceTax = $taxResult->servicetax;		
		  			}	
		  		}
				
				/* Retrieve transaction fee */							
				$transactionFee = 0;		  		
		  		$txnChargesResult = $this->getTransactionCharges('SUB_EC');
		  		
		  		if($txnChargesResult){
		  			foreach($txnChargesResult as $txnCharge){
		  				$transactionFee = $txnCharge->txncharge;
		  			}
		  		}
		  		
		  		if(count($rowSet) > 0){	
		  			$timeZone = 'EST5EDT';	
					date_default_timezone_set($timeZone);
					foreach($rowSet as $row){
						/* Create Invoice and Pdf */
						$anppid			   = "";
						$customerProfileId = "";
						$paymentProfileId  = "";
						$srid			   = "";
						$username		   = "";
						$useremail		   = "";
						$renewalPlanId     = "";
						/* info for sending email */
						$username  = $row->ancpprofile_description;
						$useremail = $row->ancpemail;
						
						$anppid			   = $row->anppid;
						$customerProfileId = $row->ancpcustomer_profile_id;
						$paymentProfileId  = $row->anpppayment_profile_id;
						$renewalPlanId     = $row->srplan_id;
						
						$invStatusMapper = new Application_Model_InvoiceStatusDataMapper();
						$unpaidinvStatus = $invStatusMapper->getInvoiceStatusByCode('UPD');
						
						$invoiceObj = new Payments_Model_Invoice();
									
						$invoiceGenDate = date('Y-m-d');
			 	 		$invoiceGenTime = date('h:i');
			 	 		
						$amount 	 = str_replace('$','',$row->sramount);
			 	 		$totalAmount = "";
			 	 		$serviceTaxTotal = "";
			 	 		
			 	 		$totalAmount 	 = round($amount + (($amount * $serviceTax)/100)+(($amount * $transactionFee)/100),2);
			 	 		$serviceTaxTotal = round($amount + (($amount * $serviceTax)/100),2);
			 	 		
			 	 		$restid = "";
			 	 		$restid = $row->srrestaurant_id;
			 	 		$srid   = $row->srid;
			 	 		
					 	$invoiceObj->setinvrestaurant_id($restid)		 	
					 	 		   ->setinvdescription($row->spplan_description)
					 	 		   ->setinvbilling_fromdate($row->srbilling_fromdate)
					 	 		   ->setinvbilling_todate($row->srbilling_todate)	
					 	 		   ->setinvamount(trim($amount))
					 	 		   ->setinvtotamount($totalAmount)
					 	 		   ->setinvservice_tax($serviceTax)
					 	 		   ->setinvservice_taxtotal($serviceTaxTotal)
					 	 		   ->setinvtxncharges($transactionFee)
					 	 		   ->setinvgenerated_date($invoiceGenDate)
					 	 		   ->setinvgenerated_time($invoiceGenTime)		 	 			
					 	 		   ->setinvstatus($unpaidinvStatus->getId());
					 	 		   
		 	 		     $invoiceMapper = new Payments_Model_InvoiceMapper();		 	 		    
					 	 $row = $invoiceMapper->CheckInvoiceGenerated($invoiceObj);
					 	 		 	 
					 	 if(!$row){
					 	 	$invoiceId = $invoiceMapper->CreateInvoice($invoiceObj);
					 	 	$invoiceObj->setinvid($invoiceId);		 	 	
					 	 }else{
					 	 	$invoiceObj->setinvid($row->invid);
					 	 }		 	 		    

		 	 		    /* Generate Invoice Pdf */		 	 		    
		 	 		    $invoiceObj->setcustprofid($customerProfileId);
	   				 	$invoiceObj->setpaymentprofid($paymentProfileId);
	   				 
	   				 	$pdfStatus = $this->GenerateInvoicePdf($invoiceObj);
					}
		  		}				
			}	
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	This function is used to send pending or renewal payment notifications to restaurant owners
 	*/
	public function ManagePaymentDueNotification($request)
	{
		try{
			if($request){
				$status = false;
				$billingDate = $request->billingdate;
				
				 /* Base Data objets */
				$profileStatusMapper = new Application_Model_ProfileStatusDataMapper();
				$prfActStatusObj = $profileStatusMapper->getProfileStatusByCode('ACT');
				
				$restPaymentPlanStatusMapper = new Application_Model_RestPaymentPlanStatusDataMapper();
				$rppmActStatusObj = $restPaymentPlanStatusMapper->getRestPaymentPlanStatusByCode('ACT');
				
				$txnStatusMapper = new Application_Model_TransactionStatusDataMapper();							
				$renewalStatus = $txnStatusMapper->getTransactionStatusByCode('RNW');
								
				/* Get Subscription Renewal records */
				
				$getSubRenwDetailsObject = new Payments_Model_GetSubscriptionRenewalDetails();
				$getSubRenwDetailsObject->setsrbilling_fromdate($billingDate);
				$getSubRenwDetailsObject->setsrstatus($renewalStatus->getId());
				$getSubRenwDetailsObject->setrappmstatus($prfActStatusObj->getId());
				$getSubRenwDetailsObject->setanppstatus($prfActStatusObj->getId());
				$getSubRenwDetailsObject->setancpstatus($prfActStatusObj->getId());				
				
				$renewalMapperObject = new Payments_Model_SubscriptionRenewalMapper();
				$rowSet = $renewalMapperObject->RetrieveSubscriptionRenewalDetails($getSubRenwDetailsObject);
				
				if(count($rowSet) > 0){
					$mailmapper = new Application_Service_Notification();
					$mailObj = new Notification_Model_Mail();
					$mailObj->setMsgCode('Sub-Rnw');
					
					foreach($rowSet as $row){
						
						$username  = $row->ancpprofile_description;
						$useremail = $row->ancpemail;
						$amount    = $row->spamount;
						$date      = $row->srbilling_date;
						
						$maildata = array('UserName' => $username,
									  	  'SenTo'    => $useremail,
										  'Amount'   => $amount,
										  'Date'     => $date);
							
						$mailObj->setData($maildata);
						$mailStatus = $mailmapper->SendMail($mailObj);						
					}	
				}
				
			 }
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetPaymentProfByUserId()
	{
		try{
			$storage   = new Zend_Auth_Storage_Session();
			$data 	   = $storage->read();
			$userid    = $data['User_Id'];
			$profMapMapper = new Payments_Model_RestAuthnetPaymentProfileMapMapper();
			$rowSet = $profMapMapper->getRestPaymentProfiles($userid);
			return $rowSet;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function updatePaymentProfile($request)
	{
		try{
			$storage   = new Zend_Auth_Storage_Session();
			$data 	   = $storage->read();
			$userid    = $data['User_Id'];
			$restid    = $request->restaurantid;
			$anppid    = $request->anppid;
			
			/* Reterieve restaurant timezone for date and time */
			$resServ  = new Application_Service_Restaurant();
			$timeZone = $resServ->GetRestaurantTimeZone($restid);
			date_default_timezone_set($timeZone);
 			$currentDate = date('Y-m-d');
 			$currentTime = date('h:i');
			
 			$profileStatusMapper = new Application_Model_ProfileStatusDataMapper();
			$prfActStatusObj 	 = $profileStatusMapper->getProfileStatusByCode('ACT');
			$prfInActStatusObj 	 = $profileStatusMapper->getProfileStatusByCode('INA');
			
 			
			$paymentProfileMapObject = new Payments_Model_RestAuthnetPaymentProfileMap(); 
			$paymentProfileMapObject->setrappmrestaurant_id($restid)
									->setrappmpayment_profile_id($anppid)
									->setcreatedby($userid)
									->setrappmstatus($prfActStatusObj->getId())
									->setrappminactivestatus($prfInActStatusObj->getId())
									->setcreateddate($currentDate)
									->setcreatedtime($currentTime)
									->setupdatedby($userid)
									->setupdateddate($currentDate)
									->setupdatedtime($currentTime);
									
			$profileMapMapperObject = new Payments_Model_RestAuthnetPaymentProfileMapMapper();
			$status = $profileMapMapperObject->updatePaymentProfile($paymentProfileMapObject);
			return $status;
			
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
		
	}
	
	public function ManagePaymentSettings(array $data,$userData,$request)
	{
		try{
			$operation = $request->formStat;
			switch($operation){
				case 'ADD':
					$form = $this->getManagePaymentSettingsForm();
					$restService = new Application_Service_Restaurant();
					if($form->isValid($data)){
						$formData = $form->getValues($data);
						$payment = new Payments_Model_RestaurantPaymentSettings();
						$paymentMapper = new Payments_Model_RestaurantPaymentSettingsMapper();
						$payment->setRestaurantId($formData['restaurantName'])
								->setAmount($formData['amount'])
								->setReservationPax($formData['partysize'])
								->setSettingName($formData['settingName'])
								->setSettingType($formData['settingType'])
								->setSettingDate($formData['settingDate'])
								->setSettingEndDate($formData['settingDateEnd'])
								->setNoShowType($formData['noshowType'])
								->setDescription($formData['paymentdesc'])
								->setStatus(true);
								
						$timeZone = $restService->GetRestaurantTimeZone($formData['restaurantName']);
						date_default_timezone_set($timeZone);
						$payment->setCreatedBy($userData['User_Id'])
								->setCreatedOn(date('Y-m-d H:i:s'))
								->setUpdatedBy($userData['User_Id'])
								->setUpdatedOn(date('Y-m-d H:i:s'));
								
						$result = $paymentMapper->addPaymentSettings($payment);
						if($result){
							return array('formStatus'=>'success','result'=>$result);
						}else{
							$form = $this->getManagePaymentSettingsForm();
							if($userData['Usertype'] == "RSO" || $userData['Usertype'] == "ADM" || $userData['Usertype'] == "ADU"){
								$restNameList = $restService->GetRestNameById($userData);
							}else if($userData['Usertype'] == "RSU"){
								$restNameList = $restService->GetRestNameById($userData);
							}
							
							$form->restaurantName->addMultiOptions($restNameList);
							
							return array('formStatus'=>'Duplicate','result'=>$form);
						}
					}else{
						if($userData['Usertype'] == "RSO" || $userData['Usertype'] == "ADM" || $userData['Usertype'] == "ADU"){
							$restNameList = $restService->GetRestNameById($userData);
						}else if($userData['Usertype'] == "RSU"){
							$restNameList = $restService->GetRestNameById($userData);
						}
						$form->restaurantName->addMultiOptions($restNameList);
						
						
						return array('formStatus'=>'error','result'=>$form);
					}
				break;
				case 'EDIT':
					$form = $this->getEditPaymentSettingsForm();
					$restService = new Application_Service_Restaurant();
					if($form->isValid($data)){
						$formData = $form->getValues($data);
						$payment = new Payments_Model_RestaurantPaymentSettings();
						$paymentMapper = new Payments_Model_RestaurantPaymentSettingsMapper();
						$payment->setId($formData['payid'])
								->setRestaurantId($formData['resid'])
								->setAmount($formData['editamount'])
								->setSettingName($formData['editsettingName'])
								->setSettingType($formData['editsettingType'])
								->setSettingDate($formData['editsettingDate'])
								->setSettingEndDate($formData['editsettingDateEnd'])
								->setReservationPax($formData['editpartysize'])
								->setDescription($formData['editpaymentdesc'])
								->setStatus(true);
						$timeZone = $restService->GetRestaurantTimeZone($formData['resid']);
						date_default_timezone_set($timeZone);
						$payment->setUpdatedBy($userData['User_Id'])
								->setUpdatedOn(date('Y-m-d H:i:s'));
								
						$result = $paymentMapper->EditPaymentSettings($payment);
						if($result){
							return array('formStatus'=>'update','result'=>$result);
						}
					}else{
						
						return array('formStatus'=>'error','result'=>$form);
					}
				break;
			}
			
			
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function GetPaymentSettings($data)
	{
		try{
			$OwnIdObj = new ManageRestaurant_Model_RestaurantByOwnerId();
			if($data['Usertype'] == "ADM" || $data['Usertype'] == "ADU"){
				$OwnIdObj->setResOwnerId($data['restownerId']);
			}else{
				$OwnIdObj->setResOwnerId($data['User_Id']);
			}
			
			$mapper = new ManageRestaurant_Model_RestaurantDataMapper();
			$restIdsList = $mapper->getRestaurantIdsByOwnerId($OwnIdObj);
			
			$paymentMapper = new Payments_Model_RestaurantPaymentSettingsMapper();
			$paymentDetails = $paymentMapper->GetPaymentSettings($restIdsList);
			return $paymentDetails;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function updatePaymentSettingStatus($request)
	{
		try{
			$payment = new Payments_Model_RestaurantPaymentSettings();
			if($request->paymentStatus){
				$stat = true;
			}else{
				$stat = 0;
			}
			$payment->setRestaurantId($request->resid)
					->setId($request->paysettingid)
					->setStatus($stat);
					
			$mapper = new Payments_Model_RestaurantPaymentSettingsMapper();
			$result = $mapper->UpdatePaymentSettingStatus($payment);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetRestaurantPaymentSettingsByResId($resid,$date)
	{
		try{
			$mapper = new Payments_Model_RestaurantPaymentSettingsMapper();
			$result = $mapper->GetPaymentSettingsByResId($resid,$date);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function Manage_Customer_Registration_On_Reservation(Ums_Model_Customer  $customer)
	{
		Uss_Logger_FileLogger::info(print_r($customer,true));
		try{
			$mapper  	   = new Payments_Model_AuthnetCustomerProfileMapper();
			$paymentMapper = new Payments_Model_AuthnetPaymentProfileMapper();
			$authHelperObj = new Uss_Helper_AuthNetHelper();
			
			$authNet_Cust_ProfId = "";
		    $ancpid				 = "";
		    $result 		     = array();
		    
		    $userMapper = new Ums_Model_UserDataMapper();
		    $userDetails = $userMapper->getUsertypeidByemail($customer->getEmail());
		   
		    	/* Check Whether Rest Owner has Authorized.Net Customer Profile */	    
			    $getAuthNetCustProfObj = new Payments_Model_GetAuthNetCustProfId();
			    $getAuthNetCustProfObj->setancpuser_id($customer->getUserid());
			    
			    $profileStatusMapper = new Application_Model_ProfileStatusDataMapper();
				$prfActStatusObj = $profileStatusMapper->getProfileStatusByCode('ACT');
				$prfInaStatusObj = $profileStatusMapper->getProfileStatusByCode('INA');
			    
		        $row = $mapper->GetAuthNetCustProfIdByUserId($getAuthNetCustProfObj);
			    if($row){
			    	$ancpid				 = $row->ancpid;
			    	$authNet_Cust_ProfId = $row->ProfileId;	
			    }
			    /* If no Profiles are found create a new Authorized.Net Customer profile */
			    if(!$authNet_Cust_ProfId){
		        /* Create Auth Net Customer Profile */
		
		         $custProfObj = new Payments_Model_AuthnetCustomerProfile();
		         $custProfObj->setancpuser_id($customer->getUserid())
		                     ->setancpprofile_description($userDetails['Firstname']." ".$userDetails['LastName'])
		                     ->setancpemail($customer->getEmail());
		
		         
			     $authNet_Cust_ProfId = $authHelperObj->CreateCustomerProfileRequest($custProfObj);
			     if($authNet_Cust_ProfId){
			     	/* Save Authorized.Net Customer Profile */
	
			     	date_default_timezone_set('EST5EDT'); 
				 	$date = date('Y-m-d');
				 	$time = date('h:i:s');
				 	
				 	$custProfObj->setancpcustomer_profile_id($authNet_Cust_ProfId);
				 	$custProfObj->setancpcreated_date($date);
				 	$custProfObj->setancpcreated_time($time);
				 	$custProfObj->setancpstatus($prfActStatusObj->getId());
			     	$ancpid = $mapper->SaveAuthNetCusomerProfile($custProfObj);	     	
			     	
			      }	      	
			    }
				$result['CustProfId'] = $authNet_Cust_ProfId;
				
				/* Check The Customer has payment profiles created */
				
				$paymentProfObj = new Payments_Model_GetAuthNetPaymentProfId();
				$paymentProfObj->setancpcustomer_profile_id($authNet_Cust_ProfId)
							   ->setancpstatus($prfActStatusObj->getId())
							   ->setanppstatus($prfActStatusObj->getId());
			   	 
				$resultSet = $paymentMapper->GetAuthNetPaymentProfIdByCustProfId($paymentProfObj);
				$custProfReq = array();
				$paymentProfileId = array();
				$paymentProfileType = array();
				$custProfReq = $authHelperObj->GetCustomerProfileRequest($authNet_Cust_ProfId);
				
				foreach($custProfReq as $key => $value){
					$paymentProfileId[] = $key;
					$paymentProfileType[$key] = $value['paymentType'];
				}
				
				$paymentIdObj = new Payments_Model_AuthnetPaymentProfile();
				date_default_timezone_set('EST5EDT');
			 	$date = date('Y-m-d');
			 	$time = date('h:i:s');
				$paymentIdObj->setanppcustomer_profile_id($ancpid);
				$paymentIdObj->setanppcreated_date($date);
				$paymentIdObj->setanppcreated_time($time);
				$paymentIdObj->setanpppayment_type($paymentProfileType);
				$paymentIdObj->setanppstatus($prfActStatusObj->getId());
				
				if(!count($resultSet) > 0){
					
					if(count($paymentProfileId) > 0){/* Save Payment Profile Id's*/
						
						$paymentIdObj->setanpppayment_profile_id($paymentProfileId);	
						$status = $paymentMapper->SavePaymentProfiles($paymentIdObj);					
						if($status){
							$resultSet = $paymentMapper->GetAuthNetPaymentProfIdByCustProfId($paymentProfObj);
						}
					}			
				}else if(count($resultSet) > 0 && count($paymentProfileId) > 0){
					
					/*Check Whether id's are new payment profile id's*/				
					$profileIdArray		   = array();
					$ureservSavedProfIdArr = array();
							
					
					foreach($resultSet as $results){
						$ureservSavedProfIdArr[] = $results->anpppayment_profile_id; 
					}				
					
					$profileIdArray['ureservSavedProfId'] = $ureservSavedProfIdArr;
					$profileIdArray['authNetProfId'] 	  = $paymentProfileId;
					$comparedArrs = array();				
					$comparedArrs = $this->ComparePaymentProfileIds($profileIdArray);
	
					if(count($comparedArrs) > 0 && count($comparedArrs['authNetNewProfId']) > 0){
						$paymentIdObj->setanpppayment_profile_id($comparedArrs['authNetNewProfId']);	
						$status = $paymentMapper->SavePaymentProfiles($paymentIdObj);					
						if($status){
							$resultSet = $paymentMapper->GetAuthNetPaymentProfIdByCustProfId($paymentProfObj);
						}
					}
					
					if(count($comparedArrs) > 0 && count($comparedArrs['authNetDeletedProfId']) > 0){
						$deletepaymentProfObj = new Payments_Model_DeletePaymentProfile();
						$deletepaymentProfObj->setPayemntProfId($comparedArrs['authNetDeletedProfId']);
						$deletepaymentProfObj->setStatus($prfInaStatusObj->getId());					
						$paymentMapper->DeletePaymentProfiles($deletepaymentProfObj);
						$resultSet = $paymentMapper->GetAuthNetPaymentProfIdByCustProfId($paymentProfObj);					
					}			
					
				}else if(count($resultSet) > 0 && count($paymentProfileId) == 0){
					$profileIdArray		   = array();
					$ureservSavedProfIdArr = array();
							
					
					foreach($resultSet as $results){
						$ureservSavedProfIdArr[] = $results->anpppayment_profile_id; 
					}				
					
					$profileIdArray['ureservSavedProfId'] = $ureservSavedProfIdArr;
					$profileIdArray['authNetProfId'] 	  = $paymentProfileId;
					$comparedArrs = array();				
					$comparedArrs = $this->ComparePaymentProfileIds($profileIdArray);
					
					$deletepaymentProfObj = new Payments_Model_DeletePaymentProfile();
					$deletepaymentProfObj->setPayemntProfId($comparedArrs['authNetDeletedProfId']);
					$deletepaymentProfObj->setStatus($prfInaStatusObj->getId());				
					$paymentMapper->DeletePaymentProfiles($deletepaymentProfObj);
					$resultSet = $paymentMapper->GetAuthNetPaymentProfIdByCustProfId($paymentProfObj);
				}
				
				$result['PaymentProfiles'] = $resultSet;
				$result['CC_AC_Details']   = $custProfReq;
		    
		    return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage());
		} 
	}
	
	public function ManagePaidReservations($bokid,$resid,$paymentStatus,$from)
	{
		try{
			$bookServ = new Application_Service_Booking();
			$bookingDetails = $bookServ->GetBookingDetails($bokid);
			$stateId = '';
			$restService = new Application_Service_Restaurant();
			$restResult = $restService->GetRestaurantDetailsById($resid);
			$mailmapper = new Application_Service_Notification();
			$status = false;
			$paymentId = array();
			$paymentProfResult = $paymentStatus['PaymentProfiles'];
	   		if($paymentProfResult){
	   			foreach($paymentProfResult as $row){
	   				$paymentId[] = $row->anppid;
	   			}
	   		}
		
			if($paymentId){
				if($bookingDetails->getNotificationType() == 'email' || $bookingDetails->getNotificationType() == 'both'){
					$mailObj = new Notification_Model_Mail();
					$mailObj->setMsgCode('BookConf');
					if($stateId == ""){
						$stateCity = $bookServ->getRestaurantStateByResId($resid);
						$stateId = $stateCity['state'];
						$cityId = $stateCity['city'];
						$regionId = $stateCity['region'];
						
					}
					$userType = 'CUS';
					$adminService = new Application_Service_Admin();
					$campProp = new Application_Model_GetCampaignForPost();
					$campProp->setAudType($userType)
							 ->setStateId($stateId)
							 ->setCityId($cityId)
							 ->setRegionId($regionId)
							 ->setIsAjaxCall(false);
					$campDetails = $adminService->GetCampaignDetails($campProp);
					
					$name = $bookingDetails->getbokfirst_name().' '.$bookingDetails->getboklast_name();
					$date = $bookingDetails->getbokbooking_date();
								$dateSplit = explode("-",$date);
								$newDate = $dateSplit[1]."-".$dateSplit[2]."-".$dateSplit[0];
								
								
					$resDataMapper = new ManageRestaurant_Model_RestaurantDataMapper();
					$restObj= new ManageRestaurant_Model_RestaurantById();
					$restObj->setRestaurantId($resid);
					$resDetails = $resDataMapper->getRestaurantById($restObj);
					
					$data = array('UserName' => $name,
							  'SenTo'    => $bookingDetails->getbokemail(),
							  'RestName' => $restResult->resrestaurant_name,
							  'ResDate'  => $newDate,
							  'Time'     => $bookingDetails->getbokbooking_timings(),
							  'Size'     => $bookingDetails->getbokparty_size(),
							  'Address'	 => $restResult->resaddress,
							  'resphone' => $restResult->resphone,
							  'Bokid'	 =>	$bokid,
							  'State_Id' =>	$stateId,
							  'City_Id'	 =>	$cityId,
							  'UserType' =>	$userType,
							  'rescity'	=>	$resDetails->getRestCityDesc(),
							  'resnbh'	=>	$resDetails->getRestNeighborDesc(),
							  'reszipcode' =>	$resDetails->getRestzipcode()	
					);
					$data['splstatus']	= false;
					if(count($campDetails)){
						$count = count($campDetails);
						if($count > 1){
							$campaign = $campDetails[rand(0,$count-1)];
						}else{
							$campaign = $campDetails[0];
						}
						$notfService = new Application_Service_Notification();
						$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
						$data['campaignName'] = trim($campaign->getSponsor());
						$data['campaignDesc'] =	trim($campaign->getCampDesc());
						$data['campaignImg'] =	trim($campaign->getCampImage());
						$data['campId']	= $campaign->getId();
					}
					
					$mailObj->setData($data);
					$mailStatus = $mailmapper->SendMail($mailObj);
					if($from == 'customer'){
						$mapper = new Booking_Model_BookingDataMapper();
						$restInfo = $mapper->ReterieveRestInfo($resid);
						if($restInfo){
							if($stateId == ""){
								$stateCity = $this->getRestaurantStateByResId($resid);
								$stateId = $stateCity['state'];
								$cityId = $stateCity['city'];
								$regionId = $stateCity['region'];
								
							}
							$userType = 'RES';		
							
							$adminService = new Application_Service_Admin();
							if($resDetails->getrescampaignstatus()){
								$campProp = new Application_Model_GetCampaignForPost();
								$campProp->setAudType($userType)
										 ->setStateId($stateId)
										 ->setCityId($cityId)
										 ->setRegionId($regionId)
										 ->setIsAjaxCall(false);
								$campDetails = $adminService->GetCampaignDetails($campProp);
							}else{
								$campDetails = array();
							}
							if($restInfo->resnotification && $restInfo->resemail){
								$restEmail = array($restInfo->resemail);
								$mailObj->setMsgCode('BookNotf');
								$name = $bookingDetails->getbokfirst_name().' '.$bookingDetails->getboklast_name();								
								
								$data = array(
										  'UserName' 			=> 	$name,
										  'SenTo'    			=> 	$restEmail,
										  'RestName'			=> 	$restResult->resrestaurant_name,
										  'ResDate'  			=> 	$newDate,
										  'Time'     			=> 	$bookingDetails->getbokbooking_timings(),
										  'email'	 			=> 	$bookingDetails->getbokemail(),
										  'phone'	 			=> 	$bookingDetails->getbokphone(),	
										  'Size'     			=> 	$bookingDetails->getbokparty_size(),
										  'Address'	 			=> 	$restResult->resaddress,
										  'Note'	 			=>	$bookingDetails->getbokspecial_request(),
										  'Bookid'	 			=> 	$bokid,
										  'State_Id'			=>	$stateId,
										  'City_Id'				=>	$cityId,
										  'UserType'			=>	$userType,
							  			  'rescity'	=>	$resDetails->getRestCityDesc(),
							  			  'resnbh'	=>	$resDetails->getRestNeighborDesc(),
							  			  'reszipcode' =>	$resDetails->getRestzipcode());
								
							
								if(count($campDetails)){
									$count = count($campDetails);
									if($count > 1){
										$campaign = $campDetails[rand(0,$count-1)];
									}else{
										$campaign = $campDetails[0];
									}
									$notfService = new Application_Service_Notification();
									$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
									$data['campaignName'] = trim($campaign->getSponsor());
									$data['campaignDesc'] =	trim($campaign->getCampDesc());
									$data['campaignImg'] =	trim($campaign->getCampImage());
									$data['campId']	= $campaign->getId();
								}
								$mailObj->setData($data);
								$mailStatus = $mailmapper->SendMail($mailObj);
							}
						}
					//
						$restservice = new Application_Service_Restaurant();
						$timeZone = $restservice->GetRestaurantTimeZone($resid);
						date_default_timezone_set($timeZone);

						/* Reterieve Phone Notify Details */
						if($bookingDetails->getbokbooking_status_code() == 'RSD'){
								
							$restPhoneInfo = $restservice->getRestaurantPhoneDetails($resid);
								
							$splitbookdate   = explode('-',$bookingDetails->getbokbooking_date());
								
							$bookingdate   = $bookingDetails->getbokbooking_date();
							$todaydate     = date('Y-m-d');
								
							if(strtotime($bookingdate) == strtotime($todaydate)){
								
								/* get day of week */
								$weekday = date('D',mktime(0,0,0,$splitbookdate[1],$splitbookdate[2],$splitbookdate[0]));
								
								$restNotifyTimesObject = new ManageRestaurant_Model_RestNotifyTimes();
								$restNotifyTimesObject->setrntfk_restaurants($resid);
								$restNotifyTimesObject->setrntnotify_week_day(strtolower($weekday));
								
								$restNotifyTimesMapperObject = new ManageRestaurant_Model_RestNotifyTimesMapper();
								$phoneRow = $restNotifyTimesMapperObject->retrievePhoneNotifyNumber($restNotifyTimesObject);
								
								if($phoneRow){
																											
									$phonenumber = "";
									$fromtime    = "";
									$totime		 = "";
									$resvTime    = date("H:i",time());
									
									$phonenumber = $phoneRow->rntphone;
									$fromtime    = $phoneRow->rntnotify_from_time;
									$totime		 = $phoneRow->rntnotify_to_time;
									
									if($phonenumber){
										
										if(strtotime($resvTime)>= strtotime($fromtime) && strtotime($resvTime)<= strtotime($totime)){
											$mailObj = new Notification_Model_Mail();
											$mailObj->setMsgCode('BookNotf');
												
											$data = array('PhoneNumber'  => $phonenumber,
													  	  'RestName'     => $bookingDetails->getresrestaurant_name(),
													  	  'ResvDate'	 => $bookingDetails->getbokbooking_date(),
													  	  'ResvTime'	 => $bookingDetails->getbokbooking_timings(),
													  	  'Pax'			 => $bookingDetails->getbokparty_size(),
													  	  'ResvPhone'	 => $bookingDetails->getbokphone(),
													  	  'Note'	 	 =>	$bookingDetails->getbokspecial_request(),
													  	  'Firstname' 	 => $bookingDetails->getbokfirst_name(),
													  	  'Lastname'	 => $bookingDetails->getboklast_name());
												
											$mailObj->setData($data);
											$status = $mailmapper->PhoneNotify($mailObj);
												
										}
									}									
								}
							}						

							if($restPhoneInfo['smsnotify']){
								$phoneRowSet = $restPhoneInfo['rowset'];
								$phonenumber = "";
								$fromtime    = "";
								$totime		 = "";
								$resvTime    = $bookingDetails->getbokbooking_timings();

								if($phoneRowSet){
									foreach($phoneRowSet as $phoneNum){
										if($phoneNum->rntnotify_type == 'sms'){
											$phonenumber = $phoneNum->rntphone;
											$fromtime    = $phoneNum->rntnotify_from_time;
											$totime		 = $phoneNum->rntnotify_to_time;
										}
									}
									if($phonenumber){
										if(strtotime($resvTime)>= strtotime($fromtime) && strtotime($resvTime)<= strtotime($totime)){
											$smsObj = new Notification_Model_Sms();
											$smsObj->setMsgCode('BookNotf');

											$data = array('to' 		 	 => $phonenumber,
														  'bokid'    	 => $bokid,
														  'RestName' 	 => $bookingDetails->getresrestaurant_name(),
														  'ResDate'	 	 => $bookingDetails->getbokbooking_date(),
														  'Time'		 => $bookingDetails->getbokbooking_timings(),
														  'Size'		 => $bookingDetails->getbokparty_size(),
														  'CustomerName' => $bookingDetails->getbokfirst_name().' '.$bookingDetails->getboklast_name());

											$smsObj->setData($data);
											$mailStatus = $mailmapper->SendSms($smsObj);

										}
									}
								}
							}
						}	
						///
					}
					$status = true;
				}
			}else{
				if($bookingDetails->getbokbooking_type_code() == 'PAID' || $bookingDetails->getbokbooking_type_code() == 'SPLPAID'){
					$bokStatusCode = 'CAN';
					$bookStatusMapper = new Application_Model_BookingStatusDataMapper();
					$status = $bookingDetails->getbokbooking_status_code();
					$bookStatus 	  = $bookStatusMapper->GetBookingStatusByCode(array($bokStatusCode));
					$bookStatusObj 	  = $bookStatus[$bokStatusCode];
					$bookingObj = new Booking_Model_Booking();
					$bookingObj->setbokid($bokid);
					$bookingObj->setbokbooking_status_id($bookStatusObj->getId());
					$bookingObj->setbokbooking_status_desc($status);
					$bookingObj->setInventoryId($bookingDetails->getInventoryId());
					$bookingObj->setbokfk_restaurant($resid);
					$mapper = new Booking_Model_BookingDataMapper();
					$bookStatus = $mapper->CancelNoteByBookingId($bookingObj);
					if($bookStatus){
						$resDataMapper = new ManageRestaurant_Model_RestaurantDataMapper();
						$settingArr = $resDataMapper->getScheduleSettingTypeByresId($bookingObj->getbokfk_restaurant());
						if($settingArr['settingType'] == 'SAC'){
							$mapper->ResetAccumulativeBookingCount($bookingObj);
						}else{
							$mapper->ResetBookingCount($bookingObj);
						}
					}
					$status = $bookStatus;
				}
			}
			return $status;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage());
		}
	}
	
	public function ManageSplPaidReservations($bokid,$resid,$splid,$paymentStatus,$from)
	{
		try{
			$bookServ = new Application_Service_Booking();
			$bookingDetails = $bookServ->GetBookingDetails($bokid);
			$stateId = '';
			$restService = new Application_Service_Restaurant();
			$restResult = $restService->GetRestaurantDetailsById($resid);
			$mailmapper = new Application_Service_Notification();
			$status = false;
			$paymentId = array();
			$paymentProfResult = $paymentStatus['PaymentProfiles'];
	   		if($paymentProfResult){
	   			foreach($paymentProfResult as $row){
	   				$paymentId[] = $row->anppid;
	   			}
	   		}
			$restaurantid = $resid;
			if($paymentId){
				
				$customer = new Payments_Model_CreateInvoiceByCustId();
				$customer->setSpecialId($splid)
						->setRestId($restaurantid)
						->setCustId($bookingDetails->getbokuserid())
						->setBookingId($bokid);
				$CustomerInvoice = $this->GenerateSpecialInvoice($customer);
				$CustomerInvoice->setpaymentprofid($paymentId[0]);
				$CustTransaction = $this->SpecialReservationTransaction($CustomerInvoice);
				
				$splServ = new Application_Service_Specials();
				$splResult = $splServ->GetWidgetSpecialDetailsById($restaurantid,$splid,false);
				
//				$mailmapper = new Application_Service_Notification();
//				$name = $bokDetails->getbokfirst_name().' '.$bokDetails->getboklast_name();
//				$InNumber = $invoiceObj->getinvid();
//				$mailObj = new Notification_Model_Mail();
//				$subject = 'Invoice-'.$InNumber.', Date:'.$currentDate;
//				$path = 'managerest/'.$restid.'/specialinvoice/'.$invoiceObj->getinvid().'.pdf';
//			    $mailObj->setMsgCode('Reservation_Invoice');
//				$maildata = array('UserName' => $name,
//						  'subject'  =>	$subject,
//						  'path'	 =>	$path,
//						  'SenTo'    => $bokDetails->getbokemail());
						
				if($bookingDetails->getNotificationType() == 'email' || $bookingDetails->getNotificationType() == 'both'){
					$mailObj = new Notification_Model_Mail();
					$mailObj->setMsgCode('Special_Booking_Conf');
					if($stateId == ""){
						$stateCity = $bookServ->getRestaurantStateByResId($resid);
						$stateId = $stateCity['state'];
						$cityId = $stateCity['city'];
						$regionId = $stateCity['region'];
						
					}
					$userType = 'CUS';
					$adminService = new Application_Service_Admin();
					$campProp = new Application_Model_GetCampaignForPost();
					$campProp->setAudType($userType)
							 ->setStateId($stateId)
							 ->setCityId($cityId)
							 ->setRegionId($regionId)
							 ->setIsAjaxCall(false);
					$campDetails = $adminService->GetCampaignDetails($campProp);
					
					$name = $bookingDetails->getbokfirst_name().' '.$bookingDetails->getboklast_name();
					
					$InNumber = $CustomerInvoice->getinvid();
//					$subject = 'Invoice-'.$InNumber.', Date:'.$currentDate;
					$path = 'managerest/'.$resid.'/specialinvoice/'.$CustomerInvoice->getinvid().'.pdf';
					
					$data = array('UserName' => $name,
							  'SenTo'    => $bookingDetails->getbokemail(),
							  'RestName' => $restResult->resrestaurant_name,
							  'ResDate'  => $bookingDetails->getbokbooking_date(),
							  'Time'     => $bookingDetails->getbokbooking_timings(),
							  'Size'     => $bookingDetails->getbokparty_size(),
							  'Address'	 => $restResult->resaddress,
							  'resphone' => $restResult->resphone,
							  'Bokid'	 =>	$bokid,
							  'path'	 => $path,
							  'State_Id' =>	$stateId,
							  'City_Id'	 =>	$cityId,
							  'UserType' =>	$userType
					);
					$data['splstatus']	= true;
					$data['splid'] 		= $splid;
					$data['splname']	= $splResult->getSpecialtitle();
					$data['spldesc'] 	= $splResult->getDescription();
					$data['splorgprice']= $splResult->getRegprice();
					if($splResult->getDiscountMode() == 'PER'){
						$data['spldiscount']= $splResult->getDispercentage().'%';	
					}else if($splResult->getDiscountMode() == 'USD'){
						$data['spldiscount']= '$'.$splResult->getDispercentage();
					}
					$data['splprice'] 	= $splResult->getPricewithdiscount();
					
					
					if(count($campDetails)){
						$count = count($campDetails);
						if($count > 1){
							$campaign = $campDetails[rand(0,$count-1)];
						}else{
							$campaign = $campDetails[0];
						}
						$notfService = new Application_Service_Notification();
						$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
						$data['campaignName'] = trim($campaign->getSponsor());
						$data['campaignDesc'] =	trim($campaign->getCampDesc());
						$data['campaignImg'] =	trim($campaign->getCampImage());
						$data['campId']	= $campaign->getId();
					}
					
					$mailObj->setData($data);
					$mailStatus = $mailmapper->SendMail($mailObj);
					if($from == 'customer'){
						$mapper = new Booking_Model_BookingDataMapper();
						$restInfo = $mapper->ReterieveRestInfo($resid);
						if($restInfo){
							if($stateId == ""){
								$stateCity = $this->getRestaurantStateByResId($resid);
								$stateId = $stateCity['state'];
								$cityId = $stateCity['city'];
								$regionId = $stateCity['region'];
								
							}
							$userType = 'RES';
							$adminService = new Application_Service_Admin();
							$resDataMapper = new ManageRestaurant_Model_RestaurantDataMapper();
							$restObj= new ManageRestaurant_Model_RestaurantById();
							$restObj->setRestaurantId($resid);
							$resDetails = $resDataMapper->getRestaurantById($restObj);
							if($resDetails->getrescampaignstatus()){
								$campProp = new Application_Model_GetCampaignForPost();
								$campProp->setAudType($userType)
										 ->setStateId($stateId)
										 ->setCityId($cityId)
										 ->setRegionId($regionId)
										 ->setIsAjaxCall(false);
								$campDetails = $adminService->GetCampaignDetails($campProp);
							}else{
								$campDetails = array();
							} 
							if($restInfo->resnotification && $restInfo->resemail){
								$restEmail = array($restInfo->resemail);
								$mailObj->setMsgCode('BookNotf');
								$name = $bookingDetails->getbokfirst_name().' '.$bookingDetails->getboklast_name();
	
								$data = array(
										  'UserName' 			=> 	$name,
										  'SenTo'    			=> 	$restEmail,
										  'RestName'			=> 	$restResult->resrestaurant_name,
										  'ResDate'  			=> 	$bookingDetails->getbokbooking_date(),
										  'Time'     			=> 	$bookingDetails->getbokbooking_timings(),
										  'email'	 			=> 	$bookingDetails->getbokemail(),
										  'phone'	 			=> 	$bookingDetails->getbokphone(),	
										  'Size'     			=> 	$bookingDetails->getbokparty_size(),
										  'Address'	 			=> 	$restResult->resaddress,
										  'Note'	 			=>	$bookingDetails->getbokspecial_request(),
										  'Bookid'	 			=> 	$bokid,
										  'State_Id'			=>	$stateId,
										  'City_Id'				=>	$cityId,
										  'UserType'			=>	$userType);
								
							
								if(count($campDetails)){
									$count = count($campDetails);
									if($count > 1){
										$campaign = $campDetails[rand(0,$count-1)];
									}else{
										$campaign = $campDetails[0];
									}
									$notfService = new Application_Service_Notification();
									$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
									$data['campaignName'] = trim($campaign->getSponsor());
									$data['campaignDesc'] =	trim($campaign->getCampDesc());
									$data['campaignImg'] =	trim($campaign->getCampImage());
									$data['campId']	= $campaign->getId();
								}
								$mailObj->setData($data);
								$mailStatus = $mailmapper->SendMail($mailObj);
							}
						}
					//
						$restservice = new Application_Service_Restaurant();
						$timeZone = $restservice->GetRestaurantTimeZone($resid);
						date_default_timezone_set($timeZone);

						/* Reterieve Phone Notify Details */
						if($bookingDetails->getbokbooking_status_code() == 'RSD'){
								
							$restPhoneInfo = $restservice->getRestaurantPhoneDetails($resid);
								
							$splitbookdate   = explode('-',$bookingDetails->getbokbooking_date());
								
							$bookingdate   = $bookingDetails->getbokbooking_date();
							$todaydate     = date('Y-m-d');
								
							if(strtotime($bookingdate) == strtotime($todaydate)){
								
								/* get day of week */
								$weekday = date('D',mktime(0,0,0,$splitbookdate[1],$splitbookdate[2],$splitbookdate[0]));
								
								$restNotifyTimesObject = new ManageRestaurant_Model_RestNotifyTimes();
								$restNotifyTimesObject->setrntfk_restaurants($resid);
								$restNotifyTimesObject->setrntnotify_week_day(strtolower($weekday));
								
								$restNotifyTimesMapperObject = new ManageRestaurant_Model_RestNotifyTimesMapper();
								$phoneRow = $restNotifyTimesMapperObject->retrievePhoneNotifyNumber($restNotifyTimesObject);
								
								if($phoneRow){
																											
									$phonenumber = "";
									$fromtime    = "";
									$totime		 = "";
									$resvTime    = date("H:i",time());
									
									$phonenumber = $phoneRow->rntphone;
									$fromtime    = $phoneRow->rntnotify_from_time;
									$totime		 = $phoneRow->rntnotify_to_time;
									
									if($phonenumber){
										
										if(strtotime($resvTime)>= strtotime($fromtime) && strtotime($resvTime)<= strtotime($totime)){
											$mailObj = new Notification_Model_Mail();
											$mailObj->setMsgCode('BookNotf');
												
											$data = array('PhoneNumber'  => $phonenumber,
													  	  'RestName'     => $bookingDetails->getresrestaurant_name(),
													  	  'ResvDate'	 => $bookingDetails->getbokbooking_date(),
													  	  'ResvTime'	 => $bookingDetails->getbokbooking_timings(),
													  	  'Pax'			 => $bookingDetails->getbokparty_size(),
													  	  'ResvPhone'	 => $bookingDetails->getbokphone(),
													  	  'Note'	 	 =>	$bookingDetails->getbokspecial_request(),
													  	  'Firstname' 	 => $bookingDetails->getbokfirst_name(),
													  	  'Lastname'	 => $bookingDetails->getboklast_name());
												
											$mailObj->setData($data);
											$status = $mailmapper->PhoneNotify($mailObj);
												
										}
									}									
								}
							}						

							if($restPhoneInfo['smsnotify']){
								$phoneRowSet = $restPhoneInfo['rowset'];
								$phonenumber = "";
								$fromtime    = "";
								$totime		 = "";
								$resvTime    = $bookingDetails->getbokbooking_timings();

								if($phoneRowSet){
									foreach($phoneRowSet as $phoneNum){
										if($phoneNum->rntnotify_type == 'sms'){
											$phonenumber = $phoneNum->rntphone;
											$fromtime    = $phoneNum->rntnotify_from_time;
											$totime		 = $phoneNum->rntnotify_to_time;
										}
									}
									if($phonenumber){
										if(strtotime($resvTime)>= strtotime($fromtime) && strtotime($resvTime)<= strtotime($totime)){
											$smsObj = new Notification_Model_Sms();
											$smsObj->setMsgCode('BookNotf');

											$data = array('to' 		 	 => $phonenumber,
														  'bokid'    	 => $bokid,
														  'RestName' 	 => $bookingDetails->getresrestaurant_name(),
														  'ResDate'	 	 => $bookingDetails->getbokbooking_date(),
														  'Time'		 => $bookingDetails->getbokbooking_timings(),
														  'Size'		 => $bookingDetails->getbokparty_size(),
														  'CustomerName' => $bookingDetails->getbokfirst_name().' '.$bookingDetails->getboklast_name());

											$smsObj->setData($data);
											$mailStatus = $mailmapper->SendSms($smsObj);

										}
									}
								}
							}
						}	
						///
					}
					$status = true;
				}
			}else{
				if($bookingDetails->getbokbooking_type_code() == 'PAID' || $bookingDetails->getbokbooking_type_code() == 'SPLPAID'){
					$bokStatusCode = 'CAN';
					$bookStatusMapper = new Application_Model_BookingStatusDataMapper();
					$status = $bookingDetails->getbokbooking_status_code();
					$bookStatus 	  = $bookStatusMapper->GetBookingStatusByCode(array($bokStatusCode));
					$bookStatusObj 	  = $bookStatus[$bokStatusCode];
					$bookingObj = new Booking_Model_Booking();
					$bookingObj->setbokid($bokid);
					$bookingObj->setbokbooking_status_id($bookStatusObj->getId());
					$bookingObj->setbokbooking_status_desc($status);
					$bookingObj->setInventoryId($bookingDetails->getInventoryId());
					$bookingObj->setbokfk_restaurant($resid);
					$mapper = new Booking_Model_BookingDataMapper();
					$bookStatus = $mapper->CancelNoteByBookingId($bookingObj);
					if($bookStatus){
						$resDataMapper = new ManageRestaurant_Model_RestaurantDataMapper();
						$settingArr = $resDataMapper->getScheduleSettingTypeByresId($bookingObj->getbokfk_restaurant());
						if($settingArr['settingType'] == 'SAC'){
							$mapper->ResetAccumulativeBookingCount($bookingObj);
						}else{
							$mapper->ResetBookingCount($bookingObj);
						}
					}
					$status = $bookStatus;
				}
			}
			return $status;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage());
		}
	}
	
	public function CustomerReservationTransaction(Payments_Model_CustomerInvoice $customer)
	{
		try{
			$result = array();			
			$customerProfileId = "";
			$paymentProfileId  = "";
			$anppid			   = "";
			$invoiceid 		   = "";
			$invoiceObj		   = "";
				
			$restid    		= $customer->getinvrestaurant_id();
			$invoiceid 		= $customer->getinvid();
			$bokid 			= $customer->getinvbooking_id();
			$custId 		= $customer->getinvcustomer_id();
			$payProfId		= $customer->getpaymentprofid();
			
			$bookMapper = new Booking_Model_BookingDataMapper();
			$book = new Booking_Model_Booking();
			$book->setbokid($bokid);
			$bokDetails = $bookMapper->getBookingDetails($book);
			$partySize = $bokDetails->getbokparty_size();
			
			if($invoiceid){
				$invDetailsByIdObject = new Payments_Model_GetInvoiceDetailsById();
				$invDetailsByIdObject->setInvoiceId($invoiceid)
									 ->setInvoiceStatus(2);
			 	$invMapperObject = new Payments_Model_CustomerInvoiceMapper();
			 	$row = $invMapperObject->RetrieveCustomerInvoiceById($invDetailsByIdObject);
				
			 	if($row){
			 		$totalAmount 	 = "";
			 		$serviceTaxTotal = "";
			 		$invoiceObj = new Payments_Model_CustomerInvoice();
				 	$amount = '';
			  		if($bokDetails->getblockStatus()){
			  			$amount = str_replace('$','',$bokDetails->getblockAmount());
				  		$totalAmount = round((($amount) + (($row->cusinvtxncharges * ($amount))/100)),2);
				  		$serviceTaxTotal = round((($amount)+ (($row->cusinvtxncharges * ($amount))/100)),2);
				  		$invoiceObj->setinvamount($bokDetails->getblockAmount());
			  		}else if($paymentSettigs['rpsnoshow_type'] == 'RESERV'){
				  		$amount = str_replace('$','',$row->cusinvamount);
				  		$totalAmount = round((($amount) + (($row->cusinvtxncharges * ($amount))/100)),2);
				  		$serviceTaxTotal = round((($amount)+ (($row->cusinvtxncharges * ($amount))/100)),2);
				  		$invoiceObj->setinvamount($row->cusinvamount);
			  		}else{
			  			$amount = str_replace('$','',$row->cusinvamount);
				  		$totalAmount = round((($amount * $partySize) + (($row->cusinvtxncharges * ($amount * $partySize))/100)),2);
				  		$serviceTaxTotal = round((($amount * $partySize)+ (($row->cusinvtxncharges * ($amount *$partySize))/100)),2);
				  		$invoiceObj->setinvamount($row->cusinvamount);
			  		}
		  		
//			 		$amount = str_replace('$','',$row->cusinvamount);
//			 		$totalAmount = round((($amount * $partySize) + (($row->cusinvtxncharges * ($amount * $partySize))/100)),2);
//			 		$serviceTaxTotal = round((($amount * $partySize)+ (($row->cusinvtxncharges * ($amount *$partySize))/100)),2);
			 		
			 		
			 		$invoiceObj->setinvid($row->cusinvid)
			 				   ->setinvrestaurant_id($row->cusinvrestaurant_id)
			 				   ->setinvbooking_id($row->cusinvbooking_id)
			 				   ->setinvcustomer_id($row->cusinvcustomer_id)
			 				   ->setinvdescription($row->cusinvdescription)				 		
			 				   ->setinvbilling_fromdate($row->cusinvbilling_fromdate)
			 				   ->setinvbilling_todate($row->cusinvbilling_todate)
			 				   ->setinvtotamount($totalAmount)
			 				   ->setinvstatus($row->cusinvstatus)
			 				   ->setinvgenerated_date($row->cusinvgenerated_date)
			 				   ->setinvgenerated_time($row->cusinvgenerated_time)
			 				   ->setinvcreated_by($row->cusinvcreated_by)
			 				   ->setinvservice_tax($row->cusinvservice_tax)
			 				   ->setinvtxncharges($row->cusinvtxncharges);
			 	}
			}else{
				$createInvoiceObj = new Payments_Model_CreateInvoiceByCustId();
				$createInvoiceObj->setCustId($custId)
								 ->setBookingId($bokid)
								 ->setRestId($restid);			
				$invoiceObj = $this->GenerateCustomerInvoice($createInvoiceObj);	
			}
			
			$getAuthNetCustProfObj = new Payments_Model_GetAuthNetCustProfId();
		    $getAuthNetCustProfObj->setancpuser_id($customer->getinvcustomer_id());
		    $mapper = new Payments_Model_AuthnetCustomerProfileMapper();
		    $CustomerProf = $mapper->GetAuthNetCustProfIdByUserId($getAuthNetCustProfObj);
	        
			$profileStatusMapper = new Application_Model_ProfileStatusDataMapper();
			$prfActStatusObj = $profileStatusMapper->getProfileStatusByCode('ACT');
			$restPaymentPlanStatusMapper = new Application_Model_RestPaymentPlanStatusDataMapper();
			$rppmActStatusObj = $restPaymentPlanStatusMapper->getRestPaymentPlanStatusByCode('ACT');
			$txnTypeMapper = new Application_Model_TransactionTypeDataMapper();
			$debitTxn = $txnTypeMapper->getTransactionTypeByCode('DR');
			$txnStatusMapper = new Application_Model_TransactionStatusDataMapper();
			$successfulTxn = $txnStatusMapper->getTransactionStatusByCode('I00001');
			$subplanStatusMapper = new Application_Model_SubscriptionPlanStatusDataMapper();
			$subPlanStatus = $subplanStatusMapper->GetSubscriptionStatusByCode(array('ACT'));
			$actSubPlanStatus = $subPlanStatus['ACT'];
			$invoiceStatusMapper = new Application_Model_InvoiceStatusDataMapper();
			$paidinvStatus = $invoiceStatusMapper->getInvoiceStatusByCode('PD');
			
			/* Reterieve Customer and Payment profile Id's */
			
			$profileByRestIdObj = new Payments_Model_GetAuthNetPaymentProfId();
			$profileByRestIdObj->setancpcustomer_profile_id($CustomerProf->ProfileId)
							   ->setanppstatus($prfActStatusObj->getId())
							   ->setancpstatus($prfActStatusObj->getId());
		   	
			$authNetProfMapper = new Payments_Model_AuthnetPaymentProfileMapper();
			$rowSet = $authNetProfMapper->GetAuthNetPaymentProfIdByCustProfId($profileByRestIdObj);
			
			foreach($rowSet as $row){
				$anppid			   = $row->anppid;
				$customerProfileId = $row->ancpcustomer_profile_id;
				if($payProfId == $row->anpppayment_profile_id){
					$paymentProfileId  = $row->anpppayment_profile_id;
					break;
				}else{
					$paymentProfileId  = $row->anpppayment_profile_id;
				}
				
			}
			/* Initiate Transaction */
			if($invoiceObj && $invoiceObj instanceof Payments_Model_CustomerInvoice){
				$authCapTransObj = new Payments_Model_AuthCaptureTransaction();
				$authCapTransObj->setCustProfId($customerProfileId)
								->setCustPaymentProfId($paymentProfileId)
								->setAmount($invoiceObj->getinvtotamount())
								->setInvoice($invoiceObj->getinvid())
								->setRecurringBilling(false);
				$authNetHelperObj = new Uss_Helper_AuthNetHelper();
				$response = $authNetHelperObj->CreateAuthCaptureTransaction($authCapTransObj);
				
				if($response['transcode'] == 'I00001'){
					
					$objectArray = array();
					
					$resServ = new Application_Service_Restaurant();
					$timeZone = $resServ->GetRestaurantTimeZone($restid);
					date_default_timezone_set($timeZone);
	 				$currentDate = date('Y-m-d');
	 				$currentTime = date('h:i');
	 				
	 				/* Prepare Transaction details object. */
	 				
					$transactionObject = new Payments_Model_BookingTransactions();
					$transactionObject->settxnfk_Customer($custId)
									  ->settxnfk_booking($bokid)
									  ->settxnfk_restaurant($restid)
									  ->settxntransaction_id($response['transid'])
									  ->settxninvoice_number($invoiceObj->getinvid())
									  ->settxnpayment_profile_id($anppid)
									  ->settxntransaction_amount($invoiceObj->getinvtotamount())
									  ->settxntransaction_date($currentDate)
									  ->settxntransaction_time($currentTime)
									  ->settxndescription($invoiceObj->getinvdescription())
									  ->settxntransaction_type($debitTxn->getId())
									  ->settxnstatus($successfulTxn->getId());
									  
					$objectArray['txnObject'] = $transactionObject; 

				  
					  /* Prepare Update Invoice object */
					  
					 $updateInvoiceStatusByIdObject  = new Payments_Model_UpdateCustomerInvoiceStatusById();
					 $updateInvoiceStatusByIdObject->setinvid($invoiceObj->getinvid())
					 							   ->setcusid($invoiceObj->getinvcustomer_id())
					 							   ->setbokid($invoiceObj->getinvbooking_id())
					 							   ->setinvrestaurant_id($restid)
					 							   ->setinvstatus($paidinvStatus->getId());
	
					 $objectArray['updateInveStatusObj'] = $updateInvoiceStatusByIdObject; 				 				 							   
					  
	   				 $transMapperObject = new Payments_Model_BookingTransactionsMapper();
	   				 $status = $transMapperObject->saveTransactionDetails($objectArray);
	
	   				 /* Generate Invoice Pdf */
	   				 
	   				 $invoiceObj->setcustprofid($customerProfileId);
	   				 $invoiceObj->setpaymentprofid($paymentProfileId);
	   				 
	   				$pdfStatus = $this->GenerateReservationInvoicePdf($invoiceObj);
   				 
					if($status){
	   		 			$storage = new Zend_Auth_Storage_Session();
						$user = $storage->read();
						$resservice = new Application_Service_Restaurant();
						$restaurantName = $resservice->GetRestaurantNamesById($restid);
	
						$mailmapper = new Application_Service_Notification();
						$name = $bokDetails->getbokfirst_name().' '.$bokDetails->getboklast_name();
						$InNumber = $invoiceObj->getinvid();
						$mailObj = new Notification_Model_Mail();
						$subject = 'Invoice-'.$InNumber.', Date:'.$currentDate;
						$path = 'managerest/'.$restid.'/reservation-invoice/'.$invoiceObj->getinvid().'.pdf';
					    $mailObj->setMsgCode('Reservation_Invoice');
						$maildata = array('UserName' => $name,
								  'subject'  =>	$subject,
								  'path'	 =>	$path,
								  'SenTo'    => $bokDetails->getbokemail());
						$mailObj->setData($maildata);
					    
					    $mailStatus = $mailmapper->SendMail($mailObj);
						
						$result['status'] = true;
						$result['amount'] = $invoiceObj->getinvtotamount();
						
	   				}			
				}else{
					//Declined trnsaction
				
					$storage = new Zend_Auth_Storage_Session();
					$user = $storage->read();						
	
					$mailmapper = new Application_Service_Notification();
					$mailObj = new Notification_Model_Mail();
					$mailObj->setMsgCode('Declined trnsaction');
					$name = $user['Firstname'].' '.$user['LastName'];
					$maildata = array('UserName' => $name,
							  'SenTo'    => $user['Email']);
					$mailObj->setData($maildata);
					$mailStatus = $mailmapper->SendMail($mailObj);
					
					$result['status'] = false;
				}					
			}	
			return $result;
			
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}		
	}
	
	public function SpecialReservationTransaction(Payments_Model_SpecialInvoice $customer)
	{
		try{
			$result = array();			
			$customerProfileId = "";
			$paymentProfileId  = "";
			$anppid			   = "";
			$invoiceid 		   = "";
			$invoiceObj		   = "";
				
			$restid    		= $customer->getinvrestaurant_id();
			$invoiceid 		= $customer->getinvid();
			$splid			= $customer->getinvspecial_id();
			$bokid 			= $customer->getinvbooking_id();
			$custId 		= $customer->getinvcustomer_id();
			$payProfId		= $customer->getpaymentprofid();
			
			$bookMapper = new Booking_Model_BookingDataMapper();
			$book = new Booking_Model_Booking();
			$book->setbokid($bokid);
			$bokDetails = $bookMapper->getBookingDetails($book);
			$partySize = $bokDetails->getbokparty_size();
			
			if($invoiceid){
				$invDetailsByIdObject = new Payments_Model_GetInvoiceDetailsById();
				$invDetailsByIdObject->setInvoiceId($invoiceid)
									 ->setInvoiceStatus(2);
			 	$invMapperObject = new Payments_Model_SpecialInvoiceDataMapper();
			 	$row = $invMapperObject->RetrieveSpecialInvoiceById($invDetailsByIdObject);
				
			 	
			
			 	if($row){
			 		$totalAmount 	 = "";
			 		$serviceTaxTotal = "";
			 		$invoiceObj = new Payments_Model_SpecialInvoice();
				 	$amount = '';
				 	$splServ = new Application_Service_Specials();
				$splDetails = $splServ->GetWidgetSpecialDetailsById($restid,$splid,false);
				 	if($splDetails->getCatTypeCode() == 'SP'){
				 		if($splDetails->getSpecialpricetypeCode() == 'PP'){
				 			$amount = str_replace('$','',$splDetails->getPricewithdiscount());
					  		$totalAmount = round((($amount) + (($row->splinvtxncharges * ($amount))/100) + (($row->splinvservice_tax * ($amount))/100)),2);
					  		$serviceTaxTotal = round((($amount)+ (($row->splinvservice_tax * ($amount))/100)),2);
					  		$invoiceObj->setinvamount($splDetails->getPricewithdiscount());
				 		}else if($splDetails->getSpecialpricetypeCode() == 'PS'){
				 			$amount = str_replace('$','',$splDetails->getPricewithdiscount())*$partySize;
					  		$totalAmount = round((($amount) + (($row->splinvtxncharges * ($amount))/100) + (($row->splinvservice_tax * ($amount))/100)),2);
					  		$serviceTaxTotal = round((($amount)+ (($row->splinvservice_tax * ($amount))/100)),2);
					  		$invoiceObj->setinvamount($splDetails->getPricewithdiscount());
				 		}
				 	}
			 		
			 		$invoiceObj->setinvid($row->splinvid)
			 				   ->setinvrestaurant_id($row->splinvrestaurant_id)
			 				   ->setinvspecial_id($splid)
			 				   ->setinvbooking_id($row->splinvbooking_id)
			 				   ->setinvcustomer_id($row->splinvcustomer_id)
			 				   ->setinvdescription($row->splinvdescription)				 		
			 				   ->setinvbilling_fromdate($row->splinvbilling_fromdate)
			 				   ->setinvbilling_todate($row->splinvbilling_todate)
			 				   ->setinvtotamount($totalAmount)
			 				   ->setinvstatus($row->splinvstatus)
			 				   ->setinvgenerated_date($row->splinvgenerated_date)
			 				   ->setinvgenerated_time($row->splinvgenerated_time)
			 				   ->setinvcreated_by($row->splinvcreated_by)
			 				   ->setinvservice_tax($row->splinvservice_tax)
			 				   ->setinvtxncharges($row->splinvtxncharges)
			 				   ->setinvservice_taxtotal($serviceTaxTotal);
			 	}
			}else{
				$createInvoiceObj = new Payments_Model_CreateInvoiceByCustId();
				$createInvoiceObj->setCustId($custId)
								 ->setBookingId($bokid)
								 ->setRestId($restid);			
				$invoiceObj = $this->GenerateSpecialInvoice($createInvoiceObj);	
			}
			
			$getAuthNetCustProfObj = new Payments_Model_GetAuthNetCustProfId();
		    $getAuthNetCustProfObj->setancpuser_id($customer->getinvcustomer_id());
		    $mapper = new Payments_Model_AuthnetCustomerProfileMapper();
		    $CustomerProf = $mapper->GetAuthNetCustProfIdByUserId($getAuthNetCustProfObj);
	        
			$profileStatusMapper = new Application_Model_ProfileStatusDataMapper();
			$prfActStatusObj = $profileStatusMapper->getProfileStatusByCode('ACT');
			$restPaymentPlanStatusMapper = new Application_Model_RestPaymentPlanStatusDataMapper();
			$rppmActStatusObj = $restPaymentPlanStatusMapper->getRestPaymentPlanStatusByCode('ACT');
			$txnTypeMapper = new Application_Model_TransactionTypeDataMapper();
			$debitTxn = $txnTypeMapper->getTransactionTypeByCode('DR');
			$txnStatusMapper = new Application_Model_TransactionStatusDataMapper();
			$successfulTxn = $txnStatusMapper->getTransactionStatusByCode('I00001');
			$subplanStatusMapper = new Application_Model_SubscriptionPlanStatusDataMapper();
			$subPlanStatus = $subplanStatusMapper->GetSubscriptionStatusByCode(array('ACT'));
			$actSubPlanStatus = $subPlanStatus['ACT'];
			$invoiceStatusMapper = new Application_Model_InvoiceStatusDataMapper();
			$paidinvStatus = $invoiceStatusMapper->getInvoiceStatusByCode('PD');
			
			/* Reterieve Customer and Payment profile Id's */
			
			$profileByRestIdObj = new Payments_Model_GetAuthNetPaymentProfId();
			$profileByRestIdObj->setancpcustomer_profile_id($CustomerProf->ProfileId)
							   ->setanppstatus($prfActStatusObj->getId())
							   ->setancpstatus($prfActStatusObj->getId());
		   	
			$authNetProfMapper = new Payments_Model_AuthnetPaymentProfileMapper();
			$rowSet = $authNetProfMapper->GetAuthNetPaymentProfIdByCustProfId($profileByRestIdObj);
			
			foreach($rowSet as $row){
				$anppid			   = $row->anppid;
				$customerProfileId = $row->ancpcustomer_profile_id;
				if($payProfId == $row->anpppayment_profile_id){
					$paymentProfileId  = $row->anpppayment_profile_id;
					break;
				}else{
					$paymentProfileId  = $row->anpppayment_profile_id;
				}
				
			}
			/* Initiate Transaction */
			if($invoiceObj && $invoiceObj instanceof Payments_Model_SpecialInvoice){
				$authCapTransObj = new Payments_Model_AuthCaptureTransaction();
				$authCapTransObj->setCustProfId($customerProfileId)
								->setCustPaymentProfId($paymentProfileId)
								->setAmount($invoiceObj->getinvtotamount())
								->setInvoice($invoiceObj->getinvid())
								->setRecurringBilling(false);
				$authNetHelperObj = new Uss_Helper_AuthNetHelper();
				$response = $authNetHelperObj->CreateAuthCaptureTransaction($authCapTransObj);
				
				if($response['transcode'] == 'I00001'){
					
					$objectArray = array();
					
					$resServ = new Application_Service_Restaurant();
					$timeZone = $resServ->GetRestaurantTimeZone($restid);
					date_default_timezone_set($timeZone);
	 				$currentDate = date('Y-m-d');
	 				$currentTime = date('h:i');
	 				
	 				/* Prepare Transaction details object. */
	 				
					$transactionObject = new Payments_Model_SpecialTransactions();
					$transactionObject->settxnfk_Special($splid)
										->settxnfk_Customer($custId)
									  ->settxnfk_booking($bokid)
									  ->settxnfk_restaurant($restid)
									  ->settxntransaction_id($response['transid'])
									  ->settxninvoice_number($invoiceObj->getinvid())
									  ->settxnpayment_profile_id($anppid)
									  ->settxntransaction_amount($invoiceObj->getinvtotamount())
									  ->settxntransaction_date($currentDate)
									  ->settxntransaction_time($currentTime)
									  ->settxndescription($invoiceObj->getinvdescription())
									  ->settxntransaction_type($debitTxn->getId())
									  ->settxnstatus($successfulTxn->getId());
									  
					$objectArray['txnObject'] = $transactionObject; 

				  
					  /* Prepare Update Invoice object */
					  
					 $updateInvoiceStatusByIdObject  = new Payments_Model_UpdateCustomerInvoiceStatusById();
					 $updateInvoiceStatusByIdObject->setinvid($invoiceObj->getinvid())
					 							   ->setcusid($invoiceObj->getinvcustomer_id())
					 							   ->setbokid($invoiceObj->getinvbooking_id())
					 							   ->setinvrestaurant_id($restid)
					 							   ->setinvstatus($paidinvStatus->getId());
	
					 $objectArray['updateInveStatusObj'] = $updateInvoiceStatusByIdObject; 				 				 							   
					  
	   				 $transMapperObject = new Payments_Model_SpecialTransactionsDataMapper();
	   				 $status = $transMapperObject->saveTransactionDetails($objectArray);
	
	   				 /* Generate Invoice Pdf */
	   				 
	   				 $invoiceObj->setcustprofid($customerProfileId);
	   				 $invoiceObj->setpaymentprofid($paymentProfileId);
	   				 
	   				$pdfStatus = $this->GenerateSpecialReservationInvoicePdf($invoiceObj);
   				 
					if($status){
	   		 			$storage = new Zend_Auth_Storage_Session();
						$user = $storage->read();
						$resservice = new Application_Service_Restaurant();
						$restaurantName = $resservice->GetRestaurantNamesById($restid);
	
//						$mailmapper = new Application_Service_Notification();
//						$name = $bokDetails->getbokfirst_name().' '.$bokDetails->getboklast_name();
//						$InNumber = $invoiceObj->getinvid();
//						$mailObj = new Notification_Model_Mail();
//						$subject = 'Invoice-'.$InNumber.', Date:'.$currentDate;
//						$path = 'managerest/'.$restid.'/specialinvoice/'.$invoiceObj->getinvid().'.pdf';
//					    $mailObj->setMsgCode('Reservation_Invoice');
//						$maildata = array('UserName' => $name,
//								  'subject'  =>	$subject,
//								  'path'	 =>	$path,
//								  'SenTo'    => $bokDetails->getbokemail());
//						$mailObj->setData($maildata);
//					    
//					    $mailStatus = $mailmapper->SendMail($mailObj);
						
						$result['status'] = true;
						$result['amount'] = $invoiceObj->getinvtotamount();
						
	   				}			
				}else{
					//Declined trnsaction
				
					$storage = new Zend_Auth_Storage_Session();
					$user = $storage->read();						
	
					$mailmapper = new Application_Service_Notification();
					$mailObj = new Notification_Model_Mail();
					$mailObj->setMsgCode('Declined trnsaction');
					$name = $user['Firstname'].' '.$user['LastName'];
					$maildata = array('UserName' => $name,
							  'SenTo'    => $user['Email']);
					$mailObj->setData($maildata);
					$mailStatus = $mailmapper->SendMail($mailObj);
					
					$result['status'] = false;
				}					
			}	
			return $result;
			
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}		
	}
	
	public function GenerateCustomerInvoice(Payments_Model_CreateInvoiceByCustId $object)
	{
		try{
			$resid = $object->getRestId();
			$cusId = $object->getCustId();
			$bokid = $object->getBookingId();
			
			$resServ = new Application_Service_Restaurant();
			$timezone = $resServ->GetRestaurantTimeZone($resid);
			date_default_timezone_set($timezone);
			$invoiceGenDate = date('Y-m-d');
			$invoiceGenTime = date('g:i A');
			$date = date('Y-m-d');
			
			$bookMapper = new Booking_Model_BookingDataMapper();
			$book = new Booking_Model_Booking();
			$book->setbokid($bokid);
			$bokDetails = $bookMapper->getBookingDetails($book);
			$partySize = $bokDetails->getbokparty_size();
			
			$paymentMapper = new Payments_Model_RestaurantPaymentSettingsMapper();
			$paymentSettigs = $paymentMapper->GetPaymentSettingsByResId($resid,$bokDetails->getbokbooking_date());
			
			$invStatusMapper = new Application_Model_InvoiceStatusDataMapper();
			$unpaidinvStatus = $invStatusMapper->getInvoiceStatusByCode('UPD');
		
	    	$invoiceObj = new Payments_Model_CustomerInvoice();
	    	$code = 'TRN-RES';
	    	$txnCharges = '';
			$txnChargesResult = $this->getTransactionCharges($code);
	  		
	  		if($txnChargesResult){
	  			foreach($txnChargesResult as $txnCharge){
	  				$txnCharges = $txnCharge->txncharge;
	  			}
	  		}
	  		$actualAmount = '';
	  		$calAmount = '';
	  		$totalAmount = '';
	  		if($bokDetails->getblockStatus()){
	  			$actualAmount = str_replace('$','',$bokDetails->getblockAmount());
		  		$calAmount = ($txnCharges * trim($actualAmount))/100;
		  		$totalAmount = round(($calAmount + $actualAmount),2);
		  		$invoiceObj->setinvamount($bokDetails->getblockAmount());
	  		}else if($paymentSettigs['rpsnoshow_type'] == 'RESERV'){
		  		$actualAmount = str_replace('$','',$paymentSettigs['payamount']);
		  		$calAmount = ($txnCharges * trim($actualAmount))/100;
		  		$totalAmount = round(($calAmount + $actualAmount),2);
		  		$invoiceObj->setinvamount($paymentSettigs['payamount']);
	  		}else{
	  			$actualAmount = str_replace('$','',$paymentSettigs['payamount']);
		  		$calAmount = ($txnCharges * trim($actualAmount * $partySize))/100;
		  		$totalAmount = round(($calAmount + $actualAmount * $partySize),2);
		  		$invoiceObj->setinvamount($paymentSettigs['payamount']);
	  		}
		 		 
		 	$invoiceObj->setinvrestaurant_id($resid)	
		 				->setinvbooking_id($bokid)	 	
		 	 			->setinvcustomer_id($cusId)
		 	 			->setinvbilling_fromdate($date)
		 	 			->setinvbilling_todate($date)	
		 	 			->setinvtotamount($totalAmount)
		 	 			->setinvservice_tax(0)
		 	 			->setinvservice_taxtotal(0)
		 	 			->setinvtxncharges($txnCharges)
		 	 			->setinvgenerated_date($invoiceGenDate)
		 	 			->setinvgenerated_time($invoiceGenTime)		 	 			
		 	 			->setinvstatus($unpaidinvStatus->getId());
		 	 
		 	 $invoiceMapper = new Payments_Model_CustomerInvoiceMapper();
		 	 $row = $invoiceMapper->CheckCustomerInvoiceGenerated($invoiceObj);
		 	 
		 	 if(!$row){
		 	 	$invoiceId = $invoiceMapper->CreateCustomerInvoice($invoiceObj);
		 	 	$invoiceObj->setinvid($invoiceId);		 	 	
		 	 }else{
		 	 	$invoiceObj->setinvid($row->cusinvid);
		 	 }		 	 
//		 }
		 return $invoiceObj;		
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
 	}
 	
	public function GenerateSpecialInvoice(Payments_Model_CreateInvoiceByCustId $object)
	{
		try{
			$resid = $object->getRestId();
			$cusId = $object->getCustId();
			$splid = $object->getSpecialId();
			$bokid = $object->getBookingId();
			
			$resServ = new Application_Service_Restaurant();
			$timezone = $resServ->GetRestaurantTimeZone($resid);
			date_default_timezone_set($timezone);
			$invoiceGenDate = date('Y-m-d');
			$invoiceGenTime = date('g:i A');
			$date = date('Y-m-d');
			
			$bookMapper = new Booking_Model_BookingDataMapper();
			$book = new Booking_Model_Booking();
			$book->setbokid($bokid);
			$bokDetails = $bookMapper->getBookingDetails($book);
			$partySize = $bokDetails->getbokparty_size();
			
			$splServ = new Application_Service_Specials();
			$splDetails = $splServ->GetWidgetSpecialDetailsById($resid,$splid,false);
			
//			$paymentMapper = new Payments_Model_RestaurantPaymentSettingsMapper();
//			$paymentSettigs = $paymentMapper->GetPaymentSettingsByResId($resid,$bokDetails->getbokbooking_date());
			
			$invStatusMapper = new Application_Model_InvoiceStatusDataMapper();
			$unpaidinvStatus = $invStatusMapper->getInvoiceStatusByCode('UPD');
		
	    	$invoiceObj = new Payments_Model_SpecialInvoice();
	    	$code = 'SUB_EC';
	    	$txnCharges = '';
			$txnChargesResult = $this->getTransactionCharges($code);
	  		
	  		if($txnChargesResult){
	  			foreach($txnChargesResult as $txnCharge){
	  				$txnCharges = $txnCharge->txncharge;
	  			}
	  		}
	  		$actualAmount = '';
	  		$calAmount = '';
	  		$totalAmount = '';
	  		
	  		if($splDetails->getCatTypeCode() == 'SP'){
	  			if($splDetails->getSpecialpricetypeCode() == 'PP'){
		  			$actualAmount = str_replace('$','',$splDetails->getPricewithdiscount());
		  			$calAmount = ($txnCharges * trim($actualAmount))/100;
		  			$calAmount += (7.5 * trim($actualAmount))/100;
		  			$totalAmount = round(($calAmount + $actualAmount),2);
			  		$invoiceObj->setinvamount($splDetails->getPricewithdiscount());
	  			}else if($splDetails->getSpecialpricetypeCode() == 'PS'){
	  				
	  				$actualAmount = str_replace('$','',$splDetails->getPricewithdiscount())*$partySize;
		  			$calAmount = ($txnCharges * trim($actualAmount))/100;
		  			$calAmount += (7.5 * trim($actualAmount))/100;
		  			$totalAmount = round(($calAmount + $actualAmount),2);
			  		$invoiceObj->setinvamount($splDetails->getPricewithdiscount());
	  			}
	  		}
	  		
//	  		if($bokDetails->getblockStatus()){
//	  			$actualAmount = str_replace('$','',$bokDetails->getblockAmount());
//		  		$calAmount = ($txnCharges * trim($actualAmount))/100;
//		  		$totalAmount = round(($calAmount + $actualAmount),2);
//		  		$invoiceObj->setinvamount($bokDetails->getblockAmount());
//	  		}else if($paymentSettigs['rpsnoshow_type'] == 'RESERV'){
//		  		$actualAmount = str_replace('$','',$paymentSettigs['payamount']);
//		  		$calAmount = ($txnCharges * trim($actualAmount))/100;
//		  		$totalAmount = round(($calAmount + $actualAmount),2);
//		  		$invoiceObj->setinvamount($paymentSettigs['payamount']);
//	  		}else{
//	  			$actualAmount = str_replace('$','',$paymentSettigs['payamount']);
//		  		$calAmount = ($txnCharges * trim($actualAmount * $partySize))/100;
//		  		$totalAmount = round(($calAmount + $actualAmount * $partySize),2);
//		  		$invoiceObj->setinvamount($paymentSettigs['payamount']);
//	  		}
		 		 
		 	$invoiceObj->setinvspecial_id($splid)
		 				->setinvrestaurant_id($resid)	
		 				->setinvbooking_id($bokid)	 	
		 	 			->setinvcustomer_id($cusId)
		 	 			->setinvbilling_fromdate($date)
		 	 			->setinvbilling_todate($date)	
		 	 			->setinvtotamount($totalAmount)
		 	 			->setinvservice_tax(7.5)
		 	 			->setinvservice_taxtotal((7.5 * trim($actualAmount))/100)
		 	 			->setinvtxncharges($txnCharges)
		 	 			->setinvgenerated_date($invoiceGenDate)
		 	 			->setinvgenerated_time($invoiceGenTime)		 	 			
		 	 			->setinvstatus($unpaidinvStatus->getId());
		 	 
		 	 $invoiceMapper = new Payments_Model_SpecialInvoiceDataMapper();
		 	 $row = $invoiceMapper->CheckSpecialInvoiceGenerated($invoiceObj);
		 	 
		 	 if(!$row){
		 	 	$invoiceId = $invoiceMapper->CreateSpecialInvoice($invoiceObj);
		 	 	$invoiceObj->setinvid($invoiceId);		 	 	
		 	 }else{
		 	 	$invoiceObj->setinvid($row->splinvid);
		 	 }		 	 
//		 }
		 return $invoiceObj;		
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
 	}
 	
	public function GenerateReservationInvoicePdf(Payments_Model_CustomerInvoice $invoiceObject)
	{
		try{
			/* Reterieve Billing info  */
			$authHelperObj = new Uss_Helper_AuthNetHelper();
			$bookServ = new Application_Service_Booking();
			$bookDetails = $bookServ->GetBookingDetails($invoiceObject->getinvbooking_id());
			
			$custProfReq = $authHelperObj->GetCustomerPaymentProfileRequest($invoiceObject->getcustprofid(),$invoiceObject->getpaymentprofid());
			$path = 'managerest/'.$invoiceObject->getinvrestaurant_id();
			if(!file_exists($path)){
				mkdir($path,0777);
			}
			$invoiceDirPath = $path.'/reservation-invoice';
			if(!file_exists($invoiceDirPath)){
				mkdir($invoiceDirPath,0777);
			}
			
			$invoiceFilePath = $invoiceDirPath.'/'.$invoiceObject->getinvid().'.pdf';
			if(!file_exists($invoiceFilePath)){
				$pdf = new My_Pdf_Document($invoiceFilePath, '.');
				$page = $pdf->createPage();
	
				$font = Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_HELVETICA);
				
				$page->setFont($font, 8);
				$page->setLineColor(new Zend_Pdf_Color_Rgb(0,100,0));
				$page->drawLine(-10, 15, ($page->getWidth()-0), 15);
				$imageurl = "../public/images/logo.png";
				
				$image = Zend_Pdf_Image::imageWithPath($imageurl);
				
				// write image to page
				$page->drawImage($image,-10,-30,80, 40);			
				
				$invoiceCreationDate = $invoiceObject->getinvgenerated_date();
				$page->drawText('INVOICE', 500, 0);
				
				$page->drawText('UReserv Inc',15,45);
				$page->setFont($font, 6);
				$page->drawText('life just got easier ',15,55);
				
				/*Print Address*/
			    $page->drawText('464 Common Street,',15,65);
				$page->drawText('Suite 253,',15,75);
				$page->drawText('Belmont, MA 02478,',15,85);		
				$page->drawText('EMail: admin@ureserv.com',15,95);
				
				$invoiceNo  = "INVOICE#  ".$invoiceObject->getinvid();
				$invoiceDate  = "DATE  ".$invoiceObject->getinvgenerated_date();
	
				/* Print Invoice No and date on right hand side */
				$page->drawText($invoiceNo,450,45);
				$page->drawText($invoiceDate,450,55);
				
				/* Print Billing info */
				
				$page->setFont($font, 8);
				
				$page->drawText('TO',15,120);
				
				$page->setFont($font, 6);
				
				$paymentProfInfo = $custProfReq[$invoiceObject->getpaymentprofid()];
				
				$name = $paymentProfInfo['firstName']. " " .$paymentProfInfo['lastName'];
				$page->drawText($name,20,130);
				
				$address = $paymentProfInfo['address'].",";
				$page->drawText($address,20,140);
				
				$city_state = $paymentProfInfo['city']." - ".$paymentProfInfo['state'].",";
				$page->drawText($city_state,20,150);
				
				$country_zip = $paymentProfInfo['country']." - ".$paymentProfInfo['zip'].".";			
				$page->drawText($country_zip,20,160);
				
				
				/* Print Invoice details */
				
				$invoiceFrom = 'Invoice From: '.$invoiceObject->getinvbilling_fromdate();
				$page->drawText($invoiceFrom,400,130);
				
				$invoiceTo = 'Invoice To: '.$invoiceObject->getinvbilling_todate();
				$page->drawText($invoiceTo,400,140);
				
				$duedate = 'Due Date:';
				$page->drawText($duedate,400,150);
				
				$restId = 'Restaurant ID: '.$invoiceObject->getinvrestaurant_id();
				$page->drawText($restId,400,160);
	
				$planType = "Plan type: Reservation Charges";
				$page->drawText($planType,400,170);
				
				/* Create table for printing  invoice desc and amount */
				
				$table = new My_Pdf_Table(6);
				/* Adding table header */
				$headrow  = new My_Pdf_Table_Row();
				$headcols = array();
						
				$sNo  = new My_Pdf_Table_Column();
				$sNo->setText("SNO",'center','middle');
				$sNo->setWidth(30);
				$sNo->setHeight(100);
				$headcols[] = $sNo;
					
				$itemTitle = new My_Pdf_Table_Column();
				$itemTitle->setText("ITEM TITLE",'center','middle');
				$itemTitle->setWidth(100);
				$headcols[] = $itemTitle;
	
				$description  = new My_Pdf_Table_Column();
				$description->setText("DESCRPTION",'center','middle');
				$description->setWidth(170);
				$headcols[] = $description;
					
				$price  = new My_Pdf_Table_Column();
				$price->setText("PRICE",'center','middle');
				$price->setWidth(70);
				$headcols[] = $price;
	
				$deductions  = new My_Pdf_Table_Column();
				$deductions->setText("No. of Seats",'center','middle');
				$deductions->setWidth(80);
				$headcols[] = $deductions;
					
				$lineTotal  = new My_Pdf_Table_Column();
				$lineTotal->setText("LINE TOTAL",'center','middle');
				$lineTotal->setWidth(80);
				$headcols[] = $lineTotal;
				
				$headrow->setColumns($headcols);
				$headrow->setFont($font, 8);
				$headrow->setBorder(My_Pdf::TOP, new Zend_Pdf_Style());
				$headrow->setBorder(My_Pdf::BOTTOM, new Zend_Pdf_Style());
				$headrow->setBorder(My_Pdf::LEFT, new Zend_Pdf_Style());
				$headrow->setBorder(My_Pdf::RIGHT, new Zend_Pdf_Style());
				$headrow->setCellPaddings(array(8,8,8,8));
				$table->addRow($headrow);
				
				/* Add Table rows */
				
				$row  = new My_Pdf_Table_Row();
				$cols = array();			
				
				$sNoCol = new My_Pdf_Table_Column();
				$sNoCol->setText('1','center','middle');
				$sNoCol->setWidth(30);
				$sNoCol->setHeight(600);
				$cols[] = $sNoCol;
				
				$itemTitleCol = new My_Pdf_Table_Column();				
				$itemTitleCol->setText($invoiceObject->getinvbilling_fromdate(),'center','middle');
				$itemTitleCol->setWidth(100);			
				$cols[] = $itemTitleCol;
				
				
				$invoiceDetails = 'Reservation Charge for'. $invoiceObject->getinvbilling_fromdate();
				$descCol = new My_Pdf_Table_Column();
				$descCol->setText($invoiceDetails,'center','middle');
				$descCol->setWidth(170);			
				$cols[] = $descCol;
				
				$priceCol = new My_Pdf_Table_Column();
				$priceCol->setText($invoiceObject->getinvamount().'/Seat' ,'center','middle');
				$priceCol->setWidth(70);			
				$cols[] = $priceCol;
				
				$deductionCol = new My_Pdf_Table_Column();
				$deductionCol->setText($bookDetails->getbokparty_size(),'center','middle');
				$deductionCol->setWidth(80);			
				$cols[] = $deductionCol;
				
				$lineTotalCol = new My_Pdf_Table_Column();
				$invAmt = str_replace('$','',$invoiceObject->getinvamount());
				$amt = round((int)$invAmt * (int)$bookDetails->getbokparty_size(),2);
				$lineTotalCol->setText('$'.$amt,'center','middle');
				$lineTotalCol->setWidth(80);			
				$cols[] = $lineTotalCol;
				
				$row->setColumns($cols);
			    $row->setFont($font, 8);
				$row->setBorder(My_Pdf::TOP, new Zend_Pdf_Style());
				$row->setBorder(My_Pdf::BOTTOM, new Zend_Pdf_Style());
				$row->setBorder(My_Pdf::LEFT, new Zend_Pdf_Style());
				$row->setBorder(My_Pdf::RIGHT, new Zend_Pdf_Style());
				$row->setCellPaddings(array(8,8,8,8));
				$table->addRow($row);				
	
				/* Print total row */
				$totCols = array();
				
				$sNoColTot = new My_Pdf_Table_Column();
				$sNoColTot->setText('','center','middle');
				$sNoColTot->setWidth(30);
				$sNoColTot->setHeight(600);
				$totCols[] = $sNoColTot;
				
				$itemTitleTotCol = new My_Pdf_Table_Column();				
				$itemTitleTotCol->setText('','center','middle');
				$itemTitleTotCol->setWidth(100);			
				$totCols[] = $itemTitleTotCol;
				
				$descTotCol = new My_Pdf_Table_Column();
				$descTotCol->setText('TOTAL','right','middle');
				$descTotCol->setWidth(170);			
				$totCols[] = $descTotCol;
				
				$priceTotCol = new My_Pdf_Table_Column();
				$priceTotCol->setText('','center','middle');
				$priceTotCol->setWidth(70);			
				$totCols[] = $priceTotCol;
				
				$deductionTotCol = new My_Pdf_Table_Column();
				$deductionTotCol->setText('$0','center','middle');
				$deductionTotCol->setWidth(80);			
				$totCols[] = $deductionTotCol;
				
				$lineTotalCol1 = new My_Pdf_Table_Column();
				$lineTotalCol1->setText('$'.$amt,'center','middle');
				$lineTotalCol1->setWidth(80);			
				$totCols[] = $lineTotalCol1;
				
				$totRow  = new My_Pdf_Table_Row();
				$totRow->setColumns($totCols);			
				$totRow->setFont($font, 8);
				$totRow->setCellPaddings(array(8,8,8,8));
				$table->addRow($totRow);	
				
				/* Add Service Tax row */
				
				$serviceTaxCols = array();
				
				$sNoColTax = new My_Pdf_Table_Column();
				$sNoColTax->setText('','center','middle');
				$sNoColTax->setWidth(30);
				$sNoColTax->setHeight(600);
				$serviceTaxCols[] = $sNoColTax;
				
				$itemTitleTaxCol = new My_Pdf_Table_Column();				
				$itemTitleTaxCol->setText('','center','middle');
				$itemTitleTaxCol->setWidth(100);			
				$serviceTaxCols[] = $itemTitleTaxCol;
				
				$descTaxCol = new My_Pdf_Table_Column();
				$descTaxCol->setText('SERVICE TAX(%)','right','middle');
				$descTaxCol->setWidth(170);			
				$serviceTaxCols[] = $descTaxCol;
				
				$priceTaxCol = new My_Pdf_Table_Column();
				$priceTaxCol->setText('','center','middle');
				$priceTaxCol->setWidth(70);			
				$serviceTaxCols[] = $priceTaxCol;
				
				$deductionTaxCol = new My_Pdf_Table_Column();
				$deductionTaxCol->setText('','center','middle');
				$deductionTaxCol->setWidth(80);			
				$serviceTaxCols[] = $deductionTaxCol;
				
				$lineTotalTaxCol = new My_Pdf_Table_Column();
				$lineTotalTaxCol->setText($invoiceObject->getinvservice_tax().'%','center','middle');
				$lineTotalTaxCol->setWidth(80);	
						
				$serviceTaxCols[] = $lineTotalTaxCol;
				
				
				$servTaxRow  = new My_Pdf_Table_Row();
				$servTaxRow->setColumns($serviceTaxCols);
				$servTaxRow->setFont($font, 8);
				$servTaxRow->setCellPaddings(array(8,8,8,8));
				$table->addRow($servTaxRow);	
				
				
					/* Add Service Tax Toatal row */
				
				$serviceTaxTotCols = array();
				
				$sNoColTaxTot = new My_Pdf_Table_Column();
				$sNoColTaxTot->setText('','center','middle');
				$sNoColTaxTot->setWidth(30);
				$sNoColTaxTot->setHeight(600);
				$serviceTaxTotCols[] = $sNoColTaxTot;
				
				$itemTitleTaxTotCol = new My_Pdf_Table_Column();				
				$itemTitleTaxTotCol->setText('','center','middle');
				$itemTitleTaxTotCol->setWidth(100);			
				$serviceTaxTotCols[] = $itemTitleTaxTotCol;
				
				$descTaxTotCol = new My_Pdf_Table_Column();
				$descTaxTotCol->setText('SERVICE TAX TOTAL','right','middle');
				$descTaxTotCol->setWidth(170);			
				$serviceTaxTotCols[] = $descTaxTotCol;
				
				$priceTaxTotCol = new My_Pdf_Table_Column();
				$priceTaxTotCol->setText('','center','middle');
				$priceTaxTotCol->setWidth(70);			
				$serviceTaxTotCols[] = $priceTaxTotCol;
				
				$deductionTaxTotCol = new My_Pdf_Table_Column();
				$deductionTaxTotCol->setText('','center','middle');
				$deductionTaxTotCol->setWidth(80);			
				$serviceTaxTotCols[] = $deductionTaxTotCol;
				
				$lineTotalTaxTotCol = new My_Pdf_Table_Column();
				$lineTotalTaxTotCol->setText($invoiceObject->getinvservice_taxtotal(),'center','middle');
				$lineTotalTaxTotCol->setWidth(80);						
				$serviceTaxTotCols[] = $lineTotalTaxTotCol;
				
				
				$servTaxTotRow  = new My_Pdf_Table_Row();
				$servTaxTotRow->setColumns($serviceTaxTotCols);
				$servTaxTotRow->setFont($font, 8);
				$servTaxTotRow->setCellPaddings(array(8,8,8,8));
				$table->addRow($servTaxTotRow);
				
				/* Handling Charges row */
				
				
				$handlingChargesCols = array();
				
				$sNoColCharge = new My_Pdf_Table_Column();
				$sNoColCharge->setText('','center','middle');
				$sNoColCharge->setWidth(30);
				$sNoColCharge->setHeight(600);
				$handlingChargesCols[] = $sNoColCharge;
				
				$itemTitleChargeCol = new My_Pdf_Table_Column();				
				$itemTitleChargeCol->setText('','center','middle');
				$itemTitleChargeCol->setWidth(100);			
				$handlingChargesCols[] = $itemTitleChargeCol;
				
				$descChargeCol = new My_Pdf_Table_Column();
				$descChargeCol->setText('TRANSACTION FEE','right','middle');
				$descChargeCol->setWidth(170);			
				$handlingChargesCols[] = $descChargeCol;
				
				$priceChargeCol = new My_Pdf_Table_Column();
				$priceChargeCol->setText('','center','middle');
				$priceChargeCol->setWidth(70);			
				$handlingChargesCols[] = $priceChargeCol;
				
				$deductionChargeCol = new My_Pdf_Table_Column();
				$deductionChargeCol->setText('','center','middle');
				$deductionChargeCol->setWidth(80);			
				$handlingChargesCols[] = $deductionChargeCol;
				
				$lineTotalChargeCol = new My_Pdf_Table_Column();
				$lineTotalChargeCol->setText($invoiceObject->getinvtxncharges().'%','center','middle');
				$lineTotalChargeCol->setWidth(80);						
				$handlingChargesCols[] = $lineTotalChargeCol;
				
				
				$txnChargeRow  = new My_Pdf_Table_Row();
				$txnChargeRow->setColumns($handlingChargesCols);
				$txnChargeRow->setFont($font, 8);
				$txnChargeRow->setCellPaddings(array(8,8,8,8));
				$table->addRow($txnChargeRow);
				
				
				/* Add Net Payable row */
										
				$netPayCols = array();
				
				$sNoColNetPay = new My_Pdf_Table_Column();
				$sNoColNetPay->setText('','center','middle');
				$sNoColNetPay->setWidth(30);
				$sNoColNetPay->setHeight(600);
				$netPayCols[] = $sNoColNetPay;
				
				$itemTitleTNetPay = new My_Pdf_Table_Column();				
				$itemTitleTNetPay->setText('','center','middle');
				$itemTitleTNetPay->setWidth(100);			
				$netPayCols[] = $itemTitleTNetPay;
				
				$descTaxNetPay = new My_Pdf_Table_Column();
				$descTaxNetPay->setText('NET PAYABLE TOTAL','right','middle');
				$descTaxNetPay->setWidth(170);			
				$netPayCols[] = $descTaxNetPay;
				
				$priceNetPay = new My_Pdf_Table_Column();
				$priceNetPay->setText('','center','middle');
				$priceNetPay->setWidth(70);			
				$netPayCols[] = $priceNetPay;
				
				$deductionNetPayCol = new My_Pdf_Table_Column();
				$deductionNetPayCol->setText('','center','middle');
				$deductionNetPayCol->setWidth(80);			
				$netPayCols[] = $deductionNetPayCol;
				
				$lineTotalNetPayCol = new My_Pdf_Table_Column();
				$lineTotalNetPayCol->setText('$'.$invoiceObject->getinvtotamount(),'center','middle');
				$lineTotalNetPayCol->setWidth(80);						
				$netPayCols[] = $lineTotalNetPayCol;
				
				
				$netPayRow  = new My_Pdf_Table_Row();
				$netPayRow->setColumns($netPayCols);
				$netPayRow->setFont($font, 8);
				$netPayRow->setCellPaddings(array(8,8,8,8));
				$table->addRow($netPayRow);
				
				
				
				$page->addTable($table, 10, 200);
				$pdf->addPage($page);
				$pdf->save();
				
			}
						
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}	
	}
	/* Invoice Generation function for Special Reservation */
	
	public function GenerateSpecialReservationInvoicePdf(Payments_Model_SpecialInvoice $invoiceObject)
	{
		try{
			/* Reterieve Billing info  */
			$authHelperObj = new Uss_Helper_AuthNetHelper();
			$bookServ = new Application_Service_Booking();
			$bookDetails = $bookServ->GetBookingDetails($invoiceObject->getinvbooking_id());
			
			/* Get Rest Name by rest id. */
			
			$restid = $invoiceObject->getinvrestaurant_id();
			$resservice = new Application_Service_Restaurant();
			$restaurantName = $resservice->GetRestaurantNamesById($restid);
			
			/* Get Special Details */
			
			$specialId = $invoiceObject->getinvspecial_id();
			
			$splService = new Application_Service_Specials();
			$splInfo = $splService->RetrieveSpecilInfoById($specialId);
			
						
			$custProfReq = $authHelperObj->GetCustomerPaymentProfileRequest($invoiceObject->getcustprofid(),$invoiceObject->getpaymentprofid());
			$path = 'managerest/'.$invoiceObject->getinvrestaurant_id();
			if(!file_exists($path)){
				mkdir($path,0777);
			}
			$invoiceDirPath = $path.'/specialinvoice';
			if(!file_exists($invoiceDirPath)){
				
				mkdir($invoiceDirPath,0777);
			}
			
			$invoiceFilePath = $invoiceDirPath.'/'.$invoiceObject->getinvid().'.pdf';
			if(!file_exists($invoiceFilePath)){
				$pdf = new My_Pdf_Document($invoiceFilePath, '.');
				$page = $pdf->createPage();
	
				$font = Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_HELVETICA);
				
				$page->setFont($font, 8);
				$page->setLineColor(new Zend_Pdf_Color_Rgb(0,100,0));
				$page->drawLine(-10, 15, ($page->getWidth()-0), 15);
				$imageurl = "../public/images/logo.png";
				
				$image = Zend_Pdf_Image::imageWithPath($imageurl);
				
				// write image to page
				$page->drawImage($image,-10,-30,80, 40);			
				
				$invoiceCreationDate = $invoiceObject->getinvgenerated_date();
				$page->drawText('INVOICE', 500, 0);
				
				$page->drawText('UReserv Inc',15,45);
				$page->setFont($font, 6);
				$page->drawText('life just got easier ',15,55);
				
				/*Print Address*/
			    $page->drawText('464 Common Street,',15,65);
				$page->drawText('Suite 253,',15,75);
				$page->drawText('Belmont, MA 02478,',15,85);		
				$page->drawText('EMail: admin@ureserv.com',15,95);
				
				$invoiceNo  = "INVOICE#  ".$invoiceObject->getinvid();
				$invoiceDate  = "DATE  ".$invoiceObject->getinvgenerated_date();
	
				/* Print Invoice No and date on right hand side */
				$page->drawText($invoiceNo,450,45);
				$page->drawText($invoiceDate,450,55);
				
				/* Print Billing info */
				
				$page->setFont($font, 8);
				
				$page->drawText('TO',15,120);
				
				$page->setFont($font, 6);
				
				$paymentProfInfo = $custProfReq[$invoiceObject->getpaymentprofid()];
				
				$name = $paymentProfInfo['firstName']. " " .$paymentProfInfo['lastName'];
				$page->drawText($name,20,130);
				
				$address = $paymentProfInfo['address'].",";
				$page->drawText($address,20,140);
				
				$city_state = $paymentProfInfo['city']." - ".$paymentProfInfo['state'].",";
				$page->drawText($city_state,20,150);
				
				$country_zip = $paymentProfInfo['country']." - ".$paymentProfInfo['zip'].".";			
				$page->drawText($country_zip,20,160);
				
				
				/* Print Invoice details */
				
				$invoiceFrom = 'Invoice Date: '.$invoiceObject->getinvbilling_fromdate();
				$page->drawText($invoiceFrom,400,130);
			
				$restName = 'Restaurant Name: '.$restaurantName['restName'];
				$page->drawText($restName,400,140);
				
				$restaddress = 'Restaurant Address: '.$restaurantName['address'].",";
				$page->drawText($restaddress,400,150);
				
				$rest_city_state = $restaurantName['city']." - ".$restaurantName['state'].",";
				$page->drawText($rest_city_state,460,160);
				
				$rest_zipcode = $restaurantName['zipcode'].".";
				$page->drawText($rest_zipcode,460,170);
				
				$rest_phone = 'Phone: '.$restaurantName['phone'];
				$page->drawText($rest_phone,400,180);
				
				$rest_email = 'Email: '.$restaurantName['email'];
				$page->drawText($rest_email,400,190);
	
				/* Create table for printing  invoice desc and amount */
				
				$table = new My_Pdf_Table(4);
				/* Adding table header */
				$headrow  = new My_Pdf_Table_Row();
				$headcols = array();
						
				$sNo  = new My_Pdf_Table_Column();
				$sNo->setText("SNO",'center','middle');
				$sNo->setWidth(30);
				$sNo->setHeight(100);
				$headcols[] = $sNo;
	
				$description  = new My_Pdf_Table_Column();
				$description->setText("DESCRIPTION",'center','middle');
				$description->setWidth(270);
				$headcols[] = $description;
				
				$noofseats  = new My_Pdf_Table_Column();
				$noofseats->setText("No of Seats",'center','middle');
				$noofseats->setWidth(70);
				$headcols[] = $noofseats;
					
				$price  = new My_Pdf_Table_Column();
				$price->setText("PRICE",'center','middle');
				$price->setWidth(80);
				$headcols[] = $price;
						
				$lineTotal  = new My_Pdf_Table_Column();
				$lineTotal->setText("LINE TOTAL",'center','middle');
				$lineTotal->setWidth(80);
				$headcols[] = $lineTotal;
				
				$headrow->setColumns($headcols);
				$headrow->setFont($font, 8);
				$headrow->setBorder(My_Pdf::TOP, new Zend_Pdf_Style());
				$headrow->setBorder(My_Pdf::BOTTOM, new Zend_Pdf_Style());
				$headrow->setBorder(My_Pdf::LEFT, new Zend_Pdf_Style());
				$headrow->setBorder(My_Pdf::RIGHT, new Zend_Pdf_Style());
				$headrow->setCellPaddings(array(8,8,8,8));
				$table->addRow($headrow);
				
				/* Add Table rows */
				
				$row  = new My_Pdf_Table_Row();
				$cols = array();			
				
				$sNoCol = new My_Pdf_Table_Column();
				$sNoCol->setText('1','center','middle');
				$sNoCol->setWidth(30);
				$sNoCol->setHeight(600);
				$cols[] = $sNoCol;
			
				$invoiceDetails = 'Charge for purchase of '. $splInfo->rspspecial_title .' on '.$bookDetails->getbokbooking_date().' at '.$bookDetails->getbokbooking_timings();
				$descCol = new My_Pdf_Table_Column();
				$descCol->setText($invoiceDetails,'center','middle');
				$descCol->setWidth(270);			
				$cols[] = $descCol;
				
				$noofseatsCol  = new My_Pdf_Table_Column();				
				$noofseatsCol->setText($bookDetails->getbokparty_size(),'center','middle');
				$noofseatsCol->setWidth(70);
				$cols[] = $noofseatsCol;
				
				$lineTotalCol = new My_Pdf_Table_Column();
				$invAmt = str_replace('$','',$invoiceObject->getinvamount());
				$amt = round($invAmt,2);
				
				$actualAmt = "";
				
				if($splInfo->pricetype == 'PS'){
					$actualAmt = (int)$amt * (int)$bookDetails->getbokparty_size();
				}else{
					$actualAmt = $amt;
				}
				
				if($splInfo->pricetype == 'PS'){
						$priceCol = new My_Pdf_Table_Column();
						$priceCol->setText('$'.$amt.'/Per Seat','center','middle');
						$priceCol->setWidth(80);			
						$cols[] = $priceCol;
				
				}else{
						$priceCol = new My_Pdf_Table_Column();
						$priceCol->setText('$'.$actualAmt,'center','middle');
						$priceCol->setWidth(70);			
						$cols[] = $priceCol;
				
				}				
				
				$lineTotalCol->setText('$'.$actualAmt,'center','middle');
				$lineTotalCol->setWidth(80);			
				$cols[] = $lineTotalCol;
				
				$row->setColumns($cols);
			    $row->setFont($font, 8);
				$row->setBorder(My_Pdf::TOP, new Zend_Pdf_Style());
				$row->setBorder(My_Pdf::BOTTOM, new Zend_Pdf_Style());
				$row->setBorder(My_Pdf::LEFT, new Zend_Pdf_Style());
				$row->setBorder(My_Pdf::RIGHT, new Zend_Pdf_Style());
				$row->setCellPaddings(array(8,8,8,8));
				$table->addRow($row);				
	
				/* Print total row */
				$totCols = array();
				
				$sNoColTot = new My_Pdf_Table_Column();
				$sNoColTot->setText('','center','middle');
				$sNoColTot->setWidth(30);
				$sNoColTot->setHeight(600);
				$totCols[] = $sNoColTot;			
				
				$descTotCol = new My_Pdf_Table_Column();
				$descTotCol->setText('TOTAL','right','middle');
				$descTotCol->setWidth(270);			
				$totCols[] = $descTotCol;
				
				$noofseatsTotCol  = new My_Pdf_Table_Column();				
				$noofseatsTotCol->setText('','center','middle');
				$noofseatsTotCol->setWidth(70);
				$totCols[] = $noofseatsTotCol;
				
				$priceTotCol = new My_Pdf_Table_Column();
				$priceTotCol->setText('','center','middle');
				$priceTotCol->setWidth(80);			
				$totCols[] = $priceTotCol;		
							
				$lineTotalCol1 = new My_Pdf_Table_Column();
				$lineTotalCol1->setText('$'.$actualAmt,'center','middle');
				$lineTotalCol1->setWidth(80);			
				$totCols[] = $lineTotalCol1;
				
				$totRow  = new My_Pdf_Table_Row();
				$totRow->setColumns($totCols);			
				$totRow->setFont($font, 8);
				$totRow->setCellPaddings(array(8,8,8,8));
				$table->addRow($totRow);	
				
				/* Add Service Tax row */
				
				$serviceTaxCols = array();
				
				$sNoColTax = new My_Pdf_Table_Column();
				$sNoColTax->setText('','center','middle');
				$sNoColTax->setWidth(30);
				$sNoColTax->setHeight(600);
				$serviceTaxCols[] = $sNoColTax;

				$serviceTax = 'SERVICE TAX @ '.$invoiceObject->getinvservice_tax().'%';
				
				$descTaxCol = new My_Pdf_Table_Column();
				$descTaxCol->setText($serviceTax,'right','middle');
				$descTaxCol->setWidth(270);			
				$serviceTaxCols[] = $descTaxCol;
				
				$noofseatsTaxCol = new My_Pdf_Table_Column();				
				$noofseatsTaxCol->setText('','center','middle');
				$noofseatsTaxCol->setWidth(70);
				$serviceTaxCols[] = $noofseatsTaxCol;
				
				$priceTaxCol = new My_Pdf_Table_Column();
				$priceTaxCol->setText('','center','middle');
				$priceTaxCol->setWidth(80);			
				$serviceTaxCols[] = $priceTaxCol;
				
				$calcServicetax = round((($invoiceObject->getinvservice_tax() * ($actualAmt))/100),2);
				
				$lineTotalTaxCol = new My_Pdf_Table_Column();
				$lineTotalTaxCol->setText('$'.$calcServicetax,'center','middle');
				$lineTotalTaxCol->setWidth(80);	
						
				$serviceTaxCols[] = $lineTotalTaxCol;
								
				$servTaxRow  = new My_Pdf_Table_Row();
				$servTaxRow->setColumns($serviceTaxCols);
				$servTaxRow->setFont($font, 8);
				$servTaxRow->setCellPaddings(array(8,8,8,8));
				$table->addRow($servTaxRow);	
								
				
				
				/* Handling Charges row */
								
				$handlingChargesCols = array();
				
				$sNoColCharge = new My_Pdf_Table_Column();
				$sNoColCharge->setText('','center','middle');
				$sNoColCharge->setWidth(30);
				$sNoColCharge->setHeight(600);
				$handlingChargesCols[] = $sNoColCharge;
				
				$txnfee = 'TRANSACTION FEE @ '.$invoiceObject->getinvtxncharges().'%';
				
				$descChargeCol = new My_Pdf_Table_Column();
				$descChargeCol->setText($txnfee,'right','middle');
				$descChargeCol->setWidth(270);			
				$handlingChargesCols[] = $descChargeCol;
				
				$noofseatsChargeCol = new My_Pdf_Table_Column();				
				$noofseatsChargeCol->setText('','center','middle');
				$noofseatsChargeCol->setWidth(70);
				$handlingChargesCols[] = $noofseatsChargeCol;
				
				$priceChargeCol = new My_Pdf_Table_Column();
				$priceChargeCol->setText('','center','middle');
				$priceChargeCol->setWidth(80);			
				$handlingChargesCols[] = $priceChargeCol;
				
				$txnFeeTot = round((($invoiceObject->getinvtxncharges() * ($actualAmt))/100),2);
				
				$lineTotalChargeCol = new My_Pdf_Table_Column();
				$lineTotalChargeCol->setText('$'.$txnFeeTot,'center','middle');
				$lineTotalChargeCol->setWidth(80);						
				$handlingChargesCols[] = $lineTotalChargeCol;
								
				$txnChargeRow  = new My_Pdf_Table_Row();
				$txnChargeRow->setColumns($handlingChargesCols);
				$txnChargeRow->setFont($font, 8);
				$txnChargeRow->setCellPaddings(array(8,8,8,8));
				$table->addRow($txnChargeRow);
								
				/* Add Net Payable row */
										
				$netPayCols = array();
				
				$sNoColNetPay = new My_Pdf_Table_Column();
				$sNoColNetPay->setText('','center','middle');
				$sNoColNetPay->setWidth(30);
				$sNoColNetPay->setHeight(600);
				$netPayCols[] = $sNoColNetPay;
				
				$descTaxNetPay = new My_Pdf_Table_Column();
				$descTaxNetPay->setText('NET PAYABLE TOTAL','right','middle');
				$descTaxNetPay->setWidth(270);			
				$netPayCols[] = $descTaxNetPay;
				
				$noofseatsTaxNetPay = new My_Pdf_Table_Column();				
				$noofseatsTaxNetPay->setText('','center','middle');
				$noofseatsTaxNetPay->setWidth(70);
				$netPayCols[] = $noofseatsTaxNetPay;
				
				$priceNetPay = new My_Pdf_Table_Column();
				$priceNetPay->setText('','center','middle');
				$priceNetPay->setWidth(80);			
				$netPayCols[] = $priceNetPay;
				
				$lineTotalNetPayCol = new My_Pdf_Table_Column();
				$lineTotalNetPayCol->setText('$'.$invoiceObject->getinvtotamount(),'center','middle');
				$lineTotalNetPayCol->setWidth(80);						
				$netPayCols[] = $lineTotalNetPayCol;				
				
				$netPayRow  = new My_Pdf_Table_Row();
				$netPayRow->setColumns($netPayCols);
				$netPayRow->setFont($font, 8);
				$netPayRow->setCellPaddings(array(8,8,8,8));
				$table->addRow($netPayRow);
								
				$page->addTable($table, 10, 200);
				$pdf->addPage($page);
				$pdf->save();
				
			}
						
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}	
	}
	
	/* Function for UList Module */
	
	public function Manage_Post_Payments($data)
	{
		try{
			$mapper  	   = new Payments_Model_AuthnetCustomerProfileMapper();
			$paymentMapper = new Payments_Model_AuthnetPaymentProfileMapper();
			$authHelperObj = new Uss_Helper_AuthNetHelper();
			
			//$storage = new Zend_Auth_Storage_Session();
		    //$data 	 = $storage->read();
		    
		    $authNet_Cust_ProfId = "";
		    $ancpid				 = "";
		    $result 		     = array();
		    
		    /* Check Whether Rest Owner has Authorized.Net Customer Profile */	    
		    $getAuthNetCustProfObj = new Payments_Model_GetAuthNetCustProfId();
		    $getAuthNetCustProfObj->setancpuser_id($data['User_Id']);
		    
		    $profileStatusMapper = new Application_Model_ProfileStatusDataMapper();
			$prfActStatusObj = $profileStatusMapper->getProfileStatusByCode('ACT');
			$prfInaStatusObj = $profileStatusMapper->getProfileStatusByCode('INA');
		    
	        $row = $mapper->GetAuthNetCustProfIdByUserId($getAuthNetCustProfObj);
		    if($row){
		    	$ancpid				 = $row->ancpid;
		    	$authNet_Cust_ProfId = $row->ProfileId;	
		    }
		    /* If no Profiles are found create a new Authorized.Net Customer profile */
		    if(!$authNet_Cust_ProfId){
	        /* Create Auth Net Customer Profile */
	
	         $custProfObj = new Payments_Model_AuthnetCustomerProfile();
	         $custProfObj->setancpuser_id($data['User_Id'])
	                     ->setancpprofile_description($data['Firstname']." ".$data['LastName'])
	                     ->setancpemail($data['Email']);
	
	         
		     $authNet_Cust_ProfId = $authHelperObj->CreateCustomerProfileRequest($custProfObj);
		     if($authNet_Cust_ProfId){
		     	/* Save Authorized.Net Customer Profile */

		     	date_default_timezone_set('EST5EDT'); 
			 	$date = date('Y-m-d');
			 	$time = date('h:i:s');
			 	
			 	$custProfObj->setancpcustomer_profile_id($authNet_Cust_ProfId);
			 	$custProfObj->setancpcreated_date($date);
			 	$custProfObj->setancpcreated_time($time);
			 	$custProfObj->setancpstatus($prfActStatusObj->getId());
		     	$ancpid = $mapper->SaveAuthNetCusomerProfile($custProfObj);	     	
		     	
		      }	      	
		    }
			$result['CustProfId'] = $authNet_Cust_ProfId;
			
			/* Check The Customer has payment profiles created */
			
			$paymentProfObj = new Payments_Model_GetAuthNetPaymentProfId();
			$paymentProfObj->setancpcustomer_profile_id($authNet_Cust_ProfId)
						   ->setancpstatus($prfActStatusObj->getId())
						   ->setanppstatus($prfActStatusObj->getId());
		   	 
			$resultSet = $paymentMapper->GetAuthNetPaymentProfIdByCustProfId($paymentProfObj);
			$custProfReq = array();
			$paymentProfileId = array();
			$paymentProfileType = array();
			$custProfReq = $authHelperObj->GetCustomerProfileRequest($authNet_Cust_ProfId);
			
			foreach($custProfReq as $key => $value){
				$paymentProfileId[] = $key;
				$paymentProfileType[$key] = $value['paymentType'];
			}
			
			$paymentIdObj = new Payments_Model_AuthnetPaymentProfile();
			date_default_timezone_set('EST5EDT');
		 	$date = date('Y-m-d');
		 	$time = date('h:i:s');
			$paymentIdObj->setanppcustomer_profile_id($ancpid);
			$paymentIdObj->setanppcreated_date($date);
			$paymentIdObj->setanppcreated_time($time);
			$paymentIdObj->setanpppayment_type($paymentProfileType);
			$paymentIdObj->setanppstatus($prfActStatusObj->getId());
			
			if(!count($resultSet) > 0){
				
				if(count($paymentProfileId) > 0){/* Save Payment Profile Id's*/
					
					$paymentIdObj->setanpppayment_profile_id($paymentProfileId);	
					$status = $paymentMapper->SavePaymentProfiles($paymentIdObj);					
					if($status){
						$resultSet = $paymentMapper->GetAuthNetPaymentProfIdByCustProfId($paymentProfObj);
					}
				}			
			}else if(count($resultSet) > 0 && count($paymentProfileId) > 0){
				
				/*Check Whether id's are new payment profile id's*/				
				$profileIdArray		   = array();
				$ureservSavedProfIdArr = array();
						
				
				foreach($resultSet as $results){
					$ureservSavedProfIdArr[] = $results->anpppayment_profile_id; 
				}				
				
				$profileIdArray['ureservSavedProfId'] = $ureservSavedProfIdArr;
				$profileIdArray['authNetProfId'] 	  = $paymentProfileId;
				$comparedArrs = array();				
				$comparedArrs = $this->ComparePaymentProfileIds($profileIdArray);

				if(count($comparedArrs) > 0 && count($comparedArrs['authNetNewProfId']) > 0){
					$paymentIdObj->setanpppayment_profile_id($comparedArrs['authNetNewProfId']);	
					$status = $paymentMapper->SavePaymentProfiles($paymentIdObj);					
					if($status){
						$resultSet = $paymentMapper->GetAuthNetPaymentProfIdByCustProfId($paymentProfObj);
					}
				}
				
				if(count($comparedArrs) > 0 && count($comparedArrs['authNetDeletedProfId']) > 0){
					$deletepaymentProfObj = new Payments_Model_DeletePaymentProfile();
					$deletepaymentProfObj->setPayemntProfId($comparedArrs['authNetDeletedProfId']);
					$deletepaymentProfObj->setStatus($prfInaStatusObj->getId());					
					$paymentMapper->DeletePaymentProfiles($deletepaymentProfObj);
					$resultSet = $paymentMapper->GetAuthNetPaymentProfIdByCustProfId($paymentProfObj);					
				}			
				
			}else if(count($resultSet) > 0 && count($paymentProfileId) == 0){
				
				$profileIdArray		   = array();
				$ureservSavedProfIdArr = array();
						
				
				foreach($resultSet as $results){
					$ureservSavedProfIdArr[] = $results->anpppayment_profile_id; 
				}				
				
				$profileIdArray['ureservSavedProfId'] = $ureservSavedProfIdArr;
				$profileIdArray['authNetProfId'] 	  = $paymentProfileId;
				$comparedArrs = array();				
				$comparedArrs = $this->ComparePaymentProfileIds($profileIdArray);
					
				$deletepaymentProfObj = new Payments_Model_DeletePaymentProfile();
				$deletepaymentProfObj->setPayemntProfId($comparedArrs['authNetDeletedProfId']);
				$deletepaymentProfObj->setStatus($prfInaStatusObj->getId());				
				$paymentMapper->DeletePaymentProfiles($deletepaymentProfObj);
				$resultSet = $paymentMapper->GetAuthNetPaymentProfIdByCustProfId($paymentProfObj);
			}
			
			$result['PaymentProfiles'] = $resultSet;
			$result['CC_AC_Details']   = $custProfReq;
				
		    return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage());
		} 
	}
	
	
	public function UListPostInvoice(Payments_Model_UListPostInvoice $UListPostInvoice)
	{
		try{		
			$UListPostInvoiceMapper =  new Payments_Model_UListPostInvoiceMapper();
			$invoiceId = $UListPostInvoiceMapper->CreateUListPostInvoice($UListPostInvoice);
			return $invoiceId;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	
	public function UListPostTransaction(Payments_Model_UListPostTransactions $UListPostTransactions)
	{
		try{
			
			$result = array();
			/* Get Payment Profile */

			$profileid = $UListPostTransactions->getulptxn_payment_profile_id();
			
			$paymentProfile = $this->GetPaymentProfileDetailsById($profileid);
			
			$customerProfileId = $paymentProfile->ancpcustomer_profile_id;
			$paymentProfileId  = $paymentProfile->anpppayment_profile_id;
			
			/* Initiate Transaction */
			
			$authCapTransObj = new Payments_Model_AuthCaptureTransaction();
			$authCapTransObj->setCustProfId($customerProfileId)
									->setCustPaymentProfId($paymentProfileId)
									->setAmount($UListPostTransactions->getulptxn_transaction_amount())
									->setInvoice($UListPostTransactions->getulptxn_invoice_number())
									->setRecurringBilling(false);
			$authNetHelperObj = new Uss_Helper_AuthNetHelper();
			$response = $authNetHelperObj->CreateAuthCaptureTransaction($authCapTransObj);
			
			if($response['transcode'] == 'I00001'){
				
				$txnid = $response['transid'];
				
				$UListPostTransactions->setulptxn_transaction_id($txnid);
				$UListPostTransactions->setulptxn_status(1);
				$objectArray = array();
				$objectArray['txnObject'] = $UListPostTransactions;
				
				$UListUpdatePostInvoiceStatusById = new Payments_Model_UListUpdatePostInvoiceStatusById();
				$UListUpdatePostInvoiceStatusById->setulpinv_id($UListPostTransactions->getulptxn_invoice_number()) ;
				$UListUpdatePostInvoiceStatusById->setulpinv_post_id($UListPostTransactions->getulptxn_post_id());
				$UListUpdatePostInvoiceStatusById->setulpinv_status(1);
				
				$objectArray['updateInveStatusObj'] = $UListUpdatePostInvoiceStatusById;
				
				$UListPostTransactionsMapper = new Payments_Model_UListPostTransactionsMapper();
				$status = $UListPostTransactionsMapper->saveTransactionDetails($objectArray);
				
				$result['status'] = true;
				$result['customerProfileId'] = $customerProfileId;
				$result['paymentProfileId']  = $paymentProfileId;	
				
			}else{
				$result['status'] = false;
			}
			
			return $result;
									
			
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetPaymentProfileDetailsById($paymentprofileid)
	{
		try{			
			
			/* Get Payment Profile */
			$RestAuthnetPaymentProfileMapMapper = new Payments_Model_RestAuthnetPaymentProfileMapMapper();
			$row = $RestAuthnetPaymentProfileMapMapper->getPaymentProfileById($paymentprofileid);
			return $row;
			
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	
	public function GeneratePostInvoicePdf(Payments_Model_UListPostInvoice $invoiceObject)
	{
		try{
			/* Reterieve Billing info  */
			$authHelperObj = new Uss_Helper_AuthNetHelper();
			$custProfReq = $authHelperObj->GetCustomerPaymentProfileRequest($invoiceObject->getcustprofid(),$invoiceObject->getauthprofid());
			$path = 'UList/PostInvoice';
			if(!file_exists($path)){
				mkdir($path,0777);
			}
			$invoiceDirPath = $path;
			
			$invoiceFilePath = $invoiceDirPath.'/'.$invoiceObject->getulpinv_id().'.pdf';
			if(!file_exists($invoiceFilePath)){
				
				$pdf = new My_Pdf_Document($invoiceFilePath, '.');
				$page = $pdf->createPage();
	
				$font = Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_HELVETICA);
				
				$page->setFont($font, 8);
				$page->setLineColor(new Zend_Pdf_Color_Rgb(0,100,0));
				$page->drawLine(-10, 15, ($page->getWidth()-0), 15);
				$imageurl = "../public/images/logo.png";
				
				$image = Zend_Pdf_Image::imageWithPath($imageurl);
				
				// write image to page
				$page->drawImage($image,-10,-30,80, 40);			
				
				$invoiceCreationDate = $invoiceObject->getulpinv_generated_date();
				$page->drawText('INVOICE', 500, 0);
				
				$page->drawText('UReserv Inc',15,45);
				$page->setFont($font, 6);
				$page->drawText('life just got easier ',15,55);
				
				/*Print Address*/
			    $page->drawText('464 Common Street,',15,65);
				$page->drawText('Suite 253,',15,75);
				$page->drawText('Belmont, MA 02478,',15,85);		
				$page->drawText('EMail: admin@ureserv.com',15,95);
				
				$invoiceNo  = "INVOICE#  ".$invoiceObject->getulpinv_id();
				$invoiceDate  = "DATE  ".$invoiceObject->getulpinv_generated_date();
	
				/* Print Invoice No and date on right hand side */
				$page->drawText($invoiceNo,450,45);
				$page->drawText($invoiceDate,450,55);
				
				/* Print Billing info */
				
				$page->setFont($font, 8);
				
				$page->drawText('TO',15,120);
				
				$page->setFont($font, 6);
				
				$paymentProfInfo = $custProfReq[$invoiceObject->getauthprofid()];
				
				$name = $paymentProfInfo['firstName']. " " .$paymentProfInfo['lastName'];
				$page->drawText($name,20,130);
				
				$address = $paymentProfInfo['address'].",";
				$page->drawText($address,20,140);
				
				$city_state = $paymentProfInfo['city']." - ".$paymentProfInfo['state'].",";
				$page->drawText($city_state,20,150);
				
				$country_zip = $paymentProfInfo['country']." - ".$paymentProfInfo['zip'].".";			
				$page->drawText($country_zip,20,160);
				
				
				/* Print Invoice details */
				
				$invoiceFrom = 'Invoice From: '.$invoiceObject->getulpinv_billing_fromdate();
				$page->drawText($invoiceFrom,400,130);
				
				$invoiceTo = 'Invoice To: '.$invoiceObject->getulpinv_billing_todate();
				$page->drawText($invoiceTo,400,140);
				
				/*$duedate = 'Due Date:';
				$page->drawText($duedate,400,150);*/
				
				/*$restId = 'Restaurant ID: '.$invoiceObject->getinvrestaurant_id();
				$page->drawText($restId,400,160);
	
				$planType = "Plan type: Monthly Subscription";
				$page->drawText($planType,400,170);*/
				
				/* Create table for printing  invoice desc and amount */
				
				
				
				$table = new My_Pdf_Table(6);
				/* Adding table header */
				$headrow  = new My_Pdf_Table_Row();
				$headcols = array();
						
				$sNo  = new My_Pdf_Table_Column();
				$sNo->setText("SNO",'center','middle');
				$sNo->setWidth(30);
				$sNo->setHeight(100);
				$headcols[] = $sNo;
					
				$itemTitle = new My_Pdf_Table_Column();
				$itemTitle->setText("ITEM TITLE",'center','middle');
				$itemTitle->setWidth(100);
				$headcols[] = $itemTitle;
	
				$description  = new My_Pdf_Table_Column();
				$description->setText("DESCRPTION",'center','middle');
				$description->setWidth(170);
				$headcols[] = $description;
					
				$price  = new My_Pdf_Table_Column();
				$price->setText("PRICE",'center','middle');
				$price->setWidth(70);
				$headcols[] = $price;
	
				$deductions  = new My_Pdf_Table_Column();
				$deductions->setText("DEDUCTIONS",'center','middle');
				$deductions->setWidth(80);
				$headcols[] = $deductions;
					
				$lineTotal  = new My_Pdf_Table_Column();
				$lineTotal->setText("LINE TOTAL",'center','middle');
				$lineTotal->setWidth(80);
				$headcols[] = $lineTotal;
				
				$headrow->setColumns($headcols);
				$headrow->setFont($font, 8);
				$headrow->setBorder(My_Pdf::TOP, new Zend_Pdf_Style());
				$headrow->setBorder(My_Pdf::BOTTOM, new Zend_Pdf_Style());
				$headrow->setBorder(My_Pdf::LEFT, new Zend_Pdf_Style());
				$headrow->setBorder(My_Pdf::RIGHT, new Zend_Pdf_Style());
				$headrow->setCellPaddings(array(8,8,8,8));
				$table->addRow($headrow);
				
				/* Add Table rows */
				
				$row  = new My_Pdf_Table_Row();
				$cols = array();			
				
				$sNoCol = new My_Pdf_Table_Column();
				$sNoCol->setText('1','center','middle');
				$sNoCol->setWidth(30);
				$sNoCol->setHeight(600);
				$cols[] = $sNoCol;
				
				$itemTitleCol = new My_Pdf_Table_Column();				
				$itemTitleCol->setText($invoiceObject->getulpinv_billing_fromdate(),'center','middle');
				$itemTitleCol->setWidth(100);			
				$cols[] = $itemTitleCol;				
				
				$invoiceDetails = 'Payment for your posting('. $invoiceObject->getposttitle() .') on UList';
				
				$descCol = new My_Pdf_Table_Column();
				$descCol->setText($invoiceDetails,'center','middle');
				$descCol->setWidth(170);			
				$cols[] = $descCol;
				
				$priceCol = new My_Pdf_Table_Column();
				$priceCol->setText('$'.$invoiceObject->getulpinv_amount(),'center','middle');
				$priceCol->setWidth(70);			
				$cols[] = $priceCol;
				
				$deductionCol = new My_Pdf_Table_Column();
				$deductionCol->setText('$0','center','middle');
				$deductionCol->setWidth(80);			
				$cols[] = $deductionCol;
				
				$lineTotalCol = new My_Pdf_Table_Column();
				$lineTotalCol->setText('$'.$invoiceObject->getulpinv_amount(),'center','middle');
				$lineTotalCol->setWidth(80);			
				$cols[] = $lineTotalCol;
				
				$row->setColumns($cols);
			    $row->setFont($font, 8);
				$row->setBorder(My_Pdf::TOP, new Zend_Pdf_Style());
				$row->setBorder(My_Pdf::BOTTOM, new Zend_Pdf_Style());
				$row->setBorder(My_Pdf::LEFT, new Zend_Pdf_Style());
				$row->setBorder(My_Pdf::RIGHT, new Zend_Pdf_Style());
				$row->setCellPaddings(array(8,8,8,8));
				$table->addRow($row);				
	
				/* Print total row */
				$totCols = array();
				
				$sNoColTot = new My_Pdf_Table_Column();
				$sNoColTot->setText('','center','middle');
				$sNoColTot->setWidth(30);
				$sNoColTot->setHeight(600);
				$totCols[] = $sNoColTot;
				
				$itemTitleTotCol = new My_Pdf_Table_Column();				
				$itemTitleTotCol->setText('','center','middle');
				$itemTitleTotCol->setWidth(100);			
				$totCols[] = $itemTitleTotCol;
				
				$descTotCol = new My_Pdf_Table_Column();
				$descTotCol->setText('TOTAL','right','middle');
				$descTotCol->setWidth(170);			
				$totCols[] = $descTotCol;
				
				$priceTotCol = new My_Pdf_Table_Column();
				$priceTotCol->setText('','center','middle');
				$priceTotCol->setWidth(70);			
				$totCols[] = $priceTotCol;
				
				$deductionTotCol = new My_Pdf_Table_Column();
				$deductionTotCol->setText('$0','center','middle');
				$deductionTotCol->setWidth(80);			
				$totCols[] = $deductionTotCol;
				
				$lineTotalCol1 = new My_Pdf_Table_Column();
				$lineTotalCol1->setText('$'.$invoiceObject->getulpinv_amount(),'center','middle');
				$lineTotalCol1->setWidth(80);			
				$totCols[] = $lineTotalCol1;
				
				$totRow  = new My_Pdf_Table_Row();
				$totRow->setColumns($totCols);			
				$totRow->setFont($font, 8);
				$totRow->setCellPaddings(array(8,8,8,8));
				$table->addRow($totRow);	
				
				/* Add Service Tax row */
				
				$serviceTaxCols = array();
				
				$sNoColTax = new My_Pdf_Table_Column();
				$sNoColTax->setText('','center','middle');
				$sNoColTax->setWidth(30);
				$sNoColTax->setHeight(600);
				$serviceTaxCols[] = $sNoColTax;
				
				$itemTitleTaxCol = new My_Pdf_Table_Column();				
				$itemTitleTaxCol->setText('','center','middle');
				$itemTitleTaxCol->setWidth(100);			
				$serviceTaxCols[] = $itemTitleTaxCol;
				
				$descTaxCol = new My_Pdf_Table_Column();
				$descTaxCol->setText('SERVICE TAX(%)','right','middle');
				$descTaxCol->setWidth(170);			
				$serviceTaxCols[] = $descTaxCol;
				
				$priceTaxCol = new My_Pdf_Table_Column();
				$priceTaxCol->setText('','center','middle');
				$priceTaxCol->setWidth(70);			
				$serviceTaxCols[] = $priceTaxCol;
				
				$deductionTaxCol = new My_Pdf_Table_Column();
				$deductionTaxCol->setText('','center','middle');
				$deductionTaxCol->setWidth(80);			
				$serviceTaxCols[] = $deductionTaxCol;
				
				$lineTotalTaxCol = new My_Pdf_Table_Column();
				$lineTotalTaxCol->setText($invoiceObject->getulpinv_service_tax().'%','center','middle');
				$lineTotalTaxCol->setWidth(80);	
						
				$serviceTaxCols[] = $lineTotalTaxCol;
				
				
				$servTaxRow  = new My_Pdf_Table_Row();
				$servTaxRow->setColumns($serviceTaxCols);
				$servTaxRow->setFont($font, 8);
				$servTaxRow->setCellPaddings(array(8,8,8,8));
				$table->addRow($servTaxRow);	
				
				
					/* Add Service Tax Toatal row */
				
				$serviceTaxTotCols = array();
				
				$sNoColTaxTot = new My_Pdf_Table_Column();
				$sNoColTaxTot->setText('','center','middle');
				$sNoColTaxTot->setWidth(30);
				$sNoColTaxTot->setHeight(600);
				$serviceTaxTotCols[] = $sNoColTaxTot;
				
				$itemTitleTaxTotCol = new My_Pdf_Table_Column();				
				$itemTitleTaxTotCol->setText('','center','middle');
				$itemTitleTaxTotCol->setWidth(100);			
				$serviceTaxTotCols[] = $itemTitleTaxTotCol;
				
				$descTaxTotCol = new My_Pdf_Table_Column();
				$descTaxTotCol->setText('SERVICE TAX TOTAL','right','middle');
				$descTaxTotCol->setWidth(170);			
				$serviceTaxTotCols[] = $descTaxTotCol;
				
				$priceTaxTotCol = new My_Pdf_Table_Column();
				$priceTaxTotCol->setText('','center','middle');
				$priceTaxTotCol->setWidth(70);			
				$serviceTaxTotCols[] = $priceTaxTotCol;
				
				$deductionTaxTotCol = new My_Pdf_Table_Column();
				$deductionTaxTotCol->setText('','center','middle');
				$deductionTaxTotCol->setWidth(80);			
				$serviceTaxTotCols[] = $deductionTaxTotCol;
				
				$lineTotalTaxTotCol = new My_Pdf_Table_Column();
				$lineTotalTaxTotCol->setText('$'.$invoiceObject->getulpinv_amount(),'center','middle');
				$lineTotalTaxTotCol->setWidth(80);						
				$serviceTaxTotCols[] = $lineTotalTaxTotCol;
				
				
				$servTaxTotRow  = new My_Pdf_Table_Row();
				$servTaxTotRow->setColumns($serviceTaxTotCols);
				$servTaxTotRow->setFont($font, 8);
				$servTaxTotRow->setCellPaddings(array(8,8,8,8));
				$table->addRow($servTaxTotRow);
				
				/* Handling Charges row */
				
				
				$handlingChargesCols = array();
				
				$sNoColCharge = new My_Pdf_Table_Column();
				$sNoColCharge->setText('','center','middle');
				$sNoColCharge->setWidth(30);
				$sNoColCharge->setHeight(600);
				$handlingChargesCols[] = $sNoColCharge;
				
				$itemTitleChargeCol = new My_Pdf_Table_Column();				
				$itemTitleChargeCol->setText('','center','middle');
				$itemTitleChargeCol->setWidth(100);			
				$handlingChargesCols[] = $itemTitleChargeCol;
				
				$descChargeCol = new My_Pdf_Table_Column();
				$descChargeCol->setText('TRANSACTION FEE','right','middle');
				$descChargeCol->setWidth(170);			
				$handlingChargesCols[] = $descChargeCol;
				
				$priceChargeCol = new My_Pdf_Table_Column();
				$priceChargeCol->setText('','center','middle');
				$priceChargeCol->setWidth(70);			
				$handlingChargesCols[] = $priceChargeCol;
				
				$deductionChargeCol = new My_Pdf_Table_Column();
				$deductionChargeCol->setText('','center','middle');
				$deductionChargeCol->setWidth(80);			
				$handlingChargesCols[] = $deductionChargeCol;
				
				$lineTotalChargeCol = new My_Pdf_Table_Column();
				$lineTotalChargeCol->setText($invoiceObject->getulpinv_txn_charges().'%','center','middle');
				$lineTotalChargeCol->setWidth(80);						
				$handlingChargesCols[] = $lineTotalChargeCol;
				
				
				$txnChargeRow  = new My_Pdf_Table_Row();
				$txnChargeRow->setColumns($handlingChargesCols);
				$txnChargeRow->setFont($font, 8);
				$txnChargeRow->setCellPaddings(array(8,8,8,8));
				$table->addRow($txnChargeRow);
				
				
				/* Add Net Payable row */
										
				$netPayCols = array();
				
				$sNoColNetPay = new My_Pdf_Table_Column();
				$sNoColNetPay->setText('','center','middle');
				$sNoColNetPay->setWidth(30);
				$sNoColNetPay->setHeight(600);
				$netPayCols[] = $sNoColNetPay;
				
				$itemTitleTNetPay = new My_Pdf_Table_Column();				
				$itemTitleTNetPay->setText('','center','middle');
				$itemTitleTNetPay->setWidth(100);			
				$netPayCols[] = $itemTitleTNetPay;
				
				$descTaxNetPay = new My_Pdf_Table_Column();
				$descTaxNetPay->setText('NET PAYABLE TOTAL','right','middle');
				$descTaxNetPay->setWidth(170);			
				$netPayCols[] = $descTaxNetPay;
				
				$priceNetPay = new My_Pdf_Table_Column();
				$priceNetPay->setText('','center','middle');
				$priceNetPay->setWidth(70);			
				$netPayCols[] = $priceNetPay;
				
				$deductionNetPayCol = new My_Pdf_Table_Column();
				$deductionNetPayCol->setText('','center','middle');
				$deductionNetPayCol->setWidth(80);			
				$netPayCols[] = $deductionNetPayCol;
				
				$lineTotalNetPayCol = new My_Pdf_Table_Column();
				$lineTotalNetPayCol->setText('$'.$invoiceObject->gettotalamt(),'center','middle');
				$lineTotalNetPayCol->setWidth(80);						
				$netPayCols[] = $lineTotalNetPayCol;
				
				
				$netPayRow  = new My_Pdf_Table_Row();
				$netPayRow->setColumns($netPayCols);
				$netPayRow->setFont($font, 8);
				$netPayRow->setCellPaddings(array(8,8,8,8));
				$table->addRow($netPayRow);
							
				
				$page->addTable($table, 10, 200);
				$pdf->addPage($page);
				$pdf->save();
				
			}
						
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}	
	}

	public function GetPaymentProfileByRestId($restid)
	{
		try
		{
			/* Reterieve Customer and Payment profile Id's */
			$profileByRestIdObj = new Payments_Model_GetPaymentProfileByRestId();
			$profileByRestIdObj->setrappmrestaurant_id($restid)
							   ->setrappmstatus(1)
							   ->setanppstatus(1)
							   ->setancpstatus(1);
		   	
			$authNetProfMapper = new Payments_Model_AuthnetPaymentProfileMapper();
			$rowSet = $authNetProfMapper->GetPaymentProfileByRestId($profileByRestIdObj);
			
			return $rowSet;
			
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GenerateInvoiceForOfflinePaymentsFromAdmin(Payments_Model_Invoice $invoiceObj)
	{
		try
		{
			/* Check Whether invoice was generated previous */
			$InvoiceMapper = new Payments_Model_InvoiceMapper();
			$row = $InvoiceMapper->CheckInvoiceGenerated($invoiceObj);
			$status = false;
			$restid = $invoiceObj->getinvrestaurant_id();
			
			date_default_timezone_set('EST5EDT'); 
			$invoiceGenDate = date('Y-m-d');
		 	$invoiceGenTime = date('h:i');
		 		
		 	if($invoiceObj->getinv_discount() && $invoiceObj->getinv_discount() != "" && $invoiceObj->getinv_discount() != 0)
		 	{
		 		$totamount =  round($invoiceObj->getinvamount() + (($invoiceObj->getinvamount() * 2.5)/100),2);
		 		$totamount = $totamount - (($totamount * $invoiceObj->getinv_discount())/100);
		 	}else
		 	{
		 		$totamount =  round($invoiceObj->getinvamount() + (($invoiceObj->getinvamount() * 2.5)/100),2);
		 	}		 	
		 	
		 	$invoiceObj->setinvtotamount($totamount);
		 	
			if($row)
			{
				$invoiceObj->setinvid($row->invid);
				/* Check Whether invoice amount is same if not update invoice */
				if(!$row->invamount == $invoiceObj->getinvamount()){
					
					$invoiceObj->setinvupdated_date($invoiceGenDate);
					$invoiceObj->setinvgenerated_time($invoiceGenTime);
					
					$InvoiceMapper->UpdateInvoice($invoiceObj);		
				}
			}else /* Create New Invoice */ 
			{
				$invoiceObj->setinvgenerated_date($invoiceGenDate);
				$invoiceObj->setinvgenerated_time($invoiceGenTime);
				$invoiceObj->setinvservice_tax(0);
				$invoiceObj->setinvtxncharges(2.5);
				
				$invoiceid = $InvoiceMapper->CreateInvoice($invoiceObj);
				$invoiceObj->setinvid($invoiceid);
				//echo '<pre>'; print_r($invoiceid); exit;
			}
			
			$profileStatusMapper = new Application_Model_ProfileStatusDataMapper();
			$prfActStatusObj = $profileStatusMapper->getProfileStatusByCode('ACT');
			
			$restPaymentPlanStatusMapper = new Application_Model_RestPaymentPlanStatusDataMapper();
			$rppmActStatusObj = $restPaymentPlanStatusMapper->getRestPaymentPlanStatusByCode('ACT');
			
			$txnTypeMapper = new Application_Model_TransactionTypeDataMapper();
			$debitTxn = $txnTypeMapper->getTransactionTypeByCode('DR');
			
			$txnStatusMapper = new Application_Model_TransactionStatusDataMapper();
			$successfulTxn = $txnStatusMapper->getTransactionStatusByCode('I00001');
			
			$subplanStatusMapper = new Application_Model_SubscriptionPlanStatusDataMapper();
			$subPlanStatus = $subplanStatusMapper->GetSubscriptionStatusByCode(array('ACT'));				
			$actSubPlanStatus = $subPlanStatus['ACT'];
			
			$invoiceStatusMapper = new Application_Model_InvoiceStatusDataMapper();
			$paidinvStatus = $invoiceStatusMapper->getInvoiceStatusByCode('PD');
				
			/* Reterieve Customer and Payment profile Id's */
			
			$profileByRestIdObj = new Payments_Model_GetPaymentProfileByRestId();
			$profileByRestIdObj->setrappmrestaurant_id($restid)
							   ->setrappmstatus($prfActStatusObj->getId())
							   ->setanppstatus($prfActStatusObj->getId())
							   ->setancpstatus($prfActStatusObj->getId());
			
			$authNetProfMapper = new Payments_Model_AuthnetPaymentProfileMapper();
			$rowSet = $authNetProfMapper->GetPaymentProfileByRestId($profileByRestIdObj);
			
			$result = array();
				if($rowSet)
				{
					foreach($rowSet as $row){
						$anppid			   = $row->anppid;
						$customerProfileId = $row->ancpcustomer_profile_id;
						$paymentProfileId  = $row->anpppayment_profile_id;					
					}
					
					/* Initiate Transaction */
					if($invoiceObj && $invoiceObj instanceof Payments_Model_Invoice && $customerProfileId && $paymentProfileId)
					{
						$authCapTransObj = new Payments_Model_AuthCaptureTransaction();
						$authCapTransObj->setCustProfId($customerProfileId)
										->setCustPaymentProfId($paymentProfileId)
										->setAmount($totamount)
										->setInvoice($invoiceObj->getinvid())
										->setRecurringBilling(false);
						$authNetHelperObj = new Uss_Helper_AuthNetHelper();
						$response = $authNetHelperObj->CreateAuthCaptureTransaction($authCapTransObj);
						
						if($response['transcode'] == 'I00001')
						{
							$objectArray = array();
							$transactionId = $response['transid'];
							
							$resServ = new Application_Service_Restaurant();
							$timeZone = $resServ->GetRestaurantTimeZone($restid);
							date_default_timezone_set($timeZone);
			 				$currentDate = date('Y-m-d');
			 				$currentTime = date('h:i');
			 				
			 				$transMapperObject = new Payments_Model_TransactionsMapper();
			 				
			 				/* Prepare Transaction details object. */
			 				
							$transactionObject = new Payments_Model_Transactions();
							$transactionObject->settxnfk_restaurant($restid)
											  ->settxntransaction_id($response['transid'])
											  ->settxninvoice_number($invoiceObj->getinvid())
											  ->settxnpayment_profile_id($anppid)
											  ->settxntransaction_amount($invoiceObj->getinvtotamount())
											  ->settxntransaction_date($currentDate)
											  ->settxntransaction_time($currentTime)
											  ->settxndescription($invoiceObj->getinvdescription())
											  ->settxntransaction_type($debitTxn->getId())
											  ->settxnstatus($successfulTxn->getId());
											  
						    $txnid = $transMapperObject->saveTransactionDetailsForOfflinePayments($transactionObject);
						    
						    /* Create Subscription renewal and paid records */
						    
							$duedates = $invoiceObj->getinvduedates();
							$subrenewalarr = array();	
							$subpaidarr = array();
						  
							foreach($duedates as $dates)
							{
								$subscriptionRenewalObject = new Payments_Model_SubscriptionRenewal();
							  
								$subscriptionRenewalObject->setsrrestaurant_id($restid);	
								$subscriptionRenewalObject->setsrbilling_date($dates->fromdate);
								$subscriptionRenewalObject->setsramount($dates->amount);
								$subplanId = 0;
								   
								if($dates->amount == 30)
								{
									$subplanId = 1;	
								}else if($dates->amount == 60)
								{
									$subplanId = 3;	
								}	
								   						   
								$subscriptionRenewalObject->setsrplan_id($subplanId);
								$subscriptionRenewalObject->setsrbilling_fromdate($dates->fromdate);
								$subscriptionRenewalObject->setsrbilling_todate($dates->todate);
								$subscriptionRenewalObject->setsrstatus(1);	

								$subrenewalarr [] = $subscriptionRenewalObject;
							   
							   
								/* Subscription Paid Object */
								   
								$subscriptionPaidObject = new Payments_Model_SubscriptionPaid();
								$subscriptionPaidObject->setsubprestaurant_id($restid)
													  ->setsubptransaction_id($txnid)										   
													  ->setsubpbilling_date($currentDate)
													  ->setsubpamount($dates->amount)
													  ->setsubpplan_id($subplanId)
													  ->setsubpbilling_fromdate($dates->fromdate)
													  ->setsubpbilling_todate($dates->todate)
													  ->setsubp_status(1);
													   
								$subpaidarr[] = $subscriptionPaidObject;						   
							}
							
							/* Reterive Plan Detiails */
							
							$planDetailsObj = new Payments_Model_SubscriptionPlanDetailsByRestId();
							$planDetailsObj->setrppmrestaurant_id($restid);
							$planDetailsObj->setspplan_status($actSubPlanStatus->getId());
							$planDetailsObj->setrppmstatus($rppmActStatusObj->getId());
							
							$planMapperObj = new Payments_Model_SubscriptionPlansMapper();
						    $rowSet = $planMapperObj->GetSubscriptionPlanDetailsByRestId($planDetailsObj);
							
						    $planId       = "";
						    $planDuration = "";
						    $subscriptionAmount = "";
						   
						    foreach($rowSet as $row){
								$planId	            = $row->spid;
								$planDuration       = $row->spplan_duration;
								$subscriptionAmount = $row->spamount;
						    }
						    
						    /* Prepare subscription renewal Object */
							$billTodate   = trim($invoiceObj->getinvbilling_todate());
							$explodedDate = explode('-',$billTodate);
				 	 	   
							$Year  = $explodedDate[0];
							$Month = $explodedDate[1];
				 	 	     
							$newRenewalFromDate = "";
							$newRenewalToDate   = "";			 	 	   	   
				 	 	   
							$newRenewalFromDate = date('Y-m-d',mktime(0,0,0,$Month,15,$Year));
							$newRenewalToDate   = date('Y-m-d',mktime(0,0,0,$Month + $planDuration,14,$Year));		 	 	   
				 	 	   
							$subscriptionRenewalObject = new Payments_Model_SubscriptionRenewal();
							$renewStatus = $txnStatusMapper->getTransactionStatusByCode('RNW');
							$subscriptionRenewalObject->setsrrestaurant_id($restid)	
						   							 ->setsrbilling_date($newRenewalFromDate)
						   							 ->setsramount($subscriptionAmount)
						   							 ->setsrplan_id($planId)
						   							 ->setsrbilling_fromdate($newRenewalFromDate)
						   							 ->setsrbilling_todate($newRenewalToDate)
						   							 ->setsrstatus($renewStatus->getId());
						   							 
						   	if($newRenewalToDate > $newRenewalFromDate){						 
						   	  $subrenewalarr[] = $subscriptionRenewalObject;
                }
						   	
						   	$objectArray['subRenewalObj'] = $subrenewalarr;
						   	$objectArray['subPaidObj'] = $subpaidarr; 	
						   	
						   	/* Prepare Update Invoice object */
						 	$updateInvoiceStatusByIdObject  = new Payments_Model_UpdateInvoiceStatusById();
						 	$updateInvoiceStatusByIdObject->setinvid($invoiceObj->getinvid())
						 							   	  ->setinvrestaurant_id($restid)
						 							      ->setinvstatus(4);	
						 	$objectArray['updateInveStatusObj'] = $updateInvoiceStatusByIdObject; 	
						 	
						 	$status = $transMapperObject->SaveSubRenewalRecords($objectArray);
						 	//echo '<pre>'; print_r($status); exit;
							/* Generate Invoice Pdf */
							$invoiceObj->setcustprofid($customerProfileId);
							$invoiceObj->setpaymentprofid($paymentProfileId);
		   				 
							$pdfStatus = $this->GenerateInvoicePdf($invoiceObj);
		   				 
							if($status){
							
								$storage = new Zend_Auth_Storage_Session();
								$user = $storage->read();
								$resservice = new Application_Service_Restaurant();
								$restaurantName = $resservice->GetRestaurantNamesById($restid);
		
								$mailmapper = new Application_Service_Notification();
								$mailObj = new Notification_Model_Mail();
								$mailObj->setMsgCode('Restaurant_Creation_Conf');
								$name = $user['Firstname'].' '.$user['LastName'];
								$maildata = array('UserName' => $name,
									  'SenTo'    => $user['Email'],
									  'resname'	 => $restaurantName['restName']);
								$mailObj->setData($maildata);
								$mailStatus = $mailmapper->SendMail($mailObj);
							
								$InNumber = $invoiceObj->getinvid();
								$mailObj = new Notification_Model_Mail();
								$subject = 'Invoice-'.$InNumber.', Date:'.$currentDate;
								$path = 'managerest/'.$restid.'/invoice/'.$invoiceObj->getinvid().'.pdf';
								$mailObj->setMsgCode('Invoice');
								$maildata = array('UserName' => $name,
									  'subject'  =>	$subject,
									  'path'	 =>	$path,
									  'SenTo'    => $user['Email']);
								$mailObj->setData($maildata);
								
								$mailStatus = $mailmapper->SendMail($mailObj);
							}
							$result['status'] = 'true';
							$result['msg'] = $successfulTxn->getdescription();
					   }else
					   {					   		
							$failTxn = $txnStatusMapper->getTransactionStatusByCode(trim($response['transcode']));
					   		$result['status'] = 'false';
					   		$result['msg'] = $failTxn->getdescription();	  
					   }						
					}else
					{
						$result['status'] = 'false';
			   			$result['msg'] = 'There are no payment profiles associated with this restaurant';	
					}
				}else
				{
					$result['status'] = 'false';
			   		$result['msg'] = 'There are no payment profiles associated with this restaurant';	
				}
				return $result;
				
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function Manage_Rest_AuthNet_Subscription_Admin($request)
	{
		try{
			$mapper  	   = new Payments_Model_AuthnetCustomerProfileMapper();
			$paymentMapper = new Payments_Model_AuthnetPaymentProfileMapper();
			$authHelperObj = new Uss_Helper_AuthNetHelper();
			
		    $authNet_Cust_ProfId = "";
		    $ancpid				 = "";
		    $result 		     = array();
		    $userId 			 = '';
		    $fName				 = '';
		    $lName				 = '';
		    $email				 = '';		    
		    
		    /* Get Rest Owner Details By Rest Id */
		    $restId = $request->restaurantid;
		    
		    $owner = new ManageRestaurant_Model_OwnerByRestaurantId();
			$owner->setRestaurantId($restId);
			$restMapper = new ManageRestaurant_Model_RestaurantDataMapper();
			$resownername = $restMapper->getOwnerByRestId($owner);
		    
		    $userId = $resownername->getRestUser();
		    $fName  = $resownername->getOwnerFirstName();
		    $lName  = $resownername->getOwnerLastName();
		    $email  = $resownername->getOwnerEmail();
		    
		    /* Check Whether Rest Owner has Authorized.Net Customer Profile */	    
		    $getAuthNetCustProfObj = new Payments_Model_GetAuthNetCustProfId();
		    $getAuthNetCustProfObj->setancpuser_id($userId);
		    
		    $profileStatusMapper = new Application_Model_ProfileStatusDataMapper();
			$prfActStatusObj = $profileStatusMapper->getProfileStatusByCode('ACT');
			$prfInaStatusObj = $profileStatusMapper->getProfileStatusByCode('INA');
		    
	        $row = $mapper->GetAuthNetCustProfIdByUserId($getAuthNetCustProfObj);
		    if($row){
		    	$ancpid				 = $row->ancpid;
		    	$authNet_Cust_ProfId = $row->ProfileId;	
		    }
			
		    /* If no Profiles are found create a new Authorized.Net Customer profile */
		    if(!$authNet_Cust_ProfId){
	        /* Create Auth Net Customer Profile */
	
				$custProfObj = new Payments_Model_AuthnetCustomerProfile();
				$custProfObj->setancpuser_id($userId)
	                     ->setancpprofile_description($fName." ".$lName)
	                     ->setancpemail($email);
	
	         
				$authNet_Cust_ProfId = $authHelperObj->CreateCustomerProfileRequest($custProfObj);
				if($authNet_Cust_ProfId){
					/* Save Authorized.Net Customer Profile */

					date_default_timezone_set('EST5EDT'); 
					$date = date('Y-m-d');
					$time = date('h:i:s');
					
					$custProfObj->setancpcustomer_profile_id($authNet_Cust_ProfId);
					$custProfObj->setancpcreated_date($date);
					$custProfObj->setancpcreated_time($time);
					$custProfObj->setancpstatus($prfActStatusObj->getId());
					$ancpid = $mapper->SaveAuthNetCusomerProfile($custProfObj);	     	
				}	      	
		    }
			$result['CustProfId'] = $authNet_Cust_ProfId;
			
			/* Check The Customer has payment profiles created */
			$paymentProfObj = new Payments_Model_GetAuthNetPaymentProfId();
			$paymentProfObj->setancpcustomer_profile_id($authNet_Cust_ProfId)
						   ->setancpstatus($prfActStatusObj->getId())
						   ->setanppstatus($prfActStatusObj->getId());
		   	 
			$resultSet = $paymentMapper->GetAuthNetPaymentProfIdByCustProfId($paymentProfObj);
			$custProfReq = array();
			$paymentProfileId = array();
			$paymentProfileType = array();
			$custProfReq = $authHelperObj->GetCustomerProfileRequest($authNet_Cust_ProfId);
			
			foreach($custProfReq as $key => $value){
				$paymentProfileId[] = $key;
				$paymentProfileType[$key] = $value['paymentType'];
			}
			
			$paymentIdObj = new Payments_Model_AuthnetPaymentProfile();
			date_default_timezone_set('EST5EDT');
		 	$date = date('Y-m-d');
		 	$time = date('h:i:s');
			$paymentIdObj->setanppcustomer_profile_id($ancpid);
			$paymentIdObj->setanppcreated_date($date);
			$paymentIdObj->setanppcreated_time($time);
			$paymentIdObj->setanpppayment_type($paymentProfileType);
			$paymentIdObj->setanppstatus($prfActStatusObj->getId());
			
			if(!count($resultSet) > 0){
				
				if(count($paymentProfileId) > 0){/* Save Payment Profile Id's*/
					
					$paymentIdObj->setanpppayment_profile_id($paymentProfileId);	
					$status = $paymentMapper->SavePaymentProfiles($paymentIdObj);					
					if($status){
						$resultSet = $paymentMapper->GetAuthNetPaymentProfIdByCustProfId($paymentProfObj);
					}
				}			
			}else if(count($resultSet) > 0 && count($paymentProfileId) > 0){
				
				/*Check Whether id's are new payment profile id's*/				
				$profileIdArray		   = array();
				$ureservSavedProfIdArr = array();
				
				foreach($resultSet as $results){
					$ureservSavedProfIdArr[] = $results->anpppayment_profile_id; 
				}				
				
				$profileIdArray['ureservSavedProfId'] = $ureservSavedProfIdArr;
				$profileIdArray['authNetProfId'] 	  = $paymentProfileId;
				$comparedArrs = array();				
				$comparedArrs = $this->ComparePaymentProfileIds($profileIdArray);
				
				if(count($comparedArrs) > 0 && count($comparedArrs['authNetNewProfId']) > 0){
					$paymentIdObj->setanpppayment_profile_id($comparedArrs['authNetNewProfId']);	
					$status = $paymentMapper->SavePaymentProfiles($paymentIdObj);					
					if($status){
						$resultSet = $paymentMapper->GetAuthNetPaymentProfIdByCustProfId($paymentProfObj);
					}
				}
				
				if(count($comparedArrs) > 0 && count($comparedArrs['authNetDeletedProfId']) > 0){
					$deletepaymentProfObj = new Payments_Model_DeletePaymentProfile();
					$deletepaymentProfObj->setPayemntProfId($comparedArrs['authNetDeletedProfId']);
					$deletepaymentProfObj->setStatus($prfInaStatusObj->getId());					
					$paymentMapper->DeletePaymentProfiles($deletepaymentProfObj);
					$resultSet = $paymentMapper->GetAuthNetPaymentProfIdByCustProfId($paymentProfObj);					
				}			
				
			}else if(count($resultSet) > 0 && count($paymentProfileId) == 0){
				
				$profileIdArray		   = array();
				$ureservSavedProfIdArr = array();
						
				
				foreach($resultSet as $results){
					$ureservSavedProfIdArr[] = $results->anpppayment_profile_id; 
				}				
				
				$profileIdArray['ureservSavedProfId'] = $ureservSavedProfIdArr;
				$profileIdArray['authNetProfId'] 	  = $paymentProfileId;
				$comparedArrs = array();				
				$comparedArrs = $this->ComparePaymentProfileIds($profileIdArray);
					
				$deletepaymentProfObj = new Payments_Model_DeletePaymentProfile();
				$deletepaymentProfObj->setPayemntProfId($comparedArrs['authNetDeletedProfId']);
				$deletepaymentProfObj->setStatus($prfInaStatusObj->getId());				
				$paymentMapper->DeletePaymentProfiles($deletepaymentProfObj);
				$resultSet = $paymentMapper->GetAuthNetPaymentProfIdByCustProfId($paymentProfObj);
			}
			
			$result['PaymentProfiles'] = $resultSet;
			$result['CC_AC_Details']   = $custProfReq;
			
			$finalResult = array();
			//echo '<pre>'; print_r($custProfReq); exit;
			if($resultSet && $custProfReq)
			{
				/* Get Rest Payment Prof Id */
				$profMapMapper = new Payments_Model_RestAuthnetPaymentProfileMapMapper();
				$rowSet = $profMapMapper->getRestPaymentProfiles($userId);
				
				$assoPayProf = "";
				if($rowSet)
				{
					$row = $rowSet[$restId];
					if($row)
					{
						$assoPayProf = $row->anpppayment_profile_id;
					}
				}
				
				foreach($resultSet as $payProf)
				{
					$accountDetails = "";
					$accInfo = $custProfReq[$payProf->anpppayment_profile_id];
					if($accInfo['paymentType'] == 'CC'){
						$accountDetails = $accInfo['cardNumber']; 	
					}else if($accInfo['paymentType'] == 'EC'){
						$accountDetails = "Account No : ".$accInfo['accountNumber']."<br/>".'Routing No : '.$accInfo['routingNumber']; 
					}
					
					$status = "";
					if($assoPayProf && $assoPayProf == $payProf->anpppayment_profile_id)
					{
						$status = "y";
					}
					
					$finalResult[] = array('restaurantid'			=> $restId,
										   'anpppayment_profile_id'	=> $payProf->anpppayment_profile_id,
										   'anppid' 				=> $payProf->anppid,
										   'accountdetails'			=> $accountDetails,
										   'anppcreated_date'		=> $payProf->anppcreated_date." ".date('h:i:s A' ,strtotime($payProf->anppcreated_time)),
										   'status'					=> $status);
				}
			}
			//echo '<pre>'; print_r($finalResult); exit;
		    return $finalResult;
		    
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage());
		} 
	}
	
	public function InActivatePaymentProfile($request)
	{
		try
		{
			$restid = $request->restaurantid;
			
			$storage   = new Zend_Auth_Storage_Session();
			$data 	   = $storage->read();
			$userid    = $data['User_Id'];
			
			/* Reterieve restaurant timezone for date and time */
			$resServ  = new Application_Service_Restaurant();
			$timeZone = $resServ->GetRestaurantTimeZone($restid);
			date_default_timezone_set($timeZone);
 			$currentDate = date('Y-m-d');
 			$currentTime = date('h:i');
 			
 			$paymentProfileMapObject = new Payments_Model_RestAuthnetPaymentProfileMap(); 
			$paymentProfileMapObject->setrappmrestaurant_id($restid)
									->setrappminactivestatus(2)									
									->setupdatedby($userid)
									->setupdateddate($currentDate)
									->setupdatedtime($currentTime);
									
			$profMapMapper = new Payments_Model_RestAuthnetPaymentProfileMapMapper();			
			$result = $profMapMapper->InActiveRestPaymentProfile($paymentProfileMapObject);			
			return $result;
			
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage());
		} 
	}
	
	public function GetAdvancePaymentInfo($request)
	{
		try
		{
			$restaurantid = $request->restaurantid;
			$payduration = $request->payduration;
			
			$result = array();
			
			/* Reterieve restaurant timezone for date and time */
			$resServ  = new Application_Service_Restaurant();
			$timeZone = $resServ->GetRestaurantTimeZone($restaurantid);
			date_default_timezone_set($timeZone);
 			$todayDate = date('Y-m-d');
			
			/* Get Payment Profile By User Id */				
			
			$paymentProf = $this->GetPaymentProfileByRestId($restaurantid);	

			/* Check whether rest contains any payment profile */
			if(!$paymentProf)
			{
				$result['status'] = 'NP';
			}
			
			/* Get Rest Info */
			
			$restInfo = $resServ->GetRestaurantNamesById($restaurantid);
 			$result['restinfo'] = $restInfo;
 			  				
  			$currdateSplit = explode('-',$todayDate);	  				
  			$currYear  = $currdateSplit[0];
  			$currMonth = $currdateSplit[1];	  		
  				
  			$currMonth_15_Day  = date('Y-m-d',mktime(0,0,0,$currMonth,15,$currYear));
  			$nextMonth_14_Day  = date('Y-m-d',mktime(0,0,0,$currMonth+1,14,$currYear));	
  			
  			$billFromDate = "";
  			
  			if(strtotime($todayDate) <= strtotime($currMonth_15_Day))
  			{
  				$billFromDate = $currMonth_15_Day;
  			}else
  			{
  				$billFromDate = date('Y-m-d',mktime(0,0,0,$currMonth+1,15,$currYear));
  			}
  			
  			$subRenewalObject = new Payments_Model_SubscriptionRenewal(); 
  			$subRenewalObject->setsrrestaurant_id($restaurantid);
  			$subRenewalObject->setsrbilling_date($billFromDate);
  			
  			$renewalMapper = new Payments_Model_SubscriptionRenewalMapper();  			
  			$rowSet = $renewalMapper->RetrieveSubRenewalRecordForAdvPay($subRenewalObject);
  			
  			$subRenewalDate = "";
  			if($rowSet)
  			{
  				$subRenewalDate = $rowSet->srbilling_date;
  			}
  			
  			$dateArray = Array();
  			$Amt = 60;
  			$total = 0;
  			
  			if($subRenewalDate)
  			{
	  			$result['status'] 	= 'T';
	  			$subRenewalDateSplit = explode('-',$subRenewalDate);
	  			$subRenwYear = $subRenewalDateSplit[0];	  
	  			$subRenwMonth = $subRenewalDateSplit[1];
	  			
	  			$subRenewalDate_14 = date('Y-m-d',mktime(0,0,0,$subRenwMonth + 1 ,14,$subRenwYear));;
	  			$dateArray[] = array('fromdate'=>$subRenewalDate,'todate'=>$subRenewalDate_14,'amount'=>$Amt);
	  			$total = $total + $Amt;
	  			/*New dates*/
	  			
	  			for($i=1; $i<$payduration; $i++)
	  			{
	  				$dateArray[] = array('fromdate'=>date('Y-m-d',mktime(0,0,0,$subRenwMonth+$i ,15,$subRenwYear)),'todate'=>date('Y-m-d',mktime(0,0,0,$subRenwMonth+$i+1 ,14,$subRenwYear)),'amount'=>$Amt);
	  				$total = $total + $Amt;
	  			}
	  			
  			}else
  			{
  				$result['status'] 	= 'T';
  				$dateArray[] = array('fromdate'=>$currMonth_15_Day,'todate'=>$nextMonth_14_Day,'amount'=>$Amt);  			
	  			$total = $total + $Amt;
	  			/*New dates*/
	  			
	  			for($i=1; $i<=$payduration-1; $i++)
	  			{
	  				$dateArray[] = array('fromdate'=>date('Y-m-d',mktime(0,0,0,$currMonth+$i ,15,$currYear)),'todate'=>date('Y-m-d',mktime(0,0,0,$currMonth+$i+1 ,14,$currYear)),'amount'=>$Amt);
	  				$total = $total + $Amt;
	  			}
  			}  	
  					
			$totalAmount 	 			  = round($total + (($total * 2.5)/100),2);
			$result['dates'] 			  = $dateArray;
  			$result['total'] 		      = $total;
  			$result['totalwithtxncharge'] = $totalAmount;
  			$result['txncharge'] 		  =  round(($total * 2.5)/100,2);
			
			return $result;
			
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage());
		} 
	}
}
