<?php
/**
 *	Name			: Reservation.php
 *	Author			: Snehal
 *	Creation Date	: 9/30/2010
 *	Path 			: application/services/Reservation.php
 *	Description		: This is the service class for the booking module.
 *
 */
class Application_Service_Reservation
{
	/**
	 * Instance variable of the form
	 * @var array
	 */
	protected $_form = array();

	/**
	 * @param instance of zend form
	 */
	public function setCustBookHistForm(Zend_Form $form)
	{
		$this->_form['CustBookHist'] = $form;
	}

	/**
	 * @return instance of form
	 */
	public function getCustBookHistForm()
	{
		if(empty($this->_form['CustBookHist'])) {
			$this->setCustBookHistForm(new Reservation_Form_CustBookHist());
		}
		return $this->_form['CustBookHist'];
	}

	/**
	 * @param instance of zend form
	 */
	public function setBookingDetailsForm(Zend_Form $form)
	{
		$this->_form['BookingDetails'] = $form;
	}

	/**
	 * @return instance of form
	 */
	public function getBookingDetailsForm()
	{
		if(empty($this->_form['BookingDetails'])) {
			$this->setBookingDetailsForm(new Reservation_Form_ReservationDetails());
		}
		return $this->_form['BookingDetails'];
	}

	/**
	 * @param instance of zend form
	 */
	public function setMakeReservationForm(Zend_Form $form)
	{
		$this->_form['MakeReservation'] = $form;
	}

	/**
	 * @return instance of form
	 */
	public function getMakeReservationForm()
	{
		if(empty($this->_form['MakeReservation'])) {
			$this->setMakeReservationForm(new Reservation_Form_MakeReservation());
		}
		return $this->_form['MakeReservation'];
	}
	
	public function setQuoteTimeSettingsForm(Zend_Form $form)
	{
		$this->_form['QuoteTimeSettings'] = $form;
	}

	/**
	 * @return instance of form
	 */
	public function getQuoteTimeSettingsForm()
	{
		if(empty($this->_form['QuoteTimeSettings'])) {
			$this->setQuoteTimeSettingsForm(new Reservation_Form_QuoteTimeSettings());
		}
		return $this->_form['QuoteTimeSettings'];
	}

	public function setMakeResevMobileForm(Zend_Form $form)
	{
		$this->_form['MakeResvMobile'] = $form;
	}

	/**
	 * @return instance of form
	 */
	public function getMakeResevMobileForm()
	{
		if(empty($this->_form['MakeResvMobile'])) {
			$this->setMakeResevMobileForm(new Phone_Form_MakeReservation());
		}
		return $this->_form['MakeResvMobile'];
	}

	public function setMakeWalkinMobileForm(Zend_Form $form)
	{
		$this->_form['MakeWalkinMobile'] = $form;
	}

	/**
	 * @return instance of form
	 */
	public function getMakeWalkinMobileForm()
	{
		if(empty($this->_form['MakeWalkinMobile'])) {
			$this->setMakeWalkinMobileForm(new Phone_Form_MakeWalkinReserv());
		}
		return $this->_form['MakeWalkinMobile'];
	}
	
	public function setMakeWaitingMobileForm(Zend_Form $form)
	{
		$this->_form['MakeWaitingMobile'] = $form;
	}

	/**
	 * @return instance of form
	 */
	public function getMakeWaitingMobileForm()
	{
		if(empty($this->_form['MakeWaitingMobile'])) {
			$this->setMakeWaitingMobileForm(new Phone_Form_MakeWaitingReserv());
		}
		return $this->_form['MakeWaitingMobile'];
	}
	
	/**
	 * @param instance of zend form
	 */
	public function setWaitingReservForm(Zend_Form $form)
	{
		$this->_form['WaitingReserv'] = $form;
	}

	/**
	 * @return instance of form
	 */
	public function getWaitingReservForm()
	{
		if(empty($this->_form['WaitingReserv'])) {
			$this->setWaitingReservForm(new Reservation_Form_WaitingReserv());
		}
		return $this->_form['WaitingReserv'];
	}
	
	public function setWaitingKioskReservForm(Zend_Form $form)
	{
		$this->_form['WaitingKioskReserv'] = $form;
	}

	/**
	 * @return instance of form
	 */
	public function getWaitingKioskReservForm()
	{
		if(empty($this->_form['WaitingKioskReserv'])) {
			$this->setWaitingKioskReservForm(new Reservation_Form_CustomerKioskReservation());
		}
		return $this->_form['WaitingKioskReserv'];
	}

	/**
	 * @param instance of zend form
	 */
	public function setBlockReservForm(Zend_Form $form)
	{
		$this->_form['BlockReserv'] = $form;
	}

	/**
	 * @return instance of form
	 */
	public function getBlockReservForm()
	{
		if(empty($this->_form['BlockReserv'])) {
			$this->setBlockReservForm(new Reservation_Form_BlockReserv());
		}
		return $this->_form['BlockReserv'];
	}

	/**
     * @param instance of zend form
     */
	public function setRestTableForm(Zend_Form $form)
	{
		$this->_form['RestTable'] = $form;
	}
	/**
     * @return instance of form
     */
	public function getRestTableForm()
	{
		if(empty($this->_form['RestTable'])) {
			$this->setRestTableForm(new FirmManagement_Form_FirmTable());
		}
		return $this->_form['RestTable'];
	}
	/**
	 * @param instance of zend form
	 */
	public function setWalkInReservForm(Zend_Form $form)
	{
		$this->_form['WalkInReserv'] = $form;
	}

	/**
	 * @return instance of form
	 */
	public function getWalkInReservForm()
	{
		if(empty($this->_form['WalkInReserv'])) {
			$this->setWalkInReservForm(new Reservation_Form_WalkInReserv());
		}
		return $this->_form['WalkInReserv'];
	}
	
	/**
	 * @param instance of zend form
	 */
	public function setRescheduleReservationForm(Zend_Form $form)
	{
		$this->_form['RescheduleReservation'] = $form;
	}

	/**
	 * @return instance of form
	 */
	public function getRescheduleReservationForm()
	{
		if(empty($this->_form['RescheduleReservation'])) {
			$this->setRescheduleReservationForm(new Reservation_Form_RescheduleReservation());
		}
		return $this->_form['RescheduleReservation'];
	}

	/**
	 * @param instance of zend form
	 */
	public function setFreezeRestaurantForm(Zend_Form $form)
	{
		$this->_form['FreezeRestaurant'] = $form;
	}

	/**
	 * @return instance of form
	 */
	public function getFreezeRestaurantForm()
	{
		if(empty($this->_form['FreezeRestaurant'])) {
			$this->setFreezeRestaurantForm(new Reservation_Form_FreezeRestaurant());
		}
		return $this->_form['FreezeRestaurant'];
	}

	/**
	 * @param instance of zend form
	 */
	public function setAddCustomerContactForm(Zend_Form $form)
	{
		$this->_form['AddCustomerContact'] = $form;
	}

	/**
	 * @return instance of form
	 */
	public function getAddCustomerContactForm()
	{
		if(empty($this->_form['AddCustomerContact'])) {
			$this->setAddCustomerContactForm(new Reservation_Form_AddCustomerContact());
		}
		return $this->_form['AddCustomerContact'];
	}
	public function setBookingConfirmationForm(Zend_Form $form)
	{
		$this->_form['BookingConfirmation'] = $form;
	}

	/**
	 * @return instance of form
	 */
	public function getBookingConfirmationForm()
	{
		if(empty($this->_form['BookingConfirmation'])) {
			$this->setBookingConfirmationForm(new Reservation_Form_ReservationConfirmation());
		}
		return $this->_form['BookingConfirmation'];
	}

	/**
	 * @param instance of request and page
	 * retreives the restaurants available slots for the search
	 */
	public function SearchListView($request,$page)
	{
		try{
			$bokService = new Application_Service_Reservation();
			$mapper = new Reservation_Model_SearchListViewDataMapper();
			$searchList = new Reservation_Model_SearchListView();
			$searchList->setPax($request->pax);
			if($request->filresid){
				$searchList->setResId($request->filresid);
			}else if($request->resname != 'Select Restaurant Name' && $request->resname!= 'Enter Restaurant Name'){
				$searchList->setRestaurantname(trim($request->resname));
			}
			if($request->price){
				$price = $bokService->GetRestaurantPriceBaseData();
				$pricedec = $request->price;
				$searchList->setPrice($pricedec);
			}
			if($request->state != ""){
				$searchList->setState($request->state);
			}
			if($request->region != ""){
				$searchList->setRegion($request->region);
			}
			if($request->city != ""){
				$searchList->setCity($request->city);
			}
			if($request->neighbor != ""){
				$searchList->setNeighbor($request->neighbor);
			}
			if($request->cuisine != 0){
				$searchList->setCuisine($request->cuisine);
			}


			$dateSplit = explode("-",$request->date);
			$weekday = date("D", mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]));
			$searchList->setDay(strtolower($weekday));
			$searchList->setTime($request->time);
			$searchList->setOffset($page);
			$searchList->setDate($request->date);
			$searchList->setLimit(2);

			$searchList = $mapper->getSearchList($searchList);
			$result = array(
        	'searchList'=>$searchList,
        	'time'=>$request->time,
        	'date'=>$request->date,
			'pax'=>$request->pax,
        	'resid'=>$request->resid

			);

			if($request->price){
				$result['price'] = $pricedec;
			}
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param instance of request
	 * retreives the restaurants(informational only) for the search
	 */
	public function SearchRestaurants($request)
	{
		try{
			$bokService = new Application_Service_Reservation();
			$mapper = new Reservation_Model_SearchListViewDataMapper();
			$searchList = new Reservation_Model_SearchListView();

			if($request->filresid){
				$searchList->setResId($request->filresid);
			}else if($request->resname != 'Select Restaurant Name' && $request->resname!= 'Enter Restaurant Name'){
				$searchList->setRestaurantname(trim($request->resname));
			}
			/*if($request->resname != 'Select Restaurant Name' && $request->resname!= 'Enter Restaurant Name'){
				$searchList->setRestaurantname(trim($request->resname));
				}*/
			if(isset($request->price)){
				$searchList->setPrice($request->price);
			}
			if($request->state != ""){
				$searchList->setState($request->state);
			}
			if($request->region != 0 && $request->region != ""){
				$searchList->setRegion($request->region);
			}
			if($request->city != 0 && $request->city != ""){
				$searchList->setCity($request->city);
			}
			if($request->neighbor != 0 && $request->neighbor != ""){
				$searchList->setNeighbor($request->neighbor);
			}
			if($request->cuisine != 0 && $request->cuisine != ""){
				$searchList->setCuisine($request->cuisine);
			}
			if(isset($request->event)){
				$searchList->setevent($request->event);
			}
			if(isset($request->offset)){
				$searchList->setOffset($request->offset);
			}

			$searchList2 = $mapper->getRestaurantList($searchList,$request);

			return $searchList2;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param instance of request
	 * retreives the restaurants special (informational and purchasable) for the search
	 */
	public function SearchRestaurantsSpecialslistview($request)
	{
		try{
			$bokService = new Application_Service_Reservation();
			$mapper = new Reservation_Model_SearchListViewDataMapper();
			$searchList = new Reservation_Model_SearchListView();

			if(isset($request->price)){
				$searchList->setPrice($request->price);
			}
			if($request->state != ""){
				$searchList->setState($request->state);
			}
			if($request->region != 0){
				$searchList->setRegion($request->region);
			}
			if($request->city != 0){
				$searchList->setCity($request->city);
			}
			if($request->neighbor != 0){
				$searchList->setNeighbor($request->neighbor);
			}
			if($request->cuisine != 0){
				$searchList->setCuisine($request->cuisine);
			}
			if(isset($request->event)){
				$searchList->setevent($request->event);
			}
			if(isset($request->offset)){
				$searchList->setOffset($request->offset);
			}
			
			if($request->date){
				$dateSplit = explode("-",$request->date);
				$weekday = date("D", mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]));
				
				$weekRecurrObj    = new Application_Model_WeekRecurr();
				$weekRecurrMapper = new Application_Model_WeekRecurrDataMapper();
				$weekRecurrObj->setcode(strtolower($weekday));
				$weekRecurrRes = $weekRecurrMapper->getWeekDayIdByCode($weekRecurrObj);
				$searchList->setDay(strtolower($weekday));																
				$searchList->setWeekDayId($weekRecurrRes->getId());
				$searchList->setDate($request->date);								
			}
			if($request->time){
				$searchList->setTime($request->time);
			}			
			$searchList = $mapper->getRestaurantSplList($searchList);

			return $searchList;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param array,state and city id
	 * function to save the booking details
	 */
	public function BookingDetails(array $data,$stateId,$cityId,$regionId,$source = 'web')
	{
		try{
			$form = $this->getBookingDetailsForm();
			if($form->isValid($data)){

				$formData = $form->getValues();
                               
				$mapper = new Reservation_Model_ReservationDataMapper();
				$dinerDetails = new Reservation_Model_Reservation();
				$userid = $formData['userid'];
                                $origin='';

				if(isset($formData['bokSrcComp']) && $formData['bokSrcComp'] != 1){
					$resModeMapper = new Application_Model_ReservationModeDataMapper();
					$resModeStatus 	  = $resModeMapper->GetReservationModeByCode(array($formData['bokSrcComp']));
					$resModeObj 	  = $resModeStatus[$formData['bokSrcComp']];
                                        $origin ='Restaurant Website';
				}else{
					$resModeMapper = new Application_Model_ReservationModeDataMapper();
                                        switch($formData['reservationfrom']){
                                            
                                            case 'FB':
                                                $resModeStatus 	  = $resModeMapper->GetReservationModeByCode(array('FB'));
						$resModeObj 	  = $resModeStatus['FB'];
                                                $origin = 'Facebook';
                                                break;
                                            case 'DWU':
                                                $resModeStatus 	  = $resModeMapper->GetReservationModeByCode(array('DWU'));                                                
						$resModeObj 	  = $resModeStatus['DWU'];
                                                $origin = 'DiningWithUs';
                                                break;
                                            case 'DWUSRC':
                                                $resModeStatus 	  = $resModeMapper->GetReservationModeByCode(array('DWUSRC'));                                                
						$resModeObj 	  = $resModeStatus['DWUSRC'];
                                                $origin = 'Restaurant Website';
                                                break;
                                            case 'DWUFB':
                                                $resModeStatus 	  = $resModeMapper->GetReservationModeByCode(array('DWUFB'));                                                
						$resModeObj 	  = $resModeStatus['DWUFB'];
                                                $origin = 'Facebook';
                                                break;
                                            case 'DWUTA':
                                                $resModeStatus 	  = $resModeMapper->GetReservationModeByCode(array('DWUTA'));                                               
 
						$resModeObj 	  = $resModeStatus['DWUTA'];
                                                $origin = 'Tripadvisor';
                                                break;
                                            case 'DWUFS':
                                                $resModeStatus 	  = $resModeMapper->GetReservationModeByCode(array('DWUFS'));                                                
						$resModeObj 	  = $resModeStatus['DWUFS'];
                                                $origin = 'Foursquare';
                                                break;
                                            default:
                                                $resModeStatus 	  = $resModeMapper->GetReservationModeByCode(array('INAT'));
						$resModeObj 	  = $resModeStatus['INAT'];
                                                $origin = 'Web';
                                                break;                                                                                            
                                        }                                        					
				}
                                
				$frmDM = new FirmManagement_Model_FirmDataMapper();
				$resAddress = $frmDM->getRestaurantDetailsById((int)$formData['resId']);
				$dinerDetails->setbokfk_restaurant((int)$formData['resId']);
				$dinerDetails->setresrestaurant_name($formData['resName']);
				$dinerDetails->setresaddress($resAddress->resaddress);
				$dinerDetails->setbokcompany_id($formData['resCompanyid']);
				$dinerDetails->setbokbooking_date($formData['resDate']);
				$dinerDetails->setbokbooking_timings($formData['resTime']);
				$dinerDetails->setbokparty_size((int)$formData['pax']);


				/* Reteriving Reservation Status Id by Code */
				$status[] = $formData['bookingStatus'];
				$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
				$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($status);
				$bookStatusRes = $bookStatusRes[$formData['bookingStatus']];
				$dinerDetails->setbokbooking_status_id($bookStatusRes->getId());
				$dinerDetails->setbokbooking_status($bookStatusRes->getId());


				$dinerDetails->setbokfirst_name($formData['firstName']);
				$dinerDetails->setboklast_name($formData['lastName']);
				$dinerDetails->setbokcountry_code($formData['countryCode']);
				$dinerDetails->setbokphone($formData['number']);
				$dinerDetails->setbokemail($formData['email']) ;
				$dinerDetails->setbokspecial_request($formData['dinerRequest']);
				if($formData['bokoptions']){
					$dinerDetails->setbokoptions($formData['bokoptions']);
				}
				if($formData['boksecoptions']){
					$dinerDetails->setboksecoptions($formData['boksecoptions']);
				}
				
				$resServ = new Application_Service_Firm();
				$timeZone = $resServ->GetRestaurantTimeZone($formData['resId']);
				date_default_timezone_set($timeZone);

				$dinerDetails->setbokbooking_made_on(date('Y-m-d H:i:s'));
				$dinerDetails->setBookingMadeTime(date("H:i",time()));
				$bookPhrase = uniqid ();
				$dinerDetails->setbokbookingphrase($bookPhrase);
				$payStat = false;
				$customerDetails = new User_Model_Guest();
				$bookTypeMapper = new Application_Model_ReservationTypeDataMapper();

				$paymentId = array();
				if($formData['specialamt']){
					$dinerDetails->setSpecialPrice($formData['specialamt']);
				} 
				if($formData['booktype']){
					$dinerDetails->setbokbooking_type_code($formData['booktype']);	
				}else{
					$dinerDetails->setbokbooking_type_code('NOR');
				}
				if($formData['specialid']){
					
					$splService = new Application_Service_Deals();	
					$splResult = $splService->GetWidgetSpecialDetailsById((int)$formData['resId'],$formData['specialid'],false);
					
					$dinerDetails->setSpecialId($formData['specialid']);
					$bookType = $bookTypeMapper->GetBookingTypeByCode($formData['booktype']);
					$dinerDetails->setbokuserid($formData['userid']);
					if($formData['paymentStatus'] == 'true'){
						$usrServ = new Application_Service_Client();
						$userResult = $usrServ->RegisterCustomerOnReservation($formData);
						if($userResult){
							$payStat = true;
							$dinerDetails->setbokuserid($userResult);
							$customerDetails->setUserid($userResult);
							$customerDetails->setEmail($formData['email']);
							
							if($splResult->getCatTypeCode() == 'SP'){
								$bookType = $bookTypeMapper->GetBookingTypeByCode('SPLPAID');
							}else if($splResult->getCatTypeCode() == 'CP'){
								$bookType = $bookTypeMapper->GetBookingTypeByCode('SPL');
							}
							
						}
					}
				}else if($formData['paymentStatus'] == 'true'){
					
				}else if($formData['paymentStatus'] == 0){
					$bookType = $bookTypeMapper->GetBookingTypeByCode('NOR');
					$dinerDetails->setbokuserid($formData['userid']);
				}
				
				$resDataMapper = new FirmManagement_Model_FirmDataMapper();
				$seetingArr = $resDataMapper->getScheduleSettingTypeByresId($formData['resId']);
				$dinerDetails->setbok_restsch_setting_id($seetingArr['settingId']);
				$dinerDetails->setbok_restsch_setting_type($seetingArr['settingType']);
				
				$dinerDetails->setbokreservation_mode_id($resModeObj->getId());
				$dinerDetails->setTableSize($formData['tablesize']);
				$dinerDetails->setNoOfTables($formData['nooftables']);
				$dinerDetails->setNotificationType('both');
				if($formData['inventoryid']){
					$dinerDetails->setInventoryId($formData['inventoryid']);
				}
				/* Reteriving Reservation Type Id by code */
				$formData['restaurantid'] = $formData['resId']; 
				$dinerDetails->setbokbooking_type_id($bookType->getId());
				
				$result = $mapper->saveBookingDetails($dinerDetails,$formData,$source);

				$dinerDetails->setbokid($result);
				$mailmapper = new Application_Service_Communication();
				//if($formData['notificationType'] == 'email'){
				if($result){
					$splresult = "";
					
					$restObj= new FirmManagement_Model_FirmById();
					$restObj->setRestaurantId($formData['resId']);
					$resDetails = $resDataMapper->getRestaurantById($restObj);
					if($formData['booktype'] == 'SPL'){
						$isAjaxCall = true;
						$splmapper = new Deals_Model_RestaurantSpecialDataMapper();
						$splresult = $splmapper->getRestaurantSplByBookingId($result,$isAjaxCall);
					}
//					if($formData['paymentStatus'] == 'false'){
						$mailObj = new Communication_Model_Mail();
						$rowSet = $resDataMapper->Getdiscountstatus($formData['resId']);
						if($source == 'web'){
							if($formData['email'] != ''){
								if($formData['bookingStatus'] == 'WAL')
								{
									if($stateId == ""){
										$stateCity = $this->getRestaurantStateByResId($formData['resId']);
										$stateId = $stateCity['state'];
										$cityId = $stateCity['city'];
										$regionId = $stateCity['region'];
	
									}
									$userType = 'CUS';
	
									$mailObj->setMsgCode('WalBookConf');
									$name = $formData['firstName'].' '.$formData['lastName'];
									$data = array('UserName' 			=> 	$name,
													'Bokid'				=>	$result,
												  'SenTo'    			=>	$formData['email'],
												  'RestName' 			=> 	$formData['resName'],
												  'ResDate'  			=> 	$formData['resDate'],
												  'Time'     			=> 	$formData['resTime'],
												  'Size'     			=> 	$formData['pax'],
												  'Address'	 			=> 	$formData['resAddress'],
												  'resphone' 			=> 	$resDetails->getres_country_code().$resDetails->getRestphone(),
												  'resemail'			=>	$resDetails->getRestemail(),
												  'rescity'				=>	$resDetails->getRestCityDesc(),
												  'resnbh'				=>	$resDetails->getRestNeighborDesc(),
												  'reszipcode'			=>	$resDetails->getRestzipcode(),	
												  'Status'	 			=> 	$formData['bookingStatus'],
												  'State_Id'			=>	$stateId,
												  'City_Id'				=>	$cityId,
												  'UserType'			=>	$userType
									);
									
									$mailObj->setData($data);
									$mailStatus = $mailmapper->SendMail($mailObj);
								}else{
									if($stateId == "" && $cityId == ""){
										$stateCity = $this->getRestaurantStateByResId($formData['resId']);
										$stateId = $stateCity['state'];
										$cityId = $stateCity['city'];
										$regionId = $stateCity['region'];
									}
									/* Restaurant discount message */
									$discountMsg = false;
									if($rowSet['msg']){
										$discountMsg = $rowSet['msg'];
									}
									$userType = 'CUS';
									/* Retrieve restaurant owner emails and cusotmer details */
									$restInfo = $mapper->ReterieveRestemails($formData['resId']);	
									$mailObj->setMsgCode('BookConf');
									$name = $formData['firstName'].' '.$formData['lastName'];
	
									$data = array(
												  'UserName' 			=> 	$name,
												  'SenTo'    			=> 	$formData['email'],
												  'RestEmails'			=>  $restInfo['emails'],
												  'RestName' 			=> 	$formData['resName'],
												  'ResDate'  			=> 	$formData['resDate'],
												  'Time'     			=> 	$formData['resTime'],
												  'Size'     			=>	$formData['pax'],
												  'Address'	 			=> 	$formData['resAddress'],
												  'resphone' 			=> 	$resDetails->getRestphone(),
												  'resemail'			=>	$resDetails->getRestemail(),
												  'phone'	 			=> 	$formData['number'],	
												  'Note'	 			=>	$formData['dinerRequest'],
												  'rescity'				=>	$resDetails->getRestCityDesc(),
												  'resnbh'				=>	$resDetails->getRestNeighborDesc(),
												  'reszipcode'			=>	$resDetails->getRestzipcode(),	
												  'Status'	 			=> 	$formData['bookingStatus'],
												  'Bokid'	 			=>	$result,
	//											  'BookingPhrase'		=>	$bookPhrase,
												  'State_Id'			=>	$stateId,
												  'City_Id'				=>	$cityId,
												  'UserType'			=>	$userType,
												  'BookNotf'			=>  true,
												  'DiscountMsg'			=>	$discountMsg
									);
									if($splresult){
										$data['splstatus']	= true;
										$data['splid'] 		= $splresult['Id'];
										$data['splname']	= $splresult['Special Name'];
										$data['spldesc'] 	= $splresult['Desc'];
										$data['splorgprice']= $splresult['Regular Price'];
										if($splresult['Discountcode'] == 'PER'){
											$data['spldiscount']= $splresult['Discount Percentage'].'%';	
										}else if($splresult['Discountcode'] == 'RE'){
											$data['spldiscount']= '$'.$splresult['Discount Percentage'];
										}
										$data['splprice'] 	= $splresult['Price with Discount'];
									}else{
										$data['splstatus']	= false;
									}
									
									$mailObj->setData($data);
									$mailStatus = $mailmapper->SendMail($mailObj);
								}
							}else if($formData['number'] != ''){
								$smsObj = new Communication_Model_Sms();
								$smsObj->setMsgCode('BookConf');
								$data = array(
								 'to'			=> trim($formData['number']),
								 'countrycode'	=> $formData['countryCode'],
								 'bokid'		=> $result,	
								 'RestName' 	=> $formData['resName'],
								 'ResDate'  	=> $formData['resDate'],
								 'Time'     	=> $formData['resTime'],
								 'Size'     	=> $formData['pax'],
								 'CustomerName' => $formData['firstName'].' '.$formData['lastName']
								);
								$smsObj->setData($data);
								$mailStatus = $mailmapper->SendSms($smsObj);
								if($rowSet['msg']){
									$data['discountMsg'] = $rowSet['msg'];
									$smsObj->setMsgCode('DiscountNotf');
									$smsObj->setData($data);
									$mailStatus = $mailmapper->SendSms($smsObj);
								}
							} 
	
							$formData['restaurantid'] = $formData['resId'];
							$restservice = new Application_Service_Firm();
							$timeZone = $restservice->GetRestaurantTimeZone($formData['resId']);
							date_default_timezone_set($timeZone);
	
							/* Reterieve Phone Notify Details */
							if($formData['bookingStatus'] == 'RSD'){
									
								$restPhoneInfo = $restservice->getRestaurantPhoneDetails($formData['resId']);
									
								$splitbookdate   = explode('-',$formData['resDate']);
									
								$bookingdate   = date('Y-m-d',mktime(0,0,0,$splitbookdate[0],$splitbookdate[1],$splitbookdate[2]));
								$todaydate     = date('Y-m-d');					
	
								if($restPhoneInfo['smsnotify']){
									$phoneRowSet = $restPhoneInfo['rowset'];
									$phonenumber = "";
									$fromtime    = "";
									$totime		 = "";
									$resvTime    = $formData['resTime'];
	
									if($phoneRowSet){
										foreach($phoneRowSet as $phoneNum){
											if($phoneNum->rntnotify_type == 'sms'){
												$phonenumber = $phoneNum->rntphone;
												$fromtime    = $phoneNum->rntnotify_from_time;
												$totime		 = $phoneNum->rntnotify_to_time;
												$countrycode = $phoneNum->rntcountrycode;
											}
										}
										if($phonenumber){
											if(strtotime($resvTime)>= strtotime($fromtime) && strtotime($resvTime)<= strtotime($totime)){
												$smsObj = new Communication_Model_Sms();
												$smsObj->setMsgCode('BookNotf');
	
												$data = array('to' 		 	 => $phonenumber,
															  'countrycode'	 =>	$countrycode,
															  'bokid'    	 => $result,
															  'RestName' 	 => $formData['resName'],
															  'ResDate'	 	 => $formData['resDate'],
															  'Time'		 => $formData['resTime'],
															  'Size'		 => $formData['pax'],
															  'CustomerName' => $formData['firstName'].' '.$formData['lastName']);
	
												$smsObj->setData($data);
												$mailStatus = $mailmapper->SendSms($smsObj);
	
											}
										}
									}
								}
							}
						}else{
                                                        if(!array_key_exists('reservationfrom', $formData)){
                                                           $autoConf = $this->GetAutoConfirmStatusByResid($formData['resId']);
							 if(!$autoConf){
                                                            
								$restInfo = $mapper->ReterieveRestemails($formData['resId']);	
								if($restInfo){
									if($stateId == "" && $cityId == ""){
										$stateCity = $this->getRestaurantStateByResId($formData['resId']);
										$stateId = $stateCity['state'];
										$cityId = $stateCity['city'];
										$regionId = $stateCity['region'];
									}
									$userType = 'RES';
									$adminService = new Application_Service_Administrator();						
								
									if($restInfo['status'] && isset($restInfo['emails'])){
										$mailObj->setMsgCode('BookNotf');
										$name = $formData['firstName'].' '.$formData['lastName'];
								
										$data = array(
												'UserName' 			=> 	$name,
												'SenTo'    			=> 	$restInfo['emails'],
												
												'RestName' 			=> 	$formData['resName'],
												  'ResDate'  			=> 	$formData['resDate'],
												  'Time'     			=> 	$formData['resTime'],
												'email'	 			=> 	$formData['email'],
												'phone'	 			=> 	$formData['number'],
												'Size'     			=> 	$formData['pax'],
												'Address'	 		=> 	$formData['resAddress'],
												'Note'	 			=>	$formData['dinerRequest'],
												'Bookid'	 		=> 	$result,
                                                                                                'Origin'	 		=> 	$origin,
												'State_Id'			=>	$stateId,
												'City_Id'			=>	$cityId,
												'UserType'			=>	$userType);
										$mailObj->setData($data);
										
										$mailStatus = $mailmapper->SendMail($mailObj);
									}
								}
							} 
                                                        }
							
						}
						$resultant = array('result'=>$bookPhrase,'userId'=>$userid);
						
						/* Check If reservation is for future date and save the info for reminder process */
						
						if($formData['bookingStatus'] == 'RSD'){
							$splitbookdateNotify   = explode('-',$formData['resDate']);
								
							$bookingdateNotify   = date('Y-m-d',mktime(0,0,0,$splitbookdateNotify[0],$splitbookdateNotify[1],$splitbookdateNotify[2]));
							$todaydateNotify     = date('Y-m-d');
							if(strtotime($bookingdateNotify) > strtotime($todaydateNotify)){
								$BookingNotify = new Reservation_Model_ReservationNotify();
								
								$BookingNotify->setbknfk_booking($result);
								$BookingNotify->setbkn_booking_date($formData['resDate']);
								
								$NotifyMapper = new Reservation_Model_ReservationNotifyMapper();
								$notifyInfoStatus = $NotifyMapper->SaveBookingNotifyInfo($BookingNotify);
							}
						}						
						return $resultant;
				}else{
					return false;
				}
			}else{
				return array('result'=>false);
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function sendBookNotification($request)
	{
		try{
			$mailmapper = new Application_Service_Communication();
			$notStatus = $this->CheckReservationNotificationStatusByBokPhraseId($request->bokid);
			$result = $this->GetBookingDetailsByPhraseId($request->bokid);
			$resultSet = array();
			if(!$notStatus){
				$splresult = "";
					
				$restObj= new FirmManagement_Model_FirmById();
				$restObj->setRestaurantId($result->getbokfk_restaurant());
				$resDataMapper = new FirmManagement_Model_FirmDataMapper();
				$resDetails = $resDataMapper->getRestaurantById($restObj);
                                $autoconfirmstatus = $resDetails->getresauto_confirm();
				if($result->getbokbooking_type_code() == 'SPL'){
					$isAjaxCall = true;
					$splmapper = new Deals_Model_RestaurantSpecialDataMapper();
					$splresult = $splmapper->getRestaurantSplByBookingId($result->getbokid(),$isAjaxCall);
				}
				//					if($formData['paymentStatus'] == 'false'){
				$mailObj = new Communication_Model_Mail();
				$rowSet = $resDataMapper->Getdiscountstatus($result->getbokfk_restaurant());
				$stateId = '';
				$mapper = new Reservation_Model_ReservationDataMapper();
				$cityId = '';
				$regionId = '';
				if($result->getbokemail() != ''){
					if($result->getbokbooking_status_code() == 'WAL')
					{
						if($stateId == ""){
							$stateCity = $this->getRestaurantStateByResId($result->getbokfk_restaurant());
							$stateId = $stateCity['state'];
							$cityId = $stateCity['city'];
							$regionId = $stateCity['region'];
			
						}
						$userType = 'CUS';
			
						$mailObj->setMsgCode('WalBookConf');
						$name = $result->getbokfirst_name().' '.$result->getboklast_name();
						$data = array('UserName' 			=> 	$name,
								'Bokid'				=>	$result->getbokid(),
								'SenTo'    			=>	$result->getbokemail(),
								'RestName' 			=> 	$result->getresrestaurant_name(),
								'ResDate'  			=> 	$result->getbokbooking_date(),
								'Time'     			=> 	$result->getbokbooking_timings(),
								'Size'     			=> 	$result->getbokparty_size(),
								'Address'	 		=> 	$result->getresaddress(),
								'resphone' 			=> 	$resDetails->getres_country_code().$resDetails->getRestphone(),
								'resemail'			=>	$resDetails->getRestemail(),
								'rescity'				=>	$resDetails->getRestCityDesc(),
								'resnbh'				=>	$resDetails->getRestNeighborDesc(),
								'reszipcode'			=>	$resDetails->getRestzipcode(),
								'Status'	 			=> 	$result->getbokbooking_status(),
								'State_Id'			=>	$stateId,
								'City_Id'				=>	$cityId,
								'UserType'			=>	$userType
						);
			
						$mailObj->setData($data);
						$mailStatus = $mailmapper->SendMail($mailObj);
						$resultSet['wal'] = true;
					}else{
						if($stateId == "" && $cityId == ""){
							$stateCity = $this->getRestaurantStateByResId($result->getbokfk_restaurant());
							$stateId = $stateCity['state'];
							$cityId = $stateCity['city'];
							$regionId = $stateCity['region'];
						}
						/* Restaurant discount message */
						$discountMsg = false;
						if($rowSet['msg']){
							$discountMsg = $rowSet['msg'];
						}
						$userType = 'CUS';
						/* Retrieve restaurant owner emails and cusotmer details */
						$restInfo = $mapper->ReterieveRestemails($result->getbokfk_restaurant());
                                                
                                                if($autoconfirmstatus){
                                                 $mailObj->setMsgCode('BookConf');   
                                                }
                                                else{
                                                   $mailObj->setMsgCode('BookRecvd'); 
                                                }
						$name = $result->getbokfirst_name().' '.$result->getboklast_name();
			
						$data = array(
								'UserName' 			=> 	$name,
								'SenTo'    			=> 	$result->getbokemail(),
								'RestEmails'		=>  $restInfo['emails'],
								'RestName' 			=> 	$result->getresrestaurant_name(),
								'ResDate'  			=> 	$result->getbokbooking_date(),
								'Time'     			=> 	$result->getbokbooking_timings(),
								'Size'     			=>	$result->getbokparty_size(),
								'Address'	 		=> 	$result->getresaddress(),
								'resphone' 			=> 	$resDetails->getRestphone(),
								'resemail'			=>	$resDetails->getRestemail(),
								'phone'	 			=> 	$result->getbokphone(),
								'Note'	 			=>	$result->getbokrestaurant_note(),
								'rescity'			=>	$resDetails->getRestCityDesc(),
								'resnbh'			=>	$resDetails->getRestNeighborDesc(),
								'reszipcode'		=>	$resDetails->getRestzipcode(),
								'Status'	 		=> 	$result->getbokbooking_status(),
								'Bokid'	 			=>	$result->getbokid(),
								'State_Id'			=>	$stateId,
								'City_Id'				=>	$cityId,
								'UserType'			=>	$userType,
// 								'BookNotf'			=>  true,
								'DiscountMsg'			=>	$discountMsg
						);
						if($splresult){
							$data['splstatus']	= true;
							$data['splid'] 		= $splresult['Id'];
							$data['splname']	= $splresult['Special Name'];
							$data['spldesc'] 	= $splresult['Desc'];
							$data['splorgprice']= $splresult['Regular Price'];
							if($splresult['Discountcode'] == 'PER'){
								$data['spldiscount']= $splresult['Discount Percentage'].'%';
							}else if($splresult['Discountcode'] == 'RE'){
								$data['spldiscount']= '$'.$splresult['Discount Percentage'];
							}
							$data['splprice'] 	= $splresult['Price with Discount'];
						}else{
							$data['splstatus']	= false;
						}
			
						$mailObj->setData($data);
						$mailStatus = $mailmapper->SendMail($mailObj);
						$resultSet['rsd'] = true;
						
						
						/* Reterive restaurant admin email start */
						
						if($restInfo){
							if($stateId == "" && $cityId == ""){
								$stateCity = $this->getRestaurantStateByResId($result->getbokfk_restaurant());
								$stateId = $stateCity['state'];
								$cityId = $stateCity['city'];
								$regionId = $stateCity['region'];
							}
							$userType = 'RES';
							$adminService = new Application_Service_Administrator();						
						
							if($restInfo['status'] && isset($restInfo['emails'])){
								$mailObj->setMsgCode('BookNotf');
								$name = $result->getbokfirst_name().' '.$result->getboklast_name();
                                                               
                                                                $bokorigin = $result->getbokreservation_mode_code();
                                                                $origin='';
                                                                switch($bokorigin){
                                                                            case 'INAT':
                                                                                $origin = 'Web';
                                                                                break;
                                                                            case 'WIN':
                                                                                $origin = 'Walk In';
                                                                                break;
                                                                            case 'PHN':
                                                                                $origin = 'Phone';
                                                                                break;
                                                                            case 'IVR':
                                                                                $origin = 'Online Booking';
                                                                                break;
                                                                            case 'AGG':
                                                                                $origin = 'Online Booking';
                                                                                break;
                                                                            case 'FB':
                                                                                $origin = 'Facebook';
                                                                                break;
                                                                            case 'DWUFB':
                                                                                $origin = 'Facebook';
                                                                                break;
                                                                            case 'DWUSRC':
                                                                                $origin = 'Restaurant Website';
                                                                                break;
                                                                            case 'DWU':
                                                                                $origin = 'DiningWithUs';
                                                                                break;
                                                                            case 'DWUTA':
                                                                                $origin = 'Tripadvisor';
                                                                                break;
                                                                            case 'DWUFS':
                                                                                $origin = 'Foursquare';
                                                                                break;
                                                                            default:
                                                                                $origin= '';
                                                                                break;
                                                                        }
                                                                
						
								$data = array(
										'UserName' 			=> 	$name,
										'SenTo'    			=> 	$restInfo['emails'],
										'RestName' 			=> 	$result->getresrestaurant_name(),
										'ResDate'  			=> 	$result->getbokbooking_date(),
										'Time'     			=> 	$result->getbokbooking_timings(),
										'email'	 			=> 	$result->getbokemail(),
										'phone'	 			=> 	$result->getbokphone(),
										'Size'     			=> 	$result->getbokparty_size(),
										'Address'	 		=> 	$result->getresaddress(),
										'Note'	 			=>	$result->getbokrestaurant_note(),
										'Bookid'	 		=> 	$result->getbokid(),
                                                                                'Origin'                        =>      $origin,
										'State_Id'			=>	$stateId,
										'City_Id'			=>	$cityId,
										'UserType'			=>	$userType);
								$mailObj->setData($data);
								$mailStatus = $mailmapper->SendMail($mailObj);
							}
						}
					}
				}else if($result->getbokphone() != ''){
					$smsObj = new Communication_Model_Sms();
                                        if($autoconfirmstatus){
                                          $smsObj->setMsgCode('BookConf');  
                                        }else{
                                          $smsObj->setMsgCode('BookRecvd');
                                        }
					
					$data = array(
							'to'			=> trim($result->getbokphone()),
							'countrycode'	=> $result->getbokcountry_code(),
							'bokid'		=> $result->getbokid(),
							'RestName' 	=> $result->getresrestaurant_name(),
							'ResDate'  	=> $result->getbokbooking_date(),
							'Time'     	=> $result->getbokbooking_timings(),
							'Size'     	=> $result->getbokparty_size(),
							'CustomerName' => $result->getbokfirst_name().' '.$result->getboklast_name(),
							'RestCountryCode'	=> $result->getbokcountry_code(),
					);
					$smsObj->setData($data);
					$mailStatus = $mailmapper->SendSms($smsObj);
					$resultSet['sms'] = true;
					if($rowSet['msg']){
						$data['discountMsg'] = $rowSet['msg'];
						$smsObj->setMsgCode('DiscountNotf');
						$smsObj->setData($data);
						$mailStatus = $mailmapper->SendSms($smsObj);
						$resultSet['disc'] = true;
					}
				}
			
				$formData['restaurantid'] = $result->getbokfk_restaurant();
				$restservice = new Application_Service_Firm();
				$timeZone = $restservice->GetRestaurantTimeZone($result->getbokfk_restaurant());
				date_default_timezone_set($timeZone);
			
				/* Reterieve Phone Notify Details */
				if($result->getbokbooking_status_code() == 'RSD'){
			
					$restPhoneInfo = $restservice->getRestaurantPhoneDetails($result->getbokfk_restaurant());
			
					$splitbookdate   = explode('-',$result->getbokbooking_date());
			
					$bookingdate   = date('Y-m-d',mktime(0,0,0,$splitbookdate[0],$splitbookdate[1],$splitbookdate[2]));
					$todaydate     = date('Y-m-d');
			
					if($restPhoneInfo['smsnotify']){
						$phoneRowSet = $restPhoneInfo['rowset'];
						$phonenumber = "";
						$fromtime    = "";
						$totime		 = "";
						$resvTime    = $result->getbokbooking_timings();
			
						if($phoneRowSet){
							foreach($phoneRowSet as $phoneNum){
								if($phoneNum->rntnotify_type == 'sms'){
									$phonenumber = $phoneNum->rntphone;
									$fromtime    = $phoneNum->rntnotify_from_time;
									$totime		 = $phoneNum->rntnotify_to_time;
									$countrycode = $phoneNum->rntcountrycode;
								}
							}
							if($phonenumber){
								if(strtotime($resvTime)>= strtotime($fromtime) && strtotime($resvTime)<= strtotime($totime)){
									$smsObj = new Communication_Model_Sms();
									$smsObj->setMsgCode('BookNotf');
			
									$data = array('to' 		 	 => $phonenumber,
											'countrycode'	 =>	$countrycode,
											'bokid'    	 => $result->getbokid(),
											'RestName' 	 => $result->getresrestaurant_name(),
											'ResDate'	 => $result->getbokbooking_date(),
											'Time'		 => $result->getbokbooking_timings(),
											'Size'		 => $result->getbokparty_size(),
											'CustomerName' => $result->getbokfirst_name().' '.$result->getboklast_name());
			
									$smsObj->setData($data);
									$mailStatus = $mailmapper->SendSms($smsObj);
									$resultSet['notf'] = true;
			 
								}
							}
						}
					}
				}
			}
			return $resultSet;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function CheckReservationNotificationStatusByBokPhraseId($phraseid)
	{
		try{
			$commServ = new Application_Service_Communication();
			$notificationStat = $commServ->CheckReservationNotStatus($phraseid);
      //echo '<pre>'; print_r($notificationStat); exit;
			return $notificationStat;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function CheckReservationNotificationStatusByBokId($bokid)
	{
		try{
			$commServ = new Application_Service_Communication();
			$notificationStat = $commServ->CheckReservationNotStatusByBokid($bokid);
			return $notificationStat;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * @param id
	 * retreives the reservation details by id
	 */
	public function GetBookingDetails($id)
	{
		try{
			$mapper = new Reservation_Model_ReservationDataMapper();
			
			$dinerDetails = new Reservation_Model_Reservation();
			$dinerDetails->setbokid($id);
			$result = $mapper->getBookingDetails($dinerDetails);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetBookingDetailsByPhraseId($id)
	{
		try{
			$mapper = new Reservation_Model_ReservationDataMapper();
			/* get booing id with phraseid */
			$phraseId = $mapper->GetBookingIdByBookPhrase($id);
			
			$dinerDetails = new Reservation_Model_Reservation();
			$dinerDetails->setbokid($phraseId);
			$result = $mapper->getBookingDetails($dinerDetails);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function updateBookingDetailsByBookid($request)
	{
		try{
			$bookid = $request->bookid;
			$mapper = new Reservation_Model_ReservationDataMapper();
			/* get booing id with phraseid */
			$phraseId = $mapper->GetBookingIdByBookPhrase($bookid);
			
			$dinerDetails = new Reservation_Model_Reservation();
			$dinerDetails->setbokid($phraseId);
			$dinerDetails->setbokfirst_name($request->fname);
			$dinerDetails->setboklast_name($request->lname);
			$dinerDetails->setbokemail($request->email);
			$dinerDetails->setbokphone($request->phone);
			$dinerDetails->setbokspecial_request($request->splreq);
			$result = $mapper->updateBookingDetailsByBookid($dinerDetails);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function UpdateBookingDetails($request,$stateId,$cityId,$regionId,$bookingid,$source = 'web')
	{
		try{
			$userid = "";
			$mapper = new Reservation_Model_ReservationDataMapper();
			
			$dinerDetails = new Reservation_Model_Reservation();
			
			$resModeMapper = new Application_Model_ReservationModeDataMapper();
			$resModeStatus 	  = $resModeMapper->GetReservationModeByCode(array('INAT'));
			$resModeObj 	  = $resModeStatus['INAT'];
			
			$dinerDetails->setbokfk_restaurant((int)$request->resId);
			$dinerDetails->setresrestaurant_name($request->resName);
			$dinerDetails->setresaddress($request->resAddress);
			$dinerDetails->setbokbooking_date($request->resDate);
			$dinerDetails->setbokbooking_timings($request->resTime);
			$dinerDetails->setbokparty_size((int)$request->resPax);
			
			/* Reteriving Reservation Status Id by Code */
			$status[] = $request->bookingStatus;
			$status[] = 'RES';
			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($status);
			$resStatusObj = $bookStatusRes['RES'];
			$bookStatusRes = $bookStatusRes[$request->bookingStatus];
			$dinerDetails->setbokbooking_status_id($bookStatusRes->getId());
			$dinerDetails->setbokbooking_status($bookStatusRes->getId());

			/* get booikng id with phraseid */
			$phraseId = $mapper->GetBookingIdByBookPhrase($bookingid);
			
			$dinerDetails->setbokid($phraseId);
			$dinerDetails->setbokfirst_name($request->firstName);
			$dinerDetails->setboklast_name($request->lastName);
			$dinerDetails->setbokphone($request->number);
			$dinerDetails->setbokemail($request->email) ;
			$dinerDetails->setbokspecial_request($request->dinerRequest);

			$resServ = new Application_Service_Firm();
			$timeZone = $resServ->GetRestaurantTimeZone($request->resId);
			date_default_timezone_set($timeZone);

			$dinerDetails->setbokbooking_made_on(date('Y-m-d H:i:s'));
			$dinerDetails->setBookingMadeTime(date("H:i",time()));
			$payStat = false;
			
			$bookPhrase = uniqid ();
			$dinerDetails->setbokbookingphrase($bookPhrase);

			$customerDetails = new User_Model_Guest();
			$bookTypeMapper = new Application_Model_ReservationTypeDataMapper();

			$paymentId = array();
			if($request->specialamt){
				$dinerDetails->setSpecialPrice($request->specialamt);
			}
			if($request->booktype){
				$dinerDetails->setbokbooking_type_code($request->booktype);	
			}else{
				$dinerDetails->setbokbooking_type_code('NOR');
			}
			if($request->specialid){
				$dinerDetails->setSpecialId($request->specialid);
				$bookType = $bookTypeMapper->GetBookingTypeByCode($request->booktype);
				$dinerDetails->setbokuserid($request->userid);
			}else{
				$bookType = $bookTypeMapper->GetBookingTypeByCode('NOR');
				$dinerDetails->setbokuserid($request->userid);
			}
			
			$resDataMapper = new FirmManagement_Model_FirmDataMapper();
 			$seetingArr = $resDataMapper->getScheduleSettingTypeByresId($request->resId);
			$dinerDetails->setbok_restsch_setting_id($seetingArr['settingId']);
			$dinerDetails->setbok_restsch_setting_type($seetingArr['settingType']);
			
			$dinerDetails->setbokreservation_mode_id($resModeObj->getId());
			$dinerDetails->setTableSize($request->tablesize);
			$dinerDetails->setNoOfTables($request->nooftables);
			$dinerDetails->setNotificationType('both');
			if($request->inventoryid){
				$dinerDetails->setInventoryId($request->inventoryid);
			}
			/* Reteriving Reservation Type Id by code */
			$dinerDetails->setRescheduleCode('RES');
			if($resStatusObj){
				$dinerDetails->setRessch_Status_Id($resStatusObj->getId());
			}
			$dinerDetails->setbokbooking_type_id($bookType->getid());
			$formdata = array();
			$formdata['firstName'] = $request->firstName;
			$formdata['lastName'] = $request->lastName;
			$formdata['email'] = $request->email;
			$formdata['number'] = $request->number;
			$formdata['dinerRequest'] = $request->dinerRequest;
			$formdata['restaurantid'] =$request->resId;
			$result = $mapper->saveBookingDetails($dinerDetails,$formdata,$source);

			$dinerDetails->setbokid($result);
			$mailmapper = new Application_Service_Communication();
			//if($formData['notificationType'] == 'email'){
			if($result){
				$splresult = "";
				$restObj= new FirmManagement_Model_FirmById();
				$restObj->setRestaurantId($request->resId);
				$resDetails = $resDataMapper->getRestaurantById($restObj);
				if($request->booktype == 'SPL'){
					$isAjaxCall = true;
					$splmapper = new Deals_Model_RestaurantSpecialDataMapper();
					$splresult = $splmapper->getRestaurantSplByBookingId($result,$isAjaxCall);
				}
				$mailObj = new Communication_Model_Mail();
				if($request->email != ''){
					if($stateId == "" && $cityId == ""){
						$stateCity = $this->getRestaurantStateByResId($request->resId);
						$stateId = $stateCity['state'];
						$cityId = $stateCity['city'];
						$regionId = $stateCity['region'];
					}
					$userType = 'CUS';
					$adminService = new Application_Service_Administrator();
					$campProp = new Application_Model_GetCampaignForPost();
					$campProp->setAudType($userType)
					->setStateId($stateId)
					->setCityId($cityId)
					->setRegionId($regionId)
					->setIsAjaxCall(false);
					$campDetails = array();
					if(!$resDetails->getrescampaignstatus() === false){
						$campDetails = $adminService->GetCampaignDetails($campProp);
					}
					/* Restaurant emails and details */
					$restInfo = $mapper->ReterieveRestemails($request->resId);	
					$mailObj->setMsgCode('ReSchedule');
					$name = $request->firstName.' '.$request->lastName;

					$data = array(
								  'UserName' 			=> 	$name,
								  'SenTo'    			=> 	$request->email,
								  'phone'	 			=> 	$request->number,
								  'RestEmails'			=>  $restInfo['emails'],
								  'RestName' 			=> 	$request->resName,
							//	  'ResDate'  			=> 	$request->resDate,
							 	  'ResDate'  			=>  date('m-d-Y',strtotime($request->resDate)),
								  'Time'     			=> 	$request->resTime,
								  'Size'     			=>	$request->pax,
								  'Address'	 			=> 	$request->resAddress,
								  'resphone' 			=> 	$resDetails->getRestphone(),
								  'resemail'			=>	$resDetails->getRestemail(),
								  'rescity'				=>	$resDetails->getRestCityDesc(),
								  'resnbh'				=>	$resDetails->getRestNeighborDesc(),
								  'reszipcode'			=>	$resDetails->getRestzipcode(),	
								  'Status'	 			=> 	$request->bookingStatus,
								  'Bokid'	 			=>	$result, 
								  'State_Id'			=>	$stateId,
								  'City_Id'				=>	$cityId,
								  'UserType'			=>	$userType,
								  'BookNotf'			=>  true,
					);
					if($splresult){
						$data['splstatus']	= true;
						$data['splid'] 		= $splresult['Id'];
						$data['splname']	= $splresult['Special Name'];
						$data['spldesc'] 	= $splresult['Desc'];
						$data['splorgprice']= $splresult['Regular Price'];
						if($splresult['Discountcode'] == 'PER'){
							$data['spldiscount']= $splresult['Discount Percentage'].'%';	
						}else if($splresult['Discountcode'] == 'RE'){
							$data['spldiscount']= '$'.$splresult['Discount Percentage'];
						}
						$data['splprice'] 	= $splresult['Price with Discount'];
					}else{
						$data['splstatus']	= false;
					}
					if(count($campDetails)){
						$count = count($campDetails);
						if($count > 1){
							$campaign = $campDetails[rand(0,$count-1)];
						}else{
							$campaign = $campDetails[0];
						}
						$notfService = new Application_Service_Communication();
						$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
						$data['campaignName'] = trim($campaign->getSponsor());
						$data['campaignDesc'] =	trim($campaign->getCampDesc());
						$data['campaignImg'] =	trim($campaign->getCampImage());
						$data['campId']	= $campaign->getId();
					}
					$mailObj->setData($data);
					$mailStatus = $mailmapper->SendMail($mailObj);
				}

				/* Reterive restaurant admin email start */
//				$restInfo = $mapper->ReterieveRestemails($request->resId);
//				if($restInfo){
//					if($stateId == ""){
//						$stateCity = $this->getRestaurantStateByResId($request->resId);
//						$stateId = $stateCity['state'];
//						$cityId = $stateCity['city'];
//						$regionId = $stateCity['region'];
//					}
//					$userType = 'RES';
//					$adminService = new Application_Service_Administrator();
//					if($resDetails->getrescampaignstatus()){
//						
//						$campProp = new Application_Model_GetCampaignForPost();
//						$campProp->setAudType($userType)
//						->setStateId($stateId)
//						->setCityId($cityId)
//						->setRegionId($regionId)
//						->setIsAjaxCall(false);
//						$campDetails = $adminService->GetCampaignDetails($campProp);
//					}else{
//						$campDetails = array();
//					}
//
//					if($restInfo['status'] && isset($restInfo['emails'])){
//						$mailObj->setMsgCode('BookNotf');
//						$name = $request->firstName.' '.$request->lastName;
//
//						$data = array(
//								  'UserName' 			=> 	$name,
//								  'SenTo'    			=> 	$restInfo['emails'],
//								  'RestName' 			=> 	$request->resName,
//								  'ResDate'  			=> 	$request->resDate,
//								  'Time'     			=> 	$request->resTime,
//								  'email'	 			=> 	$request->email,
//								  'phone'	 			=> 	$request->number,	
//								  'Size'     			=> 	$request->pax,
//								  'Address'	 			=> 	$request->resAddress,
//								  'Note'	 			=>	$request->dinerRequest,
//								  'Bookid'	 			=> 	$result,
//								  'State_Id'			=>	$stateId,
//								  'City_Id'				=>	$cityId,
//								  'UserType'			=>	$userType);
//						if(count($campDetails)){
//							$count = count($campDetails);
//							if($count > 1){
//								$campaign = $campDetails[rand(0,$count-1)];
//							}else{
//								$campaign = $campDetails[0];
//							}
//							$notfService = new Application_Service_Communication();
//							$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
//							$data['campaignName'] = trim($campaign->getSponsor());
//							$data['campaignDesc'] =	trim($campaign->getCampDesc());
//							$data['campaignImg'] =	trim($campaign->getCampImage());
//							$data['campId']	= $campaign->getId();
//						}
//						$mailObj->setData($data);
////						$mailStatus = $mailmapper->SendMail($mailObj);
//					}
//				}
						
				$formData['restaurantid'] = $request->resId;
				$restservice = new Application_Service_Firm();
				$timeZone = $restservice->GetRestaurantTimeZone($request->resId);
				date_default_timezone_set($timeZone);

				/* Reterieve Phone Notify Details */
				if($request->bookingStatus == 'RSD'){								
					$restPhoneInfo = $restservice->getRestaurantPhoneDetails($request->resId);
						
					$splitbookdate   = explode('-',$request->resDate);
						
					$bookingdate   = date('Y-m-d',mktime(0,0,0,$splitbookdate[0],$splitbookdate[1],$splitbookdate[2]));
					$todaydate     = date('Y-m-d');
								
					if($restPhoneInfo['smsnotify']){
						$phoneRowSet = $restPhoneInfo['rowset'];
						$phonenumber = "";
						$fromtime    = "";
						$totime		 = "";
						$resvTime    = $request->resTime;

						if($phoneRowSet){
							foreach($phoneRowSet as $phoneNum){
								if($phoneNum->rntnotify_type == 'sms'){
									$phonenumber = $phoneNum->rntphone;
									$fromtime    = $phoneNum->rntnotify_from_time;
									$totime		 = $phoneNum->rntnotify_to_time;
									$countrycode = $phoneNum->rntcountrycode;
								}
							}
							if($phonenumber){
								if(strtotime($resvTime)>= strtotime($fromtime) && strtotime($resvTime)<= strtotime($totime)){
									$smsObj = new Communication_Model_Sms();
									$smsObj->setMsgCode('BookNotf');

									$data = array('to' 		 	 => $phonenumber,
												  'countrycode'	 =>	$countrycode,	
												  'bokid'    	 => $result,
												  'RestName' 	 => $request->resName,
												  'ResDate'	 	 => $request->resDate,
												  'Time'		 => $request->resTime,
												  'Size'		 => $request->pax,

												  'CustomerName' => $request->firstName.' '.$request->lastName);

									$smsObj->setData($data);
									$mailStatus = $mailmapper->SendSms($smsObj);

								}
							}
						}
					}
				}
				$resultant = array('result'=>$bookPhrase,'userId'=>$userid);
						
				/* Check If reservation is for future date and save the info for reminder process */
						
				if($request->bookingStatus == 'RSD'){
					$resDate = date('m-d-Y',strtotime($request->resDate));
					$splitbookdateNotify   = explode('-',$resDate);
						
					$bookingdateNotify   = date('Y-m-d',mktime(0,0,0,$splitbookdateNotify[0],$splitbookdateNotify[1],$splitbookdateNotify[2]));
					$todaydateNotify     = date('Y-m-d');
					if(strtotime($bookingdateNotify) > strtotime($todaydateNotify)){
						$BookingNotify = new Reservation_Model_ReservationNotify();
						
						$BookingNotify->setbknfk_booking($result);
						$BookingNotify->setbkn_booking_date($request->resDate);
						
						$NotifyMapper = new Reservation_Model_ReservationNotifyMapper();
						$notifyInfoStatus = $NotifyMapper->SaveBookingNotifyInfo($BookingNotify);
					}
				}
						
				return $resultant;
			}else{
				return false;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	/**
	 * @param id
	 * retreives the reservation details of blocked reservations
	 */
	public function GetBlockBookingDetails($id)
	{
		try{
			$mapper = new Reservation_Model_ReservationDataMapper();
			$dinerDetails = new Reservation_Model_Reservation();
			/* get booking id with phraseid */
//			$phraseId = $mapper->GetBookingIdByBookPhrase($id);
			
			$dinerDetails->setbokid($id);
			$result = $mapper->getBookingDetails($dinerDetails);
			$details = array();
			$details = array('firstName'	=> $result->getbokfirst_name(),
						 'lastName'		=> $result->getboklast_name(),
						 'party_size'	=> $result->getbokparty_size(),
						 'bookingdate'  => date('d M Y',strtotime($result->getbokbooking_date())),
						 'bookingtime'  => $result->getbokbooking_timings(),
						 'email'		=> $result->getbokemail(),
						 'phone'		=> $result->getbokphone(),
						 'countrycode'	=> $result->getbokcountry_code()
			);
			return $details;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param array,userid,offset
	 * retreives the customer reservation history
	 */
	public function GetCustBookingHistory(array $data,$userid,$phone,$email,$offset)
	{
		try{
			$form = $this->getCustBookHistForm();
			$custBookHist = new Reservation_Model_CustBookHist();
			$custBookHist->setUserId($userid);
			$custBookHist->setPhone($phone);
			$custBookHist->setEmail($email);
												 
			if($form->isValid($data)){
				$formData = $form->getValues();
				if($formData['bookid'])
				{
					$custBookHist->setBookingId($formData['bookid']);
				}
				if($formData['restname'])
				{
					$custBookHist->setRestName($formData['restname']);
				}
				if($formData['startdate'])
				{
					$custBookHist->setStartDate($formData['startdate']);
				}
				if($formData['enddate'])
				{
					$custBookHist->setEndDate($formData['enddate']);
				}
				
				if($formData['patronName'])
				{
					$custBookHist->setPatronName($formData['patronName']);
				}
				
				if($formData['booksorton'])
				{
					$custBookHist->setSorting($formData['booksorton']);
				}
				
				$mapper = new Reservation_Model_ReservationDataMapper();
				$resultSet = $mapper->getCustBookingHistory($custBookHist,$offset);


				return $resultSet;

			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function GetCustSplBookingHistory($userid,$offset)
	{
		try{
			//$form = $this->getCustBookHistForm();
			$custBookHist = new Reservation_Model_ReservationSpecial();
			$custBookHist->setbkscreatedby($userid);

			$mapper = new Reservation_Model_ReservationSpecialDataMapper();
			$resultSet = $mapper->getCustBookingHistory($custBookHist,$offset);
			return $resultSet;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetCusSplBookingHistoryBysplid($request)
	{
		try{
			$splid = $request->splid;
			$custBookHist = new Reservation_Model_ReservationSpecial();
			$custBookHist->setbksid($splid);

			$mapper = new Reservation_Model_ReservationSpecialDataMapper();
			$resultSet = $mapper->getCusSplBookingHistoryBysplid($custBookHist);
			return $resultSet;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function GetRestaurantDetails($request)
	{
		try{
			$restService = new Application_Service_Firm();
			$restDetails = $restService->GetRestaurantDetails($request);
			$restService = null;

			return $restDetails;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function GetRestaurantEmailById($request)
	{
		try{
			$restService = new Application_Service_Firm();
			$result = $restService->GetRestaurantEmailById($request);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetRestaurantEmails($request)
	{
		try{
			$restService = new Application_Service_Firm();
			$result = $restService->GetRestaurantEmails($request);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function GetStateBaseData()
	{
		try{
			$stateDataMapperObj = new Application_Model_StateDataMapper();
			$rowSet = $stateDataMapperObj->fetchAll();
			return $rowSet;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function GetRegionBaseData()
	{
		try{
			$mapper = new Reservation_Model_ReservationDataMapper();
			$regionBd = $mapper->getRegionBaseData();
			return $regionBd;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * retreives the city basedata
	 */
	public function GetCityBaseData()
	{
		try{
			$mapper = new Reservation_Model_ReservationDataMapper();
			$cityBd = $mapper->getCityBaseData();
			return $cityBd;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * retreives the neighbourhood base data
	 */
	public function GetNeighborhodBaseData()
	{
		try{
			$mapper     = new Reservation_Model_ReservationDataMapper();
			$neighborBd = $mapper->getNeighborhodBaseData();
			return $neighborBd;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * retreives the restaurant type base data
	 */
	public function GetRestaurantTypesBaseData()
	{
		try{
			$mapper     = new Reservation_Model_ReservationDataMapper();
			$restTypeBd = $mapper->getRestaurantTypeBaseData();
			return $restTypeBd;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * retreives the restaurant price base data
	 */
	public function GetRestaurantPriceBaseData()
	{
		try{
			$mapper = new Reservation_Model_ReservationDataMapper();
			$restPriceBd = $mapper->getRestaurantPriceBaseData();
			return $restPriceBd;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param request,array
	 * retreives the all the reservations of the restaurant with different statuses of that day
	 */
	public function ReservationDesk($request,$data)
	{
		try{
			$resId  = $request->restaurantid;
			$result = array();
			$date = null;
			$datStat = "";
			$resServ = new Application_Service_Firm();
			$timeZone = $resServ->GetRestaurantTimeZone($resId);
			date_default_timezone_set($timeZone);
			if(isset($request->date)){
				$date = $request->date;
				$datStat = "request";
			}else{
				$date = date('Y-m-d');
			}
			/**GET MEAL PERIOD FILTER TIMES**/
			$mealPeriod = $request->meal;
			$timesLimit = array();
			$mealPeriods = $this->getDiningPeriodsByResid($resId,date("h:i a"));
			$result['meal_periods'] = $mealPeriods;
			if(!isset($mealPeriod))
			{
				//$timesLimit  = $this->getCurrentDiningTimes($resId,date("h:i a"));
			}
			else
			{
				if(strtolower($mealPeriod)!="all")
				{
					$timesLimit  = $this->getMealPeriodTimes($resId,$mealPeriod);
				}
			}
			/**END OF MEAL PERIOD TIMES **/
			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			$bookMapper = new Reservation_Model_ReservationDataMapper();

			/* Reteriving Table layout start */

			$diningidArr = array();
			$diningAreaArr = array();
			$diningMapper = new FirmManagement_Model_FirmDiningAreaDataMapper();
			$Diningresult = $diningMapper->getDinigAreasByRestId($resId);
			if($request->diningid){
				$diningid = $request->diningid;
			}else{
				foreach($Diningresult as $dining){
					$diningidArr[] = $dining->rdaid;
				}
				$diningid = $diningidArr[0];
			}
			$result['diningareas'] = $Diningresult;
			$result['diningid'] = $diningid;

			$mapper = new FirmManagement_Model_FirmTableDataMapper();
			$tableObj = new FirmManagement_Model_FirmTable();
			$tableObj->setResId($resId);
			$tableObj->setDiningId($diningid);
			$resultStr = $mapper->getRestaurantTable($tableObj);

			$result['Layout'] = $resultStr;

			/* Reteriving Table layout end */
			
			/* Retrieve seprator layout start */
			
			$restFloorSep = new FirmManagement_Model_FirmFloorSeprator();
			$restFloorSep->setrfsfk_restaurant($resId);
			$restFloorSep->setrfsfk_restaurant_dining_area($diningid);	
			
			$resFloorSepMapper = new FirmManagement_Model_FirmFloorSepratorMapper();
			$floorSepArr = $resFloorSepMapper->retrieveFloorSeprators($restFloorSep);
			
			$result['FloorSep'] = $floorSepArr;  
			
			/* Retrieve seprator layout end */

			/* Reteriving InQueue list start */

			$getInQueueList = new Reservation_Model_GetInQueueList();
			$getInQueueList->setRestaurantId($resId);

			$getInQueueList->setDate($date);

			/* Reteriving booking status id by code */
			$status = array();

			$status = array('BKD');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($status);
			$getInQueueList->setBookStatus($bookStatusRes);

			/* Retrieve section tables for highlight */
			
			$SecServer = new Application_Service_Serverservice();			
			$secTablesArr = $SecServer->getSecTablesForHighlight($resId);
			$result['SecTables'] = $secTablesArr;
			
			
			/* Retrieve Server List */
			$serverList = $SecServer->getServersByRestId($resId,$date);
			$result['ServerList'] = $serverList;
			$inqueueList = $bookMapper->getInQueueList($getInQueueList);
			$result['InQueue'] = $inqueueList;

			/* Reteriving InQueue list end */

			/* Reteriving table status start */

			$getTableStatusObj = new Reservation_Model_GetTableStatus();
			$getTableStatusObj->setRestaurantId($resId);
			$getTableStatusObj->setDate($date);

			/* Reteriving Reservation Status Id */
			$bookStatus = array('ALC','DES','BOK','PTS','CRD','WRD','BIL','RSD','OVB','BKD');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$getTableStatusObj->setBookStatus($bookStatusRes);

			$tableStatus = $bookMapper->getTableStatus($getTableStatusObj);
			$result['TableStatus'] = $tableStatus;

			/* Reteriving table status end */
			/* Reteriving no-show reservations count start*/
			$getNoshowObj = new Reservation_Model_GetNoShowList();
			$getNoshowObj->setRestaurantId($resId);
			$getNoshowObj->setDate($date);
			$getNoshowObj->setIsAjaxCall(true);
			$bookStatus = array('NOS');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
			$getNoshowObj->setBookStatus($bookStatusRes);
			$noshowlist = $bookMapper->GetNoShowReservation($getNoshowObj);
			if(count($noshowlist)){
				$result['No-Show'] = count($noshowlist);
			}else{
				$result['No-Show'] = '';
			}

			/* Reteriving no-show reservations count end*/
			/* Reteriving Attending list start */

			$getAttenListObj = new Reservation_Model_GetAttendingList();
			$getAttenListObj->setRestaurantId($resId);
			$getAttenListObj->setDate($date);
			if(count($timesLimit)==2)
			{
				$getAttenListObj->setStartTime($timesLimit['start_time']);
				$getAttenListObj->setEndTime($timesLimit['end_time']);
			}
			/* Reteriving Booking Status Id */
			$bookStatus = array('RSD','OVB','BKD');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$getAttenListObj->setBookStatus($bookStatusRes);
			$dealsListRes = $bookMapper->getAttendingList($getAttenListObj);
			$result['Attending'] = $dealsListRes;

			/* Reteriving Attending list end */
			
			
			/* Reteriving deals list start */

			$getAttenListObj = new Reservation_Model_GetAttendingList();
			$getAttenListObj->setRestaurantId($resId);
			$getAttenListObj->setDate($date);

			/* Reteriving Reservation Status Id */
			$bookStatus = array('RSD','OVB','ALC','DES','BOK','PTS','CRD','COM','WRD','BIL');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$getAttenListObj->setBookStatus($bookStatusRes);
			$dealsListRes = $bookMapper->getDealsList($getAttenListObj);
			$result['Deals'] = $dealsListRes;

			/* Reteriving deals list end */

			/* Reteriving Completed list start */

			$getCompletedObj = new Reservation_Model_GetAttendingList();
			$getCompletedObj->setRestaurantId($resId);
			$getCompletedObj->setDate($date);
			if(count($timesLimit)==2)
			{
				$getCompletedObj->setStartTime($timesLimit['start_time']);
				$getCompletedObj->setEndTime($timesLimit['end_time']);
			}
			/* Reteriving Reservation Status Id */
			$bookStatus = array('ALC','DES','BOK','PTS','CRD','WRD','BIL');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$getCompletedObj->setBookStatus($bookStatusRes);
			$CompletedListRes = $bookMapper->getAttendingList($getCompletedObj);
			$result['Completed'] = $CompletedListRes;

			/* Reteriving Completed list end */
			
			/* Reteriving Completed list start */

			$getCompletedObj = new Reservation_Model_GetAttendingList();
			$getCompletedObj->setRestaurantId($resId);
			$getCompletedObj->setDate($date);
			if(count($timesLimit)==2)
			{
				$getCompletedObj->setStartTime($timesLimit['start_time']);
				$getCompletedObj->setEndTime($timesLimit['end_time']);
			}
			/* Reteriving Reservation Status Id */
			$bookStatus = array('COM','NOS','CAN');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$getCompletedObj->setBookStatus($bookStatusRes);
			$CompletedListRes = $bookMapper->getAttendingList($getCompletedObj);
			$result['CompletedList'] = $CompletedListRes;
			/* Reteriving Completed list end */
			
			/* Reteriving Waiting list start */

			$getWaitingList = new Reservation_Model_GetWaitingList();
			$getWaitingList->setRestaurantId($resId);
			$getWaitingList->setDate($date);
			if(count($timesLimit)==2)
			{
				$getWaitingList->setStartTime($timesLimit['start_time']);
				$getWaitingList->setEndTime($timesLimit['end_time']);
			}
			/* Reteriving booking status id by code */
			$status = array();

			$bookStatus = array('WAL','READY','QUOTE','BAR','NEXT','CANCUS','BACK');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
			$getWaitingList->setBookStatus($bookStatusRes);

			$waitingListRes = $bookMapper->getWaitingList($getWaitingList);
			$result['WaitingList'] = $waitingListRes;

			/* Reteriving Freeze Status Start */

			$freezeStatus = new Reservation_Model_GetFreezeStatus();
			$freezeStatus->setRestId($resId);
			$freezeStatus->setFreezeDate($date);
			$freezemapper = new Reservation_Model_RestaurantFreezeDataMapper();
			$status = $freezemapper->GetFreezeStatus($freezeStatus);
			$result['FreezeStatus'] = $status;

			/* Reteriving Freeze Status End */

			/* Reteriving Freezed Dates Start 	*/
			$freezedmapper = new Reservation_Model_RestaurantFreezeDataMapper();
			$freezedDates = $freezedmapper->GetFreezedDates($resId);

			$result['FreezedDates'] = $freezedDates;

			/* Reteriving Freezed Dates End 	*/

			/* Reteriving Alert Status Start */
			if($data['Usertype'] == 'RSO'){
				$userid = $data['User_Id'];
				$Alertmapper = new FirmManagement_Model_FirmAlertDataMapper();
				$Alertstatus = $Alertmapper->GetAlertStatus($userid,$date,$resId);
				foreach($Alertstatus as $val){
					if($val->rar_alertstatus == 2){
						$result['AlertStstus'] = true;
						break;
					}else{
						$result['AlertStstus'] = false;
					}
				}
				$result['Alert'] = $Alertstatus;
				$result['Alertusertype'] = 'RSO';
			}else if($data['Usertype'] == 'RSU'){
				$userid = $data['User_Id'];
				$Alertmapper = new FirmManagement_Model_FirmAlertDataMapper();
				$Alertstatus = $Alertmapper->GetRestuarntUserAlerts($userid,$date,$resId);
				foreach($Alertstatus as $val){
					if($val->rar_alertstatus == 2){
						$result['AlertStstus'] = true;
						break;
					}else{
						$result['AlertStstus'] = false;
					}
				}
				$result['Alert'] = $Alertstatus;
				$result['Alertusertype'] = 'RSU';
			}else if($data['Usertype'] == 'SRU'){
				$userid = $data['User_Id'];
				$Alertmapper = new FirmManagement_Model_FirmAlertDataMapper();
				$Alertstatus = $Alertmapper->GetRestuarntUserAlerts($userid,$date,$resId);
				foreach($Alertstatus as $val){
					if($val->rar_alertstatus == 2){
						$result['AlertStstus'] = true;
						break;
					}else{
						$result['AlertStstus'] = false;
					}
				}
				$result['Alert'] = $Alertstatus;
				$result['Alertusertype'] = 'SRU';
			}
			/* Reteriving Alert Status End */
			 	
			/* Reteriving restaurant logo Start */

			$row = $bookMapper->GetRestaurantLogo($resId);
			if($row){
				$result['RestLogo'] = $row->reslogo;
				$result['RestName'] = $row->resrestaurant_name;
			}

			/* Reteriving restaurant logo End */
			 	
			/* Reteriving restaurant  payment status Start  */

			$restMapper = new FirmManagement_Model_FirmDataMapper();
			$paymentstatus = $restMapper->GetPaymentStatusByRestaurantId($resId);
			$result['paymentstatus'] = $paymentstatus;
			/* Reteriving restaurant  payment status End  */
			 	
			/* reteriving timings */

			$resMapper = new FirmManagement_Model_FirmScheduleDataMapper();
			$resObj = new FirmManagement_Model_FirmSchedule();
			$resObj->setrssfk_restaurant($request->restaurantid);
			$dateSplit = explode("-",$date);
			if($datStat){
				$weekday = strtolower(date("D", mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2])));
			}else{
				$weekday = strtolower(date("D", mktime(0,0,0,$dateSplit[1],$dateSplit[2],$dateSplit[0])));
				$date = date('m-d-Y');
			}
			//date_default_timezone_set('Asia/Kolkata');
			$time = date('h:i A');

			$timeArray = array();
			$finalArray = array();
			$prevArray  = array();
			$nextArray	= array();
			$resObj->setrssday_of_week($weekday);
			$resObj->setdate($date);
			
			$meal = new FirmManagement_Model_FirmMealType();

			$bookStatus = array('WAL','READY','QUOTE','BAR','NEXT','CANCUS','BACK','RSD','OVB');
			$abouttoSeat = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$bookStatus = array('ALC','DES','BOK','PTS','CRD');
			$seating = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$bookStatus = array('COM');
			$seated = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
			$meal->setResId($resId)
			->setDate($date)
			->setTime($time);
			$mealMapper = new FirmManagement_Model_FirmMealTypeDataMapper();
			$timeMeal = $mealMapper->GetRestaurantMealByTime($meal);
			if(!$timeMeal){
				$mealType = $mealMapper->GetRestaurantMealTypes($meal);
				$mealT = "";
				foreach($mealType as $key=>$value){
					if($key != 'count'){
						$mealT = $value['meal'];
						break;
					}
				}
				if($mealT){
					$meal->setMealType($mealT);
					$timeMeal = $mealMapper->GetRestaurantMealByType($meal);
				}
			}
			if($timeMeal){
				$meal->setMealType($timeMeal->mealid)
				->setStartTime($timeMeal->rmt_start_time)
				->setEndTime($timeMeal->rmt_end_time)
				->setSeating($seating)
				->setAboutToSeat($abouttoSeat)
				->setSeated($seated);


				$mealCount = $bookMapper->getCountByMealType($meal);
				$result['mealCount'] = $mealCount;
				$mealResult = $mealMapper->GetRestaurantMealTypes($meal);
				$result['mealType'] = $timeMeal->meal;
			}else{
				$result['mealType'] = '';
			}
			
			/* Reteriving Reservation Status Id */
			
			$bookStatus = array('RSD','OVB','BKD','ALC','DES','BOK','PTS','CRD','WRD','BIL','COM');
			$abouttoSeat = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
			
			$bookStatus = array('WAL','READY','QUOTE','BAR','NEXT','CANCUS','BACK');
			$waiting = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$statusArr = array(
								'Upcoming'		=>	$abouttoSeat,
								'Waiting'		=>	$waiting
								);
			if(count($timesLimit)==2)
			{
					$result['reservCount'] = $bookMapper->RetrieveReservationCounts($resId,$date,$statusArr,$timesLimit);
			}
			else
			{
				$result['reservCount'] = $bookMapper->RetrieveReservationCounts($resId,$date,$statusArr);
			}

			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param request
	 * retreives the reservations of the restaurant with different statuses for auto refresh
	 */
	public function Ajax_ReservationDesk($request)
	{
		try{
			$resId  = $request->restaurantid;
			$result = array();
			$resevdesk = array();
			$date = null;
			$resServ = new Application_Service_Firm();
			$timeZone = $resServ->GetRestaurantTimeZone($resId);
			date_default_timezone_set($timeZone);
			if(isset($request->date)){
				$date = $request->date;
			}else{
				$date = date('Y-m-d');
			}
			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			$bookMapper = new Reservation_Model_ReservationDataMapper();
			/**GET MEAL PERIOD FILTER TIMES**/
			$mealPeriod = $request->meal;
			$timesLimit = array();
			if(!isset($mealPeriod))
			{
				//$timesLimit  = $this->getCurrentDiningTimes($resId,date("h:i a"));
			}
			else
			{
				if(strtolower($mealPeriod)!="all")
				{
					$timesLimit  = $this->getMealPeriodTimes($resId,$mealPeriod);
				}
			}
			/**END OF MEAL PERIOD TIMES **/
			/* Reteriving InQueue list start */

			$getInQueueList = new Reservation_Model_GetInQueueList();
			$getInQueueList->setRestaurantId($resId);
			$getInQueueList->setIsAjaxCall(true);
			$getInQueueList->setDate($date);

			/* Reteriving booking status id by code */
			$status = array();

			$status = array('BKD');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($status);
			$getInQueueList->setBookStatus($bookStatusRes);

			if(isset($request->queuesorton) && isset($request->queuesortorder) && $request->queuesorton != "" && $request->queuesortorder != ""){
				if($request->queuesorton == "booktime"){
					$getInQueueList->setSortOrder($request->queuesortorder);
					$getInQueueList->setSortOn("booktime");
					$inqueueList = $bookMapper->getInQueueList($getInQueueList);
					$jsonInQueueList = json_encode($inqueueList);
					$resevdesk['InQueueList'] = $jsonInQueueList;
				}else if($request->queuesorton == "boktablenumber"){
					$getInQueueList->setSortOrder($request->queuesortorder);
					$getInQueueList->setSortOn("boktablenumber");
					$inqueueList = $bookMapper->getInQueueList($getInQueueList);
					$jsonInQueueList = json_encode($inqueueList);
					$resevdesk['InQueueList'] = $jsonInQueueList;
				}else if($request->queuesorton == "bokparty_size"){
					$getInQueueList->setSortOrder($request->queuesortorder);
					$getInQueueList->setSortOn("bokparty_size");
					$inqueueList = $bookMapper->getInQueueList($getInQueueList);
					$jsonInQueueList = json_encode($inqueueList);
					$resevdesk['InQueueList'] = $jsonInQueueList;
				}else{
					$inqueueList = $bookMapper->getInQueueList($getInQueueList);
					$queueSortedArray = $this->array_sort($inqueueList,$request->queuesorton,$request->queuesortorder);
					$jsonInQueueList = json_encode($queueSortedArray);

					$resevdesk['InQueueList'] = $jsonInQueueList;
				}
			}else{
				$inqueueList = $bookMapper->getInQueueList($getInQueueList);
				$jsonInQueueList = json_encode($inqueueList);
				$resevdesk['InQueueList'] = $jsonInQueueList;

			}
			/* Reterieve Schedule Id's
			 $restService = new Application_Service_Firm();
			 $schIdArray = array();
			 $schIdArray = $restService->GetTimeSlots($request);
			 $inqueueList = array();
			 if(count($schIdArray)>0){
				$getInQueueList->setSchId($schIdArray);
				$queueSortedArray = array();
				if(isset($request->sorton) && isset($request->sortorder) && $request->sorton != "" && $request->sortorder != ""){
				if($request->sorton == "booktime"){
				$getInQueueList->setSortOrder($request->sortorder);
				$inqueueList = $bookMapper->getInQueueList($getInQueueList);
				$jsonInQueueList = json_encode($inqueueList);
				$resevdesk['InQueueList'] = $jsonInQueueList;
				}else{
				$inqueueList = $bookMapper->getInQueueList($getInQueueList);
				$queueSortedArray = $this->array_sort($inqueueList,$request->sorton,$request->sortorder);
				$jsonInQueueList = json_encode($queueSortedArray);
				$resevdesk['InQueueList'] = $jsonInQueueList;
				}
				}else{
				$inqueueList = $bookMapper->getInQueueList($getInQueueList);
				$jsonInQueueList = json_encode($inqueueList);
				$resevdesk['InQueueList'] = $jsonInQueueList;
				}
				}
				//array_push($resevdesk,array('InQueueList'=>$jsonInQueueList));

			 Reteriving InQueue list end */

			/* Reteriving Attending list start */

			$getAttenListObj = new Reservation_Model_GetAttendingList();
			$getAttenListObj->setRestaurantId($resId);
			$getAttenListObj->setDate($date);
			$getAttenListObj->setIsAjaxCall(true);
			/* Reteriving Reservation Status Id */
			if(count($timesLimit)==2)
			{
				$getAttenListObj->setStartTime($timesLimit['start_time']);
				$getAttenListObj->setEndTime($timesLimit['end_time']);
			}
			$bookStatus = array('RSD','OVB','BKD');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
			$getAttenListObj->setBookStatus($bookStatusRes);
			
			/* Sorting of Data */
			
			$attenSortedArray = array();
			if(isset($request->attsorton)&& isset($request->attsortorder) && $request->attsorton != "" && $request->attsortorder != ""){
				if($request->attsorton == "booktime"){
					$getAttenListObj->setSortOrder($request->attsortorder);
					$getAttenListObj->setSortOn("booktime");
					$attenListRes = $bookMapper->getAttendingList($getAttenListObj);
					$jsonattenList = json_encode($attenListRes);
					$resevdesk['Attending'] = $jsonattenList;
				}else if($request->attsorton == "boktablenumber"){
					$getAttenListObj->setSortOrder($request->attsortorder);
					$getAttenListObj->setSortOn("boktablenumber");
					$attenListRes = $bookMapper->getAttendingList($getAttenListObj);
					$jsonattenList = json_encode($attenListRes);
					$resevdesk['Attending'] = $jsonattenList;
				}else if($request->attsorton == "bokparty_size"){
					$getAttenListObj->setSortOrder($request->attsortorder);
					$getAttenListObj->setSortOn("bokparty_size");
					$attenListRes = $bookMapper->getAttendingList($getAttenListObj);
					$jsonattenList = json_encode($attenListRes);
					$resevdesk['Attending'] = $jsonattenList;
				}else{
					$attenListRes = $bookMapper->getAttendingList($getAttenListObj);
					$attenSortedArray = $this->array_sort($attenListRes,$request->attsorton,$request->attsortorder);
					$jsonattenList = json_encode($attenSortedArray);
					$resevdesk['Attending'] = $jsonattenList;
				}
			}else{
				$attenListRes = $bookMapper->getAttendingList($getAttenListObj);
				$jsonattenList = json_encode($attenListRes);
				$resevdesk['Attending'] = $jsonattenList;
			}
			//array_push($resevdesk,array('Attending'=>$jsonattenList));

			/* Reteriving Attending list end */
			
			/* Reteriving Deals list start */

			$getAttenListObj = new Reservation_Model_GetAttendingList();
			$getAttenListObj->setRestaurantId($resId);
			$getAttenListObj->setDate($date);
			$getAttenListObj->setIsAjaxCall(true);
			/* Reteriving Reservation Status Id */
			$bookStatus = array('RSD','OVB','ALC','DES','BOK','PTS','CRD','COM','WRD','BIL');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
			$getAttenListObj->setBookStatus($bookStatusRes);
			
			/* Sorting of Data */
			
			$attenSortedArray = array();
			if(isset($request->attsorton)&& isset($request->attsortorder) && $request->attsorton != "" && $request->attsortorder != ""){
				if($request->attsorton == "booktime"){
					$getAttenListObj->setSortOrder($request->attsortorder);
					$getAttenListObj->setSortOn("booktime");
					$dealsListRes = $bookMapper->getDealsList($getAttenListObj);
					$jsondealsList = json_encode($dealsListRes);
					$resevdesk['Deals'] = $jsondealsList;
				}else if($request->attsorton == "boktablenumber"){
					$getAttenListObj->setSortOrder($request->attsortorder);
					$getAttenListObj->setSortOn("boktablenumber");
					$dealsListRes = $bookMapper->getDealsList($getAttenListObj);
					$jsondealsList = json_encode($dealsListRes);
					$resevdesk['Deals'] = $jsondealsList;
				}else if($request->attsorton == "bokparty_size"){
					$getAttenListObj->setSortOrder($request->attsortorder);
					$getAttenListObj->setSortOn("bokparty_size");
					$dealsListRes = $bookMapper->getDealsList($getAttenListObj);
					$jsondealsList = json_encode($dealsListRes);
					$resevdesk['Deals'] = $jsondealsList;
				}else{
					$dealsListRes = $bookMapper->getDealsList($getAttenListObj);
					$attenSortedArray = $this->array_sort($dealsListRes,$request->attsorton,$request->attsortorder);
					$jsondealsList = json_encode($attenSortedArray);
					$resevdesk['Deals'] = $jsondealsList;
				}
			}else{
				$dealsListRes = $bookMapper->getDealsList($getAttenListObj);
				$jsondealsList = json_encode($dealsListRes);
				$resevdesk['Deals'] = $jsondealsList;
			}
			//array_push($resevdesk,array('Attending'=>$jsonattenList));

			/* Reteriving Deals list end */

			/* Reteriving Completed list start */
			$getCompletedObj = new Reservation_Model_GetCompletedList();
			$getCompletedObj->setRestaurantId($resId);
			$getCompletedObj->setDate($date);
			$getCompletedObj->setIsAjaxCall(true);
			if(count($timesLimit)==2)
			{
				$getCompletedObj->setStartTime($timesLimit['start_time']);
				$getCompletedObj->setEndTime($timesLimit['end_time']);
			}	 
			/* Reteriving Reservation Status Id */
			$bookStatus = array('ALC','DES','BOK','PTS','CRD','WRD','BIL');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$getCompletedObj->setBookStatus($bookStatusRes);
			
			/* Sorting of Data */
			$completedSortedArray = array();
			if(isset($request->completesorton)&& isset($request->completesortorder) && $request->completesorton != "" && $request->completesortorder != ""){
				if($request->completesorton == "booktime"){
					$getCompletedObj->setSortOrder($request->completesortorder);
					$getCompletedObj->setSortOn("booktime");
					$completedListRes = $bookMapper->getCompletedList($getCompletedObj);
					$jsoncompletedList = json_encode($completedListRes);
					$resevdesk['Completed'] = $jsoncompletedList;
				}else if($request->completesorton == "boktablenumber"){
					$getCompletedObj->setSortOrder($request->completesortorder);
					$getCompletedObj->setSortOn("boktablenumber");
					$completedListRes = $bookMapper->getCompletedList($getCompletedObj);
					$jsoncompletedList = json_encode($completedListRes);
					$resevdesk['Completed'] = $jsoncompletedList;
				}else if($request->completesorton == "bokparty_size"){
					$getCompletedObj->setSortOrder($request->completesortorder);
					$getCompletedObj->setSortOn("bokparty_size");
					$completedListRes = $bookMapper->getCompletedList($getCompletedObj);
					$jsoncompletedList = json_encode($completedListRes);
					$resevdesk['Completed'] = $jsoncompletedList;
				}else{
					$completedListRes = $bookMapper->getCompletedList($getCompletedObj);
					$completedSortedArray = $this->array_sort($completedListRes,$request->completesorton,$request->completesortorder);
					$jsoncompletedList = json_encode($completedSortedArray);
					$resevdesk['Completed'] = $jsoncompletedList;
				}
				}else{
						$CompletedListRes = $bookMapper->getCompletedList($getCompletedObj);
						$jsoncompletedList = json_encode($CompletedListRes);
						$resevdesk['Completed'] = $jsoncompletedList;
				}			
			/* Reteriving Completed list end */		

				/* Reteriving Completed list start */
			$getCompletedObj = new Reservation_Model_GetCompletedList();
			if(count($timesLimit)==2)
			{
				$getCompletedObj->setStartTime($timesLimit['start_time']);
				$getCompletedObj->setEndTime($timesLimit['end_time']);
			}
			$getCompletedObj->setRestaurantId($resId);
			$getCompletedObj->setDate($date);
			$getCompletedObj->setIsAjaxCall(true);
			/* Reteriving Reservation Status Id */
			$bookStatus = array('COM','NOS', 'CAN');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$getCompletedObj->setBookStatus($bookStatusRes);
			
			/* Sorting of Data */
			$completedSortedArray = array();
			if(isset($request->completesorton)&& isset($request->completesortorder) && $request->completesorton != "" && $request->completesortorder != ""){
				if($request->completesorton == "booktime"){
					$getCompletedObj->setSortOrder($request->completesortorder);
					$getCompletedObj->setSortOn("booktime");
					$completedListRes = $bookMapper->getCompletedList($getCompletedObj);
					$jsoncompletedList = json_encode($completedListRes);
					$resevdesk['CompletedList'] = $jsoncompletedList;
				}else if($request->completesorton == "boktablenumber"){
					$getCompletedObj->setSortOrder($request->completesortorder);
					$getCompletedObj->setSortOn("boktablenumber");
					$completedListRes = $bookMapper->getCompletedList($getCompletedObj);
					$jsoncompletedList = json_encode($completedListRes);
					$resevdesk['CompletedList'] = $jsoncompletedList;
				}else if($request->completesorton == "bokparty_size"){
					$getCompletedObj->setSortOrder($request->completesortorder);
					$getCompletedObj->setSortOn("bokparty_size");
					$completedListRes = $bookMapper->getCompletedList($getCompletedObj);
					$jsoncompletedList = json_encode($completedListRes);
					$resevdesk['CompletedList'] = $jsoncompletedList;
				}else{
					$completedListRes = $bookMapper->getCompletedList($getCompletedObj);
					$completedSortedArray = $this->array_sort($completedListRes,$request->completesorton,$request->completesortorder);
					$jsoncompletedList = json_encode($completedSortedArray);
					$resevdesk['CompletedList'] = $jsoncompletedList;
				}
				}else{
						$CompletedListRes = $bookMapper->getCompletedList($getCompletedObj);
						$jsoncompletedList = json_encode($CompletedListRes);
						$resevdesk['CompletedList'] = $jsoncompletedList;
				}			
			/* Reteriving Completed list end */			
			
			/* Reteriving Waiting list start */

			$getWaitingList = new Reservation_Model_GetWaitingList();
			$getWaitingList->setRestaurantId($resId);
			$getWaitingList->setDate($date);
			$getWaitingList->setIsAjaxCall(true);
			if(count($timesLimit)==2)
			{
				$getWaitingList->setStartTime($timesLimit['start_time']);
				$getWaitingList->setEndTime($timesLimit['end_time']);
			}
			/* Reteriving booking status id by code */
			$status = array();

			$bookStatus = array('WAL','READY','QUOTE','BAR','NEXT','CANCUS','BACK');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
			$getWaitingList->setBookStatus($bookStatusRes);
			$waitnSortedArray = array();
			if(isset($request->waitsorton)&& isset($request->waitsortorder) && $request->waitsorton != "" && $request->waitsortorder != ""){
				if($request->waitsorton == "booktime"){
					$getWaitingList->setSortOrder($request->waitsortorder);
					$waitingListRes = $bookMapper->getWaitingList($getWaitingList);
					$jsonwaitingList = json_encode($waitingListRes);
					$resevdesk['WaitingList'] = $jsonwaitingList;
				}else{
					$waitingListRes = $bookMapper->getWaitingList($getWaitingList);
					$waitnSortedArray = $this->array_sort($waitingListRes,$request->waitsorton,$request->waitsortorder);
					$jsonattenList = json_encode($waitnSortedArray);
					$resevdesk['WaitingList'] = $jsonattenList;
				}
			}else{
				$waitingListRes = $bookMapper->getWaitingList($getWaitingList);
				$jsonwaitingList = json_encode($waitingListRes);
				$resevdesk['WaitingList'] = $jsonwaitingList;
			}

			/* Reteriving Waiting list end */
			/* Reteriving Table layout start */

			$diningidArr = array();
			$diningAreaArr = array();
			$diningMapper = new FirmManagement_Model_FirmDiningAreaDataMapper();
			$Diningresult = $diningMapper->getDinigAreasByRestId($resId);
			if($request->diningid){
				$diningid = $request->diningid;
			}else{
				foreach($Diningresult as $dining){
					$diningidArr[] = $dining->rdaid;
				}
				$diningid = $diningidArr[0];
			}
			$resevdesk['diningareas'] = $diningAreaArr;

			$mapper = new FirmManagement_Model_FirmTableDataMapper();
			$tableObj = new FirmManagement_Model_FirmTable();
			$tableObj->setResId($resId);
			$tableObj->setDiningId($diningid);
			$resultStr = $mapper->getRestaurantTable($tableObj);
			$resultFloor = $resultStr['finalStr'];
			$floorPlan = json_encode($resultFloor);
			$floorentrance = json_encode($resultStr['etnStr']);

			$resevdesk['FloorPlan'] = $floorPlan;
			$resevdesk['FloorEntrance'] = $floorentrance;
			
			/* Retrieve seprator layout start */
			
			$restFloorSep = new FirmManagement_Model_FirmFloorSeprator();
			$restFloorSep->setrfsfk_restaurant($resId);
			$restFloorSep->setrfsfk_restaurant_dining_area($diningid);	
			
			$resFloorSepMapper = new FirmManagement_Model_FirmFloorSepratorMapper();
			$floorSepArr = $resFloorSepMapper->retrieveFloorSeprators($restFloorSep);
			
			$resevdesk['FloorSep'] = json_encode($floorSepArr);  
			
			/* Retrieve seprator layout end */
			
			

			//array_push($resevdesk,array('FloorPlan'=>$floorPlan));
			//array_push($resevdesk,array('FloorEntrance'=>$floorentrance));

			/* Reteriving Table layout End */

			/* Reteriving table status start */

			$getTableStatusObj = new Reservation_Model_GetTableStatus();
			$getTableStatusObj->setRestaurantId($resId);
			$getTableStatusObj->setDate($date);
			$getTableStatusObj->setIsAjaxCall(true);
			/* Reteriving Reservation Status Id */
			$bookStatus = array('ALC','DES','BOK','PTS','CRD','WRD','BIL');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$getTableStatusObj->setBookStatus($bookStatusRes);

			$tableStatus = $bookMapper->getTableStatus($getTableStatusObj);
			$jsontableStatus = json_encode($tableStatus);
			$resevdesk['TableStatus'] = $jsontableStatus;
			//array_push($resevdesk,array('TableStatus'=>$jsontableStatus));

			/* Reteriving table status end */

			/* Reteriving Freeze Status Start */

			$freezeStatus = new Reservation_Model_GetFreezeStatus();
			$date = date('Y-m-d');
			$freezeStatus->setRestId($resId);
			$freezeStatus->setFreezeDate($date);

			$freezemapper = new Reservation_Model_RestaurantFreezeDataMapper();
			$status = $freezemapper->GetFreezeStatus($freezeStatus);

			$resevdesk['FreezeStatus'] = json_encode($status);

			/* Reteriving Freeze Status End */

			/* Reteriving restaurant logo Start */



			$row = $bookMapper->GetRestaurantLogo($resId);
			$resevdesk['RestLogo'] = json_encode($row->reslogo);

			/* Reteriving restaurant logo End */
			/* Retrieve Sec Tables for Highlight */			
			
			$SecServer = new Application_Service_Serverservice();			
			$secTablesArr = $SecServer->getSecTablesForHighlight($resId);
			$resevdesk['SecTables'] = json_encode($secTablesArr);
			/* Retrieve Server List */
			if(isset($request->date)){
				$dte = $request->date;
			}else{
				$dte = date('Y-m-d');
			}
			$serverList = $SecServer->getServersByRestId($resId,$dte);
			$resevdesk['ServerList'] = json_encode($serverList);
			$meal = new FirmManagement_Model_FirmMealType();

			$bookStatus = array('WAL','READY','QUOTE','BAR','NEXT','CANCUS','BACK','RSD','OVB');
			$abouttoSeat = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$bookStatus = array('ALC','DES','BOK','PTS','CRD','WRD','BIL');
			$seating = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
			$time = date('h:i A');
			$bookStatus = array('COM');
			$seated = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
			$mealMapper = new FirmManagement_Model_FirmMealTypeDataMapper();
			$timeMeal = '';
			if(isset($request->date)){
				$date = $request->date;
			}else{
				$date = date('Y-m-d');
			}
			if($request->mealtype){
				$meal->setResId($resId)
				->setDate($date)
				->setMealType($request->mealtype);
				$timeMeal = $mealMapper->GetRestaurantMealByType($meal);
			}else{
				$meal->setResId($resId)
				->setDate($date)
				->setTime($time);
				$timeMeal = $mealMapper->GetRestaurantMealByTime($meal);
			}

			if($timeMeal){
				$meal->setMealType($timeMeal->mealid)
				->setStartTime($timeMeal->rmt_start_time)
				->setEndTime($timeMeal->rmt_end_time)
				->setSeating($seating)
				->setAboutToSeat($abouttoSeat)
				->setSeated($seated);


				$mealCount = $bookMapper->getCountByMealType($meal);
				$resevdesk['mealCount'] = $mealCount;
				$mealResult = $mealMapper->GetRestaurantMealTypes($meal);
				$resevdesk['mealType'] = $timeMeal->meal;
			}else{
				$resevdesk['mealType'] = '';
			}

			/* Reteriving Reservation Status Id */
			
			$bookStatus = array('RSD','OVB','BKD','ALC','DES','BOK','PTS','CRD','WRD','BIL','COM');
			$abouttoSeat = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
			
			$bookStatus = array('WAL','READY','QUOTE','BAR','NEXT','CANCUS','BACK');
			$waiting = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

//			$bookStatus = array('ALC','DES','BOK','PTS','CRD','WRD','BIL');
//			$seating = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

//			$bookStatus = array('COM');
//			$seated = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
			$statusArr = array(
								'Upcoming'		=>	$abouttoSeat,
//								'Seated'		=>	$seating,
//								'Completed'		=>	$seated,
								'Waiting'		=>	$waiting
								);
			if(count($timesLimit)==2)
			{
					$resevdesk['reservCount'] = $bookMapper->RetrieveReservationCounts($resId,$date,$statusArr,$timesLimit);
			
			}
			else
			{
				$resevdesk['reservCount'] = $bookMapper->RetrieveReservationCounts($resId,$date,$statusArr);
			
			}
			
			$finalResevDesk = json_encode($resevdesk);

			return $finalResevDesk;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * @param request,array
	 * retreives all the reservations for landscape manager
	 */
	public function ReservationDeskLandScape($request,$data)
	{
		try{
			$resId = $request->restaurantid;
			$result = array();
			$date = null;
			$datStat = "";
			$resServ = new Application_Service_Firm();
			$timeZone = $resServ->GetRestaurantTimeZone($resId);
			date_default_timezone_set($timeZone);
			if(isset($request->date)){
				$date = $request->date;
				$datStat = "request";
			}else{
				$date = date('Y-m-d');
			}
			
			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			$bookMapper = new Reservation_Model_ReservationDataMapper();

			/* Reteriving Table layout start */

			$diningidArr = array();
			$diningAreaArr = array();
			$diningMapper = new FirmManagement_Model_FirmDiningAreaDataMapper();
			$Diningresult = $diningMapper->getDinigAreasByRestId($resId);
			if($request->diningid){
				$diningid = $request->diningid;
			}else{
				foreach($Diningresult as $dining){
					$diningidArr[] = $dining->rdaid;
				}
				$diningid = $diningidArr[0];
			}
			$result['diningareas'] = $Diningresult;
			$result['diningid'] = $diningid;

			$mapper = new FirmManagement_Model_FirmTableDataMapper();
			$tableObj = new FirmManagement_Model_FirmTable();
			$tableObj->setResId($resId);
			$tableObj->setDiningId($diningid);
			$resultStr = $mapper->getRestaurantTable($tableObj);

			$result['Layout'] = $resultStr;

			/* Reteriving Table layout end */
			
			/* Retrieve seprator layout start */
			
			$restFloorSep = new FirmManagement_Model_FirmFloorSeprator();
			$restFloorSep->setrfsfk_restaurant($resId);
			$restFloorSep->setrfsfk_restaurant_dining_area($diningid);	
			
			$resFloorSepMapper = new FirmManagement_Model_FirmFloorSepratorMapper();
			$floorSepArr = $resFloorSepMapper->retrieveFloorSeprators($restFloorSep);
			
			$result['FloorSep'] = $floorSepArr;  
			
			/* Retrieve seprator layout end */
			
			/* Reteriving table status start */

			$getTableStatusObj = new Reservation_Model_GetTableStatus();
			$getTableStatusObj->setRestaurantId($resId);
			$getTableStatusObj->setDate($date);

			/* Reteriving Reservation Status Id */
			$bookStatus = array('ALC','DES','BOK','PTS','CRD','WRD','BIL','RSD','OVB','BKD');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$getTableStatusObj->setBookStatus($bookStatusRes);

			$tableStatus = $bookMapper->getTableStatus($getTableStatusObj);
			$result['TableStatus'] = $tableStatus;

			/* Reteriving table status end */
			
			/* Reteriving Freeze Status Start */

			$freezeStatus = new Reservation_Model_GetFreezeStatus();
			$freezeStatus->setRestId($resId);
			$freezeStatus->setFreezeDate($date);
			$freezemapper = new Reservation_Model_RestaurantFreezeDataMapper();
			$status = $freezemapper->GetFreezeStatus($freezeStatus);
			$result['FreezeStatus'] = $status;

			/* Reteriving Freeze Status End */

			/* Reteriving Freezed Dates Start 	*/
			$freezedmapper = new Reservation_Model_RestaurantFreezeDataMapper();
			$freezedDates = $freezedmapper->GetFreezedDates($resId);

			$result['FreezedDates'] = $freezedDates;

			/* Reteriving Freezed Dates End 	*/
			
			/* Reteriving Attending list start */

			$getAttenListObj = new Reservation_Model_GetAttendingList();
			$getAttenListObj->setRestaurantId($resId);
			$getAttenListObj->setDate($date);

			/* Reteriving Reservation Status Id */
			$bookStatus = array('RSD','OVB');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$getAttenListObj->setBookStatus($bookStatusRes);
			$attenListRes = $bookMapper->getAttendingList($getAttenListObj);
			$result['Attending'] = $attenListRes;

			/* Reteriving Attending list end */

			/* Reteriving Completed list start */

			$getCompletedObj = new Reservation_Model_GetAttendingList();
			$getCompletedObj->setRestaurantId($resId);
			$getCompletedObj->setDate($date);

			/* Reteriving Reservation Status Id */
			$bookStatus = array('ALC','DES','BOK','PTS','CRD','COM','WRD','BIL');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$getCompletedObj->setBookStatus($bookStatusRes);
			$CompletedListRes = $bookMapper->getAttendingList($getCompletedObj);
			$result['Completed'] = $CompletedListRes;

			/* Reteriving Completed list end */
			
			/* Reteriving Waiting list start */

			$getWaitingList = new Reservation_Model_GetWaitingList();
			$getWaitingList->setRestaurantId($resId);
			$getWaitingList->setDate($date);

			/* Reteriving booking status id by code */
			$status = array();

			$bookStatus = array('WAL','READY','QUOTE','BAR','NEXT','CANCUS','BACK');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
			$getWaitingList->setBookStatus($bookStatusRes);

			$waitingListRes = $bookMapper->getWaitingList($getWaitingList);
			$result['WaitingList'] = $waitingListRes;

			/* Reteriving Waiting list end */
			
			/* Reteriving restaurant logo Start */

			$row = $bookMapper->GetRestaurantLogo($resId);
			if($row){
				$result['RestLogo'] = $row->reslogo;
				$result['RestName'] = $row->resrestaurant_name;
			}

			/* Reteriving restaurant logo End */
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function Ajax_ReservationDeskLandScape($request)
	{
		try{
			$resId  = $request->restaurantid;
			$result = array();
			$resevdesk = array();
			$date = null;
			$resServ = new Application_Service_Firm();
			$timeZone = $resServ->GetRestaurantTimeZone($resId);
			date_default_timezone_set($timeZone);
			if(isset($request->date)){
				$date = $request->date;
			}else{
				$date = date('Y-m-d');
			}
			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			$bookMapper = new Reservation_Model_ReservationDataMapper();

			

			/* Reteriving Attending list start */

			$getAttenListObj = new Reservation_Model_GetAttendingList();
			$getAttenListObj->setRestaurantId($resId);
			$getAttenListObj->setDate($date);
			$getAttenListObj->setIsAjaxCall(true);
			/* Reteriving Reservation Status Id */
			$bookStatus = array('RSD','OVB');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$getAttenListObj->setBookStatus($bookStatusRes);


			/* Sorting of Data */


			$attenSortedArray = array();
			if(isset($request->attsorton)&& isset($request->attsortorder) && $request->attsorton != "" && $request->attsortorder != ""){
				if($request->attsorton == "booktime"){
					$getAttenListObj->setSortOrder($request->attsortorder);
					$getAttenListObj->setSortOn("booktime");
					$attenListRes = $bookMapper->getAttendingList($getAttenListObj);
					$jsonattenList = json_encode($attenListRes);
					$resevdesk['Attending'] = $jsonattenList;
				}else if($request->attsorton == "boktablenumber"){
					$getAttenListObj->setSortOrder($request->attsortorder);
					$getAttenListObj->setSortOn("boktablenumber");
					$attenListRes = $bookMapper->getAttendingList($getAttenListObj);
					$jsonattenList = json_encode($attenListRes);
					$resevdesk['Attending'] = $jsonattenList;
				}else if($request->attsorton == "bokparty_size"){
					$getAttenListObj->setSortOrder($request->attsortorder);
					$getAttenListObj->setSortOn("bokparty_size");
					$attenListRes = $bookMapper->getAttendingList($getAttenListObj);
					$jsonattenList = json_encode($attenListRes);
					$resevdesk['Attending'] = $jsonattenList;
				}else{
					$attenListRes = $bookMapper->getAttendingList($getAttenListObj);
					$attenSortedArray = $this->array_sort($attenListRes,$request->attsorton,$request->attsortorder);
					$jsonattenList = json_encode($attenSortedArray);
					$resevdesk['Attending'] = $jsonattenList;
				}
			}else{
				$attenListRes = $bookMapper->getAttendingList($getAttenListObj);
				$jsonattenList = json_encode($attenListRes);
				$resevdesk['Attending'] = $jsonattenList;
			}
			//array_push($resevdesk,array('Attending'=>$jsonattenList));

			/* Reteriving Attending list end */

			/* Reteriving Completed list start */
			$getCompletedObj = new Reservation_Model_GetCompletedList();
			$getCompletedObj->setRestaurantId($resId);
			$getCompletedObj->setDate($date);
			$getCompletedObj->setIsAjaxCall(true);
			/* Reteriving Reservation Status Id */
			$bookStatus = array('ALC','DES','BOK','PTS','CRD','COM','WRD','BIL');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$getCompletedObj->setBookStatus($bookStatusRes);
			
			/* Sorting of Data */
			$completedSortedArray = array();
			if(isset($request->completesorton)&& isset($request->completesortorder) && $request->completesorton != "" && $request->completesortorder != ""){
				if($request->completesorton == "booktime"){
					$getCompletedObj->setSortOrder($request->completesortorder);
					$getCompletedObj->setSortOn("booktime");
					$completedListRes = $bookMapper->getCompletedList($getCompletedObj);
					$jsoncompletedList = json_encode($completedListRes);
					$resevdesk['CompletedList'] = $jsoncompletedList;
				}else if($request->completesorton == "boktablenumber"){
					$getCompletedObj->setSortOrder($request->completesortorder);
					$getCompletedObj->setSortOn("boktablenumber");
					$completedListRes = $bookMapper->getCompletedList($getCompletedObj);
					$jsoncompletedList = json_encode($completedListRes);
					$resevdesk['CompletedList'] = $jsoncompletedList;
				}else if($request->completesorton == "bokparty_size"){
					$getCompletedObj->setSortOrder($request->completesortorder);
					$getCompletedObj->setSortOn("bokparty_size");
					$completedListRes = $bookMapper->getCompletedList($getCompletedObj);
					$jsoncompletedList = json_encode($completedListRes);
					$resevdesk['CompletedList'] = $jsoncompletedList;
				}else{
					$completedListRes = $bookMapper->getCompletedList($getCompletedObj);
					$completedSortedArray = $this->array_sort($completedListRes,$request->completesorton,$request->completesortorder);
					$jsoncompletedList = json_encode($completedSortedArray);
					$resevdesk['CompletedList'] = $jsoncompletedList;
				}
				}else{
						$CompletedListRes = $bookMapper->getCompletedList($getCompletedObj);
						$jsoncompletedList = json_encode($CompletedListRes);
						$resevdesk['CompletedList'] = $jsoncompletedList;
				}			
			/* Reteriving Completed list end */	
			
			/* Reteriving Waiting list start */

			$getWaitingList = new Reservation_Model_GetWaitingList();
			$getWaitingList->setRestaurantId($resId);
			$getWaitingList->setDate($date);
			$getWaitingList->setIsAjaxCall(true);
			/* Reteriving booking status id by code */
			$status = array();

			$bookStatus = array('WAL','READY','QUOTE','BAR','NEXT','CANCUS','BACK');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
			$getWaitingList->setBookStatus($bookStatusRes);


			$waitnSortedArray = array();
			if(isset($request->waitsorton)&& isset($request->waitsortorder) && $request->waitsorton != "" && $request->waitsortorder != ""){
				if($request->waitsorton == "booktime"){


					$getWaitingList->setSortOrder($request->waitsortorder);
					$waitingListRes = $bookMapper->getWaitingList($getWaitingList);
					$jsonwaitingList = json_encode($waitingListRes);
					$resevdesk['WaitingList'] = $jsonwaitingList;


				}else{


					$waitingListRes = $bookMapper->getWaitingList($getWaitingList);
					$waitnSortedArray = $this->array_sort($waitingListRes,$request->waitsorton,$request->waitsortorder);
					$jsonattenList = json_encode($waitnSortedArray);
					$resevdesk['WaitingList'] = $jsonattenList;
				}
			}else{
				$waitingListRes = $bookMapper->getWaitingList($getWaitingList);
				$jsonwaitingList = json_encode($waitingListRes);


				$resevdesk['WaitingList'] = $jsonwaitingList;
			}

			/* Reteriving Waiting list end */
			 	
			
			/* Reteriving Table layout start */

			$diningidArr = array();
			$diningAreaArr = array();
			$diningMapper = new FirmManagement_Model_FirmDiningAreaDataMapper();
			$Diningresult = $diningMapper->getDinigAreasByRestId($resId);
			if($request->diningid){
				$diningid = $request->diningid;
			}else{
				foreach($Diningresult as $dining){
					$diningidArr[] = $dining->rdaid;
				}
				$diningid = $diningidArr[0];
			}
			$resevdesk['diningareas'] = $diningAreaArr;

			$mapper = new FirmManagement_Model_FirmTableDataMapper();
			$tableObj = new FirmManagement_Model_FirmTable();
			$tableObj->setResId($resId);
			$tableObj->setDiningId($diningid);
			$resultStr = $mapper->getRestaurantTable($tableObj);
			$resultFloor = $resultStr['finalStr'];
			$floorPlan = json_encode($resultFloor);
			$floorentrance = json_encode($resultStr['etnStr']);

			$resevdesk['FloorPlan'] = $floorPlan;
			$resevdesk['FloorEntrance'] = $floorentrance;
			
			/* Retrieve seprator layout start */
			
			$restFloorSep = new FirmManagement_Model_FirmFloorSeprator();
			$restFloorSep->setrfsfk_restaurant($resId);
			$restFloorSep->setrfsfk_restaurant_dining_area($diningid);	
			
			$resFloorSepMapper = new FirmManagement_Model_FirmFloorSepratorMapper();
			$floorSepArr = $resFloorSepMapper->retrieveFloorSeprators($restFloorSep);
			
			$resevdesk['FloorSep'] = json_encode($floorSepArr);  
			
			/* Retrieve seprator layout end */
			
			

			//array_push($resevdesk,array('FloorPlan'=>$floorPlan));
			//array_push($resevdesk,array('FloorEntrance'=>$floorentrance));

			/* Reteriving Table layout End */

			/* Reteriving table status start */

			$getTableStatusObj = new Reservation_Model_GetTableStatus();
			$getTableStatusObj->setRestaurantId($resId);
			$getTableStatusObj->setDate($date);
			$getTableStatusObj->setIsAjaxCall(true);
			/* Reteriving Reservation Status Id */
			$bookStatus = array('ALC','DES','BOK','PTS','CRD','WRD','BIL','RSD','OVB','BKD');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$getTableStatusObj->setBookStatus($bookStatusRes);

			$tableStatus = $bookMapper->getTableStatus($getTableStatusObj);
			$jsontableStatus = json_encode($tableStatus);
			$resevdesk['TableStatus'] = $jsontableStatus;
			//array_push($resevdesk,array('TableStatus'=>$jsontableStatus));

			/* Reteriving table status end */

			/* Reteriving Freeze Status Start */

			$freezeStatus = new Reservation_Model_GetFreezeStatus();
			$date = date('Y-m-d');
			$freezeStatus->setRestId($resId);
			$freezeStatus->setFreezeDate($date);

			$freezemapper = new Reservation_Model_RestaurantFreezeDataMapper();
			$status = $freezemapper->GetFreezeStatus($freezeStatus);

			$resevdesk['FreezeStatus'] = json_encode($status);

			/* Reteriving Freeze Status End */

			/* Reteriving restaurant logo Start */



			$row = $bookMapper->GetRestaurantLogo($resId);
			$resevdesk['RestLogo'] = json_encode($row->reslogo);

			/* Reteriving restaurant logo End */


			$finalResevDesk = json_encode($resevdesk);

			return $finalResevDesk;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	/**
	 * @param request
	 * retreives the floor details for the ajax call
	 */
	public function Ajax_FloorPlan($request)
	{
		try{
			$resId  = $request->restaurantid;

			/* Reteriving Table layout start */

			$mapper = new FirmManagement_Model_FirmTableDataMapper();
			$tableObj = new FirmManagement_Model_FirmTable();
			$tableObj->setResId($resId);
			$resultStr = $mapper->getRestaurantTable($tableObj);

			$result = json_encode($resultStr);
			return $result;

			/* Reteriving Table layout End */
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param request
	 * retreives the blocked reservations for the ajax call
	 */
	public function Ajax_InQueueList($request)
	{
		try{
			$resId  = $request->restaurantid;
			$result = array();
			$date = date('Y-m-d');
			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			$bookMapper = new Reservation_Model_ReservationDataMapper();

			/* Reteriving InQueue list start */

			$getInQueueList = new Reservation_Model_GetInQueueList();
			$getInQueueList->setRestaurantId($resId);
			$getInQueueList->setIsAjaxCall(true);
			$getInQueueList->setDate($date);

			/* Reteriving booking status id by code */
			$status = array();

			$status[] = 'RSD';
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($status);
			$bookStatusObj = $bookStatusRes['RSD'];
			$getInQueueList->setBookStatus($bookStatusObj->getId());

			$inqueueList = $bookMapper->getInQueueList($getInQueueList);
			$jsonInQueueList = json_encode($inqueueList);

			return $jsonInQueueList;

			/* Reteriving InQueue list end */
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param request
	 * retreives the reservations with status reserved for the ajax action
	 */
	public function Ajax_AttendingList($request)
	{
		try{
			$resId  = $request->restaurantid;

			$result = array();
			$date = date('Y-m-d');
			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			$bookMapper = new Reservation_Model_ReservationDataMapper();
			/* Reteriving Attending list start */

			$getAttenListObj = new Reservation_Model_GetAttendingList();
			$getAttenListObj->setRestaurantId($resId);
			$getAttenListObj->setDate($date);
			$getAttenListObj->setIsAjaxCall(true);
			/* Reteriving Reservation Status Id */
			$bookStatus = array('ALC','DES','BOK','PTS','CRD');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$getAttenListObj->setBookStatus($bookStatusRes);
			$attenListRes = $bookMapper->getAttendingList($getAttenListObj);
			$json_attenListRes = json_encode($attenListRes);
			return $json_attenListRes;

			/* Reteriving Attending list end */
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param request
	 * retreives the table status of the reservations for the ajax call
	 */
	public function Ajax_TableStatus($request)
	{
		try{
			$resId  = $request->restaurantid;
			$result = array();
			$date = date('Y-m-d');
			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			$bookMapper = new Reservation_Model_ReservationDataMapper();

			/* Reteriving table status start */

			$getTableStatusObj = new Reservation_Model_GetTableStatus();
			$getTableStatusObj->setRestaurantId($resId);
			$getTableStatusObj->setDate($date);
			$getTableStatusObj->setIsAjaxCall(true);
			/* Reteriving Reservation Status Id */
			$bookStatus = array('ALC','DES','BOK','PTS','CRD');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$getTableStatusObj->setBookStatus($bookStatusRes);

			$tableStatus = $bookMapper->getTableStatus($getTableStatusObj);
			$result = json_decode($tableStatus);
			return $result;

			/* Reteriving table status end */
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param request
	 * retreives the reservations based on slot for the reservation list
	 */
	public function ReservationList($request)
	{
		try{
			$result = array();
			$resId = $request->restaurantid;
			$date = $request->date;


			if($request->changedate){
				$dateArr = explode("-",$date);
				if($request->changedate == "next"){
					$date = mktime(0,0,0,$dateArr[0],(int)$dateArr[1]+1,$dateArr[2]);
					$date = date("m-d-Y",$date);
				}else if($request->changedate == "prev"){
					$date = mktime(0,0,0,$dateArr[0],(int)$dateArr[1]-1,$dateArr[2]);
					$date = date("m-d-Y",$date);
				}
			}

			$restObj = new Reservation_Model_ReservationList();
			$bookMapper = new Reservation_Model_ReservationDataMapper();
			$restObj->setRestaurantId($resId);
			$restObj->setDate($date);


			if(isset($request->event)){
				$restObj->setevent($request->event);
			}
			if(isset($request->offset)){
				$restObj->setoffset($request->offset);


			}

			$resList = $bookMapper->ReservationList($restObj);
			if(isset($resList['timeBlockArr'])){
				$result['slots'] = $resList['timeBlockArr'];
			}

			$diningidArr = array();
			$diningAreaArr = array();
			$diningMapper = new FirmManagement_Model_FirmDiningAreaDataMapper();
			$Diningresult = $diningMapper->getDinigAreasByRestId($resId);
			$result['diningareas'] = $Diningresult;
			if($request->diningid){
				$diningid = $request->diningid;
			}else{
				foreach($Diningresult as $dining){
					$diningidArr[] = $dining->rdaid;
				}
				$diningid = $diningidArr[0];
			}

			$mapper = new FirmManagement_Model_FirmTableDataMapper();
			$tableObj = new FirmManagement_Model_FirmTable();
			$tableObj->setResId($resId);
			$tableObj->setDiningId($diningid);
			$resultStr = $mapper->getRestaurantTable($tableObj);
			$result['layout'] = $resultStr;

			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			$getTableStatusObj = new Reservation_Model_GetTableStatus();
			$getTableStatusObj->setRestaurantId($resId);
			$getTableStatusObj->setDate($date);
			$bookStatus = array('ALC','DES','BOK','PTS','CRD');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
			$getTableStatusObj->setBookStatus($bookStatusRes);
			$tableStatus = $bookMapper->getTableStatus($getTableStatusObj);
			$result['TableStatus'] = $tableStatus;

			$result['prev'] = $resList['prev'];
			$result['next'] = $resList['next'];
			if(isset($resList['offset'])){
				$result['offset'] = $resList['offset'];
			}
			if(isset($resList['nextvalue'])){
				$result['nextvalue'] = $resList['nextvalue'];


			}

			$result['date'] = $date;

			/* Reteriving Freeze Status Start */

			$freezeStatus = new Reservation_Model_GetFreezeStatus();
			//$date = date('Y-m-d');
			$freezeStatus->setRestId($resId);
			$freezeStatus->setFreezeDate($date);

			$freezemapper = new Reservation_Model_RestaurantFreezeDataMapper();
			$status = $freezemapper->GetFreezeStatus($freezeStatus);
			$result['FreezeStatus'] = $status;

			/* Reteriving Freeze Status End */

			/* Reteriving Freezed Dates Start 	*/
			$freezedmapper = new Reservation_Model_RestaurantFreezeDataMapper();
			$freezedDates = $freezedmapper->GetFreezedDates($resId);
			$result['FreezedDates'] = $freezedDates;

			/* Reteriving Freezed Dates End 	*/

			/* Reteriving restaurant logo Start */

			$row = $bookMapper->GetRestaurantLogo($resId);
			if($row){
				$result['RestLogo'] = $row->reslogo;
				$result['RestName'] = $row->resrestaurant_name;
			}


			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param request
	 * retreives the reservations of the restaurant based on the table for reservation list view
	 */
	public function ReservationListView($request,$data)
	{
		try{
			$resId  = $request->restaurantid;
			$result = array();
			$date = null;
			$datStat = "";
			$resServ = new Application_Service_Firm();
			$timeZone = $resServ->GetRestaurantTimeZone($resId);
			date_default_timezone_set($timeZone);
			if(isset($request->date)){
				$date = $request->date;
				$datStat = "request";
			}else{
				$date = date('Y-m-d');
			}
			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			$bookMapper = new Reservation_Model_ReservationDataMapper();

			/* Reteriving Table layout start */

			$diningidArr = array();
			$diningAreaArr = array();
			$diningMapper = new FirmManagement_Model_FirmDiningAreaDataMapper();
			$Diningresult = $diningMapper->getDinigAreasByRestId($resId);
			if($request->diningid){
				$diningid = $request->diningid;
			}else{
				foreach($Diningresult as $dining){
					$diningidArr[] = $dining->rdaid;
				}
				$diningid = $diningidArr[0];
			}
			$result['diningareas'] = $Diningresult;
			$result['diningid'] = $diningid;

			$mapper = new FirmManagement_Model_FirmTableDataMapper();
			$tableObj = new FirmManagement_Model_FirmTable();
			$tableObj->setResId($resId);
			$tableObj->setDiningId($diningid);
			$resultStr = $mapper->getRestaurantTable($tableObj);

			$result['Layout'] = $resultStr;

			/* Reteriving Table layout end */
			
			/* Retrieve seprator layout start */
			
			$restFloorSep = new FirmManagement_Model_FirmFloorSeprator();
			$restFloorSep->setrfsfk_restaurant($resId);
			$restFloorSep->setrfsfk_restaurant_dining_area($diningid);	
			
			$resFloorSepMapper = new FirmManagement_Model_FirmFloorSepratorMapper();
			$floorSepArr = $resFloorSepMapper->retrieveFloorSeprators($restFloorSep);
			
			$result['FloorSep'] = $floorSepArr;  
			
			$getTableStatusObj = new Reservation_Model_GetTableStatus();
			$getTableStatusObj->setRestaurantId($resId);
			$getTableStatusObj->setDate($date);

			/* Reteriving Reservation Status Id */
			$bookStatus = array('ALC','DES','BOK','PTS','CRD','WRD','BIL');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$getTableStatusObj->setBookStatus($bookStatusRes);

			$tableStatus = $bookMapper->getTableStatus($getTableStatusObj);
			$result['TableStatus'] = $tableStatus;

			/* Reteriving table status end */
			/* Reteriving no-show reservations count start*/
			$getNoshowObj = new Reservation_Model_GetNoShowList();
			$getNoshowObj->setRestaurantId($resId);
			$getNoshowObj->setDate($date);
			$getNoshowObj->setIsAjaxCall(true);
			$bookStatus = array('NOS');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
			$getNoshowObj->setBookStatus($bookStatusRes);
			$noshowlist = $bookMapper->GetNoShowReservation($getNoshowObj);
			if(count($noshowlist)){
				$result['No-Show'] = count($noshowlist);
			}else{
				$result['No-Show'] = '';
			}

			/* Reteriving no-show reservations count end*/
			/* Reteriving Attending list start */

			$getAttenListObj = new Reservation_Model_GetAttendingList();
			$getAttenListObj->setRestaurantId($resId);
			$getAttenListObj->setDate($date);

			/* Reteriving Reservation Status Id */
			$bookStatus = array('ALC','DES','BOK','PTS','CRD','RSD','OVB','WRD','BKD','BIL');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$getAttenListObj->setBookStatus($bookStatusRes);
			$attenListRes = $bookMapper->getAttendingList($getAttenListObj);
			$result['Attending'] = $attenListRes;

			/* Reteriving Attending list end */

			
			/* Reteriving Waiting list start */

			$getWaitingList = new Reservation_Model_GetWaitingList();
			$getWaitingList->setRestaurantId($resId);
			$getWaitingList->setDate($date);

			/* Reteriving booking status id by code */
			$status = array();

			$bookStatus = array('WAL','READY','QUOTE','BAR','NEXT','CANCUS','BACK');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
			$getWaitingList->setBookStatus($bookStatusRes);

			$waitingListRes = $bookMapper->getWaitingList($getWaitingList);
			$result['WaitingList'] = $waitingListRes;

			/* Reteriving Waiting list end */
			 	

			$freezeStatus = new Reservation_Model_GetFreezeStatus();
			$freezeStatus->setRestId($resId);
			$freezeStatus->setFreezeDate($date);
			$freezemapper = new Reservation_Model_RestaurantFreezeDataMapper();
			$status = $freezemapper->GetFreezeStatus($freezeStatus);
			$result['FreezeStatus'] = $status;

			/* Reteriving Freeze Status End */

			/* Reteriving Freezed Dates Start 	*/
			$freezedmapper = new Reservation_Model_RestaurantFreezeDataMapper();
			$freezedDates = $freezedmapper->GetFreezedDates($resId);

			$result['FreezedDates'] = $freezedDates;

			/* Reteriving Freezed Dates End 	*/

			/* Reteriving Alert Status Start */
			if($data['Usertype'] == 'RSO'){
				$userid = $data['User_Id'];
				$Alertmapper = new FirmManagement_Model_FirmAlertDataMapper();
				$Alertstatus = $Alertmapper->GetAlertStatus($userid,$date,$resId);
				foreach($Alertstatus as $val){
					if($val->rar_alertstatus == 2){
						$result['AlertStstus'] = true;
						break;
					}else{
						$result['AlertStstus'] = false;
					}
				}
				$result['Alert'] = $Alertstatus;
				$result['Alertusertype'] = 'RSO';
			}else if($data['Usertype'] == 'RSU'){
				$userid = $data['User_Id'];
				$Alertmapper = new FirmManagement_Model_FirmAlertDataMapper();
				$Alertstatus = $Alertmapper->GetRestuarntUserAlerts($userid,$date,$resId);
				foreach($Alertstatus as $val){
					if($val->rar_alertstatus == 2){
						$result['AlertStstus'] = true;
						break;
					}else{
						$result['AlertStstus'] = false;
					}
				}
				$result['Alert'] = $Alertstatus;
				$result['Alertusertype'] = 'RSU';
			}else if($data['Usertype'] == 'SRU'){
				$userid = $data['User_Id'];
				$Alertmapper = new FirmManagement_Model_FirmAlertDataMapper();
				$Alertstatus = $Alertmapper->GetRestuarntUserAlerts($userid,$date,$resId);
				foreach($Alertstatus as $val){
					if($val->rar_alertstatus == 2){
						$result['AlertStstus'] = true;
						break;
					}else{
						$result['AlertStstus'] = false;
					}
				}
				$result['Alert'] = $Alertstatus;
				$result['Alertusertype'] = 'SRU';
			}
			/* Reteriving Alert Status End */
			 	
			/* Reteriving restaurant logo Start */

			$row = $bookMapper->GetRestaurantLogo($resId);
			if($row){
				$result['RestLogo'] = $row->reslogo;
				$result['RestName'] = $row->resrestaurant_name;
			}

			/* Reteriving restaurant logo End */
			 	
			/* Reteriving restaurant  payment status Start  */

			$restMapper = new FirmManagement_Model_FirmDataMapper();
			$paymentstatus = $restMapper->GetPaymentStatusByRestaurantId($resId);
			$result['paymentstatus'] = $paymentstatus;
			/* Reteriving restaurant  payment status End  */
			 	
			/* reteriving timings */

			$resMapper = new FirmManagement_Model_FirmScheduleDataMapper();
			$resObj = new FirmManagement_Model_FirmSchedule();
			$resObj->setrssfk_restaurant($request->restaurantid);
			$dateSplit = explode("-",$date);
			if($datStat){
				$weekday = strtolower(date("D", mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2])));
			}else{
				$weekday = strtolower(date("D", mktime(0,0,0,$dateSplit[1],$dateSplit[2],$dateSplit[0])));
				$date = date('m-d-Y');
			}
			//date_default_timezone_set('Asia/Kolkata');
			$time = date('h:i A');

			$timeArray = array();
			$finalArray = array();
			$prevArray  = array();
			$nextArray	= array();
			$resObj->setrssday_of_week($weekday);
			$resObj->setdate($date);
			
			$meal = new FirmManagement_Model_FirmMealType();

			$bookStatus = array('WAL','READY','QUOTE','BAR','NEXT','CANCUS','BACK','RSD','OVB');
			$abouttoSeat = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$bookStatus = array('ALC','DES','BOK','PTS','CRD');
			$seating = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$bookStatus = array('COM');
			$seated = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
			$meal->setResId($resId)
			->setDate($date)
			->setTime($time);
			$mealMapper = new FirmManagement_Model_FirmMealTypeDataMapper();
			$timeMeal = $mealMapper->GetRestaurantMealByTime($meal);
			if(!$timeMeal){
				$mealType = $mealMapper->GetRestaurantMealTypes($meal);
				$mealT = "";
				foreach($mealType as $key=>$value){
					if($key != 'count'){
						$mealT = $value['meal'];
						break;
					}
				}
				if($mealT){
					$meal->setMealType($mealT);
					$timeMeal = $mealMapper->GetRestaurantMealByType($meal);
				}
			}
			if($timeMeal){
				$meal->setMealType($timeMeal->mealid)
				->setStartTime($timeMeal->rmt_start_time)
				->setEndTime($timeMeal->rmt_end_time)
				->setSeating($seating)
				->setAboutToSeat($abouttoSeat)
				->setSeated($seated);

				$mealCount = $bookMapper->getCountByMealType($meal);
				$result['mealCount'] = $mealCount;
				$mealResult = $mealMapper->GetRestaurantMealTypes($meal);
				$result['mealType'] = $timeMeal->meal;
			}else{
				$result['mealType'] = '';
			}

			return $result;
			
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param request
	 * retreives the reservations based on the table for the auto refresh of the reservation listview
	 */
	public function Ajax_ReservationListView($request)
	{
		try{
			$resId  = $request->restaurantid;
			$result = array();
			$resevdesk = array();
			$date = null;
			$resServ = new Application_Service_Firm();
			$timeZone = $resServ->GetRestaurantTimeZone($resId);
			date_default_timezone_set($timeZone);
			if(isset($request->date)){
				$date = $request->date;
			}else{
				$date = date('Y-m-d');
			}
			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			$bookMapper = new Reservation_Model_ReservationDataMapper();
			/* Reteriving Attending list start */

			$getAttenListObj = new Reservation_Model_GetAttendingList();
			$getAttenListObj->setRestaurantId($resId);
			$getAttenListObj->setDate($date);
			$getAttenListObj->setIsAjaxCall(true);
			/* Reteriving Reservation Status Id */
			$bookStatus = array('ALC','DES','BOK','PTS','CRD','RSD','OVB','WRD','BKD','BIL');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$getAttenListObj->setBookStatus($bookStatusRes);

			/* Sorting of Data */
			$attenSortedArray = array();
			if(isset($request->attsorton)&& isset($request->attsortorder) && $request->attsorton != "" && $request->attsortorder != ""){
				if($request->attsorton == "booktime"){
					$getAttenListObj->setSortOrder($request->attsortorder);
					$getAttenListObj->setSortOn("booktime");
					$attenListRes = $bookMapper->getAttendingList($getAttenListObj);
					$jsonattenList = json_encode($attenListRes);
					$resevdesk['Attending'] = $jsonattenList;
				}else if($request->attsorton == "boktablenumber"){
					$getAttenListObj->setSortOrder($request->attsortorder);
					$getAttenListObj->setSortOn("boktablenumber");
					$attenListRes = $bookMapper->getAttendingList($getAttenListObj);
					$jsonattenList = json_encode($attenListRes);
					$resevdesk['Attending'] = $jsonattenList;
				}else if($request->attsorton == "bokparty_size"){
					$getAttenListObj->setSortOrder($request->attsortorder);
					$getAttenListObj->setSortOn("bokparty_size");
					$attenListRes = $bookMapper->getAttendingList($getAttenListObj);
					$jsonattenList = json_encode($attenListRes);
					$resevdesk['Attending'] = $jsonattenList;
				}else{
					$attenListRes = $bookMapper->getAttendingList($getAttenListObj);
					$attenSortedArray = $this->array_sort($attenListRes,$request->attsorton,$request->attsortorder);
					$jsonattenList = json_encode($attenSortedArray);
					$resevdesk['Attending'] = $jsonattenList;
				}
			}else{
				$attenListRes = $bookMapper->getAttendingList($getAttenListObj);
				$jsonattenList = json_encode($attenListRes);
				$resevdesk['Attending'] = $jsonattenList;
			}
			/* Reteriving Attending list end */

			
			
			/* Reteriving Waiting list start */

			$getWaitingList = new Reservation_Model_GetWaitingList();
			$getWaitingList->setRestaurantId($resId);
			$getWaitingList->setDate($date);
			$getWaitingList->setIsAjaxCall(true);
			/* Reteriving booking status id by code */
			$status = array();

			$bookStatus = array('WAL','READY','QUOTE','BAR','NEXT','CANCUS','BACK');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
			$getWaitingList->setBookStatus($bookStatusRes);
			$waitnSortedArray = array();
			if(isset($request->waitsorton)&& isset($request->waitsortorder) && $request->waitsorton != "" && $request->waitsortorder != ""){
				if($request->waitsorton == "booktime"){
					$getWaitingList->setSortOrder($request->waitsortorder);
					$waitingListRes = $bookMapper->getWaitingList($getWaitingList);
					$jsonwaitingList = json_encode($waitingListRes);
					$resevdesk['WaitingList'] = $jsonwaitingList;
				}else{
					$waitingListRes = $bookMapper->getWaitingList($getWaitingList);
					$waitnSortedArray = $this->array_sort($waitingListRes,$request->waitsorton,$request->waitsortorder);
					$jsonattenList = json_encode($waitnSortedArray);
					$resevdesk['WaitingList'] = $jsonattenList;
				}
			}else{
				$waitingListRes = $bookMapper->getWaitingList($getWaitingList);
				$jsonwaitingList = json_encode($waitingListRes);
				$resevdesk['WaitingList'] = $jsonwaitingList;
			}
			/* Reteriving Waiting list end */

			/* Reteriving Table layout start */
			$diningidArr = array();
			$diningAreaArr = array();
			$diningMapper = new FirmManagement_Model_FirmDiningAreaDataMapper();
			$Diningresult = $diningMapper->getDinigAreasByRestId($resId);
			if($request->diningid){
				$diningid = $request->diningid;
			}else{
				foreach($Diningresult as $dining){
					$diningidArr[] = $dining->rdaid;
				}
				$diningid = $diningidArr[0];
			}
			$resevdesk['diningareas'] = $diningAreaArr;

			$mapper = new FirmManagement_Model_FirmTableDataMapper();
			$tableObj = new FirmManagement_Model_FirmTable();
			$tableObj->setResId($resId);
			$tableObj->setDiningId($diningid);
			$resultStr = $mapper->getRestaurantTable($tableObj);
			$resultFloor = $resultStr['finalStr'];
			$floorPlan = json_encode($resultFloor);
			$floorentrance = json_encode($resultStr['etnStr']);

			$resevdesk['FloorPlan'] = $floorPlan;
			$resevdesk['FloorEntrance'] = $floorentrance;
			
			/* Retrieve seprator layout start */
			
			$restFloorSep = new FirmManagement_Model_FirmFloorSeprator();
			$restFloorSep->setrfsfk_restaurant($resId);
			$restFloorSep->setrfsfk_restaurant_dining_area($diningid);	
			
			$resFloorSepMapper = new FirmManagement_Model_FirmFloorSepratorMapper();
			$floorSepArr = $resFloorSepMapper->retrieveFloorSeprators($restFloorSep);
			
			$resevdesk['FloorSep'] = json_encode($floorSepArr);  
			
			/* Retrieve seprator layout end */
			/* Reteriving Table layout End */

			/* Reteriving table status start */

			$getTableStatusObj = new Reservation_Model_GetTableStatus();
			$getTableStatusObj->setRestaurantId($resId);
			$getTableStatusObj->setDate($date);
			$getTableStatusObj->setIsAjaxCall(true);
			/* Reteriving Reservation Status Id */
			$bookStatus = array('ALC','DES','BOK','PTS','CRD','WRD','BIL');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$getTableStatusObj->setBookStatus($bookStatusRes);

			$tableStatus = $bookMapper->getTableStatus($getTableStatusObj);
			$jsontableStatus = json_encode($tableStatus);
			$resevdesk['TableStatus'] = $jsontableStatus;
			//array_push($resevdesk,array('TableStatus'=>$jsontableStatus));

			/* Reteriving table status end */

			/* Reteriving Freeze Status Start */

			$freezeStatus = new Reservation_Model_GetFreezeStatus();
			$date = date('Y-m-d');
			$freezeStatus->setRestId($resId);
			$freezeStatus->setFreezeDate($date);

			$freezemapper = new Reservation_Model_RestaurantFreezeDataMapper();
			$status = $freezemapper->GetFreezeStatus($freezeStatus);

			$resevdesk['FreezeStatus'] = json_encode($status);

			/* Reteriving Freeze Status End */

			/* Reteriving restaurant logo Start */
			
			$row = $bookMapper->GetRestaurantLogo($resId);
			$resevdesk['RestLogo'] = json_encode($row->reslogo);
			
			/* Reteriving restaurant logo End */

			$meal = new FirmManagement_Model_FirmMealType();

			$bookStatus = array('WAL','READY','QUOTE','BAR','NEXT','CANCUS','BACK','RSD','OVB');
			$abouttoSeat = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$bookStatus = array('ALC','DES','BOK','PTS','CRD','WRD','BIL');
			$seating = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
			$time = date('h:i A');
			$bookStatus = array('COM');
			$seated = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
			$mealMapper = new FirmManagement_Model_FirmMealTypeDataMapper();
			$timeMeal = '';
			if(isset($request->date)){
				$date = $request->date;
			}else{
				$date = date('Y-m-d');
			}
			if($request->mealtype){
				$meal->setResId($resId)
				->setDate($date)
				->setMealType($request->mealtype);
				$timeMeal = $mealMapper->GetRestaurantMealByType($meal);
			}else{
				$meal->setResId($resId)
				->setTime($time);
				$timeMeal = $mealMapper->GetRestaurantMealByTime($meal);
			}

			if($timeMeal){
				$meal->setMealType($timeMeal->mealid)
				->setStartTime($timeMeal->rmt_start_time)
				->setEndTime($timeMeal->rmt_end_time)
				->setSeating($seating)
				->setAboutToSeat($abouttoSeat)
				->setSeated($seated);

				$mealCount = $bookMapper->getCountByMealType($meal);
				$resevdesk['mealCount'] = $mealCount;
				$mealResult = $mealMapper->GetRestaurantMealTypes($meal);
				$resevdesk['mealType'] = $timeMeal->meal;
			}else{
				$resevdesk['mealType'] = '';
			}

			$finalResevDesk = json_encode($resevdesk);
			return $finalResevDesk;	
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	/**
	 * @param request
	 * function to allocate table for the reservation
	 */
	public function AllocateSeat($request, $data)
	{
		try{
			$diningid = $request->diningid;
			$allocSeatObj 	  = new Reservation_Model_AllocateSeat();
			
			$allocSeatObj->setUserId($data['User_Id']);
			
			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			$bookStatus 	  = $bookStatusMapper->GetBookingStatusByCode(array('BOK'));
			$bookStatusObj 	  = $bookStatus['BOK'];
			$restaurantid = $request->restaurantid;

			$tableid = array();
			$tableno = array();

			$tableidString = "";
			$tablenoString = "";

			$tableidString = $request->tableid;
			$tablenoString = $request->tableno;

			if($tableidString){
				$tableid = explode(',',$tableidString);
			}

			if($tablenoString){
				$tableno = explode(',',$tablenoString);
			}

			$allocSeatObj->setBookId($request->bookingid)
			->setRestId($restaurantid)
			->setBookTableId($tableid)
			->setBookTableNo($tableno)
			->setBookStatus($bookStatusObj->getId())
			->setDiningId($diningid)
			->setBookDate($request->date);

			$bookMapper = new Reservation_Model_ReservationDataMapper();
			$status = $bookMapper->allocateSeat($allocSeatObj);
			$status = true;
			if($status){
				$result = array('status'=>true,
		 					'restaurant_id'=>$restaurantid);
				return $result;
			}else{
				$result = array('status'=>false);
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function PartiallyAllocateSeat($request,$data)
	{
		try{
			$diningid = $request->diningid;
			$allocSeatObj 	  = new Reservation_Model_AllocateSeat();
			
			$allocSeatObj->setUserId($data['User_Id']);
			
			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			$bookStatus 	  = $bookStatusMapper->GetBookingStatusByCode(array('PTS'));
			$bookStatusObj 	  = $bookStatus['PTS'];
			$restaurantid = $request->restaurantid;

			$tableid = array();
			$tableno = array();

			$tableidString = "";
			$tablenoString = "";

			$tableidString = $request->tableid;
			$tablenoString = $request->tableno;

			if($tableidString){
				$tableid = explode(',',$tableidString);
			}

			if($tablenoString){
				$tableno = explode(',',$tablenoString);
			}

			$allocSeatObj->setBookId($request->bookingid)
			->setRestId($restaurantid)
			->setBookTableId($tableid)
			->setBookTableNo($tableno)
			->setBookStatus($bookStatusObj->getId())
			->setDiningId($diningid)
			->setBookDate($request->date);

			$bookMapper = new Reservation_Model_ReservationDataMapper();
			$status = $bookMapper->allocateSeat($allocSeatObj);
			$status = true;
			if($status){
				$result = array('status'=>true,
		 					'restaurant_id'=>$restaurantid);
				return $result;
			}else{
				$result = array('status'=>false);
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param request
	 * function to pre-allocate the table for the reservation
	 */
	public function PreAllocateSeat($request, $data)
	{

		try{
			$diningid = $request->prediningid;
			$preallocSeatObj 	  = new Reservation_Model_AllocateSeat();

			$preallocSeatObj->setUserId($data['User_Id']);
			
			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			$restaurantid = $request->restaurantid;

			$tableid = array();
			$tableno = array();

			$tableidString = "";
			$tablenoString = "";

			$tableidString = $request->pretableid;
			$tablenoString = $request->pretableno;

			if($tableidString){
				$tableid = explode(',',$tableidString);
			}

			if($tablenoString){
				$tableno = explode(',',$tablenoString);
			}

			$preallocSeatObj->setBookId($request->bookingid)
			->setRestId($restaurantid)
			->setBookTableId($tableid)
			->setBookTableNo($tableno)
			->setDiningId($diningid)
			->setBookDate($request->date);

			$bookMapper = new Reservation_Model_ReservationDataMapper();
			$status = $bookMapper->preallocateSeat($preallocSeatObj);

			if($status){
				$result = array('status'=>true,
		 					'restaurant_id'=>$restaurantid);
				return $result;
			}else{

				$result = array('status'=>false);
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param request
	 * function to cancel the pre-allocation of table for the reservation
	 */
	public function CancelPreAllocation($request)
	{
		try{
			$bokid = $request->bookingid;

			$bookMapper = new Reservation_Model_ReservationDataMapper();
			
			$status = $bookMapper->CancelPreAllocation($bokid);
			return $status;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}	

	/**
	 * @param request
	 * function to move the reservation to a different table
	 */
	public function MoveParty($request)
	{
		try{
			$diningid = $request->movdiningid;
			$movePartyObj 	  = new Reservation_Model_MoveParty();
			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			$bookMapper = new Reservation_Model_ReservationDataMapper();
			
			$tableid = array();
			$tableno = array();

			$tableidString = "";
			$tablenoString = "";

			$tableidString = $request->movtableid;
			$tablenoString = $request->movtableno;

			if($tableidString){
				$tableid = explode(',',$tableidString);
			}

			if($tablenoString){
				$tableno = explode(',',$tablenoString);
			}
			
			$restaurantid = $request->restaurantid;
			$movePartyObj->setBookId($request->bookingid)
			->setRestId($restaurantid)
			->setBookTableId($tableid)
			->setBookTableNo($tableno)
			->setDiningId($diningid)
			->setBookDate($request->date);

			
			$status = $bookMapper->MoveParty($movePartyObj);
			if($status){

				$result = array('status'	   => true,
		 						'restaurant_id'=> $restaurantid);
				return $result;
			}else{

				$result = array('status' => false);
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param request
	 * function to change the table status of the reservations
	 */
	public function ChangeTableStatus($request, $data)
	{
		try{
			$companyid = $data['companyid'];
			$changeTableStatusObj  = new Reservation_Model_AllocateSeat();
			
			$changeTableStatusObj->setUserId($data['User_Id']);

			/* Reteriving Reservation Status Id By Code */
			$bokStatusCode = null;
			$bokStatusCode = $request->bookingstatus;
			$bookMapper = new Reservation_Model_ReservationDataMapper();
			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			if($bokStatusCode){
				$bookStatus 	  = $bookStatusMapper->GetBookingStatusByCode(array($bokStatusCode));
				//echo '<pre>'; print_r($bookStatus); exit;
				$bookStatusObj 	  = $bookStatus[$bokStatusCode];
			}else{
				$bookPrevStatus = $bookMapper->getBookingPrevStatus($request->bookingid);
				$bookStatus 	  = $bookStatusMapper->GetBookingStatusById(array(trim($bookPrevStatus)));
				$bookStatusObj 	  = $bookStatus[$bookPrevStatus];
			}
			$restaurantid = $request->restaurantid;
			$changeTableStatusObj->setRestId($restaurantid);
			/* get booking id with phraseid */
//			$phraseId = $bookMapper->GetBookingIdByBookPhrase($request->bookingid);
			
			$changeTableStatusObj->setBookId($request->bookingid);
			$changeTableStatusObj->setBookStatus($bookStatusObj->getId());
			$changeTableStatusObj->setBookStatusCode($bookStatusObj->getCode());
			
			$book = new Reservation_Model_Reservation();
			$book->setbokid($request->bookingid);
//			$book->setbokbookingphrase($request->bookingid);
			$bokDetails = $bookMapper->getBookingDetails($book);
			if($bokDetails->getbokcontactid()){
				$changeTableStatusObj->setContactid($bokDetails->getbokcontactid());
			}
			$neme = $book->getresrestaurant_name();
			if($request->bookingstatus == 'NOS' && $book->getbokemail()){
				if($request->reservtransaction == 'true'){
					$payServ = new Application_Service_Renumeration();
					$customer = new ManageRenumeration_Model_CreateInvoiceByCustId();
					$customer->setRestId($restaurantid)
					->setCustId($bokDetails->getbokuserid())
					->setBookingId($phraseId);
					$CustomerInvoice = $payServ->GenerateCustomerInvoice($customer);
					$CustomerInvoice->setpaymentprofid($request->payprof);
					$CustTransaction = $payServ->CustomerReservationTransaction($CustomerInvoice);
					if($CustTransaction['status']){
						$bookStatus 	  = $bookMapper->ChangeTableStatus($changeTableStatusObj);
					}else{
						$bookStatus 	  = false;
					}
				}else{
					$bookStatus 	  = $bookMapper->ChangeTableStatus($changeTableStatusObj);
				}
			}else{
				$bookStatus 	  = $bookMapper->ChangeTableStatus($changeTableStatusObj);
			}
			if($request->bokaction == 'SHOW' && $bokDetails->getbokcontactid()){
				$groupUsersDataMapper = new FirmManagement_Model_FirmGroupUsersDataMapper();
				$groupUsersDataMapper->updateGuestReservationCount($bokDetails->getbokcontactid(), 'SHOW','');
			}
			if($bookStatus){
				$result = array('status'=>true,'restaurant_id'=>$restaurantid);
				$resMapper = new FirmManagement_Model_FirmDataMapper();
				$rest = new FirmManagement_Model_FirmById();
				$rest->setRestaurantId($restaurantid);
				$resDetails = $resMapper->getRestaurantById($rest);
					
				if($request->bookingstatus == 'NOS' && $book->getbokemail()){
					$stateId = "";
					$cityId = "";
					$regionId = "";
					if($stateId == ""){
						$stateCity = $this->getRestaurantStateByResId($restaurantid);
						$stateId = $stateCity['state'];
						$cityId = $stateCity['city'];
						$regionId = $stateCity['region'];

					}
					$userType = 'CUS';
					$adminService = new Application_Service_Administrator();
					$campProp = new Application_Model_GetCampaignForPost();
					$campProp->setAudType($userType)
					->setStateId($stateId)
					->setCityId($cityId)
					->setRegionId($regionId)
					->setIsAjaxCall(false);
					$campDetails = array();
					$resMapper = new FirmManagement_Model_FirmDataMapper();
					$rest = new FirmManagement_Model_FirmById();
					$rest->setRestaurantId($restaurantid);
					$resDetails = $resMapper->getRestaurantById($rest);
					if(!$resDetails->getrescampaignstatus() === false){
						$campDetails = $adminService->GetCampaignDetails($campProp);
					}
					$mailmapper = new Application_Service_Communication();
					
					$mailObj = new Communication_Model_Mail();
					$mailObj->setMsgCode('No-Show');
					$name = $book->getbokfirst_name().' '.$book->getboklast_name();
					$data = array('UserName' => $name,
								  'Bokid'				=> $request->bookingid,
								  'SenTo'    			=> $book->getbokemail(),
								  'RestName' 			=> $book->getresrestaurant_name(),
								  'ResDate'  			=> $book->getbokbooking_date(),
								  'Time'     			=> $book->getbokbooking_timings(),
							  	  'Size'     			=> $book->getbokparty_size(),
								  'Address'	 			=> $book->getresaddress(),
								  'Status'	 			=> $book->getbokbooking_status_desc(),
								  'State_Id' 			=>	$stateId,
								  'City_Id'	 			=>	$cityId,
								  'UserType' 			=>	$userType,
								  'ResManager'			=>	$resDetails->getRestmanagername(),
								  'ResEmail'			=>	$resDetails->getRestemail()
					);
					if(count($campDetails)){
						$count = count($campDetails);
						if($count > 1){
							$campaign = $campDetails[rand(0,$count-1)];
						}else{
							$campaign = $campDetails[0];
						}
						$notfService = new Application_Service_Communication();
						$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
						$data['campaignName'] = trim($campaign->getSponsor());
						$data['campaignDesc'] =	trim($campaign->getCampDesc());
						$data['campaignImg'] =	trim($campaign->getCampImage());
						$data['campId']	= $campaign->getId();
					}
					if($request->noshowmailsend == 'yes'){
						$mailObj->setData($data);
						$mailStatus = $mailmapper->SendMail($mailObj);
					}
				}else if(isset($request->bokaction) && $request->bokaction == 'SHOW'){
					$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
					$bookStatus = array('NOS');
					$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
					$noshow = new Reservation_Model_GetNoShowList();
					$noshow->setBookStatus($bookStatusRes);
					$noshow->setRestaurantId($restaurantid);
					$noshow->setDate($request->selDate);
					$noshow->setIsAjaxCall(true);
					$noshowcount = $bookMapper->GetNoShowReservation($noshow);
					$result['count'] = count($noshowcount);
				}else if($request->bookingstatus == 'COM'){
					$resowner = $data['Firstname'].' '.$data['LastName'];
					$name = $book->getbokfirst_name().' '.$book->getboklast_name();
					$data = array('UserName' 			=>  $name,
								  'Bokid'				=> 	$request->bookingid,
								  'SenTo'    			=> 	$book->getbokemail(),
								  'to'					=> 	$book->getbokphone(),
								  'countrycode'			=>  $book->getbokcountry_code(),
								  'RestName' 			=> 	$book->getresrestaurant_name(),
								  'ResDate'  			=> 	$book->getbokbooking_date(),
								  'UserType' 			=>	'CUS',
								  'ResManager'			=>	$resDetails->getRestmanagername(),
								  'ResEmail'			=>	$resDetails->getRestemail(),
								  'ResOwner'			=>	$resowner,
								  'ResId'				=>	$restaurantid
					);
					$notifmapper = new Application_Service_Communication();
											
					if($book->getbokemail()){
						$mailObj = new Communication_Model_Mail();                                                
                                                if($companyid==25){
                                                $mailObj->setMsgCode('ThankMsgDWU');        
                                                }else{
                                                $mailObj->setMsgCode('ThankMsg');    
                                                }						
						$mailObj->setData($data);	
						$mailStatus = $notifmapper->SendMail($mailObj);
					}
					if($book->getbokphone()){	
						$smsObj = new Communication_Model_Sms();
						$smsObj->setMsgCode('ThankMsg');					
						$smsObj->setData($data);									
						$smsStatus = $notifmapper->SendSms($smsObj);
					}				
				}
				return $result;
			}else{
				$result = array('status'=>false);
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param request
	 * function to retreive the reservation object using booking id
	 */
	public function ChangeWaitingTime($request)
	{
		try{
			$quote = new Reservation_Model_ReservationWaitingQuoteMap();
			$bookMapper = new Reservation_Model_ReservationDataMapper();
//			$bokid = $bookMapper->GetBookingIdByBookPhrase($request->bokid);
			$bokid = $request->bokid;
			$quote->setBookId($bokid);
//			$quote->setbokbookingphrase($request->bokid);

			$waitingquoteMapper = new Application_Model_WaitingQuoteTimeDataMapper();
			$quotecode = $request->quoteTime;
			$quoteStatus 	  = $waitingquoteMapper->GetQuoteTimeByCode(array($quotecode));
			$quoteObj 	  = $quoteStatus[$quotecode];
			$quote->setQuoteId($quoteObj->getId());

			
			$rowsEffected = $bookMapper->updateWaitingQuote($bokid,$quoteObj->getId());

			$quoteMapper = new Reservation_Model_ReservationWaitingQuoteMapDataMapper();
			$result = $quoteMapper->InsertQuotedTimes($quote);
			
			$book = new Reservation_Model_Reservation();
			$book->setbokid($bokid);
//			$book->setbokbookingphrase($request->bokid);
			$bookDetails = $bookMapper->getBookingDetails($book);
			if($bookDetails->getbokphone() != ""){
				$name = $bookDetails->getbokfirst_name().' '.$bookDetails->getboklast_name();
				$custMsg = '';
//				$custMsg = 'Hi '.$name.', your waiting time has been updated, please wait '.$quoteObj->getDescription().'.  '.$bookDetails->getresrestaurant_name();
				$smsObj = new Communication_Model_Sms();
				$smsObj->setMsgCode('WaitingQuoteChange');
				$data = array(
								'to'			=> trim($bookDetails->getbokphone()),
								'countrycode'	=> $bookDetails->getbokcountry_code(),
								'RestName' 		=> $bookDetails->getresrestaurant_name(),
								'UserName'		=> $name,
								'BookId'		=> $request->bokid
				);
				if($quoteObj->getCode() =='NS'){
					$data['Quote'] = '';
				}else{
					$data['Quote'] = $quoteObj->getDescription();
				}
								
				$smsObj->setData($data);
				$mailmapper = new Application_Service_Communication();
				$mailStatus = $mailmapper->SendSms($smsObj);
			}
				
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function GetWaitingTimes($request)
	{
		try{
			$bookingId = $request->bookid;
			$quoteMapper = new Reservation_Model_ReservationWaitingQuoteMapDataMapper();
			$result = $quoteMapper->GetWaitingQuote($bookingId);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function SendWaitingCustomMessage(array $data)
	{
		try{
			$resId = $data['restaurantid'];
			$bokId = $data['bookingid'];
			$custPref = $data['custnotPref'];
			$notType = $data['custnotType'];
			if(isset($data['custnotSender'])){
				$notSender = $data['custnotSender'];
			}else{
				$notSender = 'RES';
			}

			$bookMapper = new Reservation_Model_ReservationDataMapper();
			/* get booking id with phraseid */
			$phraseId = $bookMapper->GetBookingPhraseByBookid($bokId);
			
			$book = new Reservation_Model_Reservation();
			$book->setbokid($bokId);
//			$book->setbokbookingphrase($bokId);
			$bookDetails = $bookMapper->getBookingDetails($book);
			$resServ = new Application_Service_Firm();
			$timeZone = $resServ->GetRestaurantTimeZone($resId);
			date_default_timezone_set($timeZone);
			
			$restService = new Application_Service_Firm();
			$restResult = $restService->GetRestaurantDetailsById($resId);
			$cusname = $bookDetails->getbokfirst_name().' '.$bookDetails->getboklast_name();
			$custMsg = '';
			$comPhone = '';
			$comEmail = '';
			if($notSender == 'CUS'){
				$comPhone = $restResult->resphone;
				$comEmail = $restResult->resemail;
				$RestName = $cusname;
				$UserName = $restResult->resrestaurant_name;
			}else{
				$comPhone = trim($bookDetails->getbokphone());
				$comEmail = $bookDetails->getbokemail();
				$RestName = $restResult->resrestaurant_name;
				$UserName = $cusname;
			}
			$Waitdata = array();
			$smsObj = new Communication_Model_Sms();
			if($custPref == 'AUTO' && $notType == 'sms' && $bookDetails->getNotificationType() == 'sms'){
				$smsObj->setMsgCode('WaitingReady');
				$Waitdata = array(
								'to'			=>	$comPhone,
								'countrycode'	=> $bookDetails->getbokcountry_code(),
								'RestName' 		=> $RestName,
								'UserName'		=> $UserName,
								'BookId'		=> $bokId,
								'Sender'		=> $notSender
				);
			}else if($custPref == 'MANUAL' && $notType == 'sms' && $bookDetails->getNotificationType() == 'sms'){
				$smsObj->setMsgCode('WaitingCustMsg');
				$Waitdata = array(
								'to'			=>	$comPhone,
								'countrycode'	=> $bookDetails->getbokcountry_code(),
								'RestName' 		=> $RestName,
								'UserName'		=> $UserName,
								'custMsg'		=> $data['custommsg'],
								'BookId'		=> $bokId,
								'Sender'		=> $notSender
				);
				$storage = new Zend_Auth_Storage_Session();
				$userdata = $storage->read();
				$bokStat = $bookMapper->getBookingPrevStatus($bokId);
				$bokLog = new Reservation_Model_BookingLog();
				$bokLog->setbok_log_fk_booking($bokId)
						->setbok_log_booked_type($bokStat)
						->setbok_log_book_message('Custom Message Sent : '.$data['custommsg'])
						->setbok_log_updated_by($userdata['User_Id'])
						->setbok_log_updated_at(date('Y-m-d H:i:s'));
				if($notSender == 'CUS'){
					$bokLog->setbok_log_update_done_by('CUS');
				}else{
					$bokLog->setbok_log_update_done_by('RES');
				}
				$bokLogMapper = new Reservation_Model_BookingLogMapper();
				$bokLogResult = $bokLogMapper->updateBookingLog($bokLog);
			}else if($custPref == 'MANUAL' && $notType == 'email' && $bookDetails->getNotificationType() == 'email'){
				$custMsg = $data['custommsg'];
			}else if($custPref == 'MANUAL' && $notType == 'both' && $bookDetails->getNotificationType() == 'both'){
				$smsObj->setMsgCode('WaitingCustMsg');
				$Waitdata = array(
								'to'			=>	$comPhone,
								'countrycode'	=> $bookDetails->getbokcountry_code(),
								'RestName' 		=> $RestName,
								'UserName'		=> $UserName,
								'custMsg'		=> $data['custommsg'],
								'BookId'		=> $bokId,
								'Sender'		=> $notSender
				);
				$custMsg = $data['custommsg'];
				$storage = new Zend_Auth_Storage_Session();
				$userdata = $storage->read();
				$bokStat = $bookMapper->getBookingPrevStatus($bokId);
				$bokLog = new Reservation_Model_BookingLog();
				$bokLog->setbok_log_fk_booking($bokId)
						->setbok_log_booked_type($bokStat)
						->setbok_log_book_message('Custom Message Sent : '.$custMsg)
						->setbok_log_updated_by($userdata['User_Id'])
						->setbok_log_updated_at(date('Y-m-d H:i:s'));
				if($notSender == 'CUS'){
					$bokLog->setbok_log_update_done_by('CUS');
				}else{
					$bokLog->setbok_log_update_done_by('RES');
				}				
				$bokLogMapper = new Reservation_Model_BookingLogMapper();
				$bokLogResult = $bokLogMapper->updateBookingLog($bokLog);
			}else if($custPref == 'AUTO' && $notType == 'both' && $bookDetails->getNotificationType() == 'both'){
				$smsObj->setMsgCode('WaitingReady');
				$Waitdata = array(
								'to'			=>	$comPhone,
								'countrycode'	=> $bookDetails->getbokcountry_code(),
								'RestName' 		=> $RestName,
								'UserName'		=> $UserName,
								'BookId'		=> $bokId,
								'Sender'		=> $notSender
				);
			}
			$mailmapper = new Application_Service_Communication();
			if($notType == 'sms' && $bookDetails->getNotificationType() == 'sms'){
				if($bookDetails->getbokphone() != ""){
					$smsObj->setData($Waitdata);
					$mailStatus = $mailmapper->SendSms($smsObj);
				}
			}else if($notType == 'both' && $bookDetails->getNotificationType() == 'both'){
				if($bookDetails->getbokphone() != ""){
					$smsObj->setData($Waitdata);
					$mailStatus = $mailmapper->SendSms($smsObj);
				}				
			}		
			return $mailStatus;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param request
	 * function to retreive the reservation object using booking id
	 */
	public function ChangeCustomerReservationStatus($request)
	{
		try{
			$changeTableStatusObj  = new Reservation_Model_AllocateSeat();
			$bokStatusCode = $request->status;
			$bookMapper = new Reservation_Model_ReservationDataMapper();
			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();

			$bookStatus 	  = $bookStatusMapper->GetBookingStatusByCode(array($bokStatusCode));
			$bookStatusObj 	  = $bookStatus[$bokStatusCode];

			$restaurantid = $request->restaurantid;
			$changeTableStatusObj->setRestId($restaurantid);
			/* get booking id with phraseid */
			$phraseId = $bookMapper->GetBookingIdByBookPhrase($request->bokid);
			
			$changeTableStatusObj->setBookId($phraseId);
			$changeTableStatusObj->setBookStatus($bookStatusObj->getId());
			$changeTableStatusObj->setBookStatusCode($bookStatusObj->getCode());

			$Status = $bookMapper->ChangeTableStatus($changeTableStatusObj);
			$result = $this->GetBookingDetails($phraseId);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param request
	 * function to retreive the reservation object using booking id
	 */
	public function getBookingObjByBookingId($request)
	{
		try{
			$bookStatusMapper = new Reservation_Model_ReservationDataMapper();
			/* get booking id with phraseid */
//			$phraseId = $bookStatusMapper->GetBookingIdByBookPhrase($request->bookingid);
			
			$bookingObj = new Reservation_Model_Reservation();
			$bookingObj->setbokid($request->bookingid);
			$bookingObj = $bookStatusMapper->getBookingDetails($bookingObj);


			$date = date("m-d-Y",strtotime($bookingObj->getbokbooking_date()));


			$formValues = array(
					'firstName' 		=>	$bookingObj->getbokfirst_name(),
					'lastName'			=>	$bookingObj->getboklast_name(),
					'number'			=>	$bookingObj->getbokphone(),
					'countryCode'		=>	$bookingObj->getbokcountry_code(),
					'pax'				=>	$bookingObj->getbokparty_size(),
					'resDate'			=>	$date,
					'resDateVal'		=>	date("d M Y",strtotime($bookingObj->getbokbooking_date())),
					'resTime'			=>	$bookingObj->getbokbooking_timings(),
					'tableType'			=>	$bookingObj->getbokbooking_type_id(),
					'email'				=>	$bookingObj->getbokemail(),
					'notificationType'	=>	$bookingObj->getNotificationType(),
					'origin'			=>	$bookingObj->getbokreservation_mode_code(),
					'bookingid'			=>	$request->bookingid,
					'rescheduleStatus'	=>	'RES',
					'contactInfo'		=>  $bookingObj->getbokspecial_request(),
					'dinerRequest'		=>	$bookingObj->getbokrestaurant_note(),
					'blockstat'			=>	$bookingObj->getblockStatus(),
					'blockamt'			=>	$bookingObj->getblockAmount(),
					'blockdesc'			=>	$bookingObj->getblockDescription()
			);
			if($bookingObj->getbokoptionsid())
			{
				$formValues['bokoptionid'] = $bookingObj->getbokoptionsid();
			}
			return $formValues;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param request
	 * function to retreive the reservation details using reservation id
	 */
	public function getBookingDetailsByBookingId($request)
	{
		try{
			$bookStatusMapper = new Reservation_Model_ReservationDataMapper();
			/* get booking id with phraseid */
//			$phraseId = $bookStatusMapper->GetBookingIdByBookPhrase($request->bookingid);
			
			$bookingObj = new Reservation_Model_Reservation();
			$bookingObj->setbokid($request->bookingid);
			$bookingObj = $bookStatusMapper->getBookingDetails($bookingObj);


			$date = date("d M Y",strtotime($bookingObj->getbokbooking_date()));
			$number = "";
			$email = "";
			$notType = "";
			if($bookingObj->getbokphone()){
				$number = $bookingObj->getbokcountry_code().$bookingObj->getbokphone();
			}
			if($bookingObj->getbokemail()){
				$email = $bookingObj->getbokemail();
			}
			if($bookingObj->getNotificationTypeDesc()){
				$notType = $bookingObj->getNotificationTypeDesc();
			}
			$text =  $bookingObj->getboklast_name()." ".$bookingObj->getbokfirst_name();
			
			$restgroupMapper = new FirmManagement_Model_FirmGroupUsersDataMapper();
			if($bookingObj->getbokcontactid()){
				$groupInfo = $restgroupMapper->searchCusContactByGroupId($bookingObj->getbokcontactid(),$request->restaurantid);
			}else{
				$groupInfo = $restgroupMapper->searchCusContactByPhone($text,$bookingObj->getbokphone(),$bookingObj->getbokemail(),$request->restaurantid);
			}
			$formValues = array(
					'Bookingid'				=>	$request->bookingid,
					'firstName' 			=>	$bookingObj->getbokfirst_name(),
					'lastName'				=>	$bookingObj->getboklast_name(),
					'Phone'					=>	$number,
					'Email'					=>	$email,
					'Notification Type'		=>	$notType,
					'Party Size'			=>	$bookingObj->getbokparty_size(),
					'Booking Date'			=>	$date,
					'Booking Time'			=>	$bookingObj->getbokbooking_timings(),
					'Origin'				=>	$bookingObj->getbokreservation_mode_desc(),
					'status'				=>	$bookingObj->getbokbooking_status(),
					'bokconfirmstatus'		=>  $bookingObj->getbokbooking_confirm_status(),
					'GuestNotes'			=>	$bookingObj->getbokspecial_request()
			);
			if($groupInfo){
				$formValues['groupInfo'] = $groupInfo[0];
			}
			if($bookingObj->getblockStatus()){
				$formValues['Block Amount']	=	$bookingObj->getblockAmount();
			}
			if($bookingObj->getbokoptions()){
				$formValues['Booking Option']	=	$bookingObj->getbokoptions();
			}
			return $formValues;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetBookingDetailsCusByBokid($request,$idtype = 'bokid')
	{
		try{
			$bookStatusMapper = new Reservation_Model_ReservationDataMapper();
			/* get booking id with phraseid */
//			$phraseId = $bookStatusMapper->GetBookingIdByBookPhrase($request->bookingid);
			
			$bookingObj = new Reservation_Model_Reservation();
			if($idtype == 'bokid'){
				$bookingObj->setbokid($request->bookingid);
			}else{
				$mapper = new Reservation_Model_ReservationDataMapper();
			/* get booing id with phraseid */
				$phraseId = $mapper->GetBookingIdByBookPhrase($request->bookingid);
				$bookingObj->setbokid($phraseId);
			}
			$bookingObj = $bookStatusMapper->getBookingDetails($bookingObj);


			$date = date("m-d-Y",strtotime($bookingObj->getbokbooking_date()));
			$number = "";
			$email = "";
			$notType = "";
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			if($bookingObj->getbokphone()){
				$usphone = $bookingObj->getbokphone();
				$usphone = substr_replace($usphone, '-', 3, 0);
				$usphone = substr_replace($usphone, '-', 7, 0);
				$number = $usphone;
			}
			if($bookingObj->getbokemail()){
//				if($data['companyid'] == 1){
					$email = $bookingObj->getbokemail();
//				}else{
//					$email = '';
//				}
			}
			if($bookingObj->getNotificationTypeDesc()){
				$notType = $bookingObj->getNotificationTypeDesc();
			}
			$row = $bookStatusMapper->GetRestaurantLogo($bookingObj->getbokfk_restaurant());
			$formValues = array(
					'restid'				=>	$bookingObj->getbokfk_restaurant(),
					'firstName' 			=>	$bookingObj->getbokfirst_name(),
					'lastName'				=>	$bookingObj->getboklast_name(),
					'CountryCode'			=>	$bookingObj->getbokcountry_code(),
					'Phone'					=>	$number,
					'Email'					=>	$email,
					'Notification Type'		=>	$notType,
					'RestaurantName'		=>	$bookingObj->getresrestaurant_name(),
					'RestaurantAddr'		=>	$bookingObj->getresaddress(),
					'RestaurantEmail'		=>	$bookingObj->getResEmail(),
					'RestaurantPhone'		=>	$bookingObj->getResPhone(),
					'RestCountryCode'		=>	$bookingObj->getResCountrycode(),
					'RestaurantZip'			=>	$bookingObj->getResZipcode(),
					'Party Size'			=>	$bookingObj->getbokparty_size(),
					'Booking Date'			=>	$date,
					'Booking Time'			=>	$bookingObj->getbokbooking_timings(),
					'Origin'				=>	$bookingObj->getbokreservation_mode_desc(),
					'status'				=>	$bookingObj->getbokbooking_status_desc(),
					'statusCode'			=>	$bookingObj->getbokbooking_status_code(),
					'bokType'				=>  $bookingObj->getbokbooking_type_desc(),
					'checkedIn'				=>	$bookingObj->getbokresv_checkedin_status(),					
					'partialArrive'			=>	$bookingObj->getbokresv_partialarrived_status(),	
				    'AllArrived' 			=>	$bookingObj->getbokresv_allarrived_status(),
					'RunningLate'			=>	$bookingObj->getbokresv_runninglate_status(),
					'ConfirmStatus'			=>	$bookingObj->getbokbooking_confirm_status(),	
			);
			if($row){
				$formValues['RestLogo'] = $row->reslogo;
				$formValues['RestImg']  = $row->resimage; 
			}else{
				$formValues['RestLogo'] = '';
				$formValues['RestImg']  = ''; 
			}
			if($bookingObj->getblockStatus()){
//				$formValues['blockStat'] = $bookingObj->getblockStatus();
				$formValues['Block Amount']	=	$bookingObj->getblockAmount();
//				$formValues['Block Description'] =	$bookingObj->getblockDescription();
			}
			if($bookingObj->getbokoptions()){
				$formValues['Booking Option']	=	$bookingObj->getbokoptions();
			}
			return $formValues;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getBookingSplDetailsByBookingId($request)
	{
		try{
			$mapper = new Reservation_Model_ReservationDataMapper();
			/* get booking id with phraseid */
//			$phraseId = $mapper->GetBookingIdByBookPhrase($request->bokid);
			
//			$bokid = $request->bokid;
			$isAjaxCall = true;
			$mapper = new Deals_Model_RestaurantSpecialDataMapper();
			$result = $mapper->getRestaurantSplByBookingId($request->bokid,$isAjaxCall);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param request,page
	 * retreives the restaurants available slots and the map view for the search
	 */
	public function SearchMapView($request,$page)
	{
		try{
			$bokService = new Application_Service_Reservation();
			$mapper = new Reservation_Model_SearchListViewDataMapper();
			$searchList = new Reservation_Model_SearchListView();
			$searchList->setPax($request->pax);
			if($request->filresid){
				$searchList->setResId($request->filresid);
			}else if($request->resname != 'Select Restaurant Name' && $request->resname!= 'Enter Restaurant Name'){
				$searchList->setRestaurantname(trim($request->resname));
			}
			if($request->price){
				$price = $bokService->GetRestaurantPriceBaseData();
				$pricedec = $request->price;
				$searchList->setPrice($pricedec);
			}
			if($request->state != "" && $request->state != 0){
				$searchList->setState($request->state);
			}
			if($request->region != 0){
				$searchList->setRegion($request->region);
			}
			if($request->city != 0){
				$searchList->setCity($request->city);
			}
			if($request->neighbor != 0){
				$searchList->setNeighbor($request->neighbor);
			}
			if($request->cuisine != 0){
				$searchList->setCuisine($request->cuisine);
			}

			$dateSplit = explode("-",$request->date);
			$weekday = date("D", mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]));
			$searchList->setDay(strtolower($weekday));
			$searchList->setTime($request->time);
			$searchList->setOffset($page);
			$searchList->setDate($request->date);
			$searchList->setLimit(2);
			$searchList = $mapper->getSearchList($searchList);
			$result = array(
        	'searchList'=>$searchList,
        	'time'=>$request->time,
        	'date'=>$request->date,
			'pax'=>$request->pax,
        	'resid'=>$request->resid

			);
			if($request->price){
				$result['price'] = $pricedec;
			}
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param array,userid,state,cityid
	 * function to save the reservation details taken by the restaurant authorities
	 */
	public function MakeReservation(array $data,$userid,$stateId,$cityId,$regionId,$ressource = 'web')
	{
		try{
			$form = $this->getMakeReservationForm();
			//echo '<pre>'; print_r($data); exit;
			$mealsData = $this->getMealsByResid($data['restaurantid'],'settings');
			$form->resTime->addMultiOptions($mealsData['times']);
			if($form->isValid($data)){
				$formData = $form->getValues();
				$resServ = new Application_Service_Firm();
				$timeZone = $resServ->GetRestaurantTimeZone($formData['restaurantid']);
				date_default_timezone_set($timeZone);
				
				$bookTypeMapper = new Application_Model_ReservationTypeDataMapper();

				$userResult = "";
				$statusCode = array();
				$resultant = array();
				if($data['bookingStatus'] && $data['rescheduleStatus']){
					$statusCode[] = $data['bookingStatus'];
					$statusCode[] = $data['rescheduleStatus'];
				}else if($data['bookingStatus'] == 'OVB' && $data['overBookingstatus'] == 'NO'){
					$statusCode[] = $data['bookingStatus'];
					$statusCode[] = 'RSD';
				}else{
					$statusCode[] = $data['bookingStatus'];
				}
				$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
				$bookStatus 	  = $bookStatusMapper->GetBookingStatusByCode($statusCode);
				$bookStatusObj 	  = $bookStatus[$data['bookingStatus']];
				$resStatusObj = null;
				if(isset($bookStatus[$data['rescheduleStatus']])){
					$resStatusObj = $bookStatus[$data['rescheduleStatus']];
				}
				//echo '<pre>'; echo "s-1";
				$resModeMapper = new Application_Model_ReservationModeDataMapper();
				$rescode = $formData['origin'];
				$resModeStatus 	  = $resModeMapper->GetReservationModeByCode(array($rescode));
				$resModeObj 	  = $resModeStatus[$rescode];
				//echo '<pre>'; echo "s-2";
				$mapper = new Reservation_Model_ReservationDataMapper();
				$dinerDetails = new Reservation_Model_Reservation();

				$dinerDetails->setbokfk_restaurant($formData['restaurantid']);
				$dinerDetails->setbokbooking_date(date('m-d-Y',strtotime($formData['resDate'])));
				if($formData['resTime']){
					$boktime = $formData['resTime'];
				}else{
					$boktime = date('h:i a');
				}
				$dinerDetails->setbokbooking_timings($boktime);
				//$dinerDetails->setbokbooking_timings($formData['resTime']);
				$dinerDetails->setbokparty_size($formData['pax']);
				if($data['bookingStatus'] && $data['rescheduleStatus']){
					$dinerDetails->setbokbooking_status_id($bookStatusObj->getId());
					$dinerDetails->setbokbooking_status_code($bookStatusObj->getCode());
					$dinerDetails->setbokbooking_status($bookStatusObj->getId());
				}else if($data['bookingStatus'] == 'OVB' && $data['overBookingstatus'] == 'NO'){
					$dinerDetails->setbokbooking_status($bookStatusObj->getId());
					$dinerDetails->setbokbooking_status_code($bookStatusObj->getCode());
					$bookStatObj 	  = $bookStatus['RSD'];
					$dinerDetails->setbokbooking_status_id($bookStatObj->getId());
				}else{
					$dinerDetails->setbokbooking_status_id($bookStatusObj->getId());
					$dinerDetails->setbokbooking_status_code($bookStatusObj->getCode());
					$dinerDetails->setbokbooking_status($bookStatusObj->getId());
				}
				
				$dinerDetails->setbokfirst_name($formData['firstName']);
				$dinerDetails->setboklast_name($formData['lastName']);
				$dinerDetails->setbokcountry_code($formData['countryCode']);
				$dinerDetails->setbokphone($formData['number']);
				$dinerDetails->setbokemail($formData['email']);
				$dinerDetails->setbokrestaurant_note($formData['dinerRequest']);

				$dinerDetails->setbokbooking_made_on(date('Y-m-d H:i:s'));
				$dinerDetails->setBookingMadeTime(date("H:i",time()));

				$bookPhrase = uniqid ();
				$dinerDetails->setbokbookingphrase($bookPhrase);
				//echo '<pre>'; echo "s-3";
				$customerDetails = new User_Model_Guest();
				$payStat = false;
				$paymentId = array();

				if($formData['paymentStatus'] == 1){
					$usrServ = new Application_Service_Client();
					$userResult = $usrServ->RegisterCustomerOnReservation($formData);
					if($userResult){
						$payStat = true;
						$dinerDetails->setbokuserid($userResult);
						$customerDetails->setUserid($userResult);
						$customerDetails->setEmail($formData['email']);
						$bookType = $bookTypeMapper->GetBookingTypeByCode('PAID');
						/* Check Whether Rest Owner has Authorized.Net Customer Profile */
						$payServ = new Application_Service_Renumeration();
							
						$userProfile = $payServ->Manage_Customer_Registration_On_Reservation($customerDetails);
						if($userProfile['CustProfId']){
							$paymentProfResult = $userProfile['PaymentProfiles'];
							if($paymentProfResult){
								foreach($paymentProfResult as $row){
									$paymentId[] = $row->anppid;
								}
							}
						}else{
							$resultant['result'] = false;
							return $resultant;
						}
					}
					//echo '<pre>'; echo "s-4";
				}else if($formData['paymentStatus'] == 0){
					if($formData['blockedStatus'] == 1){
						$usrServ = new Application_Service_Client();
						$userResult = $usrServ->RegisterCustomerOnReservation($formData);
						if($userResult){
							$payStat = true;
							$dinerDetails->setbokuserid($userResult);
							$customerDetails->setUserid($userResult);
							$customerDetails->setEmail($formData['email']);
							$bookType = $bookTypeMapper->GetBookingTypeByCode('PAID');
							/* Check Whether Rest Owner has Authorized.Net Customer Profile */
							$payServ = new Application_Service_Renumeration();
								
							$userProfile = $payServ->Manage_Customer_Registration_On_Reservation($customerDetails);
							if($userProfile['CustProfId']){
								$paymentProfResult = $userProfile['PaymentProfiles'];
								if($paymentProfResult){
									foreach($paymentProfResult as $row){
										$paymentId[] = $row->anppid;
									}
								}
							}else{
								$resultant['result'] = false;
								return $resultant;
							}
						}
						$dinerDetails->setblockStatus($formData['blockedStatus']);
						$dinerDetails->setblockAmount($formData['blockedAmt']);
						$dinerDetails->setblockDescription($formData['blockedDesc']);
					}else{
						$bookType = $bookTypeMapper->GetBookingTypeByCode('NOR');
						$dinerDetails->setbokuserid($userid);
					}
					//echo '<pre>'; echo "s-5";
				}else{
					$dinerDetails->setbokuserid($userid);
					//echo '<pre>'; echo "s-6";
				}
				
				$resDataMapper = new FirmManagement_Model_FirmDataMapper();
				$seetingArr = $resDataMapper->getScheduleSettingTypeByresId($formData['restaurantid']);
				$dinerDetails->setbok_restsch_setting_id($seetingArr['settingId']);
				$dinerDetails->setbok_restsch_setting_type($seetingArr['settingType']);
					
				$dinerDetails->setbokspecial_request($formData['contactInfo']);
				$dinerDetails->setbokbooking_type_id($bookType->getId());
				$dinerDetails->setbokbooking_type_code($bookType->getCode());
				$dinerDetails->setbokreservation_mode_id($resModeObj->getId());
				$dinerDetails->setTableSize($formData['tableSize']);
				$dinerDetails->setNoOfTables($formData['noOfTables']);
				$dinerDetails->setInventoryId($formData['inventoryid']);
				$dinerDetails->setNotificationType($formData['notificationType']);
				$dinerDetails->setbokid($formData['bookingid']);
				$dinerDetails->setbokbooking_user_initials($formData['reservationInitials']);
				$dinerDetails->setbokcreatedby($formData['reservationCreator']);
				if($formData['bokoptions']){
					$dinerDetails->setbokoptions($formData['bokoptions']);
				}

				if($formData['rescheduleStatus']){
					$dinerDetails->setRescheduleCode($formData['rescheduleStatus']);
				}
				if($resStatusObj){
					$dinerDetails->setRessch_Status_Id($resStatusObj->getId());
				}
				//echo '<pre>'; echo "s-7";
				$result = $mapper->saveMakeReservationDetails($dinerDetails,'reserv',$formData);
				//echo '<pre>'; echo "s-8";
				$dinerDetails->setbokid($result);
				$mailmapper = new Application_Service_Communication();
				$restService = new Application_Service_Firm();
				$restResult = $restService->GetRestaurantDetailsById($formData['restaurantid']);
				$resDataMapper = new FirmManagement_Model_FirmDataMapper();
				$restObj= new FirmManagement_Model_FirmById();
				$restObj->setRestaurantId($formData['restaurantid']);
				$resDetails = $resDataMapper->getRestaurantById($restObj);
				if($formData['paymentStatus'] == 0 && $formData['blockedStatus'] == 0 && $ressource == 'web'){
					$rowSet = $resDataMapper->Getdiscountstatus($formData['restaurantid']);
					$mailObj = new Communication_Model_Mail();
					if($formData['email']){
						if(isset($data['rescheduleStatus']) && $data['rescheduleStatus']== 'RES'){
							$mailObj->setMsgCode('ReSchedule');
						}else{
							$mailObj->setMsgCode('BookConf');
						}
						if($stateId == ""){
							$stateCity = $this->getRestaurantStateByResId($formData['restaurantid']);
							$stateId = $stateCity['state'];
							$cityId = $stateCity['city'];
							$regionId = $stateCity['region'];
						}
						$userType = 'CUS';
						$adminService = new Application_Service_Administrator();
						$campProp = new Application_Model_GetCampaignForPost();
						$campProp->setAudType($userType)
						->setStateId($stateId)
						->setCityId($cityId)
						->setRegionId($regionId)
						->setIsAjaxCall(false);
						$campDetails = array();
						if(!$resDetails->getrescampaignstatus() === false){
							$campDetails = $adminService->GetCampaignDetails($campProp);
						}
						$discountMsg = false;
						if($rowSet['msg']){
							$discountMsg = $rowSet['msg'];
						}
						$name = $formData['firstName'].' '.$formData['lastName'];
						$resLoc = $mapper->getRestaurantLocByBookingId($result);
						$data = array('UserName' => $name,
								  'SenTo'    => $formData['email'],
								  'RestName' => $restResult->resrestaurant_name,
								  'ResDate'  => date('m-d-Y',strtotime($formData['resDate'])),
								  'Time'     => $boktime,
								  //'Time'     => $formData['resTime'],
								  'Size'     => $formData['pax'],
								  'Address'	 => $restResult->resaddress,
								  'resphone' 			=> 	$resDetails->getRestphone(),
								  'resemail'			=>	$resDetails->getRestemail(),
								  'phone'				=>	$formData['number'],
								  'rescity'				=>	$resDetails->getRestCityDesc(),
								  'resnbh'				=>	$resDetails->getRestNeighborDesc(),
								  'reszipcode'			=>	$resDetails->getRestzipcode(),
								  'Status'	 	=> $result['bokstatus'], 
								  'Bokid'	 	=>	$result,
								  'State_Id' 	=>	$stateId,
								  'City_Id'	 	=>	$cityId,
								  'UserType' 	=>	$userType,
								  'DiscountMsg' =>  $discountMsg,
								  'Note'		=>  $formData['contactInfo'],
								  'BookNotf'	=>	false, 
						
						);
						if($resLoc->res_companyid == 6){
							$data['rmnotf'] = 'true';
							$cuisine = $resDetails->getResttypeid();
							$data['cuisine']  = $cuisine[0]->getRestCuisineDesc();
						}else{
							$data['rmnotf'] = 'false';
						}
						if(count($campDetails)){
							$count = count($campDetails);
							if($count > 1){
								$campaign = $campDetails[rand(0,$count-1)];
							}else{
								$campaign = $campDetails[0];
							}
							$notfService = new Application_Service_Communication();
							$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
							$data['campaignName'] = trim($campaign->getSponsor());
							$data['campaignDesc'] =	trim($campaign->getCampDesc());
							$data['campaignImg'] =	trim($campaign->getCampImage());
							$data['campId']	= $campaign->getId();
						}
						if($mailObj->getMsgCode() == 'ReSchedule'){
							$data['splstatus']	= false;
						}
						
						$mailObj->setData($data);
						$mailStatus = $mailmapper->SendMail($mailObj);
					}else if($formData['number']){
						$smsObj = new Communication_Model_Sms();
						if(isset($data['rescheduleStatus']) && $data['rescheduleStatus']== 'RES'){

							$smsObj->setMsgCode('ReSchedule');
						}else{
							$smsObj->setMsgCode('BookConf');
						}

						$data = array(
						 'to'				=>	trim($formData['number']),
						 'countrycode'		=> $formData['countryCode'],
						 'bokid'			=> $result,
						 'RestName' 		=> $restResult->resrestaurant_name,
						 'ResDate'  		=> date('m-d-Y',strtotime($formData['resDate'])),
						 'Time'     		=> $boktime,
						 'Size'     		=> $formData['pax'],
						 'CustomerName' 	=> $formData['firstName'].' '.$formData['lastName'],
						 'RestCountryCode'	=> $restResult->res_countrycode,
						//'Address'	 => $restResult->resaddress,
						);
						$smsObj->setData($data);
						$mailStatus = $mailmapper->SendSms($smsObj);
						if($rowSet['msg']){
							$data['discountMsg'] = $rowSet['msg'];
							$smsObj->setMsgCode('DiscountNotf');
							$smsObj->setData($data);
							$mailStatus = $mailmapper->SendSms($smsObj);
						}
					}
				}
				if(($formData['paymentStatus'] == 1 ||$formData['blockedStatus'] == 1) && $userResult && $payStat == true){
					if(count($paymentId)){
						$resultant = array('result'=>$bookPhrase,'userId'=>$userResult,'status'=>true,'profileId'=>$userProfile['CustProfId'],'payment'=>$paymentId);
					}else{
						$resultant = array('result'=>$bookPhrase,'userId'=>$userResult,'status'=>true,'profileId'=>$userProfile['CustProfId'],'payment'=>false);
					}
				}else{
					$resultant = array('result'=>$bookPhrase,'userId'=>$userid,'booking'=>$result);
				}
				
			/* Check If reservation is for future date and save the info for reminder process */
						
				if($formData['bookingStatus'] == 'RSD' || $formData['bookingStatus'] == 'OVB' || $formData['bookingStatus'] == 'WAL'){
					
					$splitbookdateNotify   = explode('-',date('m-d-Y',strtotime($formData['resDate'])));
						
					$bookingdateNotify   = date('Y-m-d',mktime(0,0,0,$splitbookdateNotify[0],$splitbookdateNotify[1],$splitbookdateNotify[2]));
					$todaydateNotify     = date('Y-m-d');
					if(strtotime($bookingdateNotify) > strtotime($todaydateNotify)){
						$BookingNotify = new Reservation_Model_ReservationNotify();
						
						$BookingNotify->setbknfk_booking($result);
						$BookingNotify->setbkn_booking_date($formData['resDate']);
						
						$NotifyMapper = new Reservation_Model_ReservationNotifyMapper();
						$notifyInfoStatus = $NotifyMapper->SaveBookingNotifyInfo($BookingNotify);
					}
				}
				
				return $resultant;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function sendMakeReservationNotificationByBokId($request)
	{
		try{
			$mailmapper = new Application_Service_Communication();
			$notStatus = $this->CheckReservationNotificationStatusByBokPhraseId($request->bokid);
			$result = $this->GetBookingDetailsByPhraseId($request->bokid);
			$mapper = new Reservation_Model_ReservationDataMapper();
      
			$stateId = '';
			if(!$notStatus){
				$mailmapper = new Application_Service_Communication();
				$restService = new Application_Service_Firm();
				$resDataMapper = new FirmManagement_Model_FirmDataMapper();
				$restObj = new FirmManagement_Model_FirmById();
				$restObj->setRestaurantId($result->getbokfk_restaurant());
        
				$resDetails = $resDataMapper->getRestaurantById($restObj);
        //echo '<pre>'; print_r($resDetails); exit;
				$rowSet = $resDataMapper->Getdiscountstatus($result->getbokfk_restaurant());
				$mailObj = new Communication_Model_Mail();
        //echo '<pre>'; print_r($rowSet); exit;
				if($result->getbokemail()){
					if(isset($request->rescheduleStatus) && $request->rescheduleStatus == 'RES'){
						$mailObj->setMsgCode('ReSchedule');
					}else{
						$mailObj->setMsgCode('BookConf');
					}
					if($stateId == ""){
						$stateCity = $this->getRestaurantStateByResId($result->getbokfk_restaurant());
						$stateId = $stateCity['state'];
						$cityId = $stateCity['city'];
						$regionId = $stateCity['region'];
					}
					$userType = 'CUS';
					$adminService = new Application_Service_Administrator();
					$campProp = new Application_Model_GetCampaignForPost();
					$campProp->setAudType($userType)
							->setStateId($stateId)
							->setCityId($cityId)
							->setRegionId($regionId)
							->setIsAjaxCall(false);
					$campDetails = array();
					if(!$resDetails->getrescampaignstatus() === false){
						$campDetails = $adminService->GetCampaignDetails($campProp);
					}
					$discountMsg = false;
					if($rowSet['msg']){
						$discountMsg = $rowSet['msg'];
					}
					$name = $result->getbokfirst_name().' '.$result->getboklast_name();
					$resLoc = $mapper->getRestaurantLocByBookingId($result->getbokid());
					$data = array('UserName' => $name,
							'SenTo'    			=> 	$result->getbokemail(),
							'RestName' 			=> 	$resDetails->getRestaurantname(),
							'ResDate'  			=> 	date('m-d-Y',strtotime($result->getbokbooking_date())),
							'Time'     			=> 	$result->getbokbooking_timings(),
							'Size'     			=> 	$result->getbokparty_size(),
							'Address'	 		=> 	$resDetails->getRestaddress(),
							'resphone' 			=> 	$resDetails->getRestphone(),
							'resemail'			=>	$resDetails->getRestemail(),
							'phone'				=>	$result->getbokphone(),
							'rescity'			=>	$resDetails->getRestCityDesc(),
							'resnbh'			=>	$resDetails->getRestNeighborDesc(),
							'reszipcode'		=>	$resDetails->getRestzipcode(),
							'Status'	 		=> 	true,
							'Bokid'	 			=>	$result->getbokid(),
							'State_Id' 			=>	$stateId,
							'City_Id'	 		=>	$cityId,
							'UserType' 			=>	$userType,
							'DiscountMsg' 		=>  $discountMsg,
							'Note'				=>  $result->getbokrestaurant_note(),
							'BookNotf'			=>	false,
				
					);
					if($resLoc->res_companyid == 6){
						$data['rmnotf'] = 'true';
						$cuisine = $resDetails->getResttypeid();
						$data['cuisine']  = $cuisine[0]->getRestCuisineDesc();
					}else{
						$data['rmnotf'] = 'false';
					}
					if(count($campDetails)){
						$count = count($campDetails);
						if($count > 1){
							$campaign = $campDetails[rand(0,$count-1)];
						}else{
							$campaign = $campDetails[0];
						}
						$notfService = new Application_Service_Communication();
						$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
						$data['campaignName'] = trim($campaign->getSponsor());
						$data['campaignDesc'] =	trim($campaign->getCampDesc());
						$data['campaignImg'] =	trim($campaign->getCampImage());
						$data['campId']	= $campaign->getId();
					}
					if($mailObj->getMsgCode() == 'ReSchedule'){
						$data['splstatus']	= false;
					}
				
					$mailObj->setData($data);
					$mailStatus = $mailmapper->SendMail($mailObj);
				}else if($result->getbokphone()){
					$smsObj = new Communication_Model_Sms();
					if(isset($request->rescheduleStatus) && $request->rescheduleStatus == 'RES'){				
						$smsObj->setMsgCode('ReSchedule');
					}else{
						$smsObj->setMsgCode('BookConf');
					}
				
					$data = array(
							'to'				=>	trim($result->getbokphone()),
							'countrycode'		=> 	$result->getbokcountry_code(),
							'bokid'				=> 	$result->getbokid(),
							'RestName' 			=> 	$resDetails->getRestaurantname(),
							'ResDate'  			=> 	date('m-d-Y',strtotime($result->getbokbooking_date())),
							'Time'     			=> 	$result->getbokbooking_timings(),
							'Size'     			=>	$result->getbokparty_size(),
							'CustomerName' 		=> 	$result->getbokfirst_name().' '.$result->getboklast_name(),
							'RestCountryCode'	=> 	$resDetails->getres_country_code()
					);
					$smsObj->setData($data);
					$mailStatus = $mailmapper->SendSms($smsObj);
					if($rowSet['msg']){
						$data['discountMsg'] = $rowSet['msg'];
						$smsObj->setMsgCode('DiscountNotf');
						$smsObj->setData($data);
						$mailStatus = $mailmapper->SendSms($smsObj);
					}
				}
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function sendAutoConfirmNotificationByBokId($bookid,$reschStatus = '')
	{
		try{
			$mailmapper = new Application_Service_Communication();
			$notStatus = $this->CheckReservationNotificationStatusByBokId($bookid);
			$result = $this->GetBookingDetails($bookid);
			$mapper = new Reservation_Model_ReservationDataMapper();
			$stateId = '';
			if(!$notStatus){
				$mailmapper = new Application_Service_Communication();
				$restService = new Application_Service_Firm();
				$resDataMapper = new FirmManagement_Model_FirmDataMapper();
				$restObj= new FirmManagement_Model_FirmById();
				$restObj->setRestaurantId($result->getbokfk_restaurant());
				$resDetails = $resDataMapper->getRestaurantById($restObj);
				$rowSet = $resDataMapper->Getdiscountstatus($result->getbokfk_restaurant());
				$mailObj = new Communication_Model_Mail();
				if($result->getbokemail()){
					if(isset($reschStatus) && $reschStatus == 'RES'){
						$mailObj->setMsgCode('ReSchedule');
					}else{
						$mailObj->setMsgCode('BookConf');
					}
					if($stateId == ""){
						$stateCity = $this->getRestaurantStateByResId($result->getbokfk_restaurant());
						$stateId = $stateCity['state'];
						$cityId = $stateCity['city'];
						$regionId = $stateCity['region'];
					}
					$userType = 'CUS';
					$adminService = new Application_Service_Administrator();
					$campProp = new Application_Model_GetCampaignForPost();
					$campProp->setAudType($userType)
							->setStateId($stateId)
							->setCityId($cityId)
							->setRegionId($regionId)
							->setIsAjaxCall(false);
					$campDetails = array();
					if(!$resDetails->getrescampaignstatus() === false){
						$campDetails = $adminService->GetCampaignDetails($campProp);
					}
					$discountMsg = false;
					if($rowSet['msg']){
						$discountMsg = $rowSet['msg'];
					}
					$name = $result->getbokfirst_name().' '.$result->getboklast_name();
					$resLoc = $mapper->getRestaurantLocByBookingId($result->getbokid());
					$data = array('UserName' => $name,
							'SenTo'    			=> 	$result->getbokemail(),
							'RestName' 			=> 	$resDetails->getRestaurantname(),
							'ResDate'  			=> 	date('m-d-Y',strtotime($result->getbokbooking_date())),
							'Time'     			=> 	$result->getbokbooking_timings(),
							'Size'     			=> 	$result->getbokparty_size(),
							'Address'	 		=> 	$resDetails->getRestaddress(),
							'resphone' 			=> 	$resDetails->getRestphone(),
							'resemail'			=>	$resDetails->getRestemail(),
							'phone'				=>	$result->getbokphone(),
							'rescity'			=>	$resDetails->getRestCityDesc(),
							'resnbh'			=>	$resDetails->getRestNeighborDesc(),
							'reszipcode'		=>	$resDetails->getRestzipcode(),
							'Status'	 		=> 	true,
							'Bokid'	 			=>	$result->getbokid(),
							'State_Id' 			=>	$stateId,
							'City_Id'	 		=>	$cityId,
							'UserType' 			=>	$userType,
							'DiscountMsg' 		=>  $discountMsg,
							'Note'				=>  $result->getbokrestaurant_note(),
							'BookNotf'			=>	false,
				
					);
					if($resLoc->res_companyid == 6){
						$data['rmnotf'] = 'true';
						$cuisine = $resDetails->getResttypeid();
						$data['cuisine']  = $cuisine[0]->getRestCuisineDesc();
					}else{
						$data['rmnotf'] = 'false';
					}
					if(count($campDetails)){
						$count = count($campDetails);
						if($count > 1){
							$campaign = $campDetails[rand(0,$count-1)];
						}else{
							$campaign = $campDetails[0];
						}
						$notfService = new Application_Service_Communication();
						$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
						$data['campaignName'] = trim($campaign->getSponsor());
						$data['campaignDesc'] =	trim($campaign->getCampDesc());
						$data['campaignImg'] =	trim($campaign->getCampImage());
						$data['campId']	= $campaign->getId();
					}
					if($mailObj->getMsgCode() == 'ReSchedule'){
						$data['splstatus']	= false;
					}
				
					$mailObj->setData($data);
					$mailStatus = $mailmapper->SendMail($mailObj);
				}else if($result->getbokphone()){
					$smsObj = new Communication_Model_Sms();
					if(isset($reschStatus) && $reschStatus == 'RES'){				
						$smsObj->setMsgCode('ReSchedule');
					}else{
						$smsObj->setMsgCode('BookConf');
					}
				
					$data = array(
							'to'				=>	trim($result->getbokphone()),
							'countrycode'		=> 	$result->getbokcountry_code(),
							'bokid'				=> 	$result->getbokid(),
							'RestName' 			=> 	$resDetails->getRestaurantname(),
							'ResDate'  			=> 	date('m-d-Y',strtotime($result->getbokbooking_date())),
							'Time'     			=> 	$result->getbokbooking_timings(),
							'Size'     			=>	$result->getbokparty_size(),
							'CustomerName' 		=> 	$result->getbokfirst_name().' '.$result->getboklast_name(),
							'RestCountryCode'	=> 	$resDetails->getres_country_code()
					);
					$smsObj->setData($data);
					$mailStatus = $mailmapper->SendSms($smsObj);
					if($rowSet['msg']){
						$data['discountMsg'] = $rowSet['msg'];
						$smsObj->setMsgCode('DiscountNotf');
						$smsObj->setData($data);
						$mailStatus = $mailmapper->SendSms($smsObj);
					}
				}
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function MakeReservationMobile(array $data)
	{
		try{
			$form = $this->getMakeResevMobileForm();
			if($form->isValid($data)){
				$formData = $form->getValues();
				$bookTypeMapper = new Application_Model_ReservationTypeDataMapper();
				$bookType = $bookTypeMapper->GetBookingTypeByCode('NOR');

				$statusCode = array();

				if($data['bookingStatus'] && $data['rescheduleStatus']){
					$statusCode[] = $data['bookingStatus'];
					$statusCode[] = $data['rescheduleStatus'];
				}else if($data['bookingStatus']){
					$statusCode[] = $data['bookingStatus'];
				}

				$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
				$bookStatus 	  = $bookStatusMapper->GetBookingStatusByCode($statusCode);
				$bookStatusObj 	  = $bookStatus[$data['bookingStatus']];
				$resStatusObj = null;
				if(isset($bookStatus[$data['rescheduleStatus']])){
					$resStatusObj = $bookStatus[$data['rescheduleStatus']];
				}
				

				$resModeMapper = new Application_Model_ReservationModeDataMapper();
				$rescode = $formData['origin'];
				$resModeStatus 	  = $resModeMapper->GetReservationModeByCode(array($rescode));
				$resModeObj 	  = $resModeStatus[$rescode];

				$mapper = new Reservation_Model_ReservationDataMapper();
				$dinerDetails = new Reservation_Model_Reservation();

				$dinerDetails->setbokfk_restaurant($formData['restaurantid']);
				$dinerDetails->setbokbooking_date($formData['resDate']);
				if($data['bookingStatus'] == 'RSD'){
					$dinerDetails->setbokbooking_timings($formData['seltime']);
				}else if($data['bookingStatus'] == 'OVB'){
					$dinerDetails->setbokbooking_timings($formData['resTime']);
				}

				if($data['bookingStatus'] && $data['rescheduleStatus']){
					$dinerDetails->setbokbooking_status_id($bookStatusObj->getId());
					$dinerDetails->setbokbooking_status_code($bookStatusObj->getCode());
					$dinerDetails->setbokbooking_status($bookStatusObj->getId());
				}else{
					$dinerDetails->setbokbooking_status_id($bookStatusObj->getId());
					$dinerDetails->setbokbooking_status_code($bookStatusObj->getCode());
					$dinerDetails->setbokbooking_status($bookStatusObj->getId());
				}
				$dinerDetails->setbokparty_size($formData['pax']);
				$dinerDetails->setbokfirst_name($formData['firstName']);
				$dinerDetails->setboklast_name($formData['lastName']);
				$dinerDetails->setbokphone($formData['number']);
				$dinerDetails->setbokemail($formData['email']);
				$dinerDetails->setbokcountry_code($formData['countryCode']);
				$dinerDetails->setbokrestaurant_note($formData['dinerRequest']);

				$resServ = new Application_Service_Firm();
				$timeZone = $resServ->GetRestaurantTimeZone($formData['restaurantid']);
				date_default_timezone_set($timeZone);

				$dinerDetails->setbokbooking_made_on(date('Y-m-d H:i:s'));
				$dinerDetails->setBookingMadeTime(date("H:i",time()));
				$userid = "";
				
				$bookPhrase = uniqid ();
				$dinerDetails->setbokbookingphrase($bookPhrase);

				$dinerDetails->setbokuserid($userid);
				$dinerDetails->setbokspecial_request($formData['contactInfo']);
				$dinerDetails->setbokbooking_type_id($bookType->getId());
				$dinerDetails->setbokreservation_mode_id($resModeObj->getId());
				$dinerDetails->setTableSize($formData['tableSize']);
				$dinerDetails->setNoOfTables($formData['noOfTables']);
				$dinerDetails->setInventoryId($formData['inventoryid']);
				$dinerDetails->setNotificationType($formData['notificationType']);
				$dinerDetails->setbokid($formData['bookingid']);
				if($formData['bokoptions']){
					$dinerDetails->setbokoptions($formData['bokoptions']);
				}
				
				$resDataMapper = new FirmManagement_Model_FirmDataMapper();
				$seetingArr = $resDataMapper->getScheduleSettingTypeByresId($formData['restaurantid']);
				$dinerDetails->setbok_restsch_setting_id($seetingArr['settingId']);
				$dinerDetails->setbok_restsch_setting_type($seetingArr['settingType']);
				
				if($formData['rescheduleStatus']){
					$dinerDetails->setRescheduleCode($formData['rescheduleStatus']);
				}
				if($resStatusObj){
					$dinerDetails->setRessch_Status_Id($resStatusObj->getId());
				}
				
				$result = $mapper->saveMakeReservationDetails($dinerDetails,'reserv',$formData);

				$dinerDetails->setbokid($result);
				$mailmapper = new Application_Service_Communication();
				$restService = new Application_Service_Firm();
				$restResult = $restService->GetRestaurantDetailsById($formData['restaurantid']);
				$resDataMapper = new FirmManagement_Model_FirmDataMapper();
				$restObj= new FirmManagement_Model_FirmById();
				$restObj->setRestaurantId($formData['restaurantid']);
				$resDetails = $resDataMapper->getRestaurantById($restObj);
				$rowSet = $resDataMapper->Getdiscountstatus($formData['restaurantid']);
				$mailObj = new Communication_Model_Mail();
				if($formData['email']){
					if(isset($data['rescheduleStatus']) && $data['rescheduleStatus']== 'RES'){
						$mailObj->setMsgCode('ReSchedule');
					}else{
						$mailObj->setMsgCode('BookConf');
					}
					if($stateId == ""){
						$stateCity = $this->getRestaurantStateByResId($formData['restaurantid']);
						$stateId = $stateCity['state'];
						$cityId = $stateCity['city'];
						$regionId = $stateCity['region'];
					}
					$userType = 'CUS';
					$adminService = new Application_Service_Administrator();
					$campProp = new Application_Model_GetCampaignForPost();
					$campProp->setAudType($userType)
					->setStateId($stateId)
					->setCityId($cityId)
					->setRegionId($regionId)
					->setIsAjaxCall(false);
					$campDetails = array();
					if(!$resDetails->getrescampaignstatus() === false){
						$campDetails = $adminService->GetCampaignDetails($campProp);
					}
					$discountMsg = false;
					if($rowSet['msg']){
						$discountMsg = $rowSet['msg'];
					}
					
					$name = $formData['firstName'].' '.$formData['lastName'];
					$data = array('UserName' => $name,
							  'SenTo'    => $formData['email'],
							  'RestName' => $restResult->resrestaurant_name,
							  'ResDate'  => date('m-d-Y',strtotime($formData['resDate'])),
					//		  'Time'     => $boktime,
							  'Time'     => $formData['resTime'],
							  'Size'     => $formData['pax'],
							  'Address'	 => $restResult->resaddress,
							  'resphone' => 	$resDetails->getRestphone(),
							  'resemail' =>	$resDetails->getRestemail(),
							  'phone'	 =>	$formData['number'],
						  	  'rescity'	 =>	$resDetails->getRestCityDesc(),
							  'resnbh'	 =>	$resDetails->getRestNeighborDesc(),
							  'reszipcode'	=>	$resDetails->getRestzipcode(),
							  'Status'	 	=>  $result['bokstatus'], 
							  'Bokid'	 	=>	$result,
							  'State_Id' 	=>	$stateId,
							  'City_Id'	 	=>	$cityId,
							  'UserType' 	=>	$userType,
							  'Note'		=>	$formData['dinerRequest'],
							  'DiscountMsg'	=>	$discountMsg,
							  'BookNotf'	=>	false,
					);
					if(count($campDetails)){
						$count = count($campDetails);
						if($count > 1){
							$campaign = $campDetails[rand(0,$count-1)];
						}else{
							$campaign = $campDetails[0];
						}
						$notfService = new Application_Service_Communication();
						$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
						$data['campaignName'] = trim($campaign->getSponsor());
						$data['campaignDesc'] =	trim($campaign->getCampDesc());
						$data['campaignImg'] =	trim($campaign->getCampImage());
						$data['campId']	= $campaign->getId();
					}
					if($mailObj->getMsgCode() == 'ReSchedule'){
						$data['splstatus']	= false;
					}
					
					$mailObj->setData($data);
					$mailStatus = $mailmapper->SendMail($mailObj);
				}else if($formData['number']){
					$smsObj = new Communication_Model_Sms();
					if(isset($data['rescheduleStatus']) && $data['rescheduleStatus']== 'RES'){

						$smsObj->setMsgCode('ReSchedule');
					}else{
						$smsObj->setMsgCode('BookConf');
					}

					$data = array(
					 'to'			=>	trim($formData['number']),
					 'countrycode'	=> $formData['countryCode'],
					 'bokid'		=> $result,
					 'RestName' 	=> $restResult->resrestaurant_name,
					 'ResDate'  	=> date('d M Y',strtotime($formData['resDate'])),
					 'Time'     	=> $formData['resTime'],
				//	 'Time'     	=> $boktime,
					 'Size'     	=> $formData['pax'],
					 'CustomerName' => $formData['firstName'].' '.$formData['lastName'],
					 'RestCountryCode'	=> $restResult->res_countrycode,
					//'Address'	 => $restResult->resaddress,
					);
					$smsObj->setData($data);
					$mailStatus = $mailmapper->SendSms($smsObj);
					if($rowSet['msg']){
						$data['discountMsg'] = $rowSet['msg'];
						$smsObj->setMsgCode('DiscountNotf');
						$smsObj->setData($data);
						$mailStatus = $mailmapper->SendSms($smsObj);
					}
				}
				if($result){
					$resultarray['status']= true;
				}
				return $resultarray;
			}else{
				$resultarray['status'] = false;
				$form->populate($data);
				$resultarray['form'] = $form;
				return $resultarray;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function MakeWalkinReservation($request, $userid,$resSource = '')
	{
		try{
			$bookTypeMapper = new Application_Model_ReservationTypeDataMapper();
			$bookType = $bookTypeMapper->GetBookingTypeByCode('NOR');
			if($request->wintableno){
				$statusCode = array('BOK','WIN');
				$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
				$bookStatus 	  = $bookStatusMapper->GetBookingStatusByCode($statusCode);
				$bookStatusObj 	  = $bookStatus['BOK'];
				$bookwaikinobj 	  = $bookStatus['WIN'];
			}else{
				$statusCode = array('RSD','WIN');
				$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
				$bookStatus 	  = $bookStatusMapper->GetBookingStatusByCode($statusCode);
				$bookStatusObj 	  = $bookStatus['RSD'];
				$bookwaikinobj 	  = $bookStatus['WIN'];
			}
			$mapper = new Reservation_Model_ReservationDataMapper();
			$dinerDetails = new Reservation_Model_Reservation();
			
			$resServ = new Application_Service_Firm();
			$timeZone = $resServ->GetRestaurantTimeZone($request->restaurantid);
			date_default_timezone_set($timeZone);

			$seatStart = date('Y-m-d H:i:s');
			
			$bookPhrase = uniqid ();
			$dinerDetails->setbokbookingphrase($bookPhrase);
			
			$dinerDetails->setbokseat_start($seatStart);
			$dinerDetails->setbokfk_restaurant($request->restaurantid);
			$dinerDetails->setbokbooking_date($request->winDate);
			
			$disMin = '';
			$selectedTimeStr = $request->winTime;
			$hour = '';
			$minute ='';
			$meridian ='';
			if(isset($selectedTimeStr))
			{
				$selectedTime = strtotime($selectedTimeStr);
				$hour = date("h",$selectedTime);
				$minute = date("i",$selectedTime);
				$disMin = $minute;
				$meridian = date("A",$selectedTime);
			}
			else
			{
				$hour = date("h");
				$minute = date("i");
				$meridian = date("A");
				if($minute < 8){
				$disMin = '00';
				}else if($minute >= 8 && $minute <= 23){
					$disMin = '15';
				}else if($minute >= 24 && $minute <= 38){
					$disMin = '30';
				}else if($minute >= 39 && $minute <= 53){
					$disMin = '45';	
				}else if($minute >= 54 && $minute <= 59){
					$disMin = '00';
				if($meridian == 'AM' && $hour == 11){
					$hour = 12;
					$meridian = 'PM';				
				}else if($meridian == 'PM' && $hour == 11){
					$hour = '00';
					$meridian = 'AM';
				}else{
					$hour = (int)($hour)+1;
				}
				}
			}
			$dinerDetails->setbokbooking_timings($hour.':'.$disMin.' '.$meridian);
			$dinerDetails->setbokparty_size($request->winpax);
			$dinerDetails->setbokbooking_status_id($bookStatusObj->getId());
			$dinerDetails->setbokbooking_status_code($bookStatusObj->getCode());
			$dinerDetails->setbokbooking_status($bookwaikinobj->getId());
			if($request->winfirstName == '' && $request->winlastName == ''){				
				$dinerDetails->setbokfirst_name('Walk');
				$dinerDetails->setboklast_name('In');
			}else{
				$dinerDetails->setbokfirst_name($request->winfirstName);
				$dinerDetails->setboklast_name($request->winlastName);
			}
			
			$dinerDetails->setbokbooking_made_on(date('Y-m-d H:i:s'));
			$dinerDetails->setBookingMadeTime(date("H:i",time()));
			$dinerDetails->setbokuserid($userid);
			$dinerDetails->setbokbooking_type_id($bookType->getId());
			$dinerDetails->setbokspecial_request($request->windinerRequest);
			//$dinerDetails->setbokspecial_request($request->wincontactInfo);
			$dinerDetails->setbokphone($request->winnumber);
			$dinerDetails->setbokcountry_code($request->countryCode);
			$dinerDetails->setbokemail($request->winemail);
			if($request->winemail != '' || $request->winnumber != ''){
				$dinerDetails->setNotificationType($request->winnotificationType);
			}	

			$resModeMapper = new Application_Model_ReservationModeDataMapper();
			$resModeStatus 	  = $resModeMapper->GetReservationModeByCode(array('WIN'));
			$resModeObj 	  = $resModeStatus['WIN'];
			$dinerDetails->setbokreservation_mode_id($resModeObj->getId());

			$dinerDetails->setTableSize($request->winpax);
			$result = $mapper->saveMakeReservationDetails($dinerDetails,'walkin',$request);

			$status = $mapper->savebookingtabledata($request, $result);

			if($result){
				if($request->winfirstName != '' && $request->winlastName != ''){
					if($request->winemail != '' || $request->winnumber != ''){
						$restservice = new Application_Service_Firm();
						$restservice->AddWalkinCustomerContact($request);
					}
				}				
			}
			$mailmapper = new Application_Service_Communication();
			$restService = new Application_Service_Firm();
			$restResult = $restService->GetRestaurantDetailsById($request->restaurantid);
			$resDataMapper = new FirmManagement_Model_FirmDataMapper();
			$restObj= new FirmManagement_Model_FirmById();
			$restObj->setRestaurantId($request->restaurantid);
			$resDetails = $resDataMapper->getRestaurantById($restObj);
			$mailObj = new Communication_Model_Mail();
			if($request->winfirstName && $request->winlastName && $resSource != 'web'){
				if($request->winemail){
					$stateId = '';
					$mailObj->setMsgCode('BookConf');
					if($stateId == ""){
						$stateCity = $this->getRestaurantStateByResId($request->restaurantid);
						$stateId = $stateCity['state'];
						$cityId = $stateCity['city'];
						$regionId = $stateCity['region'];
					}
					$userType = 'CUS';
					$adminService = new Application_Service_Administrator();
					$campProp = new Application_Model_GetCampaignForPost();
					$campProp->setAudType($userType)
					->setStateId($stateId)
					->setCityId($cityId)
					->setRegionId($regionId)
					->setIsAjaxCall(false);
					$campDetails = array();
					if(!$resDetails->getrescampaignstatus() === false){
						$campDetails = $adminService->GetCampaignDetails($campProp);
					}
	
					$name = $request->winfirstName.' '.$request->winlastName;
					$data = array('UserName' => $name,
							  'SenTo'    => $request->winemail,
							  'phone'    =>	$request->winnumber,
							  'RestName' => $restResult->resrestaurant_name,
							  'ResDate'  => $request->winDate,
							  'Time'     => $hour.':'.$disMin.' '.$meridian,
							  //'Time'     => $formData['resTime'],
							  'Size'     => $request->winpax,
							  'Address'	 => $restResult->resaddress,
							  'resphone' 			=> 	$resDetails->getRestphone(),
							  'resemail'			=>	$resDetails->getRestemail(),
							  'rescity'				=>	$resDetails->getRestCityDesc(),
							  'resnbh'				=>	$resDetails->getRestNeighborDesc(),
							  'reszipcode'			=>	$resDetails->getRestzipcode(),
							  'Bokid'	 =>	$result,
							  'State_Id' =>	$stateId,
							  'City_Id'	 =>	$cityId,
							  'UserType' =>	$userType,
							  'Note' 	 =>	$request->windinerRequest,
							  'BookNotf' => false,
					);
					if(count($campDetails)){
						$count = count($campDetails);
						if($count > 1){
							$campaign = $campDetails[rand(0,$count-1)];
						}else{
							$campaign = $campDetails[0];
						}
						$notfService = new Application_Service_Communication();
						$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
						$data['campaignName'] = trim($campaign->getSponsor());
						$data['campaignDesc'] =	trim($campaign->getCampDesc());
						$data['campaignImg'] =	trim($campaign->getCampImage());
						$data['campId']	= $campaign->getId();
					}
					if($mailObj->getMsgCode() == 'ReSchedule'){
						$data['splstatus']	= false;
					}
					
					$mailObj->setData($data);
					$mailStatus = $mailmapper->SendMail($mailObj);
				}else if($request->winnumber){
					$smsObj = new Communication_Model_Sms();
					if(isset($data['rescheduleStatus']) && $data['rescheduleStatus']== 'RES'){
	
						$smsObj->setMsgCode('ReSchedule');
					}else{
						$smsObj->setMsgCode('BookConf');
					}
	
					$data = array(
					 'to'			=>	trim($request->winnumber),
					 'countrycode'	=> $request->countryCode,
					 'bokid'		=> $result,
					 'RestName' 	=> $restResult->resrestaurant_name,
					 'ResDate'  	=> $request->winDate,
					 'Time'     	=> $hour.':'.$disMin.' '.$meridian,
					 'Size'     	=> $request->winpax,
					 'CustomerName' => $request->winfirstName.' '.$request->winlastName
					//'Address'	 => $restResult->resaddress,
					);
					$smsObj->setData($data);
					$mailStatus = $mailmapper->SendSms($smsObj);
				}
			}
			return array('result'=>$dinerDetails->getbokbookingphrase(),'booking'=>$result); 
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function sendWalkinNotification($request)
	{
		try{
			$mailmapper = new Application_Service_Communication();
			$restService = new Application_Service_Firm();
			$notStatus = $this->CheckReservationNotificationStatusByBokPhraseId($request->bokid);
			$result = $this->GetBookingDetailsByPhraseId($request->bokid);
			$resultSet = array();
			if(!$notStatus){
				$resDataMapper = new FirmManagement_Model_FirmDataMapper();
				$restObj= new FirmManagement_Model_FirmById();
				$restObj->setRestaurantId($result->getbokfk_restaurant());
				$resDetails = $resDataMapper->getRestaurantById($restObj);
				$stateId = '';
				$mailObj = new Communication_Model_Mail();
				if($result->getbokfirst_name() && $result->getboklast_name()){
					if($result->getbokemail()){
						$mailObj->setMsgCode('BookConf');
						if($stateId == ""){
							$stateCity = $this->getRestaurantStateByResId($result->getbokfk_restaurant());
							$stateId = $stateCity['state'];
							$cityId = $stateCity['city'];
							$regionId = $stateCity['region'];
						}
						$userType = 'CUS';
						$adminService = new Application_Service_Administrator();
						$campProp = new Application_Model_GetCampaignForPost();
						$campProp->setAudType($userType)
								->setStateId($stateId)
								->setCityId($cityId)
								->setRegionId($regionId)
								->setIsAjaxCall(false);
						$campDetails = array();
						if(!$resDetails->getrescampaignstatus() === false){
							$campDetails = $adminService->GetCampaignDetails($campProp);
						}
				
						$name = $result->getbokfirst_name().' '.$result->getboklast_name();
						$data = array(	'UserName' 		=> 	$name,
										'SenTo'    		=> 	$result->getbokemail(),
										'phone'    		=>	$result->getbokphone(),
										'RestName' 		=> 	$resDetails->getRestaurantname(),
										'ResDate'  		=> 	$result->getbokbooking_date(),
										'Time'     		=> 	$result->getbokbooking_timings(),
										'Size'     		=> 	$result->getbokparty_size(),
										'Address'	 	=> 	$resDetails->getRestaddress(),
										'resphone' 		=> 	$resDetails->getRestphone(),
										'resemail'		=>	$resDetails->getRestemail(),
										'rescity'		=>	$resDetails->getRestCityDesc(),
										'resnbh'		=>	$resDetails->getRestNeighborDesc(),
										'reszipcode'	=>	$resDetails->getRestzipcode(),
										'Bokid'	 		=>	$result->getbokid(),
										'State_Id' 		=>	$stateId,
										'City_Id'	 	=>	$cityId,
										'UserType' 		=>	$userType,
										'Note' 	 		=>	$result->getbokrestaurant_note(),
										'BookNotf' 		=> false,
						);
						if(count($campDetails)){
							$count = count($campDetails);
							if($count > 1){
								$campaign = $campDetails[rand(0,$count-1)];
							}else{
								$campaign = $campDetails[0];
							}
							$notfService = new Application_Service_Communication();
							$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
							$data['campaignName'] = trim($campaign->getSponsor());
							$data['campaignDesc'] =	trim($campaign->getCampDesc());
							$data['campaignImg'] =	trim($campaign->getCampImage());
							$data['campId']	= $campaign->getId();
						}
						if($mailObj->getMsgCode() == 'ReSchedule'){
							$data['splstatus']	= false;
						}
							
						$mailObj->setData($data);
						$mailStatus = $mailmapper->SendMail($mailObj);
					}else if($request->winnumber){
						$smsObj = new Communication_Model_Sms();
						if(isset($data['rescheduleStatus']) && $data['rescheduleStatus']== 'RES'){
							$smsObj->setMsgCode('ReSchedule');
						}else{
							$smsObj->setMsgCode('BookConf');
						}
				
						$data = array(
								'to'			=>	trim($result->getbokphone()),
								'countrycode'	=> 	$resDetails->getres_country_code(),
								'bokid'			=> 	$result->getbokid(),
								'RestName' 		=> 	$resDetails->getRestaurantname(),
								'ResDate'  		=> 	$result->getbokbooking_date(),
								'Time'     		=> 	$result->getbokbooking_timings(),
								'Size'     		=> 	$result->getbokparty_size(),
								'CustomerName' 	=> 	$result->getbokfirst_name().' '.$result->getboklast_name()
						);
						$smsObj->setData($data);
						$mailStatus = $mailmapper->SendSms($smsObj);
					}
				}
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param array,userid,state,cityid
	 * function to save the reservation details taken by the restaurant authorities
	 */
	public function MakeWaitingReservation(array $data,$userid,$stateId,$cityId,$regionId)
	{
		try{
			$form = $this->getWaitingReservForm();
			if($form->isValid($data)){
				$formData = $form->getValues();
				/*$firstname = "";
				 $lastname = "";

				 $name = explode(' ', $formData['firstName'], 2);
				 if(count($name) > 1){

					$firstname = $name[0];
					$lastname = $name[1];
					}else{
					$firstname = $name[0];
					}*/

				$bookTypeMapper = new Application_Model_ReservationTypeDataMapper();
				$bookType = $bookTypeMapper->GetBookingTypeByCode('NOR');

				$statusCode = array();
				if($data['waitbookingStatus'] && $data['waitrescheduleStatus']){
					$statusCode[] = $data['waitbookingStatus'];
					$statusCode[] = $data['waitrescheduleStatus'];
				}else{
					$statusCode[] = $data['waitbookingStatus'];
				}
				$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
				$bookStatus 	  = $bookStatusMapper->GetBookingStatusByCode($statusCode);
				$bookStatusObj 	  = $bookStatus[$data['waitbookingStatus']];
				$resStatusObj = null;
				if(isset($bookStatus[$data['waitrescheduleStatus']])){
					$resStatusObj = $bookStatus[$data['waitrescheduleStatus']];
				}

				$resModeMapper = new Application_Model_ReservationModeDataMapper();
				$rescode = $formData['waitorigin'];
				$resModeStatus 	  = $resModeMapper->GetReservationModeByCode(array($rescode));
				$resModeObj 	  = $resModeStatus[$rescode];

				$waitingquoteMapper = new Application_Model_WaitingQuoteTimeDataMapper();
				$quotecode = $formData['quotedTime'];
				$quoteStatus 	  = $waitingquoteMapper->GetQuoteTimeByCode(array($quotecode));
				$quoteObj 	  = $quoteStatus[$quotecode];

				$mapper = new Reservation_Model_ReservationDataMapper();
				$dinerDetails = new Reservation_Model_Reservation();

				$dinerDetails->setbokfk_restaurant($formData['restaurantid']);
					
				$dinerDetails->setbokparty_size($formData['waitpax']);
				$dinerDetails->setbokbooking_status_id($bookStatusObj->getId());
				$dinerDetails->setbokbooking_status_code($bookStatusObj->getCode());
				$dinerDetails->setbokbooking_status($bookStatusObj->getId());
				$dinerDetails->setbokfirst_name($formData['waitfirstName']);
				$dinerDetails->setboklast_name($formData['waitlastName']);
				$dinerDetails->setbokphone($formData['waitnumber']);
				$dinerDetails->setbokcountry_code($formData['countryCode']);
				if($formData['waitnumber']){
					$dinerDetails->setNotificationType('sms');
				}
				//$dinerDetails->setbokemail($formData['waitemail']);
				//$dinerDetails->setbokemail('');
				$dinerDetails->setbokspecial_request($formData['waitdinerRequest']);
				$dinerDetails->setQuotedTime($quoteObj->getId());

				$resServ = new Application_Service_Firm();
				$timeZone = $resServ->GetRestaurantTimeZone($formData['restaurantid']);
				date_default_timezone_set($timeZone);

				$dinerDetails->setbokbooking_made_on(date('Y-m-d H:i:s'));
				$dinerDetails->setBookingMadeTime(date("H:i",time()));
				$dinerDetails->setbokbooking_date($formData['waitresDate']);
				$dinerDetails->setbokbooking_timings(date('g:i A'));
				//$dinerDetails->setbokbooking_timings($formData['waitresTime']);
				$bookPhrase = uniqid ();
				$dinerDetails->setbokbookingphrase($bookPhrase);
			
				$dinerDetails->setbokuserid($userid);
				//$dinerDetails->setbokspecial_request($formData['waitcontactInfo']);
				$dinerDetails->setbokbooking_type_id($bookType->getId());
				$dinerDetails->setbokreservation_mode_id($resModeObj->getId());
				$dinerDetails->setTableSize($formData['waittableSize']);
				$dinerDetails->setNoOfTables($formData['waitnoOfTables']);
				$dinerDetails->setInventoryId($formData['waitinventoryid']);
				//$dinerDetails->setNotificationType($formData['waitnotificationType']);
				
				$dinerDetails->setbokid($formData['bookingid']);


				if($formData['waitrescheduleStatus']){
					$dinerDetails->setRescheduleCode($formData['waitrescheduleStatus']);

				}
				if($resStatusObj){
					$dinerDetails->setRessch_Status_Id($resStatusObj->getId());
				}
				$result = $mapper->saveMakeReservationDetails($dinerDetails,'waiting',$formData);

				$dinerDetails->setbokid($result);
				$mailmapper = new Application_Service_Communication();
				$restService = new Application_Service_Firm();
				$restResult = $restService->GetRestaurantDetailsById($formData['restaurantid']);

// 				if($formData['waitnumber'] != ""){
// 					$name = $formData['waitfirstName'].' '.$formData['waitlastName'];
// 					$custMsg = '';
// 					$custMsg = 'Hi '.$name.', we have put your reservation in waiting, please wait for '.$quoteObj->getDescription().'. '.$restResult->resrestaurant_name;
// 					$smsObj = new Communication_Model_Sms();
// 					$smsObj->setMsgCode('WaitingReserv');
// 					$data = array(
// 									'to'			=> trim($formData['waitnumber']),
// 									'countrycode'	=> $formData['countryCode'],
// 									'RestName' 		=> $restResult->resrestaurant_name,
// 									'UserName'		=> $name,
// 									'BookId'		=> $result
// 					);
// 					if($quoteObj->getCode() =='NS'){
// 						$data['Quote'] = '';
// 					}else{
// 						$data['Quote'] = $quoteObj->getDescription();
// 					}
// 					$smsObj->setData($data);
// 					$mailStatus = $mailmapper->SendSms($smsObj);
// 				}
				return array('bookid'=>$result,'result'=>$bookPhrase);
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function sendWaitingNotificationByBokId($request)
	{
		try{
			$mailmapper = new Application_Service_Communication();
			$notStatus = $this->CheckReservationNotificationStatusByBokPhraseId($request->bokid);
			$result = $this->GetBookingDetailsByPhraseId($request->bokid);
			$waitList = new Reservation_Model_GetWaitingList();
			$waitList->setDate($result->getbokbooking_date())
					->setRestaurantId($result->getbokfk_restaurant())
					->setBookingId($result->getbokid());
			$bookStatus = array('WAL','READY','QUOTE','BAR','NEXT','CANCUS','BACK');
			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
			$waitList->setBookStatus($bookStatusRes);
			$mapper = new Reservation_Model_ReservationDataMapper();
			$waitResult = $mapper->getWaitingList($waitList);
			$restService = new Application_Service_Firm();
			$resDataMapper = new FirmManagement_Model_FirmDataMapper();
			$restObj= new FirmManagement_Model_FirmById();
			$restObj->setRestaurantId($result->getbokfk_restaurant());
			$resDetails = $resDataMapper->getRestaurantById($restObj);
			$restResult = $restService->GetRestaurantDetailsById($result->getbokfk_restaurant());
			$stateId = '';
			if(!$notStatus){		
			
				if($result->getbokphone() != ""){
					$name = $result->getbokfirst_name().' '.$result->getboklast_name();
					$custMsg = '';
					$waitResult = $waitResult[0];
					$custMsg = 'Hi '.$name.', we have put your reservation in waiting, please wait for '.$waitResult->getQuotedTime().'. '.$resDetails->getRestaurantname();
					$smsObj = new Communication_Model_Sms();
					$smsObj->setMsgCode('WaitingReserv');
					$data = array(
							'to'			=> trim($result->getbokphone()),
							'countrycode'	=> $result->getbokcountry_code(),
							'RestName' 		=> $result->getresrestaurant_name(),
							'UserName'		=> $name,
							'BookId'		=> $result->getbokid()
					);
					if($waitResult->getQuotedTime() =='"Not Sure"'){
						$data['Quote'] = '';
					}else{
						$data['Quote'] = $waitResult->getQuotedTime();
					}
					$smsObj->setData($data);
					$mailStatus = $mailmapper->SendSms($smsObj);
				}
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param request,userid
	 * function to save the reservation details taken by the restaurant authorities from listview
	 */
	public function MakeReservationAjax($request,$userid)
	{
		try{
			$form = $this->getMakeReservationForm();
			$formData = $form->getValues();

			/*$firstname = "";
				$lastname = "";
				$name = explode(' ', $request->firstName, 2);
				if(count($name) > 1){
				$firstname = $name[0];
				$lastname = $name[1];
				}else{
				$firstname = $name[0];
				}*/
			$bookTypeMapper = new Application_Model_ReservationTypeDataMapper();
			$bookType = $bookTypeMapper->GetBookingTypeByCode('NOR');

			$statusCode = array();
			if($request->bookingStatus && $request->rescheduleStatus){
				$statusCode[] = $request->bookingStatus;
				$statusCode[] = $request->rescheduleStatus;
			}else{
				$statusCode[] = $request->bookingStatus;
			}
			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			$bookStatus 	  = $bookStatusMapper->GetBookingStatusByCode($statusCode);
			$bookStatusObj 	  = $bookStatus[$request->bookingStatus];
			$resStatusObj = null;
			if(isset($bookStatus[$request->rescheduleStatus])){
				$resStatusObj = $bookStatus[$request->rescheduleStatus];
			}

			$resModeMapper = new Application_Model_ReservationModeDataMapper();
			$rescode = $request->origin;
			$resModeStatus 	  = $resModeMapper->GetReservationModeByCode(array($rescode));
			$resModeObj 	  = $resModeStatus[$rescode];

			$mapper = new Reservation_Model_ReservationDataMapper();
			$dinerDetails = new Reservation_Model_Reservation();

			$dinerDetails->setbokfk_restaurant($request->restaurantid);
			$dinerDetails->setbokbooking_date($request->resDate);
			$dinerDetails->setbokbooking_timings($request->resTime);
			$dinerDetails->setbokparty_size($request->pax);
			$dinerDetails->setbokbooking_status_id($bookStatusObj->getId());
			$dinerDetails->setbokbooking_status($bookStatusObj->getId());
			$dinerDetails->setbokbooking_status_code($bookStatusObj->getCode());
			$dinerDetails->setbokfirst_name($request->firstName);
			$dinerDetails->setboklast_name($request->lastName);
			$dinerDetails->setbokphone($request->number);
			$dinerDetails->setbokemail($request->email);
			$dinerDetails->setbokrestaurant_note($request->dinerRequest);
			$resServ = new Application_Service_Firm();
			$timeZone = $resServ->GetRestaurantTimeZone($request->restaurantid);
			date_default_timezone_set($timeZone);

			$dinerDetails->setbokbooking_made_on(date('Y-m-d H:i:s'));
			$dinerDetails->setBookingMadeTime(date("H:i",time()));

			$bookPhrase = uniqid ();
			$dinerDetails->setbokbookingphrase($bookPhrase);

			$dinerDetails->setbokuserid($userid);
			$dinerDetails->setbokspecial_request($request->contactInfo);
			$dinerDetails->setbokbooking_type_id($bookType->getId());
			$dinerDetails->setbokreservation_mode_id($resModeObj->getId());
			$dinerDetails->setTableSize($request->tableSize);
			$dinerDetails->setNoOfTables($request->noOfTables);
			$dinerDetails->setInventoryId($request->inventoryid);
			$dinerDetails->setNotificationType($request->notificationType);
			$dinerDetails->setbokid($request->bookingid);


			if($request->rescheduleStatus){
				$dinerDetails->setRescheduleCode($request->rescheduleStatus);

			}
			if($resStatusObj){
				$dinerDetails->setRessch_Status_Id($resStatusObj->getId());
			}
			$result = $mapper->saveMakeReservationDetails($dinerDetails,'reserv');

			$dinerDetails->setbokid($result);
			$mailmapper = new Application_Service_Communication();
			$restService = new Application_Service_Firm();
			$restResult = $restService->GetRestaurantDetailsById($request->restaurantid);
			if($request->notificationType == 'email'){
				$mailObj = new Communication_Model_Mail();
				//if($request->notificationType == 'email'){
				if(isset($request->rescheduleStatus) && $request->rescheduleStatus == 'RES'){
					$mailObj->setMsgCode('ReSchedule');
				}else{
					$mailObj->setMsgCode('BookConf');
				}
				if($stateId == ""){
					$stateCity = $this->getRestaurantStateByResId($request->restaurantid);
					$stateId = $stateCity['state'];
					$cityId = $stateCity['city'];
					$regionId = $stateCity['region'];

				}
				$userType = 'CUS';
				$adminService = new Application_Service_Administrator();
				$campProp = new Application_Model_GetCampaignForPost();
				$campProp->setAudType($userType)
				->setStateId($stateId)
				->setCityId($cityId)
				->setRegionId($regionId)
				->setIsAjaxCall(false);
				$campDetails = $adminService->GetCampaignDetails($campProp);

				$name = $request->firstName.' '.$request->lastName;
				$data = array('UserName' => $name,
							  'SenTo'    => $request->email,
							  'phone'	 =>	$request->number,
							  'RestName' => $restResult->resrestaurant_name,
							  'ResDate'  => $request->resDate,
							  'Time'     => $request->resTime,
							  'Size'     => $request->pax,
							  'Address'	 => $restResult->resaddress,
							  'Status'	 => $result['bokstatus'],
							  'Bokid'	 =>	$result,
							  'State_Id' =>	$stateId,
							  'City_Id'	 =>	$cityId,
							  'UserType' =>	$userType,
							  'Note'	 =>	$request->dinerRequest,
							  'BookNotf' => false,
				);
				if(count($campDetails)){
					$count = count($campDetails);
					if($count > 1){
						$campaign = $campDetails[rand(0,$count-1)];
					}else{
						$campaign = $campDetails[0];
					}
					$notfService = new Application_Service_Communication();
					$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
					$data['campaignName'] = trim($campaign->getSponsor());
					$data['campaignDesc'] =	trim($campaign->getCampDesc());
					$data['campaignImg'] =	trim($campaign->getCampImage());
					$data['campId']	= $campaign->getId();
				}


				$mailObj->setData($data);
				$mailStatus = $mailmapper->SendMail($mailObj);
			}else if($request->notificationType == 'sms'){
				 $smsObj = new Communication_Model_Sms();
					if(isset($data['rescheduleStatus']) && $data['rescheduleStatus']== 'RES'){
					$smsObj->setMsgCode('ReSchedule');
					}else{
					$smsObj->setMsgCode('BookConf');
					}
					$data = array(
					'to'			=>	trim($request->number),
					'countrycode'	=> $request->countryCode,
					'RestName' 		=> $restResult->resrestaurant_name,
					'ResDate' 	 	=> $request->resDate,
					'Time'     		=> $request->resTime,
					'Size'     		=> $request->pax,
					'CustomerName' => $request->firstName.' '.$request->lastName
					//'Address'	 => $restResult->resaddress,
					);
					$smsObj->setData($data);
					$mailStatus = $mailmapper->SendSms($smsObj);
			}

			return $result;

		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param request,reservationid,restaurantid
	 * function to save the reservation details for the staus block
	 */
	public function MakeBlockReservation($request,$bokid,$resid)
	{
		try{
			$form = $this->getBlockReservForm();

			$formData = $form->getValues();
			$statusCode = array('RSD','WIN');
			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			$bookStatus 	  = $bookStatusMapper->GetBookingStatusByCode($statusCode);
			$bookStatusObj 	  = $bookStatus['RSD'];
			$bookwaikinobj 	  = $bookStatus['WIN'];
			
			$resServ = new Application_Service_Firm();
			$timeZone = $resServ->GetRestaurantTimeZone($request->restaurantid);
			date_default_timezone_set($timeZone);
			//$statusid = $bookStatusObj->getId();
			$notType = "";
			$email = "";
			$phone = "";
			if($request->blknumber && $request->blkemail){
				$notType = 'email';
				$email = $request->blkemail;
				$phone = $request->blknumber;
				$countrycode = $request->countrycode;
			}else if($request->blknumber){
				$phone = $request->blknumber;
				$countrycode = $request->countrycode;
				$notType = 'sms';
			}else if($request->blkemail){
				$email = $request->blkemail;
				$notType = 'email';
			}
			
			$dinerDetails = new Reservation_Model_Reservation();
			$mapper = new Reservation_Model_ReservationDataMapper();
			/* get booking id with phraseid */
//			$phraseId = $mapper->GetBookingIdByBookPhrase($bokid);
			
			$dinerDetails->setbokid($bokid);
			$dinerDetails->setbokfk_restaurant($request->restaurantid);
			$dinerDetails->setbokparty_size($request->partySize);
			if($request->blkfirstName == '' && $request->blklastName == ''){				
				$dinerDetails->setbokfirst_name('Blocked');
				$dinerDetails->setboklast_name('Slot');
			}else{
				$dinerDetails->setbokfirst_name($request->blkfirstName);
				$dinerDetails->setboklast_name($request->blklastName);
			}
			$dinerDetails->setbokphone($phone);
			$dinerDetails->setbokemail($email);
			$dinerDetails->setbokcountry_code(trim($countrycode));
			$dinerDetails->setNotificationType($notType);
			$dinerDetails->setbokbooking_status_id($bookStatusObj->getId());
			$dinerDetails->setbokbooking_status($bookwaikinobj->getId());
			$dinerDetails->setbokbooking_made_on(date('Y-m-d H:i:s'));
			$dinerDetails->setBookingMadeTime(date("H:i",time()));
			
			$results = $mapper->saveBlockCustReservationDetails($dinerDetails,$request);
			
			return $results;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param request,offset
	 * function to retreive the report of the reservations
	 */
	public function ReservationReport($request,$offset)
	{
		try{
			$resvReportObj = new Reservation_Model_GetReservationReport();
			$results = array();
			if($request){
				$bookMapper = new Reservation_Model_ReservationDataMapper();
				if($request->reserveid){
					$resvReportObj->setReservationId($request->reserveid);
				}
				if($request->reportsorton){
					$resvReportObj->setReportSortOn($request->reportsorton);
				}
				if($request->reportsortorder){
					$resvReportObj->setReportSortOrder($request->reportsortorder);
				}

				if($request->bokdatetype){
					$resvReportObj->setBokDateType($request->bokdatetype);
				}

				if($request->bokstartdate && $request->bokenddate){
					$resvReportObj->setBookStartDate($request->bokstartdate);
					$resvReportObj->setBookEndDate($request->bokenddate);
				}else if($request->bokstartdate){
					$resvReportObj->setBookStartDate($request->bokstartdate);
				}
				
				if($request->bokstarttime && $request->bokendtime){
					$resvReportObj->setBookStartTime($request->bokstarttime);
					$resvReportObj->setBookEndTime($request->bokendtime);
				}else if($request->bokstarttime){
					$resvReportObj->setBookStartTime($request->bokstarttime);
				}
				
				if($request->restaurantid){
					$resvReportObj->setRestaurantId($request->restaurantid);
				}

				if($request->bookstatus){
					$bookingstatus = $request->bookstatus;
					$bokstsarr = array();
					foreach($bookingstatus as $types){
						$bokstsarr[] = $types;
					}
					if($bokstsarr){
						$resvReportObj->setBookStatus($bokstsarr);
					}
				}
				if($request->origin){
					$origin = $request->origin;
					$originsarr = array();
					foreach($origin as $types){
						$originsarr[] = $types;
					}
					if($originsarr){
						$resvReportObj->setOrigin($originsarr);
					}
				}
				
				if($request->downloadStatus!= ""){
					echo "Yes";
				}

				$bookStatus = array('ALC','DES','BOK','PTS','CRD','RSD','COM','NOS');
				$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
				$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

				$rowSet = $bookMapper->ReservationReport($resvReportObj,$offset,$bookStatusRes);
				$results['RowSet'] = $rowSet['data'];
				$results['Count']  = $rowSet['count'];

				/* Reteriving restaurant logo Start */

				$row = $bookMapper->GetRestaurantLogo($request->restaurantid);
				if($row){
					$results['RestLogo'] = $row->reslogo;
					$results['RestName'] = $row->resrestaurant_name;
				}

				/* Reteriving restaurant logo End */

				/* Create Report */
			//	$this->CreateReport($rowSet['data'],$request,$row);
				return $results;

			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * function to retreive the booking status base data
	 */
	public function getBookingStatusBd()
	{
		try{
			$mapper = new Application_Model_ReservationStatusDataMapper();
			$rowSet = $mapper->fetchAll();
			$bookStatusBd = array();

			foreach($rowSet as $row){
				$bookStatusBd[] = array('key'=>$row->getCode(),'value'=>$row->getdescription());
			}
			return $bookStatusBd;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param request
	 * function to add the reservation note
	 */
	public function AddReservationNote($request)
	{
		try{
			$resNoteObj = new Reservation_Model_AddReservationNote();
			$resNoteObj->setBookingId($request->bookingid);
			$resNoteObj->setResId($request->restaurantid);
			$resNoteObj->setNote($request->resnote);
			$resNoteObj->setguestNote($request->guestnote);

			$mapper = new Reservation_Model_ReservationDataMapper();
			$result = $mapper->AddReservationNote($resNoteObj);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param request,userid
	 * function to freeze the slots to avoid the reservation of the slot
	 */
	public function FreezeReservation($request,$userid)
	{
		try{
			if($request && $userid){
				$restid = $request->restaurantid;
				$freeze = new Reservation_Model_RestaurantFreeze();
				$freeze->setfrzfk_restaurant($restid);
				$date = $request->date;
				if($request->status == 'freeze'){
					$freeze->setfrzstatus('TRUE');
				}
				$freeze->setfrzselAllStatus($request->selAllStatus);
				$freeze->setfrzfreezeddate($request->selectedDate);
				$freeze->setfrztype($request->selectedStatus);
				$freeze->setfrzdesc($request->freezedesc);
				$frzTime = new Reservation_Model_RestaurantFreezeTimeMap();
				$frzTime->setfrzfk_restaurant($restid);
				$frzTime->setfrzfreezedtime($request->selectedTimes);
				$frzTime->setfrzstatus(true);
				$freeze->setfrzfreezeddby($userid);
				$mapper = new Reservation_Model_RestaurantFreezeDataMapper();
				$status = $mapper->FreezeReservation($freeze,$frzTime);
				return $status;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function manageFreezeDescription($request)
	{
		try{
			$desc = new Reservation_Model_RestaurantFreezeDescMap();
			$desc->setfrzfk_restaurant($request->restaurantid);
			$desc->setDesc($request->frzdesc);
						
			$mapper = new Reservation_Model_RestaurantFreezeDescMapDataMapper();
			$result = $mapper->ManageFreezeDesc($desc);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getFreezeTypeByDate($request)
	{
		try{
			$restid = $request->restid;
			
			$frzDate = explode("-",$request->date);	
			$s = mktime(0,0,0,$frzDate[0],$frzDate[1],$frzDate[2]);
			$date = date('Y-m-d',$s);
			
			$mapper = new Reservation_Model_RestaurantFreezeDataMapper();
			$result = $mapper->getFreezeTypeByDate($restid,$date);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getFreezeDesc($request)
	{
		try{
			$restid = $request->restid;
						
			$mapper = new Reservation_Model_RestaurantFreezeDescMapDataMapper();
			$result = $mapper->getFreezeDesc($restid);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function getFreezeTypeByDateAndResId($restid,$frzdate)
	{
		try{
			$frzDate = explode("-",$frzdate);	
			$s = mktime(0,0,0,$frzDate[0],$frzDate[1],$frzDate[2]);
			$date = date('Y-m-d',$s);
			
			$mapper = new Reservation_Model_RestaurantFreezeDataMapper();
			$result = $mapper->getFreezeTypeByDate($restid,$date);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * @param request
	 * function to make the slot available for the reservations
	 */
	public function UnFreezeReservation($request)
	{
		try{
			if($request){
				$freezedateset = $request->unfreezedateset;
				$restid = $request->restaurantid;
				$date = $request->date;
				$result = array();
				$mapper = new Reservation_Model_RestaurantFreezeDataMapper();
				$status = $mapper->UnFreeze($restid,$freezedateset);
				if($status){
					$freezedmapper = new Reservation_Model_RestaurantFreezeDataMapper();
					$freezedDates = $freezedmapper->GetFreezedDates($restid);
					$result['freezedDates'] = $freezedDates;
					/* Retreiving freezeStatus */
					$freezeStatus = new Reservation_Model_GetFreezeStatus();
					$date = date('Y-m-d');
					$freezeStatus->setRestId($restid);
					$freezeStatus->setFreezeDate($date);
					$freezemapper = new Reservation_Model_RestaurantFreezeDataMapper();
					$status = $freezemapper->GetFreezeStatus($freezeStatus);
					$result['freezeStatus'] = $status;
				}
				return $result;

			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param request,data
	 * function to block the table for reservation
	 */
	public function BlockTable($request,$data)
	{
		try{
			if($request){
				$status = false;
				if($request->blkType == 'single'){
					$bokDetails = new Reservation_Model_Reservation();

					/* retreiving Restaurant Details address and name start*/
					$restService = new Application_Service_Firm();
					$restDetails = $restService->GetRestaurantDetailsById($request->restaurantid);
					$bokDetails->setbokfk_restaurant($request->restaurantid);
					$bokDetails->setresrestaurant_name($restDetails->resrestaurant_name);
					$bokDetails->setresaddress($restDetails->resaddress);
					/* retreiving Restaurant Details address and name end*/

					/* Retreiving reservation mode start */
					$resModeMapper = new Application_Model_ReservationModeDataMapper();
					$resModeStatus 	  = $resModeMapper->GetReservationModeByCode(array('WIN'));
					$resModeObj 	  = $resModeStatus['WIN'];
					$bokDetails->setbokreservation_mode_id($resModeObj->getId());
					/* Retreiving reservation mode end */

					/* retrieving the booking type start */
					$bookTypeMapper = new Application_Model_ReservationTypeDataMapper();
					$bookType = $bookTypeMapper->GetBookingTypeByCode('NOR');
					$bokDetails->setbokbooking_type_id($bookType->getId());
					/* retrieving the booking type end */

					if($request->blocktype == 'Schedule'){
						if($request->maxcountstatus){
							$bokDetails->setbokbooking_timings($request->time);
							$bokDetails->setbok_restsch_setting_id(3);
						}else{
							/* Retreiving restaurant schedule and table details start */
							$resSech = new FirmManagement_Model_FirmScheduleDataMapper();
							$schDetails = $resSech->ReterieveSchedulesForBlock($request->schid,$request->tabpax);
							$bokDetails->setInventoryId($schDetails['inventoryid']);
							$bokDetails->setTableSize($schDetails['tablesize']);
							$bokDetails->setNoOfTables($schDetails['nooftables']);
							$bokDetails->setbokbooking_timings($schDetails['schtime']);
		
							/* Retreiving restaurant schedule and table details end */
						}
					}else{
						$bokDetails->setbokbooking_timings($request->time);
					}

					/* retreiving the booking status start */
					$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
					$status[] = $request->tableStatus;
					$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($status);
					$bookStatusObj = $bookStatusRes[$request->tableStatus];
					$statusid = $bookStatusObj->getId();
					$bokDetails->setbokbooking_status_id($statusid);
					$bokDetails->setbokbooking_status($statusid);
					/* retreiving the booking status end */;

					$bokDetails->setbokparty_size($request->tabpax);
					$bokDetails->setbokbooking_date($request->date);

					$resServ = new Application_Service_Firm();
					$timeZone = $resServ->GetRestaurantTimeZone($request->restaurantid);
					date_default_timezone_set($timeZone);

					$bokDetails->setbokbooking_made_on(date('Y-m-d H:i:s'));
					$bokDetails->setBookingMadeTime(date("H:i",time()));
					
					$bookPhrase = uniqid ();
					$bokDetails->setbokbookingphrase($bookPhrase);

					$dateSplit = explode("-",$request->date);
					$weekday = date("D", mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]));
					if($request->tableStatus == 'RSD' || $request->tableStatus == 'WAL'){
						$bokDetails->setbokfirst_name('Walk');
						$bokDetails->setboklast_name('In');
					}else{
						$bokDetails->setbokfirst_name("Blocked");
						$bokDetails->setboklast_name("Slot");
					}
					$bokDetails->setbokuserid($data['User_Id']);
					
					if(isset($request->tblnoassigned)){
						$bokDetails->setboktable_no_assigned($request->tblnoassigned);
						$bokDetails->setDiningId($request->diningid);	
						$bokDetails->setboktableid($request->tableid);										
					}else{
						$bokDetails->setboktable_no_assigned("");
					}

					$mapper = new Reservation_Model_ReservationDataMapper();
					$RestaurantBookings = array();
					$RestaurantBookings[] = $bokDetails;
					$result = $mapper->saveBlockReservationDetails($RestaurantBookings);
					if($result)
					{
						$status = $result;
					}

				}else if($request->blkType == 'multiple'){
					$RestaurantBookings = array();//array of final Booking details
					$schid = null;
					$pax = null;
					$inventoryid = null;
					$tabDetailsArr = explode(",",$request->inventoryIds);//spliting the values of the checkboxes array
					foreach($tabDetailsArr as $table){
						if($table){
							$tabDetails = explode("_",$table);//spliting the scheduleid inventoryid and pax for each value
							$schid = $tabDetails[1];
							$pax = $tabDetails[2];
							$inventoryid = $tabDetails[3];
							$bokDetails = new Reservation_Model_Reservation();

							/* retreiving Restaurant Details address and name start*/
							$restService = new Application_Service_Firm();
							$restDetails = $restService->GetRestaurantDetailsById($request->restaurantid);
							$bokDetails->setbokfk_restaurant($request->restaurantid);
							$bokDetails->setresrestaurant_name($restDetails->resrestaurant_name);
							$bokDetails->setresaddress($restDetails->resaddress);
							/* retreiving Restaurant Details address and name end*/

							/* Retreiving restaurant schedule and table details start */
							$resSech = new FirmManagement_Model_FirmScheduleDataMapper();
							$bokDetails->setbokparty_size($pax);
							$schDetails = $resSech->ReterieveSchedulesForBlock($schid,$pax);
							$bokDetails->setInventoryId($schDetails['inventoryid']);
							$bokDetails->setTableSize($schDetails['tablesize']);
							$bokDetails->setNoOfTables($schDetails['nooftables']);
							$bokDetails->setbokbooking_timings($schDetails['schtime']);
							/* Retreiving restaurant schedule and table details end */

							/* Retreiving reservation mode start */
							$resModeMapper = new Application_Model_ReservationModeDataMapper();
							$resModeStatus 	  = $resModeMapper->GetReservationModeByCode(array('WIN'));
							$resModeObj 	  = $resModeStatus['WIN'];
							$bokDetails->setbokreservation_mode_id($resModeObj->getId());
							/* Retreiving reservation mode end */
							$dateSplit = explode("-",$request->date);
							$weekday = date("D", mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]));

							/* retrieving the booking type start */
							$bookTypeMapper = new Application_Model_ReservationTypeDataMapper();
							$bookType = $bookTypeMapper->GetBookingTypeByCode('NOR');
							$bokDetails->setbokbooking_type_id($bookType->getId());
							/* retrieving the booking type end */

							/* retreiving the booking status start */
							$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
							$status[] = 'BKD';
							$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($status);
							$bookStatusObj = $bookStatusRes['BKD'];
							$statusid = $bookStatusObj->getId();
							$bokDetails->setbokbooking_status_id($statusid);
							$bokDetails->setbokbooking_status($statusid);
							/* retreiving the booking status end */

							$resServ = new Application_Service_Firm();
							$timeZone = $resServ->GetRestaurantTimeZone($request->restaurantid);
							date_default_timezone_set($timeZone);

							$bokDetails->setbokbooking_made_on(date('Y-m-d H:i:s'));
							$bokDetails->setBookingMadeTime(date("H:i",time()));
							
							$bookPhrase = uniqid ();
							$bokDetails->setbokbookingphrase($bookPhrase);
					
							if(isset($request->tblnoassigned)){
								$bokDetails->setboktable_no_assigned($request->tblnoassigned);
								$bokDetails->setDiningId($request->diningid);	
								$bokDetails->setboktableid($request->tableid);										
							}else{
								$bokDetails->setboktable_no_assigned("");
							}
							$bokDetails->setbokbooking_date($request->date);
							$bokDetails->setbokfirst_name("Blocked");
							$bokDetails->setboklast_name("Slot");
							$bokDetails->setbokuserid($data['User_Id']);
							$bokDetails->setbokemail($data['Email']);
							$bokDetails->setbokphone($data['Phone']);


							$RestaurantBookings[] = $bokDetails;
						}
					}
					$mapper = new Reservation_Model_ReservationDataMapper();
					$result = $mapper->saveBlockReservationDetails($RestaurantBookings);
					if($result)
					{
						$status = $result;
					}
				}
				return $status;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function UnBlockTable($request,$data)
	{
		try{
			if($request){
				$bokStatusCode = $request->bookingstatus;

				$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
				$bookStatus 	  = $bookStatusMapper->GetBookingStatusByCode(array($bokStatusCode));
				$bookStatusObj 	  = $bookStatus[$bokStatusCode];
				$code = $request->tableStatus;
				$bokDetails = new Reservation_Model_Reservation();
				$mapper = new Reservation_Model_ReservationDataMapper();
				
				/* get booking id with phraseid */
//				$phraseId = $mapper->GetBookingIdByBookPhrase($request->bookingid);
			
				$bokDetails->setbokid($request->bookingid);	
				$bookDet = $mapper->getBookingDetailsByBookingIdArray($bokDetails);
	
				
				$bookStatus = $mapper->UnBlockTables($bookDet);
				return $bookStatus;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param request,status
	 * function to retreive the restaurant timings by party size
	 */
	public function getRestTimingsByPax($request,$status)
	{
		try{
			$mapper = new Reservation_Model_SearchListViewDataMapper();
			$timings = new Reservation_Model_GetRestaurantTimings();
			$timings->setRestId($request->restaurantid)
					->setDate($request->date)
					->setTableId($request->tableid)		
					->setpartysize($request->pax);
			$result = $mapper->RestTimingsByPax($timings,$status);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param request
	 * function to retreive the restaurant timings
	 */
	public function getRestaurantTimings($request)
	{
		try{
			if($request){
				if($request->restaurantid){
					$restid = $request->restaurantid;
				}else if($request->restid){
					$restid = $request->restid;
				}
        //echo '<pre>'; print_r($restid); exit;
				$mapper = new Reservation_Model_SearchListViewDataMapper();
				$timings = new Reservation_Model_GetRestaurantTimings();
				$timings->setRestId($restid)
				->setDate($request->date)
				->setTime(strtoupper($request->time))
				->setpartysize($request->partysize)
				->setResType('walk');
				
				/* Check Whether the selected date contains any special schedule */
				$restSpecialSchObject = new FirmManagement_Model_FirmSpecialSchedule();
				$restSpecialSchObject->setrsesfk_restaurant($timings->getRestId());
				$restSpecialSchObject->setrseseventdate($timings->getDate());
	
				$restSplSchMapperObj = new FirmManagement_Model_FirmSpecialScheduleMapper();				
				$splSchRow = $restSplSchMapperObj->CheckSpecialScheduleAvilable($restSpecialSchObject);
        
				if($splSchRow){
					$results = $mapper->GetRestTimings($timings);				
				}else{
					$resDataMapper = new FirmManagement_Model_FirmDataMapper();
					$seetingArr = $resDataMapper->getScheduleSettingTypeByresId($restid);
					$settingType = $seetingArr['settingType'];
					
					if($settingType == 'SL'){
						$results = $mapper->GetRestTimings($timings);
					}else if($settingType == 'UL'){
						$results = $mapper->GetRestTimingsForUnlimited($timings);
					}else if($settingType == 'SMC'){
						$results = $mapper->GetRestTimingsForMaxCount($timings);
					}else if($settingType == 'SAC'){
						$results = $mapper->GetRestTimingsForAccumulative($timings);
					}
				}
        //echo '<pre>'; print_r($results); exit;
				return $results;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param request
	 * function to retreive the restaurant schedule timings
	 */
	public function getSchdTimings($request)
	{
		try{
			if($request){
				$resservice = new Application_Service_Firm();
				return $resservice->GetSchdsByDateRestId($request);
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param request
	 * function to cancel the table reservation by customer
	 */
	public function ChangeTableStatusToCan($request)
	{
		try{
			$bokStatusCode = $request->bookingstatus;

			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			$bookStatus 	  = $bookStatusMapper->GetBookingStatusByCode(array($bokStatusCode));
			$bookStatusObj 	  = $bookStatus[$bokStatusCode];
			$code = $request->tableStatus;

			$mapper = new Reservation_Model_ReservationDataMapper();
			
			/* get booking id with phraseid */
//			$phraseId = $mapper->GetBookingIdByBookPhrase($request->bookingid);
			
			$bookDet = $this->GetBookingDetails($request->bookingid);

			$bookingObj = new Reservation_Model_Reservation();
			
			
			$bookingObj->setbokid($request->bookingid);
			$bookingObj->setbokbooking_status_id($bookStatusObj->getId());
			$bookingObj->setbokbooking_status_desc($request->tableStatus);
			$bookingObj->setInventoryId($bookDet->getInventoryId());
			$bookingObj->setbokfk_restaurant($request->restaurantid);
			if($bookDet->getbokcontactid()){
				$bookingObj->setbokcontactid($bookDet->getbokcontactid());
			}
			$bookStatus = $mapper->CancelNoteByBookingId($bookingObj);
			if($bookStatus){
				if($bokStatusCode == 'CAN' && $code != 'BKD'){
					$book = new Reservation_Model_Reservation();
					$book->setbokid($request->bookingid);
					$mapper->getBookingDetails($book);
					$neme = $book->getresrestaurant_name();
					$mailmapper = new Application_Service_Communication();
					$mailObj = new Communication_Model_Mail();
					if($book->getbokemail()){

						$stateCity = $this->getRestaurantStateByResId($request->restaurantid);
						$stateId = $stateCity['state'];
						$cityId = $stateCity['city'];
						$regionId = $stateCity['region'];

						$userType = 'CUS';
						$adminService = new Application_Service_Administrator();
						$campProp = new Application_Model_GetCampaignForPost();
						$campProp->setAudType($userType)
						->setStateId($stateId)
						->setCityId($cityId)
						->setRegionId($regionId)
						->setIsAjaxCall(false);
							
						$campDetails = $adminService->GetCampaignDetails($campProp);

						$mailObj->setMsgCode('Cancel');
						$name = $book->getbokfirst_name().' '.$book->getboklast_name();
						$data = array('UserName' => $name,
						  'SenTo'    	=>  $book->getbokemail(),
						  'phone'	 	=>  $book->getbokphone(),
						  'RestName' 	=>  $book->getresrestaurant_name(),
						  'ResDate'  	=>  $book->getbokbooking_date(),
						  'Time'     	=>  $book->getbokbooking_timings(),
						  'Size'     	=>  $book->getbokparty_size(),
						  'Address'	 	=>  $book->getresaddress(),
						  'Status'	 	=>  $book->getbokbooking_status_desc(),
						  'State_Id' 	=>	$stateId,
						  'City_Id'	 	=>	$cityId,
						  'resphone' 	=>  $book->getResPhone(),
						  'UserType' 	=>	$userType,
						  'BookId'	 	=>  $request->bookingid,
						  'BookNotCan'	=>	false,
						  'resemail'	=>  '',
						);
						if(count($campDetails)){
							$count = count($campDetails);
							if($count > 1){
								$campaign = $campDetails[rand(0,$count-1)];
							}else{
								$campaign = $campDetails[0];
							}
							$notfService = new Application_Service_Communication();
							$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
							$data['campaignName'] = trim($campaign->getSponsor());
							$data['campaignDesc'] =	trim($campaign->getCampDesc());
							$data['campaignImg'] =	trim($campaign->getCampImage());
							$data['campId']	= $campaign->getId();
						}
							
						$mailObj->setData($data);
						$mailStatus = $mailmapper->SendMail($mailObj);
					}else if($book->getbokphone()){
						$smsObj = new Communication_Model_Sms();
						$smsObj->setMsgCode('Cancel');
						$data = array('to'		 	=>	trim($book->getbokphone()),
									  'countrycode'	=> $book->getbokcountry_code(),
									  'bokid'	 	=> $request->bookingid,	
									  'RestName' 	=> $book->getresrestaurant_name(),
									  'ResDate'  	=> $book->getbokbooking_date(),
								   	  'Time'     	=> $book->getbokbooking_timings(),
								   	  'Size'     	=> $book->getbokparty_size(),
								   	  'CustomerName'=> $book->getbokfirst_name().' '.$book->getboklast_name()	
						);

						$smsObj->setData($data);
						$mailStatus = $mailmapper->SendSms($smsObj);
					}
				}
				$result = array('status'=>true,
		 					'restaurant_id'=>$request->restaurantid);
				return $result;
			}else{

				$result = array('status'=>false);
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param request
	 * function to cancel the reservations
	 */
	public function CancelReservation($request)
	{
		try{
			$bokid = $request->bokid;
			$mapper = new Reservation_Model_ReservationDataMapper();
			
			/* get booking id with phraseid */
			$phraseId = $mapper->GetBookingIdByBookPhrase($bokid);
			
			$result = $this->GetBookingDetails($phraseId);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param request
	 * function to cancel the reservation
	 */
	public function CancelReservationCon($request)
	{
		try{
			$resultArr = array();
			$bokid = $request->bokid;
			$mapper = new Reservation_Model_ReservationDataMapper();
			
			/* get booking id with phraseid */
			$phraseId = $mapper->GetBookingIdByBookPhrase($bokid);
			
			$result = $this->GetBookingDetails($phraseId);
			$staus = $result->getbokbooking_status_code();
			$restid = $request->restaurantid;

			$resServ = new Application_Service_Firm();
			$timeZone = $resServ->GetRestaurantTimeZone($request->restaurantid);
			date_default_timezone_set($timeZone);

			$bokdatesplit = explode("-",$result->getbokbooking_date());
			$time = explode(" ",$result->getbokbooking_timings());
			$timeHM = explode(":",$time[0]);
			if($time[1] ==  "PM"){
				if((int)$timeHM[0] != 12){
					(int)$timeHM[0] += 12;
				}
			}//if the time is PM than adding 12 to hours
			if($time[1] ==  "AM" && (int)$timeHM[0] == 12){

				(int)$timeHM[0] = 0;

			}
			$bokdaySec = mktime($timeHM[0],$timeHM[1],0,$bokdatesplit[1],$bokdatesplit[2],$bokdatesplit[0]);

			$datesplit = explode("-",date('m-d-Y'));
			$timesplit = explode(":",date('H:i:s'));
			$todaySec = mktime($timesplit[0],$timesplit[1],$timesplit[2],$datesplit[0],$datesplit[1],$datesplit[2]);
			if($bokdaySec > $todaySec){
				if($staus == 'RSD' || $staus == 'WAL'){
					$bokStatusCode = 'CAN';
					$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
					$bookStatus 	  = $bookStatusMapper->GetBookingStatusByCode(array($bokStatusCode));
					$bookStatusObj 	  = $bookStatus[$bokStatusCode];
					$code = $request->tableStatus;
					$bookingObj = new Reservation_Model_Reservation();
					$bookingObj->setbokid($phraseId);
					$bookingObj->setbokbooking_status_id($bookStatusObj->getId());
					$bookingObj->setbokbooking_status_desc($staus);
					$bookingObj->setInventoryId($result->getInventoryId());
					$bookingObj->setbokfk_restaurant($restid);
					if($result->getbokcontactid()){
						$bookingObj->setbokcontactid($result->getbokcontactid());
					}
					$bookStatus = $mapper->CancelNoteByBookingId($bookingObj);
					if($bookStatus){
						$stateId = "";
						$cityId = "";
						$regionId = "";
						if($bokStatusCode == 'CAN'){
							if($stateId == ""){
								$stateCity = $this->getRestaurantStateByResId($result->getbokfk_restaurant());
								$stateId = $stateCity['state'];
								$cityId = $stateCity['city'];
								$regionId = $stateCity['region'];

							}
							$userType = 'CUS';
							$adminService = new Application_Service_Administrator();
							$campProp = new Application_Model_GetCampaignForPost();
							$campProp->setAudType($userType)
							->setStateId($stateId)
							->setCityId($cityId)
							->setRegionId($regionId)
							->setIsAjaxCall(false);
							$campDetails = $adminService->GetCampaignDetails($campProp);

							$book = new Reservation_Model_Reservation();
							$book->setbokid($phraseId);
							$mapper->getBookingDetails($book);
							$neme = $book->getresrestaurant_name();
							$mailmapper = new Application_Service_Communication();
							if($book->getbokemail()){
								$restInfo = $mapper->ReterieveRestemails($restid);
								$mailObj = new Communication_Model_Mail();
								$mailObj->setMsgCode('Cancel');
								$name = $book->getbokfirst_name().' '.$book->getboklast_name();
								$data = array('UserName' => $name,
								  'SenTo'    	=> $book->getbokemail(),
								  'phone'		=> $book->getbokphone(),	
								  'RestName' 	=> $book->getresrestaurant_name(),
								  'RestEmails'	=> $restInfo['emails'],								
								  'ResDate'  	=> $book->getbokbooking_date(),
								  'Time'    	=> $book->getbokbooking_timings(),
								  'Size'     	=> $book->getbokparty_size(),
								  'Address'	 	=> $book->getresaddress(),
								  'Status'	 	=> $book->getbokbooking_status_desc(),
								  'State_Id' 	=>	$stateId,
								  'City_Id'	 	=>	$cityId,
								  'resphone' 	=> $book->getResPhone(),
								  'UserType' 	=>	$userType,
								  'BookId'	 	=> $phraseId,
								  'BookNotCan'	=>	true,
								  'resemail'	=>  '',
								);
								if(count($campDetails)){
									$count = count($campDetails);
									if($count > 1){
										$campaign = $campDetails[rand(0,$count-1)];
									}else{
										$campaign = $campDetails[0];
									}
									$notfService = new Application_Service_Communication();
									$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
									$data['campaignName'] = trim($campaign->getSponsor());
									$data['campaignDesc'] =	trim($campaign->getCampDesc());
									$data['campaignImg'] =	trim($campaign->getCampImage());
									$data['campId']	= $campaign->getId();
								}
									
								$mailObj->setData($data);
								$mailStatus = $mailmapper->SendMail($mailObj);
							}else if($book->getbokphone()){
								$smsObj = new Communication_Model_Sms();
								$smsObj->setMsgCode('Cancel');
								$data = array('to'			=>	trim($book->getbokphone()),
											  'countrycode'	=> $book->getbokcountry_code(),
											  'RestName' 	=> $book->getresrestaurant_name(),
											  'ResDate'  	=> $book->getbokbooking_date(),
								   			  'Time'     	=> $book->getbokbooking_timings(),
										      'bokid'		=> $phraseId,	
								   			  'Size'     	=> $book->getbokparty_size(),
								   			  'CustomerName'=>$book->getbokfirst_name().' '.$book->getboklast_name()	
								);

								$smsObj->setData($data);
								$mailStatus = $mailmapper->SendSms($smsObj);
							}
							//$restInfo = $mapper->ReterieveRestInfo($restid);
//							$restInfo = $mapper->ReterieveRestemails($restid);
//							if($restInfo){
//								if($restInfo['status'] && isset($restInfo['emails'])){
//									$mailObj = new Communication_Model_Mail();
//									$stateCityVal = $this->getRestaurantStateByResId($result->getbokfk_restaurant());
//									$stateIdVal = $stateCityVal['state'];
//									$cityIdVal = $stateCityVal['city'];
//									$regionIdVal = $stateCityVal['region'];
//
//									$userType = 'RES';
//									
//									$resDataMapper = new FirmManagement_Model_FirmDataMapper();
//									$restObj= new FirmManagement_Model_FirmById();
//									$restObj->setRestaurantId($restid);
//									$resDetails = $resDataMapper->getRestaurantById($restObj);
//									
//									$adminService = new Application_Service_Administrator();
//									if($resDetails->getrescampaignstatus()){
//										$campProp = new Application_Model_GetCampaignForPost();
//										$campProp->setAudType($userType)
//										->setStateId($stateIdVal)
//										->setCityId($cityIdVal)
//										->setRegionId($regionIdVal)
//										->setIsAjaxCall(false);
//										$campDetails = $adminService->GetCampaignDetails($campProp);
//									}else{
//										$campDetails = array();
//									}
//									//$restEmail = $restInfo->resemail;
//									$mailObj->setMsgCode('BookNotCan');
//									$name = $book->getbokfirst_name().' '.$book->getboklast_name();
//
//									$data = array('UserName' => $name,
//										  'SenTo'    => $restInfo['emails'],
//										  'RestName' => $book->getresrestaurant_name(),
//										  'ResDate'  => $book->getbokbooking_date(),
//										  'Time'     => $book->getbokbooking_timings(),
//										  'email'	 => $book->getbokemail(),
//										  'phone'	 => $book->getbokphone(),	
//										  'Size'     => $book->getbokparty_size(),
//										  'Address'	 => $book->getresaddress(),
//										  'Bookid'	 => $phraseId,
//										  'State_Id' =>	$stateId,
//										  'City_Id'	 =>	$cityIdVal,
//										  'UserType' =>	$userType
//									);
//									if(count($campDetails)){
//										$count = count($campDetails);
//										if($count > 1){
//											$campaign = $campDetails[rand(0,$count-1)];
//										}else{
//											$campaign = $campDetails[0];
//										}
//										$notfService = new Application_Service_Communication();
//										$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
//										$data['campaignName'] = trim($campaign->getSponsor());
//										$data['campaignDesc'] =	trim($campaign->getCampDesc());
//										$data['campaignImg'] =	trim($campaign->getCampImage());
//										$data['campId']	= $campaign->getId();
//									}
//									$mailObj->setData($data);
//									$mailStatus = $mailmapper->SendMail($mailObj);
//								}
//							}

							$restservice = new Application_Service_Firm();
							$timeZone = $restservice->GetRestaurantTimeZone($restid);
							date_default_timezone_set($timeZone);

							/* Reterieve Phone Notify Details */
							if($staus == 'RSD'){

								$restPhoneInfo = $restservice->getRestaurantPhoneDetails($restid);

								$bookingdate   = $book->getbokbooking_date();
								$todaydate     = date('Y-m-d');
								
								$currdate = date('m-d-Y');
								
								
								if($restPhoneInfo['smsnotify']){

									$phoneRowSet = $restPhoneInfo['rowset'];
									$phonenumber = "";
									$fromtime    = "";
									$totime		 = "";
									$resvTime    = $book->getbokbooking_timings();

									if($phoneRowSet){
										foreach($phoneRowSet as $phoneNum){
											if($phoneNum->rntnotify_type == 'sms'){
												$phonenumber = $phoneNum->rntphone;
												$fromtime    = $phoneNum->rntnotify_from_time;
												$totime		 = $phoneNum->rntnotify_to_time;
												$countrycode = $phoneNum->rntcountrycode;
											}
										}
										if($phonenumber){

											if(strtotime($resvTime)>= strtotime($fromtime) && strtotime($resvTime)<= strtotime($totime)){
												$smsObj = new Communication_Model_Sms();
												$smsObj->setMsgCode('CanNotf');
													
												$data = array('to' 		 => $phonenumber,
														  'countrycode'	 => $countrycode,
														  'bokid'    	 => $phraseId,
														  'RestName' 	 => $book->getresrestaurant_name(),
														  'ResDate'	 	 => $book->getbokbooking_date(),
														  'Time'		 => $book->getbokbooking_timings(),
														  'Size'		 => $book->getbokparty_size(),
														  'CustomerName' => $book->getbokfirst_name().' '.$book->getboklast_name());
													
												$smsObj->setData($data);
							 				$mailStatus = $mailmapper->SendSms($smsObj);
							 					
											}
										}
									}
								}
									
							}

						}
						$resultArr['status'] = true;
						$resultArr['result'] = $result;
						return $resultArr;
					}
				}else{
					$resultArr['status'] = false;
					$resultArr['result'] = $result;
					return $resultArr;
				}
			}else{
				$resultArr['status'] = false;
				$resultArr['result'] = $result;
				return $resultArr;
			}

		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param id
	 * function to retreive the location of the restaurant by booking id
	 */
	public function getBookingStateByBokId($id)
	{
		try{
			$mapper = new User_Model_ClientDataMapper();
			$result = $mapper->GetStateAndCityById($id);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param request,data
	 * function to cancel the customer reservation
	 */
	public function CancelCusResv($request,$data)
	{
		try{
			$bookingObj = new Reservation_Model_Reservation();
			$mapper = new Reservation_Model_ReservationDataMapper();
			
			/* get booking id with phraseid */
			$phraseId = $mapper->GetBookingIdByBookPhrase($request->bookingid);
			
			$bookingObj->setbokid($phraseId);
			$bookingObj->setbokfk_restaurant($request->restaurantid);
			
			$bokDetails = $mapper->getBookingDetails($bookingObj);
			$bookStatus = false;
			if($bokDetails->getbokbooking_status_code() == 'RSD' || $bokDetails->getbokbooking_status_code() == 'WAL'){
				$bookStatus = $mapper->CancelCusResvByBookingId($bookingObj);
				$stateId = $data['State_Id'];
				$cityId = $data['City_Id'];
				$regionId = '';
				if($bokDetails->getbokbooking_status_desc() != 'Waiting List'){
					$resDataMapper = new FirmManagement_Model_FirmDataMapper();
					$settingArr = $resDataMapper->getScheduleSettingTypeByresId($bookingObj->getbokfk_restaurant());
					if($settingArr['settingType'] == 'SAC'){
						$mapper->ResetAccumulativeBookingCount($bookingObj);
					}else{
						$mapper->ResetBookingCount($bookingObj);
					}
				}
			}
			if($bookStatus){
					
				$neme = $bookingObj->getresrestaurant_name();
				$mailmapper = new Application_Service_Communication();
				$mailObj = new Communication_Model_Mail();
				if($bookingObj->getbokemail()){
					if($stateId == ""){
						$stateCity = $this->getRestaurantStateByResId($bookingObj->getbokfk_restaurant());
						$stateId = $stateCity['state'];
						$cityId = $stateCity['city'];
						$regionId = $stateCity['region'];

					}
					$userType = 'CUS';
					$adminService = new Application_Service_Administrator();
					$campProp = new Application_Model_GetCampaignForPost();
					$campProp->setAudType($userType)
					->setStateId($stateId)
					->setCityId($cityId)
					->setRegionId($regionId)
					->setIsAjaxCall(false);
					$campDetails = $adminService->GetCampaignDetails($campProp);
					
					$restid  = $request->restaurantid;
//					$restInfo = $mapper->ReterieveRestInfo($restid);
					$restInfo = $mapper->ReterieveRestemails($restid);
					$mailObj->setMsgCode('Cancel');
					$name = $bookingObj->getbokfirst_name().' '.$bookingObj->getboklast_name();
					$data = array('UserName' => $name,
						  'SenTo'    	=> $bookingObj->getbokemail(),
					      'phone'	 	=> $bookingObj->getbokphone(),
						  'RestName' 	=> $bookingObj->getresrestaurant_name(),
						  'RestEmails'	=> $restInfo['emails'],
						  'ResDate' 	=> $bookingObj->getbokbooking_date(),
						  'Time'     	=> $bookingObj->getbokbooking_timings(),
						  'Size'     	=> $bookingObj->getbokparty_size(),
						  'Address'	 	=> $bookingObj->getresaddress(),
						  'Status'	 	=> 'Waiting List',
						  'State_Id' 	=>	$stateId,
						  'City_Id'	 	=>	$cityId,
						  'resphone' 	=> $bookingObj->getResPhone(),
						  'UserType' 	=>	$userType,
						  'BookId'	 	=> $bookingObj->getbokid(),
					  	  'resemail' 	=> $bookingObj->getResEmail(),
						  'BookNotCan'	=> true,		
					);
					if(count($campDetails)){
						$count = count($campDetails);
						if($count > 1){
							$campaign = $campDetails[rand(0,$count-1)];
						}else{
							$campaign = $campDetails[0];
						}
						$notfService = new Application_Service_Communication();
						$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
						$data['campaignName'] = trim($campaign->getSponsor());
						$data['campaignDesc'] =	trim($campaign->getCampDesc());
						$data['campaignImg'] =	trim($campaign->getCampImage());
						$data['campId']	= $campaign->getId();
					}

					$mailObj->setData($data);
					$mailStatus = $mailmapper->SendMail($mailObj);
				}else if($bookingObj->getbokphone()){
					$smsObj = new Communication_Model_Sms();
					$smsObj->setMsgCode('Cancel');
					$data = array('to'			=>	trim($bookingObj->getbokphone()),
								  'countrycode' => $bookingObj->getbokcountry_code(),
					 			  'RestName' 	=> $bookingObj->getresrestaurant_name(),
					 			  'ResDate'  	=> $bookingObj->getbokbooking_date(),
								  'bokid'		=> $bookingObj->getbokid(),	
								  'Time'    	=> $bookingObj->getbokbooking_timings(),
								  'Size'     	=> $bookingObj->getbokparty_size(),
							      'CustomerName'=> $bookingObj->getbokfirst_name().' '.$bookingObj->getboklast_name()				 			   		
					);
					$smsObj->setData($data);
					$mailStatus = $mailmapper->SendSms($smsObj);
				}
				$restid  = $request->restaurantid;
//				$restInfo = $mapper->ReterieveRestInfo($restid);
//				if($restInfo){
//					if($restInfo->resnotification && $restInfo->resemail){
//						$stateCityVal = $this->getRestaurantStateByResId($request->restaurantid);
//						$stateIdVal = $stateCityVal['state'];
//						$cityIdVal = $stateCityVal['city'];
//						$regionIdVal = $stateCityVal['region'];
//
//						$userType = 'RES';
//						$adminService = new Application_Service_Administrator();
//						$resDataMapper = new FirmManagement_Model_FirmDataMapper();
//						$restObj= new FirmManagement_Model_FirmById();
//						$restObj->setRestaurantId($restid);
//						$resDetails = $resDataMapper->getRestaurantById($restObj);
//						if($resDetails->getrescampaignstatus()){
//							$campProp = new Application_Model_GetCampaignForPost();
//							$campProp->setAudType($userType)
//									 ->setStateId($stateIdVal)
//									 ->setCityId($cityIdVal)
//							->setRegionId($regionIdVal)
//							->setIsAjaxCall(false);
//							$campDetails = $adminService->GetCampaignDetails($campProp);
//						}else{
//							$campDetails = array();
//						}
//						$restEmail = $restInfo->resemail;
//						$mailObj->setMsgCode('BookNotCan');
//						$name = $bookingObj->getbokfirst_name().' '.$bookingObj->getboklast_name();
//
//						$data = array('UserName' => $name,
//							  'SenTo'    => $restEmail,
//							  'RestName' => $bookingObj->getresrestaurant_name(),
//							  'ResDate'  => $bookingObj->getbokbooking_date(),
//							  'Time'     => $bookingObj->getbokbooking_timings(),
//							  'email'	 => $bookingObj->getbokemail(),
//							  'phone'	 => $bookingObj->getbokphone(),	
//							  'Size'     => $bookingObj->getbokparty_size(),
//							  'Address'	 => $bookingObj->getresaddress(),
//							  'Bookid'	 => $bookingObj->getbokid(),
//							  'State_Id' =>	$stateId,
//				  			  'City_Id'	 =>	$cityIdVal,
//				  			  'UserType' =>	$userType
//						);
//						if(count($campDetails)){
//							$count = count($campDetails);
//							if($count > 1){
//								$campaign = $campDetails[rand(0,$count-1)];
//							}else{
//								$campaign = $campDetails[0];
//							}
//							$notfService = new Application_Service_Communication();
//							$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
//							$data['campaignName'] = trim($campaign->getSponsor());
//							$data['campaignDesc'] =	trim($campaign->getCampDesc());
//							$data['campaignImg'] =	trim($campaign->getCampImage());
//							$data['campId']	= $campaign->getId();
//						}
//
//						$mailObj->setData($data);
////						$mailStatus = $mailmapper->SendMail($mailObj);
//					}
//				}
				$restservice = new Application_Service_Firm();
//				$timeZone = $restservice->GetRestaurantTimeZone($restid);
//				date_default_timezone_set($timeZone);

				/* Reterieve Phone Notify Details */
				$restPhoneInfo = $restservice->getRestaurantPhoneDetails($restid);

				$bookingdate = $bookingObj->getbokbooking_date();
				$todaydate   = date('Y-m-d');	

				if($restPhoneInfo['smsnotify']){

					$phoneRowSet = $restPhoneInfo['rowset'];
					$phonenumber = "";
					$fromtime    = "";
					$totime		 = "";
					$resvTime    = $bookingObj->getbokbooking_timings();

					if($phoneRowSet){
						foreach($phoneRowSet as $phoneNum){
							if($phoneNum->rntnotify_type == 'sms'){
								$phonenumber = $phoneNum->rntphone;
								$fromtime    = $phoneNum->rntnotify_from_time;
								$totime		 = $phoneNum->rntnotify_to_time;
								$countrycode = $phoneNum->rntcountrycode;
							}
						}
						if($phonenumber){

							if(strtotime($resvTime)>= strtotime($fromtime) && strtotime($resvTime)<= strtotime($totime)){
								$smsObj = new Communication_Model_Sms();
								$smsObj->setMsgCode('CanNotf');

								$data = array('to' 		 	 => $phonenumber,
											  'countrycode'	 => $countrycode,
											  'bokid'    	 => $bookingObj->getbokid(),
											  'RestName' 	 => $bookingObj->getresrestaurant_name(),
											  'ResDate'	 	 => $bookingObj->getbokbooking_date(),
											  'Time'		 => $bookingObj->getbokbooking_timings(),
											  'Size'		 => $bookingObj->getbokparty_size(),
											  'CustomerName' => $bookingObj->getbokfirst_name().' '.$bookingObj->getboklast_name());

								$smsObj->setData($data);
								$mailStatus = $mailmapper->SendSms($smsObj);

							}
						}
					}
				}
			}
			return  $bookStatus;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param data
	 * function to manage the reservations of the restaurant listview data
	 */
	public function ProcessListViewData($data)
	{
		try{
			$Schedules      = array();
			$Reservations   = array();

			$time = null;
			$pax  = null;
			$Schedules 	  = $data['Schedules'];
			$Reservations = $data['Reservations'];

			if(count($Schedules) > 0 && count($Reservations) > 0){
				foreach($Reservations as $resvitem){
					$time = $resvitem['resvtime'];
					$pax  = $resvitem['tablesize'];
					foreach($Schedules as &$schitem){
						if($schitem['schtime'] == $time && $schitem['tablesize'] == $pax && $schitem['flag'] == false){
							$schitem['bookid'] 	     = $resvitem['bookid'];
							$schitem['username']     = $resvitem['username'];
							$schitem['partysize']    = $resvitem['partysize'];
							$schitem['resvnote']     = $resvitem['resvnote'];
							$schitem['restnote']     = $resvitem['restnote'];
							$schitem['tableno']      = $resvitem['tableno'];
							$schitem['tablenoarr']   = $resvitem['tablenoarr'];
							$schitem['booktypecode'] = $resvitem['booktypecode'];
							$schitem['booktypedesc'] = $resvitem['booktypedesc'];
							$schitem['resvmodcode']  = $resvitem['resvmodcode'];
							$schitem['resvmoddesc']  = $resvitem['resvmoddesc'];
							$schitem['bokstscode']   = $resvitem['bokstscode'];
							$schitem['bokstsdesc']   = $resvitem['bokstsdesc'];
							$schitem['diningid']   	 = $resvitem['diningid'];
							$schitem['flag']         = true;
							break;
						}
					}
				}
			}
			return $Schedules;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param data,offset
	 * function to retreive the reservations of the customer by id
	 */
	public function GetCusBookingsByOwnerId($data,$offset)
	{
		try{
			$userid = $data['User_Id'];
			$phone  = $data['Phone'];
			$email  = $data['Email'];
			
			$custBookHist = new Reservation_Model_CustBookHist();
			$custBookHist->setUserId($userid)
						 ->setPhone($phone)
						 ->setEmail($email);
			$mapper = new Reservation_Model_ReservationDataMapper();
			$resultSet = $mapper->getCustBookingHistoryByOwnerId($custBookHist,$offset);
			return $resultSet;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param request,userid
	 * function to verify the password
	 */
	public function CheckPassword($request,$userid)
	{
		try{
			$usrservice = new Application_Service_Firm();
			$status = $usrservice->CheckPassword($request,$userid);
			return $status;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param array,on,order
	 * function to sort the reservations data according to the end user selection
	 */
	public function array_sort($array, $on, $order='SORT_DESC')
	{
		$new_array = array();
		$sortable_array = array();

		if (count($array) > 0) {
			foreach ($array as $k => $v) {
				if (is_array($v)) {
					foreach ($v as $k2 => $v2) {
						if ($k2 == $on) {
							$sortable_array[$k] = $v2;
						}
					}
				} else {
					$sortable_array[$k] = $v;
				}
			}

			switch($order)
			{
				case 'SORT_ASC':
					asort($sortable_array,SORT_REGULAR);
					break;
				case 'SORT_DESC':
					arsort($sortable_array);
					break;
			}

			foreach($sortable_array as $k => $v) {
				$new_array[] = $array[$k];
			}
		}
		return $new_array;
	}

	/**
	 * @param request,rowset,row
	 * function to generate the report of the reservations
	 */
	public function CreateReport($rowSet,$request,$row)
	{

		try{
       /* code by pratik */
      if($request->restaurantid != ''){
			  $restid = $request->restaurantid;
      }else{
        $restid = $request->report;
      }
      /* ** */
			$restname = $row->resrestaurant_name;
			$restlogo = $row->reslogo;
      //echo '<pre>'; print_r($restid); exit;
			$storage = new Zend_Auth_Storage_Session();
			$data = $storage->read();
			$companyid = $data['companyid'];
			require_once 'Zend/Loader/Autoloader.php';
			$loader = Zend_Loader_Autoloader::getInstance();

			$pdf = new My_Pdf_Document('reports/'.$restid.'.pdf', '.');
			$page = $pdf->createPage();

			$font = Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_HELVETICA);

			$page->setFont($font, 8);
			$page->setLineColor(new Zend_Pdf_Color_Rgb(0,100,0));
			$page->drawLine(-10, 15, ($page->getWidth()-0), 15);

			$imageurl = "";
			$service = new Application_Service_Firm();
		 	if(file_exists($restlogo)){
				$ext = $service->_findexts($restlogo);
				if($ext == 'jpg' || $ext == 'png'){
					$imageurl = "../public".$row->reslogo;
				}else{
					$imageurl = "../public/images/logo.png";
				}
		 	}else{
		 		$imageurl = "../public/images/logo.png";
		 	}

			$image = Zend_Pdf_Image::imageWithPath($imageurl);

			// write image to page
			$page->drawImage($image,-10,-30,80, 40);

			$page->drawText($restname, 200, 0);

			$reportcreationdate = date("Y-m-d");
			$page->drawText($reportcreationdate, 500, 0);

			$datetime = "";
			$startdate = "";
			$endate    = "";
			$starttime = "";
			$endtime   = "";

			if($request->bokstartdate){

				$startdate = $request->bokstartdate;
			}else{
				$startdate = date("Y-m-d");
			}
			if($request->bokstarttime){
				$starttime = " - ".$request->bokstarttime;
			}

			if($request->bokenddate){
				$endate = $request->bokenddate;
			}

			if($request->bokendtime){
				$endtime = " - ".$request->bokendtime;
			}

			$datetime = "Start Date & Time : ".$startdate.$starttime."        End Date & Time : ".$endate.$endtime;
			$page->drawText($datetime, -10, 35);

			$page->drawText("This report has been printed from dinedesk.com", -10, 50);

			$table = new My_Pdf_Table(10);
			if(count($rowSet)>0 ){
					
				/* Adding table header */
				$headrow  = new My_Pdf_Table_Row();
				$headcols = array();
					
				$Receipt  = new My_Pdf_Table_Column();
				$Receipt->setText("ID",'left','top');
				$Receipt->setWidth(30);
				$headcols[] = $Receipt;
					
				$FirstName  = new My_Pdf_Table_Column();
				$FirstName->setText("Customer Details",'left','top');
				$FirstName->setWidth(130);
				$headcols[] = $FirstName;
				
				$TakenBy  = new My_Pdf_Table_Column();
				$TakenBy->setText("Booked By",'left','top');
				$TakenBy->setWidth(50);
				$headcols[] = $TakenBy;
					
				$Date  = new My_Pdf_Table_Column();
				$Date->setText("Date & Time",'left','top');
				$Date->setWidth(60);
				$headcols[] = $Date;

				$Time  = new My_Pdf_Table_Column();
				$Time->setText("Created At",'left','top');
				$Time->setWidth(60);
				$headcols[] = $Time;
					
				$Seats  = new My_Pdf_Table_Column();
				$Seats->setText("Pax",'left','top');
				$Seats->setWidth(30);
				$headcols[] = $Seats;

				$Notes  = new My_Pdf_Table_Column();
				$Notes->setText("Notes",'left','top');
				$Notes->setWidth(80);
				$headcols[] = $Notes;

				$Origin = new My_Pdf_Table_Column();
				$Origin->setText("Origin",'left','top');
				$Origin->setWidth(40);
				$headcols[] = $Origin;

				$Status = new My_Pdf_Table_Column();
				$Status->setText("Status",'left','top');
				$Status->setWidth(70);
				$headcols[] = $Status;

				$tableNoCol = new My_Pdf_Table_Column();
				$tableNoCol->setText("Table",'left','top');
				$tableNoCol->setWidth(20);
				$headcols[] = $tableNoCol;

				$headrow->setColumns($headcols);
				$headrow->setFont($font, 8);
				$headrow->setBorder(My_Pdf::TOP, new Zend_Pdf_Style());
				$headrow->setBorder(My_Pdf::BOTTOM, new Zend_Pdf_Style());
				$headrow->setBorder(My_Pdf::LEFT, new Zend_Pdf_Style());
				$headrow->setCellPaddings(array(4,4,4,4));
				$table->addRow($headrow);
					
				$previd = "";
				$bokid = "";
				
				foreach($rowSet as $rows){
					if($previd == ""){
						$bokid = $rows->bokid;
						$previd = $rows->bokid;
						
						$row = new My_Pdf_Table_Row();
						$cols = array();
	
						$col = new My_Pdf_Table_Column();
						$col->setText($rows->bokid,'left','top');
						$col->setWidth(30);
						$cols[] = $col;
	
						$col1 = new My_Pdf_Table_Column();
						$contDetails = '';
						$contDetails = $rows->bokfirst_name.' '.$rows->boklast_name;
						if($rows->boknotification_type == 'email'){
							$contDetails .= ' '.$rows->bokemail;
						}else if($rows->boknotification_type == 'sms'){
							$contDetails .= ' '.$rows->bokphone;
						}else if($rows->boknotification_type == 'both'){
							$contDetails .= ' '.$rows->bokemail." ".$rows->bokphone;
						}
						$col1->setText($contDetails,'left','top');
						$col1->setWidth(130);
						$cols[] = $col1;
						
						$col10 = new My_Pdf_Table_Column();
						if($rows->resvmode == "INAT"){
							$col10->setText($rows->resvDesc,'left','top');
							$col10->setWidth(50);
							$cols[] = $col10;
						}else if($rows->resvmode == "WIN"){
							$col10->setText($rows->resvDesc,'left','top');
							$col10->setWidth(50);
							$cols[] = $col10;
						}else if($rows->resvmode == "FB"){
							$col10->setText($rows->resvDesc,'left','top');
							$col10->setWidth(50);
							$cols[] = $col10;
						}else if($rows->resvmode == "PHN"){
							$col10->setText($rows->resvDesc,'left','top');
							$col10->setWidth(50);
							$cols[] = $col10;
						}else{
							$col10->setText($rows->resvDesc,'left','top');
							$col10->setWidth(50);
							$cols[] = $col10;
						}
						
						 $col3 = new My_Pdf_Table_Column();
						 $datetime = "";
						 $datetime = date("m-d-Y",strtotime($rows->bokbooking_date)).' '.date("h:i A",strtotime($rows->bokbooking_timings));
						 $col3->setText(trim($datetime),'left','top');
						 $col3->setWidth(60);
						 $cols[] = $col3;
		
						 $col8 = new My_Pdf_Table_Column();
						 $time = "";
						 $time = date("m-d-Y",strtotime($rows->bokbooking_made_on)).' '.date("h:i A",strtotime($rows->bokbooking_made_time));
						 $col8->setText(trim($time),'left','top');
						 $col8->setWidth(60);
						 $cols[] = $col8;
		
		
						 $col4 = new My_Pdf_Table_Column();
						 $col4->setText($rows->bokparty_size,'left','top');
						 $col4->setWidth(30);
						 $cols[] = $col4;
						 
						$notes = "";	 
						if($rows->bokspecial_request != '' && $rows->bokrestaurant_note != ''){
							$notes = 'Guest Notes: '.$rows->bokspecial_request.' Restaurant Notes: '.$rows->bokrestaurant_note;							
						}else if($rows->bokspecial_request != ''){
							$notes = 'Guest Notes: '.$rows->bokspecial_request;
						}else if($rows->bokrestaurant_note != ''){
							$notes = 'Restaurant Notes: '.$rows->bokrestaurant_note;
						}	
						 $col6 = new My_Pdf_Table_Column();
						 $col6->setText($notes,'left','top');
						 $col6->setWidth(80);
						 $cols[] = $col6;
		
						 if($rows->resvmode == "INAT"){
						 	$col9 = new My_Pdf_Table_Column();
						 	if($companyid == 6){
							 	$col9->setImage("../public/images/icons/rndmenu.png",'left','top');
						 	}else{
						 		$col9->setImage("../public/images/icons/inat.png",'left','top');
						 	}
						 	$col9->setWidth(30);
						 	$cols[] = $col9;
						 }else if($rows->resvmode == "WIN"){
						 	$col9 = new My_Pdf_Table_Column();
						 	$col9->setImage("../public/images/icons/Walk.png",'left','top');
						 	$col9->setWidth(35);
						 	$cols[] = $col9;
						 }else if($rows->resvmode == "FB"){
						 	$col9 = new My_Pdf_Table_Column();
						 	$col9->setImage("../public/images/icons/fb.png",'left','top');
						 	$col9->setWidth(35);
						 	$cols[] = $col9;
						 }else if($rows->resvmode == "PHN"){
						 	$col9 = new My_Pdf_Table_Column();
						 	$col9->setImage("../public/images/icons/Mobile.png",'left','top');
						 	$col9->setWidth(35);
						 	$cols[] = $col9;
						 }else{
						 	$col9 = new My_Pdf_Table_Column();
						 	$col9->setImage("../public/images/icons/regName.png",'left','top');
						 	$col9->setWidth(35);
						 	$cols[] = $col9;
						 }
		
		
						 $col7 = new My_Pdf_Table_Column();
						 $col7->setText($rows->bokstatusdesc,'left','top');
						 $col7->setWidth(70);
						 $cols[] = $col7;
						$col11 = new My_Pdf_Table_Column();
							$col11->setWidth(20);
							$col11->setText($rows->bktbtable_no_assigned);
							$cols[] = $col11;
						 $row->setColumns($cols);
						 $row->setFont($font, 8);
						 $row->setBorder(My_Pdf::TOP, new Zend_Pdf_Style());
						 $row->setBorder(My_Pdf::BOTTOM, new Zend_Pdf_Style());
						 $row->setBorder(My_Pdf::LEFT, new Zend_Pdf_Style());
						 $row->setCellPaddings(array(4,4,4,4));
						 $table->addRow($row);
					}else{
						$bokid = $rows->bokid;
						if($previd == $bokid){
							continue;
						}else{
							$previd = $rows->bokid;
							$row = new My_Pdf_Table_Row();
							$cols = array();
		
							$col = new My_Pdf_Table_Column();
							$col->setText($bokid,'left','top');
							$col->setWidth(30);
							$cols[] = $col;
		
							$col1 = new My_Pdf_Table_Column();
							$contDetails = '';
							$contDetails = $rows->bokfirst_name.' '.$rows->boklast_name;
							if($rows->boknotification_type == 'email'){
								$contDetails .= ' '.$rows->bokemail;
							}else if($rows->boknotification_type == 'sms'){
								$contDetails .= ' '.$rows->bokphone;
							}else if($rows->boknotification_type == 'both'){
								$contDetails .= ' '.$rows->bokemail." ".$rows->bokphone;
							}
							$col1->setText($contDetails,'left','top');
							$col1->setWidth(130);
							$cols[] = $col1;
				
							$col10 = new My_Pdf_Table_Column();
							if($rows->resvmode == "INAT"){
								$col10->setText($rows->resvDesc,'left','top');
								$col10->setWidth(50);
								$cols[] = $col10;
							}else if($rows->resvmode == "WIN"){
								$col10->setText($rows->resvDesc,'left','top');
								$col10->setWidth(50);
								$cols[] = $col10;
							}else if($rows->resvmode == "FB"){
								$col10->setText($rows->resvDesc,'left','top');
								$col10->setWidth(50);
								$cols[] = $col10;
							}else if($rows->resvmode == "PHN"){
								$col10->setText($rows->resvDesc,'left','top');
								$col10->setWidth(50);
								$cols[] = $col10;
							}else{
								$col10->setText($rows->resvDesc,'left','top');
								$col10->setWidth(50);
								$cols[] = $col10;
							}
		
							 $col3 = new My_Pdf_Table_Column();
							 $datetime = "";
							 $datetime = date("m-d-Y",strtotime($rows->bokbooking_date)).' '.date("h:i A",strtotime($rows->bokbooking_timings));
							 $col3->setText(trim($datetime),'left','top');
							 $col3->setWidth(60);
							 $cols[] = $col3;
			
							 $col8 = new My_Pdf_Table_Column();
							 $time = "";
							 $time = date("m-d-Y",strtotime($rows->bokbooking_made_on)).' '.date("h:i A",strtotime($rows->bokbooking_made_time));
							 $col8->setText(trim($time),'left','top');
							 $col8->setWidth(60);
							 $cols[] = $col8;
			
			
							 $col4 = new My_Pdf_Table_Column();
							 $col4->setText($rows->bokparty_size,'left','top');
							 $col4->setWidth(20);
							 $cols[] = $col4;
			
							$notes = "";	 
							if($rows->bokspecial_request != '' && $rows->bokrestaurant_note != ''){
								$notes = 'Guest Notes: '.$rows->bokspecial_request.' Restaurant Notes: '.$rows->bokrestaurant_note;
							}else if($rows->bokspecial_request != ''){
								$notes = 'Guest Notes: '.$rows->bokspecial_request;
							}else if($rows->bokrestaurant_note != ''){
								$notes = 'Restaurant Notes: '.$rows->bokrestaurant_note;
							}
							
							 $col6 = new My_Pdf_Table_Column();
							 $col6->setText($notes,'left','top');
							 $col6->setWidth(80);
							 $cols[] = $col6;
							
							 if($rows->resvmode == "INAT"){
							 	$col9 = new My_Pdf_Table_Column();
							 	if($companyid == 6){
								 	$col9->setImage("../public/images/icons/rndmenu.png",'left','top');
							 	}else{
							 		$col9->setImage("../public/images/icons/inat.png",'left','top');
							 	}
							 	$col9->setWidth(30);
							 	$cols[] = $col9;
							 }else if($rows->resvmode == "WIN"){
							 	$col9 = new My_Pdf_Table_Column();
							 	$col9->setImage("../public/images/icons/Walk.png",'left','top');
							 	$col9->setWidth(35);
							 	$cols[] = $col9;
							 }else if($rows->resvmode == "FB"){
							 	$col9 = new My_Pdf_Table_Column();
							 	$col9->setImage("../public/images/icons/fb.png",'left','top');
							 	$col9->setWidth(35);
							 	$cols[] = $col9;
							 }else if($rows->resvmode == "PHN"){
							 	$col9 = new My_Pdf_Table_Column();
							 	$col9->setImage("../public/images/icons/Mobile.png",'left','top');
							 	$col9->setWidth(35);
							 	$cols[] = $col9;
							 }else{
							 	$col9 = new My_Pdf_Table_Column();
							 	$col9->setImage("../public/images/icons/regName.png",'left','top');
							 	$col9->setWidth(35);
							 	$cols[] = $col9;
							 }
			
							 $col7 = new My_Pdf_Table_Column();
							 $col7->setText($rows->bokstatusdesc,'left','top');
							 $col7->setWidth(70);
							 $cols[] = $col7;
							$col11 = new My_Pdf_Table_Column();
							$col11->setWidth(20);
							$col11->setText($rows->bktbtable_no_assigned);
							$cols[] = $col11;

							 $row->setColumns($cols);
							 $row->setFont($font, 8);
							 $row->setBorder(My_Pdf::TOP, new Zend_Pdf_Style());
							 $row->setBorder(My_Pdf::BOTTOM, new Zend_Pdf_Style());
							 $row->setBorder(My_Pdf::LEFT, new Zend_Pdf_Style());
							 $row->setCellPaddings(array(4,4,4,4));
							 $table->addRow($row);
						}
					}					
				}
			}
			$page->addTable($table, -10, 40);
			$pdf->addPage($page);
			$pdf->save();

		}catch (Zend_Pdf_Exception $e) {
			die ('PDF error: ' . $e->getMessage());
		}catch (Exception $e) {
			die ('Application error: ' . $e->getMessage());
		}

	}

	/**
	 * function to retreive the count of the reservations
	 */
	public function getReservationsCount()
	{
		$bokMapper = new Reservation_Model_ReservationsCountDataMapper();
		$result = $bokMapper->retrieveBookingscount();
		return $result;

	}

	/**
	 * @param restaurant id
	 * function to retreive the state details of the restaurant using restaurant id
	 */
	public function getRestaurantStateByResId($resId)
	{
		try{
			$restService = new Application_Service_Firm();
			$stateId = $restService->getRestaurantStateByResId($resId);
			return $stateId;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * function to generate the reservations chart
	 */
	public function getIndexChart()
	{
		$mapper = new Reservation_Model_ReservationDataMapper();
		$times = $mapper->getCreatedTime();
		$graph = $this->GenerateChart($times);

	}

	/**
	 * @param times
	 * function to generate the chart of the reservations for each time slot
	 */
	public function GenerateChart($times)
	{
		$timesArr = array_keys($times);
		$valuesArr = array_values($times);
		$maxPax = "";
		foreach($valuesArr as $key=>$value){
			if($maxPax == ""){
				$maxPax = $value;
			}else{
				if($value > $maxPax){
					$maxPax = $value;
				}
			}
		}
		$DataSet = new Uss_Charts_pData();
		$DataSet->AddPoint($valuesArr,"Serie1");
		//$DataSet->AddPoint($valuesArr,"Serie2");
		$DataSet->AddPoint($timesArr,"Serie2");
		$DataSet->AddAllSeries();
		$DataSet->RemoveSerie("Serie2");
		$DataSet->SetAbsciseLabelSerie("Serie2");
		$DataSet->SetSerieName("Seats","Serie1");


		$Test = new Uss_Charts_pChart(450,300);
		$Test->drawGraphAreaGradient(255,255,255,50,TARGET_BACKGROUND);
		$Test->setFontProperties("Fonts/tahoma.ttf",8);
		$Test->setGraphArea(50,30,440,230);
		$Test->drawFilledRoundedRectangle(7,7,446,293,5,84,84,84);
		$Test->drawRoundedRectangle(5,5,448,295,5,0,0,0);
		$Test->drawGraphArea(255,255,255,FALSE);
		$Test->setFixedScale(0,$maxPax+20,10);
		$Test->drawScale($DataSet->GetData(),$DataSet->GetDataDescription(),SCALE_ADDALLSTART0,213,217,221,TRUE,90,0,TRUE);
		$Test->setColorPalette(0,92,51,23);
		$Test->drawGraphAreaGradient(255,255,204,50);
		$Test->drawGrid(4,TRUE,156,156,156,20);

		$Test->drawTreshold(0,0,0,0,TRUE,TRUE);
		// Draw the cubic curve graph
		$Test->drawCubicCurve($DataSet->GetData(),$DataSet->GetDataDescription());
			
		// Finish the graph
		$Test->setFontProperties("Fonts/tahoma.ttf",10);
		$Test->drawTitle(-100,22,"(Reservations taken at different hours of the day!)",250,250,250,585);
//		$Test->Render("images/report/ureservreport.png");
	}

	/**
	 * @param request
	 * function to retreive the freezed dates of the restaurant
	 */
	public function GetFreezedDates($request)
	{
		try{
			$resid = $request->restaurantid;
			$mapper = new Reservation_Model_RestaurantFreezeDataMapper();
			$freezedDates = $mapper->GetFreezedDates($resid);
			$Dates = array();
			foreach($freezedDates as $key=>$value){
				$dateSplit = explode('-',$value);
				$frzDate = implode('/',array($dateSplit[1],$dateSplit[2],$dateSplit[0]));
				$Dates[$key] = $frzDate;
			}
			return $Dates;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	
	public function GetFreezedDatesByMonth($request)
	{
		try{
			$resid = $request->restaurantid;
			$timezone = "";
			$mapper = new FirmManagement_Model_FirmDataMapper();
			$timezone = $mapper->GetRestaurantTimeZone($resid);
			date_default_timezone_set($timezone);
			$month = '';
			$year = '';
			if(isset($request->month)){
				$month = $request->month;
			}else{
				$month = date('m');
			}
			if(isset($request->year)){
				$year = $request->year;
			}else{
				$year = date('Y');
			}
			$startDate = $year.'-'.$month.'-1';
			$endDate = '';
			if($month <12){
				$month += 1;
				$endDate = $year.'-'.$month.'-1';
			}else{
				$year += 1;
				$endDate = $year.'-1-1';
			}
			$mapper = new Reservation_Model_RestaurantFreezeDataMapper();
			$freezedDates = $mapper->GetFreezedDatesByMonthRange($resid,$startDate,$endDate);
			$Dates = array();
			foreach($freezedDates as $key=>$value){
				$dateSplit = explode('-',$value);
				
//				if($month == $dateSplit[1] && $year == $dateSplit[0]){
					$frzDate = implode('/',array($dateSplit[1],$dateSplit[2],$dateSplit[0]));
					$Dates[$key] = $frzDate;
//				}
				
			}
			return $Dates;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param request
	 * function to retreive the dining layout using dining id
	 */
	public function GetLayoutByDiningId($request)
	{
		try{
			$resid = $request->restaurantid;
			$diningid = $request->diningid;

			$date = null;
			if(isset($request->date)){
				$date = $request->date;
			}else{
				$date = date('m-d-Y');
			}

			$mapper = new FirmManagement_Model_FirmTableDataMapper();
			$tableObj = new FirmManagement_Model_FirmTable();
			$tableObj->setResId($resid);
			$tableObj->setDiningId($diningid);
			$resultStr = $mapper->getRestaurantTable($tableObj);
			$result['finalStr'] = $resultStr['finalStr'];
			$result['etnStr']   = $resultStr['etnStr'];
			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			$bookMapper = new Reservation_Model_ReservationDataMapper();

			$getTableStatusObj = new Reservation_Model_GetTableStatus();
			$getTableStatusObj->setRestaurantId($resid);
			$getTableStatusObj->setDate($date);

			$bookStatus = array('ALC','DES','BOK','PTS','CRD');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$getTableStatusObj->setBookStatus($bookStatusRes);

			$tableStatus = $bookMapper->getTableStatus($getTableStatusObj);
			$tableArr = array();
			if($tableStatus){
				foreach($tableStatus as $table){
					$tableArr[$table->getboktableid()] = $table->getbokbooking_status_code();
				}
			}
			$result['TableStatus'] = $tableArr;

			$restFloorSep = new FirmManagement_Model_FirmFloorSeprator();
			$restFloorSep->setrfsfk_restaurant($resid);
			$restFloorSep->setrfsfk_restaurant_dining_area($diningid);	
			
			$resFloorSepMapper = new FirmManagement_Model_FirmFloorSepratorMapper();
			$floorSepArr = $resFloorSepMapper->retrieveFloorSeprators($restFloorSep);
			
			$result['FloorSep'] = $floorSepArr;  
			
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetLayoutByDiningIdMobile($request)
	{
		try{
			$resid = $request->restaurantid;
			$diningid = $request->diningid;

			$date = null;
			if(isset($request->date)){
				$date = $request->date;
			}else{
				$date = date('m-d-Y');
			}

			$mapper = new FirmManagement_Model_FirmTableDataMapper();
			$tableObj = new FirmManagement_Model_FirmTable();
			$tableObj->setResId($resid);
			$tableObj->setDiningId($diningid);
			$resultStr = $mapper->getRestaurantTable($tableObj);
//			$result['finalStr'] = $resultStr['finalStr'];
//			$result['etnStr']   = $resultStr['etnStr'];
			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			$bookMapper = new Reservation_Model_ReservationDataMapper();

			$getTableStatusObj = new Reservation_Model_GetTableStatus();
			$getTableStatusObj->setRestaurantId($resid);
			$getTableStatusObj->setDate($date);

			$bookStatus = array('ALC','DES','BOK','PTS','CRD','RSD','OVB','BKD','WAL');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$getTableStatusObj->setBookStatus($bookStatusRes);

			$tableStatus = $bookMapper->getTableStatus($getTableStatusObj);
			$tablesArrFinal = array();
			foreach($resultStr['finalStr'] as $row){
				if($row['number'] != 'PH'){
					$tablesArrFinal[$row['tableid']] = $row;
				}
			}
			$tableArr = array();
			if(count($tableStatus) > 0){
				$tablesArrkeys = array_keys($tablesArrFinal);
				foreach($tableStatus as $table){
					if(in_array($table->getboktableid(),$tablesArrkeys)){
						if($table->getbokbooking_status_code() == 'RSD' || $table->getbokbooking_status_code() == "OVB" || $table->getbokbooking_status_code() == "WAL"){
							array_push($tablesArrFinal[$table->getboktableid()],$table->getbokbooking_status_code());
						}else{
							unset($tablesArrFinal[$table->getboktableid()]);
						}
					}					
				}
			}
//			$result['TableStatus'] = $tableArr;

			$restFloorSep = new FirmManagement_Model_FirmFloorSeprator();
			$restFloorSep->setrfsfk_restaurant($resid);
			$restFloorSep->setrfsfk_restaurant_dining_area($diningid);	
			
			$resFloorSepMapper = new FirmManagement_Model_FirmFloorSepratorMapper();
			$floorSepArr = $resFloorSepMapper->retrieveFloorSeprators($restFloorSep);
			
			ksort($tablesArrFinal);  
			return $tablesArrFinal;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * @param request
	 * function to retreive all the no-show reservations of that day
	 */
	public function GetNoShowReservations($request)
	{
		try{
			$noshow = new Reservation_Model_GetNoShowList();
			$status = array('NOS');
			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($status);

			$noshow->setRestaurantId($request->restaurantid)
			->setBookStatus($bookStatusRes)
			->setDate($request->resdate)
			->setIsAjaxCall(true);
			$mapper = new Reservation_Model_ReservationDataMapper();
			$result = $mapper->GetNoShowReservation($noshow);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	/* Mobile functions start */
	public function getReservationsMobile($request)
	{
		try{
			$resId  = $request->restaurantid;
			$result = array();
			$date = null;
			$resServ = new Application_Service_Firm();
			$timeZone = $resServ->GetRestaurantTimeZone($resId);
			date_default_timezone_set($timeZone);
			if(isset($request->date)){
				$date = $request->date;
			}else{
				$date = date('Y-m-d');
			}
			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			$bookMapper = new Reservation_Model_ReservationDataMapper();

			/* Reteriving Attending list start */

			$getAttenListObj = new Reservation_Model_GetAttendingList();
			$getAttenListObj->setRestaurantId($resId);
			$getAttenListObj->setDate($date);
			$getAttenListObj->setIsAjaxCall(true);
			/* Reteriving Reservation Status Id */
			$bookStatus = array('DES','BOK','PTS','CRD','RSD','CAN','OVB','WRD','BIL');


			$getAttenListObj->setBookStatus($bookStatus);
			$attenListRes = array();
			$attenListRes = $bookMapper->ReservationListMobile($getAttenListObj);
			$result['AttendingList'] = $attenListRes;
			
			/* Reteriving Completed list start */

			/* Reteriving Booking Status Id */
			$bookStatus = array('COM','NOS');
			$getAttenListObj->setBookStatus($bookStatus);
			$CompletedListRes = array();
			$CompletedListRes = $bookMapper->ReservationListMobile($getAttenListObj);
			$result['CompletedList'] = $CompletedListRes;
			/* Reteriving Completed list end */
			return $result;

		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getResvReportMobile($request)
	{
		try{
			$resvReportObj = new Reservation_Model_GetReservationReport();
			$results = array();
			if($request){
			 $bookMapper = new Reservation_Model_ReservationDataMapper();
			 $resServ = new Application_Service_Firm();
			 $timeZone = $resServ->GetRestaurantTimeZone($request->restaurantid);
			 date_default_timezone_set($timeZone);
			 $date = "";
			 $resvReportObj->setRestaurantId($request->restaurantid);
			 if($request->bokstartdate && $request->bokenddate && $request->bokstartdate != "" && $request->bokenddate != ""){
			 	$resvReportObj->setBookStartDate($request->bokstartdate);
			 	$resvReportObj->setBookEndDate($request->bokenddate);
			 }else if($request->bokstartdate && $request->bokstartdate != ""){
			 	$resvReportObj->setBookStartDate($request->bokstartdate);
			 }else{
			 	$date = date('Y-m-d');
			 	$resvReportObj->setBookStartDate($date);
			 }
			 	
			 $bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			 if($request->reservstatus && $request->reservstatus != ""){
			 	$bookStatus = array();
			 	$bookStatus[] = $request->reservstatus;
			 	$resvReportObj->setBookStatus($bookStatus);
			 }else{

			 	$bookStatus = array('ALC','DES','BOK','PTS','CRD','RSD','COM');
			 	$resvReportObj->setBookStatus($bookStatus);
			 }
			 $rowSet = $bookMapper->ReservationReportMobile($resvReportObj);
			 $result['rowset']    = $rowSet;
			 $result['todaydate'] = $date;

			 return $result;
			}

		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getOverFlowBookMobile($request)
	{
		try{
			$resId  = $request->restaurantid;
			$result = array();
			$date = null;
			$resServ = new Application_Service_Firm();
			$timeZone = $resServ->GetRestaurantTimeZone($resId);
			date_default_timezone_set($timeZone);
			if(isset($request->date)){
				$date = $request->date;
			}else{
				$date = date('Y-m-d');
			}
			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			$bookMapper = new Reservation_Model_ReservationDataMapper();

			/* Reteriving Attending list start */

			$getAttenListObj = new Reservation_Model_GetAttendingList();
			$getAttenListObj->setRestaurantId($resId);
			$getAttenListObj->setDate($date);
			$getAttenListObj->setIsAjaxCall(true);
			/* Reteriving Reservation Status Id */
			$bookStatus = array('OVB');


			$getAttenListObj->setBookStatus($bookStatus);
			$attenListRes = array();
			$attenListRes = $bookMapper->ReservationListMobile($getAttenListObj);
			return $attenListRes;

		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getDatesBetweenDateRange($request)
	{
		try{

			$resId  = $request->restaurantid;
			$result = array();
			$todaysDate = null;
			$resServ = new Application_Service_Firm();
			$timeZone = $resServ->GetRestaurantTimeZone($resId);
			date_default_timezone_set($timeZone);
			if(isset($request->fromdate)){
				$todaysDate = $request->fromdate;
			}else{
				if(isset($request->datesfrom)){
					$date = date('Y-m-d');
					$dateSplit = explode('-',$date);
					$fromyear  = $dateSplit[0];
					$frommonth = $dateSplit[1]-1;
					$todaysDate = date('Y-m-d',mktime(0,0,0,$frommonth,1,$fromyear));
				}else{
					$todaysDate = date('Y-m-d');
				}
			}

			$splitDate = explode('-',$todaysDate);
			$year   = $splitDate[0];
			$month  = $splitDate[1];

			$toDate = date('Y-m-d',mktime(0,0,0,$month+3,0,$year));

			$todayDateTS = strtotime($todaysDate);
			$toDateTS	 = strtotime($toDate);
			$dateArray = array();

			for($currentDateTS = $todayDateTS; $currentDateTS <= $toDateTS; $currentDateTS+= (60 * 60 * 24)){

				$date = "";
				$date = date("Y-m-d",$currentDateTS);
				$dateSplit = explode('-',$date);
				$weekday = "";
				$weekday = date("D", mktime(0,0,0,$dateSplit[1],$dateSplit[2],$dateSplit[0]));
				$dateform = date("d M Y", mktime(0,0,0,$dateSplit[1],$dateSplit[2],$dateSplit[0]));
				$dateArray[date("Y-m-d",$currentDateTS)] = $dateform .' - '.$weekday;
			}
			return $dateArray;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getDatesBetweenDateRangeforwidget($request)
	{
		try{
			$resId  = $request->restid;
			
			$result = array();
			$todaysDate = null;
			$resServ = new Application_Service_Firm();
			$timeZone = $resServ->GetRestaurantTimeZone($resId);
			date_default_timezone_set($timeZone);
			
			$todaysDate = date('Y-m-d');

			$splitDate = explode('-',$todaysDate);
			$year   = $splitDate[0];
			$month  = $splitDate[1];

			$toDate = date('Y-m-d',mktime(0,0,0,$month+3,0,$year));

			$todayDateTS = strtotime($todaysDate);
			$toDateTS	 = strtotime($toDate);
			$dateArray = array();

			for($currentDateTS = $todayDateTS; $currentDateTS <= $toDateTS; $currentDateTS+= (60 * 60 * 24)){

				$date = "";
				$date = date("m-d-Y",$currentDateTS);
				$dateSplit = explode('-',$date);
				$weekday = "";
				$weekday = date("D", mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2]));
				$dateArray[date("m-d-Y",$currentDateTS)] = $date .' - '.$weekday;
			}
			return $dateArray;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function ChangeReservationStatusToRead($request)
	{
		try{
			if($request){
				$bookid = $request->bookid;
				$bookMapper = new Reservation_Model_ReservationDataMapper();
				/* get booking id with phraseid */
//				$phraseId = $bookMapper->GetBookingIdByBookPhrase($bookid);
				
				$result = $bookMapper->updateBookingStatusToRead($bookid);
				return $result;
			}

		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getBokStatus($request)
	{
		try{
			if($request){
				$bookid = $request->bookid;
				$bookMapper = new Reservation_Model_ReservationDataMapper();
				/* get booking id with phraseid */
//				$phraseId = $bookMapper->GetBookingIdByBookPhrase($bookid);
				
				$status = $bookMapper->getBokStatus($bookid);
				return $status;
			}

		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getBokPrasentStatus($request)
	{
		try{
			if($request){
				$bookid = $request->bookingid;
				$bookMapper = new Reservation_Model_ReservationDataMapper();
				/* get booking id with phraseid */
//				$phraseId = $bookMapper->GetBookingIdByBookPhrase($bookid);
				
				$status = $bookMapper->getBokPrasentStatus($bookid);
				return $status;
			}

		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getRestCustomerDetails($request)
	{
		try{
			$bookid = $request->bookid;
			$resid  = $request->resid;
			$mapper = new Reservation_Model_ReservationDataMapper();
			$bookingObj = new Reservation_Model_Reservation();
			/* get booking id with phraseid */
//			$phraseId = $mapper->GetBookingIdByBookPhrase($bookid);
			
			$bookingObj->setbokid($bookid);
			$bookingObj->setbokfk_restaurant($resid);
			
			$bokDetails = $mapper->getBookingDetails($bookingObj);
			
			/*$email = "";
			$mobile = "";
			if($bokDetails->getbokphone()){
				$mobile = $bokDetails->getbokphone();
			}
			if($bokDetails->getbokemail()){
				$email = $bokDetails->getbokemail();

			}*/
			$resservice = new Application_Service_Firm();
			$result = $resservice->getRestCustomerDetails($bokDetails,$resid);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getCusBokHistory($request)
	{
		try{
			$bookid = $request->bookid;
			$resid  = $request->resid;
			$bookingObj = new Reservation_Model_Reservation();
			$mapper = new Reservation_Model_ReservationDataMapper();
			/* get booking id with phraseid */
			$phraseId = $mapper->GetBookingIdByBookPhrase($bookid);
			
			$bookingObj->setbokid($phraseId);
			$bookingObj->setbokfk_restaurant($resid);
			
			$bokDetails = $mapper->getBookingDetails($bookingObj);
			/*$email = "";
			$mobile = "";
			$fname = "";
			$lname = "";
			if($bokDetails->getbokphone()){
				$mobile = $bokDetails->getbokphone();
			}
			if($bokDetails->getbokemail()){
				$email = $bokDetails->getbokemail();
			}

			if($bokDetails->getbokfirst_name()){
				$email = $bokDetails->getbokfirst_name();
			}
			if($bokDetails->getboklast_name()){
				$email = $bokDetails->getboklast_name();
			}*/
			$result = $mapper->getCusBokHistory($bokDetails);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getBokHistoryofCus($request)
	{
		try{
			$mapper = new Reservation_Model_ReservationDataMapper();
			$result = $mapper->getBokHistoryofCus($request);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getBokHistoryofCuspage($request,$offset)
	{
		try{
			$mapper = new Reservation_Model_ReservationDataMapper();
			$result = $mapper->getBokHistoryofCuspage($request,$offset);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function updateNotificationStatus($request)
	{
		try{
			$x = $request->from ;
			if($request->from == 'email'){
				$resservice = new Application_Service_Firm();
				$result = $resservice->ManageNotificationStatus($request);
			}else if($request->from == 'phone' || $request->from == 'sms'){
				$resservice = new Application_Service_Firm();
				$result = $resservice->ManageRestNotifyStatus($request);
			}else if($request->from == 'autoconfirm'){
				$resservice = new Application_Service_Firm();
				$result = $resservice->ManageAutoConfirmStatus($request);
			}
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function GetAutoConfirmStatusByResid($restid)
	{
		try{
			$mapper = new FirmManagement_Model_FirmDataMapper();
			$status = $mapper->GetAutoConfirmStatus($restid);
			return $status;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getCountByMealType($request)
	{
		try{
			$resid 		= $request->resid;
			$mealType 	= $request->mealtype;

			$resServ = new Application_Service_Firm();
			$timeZone = $resServ->GetRestaurantTimeZone($resid);
			date_default_timezone_set($timeZone);
			if($request->resdate){
				$split = explode('-',$request->resdate);
				$date = date('Y-m-d',mktime(0,0,0,$split[0],$split[1],$split[2]));
			}else{
				$date = date('Y-m-d');
			}
			$time = date('h:i A');
			$meal = new FirmManagement_Model_FirmMealType();

			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			$bookStatus = array('WAL','READY','QUOTE','BAR','NEXT','CANCUS','BACK','RSD','OVB');
			$abouttoSeat = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$bookStatus = array('ALC','DES','BOK','PTS','CRD');
			$seating = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$bookStatus = array('COM');
			$seated = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$mealMapper = new FirmManagement_Model_FirmMealTypeDataMapper();
			$mealStatus = array($mealType);
			$meal->setResId($resid)
			->setDate($date)
			->setMealType($mealType);

			$timeMeal = $mealMapper->GetRestaurantMealByType($meal);
			$bookMapper = new Reservation_Model_ReservationDataMapper();
			$result = array();
			if($timeMeal){
				$meal->setMealType($timeMeal->mealid)
				->setStartTime($timeMeal->rmt_start_time)
				->setEndTime($timeMeal->rmt_end_time)
				->setSeating($seating)
				->setAboutToSeat($abouttoSeat)
				->setSeated($seated);


				$mealCount = $bookMapper->getCountByMealType($meal);
				$result['mealCount'] = $mealCount;
				$mealResult = $mealMapper->GetRestaurantMealTypes($meal);
				$result['mealType'] = $mealResult;
			}
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function manageResMealType($request)
	{
		try{
			$resid 		= $request->resid;
			$resmeal	 	= $request->resmeal;
			$starttime	= $request->starttime;
			$endtime	= $request->endtime;

			$meal = new FirmManagement_Model_FirmMealType();
			$meal->setResId($resid)
			->setStartTime($starttime)
			->setEndTime($endtime);

			$mealMapper = new Application_Model_MealTypeDataMapper();
			$mealType = $mealMapper->GetMealTypeByCode(array($resmeal));
			$mealTyp = $mealType[$resmeal];
			$meal->setMealType($mealTyp->getId());

			$mapper = new FirmManagement_Model_FirmMealTypeDataMapper();
			$result = $mapper->AddRestaurantMealType($meal);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function addRestaurantMealType($request)
	{
		try{
			$resid 		= $request->resid;
			$timesArr	= json_decode($request->times);
			
			
			for($i= 0 ; $i < count($timesArr); $i++){
				foreach ($timesArr[$i] as $key=>$value){
					$meal = new FirmManagement_Model_FirmMealType();
					$meal->setResId($resid);
					if($key == 'BreakFast'){
						$mealMapper = new Application_Model_MealTypeDataMapper();
						$mealType = $mealMapper->GetMealTypeByCode(array('BRE'));
						$mealTyp = $mealType['BRE'];
						$meal->setMealType($mealTyp->getId());
					}else if($key == 'Lunch'){
						$mealMapper = new Application_Model_MealTypeDataMapper();
						$mealType = $mealMapper->GetMealTypeByCode(array('LUN'));
						$mealTyp = $mealType['LUN'];
						$meal->setMealType($mealTyp->getId());
					}else if($key == 'Brunch'){
						$mealMapper = new Application_Model_MealTypeDataMapper();
						$mealType = $mealMapper->GetMealTypeByCode(array('BRU'));
						$mealTyp = $mealType['BRU'];
						$meal->setMealType($mealTyp->getId());
					}else if($key == 'Dinner'){
						$mealMapper = new Application_Model_MealTypeDataMapper();
						$mealType = $mealMapper->GetMealTypeByCode(array('DIN'));
						$mealTyp = $mealType['DIN'];
						$meal->setMealType($mealTyp->getId());
					}
					$timeExplode = explode('_',$value);
					$meal->setStartTime($timeExplode[0])
						 ->setEndTime($timeExplode[1]);
						 
					$mapper = new FirmManagement_Model_FirmMealTypeDataMapper();
					$result = $mapper->AddRestaurantMealType($meal);
				}
			}
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function editResMealType($request)
	{
		try{
			$resid 		= $request->resid;
			$resmeal	= $request->resmeal;
			$starttime	= $request->starttime;
			$endtime	= $request->endtime;

			$meal = new FirmManagement_Model_FirmMealType();
			$meal->setResId($resid)
			->setStartTime($starttime)
			->setEndTime($endtime);


			$meal->setMealType($resmeal);

			$mapper = new FirmManagement_Model_FirmMealTypeDataMapper();
			$result = $mapper->EditRestaurantMealType($meal);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function UpdateMealStattus($request)
	{
		try{
			$resid 		= $request->resid;
			$resmeal	= $request->resmeal;
			$status 	= $request->status; 

			$meal = new FirmManagement_Model_FirmMealType();
			$meal->setResId($resid)
			->setStatus($status)
			->setId($resmeal);

			$mapper = new FirmManagement_Model_FirmMealTypeDataMapper();
			$result = $mapper->UpdateMealStattus($meal);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getMealDetailsByMealId($request)
	{
		try{
			$resid 		= $request->resid;
			$mealid		= $request->mealid;
			$meal = new FirmManagement_Model_FirmMealType();
			$meal->setResId($resid)
				 ->setId($mealid);

			$mapper = new FirmManagement_Model_FirmMealTypeDataMapper();
			$result = $mapper->getMealDetailsByMealId($meal);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getRestaurantMealTypes($request,$from = 'widget')
	{
		try{
			if(isset($request->resid)){
				$resid 		= $request->resid;
			}else if($request->where){
				$resid 		= $request->where;
			}else{
				$resid 		= $request->restid;
			}
			$meal = new FirmManagement_Model_FirmMealType();
			$meal->setResId($resid);
			$mapper = new FirmManagement_Model_FirmMealTypeDataMapper();
			$result = $mapper->GetRestaurantMealTypes($meal,$from);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function ChangeBokStatusByResponse($request)
	{
		try{
			$message 	= "";
			$recivedmsg = "";
			$bookId	 	= "";
			$flag 	 	= false;
			$smsmsgid  	= $request->ReferenceID;
			$msgMapper = new Communication_Model_SmsMessageMapper();
			$msgDetails = $msgMapper->getBookingIdBySmsId($smsmsgid);
			$bookId = $msgDetails->smsmsg_fk_bokid;
			$bookMapper = new Reservation_Model_ReservationDataMapper(); 
			
			/* get booking id with phraseid */
			//$phraseId = $bookMapper->GetBookingIdByBookPhrase($bookId);
			$phraseId = $bookId;
			
			/* Sms Message Saving Start */
			$priorMapper = new Application_Model_PriorityDataMapper();
			$prior = $priorMapper->GetPriorityByCode('H');
			$emailtypeMapper = new Application_Model_EmailTypeDataMapper();
			$emailType = $emailtypeMapper->GetEmailTypeByCode('ALERT');
			$smsmessage = new Communication_Model_SmsMessage();
			$msgPhrase = uniqid ();
			$title = 'Reply';
			
			/* Sms Message Saving End */
			
			$recivedmsg = strtoupper(trim($request->Message));
			if($bookId != "" && $recivedmsg!= ""){
				switch($recivedmsg){
					case 'BP':	$message = 'NEXT';
					$flag = true;
					break;
					case 'CB':	$message = 'BACK';
					$flag = true;
					break;
					case 'CL':	$message = 'CANCUS';
					$flag = true;
					break;
				}
				if($flag){
					$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
					$bookStatus 	  = $bookStatusMapper->GetBookingStatusByCode(array($message));
					$bookStatusObj 	  = $bookStatus[$message];
					$bokststusid 	  = $bookStatusObj->getId();
					$title = $bookStatusObj->getDescription();
					
					$smsmessage->setBokid($bookId)
						->setPhrase($msgPhrase)
						->setDescription(trim($request->Message))
						->setPriority($prior->getcode())
						->setSmstype($emailType->getcode())
						->setSentToUser('RES')
						->setSentFromUser('CUS')
						->setSentby($msgDetails->smsmsg_sentto)
						->setSentTo($msgDetails->smsmsg_sentby)
						->setTitle($title)
						->setReference($smsmsgid);
			
					$msgid = $msgMapper->SaveMessageDetails($smsmessage);

					$changeTableStatusObj  = new Reservation_Model_AllocateSeat();
					$changeTableStatusObj->setBookId($phraseId );
					$changeTableStatusObj->setBookStatus($bookStatusObj->getId());
					$changeTableStatusObj->setBookStatusCode($bookStatusObj->getCode());
					
					$bookingObj = new Reservation_Model_Reservation();
					$bookingObj->setbokid($phraseId);
					
					
					$bookDetails = $bookMapper->getBookingDetails($bookingObj);
					$changeTableStatusObj->setRestId($bookDetails->getbokfk_restaurant());
					if($bookDetails->getbokbooking_status_code() == 'READY'){
						$Status = $bookMapper->ChangeTableStatus($changeTableStatusObj);
					}
				}else{
					$bookingObj = new Reservation_Model_Reservation();
					$bookingObj->setbokid($phraseId);
					$bookingObj->setbokspecial_request(trim($request->Message));

					$bookMapper = new Reservation_Model_ReservationDataMapper();
					$bookMapper->UpdateBookingGuestNotes($bookingObj);
					$bookDetails = $bookMapper->getBookingDetails($bookingObj);

					$GroupUserObj = new FirmManagement_Model_FirmGroupUsers();
					$GroupUserObj->setEmail($bookDetails->getbokemail());
					$GroupUserObj->setPhone($bookDetails->getbokphone());
					$GroupUserObj->setSplRequest($bookDetails->getbokspecial_request());
					$GroupUserObj->setRestaurantId($bookDetails->getbokfk_restaurant());

					$GroupUserMapper = new FirmManagement_Model_FirmGroupUsersDataMapper();
					$Status = $GroupUserMapper->UpdateUserGustNotes($GroupUserObj);
				}
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function CustomerKioskReservation(array $data,$userid,$stateId,$cityId,$regionId)
	{
		try{
			$form = $this->getWaitingKioskReservForm();
			$resultarray = array();
//			if($data['waitnotificationType'] == 'sms'){
//				$form->waitnumber->setRequired(true);
//				$form->waitemail->setRequired(false);
//			}else if($data['waitnotificationType'] == 'email'){
//				$form->waitnumber->setRequired(false);
//				$form->waitemail->setRequired(true);
//			}else if($data['waitnotificationType'] == 'both'){
//				$form->waitnumber->setRequired(true);
//				$form->waitemail->setRequired(true);
//			}
      
			if($form->isValid($data)){
				$formData = $form->getValues();
        
				$bookTypeMapper = new Application_Model_ReservationTypeDataMapper();
				$bookType = $bookTypeMapper->GetBookingTypeByCode('NOR');
        //echo '<pre>'; print_r($formData); exit;
				$statusCode = array();
				if($data['waitbookingStatus'] && $data['waitrescheduleStatus']){
					$statusCode[] = $data['waitbookingStatus'];
					$statusCode[] = $data['waitrescheduleStatus'];
				}else{
					$statusCode[] = $data['waitbookingStatus'];
				}
				$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
				$bookStatus 	  = $bookStatusMapper->GetBookingStatusByCode($statusCode);
				$bookStatusObj 	  = $bookStatus[$data['waitbookingStatus']];
				$resStatusObj = null;
				if(isset($bookStatus[$data['waitrescheduleStatus']])){
					$resStatusObj = $bookStatus[$data['waitrescheduleStatus']];
				}
        
				$resModeMapper = new Application_Model_ReservationModeDataMapper();
				$rescode = $formData['waitorigin'];
				$resModeStatus 	  = $resModeMapper->GetReservationModeByCode(array($rescode));
				$resModeObj 	  = $resModeStatus[$rescode];

				$waitingquoteMapper = new Application_Model_WaitingQuoteTimeDataMapper();
				$quotecode = explode(' ',$formData['quotedTime']);
        if($quotecode[0] == 'f'){$quotecode[0] = 5;}
				$quoteStatus 	  = $waitingquoteMapper->GetQuoteTimeByCode(array($quotecode[0]));
        //echo '<pre>'; print_r($quoteStatus); exit;
				$quoteObj 	  = $quoteStatus[$quotecode[0]];
        
				$mapper = new Reservation_Model_ReservationDataMapper();
				$dinerDetails = new Reservation_Model_Reservation();

				$dinerDetails->setbokfk_restaurant($formData['restaurantid']);
				$dinerDetails->setbokparty_size($formData['waitpax']);
				$dinerDetails->setbokbooking_status_id($bookStatusObj->getId());
				$dinerDetails->setbokbooking_status_code($bookStatusObj->getCode());
				$dinerDetails->setbokbooking_status($bookStatusObj->getId());
				$dinerDetails->setbokfirst_name($formData['waitfirstName']);
				$dinerDetails->setboklast_name($formData['waitlastName']);
				$dinerDetails->setbokphone($formData['waitnumber']);
				$dinerDetails->setbokcountry_code($formData['countryCode']);
				$dinerDetails->setbokemail('');
				$dinerDetails->setbokrestaurant_note($formData['waitdinerRequest']);
        
				$dinerDetails->setQuotedTime($quoteObj->getId());
        
				if($formData['waitnumber']){
					$dinerDetails->setNotificationType('sms');
				}
				$resServ = new Application_Service_Firm();
        
				$timeZone = $resServ->GetRestaurantTimeZone($formData['restaurantid']);
				date_default_timezone_set($timeZone);
        
				$dinerDetails->setbokbooking_made_on(date('Y-m-d H:i:s'));
				$dinerDetails->setBookingMadeTime(date("H:i",time()));
				$dinerDetails->setbokbooking_date($formData['waitresDate']);
				$dinerDetails->setbokbooking_timings(date('g:i A'));

				$bookPhrase = uniqid ();
				$dinerDetails->setbokbookingphrase($bookPhrase);
				
				$dinerDetails->setbokuserid($userid);
				$dinerDetails->setbokspecial_request($formData['waitcontactInfo']);
				$dinerDetails->setbokbooking_type_id($bookType->getId());
				$dinerDetails->setbokreservation_mode_id($resModeObj->getId());
				$dinerDetails->setTableSize($formData['waittableSize']);
				$dinerDetails->setNoOfTables($formData['waitnoOfTables']);
				$dinerDetails->setInventoryId($formData['waitinventoryid']);
				//$dinerDetails->setNotificationType($formData['waitnotificationType']);
				$dinerDetails->setbokid($formData['bookingid']);
        

				if($formData['waitrescheduleStatus']){
					$dinerDetails->setRescheduleCode($formData['waitrescheduleStatus']);
				}
				if($resStatusObj){
					$dinerDetails->setRessch_Status_Id($resStatusObj->getId());
				}
        //echo '<pre>'; print_r($formData); exit;
				$result = $mapper->saveMakeReservationDetails($dinerDetails,'waiting', $formData);
        
				$dinerDetails->setbokid($result);
				$mailmapper = new Application_Service_Communication();
				$restService = new Application_Service_Firm();
				$restResult = $restService->GetRestaurantDetailsById($formData['restaurantid']);
//				//if($formData['waitnotificationType'] == 'email'){
//					//$mailObj = new Communication_Model_Mail();
//					//if($formData['notificationType'] == 'email'){
//					//$mailObj->setMsgCode('WaitReserv');
//					//if($stateId == ""){
//						//$stateCity = $this->getRestaurantStateByResId($formData['restaurantid']);
//						//$stateId = $stateCity['state'];
//						//$cityId = $stateCity['city'];
//						//$regionId = $stateCity['region'];
//
//					//}
//					//$userType = 'CUS';
//					//$adminService = new Application_Service_Administrator();
//					//$campProp = new Application_Model_GetCampaignForPost();
//					//$campProp->setAudType($userType)
//					//->setStateId($stateId)
//					//->setCityId($cityId)
//					//->setRegionId($regionId)
//					//->setIsAjaxCall(false);
//					//$campDetails = $adminService->GetCampaignDetails($campProp);
//
//					//$name = $formData['waitfirstName'].' '.$formData['waitlastName'];
//					//$data = array('UserName' => $name,
//							  //'SenTo'    => $formData['waitemail'],
//							  //'RestName' => $restResult->resrestaurant_name,
//							  //'ResDate'  => $formData['waitresDate'],
//							  //'Time'     => $formData['waitresTime'],
//							  //'Size'     => $formData['waitpax'],
//							  //'Address'	 => $restResult->resaddress,
//							  //'resphone' => $restResult->resphone,
//							  //'ResEmail' =>	$restResult->resemail,
//							  //'QuoteTime'=> $quoteObj->getDescription(),
//							  //'Bokid'	 =>	$result,
//							  //'State_Id' =>	$stateId,
//							  //'City_Id'	 =>	$cityId,
//							  //'UserType' =>	$userType
//					//);
//					if(count($campDetails)){
//						//$count = count($campDetails);
//						//if($count > 1){
//							$campaign = $campDetails[rand(0,$count-1)];
//						}else{
//							$campaign = $campDetails[0];
//						}
//						$notfService = new Application_Service_Communication();
//						$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
//						$data['campaignName'] = trim($campaign->getSponsor());
//						$data['campaignDesc'] =	trim($campaign->getCampDesc());
//						$data['campaignImg'] =	trim($campaign->getCampImage());
//						$data['campId']	= $campaign->getId();
//					}
//
//					$mailObj->setData($data);
//					//$mailStatus = $mailmapper->SendMail($mailObj);
//				}else
        
				if($formData['waitnumber'] != ''){
					$name = $formData['waitfirstName'].' '.$formData['waitlastName'];
					$custMsg = '';
					$custMsg = 'Hi '.$name.', we have put your reservation in waiting, please wait for '.$quoteObj->getDescription().'. '.$restResult->resrestaurant_name;
					$smsObj = new Communication_Model_Sms();
					$smsObj->setMsgCode('WaitingReserv');
					$data = array(
									'to'			=>	trim($formData['waitnumber']),
									'countrycode'	=> $formData['countryCode'],
									'RestName' 		=> $restResult->resrestaurant_name,
									'UserName'		=> $name,
									'Quote'			=> $quoteObj->getDescription(),
									'BookId'		=> $result
					);
					$smsObj->setData($data);
           //echo '<pre>'; print_r($data); exit; 
					$mailStatus = $mailmapper->SendSms($smsObj);
				}
//				else if($formData['waitnotificationType'] == 'both'){
//					$name = $formData['waitfirstName'].' '.$formData['waitlastName'];
//					$custMsg = '';
//					$custMsg = 'Hi '.$name.', we have put your reservation in waiting, please wait for '.$quoteObj->getDescription().'. '.$restResult->resrestaurant_name;
//					$smsObj = new Communication_Model_Sms();
//					$smsObj->setMsgCode('WaitingReserv');
//					$data = array(
//									'to'			=>	trim($formData['waitnumber']),
//									'RestName' 		=> $restResult->resrestaurant_name,
//									'UserName'		=> $name,
//									'Quote'			=> $quoteObj->getDescription(),
//									'BookId'		=> $result
//					);
//					$smsObj->setData($data);
//					$mailStatus = $mailmapper->SendSms($smsObj);
//
//					$mailObj = new Communication_Model_Mail();
//					//if($formData['notificationType'] == 'email'){
//					$mailObj->setMsgCode('WaitReserv');
//					if($stateId == ""){
//						$stateCity = $this->getRestaurantStateByResId($formData['restaurantid']);
//						$stateId = $stateCity['state'];
//						$cityId = $stateCity['city'];
//						$regionId = $stateCity['region'];
//
//					}
//					$userType = 'CUS';
//					$adminService = new Application_Service_Administrator();
//					$campProp = new Application_Model_GetCampaignForPost();
//					$campProp->setAudType($userType)
//					->setStateId($stateId)
//					->setCityId($cityId)
//					->setRegionId($regionId)
//					->setIsAjaxCall(false);
//					$campDetails = $adminService->GetCampaignDetails($campProp);
//
//					$name = $formData['waitfirstName'].' '.$formData['waitlastName'];
//					$data = array('UserName' => $name,
//							  'SenTo'    => $formData['waitemail'],
//							  'RestName' => $restResult->resrestaurant_name,
//							  'ResDate'  => $formData['waitresDate'],
//							  'Time'     => $formData['waitresTime'],
//							  'Size'     => $formData['waitpax'],
//							  'Address'	 => $restResult->resaddress,
//							  'resphone' => $restResult->resphone,
//							  'ResEmail' =>	$restResult->resemail,
//							  'QuoteTime'=> $quoteObj->getDescription(),
//							  'Bokid'	 =>	$result,
//							  'State_Id' =>	$stateId,
//							  'City_Id'	 =>	$cityId,
//							  'UserType' =>	$userType
//					);
//					if(count($campDetails)){
//						$count = count($campDetails);
//						if($count > 1){
//							$campaign = $campDetails[rand(0,$count-1)];
//						}else{
//							$campaign = $campDetails[0];
//						}
//						$notfService = new Application_Service_Communication();
//						$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
//						$data['campaignName'] = trim($campaign->getSponsor());
//						$data['campaignDesc'] =	trim($campaign->getCampDesc());
//						$data['campaignImg'] =	trim($campaign->getCampImage());
//						$data['campId']	= $campaign->getId();
//					}
//
//					$mailObj->setData($data);
//					//$mailStatus = $mailmapper->SendMail($mailObj);
//				}
        //echo '<pre>'; print_r($restResult); exit; 
				if($result)
				{
					$restservice = new Application_Service_Firm();
					$restservice->AddWaitingCustomerContact($formData);
				}
				$resultarray['status'] = true;
				$form->populate($data);
				$resultarray['result'] = $bookPhrase;
			}else{
				$resultarray['status'] = false;
				$form->populate($data);
				$resultarray['Form'] = $form;
			}
			return $resultarray;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetCustomerKioskDetails($request)
	{
		try{
			$bokid = '';
			$bookMapper = new Reservation_Model_ReservationDataMapper();
			if(isset($request->bokid)){
				/* get booking id with phraseid */
				$phraseId = $bookMapper->GetBookingIdByBookPhrase($request->bokid);
				
				$bokid = $phraseId;
			}
			$resId = $request->restaurantid;
			$date = $request->date;
			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			
			$getWaitingList = new Reservation_Model_GetWaitingList();
			$getWaitingList->setRestaurantId($resId);
			$getWaitingList->setDate($date);
			if($bokid){
				$getWaitingList->setBookingId($bokid);
			}
			if(isset($request->ajaxcall)){
				$getWaitingList->setIsAjaxCall(true);
			}else{
				$getWaitingList->setIsAjaxCall(false);
			}

			/* Reteriving booking status id by code */
			$status = array();

			$bookStatus = array('WAL','READY','QUOTE','BAR','NEXT','CANCUS','BACK');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
			$getWaitingList->setBookStatus($bookStatusRes);
			$waitingListRes = $bookMapper->getWaitingList($getWaitingList);
			return $waitingListRes;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	} 
	
	public function ManageWaitQuoteSettings(array $data,$request)
	{
		try{
			$operation = $request->frmStat;
			$resultarray = array();
			$form = $this->getQuoteTimeSettingsForm();
			if($data['quoteType'] == 'Fixed'){
				$form->quoteType->setRequired(true);
				$form->quotedTime->setRequired(true);
				$form->restaurantid->setRequired(true);
				$form->startpax->setRequired(false);
				$form->endpax->setRequired(false);
			}else if($data['quoteType'] == 'Variable'){
				$form->quoteType->setRequired(true);
				$form->quotedTime->setRequired(true);
				$form->restaurantid->setRequired(true);
				$form->startpax->setRequired(true);
				$form->endpax->setRequired(true);
			}
			switch($operation){
				case 'Add':
					if($form->isValid($data)){
						$formData = $form->getValues();
						if($formData['quoteType'] == 'Fixed'){
							$restaurantquoteMapper = new Reservation_Model_RestaurantQuoteSettingsDataMapper();
							$quoteType = new Reservation_Model_RestaurantQuoteSettings();
							$quoteType->setQuoteType($formData['quoteType'])
									  ->setQuoteTime($formData['quotedTime'])
									  ->setRestId($formData['restaurantid'])
									  ->setStatus('T');
							$result = $restaurantquoteMapper->AddRestaurantQuote($quoteType);
						}else if($formData['quoteType'] == 'Variable'){
							$restaurantquoteMapper = new Reservation_Model_RestaurantQuoteTimeSettingsDataMapper();
							$quoteTimeType = new Reservation_Model_RestaurantQuoteTimeSettings();
							$quoteTimeType->setQuoteType($formData['quoteType'])
									  ->setStartPax($formData['startpax'])
									  ->setEndPax($formData['endpax'])
									  ->setQuoteTime($formData['quotedTime'])
									  ->setRestId($formData['restaurantid'])
									  ->setStatus('T');
							$result = $restaurantquoteMapper->AddRestaurantQuoteAndTime($quoteTimeType);
						}
						if($result['status']){
							$resultarray['status'] = true;
							$resultarray['msgstatus'] = false;
							$resultarray['result'] = $result['result'];
						}else{
							$resultarray['status'] = true;
							$resultarray['msgstatus'] = true;
							$form->populate($data);
							$resultarray['Form'] = $form;
							$resultarray['result'] = $result['msg'];
						}						
					}else{
						$resultarray['status'] = false;
						$form->populate($data);
						$resultarray['Form'] = $form;
					}
					return $resultarray;
					break;
				case 'Edit':
					if($form->isValid($data)){
						$formData = $form->getValues();
						if($formData['quoteType'] == 'Fixed'){
							$restaurantquoteMapper = new Reservation_Model_RestaurantQuoteSettingsDataMapper();
							$quoteType = new Reservation_Model_RestaurantQuoteSettings();
							$quoteType->setId($formData['id'])
									  ->setQuoteType($formData['quoteType'])
									  ->setQuoteTime($formData['quotedTime'])
									  ->setRestId($formData['restaurantid'])
									  ->setStatus('T');
							$result = $restaurantquoteMapper->UpdateRestaurantQuote($quoteType);
						}else if($formData['quoteType'] == 'Variable'){
							$restaurantquoteMapper = new Reservation_Model_RestaurantQuoteTimeSettingsDataMapper();
							$quoteTimeType = new Reservation_Model_RestaurantQuoteTimeSettings();
							$quoteTimeType->setId($formData['id'])
										  ->setQuoteType($formData['quoteType'])
										  ->setStartPax($formData['startpax'])
										  ->setEndPax($formData['endpax'])
										  ->setQuoteTime($formData['quotedTime'])
										  ->setRestId($formData['restaurantid'])
										  ->setStatus('T');
							$result = $restaurantquoteMapper->UpdateRestaurantQuoteAndTime($quoteTimeType);
						}
						if($result['status']){
							$resultarray['status'] = true;
							$resultarray['msgstatus'] = false;
							$resultarray['result'] = $result['result'];
						}else{
							$resultarray['status'] = true;
							$resultarray['msgstatus'] = true;
							$form->populate($data);
							$resultarray['Form'] = $form;
							$resultarray['result'] = $result['msg'];
						}
					}else{
						$resultarray['status'] = false;
						$form->populate($data);
						$resultarray['Form'] = $form;
					}
					return $resultarray;
					break;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function reteriveWaitingreservationQuoteTimes($request,$reqType = '')
	{
		try{
			$quoteSettingsDataMapper = new Reservation_Model_RestaurantQuoteSettingsDataMapper();
			$result = $quoteSettingsDataMapper->GetQuoteTimings($request->restaurantid,$reqType);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}		
	}
	
	public function CheckKioskSettings($request)
	{
		try{
			$quoteSettingsDataMapper = new Reservation_Model_RestaurantQuoteSettingsDataMapper();
			$result = $quoteSettingsDataMapper->CheckQuoteTimeSettings($request->restaurantid,$request->waitpax);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function CheckKioskSettingsOnLoad($resid,$pax)
	{
		try{
			$quoteSettingsDataMapper = new Reservation_Model_RestaurantQuoteSettingsDataMapper();
			$result = $quoteSettingsDataMapper->CheckQuoteTimeSettings($resid,$pax);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetRestInfo($request)
	{
		try{
			$bookMapper = new Reservation_Model_ReservationDataMapper();
			$restinfo   = $bookMapper->GetRestaurantLogo($request->restaurantid);
			return $restinfo;			
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}	
	}
	
	public function changeBokConfirmStatus($request)
	{
		try{
			$bookMapper = new Reservation_Model_ReservationDataMapper();
			$status = $request->bokconfirmstatus;
			$bookid = $request->bookid;
			if($status == 'deny'){
				$bookingObj = new Reservation_Model_Reservation();
				
				/* get booking id with phraseid */
				
				$bookingObj->setbokid($bookid);
				$restid = $bookMapper->getRestIdByBookId($bookid);
				$bookingObj->setbokfk_restaurant($restid);
				
				$bokDetails = $bookMapper->getBookingDetails($bookingObj);
				$bookStatus = false;
				if($bokDetails->getbokbooking_status_code() == 'RSD' || $bokDetails->getbokbooking_status_code() == 'WAL'){
					$bookStatus = $bookMapper->CancelCusResvByBookingId($bookingObj);				
				}
				return true;
			}else{				
				$result = $bookMapper->changeBokConfirmStatus($bookid,$status);
				return $result;
			}
			
			
			
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}	
	}
	
	public function ManageCheckedInResv($request)
	{
		try{
			$bookMapper = new Reservation_Model_ReservationDataMapper();
			/* get booking id with phraseid */
//			$phraseId = $bookMapper->GetBookingIdByBookPhrase($request->bookid);
			
			$bookid = $request->bookid;
			$status = $request->status;
			$result = $bookMapper->ManageCheckedInResv($bookid,$status);
			return $result;
			
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}	
	}
	
	public function ManageAllArrivedResv($request)
	{
		try{
			$bookMapper = new Reservation_Model_ReservationDataMapper();
			/* get booking id with phraseid */
//			$phraseId = $bookMapper->GetBookingIdByBookPhrase($request->bookid);
			
			$bookid = $request->bookid;
			$status = $request->status;
			$result = $bookMapper->ManageAllArrivedResv($bookid,$status);
			return $result;
			
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}	
	}
	
	public function ManagePartialArrivedResv($request)
	{
		try{
			$bookMapper = new Reservation_Model_ReservationDataMapper();
			/* get booking id with phraseid */
//			$phraseId = $bookMapper->GetBookingIdByBookPhrase($request->bookid);
			
			$bookid = $request->bookid;
			$status = $request->status;
			$result = $bookMapper->ManagePartialArrivedResv($bookid,$status);
			return $result;
			
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}	
	}
	
	public function ManageRunningLateResv($request)
	{
		try{
			$bookMapper = new Reservation_Model_ReservationDataMapper();
			/* get booking id with phraseid */
//			$phraseId = $bookMapper->GetBookingIdByBookPhrase($request->bookid);
			
			$bookid = $request->bookid;
			$status = $request->status;
			$userid = $request->userid;
			if(isset($userid))
			{
				$result = $bookMapper->ManageRunningLateResv($bookid,$status,$userid);
			}
			else
			{
				$result = $bookMapper->ManageRunningLateResv($bookid,$status);
			}
			return $result;
			
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}	
	}
	public function ClearReservationStatus($request)
	{
		try{
			$bookMapper = new Reservation_Model_ReservationDataMapper();
			/* get booking id with phraseid */
//			$phraseId = $bookMapper->GetBookingIdByBookPhrase($request->bookid);
			
			$bookid = $request->bookid;
			$result = $bookMapper->ClearReservationStatus($bookid);
			return $result;
			
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}	
	}
	public function GetReservationsForChitsAndDupes($request)
	{
		try{
			
			$resId  = $request->restaurantid;
			$result = array();
			$date = null;
			$datStat = "";
			$resServ = new Application_Service_Firm();
			$timeZone = $resServ->GetRestaurantTimeZone($resId);
			date_default_timezone_set($timeZone);
			
			if(isset($request->date)){
				$date = $request->date;				
			}else{
				$date = date('Y-m-d');
			}
			
			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			$bookMapper = new Reservation_Model_ReservationDataMapper();
			
			$ReservChitsAndDupes = new Reservation_Model_ReservationsChitsAndDupes();
			$ReservChitsAndDupes->setRestaurantId($resId);
			$ReservChitsAndDupes->setDate($date);

			/* Reteriving Reservation Status Id */
			$bookStatus = array('ALC','DES','BOK','PTS','CRD','RSD','OVB','WRD','BIL');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$ReservChitsAndDupes->setBookStatus($bookStatusRes);
			$result = $bookMapper->RetrieveReservationsForChitsAndDupes($ReservChitsAndDupes);

			return $result;
			
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function zendpdf($request)
	{
		try{
			
			$pdf = new Zend_Pdf();
			$rest_result = $this->GetReservationsForChitsAndDupes($request); 
			$resId  = $request->restaurantid;
				$result = array();
				$date = null;
				$datStat = "";
			$resServ = new Application_Service_Firm();
			$timeZone = $resServ->GetRestaurantTimeZone($resId);
			date_default_timezone_set($timeZone);
			if(isset($request->date)){
//				$tSel = explode('-',$request->date);
//				$date = date("d M Y",mktime(0,0,0,$tSel[0],$tSel[1],$tSel[2]));
				$date = $request->date;
			}else{
				$date = date('d-M-Y');
			}
			if($rest_result){
				//------------------------------------------------------------------------
				// Reverse page order
				$pdf->pages = array_reverse($pdf->pages);
				 
				// Create new Style
				$style = new Zend_Pdf_Style();
				$style->setFillColor(new Zend_Pdf_Color_Rgb(0, 0, 0.9));
				$style->setLineColor(new Zend_Pdf_Color_GrayScale(0.2));
				$style->setLineWidth(3);
				$style->setLineDashingPattern(array(3, 2, 3, 4), 1.6);
				$fontH = Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_HELVETICA_BOLD);
				$style->setFont($fontH, 32);
				 
				try {
				    // Create new image object
				    $imageFile = '../public/images/logo.png';
				    $stampImage = Zend_Pdf_Image::imageWithPath($imageFile);
				} catch (Zend_Pdf_Exception $e) {
				    // Example of operating with image loading exceptions.
				    if ($e->getMessage() != 'Image extension is not installed.' &&
				        $e->getMessage() != 'JPG support is not configured properly.') {
				        throw $e;
				    }
				    $stampImage = null;
				}
				 
			    $page_break_status = false;
			    $page_no = 1;
				for($i = 0;$i<count($rest_result);$i++){
					$reservationList = $rest_result[$i];
					// Add new page generated by Zend_Pdf object
					// (page is attached to the specified the document)
					if($i == 0){
						$pdf->pages[] = (${'page_'.$page_no} = $pdf->newPage('A4'));
						 
						// Add new page generated by Zend_Pdf_Page object
						foreach ($pdf->pages as $page){
						 
						    $page->saveGS()
						         ->setAlpha(0.85)
						         ->setStyle($style);
						         
							 $page->drawImage($stampImage, 20, 790, 100, 810);
						    $page->restoreGS();
						}
						// Create new font
						$font = Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_HELVETICA);
						$font1 = Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_HELVETICA); 
						// Apply font and draw text
					}else if($page_break_status){
						$page_break_status = false;
						$status_y_end = 748+40;
						$status_2_y_end = 748+40;
						$pdf->pages[] = (${'page_'.$page_no} = $pdf->newPage('A4'));
						 
						foreach ($pdf->pages as $page){
						 
						    $page->saveGS()
						         ->setAlpha(0.85)
						         ->setStyle($style);
						         
						 	$page->drawImage($stampImage, 20, 790, 100, 810);
						    $page->restoreGS();
						}
						// Create new font
						$font = Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_HELVETICA);
						$font1 = Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_HELVETICA); 
					}
					//chit_1_1_x => first chit line 1 and x axis
					$pdfHelper = new Uss_Helper_ChitsPdfHelper();
						
					$chit1_x = 25;
					$chit2_x = 300;
					$chit1_x_border = 280;
					$chit2_x_border = 560;
					$chit1_y = 748;		
					$chit2_y = 748;
					$font_size = 10;
					
					$server_text = 'Server:';
					$res_notes_text = 'Res Notes:';
					$res_codes_text = 'Res Codes:';
					$guest_notes_text = 'Guest Notes    :';
					$reserv_notes_text = 'Reserv Notes  :';
					$allergies_text = 'Allergies          :';
					
					$server_text_width = $pdfHelper->getTextWidth($server_text, ${'page_'.$page_no}->getFont(), $font_size-2);
					$res_notes_text_width = $pdfHelper->getTextWidth($res_notes_text, ${'page_'.$page_no}->getFont(), $font_size-2);
					$res_codes_text_width = $pdfHelper->getTextWidth($res_codes_text, ${'page_'.$page_no}->getFont(), $font_size-2);
					$guest_notes_text_width = $pdfHelper->getTextWidth($guest_notes_text, ${'page_'.$page_no}->getFont(), $font_size-2);
					$reserv_notes_text_width = $pdfHelper->getTextWidth($reserv_notes_text, ${'page_'.$page_no}->getFont(), $font_size-2);
					$allergies_text_width = $pdfHelper->getTextWidth($allergies_text, ${'page_'.$page_no}->getFont(), $font_size-2);
					
					if($reservationList['servername']){
						$serverName = $reservationList['servername'];
					}else{
						$serverName = $reservationList['Tableservername'];
					}
					
					${'page_'.$page_no}->setLineWidth(0.5)
						  ->setLineColor(Zend_Pdf_Color_Html::color('#EDEDED'))
				    	  ->drawLine($chit2_x-20, 30, $chit1_x_border, $chit2_y+30);
				    	  
					if($i % 2 == 0){
						if($i == 0){
							$chit1_y = 748-($i * 150);
						}else{
							$chit1_y = $status_y_end - 40;
						}
						/* ------------------------------------------ */
						$expected_chit_y_start = $chit1_y;
						$expected_chit_y_end = $chit1_y;
						$expected_text_y_start =  $chit1_y-60;
						$expected_text_height = 60;
						$labelArr = array($server_text_width,$res_notes_text_width,$res_codes_text_width,$guest_notes_text_width,$reserv_notes_text_width,$allergies_text_width);     
						$valArr = array('1'=>'bokrestaurant_note','2'=>'bokresmodedesc','3'=>'bokspecial_request','5'=>'bokphone');
						$expected_text_y_end = $expected_text_y_start;
						for($k = 0;$k<6;$k++){
	//						$x = $reservationList[$valArr[$k]];
							if($k == 0 || $k == 4){
								$expected_text_y_end -= 10;
							 	$expected_text_height += 10;
								continue;
							}
							$expected_text_limit = ($chit1_x_border - 10) - ($chit1_x+$labelArr[$k]['txtwidth']);
							$txtWid_expected = $pdfHelper->getTextWidth($reservationList[$valArr[$k]], ${'page_'.$page_no}->getFont(), $font_size-2,$expected_text_limit);
							$expected_text_value = $reservationList[$valArr[$k]];
							$expected_text_split = explode(' ',$expected_text_value);
							$chnkVal = 0;
							
							foreach($txtWid_expected['chunk'] as $value){
								$chnkVal = $value;
							 	$expected_text_y_end -= 10;
							 	$expected_text_height += 10;
							}
							if($chnkVal < count($expected_text_split)){
								$expected_text_y_end -= 10;
								$expected_text_height += 10;
							}      
							
						}
						$expected_chit_y_end = $expected_text_y_end;
						
						if(($expected_chit_y_end - 30) < 0){
							if($status_2_y_end > $expected_text_height + 30){
								$i--;
								continue;
							}else{
								$page_break_status = true;
								$page_no++;
								$i--;
								continue;
							}
						}
						/* --------------------------------------------- */
						
						${'page_'.$page_no}->setFont($font, $font_size)
						      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
						      ->drawText($reservationList['bok_name'], $chit1_x,$chit1_y+8);
							  
						${'page_'.$page_no}->setFont($font, $font_size-2)
						      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
							  ->drawText($reservationList['rgudesignation'], $chit1_x,$chit1_y-2);
						$date_time = 'DATE'." :"." ".$date.'    '.'TIME'." :"." ".$reservationList['bokbooking_timings'].'   '.'SIZE :'." ".$reservationList['bokparty_size'];
						${'page_'.$page_no}->setFont($font, $font_size-2)
						      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
						      ->drawText($date_time, $chit1_x,$chit1_y-13);
						      
						${'page_'.$page_no}->setLineWidth(0.8);

						if($reservationList['bokstatuscode'] ==  "PTS"){
							${'page_'.$page_no}->setFillColor(Zend_Pdf_Color_Html::color('#01ffff'))
											   ->setLineColor(new Zend_Pdf_Color_GrayScale(0.2))
						     				   ->drawRectangle($chit2_x-70, $chit1_y-5, $chit1_x_border-20, $chit1_y+20);								
						}else if($reservationList['bokstatuscode'] ==  "BOK"){
							${'page_'.$page_no}->setFillColor(Zend_Pdf_Color_Html::color('#FF6376'))
										       ->setLineColor(new Zend_Pdf_Color_GrayScale(0.2))
										       ->drawRectangle($chit2_x-70, $chit1_y-5, $chit1_x_border-20, $chit1_y+20);
						}else if($reservationList['bokstatuscode'] ==  "DES"){
							${'page_'.$page_no}->setFillColor(Zend_Pdf_Color_Html::color('#cacc05'))
										       ->setLineColor(new Zend_Pdf_Color_GrayScale(0.2))
										       ->drawRectangle($chit2_x-70, $chit1_y-5, $chit1_x_border-20, $chit1_y+20);
						}else if($reservationList['bokstatuscode'] ==  "CRD"){
							${'page_'.$page_no}->setFillColor(Zend_Pdf_Color_Html::color('#9AFF96'))
										       ->setLineColor(new Zend_Pdf_Color_GrayScale(0.2))
										       ->drawRectangle($chit2_x-70, $chit1_y-5, $chit1_x_border-20, $chit1_y+20);
						}else if($reservationList['bokstatuscode'] ==  "WRD"){
							${'page_'.$page_no}->setFillColor(Zend_Pdf_Color_Html::color('#c6a997'))
										       ->setLineColor(new Zend_Pdf_Color_GrayScale(0.2))
										       ->drawRectangle($chit2_x-70, $chit1_y-5, $chit1_x_border-20, $chit1_y+20);
						}else{
							${'page_'.$page_no}->setFillColor(Zend_Pdf_Color_Html::color('#ffffff'))
							     			   ->setLineColor(new Zend_Pdf_Color_GrayScale(0.2))
							     			   ->drawRectangle($chit2_x-70, $chit1_y-5, $chit1_x_border-20, $chit1_y+20);
						}
						$table_no = $reservationList['boktablenumber'];
						if($table_no){
							${'page_'.$page_no}->setFont($font, $font_size-2)
							      ->setFillColor(Zend_Pdf_Color_Html::color('#303030'))
							      ->drawText($reservationList['boktablenumber'], $chit2_x-58,$chit1_y+4);
	//					}else{
	//						${'page_'.$page_no}->setFont($font, $font_size-2)
	//						      ->setFillColor(Zend_Pdf_Color_Html::color('#303030'))
	//						      ->drawText($reservationList['boktablenumber'], $chit2_x-63,$chit1_y+2);
						}
						
						${'page_'.$page_no}->setFont($font, $font_size-2)
						      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
						      ->drawText($serverName, $chit1_x+202,$chit1_y-15);

						${'page_'.$page_no}->setLineWidth(0.4);      
						${'page_'.$page_no}->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
						      ->setLineColor(new Zend_Pdf_Color_GrayScale(0.2))
						      ->drawLine($chit1_x, $chit1_y-18, $chit1_x_border, $chit1_y-18);      
						      
						/* --------------------------guest notes label -------------------------------- */
						$guest_notes_y_start = $chit1_y-30;
						${'page_'.$page_no}->setFont($font, $font_size-2)
						      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
						      ->drawText($guest_notes_text, $chit1_x,$guest_notes_y_start); 
			
						$serverlimit = ($chit1_x_border - 10) - ($chit1_x+$guest_notes_text_width['txtwidth']);
						$guest_notes_value = $reservationList['bokspecial_request'];
						$guest_notes_y_end = $guest_notes_y_start;
						if($guest_notes_value){
							$txtWid_Server = $pdfHelper->getTextWidth($guest_notes_value, ${'page_'.$page_no}->getFont(), $font_size-2,$serverlimit);
							$guest_notes_split = explode(' ',$guest_notes_value);
							$chnkVal = 0;
							
							foreach($txtWid_Server['chunk'] as $value){
								$val = $value - $chnkVal;
								$t = array_slice($guest_notes_split, $chnkVal, $val);
								${'page_'.$page_no}->setFont($font, $font_size-2)
								      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
								      ->drawText(implode(' ',$t),$chit1_x+(int)$guest_notes_text_width['txtwidth'], $guest_notes_y_end);
							 	$chnkVal = $value;
							 	$guest_notes_y_end -= 10;
							}
							if($chnkVal < count($guest_notes_split)){
				//				$cnt = count($txt_split) - $chnkVal;
								$t = array_slice($guest_notes_split, $chnkVal);
								${'page_'.$page_no}->setFont($font, $font_size-2)
								      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
								      ->drawText(implode(' ',$t), $chit1_x+(int)$guest_notes_text_width['txtwidth'],$guest_notes_y_end);
							}
						}
			
						/* --------------------------guest notes label -------------------------------- */
						
						/* --------------------------reserv notes label -------------------------------- */
						$reserv_notes_y_start = $guest_notes_y_end - 15;      
						${'page_'.$page_no}->setFont($font, $font_size-2)
						      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
						      ->drawText($reserv_notes_text, $chit1_x,$reserv_notes_y_start);
			
						$reserv_notes_limit = ($chit1_x_border - 10) - ($chit1_x+$reserv_notes_text_width['txtwidth']);
						$reserv_notes_value = $reservationList['bokrestaurant_note'];
						$reserv_notes_y_end = $reserv_notes_y_start;
						if($reserv_notes_value){
							$txtWid_Server = $pdfHelper->getTextWidth($reserv_notes_value, ${'page_'.$page_no}->getFont(), $font_size-2,$reserv_notes_limit);
							
							$reserv_notes_split = explode(' ',$reserv_notes_value);
							$chnkVal = 0;
							
							foreach($txtWid_Server['chunk'] as $value){
								$val = $value - $chnkVal;
								$t = array_slice($reserv_notes_split, $chnkVal, $val);
								${'page_'.$page_no}->setFont($font, $font_size-2)
								      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
								      ->drawText(implode(' ',$t), $chit1_x+(int)$reserv_notes_text_width['txtwidth'],$reserv_notes_y_end);
							 	$chnkVal = $value;
							 	$reserv_notes_y_end -= 10;
							}
							if($chnkVal < count($reserv_notes_split)){
				//				$cnt = count($txt_split) - $chnkVal;
								$t = array_slice($reserv_notes_split, $chnkVal);
								${'page_'.$page_no}->setFont($font, $font_size-2)
								      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
								      ->drawText(implode(' ',$t), $chit1_x+(int)$reserv_notes_text_width['txtwidth'],$reserv_notes_y_end);
							}     
						}
						
						/* --------------------------reserv notes label -------------------------------- */
						      
						/* --------------------------allergies label -------------------------------------- */
						
						$allergies_y_start = $reserv_notes_y_end - 15;      
						${'page_'.$page_no}->setFont($font, $font_size-2)
						      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
						      ->drawText($allergies_text,$chit1_x,$allergies_y_start);
			
						$allergies_limit = ($chit1_x_border - 10) - ($chit1_x+$allergies_text_width['txtwidth']);
						$allergies_value = $reservationList['allergies'];
						$allergies_y_end = $allergies_y_start;
						if($allergies_value){
							$txtWid_Server = $pdfHelper->getTextWidth($allergies_value, ${'page_'.$page_no}->getFont(), $font_size-2,$allergies_limit);
							
							$allergies_split = explode(' ',$allergies_value);
							$chnkVal = 0;
							
							foreach($txtWid_Server['chunk'] as $value){
								$val = $value - $chnkVal;
								$t = array_slice($allergies_split, $chnkVal, $val);
								${'page_'.$page_no}->setFont($font, $font_size-2)
								      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
								      ->drawText(implode(' ',$t), $chit1_x+(int)$allergies_text_width['txtwidth'],$allergies_y_end);
							 	$chnkVal = $value;
							 	$allergies_y_end -= 10;
							}
							if($chnkVal < count($allergies_split)){
				//				$cnt = count($txt_split) - $chnkVal;
								$t = array_slice($allergies_split, $chnkVal);
								${'page_'.$page_no}->setFont($font, $font_size-2)
								      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
								      ->drawText(implode(' ',$t), $chit1_x+(int)$allergies_text_width['txtwidth'],$allergies_y_end);
							}    
						}
						
						/* --------------------------allergies label -------------------------------------- */
						      
						/* --------------------------reservations count-------------------------------------- */
						
						$status_1_y_start = $allergies_y_end - 15;
						$visits_text = 'Total Visits';
						$reserv_text = 'Reservations';
						$walkin_text = 'Walkins';
						$noshow_text = 'No shows';
						$cancel_text = 'Cancellations';
						
						${'page_'.$page_no}->setFillColor(Zend_Pdf_Color_Html::color('#E2E2E5'))
						      ->setLineColor(new Zend_Pdf_Color_GrayScale(0.2))
						      ->drawRectangle(20 , $status_1_y_start+10 ,276,$status_1_y_start-20);
						      
						${'page_'.$page_no}->setFont($font, $font_size-2)
						      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
						      ->drawText($visits_text, $chit1_x,$status_1_y_start);
						            
						${'page_'.$page_no}->setFont($font, $font_size-2)
						      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
						      ->drawText($reserv_text, $chit1_x+50,$status_1_y_start);
						      
						${'page_'.$page_no}->setFont($font, $font_size-2)
						      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
						      ->drawText($walkin_text, $chit1_x+105,$status_1_y_start);

						${'page_'.$page_no}->setFont($font, $font_size-2)
						      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
						      ->drawText($noshow_text, $chit1_x+150,$status_1_y_start);

						${'page_'.$page_no}->setFont($font, $font_size-2)
						      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
						      ->drawText($cancel_text, $chit1_x+200,$status_1_y_start);
						            						
						$status_start = $status_1_y_start - 15;
						
						if($reservationList['totalcount'] == null || $reservationList['totalcount'] == "")
						{
							$visits_value = 0;
						}else{
							$visits_value = $reservationList['totalcount'];
						}
						if($reservationList['reservecount'] == null || $reservationList['reservecount'] == "")
						{
							$reserv_value = 0;
						}else{
							$reserv_value = $reservationList['reservecount'];
						}
						if($reservationList['walkincount'] == null || $reservationList['walkincount'] == "")
						{
							$walkin_value = 0;
						}else{
							$walkin_value = $reservationList['walkincount'];
						}
						if($reservationList['noShowCount'] == null || $reservationList['noShowCount'] == "")
						{
							$noshow_value = 0;
						}else{
							$noshow_value = $reservationList['walkincount'];
						}
						if($reservationList['cancelCount'] == null || $reservationList['cancelCount'] == "")
						{
							$cancel_value = 0;
						}else{
							$cancel_value = $reservationList['cancelCount'];
						}
						
						${'page_'.$page_no}->setFont($font, $font_size-2)
						      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
						      ->drawText($visits_value, $chit1_x+13,$status_start);
						      
						${'page_'.$page_no}->setFont($font, $font_size-2)
						      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
						      ->drawText($reserv_value, $chit1_x+68,$status_start);
						      
						${'page_'.$page_no}->setFont($font, $font_size-2)
						      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
						      ->drawText($walkin_value, $chit1_x+113,$status_start);

						${'page_'.$page_no}->setFont($font, $font_size-2)
						      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
						      ->drawText($noshow_value, $chit1_x+165,$status_start);

						${'page_'.$page_no}->setFont($font, $font_size-2)
						      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
						      ->drawText($cancel_value, $chit1_x+218,$status_start);

						$status_y_end =  $status_start;     
						/* --------------------------reservations count-------------------------------------- */
					}else if($i % 2 == 1){
						if($i == 1){
							$chit2_y = 748;
						}else{
							$chit2_y = $status_2_y_end - 40;
						}
						/* ------------------------------------------ */
						$expected_chit_2_y_start = $chit2_y;
						$expected_chit_2_y_end = $chit2_y;
						$expected_text_2_y_start =  $chit2_y-60;
						$expected_text_2_height = 60;
						$labelArr = array($server_text_width,$res_notes_text_width,$res_codes_text_width,$guest_notes_text_width,$reserv_notes_text_width,$allergies_text_width);     
						$valArr = array('1'=>'bokrestaurant_note','2'=>'bokresmodedesc','3'=>'bokspecial_request','5'=>'bokphone');
						$expected_text_2_y_end = $expected_text_2_y_start;
						for($k = 0;$k<6;$k++){
							if($k == 0 || $k == 4){
								$expected_text_2_y_end -= 10;
							 	$expected_text_2_height += 10;
								continue;
							}
							$expected_text_2_limit = ($chit2_x_border - 10) - ($chit2_x+$labelArr[$k]['txtwidth']);
							$expected_text_2_value = $reservationList[$valArr[$k]];
							if($expected_text_2_value){
								$txtWid_expected = $pdfHelper->getTextWidth($reservationList[$valArr[$k]], ${'page_'.$page_no}->getFont(), $font_size-2,$expected_text_2_limit);
								
								$expected_text_2_split = explode(' ',$expected_text_2_value);
								$chnkVal = 0;
								
								foreach($txtWid_expected['chunk'] as $value){
									$chnkVal = $value;
								 	$expected_text_2_y_end -= 10;
								 	$expected_text_height += 10;
								}
								if($chnkVal < count($expected_text_2_split)){
									$expected_text_2_y_end -= 10;
									$expected_text_height += 10;
								}      
							}
							
						}
						$expected_chit_2_y_end = $expected_text_2_y_end;
						
						if(($expected_chit_2_y_end - 30) < 0){
							$page_break_status = true;
							$page_no++;
							$i--;
							continue;
						}
						/* --------------------------------------------- */
						${'page_'.$page_no}->setFont($font, $font_size)
						      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
						      ->drawText($reservationList['bok_name'], $chit2_x,$chit2_y+8);
     
						${'page_'.$page_no}->setFont($font, $font_size-2)
						      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
							  ->drawText($reservationList['rgudesignation'], $chit2_x,$chit2_y-2);
							  	  	
						$date_time = 'DATE'." :"." ".$date.'    '.'TIME'." :"." ".$reservationList['bokbooking_timings'].'   '.'SIZE :'." ".$reservationList['bokparty_size'];
						${'page_'.$page_no}->setFont($font, $font_size-2)
						      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
						      ->drawText($date_time, $chit2_x,$chit2_y-13);
						      
						${'page_'.$page_no}->setLineWidth(0.8);    
						  
						if($reservationList['bokstatuscode'] ==  "PTS"){
							${'page_'.$page_no}->setFillColor(Zend_Pdf_Color_Html::color('#01ffff'))
											   ->setLineColor(new Zend_Pdf_Color_GrayScale(0.2))
										       ->drawRectangle($chit2_x+210, $chit2_y-5, $chit2_x_border-20, $chit2_y+20);								
						}else if($reservationList['bokstatuscode'] ==  "BOK"){
							${'page_'.$page_no}->setFillColor(Zend_Pdf_Color_Html::color('#FF6376'))
										       ->setLineColor(new Zend_Pdf_Color_GrayScale(0.2))
										       ->drawRectangle($chit2_x+210, $chit2_y-5, $chit2_x_border-20, $chit2_y+20);
						}else if($reservationList['bokstatuscode'] ==  "DES"){
							${'page_'.$page_no}->setFillColor(Zend_Pdf_Color_Html::color('#cacc05'))
										       ->setLineColor(new Zend_Pdf_Color_GrayScale(0.2))
										       ->drawRectangle($chit2_x+210, $chit2_y-5, $chit2_x_border-20, $chit2_y+20);
						}else if($reservationList['bokstatuscode'] ==  "CRD"){
							${'page_'.$page_no}->setFillColor(Zend_Pdf_Color_Html::color('#9AFF96'))
										       ->setLineColor(new Zend_Pdf_Color_GrayScale(0.2))
										       ->drawRectangle($chit2_x+210, $chit2_y-5, $chit2_x_border-20, $chit2_y+20);
						}else if($reservationList['bokstatuscode'] ==  "WRD"){
							${'page_'.$page_no}->setFillColor(Zend_Pdf_Color_Html::color('#c6a997'))
										       ->setLineColor(new Zend_Pdf_Color_GrayScale(0.2))
										       ->drawRectangle($chit2_x+210, $chit2_y-5, $chit2_x_border-20, $chit2_y+20);
						}else{
							${'page_'.$page_no}->setFillColor(Zend_Pdf_Color_Html::color('#ffffff'))
										       ->setLineColor(new Zend_Pdf_Color_GrayScale(0.2))
										       ->drawRectangle($chit2_x+210, $chit2_y-5, $chit2_x_border-20, $chit2_y+20);
						}						
						$table_no = $reservationList['boktablenumber'];
						if($table_no){
							${'page_'.$page_no}->setFont($font, $font_size-2)
							      ->setFillColor(Zend_Pdf_Color_Html::color('#303030'))
							      ->drawText($table_no, $chit2_x+223,$chit2_y+5);
	//					}else{
	//						${'page_'.$page_no}->setFont($font, $font_size-2)
	//						      ->setFillColor(Zend_Pdf_Color_Html::color('#303030'))
	//						      ->drawText($reservationList['boktablenumber'], $chit2_x-63,$chit1_y+2);
						}						

						${'page_'.$page_no}->setFont($font, $font_size-2)
						      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
						      ->drawText($serverName, $chit2_x+208,$chit2_y-15);
     
						${'page_'.$page_no}->setLineWidth(0.4);      
						${'page_'.$page_no}->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
						      ->setLineColor(new Zend_Pdf_Color_GrayScale(0.2))
						      ->drawLine($chit2_x, $chit2_y-18, $chit2_x_border, $chit2_y-18);      
						
						/* --------------------------guest notes label -------------------------------- */
						$guest_notes_2_y_start = $chit2_y-30;
						${'page_'.$page_no}->setFont($font, $font_size-2)
						      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
						      ->drawText($guest_notes_text, $chit2_x,$guest_notes_2_y_start); 
			
						$guest_notes_2_limit = ($chit2_x_border - 10) - ($chit2_x+$guest_notes_text_width['txtwidth']);
						$guest_notes_2_value = $reservationList['bokspecial_request'];
						$guest_notes_2_y_end = $guest_notes_2_y_start;
						if($guest_notes_2_value){
							$txtWid_Server = $pdfHelper->getTextWidth($guest_notes_2_value, ${'page_'.$page_no}->getFont(), $font_size-2,$guest_notes_2_limit);
							$guest_notes_2_split = explode(' ',$guest_notes_2_value);
							$chnkVal = 0;
							foreach($txtWid_Server['chunk'] as $value){
								$val = $value - $chnkVal;
								$t = array_slice($guest_notes_2_split, $chnkVal, $val);
								${'page_'.$page_no}->setFont($font, $font_size-2)
								      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
								      ->drawText(implode(' ',$t),$chit2_x+(int)$guest_notes_text_width['txtwidth'], $guest_notes_2_y_end);
							 	$chnkVal = $value;
							 	$guest_notes_2_y_end -= 10;
							}
							if($chnkVal < count($guest_notes_2_split)){
				//				$cnt = count($txt_split) - $chnkVal;
								$t = array_slice($guest_notes_2_split, $chnkVal);
								${'page_'.$page_no}->setFont($font, $font_size-2)
								      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
								      ->drawText(implode(' ',$t), $chit2_x+(int)$guest_notes_text_width['txtwidth'],$guest_notes_2_y_end);
							}
						}
			
						/* --------------------------guest notes label -------------------------------- */
						
						/* --------------------------reserv notes label -------------------------------- */
						$reserv_notes_2_y_start = $guest_notes_2_y_end - 15;      
						${'page_'.$page_no}->setFont($font, $font_size-2)
						      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
						      ->drawText($reserv_notes_text, $chit2_x,$reserv_notes_2_y_start);
			
						$reserv_notes_2_limit = ($chit2_x_border - 10) - ($chit2_x+$reserv_notes_text_width['txtwidth']);
						$reserv_notes_2_value = $reservationList['bokrestaurant_note'];
						$reserv_notes_2_y_end = $reserv_notes_2_y_start;
						if($reserv_notes_2_value){
							$txtWid_Server = $pdfHelper->getTextWidth($reserv_notes_2_value, ${'page_'.$page_no}->getFont(), $font_size-2,$reserv_notes_2_limit);
							$reserv_notes_2_split = explode(' ',$reserv_notes_2_value);
							$chnkVal = 0;
							foreach($txtWid_Server['chunk'] as $value){
								$val = $value - $chnkVal;
								$t = array_slice($reserv_notes_2_split, $chnkVal, $val);
								${'page_'.$page_no}->setFont($font, $font_size-2)
								      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
								      ->drawText(implode(' ',$t), $chit2_x+(int)$reserv_notes_text_width['txtwidth'],$reserv_notes_2_y_end);
							 	$chnkVal = $value;
							 	$reserv_notes_2_y_end -= 10;
							}
							if($chnkVal < count($reserv_notes_2_split)){
				//				$cnt = count($txt_split) - $chnkVal;
								$t = array_slice($reserv_notes_2_split, $chnkVal);
								${'page_'.$page_no}->setFont($font, $font_size-2)
								      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
								      ->drawText(implode(' ',$t), $chit2_x+(int)$reserv_notes_text_width['txtwidth'],$reserv_notes_2_y_end);
							}
						}     
						
						/* --------------------------reserv notes label -------------------------------- */
						      
						/* --------------------------allergies label -------------------------------------- */
						
						$allergies_2_y_start = $reserv_notes_2_y_end - 15;
						${'page_'.$page_no}->setFont($font, $font_size-2)
						      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
						      ->drawText($allergies_text, $chit2_x,$allergies_2_y_start);      
						      
						$allergies_2_limit = ($chit2_x_border - 10) - ($chit2_x+$allergies_text_width['txtwidth']);
						$allergies_2_value = $reservationList['allergies'];
						$allergies_2_y_end = $allergies_2_y_start;
						if($allergies_2_value){
							$txtWid_Server = $pdfHelper->getTextWidth($allergies_2_value, ${'page_'.$page_no}->getFont(), $font_size-2,$allergies_2_limit);
							$allergies_2_split = explode(' ',$allergies_2_value);
							$chnkVal = 0;
							foreach($txtWid_Server['chunk'] as $value){
								$val = $value - $chnkVal;
								$t = array_slice($allergies_2_split, $chnkVal, $val);
								${'page_'.$page_no}->setFont($font, $font_size-2)
								      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
								      ->drawText(implode(' ',$t), $chit2_x+(int)$allergies_text_width['txtwidth'],$allergies_2_y_end);
							 	$chnkVal = $value;
							 	$allergies_2_y_end -= 10;
							}
							if($chnkVal < count($allergies_2_split)){
				//				$cnt = count($txt_split) - $chnkVal;
								$t = array_slice($allergies_2_split, $chnkVal);
								${'page_'.$page_no}->setFont($font, $font_size-2)
								      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
								      ->drawText(implode(' ',$t), $chit2_x+(int)$allergies_text_width['txtwidth'],$allergies_2_y_end);
							}     
						}
						/* --------------------------allergies label -------------------------------------- */
						      
						/* --------------------------Reservations Count label -------------------------------------- */

						$status_2_y_start = $allergies_2_y_end - 15;
						$visits2_text = 'Total Visits';
						$reserv2_text = 'Reservations';
						$walkin2_text = 'Walkins';
						$noshow2_text = 'No shows';
						$cancel2_text = 'Cancellations';
						      
						${'page_'.$page_no}->setFillColor(Zend_Pdf_Color_Html::color('#E2E2E5'))
						      ->setLineColor(new Zend_Pdf_Color_GrayScale(0.2))
						      ->drawRectangle($chit2_x-5 , $status_2_y_start+10 ,$chit2_x_border-9,$status_2_y_start-20);
						      
						${'page_'.$page_no}->setFont($font, $font_size-2)
						      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
						      ->drawText($visits2_text, $chit2_x,$status_2_y_start);
						            
						${'page_'.$page_no}->setFont($font, $font_size-2)
						      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
						      ->drawText($reserv2_text, $chit2_x+50,$status_2_y_start);
						      
						${'page_'.$page_no}->setFont($font, $font_size-2)
						      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
						      ->drawText($walkin2_text, $chit2_x+105,$status_2_y_start);

						${'page_'.$page_no}->setFont($font, $font_size-2)
						      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
						      ->drawText($noshow2_text, $chit2_x+150,$status_2_y_start);

						${'page_'.$page_no}->setFont($font, $font_size-2)
						      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
						      ->drawText($cancel2_text, $chit2_x+200,$status_2_y_start);
						            
						
						$status_start2 = $status_2_y_start - 15;
						
						$status_2_y_end = $status_start2;
						
						if($reservationList['totalcount'] == null || $reservationList['totalcount'] == "")
						{
							$visits_value2 = 0;
						}else{
							$visits_value2 = $reservationList['totalcount'];
						}
						if($reservationList['reservecount'] == null || $reservationList['reservecount'] == "")
						{
							$reserv_value2 = 0;
						}else{
							$reserv_value2 = $reservationList['reservecount'];
						}
						if($reservationList['walkincount'] == null || $reservationList['walkincount'] == "")
						{
							$walkin_value2 = 0;
						}else{
							$walkin_value2 = $reservationList['walkincount'];
						}
						if($reservationList['noShowCount'] == null || $reservationList['noShowCount'] == "")
						{
							$noshow_value2 = 0;
						}else{
							$noshow_value2 = $reservationList['walkincount'];
						}
						if($reservationList['cancelCount'] == null || $reservationList['cancelCount'] == "")
						{
							$cancel_value2 = 0;
						}else{
							$cancel_value2 = $reservationList['cancelCount'];
						}
						
						${'page_'.$page_no}->setFont($font, $font_size-2)
						      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
						      ->drawText($visits_value2, $chit2_x+13,$status_start2);
						      
						${'page_'.$page_no}->setFont($font, $font_size-2)
						      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
						      ->drawText($reserv_value2, $chit2_x+68,$status_start2);
						      
						${'page_'.$page_no}->setFont($font, $font_size-2)
						      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
						      ->drawText($walkin_value2, $chit2_x+113,$status_start2);

						${'page_'.$page_no}->setFont($font, $font_size-2)
						      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
						      ->drawText($noshow_value2, $chit2_x+165,$status_start2);

						${'page_'.$page_no}->setFont($font, $font_size-2)
						      ->setFillColor(Zend_Pdf_Color_Html::color('#000000'))
						      ->drawText($cancel_value2, $chit2_x+218,$status_start2);      
						
						/* --------------------------Rerservations Count label -------------------------------------- */
					}
				}
				$path = 'managerest/'.$request->restaurantid;
				if(!file_exists($path)){
					mkdir($path,0777);
				}
				$pdfDirPath = $path.'/chits';
				if(!file_exists($pdfDirPath)){
					mkdir($pdfDirPath,0777);
				}
				$pdf->save($pdfDirPath.'/'.$request->restaurantid.'.pdf');
			    return true;
			}else{
				$path = 'managerest/'.$request->restaurantid;
				if(!file_exists($path)){
					mkdir($path,0777);
				}
				$pdfDirPath = $path.'/chits';
				if(!file_exists($pdfDirPath)){
					mkdir($pdfDirPath,0777);
				}
				$pdf->save($pdfDirPath.'/'.$request->restaurantid.'.pdf');
				return false;
			}
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function GetReminderNotificationReservations()
	{
		try{
			
			date_default_timezone_set("EST5EDT");
			
			$batchStart = date('Y-m-d g:i:s A');
			
			$date 	  = date('Y-m-d');
			$fromtime = date('g:i A');
			$totime	  = date("g:i A", strtotime ("+4 hour"));
			
			$reminderLog = "../logs/reminder.log";
			$fh = fopen($reminderLog, 'a') or die("can't open file");
			
			fwrite($fh, "Batch Start Time : ".$batchStart."\n");
		
			
			$ReminderBookings = new Reservation_Model_ReminderBookings();
			$statusCode = array("RSD","WAL");
			$ReminderBookings->setbookingdate($date);
			$ReminderBookings->setbookfromtime($fromtime);
			$ReminderBookings->setbooktotime($totime);
			$ReminderBookings->setbookstatus($statusCode);
			
			$BookingNotifyMapper = new Reservation_Model_ReservationNotifyMapper();
			$rowSet = $BookingNotifyMapper->RetrieveReminderBookingInfo($ReminderBookings);
			
			if($rowSet){
				$mailmapper = new Application_Service_Communication();
				foreach($rowSet as $row){
					if($row->boknotification_type != "" && $row->boknotification_type == "email" || $row->boknotification_type == "both"){
						$mailObj = new Communication_Model_Mail();
						/* Get Campaign Info */
						$stateId = $row->resstate_id;
						$cityId  = $row->rescity_id;
						$regionId = $row->resregion_id;
						
						$userType = 'CUS';
						$adminService = new Application_Service_Administrator();
						$campProp = new Application_Model_GetCampaignForPost();
						$campProp->setAudType($userType)
								->setStateId($stateId)
								->setCityId($cityId)
								->setRegionId($regionId)
								->setIsAjaxCall(false);
								
						$campDetails = $adminService->GetCampaignDetails($campProp);
						if($row->bookstatus == "WAL"){
							$mailObj->setMsgCode("BookReminder");
						}else{
							$mailObj->setMsgCode("BookReminder");	
						}
												
						$name = $row->bokfirst_name.' '.$row->boklast_name;
						$data = array('UserName' 			=> 	$name,
									  'SenTo'    			=>	$row->bokemail,
									  'RestName' 			=> 	$row->resrestaurant_name,
									  'ResDate'  			=> 	$row->bokbooking_date,
									  'Time'     			=> 	date("h:i A",strtotime($row->bokbooking_timings)),
									  'Size'     			=> 	$row->bokparty_size,
									  'Address'	 			=> 	$row->resaddress,
									  'resphone' 			=> 	$row->resphone,
									  'resemail'			=>	$row->resemail,
									  'rescity'				=>	$row->citydesc,
									  'resnbh'				=>	$row->nieghbor,
									  'reszipcode'			=>	$row->reszipcode,	
									  'Status'	 			=> 	$row->bookstatus,
									  'State_Id'			=>	$stateId,
									  'City_Id'				=>	$cityId,
									  'UserType'			=>	$userType,
									  'Bokid'				=>  $row->bokid
						);	
										
						$splresult = "";
						if($row->booktype == "SPL"){
							$isAjaxCall = true;
							$splmapper = new Deals_Model_RestaurantSpecialDataMapper();
							$splresult = $splmapper->getRestaurantSplByBookingId($result,$isAjaxCall);
						}
						
							if($splresult){
								$data['splstatus']	= true;
								$data['splid'] 		= $splresult['Id'];
								$data['splname']	= $splresult['Special Name'];
								$data['spldesc'] 	= $splresult['Desc'];
								$data['splorgprice']= $splresult['Regular Price'];
								if($splresult['Discountcode'] == 'PER'){
									$data['spldiscount']= $splresult['Discount Percentage'].'%';	
								}else if($splresult['Discountcode'] == 'RE'){
									$data['spldiscount']= '$'.$splresult['Discount Percentage'];
								}
								$data['splprice'] 	= $splresult['Price with Discount'];
							}else{
								$data['splstatus']	= false;
							}
							
							if(count($campDetails)){
								$count = count($campDetails);
								if($count > 1){
									$campaign = $campDetails[rand(0,$count-1)];
								}else{
									$campaign = $campDetails[0];
								}
								$notfService = new Application_Service_Communication();
								$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
								$data['campaignName'] = trim($campaign->getSponsor());
								$data['campaignDesc'] =	trim($campaign->getCampDesc());
								$data['campaignImg']  =	trim($campaign->getCampImage());
								$data['campId']		  = $campaign->getId();
							}
								
						$mailObj->setData($data);
						$mailStatus = $mailmapper->SendMail($mailObj);						
						if($mailStatus){
							$BookingNotify = new Reservation_Model_ReservationNotify();
							$BookingNotify->setbknid($row->bknid);
							$BookingNotify->setbkn_reminderstatus(TRUE);
							$BookingNotifyMapper->UpdateReminderStatus($BookingNotify);
							
						}
						
					}	
				}
			}
			$batchEnd = date('Y-m-d g:i:s A');
			fwrite($fh, "Batch End Time: ".$batchEnd."\n");
			fclose($fh);
			
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function cancelCompletion($request)
	{
		try{
			$bookMapper = new Reservation_Model_ReservationDataMapper();
			
			$status = $request->BokstausId;
			if($status == '21'){
				$status = '10';
			}
			$bookid = $request->bookingid;
			$result = $bookMapper->cancelCompletion($bookid,$status);
			return $result;
			
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}	
	}
	
	public function cancelCompletionBookView($request)
	{
		try{
			$bookMapper = new Reservation_Model_ReservationDataMapper();
			$bookid = $request->bookingid;
			$status = $bookMapper->getBookingPrevStatus($bookid);
			if($status == 21){
				$status = 10;
			}
			
			$result = $bookMapper->cancelCompletion($bookid,$status);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * @param request
	 * function to retreive all the completed reservations of that day
	 */
	public function GetCompletedReservations($request)
	{
		try{
			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			$bookMapper = new Reservation_Model_ReservationDataMapper();
					
			/* Reteriving Reservation Status Id */
			$bookStatus = array('COM');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			/* Reteriving Completed list start */

			$getCompletedObj = new Reservation_Model_GetCompletedList();
			$getCompletedObj->setRestaurantId($request->restaurantid)
			->setBookStatus($bookStatusRes)
			->setDate($request->resdate)
			->setIsAjaxCall(true);

			$getCompletedObj->setBookStatus($bookStatusRes);
			$CompletedListRes = $bookMapper->getCompletedList($getCompletedObj);
			
			/* Reteriving Completed list end */
			
			if($CompletedListRes){
				foreach($CompletedListRes as $completed)
				{
					$resultSet[] = array(	'bokid' 			  => $completed['bokid'],
			 							 	'bokuserid' 		  => $completed['bokuserid'],
			 							 	'bokfk_restaurant'    => $completed['bokfk_restaurant'],
		 									'bokfirst_name' 	  => $completed['bokfirst_name'],				 							 
		 									'bokparty_size' 	  => $completed['bokparty_size'],
			 							 	'bokbooking_timings'  => $completed['bokbooking_timings'],
			 							 	'bokspecial_request'  => $completed['bokspecial_request'],
			 							 	'boktypcode'		  => $completed['boktypcode'],
			 							 	'boktablenumber'	  => $completed['boktablenumber'],
			 							 	'boktableid' 		  => $completed['boktableid'],
											'bokjointableno'	  => $completed['bokjointableno'],
			 							 	'bokresmodecode' 	  => $completed['bokresmodecode'],
			 							 	'bokrestaurant_note'  => $completed['bokrestaurant_note'],
										 	'bokstatuscode'       => $completed['bokstatuscode'],
											'tableNoArr'		  => $completed['tableNoArr'],
											'diningid'			  => $completed['diningid'],
											'resvconfirmstatus'   => $completed['resvconfirmstatus'],
											'bokconfirmstatus'	  => $completed['bokconfirmstatus'],
											'resvcheckedin'	   	  => $completed['resvcheckedin'],
											'bokbooked_status'	  => $completed['bokbooked_status'],
											'initial'			  => $completed['initial']);		
				}
			}else{
				$resultSet = '';
			}			
			return $resultSet;	
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getBookingsforDayView($request,$data)
	{
		try{
			$resId  = $request->restaurantid;
			$result = array();
			$date = null;
			$datStat = "";
			$resServ = new Application_Service_Firm();
			$timeZone = $resServ->GetRestaurantTimeZone($resId);
			date_default_timezone_set($timeZone);
			if(isset($request->date)){
				$date = $request->date;
				$datStat = "request";
			}else{
				$date = date('Y-m-d');
			}
			/**GET MEAL PERIOD FILTER TIMES**/
			$mealPeriod = $request->meal;
			$timesLimit = array();
			$mealPeriods = $this->getDiningPeriodsByResid($resId,date("h:i a"));
			$result['meal_periods'] = $mealPeriods;
			if(!isset($mealPeriod))
			{
				//$timesLimit  = $this->getCurrentDiningTimes($resId,date("h:i a"));
			}
			else
			{
				if(strtolower($mealPeriod)!="all")
				{
					$timesLimit  = $this->getMealPeriodTimes($resId,$mealPeriod);
				}
			}
			/**END OF MEAL PERIOD TIMES **/
			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			$bookMapper = new Reservation_Model_ReservationDataMapper();

			/* Reteriving Table layout start */

			$diningidArr = array();
			$diningAreaArr = array();
			$diningMapper = new FirmManagement_Model_FirmDiningAreaDataMapper();
			$Diningresult = $diningMapper->getDinigAreasByRestId($resId);
			if($request->diningid){
				$diningid = $request->diningid;
			}else{
				foreach($Diningresult as $dining){
					$diningidArr[] = $dining->rdaid;
				}
				$diningid = $diningidArr[0];
			}
			$result['diningareas'] = $Diningresult;
			$result['diningid'] = $diningid;

			$mapper = new FirmManagement_Model_FirmTableDataMapper();
			$tableObj = new FirmManagement_Model_FirmTable();
			$tableObj->setResId($resId);
			$tableObj->setDiningId($diningid);
			$resultStr = $mapper->getRestaurantTable($tableObj);

			$result['Layout'] = $resultStr;

			/* Reteriving Table layout end */
			
			/* Retrieve seprator layout start */
			
			$restFloorSep = new FirmManagement_Model_FirmFloorSeprator();
			$restFloorSep->setrfsfk_restaurant($resId);
			$restFloorSep->setrfsfk_restaurant_dining_area($diningid);	
			
			$resFloorSepMapper = new FirmManagement_Model_FirmFloorSepratorMapper();
			$floorSepArr = $resFloorSepMapper->retrieveFloorSeprators($restFloorSep);
			
			$result['FloorSep'] = $floorSepArr;  
			
			$getTableStatusObj = new Reservation_Model_GetTableStatus();
			$getTableStatusObj->setRestaurantId($resId);
			$getTableStatusObj->setDate($date);

			/* Reteriving Reservation Status Id */
			$bookStatus = array('ALC','DES','BOK','PTS','CRD','WRD','BIL');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$getTableStatusObj->setBookStatus($bookStatusRes);

			$tableStatus = $bookMapper->getTableStatus($getTableStatusObj);
			$result['TableStatus'] = $tableStatus;

			/* Reteriving table status end */
			
			$resMapper = new FirmManagement_Model_FirmScheduleDataMapper();
			$resObj = new FirmManagement_Model_FirmSchedule();
			$resObj->setrssfk_restaurant($request->restaurantid);
			$dateSplit = explode("-",$date);
			if($datStat){
				$weekday = strtolower(date("D", mktime(0,0,0,$dateSplit[0],$dateSplit[1],$dateSplit[2])));
			}else{
				$weekday = strtolower(date("D", mktime(0,0,0,$dateSplit[1],$dateSplit[2],$dateSplit[0])));
				$date = date('m-d-Y');
			}
			//date_default_timezone_set('Asia/Kolkata');
			$time = date('h:i A');

			$timeArray = array();
			$finalArray = array();
			$prevArray  = array();
			$nextArray	= array();
			$resObj->setrssday_of_week($weekday);
			$resObj->setdate($date);
			
			$meal = new FirmManagement_Model_FirmMealType();

			$bookStatus = array('WAL','READY','QUOTE','BAR','NEXT','CANCUS','BACK','RSD','OVB');
			$abouttoSeat = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$bookStatus = array('ALC','DES','BOK','PTS','CRD');
			$seating = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$bookStatus = array('COM');
			$seated = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
			$meal->setResId($resId)
				->setDate($date)
				->setTime($time);
			$mealMapper = new FirmManagement_Model_FirmMealTypeDataMapper();
			$timeMeal = $mealMapper->GetRestaurantMealByTime($meal);
			$mealType = '';
			if(!$timeMeal){
				$mealType = $mealMapper->GetRestaurantMealTypes($meal);
				$mealT = "";
				foreach($mealType as $key=>$value){
					if($key != 'count'){
						$mealT = $value['meal'];
						break;
					}
				}
				if($mealT){
					$meal->setMealType($mealT);
					$timeMeal = $mealMapper->GetRestaurantMealByType($meal);
				}
			}
			$result['mealDetails'] = $mealMapper->GetRestaurantMealTypes($meal);
			if($timeMeal){
				$meal->setMealType($timeMeal->mealid)
					->setStartTime($timeMeal->rmt_start_time)
					->setEndTime($timeMeal->rmt_end_time)
					->setSeating($seating)
					->setAboutToSeat($abouttoSeat)
					->setSeated($seated);


				$mealCount = $bookMapper->getCountByMealType($meal);
				$result['mealCount'] = $mealCount;
				$mealResult = $mealMapper->GetRestaurantMealTypes($meal);
				$result['mealType'] = $timeMeal->meal;
			}else{
				$result['mealType'] = '';
			}
			
			/* Reteriving Attending list start */

			$getDayViewObj = new Reservation_Model_GetDayViewList();
			$getDayViewObj->setRestaurantId($resId);
			$getDayViewObj->setDate($date);

			/* Reteriving Reservation Status Id */
			$bookStatus = array('RSD','OVB','BKD');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$getDayViewObj->setBookStatus($bookStatusRes);
			$DayViewRes = $bookMapper->getDayViewList($getDayViewObj,$result['mealDetails']);
			$result['DayView'] = $DayViewRes;
			
			$result['DayViewCount'] = count($DayViewRes);

			/* Reteriving Attending list end */
			
			/* Reteriving Seated list start */

			$getDayViewObj = new Reservation_Model_GetDayViewList();
			$getDayViewObj->setRestaurantId($resId);
			$getDayViewObj->setDate($date);
			if(count($timesLimit)==2)
			{
				$getDayViewObj->setStartTime($timesLimit['start_time']);
				$getDayViewObj->setEndTime($timesLimit['end_time']);
			}
			/* Reteriving Reservation Status Id */
			$bookStatus = array('ALC','DES','BOK','PTS','CRD','WRD','BIL');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$getDayViewObj->setBookStatus($bookStatusRes);
			$SeatedRes = $bookMapper->getDayViewList($getDayViewObj,$result['mealDetails']);
			$result['Seated'] = $SeatedRes;
			
			$result['SeatedCount'] = count($SeatedRes);

			/* Reteriving Seated list end */
			
			/* Reteriving Completed list start */

			$getDayViewObj = new Reservation_Model_GetDayViewList();
			$getDayViewObj->setRestaurantId($resId);
			$getDayViewObj->setDate($date);

			/* Reteriving Reservation Status Id */
			$bookStatus = array('COM');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
			$getDayViewObj->setBookStatus($bookStatusRes);
			if(count($timesLimit)==2)
			{
				$getDayViewObj->setStartTime($timesLimit['start_time']);
				$getDayViewObj->setEndTime($timesLimit['end_time']);
			}	
			$CompletedRes = $bookMapper->getDayViewList($getDayViewObj,$result['mealDetails']);
			$result['Completed'] = $CompletedRes;
			
			$result['CompletedCount'] = count($CompletedRes);

			/* Reteriving Completed list end */
			

			/* Reteriving Freeze Status Start */

			$freezeStatus = new Reservation_Model_GetFreezeStatus();
			$freezeStatus->setRestId($resId);
			$freezeStatus->setFreezeDate($date);
			$freezemapper = new Reservation_Model_RestaurantFreezeDataMapper();
			$status = $freezemapper->GetFreezeStatus($freezeStatus);
			$result['FreezeStatus'] = $status;

			/* Reteriving Freeze Status End */

			/* Reteriving restaurant logo Start */

			$row = $bookMapper->GetRestaurantLogo($resId);
			if($row){
				$result['RestLogo'] = $row->reslogo;
				$result['RestName'] = $row->resrestaurant_name;
			}

			/* Reteriving restaurant logo End */
			
			/* Reteriving Reservation Status Id */
			
			$bookStatus = array('RSD','OVB','BKD','ALC','DES','BOK','PTS','CRD','WRD','BIL','COM');
			$abouttoSeat = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
			
			$bookStatus = array('WAL','READY','QUOTE','BAR','NEXT','CANCUS','BACK');
			$waiting = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

//			$bookStatus = array('ALC','DES','BOK','PTS','CRD','WRD','BIL');
//			$seating = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

//			$bookStatus = array('COM');
//			$seated = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
			$statusArr = array(
								'Upcoming'		=>	$abouttoSeat,
//								'Seated'		=>	$seating,
//								'Completed'		=>	$seated,
								'Waiting'		=>	$waiting
								);
			if(count($timesLimit)==2)
			{
					$result['reservCount'] = $bookMapper->RetrieveReservationCounts($resId,$date,$statusArr,$timesLimit);

			
			}
			else
			{
				$result['reservCount'] = $bookMapper->RetrieveReservationCounts($resId,$date,$statusArr);

			
			}
			
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function Ajax_BookingsDayView($request)
	{
		try{
			$resId  = $request->restaurantid;
			$result = array();
			$dayview = array();
			$date = null;
			$resServ = new Application_Service_Firm();
			$timeZone = $resServ->GetRestaurantTimeZone($resId);
			date_default_timezone_set($timeZone);
			if(isset($request->date)){
				$date = $request->date;
			}else{
				$date = date('Y-m-d');
			}
			$request->setParam('date',$date);
			if($request->companyid == 6){
				$dayview['availability'] = $this->GetAvailabilityOfRestaurant($request);
			}else{
				$dayview['availability'] = null;
			}
			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			$bookMapper = new Reservation_Model_ReservationDataMapper();
			/**GET MEAL PERIOD FILTER TIMES**/
			$mealPeriod = $request->meal;
			$timesLimit = array();
			$mealPeriods = $this->getDiningPeriodsByResid($resId,date("h:i a"));
			$result['meal_periods'] = $mealPeriods;
			if(!isset($mealPeriod))
			{
				//$timesLimit  = $this->getCurrentDiningTimes($resId,date("h:i a"));
			}
			else
			{
				if(strtolower($mealPeriod)!="all")
				{
					$timesLimit  = $this->getMealPeriodTimes($resId,$mealPeriod);
				}
			}
			/**END OF MEAL PERIOD TIMES **/
			/* Reteriving Table layout start */
			$diningidArr = array();
			$diningAreaArr = array();
			$diningMapper = new FirmManagement_Model_FirmDiningAreaDataMapper();
			$Diningresult = $diningMapper->getDinigAreasByRestId($resId);
			if($request->diningid){
				$diningid = $request->diningid;
			}else{
				foreach($Diningresult as $dining){
					$diningidArr[] = $dining->rdaid;
				}
				$diningid = $diningidArr[0];
			}
			$dayview['diningareas'] = $Diningresult;
			$dayview['diningid'] = $diningid;
			$mapper = new FirmManagement_Model_FirmTableDataMapper();
			$tableObj = new FirmManagement_Model_FirmTable();
			$tableObj->setResId($resId);
			$tableObj->setDiningId($diningid);
			$resultStr = $mapper->getRestaurantTable($tableObj);
			$resultFloor = $resultStr['finalStr'];
			$floorPlan = json_encode($resultFloor);
			$floorentrance = json_encode($resultStr['etnStr']);

			$dayview['FloorPlan'] = $floorPlan;
			$dayview['FloorEntrance'] = $floorentrance;
			
			/* Retrieve seprator layout start */
			
			$restFloorSep = new FirmManagement_Model_FirmFloorSeprator();
			$restFloorSep->setrfsfk_restaurant($resId);
			$restFloorSep->setrfsfk_restaurant_dining_area($diningid);	
			
			$resFloorSepMapper = new FirmManagement_Model_FirmFloorSepratorMapper();
			$floorSepArr = $resFloorSepMapper->retrieveFloorSeprators($restFloorSep);
			
			$dayview['FloorSep'] = json_encode($floorSepArr);  
			
			/* Retrieve seprator layout end */
			/* Reteriving Table layout End */

			/* Reteriving table status start */

			$getTableStatusObj = new Reservation_Model_GetTableStatus();
			$getTableStatusObj->setRestaurantId($resId);
			$getTableStatusObj->setDate($date);
			$getTableStatusObj->setIsAjaxCall(true);
			/* Reteriving Reservation Status Id */
			$bookStatus = array('ALC','DES','BOK','PTS','CRD','WRD','BIL','RSD','OVB','BKD');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$getTableStatusObj->setBookStatus($bookStatusRes);

			$tableStatus = $bookMapper->getTableStatus($getTableStatusObj);
			$jsontableStatus = json_encode($tableStatus);
			$dayview['TableStatus'] = $jsontableStatus;
			//array_push($dayview,array('TableStatus'=>$jsontableStatus));

			/* Reteriving table status end */
			
			/* Reteriving restaurant logo Start */

			$row = $bookMapper->GetRestaurantLogo($resId);
			$dayview['RestLogo'] = json_encode($row->reslogo);

			/* Reteriving restaurant logo End */

			$meal = new FirmManagement_Model_FirmMealType();

			$bookStatus = array('WAL','READY','QUOTE','BAR','NEXT','CANCUS','BACK','RSD','OVB');
			$abouttoSeat = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$bookStatus = array('ALC','DES','BOK','PTS','CRD','WRD','BIL');
			$seating = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
			$time = date('h:i A');
			$bookStatus = array('COM');
			$seated = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
			$mealMapper = new FirmManagement_Model_FirmMealTypeDataMapper();
			$timeMeal = '';
			if(isset($request->date)){
				$date = $request->date;
			}else{
				$date = date('Y-m-d');
			}
			if($request->mealtype){
				$meal->setResId($resId)
				->setDate($date)
				->setMealType($request->mealtype);
				$timeMeal = $mealMapper->GetRestaurantMealByType($meal);
			}else{
				$meal->setResId($resId)
				->setDate($date)
				->setTime($time);
				$timeMeal = $mealMapper->GetRestaurantMealByTime($meal);
			}
			$dayview['mealDetails'] = $mealMapper->GetRestaurantMealTypes($meal);
			if($timeMeal){
				$meal->setMealType($timeMeal->mealid)
				->setStartTime($timeMeal->rmt_start_time)
				->setEndTime($timeMeal->rmt_end_time)
				->setSeating($seating)
				->setAboutToSeat($abouttoSeat)
				->setSeated($seated);


				$mealCount = $bookMapper->getCountByMealType($meal);
				$dayview['mealCount'] = $mealCount;
				$mealResult = $mealMapper->GetRestaurantMealTypes($meal);
				$dayview['mealType'] = $timeMeal->meal;
			}else{
				$dayview['mealType'] = '';
			}
			$tabIndex = 0;
			if(isset($request->selTab)){
				$tabIndex = $request->selTab;
			}
			/* Reteriving Attending list start */

			$getDayViewObj = new Reservation_Model_GetDayViewList();
			$getDayViewObj->setRestaurantId($resId);
			$getDayViewObj->setDate($date);
			$getDayViewObj->setIsAjaxCall(true);
			if(count($timesLimit)==2)
			{
				$getDayViewObj->setStartTime($timesLimit['start_time']);
				$getDayViewObj->setEndTime($timesLimit['end_time']);
			}
			/* Reteriving Reservation Status Id */
			$bookStatus = array('RSD','OVB','BKD');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$getDayViewObj->setBookStatus($bookStatusRes);
			
			$attenListRes = $bookMapper->getDayViewList($getDayViewObj,$dayview['mealDetails']);
			$jsonattenList = json_encode($attenListRes);
			$dayview['Attending'] = $jsonattenList;				
			$dayview['AttendingCount'] = count($attenListRes);

			/* Reteriving Attending list end */
			
			/* Reteriving Seated list start */

			$getDayViewObj = new Reservation_Model_GetDayViewList();
			$getDayViewObj->setRestaurantId($resId);
			$getDayViewObj->setDate($date);
			$getDayViewObj->setIsAjaxCall(true);
			if(count($timesLimit)==2)
			{
				$getDayViewObj->setStartTime($timesLimit['start_time']);
				$getDayViewObj->setEndTime($timesLimit['end_time']);
			}
			/* Reteriving Reservation Status Id */
			$bookStatus = array('ALC','DES','BOK','PTS','CRD','WRD','BIL');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$getDayViewObj->setBookStatus($bookStatusRes);
			
			$attenListRes = $bookMapper->getDayViewList($getDayViewObj,$dayview['mealDetails']);
			$jsonattenList = json_encode($attenListRes);
			$dayview['Seated'] = $jsonattenList;				
			$dayview['SeatedCount'] = count($attenListRes);
			
			/* Reteriving Seated list end */				
			
			/* Reteriving Completed list start */

			$getDayViewObj = new Reservation_Model_GetDayViewList();
			$getDayViewObj->setRestaurantId($resId);
			$getDayViewObj->setDate($date);
			$getDayViewObj->setIsAjaxCall(true);
			if(count($timesLimit)==2)
			{
				$getDayViewObj->setStartTime($timesLimit['start_time']);
				$getDayViewObj->setEndTime($timesLimit['end_time']);
			}
			/* Reteriving Reservation Status Id */
			$bookStatus = array('COM','NOS', 'CAN');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$getDayViewObj->setBookStatus($bookStatusRes);
			
			$attenListRes = $bookMapper->getDayViewList($getDayViewObj,$dayview['mealDetails']);
			$jsonattenList = json_encode($attenListRes);
			$dayview['Completed'] = $jsonattenList;				
			$dayview['CompletedCount'] = count($attenListRes);
			
			/* Reteriving Completed list end */
			
			$getDayViewObj = new Reservation_Model_GetWaitingList();
			$getDayViewObj->setRestaurantId($resId);
			$getDayViewObj->setDate($date);
			$getDayViewObj->setIsAjaxCall(true);
			if(count($timesLimit)==2)
			{
				$getDayViewObj->setStartTime($timesLimit['start_time']);
				$getDayViewObj->setEndTime($timesLimit['end_time']);
			}
			/* Reteriving Reservation Status Id */
			$bookStatus = array('WAL','READY','QUOTE','BAR','NEXT','CANCUS','BACK');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

			$getDayViewObj->setBookStatus($bookStatusRes);
			$DayViewResWal = $bookMapper->getWaitingListForDayView($getDayViewObj,$dayview['mealDetails']);
			$jsonattenListwal = json_encode($DayViewResWal);
			$dayview['DayViewWal'] = $jsonattenListwal;
			
			$dayview['DayViewWalCount'] = count($DayViewResWal);

			/* Reteriving Waiting list end */
			$mealsettings = $this->ChekRestMealSettings($request);
			$dayview['mealSettings'] = $mealsettings;
			
			/* Reteriving Reservation Status Id */
			
			$bookStatus = array('RSD','OVB','BKD','ALC','DES','BOK','PTS','CRD','WRD','BIL','COM');
			$abouttoSeat = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
			
			$bookStatus = array('WAL','READY','QUOTE','BAR','NEXT','CANCUS','BACK');
			$waiting = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

//			$bookStatus = array('ALC','DES','BOK','PTS','CRD','WRD','BIL');
//			$seating = $bookStatusMapper->GetBookingStatusByCode($bookStatus);

//			$bookStatus = array('COM');
//			$seated = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
			$statusArr = array(
								'Upcoming'		=>	$abouttoSeat,
//								'Seated'		=>	$seating,
//								'Completed'		=>	$seated,
								'Waiting'		=>	$waiting
								);
			if(count($timesLimit)==2)
			{
					$dayview['reservCount'] = $bookMapper->RetrieveReservationCounts($resId,$date,$statusArr,$timesLimit);
			
			}
			else
			{
				$dayview['reservCount'] = $bookMapper->RetrieveReservationCounts($resId,$date,$statusArr);
			
			}
			
			$finalResevDesk = json_encode($dayview);

			return $finalResevDesk;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function RetrieveBookingsMonthView($request)
	{
		try{
			
			$restaurantid = $request->restaurantid;
			/* Get restaurant time settings */
			
			$MealTypeDataMapper = new FirmManagement_Model_FirmMealTypeDataMapper();
			$mealSettings = $MealTypeDataMapper->GetMealSettingsByRestId($restaurantid);
			
			$datesArr = array();
			
			if(count($mealSettings)>0){
				$selmonth = "";
				if($request->selmonth){
					$selmonth = $request->selmonth;
				}
				$resServ = new Application_Service_Firm();
				$timeZone = $resServ->GetRestaurantTimeZone($restaurantid);
				date_default_timezone_set($timeZone);
				
				$year  = "";
				$month = "";
				
				$firstDayOfMonth = "";
				$lastDayOfMonth  = "";
				
				$today = date('Y-m-d');
				if($selmonth){
				$explodeToday = explode('-',$selmonth);
					$year  = $explodeToday[0];
					$month = $explodeToday[1];
					
					$firstDayOfMonth = date('Y-m-d',mktime(0,0,0,$month,1,$year));
					$lastDayOfMonth	 = date('Y-m-t',mktime(0,0,0,$month,1,$year));	
				}else{
					
					$explodeToday = explode('-',$today);
					$year  = $explodeToday[0];
					$month = $explodeToday[1];
					
					$firstDayOfMonth = date('Y-m-d',mktime(0,0,0,$month,1,$year));
					$lastDayOfMonth	 = date('Y-m-t',mktime(0,0,0,$month,1,$year));
				}
									
				$BookingMonthView = new Reservation_Model_ReservationsMonthView();
				$BookingMonthView->setrestaurantid($restaurantid);
				$BookingMonthView->setfirstdayofmonth($firstDayOfMonth);
				$BookingMonthView->setlastdayofmonth($lastDayOfMonth);
				
				$bookStatus = array("BOK","COM","BKD","CRD","DES","PTS","RSD",'WAL','READY','QUOTE','BAR','NEXT','CANCUS','BACK',"OVB","WRD");
				$BookingMonthView->setbookstatus($bookStatus);
				
				$BookingDataMapper = new Reservation_Model_ReservationDataMapper();
				$bookRowSet = $BookingDataMapper->GetBookingsMonthView($BookingMonthView);
				
				/* Get Inventory Counts */
				$days = array('sun','mon','tue','wed','thu','fri','sat');
				$inventoryCount = $resServ->RetrieveBookingsCountMonthView($restaurantid,$days,1);
				
				/* Generate Date array and add bookings count */
				
				$days = cal_days_in_month(CAL_GREGORIAN, $month, $year);	
				
				$date = "";	
					
				for($i = 1; $i<= $days; $i++){				
					$date =  date('Y-m-d',mktime(0,0,0,$month,$i,$year));	
					$dateSplit = explode("-",$date);
					$weekday = date("D", mktime(0,0,0,$dateSplit[1],$dateSplit[2],$dateSplit[0]));	
					
					$freezeMapper = new Reservation_Model_RestaurantFreezeDataMapper();
					$freezeresult = $freezeMapper->getFreezeStatusForMealTypeByDateAndRestId($restaurantid, $date);
					
					$totalNoofBook = array();
					$totalNoofBookMade = array();
												
					if(array_key_exists(strtolower($weekday),$inventoryCount)){
						$totalNoofBook = $inventoryCount[strtolower($weekday)];
					}				
					if(array_key_exists($date,$bookRowSet)){
						$totalNoofBookMade = $bookRowSet[$date];
					}
					$desc= "";
					foreach($mealSettings as $setting){
						$bookmade = 0;
						$bookava  = 0;
						
						if(array_key_exists($setting,$totalNoofBookMade)){							
							$bookmade = $totalNoofBookMade[$setting];
						}
						
						if(array_key_exists($setting,$totalNoofBook)){							
							$bookava = $totalNoofBook[$setting];
						}
						
						
				//		if($bookmade != 0 || $bookava != 0){
							if(count($freezeresult) > 0 && $freezeresult['type'] == 'All'){
								if($setting == 'Breakfast'){
									$desc .= "<div class='freezecolor breakfastCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
								}else if($setting == 'Lunch'){
									$desc .= "<div class='freezecolor lunchCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
								}else if($setting == 'Brunch'){
									$desc .= "<div class='freezecolor brunchCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
								}else if($setting == 'Dinner'){
									$desc .= "<div class='freezecolor dinnerCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
								}
							}else if(count($freezeresult) > 0 && $freezeresult['type'] == 'Slot'){
								if($setting == 'Breakfast'){
									if(array_key_exists('Breakfast',$freezeresult)){
										foreach($freezeresult['count'] as $key=>$count){
											if($key == 'Breakfast' && $count == 'true'){
												$desc .= "<div class='freezecolor breakfastCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
												break;
											}else if($key == 'Breakfast'){
												$desc .= "<div class='partialfreezecolor breakfastCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
												break;
											}
										}
									}else{
										$desc .= "<div class='availablecolor breakfastCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
									}
								}else if($setting == 'Lunch'){
									if(array_key_exists('Lunch',$freezeresult)){
										foreach($freezeresult['count'] as $key=>$count){
											if($key == 'Lunch' && $count == 'true'){
												$desc .= "<div class='freezecolor lunchCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
												break;
											}else if($key == 'Lunch'){
												$desc .= "<div class='partialfreezecolor lunchCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
												break;
											}
										}
									}else{
										$desc .= "<div class='availablecolor lunchCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
									}
								}else if($setting == 'Brunch'){
									if(array_key_exists('Brunch',$freezeresult)){
										foreach($freezeresult['count'] as $key=>$count){
											if($key == 'Brunch' && $count == 'true'){
												$desc .= "<div class='freezecolor brunchCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
												break;
											}else if($key == 'Brunch'){
												$desc .= "<div class='partialfreezecolor brunchCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
												break;
											}
										}
									}else{
										$desc .= "<div class='availablecolor brunchCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
									}
								}else if($setting == 'Dinner'){
									if(array_key_exists('Dinner',$freezeresult)){
										foreach($freezeresult['count'] as $key=>$count){
											if($key == 'Dinner' && $count == 'true'){ 
												$desc .= "<div class='freezecolor dinnerCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
												break;
											}else if($key == 'Dinner'){
												$desc .= "<div class='partialfreezecolor dinnerCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
												break;
											}
										}
									}else{
										$desc .= "<div class='availablecolor dinnerCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
									}
								}
							}else{
								if($setting == 'Breakfast'){
									$desc .= "<div class='availablecolor breakfastCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
								}else if($setting == 'Lunch'){
									$desc .= "<div class='availablecolor lunchCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
								}else if($setting == 'Brunch'){
									$desc .= "<div class='availablecolor brunchCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
								}else if($setting == 'Dinner'){
									$desc .= "<div class='availablecolor dinnerCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
								}
							}
			//			}						
					}					
					$datesArr[$date] = $desc;
				}
			}			
			return $datesArr;
						
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getFreezeDataByDateandRestaurantidajax($request)
	{
		try{
			$restaurantid = $request->restaurantid;
			$date= $request->date;
			/* Get restaurant time settings */
			$MealTypeDataMapper = new FirmManagement_Model_FirmMealTypeDataMapper();
			$mealSettings = $MealTypeDataMapper->GetMealSettingsByRestId($restaurantid);
			$desc= "";
			if(count($mealSettings)>0){
				$BookingMonthView = new Reservation_Model_ReservationsMonthView();
				$BookingMonthView->setrestaurantid($restaurantid);
				$BookingMonthView->setfirstdayofmonth($date);
				$BookingMonthView->setlastdayofmonth($date);
					
				$bookStatus = array("BOK","COM","BKD","CRD","DES","PTS","RSD",'WAL','READY','QUOTE','BAR','NEXT','CANCUS','BACK',"OVB","WRD");
				$BookingMonthView->setbookstatus($bookStatus);
					
				$BookingDataMapper = new Reservation_Model_ReservationDataMapper();
				$bookRowSet = $BookingDataMapper->GetBookingsMonthView($BookingMonthView);
					
				/* Get Inventory Counts */
				$dateSplit = explode("-",$date);
				$weekday = date("D", mktime(0,0,0,$dateSplit[1],$dateSplit[2],$dateSplit[0]));	
				$days = array($weekday);
				$resServ = new Application_Service_Firm();
				$inventoryCount = $resServ->RetrieveBookingsCountMonthView($restaurantid,$days,1);
					
				$freezeMapper = new Reservation_Model_RestaurantFreezeDataMapper();
				$freezeresult = $freezeMapper->getFreezeStatusForMealTypeByDateAndRestId($restaurantid, $date);
					
				$totalNoofBook = array();
				$totalNoofBookMade = array();
												
				if(array_key_exists(strtolower($weekday),$inventoryCount)){
					$totalNoofBook = $inventoryCount[strtolower($weekday)];
				}				
				if(array_key_exists($date,$bookRowSet)){
					$totalNoofBookMade = $bookRowSet[$date];
				}
				foreach($mealSettings as $setting){
					$bookmade = 0;
					$bookava  = 0;
					
					if(array_key_exists($setting,$totalNoofBookMade)){							
						$bookmade = $totalNoofBookMade[$setting];
					}
					
					if(array_key_exists($setting,$totalNoofBook)){							
						$bookava = $totalNoofBook[$setting];
					}
					if(count($freezeresult) > 0 && $freezeresult['type'] == 'All'){
						if($setting == 'Breakfast'){
							$desc .= "<div class='freezecolor breakfastCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
						}else if($setting == 'Lunch'){
							$desc .= "<div class='freezecolor lunchCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
						}else if($setting == 'Brunch'){
							$desc .= "<div class='freezecolor brunchCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
						}else if($setting == 'Dinner'){
							$desc .= "<div class='freezecolor dinnerCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
						}
					}else if(count($freezeresult) > 0 && $freezeresult['type'] == 'Slot'){
						if($setting == 'Breakfast'){
							if(array_key_exists('Breakfast',$freezeresult)){
								foreach($freezeresult['count'] as $key=>$count){
									if($key == 'Breakfast' && $count == 'true'){
										$desc .= "<div class='freezecolor breakfastCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
										break;
									}else if($key == 'Breakfast'){
										$desc .= "<div class='partialfreezecolor breakfastCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
										break;
									}
								}
							}else{
								$desc .= "<div class='availablecolor breakfastCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
							}
						}else if($setting == 'Lunch'){
							if(array_key_exists('Lunch',$freezeresult)){
								foreach($freezeresult['count'] as $key=>$count){
									if($key == 'Lunch' && $count == 'true'){
										$desc .= "<div class='freezecolor lunchCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
									}else if($key == 'Lunch'){
										$desc .= "<div class='partialfreezecolor lunchCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
										break;
									}
								}
							}else{
								$desc .= "<div class='availablecolor lunchCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
							}
						}else if($setting == 'Brunch'){
							if(array_key_exists('Brunch',$freezeresult)){
								foreach($freezeresult['count'] as $key=>$count){
									if($key == 'Brunch' && $count == 'true'){
										$desc .= "<div class='freezecolor brunchCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
										break;
									}else if($key == 'Brunch'){
										$desc .= "<div class='partialfreezecolor brunchCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
										break;
									}
								}
							}else{
								$desc .= "<div class='availablecolor brunchCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
							}
						}else if($setting == 'Dinner'){
							if(array_key_exists('Dinner',$freezeresult)){
								foreach($freezeresult['count'] as $key=>$count){
									if($key == 'Dinner' && $count == 'true'){ 
										$desc .= "<div class='freezecolor dinnerCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
										break;
									}else if($key == 'Dinner'){
										$desc .= "<div class='partialfreezecolor dinnerCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
										break;
									}
								}
							}else{
								$desc .= "<div class='availablecolor dinnerCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
							}
						}
					}else{
						if($setting == 'Breakfast'){
							$desc .= "<div class='availablecolor breakfastCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
						}else if($setting == 'Lunch'){
							$desc .= "<div class='availablecolor lunchCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
						}else if($setting == 'Brunch'){
							$desc .= "<div class='availablecolor brunchCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
						}else if($setting == 'Dinner'){
							$desc .= "<div class='availablecolor dinnerCls' id='".$date."'>".$setting."<span>".$bookmade."</span></div>";
						}
					}						
				}
			}			
			return $desc;
						
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function RetrieveBookingsWeekView($request)
	{
		try{
			
			$restaurantid = $request->restaurantid;
			$datesArr = array();
			
			$resServ = new Application_Service_Firm();
			$timeZone = $resServ->GetRestaurantTimeZone($restaurantid);
			date_default_timezone_set($timeZone);
			
			$year  = "";
			$month = "";
			
			$lastDayOfWeek  = "";
			
			if($request->date){
				$today = $request->date;
				$todaydate = date("d M Y",strtotime($request->date));
			}else{
				$today = date('Y-m-d');
				$todaydate = date("d M Y");
			}

			$explodeToday = explode('-',$today);
			$year  = $explodeToday[0];
			$month = $explodeToday[1];
			
			$lastDayOfWeek	= date('Y-m-d',mktime(0,0,0,$month,$explodeToday[2]+6,$year));
			$currentday = $today;
			
			$BookingWeekView = new Reservation_Model_ReservationsWeekView();
			$BookingWeekView->setrestaurantid($restaurantid);
			$BookingWeekView->setfirstdayofweek($today);
			$BookingWeekView->setlastdayofweek($lastDayOfWeek);
			
			$bookStatus = array("BOK","BKD","COM","CRD","DES","PTS","RSD",'WAL','READY','QUOTE','BAR','NEXT','CANCUS','BACK',"OVB","WRD");
			$BookingWeekView->setbookstatus($bookStatus);
			
			$BookingDataMapper = new Reservation_Model_ReservationDataMapper();
			$bookRowSet = $BookingDataMapper->GetBookingsWeekView($BookingWeekView);
			
			/* Generate Date array and add bookings count */
			
			$date = "";	
			$weekDayArr = array();
			$weekdDateArr = array();
			$displaydateArr = array();
			$partysizecountArr = "";
			$finalArr = array();
				
			for($i = 0; $i<= 6; $i++){				
				$date =  date('Y-m-d',mktime(0,0,0,$month,$explodeToday[2]+$i,$year));
				$weekdDateArr[] = $date;	
				$dateSplit = explode("-",$date);
				$weekday = date("D", mktime(0,0,0,$dateSplit[1],$dateSplit[2],$dateSplit[0]));	
				$weekDayArr[] = strtolower($weekday);
				$displaydateArr[$weekday] = date("dS M",mktime(0,0,0,$month,$explodeToday[2]+$i,$year)) ; 
				$totalNoofBookMade = array();
											
				if(array_key_exists($date,$bookRowSet)){
					$totalNoofBookMade = $bookRowSet[$date];
				}
				
				$datesArr[$date.'_'.$weekday] = $totalNoofBookMade;
			}	
			$resschmapper = new FirmManagement_Model_FirmScheduleTableDataMapper();
			$partysizecountArr = $resschmapper->getSumOfPartysizesByDay($restaurantid,$weekDayArr);	
			
			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);			
			$bookingcount = $BookingDataMapper->getSumOfReservations($restaurantid, $weekdDateArr, $bookStatusRes);
			
			$finalArr['partysizecountArr'] = $partysizecountArr;
			$finalArr['bookingcount'] = $bookingcount;
			$finalArr['displaydate'] = $displaydateArr;
			$finalArr['dateArr'] = $datesArr;
			$finalArr['today'] = $today;
			$finalArr['todaydate'] = $todaydate;
			return $finalArr;
						
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function ChekRestMealSettings($request)
	{
		try{
			$MealTypeDataMapper = new FirmManagement_Model_FirmMealTypeDataMapper();
			$mealSettings = $MealTypeDataMapper->GetMealSettingsByRestId($request->restaurantid);
			if(count($mealSettings)>0){
				return "t";
			}else{
				return "f";
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function ManageCustomMenu(array $data)
	{
		try{
			$custom = new Reservation_Model_RestaurantCustomMenu();
			$custom->setRestId($data['restid'])
					->setMenuType($data['menuType'])
					->setMenuCode($data['menuCode'])
					->setMenuDesc($data['menuDesc'])
					->setStatus('T');
			if($data['menuId']){
				$custom->setId($data['menuId']);
			}
			$mapper = new Reservation_Model_RestaurantCustomMenuMapper();
			$result = $mapper->ManageCustomMenu($custom);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getReservationMenu($resid,$stat = 'get')
	{
		try{
			$custom = new Reservation_Model_RestaurantCustomMenu();
			$custom->setRestId($resid);
			$mapper = new Reservation_Model_RestaurantCustomMenuMapper();
			$result = $mapper->GetCustomMenu($custom,$stat);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function ChangeReservationMenuStatus($request)
	{
		try{
			$custom = new Reservation_Model_RestaurantCustomMenu();
			$custom->setRestId($request->restid);
			$custom->setStatus($request->status)
					->setMenuType($request->menuType)
					->setMenuCode($request->menuCode);
			$mapper = new Reservation_Model_RestaurantCustomMenuMapper();
			$result = $mapper->ChangeCustomMenuStatus($custom);
			return $result;			
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function addBookingOptions(array $formData,$userData,$request)
	{
		try{
			$date = date('m-d-Y');
			$time = date('H:i:s');
			$mapper = new Reservation_Model_ReservationOptionsDataMapper();
			$BookingOptions = new Reservation_Model_ReservationOptions();
			$BookingOptions->setDescription($formData['description'])
				->setResid($request->restaurantid)
				->setStatus('true')
				->setCreatedDateTime($date.' '.$time)
				->setCreatedbyId($userData['User_Id'])
				->setCode($formData['addcode'])
				->setType("PRIMARY");
				
			$result = $mapper->AddBookingOptions($BookingOptions);
			return $result;
					
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
		
	}
	
	public function addSecondaryBookingOptions(array $formData,$userData,$request)
	{
		try{
			$date = date('m-d-Y');
			$time = date('H:i:s');
			$mapper = new Reservation_Model_ReservationOptionsDataMapper();
			$BookingOptions = new Reservation_Model_ReservationOptions();
			$BookingOptions->setDescription($formData['description'])
				->setResid($request->restaurantid)
				->setStatus('true')
				->setCreatedDateTime($date.' '.$time)
				->setCreatedbyId($userData['User_Id'])
				->setCode($formData['addcode'])
				->setType("SECONDARY");
				
			$result = $mapper->AddBookingOptions($BookingOptions);
			return $result;
					
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}		
	}
	
	public function EditBookingOptions(array $formData,$userData,$request)
	{
		try{
			$date = date('Y-m-d');
			$time = date('H:i:s');
			$mapper = new Reservation_Model_ReservationOptionsDataMapper();
			$BookingOptions = new Reservation_Model_ReservationOptions();
			$BookingOptions->setDescription($formData['editdescription'])
				->setResid($request->restaurantid)
				->setStatus('true')
				->setUpdatedDateTime($date.' '.$time)
				->setUpdatedbyId($userData['User_Id'])
				->setId($formData['bokoptionid'])
				->setCode($formData['editcode']);
				
			$result = $mapper->EditBookingOptions($BookingOptions);
			return $result;
					
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
		
	}	

	public function getBookingOptionsListByRestid($restid)
	{
		try{
//			$restid = $request->restid;
			$mapper = new Reservation_Model_ReservationOptionsDataMapper();
			$result = $mapper->GetBookingOptionsListByRestid($restid);
			return $result;
		}catch(Exception $ex){	
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function UpdateBookingOptionStatus($request)
	{
		try{
			$id = $request->id;
			$status = $request->status;
			$mapper = new Reservation_Model_ReservationOptionsDataMapper();
			$bokoptions = new Reservation_Model_ReservationOptions();
			$bokoptions->setId($id);
			$bokoptions->setStatus($status);
			$result = $mapper->UpdateBookingOptionStatus($bokoptions);
			return $result;
		}catch(Exception $ex){	
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getBookingOptionsByresId($request)
	{
		try{
			$bokoptions = new Reservation_Model_ReservationOptions();
			$bokoptions->setResid($request->restaurantid);
                        $bokoptions->setCompanyid($request->rescompanyid);
			$mapper = new Reservation_Model_ReservationOptionsDataMapper();
			$result = $mapper->getBookingOptionsByresId($bokoptions);
			return $result;			
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getSecBookingOptionsByresId($request)
	{
		try{
			$bokoptions = new Reservation_Model_ReservationOptions();
			$bokoptions->setResid($request->restaurantid);
			$mapper = new Reservation_Model_ReservationOptionsDataMapper();
			$result = $mapper->getSecBookingOptionsByresId($bokoptions);
			return $result;			
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function MessageDisplayDetails($emailMessage,$sender)
	{
		try{
			$bokid = $emailMessage->emsg_fk_bokid;
			
			$mapper = new Reservation_Model_ReservationDataMapper();
			/* get phrase id with booking */
			$phraseId = $mapper->GetBookingPhraseByBookid($bokid);
			
			$bookResult = $this->GetBookingDetails($bokid);
			$resid = $bookResult->getbokfk_restaurant();
			$resDataMapper = new FirmManagement_Model_FirmDataMapper();
			$restObj= new FirmManagement_Model_FirmById();
			$restObj->setRestaurantId($bookResult->getbokfk_restaurant());
			$resDetails = $resDataMapper->getRestaurantById($restObj);
			
			$request = Zend_Controller_Front::getInstance()->getRequest();
			$msgSub = trim($emailMessage->emsg_subject);
			$browserMode = "N";
			if(isset($request->viewPage)){
				if($request->viewPage == 'Phone'){
					$browserMode = $request->viewPage;
					$msgSub .= "Mobile";
				}
			}
			$splresult = '';
			if($bookResult->getbokbooking_type_code() == 'SPL' || $bookResult->getbokbooking_type_code() == 'SPLPAID'){
				$isAjaxCall = true;
				$splmapper = new Deals_Model_RestaurantSpecialDataMapper();
				$splresult = $splmapper->getRestaurantSplByBookingId($bokid,$isAjaxCall);
			}
			$stateCity = $this->getRestaurantStateByResId($bookResult->getbokfk_restaurant());
			$stateId = $stateCity['state'];
			$cityId = $stateCity['city'];
			$regionId = $stateCity['region'];
			$templateBdMapper = new Application_Model_EmailtemplateDataMapper();
			$template = $templateBdMapper->getEmailTempByCode($msgSub);
//			$template = $templateBdMapper->getEmailTempByCode('BookReminder');
			if($template){
				$name     = $bookResult->getbokfirst_name().' '.$bookResult->getboklast_name();
				$restname = $bookResult->getresrestaurant_name();
				$resdate  = '';
				if(substr($msgSub,0,-6) == 'Cancel' || $msgSub == 'Cancel'){
					$splitbookdate = explode('-',$bookResult->getbokbooking_date());
					$resdate  = date('m-d-Y',mktime(0,0,0,$splitbookdate[1],$splitbookdate[2],$splitbookdate[0]));
				}else{
					$splitbookdate = explode('-',$bookResult->getbokbooking_date());
					$resdate  = date('m-d-Y',mktime(0,0,0,$splitbookdate[1],$splitbookdate[2],$splitbookdate[0]));
//					$resdate  = $bookResult->getbokbooking_date();
				}
				
				$time     = $bookResult->getbokbooking_timings();
				$size     = $bookResult->getbokparty_size();
				$address  = $bookResult->getresaddress();
				$resphone = $bookResult->getResPhone();
				$status	  = $bookResult->getbokbooking_status_code();
				$bokid    = $bokid;
				$state	  = $stateId;
				$city	  = $cityId;
				$resemail = $resDetails->getRestemail();
				$reszipcode = $bookResult->getResZipcode();
				$rescity  = $bookResult->getResCity();
				$resnbh   = $bookResult->getResNeighborhood();
				$manager  = $resDetails->getRestmanagername();
				$horAdTemplates = array('Cancel','CancelMobile','No-Show','No-ShowMobile','BookNotf','BookNotCan');
				$subject = $template->msg_subject;
				$body    = $template->msg_body;
							
				$body    = str_replace("%firstname%",$name,$body);
				$body    = str_replace("%restname%",$restname,$body);
				$body    = str_replace("%date%",$resdate,$body);
				$body    = str_replace("%time%",$time,$body);
				$body    = str_replace("%resid%",$resid,$body);
				$body    = str_replace("%size%",$size,$body);
				$body	 = str_replace("%address%",$address,$body);
				$body	 = str_replace("%resphone%",$resphone,$body);
				$body	 = str_replace("%bookingid%",$bokid,$body);
				$body	 = str_replace("%bokid%",$bookResult->getbokbookingphrase(),$body);
				$body	 = str_replace("%resnbh%",$resnbh,$body);
				$body	 = str_replace("%rescity%",$rescity,$body);
				$body	 = str_replace("%resemail%",$resemail,$body);
				$body    = str_replace("%manager%",$manager,$body);
				$body	 = str_replace("%reszipcode%",$reszipcode,$body);
				
				$div = '';
				$imgDiv = '';
				$mobDiv = '';
				if(substr($msgSub,0,-6) == 'Cancel' || $msgSub == 'Cancel'){
					if($browserMode == 'Phone'){
						$div = '<p>To learn more about the services of our sponsor please <a href="%webLink%"  target="newwindow">Click here</a></p>';
						$imgDiv = '<img src="http://www.dinedesk.com%img%" height="100" width="150" />';
					}else{
						$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div>%img%</br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
//						$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div>%img%</br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';	
						$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.dinedesk.com%img%" width="150" height="150"/>';
					}
				}if(substr($msgSub,0,-6) == 'notifyfriends' || $msgSub == 'notifyfriends'){
					$body = str_replace("%senderemail%",$sender,$body);
					if($browserMode == 'Phone'){
						$div = '<p>To learn more about the services of our sponsor please <a href="%webLink%"  target="newwindow">Click here</a></p>';
						$imgDiv = '<img src="http://www.dinedesk.com%img%" height="100" width="150" />';
					}else{
						$div = '<td width="45%" valign="top" align="left">%img%</br><div>%desc%</div></td>';
						$imgDiv = '<div><img src="http://www.dinedesk.com%img%" width="150" height="150"/></div>';
						$spldiv = '<div style="background: #f1ede8;box-shadow: 5px 5px 30px #808080;-moz-box-shadow: 5px 5px 30px #808080;-khtml-box-shadow: 5px 5px 30px #808080;-webkit-box-shadow: 5px 5px 30px #808080;border:3px solid #643513; padding:8px; font-size:12px;"><div style="color:#F79646; font-weight:bold; text-align:center;">%splname%</div><br /><div style="color:#4f6228; font-weight:bold;">Special Id: %splid%</div><br /><br /><div style="color:#000048;">%spldesc%</div></div><br /><br />';
						if($splresult){
							$splid 			= $splresult['Id'];
							$splname		= $splresult['Special Name'];
							$spldesc 		= $splresult['Desc'];
							$splorgprice	= $splresult['Regular Price'];
							if($splresult['Discountcode'] == 'PER'){
								$spldiscount= $splresult['Discount Percentage'].'%';	
							}else if($splresult['Discountcode'] == 'RE'){
								$spldiscount= '$'.$splresult['Discount Percentage'];
							}
							$splprice	 	= $splresult['Price with Discount'];
							
							$body	= str_replace("%splname%",$splname,$body);
							$body	= str_replace("%splid%",$splid,$body);
							$body	= str_replace("%spldesc%",$spldesc,$body);
	//						$body	= str_replace("%orgprice%",$splorgprice,$body);
	//						$body	= str_replace("%discount%",$spldiscount,$body);
	//						$body	= str_replace("%price%",$splprice,$body);
							
						}else{
							$body	= str_replace($spldiv,'',$body);
						}	
					}
				}else{
					if($browserMode == "m"){
						$div = '<p>To learn more about the services of our sponsor please <a href="%webLink%"  target="newwindow">Click here</a></p>';
						$imgDiv = '<img src="http://www.dinedesk.com%img%" height="100" width="150" />';
					}else{
						if(substr($msgSub,0,-6) == 'No-Show' || $msgSub == 'No-Show'){
							$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div>%img%</br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
						}else{
							$div = '<td width="44%" valign="top" align="left">%img%</br><div>%desc%</div></td>';
						}
						$imgDiv = '<div><img src="http://www.dinedesk.com%img%" width="150" height="150"/></div>';
						$spldiv = '<div class="box-shadow"><div style="color:#F79646; font-weight:bold; text-align:center;">%splname%</div><br /><div style="color:#4f6228; font-weight:bold;">Special Id: %splid%</div><br /><br /><div style="color:#000048;">%spldesc%</div></div><br /><br />';
						if($splresult){
							$splid 			= $splresult['Id'];
							$splname		= $splresult['Special Name'];
							$spldesc 		= $splresult['Desc'];
							$splorgprice	= $splresult['Regular Price'];
							if($splresult['Discountcode'] == 'PER'){
								$spldiscount= $splresult['Discount Percentage'].'%';	
							}else if($splresult['Discountcode'] == 'RE'){
								$spldiscount= '$'.$splresult['Discount Percentage'];
							}
							$splprice	 	= $splresult['Price with Discount'];
							
							$body	= str_replace("%splname%",$splname,$body);
							$body	= str_replace("%splid%",$splid,$body);
							$body	= str_replace("%spldesc%",$spldesc,$body);
	//						$body	= str_replace("%orgprice%",$splorgprice,$body);
	//						$body	= str_replace("%discount%",$spldiscount,$body);
	//						$body	= str_replace("%price%",$splprice,$body);
							
						}else{
							$body	= str_replace($spldiv,'',$body);
						}
					}
					
				}
				$userType = 'CUS';
				if($emailMessage->emsg_campaignid){
					
					$adminService = new Application_Service_Administrator();
					$campProp = new Application_Model_GetCampaignForPost();
					$campProp->setCampId($emailMessage->emsg_campaignid)
							->setAudType($userType)
							->setStateId($stateId)
							->setCityId($cityId)
							->setRegionId($regionId)
							->setIsAjaxCall(false);
					$campDetails = array();
					$campId  	= '';
					$campname 	= '';
					$desc  		= '';
					$img 	  	= '';
					$link		= '';
					$display  	= '';
					if(!$resDetails->getrescampaignstatus() === false){
						$campDetails = $adminService->GetCampaignDetails($campProp);
						if(count($campDetails)){
							$count = count($campDetails);
							$campaign = $campDetails[0];
							if($browserMode == "m"){
								$notfService = new Application_Service_Communication();
	//							$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
								$campname = trim($campaign->getSponsor());
								$desc =	trim($campaign->getCampDesc());
								$img =	trim($campaign->getCampImage());
								$campId	= $campaign->getId();
								$link = trim($campaign->getLink());
								$countLink = "http://www.dinedesk.com/Phone/Reservations/CampaignLinkCount/scid/".$campId;
								if($link){
									$body 	= str_replace("%webLink%",$countLink,$body);
								}else{
									$body    = str_replace($div,'',$body);
								}
								$body    = str_replace("%campName%",$campname,$body);
								if($img){
									$imgDiv 	= str_replace("%img%",$img,$imgDiv);
									$body    	= str_replace("%img%",$imgDiv,$body);
								}else{
									$imgDiv 	= str_replace("%img%","/images/inat-logo-2.png",$imgDiv);
									$body    	= str_replace("%img%",$imgDiv,$body);
								}
							}else{
								$notfService = new Application_Service_Communication();
	//							$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
								$campname = trim($campaign->getSponsor());
								$desc =	trim($campaign->getCampDesc());
								$img =	trim($campaign->getCampImage());
								$campId	= $campaign->getId();
								$desc  		= str_replace('src="','src="http://www.dinedesk.com',$desc);
								$display  	= 'block';
								$body    = str_replace("none",$display,$body);
								$body    = str_replace("%desc%",$desc,$body);
								if($img){
									$imgDiv 	= str_replace("%img%",$img,$imgDiv);
									$body    	= str_replace("%img%",$imgDiv,$body);
								}else{
									$body    = str_replace($imgDiv,'',$body);
								}
								$body    = str_replace("%campName%",$campname,$body);	
							}
						}else{
							if(in_array($msgSub,$horAdTemplates)){
								$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div>%img%</br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
								$asSense = '<div class="gap"></div><script type="text/javascript">google_ad_client = "%client%";/* testin */google_ad_slot = "%slot%";google_ad_width = %wid%;google_ad_height = %hei%;</script><script type="text/javascript" src="http://pagead2.googlesyndication.com/pagead/show_ads.js"></script>';
								$asSense = str_replace('%client%','ca-pub-2808144937131233',$asSense);
								$asSense = str_replace('%slot%','4749209788',$asSense);
								$asSense = str_replace('%wid%','728',$asSense);
								$asSense = str_replace('%hei%','90',$asSense);
								$body    = str_replace($div,$asSense,$body);
							}else{
								if($browserMode != "m"){
									$asSense = '<script type="text/javascript">google_ad_client = "%client%";/* testin */google_ad_slot = "%slot%";google_ad_width = %wid%;google_ad_height = %hei%;</script><script type="text/javascript" src="http://pagead2.googlesyndication.com/pagead/show_ads.js"></script>';
									$asSense = str_replace('%client%','ca-pub-2808144937131233',$asSense);
									$asSense = str_replace('%slot%','7461566461',$asSense);
									$asSense = str_replace('%wid%','250',$asSense);
									$asSense = str_replace('%hei%','250',$asSense);
									$body    = str_replace($div,'<td width="44%" valign="top" align="left">'.$asSense.'</td>',$body);
									
								}
							}
							$body    = str_replace("%campName%",'DineDesk',$body);
							if($browserMode == "m"){
								$div = '<p>To learn more about the services of our sponsor please <a href="%webLink%"  target="newwindow">Click here</a></p>';
								$asSense = '<script type="text/javascript">google_ad_client = "%client%";/* testin */google_ad_slot = "%slot%";google_ad_width = %wid%;google_ad_height = %hei%;</script><script type="text/javascript" src="http://pagead2.googlesyndication.com/pagead/show_ads.js"></script>';
								$asSense = str_replace('%client%','ca-pub-2808144937131233',$asSense);
								$asSense = str_replace('%slot%','5563613420',$asSense);
								$asSense = str_replace('%wid%','300',$asSense);
								$asSense = str_replace('%hei%','250',$asSense);
								
//								$imgDiv 	= str_replace("%img%","/images/inat-logo-2.png",$imgDiv);
//								$body    	= str_replace("%img%",$imgDiv,$body);
								$body    = str_replace('%img%',$asSense,$body);
								$body    = str_replace($div,'',$body);
							}
						}						
					}
				}else{
					if(in_array($msgSub,$horAdTemplates)){
						$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div>%img%</br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
						$asSense = '<div class="gap"></div><script type="text/javascript">google_ad_client = "%client%";/* testin */google_ad_slot = "%slot%";google_ad_width = %wid%;google_ad_height = %hei%;</script><script type="text/javascript" src="http://pagead2.googlesyndication.com/pagead/show_ads.js"></script>';
						$asSense = str_replace('%client%','ca-pub-2808144937131233',$asSense);
						$asSense = str_replace('%slot%','4749209788',$asSense);
						$asSense = str_replace('%wid%','728',$asSense);
						$asSense = str_replace('%hei%','90',$asSense);
						$body    = str_replace($div,$asSense,$body);
					}else{
						if($browserMode != "m"){
							$asSense = '<script type="text/javascript">google_ad_client = "%client%";/* testin */google_ad_slot = "%slot%";google_ad_width = %wid%;google_ad_height = %hei%;</script><script type="text/javascript" src="http://pagead2.googlesyndication.com/pagead/show_ads.js"></script>';
							$asSense = str_replace('%client%','ca-pub-2808144937131233',$asSense);
							$asSense = str_replace('%slot%','7461566461',$asSense);
							$asSense = str_replace('%wid%','250',$asSense);
							$asSense = str_replace('%hei%','250',$asSense);
							$body    = str_replace($div,'<td width="44%" valign="top" align="left">'.$asSense.'</td>',$body);
//							$body    = str_replace($div,'<td width="44%" valign="top" align="left"></td>',$body);
						}
					}
					if($browserMode == "m"){
						$div = '<p>To learn more about the services of our sponsor please <a href="%webLink%"  target="newwindow">Click here</a></p>';
						$asSense = '<script type="text/javascript">google_ad_client = "%client%";/* testin */google_ad_slot = "%slot%";google_ad_width = %wid%;google_ad_height = %hei%;</script><script type="text/javascript" src="http://pagead2.googlesyndication.com/pagead/show_ads.js"></script>';
						$asSense = str_replace('%client%','ca-pub-2808144937131233',$asSense);
						$asSense = str_replace('%slot%','5563613420',$asSense);
						$asSense = str_replace('%wid%','300',$asSense);
						$asSense = str_replace('%hei%','250',$asSense);
								
//								$imgDiv 	= str_replace("%img%","/images/inat-logo-2.png",$imgDiv);
//								$body    	= str_replace("%img%",$imgDiv,$body);
						$body    = str_replace('%img%',$asSense,$body);
						$body    = str_replace($div,'',$body);
					}
					$body    = str_replace("%campName%",'DineDesk',$body);
				}
			}
			return $body;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function SyncReservationsByRestId($restaurantid)
	{
		try{
			
			$fianalArr = array();
			$resServ = new Application_Service_Firm();
			$timeZone = $resServ->GetRestaurantTimeZone($restaurantid);
			date_default_timezone_set($timeZone);			
			$date	= date('Y-m-d');
			
			$optionsmapper = new Reservation_Model_ReservationOptionsDataMapper();
			$bokoptionsArr = $optionsmapper->GetBookingOptionsByRestaurantId($restaurantid);
			
			$bokmapper = new Reservation_Model_ReservationDataMapper($restaurantid);
			$bokresult = $bokmapper->SynchronizationOfReservationsByRestaurantid($restaurantid,$date);
			$bookingTableDate = $bokresult['bookingsArr'];
			$bokingIds = $bokresult['bokidsArr'];
			
			$bookingcountTabledata = $bokmapper->GetbookingCountTableData($restaurantid,$date);
			
			$bookaccumalativeinventory   = array();
			$bookasigntabledata 		 = array();
			$bokwaitingquotemapTableData = array();
			$bokoptionsmapTabledata 	 = array();
			$booking_fb_event 			 = array();
			$booking_fb_invite 			 = array();
			$booking_invitedguests 		 = array();
			$menu_order					 = array();
			$booking_menu_order 		 = array();
			$booking_menu_items 		 = array();
			
			if($bokingIds){
				
				$bookasigntabledata = $bokmapper->GetBookingtableDataByBookingIds($bokingIds);
			
				$quoteMapDataMapper  = new Reservation_Model_ReservationWaitingQuoteMapDataMapper();
				$bokwaitingquotemapTableData = $quoteMapDataMapper->GetWaitingQuoteByBookingIds($bokingIds);
				
				$bokoptionmapmaper = new Reservation_Model_ReservationOptionsMapDataMapper();
				$bokoptionsmapTabledata = $bokoptionmapmaper->GetBookingOptionsByBookingIds($bokingIds);
				
				/* Get Bookings Accumalative Inventory */
				
				$AccumulativeMapper = new Reservation_Model_ReservationAccumulativeInventoryMapper();
				$bokAccumulativeArr = $AccumulativeMapper->GetBookingAccumulativeInventorysByBookingIds($bokingIds);
				
				/* Get Fb Booking FB Eevents */
				$FBEventDataMapper = new Reservation_Model_ReservationFBEventDataMapper();
				$fb_event = $FBEventDataMapper->RetrieveReservationFbEvents($bokingIds);
				
				if($fb_event["status"] == true)
				{
					/* Get Fb Invited */
					$FBInviteDataMapper = new Reservation_Model_ReservationFBInviteDataMapper();
					$booking_fb_invite = $FBInviteDataMapper->RetrieveFbEventInvites($fb_event["fb_event_ids"]); 
				}	

				/* Get Invited Guest List  */
				$InvitedGuestDataMapper = new Reservation_Model_ReservationInvitedGuestDataMapper();
				$booking_invitedguests  = $InvitedGuestDataMapper->RetrieveInvitedGuestList;
				
				/* Get Booking Menu Order */
				$MenuOrderDataMapper = new Reservation_Model_ReservationMenuOrderDataMapper();
				$menu_order = $MenuOrderDataMapper->RetrieveReservationMenuOrder($bokingIds);
				if($menu_order["status"] == true)
				{
					$booking_menu_order = $menu_order["menuorder"];
					$MenuItemsDataMapper = new Reservation_Model_ReservationMenuItemsDataMapper();
					$booking_menu_items = $MenuItemsDataMapper->RetrieveMenuItems($menu_order["menuids"]);
				}
			}		

			
			
			$fianalArr['bookinTabledata']			  = $bookingTableDate;



			$fianalArr['bookingcountTabledata']		  = $bookingcountTabledata;
			$fianalArr['bookingasignTabledata']		  = $bookasigntabledata;			
			$fianalArr['bookingoptionTabledata']	  = $bokoptionsArr;
			$fianalArr['bookingoptinsmapTabledata']	  = $bokoptionsmapTabledat;	
			$fianalArr['bokwaitingquotemapTableData'] = $bokwaitingquotemapTableData;
			$fianalArr['booking_fb_event']			  = $booking_fb_event;	
			$fianalArr['booking_fb_invite']			  = $booking_fb_invite;	
			$fianalArr['booking_invitedguests']		  = $booking_invitedguests;	
			$fianalArr['booking_menu_order']		  = $booking_menu_order;
			$fianalArr['booking_menu_items']		  = $booking_menu_items;
			$fianalArr['bokAccumulativeArr']		  = $bokAccumulativeArr;

			
			return $fianalArr;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function MigrateBookings($request)
	{
		try{
			if($request->bookdetails){
				
				$bookDetails = json_decode($request->bookdetails);
				$mapper = new Reservation_Model_ReservationDataMapper();
				$result = $mapper->MigrateBookings($bookDetails);
				foreach($result['bookDetails'] as $row){
					if($row->bokwebbookingid && $row->bokwebbookingid != null){
					
					}else{
						$resDataMapper = new FirmManagement_Model_FirmDataMapper();
						$restObj= new FirmManagement_Model_FirmById();
						$restObj->setRestaurantId($row->bokfk_restaurant);
						$resDetails = $resDataMapper->getRestaurantById($restObj);
						$splresult = '';
	//					if($formData['booktype'] == 'SPL'){
	//						$isAjaxCall = true;
	//						$splmapper = new Deals_Model_RestaurantSpecialDataMapper();
	//						$splresult = $splmapper->getRestaurantSplByBookingId($result,$isAjaxCall);
	//					}
	
						$stateCity = $this->getRestaurantStateByResId($row->bokfk_restaurant);
						$stateId = $stateCity['state'];
						$cityId = $stateCity['city'];
						$regionId = $stateCity['region'];
									
						$userType = 'CUS';
						$adminService = new Application_Service_Administrator();
						$campProp = new Application_Model_GetCampaignForPost();
						$campProp->setAudType($userType)
						->setStateId($stateId)
						->setCityId($cityId)
						->setRegionId($regionId)
						->setIsAjaxCall(false);		
						$campDetails = array();
						if(!$resDetails->getrescampaignstatus() === false){
							$campDetails = $adminService->GetCampaignDetails($campProp);
						}
								
						$mailObj = new Communication_Model_Mail();
						$mailmapper = new Application_Service_Communication();
						$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
						$bookStatusArr = $bookStatusMapper->GetBookingStatusById(array($row->bokbooking_status_id));
						$bookStatus = $bookStatusArr[$row->bokbooking_status_id];
						if($row->bokemail != ''){
							if($stateId == ""){
								$stateCity = $this->getRestaurantStateByResId($row->bokfk_restaurant);
								$stateId = $stateCity['state'];
								$cityId = $stateCity['city'];
								$regionId = $stateCity['region'];
							}
							if($bookStatus->getCode() == 'RES'){
								$mailObj->setMsgCode('ReSchedule');
								$name = $row->bokfirst_name.' '.$row->boklast_name;
	
								$data = array(
											  'UserName' 			=> 	$name,
											  'SenTo'    			=> 	$row->bokemail,
								              'phone'				=>	$row->bokphone,
											  'RestName' 			=> 	$resDetails->getRestaurantname(),
											  'ResDate'  			=> 	$row->bokbooking_date,
											  'Time'     			=> 	$row->bokbooking_timings,
											  'Size'     			=>	$row->bokparty_size,
											  'Address'	 			=> 	$resDetails->getRestaddress(),
											  'resphone' 			=> 	$resDetails->getRestphone(),
											  'resemail'			=>	$resDetails->getRestemail(),
											  'rescity'				=>	$resDetails->getRestCityDesc(),
											  'resnbh'				=>	$resDetails->getRestNeighborDesc(),
											  'reszipcode'			=>	$resDetails->getRestzipcode(),	
											  'Status'	 			=> 	$bookStatus->getCode(),
											  'Bokid'	 			=>	$row->bokId,
											  'State_Id'			=>	$stateId,
											  'City_Id'				=>	$cityId,
											  'UserType'			=>	$userType,
											  'BookNotf' 			=>  false,
								
								);
	//							if($splresult){
	//								$data['splstatus']	= true;
	//								$data['splid'] 		= $splresult['Id'];
	//								$data['splname']	= $splresult['Special Name'];
	//								$data['spldesc'] 	= $splresult['Desc'];
	//								$data['splorgprice']= $splresult['Regular Price'];
	//								if($splresult['Discountcode'] == 'PER'){
	//									$data['spldiscount']= $splresult['Discount Percentage'].'%';	
	//								}else if($splresult['Discountcode'] == 'RE'){
	//									$data['spldiscount']= '$'.$splresult['Discount Percentage'];
	//								}
	//								$data['splprice'] 	= $splresult['Price with Discount'];
	//							}else{
									$data['splstatus']	= false;
	//							}
								if(count($campDetails)){
									$count = count($campDetails);
									if($count > 1){
										$campaign = $campDetails[rand(0,$count-1)];
									}else{
										$campaign = $campDetails[0];
									}
									$notfService = new Application_Service_Communication();
									$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
									$data['campaignName'] = trim($campaign->getSponsor());
									$data['campaignDesc'] =	trim($campaign->getCampDesc());
									$data['campaignImg'] =	trim($campaign->getCampImage());
									$data['campId']	= $campaign->getId();
								}
								$mailObj->setData($data);
								$mailStatus = $mailmapper->SendMail($mailObj);
							}else if($bookStatus->getCode() == 'CAN'){
								$mailObj->setMsgCode('Cancel');
								$name = $row->bokfirst_name.' '.$row->boklast_name;
	
								$data = array('UserName' => $name,
											  'SenTo'    => $row->bokemail,
											  'phone' 	 => $row->bokphone,
											  'RestName' => $resDetails->getRestaurantname(),
											  'ResDate'  => $row->bokbooking_date,
											  'Time'     => $row->bokbooking_timings,
											  'Size'     => $row->bokparty_size,
											  'Address'	 => $resDetails->getRestaddress(),
											  'Status'	 => $bookStatus->getCode(),
											  'State_Id' =>	$stateId,
											  'City_Id'	 =>	$cityId,
											  'resphone' => $resDetails->getRestphone(),
											  'UserType' =>	$userType,
											  'BookId'	 => $row->bokId
								);
								if(count($campDetails)){
									$count = count($campDetails);
									if($count > 1){
										$campaign = $campDetails[rand(0,$count-1)];
									}else{
										$campaign = $campDetails[0];
									}
									$notfService = new Application_Service_Communication();
									$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
									$data['campaignName'] = trim($campaign->getSponsor());
									$data['campaignDesc'] =	trim($campaign->getCampDesc());
									$data['campaignImg'] =	trim($campaign->getCampImage());
									$data['campId']	= $campaign->getId();
								}
									
								$mailObj->setData($data);
								$mailStatus = $mailmapper->SendMail($mailObj);
							}else if($bookStatus->getCode() == 'WAL'){
								$mailObj->setMsgCode('WalBookConf');
								$name = $row->bokfirst_name.' '.$row->boklast_name;
								$data = array('UserName' 			=> 	$name,
											  'Bokid'				=>	$row->bokId,
											  'SenTo'    			=>	$row->bokemail,
											  'RestName' 			=> 	$resDetails->getRestaurantname(),
											  'ResDate'  			=> 	$row->bokbooking_date,
											  'Time'     			=> 	$row->bokbooking_timings,
											  'Size'     			=> 	$row->bokparty_size,
											  'Address'	 			=> 	$resDetails->getRestaddress(),
											  'resphone' 			=> 	$resDetails->getRestphone(),
											  'resemail'			=>	$resDetails->getRestemail(),
											  'rescity'				=>	$resDetails->getRestCityDesc(),
											  'resnbh'				=>	$resDetails->getRestNeighborDesc(),
											  'reszipcode'			=>	$resDetails->getRestzipcode(),	
											  'Status'	 			=> 	$bookStatus->getCode(),
											  'State_Id'			=>	$stateId,
											  'City_Id'				=>	$cityId,
											  'UserType'			=>	$userType
								);
								if(count($campDetails)){
									$count = count($campDetails);
									if($count > 1){
										$campaign = $campDetails[rand(0,$count-1)];
									}else{
										$campaign = $campDetails[0];
									}
									$notfService = new Application_Service_Communication();
									$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
									$data['campaignName'] = trim($campaign->getSponsor());
									$data['campaignDesc'] =	trim($campaign->getCampDesc());
									$data['campaignImg'] =	trim($campaign->getCampImage());
									$data['campId']	= $campaign->getId();
								}
								$mailObj->setData($data);
								$mailStatus = $mailmapper->SendMail($mailObj);
							}else if($bookStatus->getCode() == 'NOS'){
	//							$mailObj->setMsgCode('No-Show');
	//							$name = $row['bokfirst_name'].' '.$row['boklast_name'];
	//							$data = array('UserName' 			=> 	$name,
	//										  'Bokid'				=>	$row['bokId'],
	//										  'SenTo'    			=> 	$row['bokemail'],
	//										  'RestName' 			=> 	$resDetails->getRestaurantname(),
	//										  'ResDate'  			=> 	$row['bokbooking_date'],
	//										  'Time'     			=> 	$row['bokbooking_timings'],
	//									  	  'Size'     			=> 	$row['bokparty_size'],
	//										  'Address'	 			=> 	$resDetails->getRestaddress(),
	//										  'Status'	 			=> 	$bookStatus->getCode(),
	//										  'State_Id' 			=>	$stateId,
	//										  'City_Id'	 			=>	$cityId,
	//										  'UserType' 			=>	$userType,
	//										  'ResManager'			=>	$resDetails->getRestmanagername(),
	//										  'ResEmail'			=>	$resDetails->getRestemail()
	//							);
	//							if(count($campDetails)){
	//								$count = count($campDetails);
	//								if($count > 1){
	//									$campaign = $campDetails[rand(0,$count-1)];
	//								}else{
	//									$campaign = $campDetails[0];
	//								}
	//								$notfService = new Application_Service_Communication();
	//								$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
	//								$data['campaignName'] = trim($campaign->getSponsor());
	//								$data['campaignDesc'] =	trim($campaign->getCampDesc());
	//								$data['campaignImg'] =	trim($campaign->getCampImage());
	//								$data['campId']	= $campaign->getId();
	//							}
	//							if($request->noshowmailsend == 'yes'){
	//								$mailObj->setData($data);
	//								$mailStatus = $mailmapper->SendMail($mailObj);
	//							}
							}else{
								$mailObj->setMsgCode('BookConf');
								$name = $row->bokfirst_name.' '.$row->boklast_name;
	
								$data = array(
											  'UserName' 			=> 	$name,
											  'SenTo'    			=> 	$row->bokemail,
											  'phone'				=>	$row->bokphone,
											  'RestName' 			=> 	$resDetails->getRestaurantname(),
											  'ResDate'  			=> 	$row->bokbooking_date,
											  'Time'     			=> 	$row->bokbooking_timings,
											  'Size'     			=>	$row->bokparty_size,
											  'Address'	 			=> 	$resDetails->getRestaddress(),
											  'resphone' 			=> 	$resDetails->getRestphone(),
											  'resemail'			=>	$resDetails->getRestemail(),
											  'rescity'				=>	$resDetails->getRestCityDesc(),
											  'resnbh'				=>	$resDetails->getRestNeighborDesc(),
											  'reszipcode'			=>	$resDetails->getRestzipcode(),	
											  'Status'	 			=> 	$bookStatus->getCode(),
											  'Bokid'	 			=>	$row->bokId,
											  'State_Id'			=>	$stateId,
											  'City_Id'				=>	$cityId,
											  'UserType'			=>	$userType,
											  'BookNotf' 			=> false,
								);
	//							if($splresult){
	//								$data['splstatus']	= true;
	//								$data['splid'] 		= $splresult['Id'];
	//								$data['splname']	= $splresult['Special Name'];
	//								$data['spldesc'] 	= $splresult['Desc'];
	//								$data['splorgprice']= $splresult['Regular Price'];
	//								if($splresult['Discountcode'] == 'PER'){
	//									$data['spldiscount']= $splresult['Discount Percentage'].'%';	
	//								}else if($splresult['Discountcode'] == 'RE'){
	//									$data['spldiscount']= '$'.$splresult['Discount Percentage'];
	//								}
	//								$data['splprice'] 	= $splresult['Price with Discount'];
	//							}else{
									$data['splstatus']	= false;
	//							}
								if(count($campDetails)){
									$count = count($campDetails);
									if($count > 1){
										$campaign = $campDetails[rand(0,$count-1)];
									}else{
										$campaign = $campDetails[0];
									}
									$notfService = new Application_Service_Communication();
									$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
									$data['campaignName'] = trim($campaign->getSponsor());
									$data['campaignDesc'] =	trim($campaign->getCampDesc());
									$data['campaignImg'] =	trim($campaign->getCampImage());
									$data['campId']	= $campaign->getId();
								}
								$mailObj->setData($data);
								$mailStatus = $mailmapper->SendMail($mailObj);
							}
						}
						if($row->bookstatuscode == "WAL" && $row->bokphone != "" && $row->bokphone != null)
						{
							
							$waitingquoteMapper = new Application_Model_WaitingQuoteTimeDataMapper();
							$quoteStatus 	  	= $waitingquoteMapper->getQuoteTimeById($row->bokquoted_time);
							$quoteObj 	  		= $quoteStatus;
							
							$name = $row->bokfirst_name.' '.$row->boklast_name;
							
							$custMsg = '';
							$custMsg = 'Hi '.$name.', we have put your reservation in waiting, please wait for '.$quoteObj->getDescription().'. '.$restResult->resrestaurant_name;
							$smsObj = new Communication_Model_Sms();
							$smsObj->setMsgCode('WaitingReserv');
							$data = array(
											'to'			=>	trim($row->bokphone),
											'countrycode' 	=> $row->bokcountrycode,
											'RestName' 		=> $resDetails->getRestaurantname(),
											'UserName'		=> $name,
											'Quote'			=> $quoteObj->getDescription(),
											'BookId'		=> $row->bokId
							);
							$smsObj->setData($data);
							$mailStatus = $mailmapper->SendSms($smsObj);
						}
					}
				}
				return $result['result'];
			}else{
				return 'false';
			}
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function BookingWebSync($request)
	{
		try{
			$date = $request->resdate;
			$resid = $request->resid;
			
//			$bookStatus = array('RSD','OVB','BKD','WAL');
//			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
//			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
//			
			$mapper = new Reservation_Model_ReservationDataMapper();
			$result = $mapper->BookingWebSync($resid,$date);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function ManageFreezeFromNative($request)
	{
		try{
			$freezedetails = json_decode($request->freezedetails);
			$resid = $freezedetails->resid;
			$selDate = $freezedetails->resdate;
			$selTimings = $freezedetails->selTimings;
			$userid = $freezedetails->userid;
			$frztypeAction = $freezedetails->frztypeAction;
			$desc = $freezedetails->desc;
			$descStat = $freezedetails->descStat;
			$mapper = new Reservation_Model_RestaurantFreezeDataMapper();
			$result = $mapper->ManageFreezeFromNative($resid,$selDate,$selTimings,$userid,$frztypeAction,$desc,$descStat);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function CampaignManageForMobile($resid)
	{
		try{
			$bookServ = new Application_Service_Reservation();
			$adminService = new Application_Service_Administrator();
			$stateCity = $bookServ->getRestaurantStateByResId($resid);
			$stateId = $stateCity['state'];
			$cityId = $stateCity['city'];
			$regionId = $stateCity['region'];
			$resDataMapper = new FirmManagement_Model_FirmDataMapper();
			$restObj= new FirmManagement_Model_FirmById();
			$restObj->setRestaurantId($resid);
			$resDetails = $resDataMapper->getRestaurantById($restObj);
			$campProp = new Application_Model_GetCampaignForPost();
			$campProp->setAudType('CUS')
					->setStateId($stateId)
					->setCityId($cityId)
					->setRegionId($regionId)
					->setIsAjaxCall(false);
			$campDetails = array();
			if(!$resDetails->getrescampaignstatus() === false){
				$campDetails = $adminService->GetCampaignDetails($campProp);
			}
			return $campDetails;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function MessageDisplayDetailsForRestOwner($emailMessage,$sender)
	{
		try{
			$mapper = new Reservation_Model_ReservationDataMapper();
			$bokid = $emailMessage->emsg_fk_bokid;
			$dinerDetails = new Reservation_Model_Reservation();
			$dinerDetails->setbokid($bokid);
			$bookResult = $mapper->getBookingDetails($dinerDetails);
			
//			$bookResult = $this->GetBookingDetails($bokid);
			$resid = $bookResult->getbokfk_restaurant();
			$resDataMapper = new FirmManagement_Model_FirmDataMapper();
			$restObj= new FirmManagement_Model_FirmById();
			$restObj->setRestaurantId($bookResult->getbokfk_restaurant());
			$resDetails = $resDataMapper->getRestaurantById($restObj);
//			$splresult = '';
//			if($bookResult->getbokbooking_type_code() == 'SPL' || $bookResult->getbokbooking_type_code() == 'SPLPAID'){
//				$isAjaxCall = true;
//				$splmapper = new Deals_Model_RestaurantSpecialDataMapper();
//				$splresult = $splmapper->getRestaurantSplByBookingId($bokid,$isAjaxCall);
//			}
			$stateCity = $this->getRestaurantStateByResId($bookResult->getbokfk_restaurant());
			$stateId = $stateCity['state'];
			$cityId = $stateCity['city'];
			$regionId = $stateCity['region'];
			$templateBdMapper = new Application_Model_EmailtemplateDataMapper();
			$template = $templateBdMapper->getEmailTempByCode(trim($emailMessage->emsg_subject));
//			$template = $templateBdMapper->getEmailTempByCode('BookReminder');
			if($template){
				$name     = $bookResult->getresrestaurant_name();
				$custname = $bookResult->getbokfirst_name().' '.$bookResult->getboklast_name();
				$restname = $resDetails->getRestaurantname();
				$resdate  = $bookResult->getbokbooking_date();
				$resServ = new Application_Service_Firm();
				$timeZone = $resServ->GetRestaurantTimeZone($restObj->getRestaurantId());
				date_default_timezone_set($timeZone);
				$date2	  =  strtotime($resdate);
				$date	  =	 date('m-d-Y', $date2);
				$time     = $bookResult->getbokbooking_timings();
				$size     = $bookResult->getbokparty_size();
				$address  = $bookResult->getresaddress();
				$bookid	  = $bookResult->getbokid();
				$email    = $bookResult->getbokemail();
				$phone    = $bookResult->getbokphone();
				$note     = $bookResult->getbokspecial_request();
				$state	  = $stateId;
				$city	  = $cityId;
				$userType = 'RES';
//				$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div>%img%</br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
//				$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.dinedesk.com%img%" width="150" height="150"/>';
//				$div = '<div style="display:none;"><div style="width:450px; margin-top:20px;"><div style="background:buttonshadow; padding:5px; font-size:13px;" class="shadow"><span style="color:#ffffff;">This Notification has been brought to you by</span><span> %campName%</span></div></div><div><a class="linkopacity" target="newwindow">%img%</a></div></br><div><a class="linkopacity" target="newwindow">%desc%</a></div></div>';
//				$imgDiv = '<div><a class="linkopacity" target="newwindow"><img src="http://www.dinedesk.com%img%" width="150" height="150"/>';
								
							
				$subject = $template->msg_subject;
				$body    = $template->msg_body;
				
				$body    = str_replace("%firstname%",$name,$body);
				$body    = str_replace("%custname%",$custname,$body);
				$body    = str_replace("%restname%",$restname,$body);
				$body    = str_replace("%date%",$date,$body);
				$body    = str_replace("%time%",$time,$body);
				$body    = str_replace("%size%",$size,$body);
				$body	 = str_replace("%address%",$address,$body);
				$body	 = str_replace("%bookingid%",$bookid,$body);
//				$body	 = str_replace("%bokid%",$bookResult->getbokbookingphrase(),$body);
				$body	 = str_replace("%email%",$email,$body);
				$body	 = str_replace("%phone%",$phone,$body);
				$body	 = str_replace("%note%",$note,$body);
				$body 	 = str_replace("�",'',$body);
				$div = '<td width="44%" valign="top" align="left">%img%</br><div>%desc%</div></td>';
				$imgDiv = '<div><img src="http://www.dinedesk.com%img%" width="150" height="150"/></div>';
			
				if($emailMessage->emsg_campaignid){
					
					$adminService = new Application_Service_Administrator();
					$campProp = new Application_Model_GetCampaignForPost();
					$campProp->setCampId($emailMessage->emsg_campaignid)
							->setAudType($userType)
							->setStateId($stateId)
							->setCityId($cityId)
							->setRegionId($regionId)
							->setIsAjaxCall(false);
					$campDetails = array();
					$campId  	= '';
					$campname 	= '';
					$desc  		= '';
					$img 	  	= '';
					$display  	= '';
					if(!$resDetails->getrescampaignstatus() === false){
						$campDetails = $adminService->GetCampaignDetails($campProp);
						if(count($campDetails)){
							$count = count($campDetails);
							$campaign = $campDetails[0];
							$notfService = new Application_Service_Communication();
//							$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
							$campname = trim($campaign->getSponsor());
							$desc =	trim($campaign->getCampDesc());
							$img =	trim($campaign->getCampImage());
							$campId	= $campaign->getId();
							$desc  		= str_replace('src="','src="http://www.dinedesk.com',$desc);
							$display  	= 'block';
							$body    = str_replace("none",$display,$body);
							$body    = str_replace("%desc%",$desc,$body);
							if($img){
								$imgDiv 	= str_replace("%img%",$img,$imgDiv);
								$body    	= str_replace("%img%",$imgDiv,$body);
							}else{
								$body    	= str_replace("%img%",'',$body);
							}
							$body    = str_replace("%campName%",$campname,$body);
						}	
						else{
							$asSense = '<script type="text/javascript">google_ad_client = "%client%";/* testin */google_ad_slot = "%slot%";google_ad_width = %wid%;google_ad_height = %hei%;</script><script type="text/javascript" src="http://pagead2.googlesyndication.com/pagead/show_ads.js"></script>';
							$asSense = str_replace('%client%','ca-pub-2808144937131233',$asSense);
							$asSense = str_replace('%slot%','7461566461',$asSense);
							$asSense = str_replace('%wid%','250',$asSense);
							$asSense = str_replace('%hei%','250',$asSense);
							$body    = str_replace($div,'<td width="44%" valign="top" align="left">'.$asSense.'</td>',$body);
							
//							$body    = str_replace($div,'<td width="44%" valign="top" align="left"></td>',$body);
							$body    = str_replace("%campName%",'DineDesk',$body);
						}									
					}
				}else{
					$asSense = '<script type="text/javascript">google_ad_client = "%client%";/* testin */google_ad_slot = "%slot%";google_ad_width = %wid%;google_ad_height = %hei%;</script><script type="text/javascript" src="http://pagead2.googlesyndication.com/pagead/show_ads.js"></script>';
					$asSense = str_replace('%client%','ca-pub-2808144937131233',$asSense);
					$asSense = str_replace('%slot%','7461566461',$asSense);
					$asSense = str_replace('%wid%','250',$asSense);
					$asSense = str_replace('%hei%','250',$asSense);
					$body    = str_replace($div,'<td width="44%" valign="top" align="left">'.$asSense.'</td>',$body);
					
//					$body    = str_replace($div,'<td width="44%" valign="top" align="left"></td>',$body);
					$body    = str_replace("%campName%",'DineDesk',$body);
				}
			}
			return $body;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function BookingTermsAndConditionsAccept(array $data,$request)
	{
		try{
			$stateId = "";
			$cityId = "";
			$regionId = "";
			$form = $this->getBookingConfirmationForm();
			if($form->isValid($data))
			{
				$formData = $form->getValues();
				
				$mapper = new Reservation_Model_ReservationDataMapper();
				$dinerDetails = new Reservation_Model_Reservation();
				$userid = $request->userid;
	
				$resModeMapper = new Application_Model_ReservationModeDataMapper();
				if($request->reservationfrom == 'FB'){
					$resModeStatus 	  = $resModeMapper->GetReservationModeByCode(array('FB'));
					$resModeObj 	  = $resModeStatus['FB'];
				}else{
					$resModeStatus 	  = $resModeMapper->GetReservationModeByCode(array('INAT'));
					$resModeObj 	  = $resModeStatus['INAT'];
				}
	
				$dinerDetails->setbokfk_restaurant((int)$request->restaurantid);
				$dinerDetails->setresrestaurant_name($request->resname);
				$dinerDetails->setresaddress($request->resaddress);
				$dinerDetails->setbokbooking_date($request->resdate);
				$dinerDetails->setbokbooking_timings($request->restime);
				$dinerDetails->setbokparty_size((int)$request->respax);
	
	
				/* Reteriving Reservation Status Id by Code */
				$status[] = $request->bookingstatus;
				$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
				$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($status);
				$bookStatusRes = $bookStatusRes[$request->bookingstatus];
				$dinerDetails->setbokbooking_status_id($bookStatusRes->getId());
				$dinerDetails->setbokbooking_status($bookStatusRes->getId());
	
	
				$dinerDetails->setbokfirst_name($request->firstName);
				$dinerDetails->setboklast_name($request->lastName);
				$dinerDetails->setbokphone($request->number);
				$dinerDetails->setbokemail($request->email) ;
				$dinerDetails->setbokspecial_request($request->dinerRequest);
	//			if($request->bokoptions){
	//				$dinerDetails->setbokoptions($request->bokoptions);
	//			}
				
				$resServ = new Application_Service_Firm();
				$timeZone = $resServ->GetRestaurantTimeZone($request->restaurantid);
				date_default_timezone_set($timeZone);
	
				$dinerDetails->setbokbooking_made_on(date('Y-m-d H:i:s'));
				$dinerDetails->setBookingMadeTime(date("H:i",time()));
				$bookPhrase = uniqid ();
				$dinerDetails->setbokbookingphrase($bookPhrase);
				$payStat = false;
				$customerDetails = new User_Model_Guest();
				$bookTypeMapper = new Application_Model_ReservationTypeDataMapper();
	
				$paymentId = array();
				if($request->specialamt){
					$dinerDetails->setSpecialPrice($request->specialamt);
				} 
				if($request->booktype){
					$dinerDetails->setbokbooking_type_code($request->booktype);	
				}else{
					$dinerDetails->setbokbooking_type_code('NOR');
				}
				if($request->specialid){
						
					$splService = new Application_Service_Deals();	
					$splResult = $splService->GetWidgetSpecialDetailsById((int)$request->restaurantid,$request->specialid,false);
					
					$dinerDetails->setSpecialId($request->specialid);
					$bookType = $bookTypeMapper->GetBookingTypeByCode($request->booktype);
					$dinerDetails->setbokuserid($request->userid);
					if($request->paymentStatus == 'true'){
						$usrServ = new Application_Service_Client();
						$userResult = $usrServ->RegisterCustomerOnReservation($formData);
						if($userResult){
							$payStat = true;
							$dinerDetails->setbokuserid($userResult);
							$customerDetails->setUserid($userResult);
							$customerDetails->setEmail($request->email);
							
							if($splResult->getCatTypeCode() == 'SP'){
								$bookType = $bookTypeMapper->GetBookingTypeByCode('SPLPAID');
							}else if($splResult->getCatTypeCode() == 'CP'){
								$bookType = $bookTypeMapper->GetBookingTypeByCode('SPL');
							}
							
							/* Check Whether Rest Owner has Authorized.Net Customer Profile */
							$payServ = new Application_Service_Renumeration();
	
							$userProfile = $payServ->Manage_Customer_Registration_On_Reservation($customerDetails);
							if($userProfile['CustProfId']){
								$paymentProfResult = $userProfile['PaymentProfiles'];
								if($paymentProfResult){
									foreach($paymentProfResult as $row){
										$paymentId[] = $row->anppid;
									}
								}
							}else{
								$resultant['result'] = false;
								return $resultant;
							}
						}
					}
				}else if($request->paymentStatus == 'true'){
					$usrServ = new Application_Service_Client();
					$userResult = $usrServ->RegisterCustomerOnReservation($formData);
					if($userResult){
						$payStat = true;
						$dinerDetails->setbokuserid($userResult);
						$customerDetails->setUserid($userResult);
						$customerDetails->setEmail($request->email);
						$bookType = $bookTypeMapper->GetBookingTypeByCode('PAID');
						/* Check Whether Rest Owner has Authorized.Net Customer Profile */
						$payServ = new Application_Service_Renumeration();
	
						$userProfile = $payServ->Manage_Customer_Registration_On_Reservation($customerDetails);
						if($userProfile['CustProfId']){
							$paymentProfResult = $userProfile['PaymentProfiles'];
							if($paymentProfResult){
								foreach($paymentProfResult as $row){
									$paymentId[] = $row->anppid;
								}
							}
						}else{
							$resultant['result'] = false;
							return $resultant;
						}
					}
				}else if($request->paymentStatus == 0){
					$bookType = $bookTypeMapper->GetBookingTypeByCode('NOR');
					$dinerDetails->setbokuserid($request->userid);
				}
				$dinerDetails->setbokreservation_mode_id($resModeObj->getId());
				$dinerDetails->setTableSize((int)$request->tablesize);
				$dinerDetails->setNoOfTables((int)$request->nooftables);
				$dinerDetails->setNotificationType('both');
				$dinerDetails->setInventoryId((int)$request->inventoryid);
				/* Reteriving Booking Type Id by code */
				
				$dinerDetails->setbokbooking_type_id($bookType->getid());
				
				$result = $mapper->saveBookingDetails($dinerDetails);
	
				$dinerDetails->setbokid($result);
				$mailmapper = new Application_Service_Communication();
				//if($formData['notificationType'] == 'email'){
				if($result){
					$splresult = "";
					$resDataMapper = new FirmManagement_Model_FirmDataMapper();
					$restObj= new FirmManagement_Model_FirmById();
					$restObj->setRestaurantId($request->restaurantid);
					$resDetails = $resDataMapper->getRestaurantById($restObj);
					if($request->booktype == 'SPL'){
						$isAjaxCall = true;
						$splmapper = new Deals_Model_RestaurantSpecialDataMapper();
						$splresult = $splmapper->getRestaurantSplByBookingId($result,$isAjaxCall);
					}
					if($request->paymentStatus == 'false'){
						$mailObj = new Communication_Model_Mail();
						if($request->email != ''){
							if($request->bookingstatus == 'WAL')
							{
								if($stateId == ""){
									$stateCity = $this->getRestaurantStateByResId($request->restaurantid);
									$stateId = $stateCity['state'];
									$cityId = $stateCity['city'];
									$regionId = $stateCity['region'];
	
								}
								$userType = 'CUS';
								$adminService = new Application_Service_Administrator();
								$campProp = new Application_Model_GetCampaignForPost();
								$campProp->setAudType($userType)
								->setStateId($stateId)
								->setCityId($cityId)
								->setRegionId($regionId)
								->setIsAjaxCall(false);
								$campDetails = array();
								if(!$resDetails->getrescampaignstatus() === false){
									$campDetails = $adminService->GetCampaignDetails($campProp);
								}
	
								$mailObj->setMsgCode('WalBookConf');
								$name = $request->firstName.' '.$request->lastName;
								$data = array('UserName' 			=> 	$name,
												'Bokid'				=>	$result,
											  'SenTo'    			=>	$request->email,
											  'phone'				=>  $request->number,
											  'RestName' 			=> 	$request->resname,
											  'ResDate'  			=> 	$request->resdate,
											  'Time'     			=> 	$request->restime,
											  'Size'     			=> 	$request->respax,
											  'Address'	 			=> 	$request->resaddress,
											  'resphone' 			=> 	$resDetails->getRestphone(),
											  'resemail'			=>	$resDetails->getRestemail(),
											  'rescity'				=>	$resDetails->getRestCityDesc(),
											  'resnbh'				=>	$resDetails->getRestNeighborDesc(),
											  'reszipcode'			=>	$resDetails->getRestzipcode(),	
											  'Status'	 			=> 	$request->bookingstatus,
											  'State_Id'			=>	$stateId,
											  'City_Id'				=>	$cityId,
											  'UserType'			=>	$userType
								);
								if(count($campDetails)){
									$count = count($campDetails);
									if($count > 1){
										$campaign = $campDetails[rand(0,$count-1)];
									}else{
										$campaign = $campDetails[0];
									}
									$notfService = new Application_Service_Communication();
									$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
									$data['campaignName'] = trim($campaign->getSponsor());
									$data['campaignDesc'] =	trim($campaign->getCampDesc());
									$data['campaignImg'] =	trim($campaign->getCampImage());
									$data['campId']	= $campaign->getId();
								}
								$mailObj->setData($data);
								$mailStatus = $mailmapper->SendMail($mailObj);
							}else{
								if($stateId == "" && $cityId == ""){
									$stateCity = $this->getRestaurantStateByResId($request->restaurantid);
									$stateId = $stateCity['state'];
									$cityId = $stateCity['city'];
									$regionId = $stateCity['region'];
								}
								$userType = 'CUS';
								$adminService = new Application_Service_Administrator();
								$campProp = new Application_Model_GetCampaignForPost();
								$campProp->setAudType($userType)
								->setStateId($stateId)
								->setCityId($cityId)
								->setRegionId($regionId)
								->setIsAjaxCall(false);
								$campDetails = array();
								if(!$resDetails->getrescampaignstatus() === false){
									$campDetails = $adminService->GetCampaignDetails($campProp);
								}
									
								$mailObj->setMsgCode('BookConf');
								$name = $request->firstName.' '.$request->lastName;
	
								$data = array(
											  'UserName' 			=> 	$name,
											  'SenTo'    			=> 	$request->email,
											  'RestEmails'    		=> 	$restInfo['emails'],
											  'RestName' 			=> 	$request->resname,
											  'ResDate'  			=> 	$request->resdate,
											  'Time'     			=> 	$request->restime,
											  'Size'     			=>	$request->respax,
											  'Address'	 			=> 	$request->resaddress,
											  'resphone' 			=> 	$resDetails->getRestphone(),
											  'resemail'			=>	$resDetails->getRestemail(),
											  'phone'	 			=> 	$request->number,	
											  'Note'	 			=>	$request->dinerRequest,
										      'rescity'				=>	$resDetails->getRestCityDesc(),
											  'resnbh'				=>	$resDetails->getRestNeighborDesc(),
											  'reszipcode'			=>	$resDetails->getRestzipcode(),	
											  'Status'	 			=> 	$request->bookingstatus,
											  'Bokid'	 			=>	$result,
											  'State_Id'			=>	$stateId,
											  'City_Id'				=>	$cityId,
											  'UserType'			=>	$userType,
											  'BookNotf'			=>  true,
								);
								if($splresult){
									$data['splstatus']	= true;
									$data['splid'] 		= $splresult['Id'];
									$data['splname']	= $splresult['Special Name'];
									$data['spldesc'] 	= $splresult['Desc'];
									$data['splorgprice']= $splresult['Regular Price'];
									if($splresult['Discountcode'] == 'PER'){
										$data['spldiscount']= $splresult['Discount Percentage'].'%';	
									}else if($splresult['Discountcode'] == 'RE'){
										$data['spldiscount']= '$'.$splresult['Discount Percentage'];
									}
									$data['splprice'] 	= $splresult['Price with Discount'];
								}else{
									$data['splstatus']	= false;
								}
								if(count($campDetails)){
									$count = count($campDetails);
									if($count > 1){
										$campaign = $campDetails[rand(0,$count-1)];
									}else{
										$campaign = $campDetails[0];
									}
									$notfService = new Application_Service_Communication();
									$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
									$data['campaignName'] = trim($campaign->getSponsor());
									$data['campaignDesc'] =	trim($campaign->getCampDesc());
									$data['campaignImg'] =	trim($campaign->getCampImage());
									$data['campId']	= $campaign->getId();
								}
								$mailObj->setData($data);
								$mailStatus = $mailmapper->SendMail($mailObj);
							}
						}
	
						/*if($formData['number'] != ''){
							$smsObj = new Communication_Model_Sms();
							$smsObj->setMsgCode('BookConf');
							$data = array(
							 'to'		=> trim($formData['number']),
							 'countrycode => $formData['countryCode'],
							 'bokid'	=> $result,	
							 'RestName' => $formData['resName'],
							 'ResDate'  => $formData['resDate'],
							 'Time'     => $formData['resTime'],
							 'Size'     => $formData['pax'],
							);
							$smsObj->setData($data);
							$mailStatus = $mailmapper->SendSms($smsObj);
						}*/
	
						/* Send Notification to Restaurant Admin */
	
						/* Reterive restaurant admin email start */
	
						//$restInfo = $mapper->ReterieveRestInfo($formData['resId']);
//						$restInfo = $mapper->ReterieveRestemails($request->restaurantid);
//						if($restInfo){
//								if($stateId == "" && $cityId == ""){
//									$stateCity = $this->getRestaurantStateByResId($request->restaurantid);
//									$stateId = $stateCity['state'];
//									$cityId = $stateCity['city'];
//									$regionId = $stateCity['region'];
//								}
//							$userType = 'RES';
//							if($resDetails->getrescampaignstatus()){
//								$campProp = new Application_Model_GetCampaignForPost();
//								$campProp->setAudType($userType)
//								->setStateId($stateId)
//								->setCityId($cityId)
//								->setRegionId($regionId)
//								->setIsAjaxCall(false);
//								if(!$resDetails->getrescampaignstatus() === false){
//									$campDetails = $adminService->GetCampaignDetails($campProp);
//								}
//								
//								
//							}else{
//								$campDetails = array();
//							}
//							$adminService = new Application_Service_Administrator();
//							
//	
//							if($restInfo['status'] && isset($restInfo['emails'])){
//								//$restEmail = $restInfo->resemail;
//								$mailObj->setMsgCode('BookNotf');
//								$name = $request->firstName.' '.$request->lastName;
//	
//								$data = array(
//										  'UserName' 			=> 	$name,
//										  'SenTo'    			=> 	$restInfo['emails'],
//										  'RestName' 			=> 	$request->resname,
//										  'ResDate'  			=> 	$request->resdate,
//										  'Time'     			=> 	$request->restime,
//										  'email'	 			=> 	$request->email,
//										  'phone'	 			=> 	$request->number,	
//										  'Size'     			=> 	$request->respax,
//										  'Address'	 			=> 	$request->resaddress,
//										  'Note'	 			=>	$request->dinerRequest,
//										  'Bookid'	 			=> 	$result,
//										  'State_Id'			=>	$stateId,
//										  'City_Id'				=>	$cityId,
//										  'UserType'			=>	$userType);
//								if(count($campDetails)){
//									$count = count($campDetails);
//									if($count > 1){
//										$campaign = $campDetails[rand(0,$count-1)];
//									}else{
//										$campaign = $campDetails[0];
//									}
//									$notfService = new Application_Service_Communication();
//									$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
//									$data['campaignName'] = trim($campaign->getSponsor());
//									$data['campaignDesc'] =	trim($campaign->getCampDesc());
//									$data['campaignImg'] =	trim($campaign->getCampImage());
//									$data['campId']	= $campaign->getId();
//								}
//								$mailObj->setData($data);
////								$mailStatus = $mailmapper->SendMail($mailObj);
//							}
//						}
						
						//$formData['restaurantid'] = $formData['resId'];
						$restservice = new Application_Service_Firm();
						$timeZone = $restservice->GetRestaurantTimeZone($request->restaurantid);
						date_default_timezone_set($timeZone);
	
						/* Reterieve Phone Notify Details */
						if($request->bookingstatus == 'RSD'){
								
							$restPhoneInfo = $restservice->getRestaurantPhoneDetails($request->restaurantid);
								
							$splitbookdate   = explode('-',$request->resdate);
								
							$bookingdate   = date('Y-m-d',mktime(0,0,0,$splitbookdate[0],$splitbookdate[1],$splitbookdate[2]));
							$todaydate     = date('Y-m-d');
	
							if($restPhoneInfo['smsnotify']){
								$phoneRowSet = $restPhoneInfo['rowset'];
								$phonenumber = "";
								$fromtime    = "";
								$totime		 = "";
								$resvTime    = $request->restime;
	
								if($phoneRowSet){
									foreach($phoneRowSet as $phoneNum){
										if($phoneNum->rntnotify_type == 'sms'){
											$phonenumber = $phoneNum->rntphone;
											$fromtime    = $phoneNum->rntnotify_from_time;
											$totime		 = $phoneNum->rntnotify_to_time;
											$countrycode = $phoneNum->rntcountrycode;
										}
									}
									if($phonenumber){
										if(strtotime($resvTime)>= strtotime($fromtime) && strtotime($resvTime)<= strtotime($totime)){
											$smsObj = new Communication_Model_Sms();
											$smsObj->setMsgCode('BookNotf');
	
											$data = array('to' 		 	 => $phonenumber,
														  'countrycode'	 => $countrycode,
														  'bokid'    	 => $result,
														  'RestName' 	 => $request->resname,
														  'ResDate'	 	 => $request->resdate,
														  'Time'		 => $request->restime,
														  'Size'		 => $request->respax,
														  'CustomerName' => $request->firstName.' '.$request->lastName);
	
											$smsObj->setData($data);
											$mailStatus = $mailmapper->SendSms($smsObj);
	
										}
									}
								}
							}
						}
						
						$user = new FirmManagement_Model_FirmGroupUsers();
						$user->setRestaurantId($request->restaurantid)
						->setGroupId(3)
						->setFirstName($request->firstName)
						->setLastName($request->lastName)
						->setEmail($request->email)
						->setPhone($request->number)
						->setSplRequest($request->dinerRequest)
						->setStatus(TRUE);
						
						$restgroupmapper = new FirmManagement_Model_FirmGroupUsersDataMapper();
						$restgroupmapper->addUserContact($user);
						$resultant = array('result'=>$bookPhrase,'userId'=>$userid);
						
						/* Check If reservation is for future date and save the info for reminder process */
						
						if($request->bookingstatus == 'RSD'){
							$splitbookdateNotify   = explode('-',$request->resdate);
								
							$bookingdateNotify   = date('Y-m-d',mktime(0,0,0,$splitbookdateNotify[0],$splitbookdateNotify[1],$splitbookdateNotify[2]));
							$todaydateNotify     = date('Y-m-d');
							if(strtotime($bookingdateNotify) > strtotime($todaydateNotify)){
								$BookingNotify = new Reservation_Model_ReservationNotify();
								
								$BookingNotify->setbknfk_booking($result);
								$BookingNotify->setbkn_booking_date($request->resdate);
								
								$NotifyMapper = new Reservation_Model_ReservationNotifyMapper();
								$notifyInfoStatus = $NotifyMapper->SaveBookingNotifyInfo($BookingNotify);
							}
						}
						
						return $resultant;
					}else{
						$user = new FirmManagement_Model_FirmGroupUsers();
						$user->setRestaurantId($request->restaurantid)
						->setGroupId(3)
						->setFirstName($request->firstName)
						->setLastName($request->lastName)
						->setEmail($request->email)
						->setPhone($request->number)
						->setSplRequest($request->dinerRequest)
						->setStatus(TRUE);
						
						$restgroupmapper = new FirmManagement_Model_FirmGroupUsersDataMapper();
						$restgroupmapper->addUserContact($user);
						
						if($request->paymentStatus == 'true' && $result && $payStat == true){
							if(count($paymentId)){
								$resultant = array('result'=>$bookPhrase,'userId'=>$userResult,'status'=>true,'profileId'=>$userProfile['CustProfId'],'payment'=>$paymentId);
							}else{
								$resultant = array('result'=>$bookPhrase,'userId'=>$userResult,'status'=>true,'profileId'=>$userProfile['CustProfId'],'payment'=>false);
							}
						}else{
	
						}
						return $resultant;
					}
				}else{
					return false;
				}
			}else{
				$formData = $form->getValues();
				$form->populate($data);
				$result = array('status'=>false,'form'=>$form);
				return $result;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetRestTimingsFromWidget($request, $resid)
	{
		try{
			$searchList = array();			
			$resttimings = new Reservation_Model_GetRestaurantTimings();
			$resttimings->setDate($request->date);
			
			if($request->fromaction == 'weblink'){		
				$resttimings->setMealType("");	
				$resttimings->setRestId($request->restaurantid);			
				$resttimings->setResType('web');
				$resttimings->setpartysize($request->partysize);	
			}else{
				$resttimings->setResType('web');
				$resttimings->setRestId($resid);
				$resttimings->setpartysize($request->pax);
				$resttimings->setMealType($request->mealtype);		
			}		
			$detailsMapper = new Reservation_Model_SearchListViewDataMapper();
			
			/* Check Whether the selected date contains any special schedule */
			$restSpecialSchObject = new FirmManagement_Model_FirmSpecialSchedule();
			$restSpecialSchObject->setrsesfk_restaurant($resttimings->getRestId());
			$restSpecialSchObject->setrseseventdate($resttimings->getDate());
			$restSplSchMapperObj = new FirmManagement_Model_FirmSpecialScheduleMapper();				
			$splSchRow = $restSplSchMapperObj->CheckSpecialScheduleAvilable($restSpecialSchObject);

			if($splSchRow){
				$searchList = $detailsMapper->GetRestTimingsByMealType($resttimings);				
			}else{
				$resDataMapper = new FirmManagement_Model_FirmDataMapper();
				$seetingArr = $resDataMapper->getScheduleSettingTypeByresId($resid);
				$settingType = $seetingArr['settingType'];
				
				if($settingType == 'SL'){
					$searchList = $detailsMapper->GetRestTimingsByMealType($resttimings);
				}else if($settingType == 'UL'){
					$searchList = $detailsMapper->GetRestTimingsForUnlimitedByMealType($resttimings);
				}else if($settingType == 'SMC'){
					$searchList = $detailsMapper->GetRestTimingsForMaxCountByMealType($resttimings);
				}else if($settingType == 'SAC'){
					$searchList = $detailsMapper->GetRestTimingsForAccumulativeByMealType($resttimings);
				}
			}
			return $searchList;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetRestTimingsOnLocFromWidget($request)
	{
		try{
			$searchList = array();
			$resDataMapper = new FirmManagement_Model_FirmDataMapper();
			$resfkuser = new FirmManagement_Model_FirmByOwnerId();
			$resfkuser->setResOwnerId($request->resfkuser);
			$restArr = $resDataMapper->getRestaurantIdsByOwnerId($resfkuser);
			foreach($restArr as $row){
				$resid = $row->resid;
				$resDetails = $resDataMapper->getRestaurantDetailsById($resid);
				$resttimings = new Reservation_Model_GetRestaurantTimings();
				$resttimings->setDate($request->resdate);
					
				if($request->fromaction == 'weblink'){
					$resttimings->setMealType("");
					$resttimings->setRestId($request->restaurantid);
					$resttimings->setResType('web');
					$resttimings->setpartysize($request->partysize);
				}else{
					$resttimings->setResType('web');
					$resttimings->setRestId($resid);
					$resttimings->setpartysize($request->respax);
					$resttimings->setMealType($request->resMeal);
				}
				$detailsMapper = new Reservation_Model_SearchListViewDataMapper();
					
				/* Check Whether the selected date contains any special schedule */
				$restSpecialSchObject = new FirmManagement_Model_FirmSpecialSchedule();
				$restSpecialSchObject->setrsesfk_restaurant($resttimings->getRestId());
				$restSpecialSchObject->setrseseventdate($resttimings->getDate());
				$restSplSchMapperObj = new FirmManagement_Model_FirmSpecialScheduleMapper();
				$splSchRow = $restSplSchMapperObj->CheckSpecialScheduleAvilable($restSpecialSchObject);
			
				if($splSchRow){
					$searchList[$resid]['sch'] = $detailsMapper->GetRestTimingsByMealType($resttimings);
				}else{
					
					$seetingArr = $resDataMapper->getScheduleSettingTypeByresId($resid);
					$settingType = $seetingArr['settingType'];
			
					if($settingType == 'SL'){
						$searchList[$resid]['sch'] = $detailsMapper->GetRestTimingsByMealType($resttimings);
					}else if($settingType == 'UL'){
						$searchList[$resid]['sch'] = $detailsMapper->GetRestTimingsForUnlimitedByMealType($resttimings);
					}else if($settingType == 'SMC'){
						$searchList[$resid]['sch'] = $detailsMapper->GetRestTimingsForMaxCountByMealType($resttimings);
					}else if($settingType == 'SAC'){
						$searchList[$resid]['sch'] = $detailsMapper->GetRestTimingsForAccumulativeByMealType($resttimings);
					}
				}
				$searchList[$resid]['details'] = $row->resrestaurant_name;
			}
			return $searchList;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetRestTimingsForPartnerRest($request)
	{
		try{
			$searchList = array();			
			$resttimings = new Reservation_Model_GetRestaurantTimings();
			$resid = $request->restaurantid;
			$resttimings->setDate($request->date);
			
			$resttimings->setResType('web');
			$resttimings->setRestId($resid);
			$resttimings->setpartysize($request->partysize);
			$resttimings->setMealType($request->mealtype);	
			
			$detailsMapper = new Reservation_Model_SearchListViewDataMapper();
			
			/* Check Whether the selected date contains any special schedule */
			$restSpecialSchObject = new FirmManagement_Model_FirmSpecialSchedule();
			$restSpecialSchObject->setrsesfk_restaurant($resttimings->getRestId());
			$restSpecialSchObject->setrseseventdate($resttimings->getDate());
			$restSplSchMapperObj = new FirmManagement_Model_FirmSpecialScheduleMapper();				
			$splSchRow = $restSplSchMapperObj->CheckSpecialScheduleAvilable($restSpecialSchObject);

			if($splSchRow){
				$searchList = $detailsMapper->GetRestTimingsByMealType($resttimings);				
			}else{
				$resDataMapper = new FirmManagement_Model_FirmDataMapper();
				$seetingArr = $resDataMapper->getScheduleSettingTypeByresId($resid);
				$settingType = $seetingArr['settingType'];
				
				if($settingType == 'SL'){
					$searchList = $detailsMapper->GetRestTimingsByMealType($resttimings);
				}else if($settingType == 'UL'){
					$searchList = $detailsMapper->GetRestTimingsForUnlimitedByMealType($resttimings);
				}else if($settingType == 'SMC'){
					$searchList = $detailsMapper->GetRestTimingsForMaxCountByMealType($resttimings);
				}else if($settingType == 'SAC'){
					$searchList = $detailsMapper->GetRestTimingsForAccumulativeByMealType($resttimings);
				}
			}
			return $searchList;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
		
	public function GetRestReservations($data,$request)
	{
		try{
			$restObj = new FirmManagement_Model_FirmSearch();
			$resids = "";
			if($request->restaurantid){
				$resids = $request->restaurantid;
			}
			if($request->restaurantid){
				$restObj->setRestaurantname($request->restaurantid);
			}
			if($request->region){
				$restObj->setRestRegion($request->region);
				if($request->city){
					$restObj->setRestCity($request->city);
				}
			}
			if($request->startDate){
				$sdatesplit = explode('-',$request->startDate);
				$restObj->setStartDate(date('Y-m-d',mktime(0,0,0,$sdatesplit[0],$sdatesplit[1],$sdatesplit[2])));
			}else{
				$restObj->setStartDate(date('Y-m-d'));
			}
			if($request->endDate){
				$enddatesplit = explode('-',$request->endDate);
				$restObj->setEndDate(date('Y-m-d',mktime(0,0,0,$enddatesplit[0],$enddatesplit[1],$enddatesplit[2])));
			}			
		  	$mapper = new Reservation_Model_ReservationDataMapper();
			$resultset = $mapper->GetRestReservations($restObj,$resids);
			$result = array('status'=>true,'restForm'=>$resultset);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getMealTypeByRestid($request)
	{
		try{
			$restaurantid = $request->restaurantid;
			$MealTypeDataMapper = new FirmManagement_Model_FirmMealTypeDataMapper();
			$mealSettings = $MealTypeDataMapper->GetMealSettingsByRestId($restaurantid);
			return $mealSettings;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getSmsHistoryByBookingId($request)
	{
		try{
			$bookId = $request->bokid;
			$message = new Communication_Model_SmsMessage();
			$message->setBokid($bookId);
			$msgMapper = new Communication_Model_SmsMessageMapper();
			$result = $msgMapper->getSmsHistoryByBookingId($message);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function BookingDetailsAPI($request,$slotsArr)
	{
		try{
			
			$stateId	= "";
			$cityId		= "";
			$regionId	= "";
				
			$mapper = new Reservation_Model_ReservationDataMapper();
			$dinerDetails = new Reservation_Model_Reservation();

			//$userid = $formData['userid'];
			
			$resModeMapper = new Application_Model_ReservationModeDataMapper();			
			
			/* Check Whether API Call is from Pingup if yes then add company id */

			$licensekey = $request->key;
			$companyMapper = new Administrator_Model_CompanyDataMapper();			
			$licenseStatus = $companyMapper->checkLicenseKey($licensekey);
                        $roomno = '';
                        if($request->roomno){
                            $roomno = $request->roomno;
                        }
			
			if(isset($request->bokSrcComp) && $request->bokSrcComp != 1){
				$resModeStatus 	  = $resModeMapper->GetReservationModeByCode(array($request->bokSrcComp));
				$resModeObj 	  = $resModeStatus[$request->bokSrcComp];
			}else{
				$resModeStatus  = $resModeMapper->GetReservationModeByCode(array('INAT'));
				$resModeObj 	  = $resModeStatus['INAT'];
			}
			
			$dinerDetails->setbokcompany_id($licenseStatus['comapnyId']);

			if($licenseStatus['comapnyId'] == 6){
				$dinerDetails->setbokbooking_confirm_status('resvconfirm');
			}
			
			$dinerDetails->setbokfk_restaurant((int)$request->restaurantid);
			//$dinerDetails->setresrestaurant_name($formData['resName']);
			//$dinerDetails->setresaddress($formData['resAddress']);
			$dinerDetails->setbokbooking_date($request->date);
			$dinerDetails->setbokbooking_timings($request->time);
			$dinerDetails->setbokparty_size((int)$request->partysize);

			/* Reteriving Reservation Status Id by Code */
			$status[] = 'RSD';
			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($status);
			$bookStatusRes = $bookStatusRes['RSD'];
			$dinerDetails->setbokbooking_status_id($bookStatusRes->getId());
			$dinerDetails->setbokbooking_status($bookStatusRes->getId());

			if($request->lname){
				$dinerDetails->setbokfirst_name($request->fname);
				$dinerDetails->setboklast_name($request->lname);
			}else{
				$fname = explode(' ',$request->fname);
				$dinerDetails->setbokfirst_name($fname[0]);
				if($fname[1]){
					$dinerDetails->setboklast_name($fname[1]);
				}else{
					$dinerDetails->setboklast_name('.');
				}
			}
			
			$dinerDetails->setbokphone($request->phone);
			$dinerDetails->setbokemail($request->email);
                        if($roomno && $request->splrequest){
                         $dinerDetails->setbokspecial_request($request->splrequest.': Room Number '.$roomno); 
                        }else if($request->splrequest){
                          $dinerDetails->setbokspecial_request($request->splrequest);  
                        }else{
                          $dinerDetails->setbokspecial_request("Room Number ".$roomno);
                        }										
			$resServ = new Application_Service_Firm();
			$timeZone = $resServ->GetRestaurantTimeZone($request->restaurantid);
			date_default_timezone_set($timeZone);

			$dinerDetails->setbokbooking_made_on(date('Y-m-d H:i:s'));
			$dinerDetails->setBookingMadeTime(date("H:i",time()));
			$bookPhrase = uniqid ();
			$dinerDetails->setbokbookingphrase($bookPhrase);
			
			$payStat = false;
			$customerDetails = new User_Model_Guest();
			$bookTypeMapper = new Application_Model_ReservationTypeDataMapper();
			
			$dinerDetails->setbokbooking_type_code('NOR');
			$bookType = $bookTypeMapper->GetBookingTypeByCode('NOR');
			$dinerDetails->setbokbooking_type_id($bookType->getid());
			//$dinerDetails->setbokuserid($formData['userid']);
			
			$resDataMapper = new FirmManagement_Model_FirmDataMapper();
			$seetingArr = $resDataMapper->getScheduleSettingTypeByresId($request->restaurantid);
			$dinerDetails->setbok_restsch_setting_id($seetingArr['settingId']);
			$dinerDetails->setbok_restsch_setting_type($seetingArr['settingType']);
			
			$dinerDetails->setbokreservation_mode_id($resModeObj->getId());

			$dinerDetails->setTableSize($slotsArr['pax']);
			$dinerDetails->setNoOfTables($slotsArr['nooftables']);
			$dinerDetails->setNotificationType('both');
			if($slotsArr['inventory_id']){
				$dinerDetails->setInventoryId($slotsArr['inventory_id']);
			}
			
			$result = $mapper->saveBookingDetails($dinerDetails);

			$dinerDetails->setbokid($result);
			$mailmapper = new Application_Service_Communication();
			
			if($result){
				$splresult = "";					
				$restObj= new FirmManagement_Model_FirmById();
				$restObj->setRestaurantId($request->restaurantid);
				$resDetails = $resDataMapper->getRestaurantById($restObj);
				//if($formData['paymentStatus'] == 'false'){
					$mailObj = new Communication_Model_Mail();
					if($request->email != ''){
						if($stateId == "" && $cityId == ""){
							$stateCity = $this->getRestaurantStateByResId($request->restaurantid);
							$stateId = $stateCity['state'];
							$cityId = $stateCity['city'];
							$regionId = $stateCity['region'];
						}
						$restInfo = $mapper->ReterieveRestemails($request->restaurantid);
						$userType = 'CUS';
						$adminService = new Application_Service_Administrator();
						$campProp = new Application_Model_GetCampaignForPost();
						$campProp->setAudType($userType)
						->setStateId($stateId)
						->setCityId($cityId)
						->setRegionId($regionId)
						->setIsAjaxCall(false);
						$campDetails = array();
						if(!$resDetails->getrescampaignstatus() === false){
							$campDetails = $adminService->GetCampaignDetails($campProp);
						}
									
						$mailObj->setMsgCode('BookConf');
						$name = $request->fname.' '.$request->lname;

						$data = array('UserName' 			=> 	$name,
									    'SenTo'    			=> 	$request->email,
										'RestEmails'    	=> 	$restInfo['emails'],
									    'RestName' 			=> 	$resDetails->getRestaurantname(),
										'ResDate'  			=> 	$request->date,
										'Time'     			=> 	$request->time,
										'Size'     			=>	$request->partysize,
										'Address'	 		=> 	$resDetails->getRestaddress(),
										'resphone' 			=> 	$resDetails->getRestphone(),
										'resemail'			=>	$resDetails->getRestemail(),
										'phone'	 			=> 	$request->phone,	
										'rescity'			=>	$resDetails->getRestCityDesc(),
										'resnbh'			=>	$resDetails->getRestNeighborDesc(),
										'reszipcode'		=>	$resDetails->getRestzipcode(),	
										'Status'	 		=> 	'RSD',
										'Bokid'	 			=>	$result,
										'State_Id'			=>	$stateId,
										'City_Id'			=>	$cityId,
										'UserType'			=>	$userType,
										'Note'	 			=>	$request->splrequest,
										'BookNotf'			=>	true,
								);
						$data['splstatus']	= false;
						if(count($campDetails)){
							$count = count($campDetails);
							if($count > 1){
								$campaign = $campDetails[rand(0,$count-1)];
							}else{
								$campaign = $campDetails[0];
							}
							$notfService = new Application_Service_Communication();
							$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
							$data['campaignName'] = trim($campaign->getSponsor());
							$data['campaignDesc'] =	trim($campaign->getCampDesc());
							$data['campaignImg'] =	trim($campaign->getCampImage());
							$data['campId']	= $campaign->getId();
						}
						$mailObj->setData($data);
						$mailStatus = $mailmapper->SendMail($mailObj);
					}
//					$restInfo = $mapper->ReterieveRestemails($request->restaurantid);
//					if($restInfo){
//						if($stateId == "" && $cityId == ""){
//							$stateCity = $this->getRestaurantStateByResId($request->restaurantid);
//							$stateId = $stateCity['state'];
//							$cityId = $stateCity['city'];
//							$regionId = $stateCity['region'];
//						}
//						$userType = 'RES';
//						if($resDetails->getrescampaignstatus()){
//							$campProp = new Application_Model_GetCampaignForPost();
//							$campProp->setAudType($userType)
//								->setStateId($stateId)
//								->setCityId($cityId)
//								->setRegionId($regionId)
//								->setIsAjaxCall(false);
//							if(!$resDetails->getrescampaignstatus() === false){
//								$campDetails = $adminService->GetCampaignDetails($campProp);
//							}	
//						}else{
//							$campDetails = array();
//						}
//						$adminService = new Application_Service_Administrator();							
//
//						if($restInfo['status'] && isset($restInfo['emails'])){
//							$mailObj->setMsgCode('BookNotf');
//							$name = $request->fname.' '.$request->lname;
//
//							$data = array(
//										  'UserName' 			=> 	$name,
//										  'SenTo'    			=> 	$restInfo['emails'],
//										  'RestName' 			=> 	$resDetails->getRestaurantname(),
//										  'ResDate'  			=> 	$request->date,
//										  'Time'     			=> 	$request->time,
//										  'email'	 			=> 	$request->email,
//										  'phone'	 			=> 	$request->phone,	
//										  'Size'     			=> 	$request->partysize,
//										  'Address'	 			=> 	$resDetails->getRestaddress(),
//										  'Note'	 			=>	$request->splrequest,
//										  'Bookid'	 			=> 	$result,
//										  'State_Id'			=>	$stateId,
//										  'City_Id'				=>	$cityId,
//										  'UserType'			=>	$userType);
//							if(count($campDetails)){
//								$count = count($campDetails);
//								if($count > 1){
//									$campaign = $campDetails[rand(0,$count-1)];
//								}else{
//									$campaign = $campDetails[0];
//								}
//								$notfService = new Application_Service_Communication();
//								$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
//								$data['campaignName'] = trim($campaign->getSponsor());
//								$data['campaignDesc'] =	trim($campaign->getCampDesc());
//								$data['campaignImg'] =	trim($campaign->getCampImage());
//								$data['campId']	= $campaign->getId();
//							}
//							$mailObj->setData($data);
////							$mailStatus = $mailmapper->SendMail($mailObj);
//						}
//					}
						
					$restservice = new Application_Service_Firm();
					$timeZone = $restservice->GetRestaurantTimeZone($request->restaurantid);
					date_default_timezone_set($timeZone);
					
					$restPhoneInfo = $restservice->getRestaurantPhoneDetails($request->restaurantid);
					
					$splitbookdate   = explode('-',$request->date);								
					$bookingdate   = date('Y-m-d',mktime(0,0,0,$splitbookdate[0],$splitbookdate[1],$splitbookdate[2]));
					$todaydate     = date('Y-m-d');
							
					if(strtotime($bookingdate) == strtotime($todaydate)){
						/* get day of week */
						
	
						if($restPhoneInfo['smsnotify']){
							$phoneRowSet = $restPhoneInfo['rowset'];
							$phonenumber = "";
							$fromtime    = "";
							$totime		 = "";
							$resvTime    = $request->time;

							if($phoneRowSet){
								foreach($phoneRowSet as $phoneNum){
									if($phoneNum->rntnotify_type == 'sms'){
										$phonenumber = $phoneNum->rntphone;
										$fromtime    = $phoneNum->rntnotify_from_time;
										$totime		 = $phoneNum->rntnotify_to_time;
										$countrycode = $phoneNum->rntcountrycode;
									}
								}
								if($phonenumber){
									if(strtotime($resvTime)>= strtotime($fromtime) && strtotime($resvTime)<= strtotime($totime)){
										$smsObj = new Communication_Model_Sms();
										$smsObj->setMsgCode('BookNotf');

										$data = array('to' 		 	 => $phonenumber,
													  'countrycode'	 => $countrycode,
													  'bokid'    	 => $result,
													  'RestName' 	 => $resDetails->getRestaurantname(),
													  'ResDate'	 	 => $request->date,
													  'Time'		 => $request->time,
													  'Size'		 => $request->partysize,
													  'CustomerName' => $request->fname.' '.$request->lname);

										$smsObj->setData($data);
										$mailStatus = $mailmapper->SendSms($smsObj);

									}
								}
							}
						}
					}
					$formData = array( 
									'restaurantid'	=>	$request->restaurantid,
									'firstName'		=>	$request->fname,
									'lastName'		=>	$request->lname,
									'email'			=>	$request->email,
									'number'		=>	$request->phone,
									'cuscontactid'	=> ''
								);
					$restservice->AddCustomerContact($formData,$request->splrequest);
						
					/* Check If reservation is for future date and save the info for reminder process */
					$splitbookdateNotify   = explode('-',$request->date);
								
					$bookingdateNotify   = date('Y-m-d',mktime(0,0,0,$splitbookdateNotify[0],$splitbookdateNotify[1],$splitbookdateNotify[2]));
					$todaydateNotify     = date('Y-m-d');
					if(strtotime($bookingdateNotify) > strtotime($todaydateNotify)){
						$BookingNotify = new Reservation_Model_ReservationNotify();
						
						$BookingNotify->setbknfk_booking($result);
						$BookingNotify->setbkn_booking_date($request->date);
						
						$NotifyMapper = new Reservation_Model_ReservationNotifyMapper();
						$notifyInfoStatus = $NotifyMapper->SaveBookingNotifyInfo($BookingNotify);
					}
					$resultant = array('bookingid'=>$result);
					return $resultant;
				//}
			}else{
				return false;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function UpdateReservationMobile(array $data,$bokid)
	{
		try{
			$form = $this->getMakeResevMobileForm();
			if($form->isValid($data)){
				$formData = $form->getValues();
				$bookTypeMapper = new Application_Model_ReservationTypeDataMapper();
				$bookType = $bookTypeMapper->GetBookingTypeByCode('NOR');

				$statusCode = array();

				if($data['bookingStatus']){
					$statusCode[] = $data['bookingStatus'];
				}
				$statusCode[] = 'RES';

				$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
				$bookStatus 	  = $bookStatusMapper->GetBookingStatusByCode($statusCode);
				$bookStatusObj 	  = $bookStatus[$data['bookingStatus']];
					

				$resModeMapper = new Application_Model_ReservationModeDataMapper();
				$rescode = $formData['origin'];
				$resModeStatus 	  = $resModeMapper->GetReservationModeByCode(array($rescode));
				$resModeObj 	  = $resModeStatus[$rescode];

				$mapper = new Reservation_Model_ReservationDataMapper();
				$dinerDetails = new Reservation_Model_Reservation();

				/* get booikng id with phraseid */
				$phraseId = $mapper->GetBookingIdByBookPhrase($bokid);
				
				$dinerDetails->setbokid($phraseId);
				$dinerDetails->setRescheduleCode('RES');
//				
				$resStatusObj = $bookStatus['RES'];
				if($resStatusObj){
					$dinerDetails->setRessch_Status_Id($resStatusObj->getId());
				}
				$dinerDetails->setbokfk_restaurant($formData['restaurantid']);
				$dinerDetails->setbokbooking_date($formData['resDate']);
				if($data['bookingStatus'] == 'RSD'){
					$dinerDetails->setbokbooking_timings($formData['seltime']);
				}else if($data['bookingStatus'] == 'OVB'){
					$dinerDetails->setbokbooking_timings($formData['resTime']);
				}

				$dinerDetails->setbokparty_size($formData['pax']);
				$dinerDetails->setbokbooking_status_id($bookStatusObj->getId());
				$dinerDetails->setbokbooking_status_code($bookStatusObj->getCode());
				$dinerDetails->setbokbooking_status($bookStatusObj->getId());
				$dinerDetails->setbokfirst_name($formData['firstName']);
				$dinerDetails->setboklast_name($formData['lastName']);
				$dinerDetails->setbokphone($formData['number']);
				$dinerDetails->setbokcountry_code($formData['countryCode']);
				$dinerDetails->setbokemail($formData['email']);
				$dinerDetails->setbokrestaurant_note($formData['dinerRequest']);

				$resServ = new Application_Service_Firm();
				$timeZone = $resServ->GetRestaurantTimeZone($formData['restaurantid']);
				date_default_timezone_set($timeZone);

				$dinerDetails->setbokbooking_made_on(date('Y-m-d H:i:s'));
				$dinerDetails->setBookingMadeTime(date("H:i",time()));
				$storage = new Zend_Auth_Storage_Session();
				$data = $storage->read();
				$userid = $data['User_Id'];
				
				$bookPhrase = uniqid ();
				$dinerDetails->setbokbookingphrase($bookPhrase);

				$dinerDetails->setbokuserid($userid);
				$dinerDetails->setbokspecial_request($formData['contactInfo']);
				$dinerDetails->setbokbooking_type_id($bookType->getId());
				$dinerDetails->setbokreservation_mode_id($resModeObj->getId());
				$dinerDetails->setTableSize($formData['tableSize']);
				$dinerDetails->setNoOfTables($formData['noOfTables']);
				$dinerDetails->setInventoryId($formData['inventoryid']);
				$dinerDetails->setNotificationType($formData['notificationType']);
				
				$resDataMapper = new FirmManagement_Model_FirmDataMapper();
				$seetingArr = $resDataMapper->getScheduleSettingTypeByresId($formData['restaurantid']);
				$dinerDetails->setbok_restsch_setting_id($seetingArr['settingId']);
				$dinerDetails->setbok_restsch_setting_type($seetingArr['settingType']);
				
				$result = $mapper->saveMakeReservationDetails($dinerDetails,'reserv',$formData);

				$dinerDetails->setbokid($result);
				$mailmapper = new Application_Service_Communication();
				$restService = new Application_Service_Firm();
				$restResult = $restService->GetRestaurantDetailsById($formData['restaurantid']);
				$resDataMapper = new FirmManagement_Model_FirmDataMapper();
				$restObj= new FirmManagement_Model_FirmById();
				$restObj->setRestaurantId($formData['restaurantid']);
				$resDetails = $resDataMapper->getRestaurantById($restObj);
				if($formData['notificationType'] == 'email'){
					$mailObj = new Communication_Model_Mail();
					$mailObj->setMsgCode('BookConf');

					/* Get Restaurant Geo Location */

					$stateCity = $this->getRestaurantStateByResId($formData['restaurantid']);
					$stateId = $stateCity['state'];
					$cityId = $stateCity['city'];
					$regionId = $stateCity['region'];

					$userType = 'CUS';
					$adminService = new Application_Service_Administrator();
					$campProp = new Application_Model_GetCampaignForPost();
					$campProp->setAudType($userType)
					->setStateId($stateId)
					->setCityId($cityId)
					->setRegionId($regionId)
					->setIsAjaxCall(false);
					$campDetails = array();
					if(!$resDetails->getrescampaignstatus() === false){
						$campDetails = $adminService->GetCampaignDetails($campProp);
					}

					$name = $formData['firstName'].' '.$formData['lastName'];
					$data = array('UserName' => $name,
							  'SenTo'    => $formData['email'],
							  'phone'    =>	$formData['number'], 			
							  'RestName' => $restResult->resrestaurant_name,
							  'ResDate'  => $formData['resDate'],
							  'Time'     => $formData['resTime'],
							  'Size'     => $formData['pax'],
							  'Address'	 => $restResult->resaddress,
							  'resphone' => $resDetails->getRestphone(),
							  'resemail' =>	$resDetails->getRestemail(),
							  'rescity'	 =>	$resDetails->getRestCityDesc(),
							  'resnbh'	 =>	$resDetails->getRestNeighborDesc(),
							  'reszipcode'=>$resDetails->getRestzipcode(),
							  'Status'	 => $result['bokstatus'], 
							  'Bokid'	 =>	$result,
							  'State_Id' =>	$stateId,
							  'City_Id'	 =>	$cityId,
							  'UserType' =>	$userType,
							  'Note' 	 =>	$formData['dinerRequest'],
							  'BookNotf' => false,
					);
					if(count($campDetails)){
						$count = count($campDetails);
						if($count > 1){
							$campaign = $campDetails[rand(0,$count-1)];
						}else{
							$campaign = $campDetails[0];
						}
						$notfService = new Application_Service_Communication();
						$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
						$data['campaignName'] = trim($campaign->getSponsor());
						$data['campaignDesc'] =	trim($campaign->getCampDesc());
						$data['campId']	= $campaign->getId();
					}

					$mailObj->setData($data);
					$mailStatus = $mailmapper->SendMail($mailObj);

				}
				if($result){
					$resultarray['status']= true;
				}
				return $resultarray;
			}else{
				$resultarray['status'] = false;
				$form->populate($data);
				$resultarray['form'] = $form;
				return $resultarray;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetDiningTabData($request)
	{
		try{
			$resId = $request->restaurantid;
			$diningidArr = array();
			$diningAreaArr = array();
			$diningMapper = new FirmManagement_Model_FirmDiningAreaDataMapper();
			$Diningresult = $diningMapper->getDinigAreasByRestId($resId);
			if($request->diningid){
				$diningid = $request->diningid;
			}else{
				foreach($Diningresult as $dining){
					$diningidArr[] = $dining->rdaid;
				}
				$diningid = $diningidArr[0];
			}
			$result['diningareas'] = $Diningresult;
			$result['diningid'] = $diningid;

			$mapper = new FirmManagement_Model_FirmTableDataMapper();
			$tableObj = new FirmManagement_Model_FirmTable();
			$tableObj->setResId($resId);
			$tableObj->setDiningId($diningid);
			$resultStr = $mapper->getRestaurantTable($tableObj);
			$layout = $resultStr['finalStr'] ;
			$entrance = $resultStr['etnStr'];
			$result['Layout'] = $layout;
			$result['Entrance'] = $entrance;

			/* Reteriving Table layout end */
			
			/* Retrieve seprator layout start */
			
			$restFloorSep = new FirmManagement_Model_FirmFloorSeprator();
			$restFloorSep->setrfsfk_restaurant($resId);
			$restFloorSep->setrfsfk_restaurant_dining_area($diningid);	
			
			$resFloorSepMapper = new FirmManagement_Model_FirmFloorSepratorMapper();
			$floorSepArr = $resFloorSepMapper->retrieveFloorSeprators($restFloorSep);
			
			$result['FloorSep'] = $floorSepArr; 
			/* Retrieve seprator layout end */
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function Gettimeslotsforchart($request)
	{
		try{
			$mapper = new Reservation_Model_ReservationDataMapper();
			$result = $mapper->GetMonthlyTimeSlotsForChart($request);
			$mealTypes = $this->getRestaurantMealTypes($request);
			if($result['resultCount'] && $mealTypes['count']){ 
				$dataCount = count($result['resultCount']);
	        	$segmentDivide = 4;
	        	$segmentLimit = ceil($dataCount / $segmentDivide);
	        	
	     		$totalCount = array();
	     		$end_Time = array();
				$start_time = array();
	   
				$startTime = array();
				$endTime = array();
				$TimeArr = array();
				
				foreach($mealTypes as $key=>$meal){
					if($key != 'count'){
						$TimeArr[] = $meal['desc'];
						$startTime[] = $meal['starttime'];
						$endTime[] = $meal['endtime'];
					}
				}  
				for($i = 0 ; $i < count($startTime) ; $i++){
					$total = 0;	 
					foreach($result['resultCount'] as $timeArr=>$subtime){
						if(strtotime($startTime[$i]) > strtotime($timeArr) && strtotime($timeArr) > strtotime($endTime[$i])){
							break;
						}
						if(strtotime($startTime[$i]) <= strtotime($timeArr) && strtotime($timeArr) <= strtotime($endTime[$i])){
							$total += $subtime;	
						}else{
							continue;
						}
					}
					$totalCount[] = $total;					
				}
				 
				$DataSet = new Uss_Charts_pData();
				$DataSet->AddPoint($totalCount,"Serie1");  
			    $DataSet->AddPoint($TimeArr,"Serie2");  
				$DataSet->AddAllSeries();  
				$DataSet->SetAbsciseLabelSerie("Serie2");
				// Initialise the graph  
				$Test = new Uss_Charts_pChart(400,230);
				$Test->drawFilledCircle(122,102,70,200,200,200);  
				// Draw the pie chart  
				$Test->setFontProperties("Fonts/tahoma.ttf",8);  
				$Test->drawBasicPieGraph($DataSet->GetData(),$DataSet->GetDataDescription(),120,100,70,PIE_PERCENTAGE,255,255,218); 
				$Test->drawPieLegend(250,15,$DataSet->GetData(),$DataSet->GetDataDescription(),250,250,250);  
				$imageName = uniqid ();
				$Test->Render('reportimages/'.strtolower($imageName).".png");
				$piechart = strtolower('reportimages/'.strtolower($imageName).".png");
				
				if($result['resultName']){					
					$chunkName = array_chunk($result['resultName'], $segmentLimit,true);
					$NameArray = array();
					for($i = 0 ; $i < count($startTime) ; $i++){
						$total = 0;	 
						foreach($result['resultName'] as $k=>$name){
							if(strtotime($startTime[$i]) > strtotime($k) && strtotime($k) > strtotime($endTime[$i])){
								break;
							}
							if(strtotime($startTime[$i]) <= strtotime($k) && strtotime($k) <= strtotime($endTime[$i])){
								$nameArray = array();
								$timeval[$k] = array_values($name);				
							}else{
								continue;
							}
						}
						$NameArray[] = $timeval;
						$timeval = array();
					}	
					$resFinal =	array_combine($TimeArr, $NameArray);
				}
				$resultSet = array('nameArray' => $resFinal, 'piechart' => $piechart);
				return $resultSet;
			}else{
				return $result;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function Gettimeslotsfororiginchart($request)
	{
		try{
			$mapper = new Reservation_Model_ReservationDataMapper();
			$result = $mapper->GetMonthlyOriginForChart($request);
			if($result['resultCount']){ 
				$dataCount = count($result['resultCount']);
	     		
	     		$end_Time = array();
				$start_time = array();
	  
				$startTime = array();
				$endTime = array();
				$TimeArr = array_keys($result['resultCount']);
				$totalCount = array_values($result['resultCount']);
				 
				$DataSet = new Uss_Charts_pData();
				$DataSet->AddPoint($totalCount,"Serie1");  
			    $DataSet->AddPoint($TimeArr,"Serie2");  
				$DataSet->AddAllSeries();  
				$DataSet->SetAbsciseLabelSerie("Serie2");  
	  
				// Initialise the graph  
				$Test = new Uss_Charts_pChart(400,230);
				$Test->drawFilledCircle(122,102,70,200,200,200);  
				// Draw the pie chart  
				$Test->setFontProperties("Fonts/tahoma.ttf",8);  
				$Test->drawBasicPieGraph($DataSet->GetData(),$DataSet->GetDataDescription(),120,100,70,PIE_PERCENTAGE,255,255,218);
				$Test->drawPieLegend(250,15,$DataSet->GetData(),$DataSet->GetDataDescription(),250,250,250);  
				$imageName = uniqid ();
				$Test->Render('reportimages/'.strtolower($imageName).".png");
				$piechart = strtolower('reportimages/'.strtolower($imageName).".png");
				
				$resultSet = array('nameArray' => $result['resultName'], 'originpiechart' => $piechart);
				return $resultSet;
			}
			else{
				return $result;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	public function getpastandfuturereservations($request,$page)
	{
		try{							
			$mapper = new Reservation_Model_ReservationDataMapper();
			$restResult = $mapper->getpastandfuturereservations($request,$page);
			return $restResult;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	public function getCustomerDetailsbybookingdata($request)
	{
		try{
			$mapper = new FirmManagement_Model_FirmGroupUsersDataMapper();
			$restResult = $mapper->GetCustomerDetailsbybookingdata($request);
			return $restResult;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetSeatedInventory($restid,$date)
	{
		try
		{
			$getSeatInv = new Reservation_Model_GetSeatedInventoryByDate();
			$getSeatInv->setrestid($restid);
			$getSeatInv->setdate($date);
			
			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			$bookStatus = array('ALC','DES','BOK','PTS','CRD','COM','WRD');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
			$statusId = array();
			foreach($bookStatusRes as $key=>$value){
				$statusId[] = $value->getId();
			}
			
			$getSeatInv->setstatusid($statusId);
			
			$bookTableMapper = new Reservation_Model_ReservationTableMapper();
			
			$result = $bookTableMapper->retrieveSeatedInventory($getSeatInv);
			
			return $result;
			 
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function CancelReservationAPI($request)
	{
		try{
			$resultArr = array();
			$bokid = $request->bookingid;
			$mapper = new Reservation_Model_ReservationDataMapper();
			
			/* get booking id with phraseid */
			//$phraseId = $mapper->GetBookingIdByBookPhrase($bokid);
			
			$result = $this->GetBookingDetails($bokid);
			if($result->getbokfk_restaurant()){
				$staus = $result->getbokbooking_status_code();
				$restid = $result->getbokfk_restaurant();
	
				$resServ = new Application_Service_Firm();
				$timeZone = $resServ->GetRestaurantTimeZone($restid);
				date_default_timezone_set($timeZone);
	
				$bokdatesplit = explode("-",$result->getbokbooking_date());
				$time = explode(" ",$result->getbokbooking_timings());
				$timeHM = explode(":",$time[0]);
				if($time[1] ==  "PM"){
					if((int)$timeHM[0] != 12){
						(int)$timeHM[0] += 12;
					}
				}//if the time is PM than adding 12 to hours
				if($time[1] ==  "AM" && (int)$timeHM[0] == 12){
	
					(int)$timeHM[0] = 0;
	
				}
				$bokdaySec = mktime($timeHM[0],$timeHM[1],0,$bokdatesplit[1],$bokdatesplit[2],$bokdatesplit[0]);
	
				$datesplit = explode("-",date('m-d-Y'));
				$timesplit = explode(":",date('H:i:s'));
				$todaySec = mktime($timesplit[0],$timesplit[1],$timesplit[2],$datesplit[0],$datesplit[1],$datesplit[2]);
				if($bokdaySec > $todaySec){
					if($staus == 'RSD' || $staus == 'WAL'){
						$bokStatusCode = 'CAN';
						$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
						$bookStatus 	  = $bookStatusMapper->GetBookingStatusByCode(array($bokStatusCode));
						$bookStatusObj 	  = $bookStatus[$bokStatusCode];
						//$code = $request->tableStatus;
						$bookingObj = new Reservation_Model_Reservation();
						$bookingObj->setbokid($bokid);
						$bookingObj->setbokbooking_status_id($bookStatusObj->getId());
						$bookingObj->setbokbooking_status_desc($staus);
						$bookingObj->setInventoryId($result->getInventoryId());
						$bookingObj->setbokfk_restaurant($restid);
						
						$bookStatus = $mapper->CancelNoteByBookingId($bookingObj);
						if($bookStatus){
							$stateId = "";
							$cityId = "";
							$regionId = "";
							if($bokStatusCode == 'CAN'){
								if($stateId == ""){
									$stateCity = $this->getRestaurantStateByResId($result->getbokfk_restaurant());
									$stateId = $stateCity['state'];
									$cityId = $stateCity['city'];
									$regionId = $stateCity['region'];
	
								}
								$userType = 'CUS';
								$adminService = new Application_Service_Administrator();
								$campProp = new Application_Model_GetCampaignForPost();
								$campProp->setAudType($userType)
								->setStateId($stateId)
								->setCityId($cityId)
								->setRegionId($regionId)
								->setIsAjaxCall(false);
								$campDetails = $adminService->GetCampaignDetails($campProp);
	
								$book = new Reservation_Model_Reservation();
								$book->setbokid($bokid);
								$mapper->getBookingDetails($book);
								$neme = $book->getresrestaurant_name();
								$mailmapper = new Application_Service_Communication();
								if($book->getbokemail()){
									$restInfo = $mapper->ReterieveRestemails($restid);
									$mailObj = new Communication_Model_Mail();
									$mailObj->setMsgCode('Cancel');
									$name = $book->getbokfirst_name().' '.$book->getboklast_name();
									$data = array('UserName' => $name,
												  'SenTo'    	=> $book->getbokemail(),
												  'phone'    	=> $book->getbokphone(),
											  	  'RestName' 	=> $book->getresrestaurant_name(),
												  'ResDate'  	=> $book->getbokbooking_date(),
												  'RestEmails'	=> $restInfo['emails'],
												  'Time'     	=> $book->getbokbooking_timings(),
												  'Size'     	=> $book->getbokparty_size(),
												  'Address'	 	=> $book->getresaddress(),
												  'Status'	 	=> $book->getbokbooking_status_desc(),
												  'State_Id' 	=> $stateId,
												  'City_Id'	 	=> $cityId,
												  'resphone' 	=> $book->getResPhone(),
												  'UserType' 	=> $userType,
												  'BookId'	 	=> $bokid,
												  'BookNotCan'	=> true,
									);
									if(count($campDetails)){
										$count = count($campDetails);
										if($count > 1){
											$campaign = $campDetails[rand(0,$count-1)];
										}else{
											$campaign = $campDetails[0];
										}
										$notfService = new Application_Service_Communication();
										$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
										$data['campaignName'] = trim($campaign->getSponsor());
										$data['campaignDesc'] =	trim($campaign->getCampDesc());
										$data['campaignImg'] =	trim($campaign->getCampImage());
										$data['campId']	= $campaign->getId();
									}
										
									$mailObj->setData($data);
									$mailStatus = $mailmapper->SendMail($mailObj);
								}
								/*if($book->getbokphone()){
									$smsObj = new Communication_Model_Sms();
									$smsObj->setMsgCode('Cancel');
									$data = array('to'	=>	trim($book->getbokphone()),
												  'RestName' => $book->getresrestaurant_name(),
												  'ResDate'  => $book->getbokbooking_date(),
									   			  'Time'     => $book->getbokbooking_timings(),
									   			  'Size'     => $book->getbokparty_size() 	
									);
	
									$smsObj->setData($data);
									$mailStatus = $mailmapper->SendSms($smsObj);
								}*/
								//$restInfo = $mapper->ReterieveRestInfo($restid);
//								$restInfo = $mapper->ReterieveRestemails($restid);
//								if($restInfo){
//									if($restInfo['status'] && isset($restInfo['emails'])){
//										$mailObj = new Communication_Model_Mail();
//										$stateCityVal = $this->getRestaurantStateByResId($result->getbokfk_restaurant());
//										$stateIdVal = $stateCityVal['state'];
//										$cityIdVal = $stateCityVal['city'];
//										$regionIdVal = $stateCityVal['region'];
//	
//										$userType = 'RES';
//										
//										$resDataMapper = new FirmManagement_Model_FirmDataMapper();
//										$restObj= new FirmManagement_Model_FirmById();
//										$restObj->setRestaurantId($restid);
//										$resDetails = $resDataMapper->getRestaurantById($restObj);
//										
//										$adminService = new Application_Service_Administrator();
//										if($resDetails->getrescampaignstatus()){
//											$campProp = new Application_Model_GetCampaignForPost();
//											$campProp->setAudType($userType)
//											->setStateId($stateIdVal)
//											->setCityId($cityIdVal)
//											->setRegionId($regionIdVal)
//											->setIsAjaxCall(false);
//											$campDetails = $adminService->GetCampaignDetails($campProp);
//										}else{
//											$campDetails = array();
//										}
//										//$restEmail = $restInfo->resemail;
//										$mailObj->setMsgCode('BookNotCan');
//										$name = $book->getbokfirst_name().' '.$book->getboklast_name();
//	
//										$data = array('UserName' => $name,
//											  'SenTo'    => $restInfo['emails'],
//											  'RestName' => $book->getresrestaurant_name(),
//											  'ResDate'  => $book->getbokbooking_date(),
//											  'Time'     => $book->getbokbooking_timings(),
//											  'email'	 => $book->getbokemail(),
//											  'phone'	 => $book->getbokphone(),	
//											  'Size'     => $book->getbokparty_size(),
//											  'Address'	 => $book->getresaddress(),
//											  'Bookid'	 => $bokid,
//											  'State_Id' =>	$stateId,
//											  'City_Id'	 =>	$cityIdVal,
//											  'UserType' =>	$userType
//										);
//										if(count($campDetails)){
//											$count = count($campDetails);
//											if($count > 1){
//												$campaign = $campDetails[rand(0,$count-1)];
//											}else{
//												$campaign = $campDetails[0];
//											}
//											$notfService = new Application_Service_Communication();
//											$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
//											$data['campaignName'] = trim($campaign->getSponsor());
//											$data['campaignDesc'] =	trim($campaign->getCampDesc());
//											$data['campaignImg'] =	trim($campaign->getCampImage());
//											$data['campId']	= $campaign->getId();
//										}
//										$mailObj->setData($data);
////										$mailStatus = $mailmapper->SendMail($mailObj);
//									}
//								}
	
								$restservice = new Application_Service_Firm();
								$timeZone = $restservice->GetRestaurantTimeZone($restid);
								date_default_timezone_set($timeZone);
	
								/* Reterieve Phone Notify Details */
								if($staus == 'RSD'){
	
									$restPhoneInfo = $restservice->getRestaurantPhoneDetails($restid);
	
									$bookingdate   = $book->getbokbooking_date();
									$todaydate     = date('Y-m-d');
									
									$currdate = date('m-d-Y');
									
									
									if($restPhoneInfo['smsnotify']){
	
										$phoneRowSet = $restPhoneInfo['rowset'];
										$phonenumber = "";
										$fromtime    = "";
										$totime		 = "";
										$resvTime    = $book->getbokbooking_timings();
	
										if($phoneRowSet){
											foreach($phoneRowSet as $phoneNum){
												if($phoneNum->rntnotify_type == 'sms'){
													$phonenumber = $phoneNum->rntphone;
													$fromtime    = $phoneNum->rntnotify_from_time;
													$totime		 = $phoneNum->rntnotify_to_time;
													$countrycode = $phoneNum->rntcountrycode;
												}
											}
											if($phonenumber){
	
												if(strtotime($resvTime)>= strtotime($fromtime) && strtotime($resvTime)<= strtotime($totime)){
													$smsObj = new Communication_Model_Sms();
													$smsObj->setMsgCode('CanNotf');
														
													$data = array('to' 		 => $phonenumber,
															  'bokid'    	 => $bokid,
															  'countrycode'	 => $countrycode,
															  'RestName' 	 => $book->getresrestaurant_name(),
															  'ResDate'	 	 => $book->getbokbooking_date(),
															  'Time'		 => $book->getbokbooking_timings(),
															  'Size'		 => $book->getbokparty_size(),
															  'CustomerName' => $book->getbokfirst_name().' '.$book->getboklast_name());
														
													$smsObj->setData($data);
								 				$mailStatus = $mailmapper->SendSms($smsObj);
								 					
												}
											}
										}
									}
										
								}
	
							}
							$resultArr['status'] = true;
							$resultArr['result'] = $result;
							return $resultArr;
						}
					}else{
						$resultArr['status'] = false;
						$resultArr['result'] = $result;
						return $resultArr;
					}
				}else{
					$resultArr['status'] = false;
					$resultArr['result'] = $result;
					return $resultArr;
				}
			}else{
				$resultArr['status'] = false;
				$resultArr['result'] = $result;
				return $resultArr;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getPartnerRestMealTypes($request)
	{
		try{
			
			$resid = $request->restaurantid;						
			$meal = new FirmManagement_Model_FirmMealType();
			$meal->setResId($resid);
			
			$mapper = new FirmManagement_Model_FirmMealTypeDataMapper();
			
			$result = $mapper->RetrievePartnerRestMealTypes($meal);	
				
			return $result;
			
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getInvitedGuestInfo($request)
	{
		try{
			$bookingid = $request->bookingid;
			$mapper = new Reservation_Model_ReservationInvitedGuestDataMapper();
			$restResult = $mapper->getInvitedGuestInfo($bookingid);
			return $restResult;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getBookEmailEventStatus($bookingid)
	{
		try{
			$mapper = new Reservation_Model_ReservationInvitedGuestDataMapper();
			$status = $mapper->getBookEmailEventStatus($bookingid);
			return $status;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getBookEventStatusForGuest($bookingid,$guestid)
	{
		try{
			$mapper = new Reservation_Model_ReservationInvitedGuestDataMapper();
			$status = $mapper->getBookEventStatusForGuest($bookingid,$guestid);
			return $status;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function SaveBookingFbEvent($request)
	{
		try{
			$BookingFBEvent = new Reservation_Model_ReservationFBEvent();
			$BookingFBEvent->setbfe_fb_profile_id($request->fbuserid);
			$BookingFBEvent->setbfe_fb_eventid($request->fbeventid);
			$BookingFBEvent->setbfe_fk_booking($request->bokid);
			
			$mapper = new Reservation_Model_ReservationFBEventDataMapper();
			$result = $mapper->saveBookingFbEvent($BookingFBEvent);			
			return $result;			
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	
	public function SaveBookingFbInvites($request)
	{
		try{
			$eventid = $request->eventid;
			$requestArr = array();
			$usersArr = explode(',',substr($request->users, 0, -1));
			foreach($usersArr as $user){
				$obj = new Reservation_Model_ReservationFBInvite();
				$obj->setbfi_fb_status(true)
					->setbfi_fb_invite_status('invited')
					->setbfi_fb_user($user)
					->setbfi_fk_event($eventid);
				$requestArr[] = $obj;
			}					  
			$mapper = new Reservation_Model_ReservationFBInviteDataMapper();
			$fbEvent = $mapper->SaveBookingFbInvites($requestArr);
			return $fbEvent;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getBookFbEvent($bookingid)
	{
		try{
			$BookingFBEvent = new Reservation_Model_ReservationFBEvent();
			$BookingFBEvent->setbfe_fk_booking($bookingid);
			
			$mapper = new Reservation_Model_ReservationFBEventDataMapper();
			$result = $mapper->getBookFbEvent($BookingFBEvent);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getRestaurantMenu($request)
	{
		try{
			$categoryMapper = new FirmManagement_Model_MenuCategoryDataMapper();
    		$result = $categoryMapper->restaurantMenu($request->restaurantid);
    		return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function saveMenuCartDetails($request)
	{
		try{
			$orderDataMapper = new Reservation_Model_ReservationMenuOrderDataMapper();
			$status =  $orderDataMapper->saveOrderDetails($request);
			return $status;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage());
		}
	}
	
	public function getSelectedMenuByBookingId($bookingid)
	{
		try{
			$orderDataMapper = new Reservation_Model_ReservationMenuOrderDataMapper();
			$selectedMenu =  $orderDataMapper->getSelectedMenuByBookingId($bookingid);
			return $selectedMenu;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage());
		}
	}
	
	public function updateInvitationStatus($result,$request)
	{
		try{
			$guestid = $request->guestid;
			$bookingid = $result->getbokid();
			$status = $request->constat;
			$mapper = new Reservation_Model_ReservationInvitedGuestDataMapper();
			$status = $mapper->updateInvitationStatus($guestid,$bookingid,$status);
			if($status){
				$request->setParam('senderemail',$result->getbokemail());
				$notificationService = new Application_Service_Communication();
				$notificationService->NotifyConfirmation($result,$request);
			}
			return $status;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage());
		}
	}
	
	public function getCustomerDetailsByBookingId($request)
	{
		try{
			$bookingid = $request->bookingid;
			$mapper = new FirmManagement_Model_FirmGroupUsersDataMapper();
			$restResult = $mapper->getCustomerDetailsByBookingId($bookingid);
			return $restResult;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getServerByBookingid($request)
	{
		try{
			$bookingid = $request->bookingid;
			$mapper = new Server_Model_ServerDataMapper();
			$restResult = $mapper->getServerByBookingid($bookingid);
			return $restResult;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function updateServeridByBookingid($request)
	{
		try{
			$bookingid = $request->bookingid;
			$serverid = $request->serverid;
			$restid = $request->restaurantid;
			$mapper = new Reservation_Model_ReservationDataMapper();
			$restResult = $mapper->updateServeridByBookingid($bookingid,$serverid,$restid);
			return $restResult;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function updateContactIdByBookingid($request)
	{
		try{
			$bookingid = $request->bookingid;
			$contactid = $request->contactid;
			$restid = $request->restaurantid;
			$mapper = new Reservation_Model_ReservationDataMapper();
			$restResult = $mapper->updateContactIdByBookingid($bookingid,$contactid,$restid);
			return $restResult;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function updateBookingInfoByBookingid($request)
	{
		try{			
			$formData = array( 'restaurantid'	=>	$request->restaurantid,
					 		  'firstName'		=>	$request->firstname,
							  'lastName'		=>	$request->lastname);
			$book = new Reservation_Model_Reservation();
			$book->setbokid($request->bookingid);
			$book->setbokfk_restaurant($request->restaurantid);
			$book->setbokfirst_name($request->firstname);
			$book->setboklast_name($request->lastname);
			$book->setbokparty_size($request->guestpax);
			$book->setbokrestaurant_note($request->resvnotes);
                        $book->setguest_notes($request->guestsplnotes);
			if($request->type == 'both'){
				$book->setNotificationType($request->type);
			}else if($request->type == 'sms'){
				$book->setNotificationType($request->type);
			}else{
				$book->setNotificationType($request->type);
			}
			$book->setbokphone($request->phone);
			$book->setbokemail($request->email);
			$formData['email'] = $request->email;
			$formData['number'] = $request->phone;
			$formData['countryCode'] = $request->countrycode;
                        $formData['guestsplnotes'] = $request->guestsplnotes;
                        $formData['guestid'] = $request->guestupdateId;
			$book->setbokcountry_code($request->countrycode);
			$restservice = new Application_Service_Firm();
			$guestid = $restservice->AddCustomerContact($formData,'');
			$book->setbokcontactid($guestid);
			$mapper = new Reservation_Model_ReservationDataMapper();
			$restResult = $mapper->updateBookingInfoByBookingid($book);
			return $restResult;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getSpecialDetailsByBokid($request)
	{
		try{
			$bookingid = $request->bookingid;
			$splmapper = new Deals_Model_RestaurantSpecialDataMapper();
			$splresult = $splmapper->getSpecialDetailsByBookingId($bookingid);
			return $splresult;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	/**
	 * @param array,userid
	 * function to save the reservation details taken by the restaurant authorities
	 */
	public function MakeWaitingReservationMobile(array $data,$userid)
	{
		try{
			$form = $this->getMakeWaitingMobileForm();
			if($form->isValid($data)){
				$formData = $form->getValues();
			
				$bookTypeMapper = new Application_Model_ReservationTypeDataMapper();
				$bookType = $bookTypeMapper->GetBookingTypeByCode('NOR');

				$statusCode = array();
				if($data['waitbookingStatus'] && $data['waitrescheduleStatus']){
					$statusCode[] = $data['waitbookingStatus'];
					$statusCode[] = $data['waitrescheduleStatus'];
				}else{
					$statusCode[] = $data['waitbookingStatus'];
				}
				$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
				$bookStatus 	  = $bookStatusMapper->GetBookingStatusByCode($statusCode);
				$bookStatusObj 	  = $bookStatus[$data['waitbookingStatus']];
				$resStatusObj = null;
				if(isset($bookStatus[$data['waitrescheduleStatus']])){
					$resStatusObj = $bookStatus[$data['waitrescheduleStatus']];
				}

				$resModeMapper = new Application_Model_ReservationModeDataMapper();
				$rescode = $formData['waitorigin'];
				$resModeStatus 	  = $resModeMapper->GetReservationModeByCode(array($rescode));
				$resModeObj 	  = $resModeStatus[$rescode];

				$waitingquoteMapper = new Application_Model_WaitingQuoteTimeDataMapper();
				$quotecode = $formData['quotedTime'];
				$quoteStatus 	  = $waitingquoteMapper->GetQuoteTimeByCode(array($quotecode));
				$quoteObj 	  = $quoteStatus[$quotecode];

				$mapper = new Reservation_Model_ReservationDataMapper();
				$dinerDetails = new Reservation_Model_Reservation();

				$dinerDetails->setbokfk_restaurant($formData['restaurantid']);
					
				$dinerDetails->setbokparty_size($formData['waitpax']);
				$dinerDetails->setbokbooking_status_id($bookStatusObj->getId());
				$dinerDetails->setbokbooking_status_code($bookStatusObj->getCode());
				$dinerDetails->setbokbooking_status($bookStatusObj->getId());
				$dinerDetails->setbokfirst_name($formData['waitfirstName']);
				$dinerDetails->setboklast_name($formData['waitlastName']);
				$dinerDetails->setbokphone($formData['waitnumber']);
				$dinerDetails->setbokcountry_code($formData['countryCode']);
				if($formData['waitnumber']){
					$dinerDetails->setNotificationType('sms');
				}
				//$dinerDetails->setbokemail($formData['waitemail']);
				//$dinerDetails->setbokemail('');
				$dinerDetails->setbokrestaurant_note($formData['waitdinerRequest']);
				$dinerDetails->setQuotedTime($quoteObj->getId());

				$resServ = new Application_Service_Firm();
				$timeZone = $resServ->GetRestaurantTimeZone($formData['restaurantid']);
				date_default_timezone_set($timeZone);

				$dinerDetails->setbokbooking_made_on(date('Y-m-d H:i:s'));
				$dinerDetails->setBookingMadeTime(date("H:i",time()));
				$dinerDetails->setbokbooking_date($formData['waitresDate']);
				$dinerDetails->setbokbooking_timings(date('g:i A'));
				//$dinerDetails->setbokbooking_timings($formData['waitresTime']);
				$bookPhrase = uniqid ();
				$dinerDetails->setbokbookingphrase($bookPhrase);
			
				$dinerDetails->setbokuserid($userid);
				$dinerDetails->setbokspecial_request($formData['waitcontactInfo']);
				$dinerDetails->setbokbooking_type_id($bookType->getId());
				$dinerDetails->setbokreservation_mode_id($resModeObj->getId());
				$dinerDetails->setTableSize($formData['waittableSize']);
				$dinerDetails->setNoOfTables($formData['waitnoOfTables']);
				$dinerDetails->setInventoryId($formData['waitinventoryid']);
				//$dinerDetails->setNotificationType($formData['waitnotificationType']);
				
				$dinerDetails->setbokid($formData['bookingid']);


				if($formData['waitrescheduleStatus']){
					$dinerDetails->setRescheduleCode($formData['waitrescheduleStatus']);

				}
				if($resStatusObj){
					$dinerDetails->setRessch_Status_Id($resStatusObj->getId());
				}
				$result = $mapper->saveMakeReservationDetails($dinerDetails,'waiting',$formData);

				$dinerDetails->setbokid($result);
				$mailmapper = new Application_Service_Communication();
				$restService = new Application_Service_Firm();
				$restResult = $restService->GetRestaurantDetailsById($formData['restaurantid']);

				if($formData['waitnumber'] != ""){
					$name = $formData['waitfirstName'].' '.$formData['waitlastName'];
					$custMsg = '';
					$custMsg = 'Hi '.$name.', we have put your reservation in waiting, please wait for '.$quoteObj->getDescription().'. '.$restResult->resrestaurant_name;
					$smsObj = new Communication_Model_Sms();
					$smsObj->setMsgCode('WaitingReserv');
					
					$data = array(
									'to'			=> trim($formData['waitnumber']),
									'countrycode'	=> $formData['countryCode'],
									'RestName' 		=> $restResult->resrestaurant_name,
									'UserName'		=> $name,
									'BookId'		=> $result
					);
					if($quoteObj->getCode() =='NS'){
						$data['Quote'] = '';
					}else{
						$data['Quote'] = $quoteObj->getDescription();
					}
					$smsObj->setData($data);
					$mailStatus = $mailmapper->SendSms($smsObj);
				}
				$resultArr['status'] = "true";
				return $resultArr;
			}else{			
				$resultarray['status'] = "false";
				$form->populate($data);
				$resultarray['form'] = $form;
				return $resultarray;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getFeedbackFormByRestaurantId($request)
	{
		try{
			$restaurantid = $request->restaurantid;
			$mapper = new FirmManagement_Model_FeedbackQuestionsMapper();
	    	$result = $mapper->getFeedbackQuestionsAndAnswersByRestaurantId($restaurantid);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function sendFeedbackFormToCustomer($request)
	{
		try{
			$restaurantid = $request->restaurantid;
			$bookingid = $request->bookingid;
			$toemail = $request->email;
			$mapper = new FirmManagement_Model_FeedbackQuestionsMapper();
	    	$result = $mapper->getFeedbackQuestionsAndAnswersByRestaurantId($restaurantid);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getBookingFeedbackHistory($request)
	{
		try{
			$mapper = new Reservation_Model_ReservationDataMapper();
			$bookingDet = $mapper->getBokHistoryofCus($request);
			$bookingIdsArr = array();
			for($i=0; $i < count($bookingDet); $i++){
				$bookingIdsArr[] = $bookingDet[$i]['Id'];
			}
			$result = "";
			if(COUNT($bookingIdsArr) > 0){
				$mapper = new FirmManagement_Model_FeedbackQuestionsMapper();
	    		$result = $mapper->getFeedbackDeatilsByBookingId($bookingIdsArr);
			}
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getFeedbackHistoryofBookingId($request)
	{
		try{
			$result = "";
			$bookingId = $request->bookingid;
			$mapper = new FirmManagement_Model_FeedbackQuestionsMapper();
    		$result = $mapper->GetFeedbackHistoryofBookingId($bookingId);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getFeedbackReportHistoryofRestaurant($request,$userData)
	{
		try{
			$restaurantid = $request->restaurantid;
			$resServ = new Application_Service_Firm();
			$timeZone = $resServ->GetRestaurantTimeZone($restaurantid);
			date_default_timezone_set($timeZone);
			if($request->date == 'today'){
				$from = date('Y-m-d').' 00:00:00';
				$to = date('Y-m-d H:i:s');
			}else if($request->date == 'yesterday'){
				$from = date('Y-m-d H:i:s',strtotime(date('m/d/Y', strtotime("-1 days"))));
				$to = date('Y-m-d H:i:s');
			}else if($request->date == 'week'){
				$from = date('Y-m-d H:i:s',strtotime(date('m/d/Y', strtotime("-7 days"))));
				$to = date('Y-m-d H:i:s');
			}else if($request->date == 'month'){
				$from = date('Y-m-d H:i:s',strtotime(date('m/d/Y', strtotime("-30 days"))));
				$to = date('Y-m-d H:i:s');
			}else{
				$from = date('Y-m-d').' 00:00:00';
				$to = date('Y-m-d H:i:s');
			}
			$mapper = new FirmManagement_Model_FeedbackQuestionsMapper();
    		$result = $mapper->GetFeedbackReportHistoryofRestaurant($restaurantid,$from,$to);
    		return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getFeedbackReviewsHistoryofRestaurant($request,$userData)
	{
		try{
			$restaurantid = $request->restaurantid;
			$resServ = new Application_Service_Firm();
			$timeZone = $resServ->GetRestaurantTimeZone($restaurantid);
			date_default_timezone_set($timeZone);
			if($request->date == 'today'){
				$from = date('Y-m-d').' 00:00:00';
				$to = date('Y-m-d H:i:s');
			}else if($request->date == 'yesterday'){
				$from = date('Y-m-d H:i:s',strtotime(date('m/d/Y', strtotime("-1 days"))));
				$to = date('Y-m-d H:i:s');
			}else if($request->date == 'week'){
				$from = date('Y-m-d H:i:s',strtotime(date('m/d/Y', strtotime("-7 days"))));
				$to = date('Y-m-d H:i:s');
			}else if($request->date == 'month'){
				$from = date('Y-m-d H:i:s',strtotime(date('m/d/Y', strtotime("-30 days"))));
				$to = date('Y-m-d H:i:s');
			}else{
				$from = date('Y-m-d').' 00:00:00';
				$to = date('Y-m-d H:i:s');
			}
			$mapper = new FirmManagement_Model_FeedbackQuestionsMapper();
    		$result = $mapper->GetFeedbackReviewsHistoryofRestaurant($restaurantid,$from,$to);
    		return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function FeedbackReviewsCommunication($request,$userData)
	{
		try{
			if($request->replyBy == 'RES'){
				$reviewData['replyBy'] 		= $userData['Usertype'];
				$reviewData['replyById']	= $userData['User_Id'];
			}else{
				$reviewData['replyBy'] 		= 'CUS';
				$reviewData['replyById']	= '';
			}
			$reviewData['replyResId'] 	= $request->replyResId;
			$reviewData['replyCommId'] 	= $request->replyCommId;
			$reviewData['replyText']	= $request->replyText;
			$resServ = new Application_Service_Firm();
			$timeZone = $resServ->GetRestaurantTimeZone($request->replyResId);
			date_default_timezone_set($timeZone);
			
			$reviewData['replyCreated']	= date('Y-m-d H:i:s');
				
			$feedbackCommMapper = new FirmManagement_Model_FeedbackCommunicationMapper();
			$result = $feedbackCommMapper->saveFeedbackReviewReply($reviewData);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getFeedbackReviewsById($request,$userData)
	{
		try{
			$commentId = $request->commentId;
			$mapper = new FirmManagement_Model_FeedbackQuestionsMapper();
			$result = $mapper->GetFeedbackReviewsById($commentId);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getcurrentwaitlistcount($resid,$date)
	{
		try{
			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			$bookStatus = array('WAL','READY','QUOTE','BAR','NEXT','CANCUS','BACK');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
			$bookMapper = new Reservation_Model_ReservationDataMapper();
			$waitcount = $bookMapper->GetWaitingListCount($resid,$date,$bookStatusRes);
			return $waitcount; 
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getWixWidgetRestaurantid($request)
	{
		try{
			$compid = '';
			if($request->compId){
				$compid = $request->compId;
			}
			$mapper = new Reservation_Model_WixWidgetDataMapper();
			$result = $mapper->getRestaurntidByCompId($compid);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getWixWidgetUsingorigCompId($request)
	{
		try{
			$compid = '';
			if($request->origCompId){
				$compid = $request->origCompId;
			}
			$mapper = new Reservation_Model_WixWidgetDataMapper();
			$result = $mapper->getRestaurntidByCompId($compid);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function saveWixWidgetDetails($request)
	{
		try{
			$compid = '';
			$restaurantid = '';
			if($request->compid){
				$compid = $request->compid;
			}
			if($request->restaurantid){
				$restaurantid = $request->restaurantid;
			}
			$mapper = new Reservation_Model_WixWidgetDataMapper();
			$result = $mapper->saveWixWidgetDetails($restaurantid,$compid);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function deleteWixWidgetDetails($request)
	{
		try{
			$compid = '';
			if($request->compid){
				$compid = $request->compid;
			}			
			$mapper = new Reservation_Model_WixWidgetDataMapper();
			$result = $mapper->deleteWixWidgetDetails($compid);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getRestaurantInfoById($request)
	{
		try{
			$restaurantid = $request->restaurantid;
			$resMapper = new FirmManagement_Model_FirmDataMapper();
			$restDetails = $resMapper->getRestaurantDetailsById($restaurantid);
			if($restDetails){
				$result = array('RestName'  =>	$restDetails->resrestaurant_name,
						  	'ResEmail'		=>	$restDetails->resemail,
							'ResPhone'		=>	$restDetails->resphone,
							'ResAddress'	=>	$restDetails->resaddress,
							'ResLogo'		=>	$restDetails->reslogo
					);
			}else{
				$result = array();
			}
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getBookingDetailsBybookingidAndrestid($request)
	{
		try{
			$restaurantid = $request->restaurantid;
			$bookingid = $request->bookingid;
			$mapper = new Reservation_Model_ReservationDataMapper();
			$result = $mapper->getBookingDetailsBybookingidAndrestid($bookingid,$restaurantid);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getRestaurantWhatsNewPostsByResId($request)
	{
		try{
			$restaurantid = '';
			if($request->restaurantid){
				$restaurantid = $request->restaurantid;
			}
			$resMapper = new FirmManagement_Model_FirmDataMapper();
			$result = $resMapper->getRestNewPostsByRestId($restaurantid);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetReservationReportByResid($request)
	{
		try{
			$restaurantid = '';
			if($request->restaurantid){
				$restaurantid = $request->restaurantid;
			}
			if($request->page){
				$page = $request->page;
			}else{
				$page = 1;
			}
			$resMapper = new Reservation_Model_ReservationDataMapper();
			$result = $resMapper->GetReservationReportByResid($restaurantid,$page,$request);
			/* Reteriving restaurant logo Start */			
				$row = $resMapper->GetRestaurantLogo($restaurantid);
			/* Reteriving restaurant logo End */
			$this->CreateRestReportForAdmin($result['pdfResult'],$request,$row);
			return $result['result'];
			
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function CreateRestReportForAdmin($rowSet,$request,$row)
	{
		try{
			if(count($rowSet)>0 ){
				$restid = $request->restaurantid;
				$restname = $row->resrestaurant_name;
				$restlogo = $row->reslogo;
	
				require_once 'Zend/Loader/Autoloader.php';
				$loader = Zend_Loader_Autoloader::getInstance();
	
				$pdf = new My_Pdf_Document('reports/'.$restid.'.pdf', '.');
				$page = $pdf->createPage();
	
				$font = Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_HELVETICA);
	
				$page->setFont($font, 9);
				$page->setLineColor(new Zend_Pdf_Color_Rgb(0,100,0));
				$page->drawLine(-10, 15, ($page->getWidth()-0), 15);
	
				$imageurl = "";
				$service = new Application_Service_Firm();
			 	if(file_exists($restlogo)){
					$ext = $service->_findexts($restlogo);
					if($ext == 'jpg' || $ext == 'png'){
						$imageurl = "../public".$row->reslogo;
					}else{
						$imageurl = "../public/images/logo.png";
					}
			 	}else{
			 		$imageurl = "../public/images/logo.png";
			 	}
	
				$image = Zend_Pdf_Image::imageWithPath($imageurl);
	
				// write image to page
				$page->drawImage($image,-10,-30,80, 40);
	
				$page->drawText($restname, 200, 0);
	
				$reportcreationdate = date("d M Y");
				$page->drawText($reportcreationdate, 500, 0);
	
				$startdate = "";
				$endate    = "";
				
				if($request->reportStartDate && $request->reportEndDate){
	
					$startdate = $request->reportStartDate;
					$endate = $request->reportEndDate;
					$datetime = "Start Date : " .$startdate. "  End Date : ".$endate;
				}else if($request->reportStartDate){
					$startdate = $request->reportStartDate;
					$datetime = "Date : " .$startdate ;
				}else{
					$startdate = date("d M Y");
					$datetime = "Date : " .$startdate;
				}
				$page->drawText($datetime, -10, 35);
	
				$page->drawText("This report has been printed from dinedesk.com", -10, 50);
	
				$table = new My_Pdf_Table(10);
				/* Adding table header */
				$headrow  = new My_Pdf_Table_Row();
				$headcols = array();
					
				$Receipt  = new My_Pdf_Table_Column();
				$Receipt->setText("Receipt",'left','top');
				$Receipt->setWidth(50);
				$headcols[] = $Receipt;
					
				$FirstName  = new My_Pdf_Table_Column();
				$FirstName->setText("Patron Name",'left','top');
				$FirstName->setWidth(70);
				$headcols[] = $FirstName;
				
				$Contacts  = new My_Pdf_Table_Column();
				$Contacts->setText("Contact Details",'left','top');
				$Contacts->setWidth(100);
				$headcols[] = $Contacts;
				
				$Date  = new My_Pdf_Table_Column();
				$Date->setText("Date & Time",'left','top');
				$Date->setWidth(80);
				$headcols[] = $Date;
				
					
				$Seats  = new My_Pdf_Table_Column();
				$Seats->setText("Party Size",'left','top');
				$Seats->setWidth(30);
				$headcols[] = $Seats;
					
				$Origin = new My_Pdf_Table_Column();
				$Origin->setText("Origin",'left','top');
				$Origin->setWidth(40);
				$headcols[] = $Origin;
	
				$Status = new My_Pdf_Table_Column();
				$Status->setText("Status",'left','top');
				$Status->setWidth(80);
				$headcols[] = $Status;
					
				$headrow->setColumns($headcols);
				$headrow->setFont($font, 9);
				$headrow->setBorder(My_Pdf::TOP, new Zend_Pdf_Style());
				$headrow->setBorder(My_Pdf::BOTTOM, new Zend_Pdf_Style());
				$headrow->setBorder(My_Pdf::LEFT, new Zend_Pdf_Style());
				$headrow->setBorder(My_Pdf::RIGHT, new Zend_Pdf_Style());
				$headrow->setCellPaddings(array(4,4,4,4));
				$table->addRow($headrow);
					
				$previd = "";
				$bokid = "";
			
				foreach($rowSet as $rows){
					$bokid = $rows->bokid;
					$previd = $rows->bokid;
					
					$row = new My_Pdf_Table_Row();
					$cols = array();

					$col = new My_Pdf_Table_Column();
					$col->setText($rows->bokid,'left','top');
					$col->setWidth(30);
					$cols[] = $col;

					$col1 = new My_Pdf_Table_Column();
					$col1->setText($rows->bokfirst_name.$rows->boklast_name,'left','top');
					$col1->setWidth(70);
					$cols[] = $col1;
	
					 $col3 = new My_Pdf_Table_Column();
					 if($rows->bokemail && $rows->bokphone){
					 	$contact = $rows->bokemail." ".$rows->bokphone;
					 	$col3->setText($contact,'left','top');
					 }else if($rows->bokemail){
					 	$col3->setText($rows->bokemail,'left','top');
					 }else{
					 	$col3->setText($rows->bokphone,'left','top');
					 }
					 $col3->setWidth(100);
					 $cols[] = $col3;
					
					 $col2 = new My_Pdf_Table_Column();
					 $datetime = "";
					 $datetime = date("d M Y",strtotime($rows->bokbooking_date)).' '.date("h:i A",strtotime($rows->bokbooking_timings));
					 $col2->setText(trim($datetime),'left','top');
					 $col2->setWidth(80);
					 $cols[] = $col2;
	
					 $col4 = new My_Pdf_Table_Column();
					 $col4->setText($rows->bokparty_size,'left','top');
					 $col4->setWidth(30);
					 $cols[] = $col4;
	
					 
					 if($rows->resvmode == "INAT"){
					 	$col9 = new My_Pdf_Table_Column();
					 	if($rows->res_companyid == 6){
						 	$col9->setImage("../public/images/icons/rndmenu.png",'left','top');
					 	}else{
					 		$col9->setImage("../public/images/icons/inat.png",'left','top');
					 	}
					 	$col9->setWidth(40);
					 	$cols[] = $col9;
					 }else if($rows->resvmode == "WIN"){
					 	$col9 = new My_Pdf_Table_Column();
					 	$col9->setImage("../public/images/icons/Walk.png",'left','top');
					 	$col9->setWidth(40);
					 	$cols[] = $col9;
					 }else if($rows->resvmode == "FB"){
					 	$col9 = new My_Pdf_Table_Column();
					 	$col9->setImage("../public/images/icons/fb.png",'left','top');
					 	$col9->setWidth(40);
					 	$cols[] = $col9;
					 }else if($rows->resvmode == "PHN"){
					 	$col9 = new My_Pdf_Table_Column();
					 	$col9->setImage("../public/images/icons/Mobile.png",'left','top');
					 	$col9->setWidth(40);
					 	$cols[] = $col9;
					 }
	
	
					 $col7 = new My_Pdf_Table_Column();
					 $col7->setText($rows->bokstatusdesc,'left','top');
					 $col7->setWidth(80);
					 $cols[] = $col7;
	
					 $row->setColumns($cols);
					 $row->setFont($font, 9);
					 $row->setBorder(My_Pdf::TOP, new Zend_Pdf_Style());
					 $row->setBorder(My_Pdf::BOTTOM, new Zend_Pdf_Style());
					 $row->setBorder(My_Pdf::LEFT, new Zend_Pdf_Style());
				     $row->setBorder(My_Pdf::RIGHT, new Zend_Pdf_Style());
					 $row->setCellPaddings(array(4,4,4,4));
					 $table->addRow($row);				
				}
				$page->addTable($table, -10, 40);
				$pdf->addPage($page);
				$pdf->save();
			}

		}catch (Zend_Pdf_Exception $e) {
			die ('PDF error: ' . $e->getMessage());
		}catch (Exception $e) {
			die ('Application error: ' . $e->getMessage());
		}

	}
	
	public function getDatesBetweenDateRangeForCus($request)
	{
		try{

			$result = array();
			$todaysDate = null;
		//	date_default_timezone_set($timeZone);
			if(isset($request->fromdate)){
				$todaysDate = $request->fromdate;
			}else{
				if($request->datesfrom){
					$date = date('Y-m-d');
					$dateSplit = explode('-',$date);
					$fromyear  = $dateSplit[0];
					$frommonth = $dateSplit[1]-6;
					$todaysDate = date('Y-m-d',mktime(0,0,0,$frommonth,1,$fromyear));
				}else{
					$todaysDate = date('Y-m-d');
				}
			}

			$splitDate = explode('-',$todaysDate);
			$year   = $splitDate[0];
			$month  = $splitDate[1]+8;

			$toDate = date('Y-m-d',mktime(0,0,0,$month,0,$year));

			$todayDateTS = strtotime($todaysDate);
			$toDateTS	 = strtotime($toDate);
			$dateArray = array();

			for($currentDateTS = $todayDateTS; $currentDateTS <= $toDateTS; $currentDateTS+= (60 * 60 * 24)){

				$date = "";
				$date = date("Y-m-d",$currentDateTS);
				$dateSplit = explode('-',$date);
				$weekday = "";
				$weekday = date("D", mktime(0,0,0,$dateSplit[1],$dateSplit[2],$dateSplit[0]));
				$dateform = date("d M Y", mktime(0,0,0,$dateSplit[1],$dateSplit[2],$dateSplit[0]));
				$dateArray[date("Y-m-d",$currentDateTS)] = $dateform .' - '.$weekday;
			}
			return $dateArray;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetFeedbackPhoneNumbersOfRestaurant($request)
	{
		try{
			$restService = new Application_Service_Firm();
			$result = $restService->getFeedbackPhoneNumbersOfRestaurant($request);
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
/**
	 * @param array,userid,offset
	 * retreives the customer reservation history for mobileversion
	 */
	public function GetCustBookingHistoryForMobile($request,$userid,$phone,$email,$offset)
	{
		try{
			$custBookHist = new Reservation_Model_CustBookHist();
			$custBookHist->setUserId($userid);
			$custBookHist->setPhone($phone);
			$custBookHist->setEmail($email);
			$custBookHist->setSorting($request->tab);
			$mapper = new Reservation_Model_ReservationDataMapper();
			$resultSet = $mapper->getCustBookingHistoryForMobile($custBookHist,$offset);
			return $resultSet;

		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function updateFeebackNotificationStatus($request)
	{
		try{
			if($request){
				$resid = $request->restid;
				$status = "";
				if($request->notfstatus == 'Y'){
					$status = true;
				}else if($request->notfstatus == 'N'){
					$status = 0;
				}
				$type = $request->from;
				$mapper = new FirmManagement_Model_FirmDataMapper();
				$status = $mapper->ManageRestFeedbackNotifyStatus($resid, $status, $type);
				return $status;
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetFeedbackEmailStatus($request)
	{
		try{
			$restaurantid = $request->restaurantid;
			$mapper = new FirmManagement_Model_FirmDataMapper();
			$result = $mapper->GetFeedbackEmailStatusById($restaurantid);
			return $result;			
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function GetAvailabilityOfRestaurant($request)
	{
		try{
			$restaurantid = $request->restaurantid;
			$firmService = new Application_Service_Firm();
			$MealTypeDataMapper = new FirmManagement_Model_FirmMealTypeDataMapper();
			$result['mealdata'] = $MealTypeDataMapper->GetMealSettingsByRestId($restaurantid);
			$schRes = $firmService->managescheduleSetting($request);
			if($schRes == 'SPL'){
				$result['schsettingcode'] = $schRes;
			}else{
				$result['schsettingcode'] = $schRes->code;
			}
			if($result['schsettingcode'] == 'SMC'){
				$result['SMC'] = $firmService->getOpenSlotsForMaxCountSetting($request);
			}else if($result['schsettingcode'] != 'UL'){
				$result['SL'] = $firmService->getNoofTablesandPaxByTimes($request);
			}			
			return $result;
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function ValidateBookingTableAvailability($bookingId)
	{
		try{
			$mapper = new Reservation_Model_ReservationDataMapper();
			$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
			$bookStatus = array('PTS','ALC','DES','BOK','CRD','COM','WRD');
			$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
			$statusId = array();
			foreach($bookStatusRes as $key=>$value){
				$statusId[] = $value->getId();
			}
			$result = $mapper->ValidateBookingTableAvailability($bookingId,$statusId);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}	
	/* Dinedesk Desktop Functions */
	
	public function SynchronizationOfReservationsByRestaurantid($restaurantid)
	{
		try{
			$fianalArr = '';
			$resServ = new Application_Service_Firm();
			$timeZone = $resServ->GetRestaurantTimeZone($restaurantid);
			date_default_timezone_set($timeZone);			
			$date	= date('Y-m-d');
			
			$optionsmapper = new Reservation_Model_ReservationOptionsDataMapper();
			$bokoptionsArr = $optionsmapper->GetBookingOptionsByRestaurantId($restaurantid);
			
			$bokmapper = new Reservation_Model_ReservationDataMapper($restaurantid);
			$bokresult = $bokmapper->SynchronizationOfReservationsByRestaurantid($restaurantid,$date);
			$bookingTableDate = $bokresult['bookingsArr'];
			$bokingIds = $bokresult['bokidsArr'];
			
			$bookingcountTabledata = $bokmapper->GetbookingCountTableData($restaurantid,$date);
			
			$bookasigntabledata = array();
			$bokwaitingquotemapTableData = array();
			$bokoptionsmapTabledata = array();
			$bokAccumulativeInventorydata = array();
			if($bokingIds){
				$bookasigntabledata = $bokmapper->GetBookingtableDataByBookingIds($bokingIds);
			
				$quoteMapDataMapper  = new Reservation_Model_ReservationWaitingQuoteMapDataMapper();
				$bokwaitingquotemapTableData = $quoteMapDataMapper->GetWaitingQuoteByBookingIds($bokingIds);
				
				$bokoptionmapmaper = new Reservation_Model_ReservationOptionsMapDataMapper();
				$bokoptionsmapTabledata = $bokoptionmapmaper->GetBookingOptionsByBookingIds($bokingIds);
				
				$bokAccumulativeInventory = new Reservation_Model_ReservationAccumulativeInventoryMapper();
				$bokAccumulativeInventorydata = $bokAccumulativeInventory->GetBookingAccumulativeInventorysByBookingIds($bokingIds);
			}		
			
			$fianalArr = array(
						'bookingoptionTabledata'		=> $bokoptionsArr,
						'bookinTabledata'				=> $bookingTableDate,
						'bookingcountTabledata'			=> $bookingcountTabledata,
						'bookingasignTabledata'			=> $bookasigntabledata,
						'bookingoptinsmapTabledata'		=> $bokoptionsmapTabledata,	
						'bokwaitingquotemapTableData'	=> $bokwaitingquotemapTableData,
						'bokAccumulativeInventorydata'	=> $bokAccumulativeInventorydata
					);
			
			return $fianalArr;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function getReservationLogByBokid($request)
	{
		try{
			$bokid = $request->bookingid;
			$mapper = new Reservation_Model_BookingLogMapper();
			$result = $mapper->getBookingLog($bokid);
			return $result;
		}catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	
	public function MigrateIosBookings($request)
	{
		try{
			$data = json_decode($request);
			$bookDetails = $data->{'waiting'};
			if($bookDetails)
			{				
				$existingData = $this->checkForExistingBookings($request);
				if(count($existingData)>0)
				{
					$resultArry = array();
					$resBookDetails = array();
					$resultArry['result'] = array();
					foreach ($bookDetails as $key => $row) {
						$ekey = $this->complex_array_search($row,$existingData);
						if($ekey>=0)
						{

							$checkedData = $existingData[$ekey];
							$bookidArr = array("boklokid" => $row->boklokid, "bookid" => $checkedData['bokid'], "bokbooking_phrase" => $checkedData['bokbooking_phrase'],"bok_contactid"=>$checkedData['bok_contactid']);
							$row->bokId = null;
							$resultArry ['result']['status'] =true;
							$resultArry ['result']['web_bookid'] =array($bookidArr);
							$resBookDetails[] = $row;
						} 
						else
						{
							$mapper = new Reservation_Model_ReservationDataMapper();
						   $result = $mapper->MigrateIosBookings($row);
					       foreach ($result['result'] as $rkey => $rvalue) {
					       	$resultArr['result'][] = $rvalue;
					       }
					       foreach ($result['bookDetails'] as $rkey => $rvalue) {
					       	$resBookDetails[] = $rvalue;
					       }
						}
					}
					$resultArry['bookDetails'] = $resBookDetails;
					return $resultArry;
				}
				else
				{
					$mapper = new Reservation_Model_ReservationDataMapper();
					$result = $mapper->MigrateIosBookings($bookDetails);
					return $result;
				}
			}
			else
			{
				return 'false';
			}
		}catch(Exception $ex){
				Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * send ios emails
	 */
	public function sendIosEmails($result)
	{
		try
		{
			
			foreach($result['bookDetails'] as $row){
					if($row->bokid == 0 && $row->bokId != null && $row->bokId != '' ){
						$resDataMapper = new FirmManagement_Model_FirmDataMapper();
						$restObj= new FirmManagement_Model_FirmById();
						$restObj->setRestaurantId($row->bokfk_restaurant);
						$resDetails = $resDataMapper->getRestaurantById($restObj);
						$splresult = '';

						$stateCity = $this->getRestaurantStateByResId($row->bokfk_restaurant);
						$stateId = $stateCity['state'];
						$cityId = $stateCity['city'];
						$regionId = $stateCity['region'];
									
						$userType = 'CUS';
						$adminService = new Application_Service_Administrator();
						$campProp = new Application_Model_GetCampaignForPost();
						$campProp->setAudType($userType)
						->setStateId($stateId)
						->setCityId($cityId)
						->setRegionId($regionId)
						->setIsAjaxCall(false);		
						$campDetails = array();
						if(!$resDetails->getrescampaignstatus() === false){
							$campDetails = $adminService->GetCampaignDetails($campProp);
						}
								
						$mailObj = new Communication_Model_Mail();
						$mailmapper = new Application_Service_Communication();
						$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
						$bookStatusArr = $bookStatusMapper->GetBookingStatusById(array($row->bokbooking_status_id));
						$bookStatus = $bookStatusArr[$row->bokbooking_status_id];
						if($row->bokemail != ''){
							if($stateId == ""){
								$stateCity = $this->getRestaurantStateByResId($row->bokfk_restaurant);
								$stateId = $stateCity['state'];
								$cityId = $stateCity['city'];
								$regionId = $stateCity['region'];
							}
							if($bookStatus->getCode() == 'RES'){
								$mailObj->setMsgCode('ReSchedule');
								$name = $row->bokfirst_name.' '.$row->boklast_name;
	
								$data = array(
											  'UserName' 			=> 	$name,
											  'SenTo'    			=> 	$row->bokemail,
								              'phone'				=>	$row->bokphone,
											  'RestName' 			=> 	$resDetails->getRestaurantname(),
											  'ResDate'  			=> 	$row->bokbooking_date,
											  'Time'     			=> 	$row->bokbooking_timings,
											  'Size'     			=>	$row->bokparty_size,
											  'Address'	 			=> 	$resDetails->getRestaddress(),
											  'resphone' 			=> 	$resDetails->getRestphone(),
											  'resemail'			=>	$resDetails->getRestemail(),
											  'rescity'				=>	$resDetails->getRestCityDesc(),
											  'resnbh'				=>	$resDetails->getRestNeighborDesc(),
											  'reszipcode'			=>	$resDetails->getRestzipcode(),	
											  'Status'	 			=> 	$bookStatus->getCode(),
											  'Bokid'	 			=>	$row->bokId,
											  'State_Id'			=>	$stateId,
											  'City_Id'				=>	$cityId,
											  'UserType'			=>	$userType,
											  'BookNotf' 			=>  false,
								
								);
								$data['splstatus']	= false;
								if(count($campDetails)){
									$count = count($campDetails);
									if($count > 1){
										$campaign = $campDetails[rand(0,$count-1)];
									}else{
										$campaign = $campDetails[0];
									}
									$notfService = new Application_Service_Communication();
									$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
									$data['campaignName'] = trim($campaign->getSponsor());
									$data['campaignDesc'] =	trim($campaign->getCampDesc());
									$data['campaignImg'] =	trim($campaign->getCampImage());
									$data['campId']	= $campaign->getId();
								}
								$mailObj->setData($data);
								$mailStatus = $mailmapper->SendMail($mailObj);
							}else if($bookStatus->getCode() == 'CAN'){
								$mailObj->setMsgCode('Cancel');
								$name = $row->bokfirst_name.' '.$row->boklast_name;
	
								$data = array('UserName' => $name,
											  'SenTo'    => $row->bokemail,
											  'phone' 	 => $row->bokphone,
											  'RestName' => $resDetails->getRestaurantname(),
											  'ResDate'  => $row->bokbooking_date,
											  'Time'     => $row->bokbooking_timings,
											  'Size'     => $row->bokparty_size,
											  'Address'	 => $resDetails->getRestaddress(),
											  'Status'	 => $bookStatus->getCode(),
											  'State_Id' =>	$stateId,
											  'City_Id'	 =>	$cityId,
											  'resphone' => $resDetails->getRestphone(),
											  'UserType' =>	$userType,
											  'BookId'	 => $row->bokId
								);
								if(count($campDetails)){
									$count = count($campDetails);
									if($count > 1){
										$campaign = $campDetails[rand(0,$count-1)];
									}else{
										$campaign = $campDetails[0];
									}
									$notfService = new Application_Service_Communication();
									$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
									$data['campaignName'] = trim($campaign->getSponsor());
									$data['campaignDesc'] =	trim($campaign->getCampDesc());
									$data['campaignImg'] =	trim($campaign->getCampImage());
									$data['campId']	= $campaign->getId();
								}
									
								$mailObj->setData($data);
								$mailStatus = $mailmapper->SendMail($mailObj);
							}else if($bookStatus->getCode() == 'WAL'){
								$mailObj->setMsgCode('WalBookConf');
								$name = $row->bokfirst_name.' '.$row->boklast_name;
								$data = array('UserName' 			=> 	$name,
											  'Bokid'				=>	$row->bokId,
											  'SenTo'    			=>	$row->bokemail,
											  'RestName' 			=> 	$resDetails->getRestaurantname(),
											  'ResDate'  			=> 	$row->bokbooking_date,
											  'Time'     			=> 	$row->bokbooking_timings,
											  'Size'     			=> 	$row->bokparty_size,
											  'Address'	 			=> 	$resDetails->getRestaddress(),
											  'resphone' 			=> 	$resDetails->getRestphone(),
											  'resemail'			=>	$resDetails->getRestemail(),
											  'rescity'				=>	$resDetails->getRestCityDesc(),
											  'resnbh'				=>	$resDetails->getRestNeighborDesc(),
											  'reszipcode'			=>	$resDetails->getRestzipcode(),	
											  'Status'	 			=> 	$bookStatus->getCode(),
											  'State_Id'			=>	$stateId,
											  'City_Id'				=>	$cityId,
											  'UserType'			=>	$userType
								);
								if(count($campDetails)){
									$count = count($campDetails);
									if($count > 1){
										$campaign = $campDetails[rand(0,$count-1)];
									}else{
										$campaign = $campDetails[0];
									}
									$notfService = new Application_Service_Communication();
									$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
									$data['campaignName'] = trim($campaign->getSponsor());
									$data['campaignDesc'] =	trim($campaign->getCampDesc());
									$data['campaignImg'] =	trim($campaign->getCampImage());
									$data['campId']	= $campaign->getId();
								}
								$mailObj->setData($data);
								$mailStatus = $mailmapper->SendMail($mailObj);
							}else if($bookStatus->getCode() == 'NOS'){
	//							$mailObj->setMsgCode('No-Show');
	//							$name = $row['bokfirst_name'].' '.$row['boklast_name'];
	//							$data = array('UserName' 			=> 	$name,
	//										  'Bokid'				=>	$row['bokId'],
	//										  'SenTo'    			=> 	$row['bokemail'],
	//										  'RestName' 			=> 	$resDetails->getRestaurantname(),
	//										  'ResDate'  			=> 	$row['bokbooking_date'],
	//										  'Time'     			=> 	$row['bokbooking_timings'],
	//									  	  'Size'     			=> 	$row['bokparty_size'],
	//										  'Address'	 			=> 	$resDetails->getRestaddress(),
	//										  'Status'	 			=> 	$bookStatus->getCode(),
	//										  'State_Id' 			=>	$stateId,
	//										  'City_Id'	 			=>	$cityId,
	//										  'UserType' 			=>	$userType,
	//										  'ResManager'			=>	$resDetails->getRestmanagername(),
	//										  'ResEmail'			=>	$resDetails->getRestemail()
	//							);
	//							if(count($campDetails)){
	//								$count = count($campDetails);
	//								if($count > 1){
	//									$campaign = $campDetails[rand(0,$count-1)];
	//								}else{
	//									$campaign = $campDetails[0];
	//								}
	//								$notfService = new Application_Service_Communication();
	//								$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
	//								$data['campaignName'] = trim($campaign->getSponsor());
	//								$data['campaignDesc'] =	trim($campaign->getCampDesc());
	//								$data['campaignImg'] =	trim($campaign->getCampImage());
	//								$data['campId']	= $campaign->getId();
	//							}
	//							if($request->noshowmailsend == 'yes'){
	//								$mailObj->setData($data);
	//								$mailStatus = $mailmapper->SendMail($mailObj);
	//							}
							}else{
								$mailObj->setMsgCode('BookConf');
								$name = $row->bokfirst_name.' '.$row->boklast_name;
	
								$data = array(
											  'UserName' 			=> 	$name,
											  'SenTo'    			=> 	$row->bokemail,
											  'phone'				=>	$row->bokphone,
											  'RestName' 			=> 	$resDetails->getRestaurantname(),
											  'ResDate'  			=> 	$row->bokbooking_date,
											  'Time'     			=> 	$row->bokbooking_timings,
											  'Size'     			=>	$row->bokparty_size,
											  'Address'	 			=> 	$resDetails->getRestaddress(),
											  'resphone' 			=> 	$resDetails->getRestphone(),
											  'resemail'			=>	$resDetails->getRestemail(),
											  'rescity'				=>	$resDetails->getRestCityDesc(),
											  'resnbh'				=>	$resDetails->getRestNeighborDesc(),
											  'reszipcode'			=>	$resDetails->getRestzipcode(),	
											  'Status'	 			=> 	$bookStatus->getCode(),
											  'Bokid'	 			=>	$row->bokId,
											  'State_Id'			=>	$stateId,
											  'City_Id'				=>	$cityId,
											  'UserType'			=>	$userType,
											  'BookNotf' 			=> false,
								);
								$data['splstatus']	= false;
								if(count($campDetails)){
									$count = count($campDetails);
									if($count > 1){
										$campaign = $campDetails[rand(0,$count-1)];
									}else{
										$campaign = $campDetails[0];
									}
									$notfService = new Application_Service_Communication();
									$countUpdate = $notfService->UpdateCampaignEmailCount($campaign->getId(),1);
									$data['campaignName'] = trim($campaign->getSponsor());
									$data['campaignDesc'] =	trim($campaign->getCampDesc());
									$data['campaignImg'] =	trim($campaign->getCampImage());
									$data['campId']	= $campaign->getId();
								}
								$mailObj->setData($data);
								$mailStatus = $mailmapper->SendMail($mailObj);
							}
						}else{
							if($row->bookstatuscode == "WAL" && $row->bokphone != "" && $row->bokphone != null)
							{
								
								$waitingquoteMapper = new Application_Model_WaitingQuoteTimeDataMapper();
								$quoteStatus 	  	= $waitingquoteMapper->getQuoteTimeById($row->bokquoted_time);
								$quoteObj 	  		= $quoteStatus;
								
								$name = $row->bokfirst_name.' '.$row->boklast_name;
								
								$custMsg = '';
								$custMsg = 'Hi '.$name.', we have put your reservation in waiting, please wait for '.$quoteObj->getDescription().'. '.$restResult->resrestaurant_name;
								$smsObj = new Communication_Model_Sms();
								$smsObj->setMsgCode('WaitingReserv');
								$data = array(
												'to'			=>	trim($row->bokphone),
												'countrycode' 	=> $row->bokcountry_code,
												'RestName' 		=> $resDetails->getRestaurantname(),
												'UserName'		=> $name,
												'Quote'			=> $quoteObj->getDescription(),
												'BookId'		=> $row->bokId
								);
								$smsObj->setData($data);
								$mailStatus = $mailmapper->SendSms($smsObj);
							}else if(($row->bookstatuscode == "RSD" || $row->bookstatuscode == "OVB") && $row->bokphone != "" && $row->bokphone != null){
								$name = $row->bokfirst_name.' '.$row->boklast_name;
								$bookTime = date("h:i A",strtotime($row->bokbooking_timings));
								
								$smsObj = new Communication_Model_Sms();
								$smsObj->setMsgCode('BookConf');
								$data = array(
								 'to'			=> trim($row->bokphone),
								 'countrycode'	=> $row->bokcountry_code,
								 'bokid'		=> $row->bokId,	
								 'RestName' 	=> $resDetails->getRestaurantname(),
								 'ResDate'  	=> $row->bokbooking_date,
								 'Time'     	=> $bookTime,
								 'Size'     	=> $row->bokparty_size,
								 'CustomerName' => $name
								);
								
								$smsObj->setData($data);
								$mailStatus = $mailmapper->SendSms($smsObj);
							}
						}
					}
				}
		}

		catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

	/**
	 * CHECK IF BOOKING ALREADY EXISTS
	 */
	public function checkForExistingBookings($request)
	{
		try
		{

		$res = json_decode($request);
		 $bookDetails = $res->{'waiting'};
		 $reservationMapper = new Reservation_Model_ReservationDataMapper();
		 $queryResult = $reservationMapper->checkIfReserationExits($bookDetails);
		 return $queryResult;

		}
		catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
        public function getReservationNotifiByRestId($restid, $lastbokid)
        {
            try
		{		
		 $reservationMapper = new Reservation_Model_ReservationDataMapper();
		 $queryResult = $reservationMapper->getReservationNotifiByRestId($restid, $lastbokid);
		 return $queryResult;
		}
		catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}          
        }
/**
 * ARRAY SEARCH FUNCTION
 */
	public function complex_array_search($needle,$haystack)
	{
		try 
		{
			$resultKeys = array();
			$bool = true;
			$resultkey = -1;
				foreach ($haystack as $key => $hay) {
					$needleKeys = array_keys($needle);
					foreach ($needleKeys as $nkey) {
						if(array_key_exists($nkey,$haystack))
						{
							if($needle[$nkey]!==$hay[$nkey])
							{
								$bool = false;
							}
						}
					}
					if($bool==true)
					{
						$resultKey  = $key;
					}
					else
					{
						$resultKey = -1;
					}
				}
			return $resultKey;
		} 
		catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}	
	}

	public function getAllReservationReport($request)
	{
		try
		{
			$resvReportObj = new Reservation_Model_GetReservationReport();
			$results = array();
			if($request){
				$bookMapper = new Reservation_Model_ReservationDataMapper();
				if($request->reserveid){
					$resvReportObj->setReservationId($request->reserveid);
				}
				if($request->reportsorton){
					$resvReportObj->setReportSortOn($request->reportsorton);
				}
				if($request->reportsortorder){
					$resvReportObj->setReportSortOrder($request->reportsortorder);
				}
        
				if($request->bokdatetype){
					$resvReportObj->setBokDateType($request->bokdatetype);
				}

				if($request->bokstartdate && $request->bokenddate){
					$resvReportObj->setBookStartDate($request->bokstartdate);
					$resvReportObj->setBookEndDate($request->bokenddate);
				}else if($request->bokstartdate){
					$resvReportObj->setBookStartDate($request->bokstartdate);
				}
				
				if($request->bokstarttime && $request->bokendtime){
					$resvReportObj->setBookStartTime($request->bokstarttime);
					$resvReportObj->setBookEndTime($request->bokendtime);
				}else if($request->bokstarttime){
					$resvReportObj->setBookStartTime($request->bokstarttime);
				}
				
				if($request->restaurantid){
					$resvReportObj->setRestaurantId($request->restaurantid);
				}
        
				if($request->bookstatus){
					$bookingstatus = $request->bookstatus;
					$bokstsarr = array();
					foreach($bookingstatus as $types){
						$bokstsarr[] = $types;
					}
					if($bokstsarr){
						$resvReportObj->setBookStatus($bokstsarr);
					}
				}
				if($request->origin){
					$origin = $request->origin;
					$originsarr = array();
					foreach($origin as $types){
						$originsarr[] = $types;
					}
					if($originsarr){
						$resvReportObj->setOrigin($originsarr);
					}
				}
				
				if($request->downloadStatus!= ""){
					echo "Yes";
				}
        
				$bookStatus = array('ALC','DES','BOK','PTS','CRD','RSD','COM','NOS');
				$bookStatusMapper = new Application_Model_ReservationStatusDataMapper();
				$bookStatusRes = $bookStatusMapper->GetBookingStatusByCode($bookStatus);
        
				$rowSet = $bookMapper->ReservationReport($resvReportObj,null,$bookStatusRes);
        //echo '<pre>'; print_r($request); exit;
				$results['RowSet'] = $rowSet['data'];
				$results['Count']  = $rowSet['count'];
				//if($request->generateReport)
        if($request->report) // line added by pratik
				{
						//$row = $bookMapper->GetRestaurantLogo($request->restaurantid);
            $row = $bookMapper->GetRestaurantLogo($request->report);
            //echo '<pre>'; print_r($row); exit;
						if($row){
							$results['RestLogo'] = $row->reslogo;
							$results['RestName'] = $row->resrestaurant_name;
						}
						
					$this->CreateReport($rowSet['data'],$request,$row);
				}
				return $results;
		}
	}

	catch(Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}	
}

/**GET MEALS BY RESID
**/
public function getMealsByResid($resid)
	{
		try{
			if(isset($resid))
			{
				$meal = new FirmManagement_Model_FirmMealType();
				$meal->setResId($resid);
				$mapper = new FirmManagement_Model_FirmMealTypeDataMapper();
				$mealsData = $mapper->GetRestaurantMealTypes($meal,'settings');
				$times = array();
				$times[] = array('key'=>'','value'=>'Select Time');
				foreach ($mealsData as $key => $meal) {
					if($meal['status']==true)
					{
						$time = strtotime($meal['starttime']);
						$round = 15*60;
						$rounded = round($time / $round) * $round;
						$start = $rounded;
						$time = strtotime($meal['endtime']);
						$rounded = round($time / $round) * $round;
						$end =  $rounded;
						for($i = $start; $i <= $end; $i += 900) 
						{
							$times[] = array('key'=>date('h:i A', $i),'value'=>date('h:i A', $i));
						} 
					}
				}		
				$response = array('status'=>true,'times'=>$times);
				return $response;
			}
			else
			{
				return array('status'=>false);
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}

/**GET MEALS BY RESID FOR API
**/
public function getMealsByResidAPI($resid)
	{
		try{
			if(isset($resid))
			{
				$meal = new FirmManagement_Model_FirmMealType();
				$meal->setResId($resid);
				$mapper = new FirmManagement_Model_FirmMealTypeDataMapper();
				$mealsData = $mapper->GetRestaurantMealTypes($meal,'settings');
				$times = array();
				foreach ($mealsData as $key => $meal) {
					if($meal['status']==true)
					{
						$start = strtotime($meal['starttime']);
						$end = strtotime($meal['endtime']);
						for($i = $start; $i <= $end; $i += 900) 
						{
							$times[] =date('h:i A', $i);
						} 
					}
				}		
				return $times;
			}
			else
			{
				return array();
			}
		}catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
	/**
 	* GET THE CURRENT DINING PERIOD BY RESID
 	@PARAMs resid,currentTime
 	*/
 	public function getCurrentDiningTimes($resid,$currentTime)
 	{
 		try 
 		{
 			$meal = new FirmManagement_Model_FirmMealType();
			$meal->setResId($resid);
			$mapper = new FirmManagement_Model_FirmMealTypeDataMapper();
			$mealsData = $mapper->GetRestaurantMealTypes($meal,'settings');
			$currentTime = date("d-m-Y")." ".$currentTime;
			$currentTime = strtotime($currentTime);
			$response = array();
			if(count($mealsData)>0)
			{
				foreach ($mealsData as $key => $meal) 
				{
					if($meal['status']==1)
					{	
						$sttime = strtotime(date("d-m-Y")." ".$meal['starttime']);
						$endtime =  strtotime(date("d-m-Y")." ".$meal['endtime']);
						if(($currentTime>=$sttime)&&($currentTime<=$endtime))
						{
							$response['start_time'] = $meal['starttime'];
							$response['end_time'] = $meal['endtime'];
						}
					}
				}
			}
 			return $response;
 		} 
 		catch (Exception $e) {
 			Uss_Logger_FileLogger::info($e->getMessage());
			throw new Exception($ex->getMessage()) ;
 			
 		}
 	}

 	/**
 	*Get the times limit by meal period name and resid;
 	**/
 	public function getMealPeriodTimes($resid,$mealPeriod)
 	{
 		try 
 		{
 			$meal = new FirmManagement_Model_FirmMealType();
			$meal->setResId($resid);
			$mapper = new FirmManagement_Model_FirmMealTypeDataMapper();
			$mealsData = $mapper->GetRestaurantMealTypes($meal,'settings');
			$response = array();
			if(count($mealsData)>0)
			{
				foreach ($mealsData as $key => $meal) 
				{
					if($meal['status']==1)
					{	
		
						if(strtolower($mealPeriod)==strtolower($meal['desc']))
						{
							$response['start_time'] = $meal['starttime'];
							$response['end_time'] = $meal['endtime'];
						}
					}
				}
			}
 			return $response;
 		} 
 		catch (Exception $e) {
 			Uss_Logger_FileLogger::info($e->getMessage());
			throw new Exception($ex->getMessage()) ;
 			
 		}
 	}

 	/**
 	* GET THE ALL DINING PERIODS BY RESID 
 	@PARAMs resid,currentTime
 	*RETURNS ARRAY OF PERIODS N CURRENT PEROD
 	**/
 	public function getDiningPeriodsByResid($resid,$currentTime)
 	{
 		try 
 		{
 			$meal = new FirmManagement_Model_FirmMealType();
			$meal->setResId($resid);
			$mapper = new FirmManagement_Model_FirmMealTypeDataMapper();
			$mealsData = $mapper->GetRestaurantMealTypes($meal,'settings');
			$currentTime = date("d-m-Y")." ".$currentTime;
			$currentTime = strtotime($currentTime);
			$response = array();
			$response['current_period'] = 'all';
			$response['periods'] = array();
			if(count($mealsData)>0)
			{
				foreach ($mealsData as $key => $meal) 
				{
					if($meal['status']==1)
					{	
//						$sttime = strtotime(date("d-m-Y")." ".$meal['starttime']);
//						$endtime =  strtotime(date("d-m-Y")." ".$meal['endtime']);
//						if(($currentTime>=$sttime)&&($currentTime<=$endtime))
//						{
//							$response['current_period']= $meal['desc'];
//						}

						$response['periods'][] = $meal['desc'];
					}
				}
			}
 			return $response;
 		} 
 		catch (Exception $e) {
 			Uss_Logger_FileLogger::info($e->getMessage());
			throw new Exception($ex->getMessage()) ;
 			
 		}
 	}
	/**
	Send Reminder SMS
	**/
	public function sendReminderSMS($bokid,$userid=null)
	{
		try
		{
			$result = $this->GetBookingDetails($bokid);
			$resname =  $result->getresrestaurant_name();
			$userphone = $result->getbokphone();
			if(strlen($userphone)==0)
			{
				return array('status'=>false,'error'=>'No Phone Number available');
			}
			$username = $result->getbokfirst_name().' '.$result->getboklast_name();
			$size = $result->getbokparty_size();
			$date = $result->getbokbooking_date();
			$time = $result->getbokbooking_timings();
			$status = $result->getbokbooking_status_id();
			$countrycode = $result->getbokcountry_code();
			$smsobj = new Communication_Model_Sms();
			$data = array();
			$data['RestName'] = $resname;
			$data['ResDate'] = $date;
			$data['Time'] = $time;
			$data['Size'] = $size;
			$data['CustomerName'] = $username;
			$data['to'] = $userphone;
			$data['countrycode'] = $countrycode;
			$data['bokid'] = $bokid;
			$smsobj->setData($data);
			$smsobj->setMsgCode('BookConf');
			$commServ = new Application_Service_Communication();
			$smsFlag = $commServ->sendReminderSMS($smsobj);
			if($smsFlag==true)
			{
					$reservationDataMapper = new Reservation_Model_ReservationDataMapper();
					$bokStat = $reservationDataMapper->getBookingPrevStatus($bokid);
					$bokLog = new Reservation_Model_BookingLog();
					$bokLog->setbok_log_fk_booking($bokid)
					->setbok_log_booked_type($bokStat)
					->setbok_log_bok_status($status)
					->setbok_log_book_message('Reminder Message Sent')
					->setbok_log_updated_by($userid)
					->setbok_log_updated_at(date('Y-m-d H:i:s'));
					$bokLog->setbok_log_update_done_by('RES');
					$bokLogMapper = new Reservation_Model_BookingLogMapper();
					$bokLogResult = $bokLogMapper->updateBookingLog($bokLog);
					return array('status'=>true,'error'=>'');
			}
			else
			{
				return array('status'=>false,'error'=>'Message Could not be sent');
			}
			
		}
		catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}

	}

	/**
	 * GET RESTAURANT MEAL TYPES API
	 */
	public function getRestaurantMealTypesByResidApi($resid)
	{try
		{
			$meal = new FirmManagement_Model_FirmMealType();
			$meal->setResId($resid);
			$mapper = new FirmManagement_Model_FirmMealTypeDataMapper();
			$mealsData = $mapper->GetRestaurantMealTypes($meal,'settings');
			$response = array();
			if(count($mealsData)>0)
			{
				foreach ($mealsData as $key => $meal) 
				{
					if(is_array($meal))
					{
						$tmp = array();
						$tmp['rmt_id'] = $meal['id'];
						$tmp['rmt_restaurant'] = $resid;
  						$tmp['rmt_meal_type'] = $meal['desc'];
  						$tmp['rmt_start_time'] = $meal['starttime'];
  						$tmp['rmt_end_time'] = $meal['endtime'];
  						$tmp['rmt_status'] = $meal['status'];
						$response[] = $tmp;
					}
				}
			}
 			return $response;
		}
		catch (Exception $ex){
			Uss_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}}
	/**
	 * GET RESTAURANT GALLERY BY RESTAURANT ID
	 */
	public function getGalleryByRestaurantId($resid)
	{
		try
		{
			$dir = $_SERVER['DOCUMENT_ROOT']."/images/restaurant_images/".$resid."/restaurant_Image/";
		      	$abspath = "/images/restaurant_images/".$resid."/restaurant_Image/";
		      	$arrData = array();
		     		if(file_exists($dir))
		     		{
		     			$images = scandir($dir);
		     			if(sizeof($images)>2)
		     			{
		     				$i=0;
		     				foreach ($images as $image) 
		     				{	
		     					if($i>=2)
		     					{
		     					  $nameArr = explode('.', $image);
		     					  if(count($nameArr)>0)
		     					  {
		     					  	$index = count($nameArr)-1;
		     					  	$ext = $nameArr[$index];
		     					  	if(($ext=='jpg')||($ext=='png')||($ext=='jpeg'))
		     					  	{
		     					  		  $arrData[] = $abspath.$image;
		     					  	}
		     					  } 
		     					}
		     					$i=$i+1;
		     				}
		     			}
		     		}
		     	 return $arrData;
		}
		catch(Exception $ex){
			Rdine_Logger_FileLogger::info($ex->getMessage());
			throw new Exception($ex->getMessage()) ;
		}
	}
}
